/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AMDGPU target                          *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 127;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(6),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s64,
  GILLT_p1s64,
  GILLT_p2s32,
  GILLT_p3s32,
  GILLT_p4s64,
  GILLT_p5s32,
  GILLT_p6s32,
  GILLT_s1,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v3s32,
  GILLT_v3s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v5s32,
  GILLT_v6s32,
  GILLT_v7s32,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v9s32,
  GILLT_v10s32,
  GILLT_v11s32,
  GILLT_v12s32,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v16s64,
  GILLT_v32s16,
  GILLT_v32s32,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 64),
  LLT::pointer(1, 64),
  LLT::pointer(2, 32),
  LLT::pointer(3, 32),
  LLT::pointer(4, 64),
  LLT::pointer(5, 32),
  LLT::pointer(6, 32),
  LLT::scalar(1),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(3), 32),
  LLT::vector(ElementCount::getFixed(3), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(5), 32),
  LLT::vector(ElementCount::getFixed(6), 32),
  LLT::vector(ElementCount::getFixed(7), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(9), 32),
  LLT::vector(ElementCount::getFixed(10), 32),
  LLT::vector(ElementCount::getFixed(11), 32),
  LLT::vector(ElementCount::getFixed(12), 32),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(16), 64),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(32), 32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_FalsePredicateBit = 112,
  Feature_isGFX6Bit = 50,
  Feature_isGFX6GFX7Bit = 8,
  Feature_isGFX6GFX7GFX10Bit = 110,
  Feature_isGFX7OnlyBit = 84,
  Feature_isGFX7GFX8GFX9Bit = 45,
  Feature_isGFX6GFX7GFX8GFX9Bit = 66,
  Feature_isGFX6GFX7GFX8GFX9GFX10Bit = 123,
  Feature_isNotGFX12PlusBit = 19,
  Feature_isGFX8GFX9GFX10GFX11Bit = 21,
  Feature_isGFX7PlusBit = 13,
  Feature_isGFX8PlusBit = 4,
  Feature_isGFX8OnlyBit = 22,
  Feature_isGFX9PlusBit = 0,
  Feature_isNotGFX9PlusBit = 56,
  Feature_isGFX90APlusBit = 38,
  Feature_isNotGFX90APlusBit = 23,
  Feature_isGFX908orGFX90ABit = 39,
  Feature_isGFX940PlusBit = 40,
  Feature_isNotGFX940PlusBit = 51,
  Feature_HasGFX950InstsBit = 28,
  Feature_isGFX8GFX9Bit = 15,
  Feature_isGFX10OnlyBit = 62,
  Feature_isGFX10PlusBit = 5,
  Feature_isGFX9GFX10Bit = 57,
  Feature_isGFX11OnlyBit = 63,
  Feature_isGFX11PlusBit = 1,
  Feature_isGFX12OnlyBit = 64,
  Feature_isGFX12PlusBit = 3,
  Feature_HasMinimum3Maximum3F32Bit = 20,
  Feature_HasMinimum3Maximum3F16Bit = 25,
  Feature_HasMinimum3Maximum3PKF16Bit = 32,
  Feature_HasFlatAddressSpaceBit = 86,
  Feature_HasFlatBufferGlobalAtomicFaddF64InstBit = 102,
  Feature_HasAtomicFMinFMaxF32GlobalInstsBit = 96,
  Feature_HasAtomicFMinFMaxF64GlobalInstsBit = 101,
  Feature_HasAtomicFMinFMaxF32FlatInstsBit = 92,
  Feature_HasAtomicFMinFMaxF64FlatInstsBit = 93,
  Feature_HasLdsAtomicAddF64Bit = 126,
  Feature_HasFlatGlobalInstsBit = 87,
  Feature_HasFlatScratchInstsBit = 90,
  Feature_HasD16LoadStoreBit = 95,
  Feature_HasFlatScratchSVSModeBit = 91,
  Feature_HasGFX10_BEncodingBit = 49,
  Feature_HasUnpackedD16VMemBit = 106,
  Feature_HasPackedD16VMemBit = 107,
  Feature_HasUnrestrictedSOffsetBit = 105,
  Feature_D16PreservesUnusedBitsBit = 88,
  Feature_LDSRequiresM0InitBit = 119,
  Feature_NotLDSRequiresM0InitBit = 120,
  Feature_HasExportInstsBit = 7,
  Feature_HasLDSFPAtomicAddF32Bit = 125,
  Feature_HasAddNoCarryInstsBit = 65,
  Feature_NotHasAddNoCarryInstsBit = 117,
  Feature_HasXNACKEnabledBit = 83,
  Feature_Has16BitInstsBit = 9,
  Feature_NotHasTrue16BitInstsBit = 10,
  Feature_UseRealTrue16InstsBit = 11,
  Feature_UseFakeTrue16InstsBit = 12,
  Feature_HasVOP3PInstsBit = 77,
  Feature_HasMed3_16Bit = 118,
  Feature_HasMinMaxDenormModesBit = 111,
  Feature_NotHasMinMaxDenormModesBit = 113,
  Feature_HasSDWABit = 61,
  Feature_HasPackedFP32OpsBit = 43,
  Feature_HasImageInstsBit = 6,
  Feature_HasIntClampBit = 71,
  Feature_HasMadMixInstsBit = 78,
  Feature_HasScalarStoresBit = 46,
  Feature_has16BankLDSBit = 52,
  Feature_has32BankLDSBit = 24,
  Feature_HasFmaMixInstsBit = 80,
  Feature_HasDLInstsBit = 16,
  Feature_HasFmacF64InstBit = 116,
  Feature_HasDot1InstsBit = 36,
  Feature_HasDot2InstsBit = 33,
  Feature_HasDot3InstsBit = 70,
  Feature_HasDot4InstsBit = 69,
  Feature_HasDot5InstsBit = 67,
  Feature_HasDot6InstsBit = 68,
  Feature_HasDot7InstsBit = 35,
  Feature_HasDot8InstsBit = 81,
  Feature_HasDot9InstsBit = 29,
  Feature_HasDot10InstsBit = 34,
  Feature_HasDot11InstsBit = 82,
  Feature_HasGetWaveIdInstBit = 48,
  Feature_HasMAIInstsBit = 37,
  Feature_HasSMemRealTimeBit = 47,
  Feature_HasSMemTimeInstBit = 44,
  Feature_HasShaderCyclesRegisterBit = 85,
  Feature_HasShaderCyclesHiLoRegistersBit = 55,
  Feature_HasFP8InstsBit = 42,
  Feature_HasFP8ConversionInstsBit = 59,
  Feature_HasMadMacF32InstsBit = 17,
  Feature_HasFmaLegacy32Bit = 18,
  Feature_HasAtomicDsPkAdd16InstsBit = 124,
  Feature_HasAtomicFlatPkAdd16InstsBit = 104,
  Feature_HasAtomicFaddRtnInstsBit = 99,
  Feature_HasAtomicFaddNoRtnInstsBit = 97,
  Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit = 98,
  Feature_HasAtomicBufferGlobalPkAddF16InstsBit = 100,
  Feature_HasFlatAtomicFaddF32InstBit = 103,
  Feature_EnableFlatScratchBit = 89,
  Feature_DisableFlatScratchBit = 108,
  Feature_HasUnalignedAccessModeBit = 121,
  Feature_HasMADIntraFwdBugBit = 73,
  Feature_HasNotMADIntraFwdBugBit = 72,
  Feature_HasSALUFloatInstsBit = 2,
  Feature_NotHasSALUFloatInstsBit = 109,
  Feature_HasPseudoScalarTransBit = 30,
  Feature_HasBitOp3InstsBit = 75,
  Feature_HasPrngInstBit = 14,
  Feature_HasFP6BF6ConversionScaleInstsBit = 26,
  Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit = 27,
  Feature_HasCvtPkF16F32InstBit = 74,
  Feature_HasF32ToF16BF16ConversionSRInstsBit = 76,
  Feature_HasGDSBit = 122,
  Feature_HasCvtFP8VOP1BugBit = 58,
  Feature_HasNoCvtFP8VOP1BugBit = 60,
  Feature_HasAtomicCSubNoRtnInstsBit = 94,
  Feature_HasXF32InstsBit = 41,
  Feature_HasAshrPkInstsBit = 31,
  Feature_FP16DenormalsBit = 115,
  Feature_FP64DenormalsBit = 114,
  Feature_NoFP32DenormalsBit = 79,
  Feature_isWave32Bit = 53,
  Feature_isWave64Bit = 54,
};

PredicateBitset AMDGPUInstructionSelector::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (false)
    Features.set(Feature_FalsePredicateBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS)
    Features.set(Feature_isGFX6Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX6GFX7Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7OnlyBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX6GFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX8GFX9GFX10Bit);
  if (Subtarget->getGeneration() <= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isNotGFX12PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX8GFX9GFX10GFX11Bit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7PlusBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8PlusBit);
  if (Subtarget->getGeneration() ==AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX9PlusBit);
  if (Subtarget->getGeneration() < AMDGPUSubtarget::GFX9)
    Features.set(Feature_isNotGFX9PlusBit);
  if (Subtarget->hasGFX90AInsts())
    Features.set(Feature_isGFX90APlusBit);
  if (!Subtarget->hasGFX90AInsts())
    Features.set(Feature_isNotGFX90APlusBit);
  if (Subtarget->hasMAIInsts() && !Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX908orGFX90ABit);
  if (Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX940PlusBit);
  if (!Subtarget->hasGFX940Insts())
    Features.set(Feature_isNotGFX940PlusBit);
  if (Subtarget->hasGFX950Insts())
    Features.set(Feature_HasGFX950InstsBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX9GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12PlusBit);
  if (Subtarget->hasMinimum3Maximum3F32())
    Features.set(Feature_HasMinimum3Maximum3F32Bit);
  if (Subtarget->hasMinimum3Maximum3F16())
    Features.set(Feature_HasMinimum3Maximum3F16Bit);
  if (Subtarget->hasMinimum3Maximum3PKF16())
    Features.set(Feature_HasMinimum3Maximum3PKF16Bit);
  if (Subtarget->hasFlatAddressSpace())
    Features.set(Feature_HasFlatAddressSpaceBit);
  if (Subtarget->hasFlatBufferGlobalAtomicFaddF64Inst())
    Features.set(Feature_HasFlatBufferGlobalAtomicFaddF64InstBit);
  if (Subtarget->hasAtomicFMinFMaxF32GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF32FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32FlatInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64FlatInstsBit);
  if (Subtarget->hasLdsAtomicAddF64())
    Features.set(Feature_HasLdsAtomicAddF64Bit);
  if (Subtarget->hasFlatGlobalInsts())
    Features.set(Feature_HasFlatGlobalInstsBit);
  if (Subtarget->hasFlatScratchInsts())
    Features.set(Feature_HasFlatScratchInstsBit);
  if (Subtarget->hasD16LoadStore())
    Features.set(Feature_HasD16LoadStoreBit);
  if (Subtarget->hasFlatScratchSVSMode())
    Features.set(Feature_HasFlatScratchSVSModeBit);
  if (Subtarget->hasGFX10_BEncoding())
    Features.set(Feature_HasGFX10_BEncodingBit);
  if (Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasUnpackedD16VMemBit);
  if (!Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasPackedD16VMemBit);
  if (!Subtarget->hasRestrictedSOffset())
    Features.set(Feature_HasUnrestrictedSOffsetBit);
  if (Subtarget->d16PreservesUnusedBits())
    Features.set(Feature_D16PreservesUnusedBitsBit);
  if (Subtarget->ldsRequiresM0Init())
    Features.set(Feature_LDSRequiresM0InitBit);
  if (!Subtarget->ldsRequiresM0Init())
    Features.set(Feature_NotLDSRequiresM0InitBit);
  if (Subtarget->hasExportInsts())
    Features.set(Feature_HasExportInstsBit);
  if (Subtarget->hasLDSFPAtomicAddF32())
    Features.set(Feature_HasLDSFPAtomicAddF32Bit);
  if (Subtarget->hasAddNoCarry())
    Features.set(Feature_HasAddNoCarryInstsBit);
  if (!Subtarget->hasAddNoCarry())
    Features.set(Feature_NotHasAddNoCarryInstsBit);
  if (Subtarget->isXNACKEnabled())
    Features.set(Feature_HasXNACKEnabledBit);
  if (Subtarget->has16BitInsts())
    Features.set(Feature_Has16BitInstsBit);
  if (!Subtarget->hasTrue16BitInsts())
    Features.set(Feature_NotHasTrue16BitInstsBit);
  if (Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseRealTrue16InstsBit);
  if (Subtarget->hasTrue16BitInsts() && !Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseFakeTrue16InstsBit);
  if (Subtarget->hasVOP3PInsts())
    Features.set(Feature_HasVOP3PInstsBit);
  if (Subtarget->hasMed3_16())
    Features.set(Feature_HasMed3_16Bit);
  if (Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_HasMinMaxDenormModesBit);
  if (!Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_NotHasMinMaxDenormModesBit);
  if (Subtarget->hasSDWA())
    Features.set(Feature_HasSDWABit);
  if (Subtarget->hasPackedFP32Ops())
    Features.set(Feature_HasPackedFP32OpsBit);
  if (Subtarget->hasImageInsts())
    Features.set(Feature_HasImageInstsBit);
  if (Subtarget->hasIntClamp())
    Features.set(Feature_HasIntClampBit);
  if (Subtarget->hasMadMixInsts())
    Features.set(Feature_HasMadMixInstsBit);
  if (Subtarget->hasScalarStores())
    Features.set(Feature_HasScalarStoresBit);
  if (Subtarget->getLDSBankCount() == 16)
    Features.set(Feature_has16BankLDSBit);
  if (Subtarget->getLDSBankCount() == 32)
    Features.set(Feature_has32BankLDSBit);
  if (Subtarget->hasFmaMixInsts())
    Features.set(Feature_HasFmaMixInstsBit);
  if (Subtarget->hasDLInsts())
    Features.set(Feature_HasDLInstsBit);
  if (Subtarget->hasFmacF64Inst())
    Features.set(Feature_HasFmacF64InstBit);
  if (Subtarget->hasDot1Insts())
    Features.set(Feature_HasDot1InstsBit);
  if (Subtarget->hasDot2Insts())
    Features.set(Feature_HasDot2InstsBit);
  if (Subtarget->hasDot3Insts())
    Features.set(Feature_HasDot3InstsBit);
  if (Subtarget->hasDot4Insts())
    Features.set(Feature_HasDot4InstsBit);
  if (Subtarget->hasDot5Insts())
    Features.set(Feature_HasDot5InstsBit);
  if (Subtarget->hasDot6Insts())
    Features.set(Feature_HasDot6InstsBit);
  if (Subtarget->hasDot7Insts())
    Features.set(Feature_HasDot7InstsBit);
  if (Subtarget->hasDot8Insts())
    Features.set(Feature_HasDot8InstsBit);
  if (Subtarget->hasDot9Insts())
    Features.set(Feature_HasDot9InstsBit);
  if (Subtarget->hasDot10Insts())
    Features.set(Feature_HasDot10InstsBit);
  if (Subtarget->hasDot11Insts())
    Features.set(Feature_HasDot11InstsBit);
  if (Subtarget->hasGetWaveIdInst())
    Features.set(Feature_HasGetWaveIdInstBit);
  if (Subtarget->hasMAIInsts())
    Features.set(Feature_HasMAIInstsBit);
  if (Subtarget->hasSMemRealTime())
    Features.set(Feature_HasSMemRealTimeBit);
  if (Subtarget->hasSMemTimeInst())
    Features.set(Feature_HasSMemTimeInstBit);
  if (Subtarget->hasShaderCyclesRegister())
    Features.set(Feature_HasShaderCyclesRegisterBit);
  if (Subtarget->hasShaderCyclesHiLoRegisters())
    Features.set(Feature_HasShaderCyclesHiLoRegistersBit);
  if (Subtarget->hasFP8Insts())
    Features.set(Feature_HasFP8InstsBit);
  if (Subtarget->hasFP8ConversionInsts())
    Features.set(Feature_HasFP8ConversionInstsBit);
  if (Subtarget->hasMadMacF32Insts())
    Features.set(Feature_HasMadMacF32InstsBit);
  if (Subtarget->hasGFX10_3Insts())
    Features.set(Feature_HasFmaLegacy32Bit);
  if (Subtarget->hasAtomicDsPkAdd16Insts())
    Features.set(Feature_HasAtomicDsPkAdd16InstsBit);
  if (Subtarget->hasAtomicFlatPkAdd16Insts())
    Features.set(Feature_HasAtomicFlatPkAdd16InstsBit);
  if (Subtarget->hasAtomicFaddRtnInsts())
    Features.set(Feature_HasAtomicFaddRtnInstsBit);
  if (Subtarget->hasAtomicFaddNoRtnInsts())
    Features.set(Feature_HasAtomicFaddNoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16NoRtnInsts() || Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16InstsBit);
  if (Subtarget->hasFlatAtomicFaddF32Inst())
    Features.set(Feature_HasFlatAtomicFaddF32InstBit);
  if (Subtarget->enableFlatScratch())
    Features.set(Feature_EnableFlatScratchBit);
  if (!Subtarget->enableFlatScratch())
    Features.set(Feature_DisableFlatScratchBit);
  if (Subtarget->hasUnalignedAccessMode())
    Features.set(Feature_HasUnalignedAccessModeBit);
  if (Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasMADIntraFwdBugBit);
  if (!Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasNotMADIntraFwdBugBit);
  if (Subtarget->hasSALUFloatInsts())
    Features.set(Feature_HasSALUFloatInstsBit);
  if (!Subtarget->hasSALUFloatInsts())
    Features.set(Feature_NotHasSALUFloatInstsBit);
  if (Subtarget->hasPseudoScalarTrans())
    Features.set(Feature_HasPseudoScalarTransBit);
  if (Subtarget->hasBitOp3Insts())
    Features.set(Feature_HasBitOp3InstsBit);
  if (Subtarget->hasPrngInst())
    Features.set(Feature_HasPrngInstBit);
  if (Subtarget->hasFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasF16BF16ToFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasCvtPkF16F32Inst())
    Features.set(Feature_HasCvtPkF16F32InstBit);
  if (Subtarget->hasF32ToF16BF16ConversionSRInsts())
    Features.set(Feature_HasF32ToF16BF16ConversionSRInstsBit);
  if (Subtarget->hasGDS())
    Features.set(Feature_HasGDSBit);
  if (Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasCvtFP8VOP1BugBit);
  if (!Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasNoCvtFP8VOP1BugBit);
  if (Subtarget->hasAtomicCSubNoRtnInsts())
    Features.set(Feature_HasAtomicCSubNoRtnInstsBit);
  if (Subtarget->hasXF32Insts())
    Features.set(Feature_HasXF32InstsBit);
  if (Subtarget->hasAshrPkInsts())
    Features.set(Feature_HasAshrPkInstsBit);
  if (Subtarget->isWave32())
    Features.set(Feature_isWave32Bit);
  if (Subtarget->isWave64())
    Features.set(Feature_isWave64Bit);
  return Features;
}

void AMDGPUInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUInstructionSelector::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP16DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP64DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP32Denormals == DenormalMode::getPreserveSign())
    Features.set(Feature_NoFP32DenormalsBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_DisableFlatScratch,
  GIFBS_Has16BitInsts,
  GIFBS_HasAddNoCarryInsts,
  GIFBS_HasAshrPkInsts,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts,
  GIFBS_HasAtomicCSubNoRtnInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts,
  GIFBS_HasAtomicFaddNoRtnInsts,
  GIFBS_HasAtomicFaddRtnInsts,
  GIFBS_HasAtomicFlatPkAdd16Insts,
  GIFBS_HasBitOp3Insts,
  GIFBS_HasCvtPkF16F32Inst,
  GIFBS_HasD16LoadStore,
  GIFBS_HasDLInsts,
  GIFBS_HasDot10Insts,
  GIFBS_HasDot1Insts,
  GIFBS_HasDot2Insts,
  GIFBS_HasDot3Insts,
  GIFBS_HasDot4Insts,
  GIFBS_HasDot5Insts,
  GIFBS_HasDot6Insts,
  GIFBS_HasDot7Insts,
  GIFBS_HasDot8Insts,
  GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts,
  GIFBS_HasF32ToF16BF16ConversionSRInsts,
  GIFBS_HasFP6BF6ConversionScaleInsts,
  GIFBS_HasFP8Insts,
  GIFBS_HasFlatAddressSpace,
  GIFBS_HasFlatAtomicFaddF32Inst,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst,
  GIFBS_HasFlatGlobalInsts,
  GIFBS_HasFmaLegacy32,
  GIFBS_HasFmaMixInsts,
  GIFBS_HasFmacF64Inst,
  GIFBS_HasGDS,
  GIFBS_HasGFX10_BEncoding,
  GIFBS_HasGFX950Insts,
  GIFBS_HasGetWaveIdInst,
  GIFBS_HasIntClamp,
  GIFBS_HasLdsAtomicAddF64,
  GIFBS_HasMAIInsts,
  GIFBS_HasMadMacF32Insts,
  GIFBS_HasMinMaxDenormModes,
  GIFBS_HasMinimum3Maximum3F32,
  GIFBS_HasMinimum3Maximum3PKF16,
  GIFBS_HasPackedD16VMem,
  GIFBS_HasPackedFP32Ops,
  GIFBS_HasPrngInst,
  GIFBS_HasPseudoScalarTrans,
  GIFBS_HasSALUFloatInsts,
  GIFBS_HasSMemRealTime,
  GIFBS_HasSMemTimeInst,
  GIFBS_HasShaderCyclesHiLoRegisters,
  GIFBS_HasShaderCyclesRegister,
  GIFBS_HasUnpackedD16VMem,
  GIFBS_HasUnrestrictedSOffset,
  GIFBS_HasVOP3PInsts,
  GIFBS_HasXF32Insts,
  GIFBS_HasXNACKEnabled,
  GIFBS_LDSRequiresM0Init,
  GIFBS_NotHasAddNoCarryInsts,
  GIFBS_NotHasTrue16BitInsts,
  GIFBS_NotLDSRequiresM0Init,
  GIFBS_UseFakeTrue16Insts,
  GIFBS_UseRealTrue16Insts,
  GIFBS_isGFX10Only,
  GIFBS_isGFX10Plus,
  GIFBS_isGFX11Only,
  GIFBS_isGFX11Plus,
  GIFBS_isGFX12Only,
  GIFBS_isGFX12Plus,
  GIFBS_isGFX6,
  GIFBS_isGFX6GFX7,
  GIFBS_isGFX6GFX7GFX8GFX9,
  GIFBS_isGFX7GFX8GFX9,
  GIFBS_isGFX7Only,
  GIFBS_isGFX7Plus,
  GIFBS_isGFX8GFX9,
  GIFBS_isGFX8GFX9GFX10GFX11,
  GIFBS_isGFX8Plus,
  GIFBS_isGFX908orGFX90A,
  GIFBS_isGFX90APlus,
  GIFBS_isGFX940Plus,
  GIFBS_isGFX9GFX10,
  GIFBS_isGFX9Plus,
  GIFBS_isNotGFX12Plus,
  GIFBS_isNotGFX90APlus,
  GIFBS_isNotGFX940Plus,
  GIFBS_isNotGFX9Plus,
  GIFBS_isWave32,
  GIFBS_isWave64,
  GIFBS_DisableFlatScratch_HasD16LoadStore,
  GIFBS_DisableFlatScratch_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts,
  GIFBS_FP16Denormals_NotHasMinMaxDenormModes,
  GIFBS_FalsePredicate_NotHasMinMaxDenormModes,
  GIFBS_Has16BitInsts_HasIntClamp,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_UseFakeTrue16Insts,
  GIFBS_Has16BitInsts_UseRealTrue16Insts,
  GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8Only,
  GIFBS_Has16BitInsts_isNotGFX90APlus,
  GIFBS_HasAddNoCarryInsts_HasIntClamp,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus,
  GIFBS_HasAtomicDsPkAdd16Insts_HasGDS,
  GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init,
  GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts,
  GIFBS_HasDot11Insts_isGFX12Plus,
  GIFBS_HasDot9Insts_NotHasTrue16BitInsts,
  GIFBS_HasDot9Insts_UseFakeTrue16Insts,
  GIFBS_HasDot9Insts_UseRealTrue16Insts,
  GIFBS_HasExportInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_HasSDWA,
  GIFBS_HasFP8ConversionInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_isGFX940Plus,
  GIFBS_HasFP8Insts_isGFX90APlus,
  GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts,
  GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts,
  GIFBS_HasFlatAddressSpace_isGFX12Plus,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset,
  GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts,
  GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts,
  GIFBS_HasFlatGlobalInsts_isGFX12Plus,
  GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts,
  GIFBS_HasFmaMixInsts_UseFakeTrue16Insts,
  GIFBS_HasFmaMixInsts_UseRealTrue16Insts,
  GIFBS_HasGDS_HasLDSFPAtomicAddF32,
  GIFBS_HasGDS_isGFX11Plus,
  GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_HasGFX950Insts_isGFX90APlus,
  GIFBS_HasImageInsts_isGFX12Plus,
  GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init,
  GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init,
  GIFBS_HasMADIntraFwdBug_isGFX11Only,
  GIFBS_HasMAIInsts_isGFX90APlus,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals,
  GIFBS_HasMadMixInsts_NoFP32Denormals,
  GIFBS_HasMed3_16_NotHasTrue16BitInsts,
  GIFBS_HasMed3_16_UseFakeTrue16Insts,
  GIFBS_HasMed3_16_UseRealTrue16Insts,
  GIFBS_HasMinMaxDenormModes_isGFX12Plus,
  GIFBS_HasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_HasNotMADIntraFwdBug_isGFX9Plus,
  GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset,
  GIFBS_HasScalarStores_isGFX8Plus,
  GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init,
  GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init,
  GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts,
  GIFBS_HasVOP3PInsts_UseFakeTrue16Insts,
  GIFBS_HasVOP3PInsts_UseRealTrue16Insts,
  GIFBS_HasXF32Insts_isGFX90APlus,
  GIFBS_HasXNACKEnabled_isGFX7Only,
  GIFBS_HasXNACKEnabled_isGFX9Plus,
  GIFBS_HasXNACKEnabled_isNotGFX9Plus,
  GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_LDSRequiresM0Init_isGFX7Plus,
  GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init,
  GIFBS_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX12Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX8Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX9Plus,
  GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts,
  GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts,
  GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_NotLDSRequiresM0Init_isGFX7Plus,
  GIFBS_UseFakeTrue16Insts_isGFX10Plus,
  GIFBS_UseFakeTrue16Insts_isGFX12Plus,
  GIFBS_UseFakeTrue16Insts_isGFX8Plus,
  GIFBS_UseFakeTrue16Insts_isGFX9Plus,
  GIFBS_UseRealTrue16Insts_isGFX10Plus,
  GIFBS_UseRealTrue16Insts_isGFX12Plus,
  GIFBS_UseRealTrue16Insts_isGFX8Plus,
  GIFBS_UseRealTrue16Insts_isGFX9Plus,
  GIFBS_has16BankLDS_isNotGFX90APlus,
  GIFBS_has32BankLDS_isNotGFX90APlus,
  GIFBS_isGFX11Only_isWave32,
  GIFBS_isGFX11Only_isWave64,
  GIFBS_isGFX12Plus_isWave32,
  GIFBS_isGFX12Plus_isWave64,
  GIFBS_isGFX90APlus_isGFX908orGFX90A,
  GIFBS_isGFX90APlus_isGFX940Plus,
  GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts,
  GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts,
  GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseFakeTrue16Insts,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseRealTrue16Insts,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus,
  GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA,
  GIFBS_HasFP8ConversionInsts_NotHasTrue16BitInsts_isGFX9Plus,
  GIFBS_HasFP8ConversionInsts_UseFakeTrue16Insts_isGFX9Plus,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10,
  GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts,
  GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts,
  GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseFakeTrue16Insts,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseRealTrue16Insts,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_DisableFlatScratchBit, },
  {Feature_Has16BitInstsBit, },
  {Feature_HasAddNoCarryInstsBit, },
  {Feature_HasAshrPkInstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, },
  {Feature_HasAtomicFaddRtnInstsBit, },
  {Feature_HasAtomicFlatPkAdd16InstsBit, },
  {Feature_HasBitOp3InstsBit, },
  {Feature_HasCvtPkF16F32InstBit, },
  {Feature_HasD16LoadStoreBit, },
  {Feature_HasDLInstsBit, },
  {Feature_HasDot10InstsBit, },
  {Feature_HasDot1InstsBit, },
  {Feature_HasDot2InstsBit, },
  {Feature_HasDot3InstsBit, },
  {Feature_HasDot4InstsBit, },
  {Feature_HasDot5InstsBit, },
  {Feature_HasDot6InstsBit, },
  {Feature_HasDot7InstsBit, },
  {Feature_HasDot8InstsBit, },
  {Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit, },
  {Feature_HasF32ToF16BF16ConversionSRInstsBit, },
  {Feature_HasFP6BF6ConversionScaleInstsBit, },
  {Feature_HasFP8InstsBit, },
  {Feature_HasFlatAddressSpaceBit, },
  {Feature_HasFlatAtomicFaddF32InstBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, },
  {Feature_HasFlatGlobalInstsBit, },
  {Feature_HasFmaLegacy32Bit, },
  {Feature_HasFmaMixInstsBit, },
  {Feature_HasFmacF64InstBit, },
  {Feature_HasGDSBit, },
  {Feature_HasGFX10_BEncodingBit, },
  {Feature_HasGFX950InstsBit, },
  {Feature_HasGetWaveIdInstBit, },
  {Feature_HasIntClampBit, },
  {Feature_HasLdsAtomicAddF64Bit, },
  {Feature_HasMAIInstsBit, },
  {Feature_HasMadMacF32InstsBit, },
  {Feature_HasMinMaxDenormModesBit, },
  {Feature_HasMinimum3Maximum3F32Bit, },
  {Feature_HasMinimum3Maximum3PKF16Bit, },
  {Feature_HasPackedD16VMemBit, },
  {Feature_HasPackedFP32OpsBit, },
  {Feature_HasPrngInstBit, },
  {Feature_HasPseudoScalarTransBit, },
  {Feature_HasSALUFloatInstsBit, },
  {Feature_HasSMemRealTimeBit, },
  {Feature_HasSMemTimeInstBit, },
  {Feature_HasShaderCyclesHiLoRegistersBit, },
  {Feature_HasShaderCyclesRegisterBit, },
  {Feature_HasUnpackedD16VMemBit, },
  {Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasVOP3PInstsBit, },
  {Feature_HasXF32InstsBit, },
  {Feature_HasXNACKEnabledBit, },
  {Feature_LDSRequiresM0InitBit, },
  {Feature_NotHasAddNoCarryInstsBit, },
  {Feature_NotHasTrue16BitInstsBit, },
  {Feature_NotLDSRequiresM0InitBit, },
  {Feature_UseFakeTrue16InstsBit, },
  {Feature_UseRealTrue16InstsBit, },
  {Feature_isGFX10OnlyBit, },
  {Feature_isGFX10PlusBit, },
  {Feature_isGFX11OnlyBit, },
  {Feature_isGFX11PlusBit, },
  {Feature_isGFX12OnlyBit, },
  {Feature_isGFX12PlusBit, },
  {Feature_isGFX6Bit, },
  {Feature_isGFX6GFX7Bit, },
  {Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_isGFX7GFX8GFX9Bit, },
  {Feature_isGFX7OnlyBit, },
  {Feature_isGFX7PlusBit, },
  {Feature_isGFX8GFX9Bit, },
  {Feature_isGFX8GFX9GFX10GFX11Bit, },
  {Feature_isGFX8PlusBit, },
  {Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, },
  {Feature_isGFX940PlusBit, },
  {Feature_isGFX9GFX10Bit, },
  {Feature_isGFX9PlusBit, },
  {Feature_isNotGFX12PlusBit, },
  {Feature_isNotGFX90APlusBit, },
  {Feature_isNotGFX940PlusBit, },
  {Feature_isNotGFX9PlusBit, },
  {Feature_isWave32Bit, },
  {Feature_isWave64Bit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, },
  {Feature_DisableFlatScratchBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, },
  {Feature_FP16DenormalsBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_FalsePredicateBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_Has16BitInstsBit, Feature_HasIntClampBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8OnlyBit, },
  {Feature_Has16BitInstsBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasAddNoCarryInstsBit, Feature_HasIntClampBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_HasGDSBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFMinFMaxF64FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasCvtFP8VOP1BugBit, Feature_HasFP8ConversionInstsBit, },
  {Feature_HasDot11InstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasDot9InstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasExportInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasSDWABit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX940PlusBit, },
  {Feature_HasFP8InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_isGFX12PlusBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFmaMixInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasFmaMixInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasFmaMixInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasGDSBit, Feature_HasLDSFPAtomicAddF32Bit, },
  {Feature_HasGDSBit, Feature_isGFX11PlusBit, },
  {Feature_HasGDSBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_HasGFX950InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasImageInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasMADIntraFwdBugBit, Feature_isGFX11OnlyBit, },
  {Feature_HasMAIInstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMed3_16Bit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasMed3_16Bit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasMed3_16Bit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_HasNotMADIntraFwdBugBit, Feature_isGFX9PlusBit, },
  {Feature_HasPackedD16VMemBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasScalarStoresBit, Feature_isGFX8PlusBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasVOP3PInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasVOP3PInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasVOP3PInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasXF32InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX7OnlyBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX9PlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isNotGFX9PlusBit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX12PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX8PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX9PlusBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_UseRealTrue16InstsBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX12PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX8PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX12PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX8PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_has16BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_isGFX11OnlyBit, Feature_isWave32Bit, },
  {Feature_isGFX11OnlyBit, Feature_isWave64Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave32Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave64Bit, },
  {Feature_isGFX90APlusBit, Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, Feature_isGFX940PlusBit, },
  {Feature_D16PreservesUnusedBitsBit, Feature_HasFlatAddressSpaceBit, Feature_UseRealTrue16InstsBit, },
  {Feature_D16PreservesUnusedBitsBit, Feature_HasFlatGlobalInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_UseRealTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_Has16BitInstsBit, Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasNoCvtFP8VOP1BugBit, Feature_HasSDWABit, },
  {Feature_HasFP8ConversionInstsBit, Feature_NotHasTrue16BitInstsBit, Feature_isGFX9PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_UseFakeTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, Feature_isGFX6GFX7GFX10Bit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, Feature_UseRealTrue16InstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_UseRealTrue16InstsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_buf_soffset,
  GICP_gi_ds_128bit_8byte_aligned,
  GICP_gi_ds_1addr_1offset,
  GICP_gi_ds_64bit_4byte_aligned,
  GICP_gi_flat_offset,
  GICP_gi_flat_scratch_offset,
  GICP_gi_flat_scratch_saddr,
  GICP_gi_flat_scratch_svaddr,
  GICP_gi_global_offset,
  GICP_gi_global_saddr,
  GICP_gi_mubuf_addr64,
  GICP_gi_mubuf_offset,
  GICP_gi_mubuf_scratch_offen,
  GICP_gi_mubuf_scratch_offset,
  GICP_gi_smrd_buffer_imm,
  GICP_gi_smrd_buffer_imm32,
  GICP_gi_smrd_buffer_sgpr_imm,
  GICP_gi_smrd_imm,
  GICP_gi_smrd_imm32,
  GICP_gi_smrd_sgpr,
  GICP_gi_smrd_sgpr_imm,
  GICP_gi_swmmacindex16,
  GICP_gi_swmmacindex8,
  GICP_gi_vcsrc,
  GICP_gi_vinterpmods,
  GICP_gi_vinterpmods_hi,
  GICP_gi_vop3_mad_mix_mods,
  GICP_gi_vop3_mad_mix_mods_ext,
  GICP_gi_vop3_no_mods,
  GICP_gi_vop3mods,
  GICP_gi_vop3mods0,
  GICP_gi_vop3modsnoncanonicalizing,
  GICP_gi_vop3omods,
  GICP_gi_vop3opsel,
  GICP_gi_vop3opselmods,
  GICP_gi_vop3pmods,
  GICP_gi_vop3pmodsdot,
  GICP_gi_vop3pmodsneg,
  GICP_gi_vsrc0,
  GICP_gi_wmmamods,
  GICP_gi_wmmamodsf16Neg,
  GICP_gi_wmmamodsf16NegAbs,
  GICP_gi_wmmaopselvop3pmods,
  GICP_gi_wmmavisrc,
};
// See constructor for table contents

AMDGPUInstructionSelector::ComplexMatcherMemFn
AMDGPUInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AMDGPUInstructionSelector::selectBUFSOffset, // gi_buf_soffset
  &AMDGPUInstructionSelector::selectDS128Bit8ByteAligned, // gi_ds_128bit_8byte_aligned
  &AMDGPUInstructionSelector::selectDS1Addr1Offset, // gi_ds_1addr_1offset
  &AMDGPUInstructionSelector::selectDS64Bit4ByteAligned, // gi_ds_64bit_4byte_aligned
  &AMDGPUInstructionSelector::selectFlatOffset, // gi_flat_offset
  &AMDGPUInstructionSelector::selectScratchOffset, // gi_flat_scratch_offset
  &AMDGPUInstructionSelector::selectScratchSAddr, // gi_flat_scratch_saddr
  &AMDGPUInstructionSelector::selectScratchSVAddr, // gi_flat_scratch_svaddr
  &AMDGPUInstructionSelector::selectGlobalOffset, // gi_global_offset
  &AMDGPUInstructionSelector::selectGlobalSAddr, // gi_global_saddr
  &AMDGPUInstructionSelector::selectMUBUFAddr64, // gi_mubuf_addr64
  &AMDGPUInstructionSelector::selectMUBUFOffset, // gi_mubuf_offset
  &AMDGPUInstructionSelector::selectMUBUFScratchOffen, // gi_mubuf_scratch_offen
  &AMDGPUInstructionSelector::selectMUBUFScratchOffset, // gi_mubuf_scratch_offset
  &AMDGPUInstructionSelector::selectSMRDBufferImm, // gi_smrd_buffer_imm
  &AMDGPUInstructionSelector::selectSMRDBufferImm32, // gi_smrd_buffer_imm32
  &AMDGPUInstructionSelector::selectSMRDBufferSgprImm, // gi_smrd_buffer_sgpr_imm
  &AMDGPUInstructionSelector::selectSmrdImm, // gi_smrd_imm
  &AMDGPUInstructionSelector::selectSmrdImm32, // gi_smrd_imm32
  &AMDGPUInstructionSelector::selectSmrdSgpr, // gi_smrd_sgpr
  &AMDGPUInstructionSelector::selectSmrdSgprImm, // gi_smrd_sgpr_imm
  &AMDGPUInstructionSelector::selectSWMMACIndex16, // gi_swmmacindex16
  &AMDGPUInstructionSelector::selectSWMMACIndex8, // gi_swmmacindex8
  &AMDGPUInstructionSelector::selectVCSRC, // gi_vcsrc
  &AMDGPUInstructionSelector::selectVINTERPMods, // gi_vinterpmods
  &AMDGPUInstructionSelector::selectVINTERPModsHi, // gi_vinterpmods_hi
  &AMDGPUInstructionSelector::selectVOP3PMadMixMods, // gi_vop3_mad_mix_mods
  &AMDGPUInstructionSelector::selectVOP3PMadMixModsExt, // gi_vop3_mad_mix_mods_ext
  &AMDGPUInstructionSelector::selectVOP3NoMods, // gi_vop3_no_mods
  &AMDGPUInstructionSelector::selectVOP3Mods, // gi_vop3mods
  &AMDGPUInstructionSelector::selectVOP3Mods0, // gi_vop3mods0
  &AMDGPUInstructionSelector::selectVOP3ModsNonCanonicalizing, // gi_vop3modsnoncanonicalizing
  &AMDGPUInstructionSelector::selectVOP3OMods, // gi_vop3omods
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opsel
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opselmods
  &AMDGPUInstructionSelector::selectVOP3PMods, // gi_vop3pmods
  &AMDGPUInstructionSelector::selectVOP3PModsDOT, // gi_vop3pmodsdot
  &AMDGPUInstructionSelector::selectVOP3PModsNeg, // gi_vop3pmodsneg
  &AMDGPUInstructionSelector::selectVSRC0, // gi_vsrc0
  &AMDGPUInstructionSelector::selectWMMAModsF32NegAbs, // gi_wmmamods
  &AMDGPUInstructionSelector::selectWMMAModsF16Neg, // gi_wmmamodsf16Neg
  &AMDGPUInstructionSelector::selectWMMAModsF16NegAbs, // gi_wmmamodsf16NegAbs
  &AMDGPUInstructionSelector::selectWMMAOpSelVOP3PMods, // gi_wmmaopselvop3pmods
  &AMDGPUInstructionSelector::selectWMMAVISrc, // gi_wmmavisrc
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_aligned_smrd_load = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_anonymous_13701,
  GICXXPred_MI_Predicate_anonymous_13704,
  GICXXPred_MI_Predicate_anonymous_13705,
  GICXXPred_MI_Predicate_anonymous_13706,
  GICXXPred_MI_Predicate_anonymous_13707,
  GICXXPred_MI_Predicate_anonymous_13708,
  GICXXPred_MI_Predicate_anonymous_13711,
  GICXXPred_MI_Predicate_anonymous_13712,
  GICXXPred_MI_Predicate_anonymous_13713,
  GICXXPred_MI_Predicate_anonymous_13714,
  GICXXPred_MI_Predicate_anonymous_13715,
  GICXXPred_MI_Predicate_anonymous_13716,
  GICXXPred_MI_Predicate_anonymous_13717,
  GICXXPred_MI_Predicate_anonymous_13718,
  GICXXPred_MI_Predicate_anonymous_13719,
  GICXXPred_MI_Predicate_anonymous_13720,
  GICXXPred_MI_Predicate_anonymous_13721,
  GICXXPred_MI_Predicate_anonymous_13722,
  GICXXPred_MI_Predicate_anonymous_13723,
  GICXXPred_MI_Predicate_anonymous_13724,
  GICXXPred_MI_Predicate_anonymous_13725,
  GICXXPred_MI_Predicate_anonymous_13726,
  GICXXPred_MI_Predicate_anonymous_13727,
  GICXXPred_MI_Predicate_anonymous_13728,
  GICXXPred_MI_Predicate_anonymous_13729,
  GICXXPred_MI_Predicate_anonymous_13730,
  GICXXPred_MI_Predicate_anonymous_13731,
  GICXXPred_MI_Predicate_anonymous_13732,
  GICXXPred_MI_Predicate_anonymous_13733,
  GICXXPred_MI_Predicate_anonymous_13734,
  GICXXPred_MI_Predicate_anonymous_13735,
  GICXXPred_MI_Predicate_anonymous_13736,
  GICXXPred_MI_Predicate_anonymous_13737,
  GICXXPred_MI_Predicate_anonymous_13738,
  GICXXPred_MI_Predicate_anonymous_13739,
  GICXXPred_MI_Predicate_anonymous_13740,
  GICXXPred_MI_Predicate_anonymous_13741,
  GICXXPred_MI_Predicate_anonymous_13742,
  GICXXPred_MI_Predicate_anonymous_13743,
  GICXXPred_MI_Predicate_anonymous_13744,
  GICXXPred_MI_Predicate_anonymous_13745,
  GICXXPred_MI_Predicate_anonymous_13746,
  GICXXPred_MI_Predicate_anonymous_13747,
  GICXXPred_MI_Predicate_anonymous_13748,
  GICXXPred_MI_Predicate_anonymous_13749,
  GICXXPred_MI_Predicate_anonymous_13750,
  GICXXPred_MI_Predicate_anonymous_13751,
  GICXXPred_MI_Predicate_anonymous_13752,
  GICXXPred_MI_Predicate_anonymous_13753,
  GICXXPred_MI_Predicate_anonymous_13754,
  GICXXPred_MI_Predicate_anonymous_13761,
  GICXXPred_MI_Predicate_anonymous_13773,
  GICXXPred_MI_Predicate_anonymous_18315,
  GICXXPred_MI_Predicate_anonymous_19236,
  GICXXPred_MI_Predicate_anonymous_19238,
  GICXXPred_MI_Predicate_anonymous_19631,
  GICXXPred_MI_Predicate_anonymous_19633,
  GICXXPred_MI_Predicate_anonymous_19635,
  GICXXPred_MI_Predicate_anonymous_19637,
  GICXXPred_MI_Predicate_anonymous_19639,
  GICXXPred_MI_Predicate_anonymous_19643,
  GICXXPred_MI_Predicate_anonymous_19645,
  GICXXPred_MI_Predicate_anonymous_19647,
  GICXXPred_MI_Predicate_anonymous_19649,
  GICXXPred_MI_Predicate_anonymous_19651,
  GICXXPred_MI_Predicate_anonymous_19884,
  GICXXPred_MI_Predicate_anonymous_19886,
  GICXXPred_MI_Predicate_anonymous_20127,
  GICXXPred_MI_Predicate_anonymous_20300,
  GICXXPred_MI_Predicate_anonymous_20812,
  GICXXPred_MI_Predicate_anonymous_20815,
  GICXXPred_MI_Predicate_anonymous_20818,
  GICXXPred_MI_Predicate_anonymous_20820,
  GICXXPred_MI_Predicate_anonymous_20823,
  GICXXPred_MI_Predicate_anonymous_20825,
  GICXXPred_MI_Predicate_anonymous_20828,
  GICXXPred_MI_Predicate_anonymous_20831,
  GICXXPred_MI_Predicate_anonymous_20835,
  GICXXPred_MI_Predicate_anonymous_20847,
  GICXXPred_MI_Predicate_anonymous_21278,
  GICXXPred_MI_Predicate_anonymous_21551,
  GICXXPred_MI_Predicate_anonymous_21554,
  GICXXPred_MI_Predicate_anonymous_21556,
  GICXXPred_MI_Predicate_anonymous_21558,
  GICXXPred_MI_Predicate_anonymous_21560,
  GICXXPred_MI_Predicate_anonymous_21562,
  GICXXPred_MI_Predicate_anonymous_21564,
  GICXXPred_MI_Predicate_anonymous_23268,
  GICXXPred_MI_Predicate_anonymous_23270,
  GICXXPred_MI_Predicate_anonymous_23274,
  GICXXPred_MI_Predicate_anonymous_23276,
  GICXXPred_MI_Predicate_anonymous_23278,
  GICXXPred_MI_Predicate_anonymous_23280,
  GICXXPred_MI_Predicate_anonymous_23284,
  GICXXPred_MI_Predicate_anonymous_23286,
  GICXXPred_MI_Predicate_anonymous_23288,
  GICXXPred_MI_Predicate_anonymous_23290,
  GICXXPred_MI_Predicate_anonymous_23292,
  GICXXPred_MI_Predicate_anonymous_23294,
  GICXXPred_MI_Predicate_anonymous_23296,
  GICXXPred_MI_Predicate_anonymous_23298,
  GICXXPred_MI_Predicate_anonymous_23302,
  GICXXPred_MI_Predicate_anonymous_23304,
  GICXXPred_MI_Predicate_anonymous_23306,
  GICXXPred_MI_Predicate_anonymous_23308,
  GICXXPred_MI_Predicate_anonymous_23312,
  GICXXPred_MI_Predicate_anonymous_23314,
  GICXXPred_MI_Predicate_anonymous_23318,
  GICXXPred_MI_Predicate_anonymous_23320,
  GICXXPred_MI_Predicate_anonymous_23322,
  GICXXPred_MI_Predicate_anonymous_23324,
  GICXXPred_MI_Predicate_anonymous_23328,
  GICXXPred_MI_Predicate_anonymous_23330,
  GICXXPred_MI_Predicate_anonymous_23332,
  GICXXPred_MI_Predicate_anonymous_23334,
  GICXXPred_MI_Predicate_anonymous_23336,
  GICXXPred_MI_Predicate_anonymous_23338,
  GICXXPred_MI_Predicate_anonymous_23340,
  GICXXPred_MI_Predicate_anonymous_23342,
  GICXXPred_MI_Predicate_anonymous_23346,
  GICXXPred_MI_Predicate_anonymous_23348,
  GICXXPred_MI_Predicate_anonymous_23350,
  GICXXPred_MI_Predicate_anonymous_23352,
  GICXXPred_MI_Predicate_anonymous_23356,
  GICXXPred_MI_Predicate_anonymous_23358,
  GICXXPred_MI_Predicate_anonymous_23360,
  GICXXPred_MI_Predicate_anonymous_23362,
  GICXXPred_MI_Predicate_anonymous_23364,
  GICXXPred_MI_Predicate_anonymous_23366,
  GICXXPred_MI_Predicate_anonymous_23370,
  GICXXPred_MI_Predicate_anonymous_23372,
  GICXXPred_MI_Predicate_anonymous_23374,
  GICXXPred_MI_Predicate_anonymous_23376,
  GICXXPred_MI_Predicate_anonymous_23378,
  GICXXPred_MI_Predicate_anonymous_23380,
  GICXXPred_MI_Predicate_anonymous_23384,
  GICXXPred_MI_Predicate_anonymous_23386,
  GICXXPred_MI_Predicate_anonymous_23390,
  GICXXPred_MI_Predicate_anonymous_23392,
  GICXXPred_MI_Predicate_anonymous_23394,
  GICXXPred_MI_Predicate_anonymous_23396,
  GICXXPred_MI_Predicate_anonymous_23416,
  GICXXPred_MI_Predicate_anonymous_23418,
  GICXXPred_MI_Predicate_anonymous_23452,
  GICXXPred_MI_Predicate_anonymous_23454,
  GICXXPred_MI_Predicate_anonymous_23474,
  GICXXPred_MI_Predicate_anonymous_23476,
  GICXXPred_MI_Predicate_anonymous_23514,
  GICXXPred_MI_Predicate_anonymous_23516,
  GICXXPred_MI_Predicate_anonymous_23520,
  GICXXPred_MI_Predicate_anonymous_23522,
  GICXXPred_MI_Predicate_anonymous_23524,
  GICXXPred_MI_Predicate_anonymous_23526,
  GICXXPred_MI_Predicate_anonymous_23528,
  GICXXPred_MI_Predicate_anonymous_23530,
  GICXXPred_MI_Predicate_anonymous_23532,
  GICXXPred_MI_Predicate_anonymous_23534,
  GICXXPred_MI_Predicate_anonymous_23538,
  GICXXPred_MI_Predicate_anonymous_23540,
  GICXXPred_MI_Predicate_anonymous_23542,
  GICXXPred_MI_Predicate_anonymous_23544,
  GICXXPred_MI_Predicate_anonymous_23548,
  GICXXPred_MI_Predicate_anonymous_23550,
  GICXXPred_MI_Predicate_anonymous_23552,
  GICXXPred_MI_Predicate_anonymous_23554,
  GICXXPred_MI_Predicate_anonymous_23556,
  GICXXPred_MI_Predicate_anonymous_23558,
  GICXXPred_MI_Predicate_anonymous_23562,
  GICXXPred_MI_Predicate_anonymous_23564,
  GICXXPred_MI_Predicate_anonymous_23566,
  GICXXPred_MI_Predicate_anonymous_23568,
  GICXXPred_MI_Predicate_anonymous_23570,
  GICXXPred_MI_Predicate_anonymous_23572,
  GICXXPred_MI_Predicate_anonymous_23574,
  GICXXPred_MI_Predicate_anonymous_23576,
  GICXXPred_MI_Predicate_anonymous_23578,
  GICXXPred_MI_Predicate_anonymous_23580,
  GICXXPred_MI_Predicate_anonymous_23584,
  GICXXPred_MI_Predicate_anonymous_23586,
  GICXXPred_MI_Predicate_anonymous_23588,
  GICXXPred_MI_Predicate_anonymous_23590,
  GICXXPred_MI_Predicate_anonymous_23592,
  GICXXPred_MI_Predicate_anonymous_23594,
  GICXXPred_MI_Predicate_anonymous_23596,
  GICXXPred_MI_Predicate_anonymous_23598,
  GICXXPred_MI_Predicate_anonymous_34197,
  GICXXPred_MI_Predicate_anonymous_34635,
  GICXXPred_MI_Predicate_anonymous_34637,
  GICXXPred_MI_Predicate_anonymous_34683,
  GICXXPred_MI_Predicate_anonymous_34698,
  GICXXPred_MI_Predicate_anonymous_34699,
  GICXXPred_MI_Predicate_anonymous_34702,
  GICXXPred_MI_Predicate_anonymous_34705,
  GICXXPred_MI_Predicate_anonymous_34708,
  GICXXPred_MI_Predicate_anonymous_34712,
  GICXXPred_MI_Predicate_anonymous_34715,
  GICXXPred_MI_Predicate_anonymous_34718,
  GICXXPred_MI_Predicate_anonymous_34720,
  GICXXPred_MI_Predicate_anonymous_34721,
  GICXXPred_MI_Predicate_anonymous_34730,
  GICXXPred_MI_Predicate_anonymous_34732,
  GICXXPred_MI_Predicate_anonymous_34740,
  GICXXPred_MI_Predicate_anonymous_34745,
  GICXXPred_MI_Predicate_anonymous_34749,
  GICXXPred_MI_Predicate_anonymous_34753,
  GICXXPred_MI_Predicate_anonymous_34763,
  GICXXPred_MI_Predicate_anonymous_34912,
  GICXXPred_MI_Predicate_anonymous_34915,
  GICXXPred_MI_Predicate_anonymous_34920,
  GICXXPred_MI_Predicate_anonymous_34924,
  GICXXPred_MI_Predicate_anonymous_34928,
  GICXXPred_MI_Predicate_anonymous_34995,
  GICXXPred_MI_Predicate_anonymous_34997,
  GICXXPred_MI_Predicate_anonymous_35057,
  GICXXPred_MI_Predicate_anonymous_35085,
  GICXXPred_MI_Predicate_anonymous_35087,
  GICXXPred_MI_Predicate_anonymous_35116,
  GICXXPred_MI_Predicate_anonymous_35118,
  GICXXPred_MI_Predicate_anonymous_35120,
  GICXXPred_MI_Predicate_anonymous_35122,
  GICXXPred_MI_Predicate_anonymous_35124,
  GICXXPred_MI_Predicate_anonymous_35154,
  GICXXPred_MI_Predicate_anonymous_35156,
  GICXXPred_MI_Predicate_bf16_fpround,
  GICXXPred_MI_Predicate_csh_mask_16,
  GICXXPred_MI_Predicate_csh_mask_32,
  GICXXPred_MI_Predicate_csh_mask_64,
  GICXXPred_MI_Predicate_fmaxnum_like_nnan,
  GICXXPred_MI_Predicate_fminnum_like_nnan,
  GICXXPred_MI_Predicate_is_canonicalized,
  GICXXPred_MI_Predicate_load_align_less_than_4_local,
  GICXXPred_MI_Predicate_load_align_less_than_4_local_m0,
  GICXXPred_MI_Predicate_shl1_add,
  GICXXPred_MI_Predicate_shl2_add,
  GICXXPred_MI_Predicate_shl3_add,
  GICXXPred_MI_Predicate_shl4_add,
  GICXXPred_MI_Predicate_shl_0_to_4,
  GICXXPred_MI_Predicate_smrd_extloadi8,
  GICXXPred_MI_Predicate_smrd_extloadi16,
  GICXXPred_MI_Predicate_smrd_load,
  GICXXPred_MI_Predicate_smrd_prefetch,
  GICXXPred_MI_Predicate_smrd_sextloadi8,
  GICXXPred_MI_Predicate_smrd_sextloadi16,
  GICXXPred_MI_Predicate_smrd_zextloadi8,
  GICXXPred_MI_Predicate_smrd_zextloadi16,
  GICXXPred_MI_Predicate_store_align_less_than_4_local,
  GICXXPred_MI_Predicate_store_align_less_than_4_local_m0,
};
bool AMDGPUInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_aligned_smrd_load: {
    
      auto &Ld = cast<GLoad>(MI);
      TypeSize Size = Ld.getMMO().getSize().getValue();
      return Size <= 4 || Ld.getMMO().getAlign().value() >= Size;
      
    llvm_unreachable("aligned_smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_13701: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13704: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13705: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13706: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13707: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13708: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13711: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13712: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13713: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13714: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13715: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13716: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13717: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13718: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13719: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13720: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13721: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13722: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13723: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13724: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13725: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13726: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13727: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13728: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13729: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13730: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13731: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13732: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13733: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13734: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13735: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13736: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13737: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13738: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13739: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13740: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13741: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13742: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13743: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13744: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13745: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13746: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13747: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13748: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13749: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13750: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13751: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13752: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13753: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13754: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13761: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13773: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_18315: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19236: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19238: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19631: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19633: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19635: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19637: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19639: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19643: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19645: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19647: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19649: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19651: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19884: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19886: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20127: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20300: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20812: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20812 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20815: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20815 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20818: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20818 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20820: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20820 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20823: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20823 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20825: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20825 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20828: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20828 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20831: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20831 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20835: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20835 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20847: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20847 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_21278: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_21278 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_21551: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21554: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21556: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21558: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21560: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21562: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_21564: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_23268: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23270: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23274: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23276: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23278: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23280: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23284: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23286: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23288: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23290: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23292: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23294: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23296: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23298: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23302: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23304: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23306: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23308: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23312: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23314: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23318: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23320: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23322: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23324: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23328: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23330: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23332: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23334: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23336: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23338: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23340: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23342: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23346: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23348: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23350: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23352: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23356: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23358: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23360: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23362: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23364: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23366: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23370: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23372: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23374: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23376: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23378: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23380: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23384: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23386: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23390: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23392: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23394: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23396: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23416: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23418: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23452: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23454: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23474: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23476: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23514: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23516: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23520: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23522: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23524: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23526: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23528: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23530: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23532: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23534: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23538: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23540: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23542: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23544: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23548: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23550: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23552: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23554: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23556: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23558: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23562: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23564: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23566: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23568: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23570: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23572: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23574: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23576: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23578: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23580: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23584: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23586: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23588: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23590: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23592: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23594: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23596: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_23598: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_34197: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34635: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34637: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34683: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34698: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34699: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34702: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34705: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34708: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34712: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34715: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34718: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34720: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34721: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34730: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34732: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34740: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34745: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34749: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34753: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34763: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34912: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34915: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34920: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34924: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34928: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34995: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34997: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35057: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF) &&
          TLI->isCanonicalized(MI.getOperand(2).getReg(), MF);
      
    llvm_unreachable("anonymous_35057 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_35085: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35087: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35116: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF);
      
    llvm_unreachable("anonymous_35116 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_35118: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35120: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35122: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35124: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35154: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_35156: {
    return true;
  }
  case GICXXPred_MI_Predicate_bf16_fpround: {
    return false;
  }
  case GICXXPred_MI_Predicate_csh_mask_16: {
     return isUnneededShiftMask(MI, 4); 
  }
  case GICXXPred_MI_Predicate_csh_mask_32: {
     return isUnneededShiftMask(MI, 5); 
  }
  case GICXXPred_MI_Predicate_csh_mask_64: {
     return isUnneededShiftMask(MI, 6); 
  }
  case GICXXPred_MI_Predicate_fmaxnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_fminnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_is_canonicalized: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
            MF.getSubtarget().getTargetLowering());
        const MachineOperand &Dst = MI.getOperand(0);
        assert(Dst.isDef());
        return TLI->isCanonicalized(Dst.getReg(), MF);
       
    llvm_unreachable("is_canonicalized should have returned");
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_shl1_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl2_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl3_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl4_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl_0_to_4: {
    
        int64_t Imm = 0;
        if (!mi_match(MI.getOperand(2).getReg(), MRI, m_ICst(Imm)) &&
            !mi_match(MI.getOperand(2).getReg(), MRI, m_Copy(m_ICst(Imm))))
          return false;
        return (uint64_t)Imm <= 4;
      
    llvm_unreachable("shl_0_to_4 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_load: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_prefetch: {
    
        return isInstrUniform(MI);
      
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_MFMALdScaleModifierOp,
  GICXXPred_I64_Predicate_NegSubInlineConst32,
  GICXXPred_I64_Predicate_NegSubInlineIntConst16,
  GICXXPred_I64_Predicate_SIMM16bit,
  GICXXPred_I64_Predicate_ShiftAmt32Imm,
  GICXXPred_I64_Predicate_SupportedRoundMode,
  GICXXPred_I64_Predicate_i32imm_one,
  GICXXPred_I64_Predicate_i32imm_zero,
  GICXXPred_I64_Predicate_i64imm_32bit,
};
bool AMDGPUInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask: {
    
      return isMask_32(Imm);
    
  }
  case GICXXPred_I64_Predicate_MFMALdScaleModifierOp: {
    
      return isUInt<2>(Imm);
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineConst32: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineIntConst16: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_SIMM16bit: {
    return isInt<16>(Imm) || isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_ShiftAmt32Imm: {
    
      return Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_SupportedRoundMode: {
    
      return Imm == (int)RoundingMode::TowardZero ||
             Imm == (int)RoundingMode::NearestTiesToEven ||
             Imm == (int)RoundingMode::TowardPositive ||
             Imm == (int)RoundingMode::TowardNegative;
    
  }
  case GICXXPred_I64_Predicate_i32imm_one: {
    
      return Imm == 1;
    
  }
  case GICXXPred_I64_Predicate_i32imm_zero: {
    
      return Imm == 0;
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_InlineImmFP32 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_InlineImmFP64,
  GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64,
  GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64,
};
bool AMDGPUInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_InlineImmFP32: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_InlineImmFP64: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64: {
    
        if (!Imm.isNegative())
          return false;
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_neg_pow2_prefer_ldexp_f64 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64: {
    
        if (Imm.isNegative())
          return false;
    
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_pos_pow2_prefer_ldexp_f64 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_InlineImm64 = GICXXPred_Invalid + 1,
};
bool AMDGPUInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_InlineImm64: {
    
      return isInlineImmediate(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderBitcastFPImm32,
  GICR_renderBitcastFPImm64,
  GICR_renderDstSelToOpSel3XFormXForm,
  GICR_renderDstSelToOpSelXForm,
  GICR_renderExtractCPol,
  GICR_renderExtractCpolSetGLC,
  GICR_renderExtractSWZ,
  GICR_renderFPPow2ToExponent,
  GICR_renderFrameIndex,
  GICR_renderNegateImm,
  GICR_renderOpSelTImm,
  GICR_renderPopcntImm,
  GICR_renderRoundMode,
  GICR_renderScaledMAIIntrinsicOperand,
  GICR_renderSrcAndDstSelToOpSelXForm_0_0,
  GICR_renderSrcAndDstSelToOpSelXForm_0_1,
  GICR_renderSrcAndDstSelToOpSelXForm_1_0,
  GICR_renderSrcAndDstSelToOpSelXForm_1_1,
  GICR_renderSrcAndDstSelToOpSelXForm_2_0,
  GICR_renderSrcSelToOpSelXForm,
  GICR_renderTruncTImm,
  GICR_renderZextBoolTImm,
};
AMDGPUInstructionSelector::CustomRendererFn
AMDGPUInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AMDGPUInstructionSelector::renderBitcastFPImm32,
  &AMDGPUInstructionSelector::renderBitcastFPImm64,
  &AMDGPUInstructionSelector::renderDstSelToOpSel3XFormXForm,
  &AMDGPUInstructionSelector::renderDstSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderExtractCPol,
  &AMDGPUInstructionSelector::renderExtractCpolSetGLC,
  &AMDGPUInstructionSelector::renderExtractSWZ,
  &AMDGPUInstructionSelector::renderFPPow2ToExponent,
  &AMDGPUInstructionSelector::renderFrameIndex,
  &AMDGPUInstructionSelector::renderNegateImm,
  &AMDGPUInstructionSelector::renderOpSelTImm,
  &AMDGPUInstructionSelector::renderPopcntImm,
  &AMDGPUInstructionSelector::renderRoundMode,
  &AMDGPUInstructionSelector::renderScaledMAIIntrinsicOperand,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_2_0,
  &AMDGPUInstructionSelector::renderSrcSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderTruncTImm,
  &AMDGPUInstructionSelector::renderZextBoolTImm,
};

bool AMDGPUInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AMDGPUInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(3696), /*)*//*default:*//*Label 167*/ GIMT_Encode4(780372),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(14582),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(37824),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(38447), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(38793),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(40194),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(55706), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 6*/ GIMT_Encode4(60573), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 7*/ GIMT_Encode4(60628), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 8*/ GIMT_Encode4(65654), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    138 */ /*TargetOpcode::G_INTRINSIC_FPTRUNC_ROUND*//*Label 9*/ GIMT_Encode4(74818),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(75013), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 11*/ GIMT_Encode4(75341),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 12*/ GIMT_Encode4(75669),
     /*    166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 13*/ GIMT_Encode4(75809),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 14*/ GIMT_Encode4(75867),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 15*/ GIMT_Encode4(143567),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 16*/ GIMT_Encode4(150633), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 17*/ GIMT_Encode4(157841), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 18*/ GIMT_Encode4(191746),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 19*/ GIMT_Encode4(192872),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 20*/ GIMT_Encode4(195084),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 21*/ GIMT_Encode4(197596),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 22*/ GIMT_Encode4(200108), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 23*/ GIMT_Encode4(202620),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 24*/ GIMT_Encode4(205132),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 25*/ GIMT_Encode4(207644),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 26*/ GIMT_Encode4(210156),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 27*/ GIMT_Encode4(212668),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 28*/ GIMT_Encode4(215180),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 29*/ GIMT_Encode4(217692), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 30*/ GIMT_Encode4(219903),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 31*/ GIMT_Encode4(222549), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    278 */ /*TargetOpcode::G_ATOMICRMW_UINC_WRAP*//*Label 32*/ GIMT_Encode4(225195),
     /*    282 */ /*TargetOpcode::G_ATOMICRMW_UDEC_WRAP*//*Label 33*/ GIMT_Encode4(227707), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(230219),
     /*    298 */ /*TargetOpcode::G_PREFETCH*//*Label 35*/ GIMT_Encode4(230238), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 36*/ GIMT_Encode4(230674),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 37*/ GIMT_Encode4(248239),
     /*    322 */ /*TargetOpcode::G_INTRINSIC_CONVERGENT*//*Label 38*/ GIMT_Encode4(252950),
     /*    326 */ /*TargetOpcode::G_INTRINSIC_CONVERGENT_W_SIDE_EFFECTS*//*Label 39*/ GIMT_Encode4(277918),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 40*/ GIMT_Encode4(279169),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 41*/ GIMT_Encode4(279732),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 42*/ GIMT_Encode4(279972),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 43*/ GIMT_Encode4(280698), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 44*/ GIMT_Encode4(280980), GIMT_Encode4(0),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(281783),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(284986),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(286522),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(287684), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(288846),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(289108), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(289185),
     /*    398 */ /*TargetOpcode::G_FCMP*//*Label 52*/ GIMT_Encode4(290777), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 53*/ GIMT_Encode4(294940), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 54*/ GIMT_Encode4(295284),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 55*/ GIMT_Encode4(295393),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 56*/ GIMT_Encode4(295502),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 57*/ GIMT_Encode4(295890),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 58*/ GIMT_Encode4(296216),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 59*/ GIMT_Encode4(296604), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(296930),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(298288),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(298652),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(300038),
     /*    534 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(301907), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    546 */ /*TargetOpcode::G_FPOW*//*Label 65*/ GIMT_Encode4(302853), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    558 */ /*TargetOpcode::G_FEXP2*//*Label 66*/ GIMT_Encode4(302971), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    570 */ /*TargetOpcode::G_FLOG2*//*Label 67*/ GIMT_Encode4(303194), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FLDEXP*//*Label 68*/ GIMT_Encode4(303417), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(303780),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 70*/ GIMT_Encode4(305643),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 71*/ GIMT_Encode4(306043),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 72*/ GIMT_Encode4(306979),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 73*/ GIMT_Encode4(307705),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 74*/ GIMT_Encode4(308431),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 75*/ GIMT_Encode4(309164), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 76*/ GIMT_Encode4(309897),
     /*    626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 77*/ GIMT_Encode4(310698),
     /*    630 */ /*TargetOpcode::G_IS_FPCLASS*//*Label 78*/ GIMT_Encode4(311123),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 79*/ GIMT_Encode4(311454),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 80*/ GIMT_Encode4(312922),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 81*/ GIMT_Encode4(384701),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 82*/ GIMT_Encode4(456480),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 83*/ GIMT_Encode4(528259),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 84*/ GIMT_Encode4(600038),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 85*/ GIMT_Encode4(602153), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 86*/ GIMT_Encode4(604268), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    694 */ /*TargetOpcode::G_PTR_ADD*//*Label 87*/ GIMT_Encode4(604392), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 88*/ GIMT_Encode4(604469),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 89*/ GIMT_Encode4(610833),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 90*/ GIMT_Encode4(617359),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 91*/ GIMT_Encode4(623723),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 92*/ GIMT_Encode4(630087), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 93*/ GIMT_Encode4(630224), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    778 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 94*/ GIMT_Encode4(630258), GIMT_Encode4(0),
     /*    786 */ /*TargetOpcode::G_CTLZ_ZERO_UNDEF*//*Label 95*/ GIMT_Encode4(630357),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 96*/ GIMT_Encode4(630459),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 97*/ GIMT_Encode4(630674),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 98*/ GIMT_Encode4(632423),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 99*/ GIMT_Encode4(632671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 100*/ GIMT_Encode4(632999),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 101*/ GIMT_Encode4(633291), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 102*/ GIMT_Encode4(633805),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 103*/ GIMT_Encode4(634767),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 104*/ GIMT_Encode4(635131), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(636399), GIMT_Encode4(0),
     /*    918 */ /*TargetOpcode::G_STRICT_FLDEXP*//*Label 106*/ GIMT_Encode4(637445), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14282 */ /*AMDGPU::G_AMDGPU_ATOMIC_CMPXCHG*//*Label 107*/ GIMT_Encode4(637808),
     /*  14286 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_ADD*//*Label 108*/ GIMT_Encode4(640112),
     /*  14290 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_AND*//*Label 109*/ GIMT_Encode4(642496),
     /*  14294 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_CMPSWAP*//*Label 110*/ GIMT_Encode4(644880),
     /*  14298 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_COND_SUB_U32*//*Label 111*/ GIMT_Encode4(649174),
     /*  14302 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_DEC*//*Label 112*/ GIMT_Encode4(649791),
     /*  14306 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FADD*//*Label 113*/ GIMT_Encode4(652175),
     /*  14310 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMAX*//*Label 114*/ GIMT_Encode4(655817),
     /*  14314 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMIN*//*Label 115*/ GIMT_Encode4(659433),
     /*  14318 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_INC*//*Label 116*/ GIMT_Encode4(663049),
     /*  14322 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_OR*//*Label 117*/ GIMT_Encode4(665433),
     /*  14326 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMAX*//*Label 118*/ GIMT_Encode4(667817),
     /*  14330 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMIN*//*Label 119*/ GIMT_Encode4(670201),
     /*  14334 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SUB*//*Label 120*/ GIMT_Encode4(672585),
     /*  14338 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SWAP*//*Label 121*/ GIMT_Encode4(674969),
     /*  14342 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMAX*//*Label 122*/ GIMT_Encode4(678513),
     /*  14346 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMIN*//*Label 123*/ GIMT_Encode4(680897),
     /*  14350 */ /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_XOR*//*Label 124*/ GIMT_Encode4(683281),
     /*  14354 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD*//*Label 125*/ GIMT_Encode4(685665),
     /*  14358 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT*//*Label 126*/ GIMT_Encode4(701037),
     /*  14362 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_D16*//*Label 127*/ GIMT_Encode4(705945),
     /*  14366 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_TFE*//*Label 128*/ GIMT_Encode4(713690),
     /*  14370 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE*//*Label 129*/ GIMT_Encode4(716210),
     /*  14374 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE_TFE*//*Label 130*/ GIMT_Encode4(716816),
     /*  14378 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT*//*Label 131*/ GIMT_Encode4(717422),
     /*  14382 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT_TFE*//*Label 132*/ GIMT_Encode4(718028),
     /*  14386 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_TFE*//*Label 133*/ GIMT_Encode4(718634),
     /*  14390 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE*//*Label 134*/ GIMT_Encode4(721154),
     /*  14394 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE_TFE*//*Label 135*/ GIMT_Encode4(721760),
     /*  14398 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT*//*Label 136*/ GIMT_Encode4(722366),
     /*  14402 */ /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT_TFE*//*Label 137*/ GIMT_Encode4(722972),
     /*  14406 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE*//*Label 138*/ GIMT_Encode4(723578),
     /*  14410 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_BYTE*//*Label 139*/ GIMT_Encode4(738886),
     /*  14414 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT*//*Label 140*/ GIMT_Encode4(739488),
     /*  14418 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT_D16*//*Label 141*/ GIMT_Encode4(744976),
     /*  14422 */ /*AMDGPU::G_AMDGPU_BUFFER_STORE_SHORT*//*Label 142*/ GIMT_Encode4(752569), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14438 */ /*AMDGPU::G_AMDGPU_CLAMP*//*Label 143*/ GIMT_Encode4(753171), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14450 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE0*//*Label 144*/ GIMT_Encode4(754110),
     /*  14454 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE1*//*Label 145*/ GIMT_Encode4(754155),
     /*  14458 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE2*//*Label 146*/ GIMT_Encode4(754200),
     /*  14462 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE3*//*Label 147*/ GIMT_Encode4(754245),
     /*  14466 */ /*AMDGPU::G_AMDGPU_CVT_PK_I16_I32*//*Label 148*/ GIMT_Encode4(754290),
     /*  14470 */ /*AMDGPU::G_AMDGPU_FFBH_U32*//*Label 149*/ GIMT_Encode4(754320),
     /*  14474 */ /*AMDGPU::G_AMDGPU_FFBL_B32*//*Label 150*/ GIMT_Encode4(754422),
     /*  14478 */ /*AMDGPU::G_AMDGPU_FMAX_LEGACY*//*Label 151*/ GIMT_Encode4(754521),
     /*  14482 */ /*AMDGPU::G_AMDGPU_FMED3*//*Label 152*/ GIMT_Encode4(754594),
     /*  14486 */ /*AMDGPU::G_AMDGPU_FMIN_LEGACY*//*Label 153*/ GIMT_Encode4(754954), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14518 */ /*AMDGPU::G_AMDGPU_RCP_IFLAG*//*Label 154*/ GIMT_Encode4(755027), GIMT_Encode4(0),
     /*  14526 */ /*AMDGPU::G_AMDGPU_SMED3*//*Label 155*/ GIMT_Encode4(755077),
     /*  14530 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD*//*Label 156*/ GIMT_Encode4(755383),
     /*  14534 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SBYTE*//*Label 157*/ GIMT_Encode4(757685),
     /*  14538 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SSHORT*//*Label 158*/ GIMT_Encode4(757823),
     /*  14542 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_UBYTE*//*Label 159*/ GIMT_Encode4(757961),
     /*  14546 */ /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_USHORT*//*Label 160*/ GIMT_Encode4(758099),
     /*  14550 */ /*AMDGPU::G_AMDGPU_S_BUFFER_PREFETCH*//*Label 161*/ GIMT_Encode4(758237), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14562 */ /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT*//*Label 162*/ GIMT_Encode4(758344),
     /*  14566 */ /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT_D16*//*Label 163*/ GIMT_Encode4(763828),
     /*  14570 */ /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT*//*Label 164*/ GIMT_Encode4(769257),
     /*  14574 */ /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT_D16*//*Label 165*/ GIMT_Encode4(774725),
     /*  14578 */ /*AMDGPU::G_AMDGPU_UMED3*//*Label 166*/ GIMT_Encode4(780066),
     /*  14582 */ // Label 0: @14582
     /*  14582 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 173*/ GIMT_Encode4(37823),
     /*  14593 */ /*GILLT_s1*//*Label 168*/ GIMT_Encode4(14613),
     /*  14597 */ /*GILLT_s16*//*Label 169*/ GIMT_Encode4(14732),
     /*  14601 */ /*GILLT_s32*//*Label 170*/ GIMT_Encode4(15723),
     /*  14605 */ /*GILLT_s64*//*Label 171*/ GIMT_Encode4(37082),
     /*  14609 */ /*GILLT_v2s16*//*Label 172*/ GIMT_Encode4(37553),
     /*  14613 */ // Label 168: @14613
     /*  14613 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(14731),
     /*  14618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14624 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(14652), // Rule ID 7550 //
     /*  14629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  14632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  14636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  14640 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  14640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  14643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  14645 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  14650 */     GIR_RootConstrainSelectedInstOperands,
     /*  14651 */     // GIR_Coverage, 7550,
     /*  14651 */     GIR_EraseRootFromParent_Done,
     /*  14652 */   // Label 175: @14652
     /*  14652 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(14680), // Rule ID 7557 //
     /*  14657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  14660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  14664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  14668 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  14668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  14671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  14673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  14678 */     GIR_RootConstrainSelectedInstOperands,
     /*  14679 */     // GIR_Coverage, 7557,
     /*  14679 */     GIR_EraseRootFromParent_Done,
     /*  14680 */   // Label 176: @14680
     /*  14680 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(14705), // Rule ID 7548 //
     /*  14685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  14688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  14692 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  14692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  14697 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  14703 */     GIR_RootConstrainSelectedInstOperands,
     /*  14704 */     // GIR_Coverage, 7548,
     /*  14704 */     GIR_Done,
     /*  14705 */   // Label 177: @14705
     /*  14705 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(14730), // Rule ID 7555 //
     /*  14710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  14713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  14717 */     // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  14717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  14722 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  14728 */     GIR_RootConstrainSelectedInstOperands,
     /*  14729 */     // GIR_Coverage, 7555,
     /*  14729 */     GIR_Done,
     /*  14730 */   // Label 178: @14730
     /*  14730 */   GIM_Reject,
     /*  14731 */ // Label 174: @14731
     /*  14731 */ GIM_Reject,
     /*  14732 */ // Label 169: @14732
     /*  14732 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(15722),
     /*  14737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  14740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  14743 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(14795), // Rule ID 7034 //
     /*  14748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  14760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  14772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14776 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34197),
     /*  14780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14782 */     // (add:{ *:[i16] } (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34197>>), i16:{ *:[i16] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
     /*  14782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  14785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
     /*  14791 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  14793 */     GIR_RootConstrainSelectedInstOperands,
     /*  14794 */     // GIR_Coverage, 7034,
     /*  14794 */     GIR_EraseRootFromParent_Done,
     /*  14795 */   // Label 180: @14795
     /*  14795 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(14847), // Rule ID 11286 //
     /*  14800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  14812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  14824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14828 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34197),
     /*  14832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14834 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$val, (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34197>>))  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
     /*  14834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  14837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  14839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
     /*  14843 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  14845 */     GIR_RootConstrainSelectedInstOperands,
     /*  14846 */     // GIR_Coverage, 11286,
     /*  14846 */     GIR_EraseRootFromParent_Done,
     /*  14847 */   // Label 181: @14847
     /*  14847 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(14890), // Rule ID 2532 //
     /*  14852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /*  14855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  14871 */     // MIs[1] Operand 1
     /*  14871 */     // No operand predicates
     /*  14871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14873 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
     /*  14873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /*  14876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  14878 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14880 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  14885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14888 */     GIR_RootConstrainSelectedInstOperands,
     /*  14889 */     // GIR_Coverage, 2532,
     /*  14889 */     GIR_EraseRootFromParent_Done,
     /*  14890 */   // Label 182: @14890
     /*  14890 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(14942), // Rule ID 2676 //
     /*  14895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  14898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  14902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  14914 */     // MIs[1] Operand 1
     /*  14914 */     // No operand predicates
     /*  14914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14916 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  14916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /*  14919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  14921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14924 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14929 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  14934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14940 */     GIR_RootConstrainSelectedInstOperands,
     /*  14941 */     // GIR_Coverage, 2676,
     /*  14941 */     GIR_EraseRootFromParent_Done,
     /*  14942 */   // Label 183: @14942
     /*  14942 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(14994), // Rule ID 2679 //
     /*  14947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  14950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  14954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  14966 */     // MIs[1] Operand 1
     /*  14966 */     // No operand predicates
     /*  14966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14968 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 bf16 f16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  14968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /*  14971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  14973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14976 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  14978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14981 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  14986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14992 */     GIR_RootConstrainSelectedInstOperands,
     /*  14993 */     // GIR_Coverage, 2679,
     /*  14993 */     GIR_EraseRootFromParent_Done,
     /*  14994 */   // Label 184: @14994
     /*  14994 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(15046), // Rule ID 2682 //
     /*  14999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /*  15018 */     // MIs[1] Operand 1
     /*  15018 */     // No operand predicates
     /*  15018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15020 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  15020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /*  15023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15028 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15033 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  15038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15044 */     GIR_RootConstrainSelectedInstOperands,
     /*  15045 */     // GIR_Coverage, 2682,
     /*  15045 */     GIR_EraseRootFromParent_Done,
     /*  15046 */   // Label 185: @15046
     /*  15046 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(15096), // Rule ID 2572 //
     /*  15051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
     /*  15054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15076 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /*  15079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15094 */     GIR_RootConstrainSelectedInstOperands,
     /*  15095 */     // GIR_Coverage, 2572,
     /*  15095 */     GIR_EraseRootFromParent_Done,
     /*  15096 */   // Label 186: @15096
     /*  15096 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(15158), // Rule ID 2573 //
     /*  15101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15126 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_t16_e64),
     /*  15129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15156 */     GIR_RootConstrainSelectedInstOperands,
     /*  15157 */     // GIR_Coverage, 2573,
     /*  15157 */     GIR_EraseRootFromParent_Done,
     /*  15158 */   // Label 187: @15158
     /*  15158 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(15220), // Rule ID 2574 //
     /*  15163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15188 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
     /*  15191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15218 */     GIR_RootConstrainSelectedInstOperands,
     /*  15219 */     // GIR_Coverage, 2574,
     /*  15219 */     GIR_EraseRootFromParent_Done,
     /*  15220 */   // Label 188: @15220
     /*  15220 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(15282), // Rule ID 2575 //
     /*  15225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15250 */     // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
     /*  15253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  15274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15280 */     GIR_RootConstrainSelectedInstOperands,
     /*  15281 */     // GIR_Coverage, 2575,
     /*  15281 */     GIR_EraseRootFromParent_Done,
     /*  15282 */   // Label 189: @15282
     /*  15282 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(15332), // Rule ID 8622 //
     /*  15287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
     /*  15290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15312 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /*  15315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15330 */     GIR_RootConstrainSelectedInstOperands,
     /*  15331 */     // GIR_Coverage, 8622,
     /*  15331 */     GIR_EraseRootFromParent_Done,
     /*  15332 */   // Label 190: @15332
     /*  15332 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(15394), // Rule ID 8623 //
     /*  15337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  15340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15362 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_t16_e64),
     /*  15365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15392 */     GIR_RootConstrainSelectedInstOperands,
     /*  15393 */     // GIR_Coverage, 8623,
     /*  15393 */     GIR_EraseRootFromParent_Done,
     /*  15394 */   // Label 191: @15394
     /*  15394 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(15456), // Rule ID 8624 //
     /*  15399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  15402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15424 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
     /*  15427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15454 */     GIR_RootConstrainSelectedInstOperands,
     /*  15455 */     // GIR_Coverage, 8624,
     /*  15455 */     GIR_EraseRootFromParent_Done,
     /*  15456 */   // Label 192: @15456
     /*  15456 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(15518), // Rule ID 8625 //
     /*  15461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  15476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  15484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15486 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /*  15486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
     /*  15489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  15498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  15505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  15510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15516 */     GIR_RootConstrainSelectedInstOperands,
     /*  15517 */     // GIR_Coverage, 8625,
     /*  15517 */     GIR_EraseRootFromParent_Done,
     /*  15518 */   // Label 193: @15518
     /*  15518 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(15577), // Rule ID 1067 //
     /*  15523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  15526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15544 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
     /*  15547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15575 */     GIR_RootConstrainSelectedInstOperands,
     /*  15576 */     // GIR_Coverage, 1067,
     /*  15576 */     GIR_EraseRootFromParent_Done,
     /*  15577 */   // Label 194: @15577
     /*  15577 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(15636), // Rule ID 1068 //
     /*  15582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /*  15585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  15589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15603 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
     /*  15606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15634 */     GIR_RootConstrainSelectedInstOperands,
     /*  15635 */     // GIR_Coverage, 1068,
     /*  15635 */     GIR_EraseRootFromParent_Done,
     /*  15636 */   // Label 195: @15636
     /*  15636 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(15695), // Rule ID 1069 //
     /*  15641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /*  15644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  15662 */     // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  15662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
     /*  15665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  15672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  15677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  15682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  15687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15693 */     GIR_RootConstrainSelectedInstOperands,
     /*  15694 */     // GIR_Coverage, 1069,
     /*  15694 */     GIR_EraseRootFromParent_Done,
     /*  15695 */   // Label 196: @15695
     /*  15695 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(15721), // Rule ID 910 //
     /*  15700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
     /*  15703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15707 */     // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  15707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /*  15710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  15712 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  15714 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15719 */     GIR_RootConstrainSelectedInstOperands,
     /*  15720 */     // GIR_Coverage, 910,
     /*  15720 */     GIR_EraseRootFromParent_Done,
     /*  15721 */   // Label 197: @15721
     /*  15721 */   GIM_Reject,
     /*  15722 */ // Label 179: @15722
     /*  15722 */ GIM_Reject,
     /*  15723 */ // Label 170: @15723
     /*  15723 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(37081),
     /*  15728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15734 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(16233), // Rule ID 8731 //
     /*  15739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  15742 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  15744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  15748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15756 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15759 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  15764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15768 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  15772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  15774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  15786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  15790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  15794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  15798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  15806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  15810 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  15814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  15818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  15822 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  15826 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  15830 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  15832 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15836 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15840 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  15843 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  15848 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  15852 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  15856 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  15858 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  15862 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15866 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  15870 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  15874 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  15878 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15882 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  15886 */     // MIs[7] src0
     /*  15886 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15891 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  15895 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  15906 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  15910 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15914 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  15918 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  15922 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  15926 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15930 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  15934 */     // MIs[9] src1
     /*  15934 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  15939 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  15943 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  15954 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  15958 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  15962 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  15966 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  15970 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  15972 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  15976 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15980 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  15983 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  15988 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  15992 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  15996 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  15998 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  16002 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16006 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  16010 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  16014 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  16018 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16022 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  16026 */     // MIs[13] src0
     /*  16026 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16031 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  16035 */     GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
     /*  16046 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  16050 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16054 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  16058 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  16062 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  16066 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16070 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  16074 */     // MIs[15] src1
     /*  16074 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16079 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  16083 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  16094 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  16098 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16102 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  16106 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  16110 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  16112 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  16116 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16120 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  16123 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16128 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  16132 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  16136 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  16138 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  16142 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16146 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  16150 */     // MIs[18] src0
     /*  16150 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16155 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  16166 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  16170 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16174 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  16178 */     // MIs[19] src1
     /*  16178 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16183 */     GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
     /*  16194 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  16196 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  16196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  16199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  16201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  16208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  16215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
     /*  16222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16231 */     GIR_RootConstrainSelectedInstOperands,
     /*  16232 */     // GIR_Coverage, 8731,
     /*  16232 */     GIR_EraseRootFromParent_Done,
     /*  16233 */   // Label 199: @16233
     /*  16233 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(16732), // Rule ID 8730 //
     /*  16238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  16241 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  16243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  16247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  16258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  16271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  16273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16289 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  16293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  16297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  16305 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  16309 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  16313 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  16317 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16321 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  16325 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  16329 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  16331 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16335 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16339 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  16342 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16347 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  16351 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  16355 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  16361 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16365 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  16369 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  16373 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  16377 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16381 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  16385 */     // MIs[7] src0
     /*  16385 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16390 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  16394 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  16405 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  16409 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16413 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  16417 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  16421 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  16425 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16429 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  16433 */     // MIs[9] src1
     /*  16433 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16438 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  16442 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  16453 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  16457 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16461 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  16465 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  16469 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  16471 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  16475 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16479 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  16482 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16487 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  16491 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  16495 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  16497 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  16501 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16505 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  16509 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  16513 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  16517 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16521 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  16525 */     // MIs[13] src0
     /*  16525 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16530 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  16534 */     GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
     /*  16545 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  16549 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16553 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  16557 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  16561 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  16565 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16569 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  16573 */     // MIs[15] src1
     /*  16573 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16578 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  16582 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  16593 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  16597 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16601 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  16605 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  16609 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  16611 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
     /*  16615 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16619 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  16622 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16627 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  16631 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  16635 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  16637 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  16641 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16645 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  16649 */     // MIs[18] src0
     /*  16649 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16654 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  16665 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  16669 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16673 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  16677 */     // MIs[19] src1
     /*  16677 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16682 */     GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
     /*  16693 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  16695 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  16695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  16698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  16700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  16707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  16714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  16717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
     /*  16721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16730 */     GIR_RootConstrainSelectedInstOperands,
     /*  16731 */     // GIR_Coverage, 8730,
     /*  16731 */     GIR_EraseRootFromParent_Done,
     /*  16732 */   // Label 200: @16732
     /*  16732 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(17231), // Rule ID 8729 //
     /*  16737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  16740 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  16742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  16746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16754 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  16757 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16766 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  16770 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  16772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16788 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  16792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  16796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16800 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  16804 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  16808 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  16812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  16816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16820 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  16824 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  16828 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  16830 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16834 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16838 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  16841 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  16846 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  16850 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  16854 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  16856 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  16860 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16864 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  16868 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  16872 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  16876 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16880 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  16884 */     // MIs[7] src0
     /*  16884 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16889 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  16893 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  16904 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  16908 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16912 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  16916 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  16920 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  16924 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  16928 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  16932 */     // MIs[9] src1
     /*  16932 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  16937 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  16941 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  16952 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  16956 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16960 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  16964 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  16968 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  16970 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  16974 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16978 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  16982 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  16986 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  16988 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  16992 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16996 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  16999 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17004 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  17008 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  17014 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  17018 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17022 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  17026 */     // MIs[13] src0
     /*  17026 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17031 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  17042 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  17046 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17050 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  17054 */     // MIs[14] src1
     /*  17054 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17059 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  17070 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  17074 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17078 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  17081 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17086 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  17090 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  17094 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  17096 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  17100 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17104 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  17108 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  17112 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  17116 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17120 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  17124 */     // MIs[17] src0
     /*  17124 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17129 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  17133 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  17144 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  17148 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17152 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  17156 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  17160 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  17164 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17168 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  17172 */     // MIs[19] src1
     /*  17172 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17177 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  17181 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  17192 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  17194 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  17194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  17197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  17199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  17206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  17213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  17220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17229 */     GIR_RootConstrainSelectedInstOperands,
     /*  17230 */     // GIR_Coverage, 8729,
     /*  17230 */     GIR_EraseRootFromParent_Done,
     /*  17231 */   // Label 201: @17231
     /*  17231 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(17730), // Rule ID 8728 //
     /*  17236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  17239 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  17241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  17245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17253 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  17256 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17265 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  17269 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  17271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  17283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17287 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  17291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  17295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  17303 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  17307 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  17311 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  17315 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17319 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17323 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  17327 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  17329 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17333 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17337 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  17340 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17345 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  17349 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  17353 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  17355 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  17359 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17363 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  17367 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  17371 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  17375 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17379 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  17383 */     // MIs[7] src0
     /*  17383 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17388 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  17392 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  17403 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  17407 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17411 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  17415 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  17419 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  17423 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17427 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  17431 */     // MIs[9] src1
     /*  17431 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17436 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  17440 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  17451 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  17455 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17459 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  17463 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  17467 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  17469 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  17473 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17477 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  17481 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  17485 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  17487 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  17491 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17495 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  17498 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17503 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  17507 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  17511 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  17513 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  17517 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17521 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  17525 */     // MIs[13] src0
     /*  17525 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17530 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  17541 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  17545 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17549 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  17553 */     // MIs[14] src1
     /*  17553 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17558 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  17569 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  17573 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17577 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  17580 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17585 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  17589 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  17593 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  17595 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  17599 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17603 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  17607 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  17611 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  17615 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17619 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  17623 */     // MIs[17] src0
     /*  17623 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17628 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  17632 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  17643 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  17647 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17651 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  17655 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  17659 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  17663 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17667 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  17671 */     // MIs[19] src1
     /*  17671 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17676 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  17680 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  17691 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  17693 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  17693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  17696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  17698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  17705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  17712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  17715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  17719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17728 */     GIR_RootConstrainSelectedInstOperands,
     /*  17729 */     // GIR_Coverage, 8728,
     /*  17729 */     GIR_EraseRootFromParent_Done,
     /*  17730 */   // Label 202: @17730
     /*  17730 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(18229), // Rule ID 8727 //
     /*  17735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  17738 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  17740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  17744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  17755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  17768 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  17770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  17782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  17790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  17794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  17802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  17806 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  17810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  17814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17818 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  17822 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  17826 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  17828 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17832 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17836 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  17840 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  17844 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  17846 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  17850 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17854 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  17857 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  17862 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  17866 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  17870 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  17872 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  17876 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17880 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  17884 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  17888 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  17892 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17896 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  17900 */     // MIs[8] src0
     /*  17900 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17905 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  17909 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
     /*  17920 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  17924 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17928 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  17932 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  17936 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  17940 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  17944 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  17948 */     // MIs[10] src1
     /*  17948 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  17953 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  17957 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  17968 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  17972 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17976 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  17980 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  17984 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  17986 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  17990 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17994 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  17997 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18002 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  18006 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  18010 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  18012 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  18016 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18020 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  18024 */     // MIs[13] src0
     /*  18024 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18029 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  18040 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  18044 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18048 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  18052 */     // MIs[14] src1
     /*  18052 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18057 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  18068 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  18072 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18076 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  18079 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18084 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  18088 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  18092 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  18094 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  18098 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18102 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  18106 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  18110 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  18114 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18118 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  18122 */     // MIs[17] src0
     /*  18122 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18127 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  18131 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  18142 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  18146 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18150 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  18154 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  18158 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  18162 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18166 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  18170 */     // MIs[19] src1
     /*  18170 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18175 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  18179 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  18190 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  18192 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  18192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  18195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  18197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  18204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  18211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  18218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18227 */     GIR_RootConstrainSelectedInstOperands,
     /*  18228 */     // GIR_Coverage, 8727,
     /*  18228 */     GIR_EraseRootFromParent_Done,
     /*  18229 */   // Label 203: @18229
     /*  18229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(18728), // Rule ID 8726 //
     /*  18234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  18237 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  18239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  18243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18251 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  18254 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18263 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  18267 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  18269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18285 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  18289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  18293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18305 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  18309 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  18313 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18317 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  18321 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18325 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  18327 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18331 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18335 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  18339 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  18343 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  18345 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  18349 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18353 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  18356 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18361 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  18365 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  18369 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  18371 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  18375 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18379 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  18383 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  18387 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  18391 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18395 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  18399 */     // MIs[8] src0
     /*  18399 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18404 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  18408 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
     /*  18419 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  18423 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18427 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  18431 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  18435 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  18439 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18443 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  18447 */     // MIs[10] src1
     /*  18447 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18452 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  18456 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  18467 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  18471 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18475 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  18479 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  18483 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  18485 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  18489 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18493 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  18496 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18501 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  18505 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  18509 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  18511 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  18515 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18519 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  18523 */     // MIs[13] src0
     /*  18523 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18528 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  18539 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  18543 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18547 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  18551 */     // MIs[14] src1
     /*  18551 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18556 */     GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
     /*  18567 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  18571 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18575 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  18578 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18583 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  18587 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  18591 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  18593 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  18597 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18601 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  18605 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  18609 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  18613 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18617 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  18621 */     // MIs[17] src0
     /*  18621 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18626 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  18630 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  18641 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  18645 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18649 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  18653 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  18657 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  18661 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18665 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  18669 */     // MIs[19] src1
     /*  18669 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18674 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  18678 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  18689 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  18691 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  18691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  18694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  18696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  18703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  18710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  18713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  18717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18726 */     GIR_RootConstrainSelectedInstOperands,
     /*  18727 */     // GIR_Coverage, 8726,
     /*  18727 */     GIR_EraseRootFromParent_Done,
     /*  18728 */   // Label 204: @18728
     /*  18728 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(19227), // Rule ID 8725 //
     /*  18733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  18736 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  18738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  18742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18750 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  18753 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18762 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  18766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  18788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  18792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18804 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  18808 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  18812 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18816 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  18820 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18824 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  18826 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18830 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18834 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  18838 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  18842 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  18844 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  18848 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18852 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  18856 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  18860 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  18862 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  18866 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18870 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  18873 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18878 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  18882 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  18886 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  18888 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  18892 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18896 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  18900 */     // MIs[8] src0
     /*  18900 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18905 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  18916 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  18920 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18924 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  18928 */     // MIs[9] src1
     /*  18928 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  18933 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  18944 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  18948 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18952 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  18955 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  18960 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  18964 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  18968 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  18970 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  18974 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18978 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  18982 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  18986 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  18990 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18994 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  18998 */     // MIs[12] src0
     /*  18998 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19003 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  19007 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  19018 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  19022 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19026 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  19030 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  19034 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  19038 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19042 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  19046 */     // MIs[14] src1
     /*  19046 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19051 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  19055 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  19066 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  19070 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19074 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  19077 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19082 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  19090 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  19092 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  19096 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19100 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  19104 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  19108 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  19112 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19116 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  19120 */     // MIs[17] src0
     /*  19120 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19125 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  19129 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  19140 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  19144 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19148 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  19152 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  19156 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  19160 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19164 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     // MIs[19] src1
     /*  19168 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19173 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  19177 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  19188 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  19190 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  19190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  19193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  19195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  19202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  19209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
     /*  19216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19225 */     GIR_RootConstrainSelectedInstOperands,
     /*  19226 */     // GIR_Coverage, 8725,
     /*  19226 */     GIR_EraseRootFromParent_Done,
     /*  19227 */   // Label 205: @19227
     /*  19227 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(19726), // Rule ID 8724 //
     /*  19232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  19235 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  19237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  19241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19249 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  19252 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19261 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  19265 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  19267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19283 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  19291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19295 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19299 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19303 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  19307 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19311 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19315 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19319 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19323 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  19325 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19329 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19333 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  19337 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  19341 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  19343 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  19347 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19351 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  19359 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  19361 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  19365 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19369 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  19372 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19377 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  19381 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  19385 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  19387 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  19391 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19395 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  19399 */     // MIs[8] src0
     /*  19399 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19404 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  19415 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  19419 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19423 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  19427 */     // MIs[9] src1
     /*  19427 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19432 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  19443 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  19447 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19451 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  19454 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19459 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  19463 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  19467 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  19469 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  19473 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19477 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  19481 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  19485 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  19489 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19493 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  19497 */     // MIs[12] src0
     /*  19497 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19502 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  19506 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  19517 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  19521 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19525 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  19529 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  19533 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  19537 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19541 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  19545 */     // MIs[14] src1
     /*  19545 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19550 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  19554 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  19565 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  19569 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19573 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  19576 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19581 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  19585 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  19589 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  19591 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  19595 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19599 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  19603 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  19607 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  19611 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19615 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  19619 */     // MIs[17] src0
     /*  19619 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19624 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  19628 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  19639 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  19643 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19647 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  19651 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  19655 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  19659 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19663 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  19667 */     // MIs[19] src1
     /*  19667 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  19672 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  19676 */     GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
     /*  19687 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  19689 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  19689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  19692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  19694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  19701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  19708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  19711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
     /*  19715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  19724 */     GIR_RootConstrainSelectedInstOperands,
     /*  19725 */     // GIR_Coverage, 8724,
     /*  19725 */     GIR_EraseRootFromParent_Done,
     /*  19726 */   // Label 206: @19726
     /*  19726 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(20225), // Rule ID 8723 //
     /*  19731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  19734 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  19740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  19758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19766 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  19769 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19778 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  19782 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  19784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19796 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19800 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19804 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19808 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19812 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19816 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  19820 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19831 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  19835 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19839 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  19847 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  19851 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19855 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  19859 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  19863 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  19867 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  19878 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  19882 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19886 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  19890 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  19894 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  19896 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  19900 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19904 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  19907 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  19912 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  19916 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  19920 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  19922 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  19926 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19930 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  19934 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  19938 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  19942 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19946 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  19950 */     // MIs[10] src0
     /*  19950 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  19955 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  19959 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  19970 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  19974 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19978 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  19982 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  19986 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  19990 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19994 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  19998 */     // MIs[12] src1
     /*  19998 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20003 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  20007 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  20018 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  20022 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20026 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  20030 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  20034 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  20036 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  20040 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20044 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  20047 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20052 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  20056 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  20060 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  20062 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  20066 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20070 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  20074 */     // MIs[15] src0
     /*  20074 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20079 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  20090 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  20094 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20098 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  20102 */     // MIs[16] src1
     /*  20102 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20107 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  20118 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  20122 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20126 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  20129 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20134 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  20138 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  20142 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  20144 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  20148 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20152 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  20156 */     // MIs[18] src0
     /*  20156 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20161 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  20165 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  20169 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20173 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  20177 */     // MIs[19] src1
     /*  20177 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20182 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  20186 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  20188 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  20188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  20191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  20193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  20200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  20207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
     /*  20214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20223 */     GIR_RootConstrainSelectedInstOperands,
     /*  20224 */     // GIR_Coverage, 8723,
     /*  20224 */     GIR_EraseRootFromParent_Done,
     /*  20225 */   // Label 207: @20225
     /*  20225 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(20724), // Rule ID 8722 //
     /*  20230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  20233 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  20235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  20239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  20257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20265 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  20268 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20277 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  20281 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  20283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20291 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20295 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20307 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20311 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20315 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  20319 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  20330 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  20334 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20338 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  20342 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  20346 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  20350 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20354 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  20358 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  20362 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  20366 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  20377 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  20381 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20385 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  20389 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  20393 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  20395 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  20399 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20403 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  20406 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20411 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  20415 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  20419 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  20421 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  20425 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20429 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  20433 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  20437 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  20441 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20445 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  20449 */     // MIs[10] src0
     /*  20449 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20454 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  20458 */     GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
     /*  20469 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  20473 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20477 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  20481 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  20485 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  20489 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20493 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  20497 */     // MIs[12] src1
     /*  20497 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20502 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  20506 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  20517 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  20521 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20525 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  20529 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  20533 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  20535 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
     /*  20539 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20543 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  20546 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20551 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  20555 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  20559 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  20561 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  20565 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20569 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  20573 */     // MIs[15] src0
     /*  20573 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20578 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  20589 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  20593 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20597 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  20601 */     // MIs[16] src1
     /*  20601 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20606 */     GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
     /*  20617 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  20621 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20625 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  20628 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20633 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  20637 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  20641 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  20643 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  20647 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20651 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  20655 */     // MIs[18] src0
     /*  20655 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20660 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  20664 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  20668 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20672 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  20676 */     // MIs[19] src1
     /*  20676 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20681 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  20685 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  20687 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  20687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  20690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  20692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  20699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  20706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  20709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
     /*  20713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20722 */     GIR_RootConstrainSelectedInstOperands,
     /*  20723 */     // GIR_Coverage, 8722,
     /*  20723 */     GIR_EraseRootFromParent_Done,
     /*  20724 */   // Label 208: @20724
     /*  20724 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(21223), // Rule ID 8721 //
     /*  20729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  20732 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  20734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  20738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  20756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  20760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20764 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  20767 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20776 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  20780 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  20782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  20786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20802 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20806 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20810 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20814 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  20818 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  20829 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  20833 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20837 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  20841 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  20845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  20849 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20853 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  20857 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  20861 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  20865 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  20876 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  20880 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20884 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  20888 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  20892 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  20894 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  20898 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  20902 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  20906 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  20910 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  20912 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  20916 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20920 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  20923 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  20928 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  20932 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  20936 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  20938 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  20942 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20946 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  20950 */     // MIs[10] src0
     /*  20950 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  20955 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  20966 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  20970 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20974 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  20978 */     // MIs[11] src1
     /*  20978 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  20983 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  20994 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  20998 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21002 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  21005 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21010 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  21014 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  21018 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  21020 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  21024 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21028 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  21032 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  21036 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  21040 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21044 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  21048 */     // MIs[14] src0
     /*  21048 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21053 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  21057 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  21068 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  21072 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21076 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  21080 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  21084 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  21088 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21092 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  21096 */     // MIs[16] src1
     /*  21096 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21101 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  21105 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  21116 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  21120 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21124 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  21127 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21132 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  21136 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  21140 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  21142 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  21146 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21150 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  21154 */     // MIs[18] src0
     /*  21154 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21159 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  21163 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  21167 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21171 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  21175 */     // MIs[19] src1
     /*  21175 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21180 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  21184 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  21186 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  21186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  21189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  21191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  21198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  21205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  21212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21221 */     GIR_RootConstrainSelectedInstOperands,
     /*  21222 */     // GIR_Coverage, 8721,
     /*  21222 */     GIR_EraseRootFromParent_Done,
     /*  21223 */   // Label 209: @21223
     /*  21223 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(21722), // Rule ID 8720 //
     /*  21228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  21231 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  21233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  21237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  21255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21263 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  21266 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21275 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  21279 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  21281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21289 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21293 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21297 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21301 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21305 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  21309 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  21313 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  21317 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  21328 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  21332 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21336 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  21340 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  21344 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  21348 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21352 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  21356 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  21360 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  21364 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  21375 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  21379 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21383 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  21387 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  21391 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  21393 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  21397 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21401 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  21405 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  21409 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  21411 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  21415 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21419 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  21422 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21427 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  21431 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  21435 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  21437 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  21441 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21445 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     // MIs[10] src0
     /*  21449 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21454 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  21465 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  21469 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21473 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  21477 */     // MIs[11] src1
     /*  21477 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21482 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  21493 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  21497 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21501 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  21504 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21509 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  21513 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  21517 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  21519 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  21523 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21527 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  21531 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  21535 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  21539 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21543 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  21547 */     // MIs[14] src0
     /*  21547 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21552 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  21556 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  21567 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  21571 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21575 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  21579 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  21583 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  21587 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21591 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  21595 */     // MIs[16] src1
     /*  21595 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21600 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  21604 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  21615 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  21619 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21623 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  21626 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21631 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  21635 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  21639 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  21641 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  21645 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21649 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  21653 */     // MIs[18] src0
     /*  21653 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  21658 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  21662 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  21666 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21670 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  21674 */     // MIs[19] src1
     /*  21674 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  21679 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  21683 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  21685 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  21685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  21688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  21690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  21697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  21704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  21707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  21711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21720 */     GIR_RootConstrainSelectedInstOperands,
     /*  21721 */     // GIR_Coverage, 8720,
     /*  21721 */     GIR_EraseRootFromParent_Done,
     /*  21722 */   // Label 210: @21722
     /*  21722 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(22221), // Rule ID 8719 //
     /*  21727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  21730 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  21732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  21736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  21754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21770 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21780 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  21783 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21792 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  21796 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  21798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  21802 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21806 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  21810 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  21814 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21818 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21822 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  21826 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  21830 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  21834 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  21845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  21849 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21853 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  21857 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  21861 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  21865 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21869 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  21877 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  21881 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  21892 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  21896 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  21900 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  21904 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  21908 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  21910 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  21914 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  21918 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  21921 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  21926 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  21930 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  21934 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  21936 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  21940 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21944 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  21948 */     // MIs[10] src0
     /*  21948 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  21953 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  21968 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  21976 */     // MIs[11] src1
     /*  21976 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  21981 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  21992 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  21996 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22000 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  22003 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22008 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  22012 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  22016 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  22018 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  22022 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22026 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  22030 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  22034 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  22038 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22042 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  22046 */     // MIs[14] src0
     /*  22046 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22051 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  22055 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  22066 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  22070 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22074 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  22078 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  22082 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  22086 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22090 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  22094 */     // MIs[16] src1
     /*  22094 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22099 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  22103 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  22114 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  22118 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22122 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  22125 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22130 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  22134 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  22138 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  22140 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  22144 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22148 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  22152 */     // MIs[18] src0
     /*  22152 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22157 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  22161 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  22165 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22169 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  22173 */     // MIs[19] src1
     /*  22173 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22178 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  22182 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  22184 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  22184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  22187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  22189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  22196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  22203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  22210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22219 */     GIR_RootConstrainSelectedInstOperands,
     /*  22220 */     // GIR_Coverage, 8719,
     /*  22220 */     GIR_EraseRootFromParent_Done,
     /*  22221 */   // Label 211: @22221
     /*  22221 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(22720), // Rule ID 8718 //
     /*  22226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  22229 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  22231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  22235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  22253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  22269 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  22271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22279 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  22282 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22287 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22291 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  22295 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  22297 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  22301 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22305 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  22309 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  22313 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22317 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22321 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  22325 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  22329 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  22333 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  22344 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  22348 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22352 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  22356 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  22360 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  22364 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22368 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  22372 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  22376 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  22380 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  22391 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  22395 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22399 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  22403 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  22407 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  22409 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  22413 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22417 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  22420 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22425 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  22429 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  22433 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  22435 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  22439 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22443 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  22447 */     // MIs[10] src0
     /*  22447 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22452 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  22463 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  22467 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22471 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  22475 */     // MIs[11] src1
     /*  22475 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22480 */     GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
     /*  22491 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  22495 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22499 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  22502 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22507 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  22511 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  22515 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  22517 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  22521 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22525 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  22529 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  22533 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  22537 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22541 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  22545 */     // MIs[14] src0
     /*  22545 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22550 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  22554 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  22565 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  22569 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22573 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  22577 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  22581 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  22585 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22589 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  22593 */     // MIs[16] src1
     /*  22593 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22598 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  22602 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  22613 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  22617 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22621 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  22624 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22629 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  22633 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  22637 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  22639 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  22643 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22647 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  22651 */     // MIs[18] src0
     /*  22651 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22656 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  22664 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22668 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  22672 */     // MIs[19] src1
     /*  22672 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  22677 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  22681 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  22683 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  22683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  22686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  22688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  22695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  22702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  22705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  22709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  22718 */     GIR_RootConstrainSelectedInstOperands,
     /*  22719 */     // GIR_Coverage, 8718,
     /*  22719 */     GIR_EraseRootFromParent_Done,
     /*  22720 */   // Label 212: @22720
     /*  22720 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(23219), // Rule ID 8717 //
     /*  22725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  22728 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  22730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  22734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  22752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  22764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  22768 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  22770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  22774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  22778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22782 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22786 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  22788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22792 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22796 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  22799 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22804 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  22808 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  22812 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  22814 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22818 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22822 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  22826 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  22830 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  22841 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  22845 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22849 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  22853 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  22857 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  22868 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  22872 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22876 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  22879 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  22884 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  22888 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  22892 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  22894 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  22898 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22902 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  22906 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  22910 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  22914 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22918 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  22922 */     // MIs[9] src0
     /*  22922 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  22927 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  22931 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  22942 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  22946 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22950 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  22954 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  22958 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  22962 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22966 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  22970 */     // MIs[11] src1
     /*  22970 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  22975 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  22979 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  22990 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  22994 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  22998 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  23001 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23006 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  23010 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  23014 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  23016 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  23020 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23024 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  23028 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  23032 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  23036 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23040 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  23044 */     // MIs[14] src0
     /*  23044 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23049 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  23053 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  23064 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  23068 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23072 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  23076 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  23080 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  23084 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23088 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  23092 */     // MIs[16] src1
     /*  23092 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23097 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  23101 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  23112 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  23116 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23120 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  23123 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23128 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  23132 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  23136 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  23138 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  23142 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23146 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  23150 */     // MIs[18] src0
     /*  23150 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23155 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  23159 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  23163 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23167 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  23171 */     // MIs[19] src1
     /*  23171 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23176 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  23180 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  23182 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  23182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  23185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  23187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  23194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  23201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  23208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23217 */     GIR_RootConstrainSelectedInstOperands,
     /*  23218 */     // GIR_Coverage, 8717,
     /*  23218 */     GIR_EraseRootFromParent_Done,
     /*  23219 */   // Label 213: @23219
     /*  23219 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(23718), // Rule ID 2771 //
     /*  23224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /*  23227 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  23229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  23233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  23245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  23249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  23251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  23263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  23267 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  23269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  23273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  23281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  23285 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  23287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  23291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23295 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  23298 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23303 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  23307 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  23311 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  23313 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23317 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23321 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  23325 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  23329 */     GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
     /*  23340 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  23344 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23348 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  23352 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  23356 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
     /*  23367 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  23371 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23375 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  23378 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23383 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  23387 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  23391 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  23393 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  23397 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23401 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  23405 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  23409 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  23413 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23417 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  23421 */     // MIs[9] src0
     /*  23421 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23426 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  23430 */     GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
     /*  23441 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  23445 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23449 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  23453 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  23457 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  23461 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23465 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  23469 */     // MIs[11] src1
     /*  23469 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23474 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  23478 */     GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
     /*  23489 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  23493 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23497 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  23500 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23505 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  23509 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  23513 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  23515 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  23519 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23523 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  23527 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  23531 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  23535 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23539 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  23543 */     // MIs[14] src0
     /*  23543 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23548 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  23552 */     GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
     /*  23563 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  23567 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23571 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  23575 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  23579 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  23583 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23587 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  23591 */     // MIs[16] src1
     /*  23591 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23596 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  23600 */     GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
     /*  23611 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  23615 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23619 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  23622 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  23627 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  23631 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  23635 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  23637 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  23641 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23645 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  23649 */     // MIs[18] src0
     /*  23649 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  23654 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  23658 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  23662 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23666 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  23670 */     // MIs[19] src1
     /*  23670 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  23675 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  23679 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  23681 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  23681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /*  23684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  23686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  23693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  23700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  23703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  23707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23716 */     GIR_RootConstrainSelectedInstOperands,
     /*  23717 */     // GIR_Coverage, 2771,
     /*  23717 */     GIR_EraseRootFromParent_Done,
     /*  23718 */   // Label 214: @23718
     /*  23718 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(24193), // Rule ID 10011 //
     /*  23723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  23726 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  23728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  23732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23740 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23743 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  23748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  23752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  23756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  23758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  23766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  23770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  23774 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  23778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  23782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  23786 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  23790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  23794 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  23798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  23802 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23806 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  23810 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  23814 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  23816 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  23820 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23824 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  23827 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  23832 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  23836 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  23840 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  23842 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  23846 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  23850 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  23854 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  23858 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23862 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  23866 */     // MIs[7] src0
     /*  23866 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23871 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  23875 */     // MIs[6] Operand 2
     /*  23875 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  23886 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  23890 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  23894 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  23898 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  23902 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23906 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  23910 */     // MIs[9] src1
     /*  23910 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  23915 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  23919 */     // MIs[8] Operand 2
     /*  23919 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  23930 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  23934 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  23938 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  23942 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  23946 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  23948 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  23952 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23956 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  23959 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  23964 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  23968 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  23972 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  23974 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  23978 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  23982 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  23986 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  23990 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  23994 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  23998 */     // MIs[13] src0
     /*  23998 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24003 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  24007 */     // MIs[12] Operand 2
     /*  24007 */     GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
     /*  24018 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  24022 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24026 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  24030 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  24034 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24038 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  24042 */     // MIs[15] src1
     /*  24042 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24047 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  24051 */     // MIs[14] Operand 2
     /*  24051 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  24062 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  24066 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24070 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  24074 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  24078 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  24080 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  24084 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24088 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  24091 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24096 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  24100 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  24104 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  24106 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  24110 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24114 */     // MIs[18] src0
     /*  24114 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24119 */     // MIs[18] Operand 2
     /*  24119 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  24130 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  24134 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24138 */     // MIs[19] src1
     /*  24138 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24143 */     // MIs[19] Operand 2
     /*  24143 */     GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
     /*  24154 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  24156 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  24156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  24159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  24161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  24168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  24175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
     /*  24182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24191 */     GIR_RootConstrainSelectedInstOperands,
     /*  24192 */     // GIR_Coverage, 10011,
     /*  24192 */     GIR_EraseRootFromParent_Done,
     /*  24193 */   // Label 215: @24193
     /*  24193 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(24668), // Rule ID 10010 //
     /*  24198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  24201 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  24203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  24207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24215 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24218 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  24227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  24231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  24233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  24245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  24249 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  24253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  24257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  24265 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  24269 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  24273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  24277 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24281 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  24285 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  24289 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  24291 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  24295 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24299 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24302 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24307 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24311 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24315 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24317 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24321 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24325 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24329 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24333 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24337 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24341 */     // MIs[7] src0
     /*  24341 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24346 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  24350 */     // MIs[6] Operand 2
     /*  24350 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  24361 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  24365 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24369 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  24373 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  24377 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24381 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  24385 */     // MIs[9] src1
     /*  24385 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24390 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  24394 */     // MIs[8] Operand 2
     /*  24394 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  24405 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  24409 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24413 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  24417 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  24421 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  24423 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  24427 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24431 */     GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
     /*  24434 */     GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24439 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  24443 */     GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
     /*  24447 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  24449 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  24453 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24457 */     GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
     /*  24461 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
     /*  24465 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24469 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  24473 */     // MIs[13] src0
     /*  24473 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24478 */     GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
     /*  24482 */     // MIs[12] Operand 2
     /*  24482 */     GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
     /*  24493 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
     /*  24497 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24501 */     GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
     /*  24505 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
     /*  24509 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24513 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  24517 */     // MIs[15] src1
     /*  24517 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24522 */     GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
     /*  24526 */     // MIs[14] Operand 2
     /*  24526 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  24537 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
     /*  24541 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24545 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  24549 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  24553 */     GIM_CheckHasOneUse, /*MI*/16,
     /*  24555 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
     /*  24559 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24563 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  24566 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24571 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  24575 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  24579 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  24581 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  24585 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24589 */     // MIs[18] src0
     /*  24589 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24594 */     // MIs[18] Operand 2
     /*  24594 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  24605 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  24609 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24613 */     // MIs[19] src1
     /*  24613 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24618 */     // MIs[19] Operand 2
     /*  24618 */     GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
     /*  24629 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  24631 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  24631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  24634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  24636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  24643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  24650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  24653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
     /*  24657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24666 */     GIR_RootConstrainSelectedInstOperands,
     /*  24667 */     // GIR_Coverage, 10010,
     /*  24667 */     GIR_EraseRootFromParent_Done,
     /*  24668 */   // Label 216: @24668
     /*  24668 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(25143), // Rule ID 10009 //
     /*  24673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  24676 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  24678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  24682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24690 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24693 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  24702 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  24706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  24708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  24720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  24724 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  24728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  24732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  24736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  24740 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  24744 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  24748 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  24752 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24756 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  24760 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  24764 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  24766 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  24770 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24774 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  24777 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24782 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  24786 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  24790 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  24792 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  24796 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24800 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  24804 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  24808 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24812 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  24816 */     // MIs[7] src0
     /*  24816 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24821 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  24825 */     // MIs[6] Operand 2
     /*  24825 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  24836 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  24840 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24844 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  24848 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  24852 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  24856 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  24860 */     // MIs[9] src1
     /*  24860 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24865 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  24869 */     // MIs[8] Operand 2
     /*  24869 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  24880 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  24884 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24888 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  24892 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  24896 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  24898 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  24902 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  24906 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  24910 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  24914 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  24916 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  24920 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24924 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  24927 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  24932 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  24936 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  24940 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  24942 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  24946 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24950 */     // MIs[13] src0
     /*  24950 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24955 */     // MIs[13] Operand 2
     /*  24955 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  24966 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  24970 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  24974 */     // MIs[14] src1
     /*  24974 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  24979 */     // MIs[14] Operand 2
     /*  24979 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  24990 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  24994 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24998 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  25001 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25006 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  25010 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  25014 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  25016 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  25020 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25024 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  25028 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  25032 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25036 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  25040 */     // MIs[17] src0
     /*  25040 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25045 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  25049 */     // MIs[16] Operand 2
     /*  25049 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  25060 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  25064 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25068 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  25072 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  25076 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25080 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  25084 */     // MIs[19] src1
     /*  25084 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25089 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  25093 */     // MIs[18] Operand 2
     /*  25093 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  25104 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  25106 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  25106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  25109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  25111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  25118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  25125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  25132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25141 */     GIR_RootConstrainSelectedInstOperands,
     /*  25142 */     // GIR_Coverage, 10009,
     /*  25142 */     GIR_EraseRootFromParent_Done,
     /*  25143 */   // Label 217: @25143
     /*  25143 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(25618), // Rule ID 10008 //
     /*  25148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  25151 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  25153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  25157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  25168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  25177 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  25181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  25183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  25195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  25199 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  25203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  25207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25211 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  25215 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  25219 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  25223 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  25227 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25231 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  25235 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  25239 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  25245 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25249 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  25252 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25257 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  25261 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  25265 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  25267 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  25271 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25275 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  25279 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  25283 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25287 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  25291 */     // MIs[7] src0
     /*  25291 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25296 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  25300 */     // MIs[6] Operand 2
     /*  25300 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  25311 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
     /*  25315 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25319 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  25323 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  25327 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25331 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  25335 */     // MIs[9] src1
     /*  25335 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25340 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
     /*  25344 */     // MIs[8] Operand 2
     /*  25344 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  25355 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
     /*  25359 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25363 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  25367 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  25371 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  25373 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  25377 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25381 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  25385 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  25389 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  25391 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  25395 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25399 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  25402 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25407 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  25411 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  25415 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  25417 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  25421 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25425 */     // MIs[13] src0
     /*  25425 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25430 */     // MIs[13] Operand 2
     /*  25430 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  25441 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  25445 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25449 */     // MIs[14] src1
     /*  25449 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25454 */     // MIs[14] Operand 2
     /*  25454 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  25465 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
     /*  25469 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25473 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  25476 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25481 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  25485 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  25489 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  25491 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  25495 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25499 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  25503 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  25507 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25511 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  25515 */     // MIs[17] src0
     /*  25515 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25520 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
     /*  25524 */     // MIs[16] Operand 2
     /*  25524 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  25535 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  25539 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25543 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  25547 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  25551 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25555 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  25559 */     // MIs[19] src1
     /*  25559 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25564 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
     /*  25568 */     // MIs[18] Operand 2
     /*  25568 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  25579 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  25581 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  25581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  25584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  25586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  25593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  25600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  25603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  25607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25616 */     GIR_RootConstrainSelectedInstOperands,
     /*  25617 */     // GIR_Coverage, 10008,
     /*  25617 */     GIR_EraseRootFromParent_Done,
     /*  25618 */   // Label 218: @25618
     /*  25618 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(26093), // Rule ID 10007 //
     /*  25623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  25626 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  25628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  25632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25640 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  25643 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  25652 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  25656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  25658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  25670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  25674 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  25682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  25686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  25690 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  25694 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  25698 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  25702 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25706 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  25710 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  25714 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  25716 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  25720 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25724 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  25728 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  25732 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  25734 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25738 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25742 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  25745 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25750 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  25754 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  25758 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  25760 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  25764 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25768 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  25772 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  25776 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25780 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  25784 */     // MIs[8] src0
     /*  25784 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25789 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  25793 */     // MIs[7] Operand 2
     /*  25793 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
     /*  25804 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  25808 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25812 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  25816 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  25820 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25824 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  25828 */     // MIs[10] src1
     /*  25828 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25833 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  25837 */     // MIs[9] Operand 2
     /*  25837 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  25848 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  25852 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  25856 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  25860 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  25864 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  25866 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  25870 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25874 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  25877 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25882 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  25886 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  25890 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  25892 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  25896 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25900 */     // MIs[13] src0
     /*  25900 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25905 */     // MIs[13] Operand 2
     /*  25905 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  25916 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  25920 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25924 */     // MIs[14] src1
     /*  25924 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25929 */     // MIs[14] Operand 2
     /*  25929 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  25940 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  25944 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25948 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  25951 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  25956 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  25960 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  25964 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  25966 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  25970 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  25974 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  25978 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  25982 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  25986 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  25990 */     // MIs[17] src0
     /*  25990 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25995 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  25999 */     // MIs[16] Operand 2
     /*  25999 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  26010 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  26014 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26018 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  26022 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  26026 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26030 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  26034 */     // MIs[19] src1
     /*  26034 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26039 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  26043 */     // MIs[18] Operand 2
     /*  26043 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  26054 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  26056 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  26056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  26059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  26061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  26068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  26075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
     /*  26082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26091 */     GIR_RootConstrainSelectedInstOperands,
     /*  26092 */     // GIR_Coverage, 10007,
     /*  26092 */     GIR_EraseRootFromParent_Done,
     /*  26093 */   // Label 219: @26093
     /*  26093 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(26568), // Rule ID 10006 //
     /*  26098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  26101 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  26103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  26107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26115 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  26118 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26127 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  26131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  26133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  26153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  26157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26161 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  26165 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  26169 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  26173 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  26177 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26181 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  26185 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  26189 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  26191 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  26195 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26199 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  26203 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  26207 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  26209 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26213 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26217 */     GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
     /*  26220 */     GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26225 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  26229 */     GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
     /*  26233 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  26235 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  26239 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26243 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  26247 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  26251 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26255 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  26259 */     // MIs[8] src0
     /*  26259 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26264 */     GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
     /*  26268 */     // MIs[7] Operand 2
     /*  26268 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
     /*  26279 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
     /*  26283 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26287 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  26291 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  26295 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26299 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26303 */     // MIs[10] src1
     /*  26303 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26308 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  26312 */     // MIs[9] Operand 2
     /*  26312 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26323 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
     /*  26327 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26331 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26335 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  26339 */     GIM_CheckHasOneUse, /*MI*/11,
     /*  26341 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
     /*  26345 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26349 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  26352 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26357 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  26361 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  26365 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  26367 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  26371 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26375 */     // MIs[13] src0
     /*  26375 */     GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26380 */     // MIs[13] Operand 2
     /*  26380 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  26391 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
     /*  26395 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26399 */     // MIs[14] src1
     /*  26399 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26404 */     // MIs[14] Operand 2
     /*  26404 */     GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
     /*  26415 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  26419 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26423 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  26426 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26431 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  26435 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  26439 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  26441 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  26445 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26449 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  26453 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  26457 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26461 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  26465 */     // MIs[17] src0
     /*  26465 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26470 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  26474 */     // MIs[16] Operand 2
     /*  26474 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  26485 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  26489 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26493 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  26497 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  26501 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26505 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  26509 */     // MIs[19] src1
     /*  26509 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26514 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  26518 */     // MIs[18] Operand 2
     /*  26518 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  26529 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  26531 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  26531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  26534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  26536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  26543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  26550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  26553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
     /*  26557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26566 */     GIR_RootConstrainSelectedInstOperands,
     /*  26567 */     // GIR_Coverage, 10006,
     /*  26567 */     GIR_EraseRootFromParent_Done,
     /*  26568 */   // Label 220: @26568
     /*  26568 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(27043), // Rule ID 10005 //
     /*  26573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  26576 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  26578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  26582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26590 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  26593 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26602 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  26606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  26608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  26620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26624 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  26628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  26632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  26636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  26640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  26644 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  26648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  26652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26656 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  26660 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  26664 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  26666 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  26670 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26674 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  26678 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  26682 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  26684 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26688 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26692 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  26696 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  26700 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  26702 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  26706 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26710 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  26713 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26718 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  26722 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  26726 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  26728 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  26732 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26736 */     // MIs[8] src0
     /*  26736 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26741 */     // MIs[8] Operand 2
     /*  26741 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  26752 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  26756 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26760 */     // MIs[9] src1
     /*  26760 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26765 */     // MIs[9] Operand 2
     /*  26765 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  26776 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  26780 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26784 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  26787 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26792 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  26796 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  26800 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  26802 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  26806 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26810 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  26814 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  26818 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26822 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  26826 */     // MIs[12] src0
     /*  26826 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26831 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  26835 */     // MIs[11] Operand 2
     /*  26835 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  26846 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  26850 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26854 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  26858 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  26862 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26866 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  26870 */     // MIs[14] src1
     /*  26870 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26875 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  26879 */     // MIs[13] Operand 2
     /*  26879 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  26890 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  26894 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26898 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  26901 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  26906 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  26910 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  26914 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  26916 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  26920 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26924 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  26928 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  26932 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26936 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  26940 */     // MIs[17] src0
     /*  26940 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  26945 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  26949 */     // MIs[16] Operand 2
     /*  26949 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  26960 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  26964 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  26968 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  26972 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  26976 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  26980 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  26984 */     // MIs[19] src1
     /*  26984 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26989 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  26993 */     // MIs[18] Operand 2
     /*  26993 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  27004 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  27006 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  27006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  27009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  27011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  27018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  27025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
     /*  27032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27041 */     GIR_RootConstrainSelectedInstOperands,
     /*  27042 */     // GIR_Coverage, 10005,
     /*  27042 */     GIR_EraseRootFromParent_Done,
     /*  27043 */   // Label 221: @27043
     /*  27043 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(27518), // Rule ID 10004 //
     /*  27048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  27051 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  27053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  27057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27065 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  27068 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27077 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  27081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  27083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  27095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27099 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  27103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  27107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  27115 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  27119 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  27123 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  27127 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27131 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  27135 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  27139 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  27141 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  27145 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27149 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  27153 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  27157 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  27159 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27163 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27167 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  27171 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  27175 */     GIM_CheckHasOneUse, /*MI*/6,
     /*  27177 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
     /*  27181 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27185 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  27188 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27193 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  27197 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  27201 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  27203 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  27207 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27211 */     // MIs[8] src0
     /*  27211 */     GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27216 */     // MIs[8] Operand 2
     /*  27216 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  27227 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
     /*  27231 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27235 */     // MIs[9] src1
     /*  27235 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27240 */     // MIs[9] Operand 2
     /*  27240 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  27251 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
     /*  27255 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27259 */     GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
     /*  27262 */     GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27267 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  27271 */     GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
     /*  27275 */     GIM_CheckHasOneUse, /*MI*/10,
     /*  27277 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
     /*  27281 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27285 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  27289 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  27293 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27297 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27301 */     // MIs[12] src0
     /*  27301 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27306 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27310 */     // MIs[11] Operand 2
     /*  27310 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27321 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
     /*  27325 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27329 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27333 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27337 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27341 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  27345 */     // MIs[14] src1
     /*  27345 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27350 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  27354 */     // MIs[13] Operand 2
     /*  27354 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  27365 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
     /*  27369 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27373 */     GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
     /*  27376 */     GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27381 */     GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
     /*  27385 */     GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
     /*  27389 */     GIM_CheckHasOneUse, /*MI*/15,
     /*  27391 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
     /*  27395 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27399 */     GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
     /*  27403 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
     /*  27407 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27411 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  27415 */     // MIs[17] src0
     /*  27415 */     GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27420 */     GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
     /*  27424 */     // MIs[16] Operand 2
     /*  27424 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  27435 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
     /*  27439 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27443 */     GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
     /*  27447 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
     /*  27451 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27455 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  27459 */     // MIs[19] src1
     /*  27459 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27464 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
     /*  27468 */     // MIs[18] Operand 2
     /*  27468 */     GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
     /*  27479 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  27481 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  27481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  27484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  27486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  27493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  27500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
     /*  27507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27516 */     GIR_RootConstrainSelectedInstOperands,
     /*  27517 */     // GIR_Coverage, 10004,
     /*  27517 */     GIR_EraseRootFromParent_Done,
     /*  27518 */   // Label 222: @27518
     /*  27518 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(27993), // Rule ID 10003 //
     /*  27523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  27526 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  27528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  27532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  27550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27558 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27561 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27570 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  27574 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  27576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  27588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  27592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27596 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  27600 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  27604 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  27608 */     // MIs[3] Operand 2
     /*  27608 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  27619 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  27623 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27627 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  27631 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27635 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27639 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  27643 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  27647 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  27651 */     // MIs[5] Operand 2
     /*  27651 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  27662 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  27666 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27670 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  27674 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  27678 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  27680 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  27684 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27688 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  27691 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27696 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  27700 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  27704 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  27706 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  27710 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27714 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  27718 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  27722 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27726 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  27730 */     // MIs[10] src0
     /*  27730 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  27735 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  27739 */     // MIs[9] Operand 2
     /*  27739 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  27750 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  27754 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27758 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  27762 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  27766 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  27770 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  27774 */     // MIs[12] src1
     /*  27774 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  27779 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  27783 */     // MIs[11] Operand 2
     /*  27783 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  27794 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  27798 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27802 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  27806 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  27810 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  27812 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  27816 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27820 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  27823 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27828 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  27832 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  27836 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  27838 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  27842 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27846 */     // MIs[15] src0
     /*  27846 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  27851 */     // MIs[15] Operand 2
     /*  27851 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  27862 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  27866 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  27870 */     // MIs[16] src1
     /*  27870 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  27875 */     // MIs[16] Operand 2
     /*  27875 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  27886 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  27890 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27894 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  27897 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  27902 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  27906 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  27910 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  27912 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  27916 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27920 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  27924 */     // MIs[18] src0
     /*  27924 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  27929 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  27933 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  27937 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  27941 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  27945 */     // MIs[19] src1
     /*  27945 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  27950 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  27954 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  27956 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  27956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  27959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  27961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  27968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  27975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  27978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
     /*  27982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  27991 */     GIR_RootConstrainSelectedInstOperands,
     /*  27992 */     // GIR_Coverage, 10003,
     /*  27992 */     GIR_EraseRootFromParent_Done,
     /*  27993 */   // Label 223: @27993
     /*  27993 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(28468), // Rule ID 10002 //
     /*  27998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  28001 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  28003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  28007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  28019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  28023 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  28025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28033 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28036 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  28045 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  28049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  28051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28059 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  28063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  28067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28071 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  28075 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  28079 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  28083 */     // MIs[3] Operand 2
     /*  28083 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  28094 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  28098 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28102 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  28106 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28110 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28114 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  28118 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  28122 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  28126 */     // MIs[5] Operand 2
     /*  28126 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  28137 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  28141 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28145 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  28149 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  28153 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  28155 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  28159 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28163 */     GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
     /*  28166 */     GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28171 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  28175 */     GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
     /*  28179 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  28181 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  28185 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28189 */     GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
     /*  28193 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
     /*  28197 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28201 */     GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
     /*  28205 */     // MIs[10] src0
     /*  28205 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28210 */     GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
     /*  28214 */     // MIs[9] Operand 2
     /*  28214 */     GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
     /*  28225 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
     /*  28229 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28233 */     GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
     /*  28237 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
     /*  28241 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28245 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  28249 */     // MIs[12] src1
     /*  28249 */     GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28254 */     GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
     /*  28258 */     // MIs[11] Operand 2
     /*  28258 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  28269 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
     /*  28273 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28277 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  28281 */     GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
     /*  28285 */     GIM_CheckHasOneUse, /*MI*/13,
     /*  28287 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
     /*  28291 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28295 */     GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
     /*  28298 */     GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28303 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28307 */     GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
     /*  28311 */     GIM_CheckHasOneUse, /*MI*/14,
     /*  28313 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
     /*  28317 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28321 */     // MIs[15] src0
     /*  28321 */     GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28326 */     // MIs[15] Operand 2
     /*  28326 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  28337 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
     /*  28341 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28345 */     // MIs[16] src1
     /*  28345 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28350 */     // MIs[16] Operand 2
     /*  28350 */     GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
     /*  28361 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  28365 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28369 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  28372 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28377 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  28381 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  28385 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  28387 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  28391 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28395 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  28399 */     // MIs[18] src0
     /*  28399 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28404 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  28408 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  28412 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28416 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  28420 */     // MIs[19] src1
     /*  28420 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28425 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  28429 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  28431 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  28431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  28434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  28436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  28443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  28450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
     /*  28457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28466 */     GIR_RootConstrainSelectedInstOperands,
     /*  28467 */     // GIR_Coverage, 10002,
     /*  28467 */     GIR_EraseRootFromParent_Done,
     /*  28468 */   // Label 224: @28468
     /*  28468 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(28943), // Rule ID 10001 //
     /*  28473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  28476 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  28478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  28482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  28494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  28498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  28500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28508 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28511 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  28520 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  28524 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  28526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  28538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  28542 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28546 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  28550 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  28554 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  28558 */     // MIs[3] Operand 2
     /*  28558 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  28569 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  28573 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28577 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  28581 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28585 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28589 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  28593 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  28597 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  28601 */     // MIs[5] Operand 2
     /*  28601 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  28612 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  28616 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28620 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  28624 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  28628 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  28630 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  28634 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28638 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  28642 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  28646 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  28648 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  28652 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28656 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  28659 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28664 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  28668 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  28672 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  28674 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  28678 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28682 */     // MIs[10] src0
     /*  28682 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28687 */     // MIs[10] Operand 2
     /*  28687 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  28698 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  28702 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28706 */     // MIs[11] src1
     /*  28706 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28711 */     // MIs[11] Operand 2
     /*  28711 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  28722 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  28726 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28730 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  28733 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28738 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  28742 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  28746 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  28748 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  28752 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28756 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  28760 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  28764 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28768 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  28772 */     // MIs[14] src0
     /*  28772 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28777 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  28781 */     // MIs[13] Operand 2
     /*  28781 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  28792 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  28796 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  28800 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  28804 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  28808 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  28812 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  28816 */     // MIs[16] src1
     /*  28816 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28821 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  28825 */     // MIs[15] Operand 2
     /*  28825 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  28836 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  28840 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28844 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  28847 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28852 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  28856 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  28860 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  28862 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  28866 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28870 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  28874 */     // MIs[18] src0
     /*  28874 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  28879 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  28883 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  28887 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  28891 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  28895 */     // MIs[19] src1
     /*  28895 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  28900 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  28904 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  28906 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  28906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  28909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  28911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  28918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  28925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  28928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  28932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  28941 */     GIR_RootConstrainSelectedInstOperands,
     /*  28942 */     // GIR_Coverage, 10001,
     /*  28942 */     GIR_EraseRootFromParent_Done,
     /*  28943 */   // Label 225: @28943
     /*  28943 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(29418), // Rule ID 10000 //
     /*  28948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  28951 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  28953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  28957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  28969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  28973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  28975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28983 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28986 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  28991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  28995 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  28999 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  29001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  29013 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  29017 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29021 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  29025 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  29029 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  29033 */     // MIs[3] Operand 2
     /*  29033 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
     /*  29044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /*  29048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29052 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  29056 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29060 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29064 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  29068 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  29072 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  29076 */     // MIs[5] Operand 2
     /*  29076 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  29087 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
     /*  29091 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29095 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  29099 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  29103 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  29105 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
     /*  29109 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29113 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  29117 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  29121 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  29123 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  29127 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29131 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  29134 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29139 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  29143 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  29147 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  29149 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  29153 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29157 */     // MIs[10] src0
     /*  29157 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29162 */     // MIs[10] Operand 2
     /*  29162 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  29173 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  29177 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29181 */     // MIs[11] src1
     /*  29181 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29186 */     // MIs[11] Operand 2
     /*  29186 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  29197 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
     /*  29201 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29205 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  29208 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29213 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  29217 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  29221 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  29223 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  29227 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29231 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  29235 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  29239 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29243 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  29247 */     // MIs[14] src0
     /*  29247 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29252 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
     /*  29256 */     // MIs[13] Operand 2
     /*  29256 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  29267 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  29271 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29275 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  29279 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  29283 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29287 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  29291 */     // MIs[16] src1
     /*  29291 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29296 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
     /*  29300 */     // MIs[15] Operand 2
     /*  29300 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29311 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29315 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29319 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29322 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29327 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29331 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29335 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29337 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29341 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29345 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  29349 */     // MIs[18] src0
     /*  29349 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  29354 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  29358 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  29362 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29366 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  29370 */     // MIs[19] src1
     /*  29370 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  29375 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  29379 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  29381 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  29381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  29384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  29386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
     /*  29393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  29400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  29407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29416 */     GIR_RootConstrainSelectedInstOperands,
     /*  29417 */     // GIR_Coverage, 10000,
     /*  29417 */     GIR_EraseRootFromParent_Done,
     /*  29418 */   // Label 226: @29418
     /*  29418 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(29893), // Rule ID 9999 //
     /*  29423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  29426 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  29428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  29432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  29444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  29448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  29450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  29462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  29466 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  29468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29476 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  29479 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29484 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  29488 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  29492 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  29494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  29498 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29502 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  29506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29514 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  29518 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  29522 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  29526 */     // MIs[4] Operand 2
     /*  29526 */     GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  29537 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  29541 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29545 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  29549 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  29553 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29557 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  29561 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  29565 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  29569 */     // MIs[6] Operand 2
     /*  29569 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  29580 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  29584 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29588 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  29592 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  29596 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  29598 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  29602 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29606 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  29609 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29614 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  29618 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  29622 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  29624 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  29628 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29632 */     // MIs[10] src0
     /*  29632 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  29637 */     // MIs[10] Operand 2
     /*  29637 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  29648 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  29652 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29656 */     // MIs[11] src1
     /*  29656 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  29661 */     // MIs[11] Operand 2
     /*  29661 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  29672 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  29676 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29680 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  29683 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29688 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  29692 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  29696 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  29698 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  29702 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29706 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  29710 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  29714 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29718 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  29722 */     // MIs[14] src0
     /*  29722 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  29727 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  29731 */     // MIs[13] Operand 2
     /*  29731 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  29742 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  29746 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29750 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  29754 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  29758 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29762 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  29766 */     // MIs[16] src1
     /*  29766 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  29771 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  29775 */     // MIs[15] Operand 2
     /*  29775 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  29786 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  29790 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29794 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  29797 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29802 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  29806 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  29810 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  29812 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  29816 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29820 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  29824 */     // MIs[18] src0
     /*  29824 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  29829 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  29833 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  29837 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  29841 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  29845 */     // MIs[19] src1
     /*  29845 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  29850 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  29854 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  29856 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  29856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  29859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  29861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  29868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  29875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  29878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
     /*  29882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29891 */     GIR_RootConstrainSelectedInstOperands,
     /*  29892 */     // GIR_Coverage, 9999,
     /*  29892 */     GIR_EraseRootFromParent_Done,
     /*  29893 */   // Label 227: @29893
     /*  29893 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(30368), // Rule ID 9998 //
     /*  29898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  29901 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  29903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  29907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  29919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  29923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  29925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  29937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  29941 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  29943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29951 */     GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
     /*  29954 */     GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  29959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  29963 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  29967 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  29969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  29973 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  29977 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  29981 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  29985 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  29989 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  29993 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  29997 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  30001 */     // MIs[4] Operand 2
     /*  30001 */     GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  30012 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
     /*  30016 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30020 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  30024 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
     /*  30028 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30032 */     GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
     /*  30036 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  30040 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
     /*  30044 */     // MIs[6] Operand 2
     /*  30044 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  30055 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
     /*  30059 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30063 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  30067 */     GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
     /*  30071 */     GIM_CheckHasOneUse, /*MI*/8,
     /*  30073 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
     /*  30077 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30081 */     GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
     /*  30084 */     GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30089 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  30093 */     GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
     /*  30097 */     GIM_CheckHasOneUse, /*MI*/9,
     /*  30099 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
     /*  30103 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30107 */     // MIs[10] src0
     /*  30107 */     GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30112 */     // MIs[10] Operand 2
     /*  30112 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  30123 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
     /*  30127 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30131 */     // MIs[11] src1
     /*  30131 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30136 */     // MIs[11] Operand 2
     /*  30136 */     GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
     /*  30147 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  30151 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30155 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  30158 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30163 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  30167 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  30171 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  30173 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  30177 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30181 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  30185 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  30189 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30193 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  30197 */     // MIs[14] src0
     /*  30197 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30202 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  30206 */     // MIs[13] Operand 2
     /*  30206 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  30217 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  30221 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30225 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  30229 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  30233 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30237 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  30241 */     // MIs[16] src1
     /*  30241 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30246 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  30250 */     // MIs[15] Operand 2
     /*  30250 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  30261 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  30265 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30269 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  30272 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30277 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  30281 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  30285 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  30287 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  30291 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30295 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30299 */     // MIs[18] src0
     /*  30299 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30304 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30308 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30312 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30316 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30320 */     // MIs[19] src1
     /*  30320 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
     /*  30325 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30329 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30331 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
     /*  30350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
     /*  30357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30366 */     GIR_RootConstrainSelectedInstOperands,
     /*  30367 */     // GIR_Coverage, 9998,
     /*  30367 */     GIR_EraseRootFromParent_Done,
     /*  30368 */   // Label 228: @30368
     /*  30368 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(30843), // Rule ID 9997 //
     /*  30373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  30376 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  30378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  30382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  30394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  30398 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  30400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  30412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  30416 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  30418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  30430 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  30434 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  30436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30440 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30444 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  30447 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30452 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  30456 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  30460 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  30462 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  30466 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30470 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  30474 */     // MIs[5] Operand 2
     /*  30474 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  30485 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  30489 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30493 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  30497 */     // MIs[6] Operand 2
     /*  30497 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  30508 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  30512 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30516 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  30519 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30524 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  30528 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  30532 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  30534 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  30538 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30542 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  30546 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  30550 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30554 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  30558 */     // MIs[9] src0
     /*  30558 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30563 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  30567 */     // MIs[8] Operand 2
     /*  30567 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  30578 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  30582 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30586 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  30590 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  30594 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30598 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  30602 */     // MIs[11] src1
     /*  30602 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30607 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  30611 */     // MIs[10] Operand 2
     /*  30611 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  30622 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  30626 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30630 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  30633 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30638 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  30642 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  30646 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  30648 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  30652 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30656 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  30660 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  30664 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30668 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  30672 */     // MIs[14] src0
     /*  30672 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30677 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  30681 */     // MIs[13] Operand 2
     /*  30681 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  30692 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  30696 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30700 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  30704 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  30708 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  30712 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  30716 */     // MIs[16] src1
     /*  30716 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30721 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  30725 */     // MIs[15] Operand 2
     /*  30725 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  30736 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  30740 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30744 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  30747 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30752 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  30756 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  30760 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  30762 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  30766 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30770 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  30774 */     // MIs[18] src0
     /*  30774 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  30779 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  30783 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  30787 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  30791 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  30795 */     // MIs[19] src1
     /*  30795 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  30800 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  30804 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  30806 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  30806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  30809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  30811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  30818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  30825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  30828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  30832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30841 */     GIR_RootConstrainSelectedInstOperands,
     /*  30842 */     // GIR_Coverage, 9997,
     /*  30842 */     GIR_EraseRootFromParent_Done,
     /*  30843 */   // Label 229: @30843
     /*  30843 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(31318), // Rule ID 2787 //
     /*  30848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /*  30851 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  30853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  30857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  30869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  30873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  30875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  30887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  30891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  30893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  30901 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  30905 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  30909 */     GIM_CheckHasOneUse, /*MI*/3,
     /*  30911 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  30915 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30919 */     GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
     /*  30922 */     GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30927 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  30931 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  30935 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  30937 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  30941 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30945 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  30949 */     // MIs[5] Operand 2
     /*  30949 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
     /*  30960 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
     /*  30964 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  30968 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  30972 */     // MIs[6] Operand 2
     /*  30972 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
     /*  30983 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
     /*  30987 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30991 */     GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
     /*  30994 */     GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  30999 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31003 */     GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
     /*  31007 */     GIM_CheckHasOneUse, /*MI*/7,
     /*  31009 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
     /*  31013 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31017 */     GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
     /*  31021 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
     /*  31025 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31029 */     GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
     /*  31033 */     // MIs[9] src0
     /*  31033 */     GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31038 */     GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
     /*  31042 */     // MIs[8] Operand 2
     /*  31042 */     GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
     /*  31053 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
     /*  31057 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31061 */     GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
     /*  31065 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
     /*  31069 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31073 */     GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
     /*  31077 */     // MIs[11] src1
     /*  31077 */     GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31082 */     GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
     /*  31086 */     // MIs[10] Operand 2
     /*  31086 */     GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
     /*  31097 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
     /*  31101 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31105 */     GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
     /*  31108 */     GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31113 */     GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
     /*  31117 */     GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
     /*  31121 */     GIM_CheckHasOneUse, /*MI*/12,
     /*  31123 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
     /*  31127 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31131 */     GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
     /*  31135 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
     /*  31139 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31143 */     GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
     /*  31147 */     // MIs[14] src0
     /*  31147 */     GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31152 */     GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
     /*  31156 */     // MIs[13] Operand 2
     /*  31156 */     GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
     /*  31167 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
     /*  31171 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  31175 */     GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
     /*  31179 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
     /*  31183 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31187 */     GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
     /*  31191 */     // MIs[16] src1
     /*  31191 */     GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31196 */     GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
     /*  31200 */     // MIs[15] Operand 2
     /*  31200 */     GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
     /*  31211 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
     /*  31215 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31219 */     GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
     /*  31222 */     GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  31227 */     GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
     /*  31231 */     GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
     /*  31235 */     GIM_CheckHasOneUse, /*MI*/17,
     /*  31237 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
     /*  31241 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  31245 */     GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
     /*  31249 */     // MIs[18] src0
     /*  31249 */     GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
     /*  31254 */     GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
     /*  31258 */     GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
     /*  31262 */     GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  31266 */     GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
     /*  31270 */     // MIs[19] src1
     /*  31270 */     GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
     /*  31275 */     GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
     /*  31279 */     GIM_CheckIsSafeToFold, /*NumInsns*/19,
     /*  31281 */     // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /*  31284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  31293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  31300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  31307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31316 */     GIR_RootConstrainSelectedInstOperands,
     /*  31317 */     // GIR_Coverage, 2787,
     /*  31317 */     GIR_EraseRootFromParent_Done,
     /*  31318 */   // Label 230: @31318
     /*  31318 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(31541), // Rule ID 8654 //
     /*  31323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31338 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31341 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31350 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  31354 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31372 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  31383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  31387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31391 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31395 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31399 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  31410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31414 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31418 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  31422 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31426 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31428 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31432 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31436 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  31439 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31444 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  31448 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  31452 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  31454 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31458 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31462 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  31466 */     // MIs[6] src0
     /*  31466 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31471 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  31475 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  31479 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31483 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31487 */     // MIs[7] src1
     /*  31487 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31492 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  31496 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  31498 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  31501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  31510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  31517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
     /*  31524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31539 */     GIR_RootConstrainSelectedInstOperands,
     /*  31540 */     // GIR_Coverage, 8654,
     /*  31540 */     GIR_EraseRootFromParent_Done,
     /*  31541 */   // Label 231: @31541
     /*  31541 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(31764), // Rule ID 8655 //
     /*  31546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31561 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31564 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31573 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  31577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  31591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31595 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  31606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  31610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31622 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  31633 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31637 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31641 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  31645 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31649 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  31651 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31655 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31659 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  31662 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31667 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  31671 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  31675 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  31677 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31681 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31685 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  31689 */     // MIs[6] src0
     /*  31689 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31694 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  31698 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  31702 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31706 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31710 */     // MIs[7] src1
     /*  31710 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31715 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  31719 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  31721 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  31724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  31733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  31740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
     /*  31747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31762 */     GIR_RootConstrainSelectedInstOperands,
     /*  31763 */     // GIR_Coverage, 8655,
     /*  31763 */     GIR_EraseRootFromParent_Done,
     /*  31764 */   // Label 232: @31764
     /*  31764 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(31987), // Rule ID 2763 //
     /*  31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  31784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  31788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  31792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  31794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31802 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31805 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  31814 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  31818 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  31820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  31824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  31832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  31836 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  31840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  31844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  31848 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  31852 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  31856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  31860 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31864 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31868 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  31871 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  31876 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  31880 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  31884 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  31886 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31890 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31894 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  31898 */     // MIs[6] src0
     /*  31898 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31903 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
     /*  31914 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  31918 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31922 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  31926 */     // MIs[7] src1
     /*  31926 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  31931 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
     /*  31942 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  31944 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  31944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  31947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  31949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  31956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  31963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  31966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  31970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31985 */     GIR_RootConstrainSelectedInstOperands,
     /*  31986 */     // GIR_Coverage, 2763,
     /*  31986 */     GIR_EraseRootFromParent_Done,
     /*  31987 */   // Label 233: @31987
     /*  31987 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(32210), // Rule ID 8653 //
     /*  31992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  31995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  31999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  32011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32015 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32025 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32028 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  32037 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  32041 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  32043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32055 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32059 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  32071 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32075 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32079 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32083 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32087 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32091 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32094 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  32099 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32103 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32107 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32109 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32113 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32117 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32121 */     // MIs[6] src0
     /*  32121 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32126 */     GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
     /*  32137 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32141 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32145 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32149 */     // MIs[7] src1
     /*  32149 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32154 */     GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
     /*  32165 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32167 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /*  32170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  32179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  32186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  32193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32208 */     GIR_RootConstrainSelectedInstOperands,
     /*  32209 */     // GIR_Coverage, 8653,
     /*  32209 */     GIR_EraseRootFromParent_Done,
     /*  32210 */   // Label 234: @32210
     /*  32210 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(32425), // Rule ID 8686 //
     /*  32215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32230 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32233 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32242 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  32246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  32260 */     // MIs[2] Operand 2
     /*  32260 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  32271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  32275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32279 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32283 */     // MIs[3] Operand 2
     /*  32283 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*  32294 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  32298 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32302 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32306 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32310 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  32312 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  32316 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32320 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32323 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32328 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32332 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32336 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32338 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32342 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32346 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32350 */     // MIs[6] src0
     /*  32350 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  32355 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  32359 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32363 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32367 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32371 */     // MIs[7] src1
     /*  32371 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32376 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  32380 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32382 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  32394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  32401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
     /*  32408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32423 */     GIR_RootConstrainSelectedInstOperands,
     /*  32424 */     // GIR_Coverage, 8686,
     /*  32424 */     GIR_EraseRootFromParent_Done,
     /*  32425 */   // Label 235: @32425
     /*  32425 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(32640), // Rule ID 8687 //
     /*  32430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32445 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32448 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32457 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  32461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  32475 */     // MIs[2] Operand 2
     /*  32475 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  32486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  32490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32494 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32498 */     // MIs[3] Operand 2
     /*  32498 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*  32509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  32513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32517 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32521 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32525 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  32527 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  32531 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32535 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32538 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32543 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32547 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32551 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32553 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32557 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32561 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  32565 */     // MIs[6] src0
     /*  32565 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  32570 */     GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  32574 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32578 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32582 */     GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
     /*  32586 */     // MIs[7] src1
     /*  32586 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32591 */     GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
     /*  32595 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32597 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  32609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  32616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
     /*  32623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32638 */     GIR_RootConstrainSelectedInstOperands,
     /*  32639 */     // GIR_Coverage, 8687,
     /*  32639 */     GIR_EraseRootFromParent_Done,
     /*  32640 */   // Label 236: @32640
     /*  32640 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(32855), // Rule ID 2767 //
     /*  32645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  32664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32678 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32681 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  32690 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  32694 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  32696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32708 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32712 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32724 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32728 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32732 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32736 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32740 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32744 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32747 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32752 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32756 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32760 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32762 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32766 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32770 */     // MIs[6] src0
     /*  32770 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32775 */     // MIs[6] Operand 2
     /*  32775 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
     /*  32786 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  32790 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32794 */     // MIs[7] src1
     /*  32794 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  32799 */     // MIs[7] Operand 2
     /*  32799 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
     /*  32810 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  32812 */     // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  32812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  32815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  32817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  32824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  32831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  32834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  32838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32853 */     GIR_RootConstrainSelectedInstOperands,
     /*  32854 */     // GIR_Coverage, 2767,
     /*  32854 */     GIR_EraseRootFromParent_Done,
     /*  32855 */   // Label 237: @32855
     /*  32855 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(33070), // Rule ID 8685 //
     /*  32860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /*  32863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  32867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  32875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  32879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  32883 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  32885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32893 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32896 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  32905 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  32909 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  32911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  32915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  32923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  32927 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  32931 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
     /*  32935 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  32939 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  32943 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  32947 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  32951 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32955 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32959 */     GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
     /*  32962 */     GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  32967 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  32971 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  32975 */     GIM_CheckHasOneUse, /*MI*/5,
     /*  32977 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32981 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  32985 */     // MIs[6] src0
     /*  32985 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32990 */     // MIs[6] Operand 2
     /*  32990 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
     /*  33001 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
     /*  33005 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  33009 */     // MIs[7] src1
     /*  33009 */     GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  33014 */     // MIs[7] Operand 2
     /*  33014 */     GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
     /*  33025 */     GIM_CheckIsSafeToFold, /*NumInsns*/7,
     /*  33027 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /*  33030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  33039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  33046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  33049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  33053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33068 */     GIR_RootConstrainSelectedInstOperands,
     /*  33069 */     // GIR_Coverage, 8685,
     /*  33069 */     GIR_EraseRootFromParent_Done,
     /*  33070 */   // Label 238: @33070
     /*  33070 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(33123), // Rule ID 7702 //
     /*  33075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33095 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  33099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  33103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  33107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33109 */     // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_13722>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  33109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
     /*  33112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /*  33118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33121 */     GIR_RootConstrainSelectedInstOperands,
     /*  33122 */     // GIR_Coverage, 7702,
     /*  33122 */     GIR_EraseRootFromParent_Done,
     /*  33123 */   // Label 239: @33123
     /*  33123 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(33176), // Rule ID 7704 //
     /*  33128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33148 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  33152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  33156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19637),
     /*  33160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33162 */     // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_19637>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  33162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
     /*  33165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /*  33171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33174 */     GIR_RootConstrainSelectedInstOperands,
     /*  33175 */     // GIR_Coverage, 7704,
     /*  33175 */     GIR_EraseRootFromParent_Done,
     /*  33176 */   // Label 240: @33176
     /*  33176 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(33286), // Rule ID 7511 //
     /*  33181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  33193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33201 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33205 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  33215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33219 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33223 */     // MIs[2] Operand 1
     /*  33223 */     GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /*  33228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  33232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33236 */     // MIs[3] src0
     /*  33236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33241 */     // MIs[3] src1
     /*  33241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33246 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
     /*  33250 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33254 */     // MIs[4] src1
     /*  33254 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33259 */     // MIs[4] src0
     /*  33259 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  33266 */     // (add:{ *:[i32] } (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  33269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  33275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
     /*  33279 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33284 */     GIR_RootConstrainSelectedInstOperands,
     /*  33285 */     // GIR_Coverage, 7511,
     /*  33285 */     GIR_EraseRootFromParent_Done,
     /*  33286 */   // Label 241: @33286
     /*  33286 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(33396), // Rule ID 11327 //
     /*  33291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /*  33303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33311 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  33325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33329 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  33333 */     // MIs[2] Operand 1
     /*  33333 */     GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /*  33338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  33342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33346 */     // MIs[3] src0
     /*  33346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33351 */     // MIs[3] src1
     /*  33351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33356 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
     /*  33360 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33364 */     // MIs[4] src1
     /*  33364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
     /*  33369 */     // MIs[4] src0
     /*  33369 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33374 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  33376 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  33379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  33385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
     /*  33389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  33391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33394 */     GIR_RootConstrainSelectedInstOperands,
     /*  33395 */     // GIR_Coverage, 11327,
     /*  33395 */     GIR_EraseRootFromParent_Done,
     /*  33396 */   // Label 242: @33396
     /*  33396 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(33489), // Rule ID 2599 //
     /*  33401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33426 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  33430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  33442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33446 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*  33450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33458 */     // MIs[3] Operand 1
     /*  33458 */     // No operand predicates
     /*  33458 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  33462 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
     /*  33466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20812),
     /*  33470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  33472 */     // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20813>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20812>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  33472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  33475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  33485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33487 */     GIR_RootConstrainSelectedInstOperands,
     /*  33488 */     // GIR_Coverage, 2599,
     /*  33488 */     GIR_EraseRootFromParent_Done,
     /*  33489 */   // Label 243: @33489
     /*  33489 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(33582), // Rule ID 8627 //
     /*  33494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33501 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
     /*  33505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33523 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  33527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  33539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33543 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*  33547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  33551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33555 */     // MIs[3] Operand 1
     /*  33555 */     // No operand predicates
     /*  33555 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  33559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20812),
     /*  33563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  33565 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20813>>)<<P:1:Predicate_anonymous_20812>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  33565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  33568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  33578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  33580 */     GIR_RootConstrainSelectedInstOperands,
     /*  33581 */     // GIR_Coverage, 8627,
     /*  33581 */     GIR_EraseRootFromParent_Done,
     /*  33582 */   // Label 244: @33582
     /*  33582 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(33637), // Rule ID 7451 //
     /*  33587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33599 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33602 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  33607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33617 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
     /*  33620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  33626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  33630 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33635 */     GIR_RootConstrainSelectedInstOperands,
     /*  33636 */     // GIR_Coverage, 7451,
     /*  33636 */     GIR_EraseRootFromParent_Done,
     /*  33637 */   // Label 245: @33637
     /*  33637 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(33692), // Rule ID 7453 //
     /*  33642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33654 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33657 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  33662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  33670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33672 */     // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  33672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
     /*  33675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  33677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  33681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  33685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  33687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  33690 */     GIR_RootConstrainSelectedInstOperands,
     /*  33691 */     // GIR_Coverage, 7453,
     /*  33691 */     GIR_EraseRootFromParent_Done,
     /*  33692 */   // Label 246: @33692
     /*  33692 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(33757), // Rule ID 82 //
     /*  33697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33720 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33727 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  33731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
     /*  33739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33741 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
     /*  33744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33750 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33755 */     GIR_RootConstrainSelectedInstOperands,
     /*  33756 */     // GIR_Coverage, 82,
     /*  33756 */     GIR_EraseRootFromParent_Done,
     /*  33757 */   // Label 247: @33757
     /*  33757 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(33822), // Rule ID 83 //
     /*  33762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33785 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33792 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*  33796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
     /*  33804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33806 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
     /*  33809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33820 */     GIR_RootConstrainSelectedInstOperands,
     /*  33821 */     // GIR_Coverage, 83,
     /*  33821 */     GIR_EraseRootFromParent_Done,
     /*  33822 */   // Label 248: @33822
     /*  33822 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(33887), // Rule ID 84 //
     /*  33827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33857 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*  33861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
     /*  33869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33871 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
     /*  33874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33885 */     GIR_RootConstrainSelectedInstOperands,
     /*  33886 */     // GIR_Coverage, 84,
     /*  33886 */     GIR_EraseRootFromParent_Done,
     /*  33887 */   // Label 249: @33887
     /*  33887 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(33952), // Rule ID 85 //
     /*  33892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  33895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  33907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33915 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33922 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
     /*  33926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  33930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
     /*  33934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33936 */     // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  33936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
     /*  33939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  33941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  33945 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  33950 */     GIR_RootConstrainSelectedInstOperands,
     /*  33951 */     // GIR_Coverage, 85,
     /*  33951 */     GIR_EraseRootFromParent_Done,
     /*  33952 */   // Label 250: @33952
     /*  33952 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(34035), // Rule ID 7510 //
     /*  33957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  33961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  33969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  33973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  33977 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  33979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  33987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  33991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  33995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  33999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34003 */     // MIs[3] src0
     /*  34003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34008 */     // MIs[3] src1
     /*  34008 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34015 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34028 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34033 */     GIR_RootConstrainSelectedInstOperands,
     /*  34034 */     // GIR_Coverage, 7510,
     /*  34034 */     GIR_EraseRootFromParent_Done,
     /*  34035 */   // Label 251: @34035
     /*  34035 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(34118), // Rule ID 11320 //
     /*  34040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34060 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34086 */     // MIs[3] src1
     /*  34086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34091 */     // MIs[3] src0
     /*  34091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34098 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34116 */     GIR_RootConstrainSelectedInstOperands,
     /*  34117 */     // GIR_Coverage, 11320,
     /*  34117 */     GIR_EraseRootFromParent_Done,
     /*  34118 */   // Label 252: @34118
     /*  34118 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(34201), // Rule ID 11321 //
     /*  34123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34169 */     // MIs[3] src0
     /*  34169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34174 */     // MIs[3] src1
     /*  34174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34181 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34194 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34199 */     GIR_RootConstrainSelectedInstOperands,
     /*  34200 */     // GIR_Coverage, 11321,
     /*  34200 */     GIR_EraseRootFromParent_Done,
     /*  34201 */   // Label 253: @34201
     /*  34201 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(34284), // Rule ID 11322 //
     /*  34206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34226 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34252 */     // MIs[3] src1
     /*  34252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34257 */     // MIs[3] src0
     /*  34257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34264 */     // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  34279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34282 */     GIR_RootConstrainSelectedInstOperands,
     /*  34283 */     // GIR_Coverage, 11322,
     /*  34283 */     GIR_EraseRootFromParent_Done,
     /*  34284 */   // Label 254: @34284
     /*  34284 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(34349), // Rule ID 8544 //
     /*  34289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  34327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
     /*  34331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34333 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
     /*  34336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34342 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34347 */     GIR_RootConstrainSelectedInstOperands,
     /*  34348 */     // GIR_Coverage, 8544,
     /*  34348 */     GIR_EraseRootFromParent_Done,
     /*  34349 */   // Label 255: @34349
     /*  34349 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(34414), // Rule ID 8545 //
     /*  34354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34388 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*  34392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
     /*  34396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34398 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
     /*  34401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34412 */     GIR_RootConstrainSelectedInstOperands,
     /*  34413 */     // GIR_Coverage, 8545,
     /*  34413 */     GIR_EraseRootFromParent_Done,
     /*  34414 */   // Label 256: @34414
     /*  34414 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(34479), // Rule ID 8546 //
     /*  34419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*  34457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
     /*  34461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34463 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
     /*  34466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34472 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34477 */     GIR_RootConstrainSelectedInstOperands,
     /*  34478 */     // GIR_Coverage, 8546,
     /*  34478 */     GIR_EraseRootFromParent_Done,
     /*  34479 */   // Label 257: @34479
     /*  34479 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(34544), // Rule ID 8547 //
     /*  34484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  34487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  34503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  34518 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
     /*  34522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
     /*  34526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34528 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  34528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
     /*  34531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  34533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  34537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  34542 */     GIR_RootConstrainSelectedInstOperands,
     /*  34543 */     // GIR_Coverage, 8547,
     /*  34543 */     GIR_EraseRootFromParent_Done,
     /*  34544 */   // Label 258: @34544
     /*  34544 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(34599), // Rule ID 11287 //
     /*  34549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34561 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34564 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /*  34569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34573 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  34577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34579 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
     /*  34582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  34588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  34592 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34597 */     GIR_RootConstrainSelectedInstOperands,
     /*  34598 */     // GIR_Coverage, 11287,
     /*  34598 */     GIR_EraseRootFromParent_Done,
     /*  34599 */   // Label 259: @34599
     /*  34599 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(34654), // Rule ID 11289 //
     /*  34604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34616 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34619 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  34624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34628 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34634 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  34643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  34647 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34652 */     GIR_RootConstrainSelectedInstOperands,
     /*  34653 */     // GIR_Coverage, 11289,
     /*  34653 */     GIR_EraseRootFromParent_Done,
     /*  34654 */   // Label 260: @34654
     /*  34654 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(34737), // Rule ID 11323 //
     /*  34659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34679 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34705 */     // MIs[3] src0
     /*  34705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34710 */     // MIs[3] src1
     /*  34710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34717 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34735 */     GIR_RootConstrainSelectedInstOperands,
     /*  34736 */     // GIR_Coverage, 11323,
     /*  34736 */     GIR_EraseRootFromParent_Done,
     /*  34737 */   // Label 261: @34737
     /*  34737 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(34820), // Rule ID 11324 //
     /*  34742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34762 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34788 */     // MIs[3] src1
     /*  34788 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34793 */     // MIs[3] src0
     /*  34793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34800 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  34809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /*  34813 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34818 */     GIR_RootConstrainSelectedInstOperands,
     /*  34819 */     // GIR_Coverage, 11324,
     /*  34819 */     GIR_EraseRootFromParent_Done,
     /*  34820 */   // Label 262: @34820
     /*  34820 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(34903), // Rule ID 11325 //
     /*  34825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34871 */     // MIs[3] src0
     /*  34871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34876 */     // MIs[3] src1
     /*  34876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34883 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34896 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34901 */     GIR_RootConstrainSelectedInstOperands,
     /*  34902 */     // GIR_Coverage, 11325,
     /*  34902 */     GIR_EraseRootFromParent_Done,
     /*  34903 */   // Label 263: @34903
     /*  34903 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(34986), // Rule ID 11326 //
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  34920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  34924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  34928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  34930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /*  34938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  34942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  34946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  34950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /*  34954 */     // MIs[3] src1
     /*  34954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  34959 */     // MIs[3] src0
     /*  34959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  34966 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /*  34966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
     /*  34969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  34971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /*  34975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  34979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  34981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34984 */     GIR_RootConstrainSelectedInstOperands,
     /*  34985 */     // GIR_Coverage, 11326,
     /*  34985 */     GIR_EraseRootFromParent_Done,
     /*  34986 */   // Label 264: @34986
     /*  34986 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(35151), // Rule ID 8637 //
     /*  34991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  34994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  34998 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:11:z
     /*  35002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35024 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*  35028 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*  35032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  35036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35038 */     // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:11:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20848>>)<<P:11:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35038 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35041 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35045 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35052 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35055 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35059 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35064 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  35068 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35071 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35074 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35082 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35087 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35150 */     // GIR_Coverage, 8637,
     /*  35150 */     GIR_EraseRootFromParent_Done,
     /*  35151 */   // Label 265: @35151
     /*  35151 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(35316), // Rule ID 8641 //
     /*  35156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  35159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35163 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:14:z
     /*  35167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35189 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*  35193 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*  35197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  35201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35203 */     // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:14:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20848>>)<<P:14:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35203 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35206 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35210 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35217 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35220 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35224 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35229 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  35233 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35236 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35239 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35242 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  35267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35285 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35298 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35315 */     // GIR_Coverage, 8641,
     /*  35315 */     GIR_EraseRootFromParent_Done,
     /*  35316 */   // Label 266: @35316
     /*  35316 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(35381), // Rule ID 2602 //
     /*  35321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  35324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  35336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35346 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*  35350 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*  35354 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:3:z
     /*  35358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20818),
     /*  35362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35364 */     // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20816>>, i32:{ *:[i32] }:$src2:$pred:3:z)<<P:3:Predicate_anonymous_20818>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  35364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /*  35367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  35369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  35379 */     GIR_RootConstrainSelectedInstOperands,
     /*  35380 */     // GIR_Coverage, 2602,
     /*  35380 */     GIR_EraseRootFromParent_Done,
     /*  35381 */   // Label 267: @35381
     /*  35381 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(35546), // Rule ID 2621 //
     /*  35386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35411 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*  35415 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*  35419 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:11:z
     /*  35423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  35431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35433 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20848>>, VGPR_32:{ *:[i32] }:$src2:$pred:11:z)<<P:11:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35433 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35436 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35440 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35463 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35466 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35469 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35482 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35487 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35528 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35545 */     // GIR_Coverage, 2621,
     /*  35545 */     GIR_EraseRootFromParent_Done,
     /*  35546 */   // Label 268: @35546
     /*  35546 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(35711), // Rule ID 2626 //
     /*  35551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  35554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35576 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*  35580 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*  35584 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:14:z
     /*  35588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  35596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35598 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20848>>, VGPR_32:{ *:[i32] }:$src2:$pred:14:z)<<P:14:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35598 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35612 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35624 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35628 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35631 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35634 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35652 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  35662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35680 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35683 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35693 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35710 */     // GIR_Coverage, 2626,
     /*  35710 */     GIR_EraseRootFromParent_Done,
     /*  35711 */   // Label 269: @35711
     /*  35711 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(35872), // Rule ID 2620 //
     /*  35716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  35719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35739 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35741 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*  35745 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*  35749 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:10:z
     /*  35753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  35757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35759 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20848>>, i32:{ *:[i32] }:$src2:$pred:10:z)<<P:10:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35759 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35773 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35785 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35789 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35792 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35795 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  35803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  35808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  35813 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  35823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  35841 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  35844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  35847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  35849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35854 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  35861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  35871 */     // GIR_Coverage, 2620,
     /*  35871 */     GIR_EraseRootFromParent_Done,
     /*  35872 */   // Label 270: @35872
     /*  35872 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(36033), // Rule ID 2625 //
     /*  35877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  35880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  35884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  35892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  35896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  35900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  35902 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*  35906 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*  35910 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:13:z
     /*  35914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  35918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35920 */     // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20848>>, i32:{ *:[i32] }:$src2:$pred:13:z)<<P:13:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  35920 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  35923 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35927 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  35934 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  35937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  35941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  35950 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  35953 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  35956 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  35959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  35964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  35969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  35974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  35977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  35980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  35984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  35994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  35998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36015 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36032 */     // GIR_Coverage, 2625,
     /*  36032 */     GIR_EraseRootFromParent_Done,
     /*  36033 */   // Label 271: @36033
     /*  36033 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(36098), // Rule ID 2598 //
     /*  36038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36063 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  36067 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*  36071 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
     /*  36075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20812),
     /*  36079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36081 */     // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20813>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20812>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  36084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36094 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  36096 */     GIR_RootConstrainSelectedInstOperands,
     /*  36097 */     // GIR_Coverage, 2598,
     /*  36097 */     GIR_EraseRootFromParent_Done,
     /*  36098 */   // Label 272: @36098
     /*  36098 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(36163), // Rule ID 2608 //
     /*  36103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36128 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*  36132 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*  36136 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:8:z
     /*  36140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20831),
     /*  36144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36146 */     // (add:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20832>>, i32:{ *:[i32] }:$src2:$pred:8:z)<<P:8:Predicate_anonymous_20831>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
     /*  36149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  36161 */     GIR_RootConstrainSelectedInstOperands,
     /*  36162 */     // GIR_Coverage, 2608,
     /*  36162 */     GIR_EraseRootFromParent_Done,
     /*  36163 */   // Label 273: @36163
     /*  36163 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(36203), // Rule ID 7032 //
     /*  36168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  36180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36184 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34197),
     /*  36188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36190 */     // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34197>>, i32:{ *:[i32] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
     /*  36190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  36193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
     /*  36199 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  36201 */     GIR_RootConstrainSelectedInstOperands,
     /*  36202 */     // GIR_Coverage, 7032,
     /*  36202 */     GIR_EraseRootFromParent_Done,
     /*  36203 */   // Label 274: @36203
     /*  36203 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(36268), // Rule ID 8628 //
     /*  36208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36215 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:3:z
     /*  36219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36237 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*  36241 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*  36245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20818),
     /*  36249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36251 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:3:z, (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20816>>)<<P:3:Predicate_anonymous_20818>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /*  36254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36266 */     GIR_RootConstrainSelectedInstOperands,
     /*  36267 */     // GIR_Coverage, 8628,
     /*  36267 */     GIR_EraseRootFromParent_Done,
     /*  36268 */   // Label 275: @36268
     /*  36268 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(36429), // Rule ID 8636 //
     /*  36273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  36276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36280 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:10:z
     /*  36284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36302 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*  36306 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*  36310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  36314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36316 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:10:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20848>>)<<P:10:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36316 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  36346 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36349 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36352 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36370 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  36380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36398 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36401 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36428 */     // GIR_Coverage, 8636,
     /*  36428 */     GIR_EraseRootFromParent_Done,
     /*  36429 */   // Label 276: @36429
     /*  36429 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(36590), // Rule ID 8640 //
     /*  36434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  36437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36441 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:13:z
     /*  36445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  36453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36463 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*  36467 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*  36471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20847),
     /*  36475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36477 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:13:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20848>>)<<P:13:Predicate_anonymous_20847>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
     /*  36477 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  36480 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36484 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36491 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  36498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  36507 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /*  36510 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  36513 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /*  36516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  36521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  36526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  36531 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  36534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  36541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  36562 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36572 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /*  36579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  36589 */     // GIR_Coverage, 8640,
     /*  36589 */     GIR_EraseRootFromParent_Done,
     /*  36590 */   // Label 277: @36590
     /*  36590 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(36655), // Rule ID 8626 //
     /*  36595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36602 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
     /*  36606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36622 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36624 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*  36628 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*  36632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20812),
     /*  36636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36638 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20813>>)<<P:1:Predicate_anonymous_20812>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
     /*  36641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36653 */     GIR_RootConstrainSelectedInstOperands,
     /*  36654 */     // GIR_Coverage, 8626,
     /*  36654 */     GIR_EraseRootFromParent_Done,
     /*  36655 */   // Label 278: @36655
     /*  36655 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(36720), // Rule ID 8633 //
     /*  36660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  36663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36667 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:8:z
     /*  36671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  36689 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*  36693 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*  36697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20831),
     /*  36701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36703 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:8:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20832>>)<<P:8:Predicate_anonymous_20831>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  36703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
     /*  36706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  36712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  36716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  36718 */     GIR_RootConstrainSelectedInstOperands,
     /*  36719 */     // GIR_Coverage, 8633,
     /*  36719 */     GIR_EraseRootFromParent_Done,
     /*  36720 */   // Label 279: @36720
     /*  36720 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(36760), // Rule ID 11285 //
     /*  36725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  36737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36741 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34197),
     /*  36745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36747 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$val, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34197>>)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
     /*  36747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  36750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
     /*  36756 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36758 */     GIR_RootConstrainSelectedInstOperands,
     /*  36759 */     // GIR_Coverage, 11285,
     /*  36759 */     GIR_EraseRootFromParent_Done,
     /*  36760 */   // Label 280: @36760
     /*  36760 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(36804), // Rule ID 7697 //
     /*  36765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  36769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  36781 */     // MIs[1] Operand 1
     /*  36781 */     // No operand predicates
     /*  36781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  36785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36787 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_13722>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i1 i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  36787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
     /*  36790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  36792 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  36794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  36799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  36802 */     GIR_RootConstrainSelectedInstOperands,
     /*  36803 */     // GIR_Coverage, 7697,
     /*  36803 */     GIR_EraseRootFromParent_Done,
     /*  36804 */   // Label 281: @36804
     /*  36804 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(36851), // Rule ID 7698 //
     /*  36809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  36812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  36828 */     // MIs[1] Operand 1
     /*  36828 */     // No operand predicates
     /*  36828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19637),
     /*  36832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36834 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19637>>  =>  (V_SUB_U32_e64:{ *:[i32] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  36834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /*  36837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  36841 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  36846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36849 */     GIR_RootConstrainSelectedInstOperands,
     /*  36850 */     // GIR_Coverage, 7698,
     /*  36850 */     GIR_EraseRootFromParent_Done,
     /*  36851 */   // Label 282: @36851
     /*  36851 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(36906), // Rule ID 7699 //
     /*  36856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasAddNoCarryInsts),
     /*  36859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
     /*  36875 */     // MIs[1] Operand 1
     /*  36875 */     // No operand predicates
     /*  36875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19637),
     /*  36879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36881 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19637>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
     /*  36881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  36884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /*  36887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36889 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  36896 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /*  36901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36904 */     GIR_RootConstrainSelectedInstOperands,
     /*  36905 */     // GIR_Coverage, 7699,
     /*  36905 */     GIR_EraseRootFromParent_Done,
     /*  36906 */   // Label 283: @36906
     /*  36906 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(36940), // Rule ID 43 //
     /*  36911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  36915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  36919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  36923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  36927 */     // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13722>>  =>  (S_ADD_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  36927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_I32),
     /*  36932 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  36938 */     GIR_RootConstrainSelectedInstOperands,
     /*  36939 */     // GIR_Coverage, 43,
     /*  36939 */     GIR_Done,
     /*  36940 */   // Label 284: @36940
     /*  36940 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(36970), // Rule ID 2493 //
     /*  36945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  36948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19637),
     /*  36956 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19637>>  =>  (V_ADD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  36956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
     /*  36959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36961 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  36963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36968 */     GIR_RootConstrainSelectedInstOperands,
     /*  36969 */     // GIR_Coverage, 2493,
     /*  36969 */     GIR_EraseRootFromParent_Done,
     /*  36970 */   // Label 285: @36970
     /*  36970 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(37008), // Rule ID 2495 //
     /*  36975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
     /*  36978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  36982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19637),
     /*  36986 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19637>>  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  36986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  36989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
     /*  36992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  36994 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  36999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37006 */     GIR_RootConstrainSelectedInstOperands,
     /*  37007 */     // GIR_Coverage, 2495,
     /*  37007 */     GIR_EraseRootFromParent_Done,
     /*  37008 */   // Label 286: @37008
     /*  37008 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(37044), // Rule ID 818 //
     /*  37013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  37025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37031 */     // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  37031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  37034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37042 */     GIR_RootConstrainSelectedInstOperands,
     /*  37043 */     // GIR_Coverage, 818,
     /*  37043 */     GIR_EraseRootFromParent_Done,
     /*  37044 */   // Label 287: @37044
     /*  37044 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(37080), // Rule ID 8559 //
     /*  37049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
     /*  37061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37067 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$src1, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  37067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /*  37070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37076 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37078 */     GIR_RootConstrainSelectedInstOperands,
     /*  37079 */     // GIR_Coverage, 8559,
     /*  37079 */     GIR_EraseRootFromParent_Done,
     /*  37080 */   // Label 288: @37080
     /*  37080 */   GIM_Reject,
     /*  37081 */ // Label 198: @37081
     /*  37081 */ GIM_Reject,
     /*  37082 */ // Label 171: @37082
     /*  37082 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(37552),
     /*  37087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37093 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(37159), // Rule ID 2623 //
     /*  37098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  37101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37113 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37116 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37125 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37131 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  37137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37139 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37152 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37157 */     GIR_RootConstrainSelectedInstOperands,
     /*  37158 */     // GIR_Coverage, 2623,
     /*  37158 */     GIR_EraseRootFromParent_Done,
     /*  37159 */   // Label 290: @37159
     /*  37159 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(37225), // Rule ID 2628 //
     /*  37164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  37167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37179 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37182 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37191 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  37203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37205 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37223 */     GIR_RootConstrainSelectedInstOperands,
     /*  37224 */     // GIR_Coverage, 2628,
     /*  37224 */     GIR_EraseRootFromParent_Done,
     /*  37225 */   // Label 291: @37225
     /*  37225 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(37291), // Rule ID 8638 //
     /*  37230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
     /*  37233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37245 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37248 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37263 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
     /*  37269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37271 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37289 */     GIR_RootConstrainSelectedInstOperands,
     /*  37290 */     // GIR_Coverage, 8638,
     /*  37290 */     GIR_EraseRootFromParent_Done,
     /*  37291 */   // Label 292: @37291
     /*  37291 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(37357), // Rule ID 8642 //
     /*  37296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
     /*  37299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37311 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  37314 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /*  37319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  37327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37329 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /*  37329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  37332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
     /*  37335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37337 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  37342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /*  37346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
     /*  37350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37355 */     GIR_RootConstrainSelectedInstOperands,
     /*  37356 */     // GIR_Coverage, 8642,
     /*  37356 */     GIR_EraseRootFromParent_Done,
     /*  37357 */   // Label 293: @37357
     /*  37357 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(37426), // Rule ID 2610 //
     /*  37362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /*  37365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37385 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  37387 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*  37391 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*  37395 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
     /*  37399 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:9:z
     /*  37403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20835),
     /*  37407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37409 */     // (add:{ *:[i64] } (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20836>>, i64:{ *:[i64] }:$src2:$pred:9:z)<<P:9:Predicate_anonymous_20835>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
     /*  37409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
     /*  37412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  37422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  37424 */     GIR_RootConstrainSelectedInstOperands,
     /*  37425 */     // GIR_Coverage, 2610,
     /*  37425 */     GIR_EraseRootFromParent_Done,
     /*  37426 */   // Label 294: @37426
     /*  37426 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(37495), // Rule ID 8634 //
     /*  37431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /*  37434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37438 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:9:z
     /*  37442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37458 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  37460 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*  37464 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*  37468 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
     /*  37472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20835),
     /*  37476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37478 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src2:$pred:9:z, (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20836>>)<<P:9:Predicate_anonymous_20835>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
     /*  37478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
     /*  37481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  37487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  37491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  37493 */     GIR_RootConstrainSelectedInstOperands,
     /*  37494 */     // GIR_Coverage, 8634,
     /*  37494 */     GIR_EraseRootFromParent_Done,
     /*  37495 */   // Label 295: @37495
     /*  37495 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(37525), // Rule ID 1339 //
     /*  37500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  37504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19637),
     /*  37508 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19637>>  =>  (V_ADD_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  37508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U64_PSEUDO),
     /*  37513 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
     /*  37519 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  37523 */     GIR_RootConstrainSelectedInstOperands,
     /*  37524 */     // GIR_Coverage, 1339,
     /*  37524 */     GIR_Done,
     /*  37525 */   // Label 296: @37525
     /*  37525 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(37551), // Rule ID 1341 //
     /*  37530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  37534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13722),
     /*  37538 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13722>>  =>  (S_ADD_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  37538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_U64_PSEUDO),
     /*  37543 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  37549 */     GIR_RootConstrainSelectedInstOperands,
     /*  37550 */     // GIR_Coverage, 1341,
     /*  37550 */     GIR_Done,
     /*  37551 */   // Label 297: @37551
     /*  37551 */   GIM_Reject,
     /*  37552 */ // Label 289: @37552
     /*  37552 */ GIM_Reject,
     /*  37553 */ // Label 172: @37553
     /*  37553 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(37822),
     /*  37558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37568 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(37664), // Rule ID 8609 //
     /*  37573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37612 */     // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
     /*  37612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
     /*  37615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /*  37622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /*  37627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_modifiers
     /*  37632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /*  37637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /*  37642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /*  37647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37662 */     GIR_RootConstrainSelectedInstOperands,
     /*  37663 */     // GIR_Coverage, 8609,
     /*  37663 */     GIR_EraseRootFromParent_Done,
     /*  37664 */   // Label 299: @37664
     /*  37664 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(37760), // Rule ID 1088 //
     /*  37669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  37681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  37685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37708 */     // (add:{ *:[v2i16] } (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
     /*  37708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
     /*  37711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  37718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  37723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  37728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  37733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  37738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  37743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37758 */     GIR_RootConstrainSelectedInstOperands,
     /*  37759 */     // GIR_Coverage, 1088,
     /*  37759 */     GIR_EraseRootFromParent_Done,
     /*  37760 */   // Label 300: @37760
     /*  37760 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(37821), // Rule ID 1099 //
     /*  37765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  37779 */     // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  37779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
     /*  37782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  37784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  37789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  37794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  37799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  37804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37819 */     GIR_RootConstrainSelectedInstOperands,
     /*  37820 */     // GIR_Coverage, 1099,
     /*  37820 */     GIR_EraseRootFromParent_Done,
     /*  37821 */   // Label 301: @37821
     /*  37821 */   GIM_Reject,
     /*  37822 */ // Label 298: @37822
     /*  37822 */ GIM_Reject,
     /*  37823 */ // Label 173: @37823
     /*  37823 */ GIM_Reject,
     /*  37824 */ // Label 1: @37824
     /*  37824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 307*/ GIMT_Encode4(38446),
     /*  37835 */ /*GILLT_s1*//*Label 302*/ GIMT_Encode4(37855),
     /*  37839 */ /*GILLT_s16*//*Label 303*/ GIMT_Encode4(37974),
     /*  37843 */ /*GILLT_s32*//*Label 304*/ GIMT_Encode4(38190),
     /*  37847 */ /*GILLT_s64*//*Label 305*/ GIMT_Encode4(38305),
     /*  37851 */ /*GILLT_v2s16*//*Label 306*/ GIMT_Encode4(38374),
     /*  37855 */ // Label 302: @37855
     /*  37855 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(37973),
     /*  37860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  37863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  37866 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(37894), // Rule ID 7551 //
     /*  37871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  37874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  37878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37882 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  37882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  37885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  37892 */     GIR_RootConstrainSelectedInstOperands,
     /*  37893 */     // GIR_Coverage, 7551,
     /*  37893 */     GIR_EraseRootFromParent_Done,
     /*  37894 */   // Label 309: @37894
     /*  37894 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(37922), // Rule ID 7558 //
     /*  37899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  37902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37910 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
     /*  37910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  37913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  37915 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  37917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  37920 */     GIR_RootConstrainSelectedInstOperands,
     /*  37921 */     // GIR_Coverage, 7558,
     /*  37921 */     GIR_EraseRootFromParent_Done,
     /*  37922 */   // Label 310: @37922
     /*  37922 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(37947), // Rule ID 7549 //
     /*  37927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  37930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  37934 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  37934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  37939 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  37945 */     GIR_RootConstrainSelectedInstOperands,
     /*  37946 */     // GIR_Coverage, 7549,
     /*  37946 */     GIR_Done,
     /*  37947 */   // Label 311: @37947
     /*  37947 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(37972), // Rule ID 7556 //
     /*  37952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  37955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  37959 */     // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  37959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  37964 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  37970 */     GIR_RootConstrainSelectedInstOperands,
     /*  37971 */     // GIR_Coverage, 7556,
     /*  37971 */     GIR_Done,
     /*  37972 */   // Label 312: @37972
     /*  37972 */   GIM_Reject,
     /*  37973 */ // Label 308: @37973
     /*  37973 */ GIM_Reject,
     /*  37974 */ // Label 303: @37974
     /*  37974 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(38189),
     /*  37979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  37982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  37985 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(38044), // Rule ID 1070 //
     /*  37990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /*  37993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  37997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38011 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /*  38014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38042 */     GIR_RootConstrainSelectedInstOperands,
     /*  38043 */     // GIR_Coverage, 1070,
     /*  38043 */     GIR_EraseRootFromParent_Done,
     /*  38044 */   // Label 314: @38044
     /*  38044 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(38103), // Rule ID 1071 //
     /*  38049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /*  38052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  38056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38070 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /*  38073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38101 */     GIR_RootConstrainSelectedInstOperands,
     /*  38102 */     // GIR_Coverage, 1071,
     /*  38102 */     GIR_EraseRootFromParent_Done,
     /*  38103 */   // Label 315: @38103
     /*  38103 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(38162), // Rule ID 1072 //
     /*  38108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /*  38111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38129 */     // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /*  38132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38160 */     GIR_RootConstrainSelectedInstOperands,
     /*  38161 */     // GIR_Coverage, 1072,
     /*  38161 */     GIR_EraseRootFromParent_Done,
     /*  38162 */   // Label 316: @38162
     /*  38162 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(38188), // Rule ID 911 //
     /*  38167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
     /*  38170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38174 */     // (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /*  38177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38186 */     GIR_RootConstrainSelectedInstOperands,
     /*  38187 */     // GIR_Coverage, 911,
     /*  38187 */     GIR_EraseRootFromParent_Done,
     /*  38188 */   // Label 317: @38188
     /*  38188 */   GIM_Reject,
     /*  38189 */ // Label 313: @38189
     /*  38189 */ GIM_Reject,
     /*  38190 */ // Label 304: @38190
     /*  38190 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(38304),
     /*  38195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  38198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  38201 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(38235), // Rule ID 44 //
     /*  38206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13723),
     /*  38222 */     // (sub:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13723>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /*  38222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
     /*  38227 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38233 */     GIR_RootConstrainSelectedInstOperands,
     /*  38234 */     // GIR_Coverage, 44,
     /*  38234 */     GIR_Done,
     /*  38235 */   // Label 319: @38235
     /*  38235 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(38265), // Rule ID 2494 //
     /*  38240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /*  38243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19639),
     /*  38251 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19639>>  =>  (V_SUB_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  38251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /*  38254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38256 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38258 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38263 */     GIR_RootConstrainSelectedInstOperands,
     /*  38264 */     // GIR_Coverage, 2494,
     /*  38264 */     GIR_EraseRootFromParent_Done,
     /*  38265 */   // Label 320: @38265
     /*  38265 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(38303), // Rule ID 2496 //
     /*  38270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
     /*  38273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19639),
     /*  38281 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19639>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
     /*  38281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  38284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /*  38287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38289 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  38294 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  38296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38301 */     GIR_RootConstrainSelectedInstOperands,
     /*  38302 */     // GIR_Coverage, 2496,
     /*  38302 */     GIR_EraseRootFromParent_Done,
     /*  38303 */   // Label 321: @38303
     /*  38303 */   GIM_Reject,
     /*  38304 */ // Label 318: @38304
     /*  38304 */ GIM_Reject,
     /*  38305 */ // Label 305: @38305
     /*  38305 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(38373),
     /*  38310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38316 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(38346), // Rule ID 1340 //
     /*  38321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  38325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19639),
     /*  38329 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19639>>  =>  (V_SUB_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U64_PSEUDO),
     /*  38334 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
     /*  38340 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38344 */     GIR_RootConstrainSelectedInstOperands,
     /*  38345 */     // GIR_Coverage, 1340,
     /*  38345 */     GIR_Done,
     /*  38346 */   // Label 323: @38346
     /*  38346 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(38372), // Rule ID 1342 //
     /*  38351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13723),
     /*  38359 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13723>>  =>  (S_SUB_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_U64_PSEUDO),
     /*  38364 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38370 */     GIR_RootConstrainSelectedInstOperands,
     /*  38371 */     // GIR_Coverage, 1342,
     /*  38371 */     GIR_Done,
     /*  38372 */   // Label 324: @38372
     /*  38372 */   GIM_Reject,
     /*  38373 */ // Label 322: @38373
     /*  38373 */ GIM_Reject,
     /*  38374 */ // Label 306: @38374
     /*  38374 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(38445), // Rule ID 1107 //
     /*  38379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  38382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  38385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38403 */   // (sub:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  38403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
     /*  38406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38443 */   GIR_RootConstrainSelectedInstOperands,
     /*  38444 */   // GIR_Coverage, 1107,
     /*  38444 */   GIR_EraseRootFromParent_Done,
     /*  38445 */ // Label 325: @38445
     /*  38445 */ GIM_Reject,
     /*  38446 */ // Label 307: @38446
     /*  38446 */ GIM_Reject,
     /*  38447 */ // Label 2: @38447
     /*  38447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 330*/ GIMT_Encode4(38792),
     /*  38458 */ /*GILLT_s16*//*Label 326*/ GIMT_Encode4(38474),
     /*  38462 */ /*GILLT_s32*//*Label 327*/ GIMT_Encode4(38589),
     /*  38466 */ /*GILLT_s64*//*Label 328*/ GIMT_Encode4(38690),
     /*  38470 */ /*GILLT_v2s16*//*Label 329*/ GIMT_Encode4(38720),
     /*  38474 */ // Label 326: @38474
     /*  38474 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(38588),
     /*  38479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  38482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  38485 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(38541), // Rule ID 878 //
     /*  38490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  38493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  38497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  38511 */     // (mul:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LO_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  38511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_t16_e64),
     /*  38514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38539 */     GIR_RootConstrainSelectedInstOperands,
     /*  38540 */     // GIR_Coverage, 878,
     /*  38540 */     GIR_EraseRootFromParent_Done,
     /*  38541 */   // Label 332: @38541
     /*  38541 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(38564), // Rule ID 877 //
     /*  38546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  38549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38553 */     // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /*  38558 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38562 */     GIR_RootConstrainSelectedInstOperands,
     /*  38563 */     // GIR_Coverage, 877,
     /*  38563 */     GIR_Done,
     /*  38564 */   // Label 333: @38564
     /*  38564 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(38587), // Rule ID 879 //
     /*  38569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  38572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38576 */     // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  38576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_fake16_e64),
     /*  38581 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  38585 */     GIR_RootConstrainSelectedInstOperands,
     /*  38586 */     // GIR_Coverage, 879,
     /*  38586 */     GIR_Done,
     /*  38587 */   // Label 334: @38587
     /*  38587 */   GIM_Reject,
     /*  38588 */ // Label 331: @38588
     /*  38588 */ GIM_Reject,
     /*  38589 */ // Label 327: @38589
     /*  38589 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(38689),
     /*  38594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  38597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  38600 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(38620), // Rule ID 81 //
     /*  38605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13730),
     /*  38613 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13730>>  =>  (S_MUL_I32:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_I32),
     /*  38618 */     GIR_RootConstrainSelectedInstOperands,
     /*  38619 */     // GIR_Coverage, 81,
     /*  38619 */     GIR_Done,
     /*  38620 */   // Label 336: @38620
     /*  38620 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(38654), // Rule ID 939 //
     /*  38625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20127),
     /*  38633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  38640 */     // (mul:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_20127>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
     /*  38643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38652 */     GIR_RootConstrainSelectedInstOperands,
     /*  38653 */     // GIR_Coverage, 939,
     /*  38653 */     GIR_EraseRootFromParent_Done,
     /*  38654 */   // Label 337: @38654
     /*  38654 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(38688), // Rule ID 8599 //
     /*  38659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20127),
     /*  38667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  38674 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_20127>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  38674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
     /*  38677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38686 */     GIR_RootConstrainSelectedInstOperands,
     /*  38687 */     // GIR_Coverage, 8599,
     /*  38687 */     GIR_EraseRootFromParent_Done,
     /*  38688 */   // Label 338: @38688
     /*  38688 */   GIM_Reject,
     /*  38689 */ // Label 335: @38689
     /*  38689 */ GIM_Reject,
     /*  38690 */ // Label 328: @38690
     /*  38690 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(38719), // Rule ID 51 //
     /*  38695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  38698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38708 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13730),
     /*  38712 */   // (mul:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13730>>  =>  (S_MUL_U64:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  38712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_U64),
     /*  38717 */   GIR_RootConstrainSelectedInstOperands,
     /*  38718 */   // GIR_Coverage, 51,
     /*  38718 */   GIR_Done,
     /*  38719 */ // Label 339: @38719
     /*  38719 */ GIM_Reject,
     /*  38720 */ // Label 329: @38720
     /*  38720 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(38791), // Rule ID 1100 //
     /*  38725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  38728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  38731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  38735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /*  38749 */   // (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_LO_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /*  38749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_LO_U16),
     /*  38752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  38754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  38759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  38764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  38769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  38774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  38789 */   GIR_RootConstrainSelectedInstOperands,
     /*  38790 */   // GIR_Coverage, 1100,
     /*  38790 */   GIR_EraseRootFromParent_Done,
     /*  38791 */ // Label 340: @38791
     /*  38791 */ GIM_Reject,
     /*  38792 */ // Label 330: @38792
     /*  38792 */ GIM_Reject,
     /*  38793 */ // Label 3: @38793
     /*  38793 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 348*/ GIMT_Encode4(40193),
     /*  38804 */ /*GILLT_s1*//*Label 341*/ GIMT_Encode4(38844),
     /*  38808 */ /*GILLT_s16*//*Label 342*/ GIMT_Encode4(38907),
     /*  38812 */ /*GILLT_s32*//*Label 343*/ GIMT_Encode4(39147),
     /*  38816 */ /*GILLT_s64*//*Label 344*/ GIMT_Encode4(39671),
     /*  38820 */ /*GILLT_v2s16*//*Label 345*/ GIMT_Encode4(39796),
     /*  38824 */ /*GILLT_v2s32*//*Label 346*/ GIMT_Encode4(39947), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  38840 */ /*GILLT_v4s16*//*Label 347*/ GIMT_Encode4(40070),
     /*  38844 */ // Label 341: @38844
     /*  38844 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(38906),
     /*  38849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  38852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  38855 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(38880), // Rule ID 7545 //
     /*  38860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  38863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  38867 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  38867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
     /*  38872 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38878 */     GIR_RootConstrainSelectedInstOperands,
     /*  38879 */     // GIR_Coverage, 7545,
     /*  38879 */     GIR_Done,
     /*  38880 */   // Label 350: @38880
     /*  38880 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(38905), // Rule ID 7552 //
     /*  38885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  38888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38892 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  38892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  38897 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  38903 */     GIR_RootConstrainSelectedInstOperands,
     /*  38904 */     // GIR_Coverage, 7552,
     /*  38904 */     GIR_Done,
     /*  38905 */   // Label 351: @38905
     /*  38905 */   GIM_Reject,
     /*  38906 */ // Label 349: @38906
     /*  38906 */ GIM_Reject,
     /*  38907 */ // Label 342: @38907
     /*  38907 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(39146),
     /*  38912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  38915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  38918 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(38969), // Rule ID 8611 //
     /*  38923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  38939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  38943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  38947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  38951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38953 */     // (and:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  38953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  38956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  38958 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  38960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  38967 */     GIR_RootConstrainSelectedInstOperands,
     /*  38968 */     // GIR_Coverage, 8611,
     /*  38968 */     GIR_EraseRootFromParent_Done,
     /*  38969 */   // Label 353: @38969
     /*  38969 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(39020), // Rule ID 1883 //
     /*  38974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  38978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  38990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  38994 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  38998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39004 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  39004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39009 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39018 */     GIR_RootConstrainSelectedInstOperands,
     /*  39019 */     // GIR_Coverage, 1883,
     /*  39019 */     GIR_EraseRootFromParent_Done,
     /*  39020 */   // Label 354: @39020
     /*  39020 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(39043), // Rule ID 2523 //
     /*  39025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  39028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39032 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  39032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39037 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39041 */     GIR_RootConstrainSelectedInstOperands,
     /*  39042 */     // GIR_Coverage, 2523,
     /*  39042 */     GIR_Done,
     /*  39043 */   // Label 355: @39043
     /*  39043 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(39066), // Rule ID 2526 //
     /*  39048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  39051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39055 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  39055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39060 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39064 */     GIR_RootConstrainSelectedInstOperands,
     /*  39065 */     // GIR_Coverage, 2526,
     /*  39065 */     GIR_Done,
     /*  39066 */   // Label 356: @39066
     /*  39066 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(39122), // Rule ID 904 //
     /*  39071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  39074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  39078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  39085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  39092 */     // (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_AND_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  39092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
     /*  39095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  39102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  39107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  39112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  39117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39120 */     GIR_RootConstrainSelectedInstOperands,
     /*  39121 */     // GIR_Coverage, 904,
     /*  39121 */     GIR_EraseRootFromParent_Done,
     /*  39122 */   // Label 357: @39122
     /*  39122 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(39145), // Rule ID 905 //
     /*  39127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  39130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39134 */     // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  39134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_fake16_e64),
     /*  39139 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39143 */     GIR_RootConstrainSelectedInstOperands,
     /*  39144 */     // GIR_Coverage, 905,
     /*  39144 */     GIR_Done,
     /*  39145 */   // Label 358: @39145
     /*  39145 */   GIM_Reject,
     /*  39146 */ // Label 352: @39146
     /*  39146 */ GIM_Reject,
     /*  39147 */ // Label 343: @39147
     /*  39147 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(39670),
     /*  39152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  39155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  39158 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(39233), // Rule ID 11328 //
     /*  39163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  39175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39183 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39201 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39203 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  39207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19647),
     /*  39215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39217 */     // (and:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19647>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  39224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39231 */     GIR_RootConstrainSelectedInstOperands,
     /*  39232 */     // GIR_Coverage, 11328,
     /*  39232 */     GIR_EraseRootFromParent_Done,
     /*  39233 */   // Label 360: @39233
     /*  39233 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(39308), // Rule ID 11329 //
     /*  39238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39258 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39276 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39278 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  39282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19647),
     /*  39290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39292 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19647>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  39299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39306 */     GIR_RootConstrainSelectedInstOperands,
     /*  39307 */     // GIR_Coverage, 11329,
     /*  39307 */     GIR_EraseRootFromParent_Done,
     /*  39308 */   // Label 361: @39308
     /*  39308 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(39383), // Rule ID 7706 //
     /*  39313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  39325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39333 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39353 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  39357 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19647),
     /*  39365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39367 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>)<<P:Predicate_anonymous_19647>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39381 */     GIR_RootConstrainSelectedInstOperands,
     /*  39382 */     // GIR_Coverage, 7706,
     /*  39382 */     GIR_EraseRootFromParent_Done,
     /*  39383 */   // Label 362: @39383
     /*  39383 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(39458), // Rule ID 7707 //
     /*  39388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39408 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  39410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  39418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  39426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  39428 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  39432 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19647),
     /*  39440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39442 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>)<<P:Predicate_anonymous_19647>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
     /*  39442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  39452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
     /*  39456 */     GIR_RootConstrainSelectedInstOperands,
     /*  39457 */     // GIR_Coverage, 7707,
     /*  39457 */     GIR_EraseRootFromParent_Done,
     /*  39458 */   // Label 363: @39458
     /*  39458 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(39509), // Rule ID 8540 //
     /*  39463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39483 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39493 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39507 */     GIR_RootConstrainSelectedInstOperands,
     /*  39508 */     // GIR_Coverage, 8540,
     /*  39508 */     GIR_EraseRootFromParent_Done,
     /*  39509 */   // Label 364: @39509
     /*  39509 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(39560), // Rule ID 64 //
     /*  39514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39534 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39538 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39544 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39558 */     GIR_RootConstrainSelectedInstOperands,
     /*  39559 */     // GIR_Coverage, 64,
     /*  39559 */     GIR_EraseRootFromParent_Done,
     /*  39560 */   // Label 365: @39560
     /*  39560 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(39623), // Rule ID 7705 //
     /*  39565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  39577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  39581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  39585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  39589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39593 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask),
     /*  39597 */     // MIs[2] Operand 1
     /*  39597 */     // No operand predicates
     /*  39597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19647),
     /*  39601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39603 */     // (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$rshift), (imm:{ *:[i32] })<<P:Predicate_IMMZeroBasedBitfieldMask>>:$mask)<<P:Predicate_anonymous_19647>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, ?:{ *:[i32] }:$rshift, (IMMPopCount:{ *:[i32] } ?:{ *:[i32] }:$mask))
     /*  39603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /*  39606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  39608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  39612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rshift
     /*  39616 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderPopcntImm), // mask
     /*  39621 */     GIR_RootConstrainSelectedInstOperands,
     /*  39622 */     // GIR_Coverage, 7705,
     /*  39622 */     GIR_EraseRootFromParent_Done,
     /*  39623 */   // Label 366: @39623
     /*  39623 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(39649), // Rule ID 52 //
     /*  39628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39636 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13731>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  39641 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39647 */     GIR_RootConstrainSelectedInstOperands,
     /*  39648 */     // GIR_Coverage, 52,
     /*  39648 */     GIR_Done,
     /*  39649 */   // Label 367: @39649
     /*  39649 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(39669), // Rule ID 815 //
     /*  39654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39658 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_AND_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  39658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39663 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39667 */     GIR_RootConstrainSelectedInstOperands,
     /*  39668 */     // GIR_Coverage, 815,
     /*  39668 */     GIR_Done,
     /*  39669 */   // Label 368: @39669
     /*  39669 */   GIM_Reject,
     /*  39670 */ // Label 359: @39670
     /*  39670 */ GIM_Reject,
     /*  39671 */ // Label 344: @39671
     /*  39671 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(39795),
     /*  39676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  39679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  39682 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  39690 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(39733), // Rule ID 8541 //
     /*  39695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39717 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  39720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39722 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39731 */     GIR_RootConstrainSelectedInstOperands,
     /*  39732 */     // GIR_Coverage, 8541,
     /*  39732 */     GIR_EraseRootFromParent_Done,
     /*  39733 */   // Label 370: @39733
     /*  39733 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(39776), // Rule ID 65 //
     /*  39738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39754 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  39758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39760 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  39763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39765 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39774 */     GIR_RootConstrainSelectedInstOperands,
     /*  39775 */     // GIR_Coverage, 65,
     /*  39775 */     GIR_EraseRootFromParent_Done,
     /*  39776 */   // Label 371: @39776
     /*  39776 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(39794), // Rule ID 53 //
     /*  39781 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13731>>  =>  (S_AND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  39781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
     /*  39786 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  39792 */     GIR_RootConstrainSelectedInstOperands,
     /*  39793 */     // GIR_Coverage, 53,
     /*  39793 */     GIR_Done,
     /*  39794 */   // Label 372: @39794
     /*  39794 */   GIM_Reject,
     /*  39795 */ // Label 369: @39795
     /*  39795 */ GIM_Reject,
     /*  39796 */ // Label 345: @39796
     /*  39796 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(39946),
     /*  39801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  39804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  39807 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(39866), // Rule ID 8612 //
     /*  39812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  39828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  39832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  39836 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  39844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39850 */     // (and:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  39850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  39857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39864 */     GIR_RootConstrainSelectedInstOperands,
     /*  39865 */     // GIR_Coverage, 8612,
     /*  39865 */     GIR_EraseRootFromParent_Done,
     /*  39866 */   // Label 374: @39866
     /*  39866 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(39925), // Rule ID 1884 //
     /*  39871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  39875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  39887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  39891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  39895 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  39903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39909 */     // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  39909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
     /*  39912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  39914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  39916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  39923 */     GIR_RootConstrainSelectedInstOperands,
     /*  39924 */     // GIR_Coverage, 1884,
     /*  39924 */     GIR_EraseRootFromParent_Done,
     /*  39925 */   // Label 375: @39925
     /*  39925 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(39945), // Rule ID 2529 //
     /*  39930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  39934 */     // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  39934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  39939 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  39943 */     GIR_RootConstrainSelectedInstOperands,
     /*  39944 */     // GIR_Coverage, 2529,
     /*  39944 */     GIR_Done,
     /*  39945 */   // Label 376: @39945
     /*  39945 */   GIM_Reject,
     /*  39946 */ // Label 373: @39946
     /*  39946 */ GIM_Reject,
     /*  39947 */ // Label 346: @39947
     /*  39947 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(40069),
     /*  39952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39958 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  39962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  39966 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(40017), // Rule ID 8614 //
     /*  39971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  39991 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39997 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  39999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40001 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  40001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40015 */     GIR_RootConstrainSelectedInstOperands,
     /*  40016 */     // GIR_Coverage, 8614,
     /*  40016 */     GIR_EraseRootFromParent_Done,
     /*  40017 */   // Label 378: @40017
     /*  40017 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(40068), // Rule ID 1886 //
     /*  40022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40042 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40052 */     // (and:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  40052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40066 */     GIR_RootConstrainSelectedInstOperands,
     /*  40067 */     // GIR_Coverage, 1886,
     /*  40067 */     GIR_EraseRootFromParent_Done,
     /*  40068 */   // Label 379: @40068
     /*  40068 */   GIM_Reject,
     /*  40069 */ // Label 377: @40069
     /*  40069 */ GIM_Reject,
     /*  40070 */ // Label 347: @40070
     /*  40070 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(40192),
     /*  40075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40081 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13731),
     /*  40085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40089 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(40140), // Rule ID 8613 //
     /*  40094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40114 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40124 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  40124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40129 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40138 */     GIR_RootConstrainSelectedInstOperands,
     /*  40139 */     // GIR_Coverage, 8613,
     /*  40139 */     GIR_EraseRootFromParent_Done,
     /*  40140 */   // Label 381: @40140
     /*  40140 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(40191), // Rule ID 1885 //
     /*  40145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  40157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40165 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40175 */     // (and:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13731>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  40175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
     /*  40178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40189 */     GIR_RootConstrainSelectedInstOperands,
     /*  40190 */     // GIR_Coverage, 1885,
     /*  40190 */     GIR_EraseRootFromParent_Done,
     /*  40191 */   // Label 382: @40191
     /*  40191 */   GIM_Reject,
     /*  40192 */ // Label 380: @40192
     /*  40192 */ GIM_Reject,
     /*  40193 */ // Label 348: @40193
     /*  40193 */ GIM_Reject,
     /*  40194 */ // Label 4: @40194
     /*  40194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 390*/ GIMT_Encode4(55705),
     /*  40205 */ /*GILLT_s1*//*Label 383*/ GIMT_Encode4(40245),
     /*  40209 */ /*GILLT_s16*//*Label 384*/ GIMT_Encode4(40308),
     /*  40213 */ /*GILLT_s32*//*Label 385*/ GIMT_Encode4(40548),
     /*  40217 */ /*GILLT_s64*//*Label 386*/ GIMT_Encode4(46119),
     /*  40221 */ /*GILLT_v2s16*//*Label 387*/ GIMT_Encode4(55308),
     /*  40225 */ /*GILLT_v2s32*//*Label 388*/ GIMT_Encode4(55459), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  40241 */ /*GILLT_v4s16*//*Label 389*/ GIMT_Encode4(55582),
     /*  40245 */ // Label 383: @40245
     /*  40245 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(40307),
     /*  40250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  40253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  40256 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(40281), // Rule ID 7546 //
     /*  40261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  40264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  40268 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  40268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
     /*  40273 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  40279 */     GIR_RootConstrainSelectedInstOperands,
     /*  40280 */     // GIR_Coverage, 7546,
     /*  40280 */     GIR_Done,
     /*  40281 */   // Label 392: @40281
     /*  40281 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(40306), // Rule ID 7553 //
     /*  40286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  40289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40293 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  40293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /*  40298 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  40304 */     GIR_RootConstrainSelectedInstOperands,
     /*  40305 */     // GIR_Coverage, 7553,
     /*  40305 */     GIR_Done,
     /*  40306 */   // Label 393: @40306
     /*  40306 */   GIM_Reject,
     /*  40307 */ // Label 391: @40307
     /*  40307 */ GIM_Reject,
     /*  40308 */ // Label 384: @40308
     /*  40308 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(40547),
     /*  40313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  40316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  40319 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(40370), // Rule ID 8615 //
     /*  40324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  40340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  40344 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  40348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  40352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40354 */     // (or:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  40354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  40357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  40361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40368 */     GIR_RootConstrainSelectedInstOperands,
     /*  40369 */     // GIR_Coverage, 8615,
     /*  40369 */     GIR_EraseRootFromParent_Done,
     /*  40370 */   // Label 395: @40370
     /*  40370 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(40421), // Rule ID 1887 //
     /*  40375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  40379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  40391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  40395 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  40399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  40403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40405 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
     /*  40405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  40408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  40410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  40412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  40419 */     GIR_RootConstrainSelectedInstOperands,
     /*  40420 */     // GIR_Coverage, 1887,
     /*  40420 */     GIR_EraseRootFromParent_Done,
     /*  40421 */   // Label 396: @40421
     /*  40421 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(40444), // Rule ID 2524 //
     /*  40426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  40429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40433 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  40433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  40438 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40442 */     GIR_RootConstrainSelectedInstOperands,
     /*  40443 */     // GIR_Coverage, 2524,
     /*  40443 */     GIR_Done,
     /*  40444 */   // Label 397: @40444
     /*  40444 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(40467), // Rule ID 2527 //
     /*  40449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  40452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40456 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  40456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  40461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40465 */     GIR_RootConstrainSelectedInstOperands,
     /*  40466 */     // GIR_Coverage, 2527,
     /*  40466 */     GIR_Done,
     /*  40467 */   // Label 398: @40467
     /*  40467 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(40523), // Rule ID 906 //
     /*  40472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  40475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  40479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  40486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  40493 */     // (or:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_OR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  40493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
     /*  40496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  40498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  40503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  40508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  40513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  40518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40521 */     GIR_RootConstrainSelectedInstOperands,
     /*  40522 */     // GIR_Coverage, 906,
     /*  40522 */     GIR_EraseRootFromParent_Done,
     /*  40523 */   // Label 399: @40523
     /*  40523 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(40546), // Rule ID 907 //
     /*  40528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  40531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40535 */     // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  40535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_fake16_e64),
     /*  40540 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  40544 */     GIR_RootConstrainSelectedInstOperands,
     /*  40545 */     // GIR_Coverage, 907,
     /*  40545 */     GIR_Done,
     /*  40546 */   // Label 400: @40546
     /*  40546 */   GIM_Reject,
     /*  40547 */ // Label 394: @40547
     /*  40547 */ GIM_Reject,
     /*  40548 */ // Label 385: @40548
     /*  40548 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(46118),
     /*  40553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  40556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  40559 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(40740), // Rule ID 8645 //
     /*  40564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  40567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  40583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  40587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  40603 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  40607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40615 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40619 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  40623 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-128),
     /*  40627 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 127,
     /*  40631 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  40642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  40646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  40650 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  40654 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  40658 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  40662 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40666 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  40670 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  40674 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  40678 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40682 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40686 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  40690 */     // MIs[6] src2
     /*  40690 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40695 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, uint8_t(-128),
     /*  40699 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/3, 127,
     /*  40703 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  40707 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40709 */     // (or:{ *:[i32] } (and:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 255:{ *:[i32] }), (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 8:{ *:[i32] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  40709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /*  40712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  40714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
     /*  40721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
     /*  40728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  40735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40738 */     GIR_RootConstrainSelectedInstOperands,
     /*  40739 */     // GIR_Coverage, 8645,
     /*  40739 */     GIR_EraseRootFromParent_Done,
     /*  40740 */   // Label 402: @40740
     /*  40740 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(40921), // Rule ID 2708 //
     /*  40745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  40748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  40760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  40764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  40768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  40784 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  40788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  40792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  40804 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-128),
     /*  40808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 127,
     /*  40812 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  40816 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  40820 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40824 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  40828 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  40832 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  40836 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40840 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  40844 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  40848 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /*  40852 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40856 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40860 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  40864 */     // MIs[6] src2
     /*  40864 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40869 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, uint8_t(-128),
     /*  40873 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/3, 127,
     /*  40877 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
     /*  40888 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40890 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 8:{ *:[i32] }), (and:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] }), 255:{ *:[i32] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  40890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /*  40893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  40895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src0
     /*  40902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  40909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  40916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40919 */     GIR_RootConstrainSelectedInstOperands,
     /*  40920 */     // GIR_Coverage, 2708,
     /*  40920 */     GIR_EraseRootFromParent_Done,
     /*  40921 */   // Label 403: @40921
     /*  40921 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(41089), // Rule ID 8646 //
     /*  40926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  40929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  40933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  40941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  40945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  40949 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  40953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  40961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  40969 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  40973 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/3, GIMT_Encode8(255),
     /*  40984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  40988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  40992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40996 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41008 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41012 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41016 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  41020 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41024 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41028 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41032 */     // MIs[5] src2
     /*  41032 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  41037 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /*  41041 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/3, GIMT_Encode8(255),
     /*  41052 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*  41056 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  41058 */     // (or:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), 8:{ *:[i32] }))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /*  41061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  41070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src1
     /*  41077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*  41084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41087 */     GIR_RootConstrainSelectedInstOperands,
     /*  41088 */     // GIR_Coverage, 8646,
     /*  41088 */     GIR_EraseRootFromParent_Done,
     /*  41089 */   // Label 404: @41089
     /*  41089 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(41257), // Rule ID 2709 //
     /*  41094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /*  41097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41133 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  41137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41145 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41149 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41153 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*  41157 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/3, GIMT_Encode8(255),
     /*  41168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  41172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  41176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
     /*  41180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  41184 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  41188 */     GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
     /*  41192 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  41196 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  41200 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  41204 */     // MIs[5] src2
     /*  41204 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41209 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /*  41213 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/3, GIMT_Encode8(255),
     /*  41224 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  41226 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }), 8:{ *:[i32] }), (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] }))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  41226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /*  41229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
     /*  41238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  41245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
     /*  41252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41255 */     GIR_RootConstrainSelectedInstOperands,
     /*  41256 */     // GIR_Coverage, 2709,
     /*  41256 */     GIR_EraseRootFromParent_Done,
     /*  41257 */   // Label 405: @41257
     /*  41257 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(41404), // Rule ID 11297 //
     /*  41262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41266 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41282 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41298 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41302 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41310 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41314 */     // MIs[3] x
     /*  41314 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  41323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41325 */     // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41325 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41328 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41332 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41337 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  41341 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41346 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41349 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41353 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41358 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
     /*  41362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41402 */     GIR_RootConstrainSelectedInstOperands,
     /*  41403 */     // GIR_Coverage, 11297,
     /*  41403 */     GIR_EraseRootFromParent_Done,
     /*  41404 */   // Label 406: @41404
     /*  41404 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(41551), // Rule ID 11296 //
     /*  41409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41413 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41429 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41445 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41449 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41457 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41461 */     // MIs[3] x
     /*  41461 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  41470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41472 */     // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41472 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41475 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41479 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41484 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  41488 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41493 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41496 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41500 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41505 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
     /*  41509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41549 */     GIR_RootConstrainSelectedInstOperands,
     /*  41550 */     // GIR_Coverage, 11296,
     /*  41550 */     GIR_EraseRootFromParent_Done,
     /*  41551 */   // Label 407: @41551
     /*  41551 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(41698), // Rule ID 11295 //
     /*  41556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41560 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41576 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41596 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41604 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41608 */     // MIs[3] x
     /*  41608 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  41617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41619 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41619 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41622 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41626 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41631 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  41635 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41652 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
     /*  41656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41696 */     GIR_RootConstrainSelectedInstOperands,
     /*  41697 */     // GIR_Coverage, 11295,
     /*  41697 */     GIR_EraseRootFromParent_Done,
     /*  41698 */   // Label 408: @41698
     /*  41698 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(41845), // Rule ID 11294 //
     /*  41703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41707 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41723 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  41743 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41751 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  41755 */     // MIs[3] x
     /*  41755 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  41764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41766 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41766 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41769 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41773 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41778 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  41782 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
     /*  41803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  41824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41843 */     GIR_RootConstrainSelectedInstOperands,
     /*  41844 */     // GIR_Coverage, 11294,
     /*  41844 */     GIR_EraseRootFromParent_Done,
     /*  41845 */   // Label 409: @41845
     /*  41845 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(41992), // Rule ID 11291 //
     /*  41850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41854 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41870 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  41874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  41886 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  41890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41894 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  41898 */     // MIs[3] x
     /*  41898 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41903 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  41907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  41911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41913 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  41913 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  41916 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41920 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41925 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  41929 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  41937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  41950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  41958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  41971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  41976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  41979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  41981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  41987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  41990 */     GIR_RootConstrainSelectedInstOperands,
     /*  41991 */     // GIR_Coverage, 11291,
     /*  41991 */     GIR_EraseRootFromParent_Done,
     /*  41992 */   // Label 410: @41992
     /*  41992 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(42139), // Rule ID 11293 //
     /*  41997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42001 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42017 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42033 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42045 */     // MIs[3] x
     /*  42045 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  42050 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  42058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42060 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42060 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42063 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42067 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42072 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42076 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42097 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  42118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42137 */     GIR_RootConstrainSelectedInstOperands,
     /*  42138 */     // GIR_Coverage, 11293,
     /*  42138 */     GIR_EraseRootFromParent_Done,
     /*  42139 */   // Label 411: @42139
     /*  42139 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(42286), // Rule ID 7455 //
     /*  42144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42148 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42164 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42180 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42192 */     // MIs[3] x
     /*  42192 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42197 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  42205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42207 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42207 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42210 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42214 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42219 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  42223 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42240 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  42244 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  42265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42284 */     GIR_RootConstrainSelectedInstOperands,
     /*  42285 */     // GIR_Coverage, 7455,
     /*  42285 */     GIR_EraseRootFromParent_Done,
     /*  42286 */   // Label 412: @42286
     /*  42286 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(42433), // Rule ID 11292 //
     /*  42291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42295 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42311 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  42315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42327 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42335 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  42339 */     // MIs[3] x
     /*  42339 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  42344 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  42348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  42352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42354 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  42354 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42357 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42361 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42366 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  42370 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42375 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42378 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42382 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42387 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42391 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  42412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  42431 */     GIR_RootConstrainSelectedInstOperands,
     /*  42432 */     // GIR_Coverage, 11292,
     /*  42432 */     GIR_EraseRootFromParent_Done,
     /*  42433 */   // Label 413: @42433
     /*  42433 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(42526), // Rule ID 2605 //
     /*  42438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  42441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42463 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  42467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42483 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*  42487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42495 */     // MIs[3] Operand 1
     /*  42495 */     // No operand predicates
     /*  42495 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  42499 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
     /*  42503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20823),
     /*  42507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42509 */     // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20813>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20823>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  42509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  42512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  42518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  42522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  42524 */     GIR_RootConstrainSelectedInstOperands,
     /*  42525 */     // GIR_Coverage, 2605,
     /*  42525 */     GIR_EraseRootFromParent_Done,
     /*  42526 */   // Label 414: @42526
     /*  42526 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(42619), // Rule ID 8630 //
     /*  42531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  42534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
     /*  42542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42560 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  42564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42580 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*  42584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42592 */     // MIs[3] Operand 1
     /*  42592 */     // No operand predicates
     /*  42592 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /*  42596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20823),
     /*  42600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42602 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20813>>)<<P:5:Predicate_anonymous_20823>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  42602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  42605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  42611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  42615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  42617 */     GIR_RootConstrainSelectedInstOperands,
     /*  42618 */     // GIR_Coverage, 8630,
     /*  42618 */     GIR_EraseRootFromParent_Done,
     /*  42619 */   // Label 415: @42619
     /*  42619 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(42804), // Rule ID 11342 //
     /*  42624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42628 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42644 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42660 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42668 */     // MIs[3] x
     /*  42668 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42673 */     // MIs[3] z
     /*  42673 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  42678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  42682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42684 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  42684 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  42687 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42691 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42696 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42700 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42705 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  42708 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42712 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42717 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42721 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42726 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42729 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42733 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42738 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42742 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42759 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  42763 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  42775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42780 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  42786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  42799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  42802 */     GIR_RootConstrainSelectedInstOperands,
     /*  42803 */     // GIR_Coverage, 11342,
     /*  42803 */     GIR_EraseRootFromParent_Done,
     /*  42804 */   // Label 416: @42804
     /*  42804 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(42989), // Rule ID 11343 //
     /*  42809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42813 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42829 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  42841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  42845 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42853 */     // MIs[3] z
     /*  42853 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  42858 */     // MIs[3] x
     /*  42858 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42863 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  42867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42869 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  42869 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  42872 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42876 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42881 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42885 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42890 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  42893 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42897 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42902 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  42906 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  42914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42923 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  42927 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  42935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  42948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  42956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  42960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42968 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  42971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  42976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  42978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  42984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  42987 */     GIR_RootConstrainSelectedInstOperands,
     /*  42988 */     // GIR_Coverage, 11343,
     /*  42988 */     GIR_EraseRootFromParent_Done,
     /*  42989 */   // Label 417: @42989
     /*  42989 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(43174), // Rule ID 11344 //
     /*  42994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  42998 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43014 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43030 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43038 */     // MIs[3] x
     /*  43038 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43043 */     // MIs[3] z
     /*  43043 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  43052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43054 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43054 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43057 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43061 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43066 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43070 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43075 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43078 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43082 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43087 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  43091 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43096 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43099 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43103 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43108 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43112 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  43133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43172 */     GIR_RootConstrainSelectedInstOperands,
     /*  43173 */     // GIR_Coverage, 11344,
     /*  43173 */     GIR_EraseRootFromParent_Done,
     /*  43174 */   // Label 418: @43174
     /*  43174 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(43359), // Rule ID 11345 //
     /*  43179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43183 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43199 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43215 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43223 */     // MIs[3] z
     /*  43223 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43228 */     // MIs[3] x
     /*  43228 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  43237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43239 */     // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43239 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43242 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43246 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43251 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43255 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43260 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43263 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43267 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43272 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  43276 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43293 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
     /*  43297 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  43318 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43338 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43357 */     GIR_RootConstrainSelectedInstOperands,
     /*  43358 */     // GIR_Coverage, 11345,
     /*  43358 */     GIR_EraseRootFromParent_Done,
     /*  43359 */   // Label 419: @43359
     /*  43359 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(43544), // Rule ID 11338 //
     /*  43364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43368 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43384 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43400 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43408 */     // MIs[3] x
     /*  43408 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43413 */     // MIs[3] z
     /*  43413 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  43422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43424 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43424 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43427 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43431 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43436 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43440 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43445 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43448 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43452 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43457 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43461 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43466 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43469 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43473 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43478 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43482 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43487 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43490 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43494 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43503 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43520 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43523 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43542 */     GIR_RootConstrainSelectedInstOperands,
     /*  43543 */     // GIR_Coverage, 11338,
     /*  43543 */     GIR_EraseRootFromParent_Done,
     /*  43544 */   // Label 420: @43544
     /*  43544 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(43729), // Rule ID 11339 //
     /*  43549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43553 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43569 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43585 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43593 */     // MIs[3] z
     /*  43593 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43598 */     // MIs[3] x
     /*  43598 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  43607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43609 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43609 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43612 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43616 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43621 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43625 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43630 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43633 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43637 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43642 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  43646 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43651 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43654 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43658 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43663 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43667 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43672 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43675 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43679 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43684 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
     /*  43688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43727 */     GIR_RootConstrainSelectedInstOperands,
     /*  43728 */     // GIR_Coverage, 11339,
     /*  43728 */     GIR_EraseRootFromParent_Done,
     /*  43729 */   // Label 421: @43729
     /*  43729 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(43914), // Rule ID 11340 //
     /*  43734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43738 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43754 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43770 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43778 */     // MIs[3] x
     /*  43778 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43783 */     // MIs[3] z
     /*  43783 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  43792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43794 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43794 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43797 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43801 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43806 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43810 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43815 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  43818 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43822 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43827 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  43831 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43836 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  43839 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43843 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43848 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43852 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  43860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  43873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  43881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  43885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43890 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  43896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  43901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  43903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  43909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  43912 */     GIR_RootConstrainSelectedInstOperands,
     /*  43913 */     // GIR_Coverage, 11340,
     /*  43913 */     GIR_EraseRootFromParent_Done,
     /*  43914 */   // Label 422: @43914
     /*  43914 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(44099), // Rule ID 11341 //
     /*  43919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  43923 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  43935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  43939 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  43951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  43955 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43963 */     // MIs[3] z
     /*  43963 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43968 */     // MIs[3] x
     /*  43968 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  43973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  43977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  43979 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  43979 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  43982 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43986 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43991 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  43995 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44000 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44003 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44007 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44012 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  44016 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44033 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
     /*  44037 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
     /*  44058 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44075 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44078 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44097 */     GIR_RootConstrainSelectedInstOperands,
     /*  44098 */     // GIR_Coverage, 11341,
     /*  44098 */     GIR_EraseRootFromParent_Done,
     /*  44099 */   // Label 423: @44099
     /*  44099 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(44284), // Rule ID 11332 //
     /*  44104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44108 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44124 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44140 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44148 */     // MIs[3] x
     /*  44148 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44153 */     // MIs[3] z
     /*  44153 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  44162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44164 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44164 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44167 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44171 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44176 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44180 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44185 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44188 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44192 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44197 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  44201 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44206 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44209 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44213 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44218 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44222 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  44243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44260 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44282 */     GIR_RootConstrainSelectedInstOperands,
     /*  44283 */     // GIR_Coverage, 11332,
     /*  44283 */     GIR_EraseRootFromParent_Done,
     /*  44284 */   // Label 424: @44284
     /*  44284 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(44469), // Rule ID 11333 //
     /*  44289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44293 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44309 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44325 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44333 */     // MIs[3] z
     /*  44333 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44338 */     // MIs[3] x
     /*  44338 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  44347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44349 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44349 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44352 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44356 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44361 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44365 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44370 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44373 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44377 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44382 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  44386 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44391 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44394 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44398 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44403 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44407 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44424 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  44428 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44467 */     GIR_RootConstrainSelectedInstOperands,
     /*  44468 */     // GIR_Coverage, 11333,
     /*  44468 */     GIR_EraseRootFromParent_Done,
     /*  44469 */   // Label 425: @44469
     /*  44469 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(44654), // Rule ID 11336 //
     /*  44474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44478 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44494 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44510 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44518 */     // MIs[3] x
     /*  44518 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44523 */     // MIs[3] z
     /*  44523 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  44532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44534 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44534 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44537 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44541 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44546 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44550 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44555 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44558 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44562 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44567 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  44571 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44588 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44592 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44609 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  44613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44633 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44652 */     GIR_RootConstrainSelectedInstOperands,
     /*  44653 */     // GIR_Coverage, 11336,
     /*  44653 */     GIR_EraseRootFromParent_Done,
     /*  44654 */   // Label 426: @44654
     /*  44654 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(44839), // Rule ID 11337 //
     /*  44659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44663 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44679 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44695 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44703 */     // MIs[3] z
     /*  44703 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44708 */     // MIs[3] x
     /*  44708 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  44717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44719 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44719 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44722 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44726 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44731 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44735 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44740 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44743 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44747 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44752 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  44756 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44761 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44764 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44768 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44773 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  44777 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44794 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  44798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44818 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  44821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  44826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  44828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  44834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  44837 */     GIR_RootConstrainSelectedInstOperands,
     /*  44838 */     // GIR_Coverage, 11337,
     /*  44838 */     GIR_EraseRootFromParent_Done,
     /*  44839 */   // Label 427: @44839
     /*  44839 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(45024), // Rule ID 7709 //
     /*  44844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44848 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  44860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  44864 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  44876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  44880 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44888 */     // MIs[3] x
     /*  44888 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  44893 */     // MIs[3] z
     /*  44893 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  44898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  44902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44904 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  44904 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  44907 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44911 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44916 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  44920 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44925 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  44928 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44932 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44937 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  44941 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  44949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44958 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  44962 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  44970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  44983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  44988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  44991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  44995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45003 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45022 */     GIR_RootConstrainSelectedInstOperands,
     /*  45023 */     // GIR_Coverage, 7709,
     /*  45023 */     GIR_EraseRootFromParent_Done,
     /*  45024 */   // Label 428: @45024
     /*  45024 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(45209), // Rule ID 11331 //
     /*  45029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45033 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45049 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45065 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45069 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45073 */     // MIs[3] z
     /*  45073 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45078 */     // MIs[3] x
     /*  45078 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  45087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45089 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45089 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45092 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45096 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45101 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45105 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45110 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45113 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45117 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45122 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
     /*  45126 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45131 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45134 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45138 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45143 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45147 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45152 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45155 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45159 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  45168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45188 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45207 */     GIR_RootConstrainSelectedInstOperands,
     /*  45208 */     // GIR_Coverage, 11331,
     /*  45208 */     GIR_EraseRootFromParent_Done,
     /*  45209 */   // Label 429: @45209
     /*  45209 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(45394), // Rule ID 11334 //
     /*  45214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45218 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45234 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45250 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45258 */     // MIs[3] x
     /*  45258 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45263 */     // MIs[3] z
     /*  45263 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  45272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45274 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45274 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45277 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45281 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45286 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45290 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45295 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45298 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45302 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45307 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  45311 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45328 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45332 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45349 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  45353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45392 */     GIR_RootConstrainSelectedInstOperands,
     /*  45393 */     // GIR_Coverage, 11334,
     /*  45393 */     GIR_EraseRootFromParent_Done,
     /*  45394 */   // Label 430: @45394
     /*  45394 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(45579), // Rule ID 11335 //
     /*  45399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45403 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45419 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  45431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  45435 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45443 */     // MIs[3] z
     /*  45443 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45448 */     // MIs[3] x
     /*  45448 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  45457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45459 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19649>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
     /*  45459 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  45462 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45466 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45471 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45475 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45480 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /*  45483 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45487 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45492 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
     /*  45496 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45501 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  45504 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45508 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45513 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  45517 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  45525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  45538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  45546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  45550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45555 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45558 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  45561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  45566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  45571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  45574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  45577 */     GIR_RootConstrainSelectedInstOperands,
     /*  45578 */     // GIR_Coverage, 11335,
     /*  45578 */     GIR_EraseRootFromParent_Done,
     /*  45579 */   // Label 431: @45579
     /*  45579 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(45630), // Rule ID 8542 //
     /*  45584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  45588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45604 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  45608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  45612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45614 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  45614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  45617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  45619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  45621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  45628 */     GIR_RootConstrainSelectedInstOperands,
     /*  45629 */     // GIR_Coverage, 8542,
     /*  45629 */     GIR_EraseRootFromParent_Done,
     /*  45630 */   // Label 432: @45630
     /*  45630 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(45681), // Rule ID 66 //
     /*  45635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  45639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45655 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  45659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  45663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45665 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  45665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  45668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  45670 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  45672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  45676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  45679 */     GIR_RootConstrainSelectedInstOperands,
     /*  45680 */     // GIR_Coverage, 66,
     /*  45680 */     GIR_EraseRootFromParent_Done,
     /*  45681 */   // Label 433: @45681
     /*  45681 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(45746), // Rule ID 2606 //
     /*  45686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45711 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*  45715 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*  45719 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:6:z
     /*  45723 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20825),
     /*  45727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45729 */     // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20826>>, i32:{ *:[i32] }:$src2:$pred:6:z)<<P:6:Predicate_anonymous_20825>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
     /*  45732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45744 */     GIR_RootConstrainSelectedInstOperands,
     /*  45745 */     // GIR_Coverage, 2606,
     /*  45745 */     GIR_EraseRootFromParent_Done,
     /*  45746 */   // Label 434: @45746
     /*  45746 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(45811), // Rule ID 2607 //
     /*  45751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45774 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45776 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*  45780 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*  45784 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:7:z
     /*  45788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20828),
     /*  45792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45794 */     // (or:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20829>>, i32:{ *:[i32] }:$src2:$pred:7:z)<<P:7:Predicate_anonymous_20828>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
     /*  45797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45807 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45809 */     GIR_RootConstrainSelectedInstOperands,
     /*  45810 */     // GIR_Coverage, 2607,
     /*  45810 */     GIR_EraseRootFromParent_Done,
     /*  45811 */   // Label 435: @45811
     /*  45811 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(45876), // Rule ID 2604 //
     /*  45816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  45831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45841 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  45845 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*  45849 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
     /*  45853 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20823),
     /*  45857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45859 */     // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20813>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20823>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  45862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45872 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  45874 */     GIR_RootConstrainSelectedInstOperands,
     /*  45875 */     // GIR_Coverage, 2604,
     /*  45875 */     GIR_EraseRootFromParent_Done,
     /*  45876 */   // Label 436: @45876
     /*  45876 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(45941), // Rule ID 8631 //
     /*  45881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45888 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:6:z
     /*  45892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45910 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*  45914 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*  45918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20825),
     /*  45922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45924 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:6:z, (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20826>>)<<P:6:Predicate_anonymous_20825>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
     /*  45927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  45937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  45939 */     GIR_RootConstrainSelectedInstOperands,
     /*  45940 */     // GIR_Coverage, 8631,
     /*  45940 */     GIR_EraseRootFromParent_Done,
     /*  45941 */   // Label 437: @45941
     /*  45941 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(46006), // Rule ID 8632 //
     /*  45946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  45949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  45953 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:7:z
     /*  45957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  45969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  45973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  45975 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*  45979 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*  45983 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20828),
     /*  45987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45989 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:7:z, (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20829>>)<<P:7:Predicate_anonymous_20828>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  45989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
     /*  45992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  45994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  45998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46002 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46004 */     GIR_RootConstrainSelectedInstOperands,
     /*  46005 */     // GIR_Coverage, 8632,
     /*  46005 */     GIR_EraseRootFromParent_Done,
     /*  46006 */   // Label 438: @46006
     /*  46006 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(46071), // Rule ID 8629 //
     /*  46011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  46014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46018 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
     /*  46022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  46030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  46034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  46038 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  46040 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*  46044 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*  46048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20823),
     /*  46052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46054 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20813>>)<<P:5:Predicate_anonymous_20823>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  46054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  46057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  46059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  46063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  46067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46069 */     GIR_RootConstrainSelectedInstOperands,
     /*  46070 */     // GIR_Coverage, 8629,
     /*  46070 */     GIR_EraseRootFromParent_Done,
     /*  46071 */   // Label 439: @46071
     /*  46071 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(46097), // Rule ID 54 //
     /*  46076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  46080 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  46084 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13732>>  =>  (S_OR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  46084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /*  46089 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  46095 */     GIR_RootConstrainSelectedInstOperands,
     /*  46096 */     // GIR_Coverage, 54,
     /*  46096 */     GIR_Done,
     /*  46097 */   // Label 440: @46097
     /*  46097 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(46117), // Rule ID 816 //
     /*  46102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46106 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_OR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  46106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  46111 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  46115 */     GIR_RootConstrainSelectedInstOperands,
     /*  46116 */     // GIR_Coverage, 816,
     /*  46116 */     GIR_Done,
     /*  46117 */   // Label 441: @46117
     /*  46117 */   GIM_Reject,
     /*  46118 */ // Label 401: @46118
     /*  46118 */ GIM_Reject,
     /*  46119 */ // Label 386: @46119
     /*  46119 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(55307),
     /*  46124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  46127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  46130 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(46445), // Rule ID 11305 //
     /*  46135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46139 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46155 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46171 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46175 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46187 */     // MIs[3] x
     /*  46187 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  46196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46198 */     // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  46198 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  46201 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46205 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46210 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  46216 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46221 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46226 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  46229 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46233 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46238 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  46244 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46249 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46254 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  46257 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46261 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46266 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  46272 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46277 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46282 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  46285 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46289 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46294 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  46297 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  46300 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  46303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  46305 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46308 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46312 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46317 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  46323 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46328 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46333 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46336 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46340 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46345 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  46351 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46356 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46373 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  46379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  46392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46401 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46404 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  46410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  46415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46420 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  46423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  46426 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  46429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46444 */     // GIR_Coverage, 11305,
     /*  46444 */     GIR_EraseRootFromParent_Done,
     /*  46445 */   // Label 443: @46445
     /*  46445 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(46760), // Rule ID 11304 //
     /*  46450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46454 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46470 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46486 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46490 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  46502 */     // MIs[3] x
     /*  46502 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  46511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46513 */     // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  46513 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  46516 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46520 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46525 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  46531 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46536 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46541 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  46544 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46548 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46553 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  46559 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46564 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46569 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  46572 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46576 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46581 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  46587 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46592 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46597 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  46600 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46604 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46609 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  46612 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  46615 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  46618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  46620 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46623 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46627 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46632 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  46638 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46643 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46660 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  46666 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46671 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46688 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  46694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  46707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  46722 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  46725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  46730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46735 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  46738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  46741 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  46744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46759 */     // GIR_Coverage, 11304,
     /*  46759 */     GIR_EraseRootFromParent_Done,
     /*  46760 */   // Label 444: @46760
     /*  46760 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(47075), // Rule ID 11303 //
     /*  46765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46769 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  46781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  46785 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  46797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  46801 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  46805 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46813 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46817 */     // MIs[3] x
     /*  46817 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  46822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  46826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46828 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  46828 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  46831 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46835 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46840 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  46846 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46851 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46856 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  46859 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46863 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46868 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  46874 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46879 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46884 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  46887 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46891 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46896 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  46902 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46907 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46912 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  46915 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  46919 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46924 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  46927 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  46930 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  46933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  46935 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  46938 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46942 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46947 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  46953 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46958 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46975 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  46981 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  46986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  46991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47003 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47031 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47050 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47056 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47074 */     // GIR_Coverage, 11303,
     /*  47074 */     GIR_EraseRootFromParent_Done,
     /*  47075 */   // Label 445: @47075
     /*  47075 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(47390), // Rule ID 11302 //
     /*  47080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47084 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47100 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47116 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  47120 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  47132 */     // MIs[3] x
     /*  47132 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  47137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  47141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47143 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47143 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47146 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47150 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47155 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47161 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47166 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47171 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47174 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47178 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47183 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47189 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47194 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47199 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47202 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47206 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47211 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47217 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47222 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47227 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47230 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47234 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47239 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47242 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47245 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47250 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47253 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47257 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47262 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47268 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47273 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47290 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47296 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47301 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47318 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47329 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47346 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47349 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47365 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47371 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47389 */     // GIR_Coverage, 11302,
     /*  47389 */     GIR_EraseRootFromParent_Done,
     /*  47390 */   // Label 446: @47390
     /*  47390 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(47705), // Rule ID 11299 //
     /*  47395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47399 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47415 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47431 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47439 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47443 */     // MIs[3] x
     /*  47443 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  47448 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  47452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  47456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47458 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47458 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47461 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47465 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47470 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47476 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47481 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47486 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47489 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47493 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47498 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47504 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47509 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47514 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47517 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47521 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47526 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47532 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47537 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47542 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47545 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47549 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47554 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47557 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47560 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47565 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47568 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47572 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47577 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47583 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47588 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47593 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47596 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47600 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47605 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47611 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47616 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47633 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47680 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  47686 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  47689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47704 */     // GIR_Coverage, 11299,
     /*  47704 */     GIR_EraseRootFromParent_Done,
     /*  47705 */   // Label 447: @47705
     /*  47705 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(48020), // Rule ID 11301 //
     /*  47710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47714 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  47726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  47730 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  47742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  47746 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47754 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47758 */     // MIs[3] x
     /*  47758 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  47763 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  47767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  47771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47773 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  47773 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  47776 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47780 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47785 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  47791 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47796 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47801 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  47804 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47808 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47813 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  47819 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47824 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47829 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  47832 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47836 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47841 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  47847 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47852 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47857 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  47860 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47864 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47869 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  47872 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  47875 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  47878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  47880 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47883 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47887 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47892 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  47898 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47903 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47908 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47911 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47915 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47920 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  47926 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47931 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  47939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47948 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  47954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  47959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  47964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  47967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  47971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47976 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  47985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  47990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47995 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  47998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48001 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48019 */     // GIR_Coverage, 11301,
     /*  48019 */     GIR_EraseRootFromParent_Done,
     /*  48020 */   // Label 448: @48020
     /*  48020 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(48335), // Rule ID 7457 //
     /*  48025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48029 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48045 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48061 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48069 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48073 */     // MIs[3] x
     /*  48073 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  48078 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  48082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  48086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48088 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48088 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  48091 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48095 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48100 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48106 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48111 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48116 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  48119 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48123 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48128 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48134 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48139 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48144 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48147 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48151 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48156 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48162 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48167 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48172 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48175 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48179 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48184 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48187 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48190 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48195 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48198 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48202 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48207 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48213 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48218 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48223 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48226 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48230 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48235 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48241 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48246 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48263 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48310 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48316 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48334 */     // GIR_Coverage, 7457,
     /*  48334 */     GIR_EraseRootFromParent_Done,
     /*  48335 */   // Label 449: @48335
     /*  48335 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(48650), // Rule ID 11300 //
     /*  48340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48344 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48360 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48376 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48384 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48388 */     // MIs[3] x
     /*  48388 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  48393 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
     /*  48397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  48401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48403 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48403 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  48406 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48410 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48415 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48421 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48426 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48431 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  48434 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48438 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48443 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48449 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48454 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48459 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48462 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48466 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48471 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48482 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48487 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  48490 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48494 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48499 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  48502 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  48505 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  48508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  48510 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48513 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48517 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48522 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48528 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48533 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48550 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48556 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48561 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48578 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  48597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48609 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  48612 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  48615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  48620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48625 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  48628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  48631 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  48634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48649 */     // GIR_Coverage, 11300,
     /*  48649 */     GIR_EraseRootFromParent_Done,
     /*  48650 */   // Label 450: @48650
     /*  48650 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(49058), // Rule ID 11357 //
     /*  48655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48659 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  48671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48675 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  48687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48691 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  48695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48699 */     // MIs[3] x
     /*  48699 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  48704 */     // MIs[3] z
     /*  48704 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  48709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  48713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48715 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  48715 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  48718 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48722 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48727 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48733 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48738 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48743 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  48746 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48750 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48755 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  48761 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48766 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48771 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  48774 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48778 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48783 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  48789 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48794 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48799 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  48802 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48806 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48811 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  48817 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48822 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48827 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  48830 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  48834 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48839 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  48842 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  48845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  48847 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  48850 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  48854 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48859 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  48862 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  48865 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  48868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  48870 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  48873 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48877 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48882 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48888 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48893 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48898 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  48901 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48905 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48910 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  48916 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48921 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48926 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  48929 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48933 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48938 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  48944 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48949 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  48957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48966 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  48972 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  48977 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  48982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  48985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  48989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48994 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  48997 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  49017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  49020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  49023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  49028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  49033 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  49036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  49039 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  49042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49057 */     // GIR_Coverage, 11357,
     /*  49057 */     GIR_EraseRootFromParent_Done,
     /*  49058 */   // Label 451: @49058
     /*  49058 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(49466), // Rule ID 11358 //
     /*  49063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49067 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  49079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49083 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  49091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  49095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49099 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  49103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49107 */     // MIs[3] z
     /*  49107 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  49112 */     // MIs[3] x
     /*  49112 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  49117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  49121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49123 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  49123 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  49126 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49130 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49135 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49141 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49146 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49151 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  49154 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49158 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49163 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  49169 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49174 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49179 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  49182 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49186 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49191 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49197 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49202 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49207 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  49210 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49214 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49219 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  49225 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49230 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49235 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49238 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49242 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49247 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49250 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49255 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49258 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49262 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49267 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49270 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49273 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49278 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49281 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49285 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49290 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49296 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49301 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49306 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49309 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49313 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49318 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49324 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49329 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49334 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49337 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49341 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49346 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49352 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49357 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49362 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49365 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49369 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49374 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49380 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49385 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49402 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49405 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  49425 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  49428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  49431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  49436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  49441 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  49444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  49447 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  49450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49465 */     // GIR_Coverage, 11358,
     /*  49465 */     GIR_EraseRootFromParent_Done,
     /*  49466 */   // Label 452: @49466
     /*  49466 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(49874), // Rule ID 11359 //
     /*  49471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49475 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  49487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49491 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  49499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  49503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49507 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  49511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49515 */     // MIs[3] x
     /*  49515 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  49520 */     // MIs[3] z
     /*  49520 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  49525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  49529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49531 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  49531 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  49534 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49538 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49543 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49549 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49554 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49559 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  49562 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49566 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49571 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  49577 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49582 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49587 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  49590 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49594 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49599 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49605 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49610 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49615 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  49618 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49622 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49627 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  49633 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49638 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49643 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  49646 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49650 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49655 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  49658 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  49661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  49663 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  49666 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49670 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49675 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  49678 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  49681 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  49684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  49686 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  49689 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49693 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49698 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49704 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49709 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49714 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  49717 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49721 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49726 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  49732 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49737 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49742 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  49745 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49749 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49754 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  49760 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49765 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  49773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49782 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  49788 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49793 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49798 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  49801 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  49805 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49810 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  49813 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  49816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  49818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  49821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  49825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  49833 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  49836 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  49839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  49844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  49849 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  49852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  49855 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  49858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49873 */     // GIR_Coverage, 11359,
     /*  49873 */     GIR_EraseRootFromParent_Done,
     /*  49874 */   // Label 453: @49874
     /*  49874 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(50282), // Rule ID 11360 //
     /*  49879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49883 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  49895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49899 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  49907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  49911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49915 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  49919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  49923 */     // MIs[3] z
     /*  49923 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  49928 */     // MIs[3] x
     /*  49928 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  49933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  49937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49939 */     // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  49939 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  49942 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49946 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49951 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  49957 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49962 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49967 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  49970 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49974 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49979 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  49985 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  49990 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  49995 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  49998 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50002 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50007 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50013 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50018 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50023 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  50026 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50030 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50035 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  50041 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50046 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50051 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  50054 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50058 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50063 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  50066 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  50069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  50071 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  50074 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50078 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50083 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  50086 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  50089 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  50092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  50094 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  50097 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50101 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50106 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50112 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50117 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50122 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  50125 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50129 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50134 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  50140 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50145 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50150 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  50153 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50157 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50162 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50168 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50173 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  50181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50190 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  50196 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50201 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  50209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  50221 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  50224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  50226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  50229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50257 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50263 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50281 */     // GIR_Coverage, 11360,
     /*  50281 */     GIR_EraseRootFromParent_Done,
     /*  50282 */   // Label 454: @50282
     /*  50282 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(50690), // Rule ID 11353 //
     /*  50287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50291 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50307 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50323 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50331 */     // MIs[3] x
     /*  50331 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50336 */     // MIs[3] z
     /*  50336 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  50345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50347 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50347 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50350 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50354 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50359 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50365 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50370 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50375 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50378 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50382 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50387 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50393 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50398 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50403 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50406 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50410 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50415 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50421 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50426 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50431 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  50434 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50438 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50443 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  50449 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50454 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50459 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  50462 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50466 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50471 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  50474 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  50477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  50479 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  50482 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50486 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50491 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  50494 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  50497 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  50500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  50502 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  50505 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50509 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50514 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50520 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50525 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50530 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  50533 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50537 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50542 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  50548 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50553 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50558 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  50561 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50565 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50570 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50576 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50581 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50586 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  50589 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50593 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50598 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  50604 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50609 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50614 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  50617 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50621 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50626 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  50629 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  50632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  50634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  50637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  50649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  50652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  50655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  50660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50665 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  50668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  50671 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  50674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50689 */     // GIR_Coverage, 11353,
     /*  50689 */     GIR_EraseRootFromParent_Done,
     /*  50690 */   // Label 455: @50690
     /*  50690 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(51098), // Rule ID 11354 //
     /*  50695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50699 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50715 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  50719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  50723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50731 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  50735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50739 */     // MIs[3] z
     /*  50739 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  50744 */     // MIs[3] x
     /*  50744 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  50749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  50753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  50755 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  50755 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  50758 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50762 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50767 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50773 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50778 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50783 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  50786 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50790 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50795 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  50801 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50806 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50811 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  50814 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50818 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50823 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  50829 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50834 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50839 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  50842 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50846 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50851 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  50857 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50862 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50867 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  50870 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  50874 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50879 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  50882 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  50885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  50887 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  50890 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  50894 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50899 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  50902 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  50905 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  50908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  50910 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  50913 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50917 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50922 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50928 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50933 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50938 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  50941 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50945 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50950 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  50956 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50961 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50966 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  50969 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50973 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50978 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  50984 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  50989 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  50994 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  50997 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51001 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51006 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  51012 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51017 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  51025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51034 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  51037 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  51040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  51045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51057 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  51060 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  51063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  51068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51073 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  51076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  51079 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  51082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51097 */     // GIR_Coverage, 11354,
     /*  51097 */     GIR_EraseRootFromParent_Done,
     /*  51098 */   // Label 456: @51098
     /*  51098 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(51506), // Rule ID 11355 //
     /*  51103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51107 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51123 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  51131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51139 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  51143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51147 */     // MIs[3] x
     /*  51147 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  51152 */     // MIs[3] z
     /*  51152 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  51157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  51161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51163 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  51163 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  51166 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51170 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51175 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51181 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51186 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51191 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  51194 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51198 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51203 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  51209 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51214 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51219 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  51222 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51226 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51231 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51237 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51242 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51247 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51250 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51254 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51259 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51265 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51270 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51275 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51278 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51282 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51287 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51290 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51295 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51298 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51302 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51307 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51310 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51313 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51318 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51321 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51325 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51330 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51336 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51341 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51346 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51349 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51353 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51358 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51364 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51369 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51374 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51377 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51381 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51386 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51392 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51397 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51402 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51405 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51409 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51414 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  51420 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51425 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51430 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  51433 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51437 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51442 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  51445 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  51448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  51453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51465 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  51468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  51471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  51476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51481 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  51484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  51487 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  51490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51505 */     // GIR_Coverage, 11355,
     /*  51505 */     GIR_EraseRootFromParent_Done,
     /*  51506 */   // Label 457: @51506
     /*  51506 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(51914), // Rule ID 11356 //
     /*  51511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51515 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51531 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  51539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51547 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  51551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51555 */     // MIs[3] z
     /*  51555 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  51560 */     // MIs[3] x
     /*  51560 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  51565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  51569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51571 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  51571 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  51574 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51578 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51583 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51589 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51594 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51599 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  51602 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51606 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51611 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  51617 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51622 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51627 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  51630 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51634 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51639 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51645 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51650 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51655 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  51658 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51662 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51667 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  51673 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51678 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51683 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  51686 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51690 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51695 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  51698 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  51701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  51703 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  51706 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51710 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51715 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  51718 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  51721 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  51724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  51726 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  51729 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51733 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51738 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51744 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51749 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51754 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  51757 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51761 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51766 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  51772 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51777 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51782 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  51785 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51789 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51794 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  51800 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51805 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51810 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  51813 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51817 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51822 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  51828 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51833 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  51841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  51845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51850 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  51853 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  51856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  51861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  51865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51870 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  51873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  51876 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  51879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  51884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51889 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  51892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  51895 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  51898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  51913 */     // GIR_Coverage, 11356,
     /*  51913 */     GIR_EraseRootFromParent_Done,
     /*  51914 */   // Label 458: @51914
     /*  51914 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(52322), // Rule ID 11347 //
     /*  51919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  51923 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51939 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51955 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  51959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  51963 */     // MIs[3] x
     /*  51963 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  51968 */     // MIs[3] z
     /*  51968 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  51973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  51977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51979 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  51979 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  51982 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51986 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51991 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  51997 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52002 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52007 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  52010 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52014 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52019 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  52025 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52030 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52035 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  52038 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52042 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52047 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52053 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52058 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52063 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  52066 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52070 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52075 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  52081 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52086 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52091 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  52094 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52098 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52103 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  52106 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  52109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  52111 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  52114 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52118 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52123 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  52126 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  52129 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  52132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  52134 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  52137 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52141 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52146 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52152 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52157 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52162 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  52165 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52169 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52174 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  52180 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52185 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52190 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  52193 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52197 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52202 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52208 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52213 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52218 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  52221 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52225 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52230 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52236 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52241 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52258 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52261 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52278 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52281 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52297 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52303 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52321 */     // GIR_Coverage, 11347,
     /*  52321 */     GIR_EraseRootFromParent_Done,
     /*  52322 */   // Label 459: @52322
     /*  52322 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(52730), // Rule ID 11348 //
     /*  52327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52331 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52347 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52363 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52371 */     // MIs[3] z
     /*  52371 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52376 */     // MIs[3] x
     /*  52376 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  52385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52387 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52387 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52390 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52394 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52399 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52405 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52410 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52415 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  52418 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52422 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52427 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  52433 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52438 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52443 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  52446 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52450 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52455 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52461 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52466 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52471 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  52474 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52478 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52483 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  52489 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52494 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52499 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  52502 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52506 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52511 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  52514 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  52517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  52519 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  52522 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52526 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52531 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  52534 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  52537 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  52540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  52542 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  52545 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52549 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52554 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52560 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52565 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52570 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  52573 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52577 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52582 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  52588 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52593 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52598 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  52601 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52605 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52610 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52616 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52621 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52626 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  52629 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52633 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52638 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  52644 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52649 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52654 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  52657 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52661 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52666 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  52669 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  52672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  52677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52686 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  52689 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  52692 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  52695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  52700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52705 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  52708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  52711 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  52714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52729 */     // GIR_Coverage, 11348,
     /*  52729 */     GIR_EraseRootFromParent_Done,
     /*  52730 */   // Label 460: @52730
     /*  52730 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(53138), // Rule ID 11351 //
     /*  52735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52739 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52755 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52771 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  52775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  52779 */     // MIs[3] x
     /*  52779 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  52784 */     // MIs[3] z
     /*  52784 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  52789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  52793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52795 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  52795 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  52798 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52802 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52807 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52813 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52818 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52823 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  52826 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52830 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52835 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  52841 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52846 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52851 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  52854 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52858 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52863 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  52869 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52874 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52879 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  52882 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52886 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52891 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  52897 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52902 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52907 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  52910 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  52914 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52919 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  52922 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  52925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  52927 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  52930 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  52934 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52939 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  52942 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  52945 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  52948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  52950 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  52953 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52957 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52962 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  52968 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  52973 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  52978 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  52981 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52985 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52990 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  52996 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53001 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53006 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  53009 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53013 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53018 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53024 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53029 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  53037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53046 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  53052 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53057 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  53065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53074 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  53077 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  53080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  53085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53094 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53097 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  53100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  53103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  53108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53113 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  53116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  53119 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  53122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53137 */     // GIR_Coverage, 11351,
     /*  53137 */     GIR_EraseRootFromParent_Done,
     /*  53138 */   // Label 461: @53138
     /*  53138 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(53546), // Rule ID 11352 //
     /*  53143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53147 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53163 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53179 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  53183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53187 */     // MIs[3] z
     /*  53187 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  53192 */     // MIs[3] x
     /*  53192 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  53197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  53201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53203 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  53203 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  53206 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53210 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53215 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53221 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53226 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53231 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53234 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53238 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53243 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53249 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53254 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53259 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53262 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53266 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53271 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53277 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53282 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53287 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53290 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53294 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53299 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53305 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53310 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53315 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53318 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53322 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53327 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53330 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53335 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53338 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53342 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53347 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53350 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53353 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53358 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53361 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53365 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53370 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53376 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53381 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53386 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53389 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53393 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53398 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53404 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53409 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53414 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  53417 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53421 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53426 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53432 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53437 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53442 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  53445 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53449 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53454 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  53460 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53465 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53470 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  53473 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53477 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53482 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  53485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  53488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  53493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53502 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  53508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  53511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  53516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53521 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  53524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  53527 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  53530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53545 */     // GIR_Coverage, 11352,
     /*  53545 */     GIR_EraseRootFromParent_Done,
     /*  53546 */   // Label 462: @53546
     /*  53546 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(53954), // Rule ID 7710 //
     /*  53551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53555 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53571 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53587 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53595 */     // MIs[3] x
     /*  53595 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  53600 */     // MIs[3] z
     /*  53600 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  53605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  53609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53611 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  53611 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  53614 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53618 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53623 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53629 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53634 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53639 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  53642 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53646 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53651 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  53657 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53662 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53667 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  53670 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53674 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53679 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  53685 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53690 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53695 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  53698 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53702 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53707 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  53713 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53718 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53723 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  53726 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53730 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53735 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  53738 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  53741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  53743 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  53746 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53750 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53755 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  53758 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  53761 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  53764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  53766 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  53769 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53773 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53778 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53784 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53789 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53794 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  53797 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53801 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53806 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  53812 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53817 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53822 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  53825 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53829 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53834 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  53840 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53845 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  53853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53862 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  53868 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53873 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  53881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  53885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  53893 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  53896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  53901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  53905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53913 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  53916 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  53919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  53924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53929 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  53932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  53935 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  53938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  53953 */     // GIR_Coverage, 7710,
     /*  53953 */     GIR_EraseRootFromParent_Done,
     /*  53954 */   // Label 463: @53954
     /*  53954 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(54362), // Rule ID 11346 //
     /*  53959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  53963 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53979 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53995 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54003 */     // MIs[3] z
     /*  54003 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  54008 */     // MIs[3] x
     /*  54008 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  54013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  54017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54019 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  54019 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  54022 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54026 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54031 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54037 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54042 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54047 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  54050 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54054 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54059 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  54065 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54070 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54075 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  54078 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54082 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54087 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54093 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54098 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54103 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  54106 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54110 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54115 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  54121 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54126 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54131 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  54134 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54138 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54143 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  54146 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  54149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  54151 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  54154 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54158 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54163 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  54166 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  54169 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  54172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  54174 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  54177 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54181 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54186 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54192 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54197 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54202 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  54205 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54209 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54214 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  54220 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54225 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54230 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54233 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54237 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54242 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54248 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54253 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54258 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54261 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54265 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54270 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54276 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54281 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54301 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54318 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54337 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54343 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54361 */     // GIR_Coverage, 11346,
     /*  54361 */     GIR_EraseRootFromParent_Done,
     /*  54362 */   // Label 464: @54362
     /*  54362 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(54770), // Rule ID 11349 //
     /*  54367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54371 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54387 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54403 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54411 */     // MIs[3] x
     /*  54411 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  54416 */     // MIs[3] z
     /*  54416 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  54421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  54425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54427 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  54427 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  54430 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54434 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54439 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54445 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54450 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54455 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  54458 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54462 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54467 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  54473 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54478 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54483 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  54486 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54490 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54495 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54501 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54506 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54511 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  54514 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54518 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54523 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  54529 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54534 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54539 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  54542 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54546 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54551 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  54554 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  54557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  54559 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  54562 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54566 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54571 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  54574 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  54577 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  54580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  54582 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  54585 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54589 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54594 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54600 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54605 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54610 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  54613 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54617 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54622 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  54628 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54633 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54638 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  54641 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54645 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54650 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  54656 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54661 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54666 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  54669 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54673 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54678 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  54684 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54689 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  54697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54706 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  54709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  54712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  54717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  54732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  54735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  54740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54745 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  54748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  54751 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  54754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54769 */     // GIR_Coverage, 11349,
     /*  54769 */     GIR_EraseRootFromParent_Done,
     /*  54770 */   // Label 465: @54770
     /*  54770 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(55178), // Rule ID 11350 //
     /*  54775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54779 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54795 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  54807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54811 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54819 */     // MIs[3] z
     /*  54819 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  54824 */     // MIs[3] x
     /*  54824 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  54829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19649),
     /*  54833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54835 */     // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19649>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  54835 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /*  54838 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54842 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54847 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54853 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54858 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54863 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /*  54866 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54870 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54875 */     GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  54881 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54886 */     GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54891 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /*  54894 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54898 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54903 */     GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  54909 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54914 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54919 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /*  54922 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54926 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54931 */     GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  54937 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  54942 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  54947 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /*  54950 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  54954 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54959 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /*  54962 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
     /*  54965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  54967 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /*  54970 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  54974 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54979 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  54982 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
     /*  54985 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
     /*  54988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  54990 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  54993 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54997 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55002 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  55008 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55013 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55018 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /*  55021 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55025 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55030 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  55036 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55041 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55046 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  55049 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55053 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55058 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  55064 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55069 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55074 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  55077 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55081 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55086 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  55092 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55097 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  55105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  55109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55114 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  55117 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  55120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  55122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  55125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  55129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55137 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /*  55140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  55143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  55148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55153 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  55156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  55159 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  55162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  55167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55177 */     // GIR_Coverage, 11350,
     /*  55177 */     GIR_EraseRootFromParent_Done,
     /*  55178 */   // Label 466: @55178
     /*  55178 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(55229), // Rule ID 8543 //
     /*  55183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55203 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  55211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55213 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55227 */     GIR_RootConstrainSelectedInstOperands,
     /*  55228 */     // GIR_Coverage, 8543,
     /*  55228 */     GIR_EraseRootFromParent_Done,
     /*  55229 */   // Label 467: @55229
     /*  55229 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(55280), // Rule ID 67 //
     /*  55234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55254 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  55262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55264 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55269 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55278 */     GIR_RootConstrainSelectedInstOperands,
     /*  55279 */     // GIR_Coverage, 67,
     /*  55279 */     GIR_EraseRootFromParent_Done,
     /*  55280 */   // Label 468: @55280
     /*  55280 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(55306), // Rule ID 55 //
     /*  55285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  55293 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13732>>  =>  (S_OR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  55293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
     /*  55298 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55304 */     GIR_RootConstrainSelectedInstOperands,
     /*  55305 */     // GIR_Coverage, 55,
     /*  55305 */     GIR_Done,
     /*  55306 */   // Label 469: @55306
     /*  55306 */   GIM_Reject,
     /*  55307 */ // Label 442: @55307
     /*  55307 */ GIM_Reject,
     /*  55308 */ // Label 387: @55308
     /*  55308 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(55458),
     /*  55313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55319 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(55378), // Rule ID 8616 //
     /*  55324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55348 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  55360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55362 */     // (or:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  55362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  55365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55367 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55376 */     GIR_RootConstrainSelectedInstOperands,
     /*  55377 */     // GIR_Coverage, 8616,
     /*  55377 */     GIR_EraseRootFromParent_Done,
     /*  55378 */   // Label 471: @55378
     /*  55378 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(55437), // Rule ID 1888 //
     /*  55383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  55399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  55403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55407 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55413 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  55419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55421 */     // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
     /*  55421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
     /*  55424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55426 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55435 */     GIR_RootConstrainSelectedInstOperands,
     /*  55436 */     // GIR_Coverage, 1888,
     /*  55436 */     GIR_EraseRootFromParent_Done,
     /*  55437 */   // Label 472: @55437
     /*  55437 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(55457), // Rule ID 2530 //
     /*  55442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55446 */     // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  55446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /*  55451 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  55455 */     GIR_RootConstrainSelectedInstOperands,
     /*  55456 */     // GIR_Coverage, 2530,
     /*  55456 */     GIR_Done,
     /*  55457 */   // Label 473: @55457
     /*  55457 */   GIM_Reject,
     /*  55458 */ // Label 470: @55458
     /*  55458 */ GIM_Reject,
     /*  55459 */ // Label 388: @55459
     /*  55459 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(55581),
     /*  55464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55470 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  55474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55478 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(55529), // Rule ID 8618 //
     /*  55483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55503 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55513 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  55513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55518 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55527 */     GIR_RootConstrainSelectedInstOperands,
     /*  55528 */     // GIR_Coverage, 8618,
     /*  55528 */     GIR_EraseRootFromParent_Done,
     /*  55529 */   // Label 475: @55529
     /*  55529 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(55580), // Rule ID 1890 //
     /*  55534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55554 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55564 */     // (or:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
     /*  55564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55578 */     GIR_RootConstrainSelectedInstOperands,
     /*  55579 */     // GIR_Coverage, 1890,
     /*  55579 */     GIR_EraseRootFromParent_Done,
     /*  55580 */   // Label 476: @55580
     /*  55580 */   GIM_Reject,
     /*  55581 */ // Label 474: @55581
     /*  55581 */ GIM_Reject,
     /*  55582 */ // Label 389: @55582
     /*  55582 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(55704),
     /*  55587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55593 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13732),
     /*  55597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55601 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(55652), // Rule ID 8617 //
     /*  55606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55626 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55636 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  55636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55641 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /*  55643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55650 */     GIR_RootConstrainSelectedInstOperands,
     /*  55651 */     // GIR_Coverage, 8617,
     /*  55651 */     GIR_EraseRootFromParent_Done,
     /*  55652 */   // Label 478: @55652
     /*  55652 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(55703), // Rule ID 1889 //
     /*  55657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55677 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55683 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55687 */     // (or:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13732>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
     /*  55687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
     /*  55690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55692 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  55694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  55698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55701 */     GIR_RootConstrainSelectedInstOperands,
     /*  55702 */     // GIR_Coverage, 1889,
     /*  55702 */     GIR_EraseRootFromParent_Done,
     /*  55703 */   // Label 479: @55703
     /*  55703 */   GIM_Reject,
     /*  55704 */ // Label 477: @55704
     /*  55704 */ GIM_Reject,
     /*  55705 */ // Label 390: @55705
     /*  55705 */ GIM_Reject,
     /*  55706 */ // Label 5: @55706
     /*  55706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 485*/ GIMT_Encode4(60572),
     /*  55717 */ /*GILLT_s1*//*Label 480*/ GIMT_Encode4(55737),
     /*  55721 */ /*GILLT_s16*//*Label 481*/ GIMT_Encode4(55975),
     /*  55725 */ /*GILLT_s32*//*Label 482*/ GIMT_Encode4(56113),
     /*  55729 */ /*GILLT_s64*//*Label 483*/ GIMT_Encode4(57912),
     /*  55733 */ /*GILLT_v2s16*//*Label 484*/ GIMT_Encode4(60545),
     /*  55737 */ // Label 480: @55737
     /*  55737 */ GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(55974),
     /*  55742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  55745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  55748 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(55802), // Rule ID 1891 //
     /*  55753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  55756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  55772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  55776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  55778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  55782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55784 */     // (xor:{ *:[i1] } (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i1] })  =>  (S_NOR_B32:{ *:[i1] }:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)
     /*  55784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B32),
     /*  55787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  55793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  55797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55800 */     GIR_RootConstrainSelectedInstOperands,
     /*  55801 */     // GIR_Coverage, 1891,
     /*  55801 */     GIR_EraseRootFromParent_Done,
     /*  55802 */   // Label 487: @55802
     /*  55802 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(55856), // Rule ID 1892 //
     /*  55807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  55810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  55826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  55830 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  55832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  55836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55838 */     // (xor:{ *:[i1] } (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i1] })  =>  (S_NOR_B64:{ *:[i1] }:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)
     /*  55838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B64),
     /*  55841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  55847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  55851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  55854 */     GIR_RootConstrainSelectedInstOperands,
     /*  55855 */     // GIR_Coverage, 1892,
     /*  55855 */     GIR_EraseRootFromParent_Done,
     /*  55856 */   // Label 488: @55856
     /*  55856 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(55923), // Rule ID 7582 //
     /*  55861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /*  55865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  55873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  55879 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34928),
     /*  55883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  55887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55889 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34927>><<P:Predicate_anonymous_34928>>, -1:{ *:[i1] })  =>  (V_CMP_NE_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), 1:{ *:[i32] })
     /*  55889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  55892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  55896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  55904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  55908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U32_e64),
     /*  55913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  55915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  55921 */     GIR_RootConstrainSelectedInstOperands,
     /*  55922 */     // GIR_Coverage, 7582,
     /*  55922 */     GIR_EraseRootFromParent_Done,
     /*  55923 */   // Label 489: @55923
     /*  55923 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(55948), // Rule ID 7547 //
     /*  55928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /*  55931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  55935 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  55935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  55940 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55946 */     GIR_RootConstrainSelectedInstOperands,
     /*  55947 */     // GIR_Coverage, 7547,
     /*  55947 */     GIR_Done,
     /*  55948 */   // Label 490: @55948
     /*  55948 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(55973), // Rule ID 7554 //
     /*  55953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /*  55956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  55960 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
     /*  55960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  55965 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  55971 */     GIR_RootConstrainSelectedInstOperands,
     /*  55972 */     // GIR_Coverage, 7554,
     /*  55972 */     GIR_Done,
     /*  55973 */   // Label 491: @55973
     /*  55973 */   GIM_Reject,
     /*  55974 */ // Label 486: @55974
     /*  55974 */ GIM_Reject,
     /*  55975 */ // Label 481: @55975
     /*  55975 */ GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(56112),
     /*  55980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  55983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  55986 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(56009), // Rule ID 2525 //
     /*  55991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  55994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  55998 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  55998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  56003 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56007 */     GIR_RootConstrainSelectedInstOperands,
     /*  56008 */     // GIR_Coverage, 2525,
     /*  56008 */     GIR_Done,
     /*  56009 */   // Label 493: @56009
     /*  56009 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(56032), // Rule ID 2528 //
     /*  56014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  56017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56021 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
     /*  56021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  56026 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56030 */     GIR_RootConstrainSelectedInstOperands,
     /*  56031 */     // GIR_Coverage, 2528,
     /*  56031 */     GIR_Done,
     /*  56032 */   // Label 494: @56032
     /*  56032 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(56088), // Rule ID 908 //
     /*  56037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  56040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  56044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  56051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  56058 */     // (xor:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_XOR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /*  56058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
     /*  56061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  56068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  56073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  56078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  56083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56086 */     GIR_RootConstrainSelectedInstOperands,
     /*  56087 */     // GIR_Coverage, 908,
     /*  56087 */     GIR_EraseRootFromParent_Done,
     /*  56088 */   // Label 495: @56088
     /*  56088 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(56111), // Rule ID 909 //
     /*  56093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  56096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56100 */     // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /*  56100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_fake16_e64),
     /*  56105 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  56109 */     GIR_RootConstrainSelectedInstOperands,
     /*  56110 */     // GIR_Coverage, 909,
     /*  56110 */     GIR_Done,
     /*  56111 */   // Label 496: @56111
     /*  56111 */   GIM_Reject,
     /*  56112 */ // Label 492: @56112
     /*  56112 */ GIM_Reject,
     /*  56113 */ // Label 482: @56113
     /*  56113 */ GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(57911),
     /*  56118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  56121 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(56179), // Rule ID 60 //
     /*  56126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  56159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56161 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13701>>  =>  (S_NAND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B32),
     /*  56164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56177 */     GIR_RootConstrainSelectedInstOperands,
     /*  56178 */     // GIR_Coverage, 60,
     /*  56178 */     GIR_EraseRootFromParent_Done,
     /*  56179 */   // Label 498: @56179
     /*  56179 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(56237), // Rule ID 62 //
     /*  56184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56207 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  56217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56219 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13701>>  =>  (S_NOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B32),
     /*  56222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56235 */     GIR_RootConstrainSelectedInstOperands,
     /*  56236 */     // GIR_Coverage, 62,
     /*  56236 */     GIR_EraseRootFromParent_Done,
     /*  56237 */   // Label 499: @56237
     /*  56237 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(56295), // Rule ID 58 //
     /*  56242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  56249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56265 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  56275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56277 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13701>>  =>  (S_XNOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  56277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B32),
     /*  56280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  56282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  56293 */     GIR_RootConstrainSelectedInstOperands,
     /*  56294 */     // GIR_Coverage, 58,
     /*  56294 */     GIR_EraseRootFromParent_Done,
     /*  56295 */   // Label 500: @56295
     /*  56295 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(56353), // Rule ID 2512 //
     /*  56300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  56328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  56332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19884),
     /*  56336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56338 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_19884>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  56351 */     GIR_RootConstrainSelectedInstOperands,
     /*  56352 */     // GIR_Coverage, 2512,
     /*  56352 */     GIR_EraseRootFromParent_Done,
     /*  56353 */   // Label 501: @56353
     /*  56353 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(56409), // Rule ID 2513 //
     /*  56358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56364 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19886),
     /*  56394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56396 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19886>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56405 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  56407 */     GIR_RootConstrainSelectedInstOperands,
     /*  56408 */     // GIR_Coverage, 2513,
     /*  56408 */     GIR_EraseRootFromParent_Done,
     /*  56409 */   // Label 502: @56409
     /*  56409 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(56465), // Rule ID 8619 //
     /*  56414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  56417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56420 */     GIM_CheckHasOneUse, /*MI*/0,
     /*  56422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56442 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19886),
     /*  56450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56452 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19886>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /*  56452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  56455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  56461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  56463 */     GIR_RootConstrainSelectedInstOperands,
     /*  56464 */     // GIR_Coverage, 8619,
     /*  56464 */     GIR_EraseRootFromParent_Done,
     /*  56465 */   // Label 503: @56465
     /*  56465 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(56596), // Rule ID 11311 //
     /*  56470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56474 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56490 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56506 */     // MIs[0] z
     /*  56506 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  56511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  56515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56517 */     // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56517 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56520 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56524 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56529 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  56533 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56550 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  56554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  56575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56594 */     GIR_RootConstrainSelectedInstOperands,
     /*  56595 */     // GIR_Coverage, 11311,
     /*  56595 */     GIR_EraseRootFromParent_Done,
     /*  56596 */   // Label 504: @56596
     /*  56596 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(56727), // Rule ID 11312 //
     /*  56601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56605 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56621 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56637 */     // MIs[0] z
     /*  56637 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  56642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  56646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56648 */     // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56660 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  56664 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  56685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  56706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56725 */     GIR_RootConstrainSelectedInstOperands,
     /*  56726 */     // GIR_Coverage, 11312,
     /*  56726 */     GIR_EraseRootFromParent_Done,
     /*  56727 */   // Label 505: @56727
     /*  56727 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(56858), // Rule ID 11309 //
     /*  56732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56736 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56752 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56768 */     // MIs[0] z
     /*  56768 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  56773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  56777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56779 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56779 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56782 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56786 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56791 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
     /*  56795 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56800 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56803 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56807 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  56816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  56837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56856 */     GIR_RootConstrainSelectedInstOperands,
     /*  56857 */     // GIR_Coverage, 11309,
     /*  56857 */     GIR_EraseRootFromParent_Done,
     /*  56858 */   // Label 506: @56858
     /*  56858 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(56989), // Rule ID 11310 //
     /*  56863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56867 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  56879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  56883 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  56899 */     // MIs[0] z
     /*  56899 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  56904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  56908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56910 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  56910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  56913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56922 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
     /*  56926 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  56934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  56947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  56955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  56968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  56973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  56976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  56978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  56984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  56987 */     GIR_RootConstrainSelectedInstOperands,
     /*  56988 */     // GIR_Coverage, 11310,
     /*  56988 */     GIR_EraseRootFromParent_Done,
     /*  56989 */   // Label 507: @56989
     /*  56989 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(57119), // Rule ID 11308 //
     /*  56994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  56997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57001 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57017 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  57029 */     // MIs[2] z
     /*  57029 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  57038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57040 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57040 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57043 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57047 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57052 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57056 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57073 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  57077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  57098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57117 */     GIR_RootConstrainSelectedInstOperands,
     /*  57118 */     // GIR_Coverage, 11308,
     /*  57118 */     GIR_EraseRootFromParent_Done,
     /*  57119 */   // Label 508: @57119
     /*  57119 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(57249), // Rule ID 11307 //
     /*  57124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57131 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57147 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57159 */     // MIs[2] z
     /*  57159 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  57168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57170 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57170 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57173 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57177 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57182 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57186 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  57207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
     /*  57228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57247 */     GIR_RootConstrainSelectedInstOperands,
     /*  57248 */     // GIR_Coverage, 11307,
     /*  57248 */     GIR_EraseRootFromParent_Done,
     /*  57249 */   // Label 509: @57249
     /*  57249 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(57379), // Rule ID 11306 //
     /*  57254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57261 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57277 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  57289 */     // MIs[2] z
     /*  57289 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  57298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57300 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)))<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57312 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57316 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57333 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
     /*  57337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  57358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57377 */     GIR_RootConstrainSelectedInstOperands,
     /*  57378 */     // GIR_Coverage, 11306,
     /*  57378 */     GIR_EraseRootFromParent_Done,
     /*  57379 */   // Label 510: @57379
     /*  57379 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(57509), // Rule ID 7458 //
     /*  57384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57391 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57407 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57419 */     // MIs[2] z
     /*  57419 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  57428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57430 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19651>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
     /*  57430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /*  57433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57442 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
     /*  57446 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57451 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  57454 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57458 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57463 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
     /*  57467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  57475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  57479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
     /*  57488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  57496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  57504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57507 */     GIR_RootConstrainSelectedInstOperands,
     /*  57508 */     // GIR_Coverage, 7458,
     /*  57508 */     GIR_EraseRootFromParent_Done,
     /*  57509 */   // Label 511: @57509
     /*  57509 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(57541), // Rule ID 0 //
     /*  57514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  57521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  57529 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_13701>>  =>  (S_NOT_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /*  57529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
     /*  57532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  57534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  57536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  57539 */     GIR_RootConstrainSelectedInstOperands,
     /*  57540 */     // GIR_Coverage, 0,
     /*  57540 */     GIR_EraseRootFromParent_Done,
     /*  57541 */   // Label 512: @57541
     /*  57541 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(57570), // Rule ID 7559 //
     /*  57546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  57561 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_19651>>  =>  (V_NOT_B32_e32:{ *:[i32] } ?:{ *:[i32] }:$src0)
     /*  57561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_NOT_B32_e32),
     /*  57564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57566 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  57568 */     GIR_RootConstrainSelectedInstOperands,
     /*  57569 */     // GIR_Coverage, 7559,
     /*  57569 */     GIR_EraseRootFromParent_Done,
     /*  57570 */   // Label 513: @57570
     /*  57570 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(57638), // Rule ID 2657 //
     /*  57575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /*  57578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57603 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*  57607 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*  57611 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:16:z
     /*  57615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21278),
     /*  57619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57621 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20832>>, i32:{ *:[i32] }:$src2:$pred:16:z)<<P:16:Predicate_anonymous_21278>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  57621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
     /*  57624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  57636 */     GIR_RootConstrainSelectedInstOperands,
     /*  57637 */     // GIR_Coverage, 2657,
     /*  57637 */     GIR_EraseRootFromParent_Done,
     /*  57638 */   // Label 514: @57638
     /*  57638 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(57706), // Rule ID 8644 //
     /*  57643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /*  57646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57653 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:16:z
     /*  57657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57673 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57675 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*  57679 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*  57683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21278),
     /*  57687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57689 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:16:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20832>>)<<P:16:Predicate_anonymous_21278>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /*  57689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
     /*  57692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  57704 */     GIR_RootConstrainSelectedInstOperands,
     /*  57705 */     // GIR_Coverage, 8644,
     /*  57705 */     GIR_EraseRootFromParent_Done,
     /*  57706 */   // Label 515: @57706
     /*  57706 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(57735), // Rule ID 56 //
     /*  57711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  57718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13733),
     /*  57722 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13733>>  =>  (S_XOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /*  57727 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  57733 */     GIR_RootConstrainSelectedInstOperands,
     /*  57734 */     // GIR_Coverage, 56,
     /*  57734 */     GIR_Done,
     /*  57735 */   // Label 516: @57735
     /*  57735 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(57785), // Rule ID 8576 //
     /*  57740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57766 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57772 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57781 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  57783 */     GIR_RootConstrainSelectedInstOperands,
     /*  57784 */     // GIR_Coverage, 8576,
     /*  57784 */     GIR_EraseRootFromParent_Done,
     /*  57785 */   // Label 517: @57785
     /*  57785 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(57837), // Rule ID 912 //
     /*  57790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57822 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), -1:{ *:[i32] })  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57835 */     GIR_RootConstrainSelectedInstOperands,
     /*  57836 */     // GIR_Coverage, 912,
     /*  57836 */     GIR_EraseRootFromParent_Done,
     /*  57837 */   // Label 518: @57837
     /*  57837 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(57887), // Rule ID 8577 //
     /*  57842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /*  57845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  57864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  57868 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  57872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57874 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
     /*  57877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  57879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  57885 */     GIR_RootConstrainSelectedInstOperands,
     /*  57886 */     // GIR_Coverage, 8577,
     /*  57886 */     GIR_EraseRootFromParent_Done,
     /*  57887 */   // Label 519: @57887
     /*  57887 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(57910), // Rule ID 817 //
     /*  57892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  57899 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /*  57899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  57904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  57908 */     GIR_RootConstrainSelectedInstOperands,
     /*  57909 */     // GIR_Coverage, 817,
     /*  57909 */     GIR_Done,
     /*  57910 */   // Label 520: @57910
     /*  57910 */   GIM_Reject,
     /*  57911 */ // Label 497: @57911
     /*  57911 */ GIM_Reject,
     /*  57912 */ // Label 483: @57912
     /*  57912 */ GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(60544),
     /*  57917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57920 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(57978), // Rule ID 61 //
     /*  57925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  57932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  57948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  57950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  57954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  57958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57960 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13701>>  =>  (S_NAND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  57960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B64),
     /*  57963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  57965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  57969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  57973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  57976 */     GIR_RootConstrainSelectedInstOperands,
     /*  57977 */     // GIR_Coverage, 61,
     /*  57977 */     GIR_EraseRootFromParent_Done,
     /*  57978 */   // Label 522: @57978
     /*  57978 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(58036), // Rule ID 63 //
     /*  57983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  57990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  58008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  58012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  58016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58018 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13701>>  =>  (S_NOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  58018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B64),
     /*  58021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  58023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  58027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  58031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  58034 */     GIR_RootConstrainSelectedInstOperands,
     /*  58035 */     // GIR_Coverage, 63,
     /*  58035 */     GIR_EraseRootFromParent_Done,
     /*  58036 */   // Label 523: @58036
     /*  58036 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(58094), // Rule ID 59 //
     /*  58041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  58048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58064 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  58066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  58070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  58074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58076 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13701>>  =>  (S_XNOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  58076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B64),
     /*  58079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  58081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /*  58085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /*  58089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  58092 */     GIR_RootConstrainSelectedInstOperands,
     /*  58093 */     // GIR_Coverage, 59,
     /*  58093 */     GIR_EraseRootFromParent_Done,
     /*  58094 */   // Label 524: @58094
     /*  58094 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(58393), // Rule ID 11318 //
     /*  58099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58103 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58119 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58135 */     // MIs[0] z
     /*  58135 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  58140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  58144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58146 */     // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58146 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58149 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58153 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58158 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58164 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58169 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58174 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58177 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58181 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58186 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58192 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58197 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58202 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58205 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58209 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58214 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58220 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58225 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58230 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58233 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58237 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58242 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58245 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58248 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58253 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58256 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58260 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58265 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58271 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58276 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58293 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58299 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58304 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58309 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58312 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58316 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58321 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58327 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58332 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58349 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58368 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58374 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58392 */     // GIR_Coverage, 11318,
     /*  58392 */     GIR_EraseRootFromParent_Done,
     /*  58393 */   // Label 525: @58393
     /*  58393 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(58692), // Rule ID 11319 //
     /*  58398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58402 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58418 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58434 */     // MIs[0] z
     /*  58434 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  58439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  58443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58445 */     // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58445 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58448 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58452 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58457 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58463 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58468 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58473 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58476 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58480 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58485 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58491 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58496 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58501 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58504 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58508 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58513 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58519 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58524 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58529 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58532 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58536 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58541 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58544 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58547 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58552 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58555 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58559 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58564 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58570 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58575 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58580 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58583 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58587 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58592 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58598 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58603 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58620 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58626 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58648 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58654 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58667 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58673 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58691 */     // GIR_Coverage, 11319,
     /*  58691 */     GIR_EraseRootFromParent_Done,
     /*  58692 */   // Label 526: @58692
     /*  58692 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(58991), // Rule ID 11316 //
     /*  58697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58701 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  58709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  58713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  58717 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  58733 */     // MIs[0] z
     /*  58733 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  58738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  58742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58744 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  58744 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  58747 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58751 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58756 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  58762 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58767 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58772 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  58775 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58779 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58784 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  58790 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58795 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58800 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  58803 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58807 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58812 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  58818 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58823 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58828 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  58831 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58835 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58840 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  58843 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  58846 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  58849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  58851 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  58854 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58858 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58863 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  58869 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58874 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58879 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  58882 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58886 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58891 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  58897 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58902 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  58910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58919 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  58925 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  58938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  58942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58950 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  58953 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  58956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  58961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58966 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  58969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  58972 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  58975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  58980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  58990 */     // GIR_Coverage, 11316,
     /*  58990 */     GIR_EraseRootFromParent_Done,
     /*  58991 */   // Label 527: @58991
     /*  58991 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(59290), // Rule ID 11317 //
     /*  58996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59000 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59016 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59032 */     // MIs[0] z
     /*  59032 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  59037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  59041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59043 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59043 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59046 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59050 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59055 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59061 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59066 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59071 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59074 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59078 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59083 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59089 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59094 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59099 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59102 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59106 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59111 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59117 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59122 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59127 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59130 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59134 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59139 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59142 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59145 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59150 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59153 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59157 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59162 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59168 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59173 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59190 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59196 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59201 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59218 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59265 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59271 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59289 */     // GIR_Coverage, 11317,
     /*  59289 */     GIR_EraseRootFromParent_Done,
     /*  59290 */   // Label 528: @59290
     /*  59290 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(59588), // Rule ID 11315 //
     /*  59295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59302 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59318 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59330 */     // MIs[2] z
     /*  59330 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  59339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59341 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59341 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59344 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59348 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59353 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59359 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59364 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59369 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59372 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59376 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59381 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59387 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59392 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59397 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59400 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59404 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59409 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59415 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59420 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59425 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59428 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59432 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59437 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59440 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59443 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59448 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59451 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59455 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59460 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59466 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59471 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59476 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59479 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59483 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59488 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59494 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59499 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59504 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59507 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59511 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59516 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59522 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59527 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59547 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59550 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59563 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59569 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59587 */     // GIR_Coverage, 11315,
     /*  59587 */     GIR_EraseRootFromParent_Done,
     /*  59588 */   // Label 529: @59588
     /*  59588 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(59886), // Rule ID 11314 //
     /*  59593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59600 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59616 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59628 */     // MIs[2] z
     /*  59628 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  59637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59639 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59639 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59642 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59646 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59651 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59657 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59662 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59667 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59670 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59674 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59679 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59685 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59690 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59695 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59698 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59702 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59707 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  59713 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59718 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59723 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  59726 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59730 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59735 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  59738 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  59741 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  59744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  59746 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  59749 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59753 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59758 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  59764 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59769 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59774 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  59777 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59781 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59786 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  59792 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59797 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59802 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  59805 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59809 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59814 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  59820 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  59833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  59837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59842 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  59845 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  59848 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  59851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  59856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59861 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  59864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  59867 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  59870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59885 */     // GIR_Coverage, 11314,
     /*  59885 */     GIR_EraseRootFromParent_Done,
     /*  59886 */   // Label 530: @59886
     /*  59886 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(60184), // Rule ID 11313 //
     /*  59891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  59894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59898 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  59906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  59910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  59914 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  59926 */     // MIs[2] z
     /*  59926 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  59931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  59935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59937 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)))<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  59937 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  59940 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59944 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59949 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  59955 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59960 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59965 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  59968 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59972 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59977 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  59983 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  59988 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  59993 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  59996 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60000 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60005 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  60011 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60016 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60021 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  60024 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60028 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60033 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  60036 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  60039 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  60042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  60044 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  60047 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60051 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60056 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  60062 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60067 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60072 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  60075 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60079 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60084 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  60090 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60095 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60100 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60103 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60107 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60112 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  60118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  60146 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  60149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60159 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  60162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  60165 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  60168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60183 */     // GIR_Coverage, 11313,
     /*  60183 */     GIR_EraseRootFromParent_Done,
     /*  60184 */   // Label 531: @60184
     /*  60184 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(60482), // Rule ID 7459 //
     /*  60189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60196 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60212 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60224 */     // MIs[2] z
     /*  60224 */     GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  60229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19651),
     /*  60233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60235 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19651>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /*  60235 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /*  60238 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60242 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60247 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
     /*  60253 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60258 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60263 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /*  60266 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60270 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60275 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
     /*  60281 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60286 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60291 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /*  60294 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60298 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60303 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
     /*  60309 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60314 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60319 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /*  60322 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60326 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60331 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  60334 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /*  60337 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
     /*  60340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  60342 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  60345 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60349 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60354 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
     /*  60360 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60365 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60370 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  60373 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60377 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60382 */     GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
     /*  60388 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60393 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60410 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
     /*  60416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  60433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60441 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  60444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  60447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60457 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  60460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
     /*  60463 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  60466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  60471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60481 */     // GIR_Coverage, 7459,
     /*  60481 */     GIR_EraseRootFromParent_Done,
     /*  60482 */   // Label 532: @60482
     /*  60482 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(60514), // Rule ID 1 //
     /*  60487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  60494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  60498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13701),
     /*  60502 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, -1:{ *:[i64] })<<P:Predicate_anonymous_13701>>  =>  (S_NOT_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /*  60502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
     /*  60505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  60507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  60509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  60512 */     GIR_RootConstrainSelectedInstOperands,
     /*  60513 */     // GIR_Coverage, 1,
     /*  60513 */     GIR_EraseRootFromParent_Done,
     /*  60514 */   // Label 533: @60514
     /*  60514 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(60543), // Rule ID 57 //
     /*  60519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  60526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13733),
     /*  60530 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13733>>  =>  (S_XOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /*  60530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
     /*  60535 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  60541 */     GIR_RootConstrainSelectedInstOperands,
     /*  60542 */     // GIR_Coverage, 57,
     /*  60542 */     GIR_Done,
     /*  60543 */   // Label 534: @60543
     /*  60543 */   GIM_Reject,
     /*  60544 */ // Label 521: @60544
     /*  60544 */ GIM_Reject,
     /*  60545 */ // Label 484: @60545
     /*  60545 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(60571), // Rule ID 2531 //
     /*  60550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  60553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  60556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60560 */   // (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
     /*  60560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /*  60565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /*  60569 */   GIR_RootConstrainSelectedInstOperands,
     /*  60570 */   // GIR_Coverage, 2531,
     /*  60570 */   GIR_Done,
     /*  60571 */ // Label 535: @60571
     /*  60571 */ GIM_Reject,
     /*  60572 */ // Label 485: @60572
     /*  60572 */ GIM_Reject,
     /*  60573 */ // Label 6: @60573
     /*  60573 */ GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(60602), // Rule ID 7410 //
     /*  60578 */   // MIs[0] DstI[vdst]
     /*  60578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /*  60582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60586 */   // MIs[0] Operand 1
     /*  60586 */   // No operand predicates
     /*  60586 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34712),
     /*  60590 */   // (frameindex:{ *:[i32] })<<P:Predicate_anonymous_34712>>:$fi  =>  (V_MOV_B32_e32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
     /*  60590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  60593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60595 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  60600 */   GIR_RootConstrainSelectedInstOperands,
     /*  60601 */   // GIR_Coverage, 7410,
     /*  60601 */   GIR_EraseRootFromParent_Done,
     /*  60602 */ // Label 536: @60602
     /*  60602 */ GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(60627), // Rule ID 7411 //
     /*  60607 */   // MIs[0] DstI[sdst]
     /*  60607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /*  60611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  60615 */   // MIs[0] Operand 1
     /*  60615 */   // No operand predicates
     /*  60615 */   // (frameindex:{ *:[i32] }):$fi  =>  (S_MOV_B32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
     /*  60615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  60618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  60620 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  60625 */   GIR_RootConstrainSelectedInstOperands,
     /*  60626 */   // GIR_Coverage, 7411,
     /*  60626 */   GIR_EraseRootFromParent_Done,
     /*  60627 */ // Label 537: @60627
     /*  60627 */ GIM_Reject,
     /*  60628 */ // Label 7: @60628
     /*  60628 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(65653),
     /*  60633 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  60636 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /*  60639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  60642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60645 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(62611),
     /*  60650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  60654 */     GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(60777), // Rule ID 2749 //
     /*  60659 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts),
     /*  60662 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60666 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60670 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60674 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60678 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60682 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60686 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60690 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60694 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60698 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60702 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60706 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60708 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60715 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60722 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60729 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  60729 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  60732 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60734 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  60739 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  60744 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  60749 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  60754 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  60759 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  60764 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60767 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  60769 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60772 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60775 */       GIR_RootConstrainSelectedInstOperands,
     /*  60776 */       // GIR_Coverage, 2749,
     /*  60776 */       GIR_EraseRootFromParent_Done,
     /*  60777 */     // Label 540: @60777
     /*  60777 */     GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(60900), // Rule ID 2751 //
     /*  60782 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseFakeTrue16Insts),
     /*  60785 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60789 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60793 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60797 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60801 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60805 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60809 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60813 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60817 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60821 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60825 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60829 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60831 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60838 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60845 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60852 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  60852 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  60855 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  60857 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  60862 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  60867 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  60872 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  60877 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  60882 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  60887 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60890 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  60892 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60895 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60898 */       GIR_RootConstrainSelectedInstOperands,
     /*  60899 */       // GIR_Coverage, 2751,
     /*  60899 */       GIR_EraseRootFromParent_Done,
     /*  60900 */     // Label 541: @60900
     /*  60900 */     GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(61078), // Rule ID 2754 //
     /*  60905 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  60908 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60912 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  60916 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  60920 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60924 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  60928 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60932 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  60936 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  60940 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  60944 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  60948 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  60952 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  60954 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60961 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60968 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  60975 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  60975 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  60978 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  60982 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60987 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  60989 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  60992 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  60996 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61001 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  61005 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61008 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61011 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61014 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61019 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61024 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61029 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  61032 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61034 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61039 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61044 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61049 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61054 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61059 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61064 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61067 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61070 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61073 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61076 */       GIR_RootConstrainSelectedInstOperands,
     /*  61077 */       // GIR_Coverage, 2754,
     /*  61077 */       GIR_EraseRootFromParent_Done,
     /*  61078 */     // Label 542: @61078
     /*  61078 */     GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(61201), // Rule ID 2733 //
     /*  61083 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts),
     /*  61086 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61090 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61094 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61098 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61102 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61106 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61110 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61114 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61118 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61122 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61126 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61130 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61132 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61139 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61146 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61153 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61153 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61156 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61158 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61163 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61168 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61173 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61178 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61183 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61188 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61191 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61193 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61196 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61199 */       GIR_RootConstrainSelectedInstOperands,
     /*  61200 */       // GIR_Coverage, 2733,
     /*  61200 */       GIR_EraseRootFromParent_Done,
     /*  61201 */     // Label 543: @61201
     /*  61201 */     GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(61379), // Rule ID 2736 //
     /*  61206 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  61209 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61213 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61217 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61221 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61225 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61229 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61233 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61237 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61241 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61245 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61249 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61253 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61255 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61262 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61269 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61276 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  61276 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61279 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61283 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61288 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61290 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61293 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61297 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61302 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  61306 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61309 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61312 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61315 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61330 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61333 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61335 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61340 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61345 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61350 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61355 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61360 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61365 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61368 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61371 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61374 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61377 */       GIR_RootConstrainSelectedInstOperands,
     /*  61378 */       // GIR_Coverage, 2736,
     /*  61378 */       GIR_EraseRootFromParent_Done,
     /*  61379 */     // Label 544: @61379
     /*  61379 */     GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(61502), // Rule ID 2740 //
     /*  61384 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts),
     /*  61387 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61391 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
     /*  61395 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  61399 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61403 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61407 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61411 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61415 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61419 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  61423 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  61427 */       GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /*  61431 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61433 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61440 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61447 */       GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61454 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61454 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  61457 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61459 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61464 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61469 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61474 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61479 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61484 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61489 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61492 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61494 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61497 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61500 */       GIR_RootConstrainSelectedInstOperands,
     /*  61501 */       // GIR_Coverage, 2740,
     /*  61501 */       GIR_EraseRootFromParent_Done,
     /*  61502 */     // Label 545: @61502
     /*  61502 */     GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(61668), // Rule ID 2752 //
     /*  61507 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  61510 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61514 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61518 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61522 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61526 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61530 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61534 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61538 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61542 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61544 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61551 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61558 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61565 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))), f16:{ *:[f16] }:$elt1)  =>  (V_FMA_MIXLO_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), lo16:{ *:[i32] }, ?:{ *:[f16] }:$elt1, hi16:{ *:[i32] }))
     /*  61565 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61568 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61572 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61577 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61579 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61582 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61586 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61591 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61594 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61597 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // elt1
     /*  61601 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61604 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61609 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61614 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61619 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /*  61622 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61624 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61629 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61634 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61639 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61644 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61649 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61654 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61657 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61660 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61663 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61666 */       GIR_RootConstrainSelectedInstOperands,
     /*  61667 */       // GIR_Coverage, 2752,
     /*  61667 */       GIR_EraseRootFromParent_Done,
     /*  61668 */     // Label 546: @61668
     /*  61668 */     GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(61834), // Rule ID 2734 //
     /*  61673 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  61676 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61680 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61684 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61688 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61692 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  61696 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61700 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61704 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61708 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61710 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61717 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61724 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61731 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))), f16:{ *:[f16] }:$elt1)  =>  (V_MAD_MIXLO_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), lo16:{ *:[i32] }, ?:{ *:[f16] }:$elt1, hi16:{ *:[i32] }))
     /*  61731 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  61734 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61738 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61743 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  61745 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  61748 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  61752 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61757 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61760 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  61763 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // elt1
     /*  61767 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  61770 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  61775 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61780 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  61785 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /*  61788 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61790 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61795 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61800 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61805 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61815 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61820 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61823 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61826 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61829 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61832 */       GIR_RootConstrainSelectedInstOperands,
     /*  61833 */       // GIR_Coverage, 2734,
     /*  61833 */       GIR_EraseRootFromParent_Done,
     /*  61834 */     // Label 547: @61834
     /*  61834 */     GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(61945), // Rule ID 2748 //
     /*  61839 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_NotHasTrue16BitInsts),
     /*  61842 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61846 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61850 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61854 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61858 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61862 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61866 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61870 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61874 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61876 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61883 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61890 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61897 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  61897 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  61900 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  61902 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  61907 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  61912 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  61917 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  61922 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  61927 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  61932 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61935 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  61937 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61940 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61943 */       GIR_RootConstrainSelectedInstOperands,
     /*  61944 */       // GIR_Coverage, 2748,
     /*  61944 */       GIR_EraseRootFromParent_Done,
     /*  61945 */     // Label 548: @61945
     /*  61945 */     GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(62056), // Rule ID 2750 //
     /*  61950 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseFakeTrue16Insts),
     /*  61953 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61957 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  61961 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61965 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61969 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  61973 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61977 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  61981 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  61985 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61987 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  61994 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62001 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62008 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62008 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  62011 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62013 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62018 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62023 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62028 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62033 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62038 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62043 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62046 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62048 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62051 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62054 */       GIR_RootConstrainSelectedInstOperands,
     /*  62055 */       // GIR_Coverage, 2750,
     /*  62055 */       GIR_EraseRootFromParent_Done,
     /*  62056 */     // Label 549: @62056
     /*  62056 */     GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(62222), // Rule ID 2753 //
     /*  62061 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts_UseRealTrue16Insts),
     /*  62064 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62068 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62072 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62076 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62080 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
     /*  62084 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62088 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62092 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62096 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62098 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62105 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62112 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62119 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  62119 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  62122 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62126 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62131 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  62133 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62136 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  62140 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62145 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  62149 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  62152 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62155 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  62158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62168 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62173 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  62176 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62178 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62183 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62188 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62193 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62198 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62203 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62208 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62211 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62214 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62217 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62220 */       GIR_RootConstrainSelectedInstOperands,
     /*  62221 */       // GIR_Coverage, 2753,
     /*  62221 */       GIR_EraseRootFromParent_Done,
     /*  62222 */     // Label 550: @62222
     /*  62222 */     GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(62333), // Rule ID 2732 //
     /*  62227 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_NotHasTrue16BitInsts),
     /*  62230 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62234 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62238 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62242 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62246 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62250 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62254 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62258 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62262 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62264 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62271 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62278 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62285 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62285 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62288 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62295 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62300 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62305 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62310 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62315 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62320 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62323 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62325 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62328 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62331 */       GIR_RootConstrainSelectedInstOperands,
     /*  62332 */       // GIR_Coverage, 2732,
     /*  62332 */       GIR_EraseRootFromParent_Done,
     /*  62333 */     // Label 551: @62333
     /*  62333 */     GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(62499), // Rule ID 2735 //
     /*  62338 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseRealTrue16Insts),
     /*  62341 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62345 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62349 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62353 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62357 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62361 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62365 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62369 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62373 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62375 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62382 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62389 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62396 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (REG_SEQUENCE:{ *:[i16] } VGPR_32:{ *:[i32] }, ?:{ *:[f16] }:$elt0, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f16] }), hi16:{ *:[i32] }))
     /*  62396 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  62399 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62403 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62408 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  62410 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62413 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  62417 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62422 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // elt0
     /*  62426 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  62429 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62432 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  62435 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62440 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62445 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  62450 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62453 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62455 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62460 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62465 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62470 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62475 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62480 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62485 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62488 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62491 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62494 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62497 */       GIR_RootConstrainSelectedInstOperands,
     /*  62498 */       // GIR_Coverage, 2735,
     /*  62498 */       GIR_EraseRootFromParent_Done,
     /*  62499 */     // Label 552: @62499
     /*  62499 */     GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(62610), // Rule ID 2739 //
     /*  62504 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals_UseFakeTrue16Insts),
     /*  62507 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62511 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  62515 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62519 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62523 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
     /*  62527 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62531 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62535 */       GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /*  62539 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62541 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62548 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62555 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  62562 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  62562 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  62565 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62567 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  62572 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  62577 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  62582 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  62587 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /*  62592 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /*  62597 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62600 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  62602 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62605 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62608 */       GIR_RootConstrainSelectedInstOperands,
     /*  62609 */       // GIR_Coverage, 2739,
     /*  62609 */       GIR_EraseRootFromParent_Done,
     /*  62610 */     // Label 553: @62610
     /*  62610 */     GIM_Reject,
     /*  62611 */   // Label 539: @62611
     /*  62611 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(62925),
     /*  62616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  62620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62624 */     GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(62774), // Rule ID 7676 //
     /*  62629 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  62632 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62636 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62640 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  62644 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62648 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62652 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62656 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62660 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62664 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62668 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  62672 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62677 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  62681 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62685 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62689 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
     /*  62693 */       GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  62697 */       GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62701 */       GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  62705 */       GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  62709 */       GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62713 */       GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  62717 */       GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  62721 */       GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62726 */       GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  62730 */       GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  62732 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  62732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  62739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62744 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  62754 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62756 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  62759 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62761 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
     /*  62765 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  62769 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62772 */       GIR_RootConstrainSelectedInstOperands,
     /*  62773 */       // GIR_Coverage, 7676,
     /*  62773 */       GIR_EraseRootFromParent_Done,
     /*  62774 */     // Label 555: @62774
     /*  62774 */     GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(62924), // Rule ID 7677 //
     /*  62779 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  62782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62790 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  62794 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62798 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62802 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62806 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62810 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62814 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62818 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  62822 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62827 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  62831 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62835 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  62839 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
     /*  62843 */       GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  62847 */       GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62851 */       GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  62855 */       GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  62859 */       GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62863 */       GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
     /*  62867 */       GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
     /*  62871 */       GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  62876 */       GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
     /*  62880 */       GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  62882 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  62882 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  62885 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  62889 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62894 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  62904 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62906 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  62909 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  62911 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
     /*  62915 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  62919 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62922 */       GIR_RootConstrainSelectedInstOperands,
     /*  62923 */       // GIR_Coverage, 7677,
     /*  62923 */       GIR_EraseRootFromParent_Done,
     /*  62924 */     // Label 556: @62924
     /*  62924 */     GIM_Reject,
     /*  62925 */   // Label 554: @62925
     /*  62925 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(63036), // Rule ID 7657 //
     /*  62930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  62933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  62937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  62965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  62967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  62972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  62976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  62980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  62984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  62988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  62992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62996 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63000 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63004 */     GIM_CheckHasOneUse, /*MI*/4,
     /*  63006 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  63011 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63015 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  63019 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63021 */     // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34995>>  =>  (S_PACK_HH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i32] }:$src1)
     /*  63021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HH_B32_B16),
     /*  63024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  63026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  63030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  63034 */     GIR_RootConstrainSelectedInstOperands,
     /*  63035 */     // GIR_Coverage, 7657,
     /*  63035 */     GIR_EraseRootFromParent_Done,
     /*  63036 */   // Label 557: @63036
     /*  63036 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(63215),
     /*  63041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35057),
     /*  63045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63049 */     GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(63104), // Rule ID 7678 //
     /*  63054 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /*  63057 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63064 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63071 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_35057>>  =>  (V_PACK_B32_F16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63071 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_e64),
     /*  63074 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63076 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63081 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63086 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63091 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63096 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63099 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63102 */       GIR_RootConstrainSelectedInstOperands,
     /*  63103 */       // GIR_Coverage, 7678,
     /*  63103 */       GIR_EraseRootFromParent_Done,
     /*  63104 */     // Label 559: @63104
     /*  63104 */     GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(63159), // Rule ID 7679 //
     /*  63109 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /*  63112 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63119 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63126 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_35057>>  =>  (V_PACK_B32_F16_t16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63126 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_t16_e64),
     /*  63129 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63131 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63136 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63141 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63146 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63151 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63157 */       GIR_RootConstrainSelectedInstOperands,
     /*  63158 */       // GIR_Coverage, 7679,
     /*  63158 */       GIR_EraseRootFromParent_Done,
     /*  63159 */     // Label 560: @63159
     /*  63159 */     GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(63214), // Rule ID 7680 //
     /*  63164 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /*  63167 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63174 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63181 */       // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_35057>>  =>  (V_PACK_B32_F16_fake16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
     /*  63181 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_fake16_e64),
     /*  63184 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63186 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /*  63191 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63196 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /*  63201 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63206 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63209 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63212 */       GIR_RootConstrainSelectedInstOperands,
     /*  63213 */       // GIR_Coverage, 7680,
     /*  63213 */       GIR_EraseRootFromParent_Done,
     /*  63214 */     // Label 561: @63214
     /*  63214 */     GIM_Reject,
     /*  63215 */   // Label 558: @63215
     /*  63215 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(63498),
     /*  63220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63224 */     GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(63305), // Rule ID 2632 //
     /*  63229 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /*  63232 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63236 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63240 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63244 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63248 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63252 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63256 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63258 */       GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63265 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /*  63272 */       // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers)), (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1)
     /*  63272 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /*  63275 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63277 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63282 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63287 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63292 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63297 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63300 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63303 */       GIR_RootConstrainSelectedInstOperands,
     /*  63304 */       // GIR_Coverage, 2632,
     /*  63304 */       GIR_EraseRootFromParent_Done,
     /*  63305 */     // Label 563: @63305
     /*  63305 */     GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(63401), // Rule ID 2730 //
     /*  63310 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /*  63313 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63317 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63321 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63325 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63329 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /*  63333 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63337 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63341 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63343 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63350 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63357 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  63357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /*  63360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63362 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63367 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63372 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63377 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63382 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63385 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63388 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63391 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  63393 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63396 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63399 */       GIR_RootConstrainSelectedInstOperands,
     /*  63400 */       // GIR_Coverage, 2730,
     /*  63400 */       GIR_EraseRootFromParent_Done,
     /*  63401 */     // Label 564: @63401
     /*  63401 */     GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(63497), // Rule ID 2746 //
     /*  63406 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /*  63409 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63413 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  63417 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63421 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63425 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /*  63429 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63433 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63437 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63439 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63446 */       GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /*  63453 */       // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
     /*  63453 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /*  63456 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63458 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  63463 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  63468 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /*  63473 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /*  63478 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63481 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63484 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63487 */       GIR_RootToRootCopy, /*OpIdx*/1, // elt0
     /*  63489 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63492 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63495 */       GIR_RootConstrainSelectedInstOperands,
     /*  63496 */       // GIR_Coverage, 2746,
     /*  63496 */       GIR_EraseRootFromParent_Done,
     /*  63497 */     // Label 565: @63497
     /*  63497 */     GIM_Reject,
     /*  63498 */   // Label 562: @63498
     /*  63498 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(64040),
     /*  63503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  63507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63511 */     GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(63637), // Rule ID 7665 //
     /*  63516 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  63519 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63523 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63527 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63531 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63535 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63539 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63543 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63547 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63552 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  63556 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63560 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63564 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63568 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63572 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63576 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63580 */       GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63584 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63589 */       GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63593 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63595 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  63595 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  63598 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  63602 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63607 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  63617 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  63619 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  63622 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63624 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // b
     /*  63628 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  63632 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63635 */       GIR_RootConstrainSelectedInstOperands,
     /*  63636 */       // GIR_Coverage, 7665,
     /*  63636 */       GIR_EraseRootFromParent_Done,
     /*  63637 */     // Label 567: @63637
     /*  63637 */     GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(63763), // Rule ID 7667 //
     /*  63642 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  63645 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63649 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63653 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  63657 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63661 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63665 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63669 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  63673 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63678 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  63682 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63686 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63690 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63694 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63698 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63702 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  63706 */       GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  63710 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63715 */       GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  63719 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63721 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
     /*  63721 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  63724 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  63728 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63733 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
     /*  63743 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  63745 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  63748 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63750 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // b
     /*  63754 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  63758 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63761 */       GIR_RootConstrainSelectedInstOperands,
     /*  63762 */       // GIR_Coverage, 7667,
     /*  63762 */       GIR_EraseRootFromParent_Done,
     /*  63763 */     // Label 568: @63763
     /*  63763 */     GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(63842), // Rule ID 7674 //
     /*  63768 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  63771 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63775 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63779 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63783 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63787 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63791 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63795 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63799 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63803 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63807 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63811 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63816 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63820 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63824 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  63826 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
     /*  63826 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /*  63829 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63831 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  63833 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  63837 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  63840 */       GIR_RootConstrainSelectedInstOperands,
     /*  63841 */       // GIR_Coverage, 7674,
     /*  63841 */       GIR_EraseRootFromParent_Done,
     /*  63842 */     // Label 569: @63842
     /*  63842 */     GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(63936), // Rule ID 7675 //
     /*  63847 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  63850 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63854 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63858 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63862 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63866 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63870 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63874 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63878 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63882 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63886 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63890 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63895 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63899 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63903 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  63905 */       // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[v2f16] } 0:{ *:[i32] }, VGPR_32:{ *:[f16] }:$b, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$a, 0:{ *:[i32] }, 16:{ *:[i16] }, 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  63905 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /*  63908 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  63910 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63913 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  63915 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63918 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
     /*  63922 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63925 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  63928 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63931 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63934 */       GIR_RootConstrainSelectedInstOperands,
     /*  63935 */       // GIR_Coverage, 7675,
     /*  63935 */       GIR_EraseRootFromParent_Done,
     /*  63936 */     // Label 570: @63936
     /*  63936 */     GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(64039), // Rule ID 7673 //
     /*  63941 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  63944 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63948 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63952 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  63956 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  63960 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63964 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  63968 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  63972 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63976 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63980 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  63984 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  63988 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  63993 */       GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  63997 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  63999 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34997>>  =>  (V_BFI_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[i32] }:$b)
     /*  63999 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  64002 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64006 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64011 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64021 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64023 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  64026 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64028 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64031 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  64033 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // b
     /*  64037 */       GIR_RootConstrainSelectedInstOperands,
     /*  64038 */       // GIR_Coverage, 7673,
     /*  64038 */       GIR_EraseRootFromParent_Done,
     /*  64039 */     // Label 571: @64039
     /*  64039 */     GIM_Reject,
     /*  64040 */   // Label 566: @64040
     /*  64040 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(64114), // Rule ID 7656 //
     /*  64045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  64048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  64086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64091 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  64099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64101 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34995>>  =>  (S_PACK_LH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] }:$src1)
     /*  64101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LH_B32_B16),
     /*  64104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64106 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  64112 */     GIR_RootConstrainSelectedInstOperands,
     /*  64113 */     // GIR_Coverage, 7656,
     /*  64113 */     GIR_EraseRootFromParent_Done,
     /*  64114 */   // Label 572: @64114
     /*  64114 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(64273),
     /*  64119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  64123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64131 */     GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(64194), // Rule ID 7663 //
     /*  64136 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  64139 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64143 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64147 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64151 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64155 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64159 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64163 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64167 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64172 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64176 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64178 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
     /*  64178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /*  64181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64183 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  64185 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  64189 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64192 */       GIR_RootConstrainSelectedInstOperands,
     /*  64193 */       // GIR_Coverage, 7663,
     /*  64193 */       GIR_EraseRootFromParent_Done,
     /*  64194 */     // Label 574: @64194
     /*  64194 */     GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(64272), // Rule ID 7664 //
     /*  64199 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  64202 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64206 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64210 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64214 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64218 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64222 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64226 */       GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64230 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64235 */       GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64239 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64241 */       // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[v2i16] } 0:{ *:[i32] }, VGPR_32:{ *:[i16] }:$b, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$a, 0:{ *:[i32] }, 16:{ *:[i16] }, 0:{ *:[i1] }, 0:{ *:[i32] })
     /*  64241 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /*  64244 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64246 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64249 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  64251 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64254 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
     /*  64258 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64261 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64264 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64267 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64270 */       GIR_RootConstrainSelectedInstOperands,
     /*  64271 */       // GIR_Coverage, 7664,
     /*  64271 */       GIR_EraseRootFromParent_Done,
     /*  64272 */     // Label 575: @64272
     /*  64272 */     GIM_Reject,
     /*  64273 */   // Label 573: @64273
     /*  64273 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(64343), // Rule ID 7681 //
     /*  64278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  64281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64313 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  64315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64320 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64330 */     // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), SReg_32:{ *:[i16] }:$src1)  =>  (S_PACK_HL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i16] }:$src1)
     /*  64330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HL_B32_B16),
     /*  64333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /*  64339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64341 */     GIR_RootConstrainSelectedInstOperands,
     /*  64342 */     // GIR_Coverage, 7681,
     /*  64342 */     GIR_EraseRootFromParent_Done,
     /*  64343 */   // Label 576: @64343
     /*  64343 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(64442), // Rule ID 7662 //
     /*  64348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  64351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  64367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  64371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  64383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  64387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64392 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  64396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  64400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64402 */     // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34997>>  =>  (V_BFI_B32_e64:{ *:[v2i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i32] }:$b)
     /*  64402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  64405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64414 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /*  64429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64434 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  64436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // b
     /*  64440 */     GIR_RootConstrainSelectedInstOperands,
     /*  64441 */     // GIR_Coverage, 7662,
     /*  64441 */     GIR_EraseRootFromParent_Done,
     /*  64442 */   // Label 577: @64442
     /*  64442 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(64478), // Rule ID 7636 //
     /*  64447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  64455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  64463 */     // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34995>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i16] })
     /*  64463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64468 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64476 */     GIR_RootConstrainSelectedInstOperands,
     /*  64477 */     // GIR_Coverage, 7636,
     /*  64477 */     GIR_EraseRootFromParent_Done,
     /*  64478 */   // Label 578: @64478
     /*  64478 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(64511), // Rule ID 7637 //
     /*  64483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  64491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  64499 */     // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34997>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)
     /*  64499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64507 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64509 */     GIR_RootConstrainSelectedInstOperands,
     /*  64510 */     // GIR_Coverage, 7637,
     /*  64510 */     GIR_EraseRootFromParent_Done,
     /*  64511 */   // Label 579: @64511
     /*  64511 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(64571), // Rule ID 7638 //
     /*  64516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  64532 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34995>>  =>  (S_AND_B32:{ *:[v2i16] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), SReg_32:{ *:[i16] }:$src1)
     /*  64532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  64535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  64539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64544 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /*  64559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  64566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64569 */     GIR_RootConstrainSelectedInstOperands,
     /*  64570 */     // GIR_Coverage, 7638,
     /*  64570 */     GIR_EraseRootFromParent_Done,
     /*  64571 */   // Label 580: @64571
     /*  64571 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(64628), // Rule ID 7639 //
     /*  64576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  64592 */     // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34997>>  =>  (V_AND_B32_e64:{ *:[v2i16] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$src1)
     /*  64592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  64595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  64599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64604 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /*  64614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  64616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  64619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  64626 */     GIR_RootConstrainSelectedInstOperands,
     /*  64627 */     // GIR_Coverage, 7639,
     /*  64627 */     GIR_EraseRootFromParent_Done,
     /*  64628 */   // Label 581: @64628
     /*  64628 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(64673), // Rule ID 7644 //
     /*  64633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  64656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64658 */     // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34995>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i32] })
     /*  64658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64663 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64671 */     GIR_RootConstrainSelectedInstOperands,
     /*  64672 */     // GIR_Coverage, 7644,
     /*  64672 */     GIR_EraseRootFromParent_Done,
     /*  64673 */   // Label 582: @64673
     /*  64673 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(64712), // Rule ID 7645 //
     /*  64678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  64698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64700 */     // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34997>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i32] }, VGPR_32:{ *:[i16] }:$src1)
     /*  64700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64710 */     GIR_RootConstrainSelectedInstOperands,
     /*  64711 */     // GIR_Coverage, 7645,
     /*  64711 */     GIR_EraseRootFromParent_Done,
     /*  64712 */   // Label 583: @64712
     /*  64712 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(64829),
     /*  64717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  64721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64729 */     GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(64762), // Rule ID 7647 //
     /*  64734 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64737 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64741 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64745 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64747 */       // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34995>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i32] })
     /*  64747 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64750 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64752 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64754 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64757 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64760 */       GIR_RootConstrainSelectedInstOperands,
     /*  64761 */       // GIR_Coverage, 7647,
     /*  64761 */       GIR_EraseRootFromParent_Done,
     /*  64762 */     // Label 585: @64762
     /*  64762 */     GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(64795), // Rule ID 7650 //
     /*  64767 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64770 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64774 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64778 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64780 */       // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34995>>  =>  (S_LSHL_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src1, 16:{ *:[i32] })
     /*  64780 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64783 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64785 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64787 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64790 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64793 */       GIR_RootConstrainSelectedInstOperands,
     /*  64794 */       // GIR_Coverage, 7650,
     /*  64794 */       GIR_EraseRootFromParent_Done,
     /*  64795 */     // Label 586: @64795
     /*  64795 */     GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(64828), // Rule ID 7652 //
     /*  64800 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64803 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64807 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64811 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64813 */       // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34995>>  =>  (S_LSHL_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src1, 16:{ *:[i32] })
     /*  64813 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /*  64816 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  64818 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64820 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64823 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /*  64826 */       GIR_RootConstrainSelectedInstOperands,
     /*  64827 */       // GIR_Coverage, 7652,
     /*  64827 */       GIR_EraseRootFromParent_Done,
     /*  64828 */     // Label 587: @64828
     /*  64828 */     GIM_Reject,
     /*  64829 */   // Label 584: @64829
     /*  64829 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(64868), // Rule ID 7653 //
     /*  64834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  64854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64856 */     // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), VGPR_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34997>>  =>  (V_LSHLREV_B32_e64:{ *:[v2f16] } 16:{ *:[i32] }, VGPR_32:{ *:[f16] }:$src1)
     /*  64856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /*  64859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  64861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  64864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  64866 */     GIR_RootConstrainSelectedInstOperands,
     /*  64867 */     // GIR_Coverage, 7653,
     /*  64867 */     GIR_EraseRootFromParent_Done,
     /*  64868 */   // Label 588: @64868
     /*  64868 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(64908), // Rule ID 7642 //
     /*  64873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  64893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64895 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34995>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] })
     /*  64895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64907 */     // GIR_Coverage, 7642,
     /*  64907 */     GIR_EraseRootFromParent_Done,
     /*  64908 */   // Label 589: @64908
     /*  64908 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(64988),
     /*  64913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  64917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64925 */     GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(64956), // Rule ID 7643 //
     /*  64930 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  64933 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64937 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64941 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64943 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34997>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i32] })
     /*  64943 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64946 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64948 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64950 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64955 */       // GIR_Coverage, 7643,
     /*  64955 */       GIR_EraseRootFromParent_Done,
     /*  64956 */     // Label 591: @64956
     /*  64956 */     GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(64987), // Rule ID 7646 //
     /*  64961 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  64964 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64968 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  64972 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64974 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34997>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i32] })
     /*  64974 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64977 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64979 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  64981 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  64986 */       // GIR_Coverage, 7646,
     /*  64986 */       GIR_EraseRootFromParent_Done,
     /*  64987 */     // Label 592: @64987
     /*  64987 */     GIM_Reject,
     /*  64988 */   // Label 590: @64988
     /*  64988 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(65028), // Rule ID 7648 //
     /*  64993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  64997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  65013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65015 */     // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34995>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[i32] })
     /*  65015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65020 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65027 */     // GIR_Coverage, 7648,
     /*  65027 */     GIR_EraseRootFromParent_Done,
     /*  65028 */   // Label 593: @65028
     /*  65028 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(65252),
     /*  65033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  65037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65045 */     GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(65076), // Rule ID 7649 //
     /*  65050 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  65053 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65057 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65061 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65063 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34997>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, VGPR_32:{ *:[i32] })
     /*  65063 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65066 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65068 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65070 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65075 */       // GIR_Coverage, 7649,
     /*  65075 */       GIR_EraseRootFromParent_Done,
     /*  65076 */     // Label 595: @65076
     /*  65076 */     GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(65107), // Rule ID 7651 //
     /*  65081 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  65084 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65088 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  65092 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65094 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34997>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, VGPR_32:{ *:[i32] })
     /*  65094 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65097 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65099 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65101 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65106 */       // GIR_Coverage, 7651,
     /*  65106 */       GIR_EraseRootFromParent_Done,
     /*  65107 */     // Label 596: @65107
     /*  65107 */     GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(65179), // Rule ID 7654 //
     /*  65112 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65115 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65119 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34997>>  =>  (V_LSHL_OR_B32_e64:{ *:[v2i16] } ?:{ *:[i16] }:$src1, 16:{ *:[i32] }, (V_AND_B32_e64:{ *:[i32] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src0))
     /*  65119 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  65122 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  65126 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65131 */       GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /*  65141 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  65143 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  65146 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  65150 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65155 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65158 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src0
     /*  65162 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65164 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  65167 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65169 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  65171 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  65174 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65177 */       GIR_RootConstrainSelectedInstOperands,
     /*  65178 */       // GIR_Coverage, 7654,
     /*  65178 */       GIR_EraseRootFromParent_Done,
     /*  65179 */     // Label 597: @65179
     /*  65179 */     GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(65251), // Rule ID 7655 //
     /*  65184 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65187 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65191 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34997>>  =>  (V_LSHL_OR_B32_e64:{ *:[v2i16] } ?:{ *:[i16] }:$src1, 16:{ *:[i32] }, (V_AND_B32_e64:{ *:[i32] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src0))
     /*  65191 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  65194 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /*  65198 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65203 */       GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /*  65213 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  65215 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  65218 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /*  65222 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65227 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65230 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src0
     /*  65234 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65236 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
     /*  65239 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65241 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  65243 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  65246 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65249 */       GIR_RootConstrainSelectedInstOperands,
     /*  65250 */       // GIR_Coverage, 7655,
     /*  65250 */       GIR_EraseRootFromParent_Done,
     /*  65251 */     // Label 598: @65251
     /*  65251 */     GIM_Reject,
     /*  65252 */   // Label 594: @65252
     /*  65252 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(65283), // Rule ID 7658 //
     /*  65257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  65260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  65276 */     // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34995>>  =>  (S_PACK_LL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)
     /*  65276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
     /*  65281 */     GIR_RootConstrainSelectedInstOperands,
     /*  65282 */     // GIR_Coverage, 7658,
     /*  65282 */     GIR_Done,
     /*  65283 */   // Label 599: @65283
     /*  65283 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(65452),
     /*  65288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  65292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65296 */     GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(65350), // Rule ID 7659 //
     /*  65301 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65304 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65308 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65312 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65312 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65315 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65319 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65324 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65334 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65336 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65339 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65341 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65343 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65345 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65348 */       GIR_RootConstrainSelectedInstOperands,
     /*  65349 */       // GIR_Coverage, 7659,
     /*  65349 */       GIR_EraseRootFromParent_Done,
     /*  65350 */     // Label 601: @65350
     /*  65350 */     GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(65397), // Rule ID 7660 //
     /*  65355 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseRealTrue16Insts),
     /*  65358 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65362 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65366 */       // (build_vector:{ *:[v2i16] } VGPR_16:{ *:[i16] }:$a, VGPR_16:{ *:[i16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (REG_SEQUENCE:{ *:[v2i16] } VGPR_32:{ *:[i32] }, VGPR_16:{ *:[i16] }:$a, lo16:{ *:[i32] }, VGPR_16:{ *:[i16] }:$b, hi16:{ *:[i32] })
     /*  65366 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  65369 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65371 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65373 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  65376 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65378 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  65381 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65386 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65391 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65396 */       // GIR_Coverage, 7660,
     /*  65396 */       GIR_EraseRootFromParent_Done,
     /*  65397 */     // Label 602: @65397
     /*  65397 */     GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(65451), // Rule ID 7666 //
     /*  65402 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65405 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65409 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65413 */       // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65413 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65416 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65420 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65425 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65435 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65442 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65444 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65446 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65449 */       GIR_RootConstrainSelectedInstOperands,
     /*  65450 */       // GIR_Coverage, 7666,
     /*  65450 */       GIR_EraseRootFromParent_Done,
     /*  65451 */     // Label 603: @65451
     /*  65451 */     GIM_Reject,
     /*  65452 */   // Label 600: @65452
     /*  65452 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(65483), // Rule ID 7668 //
     /*  65457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /*  65460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34995),
     /*  65476 */     // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34995>>  =>  (S_PACK_LL_B32_B16:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)
     /*  65476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
     /*  65481 */     GIR_RootConstrainSelectedInstOperands,
     /*  65482 */     // GIR_Coverage, 7668,
     /*  65482 */     GIR_Done,
     /*  65483 */   // Label 604: @65483
     /*  65483 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(65652),
     /*  65488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34997),
     /*  65492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65496 */     GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(65550), // Rule ID 7669 //
     /*  65501 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_NotHasTrue16BitInsts),
     /*  65504 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65508 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65512 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[f16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65512 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65515 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65519 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65524 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65534 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65536 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65539 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65541 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65543 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65545 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65548 */       GIR_RootConstrainSelectedInstOperands,
     /*  65549 */       // GIR_Coverage, 7669,
     /*  65549 */       GIR_EraseRootFromParent_Done,
     /*  65550 */     // Label 606: @65550
     /*  65550 */     GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(65604), // Rule ID 7670 //
     /*  65555 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseFakeTrue16Insts),
     /*  65558 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65562 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65566 */       // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[f16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
     /*  65566 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  65569 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  65573 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65578 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
     /*  65588 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65590 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /*  65593 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  65595 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65597 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65599 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65602 */       GIR_RootConstrainSelectedInstOperands,
     /*  65603 */       // GIR_Coverage, 7670,
     /*  65603 */       GIR_EraseRootFromParent_Done,
     /*  65604 */     // Label 607: @65604
     /*  65604 */     GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(65651), // Rule ID 7671 //
     /*  65609 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts_UseRealTrue16Insts),
     /*  65612 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65616 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65620 */       // (build_vector:{ *:[v2f16] } VGPR_16:{ *:[f16] }:$a, VGPR_16:{ *:[f16] }:$b)<<P:Predicate_anonymous_34997>>  =>  (REG_SEQUENCE:{ *:[v2f16] } VGPR_32:{ *:[i32] }, VGPR_16:{ *:[f16] }:$a, lo16:{ *:[i32] }, VGPR_16:{ *:[f16] }:$b, hi16:{ *:[i32] })
     /*  65620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  65623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65625 */       GIR_RootToRootCopy, /*OpIdx*/1, // a
     /*  65627 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  65630 */       GIR_RootToRootCopy, /*OpIdx*/2, // b
     /*  65632 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  65635 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65640 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65645 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  65650 */       // GIR_Coverage, 7671,
     /*  65650 */       GIR_EraseRootFromParent_Done,
     /*  65651 */     // Label 608: @65651
     /*  65651 */     GIM_Reject,
     /*  65652 */   // Label 605: @65652
     /*  65652 */   GIM_Reject,
     /*  65653 */ // Label 538: @65653
     /*  65653 */ GIM_Reject,
     /*  65654 */ // Label 8: @65654
     /*  65654 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(34), /*)*//*default:*//*Label 635*/ GIMT_Encode4(74817),
     /*  65665 */ /*GILLT_s16*//*Label 609*/ GIMT_Encode4(65769),
     /*  65669 */ /*GILLT_s32*//*Label 610*/ GIMT_Encode4(65883),
     /*  65673 */ /*GILLT_s64*//*Label 611*/ GIMT_Encode4(66232),
     /*  65677 */ /*GILLT_v2s16*//*Label 612*/ GIMT_Encode4(66523),
     /*  65681 */ /*GILLT_v2s32*//*Label 613*/ GIMT_Encode4(66872),
     /*  65685 */ /*GILLT_v2s64*//*Label 614*/ GIMT_Encode4(67163),
     /*  65689 */ /*GILLT_v3s32*//*Label 615*/ GIMT_Encode4(67744),
     /*  65693 */ /*GILLT_v3s64*//*Label 616*/ GIMT_Encode4(67798),
     /*  65697 */ /*GILLT_v4s16*//*Label 617*/ GIMT_Encode4(68147),
     /*  65701 */ /*GILLT_v4s32*//*Label 618*/ GIMT_Encode4(68438),
     /*  65705 */ /*GILLT_v4s64*//*Label 619*/ GIMT_Encode4(69019),
     /*  65709 */ /*GILLT_v5s32*//*Label 620*/ GIMT_Encode4(69600),
     /*  65713 */ /*GILLT_v6s32*//*Label 621*/ GIMT_Encode4(69714),
     /*  65717 */ /*GILLT_v7s32*//*Label 622*/ GIMT_Encode4(70063),
     /*  65721 */ /*GILLT_v8s16*//*Label 623*/ GIMT_Encode4(70177),
     /*  65725 */ /*GILLT_v8s32*//*Label 624*/ GIMT_Encode4(70758),
     /*  65729 */ /*GILLT_v8s64*//*Label 625*/ GIMT_Encode4(71339),
     /*  65733 */ /*GILLT_v9s32*//*Label 626*/ GIMT_Encode4(71920),
     /*  65737 */ /*GILLT_v10s32*//*Label 627*/ GIMT_Encode4(72034),
     /*  65741 */ /*GILLT_v11s32*//*Label 628*/ GIMT_Encode4(72148),
     /*  65745 */ /*GILLT_v12s32*//*Label 629*/ GIMT_Encode4(72262),
     /*  65749 */ /*GILLT_v16s16*//*Label 630*/ GIMT_Encode4(72376),
     /*  65753 */ /*GILLT_v16s32*//*Label 631*/ GIMT_Encode4(72957),
     /*  65757 */ /*GILLT_v16s64*//*Label 632*/ GIMT_Encode4(73538),
     /*  65761 */ /*GILLT_v32s16*//*Label 633*/ GIMT_Encode4(73887),
     /*  65765 */ /*GILLT_v32s32*//*Label 634*/ GIMT_Encode4(74468),
     /*  65769 */ // Label 609: @65769
     /*  65769 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(65882),
     /*  65774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  65777 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(65803), // Rule ID 7040 //
     /*  65782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65790 */     // (bitconvert:{ *:[i16] } VGPR_32:{ *:[f16] }:$src0)  =>  VGPR_32:{ *:[i16] }:$src0
     /*  65790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65793 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65802 */     // GIR_Coverage, 7040,
     /*  65802 */     GIR_EraseRootFromParent_Done,
     /*  65803 */   // Label 637: @65803
     /*  65803 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(65829), // Rule ID 7041 //
     /*  65808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65816 */     // (bitconvert:{ *:[i16] } SReg_32:{ *:[f16] }:$src0)  =>  SReg_32:{ *:[i16] }:$src0
     /*  65816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65819 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65821 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65828 */     // GIR_Coverage, 7041,
     /*  65828 */     GIR_EraseRootFromParent_Done,
     /*  65829 */   // Label 638: @65829
     /*  65829 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(65855), // Rule ID 7042 //
     /*  65834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65842 */     // (bitconvert:{ *:[f16] } VGPR_32:{ *:[i16] }:$src0)  =>  VGPR_32:{ *:[f16] }:$src0
     /*  65842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65845 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65854 */     // GIR_Coverage, 7042,
     /*  65854 */     GIR_EraseRootFromParent_Done,
     /*  65855 */   // Label 639: @65855
     /*  65855 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(65881), // Rule ID 7043 //
     /*  65860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65868 */     // (bitconvert:{ *:[f16] } SReg_32:{ *:[i16] }:$src0)  =>  SReg_32:{ *:[f16] }:$src0
     /*  65868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65871 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65880 */     // GIR_Coverage, 7043,
     /*  65880 */     GIR_EraseRootFromParent_Done,
     /*  65881 */   // Label 640: @65881
     /*  65881 */   GIM_Reject,
     /*  65882 */ // Label 636: @65882
     /*  65882 */ GIM_Reject,
     /*  65883 */ // Label 610: @65883
     /*  65883 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(65912), // Rule ID 7044 //
     /*  65888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65899 */   // (bitconvert:{ *:[i32] } VGPR_32:{ *:[f32] }:$src0)  =>  VGPR_32:{ *:[i32] }:$src0
     /*  65899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65902 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65904 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65906 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65911 */   // GIR_Coverage, 7044,
     /*  65911 */   GIR_EraseRootFromParent_Done,
     /*  65912 */ // Label 641: @65912
     /*  65912 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(65941), // Rule ID 7045 //
     /*  65917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  65920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65928 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  65928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65931 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65933 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65940 */   // GIR_Coverage, 7045,
     /*  65940 */   GIR_EraseRootFromParent_Done,
     /*  65941 */ // Label 642: @65941
     /*  65941 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(65970), // Rule ID 7046 //
     /*  65946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  65949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65957 */   // (bitconvert:{ *:[i32] } VGPR_32:{ *:[v2i16] }:$src0)  =>  VGPR_32:{ *:[i32] }:$src0
     /*  65957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65960 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65962 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  65969 */   // GIR_Coverage, 7046,
     /*  65969 */   GIR_EraseRootFromParent_Done,
     /*  65970 */ // Label 643: @65970
     /*  65970 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(65999), // Rule ID 7047 //
     /*  65975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  65978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65986 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  65986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65989 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  65991 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  65993 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  65998 */   // GIR_Coverage, 7047,
     /*  65998 */   GIR_EraseRootFromParent_Done,
     /*  65999 */ // Label 644: @65999
     /*  65999 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(66028), // Rule ID 7048 //
     /*  66004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66015 */   // (bitconvert:{ *:[i32] } VGPR_32:{ *:[v2f16] }:$src0)  =>  VGPR_32:{ *:[i32] }:$src0
     /*  66015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66018 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66020 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66027 */   // GIR_Coverage, 7048,
     /*  66027 */   GIR_EraseRootFromParent_Done,
     /*  66028 */ // Label 645: @66028
     /*  66028 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(66057), // Rule ID 7049 //
     /*  66033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66044 */   // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
     /*  66044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66056 */   // GIR_Coverage, 7049,
     /*  66056 */   GIR_EraseRootFromParent_Done,
     /*  66057 */ // Label 646: @66057
     /*  66057 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(66086), // Rule ID 7050 //
     /*  66062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66073 */   // (bitconvert:{ *:[f32] } VGPR_32:{ *:[i32] }:$src0)  =>  VGPR_32:{ *:[f32] }:$src0
     /*  66073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66076 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66078 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66080 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66085 */   // GIR_Coverage, 7050,
     /*  66085 */   GIR_EraseRootFromParent_Done,
     /*  66086 */ // Label 647: @66086
     /*  66086 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(66115), // Rule ID 7051 //
     /*  66091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66102 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  66102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66114 */   // GIR_Coverage, 7051,
     /*  66114 */   GIR_EraseRootFromParent_Done,
     /*  66115 */ // Label 648: @66115
     /*  66115 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(66144), // Rule ID 7052 //
     /*  66120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66131 */   // (bitconvert:{ *:[f32] } VGPR_32:{ *:[v2i16] }:$src0)  =>  VGPR_32:{ *:[f32] }:$src0
     /*  66131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66143 */   // GIR_Coverage, 7052,
     /*  66143 */   GIR_EraseRootFromParent_Done,
     /*  66144 */ // Label 649: @66144
     /*  66144 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(66173), // Rule ID 7053 //
     /*  66149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66160 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  66160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66172 */   // GIR_Coverage, 7053,
     /*  66172 */   GIR_EraseRootFromParent_Done,
     /*  66173 */ // Label 650: @66173
     /*  66173 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(66202), // Rule ID 7054 //
     /*  66178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66189 */   // (bitconvert:{ *:[f32] } VGPR_32:{ *:[v2f16] }:$src0)  =>  VGPR_32:{ *:[f32] }:$src0
     /*  66189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66192 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66194 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66201 */   // GIR_Coverage, 7054,
     /*  66201 */   GIR_EraseRootFromParent_Done,
     /*  66202 */ // Label 651: @66202
     /*  66202 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(66231), // Rule ID 7055 //
     /*  66207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66218 */   // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
     /*  66218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66230 */   // GIR_Coverage, 7055,
     /*  66230 */   GIR_EraseRootFromParent_Done,
     /*  66231 */ // Label 652: @66231
     /*  66231 */ GIM_Reject,
     /*  66232 */ // Label 611: @66232
     /*  66232 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(66261), // Rule ID 7068 //
     /*  66237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66248 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66251 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66260 */   // GIR_Coverage, 7068,
     /*  66260 */   GIR_EraseRootFromParent_Done,
     /*  66261 */ // Label 653: @66261
     /*  66261 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(66290), // Rule ID 7069 //
     /*  66266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66277 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66280 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66282 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66284 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66289 */   // GIR_Coverage, 7069,
     /*  66289 */   GIR_EraseRootFromParent_Done,
     /*  66290 */ // Label 654: @66290
     /*  66290 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(66319), // Rule ID 7070 //
     /*  66295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66306 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66309 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66313 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66318 */   // GIR_Coverage, 7070,
     /*  66318 */   GIR_EraseRootFromParent_Done,
     /*  66319 */ // Label 655: @66319
     /*  66319 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(66348), // Rule ID 7071 //
     /*  66324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66335 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66338 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66340 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66347 */   // GIR_Coverage, 7071,
     /*  66347 */   GIR_EraseRootFromParent_Done,
     /*  66348 */ // Label 656: @66348
     /*  66348 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(66377), // Rule ID 7072 //
     /*  66353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66364 */   // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
     /*  66364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66367 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66376 */   // GIR_Coverage, 7072,
     /*  66376 */   GIR_EraseRootFromParent_Done,
     /*  66377 */ // Label 657: @66377
     /*  66377 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(66406), // Rule ID 7073 //
     /*  66382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66393 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66396 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66398 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66405 */   // GIR_Coverage, 7073,
     /*  66405 */   GIR_EraseRootFromParent_Done,
     /*  66406 */ // Label 658: @66406
     /*  66406 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(66435), // Rule ID 7074 //
     /*  66411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66422 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66434 */   // GIR_Coverage, 7074,
     /*  66434 */   GIR_EraseRootFromParent_Done,
     /*  66435 */ // Label 659: @66435
     /*  66435 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(66464), // Rule ID 7075 //
     /*  66440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66451 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66463 */   // GIR_Coverage, 7075,
     /*  66463 */   GIR_EraseRootFromParent_Done,
     /*  66464 */ // Label 660: @66464
     /*  66464 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(66493), // Rule ID 7076 //
     /*  66469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66480 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66492 */   // GIR_Coverage, 7076,
     /*  66492 */   GIR_EraseRootFromParent_Done,
     /*  66493 */ // Label 661: @66493
     /*  66493 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(66522), // Rule ID 7077 //
     /*  66498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66509 */   // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
     /*  66509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66521 */   // GIR_Coverage, 7077,
     /*  66521 */   GIR_EraseRootFromParent_Done,
     /*  66522 */ // Label 662: @66522
     /*  66522 */ GIM_Reject,
     /*  66523 */ // Label 612: @66523
     /*  66523 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(66552), // Rule ID 7056 //
     /*  66528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66539 */   // (bitconvert:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$src0)  =>  VGPR_32:{ *:[v2i16] }:$src0
     /*  66539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66542 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66544 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66546 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66551 */   // GIR_Coverage, 7056,
     /*  66551 */   GIR_EraseRootFromParent_Done,
     /*  66552 */ // Label 663: @66552
     /*  66552 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(66581), // Rule ID 7057 //
     /*  66557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66568 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66571 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66573 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66580 */   // GIR_Coverage, 7057,
     /*  66580 */   GIR_EraseRootFromParent_Done,
     /*  66581 */ // Label 664: @66581
     /*  66581 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(66610), // Rule ID 7058 //
     /*  66586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66597 */   // (bitconvert:{ *:[v2i16] } VGPR_32:{ *:[f32] }:$src0)  =>  VGPR_32:{ *:[v2i16] }:$src0
     /*  66597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66600 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66602 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66604 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66609 */   // GIR_Coverage, 7058,
     /*  66609 */   GIR_EraseRootFromParent_Done,
     /*  66610 */ // Label 665: @66610
     /*  66610 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(66639), // Rule ID 7059 //
     /*  66615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66626 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66629 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66631 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66638 */   // GIR_Coverage, 7059,
     /*  66638 */   GIR_EraseRootFromParent_Done,
     /*  66639 */ // Label 666: @66639
     /*  66639 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(66668), // Rule ID 7060 //
     /*  66644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66655 */   // (bitconvert:{ *:[v2i16] } VGPR_32:{ *:[v2f16] }:$src0)  =>  VGPR_32:{ *:[v2i16] }:$src0
     /*  66655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66658 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66660 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66667 */   // GIR_Coverage, 7060,
     /*  66667 */   GIR_EraseRootFromParent_Done,
     /*  66668 */ // Label 667: @66668
     /*  66668 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(66697), // Rule ID 7061 //
     /*  66673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66684 */   // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
     /*  66684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66696 */   // GIR_Coverage, 7061,
     /*  66696 */   GIR_EraseRootFromParent_Done,
     /*  66697 */ // Label 668: @66697
     /*  66697 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(66726), // Rule ID 7062 //
     /*  66702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66713 */   // (bitconvert:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$src0)  =>  VGPR_32:{ *:[v2f16] }:$src0
     /*  66713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66716 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66725 */   // GIR_Coverage, 7062,
     /*  66725 */   GIR_EraseRootFromParent_Done,
     /*  66726 */ // Label 669: @66726
     /*  66726 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(66755), // Rule ID 7063 //
     /*  66731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66742 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66754 */   // GIR_Coverage, 7063,
     /*  66754 */   GIR_EraseRootFromParent_Done,
     /*  66755 */ // Label 670: @66755
     /*  66755 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(66784), // Rule ID 7064 //
     /*  66760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66771 */   // (bitconvert:{ *:[v2f16] } VGPR_32:{ *:[f32] }:$src0)  =>  VGPR_32:{ *:[v2f16] }:$src0
     /*  66771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66783 */   // GIR_Coverage, 7064,
     /*  66783 */   GIR_EraseRootFromParent_Done,
     /*  66784 */ // Label 671: @66784
     /*  66784 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(66813), // Rule ID 7065 //
     /*  66789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  66792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66800 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66812 */   // GIR_Coverage, 7065,
     /*  66812 */   GIR_EraseRootFromParent_Done,
     /*  66813 */ // Label 672: @66813
     /*  66813 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(66842), // Rule ID 7066 //
     /*  66818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66829 */   // (bitconvert:{ *:[v2f16] } VGPR_32:{ *:[v2i16] }:$src0)  =>  VGPR_32:{ *:[v2f16] }:$src0
     /*  66829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66832 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66834 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  66841 */   // GIR_Coverage, 7066,
     /*  66841 */   GIR_EraseRootFromParent_Done,
     /*  66842 */ // Label 673: @66842
     /*  66842 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(66871), // Rule ID 7067 //
     /*  66847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  66850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66858 */   // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
     /*  66858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66861 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66863 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  66870 */   // GIR_Coverage, 7067,
     /*  66870 */   GIR_EraseRootFromParent_Done,
     /*  66871 */ // Label 674: @66871
     /*  66871 */ GIM_Reject,
     /*  66872 */ // Label 613: @66872
     /*  66872 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(66901), // Rule ID 7078 //
     /*  66877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66888 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66891 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66893 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66895 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66900 */   // GIR_Coverage, 7078,
     /*  66900 */   GIR_EraseRootFromParent_Done,
     /*  66901 */ // Label 675: @66901
     /*  66901 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(66930), // Rule ID 7079 //
     /*  66906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  66909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66917 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66920 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66922 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66929 */   // GIR_Coverage, 7079,
     /*  66929 */   GIR_EraseRootFromParent_Done,
     /*  66930 */ // Label 676: @66930
     /*  66930 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(66959), // Rule ID 7080 //
     /*  66935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66946 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66958 */   // GIR_Coverage, 7080,
     /*  66958 */   GIR_EraseRootFromParent_Done,
     /*  66959 */ // Label 677: @66959
     /*  66959 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(66988), // Rule ID 7081 //
     /*  66964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66975 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  66975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66978 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  66980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  66982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  66987 */   // GIR_Coverage, 7081,
     /*  66987 */   GIR_EraseRootFromParent_Done,
     /*  66988 */ // Label 678: @66988
     /*  66988 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(67017), // Rule ID 7082 //
     /*  66993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67004 */   // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
     /*  67004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67016 */   // GIR_Coverage, 7082,
     /*  67016 */   GIR_EraseRootFromParent_Done,
     /*  67017 */ // Label 679: @67017
     /*  67017 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(67046), // Rule ID 7083 //
     /*  67022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67033 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  67033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67045 */   // GIR_Coverage, 7083,
     /*  67045 */   GIR_EraseRootFromParent_Done,
     /*  67046 */ // Label 680: @67046
     /*  67046 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(67075), // Rule ID 7084 //
     /*  67051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  67054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67062 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  67062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67074 */   // GIR_Coverage, 7084,
     /*  67074 */   GIR_EraseRootFromParent_Done,
     /*  67075 */ // Label 681: @67075
     /*  67075 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(67104), // Rule ID 7085 //
     /*  67080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  67083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67091 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  67091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67094 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67096 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67103 */   // GIR_Coverage, 7085,
     /*  67103 */   GIR_EraseRootFromParent_Done,
     /*  67104 */ // Label 682: @67104
     /*  67104 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(67133), // Rule ID 7086 //
     /*  67109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67120 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  67120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67123 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67125 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67132 */   // GIR_Coverage, 7086,
     /*  67132 */   GIR_EraseRootFromParent_Done,
     /*  67133 */ // Label 683: @67133
     /*  67133 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(67162), // Rule ID 7087 //
     /*  67138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67149 */   // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
     /*  67149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67152 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67154 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  67161 */   // GIR_Coverage, 7087,
     /*  67161 */   GIR_EraseRootFromParent_Done,
     /*  67162 */ // Label 684: @67162
     /*  67162 */ GIM_Reject,
     /*  67163 */ // Label 614: @67163
     /*  67163 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(67192), // Rule ID 7120 //
     /*  67168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67179 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67182 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67184 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67191 */   // GIR_Coverage, 7120,
     /*  67191 */   GIR_EraseRootFromParent_Done,
     /*  67192 */ // Label 685: @67192
     /*  67192 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(67221), // Rule ID 7121 //
     /*  67197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67208 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67211 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67213 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67215 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67220 */   // GIR_Coverage, 7121,
     /*  67220 */   GIR_EraseRootFromParent_Done,
     /*  67221 */ // Label 686: @67221
     /*  67221 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(67250), // Rule ID 7122 //
     /*  67226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67237 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67240 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67242 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67249 */   // GIR_Coverage, 7122,
     /*  67249 */   GIR_EraseRootFromParent_Done,
     /*  67250 */ // Label 687: @67250
     /*  67250 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(67279), // Rule ID 7123 //
     /*  67255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67266 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v4f32] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67269 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67271 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67273 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67278 */   // GIR_Coverage, 7123,
     /*  67278 */   GIR_EraseRootFromParent_Done,
     /*  67279 */ // Label 688: @67279
     /*  67279 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(67308), // Rule ID 7124 //
     /*  67284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67295 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67298 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67300 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67307 */   // GIR_Coverage, 7124,
     /*  67307 */   GIR_EraseRootFromParent_Done,
     /*  67308 */ // Label 689: @67308
     /*  67308 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(67337), // Rule ID 7125 //
     /*  67313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67324 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67336 */   // GIR_Coverage, 7125,
     /*  67336 */   GIR_EraseRootFromParent_Done,
     /*  67337 */ // Label 690: @67337
     /*  67337 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(67366), // Rule ID 7126 //
     /*  67342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67353 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67365 */   // GIR_Coverage, 7126,
     /*  67365 */   GIR_EraseRootFromParent_Done,
     /*  67366 */ // Label 691: @67366
     /*  67366 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(67395), // Rule ID 7127 //
     /*  67371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67382 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67394 */   // GIR_Coverage, 7127,
     /*  67394 */   GIR_EraseRootFromParent_Done,
     /*  67395 */ // Label 692: @67395
     /*  67395 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(67424), // Rule ID 7128 //
     /*  67400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67411 */   // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
     /*  67411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67414 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67423 */   // GIR_Coverage, 7128,
     /*  67423 */   GIR_EraseRootFromParent_Done,
     /*  67424 */ // Label 693: @67424
     /*  67424 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(67453), // Rule ID 7129 //
     /*  67429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67440 */   // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
     /*  67440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67443 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67445 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67452 */   // GIR_Coverage, 7129,
     /*  67452 */   GIR_EraseRootFromParent_Done,
     /*  67453 */ // Label 694: @67453
     /*  67453 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(67482), // Rule ID 7130 //
     /*  67458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67469 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  67469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67472 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67474 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67481 */   // GIR_Coverage, 7130,
     /*  67481 */   GIR_EraseRootFromParent_Done,
     /*  67482 */ // Label 695: @67482
     /*  67482 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(67511), // Rule ID 7131 //
     /*  67487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67498 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67501 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67503 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67510 */   // GIR_Coverage, 7131,
     /*  67510 */   GIR_EraseRootFromParent_Done,
     /*  67511 */ // Label 696: @67511
     /*  67511 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(67540), // Rule ID 7132 //
     /*  67516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67527 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  67527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67530 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67532 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67539 */   // GIR_Coverage, 7132,
     /*  67539 */   GIR_EraseRootFromParent_Done,
     /*  67540 */ // Label 697: @67540
     /*  67540 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(67569), // Rule ID 7133 //
     /*  67545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67556 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v4f32] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67559 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67561 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67568 */   // GIR_Coverage, 7133,
     /*  67568 */   GIR_EraseRootFromParent_Done,
     /*  67569 */ // Label 698: @67569
     /*  67569 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(67598), // Rule ID 7134 //
     /*  67574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67585 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  67585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67588 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67590 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67597 */   // GIR_Coverage, 7134,
     /*  67597 */   GIR_EraseRootFromParent_Done,
     /*  67598 */ // Label 699: @67598
     /*  67598 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(67627), // Rule ID 7135 //
     /*  67603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67614 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67617 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67619 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67626 */   // GIR_Coverage, 7135,
     /*  67626 */   GIR_EraseRootFromParent_Done,
     /*  67627 */ // Label 700: @67627
     /*  67627 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(67656), // Rule ID 7136 //
     /*  67632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67643 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  67643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67655 */   // GIR_Coverage, 7136,
     /*  67655 */   GIR_EraseRootFromParent_Done,
     /*  67656 */ // Label 701: @67656
     /*  67656 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(67685), // Rule ID 7137 //
     /*  67661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67672 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67684 */   // GIR_Coverage, 7137,
     /*  67684 */   GIR_EraseRootFromParent_Done,
     /*  67685 */ // Label 702: @67685
     /*  67685 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(67714), // Rule ID 7138 //
     /*  67690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67701 */   // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
     /*  67701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67704 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67708 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  67713 */   // GIR_Coverage, 7138,
     /*  67713 */   GIR_EraseRootFromParent_Done,
     /*  67714 */ // Label 703: @67714
     /*  67714 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(67743), // Rule ID 7139 //
     /*  67719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  67722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67730 */   // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
     /*  67730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  67742 */   // GIR_Coverage, 7139,
     /*  67742 */   GIR_EraseRootFromParent_Done,
     /*  67743 */ // Label 704: @67743
     /*  67743 */ GIM_Reject,
     /*  67744 */ // Label 615: @67744
     /*  67744 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(67797),
     /*  67749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s32,
     /*  67752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67760 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(67778), // Rule ID 7098 //
     /*  67765 */     // (bitconvert:{ *:[v3i32] } SGPR_96:{ *:[v3f32] }:$src0)  =>  SGPR_96:{ *:[v3i32] }:$src0
     /*  67765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67768 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67770 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67777 */     // GIR_Coverage, 7098,
     /*  67777 */     GIR_EraseRootFromParent_Done,
     /*  67778 */   // Label 706: @67778
     /*  67778 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(67796), // Rule ID 7099 //
     /*  67783 */     // (bitconvert:{ *:[v3f32] } SGPR_96:{ *:[v3i32] }:$src0)  =>  SGPR_96:{ *:[v3f32] }:$src0
     /*  67783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67786 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
     /*  67795 */     // GIR_Coverage, 7099,
     /*  67795 */     GIR_EraseRootFromParent_Done,
     /*  67796 */   // Label 707: @67796
     /*  67796 */   GIM_Reject,
     /*  67797 */ // Label 705: @67797
     /*  67797 */ GIM_Reject,
     /*  67798 */ // Label 616: @67798
     /*  67798 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(67827), // Rule ID 7176 //
     /*  67803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67814 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67817 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67826 */   // GIR_Coverage, 7176,
     /*  67826 */   GIR_EraseRootFromParent_Done,
     /*  67827 */ // Label 708: @67827
     /*  67827 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(67856), // Rule ID 7177 //
     /*  67832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67843 */   // (bitconvert:{ *:[v3i64] } SReg_192:{ *:[v6i32] }:$src0)  =>  SReg_192:{ *:[v3i64] }:$src0
     /*  67843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67846 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67848 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67850 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67855 */   // GIR_Coverage, 7177,
     /*  67855 */   GIR_EraseRootFromParent_Done,
     /*  67856 */ // Label 709: @67856
     /*  67856 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(67885), // Rule ID 7178 //
     /*  67861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67872 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67875 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67884 */   // GIR_Coverage, 7178,
     /*  67884 */   GIR_EraseRootFromParent_Done,
     /*  67885 */ // Label 710: @67885
     /*  67885 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(67914), // Rule ID 7179 //
     /*  67890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67901 */   // (bitconvert:{ *:[v3i64] } SReg_192:{ *:[v6f32] }:$src0)  =>  SReg_192:{ *:[v3i64] }:$src0
     /*  67901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67904 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67906 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67913 */   // GIR_Coverage, 7179,
     /*  67913 */   GIR_EraseRootFromParent_Done,
     /*  67914 */ // Label 711: @67914
     /*  67914 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(67943), // Rule ID 7180 //
     /*  67919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  67922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67930 */   // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
     /*  67930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67933 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67942 */   // GIR_Coverage, 7180,
     /*  67942 */   GIR_EraseRootFromParent_Done,
     /*  67943 */ // Label 712: @67943
     /*  67943 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(67972), // Rule ID 7181 //
     /*  67948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  67951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67959 */   // (bitconvert:{ *:[v3i64] } SReg_192:{ *:[v3f64] }:$src0)  =>  SReg_192:{ *:[v3i64] }:$src0
     /*  67959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67962 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  67971 */   // GIR_Coverage, 7181,
     /*  67971 */   GIR_EraseRootFromParent_Done,
     /*  67972 */ // Label 713: @67972
     /*  67972 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(68001), // Rule ID 7182 //
     /*  67977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  67980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  67988 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  67988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  67993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  67995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68000 */   // GIR_Coverage, 7182,
     /*  68000 */   GIR_EraseRootFromParent_Done,
     /*  68001 */ // Label 714: @68001
     /*  68001 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(68030), // Rule ID 7183 //
     /*  68006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68017 */   // (bitconvert:{ *:[v3f64] } SReg_192:{ *:[v6i32] }:$src0)  =>  SReg_192:{ *:[v3f64] }:$src0
     /*  68017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68020 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68022 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68029 */   // GIR_Coverage, 7183,
     /*  68029 */   GIR_EraseRootFromParent_Done,
     /*  68030 */ // Label 715: @68030
     /*  68030 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(68059), // Rule ID 7184 //
     /*  68035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68046 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  68046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68058 */   // GIR_Coverage, 7184,
     /*  68058 */   GIR_EraseRootFromParent_Done,
     /*  68059 */ // Label 716: @68059
     /*  68059 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(68088), // Rule ID 7185 //
     /*  68064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  68067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68075 */   // (bitconvert:{ *:[v3f64] } SReg_192:{ *:[v6f32] }:$src0)  =>  SReg_192:{ *:[v3f64] }:$src0
     /*  68075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68078 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68080 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68082 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68087 */   // GIR_Coverage, 7185,
     /*  68087 */   GIR_EraseRootFromParent_Done,
     /*  68088 */ // Label 717: @68088
     /*  68088 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(68117), // Rule ID 7186 //
     /*  68093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68104 */   // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
     /*  68104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68107 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68109 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  68116 */   // GIR_Coverage, 7186,
     /*  68116 */   GIR_EraseRootFromParent_Done,
     /*  68117 */ // Label 718: @68117
     /*  68117 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(68146), // Rule ID 7187 //
     /*  68122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  68125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68133 */   // (bitconvert:{ *:[v3f64] } SReg_192:{ *:[v3i64] }:$src0)  =>  SReg_192:{ *:[v3f64] }:$src0
     /*  68133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  68145 */   // GIR_Coverage, 7187,
     /*  68145 */   GIR_EraseRootFromParent_Done,
     /*  68146 */ // Label 719: @68146
     /*  68146 */ GIM_Reject,
     /*  68147 */ // Label 617: @68147
     /*  68147 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(68176), // Rule ID 7088 //
     /*  68152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  68155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68163 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  68163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68175 */   // GIR_Coverage, 7088,
     /*  68175 */   GIR_EraseRootFromParent_Done,
     /*  68176 */ // Label 720: @68176
     /*  68176 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(68205), // Rule ID 7089 //
     /*  68181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  68184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68192 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  68192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68195 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68204 */   // GIR_Coverage, 7089,
     /*  68204 */   GIR_EraseRootFromParent_Done,
     /*  68205 */ // Label 721: @68205
     /*  68205 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(68234), // Rule ID 7090 //
     /*  68210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  68213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68221 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  68221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68224 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68226 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68233 */   // GIR_Coverage, 7090,
     /*  68233 */   GIR_EraseRootFromParent_Done,
     /*  68234 */ // Label 722: @68234
     /*  68234 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(68263), // Rule ID 7091 //
     /*  68239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  68242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68250 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  68250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68262 */   // GIR_Coverage, 7091,
     /*  68262 */   GIR_EraseRootFromParent_Done,
     /*  68263 */ // Label 723: @68263
     /*  68263 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(68292), // Rule ID 7092 //
     /*  68268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68279 */   // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
     /*  68279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68282 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68284 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68291 */   // GIR_Coverage, 7092,
     /*  68291 */   GIR_EraseRootFromParent_Done,
     /*  68292 */ // Label 724: @68292
     /*  68292 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(68321), // Rule ID 7093 //
     /*  68297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  68300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68308 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  68308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68311 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68320 */   // GIR_Coverage, 7093,
     /*  68320 */   GIR_EraseRootFromParent_Done,
     /*  68321 */ // Label 725: @68321
     /*  68321 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(68350), // Rule ID 7094 //
     /*  68326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  68329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68337 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  68337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68340 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68342 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68344 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68349 */   // GIR_Coverage, 7094,
     /*  68349 */   GIR_EraseRootFromParent_Done,
     /*  68350 */ // Label 726: @68350
     /*  68350 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(68379), // Rule ID 7095 //
     /*  68355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  68358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68366 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  68366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68369 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68378 */   // GIR_Coverage, 7095,
     /*  68378 */   GIR_EraseRootFromParent_Done,
     /*  68379 */ // Label 727: @68379
     /*  68379 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(68408), // Rule ID 7096 //
     /*  68384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  68387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68395 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  68395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68398 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68400 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68402 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68407 */   // GIR_Coverage, 7096,
     /*  68407 */   GIR_EraseRootFromParent_Done,
     /*  68408 */ // Label 728: @68408
     /*  68408 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(68437), // Rule ID 7097 //
     /*  68413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68424 */   // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
     /*  68424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  68436 */   // GIR_Coverage, 7097,
     /*  68436 */   GIR_EraseRootFromParent_Done,
     /*  68437 */ // Label 729: @68437
     /*  68437 */ GIM_Reject,
     /*  68438 */ // Label 618: @68438
     /*  68438 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(68467), // Rule ID 7100 //
     /*  68443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68454 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  68454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68457 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68466 */   // GIR_Coverage, 7100,
     /*  68466 */   GIR_EraseRootFromParent_Done,
     /*  68467 */ // Label 730: @68467
     /*  68467 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(68496), // Rule ID 7101 //
     /*  68472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68483 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v4f32] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  68483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68495 */   // GIR_Coverage, 7101,
     /*  68495 */   GIR_EraseRootFromParent_Done,
     /*  68496 */ // Label 731: @68496
     /*  68496 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(68525), // Rule ID 7102 //
     /*  68501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68512 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  68512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68515 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68524 */   // GIR_Coverage, 7102,
     /*  68524 */   GIR_EraseRootFromParent_Done,
     /*  68525 */ // Label 732: @68525
     /*  68525 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(68554), // Rule ID 7103 //
     /*  68530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68541 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  68541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68553 */   // GIR_Coverage, 7103,
     /*  68553 */   GIR_EraseRootFromParent_Done,
     /*  68554 */ // Label 733: @68554
     /*  68554 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(68583), // Rule ID 7104 //
     /*  68559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68570 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  68570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68573 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68575 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68582 */   // GIR_Coverage, 7104,
     /*  68582 */   GIR_EraseRootFromParent_Done,
     /*  68583 */ // Label 734: @68583
     /*  68583 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(68612), // Rule ID 7105 //
     /*  68588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68599 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  68599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68602 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68604 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68606 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68611 */   // GIR_Coverage, 7105,
     /*  68611 */   GIR_EraseRootFromParent_Done,
     /*  68612 */ // Label 735: @68612
     /*  68612 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(68641), // Rule ID 7106 //
     /*  68617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68628 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  68628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68631 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68633 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68640 */   // GIR_Coverage, 7106,
     /*  68640 */   GIR_EraseRootFromParent_Done,
     /*  68641 */ // Label 736: @68641
     /*  68641 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(68670), // Rule ID 7107 //
     /*  68646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68657 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  68657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68669 */   // GIR_Coverage, 7107,
     /*  68669 */   GIR_EraseRootFromParent_Done,
     /*  68670 */ // Label 737: @68670
     /*  68670 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(68699), // Rule ID 7108 //
     /*  68675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68686 */   // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
     /*  68686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68689 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68698 */   // GIR_Coverage, 7108,
     /*  68698 */   GIR_EraseRootFromParent_Done,
     /*  68699 */ // Label 738: @68699
     /*  68699 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(68728), // Rule ID 7109 //
     /*  68704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68715 */   // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
     /*  68715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68718 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68727 */   // GIR_Coverage, 7109,
     /*  68727 */   GIR_EraseRootFromParent_Done,
     /*  68728 */ // Label 739: @68728
     /*  68728 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(68757), // Rule ID 7110 //
     /*  68733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68744 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  68744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68756 */   // GIR_Coverage, 7110,
     /*  68756 */   GIR_EraseRootFromParent_Done,
     /*  68757 */ // Label 740: @68757
     /*  68757 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(68786), // Rule ID 7111 //
     /*  68762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68773 */   // (bitconvert:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v4f32] }:$src0
     /*  68773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68776 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68778 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68785 */   // GIR_Coverage, 7111,
     /*  68785 */   GIR_EraseRootFromParent_Done,
     /*  68786 */ // Label 741: @68786
     /*  68786 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(68815), // Rule ID 7112 //
     /*  68791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68802 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  68802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68814 */   // GIR_Coverage, 7112,
     /*  68814 */   GIR_EraseRootFromParent_Done,
     /*  68815 */ // Label 742: @68815
     /*  68815 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(68844), // Rule ID 7113 //
     /*  68820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68831 */   // (bitconvert:{ *:[v4f32] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v4f32] }:$src0
     /*  68831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68834 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68836 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68843 */   // GIR_Coverage, 7113,
     /*  68843 */   GIR_EraseRootFromParent_Done,
     /*  68844 */ // Label 743: @68844
     /*  68844 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(68873), // Rule ID 7114 //
     /*  68849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68860 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  68860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68872 */   // GIR_Coverage, 7114,
     /*  68872 */   GIR_EraseRootFromParent_Done,
     /*  68873 */ // Label 744: @68873
     /*  68873 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(68902), // Rule ID 7115 //
     /*  68878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  68881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68889 */   // (bitconvert:{ *:[v4f32] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v4f32] }:$src0
     /*  68889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68901 */   // GIR_Coverage, 7115,
     /*  68901 */   GIR_EraseRootFromParent_Done,
     /*  68902 */ // Label 745: @68902
     /*  68902 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(68931), // Rule ID 7116 //
     /*  68907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68918 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  68918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68930 */   // GIR_Coverage, 7116,
     /*  68930 */   GIR_EraseRootFromParent_Done,
     /*  68931 */ // Label 746: @68931
     /*  68931 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(68960), // Rule ID 7117 //
     /*  68936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68947 */   // (bitconvert:{ *:[v4f32] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v4f32] }:$src0
     /*  68947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68950 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68952 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  68959 */   // GIR_Coverage, 7117,
     /*  68959 */   GIR_EraseRootFromParent_Done,
     /*  68960 */ // Label 747: @68960
     /*  68960 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(68989), // Rule ID 7118 //
     /*  68965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68976 */   // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
     /*  68976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68979 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  68981 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  68983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  68988 */   // GIR_Coverage, 7118,
     /*  68988 */   GIR_EraseRootFromParent_Done,
     /*  68989 */ // Label 748: @68989
     /*  68989 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(69018), // Rule ID 7119 //
     /*  68994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  68997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69005 */   // (bitconvert:{ *:[v4f32] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v4f32] }:$src0
     /*  69005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69008 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  69017 */   // GIR_Coverage, 7119,
     /*  69017 */   GIR_EraseRootFromParent_Done,
     /*  69018 */ // Label 749: @69018
     /*  69018 */ GIM_Reject,
     /*  69019 */ // Label 619: @69019
     /*  69019 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(69048), // Rule ID 7212 //
     /*  69024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69035 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  69035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69047 */   // GIR_Coverage, 7212,
     /*  69047 */   GIR_EraseRootFromParent_Done,
     /*  69048 */ // Label 750: @69048
     /*  69048 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(69077), // Rule ID 7213 //
     /*  69053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69064 */   // (bitconvert:{ *:[v4i64] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v4i64] }:$src0
     /*  69064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69076 */   // GIR_Coverage, 7213,
     /*  69076 */   GIR_EraseRootFromParent_Done,
     /*  69077 */ // Label 751: @69077
     /*  69077 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(69106), // Rule ID 7214 //
     /*  69082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69093 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  69093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69096 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69105 */   // GIR_Coverage, 7214,
     /*  69105 */   GIR_EraseRootFromParent_Done,
     /*  69106 */ // Label 752: @69106
     /*  69106 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(69135), // Rule ID 7215 //
     /*  69111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69122 */   // (bitconvert:{ *:[v4i64] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v4i64] }:$src0
     /*  69122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69134 */   // GIR_Coverage, 7215,
     /*  69134 */   GIR_EraseRootFromParent_Done,
     /*  69135 */ // Label 753: @69135
     /*  69135 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(69164), // Rule ID 7216 //
     /*  69140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69151 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  69151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69163 */   // GIR_Coverage, 7216,
     /*  69163 */   GIR_EraseRootFromParent_Done,
     /*  69164 */ // Label 754: @69164
     /*  69164 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(69193), // Rule ID 7217 //
     /*  69169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69180 */   // (bitconvert:{ *:[v4i64] } SReg_256:{ *:[v4f64] }:$src0)  =>  SReg_256:{ *:[v4i64] }:$src0
     /*  69180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69192 */   // GIR_Coverage, 7217,
     /*  69192 */   GIR_EraseRootFromParent_Done,
     /*  69193 */ // Label 755: @69193
     /*  69193 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(69222), // Rule ID 7218 //
     /*  69198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69209 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  69209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69212 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69221 */   // GIR_Coverage, 7218,
     /*  69221 */   GIR_EraseRootFromParent_Done,
     /*  69222 */ // Label 756: @69222
     /*  69222 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(69251), // Rule ID 7219 //
     /*  69227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69238 */   // (bitconvert:{ *:[v4i64] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v4i64] }:$src0
     /*  69238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69250 */   // GIR_Coverage, 7219,
     /*  69250 */   GIR_EraseRootFromParent_Done,
     /*  69251 */ // Label 757: @69251
     /*  69251 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(69280), // Rule ID 7220 //
     /*  69256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69267 */   // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
     /*  69267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69270 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69272 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69279 */   // GIR_Coverage, 7220,
     /*  69279 */   GIR_EraseRootFromParent_Done,
     /*  69280 */ // Label 758: @69280
     /*  69280 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(69309), // Rule ID 7221 //
     /*  69285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69296 */   // (bitconvert:{ *:[v4i64] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v4i64] }:$src0
     /*  69296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69308 */   // GIR_Coverage, 7221,
     /*  69308 */   GIR_EraseRootFromParent_Done,
     /*  69309 */ // Label 759: @69309
     /*  69309 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(69338), // Rule ID 7222 //
     /*  69314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69325 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  69325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69337 */   // GIR_Coverage, 7222,
     /*  69337 */   GIR_EraseRootFromParent_Done,
     /*  69338 */ // Label 760: @69338
     /*  69338 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(69367), // Rule ID 7223 //
     /*  69343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69354 */   // (bitconvert:{ *:[v4f64] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v4f64] }:$src0
     /*  69354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69357 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69359 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69366 */   // GIR_Coverage, 7223,
     /*  69366 */   GIR_EraseRootFromParent_Done,
     /*  69367 */ // Label 761: @69367
     /*  69367 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(69396), // Rule ID 7224 //
     /*  69372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69383 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  69383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69386 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69388 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69395 */   // GIR_Coverage, 7224,
     /*  69395 */   GIR_EraseRootFromParent_Done,
     /*  69396 */ // Label 762: @69396
     /*  69396 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(69425), // Rule ID 7225 //
     /*  69401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  69404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69412 */   // (bitconvert:{ *:[v4f64] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v4f64] }:$src0
     /*  69412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69424 */   // GIR_Coverage, 7225,
     /*  69424 */   GIR_EraseRootFromParent_Done,
     /*  69425 */ // Label 763: @69425
     /*  69425 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(69454), // Rule ID 7226 //
     /*  69430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69441 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  69441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69444 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69453 */   // GIR_Coverage, 7226,
     /*  69453 */   GIR_EraseRootFromParent_Done,
     /*  69454 */ // Label 764: @69454
     /*  69454 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(69483), // Rule ID 7227 //
     /*  69459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  69462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69470 */   // (bitconvert:{ *:[v4f64] } SReg_256:{ *:[v4i64] }:$src0)  =>  SReg_256:{ *:[v4f64] }:$src0
     /*  69470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69473 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69477 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69482 */   // GIR_Coverage, 7227,
     /*  69482 */   GIR_EraseRootFromParent_Done,
     /*  69483 */ // Label 765: @69483
     /*  69483 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(69512), // Rule ID 7228 //
     /*  69488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69499 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  69499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69511 */   // GIR_Coverage, 7228,
     /*  69511 */   GIR_EraseRootFromParent_Done,
     /*  69512 */ // Label 766: @69512
     /*  69512 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(69541), // Rule ID 7229 //
     /*  69517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69528 */   // (bitconvert:{ *:[v4f64] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v4f64] }:$src0
     /*  69528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69531 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69533 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69540 */   // GIR_Coverage, 7229,
     /*  69540 */   GIR_EraseRootFromParent_Done,
     /*  69541 */ // Label 767: @69541
     /*  69541 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(69570), // Rule ID 7230 //
     /*  69546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69557 */   // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
     /*  69557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69560 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69562 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  69569 */   // GIR_Coverage, 7230,
     /*  69569 */   GIR_EraseRootFromParent_Done,
     /*  69570 */ // Label 768: @69570
     /*  69570 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(69599), // Rule ID 7231 //
     /*  69575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  69578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69586 */   // (bitconvert:{ *:[v4f64] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v4f64] }:$src0
     /*  69586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69589 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69591 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69593 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  69598 */   // GIR_Coverage, 7231,
     /*  69598 */   GIR_EraseRootFromParent_Done,
     /*  69599 */ // Label 769: @69599
     /*  69599 */ GIM_Reject,
     /*  69600 */ // Label 620: @69600
     /*  69600 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(69713),
     /*  69605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v5s32,
     /*  69608 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(69634), // Rule ID 7160 //
     /*  69613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  69617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  69621 */     // (bitconvert:{ *:[v5i32] } VReg_160:{ *:[v5f32] }:$src0)  =>  VReg_160:{ *:[v5i32] }:$src0
     /*  69621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69624 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  69633 */     // GIR_Coverage, 7160,
     /*  69633 */     GIR_EraseRootFromParent_Done,
     /*  69634 */   // Label 771: @69634
     /*  69634 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(69660), // Rule ID 7161 //
     /*  69639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  69643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  69647 */     // (bitconvert:{ *:[v5i32] } SReg_160:{ *:[v5f32] }:$src0)  =>  SReg_160:{ *:[v5i32] }:$src0
     /*  69647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69650 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69652 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  69659 */     // GIR_Coverage, 7161,
     /*  69659 */     GIR_EraseRootFromParent_Done,
     /*  69660 */   // Label 772: @69660
     /*  69660 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(69686), // Rule ID 7162 //
     /*  69665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  69669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  69673 */     // (bitconvert:{ *:[v5f32] } VReg_160:{ *:[v5i32] }:$src0)  =>  VReg_160:{ *:[v5f32] }:$src0
     /*  69673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69676 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
     /*  69685 */     // GIR_Coverage, 7162,
     /*  69685 */     GIR_EraseRootFromParent_Done,
     /*  69686 */   // Label 773: @69686
     /*  69686 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(69712), // Rule ID 7163 //
     /*  69691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  69695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  69699 */     // (bitconvert:{ *:[v5f32] } SReg_160:{ *:[v5i32] }:$src0)  =>  SReg_160:{ *:[v5f32] }:$src0
     /*  69699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69702 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
     /*  69711 */     // GIR_Coverage, 7163,
     /*  69711 */     GIR_EraseRootFromParent_Done,
     /*  69712 */   // Label 774: @69712
     /*  69712 */   GIM_Reject,
     /*  69713 */ // Label 770: @69713
     /*  69713 */ GIM_Reject,
     /*  69714 */ // Label 621: @69714
     /*  69714 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(69743), // Rule ID 7164 //
     /*  69719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  69722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69730 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  69730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69742 */   // GIR_Coverage, 7164,
     /*  69742 */   GIR_EraseRootFromParent_Done,
     /*  69743 */ // Label 775: @69743
     /*  69743 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(69772), // Rule ID 7165 //
     /*  69748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  69751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69759 */   // (bitconvert:{ *:[v6i32] } SReg_192:{ *:[v6f32] }:$src0)  =>  SReg_192:{ *:[v6i32] }:$src0
     /*  69759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69762 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69764 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69771 */   // GIR_Coverage, 7165,
     /*  69771 */   GIR_EraseRootFromParent_Done,
     /*  69772 */ // Label 776: @69772
     /*  69772 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(69801), // Rule ID 7166 //
     /*  69777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  69780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69788 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  69788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69791 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69793 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69800 */   // GIR_Coverage, 7166,
     /*  69800 */   GIR_EraseRootFromParent_Done,
     /*  69801 */ // Label 777: @69801
     /*  69801 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(69830), // Rule ID 7167 //
     /*  69806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  69809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69817 */   // (bitconvert:{ *:[v6i32] } SReg_192:{ *:[v3i64] }:$src0)  =>  SReg_192:{ *:[v6i32] }:$src0
     /*  69817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69829 */   // GIR_Coverage, 7167,
     /*  69829 */   GIR_EraseRootFromParent_Done,
     /*  69830 */ // Label 778: @69830
     /*  69830 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(69859), // Rule ID 7168 //
     /*  69835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  69838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69846 */   // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
     /*  69846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69858 */   // GIR_Coverage, 7168,
     /*  69858 */   GIR_EraseRootFromParent_Done,
     /*  69859 */ // Label 779: @69859
     /*  69859 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(69888), // Rule ID 7169 //
     /*  69864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  69867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69875 */   // (bitconvert:{ *:[v6i32] } SReg_192:{ *:[v3f64] }:$src0)  =>  SReg_192:{ *:[v6i32] }:$src0
     /*  69875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69878 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69887 */   // GIR_Coverage, 7169,
     /*  69887 */   GIR_EraseRootFromParent_Done,
     /*  69888 */ // Label 780: @69888
     /*  69888 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(69917), // Rule ID 7170 //
     /*  69893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  69896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69904 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  69904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69916 */   // GIR_Coverage, 7170,
     /*  69916 */   GIR_EraseRootFromParent_Done,
     /*  69917 */ // Label 781: @69917
     /*  69917 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(69946), // Rule ID 7171 //
     /*  69922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
     /*  69925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69933 */   // (bitconvert:{ *:[v6f32] } SReg_192:{ *:[v6i32] }:$src0)  =>  SReg_192:{ *:[v6f32] }:$src0
     /*  69933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69936 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69938 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69945 */   // GIR_Coverage, 7171,
     /*  69945 */   GIR_EraseRootFromParent_Done,
     /*  69946 */ // Label 782: @69946
     /*  69946 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(69975), // Rule ID 7172 //
     /*  69951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  69954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69962 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  69962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69965 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  69974 */   // GIR_Coverage, 7172,
     /*  69974 */   GIR_EraseRootFromParent_Done,
     /*  69975 */ // Label 783: @69975
     /*  69975 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(70004), // Rule ID 7173 //
     /*  69980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  69983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  69991 */   // (bitconvert:{ *:[v6f32] } SReg_192:{ *:[v3i64] }:$src0)  =>  SReg_192:{ *:[v6f32] }:$src0
     /*  69991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69994 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  69996 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  69998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  70003 */   // GIR_Coverage, 7173,
     /*  70003 */   GIR_EraseRootFromParent_Done,
     /*  70004 */ // Label 784: @70004
     /*  70004 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(70033), // Rule ID 7174 //
     /*  70009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  70012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  70016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  70020 */   // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
     /*  70020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /*  70032 */   // GIR_Coverage, 7174,
     /*  70032 */   GIR_EraseRootFromParent_Done,
     /*  70033 */ // Label 785: @70033
     /*  70033 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(70062), // Rule ID 7175 //
     /*  70038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
     /*  70041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  70045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  70049 */   // (bitconvert:{ *:[v6f32] } SReg_192:{ *:[v3f64] }:$src0)  =>  SReg_192:{ *:[v6f32] }:$src0
     /*  70049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70052 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
     /*  70061 */   // GIR_Coverage, 7175,
     /*  70061 */   GIR_EraseRootFromParent_Done,
     /*  70062 */ // Label 786: @70062
     /*  70062 */ GIM_Reject,
     /*  70063 */ // Label 622: @70063
     /*  70063 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(70176),
     /*  70068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v7s32,
     /*  70071 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(70097), // Rule ID 7188 //
     /*  70076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  70080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  70084 */     // (bitconvert:{ *:[v7i32] } VReg_224:{ *:[v7f32] }:$src0)  =>  VReg_224:{ *:[v7i32] }:$src0
     /*  70084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70087 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  70096 */     // GIR_Coverage, 7188,
     /*  70096 */     GIR_EraseRootFromParent_Done,
     /*  70097 */   // Label 788: @70097
     /*  70097 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(70123), // Rule ID 7189 //
     /*  70102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  70106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  70110 */     // (bitconvert:{ *:[v7i32] } SReg_224:{ *:[v7f32] }:$src0)  =>  SReg_224:{ *:[v7i32] }:$src0
     /*  70110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70113 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  70122 */     // GIR_Coverage, 7189,
     /*  70122 */     GIR_EraseRootFromParent_Done,
     /*  70123 */   // Label 789: @70123
     /*  70123 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(70149), // Rule ID 7190 //
     /*  70128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  70132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  70136 */     // (bitconvert:{ *:[v7f32] } VReg_224:{ *:[v7i32] }:$src0)  =>  VReg_224:{ *:[v7f32] }:$src0
     /*  70136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70139 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70141 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
     /*  70148 */     // GIR_Coverage, 7190,
     /*  70148 */     GIR_EraseRootFromParent_Done,
     /*  70149 */   // Label 790: @70149
     /*  70149 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(70175), // Rule ID 7191 //
     /*  70154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  70158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  70162 */     // (bitconvert:{ *:[v7f32] } SReg_224:{ *:[v7i32] }:$src0)  =>  SReg_224:{ *:[v7f32] }:$src0
     /*  70162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70165 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70167 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
     /*  70174 */     // GIR_Coverage, 7191,
     /*  70174 */     GIR_EraseRootFromParent_Done,
     /*  70175 */   // Label 791: @70175
     /*  70175 */   GIM_Reject,
     /*  70176 */ // Label 787: @70176
     /*  70176 */ GIM_Reject,
     /*  70177 */ // Label 623: @70177
     /*  70177 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(70206), // Rule ID 7140 //
     /*  70182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70193 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  70193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70205 */   // GIR_Coverage, 7140,
     /*  70205 */   GIR_EraseRootFromParent_Done,
     /*  70206 */ // Label 792: @70206
     /*  70206 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(70235), // Rule ID 7141 //
     /*  70211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70222 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  70222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70225 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70227 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70229 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70234 */   // GIR_Coverage, 7141,
     /*  70234 */   GIR_EraseRootFromParent_Done,
     /*  70235 */ // Label 793: @70235
     /*  70235 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(70264), // Rule ID 7142 //
     /*  70240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70251 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  70251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70254 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70263 */   // GIR_Coverage, 7142,
     /*  70263 */   GIR_EraseRootFromParent_Done,
     /*  70264 */ // Label 794: @70264
     /*  70264 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(70293), // Rule ID 7143 //
     /*  70269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70280 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v4f32] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  70280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70283 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70292 */   // GIR_Coverage, 7143,
     /*  70292 */   GIR_EraseRootFromParent_Done,
     /*  70293 */ // Label 795: @70293
     /*  70293 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(70322), // Rule ID 7144 //
     /*  70298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70309 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  70309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70312 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70314 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70321 */   // GIR_Coverage, 7144,
     /*  70321 */   GIR_EraseRootFromParent_Done,
     /*  70322 */ // Label 796: @70322
     /*  70322 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(70351), // Rule ID 7145 //
     /*  70327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70338 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  70338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70341 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70345 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70350 */   // GIR_Coverage, 7145,
     /*  70350 */   GIR_EraseRootFromParent_Done,
     /*  70351 */ // Label 797: @70351
     /*  70351 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(70380), // Rule ID 7146 //
     /*  70356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70367 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  70367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70370 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70372 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70379 */   // GIR_Coverage, 7146,
     /*  70379 */   GIR_EraseRootFromParent_Done,
     /*  70380 */ // Label 798: @70380
     /*  70380 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(70409), // Rule ID 7147 //
     /*  70385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70396 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  70396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70399 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70408 */   // GIR_Coverage, 7147,
     /*  70408 */   GIR_EraseRootFromParent_Done,
     /*  70409 */ // Label 799: @70409
     /*  70409 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(70438), // Rule ID 7148 //
     /*  70414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70425 */   // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
     /*  70425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70428 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70430 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70437 */   // GIR_Coverage, 7148,
     /*  70437 */   GIR_EraseRootFromParent_Done,
     /*  70438 */ // Label 800: @70438
     /*  70438 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(70467), // Rule ID 7149 //
     /*  70443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70454 */   // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
     /*  70454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70457 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70466 */   // GIR_Coverage, 7149,
     /*  70466 */   GIR_EraseRootFromParent_Done,
     /*  70467 */ // Label 801: @70467
     /*  70467 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(70496), // Rule ID 7150 //
     /*  70472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70483 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  70483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70495 */   // GIR_Coverage, 7150,
     /*  70495 */   GIR_EraseRootFromParent_Done,
     /*  70496 */ // Label 802: @70496
     /*  70496 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(70525), // Rule ID 7151 //
     /*  70501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70512 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  70512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70515 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70524 */   // GIR_Coverage, 7151,
     /*  70524 */   GIR_EraseRootFromParent_Done,
     /*  70525 */ // Label 803: @70525
     /*  70525 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(70554), // Rule ID 7152 //
     /*  70530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70541 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  70541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70553 */   // GIR_Coverage, 7152,
     /*  70553 */   GIR_EraseRootFromParent_Done,
     /*  70554 */ // Label 804: @70554
     /*  70554 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(70583), // Rule ID 7153 //
     /*  70559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70570 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v4f32] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  70570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70573 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70575 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70582 */   // GIR_Coverage, 7153,
     /*  70582 */   GIR_EraseRootFromParent_Done,
     /*  70583 */ // Label 805: @70583
     /*  70583 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(70612), // Rule ID 7154 //
     /*  70588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70599 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  70599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70602 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70604 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70606 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70611 */   // GIR_Coverage, 7154,
     /*  70611 */   GIR_EraseRootFromParent_Done,
     /*  70612 */ // Label 806: @70612
     /*  70612 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(70641), // Rule ID 7155 //
     /*  70617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70628 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  70628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70631 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70633 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70640 */   // GIR_Coverage, 7155,
     /*  70640 */   GIR_EraseRootFromParent_Done,
     /*  70641 */ // Label 807: @70641
     /*  70641 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(70670), // Rule ID 7156 //
     /*  70646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70657 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  70657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70669 */   // GIR_Coverage, 7156,
     /*  70669 */   GIR_EraseRootFromParent_Done,
     /*  70670 */ // Label 808: @70670
     /*  70670 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(70699), // Rule ID 7157 //
     /*  70675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  70678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70686 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  70686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70689 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70698 */   // GIR_Coverage, 7157,
     /*  70698 */   GIR_EraseRootFromParent_Done,
     /*  70699 */ // Label 809: @70699
     /*  70699 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(70728), // Rule ID 7158 //
     /*  70704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70715 */   // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
     /*  70715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70718 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /*  70727 */   // GIR_Coverage, 7158,
     /*  70727 */   GIR_EraseRootFromParent_Done,
     /*  70728 */ // Label 810: @70728
     /*  70728 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(70757), // Rule ID 7159 //
     /*  70733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70744 */   // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
     /*  70744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70747 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /*  70756 */   // GIR_Coverage, 7159,
     /*  70756 */   GIR_EraseRootFromParent_Done,
     /*  70757 */ // Label 811: @70757
     /*  70757 */ GIM_Reject,
     /*  70758 */ // Label 624: @70758
     /*  70758 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(70787), // Rule ID 7192 //
     /*  70763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70774 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  70774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70786 */   // GIR_Coverage, 7192,
     /*  70786 */   GIR_EraseRootFromParent_Done,
     /*  70787 */ // Label 812: @70787
     /*  70787 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(70816), // Rule ID 7193 //
     /*  70792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  70795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70803 */   // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
     /*  70803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70815 */   // GIR_Coverage, 7193,
     /*  70815 */   GIR_EraseRootFromParent_Done,
     /*  70816 */ // Label 813: @70816
     /*  70816 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(70845), // Rule ID 7194 //
     /*  70821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70832 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  70832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70844 */   // GIR_Coverage, 7194,
     /*  70844 */   GIR_EraseRootFromParent_Done,
     /*  70845 */ // Label 814: @70845
     /*  70845 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(70874), // Rule ID 7195 //
     /*  70850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70861 */   // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v4i64] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
     /*  70861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70864 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70866 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70868 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70873 */   // GIR_Coverage, 7195,
     /*  70873 */   GIR_EraseRootFromParent_Done,
     /*  70874 */ // Label 815: @70874
     /*  70874 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(70903), // Rule ID 7196 //
     /*  70879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70890 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  70890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70893 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70895 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70902 */   // GIR_Coverage, 7196,
     /*  70902 */   GIR_EraseRootFromParent_Done,
     /*  70903 */ // Label 816: @70903
     /*  70903 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(70932), // Rule ID 7197 //
     /*  70908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  70911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70919 */   // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v4f64] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
     /*  70919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70922 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70924 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70931 */   // GIR_Coverage, 7197,
     /*  70931 */   GIR_EraseRootFromParent_Done,
     /*  70932 */ // Label 817: @70932
     /*  70932 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(70961), // Rule ID 7198 //
     /*  70937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70948 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  70948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  70960 */   // GIR_Coverage, 7198,
     /*  70960 */   GIR_EraseRootFromParent_Done,
     /*  70961 */ // Label 818: @70961
     /*  70961 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(70990), // Rule ID 7199 //
     /*  70966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70977 */   // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
     /*  70977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70980 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  70982 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  70984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  70989 */   // GIR_Coverage, 7199,
     /*  70989 */   GIR_EraseRootFromParent_Done,
     /*  70990 */ // Label 819: @70990
     /*  70990 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(71019), // Rule ID 7200 //
     /*  70995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  70998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71006 */   // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
     /*  71006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71009 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71011 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71018 */   // GIR_Coverage, 7200,
     /*  71018 */   GIR_EraseRootFromParent_Done,
     /*  71019 */ // Label 820: @71019
     /*  71019 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(71048), // Rule ID 7201 //
     /*  71024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  71027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71035 */   // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
     /*  71035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71047 */   // GIR_Coverage, 7201,
     /*  71047 */   GIR_EraseRootFromParent_Done,
     /*  71048 */ // Label 821: @71048
     /*  71048 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(71077), // Rule ID 7202 //
     /*  71053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  71056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71064 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  71064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71076 */   // GIR_Coverage, 7202,
     /*  71076 */   GIR_EraseRootFromParent_Done,
     /*  71077 */ // Label 822: @71077
     /*  71077 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(71106), // Rule ID 7203 //
     /*  71082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  71085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71093 */   // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
     /*  71093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71096 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71105 */   // GIR_Coverage, 7203,
     /*  71105 */   GIR_EraseRootFromParent_Done,
     /*  71106 */ // Label 823: @71106
     /*  71106 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(71135), // Rule ID 7204 //
     /*  71111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  71114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71122 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  71122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71134 */   // GIR_Coverage, 7204,
     /*  71134 */   GIR_EraseRootFromParent_Done,
     /*  71135 */ // Label 824: @71135
     /*  71135 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(71164), // Rule ID 7205 //
     /*  71140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  71143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71151 */   // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v4i64] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
     /*  71151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71163 */   // GIR_Coverage, 7205,
     /*  71163 */   GIR_EraseRootFromParent_Done,
     /*  71164 */ // Label 825: @71164
     /*  71164 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(71193), // Rule ID 7206 //
     /*  71169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  71172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71180 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  71180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71192 */   // GIR_Coverage, 7206,
     /*  71192 */   GIR_EraseRootFromParent_Done,
     /*  71193 */ // Label 826: @71193
     /*  71193 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(71222), // Rule ID 7207 //
     /*  71198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  71201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71209 */   // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v4f64] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
     /*  71209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71212 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71221 */   // GIR_Coverage, 7207,
     /*  71221 */   GIR_EraseRootFromParent_Done,
     /*  71222 */ // Label 827: @71222
     /*  71222 */ GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(71251), // Rule ID 7208 //
     /*  71227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  71230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71238 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  71238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71250 */   // GIR_Coverage, 7208,
     /*  71250 */   GIR_EraseRootFromParent_Done,
     /*  71251 */ // Label 828: @71251
     /*  71251 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(71280), // Rule ID 7209 //
     /*  71256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  71259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71267 */   // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
     /*  71267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71270 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71272 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71279 */   // GIR_Coverage, 7209,
     /*  71279 */   GIR_EraseRootFromParent_Done,
     /*  71280 */ // Label 829: @71280
     /*  71280 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(71309), // Rule ID 7210 //
     /*  71285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  71288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71296 */   // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
     /*  71296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71299 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71301 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  71308 */   // GIR_Coverage, 7210,
     /*  71308 */   GIR_EraseRootFromParent_Done,
     /*  71309 */ // Label 830: @71309
     /*  71309 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(71338), // Rule ID 7211 //
     /*  71314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  71317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71325 */   // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
     /*  71325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  71337 */   // GIR_Coverage, 7211,
     /*  71337 */   GIR_EraseRootFromParent_Done,
     /*  71338 */ // Label 831: @71338
     /*  71338 */ GIM_Reject,
     /*  71339 */ // Label 625: @71339
     /*  71339 */ GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(71368), // Rule ID 7288 //
     /*  71344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71355 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  71355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71367 */   // GIR_Coverage, 7288,
     /*  71367 */   GIR_EraseRootFromParent_Done,
     /*  71368 */ // Label 832: @71368
     /*  71368 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(71397), // Rule ID 7289 //
     /*  71373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71384 */   // (bitconvert:{ *:[v8i64] } SReg_512:{ *:[v16i32] }:$src0)  =>  SReg_512:{ *:[v8i64] }:$src0
     /*  71384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71387 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71389 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71396 */   // GIR_Coverage, 7289,
     /*  71396 */   GIR_EraseRootFromParent_Done,
     /*  71397 */ // Label 833: @71397
     /*  71397 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(71426), // Rule ID 7290 //
     /*  71402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71413 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  71413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71416 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71425 */   // GIR_Coverage, 7290,
     /*  71425 */   GIR_EraseRootFromParent_Done,
     /*  71426 */ // Label 834: @71426
     /*  71426 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(71455), // Rule ID 7291 //
     /*  71431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71442 */   // (bitconvert:{ *:[v8i64] } SReg_512:{ *:[v16f32] }:$src0)  =>  SReg_512:{ *:[v8i64] }:$src0
     /*  71442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71445 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71447 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71454 */   // GIR_Coverage, 7291,
     /*  71454 */   GIR_EraseRootFromParent_Done,
     /*  71455 */ // Label 835: @71455
     /*  71455 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(71484), // Rule ID 7292 //
     /*  71460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71471 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  71471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71474 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71476 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71483 */   // GIR_Coverage, 7292,
     /*  71483 */   GIR_EraseRootFromParent_Done,
     /*  71484 */ // Label 836: @71484
     /*  71484 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(71513), // Rule ID 7293 //
     /*  71489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71500 */   // (bitconvert:{ *:[v8i64] } SReg_512:{ *:[v8f64] }:$src0)  =>  SReg_512:{ *:[v8i64] }:$src0
     /*  71500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71503 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71505 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71512 */   // GIR_Coverage, 7293,
     /*  71512 */   GIR_EraseRootFromParent_Done,
     /*  71513 */ // Label 837: @71513
     /*  71513 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(71542), // Rule ID 7294 //
     /*  71518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71529 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  71529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71532 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71534 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71541 */   // GIR_Coverage, 7294,
     /*  71541 */   GIR_EraseRootFromParent_Done,
     /*  71542 */ // Label 838: @71542
     /*  71542 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(71571), // Rule ID 7295 //
     /*  71547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71558 */   // (bitconvert:{ *:[v8i64] } SReg_512:{ *:[v32i16] }:$src0)  =>  SReg_512:{ *:[v8i64] }:$src0
     /*  71558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71570 */   // GIR_Coverage, 7295,
     /*  71570 */   GIR_EraseRootFromParent_Done,
     /*  71571 */ // Label 839: @71571
     /*  71571 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(71600), // Rule ID 7296 //
     /*  71576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71587 */   // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
     /*  71587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71590 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71592 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71599 */   // GIR_Coverage, 7296,
     /*  71599 */   GIR_EraseRootFromParent_Done,
     /*  71600 */ // Label 840: @71600
     /*  71600 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(71629), // Rule ID 7297 //
     /*  71605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71616 */   // (bitconvert:{ *:[v8i64] } SReg_512:{ *:[v32f16] }:$src0)  =>  SReg_512:{ *:[v8i64] }:$src0
     /*  71616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71619 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71628 */   // GIR_Coverage, 7297,
     /*  71628 */   GIR_EraseRootFromParent_Done,
     /*  71629 */ // Label 841: @71629
     /*  71629 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(71658), // Rule ID 7298 //
     /*  71634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71645 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  71645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71648 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71650 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71657 */   // GIR_Coverage, 7298,
     /*  71657 */   GIR_EraseRootFromParent_Done,
     /*  71658 */ // Label 842: @71658
     /*  71658 */ GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(71687), // Rule ID 7299 //
     /*  71663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71674 */   // (bitconvert:{ *:[v8f64] } SReg_512:{ *:[v16i32] }:$src0)  =>  SReg_512:{ *:[v8f64] }:$src0
     /*  71674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71677 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71679 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71686 */   // GIR_Coverage, 7299,
     /*  71686 */   GIR_EraseRootFromParent_Done,
     /*  71687 */ // Label 843: @71687
     /*  71687 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(71716), // Rule ID 7300 //
     /*  71692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71703 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  71703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71706 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71708 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71715 */   // GIR_Coverage, 7300,
     /*  71715 */   GIR_EraseRootFromParent_Done,
     /*  71716 */ // Label 844: @71716
     /*  71716 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(71745), // Rule ID 7301 //
     /*  71721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  71724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71732 */   // (bitconvert:{ *:[v8f64] } SReg_512:{ *:[v16f32] }:$src0)  =>  SReg_512:{ *:[v8f64] }:$src0
     /*  71732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71735 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71737 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71744 */   // GIR_Coverage, 7301,
     /*  71744 */   GIR_EraseRootFromParent_Done,
     /*  71745 */ // Label 845: @71745
     /*  71745 */ GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(71774), // Rule ID 7302 //
     /*  71750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71761 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  71761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71773 */   // GIR_Coverage, 7302,
     /*  71773 */   GIR_EraseRootFromParent_Done,
     /*  71774 */ // Label 846: @71774
     /*  71774 */ GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(71803), // Rule ID 7303 //
     /*  71779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  71782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71790 */   // (bitconvert:{ *:[v8f64] } SReg_512:{ *:[v8i64] }:$src0)  =>  SReg_512:{ *:[v8f64] }:$src0
     /*  71790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71802 */   // GIR_Coverage, 7303,
     /*  71802 */   GIR_EraseRootFromParent_Done,
     /*  71803 */ // Label 847: @71803
     /*  71803 */ GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(71832), // Rule ID 7304 //
     /*  71808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71819 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  71819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71822 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71824 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71826 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71831 */   // GIR_Coverage, 7304,
     /*  71831 */   GIR_EraseRootFromParent_Done,
     /*  71832 */ // Label 848: @71832
     /*  71832 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(71861), // Rule ID 7305 //
     /*  71837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71848 */   // (bitconvert:{ *:[v8f64] } SReg_512:{ *:[v32i16] }:$src0)  =>  SReg_512:{ *:[v8f64] }:$src0
     /*  71848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71851 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71860 */   // GIR_Coverage, 7305,
     /*  71860 */   GIR_EraseRootFromParent_Done,
     /*  71861 */ // Label 849: @71861
     /*  71861 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(71890), // Rule ID 7306 //
     /*  71866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71877 */   // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
     /*  71877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71880 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71882 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71884 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  71889 */   // GIR_Coverage, 7306,
     /*  71889 */   GIR_EraseRootFromParent_Done,
     /*  71890 */ // Label 850: @71890
     /*  71890 */ GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(71919), // Rule ID 7307 //
     /*  71895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  71898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71906 */   // (bitconvert:{ *:[v8f64] } SReg_512:{ *:[v32f16] }:$src0)  =>  SReg_512:{ *:[v8f64] }:$src0
     /*  71906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71909 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71911 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  71918 */   // GIR_Coverage, 7307,
     /*  71918 */   GIR_EraseRootFromParent_Done,
     /*  71919 */ // Label 851: @71919
     /*  71919 */ GIM_Reject,
     /*  71920 */ // Label 626: @71920
     /*  71920 */ GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(72033),
     /*  71925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v9s32,
     /*  71928 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(71954), // Rule ID 7252 //
     /*  71933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  71937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  71941 */     // (bitconvert:{ *:[v9i32] } VReg_288:{ *:[v9f32] }:$src0)  =>  VReg_288:{ *:[v9i32] }:$src0
     /*  71941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71944 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  71953 */     // GIR_Coverage, 7252,
     /*  71953 */     GIR_EraseRootFromParent_Done,
     /*  71954 */   // Label 853: @71954
     /*  71954 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(71980), // Rule ID 7253 //
     /*  71959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  71963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  71967 */     // (bitconvert:{ *:[v9i32] } SReg_288:{ *:[v9f32] }:$src0)  =>  SReg_288:{ *:[v9i32] }:$src0
     /*  71967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71970 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71972 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  71974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  71979 */     // GIR_Coverage, 7253,
     /*  71979 */     GIR_EraseRootFromParent_Done,
     /*  71980 */   // Label 854: @71980
     /*  71980 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(72006), // Rule ID 7254 //
     /*  71985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  71989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  71993 */     // (bitconvert:{ *:[v9f32] } VReg_288:{ *:[v9i32] }:$src0)  =>  VReg_288:{ *:[v9f32] }:$src0
     /*  71993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  71996 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  71998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
     /*  72005 */     // GIR_Coverage, 7254,
     /*  72005 */     GIR_EraseRootFromParent_Done,
     /*  72006 */   // Label 855: @72006
     /*  72006 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(72032), // Rule ID 7255 //
     /*  72011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  72015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  72019 */     // (bitconvert:{ *:[v9f32] } SReg_288:{ *:[v9i32] }:$src0)  =>  SReg_288:{ *:[v9f32] }:$src0
     /*  72019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72022 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
     /*  72031 */     // GIR_Coverage, 7255,
     /*  72031 */     GIR_EraseRootFromParent_Done,
     /*  72032 */   // Label 856: @72032
     /*  72032 */   GIM_Reject,
     /*  72033 */ // Label 852: @72033
     /*  72033 */ GIM_Reject,
     /*  72034 */ // Label 627: @72034
     /*  72034 */ GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(72147),
     /*  72039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v10s32,
     /*  72042 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(72068), // Rule ID 7256 //
     /*  72047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  72051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  72055 */     // (bitconvert:{ *:[v10i32] } VReg_320:{ *:[v10f32] }:$src0)  =>  VReg_320:{ *:[v10i32] }:$src0
     /*  72055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72058 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72060 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  72067 */     // GIR_Coverage, 7256,
     /*  72067 */     GIR_EraseRootFromParent_Done,
     /*  72068 */   // Label 858: @72068
     /*  72068 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(72094), // Rule ID 7257 //
     /*  72073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  72077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  72081 */     // (bitconvert:{ *:[v10i32] } SReg_320:{ *:[v10f32] }:$src0)  =>  SReg_320:{ *:[v10i32] }:$src0
     /*  72081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72084 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72086 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  72093 */     // GIR_Coverage, 7257,
     /*  72093 */     GIR_EraseRootFromParent_Done,
     /*  72094 */   // Label 859: @72094
     /*  72094 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(72120), // Rule ID 7258 //
     /*  72099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  72103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  72107 */     // (bitconvert:{ *:[v10f32] } VReg_320:{ *:[v10i32] }:$src0)  =>  VReg_320:{ *:[v10f32] }:$src0
     /*  72107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72110 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
     /*  72119 */     // GIR_Coverage, 7258,
     /*  72119 */     GIR_EraseRootFromParent_Done,
     /*  72120 */   // Label 860: @72120
     /*  72120 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(72146), // Rule ID 7259 //
     /*  72125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  72129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  72133 */     // (bitconvert:{ *:[v10f32] } SReg_320:{ *:[v10i32] }:$src0)  =>  SReg_320:{ *:[v10f32] }:$src0
     /*  72133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72136 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
     /*  72145 */     // GIR_Coverage, 7259,
     /*  72145 */     GIR_EraseRootFromParent_Done,
     /*  72146 */   // Label 861: @72146
     /*  72146 */   GIM_Reject,
     /*  72147 */ // Label 857: @72147
     /*  72147 */ GIM_Reject,
     /*  72148 */ // Label 628: @72148
     /*  72148 */ GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(72261),
     /*  72153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v11s32,
     /*  72156 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(72182), // Rule ID 7260 //
     /*  72161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  72165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  72169 */     // (bitconvert:{ *:[v11i32] } VReg_352:{ *:[v11f32] }:$src0)  =>  VReg_352:{ *:[v11i32] }:$src0
     /*  72169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72172 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72174 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  72181 */     // GIR_Coverage, 7260,
     /*  72181 */     GIR_EraseRootFromParent_Done,
     /*  72182 */   // Label 863: @72182
     /*  72182 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(72208), // Rule ID 7261 //
     /*  72187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  72191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  72195 */     // (bitconvert:{ *:[v11i32] } SReg_352:{ *:[v11f32] }:$src0)  =>  SReg_352:{ *:[v11i32] }:$src0
     /*  72195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72198 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72200 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  72207 */     // GIR_Coverage, 7261,
     /*  72207 */     GIR_EraseRootFromParent_Done,
     /*  72208 */   // Label 864: @72208
     /*  72208 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(72234), // Rule ID 7262 //
     /*  72213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  72217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  72221 */     // (bitconvert:{ *:[v11f32] } VReg_352:{ *:[v11i32] }:$src0)  =>  VReg_352:{ *:[v11f32] }:$src0
     /*  72221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72224 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
     /*  72233 */     // GIR_Coverage, 7262,
     /*  72233 */     GIR_EraseRootFromParent_Done,
     /*  72234 */   // Label 865: @72234
     /*  72234 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(72260), // Rule ID 7263 //
     /*  72239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  72243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  72247 */     // (bitconvert:{ *:[v11f32] } SReg_352:{ *:[v11i32] }:$src0)  =>  SReg_352:{ *:[v11f32] }:$src0
     /*  72247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72250 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
     /*  72259 */     // GIR_Coverage, 7263,
     /*  72259 */     GIR_EraseRootFromParent_Done,
     /*  72260 */   // Label 866: @72260
     /*  72260 */   GIM_Reject,
     /*  72261 */ // Label 862: @72261
     /*  72261 */ GIM_Reject,
     /*  72262 */ // Label 629: @72262
     /*  72262 */ GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(72375),
     /*  72267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v12s32,
     /*  72270 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(72296), // Rule ID 7264 //
     /*  72275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  72279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  72283 */     // (bitconvert:{ *:[v12i32] } VReg_384:{ *:[v12f32] }:$src0)  =>  VReg_384:{ *:[v12i32] }:$src0
     /*  72283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72286 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72288 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  72295 */     // GIR_Coverage, 7264,
     /*  72295 */     GIR_EraseRootFromParent_Done,
     /*  72296 */   // Label 868: @72296
     /*  72296 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(72322), // Rule ID 7265 //
     /*  72301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  72305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  72309 */     // (bitconvert:{ *:[v12i32] } SReg_384:{ *:[v12f32] }:$src0)  =>  SReg_384:{ *:[v12i32] }:$src0
     /*  72309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72312 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  72321 */     // GIR_Coverage, 7265,
     /*  72321 */     GIR_EraseRootFromParent_Done,
     /*  72322 */   // Label 869: @72322
     /*  72322 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(72348), // Rule ID 7266 //
     /*  72327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  72331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  72335 */     // (bitconvert:{ *:[v12f32] } VReg_384:{ *:[v12i32] }:$src0)  =>  VReg_384:{ *:[v12f32] }:$src0
     /*  72335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72338 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72340 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
     /*  72347 */     // GIR_Coverage, 7266,
     /*  72347 */     GIR_EraseRootFromParent_Done,
     /*  72348 */   // Label 870: @72348
     /*  72348 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(72374), // Rule ID 7267 //
     /*  72353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  72357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  72361 */     // (bitconvert:{ *:[v12f32] } SReg_384:{ *:[v12i32] }:$src0)  =>  SReg_384:{ *:[v12f32] }:$src0
     /*  72361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72364 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
     /*  72373 */     // GIR_Coverage, 7267,
     /*  72373 */     GIR_EraseRootFromParent_Done,
     /*  72374 */   // Label 871: @72374
     /*  72374 */   GIM_Reject,
     /*  72375 */ // Label 867: @72375
     /*  72375 */ GIM_Reject,
     /*  72376 */ // Label 630: @72376
     /*  72376 */ GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(72405), // Rule ID 7232 //
     /*  72381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72392 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  72392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72404 */   // GIR_Coverage, 7232,
     /*  72404 */   GIR_EraseRootFromParent_Done,
     /*  72405 */ // Label 872: @72405
     /*  72405 */ GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(72434), // Rule ID 7233 //
     /*  72410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72421 */   // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
     /*  72421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72433 */   // GIR_Coverage, 7233,
     /*  72433 */   GIR_EraseRootFromParent_Done,
     /*  72434 */ // Label 873: @72434
     /*  72434 */ GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(72463), // Rule ID 7234 //
     /*  72439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72450 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  72450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72453 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72455 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72462 */   // GIR_Coverage, 7234,
     /*  72462 */   GIR_EraseRootFromParent_Done,
     /*  72463 */ // Label 874: @72463
     /*  72463 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(72492), // Rule ID 7235 //
     /*  72468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72479 */   // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
     /*  72479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72482 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72484 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72491 */   // GIR_Coverage, 7235,
     /*  72491 */   GIR_EraseRootFromParent_Done,
     /*  72492 */ // Label 875: @72492
     /*  72492 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(72521), // Rule ID 7236 //
     /*  72497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72508 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  72508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72520 */   // GIR_Coverage, 7236,
     /*  72520 */   GIR_EraseRootFromParent_Done,
     /*  72521 */ // Label 876: @72521
     /*  72521 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(72550), // Rule ID 7237 //
     /*  72526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72537 */   // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v4i64] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
     /*  72537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72540 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72542 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72549 */   // GIR_Coverage, 7237,
     /*  72549 */   GIR_EraseRootFromParent_Done,
     /*  72550 */ // Label 877: @72550
     /*  72550 */ GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(72579), // Rule ID 7238 //
     /*  72555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72566 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  72566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72569 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72571 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72573 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72578 */   // GIR_Coverage, 7238,
     /*  72578 */   GIR_EraseRootFromParent_Done,
     /*  72579 */ // Label 878: @72579
     /*  72579 */ GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(72608), // Rule ID 7239 //
     /*  72584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72595 */   // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v4f64] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
     /*  72595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72598 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72600 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72607 */   // GIR_Coverage, 7239,
     /*  72607 */   GIR_EraseRootFromParent_Done,
     /*  72608 */ // Label 879: @72608
     /*  72608 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(72637), // Rule ID 7240 //
     /*  72613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  72616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72624 */   // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
     /*  72624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72627 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72636 */   // GIR_Coverage, 7240,
     /*  72636 */   GIR_EraseRootFromParent_Done,
     /*  72637 */ // Label 880: @72637
     /*  72637 */ GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(72666), // Rule ID 7241 //
     /*  72642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  72645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72653 */   // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
     /*  72653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72656 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72658 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72665 */   // GIR_Coverage, 7241,
     /*  72665 */   GIR_EraseRootFromParent_Done,
     /*  72666 */ // Label 881: @72666
     /*  72666 */ GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(72695), // Rule ID 7242 //
     /*  72671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72682 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  72682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72685 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72694 */   // GIR_Coverage, 7242,
     /*  72694 */   GIR_EraseRootFromParent_Done,
     /*  72695 */ // Label 882: @72695
     /*  72695 */ GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(72724), // Rule ID 7243 //
     /*  72700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72711 */   // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
     /*  72711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72714 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72716 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72723 */   // GIR_Coverage, 7243,
     /*  72723 */   GIR_EraseRootFromParent_Done,
     /*  72724 */ // Label 883: @72724
     /*  72724 */ GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(72753), // Rule ID 7244 //
     /*  72729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72740 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  72740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72752 */   // GIR_Coverage, 7244,
     /*  72752 */   GIR_EraseRootFromParent_Done,
     /*  72753 */ // Label 884: @72753
     /*  72753 */ GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(72782), // Rule ID 7245 //
     /*  72758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  72761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72769 */   // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
     /*  72769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72781 */   // GIR_Coverage, 7245,
     /*  72781 */   GIR_EraseRootFromParent_Done,
     /*  72782 */ // Label 885: @72782
     /*  72782 */ GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(72811), // Rule ID 7246 //
     /*  72787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72798 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  72798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72810 */   // GIR_Coverage, 7246,
     /*  72810 */   GIR_EraseRootFromParent_Done,
     /*  72811 */ // Label 886: @72811
     /*  72811 */ GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(72840), // Rule ID 7247 //
     /*  72816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72827 */   // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v4i64] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
     /*  72827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72830 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72839 */   // GIR_Coverage, 7247,
     /*  72839 */   GIR_EraseRootFromParent_Done,
     /*  72840 */ // Label 887: @72840
     /*  72840 */ GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(72869), // Rule ID 7248 //
     /*  72845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72856 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  72856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72859 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72861 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72868 */   // GIR_Coverage, 7248,
     /*  72868 */   GIR_EraseRootFromParent_Done,
     /*  72869 */ // Label 888: @72869
     /*  72869 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(72898), // Rule ID 7249 //
     /*  72874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  72877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72885 */   // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v4f64] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
     /*  72885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72888 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72892 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72897 */   // GIR_Coverage, 7249,
     /*  72897 */   GIR_EraseRootFromParent_Done,
     /*  72898 */ // Label 889: @72898
     /*  72898 */ GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(72927), // Rule ID 7250 //
     /*  72903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  72906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72914 */   // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
     /*  72914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72917 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /*  72926 */   // GIR_Coverage, 7250,
     /*  72926 */   GIR_EraseRootFromParent_Done,
     /*  72927 */ // Label 890: @72927
     /*  72927 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(72956), // Rule ID 7251 //
     /*  72932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  72935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72943 */   // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
     /*  72943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72946 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72948 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /*  72955 */   // GIR_Coverage, 7251,
     /*  72955 */   GIR_EraseRootFromParent_Done,
     /*  72956 */ // Label 891: @72956
     /*  72956 */ GIM_Reject,
     /*  72957 */ // Label 631: @72957
     /*  72957 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(72986), // Rule ID 7268 //
     /*  72962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  72965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  72969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  72973 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  72973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72976 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  72978 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  72980 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  72985 */   // GIR_Coverage, 7268,
     /*  72985 */   GIR_EraseRootFromParent_Done,
     /*  72986 */ // Label 892: @72986
     /*  72986 */ GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(73015), // Rule ID 7269 //
     /*  72991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  72994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  72998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73002 */   // (bitconvert:{ *:[v16i32] } SReg_512:{ *:[v16f32] }:$src0)  =>  SReg_512:{ *:[v16i32] }:$src0
     /*  73002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73005 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73007 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73014 */   // GIR_Coverage, 7269,
     /*  73014 */   GIR_EraseRootFromParent_Done,
     /*  73015 */ // Label 893: @73015
     /*  73015 */ GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(73044), // Rule ID 7270 //
     /*  73020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73031 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  73031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73043 */   // GIR_Coverage, 7270,
     /*  73043 */   GIR_EraseRootFromParent_Done,
     /*  73044 */ // Label 894: @73044
     /*  73044 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(73073), // Rule ID 7271 //
     /*  73049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73060 */   // (bitconvert:{ *:[v16i32] } SReg_512:{ *:[v8i64] }:$src0)  =>  SReg_512:{ *:[v16i32] }:$src0
     /*  73060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73072 */   // GIR_Coverage, 7271,
     /*  73072 */   GIR_EraseRootFromParent_Done,
     /*  73073 */ // Label 895: @73073
     /*  73073 */ GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(73102), // Rule ID 7272 //
     /*  73078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73089 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  73089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73101 */   // GIR_Coverage, 7272,
     /*  73101 */   GIR_EraseRootFromParent_Done,
     /*  73102 */ // Label 896: @73102
     /*  73102 */ GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(73131), // Rule ID 7273 //
     /*  73107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73118 */   // (bitconvert:{ *:[v16i32] } SReg_512:{ *:[v8f64] }:$src0)  =>  SReg_512:{ *:[v16i32] }:$src0
     /*  73118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73121 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73130 */   // GIR_Coverage, 7273,
     /*  73130 */   GIR_EraseRootFromParent_Done,
     /*  73131 */ // Label 897: @73131
     /*  73131 */ GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(73160), // Rule ID 7274 //
     /*  73136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73147 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  73147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73150 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73152 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73154 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73159 */   // GIR_Coverage, 7274,
     /*  73159 */   GIR_EraseRootFromParent_Done,
     /*  73160 */ // Label 898: @73160
     /*  73160 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(73189), // Rule ID 7275 //
     /*  73165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73176 */   // (bitconvert:{ *:[v16i32] } SReg_512:{ *:[v32i16] }:$src0)  =>  SReg_512:{ *:[v16i32] }:$src0
     /*  73176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73179 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73181 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73188 */   // GIR_Coverage, 7275,
     /*  73188 */   GIR_EraseRootFromParent_Done,
     /*  73189 */ // Label 899: @73189
     /*  73189 */ GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(73218), // Rule ID 7276 //
     /*  73194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73205 */   // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
     /*  73205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73208 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73210 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73217 */   // GIR_Coverage, 7276,
     /*  73217 */   GIR_EraseRootFromParent_Done,
     /*  73218 */ // Label 900: @73218
     /*  73218 */ GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(73247), // Rule ID 7277 //
     /*  73223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73234 */   // (bitconvert:{ *:[v16i32] } SReg_512:{ *:[v32f16] }:$src0)  =>  SReg_512:{ *:[v16i32] }:$src0
     /*  73234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73237 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73239 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73246 */   // GIR_Coverage, 7277,
     /*  73246 */   GIR_EraseRootFromParent_Done,
     /*  73247 */ // Label 901: @73247
     /*  73247 */ GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(73276), // Rule ID 7278 //
     /*  73252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  73255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73263 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  73263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73266 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73268 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73275 */   // GIR_Coverage, 7278,
     /*  73275 */   GIR_EraseRootFromParent_Done,
     /*  73276 */ // Label 902: @73276
     /*  73276 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(73305), // Rule ID 7279 //
     /*  73281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  73284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73292 */   // (bitconvert:{ *:[v16f32] } SReg_512:{ *:[v16i32] }:$src0)  =>  SReg_512:{ *:[v16f32] }:$src0
     /*  73292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73295 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73297 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73304 */   // GIR_Coverage, 7279,
     /*  73304 */   GIR_EraseRootFromParent_Done,
     /*  73305 */ // Label 903: @73305
     /*  73305 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(73334), // Rule ID 7280 //
     /*  73310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73321 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  73321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73324 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73326 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73333 */   // GIR_Coverage, 7280,
     /*  73333 */   GIR_EraseRootFromParent_Done,
     /*  73334 */ // Label 904: @73334
     /*  73334 */ GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(73363), // Rule ID 7281 //
     /*  73339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73350 */   // (bitconvert:{ *:[v16f32] } SReg_512:{ *:[v8i64] }:$src0)  =>  SReg_512:{ *:[v16f32] }:$src0
     /*  73350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73353 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73355 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73357 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73362 */   // GIR_Coverage, 7281,
     /*  73362 */   GIR_EraseRootFromParent_Done,
     /*  73363 */ // Label 905: @73363
     /*  73363 */ GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(73392), // Rule ID 7282 //
     /*  73368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73379 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  73379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73382 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73384 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73391 */   // GIR_Coverage, 7282,
     /*  73391 */   GIR_EraseRootFromParent_Done,
     /*  73392 */ // Label 906: @73392
     /*  73392 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(73421), // Rule ID 7283 //
     /*  73397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  73400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73408 */   // (bitconvert:{ *:[v16f32] } SReg_512:{ *:[v8f64] }:$src0)  =>  SReg_512:{ *:[v16f32] }:$src0
     /*  73408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73411 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73413 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73420 */   // GIR_Coverage, 7283,
     /*  73420 */   GIR_EraseRootFromParent_Done,
     /*  73421 */ // Label 907: @73421
     /*  73421 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(73450), // Rule ID 7284 //
     /*  73426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73437 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  73437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73440 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73442 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73449 */   // GIR_Coverage, 7284,
     /*  73449 */   GIR_EraseRootFromParent_Done,
     /*  73450 */ // Label 908: @73450
     /*  73450 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(73479), // Rule ID 7285 //
     /*  73455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73466 */   // (bitconvert:{ *:[v16f32] } SReg_512:{ *:[v32i16] }:$src0)  =>  SReg_512:{ *:[v16f32] }:$src0
     /*  73466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73469 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73478 */   // GIR_Coverage, 7285,
     /*  73478 */   GIR_EraseRootFromParent_Done,
     /*  73479 */ // Label 909: @73479
     /*  73479 */ GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(73508), // Rule ID 7286 //
     /*  73484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73495 */   // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
     /*  73495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73498 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73500 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73507 */   // GIR_Coverage, 7286,
     /*  73507 */   GIR_EraseRootFromParent_Done,
     /*  73508 */ // Label 910: @73508
     /*  73508 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(73537), // Rule ID 7287 //
     /*  73513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  73516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73524 */   // (bitconvert:{ *:[v16f32] } SReg_512:{ *:[v32f16] }:$src0)  =>  SReg_512:{ *:[v16f32] }:$src0
     /*  73524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73527 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73531 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73536 */   // GIR_Coverage, 7287,
     /*  73536 */   GIR_EraseRootFromParent_Done,
     /*  73537 */ // Label 911: @73537
     /*  73537 */ GIM_Reject,
     /*  73538 */ // Label 632: @73538
     /*  73538 */ GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(73567), // Rule ID 7340 //
     /*  73543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73554 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  73554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73557 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73559 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73566 */   // GIR_Coverage, 7340,
     /*  73566 */   GIR_EraseRootFromParent_Done,
     /*  73567 */ // Label 912: @73567
     /*  73567 */ GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(73596), // Rule ID 7341 //
     /*  73572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73583 */   // (bitconvert:{ *:[v16i64] } SReg_1024:{ *:[v32i32] }:$src0)  =>  SReg_1024:{ *:[v16i64] }:$src0
     /*  73583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73586 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73588 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73595 */   // GIR_Coverage, 7341,
     /*  73595 */   GIR_EraseRootFromParent_Done,
     /*  73596 */ // Label 913: @73596
     /*  73596 */ GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(73625), // Rule ID 7342 //
     /*  73601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73612 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  73612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73615 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73617 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73624 */   // GIR_Coverage, 7342,
     /*  73624 */   GIR_EraseRootFromParent_Done,
     /*  73625 */ // Label 914: @73625
     /*  73625 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(73654), // Rule ID 7343 //
     /*  73630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73641 */   // (bitconvert:{ *:[v16i64] } SReg_1024:{ *:[v32f32] }:$src0)  =>  SReg_1024:{ *:[v16i64] }:$src0
     /*  73641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73653 */   // GIR_Coverage, 7343,
     /*  73653 */   GIR_EraseRootFromParent_Done,
     /*  73654 */ // Label 915: @73654
     /*  73654 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(73683), // Rule ID 7344 //
     /*  73659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  73662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73670 */   // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
     /*  73670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73682 */   // GIR_Coverage, 7344,
     /*  73682 */   GIR_EraseRootFromParent_Done,
     /*  73683 */ // Label 916: @73683
     /*  73683 */ GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(73712), // Rule ID 7345 //
     /*  73688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  73691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73699 */   // (bitconvert:{ *:[v16i64] } SReg_1024:{ *:[v16f64] }:$src0)  =>  SReg_1024:{ *:[v16i64] }:$src0
     /*  73699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73702 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73711 */   // GIR_Coverage, 7345,
     /*  73711 */   GIR_EraseRootFromParent_Done,
     /*  73712 */ // Label 917: @73712
     /*  73712 */ GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(73741), // Rule ID 7346 //
     /*  73717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73728 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  73728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73731 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73733 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73740 */   // GIR_Coverage, 7346,
     /*  73740 */   GIR_EraseRootFromParent_Done,
     /*  73741 */ // Label 918: @73741
     /*  73741 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(73770), // Rule ID 7347 //
     /*  73746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73757 */   // (bitconvert:{ *:[v16f64] } SReg_1024:{ *:[v32i32] }:$src0)  =>  SReg_1024:{ *:[v16f64] }:$src0
     /*  73757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73760 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73762 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73769 */   // GIR_Coverage, 7347,
     /*  73769 */   GIR_EraseRootFromParent_Done,
     /*  73770 */ // Label 919: @73770
     /*  73770 */ GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(73799), // Rule ID 7348 //
     /*  73775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73786 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  73786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73789 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73791 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73798 */   // GIR_Coverage, 7348,
     /*  73798 */   GIR_EraseRootFromParent_Done,
     /*  73799 */ // Label 920: @73799
     /*  73799 */ GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(73828), // Rule ID 7349 //
     /*  73804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  73807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73815 */   // (bitconvert:{ *:[v16f64] } SReg_1024:{ *:[v32f32] }:$src0)  =>  SReg_1024:{ *:[v16f64] }:$src0
     /*  73815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73818 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73820 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73822 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73827 */   // GIR_Coverage, 7349,
     /*  73827 */   GIR_EraseRootFromParent_Done,
     /*  73828 */ // Label 921: @73828
     /*  73828 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(73857), // Rule ID 7350 //
     /*  73833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  73836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73844 */   // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
     /*  73844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  73856 */   // GIR_Coverage, 7350,
     /*  73856 */   GIR_EraseRootFromParent_Done,
     /*  73857 */ // Label 922: @73857
     /*  73857 */ GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(73886), // Rule ID 7351 //
     /*  73862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  73865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73873 */   // (bitconvert:{ *:[v16f64] } SReg_1024:{ *:[v16i64] }:$src0)  =>  SReg_1024:{ *:[v16f64] }:$src0
     /*  73873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  73885 */   // GIR_Coverage, 7351,
     /*  73885 */   GIR_EraseRootFromParent_Done,
     /*  73886 */ // Label 923: @73886
     /*  73886 */ GIM_Reject,
     /*  73887 */ // Label 633: @73887
     /*  73887 */ GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(73916), // Rule ID 7308 //
     /*  73892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  73895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73903 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  73903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73915 */   // GIR_Coverage, 7308,
     /*  73915 */   GIR_EraseRootFromParent_Done,
     /*  73916 */ // Label 924: @73916
     /*  73916 */ GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(73945), // Rule ID 7309 //
     /*  73921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  73924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73932 */   // (bitconvert:{ *:[v32i16] } SReg_512:{ *:[v16i32] }:$src0)  =>  SReg_512:{ *:[v32i16] }:$src0
     /*  73932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73944 */   // GIR_Coverage, 7309,
     /*  73944 */   GIR_EraseRootFromParent_Done,
     /*  73945 */ // Label 925: @73945
     /*  73945 */ GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(73974), // Rule ID 7310 //
     /*  73950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  73953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73961 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  73961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73964 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73966 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  73973 */   // GIR_Coverage, 7310,
     /*  73973 */   GIR_EraseRootFromParent_Done,
     /*  73974 */ // Label 926: @73974
     /*  73974 */ GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(74003), // Rule ID 7311 //
     /*  73979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  73982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  73990 */   // (bitconvert:{ *:[v32i16] } SReg_512:{ *:[v16f32] }:$src0)  =>  SReg_512:{ *:[v32i16] }:$src0
     /*  73990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73993 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  73995 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  73997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74002 */   // GIR_Coverage, 7311,
     /*  74002 */   GIR_EraseRootFromParent_Done,
     /*  74003 */ // Label 927: @74003
     /*  74003 */ GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(74032), // Rule ID 7312 //
     /*  74008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74019 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  74019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74022 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74031 */   // GIR_Coverage, 7312,
     /*  74031 */   GIR_EraseRootFromParent_Done,
     /*  74032 */ // Label 928: @74032
     /*  74032 */ GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(74061), // Rule ID 7313 //
     /*  74037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74048 */   // (bitconvert:{ *:[v32i16] } SReg_512:{ *:[v8i64] }:$src0)  =>  SReg_512:{ *:[v32i16] }:$src0
     /*  74048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74051 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74053 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74060 */   // GIR_Coverage, 7313,
     /*  74060 */   GIR_EraseRootFromParent_Done,
     /*  74061 */ // Label 929: @74061
     /*  74061 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(74090), // Rule ID 7314 //
     /*  74066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74077 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  74077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74080 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74082 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74089 */   // GIR_Coverage, 7314,
     /*  74089 */   GIR_EraseRootFromParent_Done,
     /*  74090 */ // Label 930: @74090
     /*  74090 */ GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(74119), // Rule ID 7315 //
     /*  74095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74106 */   // (bitconvert:{ *:[v32i16] } SReg_512:{ *:[v8f64] }:$src0)  =>  SReg_512:{ *:[v32i16] }:$src0
     /*  74106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74118 */   // GIR_Coverage, 7315,
     /*  74118 */   GIR_EraseRootFromParent_Done,
     /*  74119 */ // Label 931: @74119
     /*  74119 */ GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(74148), // Rule ID 7316 //
     /*  74124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  74127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74135 */   // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
     /*  74135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74147 */   // GIR_Coverage, 7316,
     /*  74147 */   GIR_EraseRootFromParent_Done,
     /*  74148 */ // Label 932: @74148
     /*  74148 */ GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(74177), // Rule ID 7317 //
     /*  74153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  74156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74164 */   // (bitconvert:{ *:[v32i16] } SReg_512:{ *:[v32f16] }:$src0)  =>  SReg_512:{ *:[v32i16] }:$src0
     /*  74164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74167 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74169 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74176 */   // GIR_Coverage, 7317,
     /*  74176 */   GIR_EraseRootFromParent_Done,
     /*  74177 */ // Label 933: @74177
     /*  74177 */ GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(74206), // Rule ID 7318 //
     /*  74182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  74185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74193 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  74193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74205 */   // GIR_Coverage, 7318,
     /*  74205 */   GIR_EraseRootFromParent_Done,
     /*  74206 */ // Label 934: @74206
     /*  74206 */ GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(74235), // Rule ID 7319 //
     /*  74211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  74214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74222 */   // (bitconvert:{ *:[v32f16] } SReg_512:{ *:[v16i32] }:$src0)  =>  SReg_512:{ *:[v32f16] }:$src0
     /*  74222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74225 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74227 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74229 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74234 */   // GIR_Coverage, 7319,
     /*  74234 */   GIR_EraseRootFromParent_Done,
     /*  74235 */ // Label 935: @74235
     /*  74235 */ GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(74264), // Rule ID 7320 //
     /*  74240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  74243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74251 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  74251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74254 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74263 */   // GIR_Coverage, 7320,
     /*  74263 */   GIR_EraseRootFromParent_Done,
     /*  74264 */ // Label 936: @74264
     /*  74264 */ GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(74293), // Rule ID 7321 //
     /*  74269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  74272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74280 */   // (bitconvert:{ *:[v32f16] } SReg_512:{ *:[v16f32] }:$src0)  =>  SReg_512:{ *:[v32f16] }:$src0
     /*  74280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74283 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74292 */   // GIR_Coverage, 7321,
     /*  74292 */   GIR_EraseRootFromParent_Done,
     /*  74293 */ // Label 937: @74293
     /*  74293 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(74322), // Rule ID 7322 //
     /*  74298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74309 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  74309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74312 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74314 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74321 */   // GIR_Coverage, 7322,
     /*  74321 */   GIR_EraseRootFromParent_Done,
     /*  74322 */ // Label 938: @74322
     /*  74322 */ GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(74351), // Rule ID 7323 //
     /*  74327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74338 */   // (bitconvert:{ *:[v32f16] } SReg_512:{ *:[v8i64] }:$src0)  =>  SReg_512:{ *:[v32f16] }:$src0
     /*  74338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74341 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74345 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74350 */   // GIR_Coverage, 7323,
     /*  74350 */   GIR_EraseRootFromParent_Done,
     /*  74351 */ // Label 939: @74351
     /*  74351 */ GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(74380), // Rule ID 7324 //
     /*  74356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74367 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  74367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74370 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74372 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74379 */   // GIR_Coverage, 7324,
     /*  74379 */   GIR_EraseRootFromParent_Done,
     /*  74380 */ // Label 940: @74380
     /*  74380 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(74409), // Rule ID 7325 //
     /*  74385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  74388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74396 */   // (bitconvert:{ *:[v32f16] } SReg_512:{ *:[v8f64] }:$src0)  =>  SReg_512:{ *:[v32f16] }:$src0
     /*  74396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74399 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74408 */   // GIR_Coverage, 7325,
     /*  74408 */   GIR_EraseRootFromParent_Done,
     /*  74409 */ // Label 941: @74409
     /*  74409 */ GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(74438), // Rule ID 7326 //
     /*  74414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  74417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74425 */   // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
     /*  74425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74428 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74430 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /*  74437 */   // GIR_Coverage, 7326,
     /*  74437 */   GIR_EraseRootFromParent_Done,
     /*  74438 */ // Label 942: @74438
     /*  74438 */ GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(74467), // Rule ID 7327 //
     /*  74443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  74446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74454 */   // (bitconvert:{ *:[v32f16] } SReg_512:{ *:[v32i16] }:$src0)  =>  SReg_512:{ *:[v32f16] }:$src0
     /*  74454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74457 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /*  74466 */   // GIR_Coverage, 7327,
     /*  74466 */   GIR_EraseRootFromParent_Done,
     /*  74467 */ // Label 943: @74467
     /*  74467 */ GIM_Reject,
     /*  74468 */ // Label 634: @74468
     /*  74468 */ GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(74497), // Rule ID 7328 //
     /*  74473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  74476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74484 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  74484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74496 */   // GIR_Coverage, 7328,
     /*  74496 */   GIR_EraseRootFromParent_Done,
     /*  74497 */ // Label 944: @74497
     /*  74497 */ GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(74526), // Rule ID 7329 //
     /*  74502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  74505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74513 */   // (bitconvert:{ *:[v32i32] } SReg_1024:{ *:[v32f32] }:$src0)  =>  SReg_1024:{ *:[v32i32] }:$src0
     /*  74513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74525 */   // GIR_Coverage, 7329,
     /*  74525 */   GIR_EraseRootFromParent_Done,
     /*  74526 */ // Label 945: @74526
     /*  74526 */ GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(74555), // Rule ID 7330 //
     /*  74531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74542 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  74542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74554 */   // GIR_Coverage, 7330,
     /*  74554 */   GIR_EraseRootFromParent_Done,
     /*  74555 */ // Label 946: @74555
     /*  74555 */ GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(74584), // Rule ID 7331 //
     /*  74560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74571 */   // (bitconvert:{ *:[v32i32] } SReg_1024:{ *:[v16i64] }:$src0)  =>  SReg_1024:{ *:[v32i32] }:$src0
     /*  74571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74574 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74576 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74583 */   // GIR_Coverage, 7331,
     /*  74583 */   GIR_EraseRootFromParent_Done,
     /*  74584 */ // Label 947: @74584
     /*  74584 */ GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(74613), // Rule ID 7332 //
     /*  74589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74600 */   // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
     /*  74600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74612 */   // GIR_Coverage, 7332,
     /*  74612 */   GIR_EraseRootFromParent_Done,
     /*  74613 */ // Label 948: @74613
     /*  74613 */ GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(74642), // Rule ID 7333 //
     /*  74618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74629 */   // (bitconvert:{ *:[v32i32] } SReg_1024:{ *:[v16f64] }:$src0)  =>  SReg_1024:{ *:[v32i32] }:$src0
     /*  74629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74632 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74634 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74641 */   // GIR_Coverage, 7333,
     /*  74641 */   GIR_EraseRootFromParent_Done,
     /*  74642 */ // Label 949: @74642
     /*  74642 */ GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(74671), // Rule ID 7334 //
     /*  74647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  74650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74658 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  74658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74661 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74663 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74670 */   // GIR_Coverage, 7334,
     /*  74670 */   GIR_EraseRootFromParent_Done,
     /*  74671 */ // Label 950: @74671
     /*  74671 */ GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(74700), // Rule ID 7335 //
     /*  74676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
     /*  74679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74687 */   // (bitconvert:{ *:[v32f32] } SReg_1024:{ *:[v32i32] }:$src0)  =>  SReg_1024:{ *:[v32f32] }:$src0
     /*  74687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74690 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74692 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74699 */   // GIR_Coverage, 7335,
     /*  74699 */   GIR_EraseRootFromParent_Done,
     /*  74700 */ // Label 951: @74700
     /*  74700 */ GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(74729), // Rule ID 7336 //
     /*  74705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74716 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  74716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74728 */   // GIR_Coverage, 7336,
     /*  74728 */   GIR_EraseRootFromParent_Done,
     /*  74729 */ // Label 952: @74729
     /*  74729 */ GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(74758), // Rule ID 7337 //
     /*  74734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74745 */   // (bitconvert:{ *:[v32f32] } SReg_1024:{ *:[v16i64] }:$src0)  =>  SReg_1024:{ *:[v32f32] }:$src0
     /*  74745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74757 */   // GIR_Coverage, 7337,
     /*  74757 */   GIR_EraseRootFromParent_Done,
     /*  74758 */ // Label 953: @74758
     /*  74758 */ GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(74787), // Rule ID 7338 //
     /*  74763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74774 */   // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
     /*  74774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /*  74786 */   // GIR_Coverage, 7338,
     /*  74786 */   GIR_EraseRootFromParent_Done,
     /*  74787 */ // Label 954: @74787
     /*  74787 */ GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(74816), // Rule ID 7339 //
     /*  74792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
     /*  74795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74803 */   // (bitconvert:{ *:[v32f32] } SReg_1024:{ *:[v16f64] }:$src0)  =>  SReg_1024:{ *:[v32f32] }:$src0
     /*  74803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  74808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_1024RegClassID),
     /*  74815 */   // GIR_Coverage, 7339,
     /*  74815 */   GIR_EraseRootFromParent_Done,
     /*  74816 */ // Label 955: @74816
     /*  74816 */ GIM_Reject,
     /*  74817 */ // Label 635: @74817
     /*  74817 */ GIM_Reject,
     /*  74818 */ // Label 9: @74818
     /*  74818 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 958*/ GIMT_Encode4(75012),
     /*  74829 */ /*GILLT_s16*//*Label 956*/ GIMT_Encode4(74837),
     /*  74833 */ /*GILLT_s32*//*Label 957*/ GIMT_Encode4(74976),
     /*  74837 */ // Label 956: @74837
     /*  74837 */ GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(74975),
     /*  74842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  74845 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(74904), // Rule ID 6949 //
     /*  74850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  74853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  74857 */     // MIs[0] round
     /*  74857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  74860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  74865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  74872 */     // (fptrunc_round:{ *:[f16] } (VOP3OpSelMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  74872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO_t16_e64),
     /*  74875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  74882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  74887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  74902 */     GIR_RootConstrainSelectedInstOperands,
     /*  74903 */     // GIR_Coverage, 6949,
     /*  74903 */     GIR_EraseRootFromParent_Done,
     /*  74904 */   // Label 960: @74904
     /*  74904 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(74939), // Rule ID 6947 //
     /*  74909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /*  74912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  74916 */     // MIs[0] round
     /*  74916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  74919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  74924 */     // (fptrunc_round:{ *:[f16] } f32:{ *:[f32] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO:{ *:[f16] } ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  74924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO),
     /*  74927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  74937 */     GIR_RootConstrainSelectedInstOperands,
     /*  74938 */     // GIR_Coverage, 6947,
     /*  74938 */     GIR_EraseRootFromParent_Done,
     /*  74939 */   // Label 961: @74939
     /*  74939 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(74974), // Rule ID 6948 //
     /*  74944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  74947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  74951 */     // MIs[0] round
     /*  74951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  74954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  74959 */     // (fptrunc_round:{ *:[f16] } f32:{ *:[f32] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO_fake16_e32:{ *:[f16] } ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  74959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO_fake16_e32),
     /*  74962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  74964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  74966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  74972 */     GIR_RootConstrainSelectedInstOperands,
     /*  74973 */     // GIR_Coverage, 6948,
     /*  74973 */     GIR_EraseRootFromParent_Done,
     /*  74974 */   // Label 962: @74974
     /*  74974 */   GIM_Reject,
     /*  74975 */ // Label 959: @74975
     /*  74975 */ GIM_Reject,
     /*  74976 */ // Label 957: @74976
     /*  74976 */ GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(75011), // Rule ID 6950 //
     /*  74981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  74984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  74988 */   // MIs[0] round
     /*  74988 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  74991 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
     /*  74996 */   // (fptrunc_round:{ *:[f32] } f64:{ *:[f64] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F32_F64_PSEUDO:{ *:[f32] } ?:{ *:[f64] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
     /*  74996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F32_F64_PSEUDO),
     /*  74999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /*  75003 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
     /*  75009 */   GIR_RootConstrainSelectedInstOperands,
     /*  75010 */   // GIR_Coverage, 6950,
     /*  75010 */   GIR_EraseRootFromParent_Done,
     /*  75011 */ // Label 963: @75011
     /*  75011 */ GIM_Reject,
     /*  75012 */ // Label 958: @75012
     /*  75012 */ GIM_Reject,
     /*  75013 */ // Label 10: @75013
     /*  75013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 967*/ GIMT_Encode4(75340),
     /*  75024 */ /*GILLT_s16*//*Label 964*/ GIMT_Encode4(75036),
     /*  75028 */ /*GILLT_s32*//*Label 965*/ GIMT_Encode4(75210),
     /*  75032 */ /*GILLT_s64*//*Label 966*/ GIMT_Encode4(75290),
     /*  75036 */ // Label 964: @75036
     /*  75036 */ GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(75209),
     /*  75041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  75044 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(75071), // Rule ID 39 //
     /*  75049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  75052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  75056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13719),
     /*  75060 */     // (ftrunc:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13719>>  =>  (S_TRUNC_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /*  75060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F16),
     /*  75065 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  75069 */     GIR_RootConstrainSelectedInstOperands,
     /*  75070 */     // GIR_Coverage, 39,
     /*  75070 */     GIR_Done,
     /*  75071 */   // Label 969: @75071
     /*  75071 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(75117), // Rule ID 772 //
     /*  75076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  75079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  75083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75090 */     // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_e64),
     /*  75093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75115 */     GIR_RootConstrainSelectedInstOperands,
     /*  75116 */     // GIR_Coverage, 772,
     /*  75116 */     GIR_EraseRootFromParent_Done,
     /*  75117 */   // Label 970: @75117
     /*  75117 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(75163), // Rule ID 774 //
     /*  75122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  75125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  75129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75136 */     // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_fake16_e64),
     /*  75139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75161 */     GIR_RootConstrainSelectedInstOperands,
     /*  75162 */     // GIR_Coverage, 774,
     /*  75162 */     GIR_EraseRootFromParent_Done,
     /*  75163 */   // Label 971: @75163
     /*  75163 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(75208), // Rule ID 773 //
     /*  75168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  75171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  75175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  75182 */     // (ftrunc:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_TRUNC_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /*  75182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_t16_e64),
     /*  75185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75206 */     GIR_RootConstrainSelectedInstOperands,
     /*  75207 */     // GIR_Coverage, 773,
     /*  75207 */     GIR_EraseRootFromParent_Done,
     /*  75208 */   // Label 972: @75208
     /*  75208 */   GIM_Reject,
     /*  75209 */ // Label 968: @75209
     /*  75209 */ GIM_Reject,
     /*  75210 */ // Label 965: @75210
     /*  75210 */ GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(75289),
     /*  75215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  75218 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(75245), // Rule ID 34 //
     /*  75223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  75226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  75230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13719),
     /*  75234 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13719>>  =>  (S_TRUNC_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /*  75234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F32),
     /*  75239 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  75243 */     GIR_RootConstrainSelectedInstOperands,
     /*  75244 */     // GIR_Coverage, 34,
     /*  75244 */     GIR_Done,
     /*  75245 */   // Label 974: @75245
     /*  75245 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(75288), // Rule ID 658 //
     /*  75250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  75254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75261 */     // (ftrunc:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F32_e64),
     /*  75264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75286 */     GIR_RootConstrainSelectedInstOperands,
     /*  75287 */     // GIR_Coverage, 658,
     /*  75287 */     GIR_EraseRootFromParent_Done,
     /*  75288 */   // Label 975: @75288
     /*  75288 */   GIM_Reject,
     /*  75289 */ // Label 973: @75289
     /*  75289 */ GIM_Reject,
     /*  75290 */ // Label 966: @75290
     /*  75290 */ GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(75339), // Rule ID 702 //
     /*  75295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /*  75298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  75301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  75305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75312 */   // (ftrunc:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F64_e64),
     /*  75315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75337 */   GIR_RootConstrainSelectedInstOperands,
     /*  75338 */   // GIR_Coverage, 702,
     /*  75338 */   GIR_EraseRootFromParent_Done,
     /*  75339 */ // Label 976: @75339
     /*  75339 */ GIM_Reject,
     /*  75340 */ // Label 967: @75340
     /*  75340 */ GIM_Reject,
     /*  75341 */ // Label 11: @75341
     /*  75341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 980*/ GIMT_Encode4(75668),
     /*  75352 */ /*GILLT_s16*//*Label 977*/ GIMT_Encode4(75364),
     /*  75356 */ /*GILLT_s32*//*Label 978*/ GIMT_Encode4(75538),
     /*  75360 */ /*GILLT_s64*//*Label 979*/ GIMT_Encode4(75618),
     /*  75364 */ // Label 977: @75364
     /*  75364 */ GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(75537),
     /*  75369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  75372 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(75399), // Rule ID 40 //
     /*  75377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  75380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  75384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13720),
     /*  75388 */     // (froundeven:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13720>>  =>  (S_RNDNE_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /*  75388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F16),
     /*  75393 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  75397 */     GIR_RootConstrainSelectedInstOperands,
     /*  75398 */     // GIR_Coverage, 40,
     /*  75398 */     GIR_Done,
     /*  75399 */   // Label 982: @75399
     /*  75399 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(75445), // Rule ID 775 //
     /*  75404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /*  75407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  75411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75418 */     // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_e64),
     /*  75421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75443 */     GIR_RootConstrainSelectedInstOperands,
     /*  75444 */     // GIR_Coverage, 775,
     /*  75444 */     GIR_EraseRootFromParent_Done,
     /*  75445 */   // Label 983: @75445
     /*  75445 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(75491), // Rule ID 777 //
     /*  75450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /*  75453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  75457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75464 */     // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_fake16_e64),
     /*  75467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75489 */     GIR_RootConstrainSelectedInstOperands,
     /*  75490 */     // GIR_Coverage, 777,
     /*  75490 */     GIR_EraseRootFromParent_Done,
     /*  75491 */   // Label 984: @75491
     /*  75491 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(75536), // Rule ID 776 //
     /*  75496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /*  75499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  75503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /*  75510 */     // (froundeven:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RNDNE_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /*  75510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_t16_e64),
     /*  75513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75534 */     GIR_RootConstrainSelectedInstOperands,
     /*  75535 */     // GIR_Coverage, 776,
     /*  75535 */     GIR_EraseRootFromParent_Done,
     /*  75536 */   // Label 985: @75536
     /*  75536 */   GIM_Reject,
     /*  75537 */ // Label 981: @75537
     /*  75537 */ GIM_Reject,
     /*  75538 */ // Label 978: @75538
     /*  75538 */ GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(75617),
     /*  75543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  75546 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(75573), // Rule ID 35 //
     /*  75551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /*  75554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /*  75558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13720),
     /*  75562 */     // (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13720>>  =>  (S_RNDNE_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /*  75562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F32),
     /*  75567 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /*  75571 */     GIR_RootConstrainSelectedInstOperands,
     /*  75572 */     // GIR_Coverage, 35,
     /*  75572 */     GIR_Done,
     /*  75573 */   // Label 987: @75573
     /*  75573 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(75616), // Rule ID 660 //
     /*  75578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /*  75582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75589 */     // (froundeven:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F32_e64),
     /*  75592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75614 */     GIR_RootConstrainSelectedInstOperands,
     /*  75615 */     // GIR_Coverage, 660,
     /*  75615 */     GIR_EraseRootFromParent_Done,
     /*  75616 */   // Label 988: @75616
     /*  75616 */   GIM_Reject,
     /*  75617 */ // Label 986: @75617
     /*  75617 */ GIM_Reject,
     /*  75618 */ // Label 979: @75618
     /*  75618 */ GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(75667), // Rule ID 704 //
     /*  75623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /*  75626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  75629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /*  75633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /*  75640 */   // (froundeven:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /*  75640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F64_e64),
     /*  75643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  75645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /*  75650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /*  75655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /*  75660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /*  75665 */   GIR_RootConstrainSelectedInstOperands,
     /*  75666 */   // GIR_Coverage, 704,
     /*  75666 */   GIR_EraseRootFromParent_Done,
     /*  75667 */ // Label 989: @75667
     /*  75667 */ GIM_Reject,
     /*  75668 */ // Label 980: @75668
     /*  75668 */ GIM_Reject,
     /*  75669 */ // Label 12: @75669
     /*  75669 */ GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(75808),
     /*  75674 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75677 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(75702), // Rule ID 1343 //
     /*  75682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesHiLoRegisters),
     /*  75685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75689 */     // (readcyclecounter:{ *:[i64] })  =>  (GET_SHADERCYCLESHILO:{ *:[i64] }:{ *:[i1] })
     /*  75689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::GET_SHADERCYCLESHILO),
     /*  75694 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /*  75700 */     GIR_RootConstrainSelectedInstOperands,
     /*  75701 */     // GIR_Coverage, 1343,
     /*  75701 */     GIR_Done,
     /*  75702 */   // Label 991: @75702
     /*  75702 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(75721), // Rule ID 3534 //
     /*  75707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
     /*  75710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75714 */     // (readcyclecounter:{ *:[i64] })  =>  (S_MEMTIME:{ *:[i64] })
     /*  75714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
     /*  75719 */     GIR_RootConstrainSelectedInstOperands,
     /*  75720 */     // GIR_Coverage, 3534,
     /*  75720 */     GIR_Done,
     /*  75721 */   // Label 992: @75721
     /*  75721 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(75807), // Rule ID 3535 //
     /*  75726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesRegister),
     /*  75729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75733 */     // (readcyclecounter:{ *:[i64] })  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 38941:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /*  75733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /*  75736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /*  75740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75745 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  75748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  75750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  75753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /*  75757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75762 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(38941),
     /*  75772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  75774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  75777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  75779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75782 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /*  75785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  75788 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /*  75791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /*  75801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /*  75806 */     // GIR_Coverage, 3535,
     /*  75806 */     GIR_EraseRootFromParent_Done,
     /*  75807 */   // Label 993: @75807
     /*  75807 */   GIM_Reject,
     /*  75808 */ // Label 990: @75808
     /*  75808 */ GIM_Reject,
     /*  75809 */ // Label 13: @75809
     /*  75809 */ GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(75866),
     /*  75814 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75817 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(75836), // Rule ID 3536 //
     /*  75822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
     /*  75825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  75829 */     // (readsteadycounter:{ *:[i64] })  =>  (S_MEMREALTIME:{ *:[i64] })
     /*  75829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
     /*  75834 */     GIR_RootConstrainSelectedInstOperands,
     /*  75835 */     // GIR_Coverage, 3536,
     /*  75835 */     GIR_Done,
     /*  75836 */   // Label 995: @75836
     /*  75836 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(75865), // Rule ID 3537 //
     /*  75841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /*  75844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  75848 */     // (readsteadycounter:{ *:[i64] })  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } 131:{ *:[i32] })
     /*  75848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
     /*  75851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  75853 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  75863 */     GIR_RootConstrainSelectedInstOperands,
     /*  75864 */     // GIR_Coverage, 3537,
     /*  75864 */     GIR_EraseRootFromParent_Done,
     /*  75865 */   // Label 996: @75865
     /*  75865 */   GIM_Reject,
     /*  75866 */ // Label 994: @75866
     /*  75866 */ GIM_Reject,
     /*  75867 */ // Label 14: @75867
     /*  75867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(33), /*)*//*default:*//*Label 1021*/ GIMT_Encode4(143566),
     /*  75878 */ /*GILLT_p0s64*//*Label 997*/ GIMT_Encode4(76010),
     /*  75882 */ /*GILLT_p1s64*//*Label 998*/ GIMT_Encode4(77914),
     /*  75886 */ /*GILLT_p2s32*//*Label 999*/ GIMT_Encode4(79818),
     /*  75890 */ /*GILLT_p3s32*//*Label 1000*/ GIMT_Encode4(81445),
     /*  75894 */ /*GILLT_p4s64*//*Label 1001*/ GIMT_Encode4(83072),
     /*  75898 */ /*GILLT_p5s32*//*Label 1002*/ GIMT_Encode4(84976),
     /*  75902 */ /*GILLT_p6s32*//*Label 1003*/ GIMT_Encode4(86603),
     /*  75906 */ /*GILLT_s1*//*Label 1004*/ GIMT_Encode4(88230),
     /*  75910 */ /*GILLT_s16*//*Label 1005*/ GIMT_Encode4(88830),
     /*  75914 */ /*GILLT_s32*//*Label 1006*/ GIMT_Encode4(94163),
     /*  75918 */ /*GILLT_s64*//*Label 1007*/ GIMT_Encode4(102287),
     /*  75922 */ /*GILLT_v2s16*//*Label 1008*/ GIMT_Encode4(107701),
     /*  75926 */ /*GILLT_v2s32*//*Label 1009*/ GIMT_Encode4(110945),
     /*  75930 */ /*GILLT_v2s64*//*Label 1010*/ GIMT_Encode4(114993),
     /*  75934 */ /*GILLT_v3s32*//*Label 1011*/ GIMT_Encode4(118791), GIMT_Encode4(0),
     /*  75942 */ /*GILLT_v4s16*//*Label 1012*/ GIMT_Encode4(122010),
     /*  75946 */ /*GILLT_v4s32*//*Label 1013*/ GIMT_Encode4(125808),
     /*  75950 */ /*GILLT_v4s64*//*Label 1014*/ GIMT_Encode4(129856), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  75966 */ /*GILLT_v8s16*//*Label 1015*/ GIMT_Encode4(131508),
     /*  75970 */ /*GILLT_v8s32*//*Label 1016*/ GIMT_Encode4(135306),
     /*  75974 */ /*GILLT_v8s64*//*Label 1017*/ GIMT_Encode4(136958), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  75994 */ /*GILLT_v16s16*//*Label 1018*/ GIMT_Encode4(138610),
     /*  75998 */ /*GILLT_v16s32*//*Label 1019*/ GIMT_Encode4(140262), GIMT_Encode4(0),
     /*  76006 */ /*GILLT_v32s16*//*Label 1020*/ GIMT_Encode4(141914),
     /*  76010 */ // Label 997: @76010
     /*  76010 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(77913),
     /*  76015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76018 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(76082), // Rule ID 8493 //
     /*  76023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  76053 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  76056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76080 */     GIR_RootConstrainSelectedInstOperands,
     /*  76081 */     // GIR_Coverage, 8493,
     /*  76081 */     GIR_EraseRootFromParent_Done,
     /*  76082 */   // Label 1023: @76082
     /*  76082 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(76142), // Rule ID 8498 //
     /*  76087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  76113 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  76116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76140 */     GIR_RootConstrainSelectedInstOperands,
     /*  76141 */     // GIR_Coverage, 8498,
     /*  76141 */     GIR_EraseRootFromParent_Done,
     /*  76142 */   // Label 1024: @76142
     /*  76142 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(76202), // Rule ID 8504 //
     /*  76147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  76150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  76173 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  76176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  76193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76200 */     GIR_RootConstrainSelectedInstOperands,
     /*  76201 */     // GIR_Coverage, 8504,
     /*  76201 */     GIR_EraseRootFromParent_Done,
     /*  76202 */   // Label 1025: @76202
     /*  76202 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(76261), // Rule ID 8489 //
     /*  76207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  76210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  76237 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  76240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76259 */     GIR_RootConstrainSelectedInstOperands,
     /*  76260 */     // GIR_Coverage, 8489,
     /*  76260 */     GIR_EraseRootFromParent_Done,
     /*  76261 */   // Label 1026: @76261
     /*  76261 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(76320), // Rule ID 8490 //
     /*  76266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  76269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  76296 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  76299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76318 */     GIR_RootConstrainSelectedInstOperands,
     /*  76319 */     // GIR_Coverage, 8490,
     /*  76319 */     GIR_EraseRootFromParent_Done,
     /*  76320 */   // Label 1027: @76320
     /*  76320 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(76379), // Rule ID 8491 //
     /*  76325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  76328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76355 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  76355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  76358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76377 */     GIR_RootConstrainSelectedInstOperands,
     /*  76378 */     // GIR_Coverage, 8491,
     /*  76378 */     GIR_EraseRootFromParent_Done,
     /*  76379 */   // Label 1028: @76379
     /*  76379 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(76441), // Rule ID 8492 //
     /*  76384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76403 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  76407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76414 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  76417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76439 */     GIR_RootConstrainSelectedInstOperands,
     /*  76440 */     // GIR_Coverage, 8492,
     /*  76440 */     GIR_EraseRootFromParent_Done,
     /*  76441 */   // Label 1029: @76441
     /*  76441 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(76496), // Rule ID 8495 //
     /*  76446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  76449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  76472 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  76475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76494 */     GIR_RootConstrainSelectedInstOperands,
     /*  76495 */     // GIR_Coverage, 8495,
     /*  76495 */     GIR_EraseRootFromParent_Done,
     /*  76496 */   // Label 1030: @76496
     /*  76496 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(76551), // Rule ID 8496 //
     /*  76501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  76504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76527 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  76527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  76530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76549 */     GIR_RootConstrainSelectedInstOperands,
     /*  76550 */     // GIR_Coverage, 8496,
     /*  76550 */     GIR_EraseRootFromParent_Done,
     /*  76551 */   // Label 1031: @76551
     /*  76551 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(76609), // Rule ID 8497 //
     /*  76556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  76559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76582 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  76585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76607 */     GIR_RootConstrainSelectedInstOperands,
     /*  76608 */     // GIR_Coverage, 8497,
     /*  76608 */     GIR_EraseRootFromParent_Done,
     /*  76609 */   // Label 1032: @76609
     /*  76609 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(76674), // Rule ID 8216 //
     /*  76614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  76617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76621 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76626 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  76643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  76650 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  76650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  76653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  76660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76672 */     GIR_RootConstrainSelectedInstOperands,
     /*  76673 */     // GIR_Coverage, 8216,
     /*  76673 */     GIR_EraseRootFromParent_Done,
     /*  76674 */   // Label 1033: @76674
     /*  76674 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(76734), // Rule ID 8148 //
     /*  76679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  76682 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76686 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76691 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  76695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  76710 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  76710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  76713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  76720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76732 */     GIR_RootConstrainSelectedInstOperands,
     /*  76733 */     // GIR_Coverage, 8148,
     /*  76733 */     GIR_EraseRootFromParent_Done,
     /*  76734 */   // Label 1034: @76734
     /*  76734 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(76786), // Rule ID 8500 //
     /*  76739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  76762 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  76765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76784 */     GIR_RootConstrainSelectedInstOperands,
     /*  76785 */     // GIR_Coverage, 8500,
     /*  76785 */     GIR_EraseRootFromParent_Done,
     /*  76786 */   // Label 1035: @76786
     /*  76786 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(76841), // Rule ID 8501 //
     /*  76791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  76794 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  76817 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  76817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  76820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  76832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76839 */     GIR_RootConstrainSelectedInstOperands,
     /*  76840 */     // GIR_Coverage, 8501,
     /*  76840 */     GIR_EraseRootFromParent_Done,
     /*  76841 */   // Label 1036: @76841
     /*  76841 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(76896), // Rule ID 8502 //
     /*  76846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  76849 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76872 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  76872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  76875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76894 */     GIR_RootConstrainSelectedInstOperands,
     /*  76895 */     // GIR_Coverage, 8502,
     /*  76895 */     GIR_EraseRootFromParent_Done,
     /*  76896 */   // Label 1037: @76896
     /*  76896 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(76954), // Rule ID 8503 //
     /*  76901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  76904 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  76912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  76920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  76927 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  76927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  76930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  76932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  76937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  76942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76952 */     GIR_RootConstrainSelectedInstOperands,
     /*  76953 */     // GIR_Coverage, 8503,
     /*  76953 */     GIR_EraseRootFromParent_Done,
     /*  76954 */   // Label 1038: @76954
     /*  76954 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(77015), // Rule ID 8217 //
     /*  76959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  76962 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  76972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  76976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  76984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  76991 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  76991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  76994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  76996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77013 */     GIR_RootConstrainSelectedInstOperands,
     /*  77014 */     // GIR_Coverage, 8217,
     /*  77014 */     GIR_EraseRootFromParent_Done,
     /*  77015 */   // Label 1039: @77015
     /*  77015 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(77071), // Rule ID 8149 //
     /*  77020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  77023 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  77028 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  77032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  77047 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  77047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  77050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77069 */     GIR_RootConstrainSelectedInstOperands,
     /*  77070 */     // GIR_Coverage, 8149,
     /*  77070 */     GIR_EraseRootFromParent_Done,
     /*  77071 */   // Label 1040: @77071
     /*  77071 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(77122), // Rule ID 8494 //
     /*  77076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  77079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  77087 */     // MIs[0] sbase
     /*  77087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  77091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  77095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  77103 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  77103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  77106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77108 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  77110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77120 */     GIR_RootConstrainSelectedInstOperands,
     /*  77121 */     // GIR_Coverage, 8494,
     /*  77121 */     GIR_EraseRootFromParent_Done,
     /*  77122 */   // Label 1041: @77122
     /*  77122 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(77169), // Rule ID 8499 //
     /*  77127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  77130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  77138 */     // MIs[0] sbase
     /*  77138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  77142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  77146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77150 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  77150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  77153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77155 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  77157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77167 */     GIR_RootConstrainSelectedInstOperands,
     /*  77168 */     // GIR_Coverage, 8499,
     /*  77168 */     GIR_EraseRootFromParent_Done,
     /*  77169 */   // Label 1042: @77169
     /*  77169 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(77213), // Rule ID 8505 //
     /*  77174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  77182 */     // MIs[0] sbase
     /*  77182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  77186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  77190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77194 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  77194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  77197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77199 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  77201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77211 */     GIR_RootConstrainSelectedInstOperands,
     /*  77212 */     // GIR_Coverage, 8505,
     /*  77212 */     GIR_EraseRootFromParent_Done,
     /*  77213 */   // Label 1043: @77213
     /*  77213 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(77270), // Rule ID 4337 //
     /*  77218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  77221 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  77241 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  77244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  77256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77268 */     GIR_RootConstrainSelectedInstOperands,
     /*  77269 */     // GIR_Coverage, 4337,
     /*  77269 */     GIR_EraseRootFromParent_Done,
     /*  77270 */   // Label 1044: @77270
     /*  77270 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(77322), // Rule ID 4336 //
     /*  77275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  77278 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  77298 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  77298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  77301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  77308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77320 */     GIR_RootConstrainSelectedInstOperands,
     /*  77321 */     // GIR_Coverage, 4336,
     /*  77321 */     GIR_EraseRootFromParent_Done,
     /*  77322 */   // Label 1045: @77322
     /*  77322 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(77374), // Rule ID 4335 //
     /*  77327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  77330 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  77335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  77350 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  77350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  77353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77372 */     GIR_RootConstrainSelectedInstOperands,
     /*  77373 */     // GIR_Coverage, 4335,
     /*  77373 */     GIR_EraseRootFromParent_Done,
     /*  77374 */   // Label 1046: @77374
     /*  77374 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(77441), // Rule ID 4563 //
     /*  77379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  77382 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  77404 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  77407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77439 */     GIR_RootConstrainSelectedInstOperands,
     /*  77440 */     // GIR_Coverage, 4563,
     /*  77440 */     GIR_EraseRootFromParent_Done,
     /*  77441 */   // Label 1047: @77441
     /*  77441 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(77505), // Rule ID 4565 //
     /*  77446 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  77468 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  77471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  77478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  77488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  77493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77503 */     GIR_RootConstrainSelectedInstOperands,
     /*  77504 */     // GIR_Coverage, 4565,
     /*  77504 */     GIR_EraseRootFromParent_Done,
     /*  77505 */   // Label 1048: @77505
     /*  77505 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(77566), // Rule ID 8092 //
     /*  77510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  77513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77517 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  77522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  77537 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  77537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  77540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  77552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  77557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77564 */     GIR_RootConstrainSelectedInstOperands,
     /*  77565 */     // GIR_Coverage, 8092,
     /*  77565 */     GIR_EraseRootFromParent_Done,
     /*  77566 */   // Label 1049: @77566
     /*  77566 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(77628), // Rule ID 4562 //
     /*  77571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  77574 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  77596 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  77599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77626 */     GIR_RootConstrainSelectedInstOperands,
     /*  77627 */     // GIR_Coverage, 4562,
     /*  77627 */     GIR_EraseRootFromParent_Done,
     /*  77628 */   // Label 1050: @77628
     /*  77628 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(77687), // Rule ID 4564 //
     /*  77633 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  77655 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  77655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  77658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  77660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  77665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77685 */     GIR_RootConstrainSelectedInstOperands,
     /*  77686 */     // GIR_Coverage, 4564,
     /*  77686 */     GIR_EraseRootFromParent_Done,
     /*  77687 */   // Label 1051: @77687
     /*  77687 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(77744), // Rule ID 8094 //
     /*  77692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  77695 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  77700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  77715 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  77715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  77718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  77725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  77730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  77735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77742 */     GIR_RootConstrainSelectedInstOperands,
     /*  77743 */     // GIR_Coverage, 8094,
     /*  77743 */     GIR_EraseRootFromParent_Done,
     /*  77744 */   // Label 1052: @77744
     /*  77744 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(77803), // Rule ID 3924 //
     /*  77749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  77752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  77774 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  77777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  77784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  77789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77801 */     GIR_RootConstrainSelectedInstOperands,
     /*  77802 */     // GIR_Coverage, 3924,
     /*  77802 */     GIR_EraseRootFromParent_Done,
     /*  77803 */   // Label 1053: @77803
     /*  77803 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(77857), // Rule ID 3923 //
     /*  77808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  77811 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  77833 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  77833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  77836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77855 */     GIR_RootConstrainSelectedInstOperands,
     /*  77856 */     // GIR_Coverage, 3923,
     /*  77856 */     GIR_EraseRootFromParent_Done,
     /*  77857 */   // Label 1054: @77857
     /*  77857 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(77912), // Rule ID 3649 //
     /*  77862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  77865 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  77873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  77877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  77888 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  77888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  77891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  77893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  77898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  77903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77910 */     GIR_RootConstrainSelectedInstOperands,
     /*  77911 */     // GIR_Coverage, 3649,
     /*  77911 */     GIR_EraseRootFromParent_Done,
     /*  77912 */   // Label 1055: @77912
     /*  77912 */   GIM_Reject,
     /*  77913 */ // Label 1022: @77913
     /*  77913 */ GIM_Reject,
     /*  77914 */ // Label 998: @77914
     /*  77914 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(79817),
     /*  77919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77922 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(77986), // Rule ID 8510 //
     /*  77927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  77930 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  77938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  77942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  77946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  77950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  77957 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  77957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  77960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  77962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  77967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  77972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  77977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  77984 */     GIR_RootConstrainSelectedInstOperands,
     /*  77985 */     // GIR_Coverage, 8510,
     /*  77985 */     GIR_EraseRootFromParent_Done,
     /*  77986 */   // Label 1057: @77986
     /*  77986 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(78046), // Rule ID 8515 //
     /*  77991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  77994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  78017 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  78020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78044 */     GIR_RootConstrainSelectedInstOperands,
     /*  78045 */     // GIR_Coverage, 8515,
     /*  78045 */     GIR_EraseRootFromParent_Done,
     /*  78046 */   // Label 1058: @78046
     /*  78046 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(78106), // Rule ID 8521 //
     /*  78051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  78054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  78077 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  78080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  78097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78104 */     GIR_RootConstrainSelectedInstOperands,
     /*  78105 */     // GIR_Coverage, 8521,
     /*  78105 */     GIR_EraseRootFromParent_Done,
     /*  78106 */   // Label 1059: @78106
     /*  78106 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(78165), // Rule ID 8506 //
     /*  78111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  78114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  78141 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  78144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78163 */     GIR_RootConstrainSelectedInstOperands,
     /*  78164 */     // GIR_Coverage, 8506,
     /*  78164 */     GIR_EraseRootFromParent_Done,
     /*  78165 */   // Label 1060: @78165
     /*  78165 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(78224), // Rule ID 8507 //
     /*  78170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  78173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  78200 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  78203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78222 */     GIR_RootConstrainSelectedInstOperands,
     /*  78223 */     // GIR_Coverage, 8507,
     /*  78223 */     GIR_EraseRootFromParent_Done,
     /*  78224 */   // Label 1061: @78224
     /*  78224 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(78283), // Rule ID 8508 //
     /*  78229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  78232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78248 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78259 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  78259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  78262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78281 */     GIR_RootConstrainSelectedInstOperands,
     /*  78282 */     // GIR_Coverage, 8508,
     /*  78282 */     GIR_EraseRootFromParent_Done,
     /*  78283 */   // Label 1062: @78283
     /*  78283 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(78345), // Rule ID 8509 //
     /*  78288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  78291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  78311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78318 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  78321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78343 */     GIR_RootConstrainSelectedInstOperands,
     /*  78344 */     // GIR_Coverage, 8509,
     /*  78344 */     GIR_EraseRootFromParent_Done,
     /*  78345 */   // Label 1063: @78345
     /*  78345 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(78400), // Rule ID 8512 //
     /*  78350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  78353 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  78376 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  78379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78398 */     GIR_RootConstrainSelectedInstOperands,
     /*  78399 */     // GIR_Coverage, 8512,
     /*  78399 */     GIR_EraseRootFromParent_Done,
     /*  78400 */   // Label 1064: @78400
     /*  78400 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(78455), // Rule ID 8513 //
     /*  78405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  78408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78431 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  78431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  78434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78453 */     GIR_RootConstrainSelectedInstOperands,
     /*  78454 */     // GIR_Coverage, 8513,
     /*  78454 */     GIR_EraseRootFromParent_Done,
     /*  78455 */   // Label 1065: @78455
     /*  78455 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(78513), // Rule ID 8514 //
     /*  78460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  78463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78486 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  78489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78511 */     GIR_RootConstrainSelectedInstOperands,
     /*  78512 */     // GIR_Coverage, 8514,
     /*  78512 */     GIR_EraseRootFromParent_Done,
     /*  78513 */   // Label 1066: @78513
     /*  78513 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(78578), // Rule ID 8220 //
     /*  78518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  78521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78525 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  78530 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  78535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  78539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  78547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  78554 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  78554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  78557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  78564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78576 */     GIR_RootConstrainSelectedInstOperands,
     /*  78577 */     // GIR_Coverage, 8220,
     /*  78577 */     GIR_EraseRootFromParent_Done,
     /*  78578 */   // Label 1067: @78578
     /*  78578 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(78638), // Rule ID 8152 //
     /*  78583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  78586 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78590 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  78595 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  78599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  78603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  78614 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  78614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  78617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  78624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78636 */     GIR_RootConstrainSelectedInstOperands,
     /*  78637 */     // GIR_Coverage, 8152,
     /*  78637 */     GIR_EraseRootFromParent_Done,
     /*  78638 */   // Label 1068: @78638
     /*  78638 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(78690), // Rule ID 8517 //
     /*  78643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  78666 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  78669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78688 */     GIR_RootConstrainSelectedInstOperands,
     /*  78689 */     // GIR_Coverage, 8517,
     /*  78689 */     GIR_EraseRootFromParent_Done,
     /*  78690 */   // Label 1069: @78690
     /*  78690 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(78745), // Rule ID 8518 //
     /*  78695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  78698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  78721 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  78721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  78724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78743 */     GIR_RootConstrainSelectedInstOperands,
     /*  78744 */     // GIR_Coverage, 8518,
     /*  78744 */     GIR_EraseRootFromParent_Done,
     /*  78745 */   // Label 1070: @78745
     /*  78745 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(78800), // Rule ID 8519 //
     /*  78750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  78753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78776 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  78776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  78779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78798 */     GIR_RootConstrainSelectedInstOperands,
     /*  78799 */     // GIR_Coverage, 8519,
     /*  78799 */     GIR_EraseRootFromParent_Done,
     /*  78800 */   // Label 1071: @78800
     /*  78800 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(78858), // Rule ID 8520 //
     /*  78805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  78808 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  78824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  78831 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  78831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  78834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  78836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  78841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  78846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78856 */     GIR_RootConstrainSelectedInstOperands,
     /*  78857 */     // GIR_Coverage, 8520,
     /*  78857 */     GIR_EraseRootFromParent_Done,
     /*  78858 */   // Label 1072: @78858
     /*  78858 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(78919), // Rule ID 8221 //
     /*  78863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  78866 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  78871 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  78876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  78880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  78888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  78895 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  78895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  78898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  78905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78917 */     GIR_RootConstrainSelectedInstOperands,
     /*  78918 */     // GIR_Coverage, 8221,
     /*  78918 */     GIR_EraseRootFromParent_Done,
     /*  78919 */   // Label 1073: @78919
     /*  78919 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(78975), // Rule ID 8153 //
     /*  78924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  78927 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  78932 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  78936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  78940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  78944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  78951 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  78951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  78954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  78956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  78961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  78966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  78973 */     GIR_RootConstrainSelectedInstOperands,
     /*  78974 */     // GIR_Coverage, 8153,
     /*  78974 */     GIR_EraseRootFromParent_Done,
     /*  78975 */   // Label 1074: @78975
     /*  78975 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(79026), // Rule ID 8511 //
     /*  78980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  78983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  78991 */     // MIs[0] sbase
     /*  78991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  78995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  78999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79003 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79007 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  79007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  79010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79012 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  79014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79024 */     GIR_RootConstrainSelectedInstOperands,
     /*  79025 */     // GIR_Coverage, 8511,
     /*  79025 */     GIR_EraseRootFromParent_Done,
     /*  79026 */   // Label 1075: @79026
     /*  79026 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(79073), // Rule ID 8516 //
     /*  79031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  79034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79042 */     // MIs[0] sbase
     /*  79042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  79046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  79050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79054 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  79054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  79057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79059 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  79061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79071 */     GIR_RootConstrainSelectedInstOperands,
     /*  79072 */     // GIR_Coverage, 8516,
     /*  79072 */     GIR_EraseRootFromParent_Done,
     /*  79073 */   // Label 1076: @79073
     /*  79073 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(79117), // Rule ID 8522 //
     /*  79078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  79086 */     // MIs[0] sbase
     /*  79086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  79090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  79094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79098 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  79098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  79101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79103 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  79105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79115 */     GIR_RootConstrainSelectedInstOperands,
     /*  79116 */     // GIR_Coverage, 8522,
     /*  79116 */     GIR_EraseRootFromParent_Done,
     /*  79117 */   // Label 1077: @79117
     /*  79117 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(79174), // Rule ID 4343 //
     /*  79122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  79125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  79130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  79145 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  79148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  79160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79172 */     GIR_RootConstrainSelectedInstOperands,
     /*  79173 */     // GIR_Coverage, 4343,
     /*  79173 */     GIR_EraseRootFromParent_Done,
     /*  79174 */   // Label 1078: @79174
     /*  79174 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(79226), // Rule ID 4342 //
     /*  79179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  79182 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  79187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  79202 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  79202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  79205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  79212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79224 */     GIR_RootConstrainSelectedInstOperands,
     /*  79225 */     // GIR_Coverage, 4342,
     /*  79225 */     GIR_EraseRootFromParent_Done,
     /*  79226 */   // Label 1079: @79226
     /*  79226 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(79278), // Rule ID 4341 //
     /*  79231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  79234 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  79239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  79254 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  79257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79276 */     GIR_RootConstrainSelectedInstOperands,
     /*  79277 */     // GIR_Coverage, 4341,
     /*  79277 */     GIR_EraseRootFromParent_Done,
     /*  79278 */   // Label 1080: @79278
     /*  79278 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(79345), // Rule ID 4567 //
     /*  79283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  79286 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  79308 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  79311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79343 */     GIR_RootConstrainSelectedInstOperands,
     /*  79344 */     // GIR_Coverage, 4567,
     /*  79344 */     GIR_EraseRootFromParent_Done,
     /*  79345 */   // Label 1081: @79345
     /*  79345 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(79409), // Rule ID 4569 //
     /*  79350 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  79372 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  79375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  79382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  79392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  79397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79407 */     GIR_RootConstrainSelectedInstOperands,
     /*  79408 */     // GIR_Coverage, 4569,
     /*  79408 */     GIR_EraseRootFromParent_Done,
     /*  79409 */   // Label 1082: @79409
     /*  79409 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(79470), // Rule ID 8096 //
     /*  79414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  79417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79421 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  79426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  79441 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  79441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  79444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  79451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  79456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  79461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79468 */     GIR_RootConstrainSelectedInstOperands,
     /*  79469 */     // GIR_Coverage, 8096,
     /*  79469 */     GIR_EraseRootFromParent_Done,
     /*  79470 */   // Label 1083: @79470
     /*  79470 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(79532), // Rule ID 4566 //
     /*  79475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  79478 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  79500 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  79503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79530 */     GIR_RootConstrainSelectedInstOperands,
     /*  79531 */     // GIR_Coverage, 4566,
     /*  79531 */     GIR_EraseRootFromParent_Done,
     /*  79532 */   // Label 1084: @79532
     /*  79532 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(79591), // Rule ID 4568 //
     /*  79537 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  79559 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  79559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  79562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  79564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  79569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79589 */     GIR_RootConstrainSelectedInstOperands,
     /*  79590 */     // GIR_Coverage, 4568,
     /*  79590 */     GIR_EraseRootFromParent_Done,
     /*  79591 */   // Label 1085: @79591
     /*  79591 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(79648), // Rule ID 8098 //
     /*  79596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  79599 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  79604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  79619 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  79619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  79622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  79629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  79634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  79639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79646 */     GIR_RootConstrainSelectedInstOperands,
     /*  79647 */     // GIR_Coverage, 8098,
     /*  79647 */     GIR_EraseRootFromParent_Done,
     /*  79648 */   // Label 1086: @79648
     /*  79648 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(79707), // Rule ID 3928 //
     /*  79653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  79656 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  79678 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  79681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  79688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  79693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79705 */     GIR_RootConstrainSelectedInstOperands,
     /*  79706 */     // GIR_Coverage, 3928,
     /*  79706 */     GIR_EraseRootFromParent_Done,
     /*  79707 */   // Label 1087: @79707
     /*  79707 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(79761), // Rule ID 3927 //
     /*  79712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  79715 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  79737 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  79740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79759 */     GIR_RootConstrainSelectedInstOperands,
     /*  79760 */     // GIR_Coverage, 3927,
     /*  79760 */     GIR_EraseRootFromParent_Done,
     /*  79761 */   // Label 1088: @79761
     /*  79761 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(79816), // Rule ID 3651 //
     /*  79766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  79769 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  79777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  79781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  79792 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  79792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  79795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  79797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  79802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  79807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79814 */     GIR_RootConstrainSelectedInstOperands,
     /*  79815 */     // GIR_Coverage, 3651,
     /*  79815 */     GIR_EraseRootFromParent_Done,
     /*  79816 */   // Label 1089: @79816
     /*  79816 */   GIM_Reject,
     /*  79817 */ // Label 1056: @79817
     /*  79817 */ GIM_Reject,
     /*  79818 */ // Label 999: @79818
     /*  79818 */ GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(81444),
     /*  79823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79826 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(79890), // Rule ID 2987 //
     /*  79831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  79834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  79842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79861 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  79864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79888 */     GIR_RootConstrainSelectedInstOperands,
     /*  79889 */     // GIR_Coverage, 2987,
     /*  79889 */     GIR_EraseRootFromParent_Done,
     /*  79890 */   // Label 1091: @79890
     /*  79890 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(79950), // Rule ID 2993 //
     /*  79895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  79898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  79906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  79921 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  79924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  79936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  79941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  79948 */     GIR_RootConstrainSelectedInstOperands,
     /*  79949 */     // GIR_Coverage, 2993,
     /*  79949 */     GIR_EraseRootFromParent_Done,
     /*  79950 */   // Label 1092: @79950
     /*  79950 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(80009), // Rule ID 2983 //
     /*  79955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  79958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  79966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  79970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  79974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  79978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  79985 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  79985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  79988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  79990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  79995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80007 */     GIR_RootConstrainSelectedInstOperands,
     /*  80008 */     // GIR_Coverage, 2983,
     /*  80008 */     GIR_EraseRootFromParent_Done,
     /*  80009 */   // Label 1093: @80009
     /*  80009 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(80068), // Rule ID 2984 //
     /*  80014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  80017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  80044 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  80047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80066 */     GIR_RootConstrainSelectedInstOperands,
     /*  80067 */     // GIR_Coverage, 2984,
     /*  80067 */     GIR_EraseRootFromParent_Done,
     /*  80068 */   // Label 1094: @80068
     /*  80068 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(80127), // Rule ID 2985 //
     /*  80073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  80076 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80088 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80103 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  80103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  80106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80125 */     GIR_RootConstrainSelectedInstOperands,
     /*  80126 */     // GIR_Coverage, 2985,
     /*  80126 */     GIR_EraseRootFromParent_Done,
     /*  80127 */   // Label 1095: @80127
     /*  80127 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(80189), // Rule ID 2986 //
     /*  80132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  80135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80162 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  80165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80187 */     GIR_RootConstrainSelectedInstOperands,
     /*  80188 */     // GIR_Coverage, 2986,
     /*  80188 */     GIR_EraseRootFromParent_Done,
     /*  80189 */   // Label 1096: @80189
     /*  80189 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(80241), // Rule ID 2989 //
     /*  80194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  80217 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  80220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80239 */     GIR_RootConstrainSelectedInstOperands,
     /*  80240 */     // GIR_Coverage, 2989,
     /*  80240 */     GIR_EraseRootFromParent_Done,
     /*  80241 */   // Label 1097: @80241
     /*  80241 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(80296), // Rule ID 2990 //
     /*  80246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  80249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  80272 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  80275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80294 */     GIR_RootConstrainSelectedInstOperands,
     /*  80295 */     // GIR_Coverage, 2990,
     /*  80295 */     GIR_EraseRootFromParent_Done,
     /*  80296 */   // Label 1098: @80296
     /*  80296 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(80351), // Rule ID 2991 //
     /*  80301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  80304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80327 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  80327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  80330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80349 */     GIR_RootConstrainSelectedInstOperands,
     /*  80350 */     // GIR_Coverage, 2991,
     /*  80350 */     GIR_EraseRootFromParent_Done,
     /*  80351 */   // Label 1099: @80351
     /*  80351 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(80409), // Rule ID 2992 //
     /*  80356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  80359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  80382 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  80385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  80392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80407 */     GIR_RootConstrainSelectedInstOperands,
     /*  80408 */     // GIR_Coverage, 2992,
     /*  80408 */     GIR_EraseRootFromParent_Done,
     /*  80409 */   // Label 1100: @80409
     /*  80409 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(80460), // Rule ID 2988 //
     /*  80414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  80417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80425 */     // MIs[0] sbase
     /*  80425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  80441 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  80444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80446 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80458 */     GIR_RootConstrainSelectedInstOperands,
     /*  80459 */     // GIR_Coverage, 2988,
     /*  80459 */     GIR_EraseRootFromParent_Done,
     /*  80460 */   // Label 1101: @80460
     /*  80460 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(80504), // Rule ID 2994 //
     /*  80465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  80473 */     // MIs[0] sbase
     /*  80473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  80477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  80481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  80485 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  80485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  80488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  80490 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  80492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80502 */     GIR_RootConstrainSelectedInstOperands,
     /*  80503 */     // GIR_Coverage, 2994,
     /*  80503 */     GIR_EraseRootFromParent_Done,
     /*  80504 */   // Label 1102: @80504
     /*  80504 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(80564), // Rule ID 6507 //
     /*  80509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  80512 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  80532 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  80532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  80535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  80537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  80542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  80552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80562 */     GIR_RootConstrainSelectedInstOperands,
     /*  80563 */     // GIR_Coverage, 6507,
     /*  80563 */     GIR_EraseRootFromParent_Done,
     /*  80564 */   // Label 1103: @80564
     /*  80564 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(80624), // Rule ID 6509 //
     /*  80569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  80572 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  80592 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  80592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  80595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  80597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  80602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  80607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  80612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80622 */     GIR_RootConstrainSelectedInstOperands,
     /*  80623 */     // GIR_Coverage, 6509,
     /*  80623 */     GIR_EraseRootFromParent_Done,
     /*  80624 */   // Label 1104: @80624
     /*  80624 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(80681), // Rule ID 4277 //
     /*  80629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  80632 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  80652 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  80652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  80655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  80662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  80667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  80672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80679 */     GIR_RootConstrainSelectedInstOperands,
     /*  80680 */     // GIR_Coverage, 4277,
     /*  80680 */     GIR_EraseRootFromParent_Done,
     /*  80681 */   // Label 1105: @80681
     /*  80681 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(80733), // Rule ID 4276 //
     /*  80686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  80689 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  80709 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  80709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  80712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  80719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80731 */     GIR_RootConstrainSelectedInstOperands,
     /*  80732 */     // GIR_Coverage, 4276,
     /*  80732 */     GIR_EraseRootFromParent_Done,
     /*  80733 */   // Label 1106: @80733
     /*  80733 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(80785), // Rule ID 4275 //
     /*  80738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  80741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  80761 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  80761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  80764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  80766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  80771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  80776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80783 */     GIR_RootConstrainSelectedInstOperands,
     /*  80784 */     // GIR_Coverage, 4275,
     /*  80784 */     GIR_EraseRootFromParent_Done,
     /*  80785 */   // Label 1107: @80785
     /*  80785 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(80852), // Rule ID 4523 //
     /*  80790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  80793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  80800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  80815 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  80815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  80818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  80820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  80825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  80830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  80835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  80840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80850 */     GIR_RootConstrainSelectedInstOperands,
     /*  80851 */     // GIR_Coverage, 4523,
     /*  80851 */     GIR_EraseRootFromParent_Done,
     /*  80852 */   // Label 1108: @80852
     /*  80852 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(80916), // Rule ID 4525 //
     /*  80857 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  80864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  80879 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  80879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  80882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  80884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  80889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  80894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  80899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  80904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80914 */     GIR_RootConstrainSelectedInstOperands,
     /*  80915 */     // GIR_Coverage, 4525,
     /*  80915 */     GIR_EraseRootFromParent_Done,
     /*  80916 */   // Label 1109: @80916
     /*  80916 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(80981), // Rule ID 6506 //
     /*  80921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  80924 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  80944 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  80944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  80947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  80949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  80954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  80959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  80964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  80969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  80979 */     GIR_RootConstrainSelectedInstOperands,
     /*  80980 */     // GIR_Coverage, 6506,
     /*  80980 */     GIR_EraseRootFromParent_Done,
     /*  80981 */   // Label 1110: @80981
     /*  80981 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(81046), // Rule ID 6508 //
     /*  80986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  80989 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  80994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  80998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  81009 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  81009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  81012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  81019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  81029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  81034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81044 */     GIR_RootConstrainSelectedInstOperands,
     /*  81045 */     // GIR_Coverage, 6508,
     /*  81045 */     GIR_EraseRootFromParent_Done,
     /*  81046 */   // Label 1111: @81046
     /*  81046 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(81108), // Rule ID 4522 //
     /*  81051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  81054 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  81065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  81076 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  81079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81106 */     GIR_RootConstrainSelectedInstOperands,
     /*  81107 */     // GIR_Coverage, 4522,
     /*  81107 */     GIR_EraseRootFromParent_Done,
     /*  81108 */   // Label 1112: @81108
     /*  81108 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(81167), // Rule ID 4524 //
     /*  81113 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  81124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  81135 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  81135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  81138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  81140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  81145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81165 */     GIR_RootConstrainSelectedInstOperands,
     /*  81166 */     // GIR_Coverage, 4524,
     /*  81166 */     GIR_EraseRootFromParent_Done,
     /*  81167 */   // Label 1113: @81167
     /*  81167 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(81223), // Rule ID 7966 //
     /*  81172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  81175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81179 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  81184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  81188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  81199 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  81199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  81202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  81209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81221 */     GIR_RootConstrainSelectedInstOperands,
     /*  81222 */     // GIR_Coverage, 7966,
     /*  81222 */     GIR_EraseRootFromParent_Done,
     /*  81223 */   // Label 1114: @81223
     /*  81223 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(81275), // Rule ID 7967 //
     /*  81228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  81231 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  81236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  81240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  81251 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  81251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  81254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  81261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81273 */     GIR_RootConstrainSelectedInstOperands,
     /*  81274 */     // GIR_Coverage, 7967,
     /*  81274 */     GIR_EraseRootFromParent_Done,
     /*  81275 */   // Label 1115: @81275
     /*  81275 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(81334), // Rule ID 3884 //
     /*  81280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  81283 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  81294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  81305 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  81308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  81315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  81320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81332 */     GIR_RootConstrainSelectedInstOperands,
     /*  81333 */     // GIR_Coverage, 3884,
     /*  81333 */     GIR_EraseRootFromParent_Done,
     /*  81334 */   // Label 1116: @81334
     /*  81334 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(81388), // Rule ID 3883 //
     /*  81339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  81342 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  81353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  81364 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  81364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  81367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  81374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81386 */     GIR_RootConstrainSelectedInstOperands,
     /*  81387 */     // GIR_Coverage, 3883,
     /*  81387 */     GIR_EraseRootFromParent_Done,
     /*  81388 */   // Label 1117: @81388
     /*  81388 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(81443), // Rule ID 3628 //
     /*  81393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  81396 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  81404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  81408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  81419 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  81419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  81422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  81424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  81429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81441 */     GIR_RootConstrainSelectedInstOperands,
     /*  81442 */     // GIR_Coverage, 3628,
     /*  81442 */     GIR_EraseRootFromParent_Done,
     /*  81443 */   // Label 1118: @81443
     /*  81443 */   GIM_Reject,
     /*  81444 */ // Label 1090: @81444
     /*  81444 */ GIM_Reject,
     /*  81445 */ // Label 1000: @81445
     /*  81445 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(83071),
     /*  81450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81453 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(81517), // Rule ID 2999 //
     /*  81458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  81461 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  81488 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81515 */     GIR_RootConstrainSelectedInstOperands,
     /*  81516 */     // GIR_Coverage, 2999,
     /*  81516 */     GIR_EraseRootFromParent_Done,
     /*  81517 */   // Label 1120: @81517
     /*  81517 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(81577), // Rule ID 3005 //
     /*  81522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  81525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  81548 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  81568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81575 */     GIR_RootConstrainSelectedInstOperands,
     /*  81576 */     // GIR_Coverage, 3005,
     /*  81576 */     GIR_EraseRootFromParent_Done,
     /*  81577 */   // Label 1121: @81577
     /*  81577 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(81636), // Rule ID 2995 //
     /*  81582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  81585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  81612 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  81615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81634 */     GIR_RootConstrainSelectedInstOperands,
     /*  81635 */     // GIR_Coverage, 2995,
     /*  81635 */     GIR_EraseRootFromParent_Done,
     /*  81636 */   // Label 1122: @81636
     /*  81636 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(81695), // Rule ID 2996 //
     /*  81641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  81644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  81671 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  81674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81693 */     GIR_RootConstrainSelectedInstOperands,
     /*  81694 */     // GIR_Coverage, 2996,
     /*  81694 */     GIR_EraseRootFromParent_Done,
     /*  81695 */   // Label 1123: @81695
     /*  81695 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(81754), // Rule ID 2997 //
     /*  81700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  81703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81730 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  81730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  81733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81752 */     GIR_RootConstrainSelectedInstOperands,
     /*  81753 */     // GIR_Coverage, 2997,
     /*  81753 */     GIR_EraseRootFromParent_Done,
     /*  81754 */   // Label 1124: @81754
     /*  81754 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(81816), // Rule ID 2998 //
     /*  81759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  81762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  81782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81789 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  81789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  81792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81814 */     GIR_RootConstrainSelectedInstOperands,
     /*  81815 */     // GIR_Coverage, 2998,
     /*  81815 */     GIR_EraseRootFromParent_Done,
     /*  81816 */   // Label 1125: @81816
     /*  81816 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(81868), // Rule ID 3001 //
     /*  81821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  81844 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  81847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81866 */     GIR_RootConstrainSelectedInstOperands,
     /*  81867 */     // GIR_Coverage, 3001,
     /*  81867 */     GIR_EraseRootFromParent_Done,
     /*  81868 */   // Label 1126: @81868
     /*  81868 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(81923), // Rule ID 3002 //
     /*  81873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  81876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  81899 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  81899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  81902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  81914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81921 */     GIR_RootConstrainSelectedInstOperands,
     /*  81922 */     // GIR_Coverage, 3002,
     /*  81922 */     GIR_EraseRootFromParent_Done,
     /*  81923 */   // Label 1127: @81923
     /*  81923 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(81978), // Rule ID 3003 //
     /*  81928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  81931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  81947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  81954 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  81954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  81957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  81959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  81964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  81969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81976 */     GIR_RootConstrainSelectedInstOperands,
     /*  81977 */     // GIR_Coverage, 3003,
     /*  81977 */     GIR_EraseRootFromParent_Done,
     /*  81978 */   // Label 1128: @81978
     /*  81978 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(82036), // Rule ID 3004 //
     /*  81983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  81986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  81994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  82009 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  82012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  82019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82034 */     GIR_RootConstrainSelectedInstOperands,
     /*  82035 */     // GIR_Coverage, 3004,
     /*  82035 */     GIR_EraseRootFromParent_Done,
     /*  82036 */   // Label 1129: @82036
     /*  82036 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(82087), // Rule ID 3000 //
     /*  82041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  82044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82052 */     // MIs[0] sbase
     /*  82052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  82056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  82060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  82068 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  82071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82073 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  82075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82085 */     GIR_RootConstrainSelectedInstOperands,
     /*  82086 */     // GIR_Coverage, 3000,
     /*  82086 */     GIR_EraseRootFromParent_Done,
     /*  82087 */   // Label 1130: @82087
     /*  82087 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(82131), // Rule ID 3006 //
     /*  82092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  82100 */     // MIs[0] sbase
     /*  82100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  82104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  82108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  82112 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  82112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  82115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  82117 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  82119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82129 */     GIR_RootConstrainSelectedInstOperands,
     /*  82130 */     // GIR_Coverage, 3006,
     /*  82130 */     GIR_EraseRootFromParent_Done,
     /*  82131 */   // Label 1131: @82131
     /*  82131 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(82191), // Rule ID 6511 //
     /*  82136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  82139 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  82159 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  82162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82189 */     GIR_RootConstrainSelectedInstOperands,
     /*  82190 */     // GIR_Coverage, 6511,
     /*  82190 */     GIR_EraseRootFromParent_Done,
     /*  82191 */   // Label 1132: @82191
     /*  82191 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(82251), // Rule ID 6513 //
     /*  82196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  82199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  82219 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  82222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82249 */     GIR_RootConstrainSelectedInstOperands,
     /*  82250 */     // GIR_Coverage, 6513,
     /*  82250 */     GIR_EraseRootFromParent_Done,
     /*  82251 */   // Label 1133: @82251
     /*  82251 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(82308), // Rule ID 4283 //
     /*  82256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  82259 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  82279 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  82279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  82282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  82289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  82294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82306 */     GIR_RootConstrainSelectedInstOperands,
     /*  82307 */     // GIR_Coverage, 4283,
     /*  82307 */     GIR_EraseRootFromParent_Done,
     /*  82308 */   // Label 1134: @82308
     /*  82308 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(82360), // Rule ID 4282 //
     /*  82313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  82316 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  82336 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  82336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  82339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  82346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82358 */     GIR_RootConstrainSelectedInstOperands,
     /*  82359 */     // GIR_Coverage, 4282,
     /*  82359 */     GIR_EraseRootFromParent_Done,
     /*  82360 */   // Label 1135: @82360
     /*  82360 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(82412), // Rule ID 4281 //
     /*  82365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  82368 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  82388 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  82388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  82391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  82398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82410 */     GIR_RootConstrainSelectedInstOperands,
     /*  82411 */     // GIR_Coverage, 4281,
     /*  82411 */     GIR_EraseRootFromParent_Done,
     /*  82412 */   // Label 1136: @82412
     /*  82412 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(82479), // Rule ID 4527 //
     /*  82417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  82420 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  82442 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  82445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82477 */     GIR_RootConstrainSelectedInstOperands,
     /*  82478 */     // GIR_Coverage, 4527,
     /*  82478 */     GIR_EraseRootFromParent_Done,
     /*  82479 */   // Label 1137: @82479
     /*  82479 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(82543), // Rule ID 4529 //
     /*  82484 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  82506 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  82509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82541 */     GIR_RootConstrainSelectedInstOperands,
     /*  82542 */     // GIR_Coverage, 4529,
     /*  82542 */     GIR_EraseRootFromParent_Done,
     /*  82543 */   // Label 1138: @82543
     /*  82543 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(82608), // Rule ID 6510 //
     /*  82548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  82551 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  82571 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  82574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82606 */     GIR_RootConstrainSelectedInstOperands,
     /*  82607 */     // GIR_Coverage, 6510,
     /*  82607 */     GIR_EraseRootFromParent_Done,
     /*  82608 */   // Label 1139: @82608
     /*  82608 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(82673), // Rule ID 6512 //
     /*  82613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  82616 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  82621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  82636 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  82636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  82639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  82646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  82656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  82661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82671 */     GIR_RootConstrainSelectedInstOperands,
     /*  82672 */     // GIR_Coverage, 6512,
     /*  82672 */     GIR_EraseRootFromParent_Done,
     /*  82673 */   // Label 1140: @82673
     /*  82673 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(82735), // Rule ID 4526 //
     /*  82678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  82681 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  82703 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  82706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82733 */     GIR_RootConstrainSelectedInstOperands,
     /*  82734 */     // GIR_Coverage, 4526,
     /*  82734 */     GIR_EraseRootFromParent_Done,
     /*  82735 */   // Label 1141: @82735
     /*  82735 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(82794), // Rule ID 4528 //
     /*  82740 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  82762 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  82762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  82765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  82767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  82772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  82777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82792 */     GIR_RootConstrainSelectedInstOperands,
     /*  82793 */     // GIR_Coverage, 4528,
     /*  82793 */     GIR_EraseRootFromParent_Done,
     /*  82794 */   // Label 1142: @82794
     /*  82794 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(82850), // Rule ID 7968 //
     /*  82799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  82802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82806 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  82811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  82826 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  82826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  82829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  82836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82848 */     GIR_RootConstrainSelectedInstOperands,
     /*  82849 */     // GIR_Coverage, 7968,
     /*  82849 */     GIR_EraseRootFromParent_Done,
     /*  82850 */   // Label 1143: @82850
     /*  82850 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(82902), // Rule ID 7969 //
     /*  82855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  82858 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  82863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  82878 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  82878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  82881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  82888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  82893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82900 */     GIR_RootConstrainSelectedInstOperands,
     /*  82901 */     // GIR_Coverage, 7969,
     /*  82901 */     GIR_EraseRootFromParent_Done,
     /*  82902 */   // Label 1144: @82902
     /*  82902 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(82961), // Rule ID 3888 //
     /*  82907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  82910 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  82932 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  82932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  82935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  82942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  82947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  82952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82959 */     GIR_RootConstrainSelectedInstOperands,
     /*  82960 */     // GIR_Coverage, 3888,
     /*  82960 */     GIR_EraseRootFromParent_Done,
     /*  82961 */   // Label 1145: @82961
     /*  82961 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(83015), // Rule ID 3887 //
     /*  82966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  82969 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  82976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  82980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  82991 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  82991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  82994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  82996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  83001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83013 */     GIR_RootConstrainSelectedInstOperands,
     /*  83014 */     // GIR_Coverage, 3887,
     /*  83014 */     GIR_EraseRootFromParent_Done,
     /*  83015 */   // Label 1146: @83015
     /*  83015 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(83070), // Rule ID 3630 //
     /*  83020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  83023 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  83031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  83035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  83046 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  83046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  83049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  83056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83068 */     GIR_RootConstrainSelectedInstOperands,
     /*  83069 */     // GIR_Coverage, 3630,
     /*  83069 */     GIR_EraseRootFromParent_Done,
     /*  83070 */   // Label 1147: @83070
     /*  83070 */   GIM_Reject,
     /*  83071 */ // Label 1119: @83071
     /*  83071 */ GIM_Reject,
     /*  83072 */ // Label 1001: @83072
     /*  83072 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(84975),
     /*  83077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83080 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(83144), // Rule ID 8527 //
     /*  83085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83088 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  83115 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  83118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83142 */     GIR_RootConstrainSelectedInstOperands,
     /*  83143 */     // GIR_Coverage, 8527,
     /*  83143 */     GIR_EraseRootFromParent_Done,
     /*  83144 */   // Label 1149: @83144
     /*  83144 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(83204), // Rule ID 8532 //
     /*  83149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  83175 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  83178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83202 */     GIR_RootConstrainSelectedInstOperands,
     /*  83203 */     // GIR_Coverage, 8532,
     /*  83203 */     GIR_EraseRootFromParent_Done,
     /*  83204 */   // Label 1150: @83204
     /*  83204 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(83264), // Rule ID 8538 //
     /*  83209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  83212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  83235 */     // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  83238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  83255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83262 */     GIR_RootConstrainSelectedInstOperands,
     /*  83263 */     // GIR_Coverage, 8538,
     /*  83263 */     GIR_EraseRootFromParent_Done,
     /*  83264 */   // Label 1151: @83264
     /*  83264 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(83323), // Rule ID 8523 //
     /*  83269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  83272 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  83299 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  83302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83321 */     GIR_RootConstrainSelectedInstOperands,
     /*  83322 */     // GIR_Coverage, 8523,
     /*  83322 */     GIR_EraseRootFromParent_Done,
     /*  83323 */   // Label 1152: @83323
     /*  83323 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(83382), // Rule ID 8524 //
     /*  83328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  83331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  83358 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  83361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83380 */     GIR_RootConstrainSelectedInstOperands,
     /*  83381 */     // GIR_Coverage, 8524,
     /*  83381 */     GIR_EraseRootFromParent_Done,
     /*  83382 */   // Label 1153: @83382
     /*  83382 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(83441), // Rule ID 8525 //
     /*  83387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  83390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83417 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  83417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  83420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83439 */     GIR_RootConstrainSelectedInstOperands,
     /*  83440 */     // GIR_Coverage, 8525,
     /*  83440 */     GIR_EraseRootFromParent_Done,
     /*  83441 */   // Label 1154: @83441
     /*  83441 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(83503), // Rule ID 8526 //
     /*  83446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83449 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  83469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83476 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  83479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83501 */     GIR_RootConstrainSelectedInstOperands,
     /*  83502 */     // GIR_Coverage, 8526,
     /*  83502 */     GIR_EraseRootFromParent_Done,
     /*  83503 */   // Label 1155: @83503
     /*  83503 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(83558), // Rule ID 8529 //
     /*  83508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  83511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  83534 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  83537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83556 */     GIR_RootConstrainSelectedInstOperands,
     /*  83557 */     // GIR_Coverage, 8529,
     /*  83557 */     GIR_EraseRootFromParent_Done,
     /*  83558 */   // Label 1156: @83558
     /*  83558 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(83613), // Rule ID 8530 //
     /*  83563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  83566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83589 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  83589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /*  83592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83611 */     GIR_RootConstrainSelectedInstOperands,
     /*  83612 */     // GIR_Coverage, 8530,
     /*  83612 */     GIR_EraseRootFromParent_Done,
     /*  83613 */   // Label 1157: @83613
     /*  83613 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(83671), // Rule ID 8531 //
     /*  83618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  83621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83644 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /*  83647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83669 */     GIR_RootConstrainSelectedInstOperands,
     /*  83670 */     // GIR_Coverage, 8531,
     /*  83670 */     GIR_EraseRootFromParent_Done,
     /*  83671 */   // Label 1158: @83671
     /*  83671 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(83736), // Rule ID 8224 //
     /*  83676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /*  83679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83683 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  83688 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  83693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  83697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /*  83705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  83712 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  83712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  83715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  83722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83734 */     GIR_RootConstrainSelectedInstOperands,
     /*  83735 */     // GIR_Coverage, 8224,
     /*  83735 */     GIR_EraseRootFromParent_Done,
     /*  83736 */   // Label 1159: @83736
     /*  83736 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(83796), // Rule ID 8156 //
     /*  83741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  83744 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83748 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  83753 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  83757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  83761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  83772 */     // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  83772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /*  83775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  83777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  83782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83794 */     GIR_RootConstrainSelectedInstOperands,
     /*  83795 */     // GIR_Coverage, 8156,
     /*  83795 */     GIR_EraseRootFromParent_Done,
     /*  83796 */   // Label 1160: @83796
     /*  83796 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(83848), // Rule ID 8534 //
     /*  83801 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  83824 */     // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  83827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83846 */     GIR_RootConstrainSelectedInstOperands,
     /*  83847 */     // GIR_Coverage, 8534,
     /*  83847 */     GIR_EraseRootFromParent_Done,
     /*  83848 */   // Label 1161: @83848
     /*  83848 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(83903), // Rule ID 8535 //
     /*  83853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  83856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  83879 */     // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  83879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  83882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  83894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83901 */     GIR_RootConstrainSelectedInstOperands,
     /*  83902 */     // GIR_Coverage, 8535,
     /*  83902 */     GIR_EraseRootFromParent_Done,
     /*  83903 */   // Label 1162: @83903
     /*  83903 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(83958), // Rule ID 8536 //
     /*  83908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  83911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83934 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  83934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  83937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  83949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83956 */     GIR_RootConstrainSelectedInstOperands,
     /*  83957 */     // GIR_Coverage, 8536,
     /*  83957 */     GIR_EraseRootFromParent_Done,
     /*  83958 */   // Label 1163: @83958
     /*  83958 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(84016), // Rule ID 8537 //
     /*  83963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  83966 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  83974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  83982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  83989 */     // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  83989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  83992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  83994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  83999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84014 */     GIR_RootConstrainSelectedInstOperands,
     /*  84015 */     // GIR_Coverage, 8537,
     /*  84015 */     GIR_EraseRootFromParent_Done,
     /*  84016 */   // Label 1164: @84016
     /*  84016 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(84077), // Rule ID 8225 //
     /*  84021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /*  84024 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84029 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /*  84046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  84053 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  84053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  84056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84075 */     GIR_RootConstrainSelectedInstOperands,
     /*  84076 */     // GIR_Coverage, 8225,
     /*  84076 */     GIR_EraseRootFromParent_Done,
     /*  84077 */   // Label 1165: @84077
     /*  84077 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(84133), // Rule ID 8157 //
     /*  84082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  84085 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84090 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /*  84094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  84109 */     // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  84109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /*  84112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84131 */     GIR_RootConstrainSelectedInstOperands,
     /*  84132 */     // GIR_Coverage, 8157,
     /*  84132 */     GIR_EraseRootFromParent_Done,
     /*  84133 */   // Label 1166: @84133
     /*  84133 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(84184), // Rule ID 8528 //
     /*  84138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  84141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84149 */     // MIs[0] sbase
     /*  84149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  84153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  84157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  84161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  84165 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  84165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  84168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84170 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  84172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84182 */     GIR_RootConstrainSelectedInstOperands,
     /*  84183 */     // GIR_Coverage, 8528,
     /*  84183 */     GIR_EraseRootFromParent_Done,
     /*  84184 */   // Label 1167: @84184
     /*  84184 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(84231), // Rule ID 8533 //
     /*  84189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  84192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84200 */     // MIs[0] sbase
     /*  84200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  84204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  84208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  84212 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  84212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /*  84215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84217 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  84219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84229 */     GIR_RootConstrainSelectedInstOperands,
     /*  84230 */     // GIR_Coverage, 8533,
     /*  84230 */     GIR_EraseRootFromParent_Done,
     /*  84231 */   // Label 1168: @84231
     /*  84231 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(84275), // Rule ID 8539 //
     /*  84236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  84244 */     // MIs[0] sbase
     /*  84244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  84248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  84252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  84256 */     // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  84256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  84259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  84261 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  84263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84273 */     GIR_RootConstrainSelectedInstOperands,
     /*  84274 */     // GIR_Coverage, 8539,
     /*  84274 */     GIR_EraseRootFromParent_Done,
     /*  84275 */   // Label 1169: @84275
     /*  84275 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(84332), // Rule ID 4349 //
     /*  84280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  84283 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  84303 */     // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /*  84306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  84318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84330 */     GIR_RootConstrainSelectedInstOperands,
     /*  84331 */     // GIR_Coverage, 4349,
     /*  84331 */     GIR_EraseRootFromParent_Done,
     /*  84332 */   // Label 1170: @84332
     /*  84332 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(84384), // Rule ID 4348 //
     /*  84337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  84340 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  84360 */     // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  84360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /*  84363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  84370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84382 */     GIR_RootConstrainSelectedInstOperands,
     /*  84383 */     // GIR_Coverage, 4348,
     /*  84383 */     GIR_EraseRootFromParent_Done,
     /*  84384 */   // Label 1171: @84384
     /*  84384 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(84436), // Rule ID 4347 //
     /*  84389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  84392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  84397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  84412 */     // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /*  84415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84434 */     GIR_RootConstrainSelectedInstOperands,
     /*  84435 */     // GIR_Coverage, 4347,
     /*  84435 */     GIR_EraseRootFromParent_Done,
     /*  84436 */   // Label 1172: @84436
     /*  84436 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(84503), // Rule ID 4571 //
     /*  84441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  84444 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  84466 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84501 */     GIR_RootConstrainSelectedInstOperands,
     /*  84502 */     // GIR_Coverage, 4571,
     /*  84502 */     GIR_EraseRootFromParent_Done,
     /*  84503 */   // Label 1173: @84503
     /*  84503 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(84567), // Rule ID 4573 //
     /*  84508 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  84530 */     // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /*  84533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  84540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  84550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  84555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84565 */     GIR_RootConstrainSelectedInstOperands,
     /*  84566 */     // GIR_Coverage, 4573,
     /*  84566 */     GIR_EraseRootFromParent_Done,
     /*  84567 */   // Label 1174: @84567
     /*  84567 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(84628), // Rule ID 8100 //
     /*  84572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /*  84575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84579 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  84599 */     // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  84599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /*  84602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  84614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  84619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84626 */     GIR_RootConstrainSelectedInstOperands,
     /*  84627 */     // GIR_Coverage, 8100,
     /*  84627 */     GIR_EraseRootFromParent_Done,
     /*  84628 */   // Label 1175: @84628
     /*  84628 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(84690), // Rule ID 4570 //
     /*  84633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  84636 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  84658 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /*  84661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84688 */     GIR_RootConstrainSelectedInstOperands,
     /*  84689 */     // GIR_Coverage, 4570,
     /*  84689 */     GIR_EraseRootFromParent_Done,
     /*  84690 */   // Label 1176: @84690
     /*  84690 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(84749), // Rule ID 4572 //
     /*  84695 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  84717 */     // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  84717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /*  84720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  84722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  84727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  84732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84747 */     GIR_RootConstrainSelectedInstOperands,
     /*  84748 */     // GIR_Coverage, 4572,
     /*  84748 */     GIR_EraseRootFromParent_Done,
     /*  84749 */   // Label 1177: @84749
     /*  84749 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(84806), // Rule ID 8102 //
     /*  84754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  84757 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  84762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /*  84777 */     // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /*  84777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /*  84780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  84787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /*  84792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /*  84797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84804 */     GIR_RootConstrainSelectedInstOperands,
     /*  84805 */     // GIR_Coverage, 8102,
     /*  84805 */     GIR_EraseRootFromParent_Done,
     /*  84806 */   // Label 1178: @84806
     /*  84806 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(84865), // Rule ID 3932 //
     /*  84811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  84814 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  84836 */     // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  84836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /*  84839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  84846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  84851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  84856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84863 */     GIR_RootConstrainSelectedInstOperands,
     /*  84864 */     // GIR_Coverage, 3932,
     /*  84864 */     GIR_EraseRootFromParent_Done,
     /*  84865 */   // Label 1179: @84865
     /*  84865 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(84919), // Rule ID 3931 //
     /*  84870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  84873 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  84895 */     // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /*  84898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84917 */     GIR_RootConstrainSelectedInstOperands,
     /*  84918 */     // GIR_Coverage, 3931,
     /*  84918 */     GIR_EraseRootFromParent_Done,
     /*  84919 */   // Label 1180: @84919
     /*  84919 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(84974), // Rule ID 3653 //
     /*  84924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  84927 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  84935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /*  84939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  84950 */     // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  84950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /*  84953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  84955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  84960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  84965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84972 */     GIR_RootConstrainSelectedInstOperands,
     /*  84973 */     // GIR_Coverage, 3653,
     /*  84973 */     GIR_EraseRootFromParent_Done,
     /*  84974 */   // Label 1181: @84974
     /*  84974 */   GIM_Reject,
     /*  84975 */ // Label 1148: @84975
     /*  84975 */ GIM_Reject,
     /*  84976 */ // Label 1002: @84976
     /*  84976 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(86602),
     /*  84981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84984 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(85048), // Rule ID 3011 //
     /*  84989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  84992 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  85019 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  85022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85046 */     GIR_RootConstrainSelectedInstOperands,
     /*  85047 */     // GIR_Coverage, 3011,
     /*  85047 */     GIR_EraseRootFromParent_Done,
     /*  85048 */   // Label 1183: @85048
     /*  85048 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(85108), // Rule ID 3017 //
     /*  85053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  85056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  85079 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  85082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85106 */     GIR_RootConstrainSelectedInstOperands,
     /*  85107 */     // GIR_Coverage, 3017,
     /*  85107 */     GIR_EraseRootFromParent_Done,
     /*  85108 */   // Label 1184: @85108
     /*  85108 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(85167), // Rule ID 3007 //
     /*  85113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  85116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  85143 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  85146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85165 */     GIR_RootConstrainSelectedInstOperands,
     /*  85166 */     // GIR_Coverage, 3007,
     /*  85166 */     GIR_EraseRootFromParent_Done,
     /*  85167 */   // Label 1185: @85167
     /*  85167 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(85226), // Rule ID 3008 //
     /*  85172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  85175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  85202 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  85205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85224 */     GIR_RootConstrainSelectedInstOperands,
     /*  85225 */     // GIR_Coverage, 3008,
     /*  85225 */     GIR_EraseRootFromParent_Done,
     /*  85226 */   // Label 1186: @85226
     /*  85226 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(85285), // Rule ID 3009 //
     /*  85231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  85234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85261 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  85261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  85264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85283 */     GIR_RootConstrainSelectedInstOperands,
     /*  85284 */     // GIR_Coverage, 3009,
     /*  85284 */     GIR_EraseRootFromParent_Done,
     /*  85285 */   // Label 1187: @85285
     /*  85285 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(85347), // Rule ID 3010 //
     /*  85290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  85293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85320 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  85323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85345 */     GIR_RootConstrainSelectedInstOperands,
     /*  85346 */     // GIR_Coverage, 3010,
     /*  85346 */     GIR_EraseRootFromParent_Done,
     /*  85347 */   // Label 1188: @85347
     /*  85347 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(85399), // Rule ID 3013 //
     /*  85352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  85375 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  85378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85397 */     GIR_RootConstrainSelectedInstOperands,
     /*  85398 */     // GIR_Coverage, 3013,
     /*  85398 */     GIR_EraseRootFromParent_Done,
     /*  85399 */   // Label 1189: @85399
     /*  85399 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(85454), // Rule ID 3014 //
     /*  85404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  85407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  85430 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  85433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85452 */     GIR_RootConstrainSelectedInstOperands,
     /*  85453 */     // GIR_Coverage, 3014,
     /*  85453 */     GIR_EraseRootFromParent_Done,
     /*  85454 */   // Label 1190: @85454
     /*  85454 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(85509), // Rule ID 3015 //
     /*  85459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  85462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85485 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  85485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  85488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85507 */     GIR_RootConstrainSelectedInstOperands,
     /*  85508 */     // GIR_Coverage, 3015,
     /*  85508 */     GIR_EraseRootFromParent_Done,
     /*  85509 */   // Label 1191: @85509
     /*  85509 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(85567), // Rule ID 3016 //
     /*  85514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  85517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  85540 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  85543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  85550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85565 */     GIR_RootConstrainSelectedInstOperands,
     /*  85566 */     // GIR_Coverage, 3016,
     /*  85566 */     GIR_EraseRootFromParent_Done,
     /*  85567 */   // Label 1192: @85567
     /*  85567 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(85618), // Rule ID 3012 //
     /*  85572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  85575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85583 */     // MIs[0] sbase
     /*  85583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  85587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  85591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  85599 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  85602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85604 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  85606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85616 */     GIR_RootConstrainSelectedInstOperands,
     /*  85617 */     // GIR_Coverage, 3012,
     /*  85617 */     GIR_EraseRootFromParent_Done,
     /*  85618 */   // Label 1193: @85618
     /*  85618 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(85662), // Rule ID 3018 //
     /*  85623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  85631 */     // MIs[0] sbase
     /*  85631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  85635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  85639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  85643 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  85643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  85646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  85648 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  85650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85660 */     GIR_RootConstrainSelectedInstOperands,
     /*  85661 */     // GIR_Coverage, 3018,
     /*  85661 */     GIR_EraseRootFromParent_Done,
     /*  85662 */   // Label 1194: @85662
     /*  85662 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(85722), // Rule ID 6515 //
     /*  85667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  85670 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85690 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  85693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85720 */     GIR_RootConstrainSelectedInstOperands,
     /*  85721 */     // GIR_Coverage, 6515,
     /*  85721 */     GIR_EraseRootFromParent_Done,
     /*  85722 */   // Label 1195: @85722
     /*  85722 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(85782), // Rule ID 6517 //
     /*  85727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  85730 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  85750 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  85750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  85753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  85765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85780 */     GIR_RootConstrainSelectedInstOperands,
     /*  85781 */     // GIR_Coverage, 6517,
     /*  85781 */     GIR_EraseRootFromParent_Done,
     /*  85782 */   // Label 1196: @85782
     /*  85782 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(85839), // Rule ID 4289 //
     /*  85787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  85790 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  85810 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  85810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  85813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  85825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  85830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85837 */     GIR_RootConstrainSelectedInstOperands,
     /*  85838 */     // GIR_Coverage, 4289,
     /*  85838 */     GIR_EraseRootFromParent_Done,
     /*  85839 */   // Label 1197: @85839
     /*  85839 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(85891), // Rule ID 4288 //
     /*  85844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  85847 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  85867 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  85867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  85870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  85877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85889 */     GIR_RootConstrainSelectedInstOperands,
     /*  85890 */     // GIR_Coverage, 4288,
     /*  85890 */     GIR_EraseRootFromParent_Done,
     /*  85891 */   // Label 1198: @85891
     /*  85891 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(85943), // Rule ID 4287 //
     /*  85896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  85899 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  85904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  85919 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  85919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  85922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  85924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  85929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  85934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85941 */     GIR_RootConstrainSelectedInstOperands,
     /*  85942 */     // GIR_Coverage, 4287,
     /*  85942 */     GIR_EraseRootFromParent_Done,
     /*  85943 */   // Label 1199: @85943
     /*  85943 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(86010), // Rule ID 4531 //
     /*  85948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  85951 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  85958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  85962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  85973 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  85973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  85976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  85978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  85983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  85988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  85993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  85998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86008 */     GIR_RootConstrainSelectedInstOperands,
     /*  86009 */     // GIR_Coverage, 4531,
     /*  86009 */     GIR_EraseRootFromParent_Done,
     /*  86010 */   // Label 1200: @86010
     /*  86010 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(86074), // Rule ID 4533 //
     /*  86015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  86037 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  86040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86072 */     GIR_RootConstrainSelectedInstOperands,
     /*  86073 */     // GIR_Coverage, 4533,
     /*  86073 */     GIR_EraseRootFromParent_Done,
     /*  86074 */   // Label 1201: @86074
     /*  86074 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(86139), // Rule ID 6514 //
     /*  86079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  86082 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  86102 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  86102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  86105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86137 */     GIR_RootConstrainSelectedInstOperands,
     /*  86138 */     // GIR_Coverage, 6514,
     /*  86138 */     GIR_EraseRootFromParent_Done,
     /*  86139 */   // Label 1202: @86139
     /*  86139 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(86204), // Rule ID 6516 //
     /*  86144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  86147 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  86152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  86167 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  86167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  86170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  86177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  86187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  86192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86202 */     GIR_RootConstrainSelectedInstOperands,
     /*  86203 */     // GIR_Coverage, 6516,
     /*  86203 */     GIR_EraseRootFromParent_Done,
     /*  86204 */   // Label 1203: @86204
     /*  86204 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(86266), // Rule ID 4530 //
     /*  86209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  86212 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  86234 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  86237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  86249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86264 */     GIR_RootConstrainSelectedInstOperands,
     /*  86265 */     // GIR_Coverage, 4530,
     /*  86265 */     GIR_EraseRootFromParent_Done,
     /*  86266 */   // Label 1204: @86266
     /*  86266 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(86325), // Rule ID 4532 //
     /*  86271 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  86293 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  86293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  86296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  86298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  86303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  86308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86323 */     GIR_RootConstrainSelectedInstOperands,
     /*  86324 */     // GIR_Coverage, 4532,
     /*  86324 */     GIR_EraseRootFromParent_Done,
     /*  86325 */   // Label 1205: @86325
     /*  86325 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(86381), // Rule ID 7970 //
     /*  86330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  86333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86337 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  86342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  86357 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  86357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  86360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  86367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86379 */     GIR_RootConstrainSelectedInstOperands,
     /*  86380 */     // GIR_Coverage, 7970,
     /*  86380 */     GIR_EraseRootFromParent_Done,
     /*  86381 */   // Label 1206: @86381
     /*  86381 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(86433), // Rule ID 7971 //
     /*  86386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  86389 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  86394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  86409 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  86409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  86412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  86419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86431 */     GIR_RootConstrainSelectedInstOperands,
     /*  86432 */     // GIR_Coverage, 7971,
     /*  86432 */     GIR_EraseRootFromParent_Done,
     /*  86433 */   // Label 1207: @86433
     /*  86433 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(86492), // Rule ID 3892 //
     /*  86438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  86441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  86463 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  86466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  86473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  86478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86490 */     GIR_RootConstrainSelectedInstOperands,
     /*  86491 */     // GIR_Coverage, 3892,
     /*  86491 */     GIR_EraseRootFromParent_Done,
     /*  86492 */   // Label 1208: @86492
     /*  86492 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(86546), // Rule ID 3891 //
     /*  86497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  86500 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  86522 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  86525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86544 */     GIR_RootConstrainSelectedInstOperands,
     /*  86545 */     // GIR_Coverage, 3891,
     /*  86545 */     GIR_EraseRootFromParent_Done,
     /*  86546 */   // Label 1209: @86546
     /*  86546 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(86601), // Rule ID 3632 //
     /*  86551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  86554 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  86562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  86566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  86577 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  86577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  86580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  86582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  86587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86599 */     GIR_RootConstrainSelectedInstOperands,
     /*  86600 */     // GIR_Coverage, 3632,
     /*  86600 */     GIR_EraseRootFromParent_Done,
     /*  86601 */   // Label 1210: @86601
     /*  86601 */   GIM_Reject,
     /*  86602 */ // Label 1182: @86602
     /*  86602 */ GIM_Reject,
     /*  86603 */ // Label 1003: @86603
     /*  86603 */ GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(88229),
     /*  86608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86611 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(86675), // Rule ID 3023 //
     /*  86616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  86619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  86627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  86635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  86639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  86646 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  86649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  86651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  86656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  86661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86673 */     GIR_RootConstrainSelectedInstOperands,
     /*  86674 */     // GIR_Coverage, 3023,
     /*  86674 */     GIR_EraseRootFromParent_Done,
     /*  86675 */   // Label 1212: @86675
     /*  86675 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(86735), // Rule ID 3029 //
     /*  86680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  86683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  86691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  86699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  86706 */     // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  86709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  86711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  86716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  86721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  86726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86733 */     GIR_RootConstrainSelectedInstOperands,
     /*  86734 */     // GIR_Coverage, 3029,
     /*  86734 */     GIR_EraseRootFromParent_Done,
     /*  86735 */   // Label 1213: @86735
     /*  86735 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(86794), // Rule ID 3019 //
     /*  86740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  86743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  86751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  86759 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  86763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  86770 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  86773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  86775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  86780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86792 */     GIR_RootConstrainSelectedInstOperands,
     /*  86793 */     // GIR_Coverage, 3019,
     /*  86793 */     GIR_EraseRootFromParent_Done,
     /*  86794 */   // Label 1214: @86794
     /*  86794 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(86853), // Rule ID 3020 //
     /*  86799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  86802 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  86810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  86818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  86822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  86829 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  86829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  86832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  86834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  86839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86851 */     GIR_RootConstrainSelectedInstOperands,
     /*  86852 */     // GIR_Coverage, 3020,
     /*  86852 */     GIR_EraseRootFromParent_Done,
     /*  86853 */   // Label 1215: @86853
     /*  86853 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(86912), // Rule ID 3021 //
     /*  86858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  86861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  86869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  86877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  86881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  86888 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  86888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  86891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  86893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  86898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  86903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86910 */     GIR_RootConstrainSelectedInstOperands,
     /*  86911 */     // GIR_Coverage, 3021,
     /*  86911 */     GIR_EraseRootFromParent_Done,
     /*  86912 */   // Label 1216: @86912
     /*  86912 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(86974), // Rule ID 3022 //
     /*  86917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  86920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  86928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  86936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  86940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  86947 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  86947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  86950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  86952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  86957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  86962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86972 */     GIR_RootConstrainSelectedInstOperands,
     /*  86973 */     // GIR_Coverage, 3022,
     /*  86973 */     GIR_EraseRootFromParent_Done,
     /*  86974 */   // Label 1217: @86974
     /*  86974 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(87026), // Rule ID 3025 //
     /*  86979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  86983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  86987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86991 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  86995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  87002 */     // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  87002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  87005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  87007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  87012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87024 */     GIR_RootConstrainSelectedInstOperands,
     /*  87025 */     // GIR_Coverage, 3025,
     /*  87025 */     GIR_EraseRootFromParent_Done,
     /*  87026 */   // Label 1218: @87026
     /*  87026 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(87081), // Rule ID 3026 //
     /*  87031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  87034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  87042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  87050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  87057 */     // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  87057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  87060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  87062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  87067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87079 */     GIR_RootConstrainSelectedInstOperands,
     /*  87080 */     // GIR_Coverage, 3026,
     /*  87080 */     GIR_EraseRootFromParent_Done,
     /*  87081 */   // Label 1219: @87081
     /*  87081 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(87136), // Rule ID 3027 //
     /*  87086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  87089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  87097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  87105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  87112 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  87112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  87115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  87117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  87122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87134 */     GIR_RootConstrainSelectedInstOperands,
     /*  87135 */     // GIR_Coverage, 3027,
     /*  87135 */     GIR_EraseRootFromParent_Done,
     /*  87136 */   // Label 1220: @87136
     /*  87136 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(87194), // Rule ID 3028 //
     /*  87141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  87144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  87152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  87160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  87167 */     // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  87167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  87170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  87172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  87177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87192 */     GIR_RootConstrainSelectedInstOperands,
     /*  87193 */     // GIR_Coverage, 3028,
     /*  87193 */     GIR_EraseRootFromParent_Done,
     /*  87194 */   // Label 1221: @87194
     /*  87194 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(87245), // Rule ID 3024 //
     /*  87199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  87202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  87210 */     // MIs[0] sbase
     /*  87210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  87214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  87218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  87222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  87226 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  87226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  87229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  87231 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  87233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87243 */     GIR_RootConstrainSelectedInstOperands,
     /*  87244 */     // GIR_Coverage, 3024,
     /*  87244 */     GIR_EraseRootFromParent_Done,
     /*  87245 */   // Label 1222: @87245
     /*  87245 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(87289), // Rule ID 3030 //
     /*  87250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  87258 */     // MIs[0] sbase
     /*  87258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  87262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  87266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  87270 */     // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  87270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  87273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  87275 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  87277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87287 */     GIR_RootConstrainSelectedInstOperands,
     /*  87288 */     // GIR_Coverage, 3030,
     /*  87288 */     GIR_EraseRootFromParent_Done,
     /*  87289 */   // Label 1223: @87289
     /*  87289 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(87349), // Rule ID 6519 //
     /*  87294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  87297 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  87317 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  87320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87347 */     GIR_RootConstrainSelectedInstOperands,
     /*  87348 */     // GIR_Coverage, 6519,
     /*  87348 */     GIR_EraseRootFromParent_Done,
     /*  87349 */   // Label 1224: @87349
     /*  87349 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(87409), // Rule ID 6521 //
     /*  87354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  87357 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  87377 */     // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  87380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87407 */     GIR_RootConstrainSelectedInstOperands,
     /*  87408 */     // GIR_Coverage, 6521,
     /*  87408 */     GIR_EraseRootFromParent_Done,
     /*  87409 */   // Label 1225: @87409
     /*  87409 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(87466), // Rule ID 4295 //
     /*  87414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  87417 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  87437 */     // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  87437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  87440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  87442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  87447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  87452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87464 */     GIR_RootConstrainSelectedInstOperands,
     /*  87465 */     // GIR_Coverage, 4295,
     /*  87465 */     GIR_EraseRootFromParent_Done,
     /*  87466 */   // Label 1226: @87466
     /*  87466 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(87518), // Rule ID 4294 //
     /*  87471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  87474 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  87494 */     // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  87494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  87497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  87499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  87504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87516 */     GIR_RootConstrainSelectedInstOperands,
     /*  87517 */     // GIR_Coverage, 4294,
     /*  87517 */     GIR_EraseRootFromParent_Done,
     /*  87518 */   // Label 1227: @87518
     /*  87518 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(87570), // Rule ID 4293 //
     /*  87523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  87526 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  87546 */     // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  87546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  87549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  87551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  87556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87568 */     GIR_RootConstrainSelectedInstOperands,
     /*  87569 */     // GIR_Coverage, 4293,
     /*  87569 */     GIR_EraseRootFromParent_Done,
     /*  87570 */   // Label 1228: @87570
     /*  87570 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(87637), // Rule ID 4535 //
     /*  87575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  87578 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  87600 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  87603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87635 */     GIR_RootConstrainSelectedInstOperands,
     /*  87636 */     // GIR_Coverage, 4535,
     /*  87636 */     GIR_EraseRootFromParent_Done,
     /*  87637 */   // Label 1229: @87637
     /*  87637 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(87701), // Rule ID 4537 //
     /*  87642 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  87664 */     // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  87667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87699 */     GIR_RootConstrainSelectedInstOperands,
     /*  87700 */     // GIR_Coverage, 4537,
     /*  87700 */     GIR_EraseRootFromParent_Done,
     /*  87701 */   // Label 1230: @87701
     /*  87701 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(87766), // Rule ID 6518 //
     /*  87706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  87709 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87729 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  87732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87764 */     GIR_RootConstrainSelectedInstOperands,
     /*  87765 */     // GIR_Coverage, 6518,
     /*  87765 */     GIR_EraseRootFromParent_Done,
     /*  87766 */   // Label 1231: @87766
     /*  87766 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(87831), // Rule ID 6520 //
     /*  87771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  87774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  87779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  87794 */     // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  87794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  87797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  87804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  87814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  87819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87829 */     GIR_RootConstrainSelectedInstOperands,
     /*  87830 */     // GIR_Coverage, 6520,
     /*  87830 */     GIR_EraseRootFromParent_Done,
     /*  87831 */   // Label 1232: @87831
     /*  87831 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(87893), // Rule ID 4534 //
     /*  87836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  87839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87861 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  87864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87891 */     GIR_RootConstrainSelectedInstOperands,
     /*  87892 */     // GIR_Coverage, 4534,
     /*  87892 */     GIR_EraseRootFromParent_Done,
     /*  87893 */   // Label 1233: @87893
     /*  87893 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(87952), // Rule ID 4536 //
     /*  87898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  87905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  87920 */     // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  87920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  87923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  87925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  87930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  87935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  87940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  87950 */     GIR_RootConstrainSelectedInstOperands,
     /*  87951 */     // GIR_Coverage, 4536,
     /*  87951 */     GIR_EraseRootFromParent_Done,
     /*  87952 */   // Label 1234: @87952
     /*  87952 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(88008), // Rule ID 7972 //
     /*  87957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  87960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  87964 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  87969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  87973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  87977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  87984 */     // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  87984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /*  87987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  87989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  87994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88006 */     GIR_RootConstrainSelectedInstOperands,
     /*  88007 */     // GIR_Coverage, 7972,
     /*  88007 */     GIR_EraseRootFromParent_Done,
     /*  88008 */   // Label 1235: @88008
     /*  88008 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(88060), // Rule ID 7973 //
     /*  88013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /*  88016 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  88021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  88036 */     // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  88036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /*  88039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  88046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88058 */     GIR_RootConstrainSelectedInstOperands,
     /*  88059 */     // GIR_Coverage, 7973,
     /*  88059 */     GIR_EraseRootFromParent_Done,
     /*  88060 */   // Label 1236: @88060
     /*  88060 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(88119), // Rule ID 3896 //
     /*  88065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  88068 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  88075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  88090 */     // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /*  88093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  88100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  88105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88117 */     GIR_RootConstrainSelectedInstOperands,
     /*  88118 */     // GIR_Coverage, 3896,
     /*  88118 */     GIR_EraseRootFromParent_Done,
     /*  88119 */   // Label 1237: @88119
     /*  88119 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(88173), // Rule ID 3895 //
     /*  88124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  88127 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  88134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  88149 */     // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  88149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /*  88152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  88159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88171 */     GIR_RootConstrainSelectedInstOperands,
     /*  88172 */     // GIR_Coverage, 3895,
     /*  88172 */     GIR_EraseRootFromParent_Done,
     /*  88173 */   // Label 1238: @88173
     /*  88173 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(88228), // Rule ID 3634 //
     /*  88178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  88181 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  88189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  88204 */     // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  88204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /*  88207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  88209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  88214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88226 */     GIR_RootConstrainSelectedInstOperands,
     /*  88227 */     // GIR_Coverage, 3634,
     /*  88227 */     GIR_EraseRootFromParent_Done,
     /*  88228 */   // Label 1239: @88228
     /*  88228 */   GIM_Reject,
     /*  88229 */ // Label 1211: @88229
     /*  88229 */ GIM_Reject,
     /*  88230 */ // Label 1004: @88230
     /*  88230 */ GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(88829),
     /*  88235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88242 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  88246 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(88302), // Rule ID 3103 //
     /*  88251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  88254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  88266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  88273 */     // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  88276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88300 */     GIR_RootConstrainSelectedInstOperands,
     /*  88301 */     // GIR_Coverage, 3103,
     /*  88301 */     GIR_EraseRootFromParent_Done,
     /*  88302 */   // Label 1241: @88302
     /*  88302 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(88354), // Rule ID 3109 //
     /*  88307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  88310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  88325 */     // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  88328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88352 */     GIR_RootConstrainSelectedInstOperands,
     /*  88353 */     // GIR_Coverage, 3109,
     /*  88353 */     GIR_EraseRootFromParent_Done,
     /*  88354 */   // Label 1242: @88354
     /*  88354 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(88405), // Rule ID 3099 //
     /*  88359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  88362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  88374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  88381 */     // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  88384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88403 */     GIR_RootConstrainSelectedInstOperands,
     /*  88404 */     // GIR_Coverage, 3099,
     /*  88404 */     GIR_EraseRootFromParent_Done,
     /*  88405 */   // Label 1243: @88405
     /*  88405 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(88456), // Rule ID 3100 //
     /*  88410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  88413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  88425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  88432 */     // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  88435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88454 */     GIR_RootConstrainSelectedInstOperands,
     /*  88455 */     // GIR_Coverage, 3100,
     /*  88455 */     GIR_EraseRootFromParent_Done,
     /*  88456 */   // Label 1244: @88456
     /*  88456 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(88507), // Rule ID 3101 //
     /*  88461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  88464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  88476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  88483 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  88483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  88486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88505 */     GIR_RootConstrainSelectedInstOperands,
     /*  88506 */     // GIR_Coverage, 3101,
     /*  88506 */     GIR_EraseRootFromParent_Done,
     /*  88507 */   // Label 1245: @88507
     /*  88507 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(88561), // Rule ID 3102 //
     /*  88512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  88515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  88527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  88534 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  88534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  88537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88559 */     GIR_RootConstrainSelectedInstOperands,
     /*  88560 */     // GIR_Coverage, 3102,
     /*  88560 */     GIR_EraseRootFromParent_Done,
     /*  88561 */   // Label 1246: @88561
     /*  88561 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(88605), // Rule ID 3105 //
     /*  88566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  88581 */     // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  88584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88603 */     GIR_RootConstrainSelectedInstOperands,
     /*  88604 */     // GIR_Coverage, 3105,
     /*  88604 */     GIR_EraseRootFromParent_Done,
     /*  88605 */   // Label 1247: @88605
     /*  88605 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(88652), // Rule ID 3106 //
     /*  88610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  88613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  88628 */     // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  88628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /*  88631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88650 */     GIR_RootConstrainSelectedInstOperands,
     /*  88651 */     // GIR_Coverage, 3106,
     /*  88651 */     GIR_EraseRootFromParent_Done,
     /*  88652 */   // Label 1248: @88652
     /*  88652 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(88699), // Rule ID 3107 //
     /*  88657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  88660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  88675 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  88675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /*  88678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88697 */     GIR_RootConstrainSelectedInstOperands,
     /*  88698 */     // GIR_Coverage, 3107,
     /*  88698 */     GIR_EraseRootFromParent_Done,
     /*  88699 */   // Label 1249: @88699
     /*  88699 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(88749), // Rule ID 3108 //
     /*  88704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  88707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  88722 */     // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  88722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /*  88725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  88732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88747 */     GIR_RootConstrainSelectedInstOperands,
     /*  88748 */     // GIR_Coverage, 3108,
     /*  88748 */     GIR_EraseRootFromParent_Done,
     /*  88749 */   // Label 1250: @88749
     /*  88749 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(88792), // Rule ID 3104 //
     /*  88754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  88757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88761 */     // MIs[0] sbase
     /*  88761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  88765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  88769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  88773 */     // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  88773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  88776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88778 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  88780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88790 */     GIR_RootConstrainSelectedInstOperands,
     /*  88791 */     // GIR_Coverage, 3104,
     /*  88791 */     GIR_EraseRootFromParent_Done,
     /*  88792 */   // Label 1251: @88792
     /*  88792 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(88828), // Rule ID 3110 //
     /*  88797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /*  88801 */     // MIs[0] sbase
     /*  88801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  88805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  88809 */     // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  88809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /*  88812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  88814 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  88816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88826 */     GIR_RootConstrainSelectedInstOperands,
     /*  88827 */     // GIR_Coverage, 3110,
     /*  88827 */     GIR_EraseRootFromParent_Done,
     /*  88828 */   // Label 1252: @88828
     /*  88828 */   GIM_Reject,
     /*  88829 */ // Label 1240: @88829
     /*  88829 */ GIM_Reject,
     /*  88830 */ // Label 1005: @88830
     /*  88830 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(88904), // Rule ID 6467 //
     /*  88835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  88838 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88841 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88852 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  88857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  88872 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  88872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  88875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  88877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  88882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88902 */   GIR_RootConstrainSelectedInstOperands,
     /*  88903 */   // GIR_Coverage, 6467,
     /*  88903 */   GIR_EraseRootFromParent_Done,
     /*  88904 */ // Label 1253: @88904
     /*  88904 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(88978), // Rule ID 6469 //
     /*  88909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  88912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88915 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  88919 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  88926 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  88931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  88939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  88946 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  88946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  88949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  88951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  88956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  88961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  88966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  88976 */   GIR_RootConstrainSelectedInstOperands,
     /*  88977 */   // GIR_Coverage, 6469,
     /*  88977 */   GIR_EraseRootFromParent_Done,
     /*  88978 */ // Label 1254: @88978
     /*  88978 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(89041), // Rule ID 6487 //
     /*  88983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  88986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88989 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  88994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  88998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89002 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  89009 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  89009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  89012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  89014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  89019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  89024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89039 */   GIR_RootConstrainSelectedInstOperands,
     /*  89040 */   // GIR_Coverage, 6487,
     /*  89040 */   GIR_EraseRootFromParent_Done,
     /*  89041 */ // Label 1255: @89041
     /*  89041 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(89104), // Rule ID 6489 //
     /*  89046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  89049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89052 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  89072 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  89072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  89075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  89077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  89082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  89087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89102 */   GIR_RootConstrainSelectedInstOperands,
     /*  89103 */   // GIR_Coverage, 6489,
     /*  89103 */   GIR_EraseRootFromParent_Done,
     /*  89104 */ // Label 1256: @89104
     /*  89104 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(89175), // Rule ID 3580 //
     /*  89109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /*  89112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89115 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89119 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89126 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89139 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  89146 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SVS_t16),
     /*  89149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  89161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89169 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89173 */   GIR_RootConstrainSelectedInstOperands,
     /*  89174 */   // GIR_Coverage, 3580,
     /*  89174 */   GIR_EraseRootFromParent_Done,
     /*  89175 */ // Label 1257: @89175
     /*  89175 */ GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(89246), // Rule ID 4208 //
     /*  89180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /*  89183 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89186 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89190 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89197 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  89217 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  89220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  89232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89244 */   GIR_RootConstrainSelectedInstOperands,
     /*  89245 */   // GIR_Coverage, 4208,
     /*  89245 */   GIR_EraseRootFromParent_Done,
     /*  89246 */ // Label 1258: @89246
     /*  89246 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(89317), // Rule ID 4223 //
     /*  89251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /*  89254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89257 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89268 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  89288 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  89291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  89303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89315 */   GIR_RootConstrainSelectedInstOperands,
     /*  89316 */   // GIR_Coverage, 4223,
     /*  89316 */   GIR_EraseRootFromParent_Done,
     /*  89317 */ // Label 1259: @89317
     /*  89317 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(89377), // Rule ID 4217 //
     /*  89322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /*  89325 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89328 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  89348 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  89351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  89363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89375 */   GIR_RootConstrainSelectedInstOperands,
     /*  89376 */   // GIR_Coverage, 4217,
     /*  89376 */   GIR_EraseRootFromParent_Done,
     /*  89377 */ // Label 1260: @89377
     /*  89377 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(89437), // Rule ID 4232 //
     /*  89382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /*  89385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89388 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89397 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89401 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  89408 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  89411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  89423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89435 */   GIR_RootConstrainSelectedInstOperands,
     /*  89436 */   // GIR_Coverage, 4232,
     /*  89436 */   GIR_EraseRootFromParent_Done,
     /*  89437 */ // Label 1261: @89437
     /*  89437 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(89497), // Rule ID 4247 //
     /*  89442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /*  89445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89448 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  89468 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_SVS_t16),
     /*  89471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  89483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  89488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89495 */   GIR_RootConstrainSelectedInstOperands,
     /*  89496 */   // GIR_Coverage, 4247,
     /*  89496 */   GIR_EraseRootFromParent_Done,
     /*  89497 */ // Label 1262: @89497
     /*  89497 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(89563), // Rule ID 3579 //
     /*  89502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  89505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89508 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89519 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89532 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  89539 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SADDR_t16),
     /*  89542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89561 */   GIR_RootConstrainSelectedInstOperands,
     /*  89562 */   // GIR_Coverage, 3579,
     /*  89562 */   GIR_EraseRootFromParent_Done,
     /*  89563 */ // Label 1263: @89563
     /*  89563 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(89629), // Rule ID 4207 //
     /*  89568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  89571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89574 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89585 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  89605 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  89605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  89608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89627 */   GIR_RootConstrainSelectedInstOperands,
     /*  89628 */   // GIR_Coverage, 4207,
     /*  89628 */   GIR_EraseRootFromParent_Done,
     /*  89629 */ // Label 1264: @89629
     /*  89629 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(89695), // Rule ID 4222 //
     /*  89634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  89637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89640 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89651 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89664 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  89671 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  89671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  89674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89693 */   GIR_RootConstrainSelectedInstOperands,
     /*  89694 */   // GIR_Coverage, 4222,
     /*  89694 */   GIR_EraseRootFromParent_Done,
     /*  89695 */ // Label 1265: @89695
     /*  89695 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(89750), // Rule ID 4216 //
     /*  89700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  89703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89706 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89715 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  89726 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  89726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  89729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89748 */   GIR_RootConstrainSelectedInstOperands,
     /*  89749 */   // GIR_Coverage, 4216,
     /*  89749 */   GIR_EraseRootFromParent_Done,
     /*  89750 */ // Label 1266: @89750
     /*  89750 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(89805), // Rule ID 4231 //
     /*  89755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  89758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89761 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89770 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89774 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  89781 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  89781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  89784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89799 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89803 */   GIR_RootConstrainSelectedInstOperands,
     /*  89804 */   // GIR_Coverage, 4231,
     /*  89804 */   GIR_EraseRootFromParent_Done,
     /*  89805 */ // Label 1267: @89805
     /*  89805 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(89860), // Rule ID 4246 //
     /*  89810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  89813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89816 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  89836 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_SADDR_t16),
     /*  89839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  89846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89858 */   GIR_RootConstrainSelectedInstOperands,
     /*  89859 */   // GIR_Coverage, 4246,
     /*  89859 */   GIR_EraseRootFromParent_Done,
     /*  89860 */ // Label 1268: @89860
     /*  89860 */ GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(89926), // Rule ID 3578 //
     /*  89865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  89868 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89871 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89875 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89882 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  89891 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  89902 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  89902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_t16),
     /*  89905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89924 */   GIR_RootConstrainSelectedInstOperands,
     /*  89925 */   // GIR_Coverage, 3578,
     /*  89925 */   GIR_EraseRootFromParent_Done,
     /*  89926 */ // Label 1269: @89926
     /*  89926 */ GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(89992), // Rule ID 4206 //
     /*  89931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  89934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89937 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  89941 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  89948 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  89953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  89957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  89961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  89968 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  89968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  89971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  89973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  89978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  89983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  89990 */   GIR_RootConstrainSelectedInstOperands,
     /*  89991 */   // GIR_Coverage, 4206,
     /*  89991 */   GIR_EraseRootFromParent_Done,
     /*  89992 */ // Label 1270: @89992
     /*  89992 */ GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(90058), // Rule ID 4221 //
     /*  89997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  90000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90003 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90007 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90014 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90027 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  90034 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  90037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90056 */   GIR_RootConstrainSelectedInstOperands,
     /*  90057 */   // GIR_Coverage, 4221,
     /*  90057 */   GIR_EraseRootFromParent_Done,
     /*  90058 */ // Label 1271: @90058
     /*  90058 */ GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(90113), // Rule ID 4215 //
     /*  90063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /*  90066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90069 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  90089 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  90092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90111 */   GIR_RootConstrainSelectedInstOperands,
     /*  90112 */   // GIR_Coverage, 4215,
     /*  90112 */   GIR_EraseRootFromParent_Done,
     /*  90113 */ // Label 1272: @90113
     /*  90113 */ GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(90168), // Rule ID 4230 //
     /*  90118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /*  90121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90124 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90137 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  90144 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  90144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  90147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90162 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90166 */   GIR_RootConstrainSelectedInstOperands,
     /*  90167 */   // GIR_Coverage, 4230,
     /*  90167 */   GIR_EraseRootFromParent_Done,
     /*  90168 */ // Label 1273: @90168
     /*  90168 */ GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(90223), // Rule ID 4245 //
     /*  90173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /*  90176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90179 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  90188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90192 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  90199 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  90199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SHORT_D16_t16),
     /*  90202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  90204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  90209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  90214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90217 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90221 */   GIR_RootConstrainSelectedInstOperands,
     /*  90222 */   // GIR_Coverage, 4245,
     /*  90222 */   GIR_EraseRootFromParent_Done,
     /*  90223 */ // Label 1274: @90223
     /*  90223 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(90304), // Rule ID 4459 //
     /*  90228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  90231 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90234 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90245 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90256 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90260 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  90267 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  90267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  90270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90302 */   GIR_RootConstrainSelectedInstOperands,
     /*  90303 */   // GIR_Coverage, 4459,
     /*  90303 */   GIR_EraseRootFromParent_Done,
     /*  90304 */ // Label 1275: @90304
     /*  90304 */ GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(90382), // Rule ID 4461 //
     /*  90309 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90312 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90316 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90323 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  90345 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  90345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  90348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90380 */   GIR_RootConstrainSelectedInstOperands,
     /*  90381 */   // GIR_Coverage, 4461,
     /*  90381 */   GIR_EraseRootFromParent_Done,
     /*  90382 */ // Label 1276: @90382
     /*  90382 */ GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(90463), // Rule ID 4467 //
     /*  90387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  90390 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90393 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  90404 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  90426 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  90426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  90429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90461 */   GIR_RootConstrainSelectedInstOperands,
     /*  90462 */   // GIR_Coverage, 4467,
     /*  90462 */   GIR_EraseRootFromParent_Done,
     /*  90463 */ // Label 1277: @90463
     /*  90463 */ GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(90541), // Rule ID 4469 //
     /*  90468 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90471 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90475 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  90482 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  90504 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  90504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  90507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90539 */   GIR_RootConstrainSelectedInstOperands,
     /*  90540 */   // GIR_Coverage, 4469,
     /*  90540 */   GIR_EraseRootFromParent_Done,
     /*  90541 */ // Label 1278: @90541
     /*  90541 */ GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(90620), // Rule ID 6466 //
     /*  90546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  90549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90552 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90556 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90563 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90576 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  90583 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  90583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /*  90586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90618 */   GIR_RootConstrainSelectedInstOperands,
     /*  90619 */   // GIR_Coverage, 6466,
     /*  90619 */   GIR_EraseRootFromParent_Done,
     /*  90620 */ // Label 1279: @90620
     /*  90620 */ GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(90699), // Rule ID 6468 //
     /*  90625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  90628 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90631 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90642 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  90662 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  90662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /*  90665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90697 */   GIR_RootConstrainSelectedInstOperands,
     /*  90698 */   // GIR_Coverage, 6468,
     /*  90698 */   GIR_EraseRootFromParent_Done,
     /*  90699 */ // Label 1280: @90699
     /*  90699 */ GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(90767), // Rule ID 6486 //
     /*  90704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  90707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90710 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90719 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90723 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  90730 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  90730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /*  90733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90765 */   GIR_RootConstrainSelectedInstOperands,
     /*  90766 */   // GIR_Coverage, 6486,
     /*  90766 */   GIR_EraseRootFromParent_Done,
     /*  90767 */ // Label 1281: @90767
     /*  90767 */ GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(90835), // Rule ID 6488 //
     /*  90772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  90775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90778 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  90783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90787 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90791 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  90798 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  90798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /*  90801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  90808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  90818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  90823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90829 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90833 */   GIR_RootConstrainSelectedInstOperands,
     /*  90834 */   // GIR_Coverage, 6488,
     /*  90834 */   GIR_EraseRootFromParent_Done,
     /*  90835 */ // Label 1282: @90835
     /*  90835 */ GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(90911), // Rule ID 4458 //
     /*  90840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  90843 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90846 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90850 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90857 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  90879 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  90879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  90882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90905 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90909 */   GIR_RootConstrainSelectedInstOperands,
     /*  90910 */   // GIR_Coverage, 4458,
     /*  90910 */   GIR_EraseRootFromParent_Done,
     /*  90911 */ // Label 1283: @90911
     /*  90911 */ GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(90984), // Rule ID 4460 //
     /*  90916 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90919 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  90930 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  90937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  90941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  90945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  90952 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  90952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  90955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  90957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  90962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  90967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  90972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  90982 */   GIR_RootConstrainSelectedInstOperands,
     /*  90983 */   // GIR_Coverage, 4460,
     /*  90983 */   GIR_EraseRootFromParent_Done,
     /*  90984 */ // Label 1284: @90984
     /*  90984 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(91060), // Rule ID 4466 //
     /*  90989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  90992 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  90995 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  90999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  91006 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91017 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91021 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91028 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  91028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  91031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91058 */   GIR_RootConstrainSelectedInstOperands,
     /*  91059 */   // GIR_Coverage, 4466,
     /*  91059 */   GIR_EraseRootFromParent_Done,
     /*  91060 */ // Label 1285: @91060
     /*  91060 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(91133), // Rule ID 4468 //
     /*  91065 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  91068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  91079 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91101 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  91101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  91104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91131 */   GIR_RootConstrainSelectedInstOperands,
     /*  91132 */   // GIR_Coverage, 4468,
     /*  91132 */   GIR_EraseRootFromParent_Done,
     /*  91133 */ // Label 1286: @91133
     /*  91133 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(91208), // Rule ID 6436 //
     /*  91138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  91141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91144 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91155 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91176 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  91176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  91179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91202 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91206 */   GIR_RootConstrainSelectedInstOperands,
     /*  91207 */   // GIR_Coverage, 6436,
     /*  91207 */   GIR_EraseRootFromParent_Done,
     /*  91208 */ // Label 1287: @91208
     /*  91208 */ GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(91283), // Rule ID 6437 //
     /*  91213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  91216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91219 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91230 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91251 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  91251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  91254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91281 */   GIR_RootConstrainSelectedInstOperands,
     /*  91282 */   // GIR_Coverage, 6437,
     /*  91282 */   GIR_EraseRootFromParent_Done,
     /*  91283 */ // Label 1288: @91283
     /*  91283 */ GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(91359), // Rule ID 6442 //
     /*  91288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  91291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91294 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91305 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91320 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91327 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  91327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  91330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91353 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91357 */   GIR_RootConstrainSelectedInstOperands,
     /*  91358 */   // GIR_Coverage, 6442,
     /*  91358 */   GIR_EraseRootFromParent_Done,
     /*  91359 */ // Label 1289: @91359
     /*  91359 */ GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(91435), // Rule ID 6443 //
     /*  91364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  91367 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91370 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91374 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91381 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91403 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  91403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  91406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91429 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91433 */   GIR_RootConstrainSelectedInstOperands,
     /*  91434 */   // GIR_Coverage, 6443,
     /*  91434 */   GIR_EraseRootFromParent_Done,
     /*  91435 */ // Label 1290: @91435
     /*  91435 */ GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(91500), // Rule ID 6446 //
     /*  91440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  91443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91446 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91468 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  91468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  91471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91498 */   GIR_RootConstrainSelectedInstOperands,
     /*  91499 */   // GIR_Coverage, 6446,
     /*  91499 */   GIR_EraseRootFromParent_Done,
     /*  91500 */ // Label 1291: @91500
     /*  91500 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(91565), // Rule ID 6447 //
     /*  91505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /*  91508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91511 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  91518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91526 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  91533 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  91533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  91536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  91538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  91543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  91548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  91553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91563 */   GIR_RootConstrainSelectedInstOperands,
     /*  91564 */   // GIR_Coverage, 6447,
     /*  91564 */   GIR_EraseRootFromParent_Done,
     /*  91565 */ // Label 1292: @91565
     /*  91565 */ GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(91631), // Rule ID 7946 //
     /*  91570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  91573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91576 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91580 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91587 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  91592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91600 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  91607 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  91607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  91610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  91612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  91617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91629 */   GIR_RootConstrainSelectedInstOperands,
     /*  91630 */   // GIR_Coverage, 7946,
     /*  91630 */   GIR_EraseRootFromParent_Done,
     /*  91631 */ // Label 1293: @91631
     /*  91631 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(91697), // Rule ID 7947 //
     /*  91636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  91639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91642 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91653 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  91658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91662 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91666 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  91673 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  91673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  91676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  91678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  91683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91695 */   GIR_RootConstrainSelectedInstOperands,
     /*  91696 */   // GIR_Coverage, 7947,
     /*  91696 */   GIR_EraseRootFromParent_Done,
     /*  91697 */ // Label 1294: @91697
     /*  91697 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(91763), // Rule ID 7948 //
     /*  91702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  91705 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91708 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91719 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  91724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91732 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  91739 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  91739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  91742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  91744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  91749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91761 */   GIR_RootConstrainSelectedInstOperands,
     /*  91762 */   // GIR_Coverage, 7948,
     /*  91762 */   GIR_EraseRootFromParent_Done,
     /*  91763 */ // Label 1295: @91763
     /*  91763 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(91829), // Rule ID 7949 //
     /*  91768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  91771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91774 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91785 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  91790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  91794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  91805 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  91805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /*  91808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  91810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  91815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91827 */   GIR_RootConstrainSelectedInstOperands,
     /*  91828 */   // GIR_Coverage, 7949,
     /*  91828 */   GIR_EraseRootFromParent_Done,
     /*  91829 */ // Label 1296: @91829
     /*  91829 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(91895), // Rule ID 7974 //
     /*  91834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  91837 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  91840 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91844 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91851 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  91856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91864 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  91871 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext_glue>><<P:Predicate_atomic_load_aext_8_glue>><<P:Predicate_atomic_load_aext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  91871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /*  91874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  91876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  91881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91893 */   GIR_RootConstrainSelectedInstOperands,
     /*  91894 */   // GIR_Coverage, 7974,
     /*  91894 */   GIR_EraseRootFromParent_Done,
     /*  91895 */ // Label 1297: @91895
     /*  91895 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(91961), // Rule ID 7975 //
     /*  91900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  91903 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  91906 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91910 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91917 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  91922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91926 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  91937 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  91937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  91940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  91942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  91947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  91952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91959 */   GIR_RootConstrainSelectedInstOperands,
     /*  91960 */   // GIR_Coverage, 7975,
     /*  91960 */   GIR_EraseRootFromParent_Done,
     /*  91961 */ // Label 1298: @91961
     /*  91961 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(92027), // Rule ID 7976 //
     /*  91966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  91969 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  91972 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  91976 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  91983 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  91988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  91992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  91996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92003 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /*  92006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92025 */   GIR_RootConstrainSelectedInstOperands,
     /*  92026 */   // GIR_Coverage, 7976,
     /*  92026 */   GIR_EraseRootFromParent_Done,
     /*  92027 */ // Label 1299: @92027
     /*  92027 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(92093), // Rule ID 7977 //
     /*  92032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  92035 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  92038 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92042 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92049 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  92058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92069 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /*  92072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92091 */   GIR_RootConstrainSelectedInstOperands,
     /*  92092 */   // GIR_Coverage, 7977,
     /*  92092 */   GIR_EraseRootFromParent_Done,
     /*  92093 */ // Label 1300: @92093
     /*  92093 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(92159), // Rule ID 7992 //
     /*  92098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  92101 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  92104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92108 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92115 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92128 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92135 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext_glue>><<P:Predicate_atomic_load_nonext_16_glue>><<P:Predicate_atomic_load_nonext_16_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  92138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92157 */   GIR_RootConstrainSelectedInstOperands,
     /*  92158 */   // GIR_Coverage, 7992,
     /*  92158 */   GIR_EraseRootFromParent_Done,
     /*  92159 */ // Label 1301: @92159
     /*  92159 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(92225), // Rule ID 7993 //
     /*  92164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  92167 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  92170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92174 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92181 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92190 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92194 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92201 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  92204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92219 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92223 */   GIR_RootConstrainSelectedInstOperands,
     /*  92224 */   // GIR_Coverage, 7993,
     /*  92224 */   GIR_EraseRootFromParent_Done,
     /*  92225 */ // Label 1302: @92225
     /*  92225 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(92291), // Rule ID 7994 //
     /*  92230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  92233 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  92236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92240 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92247 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92256 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92260 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92267 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  92270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92289 */   GIR_RootConstrainSelectedInstOperands,
     /*  92290 */   // GIR_Coverage, 7994,
     /*  92290 */   GIR_EraseRootFromParent_Done,
     /*  92291 */ // Label 1303: @92291
     /*  92291 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(92357), // Rule ID 7995 //
     /*  92296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  92299 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  92302 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92306 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92313 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  92322 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92326 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92333 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_local>>  =>  (DS_READ_U16_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_t16),
     /*  92336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92355 */   GIR_RootConstrainSelectedInstOperands,
     /*  92356 */   // GIR_Coverage, 7995,
     /*  92356 */   GIR_EraseRootFromParent_Done,
     /*  92357 */ // Label 1304: @92357
     /*  92357 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(92416), // Rule ID 7954 //
     /*  92362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /*  92365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92368 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92372 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92381 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92392 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /*  92395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92414 */   GIR_RootConstrainSelectedInstOperands,
     /*  92415 */   // GIR_Coverage, 7954,
     /*  92415 */   GIR_EraseRootFromParent_Done,
     /*  92416 */ // Label 1305: @92416
     /*  92416 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(92471), // Rule ID 7955 //
     /*  92421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /*  92424 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92427 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92447 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  92450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92469 */   GIR_RootConstrainSelectedInstOperands,
     /*  92470 */   // GIR_Coverage, 7955,
     /*  92470 */   GIR_EraseRootFromParent_Done,
     /*  92471 */ // Label 1306: @92471
     /*  92471 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(92526), // Rule ID 7956 //
     /*  92476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /*  92479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92482 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92502 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /*  92505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92524 */   GIR_RootConstrainSelectedInstOperands,
     /*  92525 */   // GIR_Coverage, 7956,
     /*  92525 */   GIR_EraseRootFromParent_Done,
     /*  92526 */ // Label 1307: @92526
     /*  92526 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(92581), // Rule ID 7957 //
     /*  92531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /*  92534 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92537 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /*  92542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  92546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /*  92557 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /*  92557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_t16),
     /*  92560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /*  92567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  92572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92579 */   GIR_RootConstrainSelectedInstOperands,
     /*  92580 */   // GIR_Coverage, 7957,
     /*  92580 */   GIR_EraseRootFromParent_Done,
     /*  92581 */ // Label 1308: @92581
     /*  92581 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(92654), // Rule ID 3557 //
     /*  92586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  92589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92592 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92596 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92603 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  92610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  92614 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92618 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  92625 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_SADDR_t16),
     /*  92628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  92635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  92640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92652 */   GIR_RootConstrainSelectedInstOperands,
     /*  92653 */   // GIR_Coverage, 3557,
     /*  92653 */   GIR_EraseRootFromParent_Done,
     /*  92654 */ // Label 1309: @92654
     /*  92654 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(92727), // Rule ID 3808 //
     /*  92659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  92662 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  92665 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92676 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  92683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  92698 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  92701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  92708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  92713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92725 */   GIR_RootConstrainSelectedInstOperands,
     /*  92726 */   // GIR_Coverage, 3808,
     /*  92726 */   GIR_EraseRootFromParent_Done,
     /*  92727 */ // Label 1310: @92727
     /*  92727 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(92800), // Rule ID 3816 //
     /*  92732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  92735 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  92738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  92749 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  92756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  92771 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  92774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  92781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  92786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92798 */   GIR_RootConstrainSelectedInstOperands,
     /*  92799 */   // GIR_Coverage, 3816,
     /*  92799 */   GIR_EraseRootFromParent_Done,
     /*  92800 */ // Label 1311: @92800
     /*  92800 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(92873), // Rule ID 3838 //
     /*  92805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  92808 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92811 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92822 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  92829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  92844 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  92847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  92854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  92859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92871 */   GIR_RootConstrainSelectedInstOperands,
     /*  92872 */   // GIR_Coverage, 3838,
     /*  92872 */   GIR_EraseRootFromParent_Done,
     /*  92873 */ // Label 1312: @92873
     /*  92873 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(92946), // Rule ID 3850 //
     /*  92878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  92881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92884 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  92888 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  92895 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  92902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  92917 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /*  92920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  92927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  92932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92940 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92944 */   GIR_RootConstrainSelectedInstOperands,
     /*  92945 */   // GIR_Coverage, 3850,
     /*  92945 */   GIR_EraseRootFromParent_Done,
     /*  92946 */ // Label 1313: @92946
     /*  92946 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(93008), // Rule ID 3848 //
     /*  92951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  92954 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92957 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  92964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  92968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  92972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  92979 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  92979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  92982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  92984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  92989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  92994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  92999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93006 */   GIR_RootConstrainSelectedInstOperands,
     /*  93007 */   // GIR_Coverage, 3848,
     /*  93007 */   GIR_EraseRootFromParent_Done,
     /*  93008 */ // Label 1314: @93008
     /*  93008 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(93070), // Rule ID 3860 //
     /*  93013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  93016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93019 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  93041 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /*  93044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  93056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93068 */   GIR_RootConstrainSelectedInstOperands,
     /*  93069 */   // GIR_Coverage, 3860,
     /*  93069 */   GIR_EraseRootFromParent_Done,
     /*  93070 */ // Label 1315: @93070
     /*  93070 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(93132), // Rule ID 3866 //
     /*  93075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  93078 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93081 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  93092 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93096 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /*  93103 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_SHORT_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SHORT_D16_SADDR_t16),
     /*  93106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  93113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /*  93118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  93123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93130 */   GIR_RootConstrainSelectedInstOperands,
     /*  93131 */   // GIR_Coverage, 3866,
     /*  93131 */   GIR_EraseRootFromParent_Done,
     /*  93132 */ // Label 1316: @93132
     /*  93132 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(93200), // Rule ID 3556 //
     /*  93137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  93140 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93143 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93147 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93154 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  93165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93176 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_t16),
     /*  93179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93198 */   GIR_RootConstrainSelectedInstOperands,
     /*  93199 */   // GIR_Coverage, 3556,
     /*  93199 */   GIR_EraseRootFromParent_Done,
     /*  93200 */ // Label 1317: @93200
     /*  93200 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(93268), // Rule ID 3807 //
     /*  93205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  93208 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93211 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93215 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93222 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93233 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93244 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  93247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93266 */   GIR_RootConstrainSelectedInstOperands,
     /*  93267 */   // GIR_Coverage, 3807,
     /*  93267 */   GIR_EraseRootFromParent_Done,
     /*  93268 */ // Label 1318: @93268
     /*  93268 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(93336), // Rule ID 3815 //
     /*  93273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /*  93276 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93279 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93290 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93312 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  93315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93334 */   GIR_RootConstrainSelectedInstOperands,
     /*  93335 */   // GIR_Coverage, 3815,
     /*  93335 */   GIR_EraseRootFromParent_Done,
     /*  93336 */ // Label 1319: @93336
     /*  93336 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(93404), // Rule ID 3837 //
     /*  93341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  93344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93347 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93351 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93358 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93380 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  93383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93402 */   GIR_RootConstrainSelectedInstOperands,
     /*  93403 */   // GIR_Coverage, 3837,
     /*  93403 */   GIR_EraseRootFromParent_Done,
     /*  93404 */ // Label 1320: @93404
     /*  93404 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(93472), // Rule ID 3849 //
     /*  93409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  93412 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93415 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93419 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93426 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93448 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /*  93451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93470 */   GIR_RootConstrainSelectedInstOperands,
     /*  93471 */   // GIR_Coverage, 3849,
     /*  93471 */   GIR_EraseRootFromParent_Done,
     /*  93472 */ // Label 1321: @93472
     /*  93472 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(93529), // Rule ID 3847 //
     /*  93477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /*  93480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93483 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93505 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  93508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93527 */   GIR_RootConstrainSelectedInstOperands,
     /*  93528 */   // GIR_Coverage, 3847,
     /*  93528 */   GIR_EraseRootFromParent_Done,
     /*  93529 */ // Label 1322: @93529
     /*  93529 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(93586), // Rule ID 3859 //
     /*  93534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /*  93537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93540 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93551 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93555 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93562 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /*  93565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93584 */   GIR_RootConstrainSelectedInstOperands,
     /*  93585 */   // GIR_Coverage, 3859,
     /*  93585 */   GIR_EraseRootFromParent_Done,
     /*  93586 */ // Label 1323: @93586
     /*  93586 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(93643), // Rule ID 3865 //
     /*  93591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /*  93594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93597 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  93608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /*  93619 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SHORT_D16_t16),
     /*  93622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93641 */   GIR_RootConstrainSelectedInstOperands,
     /*  93642 */   // GIR_Coverage, 3865,
     /*  93642 */   GIR_EraseRootFromParent_Done,
     /*  93643 */ // Label 1324: @93643
     /*  93643 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(93712), // Rule ID 3582 //
     /*  93648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  93651 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93654 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93665 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  93688 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  93691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93710 */   GIR_RootConstrainSelectedInstOperands,
     /*  93711 */   // GIR_Coverage, 3582,
     /*  93711 */   GIR_EraseRootFromParent_Done,
     /*  93712 */ // Label 1325: @93712
     /*  93712 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(93781), // Rule ID 3586 //
     /*  93717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /*  93720 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  93723 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  93734 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93746 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93750 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  93757 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>><<P:Predicate_atomic_load_nonext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  93760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93775 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93779 */   GIR_RootConstrainSelectedInstOperands,
     /*  93780 */   // GIR_Coverage, 3586,
     /*  93780 */   GIR_EraseRootFromParent_Done,
     /*  93781 */ // Label 1326: @93781
     /*  93781 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(93850), // Rule ID 3598 //
     /*  93786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /*  93789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93792 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93796 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93803 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93815 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93819 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  93826 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  93829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93848 */   GIR_RootConstrainSelectedInstOperands,
     /*  93849 */   // GIR_Coverage, 3598,
     /*  93849 */   GIR_EraseRootFromParent_Done,
     /*  93850 */ // Label 1327: @93850
     /*  93850 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(93919), // Rule ID 3604 //
     /*  93855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /*  93858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93861 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93865 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93872 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  93884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  93895 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  93895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /*  93898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93917 */   GIR_RootConstrainSelectedInstOperands,
     /*  93918 */   // GIR_Coverage, 3604,
     /*  93918 */   GIR_EraseRootFromParent_Done,
     /*  93919 */ // Label 1328: @93919
     /*  93919 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(93988), // Rule ID 3610 //
     /*  93924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /*  93927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93930 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  93934 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  93941 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  93949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  93953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  93957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  93964 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  93964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE_D16_t16),
     /*  93967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  93969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  93974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  93979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93982 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93986 */   GIR_RootConstrainSelectedInstOperands,
     /*  93987 */   // GIR_Coverage, 3610,
     /*  93987 */   GIR_EraseRootFromParent_Done,
     /*  93988 */ // Label 1329: @93988
     /*  93988 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(94046), // Rule ID 3601 //
     /*  93993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /*  93996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  93999 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  94022 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  94022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  94025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  94027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  94032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  94037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94040 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94044 */   GIR_RootConstrainSelectedInstOperands,
     /*  94045 */   // GIR_Coverage, 3601,
     /*  94045 */   GIR_EraseRootFromParent_Done,
     /*  94046 */ // Label 1330: @94046
     /*  94046 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(94104), // Rule ID 3607 //
     /*  94051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /*  94054 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94057 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  94069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  94080 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  94080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /*  94083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  94085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  94090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  94095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94102 */   GIR_RootConstrainSelectedInstOperands,
     /*  94103 */   // GIR_Coverage, 3607,
     /*  94103 */   GIR_EraseRootFromParent_Done,
     /*  94104 */ // Label 1331: @94104
     /*  94104 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(94162), // Rule ID 3613 //
     /*  94109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /*  94112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94115 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  94123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /*  94127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /*  94138 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_SHORT_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SHORT_D16_t16),
     /*  94141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  94143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  94148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  94153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94160 */   GIR_RootConstrainSelectedInstOperands,
     /*  94161 */   // GIR_Coverage, 3613,
     /*  94161 */   GIR_EraseRootFromParent_Done,
     /*  94162 */ // Label 1332: @94162
     /*  94162 */ GIM_Reject,
     /*  94163 */ // Label 1006: @94163
     /*  94163 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(94230), // Rule ID 2898 //
     /*  94168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  94171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94174 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94186 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94190 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94194 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  94201 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  94204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  94221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94228 */   GIR_RootConstrainSelectedInstOperands,
     /*  94229 */   // GIR_Coverage, 2898,
     /*  94229 */   GIR_EraseRootFromParent_Done,
     /*  94230 */ // Label 1333: @94230
     /*  94230 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(94297), // Rule ID 2951 //
     /*  94235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  94238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94241 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94249 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94253 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94257 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94261 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  94268 */   // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  94271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  94288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94295 */   GIR_RootConstrainSelectedInstOperands,
     /*  94296 */   // GIR_Coverage, 2951,
     /*  94296 */   GIR_EraseRootFromParent_Done,
     /*  94297 */ // Label 1334: @94297
     /*  94297 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(94367), // Rule ID 2907 //
     /*  94302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  94305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94308 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94312 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  94319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94323 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94327 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  94331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  94338 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /*  94341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  94358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94365 */   GIR_RootConstrainSelectedInstOperands,
     /*  94366 */   // GIR_Coverage, 2907,
     /*  94366 */   GIR_EraseRootFromParent_Done,
     /*  94367 */ // Label 1335: @94367
     /*  94367 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(94437), // Rule ID 2922 //
     /*  94372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  94375 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94378 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94382 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  94389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94397 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  94401 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  94408 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /*  94411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  94428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94435 */   GIR_RootConstrainSelectedInstOperands,
     /*  94436 */   // GIR_Coverage, 2922,
     /*  94436 */   GIR_EraseRootFromParent_Done,
     /*  94437 */ // Label 1336: @94437
     /*  94437 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(94500), // Rule ID 2945 //
     /*  94442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  94445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94448 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94456 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94460 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  94471 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  94474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  94491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94498 */   GIR_RootConstrainSelectedInstOperands,
     /*  94499 */   // GIR_Coverage, 2945,
     /*  94499 */   GIR_EraseRootFromParent_Done,
     /*  94500 */ // Label 1337: @94500
     /*  94500 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(94563), // Rule ID 2957 //
     /*  94505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  94508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94523 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /*  94534 */   // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  94537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  94554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94561 */   GIR_RootConstrainSelectedInstOperands,
     /*  94562 */   // GIR_Coverage, 2957,
     /*  94562 */   GIR_EraseRootFromParent_Done,
     /*  94563 */ // Label 1338: @94563
     /*  94563 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(94625), // Rule ID 2894 //
     /*  94568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  94571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94574 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94582 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94586 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94590 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  94601 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  94604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  94616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94619 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94623 */   GIR_RootConstrainSelectedInstOperands,
     /*  94624 */   // GIR_Coverage, 2894,
     /*  94624 */   GIR_EraseRootFromParent_Done,
     /*  94625 */ // Label 1339: @94625
     /*  94625 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(94687), // Rule ID 2895 //
     /*  94630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  94633 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94648 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94652 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94656 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  94663 */   // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  94666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  94678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94685 */   GIR_RootConstrainSelectedInstOperands,
     /*  94686 */   // GIR_Coverage, 2895,
     /*  94686 */   GIR_EraseRootFromParent_Done,
     /*  94687 */ // Label 1340: @94687
     /*  94687 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(94749), // Rule ID 2896 //
     /*  94692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  94695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94710 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94714 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  94725 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  94725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  94728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94747 */   GIR_RootConstrainSelectedInstOperands,
     /*  94748 */   // GIR_Coverage, 2896,
     /*  94748 */   GIR_EraseRootFromParent_Done,
     /*  94749 */ // Label 1341: @94749
     /*  94749 */ GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(94814), // Rule ID 2897 //
     /*  94754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  94757 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94760 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94772 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94776 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94780 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  94787 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  94787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  94790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94812 */   GIR_RootConstrainSelectedInstOperands,
     /*  94813 */   // GIR_Coverage, 2897,
     /*  94813 */   GIR_EraseRootFromParent_Done,
     /*  94814 */ // Label 1342: @94814
     /*  94814 */ GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(94876), // Rule ID 2947 //
     /*  94819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  94822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94837 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94841 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  94852 */   // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  94855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  94867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94874 */   GIR_RootConstrainSelectedInstOperands,
     /*  94875 */   // GIR_Coverage, 2947,
     /*  94875 */   GIR_EraseRootFromParent_Done,
     /*  94876 */ // Label 1343: @94876
     /*  94876 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(94938), // Rule ID 2948 //
     /*  94881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /*  94884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94887 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94895 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94899 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94903 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  94914 */   // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  94914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  94917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  94929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94936 */   GIR_RootConstrainSelectedInstOperands,
     /*  94937 */   // GIR_Coverage, 2948,
     /*  94937 */   GIR_EraseRootFromParent_Done,
     /*  94938 */ // Label 1344: @94938
     /*  94938 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(95000), // Rule ID 2949 //
     /*  94943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /*  94946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  94949 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  94953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  94957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  94961 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  94965 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  94969 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  94976 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  94976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  94979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  94981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  94986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  94991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  94994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94998 */   GIR_RootConstrainSelectedInstOperands,
     /*  94999 */   // GIR_Coverage, 2949,
     /*  94999 */   GIR_EraseRootFromParent_Done,
     /*  95000 */ // Label 1345: @95000
     /*  95000 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(95065), // Rule ID 2950 //
     /*  95005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /*  95008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95019 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95023 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95027 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  95031 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  95038 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  95041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95063 */   GIR_RootConstrainSelectedInstOperands,
     /*  95064 */   // GIR_Coverage, 2950,
     /*  95064 */   GIR_EraseRootFromParent_Done,
     /*  95065 */ // Label 1346: @95065
     /*  95065 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(95130), // Rule ID 2905 //
     /*  95070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  95073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95076 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95095 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  95099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  95106 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  95106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /*  95109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95128 */   GIR_RootConstrainSelectedInstOperands,
     /*  95129 */   // GIR_Coverage, 2905,
     /*  95129 */   GIR_EraseRootFromParent_Done,
     /*  95130 */ // Label 1347: @95130
     /*  95130 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(95198), // Rule ID 2906 //
     /*  95135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  95138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95141 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95145 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95160 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  95164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  95171 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /*  95174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95196 */   GIR_RootConstrainSelectedInstOperands,
     /*  95197 */   // GIR_Coverage, 2906,
     /*  95197 */   GIR_EraseRootFromParent_Done,
     /*  95198 */ // Label 1348: @95198
     /*  95198 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(95263), // Rule ID 2920 //
     /*  95203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  95206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95209 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95213 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95228 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  95232 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  95239 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  95239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /*  95242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95257 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95261 */   GIR_RootConstrainSelectedInstOperands,
     /*  95262 */   // GIR_Coverage, 2920,
     /*  95262 */   GIR_EraseRootFromParent_Done,
     /*  95263 */ // Label 1349: @95263
     /*  95263 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(95331), // Rule ID 2921 //
     /*  95268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  95271 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95274 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95278 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95289 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95293 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  95297 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  95304 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /*  95307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95329 */   GIR_RootConstrainSelectedInstOperands,
     /*  95330 */   // GIR_Coverage, 2921,
     /*  95330 */   GIR_EraseRootFromParent_Done,
     /*  95331 */ // Label 1350: @95331
     /*  95331 */ GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(95386), // Rule ID 2941 //
     /*  95336 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95339 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95351 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  95362 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  95362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  95365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95384 */   GIR_RootConstrainSelectedInstOperands,
     /*  95385 */   // GIR_Coverage, 2941,
     /*  95385 */   GIR_EraseRootFromParent_Done,
     /*  95386 */ // Label 1351: @95386
     /*  95386 */ GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(95444), // Rule ID 2942 //
     /*  95391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  95394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95405 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95409 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  95420 */   // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  95420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  95423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95442 */   GIR_RootConstrainSelectedInstOperands,
     /*  95443 */   // GIR_Coverage, 2942,
     /*  95443 */   GIR_EraseRootFromParent_Done,
     /*  95444 */ // Label 1352: @95444
     /*  95444 */ GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(95502), // Rule ID 2943 //
     /*  95449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  95452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95467 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  95478 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  95478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  95481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95500 */   GIR_RootConstrainSelectedInstOperands,
     /*  95501 */   // GIR_Coverage, 2943,
     /*  95501 */   GIR_EraseRootFromParent_Done,
     /*  95502 */ // Label 1353: @95502
     /*  95502 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(95563), // Rule ID 2944 //
     /*  95507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  95510 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95513 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95521 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95525 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95529 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  95536 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  95539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95561 */   GIR_RootConstrainSelectedInstOperands,
     /*  95562 */   // GIR_Coverage, 2944,
     /*  95562 */   GIR_EraseRootFromParent_Done,
     /*  95563 */ // Label 1354: @95563
     /*  95563 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(95618), // Rule ID 2953 //
     /*  95568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95571 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95583 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /*  95594 */   // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  95594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  95597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95612 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95616 */   GIR_RootConstrainSelectedInstOperands,
     /*  95617 */   // GIR_Coverage, 2953,
     /*  95617 */   GIR_EraseRootFromParent_Done,
     /*  95618 */ // Label 1355: @95618
     /*  95618 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(95676), // Rule ID 2954 //
     /*  95623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /*  95626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95641 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95645 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /*  95652 */   // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  95652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /*  95655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  95667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95670 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95674 */   GIR_RootConstrainSelectedInstOperands,
     /*  95675 */   // GIR_Coverage, 2954,
     /*  95675 */   GIR_EraseRootFromParent_Done,
     /*  95676 */ // Label 1356: @95676
     /*  95676 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(95734), // Rule ID 2955 //
     /*  95681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /*  95684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95699 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95703 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  95710 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /*  95710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /*  95713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95728 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95732 */   GIR_RootConstrainSelectedInstOperands,
     /*  95733 */   // GIR_Coverage, 2955,
     /*  95733 */   GIR_EraseRootFromParent_Done,
     /*  95734 */ // Label 1357: @95734
     /*  95734 */ GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(95795), // Rule ID 2956 //
     /*  95739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /*  95742 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95745 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95753 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  95757 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /*  95768 */   // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /*  95771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /*  95778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  95783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95793 */   GIR_RootConstrainSelectedInstOperands,
     /*  95794 */   // GIR_Coverage, 2956,
     /*  95794 */   GIR_EraseRootFromParent_Done,
     /*  95795 */ // Label 1358: @95795
     /*  95795 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(95849), // Rule ID 2899 //
     /*  95800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  95803 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95814 */   // MIs[0] sbase
     /*  95814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  95818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  95822 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95826 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  95830 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  95833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95835 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  95837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95847 */   GIR_RootConstrainSelectedInstOperands,
     /*  95848 */   // GIR_Coverage, 2899,
     /*  95848 */   GIR_EraseRootFromParent_Done,
     /*  95849 */ // Label 1359: @95849
     /*  95849 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(95903), // Rule ID 2952 //
     /*  95854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /*  95857 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95868 */   // MIs[0] sbase
     /*  95868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  95872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  95876 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  95880 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /*  95884 */   // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  95887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95889 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  95891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95901 */   GIR_RootConstrainSelectedInstOperands,
     /*  95902 */   // GIR_Coverage, 2952,
     /*  95902 */   GIR_EraseRootFromParent_Done,
     /*  95903 */ // Label 1360: @95903
     /*  95903 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(95960), // Rule ID 2908 //
     /*  95908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  95911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95914 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  95925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95929 */   // MIs[0] sbase
     /*  95929 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  95933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  95937 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
     /*  95941 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /*  95944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  95946 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  95948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  95954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95958 */   GIR_RootConstrainSelectedInstOperands,
     /*  95959 */   // GIR_Coverage, 2908,
     /*  95959 */   GIR_EraseRootFromParent_Done,
     /*  95960 */ // Label 1361: @95960
     /*  95960 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(96017), // Rule ID 2923 //
     /*  95965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /*  95968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95971 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  95975 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  95982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  95986 */   // MIs[0] sbase
     /*  95986 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  95990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  95994 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
     /*  95998 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  95998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /*  96001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  96003 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  96005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96011 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96015 */   GIR_RootConstrainSelectedInstOperands,
     /*  96016 */   // GIR_Coverage, 2923,
     /*  96016 */   GIR_EraseRootFromParent_Done,
     /*  96017 */ // Label 1362: @96017
     /*  96017 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(96064), // Rule ID 2946 //
     /*  96022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  96033 */   // MIs[0] sbase
     /*  96033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  96037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  96041 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  96045 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  96045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  96048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  96050 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  96052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96062 */   GIR_RootConstrainSelectedInstOperands,
     /*  96063 */   // GIR_Coverage, 2946,
     /*  96063 */   GIR_EraseRootFromParent_Done,
     /*  96064 */ // Label 1363: @96064
     /*  96064 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(96111), // Rule ID 2958 //
     /*  96069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96072 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /*  96080 */   // MIs[0] sbase
     /*  96080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  96084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /*  96088 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /*  96092 */   // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /*  96092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /*  96095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /*  96097 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /*  96099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96109 */   GIR_RootConstrainSelectedInstOperands,
     /*  96110 */   // GIR_Coverage, 2958,
     /*  96110 */   GIR_EraseRootFromParent_Done,
     /*  96111 */ // Label 1364: @96111
     /*  96111 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(96185), // Rule ID 6455 //
     /*  96116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  96119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96122 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96126 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96133 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96146 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96153 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  96156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96183 */   GIR_RootConstrainSelectedInstOperands,
     /*  96184 */   // GIR_Coverage, 6455,
     /*  96184 */   GIR_EraseRootFromParent_Done,
     /*  96185 */ // Label 1365: @96185
     /*  96185 */ GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(96259), // Rule ID 6457 //
     /*  96190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  96193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96207 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96220 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96227 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  96230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96253 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96257 */   GIR_RootConstrainSelectedInstOperands,
     /*  96258 */   // GIR_Coverage, 6457,
     /*  96258 */   GIR_EraseRootFromParent_Done,
     /*  96259 */ // Label 1366: @96259
     /*  96259 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(96333), // Rule ID 6479 //
     /*  96264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  96267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96270 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96281 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96301 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  96304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96331 */   GIR_RootConstrainSelectedInstOperands,
     /*  96332 */   // GIR_Coverage, 6479,
     /*  96332 */   GIR_EraseRootFromParent_Done,
     /*  96333 */ // Label 1367: @96333
     /*  96333 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(96407), // Rule ID 6481 //
     /*  96338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  96341 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96344 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96348 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96355 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96375 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  96378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96405 */   GIR_RootConstrainSelectedInstOperands,
     /*  96406 */   // GIR_Coverage, 6481,
     /*  96406 */   GIR_EraseRootFromParent_Done,
     /*  96407 */ // Label 1368: @96407
     /*  96407 */ GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(96470), // Rule ID 6491 //
     /*  96412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  96415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96418 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96431 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96438 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  96441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96468 */   GIR_RootConstrainSelectedInstOperands,
     /*  96469 */   // GIR_Coverage, 6491,
     /*  96469 */   GIR_EraseRootFromParent_Done,
     /*  96470 */ // Label 1369: @96470
     /*  96470 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(96533), // Rule ID 6493 //
     /*  96475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  96478 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96481 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96501 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  96504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96531 */   GIR_RootConstrainSelectedInstOperands,
     /*  96532 */   // GIR_Coverage, 6493,
     /*  96532 */   GIR_EraseRootFromParent_Done,
     /*  96533 */ // Label 1370: @96533
     /*  96533 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(96596), // Rule ID 6495 //
     /*  96538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  96541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96544 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96564 */   // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  96567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96594 */   GIR_RootConstrainSelectedInstOperands,
     /*  96595 */   // GIR_Coverage, 6495,
     /*  96595 */   GIR_EraseRootFromParent_Done,
     /*  96596 */ // Label 1371: @96596
     /*  96596 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(96659), // Rule ID 6497 //
     /*  96601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  96604 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96607 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /*  96627 */   // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  96627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  96630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  96632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  96637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  96642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96657 */   GIR_RootConstrainSelectedInstOperands,
     /*  96658 */   // GIR_Coverage, 6497,
     /*  96658 */   GIR_EraseRootFromParent_Done,
     /*  96659 */ // Label 1372: @96659
     /*  96659 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(96730), // Rule ID 3568 //
     /*  96664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  96667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96670 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96681 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  96701 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  96701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /*  96704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  96711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  96716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96728 */   GIR_RootConstrainSelectedInstOperands,
     /*  96729 */   // GIR_Coverage, 3568,
     /*  96729 */   GIR_EraseRootFromParent_Done,
     /*  96730 */ // Label 1373: @96730
     /*  96730 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(96801), // Rule ID 4199 //
     /*  96735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  96738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96741 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96745 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  96752 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96761 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  96772 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  96772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /*  96775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  96782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  96787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96799 */   GIR_RootConstrainSelectedInstOperands,
     /*  96800 */   // GIR_Coverage, 4199,
     /*  96800 */   GIR_EraseRootFromParent_Done,
     /*  96801 */ // Label 1374: @96801
     /*  96801 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(96861), // Rule ID 4253 //
     /*  96806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  96809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96812 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  96832 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  96832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  96835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  96842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  96847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96855 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96859 */   GIR_RootConstrainSelectedInstOperands,
     /*  96860 */   // GIR_Coverage, 4253,
     /*  96860 */   GIR_EraseRootFromParent_Done,
     /*  96861 */ // Label 1375: @96861
     /*  96861 */ GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(96921), // Rule ID 4259 //
     /*  96866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /*  96869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96872 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96881 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /*  96892 */   // (ld:{ *:[f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /*  96892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /*  96895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  96902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /*  96907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  96912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96919 */   GIR_RootConstrainSelectedInstOperands,
     /*  96920 */   // GIR_Coverage, 4259,
     /*  96920 */   GIR_EraseRootFromParent_Done,
     /*  96921 */ // Label 1376: @96921
     /*  96921 */ GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(96987), // Rule ID 3567 //
     /*  96926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  96929 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96932 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  96936 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  96943 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  96948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  96952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  96956 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  96963 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  96963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /*  96966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  96968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  96973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  96978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  96981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96985 */   GIR_RootConstrainSelectedInstOperands,
     /*  96986 */   // GIR_Coverage, 3567,
     /*  96986 */   GIR_EraseRootFromParent_Done,
     /*  96987 */ // Label 1377: @96987
     /*  96987 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(97053), // Rule ID 4198 //
     /*  96992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  96995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96998 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97002 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97009 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  97014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  97029 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  97029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /*  97032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97051 */   GIR_RootConstrainSelectedInstOperands,
     /*  97052 */   // GIR_Coverage, 4198,
     /*  97052 */   GIR_EraseRootFromParent_Done,
     /*  97053 */ // Label 1378: @97053
     /*  97053 */ GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(97108), // Rule ID 4252 //
     /*  97058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  97061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97064 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  97069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  97084 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  97084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  97087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97106 */   GIR_RootConstrainSelectedInstOperands,
     /*  97107 */   // GIR_Coverage, 4252,
     /*  97107 */   GIR_EraseRootFromParent_Done,
     /*  97108 */ // Label 1379: @97108
     /*  97108 */ GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(97163), // Rule ID 4258 //
     /*  97113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  97116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97119 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  97124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97132 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /*  97139 */   // (ld:{ *:[f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /*  97139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /*  97142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /*  97149 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97161 */   GIR_RootConstrainSelectedInstOperands,
     /*  97162 */   // GIR_Coverage, 4258,
     /*  97162 */   GIR_EraseRootFromParent_Done,
     /*  97163 */ // Label 1380: @97163
     /*  97163 */ GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(97229), // Rule ID 3566 //
     /*  97168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  97171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97174 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97178 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97185 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  97190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97194 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  97205 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /*  97208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97227 */   GIR_RootConstrainSelectedInstOperands,
     /*  97228 */   // GIR_Coverage, 3566,
     /*  97228 */   GIR_EraseRootFromParent_Done,
     /*  97229 */ // Label 1381: @97229
     /*  97229 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(97295), // Rule ID 4197 //
     /*  97234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  97237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97240 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97251 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  97256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  97271 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /*  97274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97293 */   GIR_RootConstrainSelectedInstOperands,
     /*  97294 */   // GIR_Coverage, 4197,
     /*  97294 */   GIR_EraseRootFromParent_Done,
     /*  97295 */ // Label 1382: @97295
     /*  97295 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(97350), // Rule ID 4251 //
     /*  97300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  97303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97306 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  97311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  97326 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  97329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97348 */   GIR_RootConstrainSelectedInstOperands,
     /*  97349 */   // GIR_Coverage, 4251,
     /*  97349 */   GIR_EraseRootFromParent_Done,
     /*  97350 */ // Label 1383: @97350
     /*  97350 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(97405), // Rule ID 4257 //
     /*  97355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /*  97358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97361 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  97366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97370 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97374 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /*  97381 */   // (ld:{ *:[f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /*  97381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /*  97384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /*  97386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /*  97391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  97396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97399 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97403 */   GIR_RootConstrainSelectedInstOperands,
     /*  97404 */   // GIR_Coverage, 4257,
     /*  97404 */   GIR_EraseRootFromParent_Done,
     /*  97405 */ // Label 1384: @97405
     /*  97405 */ GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(97486), // Rule ID 4441 //
     /*  97410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  97413 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97416 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97420 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97427 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97438 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97442 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  97449 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  97449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  97452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  97454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  97459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  97464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  97469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  97474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97484 */   GIR_RootConstrainSelectedInstOperands,
     /*  97485 */   // GIR_Coverage, 4441,
     /*  97485 */   GIR_EraseRootFromParent_Done,
     /*  97486 */ // Label 1385: @97486
     /*  97486 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(97564), // Rule ID 4445 //
     /*  97491 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97494 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97498 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97505 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  97527 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  97527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  97530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  97532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  97537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  97542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  97547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  97552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97562 */   GIR_RootConstrainSelectedInstOperands,
     /*  97563 */   // GIR_Coverage, 4445,
     /*  97563 */   GIR_EraseRootFromParent_Done,
     /*  97564 */ // Label 1386: @97564
     /*  97564 */ GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(97645), // Rule ID 4451 //
     /*  97569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  97572 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97575 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97579 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97586 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  97608 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  97608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  97611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  97613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  97618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  97623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  97628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  97633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97643 */   GIR_RootConstrainSelectedInstOperands,
     /*  97644 */   // GIR_Coverage, 4451,
     /*  97644 */   GIR_EraseRootFromParent_Done,
     /*  97645 */ // Label 1387: @97645
     /*  97645 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(97723), // Rule ID 4453 //
     /*  97650 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  97653 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97657 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97664 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97679 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  97686 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  97686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  97689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  97691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  97696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  97701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  97706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  97711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97717 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97721 */   GIR_RootConstrainSelectedInstOperands,
     /*  97722 */   // GIR_Coverage, 4453,
     /*  97722 */   GIR_EraseRootFromParent_Done,
     /*  97723 */ // Label 1388: @97723
     /*  97723 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(97804), // Rule ID 4471 //
     /*  97728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  97731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97734 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97738 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97745 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97756 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97760 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  97767 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  97767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  97770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  97772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  97777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  97782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  97787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  97792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97802 */   GIR_RootConstrainSelectedInstOperands,
     /*  97803 */   // GIR_Coverage, 4471,
     /*  97803 */   GIR_EraseRootFromParent_Done,
     /*  97804 */ // Label 1389: @97804
     /*  97804 */ GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(97882), // Rule ID 4473 //
     /*  97809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  97823 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97838 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  97845 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  97845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /*  97848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  97850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  97855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  97860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  97865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  97870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97880 */   GIR_RootConstrainSelectedInstOperands,
     /*  97881 */   // GIR_Coverage, 4473,
     /*  97881 */   GIR_EraseRootFromParent_Done,
     /*  97882 */ // Label 1390: @97882
     /*  97882 */ GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(97963), // Rule ID 4491 //
     /*  97887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  97890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97893 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97897 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97904 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  97926 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  97926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  97929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  97931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  97936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  97941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  97946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  97951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97961 */   GIR_RootConstrainSelectedInstOperands,
     /*  97962 */   // GIR_Coverage, 4491,
     /*  97962 */   GIR_EraseRootFromParent_Done,
     /*  97963 */ // Label 1391: @97963
     /*  97963 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(98041), // Rule ID 4493 //
     /*  97968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97971 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  97975 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  97982 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  97989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  97993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  97997 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98004 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  98004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /*  98007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98039 */   GIR_RootConstrainSelectedInstOperands,
     /*  98040 */   // GIR_Coverage, 4493,
     /*  98040 */   GIR_EraseRootFromParent_Done,
     /*  98041 */ // Label 1392: @98041
     /*  98041 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(98122), // Rule ID 6424 //
     /*  98046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  98049 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  98052 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98056 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98063 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98074 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98078 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98085 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_atomic_load_nonext_32_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  98085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  98088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98120 */   GIR_RootConstrainSelectedInstOperands,
     /*  98121 */   // GIR_Coverage, 6424,
     /*  98121 */   GIR_EraseRootFromParent_Done,
     /*  98122 */ // Label 1393: @98122
     /*  98122 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(98202), // Rule ID 6427 //
     /*  98127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  98130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98133 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98144 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98165 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  98165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /*  98168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98200 */   GIR_RootConstrainSelectedInstOperands,
     /*  98201 */   // GIR_Coverage, 6427,
     /*  98201 */   GIR_EraseRootFromParent_Done,
     /*  98202 */ // Label 1394: @98202
     /*  98202 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(98282), // Rule ID 6430 //
     /*  98207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /*  98210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98213 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98217 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98224 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98238 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98245 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /*  98245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /*  98248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98276 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98280 */   GIR_RootConstrainSelectedInstOperands,
     /*  98281 */   // GIR_Coverage, 6430,
     /*  98281 */   GIR_EraseRootFromParent_Done,
     /*  98282 */ // Label 1395: @98282
     /*  98282 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(98361), // Rule ID 6454 //
     /*  98287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  98290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98293 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98304 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  98309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  98324 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  98324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /*  98327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98355 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98359 */   GIR_RootConstrainSelectedInstOperands,
     /*  98360 */   // GIR_Coverage, 6454,
     /*  98360 */   GIR_EraseRootFromParent_Done,
     /*  98361 */ // Label 1396: @98361
     /*  98361 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(98440), // Rule ID 6456 //
     /*  98366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  98369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98372 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98383 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  98388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  98403 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  98403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /*  98406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98438 */   GIR_RootConstrainSelectedInstOperands,
     /*  98439 */   // GIR_Coverage, 6456,
     /*  98439 */   GIR_EraseRootFromParent_Done,
     /*  98440 */ // Label 1397: @98440
     /*  98440 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(98519), // Rule ID 6478 //
     /*  98445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  98448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98451 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98462 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  98467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98475 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  98482 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  98482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /*  98485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98517 */   GIR_RootConstrainSelectedInstOperands,
     /*  98518 */   // GIR_Coverage, 6478,
     /*  98518 */   GIR_EraseRootFromParent_Done,
     /*  98519 */ // Label 1398: @98519
     /*  98519 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(98598), // Rule ID 6480 //
     /*  98524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  98527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98530 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98534 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98541 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  98546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  98561 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  98561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /*  98564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98596 */   GIR_RootConstrainSelectedInstOperands,
     /*  98597 */   // GIR_Coverage, 6480,
     /*  98597 */   GIR_EraseRootFromParent_Done,
     /*  98598 */ // Label 1399: @98598
     /*  98598 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(98668), // Rule ID 4507 //
     /*  98603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  98606 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98609 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98631 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  98631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  98634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98666 */   GIR_RootConstrainSelectedInstOperands,
     /*  98667 */   // GIR_Coverage, 4507,
     /*  98667 */   GIR_EraseRootFromParent_Done,
     /*  98668 */ // Label 1400: @98668
     /*  98668 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(98735), // Rule ID 4509 //
     /*  98673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98676 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98698 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  98698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  98701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98733 */   GIR_RootConstrainSelectedInstOperands,
     /*  98734 */   // GIR_Coverage, 4509,
     /*  98734 */   GIR_EraseRootFromParent_Done,
     /*  98735 */ // Label 1401: @98735
     /*  98735 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(98805), // Rule ID 4511 //
     /*  98740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  98743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98746 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98761 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98768 */   // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  98768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /*  98771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98799 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98803 */   GIR_RootConstrainSelectedInstOperands,
     /*  98804 */   // GIR_Coverage, 4511,
     /*  98804 */   GIR_EraseRootFromParent_Done,
     /*  98805 */ // Label 1402: @98805
     /*  98805 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(98872), // Rule ID 4513 //
     /*  98810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98813 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  98820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98824 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /*  98835 */   // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  98835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /*  98838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98866 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98870 */   GIR_RootConstrainSelectedInstOperands,
     /*  98871 */   // GIR_Coverage, 4513,
     /*  98871 */   GIR_EraseRootFromParent_Done,
     /*  98872 */ // Label 1403: @98872
     /*  98872 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(98940), // Rule ID 6490 //
     /*  98877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  98880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98883 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  98888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  98903 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  98903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  98906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98938 */   GIR_RootConstrainSelectedInstOperands,
     /*  98939 */   // GIR_Coverage, 6490,
     /*  98939 */   GIR_EraseRootFromParent_Done,
     /*  98940 */ // Label 1404: @98940
     /*  98940 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(99008), // Rule ID 6492 //
     /*  98945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  98948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98951 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  98956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  98960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  98971 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  98971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  98974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  98976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  98981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  98986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  98991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  98996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99006 */   GIR_RootConstrainSelectedInstOperands,
     /*  99007 */   // GIR_Coverage, 6492,
     /*  99007 */   GIR_EraseRootFromParent_Done,
     /*  99008 */ // Label 1405: @99008
     /*  99008 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(99076), // Rule ID 6494 //
     /*  99013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /*  99016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99019 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  99024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  99039 */   // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  99039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /*  99042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  99049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  99059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  99064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99070 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99074 */   GIR_RootConstrainSelectedInstOperands,
     /*  99075 */   // GIR_Coverage, 6494,
     /*  99075 */   GIR_EraseRootFromParent_Done,
     /*  99076 */ // Label 1406: @99076
     /*  99076 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(99144), // Rule ID 6496 //
     /*  99081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /*  99084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99087 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /*  99092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /*  99107 */   // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /*  99107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /*  99110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /*  99117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /*  99127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /*  99132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99142 */   GIR_RootConstrainSelectedInstOperands,
     /*  99143 */   // GIR_Coverage, 6496,
     /*  99143 */   GIR_EraseRootFromParent_Done,
     /*  99144 */ // Label 1407: @99144
     /*  99144 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(99220), // Rule ID 4440 //
     /*  99149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  99152 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99155 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99166 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99188 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  99191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99218 */   GIR_RootConstrainSelectedInstOperands,
     /*  99219 */   // GIR_Coverage, 4440,
     /*  99219 */   GIR_EraseRootFromParent_Done,
     /*  99220 */ // Label 1408: @99220
     /*  99220 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(99293), // Rule ID 4444 //
     /*  99225 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99228 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99232 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99239 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99250 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99254 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99261 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  99264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99291 */   GIR_RootConstrainSelectedInstOperands,
     /*  99292 */   // GIR_Coverage, 4444,
     /*  99292 */   GIR_EraseRootFromParent_Done,
     /*  99293 */ // Label 1409: @99293
     /*  99293 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(99369), // Rule ID 4450 //
     /*  99298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  99301 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99304 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99308 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99315 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99337 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  99340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99367 */   GIR_RootConstrainSelectedInstOperands,
     /*  99368 */   // GIR_Coverage, 4450,
     /*  99368 */   GIR_EraseRootFromParent_Done,
     /*  99369 */ // Label 1410: @99369
     /*  99369 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(99442), // Rule ID 4452 //
     /*  99374 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99377 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99381 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99388 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99410 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  99413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99440 */   GIR_RootConstrainSelectedInstOperands,
     /*  99441 */   // GIR_Coverage, 4452,
     /*  99441 */   GIR_EraseRootFromParent_Done,
     /*  99442 */ // Label 1411: @99442
     /*  99442 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(99518), // Rule ID 4470 //
     /*  99447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  99450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99453 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99457 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99464 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99475 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99479 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99486 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /*  99489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99516 */   GIR_RootConstrainSelectedInstOperands,
     /*  99517 */   // GIR_Coverage, 4470,
     /*  99517 */   GIR_EraseRootFromParent_Done,
     /*  99518 */ // Label 1412: @99518
     /*  99518 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(99591), // Rule ID 4472 //
     /*  99523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99526 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99537 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99548 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99552 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99559 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /*  99562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99589 */   GIR_RootConstrainSelectedInstOperands,
     /*  99590 */   // GIR_Coverage, 4472,
     /*  99590 */   GIR_EraseRootFromParent_Done,
     /*  99591 */ // Label 1413: @99591
     /*  99591 */ GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(99667), // Rule ID 4490 //
     /*  99596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  99599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99602 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99613 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99635 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /*  99638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99665 */   GIR_RootConstrainSelectedInstOperands,
     /*  99666 */   // GIR_Coverage, 4490,
     /*  99666 */   GIR_EraseRootFromParent_Done,
     /*  99667 */ // Label 1414: @99667
     /*  99667 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(99740), // Rule ID 4492 //
     /*  99672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99675 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99679 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99686 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99708 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /*  99711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99738 */   GIR_RootConstrainSelectedInstOperands,
     /*  99739 */   // GIR_Coverage, 4492,
     /*  99739 */   GIR_EraseRootFromParent_Done,
     /*  99740 */ // Label 1415: @99740
     /*  99740 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(99805), // Rule ID 4506 //
     /*  99745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  99748 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99751 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99773 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  99776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99799 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99803 */   GIR_RootConstrainSelectedInstOperands,
     /*  99804 */   // GIR_Coverage, 4506,
     /*  99804 */   GIR_EraseRootFromParent_Done,
     /*  99805 */ // Label 1416: @99805
     /*  99805 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(99867), // Rule ID 4508 //
     /*  99810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99813 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99824 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99835 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  99838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99865 */   GIR_RootConstrainSelectedInstOperands,
     /*  99866 */   // GIR_Coverage, 4508,
     /*  99866 */   GIR_EraseRootFromParent_Done,
     /*  99867 */ // Label 1417: @99867
     /*  99867 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(99932), // Rule ID 4510 //
     /*  99872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /*  99875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99878 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99900 */   // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /*  99903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99926 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99930 */   GIR_RootConstrainSelectedInstOperands,
     /*  99931 */   // GIR_Coverage, 4510,
     /*  99931 */   GIR_EraseRootFromParent_Done,
     /*  99932 */ // Label 1418: @99932
     /*  99932 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(99994), // Rule ID 4512 //
     /*  99937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99940 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /*  99947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /*  99951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /*  99962 */   // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /*  99962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /*  99965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /*  99967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /*  99972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /*  99977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99992 */   GIR_RootConstrainSelectedInstOperands,
     /*  99993 */   // GIR_Coverage, 4512,
     /*  99993 */   GIR_EraseRootFromParent_Done,
     /*  99994 */ // Label 1419: @99994
     /*  99994 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(100060), // Rule ID 7933 //
     /*  99999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100002 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100005 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100009 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100016 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100025 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100036 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 100039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100058 */   GIR_RootConstrainSelectedInstOperands,
     /* 100059 */   // GIR_Coverage, 7933,
     /* 100059 */   GIR_EraseRootFromParent_Done,
     /* 100060 */ // Label 1420: @100060
     /* 100060 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(100126), // Rule ID 7934 //
     /* 100065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 100068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100071 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100082 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100102 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 100105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100124 */   GIR_RootConstrainSelectedInstOperands,
     /* 100125 */   // GIR_Coverage, 7934,
     /* 100125 */   GIR_EraseRootFromParent_Done,
     /* 100126 */ // Label 1421: @100126
     /* 100126 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(100192), // Rule ID 7941 //
     /* 100131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100137 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100141 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100148 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100168 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi16_glue>><<P:Predicate_extloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 100171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100190 */   GIR_RootConstrainSelectedInstOperands,
     /* 100191 */   // GIR_Coverage, 7941,
     /* 100191 */   GIR_EraseRootFromParent_Done,
     /* 100192 */ // Label 1422: @100192
     /* 100192 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(100258), // Rule ID 7942 //
     /* 100197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 100200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100203 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100207 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100214 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100223 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100234 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 100237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100256 */   GIR_RootConstrainSelectedInstOperands,
     /* 100257 */   // GIR_Coverage, 7942,
     /* 100257 */   GIR_EraseRootFromParent_Done,
     /* 100258 */ // Label 1423: @100258
     /* 100258 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(100324), // Rule ID 7978 //
     /* 100263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100266 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100269 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100273 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100280 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100289 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100293 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100300 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext_glue>><<P:Predicate_atomic_load_aext_8_glue>><<P:Predicate_atomic_load_aext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 100303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100322 */   GIR_RootConstrainSelectedInstOperands,
     /* 100323 */   // GIR_Coverage, 7978,
     /* 100323 */   GIR_EraseRootFromParent_Done,
     /* 100324 */ // Label 1424: @100324
     /* 100324 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(100390), // Rule ID 7979 //
     /* 100329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 100332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100335 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100346 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100359 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100366 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 100369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100388 */   GIR_RootConstrainSelectedInstOperands,
     /* 100389 */   // GIR_Coverage, 7979,
     /* 100389 */   GIR_EraseRootFromParent_Done,
     /* 100390 */ // Label 1425: @100390
     /* 100390 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(100456), // Rule ID 7996 //
     /* 100395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100398 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100401 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100412 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100421 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100425 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100432 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext_glue>><<P:Predicate_atomic_load_aext_16_glue>><<P:Predicate_atomic_load_aext_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 100435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100454 */   GIR_RootConstrainSelectedInstOperands,
     /* 100455 */   // GIR_Coverage, 7996,
     /* 100455 */   GIR_EraseRootFromParent_Done,
     /* 100456 */ // Label 1426: @100456
     /* 100456 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(100522), // Rule ID 7997 //
     /* 100461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 100464 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100467 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100471 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100478 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100498 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 100501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100520 */   GIR_RootConstrainSelectedInstOperands,
     /* 100521 */   // GIR_Coverage, 7997,
     /* 100521 */   GIR_EraseRootFromParent_Done,
     /* 100522 */ // Label 1427: @100522
     /* 100522 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(100588), // Rule ID 8002 //
     /* 100527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100530 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100533 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100537 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100544 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100564 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext_glue>><<P:Predicate_atomic_load_nonext_32_glue>><<P:Predicate_atomic_load_nonext_32_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 100567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100582 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100586 */   GIR_RootConstrainSelectedInstOperands,
     /* 100587 */   // GIR_Coverage, 8002,
     /* 100587 */   GIR_EraseRootFromParent_Done,
     /* 100588 */ // Label 1428: @100588
     /* 100588 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(100654), // Rule ID 8003 //
     /* 100593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 100596 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100599 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100610 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100630 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_atomic_load_nonext_32_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 100633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100652 */   GIR_RootConstrainSelectedInstOperands,
     /* 100653 */   // GIR_Coverage, 8003,
     /* 100653 */   GIR_EraseRootFromParent_Done,
     /* 100654 */ // Label 1429: @100654
     /* 100654 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(100713), // Rule ID 7958 //
     /* 100659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100665 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100669 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100678 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100682 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100689 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 100692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100711 */   GIR_RootConstrainSelectedInstOperands,
     /* 100712 */   // GIR_Coverage, 7958,
     /* 100712 */   GIR_EraseRootFromParent_Done,
     /* 100713 */ // Label 1430: @100713
     /* 100713 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(100772), // Rule ID 7960 //
     /* 100718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 100721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100728 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100737 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100741 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100748 */   // (AMDGPUld_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 100751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100770 */   GIR_RootConstrainSelectedInstOperands,
     /* 100771 */   // GIR_Coverage, 7960,
     /* 100771 */   GIR_EraseRootFromParent_Done,
     /* 100772 */ // Label 1431: @100772
     /* 100772 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(100827), // Rule ID 7959 //
     /* 100777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 100780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100783 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100803 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 100806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100821 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100825 */   GIR_RootConstrainSelectedInstOperands,
     /* 100826 */   // GIR_Coverage, 7959,
     /* 100826 */   GIR_EraseRootFromParent_Done,
     /* 100827 */ // Label 1432: @100827
     /* 100827 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(100882), // Rule ID 7961 //
     /* 100832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 100835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100838 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 100843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 100858 */   // (ld:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 100858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 100861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 100868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100880 */   GIR_RootConstrainSelectedInstOperands,
     /* 100881 */   // GIR_Coverage, 7961,
     /* 100881 */   GIR_EraseRootFromParent_Done,
     /* 100882 */ // Label 1433: @100882
     /* 100882 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(100955), // Rule ID 3553 //
     /* 100887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 100890 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100893 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100897 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100904 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 100911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 100926 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 100929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 100931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 100936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 100941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100953 */   GIR_RootConstrainSelectedInstOperands,
     /* 100954 */   // GIR_Coverage, 3553,
     /* 100954 */   GIR_EraseRootFromParent_Done,
     /* 100955 */ // Label 1434: @100955
     /* 100955 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(101028), // Rule ID 3814 //
     /* 100960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 100963 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100966 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100970 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100977 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 100984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 100988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 100999 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 100999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 101002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 101009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 101014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 101019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101022 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101026 */   GIR_RootConstrainSelectedInstOperands,
     /* 101027 */   // GIR_Coverage, 3814,
     /* 101027 */   GIR_EraseRootFromParent_Done,
     /* 101028 */ // Label 1435: @101028
     /* 101028 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(101101), // Rule ID 3826 //
     /* 101033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101039 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101043 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101050 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 101072 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 101075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 101082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 101087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 101092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101099 */   GIR_RootConstrainSelectedInstOperands,
     /* 101100 */   // GIR_Coverage, 3826,
     /* 101100 */   GIR_EraseRootFromParent_Done,
     /* 101101 */ // Label 1436: @101101
     /* 101101 */ GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(101174), // Rule ID 3832 //
     /* 101106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101112 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101116 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101123 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 101145 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 101148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 101155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 101160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 101165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101168 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101172 */   GIR_RootConstrainSelectedInstOperands,
     /* 101173 */   // GIR_Coverage, 3832,
     /* 101173 */   GIR_EraseRootFromParent_Done,
     /* 101174 */ // Label 1437: @101174
     /* 101174 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(101247), // Rule ID 3962 //
     /* 101179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101182 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101185 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101196 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 101218 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_atomic_load_nonext_32_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 101221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 101228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 101233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 101238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101241 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101245 */   GIR_RootConstrainSelectedInstOperands,
     /* 101246 */   // GIR_Coverage, 3962,
     /* 101246 */   GIR_EraseRootFromParent_Done,
     /* 101247 */ // Label 1438: @101247
     /* 101247 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(101309), // Rule ID 3870 //
     /* 101252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101258 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 101280 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 101283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 101290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 101295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 101300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101307 */   GIR_RootConstrainSelectedInstOperands,
     /* 101308 */   // GIR_Coverage, 3870,
     /* 101308 */   GIR_EraseRootFromParent_Done,
     /* 101309 */ // Label 1439: @101309
     /* 101309 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(101371), // Rule ID 3872 //
     /* 101314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101320 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 101342 */   // (ld:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 101342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 101345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 101352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 101357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 101362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101369 */   GIR_RootConstrainSelectedInstOperands,
     /* 101370 */   // GIR_Coverage, 3872,
     /* 101370 */   GIR_EraseRootFromParent_Done,
     /* 101371 */ // Label 1440: @101371
     /* 101371 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(101439), // Rule ID 3552 //
     /* 101376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101379 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101382 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101386 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101393 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 101415 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 101418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101437 */   GIR_RootConstrainSelectedInstOperands,
     /* 101438 */   // GIR_Coverage, 3552,
     /* 101438 */   GIR_EraseRootFromParent_Done,
     /* 101439 */ // Label 1441: @101439
     /* 101439 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(101507), // Rule ID 3813 //
     /* 101444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101450 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101461 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 101483 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 101486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101505 */   GIR_RootConstrainSelectedInstOperands,
     /* 101506 */   // GIR_Coverage, 3813,
     /* 101506 */   GIR_EraseRootFromParent_Done,
     /* 101507 */ // Label 1442: @101507
     /* 101507 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(101575), // Rule ID 3825 //
     /* 101512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101518 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101529 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 101551 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 101554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101573 */   GIR_RootConstrainSelectedInstOperands,
     /* 101574 */   // GIR_Coverage, 3825,
     /* 101574 */   GIR_EraseRootFromParent_Done,
     /* 101575 */ // Label 1443: @101575
     /* 101575 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(101643), // Rule ID 3831 //
     /* 101580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101586 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101597 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 101619 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 101622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101641 */   GIR_RootConstrainSelectedInstOperands,
     /* 101642 */   // GIR_Coverage, 3831,
     /* 101642 */   GIR_EraseRootFromParent_Done,
     /* 101643 */ // Label 1444: @101643
     /* 101643 */ GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(101711), // Rule ID 3961 //
     /* 101648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101651 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101654 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101665 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101676 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101680 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 101687 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_atomic_load_nonext_32_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 101690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101709 */   GIR_RootConstrainSelectedInstOperands,
     /* 101710 */   // GIR_Coverage, 3961,
     /* 101710 */   GIR_EraseRootFromParent_Done,
     /* 101711 */ // Label 1445: @101711
     /* 101711 */ GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(101768), // Rule ID 3869 //
     /* 101716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101719 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101722 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 101744 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 101747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101766 */   GIR_RootConstrainSelectedInstOperands,
     /* 101767 */   // GIR_Coverage, 3869,
     /* 101767 */   GIR_EraseRootFromParent_Done,
     /* 101768 */ // Label 1446: @101768
     /* 101768 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(101825), // Rule ID 3871 //
     /* 101773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 101776 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101779 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 101801 */   // (ld:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 101804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101823 */   GIR_RootConstrainSelectedInstOperands,
     /* 101824 */   // GIR_Coverage, 3871,
     /* 101824 */   GIR_EraseRootFromParent_Done,
     /* 101825 */ // Label 1447: @101825
     /* 101825 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(101894), // Rule ID 3581 //
     /* 101830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 101833 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101836 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101840 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101847 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 101870 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_atomic_load_aext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 101873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101892 */   GIR_RootConstrainSelectedInstOperands,
     /* 101893 */   // GIR_Coverage, 3581,
     /* 101893 */   GIR_EraseRootFromParent_Done,
     /* 101894 */ // Label 1448: @101894
     /* 101894 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(101963), // Rule ID 3585 //
     /* 101899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 101902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101905 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101909 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101916 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101928 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101932 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 101939 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_atomic_load_aext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 101939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 101942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 101944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 101949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101957 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101961 */   GIR_RootConstrainSelectedInstOperands,
     /* 101962 */   // GIR_Coverage, 3585,
     /* 101962 */   GIR_EraseRootFromParent_Done,
     /* 101963 */ // Label 1449: @101963
     /* 101963 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(102032), // Rule ID 3588 //
     /* 101968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 101971 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101974 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101985 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 101993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 101997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 102008 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 102011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102030 */   GIR_RootConstrainSelectedInstOperands,
     /* 102031 */   // GIR_Coverage, 3588,
     /* 102031 */   GIR_EraseRootFromParent_Done,
     /* 102032 */ // Label 1450: @102032
     /* 102032 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(102101), // Rule ID 3593 //
     /* 102037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 102040 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102043 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102054 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 102066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 102077 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 102080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102099 */   GIR_RootConstrainSelectedInstOperands,
     /* 102100 */   // GIR_Coverage, 3593,
     /* 102100 */   GIR_EraseRootFromParent_Done,
     /* 102101 */ // Label 1451: @102101
     /* 102101 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(102170), // Rule ID 3616 //
     /* 102106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 102109 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102116 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102123 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 102135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102139 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 102146 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_atomic_load_nonext_32_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 102149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102164 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102168 */   GIR_RootConstrainSelectedInstOperands,
     /* 102169 */   // GIR_Coverage, 3616,
     /* 102169 */   GIR_EraseRootFromParent_Done,
     /* 102170 */ // Label 1452: @102170
     /* 102170 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(102228), // Rule ID 3620 //
     /* 102175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 102178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102181 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 102193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 102204 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 102207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102226 */   GIR_RootConstrainSelectedInstOperands,
     /* 102227 */   // GIR_Coverage, 3620,
     /* 102227 */   GIR_EraseRootFromParent_Done,
     /* 102228 */ // Label 1453: @102228
     /* 102228 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(102286), // Rule ID 3622 //
     /* 102233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 102236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102239 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 102247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 102251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 102262 */   // (ld:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 102262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 102265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 102267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 102272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102280 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102284 */   GIR_RootConstrainSelectedInstOperands,
     /* 102285 */   // GIR_Coverage, 3622,
     /* 102285 */   GIR_EraseRootFromParent_Done,
     /* 102286 */ // Label 1454: @102286
     /* 102286 */ GIM_Reject,
     /* 102287 */ // Label 1007: @102287
     /* 102287 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(102354), // Rule ID 3052 //
     /* 102292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 102295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102310 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102314 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 102318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102325 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 102328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102352 */   GIR_RootConstrainSelectedInstOperands,
     /* 102353 */   // GIR_Coverage, 3052,
     /* 102353 */   GIR_EraseRootFromParent_Done,
     /* 102354 */ // Label 1455: @102354
     /* 102354 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(102421), // Rule ID 3086 //
     /* 102359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 102362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102365 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102377 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102381 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 102385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102392 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 102395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102419 */   GIR_RootConstrainSelectedInstOperands,
     /* 102420 */   // GIR_Coverage, 3086,
     /* 102420 */   GIR_EraseRootFromParent_Done,
     /* 102421 */ // Label 1456: @102421
     /* 102421 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(102488), // Rule ID 8476 //
     /* 102426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 102429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102444 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102448 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 102452 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102459 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 102462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102482 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102486 */   GIR_RootConstrainSelectedInstOperands,
     /* 102487 */   // GIR_Coverage, 8476,
     /* 102487 */   GIR_EraseRootFromParent_Done,
     /* 102488 */ // Label 1457: @102488
     /* 102488 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(102551), // Rule ID 3057 //
     /* 102493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 102496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102499 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102507 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102511 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102522 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 102525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102549 */   GIR_RootConstrainSelectedInstOperands,
     /* 102550 */   // GIR_Coverage, 3057,
     /* 102550 */   GIR_EraseRootFromParent_Done,
     /* 102551 */ // Label 1458: @102551
     /* 102551 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(102614), // Rule ID 3091 //
     /* 102556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 102559 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102562 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102574 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102578 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102585 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 102588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102612 */   GIR_RootConstrainSelectedInstOperands,
     /* 102613 */   // GIR_Coverage, 3091,
     /* 102613 */   GIR_EraseRootFromParent_Done,
     /* 102614 */ // Label 1459: @102614
     /* 102614 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(102677), // Rule ID 8481 //
     /* 102619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 102622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102625 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102633 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102637 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102641 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102648 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 102651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102675 */   GIR_RootConstrainSelectedInstOperands,
     /* 102676 */   // GIR_Coverage, 8481,
     /* 102676 */   GIR_EraseRootFromParent_Done,
     /* 102677 */ // Label 1460: @102677
     /* 102677 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(102740), // Rule ID 3063 //
     /* 102682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 102685 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102700 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102711 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 102714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102738 */   GIR_RootConstrainSelectedInstOperands,
     /* 102739 */   // GIR_Coverage, 3063,
     /* 102739 */   GIR_EraseRootFromParent_Done,
     /* 102740 */ // Label 1461: @102740
     /* 102740 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(102803), // Rule ID 3097 //
     /* 102745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 102748 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102751 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102763 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102774 */   // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 102777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102801 */   GIR_RootConstrainSelectedInstOperands,
     /* 102802 */   // GIR_Coverage, 3097,
     /* 102802 */   GIR_EraseRootFromParent_Done,
     /* 102803 */ // Label 1462: @102803
     /* 102803 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(102866), // Rule ID 8487 //
     /* 102808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 102811 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102814 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102826 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 102837 */   // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 102840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 102852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 102857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102864 */   GIR_RootConstrainSelectedInstOperands,
     /* 102865 */   // GIR_Coverage, 8487,
     /* 102865 */   GIR_EraseRootFromParent_Done,
     /* 102866 */ // Label 1463: @102866
     /* 102866 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(102928), // Rule ID 3048 //
     /* 102871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 102874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102877 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102889 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102893 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 102897 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 102904 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 102907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102919 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102926 */   GIR_RootConstrainSelectedInstOperands,
     /* 102927 */   // GIR_Coverage, 3048,
     /* 102927 */   GIR_EraseRootFromParent_Done,
     /* 102928 */ // Label 1464: @102928
     /* 102928 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(102990), // Rule ID 3049 //
     /* 102933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 102936 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102939 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 102947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102951 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 102955 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 102959 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 102966 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 102966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 102969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 102971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 102976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102988 */   GIR_RootConstrainSelectedInstOperands,
     /* 102989 */   // GIR_Coverage, 3049,
     /* 102989 */   GIR_EraseRootFromParent_Done,
     /* 102990 */ // Label 1465: @102990
     /* 102990 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(103052), // Rule ID 3050 //
     /* 102995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 102998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103013 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103017 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103021 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103028 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 103028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 103031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103046 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103050 */   GIR_RootConstrainSelectedInstOperands,
     /* 103051 */   // GIR_Coverage, 3050,
     /* 103051 */   GIR_EraseRootFromParent_Done,
     /* 103052 */ // Label 1466: @103052
     /* 103052 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(103117), // Rule ID 3051 //
     /* 103057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 103060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103063 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103075 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103079 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103090 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 103090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 103093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103115 */   GIR_RootConstrainSelectedInstOperands,
     /* 103116 */   // GIR_Coverage, 3051,
     /* 103116 */   GIR_EraseRootFromParent_Done,
     /* 103117 */ // Label 1467: @103117
     /* 103117 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(103179), // Rule ID 3082 //
     /* 103122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 103125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103128 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103136 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103140 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103144 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 103155 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 103158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103177 */   GIR_RootConstrainSelectedInstOperands,
     /* 103178 */   // GIR_Coverage, 3082,
     /* 103178 */   GIR_EraseRootFromParent_Done,
     /* 103179 */ // Label 1468: @103179
     /* 103179 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(103241), // Rule ID 3083 //
     /* 103184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 103187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103190 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103202 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103206 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 103217 */   // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 103220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103239 */   GIR_RootConstrainSelectedInstOperands,
     /* 103240 */   // GIR_Coverage, 3083,
     /* 103240 */   GIR_EraseRootFromParent_Done,
     /* 103241 */ // Label 1469: @103241
     /* 103241 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(103303), // Rule ID 3084 //
     /* 103246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 103249 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103252 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103264 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103268 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103279 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 103279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 103282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103301 */   GIR_RootConstrainSelectedInstOperands,
     /* 103302 */   // GIR_Coverage, 3084,
     /* 103302 */   GIR_EraseRootFromParent_Done,
     /* 103303 */ // Label 1470: @103303
     /* 103303 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(103368), // Rule ID 3085 //
     /* 103308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 103311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103314 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103322 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103326 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103330 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103341 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 103341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 103344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103366 */   GIR_RootConstrainSelectedInstOperands,
     /* 103367 */   // GIR_Coverage, 3085,
     /* 103367 */   GIR_EraseRootFromParent_Done,
     /* 103368 */ // Label 1471: @103368
     /* 103368 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(103430), // Rule ID 8472 //
     /* 103373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 103376 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103379 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103387 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103391 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103395 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103399 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 103406 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 103409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103428 */   GIR_RootConstrainSelectedInstOperands,
     /* 103429 */   // GIR_Coverage, 8472,
     /* 103429 */   GIR_EraseRootFromParent_Done,
     /* 103430 */ // Label 1472: @103430
     /* 103430 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(103492), // Rule ID 8473 //
     /* 103435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 103438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103453 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103457 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 103468 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 103471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103490 */   GIR_RootConstrainSelectedInstOperands,
     /* 103491 */   // GIR_Coverage, 8473,
     /* 103491 */   GIR_EraseRootFromParent_Done,
     /* 103492 */ // Label 1473: @103492
     /* 103492 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(103554), // Rule ID 8474 //
     /* 103497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 103500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103515 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103519 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103530 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 103530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 103533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103552 */   GIR_RootConstrainSelectedInstOperands,
     /* 103553 */   // GIR_Coverage, 8474,
     /* 103553 */   GIR_EraseRootFromParent_Done,
     /* 103554 */ // Label 1474: @103554
     /* 103554 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(103619), // Rule ID 8475 //
     /* 103559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 103562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103565 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103573 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103577 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103581 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 103585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103592 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 103592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 103595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103613 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103617 */   GIR_RootConstrainSelectedInstOperands,
     /* 103618 */   // GIR_Coverage, 8475,
     /* 103618 */   GIR_EraseRootFromParent_Done,
     /* 103619 */ // Label 1475: @103619
     /* 103619 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(103677), // Rule ID 3054 //
     /* 103624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 103627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103630 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103642 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 103653 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 103656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103675 */   GIR_RootConstrainSelectedInstOperands,
     /* 103676 */   // GIR_Coverage, 3054,
     /* 103676 */   GIR_EraseRootFromParent_Done,
     /* 103677 */ // Label 1476: @103677
     /* 103677 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(103735), // Rule ID 3055 //
     /* 103682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 103685 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103700 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103711 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 103711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 103714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103733 */   GIR_RootConstrainSelectedInstOperands,
     /* 103734 */   // GIR_Coverage, 3055,
     /* 103734 */   GIR_EraseRootFromParent_Done,
     /* 103735 */ // Label 1477: @103735
     /* 103735 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(103796), // Rule ID 3056 //
     /* 103740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 103743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103758 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103762 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103769 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 103769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 103772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103794 */   GIR_RootConstrainSelectedInstOperands,
     /* 103795 */   // GIR_Coverage, 3056,
     /* 103795 */   GIR_EraseRootFromParent_Done,
     /* 103796 */ // Label 1478: @103796
     /* 103796 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(103854), // Rule ID 3088 //
     /* 103801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 103804 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103807 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103815 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103819 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 103830 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 103830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 103833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103852 */   GIR_RootConstrainSelectedInstOperands,
     /* 103853 */   // GIR_Coverage, 3088,
     /* 103853 */   GIR_EraseRootFromParent_Done,
     /* 103854 */ // Label 1479: @103854
     /* 103854 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(103912), // Rule ID 3089 //
     /* 103859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 103862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103865 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103877 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103888 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 103888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 103891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103906 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103910 */   GIR_RootConstrainSelectedInstOperands,
     /* 103911 */   // GIR_Coverage, 3089,
     /* 103911 */   GIR_EraseRootFromParent_Done,
     /* 103912 */ // Label 1480: @103912
     /* 103912 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(103973), // Rule ID 3090 //
     /* 103917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 103920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103935 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 103939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 103946 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 103946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 103949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 103951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 103956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 103961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103971 */   GIR_RootConstrainSelectedInstOperands,
     /* 103972 */   // GIR_Coverage, 3090,
     /* 103972 */   GIR_EraseRootFromParent_Done,
     /* 103973 */ // Label 1481: @103973
     /* 103973 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(104031), // Rule ID 8478 //
     /* 103978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 103981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 103992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103996 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104000 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104007 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 104010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104029 */   GIR_RootConstrainSelectedInstOperands,
     /* 104030 */   // GIR_Coverage, 8478,
     /* 104030 */   GIR_EraseRootFromParent_Done,
     /* 104031 */ // Label 1482: @104031
     /* 104031 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(104089), // Rule ID 8479 //
     /* 104036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 104039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104054 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104065 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 104068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104083 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104087 */   GIR_RootConstrainSelectedInstOperands,
     /* 104088 */   // GIR_Coverage, 8479,
     /* 104088 */   GIR_EraseRootFromParent_Done,
     /* 104089 */ // Label 1483: @104089
     /* 104089 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(104150), // Rule ID 8480 //
     /* 104094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 104097 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104100 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104112 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104123 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 104126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104148 */   GIR_RootConstrainSelectedInstOperands,
     /* 104149 */   // GIR_Coverage, 8480,
     /* 104149 */   GIR_EraseRootFromParent_Done,
     /* 104150 */ // Label 1484: @104150
     /* 104150 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(104218), // Rule ID 8192 //
     /* 104155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 104158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104161 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104165 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 104170 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 104175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 104179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104183 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 104187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 104194 */   // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 104194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 104197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 104199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 104204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104216 */   GIR_RootConstrainSelectedInstOperands,
     /* 104217 */   // GIR_Coverage, 8192,
     /* 104217 */   GIR_EraseRootFromParent_Done,
     /* 104218 */ // Label 1485: @104218
     /* 104218 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(104286), // Rule ID 8196 //
     /* 104223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 104226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104233 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 104238 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 104243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 104247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104251 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 104255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 104262 */   // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 104262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 104265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 104267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 104272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104280 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104284 */   GIR_RootConstrainSelectedInstOperands,
     /* 104285 */   // GIR_Coverage, 8196,
     /* 104285 */   GIR_EraseRootFromParent_Done,
     /* 104286 */ // Label 1486: @104286
     /* 104286 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(104349), // Rule ID 8124 //
     /* 104291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 104294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104301 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 104306 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 104310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 104314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 104325 */   // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 104325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 104328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 104330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 104335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104347 */   GIR_RootConstrainSelectedInstOperands,
     /* 104348 */   // GIR_Coverage, 8124,
     /* 104348 */   GIR_EraseRootFromParent_Done,
     /* 104349 */ // Label 1487: @104349
     /* 104349 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(104412), // Rule ID 8128 //
     /* 104354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 104357 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104360 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104364 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 104369 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 104373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 104377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 104388 */   // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 104388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 104391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 104393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 104398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104410 */   GIR_RootConstrainSelectedInstOperands,
     /* 104411 */   // GIR_Coverage, 8128,
     /* 104411 */   GIR_EraseRootFromParent_Done,
     /* 104412 */ // Label 1488: @104412
     /* 104412 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(104467), // Rule ID 3059 //
     /* 104417 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104420 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104432 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104443 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 104446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104461 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104465 */   GIR_RootConstrainSelectedInstOperands,
     /* 104466 */   // GIR_Coverage, 3059,
     /* 104466 */   GIR_EraseRootFromParent_Done,
     /* 104467 */ // Label 1489: @104467
     /* 104467 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(104525), // Rule ID 3060 //
     /* 104472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 104475 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104478 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104486 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104490 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104501 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 104504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104519 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104523 */   GIR_RootConstrainSelectedInstOperands,
     /* 104524 */   // GIR_Coverage, 3060,
     /* 104524 */   GIR_EraseRootFromParent_Done,
     /* 104525 */ // Label 1490: @104525
     /* 104525 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(104583), // Rule ID 3061 //
     /* 104530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 104533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104536 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104548 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104552 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104559 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 104562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104581 */   GIR_RootConstrainSelectedInstOperands,
     /* 104582 */   // GIR_Coverage, 3061,
     /* 104582 */   GIR_EraseRootFromParent_Done,
     /* 104583 */ // Label 1491: @104583
     /* 104583 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(104644), // Rule ID 3062 //
     /* 104588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 104591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104594 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104606 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104610 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104617 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 104620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104642 */   GIR_RootConstrainSelectedInstOperands,
     /* 104643 */   // GIR_Coverage, 3062,
     /* 104643 */   GIR_EraseRootFromParent_Done,
     /* 104644 */ // Label 1492: @104644
     /* 104644 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(104699), // Rule ID 3093 //
     /* 104649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104664 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104675 */   // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 104678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104697 */   GIR_RootConstrainSelectedInstOperands,
     /* 104698 */   // GIR_Coverage, 3093,
     /* 104698 */   GIR_EraseRootFromParent_Done,
     /* 104699 */ // Label 1493: @104699
     /* 104699 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(104757), // Rule ID 3094 //
     /* 104704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 104707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104710 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104718 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104722 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104726 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104733 */   // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 104736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104751 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104755 */   GIR_RootConstrainSelectedInstOperands,
     /* 104756 */   // GIR_Coverage, 3094,
     /* 104756 */   GIR_EraseRootFromParent_Done,
     /* 104757 */ // Label 1494: @104757
     /* 104757 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(104815), // Rule ID 3095 //
     /* 104762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 104765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104780 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104784 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104791 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 104791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 104794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104813 */   GIR_RootConstrainSelectedInstOperands,
     /* 104814 */   // GIR_Coverage, 3095,
     /* 104814 */   GIR_EraseRootFromParent_Done,
     /* 104815 */ // Label 1495: @104815
     /* 104815 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(104876), // Rule ID 3096 //
     /* 104820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 104823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104838 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104842 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 104849 */   // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 104849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 104852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 104864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104874 */   GIR_RootConstrainSelectedInstOperands,
     /* 104875 */   // GIR_Coverage, 3096,
     /* 104875 */   GIR_EraseRootFromParent_Done,
     /* 104876 */ // Label 1496: @104876
     /* 104876 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(104931), // Rule ID 8483 //
     /* 104881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104884 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104896 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104900 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 104907 */   // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 104910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104925 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104929 */   GIR_RootConstrainSelectedInstOperands,
     /* 104930 */   // GIR_Coverage, 8483,
     /* 104930 */   GIR_EraseRootFromParent_Done,
     /* 104931 */ // Label 1497: @104931
     /* 104931 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(104989), // Rule ID 8484 //
     /* 104936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 104939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104942 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 104950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104954 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 104958 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 104965 */   // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 104965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 104968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 104970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 104975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104987 */   GIR_RootConstrainSelectedInstOperands,
     /* 104988 */   // GIR_Coverage, 8484,
     /* 104988 */   GIR_EraseRootFromParent_Done,
     /* 104989 */ // Label 1498: @104989
     /* 104989 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(105047), // Rule ID 8485 //
     /* 104994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 104997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105012 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105023 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 105023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 105026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105045 */   GIR_RootConstrainSelectedInstOperands,
     /* 105046 */   // GIR_Coverage, 8485,
     /* 105046 */   GIR_EraseRootFromParent_Done,
     /* 105047 */ // Label 1499: @105047
     /* 105047 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(105108), // Rule ID 8486 //
     /* 105052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 105055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105070 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 105081 */   // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 105084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 105091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 105096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105106 */   GIR_RootConstrainSelectedInstOperands,
     /* 105107 */   // GIR_Coverage, 8486,
     /* 105107 */   GIR_EraseRootFromParent_Done,
     /* 105108 */ // Label 1500: @105108
     /* 105108 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(105172), // Rule ID 8193 //
     /* 105113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 105116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105119 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 105124 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 105129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 105133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105137 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 105141 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 105148 */   // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 105148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 105151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 105158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105170 */   GIR_RootConstrainSelectedInstOperands,
     /* 105171 */   // GIR_Coverage, 8193,
     /* 105171 */   GIR_EraseRootFromParent_Done,
     /* 105172 */ // Label 1501: @105172
     /* 105172 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(105236), // Rule ID 8197 //
     /* 105177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 105180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105183 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 105188 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 105193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 105197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105201 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 105205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 105212 */   // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 105212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 105215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 105222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105234 */   GIR_RootConstrainSelectedInstOperands,
     /* 105235 */   // GIR_Coverage, 8197,
     /* 105235 */   GIR_EraseRootFromParent_Done,
     /* 105236 */ // Label 1502: @105236
     /* 105236 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(105295), // Rule ID 8125 //
     /* 105241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 105244 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105247 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 105252 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 105256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 105260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 105271 */   // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 105271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 105274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 105281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105293 */   GIR_RootConstrainSelectedInstOperands,
     /* 105294 */   // GIR_Coverage, 8125,
     /* 105294 */   GIR_EraseRootFromParent_Done,
     /* 105295 */ // Label 1503: @105295
     /* 105295 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(105354), // Rule ID 8129 //
     /* 105300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 105303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105306 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 105311 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 105315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 105319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 105330 */   // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 105330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 105333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 105340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105352 */   GIR_RootConstrainSelectedInstOperands,
     /* 105353 */   // GIR_Coverage, 8129,
     /* 105353 */   GIR_EraseRootFromParent_Done,
     /* 105354 */ // Label 1504: @105354
     /* 105354 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(105408), // Rule ID 3053 //
     /* 105359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105365 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105373 */   // MIs[0] sbase
     /* 105373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105381 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105385 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 105389 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 105392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105394 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105406 */   GIR_RootConstrainSelectedInstOperands,
     /* 105407 */   // GIR_Coverage, 3053,
     /* 105407 */   GIR_EraseRootFromParent_Done,
     /* 105408 */ // Label 1505: @105408
     /* 105408 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(105462), // Rule ID 3087 //
     /* 105413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105427 */   // MIs[0] sbase
     /* 105427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105435 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105439 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 105443 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 105446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105448 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105456 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105460 */   GIR_RootConstrainSelectedInstOperands,
     /* 105461 */   // GIR_Coverage, 3087,
     /* 105461 */   GIR_EraseRootFromParent_Done,
     /* 105462 */ // Label 1506: @105462
     /* 105462 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(105516), // Rule ID 8477 //
     /* 105467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105470 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105473 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105481 */   // MIs[0] sbase
     /* 105481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105489 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105493 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 105497 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 105500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105502 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105514 */   GIR_RootConstrainSelectedInstOperands,
     /* 105515 */   // GIR_Coverage, 8477,
     /* 105515 */   GIR_EraseRootFromParent_Done,
     /* 105516 */ // Label 1507: @105516
     /* 105516 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(105566), // Rule ID 3058 //
     /* 105521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105527 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105535 */   // MIs[0] sbase
     /* 105535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105543 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105547 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 105550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105552 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105564 */   GIR_RootConstrainSelectedInstOperands,
     /* 105565 */   // GIR_Coverage, 3058,
     /* 105565 */   GIR_EraseRootFromParent_Done,
     /* 105566 */ // Label 1508: @105566
     /* 105566 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(105616), // Rule ID 3092 //
     /* 105571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105585 */   // MIs[0] sbase
     /* 105585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105593 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105597 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 105600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105602 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105610 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105614 */   GIR_RootConstrainSelectedInstOperands,
     /* 105615 */   // GIR_Coverage, 3092,
     /* 105615 */   GIR_EraseRootFromParent_Done,
     /* 105616 */ // Label 1509: @105616
     /* 105616 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(105666), // Rule ID 8482 //
     /* 105621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 105624 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105627 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105635 */   // MIs[0] sbase
     /* 105635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105643 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105647 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 105650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105652 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105664 */   GIR_RootConstrainSelectedInstOperands,
     /* 105665 */   // GIR_Coverage, 8482,
     /* 105665 */   GIR_EraseRootFromParent_Done,
     /* 105666 */ // Label 1510: @105666
     /* 105666 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(105713), // Rule ID 3064 //
     /* 105671 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105674 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105682 */   // MIs[0] sbase
     /* 105682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105690 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105694 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 105697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105699 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105711 */   GIR_RootConstrainSelectedInstOperands,
     /* 105712 */   // GIR_Coverage, 3064,
     /* 105712 */   GIR_EraseRootFromParent_Done,
     /* 105713 */ // Label 1511: @105713
     /* 105713 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(105760), // Rule ID 3098 //
     /* 105718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105721 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105729 */   // MIs[0] sbase
     /* 105729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105737 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105741 */   // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 105744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105746 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105758 */   GIR_RootConstrainSelectedInstOperands,
     /* 105759 */   // GIR_Coverage, 3098,
     /* 105759 */   GIR_EraseRootFromParent_Done,
     /* 105760 */ // Label 1512: @105760
     /* 105760 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(105807), // Rule ID 8488 //
     /* 105765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 105776 */   // MIs[0] sbase
     /* 105776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 105784 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 105788 */   // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 105788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 105791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 105793 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 105795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105805 */   GIR_RootConstrainSelectedInstOperands,
     /* 105806 */   // GIR_Coverage, 8488,
     /* 105806 */   GIR_EraseRootFromParent_Done,
     /* 105807 */ // Label 1513: @105807
     /* 105807 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(105867), // Rule ID 4301 //
     /* 105812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 105815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105818 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 105827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 105838 */   // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 105841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 105853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105865 */   GIR_RootConstrainSelectedInstOperands,
     /* 105866 */   // GIR_Coverage, 4301,
     /* 105866 */   GIR_EraseRootFromParent_Done,
     /* 105867 */ // Label 1514: @105867
     /* 105867 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(105927), // Rule ID 4307 //
     /* 105872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 105875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105878 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 105887 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 105898 */   // (ld:{ *:[f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 105898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 105901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 105908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 105913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 105918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105925 */   GIR_RootConstrainSelectedInstOperands,
     /* 105926 */   // GIR_Coverage, 4307,
     /* 105926 */   GIR_EraseRootFromParent_Done,
     /* 105927 */ // Label 1515: @105927
     /* 105927 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(105982), // Rule ID 4300 //
     /* 105932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105938 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 105947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 105958 */   // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 105958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 105961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 105963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 105968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105980 */   GIR_RootConstrainSelectedInstOperands,
     /* 105981 */   // GIR_Coverage, 4300,
     /* 105981 */   GIR_EraseRootFromParent_Done,
     /* 105982 */ // Label 1516: @105982
     /* 105982 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(106037), // Rule ID 4306 //
     /* 105987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 105990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105993 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 105998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106002 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106006 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 106013 */   // (ld:{ *:[f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 106013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 106016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 106023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106035 */   GIR_RootConstrainSelectedInstOperands,
     /* 106036 */   // GIR_Coverage, 4306,
     /* 106036 */   GIR_EraseRootFromParent_Done,
     /* 106037 */ // Label 1517: @106037
     /* 106037 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(106092), // Rule ID 4299 //
     /* 106042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 106045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106048 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106057 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106061 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 106068 */   // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 106068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 106071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 106078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106086 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106090 */   GIR_RootConstrainSelectedInstOperands,
     /* 106091 */   // GIR_Coverage, 4299,
     /* 106091 */   GIR_EraseRootFromParent_Done,
     /* 106092 */ // Label 1518: @106092
     /* 106092 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(106147), // Rule ID 4305 //
     /* 106097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 106100 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106103 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 106108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 106123 */   // (ld:{ *:[f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 106123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 106126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 106133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106141 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106145 */   GIR_RootConstrainSelectedInstOperands,
     /* 106146 */   // GIR_Coverage, 4305,
     /* 106146 */   GIR_EraseRootFromParent_Done,
     /* 106147 */ // Label 1519: @106147
     /* 106147 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(106228), // Rule ID 6432 //
     /* 106152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 106155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106158 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106162 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106169 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106191 */   // (atomic_load:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_atomic_load_nonext_64_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 106191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 106194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106226 */   GIR_RootConstrainSelectedInstOperands,
     /* 106227 */   // GIR_Coverage, 6432,
     /* 106227 */   GIR_EraseRootFromParent_Done,
     /* 106228 */ // Label 1520: @106228
     /* 106228 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(106298), // Rule ID 4539 //
     /* 106233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106239 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106250 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106254 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106261 */   // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 106264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106296 */   GIR_RootConstrainSelectedInstOperands,
     /* 106297 */   // GIR_Coverage, 4539,
     /* 106297 */   GIR_EraseRootFromParent_Done,
     /* 106298 */ // Label 1521: @106298
     /* 106298 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(106365), // Rule ID 4541 //
     /* 106303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106306 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106328 */   // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 106331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106363 */   GIR_RootConstrainSelectedInstOperands,
     /* 106364 */   // GIR_Coverage, 4541,
     /* 106364 */   GIR_EraseRootFromParent_Done,
     /* 106365 */ // Label 1522: @106365
     /* 106365 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(106435), // Rule ID 4543 //
     /* 106370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106376 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106387 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106391 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106398 */   // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 106401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106429 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106433 */   GIR_RootConstrainSelectedInstOperands,
     /* 106434 */   // GIR_Coverage, 4543,
     /* 106434 */   GIR_EraseRootFromParent_Done,
     /* 106435 */ // Label 1523: @106435
     /* 106435 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(106502), // Rule ID 4545 //
     /* 106440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106443 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106454 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106458 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 106465 */   // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 106468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 106475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106480 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 106485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 106490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106496 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106500 */   GIR_RootConstrainSelectedInstOperands,
     /* 106501 */   // GIR_Coverage, 4545,
     /* 106501 */   GIR_EraseRootFromParent_Done,
     /* 106502 */ // Label 1524: @106502
     /* 106502 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(106566), // Rule ID 8064 //
     /* 106507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 106510 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106513 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106517 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106526 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106530 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 106537 */   // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 106537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 106540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 106552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 106557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106564 */   GIR_RootConstrainSelectedInstOperands,
     /* 106565 */   // GIR_Coverage, 8064,
     /* 106565 */   GIR_EraseRootFromParent_Done,
     /* 106566 */ // Label 1525: @106566
     /* 106566 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(106630), // Rule ID 8072 //
     /* 106571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 106574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106581 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 106601 */   // (AMDGPUld_glue:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 106601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 106604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 106616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 106621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106628 */   GIR_RootConstrainSelectedInstOperands,
     /* 106629 */   // GIR_Coverage, 8072,
     /* 106629 */   GIR_EraseRootFromParent_Done,
     /* 106630 */ // Label 1526: @106630
     /* 106630 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(106695), // Rule ID 4538 //
     /* 106635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106641 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106652 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106656 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106663 */   // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 106666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106693 */   GIR_RootConstrainSelectedInstOperands,
     /* 106694 */   // GIR_Coverage, 4538,
     /* 106694 */   GIR_EraseRootFromParent_Done,
     /* 106695 */ // Label 1527: @106695
     /* 106695 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(106757), // Rule ID 4540 //
     /* 106700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106703 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106725 */   // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 106728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106751 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106755 */   GIR_RootConstrainSelectedInstOperands,
     /* 106756 */   // GIR_Coverage, 4540,
     /* 106756 */   GIR_EraseRootFromParent_Done,
     /* 106757 */ // Label 1528: @106757
     /* 106757 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(106822), // Rule ID 4542 //
     /* 106762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 106765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106768 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106790 */   // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 106793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106820 */   GIR_RootConstrainSelectedInstOperands,
     /* 106821 */   // GIR_Coverage, 4542,
     /* 106821 */   GIR_EraseRootFromParent_Done,
     /* 106822 */ // Label 1529: @106822
     /* 106822 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(106884), // Rule ID 4544 //
     /* 106827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106830 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 106837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 106852 */   // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 106852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 106855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 106857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 106862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 106867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 106872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106882 */   GIR_RootConstrainSelectedInstOperands,
     /* 106883 */   // GIR_Coverage, 4544,
     /* 106883 */   GIR_EraseRootFromParent_Done,
     /* 106884 */ // Label 1530: @106884
     /* 106884 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(106944), // Rule ID 8066 //
     /* 106889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 106892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106895 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 106915 */   // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 106915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 106918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 106930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 106935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106942 */   GIR_RootConstrainSelectedInstOperands,
     /* 106943 */   // GIR_Coverage, 8066,
     /* 106943 */   GIR_EraseRootFromParent_Done,
     /* 106944 */ // Label 1531: @106944
     /* 106944 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(107004), // Rule ID 8074 //
     /* 106949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 106952 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106955 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 106960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 106964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106968 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 106975 */   // (ld:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 106975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 106978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 106980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 106985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 106990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 106995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106998 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107002 */   GIR_RootConstrainSelectedInstOperands,
     /* 107003 */   // GIR_Coverage, 8074,
     /* 107003 */   GIR_EraseRootFromParent_Done,
     /* 107004 */ // Label 1532: @107004
     /* 107004 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(107070), // Rule ID 8004 //
     /* 107009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 107012 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107015 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107026 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 107031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107039 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 107046 */   // (AMDGPUatomic_ld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext_glue>><<P:Predicate_atomic_load_nonext_64_glue>><<P:Predicate_atomic_load_nonext_64_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 107046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 107049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 107056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107068 */   GIR_RootConstrainSelectedInstOperands,
     /* 107069 */   // GIR_Coverage, 8004,
     /* 107069 */   GIR_EraseRootFromParent_Done,
     /* 107070 */ // Label 1533: @107070
     /* 107070 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(107136), // Rule ID 8005 //
     /* 107075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 107078 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107081 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107092 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 107097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 107112 */   // (atomic_load:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_atomic_load_nonext_64_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 107112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 107115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 107122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107134 */   GIR_RootConstrainSelectedInstOperands,
     /* 107135 */   // GIR_Coverage, 8005,
     /* 107135 */   GIR_EraseRootFromParent_Done,
     /* 107136 */ // Label 1534: @107136
     /* 107136 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(107209), // Rule ID 3964 //
     /* 107141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107151 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107158 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 107180 */   // (atomic_load:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_atomic_load_nonext_64_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 107183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 107190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 107195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107207 */   GIR_RootConstrainSelectedInstOperands,
     /* 107208 */   // GIR_Coverage, 3964,
     /* 107208 */   GIR_EraseRootFromParent_Done,
     /* 107209 */ // Label 1535: @107209
     /* 107209 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(107271), // Rule ID 3900 //
     /* 107214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107220 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107231 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107235 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 107242 */   // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 107245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 107252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 107257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107269 */   GIR_RootConstrainSelectedInstOperands,
     /* 107270 */   // GIR_Coverage, 3900,
     /* 107270 */   GIR_EraseRootFromParent_Done,
     /* 107271 */ // Label 1536: @107271
     /* 107271 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(107333), // Rule ID 3904 //
     /* 107276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107282 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107293 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107297 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 107304 */   // (ld:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 107307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 107314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 107319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107331 */   GIR_RootConstrainSelectedInstOperands,
     /* 107332 */   // GIR_Coverage, 3904,
     /* 107332 */   GIR_EraseRootFromParent_Done,
     /* 107333 */ // Label 1537: @107333
     /* 107333 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(107401), // Rule ID 3963 //
     /* 107338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107341 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107344 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107348 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107355 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 107377 */   // (atomic_load:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_atomic_load_nonext_64_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 107380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107399 */   GIR_RootConstrainSelectedInstOperands,
     /* 107400 */   // GIR_Coverage, 3963,
     /* 107400 */   GIR_EraseRootFromParent_Done,
     /* 107401 */ // Label 1538: @107401
     /* 107401 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(107458), // Rule ID 3899 //
     /* 107406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107412 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 107434 */   // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 107437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107456 */   GIR_RootConstrainSelectedInstOperands,
     /* 107457 */   // GIR_Coverage, 3899,
     /* 107457 */   GIR_EraseRootFromParent_Done,
     /* 107458 */ // Label 1539: @107458
     /* 107458 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(107515), // Rule ID 3903 //
     /* 107463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 107466 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107469 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 107491 */   // (ld:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 107494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107513 */   GIR_RootConstrainSelectedInstOperands,
     /* 107514 */   // GIR_Coverage, 3903,
     /* 107514 */   GIR_EraseRootFromParent_Done,
     /* 107515 */ // Label 1540: @107515
     /* 107515 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(107584), // Rule ID 3617 //
     /* 107520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 107523 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107537 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107549 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107553 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 107560 */   // (atomic_load:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_atomic_load_nonext_64_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 107563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107578 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107582 */   GIR_RootConstrainSelectedInstOperands,
     /* 107583 */   // GIR_Coverage, 3617,
     /* 107583 */   GIR_EraseRootFromParent_Done,
     /* 107584 */ // Label 1541: @107584
     /* 107584 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(107642), // Rule ID 3637 //
     /* 107589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 107592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107595 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 107618 */   // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 107621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107640 */   GIR_RootConstrainSelectedInstOperands,
     /* 107641 */   // GIR_Coverage, 3637,
     /* 107641 */   GIR_EraseRootFromParent_Done,
     /* 107642 */ // Label 1542: @107642
     /* 107642 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(107700), // Rule ID 3639 //
     /* 107647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 107650 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107653 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 107661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 107665 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107669 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 107676 */   // (ld:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 107676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 107679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 107681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 107686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107694 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107698 */   GIR_RootConstrainSelectedInstOperands,
     /* 107699 */   // GIR_Coverage, 3639,
     /* 107699 */   GIR_EraseRootFromParent_Done,
     /* 107700 */ // Label 1543: @107700
     /* 107700 */ GIM_Reject,
     /* 107701 */ // Label 1008: @107701
     /* 107701 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(110944),
     /* 107706 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107709 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(107773), // Rule ID 2963 //
     /* 107714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 107725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107744 */     // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 107747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107771 */     GIR_RootConstrainSelectedInstOperands,
     /* 107772 */     // GIR_Coverage, 2963,
     /* 107772 */     GIR_EraseRootFromParent_Done,
     /* 107773 */   // Label 1545: @107773
     /* 107773 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(107837), // Rule ID 2975 //
     /* 107778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 107781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 107789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107793 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107797 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107808 */     // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 107811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107835 */     GIR_RootConstrainSelectedInstOperands,
     /* 107836 */     // GIR_Coverage, 2975,
     /* 107836 */     GIR_EraseRootFromParent_Done,
     /* 107837 */   // Label 1546: @107837
     /* 107837 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(107897), // Rule ID 2969 //
     /* 107842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 107845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 107853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107868 */     // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 107871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107895 */     GIR_RootConstrainSelectedInstOperands,
     /* 107896 */     // GIR_Coverage, 2969,
     /* 107896 */     GIR_EraseRootFromParent_Done,
     /* 107897 */   // Label 1547: @107897
     /* 107897 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(107957), // Rule ID 2981 //
     /* 107902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 107905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 107913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 107928 */     // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 107931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 107938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 107943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 107948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107955 */     GIR_RootConstrainSelectedInstOperands,
     /* 107956 */     // GIR_Coverage, 2981,
     /* 107956 */     GIR_EraseRootFromParent_Done,
     /* 107957 */   // Label 1548: @107957
     /* 107957 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(108016), // Rule ID 2959 //
     /* 107962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 107965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 107973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 107981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 107985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 107992 */     // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 107992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 107995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 107997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108014 */     GIR_RootConstrainSelectedInstOperands,
     /* 108015 */     // GIR_Coverage, 2959,
     /* 108015 */     GIR_EraseRootFromParent_Done,
     /* 108016 */   // Label 1549: @108016
     /* 108016 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(108075), // Rule ID 2960 //
     /* 108021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 108024 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108051 */     // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 108054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108073 */     GIR_RootConstrainSelectedInstOperands,
     /* 108074 */     // GIR_Coverage, 2960,
     /* 108074 */     GIR_EraseRootFromParent_Done,
     /* 108075 */   // Label 1550: @108075
     /* 108075 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(108134), // Rule ID 2961 //
     /* 108080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 108083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108110 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 108113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108132 */     GIR_RootConstrainSelectedInstOperands,
     /* 108133 */     // GIR_Coverage, 2961,
     /* 108133 */     GIR_EraseRootFromParent_Done,
     /* 108134 */   // Label 1551: @108134
     /* 108134 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(108196), // Rule ID 2962 //
     /* 108139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 108142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108169 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 108172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108194 */     GIR_RootConstrainSelectedInstOperands,
     /* 108195 */     // GIR_Coverage, 2962,
     /* 108195 */     GIR_EraseRootFromParent_Done,
     /* 108196 */   // Label 1552: @108196
     /* 108196 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(108255), // Rule ID 2971 //
     /* 108201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108204 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108231 */     // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 108234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108253 */     GIR_RootConstrainSelectedInstOperands,
     /* 108254 */     // GIR_Coverage, 2971,
     /* 108254 */     GIR_EraseRootFromParent_Done,
     /* 108255 */   // Label 1553: @108255
     /* 108255 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(108314), // Rule ID 2972 //
     /* 108260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 108263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108290 */     // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 108293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108312 */     GIR_RootConstrainSelectedInstOperands,
     /* 108313 */     // GIR_Coverage, 2972,
     /* 108313 */     GIR_EraseRootFromParent_Done,
     /* 108314 */   // Label 1554: @108314
     /* 108314 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(108373), // Rule ID 2973 //
     /* 108319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 108322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108349 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 108352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108371 */     GIR_RootConstrainSelectedInstOperands,
     /* 108372 */     // GIR_Coverage, 2973,
     /* 108372 */     GIR_EraseRootFromParent_Done,
     /* 108373 */   // Label 1555: @108373
     /* 108373 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(108435), // Rule ID 2974 //
     /* 108378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 108381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108408 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 108411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108433 */     GIR_RootConstrainSelectedInstOperands,
     /* 108434 */     // GIR_Coverage, 2974,
     /* 108434 */     GIR_EraseRootFromParent_Done,
     /* 108435 */   // Label 1556: @108435
     /* 108435 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(108487), // Rule ID 2965 //
     /* 108440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108463 */     // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 108466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108485 */     GIR_RootConstrainSelectedInstOperands,
     /* 108486 */     // GIR_Coverage, 2965,
     /* 108486 */     GIR_EraseRootFromParent_Done,
     /* 108487 */   // Label 1557: @108487
     /* 108487 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(108542), // Rule ID 2966 //
     /* 108492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 108495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108518 */     // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 108521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108540 */     GIR_RootConstrainSelectedInstOperands,
     /* 108541 */     // GIR_Coverage, 2966,
     /* 108541 */     GIR_EraseRootFromParent_Done,
     /* 108542 */   // Label 1558: @108542
     /* 108542 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(108597), // Rule ID 2967 //
     /* 108547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 108550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108573 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 108576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108595 */     GIR_RootConstrainSelectedInstOperands,
     /* 108596 */     // GIR_Coverage, 2967,
     /* 108596 */     GIR_EraseRootFromParent_Done,
     /* 108597 */   // Label 1559: @108597
     /* 108597 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(108655), // Rule ID 2968 //
     /* 108602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 108605 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108628 */     // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 108631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108653 */     GIR_RootConstrainSelectedInstOperands,
     /* 108654 */     // GIR_Coverage, 2968,
     /* 108654 */     GIR_EraseRootFromParent_Done,
     /* 108655 */   // Label 1560: @108655
     /* 108655 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(108707), // Rule ID 2977 //
     /* 108660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 108683 */     // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 108686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108705 */     GIR_RootConstrainSelectedInstOperands,
     /* 108706 */     // GIR_Coverage, 2977,
     /* 108706 */     GIR_EraseRootFromParent_Done,
     /* 108707 */   // Label 1561: @108707
     /* 108707 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(108762), // Rule ID 2978 //
     /* 108712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 108715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 108738 */     // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 108738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
     /* 108741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108760 */     GIR_RootConstrainSelectedInstOperands,
     /* 108761 */     // GIR_Coverage, 2978,
     /* 108761 */     GIR_EraseRootFromParent_Done,
     /* 108762 */   // Label 1562: @108762
     /* 108762 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(108817), // Rule ID 2979 //
     /* 108767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 108770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108793 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 108793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
     /* 108796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108815 */     GIR_RootConstrainSelectedInstOperands,
     /* 108816 */     // GIR_Coverage, 2979,
     /* 108816 */     GIR_EraseRootFromParent_Done,
     /* 108817 */   // Label 1563: @108817
     /* 108817 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(108875), // Rule ID 2980 //
     /* 108822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 108825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 108848 */     // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
     /* 108851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 108858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 108863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108873 */     GIR_RootConstrainSelectedInstOperands,
     /* 108874 */     // GIR_Coverage, 2980,
     /* 108874 */     GIR_EraseRootFromParent_Done,
     /* 108875 */   // Label 1564: @108875
     /* 108875 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(108926), // Rule ID 2964 //
     /* 108880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108891 */     // MIs[0] sbase
     /* 108891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 108899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108907 */     // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 108910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108912 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 108914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108924 */     GIR_RootConstrainSelectedInstOperands,
     /* 108925 */     // GIR_Coverage, 2964,
     /* 108925 */     GIR_EraseRootFromParent_Done,
     /* 108926 */   // Label 1565: @108926
     /* 108926 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(108977), // Rule ID 2976 //
     /* 108931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 108934 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108942 */     // MIs[0] sbase
     /* 108942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 108950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 108954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 108958 */     // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 108958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 108961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 108963 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 108965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108975 */     GIR_RootConstrainSelectedInstOperands,
     /* 108976 */     // GIR_Coverage, 2976,
     /* 108976 */     GIR_EraseRootFromParent_Done,
     /* 108977 */   // Label 1566: @108977
     /* 108977 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(109021), // Rule ID 2970 //
     /* 108982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 108986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 108990 */     // MIs[0] sbase
     /* 108990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 108994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 108998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109002 */     // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 109005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109007 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109019 */     GIR_RootConstrainSelectedInstOperands,
     /* 109020 */     // GIR_Coverage, 2970,
     /* 109020 */     GIR_EraseRootFromParent_Done,
     /* 109021 */   // Label 1567: @109021
     /* 109021 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(109065), // Rule ID 2982 //
     /* 109026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 109030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 109034 */     // MIs[0] sbase
     /* 109034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 109042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 109046 */     // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 109046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
     /* 109049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 109051 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 109053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109063 */     GIR_RootConstrainSelectedInstOperands,
     /* 109064 */     // GIR_Coverage, 2982,
     /* 109064 */     GIR_EraseRootFromParent_Done,
     /* 109065 */   // Label 1568: @109065
     /* 109065 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(109125), // Rule ID 6499 //
     /* 109070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 109073 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109093 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 109096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109123 */     GIR_RootConstrainSelectedInstOperands,
     /* 109124 */     // GIR_Coverage, 6499,
     /* 109124 */     GIR_EraseRootFromParent_Done,
     /* 109125 */   // Label 1569: @109125
     /* 109125 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(109185), // Rule ID 6501 //
     /* 109130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 109133 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109153 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 109156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109183 */     GIR_RootConstrainSelectedInstOperands,
     /* 109184 */     // GIR_Coverage, 6501,
     /* 109184 */     GIR_EraseRootFromParent_Done,
     /* 109185 */   // Label 1570: @109185
     /* 109185 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(109245), // Rule ID 6503 //
     /* 109190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 109193 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109213 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 109216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109243 */     GIR_RootConstrainSelectedInstOperands,
     /* 109244 */     // GIR_Coverage, 6503,
     /* 109244 */     GIR_EraseRootFromParent_Done,
     /* 109245 */   // Label 1571: @109245
     /* 109245 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(109305), // Rule ID 6505 //
     /* 109250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 109253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 109273 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 109276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 109288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109303 */     GIR_RootConstrainSelectedInstOperands,
     /* 109304 */     // GIR_Coverage, 6505,
     /* 109304 */     GIR_EraseRootFromParent_Done,
     /* 109305 */   // Label 1572: @109305
     /* 109305 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(109362), // Rule ID 4265 //
     /* 109310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 109313 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 109333 */     // (ld:{ *:[v2i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 109333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /* 109336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 109348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109360 */     GIR_RootConstrainSelectedInstOperands,
     /* 109361 */     // GIR_Coverage, 4265,
     /* 109361 */     GIR_EraseRootFromParent_Done,
     /* 109362 */   // Label 1573: @109362
     /* 109362 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(109419), // Rule ID 4271 //
     /* 109367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 109370 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 109390 */     // (ld:{ *:[v2f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 109390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
     /* 109393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 109405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109417 */     GIR_RootConstrainSelectedInstOperands,
     /* 109418 */     // GIR_Coverage, 4271,
     /* 109418 */     GIR_EraseRootFromParent_Done,
     /* 109419 */   // Label 1574: @109419
     /* 109419 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(109471), // Rule ID 4264 //
     /* 109424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109427 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 109447 */     // (ld:{ *:[v2i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 109447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /* 109450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 109457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109469 */     GIR_RootConstrainSelectedInstOperands,
     /* 109470 */     // GIR_Coverage, 4264,
     /* 109470 */     GIR_EraseRootFromParent_Done,
     /* 109471 */   // Label 1575: @109471
     /* 109471 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(109523), // Rule ID 4270 //
     /* 109476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 109499 */     // (ld:{ *:[v2f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 109499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
     /* 109502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 109509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109521 */     GIR_RootConstrainSelectedInstOperands,
     /* 109522 */     // GIR_Coverage, 4270,
     /* 109522 */     GIR_EraseRootFromParent_Done,
     /* 109523 */   // Label 1576: @109523
     /* 109523 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(109575), // Rule ID 4263 //
     /* 109528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109531 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 109551 */     // (ld:{ *:[v2i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 109551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /* 109554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109573 */     GIR_RootConstrainSelectedInstOperands,
     /* 109574 */     // GIR_Coverage, 4263,
     /* 109574 */     GIR_EraseRootFromParent_Done,
     /* 109575 */   // Label 1577: @109575
     /* 109575 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(109627), // Rule ID 4269 //
     /* 109580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 109583 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 109603 */     // (ld:{ *:[v2f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 109603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
     /* 109606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 109608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 109613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109625 */     GIR_RootConstrainSelectedInstOperands,
     /* 109626 */     // GIR_Coverage, 4269,
     /* 109626 */     GIR_EraseRootFromParent_Done,
     /* 109627 */   // Label 1578: @109627
     /* 109627 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(109694), // Rule ID 4515 //
     /* 109632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 109635 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 109642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 109657 */     // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 109657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /* 109660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 109667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 109677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 109682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109692 */     GIR_RootConstrainSelectedInstOperands,
     /* 109693 */     // GIR_Coverage, 4515,
     /* 109693 */     GIR_EraseRootFromParent_Done,
     /* 109694 */   // Label 1579: @109694
     /* 109694 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(109758), // Rule ID 4517 //
     /* 109699 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 109706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 109721 */     // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 109721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /* 109724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 109731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 109741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 109746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109756 */     GIR_RootConstrainSelectedInstOperands,
     /* 109757 */     // GIR_Coverage, 4517,
     /* 109757 */     GIR_EraseRootFromParent_Done,
     /* 109758 */   // Label 1580: @109758
     /* 109758 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(109825), // Rule ID 4519 //
     /* 109763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 109766 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 109773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 109788 */     // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 109788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
     /* 109791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 109798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 109808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 109813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109823 */     GIR_RootConstrainSelectedInstOperands,
     /* 109824 */     // GIR_Coverage, 4519,
     /* 109824 */     GIR_EraseRootFromParent_Done,
     /* 109825 */   // Label 1581: @109825
     /* 109825 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(109889), // Rule ID 4521 //
     /* 109830 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 109837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 109852 */     // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 109852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
     /* 109855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 109862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 109872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 109877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109887 */     GIR_RootConstrainSelectedInstOperands,
     /* 109888 */     // GIR_Coverage, 4521,
     /* 109888 */     GIR_EraseRootFromParent_Done,
     /* 109889 */   // Label 1582: @109889
     /* 109889 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(109954), // Rule ID 6498 //
     /* 109894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 109897 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 109917 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 109920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 109927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 109937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 109942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109952 */     GIR_RootConstrainSelectedInstOperands,
     /* 109953 */     // GIR_Coverage, 6498,
     /* 109953 */     GIR_EraseRootFromParent_Done,
     /* 109954 */   // Label 1583: @109954
     /* 109954 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(110019), // Rule ID 6500 //
     /* 109959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 109962 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 109967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 109971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 109982 */     // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 109982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 109985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 109987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 109992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 109997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110017 */     GIR_RootConstrainSelectedInstOperands,
     /* 110018 */     // GIR_Coverage, 6500,
     /* 110018 */     GIR_EraseRootFromParent_Done,
     /* 110019 */   // Label 1584: @110019
     /* 110019 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(110084), // Rule ID 6502 //
     /* 110024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 110027 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 110047 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 110047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 110050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110082 */     GIR_RootConstrainSelectedInstOperands,
     /* 110083 */     // GIR_Coverage, 6502,
     /* 110083 */     GIR_EraseRootFromParent_Done,
     /* 110084 */   // Label 1585: @110084
     /* 110084 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(110149), // Rule ID 6504 //
     /* 110089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 110092 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 110097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 110112 */     // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 110112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 110115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 110122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 110132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 110137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110147 */     GIR_RootConstrainSelectedInstOperands,
     /* 110148 */     // GIR_Coverage, 6504,
     /* 110148 */     GIR_EraseRootFromParent_Done,
     /* 110149 */   // Label 1586: @110149
     /* 110149 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(110211), // Rule ID 4514 //
     /* 110154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110157 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110179 */     // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 110182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110209 */     GIR_RootConstrainSelectedInstOperands,
     /* 110210 */     // GIR_Coverage, 4514,
     /* 110210 */     GIR_EraseRootFromParent_Done,
     /* 110211 */   // Label 1587: @110211
     /* 110211 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(110270), // Rule ID 4516 //
     /* 110216 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110238 */     // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 110241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110268 */     GIR_RootConstrainSelectedInstOperands,
     /* 110269 */     // GIR_Coverage, 4516,
     /* 110269 */     GIR_EraseRootFromParent_Done,
     /* 110270 */   // Label 1588: @110270
     /* 110270 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(110332), // Rule ID 4518 //
     /* 110275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 110278 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110300 */     // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 110303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110330 */     GIR_RootConstrainSelectedInstOperands,
     /* 110331 */     // GIR_Coverage, 4518,
     /* 110331 */     GIR_EraseRootFromParent_Done,
     /* 110332 */   // Label 1589: @110332
     /* 110332 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(110391), // Rule ID 4520 //
     /* 110337 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 110359 */     // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 110359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 110362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 110364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 110369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 110374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110389 */     GIR_RootConstrainSelectedInstOperands,
     /* 110390 */     // GIR_Coverage, 4520,
     /* 110390 */     GIR_EraseRootFromParent_Done,
     /* 110391 */   // Label 1590: @110391
     /* 110391 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(110447), // Rule ID 7962 //
     /* 110396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 110399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110403 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 110423 */     // (AMDGPUld_glue:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 110423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 110426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110445 */     GIR_RootConstrainSelectedInstOperands,
     /* 110446 */     // GIR_Coverage, 7962,
     /* 110446 */     GIR_EraseRootFromParent_Done,
     /* 110447 */   // Label 1591: @110447
     /* 110447 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(110503), // Rule ID 7964 //
     /* 110452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 110455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110459 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 110479 */     // (AMDGPUld_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 110479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
     /* 110482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110501 */     GIR_RootConstrainSelectedInstOperands,
     /* 110502 */     // GIR_Coverage, 7964,
     /* 110502 */     GIR_EraseRootFromParent_Done,
     /* 110503 */   // Label 1592: @110503
     /* 110503 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(110555), // Rule ID 7963 //
     /* 110508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 110511 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 110531 */     // (ld:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 110531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 110534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110553 */     GIR_RootConstrainSelectedInstOperands,
     /* 110554 */     // GIR_Coverage, 7963,
     /* 110554 */     GIR_EraseRootFromParent_Done,
     /* 110555 */   // Label 1593: @110555
     /* 110555 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(110607), // Rule ID 7965 //
     /* 110560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 110563 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 110568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 110583 */     // (ld:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 110583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
     /* 110586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 110593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110605 */     GIR_RootConstrainSelectedInstOperands,
     /* 110606 */     // GIR_Coverage, 7965,
     /* 110606 */     GIR_EraseRootFromParent_Done,
     /* 110607 */   // Label 1594: @110607
     /* 110607 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(110666), // Rule ID 3876 //
     /* 110612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 110615 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 110637 */     // (ld:{ *:[v2i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 110637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 110640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 110647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 110652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110664 */     GIR_RootConstrainSelectedInstOperands,
     /* 110665 */     // GIR_Coverage, 3876,
     /* 110665 */     GIR_EraseRootFromParent_Done,
     /* 110666 */   // Label 1595: @110666
     /* 110666 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(110725), // Rule ID 3880 //
     /* 110671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 110674 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 110696 */     // (ld:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 110696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
     /* 110699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 110706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 110711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 110716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110723 */     GIR_RootConstrainSelectedInstOperands,
     /* 110724 */     // GIR_Coverage, 3880,
     /* 110724 */     GIR_EraseRootFromParent_Done,
     /* 110725 */   // Label 1596: @110725
     /* 110725 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(110779), // Rule ID 3875 //
     /* 110730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 110733 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 110755 */     // (ld:{ *:[v2i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 110755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 110758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 110765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110777 */     GIR_RootConstrainSelectedInstOperands,
     /* 110778 */     // GIR_Coverage, 3875,
     /* 110778 */     GIR_EraseRootFromParent_Done,
     /* 110779 */   // Label 1597: @110779
     /* 110779 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(110833), // Rule ID 3879 //
     /* 110784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 110787 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 110809 */     // (ld:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 110809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
     /* 110812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 110819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110831 */     GIR_RootConstrainSelectedInstOperands,
     /* 110832 */     // GIR_Coverage, 3879,
     /* 110832 */     GIR_EraseRootFromParent_Done,
     /* 110833 */   // Label 1598: @110833
     /* 110833 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(110888), // Rule ID 3624 //
     /* 110838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 110841 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 110864 */     // (ld:{ *:[v2i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 110864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 110867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 110874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110886 */     GIR_RootConstrainSelectedInstOperands,
     /* 110887 */     // GIR_Coverage, 3624,
     /* 110887 */     GIR_EraseRootFromParent_Done,
     /* 110888 */   // Label 1599: @110888
     /* 110888 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(110943), // Rule ID 3626 //
     /* 110893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 110896 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 110904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 110908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 110919 */     // (ld:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 110919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
     /* 110922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 110924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 110929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110941 */     GIR_RootConstrainSelectedInstOperands,
     /* 110942 */     // GIR_Coverage, 3626,
     /* 110942 */     GIR_EraseRootFromParent_Done,
     /* 110943 */   // Label 1600: @110943
     /* 110943 */   GIM_Reject,
     /* 110944 */ // Label 1544: @110944
     /* 110944 */ GIM_Reject,
     /* 110945 */ // Label 1009: @110945
     /* 110945 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(114992),
     /* 110950 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110953 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(111017), // Rule ID 3035 //
     /* 110958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 110961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 110969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 110977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 110981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 110988 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 110988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 110991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 110993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 110998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111015 */     GIR_RootConstrainSelectedInstOperands,
     /* 111016 */     // GIR_Coverage, 3035,
     /* 111016 */     GIR_EraseRootFromParent_Done,
     /* 111017 */   // Label 1602: @111017
     /* 111017 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(111081), // Rule ID 3069 //
     /* 111022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111052 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 111055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111079 */     GIR_RootConstrainSelectedInstOperands,
     /* 111080 */     // GIR_Coverage, 3069,
     /* 111080 */     GIR_EraseRootFromParent_Done,
     /* 111081 */   // Label 1603: @111081
     /* 111081 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(111141), // Rule ID 3040 //
     /* 111086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111089 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111112 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 111115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111139 */     GIR_RootConstrainSelectedInstOperands,
     /* 111140 */     // GIR_Coverage, 3040,
     /* 111140 */     GIR_EraseRootFromParent_Done,
     /* 111141 */   // Label 1604: @111141
     /* 111141 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(111201), // Rule ID 3074 //
     /* 111146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111172 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 111175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111199 */     GIR_RootConstrainSelectedInstOperands,
     /* 111200 */     // GIR_Coverage, 3074,
     /* 111200 */     GIR_EraseRootFromParent_Done,
     /* 111201 */   // Label 1605: @111201
     /* 111201 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(111261), // Rule ID 3046 //
     /* 111206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 111209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111232 */     // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 111235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111259 */     GIR_RootConstrainSelectedInstOperands,
     /* 111260 */     // GIR_Coverage, 3046,
     /* 111260 */     GIR_EraseRootFromParent_Done,
     /* 111261 */   // Label 1606: @111261
     /* 111261 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(111321), // Rule ID 3080 //
     /* 111266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 111269 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 111292 */     // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 111295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 111312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111319 */     GIR_RootConstrainSelectedInstOperands,
     /* 111320 */     // GIR_Coverage, 3080,
     /* 111320 */     GIR_EraseRootFromParent_Done,
     /* 111321 */   // Label 1607: @111321
     /* 111321 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(111380), // Rule ID 3031 //
     /* 111326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 111329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 111356 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 111359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111378 */     GIR_RootConstrainSelectedInstOperands,
     /* 111379 */     // GIR_Coverage, 3031,
     /* 111379 */     GIR_EraseRootFromParent_Done,
     /* 111380 */   // Label 1608: @111380
     /* 111380 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(111439), // Rule ID 3032 //
     /* 111385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 111388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 111415 */     // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 111418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111437 */     GIR_RootConstrainSelectedInstOperands,
     /* 111438 */     // GIR_Coverage, 3032,
     /* 111438 */     GIR_EraseRootFromParent_Done,
     /* 111439 */   // Label 1609: @111439
     /* 111439 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(111498), // Rule ID 3033 //
     /* 111444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 111447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111474 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 111474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 111477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111496 */     GIR_RootConstrainSelectedInstOperands,
     /* 111497 */     // GIR_Coverage, 3033,
     /* 111497 */     GIR_EraseRootFromParent_Done,
     /* 111498 */   // Label 1610: @111498
     /* 111498 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(111560), // Rule ID 3034 //
     /* 111503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111533 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 111533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 111536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111558 */     GIR_RootConstrainSelectedInstOperands,
     /* 111559 */     // GIR_Coverage, 3034,
     /* 111559 */     GIR_EraseRootFromParent_Done,
     /* 111560 */   // Label 1611: @111560
     /* 111560 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(111619), // Rule ID 3065 //
     /* 111565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 111568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 111595 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 111598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111617 */     GIR_RootConstrainSelectedInstOperands,
     /* 111618 */     // GIR_Coverage, 3065,
     /* 111618 */     GIR_EraseRootFromParent_Done,
     /* 111619 */   // Label 1612: @111619
     /* 111619 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(111678), // Rule ID 3066 //
     /* 111624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 111627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111643 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 111654 */     // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 111657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111676 */     GIR_RootConstrainSelectedInstOperands,
     /* 111677 */     // GIR_Coverage, 3066,
     /* 111677 */     GIR_EraseRootFromParent_Done,
     /* 111678 */   // Label 1613: @111678
     /* 111678 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(111737), // Rule ID 3067 //
     /* 111683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 111686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111713 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 111713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 111716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111735 */     GIR_RootConstrainSelectedInstOperands,
     /* 111736 */     // GIR_Coverage, 3067,
     /* 111736 */     GIR_EraseRootFromParent_Done,
     /* 111737 */   // Label 1614: @111737
     /* 111737 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(111799), // Rule ID 3068 //
     /* 111742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 111765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111772 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 111772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 111775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111797 */     GIR_RootConstrainSelectedInstOperands,
     /* 111798 */     // GIR_Coverage, 3068,
     /* 111798 */     GIR_EraseRootFromParent_Done,
     /* 111799 */   // Label 1615: @111799
     /* 111799 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(111854), // Rule ID 3037 //
     /* 111804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 111807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 111830 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 111833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111852 */     GIR_RootConstrainSelectedInstOperands,
     /* 111853 */     // GIR_Coverage, 3037,
     /* 111853 */     GIR_EraseRootFromParent_Done,
     /* 111854 */   // Label 1616: @111854
     /* 111854 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(111909), // Rule ID 3038 //
     /* 111859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 111862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111885 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 111885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 111888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111907 */     GIR_RootConstrainSelectedInstOperands,
     /* 111908 */     // GIR_Coverage, 3038,
     /* 111908 */     GIR_EraseRootFromParent_Done,
     /* 111909 */   // Label 1617: @111909
     /* 111909 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(111967), // Rule ID 3039 //
     /* 111914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 111917 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 111940 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 111940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 111943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 111945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 111950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 111955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111965 */     GIR_RootConstrainSelectedInstOperands,
     /* 111966 */     // GIR_Coverage, 3039,
     /* 111966 */     GIR_EraseRootFromParent_Done,
     /* 111967 */   // Label 1618: @111967
     /* 111967 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(112022), // Rule ID 3071 //
     /* 111972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 111975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 111983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 111991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 111998 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 111998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 112001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112020 */     GIR_RootConstrainSelectedInstOperands,
     /* 112021 */     // GIR_Coverage, 3071,
     /* 112021 */     GIR_EraseRootFromParent_Done,
     /* 112022 */   // Label 1619: @112022
     /* 112022 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(112077), // Rule ID 3072 //
     /* 112027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 112030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112053 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 112056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112075 */     GIR_RootConstrainSelectedInstOperands,
     /* 112076 */     // GIR_Coverage, 3072,
     /* 112076 */     GIR_EraseRootFromParent_Done,
     /* 112077 */   // Label 1620: @112077
     /* 112077 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(112135), // Rule ID 3073 //
     /* 112082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 112085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112108 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 112111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112133 */     GIR_RootConstrainSelectedInstOperands,
     /* 112134 */     // GIR_Coverage, 3073,
     /* 112134 */     GIR_EraseRootFromParent_Done,
     /* 112135 */   // Label 1621: @112135
     /* 112135 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(112200), // Rule ID 8200 //
     /* 112140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 112143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112147 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112152 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 112161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 112169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112176 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 112179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112198 */     GIR_RootConstrainSelectedInstOperands,
     /* 112199 */     // GIR_Coverage, 8200,
     /* 112199 */     GIR_EraseRootFromParent_Done,
     /* 112200 */   // Label 1622: @112200
     /* 112200 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(112265), // Rule ID 8204 //
     /* 112205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 112208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112212 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112217 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 112226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 112234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112241 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 112244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112263 */     GIR_RootConstrainSelectedInstOperands,
     /* 112264 */     // GIR_Coverage, 8204,
     /* 112264 */     GIR_EraseRootFromParent_Done,
     /* 112265 */   // Label 1623: @112265
     /* 112265 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(112325), // Rule ID 8132 //
     /* 112270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 112273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112277 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112282 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 112286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 112290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112301 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 112304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112323 */     GIR_RootConstrainSelectedInstOperands,
     /* 112324 */     // GIR_Coverage, 8132,
     /* 112324 */     GIR_EraseRootFromParent_Done,
     /* 112325 */   // Label 1624: @112325
     /* 112325 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(112385), // Rule ID 8136 //
     /* 112330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 112333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112337 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112342 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 112346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 112350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112361 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 112364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112383 */     GIR_RootConstrainSelectedInstOperands,
     /* 112384 */     // GIR_Coverage, 8136,
     /* 112384 */     GIR_EraseRootFromParent_Done,
     /* 112385 */   // Label 1625: @112385
     /* 112385 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(112437), // Rule ID 3042 //
     /* 112390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112413 */     // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 112416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112435 */     GIR_RootConstrainSelectedInstOperands,
     /* 112436 */     // GIR_Coverage, 3042,
     /* 112436 */     GIR_EraseRootFromParent_Done,
     /* 112437 */   // Label 1626: @112437
     /* 112437 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(112492), // Rule ID 3043 //
     /* 112442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 112445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 112468 */     // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 112471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112490 */     GIR_RootConstrainSelectedInstOperands,
     /* 112491 */     // GIR_Coverage, 3043,
     /* 112491 */     GIR_EraseRootFromParent_Done,
     /* 112492 */   // Label 1627: @112492
     /* 112492 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(112547), // Rule ID 3044 //
     /* 112497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 112500 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112523 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 112526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112545 */     GIR_RootConstrainSelectedInstOperands,
     /* 112546 */     // GIR_Coverage, 3044,
     /* 112546 */     GIR_EraseRootFromParent_Done,
     /* 112547 */   // Label 1628: @112547
     /* 112547 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(112605), // Rule ID 3045 //
     /* 112552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 112555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112578 */     // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 112581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112603 */     GIR_RootConstrainSelectedInstOperands,
     /* 112604 */     // GIR_Coverage, 3045,
     /* 112604 */     GIR_EraseRootFromParent_Done,
     /* 112605 */   // Label 1629: @112605
     /* 112605 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(112657), // Rule ID 3076 //
     /* 112610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 112633 */     // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 112636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112655 */     GIR_RootConstrainSelectedInstOperands,
     /* 112656 */     // GIR_Coverage, 3076,
     /* 112656 */     GIR_EraseRootFromParent_Done,
     /* 112657 */   // Label 1630: @112657
     /* 112657 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(112712), // Rule ID 3077 //
     /* 112662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 112665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 112688 */     // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 112688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 112691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112710 */     GIR_RootConstrainSelectedInstOperands,
     /* 112711 */     // GIR_Coverage, 3077,
     /* 112711 */     GIR_EraseRootFromParent_Done,
     /* 112712 */   // Label 1631: @112712
     /* 112712 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(112767), // Rule ID 3078 //
     /* 112717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 112720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112743 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 112743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 112746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112765 */     GIR_RootConstrainSelectedInstOperands,
     /* 112766 */     // GIR_Coverage, 3078,
     /* 112766 */     GIR_EraseRootFromParent_Done,
     /* 112767 */   // Label 1632: @112767
     /* 112767 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(112825), // Rule ID 3079 //
     /* 112772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 112775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 112783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 112791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 112798 */     // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 112798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 112801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 112803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 112808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 112813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112823 */     GIR_RootConstrainSelectedInstOperands,
     /* 112824 */     // GIR_Coverage, 3079,
     /* 112824 */     GIR_EraseRootFromParent_Done,
     /* 112825 */   // Label 1633: @112825
     /* 112825 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(112886), // Rule ID 8201 //
     /* 112830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 112833 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112838 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 112847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 112855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112862 */     // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 112865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112884 */     GIR_RootConstrainSelectedInstOperands,
     /* 112885 */     // GIR_Coverage, 8201,
     /* 112885 */     GIR_EraseRootFromParent_Done,
     /* 112886 */   // Label 1634: @112886
     /* 112886 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(112947), // Rule ID 8205 //
     /* 112891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 112894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112899 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 112908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 112916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112923 */     // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 112926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112945 */     GIR_RootConstrainSelectedInstOperands,
     /* 112946 */     // GIR_Coverage, 8205,
     /* 112946 */     GIR_EraseRootFromParent_Done,
     /* 112947 */   // Label 1635: @112947
     /* 112947 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(113003), // Rule ID 8133 //
     /* 112952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 112955 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 112960 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 112964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 112968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 112979 */     // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 112979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 112982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 112984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 112989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113001 */     GIR_RootConstrainSelectedInstOperands,
     /* 113002 */     // GIR_Coverage, 8133,
     /* 113002 */     GIR_EraseRootFromParent_Done,
     /* 113003 */   // Label 1636: @113003
     /* 113003 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(113059), // Rule ID 8137 //
     /* 113008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 113011 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 113016 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 113020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 113035 */     // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 113035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 113038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 113045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113057 */     GIR_RootConstrainSelectedInstOperands,
     /* 113058 */     // GIR_Coverage, 8137,
     /* 113058 */     GIR_EraseRootFromParent_Done,
     /* 113059 */   // Label 1637: @113059
     /* 113059 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(113110), // Rule ID 3036 //
     /* 113064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 113075 */     // MIs[0] sbase
     /* 113075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113083 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 113091 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 113094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113096 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113108 */     GIR_RootConstrainSelectedInstOperands,
     /* 113109 */     // GIR_Coverage, 3036,
     /* 113109 */     GIR_EraseRootFromParent_Done,
     /* 113110 */   // Label 1638: @113110
     /* 113110 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(113161), // Rule ID 3070 //
     /* 113115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 113126 */     // MIs[0] sbase
     /* 113126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 113142 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 113145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113147 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113159 */     GIR_RootConstrainSelectedInstOperands,
     /* 113160 */     // GIR_Coverage, 3070,
     /* 113160 */     GIR_EraseRootFromParent_Done,
     /* 113161 */   // Label 1639: @113161
     /* 113161 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(113208), // Rule ID 3041 //
     /* 113166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 113177 */     // MIs[0] sbase
     /* 113177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113189 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 113192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113194 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113206 */     GIR_RootConstrainSelectedInstOperands,
     /* 113207 */     // GIR_Coverage, 3041,
     /* 113207 */     GIR_EraseRootFromParent_Done,
     /* 113208 */   // Label 1640: @113208
     /* 113208 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(113255), // Rule ID 3075 //
     /* 113213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 113216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 113224 */     // MIs[0] sbase
     /* 113224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113236 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 113239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113241 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113253 */     GIR_RootConstrainSelectedInstOperands,
     /* 113254 */     // GIR_Coverage, 3075,
     /* 113254 */     GIR_EraseRootFromParent_Done,
     /* 113255 */   // Label 1641: @113255
     /* 113255 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(113299), // Rule ID 3047 //
     /* 113260 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 113268 */     // MIs[0] sbase
     /* 113268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113280 */     // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 113283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113285 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113297 */     GIR_RootConstrainSelectedInstOperands,
     /* 113298 */     // GIR_Coverage, 3047,
     /* 113298 */     GIR_EraseRootFromParent_Done,
     /* 113299 */   // Label 1642: @113299
     /* 113299 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(113343), // Rule ID 3081 //
     /* 113304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 113312 */     // MIs[0] sbase
     /* 113312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 113320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 113324 */     // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 113324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 113327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 113329 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 113331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113341 */     GIR_RootConstrainSelectedInstOperands,
     /* 113342 */     // GIR_Coverage, 3081,
     /* 113342 */     GIR_EraseRootFromParent_Done,
     /* 113343 */   // Label 1643: @113343
     /* 113343 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(113403), // Rule ID 6523 //
     /* 113348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 113351 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 113371 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 113371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 113374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 113376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 113381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113401 */     GIR_RootConstrainSelectedInstOperands,
     /* 113402 */     // GIR_Coverage, 6523,
     /* 113402 */     GIR_EraseRootFromParent_Done,
     /* 113403 */   // Label 1644: @113403
     /* 113403 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(113463), // Rule ID 6525 //
     /* 113408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 113411 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 113431 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 113431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 113434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 113436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 113441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 113446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113461 */     GIR_RootConstrainSelectedInstOperands,
     /* 113462 */     // GIR_Coverage, 6525,
     /* 113462 */     GIR_EraseRootFromParent_Done,
     /* 113463 */   // Label 1645: @113463
     /* 113463 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(113520), // Rule ID 4313 //
     /* 113468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 113471 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 113491 */     // (ld:{ *:[v2i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 113494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 113506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113518 */     GIR_RootConstrainSelectedInstOperands,
     /* 113519 */     // GIR_Coverage, 4313,
     /* 113519 */     GIR_EraseRootFromParent_Done,
     /* 113520 */   // Label 1646: @113520
     /* 113520 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(113577), // Rule ID 4319 //
     /* 113525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 113528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 113548 */     // (ld:{ *:[v2f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 113548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 113551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 113563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 113568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113575 */     GIR_RootConstrainSelectedInstOperands,
     /* 113576 */     // GIR_Coverage, 4319,
     /* 113576 */     GIR_EraseRootFromParent_Done,
     /* 113577 */   // Label 1647: @113577
     /* 113577 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(113629), // Rule ID 4312 //
     /* 113582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113585 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 113605 */     // (ld:{ *:[v2i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 113605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 113608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 113615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113627 */     GIR_RootConstrainSelectedInstOperands,
     /* 113628 */     // GIR_Coverage, 4312,
     /* 113628 */     GIR_EraseRootFromParent_Done,
     /* 113629 */   // Label 1648: @113629
     /* 113629 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(113681), // Rule ID 4318 //
     /* 113634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113637 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 113657 */     // (ld:{ *:[v2f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 113657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 113660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 113667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113679 */     GIR_RootConstrainSelectedInstOperands,
     /* 113680 */     // GIR_Coverage, 4318,
     /* 113680 */     GIR_EraseRootFromParent_Done,
     /* 113681 */   // Label 1649: @113681
     /* 113681 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(113733), // Rule ID 4311 //
     /* 113686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113689 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 113709 */     // (ld:{ *:[v2i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 113709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 113712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113731 */     GIR_RootConstrainSelectedInstOperands,
     /* 113732 */     // GIR_Coverage, 4311,
     /* 113732 */     GIR_EraseRootFromParent_Done,
     /* 113733 */   // Label 1650: @113733
     /* 113733 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(113785), // Rule ID 4317 //
     /* 113738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 113741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 113746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 113761 */     // (ld:{ *:[v2f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 113761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 113764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 113766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 113771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113783 */     GIR_RootConstrainSelectedInstOperands,
     /* 113784 */     // GIR_Coverage, 4317,
     /* 113784 */     GIR_EraseRootFromParent_Done,
     /* 113785 */   // Label 1651: @113785
     /* 113785 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(113852), // Rule ID 4547 //
     /* 113790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 113793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 113800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 113815 */     // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 113815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 113818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 113820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 113825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 113830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 113835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 113840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113850 */     GIR_RootConstrainSelectedInstOperands,
     /* 113851 */     // GIR_Coverage, 4547,
     /* 113851 */     GIR_EraseRootFromParent_Done,
     /* 113852 */   // Label 1652: @113852
     /* 113852 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(113916), // Rule ID 4549 //
     /* 113857 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 113864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 113879 */     // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 113879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 113882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 113884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 113889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 113894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 113899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 113904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113914 */     GIR_RootConstrainSelectedInstOperands,
     /* 113915 */     // GIR_Coverage, 4549,
     /* 113915 */     GIR_EraseRootFromParent_Done,
     /* 113916 */   // Label 1653: @113916
     /* 113916 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(113983), // Rule ID 4551 //
     /* 113921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 113924 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 113931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 113946 */     // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 113946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 113949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 113951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 113956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 113961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 113966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 113971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113981 */     GIR_RootConstrainSelectedInstOperands,
     /* 113982 */     // GIR_Coverage, 4551,
     /* 113982 */     GIR_EraseRootFromParent_Done,
     /* 113983 */   // Label 1654: @113983
     /* 113983 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(114047), // Rule ID 4553 //
     /* 113988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 113995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 113999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 114010 */     // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 114013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114045 */     GIR_RootConstrainSelectedInstOperands,
     /* 114046 */     // GIR_Coverage, 4553,
     /* 114046 */     GIR_EraseRootFromParent_Done,
     /* 114047 */   // Label 1655: @114047
     /* 114047 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(114112), // Rule ID 6522 //
     /* 114052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 114055 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 114060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 114075 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 114075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 114078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114110 */     GIR_RootConstrainSelectedInstOperands,
     /* 114111 */     // GIR_Coverage, 6522,
     /* 114111 */     GIR_EraseRootFromParent_Done,
     /* 114112 */   // Label 1656: @114112
     /* 114112 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(114177), // Rule ID 6524 //
     /* 114117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 114120 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 114125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 114140 */     // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 114140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 114143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 114150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 114160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 114165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114175 */     GIR_RootConstrainSelectedInstOperands,
     /* 114176 */     // GIR_Coverage, 6524,
     /* 114176 */     GIR_EraseRootFromParent_Done,
     /* 114177 */   // Label 1657: @114177
     /* 114177 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(114238), // Rule ID 8076 //
     /* 114182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 114185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114189 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 114209 */     // (AMDGPUld_glue:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 114212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114236 */     GIR_RootConstrainSelectedInstOperands,
     /* 114237 */     // GIR_Coverage, 8076,
     /* 114237 */     GIR_EraseRootFromParent_Done,
     /* 114238 */   // Label 1658: @114238
     /* 114238 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(114299), // Rule ID 8080 //
     /* 114243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 114246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114250 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 114270 */     // (AMDGPUld_glue:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 114273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114297 */     GIR_RootConstrainSelectedInstOperands,
     /* 114298 */     // GIR_Coverage, 8080,
     /* 114298 */     GIR_EraseRootFromParent_Done,
     /* 114299 */   // Label 1659: @114299
     /* 114299 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(114361), // Rule ID 4546 //
     /* 114304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114307 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114329 */     // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 114332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114359 */     GIR_RootConstrainSelectedInstOperands,
     /* 114360 */     // GIR_Coverage, 4546,
     /* 114360 */     GIR_EraseRootFromParent_Done,
     /* 114361 */   // Label 1660: @114361
     /* 114361 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(114420), // Rule ID 4548 //
     /* 114366 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114388 */     // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 114391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114418 */     GIR_RootConstrainSelectedInstOperands,
     /* 114419 */     // GIR_Coverage, 4548,
     /* 114419 */     GIR_EraseRootFromParent_Done,
     /* 114420 */   // Label 1661: @114420
     /* 114420 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(114482), // Rule ID 4550 //
     /* 114425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 114428 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114450 */     // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 114453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114480 */     GIR_RootConstrainSelectedInstOperands,
     /* 114481 */     // GIR_Coverage, 4550,
     /* 114481 */     GIR_EraseRootFromParent_Done,
     /* 114482 */   // Label 1662: @114482
     /* 114482 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(114541), // Rule ID 4552 //
     /* 114487 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 114509 */     // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 114509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 114512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 114514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 114519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 114524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114539 */     GIR_RootConstrainSelectedInstOperands,
     /* 114540 */     // GIR_Coverage, 4552,
     /* 114540 */     GIR_EraseRootFromParent_Done,
     /* 114541 */   // Label 1663: @114541
     /* 114541 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(114598), // Rule ID 8078 //
     /* 114546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 114549 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 114569 */     // (ld:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 114572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114596 */     GIR_RootConstrainSelectedInstOperands,
     /* 114597 */     // GIR_Coverage, 8078,
     /* 114597 */     GIR_EraseRootFromParent_Done,
     /* 114598 */   // Label 1664: @114598
     /* 114598 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(114655), // Rule ID 8082 //
     /* 114603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 114606 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 114611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 114626 */     // (ld:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 114626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 114629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 114636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 114641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 114646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114653 */     GIR_RootConstrainSelectedInstOperands,
     /* 114654 */     // GIR_Coverage, 8082,
     /* 114654 */     GIR_EraseRootFromParent_Done,
     /* 114655 */   // Label 1665: @114655
     /* 114655 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(114714), // Rule ID 3908 //
     /* 114660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 114685 */     // (ld:{ *:[v2i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 114685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 114688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 114695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 114700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114712 */     GIR_RootConstrainSelectedInstOperands,
     /* 114713 */     // GIR_Coverage, 3908,
     /* 114713 */     GIR_EraseRootFromParent_Done,
     /* 114714 */   // Label 1666: @114714
     /* 114714 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(114773), // Rule ID 3912 //
     /* 114719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114722 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 114744 */     // (ld:{ *:[v2f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 114744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 114747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 114754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 114759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 114764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114771 */     GIR_RootConstrainSelectedInstOperands,
     /* 114772 */     // GIR_Coverage, 3912,
     /* 114772 */     GIR_EraseRootFromParent_Done,
     /* 114773 */   // Label 1667: @114773
     /* 114773 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(114827), // Rule ID 3907 //
     /* 114778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114781 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 114803 */     // (ld:{ *:[v2i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 114806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114825 */     GIR_RootConstrainSelectedInstOperands,
     /* 114826 */     // GIR_Coverage, 3907,
     /* 114826 */     GIR_EraseRootFromParent_Done,
     /* 114827 */   // Label 1668: @114827
     /* 114827 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(114881), // Rule ID 3911 //
     /* 114832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 114835 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 114857 */     // (ld:{ *:[v2f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 114860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114879 */     GIR_RootConstrainSelectedInstOperands,
     /* 114880 */     // GIR_Coverage, 3911,
     /* 114880 */     GIR_EraseRootFromParent_Done,
     /* 114881 */   // Label 1669: @114881
     /* 114881 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(114936), // Rule ID 3641 //
     /* 114886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 114889 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 114912 */     // (ld:{ *:[v2i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 114915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114934 */     GIR_RootConstrainSelectedInstOperands,
     /* 114935 */     // GIR_Coverage, 3641,
     /* 114935 */     GIR_EraseRootFromParent_Done,
     /* 114936 */   // Label 1670: @114936
     /* 114936 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(114991), // Rule ID 3643 //
     /* 114941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 114944 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 114952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 114956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 114967 */     // (ld:{ *:[v2f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 114967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 114970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 114972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 114977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114989 */     GIR_RootConstrainSelectedInstOperands,
     /* 114990 */     // GIR_Coverage, 3643,
     /* 114990 */     GIR_EraseRootFromParent_Done,
     /* 114991 */   // Label 1671: @114991
     /* 114991 */   GIM_Reject,
     /* 114992 */ // Label 1601: @114992
     /* 114992 */ GIM_Reject,
     /* 114993 */ // Label 1010: @114993
     /* 114993 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(118790),
     /* 114998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115001 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(115065), // Rule ID 3213 //
     /* 115006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115036 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 115039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115063 */     GIR_RootConstrainSelectedInstOperands,
     /* 115064 */     // GIR_Coverage, 3213,
     /* 115064 */     GIR_EraseRootFromParent_Done,
     /* 115065 */   // Label 1673: @115065
     /* 115065 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(115129), // Rule ID 3230 //
     /* 115070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115100 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 115103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115127 */     GIR_RootConstrainSelectedInstOperands,
     /* 115128 */     // GIR_Coverage, 3230,
     /* 115128 */     GIR_EraseRootFromParent_Done,
     /* 115129 */   // Label 1674: @115129
     /* 115129 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(115189), // Rule ID 3218 //
     /* 115134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115160 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 115163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115187 */     GIR_RootConstrainSelectedInstOperands,
     /* 115188 */     // GIR_Coverage, 3218,
     /* 115188 */     GIR_EraseRootFromParent_Done,
     /* 115189 */   // Label 1675: @115189
     /* 115189 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(115249), // Rule ID 3235 //
     /* 115194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115220 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 115223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115247 */     GIR_RootConstrainSelectedInstOperands,
     /* 115248 */     // GIR_Coverage, 3235,
     /* 115248 */     GIR_EraseRootFromParent_Done,
     /* 115249 */   // Label 1676: @115249
     /* 115249 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(115309), // Rule ID 3224 //
     /* 115254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 115257 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115280 */     // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 115283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115307 */     GIR_RootConstrainSelectedInstOperands,
     /* 115308 */     // GIR_Coverage, 3224,
     /* 115308 */     GIR_EraseRootFromParent_Done,
     /* 115309 */   // Label 1677: @115309
     /* 115309 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(115369), // Rule ID 3241 //
     /* 115314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 115317 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 115340 */     // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 115343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 115360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115367 */     GIR_RootConstrainSelectedInstOperands,
     /* 115368 */     // GIR_Coverage, 3241,
     /* 115368 */     GIR_EraseRootFromParent_Done,
     /* 115369 */   // Label 1678: @115369
     /* 115369 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(115428), // Rule ID 3209 //
     /* 115374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115404 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 115407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115426 */     GIR_RootConstrainSelectedInstOperands,
     /* 115427 */     // GIR_Coverage, 3209,
     /* 115427 */     GIR_EraseRootFromParent_Done,
     /* 115428 */   // Label 1679: @115428
     /* 115428 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(115487), // Rule ID 3210 //
     /* 115433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 115436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 115463 */     // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 115466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115485 */     GIR_RootConstrainSelectedInstOperands,
     /* 115486 */     // GIR_Coverage, 3210,
     /* 115486 */     GIR_EraseRootFromParent_Done,
     /* 115487 */   // Label 1680: @115487
     /* 115487 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(115546), // Rule ID 3211 //
     /* 115492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115522 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 115525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115544 */     GIR_RootConstrainSelectedInstOperands,
     /* 115545 */     // GIR_Coverage, 3211,
     /* 115545 */     GIR_EraseRootFromParent_Done,
     /* 115546 */   // Label 1681: @115546
     /* 115546 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(115608), // Rule ID 3212 //
     /* 115551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115581 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 115584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115606 */     GIR_RootConstrainSelectedInstOperands,
     /* 115607 */     // GIR_Coverage, 3212,
     /* 115607 */     GIR_EraseRootFromParent_Done,
     /* 115608 */   // Label 1682: @115608
     /* 115608 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(115667), // Rule ID 3226 //
     /* 115613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115628 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115643 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 115646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115665 */     GIR_RootConstrainSelectedInstOperands,
     /* 115666 */     // GIR_Coverage, 3226,
     /* 115666 */     GIR_EraseRootFromParent_Done,
     /* 115667 */   // Label 1683: @115667
     /* 115667 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(115726), // Rule ID 3227 //
     /* 115672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 115675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 115702 */     // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 115705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115724 */     GIR_RootConstrainSelectedInstOperands,
     /* 115725 */     // GIR_Coverage, 3227,
     /* 115725 */     GIR_EraseRootFromParent_Done,
     /* 115726 */   // Label 1684: @115726
     /* 115726 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(115785), // Rule ID 3228 //
     /* 115731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115761 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 115764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115783 */     GIR_RootConstrainSelectedInstOperands,
     /* 115784 */     // GIR_Coverage, 3228,
     /* 115784 */     GIR_EraseRootFromParent_Done,
     /* 115785 */   // Label 1685: @115785
     /* 115785 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(115847), // Rule ID 3229 //
     /* 115790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115793 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 115813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115820 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 115823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115845 */     GIR_RootConstrainSelectedInstOperands,
     /* 115846 */     // GIR_Coverage, 3229,
     /* 115846 */     GIR_EraseRootFromParent_Done,
     /* 115847 */   // Label 1686: @115847
     /* 115847 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(115902), // Rule ID 3215 //
     /* 115852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 115855 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 115878 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 115878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 115881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115900 */     GIR_RootConstrainSelectedInstOperands,
     /* 115901 */     // GIR_Coverage, 3215,
     /* 115901 */     GIR_EraseRootFromParent_Done,
     /* 115902 */   // Label 1687: @115902
     /* 115902 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(115957), // Rule ID 3216 //
     /* 115907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 115910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115933 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 115933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 115936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 115948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115955 */     GIR_RootConstrainSelectedInstOperands,
     /* 115956 */     // GIR_Coverage, 3216,
     /* 115956 */     GIR_EraseRootFromParent_Done,
     /* 115957 */   // Label 1688: @115957
     /* 115957 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(116015), // Rule ID 3217 //
     /* 115962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 115965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 115973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 115981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 115988 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 115988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 115991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 115993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 115998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116013 */     GIR_RootConstrainSelectedInstOperands,
     /* 116014 */     // GIR_Coverage, 3217,
     /* 116014 */     GIR_EraseRootFromParent_Done,
     /* 116015 */   // Label 1689: @116015
     /* 116015 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(116070), // Rule ID 3232 //
     /* 116020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 116023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116046 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 116049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116068 */     GIR_RootConstrainSelectedInstOperands,
     /* 116069 */     // GIR_Coverage, 3232,
     /* 116069 */     GIR_EraseRootFromParent_Done,
     /* 116070 */   // Label 1690: @116070
     /* 116070 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(116125), // Rule ID 3233 //
     /* 116075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 116078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116101 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 116104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116123 */     GIR_RootConstrainSelectedInstOperands,
     /* 116124 */     // GIR_Coverage, 3233,
     /* 116124 */     GIR_EraseRootFromParent_Done,
     /* 116125 */   // Label 1691: @116125
     /* 116125 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(116183), // Rule ID 3234 //
     /* 116130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 116133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116156 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 116159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116181 */     GIR_RootConstrainSelectedInstOperands,
     /* 116182 */     // GIR_Coverage, 3234,
     /* 116182 */     GIR_EraseRootFromParent_Done,
     /* 116183 */   // Label 1692: @116183
     /* 116183 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(116243), // Rule ID 8176 //
     /* 116188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 116191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116195 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116200 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 116208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116219 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 116222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116241 */     GIR_RootConstrainSelectedInstOperands,
     /* 116242 */     // GIR_Coverage, 8176,
     /* 116242 */     GIR_EraseRootFromParent_Done,
     /* 116243 */   // Label 1693: @116243
     /* 116243 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(116303), // Rule ID 8180 //
     /* 116248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 116251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116255 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116260 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 116268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116279 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 116282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116301 */     GIR_RootConstrainSelectedInstOperands,
     /* 116302 */     // GIR_Coverage, 8180,
     /* 116302 */     GIR_EraseRootFromParent_Done,
     /* 116303 */   // Label 1694: @116303
     /* 116303 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(116368), // Rule ID 8244 //
     /* 116308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 116311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116315 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116320 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 116329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 116337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116344 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 116347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116366 */     GIR_RootConstrainSelectedInstOperands,
     /* 116367 */     // GIR_Coverage, 8244,
     /* 116367 */     GIR_EraseRootFromParent_Done,
     /* 116368 */   // Label 1695: @116368
     /* 116368 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(116433), // Rule ID 8248 //
     /* 116373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 116376 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116380 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116385 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 116394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 116402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116409 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 116412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116431 */     GIR_RootConstrainSelectedInstOperands,
     /* 116432 */     // GIR_Coverage, 8248,
     /* 116432 */     GIR_EraseRootFromParent_Done,
     /* 116433 */   // Label 1696: @116433
     /* 116433 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(116485), // Rule ID 3220 //
     /* 116438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116461 */     // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 116464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116483 */     GIR_RootConstrainSelectedInstOperands,
     /* 116484 */     // GIR_Coverage, 3220,
     /* 116484 */     GIR_EraseRootFromParent_Done,
     /* 116485 */   // Label 1697: @116485
     /* 116485 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(116540), // Rule ID 3221 //
     /* 116490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 116493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 116516 */     // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 116519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116538 */     GIR_RootConstrainSelectedInstOperands,
     /* 116539 */     // GIR_Coverage, 3221,
     /* 116539 */     GIR_EraseRootFromParent_Done,
     /* 116540 */   // Label 1698: @116540
     /* 116540 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(116595), // Rule ID 3222 //
     /* 116545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 116548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116571 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 116574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116593 */     GIR_RootConstrainSelectedInstOperands,
     /* 116594 */     // GIR_Coverage, 3222,
     /* 116594 */     GIR_EraseRootFromParent_Done,
     /* 116595 */   // Label 1699: @116595
     /* 116595 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(116653), // Rule ID 3223 //
     /* 116600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 116603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116626 */     // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 116629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116651 */     GIR_RootConstrainSelectedInstOperands,
     /* 116652 */     // GIR_Coverage, 3223,
     /* 116652 */     GIR_EraseRootFromParent_Done,
     /* 116653 */   // Label 1700: @116653
     /* 116653 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(116705), // Rule ID 3237 //
     /* 116658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 116681 */     // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 116684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116703 */     GIR_RootConstrainSelectedInstOperands,
     /* 116704 */     // GIR_Coverage, 3237,
     /* 116704 */     GIR_EraseRootFromParent_Done,
     /* 116705 */   // Label 1701: @116705
     /* 116705 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(116760), // Rule ID 3238 //
     /* 116710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 116713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 116736 */     // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 116736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 116739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116758 */     GIR_RootConstrainSelectedInstOperands,
     /* 116759 */     // GIR_Coverage, 3238,
     /* 116759 */     GIR_EraseRootFromParent_Done,
     /* 116760 */   // Label 1702: @116760
     /* 116760 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(116815), // Rule ID 3239 //
     /* 116765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 116768 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116791 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 116791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 116794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116813 */     GIR_RootConstrainSelectedInstOperands,
     /* 116814 */     // GIR_Coverage, 3239,
     /* 116814 */     GIR_EraseRootFromParent_Done,
     /* 116815 */   // Label 1703: @116815
     /* 116815 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(116873), // Rule ID 3240 //
     /* 116820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 116823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 116831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 116839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 116846 */     // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 116846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 116849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 116851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 116856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 116861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116871 */     GIR_RootConstrainSelectedInstOperands,
     /* 116872 */     // GIR_Coverage, 3240,
     /* 116872 */     GIR_EraseRootFromParent_Done,
     /* 116873 */   // Label 1704: @116873
     /* 116873 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(116929), // Rule ID 8177 //
     /* 116878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 116881 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116886 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 116894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116905 */     // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 116908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116927 */     GIR_RootConstrainSelectedInstOperands,
     /* 116928 */     // GIR_Coverage, 8177,
     /* 116928 */     GIR_EraseRootFromParent_Done,
     /* 116929 */   // Label 1705: @116929
     /* 116929 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(116985), // Rule ID 8181 //
     /* 116934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 116937 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116942 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 116946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 116950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 116961 */     // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 116961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 116964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 116966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 116971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116983 */     GIR_RootConstrainSelectedInstOperands,
     /* 116984 */     // GIR_Coverage, 8181,
     /* 116984 */     GIR_EraseRootFromParent_Done,
     /* 116985 */   // Label 1706: @116985
     /* 116985 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(117046), // Rule ID 8245 //
     /* 116990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 116993 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 116998 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 117003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 117015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 117022 */     // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 117022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 117025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 117032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117044 */     GIR_RootConstrainSelectedInstOperands,
     /* 117045 */     // GIR_Coverage, 8245,
     /* 117045 */     GIR_EraseRootFromParent_Done,
     /* 117046 */   // Label 1707: @117046
     /* 117046 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(117107), // Rule ID 8249 //
     /* 117051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 117054 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 117059 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 117064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 117076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 117083 */     // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 117083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 117086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 117093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117105 */     GIR_RootConstrainSelectedInstOperands,
     /* 117106 */     // GIR_Coverage, 8249,
     /* 117106 */     GIR_EraseRootFromParent_Done,
     /* 117107 */   // Label 1708: @117107
     /* 117107 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(117158), // Rule ID 3214 //
     /* 117112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 117123 */     // MIs[0] sbase
     /* 117123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 117139 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 117142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117144 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117156 */     GIR_RootConstrainSelectedInstOperands,
     /* 117157 */     // GIR_Coverage, 3214,
     /* 117157 */     GIR_EraseRootFromParent_Done,
     /* 117158 */   // Label 1709: @117158
     /* 117158 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(117209), // Rule ID 3231 //
     /* 117163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117166 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 117174 */     // MIs[0] sbase
     /* 117174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 117190 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 117193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117195 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117207 */     GIR_RootConstrainSelectedInstOperands,
     /* 117208 */     // GIR_Coverage, 3231,
     /* 117208 */     GIR_EraseRootFromParent_Done,
     /* 117209 */   // Label 1710: @117209
     /* 117209 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(117256), // Rule ID 3219 //
     /* 117214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 117225 */     // MIs[0] sbase
     /* 117225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117233 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117237 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 117240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117242 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117254 */     GIR_RootConstrainSelectedInstOperands,
     /* 117255 */     // GIR_Coverage, 3219,
     /* 117255 */     GIR_EraseRootFromParent_Done,
     /* 117256 */   // Label 1711: @117256
     /* 117256 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(117303), // Rule ID 3236 //
     /* 117261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 117264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 117272 */     // MIs[0] sbase
     /* 117272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117284 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 117287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117289 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117301 */     GIR_RootConstrainSelectedInstOperands,
     /* 117302 */     // GIR_Coverage, 3236,
     /* 117302 */     GIR_EraseRootFromParent_Done,
     /* 117303 */   // Label 1712: @117303
     /* 117303 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(117347), // Rule ID 3225 //
     /* 117308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 117316 */     // MIs[0] sbase
     /* 117316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117328 */     // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 117331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117333 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117345 */     GIR_RootConstrainSelectedInstOperands,
     /* 117346 */     // GIR_Coverage, 3225,
     /* 117346 */     GIR_EraseRootFromParent_Done,
     /* 117347 */   // Label 1713: @117347
     /* 117347 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(117391), // Rule ID 3242 //
     /* 117352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 117360 */     // MIs[0] sbase
     /* 117360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 117368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 117372 */     // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 117372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 117375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 117377 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 117379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117389 */     GIR_RootConstrainSelectedInstOperands,
     /* 117390 */     // GIR_Coverage, 3242,
     /* 117390 */     GIR_EraseRootFromParent_Done,
     /* 117391 */   // Label 1714: @117391
     /* 117391 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(117448), // Rule ID 4370 //
     /* 117396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 117399 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 117419 */     // (ld:{ *:[v2i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 117419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 117422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 117434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117446 */     GIR_RootConstrainSelectedInstOperands,
     /* 117447 */     // GIR_Coverage, 4370,
     /* 117447 */     GIR_EraseRootFromParent_Done,
     /* 117448 */   // Label 1715: @117448
     /* 117448 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(117505), // Rule ID 4376 //
     /* 117453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 117456 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 117476 */     // (ld:{ *:[v2f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 117476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 117479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 117491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117503 */     GIR_RootConstrainSelectedInstOperands,
     /* 117504 */     // GIR_Coverage, 4376,
     /* 117504 */     GIR_EraseRootFromParent_Done,
     /* 117505 */   // Label 1716: @117505
     /* 117505 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(117557), // Rule ID 4369 //
     /* 117510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117513 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 117533 */     // (ld:{ *:[v2i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 117533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 117536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 117543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117555 */     GIR_RootConstrainSelectedInstOperands,
     /* 117556 */     // GIR_Coverage, 4369,
     /* 117556 */     GIR_EraseRootFromParent_Done,
     /* 117557 */   // Label 1717: @117557
     /* 117557 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(117609), // Rule ID 4375 //
     /* 117562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117565 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 117585 */     // (ld:{ *:[v2f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 117585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 117588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 117595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117607 */     GIR_RootConstrainSelectedInstOperands,
     /* 117608 */     // GIR_Coverage, 4375,
     /* 117608 */     GIR_EraseRootFromParent_Done,
     /* 117609 */   // Label 1718: @117609
     /* 117609 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(117661), // Rule ID 4368 //
     /* 117614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 117637 */     // (ld:{ *:[v2i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 117637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 117640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117659 */     GIR_RootConstrainSelectedInstOperands,
     /* 117660 */     // GIR_Coverage, 4368,
     /* 117660 */     GIR_EraseRootFromParent_Done,
     /* 117661 */   // Label 1719: @117661
     /* 117661 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(117713), // Rule ID 4374 //
     /* 117666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 117669 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 117674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 117689 */     // (ld:{ *:[v2f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 117689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 117692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 117694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 117699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117711 */     GIR_RootConstrainSelectedInstOperands,
     /* 117712 */     // GIR_Coverage, 4374,
     /* 117712 */     GIR_EraseRootFromParent_Done,
     /* 117713 */   // Label 1720: @117713
     /* 117713 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(117780), // Rule ID 4591 //
     /* 117718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117721 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117743 */     // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 117746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117778 */     GIR_RootConstrainSelectedInstOperands,
     /* 117779 */     // GIR_Coverage, 4591,
     /* 117779 */     GIR_EraseRootFromParent_Done,
     /* 117780 */   // Label 1721: @117780
     /* 117780 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(117844), // Rule ID 4593 //
     /* 117785 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117807 */     // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 117810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117842 */     GIR_RootConstrainSelectedInstOperands,
     /* 117843 */     // GIR_Coverage, 4593,
     /* 117843 */     GIR_EraseRootFromParent_Done,
     /* 117844 */   // Label 1722: @117844
     /* 117844 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(117911), // Rule ID 4595 //
     /* 117849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 117852 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117874 */     // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 117877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117909 */     GIR_RootConstrainSelectedInstOperands,
     /* 117910 */     // GIR_Coverage, 4595,
     /* 117910 */     GIR_EraseRootFromParent_Done,
     /* 117911 */   // Label 1723: @117911
     /* 117911 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(117975), // Rule ID 4597 //
     /* 117916 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 117923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 117938 */     // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 117938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 117941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 117943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 117948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 117953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 117958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 117963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117973 */     GIR_RootConstrainSelectedInstOperands,
     /* 117974 */     // GIR_Coverage, 4597,
     /* 117974 */     GIR_EraseRootFromParent_Done,
     /* 117975 */   // Label 1724: @117975
     /* 117975 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(118036), // Rule ID 8108 //
     /* 117980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 117983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117987 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 117992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 117996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 118007 */     // (AMDGPUld_glue:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 118007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 118010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 118017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 118022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 118027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118034 */     GIR_RootConstrainSelectedInstOperands,
     /* 118035 */     // GIR_Coverage, 8108,
     /* 118035 */     GIR_EraseRootFromParent_Done,
     /* 118036 */   // Label 1725: @118036
     /* 118036 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(118097), // Rule ID 8112 //
     /* 118041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 118044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118048 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 118053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 118068 */     // (AMDGPUld_glue:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 118068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 118071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 118078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 118083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 118088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118095 */     GIR_RootConstrainSelectedInstOperands,
     /* 118096 */     // GIR_Coverage, 8112,
     /* 118096 */     GIR_EraseRootFromParent_Done,
     /* 118097 */   // Label 1726: @118097
     /* 118097 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(118159), // Rule ID 4590 //
     /* 118102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 118105 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118127 */     // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 118130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118157 */     GIR_RootConstrainSelectedInstOperands,
     /* 118158 */     // GIR_Coverage, 4590,
     /* 118158 */     GIR_EraseRootFromParent_Done,
     /* 118159 */   // Label 1727: @118159
     /* 118159 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(118218), // Rule ID 4592 //
     /* 118164 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118186 */     // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 118189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118216 */     GIR_RootConstrainSelectedInstOperands,
     /* 118217 */     // GIR_Coverage, 4592,
     /* 118217 */     GIR_EraseRootFromParent_Done,
     /* 118218 */   // Label 1728: @118218
     /* 118218 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(118280), // Rule ID 4594 //
     /* 118223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 118226 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118248 */     // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 118251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118278 */     GIR_RootConstrainSelectedInstOperands,
     /* 118279 */     // GIR_Coverage, 4594,
     /* 118279 */     GIR_EraseRootFromParent_Done,
     /* 118280 */   // Label 1729: @118280
     /* 118280 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(118339), // Rule ID 4596 //
     /* 118285 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 118307 */     // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 118307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 118310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 118312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 118317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118337 */     GIR_RootConstrainSelectedInstOperands,
     /* 118338 */     // GIR_Coverage, 4596,
     /* 118338 */     GIR_EraseRootFromParent_Done,
     /* 118339 */   // Label 1730: @118339
     /* 118339 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(118396), // Rule ID 8110 //
     /* 118344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 118347 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 118352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 118367 */     // (ld:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 118367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 118370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 118377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 118382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 118387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118394 */     GIR_RootConstrainSelectedInstOperands,
     /* 118395 */     // GIR_Coverage, 8110,
     /* 118395 */     GIR_EraseRootFromParent_Done,
     /* 118396 */   // Label 1731: @118396
     /* 118396 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(118453), // Rule ID 8114 //
     /* 118401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 118404 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 118409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 118424 */     // (ld:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 118424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 118427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 118434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 118439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 118444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118451 */     GIR_RootConstrainSelectedInstOperands,
     /* 118452 */     // GIR_Coverage, 8114,
     /* 118452 */     GIR_EraseRootFromParent_Done,
     /* 118453 */   // Label 1732: @118453
     /* 118453 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(118512), // Rule ID 3946 //
     /* 118458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118461 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 118483 */     // (ld:{ *:[v2i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 118486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 118493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 118498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118510 */     GIR_RootConstrainSelectedInstOperands,
     /* 118511 */     // GIR_Coverage, 3946,
     /* 118511 */     GIR_EraseRootFromParent_Done,
     /* 118512 */   // Label 1733: @118512
     /* 118512 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(118571), // Rule ID 3950 //
     /* 118517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118520 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 118542 */     // (ld:{ *:[v2f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 118545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 118552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 118557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118569 */     GIR_RootConstrainSelectedInstOperands,
     /* 118570 */     // GIR_Coverage, 3950,
     /* 118570 */     GIR_EraseRootFromParent_Done,
     /* 118571 */   // Label 1734: @118571
     /* 118571 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(118625), // Rule ID 3945 //
     /* 118576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118579 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 118601 */     // (ld:{ *:[v2i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 118604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118623 */     GIR_RootConstrainSelectedInstOperands,
     /* 118624 */     // GIR_Coverage, 3945,
     /* 118624 */     GIR_EraseRootFromParent_Done,
     /* 118625 */   // Label 1735: @118625
     /* 118625 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(118679), // Rule ID 3949 //
     /* 118630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 118633 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 118655 */     // (ld:{ *:[v2f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 118658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118677 */     GIR_RootConstrainSelectedInstOperands,
     /* 118678 */     // GIR_Coverage, 3949,
     /* 118678 */     GIR_EraseRootFromParent_Done,
     /* 118679 */   // Label 1736: @118679
     /* 118679 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(118734), // Rule ID 3659 //
     /* 118684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 118687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 118710 */     // (ld:{ *:[v2i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 118713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118732 */     GIR_RootConstrainSelectedInstOperands,
     /* 118733 */     // GIR_Coverage, 3659,
     /* 118733 */     GIR_EraseRootFromParent_Done,
     /* 118734 */   // Label 1737: @118734
     /* 118734 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(118789), // Rule ID 3661 //
     /* 118739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 118742 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 118750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 118754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 118765 */     // (ld:{ *:[v2f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 118765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 118768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 118770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 118775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118787 */     GIR_RootConstrainSelectedInstOperands,
     /* 118788 */     // GIR_Coverage, 3661,
     /* 118788 */     GIR_EraseRootFromParent_Done,
     /* 118789 */   // Label 1738: @118789
     /* 118789 */   GIM_Reject,
     /* 118790 */ // Label 1672: @118790
     /* 118790 */ GIM_Reject,
     /* 118791 */ // Label 1011: @118791
     /* 118791 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(122009),
     /* 118796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118799 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(118863), // Rule ID 3148 //
     /* 118804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 118815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118834 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 118837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118861 */     GIR_RootConstrainSelectedInstOperands,
     /* 118862 */     // GIR_Coverage, 3148,
     /* 118862 */     GIR_EraseRootFromParent_Done,
     /* 118863 */   // Label 1740: @118863
     /* 118863 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(118927), // Rule ID 3163 //
     /* 118868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 118879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 118891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118898 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 118901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118925 */     GIR_RootConstrainSelectedInstOperands,
     /* 118926 */     // GIR_Coverage, 3163,
     /* 118926 */     GIR_EraseRootFromParent_Done,
     /* 118927 */   // Label 1741: @118927
     /* 118927 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(118987), // Rule ID 3153 //
     /* 118932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 118943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 118951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 118958 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 118958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 118961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 118963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 118968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 118973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 118978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118985 */     GIR_RootConstrainSelectedInstOperands,
     /* 118986 */     // GIR_Coverage, 3153,
     /* 118986 */     GIR_EraseRootFromParent_Done,
     /* 118987 */   // Label 1742: @118987
     /* 118987 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(119047), // Rule ID 3168 //
     /* 118992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 118995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 119018 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 119021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119045 */     GIR_RootConstrainSelectedInstOperands,
     /* 119046 */     // GIR_Coverage, 3168,
     /* 119046 */     GIR_EraseRootFromParent_Done,
     /* 119047 */   // Label 1743: @119047
     /* 119047 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(119107), // Rule ID 3158 //
     /* 119052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 119055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 119078 */     // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 119081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119105 */     GIR_RootConstrainSelectedInstOperands,
     /* 119106 */     // GIR_Coverage, 3158,
     /* 119106 */     GIR_EraseRootFromParent_Done,
     /* 119107 */   // Label 1744: @119107
     /* 119107 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(119167), // Rule ID 3173 //
     /* 119112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 119115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 119138 */     // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 119141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119165 */     GIR_RootConstrainSelectedInstOperands,
     /* 119166 */     // GIR_Coverage, 3173,
     /* 119166 */     GIR_EraseRootFromParent_Done,
     /* 119167 */   // Label 1745: @119167
     /* 119167 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(119226), // Rule ID 3145 //
     /* 119172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119202 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 119205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119224 */     GIR_RootConstrainSelectedInstOperands,
     /* 119225 */     // GIR_Coverage, 3145,
     /* 119225 */     GIR_EraseRootFromParent_Done,
     /* 119226 */   // Label 1746: @119226
     /* 119226 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(119285), // Rule ID 3146 //
     /* 119231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119261 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 119264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119283 */     GIR_RootConstrainSelectedInstOperands,
     /* 119284 */     // GIR_Coverage, 3146,
     /* 119284 */     GIR_EraseRootFromParent_Done,
     /* 119285 */   // Label 1747: @119285
     /* 119285 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(119347), // Rule ID 3147 //
     /* 119290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119293 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119320 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 119323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119345 */     GIR_RootConstrainSelectedInstOperands,
     /* 119346 */     // GIR_Coverage, 3147,
     /* 119346 */     GIR_EraseRootFromParent_Done,
     /* 119347 */   // Label 1748: @119347
     /* 119347 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(119406), // Rule ID 3160 //
     /* 119352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119382 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 119385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119404 */     GIR_RootConstrainSelectedInstOperands,
     /* 119405 */     // GIR_Coverage, 3160,
     /* 119405 */     GIR_EraseRootFromParent_Done,
     /* 119406 */   // Label 1749: @119406
     /* 119406 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(119465), // Rule ID 3161 //
     /* 119411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119441 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 119444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119463 */     GIR_RootConstrainSelectedInstOperands,
     /* 119464 */     // GIR_Coverage, 3161,
     /* 119464 */     GIR_EraseRootFromParent_Done,
     /* 119465 */   // Label 1750: @119465
     /* 119465 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(119527), // Rule ID 3162 //
     /* 119470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 119493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119500 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 119503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119525 */     GIR_RootConstrainSelectedInstOperands,
     /* 119526 */     // GIR_Coverage, 3162,
     /* 119526 */     GIR_EraseRootFromParent_Done,
     /* 119527 */   // Label 1751: @119527
     /* 119527 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(119582), // Rule ID 3150 //
     /* 119532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119558 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 119561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119580 */     GIR_RootConstrainSelectedInstOperands,
     /* 119581 */     // GIR_Coverage, 3150,
     /* 119581 */     GIR_EraseRootFromParent_Done,
     /* 119582 */   // Label 1752: @119582
     /* 119582 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(119637), // Rule ID 3151 //
     /* 119587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119613 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
     /* 119616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119635 */     GIR_RootConstrainSelectedInstOperands,
     /* 119636 */     // GIR_Coverage, 3151,
     /* 119636 */     GIR_EraseRootFromParent_Done,
     /* 119637 */   // Label 1753: @119637
     /* 119637 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(119695), // Rule ID 3152 //
     /* 119642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119668 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 119671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119693 */     GIR_RootConstrainSelectedInstOperands,
     /* 119694 */     // GIR_Coverage, 3152,
     /* 119694 */     GIR_EraseRootFromParent_Done,
     /* 119695 */   // Label 1754: @119695
     /* 119695 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(119750), // Rule ID 3165 //
     /* 119700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 119703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 119726 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 119726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 119729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119748 */     GIR_RootConstrainSelectedInstOperands,
     /* 119749 */     // GIR_Coverage, 3165,
     /* 119749 */     GIR_EraseRootFromParent_Done,
     /* 119750 */   // Label 1755: @119750
     /* 119750 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(119805), // Rule ID 3166 //
     /* 119755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 119758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119781 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 119781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
     /* 119784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119803 */     GIR_RootConstrainSelectedInstOperands,
     /* 119804 */     // GIR_Coverage, 3166,
     /* 119804 */     GIR_EraseRootFromParent_Done,
     /* 119805 */   // Label 1756: @119805
     /* 119805 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(119863), // Rule ID 3167 //
     /* 119810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 119813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 119821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119825 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 119829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 119836 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 119836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
     /* 119839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 119841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 119846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 119851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119861 */     GIR_RootConstrainSelectedInstOperands,
     /* 119862 */     // GIR_Coverage, 3167,
     /* 119862 */     GIR_EraseRootFromParent_Done,
     /* 119863 */   // Label 1757: @119863
     /* 119863 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(119923), // Rule ID 8160 //
     /* 119868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 119871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119875 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119880 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 119884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 119888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119899 */     // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 119902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119921 */     GIR_RootConstrainSelectedInstOperands,
     /* 119922 */     // GIR_Coverage, 8160,
     /* 119922 */     GIR_EraseRootFromParent_Done,
     /* 119923 */   // Label 1758: @119923
     /* 119923 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(119983), // Rule ID 8164 //
     /* 119928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 119931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119935 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 119940 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 119944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 119948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 119959 */     // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 119959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 119962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 119964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 119969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119981 */     GIR_RootConstrainSelectedInstOperands,
     /* 119982 */     // GIR_Coverage, 8164,
     /* 119982 */     GIR_EraseRootFromParent_Done,
     /* 119983 */   // Label 1759: @119983
     /* 119983 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(120039), // Rule ID 8228 //
     /* 119988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 119991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119995 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 120004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120015 */     // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 120018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120037 */     GIR_RootConstrainSelectedInstOperands,
     /* 120038 */     // GIR_Coverage, 8228,
     /* 120038 */     GIR_EraseRootFromParent_Done,
     /* 120039 */   // Label 1760: @120039
     /* 120039 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(120095), // Rule ID 8232 //
     /* 120044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 120047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120051 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 120060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120071 */     // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
     /* 120074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120093 */     GIR_RootConstrainSelectedInstOperands,
     /* 120094 */     // GIR_Coverage, 8232,
     /* 120094 */     GIR_EraseRootFromParent_Done,
     /* 120095 */   // Label 1761: @120095
     /* 120095 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(120147), // Rule ID 3155 //
     /* 120100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120112 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 120123 */     // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 120126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120145 */     GIR_RootConstrainSelectedInstOperands,
     /* 120146 */     // GIR_Coverage, 3155,
     /* 120146 */     GIR_EraseRootFromParent_Done,
     /* 120147 */   // Label 1762: @120147
     /* 120147 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(120202), // Rule ID 3156 //
     /* 120152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 120155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120178 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 120178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 120181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120200 */     GIR_RootConstrainSelectedInstOperands,
     /* 120201 */     // GIR_Coverage, 3156,
     /* 120201 */     GIR_EraseRootFromParent_Done,
     /* 120202 */   // Label 1763: @120202
     /* 120202 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(120260), // Rule ID 3157 //
     /* 120207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 120210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120233 */     // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 120236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120258 */     GIR_RootConstrainSelectedInstOperands,
     /* 120259 */     // GIR_Coverage, 3157,
     /* 120259 */     GIR_EraseRootFromParent_Done,
     /* 120260 */   // Label 1764: @120260
     /* 120260 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(120312), // Rule ID 3170 //
     /* 120265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 120288 */     // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 120288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 120291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120310 */     GIR_RootConstrainSelectedInstOperands,
     /* 120311 */     // GIR_Coverage, 3170,
     /* 120311 */     GIR_EraseRootFromParent_Done,
     /* 120312 */   // Label 1765: @120312
     /* 120312 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(120367), // Rule ID 3171 //
     /* 120317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 120320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120343 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 120343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
     /* 120346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120365 */     GIR_RootConstrainSelectedInstOperands,
     /* 120366 */     // GIR_Coverage, 3171,
     /* 120366 */     GIR_EraseRootFromParent_Done,
     /* 120367 */   // Label 1766: @120367
     /* 120367 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(120425), // Rule ID 3172 //
     /* 120372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 120375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 120398 */     // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
     /* 120401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 120408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120423 */     GIR_RootConstrainSelectedInstOperands,
     /* 120424 */     // GIR_Coverage, 3172,
     /* 120424 */     GIR_EraseRootFromParent_Done,
     /* 120425 */   // Label 1767: @120425
     /* 120425 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(120481), // Rule ID 8161 //
     /* 120430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 120433 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120438 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 120442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 120446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120457 */     // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 120460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120479 */     GIR_RootConstrainSelectedInstOperands,
     /* 120480 */     // GIR_Coverage, 8161,
     /* 120480 */     GIR_EraseRootFromParent_Done,
     /* 120481 */   // Label 1768: @120481
     /* 120481 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(120537), // Rule ID 8165 //
     /* 120486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 120489 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120494 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 120498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 120502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120513 */     // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 120516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120535 */     GIR_RootConstrainSelectedInstOperands,
     /* 120536 */     // GIR_Coverage, 8165,
     /* 120536 */     GIR_EraseRootFromParent_Done,
     /* 120537 */   // Label 1769: @120537
     /* 120537 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(120589), // Rule ID 8229 //
     /* 120542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 120545 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 120554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120565 */     // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 120568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120587 */     GIR_RootConstrainSelectedInstOperands,
     /* 120588 */     // GIR_Coverage, 8229,
     /* 120588 */     GIR_EraseRootFromParent_Done,
     /* 120589 */   // Label 1770: @120589
     /* 120589 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(120641), // Rule ID 8233 //
     /* 120594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 120597 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 120602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 120606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 120617 */     // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 120617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
     /* 120620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 120622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 120627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120639 */     GIR_RootConstrainSelectedInstOperands,
     /* 120640 */     // GIR_Coverage, 8233,
     /* 120640 */     GIR_EraseRootFromParent_Done,
     /* 120641 */   // Label 1771: @120641
     /* 120641 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(120692), // Rule ID 3149 //
     /* 120646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120657 */     // MIs[0] sbase
     /* 120657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 120673 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 120676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120678 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120690 */     GIR_RootConstrainSelectedInstOperands,
     /* 120691 */     // GIR_Coverage, 3149,
     /* 120691 */     GIR_EraseRootFromParent_Done,
     /* 120692 */   // Label 1772: @120692
     /* 120692 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(120743), // Rule ID 3164 //
     /* 120697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120708 */     // MIs[0] sbase
     /* 120708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 120724 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 120727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120729 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120741 */     GIR_RootConstrainSelectedInstOperands,
     /* 120742 */     // GIR_Coverage, 3164,
     /* 120742 */     GIR_EraseRootFromParent_Done,
     /* 120743 */   // Label 1773: @120743
     /* 120743 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(120790), // Rule ID 3154 //
     /* 120748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120759 */     // MIs[0] sbase
     /* 120759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120771 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 120774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120776 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120788 */     GIR_RootConstrainSelectedInstOperands,
     /* 120789 */     // GIR_Coverage, 3154,
     /* 120789 */     GIR_EraseRootFromParent_Done,
     /* 120790 */   // Label 1774: @120790
     /* 120790 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(120837), // Rule ID 3169 //
     /* 120795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 120798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120806 */     // MIs[0] sbase
     /* 120806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120818 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
     /* 120821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120823 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120835 */     GIR_RootConstrainSelectedInstOperands,
     /* 120836 */     // GIR_Coverage, 3169,
     /* 120836 */     GIR_EraseRootFromParent_Done,
     /* 120837 */   // Label 1775: @120837
     /* 120837 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(120881), // Rule ID 3159 //
     /* 120842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120850 */     // MIs[0] sbase
     /* 120850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120862 */     // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 120865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120867 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120879 */     GIR_RootConstrainSelectedInstOperands,
     /* 120880 */     // GIR_Coverage, 3159,
     /* 120880 */     GIR_EraseRootFromParent_Done,
     /* 120881 */   // Label 1776: @120881
     /* 120881 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(120925), // Rule ID 3174 //
     /* 120886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 120894 */     // MIs[0] sbase
     /* 120894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 120902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 120906 */     // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 120906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
     /* 120909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 120911 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 120913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120923 */     GIR_RootConstrainSelectedInstOperands,
     /* 120924 */     // GIR_Coverage, 3174,
     /* 120924 */     GIR_EraseRootFromParent_Done,
     /* 120925 */   // Label 1777: @120925
     /* 120925 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(120985), // Rule ID 6527 //
     /* 120930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 120933 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 120942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 120953 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 120953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 120956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 120958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 120963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 120968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 120973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120983 */     GIR_RootConstrainSelectedInstOperands,
     /* 120984 */     // GIR_Coverage, 6527,
     /* 120984 */     GIR_EraseRootFromParent_Done,
     /* 120985 */   // Label 1778: @120985
     /* 120985 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(121045), // Rule ID 6529 //
     /* 120990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 120993 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 120998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 121013 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 121013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 121016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121043 */     GIR_RootConstrainSelectedInstOperands,
     /* 121044 */     // GIR_Coverage, 6529,
     /* 121044 */     GIR_EraseRootFromParent_Done,
     /* 121045 */   // Label 1779: @121045
     /* 121045 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(121102), // Rule ID 4355 //
     /* 121050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 121053 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 121073 */     // (ld:{ *:[v3i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SVS:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 121073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SVS),
     /* 121076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 121088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121100 */     GIR_RootConstrainSelectedInstOperands,
     /* 121101 */     // GIR_Coverage, 4355,
     /* 121101 */     GIR_EraseRootFromParent_Done,
     /* 121102 */   // Label 1780: @121102
     /* 121102 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(121154), // Rule ID 4354 //
     /* 121107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 121110 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 121130 */     // (ld:{ *:[v3i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 121130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SADDR),
     /* 121133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 121140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121152 */     GIR_RootConstrainSelectedInstOperands,
     /* 121153 */     // GIR_Coverage, 4354,
     /* 121153 */     GIR_EraseRootFromParent_Done,
     /* 121154 */   // Label 1781: @121154
     /* 121154 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(121206), // Rule ID 4353 //
     /* 121159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 121162 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 121182 */     // (ld:{ *:[v3i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3),
     /* 121185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121204 */     GIR_RootConstrainSelectedInstOperands,
     /* 121205 */     // GIR_Coverage, 4353,
     /* 121205 */     GIR_EraseRootFromParent_Done,
     /* 121206 */   // Label 1782: @121206
     /* 121206 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(121273), // Rule ID 4575 //
     /* 121211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121236 */     // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
     /* 121239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121271 */     GIR_RootConstrainSelectedInstOperands,
     /* 121272 */     // GIR_Coverage, 4575,
     /* 121272 */     GIR_EraseRootFromParent_Done,
     /* 121273 */   // Label 1783: @121273
     /* 121273 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(121337), // Rule ID 4577 //
     /* 121278 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121300 */     // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
     /* 121303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121335 */     GIR_RootConstrainSelectedInstOperands,
     /* 121336 */     // GIR_Coverage, 4577,
     /* 121336 */     GIR_EraseRootFromParent_Done,
     /* 121337 */   // Label 1784: @121337
     /* 121337 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(121404), // Rule ID 4579 //
     /* 121342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121345 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121367 */     // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
     /* 121370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121402 */     GIR_RootConstrainSelectedInstOperands,
     /* 121403 */     // GIR_Coverage, 4579,
     /* 121403 */     GIR_EraseRootFromParent_Done,
     /* 121404 */   // Label 1785: @121404
     /* 121404 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(121468), // Rule ID 4581 //
     /* 121409 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 121431 */     // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
     /* 121434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121466 */     GIR_RootConstrainSelectedInstOperands,
     /* 121467 */     // GIR_Coverage, 4581,
     /* 121467 */     GIR_EraseRootFromParent_Done,
     /* 121468 */   // Label 1786: @121468
     /* 121468 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(121533), // Rule ID 6526 //
     /* 121473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 121476 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 121496 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 121496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 121499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121531 */     GIR_RootConstrainSelectedInstOperands,
     /* 121532 */     // GIR_Coverage, 6526,
     /* 121532 */     GIR_EraseRootFromParent_Done,
     /* 121533 */   // Label 1787: @121533
     /* 121533 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(121598), // Rule ID 6528 //
     /* 121538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 121541 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 121546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 121561 */     // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 121561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 121564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 121571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 121581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 121586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121596 */     GIR_RootConstrainSelectedInstOperands,
     /* 121597 */     // GIR_Coverage, 6528,
     /* 121597 */     GIR_EraseRootFromParent_Done,
     /* 121598 */   // Label 1788: @121598
     /* 121598 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(121660), // Rule ID 4574 //
     /* 121603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121606 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121628 */     // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 121631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121658 */     GIR_RootConstrainSelectedInstOperands,
     /* 121659 */     // GIR_Coverage, 4574,
     /* 121659 */     GIR_EraseRootFromParent_Done,
     /* 121660 */   // Label 1789: @121660
     /* 121660 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(121719), // Rule ID 4576 //
     /* 121665 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121687 */     // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 121690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121717 */     GIR_RootConstrainSelectedInstOperands,
     /* 121718 */     // GIR_Coverage, 4576,
     /* 121718 */     GIR_EraseRootFromParent_Done,
     /* 121719 */   // Label 1790: @121719
     /* 121719 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(121781), // Rule ID 4578 //
     /* 121724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 121727 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121749 */     // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 121752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121779 */     GIR_RootConstrainSelectedInstOperands,
     /* 121780 */     // GIR_Coverage, 4578,
     /* 121780 */     GIR_EraseRootFromParent_Done,
     /* 121781 */   // Label 1791: @121781
     /* 121781 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(121840), // Rule ID 4580 //
     /* 121786 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 121808 */     // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 121808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 121811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 121813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 121818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 121823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121838 */     GIR_RootConstrainSelectedInstOperands,
     /* 121839 */     // GIR_Coverage, 4580,
     /* 121839 */     GIR_EraseRootFromParent_Done,
     /* 121840 */   // Label 1792: @121840
     /* 121840 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(121899), // Rule ID 3936 //
     /* 121845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121848 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 121870 */     // (ld:{ *:[v3i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 121870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3_SADDR),
     /* 121873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 121880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 121885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 121890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121897 */     GIR_RootConstrainSelectedInstOperands,
     /* 121898 */     // GIR_Coverage, 3936,
     /* 121898 */     GIR_EraseRootFromParent_Done,
     /* 121899 */   // Label 1793: @121899
     /* 121899 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(121953), // Rule ID 3935 //
     /* 121904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 121907 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 121929 */     // (ld:{ *:[v3i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3),
     /* 121932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121951 */     GIR_RootConstrainSelectedInstOperands,
     /* 121952 */     // GIR_Coverage, 3935,
     /* 121952 */     GIR_EraseRootFromParent_Done,
     /* 121953 */   // Label 1794: @121953
     /* 121953 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(122008), // Rule ID 3597 //
     /* 121958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 121961 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 121969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 121973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 121984 */     // (ld:{ *:[v3i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 121984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX3),
     /* 121987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 121989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 121994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122006 */     GIR_RootConstrainSelectedInstOperands,
     /* 122007 */     // GIR_Coverage, 3597,
     /* 122007 */     GIR_EraseRootFromParent_Done,
     /* 122008 */   // Label 1795: @122008
     /* 122008 */   GIM_Reject,
     /* 122009 */ // Label 1739: @122009
     /* 122009 */ GIM_Reject,
     /* 122010 */ // Label 1012: @122010
     /* 122010 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(125807),
     /* 122015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122018 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(122082), // Rule ID 3115 //
     /* 122023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122053 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 122056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122080 */     GIR_RootConstrainSelectedInstOperands,
     /* 122081 */     // GIR_Coverage, 3115,
     /* 122081 */     GIR_EraseRootFromParent_Done,
     /* 122082 */   // Label 1797: @122082
     /* 122082 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(122146), // Rule ID 3132 //
     /* 122087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122117 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 122120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122144 */     GIR_RootConstrainSelectedInstOperands,
     /* 122145 */     // GIR_Coverage, 3132,
     /* 122145 */     GIR_EraseRootFromParent_Done,
     /* 122146 */   // Label 1798: @122146
     /* 122146 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(122206), // Rule ID 3120 //
     /* 122151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122177 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 122180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122204 */     GIR_RootConstrainSelectedInstOperands,
     /* 122205 */     // GIR_Coverage, 3120,
     /* 122205 */     GIR_EraseRootFromParent_Done,
     /* 122206 */   // Label 1799: @122206
     /* 122206 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(122266), // Rule ID 3137 //
     /* 122211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122214 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122237 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 122240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122264 */     GIR_RootConstrainSelectedInstOperands,
     /* 122265 */     // GIR_Coverage, 3137,
     /* 122265 */     GIR_EraseRootFromParent_Done,
     /* 122266 */   // Label 1800: @122266
     /* 122266 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(122326), // Rule ID 3126 //
     /* 122271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 122274 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122297 */     // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 122300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122324 */     GIR_RootConstrainSelectedInstOperands,
     /* 122325 */     // GIR_Coverage, 3126,
     /* 122325 */     GIR_EraseRootFromParent_Done,
     /* 122326 */   // Label 1801: @122326
     /* 122326 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(122386), // Rule ID 3143 //
     /* 122331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 122334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 122357 */     // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 122360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 122377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122384 */     GIR_RootConstrainSelectedInstOperands,
     /* 122385 */     // GIR_Coverage, 3143,
     /* 122385 */     GIR_EraseRootFromParent_Done,
     /* 122386 */   // Label 1802: @122386
     /* 122386 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(122445), // Rule ID 3111 //
     /* 122391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122394 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122421 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 122424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122443 */     GIR_RootConstrainSelectedInstOperands,
     /* 122444 */     // GIR_Coverage, 3111,
     /* 122444 */     GIR_EraseRootFromParent_Done,
     /* 122445 */   // Label 1803: @122445
     /* 122445 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(122504), // Rule ID 3112 //
     /* 122450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 122453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 122480 */     // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 122483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122502 */     GIR_RootConstrainSelectedInstOperands,
     /* 122503 */     // GIR_Coverage, 3112,
     /* 122503 */     GIR_EraseRootFromParent_Done,
     /* 122504 */   // Label 1804: @122504
     /* 122504 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(122563), // Rule ID 3113 //
     /* 122509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 122512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122539 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 122539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 122542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122561 */     GIR_RootConstrainSelectedInstOperands,
     /* 122562 */     // GIR_Coverage, 3113,
     /* 122562 */     GIR_EraseRootFromParent_Done,
     /* 122563 */   // Label 1805: @122563
     /* 122563 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(122625), // Rule ID 3114 //
     /* 122568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122598 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 122598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 122601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122623 */     GIR_RootConstrainSelectedInstOperands,
     /* 122624 */     // GIR_Coverage, 3114,
     /* 122624 */     GIR_EraseRootFromParent_Done,
     /* 122625 */   // Label 1806: @122625
     /* 122625 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(122684), // Rule ID 3128 //
     /* 122630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122660 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 122663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122682 */     GIR_RootConstrainSelectedInstOperands,
     /* 122683 */     // GIR_Coverage, 3128,
     /* 122683 */     GIR_EraseRootFromParent_Done,
     /* 122684 */   // Label 1807: @122684
     /* 122684 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(122743), // Rule ID 3129 //
     /* 122689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 122692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 122719 */     // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 122722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122741 */     GIR_RootConstrainSelectedInstOperands,
     /* 122742 */     // GIR_Coverage, 3129,
     /* 122742 */     GIR_EraseRootFromParent_Done,
     /* 122743 */   // Label 1808: @122743
     /* 122743 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(122802), // Rule ID 3130 //
     /* 122748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 122751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122778 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 122778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 122781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122800 */     GIR_RootConstrainSelectedInstOperands,
     /* 122801 */     // GIR_Coverage, 3130,
     /* 122801 */     GIR_EraseRootFromParent_Done,
     /* 122802 */   // Label 1809: @122802
     /* 122802 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(122864), // Rule ID 3131 //
     /* 122807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 122830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122837 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 122837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 122840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122862 */     GIR_RootConstrainSelectedInstOperands,
     /* 122863 */     // GIR_Coverage, 3131,
     /* 122863 */     GIR_EraseRootFromParent_Done,
     /* 122864 */   // Label 1810: @122864
     /* 122864 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(122919), // Rule ID 3117 //
     /* 122869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 122872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 122895 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 122895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 122898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122917 */     GIR_RootConstrainSelectedInstOperands,
     /* 122918 */     // GIR_Coverage, 3117,
     /* 122918 */     GIR_EraseRootFromParent_Done,
     /* 122919 */   // Label 1811: @122919
     /* 122919 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(122974), // Rule ID 3118 //
     /* 122924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 122927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 122950 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 122950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 122953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 122955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 122960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 122965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122972 */     GIR_RootConstrainSelectedInstOperands,
     /* 122973 */     // GIR_Coverage, 3118,
     /* 122973 */     GIR_EraseRootFromParent_Done,
     /* 122974 */   // Label 1812: @122974
     /* 122974 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(123032), // Rule ID 3119 //
     /* 122979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 122982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 122990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 122998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123005 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 123008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123030 */     GIR_RootConstrainSelectedInstOperands,
     /* 123031 */     // GIR_Coverage, 3119,
     /* 123031 */     GIR_EraseRootFromParent_Done,
     /* 123032 */   // Label 1813: @123032
     /* 123032 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(123087), // Rule ID 3134 //
     /* 123037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 123040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123063 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 123066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123085 */     GIR_RootConstrainSelectedInstOperands,
     /* 123086 */     // GIR_Coverage, 3134,
     /* 123086 */     GIR_EraseRootFromParent_Done,
     /* 123087 */   // Label 1814: @123087
     /* 123087 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(123142), // Rule ID 3135 //
     /* 123092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 123095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123118 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
     /* 123121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123140 */     GIR_RootConstrainSelectedInstOperands,
     /* 123141 */     // GIR_Coverage, 3135,
     /* 123141 */     GIR_EraseRootFromParent_Done,
     /* 123142 */   // Label 1815: @123142
     /* 123142 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(123200), // Rule ID 3136 //
     /* 123147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 123150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123173 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
     /* 123176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123198 */     GIR_RootConstrainSelectedInstOperands,
     /* 123199 */     // GIR_Coverage, 3136,
     /* 123199 */     GIR_EraseRootFromParent_Done,
     /* 123200 */   // Label 1816: @123200
     /* 123200 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(123265), // Rule ID 8208 //
     /* 123205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 123208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123212 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123217 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 123226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 123234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123241 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 123244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123263 */     GIR_RootConstrainSelectedInstOperands,
     /* 123264 */     // GIR_Coverage, 8208,
     /* 123264 */     GIR_EraseRootFromParent_Done,
     /* 123265 */   // Label 1817: @123265
     /* 123265 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(123330), // Rule ID 8212 //
     /* 123270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 123273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123277 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123282 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 123291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 123299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123306 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 123309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123328 */     GIR_RootConstrainSelectedInstOperands,
     /* 123329 */     // GIR_Coverage, 8212,
     /* 123329 */     GIR_EraseRootFromParent_Done,
     /* 123330 */   // Label 1818: @123330
     /* 123330 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(123390), // Rule ID 8140 //
     /* 123335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 123338 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123342 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123347 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 123351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 123355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123366 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 123369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123388 */     GIR_RootConstrainSelectedInstOperands,
     /* 123389 */     // GIR_Coverage, 8140,
     /* 123389 */     GIR_EraseRootFromParent_Done,
     /* 123390 */   // Label 1819: @123390
     /* 123390 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(123450), // Rule ID 8144 //
     /* 123395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 123398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123402 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123407 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 123411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 123415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123426 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
     /* 123429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123448 */     GIR_RootConstrainSelectedInstOperands,
     /* 123449 */     // GIR_Coverage, 8144,
     /* 123449 */     GIR_EraseRootFromParent_Done,
     /* 123450 */   // Label 1820: @123450
     /* 123450 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(123502), // Rule ID 3122 //
     /* 123455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123478 */     // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 123481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123500 */     GIR_RootConstrainSelectedInstOperands,
     /* 123501 */     // GIR_Coverage, 3122,
     /* 123501 */     GIR_EraseRootFromParent_Done,
     /* 123502 */   // Label 1821: @123502
     /* 123502 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(123557), // Rule ID 3123 //
     /* 123507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 123510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 123533 */     // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 123536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123555 */     GIR_RootConstrainSelectedInstOperands,
     /* 123556 */     // GIR_Coverage, 3123,
     /* 123556 */     GIR_EraseRootFromParent_Done,
     /* 123557 */   // Label 1822: @123557
     /* 123557 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(123612), // Rule ID 3124 //
     /* 123562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 123565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123588 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 123591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123610 */     GIR_RootConstrainSelectedInstOperands,
     /* 123611 */     // GIR_Coverage, 3124,
     /* 123611 */     GIR_EraseRootFromParent_Done,
     /* 123612 */   // Label 1823: @123612
     /* 123612 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(123670), // Rule ID 3125 //
     /* 123617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 123620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123643 */     // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 123646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123668 */     GIR_RootConstrainSelectedInstOperands,
     /* 123669 */     // GIR_Coverage, 3125,
     /* 123669 */     GIR_EraseRootFromParent_Done,
     /* 123670 */   // Label 1824: @123670
     /* 123670 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(123722), // Rule ID 3139 //
     /* 123675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 123698 */     // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 123701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123720 */     GIR_RootConstrainSelectedInstOperands,
     /* 123721 */     // GIR_Coverage, 3139,
     /* 123721 */     GIR_EraseRootFromParent_Done,
     /* 123722 */   // Label 1825: @123722
     /* 123722 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(123777), // Rule ID 3140 //
     /* 123727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 123730 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 123753 */     // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 123753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
     /* 123756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123775 */     GIR_RootConstrainSelectedInstOperands,
     /* 123776 */     // GIR_Coverage, 3140,
     /* 123776 */     GIR_EraseRootFromParent_Done,
     /* 123777 */   // Label 1826: @123777
     /* 123777 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(123832), // Rule ID 3141 //
     /* 123782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 123785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123797 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123808 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 123808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
     /* 123811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123830 */     GIR_RootConstrainSelectedInstOperands,
     /* 123831 */     // GIR_Coverage, 3141,
     /* 123831 */     GIR_EraseRootFromParent_Done,
     /* 123832 */   // Label 1827: @123832
     /* 123832 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(123890), // Rule ID 3142 //
     /* 123837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 123840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 123848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 123856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 123863 */     // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 123863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
     /* 123866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 123868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 123873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 123878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123888 */     GIR_RootConstrainSelectedInstOperands,
     /* 123889 */     // GIR_Coverage, 3142,
     /* 123889 */     GIR_EraseRootFromParent_Done,
     /* 123890 */   // Label 1828: @123890
     /* 123890 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(123951), // Rule ID 8209 //
     /* 123895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 123898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123903 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 123912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 123920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123927 */     // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 123930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123949 */     GIR_RootConstrainSelectedInstOperands,
     /* 123950 */     // GIR_Coverage, 8209,
     /* 123950 */     GIR_EraseRootFromParent_Done,
     /* 123951 */   // Label 1829: @123951
     /* 123951 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(124012), // Rule ID 8213 //
     /* 123956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 123959 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123964 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 123969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 123973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 123981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 123988 */     // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 123988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 123991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 123993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 123998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124010 */     GIR_RootConstrainSelectedInstOperands,
     /* 124011 */     // GIR_Coverage, 8213,
     /* 124011 */     GIR_EraseRootFromParent_Done,
     /* 124012 */   // Label 1830: @124012
     /* 124012 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(124068), // Rule ID 8141 //
     /* 124017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 124020 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124025 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 124029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124044 */     // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 124047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124066 */     GIR_RootConstrainSelectedInstOperands,
     /* 124067 */     // GIR_Coverage, 8141,
     /* 124067 */     GIR_EraseRootFromParent_Done,
     /* 124068 */   // Label 1831: @124068
     /* 124068 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(124124), // Rule ID 8145 //
     /* 124073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 124076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 124081 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 124085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 124100 */     // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 124100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
     /* 124103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 124110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124122 */     GIR_RootConstrainSelectedInstOperands,
     /* 124123 */     // GIR_Coverage, 8145,
     /* 124123 */     GIR_EraseRootFromParent_Done,
     /* 124124 */   // Label 1832: @124124
     /* 124124 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(124175), // Rule ID 3116 //
     /* 124129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 124140 */     // MIs[0] sbase
     /* 124140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124152 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 124156 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 124159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124161 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124173 */     GIR_RootConstrainSelectedInstOperands,
     /* 124174 */     // GIR_Coverage, 3116,
     /* 124174 */     GIR_EraseRootFromParent_Done,
     /* 124175 */   // Label 1833: @124175
     /* 124175 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(124226), // Rule ID 3133 //
     /* 124180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124183 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 124191 */     // MIs[0] sbase
     /* 124191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 124207 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 124210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124212 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124224 */     GIR_RootConstrainSelectedInstOperands,
     /* 124225 */     // GIR_Coverage, 3133,
     /* 124225 */     GIR_EraseRootFromParent_Done,
     /* 124226 */   // Label 1834: @124226
     /* 124226 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(124273), // Rule ID 3121 //
     /* 124231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124234 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 124242 */     // MIs[0] sbase
     /* 124242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124254 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 124257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124259 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124271 */     GIR_RootConstrainSelectedInstOperands,
     /* 124272 */     // GIR_Coverage, 3121,
     /* 124272 */     GIR_EraseRootFromParent_Done,
     /* 124273 */   // Label 1835: @124273
     /* 124273 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(124320), // Rule ID 3138 //
     /* 124278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 124281 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 124289 */     // MIs[0] sbase
     /* 124289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124301 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
     /* 124304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124306 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124318 */     GIR_RootConstrainSelectedInstOperands,
     /* 124319 */     // GIR_Coverage, 3138,
     /* 124319 */     GIR_EraseRootFromParent_Done,
     /* 124320 */   // Label 1836: @124320
     /* 124320 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(124364), // Rule ID 3127 //
     /* 124325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 124333 */     // MIs[0] sbase
     /* 124333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124345 */     // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 124348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124350 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124362 */     GIR_RootConstrainSelectedInstOperands,
     /* 124363 */     // GIR_Coverage, 3127,
     /* 124363 */     GIR_EraseRootFromParent_Done,
     /* 124364 */   // Label 1837: @124364
     /* 124364 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(124408), // Rule ID 3144 //
     /* 124369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 124377 */     // MIs[0] sbase
     /* 124377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 124385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 124389 */     // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 124389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
     /* 124392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 124394 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 124396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124406 */     GIR_RootConstrainSelectedInstOperands,
     /* 124407 */     // GIR_Coverage, 3144,
     /* 124407 */     GIR_EraseRootFromParent_Done,
     /* 124408 */   // Label 1838: @124408
     /* 124408 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(124465), // Rule ID 4325 //
     /* 124413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 124416 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 124436 */     // (ld:{ *:[v4i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 124436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 124439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 124451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124463 */     GIR_RootConstrainSelectedInstOperands,
     /* 124464 */     // GIR_Coverage, 4325,
     /* 124464 */     GIR_EraseRootFromParent_Done,
     /* 124465 */   // Label 1839: @124465
     /* 124465 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(124522), // Rule ID 4331 //
     /* 124470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 124473 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 124493 */     // (ld:{ *:[v4f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 124493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
     /* 124496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 124508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 124513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124520 */     GIR_RootConstrainSelectedInstOperands,
     /* 124521 */     // GIR_Coverage, 4331,
     /* 124521 */     GIR_EraseRootFromParent_Done,
     /* 124522 */   // Label 1840: @124522
     /* 124522 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(124574), // Rule ID 4324 //
     /* 124527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124530 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 124550 */     // (ld:{ *:[v4i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 124550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 124553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 124560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124572 */     GIR_RootConstrainSelectedInstOperands,
     /* 124573 */     // GIR_Coverage, 4324,
     /* 124573 */     GIR_EraseRootFromParent_Done,
     /* 124574 */   // Label 1841: @124574
     /* 124574 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(124626), // Rule ID 4330 //
     /* 124579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124582 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 124602 */     // (ld:{ *:[v4f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 124602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
     /* 124605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 124612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124624 */     GIR_RootConstrainSelectedInstOperands,
     /* 124625 */     // GIR_Coverage, 4330,
     /* 124625 */     GIR_EraseRootFromParent_Done,
     /* 124626 */   // Label 1842: @124626
     /* 124626 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(124678), // Rule ID 4323 //
     /* 124631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124634 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 124654 */     // (ld:{ *:[v4i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 124654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 124657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124676 */     GIR_RootConstrainSelectedInstOperands,
     /* 124677 */     // GIR_Coverage, 4323,
     /* 124677 */     GIR_EraseRootFromParent_Done,
     /* 124678 */   // Label 1843: @124678
     /* 124678 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(124730), // Rule ID 4329 //
     /* 124683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 124686 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 124691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 124706 */     // (ld:{ *:[v4f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 124706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
     /* 124709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 124711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 124716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124728 */     GIR_RootConstrainSelectedInstOperands,
     /* 124729 */     // GIR_Coverage, 4329,
     /* 124729 */     GIR_EraseRootFromParent_Done,
     /* 124730 */   // Label 1844: @124730
     /* 124730 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(124797), // Rule ID 4555 //
     /* 124735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 124738 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 124745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 124760 */     // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 124760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 124763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 124770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 124780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 124785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124795 */     GIR_RootConstrainSelectedInstOperands,
     /* 124796 */     // GIR_Coverage, 4555,
     /* 124796 */     GIR_EraseRootFromParent_Done,
     /* 124797 */   // Label 1845: @124797
     /* 124797 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(124861), // Rule ID 4557 //
     /* 124802 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 124809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 124824 */     // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 124824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 124827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 124834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 124844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 124849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124859 */     GIR_RootConstrainSelectedInstOperands,
     /* 124860 */     // GIR_Coverage, 4557,
     /* 124860 */     GIR_EraseRootFromParent_Done,
     /* 124861 */   // Label 1846: @124861
     /* 124861 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(124928), // Rule ID 4559 //
     /* 124866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 124869 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 124876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 124891 */     // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 124891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
     /* 124894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 124901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 124911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 124916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124926 */     GIR_RootConstrainSelectedInstOperands,
     /* 124927 */     // GIR_Coverage, 4559,
     /* 124927 */     GIR_EraseRootFromParent_Done,
     /* 124928 */   // Label 1847: @124928
     /* 124928 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(124992), // Rule ID 4561 //
     /* 124933 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 124940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 124944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 124955 */     // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 124955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
     /* 124958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 124960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 124965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 124970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 124975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 124980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124990 */     GIR_RootConstrainSelectedInstOperands,
     /* 124991 */     // GIR_Coverage, 4561,
     /* 124991 */     GIR_EraseRootFromParent_Done,
     /* 124992 */   // Label 1848: @124992
     /* 124992 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(125053), // Rule ID 8084 //
     /* 124997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 125000 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125004 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 125024 */     // (AMDGPUld_glue:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 125027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125051 */     GIR_RootConstrainSelectedInstOperands,
     /* 125052 */     // GIR_Coverage, 8084,
     /* 125052 */     GIR_EraseRootFromParent_Done,
     /* 125053 */   // Label 1849: @125053
     /* 125053 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(125114), // Rule ID 8088 //
     /* 125058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 125061 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125065 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 125085 */     // (AMDGPUld_glue:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
     /* 125088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125112 */     GIR_RootConstrainSelectedInstOperands,
     /* 125113 */     // GIR_Coverage, 8088,
     /* 125113 */     GIR_EraseRootFromParent_Done,
     /* 125114 */   // Label 1850: @125114
     /* 125114 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(125176), // Rule ID 4554 //
     /* 125119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125122 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125144 */     // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 125147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125174 */     GIR_RootConstrainSelectedInstOperands,
     /* 125175 */     // GIR_Coverage, 4554,
     /* 125175 */     GIR_EraseRootFromParent_Done,
     /* 125176 */   // Label 1851: @125176
     /* 125176 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(125235), // Rule ID 4556 //
     /* 125181 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125203 */     // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 125206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125233 */     GIR_RootConstrainSelectedInstOperands,
     /* 125234 */     // GIR_Coverage, 4556,
     /* 125234 */     GIR_EraseRootFromParent_Done,
     /* 125235 */   // Label 1852: @125235
     /* 125235 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(125297), // Rule ID 4558 //
     /* 125240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 125243 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125265 */     // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 125268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125295 */     GIR_RootConstrainSelectedInstOperands,
     /* 125296 */     // GIR_Coverage, 4558,
     /* 125296 */     GIR_EraseRootFromParent_Done,
     /* 125297 */   // Label 1853: @125297
     /* 125297 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(125356), // Rule ID 4560 //
     /* 125302 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 125324 */     // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 125324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 125327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 125329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 125334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125354 */     GIR_RootConstrainSelectedInstOperands,
     /* 125355 */     // GIR_Coverage, 4560,
     /* 125355 */     GIR_EraseRootFromParent_Done,
     /* 125356 */   // Label 1854: @125356
     /* 125356 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(125413), // Rule ID 8086 //
     /* 125361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 125364 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 125384 */     // (ld:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 125387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125411 */     GIR_RootConstrainSelectedInstOperands,
     /* 125412 */     // GIR_Coverage, 8086,
     /* 125412 */     GIR_EraseRootFromParent_Done,
     /* 125413 */   // Label 1855: @125413
     /* 125413 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(125470), // Rule ID 8090 //
     /* 125418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 125421 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 125426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 125441 */     // (ld:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 125441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
     /* 125444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 125451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 125456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 125461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125468 */     GIR_RootConstrainSelectedInstOperands,
     /* 125469 */     // GIR_Coverage, 8090,
     /* 125469 */     GIR_EraseRootFromParent_Done,
     /* 125470 */   // Label 1856: @125470
     /* 125470 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(125529), // Rule ID 3916 //
     /* 125475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125478 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 125500 */     // (ld:{ *:[v4i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 125500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 125503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 125510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 125515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125527 */     GIR_RootConstrainSelectedInstOperands,
     /* 125528 */     // GIR_Coverage, 3916,
     /* 125528 */     GIR_EraseRootFromParent_Done,
     /* 125529 */   // Label 1857: @125529
     /* 125529 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(125588), // Rule ID 3920 //
     /* 125534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125537 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 125559 */     // (ld:{ *:[v4f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 125559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
     /* 125562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 125569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 125574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125586 */     GIR_RootConstrainSelectedInstOperands,
     /* 125587 */     // GIR_Coverage, 3920,
     /* 125587 */     GIR_EraseRootFromParent_Done,
     /* 125588 */   // Label 1858: @125588
     /* 125588 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(125642), // Rule ID 3915 //
     /* 125593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125596 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 125618 */     // (ld:{ *:[v4i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 125621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125640 */     GIR_RootConstrainSelectedInstOperands,
     /* 125641 */     // GIR_Coverage, 3915,
     /* 125641 */     GIR_EraseRootFromParent_Done,
     /* 125642 */   // Label 1859: @125642
     /* 125642 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(125696), // Rule ID 3919 //
     /* 125647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 125650 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 125672 */     // (ld:{ *:[v4f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
     /* 125675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125694 */     GIR_RootConstrainSelectedInstOperands,
     /* 125695 */     // GIR_Coverage, 3919,
     /* 125695 */     GIR_EraseRootFromParent_Done,
     /* 125696 */   // Label 1860: @125696
     /* 125696 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(125751), // Rule ID 3645 //
     /* 125701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 125704 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 125727 */     // (ld:{ *:[v4i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 125730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125749 */     GIR_RootConstrainSelectedInstOperands,
     /* 125750 */     // GIR_Coverage, 3645,
     /* 125750 */     GIR_EraseRootFromParent_Done,
     /* 125751 */   // Label 1861: @125751
     /* 125751 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(125806), // Rule ID 3647 //
     /* 125756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 125759 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 125767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 125771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 125782 */     // (ld:{ *:[v4f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 125782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
     /* 125785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 125787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 125792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125804 */     GIR_RootConstrainSelectedInstOperands,
     /* 125805 */     // GIR_Coverage, 3647,
     /* 125805 */     GIR_EraseRootFromParent_Done,
     /* 125806 */   // Label 1862: @125806
     /* 125806 */   GIM_Reject,
     /* 125807 */ // Label 1796: @125807
     /* 125807 */ GIM_Reject,
     /* 125808 */ // Label 1013: @125808
     /* 125808 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(129855),
     /* 125813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125816 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(125880), // Rule ID 3179 //
     /* 125821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 125824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 125832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 125840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 125844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 125851 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 125851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 125854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 125856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 125861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125878 */     GIR_RootConstrainSelectedInstOperands,
     /* 125879 */     // GIR_Coverage, 3179,
     /* 125879 */     GIR_EraseRootFromParent_Done,
     /* 125880 */   // Label 1864: @125880
     /* 125880 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(125944), // Rule ID 3196 //
     /* 125885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 125888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 125896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 125904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 125908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 125915 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 125915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 125918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 125920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 125925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125942 */     GIR_RootConstrainSelectedInstOperands,
     /* 125943 */     // GIR_Coverage, 3196,
     /* 125943 */     GIR_EraseRootFromParent_Done,
     /* 125944 */   // Label 1865: @125944
     /* 125944 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(126004), // Rule ID 3184 //
     /* 125949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 125952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 125960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 125968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 125975 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 125975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 125978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 125980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 125985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 125990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 125995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126002 */     GIR_RootConstrainSelectedInstOperands,
     /* 126003 */     // GIR_Coverage, 3184,
     /* 126003 */     GIR_EraseRootFromParent_Done,
     /* 126004 */   // Label 1866: @126004
     /* 126004 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(126064), // Rule ID 3201 //
     /* 126009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126035 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 126038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126062 */     GIR_RootConstrainSelectedInstOperands,
     /* 126063 */     // GIR_Coverage, 3201,
     /* 126063 */     GIR_EraseRootFromParent_Done,
     /* 126064 */   // Label 1867: @126064
     /* 126064 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(126124), // Rule ID 3190 //
     /* 126069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 126072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126095 */     // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 126098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126122 */     GIR_RootConstrainSelectedInstOperands,
     /* 126123 */     // GIR_Coverage, 3190,
     /* 126123 */     GIR_EraseRootFromParent_Done,
     /* 126124 */   // Label 1868: @126124
     /* 126124 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(126184), // Rule ID 3207 //
     /* 126129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 126132 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 126155 */     // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 126158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 126175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126182 */     GIR_RootConstrainSelectedInstOperands,
     /* 126183 */     // GIR_Coverage, 3207,
     /* 126183 */     GIR_EraseRootFromParent_Done,
     /* 126184 */   // Label 1869: @126184
     /* 126184 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(126243), // Rule ID 3175 //
     /* 126189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126219 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 126222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126241 */     GIR_RootConstrainSelectedInstOperands,
     /* 126242 */     // GIR_Coverage, 3175,
     /* 126242 */     GIR_EraseRootFromParent_Done,
     /* 126243 */   // Label 1870: @126243
     /* 126243 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(126302), // Rule ID 3176 //
     /* 126248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 126251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 126278 */     // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 126281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126300 */     GIR_RootConstrainSelectedInstOperands,
     /* 126301 */     // GIR_Coverage, 3176,
     /* 126301 */     GIR_EraseRootFromParent_Done,
     /* 126302 */   // Label 1871: @126302
     /* 126302 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(126361), // Rule ID 3177 //
     /* 126307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126337 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 126340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126359 */     GIR_RootConstrainSelectedInstOperands,
     /* 126360 */     // GIR_Coverage, 3177,
     /* 126360 */     GIR_EraseRootFromParent_Done,
     /* 126361 */   // Label 1872: @126361
     /* 126361 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(126423), // Rule ID 3178 //
     /* 126366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126396 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 126399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126421 */     GIR_RootConstrainSelectedInstOperands,
     /* 126422 */     // GIR_Coverage, 3178,
     /* 126422 */     GIR_EraseRootFromParent_Done,
     /* 126423 */   // Label 1873: @126423
     /* 126423 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(126482), // Rule ID 3192 //
     /* 126428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126443 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126458 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 126461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126480 */     GIR_RootConstrainSelectedInstOperands,
     /* 126481 */     // GIR_Coverage, 3192,
     /* 126481 */     GIR_EraseRootFromParent_Done,
     /* 126482 */   // Label 1874: @126482
     /* 126482 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(126541), // Rule ID 3193 //
     /* 126487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 126490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 126517 */     // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 126520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126539 */     GIR_RootConstrainSelectedInstOperands,
     /* 126540 */     // GIR_Coverage, 3193,
     /* 126540 */     GIR_EraseRootFromParent_Done,
     /* 126541 */   // Label 1875: @126541
     /* 126541 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(126600), // Rule ID 3194 //
     /* 126546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126576 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 126579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126598 */     GIR_RootConstrainSelectedInstOperands,
     /* 126599 */     // GIR_Coverage, 3194,
     /* 126599 */     GIR_EraseRootFromParent_Done,
     /* 126600 */   // Label 1876: @126600
     /* 126600 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(126662), // Rule ID 3195 //
     /* 126605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126608 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 126628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126635 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 126638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126660 */     GIR_RootConstrainSelectedInstOperands,
     /* 126661 */     // GIR_Coverage, 3195,
     /* 126661 */     GIR_EraseRootFromParent_Done,
     /* 126662 */   // Label 1877: @126662
     /* 126662 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(126717), // Rule ID 3181 //
     /* 126667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126670 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126693 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 126696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126715 */     GIR_RootConstrainSelectedInstOperands,
     /* 126716 */     // GIR_Coverage, 3181,
     /* 126716 */     GIR_EraseRootFromParent_Done,
     /* 126717 */   // Label 1878: @126717
     /* 126717 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(126772), // Rule ID 3182 //
     /* 126722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126748 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 126751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126770 */     GIR_RootConstrainSelectedInstOperands,
     /* 126771 */     // GIR_Coverage, 3182,
     /* 126771 */     GIR_EraseRootFromParent_Done,
     /* 126772 */   // Label 1879: @126772
     /* 126772 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(126830), // Rule ID 3183 //
     /* 126777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126803 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 126806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126828 */     GIR_RootConstrainSelectedInstOperands,
     /* 126829 */     // GIR_Coverage, 3183,
     /* 126829 */     GIR_EraseRootFromParent_Done,
     /* 126830 */   // Label 1880: @126830
     /* 126830 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(126885), // Rule ID 3198 //
     /* 126835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 126838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 126861 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 126861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 126864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126883 */     GIR_RootConstrainSelectedInstOperands,
     /* 126884 */     // GIR_Coverage, 3198,
     /* 126884 */     GIR_EraseRootFromParent_Done,
     /* 126885 */   // Label 1881: @126885
     /* 126885 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(126940), // Rule ID 3199 //
     /* 126890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 126893 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126916 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 126916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 126919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126938 */     GIR_RootConstrainSelectedInstOperands,
     /* 126939 */     // GIR_Coverage, 3199,
     /* 126939 */     GIR_EraseRootFromParent_Done,
     /* 126940 */   // Label 1882: @126940
     /* 126940 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(126998), // Rule ID 3200 //
     /* 126945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 126948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 126956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 126964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 126971 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 126971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 126974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 126976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 126981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 126986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126996 */     GIR_RootConstrainSelectedInstOperands,
     /* 126997 */     // GIR_Coverage, 3200,
     /* 126997 */     GIR_EraseRootFromParent_Done,
     /* 126998 */   // Label 1883: @126998
     /* 126998 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(127058), // Rule ID 8168 //
     /* 127003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 127006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127010 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127015 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 127019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127034 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 127037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127056 */     GIR_RootConstrainSelectedInstOperands,
     /* 127057 */     // GIR_Coverage, 8168,
     /* 127057 */     GIR_EraseRootFromParent_Done,
     /* 127058 */   // Label 1884: @127058
     /* 127058 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(127118), // Rule ID 8172 //
     /* 127063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 127066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127075 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 127079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127094 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 127097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127116 */     GIR_RootConstrainSelectedInstOperands,
     /* 127117 */     // GIR_Coverage, 8172,
     /* 127117 */     GIR_EraseRootFromParent_Done,
     /* 127118 */   // Label 1885: @127118
     /* 127118 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(127183), // Rule ID 8236 //
     /* 127123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 127126 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127130 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127135 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127148 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 127152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127159 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 127162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127181 */     GIR_RootConstrainSelectedInstOperands,
     /* 127182 */     // GIR_Coverage, 8236,
     /* 127182 */     GIR_EraseRootFromParent_Done,
     /* 127183 */   // Label 1886: @127183
     /* 127183 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(127248), // Rule ID 8240 //
     /* 127188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 127191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127195 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127200 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 127217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127224 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 127227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127246 */     GIR_RootConstrainSelectedInstOperands,
     /* 127247 */     // GIR_Coverage, 8240,
     /* 127247 */     GIR_EraseRootFromParent_Done,
     /* 127248 */   // Label 1887: @127248
     /* 127248 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(127300), // Rule ID 3186 //
     /* 127253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127276 */     // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 127279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127298 */     GIR_RootConstrainSelectedInstOperands,
     /* 127299 */     // GIR_Coverage, 3186,
     /* 127299 */     GIR_EraseRootFromParent_Done,
     /* 127300 */   // Label 1888: @127300
     /* 127300 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(127355), // Rule ID 3187 //
     /* 127305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 127308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 127331 */     // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 127334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127353 */     GIR_RootConstrainSelectedInstOperands,
     /* 127354 */     // GIR_Coverage, 3187,
     /* 127354 */     GIR_EraseRootFromParent_Done,
     /* 127355 */   // Label 1889: @127355
     /* 127355 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(127410), // Rule ID 3188 //
     /* 127360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 127363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127386 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 127389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127408 */     GIR_RootConstrainSelectedInstOperands,
     /* 127409 */     // GIR_Coverage, 3188,
     /* 127409 */     GIR_EraseRootFromParent_Done,
     /* 127410 */   // Label 1890: @127410
     /* 127410 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(127468), // Rule ID 3189 //
     /* 127415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 127418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127441 */     // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 127444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127466 */     GIR_RootConstrainSelectedInstOperands,
     /* 127467 */     // GIR_Coverage, 3189,
     /* 127467 */     GIR_EraseRootFromParent_Done,
     /* 127468 */   // Label 1891: @127468
     /* 127468 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(127520), // Rule ID 3203 //
     /* 127473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 127496 */     // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 127499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127518 */     GIR_RootConstrainSelectedInstOperands,
     /* 127519 */     // GIR_Coverage, 3203,
     /* 127519 */     GIR_EraseRootFromParent_Done,
     /* 127520 */   // Label 1892: @127520
     /* 127520 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(127575), // Rule ID 3204 //
     /* 127525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 127528 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127540 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 127551 */     // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 127551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 127554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127573 */     GIR_RootConstrainSelectedInstOperands,
     /* 127574 */     // GIR_Coverage, 3204,
     /* 127574 */     GIR_EraseRootFromParent_Done,
     /* 127575 */   // Label 1893: @127575
     /* 127575 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(127630), // Rule ID 3205 //
     /* 127580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 127583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127606 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 127606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 127609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127628 */     GIR_RootConstrainSelectedInstOperands,
     /* 127629 */     // GIR_Coverage, 3205,
     /* 127629 */     GIR_EraseRootFromParent_Done,
     /* 127630 */   // Label 1894: @127630
     /* 127630 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(127688), // Rule ID 3206 //
     /* 127635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 127638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127646 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 127661 */     // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 127664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 127671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 127676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127686 */     GIR_RootConstrainSelectedInstOperands,
     /* 127687 */     // GIR_Coverage, 3206,
     /* 127687 */     GIR_EraseRootFromParent_Done,
     /* 127688 */   // Label 1895: @127688
     /* 127688 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(127744), // Rule ID 8169 //
     /* 127693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 127696 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127701 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 127705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127720 */     // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 127723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127742 */     GIR_RootConstrainSelectedInstOperands,
     /* 127743 */     // GIR_Coverage, 8169,
     /* 127743 */     GIR_EraseRootFromParent_Done,
     /* 127744 */   // Label 1896: @127744
     /* 127744 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(127800), // Rule ID 8173 //
     /* 127749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 127752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127757 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 127761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127776 */     // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 127779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127798 */     GIR_RootConstrainSelectedInstOperands,
     /* 127799 */     // GIR_Coverage, 8173,
     /* 127799 */     GIR_EraseRootFromParent_Done,
     /* 127800 */   // Label 1897: @127800
     /* 127800 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(127861), // Rule ID 8237 //
     /* 127805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 127808 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 127830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127837 */     // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 127840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127859 */     GIR_RootConstrainSelectedInstOperands,
     /* 127860 */     // GIR_Coverage, 8237,
     /* 127860 */     GIR_EraseRootFromParent_Done,
     /* 127861 */   // Label 1898: @127861
     /* 127861 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(127922), // Rule ID 8241 //
     /* 127866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 127869 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127874 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 127879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 127883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 127891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 127898 */     // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 127898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 127901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 127903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 127908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127920 */     GIR_RootConstrainSelectedInstOperands,
     /* 127921 */     // GIR_Coverage, 8241,
     /* 127921 */     GIR_EraseRootFromParent_Done,
     /* 127922 */   // Label 1899: @127922
     /* 127922 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(127973), // Rule ID 3180 //
     /* 127927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127930 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127938 */     // MIs[0] sbase
     /* 127938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 127950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 127954 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 127954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 127957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 127959 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 127961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127971 */     GIR_RootConstrainSelectedInstOperands,
     /* 127972 */     // GIR_Coverage, 3180,
     /* 127972 */     GIR_EraseRootFromParent_Done,
     /* 127973 */   // Label 1900: @127973
     /* 127973 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(128024), // Rule ID 3197 //
     /* 127978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 127981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 127989 */     // MIs[0] sbase
     /* 127989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 127997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 128005 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 128008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128010 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 128012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128022 */     GIR_RootConstrainSelectedInstOperands,
     /* 128023 */     // GIR_Coverage, 3197,
     /* 128023 */     GIR_EraseRootFromParent_Done,
     /* 128024 */   // Label 1901: @128024
     /* 128024 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(128071), // Rule ID 3185 //
     /* 128029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128032 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128040 */     // MIs[0] sbase
     /* 128040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 128048 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128052 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 128055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128057 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 128059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128069 */     GIR_RootConstrainSelectedInstOperands,
     /* 128070 */     // GIR_Coverage, 3185,
     /* 128070 */     GIR_EraseRootFromParent_Done,
     /* 128071 */   // Label 1902: @128071
     /* 128071 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(128118), // Rule ID 3202 //
     /* 128076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 128079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128087 */     // MIs[0] sbase
     /* 128087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 128095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128099 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 128102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128104 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 128106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128116 */     GIR_RootConstrainSelectedInstOperands,
     /* 128117 */     // GIR_Coverage, 3202,
     /* 128117 */     GIR_EraseRootFromParent_Done,
     /* 128118 */   // Label 1903: @128118
     /* 128118 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(128162), // Rule ID 3191 //
     /* 128123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128131 */     // MIs[0] sbase
     /* 128131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 128139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128143 */     // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 128146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128148 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 128150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128160 */     GIR_RootConstrainSelectedInstOperands,
     /* 128161 */     // GIR_Coverage, 3191,
     /* 128161 */     GIR_EraseRootFromParent_Done,
     /* 128162 */   // Label 1904: @128162
     /* 128162 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(128206), // Rule ID 3208 //
     /* 128167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 128171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 128175 */     // MIs[0] sbase
     /* 128175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 128183 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 128187 */     // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 128187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 128190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 128192 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 128194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128204 */     GIR_RootConstrainSelectedInstOperands,
     /* 128205 */     // GIR_Coverage, 3208,
     /* 128205 */     GIR_EraseRootFromParent_Done,
     /* 128206 */   // Label 1905: @128206
     /* 128206 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(128266), // Rule ID 6531 //
     /* 128211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 128214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 128234 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 128234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 128237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 128239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 128244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128264 */     GIR_RootConstrainSelectedInstOperands,
     /* 128265 */     // GIR_Coverage, 6531,
     /* 128265 */     GIR_EraseRootFromParent_Done,
     /* 128266 */   // Label 1906: @128266
     /* 128266 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(128326), // Rule ID 6533 //
     /* 128271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 128274 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 128294 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 128294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 128297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 128299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 128304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 128309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128324 */     GIR_RootConstrainSelectedInstOperands,
     /* 128325 */     // GIR_Coverage, 6533,
     /* 128325 */     GIR_EraseRootFromParent_Done,
     /* 128326 */   // Label 1907: @128326
     /* 128326 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(128383), // Rule ID 4358 //
     /* 128331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 128334 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 128354 */     // (ld:{ *:[v4i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 128357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 128359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 128364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 128369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128381 */     GIR_RootConstrainSelectedInstOperands,
     /* 128382 */     // GIR_Coverage, 4358,
     /* 128382 */     GIR_EraseRootFromParent_Done,
     /* 128383 */   // Label 1908: @128383
     /* 128383 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(128440), // Rule ID 4364 //
     /* 128388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 128391 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 128411 */     // (ld:{ *:[v4f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 128411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 128414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 128416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 128421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 128426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128438 */     GIR_RootConstrainSelectedInstOperands,
     /* 128439 */     // GIR_Coverage, 4364,
     /* 128439 */     GIR_EraseRootFromParent_Done,
     /* 128440 */   // Label 1909: @128440
     /* 128440 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(128492), // Rule ID 4357 //
     /* 128445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 128448 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 128468 */     // (ld:{ *:[v4i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 128468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 128471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 128473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 128478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128490 */     GIR_RootConstrainSelectedInstOperands,
     /* 128491 */     // GIR_Coverage, 4357,
     /* 128491 */     GIR_EraseRootFromParent_Done,
     /* 128492 */   // Label 1910: @128492
     /* 128492 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(128544), // Rule ID 4363 //
     /* 128497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 128500 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 128520 */     // (ld:{ *:[v4f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 128520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 128523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 128525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 128530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128542 */     GIR_RootConstrainSelectedInstOperands,
     /* 128543 */     // GIR_Coverage, 4363,
     /* 128543 */     GIR_EraseRootFromParent_Done,
     /* 128544 */   // Label 1911: @128544
     /* 128544 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(128596), // Rule ID 4356 //
     /* 128549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 128552 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 128572 */     // (ld:{ *:[v4i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 128572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 128575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 128577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 128582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128594 */     GIR_RootConstrainSelectedInstOperands,
     /* 128595 */     // GIR_Coverage, 4356,
     /* 128595 */     GIR_EraseRootFromParent_Done,
     /* 128596 */   // Label 1912: @128596
     /* 128596 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(128648), // Rule ID 4362 //
     /* 128601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 128604 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 128624 */     // (ld:{ *:[v4f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 128624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 128627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 128629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 128634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128646 */     GIR_RootConstrainSelectedInstOperands,
     /* 128647 */     // GIR_Coverage, 4362,
     /* 128647 */     GIR_EraseRootFromParent_Done,
     /* 128648 */   // Label 1913: @128648
     /* 128648 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(128715), // Rule ID 4583 //
     /* 128653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 128656 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 128663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 128678 */     // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 128678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 128681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 128683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 128688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 128693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 128698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 128703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128713 */     GIR_RootConstrainSelectedInstOperands,
     /* 128714 */     // GIR_Coverage, 4583,
     /* 128714 */     GIR_EraseRootFromParent_Done,
     /* 128715 */   // Label 1914: @128715
     /* 128715 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(128779), // Rule ID 4585 //
     /* 128720 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 128727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 128742 */     // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 128742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 128745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 128747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 128752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 128757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 128762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 128767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128777 */     GIR_RootConstrainSelectedInstOperands,
     /* 128778 */     // GIR_Coverage, 4585,
     /* 128778 */     GIR_EraseRootFromParent_Done,
     /* 128779 */   // Label 1915: @128779
     /* 128779 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(128846), // Rule ID 4587 //
     /* 128784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 128787 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 128794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 128809 */     // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 128809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 128812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 128814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 128819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 128824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 128829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 128834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128844 */     GIR_RootConstrainSelectedInstOperands,
     /* 128845 */     // GIR_Coverage, 4587,
     /* 128845 */     GIR_EraseRootFromParent_Done,
     /* 128846 */   // Label 1916: @128846
     /* 128846 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(128910), // Rule ID 4589 //
     /* 128851 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 128858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 128873 */     // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 128873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 128876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 128878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 128883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 128888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 128893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 128898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128908 */     GIR_RootConstrainSelectedInstOperands,
     /* 128909 */     // GIR_Coverage, 4589,
     /* 128909 */     GIR_EraseRootFromParent_Done,
     /* 128910 */   // Label 1917: @128910
     /* 128910 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(128975), // Rule ID 6530 //
     /* 128915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 128918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 128938 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 128938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 128941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 128943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 128948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 128953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 128958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 128963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128973 */     GIR_RootConstrainSelectedInstOperands,
     /* 128974 */     // GIR_Coverage, 6530,
     /* 128974 */     GIR_EraseRootFromParent_Done,
     /* 128975 */   // Label 1918: @128975
     /* 128975 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(129040), // Rule ID 6532 //
     /* 128980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 128983 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 128988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 128992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 129003 */     // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 129003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 129006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 129008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 129013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 129018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 129023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 129028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129038 */     GIR_RootConstrainSelectedInstOperands,
     /* 129039 */     // GIR_Coverage, 6532,
     /* 129039 */     GIR_EraseRootFromParent_Done,
     /* 129040 */   // Label 1919: @129040
     /* 129040 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(129101), // Rule ID 8068 //
     /* 129045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 129048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129052 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 129072 */     // (AMDGPUld_glue:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 129072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 129075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 129087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 129092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129099 */     GIR_RootConstrainSelectedInstOperands,
     /* 129100 */     // GIR_Coverage, 8068,
     /* 129100 */     GIR_EraseRootFromParent_Done,
     /* 129101 */   // Label 1920: @129101
     /* 129101 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(129162), // Rule ID 8104 //
     /* 129106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 129109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129113 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 129133 */     // (AMDGPUld_glue:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 129133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 129136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 129148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 129153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129160 */     GIR_RootConstrainSelectedInstOperands,
     /* 129161 */     // GIR_Coverage, 8104,
     /* 129161 */     GIR_EraseRootFromParent_Done,
     /* 129162 */   // Label 1921: @129162
     /* 129162 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(129224), // Rule ID 4582 //
     /* 129167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 129170 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 129192 */     // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 129192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 129195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 129197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 129202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129222 */     GIR_RootConstrainSelectedInstOperands,
     /* 129223 */     // GIR_Coverage, 4582,
     /* 129223 */     GIR_EraseRootFromParent_Done,
     /* 129224 */   // Label 1922: @129224
     /* 129224 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(129283), // Rule ID 4584 //
     /* 129229 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 129251 */     // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 129251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 129254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 129256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 129261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129281 */     GIR_RootConstrainSelectedInstOperands,
     /* 129282 */     // GIR_Coverage, 4584,
     /* 129282 */     GIR_EraseRootFromParent_Done,
     /* 129283 */   // Label 1923: @129283
     /* 129283 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(129345), // Rule ID 4586 //
     /* 129288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 129291 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 129313 */     // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 129313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 129316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 129318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 129323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129343 */     GIR_RootConstrainSelectedInstOperands,
     /* 129344 */     // GIR_Coverage, 4586,
     /* 129344 */     GIR_EraseRootFromParent_Done,
     /* 129345 */   // Label 1924: @129345
     /* 129345 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(129404), // Rule ID 4588 //
     /* 129350 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 129372 */     // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 129372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 129375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 129377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 129382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129402 */     GIR_RootConstrainSelectedInstOperands,
     /* 129403 */     // GIR_Coverage, 4588,
     /* 129403 */     GIR_EraseRootFromParent_Done,
     /* 129404 */   // Label 1925: @129404
     /* 129404 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(129461), // Rule ID 8070 //
     /* 129409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 129412 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 129432 */     // (ld:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 129432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 129435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 129447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 129452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129459 */     GIR_RootConstrainSelectedInstOperands,
     /* 129460 */     // GIR_Coverage, 8070,
     /* 129460 */     GIR_EraseRootFromParent_Done,
     /* 129461 */   // Label 1926: @129461
     /* 129461 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(129518), // Rule ID 8106 //
     /* 129466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 129469 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 129474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 129489 */     // (ld:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 129489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 129492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 129499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 129504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 129509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129516 */     GIR_RootConstrainSelectedInstOperands,
     /* 129517 */     // GIR_Coverage, 8106,
     /* 129517 */     GIR_EraseRootFromParent_Done,
     /* 129518 */   // Label 1927: @129518
     /* 129518 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(129577), // Rule ID 3938 //
     /* 129523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 129526 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 129548 */     // (ld:{ *:[v4i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 129551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 129558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 129563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129575 */     GIR_RootConstrainSelectedInstOperands,
     /* 129576 */     // GIR_Coverage, 3938,
     /* 129576 */     GIR_EraseRootFromParent_Done,
     /* 129577 */   // Label 1928: @129577
     /* 129577 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(129636), // Rule ID 3942 //
     /* 129582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 129585 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 129607 */     // (ld:{ *:[v4f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 129610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 129617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 129622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129634 */     GIR_RootConstrainSelectedInstOperands,
     /* 129635 */     // GIR_Coverage, 3942,
     /* 129635 */     GIR_EraseRootFromParent_Done,
     /* 129636 */   // Label 1929: @129636
     /* 129636 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(129690), // Rule ID 3937 //
     /* 129641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 129644 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 129666 */     // (ld:{ *:[v4i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 129666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 129669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 129676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129688 */     GIR_RootConstrainSelectedInstOperands,
     /* 129689 */     // GIR_Coverage, 3937,
     /* 129689 */     GIR_EraseRootFromParent_Done,
     /* 129690 */   // Label 1930: @129690
     /* 129690 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(129744), // Rule ID 3941 //
     /* 129695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 129698 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 129720 */     // (ld:{ *:[v4f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 129720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 129723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 129730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129742 */     GIR_RootConstrainSelectedInstOperands,
     /* 129743 */     // GIR_Coverage, 3941,
     /* 129743 */     GIR_EraseRootFromParent_Done,
     /* 129744 */   // Label 1931: @129744
     /* 129744 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(129799), // Rule ID 3655 //
     /* 129749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 129752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 129775 */     // (ld:{ *:[v4i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 129775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 129778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 129785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129797 */     GIR_RootConstrainSelectedInstOperands,
     /* 129798 */     // GIR_Coverage, 3655,
     /* 129798 */     GIR_EraseRootFromParent_Done,
     /* 129799 */   // Label 1932: @129799
     /* 129799 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(129854), // Rule ID 3657 //
     /* 129804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 129807 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 129815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 129819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 129830 */     // (ld:{ *:[v4f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 129830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 129833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 129835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 129840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129852 */     GIR_RootConstrainSelectedInstOperands,
     /* 129853 */     // GIR_Coverage, 3657,
     /* 129853 */     GIR_EraseRootFromParent_Done,
     /* 129854 */   // Label 1933: @129854
     /* 129854 */   GIM_Reject,
     /* 129855 */ // Label 1863: @129855
     /* 129855 */ GIM_Reject,
     /* 129856 */ // Label 1014: @129856
     /* 129856 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(131507),
     /* 129861 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129864 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129868 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 129872 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(129928), // Rule ID 3315 //
     /* 129877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 129880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 129884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 129892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 129899 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 129902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129926 */     GIR_RootConstrainSelectedInstOperands,
     /* 129927 */     // GIR_Coverage, 3315,
     /* 129927 */     GIR_EraseRootFromParent_Done,
     /* 129928 */   // Label 1935: @129928
     /* 129928 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(129984), // Rule ID 3332 //
     /* 129933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 129936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 129940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 129948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 129955 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 129955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 129958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 129960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 129965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 129970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 129975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129982 */     GIR_RootConstrainSelectedInstOperands,
     /* 129983 */     // GIR_Coverage, 3332,
     /* 129983 */     GIR_EraseRootFromParent_Done,
     /* 129984 */   // Label 1936: @129984
     /* 129984 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(130036), // Rule ID 3320 //
     /* 129989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 129992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 129996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 130007 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 130010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130034 */     GIR_RootConstrainSelectedInstOperands,
     /* 130035 */     // GIR_Coverage, 3320,
     /* 130035 */     GIR_EraseRootFromParent_Done,
     /* 130036 */   // Label 1937: @130036
     /* 130036 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(130088), // Rule ID 3337 //
     /* 130041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 130044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 130059 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 130062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130086 */     GIR_RootConstrainSelectedInstOperands,
     /* 130087 */     // GIR_Coverage, 3337,
     /* 130087 */     GIR_EraseRootFromParent_Done,
     /* 130088 */   // Label 1938: @130088
     /* 130088 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(130140), // Rule ID 3326 //
     /* 130093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 130096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 130111 */     // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 130114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130138 */     GIR_RootConstrainSelectedInstOperands,
     /* 130139 */     // GIR_Coverage, 3326,
     /* 130139 */     GIR_EraseRootFromParent_Done,
     /* 130140 */   // Label 1939: @130140
     /* 130140 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(130192), // Rule ID 3343 //
     /* 130145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 130148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 130163 */     // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 130166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 130183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130190 */     GIR_RootConstrainSelectedInstOperands,
     /* 130191 */     // GIR_Coverage, 3343,
     /* 130191 */     GIR_EraseRootFromParent_Done,
     /* 130192 */   // Label 1940: @130192
     /* 130192 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(130243), // Rule ID 3311 //
     /* 130197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130208 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 130219 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 130222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130241 */     GIR_RootConstrainSelectedInstOperands,
     /* 130242 */     // GIR_Coverage, 3311,
     /* 130242 */     GIR_EraseRootFromParent_Done,
     /* 130243 */   // Label 1941: @130243
     /* 130243 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(130294), // Rule ID 3312 //
     /* 130248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 130251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 130270 */     // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 130273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130292 */     GIR_RootConstrainSelectedInstOperands,
     /* 130293 */     // GIR_Coverage, 3312,
     /* 130293 */     GIR_EraseRootFromParent_Done,
     /* 130294 */   // Label 1942: @130294
     /* 130294 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(130345), // Rule ID 3313 //
     /* 130299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 130302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130321 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 130321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 130324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130343 */     GIR_RootConstrainSelectedInstOperands,
     /* 130344 */     // GIR_Coverage, 3313,
     /* 130344 */     GIR_EraseRootFromParent_Done,
     /* 130345 */   // Label 1943: @130345
     /* 130345 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(130399), // Rule ID 3314 //
     /* 130350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 130353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130372 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 130375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130397 */     GIR_RootConstrainSelectedInstOperands,
     /* 130398 */     // GIR_Coverage, 3314,
     /* 130398 */     GIR_EraseRootFromParent_Done,
     /* 130399 */   // Label 1944: @130399
     /* 130399 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(130450), // Rule ID 3328 //
     /* 130404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 130426 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 130429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130448 */     GIR_RootConstrainSelectedInstOperands,
     /* 130449 */     // GIR_Coverage, 3328,
     /* 130449 */     GIR_EraseRootFromParent_Done,
     /* 130450 */   // Label 1945: @130450
     /* 130450 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(130501), // Rule ID 3329 //
     /* 130455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 130458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 130477 */     // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 130480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130499 */     GIR_RootConstrainSelectedInstOperands,
     /* 130500 */     // GIR_Coverage, 3329,
     /* 130500 */     GIR_EraseRootFromParent_Done,
     /* 130501 */   // Label 1946: @130501
     /* 130501 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(130552), // Rule ID 3330 //
     /* 130506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 130509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130528 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 130528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 130531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130550 */     GIR_RootConstrainSelectedInstOperands,
     /* 130551 */     // GIR_Coverage, 3330,
     /* 130551 */     GIR_EraseRootFromParent_Done,
     /* 130552 */   // Label 1947: @130552
     /* 130552 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(130606), // Rule ID 3331 //
     /* 130557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 130560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 130572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130579 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 130582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130604 */     GIR_RootConstrainSelectedInstOperands,
     /* 130605 */     // GIR_Coverage, 3331,
     /* 130605 */     GIR_EraseRootFromParent_Done,
     /* 130606 */   // Label 1948: @130606
     /* 130606 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(130653), // Rule ID 3317 //
     /* 130611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 130629 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 130632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130651 */     GIR_RootConstrainSelectedInstOperands,
     /* 130652 */     // GIR_Coverage, 3317,
     /* 130652 */     GIR_EraseRootFromParent_Done,
     /* 130653 */   // Label 1949: @130653
     /* 130653 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(130700), // Rule ID 3318 //
     /* 130658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 130661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130676 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 130676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 130679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130698 */     GIR_RootConstrainSelectedInstOperands,
     /* 130699 */     // GIR_Coverage, 3318,
     /* 130699 */     GIR_EraseRootFromParent_Done,
     /* 130700 */   // Label 1950: @130700
     /* 130700 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(130750), // Rule ID 3319 //
     /* 130705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 130708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130723 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 130726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130748 */     GIR_RootConstrainSelectedInstOperands,
     /* 130749 */     // GIR_Coverage, 3319,
     /* 130749 */     GIR_EraseRootFromParent_Done,
     /* 130750 */   // Label 1951: @130750
     /* 130750 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(130797), // Rule ID 3334 //
     /* 130755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 130758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 130773 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 130776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130795 */     GIR_RootConstrainSelectedInstOperands,
     /* 130796 */     // GIR_Coverage, 3334,
     /* 130796 */     GIR_EraseRootFromParent_Done,
     /* 130797 */   // Label 1952: @130797
     /* 130797 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(130844), // Rule ID 3335 //
     /* 130802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 130805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130820 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 130820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 130823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130842 */     GIR_RootConstrainSelectedInstOperands,
     /* 130843 */     // GIR_Coverage, 3335,
     /* 130843 */     GIR_EraseRootFromParent_Done,
     /* 130844 */   // Label 1953: @130844
     /* 130844 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(130894), // Rule ID 3336 //
     /* 130849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 130852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 130867 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 130867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 130870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 130882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130892 */     GIR_RootConstrainSelectedInstOperands,
     /* 130893 */     // GIR_Coverage, 3336,
     /* 130893 */     GIR_EraseRootFromParent_Done,
     /* 130894 */   // Label 1954: @130894
     /* 130894 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(130938), // Rule ID 3322 //
     /* 130899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 130914 */     // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 130917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130936 */     GIR_RootConstrainSelectedInstOperands,
     /* 130937 */     // GIR_Coverage, 3322,
     /* 130937 */     GIR_EraseRootFromParent_Done,
     /* 130938 */   // Label 1955: @130938
     /* 130938 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(130985), // Rule ID 3323 //
     /* 130943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 130946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 130961 */     // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 130961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 130964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 130966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 130971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130983 */     GIR_RootConstrainSelectedInstOperands,
     /* 130984 */     // GIR_Coverage, 3323,
     /* 130984 */     GIR_EraseRootFromParent_Done,
     /* 130985 */   // Label 1956: @130985
     /* 130985 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(131032), // Rule ID 3324 //
     /* 130990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 130993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 130997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 131008 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 131008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 131011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131030 */     GIR_RootConstrainSelectedInstOperands,
     /* 131031 */     // GIR_Coverage, 3324,
     /* 131031 */     GIR_EraseRootFromParent_Done,
     /* 131032 */   // Label 1957: @131032
     /* 131032 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(131082), // Rule ID 3325 //
     /* 131037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 131040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 131055 */     // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131080 */     GIR_RootConstrainSelectedInstOperands,
     /* 131081 */     // GIR_Coverage, 3325,
     /* 131081 */     GIR_EraseRootFromParent_Done,
     /* 131082 */   // Label 1958: @131082
     /* 131082 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(131126), // Rule ID 3339 //
     /* 131087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 131102 */     // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 131105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131124 */     GIR_RootConstrainSelectedInstOperands,
     /* 131125 */     // GIR_Coverage, 3339,
     /* 131125 */     GIR_EraseRootFromParent_Done,
     /* 131126 */   // Label 1959: @131126
     /* 131126 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(131173), // Rule ID 3340 //
     /* 131131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 131134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 131149 */     // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 131152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131171 */     GIR_RootConstrainSelectedInstOperands,
     /* 131172 */     // GIR_Coverage, 3340,
     /* 131172 */     GIR_EraseRootFromParent_Done,
     /* 131173 */   // Label 1960: @131173
     /* 131173 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(131220), // Rule ID 3341 //
     /* 131178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 131181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 131196 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 131196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 131199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131218 */     GIR_RootConstrainSelectedInstOperands,
     /* 131219 */     // GIR_Coverage, 3341,
     /* 131219 */     GIR_EraseRootFromParent_Done,
     /* 131220 */   // Label 1961: @131220
     /* 131220 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(131270), // Rule ID 3342 //
     /* 131225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 131228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 131243 */     // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 131246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131268 */     GIR_RootConstrainSelectedInstOperands,
     /* 131269 */     // GIR_Coverage, 3342,
     /* 131269 */     GIR_EraseRootFromParent_Done,
     /* 131270 */   // Label 1962: @131270
     /* 131270 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(131313), // Rule ID 3316 //
     /* 131275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 131278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131282 */     // MIs[0] sbase
     /* 131282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 131290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131294 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 131297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131299 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 131301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131311 */     GIR_RootConstrainSelectedInstOperands,
     /* 131312 */     // GIR_Coverage, 3316,
     /* 131312 */     GIR_EraseRootFromParent_Done,
     /* 131313 */   // Label 1963: @131313
     /* 131313 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(131356), // Rule ID 3333 //
     /* 131318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 131321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131325 */     // MIs[0] sbase
     /* 131325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 131333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131337 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 131340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131342 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 131344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131354 */     GIR_RootConstrainSelectedInstOperands,
     /* 131355 */     // GIR_Coverage, 3333,
     /* 131355 */     GIR_EraseRootFromParent_Done,
     /* 131356 */   // Label 1964: @131356
     /* 131356 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(131395), // Rule ID 3321 //
     /* 131361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 131364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131368 */     // MIs[0] sbase
     /* 131368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 131376 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 131379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131381 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 131383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131393 */     GIR_RootConstrainSelectedInstOperands,
     /* 131394 */     // GIR_Coverage, 3321,
     /* 131394 */     GIR_EraseRootFromParent_Done,
     /* 131395 */   // Label 1965: @131395
     /* 131395 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(131434), // Rule ID 3338 //
     /* 131400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 131403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131407 */     // MIs[0] sbase
     /* 131407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 131415 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 131418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131420 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 131422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131432 */     GIR_RootConstrainSelectedInstOperands,
     /* 131433 */     // GIR_Coverage, 3338,
     /* 131433 */     GIR_EraseRootFromParent_Done,
     /* 131434 */   // Label 1966: @131434
     /* 131434 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(131470), // Rule ID 3327 //
     /* 131439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131443 */     // MIs[0] sbase
     /* 131443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 131451 */     // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 131454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131456 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 131458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131468 */     GIR_RootConstrainSelectedInstOperands,
     /* 131469 */     // GIR_Coverage, 3327,
     /* 131469 */     GIR_EraseRootFromParent_Done,
     /* 131470 */   // Label 1967: @131470
     /* 131470 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(131506), // Rule ID 3344 //
     /* 131475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 131479 */     // MIs[0] sbase
     /* 131479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 131487 */     // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 131487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 131490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131492 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 131494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131504 */     GIR_RootConstrainSelectedInstOperands,
     /* 131505 */     // GIR_Coverage, 3344,
     /* 131505 */     GIR_EraseRootFromParent_Done,
     /* 131506 */   // Label 1968: @131506
     /* 131506 */   GIM_Reject,
     /* 131507 */ // Label 1934: @131507
     /* 131507 */ GIM_Reject,
     /* 131508 */ // Label 1015: @131508
     /* 131508 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(135305),
     /* 131513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131516 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(131580), // Rule ID 3247 //
     /* 131521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131540 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131551 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 131554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131578 */     GIR_RootConstrainSelectedInstOperands,
     /* 131579 */     // GIR_Coverage, 3247,
     /* 131579 */     GIR_EraseRootFromParent_Done,
     /* 131580 */   // Label 1970: @131580
     /* 131580 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(131644), // Rule ID 3264 //
     /* 131585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131604 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131615 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 131618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131642 */     GIR_RootConstrainSelectedInstOperands,
     /* 131643 */     // GIR_Coverage, 3264,
     /* 131643 */     GIR_EraseRootFromParent_Done,
     /* 131644 */   // Label 1971: @131644
     /* 131644 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(131704), // Rule ID 3252 //
     /* 131649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131675 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 131678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131702 */     GIR_RootConstrainSelectedInstOperands,
     /* 131703 */     // GIR_Coverage, 3252,
     /* 131703 */     GIR_EraseRootFromParent_Done,
     /* 131704 */   // Label 1972: @131704
     /* 131704 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(131764), // Rule ID 3269 //
     /* 131709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 131712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131735 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 131738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131762 */     GIR_RootConstrainSelectedInstOperands,
     /* 131763 */     // GIR_Coverage, 3269,
     /* 131763 */     GIR_EraseRootFromParent_Done,
     /* 131764 */   // Label 1973: @131764
     /* 131764 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(131824), // Rule ID 3258 //
     /* 131769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 131772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131795 */     // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 131798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131822 */     GIR_RootConstrainSelectedInstOperands,
     /* 131823 */     // GIR_Coverage, 3258,
     /* 131823 */     GIR_EraseRootFromParent_Done,
     /* 131824 */   // Label 1974: @131824
     /* 131824 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(131884), // Rule ID 3275 //
     /* 131829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 131832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 131855 */     // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 131858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 131870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 131875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131882 */     GIR_RootConstrainSelectedInstOperands,
     /* 131883 */     // GIR_Coverage, 3275,
     /* 131883 */     GIR_EraseRootFromParent_Done,
     /* 131884 */   // Label 1975: @131884
     /* 131884 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(131943), // Rule ID 3243 //
     /* 131889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 131892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 131919 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 131922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131941 */     GIR_RootConstrainSelectedInstOperands,
     /* 131942 */     // GIR_Coverage, 3243,
     /* 131942 */     GIR_EraseRootFromParent_Done,
     /* 131943 */   // Label 1976: @131943
     /* 131943 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(132002), // Rule ID 3244 //
     /* 131948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 131951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 131959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 131967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 131971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 131978 */     // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 131978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 131981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 131983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 131988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132000 */     GIR_RootConstrainSelectedInstOperands,
     /* 132001 */     // GIR_Coverage, 3244,
     /* 132001 */     GIR_EraseRootFromParent_Done,
     /* 132002 */   // Label 1977: @132002
     /* 132002 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(132061), // Rule ID 3245 //
     /* 132007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132037 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 132040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132059 */     GIR_RootConstrainSelectedInstOperands,
     /* 132060 */     // GIR_Coverage, 3245,
     /* 132060 */     GIR_EraseRootFromParent_Done,
     /* 132061 */   // Label 1978: @132061
     /* 132061 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(132123), // Rule ID 3246 //
     /* 132066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132096 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 132099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132121 */     GIR_RootConstrainSelectedInstOperands,
     /* 132122 */     // GIR_Coverage, 3246,
     /* 132122 */     GIR_EraseRootFromParent_Done,
     /* 132123 */   // Label 1979: @132123
     /* 132123 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(132182), // Rule ID 3260 //
     /* 132128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132131 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132158 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 132161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132180 */     GIR_RootConstrainSelectedInstOperands,
     /* 132181 */     // GIR_Coverage, 3260,
     /* 132181 */     GIR_EraseRootFromParent_Done,
     /* 132182 */   // Label 1980: @132182
     /* 132182 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(132241), // Rule ID 3261 //
     /* 132187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 132190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 132217 */     // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 132220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132239 */     GIR_RootConstrainSelectedInstOperands,
     /* 132240 */     // GIR_Coverage, 3261,
     /* 132240 */     GIR_EraseRootFromParent_Done,
     /* 132241 */   // Label 1981: @132241
     /* 132241 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(132300), // Rule ID 3262 //
     /* 132246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132276 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 132279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132298 */     GIR_RootConstrainSelectedInstOperands,
     /* 132299 */     // GIR_Coverage, 3262,
     /* 132299 */     GIR_EraseRootFromParent_Done,
     /* 132300 */   // Label 1982: @132300
     /* 132300 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(132362), // Rule ID 3263 //
     /* 132305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 132328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132335 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 132338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132360 */     GIR_RootConstrainSelectedInstOperands,
     /* 132361 */     // GIR_Coverage, 3263,
     /* 132361 */     GIR_EraseRootFromParent_Done,
     /* 132362 */   // Label 1983: @132362
     /* 132362 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(132417), // Rule ID 3249 //
     /* 132367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132370 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132393 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 132396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132415 */     GIR_RootConstrainSelectedInstOperands,
     /* 132416 */     // GIR_Coverage, 3249,
     /* 132416 */     GIR_EraseRootFromParent_Done,
     /* 132417 */   // Label 1984: @132417
     /* 132417 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(132472), // Rule ID 3250 //
     /* 132422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132448 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 132451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132470 */     GIR_RootConstrainSelectedInstOperands,
     /* 132471 */     // GIR_Coverage, 3250,
     /* 132471 */     GIR_EraseRootFromParent_Done,
     /* 132472 */   // Label 1985: @132472
     /* 132472 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(132530), // Rule ID 3251 //
     /* 132477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132503 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 132506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132528 */     GIR_RootConstrainSelectedInstOperands,
     /* 132529 */     // GIR_Coverage, 3251,
     /* 132529 */     GIR_EraseRootFromParent_Done,
     /* 132530 */   // Label 1986: @132530
     /* 132530 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(132585), // Rule ID 3266 //
     /* 132535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 132538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132561 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 132564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132583 */     GIR_RootConstrainSelectedInstOperands,
     /* 132584 */     // GIR_Coverage, 3266,
     /* 132584 */     GIR_EraseRootFromParent_Done,
     /* 132585 */   // Label 1987: @132585
     /* 132585 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(132640), // Rule ID 3267 //
     /* 132590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 132593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132616 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 132616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
     /* 132619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132638 */     GIR_RootConstrainSelectedInstOperands,
     /* 132639 */     // GIR_Coverage, 3267,
     /* 132639 */     GIR_EraseRootFromParent_Done,
     /* 132640 */   // Label 1988: @132640
     /* 132640 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(132698), // Rule ID 3268 //
     /* 132645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 132648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 132671 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 132671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
     /* 132674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 132686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132696 */     GIR_RootConstrainSelectedInstOperands,
     /* 132697 */     // GIR_Coverage, 3268,
     /* 132697 */     GIR_EraseRootFromParent_Done,
     /* 132698 */   // Label 1989: @132698
     /* 132698 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(132758), // Rule ID 8184 //
     /* 132703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 132706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132710 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 132715 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 132719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 132723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 132734 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 132734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 132737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 132739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 132744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132756 */     GIR_RootConstrainSelectedInstOperands,
     /* 132757 */     // GIR_Coverage, 8184,
     /* 132757 */     GIR_EraseRootFromParent_Done,
     /* 132758 */   // Label 1990: @132758
     /* 132758 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(132818), // Rule ID 8188 //
     /* 132763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 132766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132770 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 132775 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 132779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 132783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 132794 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 132794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 132797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 132799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 132804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132816 */     GIR_RootConstrainSelectedInstOperands,
     /* 132817 */     // GIR_Coverage, 8188,
     /* 132817 */     GIR_EraseRootFromParent_Done,
     /* 132818 */   // Label 1991: @132818
     /* 132818 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(132883), // Rule ID 8252 //
     /* 132823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 132826 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132830 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 132835 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 132840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 132844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 132852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 132859 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 132859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 132862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 132864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 132869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132881 */     GIR_RootConstrainSelectedInstOperands,
     /* 132882 */     // GIR_Coverage, 8252,
     /* 132882 */     GIR_EraseRootFromParent_Done,
     /* 132883 */   // Label 1992: @132883
     /* 132883 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(132948), // Rule ID 8256 //
     /* 132888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 132891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 132900 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 132905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 132909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
     /* 132917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 132924 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 132924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
     /* 132927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 132929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 132934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132946 */     GIR_RootConstrainSelectedInstOperands,
     /* 132947 */     // GIR_Coverage, 8256,
     /* 132947 */     GIR_EraseRootFromParent_Done,
     /* 132948 */   // Label 1993: @132948
     /* 132948 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(133000), // Rule ID 3254 //
     /* 132953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 132961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 132969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 132976 */     // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 132976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 132979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 132981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 132986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 132994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132998 */     GIR_RootConstrainSelectedInstOperands,
     /* 132999 */     // GIR_Coverage, 3254,
     /* 132999 */     GIR_EraseRootFromParent_Done,
     /* 133000 */   // Label 1994: @133000
     /* 133000 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(133055), // Rule ID 3255 //
     /* 133005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 133008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 133031 */     // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 133034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133053 */     GIR_RootConstrainSelectedInstOperands,
     /* 133054 */     // GIR_Coverage, 3255,
     /* 133054 */     GIR_EraseRootFromParent_Done,
     /* 133055 */   // Label 1995: @133055
     /* 133055 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(133110), // Rule ID 3256 //
     /* 133060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 133063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133086 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 133086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 133089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133108 */     GIR_RootConstrainSelectedInstOperands,
     /* 133109 */     // GIR_Coverage, 3256,
     /* 133109 */     GIR_EraseRootFromParent_Done,
     /* 133110 */   // Label 1996: @133110
     /* 133110 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(133168), // Rule ID 3257 //
     /* 133115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 133118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133141 */     // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 133144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133166 */     GIR_RootConstrainSelectedInstOperands,
     /* 133167 */     // GIR_Coverage, 3257,
     /* 133167 */     GIR_EraseRootFromParent_Done,
     /* 133168 */   // Label 1997: @133168
     /* 133168 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(133220), // Rule ID 3271 //
     /* 133173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 133196 */     // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 133199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133218 */     GIR_RootConstrainSelectedInstOperands,
     /* 133219 */     // GIR_Coverage, 3271,
     /* 133219 */     GIR_EraseRootFromParent_Done,
     /* 133220 */   // Label 1998: @133220
     /* 133220 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(133275), // Rule ID 3272 //
     /* 133225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 133228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 133251 */     // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
     /* 133254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133273 */     GIR_RootConstrainSelectedInstOperands,
     /* 133274 */     // GIR_Coverage, 3272,
     /* 133274 */     GIR_EraseRootFromParent_Done,
     /* 133275 */   // Label 1999: @133275
     /* 133275 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(133330), // Rule ID 3273 //
     /* 133280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 133283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133306 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 133306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
     /* 133309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133328 */     GIR_RootConstrainSelectedInstOperands,
     /* 133329 */     // GIR_Coverage, 3273,
     /* 133329 */     GIR_EraseRootFromParent_Done,
     /* 133330 */   // Label 2000: @133330
     /* 133330 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(133388), // Rule ID 3274 //
     /* 133335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 133338 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 133361 */     // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
     /* 133364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 133371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 133376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133386 */     GIR_RootConstrainSelectedInstOperands,
     /* 133387 */     // GIR_Coverage, 3274,
     /* 133387 */     GIR_EraseRootFromParent_Done,
     /* 133388 */   // Label 2001: @133388
     /* 133388 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(133444), // Rule ID 8185 //
     /* 133393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 133396 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 133401 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 133405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 133409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 133420 */     // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 133420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 133423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 133425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 133430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133442 */     GIR_RootConstrainSelectedInstOperands,
     /* 133443 */     // GIR_Coverage, 8185,
     /* 133443 */     GIR_EraseRootFromParent_Done,
     /* 133444 */   // Label 2002: @133444
     /* 133444 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(133500), // Rule ID 8189 //
     /* 133449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 133452 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 133457 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 133461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 133465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 133476 */     // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 133476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 133479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 133481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 133486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133498 */     GIR_RootConstrainSelectedInstOperands,
     /* 133499 */     // GIR_Coverage, 8189,
     /* 133499 */     GIR_EraseRootFromParent_Done,
     /* 133500 */   // Label 2003: @133500
     /* 133500 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(133561), // Rule ID 8253 //
     /* 133505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 133508 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 133513 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 133518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 133522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 133530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 133537 */     // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 133537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 133540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 133542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 133547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133559 */     GIR_RootConstrainSelectedInstOperands,
     /* 133560 */     // GIR_Coverage, 8253,
     /* 133560 */     GIR_EraseRootFromParent_Done,
     /* 133561 */   // Label 2004: @133561
     /* 133561 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(133622), // Rule ID 8257 //
     /* 133566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 133569 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 133574 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 133579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 133583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
     /* 133591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 133598 */     // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 133598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
     /* 133601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 133603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 133608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133620 */     GIR_RootConstrainSelectedInstOperands,
     /* 133621 */     // GIR_Coverage, 8257,
     /* 133621 */     GIR_EraseRootFromParent_Done,
     /* 133622 */   // Label 2005: @133622
     /* 133622 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(133673), // Rule ID 3248 //
     /* 133627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133638 */     // MIs[0] sbase
     /* 133638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133654 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 133657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133659 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133671 */     GIR_RootConstrainSelectedInstOperands,
     /* 133672 */     // GIR_Coverage, 3248,
     /* 133672 */     GIR_EraseRootFromParent_Done,
     /* 133673 */   // Label 2006: @133673
     /* 133673 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(133724), // Rule ID 3265 //
     /* 133678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133689 */     // MIs[0] sbase
     /* 133689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 133705 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 133708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133710 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133722 */     GIR_RootConstrainSelectedInstOperands,
     /* 133723 */     // GIR_Coverage, 3265,
     /* 133723 */     GIR_EraseRootFromParent_Done,
     /* 133724 */   // Label 2007: @133724
     /* 133724 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(133771), // Rule ID 3253 //
     /* 133729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133740 */     // MIs[0] sbase
     /* 133740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133752 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 133755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133757 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133769 */     GIR_RootConstrainSelectedInstOperands,
     /* 133770 */     // GIR_Coverage, 3253,
     /* 133770 */     GIR_EraseRootFromParent_Done,
     /* 133771 */   // Label 2008: @133771
     /* 133771 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(133818), // Rule ID 3270 //
     /* 133776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 133779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133787 */     // MIs[0] sbase
     /* 133787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133795 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133799 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
     /* 133802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133804 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133816 */     GIR_RootConstrainSelectedInstOperands,
     /* 133817 */     // GIR_Coverage, 3270,
     /* 133817 */     GIR_EraseRootFromParent_Done,
     /* 133818 */   // Label 2009: @133818
     /* 133818 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(133862), // Rule ID 3259 //
     /* 133823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133831 */     // MIs[0] sbase
     /* 133831 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133843 */     // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 133846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133848 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133860 */     GIR_RootConstrainSelectedInstOperands,
     /* 133861 */     // GIR_Coverage, 3259,
     /* 133861 */     GIR_EraseRootFromParent_Done,
     /* 133862 */   // Label 2010: @133862
     /* 133862 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(133906), // Rule ID 3276 //
     /* 133867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 133875 */     // MIs[0] sbase
     /* 133875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 133883 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 133887 */     // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 133887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
     /* 133890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 133892 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 133894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133904 */     GIR_RootConstrainSelectedInstOperands,
     /* 133905 */     // GIR_Coverage, 3276,
     /* 133905 */     GIR_EraseRootFromParent_Done,
     /* 133906 */   // Label 2011: @133906
     /* 133906 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(133963), // Rule ID 4382 //
     /* 133911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 133914 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 133919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 133923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 133934 */     // (ld:{ *:[v8i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 133937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 133939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 133944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 133949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 133954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 133957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133961 */     GIR_RootConstrainSelectedInstOperands,
     /* 133962 */     // GIR_Coverage, 4382,
     /* 133962 */     GIR_EraseRootFromParent_Done,
     /* 133963 */   // Label 2012: @133963
     /* 133963 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(134020), // Rule ID 4388 //
     /* 133968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 133971 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 133976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 133980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 133991 */     // (ld:{ *:[v8f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 133991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
     /* 133994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 133996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 134001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 134006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 134011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134018 */     GIR_RootConstrainSelectedInstOperands,
     /* 134019 */     // GIR_Coverage, 4388,
     /* 134019 */     GIR_EraseRootFromParent_Done,
     /* 134020 */   // Label 2013: @134020
     /* 134020 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(134072), // Rule ID 4381 //
     /* 134025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 134028 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 134033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 134048 */     // (ld:{ *:[v8i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 134048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 134051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 134058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134070 */     GIR_RootConstrainSelectedInstOperands,
     /* 134071 */     // GIR_Coverage, 4381,
     /* 134071 */     GIR_EraseRootFromParent_Done,
     /* 134072 */   // Label 2014: @134072
     /* 134072 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(134124), // Rule ID 4387 //
     /* 134077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 134080 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 134085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 134100 */     // (ld:{ *:[v8f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 134100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
     /* 134103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 134110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134122 */     GIR_RootConstrainSelectedInstOperands,
     /* 134123 */     // GIR_Coverage, 4387,
     /* 134123 */     GIR_EraseRootFromParent_Done,
     /* 134124 */   // Label 2015: @134124
     /* 134124 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(134176), // Rule ID 4380 //
     /* 134129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 134132 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 134137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 134152 */     // (ld:{ *:[v8i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 134152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 134155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 134162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134174 */     GIR_RootConstrainSelectedInstOperands,
     /* 134175 */     // GIR_Coverage, 4380,
     /* 134175 */     GIR_EraseRootFromParent_Done,
     /* 134176 */   // Label 2016: @134176
     /* 134176 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(134228), // Rule ID 4386 //
     /* 134181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 134184 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 134189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 134204 */     // (ld:{ *:[v8f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 134204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
     /* 134207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 134214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134226 */     GIR_RootConstrainSelectedInstOperands,
     /* 134227 */     // GIR_Coverage, 4386,
     /* 134227 */     GIR_EraseRootFromParent_Done,
     /* 134228 */   // Label 2017: @134228
     /* 134228 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(134295), // Rule ID 4599 //
     /* 134233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 134236 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 134258 */     // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 134261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 134268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 134278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 134283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134293 */     GIR_RootConstrainSelectedInstOperands,
     /* 134294 */     // GIR_Coverage, 4599,
     /* 134294 */     GIR_EraseRootFromParent_Done,
     /* 134295 */   // Label 2018: @134295
     /* 134295 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(134359), // Rule ID 4601 //
     /* 134300 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 134322 */     // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 134325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 134332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 134342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 134347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134357 */     GIR_RootConstrainSelectedInstOperands,
     /* 134358 */     // GIR_Coverage, 4601,
     /* 134358 */     GIR_EraseRootFromParent_Done,
     /* 134359 */   // Label 2019: @134359
     /* 134359 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(134426), // Rule ID 4603 //
     /* 134364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 134367 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 134389 */     // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
     /* 134392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 134399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 134409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 134414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134424 */     GIR_RootConstrainSelectedInstOperands,
     /* 134425 */     // GIR_Coverage, 4603,
     /* 134425 */     GIR_EraseRootFromParent_Done,
     /* 134426 */   // Label 2020: @134426
     /* 134426 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(134490), // Rule ID 4605 //
     /* 134431 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 134453 */     // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
     /* 134456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 134463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 134473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 134478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134488 */     GIR_RootConstrainSelectedInstOperands,
     /* 134489 */     // GIR_Coverage, 4605,
     /* 134489 */     GIR_EraseRootFromParent_Done,
     /* 134490 */   // Label 2021: @134490
     /* 134490 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(134551), // Rule ID 8116 //
     /* 134495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 134498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134502 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 134507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 134522 */     // (AMDGPUld_glue:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 134522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 134525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 134532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 134537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 134542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134549 */     GIR_RootConstrainSelectedInstOperands,
     /* 134550 */     // GIR_Coverage, 8116,
     /* 134550 */     GIR_EraseRootFromParent_Done,
     /* 134551 */   // Label 2022: @134551
     /* 134551 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(134612), // Rule ID 8120 //
     /* 134556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 134559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134563 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 134568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 134583 */     // (AMDGPUld_glue:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 134583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
     /* 134586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 134593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 134598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 134603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134610 */     GIR_RootConstrainSelectedInstOperands,
     /* 134611 */     // GIR_Coverage, 8120,
     /* 134611 */     GIR_EraseRootFromParent_Done,
     /* 134612 */   // Label 2023: @134612
     /* 134612 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(134674), // Rule ID 4598 //
     /* 134617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 134620 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 134642 */     // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 134645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 134662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134672 */     GIR_RootConstrainSelectedInstOperands,
     /* 134673 */     // GIR_Coverage, 4598,
     /* 134673 */     GIR_EraseRootFromParent_Done,
     /* 134674 */   // Label 2024: @134674
     /* 134674 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(134733), // Rule ID 4600 //
     /* 134679 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 134701 */     // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 134704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 134721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134731 */     GIR_RootConstrainSelectedInstOperands,
     /* 134732 */     // GIR_Coverage, 4600,
     /* 134732 */     GIR_EraseRootFromParent_Done,
     /* 134733 */   // Label 2025: @134733
     /* 134733 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(134795), // Rule ID 4602 //
     /* 134738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 134741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 134763 */     // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 134766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 134783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134793 */     GIR_RootConstrainSelectedInstOperands,
     /* 134794 */     // GIR_Coverage, 4602,
     /* 134794 */     GIR_EraseRootFromParent_Done,
     /* 134795 */   // Label 2026: @134795
     /* 134795 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(134854), // Rule ID 4604 //
     /* 134800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 134822 */     // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 134822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 134825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 134827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 134832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 134837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 134842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134852 */     GIR_RootConstrainSelectedInstOperands,
     /* 134853 */     // GIR_Coverage, 4604,
     /* 134853 */     GIR_EraseRootFromParent_Done,
     /* 134854 */   // Label 2027: @134854
     /* 134854 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(134911), // Rule ID 8118 //
     /* 134859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 134862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 134867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 134882 */     // (ld:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 134882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 134885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 134892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 134897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 134902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134909 */     GIR_RootConstrainSelectedInstOperands,
     /* 134910 */     // GIR_Coverage, 8118,
     /* 134910 */     GIR_EraseRootFromParent_Done,
     /* 134911 */   // Label 2028: @134911
     /* 134911 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(134968), // Rule ID 8122 //
     /* 134916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 134919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 134924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 134939 */     // (ld:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 134939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
     /* 134942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 134944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 134949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 134954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 134959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 134962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134966 */     GIR_RootConstrainSelectedInstOperands,
     /* 134967 */     // GIR_Coverage, 8122,
     /* 134967 */     GIR_EraseRootFromParent_Done,
     /* 134968 */   // Label 2029: @134968
     /* 134968 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(135027), // Rule ID 3954 //
     /* 134973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 134976 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 134983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 134987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 134998 */     // (ld:{ *:[v8i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 134998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 135001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 135003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 135008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 135013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135025 */     GIR_RootConstrainSelectedInstOperands,
     /* 135026 */     // GIR_Coverage, 3954,
     /* 135026 */     GIR_EraseRootFromParent_Done,
     /* 135027 */   // Label 2030: @135027
     /* 135027 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(135086), // Rule ID 3958 //
     /* 135032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 135035 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 135042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 135046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 135057 */     // (ld:{ *:[v8f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
     /* 135060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 135062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 135067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 135072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135084 */     GIR_RootConstrainSelectedInstOperands,
     /* 135085 */     // GIR_Coverage, 3958,
     /* 135085 */     GIR_EraseRootFromParent_Done,
     /* 135086 */   // Label 2031: @135086
     /* 135086 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(135140), // Rule ID 3953 //
     /* 135091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 135094 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 135101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 135105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 135116 */     // (ld:{ *:[v8i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 135116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 135119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 135121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 135126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135138 */     GIR_RootConstrainSelectedInstOperands,
     /* 135139 */     // GIR_Coverage, 3953,
     /* 135139 */     GIR_EraseRootFromParent_Done,
     /* 135140 */   // Label 2032: @135140
     /* 135140 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(135194), // Rule ID 3957 //
     /* 135145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 135148 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 135155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 135159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 135170 */     // (ld:{ *:[v8f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 135170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
     /* 135173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 135175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 135180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135192 */     GIR_RootConstrainSelectedInstOperands,
     /* 135193 */     // GIR_Coverage, 3957,
     /* 135193 */     GIR_EraseRootFromParent_Done,
     /* 135194 */   // Label 2033: @135194
     /* 135194 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(135249), // Rule ID 3663 //
     /* 135199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 135202 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 135210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 135214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 135225 */     // (ld:{ *:[v8i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 135225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 135228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 135230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 135235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135247 */     GIR_RootConstrainSelectedInstOperands,
     /* 135248 */     // GIR_Coverage, 3663,
     /* 135248 */     GIR_EraseRootFromParent_Done,
     /* 135249 */   // Label 2034: @135249
     /* 135249 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(135304), // Rule ID 3665 //
     /* 135254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 135257 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 135265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 135269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 135280 */     // (ld:{ *:[v8f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 135280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
     /* 135283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 135285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 135290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135302 */     GIR_RootConstrainSelectedInstOperands,
     /* 135303 */     // GIR_Coverage, 3665,
     /* 135303 */     GIR_EraseRootFromParent_Done,
     /* 135304 */   // Label 2035: @135304
     /* 135304 */   GIM_Reject,
     /* 135305 */ // Label 1969: @135305
     /* 135305 */ GIM_Reject,
     /* 135306 */ // Label 1016: @135306
     /* 135306 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(136957),
     /* 135311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135314 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135318 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 135322 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(135378), // Rule ID 3281 //
     /* 135327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135349 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135376 */     GIR_RootConstrainSelectedInstOperands,
     /* 135377 */     // GIR_Coverage, 3281,
     /* 135377 */     GIR_EraseRootFromParent_Done,
     /* 135378 */   // Label 2037: @135378
     /* 135378 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(135434), // Rule ID 3298 //
     /* 135383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135405 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135432 */     GIR_RootConstrainSelectedInstOperands,
     /* 135433 */     // GIR_Coverage, 3298,
     /* 135433 */     GIR_EraseRootFromParent_Done,
     /* 135434 */   // Label 2038: @135434
     /* 135434 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(135486), // Rule ID 3286 //
     /* 135439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135457 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135484 */     GIR_RootConstrainSelectedInstOperands,
     /* 135485 */     // GIR_Coverage, 3286,
     /* 135485 */     GIR_EraseRootFromParent_Done,
     /* 135486 */   // Label 2039: @135486
     /* 135486 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(135538), // Rule ID 3303 //
     /* 135491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135509 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 135512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135536 */     GIR_RootConstrainSelectedInstOperands,
     /* 135537 */     // GIR_Coverage, 3303,
     /* 135537 */     GIR_EraseRootFromParent_Done,
     /* 135538 */   // Label 2040: @135538
     /* 135538 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(135590), // Rule ID 3292 //
     /* 135543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 135546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135561 */     // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135588 */     GIR_RootConstrainSelectedInstOperands,
     /* 135589 */     // GIR_Coverage, 3292,
     /* 135589 */     GIR_EraseRootFromParent_Done,
     /* 135590 */   // Label 2041: @135590
     /* 135590 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(135642), // Rule ID 3309 //
     /* 135595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 135598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 135613 */     // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 135633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135640 */     GIR_RootConstrainSelectedInstOperands,
     /* 135641 */     // GIR_Coverage, 3309,
     /* 135641 */     GIR_EraseRootFromParent_Done,
     /* 135642 */   // Label 2042: @135642
     /* 135642 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(135693), // Rule ID 3277 //
     /* 135647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135669 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 135672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135691 */     GIR_RootConstrainSelectedInstOperands,
     /* 135692 */     // GIR_Coverage, 3277,
     /* 135692 */     GIR_EraseRootFromParent_Done,
     /* 135693 */   // Label 2043: @135693
     /* 135693 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(135744), // Rule ID 3278 //
     /* 135698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 135701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 135720 */     // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 135723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135742 */     GIR_RootConstrainSelectedInstOperands,
     /* 135743 */     // GIR_Coverage, 3278,
     /* 135743 */     GIR_EraseRootFromParent_Done,
     /* 135744 */   // Label 2044: @135744
     /* 135744 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(135795), // Rule ID 3279 //
     /* 135749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135771 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 135774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135793 */     GIR_RootConstrainSelectedInstOperands,
     /* 135794 */     // GIR_Coverage, 3279,
     /* 135794 */     GIR_EraseRootFromParent_Done,
     /* 135795 */   // Label 2045: @135795
     /* 135795 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(135849), // Rule ID 3280 //
     /* 135800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 135803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135822 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 135822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 135825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135847 */     GIR_RootConstrainSelectedInstOperands,
     /* 135848 */     // GIR_Coverage, 3280,
     /* 135848 */     GIR_EraseRootFromParent_Done,
     /* 135849 */   // Label 2046: @135849
     /* 135849 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(135900), // Rule ID 3294 //
     /* 135854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 135857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 135876 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 135879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135898 */     GIR_RootConstrainSelectedInstOperands,
     /* 135899 */     // GIR_Coverage, 3294,
     /* 135899 */     GIR_EraseRootFromParent_Done,
     /* 135900 */   // Label 2047: @135900
     /* 135900 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(135951), // Rule ID 3295 //
     /* 135905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 135908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 135927 */     // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 135927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 135930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135949 */     GIR_RootConstrainSelectedInstOperands,
     /* 135950 */     // GIR_Coverage, 3295,
     /* 135950 */     GIR_EraseRootFromParent_Done,
     /* 135951 */   // Label 2048: @135951
     /* 135951 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(136002), // Rule ID 3296 //
     /* 135956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 135959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 135963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 135971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 135978 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 135978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 135981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 135983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 135988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 135993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 135996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136000 */     GIR_RootConstrainSelectedInstOperands,
     /* 136001 */     // GIR_Coverage, 3296,
     /* 136001 */     GIR_EraseRootFromParent_Done,
     /* 136002 */   // Label 2049: @136002
     /* 136002 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(136056), // Rule ID 3297 //
     /* 136007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136018 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136029 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 136032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136054 */     GIR_RootConstrainSelectedInstOperands,
     /* 136055 */     // GIR_Coverage, 3297,
     /* 136055 */     GIR_EraseRootFromParent_Done,
     /* 136056 */   // Label 2050: @136056
     /* 136056 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(136103), // Rule ID 3283 //
     /* 136061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136079 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136101 */     GIR_RootConstrainSelectedInstOperands,
     /* 136102 */     // GIR_Coverage, 3283,
     /* 136102 */     GIR_EraseRootFromParent_Done,
     /* 136103 */   // Label 2051: @136103
     /* 136103 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(136150), // Rule ID 3284 //
     /* 136108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 136111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136126 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 136129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136148 */     GIR_RootConstrainSelectedInstOperands,
     /* 136149 */     // GIR_Coverage, 3284,
     /* 136149 */     GIR_EraseRootFromParent_Done,
     /* 136150 */   // Label 2052: @136150
     /* 136150 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(136200), // Rule ID 3285 //
     /* 136155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136173 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 136176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136198 */     GIR_RootConstrainSelectedInstOperands,
     /* 136199 */     // GIR_Coverage, 3285,
     /* 136199 */     GIR_EraseRootFromParent_Done,
     /* 136200 */   // Label 2053: @136200
     /* 136200 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(136247), // Rule ID 3300 //
     /* 136205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136223 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136245 */     GIR_RootConstrainSelectedInstOperands,
     /* 136246 */     // GIR_Coverage, 3300,
     /* 136246 */     GIR_EraseRootFromParent_Done,
     /* 136247 */   // Label 2054: @136247
     /* 136247 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(136294), // Rule ID 3301 //
     /* 136252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 136255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136270 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 136273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136292 */     GIR_RootConstrainSelectedInstOperands,
     /* 136293 */     // GIR_Coverage, 3301,
     /* 136293 */     GIR_EraseRootFromParent_Done,
     /* 136294 */   // Label 2055: @136294
     /* 136294 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(136344), // Rule ID 3302 //
     /* 136299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136317 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 136320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136342 */     GIR_RootConstrainSelectedInstOperands,
     /* 136343 */     // GIR_Coverage, 3302,
     /* 136343 */     GIR_EraseRootFromParent_Done,
     /* 136344 */   // Label 2056: @136344
     /* 136344 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(136388), // Rule ID 3288 //
     /* 136349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136364 */     // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136386 */     GIR_RootConstrainSelectedInstOperands,
     /* 136387 */     // GIR_Coverage, 3288,
     /* 136387 */     GIR_EraseRootFromParent_Done,
     /* 136388 */   // Label 2057: @136388
     /* 136388 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(136435), // Rule ID 3289 //
     /* 136393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 136396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 136411 */     // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 136414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136433 */     GIR_RootConstrainSelectedInstOperands,
     /* 136434 */     // GIR_Coverage, 3289,
     /* 136434 */     GIR_EraseRootFromParent_Done,
     /* 136435 */   // Label 2058: @136435
     /* 136435 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(136482), // Rule ID 3290 //
     /* 136440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 136443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136458 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 136461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136480 */     GIR_RootConstrainSelectedInstOperands,
     /* 136481 */     // GIR_Coverage, 3290,
     /* 136481 */     GIR_EraseRootFromParent_Done,
     /* 136482 */   // Label 2059: @136482
     /* 136482 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(136532), // Rule ID 3291 //
     /* 136487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136505 */     // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 136508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136530 */     GIR_RootConstrainSelectedInstOperands,
     /* 136531 */     // GIR_Coverage, 3291,
     /* 136531 */     GIR_EraseRootFromParent_Done,
     /* 136532 */   // Label 2060: @136532
     /* 136532 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(136576), // Rule ID 3305 //
     /* 136537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 136552 */     // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136574 */     GIR_RootConstrainSelectedInstOperands,
     /* 136575 */     // GIR_Coverage, 3305,
     /* 136575 */     GIR_EraseRootFromParent_Done,
     /* 136576 */   // Label 2061: @136576
     /* 136576 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(136623), // Rule ID 3306 //
     /* 136581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 136584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 136599 */     // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 136599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 136602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136621 */     GIR_RootConstrainSelectedInstOperands,
     /* 136622 */     // GIR_Coverage, 3306,
     /* 136622 */     GIR_EraseRootFromParent_Done,
     /* 136623 */   // Label 2062: @136623
     /* 136623 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(136670), // Rule ID 3307 //
     /* 136628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 136631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136646 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 136646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 136649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136668 */     GIR_RootConstrainSelectedInstOperands,
     /* 136669 */     // GIR_Coverage, 3307,
     /* 136669 */     GIR_EraseRootFromParent_Done,
     /* 136670 */   // Label 2063: @136670
     /* 136670 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(136720), // Rule ID 3308 //
     /* 136675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 136678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 136693 */     // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 136696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 136703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 136708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136718 */     GIR_RootConstrainSelectedInstOperands,
     /* 136719 */     // GIR_Coverage, 3308,
     /* 136719 */     GIR_EraseRootFromParent_Done,
     /* 136720 */   // Label 2064: @136720
     /* 136720 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(136763), // Rule ID 3282 //
     /* 136725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136732 */     // MIs[0] sbase
     /* 136732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136744 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136749 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136761 */     GIR_RootConstrainSelectedInstOperands,
     /* 136762 */     // GIR_Coverage, 3282,
     /* 136762 */     GIR_EraseRootFromParent_Done,
     /* 136763 */   // Label 2065: @136763
     /* 136763 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(136806), // Rule ID 3299 //
     /* 136768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136775 */     // MIs[0] sbase
     /* 136775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136787 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136792 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136804 */     GIR_RootConstrainSelectedInstOperands,
     /* 136805 */     // GIR_Coverage, 3299,
     /* 136805 */     GIR_EraseRootFromParent_Done,
     /* 136806 */   // Label 2066: @136806
     /* 136806 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(136845), // Rule ID 3287 //
     /* 136811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136818 */     // MIs[0] sbase
     /* 136818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136826 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136831 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136843 */     GIR_RootConstrainSelectedInstOperands,
     /* 136844 */     // GIR_Coverage, 3287,
     /* 136844 */     GIR_EraseRootFromParent_Done,
     /* 136845 */   // Label 2067: @136845
     /* 136845 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(136884), // Rule ID 3304 //
     /* 136850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 136853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136857 */     // MIs[0] sbase
     /* 136857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136865 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 136868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136870 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136882 */     GIR_RootConstrainSelectedInstOperands,
     /* 136883 */     // GIR_Coverage, 3304,
     /* 136883 */     GIR_EraseRootFromParent_Done,
     /* 136884 */   // Label 2068: @136884
     /* 136884 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(136920), // Rule ID 3293 //
     /* 136889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136893 */     // MIs[0] sbase
     /* 136893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136901 */     // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136906 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136918 */     GIR_RootConstrainSelectedInstOperands,
     /* 136919 */     // GIR_Coverage, 3293,
     /* 136919 */     GIR_EraseRootFromParent_Done,
     /* 136920 */   // Label 2069: @136920
     /* 136920 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(136956), // Rule ID 3310 //
     /* 136925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 136929 */     // MIs[0] sbase
     /* 136929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 136937 */     // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 136937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 136940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 136942 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 136944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 136950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136954 */     GIR_RootConstrainSelectedInstOperands,
     /* 136955 */     // GIR_Coverage, 3310,
     /* 136955 */     GIR_EraseRootFromParent_Done,
     /* 136956 */   // Label 2070: @136956
     /* 136956 */   GIM_Reject,
     /* 136957 */ // Label 2036: @136957
     /* 136957 */ GIM_Reject,
     /* 136958 */ // Label 1017: @136958
     /* 136958 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(138609),
     /* 136963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136966 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136970 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 136974 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(137030), // Rule ID 3417 //
     /* 136979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 136982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 136986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136990 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 136994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 137001 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 137021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137028 */     GIR_RootConstrainSelectedInstOperands,
     /* 137029 */     // GIR_Coverage, 3417,
     /* 137029 */     GIR_EraseRootFromParent_Done,
     /* 137030 */   // Label 2072: @137030
     /* 137030 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(137086), // Rule ID 3434 //
     /* 137035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 137057 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 137077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137084 */     GIR_RootConstrainSelectedInstOperands,
     /* 137085 */     // GIR_Coverage, 3434,
     /* 137085 */     GIR_EraseRootFromParent_Done,
     /* 137086 */   // Label 2073: @137086
     /* 137086 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(137138), // Rule ID 3422 //
     /* 137091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 137109 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 137129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137136 */     GIR_RootConstrainSelectedInstOperands,
     /* 137137 */     // GIR_Coverage, 3422,
     /* 137137 */     GIR_EraseRootFromParent_Done,
     /* 137138 */   // Label 2074: @137138
     /* 137138 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(137190), // Rule ID 3439 //
     /* 137143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 137161 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 137181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137188 */     GIR_RootConstrainSelectedInstOperands,
     /* 137189 */     // GIR_Coverage, 3439,
     /* 137189 */     GIR_EraseRootFromParent_Done,
     /* 137190 */   // Label 2075: @137190
     /* 137190 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(137242), // Rule ID 3428 //
     /* 137195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 137198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 137213 */     // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 137233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137240 */     GIR_RootConstrainSelectedInstOperands,
     /* 137241 */     // GIR_Coverage, 3428,
     /* 137241 */     GIR_EraseRootFromParent_Done,
     /* 137242 */   // Label 2076: @137242
     /* 137242 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(137294), // Rule ID 3445 //
     /* 137247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 137250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 137265 */     // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 137285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137292 */     GIR_RootConstrainSelectedInstOperands,
     /* 137293 */     // GIR_Coverage, 3445,
     /* 137293 */     GIR_EraseRootFromParent_Done,
     /* 137294 */   // Label 2077: @137294
     /* 137294 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(137345), // Rule ID 3413 //
     /* 137299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137321 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137343 */     GIR_RootConstrainSelectedInstOperands,
     /* 137344 */     // GIR_Coverage, 3413,
     /* 137344 */     GIR_EraseRootFromParent_Done,
     /* 137345 */   // Label 2078: @137345
     /* 137345 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(137396), // Rule ID 3414 //
     /* 137350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 137353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137372 */     // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137394 */     GIR_RootConstrainSelectedInstOperands,
     /* 137395 */     // GIR_Coverage, 3414,
     /* 137395 */     GIR_EraseRootFromParent_Done,
     /* 137396 */   // Label 2079: @137396
     /* 137396 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(137447), // Rule ID 3415 //
     /* 137401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137423 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137445 */     GIR_RootConstrainSelectedInstOperands,
     /* 137446 */     // GIR_Coverage, 3415,
     /* 137446 */     GIR_EraseRootFromParent_Done,
     /* 137447 */   // Label 2080: @137447
     /* 137447 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(137501), // Rule ID 3416 //
     /* 137452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137474 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137499 */     GIR_RootConstrainSelectedInstOperands,
     /* 137500 */     // GIR_Coverage, 3416,
     /* 137500 */     GIR_EraseRootFromParent_Done,
     /* 137501 */   // Label 2081: @137501
     /* 137501 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(137552), // Rule ID 3430 //
     /* 137506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137528 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 137531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137550 */     GIR_RootConstrainSelectedInstOperands,
     /* 137551 */     // GIR_Coverage, 3430,
     /* 137551 */     GIR_EraseRootFromParent_Done,
     /* 137552 */   // Label 2082: @137552
     /* 137552 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(137603), // Rule ID 3431 //
     /* 137557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 137560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137568 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 137579 */     // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 137582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137601 */     GIR_RootConstrainSelectedInstOperands,
     /* 137602 */     // GIR_Coverage, 3431,
     /* 137602 */     GIR_EraseRootFromParent_Done,
     /* 137603 */   // Label 2083: @137603
     /* 137603 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(137654), // Rule ID 3432 //
     /* 137608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137630 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 137633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137652 */     GIR_RootConstrainSelectedInstOperands,
     /* 137653 */     // GIR_Coverage, 3432,
     /* 137653 */     GIR_EraseRootFromParent_Done,
     /* 137654 */   // Label 2084: @137654
     /* 137654 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(137708), // Rule ID 3433 //
     /* 137659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 137674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137681 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 137684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137706 */     GIR_RootConstrainSelectedInstOperands,
     /* 137707 */     // GIR_Coverage, 3433,
     /* 137707 */     GIR_EraseRootFromParent_Done,
     /* 137708 */   // Label 2085: @137708
     /* 137708 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(137755), // Rule ID 3419 //
     /* 137713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137731 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 137734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137753 */     GIR_RootConstrainSelectedInstOperands,
     /* 137754 */     // GIR_Coverage, 3419,
     /* 137754 */     GIR_EraseRootFromParent_Done,
     /* 137755 */   // Label 2086: @137755
     /* 137755 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(137802), // Rule ID 3420 //
     /* 137760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137778 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 137781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137800 */     GIR_RootConstrainSelectedInstOperands,
     /* 137801 */     // GIR_Coverage, 3420,
     /* 137801 */     GIR_EraseRootFromParent_Done,
     /* 137802 */   // Label 2087: @137802
     /* 137802 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(137852), // Rule ID 3421 //
     /* 137807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137825 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137850 */     GIR_RootConstrainSelectedInstOperands,
     /* 137851 */     // GIR_Coverage, 3421,
     /* 137851 */     GIR_EraseRootFromParent_Done,
     /* 137852 */   // Label 2088: @137852
     /* 137852 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(137899), // Rule ID 3436 //
     /* 137857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 137860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 137875 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 137875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 137878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137897 */     GIR_RootConstrainSelectedInstOperands,
     /* 137898 */     // GIR_Coverage, 3436,
     /* 137898 */     GIR_EraseRootFromParent_Done,
     /* 137899 */   // Label 2089: @137899
     /* 137899 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(137946), // Rule ID 3437 //
     /* 137904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 137907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137922 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 137922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 137925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137944 */     GIR_RootConstrainSelectedInstOperands,
     /* 137945 */     // GIR_Coverage, 3437,
     /* 137945 */     GIR_EraseRootFromParent_Done,
     /* 137946 */   // Label 2090: @137946
     /* 137946 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(137996), // Rule ID 3438 //
     /* 137951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 137954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 137958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 137969 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 137969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 137972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 137974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 137979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 137984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 137990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137994 */     GIR_RootConstrainSelectedInstOperands,
     /* 137995 */     // GIR_Coverage, 3438,
     /* 137995 */     GIR_EraseRootFromParent_Done,
     /* 137996 */   // Label 2091: @137996
     /* 137996 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(138040), // Rule ID 3424 //
     /* 138001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138016 */     // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138038 */     GIR_RootConstrainSelectedInstOperands,
     /* 138039 */     // GIR_Coverage, 3424,
     /* 138039 */     GIR_EraseRootFromParent_Done,
     /* 138040 */   // Label 2092: @138040
     /* 138040 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(138087), // Rule ID 3425 //
     /* 138045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 138048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 138063 */     // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 138066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138085 */     GIR_RootConstrainSelectedInstOperands,
     /* 138086 */     // GIR_Coverage, 3425,
     /* 138086 */     GIR_EraseRootFromParent_Done,
     /* 138087 */   // Label 2093: @138087
     /* 138087 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(138134), // Rule ID 3426 //
     /* 138092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 138095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138110 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 138110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 138113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138132 */     GIR_RootConstrainSelectedInstOperands,
     /* 138133 */     // GIR_Coverage, 3426,
     /* 138133 */     GIR_EraseRootFromParent_Done,
     /* 138134 */   // Label 2094: @138134
     /* 138134 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(138184), // Rule ID 3427 //
     /* 138139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138157 */     // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138182 */     GIR_RootConstrainSelectedInstOperands,
     /* 138183 */     // GIR_Coverage, 3427,
     /* 138183 */     GIR_EraseRootFromParent_Done,
     /* 138184 */   // Label 2095: @138184
     /* 138184 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(138228), // Rule ID 3441 //
     /* 138189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138204 */     // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138226 */     GIR_RootConstrainSelectedInstOperands,
     /* 138227 */     // GIR_Coverage, 3441,
     /* 138227 */     GIR_EraseRootFromParent_Done,
     /* 138228 */   // Label 2096: @138228
     /* 138228 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(138275), // Rule ID 3442 //
     /* 138233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 138236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 138251 */     // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 138254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138273 */     GIR_RootConstrainSelectedInstOperands,
     /* 138274 */     // GIR_Coverage, 3442,
     /* 138274 */     GIR_EraseRootFromParent_Done,
     /* 138275 */   // Label 2097: @138275
     /* 138275 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(138322), // Rule ID 3443 //
     /* 138280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 138283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138298 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 138298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 138301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138320 */     GIR_RootConstrainSelectedInstOperands,
     /* 138321 */     // GIR_Coverage, 3443,
     /* 138321 */     GIR_EraseRootFromParent_Done,
     /* 138322 */   // Label 2098: @138322
     /* 138322 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(138372), // Rule ID 3444 //
     /* 138327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 138345 */     // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 138348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138370 */     GIR_RootConstrainSelectedInstOperands,
     /* 138371 */     // GIR_Coverage, 3444,
     /* 138371 */     GIR_EraseRootFromParent_Done,
     /* 138372 */   // Label 2099: @138372
     /* 138372 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(138415), // Rule ID 3418 //
     /* 138377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138384 */     // MIs[0] sbase
     /* 138384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138396 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138401 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138413 */     GIR_RootConstrainSelectedInstOperands,
     /* 138414 */     // GIR_Coverage, 3418,
     /* 138414 */     GIR_EraseRootFromParent_Done,
     /* 138415 */   // Label 2100: @138415
     /* 138415 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(138458), // Rule ID 3435 //
     /* 138420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138427 */     // MIs[0] sbase
     /* 138427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138439 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138444 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138456 */     GIR_RootConstrainSelectedInstOperands,
     /* 138457 */     // GIR_Coverage, 3435,
     /* 138457 */     GIR_EraseRootFromParent_Done,
     /* 138458 */   // Label 2101: @138458
     /* 138458 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(138497), // Rule ID 3423 //
     /* 138463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138470 */     // MIs[0] sbase
     /* 138470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138478 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 138481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138483 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138495 */     GIR_RootConstrainSelectedInstOperands,
     /* 138496 */     // GIR_Coverage, 3423,
     /* 138496 */     GIR_EraseRootFromParent_Done,
     /* 138497 */   // Label 2102: @138497
     /* 138497 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(138536), // Rule ID 3440 //
     /* 138502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138509 */     // MIs[0] sbase
     /* 138509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138517 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 138520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138522 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138534 */     GIR_RootConstrainSelectedInstOperands,
     /* 138535 */     // GIR_Coverage, 3440,
     /* 138535 */     GIR_EraseRootFromParent_Done,
     /* 138536 */   // Label 2103: @138536
     /* 138536 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(138572), // Rule ID 3429 //
     /* 138541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138545 */     // MIs[0] sbase
     /* 138545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138553 */     // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138558 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138570 */     GIR_RootConstrainSelectedInstOperands,
     /* 138571 */     // GIR_Coverage, 3429,
     /* 138571 */     GIR_EraseRootFromParent_Done,
     /* 138572 */   // Label 2104: @138572
     /* 138572 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(138608), // Rule ID 3446 //
     /* 138577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 138581 */     // MIs[0] sbase
     /* 138581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 138589 */     // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 138589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 138592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138594 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 138596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138606 */     GIR_RootConstrainSelectedInstOperands,
     /* 138607 */     // GIR_Coverage, 3446,
     /* 138607 */     GIR_EraseRootFromParent_Done,
     /* 138608 */   // Label 2105: @138608
     /* 138608 */   GIM_Reject,
     /* 138609 */ // Label 2071: @138609
     /* 138609 */ GIM_Reject,
     /* 138610 */ // Label 1018: @138610
     /* 138610 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(140261),
     /* 138615 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138622 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 138626 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(138682), // Rule ID 3349 //
     /* 138631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 138638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138653 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 138656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138680 */     GIR_RootConstrainSelectedInstOperands,
     /* 138681 */     // GIR_Coverage, 3349,
     /* 138681 */     GIR_EraseRootFromParent_Done,
     /* 138682 */   // Label 2107: @138682
     /* 138682 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(138738), // Rule ID 3366 //
     /* 138687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 138694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138698 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138709 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 138712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138736 */     GIR_RootConstrainSelectedInstOperands,
     /* 138737 */     // GIR_Coverage, 3366,
     /* 138737 */     GIR_EraseRootFromParent_Done,
     /* 138738 */   // Label 2108: @138738
     /* 138738 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(138790), // Rule ID 3354 //
     /* 138743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 138750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138761 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 138764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138788 */     GIR_RootConstrainSelectedInstOperands,
     /* 138789 */     // GIR_Coverage, 3354,
     /* 138789 */     GIR_EraseRootFromParent_Done,
     /* 138790 */   // Label 2109: @138790
     /* 138790 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(138842), // Rule ID 3371 //
     /* 138795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 138798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 138802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138813 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 138816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138840 */     GIR_RootConstrainSelectedInstOperands,
     /* 138841 */     // GIR_Coverage, 3371,
     /* 138841 */     GIR_EraseRootFromParent_Done,
     /* 138842 */   // Label 2110: @138842
     /* 138842 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(138894), // Rule ID 3360 //
     /* 138847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 138854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138865 */     // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 138868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138892 */     GIR_RootConstrainSelectedInstOperands,
     /* 138893 */     // GIR_Coverage, 3360,
     /* 138893 */     GIR_EraseRootFromParent_Done,
     /* 138894 */   // Label 2111: @138894
     /* 138894 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(138946), // Rule ID 3377 //
     /* 138899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 138902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 138906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 138917 */     // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 138920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 138932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 138937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138944 */     GIR_RootConstrainSelectedInstOperands,
     /* 138945 */     // GIR_Coverage, 3377,
     /* 138945 */     GIR_EraseRootFromParent_Done,
     /* 138946 */   // Label 2112: @138946
     /* 138946 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(138997), // Rule ID 3345 //
     /* 138951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 138954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 138958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 138966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 138973 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 138973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 138976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 138978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 138983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 138991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138995 */     GIR_RootConstrainSelectedInstOperands,
     /* 138996 */     // GIR_Coverage, 3345,
     /* 138996 */     GIR_EraseRootFromParent_Done,
     /* 138997 */   // Label 2113: @138997
     /* 138997 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(139048), // Rule ID 3346 //
     /* 139002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 139005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139024 */     // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 139027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139046 */     GIR_RootConstrainSelectedInstOperands,
     /* 139047 */     // GIR_Coverage, 3346,
     /* 139047 */     GIR_EraseRootFromParent_Done,
     /* 139048 */   // Label 2114: @139048
     /* 139048 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(139099), // Rule ID 3347 //
     /* 139053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139075 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 139078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139097 */     GIR_RootConstrainSelectedInstOperands,
     /* 139098 */     // GIR_Coverage, 3347,
     /* 139098 */     GIR_EraseRootFromParent_Done,
     /* 139099 */   // Label 2115: @139099
     /* 139099 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(139153), // Rule ID 3348 //
     /* 139104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139126 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 139129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139151 */     GIR_RootConstrainSelectedInstOperands,
     /* 139152 */     // GIR_Coverage, 3348,
     /* 139152 */     GIR_EraseRootFromParent_Done,
     /* 139153 */   // Label 2116: @139153
     /* 139153 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(139204), // Rule ID 3362 //
     /* 139158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139180 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 139183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139202 */     GIR_RootConstrainSelectedInstOperands,
     /* 139203 */     // GIR_Coverage, 3362,
     /* 139203 */     GIR_EraseRootFromParent_Done,
     /* 139204 */   // Label 2117: @139204
     /* 139204 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(139255), // Rule ID 3363 //
     /* 139209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 139212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139231 */     // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 139234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139253 */     GIR_RootConstrainSelectedInstOperands,
     /* 139254 */     // GIR_Coverage, 3363,
     /* 139254 */     GIR_EraseRootFromParent_Done,
     /* 139255 */   // Label 2118: @139255
     /* 139255 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(139306), // Rule ID 3364 //
     /* 139260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139282 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 139285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139304 */     GIR_RootConstrainSelectedInstOperands,
     /* 139305 */     // GIR_Coverage, 3364,
     /* 139305 */     GIR_EraseRootFromParent_Done,
     /* 139306 */   // Label 2119: @139306
     /* 139306 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(139360), // Rule ID 3365 //
     /* 139311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 139326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139333 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 139336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139358 */     GIR_RootConstrainSelectedInstOperands,
     /* 139359 */     // GIR_Coverage, 3365,
     /* 139359 */     GIR_EraseRootFromParent_Done,
     /* 139360 */   // Label 2120: @139360
     /* 139360 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(139407), // Rule ID 3351 //
     /* 139365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139383 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 139386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139405 */     GIR_RootConstrainSelectedInstOperands,
     /* 139406 */     // GIR_Coverage, 3351,
     /* 139406 */     GIR_EraseRootFromParent_Done,
     /* 139407 */   // Label 2121: @139407
     /* 139407 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(139454), // Rule ID 3352 //
     /* 139412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139430 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 139433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139452 */     GIR_RootConstrainSelectedInstOperands,
     /* 139453 */     // GIR_Coverage, 3352,
     /* 139453 */     GIR_EraseRootFromParent_Done,
     /* 139454 */   // Label 2122: @139454
     /* 139454 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(139504), // Rule ID 3353 //
     /* 139459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139477 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 139480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139502 */     GIR_RootConstrainSelectedInstOperands,
     /* 139503 */     // GIR_Coverage, 3353,
     /* 139503 */     GIR_EraseRootFromParent_Done,
     /* 139504 */   // Label 2123: @139504
     /* 139504 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(139551), // Rule ID 3368 //
     /* 139509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 139512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139527 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 139530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139549 */     GIR_RootConstrainSelectedInstOperands,
     /* 139550 */     // GIR_Coverage, 3368,
     /* 139550 */     GIR_EraseRootFromParent_Done,
     /* 139551 */   // Label 2124: @139551
     /* 139551 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(139598), // Rule ID 3369 //
     /* 139556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 139559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139574 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
     /* 139577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139596 */     GIR_RootConstrainSelectedInstOperands,
     /* 139597 */     // GIR_Coverage, 3369,
     /* 139597 */     GIR_EraseRootFromParent_Done,
     /* 139598 */   // Label 2125: @139598
     /* 139598 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(139648), // Rule ID 3370 //
     /* 139603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 139606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139621 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
     /* 139624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139646 */     GIR_RootConstrainSelectedInstOperands,
     /* 139647 */     // GIR_Coverage, 3370,
     /* 139647 */     GIR_EraseRootFromParent_Done,
     /* 139648 */   // Label 2126: @139648
     /* 139648 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(139692), // Rule ID 3356 //
     /* 139653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139668 */     // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 139671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139690 */     GIR_RootConstrainSelectedInstOperands,
     /* 139691 */     // GIR_Coverage, 3356,
     /* 139691 */     GIR_EraseRootFromParent_Done,
     /* 139692 */   // Label 2127: @139692
     /* 139692 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(139739), // Rule ID 3357 //
     /* 139697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 139700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139715 */     // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 139718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139737 */     GIR_RootConstrainSelectedInstOperands,
     /* 139738 */     // GIR_Coverage, 3357,
     /* 139738 */     GIR_EraseRootFromParent_Done,
     /* 139739 */   // Label 2128: @139739
     /* 139739 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(139786), // Rule ID 3358 //
     /* 139744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 139747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139762 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 139765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139784 */     GIR_RootConstrainSelectedInstOperands,
     /* 139785 */     // GIR_Coverage, 3358,
     /* 139785 */     GIR_EraseRootFromParent_Done,
     /* 139786 */   // Label 2129: @139786
     /* 139786 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(139836), // Rule ID 3359 //
     /* 139791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 139794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139809 */     // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 139812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139834 */     GIR_RootConstrainSelectedInstOperands,
     /* 139835 */     // GIR_Coverage, 3359,
     /* 139835 */     GIR_EraseRootFromParent_Done,
     /* 139836 */   // Label 2130: @139836
     /* 139836 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(139880), // Rule ID 3373 //
     /* 139841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 139856 */     // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 139859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139878 */     GIR_RootConstrainSelectedInstOperands,
     /* 139879 */     // GIR_Coverage, 3373,
     /* 139879 */     GIR_EraseRootFromParent_Done,
     /* 139880 */   // Label 2131: @139880
     /* 139880 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(139927), // Rule ID 3374 //
     /* 139885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 139888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 139903 */     // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 139903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
     /* 139906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139925 */     GIR_RootConstrainSelectedInstOperands,
     /* 139926 */     // GIR_Coverage, 3374,
     /* 139926 */     GIR_EraseRootFromParent_Done,
     /* 139927 */   // Label 2132: @139927
     /* 139927 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(139974), // Rule ID 3375 //
     /* 139932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 139935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139950 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 139950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
     /* 139953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 139955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 139960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 139965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139972 */     GIR_RootConstrainSelectedInstOperands,
     /* 139973 */     // GIR_Coverage, 3375,
     /* 139973 */     GIR_EraseRootFromParent_Done,
     /* 139974 */   // Label 2133: @139974
     /* 139974 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(140024), // Rule ID 3376 //
     /* 139979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 139982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 139986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 139997 */     // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 139997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
     /* 140000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140022 */     GIR_RootConstrainSelectedInstOperands,
     /* 140023 */     // GIR_Coverage, 3376,
     /* 140023 */     GIR_EraseRootFromParent_Done,
     /* 140024 */   // Label 2134: @140024
     /* 140024 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(140067), // Rule ID 3350 //
     /* 140029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 140032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 140036 */     // MIs[0] sbase
     /* 140036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 140044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140048 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 140051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140053 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 140055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140065 */     GIR_RootConstrainSelectedInstOperands,
     /* 140066 */     // GIR_Coverage, 3350,
     /* 140066 */     GIR_EraseRootFromParent_Done,
     /* 140067 */   // Label 2135: @140067
     /* 140067 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(140110), // Rule ID 3367 //
     /* 140072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 140075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 140079 */     // MIs[0] sbase
     /* 140079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 140087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140091 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 140094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140096 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 140098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140108 */     GIR_RootConstrainSelectedInstOperands,
     /* 140109 */     // GIR_Coverage, 3367,
     /* 140109 */     GIR_EraseRootFromParent_Done,
     /* 140110 */   // Label 2136: @140110
     /* 140110 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(140149), // Rule ID 3355 //
     /* 140115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 140118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 140122 */     // MIs[0] sbase
     /* 140122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 140130 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 140133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140135 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 140137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140147 */     GIR_RootConstrainSelectedInstOperands,
     /* 140148 */     // GIR_Coverage, 3355,
     /* 140148 */     GIR_EraseRootFromParent_Done,
     /* 140149 */   // Label 2137: @140149
     /* 140149 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(140188), // Rule ID 3372 //
     /* 140154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 140157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 140161 */     // MIs[0] sbase
     /* 140161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 140169 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
     /* 140172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140174 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 140176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140186 */     GIR_RootConstrainSelectedInstOperands,
     /* 140187 */     // GIR_Coverage, 3372,
     /* 140187 */     GIR_EraseRootFromParent_Done,
     /* 140188 */   // Label 2138: @140188
     /* 140188 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(140224), // Rule ID 3361 //
     /* 140193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 140197 */     // MIs[0] sbase
     /* 140197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 140205 */     // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 140208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140210 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 140212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140222 */     GIR_RootConstrainSelectedInstOperands,
     /* 140223 */     // GIR_Coverage, 3361,
     /* 140223 */     GIR_EraseRootFromParent_Done,
     /* 140224 */   // Label 2139: @140224
     /* 140224 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(140260), // Rule ID 3378 //
     /* 140229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 140233 */     // MIs[0] sbase
     /* 140233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 140241 */     // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
     /* 140244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140246 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 140248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140258 */     GIR_RootConstrainSelectedInstOperands,
     /* 140259 */     // GIR_Coverage, 3378,
     /* 140259 */     GIR_EraseRootFromParent_Done,
     /* 140260 */   // Label 2140: @140260
     /* 140260 */   GIM_Reject,
     /* 140261 */ // Label 2106: @140261
     /* 140261 */ GIM_Reject,
     /* 140262 */ // Label 1019: @140262
     /* 140262 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(141913),
     /* 140267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140270 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140274 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 140278 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(140334), // Rule ID 3383 //
     /* 140283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 140286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 140305 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 140308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140332 */     GIR_RootConstrainSelectedInstOperands,
     /* 140333 */     // GIR_Coverage, 3383,
     /* 140333 */     GIR_EraseRootFromParent_Done,
     /* 140334 */   // Label 2142: @140334
     /* 140334 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(140390), // Rule ID 3400 //
     /* 140339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 140342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 140361 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 140364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140388 */     GIR_RootConstrainSelectedInstOperands,
     /* 140389 */     // GIR_Coverage, 3400,
     /* 140389 */     GIR_EraseRootFromParent_Done,
     /* 140390 */   // Label 2143: @140390
     /* 140390 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(140442), // Rule ID 3388 //
     /* 140395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 140398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 140413 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 140416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140440 */     GIR_RootConstrainSelectedInstOperands,
     /* 140441 */     // GIR_Coverage, 3388,
     /* 140441 */     GIR_EraseRootFromParent_Done,
     /* 140442 */   // Label 2144: @140442
     /* 140442 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(140494), // Rule ID 3405 //
     /* 140447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 140450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 140465 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 140468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140492 */     GIR_RootConstrainSelectedInstOperands,
     /* 140493 */     // GIR_Coverage, 3405,
     /* 140493 */     GIR_EraseRootFromParent_Done,
     /* 140494 */   // Label 2145: @140494
     /* 140494 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(140546), // Rule ID 3394 //
     /* 140499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 140502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 140517 */     // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 140520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140544 */     GIR_RootConstrainSelectedInstOperands,
     /* 140545 */     // GIR_Coverage, 3394,
     /* 140545 */     GIR_EraseRootFromParent_Done,
     /* 140546 */   // Label 2146: @140546
     /* 140546 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(140598), // Rule ID 3411 //
     /* 140551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 140554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 140569 */     // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 140572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 140589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140596 */     GIR_RootConstrainSelectedInstOperands,
     /* 140597 */     // GIR_Coverage, 3411,
     /* 140597 */     GIR_EraseRootFromParent_Done,
     /* 140598 */   // Label 2147: @140598
     /* 140598 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(140649), // Rule ID 3379 //
     /* 140603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 140606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 140625 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 140628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140647 */     GIR_RootConstrainSelectedInstOperands,
     /* 140648 */     // GIR_Coverage, 3379,
     /* 140648 */     GIR_EraseRootFromParent_Done,
     /* 140649 */   // Label 2148: @140649
     /* 140649 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(140700), // Rule ID 3380 //
     /* 140654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 140657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 140676 */     // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 140679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140698 */     GIR_RootConstrainSelectedInstOperands,
     /* 140699 */     // GIR_Coverage, 3380,
     /* 140699 */     GIR_EraseRootFromParent_Done,
     /* 140700 */   // Label 2149: @140700
     /* 140700 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(140751), // Rule ID 3381 //
     /* 140705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 140708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 140727 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 140727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 140730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140749 */     GIR_RootConstrainSelectedInstOperands,
     /* 140750 */     // GIR_Coverage, 3381,
     /* 140750 */     GIR_EraseRootFromParent_Done,
     /* 140751 */   // Label 2150: @140751
     /* 140751 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(140805), // Rule ID 3382 //
     /* 140756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 140759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 140778 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 140781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140803 */     GIR_RootConstrainSelectedInstOperands,
     /* 140804 */     // GIR_Coverage, 3382,
     /* 140804 */     GIR_EraseRootFromParent_Done,
     /* 140805 */   // Label 2151: @140805
     /* 140805 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(140856), // Rule ID 3396 //
     /* 140810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 140813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 140832 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 140835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140854 */     GIR_RootConstrainSelectedInstOperands,
     /* 140855 */     // GIR_Coverage, 3396,
     /* 140855 */     GIR_EraseRootFromParent_Done,
     /* 140856 */   // Label 2152: @140856
     /* 140856 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(140907), // Rule ID 3397 //
     /* 140861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 140864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 140883 */     // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 140883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 140886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140905 */     GIR_RootConstrainSelectedInstOperands,
     /* 140906 */     // GIR_Coverage, 3397,
     /* 140906 */     GIR_EraseRootFromParent_Done,
     /* 140907 */   // Label 2153: @140907
     /* 140907 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(140958), // Rule ID 3398 //
     /* 140912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 140915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 140934 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 140934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 140937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 140949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 140952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140956 */     GIR_RootConstrainSelectedInstOperands,
     /* 140957 */     // GIR_Coverage, 3398,
     /* 140957 */     GIR_EraseRootFromParent_Done,
     /* 140958 */   // Label 2154: @140958
     /* 140958 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(141012), // Rule ID 3399 //
     /* 140963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 140966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 140970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 140978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 140985 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 140985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 140988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 140990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 140995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141010 */     GIR_RootConstrainSelectedInstOperands,
     /* 141011 */     // GIR_Coverage, 3399,
     /* 141011 */     GIR_EraseRootFromParent_Done,
     /* 141012 */   // Label 2155: @141012
     /* 141012 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(141059), // Rule ID 3385 //
     /* 141017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 141020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 141035 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 141038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141057 */     GIR_RootConstrainSelectedInstOperands,
     /* 141058 */     // GIR_Coverage, 3385,
     /* 141058 */     GIR_EraseRootFromParent_Done,
     /* 141059 */   // Label 2156: @141059
     /* 141059 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(141106), // Rule ID 3386 //
     /* 141064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 141067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141082 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 141082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 141085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141104 */     GIR_RootConstrainSelectedInstOperands,
     /* 141105 */     // GIR_Coverage, 3386,
     /* 141105 */     GIR_EraseRootFromParent_Done,
     /* 141106 */   // Label 2157: @141106
     /* 141106 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(141156), // Rule ID 3387 //
     /* 141111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 141114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141129 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 141132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141154 */     GIR_RootConstrainSelectedInstOperands,
     /* 141155 */     // GIR_Coverage, 3387,
     /* 141155 */     GIR_EraseRootFromParent_Done,
     /* 141156 */   // Label 2158: @141156
     /* 141156 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(141203), // Rule ID 3402 //
     /* 141161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 141164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 141179 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 141182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141201 */     GIR_RootConstrainSelectedInstOperands,
     /* 141202 */     // GIR_Coverage, 3402,
     /* 141202 */     GIR_EraseRootFromParent_Done,
     /* 141203 */   // Label 2159: @141203
     /* 141203 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(141250), // Rule ID 3403 //
     /* 141208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 141211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141226 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 141226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 141229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141248 */     GIR_RootConstrainSelectedInstOperands,
     /* 141249 */     // GIR_Coverage, 3403,
     /* 141249 */     GIR_EraseRootFromParent_Done,
     /* 141250 */   // Label 2160: @141250
     /* 141250 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(141300), // Rule ID 3404 //
     /* 141255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 141258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141273 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 141276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141298 */     GIR_RootConstrainSelectedInstOperands,
     /* 141299 */     // GIR_Coverage, 3404,
     /* 141299 */     GIR_EraseRootFromParent_Done,
     /* 141300 */   // Label 2161: @141300
     /* 141300 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(141344), // Rule ID 3390 //
     /* 141305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 141320 */     // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 141323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141342 */     GIR_RootConstrainSelectedInstOperands,
     /* 141343 */     // GIR_Coverage, 3390,
     /* 141343 */     GIR_EraseRootFromParent_Done,
     /* 141344 */   // Label 2162: @141344
     /* 141344 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(141391), // Rule ID 3391 //
     /* 141349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 141352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 141367 */     // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 141370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141389 */     GIR_RootConstrainSelectedInstOperands,
     /* 141390 */     // GIR_Coverage, 3391,
     /* 141390 */     GIR_EraseRootFromParent_Done,
     /* 141391 */   // Label 2163: @141391
     /* 141391 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(141438), // Rule ID 3392 //
     /* 141396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 141399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141414 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 141414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 141417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141436 */     GIR_RootConstrainSelectedInstOperands,
     /* 141437 */     // GIR_Coverage, 3392,
     /* 141437 */     GIR_EraseRootFromParent_Done,
     /* 141438 */   // Label 2164: @141438
     /* 141438 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(141488), // Rule ID 3393 //
     /* 141443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 141446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141461 */     // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 141464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141486 */     GIR_RootConstrainSelectedInstOperands,
     /* 141487 */     // GIR_Coverage, 3393,
     /* 141487 */     GIR_EraseRootFromParent_Done,
     /* 141488 */   // Label 2165: @141488
     /* 141488 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(141532), // Rule ID 3407 //
     /* 141493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 141508 */     // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 141511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141530 */     GIR_RootConstrainSelectedInstOperands,
     /* 141531 */     // GIR_Coverage, 3407,
     /* 141531 */     GIR_EraseRootFromParent_Done,
     /* 141532 */   // Label 2166: @141532
     /* 141532 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(141579), // Rule ID 3408 //
     /* 141537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 141540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 141555 */     // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 141558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141577 */     GIR_RootConstrainSelectedInstOperands,
     /* 141578 */     // GIR_Coverage, 3408,
     /* 141578 */     GIR_EraseRootFromParent_Done,
     /* 141579 */   // Label 2167: @141579
     /* 141579 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(141626), // Rule ID 3409 //
     /* 141584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 141587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141602 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 141602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 141605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141624 */     GIR_RootConstrainSelectedInstOperands,
     /* 141625 */     // GIR_Coverage, 3409,
     /* 141625 */     GIR_EraseRootFromParent_Done,
     /* 141626 */   // Label 2168: @141626
     /* 141626 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(141676), // Rule ID 3410 //
     /* 141631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 141634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 141649 */     // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 141652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141674 */     GIR_RootConstrainSelectedInstOperands,
     /* 141675 */     // GIR_Coverage, 3410,
     /* 141675 */     GIR_EraseRootFromParent_Done,
     /* 141676 */   // Label 2169: @141676
     /* 141676 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(141719), // Rule ID 3384 //
     /* 141681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 141684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141688 */     // MIs[0] sbase
     /* 141688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 141696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 141700 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 141703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141705 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 141707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141717 */     GIR_RootConstrainSelectedInstOperands,
     /* 141718 */     // GIR_Coverage, 3384,
     /* 141718 */     GIR_EraseRootFromParent_Done,
     /* 141719 */   // Label 2170: @141719
     /* 141719 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(141762), // Rule ID 3401 //
     /* 141724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 141727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141731 */     // MIs[0] sbase
     /* 141731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 141739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 141743 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 141746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141748 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 141750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141760 */     GIR_RootConstrainSelectedInstOperands,
     /* 141761 */     // GIR_Coverage, 3401,
     /* 141761 */     GIR_EraseRootFromParent_Done,
     /* 141762 */   // Label 2171: @141762
     /* 141762 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(141801), // Rule ID 3389 //
     /* 141767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 141770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141774 */     // MIs[0] sbase
     /* 141774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 141782 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 141785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141787 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 141789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141799 */     GIR_RootConstrainSelectedInstOperands,
     /* 141800 */     // GIR_Coverage, 3389,
     /* 141800 */     GIR_EraseRootFromParent_Done,
     /* 141801 */   // Label 2172: @141801
     /* 141801 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(141840), // Rule ID 3406 //
     /* 141806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 141809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141813 */     // MIs[0] sbase
     /* 141813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 141821 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 141824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141826 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 141828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141838 */     GIR_RootConstrainSelectedInstOperands,
     /* 141839 */     // GIR_Coverage, 3406,
     /* 141839 */     GIR_EraseRootFromParent_Done,
     /* 141840 */   // Label 2173: @141840
     /* 141840 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(141876), // Rule ID 3395 //
     /* 141845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141849 */     // MIs[0] sbase
     /* 141849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 141857 */     // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 141860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141862 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 141864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141874 */     GIR_RootConstrainSelectedInstOperands,
     /* 141875 */     // GIR_Coverage, 3395,
     /* 141875 */     GIR_EraseRootFromParent_Done,
     /* 141876 */   // Label 2174: @141876
     /* 141876 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(141912), // Rule ID 3412 //
     /* 141881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141885 */     // MIs[0] sbase
     /* 141885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 141893 */     // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 141893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 141896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141898 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 141900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141910 */     GIR_RootConstrainSelectedInstOperands,
     /* 141911 */     // GIR_Coverage, 3412,
     /* 141911 */     GIR_EraseRootFromParent_Done,
     /* 141912 */   // Label 2175: @141912
     /* 141912 */   GIM_Reject,
     /* 141913 */ // Label 2141: @141913
     /* 141913 */ GIM_Reject,
     /* 141914 */ // Label 1020: @141914
     /* 141914 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(143565),
     /* 141919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141922 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141926 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
     /* 141930 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(141986), // Rule ID 3451 //
     /* 141935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 141938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 141950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 141957 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 141957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 141960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 141962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 141967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 141972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 141977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141984 */     GIR_RootConstrainSelectedInstOperands,
     /* 141985 */     // GIR_Coverage, 3451,
     /* 141985 */     GIR_EraseRootFromParent_Done,
     /* 141986 */   // Label 2177: @141986
     /* 141986 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(142042), // Rule ID 3468 //
     /* 141991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 141994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 141998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142013 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 142016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142040 */     GIR_RootConstrainSelectedInstOperands,
     /* 142041 */     // GIR_Coverage, 3468,
     /* 142041 */     GIR_EraseRootFromParent_Done,
     /* 142042 */   // Label 2178: @142042
     /* 142042 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(142094), // Rule ID 3456 //
     /* 142047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 142050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142065 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 142068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142092 */     GIR_RootConstrainSelectedInstOperands,
     /* 142093 */     // GIR_Coverage, 3456,
     /* 142093 */     GIR_EraseRootFromParent_Done,
     /* 142094 */   // Label 2179: @142094
     /* 142094 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(142146), // Rule ID 3473 //
     /* 142099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 142102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142117 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 142120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142144 */     GIR_RootConstrainSelectedInstOperands,
     /* 142145 */     // GIR_Coverage, 3473,
     /* 142145 */     GIR_EraseRootFromParent_Done,
     /* 142146 */   // Label 2180: @142146
     /* 142146 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(142198), // Rule ID 3462 //
     /* 142151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 142154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142169 */     // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 142172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142196 */     GIR_RootConstrainSelectedInstOperands,
     /* 142197 */     // GIR_Coverage, 3462,
     /* 142197 */     GIR_EraseRootFromParent_Done,
     /* 142198 */   // Label 2181: @142198
     /* 142198 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(142250), // Rule ID 3479 //
     /* 142203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 142206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 142221 */     // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 142224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 142241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142248 */     GIR_RootConstrainSelectedInstOperands,
     /* 142249 */     // GIR_Coverage, 3479,
     /* 142249 */     GIR_EraseRootFromParent_Done,
     /* 142250 */   // Label 2182: @142250
     /* 142250 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(142301), // Rule ID 3447 //
     /* 142255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 142258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142277 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 142280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142299 */     GIR_RootConstrainSelectedInstOperands,
     /* 142300 */     // GIR_Coverage, 3447,
     /* 142300 */     GIR_EraseRootFromParent_Done,
     /* 142301 */   // Label 2183: @142301
     /* 142301 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(142352), // Rule ID 3448 //
     /* 142306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 142309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 142328 */     // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 142331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142350 */     GIR_RootConstrainSelectedInstOperands,
     /* 142351 */     // GIR_Coverage, 3448,
     /* 142351 */     GIR_EraseRootFromParent_Done,
     /* 142352 */   // Label 2184: @142352
     /* 142352 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(142403), // Rule ID 3449 //
     /* 142357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 142360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142379 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 142379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 142382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142401 */     GIR_RootConstrainSelectedInstOperands,
     /* 142402 */     // GIR_Coverage, 3449,
     /* 142402 */     GIR_EraseRootFromParent_Done,
     /* 142403 */   // Label 2185: @142403
     /* 142403 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(142457), // Rule ID 3450 //
     /* 142408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 142411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142430 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 142433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142455 */     GIR_RootConstrainSelectedInstOperands,
     /* 142456 */     // GIR_Coverage, 3450,
     /* 142456 */     GIR_EraseRootFromParent_Done,
     /* 142457 */   // Label 2186: @142457
     /* 142457 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(142508), // Rule ID 3464 //
     /* 142462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 142465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142484 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 142487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142506 */     GIR_RootConstrainSelectedInstOperands,
     /* 142507 */     // GIR_Coverage, 3464,
     /* 142507 */     GIR_EraseRootFromParent_Done,
     /* 142508 */   // Label 2187: @142508
     /* 142508 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(142559), // Rule ID 3465 //
     /* 142513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
     /* 142516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 142535 */     // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 142538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142557 */     GIR_RootConstrainSelectedInstOperands,
     /* 142558 */     // GIR_Coverage, 3465,
     /* 142558 */     GIR_EraseRootFromParent_Done,
     /* 142559 */   // Label 2188: @142559
     /* 142559 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(142610), // Rule ID 3466 //
     /* 142564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 142567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142586 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 142586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 142589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142608 */     GIR_RootConstrainSelectedInstOperands,
     /* 142609 */     // GIR_Coverage, 3466,
     /* 142609 */     GIR_EraseRootFromParent_Done,
     /* 142610 */   // Label 2189: @142610
     /* 142610 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(142664), // Rule ID 3467 //
     /* 142615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 142618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 142630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142637 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 142640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142662 */     GIR_RootConstrainSelectedInstOperands,
     /* 142663 */     // GIR_Coverage, 3467,
     /* 142663 */     GIR_EraseRootFromParent_Done,
     /* 142664 */   // Label 2190: @142664
     /* 142664 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(142711), // Rule ID 3453 //
     /* 142669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 142672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142687 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 142690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142709 */     GIR_RootConstrainSelectedInstOperands,
     /* 142710 */     // GIR_Coverage, 3453,
     /* 142710 */     GIR_EraseRootFromParent_Done,
     /* 142711 */   // Label 2191: @142711
     /* 142711 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(142758), // Rule ID 3454 //
     /* 142716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 142719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142734 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 142734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 142737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142756 */     GIR_RootConstrainSelectedInstOperands,
     /* 142757 */     // GIR_Coverage, 3454,
     /* 142757 */     GIR_EraseRootFromParent_Done,
     /* 142758 */   // Label 2192: @142758
     /* 142758 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(142808), // Rule ID 3455 //
     /* 142763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 142766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142781 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 142784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142806 */     GIR_RootConstrainSelectedInstOperands,
     /* 142807 */     // GIR_Coverage, 3455,
     /* 142807 */     GIR_EraseRootFromParent_Done,
     /* 142808 */   // Label 2193: @142808
     /* 142808 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(142855), // Rule ID 3470 //
     /* 142813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 142816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142831 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 142834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142853 */     GIR_RootConstrainSelectedInstOperands,
     /* 142854 */     // GIR_Coverage, 3470,
     /* 142854 */     GIR_EraseRootFromParent_Done,
     /* 142855 */   // Label 2194: @142855
     /* 142855 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(142902), // Rule ID 3471 //
     /* 142860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
     /* 142863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142878 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 142878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
     /* 142881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142900 */     GIR_RootConstrainSelectedInstOperands,
     /* 142901 */     // GIR_Coverage, 3471,
     /* 142901 */     GIR_EraseRootFromParent_Done,
     /* 142902 */   // Label 2195: @142902
     /* 142902 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(142952), // Rule ID 3472 //
     /* 142907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
     /* 142910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 142925 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 142925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
     /* 142928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 142940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142950 */     GIR_RootConstrainSelectedInstOperands,
     /* 142951 */     // GIR_Coverage, 3472,
     /* 142951 */     GIR_EraseRootFromParent_Done,
     /* 142952 */   // Label 2196: @142952
     /* 142952 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(142996), // Rule ID 3458 //
     /* 142957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 142961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 142972 */     // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 142972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 142975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 142977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 142982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142994 */     GIR_RootConstrainSelectedInstOperands,
     /* 142995 */     // GIR_Coverage, 3458,
     /* 142995 */     GIR_EraseRootFromParent_Done,
     /* 142996 */   // Label 2197: @142996
     /* 142996 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(143043), // Rule ID 3459 //
     /* 143001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 143004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 143019 */     // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 143022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 143029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143041 */     GIR_RootConstrainSelectedInstOperands,
     /* 143042 */     // GIR_Coverage, 3459,
     /* 143042 */     GIR_EraseRootFromParent_Done,
     /* 143043 */   // Label 2198: @143043
     /* 143043 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(143090), // Rule ID 3460 //
     /* 143048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 143051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 143066 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 143066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 143069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 143076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143088 */     GIR_RootConstrainSelectedInstOperands,
     /* 143089 */     // GIR_Coverage, 3460,
     /* 143089 */     GIR_EraseRootFromParent_Done,
     /* 143090 */   // Label 2199: @143090
     /* 143090 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(143140), // Rule ID 3461 //
     /* 143095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 143098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 143113 */     // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 143116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 143123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143138 */     GIR_RootConstrainSelectedInstOperands,
     /* 143139 */     // GIR_Coverage, 3461,
     /* 143139 */     GIR_EraseRootFromParent_Done,
     /* 143140 */   // Label 2200: @143140
     /* 143140 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(143184), // Rule ID 3475 //
     /* 143145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 143160 */     // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 143163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 143170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143182 */     GIR_RootConstrainSelectedInstOperands,
     /* 143183 */     // GIR_Coverage, 3475,
     /* 143183 */     GIR_EraseRootFromParent_Done,
     /* 143184 */   // Label 2201: @143184
     /* 143184 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(143231), // Rule ID 3476 //
     /* 143189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 143192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
     /* 143207 */     // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
     /* 143210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 143217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143229 */     GIR_RootConstrainSelectedInstOperands,
     /* 143230 */     // GIR_Coverage, 3476,
     /* 143230 */     GIR_EraseRootFromParent_Done,
     /* 143231 */   // Label 2202: @143231
     /* 143231 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(143278), // Rule ID 3477 //
     /* 143236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 143239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 143254 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
     /* 143254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
     /* 143257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 143264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143276 */     GIR_RootConstrainSelectedInstOperands,
     /* 143277 */     // GIR_Coverage, 3477,
     /* 143277 */     GIR_EraseRootFromParent_Done,
     /* 143278 */   // Label 2203: @143278
     /* 143278 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(143328), // Rule ID 3478 //
     /* 143283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 143286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 143301 */     // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
     /* 143304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 143311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143326 */     GIR_RootConstrainSelectedInstOperands,
     /* 143327 */     // GIR_Coverage, 3478,
     /* 143327 */     GIR_EraseRootFromParent_Done,
     /* 143328 */   // Label 2204: @143328
     /* 143328 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(143371), // Rule ID 3452 //
     /* 143333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 143336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143340 */     // MIs[0] sbase
     /* 143340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 143348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 143352 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 143355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143357 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 143359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143369 */     GIR_RootConstrainSelectedInstOperands,
     /* 143370 */     // GIR_Coverage, 3452,
     /* 143370 */     GIR_EraseRootFromParent_Done,
     /* 143371 */   // Label 2205: @143371
     /* 143371 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(143414), // Rule ID 3469 //
     /* 143376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 143379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143383 */     // MIs[0] sbase
     /* 143383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 143391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
     /* 143395 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 143398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143400 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 143402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143412 */     GIR_RootConstrainSelectedInstOperands,
     /* 143413 */     // GIR_Coverage, 3469,
     /* 143413 */     GIR_EraseRootFromParent_Done,
     /* 143414 */   // Label 2206: @143414
     /* 143414 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(143453), // Rule ID 3457 //
     /* 143419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 143422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143426 */     // MIs[0] sbase
     /* 143426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 143434 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 143437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143439 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 143441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143451 */     GIR_RootConstrainSelectedInstOperands,
     /* 143452 */     // GIR_Coverage, 3457,
     /* 143452 */     GIR_EraseRootFromParent_Done,
     /* 143453 */   // Label 2207: @143453
     /* 143453 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(143492), // Rule ID 3474 //
     /* 143458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
     /* 143461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143465 */     // MIs[0] sbase
     /* 143465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 143473 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
     /* 143476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143478 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 143480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143490 */     GIR_RootConstrainSelectedInstOperands,
     /* 143491 */     // GIR_Coverage, 3474,
     /* 143491 */     GIR_EraseRootFromParent_Done,
     /* 143492 */   // Label 2208: @143492
     /* 143492 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(143528), // Rule ID 3463 //
     /* 143497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143501 */     // MIs[0] sbase
     /* 143501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 143509 */     // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 143512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143514 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 143516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143526 */     GIR_RootConstrainSelectedInstOperands,
     /* 143527 */     // GIR_Coverage, 3463,
     /* 143527 */     GIR_EraseRootFromParent_Done,
     /* 143528 */   // Label 2209: @143528
     /* 143528 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(143564), // Rule ID 3480 //
     /* 143533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 143537 */     // MIs[0] sbase
     /* 143537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 143545 */     // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 143545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
     /* 143548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 143550 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 143552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143562 */     GIR_RootConstrainSelectedInstOperands,
     /* 143563 */     // GIR_Coverage, 3480,
     /* 143563 */     GIR_EraseRootFromParent_Done,
     /* 143564 */   // Label 2210: @143564
     /* 143564 */   GIM_Reject,
     /* 143565 */ // Label 2176: @143565
     /* 143565 */ GIM_Reject,
     /* 143566 */ // Label 1021: @143566
     /* 143566 */ GIM_Reject,
     /* 143567 */ // Label 15: @143567
     /* 143567 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2213*/ GIMT_Encode4(150632),
     /* 143578 */ /*GILLT_s16*//*Label 2211*/ GIMT_Encode4(143586),
     /* 143582 */ /*GILLT_s32*//*Label 2212*/ GIMT_Encode4(146024),
     /* 143586 */ // Label 2211: @143586
     /* 143586 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(143656), // Rule ID 6463 //
     /* 143591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 143594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143597 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143604 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143617 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 143624 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 143624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 143627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143654 */   GIR_RootConstrainSelectedInstOperands,
     /* 143655 */   // GIR_Coverage, 6463,
     /* 143655 */   GIR_EraseRootFromParent_Done,
     /* 143656 */ // Label 2214: @143656
     /* 143656 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(143726), // Rule ID 6465 //
     /* 143661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 143664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143674 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 143694 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 143694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 143697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 143699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 143704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 143709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143724 */   GIR_RootConstrainSelectedInstOperands,
     /* 143725 */   // GIR_Coverage, 6465,
     /* 143725 */   GIR_EraseRootFromParent_Done,
     /* 143726 */ // Label 2215: @143726
     /* 143726 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(143793), // Rule ID 4214 //
     /* 143731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 143734 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143737 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143744 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143753 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143757 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 143764 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 143767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 143779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143791 */   GIR_RootConstrainSelectedInstOperands,
     /* 143792 */   // GIR_Coverage, 4214,
     /* 143792 */   GIR_EraseRootFromParent_Done,
     /* 143793 */ // Label 2216: @143793
     /* 143793 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(143860), // Rule ID 4229 //
     /* 143798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 143801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143804 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143811 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 143831 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 143834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 143846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143858 */   GIR_RootConstrainSelectedInstOperands,
     /* 143859 */   // GIR_Coverage, 4229,
     /* 143859 */   GIR_EraseRootFromParent_Done,
     /* 143860 */ // Label 2217: @143860
     /* 143860 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(143927), // Rule ID 4244 //
     /* 143865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 143868 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143871 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143878 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 143887 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 143898 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 143898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_SVS_t16),
     /* 143901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 143908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 143913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 143918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143925 */   GIR_RootConstrainSelectedInstOperands,
     /* 143926 */   // GIR_Coverage, 4244,
     /* 143926 */   GIR_EraseRootFromParent_Done,
     /* 143927 */ // Label 2218: @143927
     /* 143927 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(143989), // Rule ID 4213 //
     /* 143932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 143935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143938 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143945 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 143950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 143954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143958 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 143965 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 143965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 143968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 143970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 143975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143987 */   GIR_RootConstrainSelectedInstOperands,
     /* 143988 */   // GIR_Coverage, 4213,
     /* 143988 */   GIR_EraseRootFromParent_Done,
     /* 143989 */ // Label 2219: @143989
     /* 143989 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(144051), // Rule ID 4228 //
     /* 143994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 143997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144000 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144007 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 144027 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 144027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 144030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 144037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144049 */   GIR_RootConstrainSelectedInstOperands,
     /* 144050 */   // GIR_Coverage, 4228,
     /* 144050 */   GIR_EraseRootFromParent_Done,
     /* 144051 */ // Label 2220: @144051
     /* 144051 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(144113), // Rule ID 4243 //
     /* 144056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 144059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144069 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 144078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 144089 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 144089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_SADDR_t16),
     /* 144092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 144099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144111 */   GIR_RootConstrainSelectedInstOperands,
     /* 144112 */   // GIR_Coverage, 4243,
     /* 144112 */   GIR_EraseRootFromParent_Done,
     /* 144113 */ // Label 2221: @144113
     /* 144113 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(144175), // Rule ID 4212 //
     /* 144118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 144121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144124 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144131 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144144 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 144151 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 144151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 144154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 144161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144169 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144173 */   GIR_RootConstrainSelectedInstOperands,
     /* 144174 */   // GIR_Coverage, 4212,
     /* 144174 */   GIR_EraseRootFromParent_Done,
     /* 144175 */ // Label 2222: @144175
     /* 144175 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(144237), // Rule ID 4227 //
     /* 144180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 144183 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144186 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144193 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144202 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144206 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 144213 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 144213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 144216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 144223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144235 */   GIR_RootConstrainSelectedInstOperands,
     /* 144236 */   // GIR_Coverage, 4227,
     /* 144236 */   GIR_EraseRootFromParent_Done,
     /* 144237 */ // Label 2223: @144237
     /* 144237 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(144299), // Rule ID 4242 //
     /* 144242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 144245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144255 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 144264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 144275 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 144275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_D16_t16),
     /* 144278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 144285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144297 */   GIR_RootConstrainSelectedInstOperands,
     /* 144298 */   // GIR_Coverage, 4242,
     /* 144298 */   GIR_EraseRootFromParent_Done,
     /* 144299 */ // Label 2224: @144299
     /* 144299 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(144374), // Rule ID 6462 //
     /* 144304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 144307 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144310 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144317 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144337 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 144340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144372 */   GIR_RootConstrainSelectedInstOperands,
     /* 144373 */   // GIR_Coverage, 6462,
     /* 144373 */   GIR_EraseRootFromParent_Done,
     /* 144374 */ // Label 2225: @144374
     /* 144374 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(144449), // Rule ID 6464 //
     /* 144379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 144382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144385 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144392 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 144397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 144412 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 144412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 144415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 144422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 144432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 144437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144447 */   GIR_RootConstrainSelectedInstOperands,
     /* 144448 */   // GIR_Coverage, 6464,
     /* 144448 */   GIR_EraseRootFromParent_Done,
     /* 144449 */ // Label 2226: @144449
     /* 144449 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(144520), // Rule ID 6434 //
     /* 144454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 144457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144460 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144467 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144481 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144488 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 144491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144518 */   GIR_RootConstrainSelectedInstOperands,
     /* 144519 */   // GIR_Coverage, 6434,
     /* 144519 */   GIR_EraseRootFromParent_Done,
     /* 144520 */ // Label 2227: @144520
     /* 144520 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(144591), // Rule ID 6435 //
     /* 144525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 144528 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144538 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144548 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144552 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144559 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 144562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144589 */   GIR_RootConstrainSelectedInstOperands,
     /* 144590 */   // GIR_Coverage, 6435,
     /* 144590 */   GIR_EraseRootFromParent_Done,
     /* 144591 */ // Label 2228: @144591
     /* 144591 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(144663), // Rule ID 6440 //
     /* 144596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 144599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144602 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144609 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144631 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 144634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144657 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144661 */   GIR_RootConstrainSelectedInstOperands,
     /* 144662 */   // GIR_Coverage, 6440,
     /* 144662 */   GIR_EraseRootFromParent_Done,
     /* 144663 */ // Label 2229: @144663
     /* 144663 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(144735), // Rule ID 6441 //
     /* 144668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 144671 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144681 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 144688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 144703 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 144703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 144706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 144708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 144713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 144718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 144723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144733 */   GIR_RootConstrainSelectedInstOperands,
     /* 144734 */   // GIR_Coverage, 6441,
     /* 144734 */   GIR_EraseRootFromParent_Done,
     /* 144735 */ // Label 2230: @144735
     /* 144735 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(144797), // Rule ID 7930 //
     /* 144740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 144743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144753 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 144758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 144773 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 144773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 144776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 144783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144795 */   GIR_RootConstrainSelectedInstOperands,
     /* 144796 */   // GIR_Coverage, 7930,
     /* 144796 */   GIR_EraseRootFromParent_Done,
     /* 144797 */ // Label 2231: @144797
     /* 144797 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(144859), // Rule ID 7931 //
     /* 144802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 144805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144808 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144815 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 144820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144824 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 144835 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 144835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 144838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 144845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144857 */   GIR_RootConstrainSelectedInstOperands,
     /* 144858 */   // GIR_Coverage, 7931,
     /* 144858 */   GIR_EraseRootFromParent_Done,
     /* 144859 */ // Label 2232: @144859
     /* 144859 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(144921), // Rule ID 7932 //
     /* 144864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 144867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144877 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 144882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 144886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 144897 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 144897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_t16),
     /* 144900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 144907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144919 */   GIR_RootConstrainSelectedInstOperands,
     /* 144920 */   // GIR_Coverage, 7932,
     /* 144920 */   GIR_EraseRootFromParent_Done,
     /* 144921 */ // Label 2233: @144921
     /* 144921 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(144983), // Rule ID 7945 //
     /* 144926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 144929 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144932 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144939 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 144944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 144948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 144952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 144959 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 144959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 144962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 144964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 144969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 144974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144981 */   GIR_RootConstrainSelectedInstOperands,
     /* 144982 */   // GIR_Coverage, 7945,
     /* 144982 */   GIR_EraseRootFromParent_Done,
     /* 144983 */ // Label 2234: @144983
     /* 144983 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(145045), // Rule ID 7986 //
     /* 144988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 144991 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 144994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145001 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145021 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 145024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145043 */   GIR_RootConstrainSelectedInstOperands,
     /* 145044 */   // GIR_Coverage, 7986,
     /* 145044 */   GIR_EraseRootFromParent_Done,
     /* 145045 */ // Label 2235: @145045
     /* 145045 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(145107), // Rule ID 7987 //
     /* 145050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 145053 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145056 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145063 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145072 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145083 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 145086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145105 */   GIR_RootConstrainSelectedInstOperands,
     /* 145106 */   // GIR_Coverage, 7987,
     /* 145106 */   GIR_EraseRootFromParent_Done,
     /* 145107 */ // Label 2236: @145107
     /* 145107 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(145169), // Rule ID 7988 //
     /* 145112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 145115 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145118 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145125 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145145 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 145148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145163 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145167 */   GIR_RootConstrainSelectedInstOperands,
     /* 145168 */   // GIR_Coverage, 7988,
     /* 145168 */   GIR_EraseRootFromParent_Done,
     /* 145169 */ // Label 2237: @145169
     /* 145169 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(145231), // Rule ID 7989 //
     /* 145174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 145177 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145180 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145187 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 145192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 145196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 145207 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 145207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_t16),
     /* 145210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 145217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145229 */   GIR_RootConstrainSelectedInstOperands,
     /* 145230 */   // GIR_Coverage, 7989,
     /* 145230 */   GIR_EraseRootFromParent_Done,
     /* 145231 */ // Label 2238: @145231
     /* 145231 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(145300), // Rule ID 3824 //
     /* 145236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 145239 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145242 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145249 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145264 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 145271 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 145271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 145274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 145281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 145286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145298 */   GIR_RootConstrainSelectedInstOperands,
     /* 145299 */   // GIR_Coverage, 3824,
     /* 145299 */   GIR_EraseRootFromParent_Done,
     /* 145300 */ // Label 2239: @145300
     /* 145300 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(145369), // Rule ID 3842 //
     /* 145305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 145308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145311 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145318 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145329 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145333 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 145340 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 145340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 145343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 145350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 145355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145367 */   GIR_RootConstrainSelectedInstOperands,
     /* 145368 */   // GIR_Coverage, 3842,
     /* 145368 */   GIR_EraseRootFromParent_Done,
     /* 145369 */ // Label 2240: @145369
     /* 145369 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(145438), // Rule ID 3854 //
     /* 145374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 145377 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145387 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145398 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145402 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 145409 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 145409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 145412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 145419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 145424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145436 */   GIR_RootConstrainSelectedInstOperands,
     /* 145437 */   // GIR_Coverage, 3854,
     /* 145437 */   GIR_EraseRootFromParent_Done,
     /* 145438 */ // Label 2241: @145438
     /* 145438 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(145507), // Rule ID 3864 //
     /* 145443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 145446 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145456 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 145467 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 145478 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 145478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_D16_SADDR_t16),
     /* 145481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 145488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 145493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 145498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145505 */   GIR_RootConstrainSelectedInstOperands,
     /* 145506 */   // GIR_Coverage, 3864,
     /* 145506 */   GIR_EraseRootFromParent_Done,
     /* 145507 */ // Label 2242: @145507
     /* 145507 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(145571), // Rule ID 3823 //
     /* 145512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 145515 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145518 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145525 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 145547 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 145547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 145550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 145557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145569 */   GIR_RootConstrainSelectedInstOperands,
     /* 145570 */   // GIR_Coverage, 3823,
     /* 145570 */   GIR_EraseRootFromParent_Done,
     /* 145571 */ // Label 2243: @145571
     /* 145571 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(145635), // Rule ID 3841 //
     /* 145576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 145579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145582 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145589 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145604 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 145611 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 145611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 145614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 145621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145629 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145633 */   GIR_RootConstrainSelectedInstOperands,
     /* 145634 */   // GIR_Coverage, 3841,
     /* 145634 */   GIR_EraseRootFromParent_Done,
     /* 145635 */ // Label 2244: @145635
     /* 145635 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(145699), // Rule ID 3853 //
     /* 145640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 145643 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145653 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 145675 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 145675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 145678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 145685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145697 */   GIR_RootConstrainSelectedInstOperands,
     /* 145698 */   // GIR_Coverage, 3853,
     /* 145698 */   GIR_EraseRootFromParent_Done,
     /* 145699 */ // Label 2245: @145699
     /* 145699 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(145763), // Rule ID 3863 //
     /* 145704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 145707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145710 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145717 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 145728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145732 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 145739 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 145739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_D16_t16),
     /* 145742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 145749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145761 */   GIR_RootConstrainSelectedInstOperands,
     /* 145762 */   // GIR_Coverage, 3863,
     /* 145762 */   GIR_EraseRootFromParent_Done,
     /* 145763 */ // Label 2246: @145763
     /* 145763 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(145828), // Rule ID 3592 //
     /* 145768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 145771 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 145774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145781 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 145804 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 145804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 145807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 145814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145826 */   GIR_RootConstrainSelectedInstOperands,
     /* 145827 */   // GIR_Coverage, 3592,
     /* 145827 */   GIR_EraseRootFromParent_Done,
     /* 145828 */ // Label 2247: @145828
     /* 145828 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(145893), // Rule ID 3600 //
     /* 145833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 145836 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145839 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145846 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 145869 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 145869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 145872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 145879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145891 */   GIR_RootConstrainSelectedInstOperands,
     /* 145892 */   // GIR_Coverage, 3600,
     /* 145892 */   GIR_EraseRootFromParent_Done,
     /* 145893 */ // Label 2248: @145893
     /* 145893 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(145958), // Rule ID 3606 //
     /* 145898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 145901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145911 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 145923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 145934 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 145934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 145937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 145939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 145944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 145949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145952 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145956 */   GIR_RootConstrainSelectedInstOperands,
     /* 145957 */   // GIR_Coverage, 3606,
     /* 145957 */   GIR_EraseRootFromParent_Done,
     /* 145958 */ // Label 2249: @145958
     /* 145958 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(146023), // Rule ID 3612 //
     /* 145963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 145966 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145976 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 145984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 145988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 145992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 145999 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 145999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE_D16_t16),
     /* 146002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146021 */   GIR_RootConstrainSelectedInstOperands,
     /* 146022 */   // GIR_Coverage, 3612,
     /* 146022 */   GIR_EraseRootFromParent_Done,
     /* 146023 */ // Label 2250: @146023
     /* 146023 */ GIM_Reject,
     /* 146024 */ // Label 2212: @146024
     /* 146024 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(146090), // Rule ID 2918 //
     /* 146029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146032 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146035 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146050 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 146054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 146061 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
     /* 146064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 146071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146088 */   GIR_RootConstrainSelectedInstOperands,
     /* 146089 */   // GIR_Coverage, 2918,
     /* 146089 */   GIR_EraseRootFromParent_Done,
     /* 146090 */ // Label 2251: @146090
     /* 146090 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(146156), // Rule ID 2930 //
     /* 146095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146116 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 146120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 146127 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
     /* 146130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 146137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146154 */   GIR_RootConstrainSelectedInstOperands,
     /* 146155 */   // GIR_Coverage, 2930,
     /* 146155 */   GIR_EraseRootFromParent_Done,
     /* 146156 */ // Label 2252: @146156
     /* 146156 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(146217), // Rule ID 2916 //
     /* 146161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146167 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146178 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146182 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 146186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 146193 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
     /* 146196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 146203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146215 */   GIR_RootConstrainSelectedInstOperands,
     /* 146216 */   // GIR_Coverage, 2916,
     /* 146216 */   GIR_EraseRootFromParent_Done,
     /* 146217 */ // Label 2253: @146217
     /* 146217 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(146281), // Rule ID 2917 //
     /* 146222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146243 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 146247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 146254 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 146254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
     /* 146257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 146264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146279 */   GIR_RootConstrainSelectedInstOperands,
     /* 146280 */   // GIR_Coverage, 2917,
     /* 146280 */   GIR_EraseRootFromParent_Done,
     /* 146281 */ // Label 2254: @146281
     /* 146281 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(146342), // Rule ID 2928 //
     /* 146286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146292 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146303 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146307 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 146311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 146318 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
     /* 146321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 146328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146336 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146340 */   GIR_RootConstrainSelectedInstOperands,
     /* 146341 */   // GIR_Coverage, 2928,
     /* 146341 */   GIR_EraseRootFromParent_Done,
     /* 146342 */ // Label 2255: @146342
     /* 146342 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(146406), // Rule ID 2929 //
     /* 146347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146368 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 146372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 146379 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 146379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
     /* 146382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 146389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146400 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146404 */   GIR_RootConstrainSelectedInstOperands,
     /* 146405 */   // GIR_Coverage, 2929,
     /* 146405 */   GIR_EraseRootFromParent_Done,
     /* 146406 */ // Label 2256: @146406
     /* 146406 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(146459), // Rule ID 2919 //
     /* 146411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146417 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146428 */   // MIs[0] sbase
     /* 146428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 146436 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
     /* 146440 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 146440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
     /* 146443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146445 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 146447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146457 */   GIR_RootConstrainSelectedInstOperands,
     /* 146458 */   // GIR_Coverage, 2919,
     /* 146458 */   GIR_EraseRootFromParent_Done,
     /* 146459 */ // Label 2257: @146459
     /* 146459 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(146512), // Rule ID 2931 //
     /* 146464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 146467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 146481 */   // MIs[0] sbase
     /* 146481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 146489 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
     /* 146493 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 146493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
     /* 146496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 146498 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 146500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146506 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146510 */   GIR_RootConstrainSelectedInstOperands,
     /* 146511 */   // GIR_Coverage, 2931,
     /* 146511 */   GIR_EraseRootFromParent_Done,
     /* 146512 */ // Label 2258: @146512
     /* 146512 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(146582), // Rule ID 6449 //
     /* 146517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 146520 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146530 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 146550 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 146550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 146553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 146555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 146560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146580 */   GIR_RootConstrainSelectedInstOperands,
     /* 146581 */   // GIR_Coverage, 6449,
     /* 146581 */   GIR_EraseRootFromParent_Done,
     /* 146582 */ // Label 2259: @146582
     /* 146582 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(146652), // Rule ID 6453 //
     /* 146587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 146590 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146600 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 146620 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 146620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 146623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 146625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 146630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146650 */   GIR_RootConstrainSelectedInstOperands,
     /* 146651 */   // GIR_Coverage, 6453,
     /* 146651 */   GIR_EraseRootFromParent_Done,
     /* 146652 */ // Label 2260: @146652
     /* 146652 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(146722), // Rule ID 6475 //
     /* 146657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 146660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146670 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 146690 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 146690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 146693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 146695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 146700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146720 */   GIR_RootConstrainSelectedInstOperands,
     /* 146721 */   // GIR_Coverage, 6475,
     /* 146721 */   GIR_EraseRootFromParent_Done,
     /* 146722 */ // Label 2261: @146722
     /* 146722 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(146792), // Rule ID 6477 //
     /* 146727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 146730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146733 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146740 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146749 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146753 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 146760 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 146760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 146763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 146765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 146770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 146775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146790 */   GIR_RootConstrainSelectedInstOperands,
     /* 146791 */   // GIR_Coverage, 6477,
     /* 146791 */   GIR_EraseRootFromParent_Done,
     /* 146792 */ // Label 2262: @146792
     /* 146792 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(146859), // Rule ID 4196 //
     /* 146797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 146800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146810 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 146830 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
     /* 146833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 146845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146857 */   GIR_RootConstrainSelectedInstOperands,
     /* 146858 */   // GIR_Coverage, 4196,
     /* 146858 */   GIR_EraseRootFromParent_Done,
     /* 146859 */ // Label 2263: @146859
     /* 146859 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(146926), // Rule ID 4205 //
     /* 146864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 146867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146877 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 146897 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 146897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SVS),
     /* 146900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 146907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 146912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 146917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146924 */   GIR_RootConstrainSelectedInstOperands,
     /* 146925 */   // GIR_Coverage, 4205,
     /* 146925 */   GIR_EraseRootFromParent_Done,
     /* 146926 */ // Label 2264: @146926
     /* 146926 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(146988), // Rule ID 4195 //
     /* 146931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 146934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146944 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 146949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 146953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 146957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 146964 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 146964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
     /* 146967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 146969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 146974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 146979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146982 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146986 */   GIR_RootConstrainSelectedInstOperands,
     /* 146987 */   // GIR_Coverage, 4195,
     /* 146987 */   GIR_EraseRootFromParent_Done,
     /* 146988 */ // Label 2265: @146988
     /* 146988 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(147050), // Rule ID 4204 //
     /* 146993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 146996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147006 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147019 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 147026 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 147026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SADDR),
     /* 147029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 147036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147048 */   GIR_RootConstrainSelectedInstOperands,
     /* 147049 */   // GIR_Coverage, 4204,
     /* 147049 */   GIR_EraseRootFromParent_Done,
     /* 147050 */ // Label 2266: @147050
     /* 147050 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(147112), // Rule ID 4194 //
     /* 147055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 147058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147061 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147068 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147081 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147088 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
     /* 147091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147106 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147110 */   GIR_RootConstrainSelectedInstOperands,
     /* 147111 */   // GIR_Coverage, 4194,
     /* 147111 */   GIR_EraseRootFromParent_Done,
     /* 147112 */ // Label 2267: @147112
     /* 147112 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(147174), // Rule ID 4203 //
     /* 147117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 147120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147123 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147130 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 147135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147139 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147143 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 147150 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 147150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT),
     /* 147153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 147155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 147160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 147165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147168 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147172 */   GIR_RootConstrainSelectedInstOperands,
     /* 147173 */   // GIR_Coverage, 4203,
     /* 147173 */   GIR_EraseRootFromParent_Done,
     /* 147174 */ // Label 2268: @147174
     /* 147174 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(147251), // Rule ID 4479 //
     /* 147179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 147182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147192 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147203 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147207 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147214 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 147217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147234 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147249 */   GIR_RootConstrainSelectedInstOperands,
     /* 147250 */   // GIR_Coverage, 4479,
     /* 147250 */   GIR_EraseRootFromParent_Done,
     /* 147251 */ // Label 2269: @147251
     /* 147251 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(147325), // Rule ID 4481 //
     /* 147256 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147259 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147266 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147288 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 147291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147323 */   GIR_RootConstrainSelectedInstOperands,
     /* 147324 */   // GIR_Coverage, 4481,
     /* 147324 */   GIR_EraseRootFromParent_Done,
     /* 147325 */ // Label 2270: @147325
     /* 147325 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(147402), // Rule ID 4483 //
     /* 147330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 147333 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147343 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147365 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 147368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147400 */   GIR_RootConstrainSelectedInstOperands,
     /* 147401 */   // GIR_Coverage, 4483,
     /* 147401 */   GIR_EraseRootFromParent_Done,
     /* 147402 */ // Label 2271: @147402
     /* 147402 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(147476), // Rule ID 4485 //
     /* 147407 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147410 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147417 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147428 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147432 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147439 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 147442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147474 */   GIR_RootConstrainSelectedInstOperands,
     /* 147475 */   // GIR_Coverage, 4485,
     /* 147475 */   GIR_EraseRootFromParent_Done,
     /* 147476 */ // Label 2272: @147476
     /* 147476 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(147553), // Rule ID 4487 //
     /* 147481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 147484 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147487 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147494 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147516 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 147519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147547 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147551 */   GIR_RootConstrainSelectedInstOperands,
     /* 147552 */   // GIR_Coverage, 4487,
     /* 147552 */   GIR_EraseRootFromParent_Done,
     /* 147553 */ // Label 2273: @147553
     /* 147553 */ GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(147627), // Rule ID 4489 //
     /* 147558 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147561 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147568 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147583 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147590 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
     /* 147593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147621 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147625 */   GIR_RootConstrainSelectedInstOperands,
     /* 147626 */   // GIR_Coverage, 4489,
     /* 147626 */   GIR_EraseRootFromParent_Done,
     /* 147627 */ // Label 2274: @147627
     /* 147627 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(147704), // Rule ID 4499 //
     /* 147632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 147635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147638 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147645 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147656 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147660 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147667 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 147670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147698 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147702 */   GIR_RootConstrainSelectedInstOperands,
     /* 147703 */   // GIR_Coverage, 4499,
     /* 147703 */   GIR_EraseRootFromParent_Done,
     /* 147704 */ // Label 2275: @147704
     /* 147704 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(147778), // Rule ID 4501 //
     /* 147709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147719 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147741 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
     /* 147744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147776 */   GIR_RootConstrainSelectedInstOperands,
     /* 147777 */   // GIR_Coverage, 4501,
     /* 147777 */   GIR_EraseRootFromParent_Done,
     /* 147778 */ // Label 2276: @147778
     /* 147778 */ GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(147855), // Rule ID 4503 //
     /* 147783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 147786 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147796 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147811 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147818 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 147821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147853 */   GIR_RootConstrainSelectedInstOperands,
     /* 147854 */   // GIR_Coverage, 4503,
     /* 147854 */   GIR_EraseRootFromParent_Done,
     /* 147855 */ // Label 2277: @147855
     /* 147855 */ GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(147929), // Rule ID 4505 //
     /* 147860 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 147863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147870 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147881 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147892 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 147892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
     /* 147895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147927 */   GIR_RootConstrainSelectedInstOperands,
     /* 147928 */   // GIR_Coverage, 4505,
     /* 147928 */   GIR_EraseRootFromParent_Done,
     /* 147929 */ // Label 2278: @147929
     /* 147929 */ GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(148005), // Rule ID 6426 //
     /* 147934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 147937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147947 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 147953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 147957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 147961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 147968 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 147968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
     /* 147971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 147973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 147978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 147983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 147988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 147993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147999 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148003 */   GIR_RootConstrainSelectedInstOperands,
     /* 148004 */   // GIR_Coverage, 6426,
     /* 148004 */   GIR_EraseRootFromParent_Done,
     /* 148005 */ // Label 2279: @148005
     /* 148005 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(148081), // Rule ID 6429 //
     /* 148010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 148013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148016 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148023 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 148044 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_constant>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 148044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
     /* 148047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 148054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 148064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 148069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148075 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148079 */   GIR_RootConstrainSelectedInstOperands,
     /* 148080 */   // GIR_Coverage, 6429,
     /* 148080 */   GIR_EraseRootFromParent_Done,
     /* 148081 */ // Label 2280: @148081
     /* 148081 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(148156), // Rule ID 6448 //
     /* 148086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 148089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148092 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148099 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 148104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148112 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 148119 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 148119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 148122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 148129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 148139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 148144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148154 */   GIR_RootConstrainSelectedInstOperands,
     /* 148155 */   // GIR_Coverage, 6448,
     /* 148155 */   GIR_EraseRootFromParent_Done,
     /* 148156 */ // Label 2281: @148156
     /* 148156 */ GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(148231), // Rule ID 6452 //
     /* 148161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 148164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148167 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148174 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 148179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 148194 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 148194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 148197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 148204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 148214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 148219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148229 */   GIR_RootConstrainSelectedInstOperands,
     /* 148230 */   // GIR_Coverage, 6452,
     /* 148230 */   GIR_EraseRootFromParent_Done,
     /* 148231 */ // Label 2282: @148231
     /* 148231 */ GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(148306), // Rule ID 6474 //
     /* 148236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 148239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148242 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148249 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 148254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 148269 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 148269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
     /* 148272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 148279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 148289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 148294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148304 */   GIR_RootConstrainSelectedInstOperands,
     /* 148305 */   // GIR_Coverage, 6474,
     /* 148305 */   GIR_EraseRootFromParent_Done,
     /* 148306 */ // Label 2283: @148306
     /* 148306 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(148381), // Rule ID 6476 //
     /* 148311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 148314 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148317 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148324 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 148329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148333 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148337 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 148344 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 148344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
     /* 148347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 148354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 148364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 148369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148379 */   GIR_RootConstrainSelectedInstOperands,
     /* 148380 */   // GIR_Coverage, 6476,
     /* 148380 */   GIR_EraseRootFromParent_Done,
     /* 148381 */ // Label 2284: @148381
     /* 148381 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(148453), // Rule ID 4478 //
     /* 148386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 148389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148399 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148414 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148421 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 148424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148447 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148451 */   GIR_RootConstrainSelectedInstOperands,
     /* 148452 */   // GIR_Coverage, 4478,
     /* 148452 */   GIR_EraseRootFromParent_Done,
     /* 148453 */ // Label 2285: @148453
     /* 148453 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(148522), // Rule ID 4480 //
     /* 148458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148461 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148468 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148490 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 148493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148520 */   GIR_RootConstrainSelectedInstOperands,
     /* 148521 */   // GIR_Coverage, 4480,
     /* 148521 */   GIR_EraseRootFromParent_Done,
     /* 148522 */ // Label 2286: @148522
     /* 148522 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(148594), // Rule ID 4482 //
     /* 148527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 148530 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148533 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148540 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148551 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148555 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148562 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 148565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148592 */   GIR_RootConstrainSelectedInstOperands,
     /* 148593 */   // GIR_Coverage, 4482,
     /* 148593 */   GIR_EraseRootFromParent_Done,
     /* 148594 */ // Label 2287: @148594
     /* 148594 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(148663), // Rule ID 4484 //
     /* 148599 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148602 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148609 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148631 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 148634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148657 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148661 */   GIR_RootConstrainSelectedInstOperands,
     /* 148662 */   // GIR_Coverage, 4484,
     /* 148662 */   GIR_EraseRootFromParent_Done,
     /* 148663 */ // Label 2288: @148663
     /* 148663 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(148735), // Rule ID 4486 //
     /* 148668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 148671 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148681 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148703 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 148706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148733 */   GIR_RootConstrainSelectedInstOperands,
     /* 148734 */   // GIR_Coverage, 4486,
     /* 148734 */   GIR_EraseRootFromParent_Done,
     /* 148735 */ // Label 2289: @148735
     /* 148735 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(148804), // Rule ID 4488 //
     /* 148740 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148743 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148750 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148761 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148765 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148772 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 148775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148802 */   GIR_RootConstrainSelectedInstOperands,
     /* 148803 */   // GIR_Coverage, 4488,
     /* 148803 */   GIR_EraseRootFromParent_Done,
     /* 148804 */ // Label 2290: @148804
     /* 148804 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(148876), // Rule ID 4498 //
     /* 148809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 148812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148822 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148844 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 148847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148874 */   GIR_RootConstrainSelectedInstOperands,
     /* 148875 */   // GIR_Coverage, 4498,
     /* 148875 */   GIR_EraseRootFromParent_Done,
     /* 148876 */ // Label 2291: @148876
     /* 148876 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(148945), // Rule ID 4500 //
     /* 148881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148891 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148906 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148913 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 148916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 148928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 148933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 148939 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148943 */   GIR_RootConstrainSelectedInstOperands,
     /* 148944 */   // GIR_Coverage, 4500,
     /* 148944 */   GIR_EraseRootFromParent_Done,
     /* 148945 */ // Label 2292: @148945
     /* 148945 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(149017), // Rule ID 4502 //
     /* 148950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 148953 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148956 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148963 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 148970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 148974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 148978 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 148985 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 148985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 148988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 148990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 148995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149011 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149015 */   GIR_RootConstrainSelectedInstOperands,
     /* 149016 */   // GIR_Coverage, 4502,
     /* 149016 */   GIR_EraseRootFromParent_Done,
     /* 149017 */ // Label 2293: @149017
     /* 149017 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(149086), // Rule ID 4504 //
     /* 149022 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149025 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149032 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149043 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149047 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 149054 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 149054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 149057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 149059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 149064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 149069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149084 */   GIR_RootConstrainSelectedInstOperands,
     /* 149085 */   // GIR_Coverage, 4504,
     /* 149085 */   GIR_EraseRootFromParent_Done,
     /* 149086 */ // Label 2294: @149086
     /* 149086 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(149148), // Rule ID 7928 //
     /* 149091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 149094 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149104 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149124 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 149127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149142 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149146 */   GIR_RootConstrainSelectedInstOperands,
     /* 149147 */   // GIR_Coverage, 7928,
     /* 149147 */   GIR_EraseRootFromParent_Done,
     /* 149148 */ // Label 2295: @149148
     /* 149148 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(149210), // Rule ID 7929 //
     /* 149153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 149156 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149166 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149175 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149179 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149186 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 149189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149208 */   GIR_RootConstrainSelectedInstOperands,
     /* 149209 */   // GIR_Coverage, 7929,
     /* 149209 */   GIR_EraseRootFromParent_Done,
     /* 149210 */ // Label 2296: @149210
     /* 149210 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(149272), // Rule ID 7937 //
     /* 149215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 149218 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149228 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149248 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 149251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149270 */   GIR_RootConstrainSelectedInstOperands,
     /* 149271 */   // GIR_Coverage, 7937,
     /* 149271 */   GIR_EraseRootFromParent_Done,
     /* 149272 */ // Label 2297: @149272
     /* 149272 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(149334), // Rule ID 7938 //
     /* 149277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 149280 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149290 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149310 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 149313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149332 */   GIR_RootConstrainSelectedInstOperands,
     /* 149333 */   // GIR_Coverage, 7938,
     /* 149333 */   GIR_EraseRootFromParent_Done,
     /* 149334 */ // Label 2298: @149334
     /* 149334 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(149396), // Rule ID 7939 //
     /* 149339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 149342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149352 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149361 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149365 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149372 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 149375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149394 */   GIR_RootConstrainSelectedInstOperands,
     /* 149395 */   // GIR_Coverage, 7939,
     /* 149395 */   GIR_EraseRootFromParent_Done,
     /* 149396 */ // Label 2299: @149396
     /* 149396 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(149458), // Rule ID 7940 //
     /* 149401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 149404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149407 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149414 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149427 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149434 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 149437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149452 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149456 */   GIR_RootConstrainSelectedInstOperands,
     /* 149457 */   // GIR_Coverage, 7940,
     /* 149457 */   GIR_EraseRootFromParent_Done,
     /* 149458 */ // Label 2300: @149458
     /* 149458 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(149520), // Rule ID 7990 //
     /* 149463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 149466 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149469 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149476 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149489 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149496 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
     /* 149499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149518 */   GIR_RootConstrainSelectedInstOperands,
     /* 149519 */   // GIR_Coverage, 7990,
     /* 149519 */   GIR_EraseRootFromParent_Done,
     /* 149520 */ // Label 2301: @149520
     /* 149520 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(149582), // Rule ID 7991 //
     /* 149525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 149528 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149538 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149547 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149551 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149558 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
     /* 149561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149580 */   GIR_RootConstrainSelectedInstOperands,
     /* 149581 */   // GIR_Coverage, 7991,
     /* 149581 */   GIR_EraseRootFromParent_Done,
     /* 149582 */ // Label 2302: @149582
     /* 149582 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(149644), // Rule ID 8000 //
     /* 149587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 149590 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149593 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149600 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149620 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_16_glue>><<P:Predicate_atomic_load_sext_16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
     /* 149623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149642 */   GIR_RootConstrainSelectedInstOperands,
     /* 149643 */   // GIR_Coverage, 8000,
     /* 149643 */   GIR_EraseRootFromParent_Done,
     /* 149644 */ // Label 2303: @149644
     /* 149644 */ GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(149706), // Rule ID 8001 //
     /* 149649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 149652 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149655 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149662 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 149667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149671 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149675 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 149682 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 149682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
     /* 149685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 149692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 149697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149700 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149704 */   GIR_RootConstrainSelectedInstOperands,
     /* 149705 */   // GIR_Coverage, 8001,
     /* 149705 */   GIR_EraseRootFromParent_Done,
     /* 149706 */ // Label 2304: @149706
     /* 149706 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(149775), // Rule ID 3822 //
     /* 149711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 149714 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149717 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149724 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 149746 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 149749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 149756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 149761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149769 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149773 */   GIR_RootConstrainSelectedInstOperands,
     /* 149774 */   // GIR_Coverage, 3822,
     /* 149774 */   GIR_EraseRootFromParent_Done,
     /* 149775 */ // Label 2305: @149775
     /* 149775 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(149844), // Rule ID 3830 //
     /* 149780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 149783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149793 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 149815 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
     /* 149818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 149825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 149830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149842 */   GIR_RootConstrainSelectedInstOperands,
     /* 149843 */   // GIR_Coverage, 3830,
     /* 149843 */   GIR_EraseRootFromParent_Done,
     /* 149844 */ // Label 2306: @149844
     /* 149844 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(149913), // Rule ID 3836 //
     /* 149849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 149852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149855 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149862 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149877 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 149884 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 149887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 149894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 149899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149911 */   GIR_RootConstrainSelectedInstOperands,
     /* 149912 */   // GIR_Coverage, 3836,
     /* 149912 */   GIR_EraseRootFromParent_Done,
     /* 149913 */ // Label 2307: @149913
     /* 149913 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(149982), // Rule ID 3844 //
     /* 149918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 149921 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149924 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149931 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 149938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 149942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 149946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 149953 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 149953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 149956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 149958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 149963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 149968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 149973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 149976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149980 */   GIR_RootConstrainSelectedInstOperands,
     /* 149981 */   // GIR_Coverage, 3844,
     /* 149981 */   GIR_EraseRootFromParent_Done,
     /* 149982 */ // Label 2308: @149982
     /* 149982 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(150051), // Rule ID 3856 //
     /* 149987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 149990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150000 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150011 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150015 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 150022 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
     /* 150025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 150032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 150037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150049 */   GIR_RootConstrainSelectedInstOperands,
     /* 150050 */   // GIR_Coverage, 3856,
     /* 150050 */   GIR_EraseRootFromParent_Done,
     /* 150051 */ // Label 2309: @150051
     /* 150051 */ GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(150115), // Rule ID 3821 //
     /* 150056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 150059 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150069 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150084 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 150091 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 150094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150113 */   GIR_RootConstrainSelectedInstOperands,
     /* 150114 */   // GIR_Coverage, 3821,
     /* 150114 */   GIR_EraseRootFromParent_Done,
     /* 150115 */ // Label 2310: @150115
     /* 150115 */ GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(150179), // Rule ID 3829 //
     /* 150120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 150123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150126 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150133 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 150155 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
     /* 150158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150177 */   GIR_RootConstrainSelectedInstOperands,
     /* 150178 */   // GIR_Coverage, 3829,
     /* 150178 */   GIR_EraseRootFromParent_Done,
     /* 150179 */ // Label 2311: @150179
     /* 150179 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(150243), // Rule ID 3835 //
     /* 150184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 150187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150190 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150197 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150212 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 150219 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 150222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150241 */   GIR_RootConstrainSelectedInstOperands,
     /* 150242 */   // GIR_Coverage, 3835,
     /* 150242 */   GIR_EraseRootFromParent_Done,
     /* 150243 */ // Label 2312: @150243
     /* 150243 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(150307), // Rule ID 3843 //
     /* 150248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 150251 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150254 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150261 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150276 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 150283 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 150286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150305 */   GIR_RootConstrainSelectedInstOperands,
     /* 150306 */   // GIR_Coverage, 3843,
     /* 150306 */   GIR_EraseRootFromParent_Done,
     /* 150307 */ // Label 2313: @150307
     /* 150307 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(150371), // Rule ID 3855 //
     /* 150312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 150315 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150318 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150325 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150336 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150340 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 150347 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
     /* 150350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150369 */   GIR_RootConstrainSelectedInstOperands,
     /* 150370 */   // GIR_Coverage, 3855,
     /* 150370 */   GIR_EraseRootFromParent_Done,
     /* 150371 */ // Label 2314: @150371
     /* 150371 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(150436), // Rule ID 3590 //
     /* 150376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 150379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150382 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150389 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 150412 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 150415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150434 */   GIR_RootConstrainSelectedInstOperands,
     /* 150435 */   // GIR_Coverage, 3590,
     /* 150435 */   GIR_EraseRootFromParent_Done,
     /* 150436 */ // Label 2315: @150436
     /* 150436 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(150501), // Rule ID 3591 //
     /* 150441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 150444 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150447 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150454 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150470 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 150477 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
     /* 150480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150499 */   GIR_RootConstrainSelectedInstOperands,
     /* 150500 */   // GIR_Coverage, 3591,
     /* 150500 */   GIR_EraseRootFromParent_Done,
     /* 150501 */ // Label 2316: @150501
     /* 150501 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(150566), // Rule ID 3595 //
     /* 150506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 150509 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150519 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150531 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150535 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 150542 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
     /* 150545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150552 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150564 */   GIR_RootConstrainSelectedInstOperands,
     /* 150565 */   // GIR_Coverage, 3595,
     /* 150565 */   GIR_EraseRootFromParent_Done,
     /* 150566 */ // Label 2317: @150566
     /* 150566 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(150631), // Rule ID 3596 //
     /* 150571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 150574 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 150577 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150584 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 150592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150600 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 150607 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 150607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
     /* 150610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 150622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150629 */   GIR_RootConstrainSelectedInstOperands,
     /* 150630 */   // GIR_Coverage, 3596,
     /* 150630 */   GIR_EraseRootFromParent_Done,
     /* 150631 */ // Label 2318: @150631
     /* 150631 */ GIM_Reject,
     /* 150632 */ // Label 2213: @150632
     /* 150632 */ GIM_Reject,
     /* 150633 */ // Label 16: @150633
     /* 150633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2321*/ GIMT_Encode4(157840),
     /* 150644 */ /*GILLT_s16*//*Label 2319*/ GIMT_Encode4(150652),
     /* 150648 */ /*GILLT_s32*//*Label 2320*/ GIMT_Encode4(153515),
     /* 150652 */ // Label 2319: @150652
     /* 150652 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(150722), // Rule ID 6471 //
     /* 150657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 150660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150670 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150690 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 150693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150720 */   GIR_RootConstrainSelectedInstOperands,
     /* 150721 */   // GIR_Coverage, 6471,
     /* 150721 */   GIR_EraseRootFromParent_Done,
     /* 150722 */ // Label 2322: @150722
     /* 150722 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(150792), // Rule ID 6473 //
     /* 150727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 150730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150733 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150740 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150749 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150753 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 150760 */   // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 150760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 150763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 150765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 150770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 150775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150790 */   GIR_RootConstrainSelectedInstOperands,
     /* 150791 */   // GIR_Coverage, 6473,
     /* 150791 */   GIR_EraseRootFromParent_Done,
     /* 150792 */ // Label 2323: @150792
     /* 150792 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(150859), // Rule ID 4211 //
     /* 150797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 150800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150810 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 150830 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 150833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 150845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150857 */   GIR_RootConstrainSelectedInstOperands,
     /* 150858 */   // GIR_Coverage, 4211,
     /* 150858 */   GIR_EraseRootFromParent_Done,
     /* 150859 */ // Label 2324: @150859
     /* 150859 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(150926), // Rule ID 4226 //
     /* 150864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 150867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150877 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 150886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 150897 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 150900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 150912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150924 */   GIR_RootConstrainSelectedInstOperands,
     /* 150925 */   // GIR_Coverage, 4226,
     /* 150925 */   GIR_EraseRootFromParent_Done,
     /* 150926 */ // Label 2325: @150926
     /* 150926 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(150993), // Rule ID 4241 //
     /* 150931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 150934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150944 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 150949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 150953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 150957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 150964 */   // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SVS_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 150964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SVS_t16),
     /* 150967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 150969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 150974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 150979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 150984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 150987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150991 */   GIR_RootConstrainSelectedInstOperands,
     /* 150992 */   // GIR_Coverage, 4241,
     /* 150992 */   GIR_EraseRootFromParent_Done,
     /* 150993 */ // Label 2326: @150993
     /* 150993 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(151055), // Rule ID 4210 //
     /* 150998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 151001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151004 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151011 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151020 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151024 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 151031 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 151031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 151034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 151036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 151041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 151046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151053 */   GIR_RootConstrainSelectedInstOperands,
     /* 151054 */   // GIR_Coverage, 4210,
     /* 151054 */   GIR_EraseRootFromParent_Done,
     /* 151055 */ // Label 2327: @151055
     /* 151055 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(151117), // Rule ID 4225 //
     /* 151060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 151063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151066 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151073 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151082 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151086 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 151093 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 151093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 151096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 151098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 151103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 151108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151115 */   GIR_RootConstrainSelectedInstOperands,
     /* 151116 */   // GIR_Coverage, 4225,
     /* 151116 */   GIR_EraseRootFromParent_Done,
     /* 151117 */ // Label 2328: @151117
     /* 151117 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(151179), // Rule ID 4240 //
     /* 151122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 151125 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151128 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151135 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 151144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 151155 */   // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 151155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_SADDR_t16),
     /* 151158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 151160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 151165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 151170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151177 */   GIR_RootConstrainSelectedInstOperands,
     /* 151178 */   // GIR_Coverage, 4240,
     /* 151178 */   GIR_EraseRootFromParent_Done,
     /* 151179 */ // Label 2329: @151179
     /* 151179 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(151241), // Rule ID 4209 //
     /* 151184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 151187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151190 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151197 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 151217 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 151217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 151220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 151222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 151227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 151232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151239 */   GIR_RootConstrainSelectedInstOperands,
     /* 151240 */   // GIR_Coverage, 4209,
     /* 151240 */   GIR_EraseRootFromParent_Done,
     /* 151241 */ // Label 2330: @151241
     /* 151241 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(151303), // Rule ID 4224 //
     /* 151246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 151249 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151252 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151259 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 151279 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 151279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 151282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 151284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 151289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 151294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151301 */   GIR_RootConstrainSelectedInstOperands,
     /* 151302 */   // GIR_Coverage, 4224,
     /* 151302 */   GIR_EraseRootFromParent_Done,
     /* 151303 */ // Label 2331: @151303
     /* 151303 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(151365), // Rule ID 4239 //
     /* 151308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 151311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151321 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 151330 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 151341 */   // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 151341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_D16_t16),
     /* 151344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 151346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 151351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 151356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151363 */   GIR_RootConstrainSelectedInstOperands,
     /* 151364 */   // GIR_Coverage, 4239,
     /* 151364 */   GIR_EraseRootFromParent_Done,
     /* 151365 */ // Label 2332: @151365
     /* 151365 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(151442), // Rule ID 4463 //
     /* 151370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151373 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151383 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151394 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151398 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151405 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 151408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151440 */   GIR_RootConstrainSelectedInstOperands,
     /* 151441 */   // GIR_Coverage, 4463,
     /* 151441 */   GIR_EraseRootFromParent_Done,
     /* 151442 */ // Label 2333: @151442
     /* 151442 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(151516), // Rule ID 4465 //
     /* 151447 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151457 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 151479 */   // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /* 151482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151514 */   GIR_RootConstrainSelectedInstOperands,
     /* 151515 */   // GIR_Coverage, 4465,
     /* 151515 */   GIR_EraseRootFromParent_Done,
     /* 151516 */ // Label 2334: @151516
     /* 151516 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(151591), // Rule ID 6470 //
     /* 151521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 151524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151534 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151554 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 151557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151589 */   GIR_RootConstrainSelectedInstOperands,
     /* 151590 */   // GIR_Coverage, 6470,
     /* 151590 */   GIR_EraseRootFromParent_Done,
     /* 151591 */ // Label 2335: @151591
     /* 151591 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(151666), // Rule ID 6472 //
     /* 151596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 151599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151602 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151609 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 151614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 151629 */   // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 151629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 151632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 151639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 151649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 151654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151664 */   GIR_RootConstrainSelectedInstOperands,
     /* 151665 */   // GIR_Coverage, 6472,
     /* 151665 */   GIR_EraseRootFromParent_Done,
     /* 151666 */ // Label 2336: @151666
     /* 151666 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(151738), // Rule ID 4462 //
     /* 151671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 151674 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151677 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151684 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151706 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 151709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151736 */   GIR_RootConstrainSelectedInstOperands,
     /* 151737 */   // GIR_Coverage, 4462,
     /* 151737 */   GIR_EraseRootFromParent_Done,
     /* 151738 */ // Label 2337: @151738
     /* 151738 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(151807), // Rule ID 4464 //
     /* 151743 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 151746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151753 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151768 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151775 */   // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 151775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 151778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151805 */   GIR_RootConstrainSelectedInstOperands,
     /* 151806 */   // GIR_Coverage, 4464,
     /* 151806 */   GIR_EraseRootFromParent_Done,
     /* 151807 */ // Label 2338: @151807
     /* 151807 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(151878), // Rule ID 6438 //
     /* 151812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 151815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151825 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151846 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 151846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 151849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151872 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151876 */   GIR_RootConstrainSelectedInstOperands,
     /* 151877 */   // GIR_Coverage, 6438,
     /* 151877 */   GIR_EraseRootFromParent_Done,
     /* 151878 */ // Label 2339: @151878
     /* 151878 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(151949), // Rule ID 6439 //
     /* 151883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 151886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151889 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151896 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151917 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 151917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 151920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 151932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 151937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 151943 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151947 */   GIR_RootConstrainSelectedInstOperands,
     /* 151948 */   // GIR_Coverage, 6439,
     /* 151948 */   GIR_EraseRootFromParent_Done,
     /* 151949 */ // Label 2340: @151949
     /* 151949 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(152021), // Rule ID 6444 //
     /* 151954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 151957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151960 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151967 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 151974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 151978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 151982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 151989 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 151989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 151992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 151994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 151999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152019 */   GIR_RootConstrainSelectedInstOperands,
     /* 152020 */   // GIR_Coverage, 6444,
     /* 152020 */   GIR_EraseRootFromParent_Done,
     /* 152021 */ // Label 2341: @152021
     /* 152021 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(152093), // Rule ID 6445 //
     /* 152026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 152029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152032 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152039 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 152061 */   // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 152061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 152064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 152066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 152071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 152076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152091 */   GIR_RootConstrainSelectedInstOperands,
     /* 152092 */   // GIR_Coverage, 6445,
     /* 152092 */   GIR_EraseRootFromParent_Done,
     /* 152093 */ // Label 2342: @152093
     /* 152093 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(152155), // Rule ID 7950 //
     /* 152098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152104 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152131 */   // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 152134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152153 */   GIR_RootConstrainSelectedInstOperands,
     /* 152154 */   // GIR_Coverage, 7950,
     /* 152154 */   GIR_EraseRootFromParent_Done,
     /* 152155 */ // Label 2343: @152155
     /* 152155 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(152217), // Rule ID 7951 //
     /* 152160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 152163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152173 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152193 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152215 */   GIR_RootConstrainSelectedInstOperands,
     /* 152216 */   // GIR_Coverage, 7951,
     /* 152216 */   GIR_EraseRootFromParent_Done,
     /* 152217 */ // Label 2344: @152217
     /* 152217 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(152279), // Rule ID 7952 //
     /* 152222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 152225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152235 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152248 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152255 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152277 */   GIR_RootConstrainSelectedInstOperands,
     /* 152278 */   // GIR_Coverage, 7952,
     /* 152278 */   GIR_EraseRootFromParent_Done,
     /* 152279 */ // Label 2345: @152279
     /* 152279 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(152341), // Rule ID 7953 //
     /* 152284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 152287 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152290 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152297 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 152306 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152310 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152317 */   // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /* 152320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152339 */   GIR_RootConstrainSelectedInstOperands,
     /* 152340 */   // GIR_Coverage, 7953,
     /* 152340 */   GIR_EraseRootFromParent_Done,
     /* 152341 */ // Label 2346: @152341
     /* 152341 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(152403), // Rule ID 7980 //
     /* 152346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 152349 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152352 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152359 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152379 */   // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 152382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152401 */   GIR_RootConstrainSelectedInstOperands,
     /* 152402 */   // GIR_Coverage, 7980,
     /* 152402 */   GIR_EraseRootFromParent_Done,
     /* 152403 */ // Label 2347: @152403
     /* 152403 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(152465), // Rule ID 7981 //
     /* 152408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 152411 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152414 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152421 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152430 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152434 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152441 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152459 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152463 */   GIR_RootConstrainSelectedInstOperands,
     /* 152464 */   // GIR_Coverage, 7981,
     /* 152464 */   GIR_EraseRootFromParent_Done,
     /* 152465 */ // Label 2348: @152465
     /* 152465 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(152527), // Rule ID 7982 //
     /* 152470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 152473 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152483 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152496 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152503 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 152506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152525 */   GIR_RootConstrainSelectedInstOperands,
     /* 152526 */   // GIR_Coverage, 7982,
     /* 152526 */   GIR_EraseRootFromParent_Done,
     /* 152527 */ // Label 2349: @152527
     /* 152527 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(152589), // Rule ID 7983 //
     /* 152532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 152535 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152538 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152545 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 152550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 152554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152558 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 152565 */   // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_t16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 152565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_t16),
     /* 152568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 152575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152587 */   GIR_RootConstrainSelectedInstOperands,
     /* 152588 */   // GIR_Coverage, 7983,
     /* 152588 */   GIR_EraseRootFromParent_Done,
     /* 152589 */ // Label 2350: @152589
     /* 152589 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(152658), // Rule ID 3812 //
     /* 152594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 152597 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152600 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152607 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152629 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 152632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152656 */   GIR_RootConstrainSelectedInstOperands,
     /* 152657 */   // GIR_Coverage, 3812,
     /* 152657 */   GIR_EraseRootFromParent_Done,
     /* 152658 */ // Label 2351: @152658
     /* 152658 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(152727), // Rule ID 3820 //
     /* 152663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 152666 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152676 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152698 */   // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 152701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152725 */   GIR_RootConstrainSelectedInstOperands,
     /* 152726 */   // GIR_Coverage, 3820,
     /* 152726 */   GIR_EraseRootFromParent_Done,
     /* 152727 */ // Label 2352: @152727
     /* 152727 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(152796), // Rule ID 3840 //
     /* 152732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 152735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152738 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152745 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152756 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152760 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152767 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 152770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152794 */   GIR_RootConstrainSelectedInstOperands,
     /* 152795 */   // GIR_Coverage, 3840,
     /* 152795 */   GIR_EraseRootFromParent_Done,
     /* 152796 */ // Label 2353: @152796
     /* 152796 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(152865), // Rule ID 3852 //
     /* 152801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 152804 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152814 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152836 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 152839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152863 */   GIR_RootConstrainSelectedInstOperands,
     /* 152864 */   // GIR_Coverage, 3852,
     /* 152864 */   GIR_EraseRootFromParent_Done,
     /* 152865 */ // Label 2354: @152865
     /* 152865 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(152934), // Rule ID 3862 //
     /* 152870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 152873 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152876 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152883 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 152894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 152905 */   // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_SADDR_t16:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 152905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_SADDR_t16),
     /* 152908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 152915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 152920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 152925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152928 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152932 */   GIR_RootConstrainSelectedInstOperands,
     /* 152933 */   // GIR_Coverage, 3862,
     /* 152933 */   GIR_EraseRootFromParent_Done,
     /* 152934 */ // Label 2355: @152934
     /* 152934 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(152998), // Rule ID 3811 //
     /* 152939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 152942 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 152945 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152952 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 152959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 152963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 152967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 152974 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 152974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 152977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 152979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 152984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 152989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152996 */   GIR_RootConstrainSelectedInstOperands,
     /* 152997 */   // GIR_Coverage, 3811,
     /* 152997 */   GIR_EraseRootFromParent_Done,
     /* 152998 */ // Label 2356: @152998
     /* 152998 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(153062), // Rule ID 3819 //
     /* 153003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 153006 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153009 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153016 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153027 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153031 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153038 */   // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 153041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153060 */   GIR_RootConstrainSelectedInstOperands,
     /* 153061 */   // GIR_Coverage, 3819,
     /* 153061 */   GIR_EraseRootFromParent_Done,
     /* 153062 */ // Label 2357: @153062
     /* 153062 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(153126), // Rule ID 3839 //
     /* 153067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 153070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153080 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153102 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 153105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153124 */   GIR_RootConstrainSelectedInstOperands,
     /* 153125 */   // GIR_Coverage, 3839,
     /* 153125 */   GIR_EraseRootFromParent_Done,
     /* 153126 */ // Label 2358: @153126
     /* 153126 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(153190), // Rule ID 3851 //
     /* 153131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 153134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153144 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153155 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153166 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 153169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153188 */   GIR_RootConstrainSelectedInstOperands,
     /* 153189 */   // GIR_Coverage, 3851,
     /* 153189 */   GIR_EraseRootFromParent_Done,
     /* 153190 */ // Label 2359: @153190
     /* 153190 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(153254), // Rule ID 3861 //
     /* 153195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 153198 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153208 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 153219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 153230 */   // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_D16_t16),
     /* 153233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153252 */   GIR_RootConstrainSelectedInstOperands,
     /* 153253 */   // GIR_Coverage, 3861,
     /* 153253 */   GIR_EraseRootFromParent_Done,
     /* 153254 */ // Label 2360: @153254
     /* 153254 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(153319), // Rule ID 3584 //
     /* 153259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 153262 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153265 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153272 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153295 */   // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 153298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153317 */   GIR_RootConstrainSelectedInstOperands,
     /* 153318 */   // GIR_Coverage, 3584,
     /* 153318 */   GIR_EraseRootFromParent_Done,
     /* 153319 */ // Label 2361: @153319
     /* 153319 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(153384), // Rule ID 3599 //
     /* 153324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 153327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153330 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153337 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153353 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153360 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 153363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153382 */   GIR_RootConstrainSelectedInstOperands,
     /* 153383 */   // GIR_Coverage, 3599,
     /* 153383 */   GIR_EraseRootFromParent_Done,
     /* 153384 */ // Label 2362: @153384
     /* 153384 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(153449), // Rule ID 3605 //
     /* 153389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 153392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153402 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 153414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153425 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 153425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 153428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153447 */   GIR_RootConstrainSelectedInstOperands,
     /* 153448 */   // GIR_Coverage, 3605,
     /* 153448 */   GIR_EraseRootFromParent_Done,
     /* 153449 */ // Label 2363: @153449
     /* 153449 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(153514), // Rule ID 3611 //
     /* 153454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 153457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153460 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153467 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 153475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 153479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 153490 */   // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE_D16_t16:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE_D16_t16),
     /* 153493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 153495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 153500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153512 */   GIR_RootConstrainSelectedInstOperands,
     /* 153513 */   // GIR_Coverage, 3611,
     /* 153513 */   GIR_EraseRootFromParent_Done,
     /* 153514 */ // Label 2364: @153514
     /* 153514 */ GIM_Reject,
     /* 153515 */ // Label 2320: @153515
     /* 153515 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(153581), // Rule ID 2914 //
     /* 153520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153526 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153541 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 153545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 153552 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /* 153555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 153562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 153567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153579 */   GIR_RootConstrainSelectedInstOperands,
     /* 153580 */   // GIR_Coverage, 2914,
     /* 153580 */   GIR_EraseRootFromParent_Done,
     /* 153581 */ // Label 2365: @153581
     /* 153581 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(153647), // Rule ID 2926 //
     /* 153586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153592 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153603 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153607 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 153611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
     /* 153618 */   // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /* 153621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 153628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 153633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 153638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153641 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153645 */   GIR_RootConstrainSelectedInstOperands,
     /* 153646 */   // GIR_Coverage, 2926,
     /* 153646 */   GIR_EraseRootFromParent_Done,
     /* 153647 */ // Label 2366: @153647
     /* 153647 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(153708), // Rule ID 2912 //
     /* 153652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153655 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153669 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153673 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 153677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 153684 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /* 153687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 153694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153702 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153706 */   GIR_RootConstrainSelectedInstOperands,
     /* 153707 */   // GIR_Coverage, 2912,
     /* 153707 */   GIR_EraseRootFromParent_Done,
     /* 153708 */ // Label 2367: @153708
     /* 153708 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(153772), // Rule ID 2913 //
     /* 153713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153719 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153734 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 153738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 153745 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 153745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
     /* 153748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 153755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 153760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153770 */   GIR_RootConstrainSelectedInstOperands,
     /* 153771 */   // GIR_Coverage, 2913,
     /* 153771 */   GIR_EraseRootFromParent_Done,
     /* 153772 */ // Label 2368: @153772
     /* 153772 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(153833), // Rule ID 2924 //
     /* 153777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153780 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153783 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153798 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 153802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 153809 */   // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 153809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /* 153812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 153819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 153824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153831 */   GIR_RootConstrainSelectedInstOperands,
     /* 153832 */   // GIR_Coverage, 2924,
     /* 153832 */   GIR_EraseRootFromParent_Done,
     /* 153833 */ // Label 2369: @153833
     /* 153833 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(153897), // Rule ID 2925 //
     /* 153838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153844 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 153859 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 153863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
     /* 153870 */   // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 153870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
     /* 153873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 153880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 153885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153895 */   GIR_RootConstrainSelectedInstOperands,
     /* 153896 */   // GIR_Coverage, 2925,
     /* 153896 */   GIR_EraseRootFromParent_Done,
     /* 153897 */ // Label 2370: @153897
     /* 153897 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(153950), // Rule ID 2915 //
     /* 153902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153908 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153919 */   // MIs[0] sbase
     /* 153919 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 153927 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
     /* 153931 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 153931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
     /* 153934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153936 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 153938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153948 */   GIR_RootConstrainSelectedInstOperands,
     /* 153949 */   // GIR_Coverage, 2915,
     /* 153949 */   GIR_EraseRootFromParent_Done,
     /* 153950 */ // Label 2371: @153950
     /* 153950 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(154003), // Rule ID 2927 //
     /* 153955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 153958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153961 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 153972 */   // MIs[0] sbase
     /* 153972 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 153980 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
     /* 153984 */   // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 153984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
     /* 153987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 153989 */   GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 153991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154001 */   GIR_RootConstrainSelectedInstOperands,
     /* 154002 */   // GIR_Coverage, 2927,
     /* 154002 */   GIR_EraseRootFromParent_Done,
     /* 154003 */ // Label 2372: @154003
     /* 154003 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(154073), // Rule ID 6459 //
     /* 154008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 154011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154021 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 154041 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 154041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 154044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154071 */   GIR_RootConstrainSelectedInstOperands,
     /* 154072 */   // GIR_Coverage, 6459,
     /* 154072 */   GIR_EraseRootFromParent_Done,
     /* 154073 */ // Label 2373: @154073
     /* 154073 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(154143), // Rule ID 6461 //
     /* 154078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 154081 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154091 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154100 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154104 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 154111 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 154111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 154114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154141 */   GIR_RootConstrainSelectedInstOperands,
     /* 154142 */   // GIR_Coverage, 6461,
     /* 154142 */   GIR_EraseRootFromParent_Done,
     /* 154143 */ // Label 2374: @154143
     /* 154143 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(154213), // Rule ID 6483 //
     /* 154148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 154151 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154161 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154174 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 154181 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 154181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 154184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154211 */   GIR_RootConstrainSelectedInstOperands,
     /* 154212 */   // GIR_Coverage, 6483,
     /* 154212 */   GIR_EraseRootFromParent_Done,
     /* 154213 */ // Label 2375: @154213
     /* 154213 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(154283), // Rule ID 6485 //
     /* 154218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 154221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154231 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 154251 */   // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 154251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 154254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 154266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154281 */   GIR_RootConstrainSelectedInstOperands,
     /* 154282 */   // GIR_Coverage, 6485,
     /* 154282 */   GIR_EraseRootFromParent_Done,
     /* 154283 */ // Label 2376: @154283
     /* 154283 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(154350), // Rule ID 4193 //
     /* 154288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 154291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154294 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154301 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154314 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 154321 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 154321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
     /* 154324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 154326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 154336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154348 */   GIR_RootConstrainSelectedInstOperands,
     /* 154349 */   // GIR_Coverage, 4193,
     /* 154349 */   GIR_EraseRootFromParent_Done,
     /* 154350 */ // Label 2377: @154350
     /* 154350 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(154417), // Rule ID 4202 //
     /* 154355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 154358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154361 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154368 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 154388 */   // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 154388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
     /* 154391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 154393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 154403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 154408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154415 */   GIR_RootConstrainSelectedInstOperands,
     /* 154416 */   // GIR_Coverage, 4202,
     /* 154416 */   GIR_EraseRootFromParent_Done,
     /* 154417 */ // Label 2378: @154417
     /* 154417 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(154479), // Rule ID 4192 //
     /* 154422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154435 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154444 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 154455 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 154455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
     /* 154458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 154460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 154465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154477 */   GIR_RootConstrainSelectedInstOperands,
     /* 154478 */   // GIR_Coverage, 4192,
     /* 154478 */   GIR_EraseRootFromParent_Done,
     /* 154479 */ // Label 2379: @154479
     /* 154479 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(154541), // Rule ID 4201 //
     /* 154484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154487 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154490 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154497 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 154517 */   // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 154517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
     /* 154520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 154522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 154527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154539 */   GIR_RootConstrainSelectedInstOperands,
     /* 154540 */   // GIR_Coverage, 4201,
     /* 154540 */   GIR_EraseRootFromParent_Done,
     /* 154541 */ // Label 2380: @154541
     /* 154541 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(154603), // Rule ID 4191 //
     /* 154546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154552 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154559 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 154579 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 154579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
     /* 154582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 154584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154601 */   GIR_RootConstrainSelectedInstOperands,
     /* 154602 */   // GIR_Coverage, 4191,
     /* 154602 */   GIR_EraseRootFromParent_Done,
     /* 154603 */ // Label 2381: @154603
     /* 154603 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(154665), // Rule ID 4200 //
     /* 154608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 154611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154614 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154621 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 154626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 154641 */   // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 154641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
     /* 154644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 154646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 154651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 154656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154663 */   GIR_RootConstrainSelectedInstOperands,
     /* 154664 */   // GIR_Coverage, 4200,
     /* 154664 */   GIR_EraseRootFromParent_Done,
     /* 154665 */ // Label 2382: @154665
     /* 154665 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(154742), // Rule ID 4447 //
     /* 154670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 154673 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154676 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154683 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 154690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154698 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154705 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 154708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154736 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154740 */   GIR_RootConstrainSelectedInstOperands,
     /* 154741 */   // GIR_Coverage, 4447,
     /* 154741 */   GIR_EraseRootFromParent_Done,
     /* 154742 */ // Label 2383: @154742
     /* 154742 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(154816), // Rule ID 4449 //
     /* 154747 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154750 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154757 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 154764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154768 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154772 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154779 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /* 154782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154814 */   GIR_RootConstrainSelectedInstOperands,
     /* 154815 */   // GIR_Coverage, 4449,
     /* 154815 */   GIR_EraseRootFromParent_Done,
     /* 154816 */ // Label 2384: @154816
     /* 154816 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(154893), // Rule ID 4455 //
     /* 154821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 154824 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154827 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154834 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 154841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154845 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154849 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154856 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 154859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154891 */   GIR_RootConstrainSelectedInstOperands,
     /* 154892 */   // GIR_Coverage, 4455,
     /* 154892 */   GIR_EraseRootFromParent_Done,
     /* 154893 */ // Label 2385: @154893
     /* 154893 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(154967), // Rule ID 4457 //
     /* 154898 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154901 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154908 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 154915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154919 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 154923 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 154930 */   // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 154930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /* 154933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 154935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 154940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 154945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 154950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 154955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154965 */   GIR_RootConstrainSelectedInstOperands,
     /* 154966 */   // GIR_Coverage, 4457,
     /* 154966 */   GIR_EraseRootFromParent_Done,
     /* 154967 */ // Label 2386: @154967
     /* 154967 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(155044), // Rule ID 4475 //
     /* 154972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 154975 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154978 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154985 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 154992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 154996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155000 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155007 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 155010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155042 */   GIR_RootConstrainSelectedInstOperands,
     /* 155043 */   // GIR_Coverage, 4475,
     /* 155043 */   GIR_EraseRootFromParent_Done,
     /* 155044 */ // Label 2387: @155044
     /* 155044 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(155118), // Rule ID 4477 //
     /* 155049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155059 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155074 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155081 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
     /* 155084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155116 */   GIR_RootConstrainSelectedInstOperands,
     /* 155117 */   // GIR_Coverage, 4477,
     /* 155117 */   GIR_EraseRootFromParent_Done,
     /* 155118 */ // Label 2388: @155118
     /* 155118 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(155195), // Rule ID 4495 //
     /* 155123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 155126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155129 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155136 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155147 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155151 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155158 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 155161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155193 */   GIR_RootConstrainSelectedInstOperands,
     /* 155194 */   // GIR_Coverage, 4495,
     /* 155194 */   GIR_EraseRootFromParent_Done,
     /* 155195 */ // Label 2389: @155195
     /* 155195 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(155269), // Rule ID 4497 //
     /* 155200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155203 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155210 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155221 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155225 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155232 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
     /* 155235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155263 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155267 */   GIR_RootConstrainSelectedInstOperands,
     /* 155268 */   // GIR_Coverage, 4497,
     /* 155268 */   GIR_EraseRootFromParent_Done,
     /* 155269 */ // Label 2390: @155269
     /* 155269 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(155345), // Rule ID 6428 //
     /* 155274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 155277 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155287 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155308 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 155308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
     /* 155311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155343 */   GIR_RootConstrainSelectedInstOperands,
     /* 155344 */   // GIR_Coverage, 6428,
     /* 155344 */   GIR_EraseRootFromParent_Done,
     /* 155345 */ // Label 2391: @155345
     /* 155345 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(155421), // Rule ID 6431 //
     /* 155350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 155353 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155356 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155363 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 155384 */   // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 155384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
     /* 155387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155404 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155419 */   GIR_RootConstrainSelectedInstOperands,
     /* 155420 */   // GIR_Coverage, 6431,
     /* 155420 */   GIR_EraseRootFromParent_Done,
     /* 155421 */ // Label 2392: @155421
     /* 155421 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(155496), // Rule ID 6458 //
     /* 155426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 155429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155439 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155452 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 155459 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 155459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 155462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155490 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155494 */   GIR_RootConstrainSelectedInstOperands,
     /* 155495 */   // GIR_Coverage, 6458,
     /* 155495 */   GIR_EraseRootFromParent_Done,
     /* 155496 */ // Label 2393: @155496
     /* 155496 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(155571), // Rule ID 6460 //
     /* 155501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 155504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155507 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155514 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155523 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 155534 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 155534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 155537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155539 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155569 */   GIR_RootConstrainSelectedInstOperands,
     /* 155570 */   // GIR_Coverage, 6460,
     /* 155570 */   GIR_EraseRootFromParent_Done,
     /* 155571 */ // Label 2394: @155571
     /* 155571 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(155646), // Rule ID 6482 //
     /* 155576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 155579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155582 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155589 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 155609 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 155609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /* 155612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155644 */   GIR_RootConstrainSelectedInstOperands,
     /* 155645 */   // GIR_Coverage, 6482,
     /* 155645 */   GIR_EraseRootFromParent_Done,
     /* 155646 */ // Label 2395: @155646
     /* 155646 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(155721), // Rule ID 6484 //
     /* 155651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 155654 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155657 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155664 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 155669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 155684 */   // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 155684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /* 155687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 155694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 155704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 155709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155719 */   GIR_RootConstrainSelectedInstOperands,
     /* 155720 */   // GIR_Coverage, 6484,
     /* 155720 */   GIR_EraseRootFromParent_Done,
     /* 155721 */ // Label 2396: @155721
     /* 155721 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(155793), // Rule ID 4446 //
     /* 155726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 155729 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 155732 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155739 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155750 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155754 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155761 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 155764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155787 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155791 */   GIR_RootConstrainSelectedInstOperands,
     /* 155792 */   // GIR_Coverage, 4446,
     /* 155792 */   GIR_EraseRootFromParent_Done,
     /* 155793 */ // Label 2397: @155793
     /* 155793 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(155862), // Rule ID 4448 //
     /* 155798 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 155801 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155808 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155830 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 155833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155860 */   GIR_RootConstrainSelectedInstOperands,
     /* 155861 */   // GIR_Coverage, 4448,
     /* 155861 */   GIR_EraseRootFromParent_Done,
     /* 155862 */ // Label 2398: @155862
     /* 155862 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(155934), // Rule ID 4454 //
     /* 155867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 155870 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 155873 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155880 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155891 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155902 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 155905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155928 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155932 */   GIR_RootConstrainSelectedInstOperands,
     /* 155933 */   // GIR_Coverage, 4454,
     /* 155933 */   GIR_EraseRootFromParent_Done,
     /* 155934 */ // Label 2399: @155934
     /* 155934 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(156003), // Rule ID 4456 //
     /* 155939 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 155942 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155949 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 155956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 155960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 155964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 155971 */   // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 155971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 155974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 155976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 155981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 155986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 155991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156001 */   GIR_RootConstrainSelectedInstOperands,
     /* 156002 */   // GIR_Coverage, 4456,
     /* 156002 */   GIR_EraseRootFromParent_Done,
     /* 156003 */ // Label 2400: @156003
     /* 156003 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(156075), // Rule ID 4474 //
     /* 156008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 156011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156014 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156021 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 156028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156032 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156036 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156043 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 156046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 156048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156073 */   GIR_RootConstrainSelectedInstOperands,
     /* 156074 */   // GIR_Coverage, 4474,
     /* 156074 */   GIR_EraseRootFromParent_Done,
     /* 156075 */ // Label 2401: @156075
     /* 156075 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(156144), // Rule ID 4476 //
     /* 156080 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156083 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156090 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 156097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156112 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 156115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 156117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156142 */   GIR_RootConstrainSelectedInstOperands,
     /* 156143 */   // GIR_Coverage, 4476,
     /* 156143 */   GIR_EraseRootFromParent_Done,
     /* 156144 */ // Label 2402: @156144
     /* 156144 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(156216), // Rule ID 4494 //
     /* 156149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 156152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156155 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156162 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 156169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156184 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 156187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 156189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156214 */   GIR_RootConstrainSelectedInstOperands,
     /* 156215 */   // GIR_Coverage, 4494,
     /* 156215 */   GIR_EraseRootFromParent_Done,
     /* 156216 */ // Label 2403: @156216
     /* 156216 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(156285), // Rule ID 4496 //
     /* 156221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156231 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 156238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 156253 */   // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 156253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 156256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 156258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 156263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 156268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156283 */   GIR_RootConstrainSelectedInstOperands,
     /* 156284 */   // GIR_Coverage, 4496,
     /* 156284 */   GIR_EraseRootFromParent_Done,
     /* 156285 */ // Label 2404: @156285
     /* 156285 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(156347), // Rule ID 7935 //
     /* 156290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 156293 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156303 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156323 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 156326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156341 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156345 */   GIR_RootConstrainSelectedInstOperands,
     /* 156346 */   // GIR_Coverage, 7935,
     /* 156346 */   GIR_EraseRootFromParent_Done,
     /* 156347 */ // Label 2405: @156347
     /* 156347 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(156409), // Rule ID 7936 //
     /* 156352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 156355 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156358 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156365 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156385 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 156388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156407 */   GIR_RootConstrainSelectedInstOperands,
     /* 156408 */   // GIR_Coverage, 7936,
     /* 156408 */   GIR_EraseRootFromParent_Done,
     /* 156409 */ // Label 2406: @156409
     /* 156409 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(156471), // Rule ID 7943 //
     /* 156414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 156417 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156420 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156427 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156447 */   // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi16_glue>><<P:Predicate_zextloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 156450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156469 */   GIR_RootConstrainSelectedInstOperands,
     /* 156470 */   // GIR_Coverage, 7943,
     /* 156470 */   GIR_EraseRootFromParent_Done,
     /* 156471 */ // Label 2407: @156471
     /* 156471 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(156533), // Rule ID 7944 //
     /* 156476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 156479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156482 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156489 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156502 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156509 */   // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 156512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156531 */   GIR_RootConstrainSelectedInstOperands,
     /* 156532 */   // GIR_Coverage, 7944,
     /* 156532 */   GIR_EraseRootFromParent_Done,
     /* 156533 */ // Label 2408: @156533
     /* 156533 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(156595), // Rule ID 7984 //
     /* 156538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 156541 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156551 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156571 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
     /* 156574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156593 */   GIR_RootConstrainSelectedInstOperands,
     /* 156594 */   // GIR_Coverage, 7984,
     /* 156594 */   GIR_EraseRootFromParent_Done,
     /* 156595 */ // Label 2409: @156595
     /* 156595 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(156657), // Rule ID 7985 //
     /* 156600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 156603 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156613 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156633 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
     /* 156636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156655 */   GIR_RootConstrainSelectedInstOperands,
     /* 156656 */   // GIR_Coverage, 7985,
     /* 156656 */   GIR_EraseRootFromParent_Done,
     /* 156657 */ // Label 2410: @156657
     /* 156657 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(156719), // Rule ID 7998 //
     /* 156662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 156665 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156675 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156695 */   // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_16_glue>><<P:Predicate_atomic_load_zext_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
     /* 156698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156717 */   GIR_RootConstrainSelectedInstOperands,
     /* 156718 */   // GIR_Coverage, 7998,
     /* 156718 */   GIR_EraseRootFromParent_Done,
     /* 156719 */ // Label 2411: @156719
     /* 156719 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(156781), // Rule ID 7999 //
     /* 156724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 156727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156737 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 156742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156746 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156750 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 156757 */   // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 156757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
     /* 156760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 156767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 156772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156775 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156779 */   GIR_RootConstrainSelectedInstOperands,
     /* 156780 */   // GIR_Coverage, 7999,
     /* 156780 */   GIR_EraseRootFromParent_Done,
     /* 156781 */ // Label 2412: @156781
     /* 156781 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(156850), // Rule ID 3810 //
     /* 156786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156789 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156792 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156799 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 156806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 156821 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 156821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 156824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 156836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156848 */   GIR_RootConstrainSelectedInstOperands,
     /* 156849 */   // GIR_Coverage, 3810,
     /* 156849 */   GIR_EraseRootFromParent_Done,
     /* 156850 */ // Label 2413: @156850
     /* 156850 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(156919), // Rule ID 3818 //
     /* 156855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156858 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 156861 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156868 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 156875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156879 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156883 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 156890 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 156890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 156893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 156905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156917 */   GIR_RootConstrainSelectedInstOperands,
     /* 156918 */   // GIR_Coverage, 3818,
     /* 156918 */   GIR_EraseRootFromParent_Done,
     /* 156919 */ // Label 2414: @156919
     /* 156919 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(156988), // Rule ID 3828 //
     /* 156924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156937 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 156944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 156948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 156952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 156959 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 156959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
     /* 156962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 156964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 156969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 156974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 156979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 156982 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156986 */   GIR_RootConstrainSelectedInstOperands,
     /* 156987 */   // GIR_Coverage, 3828,
     /* 156987 */   GIR_EraseRootFromParent_Done,
     /* 156988 */ // Label 2415: @156988
     /* 156988 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(157057), // Rule ID 3834 //
     /* 156993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 156996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157006 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157017 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157021 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 157028 */   // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 157028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 157031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 157043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157055 */   GIR_RootConstrainSelectedInstOperands,
     /* 157056 */   // GIR_Coverage, 3834,
     /* 157056 */   GIR_EraseRootFromParent_Done,
     /* 157057 */ // Label 2416: @157057
     /* 157057 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(157126), // Rule ID 3846 //
     /* 157062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 157065 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157068 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157075 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 157097 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 157097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 157100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 157112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157124 */   GIR_RootConstrainSelectedInstOperands,
     /* 157125 */   // GIR_Coverage, 3846,
     /* 157125 */   GIR_EraseRootFromParent_Done,
     /* 157126 */ // Label 2417: @157126
     /* 157126 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(157195), // Rule ID 3858 //
     /* 157131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 157134 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157144 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157155 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 157166 */   // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 157166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
     /* 157169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 157176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 157181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 157186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157193 */   GIR_RootConstrainSelectedInstOperands,
     /* 157194 */   // GIR_Coverage, 3858,
     /* 157194 */   GIR_EraseRootFromParent_Done,
     /* 157195 */ // Label 2418: @157195
     /* 157195 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(157259), // Rule ID 3809 //
     /* 157200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 157213 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157228 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157235 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 157238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157253 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157257 */   GIR_RootConstrainSelectedInstOperands,
     /* 157258 */   // GIR_Coverage, 3809,
     /* 157258 */   GIR_EraseRootFromParent_Done,
     /* 157259 */ // Label 2419: @157259
     /* 157259 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(157323), // Rule ID 3817 //
     /* 157264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157267 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157277 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157292 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157299 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 157302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157321 */   GIR_RootConstrainSelectedInstOperands,
     /* 157322 */   // GIR_Coverage, 3817,
     /* 157322 */   GIR_EraseRootFromParent_Done,
     /* 157323 */ // Label 2420: @157323
     /* 157323 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(157387), // Rule ID 3827 //
     /* 157328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157334 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 157341 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157352 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157356 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157363 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
     /* 157366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157385 */   GIR_RootConstrainSelectedInstOperands,
     /* 157386 */   // GIR_Coverage, 3827,
     /* 157386 */   GIR_EraseRootFromParent_Done,
     /* 157387 */ // Label 2421: @157387
     /* 157387 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(157451), // Rule ID 3833 //
     /* 157392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 157395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157405 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157427 */   // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 157430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157445 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157449 */   GIR_RootConstrainSelectedInstOperands,
     /* 157450 */   // GIR_Coverage, 3833,
     /* 157450 */   GIR_EraseRootFromParent_Done,
     /* 157451 */ // Label 2422: @157451
     /* 157451 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(157515), // Rule ID 3845 //
     /* 157456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 157459 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157462 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157469 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157491 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 157494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157513 */   GIR_RootConstrainSelectedInstOperands,
     /* 157514 */   // GIR_Coverage, 3845,
     /* 157514 */   GIR_EraseRootFromParent_Done,
     /* 157515 */ // Label 2423: @157515
     /* 157515 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(157579), // Rule ID 3857 //
     /* 157520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 157523 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157526 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157533 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 157555 */   // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
     /* 157558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157573 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157577 */   GIR_RootConstrainSelectedInstOperands,
     /* 157578 */   // GIR_Coverage, 3857,
     /* 157578 */   GIR_EraseRootFromParent_Done,
     /* 157579 */ // Label 2424: @157579
     /* 157579 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(157644), // Rule ID 3583 //
     /* 157584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 157587 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157590 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 157597 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 157620 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 157623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157642 */   GIR_RootConstrainSelectedInstOperands,
     /* 157643 */   // GIR_Coverage, 3583,
     /* 157643 */   GIR_EraseRootFromParent_Done,
     /* 157644 */ // Label 2425: @157644
     /* 157644 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(157709), // Rule ID 3587 //
     /* 157649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 157652 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 157655 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157662 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 157685 */   // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 157688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157707 */   GIR_RootConstrainSelectedInstOperands,
     /* 157708 */   // GIR_Coverage, 3587,
     /* 157708 */   GIR_EraseRootFromParent_Done,
     /* 157709 */ // Label 2426: @157709
     /* 157709 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(157774), // Rule ID 3589 //
     /* 157714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 157717 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 157727 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 157750 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
     /* 157753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157772 */   GIR_RootConstrainSelectedInstOperands,
     /* 157773 */   // GIR_Coverage, 3589,
     /* 157773 */   GIR_EraseRootFromParent_Done,
     /* 157774 */ // Label 2427: @157774
     /* 157774 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(157839), // Rule ID 3594 //
     /* 157779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 157782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157785 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157792 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 157800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 157804 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 157815 */   // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 157815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
     /* 157818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 157820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 157825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 157830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 157833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157837 */   GIR_RootConstrainSelectedInstOperands,
     /* 157838 */   // GIR_Coverage, 3594,
     /* 157838 */   GIR_EraseRootFromParent_Done,
     /* 157839 */ // Label 2428: @157839
     /* 157839 */ GIM_Reject,
     /* 157840 */ // Label 2321: @157840
     /* 157840 */ GIM_Reject,
     /* 157841 */ // Label 17: @157841
     /* 157841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 2446*/ GIMT_Encode4(191745),
     /* 157852 */ /*GILLT_p0s64*//*Label 2429*/ GIMT_Encode4(157944),
     /* 157856 */ /*GILLT_p1s64*//*Label 2430*/ GIMT_Encode4(158937),
     /* 157860 */ /*GILLT_p2s32*//*Label 2431*/ GIMT_Encode4(159930),
     /* 157864 */ /*GILLT_p3s32*//*Label 2432*/ GIMT_Encode4(160801),
     /* 157868 */ /*GILLT_p4s64*//*Label 2433*/ GIMT_Encode4(161672),
     /* 157872 */ /*GILLT_p5s32*//*Label 2434*/ GIMT_Encode4(162665),
     /* 157876 */ /*GILLT_p6s32*//*Label 2435*/ GIMT_Encode4(163536), GIMT_Encode4(0),
     /* 157884 */ /*GILLT_s16*//*Label 2436*/ GIMT_Encode4(164407),
     /* 157888 */ /*GILLT_s32*//*Label 2437*/ GIMT_Encode4(168718),
     /* 157892 */ /*GILLT_s64*//*Label 2438*/ GIMT_Encode4(175820),
     /* 157896 */ /*GILLT_v2s16*//*Label 2439*/ GIMT_Encode4(178250),
     /* 157900 */ /*GILLT_v2s32*//*Label 2440*/ GIMT_Encode4(179982),
     /* 157904 */ /*GILLT_v2s64*//*Label 2441*/ GIMT_Encode4(182192),
     /* 157908 */ /*GILLT_v3s32*//*Label 2442*/ GIMT_Encode4(184168), GIMT_Encode4(0),
     /* 157916 */ /*GILLT_v4s16*//*Label 2443*/ GIMT_Encode4(185583),
     /* 157920 */ /*GILLT_v4s32*//*Label 2444*/ GIMT_Encode4(187559), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157940 */ /*GILLT_v8s16*//*Label 2445*/ GIMT_Encode4(189769),
     /* 157944 */ // Label 2429: @157944
     /* 157944 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(158936),
     /* 157949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157952 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(158013), // Rule ID 8218 //
     /* 157957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 157960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 157964 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157969 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 157974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 157978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 157982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 157989 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 157989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 157992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 157997 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 157999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158011 */     GIR_RootConstrainSelectedInstOperands,
     /* 158012 */     // GIR_Coverage, 8218,
     /* 158012 */     GIR_EraseRootFromParent_Done,
     /* 158013 */   // Label 2448: @158013
     /* 158013 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(158069), // Rule ID 8150 //
     /* 158018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 158021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 158025 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158030 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 158034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 158045 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 158045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 158048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158053 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158067 */     GIR_RootConstrainSelectedInstOperands,
     /* 158068 */     // GIR_Coverage, 8150,
     /* 158068 */     GIR_EraseRootFromParent_Done,
     /* 158069 */   // Label 2449: @158069
     /* 158069 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(158126), // Rule ID 8219 //
     /* 158074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 158077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158082 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 158095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 158102 */     // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 158102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 158105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158110 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158124 */     GIR_RootConstrainSelectedInstOperands,
     /* 158125 */     // GIR_Coverage, 8219,
     /* 158125 */     GIR_EraseRootFromParent_Done,
     /* 158126 */   // Label 2450: @158126
     /* 158126 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(158178), // Rule ID 8151 //
     /* 158131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 158134 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158139 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 158143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 158154 */     // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 158154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 158157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158162 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158176 */     GIR_RootConstrainSelectedInstOperands,
     /* 158177 */     // GIR_Coverage, 8151,
     /* 158177 */     GIR_EraseRootFromParent_Done,
     /* 158178 */   // Label 2451: @158178
     /* 158178 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(158231), // Rule ID 4340 //
     /* 158183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 158186 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 158202 */     // (st p0:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 158205 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 158217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158229 */     GIR_RootConstrainSelectedInstOperands,
     /* 158230 */     // GIR_Coverage, 4340,
     /* 158230 */     GIR_EraseRootFromParent_Done,
     /* 158231 */   // Label 2452: @158231
     /* 158231 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(158279), // Rule ID 4339 //
     /* 158236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 158239 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 158255 */     // (st p0:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 158258 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 158265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158277 */     GIR_RootConstrainSelectedInstOperands,
     /* 158278 */     // GIR_Coverage, 4339,
     /* 158278 */     GIR_EraseRootFromParent_Done,
     /* 158279 */   // Label 2453: @158279
     /* 158279 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(158327), // Rule ID 4338 //
     /* 158284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 158287 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 158292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 158303 */     // (st p0:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 158303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 158306 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158325 */     GIR_RootConstrainSelectedInstOperands,
     /* 158326 */     // GIR_Coverage, 4338,
     /* 158326 */     GIR_EraseRootFromParent_Done,
     /* 158327 */   // Label 2454: @158327
     /* 158327 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(158388), // Rule ID 4669 //
     /* 158332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 158335 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 158351 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 158354 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 158361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 158371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 158376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158386 */     GIR_RootConstrainSelectedInstOperands,
     /* 158387 */     // GIR_Coverage, 4669,
     /* 158387 */     GIR_EraseRootFromParent_Done,
     /* 158388 */   // Label 2455: @158388
     /* 158388 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(158446), // Rule ID 4671 //
     /* 158393 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 158409 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 158412 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 158419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 158429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 158434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158444 */     GIR_RootConstrainSelectedInstOperands,
     /* 158445 */     // GIR_Coverage, 4671,
     /* 158445 */     GIR_EraseRootFromParent_Done,
     /* 158446 */   // Label 2456: @158446
     /* 158446 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(158563), // Rule ID 8093 //
     /* 158451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 158454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 158458 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 158474 */     // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 158474 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158477 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158481 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158486 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 158492 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158514 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 158520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 158533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 158549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 158554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158561 */     GIR_RootConstrainSelectedInstOperands,
     /* 158562 */     // GIR_Coverage, 8093,
     /* 158562 */     GIR_EraseRootFromParent_Done,
     /* 158563 */   // Label 2457: @158563
     /* 158563 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(158619), // Rule ID 4668 //
     /* 158568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 158571 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 158587 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 158590 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158617 */     GIR_RootConstrainSelectedInstOperands,
     /* 158618 */     // GIR_Coverage, 4668,
     /* 158618 */     GIR_EraseRootFromParent_Done,
     /* 158619 */   // Label 2458: @158619
     /* 158619 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(158672), // Rule ID 4670 //
     /* 158624 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 158640 */     // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 158640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 158643 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 158645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 158650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 158655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158670 */     GIR_RootConstrainSelectedInstOperands,
     /* 158671 */     // GIR_Coverage, 4670,
     /* 158671 */     GIR_EraseRootFromParent_Done,
     /* 158672 */   // Label 2459: @158672
     /* 158672 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(158785), // Rule ID 8095 //
     /* 158677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 158680 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 158696 */     // (st p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 158696 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158699 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158703 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158708 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 158714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158736 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 158742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 158747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 158752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 158755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 158766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 158771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 158776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158783 */     GIR_RootConstrainSelectedInstOperands,
     /* 158784 */     // GIR_Coverage, 8095,
     /* 158784 */     GIR_EraseRootFromParent_Done,
     /* 158785 */   // Label 2460: @158785
     /* 158785 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(158838), // Rule ID 3926 //
     /* 158790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 158793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 158809 */     // (st p0:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 158809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 158812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 158817 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 158824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 158829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158836 */     GIR_RootConstrainSelectedInstOperands,
     /* 158837 */     // GIR_Coverage, 3926,
     /* 158837 */     GIR_EraseRootFromParent_Done,
     /* 158838 */   // Label 2461: @158838
     /* 158838 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(158886), // Rule ID 3925 //
     /* 158843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 158846 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 158851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 158862 */     // (st p0:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 158862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 158865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158870 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158884 */     GIR_RootConstrainSelectedInstOperands,
     /* 158885 */     // GIR_Coverage, 3925,
     /* 158885 */     GIR_EraseRootFromParent_Done,
     /* 158886 */   // Label 2462: @158886
     /* 158886 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(158935), // Rule ID 3648 //
     /* 158891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 158894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 158900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 158911 */     // (st p0:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 158911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 158914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 158919 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 158921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 158929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158933 */     GIR_RootConstrainSelectedInstOperands,
     /* 158934 */     // GIR_Coverage, 3648,
     /* 158934 */     GIR_EraseRootFromParent_Done,
     /* 158935 */   // Label 2463: @158935
     /* 158935 */   GIM_Reject,
     /* 158936 */ // Label 2447: @158936
     /* 158936 */ GIM_Reject,
     /* 158937 */ // Label 2430: @158937
     /* 158937 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(159929),
     /* 158942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158945 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(159006), // Rule ID 8222 //
     /* 158950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 158953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 158957 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158962 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 158967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 158971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 158975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 158982 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 158982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 158985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 158990 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 158992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 158997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159004 */     GIR_RootConstrainSelectedInstOperands,
     /* 159005 */     // GIR_Coverage, 8222,
     /* 159005 */     GIR_EraseRootFromParent_Done,
     /* 159006 */   // Label 2465: @159006
     /* 159006 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(159062), // Rule ID 8154 //
     /* 159011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 159014 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 159018 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159023 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 159027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 159038 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 159038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 159041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159046 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159060 */     GIR_RootConstrainSelectedInstOperands,
     /* 159061 */     // GIR_Coverage, 8154,
     /* 159061 */     GIR_EraseRootFromParent_Done,
     /* 159062 */   // Label 2466: @159062
     /* 159062 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(159119), // Rule ID 8223 //
     /* 159067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 159070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159075 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 159088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 159095 */     // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 159095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 159098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159103 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159117 */     GIR_RootConstrainSelectedInstOperands,
     /* 159118 */     // GIR_Coverage, 8223,
     /* 159118 */     GIR_EraseRootFromParent_Done,
     /* 159119 */   // Label 2467: @159119
     /* 159119 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(159171), // Rule ID 8155 //
     /* 159124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 159127 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159132 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 159136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 159147 */     // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 159147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 159150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159155 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159169 */     GIR_RootConstrainSelectedInstOperands,
     /* 159170 */     // GIR_Coverage, 8155,
     /* 159170 */     GIR_EraseRootFromParent_Done,
     /* 159171 */   // Label 2468: @159171
     /* 159171 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(159224), // Rule ID 4346 //
     /* 159176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 159179 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 159195 */     // (st p1:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 159198 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 159210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159222 */     GIR_RootConstrainSelectedInstOperands,
     /* 159223 */     // GIR_Coverage, 4346,
     /* 159223 */     GIR_EraseRootFromParent_Done,
     /* 159224 */   // Label 2469: @159224
     /* 159224 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(159272), // Rule ID 4345 //
     /* 159229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159232 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 159248 */     // (st p1:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 159251 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 159258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159270 */     GIR_RootConstrainSelectedInstOperands,
     /* 159271 */     // GIR_Coverage, 4345,
     /* 159271 */     GIR_EraseRootFromParent_Done,
     /* 159272 */   // Label 2470: @159272
     /* 159272 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(159320), // Rule ID 4344 //
     /* 159277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 159280 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 159296 */     // (st p1:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 159296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 159299 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159318 */     GIR_RootConstrainSelectedInstOperands,
     /* 159319 */     // GIR_Coverage, 4344,
     /* 159319 */     GIR_EraseRootFromParent_Done,
     /* 159320 */   // Label 2471: @159320
     /* 159320 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(159381), // Rule ID 4673 //
     /* 159325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 159328 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 159344 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 159347 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159379 */     GIR_RootConstrainSelectedInstOperands,
     /* 159380 */     // GIR_Coverage, 4673,
     /* 159380 */     GIR_EraseRootFromParent_Done,
     /* 159381 */   // Label 2472: @159381
     /* 159381 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(159439), // Rule ID 4675 //
     /* 159386 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 159402 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 159405 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 159412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 159422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 159427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159437 */     GIR_RootConstrainSelectedInstOperands,
     /* 159438 */     // GIR_Coverage, 4675,
     /* 159438 */     GIR_EraseRootFromParent_Done,
     /* 159439 */   // Label 2473: @159439
     /* 159439 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(159556), // Rule ID 8097 //
     /* 159444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 159447 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 159451 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 159467 */     // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 159467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159479 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 159485 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 159490 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 159495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159507 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 159513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 159518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 159523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 159526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 159537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 159542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 159547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159554 */     GIR_RootConstrainSelectedInstOperands,
     /* 159555 */     // GIR_Coverage, 8097,
     /* 159555 */     GIR_EraseRootFromParent_Done,
     /* 159556 */   // Label 2474: @159556
     /* 159556 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(159612), // Rule ID 4672 //
     /* 159561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 159564 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 159580 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 159583 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159610 */     GIR_RootConstrainSelectedInstOperands,
     /* 159611 */     // GIR_Coverage, 4672,
     /* 159611 */     GIR_EraseRootFromParent_Done,
     /* 159612 */   // Label 2475: @159612
     /* 159612 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(159665), // Rule ID 4674 //
     /* 159617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 159633 */     // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 159633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 159636 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 159638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159663 */     GIR_RootConstrainSelectedInstOperands,
     /* 159664 */     // GIR_Coverage, 4674,
     /* 159664 */     GIR_EraseRootFromParent_Done,
     /* 159665 */   // Label 2476: @159665
     /* 159665 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(159778), // Rule ID 8099 //
     /* 159670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 159673 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 159678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 159689 */     // (st p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 159689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159701 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 159707 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 159712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 159717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159729 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 159735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 159740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 159745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 159748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 159753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 159759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 159764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 159769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159776 */     GIR_RootConstrainSelectedInstOperands,
     /* 159777 */     // GIR_Coverage, 8099,
     /* 159777 */     GIR_EraseRootFromParent_Done,
     /* 159778 */   // Label 2477: @159778
     /* 159778 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(159831), // Rule ID 3930 //
     /* 159783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 159786 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 159802 */     // (st p1:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 159802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 159805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 159810 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 159817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159829 */     GIR_RootConstrainSelectedInstOperands,
     /* 159830 */     // GIR_Coverage, 3930,
     /* 159830 */     GIR_EraseRootFromParent_Done,
     /* 159831 */   // Label 2478: @159831
     /* 159831 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(159879), // Rule ID 3929 //
     /* 159836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 159839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 159844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 159855 */     // (st p1:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 159855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 159858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159863 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159877 */     GIR_RootConstrainSelectedInstOperands,
     /* 159878 */     // GIR_Coverage, 3929,
     /* 159878 */     GIR_EraseRootFromParent_Done,
     /* 159879 */   // Label 2479: @159879
     /* 159879 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(159928), // Rule ID 3650 //
     /* 159884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 159887 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 159893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 159904 */     // (st p1:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 159904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 159907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 159912 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 159914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 159919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159926 */     GIR_RootConstrainSelectedInstOperands,
     /* 159927 */     // GIR_Coverage, 3650,
     /* 159927 */     GIR_EraseRootFromParent_Done,
     /* 159928 */   // Label 2480: @159928
     /* 159928 */   GIM_Reject,
     /* 159929 */ // Label 2464: @159929
     /* 159929 */ GIM_Reject,
     /* 159930 */ // Label 2431: @159930
     /* 159930 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(160800),
     /* 159935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159938 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(159994), // Rule ID 6629 //
     /* 159943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 159946 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 159951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 159955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 159962 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 159962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 159967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 159972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 159977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 159982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 159988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159992 */     GIR_RootConstrainSelectedInstOperands,
     /* 159993 */     // GIR_Coverage, 6629,
     /* 159993 */     GIR_EraseRootFromParent_Done,
     /* 159994 */   // Label 2482: @159994
     /* 159994 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(160050), // Rule ID 6631 //
     /* 159999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160002 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160018 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 160021 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160048 */     GIR_RootConstrainSelectedInstOperands,
     /* 160049 */     // GIR_Coverage, 6631,
     /* 160049 */     GIR_EraseRootFromParent_Done,
     /* 160050 */   // Label 2483: @160050
     /* 160050 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(160103), // Rule ID 4280 //
     /* 160055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 160058 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160074 */     // (st p2:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 160077 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160101 */     GIR_RootConstrainSelectedInstOperands,
     /* 160102 */     // GIR_Coverage, 4280,
     /* 160102 */     GIR_EraseRootFromParent_Done,
     /* 160103 */   // Label 2484: @160103
     /* 160103 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(160151), // Rule ID 4279 //
     /* 160108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 160111 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 160127 */     // (st p2:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 160130 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 160137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160149 */     GIR_RootConstrainSelectedInstOperands,
     /* 160150 */     // GIR_Coverage, 4279,
     /* 160150 */     GIR_EraseRootFromParent_Done,
     /* 160151 */   // Label 2485: @160151
     /* 160151 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(160199), // Rule ID 4278 //
     /* 160156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 160159 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 160175 */     // (st p2:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 160175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 160178 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160197 */     GIR_RootConstrainSelectedInstOperands,
     /* 160198 */     // GIR_Coverage, 4278,
     /* 160198 */     GIR_EraseRootFromParent_Done,
     /* 160199 */   // Label 2486: @160199
     /* 160199 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(160260), // Rule ID 4629 //
     /* 160204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 160207 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 160223 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 160226 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160258 */     GIR_RootConstrainSelectedInstOperands,
     /* 160259 */     // GIR_Coverage, 4629,
     /* 160259 */     GIR_EraseRootFromParent_Done,
     /* 160260 */   // Label 2487: @160260
     /* 160260 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(160318), // Rule ID 4631 //
     /* 160265 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 160281 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 160284 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160316 */     GIR_RootConstrainSelectedInstOperands,
     /* 160317 */     // GIR_Coverage, 4631,
     /* 160317 */     GIR_EraseRootFromParent_Done,
     /* 160318 */   // Label 2488: @160318
     /* 160318 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(160379), // Rule ID 6628 //
     /* 160323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 160326 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 160342 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 160345 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160377 */     GIR_RootConstrainSelectedInstOperands,
     /* 160378 */     // GIR_Coverage, 6628,
     /* 160378 */     GIR_EraseRootFromParent_Done,
     /* 160379 */   // Label 2489: @160379
     /* 160379 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(160440), // Rule ID 6630 //
     /* 160384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160387 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 160403 */     // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 160406 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 160413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 160423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 160428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160438 */     GIR_RootConstrainSelectedInstOperands,
     /* 160439 */     // GIR_Coverage, 6630,
     /* 160439 */     GIR_EraseRootFromParent_Done,
     /* 160440 */   // Label 2490: @160440
     /* 160440 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(160496), // Rule ID 4628 //
     /* 160445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 160448 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 160464 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 160467 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160494 */     GIR_RootConstrainSelectedInstOperands,
     /* 160495 */     // GIR_Coverage, 4628,
     /* 160495 */     GIR_EraseRootFromParent_Done,
     /* 160496 */   // Label 2491: @160496
     /* 160496 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(160549), // Rule ID 4630 //
     /* 160501 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 160517 */     // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 160517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 160520 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 160522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160547 */     GIR_RootConstrainSelectedInstOperands,
     /* 160548 */     // GIR_Coverage, 4630,
     /* 160548 */     GIR_EraseRootFromParent_Done,
     /* 160549 */   // Label 2492: @160549
     /* 160549 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(160601), // Rule ID 8038 //
     /* 160554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 160557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 160561 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 160566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 160577 */     // (AMDGPUst_glue p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 160577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 160580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 160585 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160599 */     GIR_RootConstrainSelectedInstOperands,
     /* 160600 */     // GIR_Coverage, 8038,
     /* 160600 */     GIR_EraseRootFromParent_Done,
     /* 160601 */   // Label 2493: @160601
     /* 160601 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(160649), // Rule ID 8039 //
     /* 160606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 160609 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 160614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 160625 */     // (st p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 160625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 160628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 160633 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160647 */     GIR_RootConstrainSelectedInstOperands,
     /* 160648 */     // GIR_Coverage, 8039,
     /* 160648 */     GIR_EraseRootFromParent_Done,
     /* 160649 */   // Label 2494: @160649
     /* 160649 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(160702), // Rule ID 3886 //
     /* 160654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 160657 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 160673 */     // (st p2:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 160676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 160681 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 160688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160700 */     GIR_RootConstrainSelectedInstOperands,
     /* 160701 */     // GIR_Coverage, 3886,
     /* 160701 */     GIR_EraseRootFromParent_Done,
     /* 160702 */   // Label 2495: @160702
     /* 160702 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(160750), // Rule ID 3885 //
     /* 160707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 160710 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 160715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 160726 */     // (st p2:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 160726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 160729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160734 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160748 */     GIR_RootConstrainSelectedInstOperands,
     /* 160749 */     // GIR_Coverage, 3885,
     /* 160749 */     GIR_EraseRootFromParent_Done,
     /* 160750 */   // Label 2496: @160750
     /* 160750 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(160799), // Rule ID 3629 //
     /* 160755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 160758 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 160764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 160775 */     // (st p2:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 160775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 160778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160783 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 160790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160797 */     GIR_RootConstrainSelectedInstOperands,
     /* 160798 */     // GIR_Coverage, 3629,
     /* 160798 */     GIR_EraseRootFromParent_Done,
     /* 160799 */   // Label 2497: @160799
     /* 160799 */   GIM_Reject,
     /* 160800 */ // Label 2481: @160800
     /* 160800 */ GIM_Reject,
     /* 160801 */ // Label 2432: @160801
     /* 160801 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(161671),
     /* 160806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160809 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(160865), // Rule ID 6633 //
     /* 160814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 160817 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160833 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 160836 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160863 */     GIR_RootConstrainSelectedInstOperands,
     /* 160864 */     // GIR_Coverage, 6633,
     /* 160864 */     GIR_EraseRootFromParent_Done,
     /* 160865 */   // Label 2499: @160865
     /* 160865 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(160921), // Rule ID 6635 //
     /* 160870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 160873 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 160889 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 160889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 160892 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 160894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 160899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 160904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160919 */     GIR_RootConstrainSelectedInstOperands,
     /* 160920 */     // GIR_Coverage, 6635,
     /* 160920 */     GIR_EraseRootFromParent_Done,
     /* 160921 */   // Label 2500: @160921
     /* 160921 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(160974), // Rule ID 4286 //
     /* 160926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 160929 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 160945 */     // (st p3:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 160948 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 160950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 160955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 160960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 160965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 160968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160972 */     GIR_RootConstrainSelectedInstOperands,
     /* 160973 */     // GIR_Coverage, 4286,
     /* 160973 */     GIR_EraseRootFromParent_Done,
     /* 160974 */   // Label 2501: @160974
     /* 160974 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(161022), // Rule ID 4285 //
     /* 160979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 160982 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 160987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 160991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 160998 */     // (st p3:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 160998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 161001 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161020 */     GIR_RootConstrainSelectedInstOperands,
     /* 161021 */     // GIR_Coverage, 4285,
     /* 161021 */     GIR_EraseRootFromParent_Done,
     /* 161022 */   // Label 2502: @161022
     /* 161022 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(161070), // Rule ID 4284 //
     /* 161027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 161030 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 161046 */     // (st p3:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 161046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 161049 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161068 */     GIR_RootConstrainSelectedInstOperands,
     /* 161069 */     // GIR_Coverage, 4284,
     /* 161069 */     GIR_EraseRootFromParent_Done,
     /* 161070 */   // Label 2503: @161070
     /* 161070 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(161131), // Rule ID 4633 //
     /* 161075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 161078 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 161094 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 161094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 161097 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 161099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161129 */     GIR_RootConstrainSelectedInstOperands,
     /* 161130 */     // GIR_Coverage, 4633,
     /* 161130 */     GIR_EraseRootFromParent_Done,
     /* 161131 */   // Label 2504: @161131
     /* 161131 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(161189), // Rule ID 4635 //
     /* 161136 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 161152 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 161152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 161155 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 161157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161187 */     GIR_RootConstrainSelectedInstOperands,
     /* 161188 */     // GIR_Coverage, 4635,
     /* 161188 */     GIR_EraseRootFromParent_Done,
     /* 161189 */   // Label 2505: @161189
     /* 161189 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(161250), // Rule ID 6632 //
     /* 161194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 161197 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 161213 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 161213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 161216 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161248 */     GIR_RootConstrainSelectedInstOperands,
     /* 161249 */     // GIR_Coverage, 6632,
     /* 161249 */     GIR_EraseRootFromParent_Done,
     /* 161250 */   // Label 2506: @161250
     /* 161250 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(161311), // Rule ID 6634 //
     /* 161255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 161258 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 161274 */     // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 161274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 161277 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 161284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 161294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 161299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161309 */     GIR_RootConstrainSelectedInstOperands,
     /* 161310 */     // GIR_Coverage, 6634,
     /* 161310 */     GIR_EraseRootFromParent_Done,
     /* 161311 */   // Label 2507: @161311
     /* 161311 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(161367), // Rule ID 4632 //
     /* 161316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 161319 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 161335 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 161335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 161338 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 161340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 161350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161365 */     GIR_RootConstrainSelectedInstOperands,
     /* 161366 */     // GIR_Coverage, 4632,
     /* 161366 */     GIR_EraseRootFromParent_Done,
     /* 161367 */   // Label 2508: @161367
     /* 161367 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(161420), // Rule ID 4634 //
     /* 161372 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 161388 */     // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 161388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 161391 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 161393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 161398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 161403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161418 */     GIR_RootConstrainSelectedInstOperands,
     /* 161419 */     // GIR_Coverage, 4634,
     /* 161419 */     GIR_EraseRootFromParent_Done,
     /* 161420 */   // Label 2509: @161420
     /* 161420 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(161472), // Rule ID 8040 //
     /* 161425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 161428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161432 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 161448 */     // (AMDGPUst_glue p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 161448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 161451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 161456 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161470 */     GIR_RootConstrainSelectedInstOperands,
     /* 161471 */     // GIR_Coverage, 8040,
     /* 161471 */     GIR_EraseRootFromParent_Done,
     /* 161472 */   // Label 2510: @161472
     /* 161472 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(161520), // Rule ID 8041 //
     /* 161477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 161480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 161496 */     // (st p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 161496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 161499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 161504 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161518 */     GIR_RootConstrainSelectedInstOperands,
     /* 161519 */     // GIR_Coverage, 8041,
     /* 161519 */     GIR_EraseRootFromParent_Done,
     /* 161520 */   // Label 2511: @161520
     /* 161520 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(161573), // Rule ID 3890 //
     /* 161525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 161528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 161544 */     // (st p3:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 161547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 161552 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161571 */     GIR_RootConstrainSelectedInstOperands,
     /* 161572 */     // GIR_Coverage, 3890,
     /* 161572 */     GIR_EraseRootFromParent_Done,
     /* 161573 */   // Label 2512: @161573
     /* 161573 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(161621), // Rule ID 3889 //
     /* 161578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 161581 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 161586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 161597 */     // (st p3:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 161597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 161600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161605 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161619 */     GIR_RootConstrainSelectedInstOperands,
     /* 161620 */     // GIR_Coverage, 3889,
     /* 161620 */     GIR_EraseRootFromParent_Done,
     /* 161621 */   // Label 2513: @161621
     /* 161621 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(161670), // Rule ID 3631 //
     /* 161626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 161629 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 161635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 161646 */     // (st p3:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 161646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 161649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161654 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161668 */     GIR_RootConstrainSelectedInstOperands,
     /* 161669 */     // GIR_Coverage, 3631,
     /* 161669 */     GIR_EraseRootFromParent_Done,
     /* 161670 */   // Label 2514: @161670
     /* 161670 */   GIM_Reject,
     /* 161671 */ // Label 2498: @161671
     /* 161671 */ GIM_Reject,
     /* 161672 */ // Label 2433: @161672
     /* 161672 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(162664),
     /* 161677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161680 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(161741), // Rule ID 8226 //
     /* 161685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 161688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161692 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161697 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 161710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 161717 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 161717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 161720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 161725 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161739 */     GIR_RootConstrainSelectedInstOperands,
     /* 161740 */     // GIR_Coverage, 8226,
     /* 161740 */     GIR_EraseRootFromParent_Done,
     /* 161741 */   // Label 2516: @161741
     /* 161741 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(161797), // Rule ID 8158 //
     /* 161746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 161749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 161753 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161758 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 161762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 161773 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 161773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 161776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 161781 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161795 */     GIR_RootConstrainSelectedInstOperands,
     /* 161796 */     // GIR_Coverage, 8158,
     /* 161796 */     GIR_EraseRootFromParent_Done,
     /* 161797 */   // Label 2517: @161797
     /* 161797 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(161854), // Rule ID 8227 //
     /* 161802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 161805 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161810 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 161823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 161830 */     // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 161830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 161833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 161838 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161852 */     GIR_RootConstrainSelectedInstOperands,
     /* 161853 */     // GIR_Coverage, 8227,
     /* 161853 */     GIR_EraseRootFromParent_Done,
     /* 161854 */   // Label 2518: @161854
     /* 161854 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(161906), // Rule ID 8159 //
     /* 161859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 161862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 161867 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 161871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 161882 */     // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 161882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 161885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 161890 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 161892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161904 */     GIR_RootConstrainSelectedInstOperands,
     /* 161905 */     // GIR_Coverage, 8159,
     /* 161905 */     GIR_EraseRootFromParent_Done,
     /* 161906 */   // Label 2519: @161906
     /* 161906 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(161959), // Rule ID 4352 //
     /* 161911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 161914 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 161930 */     // (st p4:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 161933 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 161940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 161945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 161950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 161953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 161957 */     GIR_RootConstrainSelectedInstOperands,
     /* 161958 */     // GIR_Coverage, 4352,
     /* 161958 */     GIR_EraseRootFromParent_Done,
     /* 161959 */   // Label 2520: @161959
     /* 161959 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(162007), // Rule ID 4351 //
     /* 161964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 161967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 161972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 161976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 161983 */     // (st p4:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 161983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 161986 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 161988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 161993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 161998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162005 */     GIR_RootConstrainSelectedInstOperands,
     /* 162006 */     // GIR_Coverage, 4351,
     /* 162006 */     GIR_EraseRootFromParent_Done,
     /* 162007 */   // Label 2521: @162007
     /* 162007 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(162055), // Rule ID 4350 //
     /* 162012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 162015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 162031 */     // (st p4:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 162031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 162034 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 162036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 162041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162053 */     GIR_RootConstrainSelectedInstOperands,
     /* 162054 */     // GIR_Coverage, 4350,
     /* 162054 */     GIR_EraseRootFromParent_Done,
     /* 162055 */   // Label 2522: @162055
     /* 162055 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(162116), // Rule ID 4677 //
     /* 162060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 162063 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 162079 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 162079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 162082 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162114 */     GIR_RootConstrainSelectedInstOperands,
     /* 162115 */     // GIR_Coverage, 4677,
     /* 162115 */     GIR_EraseRootFromParent_Done,
     /* 162116 */   // Label 2523: @162116
     /* 162116 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(162174), // Rule ID 4679 //
     /* 162121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 162137 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 162137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 162140 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162172 */     GIR_RootConstrainSelectedInstOperands,
     /* 162173 */     // GIR_Coverage, 4679,
     /* 162173 */     GIR_EraseRootFromParent_Done,
     /* 162174 */   // Label 2524: @162174
     /* 162174 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(162291), // Rule ID 8101 //
     /* 162179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 162182 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 162186 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 162202 */     // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 162202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 162205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162214 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 162220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 162225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 162230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 162233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162242 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 162248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 162253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 162258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 162261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 162272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 162277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 162282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162289 */     GIR_RootConstrainSelectedInstOperands,
     /* 162290 */     // GIR_Coverage, 8101,
     /* 162290 */     GIR_EraseRootFromParent_Done,
     /* 162291 */   // Label 2525: @162291
     /* 162291 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(162347), // Rule ID 4676 //
     /* 162296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 162299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162315 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 162315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 162318 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162345 */     GIR_RootConstrainSelectedInstOperands,
     /* 162346 */     // GIR_Coverage, 4676,
     /* 162346 */     GIR_EraseRootFromParent_Done,
     /* 162347 */   // Label 2526: @162347
     /* 162347 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(162400), // Rule ID 4678 //
     /* 162352 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 162368 */     // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 162368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 162371 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162398 */     GIR_RootConstrainSelectedInstOperands,
     /* 162399 */     // GIR_Coverage, 4678,
     /* 162399 */     GIR_EraseRootFromParent_Done,
     /* 162400 */   // Label 2527: @162400
     /* 162400 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(162513), // Rule ID 8103 //
     /* 162405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 162408 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 162413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 162424 */     // (st p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 162424 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 162427 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162431 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162436 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 162442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 162447 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 162452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 162455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162464 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 162470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 162475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 162480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 162483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 162488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 162494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 162499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 162504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162511 */     GIR_RootConstrainSelectedInstOperands,
     /* 162512 */     // GIR_Coverage, 8103,
     /* 162512 */     GIR_EraseRootFromParent_Done,
     /* 162513 */   // Label 2528: @162513
     /* 162513 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(162566), // Rule ID 3934 //
     /* 162518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 162521 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 162537 */     // (st p4:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 162537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 162540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 162545 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 162547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 162552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162564 */     GIR_RootConstrainSelectedInstOperands,
     /* 162565 */     // GIR_Coverage, 3934,
     /* 162565 */     GIR_EraseRootFromParent_Done,
     /* 162566 */   // Label 2529: @162566
     /* 162566 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(162614), // Rule ID 3933 //
     /* 162571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 162574 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 162590 */     // (st p4:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 162590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 162593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 162598 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 162600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162612 */     GIR_RootConstrainSelectedInstOperands,
     /* 162613 */     // GIR_Coverage, 3933,
     /* 162613 */     GIR_EraseRootFromParent_Done,
     /* 162614 */   // Label 2530: @162614
     /* 162614 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(162663), // Rule ID 3652 //
     /* 162619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 162622 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 162628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 162639 */     // (st p4:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 162639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 162642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 162647 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 162649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162661 */     GIR_RootConstrainSelectedInstOperands,
     /* 162662 */     // GIR_Coverage, 3652,
     /* 162662 */     GIR_EraseRootFromParent_Done,
     /* 162663 */   // Label 2531: @162663
     /* 162663 */   GIM_Reject,
     /* 162664 */ // Label 2515: @162664
     /* 162664 */ GIM_Reject,
     /* 162665 */ // Label 2434: @162665
     /* 162665 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(163535),
     /* 162670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162673 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(162729), // Rule ID 6637 //
     /* 162678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 162681 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 162697 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 162700 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162727 */     GIR_RootConstrainSelectedInstOperands,
     /* 162728 */     // GIR_Coverage, 6637,
     /* 162728 */     GIR_EraseRootFromParent_Done,
     /* 162729 */   // Label 2533: @162729
     /* 162729 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(162785), // Rule ID 6639 //
     /* 162734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 162737 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 162753 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 162753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 162756 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 162758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 162768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162783 */     GIR_RootConstrainSelectedInstOperands,
     /* 162784 */     // GIR_Coverage, 6639,
     /* 162784 */     GIR_EraseRootFromParent_Done,
     /* 162785 */   // Label 2534: @162785
     /* 162785 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(162838), // Rule ID 4292 //
     /* 162790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 162793 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 162809 */     // (st p5:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 162809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 162812 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 162814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 162819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 162824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 162829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162836 */     GIR_RootConstrainSelectedInstOperands,
     /* 162837 */     // GIR_Coverage, 4292,
     /* 162837 */     GIR_EraseRootFromParent_Done,
     /* 162838 */   // Label 2535: @162838
     /* 162838 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(162886), // Rule ID 4291 //
     /* 162843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 162846 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 162862 */     // (st p5:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 162862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 162865 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 162867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 162872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162884 */     GIR_RootConstrainSelectedInstOperands,
     /* 162885 */     // GIR_Coverage, 4291,
     /* 162885 */     GIR_EraseRootFromParent_Done,
     /* 162886 */   // Label 2536: @162886
     /* 162886 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(162934), // Rule ID 4290 //
     /* 162891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 162894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 162899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 162910 */     // (st p5:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 162910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 162913 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 162915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 162920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 162925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162932 */     GIR_RootConstrainSelectedInstOperands,
     /* 162933 */     // GIR_Coverage, 4290,
     /* 162933 */     GIR_EraseRootFromParent_Done,
     /* 162934 */   // Label 2537: @162934
     /* 162934 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(162995), // Rule ID 4637 //
     /* 162939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 162942 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 162947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 162951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 162958 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 162958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 162961 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 162963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 162968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 162973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 162978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 162983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 162989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 162993 */     GIR_RootConstrainSelectedInstOperands,
     /* 162994 */     // GIR_Coverage, 4637,
     /* 162994 */     GIR_EraseRootFromParent_Done,
     /* 162995 */   // Label 2538: @162995
     /* 162995 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(163053), // Rule ID 4639 //
     /* 163000 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 163016 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 163016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 163019 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 163021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 163026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 163036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 163041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163051 */     GIR_RootConstrainSelectedInstOperands,
     /* 163052 */     // GIR_Coverage, 4639,
     /* 163052 */     GIR_EraseRootFromParent_Done,
     /* 163053 */   // Label 2539: @163053
     /* 163053 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(163114), // Rule ID 6636 //
     /* 163058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 163061 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 163077 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 163077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 163080 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 163087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 163097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 163102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163112 */     GIR_RootConstrainSelectedInstOperands,
     /* 163113 */     // GIR_Coverage, 6636,
     /* 163113 */     GIR_EraseRootFromParent_Done,
     /* 163114 */   // Label 2540: @163114
     /* 163114 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(163175), // Rule ID 6638 //
     /* 163119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 163122 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 163138 */     // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 163138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 163141 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 163148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 163158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 163163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163173 */     GIR_RootConstrainSelectedInstOperands,
     /* 163174 */     // GIR_Coverage, 6638,
     /* 163174 */     GIR_EraseRootFromParent_Done,
     /* 163175 */   // Label 2541: @163175
     /* 163175 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(163231), // Rule ID 4636 //
     /* 163180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 163183 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 163199 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 163199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 163202 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 163204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 163214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163229 */     GIR_RootConstrainSelectedInstOperands,
     /* 163230 */     // GIR_Coverage, 4636,
     /* 163230 */     GIR_EraseRootFromParent_Done,
     /* 163231 */   // Label 2542: @163231
     /* 163231 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(163284), // Rule ID 4638 //
     /* 163236 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 163252 */     // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 163252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 163255 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 163257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 163267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163282 */     GIR_RootConstrainSelectedInstOperands,
     /* 163283 */     // GIR_Coverage, 4638,
     /* 163283 */     GIR_EraseRootFromParent_Done,
     /* 163284 */   // Label 2543: @163284
     /* 163284 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(163336), // Rule ID 8042 //
     /* 163289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 163292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 163296 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163312 */     // (AMDGPUst_glue p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 163315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163320 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163334 */     GIR_RootConstrainSelectedInstOperands,
     /* 163335 */     // GIR_Coverage, 8042,
     /* 163335 */     GIR_EraseRootFromParent_Done,
     /* 163336 */   // Label 2544: @163336
     /* 163336 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(163384), // Rule ID 8043 //
     /* 163341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 163344 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 163349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 163360 */     // (st p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 163360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 163363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 163368 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163382 */     GIR_RootConstrainSelectedInstOperands,
     /* 163383 */     // GIR_Coverage, 8043,
     /* 163383 */     GIR_EraseRootFromParent_Done,
     /* 163384 */   // Label 2545: @163384
     /* 163384 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(163437), // Rule ID 3894 //
     /* 163389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163392 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 163408 */     // (st p5:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 163411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 163416 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163435 */     GIR_RootConstrainSelectedInstOperands,
     /* 163436 */     // GIR_Coverage, 3894,
     /* 163436 */     GIR_EraseRootFromParent_Done,
     /* 163437 */   // Label 2546: @163437
     /* 163437 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(163485), // Rule ID 3893 //
     /* 163442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 163445 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 163461 */     // (st p5:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 163461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 163464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 163469 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163483 */     GIR_RootConstrainSelectedInstOperands,
     /* 163484 */     // GIR_Coverage, 3893,
     /* 163484 */     GIR_EraseRootFromParent_Done,
     /* 163485 */   // Label 2547: @163485
     /* 163485 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(163534), // Rule ID 3633 //
     /* 163490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 163493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 163499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 163510 */     // (st p5:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 163510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 163513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 163518 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163532 */     GIR_RootConstrainSelectedInstOperands,
     /* 163533 */     // GIR_Coverage, 3633,
     /* 163533 */     GIR_EraseRootFromParent_Done,
     /* 163534 */   // Label 2548: @163534
     /* 163534 */   GIM_Reject,
     /* 163535 */ // Label 2532: @163535
     /* 163535 */ GIM_Reject,
     /* 163536 */ // Label 2435: @163536
     /* 163536 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(164406),
     /* 163541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163544 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(163600), // Rule ID 6641 //
     /* 163549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 163552 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 163568 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 163568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 163571 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 163583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163598 */     GIR_RootConstrainSelectedInstOperands,
     /* 163599 */     // GIR_Coverage, 6641,
     /* 163599 */     GIR_EraseRootFromParent_Done,
     /* 163600 */   // Label 2550: @163600
     /* 163600 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(163656), // Rule ID 6643 //
     /* 163605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 163608 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 163624 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 163624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 163627 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 163639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163654 */     GIR_RootConstrainSelectedInstOperands,
     /* 163655 */     // GIR_Coverage, 6643,
     /* 163655 */     GIR_EraseRootFromParent_Done,
     /* 163656 */   // Label 2551: @163656
     /* 163656 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(163709), // Rule ID 4298 //
     /* 163661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 163664 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 163680 */     // (st p6:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 163683 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 163690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 163695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 163700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163707 */     GIR_RootConstrainSelectedInstOperands,
     /* 163708 */     // GIR_Coverage, 4298,
     /* 163708 */     GIR_EraseRootFromParent_Done,
     /* 163709 */   // Label 2552: @163709
     /* 163709 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(163757), // Rule ID 4297 //
     /* 163714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 163717 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 163733 */     // (st p6:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 163733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 163736 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 163743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163755 */     GIR_RootConstrainSelectedInstOperands,
     /* 163756 */     // GIR_Coverage, 4297,
     /* 163756 */     GIR_EraseRootFromParent_Done,
     /* 163757 */   // Label 2553: @163757
     /* 163757 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(163805), // Rule ID 4296 //
     /* 163762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 163765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 163781 */     // (st p6:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 163781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 163784 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 163786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 163791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 163796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163803 */     GIR_RootConstrainSelectedInstOperands,
     /* 163804 */     // GIR_Coverage, 4296,
     /* 163804 */     GIR_EraseRootFromParent_Done,
     /* 163805 */   // Label 2554: @163805
     /* 163805 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(163866), // Rule ID 4641 //
     /* 163810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 163813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 163829 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 163829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 163832 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 163834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 163839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 163849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 163854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163864 */     GIR_RootConstrainSelectedInstOperands,
     /* 163865 */     // GIR_Coverage, 4641,
     /* 163865 */     GIR_EraseRootFromParent_Done,
     /* 163866 */   // Label 2555: @163866
     /* 163866 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(163924), // Rule ID 4643 //
     /* 163871 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 163876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 163887 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 163887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 163890 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 163892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 163897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 163907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 163912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163922 */     GIR_RootConstrainSelectedInstOperands,
     /* 163923 */     // GIR_Coverage, 4643,
     /* 163923 */     GIR_EraseRootFromParent_Done,
     /* 163924 */   // Label 2556: @163924
     /* 163924 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(163985), // Rule ID 6640 //
     /* 163929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 163932 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 163941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 163948 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 163948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 163951 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 163953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 163958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 163963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 163968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 163973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 163979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 163983 */     GIR_RootConstrainSelectedInstOperands,
     /* 163984 */     // GIR_Coverage, 6640,
     /* 163984 */     GIR_EraseRootFromParent_Done,
     /* 163985 */   // Label 2557: @163985
     /* 163985 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(164046), // Rule ID 6642 //
     /* 163990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 163993 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 163998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 164009 */     // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 164012 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 164014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 164019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 164029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 164034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164044 */     GIR_RootConstrainSelectedInstOperands,
     /* 164045 */     // GIR_Coverage, 6642,
     /* 164045 */     GIR_EraseRootFromParent_Done,
     /* 164046 */   // Label 2558: @164046
     /* 164046 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(164102), // Rule ID 4640 //
     /* 164051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 164054 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 164070 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 164070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 164073 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 164075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164100 */     GIR_RootConstrainSelectedInstOperands,
     /* 164101 */     // GIR_Coverage, 4640,
     /* 164101 */     GIR_EraseRootFromParent_Done,
     /* 164102 */   // Label 2559: @164102
     /* 164102 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(164155), // Rule ID 4642 //
     /* 164107 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 164123 */     // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 164123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 164126 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 164128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164153 */     GIR_RootConstrainSelectedInstOperands,
     /* 164154 */     // GIR_Coverage, 4642,
     /* 164154 */     GIR_EraseRootFromParent_Done,
     /* 164155 */   // Label 2560: @164155
     /* 164155 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(164207), // Rule ID 8044 //
     /* 164160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 164163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164167 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 164172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 164183 */     // (AMDGPUst_glue p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 164183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 164186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 164191 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 164193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164205 */     GIR_RootConstrainSelectedInstOperands,
     /* 164206 */     // GIR_Coverage, 8044,
     /* 164206 */     GIR_EraseRootFromParent_Done,
     /* 164207 */   // Label 2561: @164207
     /* 164207 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(164255), // Rule ID 8045 //
     /* 164212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 164215 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 164220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 164231 */     // (st p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 164231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 164234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 164239 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 164241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164253 */     GIR_RootConstrainSelectedInstOperands,
     /* 164254 */     // GIR_Coverage, 8045,
     /* 164254 */     GIR_EraseRootFromParent_Done,
     /* 164255 */   // Label 2562: @164255
     /* 164255 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(164308), // Rule ID 3898 //
     /* 164260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 164263 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 164279 */     // (st p6:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 164279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 164282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 164287 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 164294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164306 */     GIR_RootConstrainSelectedInstOperands,
     /* 164307 */     // GIR_Coverage, 3898,
     /* 164307 */     GIR_EraseRootFromParent_Done,
     /* 164308 */   // Label 2563: @164308
     /* 164308 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(164356), // Rule ID 3897 //
     /* 164313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 164316 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 164321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 164332 */     // (st p6:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 164332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 164335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164340 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164354 */     GIR_RootConstrainSelectedInstOperands,
     /* 164355 */     // GIR_Coverage, 3897,
     /* 164355 */     GIR_EraseRootFromParent_Done,
     /* 164356 */   // Label 2564: @164356
     /* 164356 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(164405), // Rule ID 3635 //
     /* 164361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 164364 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 164370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 164381 */     // (st p6:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 164381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 164384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164389 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 164396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164403 */     GIR_RootConstrainSelectedInstOperands,
     /* 164404 */     // GIR_Coverage, 3635,
     /* 164404 */     GIR_EraseRootFromParent_Done,
     /* 164405 */   // Label 2565: @164405
     /* 164405 */   GIM_Reject,
     /* 164406 */ // Label 2549: @164406
     /* 164406 */ GIM_Reject,
     /* 164407 */ // Label 2436: @164407
     /* 164407 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(164477), // Rule ID 6605 //
     /* 164412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 164415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164418 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164422 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164429 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164434 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164438 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 164445 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 164448 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 164450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164475 */   GIR_RootConstrainSelectedInstOperands,
     /* 164476 */   // GIR_Coverage, 6605,
     /* 164476 */   GIR_EraseRootFromParent_Done,
     /* 164477 */ // Label 2566: @164477
     /* 164477 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(164547), // Rule ID 6607 //
     /* 164482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 164485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164488 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164499 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164504 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164508 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 164515 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 164518 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 164520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164545 */   GIR_RootConstrainSelectedInstOperands,
     /* 164546 */   // GIR_Coverage, 6607,
     /* 164546 */   GIR_EraseRootFromParent_Done,
     /* 164547 */ // Label 2567: @164547
     /* 164547 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(164606), // Rule ID 6609 //
     /* 164552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 164555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164558 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 164574 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 164577 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 164579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164604 */   GIR_RootConstrainSelectedInstOperands,
     /* 164605 */   // GIR_Coverage, 6609,
     /* 164605 */   GIR_EraseRootFromParent_Done,
     /* 164606 */ // Label 2568: @164606
     /* 164606 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(164665), // Rule ID 6611 //
     /* 164611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 164614 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164617 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 164633 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 164633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 164636 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 164638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 164643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 164648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164663 */   GIR_RootConstrainSelectedInstOperands,
     /* 164664 */   // GIR_Coverage, 6611,
     /* 164664 */   GIR_EraseRootFromParent_Done,
     /* 164665 */ // Label 2569: @164665
     /* 164665 */ GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(164732), // Rule ID 4220 //
     /* 164670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 164673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164676 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164680 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164687 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 164703 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 164703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 164706 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 164718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164730 */   GIR_RootConstrainSelectedInstOperands,
     /* 164731 */   // GIR_Coverage, 4220,
     /* 164731 */   GIR_EraseRootFromParent_Done,
     /* 164732 */ // Label 2570: @164732
     /* 164732 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(164799), // Rule ID 4238 //
     /* 164737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 164740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164743 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164747 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164754 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 164770 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 164770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 164773 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 164785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164797 */   GIR_RootConstrainSelectedInstOperands,
     /* 164798 */   // GIR_Coverage, 4238,
     /* 164798 */   GIR_EraseRootFromParent_Done,
     /* 164799 */ // Label 2571: @164799
     /* 164799 */ GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(164866), // Rule ID 4250 //
     /* 164804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 164807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164810 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 164814 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 164821 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 164837 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS_t16 anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 164837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS_t16),
     /* 164840 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 164852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164864 */   GIR_RootConstrainSelectedInstOperands,
     /* 164865 */   // GIR_Coverage, 4250,
     /* 164865 */   GIR_EraseRootFromParent_Done,
     /* 164866 */ // Label 2572: @164866
     /* 164866 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(164922), // Rule ID 3571 //
     /* 164871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_NotHasTrue16BitInsts),
     /* 164874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164877 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164882 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164886 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 164893 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 164893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 164896 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 164908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164920 */   GIR_RootConstrainSelectedInstOperands,
     /* 164921 */   // GIR_Coverage, 3571,
     /* 164921 */   GIR_EraseRootFromParent_Done,
     /* 164922 */ // Label 2573: @164922
     /* 164922 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(164978), // Rule ID 3574 //
     /* 164927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseRealTrue16Insts),
     /* 164930 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164933 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164938 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164942 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 164949 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS_t16 anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 164949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS_t16),
     /* 164952 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 164954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 164959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 164964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 164969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 164972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 164976 */   GIR_RootConstrainSelectedInstOperands,
     /* 164977 */   // GIR_Coverage, 3574,
     /* 164977 */   GIR_EraseRootFromParent_Done,
     /* 164978 */ // Label 2574: @164978
     /* 164978 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(165034), // Rule ID 4235 //
     /* 164983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode_UseFakeTrue16Insts),
     /* 164986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164989 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 164994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 164998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 165005 */   // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 165008 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 165020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 165025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165028 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165032 */   GIR_RootConstrainSelectedInstOperands,
     /* 165033 */   // GIR_Coverage, 4235,
     /* 165033 */   GIR_EraseRootFromParent_Done,
     /* 165034 */ // Label 2575: @165034
     /* 165034 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(165096), // Rule ID 4219 //
     /* 165039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 165042 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165045 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165049 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165056 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165072 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 165075 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165094 */   GIR_RootConstrainSelectedInstOperands,
     /* 165095 */   // GIR_Coverage, 4219,
     /* 165095 */   GIR_EraseRootFromParent_Done,
     /* 165096 */ // Label 2576: @165096
     /* 165096 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(165158), // Rule ID 4237 //
     /* 165101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 165104 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165107 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165118 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165134 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 165137 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165156 */   GIR_RootConstrainSelectedInstOperands,
     /* 165157 */   // GIR_Coverage, 4237,
     /* 165157 */   GIR_EraseRootFromParent_Done,
     /* 165158 */ // Label 2577: @165158
     /* 165158 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(165220), // Rule ID 4249 //
     /* 165163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 165166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165169 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165173 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165180 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165196 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR_t16 anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR_t16),
     /* 165199 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165218 */   GIR_RootConstrainSelectedInstOperands,
     /* 165219 */   // GIR_Coverage, 4249,
     /* 165219 */   GIR_EraseRootFromParent_Done,
     /* 165220 */ // Label 2578: @165220
     /* 165220 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(165271), // Rule ID 3570 //
     /* 165225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 165228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165231 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165240 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165247 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 165250 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165269 */   GIR_RootConstrainSelectedInstOperands,
     /* 165270 */   // GIR_Coverage, 3570,
     /* 165270 */   GIR_EraseRootFromParent_Done,
     /* 165271 */ // Label 2579: @165271
     /* 165271 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(165322), // Rule ID 3573 //
     /* 165276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 165279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165282 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165298 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR_t16 anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR_t16),
     /* 165301 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165320 */   GIR_RootConstrainSelectedInstOperands,
     /* 165321 */   // GIR_Coverage, 3573,
     /* 165321 */   GIR_EraseRootFromParent_Done,
     /* 165322 */ // Label 2580: @165322
     /* 165322 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(165373), // Rule ID 4234 //
     /* 165327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 165330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165333 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 165349 */   // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 165349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 165352 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 165359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165371 */   GIR_RootConstrainSelectedInstOperands,
     /* 165372 */   // GIR_Coverage, 4234,
     /* 165372 */   GIR_EraseRootFromParent_Done,
     /* 165373 */ // Label 2581: @165373
     /* 165373 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(165435), // Rule ID 4218 //
     /* 165378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 165381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165384 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165388 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165395 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165411 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 165414 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165429 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165433 */   GIR_RootConstrainSelectedInstOperands,
     /* 165434 */   // GIR_Coverage, 4218,
     /* 165434 */   GIR_EraseRootFromParent_Done,
     /* 165435 */ // Label 2582: @165435
     /* 165435 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(165497), // Rule ID 4236 //
     /* 165440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 165443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165446 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165457 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165462 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165473 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 165476 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165495 */   GIR_RootConstrainSelectedInstOperands,
     /* 165496 */   // GIR_Coverage, 4236,
     /* 165496 */   GIR_EraseRootFromParent_Done,
     /* 165497 */ // Label 2583: @165497
     /* 165497 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(165559), // Rule ID 4248 //
     /* 165502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 165505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165508 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165519 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165535 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_t16 anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_t16),
     /* 165538 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165557 */   GIR_RootConstrainSelectedInstOperands,
     /* 165558 */   // GIR_Coverage, 4248,
     /* 165558 */   GIR_EraseRootFromParent_Done,
     /* 165559 */ // Label 2584: @165559
     /* 165559 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(165610), // Rule ID 3569 //
     /* 165564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_NotHasTrue16BitInsts),
     /* 165567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165570 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165575 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165579 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165586 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 165589 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165604 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165608 */   GIR_RootConstrainSelectedInstOperands,
     /* 165609 */   // GIR_Coverage, 3569,
     /* 165609 */   GIR_EraseRootFromParent_Done,
     /* 165610 */ // Label 2585: @165610
     /* 165610 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(165661), // Rule ID 3572 //
     /* 165615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseRealTrue16Insts),
     /* 165618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165621 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165637 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_t16 anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_t16),
     /* 165640 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165659 */   GIR_RootConstrainSelectedInstOperands,
     /* 165660 */   // GIR_Coverage, 3572,
     /* 165660 */   GIR_EraseRootFromParent_Done,
     /* 165661 */ // Label 2586: @165661
     /* 165661 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(165712), // Rule ID 4233 //
     /* 165666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_UseFakeTrue16Insts),
     /* 165669 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165672 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 165688 */   // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 165688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 165691 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 165693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 165698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 165703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165710 */   GIR_RootConstrainSelectedInstOperands,
     /* 165711 */   // GIR_Coverage, 4233,
     /* 165711 */   GIR_EraseRootFromParent_Done,
     /* 165712 */ // Label 2587: @165712
     /* 165712 */ GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(165783), // Rule ID 6582 //
     /* 165717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 165720 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 165723 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165730 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 165735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 165746 */   // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 165746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 165749 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 165751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165777 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165781 */   GIR_RootConstrainSelectedInstOperands,
     /* 165782 */   // GIR_Coverage, 6582,
     /* 165782 */   GIR_EraseRootFromParent_Done,
     /* 165783 */ // Label 2588: @165783
     /* 165783 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(165854), // Rule ID 6586 //
     /* 165788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 165791 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 165794 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 165801 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 165806 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165810 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 165817 */   // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 165817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 165820 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 165822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165852 */   GIR_RootConstrainSelectedInstOperands,
     /* 165853 */   // GIR_Coverage, 6586,
     /* 165853 */   GIR_EraseRootFromParent_Done,
     /* 165854 */ // Label 2589: @165854
     /* 165854 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(165929), // Rule ID 6604 //
     /* 165859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 165862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165865 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165876 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165881 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 165892 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
     /* 165895 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 165897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 165927 */   GIR_RootConstrainSelectedInstOperands,
     /* 165928 */   // GIR_Coverage, 6604,
     /* 165928 */   GIR_EraseRootFromParent_Done,
     /* 165929 */ // Label 2590: @165929
     /* 165929 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(166004), // Rule ID 6606 //
     /* 165934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 165937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165940 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 165944 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 165951 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 165956 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 165960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 165967 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 165967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
     /* 165970 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 165972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 165977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 165982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 165987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 165992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165998 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166002 */   GIR_RootConstrainSelectedInstOperands,
     /* 166003 */   // GIR_Coverage, 6606,
     /* 166003 */   GIR_EraseRootFromParent_Done,
     /* 166004 */ // Label 2591: @166004
     /* 166004 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(166068), // Rule ID 6608 //
     /* 166009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 166012 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166015 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166020 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166024 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 166031 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
     /* 166034 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 166041 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 166051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 166056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166066 */   GIR_RootConstrainSelectedInstOperands,
     /* 166067 */   // GIR_Coverage, 6608,
     /* 166067 */   GIR_EraseRootFromParent_Done,
     /* 166068 */ // Label 2592: @166068
     /* 166068 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(166132), // Rule ID 6610 //
     /* 166073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 166076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166079 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 166084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 166095 */   // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 166095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
     /* 166098 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 166105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 166115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 166120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166130 */   GIR_RootConstrainSelectedInstOperands,
     /* 166131 */   // GIR_Coverage, 6610,
     /* 166131 */   GIR_EraseRootFromParent_Done,
     /* 166132 */ // Label 2593: @166132
     /* 166132 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(166202), // Rule ID 6592 //
     /* 166137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 166140 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166143 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166147 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166154 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 166159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166163 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 166170 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 166170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 166173 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 166175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166200 */   GIR_RootConstrainSelectedInstOperands,
     /* 166201 */   // GIR_Coverage, 6592,
     /* 166201 */   GIR_EraseRootFromParent_Done,
     /* 166202 */ // Label 2594: @166202
     /* 166202 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(166269), // Rule ID 6593 //
     /* 166207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166210 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166214 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166221 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 166226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 166237 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 166237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 166240 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 166242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166263 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166267 */   GIR_RootConstrainSelectedInstOperands,
     /* 166268 */   // GIR_Coverage, 6593,
     /* 166268 */   GIR_EraseRootFromParent_Done,
     /* 166269 */ // Label 2595: @166269
     /* 166269 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(166328), // Rule ID 6594 //
     /* 166274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 166277 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166280 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 166285 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 166296 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 166296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 166299 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 166301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166322 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166326 */   GIR_RootConstrainSelectedInstOperands,
     /* 166327 */   // GIR_Coverage, 6594,
     /* 166327 */   GIR_EraseRootFromParent_Done,
     /* 166328 */ // Label 2596: @166328
     /* 166328 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(166384), // Rule ID 6595 //
     /* 166333 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166336 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 166341 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166345 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 166352 */   // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 166352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 166355 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 166357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 166362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 166367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 166372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166382 */   GIR_RootConstrainSelectedInstOperands,
     /* 166383 */   // GIR_Coverage, 6595,
     /* 166383 */   GIR_EraseRootFromParent_Done,
     /* 166384 */ // Label 2597: @166384
     /* 166384 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(166442), // Rule ID 8046 //
     /* 166389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 166392 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166402 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166411 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166418 */   // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 166421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166426 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166440 */   GIR_RootConstrainSelectedInstOperands,
     /* 166441 */   // GIR_Coverage, 8046,
     /* 166441 */   GIR_EraseRootFromParent_Done,
     /* 166442 */ // Label 2598: @166442
     /* 166442 */ GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(166500), // Rule ID 8047 //
     /* 166447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 166450 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166453 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166460 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166469 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166476 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 166479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166484 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166498 */   GIR_RootConstrainSelectedInstOperands,
     /* 166499 */   // GIR_Coverage, 8047,
     /* 166499 */   GIR_EraseRootFromParent_Done,
     /* 166500 */ // Label 2599: @166500
     /* 166500 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(166558), // Rule ID 8048 //
     /* 166505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 166508 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166518 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166523 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166527 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166534 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 166537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166542 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166556 */   GIR_RootConstrainSelectedInstOperands,
     /* 166557 */   // GIR_Coverage, 8048,
     /* 166557 */   GIR_EraseRootFromParent_Done,
     /* 166558 */ // Label 2600: @166558
     /* 166558 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(166616), // Rule ID 8049 //
     /* 166563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 166566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166576 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166592 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_t16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_t16),
     /* 166595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166600 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166610 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166614 */   GIR_RootConstrainSelectedInstOperands,
     /* 166615 */   // GIR_Coverage, 8049,
     /* 166615 */   GIR_EraseRootFromParent_Done,
     /* 166616 */ // Label 2601: @166616
     /* 166616 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(166674), // Rule ID 8052 //
     /* 166621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 166624 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166627 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166634 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166650 */   // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 166653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166658 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166672 */   GIR_RootConstrainSelectedInstOperands,
     /* 166673 */   // GIR_Coverage, 8052,
     /* 166673 */   GIR_EraseRootFromParent_Done,
     /* 166674 */ // Label 2602: @166674
     /* 166674 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(166732), // Rule ID 8053 //
     /* 166679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 166682 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166685 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166692 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166697 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166708 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 166711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166716 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166730 */   GIR_RootConstrainSelectedInstOperands,
     /* 166731 */   // GIR_Coverage, 8053,
     /* 166731 */   GIR_EraseRootFromParent_Done,
     /* 166732 */ // Label 2603: @166732
     /* 166732 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(166790), // Rule ID 8054 //
     /* 166737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 166740 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166743 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166750 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166759 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166766 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 166769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166774 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166784 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166788 */   GIR_RootConstrainSelectedInstOperands,
     /* 166789 */   // GIR_Coverage, 8054,
     /* 166789 */   GIR_EraseRootFromParent_Done,
     /* 166790 */ // Label 2604: @166790
     /* 166790 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(166848), // Rule ID 8055 //
     /* 166795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 166798 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 166801 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 166808 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166813 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166824 */   // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_t16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_t16),
     /* 166827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166832 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166842 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166846 */   GIR_RootConstrainSelectedInstOperands,
     /* 166847 */   // GIR_Coverage, 8055,
     /* 166847 */   GIR_EraseRootFromParent_Done,
     /* 166848 */ // Label 2605: @166848
     /* 166848 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(166910), // Rule ID 8020 //
     /* 166853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 166856 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166859 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166870 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166875 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166886 */   // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 166889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166894 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166904 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166908 */   GIR_RootConstrainSelectedInstOperands,
     /* 166909 */   // GIR_Coverage, 8020,
     /* 166909 */   GIR_EraseRootFromParent_Done,
     /* 166910 */ // Label 2606: @166910
     /* 166910 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(166972), // Rule ID 8021 //
     /* 166915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 166918 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166921 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166925 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166932 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 166941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 166948 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 166948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 166951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 166956 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 166958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 166963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 166970 */   GIR_RootConstrainSelectedInstOperands,
     /* 166971 */   // GIR_Coverage, 8021,
     /* 166971 */   GIR_EraseRootFromParent_Done,
     /* 166972 */ // Label 2607: @166972
     /* 166972 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(167034), // Rule ID 8022 //
     /* 166977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 166980 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166983 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 166987 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 166994 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 166999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167010 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_t16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_t16),
     /* 167013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167018 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 167020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167028 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167032 */   GIR_RootConstrainSelectedInstOperands,
     /* 167033 */   // GIR_Coverage, 8022,
     /* 167033 */   GIR_EraseRootFromParent_Done,
     /* 167034 */ // Label 2608: @167034
     /* 167034 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(167096), // Rule ID 8025 //
     /* 167039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 167042 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167045 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167049 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167056 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167072 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 167075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167080 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 167082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167094 */   GIR_RootConstrainSelectedInstOperands,
     /* 167095 */   // GIR_Coverage, 8025,
     /* 167095 */   GIR_EraseRootFromParent_Done,
     /* 167096 */ // Label 2609: @167096
     /* 167096 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(167151), // Rule ID 8026 //
     /* 167101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 167104 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167107 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167111 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167127 */   // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 167130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167135 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 167137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167149 */   GIR_RootConstrainSelectedInstOperands,
     /* 167150 */   // GIR_Coverage, 8026,
     /* 167150 */   GIR_EraseRootFromParent_Done,
     /* 167151 */ // Label 2610: @167151
     /* 167151 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(167202), // Rule ID 8027 //
     /* 167156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_NotLDSRequiresM0Init),
     /* 167159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167162 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167167 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167178 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 167181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167186 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 167188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167196 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167200 */   GIR_RootConstrainSelectedInstOperands,
     /* 167201 */   // GIR_Coverage, 8027,
     /* 167201 */   GIR_EraseRootFromParent_Done,
     /* 167202 */ // Label 2611: @167202
     /* 167202 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(167253), // Rule ID 8028 //
     /* 167207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseFakeTrue16Insts),
     /* 167210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167213 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167222 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167229 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 167232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167237 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 167239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167251 */   GIR_RootConstrainSelectedInstOperands,
     /* 167252 */   // GIR_Coverage, 8028,
     /* 167252 */   GIR_EraseRootFromParent_Done,
     /* 167253 */ // Label 2612: @167253
     /* 167253 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(167304), // Rule ID 8029 //
     /* 167258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_UseRealTrue16Insts),
     /* 167261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167264 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 167269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 167280 */   // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_t16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 167280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_t16),
     /* 167283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 167288 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 167290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167302 */   GIR_RootConstrainSelectedInstOperands,
     /* 167303 */   // GIR_Coverage, 8029,
     /* 167303 */   GIR_EraseRootFromParent_Done,
     /* 167304 */ // Label 2613: @167304
     /* 167304 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(167367), // Rule ID 4008 //
     /* 167309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 167312 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167322 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167327 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167331 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167338 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 167341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167346 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167361 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167365 */   GIR_RootConstrainSelectedInstOperands,
     /* 167366 */   // GIR_Coverage, 4008,
     /* 167366 */   GIR_EraseRootFromParent_Done,
     /* 167367 */ // Label 2614: @167367
     /* 167367 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(167430), // Rule ID 4012 //
     /* 167372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 167375 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167378 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167385 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167394 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167401 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 167404 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167409 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167428 */   GIR_RootConstrainSelectedInstOperands,
     /* 167429 */   // GIR_Coverage, 4012,
     /* 167429 */   GIR_EraseRootFromParent_Done,
     /* 167430 */ // Label 2615: @167430
     /* 167430 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(167497), // Rule ID 3561 //
     /* 167435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 167438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167441 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167445 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167452 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167457 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167461 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167468 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR_t16 ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR_t16),
     /* 167471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167476 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167491 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167495 */   GIR_RootConstrainSelectedInstOperands,
     /* 167496 */   // GIR_Coverage, 3561,
     /* 167496 */   GIR_EraseRootFromParent_Done,
     /* 167497 */ // Label 2616: @167497
     /* 167497 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(167564), // Rule ID 3972 //
     /* 167502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 167505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167508 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167519 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167535 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 167538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167543 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167562 */   GIR_RootConstrainSelectedInstOperands,
     /* 167563 */   // GIR_Coverage, 3972,
     /* 167563 */   GIR_EraseRootFromParent_Done,
     /* 167564 */ // Label 2617: @167564
     /* 167564 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(167631), // Rule ID 3976 //
     /* 167569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 167572 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167575 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167579 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167586 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167591 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167595 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167602 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 167605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167610 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167629 */   GIR_RootConstrainSelectedInstOperands,
     /* 167630 */   // GIR_Coverage, 3976,
     /* 167630 */   GIR_EraseRootFromParent_Done,
     /* 167631 */ // Label 2618: @167631
     /* 167631 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(167687), // Rule ID 3868 //
     /* 167636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 167639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167642 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167658 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR_t16 ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR_t16),
     /* 167661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167666 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167685 */   GIR_RootConstrainSelectedInstOperands,
     /* 167686 */   // GIR_Coverage, 3868,
     /* 167686 */   GIR_EraseRootFromParent_Done,
     /* 167687 */ // Label 2619: @167687
     /* 167687 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(167743), // Rule ID 3974 //
     /* 167692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 167695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167698 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167714 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 167717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167722 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167741 */   GIR_RootConstrainSelectedInstOperands,
     /* 167742 */   // GIR_Coverage, 3974,
     /* 167742 */   GIR_EraseRootFromParent_Done,
     /* 167743 */ // Label 2620: @167743
     /* 167743 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(167799), // Rule ID 3978 //
     /* 167748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 167751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167754 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 167770 */   // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 167770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 167773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 167778 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 167785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 167790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167797 */   GIR_RootConstrainSelectedInstOperands,
     /* 167798 */   // GIR_Coverage, 3978,
     /* 167798 */   GIR_EraseRootFromParent_Done,
     /* 167799 */ // Label 2621: @167799
     /* 167799 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(167857), // Rule ID 4007 //
     /* 167804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 167807 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167817 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167826 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 167833 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 167833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 167836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167841 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167855 */   GIR_RootConstrainSelectedInstOperands,
     /* 167856 */   // GIR_Coverage, 4007,
     /* 167856 */   GIR_EraseRootFromParent_Done,
     /* 167857 */ // Label 2622: @167857
     /* 167857 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(167915), // Rule ID 4011 //
     /* 167862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 167865 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 167868 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 167875 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 167891 */   // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 167891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 167894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167899 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167913 */   GIR_RootConstrainSelectedInstOperands,
     /* 167914 */   // GIR_Coverage, 4011,
     /* 167914 */   GIR_EraseRootFromParent_Done,
     /* 167915 */ // Label 2623: @167915
     /* 167915 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(167977), // Rule ID 3560 //
     /* 167920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 167923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167937 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 167942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 167946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 167953 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_t16 ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 167953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_t16),
     /* 167956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 167961 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 167963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 167968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167971 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 167975 */   GIR_RootConstrainSelectedInstOperands,
     /* 167976 */   // GIR_Coverage, 3560,
     /* 167976 */   GIR_EraseRootFromParent_Done,
     /* 167977 */ // Label 2624: @167977
     /* 167977 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(168039), // Rule ID 3971 //
     /* 167982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 167985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167988 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 167992 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 167999 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 168015 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 168018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168023 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168033 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168037 */   GIR_RootConstrainSelectedInstOperands,
     /* 168038 */   // GIR_Coverage, 3971,
     /* 168038 */   GIR_EraseRootFromParent_Done,
     /* 168039 */ // Label 2625: @168039
     /* 168039 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(168101), // Rule ID 3975 //
     /* 168044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 168047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168050 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168054 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168061 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 168077 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 168080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168085 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168099 */   GIR_RootConstrainSelectedInstOperands,
     /* 168100 */   // GIR_Coverage, 3975,
     /* 168100 */   GIR_EraseRootFromParent_Done,
     /* 168101 */ // Label 2626: @168101
     /* 168101 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(168152), // Rule ID 3867 //
     /* 168106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatGlobalInsts_UseRealTrue16Insts),
     /* 168109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168112 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 168128 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_t16 ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_t16),
     /* 168131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168136 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168150 */   GIR_RootConstrainSelectedInstOperands,
     /* 168151 */   // GIR_Coverage, 3867,
     /* 168151 */   GIR_EraseRootFromParent_Done,
     /* 168152 */ // Label 2627: @168152
     /* 168152 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(168203), // Rule ID 3973 //
     /* 168157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_NotHasTrue16BitInsts),
     /* 168160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168163 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 168179 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 168182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168187 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168201 */   GIR_RootConstrainSelectedInstOperands,
     /* 168202 */   // GIR_Coverage, 3973,
     /* 168202 */   GIR_EraseRootFromParent_Done,
     /* 168203 */ // Label 2628: @168203
     /* 168203 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(168254), // Rule ID 3977 //
     /* 168208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_UseFakeTrue16Insts),
     /* 168211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168214 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 168219 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 168230 */   // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 168233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168238 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168252 */   GIR_RootConstrainSelectedInstOperands,
     /* 168253 */   // GIR_Coverage, 3977,
     /* 168253 */   GIR_EraseRootFromParent_Done,
     /* 168254 */ // Label 2629: @168254
     /* 168254 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(168313), // Rule ID 3670 //
     /* 168259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 168262 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168265 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168272 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168278 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168282 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168289 */   // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 168292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168297 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168307 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168311 */   GIR_RootConstrainSelectedInstOperands,
     /* 168312 */   // GIR_Coverage, 3670,
     /* 168312 */   GIR_EraseRootFromParent_Done,
     /* 168313 */ // Label 2630: @168313
     /* 168313 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(168372), // Rule ID 3672 //
     /* 168318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 168321 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 168324 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168331 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168348 */   // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 168351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168356 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168366 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168370 */   GIR_RootConstrainSelectedInstOperands,
     /* 168371 */   // GIR_Coverage, 3672,
     /* 168371 */   GIR_EraseRootFromParent_Done,
     /* 168372 */ // Label 2631: @168372
     /* 168372 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(168435), // Rule ID 3602 //
     /* 168377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 168380 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168383 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168387 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168394 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168404 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168411 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 168414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168419 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168429 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168433 */   GIR_RootConstrainSelectedInstOperands,
     /* 168434 */   // GIR_Coverage, 3602,
     /* 168434 */   GIR_EraseRootFromParent_Done,
     /* 168435 */ // Label 2632: @168435
     /* 168435 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(168498), // Rule ID 3608 //
     /* 168440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 168443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168446 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168457 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168474 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 168477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168482 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168496 */   GIR_RootConstrainSelectedInstOperands,
     /* 168497 */   // GIR_Coverage, 3608,
     /* 168497 */   GIR_EraseRootFromParent_Done,
     /* 168498 */ // Label 2633: @168498
     /* 168498 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(168561), // Rule ID 3614 //
     /* 168503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 168506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168509 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168520 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168526 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168530 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168537 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE_t16 ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE_t16),
     /* 168540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168545 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168559 */   GIR_RootConstrainSelectedInstOperands,
     /* 168560 */   // GIR_Coverage, 3614,
     /* 168560 */   GIR_EraseRootFromParent_Done,
     /* 168561 */ // Label 2634: @168561
     /* 168561 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(168613), // Rule ID 3603 //
     /* 168566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_NotHasTrue16BitInsts),
     /* 168569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168572 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168578 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168589 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 168592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168597 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168611 */   GIR_RootConstrainSelectedInstOperands,
     /* 168612 */   // GIR_Coverage, 3603,
     /* 168612 */   GIR_EraseRootFromParent_Done,
     /* 168613 */ // Label 2635: @168613
     /* 168613 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(168665), // Rule ID 3609 //
     /* 168618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_UseFakeTrue16Insts),
     /* 168621 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168624 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168641 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 168644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168649 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168663 */   GIR_RootConstrainSelectedInstOperands,
     /* 168664 */   // GIR_Coverage, 3609,
     /* 168664 */   GIR_EraseRootFromParent_Done,
     /* 168665 */ // Label 2636: @168665
     /* 168665 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(168717), // Rule ID 3615 //
     /* 168670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_D16PreservesUnusedBits_HasFlatAddressSpace_UseRealTrue16Insts),
     /* 168673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168676 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 168682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 168693 */   // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT_t16 ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 168693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT_t16),
     /* 168696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 168701 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 168703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 168708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 168715 */   GIR_RootConstrainSelectedInstOperands,
     /* 168716 */   // GIR_Coverage, 3615,
     /* 168716 */   GIR_EraseRootFromParent_Done,
     /* 168717 */ // Label 2637: @168717
     /* 168717 */ GIM_Reject,
     /* 168718 */ // Label 2437: @168718
     /* 168718 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(168813), // Rule ID 6657 //
     /* 168723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 168726 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168729 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168733 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168740 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168745 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 168749 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 168753 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168757 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 168761 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 168765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168771 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 168778 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFSET),
     /* 168781 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 168785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 168795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 168800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168806 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168811 */   GIR_RootConstrainSelectedInstOperands,
     /* 168812 */   // GIR_Coverage, 6657,
     /* 168812 */   GIR_EraseRootFromParent_Done,
     /* 168813 */ // Label 2638: @168813
     /* 168813 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(168908), // Rule ID 6659 //
     /* 168818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 168821 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168824 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168828 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 168835 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 168844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 168848 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168852 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 168856 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 168860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168866 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 168873 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET),
     /* 168876 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 168880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 168890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 168895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168906 */   GIR_RootConstrainSelectedInstOperands,
     /* 168907 */   // GIR_Coverage, 6659,
     /* 168907 */   GIR_EraseRootFromParent_Done,
     /* 168908 */ // Label 2639: @168908
     /* 168908 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(169003), // Rule ID 6661 //
     /* 168913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 168916 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168919 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 168923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 168930 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 168935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 168939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 168943 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 168947 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 168951 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 168955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 168959 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 168968 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 168968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFSET),
     /* 168971 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 168975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 168980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 168985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 168990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 168996 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169001 */   GIR_RootConstrainSelectedInstOperands,
     /* 169002 */   // GIR_Coverage, 6661,
     /* 169002 */   GIR_EraseRootFromParent_Done,
     /* 169003 */ // Label 2640: @169003
     /* 169003 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(169098), // Rule ID 6663 //
     /* 169008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 169011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169014 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169018 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169025 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169046 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169050 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169056 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 169063 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 169063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET),
     /* 169066 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 169070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 169080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169096 */   GIR_RootConstrainSelectedInstOperands,
     /* 169097 */   // GIR_Coverage, 6663,
     /* 169097 */   GIR_EraseRootFromParent_Done,
     /* 169098 */ // Label 2641: @169098
     /* 169098 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(169190), // Rule ID 4403 //
     /* 169103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 169106 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169109 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169120 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169125 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169133 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169137 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169141 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169151 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 169158 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 169158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SVS),
     /* 169161 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 169175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169188 */   GIR_RootConstrainSelectedInstOperands,
     /* 169189 */   // GIR_Coverage, 4403,
     /* 169189 */   GIR_EraseRootFromParent_Done,
     /* 169190 */ // Label 2642: @169190
     /* 169190 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(169282), // Rule ID 4406 //
     /* 169195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 169198 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169201 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169205 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169212 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169225 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169233 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169241 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 169250 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 169250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SVS),
     /* 169253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 169267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 169272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169280 */   GIR_RootConstrainSelectedInstOperands,
     /* 169281 */   // GIR_Coverage, 4406,
     /* 169281 */   GIR_EraseRootFromParent_Done,
     /* 169282 */ // Label 2643: @169282
     /* 169282 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(169369), // Rule ID 4402 //
     /* 169287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 169290 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169293 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169297 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169304 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169309 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169313 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169317 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169321 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169325 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169329 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 169342 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 169342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SADDR),
     /* 169345 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 169354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169367 */   GIR_RootConstrainSelectedInstOperands,
     /* 169368 */   // GIR_Coverage, 4402,
     /* 169368 */   GIR_EraseRootFromParent_Done,
     /* 169369 */ // Label 2644: @169369
     /* 169369 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(169456), // Rule ID 4405 //
     /* 169374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 169377 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169380 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169384 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169391 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169408 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169412 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 169429 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 169429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SADDR),
     /* 169432 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 169441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169449 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169454 */   GIR_RootConstrainSelectedInstOperands,
     /* 169455 */   // GIR_Coverage, 4405,
     /* 169455 */   GIR_EraseRootFromParent_Done,
     /* 169456 */ // Label 2645: @169456
     /* 169456 */ GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(169543), // Rule ID 4401 //
     /* 169461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 169464 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169467 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169471 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169478 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169491 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169499 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169507 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 169516 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 169516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI),
     /* 169519 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169541 */   GIR_RootConstrainSelectedInstOperands,
     /* 169542 */   // GIR_Coverage, 4401,
     /* 169542 */   GIR_EraseRootFromParent_Done,
     /* 169543 */ // Label 2646: @169543
     /* 169543 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(169630), // Rule ID 4404 //
     /* 169548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
     /* 169551 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169554 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169558 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169565 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169578 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169586 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 169603 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 169603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI),
     /* 169606 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 169610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 169615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 169620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169628 */   GIR_RootConstrainSelectedInstOperands,
     /* 169629 */   // GIR_Coverage, 4404,
     /* 169629 */   GIR_EraseRootFromParent_Done,
     /* 169630 */ // Label 2647: @169630
     /* 169630 */ GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(169730), // Rule ID 6656 //
     /* 169635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 169638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169641 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169652 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169657 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169661 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169665 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169669 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169673 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169681 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 169690 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 169690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFEN),
     /* 169693 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 169697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 169702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 169712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 169717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169723 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169728 */   GIR_RootConstrainSelectedInstOperands,
     /* 169729 */   // GIR_Coverage, 6656,
     /* 169729 */   GIR_EraseRootFromParent_Done,
     /* 169730 */ // Label 2648: @169730
     /* 169730 */ GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(169830), // Rule ID 6658 //
     /* 169735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 169738 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169741 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169745 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 169752 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169757 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169761 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169765 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169769 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169773 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169781 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 169790 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 169790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN),
     /* 169793 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 169797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 169802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 169812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 169817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169828 */   GIR_RootConstrainSelectedInstOperands,
     /* 169829 */   // GIR_Coverage, 6658,
     /* 169829 */   GIR_EraseRootFromParent_Done,
     /* 169830 */ // Label 2649: @169830
     /* 169830 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(169930), // Rule ID 6660 //
     /* 169835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
     /* 169838 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169841 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169852 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169865 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169869 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169873 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169883 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 169890 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 169890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFEN),
     /* 169893 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 169897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 169902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 169907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 169912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 169917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 169923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169928 */   GIR_RootConstrainSelectedInstOperands,
     /* 169929 */   // GIR_Coverage, 6660,
     /* 169929 */   GIR_EraseRootFromParent_Done,
     /* 169930 */ // Label 2650: @169930
     /* 169930 */ GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(170030), // Rule ID 6662 //
     /* 169935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
     /* 169938 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169941 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 169945 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 169952 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 169957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 169961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 169965 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169969 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 169973 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 169977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 169981 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 169990 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 169990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN),
     /* 169993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 169997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 170002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 170012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 170017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170028 */   GIR_RootConstrainSelectedInstOperands,
     /* 170029 */   // GIR_Coverage, 6662,
     /* 170029 */   GIR_EraseRootFromParent_Done,
     /* 170030 */ // Label 2651: @170030
     /* 170030 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(170100), // Rule ID 6597 //
     /* 170035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 170038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170041 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170045 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170052 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170057 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170061 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170068 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 170071 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170098 */   GIR_RootConstrainSelectedInstOperands,
     /* 170099 */   // GIR_Coverage, 6597,
     /* 170099 */   GIR_EraseRootFromParent_Done,
     /* 170100 */ // Label 2652: @170100
     /* 170100 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(170170), // Rule ID 6599 //
     /* 170105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 170108 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170111 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170115 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170122 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170138 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 170141 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170164 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170168 */   GIR_RootConstrainSelectedInstOperands,
     /* 170169 */   // GIR_Coverage, 6599,
     /* 170169 */   GIR_EraseRootFromParent_Done,
     /* 170170 */ // Label 2653: @170170
     /* 170170 */ GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(170240), // Rule ID 6601 //
     /* 170175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 170178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170181 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170192 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170208 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 170211 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170238 */   GIR_RootConstrainSelectedInstOperands,
     /* 170239 */   // GIR_Coverage, 6601,
     /* 170239 */   GIR_EraseRootFromParent_Done,
     /* 170240 */ // Label 2654: @170240
     /* 170240 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(170310), // Rule ID 6603 //
     /* 170245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 170248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170251 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170255 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170262 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170267 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170278 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 170281 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170304 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170308 */   GIR_RootConstrainSelectedInstOperands,
     /* 170309 */   // GIR_Coverage, 6603,
     /* 170309 */   GIR_EraseRootFromParent_Done,
     /* 170310 */ // Label 2655: @170310
     /* 170310 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(170369), // Rule ID 6613 //
     /* 170315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 170318 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170321 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170337 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 170340 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170367 */   GIR_RootConstrainSelectedInstOperands,
     /* 170368 */   // GIR_Coverage, 6613,
     /* 170368 */   GIR_EraseRootFromParent_Done,
     /* 170369 */ // Label 2656: @170369
     /* 170369 */ GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(170428), // Rule ID 6615 //
     /* 170374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 170377 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170380 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170396 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 170399 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170426 */   GIR_RootConstrainSelectedInstOperands,
     /* 170427 */   // GIR_Coverage, 6615,
     /* 170427 */   GIR_EraseRootFromParent_Done,
     /* 170428 */ // Label 2657: @170428
     /* 170428 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(170487), // Rule ID 6617 //
     /* 170433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 170436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170439 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170444 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170455 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 170458 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170485 */   GIR_RootConstrainSelectedInstOperands,
     /* 170486 */   // GIR_Coverage, 6617,
     /* 170486 */   GIR_EraseRootFromParent_Done,
     /* 170487 */ // Label 2658: @170487
     /* 170487 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(170546), // Rule ID 6619 //
     /* 170492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 170495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170498 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 170514 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 170514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 170517 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 170519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 170524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 170529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170544 */   GIR_RootConstrainSelectedInstOperands,
     /* 170545 */   // GIR_Coverage, 6619,
     /* 170545 */   GIR_EraseRootFromParent_Done,
     /* 170546 */ // Label 2659: @170546
     /* 170546 */ GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(170613), // Rule ID 4394 //
     /* 170551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 170554 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170557 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170561 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170568 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170573 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170577 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 170584 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
     /* 170587 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 170594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 170599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170611 */   GIR_RootConstrainSelectedInstOperands,
     /* 170612 */   // GIR_Coverage, 4394,
     /* 170612 */   GIR_EraseRootFromParent_Done,
     /* 170613 */ // Label 2660: @170613
     /* 170613 */ GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(170680), // Rule ID 4397 //
     /* 170618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 170621 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170624 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170635 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 170651 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
     /* 170654 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 170661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 170666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170678 */   GIR_RootConstrainSelectedInstOperands,
     /* 170679 */   // GIR_Coverage, 4397,
     /* 170679 */   GIR_EraseRootFromParent_Done,
     /* 170680 */ // Label 2661: @170680
     /* 170680 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(170736), // Rule ID 4256 //
     /* 170685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 170688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170691 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 170707 */   // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 170710 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 170717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 170722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170734 */   GIR_RootConstrainSelectedInstOperands,
     /* 170735 */   // GIR_Coverage, 4256,
     /* 170735 */   GIR_EraseRootFromParent_Done,
     /* 170736 */ // Label 2662: @170736
     /* 170736 */ GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(170792), // Rule ID 4262 //
     /* 170741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 170744 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170747 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170752 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170756 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 170763 */   // (st f32:{ *:[f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 170766 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 170773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 170778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 170783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170790 */   GIR_RootConstrainSelectedInstOperands,
     /* 170791 */   // GIR_Coverage, 4262,
     /* 170791 */   GIR_EraseRootFromParent_Done,
     /* 170792 */ // Label 2663: @170792
     /* 170792 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(170854), // Rule ID 4393 //
     /* 170797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 170800 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170803 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 170814 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 170830 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
     /* 170833 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170852 */   GIR_RootConstrainSelectedInstOperands,
     /* 170853 */   // GIR_Coverage, 4393,
     /* 170853 */   GIR_EraseRootFromParent_Done,
     /* 170854 */ // Label 2664: @170854
     /* 170854 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(170916), // Rule ID 4396 //
     /* 170859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 170862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170865 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 170869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170876 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170881 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 170892 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
     /* 170895 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170914 */   GIR_RootConstrainSelectedInstOperands,
     /* 170915 */   // GIR_Coverage, 4396,
     /* 170915 */   GIR_EraseRootFromParent_Done,
     /* 170916 */ // Label 2665: @170916
     /* 170916 */ GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(170967), // Rule ID 4255 //
     /* 170921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 170924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170927 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 170943 */   // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 170946 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 170953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 170958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 170961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 170965 */   GIR_RootConstrainSelectedInstOperands,
     /* 170966 */   // GIR_Coverage, 4255,
     /* 170966 */   GIR_EraseRootFromParent_Done,
     /* 170967 */ // Label 2666: @170967
     /* 170967 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(171018), // Rule ID 4261 //
     /* 170972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 170975 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170978 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 170983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 170987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 170994 */   // (st f32:{ *:[f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 170994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 170997 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 170999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 171004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171016 */   GIR_RootConstrainSelectedInstOperands,
     /* 171017 */   // GIR_Coverage, 4261,
     /* 171017 */   GIR_EraseRootFromParent_Done,
     /* 171018 */ // Label 2667: @171018
     /* 171018 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(171080), // Rule ID 4392 //
     /* 171023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 171026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171029 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171033 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171040 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 171045 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171049 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 171056 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 171056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
     /* 171059 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171074 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171078 */   GIR_RootConstrainSelectedInstOperands,
     /* 171079 */   // GIR_Coverage, 4392,
     /* 171079 */   GIR_EraseRootFromParent_Done,
     /* 171080 */ // Label 2668: @171080
     /* 171080 */ GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(171142), // Rule ID 4395 //
     /* 171085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 171088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171091 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171095 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171102 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 171107 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 171118 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 171118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
     /* 171121 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171140 */   GIR_RootConstrainSelectedInstOperands,
     /* 171141 */   // GIR_Coverage, 4395,
     /* 171141 */   GIR_EraseRootFromParent_Done,
     /* 171142 */ // Label 2669: @171142
     /* 171142 */ GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(171193), // Rule ID 4254 //
     /* 171147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 171150 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171153 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 171158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 171169 */   // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 171169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 171172 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171187 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171191 */   GIR_RootConstrainSelectedInstOperands,
     /* 171192 */   // GIR_Coverage, 4254,
     /* 171192 */   GIR_EraseRootFromParent_Done,
     /* 171193 */ // Label 2670: @171193
     /* 171193 */ GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(171244), // Rule ID 4260 //
     /* 171198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 171201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171204 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 171209 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171213 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 171220 */   // (st f32:{ *:[f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 171220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 171223 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 171225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 171230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171242 */   GIR_RootConstrainSelectedInstOperands,
     /* 171243 */   // GIR_Coverage, 4260,
     /* 171243 */   GIR_EraseRootFromParent_Done,
     /* 171244 */ // Label 2671: @171244
     /* 171244 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(171331), // Rule ID 8062 //
     /* 171249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 171252 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171255 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171259 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171266 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 171271 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 171275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 171279 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 171283 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 171287 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 171291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171297 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 171304 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_local>>  =>  (DS_WRITE_B16_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 171304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_D16_HI),
     /* 171307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 171312 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 171316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171329 */   GIR_RootConstrainSelectedInstOperands,
     /* 171330 */   // GIR_Coverage, 8062,
     /* 171330 */   GIR_EraseRootFromParent_Done,
     /* 171331 */ // Label 2672: @171331
     /* 171331 */ GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(171418), // Rule ID 8063 //
     /* 171336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 171339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171342 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171346 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171353 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 171358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 171362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 171366 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 171370 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 171374 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 171378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171384 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 171391 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_local>>  =>  (DS_WRITE_B8_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 171391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_D16_HI),
     /* 171394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 171399 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
     /* 171403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 171408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171416 */   GIR_RootConstrainSelectedInstOperands,
     /* 171417 */   // GIR_Coverage, 8063,
     /* 171417 */   GIR_EraseRootFromParent_Done,
     /* 171418 */ // Label 2673: @171418
     /* 171418 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(171489), // Rule ID 6580 //
     /* 171423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 171426 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171429 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171436 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 171452 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 171452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 171455 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 171457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171487 */   GIR_RootConstrainSelectedInstOperands,
     /* 171488 */   // GIR_Coverage, 6580,
     /* 171488 */   GIR_EraseRootFromParent_Done,
     /* 171489 */ // Label 2674: @171489
     /* 171489 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(171560), // Rule ID 6584 //
     /* 171494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 171497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171507 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 171523 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 171523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 171526 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 171528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171558 */   GIR_RootConstrainSelectedInstOperands,
     /* 171559 */   // GIR_Coverage, 6584,
     /* 171559 */   GIR_EraseRootFromParent_Done,
     /* 171560 */ // Label 2675: @171560
     /* 171560 */ GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(171631), // Rule ID 6588 //
     /* 171565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 171568 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171571 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171578 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 171594 */   // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 171594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 171597 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 171599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171609 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171629 */   GIR_RootConstrainSelectedInstOperands,
     /* 171630 */   // GIR_Coverage, 6588,
     /* 171630 */   GIR_EraseRootFromParent_Done,
     /* 171631 */ // Label 2676: @171631
     /* 171631 */ GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(171706), // Rule ID 4443 //
     /* 171636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 171639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171642 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171653 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 171669 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 171669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
     /* 171672 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 171674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171700 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171704 */   GIR_RootConstrainSelectedInstOperands,
     /* 171705 */   // GIR_Coverage, 4443,
     /* 171705 */   GIR_EraseRootFromParent_Done,
     /* 171706 */ // Label 2677: @171706
     /* 171706 */ GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(171778), // Rule ID 4607 //
     /* 171711 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171714 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171718 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171725 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171730 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 171741 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 171741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_ADDR64),
     /* 171744 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 171746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171776 */   GIR_RootConstrainSelectedInstOperands,
     /* 171777 */   // GIR_Coverage, 4607,
     /* 171777 */   GIR_EraseRootFromParent_Done,
     /* 171778 */ // Label 2678: @171778
     /* 171778 */ GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(171853), // Rule ID 4609 //
     /* 171783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 171786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171789 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171800 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171809 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 171816 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 171816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
     /* 171819 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 171821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171851 */   GIR_RootConstrainSelectedInstOperands,
     /* 171852 */   // GIR_Coverage, 4609,
     /* 171852 */   GIR_EraseRootFromParent_Done,
     /* 171853 */ // Label 2679: @171853
     /* 171853 */ GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(171925), // Rule ID 4611 //
     /* 171858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171861 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171865 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171872 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 171877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 171888 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 171888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_ADDR64),
     /* 171891 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 171893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171923 */   GIR_RootConstrainSelectedInstOperands,
     /* 171924 */   // GIR_Coverage, 4611,
     /* 171924 */   GIR_EraseRootFromParent_Done,
     /* 171925 */ // Label 2680: @171925
     /* 171925 */ GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(172000), // Rule ID 6596 //
     /* 171930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 171933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171936 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 171940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 171947 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 171952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 171956 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 171963 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 171963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
     /* 171966 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 171968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 171973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 171978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 171983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 171988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 171994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 171998 */   GIR_RootConstrainSelectedInstOperands,
     /* 171999 */   // GIR_Coverage, 6596,
     /* 171999 */   GIR_EraseRootFromParent_Done,
     /* 172000 */ // Label 2681: @172000
     /* 172000 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(172075), // Rule ID 6598 //
     /* 172005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 172008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172011 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172015 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 172022 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172027 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172031 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 172038 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 172038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
     /* 172041 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172073 */   GIR_RootConstrainSelectedInstOperands,
     /* 172074 */   // GIR_Coverage, 6598,
     /* 172074 */   GIR_EraseRootFromParent_Done,
     /* 172075 */ // Label 2682: @172075
     /* 172075 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(172150), // Rule ID 6600 //
     /* 172080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 172083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172086 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172090 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172097 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172106 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 172113 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 172113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
     /* 172116 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172148 */   GIR_RootConstrainSelectedInstOperands,
     /* 172149 */   // GIR_Coverage, 6600,
     /* 172149 */   GIR_EraseRootFromParent_Done,
     /* 172150 */ // Label 2683: @172150
     /* 172150 */ GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(172225), // Rule ID 6602 //
     /* 172155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 172158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172161 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172165 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172172 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 172188 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 172188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
     /* 172191 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172219 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172223 */   GIR_RootConstrainSelectedInstOperands,
     /* 172224 */   // GIR_Coverage, 6602,
     /* 172224 */   GIR_EraseRootFromParent_Done,
     /* 172225 */ // Label 2684: @172225
     /* 172225 */ GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(172289), // Rule ID 4613 //
     /* 172230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 172233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172236 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172252 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 172255 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172283 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172287 */   GIR_RootConstrainSelectedInstOperands,
     /* 172288 */   // GIR_Coverage, 4613,
     /* 172288 */   GIR_EraseRootFromParent_Done,
     /* 172289 */ // Label 2685: @172289
     /* 172289 */ GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(172350), // Rule ID 4615 //
     /* 172294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172297 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172306 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172313 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 172316 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172348 */   GIR_RootConstrainSelectedInstOperands,
     /* 172349 */   // GIR_Coverage, 4615,
     /* 172349 */   GIR_EraseRootFromParent_Done,
     /* 172350 */ // Label 2686: @172350
     /* 172350 */ GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(172414), // Rule ID 4617 //
     /* 172355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 172358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172361 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172377 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 172380 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172412 */   GIR_RootConstrainSelectedInstOperands,
     /* 172413 */   // GIR_Coverage, 4617,
     /* 172413 */   GIR_EraseRootFromParent_Done,
     /* 172414 */ // Label 2687: @172414
     /* 172414 */ GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(172475), // Rule ID 4619 //
     /* 172419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172422 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172431 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 172438 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 172441 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172473 */   GIR_RootConstrainSelectedInstOperands,
     /* 172474 */   // GIR_Coverage, 4619,
     /* 172474 */   GIR_EraseRootFromParent_Done,
     /* 172475 */ // Label 2688: @172475
     /* 172475 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(172539), // Rule ID 6612 //
     /* 172480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 172483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172486 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 172502 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 172502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 172505 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172533 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172537 */   GIR_RootConstrainSelectedInstOperands,
     /* 172538 */   // GIR_Coverage, 6612,
     /* 172538 */   GIR_EraseRootFromParent_Done,
     /* 172539 */ // Label 2689: @172539
     /* 172539 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(172603), // Rule ID 6614 //
     /* 172544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 172547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172550 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 172566 */   // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 172566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 172569 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172601 */   GIR_RootConstrainSelectedInstOperands,
     /* 172602 */   // GIR_Coverage, 6614,
     /* 172602 */   GIR_EraseRootFromParent_Done,
     /* 172603 */ // Label 2690: @172603
     /* 172603 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(172667), // Rule ID 6616 //
     /* 172608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 172611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172614 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 172630 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 172630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 172633 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172665 */   GIR_RootConstrainSelectedInstOperands,
     /* 172666 */   // GIR_Coverage, 6616,
     /* 172666 */   GIR_EraseRootFromParent_Done,
     /* 172667 */ // Label 2691: @172667
     /* 172667 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(172731), // Rule ID 6618 //
     /* 172672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 172675 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172678 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 172683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 172694 */   // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 172694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 172697 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 172699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 172704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 172714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 172719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172729 */   GIR_RootConstrainSelectedInstOperands,
     /* 172730 */   // GIR_Coverage, 6618,
     /* 172730 */   GIR_EraseRootFromParent_Done,
     /* 172731 */ // Label 2692: @172731
     /* 172731 */ GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(172823), // Rule ID 3980 //
     /* 172736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 172739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172742 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172753 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 172762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 172766 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 172770 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 172774 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 172778 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172782 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172784 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 172791 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI_SADDR),
     /* 172794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 172799 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 172803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 172808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 172813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172821 */   GIR_RootConstrainSelectedInstOperands,
     /* 172822 */   // GIR_Coverage, 3980,
     /* 172822 */   GIR_EraseRootFromParent_Done,
     /* 172823 */ // Label 2693: @172823
     /* 172823 */ GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(172915), // Rule ID 3982 //
     /* 172828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 172831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172834 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172838 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 172845 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 172854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 172858 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 172862 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 172866 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 172870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 172883 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 172883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI_SADDR),
     /* 172886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 172891 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 172895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 172900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 172905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172913 */   GIR_RootConstrainSelectedInstOperands,
     /* 172914 */   // GIR_Coverage, 3982,
     /* 172914 */   GIR_EraseRootFromParent_Done,
     /* 172915 */ // Label 2694: @172915
     /* 172915 */ GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(172985), // Rule ID 4442 //
     /* 172920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 172923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 172937 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 172942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 172946 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 172953 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 172953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
     /* 172956 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 172958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 172963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 172968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 172973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 172979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 172983 */   GIR_RootConstrainSelectedInstOperands,
     /* 172984 */   // GIR_Coverage, 4442,
     /* 172984 */   GIR_EraseRootFromParent_Done,
     /* 172985 */ // Label 2695: @172985
     /* 172985 */ GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(173052), // Rule ID 4606 //
     /* 172990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172993 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 172997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 173004 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173013 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173020 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
     /* 173023 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173046 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173050 */   GIR_RootConstrainSelectedInstOperands,
     /* 173051 */   // GIR_Coverage, 4606,
     /* 173051 */   GIR_EraseRootFromParent_Done,
     /* 173052 */ // Label 2696: @173052
     /* 173052 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(173122), // Rule ID 4608 //
     /* 173057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173063 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173067 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 173074 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173090 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
     /* 173093 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173120 */   GIR_RootConstrainSelectedInstOperands,
     /* 173121 */   // GIR_Coverage, 4608,
     /* 173121 */   GIR_EraseRootFromParent_Done,
     /* 173122 */ // Label 2697: @173122
     /* 173122 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(173189), // Rule ID 4610 //
     /* 173127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173130 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173134 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 173141 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173146 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173150 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173157 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
     /* 173160 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173167 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173187 */   GIR_RootConstrainSelectedInstOperands,
     /* 173188 */   // GIR_Coverage, 4610,
     /* 173188 */   GIR_EraseRootFromParent_Done,
     /* 173189 */ // Label 2698: @173189
     /* 173189 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(173248), // Rule ID 4612 //
     /* 173194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173200 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173216 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 173219 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173246 */   GIR_RootConstrainSelectedInstOperands,
     /* 173247 */   // GIR_Coverage, 4612,
     /* 173247 */   GIR_EraseRootFromParent_Done,
     /* 173248 */ // Label 2699: @173248
     /* 173248 */ GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(173304), // Rule ID 4614 //
     /* 173253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173256 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173272 */   // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 173275 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173302 */   GIR_RootConstrainSelectedInstOperands,
     /* 173303 */   // GIR_Coverage, 4614,
     /* 173303 */   GIR_EraseRootFromParent_Done,
     /* 173304 */ // Label 2700: @173304
     /* 173304 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(173363), // Rule ID 4616 //
     /* 173309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 173312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173315 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173331 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 173334 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173361 */   GIR_RootConstrainSelectedInstOperands,
     /* 173362 */   // GIR_Coverage, 4616,
     /* 173362 */   GIR_EraseRootFromParent_Done,
     /* 173363 */ // Label 2701: @173363
     /* 173363 */ GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(173419), // Rule ID 4618 //
     /* 173368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173371 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173380 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 173387 */   // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 173387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 173390 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 173392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 173397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 173402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 173407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173417 */   GIR_RootConstrainSelectedInstOperands,
     /* 173418 */   // GIR_Coverage, 4618,
     /* 173418 */   GIR_EraseRootFromParent_Done,
     /* 173419 */ // Label 2702: @173419
     /* 173419 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(173506), // Rule ID 3979 //
     /* 173424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 173427 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173430 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173434 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 173441 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 173450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 173454 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 173458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 173462 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 173466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 173479 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 173479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI),
     /* 173482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 173487 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 173491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173499 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173504 */   GIR_RootConstrainSelectedInstOperands,
     /* 173505 */   // GIR_Coverage, 3979,
     /* 173505 */   GIR_EraseRootFromParent_Done,
     /* 173506 */ // Label 2703: @173506
     /* 173506 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(173593), // Rule ID 3981 //
     /* 173511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 173514 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173517 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173521 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 173528 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 173533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 173537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 173541 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 173545 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 173549 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 173553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 173566 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 173566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI),
     /* 173569 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 173574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 173578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173591 */   GIR_RootConstrainSelectedInstOperands,
     /* 173592 */   // GIR_Coverage, 3981,
     /* 173592 */   GIR_EraseRootFromParent_Done,
     /* 173593 */ // Label 2704: @173593
     /* 173593 */ GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(173651), // Rule ID 8050 //
     /* 173598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 173601 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 173611 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173616 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173627 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 173630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173635 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173645 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173649 */   GIR_RootConstrainSelectedInstOperands,
     /* 173650 */   // GIR_Coverage, 8050,
     /* 173650 */   GIR_EraseRootFromParent_Done,
     /* 173651 */ // Label 2705: @173651
     /* 173651 */ GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(173709), // Rule ID 8051 //
     /* 173656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173659 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173662 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 173669 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173685 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 173688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173693 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173707 */   GIR_RootConstrainSelectedInstOperands,
     /* 173708 */   // GIR_Coverage, 8051,
     /* 173708 */   GIR_EraseRootFromParent_Done,
     /* 173709 */ // Label 2706: @173709
     /* 173709 */ GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(173767), // Rule ID 8056 //
     /* 173714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 173717 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 173727 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173736 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173743 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 173746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173751 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173765 */   GIR_RootConstrainSelectedInstOperands,
     /* 173766 */   // GIR_Coverage, 8056,
     /* 173766 */   GIR_EraseRootFromParent_Done,
     /* 173767 */ // Label 2707: @173767
     /* 173767 */ GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(173825), // Rule ID 8057 //
     /* 173772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 173785 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173790 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173794 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173801 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 173804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173809 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173823 */   GIR_RootConstrainSelectedInstOperands,
     /* 173824 */   // GIR_Coverage, 8057,
     /* 173824 */   GIR_EraseRootFromParent_Done,
     /* 173825 */ // Label 2708: @173825
     /* 173825 */ GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(173883), // Rule ID 8058 //
     /* 173830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 173833 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173836 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 173843 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173859 */   // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32_glue>><<P:Predicate_atomic_store_32_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 173862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173867 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173877 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173881 */   GIR_RootConstrainSelectedInstOperands,
     /* 173882 */   // GIR_Coverage, 8058,
     /* 173882 */   GIR_EraseRootFromParent_Done,
     /* 173883 */ // Label 2709: @173883
     /* 173883 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(173941), // Rule ID 8059 //
     /* 173888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 173891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 173894 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 173901 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173917 */   // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 173920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173925 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 173939 */   GIR_RootConstrainSelectedInstOperands,
     /* 173940 */   // GIR_Coverage, 8059,
     /* 173940 */   GIR_EraseRootFromParent_Done,
     /* 173941 */ // Label 2710: @173941
     /* 173941 */ GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(174003), // Rule ID 8018 //
     /* 173946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 173949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173952 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 173956 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 173963 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 173968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 173972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 173979 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 173979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
     /* 173982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 173987 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 173989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 173994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 173997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174001 */   GIR_RootConstrainSelectedInstOperands,
     /* 174002 */   // GIR_Coverage, 8018,
     /* 174002 */   GIR_EraseRootFromParent_Done,
     /* 174003 */ // Label 2711: @174003
     /* 174003 */ GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(174065), // Rule ID 8019 //
     /* 174008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 174011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174014 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 174018 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 174025 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 174030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 174041 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 174041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
     /* 174044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 174049 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174063 */   GIR_RootConstrainSelectedInstOperands,
     /* 174064 */   // GIR_Coverage, 8019,
     /* 174064 */   GIR_EraseRootFromParent_Done,
     /* 174065 */ // Label 2712: @174065
     /* 174065 */ GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(174127), // Rule ID 8023 //
     /* 174070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 174073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174076 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 174080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 174087 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 174092 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174096 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 174103 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei16_glue>><<P:Predicate_truncstorei16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 174103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
     /* 174106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 174111 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174125 */   GIR_RootConstrainSelectedInstOperands,
     /* 174126 */   // GIR_Coverage, 8023,
     /* 174126 */   GIR_EraseRootFromParent_Done,
     /* 174127 */ // Label 2713: @174127
     /* 174127 */ GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(174189), // Rule ID 8024 //
     /* 174132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 174135 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174138 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 174142 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 174149 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 174154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 174165 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 174165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
     /* 174168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 174173 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174183 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174187 */   GIR_RootConstrainSelectedInstOperands,
     /* 174188 */   // GIR_Coverage, 8024,
     /* 174188 */   GIR_EraseRootFromParent_Done,
     /* 174189 */ // Label 2714: @174189
     /* 174189 */ GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(174244), // Rule ID 8030 //
     /* 174194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 174197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174200 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 174204 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 174209 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174213 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 174220 */   // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 174220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 174223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 174228 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174242 */   GIR_RootConstrainSelectedInstOperands,
     /* 174243 */   // GIR_Coverage, 8030,
     /* 174243 */   GIR_EraseRootFromParent_Done,
     /* 174244 */ // Label 2715: @174244
     /* 174244 */ GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(174299), // Rule ID 8032 //
     /* 174249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 174252 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174255 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 174259 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 174264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 174275 */   // (AMDGPUst_glue f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 174275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 174278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 174283 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174297 */   GIR_RootConstrainSelectedInstOperands,
     /* 174298 */   // GIR_Coverage, 8032,
     /* 174298 */   GIR_EraseRootFromParent_Done,
     /* 174299 */ // Label 2716: @174299
     /* 174299 */ GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(174350), // Rule ID 8031 //
     /* 174304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 174307 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174310 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 174315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 174326 */   // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 174326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 174329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 174334 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174348 */   GIR_RootConstrainSelectedInstOperands,
     /* 174349 */   // GIR_Coverage, 8031,
     /* 174349 */   GIR_EraseRootFromParent_Done,
     /* 174350 */ // Label 2717: @174350
     /* 174350 */ GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(174401), // Rule ID 8033 //
     /* 174355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 174358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174361 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 174366 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 174377 */   // (st f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 174377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 174380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 174385 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 174387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174399 */   GIR_RootConstrainSelectedInstOperands,
     /* 174400 */   // GIR_Coverage, 8033,
     /* 174400 */   GIR_EraseRootFromParent_Done,
     /* 174401 */ // Label 2718: @174401
     /* 174401 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(174464), // Rule ID 4006 //
     /* 174406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 174419 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174428 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174435 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 174438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174443 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174462 */   GIR_RootConstrainSelectedInstOperands,
     /* 174463 */   // GIR_Coverage, 4006,
     /* 174463 */   GIR_EraseRootFromParent_Done,
     /* 174464 */ // Label 2719: @174464
     /* 174464 */ GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(174527), // Rule ID 4010 //
     /* 174469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174472 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174475 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 174482 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174498 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 174501 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174506 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174525 */   GIR_RootConstrainSelectedInstOperands,
     /* 174526 */   // GIR_Coverage, 4010,
     /* 174526 */   GIR_EraseRootFromParent_Done,
     /* 174527 */ // Label 2720: @174527
     /* 174527 */ GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(174590), // Rule ID 4014 //
     /* 174532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174535 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174538 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 174545 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174561 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 174564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174569 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174588 */   GIR_RootConstrainSelectedInstOperands,
     /* 174589 */   // GIR_Coverage, 4014,
     /* 174589 */   GIR_EraseRootFromParent_Done,
     /* 174590 */ // Label 2721: @174590
     /* 174590 */ GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(174657), // Rule ID 3966 //
     /* 174595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174601 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 174605 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 174612 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174628 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
     /* 174631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174636 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174655 */   GIR_RootConstrainSelectedInstOperands,
     /* 174656 */   // GIR_Coverage, 3966,
     /* 174656 */   GIR_EraseRootFromParent_Done,
     /* 174657 */ // Label 2722: @174657
     /* 174657 */ GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(174724), // Rule ID 3968 //
     /* 174662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174665 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174668 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 174672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 174679 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174695 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
     /* 174698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174703 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174718 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174722 */   GIR_RootConstrainSelectedInstOperands,
     /* 174723 */   // GIR_Coverage, 3968,
     /* 174723 */   GIR_EraseRootFromParent_Done,
     /* 174724 */ // Label 2723: @174724
     /* 174724 */ GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(174780), // Rule ID 3559 //
     /* 174729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174732 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174735 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174751 */   // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 174754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174759 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174778 */   GIR_RootConstrainSelectedInstOperands,
     /* 174779 */   // GIR_Coverage, 3559,
     /* 174779 */   GIR_EraseRootFromParent_Done,
     /* 174780 */ // Label 2724: @174780
     /* 174780 */ GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(174836), // Rule ID 3874 //
     /* 174785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174791 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174796 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174800 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 174807 */   // (st f32:{ *:[f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 174807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 174810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 174815 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 174822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 174827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174834 */   GIR_RootConstrainSelectedInstOperands,
     /* 174835 */   // GIR_Coverage, 3874,
     /* 174835 */   GIR_EraseRootFromParent_Done,
     /* 174836 */ // Label 2725: @174836
     /* 174836 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(174894), // Rule ID 4005 //
     /* 174841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174844 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174847 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 174854 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174870 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 174870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 174873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174878 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174892 */   GIR_RootConstrainSelectedInstOperands,
     /* 174893 */   // GIR_Coverage, 4005,
     /* 174893 */   GIR_EraseRootFromParent_Done,
     /* 174894 */ // Label 2726: @174894
     /* 174894 */ GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(174952), // Rule ID 4009 //
     /* 174899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 174912 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174917 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174928 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 174928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 174931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174936 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 174943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 174950 */   GIR_RootConstrainSelectedInstOperands,
     /* 174951 */   // GIR_Coverage, 4009,
     /* 174951 */   GIR_EraseRootFromParent_Done,
     /* 174952 */ // Label 2727: @174952
     /* 174952 */ GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(175010), // Rule ID 4013 //
     /* 174957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 174960 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 174963 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 174970 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 174975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 174979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 174986 */   // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 174986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 174989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 174994 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 174996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175008 */   GIR_RootConstrainSelectedInstOperands,
     /* 175009 */   // GIR_Coverage, 4013,
     /* 175009 */   GIR_EraseRootFromParent_Done,
     /* 175010 */ // Label 2728: @175010
     /* 175010 */ GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(175072), // Rule ID 3965 //
     /* 175015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175021 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175025 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 175032 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 175048 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
     /* 175051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175056 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175070 */   GIR_RootConstrainSelectedInstOperands,
     /* 175071 */   // GIR_Coverage, 3965,
     /* 175071 */   GIR_EraseRootFromParent_Done,
     /* 175072 */ // Label 2729: @175072
     /* 175072 */ GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(175134), // Rule ID 3967 //
     /* 175077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175080 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175083 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175087 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 175094 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 175110 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
     /* 175113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175118 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175132 */   GIR_RootConstrainSelectedInstOperands,
     /* 175133 */   // GIR_Coverage, 3967,
     /* 175133 */   GIR_EraseRootFromParent_Done,
     /* 175134 */ // Label 2730: @175134
     /* 175134 */ GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(175185), // Rule ID 3558 //
     /* 175139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175145 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 175161 */   // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 175164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175169 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175183 */   GIR_RootConstrainSelectedInstOperands,
     /* 175184 */   // GIR_Coverage, 3558,
     /* 175184 */   GIR_EraseRootFromParent_Done,
     /* 175185 */ // Label 2731: @175185
     /* 175185 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(175236), // Rule ID 3873 //
     /* 175190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 175193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175196 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 175201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 175212 */   // (st f32:{ *:[f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 175215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175220 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175234 */   GIR_RootConstrainSelectedInstOperands,
     /* 175235 */   // GIR_Coverage, 3873,
     /* 175235 */   GIR_EraseRootFromParent_Done,
     /* 175236 */ // Label 2732: @175236
     /* 175236 */ GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(175324), // Rule ID 3793 //
     /* 175241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 175244 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175247 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175251 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 175258 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 175268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 175272 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 175276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 175280 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 175284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175290 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175297 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_flat>>  =>  (FLAT_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT_D16_HI),
     /* 175300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175305 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 175309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175322 */   GIR_RootConstrainSelectedInstOperands,
     /* 175323 */   // GIR_Coverage, 3793,
     /* 175323 */   GIR_EraseRootFromParent_Done,
     /* 175324 */ // Label 2733: @175324
     /* 175324 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(175412), // Rule ID 3794 //
     /* 175329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
     /* 175332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175335 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 175346 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 175356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 175360 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 175364 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 175368 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 175372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175385 */   // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_flat>>  =>  (FLAT_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE_D16_HI),
     /* 175388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175393 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
     /* 175397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175410 */   GIR_RootConstrainSelectedInstOperands,
     /* 175411 */   // GIR_Coverage, 3794,
     /* 175411 */   GIR_EraseRootFromParent_Done,
     /* 175412 */ // Label 2734: @175412
     /* 175412 */ GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(175471), // Rule ID 3667 //
     /* 175417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175420 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 175423 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 175430 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175436 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175440 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175447 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 175450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175455 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175465 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175469 */   GIR_RootConstrainSelectedInstOperands,
     /* 175470 */   // GIR_Coverage, 3667,
     /* 175470 */   GIR_EraseRootFromParent_Done,
     /* 175471 */ // Label 2735: @175471
     /* 175471 */ GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(175530), // Rule ID 3669 //
     /* 175476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175479 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 175482 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 175489 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175506 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 175509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175514 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175528 */   GIR_RootConstrainSelectedInstOperands,
     /* 175529 */   // GIR_Coverage, 3669,
     /* 175529 */   GIR_EraseRootFromParent_Done,
     /* 175530 */ // Label 2736: @175530
     /* 175530 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(175589), // Rule ID 3671 //
     /* 175535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175538 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 175541 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 175548 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175558 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175565 */   // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 175568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175573 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175587 */   GIR_RootConstrainSelectedInstOperands,
     /* 175588 */   // GIR_Coverage, 3671,
     /* 175588 */   GIR_EraseRootFromParent_Done,
     /* 175589 */ // Label 2737: @175589
     /* 175589 */ GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(175652), // Rule ID 3618 //
     /* 175594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175600 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 175611 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175628 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
     /* 175631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175636 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175650 */   GIR_RootConstrainSelectedInstOperands,
     /* 175651 */   // GIR_Coverage, 3618,
     /* 175651 */   GIR_EraseRootFromParent_Done,
     /* 175652 */ // Label 2738: @175652
     /* 175652 */ GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(175715), // Rule ID 3619 //
     /* 175657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175663 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 175674 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175684 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175691 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
     /* 175694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175699 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175713 */   GIR_RootConstrainSelectedInstOperands,
     /* 175714 */   // GIR_Coverage, 3619,
     /* 175714 */   GIR_EraseRootFromParent_Done,
     /* 175715 */ // Label 2739: @175715
     /* 175715 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(175767), // Rule ID 3621 //
     /* 175720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175723 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175726 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175736 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175743 */   // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 175746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175751 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175765 */   GIR_RootConstrainSelectedInstOperands,
     /* 175766 */   // GIR_Coverage, 3621,
     /* 175766 */   GIR_EraseRootFromParent_Done,
     /* 175767 */ // Label 2740: @175767
     /* 175767 */ GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(175819), // Rule ID 3623 //
     /* 175772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 175775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175778 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 175784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175788 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 175795 */   // (st f32:{ *:[f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 175795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 175798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 175803 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 175805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175813 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175817 */   GIR_RootConstrainSelectedInstOperands,
     /* 175818 */   // GIR_Coverage, 3623,
     /* 175818 */   GIR_EraseRootFromParent_Done,
     /* 175819 */ // Label 2741: @175819
     /* 175819 */ GIM_Reject,
     /* 175820 */ // Label 2438: @175820
     /* 175820 */ GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(175884), // Rule ID 8194 //
     /* 175825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 175828 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175831 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175835 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175840 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175845 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175849 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 175853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175860 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 175863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175868 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175882 */   GIR_RootConstrainSelectedInstOperands,
     /* 175883 */   // GIR_Coverage, 8194,
     /* 175883 */   GIR_EraseRootFromParent_Done,
     /* 175884 */ // Label 2742: @175884
     /* 175884 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(175948), // Rule ID 8198 //
     /* 175889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 175892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175895 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175899 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175904 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175913 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 175917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175924 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 175927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175932 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 175942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 175946 */   GIR_RootConstrainSelectedInstOperands,
     /* 175947 */   // GIR_Coverage, 8198,
     /* 175947 */   GIR_EraseRootFromParent_Done,
     /* 175948 */ // Label 2743: @175948
     /* 175948 */ GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(176007), // Rule ID 8126 //
     /* 175953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 175956 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175959 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 175963 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 175968 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 175972 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 175976 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 175983 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 175983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 175986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 175991 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 175993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 175998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176005 */   GIR_RootConstrainSelectedInstOperands,
     /* 176006 */   // GIR_Coverage, 8126,
     /* 176006 */   GIR_EraseRootFromParent_Done,
     /* 176007 */ // Label 2744: @176007
     /* 176007 */ GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(176066), // Rule ID 8130 //
     /* 176012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 176015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176022 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176027 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176042 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 176045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176050 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176060 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176064 */   GIR_RootConstrainSelectedInstOperands,
     /* 176065 */   // GIR_Coverage, 8130,
     /* 176065 */   GIR_EraseRootFromParent_Done,
     /* 176066 */ // Label 2745: @176066
     /* 176066 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(176126), // Rule ID 8195 //
     /* 176071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 176074 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176077 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176082 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176091 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 176095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176102 */   // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176110 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176120 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176124 */   GIR_RootConstrainSelectedInstOperands,
     /* 176125 */   // GIR_Coverage, 8195,
     /* 176125 */   GIR_EraseRootFromParent_Done,
     /* 176126 */ // Label 2746: @176126
     /* 176126 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(176186), // Rule ID 8199 //
     /* 176131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 176134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176137 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176142 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176147 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176151 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 176155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176162 */   // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176170 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176180 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176184 */   GIR_RootConstrainSelectedInstOperands,
     /* 176185 */   // GIR_Coverage, 8199,
     /* 176185 */   GIR_EraseRootFromParent_Done,
     /* 176186 */ // Label 2747: @176186
     /* 176186 */ GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(176241), // Rule ID 8127 //
     /* 176191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 176194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176197 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176202 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176217 */   // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176225 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176239 */   GIR_RootConstrainSelectedInstOperands,
     /* 176240 */   // GIR_Coverage, 8127,
     /* 176240 */   GIR_EraseRootFromParent_Done,
     /* 176241 */ // Label 2748: @176241
     /* 176241 */ GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(176296), // Rule ID 8131 //
     /* 176246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 176249 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176252 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176257 */   GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 176261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 176272 */   // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 176272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 176275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 176280 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 176282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176294 */   GIR_RootConstrainSelectedInstOperands,
     /* 176295 */   // GIR_Coverage, 8131,
     /* 176295 */   GIR_EraseRootFromParent_Done,
     /* 176296 */ // Label 2749: @176296
     /* 176296 */ GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(176352), // Rule ID 4304 //
     /* 176301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 176304 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176307 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 176323 */   // (st i64:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 176326 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 176338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176346 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176350 */   GIR_RootConstrainSelectedInstOperands,
     /* 176351 */   // GIR_Coverage, 4304,
     /* 176351 */   GIR_EraseRootFromParent_Done,
     /* 176352 */ // Label 2750: @176352
     /* 176352 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(176408), // Rule ID 4310 //
     /* 176357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 176360 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176363 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 176379 */   // (st f64:{ *:[f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 176382 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 176394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 176399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176402 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176406 */   GIR_RootConstrainSelectedInstOperands,
     /* 176407 */   // GIR_Coverage, 4310,
     /* 176407 */   GIR_EraseRootFromParent_Done,
     /* 176408 */ // Label 2751: @176408
     /* 176408 */ GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(176459), // Rule ID 4303 //
     /* 176413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176419 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176428 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 176435 */   // (st i64:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 176438 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 176445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176457 */   GIR_RootConstrainSelectedInstOperands,
     /* 176458 */   // GIR_Coverage, 4303,
     /* 176458 */   GIR_EraseRootFromParent_Done,
     /* 176459 */ // Label 2752: @176459
     /* 176459 */ GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(176510), // Rule ID 4309 //
     /* 176464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176470 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176475 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176479 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 176486 */   // (st f64:{ *:[f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 176486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 176489 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 176496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176508 */   GIR_RootConstrainSelectedInstOperands,
     /* 176509 */   // GIR_Coverage, 4309,
     /* 176509 */   GIR_EraseRootFromParent_Done,
     /* 176510 */ // Label 2753: @176510
     /* 176510 */ GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(176561), // Rule ID 4302 //
     /* 176515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176518 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176521 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176526 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176530 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 176537 */   // (st i64:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 176537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 176540 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176559 */   GIR_RootConstrainSelectedInstOperands,
     /* 176560 */   // GIR_Coverage, 4302,
     /* 176560 */   GIR_EraseRootFromParent_Done,
     /* 176561 */ // Label 2754: @176561
     /* 176561 */ GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(176612), // Rule ID 4308 //
     /* 176566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 176569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176572 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 176577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 176588 */   // (st f64:{ *:[f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 176588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 176591 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 176593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 176598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 176603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176606 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176610 */   GIR_RootConstrainSelectedInstOperands,
     /* 176611 */   // GIR_Coverage, 4308,
     /* 176611 */   GIR_EraseRootFromParent_Done,
     /* 176612 */ // Label 2755: @176612
     /* 176612 */ GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(176683), // Rule ID 6590 //
     /* 176617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 176620 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 176623 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 176630 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176639 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176646 */   // (atomic_store i64:{ *:[i64] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 ?:{ *:[i64] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
     /* 176646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 176649 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 176651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 176656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 176666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 176671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176681 */   GIR_RootConstrainSelectedInstOperands,
     /* 176682 */   // GIR_Coverage, 6590,
     /* 176682 */   GIR_EraseRootFromParent_Done,
     /* 176683 */ // Label 2756: @176683
     /* 176683 */ GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(176747), // Rule ID 4645 //
     /* 176688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 176691 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176694 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176699 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176703 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176710 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 176710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 176713 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 176715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 176720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 176730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 176735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176741 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176745 */   GIR_RootConstrainSelectedInstOperands,
     /* 176746 */   // GIR_Coverage, 4645,
     /* 176746 */   GIR_EraseRootFromParent_Done,
     /* 176747 */ // Label 2757: @176747
     /* 176747 */ GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(176808), // Rule ID 4647 //
     /* 176752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176755 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176771 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 176771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 176774 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 176776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 176781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 176791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 176796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176806 */   GIR_RootConstrainSelectedInstOperands,
     /* 176807 */   // GIR_Coverage, 4647,
     /* 176807 */   GIR_EraseRootFromParent_Done,
     /* 176808 */ // Label 2758: @176808
     /* 176808 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(176872), // Rule ID 4649 //
     /* 176813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 176816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176819 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176824 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176835 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 176835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 176838 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 176840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 176845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 176855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 176860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176866 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176870 */   GIR_RootConstrainSelectedInstOperands,
     /* 176871 */   // GIR_Coverage, 4649,
     /* 176871 */   GIR_EraseRootFromParent_Done,
     /* 176872 */ // Label 2759: @176872
     /* 176872 */ GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(176933), // Rule ID 4651 //
     /* 176877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176880 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 176885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176889 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 176896 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 176896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 176899 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 176901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 176906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 176911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 176916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 176921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 176927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 176931 */   GIR_RootConstrainSelectedInstOperands,
     /* 176932 */   // GIR_Coverage, 4651,
     /* 176932 */   GIR_EraseRootFromParent_Done,
     /* 176933 */ // Label 2760: @176933
     /* 176933 */ GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(177053), // Rule ID 8065 //
     /* 176938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 176941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 176948 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 176953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 176957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 176964 */   // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 176964 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 176967 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176971 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176976 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 176982 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 176987 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 176992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 176995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 176999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177004 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177015 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 177023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177051 */   GIR_RootConstrainSelectedInstOperands,
     /* 177052 */   // GIR_Coverage, 8065,
     /* 177052 */   GIR_EraseRootFromParent_Done,
     /* 177053 */ // Label 2761: @177053
     /* 177053 */ GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(177173), // Rule ID 8073 //
     /* 177058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 177061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177064 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 177068 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177084 */   // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177084 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177087 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177091 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177096 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177102 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177107 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177124 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177130 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 177143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177171 */   GIR_RootConstrainSelectedInstOperands,
     /* 177172 */   // GIR_Coverage, 8073,
     /* 177172 */   GIR_EraseRootFromParent_Done,
     /* 177173 */ // Label 2762: @177173
     /* 177173 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(177232), // Rule ID 4644 //
     /* 177178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177184 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177189 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177193 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177200 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 177203 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177226 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177230 */   GIR_RootConstrainSelectedInstOperands,
     /* 177231 */   // GIR_Coverage, 4644,
     /* 177231 */   GIR_EraseRootFromParent_Done,
     /* 177232 */ // Label 2763: @177232
     /* 177232 */ GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(177288), // Rule ID 4646 //
     /* 177237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177240 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177245 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177249 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177256 */   // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 177259 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177286 */   GIR_RootConstrainSelectedInstOperands,
     /* 177287 */   // GIR_Coverage, 4646,
     /* 177287 */   GIR_EraseRootFromParent_Done,
     /* 177288 */ // Label 2764: @177288
     /* 177288 */ GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(177347), // Rule ID 4648 //
     /* 177293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 177296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177299 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177304 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177315 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 177318 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177341 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177345 */   GIR_RootConstrainSelectedInstOperands,
     /* 177346 */   // GIR_Coverage, 4648,
     /* 177346 */   GIR_EraseRootFromParent_Done,
     /* 177347 */ // Label 2765: @177347
     /* 177347 */ GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(177403), // Rule ID 4650 //
     /* 177352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177355 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 177371 */   // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 177371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 177374 */   GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 177376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 177381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 177386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177401 */   GIR_RootConstrainSelectedInstOperands,
     /* 177402 */   // GIR_Coverage, 4650,
     /* 177402 */   GIR_EraseRootFromParent_Done,
     /* 177403 */ // Label 2766: @177403
     /* 177403 */ GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(177519), // Rule ID 8067 //
     /* 177408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 177411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177414 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177419 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177423 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177430 */   // (st i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177430 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177433 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177437 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177442 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177448 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177470 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 177489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177517 */   GIR_RootConstrainSelectedInstOperands,
     /* 177518 */   // GIR_Coverage, 8067,
     /* 177518 */   GIR_EraseRootFromParent_Done,
     /* 177519 */ // Label 2767: @177519
     /* 177519 */ GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(177635), // Rule ID 8075 //
     /* 177524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 177527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177530 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177539 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 177546 */   // (st f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 177546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177558 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 177564 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177569 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177586 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 177592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 177597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 177602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 177605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 177616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 177621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 177626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177629 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177633 */   GIR_RootConstrainSelectedInstOperands,
     /* 177634 */   // GIR_Coverage, 8075,
     /* 177634 */   GIR_EraseRootFromParent_Done,
     /* 177635 */ // Label 2768: @177635
     /* 177635 */ GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(177693), // Rule ID 8060 //
     /* 177640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 177643 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 177646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 177653 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 177669 */   // (AMDGPUatomic_st_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64_glue>><<P:Predicate_atomic_store_64_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 177669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 177672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177677 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 177679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 177684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177687 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177691 */   GIR_RootConstrainSelectedInstOperands,
     /* 177692 */   // GIR_Coverage, 8060,
     /* 177692 */   GIR_EraseRootFromParent_Done,
     /* 177693 */ // Label 2769: @177693
     /* 177693 */ GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(177751), // Rule ID 8061 //
     /* 177698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 177701 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 177704 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 177711 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 177716 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177720 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 177727 */   // (atomic_store i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 177727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 177730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 177735 */   GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 177737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 177742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177749 */   GIR_RootConstrainSelectedInstOperands,
     /* 177750 */   // GIR_Coverage, 8061,
     /* 177750 */   GIR_EraseRootFromParent_Done,
     /* 177751 */ // Label 2770: @177751
     /* 177751 */ GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(177814), // Rule ID 4016 //
     /* 177756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 177759 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 177762 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 177769 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 177785 */   // (atomic_store i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 177785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 177788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 177793 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 177800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177812 */   GIR_RootConstrainSelectedInstOperands,
     /* 177813 */   // GIR_Coverage, 4016,
     /* 177813 */   GIR_EraseRootFromParent_Done,
     /* 177814 */ // Label 2771: @177814
     /* 177814 */ GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(177870), // Rule ID 3902 //
     /* 177819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 177822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177825 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 177841 */   // (st i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 177841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 177844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 177849 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 177856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177868 */   GIR_RootConstrainSelectedInstOperands,
     /* 177869 */   // GIR_Coverage, 3902,
     /* 177869 */   GIR_EraseRootFromParent_Done,
     /* 177870 */ // Label 2772: @177870
     /* 177870 */ GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(177926), // Rule ID 3906 //
     /* 177875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 177878 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177881 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 177897 */   // (st f64:{ *:[f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 177897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 177900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 177905 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 177912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 177917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177924 */   GIR_RootConstrainSelectedInstOperands,
     /* 177925 */   // GIR_Coverage, 3906,
     /* 177925 */   GIR_EraseRootFromParent_Done,
     /* 177926 */ // Label 2773: @177926
     /* 177926 */ GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(177984), // Rule ID 4015 //
     /* 177931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 177934 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 177937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 177944 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 177949 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 177953 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 177960 */   // (atomic_store i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 177960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 177963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 177968 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 177970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 177975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 177982 */   GIR_RootConstrainSelectedInstOperands,
     /* 177983 */   // GIR_Coverage, 4015,
     /* 177983 */   GIR_EraseRootFromParent_Done,
     /* 177984 */ // Label 2774: @177984
     /* 177984 */ GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(178035), // Rule ID 3901 //
     /* 177989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 177992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177995 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 178011 */   // (st i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 178011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 178014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178019 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178029 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178033 */   GIR_RootConstrainSelectedInstOperands,
     /* 178034 */   // GIR_Coverage, 3901,
     /* 178034 */   GIR_EraseRootFromParent_Done,
     /* 178035 */ // Label 2775: @178035
     /* 178035 */ GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(178086), // Rule ID 3905 //
     /* 178040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 178043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178046 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178051 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178055 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 178062 */   // (st f64:{ *:[f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 178062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 178065 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178070 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178084 */   GIR_RootConstrainSelectedInstOperands,
     /* 178085 */   // GIR_Coverage, 3905,
     /* 178085 */   GIR_EraseRootFromParent_Done,
     /* 178086 */ // Label 2776: @178086
     /* 178086 */ GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(178145), // Rule ID 3668 //
     /* 178091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 178094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 178097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 178104 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 178110 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178114 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 178121 */   // (atomic_store i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 178121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 178124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178129 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178139 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178143 */   GIR_RootConstrainSelectedInstOperands,
     /* 178144 */   // GIR_Coverage, 3668,
     /* 178144 */   GIR_EraseRootFromParent_Done,
     /* 178145 */ // Label 2777: @178145
     /* 178145 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(178197), // Rule ID 3636 //
     /* 178150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 178153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178156 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 178162 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178166 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 178173 */   // (st i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 178173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 178176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178181 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178195 */   GIR_RootConstrainSelectedInstOperands,
     /* 178196 */   // GIR_Coverage, 3636,
     /* 178196 */   GIR_EraseRootFromParent_Done,
     /* 178197 */ // Label 2778: @178197
     /* 178197 */ GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(178249), // Rule ID 3638 //
     /* 178202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 178205 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178208 */   GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 178214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178218 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 178225 */   // (st f64:{ *:[f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 178225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 178228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178233 */   GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178243 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178247 */   GIR_RootConstrainSelectedInstOperands,
     /* 178248 */   // GIR_Coverage, 3638,
     /* 178248 */   GIR_EraseRootFromParent_Done,
     /* 178249 */ // Label 2779: @178249
     /* 178249 */ GIM_Reject,
     /* 178250 */ // Label 2439: @178250
     /* 178250 */ GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(179981),
     /* 178255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178258 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(178314), // Rule ID 6621 //
     /* 178263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 178266 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 178282 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 178282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 178285 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 178297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178312 */     GIR_RootConstrainSelectedInstOperands,
     /* 178313 */     // GIR_Coverage, 6621,
     /* 178313 */     GIR_EraseRootFromParent_Done,
     /* 178314 */   // Label 2781: @178314
     /* 178314 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(178370), // Rule ID 6623 //
     /* 178319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 178322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 178338 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 178338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 178341 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 178353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178368 */     GIR_RootConstrainSelectedInstOperands,
     /* 178369 */     // GIR_Coverage, 6623,
     /* 178369 */     GIR_EraseRootFromParent_Done,
     /* 178370 */   // Label 2782: @178370
     /* 178370 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(178426), // Rule ID 6625 //
     /* 178375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 178378 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 178394 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 178394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 178397 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 178409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178424 */     GIR_RootConstrainSelectedInstOperands,
     /* 178425 */     // GIR_Coverage, 6625,
     /* 178425 */     GIR_EraseRootFromParent_Done,
     /* 178426 */   // Label 2783: @178426
     /* 178426 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(178482), // Rule ID 6627 //
     /* 178431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 178434 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 178450 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 178450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 178453 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 178455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 178465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178480 */     GIR_RootConstrainSelectedInstOperands,
     /* 178481 */     // GIR_Coverage, 6627,
     /* 178481 */     GIR_EraseRootFromParent_Done,
     /* 178482 */   // Label 2784: @178482
     /* 178482 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(178535), // Rule ID 4268 //
     /* 178487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 178490 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 178506 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 178509 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 178521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178533 */     GIR_RootConstrainSelectedInstOperands,
     /* 178534 */     // GIR_Coverage, 4268,
     /* 178534 */     GIR_EraseRootFromParent_Done,
     /* 178535 */   // Label 2785: @178535
     /* 178535 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(178588), // Rule ID 4274 //
     /* 178540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 178543 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 178559 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
     /* 178562 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 178574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 178579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178586 */     GIR_RootConstrainSelectedInstOperands,
     /* 178587 */     // GIR_Coverage, 4274,
     /* 178587 */     GIR_EraseRootFromParent_Done,
     /* 178588 */   // Label 2786: @178588
     /* 178588 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(178636), // Rule ID 4267 //
     /* 178593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178596 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 178612 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 178615 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 178622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178634 */     GIR_RootConstrainSelectedInstOperands,
     /* 178635 */     // GIR_Coverage, 4267,
     /* 178635 */     GIR_EraseRootFromParent_Done,
     /* 178636 */   // Label 2787: @178636
     /* 178636 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(178684), // Rule ID 4273 //
     /* 178641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178644 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 178660 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 178660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
     /* 178663 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 178670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178682 */     GIR_RootConstrainSelectedInstOperands,
     /* 178683 */     // GIR_Coverage, 4273,
     /* 178683 */     GIR_EraseRootFromParent_Done,
     /* 178684 */   // Label 2788: @178684
     /* 178684 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(178732), // Rule ID 4266 //
     /* 178689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178692 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 178708 */     // (st v2i16:{ *:[v2i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 178708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 178711 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178730 */     GIR_RootConstrainSelectedInstOperands,
     /* 178731 */     // GIR_Coverage, 4266,
     /* 178731 */     GIR_EraseRootFromParent_Done,
     /* 178732 */   // Label 2789: @178732
     /* 178732 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(178780), // Rule ID 4272 //
     /* 178737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 178740 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 178745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 178756 */     // (st v2f16:{ *:[v2f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 178756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
     /* 178759 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 178761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 178766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 178771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178778 */     GIR_RootConstrainSelectedInstOperands,
     /* 178779 */     // GIR_Coverage, 4272,
     /* 178779 */     GIR_EraseRootFromParent_Done,
     /* 178780 */   // Label 2790: @178780
     /* 178780 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(178841), // Rule ID 4621 //
     /* 178785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 178788 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 178804 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 178804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 178807 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 178809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 178814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 178824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 178829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178839 */     GIR_RootConstrainSelectedInstOperands,
     /* 178840 */     // GIR_Coverage, 4621,
     /* 178840 */     GIR_EraseRootFromParent_Done,
     /* 178841 */   // Label 2791: @178841
     /* 178841 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(178899), // Rule ID 4623 //
     /* 178846 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 178862 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 178862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 178865 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 178867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 178872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 178882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 178887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178897 */     GIR_RootConstrainSelectedInstOperands,
     /* 178898 */     // GIR_Coverage, 4623,
     /* 178898 */     GIR_EraseRootFromParent_Done,
     /* 178899 */   // Label 2792: @178899
     /* 178899 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(178960), // Rule ID 4625 //
     /* 178904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 178907 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 178923 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 178923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
     /* 178926 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 178928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 178933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 178943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 178948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 178954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 178958 */     GIR_RootConstrainSelectedInstOperands,
     /* 178959 */     // GIR_Coverage, 4625,
     /* 178959 */     GIR_EraseRootFromParent_Done,
     /* 178960 */   // Label 2793: @178960
     /* 178960 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(179018), // Rule ID 4627 //
     /* 178965 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 178970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 178974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 178981 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 178981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
     /* 178984 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 178986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 178991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 178996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179016 */     GIR_RootConstrainSelectedInstOperands,
     /* 179017 */     // GIR_Coverage, 4627,
     /* 179017 */     GIR_EraseRootFromParent_Done,
     /* 179018 */   // Label 2794: @179018
     /* 179018 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(179079), // Rule ID 6620 //
     /* 179023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 179026 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 179042 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 179042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 179045 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179077 */     GIR_RootConstrainSelectedInstOperands,
     /* 179078 */     // GIR_Coverage, 6620,
     /* 179078 */     GIR_EraseRootFromParent_Done,
     /* 179079 */   // Label 2795: @179079
     /* 179079 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(179140), // Rule ID 6622 //
     /* 179084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 179087 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 179103 */     // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 179103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 179106 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179138 */     GIR_RootConstrainSelectedInstOperands,
     /* 179139 */     // GIR_Coverage, 6622,
     /* 179139 */     GIR_EraseRootFromParent_Done,
     /* 179140 */   // Label 2796: @179140
     /* 179140 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(179201), // Rule ID 6624 //
     /* 179145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 179148 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 179164 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 179164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
     /* 179167 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179199 */     GIR_RootConstrainSelectedInstOperands,
     /* 179200 */     // GIR_Coverage, 6624,
     /* 179200 */     GIR_EraseRootFromParent_Done,
     /* 179201 */   // Label 2797: @179201
     /* 179201 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(179262), // Rule ID 6626 //
     /* 179206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 179209 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 179214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 179225 */     // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 179225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
     /* 179228 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 179235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 179245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 179250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179260 */     GIR_RootConstrainSelectedInstOperands,
     /* 179261 */     // GIR_Coverage, 6626,
     /* 179261 */     GIR_EraseRootFromParent_Done,
     /* 179262 */   // Label 2798: @179262
     /* 179262 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(179318), // Rule ID 4620 //
     /* 179267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179270 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179286 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 179289 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179316 */     GIR_RootConstrainSelectedInstOperands,
     /* 179317 */     // GIR_Coverage, 4620,
     /* 179317 */     GIR_EraseRootFromParent_Done,
     /* 179318 */   // Label 2799: @179318
     /* 179318 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(179371), // Rule ID 4622 //
     /* 179323 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179339 */     // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 179342 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179369 */     GIR_RootConstrainSelectedInstOperands,
     /* 179370 */     // GIR_Coverage, 4622,
     /* 179370 */     GIR_EraseRootFromParent_Done,
     /* 179371 */   // Label 2800: @179371
     /* 179371 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(179427), // Rule ID 4624 //
     /* 179376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 179379 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179395 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
     /* 179398 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179425 */     GIR_RootConstrainSelectedInstOperands,
     /* 179426 */     // GIR_Coverage, 4624,
     /* 179426 */     GIR_EraseRootFromParent_Done,
     /* 179427 */   // Label 2801: @179427
     /* 179427 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(179480), // Rule ID 4626 //
     /* 179432 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 179448 */     // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 179448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
     /* 179451 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 179453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 179458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 179463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179478 */     GIR_RootConstrainSelectedInstOperands,
     /* 179479 */     // GIR_Coverage, 4626,
     /* 179479 */     GIR_EraseRootFromParent_Done,
     /* 179480 */   // Label 2802: @179480
     /* 179480 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(179532), // Rule ID 8034 //
     /* 179485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 179488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 179492 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 179508 */     // (AMDGPUst_glue v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 179508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 179511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179516 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179530 */     GIR_RootConstrainSelectedInstOperands,
     /* 179531 */     // GIR_Coverage, 8034,
     /* 179531 */     GIR_EraseRootFromParent_Done,
     /* 179532 */   // Label 2803: @179532
     /* 179532 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(179584), // Rule ID 8036 //
     /* 179537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 179540 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 179544 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 179560 */     // (AMDGPUst_glue v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 179560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
     /* 179563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179568 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179582 */     GIR_RootConstrainSelectedInstOperands,
     /* 179583 */     // GIR_Coverage, 8036,
     /* 179583 */     GIR_EraseRootFromParent_Done,
     /* 179584 */   // Label 2804: @179584
     /* 179584 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(179632), // Rule ID 8035 //
     /* 179589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 179592 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 179608 */     // (st v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 179608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 179611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179616 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179630 */     GIR_RootConstrainSelectedInstOperands,
     /* 179631 */     // GIR_Coverage, 8035,
     /* 179631 */     GIR_EraseRootFromParent_Done,
     /* 179632 */   // Label 2805: @179632
     /* 179632 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(179680), // Rule ID 8037 //
     /* 179637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 179640 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 179645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 179656 */     // (st v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 179656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
     /* 179659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 179664 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 179666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179678 */     GIR_RootConstrainSelectedInstOperands,
     /* 179679 */     // GIR_Coverage, 8037,
     /* 179679 */     GIR_EraseRootFromParent_Done,
     /* 179680 */   // Label 2806: @179680
     /* 179680 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(179733), // Rule ID 3878 //
     /* 179685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 179688 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 179704 */     // (st v2i16:{ *:[v2i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[v2i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 179704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 179707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 179712 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 179719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179731 */     GIR_RootConstrainSelectedInstOperands,
     /* 179732 */     // GIR_Coverage, 3878,
     /* 179732 */     GIR_EraseRootFromParent_Done,
     /* 179733 */   // Label 2807: @179733
     /* 179733 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(179786), // Rule ID 3882 //
     /* 179738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 179741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 179757 */     // (st v2f16:{ *:[v2f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 179757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
     /* 179760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 179765 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 179772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 179777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179784 */     GIR_RootConstrainSelectedInstOperands,
     /* 179785 */     // GIR_Coverage, 3882,
     /* 179785 */     GIR_EraseRootFromParent_Done,
     /* 179786 */   // Label 2808: @179786
     /* 179786 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(179834), // Rule ID 3877 //
     /* 179791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 179794 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 179810 */     // (st v2i16:{ *:[v2i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 179810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 179813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 179818 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179832 */     GIR_RootConstrainSelectedInstOperands,
     /* 179833 */     // GIR_Coverage, 3877,
     /* 179833 */     GIR_EraseRootFromParent_Done,
     /* 179834 */   // Label 2809: @179834
     /* 179834 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(179882), // Rule ID 3881 //
     /* 179839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 179842 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 179847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 179858 */     // (st v2f16:{ *:[v2f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 179858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
     /* 179861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 179866 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179880 */     GIR_RootConstrainSelectedInstOperands,
     /* 179881 */     // GIR_Coverage, 3881,
     /* 179881 */     GIR_EraseRootFromParent_Done,
     /* 179882 */   // Label 2810: @179882
     /* 179882 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(179931), // Rule ID 3625 //
     /* 179887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 179890 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 179896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 179907 */     // (st v2i16:{ *:[v2i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 179907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 179910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 179915 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179929 */     GIR_RootConstrainSelectedInstOperands,
     /* 179930 */     // GIR_Coverage, 3625,
     /* 179930 */     GIR_EraseRootFromParent_Done,
     /* 179931 */   // Label 2811: @179931
     /* 179931 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(179980), // Rule ID 3627 //
     /* 179936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 179939 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 179945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 179949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 179956 */     // (st v2f16:{ *:[v2f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 179956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
     /* 179959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 179964 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 179966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 179971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 179974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 179978 */     GIR_RootConstrainSelectedInstOperands,
     /* 179979 */     // GIR_Coverage, 3627,
     /* 179979 */     GIR_EraseRootFromParent_Done,
     /* 179980 */   // Label 2812: @179980
     /* 179980 */   GIM_Reject,
     /* 179981 */ // Label 2780: @179981
     /* 179981 */ GIM_Reject,
     /* 179982 */ // Label 2440: @179982
     /* 179982 */ GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(182191),
     /* 179987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179990 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(180051), // Rule ID 8202 //
     /* 179995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 179998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180002 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 180020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180027 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 180030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180035 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180049 */     GIR_RootConstrainSelectedInstOperands,
     /* 180050 */     // GIR_Coverage, 8202,
     /* 180050 */     GIR_EraseRootFromParent_Done,
     /* 180051 */   // Label 2814: @180051
     /* 180051 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(180112), // Rule ID 8206 //
     /* 180056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 180059 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180063 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180068 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 180081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180088 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 180091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180096 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180110 */     GIR_RootConstrainSelectedInstOperands,
     /* 180111 */     // GIR_Coverage, 8206,
     /* 180111 */     GIR_EraseRootFromParent_Done,
     /* 180112 */   // Label 2815: @180112
     /* 180112 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(180168), // Rule ID 8134 //
     /* 180117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 180120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180124 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180129 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 180133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180144 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 180147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180152 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180166 */     GIR_RootConstrainSelectedInstOperands,
     /* 180167 */     // GIR_Coverage, 8134,
     /* 180167 */     GIR_EraseRootFromParent_Done,
     /* 180168 */   // Label 2816: @180168
     /* 180168 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(180224), // Rule ID 8138 //
     /* 180173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 180176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 180180 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180185 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 180189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180200 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 180203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180208 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180222 */     GIR_RootConstrainSelectedInstOperands,
     /* 180223 */     // GIR_Coverage, 8138,
     /* 180223 */     GIR_EraseRootFromParent_Done,
     /* 180224 */   // Label 2817: @180224
     /* 180224 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(180281), // Rule ID 8203 //
     /* 180229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 180232 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 180250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180257 */     // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 180260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180265 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180279 */     GIR_RootConstrainSelectedInstOperands,
     /* 180280 */     // GIR_Coverage, 8203,
     /* 180280 */     GIR_EraseRootFromParent_Done,
     /* 180281 */   // Label 2818: @180281
     /* 180281 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(180338), // Rule ID 8207 //
     /* 180286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 180289 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180294 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 180307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180314 */     // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 180317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180322 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180336 */     GIR_RootConstrainSelectedInstOperands,
     /* 180337 */     // GIR_Coverage, 8207,
     /* 180337 */     GIR_EraseRootFromParent_Done,
     /* 180338 */   // Label 2819: @180338
     /* 180338 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(180390), // Rule ID 8135 //
     /* 180343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 180346 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180351 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 180355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180366 */     // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 180369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180374 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180388 */     GIR_RootConstrainSelectedInstOperands,
     /* 180389 */     // GIR_Coverage, 8135,
     /* 180389 */     GIR_EraseRootFromParent_Done,
     /* 180390 */   // Label 2820: @180390
     /* 180390 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(180442), // Rule ID 8139 //
     /* 180395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 180398 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 180403 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 180407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 180418 */     // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 180418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 180421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 180426 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180440 */     GIR_RootConstrainSelectedInstOperands,
     /* 180441 */     // GIR_Coverage, 8139,
     /* 180441 */     GIR_EraseRootFromParent_Done,
     /* 180442 */   // Label 2821: @180442
     /* 180442 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(180498), // Rule ID 6645 //
     /* 180447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 180450 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 180466 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 180466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 180469 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 180481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180496 */     GIR_RootConstrainSelectedInstOperands,
     /* 180497 */     // GIR_Coverage, 6645,
     /* 180497 */     GIR_EraseRootFromParent_Done,
     /* 180498 */   // Label 2822: @180498
     /* 180498 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(180554), // Rule ID 6647 //
     /* 180503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 180506 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 180522 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 180522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 180525 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 180527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 180537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180552 */     GIR_RootConstrainSelectedInstOperands,
     /* 180553 */     // GIR_Coverage, 6647,
     /* 180553 */     GIR_EraseRootFromParent_Done,
     /* 180554 */   // Label 2823: @180554
     /* 180554 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(180607), // Rule ID 4316 //
     /* 180559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 180562 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 180578 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 180581 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 180593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180605 */     GIR_RootConstrainSelectedInstOperands,
     /* 180606 */     // GIR_Coverage, 4316,
     /* 180606 */     GIR_EraseRootFromParent_Done,
     /* 180607 */   // Label 2824: @180607
     /* 180607 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(180660), // Rule ID 4322 //
     /* 180612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 180615 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 180631 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 180634 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 180646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 180651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180658 */     GIR_RootConstrainSelectedInstOperands,
     /* 180659 */     // GIR_Coverage, 4322,
     /* 180659 */     GIR_EraseRootFromParent_Done,
     /* 180660 */   // Label 2825: @180660
     /* 180660 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(180708), // Rule ID 4315 //
     /* 180665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 180668 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 180684 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 180687 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 180694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180706 */     GIR_RootConstrainSelectedInstOperands,
     /* 180707 */     // GIR_Coverage, 4315,
     /* 180707 */     GIR_EraseRootFromParent_Done,
     /* 180708 */   // Label 2826: @180708
     /* 180708 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(180756), // Rule ID 4321 //
     /* 180713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 180716 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 180732 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 180732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 180735 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 180742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180754 */     GIR_RootConstrainSelectedInstOperands,
     /* 180755 */     // GIR_Coverage, 4321,
     /* 180755 */     GIR_EraseRootFromParent_Done,
     /* 180756 */   // Label 2827: @180756
     /* 180756 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(180804), // Rule ID 4314 //
     /* 180761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 180764 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 180780 */     // (st v2i32:{ *:[v2i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 180780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 180783 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180802 */     GIR_RootConstrainSelectedInstOperands,
     /* 180803 */     // GIR_Coverage, 4314,
     /* 180803 */     GIR_EraseRootFromParent_Done,
     /* 180804 */   // Label 2828: @180804
     /* 180804 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(180852), // Rule ID 4320 //
     /* 180809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 180812 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 180817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 180828 */     // (st v2f32:{ *:[v2f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 180828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 180831 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 180833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 180838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 180843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180850 */     GIR_RootConstrainSelectedInstOperands,
     /* 180851 */     // GIR_Coverage, 4320,
     /* 180851 */     GIR_EraseRootFromParent_Done,
     /* 180852 */   // Label 2829: @180852
     /* 180852 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(180913), // Rule ID 4653 //
     /* 180857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 180860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 180876 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 180876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 180879 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 180881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 180886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 180896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 180901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180911 */     GIR_RootConstrainSelectedInstOperands,
     /* 180912 */     // GIR_Coverage, 4653,
     /* 180912 */     GIR_EraseRootFromParent_Done,
     /* 180913 */   // Label 2830: @180913
     /* 180913 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(180971), // Rule ID 4655 //
     /* 180918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 180934 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 180934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 180937 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 180939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 180944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 180949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 180954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 180959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 180969 */     GIR_RootConstrainSelectedInstOperands,
     /* 180970 */     // GIR_Coverage, 4655,
     /* 180970 */     GIR_EraseRootFromParent_Done,
     /* 180971 */   // Label 2831: @180971
     /* 180971 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(181032), // Rule ID 4657 //
     /* 180976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 180979 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 180984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 180988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 180995 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 180995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 180998 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181030 */     GIR_RootConstrainSelectedInstOperands,
     /* 181031 */     // GIR_Coverage, 4657,
     /* 181031 */     GIR_EraseRootFromParent_Done,
     /* 181032 */   // Label 2832: @181032
     /* 181032 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(181090), // Rule ID 4659 //
     /* 181037 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181042 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 181053 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 181056 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181088 */     GIR_RootConstrainSelectedInstOperands,
     /* 181089 */     // GIR_Coverage, 4659,
     /* 181089 */     GIR_EraseRootFromParent_Done,
     /* 181090 */   // Label 2833: @181090
     /* 181090 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(181151), // Rule ID 6644 //
     /* 181095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 181098 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 181114 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 181114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN),
     /* 181117 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181149 */     GIR_RootConstrainSelectedInstOperands,
     /* 181150 */     // GIR_Coverage, 6644,
     /* 181150 */     GIR_EraseRootFromParent_Done,
     /* 181151 */   // Label 2834: @181151
     /* 181151 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(181212), // Rule ID 6646 //
     /* 181156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 181159 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 181164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 181175 */     // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 181175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN),
     /* 181178 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 181180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 181185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 181195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 181200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181210 */     GIR_RootConstrainSelectedInstOperands,
     /* 181211 */     // GIR_Coverage, 6646,
     /* 181211 */     GIR_EraseRootFromParent_Done,
     /* 181212 */   // Label 2835: @181212
     /* 181212 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(181329), // Rule ID 8077 //
     /* 181217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 181220 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181224 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 181240 */     // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 181240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 181243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181252 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 181258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181280 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 181286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 181299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 181315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 181320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181327 */     GIR_RootConstrainSelectedInstOperands,
     /* 181328 */     // GIR_Coverage, 8077,
     /* 181328 */     GIR_EraseRootFromParent_Done,
     /* 181329 */   // Label 2836: @181329
     /* 181329 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(181446), // Rule ID 8081 //
     /* 181334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 181337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 181341 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 181357 */     // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 181357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 181360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181369 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 181375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181397 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 181403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 181416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 181432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 181437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181444 */     GIR_RootConstrainSelectedInstOperands,
     /* 181445 */     // GIR_Coverage, 8081,
     /* 181445 */     GIR_EraseRootFromParent_Done,
     /* 181446 */   // Label 2837: @181446
     /* 181446 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(181502), // Rule ID 4652 //
     /* 181451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181454 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181470 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 181473 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181500 */     GIR_RootConstrainSelectedInstOperands,
     /* 181501 */     // GIR_Coverage, 4652,
     /* 181501 */     GIR_EraseRootFromParent_Done,
     /* 181502 */   // Label 2838: @181502
     /* 181502 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(181555), // Rule ID 4654 //
     /* 181507 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181523 */     // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 181526 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181553 */     GIR_RootConstrainSelectedInstOperands,
     /* 181554 */     // GIR_Coverage, 4654,
     /* 181554 */     GIR_EraseRootFromParent_Done,
     /* 181555 */   // Label 2839: @181555
     /* 181555 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(181611), // Rule ID 4656 //
     /* 181560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 181563 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181579 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 181582 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181609 */     GIR_RootConstrainSelectedInstOperands,
     /* 181610 */     // GIR_Coverage, 4656,
     /* 181610 */     GIR_EraseRootFromParent_Done,
     /* 181611 */   // Label 2840: @181611
     /* 181611 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(181664), // Rule ID 4658 //
     /* 181616 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 181632 */     // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 181632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 181635 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 181637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 181642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 181647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181662 */     GIR_RootConstrainSelectedInstOperands,
     /* 181663 */     // GIR_Coverage, 4658,
     /* 181663 */     GIR_EraseRootFromParent_Done,
     /* 181664 */   // Label 2841: @181664
     /* 181664 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(181777), // Rule ID 8079 //
     /* 181669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 181672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 181688 */     // (st v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 181688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 181691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181700 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 181706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 181734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 181747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 181763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 181768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181775 */     GIR_RootConstrainSelectedInstOperands,
     /* 181776 */     // GIR_Coverage, 8079,
     /* 181776 */     GIR_EraseRootFromParent_Done,
     /* 181777 */   // Label 2842: @181777
     /* 181777 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(181890), // Rule ID 8083 //
     /* 181782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 181785 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 181790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 181801 */     // (st v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 181801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 181804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181813 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 181819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 181836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181841 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 181847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 181852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 181857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 181860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 181865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 181876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 181881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181888 */     GIR_RootConstrainSelectedInstOperands,
     /* 181889 */     // GIR_Coverage, 8083,
     /* 181889 */     GIR_EraseRootFromParent_Done,
     /* 181890 */   // Label 2843: @181890
     /* 181890 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(181943), // Rule ID 3910 //
     /* 181895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 181898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 181914 */     // (st v2i32:{ *:[v2i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 181914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 181917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 181922 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 181929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181941 */     GIR_RootConstrainSelectedInstOperands,
     /* 181942 */     // GIR_Coverage, 3910,
     /* 181942 */     GIR_EraseRootFromParent_Done,
     /* 181943 */   // Label 2844: @181943
     /* 181943 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(181996), // Rule ID 3914 //
     /* 181948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 181951 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 181956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 181960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 181967 */     // (st v2f32:{ *:[v2f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[v2f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 181967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 181970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 181975 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 181977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 181982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 181987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 181994 */     GIR_RootConstrainSelectedInstOperands,
     /* 181995 */     // GIR_Coverage, 3914,
     /* 181995 */     GIR_EraseRootFromParent_Done,
     /* 181996 */   // Label 2845: @181996
     /* 181996 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(182044), // Rule ID 3909 //
     /* 182001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 182004 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 182020 */     // (st v2i32:{ *:[v2i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 182020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 182023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182028 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182042 */     GIR_RootConstrainSelectedInstOperands,
     /* 182043 */     // GIR_Coverage, 3909,
     /* 182043 */     GIR_EraseRootFromParent_Done,
     /* 182044 */   // Label 2846: @182044
     /* 182044 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(182092), // Rule ID 3913 //
     /* 182049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 182052 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 182068 */     // (st v2f32:{ *:[v2f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 182068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 182071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182076 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182090 */     GIR_RootConstrainSelectedInstOperands,
     /* 182091 */     // GIR_Coverage, 3913,
     /* 182091 */     GIR_EraseRootFromParent_Done,
     /* 182092 */   // Label 2847: @182092
     /* 182092 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(182141), // Rule ID 3640 //
     /* 182097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 182100 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 182106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 182117 */     // (st v2i32:{ *:[v2i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 182117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 182120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182125 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182139 */     GIR_RootConstrainSelectedInstOperands,
     /* 182140 */     // GIR_Coverage, 3640,
     /* 182140 */     GIR_EraseRootFromParent_Done,
     /* 182141 */   // Label 2848: @182141
     /* 182141 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(182190), // Rule ID 3642 //
     /* 182146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 182149 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 182155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 182166 */     // (st v2f32:{ *:[v2f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 182166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 182169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182174 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182188 */     GIR_RootConstrainSelectedInstOperands,
     /* 182189 */     // GIR_Coverage, 3642,
     /* 182189 */     GIR_EraseRootFromParent_Done,
     /* 182190 */   // Label 2849: @182190
     /* 182190 */   GIM_Reject,
     /* 182191 */ // Label 2813: @182191
     /* 182191 */ GIM_Reject,
     /* 182192 */ // Label 2441: @182192
     /* 182192 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(184167),
     /* 182197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182200 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(182256), // Rule ID 8178 //
     /* 182205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 182208 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182212 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182217 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 182221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182232 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 182235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182240 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182254 */     GIR_RootConstrainSelectedInstOperands,
     /* 182255 */     // GIR_Coverage, 8178,
     /* 182255 */     GIR_EraseRootFromParent_Done,
     /* 182256 */   // Label 2851: @182256
     /* 182256 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(182312), // Rule ID 8182 //
     /* 182261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 182264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182268 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182273 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 182277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182288 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 182291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182296 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182310 */     GIR_RootConstrainSelectedInstOperands,
     /* 182311 */     // GIR_Coverage, 8182,
     /* 182311 */     GIR_EraseRootFromParent_Done,
     /* 182312 */   // Label 2852: @182312
     /* 182312 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(182373), // Rule ID 8246 //
     /* 182317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 182320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182324 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182329 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 182342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182349 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 182352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182357 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182371 */     GIR_RootConstrainSelectedInstOperands,
     /* 182372 */     // GIR_Coverage, 8246,
     /* 182372 */     GIR_EraseRootFromParent_Done,
     /* 182373 */   // Label 2853: @182373
     /* 182373 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(182434), // Rule ID 8250 //
     /* 182378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 182381 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 182385 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182390 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 182403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182410 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 182413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182418 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182432 */     GIR_RootConstrainSelectedInstOperands,
     /* 182433 */     // GIR_Coverage, 8250,
     /* 182433 */     GIR_EraseRootFromParent_Done,
     /* 182434 */   // Label 2854: @182434
     /* 182434 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(182486), // Rule ID 8179 //
     /* 182439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 182442 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182447 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 182451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182462 */     // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 182465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182470 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182484 */     GIR_RootConstrainSelectedInstOperands,
     /* 182485 */     // GIR_Coverage, 8179,
     /* 182485 */     GIR_EraseRootFromParent_Done,
     /* 182486 */   // Label 2855: @182486
     /* 182486 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(182538), // Rule ID 8183 //
     /* 182491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 182494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182499 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 182503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182514 */     // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 182517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182522 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182536 */     GIR_RootConstrainSelectedInstOperands,
     /* 182537 */     // GIR_Coverage, 8183,
     /* 182537 */     GIR_EraseRootFromParent_Done,
     /* 182538 */   // Label 2856: @182538
     /* 182538 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(182595), // Rule ID 8247 //
     /* 182543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 182546 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182551 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 182564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182571 */     // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 182574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182579 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182593 */     GIR_RootConstrainSelectedInstOperands,
     /* 182594 */     // GIR_Coverage, 8247,
     /* 182594 */     GIR_EraseRootFromParent_Done,
     /* 182595 */   // Label 2857: @182595
     /* 182595 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(182652), // Rule ID 8251 //
     /* 182600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 182603 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182608 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 182613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 182621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 182628 */     // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 182628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 182631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 182636 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 182638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182650 */     GIR_RootConstrainSelectedInstOperands,
     /* 182651 */     // GIR_Coverage, 8251,
     /* 182651 */     GIR_EraseRootFromParent_Done,
     /* 182652 */   // Label 2858: @182652
     /* 182652 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(182705), // Rule ID 4373 //
     /* 182657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 182660 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 182676 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 182679 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 182691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182703 */     GIR_RootConstrainSelectedInstOperands,
     /* 182704 */     // GIR_Coverage, 4373,
     /* 182704 */     GIR_EraseRootFromParent_Done,
     /* 182705 */   // Label 2859: @182705
     /* 182705 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(182758), // Rule ID 4379 //
     /* 182710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 182713 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 182729 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9741:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 182732 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 182744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 182749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182756 */     GIR_RootConstrainSelectedInstOperands,
     /* 182757 */     // GIR_Coverage, 4379,
     /* 182757 */     GIR_EraseRootFromParent_Done,
     /* 182758 */   // Label 2860: @182758
     /* 182758 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(182806), // Rule ID 4372 //
     /* 182763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182766 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 182782 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 182785 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 182792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182804 */     GIR_RootConstrainSelectedInstOperands,
     /* 182805 */     // GIR_Coverage, 4372,
     /* 182805 */     GIR_EraseRootFromParent_Done,
     /* 182806 */   // Label 2861: @182806
     /* 182806 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(182854), // Rule ID 4378 //
     /* 182811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182814 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 182830 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9741:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 182830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 182833 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 182840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182852 */     GIR_RootConstrainSelectedInstOperands,
     /* 182853 */     // GIR_Coverage, 4378,
     /* 182853 */     GIR_EraseRootFromParent_Done,
     /* 182854 */   // Label 2862: @182854
     /* 182854 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(182902), // Rule ID 4371 //
     /* 182859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 182878 */     // (st v2i64:{ *:[v2i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 182878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 182881 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182900 */     GIR_RootConstrainSelectedInstOperands,
     /* 182901 */     // GIR_Coverage, 4371,
     /* 182901 */     GIR_EraseRootFromParent_Done,
     /* 182902 */   // Label 2863: @182902
     /* 182902 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(182950), // Rule ID 4377 //
     /* 182907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 182910 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 182915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 182926 */     // (st v2f64:{ *:[v2f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9741:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 182926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 182929 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 182931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 182936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 182941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 182944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 182948 */     GIR_RootConstrainSelectedInstOperands,
     /* 182949 */     // GIR_Coverage, 4377,
     /* 182949 */     GIR_EraseRootFromParent_Done,
     /* 182950 */   // Label 2864: @182950
     /* 182950 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(183011), // Rule ID 4697 //
     /* 182955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 182958 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 182963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 182967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 182974 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 182974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 182977 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 182979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 182984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 182989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 182994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 182999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183009 */     GIR_RootConstrainSelectedInstOperands,
     /* 183010 */     // GIR_Coverage, 4697,
     /* 183010 */     GIR_EraseRootFromParent_Done,
     /* 183011 */   // Label 2865: @183011
     /* 183011 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(183069), // Rule ID 4699 //
     /* 183016 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 183032 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 183035 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 183042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 183052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 183057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183067 */     GIR_RootConstrainSelectedInstOperands,
     /* 183068 */     // GIR_Coverage, 4699,
     /* 183068 */     GIR_EraseRootFromParent_Done,
     /* 183069 */   // Label 2866: @183069
     /* 183069 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(183130), // Rule ID 4701 //
     /* 183074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 183077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 183093 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 183096 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 183103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 183113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 183118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183128 */     GIR_RootConstrainSelectedInstOperands,
     /* 183129 */     // GIR_Coverage, 4701,
     /* 183129 */     GIR_EraseRootFromParent_Done,
     /* 183130 */   // Label 2867: @183130
     /* 183130 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(183188), // Rule ID 4703 //
     /* 183135 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 183151 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 183154 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 183161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 183171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 183176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183186 */     GIR_RootConstrainSelectedInstOperands,
     /* 183187 */     // GIR_Coverage, 4703,
     /* 183187 */     GIR_EraseRootFromParent_Done,
     /* 183188 */   // Label 2868: @183188
     /* 183188 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(183305), // Rule ID 8109 //
     /* 183193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 183196 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183200 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 183216 */     // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 183219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183228 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 183234 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183239 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183256 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 183262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 183275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183303 */     GIR_RootConstrainSelectedInstOperands,
     /* 183304 */     // GIR_Coverage, 8109,
     /* 183304 */     GIR_EraseRootFromParent_Done,
     /* 183305 */   // Label 2869: @183305
     /* 183305 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(183422), // Rule ID 8113 //
     /* 183310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 183313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 183317 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 183333 */     // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 183336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183345 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 183351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 183379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 183392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183420 */     GIR_RootConstrainSelectedInstOperands,
     /* 183421 */     // GIR_Coverage, 8113,
     /* 183421 */     GIR_EraseRootFromParent_Done,
     /* 183422 */   // Label 2870: @183422
     /* 183422 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(183478), // Rule ID 4696 //
     /* 183427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 183430 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183446 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 183449 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183476 */     GIR_RootConstrainSelectedInstOperands,
     /* 183477 */     // GIR_Coverage, 4696,
     /* 183477 */     GIR_EraseRootFromParent_Done,
     /* 183478 */   // Label 2871: @183478
     /* 183478 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(183531), // Rule ID 4698 //
     /* 183483 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183499 */     // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 183502 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183529 */     GIR_RootConstrainSelectedInstOperands,
     /* 183530 */     // GIR_Coverage, 4698,
     /* 183530 */     GIR_EraseRootFromParent_Done,
     /* 183531 */   // Label 2872: @183531
     /* 183531 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(183587), // Rule ID 4700 //
     /* 183536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 183539 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183555 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 183558 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183585 */     GIR_RootConstrainSelectedInstOperands,
     /* 183586 */     // GIR_Coverage, 4700,
     /* 183586 */     GIR_EraseRootFromParent_Done,
     /* 183587 */   // Label 2873: @183587
     /* 183587 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(183640), // Rule ID 4702 //
     /* 183592 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 183608 */     // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 183608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 183611 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 183613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 183618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 183623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183638 */     GIR_RootConstrainSelectedInstOperands,
     /* 183639 */     // GIR_Coverage, 4702,
     /* 183639 */     GIR_EraseRootFromParent_Done,
     /* 183640 */   // Label 2874: @183640
     /* 183640 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(183753), // Rule ID 8111 //
     /* 183645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 183648 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 183664 */     // (st v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183664 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 183667 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183671 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183676 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 183682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183704 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 183710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 183723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183751 */     GIR_RootConstrainSelectedInstOperands,
     /* 183752 */     // GIR_Coverage, 8111,
     /* 183752 */     GIR_EraseRootFromParent_Done,
     /* 183753 */   // Label 2875: @183753
     /* 183753 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(183866), // Rule ID 8115 //
     /* 183758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 183761 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 183766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 183777 */     // (st v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 183777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 183780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183789 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 183795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 183823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 183828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 183833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 183836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 183841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 183852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 183857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183864 */     GIR_RootConstrainSelectedInstOperands,
     /* 183865 */     // GIR_Coverage, 8115,
     /* 183865 */     GIR_EraseRootFromParent_Done,
     /* 183866 */   // Label 2876: @183866
     /* 183866 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(183919), // Rule ID 3948 //
     /* 183871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183874 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 183890 */     // (st v2i64:{ *:[v2i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 183890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 183893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 183898 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 183905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183917 */     GIR_RootConstrainSelectedInstOperands,
     /* 183918 */     // GIR_Coverage, 3948,
     /* 183918 */     GIR_EraseRootFromParent_Done,
     /* 183919 */   // Label 2877: @183919
     /* 183919 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(183972), // Rule ID 3952 //
     /* 183924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183927 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 183943 */     // (st v2f64:{ *:[v2f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v2f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 183943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 183946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 183951 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 183953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 183958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 183963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 183966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 183970 */     GIR_RootConstrainSelectedInstOperands,
     /* 183971 */     // GIR_Coverage, 3952,
     /* 183971 */     GIR_EraseRootFromParent_Done,
     /* 183972 */   // Label 2878: @183972
     /* 183972 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(184020), // Rule ID 3947 //
     /* 183977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 183980 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 183985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 183989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 183996 */     // (st v2i64:{ *:[v2i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 183996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 183999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184004 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184018 */     GIR_RootConstrainSelectedInstOperands,
     /* 184019 */     // GIR_Coverage, 3947,
     /* 184019 */     GIR_EraseRootFromParent_Done,
     /* 184020 */   // Label 2879: @184020
     /* 184020 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(184068), // Rule ID 3951 //
     /* 184025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 184028 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 184044 */     // (st v2f64:{ *:[v2f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 184044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 184047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184052 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184066 */     GIR_RootConstrainSelectedInstOperands,
     /* 184067 */     // GIR_Coverage, 3951,
     /* 184067 */     GIR_EraseRootFromParent_Done,
     /* 184068 */   // Label 2880: @184068
     /* 184068 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(184117), // Rule ID 3660 //
     /* 184073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 184076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 184082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 184093 */     // (st v2i64:{ *:[v2i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 184093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 184096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184101 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184115 */     GIR_RootConstrainSelectedInstOperands,
     /* 184116 */     // GIR_Coverage, 3660,
     /* 184116 */     GIR_EraseRootFromParent_Done,
     /* 184117 */   // Label 2881: @184117
     /* 184117 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(184166), // Rule ID 3662 //
     /* 184122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 184125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 184131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 184142 */     // (st v2f64:{ *:[v2f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 184142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 184145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184150 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184164 */     GIR_RootConstrainSelectedInstOperands,
     /* 184165 */     // GIR_Coverage, 3662,
     /* 184165 */     GIR_EraseRootFromParent_Done,
     /* 184166 */   // Label 2882: @184166
     /* 184166 */   GIM_Reject,
     /* 184167 */ // Label 2850: @184167
     /* 184167 */ GIM_Reject,
     /* 184168 */ // Label 2442: @184168
     /* 184168 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(185582),
     /* 184173 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184176 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(184232), // Rule ID 8162 //
     /* 184181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 184184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 184188 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184193 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 184197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184208 */     // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 184211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184216 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184230 */     GIR_RootConstrainSelectedInstOperands,
     /* 184231 */     // GIR_Coverage, 8162,
     /* 184231 */     GIR_EraseRootFromParent_Done,
     /* 184232 */   // Label 2884: @184232
     /* 184232 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(184288), // Rule ID 8166 //
     /* 184237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 184240 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 184244 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184249 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 184253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184264 */     // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 184267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184272 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184286 */     GIR_RootConstrainSelectedInstOperands,
     /* 184287 */     // GIR_Coverage, 8166,
     /* 184287 */     GIR_EraseRootFromParent_Done,
     /* 184288 */   // Label 2885: @184288
     /* 184288 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(184340), // Rule ID 8230 //
     /* 184293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 184296 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 184300 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184316 */     // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 184319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184324 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184338 */     GIR_RootConstrainSelectedInstOperands,
     /* 184339 */     // GIR_Coverage, 8230,
     /* 184339 */     GIR_EraseRootFromParent_Done,
     /* 184340 */   // Label 2886: @184340
     /* 184340 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(184392), // Rule ID 8234 //
     /* 184345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 184348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 184352 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184368 */     // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
     /* 184371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184376 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184390 */     GIR_RootConstrainSelectedInstOperands,
     /* 184391 */     // GIR_Coverage, 8234,
     /* 184391 */     GIR_EraseRootFromParent_Done,
     /* 184392 */   // Label 2887: @184392
     /* 184392 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(184444), // Rule ID 8163 //
     /* 184397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 184400 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184405 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 184409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184420 */     // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 184423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184428 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184442 */     GIR_RootConstrainSelectedInstOperands,
     /* 184443 */     // GIR_Coverage, 8163,
     /* 184443 */     GIR_EraseRootFromParent_Done,
     /* 184444 */   // Label 2888: @184444
     /* 184444 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(184496), // Rule ID 8167 //
     /* 184449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 184452 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184457 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 184461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184472 */     // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 184475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184480 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184494 */     GIR_RootConstrainSelectedInstOperands,
     /* 184495 */     // GIR_Coverage, 8167,
     /* 184495 */     GIR_EraseRootFromParent_Done,
     /* 184496 */   // Label 2889: @184496
     /* 184496 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(184544), // Rule ID 8231 //
     /* 184501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 184504 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184520 */     // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 184523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184528 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184542 */     GIR_RootConstrainSelectedInstOperands,
     /* 184543 */     // GIR_Coverage, 8231,
     /* 184543 */     GIR_EraseRootFromParent_Done,
     /* 184544 */   // Label 2890: @184544
     /* 184544 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(184592), // Rule ID 8235 //
     /* 184549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 184552 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 184557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 184568 */     // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9742:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 184568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
     /* 184571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 184576 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184590 */     GIR_RootConstrainSelectedInstOperands,
     /* 184591 */     // GIR_Coverage, 8235,
     /* 184591 */     GIR_EraseRootFromParent_Done,
     /* 184592 */   // Label 2891: @184592
     /* 184592 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(184648), // Rule ID 6649 //
     /* 184597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 184600 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 184616 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 184619 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 184631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184646 */     GIR_RootConstrainSelectedInstOperands,
     /* 184647 */     // GIR_Coverage, 6649,
     /* 184647 */     GIR_EraseRootFromParent_Done,
     /* 184648 */   // Label 2892: @184648
     /* 184648 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(184704), // Rule ID 6651 //
     /* 184653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 184656 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 184672 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 184672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 184675 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 184677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 184687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184702 */     GIR_RootConstrainSelectedInstOperands,
     /* 184703 */     // GIR_Coverage, 6651,
     /* 184703 */     GIR_EraseRootFromParent_Done,
     /* 184704 */   // Label 2893: @184704
     /* 184704 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(184757), // Rule ID 4400 //
     /* 184709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 184712 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 184728 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SVS anonymous_9742:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SVS),
     /* 184731 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 184743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 184748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184755 */     GIR_RootConstrainSelectedInstOperands,
     /* 184756 */     // GIR_Coverage, 4400,
     /* 184756 */     GIR_EraseRootFromParent_Done,
     /* 184757 */   // Label 2894: @184757
     /* 184757 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(184805), // Rule ID 4399 //
     /* 184762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 184781 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SADDR anonymous_9742:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 184781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SADDR),
     /* 184784 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 184791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184803 */     GIR_RootConstrainSelectedInstOperands,
     /* 184804 */     // GIR_Coverage, 4399,
     /* 184804 */     GIR_EraseRootFromParent_Done,
     /* 184805 */   // Label 2895: @184805
     /* 184805 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(184853), // Rule ID 4398 //
     /* 184810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 184813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 184818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 184829 */     // (st v3i32:{ *:[v3i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3 anonymous_9742:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 184829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3),
     /* 184832 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 184834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 184839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 184844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184851 */     GIR_RootConstrainSelectedInstOperands,
     /* 184852 */     // GIR_Coverage, 4398,
     /* 184852 */     GIR_EraseRootFromParent_Done,
     /* 184853 */   // Label 2896: @184853
     /* 184853 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(184914), // Rule ID 4681 //
     /* 184858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 184861 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184877 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
     /* 184880 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184912 */     GIR_RootConstrainSelectedInstOperands,
     /* 184913 */     // GIR_Coverage, 4681,
     /* 184913 */     GIR_EraseRootFromParent_Done,
     /* 184914 */   // Label 2897: @184914
     /* 184914 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(184972), // Rule ID 4683 //
     /* 184919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184935 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
     /* 184938 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 184940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 184945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 184950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 184955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 184960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 184966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 184970 */     GIR_RootConstrainSelectedInstOperands,
     /* 184971 */     // GIR_Coverage, 4683,
     /* 184971 */     GIR_EraseRootFromParent_Done,
     /* 184972 */   // Label 2898: @184972
     /* 184972 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(185033), // Rule ID 4685 //
     /* 184977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 184980 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 184985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 184989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 184996 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 184996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
     /* 184999 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 185006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 185016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 185021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185031 */     GIR_RootConstrainSelectedInstOperands,
     /* 185032 */     // GIR_Coverage, 4685,
     /* 185032 */     GIR_EraseRootFromParent_Done,
     /* 185033 */   // Label 2899: @185033
     /* 185033 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(185091), // Rule ID 4687 //
     /* 185038 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 185054 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
     /* 185057 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 185064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 185074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 185079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185089 */     GIR_RootConstrainSelectedInstOperands,
     /* 185090 */     // GIR_Coverage, 4687,
     /* 185090 */     GIR_EraseRootFromParent_Done,
     /* 185091 */   // Label 2900: @185091
     /* 185091 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(185152), // Rule ID 6648 //
     /* 185096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 185099 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 185104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 185115 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 185115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN),
     /* 185118 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 185125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 185135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 185140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185150 */     GIR_RootConstrainSelectedInstOperands,
     /* 185151 */     // GIR_Coverage, 6648,
     /* 185151 */     GIR_EraseRootFromParent_Done,
     /* 185152 */   // Label 2901: @185152
     /* 185152 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(185213), // Rule ID 6650 //
     /* 185157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 185160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 185165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 185176 */     // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 185176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN),
     /* 185179 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 185186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 185196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 185201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185211 */     GIR_RootConstrainSelectedInstOperands,
     /* 185212 */     // GIR_Coverage, 6650,
     /* 185212 */     GIR_EraseRootFromParent_Done,
     /* 185213 */   // Label 2902: @185213
     /* 185213 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(185269), // Rule ID 4680 //
     /* 185218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 185221 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185237 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 185240 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185267 */     GIR_RootConstrainSelectedInstOperands,
     /* 185268 */     // GIR_Coverage, 4680,
     /* 185268 */     GIR_EraseRootFromParent_Done,
     /* 185269 */   // Label 2903: @185269
     /* 185269 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(185322), // Rule ID 4682 //
     /* 185274 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185290 */     // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 185293 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185320 */     GIR_RootConstrainSelectedInstOperands,
     /* 185321 */     // GIR_Coverage, 4682,
     /* 185321 */     GIR_EraseRootFromParent_Done,
     /* 185322 */   // Label 2904: @185322
     /* 185322 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(185378), // Rule ID 4684 //
     /* 185327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 185330 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185346 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
     /* 185349 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185376 */     GIR_RootConstrainSelectedInstOperands,
     /* 185377 */     // GIR_Coverage, 4684,
     /* 185377 */     GIR_EraseRootFromParent_Done,
     /* 185378 */   // Label 2905: @185378
     /* 185378 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(185431), // Rule ID 4686 //
     /* 185383 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 185399 */     // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 185399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
     /* 185402 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 185404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 185409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 185414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185429 */     GIR_RootConstrainSelectedInstOperands,
     /* 185430 */     // GIR_Coverage, 4686,
     /* 185430 */     GIR_EraseRootFromParent_Done,
     /* 185431 */   // Label 2906: @185431
     /* 185431 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(185484), // Rule ID 3970 //
     /* 185436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185439 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 185455 */     // (st v3i32:{ *:[v3i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3_SADDR ?:{ *:[i32] }:$voffset, anonymous_9742:{ *:[v3i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 185455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3_SADDR),
     /* 185458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 185463 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 185470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 185475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185482 */     GIR_RootConstrainSelectedInstOperands,
     /* 185483 */     // GIR_Coverage, 3970,
     /* 185483 */     GIR_EraseRootFromParent_Done,
     /* 185484 */   // Label 2907: @185484
     /* 185484 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(185532), // Rule ID 3969 //
     /* 185489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 185492 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 185497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 185508 */     // (st v3i32:{ *:[v3i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9742:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3),
     /* 185511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185516 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185530 */     GIR_RootConstrainSelectedInstOperands,
     /* 185531 */     // GIR_Coverage, 3969,
     /* 185531 */     GIR_EraseRootFromParent_Done,
     /* 185532 */   // Label 2908: @185532
     /* 185532 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(185581), // Rule ID 3654 //
     /* 185537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 185540 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 185546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 185557 */     // (st v3i32:{ *:[v3i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9742:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 185557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX3),
     /* 185560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 185565 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 185567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185579 */     GIR_RootConstrainSelectedInstOperands,
     /* 185580 */     // GIR_Coverage, 3654,
     /* 185580 */     GIR_EraseRootFromParent_Done,
     /* 185581 */   // Label 2909: @185581
     /* 185581 */   GIM_Reject,
     /* 185582 */ // Label 2883: @185582
     /* 185582 */ GIM_Reject,
     /* 185583 */ // Label 2443: @185583
     /* 185583 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(187558),
     /* 185588 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185591 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(185652), // Rule ID 8210 //
     /* 185596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 185599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185603 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185608 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 185621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185628 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 185631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185636 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185650 */     GIR_RootConstrainSelectedInstOperands,
     /* 185651 */     // GIR_Coverage, 8210,
     /* 185651 */     GIR_EraseRootFromParent_Done,
     /* 185652 */   // Label 2911: @185652
     /* 185652 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(185713), // Rule ID 8214 //
     /* 185657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 185660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185664 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185669 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 185682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185689 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 185692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185697 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185711 */     GIR_RootConstrainSelectedInstOperands,
     /* 185712 */     // GIR_Coverage, 8214,
     /* 185712 */     GIR_EraseRootFromParent_Done,
     /* 185713 */   // Label 2912: @185713
     /* 185713 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(185769), // Rule ID 8142 //
     /* 185718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 185721 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185725 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185730 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 185734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185745 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 185748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185753 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185767 */     GIR_RootConstrainSelectedInstOperands,
     /* 185768 */     // GIR_Coverage, 8142,
     /* 185768 */     GIR_EraseRootFromParent_Done,
     /* 185769 */   // Label 2913: @185769
     /* 185769 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(185825), // Rule ID 8146 //
     /* 185774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 185777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 185781 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185786 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 185790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185801 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
     /* 185804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185809 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185823 */     GIR_RootConstrainSelectedInstOperands,
     /* 185824 */     // GIR_Coverage, 8146,
     /* 185824 */     GIR_EraseRootFromParent_Done,
     /* 185825 */   // Label 2914: @185825
     /* 185825 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(185882), // Rule ID 8211 //
     /* 185830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 185833 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185838 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 185851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185858 */     // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 185861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185866 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185880 */     GIR_RootConstrainSelectedInstOperands,
     /* 185881 */     // GIR_Coverage, 8211,
     /* 185881 */     GIR_EraseRootFromParent_Done,
     /* 185882 */   // Label 2915: @185882
     /* 185882 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(185939), // Rule ID 8215 //
     /* 185887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 185890 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 185908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185915 */     // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 185918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185923 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185937 */     GIR_RootConstrainSelectedInstOperands,
     /* 185938 */     // GIR_Coverage, 8215,
     /* 185938 */     GIR_EraseRootFromParent_Done,
     /* 185939 */   // Label 2916: @185939
     /* 185939 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(185991), // Rule ID 8143 //
     /* 185944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 185947 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 185952 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 185956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 185960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 185967 */     // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 185967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 185970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 185975 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 185977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 185982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 185985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 185989 */     GIR_RootConstrainSelectedInstOperands,
     /* 185990 */     // GIR_Coverage, 8143,
     /* 185990 */     GIR_EraseRootFromParent_Done,
     /* 185991 */   // Label 2917: @185991
     /* 185991 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(186043), // Rule ID 8147 //
     /* 185996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 185999 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186004 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
     /* 186008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 186019 */     // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 186019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
     /* 186022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186027 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 186029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186041 */     GIR_RootConstrainSelectedInstOperands,
     /* 186042 */     // GIR_Coverage, 8147,
     /* 186042 */     GIR_EraseRootFromParent_Done,
     /* 186043 */   // Label 2918: @186043
     /* 186043 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(186096), // Rule ID 4328 //
     /* 186048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 186051 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 186067 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 186070 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 186082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186094 */     GIR_RootConstrainSelectedInstOperands,
     /* 186095 */     // GIR_Coverage, 4328,
     /* 186095 */     GIR_EraseRootFromParent_Done,
     /* 186096 */   // Label 2919: @186096
     /* 186096 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(186149), // Rule ID 4334 //
     /* 186101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 186104 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 186120 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9743:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
     /* 186123 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 186135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186147 */     GIR_RootConstrainSelectedInstOperands,
     /* 186148 */     // GIR_Coverage, 4334,
     /* 186148 */     GIR_EraseRootFromParent_Done,
     /* 186149 */   // Label 2920: @186149
     /* 186149 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(186197), // Rule ID 4327 //
     /* 186154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186157 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 186173 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 186176 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 186183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186195 */     GIR_RootConstrainSelectedInstOperands,
     /* 186196 */     // GIR_Coverage, 4327,
     /* 186196 */     GIR_EraseRootFromParent_Done,
     /* 186197 */   // Label 2921: @186197
     /* 186197 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(186245), // Rule ID 4333 //
     /* 186202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186205 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 186221 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9743:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 186221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
     /* 186224 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 186231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186243 */     GIR_RootConstrainSelectedInstOperands,
     /* 186244 */     // GIR_Coverage, 4333,
     /* 186244 */     GIR_EraseRootFromParent_Done,
     /* 186245 */   // Label 2922: @186245
     /* 186245 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(186293), // Rule ID 4326 //
     /* 186250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 186269 */     // (st v4i16:{ *:[v4i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 186269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 186272 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186291 */     GIR_RootConstrainSelectedInstOperands,
     /* 186292 */     // GIR_Coverage, 4326,
     /* 186292 */     GIR_EraseRootFromParent_Done,
     /* 186293 */   // Label 2923: @186293
     /* 186293 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(186341), // Rule ID 4332 //
     /* 186298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 186301 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 186306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 186317 */     // (st v4f16:{ *:[v4f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9743:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 186317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
     /* 186320 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 186322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 186327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 186332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186339 */     GIR_RootConstrainSelectedInstOperands,
     /* 186340 */     // GIR_Coverage, 4332,
     /* 186340 */     GIR_EraseRootFromParent_Done,
     /* 186341 */   // Label 2924: @186341
     /* 186341 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(186402), // Rule ID 4661 //
     /* 186346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186349 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186365 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 186368 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186400 */     GIR_RootConstrainSelectedInstOperands,
     /* 186401 */     // GIR_Coverage, 4661,
     /* 186401 */     GIR_EraseRootFromParent_Done,
     /* 186402 */   // Label 2925: @186402
     /* 186402 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(186460), // Rule ID 4663 //
     /* 186407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186423 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 186426 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186458 */     GIR_RootConstrainSelectedInstOperands,
     /* 186459 */     // GIR_Coverage, 4663,
     /* 186459 */     GIR_EraseRootFromParent_Done,
     /* 186460 */   // Label 2926: @186460
     /* 186460 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(186521), // Rule ID 4665 //
     /* 186465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186468 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186484 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
     /* 186487 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186519 */     GIR_RootConstrainSelectedInstOperands,
     /* 186520 */     // GIR_Coverage, 4665,
     /* 186520 */     GIR_EraseRootFromParent_Done,
     /* 186521 */   // Label 2927: @186521
     /* 186521 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(186579), // Rule ID 4667 //
     /* 186526 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 186542 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
     /* 186545 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 186552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 186562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 186567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186577 */     GIR_RootConstrainSelectedInstOperands,
     /* 186578 */     // GIR_Coverage, 4667,
     /* 186578 */     GIR_EraseRootFromParent_Done,
     /* 186579 */   // Label 2928: @186579
     /* 186579 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(186696), // Rule ID 8085 //
     /* 186584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 186587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186591 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 186607 */     // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 186607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 186610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186619 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 186625 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 186630 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 186638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186647 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 186653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 186658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 186666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 186674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 186677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 186682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 186687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186694 */     GIR_RootConstrainSelectedInstOperands,
     /* 186695 */     // GIR_Coverage, 8085,
     /* 186695 */     GIR_EraseRootFromParent_Done,
     /* 186696 */   // Label 2929: @186696
     /* 186696 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(186813), // Rule ID 8089 //
     /* 186701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 186704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 186708 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 186713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 186724 */     // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 186724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 186727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186736 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 186742 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 186747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 186755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186764 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 186770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 186775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 186780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
     /* 186783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 186788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 186791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 186794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 186799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 186804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186811 */     GIR_RootConstrainSelectedInstOperands,
     /* 186812 */     // GIR_Coverage, 8089,
     /* 186812 */     GIR_EraseRootFromParent_Done,
     /* 186813 */   // Label 2930: @186813
     /* 186813 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(186869), // Rule ID 4660 //
     /* 186818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186821 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 186837 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 186840 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 186852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186867 */     GIR_RootConstrainSelectedInstOperands,
     /* 186868 */     // GIR_Coverage, 4660,
     /* 186868 */     GIR_EraseRootFromParent_Done,
     /* 186869 */   // Label 2931: @186869
     /* 186869 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(186922), // Rule ID 4662 //
     /* 186874 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 186890 */     // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 186893 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 186905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186920 */     GIR_RootConstrainSelectedInstOperands,
     /* 186921 */     // GIR_Coverage, 4662,
     /* 186921 */     GIR_EraseRootFromParent_Done,
     /* 186922 */   // Label 2932: @186922
     /* 186922 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(186978), // Rule ID 4664 //
     /* 186927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 186930 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 186946 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
     /* 186949 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 186951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 186956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 186961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 186966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 186972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 186976 */     GIR_RootConstrainSelectedInstOperands,
     /* 186977 */     // GIR_Coverage, 4664,
     /* 186977 */     GIR_EraseRootFromParent_Done,
     /* 186978 */   // Label 2933: @186978
     /* 186978 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(187031), // Rule ID 4666 //
     /* 186983 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 186988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 186992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 186999 */     // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 186999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
     /* 187002 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 187004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 187009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 187014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187029 */     GIR_RootConstrainSelectedInstOperands,
     /* 187030 */     // GIR_Coverage, 4666,
     /* 187030 */     GIR_EraseRootFromParent_Done,
     /* 187031 */   // Label 2934: @187031
     /* 187031 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(187144), // Rule ID 8087 //
     /* 187036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 187039 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 187055 */     // (st v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 187058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187067 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 187073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 187078 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 187086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187095 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 187101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 187106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 187114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187142 */     GIR_RootConstrainSelectedInstOperands,
     /* 187143 */     // GIR_Coverage, 8087,
     /* 187143 */     GIR_EraseRootFromParent_Done,
     /* 187144 */   // Label 2935: @187144
     /* 187144 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(187257), // Rule ID 8091 //
     /* 187149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 187152 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
     /* 187168 */     // (st v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 187168 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 187171 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187175 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187180 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
     /* 187186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 187191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 187199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187208 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
     /* 187214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 187219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 187224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
     /* 187227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 187235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 187238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 187243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 187248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187255 */     GIR_RootConstrainSelectedInstOperands,
     /* 187256 */     // GIR_Coverage, 8091,
     /* 187256 */     GIR_EraseRootFromParent_Done,
     /* 187257 */   // Label 2936: @187257
     /* 187257 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(187310), // Rule ID 3918 //
     /* 187262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187265 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 187281 */     // (st v4i16:{ *:[v4i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[v4i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 187281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 187284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 187289 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 187296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187308 */     GIR_RootConstrainSelectedInstOperands,
     /* 187309 */     // GIR_Coverage, 3918,
     /* 187309 */     GIR_EraseRootFromParent_Done,
     /* 187310 */   // Label 2937: @187310
     /* 187310 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(187363), // Rule ID 3922 //
     /* 187315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187318 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 187334 */     // (st v4f16:{ *:[v4f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[v4f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 187334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
     /* 187337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 187342 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 187349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 187354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187361 */     GIR_RootConstrainSelectedInstOperands,
     /* 187362 */     // GIR_Coverage, 3922,
     /* 187362 */     GIR_EraseRootFromParent_Done,
     /* 187363 */   // Label 2938: @187363
     /* 187363 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(187411), // Rule ID 3917 //
     /* 187368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187371 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 187387 */     // (st v4i16:{ *:[v4i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 187390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187395 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187409 */     GIR_RootConstrainSelectedInstOperands,
     /* 187410 */     // GIR_Coverage, 3917,
     /* 187410 */     GIR_EraseRootFromParent_Done,
     /* 187411 */   // Label 2939: @187411
     /* 187411 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(187459), // Rule ID 3921 //
     /* 187416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 187419 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 187424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 187435 */     // (st v4f16:{ *:[v4f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
     /* 187438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187443 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187457 */     GIR_RootConstrainSelectedInstOperands,
     /* 187458 */     // GIR_Coverage, 3921,
     /* 187458 */     GIR_EraseRootFromParent_Done,
     /* 187459 */   // Label 2940: @187459
     /* 187459 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(187508), // Rule ID 3644 //
     /* 187464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 187467 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 187473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 187484 */     // (st v4i16:{ *:[v4i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 187487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187492 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187506 */     GIR_RootConstrainSelectedInstOperands,
     /* 187507 */     // GIR_Coverage, 3644,
     /* 187507 */     GIR_EraseRootFromParent_Done,
     /* 187508 */   // Label 2941: @187508
     /* 187508 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(187557), // Rule ID 3646 //
     /* 187513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 187516 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 187522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 187533 */     // (st v4f16:{ *:[v4f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 187533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
     /* 187536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 187541 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 187543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187555 */     GIR_RootConstrainSelectedInstOperands,
     /* 187556 */     // GIR_Coverage, 3646,
     /* 187556 */     GIR_EraseRootFromParent_Done,
     /* 187557 */   // Label 2942: @187557
     /* 187557 */   GIM_Reject,
     /* 187558 */ // Label 2910: @187558
     /* 187558 */ GIM_Reject,
     /* 187559 */ // Label 2444: @187559
     /* 187559 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(189768),
     /* 187564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187567 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(187623), // Rule ID 8170 //
     /* 187572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 187575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 187579 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187584 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 187588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187599 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 187602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187607 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 187609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187621 */     GIR_RootConstrainSelectedInstOperands,
     /* 187622 */     // GIR_Coverage, 8170,
     /* 187622 */     GIR_EraseRootFromParent_Done,
     /* 187623 */   // Label 2944: @187623
     /* 187623 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(187679), // Rule ID 8174 //
     /* 187628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 187631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 187635 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187640 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 187644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187655 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 187658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187663 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 187665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187677 */     GIR_RootConstrainSelectedInstOperands,
     /* 187678 */     // GIR_Coverage, 8174,
     /* 187678 */     GIR_EraseRootFromParent_Done,
     /* 187679 */   // Label 2945: @187679
     /* 187679 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(187740), // Rule ID 8238 //
     /* 187684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 187687 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 187691 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187696 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 187709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187716 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 187719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187724 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 187726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187738 */     GIR_RootConstrainSelectedInstOperands,
     /* 187739 */     // GIR_Coverage, 8238,
     /* 187739 */     GIR_EraseRootFromParent_Done,
     /* 187740 */   // Label 2946: @187740
     /* 187740 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(187801), // Rule ID 8242 //
     /* 187745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 187748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 187752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187757 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 187770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187777 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 187780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187785 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 187787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187799 */     GIR_RootConstrainSelectedInstOperands,
     /* 187800 */     // GIR_Coverage, 8242,
     /* 187800 */     GIR_EraseRootFromParent_Done,
     /* 187801 */   // Label 2947: @187801
     /* 187801 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(187853), // Rule ID 8171 //
     /* 187806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 187809 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187814 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 187818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187829 */     // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 187832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187837 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 187839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187851 */     GIR_RootConstrainSelectedInstOperands,
     /* 187852 */     // GIR_Coverage, 8171,
     /* 187852 */     GIR_EraseRootFromParent_Done,
     /* 187853 */   // Label 2948: @187853
     /* 187853 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(187905), // Rule ID 8175 //
     /* 187858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 187861 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187866 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 187870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187881 */     // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 187884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187889 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 187891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187903 */     GIR_RootConstrainSelectedInstOperands,
     /* 187904 */     // GIR_Coverage, 8175,
     /* 187904 */     GIR_EraseRootFromParent_Done,
     /* 187905 */   // Label 2949: @187905
     /* 187905 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(187962), // Rule ID 8239 //
     /* 187910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 187913 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 187931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187938 */     // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 187941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 187946 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 187948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 187953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 187956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 187960 */     GIR_RootConstrainSelectedInstOperands,
     /* 187961 */     // GIR_Coverage, 8239,
     /* 187961 */     GIR_EraseRootFromParent_Done,
     /* 187962 */   // Label 2950: @187962
     /* 187962 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(188019), // Rule ID 8243 //
     /* 187967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 187970 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187975 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 187980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 187984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 187988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 187995 */     // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 187995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 187998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188003 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 188005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188017 */     GIR_RootConstrainSelectedInstOperands,
     /* 188018 */     // GIR_Coverage, 8243,
     /* 188018 */     GIR_EraseRootFromParent_Done,
     /* 188019 */   // Label 2951: @188019
     /* 188019 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(188075), // Rule ID 6653 //
     /* 188024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 188027 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 188043 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 188043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 188046 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 188048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 188058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 188063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188073 */     GIR_RootConstrainSelectedInstOperands,
     /* 188074 */     // GIR_Coverage, 6653,
     /* 188074 */     GIR_EraseRootFromParent_Done,
     /* 188075 */   // Label 2952: @188075
     /* 188075 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(188131), // Rule ID 6655 //
     /* 188080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 188083 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
     /* 188099 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 188099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 188102 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 188104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 188114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 188119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188129 */     GIR_RootConstrainSelectedInstOperands,
     /* 188130 */     // GIR_Coverage, 6655,
     /* 188130 */     GIR_EraseRootFromParent_Done,
     /* 188131 */   // Label 2953: @188131
     /* 188131 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(188184), // Rule ID 4361 //
     /* 188136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 188139 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 188155 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9741:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 188155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 188158 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 188160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 188165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 188170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 188175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188182 */     GIR_RootConstrainSelectedInstOperands,
     /* 188183 */     // GIR_Coverage, 4361,
     /* 188183 */     GIR_EraseRootFromParent_Done,
     /* 188184 */   // Label 2954: @188184
     /* 188184 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(188237), // Rule ID 4367 //
     /* 188189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 188192 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 188208 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9741:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 188208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 188211 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 188213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 188218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 188223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 188228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188235 */     GIR_RootConstrainSelectedInstOperands,
     /* 188236 */     // GIR_Coverage, 4367,
     /* 188236 */     GIR_EraseRootFromParent_Done,
     /* 188237 */   // Label 2955: @188237
     /* 188237 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(188285), // Rule ID 4360 //
     /* 188242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 188245 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 188261 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9741:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 188261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 188264 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 188266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 188271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188283 */     GIR_RootConstrainSelectedInstOperands,
     /* 188284 */     // GIR_Coverage, 4360,
     /* 188284 */     GIR_EraseRootFromParent_Done,
     /* 188285 */   // Label 2956: @188285
     /* 188285 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(188333), // Rule ID 4366 //
     /* 188290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 188293 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 188309 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9741:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 188309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 188312 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 188314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 188319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188331 */     GIR_RootConstrainSelectedInstOperands,
     /* 188332 */     // GIR_Coverage, 4366,
     /* 188332 */     GIR_EraseRootFromParent_Done,
     /* 188333 */   // Label 2957: @188333
     /* 188333 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(188381), // Rule ID 4359 //
     /* 188338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 188341 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 188357 */     // (st v4i32:{ *:[v4i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9741:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 188357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 188360 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 188362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 188367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188379 */     GIR_RootConstrainSelectedInstOperands,
     /* 188380 */     // GIR_Coverage, 4359,
     /* 188380 */     GIR_EraseRootFromParent_Done,
     /* 188381 */   // Label 2958: @188381
     /* 188381 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(188429), // Rule ID 4365 //
     /* 188386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 188389 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 188405 */     // (st v4f32:{ *:[v4f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9741:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 188405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 188408 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 188410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 188415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 188420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188427 */     GIR_RootConstrainSelectedInstOperands,
     /* 188428 */     // GIR_Coverage, 4365,
     /* 188428 */     GIR_EraseRootFromParent_Done,
     /* 188429 */   // Label 2959: @188429
     /* 188429 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(188490), // Rule ID 4689 //
     /* 188434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 188437 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 188442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 188453 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 188453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 188456 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 188458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 188473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 188478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188488 */     GIR_RootConstrainSelectedInstOperands,
     /* 188489 */     // GIR_Coverage, 4689,
     /* 188489 */     GIR_EraseRootFromParent_Done,
     /* 188490 */   // Label 2960: @188490
     /* 188490 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(188548), // Rule ID 4691 //
     /* 188495 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 188500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 188511 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 188511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 188514 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 188516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 188531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 188536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188546 */     GIR_RootConstrainSelectedInstOperands,
     /* 188547 */     // GIR_Coverage, 4691,
     /* 188547 */     GIR_EraseRootFromParent_Done,
     /* 188548 */   // Label 2961: @188548
     /* 188548 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(188609), // Rule ID 4693 //
     /* 188553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 188556 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 188561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 188572 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 188572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 188575 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 188577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 188592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 188597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188607 */     GIR_RootConstrainSelectedInstOperands,
     /* 188608 */     // GIR_Coverage, 4693,
     /* 188608 */     GIR_EraseRootFromParent_Done,
     /* 188609 */   // Label 2962: @188609
     /* 188609 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(188667), // Rule ID 4695 //
     /* 188614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 188619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 188630 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 188630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 188633 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 188635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 188650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 188655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188665 */     GIR_RootConstrainSelectedInstOperands,
     /* 188666 */     // GIR_Coverage, 4695,
     /* 188666 */     GIR_EraseRootFromParent_Done,
     /* 188667 */   // Label 2963: @188667
     /* 188667 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(188728), // Rule ID 6652 //
     /* 188672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
     /* 188675 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 188691 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 188691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN),
     /* 188694 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 188696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 188711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 188716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188726 */     GIR_RootConstrainSelectedInstOperands,
     /* 188727 */     // GIR_Coverage, 6652,
     /* 188727 */     GIR_EraseRootFromParent_Done,
     /* 188728 */   // Label 2964: @188728
     /* 188728 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(188789), // Rule ID 6654 //
     /* 188733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
     /* 188736 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 188741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
     /* 188752 */     // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
     /* 188752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN),
     /* 188755 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 188757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 188762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 188767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 188772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 188777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188787 */     GIR_RootConstrainSelectedInstOperands,
     /* 188788 */     // GIR_Coverage, 6654,
     /* 188788 */     GIR_EraseRootFromParent_Done,
     /* 188789 */   // Label 2965: @188789
     /* 188789 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(188906), // Rule ID 8069 //
     /* 188794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 188797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 188801 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 188817 */     // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 188817 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 188820 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 188824 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188829 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 188835 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 188840 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 188845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 188848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 188852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188857 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 188863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 188868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 188873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 188876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 188884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 188887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 188892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 188897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 188900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 188904 */     GIR_RootConstrainSelectedInstOperands,
     /* 188905 */     // GIR_Coverage, 8069,
     /* 188905 */     GIR_EraseRootFromParent_Done,
     /* 188906 */   // Label 2966: @188906
     /* 188906 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(189023), // Rule ID 8105 //
     /* 188911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 188914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 188918 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 188923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 188927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 188934 */     // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 188934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 188937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 188941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188946 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 188952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 188957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 188962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 188965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 188969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188974 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 188980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 188985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 188990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 188993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 188998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 189001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 189004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 189009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 189014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189021 */     GIR_RootConstrainSelectedInstOperands,
     /* 189022 */     // GIR_Coverage, 8105,
     /* 189022 */     GIR_EraseRootFromParent_Done,
     /* 189023 */   // Label 2967: @189023
     /* 189023 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(189079), // Rule ID 4688 //
     /* 189028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189031 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189047 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 189047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 189050 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 189052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189077 */     GIR_RootConstrainSelectedInstOperands,
     /* 189078 */     // GIR_Coverage, 4688,
     /* 189078 */     GIR_EraseRootFromParent_Done,
     /* 189079 */   // Label 2968: @189079
     /* 189079 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(189132), // Rule ID 4690 //
     /* 189084 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189100 */     // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 189100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 189103 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 189105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189130 */     GIR_RootConstrainSelectedInstOperands,
     /* 189131 */     // GIR_Coverage, 4690,
     /* 189131 */     GIR_EraseRootFromParent_Done,
     /* 189132 */   // Label 2969: @189132
     /* 189132 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(189188), // Rule ID 4692 //
     /* 189137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 189140 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189156 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 189156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 189159 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 189161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189186 */     GIR_RootConstrainSelectedInstOperands,
     /* 189187 */     // GIR_Coverage, 4692,
     /* 189187 */     GIR_EraseRootFromParent_Done,
     /* 189188 */   // Label 2970: @189188
     /* 189188 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(189241), // Rule ID 4694 //
     /* 189193 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 189209 */     // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 189209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 189212 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 189214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 189219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 189224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189239 */     GIR_RootConstrainSelectedInstOperands,
     /* 189240 */     // GIR_Coverage, 4694,
     /* 189240 */     GIR_EraseRootFromParent_Done,
     /* 189241 */   // Label 2971: @189241
     /* 189241 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(189354), // Rule ID 8071 //
     /* 189246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 189249 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 189265 */     // (st v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 189265 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 189268 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 189272 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189277 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 189283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 189288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 189293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 189296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 189300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189305 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 189311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 189316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 189321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 189324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 189332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 189335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 189340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 189345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189352 */     GIR_RootConstrainSelectedInstOperands,
     /* 189353 */     // GIR_Coverage, 8071,
     /* 189353 */     GIR_EraseRootFromParent_Done,
     /* 189354 */   // Label 2972: @189354
     /* 189354 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(189467), // Rule ID 8107 //
     /* 189359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 189362 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 189378 */     // (st v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 189378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 189381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 189385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189390 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 189396 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 189401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 189406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 189409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 189413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189418 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 189424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 189429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 189434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 189437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 189445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 189448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 189453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 189458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189465 */     GIR_RootConstrainSelectedInstOperands,
     /* 189466 */     // GIR_Coverage, 8107,
     /* 189466 */     GIR_EraseRootFromParent_Done,
     /* 189467 */   // Label 2973: @189467
     /* 189467 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(189520), // Rule ID 3940 //
     /* 189472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189475 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 189491 */     // (st v4i32:{ *:[v4i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v4i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 189491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 189494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 189499 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 189501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 189506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189518 */     GIR_RootConstrainSelectedInstOperands,
     /* 189519 */     // GIR_Coverage, 3940,
     /* 189519 */     GIR_EraseRootFromParent_Done,
     /* 189520 */   // Label 2974: @189520
     /* 189520 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(189573), // Rule ID 3944 //
     /* 189525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 189544 */     // (st v4f32:{ *:[v4f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v4f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 189544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 189547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 189552 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 189554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 189559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 189564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189571 */     GIR_RootConstrainSelectedInstOperands,
     /* 189572 */     // GIR_Coverage, 3944,
     /* 189572 */     GIR_EraseRootFromParent_Done,
     /* 189573 */   // Label 2975: @189573
     /* 189573 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(189621), // Rule ID 3939 //
     /* 189578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189581 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 189597 */     // (st v4i32:{ *:[v4i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 189600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189605 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 189607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189619 */     GIR_RootConstrainSelectedInstOperands,
     /* 189620 */     // GIR_Coverage, 3939,
     /* 189620 */     GIR_EraseRootFromParent_Done,
     /* 189621 */   // Label 2976: @189621
     /* 189621 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(189669), // Rule ID 3943 //
     /* 189626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 189629 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 189634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 189645 */     // (st v4f32:{ *:[v4f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 189648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189653 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 189655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189667 */     GIR_RootConstrainSelectedInstOperands,
     /* 189668 */     // GIR_Coverage, 3943,
     /* 189668 */     GIR_EraseRootFromParent_Done,
     /* 189669 */   // Label 2977: @189669
     /* 189669 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(189718), // Rule ID 3656 //
     /* 189674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 189677 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 189683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 189694 */     // (st v4i32:{ *:[v4i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 189697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189702 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 189704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189716 */     GIR_RootConstrainSelectedInstOperands,
     /* 189717 */     // GIR_Coverage, 3656,
     /* 189717 */     GIR_EraseRootFromParent_Done,
     /* 189718 */   // Label 2978: @189718
     /* 189718 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(189767), // Rule ID 3658 //
     /* 189723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 189726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 189732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 189743 */     // (st v4f32:{ *:[v4f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 189743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 189746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 189751 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 189753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189765 */     GIR_RootConstrainSelectedInstOperands,
     /* 189766 */     // GIR_Coverage, 3658,
     /* 189766 */     GIR_EraseRootFromParent_Done,
     /* 189767 */   // Label 2979: @189767
     /* 189767 */   GIM_Reject,
     /* 189768 */ // Label 2943: @189768
     /* 189768 */ GIM_Reject,
     /* 189769 */ // Label 2445: @189769
     /* 189769 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(191744),
     /* 189774 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189777 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(189833), // Rule ID 8186 //
     /* 189782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 189785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 189789 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189794 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 189798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189809 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 189812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189817 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 189819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189831 */     GIR_RootConstrainSelectedInstOperands,
     /* 189832 */     // GIR_Coverage, 8186,
     /* 189832 */     GIR_EraseRootFromParent_Done,
     /* 189833 */   // Label 2981: @189833
     /* 189833 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(189889), // Rule ID 8190 //
     /* 189838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 189841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 189845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189850 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 189854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189865 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 189868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189873 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 189875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189887 */     GIR_RootConstrainSelectedInstOperands,
     /* 189888 */     // GIR_Coverage, 8190,
     /* 189888 */     GIR_EraseRootFromParent_Done,
     /* 189889 */   // Label 2982: @189889
     /* 189889 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(189950), // Rule ID 8254 //
     /* 189894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 189897 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 189901 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189906 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 189919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189926 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 189929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189934 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 189936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 189941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 189944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 189948 */     GIR_RootConstrainSelectedInstOperands,
     /* 189949 */     // GIR_Coverage, 8254,
     /* 189949 */     GIR_EraseRootFromParent_Done,
     /* 189950 */   // Label 2983: @189950
     /* 189950 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(190011), // Rule ID 8258 //
     /* 189955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
     /* 189958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 189962 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 189972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 189976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
     /* 189980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 189987 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 189987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
     /* 189990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 189995 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 189997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190009 */     GIR_RootConstrainSelectedInstOperands,
     /* 190010 */     // GIR_Coverage, 8258,
     /* 190010 */     GIR_EraseRootFromParent_Done,
     /* 190011 */   // Label 2984: @190011
     /* 190011 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(190063), // Rule ID 8187 //
     /* 190016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 190019 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190024 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 190028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190039 */     // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 190042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190047 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 190049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190061 */     GIR_RootConstrainSelectedInstOperands,
     /* 190062 */     // GIR_Coverage, 8187,
     /* 190062 */     GIR_EraseRootFromParent_Done,
     /* 190063 */   // Label 2985: @190063
     /* 190063 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(190115), // Rule ID 8191 //
     /* 190068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
     /* 190071 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190076 */     GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
     /* 190080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190091 */     // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 190094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190099 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 190101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190113 */     GIR_RootConstrainSelectedInstOperands,
     /* 190114 */     // GIR_Coverage, 8191,
     /* 190114 */     GIR_EraseRootFromParent_Done,
     /* 190115 */   // Label 2986: @190115
     /* 190115 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(190172), // Rule ID 8255 //
     /* 190120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 190123 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190128 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 190141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190148 */     // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 190151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190156 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 190158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190170 */     GIR_RootConstrainSelectedInstOperands,
     /* 190171 */     // GIR_Coverage, 8255,
     /* 190171 */     GIR_EraseRootFromParent_Done,
     /* 190172 */   // Label 2987: @190172
     /* 190172 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(190229), // Rule ID 8259 //
     /* 190177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
     /* 190180 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
     /* 190198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 190205 */     // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9741:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 190205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
     /* 190208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190213 */     GIR_RootToRootCopy, /*OpIdx*/0, // value
     /* 190215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190227 */     GIR_RootConstrainSelectedInstOperands,
     /* 190228 */     // GIR_Coverage, 8259,
     /* 190228 */     GIR_EraseRootFromParent_Done,
     /* 190229 */   // Label 2988: @190229
     /* 190229 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(190282), // Rule ID 4385 //
     /* 190234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 190237 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 190242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 190253 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9741:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 190256 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 190258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 190268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190280 */     GIR_RootConstrainSelectedInstOperands,
     /* 190281 */     // GIR_Coverage, 4385,
     /* 190281 */     GIR_EraseRootFromParent_Done,
     /* 190282 */   // Label 2989: @190282
     /* 190282 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(190335), // Rule ID 4391 //
     /* 190287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
     /* 190290 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 190295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
     /* 190306 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9741:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
     /* 190309 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 190311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
     /* 190321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 190326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190333 */     GIR_RootConstrainSelectedInstOperands,
     /* 190334 */     // GIR_Coverage, 4391,
     /* 190334 */     GIR_EraseRootFromParent_Done,
     /* 190335 */   // Label 2990: @190335
     /* 190335 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(190383), // Rule ID 4384 //
     /* 190340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 190343 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 190348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 190359 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9741:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 190362 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 190364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 190369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190381 */     GIR_RootConstrainSelectedInstOperands,
     /* 190382 */     // GIR_Coverage, 4384,
     /* 190382 */     GIR_EraseRootFromParent_Done,
     /* 190383 */   // Label 2991: @190383
     /* 190383 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(190431), // Rule ID 4390 //
     /* 190388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 190391 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 190396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
     /* 190407 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9741:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 190407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
     /* 190410 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 190412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 190417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190429 */     GIR_RootConstrainSelectedInstOperands,
     /* 190430 */     // GIR_Coverage, 4390,
     /* 190430 */     GIR_EraseRootFromParent_Done,
     /* 190431 */   // Label 2992: @190431
     /* 190431 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(190479), // Rule ID 4383 //
     /* 190436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 190439 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 190444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 190455 */     // (st v8i16:{ *:[v8i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9741:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 190455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 190458 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 190460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190477 */     GIR_RootConstrainSelectedInstOperands,
     /* 190478 */     // GIR_Coverage, 4383,
     /* 190478 */     GIR_EraseRootFromParent_Done,
     /* 190479 */   // Label 2993: @190479
     /* 190479 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(190527), // Rule ID 4389 //
     /* 190484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
     /* 190487 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
     /* 190492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
     /* 190503 */     // (st v8f16:{ *:[v8f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9741:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 190503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
     /* 190506 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 190508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 190513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 190518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190525 */     GIR_RootConstrainSelectedInstOperands,
     /* 190526 */     // GIR_Coverage, 4389,
     /* 190526 */     GIR_EraseRootFromParent_Done,
     /* 190527 */   // Label 2994: @190527
     /* 190527 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(190588), // Rule ID 4705 //
     /* 190532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190535 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 190540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190551 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 190551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 190554 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 190556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190586 */     GIR_RootConstrainSelectedInstOperands,
     /* 190587 */     // GIR_Coverage, 4705,
     /* 190587 */     GIR_EraseRootFromParent_Done,
     /* 190588 */   // Label 2995: @190588
     /* 190588 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(190646), // Rule ID 4707 //
     /* 190593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 190598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190609 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 190609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 190612 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 190614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190644 */     GIR_RootConstrainSelectedInstOperands,
     /* 190645 */     // GIR_Coverage, 4707,
     /* 190645 */     GIR_EraseRootFromParent_Done,
     /* 190646 */   // Label 2996: @190646
     /* 190646 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(190707), // Rule ID 4709 //
     /* 190651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 190654 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 190659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190670 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 190670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
     /* 190673 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 190675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190705 */     GIR_RootConstrainSelectedInstOperands,
     /* 190706 */     // GIR_Coverage, 4709,
     /* 190706 */     GIR_EraseRootFromParent_Done,
     /* 190707 */   // Label 2997: @190707
     /* 190707 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(190765), // Rule ID 4711 //
     /* 190712 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 190717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 190728 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 190728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
     /* 190731 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 190733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 190738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 190743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 190748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 190753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190763 */     GIR_RootConstrainSelectedInstOperands,
     /* 190764 */     // GIR_Coverage, 4711,
     /* 190764 */     GIR_EraseRootFromParent_Done,
     /* 190765 */   // Label 2998: @190765
     /* 190765 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(190882), // Rule ID 8117 //
     /* 190770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 190773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 190777 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 190793 */     // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 190793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 190796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190805 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 190811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 190816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 190821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 190824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 190839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 190844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 190849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 190852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 190860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 190863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 190868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 190873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190880 */     GIR_RootConstrainSelectedInstOperands,
     /* 190881 */     // GIR_Coverage, 8117,
     /* 190881 */     GIR_EraseRootFromParent_Done,
     /* 190882 */   // Label 2999: @190882
     /* 190882 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(190999), // Rule ID 8121 //
     /* 190887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
     /* 190890 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 190894 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 190899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 190903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 190910 */     // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 190910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 190913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190922 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 190928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 190933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 190938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 190941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190950 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 190956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 190961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 190966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
     /* 190969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 190974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 190977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 190980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 190985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 190990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 190993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 190997 */     GIR_RootConstrainSelectedInstOperands,
     /* 190998 */     // GIR_Coverage, 8121,
     /* 190998 */     GIR_EraseRootFromParent_Done,
     /* 190999 */   // Label 3000: @190999
     /* 190999 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(191055), // Rule ID 4704 //
     /* 191004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191023 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 191023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 191026 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 191028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191053 */     GIR_RootConstrainSelectedInstOperands,
     /* 191054 */     // GIR_Coverage, 4704,
     /* 191054 */     GIR_EraseRootFromParent_Done,
     /* 191055 */   // Label 3001: @191055
     /* 191055 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(191108), // Rule ID 4706 //
     /* 191060 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191076 */     // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 191076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 191079 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 191081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191106 */     GIR_RootConstrainSelectedInstOperands,
     /* 191107 */     // GIR_Coverage, 4706,
     /* 191107 */     GIR_EraseRootFromParent_Done,
     /* 191108 */   // Label 3002: @191108
     /* 191108 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(191164), // Rule ID 4708 //
     /* 191113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 191116 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191132 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 191132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
     /* 191135 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 191137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191162 */     GIR_RootConstrainSelectedInstOperands,
     /* 191163 */     // GIR_Coverage, 4708,
     /* 191163 */     GIR_EraseRootFromParent_Done,
     /* 191164 */   // Label 3003: @191164
     /* 191164 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(191217), // Rule ID 4710 //
     /* 191169 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 191185 */     // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 191185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
     /* 191188 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 191190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 191195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 191200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191215 */     GIR_RootConstrainSelectedInstOperands,
     /* 191216 */     // GIR_Coverage, 4710,
     /* 191216 */     GIR_EraseRootFromParent_Done,
     /* 191217 */   // Label 3004: @191217
     /* 191217 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(191330), // Rule ID 8119 //
     /* 191222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 191225 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 191241 */     // (st v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 191241 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 191244 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 191248 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191253 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 191259 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 191264 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 191269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 191272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 191276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191281 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 191287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 191292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 191297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 191300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 191308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 191311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 191316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 191321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191328 */     GIR_RootConstrainSelectedInstOperands,
     /* 191329 */     // GIR_Coverage, 8119,
     /* 191329 */     GIR_EraseRootFromParent_Done,
     /* 191330 */   // Label 3005: @191330
     /* 191330 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(191443), // Rule ID 8123 //
     /* 191335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 191338 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
     /* 191354 */     // (st v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
     /* 191354 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 191357 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 191361 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191366 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
     /* 191372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 191377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 191382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 191385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 191389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191394 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
     /* 191400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 191405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 191410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
     /* 191413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 191421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 191424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
     /* 191429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
     /* 191434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191441 */     GIR_RootConstrainSelectedInstOperands,
     /* 191442 */     // GIR_Coverage, 8123,
     /* 191442 */     GIR_EraseRootFromParent_Done,
     /* 191443 */   // Label 3006: @191443
     /* 191443 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(191496), // Rule ID 3956 //
     /* 191448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 191451 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 191467 */     // (st v8i16:{ *:[v8i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v8i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 191467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 191470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 191475 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 191477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 191482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191494 */     GIR_RootConstrainSelectedInstOperands,
     /* 191495 */     // GIR_Coverage, 3956,
     /* 191495 */     GIR_EraseRootFromParent_Done,
     /* 191496 */   // Label 3007: @191496
     /* 191496 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(191549), // Rule ID 3960 //
     /* 191501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 191504 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 191520 */     // (st v8f16:{ *:[v8f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v8f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 191520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
     /* 191523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 191528 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 191530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 191535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 191540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191547 */     GIR_RootConstrainSelectedInstOperands,
     /* 191548 */     // GIR_Coverage, 3960,
     /* 191548 */     GIR_EraseRootFromParent_Done,
     /* 191549 */   // Label 3008: @191549
     /* 191549 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(191597), // Rule ID 3955 //
     /* 191554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 191557 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 191573 */     // (st v8i16:{ *:[v8i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 191573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 191576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191581 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 191583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191595 */     GIR_RootConstrainSelectedInstOperands,
     /* 191596 */     // GIR_Coverage, 3955,
     /* 191596 */     GIR_EraseRootFromParent_Done,
     /* 191597 */   // Label 3009: @191597
     /* 191597 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(191645), // Rule ID 3959 //
     /* 191602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 191605 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
     /* 191610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 191621 */     // (st v8f16:{ *:[v8f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 191621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
     /* 191624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191629 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 191631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191643 */     GIR_RootConstrainSelectedInstOperands,
     /* 191644 */     // GIR_Coverage, 3959,
     /* 191644 */     GIR_EraseRootFromParent_Done,
     /* 191645 */   // Label 3010: @191645
     /* 191645 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(191694), // Rule ID 3664 //
     /* 191650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 191653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 191659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 191670 */     // (st v8i16:{ *:[v8i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
     /* 191670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 191673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191678 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 191680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191692 */     GIR_RootConstrainSelectedInstOperands,
     /* 191693 */     // GIR_Coverage, 3664,
     /* 191693 */     GIR_EraseRootFromParent_Done,
     /* 191694 */   // Label 3011: @191694
     /* 191694 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(191743), // Rule ID 3666 //
     /* 191699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 191702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
     /* 191708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 191719 */     // (st v8f16:{ *:[v8f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 191719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
     /* 191722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 191727 */     GIR_RootToRootCopy, /*OpIdx*/0, // data
     /* 191729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191741 */     GIR_RootConstrainSelectedInstOperands,
     /* 191742 */     // GIR_Coverage, 3666,
     /* 191742 */     GIR_EraseRootFromParent_Done,
     /* 191743 */   // Label 3012: @191743
     /* 191743 */   GIM_Reject,
     /* 191744 */ // Label 2980: @191744
     /* 191744 */ GIM_Reject,
     /* 191745 */ // Label 2446: @191745
     /* 191745 */ GIM_Reject,
     /* 191746 */ // Label 18: @191746
     /* 191746 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3015*/ GIMT_Encode4(192871),
     /* 191757 */ /*GILLT_s32*//*Label 3013*/ GIMT_Encode4(191765),
     /* 191761 */ /*GILLT_s64*//*Label 3014*/ GIMT_Encode4(192318),
     /* 191765 */ // Label 3013: @191765
     /* 191765 */ GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(192317),
     /* 191770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 191773 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 191776 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(191828), // Rule ID 8270 //
     /* 191781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 191784 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191789 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191802 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$cmp, anonymous_9744:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
     /* 191805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191810 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 191812 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 191814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191826 */     GIR_RootConstrainSelectedInstOperands,
     /* 191827 */     // GIR_Coverage, 8270,
     /* 191827 */     GIR_EraseRootFromParent_Done,
     /* 191828 */   // Label 3017: @191828
     /* 191828 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(191880), // Rule ID 8272 //
     /* 191833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 191836 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191841 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191854 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPST_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$cmp, anonymous_9744:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32_gfx9),
     /* 191857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191862 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 191864 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 191866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191878 */     GIR_RootConstrainSelectedInstOperands,
     /* 191879 */     // GIR_Coverage, 8272,
     /* 191879 */     GIR_EraseRootFromParent_Done,
     /* 191880 */   // Label 3018: @191880
     /* 191880 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(191932), // Rule ID 8274 //
     /* 191885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 191888 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 191893 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191906 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$cmp, anonymous_9744:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 191906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
     /* 191909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191914 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 191916 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 191918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 191926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191930 */     GIR_RootConstrainSelectedInstOperands,
     /* 191931 */     // GIR_Coverage, 8274,
     /* 191931 */     GIR_EraseRootFromParent_Done,
     /* 191932 */   // Label 3019: @191932
     /* 191932 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(191984), // Rule ID 8276 //
     /* 191937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 191940 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 191945 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 191951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 191958 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPSTORE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$swap, anonymous_9744:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 191958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32_gfx9),
     /* 191961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 191966 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 191968 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 191970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 191975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 191978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 191982 */     GIR_RootConstrainSelectedInstOperands,
     /* 191983 */     // GIR_Coverage, 8276,
     /* 191983 */     GIR_EraseRootFromParent_Done,
     /* 191984 */   // Label 3020: @191984
     /* 191984 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(192036), // Rule ID 8278 //
     /* 191989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 191992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 191997 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 191999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192010 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPSTORE_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$swap, anonymous_9744:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32),
     /* 192013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192018 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192020 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192034 */     GIR_RootConstrainSelectedInstOperands,
     /* 192035 */     // GIR_Coverage, 8278,
     /* 192035 */     GIR_EraseRootFromParent_Done,
     /* 192036 */   // Label 3021: @192036
     /* 192036 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(192092), // Rule ID 8269 //
     /* 192041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 192044 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192064 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$cmp, anonymous_9744:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
     /* 192067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192074 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192076 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192090 */     GIR_RootConstrainSelectedInstOperands,
     /* 192091 */     // GIR_Coverage, 8269,
     /* 192091 */     GIR_EraseRootFromParent_Done,
     /* 192092 */   // Label 3022: @192092
     /* 192092 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(192148), // Rule ID 8271 //
     /* 192097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 192100 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192120 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPST_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$cmp, anonymous_9744:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32_gfx9),
     /* 192123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192130 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192132 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192146 */     GIR_RootConstrainSelectedInstOperands,
     /* 192147 */     // GIR_Coverage, 8271,
     /* 192147 */     GIR_EraseRootFromParent_Done,
     /* 192148 */   // Label 3023: @192148
     /* 192148 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(192204), // Rule ID 8273 //
     /* 192153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 192156 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192176 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$cmp, anonymous_9744:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
     /* 192179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192186 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192188 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192202 */     GIR_RootConstrainSelectedInstOperands,
     /* 192203 */     // GIR_Coverage, 8273,
     /* 192203 */     GIR_EraseRootFromParent_Done,
     /* 192204 */   // Label 3024: @192204
     /* 192204 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(192260), // Rule ID 8275 //
     /* 192209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 192212 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192232 */     // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPSTORE_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$swap, anonymous_9744:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32_gfx9),
     /* 192235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192242 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192244 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192258 */     GIR_RootConstrainSelectedInstOperands,
     /* 192259 */     // GIR_Coverage, 8275,
     /* 192259 */     GIR_EraseRootFromParent_Done,
     /* 192260 */   // Label 3025: @192260
     /* 192260 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(192316), // Rule ID 8277 //
     /* 192265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 192268 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 192277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192288 */     // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPSTORE_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$swap, anonymous_9744:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32),
     /* 192291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192298 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192300 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192314 */     GIR_RootConstrainSelectedInstOperands,
     /* 192315 */     // GIR_Coverage, 8277,
     /* 192315 */     GIR_EraseRootFromParent_Done,
     /* 192316 */   // Label 3026: @192316
     /* 192316 */   GIM_Reject,
     /* 192317 */ // Label 3016: @192317
     /* 192317 */ GIM_Reject,
     /* 192318 */ // Label 3014: @192318
     /* 192318 */ GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(192870),
     /* 192323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 192326 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 192329 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(192381), // Rule ID 8445 //
     /* 192334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 192337 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192342 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192355 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$cmp, anonymous_9743:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
     /* 192358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192363 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192365 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192379 */     GIR_RootConstrainSelectedInstOperands,
     /* 192380 */     // GIR_Coverage, 8445,
     /* 192380 */     GIR_EraseRootFromParent_Done,
     /* 192381 */   // Label 3028: @192381
     /* 192381 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(192433), // Rule ID 8447 //
     /* 192386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 192389 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192394 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192407 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPST_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$cmp, anonymous_9743:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64_gfx9),
     /* 192410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192415 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192417 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192431 */     GIR_RootConstrainSelectedInstOperands,
     /* 192432 */     // GIR_Coverage, 8447,
     /* 192432 */     GIR_EraseRootFromParent_Done,
     /* 192433 */   // Label 3029: @192433
     /* 192433 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(192485), // Rule ID 8449 //
     /* 192438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 192441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192446 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192459 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$cmp, anonymous_9743:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
     /* 192462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192467 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192469 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192483 */     GIR_RootConstrainSelectedInstOperands,
     /* 192484 */     // GIR_Coverage, 8449,
     /* 192484 */     GIR_EraseRootFromParent_Done,
     /* 192485 */   // Label 3030: @192485
     /* 192485 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(192537), // Rule ID 8451 //
     /* 192490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 192493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192498 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192511 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPSTORE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$swap, anonymous_9743:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64_gfx9),
     /* 192514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192519 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192521 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192535 */     GIR_RootConstrainSelectedInstOperands,
     /* 192536 */     // GIR_Coverage, 8451,
     /* 192536 */     GIR_EraseRootFromParent_Done,
     /* 192537 */   // Label 3031: @192537
     /* 192537 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(192589), // Rule ID 8453 //
     /* 192542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 192545 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192550 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192563 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPSTORE_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$swap, anonymous_9743:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64),
     /* 192566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192571 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192573 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192587 */     GIR_RootConstrainSelectedInstOperands,
     /* 192588 */     // GIR_Coverage, 8453,
     /* 192588 */     GIR_EraseRootFromParent_Done,
     /* 192589 */   // Label 3032: @192589
     /* 192589 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(192645), // Rule ID 8444 //
     /* 192594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 192597 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192617 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$cmp, anonymous_9743:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
     /* 192620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192627 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192629 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192643 */     GIR_RootConstrainSelectedInstOperands,
     /* 192644 */     // GIR_Coverage, 8444,
     /* 192644 */     GIR_EraseRootFromParent_Done,
     /* 192645 */   // Label 3033: @192645
     /* 192645 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(192701), // Rule ID 8446 //
     /* 192650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
     /* 192653 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192673 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPST_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$cmp, anonymous_9743:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64_gfx9),
     /* 192676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192683 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192685 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192699 */     GIR_RootConstrainSelectedInstOperands,
     /* 192700 */     // GIR_Coverage, 8446,
     /* 192700 */     GIR_EraseRootFromParent_Done,
     /* 192701 */   // Label 3034: @192701
     /* 192701 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(192757), // Rule ID 8448 //
     /* 192706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
     /* 192709 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192729 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$cmp, anonymous_9743:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
     /* 192732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192739 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192741 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192755 */     GIR_RootConstrainSelectedInstOperands,
     /* 192756 */     // GIR_Coverage, 8448,
     /* 192756 */     GIR_EraseRootFromParent_Done,
     /* 192757 */   // Label 3035: @192757
     /* 192757 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(192813), // Rule ID 8450 //
     /* 192762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 192765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 192770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192785 */     // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPSTORE_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$swap, anonymous_9743:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 192785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64_gfx9),
     /* 192788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192795 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192797 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192811 */     GIR_RootConstrainSelectedInstOperands,
     /* 192812 */     // GIR_Coverage, 8450,
     /* 192812 */     GIR_EraseRootFromParent_Done,
     /* 192813 */   // Label 3036: @192813
     /* 192813 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(192869), // Rule ID 8452 //
     /* 192818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
     /* 192821 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 192826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 192830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 192841 */     // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPSTORE_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$swap, anonymous_9743:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 192841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64),
     /* 192844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 192846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 192851 */     GIR_RootToRootCopy, /*OpIdx*/3, // swap
     /* 192853 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /* 192855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 192860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 192863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192867 */     GIR_RootConstrainSelectedInstOperands,
     /* 192868 */     // GIR_Coverage, 8452,
     /* 192868 */     GIR_EraseRootFromParent_Done,
     /* 192869 */   // Label 3037: @192869
     /* 192869 */   GIM_Reject,
     /* 192870 */ // Label 3027: @192870
     /* 192870 */ GIM_Reject,
     /* 192871 */ // Label 3015: @192871
     /* 192871 */ GIM_Reject,
     /* 192872 */ // Label 19: @192872
     /* 192872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3040*/ GIMT_Encode4(195083),
     /* 192883 */ /*GILLT_s32*//*Label 3038*/ GIMT_Encode4(192891),
     /* 192887 */ /*GILLT_s64*//*Label 3039*/ GIMT_Encode4(193987),
     /* 192891 */ // Label 3038: @192891
     /* 192891 */ GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(193986),
     /* 192896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 192899 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(192961), // Rule ID 5589 //
     /* 192904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 192907 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192914 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192927 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64),
     /* 192930 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 192942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 192947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 192952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 192955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 192959 */     GIR_RootConstrainSelectedInstOperands,
     /* 192960 */     // GIR_Coverage, 5589,
     /* 192960 */     GIR_EraseRootFromParent_Done,
     /* 192961 */   // Label 3042: @192961
     /* 192961 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(193020), // Rule ID 5593 //
     /* 192966 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 192973 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 192975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 192979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 192986 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 192986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64),
     /* 192989 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 192991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 192996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193018 */     GIR_RootConstrainSelectedInstOperands,
     /* 193019 */     // GIR_Coverage, 5593,
     /* 193019 */     GIR_EraseRootFromParent_Done,
     /* 193020 */   // Label 3043: @193020
     /* 193020 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(193086), // Rule ID 5585 //
     /* 193025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193028 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193050 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64_RTN),
     /* 193053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 193055 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193084 */     GIR_RootConstrainSelectedInstOperands,
     /* 193085 */     // GIR_Coverage, 5585,
     /* 193085 */     GIR_EraseRootFromParent_Done,
     /* 193086 */   // Label 3044: @193086
     /* 193086 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(193149), // Rule ID 5591 //
     /* 193091 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 193113 */     // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN),
     /* 193116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 193118 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 193125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 193135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 193140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193147 */     GIR_RootConstrainSelectedInstOperands,
     /* 193148 */     // GIR_Coverage, 5591,
     /* 193148 */     GIR_EraseRootFromParent_Done,
     /* 193149 */   // Label 3045: @193149
     /* 193149 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(193206), // Rule ID 5588 //
     /* 193154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193157 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193164 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 193177 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 193180 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 193192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193204 */     GIR_RootConstrainSelectedInstOperands,
     /* 193205 */     // GIR_Coverage, 5588,
     /* 193205 */     GIR_EraseRootFromParent_Done,
     /* 193206 */   // Label 3046: @193206
     /* 193206 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(193260), // Rule ID 5592 //
     /* 193211 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193218 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 193231 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 193234 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 193246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193258 */     GIR_RootConstrainSelectedInstOperands,
     /* 193259 */     // GIR_Coverage, 5592,
     /* 193259 */     GIR_EraseRootFromParent_Done,
     /* 193260 */   // Label 3047: @193260
     /* 193260 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(193321), // Rule ID 5584 //
     /* 193265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 193268 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 193290 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 193293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 193295 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 193307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193319 */     GIR_RootConstrainSelectedInstOperands,
     /* 193320 */     // GIR_Coverage, 5584,
     /* 193320 */     GIR_EraseRootFromParent_Done,
     /* 193321 */   // Label 3048: @193321
     /* 193321 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(193379), // Rule ID 5590 //
     /* 193326 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 193348 */     // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 193348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 193351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 193353 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 193355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 193360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 193365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193377 */     GIR_RootConstrainSelectedInstOperands,
     /* 193378 */     // GIR_Coverage, 5590,
     /* 193378 */     GIR_EraseRootFromParent_Done,
     /* 193379 */   // Label 3049: @193379
     /* 193379 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(193433), // Rule ID 8260 //
     /* 193384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 193387 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 193392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193407 */     // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
     /* 193410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193417 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193431 */     GIR_RootConstrainSelectedInstOperands,
     /* 193432 */     // GIR_Coverage, 8260,
     /* 193432 */     GIR_EraseRootFromParent_Done,
     /* 193433 */   // Label 3050: @193433
     /* 193433 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(193487), // Rule ID 8261 //
     /* 193438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 193441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 193446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193461 */     // (atomic_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_i32>>  =>  (DS_WRXCHG_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 193461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32_gfx9),
     /* 193464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193471 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193485 */     GIR_RootConstrainSelectedInstOperands,
     /* 193486 */     // GIR_Coverage, 8261,
     /* 193486 */     GIR_EraseRootFromParent_Done,
     /* 193487 */   // Label 3051: @193487
     /* 193487 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(193541), // Rule ID 8262 //
     /* 193492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 193495 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 193500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 193515 */     // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_region_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 193515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
     /* 193518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 193525 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 193527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193539 */     GIR_RootConstrainSelectedInstOperands,
     /* 193540 */     // GIR_Coverage, 8262,
     /* 193540 */     GIR_EraseRootFromParent_Done,
     /* 193541 */   // Label 3052: @193541
     /* 193541 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(193598), // Rule ID 4054 //
     /* 193546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193549 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193556 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 193569 */     // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 193569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR),
     /* 193572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 193577 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 193584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193596 */     GIR_RootConstrainSelectedInstOperands,
     /* 193597 */     // GIR_Coverage, 4054,
     /* 193597 */     GIR_EraseRootFromParent_Done,
     /* 193598 */   // Label 3053: @193598
     /* 193598 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(193659), // Rule ID 4056 //
     /* 193603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193606 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 193628 */     // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 193628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR_RTN),
     /* 193631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 193638 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 193645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 193650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193657 */     GIR_RootConstrainSelectedInstOperands,
     /* 193658 */     // GIR_Coverage, 4056,
     /* 193658 */     GIR_EraseRootFromParent_Done,
     /* 193659 */   // Label 3054: @193659
     /* 193659 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(193711), // Rule ID 4053 //
     /* 193664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193667 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193674 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 193687 */     // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 193687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP),
     /* 193690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193695 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193709 */     GIR_RootConstrainSelectedInstOperands,
     /* 193710 */     // GIR_Coverage, 4053,
     /* 193710 */     GIR_EraseRootFromParent_Done,
     /* 193711 */   // Label 3055: @193711
     /* 193711 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(193767), // Rule ID 4055 //
     /* 193716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 193719 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 193741 */     // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 193741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_RTN),
     /* 193744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193751 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193765 */     GIR_RootConstrainSelectedInstOperands,
     /* 193766 */     // GIR_Coverage, 4055,
     /* 193766 */     GIR_EraseRootFromParent_Done,
     /* 193767 */   // Label 3056: @193767
     /* 193767 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(193820), // Rule ID 3692 //
     /* 193772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193775 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193783 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193796 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 193796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
     /* 193799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193804 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193818 */     GIR_RootConstrainSelectedInstOperands,
     /* 193819 */     // GIR_Coverage, 3692,
     /* 193819 */     GIR_EraseRootFromParent_Done,
     /* 193820 */   // Label 3057: @193820
     /* 193820 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(193872), // Rule ID 3752 //
     /* 193825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193828 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193835 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 193837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193848 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 193848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
     /* 193851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193856 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 193866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193870 */     GIR_RootConstrainSelectedInstOperands,
     /* 193871 */     // GIR_Coverage, 3752,
     /* 193871 */     GIR_EraseRootFromParent_Done,
     /* 193872 */   // Label 3058: @193872
     /* 193872 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(193929), // Rule ID 3691 //
     /* 193877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193903 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 193903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
     /* 193906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193913 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193927 */     GIR_RootConstrainSelectedInstOperands,
     /* 193928 */     // GIR_Coverage, 3691,
     /* 193928 */     GIR_EraseRootFromParent_Done,
     /* 193929 */   // Label 3059: @193929
     /* 193929 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(193985), // Rule ID 3751 //
     /* 193934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 193937 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 193944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 193948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 193952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 193959 */     // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 193959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
     /* 193962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 193964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 193969 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 193971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 193976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 193979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 193983 */     GIR_RootConstrainSelectedInstOperands,
     /* 193984 */     // GIR_Coverage, 3751,
     /* 193984 */     GIR_EraseRootFromParent_Done,
     /* 193985 */   // Label 3060: @193985
     /* 193985 */   GIM_Reject,
     /* 193986 */ // Label 3041: @193986
     /* 193986 */ GIM_Reject,
     /* 193987 */ // Label 3039: @193987
     /* 193987 */ GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(195082),
     /* 193992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193995 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(194057), // Rule ID 5685 //
     /* 194000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194003 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194010 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194023 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64),
     /* 194026 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194055 */     GIR_RootConstrainSelectedInstOperands,
     /* 194056 */     // GIR_Coverage, 5685,
     /* 194056 */     GIR_EraseRootFromParent_Done,
     /* 194057 */   // Label 3062: @194057
     /* 194057 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(194116), // Rule ID 5689 //
     /* 194062 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194069 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194082 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64),
     /* 194085 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194114 */     GIR_RootConstrainSelectedInstOperands,
     /* 194115 */     // GIR_Coverage, 5689,
     /* 194115 */     GIR_EraseRootFromParent_Done,
     /* 194116 */   // Label 3063: @194116
     /* 194116 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(194182), // Rule ID 5683 //
     /* 194121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194124 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194146 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN),
     /* 194149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194151 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194180 */     GIR_RootConstrainSelectedInstOperands,
     /* 194181 */     // GIR_Coverage, 5683,
     /* 194181 */     GIR_EraseRootFromParent_Done,
     /* 194182 */   // Label 3064: @194182
     /* 194182 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(194245), // Rule ID 5687 //
     /* 194187 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 194209 */     // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN),
     /* 194212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194214 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 194221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 194231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 194236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194243 */     GIR_RootConstrainSelectedInstOperands,
     /* 194244 */     // GIR_Coverage, 5687,
     /* 194244 */     GIR_EraseRootFromParent_Done,
     /* 194245 */   // Label 3065: @194245
     /* 194245 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(194302), // Rule ID 5684 //
     /* 194250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194260 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194273 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
     /* 194276 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194300 */     GIR_RootConstrainSelectedInstOperands,
     /* 194301 */     // GIR_Coverage, 5684,
     /* 194301 */     GIR_EraseRootFromParent_Done,
     /* 194302 */   // Label 3066: @194302
     /* 194302 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(194356), // Rule ID 5688 //
     /* 194307 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194314 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194327 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
     /* 194330 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194354 */     GIR_RootConstrainSelectedInstOperands,
     /* 194355 */     // GIR_Coverage, 5688,
     /* 194355 */     GIR_EraseRootFromParent_Done,
     /* 194356 */   // Label 3067: @194356
     /* 194356 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(194417), // Rule ID 5682 //
     /* 194361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 194364 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194386 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
     /* 194389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194391 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194415 */     GIR_RootConstrainSelectedInstOperands,
     /* 194416 */     // GIR_Coverage, 5682,
     /* 194416 */     GIR_EraseRootFromParent_Done,
     /* 194417 */   // Label 3068: @194417
     /* 194417 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(194475), // Rule ID 5686 //
     /* 194422 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 194444 */     // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 194444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
     /* 194447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 194449 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 194451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 194456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 194461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194473 */     GIR_RootConstrainSelectedInstOperands,
     /* 194474 */     // GIR_Coverage, 5686,
     /* 194474 */     GIR_EraseRootFromParent_Done,
     /* 194475 */   // Label 3069: @194475
     /* 194475 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(194529), // Rule ID 8363 //
     /* 194480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 194483 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194503 */     // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
     /* 194506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194513 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194527 */     GIR_RootConstrainSelectedInstOperands,
     /* 194528 */     // GIR_Coverage, 8363,
     /* 194528 */     GIR_EraseRootFromParent_Done,
     /* 194529 */   // Label 3070: @194529
     /* 194529 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(194583), // Rule ID 8364 //
     /* 194534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 194537 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 194542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194557 */     // (atomic_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_i64>>  =>  (DS_WRXCHG_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 194557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64_gfx9),
     /* 194560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194567 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194581 */     GIR_RootConstrainSelectedInstOperands,
     /* 194582 */     // GIR_Coverage, 8364,
     /* 194582 */     GIR_EraseRootFromParent_Done,
     /* 194583 */   // Label 3071: @194583
     /* 194583 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(194637), // Rule ID 8365 //
     /* 194588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 194591 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 194596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 194611 */     // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_region_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 194611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
     /* 194614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 194621 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 194623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194635 */     GIR_RootConstrainSelectedInstOperands,
     /* 194636 */     // GIR_Coverage, 8365,
     /* 194636 */     GIR_EraseRootFromParent_Done,
     /* 194637 */   // Label 3072: @194637
     /* 194637 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(194694), // Rule ID 4110 //
     /* 194642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194645 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194652 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 194665 */     // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 194665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR),
     /* 194668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 194673 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 194680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194692 */     GIR_RootConstrainSelectedInstOperands,
     /* 194693 */     // GIR_Coverage, 4110,
     /* 194693 */     GIR_EraseRootFromParent_Done,
     /* 194694 */   // Label 3073: @194694
     /* 194694 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(194755), // Rule ID 4112 //
     /* 194699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 194724 */     // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 194724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN),
     /* 194727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 194734 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 194741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 194746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194753 */     GIR_RootConstrainSelectedInstOperands,
     /* 194754 */     // GIR_Coverage, 4112,
     /* 194754 */     GIR_EraseRootFromParent_Done,
     /* 194755 */   // Label 3074: @194755
     /* 194755 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(194807), // Rule ID 4109 //
     /* 194760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194763 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194770 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 194783 */     // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 194783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2),
     /* 194786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194791 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194805 */     GIR_RootConstrainSelectedInstOperands,
     /* 194806 */     // GIR_Coverage, 4109,
     /* 194806 */     GIR_EraseRootFromParent_Done,
     /* 194807 */   // Label 3075: @194807
     /* 194807 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(194863), // Rule ID 4111 //
     /* 194812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 194815 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 194837 */     // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 194837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_RTN),
     /* 194840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 194842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194847 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 194857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194861 */     GIR_RootConstrainSelectedInstOperands,
     /* 194862 */     // GIR_Coverage, 4111,
     /* 194862 */     GIR_EraseRootFromParent_Done,
     /* 194863 */   // Label 3076: @194863
     /* 194863 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(194916), // Rule ID 3718 //
     /* 194868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194871 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194879 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194892 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 194892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
     /* 194895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194900 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194914 */     GIR_RootConstrainSelectedInstOperands,
     /* 194915 */     // GIR_Coverage, 3718,
     /* 194915 */     GIR_EraseRootFromParent_Done,
     /* 194916 */   // Label 3077: @194916
     /* 194916 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(194968), // Rule ID 3778 //
     /* 194921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194924 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194931 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 194933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194944 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 194944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
     /* 194947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 194952 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 194954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 194959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 194962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 194966 */     GIR_RootConstrainSelectedInstOperands,
     /* 194967 */     // GIR_Coverage, 3778,
     /* 194967 */     GIR_EraseRootFromParent_Done,
     /* 194968 */   // Label 3078: @194968
     /* 194968 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(195025), // Rule ID 3717 //
     /* 194973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 194976 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 194984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 194988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 194992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 194999 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 194999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
     /* 195002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195009 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195023 */     GIR_RootConstrainSelectedInstOperands,
     /* 195024 */     // GIR_Coverage, 3717,
     /* 195024 */     GIR_EraseRootFromParent_Done,
     /* 195025 */   // Label 3079: @195025
     /* 195025 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(195081), // Rule ID 3777 //
     /* 195030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 195033 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 195044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 195055 */     // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 195055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
     /* 195058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 195065 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195079 */     GIR_RootConstrainSelectedInstOperands,
     /* 195080 */     // GIR_Coverage, 3777,
     /* 195080 */     GIR_EraseRootFromParent_Done,
     /* 195081 */   // Label 3080: @195081
     /* 195081 */   GIM_Reject,
     /* 195082 */ // Label 3061: @195082
     /* 195082 */ GIM_Reject,
     /* 195083 */ // Label 3040: @195083
     /* 195083 */ GIM_Reject,
     /* 195084 */ // Label 20: @195084
     /* 195084 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3083*/ GIMT_Encode4(197595),
     /* 195095 */ /*GILLT_s32*//*Label 3081*/ GIMT_Encode4(195103),
     /* 195099 */ /*GILLT_s64*//*Label 3082*/ GIMT_Encode4(196349),
     /* 195103 */ // Label 3081: @195103
     /* 195103 */ GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(196348),
     /* 195108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195111 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(195173), // Rule ID 5597 //
     /* 195116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195119 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195126 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195139 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64),
     /* 195142 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195171 */     GIR_RootConstrainSelectedInstOperands,
     /* 195172 */     // GIR_Coverage, 5597,
     /* 195172 */     GIR_EraseRootFromParent_Done,
     /* 195173 */   // Label 3085: @195173
     /* 195173 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(195232), // Rule ID 5601 //
     /* 195178 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195185 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195198 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64),
     /* 195201 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195230 */     GIR_RootConstrainSelectedInstOperands,
     /* 195231 */     // GIR_Coverage, 5601,
     /* 195231 */     GIR_EraseRootFromParent_Done,
     /* 195232 */   // Label 3086: @195232
     /* 195232 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(195298), // Rule ID 5595 //
     /* 195237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195240 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195262 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64_RTN),
     /* 195265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195267 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195296 */     GIR_RootConstrainSelectedInstOperands,
     /* 195297 */     // GIR_Coverage, 5595,
     /* 195297 */     GIR_EraseRootFromParent_Done,
     /* 195298 */   // Label 3087: @195298
     /* 195298 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(195361), // Rule ID 5599 //
     /* 195303 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 195325 */     // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN),
     /* 195328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195330 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 195337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 195347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 195352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195359 */     GIR_RootConstrainSelectedInstOperands,
     /* 195360 */     // GIR_Coverage, 5599,
     /* 195360 */     GIR_EraseRootFromParent_Done,
     /* 195361 */   // Label 3088: @195361
     /* 195361 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(195418), // Rule ID 5596 //
     /* 195366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195369 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195376 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195389 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
     /* 195392 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195416 */     GIR_RootConstrainSelectedInstOperands,
     /* 195417 */     // GIR_Coverage, 5596,
     /* 195417 */     GIR_EraseRootFromParent_Done,
     /* 195418 */   // Label 3089: @195418
     /* 195418 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(195472), // Rule ID 5600 //
     /* 195423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195430 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195443 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
     /* 195446 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195470 */     GIR_RootConstrainSelectedInstOperands,
     /* 195471 */     // GIR_Coverage, 5600,
     /* 195471 */     GIR_EraseRootFromParent_Done,
     /* 195472 */   // Label 3090: @195472
     /* 195472 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(195533), // Rule ID 5594 //
     /* 195477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 195480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195502 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
     /* 195505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195507 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195531 */     GIR_RootConstrainSelectedInstOperands,
     /* 195532 */     // GIR_Coverage, 5594,
     /* 195532 */     GIR_EraseRootFromParent_Done,
     /* 195533 */   // Label 3091: @195533
     /* 195533 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(195591), // Rule ID 5598 //
     /* 195538 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 195560 */     // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 195560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
     /* 195563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 195565 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 195567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 195572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 195577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195589 */     GIR_RootConstrainSelectedInstOperands,
     /* 195590 */     // GIR_Coverage, 5598,
     /* 195590 */     GIR_EraseRootFromParent_Done,
     /* 195591 */   // Label 3092: @195591
     /* 195591 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(195641), // Rule ID 8264 //
     /* 195596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 195599 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195604 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195617 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
     /* 195620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195625 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195639 */     GIR_RootConstrainSelectedInstOperands,
     /* 195640 */     // GIR_Coverage, 8264,
     /* 195640 */     GIR_EraseRootFromParent_Done,
     /* 195641 */   // Label 3093: @195641
     /* 195641 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(195691), // Rule ID 8266 //
     /* 195646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 195649 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195654 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195667 */     // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_noret_i32>>  =>  (DS_ADD_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32_gfx9),
     /* 195670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195675 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195689 */     GIR_RootConstrainSelectedInstOperands,
     /* 195690 */     // GIR_Coverage, 8266,
     /* 195690 */     GIR_EraseRootFromParent_Done,
     /* 195691 */   // Label 3094: @195691
     /* 195691 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(195741), // Rule ID 8268 //
     /* 195696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 195699 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 195704 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195717 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 195717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
     /* 195720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195725 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195739 */     GIR_RootConstrainSelectedInstOperands,
     /* 195740 */     // GIR_Coverage, 8268,
     /* 195740 */     GIR_EraseRootFromParent_Done,
     /* 195741 */   // Label 3095: @195741
     /* 195741 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(195795), // Rule ID 8263 //
     /* 195746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 195749 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195769 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
     /* 195772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195779 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195793 */     GIR_RootConstrainSelectedInstOperands,
     /* 195794 */     // GIR_Coverage, 8263,
     /* 195794 */     GIR_EraseRootFromParent_Done,
     /* 195795 */   // Label 3096: @195795
     /* 195795 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(195849), // Rule ID 8265 //
     /* 195800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 195803 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 195808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195823 */     // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_i32>>  =>  (DS_ADD_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 195823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32_gfx9),
     /* 195826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195833 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195847 */     GIR_RootConstrainSelectedInstOperands,
     /* 195848 */     // GIR_Coverage, 8265,
     /* 195848 */     GIR_EraseRootFromParent_Done,
     /* 195849 */   // Label 3097: @195849
     /* 195849 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(195903), // Rule ID 8267 //
     /* 195854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 195857 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 195862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 195877 */     // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 195877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
     /* 195880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 195887 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 195889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 195894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 195897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195901 */     GIR_RootConstrainSelectedInstOperands,
     /* 195902 */     // GIR_Coverage, 8267,
     /* 195902 */     GIR_EraseRootFromParent_Done,
     /* 195903 */   // Label 3098: @195903
     /* 195903 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(195960), // Rule ID 3563 //
     /* 195908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195911 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195918 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 195920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 195931 */     // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 195931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR),
     /* 195934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 195939 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 195941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 195946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 195951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 195954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 195958 */     GIR_RootConstrainSelectedInstOperands,
     /* 195959 */     // GIR_Coverage, 3563,
     /* 195959 */     GIR_EraseRootFromParent_Done,
     /* 195960 */   // Label 3099: @195960
     /* 195960 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(196021), // Rule ID 3565 //
     /* 195965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 195968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 195975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 195979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 195983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 195990 */     // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 195990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR_RTN),
     /* 195993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 195995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 196000 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 196007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196019 */     GIR_RootConstrainSelectedInstOperands,
     /* 196020 */     // GIR_Coverage, 3565,
     /* 196020 */     GIR_EraseRootFromParent_Done,
     /* 196021 */   // Label 3100: @196021
     /* 196021 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(196073), // Rule ID 3562 //
     /* 196026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 196029 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196036 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 196049 */     // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 196049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD),
     /* 196052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196057 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196071 */     GIR_RootConstrainSelectedInstOperands,
     /* 196072 */     // GIR_Coverage, 3562,
     /* 196072 */     GIR_EraseRootFromParent_Done,
     /* 196073 */   // Label 3101: @196073
     /* 196073 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(196129), // Rule ID 3564 //
     /* 196078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 196081 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 196103 */     // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 196103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_RTN),
     /* 196106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196113 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196127 */     GIR_RootConstrainSelectedInstOperands,
     /* 196128 */     // GIR_Coverage, 3564,
     /* 196128 */     GIR_EraseRootFromParent_Done,
     /* 196129 */   // Label 3102: @196129
     /* 196129 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(196182), // Rule ID 3550 //
     /* 196134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196137 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196145 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196158 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 196158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
     /* 196161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196166 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196180 */     GIR_RootConstrainSelectedInstOperands,
     /* 196181 */     // GIR_Coverage, 3550,
     /* 196181 */     GIR_EraseRootFromParent_Done,
     /* 196182 */   // Label 3103: @196182
     /* 196182 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(196234), // Rule ID 3732 //
     /* 196187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196190 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196197 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196210 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 196210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
     /* 196213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196218 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196232 */     GIR_RootConstrainSelectedInstOperands,
     /* 196233 */     // GIR_Coverage, 3732,
     /* 196233 */     GIR_EraseRootFromParent_Done,
     /* 196234 */   // Label 3104: @196234
     /* 196234 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(196291), // Rule ID 3551 //
     /* 196239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196242 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196265 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 196265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
     /* 196268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196275 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196289 */     GIR_RootConstrainSelectedInstOperands,
     /* 196290 */     // GIR_Coverage, 3551,
     /* 196290 */     GIR_EraseRootFromParent_Done,
     /* 196291 */   // Label 3105: @196291
     /* 196291 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(196347), // Rule ID 3731 //
     /* 196296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 196299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 196310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 196321 */     // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 196321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
     /* 196324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 196326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 196331 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 196333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196345 */     GIR_RootConstrainSelectedInstOperands,
     /* 196346 */     // GIR_Coverage, 3731,
     /* 196346 */     GIR_EraseRootFromParent_Done,
     /* 196347 */   // Label 3106: @196347
     /* 196347 */   GIM_Reject,
     /* 196348 */ // Label 3084: @196348
     /* 196348 */ GIM_Reject,
     /* 196349 */ // Label 3082: @196349
     /* 196349 */ GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(197594),
     /* 196354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196357 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(196419), // Rule ID 5693 //
     /* 196362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196365 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196372 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196385 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64),
     /* 196388 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196417 */     GIR_RootConstrainSelectedInstOperands,
     /* 196418 */     // GIR_Coverage, 5693,
     /* 196418 */     GIR_EraseRootFromParent_Done,
     /* 196419 */   // Label 3108: @196419
     /* 196419 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(196478), // Rule ID 5697 //
     /* 196424 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196431 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196444 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64),
     /* 196447 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196476 */     GIR_RootConstrainSelectedInstOperands,
     /* 196477 */     // GIR_Coverage, 5697,
     /* 196477 */     GIR_EraseRootFromParent_Done,
     /* 196478 */   // Label 3109: @196478
     /* 196478 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(196544), // Rule ID 5691 //
     /* 196483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196486 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196508 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64_RTN),
     /* 196511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196513 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196542 */     GIR_RootConstrainSelectedInstOperands,
     /* 196543 */     // GIR_Coverage, 5691,
     /* 196543 */     GIR_EraseRootFromParent_Done,
     /* 196544 */   // Label 3110: @196544
     /* 196544 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(196607), // Rule ID 5695 //
     /* 196549 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 196571 */     // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN),
     /* 196574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196576 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 196583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 196593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 196598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196605 */     GIR_RootConstrainSelectedInstOperands,
     /* 196606 */     // GIR_Coverage, 5695,
     /* 196606 */     GIR_EraseRootFromParent_Done,
     /* 196607 */   // Label 3111: @196607
     /* 196607 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(196664), // Rule ID 5692 //
     /* 196612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196615 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196622 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196635 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
     /* 196638 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196662 */     GIR_RootConstrainSelectedInstOperands,
     /* 196663 */     // GIR_Coverage, 5692,
     /* 196663 */     GIR_EraseRootFromParent_Done,
     /* 196664 */   // Label 3112: @196664
     /* 196664 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(196718), // Rule ID 5696 //
     /* 196669 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196676 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196689 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
     /* 196692 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196716 */     GIR_RootConstrainSelectedInstOperands,
     /* 196717 */     // GIR_Coverage, 5696,
     /* 196717 */     GIR_EraseRootFromParent_Done,
     /* 196718 */   // Label 3113: @196718
     /* 196718 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(196779), // Rule ID 5690 //
     /* 196723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 196726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196748 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
     /* 196751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196753 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196777 */     GIR_RootConstrainSelectedInstOperands,
     /* 196778 */     // GIR_Coverage, 5690,
     /* 196778 */     GIR_EraseRootFromParent_Done,
     /* 196779 */   // Label 3114: @196779
     /* 196779 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(196837), // Rule ID 5694 //
     /* 196784 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 196791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 196795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 196806 */     // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 196806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
     /* 196809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 196811 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 196813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 196818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 196823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 196828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196835 */     GIR_RootConstrainSelectedInstOperands,
     /* 196836 */     // GIR_Coverage, 5694,
     /* 196836 */     GIR_EraseRootFromParent_Done,
     /* 196837 */   // Label 3115: @196837
     /* 196837 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(196887), // Rule ID 8367 //
     /* 196842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 196845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196850 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196863 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
     /* 196866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196871 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196885 */     GIR_RootConstrainSelectedInstOperands,
     /* 196886 */     // GIR_Coverage, 8367,
     /* 196886 */     GIR_EraseRootFromParent_Done,
     /* 196887 */   // Label 3116: @196887
     /* 196887 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(196937), // Rule ID 8369 //
     /* 196892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 196895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 196900 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196913 */     // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_noret_i64>>  =>  (DS_ADD_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 196913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64_gfx9),
     /* 196916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196921 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 196931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196935 */     GIR_RootConstrainSelectedInstOperands,
     /* 196936 */     // GIR_Coverage, 8369,
     /* 196936 */     GIR_EraseRootFromParent_Done,
     /* 196937 */   // Label 3117: @196937
     /* 196937 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(196987), // Rule ID 8371 //
     /* 196942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 196945 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 196950 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 196952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 196956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 196963 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 196963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
     /* 196966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 196971 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 196973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 196978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 196981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 196985 */     GIR_RootConstrainSelectedInstOperands,
     /* 196986 */     // GIR_Coverage, 8371,
     /* 196986 */     GIR_EraseRootFromParent_Done,
     /* 196987 */   // Label 3118: @196987
     /* 196987 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(197041), // Rule ID 8366 //
     /* 196992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 196995 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 197000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197015 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 197015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
     /* 197018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197025 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197039 */     GIR_RootConstrainSelectedInstOperands,
     /* 197040 */     // GIR_Coverage, 8366,
     /* 197040 */     GIR_EraseRootFromParent_Done,
     /* 197041 */   // Label 3119: @197041
     /* 197041 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(197095), // Rule ID 8368 //
     /* 197046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 197049 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 197054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197069 */     // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_i64>>  =>  (DS_ADD_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 197069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64_gfx9),
     /* 197072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197079 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197093 */     GIR_RootConstrainSelectedInstOperands,
     /* 197094 */     // GIR_Coverage, 8368,
     /* 197094 */     GIR_EraseRootFromParent_Done,
     /* 197095 */   // Label 3120: @197095
     /* 197095 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(197149), // Rule ID 8370 //
     /* 197100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 197103 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 197108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 197123 */     // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 197123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
     /* 197126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 197133 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 197135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197147 */     GIR_RootConstrainSelectedInstOperands,
     /* 197148 */     // GIR_Coverage, 8370,
     /* 197148 */     GIR_EraseRootFromParent_Done,
     /* 197149 */   // Label 3121: @197149
     /* 197149 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(197206), // Rule ID 4070 //
     /* 197154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197157 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197164 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 197177 */     // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 197177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR),
     /* 197180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 197185 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 197192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197204 */     GIR_RootConstrainSelectedInstOperands,
     /* 197205 */     // GIR_Coverage, 4070,
     /* 197205 */     GIR_EraseRootFromParent_Done,
     /* 197206 */   // Label 3122: @197206
     /* 197206 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(197267), // Rule ID 4072 //
     /* 197211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 197236 */     // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 197236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR_RTN),
     /* 197239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 197246 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 197253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197265 */     GIR_RootConstrainSelectedInstOperands,
     /* 197266 */     // GIR_Coverage, 4072,
     /* 197266 */     GIR_EraseRootFromParent_Done,
     /* 197267 */   // Label 3123: @197267
     /* 197267 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(197319), // Rule ID 4069 //
     /* 197272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197275 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197282 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 197295 */     // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 197295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2),
     /* 197298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197303 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197317 */     GIR_RootConstrainSelectedInstOperands,
     /* 197318 */     // GIR_Coverage, 4069,
     /* 197318 */     GIR_EraseRootFromParent_Done,
     /* 197319 */   // Label 3124: @197319
     /* 197319 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(197375), // Rule ID 4071 //
     /* 197324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 197327 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 197349 */     // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 197349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_RTN),
     /* 197352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197359 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197373 */     GIR_RootConstrainSelectedInstOperands,
     /* 197374 */     // GIR_Coverage, 4071,
     /* 197374 */     GIR_EraseRootFromParent_Done,
     /* 197375 */   // Label 3125: @197375
     /* 197375 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(197428), // Rule ID 3698 //
     /* 197380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197383 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197391 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197404 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 197404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
     /* 197407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197412 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197426 */     GIR_RootConstrainSelectedInstOperands,
     /* 197427 */     // GIR_Coverage, 3698,
     /* 197427 */     GIR_EraseRootFromParent_Done,
     /* 197428 */   // Label 3126: @197428
     /* 197428 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(197480), // Rule ID 3758 //
     /* 197433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197436 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197443 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197456 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 197456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
     /* 197459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197464 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197478 */     GIR_RootConstrainSelectedInstOperands,
     /* 197479 */     // GIR_Coverage, 3758,
     /* 197479 */     GIR_EraseRootFromParent_Done,
     /* 197480 */   // Label 3127: @197480
     /* 197480 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(197537), // Rule ID 3697 //
     /* 197485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197488 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197511 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 197511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
     /* 197514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197521 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197535 */     GIR_RootConstrainSelectedInstOperands,
     /* 197536 */     // GIR_Coverage, 3697,
     /* 197536 */     GIR_EraseRootFromParent_Done,
     /* 197537 */   // Label 3128: @197537
     /* 197537 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(197593), // Rule ID 3757 //
     /* 197542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 197545 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 197556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 197567 */     // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 197567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
     /* 197570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 197572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 197577 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 197579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 197584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197591 */     GIR_RootConstrainSelectedInstOperands,
     /* 197592 */     // GIR_Coverage, 3757,
     /* 197592 */     GIR_EraseRootFromParent_Done,
     /* 197593 */   // Label 3129: @197593
     /* 197593 */   GIM_Reject,
     /* 197594 */ // Label 3107: @197594
     /* 197594 */ GIM_Reject,
     /* 197595 */ // Label 3083: @197595
     /* 197595 */ GIM_Reject,
     /* 197596 */ // Label 21: @197596
     /* 197596 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3132*/ GIMT_Encode4(200107),
     /* 197607 */ /*GILLT_s32*//*Label 3130*/ GIMT_Encode4(197615),
     /* 197611 */ /*GILLT_s64*//*Label 3131*/ GIMT_Encode4(198861),
     /* 197615 */ // Label 3130: @197615
     /* 197615 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(198860),
     /* 197620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197623 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(197685), // Rule ID 5605 //
     /* 197628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197631 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197638 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197651 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64),
     /* 197654 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197683 */     GIR_RootConstrainSelectedInstOperands,
     /* 197684 */     // GIR_Coverage, 5605,
     /* 197684 */     GIR_EraseRootFromParent_Done,
     /* 197685 */   // Label 3134: @197685
     /* 197685 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(197744), // Rule ID 5609 //
     /* 197690 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197697 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197710 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64),
     /* 197713 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197742 */     GIR_RootConstrainSelectedInstOperands,
     /* 197743 */     // GIR_Coverage, 5609,
     /* 197743 */     GIR_EraseRootFromParent_Done,
     /* 197744 */   // Label 3135: @197744
     /* 197744 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(197810), // Rule ID 5603 //
     /* 197749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197752 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197763 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197774 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64_RTN),
     /* 197777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197779 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197808 */     GIR_RootConstrainSelectedInstOperands,
     /* 197809 */     // GIR_Coverage, 5603,
     /* 197809 */     GIR_EraseRootFromParent_Done,
     /* 197810 */   // Label 3136: @197810
     /* 197810 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(197873), // Rule ID 5607 //
     /* 197815 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 197826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 197837 */     // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN),
     /* 197840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 197842 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 197849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 197859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 197864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 197867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197871 */     GIR_RootConstrainSelectedInstOperands,
     /* 197872 */     // GIR_Coverage, 5607,
     /* 197872 */     GIR_EraseRootFromParent_Done,
     /* 197873 */   // Label 3137: @197873
     /* 197873 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(197930), // Rule ID 5604 //
     /* 197878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197881 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197888 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197901 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
     /* 197904 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197928 */     GIR_RootConstrainSelectedInstOperands,
     /* 197929 */     // GIR_Coverage, 5604,
     /* 197929 */     GIR_EraseRootFromParent_Done,
     /* 197930 */   // Label 3138: @197930
     /* 197930 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(197984), // Rule ID 5608 //
     /* 197935 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197942 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 197944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 197948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 197955 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 197955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
     /* 197958 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 197960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 197965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 197970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 197975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 197978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 197982 */     GIR_RootConstrainSelectedInstOperands,
     /* 197983 */     // GIR_Coverage, 5608,
     /* 197983 */     GIR_EraseRootFromParent_Done,
     /* 197984 */   // Label 3139: @197984
     /* 197984 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(198045), // Rule ID 5602 //
     /* 197989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 197992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 197999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 198014 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
     /* 198017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 198019 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 198031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198043 */     GIR_RootConstrainSelectedInstOperands,
     /* 198044 */     // GIR_Coverage, 5602,
     /* 198044 */     GIR_EraseRootFromParent_Done,
     /* 198045 */   // Label 3140: @198045
     /* 198045 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(198103), // Rule ID 5606 //
     /* 198050 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 198072 */     // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
     /* 198075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 198077 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 198089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198101 */     GIR_RootConstrainSelectedInstOperands,
     /* 198102 */     // GIR_Coverage, 5606,
     /* 198102 */     GIR_EraseRootFromParent_Done,
     /* 198103 */   // Label 3141: @198103
     /* 198103 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(198153), // Rule ID 8280 //
     /* 198108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 198111 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198116 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198129 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
     /* 198132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198137 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198151 */     GIR_RootConstrainSelectedInstOperands,
     /* 198152 */     // GIR_Coverage, 8280,
     /* 198152 */     GIR_EraseRootFromParent_Done,
     /* 198153 */   // Label 3142: @198153
     /* 198153 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(198203), // Rule ID 8282 //
     /* 198158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 198161 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198166 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198179 */     // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i32>>  =>  (DS_SUB_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32_gfx9),
     /* 198182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198187 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198201 */     GIR_RootConstrainSelectedInstOperands,
     /* 198202 */     // GIR_Coverage, 8282,
     /* 198202 */     GIR_EraseRootFromParent_Done,
     /* 198203 */   // Label 3143: @198203
     /* 198203 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(198253), // Rule ID 8284 //
     /* 198208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 198211 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 198216 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198229 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 198229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
     /* 198232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198237 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198251 */     GIR_RootConstrainSelectedInstOperands,
     /* 198252 */     // GIR_Coverage, 8284,
     /* 198252 */     GIR_EraseRootFromParent_Done,
     /* 198253 */   // Label 3144: @198253
     /* 198253 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(198307), // Rule ID 8279 //
     /* 198258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 198261 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198281 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
     /* 198284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198291 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198305 */     GIR_RootConstrainSelectedInstOperands,
     /* 198306 */     // GIR_Coverage, 8279,
     /* 198306 */     GIR_EraseRootFromParent_Done,
     /* 198307 */   // Label 3145: @198307
     /* 198307 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(198361), // Rule ID 8281 //
     /* 198312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 198315 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 198320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198335 */     // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_i32>>  =>  (DS_SUB_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 198335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32_gfx9),
     /* 198338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198345 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198359 */     GIR_RootConstrainSelectedInstOperands,
     /* 198360 */     // GIR_Coverage, 8281,
     /* 198360 */     GIR_EraseRootFromParent_Done,
     /* 198361 */   // Label 3146: @198361
     /* 198361 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(198415), // Rule ID 8283 //
     /* 198366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 198369 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 198374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 198389 */     // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 198389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
     /* 198392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 198399 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 198401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198413 */     GIR_RootConstrainSelectedInstOperands,
     /* 198414 */     // GIR_Coverage, 8283,
     /* 198414 */     GIR_EraseRootFromParent_Done,
     /* 198415 */   // Label 3147: @198415
     /* 198415 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(198472), // Rule ID 4018 //
     /* 198420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198430 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 198443 */     // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 198443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR),
     /* 198446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 198451 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 198458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198470 */     GIR_RootConstrainSelectedInstOperands,
     /* 198471 */     // GIR_Coverage, 4018,
     /* 198471 */     GIR_EraseRootFromParent_Done,
     /* 198472 */   // Label 3148: @198472
     /* 198472 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(198533), // Rule ID 4020 //
     /* 198477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 198502 */     // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 198502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR_RTN),
     /* 198505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 198512 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 198519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 198524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198531 */     GIR_RootConstrainSelectedInstOperands,
     /* 198532 */     // GIR_Coverage, 4020,
     /* 198532 */     GIR_EraseRootFromParent_Done,
     /* 198533 */   // Label 3149: @198533
     /* 198533 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(198585), // Rule ID 4017 //
     /* 198538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198541 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198548 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 198561 */     // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 198561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB),
     /* 198564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198569 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198583 */     GIR_RootConstrainSelectedInstOperands,
     /* 198584 */     // GIR_Coverage, 4017,
     /* 198584 */     GIR_EraseRootFromParent_Done,
     /* 198585 */   // Label 3150: @198585
     /* 198585 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(198641), // Rule ID 4019 //
     /* 198590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 198593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 198615 */     // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 198615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_RTN),
     /* 198618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198625 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198639 */     GIR_RootConstrainSelectedInstOperands,
     /* 198640 */     // GIR_Coverage, 4019,
     /* 198640 */     GIR_EraseRootFromParent_Done,
     /* 198641 */   // Label 3151: @198641
     /* 198641 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(198694), // Rule ID 3674 //
     /* 198646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198649 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198657 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198670 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 198670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
     /* 198673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198678 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198692 */     GIR_RootConstrainSelectedInstOperands,
     /* 198693 */     // GIR_Coverage, 3674,
     /* 198693 */     GIR_EraseRootFromParent_Done,
     /* 198694 */   // Label 3152: @198694
     /* 198694 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(198746), // Rule ID 3734 //
     /* 198699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198709 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198722 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 198722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
     /* 198725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198730 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198744 */     GIR_RootConstrainSelectedInstOperands,
     /* 198745 */     // GIR_Coverage, 3734,
     /* 198745 */     GIR_EraseRootFromParent_Done,
     /* 198746 */   // Label 3153: @198746
     /* 198746 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(198803), // Rule ID 3673 //
     /* 198751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198754 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198777 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 198777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
     /* 198780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198787 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198801 */     GIR_RootConstrainSelectedInstOperands,
     /* 198802 */     // GIR_Coverage, 3673,
     /* 198802 */     GIR_EraseRootFromParent_Done,
     /* 198803 */   // Label 3154: @198803
     /* 198803 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(198859), // Rule ID 3733 //
     /* 198808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 198811 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 198822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 198833 */     // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 198833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
     /* 198836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 198838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 198843 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 198845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 198850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198857 */     GIR_RootConstrainSelectedInstOperands,
     /* 198858 */     // GIR_Coverage, 3733,
     /* 198858 */     GIR_EraseRootFromParent_Done,
     /* 198859 */   // Label 3155: @198859
     /* 198859 */   GIM_Reject,
     /* 198860 */ // Label 3133: @198860
     /* 198860 */ GIM_Reject,
     /* 198861 */ // Label 3131: @198861
     /* 198861 */ GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(200106),
     /* 198866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198869 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(198931), // Rule ID 5701 //
     /* 198874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 198877 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198884 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198897 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64),
     /* 198900 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198929 */     GIR_RootConstrainSelectedInstOperands,
     /* 198930 */     // GIR_Coverage, 5701,
     /* 198930 */     GIR_EraseRootFromParent_Done,
     /* 198931 */   // Label 3157: @198931
     /* 198931 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(198990), // Rule ID 5705 //
     /* 198936 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 198943 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 198945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 198949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 198956 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 198956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64),
     /* 198959 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 198961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 198966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 198971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 198976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 198981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 198988 */     GIR_RootConstrainSelectedInstOperands,
     /* 198989 */     // GIR_Coverage, 5705,
     /* 198989 */     GIR_EraseRootFromParent_Done,
     /* 198990 */   // Label 3158: @198990
     /* 198990 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(199056), // Rule ID 5699 //
     /* 198995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 198998 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 199020 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64_RTN),
     /* 199023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199025 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 199032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 199042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 199047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199054 */     GIR_RootConstrainSelectedInstOperands,
     /* 199055 */     // GIR_Coverage, 5699,
     /* 199055 */     GIR_EraseRootFromParent_Done,
     /* 199056 */   // Label 3159: @199056
     /* 199056 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(199119), // Rule ID 5703 //
     /* 199061 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 199083 */     // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN),
     /* 199086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199088 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 199095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 199105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 199110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199117 */     GIR_RootConstrainSelectedInstOperands,
     /* 199118 */     // GIR_Coverage, 5703,
     /* 199118 */     GIR_EraseRootFromParent_Done,
     /* 199119 */   // Label 3160: @199119
     /* 199119 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(199176), // Rule ID 5700 //
     /* 199124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 199127 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199134 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199147 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
     /* 199150 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199174 */     GIR_RootConstrainSelectedInstOperands,
     /* 199175 */     // GIR_Coverage, 5700,
     /* 199175 */     GIR_EraseRootFromParent_Done,
     /* 199176 */   // Label 3161: @199176
     /* 199176 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(199230), // Rule ID 5704 //
     /* 199181 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199188 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199201 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
     /* 199204 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199228 */     GIR_RootConstrainSelectedInstOperands,
     /* 199229 */     // GIR_Coverage, 5704,
     /* 199229 */     GIR_EraseRootFromParent_Done,
     /* 199230 */   // Label 3162: @199230
     /* 199230 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(199291), // Rule ID 5698 //
     /* 199235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 199238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199260 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
     /* 199263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199265 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199289 */     GIR_RootConstrainSelectedInstOperands,
     /* 199290 */     // GIR_Coverage, 5698,
     /* 199290 */     GIR_EraseRootFromParent_Done,
     /* 199291 */   // Label 3163: @199291
     /* 199291 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(199349), // Rule ID 5702 //
     /* 199296 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 199318 */     // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 199318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
     /* 199321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 199323 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 199325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 199330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 199335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199347 */     GIR_RootConstrainSelectedInstOperands,
     /* 199348 */     // GIR_Coverage, 5702,
     /* 199348 */     GIR_EraseRootFromParent_Done,
     /* 199349 */   // Label 3164: @199349
     /* 199349 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(199399), // Rule ID 8373 //
     /* 199354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 199357 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199362 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199375 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
     /* 199378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199383 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199397 */     GIR_RootConstrainSelectedInstOperands,
     /* 199398 */     // GIR_Coverage, 8373,
     /* 199398 */     GIR_EraseRootFromParent_Done,
     /* 199399 */   // Label 3165: @199399
     /* 199399 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(199449), // Rule ID 8375 //
     /* 199404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 199407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199412 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199425 */     // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i64>>  =>  (DS_SUB_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64_gfx9),
     /* 199428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199433 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199447 */     GIR_RootConstrainSelectedInstOperands,
     /* 199448 */     // GIR_Coverage, 8375,
     /* 199448 */     GIR_EraseRootFromParent_Done,
     /* 199449 */   // Label 3166: @199449
     /* 199449 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(199499), // Rule ID 8377 //
     /* 199454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 199457 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 199462 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199475 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 199475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
     /* 199478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199483 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199497 */     GIR_RootConstrainSelectedInstOperands,
     /* 199498 */     // GIR_Coverage, 8377,
     /* 199498 */     GIR_EraseRootFromParent_Done,
     /* 199499 */   // Label 3167: @199499
     /* 199499 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(199553), // Rule ID 8372 //
     /* 199504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 199507 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199527 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
     /* 199530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199537 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199551 */     GIR_RootConstrainSelectedInstOperands,
     /* 199552 */     // GIR_Coverage, 8372,
     /* 199552 */     GIR_EraseRootFromParent_Done,
     /* 199553 */   // Label 3168: @199553
     /* 199553 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(199607), // Rule ID 8374 //
     /* 199558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 199561 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 199566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199581 */     // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_i64>>  =>  (DS_SUB_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 199581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64_gfx9),
     /* 199584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199591 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199605 */     GIR_RootConstrainSelectedInstOperands,
     /* 199606 */     // GIR_Coverage, 8374,
     /* 199606 */     GIR_EraseRootFromParent_Done,
     /* 199607 */   // Label 3169: @199607
     /* 199607 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(199661), // Rule ID 8376 //
     /* 199612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 199615 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 199620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 199635 */     // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 199635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
     /* 199638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 199645 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 199647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199659 */     GIR_RootConstrainSelectedInstOperands,
     /* 199660 */     // GIR_Coverage, 8376,
     /* 199660 */     GIR_EraseRootFromParent_Done,
     /* 199661 */   // Label 3170: @199661
     /* 199661 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(199718), // Rule ID 4074 //
     /* 199666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199669 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199676 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 199689 */     // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 199689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR),
     /* 199692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 199697 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 199704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199716 */     GIR_RootConstrainSelectedInstOperands,
     /* 199717 */     // GIR_Coverage, 4074,
     /* 199717 */     GIR_EraseRootFromParent_Done,
     /* 199718 */   // Label 3171: @199718
     /* 199718 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(199779), // Rule ID 4076 //
     /* 199723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 199748 */     // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 199748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR_RTN),
     /* 199751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 199758 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 199765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 199770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199777 */     GIR_RootConstrainSelectedInstOperands,
     /* 199778 */     // GIR_Coverage, 4076,
     /* 199778 */     GIR_EraseRootFromParent_Done,
     /* 199779 */   // Label 3172: @199779
     /* 199779 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(199831), // Rule ID 4073 //
     /* 199784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199787 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199794 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 199807 */     // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 199807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2),
     /* 199810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199815 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199829 */     GIR_RootConstrainSelectedInstOperands,
     /* 199830 */     // GIR_Coverage, 4073,
     /* 199830 */     GIR_EraseRootFromParent_Done,
     /* 199831 */   // Label 3173: @199831
     /* 199831 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(199887), // Rule ID 4075 //
     /* 199836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 199839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 199850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 199861 */     // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 199861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_RTN),
     /* 199864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 199866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199871 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199885 */     GIR_RootConstrainSelectedInstOperands,
     /* 199886 */     // GIR_Coverage, 4075,
     /* 199886 */     GIR_EraseRootFromParent_Done,
     /* 199887 */   // Label 3174: @199887
     /* 199887 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(199940), // Rule ID 3700 //
     /* 199892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199903 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199916 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 199916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
     /* 199919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199924 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199938 */     GIR_RootConstrainSelectedInstOperands,
     /* 199939 */     // GIR_Coverage, 3700,
     /* 199939 */     GIR_EraseRootFromParent_Done,
     /* 199940 */   // Label 3175: @199940
     /* 199940 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(199992), // Rule ID 3760 //
     /* 199945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 199948 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 199955 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 199957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 199961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 199968 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 199968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
     /* 199971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 199976 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 199978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 199983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 199990 */     GIR_RootConstrainSelectedInstOperands,
     /* 199991 */     // GIR_Coverage, 3760,
     /* 199991 */     GIR_EraseRootFromParent_Done,
     /* 199992 */   // Label 3176: @199992
     /* 199992 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(200049), // Rule ID 3699 //
     /* 199997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 200000 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 200023 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 200023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
     /* 200026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200033 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200047 */     GIR_RootConstrainSelectedInstOperands,
     /* 200048 */     // GIR_Coverage, 3699,
     /* 200048 */     GIR_EraseRootFromParent_Done,
     /* 200049 */   // Label 3177: @200049
     /* 200049 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(200105), // Rule ID 3759 //
     /* 200054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 200057 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 200068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 200079 */     // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 200079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
     /* 200082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 200089 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200103 */     GIR_RootConstrainSelectedInstOperands,
     /* 200104 */     // GIR_Coverage, 3759,
     /* 200104 */     GIR_EraseRootFromParent_Done,
     /* 200105 */   // Label 3178: @200105
     /* 200105 */   GIM_Reject,
     /* 200106 */ // Label 3156: @200106
     /* 200106 */ GIM_Reject,
     /* 200107 */ // Label 3132: @200107
     /* 200107 */ GIM_Reject,
     /* 200108 */ // Label 22: @200108
     /* 200108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3181*/ GIMT_Encode4(202619),
     /* 200119 */ /*GILLT_s32*//*Label 3179*/ GIMT_Encode4(200127),
     /* 200123 */ /*GILLT_s64*//*Label 3180*/ GIMT_Encode4(201373),
     /* 200127 */ // Label 3179: @200127
     /* 200127 */ GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(201372),
     /* 200132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200135 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(200197), // Rule ID 5645 //
     /* 200140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200143 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200150 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200163 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64),
     /* 200166 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200195 */     GIR_RootConstrainSelectedInstOperands,
     /* 200196 */     // GIR_Coverage, 5645,
     /* 200196 */     GIR_EraseRootFromParent_Done,
     /* 200197 */   // Label 3183: @200197
     /* 200197 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(200256), // Rule ID 5649 //
     /* 200202 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200209 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200222 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64),
     /* 200225 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200254 */     GIR_RootConstrainSelectedInstOperands,
     /* 200255 */     // GIR_Coverage, 5649,
     /* 200255 */     GIR_EraseRootFromParent_Done,
     /* 200256 */   // Label 3184: @200256
     /* 200256 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(200322), // Rule ID 5643 //
     /* 200261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200264 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200286 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64_RTN),
     /* 200289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200291 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200320 */     GIR_RootConstrainSelectedInstOperands,
     /* 200321 */     // GIR_Coverage, 5643,
     /* 200321 */     GIR_EraseRootFromParent_Done,
     /* 200322 */   // Label 3185: @200322
     /* 200322 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(200385), // Rule ID 5647 //
     /* 200327 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 200349 */     // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN),
     /* 200352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200354 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 200361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 200371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 200376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200383 */     GIR_RootConstrainSelectedInstOperands,
     /* 200384 */     // GIR_Coverage, 5647,
     /* 200384 */     GIR_EraseRootFromParent_Done,
     /* 200385 */   // Label 3186: @200385
     /* 200385 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(200442), // Rule ID 5644 //
     /* 200390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200393 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200400 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200413 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
     /* 200416 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200440 */     GIR_RootConstrainSelectedInstOperands,
     /* 200441 */     // GIR_Coverage, 5644,
     /* 200441 */     GIR_EraseRootFromParent_Done,
     /* 200442 */   // Label 3187: @200442
     /* 200442 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(200496), // Rule ID 5648 //
     /* 200447 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200454 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200467 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
     /* 200470 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200494 */     GIR_RootConstrainSelectedInstOperands,
     /* 200495 */     // GIR_Coverage, 5648,
     /* 200495 */     GIR_EraseRootFromParent_Done,
     /* 200496 */   // Label 3188: @200496
     /* 200496 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(200557), // Rule ID 5642 //
     /* 200501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 200504 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200526 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
     /* 200529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200531 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200555 */     GIR_RootConstrainSelectedInstOperands,
     /* 200556 */     // GIR_Coverage, 5642,
     /* 200556 */     GIR_EraseRootFromParent_Done,
     /* 200557 */   // Label 3189: @200557
     /* 200557 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(200615), // Rule ID 5646 //
     /* 200562 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 200584 */     // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 200584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
     /* 200587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 200589 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 200591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 200596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 200601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200613 */     GIR_RootConstrainSelectedInstOperands,
     /* 200614 */     // GIR_Coverage, 5646,
     /* 200614 */     GIR_EraseRootFromParent_Done,
     /* 200615 */   // Label 3190: @200615
     /* 200615 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(200665), // Rule ID 8298 //
     /* 200620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 200623 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200628 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200641 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
     /* 200644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200649 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200663 */     GIR_RootConstrainSelectedInstOperands,
     /* 200664 */     // GIR_Coverage, 8298,
     /* 200664 */     GIR_EraseRootFromParent_Done,
     /* 200665 */   // Label 3191: @200665
     /* 200665 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(200715), // Rule ID 8300 //
     /* 200670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 200673 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200678 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200691 */     // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_noret_i32>>  =>  (DS_AND_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32_gfx9),
     /* 200694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200699 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200713 */     GIR_RootConstrainSelectedInstOperands,
     /* 200714 */     // GIR_Coverage, 8300,
     /* 200714 */     GIR_EraseRootFromParent_Done,
     /* 200715 */   // Label 3192: @200715
     /* 200715 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(200765), // Rule ID 8302 //
     /* 200720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 200723 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 200728 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200741 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 200741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
     /* 200744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200749 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200763 */     GIR_RootConstrainSelectedInstOperands,
     /* 200764 */     // GIR_Coverage, 8302,
     /* 200764 */     GIR_EraseRootFromParent_Done,
     /* 200765 */   // Label 3193: @200765
     /* 200765 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(200819), // Rule ID 8297 //
     /* 200770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 200773 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200793 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
     /* 200796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200803 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200817 */     GIR_RootConstrainSelectedInstOperands,
     /* 200818 */     // GIR_Coverage, 8297,
     /* 200818 */     GIR_EraseRootFromParent_Done,
     /* 200819 */   // Label 3194: @200819
     /* 200819 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(200873), // Rule ID 8299 //
     /* 200824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 200827 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 200832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200847 */     // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_i32>>  =>  (DS_AND_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 200847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32_gfx9),
     /* 200850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200857 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200871 */     GIR_RootConstrainSelectedInstOperands,
     /* 200872 */     // GIR_Coverage, 8299,
     /* 200872 */     GIR_EraseRootFromParent_Done,
     /* 200873 */   // Label 3195: @200873
     /* 200873 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(200927), // Rule ID 8301 //
     /* 200878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 200881 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 200886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 200890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 200901 */     // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 200901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
     /* 200904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 200906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 200911 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 200913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 200918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200925 */     GIR_RootConstrainSelectedInstOperands,
     /* 200926 */     // GIR_Coverage, 8301,
     /* 200926 */     GIR_EraseRootFromParent_Done,
     /* 200927 */   // Label 3196: @200927
     /* 200927 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(200984), // Rule ID 4030 //
     /* 200932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200935 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200942 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 200944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 200948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 200955 */     // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 200955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR),
     /* 200958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 200963 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 200965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 200970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 200975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 200982 */     GIR_RootConstrainSelectedInstOperands,
     /* 200983 */     // GIR_Coverage, 4030,
     /* 200983 */     GIR_EraseRootFromParent_Done,
     /* 200984 */   // Label 3197: @200984
     /* 200984 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(201045), // Rule ID 4032 //
     /* 200989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 200992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 200999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 201014 */     // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 201014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR_RTN),
     /* 201017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 201024 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 201031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201043 */     GIR_RootConstrainSelectedInstOperands,
     /* 201044 */     // GIR_Coverage, 4032,
     /* 201044 */     GIR_EraseRootFromParent_Done,
     /* 201045 */   // Label 3198: @201045
     /* 201045 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(201097), // Rule ID 4029 //
     /* 201050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 201053 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201060 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 201073 */     // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 201073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND),
     /* 201076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201081 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201095 */     GIR_RootConstrainSelectedInstOperands,
     /* 201096 */     // GIR_Coverage, 4029,
     /* 201096 */     GIR_EraseRootFromParent_Done,
     /* 201097 */   // Label 3199: @201097
     /* 201097 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(201153), // Rule ID 4031 //
     /* 201102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 201105 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 201127 */     // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 201127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_RTN),
     /* 201130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201137 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201151 */     GIR_RootConstrainSelectedInstOperands,
     /* 201152 */     // GIR_Coverage, 4031,
     /* 201152 */     GIR_EraseRootFromParent_Done,
     /* 201153 */   // Label 3200: @201153
     /* 201153 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(201206), // Rule ID 3680 //
     /* 201158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201161 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201169 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201182 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 201182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
     /* 201185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201190 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201204 */     GIR_RootConstrainSelectedInstOperands,
     /* 201205 */     // GIR_Coverage, 3680,
     /* 201205 */     GIR_EraseRootFromParent_Done,
     /* 201206 */   // Label 3201: @201206
     /* 201206 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(201258), // Rule ID 3740 //
     /* 201211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201221 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201234 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 201234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
     /* 201237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201242 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201256 */     GIR_RootConstrainSelectedInstOperands,
     /* 201257 */     // GIR_Coverage, 3740,
     /* 201257 */     GIR_EraseRootFromParent_Done,
     /* 201258 */   // Label 3202: @201258
     /* 201258 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(201315), // Rule ID 3679 //
     /* 201263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201266 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201289 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 201289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
     /* 201292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201299 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201313 */     GIR_RootConstrainSelectedInstOperands,
     /* 201314 */     // GIR_Coverage, 3679,
     /* 201314 */     GIR_EraseRootFromParent_Done,
     /* 201315 */   // Label 3203: @201315
     /* 201315 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(201371), // Rule ID 3739 //
     /* 201320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 201323 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 201334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 201345 */     // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 201345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
     /* 201348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 201350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 201355 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 201357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201369 */     GIR_RootConstrainSelectedInstOperands,
     /* 201370 */     // GIR_Coverage, 3739,
     /* 201370 */     GIR_EraseRootFromParent_Done,
     /* 201371 */   // Label 3204: @201371
     /* 201371 */   GIM_Reject,
     /* 201372 */ // Label 3182: @201372
     /* 201372 */ GIM_Reject,
     /* 201373 */ // Label 3180: @201373
     /* 201373 */ GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(202618),
     /* 201378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201381 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(201443), // Rule ID 5741 //
     /* 201386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201389 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201396 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201409 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64),
     /* 201412 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201441 */     GIR_RootConstrainSelectedInstOperands,
     /* 201442 */     // GIR_Coverage, 5741,
     /* 201442 */     GIR_EraseRootFromParent_Done,
     /* 201443 */   // Label 3206: @201443
     /* 201443 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(201502), // Rule ID 5745 //
     /* 201448 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201455 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201468 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64),
     /* 201471 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201500 */     GIR_RootConstrainSelectedInstOperands,
     /* 201501 */     // GIR_Coverage, 5745,
     /* 201501 */     GIR_EraseRootFromParent_Done,
     /* 201502 */   // Label 3207: @201502
     /* 201502 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(201568), // Rule ID 5739 //
     /* 201507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201510 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201532 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64_RTN),
     /* 201535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201537 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201566 */     GIR_RootConstrainSelectedInstOperands,
     /* 201567 */     // GIR_Coverage, 5739,
     /* 201567 */     GIR_EraseRootFromParent_Done,
     /* 201568 */   // Label 3208: @201568
     /* 201568 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(201631), // Rule ID 5743 //
     /* 201573 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 201595 */     // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN),
     /* 201598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201600 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 201607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 201617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 201622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201629 */     GIR_RootConstrainSelectedInstOperands,
     /* 201630 */     // GIR_Coverage, 5743,
     /* 201630 */     GIR_EraseRootFromParent_Done,
     /* 201631 */   // Label 3209: @201631
     /* 201631 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(201688), // Rule ID 5740 //
     /* 201636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201639 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201646 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201659 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
     /* 201662 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201686 */     GIR_RootConstrainSelectedInstOperands,
     /* 201687 */     // GIR_Coverage, 5740,
     /* 201687 */     GIR_EraseRootFromParent_Done,
     /* 201688 */   // Label 3210: @201688
     /* 201688 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(201742), // Rule ID 5744 //
     /* 201693 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201700 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201713 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
     /* 201716 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201740 */     GIR_RootConstrainSelectedInstOperands,
     /* 201741 */     // GIR_Coverage, 5744,
     /* 201741 */     GIR_EraseRootFromParent_Done,
     /* 201742 */   // Label 3211: @201742
     /* 201742 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(201803), // Rule ID 5738 //
     /* 201747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 201750 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201772 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
     /* 201775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201777 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201801 */     GIR_RootConstrainSelectedInstOperands,
     /* 201802 */     // GIR_Coverage, 5738,
     /* 201802 */     GIR_EraseRootFromParent_Done,
     /* 201803 */   // Label 3212: @201803
     /* 201803 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(201861), // Rule ID 5742 //
     /* 201808 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 201815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 201819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 201830 */     // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 201830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
     /* 201833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 201835 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 201837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 201842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 201847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 201852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 201855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201859 */     GIR_RootConstrainSelectedInstOperands,
     /* 201860 */     // GIR_Coverage, 5742,
     /* 201860 */     GIR_EraseRootFromParent_Done,
     /* 201861 */   // Label 3213: @201861
     /* 201861 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(201911), // Rule ID 8391 //
     /* 201866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 201869 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201874 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201887 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
     /* 201890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201895 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201909 */     GIR_RootConstrainSelectedInstOperands,
     /* 201910 */     // GIR_Coverage, 8391,
     /* 201910 */     GIR_EraseRootFromParent_Done,
     /* 201911 */   // Label 3214: @201911
     /* 201911 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(201961), // Rule ID 8393 //
     /* 201916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 201919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 201924 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201937 */     // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_noret_i64>>  =>  (DS_AND_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 201937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64_gfx9),
     /* 201940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201945 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 201952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 201955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 201959 */     GIR_RootConstrainSelectedInstOperands,
     /* 201960 */     // GIR_Coverage, 8393,
     /* 201960 */     GIR_EraseRootFromParent_Done,
     /* 201961 */   // Label 3215: @201961
     /* 201961 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(202011), // Rule ID 8395 //
     /* 201966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 201969 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 201974 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 201976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 201980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 201987 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 201987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
     /* 201990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 201995 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 201997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202009 */     GIR_RootConstrainSelectedInstOperands,
     /* 202010 */     // GIR_Coverage, 8395,
     /* 202010 */     GIR_EraseRootFromParent_Done,
     /* 202011 */   // Label 3216: @202011
     /* 202011 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(202065), // Rule ID 8390 //
     /* 202016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 202019 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 202024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202039 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 202039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
     /* 202042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202049 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202063 */     GIR_RootConstrainSelectedInstOperands,
     /* 202064 */     // GIR_Coverage, 8390,
     /* 202064 */     GIR_EraseRootFromParent_Done,
     /* 202065 */   // Label 3217: @202065
     /* 202065 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(202119), // Rule ID 8392 //
     /* 202070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 202073 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 202078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202093 */     // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_i64>>  =>  (DS_AND_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 202093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64_gfx9),
     /* 202096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202103 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202117 */     GIR_RootConstrainSelectedInstOperands,
     /* 202118 */     // GIR_Coverage, 8392,
     /* 202118 */     GIR_EraseRootFromParent_Done,
     /* 202119 */   // Label 3218: @202119
     /* 202119 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(202173), // Rule ID 8394 //
     /* 202124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 202127 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 202132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 202147 */     // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 202147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
     /* 202150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 202157 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 202159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202171 */     GIR_RootConstrainSelectedInstOperands,
     /* 202172 */     // GIR_Coverage, 8394,
     /* 202172 */     GIR_EraseRootFromParent_Done,
     /* 202173 */   // Label 3219: @202173
     /* 202173 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(202230), // Rule ID 4086 //
     /* 202178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202181 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202188 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 202201 */     // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 202201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR),
     /* 202204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 202209 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 202216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202228 */     GIR_RootConstrainSelectedInstOperands,
     /* 202229 */     // GIR_Coverage, 4086,
     /* 202229 */     GIR_EraseRootFromParent_Done,
     /* 202230 */   // Label 3220: @202230
     /* 202230 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(202291), // Rule ID 4088 //
     /* 202235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 202260 */     // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 202260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR_RTN),
     /* 202263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 202270 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 202277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202289 */     GIR_RootConstrainSelectedInstOperands,
     /* 202290 */     // GIR_Coverage, 4088,
     /* 202290 */     GIR_EraseRootFromParent_Done,
     /* 202291 */   // Label 3221: @202291
     /* 202291 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(202343), // Rule ID 4085 //
     /* 202296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202299 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202306 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 202319 */     // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 202319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2),
     /* 202322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202327 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202341 */     GIR_RootConstrainSelectedInstOperands,
     /* 202342 */     // GIR_Coverage, 4085,
     /* 202342 */     GIR_EraseRootFromParent_Done,
     /* 202343 */   // Label 3222: @202343
     /* 202343 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(202399), // Rule ID 4087 //
     /* 202348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 202351 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 202373 */     // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 202373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_RTN),
     /* 202376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202383 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202397 */     GIR_RootConstrainSelectedInstOperands,
     /* 202398 */     // GIR_Coverage, 4087,
     /* 202398 */     GIR_EraseRootFromParent_Done,
     /* 202399 */   // Label 3223: @202399
     /* 202399 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(202452), // Rule ID 3706 //
     /* 202404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202415 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202428 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 202428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
     /* 202431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202436 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202450 */     GIR_RootConstrainSelectedInstOperands,
     /* 202451 */     // GIR_Coverage, 3706,
     /* 202451 */     GIR_EraseRootFromParent_Done,
     /* 202452 */   // Label 3224: @202452
     /* 202452 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(202504), // Rule ID 3766 //
     /* 202457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202460 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202467 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202480 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 202480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
     /* 202483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202488 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202502 */     GIR_RootConstrainSelectedInstOperands,
     /* 202503 */     // GIR_Coverage, 3766,
     /* 202503 */     GIR_EraseRootFromParent_Done,
     /* 202504 */   // Label 3225: @202504
     /* 202504 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(202561), // Rule ID 3705 //
     /* 202509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202512 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202535 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 202535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
     /* 202538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202545 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202559 */     GIR_RootConstrainSelectedInstOperands,
     /* 202560 */     // GIR_Coverage, 3705,
     /* 202560 */     GIR_EraseRootFromParent_Done,
     /* 202561 */   // Label 3226: @202561
     /* 202561 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(202617), // Rule ID 3765 //
     /* 202566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 202569 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 202580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 202591 */     // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 202591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
     /* 202594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 202596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 202601 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 202603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 202608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202615 */     GIR_RootConstrainSelectedInstOperands,
     /* 202616 */     // GIR_Coverage, 3765,
     /* 202616 */     GIR_EraseRootFromParent_Done,
     /* 202617 */   // Label 3227: @202617
     /* 202617 */   GIM_Reject,
     /* 202618 */ // Label 3205: @202618
     /* 202618 */ GIM_Reject,
     /* 202619 */ // Label 3181: @202619
     /* 202619 */ GIM_Reject,
     /* 202620 */ // Label 23: @202620
     /* 202620 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3230*/ GIMT_Encode4(205131),
     /* 202631 */ /*GILLT_s32*//*Label 3228*/ GIMT_Encode4(202639),
     /* 202635 */ /*GILLT_s64*//*Label 3229*/ GIMT_Encode4(203885),
     /* 202639 */ // Label 3228: @202639
     /* 202639 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(203884),
     /* 202644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202647 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(202709), // Rule ID 5653 //
     /* 202652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202655 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202662 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202675 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64),
     /* 202678 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202707 */     GIR_RootConstrainSelectedInstOperands,
     /* 202708 */     // GIR_Coverage, 5653,
     /* 202708 */     GIR_EraseRootFromParent_Done,
     /* 202709 */   // Label 3232: @202709
     /* 202709 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(202768), // Rule ID 5657 //
     /* 202714 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202721 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202734 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64),
     /* 202737 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202766 */     GIR_RootConstrainSelectedInstOperands,
     /* 202767 */     // GIR_Coverage, 5657,
     /* 202767 */     GIR_EraseRootFromParent_Done,
     /* 202768 */   // Label 3233: @202768
     /* 202768 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(202834), // Rule ID 5651 //
     /* 202773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202776 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202798 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64_RTN),
     /* 202801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202803 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202832 */     GIR_RootConstrainSelectedInstOperands,
     /* 202833 */     // GIR_Coverage, 5651,
     /* 202833 */     GIR_EraseRootFromParent_Done,
     /* 202834 */   // Label 3234: @202834
     /* 202834 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(202897), // Rule ID 5655 //
     /* 202839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 202850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 202861 */     // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN),
     /* 202864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 202866 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 202873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 202883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 202888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 202891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202895 */     GIR_RootConstrainSelectedInstOperands,
     /* 202896 */     // GIR_Coverage, 5655,
     /* 202896 */     GIR_EraseRootFromParent_Done,
     /* 202897 */   // Label 3235: @202897
     /* 202897 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(202954), // Rule ID 5652 //
     /* 202902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 202905 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202912 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202925 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
     /* 202928 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 202948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 202952 */     GIR_RootConstrainSelectedInstOperands,
     /* 202953 */     // GIR_Coverage, 5652,
     /* 202953 */     GIR_EraseRootFromParent_Done,
     /* 202954 */   // Label 3236: @202954
     /* 202954 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(203008), // Rule ID 5656 //
     /* 202959 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 202966 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 202968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 202972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 202979 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 202979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
     /* 202982 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 202984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 202989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 202994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 202999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203006 */     GIR_RootConstrainSelectedInstOperands,
     /* 203007 */     // GIR_Coverage, 5656,
     /* 203007 */     GIR_EraseRootFromParent_Done,
     /* 203008 */   // Label 3237: @203008
     /* 203008 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(203069), // Rule ID 5650 //
     /* 203013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 203016 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 203038 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
     /* 203041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 203043 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 203055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203067 */     GIR_RootConstrainSelectedInstOperands,
     /* 203068 */     // GIR_Coverage, 5650,
     /* 203068 */     GIR_EraseRootFromParent_Done,
     /* 203069 */   // Label 3238: @203069
     /* 203069 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(203127), // Rule ID 5654 //
     /* 203074 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 203096 */     // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
     /* 203099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 203101 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 203113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203125 */     GIR_RootConstrainSelectedInstOperands,
     /* 203126 */     // GIR_Coverage, 5654,
     /* 203126 */     GIR_EraseRootFromParent_Done,
     /* 203127 */   // Label 3239: @203127
     /* 203127 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(203177), // Rule ID 8304 //
     /* 203132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 203135 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203140 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203153 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
     /* 203156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203161 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203175 */     GIR_RootConstrainSelectedInstOperands,
     /* 203176 */     // GIR_Coverage, 8304,
     /* 203176 */     GIR_EraseRootFromParent_Done,
     /* 203177 */   // Label 3240: @203177
     /* 203177 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(203227), // Rule ID 8306 //
     /* 203182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 203185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203190 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203203 */     // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_noret_i32>>  =>  (DS_OR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32_gfx9),
     /* 203206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203211 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203225 */     GIR_RootConstrainSelectedInstOperands,
     /* 203226 */     // GIR_Coverage, 8306,
     /* 203226 */     GIR_EraseRootFromParent_Done,
     /* 203227 */   // Label 3241: @203227
     /* 203227 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(203277), // Rule ID 8308 //
     /* 203232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 203235 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 203240 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203253 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 203253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
     /* 203256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203261 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203275 */     GIR_RootConstrainSelectedInstOperands,
     /* 203276 */     // GIR_Coverage, 8308,
     /* 203276 */     GIR_EraseRootFromParent_Done,
     /* 203277 */   // Label 3242: @203277
     /* 203277 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(203331), // Rule ID 8303 //
     /* 203282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 203285 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203305 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
     /* 203308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203315 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203329 */     GIR_RootConstrainSelectedInstOperands,
     /* 203330 */     // GIR_Coverage, 8303,
     /* 203330 */     GIR_EraseRootFromParent_Done,
     /* 203331 */   // Label 3243: @203331
     /* 203331 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(203385), // Rule ID 8305 //
     /* 203336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 203339 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 203344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203359 */     // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_i32>>  =>  (DS_OR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 203359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32_gfx9),
     /* 203362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203369 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203383 */     GIR_RootConstrainSelectedInstOperands,
     /* 203384 */     // GIR_Coverage, 8305,
     /* 203384 */     GIR_EraseRootFromParent_Done,
     /* 203385 */   // Label 3244: @203385
     /* 203385 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(203439), // Rule ID 8307 //
     /* 203390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 203393 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 203398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 203413 */     // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 203413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
     /* 203416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 203423 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 203425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203437 */     GIR_RootConstrainSelectedInstOperands,
     /* 203438 */     // GIR_Coverage, 8307,
     /* 203438 */     GIR_EraseRootFromParent_Done,
     /* 203439 */   // Label 3245: @203439
     /* 203439 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(203496), // Rule ID 4050 //
     /* 203444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203447 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203454 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 203467 */     // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 203467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR),
     /* 203470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 203475 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 203482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203494 */     GIR_RootConstrainSelectedInstOperands,
     /* 203495 */     // GIR_Coverage, 4050,
     /* 203495 */     GIR_EraseRootFromParent_Done,
     /* 203496 */   // Label 3246: @203496
     /* 203496 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(203557), // Rule ID 4052 //
     /* 203501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203504 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 203526 */     // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 203526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR_RTN),
     /* 203529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 203536 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 203543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 203548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203555 */     GIR_RootConstrainSelectedInstOperands,
     /* 203556 */     // GIR_Coverage, 4052,
     /* 203556 */     GIR_EraseRootFromParent_Done,
     /* 203557 */   // Label 3247: @203557
     /* 203557 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(203609), // Rule ID 4049 //
     /* 203562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203565 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203572 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 203585 */     // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 203585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR),
     /* 203588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203593 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203607 */     GIR_RootConstrainSelectedInstOperands,
     /* 203608 */     // GIR_Coverage, 4049,
     /* 203608 */     GIR_EraseRootFromParent_Done,
     /* 203609 */   // Label 3248: @203609
     /* 203609 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(203665), // Rule ID 4051 //
     /* 203614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 203617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 203639 */     // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 203639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_RTN),
     /* 203642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203649 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203663 */     GIR_RootConstrainSelectedInstOperands,
     /* 203664 */     // GIR_Coverage, 4051,
     /* 203664 */     GIR_EraseRootFromParent_Done,
     /* 203665 */   // Label 3249: @203665
     /* 203665 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(203718), // Rule ID 3690 //
     /* 203670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203673 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203681 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203694 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 203694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
     /* 203697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203702 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203716 */     GIR_RootConstrainSelectedInstOperands,
     /* 203717 */     // GIR_Coverage, 3690,
     /* 203717 */     GIR_EraseRootFromParent_Done,
     /* 203718 */   // Label 3250: @203718
     /* 203718 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(203770), // Rule ID 3750 //
     /* 203723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203733 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203746 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 203746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
     /* 203749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203754 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203768 */     GIR_RootConstrainSelectedInstOperands,
     /* 203769 */     // GIR_Coverage, 3750,
     /* 203769 */     GIR_EraseRootFromParent_Done,
     /* 203770 */   // Label 3251: @203770
     /* 203770 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(203827), // Rule ID 3689 //
     /* 203775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203778 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203801 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 203801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
     /* 203804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203811 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203825 */     GIR_RootConstrainSelectedInstOperands,
     /* 203826 */     // GIR_Coverage, 3689,
     /* 203826 */     GIR_EraseRootFromParent_Done,
     /* 203827 */   // Label 3252: @203827
     /* 203827 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(203883), // Rule ID 3749 //
     /* 203832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 203835 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 203846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 203857 */     // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 203857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
     /* 203860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 203862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 203867 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 203869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 203874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203881 */     GIR_RootConstrainSelectedInstOperands,
     /* 203882 */     // GIR_Coverage, 3749,
     /* 203882 */     GIR_EraseRootFromParent_Done,
     /* 203883 */   // Label 3253: @203883
     /* 203883 */   GIM_Reject,
     /* 203884 */ // Label 3231: @203884
     /* 203884 */ GIM_Reject,
     /* 203885 */ // Label 3229: @203885
     /* 203885 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(205130),
     /* 203890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203893 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(203955), // Rule ID 5749 //
     /* 203898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 203901 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203908 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203921 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64),
     /* 203924 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 203941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 203946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 203953 */     GIR_RootConstrainSelectedInstOperands,
     /* 203954 */     // GIR_Coverage, 5749,
     /* 203954 */     GIR_EraseRootFromParent_Done,
     /* 203955 */   // Label 3255: @203955
     /* 203955 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(204014), // Rule ID 5753 //
     /* 203960 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 203967 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 203969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 203973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 203980 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 203980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64),
     /* 203983 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 203985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 203990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 203995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 204000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 204005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204012 */     GIR_RootConstrainSelectedInstOperands,
     /* 204013 */     // GIR_Coverage, 5753,
     /* 204013 */     GIR_EraseRootFromParent_Done,
     /* 204014 */   // Label 3256: @204014
     /* 204014 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(204080), // Rule ID 5747 //
     /* 204019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204022 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 204044 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64_RTN),
     /* 204047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204049 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 204056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 204066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 204071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204078 */     GIR_RootConstrainSelectedInstOperands,
     /* 204079 */     // GIR_Coverage, 5747,
     /* 204079 */     GIR_EraseRootFromParent_Done,
     /* 204080 */   // Label 3257: @204080
     /* 204080 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(204143), // Rule ID 5751 //
     /* 204085 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 204107 */     // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN),
     /* 204110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204112 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 204119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 204129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 204134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204141 */     GIR_RootConstrainSelectedInstOperands,
     /* 204142 */     // GIR_Coverage, 5751,
     /* 204142 */     GIR_EraseRootFromParent_Done,
     /* 204143 */   // Label 3258: @204143
     /* 204143 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(204200), // Rule ID 5748 //
     /* 204148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204151 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204158 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204171 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
     /* 204174 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204198 */     GIR_RootConstrainSelectedInstOperands,
     /* 204199 */     // GIR_Coverage, 5748,
     /* 204199 */     GIR_EraseRootFromParent_Done,
     /* 204200 */   // Label 3259: @204200
     /* 204200 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(204254), // Rule ID 5752 //
     /* 204205 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204212 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204225 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
     /* 204228 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204252 */     GIR_RootConstrainSelectedInstOperands,
     /* 204253 */     // GIR_Coverage, 5752,
     /* 204253 */     GIR_EraseRootFromParent_Done,
     /* 204254 */   // Label 3260: @204254
     /* 204254 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(204315), // Rule ID 5746 //
     /* 204259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 204262 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204284 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
     /* 204287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204289 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204313 */     GIR_RootConstrainSelectedInstOperands,
     /* 204314 */     // GIR_Coverage, 5746,
     /* 204314 */     GIR_EraseRootFromParent_Done,
     /* 204315 */   // Label 3261: @204315
     /* 204315 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(204373), // Rule ID 5750 //
     /* 204320 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 204342 */     // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 204342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
     /* 204345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 204347 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 204349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 204354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 204359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204371 */     GIR_RootConstrainSelectedInstOperands,
     /* 204372 */     // GIR_Coverage, 5750,
     /* 204372 */     GIR_EraseRootFromParent_Done,
     /* 204373 */   // Label 3262: @204373
     /* 204373 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(204423), // Rule ID 8397 //
     /* 204378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 204381 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204386 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204399 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
     /* 204402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204407 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204421 */     GIR_RootConstrainSelectedInstOperands,
     /* 204422 */     // GIR_Coverage, 8397,
     /* 204422 */     GIR_EraseRootFromParent_Done,
     /* 204423 */   // Label 3263: @204423
     /* 204423 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(204473), // Rule ID 8399 //
     /* 204428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 204431 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204436 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204449 */     // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_noret_i64>>  =>  (DS_OR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64_gfx9),
     /* 204452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204457 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204471 */     GIR_RootConstrainSelectedInstOperands,
     /* 204472 */     // GIR_Coverage, 8399,
     /* 204472 */     GIR_EraseRootFromParent_Done,
     /* 204473 */   // Label 3264: @204473
     /* 204473 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(204523), // Rule ID 8401 //
     /* 204478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 204481 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 204486 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204499 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 204499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
     /* 204502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204507 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204521 */     GIR_RootConstrainSelectedInstOperands,
     /* 204522 */     // GIR_Coverage, 8401,
     /* 204522 */     GIR_EraseRootFromParent_Done,
     /* 204523 */   // Label 3265: @204523
     /* 204523 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(204577), // Rule ID 8396 //
     /* 204528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 204531 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204551 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
     /* 204554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204561 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204575 */     GIR_RootConstrainSelectedInstOperands,
     /* 204576 */     // GIR_Coverage, 8396,
     /* 204576 */     GIR_EraseRootFromParent_Done,
     /* 204577 */   // Label 3266: @204577
     /* 204577 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(204631), // Rule ID 8398 //
     /* 204582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 204585 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 204590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204605 */     // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_i64>>  =>  (DS_OR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 204605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64_gfx9),
     /* 204608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204615 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204629 */     GIR_RootConstrainSelectedInstOperands,
     /* 204630 */     // GIR_Coverage, 8398,
     /* 204630 */     GIR_EraseRootFromParent_Done,
     /* 204631 */   // Label 3267: @204631
     /* 204631 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(204685), // Rule ID 8400 //
     /* 204636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 204639 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 204644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 204659 */     // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 204659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
     /* 204662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 204669 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 204671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204683 */     GIR_RootConstrainSelectedInstOperands,
     /* 204684 */     // GIR_Coverage, 8400,
     /* 204684 */     GIR_EraseRootFromParent_Done,
     /* 204685 */   // Label 3268: @204685
     /* 204685 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(204742), // Rule ID 4106 //
     /* 204690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204693 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204700 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 204713 */     // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 204713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR),
     /* 204716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 204721 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 204728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204740 */     GIR_RootConstrainSelectedInstOperands,
     /* 204741 */     // GIR_Coverage, 4106,
     /* 204741 */     GIR_EraseRootFromParent_Done,
     /* 204742 */   // Label 3269: @204742
     /* 204742 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(204803), // Rule ID 4108 //
     /* 204747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204750 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 204772 */     // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 204772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR_RTN),
     /* 204775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 204782 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 204789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 204794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204801 */     GIR_RootConstrainSelectedInstOperands,
     /* 204802 */     // GIR_Coverage, 4108,
     /* 204802 */     GIR_EraseRootFromParent_Done,
     /* 204803 */   // Label 3270: @204803
     /* 204803 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(204855), // Rule ID 4105 //
     /* 204808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204811 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204818 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 204831 */     // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 204831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2),
     /* 204834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204839 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204853 */     GIR_RootConstrainSelectedInstOperands,
     /* 204854 */     // GIR_Coverage, 4105,
     /* 204854 */     GIR_EraseRootFromParent_Done,
     /* 204855 */   // Label 3271: @204855
     /* 204855 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(204911), // Rule ID 4107 //
     /* 204860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 204863 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 204874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 204885 */     // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 204885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_RTN),
     /* 204888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 204890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204895 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204909 */     GIR_RootConstrainSelectedInstOperands,
     /* 204910 */     // GIR_Coverage, 4107,
     /* 204910 */     GIR_EraseRootFromParent_Done,
     /* 204911 */   // Label 3272: @204911
     /* 204911 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(204964), // Rule ID 3716 //
     /* 204916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204927 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 204940 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 204940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
     /* 204943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 204948 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 204950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 204955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 204962 */     GIR_RootConstrainSelectedInstOperands,
     /* 204963 */     // GIR_Coverage, 3716,
     /* 204963 */     GIR_EraseRootFromParent_Done,
     /* 204964 */   // Label 3273: @204964
     /* 204964 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(205016), // Rule ID 3776 //
     /* 204969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 204972 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 204979 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 204981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 204985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 204992 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 204992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
     /* 204995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205000 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205014 */     GIR_RootConstrainSelectedInstOperands,
     /* 205015 */     // GIR_Coverage, 3776,
     /* 205015 */     GIR_EraseRootFromParent_Done,
     /* 205016 */   // Label 3274: @205016
     /* 205016 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(205073), // Rule ID 3715 //
     /* 205021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 205024 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 205047 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 205047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
     /* 205050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205057 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205071 */     GIR_RootConstrainSelectedInstOperands,
     /* 205072 */     // GIR_Coverage, 3715,
     /* 205072 */     GIR_EraseRootFromParent_Done,
     /* 205073 */   // Label 3275: @205073
     /* 205073 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(205129), // Rule ID 3775 //
     /* 205078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 205081 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 205092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 205103 */     // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 205103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
     /* 205106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 205113 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205127 */     GIR_RootConstrainSelectedInstOperands,
     /* 205128 */     // GIR_Coverage, 3775,
     /* 205128 */     GIR_EraseRootFromParent_Done,
     /* 205129 */   // Label 3276: @205129
     /* 205129 */   GIM_Reject,
     /* 205130 */ // Label 3254: @205130
     /* 205130 */ GIM_Reject,
     /* 205131 */ // Label 3230: @205131
     /* 205131 */ GIM_Reject,
     /* 205132 */ // Label 24: @205132
     /* 205132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3279*/ GIMT_Encode4(207643),
     /* 205143 */ /*GILLT_s32*//*Label 3277*/ GIMT_Encode4(205151),
     /* 205147 */ /*GILLT_s64*//*Label 3278*/ GIMT_Encode4(206397),
     /* 205151 */ // Label 3277: @205151
     /* 205151 */ GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(206396),
     /* 205156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205159 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(205221), // Rule ID 5661 //
     /* 205164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205167 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205174 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205187 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64),
     /* 205190 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205219 */     GIR_RootConstrainSelectedInstOperands,
     /* 205220 */     // GIR_Coverage, 5661,
     /* 205220 */     GIR_EraseRootFromParent_Done,
     /* 205221 */   // Label 3281: @205221
     /* 205221 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(205280), // Rule ID 5665 //
     /* 205226 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205233 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205246 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64),
     /* 205249 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205278 */     GIR_RootConstrainSelectedInstOperands,
     /* 205279 */     // GIR_Coverage, 5665,
     /* 205279 */     GIR_EraseRootFromParent_Done,
     /* 205280 */   // Label 3282: @205280
     /* 205280 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(205346), // Rule ID 5659 //
     /* 205285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205288 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205310 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64_RTN),
     /* 205313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205315 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205344 */     GIR_RootConstrainSelectedInstOperands,
     /* 205345 */     // GIR_Coverage, 5659,
     /* 205345 */     GIR_EraseRootFromParent_Done,
     /* 205346 */   // Label 3283: @205346
     /* 205346 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(205409), // Rule ID 5663 //
     /* 205351 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 205373 */     // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN),
     /* 205376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205378 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 205385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 205395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 205400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205407 */     GIR_RootConstrainSelectedInstOperands,
     /* 205408 */     // GIR_Coverage, 5663,
     /* 205408 */     GIR_EraseRootFromParent_Done,
     /* 205409 */   // Label 3284: @205409
     /* 205409 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(205466), // Rule ID 5660 //
     /* 205414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205417 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205424 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205437 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
     /* 205440 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205464 */     GIR_RootConstrainSelectedInstOperands,
     /* 205465 */     // GIR_Coverage, 5660,
     /* 205465 */     GIR_EraseRootFromParent_Done,
     /* 205466 */   // Label 3285: @205466
     /* 205466 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(205520), // Rule ID 5664 //
     /* 205471 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205478 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205491 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
     /* 205494 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205518 */     GIR_RootConstrainSelectedInstOperands,
     /* 205519 */     // GIR_Coverage, 5664,
     /* 205519 */     GIR_EraseRootFromParent_Done,
     /* 205520 */   // Label 3286: @205520
     /* 205520 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(205581), // Rule ID 5658 //
     /* 205525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 205528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205550 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
     /* 205553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205555 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205579 */     GIR_RootConstrainSelectedInstOperands,
     /* 205580 */     // GIR_Coverage, 5658,
     /* 205580 */     GIR_EraseRootFromParent_Done,
     /* 205581 */   // Label 3287: @205581
     /* 205581 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(205639), // Rule ID 5662 //
     /* 205586 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 205608 */     // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 205608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
     /* 205611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 205613 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 205615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 205620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 205625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205637 */     GIR_RootConstrainSelectedInstOperands,
     /* 205638 */     // GIR_Coverage, 5662,
     /* 205638 */     GIR_EraseRootFromParent_Done,
     /* 205639 */   // Label 3288: @205639
     /* 205639 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(205689), // Rule ID 8310 //
     /* 205644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 205647 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205652 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205665 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
     /* 205668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205673 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205687 */     GIR_RootConstrainSelectedInstOperands,
     /* 205688 */     // GIR_Coverage, 8310,
     /* 205688 */     GIR_EraseRootFromParent_Done,
     /* 205689 */   // Label 3289: @205689
     /* 205689 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(205739), // Rule ID 8312 //
     /* 205694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 205697 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205702 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205715 */     // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i32>>  =>  (DS_XOR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32_gfx9),
     /* 205718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205723 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205737 */     GIR_RootConstrainSelectedInstOperands,
     /* 205738 */     // GIR_Coverage, 8312,
     /* 205738 */     GIR_EraseRootFromParent_Done,
     /* 205739 */   // Label 3290: @205739
     /* 205739 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(205789), // Rule ID 8314 //
     /* 205744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 205747 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 205752 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205765 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 205765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
     /* 205768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205773 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205787 */     GIR_RootConstrainSelectedInstOperands,
     /* 205788 */     // GIR_Coverage, 8314,
     /* 205788 */     GIR_EraseRootFromParent_Done,
     /* 205789 */   // Label 3291: @205789
     /* 205789 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(205843), // Rule ID 8309 //
     /* 205794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 205797 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205817 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
     /* 205820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205827 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205841 */     GIR_RootConstrainSelectedInstOperands,
     /* 205842 */     // GIR_Coverage, 8309,
     /* 205842 */     GIR_EraseRootFromParent_Done,
     /* 205843 */   // Label 3292: @205843
     /* 205843 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(205897), // Rule ID 8311 //
     /* 205848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 205851 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 205856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205871 */     // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_i32>>  =>  (DS_XOR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 205871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32_gfx9),
     /* 205874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205881 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205895 */     GIR_RootConstrainSelectedInstOperands,
     /* 205896 */     // GIR_Coverage, 8311,
     /* 205896 */     GIR_EraseRootFromParent_Done,
     /* 205897 */   // Label 3293: @205897
     /* 205897 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(205951), // Rule ID 8313 //
     /* 205902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 205905 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 205910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 205914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 205925 */     // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 205925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
     /* 205928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 205930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 205935 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 205937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 205942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 205949 */     GIR_RootConstrainSelectedInstOperands,
     /* 205950 */     // GIR_Coverage, 8313,
     /* 205950 */     GIR_EraseRootFromParent_Done,
     /* 205951 */   // Label 3294: @205951
     /* 205951 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(206008), // Rule ID 4062 //
     /* 205956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 205959 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 205966 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 205968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 205972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 205979 */     // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 205979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR),
     /* 205982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 205987 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 205989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 205994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 205999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206006 */     GIR_RootConstrainSelectedInstOperands,
     /* 206007 */     // GIR_Coverage, 4062,
     /* 206007 */     GIR_EraseRootFromParent_Done,
     /* 206008 */   // Label 3295: @206008
     /* 206008 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(206069), // Rule ID 4064 //
     /* 206013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 206016 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 206038 */     // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 206038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR_RTN),
     /* 206041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 206048 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 206055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206067 */     GIR_RootConstrainSelectedInstOperands,
     /* 206068 */     // GIR_Coverage, 4064,
     /* 206068 */     GIR_EraseRootFromParent_Done,
     /* 206069 */   // Label 3296: @206069
     /* 206069 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(206121), // Rule ID 4061 //
     /* 206074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 206077 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206084 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 206097 */     // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 206097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR),
     /* 206100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206105 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206119 */     GIR_RootConstrainSelectedInstOperands,
     /* 206120 */     // GIR_Coverage, 4061,
     /* 206120 */     GIR_EraseRootFromParent_Done,
     /* 206121 */   // Label 3297: @206121
     /* 206121 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(206177), // Rule ID 4063 //
     /* 206126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 206129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 206151 */     // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 206151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_RTN),
     /* 206154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206161 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206175 */     GIR_RootConstrainSelectedInstOperands,
     /* 206176 */     // GIR_Coverage, 4063,
     /* 206176 */     GIR_EraseRootFromParent_Done,
     /* 206177 */   // Label 3298: @206177
     /* 206177 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(206230), // Rule ID 3696 //
     /* 206182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206185 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206193 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206206 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 206206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
     /* 206209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206214 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206228 */     GIR_RootConstrainSelectedInstOperands,
     /* 206229 */     // GIR_Coverage, 3696,
     /* 206229 */     GIR_EraseRootFromParent_Done,
     /* 206230 */   // Label 3299: @206230
     /* 206230 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(206282), // Rule ID 3756 //
     /* 206235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206245 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206258 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 206258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
     /* 206261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206266 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206280 */     GIR_RootConstrainSelectedInstOperands,
     /* 206281 */     // GIR_Coverage, 3756,
     /* 206281 */     GIR_EraseRootFromParent_Done,
     /* 206282 */   // Label 3300: @206282
     /* 206282 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(206339), // Rule ID 3695 //
     /* 206287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206290 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206313 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 206313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
     /* 206316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206323 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206337 */     GIR_RootConstrainSelectedInstOperands,
     /* 206338 */     // GIR_Coverage, 3695,
     /* 206338 */     GIR_EraseRootFromParent_Done,
     /* 206339 */   // Label 3301: @206339
     /* 206339 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(206395), // Rule ID 3755 //
     /* 206344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 206347 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 206358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 206369 */     // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 206369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
     /* 206372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 206374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 206379 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 206381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206393 */     GIR_RootConstrainSelectedInstOperands,
     /* 206394 */     // GIR_Coverage, 3755,
     /* 206394 */     GIR_EraseRootFromParent_Done,
     /* 206395 */   // Label 3302: @206395
     /* 206395 */   GIM_Reject,
     /* 206396 */ // Label 3280: @206396
     /* 206396 */ GIM_Reject,
     /* 206397 */ // Label 3278: @206397
     /* 206397 */ GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(207642),
     /* 206402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206405 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(206467), // Rule ID 5757 //
     /* 206410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206413 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206420 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206433 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64),
     /* 206436 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206465 */     GIR_RootConstrainSelectedInstOperands,
     /* 206466 */     // GIR_Coverage, 5757,
     /* 206466 */     GIR_EraseRootFromParent_Done,
     /* 206467 */   // Label 3304: @206467
     /* 206467 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(206526), // Rule ID 5761 //
     /* 206472 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206479 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206492 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64),
     /* 206495 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206524 */     GIR_RootConstrainSelectedInstOperands,
     /* 206525 */     // GIR_Coverage, 5761,
     /* 206525 */     GIR_EraseRootFromParent_Done,
     /* 206526 */   // Label 3305: @206526
     /* 206526 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(206592), // Rule ID 5755 //
     /* 206531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206534 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206556 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64_RTN),
     /* 206559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206561 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206590 */     GIR_RootConstrainSelectedInstOperands,
     /* 206591 */     // GIR_Coverage, 5755,
     /* 206591 */     GIR_EraseRootFromParent_Done,
     /* 206592 */   // Label 3306: @206592
     /* 206592 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(206655), // Rule ID 5759 //
     /* 206597 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 206619 */     // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN),
     /* 206622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206624 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 206631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 206641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 206646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206653 */     GIR_RootConstrainSelectedInstOperands,
     /* 206654 */     // GIR_Coverage, 5759,
     /* 206654 */     GIR_EraseRootFromParent_Done,
     /* 206655 */   // Label 3307: @206655
     /* 206655 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(206712), // Rule ID 5756 //
     /* 206660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206670 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206683 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
     /* 206686 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206710 */     GIR_RootConstrainSelectedInstOperands,
     /* 206711 */     // GIR_Coverage, 5756,
     /* 206711 */     GIR_EraseRootFromParent_Done,
     /* 206712 */   // Label 3308: @206712
     /* 206712 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(206766), // Rule ID 5760 //
     /* 206717 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206724 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206737 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
     /* 206740 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206764 */     GIR_RootConstrainSelectedInstOperands,
     /* 206765 */     // GIR_Coverage, 5760,
     /* 206765 */     GIR_EraseRootFromParent_Done,
     /* 206766 */   // Label 3309: @206766
     /* 206766 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(206827), // Rule ID 5754 //
     /* 206771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 206774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206796 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
     /* 206799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206801 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206825 */     GIR_RootConstrainSelectedInstOperands,
     /* 206826 */     // GIR_Coverage, 5754,
     /* 206826 */     GIR_EraseRootFromParent_Done,
     /* 206827 */   // Label 3310: @206827
     /* 206827 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(206885), // Rule ID 5758 //
     /* 206832 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 206839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 206843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 206854 */     // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 206854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
     /* 206857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 206859 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 206861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 206866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 206871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 206876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206883 */     GIR_RootConstrainSelectedInstOperands,
     /* 206884 */     // GIR_Coverage, 5758,
     /* 206884 */     GIR_EraseRootFromParent_Done,
     /* 206885 */   // Label 3311: @206885
     /* 206885 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(206935), // Rule ID 8403 //
     /* 206890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 206893 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206898 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206911 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
     /* 206914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206919 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206933 */     GIR_RootConstrainSelectedInstOperands,
     /* 206934 */     // GIR_Coverage, 8403,
     /* 206934 */     GIR_EraseRootFromParent_Done,
     /* 206935 */   // Label 3312: @206935
     /* 206935 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(206985), // Rule ID 8405 //
     /* 206940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 206943 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 206948 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 206950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 206954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 206961 */     // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i64>>  =>  (DS_XOR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 206961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64_gfx9),
     /* 206964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 206969 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 206971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 206976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 206983 */     GIR_RootConstrainSelectedInstOperands,
     /* 206984 */     // GIR_Coverage, 8405,
     /* 206984 */     GIR_EraseRootFromParent_Done,
     /* 206985 */   // Label 3313: @206985
     /* 206985 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(207035), // Rule ID 8407 //
     /* 206990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 206993 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 206998 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207011 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 207011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
     /* 207014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207019 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207033 */     GIR_RootConstrainSelectedInstOperands,
     /* 207034 */     // GIR_Coverage, 8407,
     /* 207034 */     GIR_EraseRootFromParent_Done,
     /* 207035 */   // Label 3314: @207035
     /* 207035 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(207089), // Rule ID 8402 //
     /* 207040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 207043 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 207048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207063 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 207063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
     /* 207066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207073 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207087 */     GIR_RootConstrainSelectedInstOperands,
     /* 207088 */     // GIR_Coverage, 8402,
     /* 207088 */     GIR_EraseRootFromParent_Done,
     /* 207089 */   // Label 3315: @207089
     /* 207089 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(207143), // Rule ID 8404 //
     /* 207094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 207097 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 207102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207117 */     // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_i64>>  =>  (DS_XOR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 207117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64_gfx9),
     /* 207120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207127 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207141 */     GIR_RootConstrainSelectedInstOperands,
     /* 207142 */     // GIR_Coverage, 8404,
     /* 207142 */     GIR_EraseRootFromParent_Done,
     /* 207143 */   // Label 3316: @207143
     /* 207143 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(207197), // Rule ID 8406 //
     /* 207148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 207151 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 207156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 207171 */     // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 207171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
     /* 207174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 207181 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 207183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207195 */     GIR_RootConstrainSelectedInstOperands,
     /* 207196 */     // GIR_Coverage, 8406,
     /* 207196 */     GIR_EraseRootFromParent_Done,
     /* 207197 */   // Label 3317: @207197
     /* 207197 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(207254), // Rule ID 4118 //
     /* 207202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207205 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207212 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 207225 */     // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 207225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR),
     /* 207228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 207233 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 207240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207252 */     GIR_RootConstrainSelectedInstOperands,
     /* 207253 */     // GIR_Coverage, 4118,
     /* 207253 */     GIR_EraseRootFromParent_Done,
     /* 207254 */   // Label 3318: @207254
     /* 207254 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(207315), // Rule ID 4120 //
     /* 207259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207262 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 207284 */     // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 207284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR_RTN),
     /* 207287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 207294 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 207301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207313 */     GIR_RootConstrainSelectedInstOperands,
     /* 207314 */     // GIR_Coverage, 4120,
     /* 207314 */     GIR_EraseRootFromParent_Done,
     /* 207315 */   // Label 3319: @207315
     /* 207315 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(207367), // Rule ID 4117 //
     /* 207320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207323 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207330 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 207343 */     // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 207343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2),
     /* 207346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207351 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207365 */     GIR_RootConstrainSelectedInstOperands,
     /* 207366 */     // GIR_Coverage, 4117,
     /* 207366 */     GIR_EraseRootFromParent_Done,
     /* 207367 */   // Label 3320: @207367
     /* 207367 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(207423), // Rule ID 4119 //
     /* 207372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 207375 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 207397 */     // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 207397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_RTN),
     /* 207400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207407 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207421 */     GIR_RootConstrainSelectedInstOperands,
     /* 207422 */     // GIR_Coverage, 4119,
     /* 207422 */     GIR_EraseRootFromParent_Done,
     /* 207423 */   // Label 3321: @207423
     /* 207423 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(207476), // Rule ID 3722 //
     /* 207428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207431 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207439 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207452 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 207452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
     /* 207455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207460 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207474 */     GIR_RootConstrainSelectedInstOperands,
     /* 207475 */     // GIR_Coverage, 3722,
     /* 207475 */     GIR_EraseRootFromParent_Done,
     /* 207476 */   // Label 3322: @207476
     /* 207476 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(207528), // Rule ID 3782 //
     /* 207481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207484 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207491 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207504 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 207504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
     /* 207507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207512 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207526 */     GIR_RootConstrainSelectedInstOperands,
     /* 207527 */     // GIR_Coverage, 3782,
     /* 207527 */     GIR_EraseRootFromParent_Done,
     /* 207528 */   // Label 3323: @207528
     /* 207528 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(207585), // Rule ID 3721 //
     /* 207533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207536 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207559 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 207559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
     /* 207562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207569 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207583 */     GIR_RootConstrainSelectedInstOperands,
     /* 207584 */     // GIR_Coverage, 3721,
     /* 207584 */     GIR_EraseRootFromParent_Done,
     /* 207585 */   // Label 3324: @207585
     /* 207585 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(207641), // Rule ID 3781 //
     /* 207590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 207593 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 207604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 207615 */     // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 207615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
     /* 207618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 207620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 207625 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 207627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 207632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207639 */     GIR_RootConstrainSelectedInstOperands,
     /* 207640 */     // GIR_Coverage, 3781,
     /* 207640 */     GIR_EraseRootFromParent_Done,
     /* 207641 */   // Label 3325: @207641
     /* 207641 */   GIM_Reject,
     /* 207642 */ // Label 3303: @207642
     /* 207642 */ GIM_Reject,
     /* 207643 */ // Label 3279: @207643
     /* 207643 */ GIM_Reject,
     /* 207644 */ // Label 25: @207644
     /* 207644 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3328*/ GIMT_Encode4(210155),
     /* 207655 */ /*GILLT_s32*//*Label 3326*/ GIMT_Encode4(207663),
     /* 207659 */ /*GILLT_s64*//*Label 3327*/ GIMT_Encode4(208909),
     /* 207663 */ // Label 3326: @207663
     /* 207663 */ GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(208908),
     /* 207668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207671 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(207733), // Rule ID 5629 //
     /* 207676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207679 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207686 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207699 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64),
     /* 207702 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207731 */     GIR_RootConstrainSelectedInstOperands,
     /* 207732 */     // GIR_Coverage, 5629,
     /* 207732 */     GIR_EraseRootFromParent_Done,
     /* 207733 */   // Label 3330: @207733
     /* 207733 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(207792), // Rule ID 5633 //
     /* 207738 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207745 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207758 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64),
     /* 207761 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207790 */     GIR_RootConstrainSelectedInstOperands,
     /* 207791 */     // GIR_Coverage, 5633,
     /* 207791 */     GIR_EraseRootFromParent_Done,
     /* 207792 */   // Label 3331: @207792
     /* 207792 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(207858), // Rule ID 5627 //
     /* 207797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207800 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207822 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64_RTN),
     /* 207825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207827 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207856 */     GIR_RootConstrainSelectedInstOperands,
     /* 207857 */     // GIR_Coverage, 5627,
     /* 207857 */     GIR_EraseRootFromParent_Done,
     /* 207858 */   // Label 3332: @207858
     /* 207858 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(207921), // Rule ID 5631 //
     /* 207863 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 207874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 207885 */     // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN),
     /* 207888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 207890 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 207897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 207907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 207912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207919 */     GIR_RootConstrainSelectedInstOperands,
     /* 207920 */     // GIR_Coverage, 5631,
     /* 207920 */     GIR_EraseRootFromParent_Done,
     /* 207921 */   // Label 3333: @207921
     /* 207921 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(207978), // Rule ID 5628 //
     /* 207926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 207929 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207936 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 207949 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 207949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
     /* 207952 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 207954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 207959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 207964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 207969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 207976 */     GIR_RootConstrainSelectedInstOperands,
     /* 207977 */     // GIR_Coverage, 5628,
     /* 207977 */     GIR_EraseRootFromParent_Done,
     /* 207978 */   // Label 3334: @207978
     /* 207978 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(208032), // Rule ID 5632 //
     /* 207983 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 207990 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 207992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 207996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 208003 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
     /* 208006 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 208018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208030 */     GIR_RootConstrainSelectedInstOperands,
     /* 208031 */     // GIR_Coverage, 5632,
     /* 208031 */     GIR_EraseRootFromParent_Done,
     /* 208032 */   // Label 3335: @208032
     /* 208032 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(208093), // Rule ID 5626 //
     /* 208037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 208040 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 208062 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
     /* 208065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 208067 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 208079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208091 */     GIR_RootConstrainSelectedInstOperands,
     /* 208092 */     // GIR_Coverage, 5626,
     /* 208092 */     GIR_EraseRootFromParent_Done,
     /* 208093 */   // Label 3336: @208093
     /* 208093 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(208151), // Rule ID 5630 //
     /* 208098 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 208120 */     // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
     /* 208123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 208125 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 208137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208149 */     GIR_RootConstrainSelectedInstOperands,
     /* 208150 */     // GIR_Coverage, 5630,
     /* 208150 */     GIR_EraseRootFromParent_Done,
     /* 208151 */   // Label 3337: @208151
     /* 208151 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(208201), // Rule ID 8322 //
     /* 208156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 208159 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208164 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208177 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
     /* 208180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208185 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208199 */     GIR_RootConstrainSelectedInstOperands,
     /* 208200 */     // GIR_Coverage, 8322,
     /* 208200 */     GIR_EraseRootFromParent_Done,
     /* 208201 */   // Label 3338: @208201
     /* 208201 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(208251), // Rule ID 8324 //
     /* 208206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 208209 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208214 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208227 */     // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_noret_i32>>  =>  (DS_MAX_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32_gfx9),
     /* 208230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208235 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208249 */     GIR_RootConstrainSelectedInstOperands,
     /* 208250 */     // GIR_Coverage, 8324,
     /* 208250 */     GIR_EraseRootFromParent_Done,
     /* 208251 */   // Label 3339: @208251
     /* 208251 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(208301), // Rule ID 8326 //
     /* 208256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 208259 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 208264 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208277 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 208277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
     /* 208280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208285 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208299 */     GIR_RootConstrainSelectedInstOperands,
     /* 208300 */     // GIR_Coverage, 8326,
     /* 208300 */     GIR_EraseRootFromParent_Done,
     /* 208301 */   // Label 3340: @208301
     /* 208301 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(208355), // Rule ID 8321 //
     /* 208306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 208309 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208329 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
     /* 208332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208339 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208353 */     GIR_RootConstrainSelectedInstOperands,
     /* 208354 */     // GIR_Coverage, 8321,
     /* 208354 */     GIR_EraseRootFromParent_Done,
     /* 208355 */   // Label 3341: @208355
     /* 208355 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(208409), // Rule ID 8323 //
     /* 208360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 208363 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 208368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208383 */     // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_i32>>  =>  (DS_MAX_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 208383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32_gfx9),
     /* 208386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208393 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208407 */     GIR_RootConstrainSelectedInstOperands,
     /* 208408 */     // GIR_Coverage, 8323,
     /* 208408 */     GIR_EraseRootFromParent_Done,
     /* 208409 */   // Label 3342: @208409
     /* 208409 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(208463), // Rule ID 8325 //
     /* 208414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 208417 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 208422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 208437 */     // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 208437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
     /* 208440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 208447 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 208449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208461 */     GIR_RootConstrainSelectedInstOperands,
     /* 208462 */     // GIR_Coverage, 8325,
     /* 208462 */     GIR_EraseRootFromParent_Done,
     /* 208463 */   // Label 3343: @208463
     /* 208463 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(208520), // Rule ID 4034 //
     /* 208468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208471 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208478 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 208491 */     // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 208491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR),
     /* 208494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 208499 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 208506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208518 */     GIR_RootConstrainSelectedInstOperands,
     /* 208519 */     // GIR_Coverage, 4034,
     /* 208519 */     GIR_EraseRootFromParent_Done,
     /* 208520 */   // Label 3344: @208520
     /* 208520 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(208581), // Rule ID 4036 //
     /* 208525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208528 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208539 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 208550 */     // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 208550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR_RTN),
     /* 208553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 208560 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 208567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 208572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208579 */     GIR_RootConstrainSelectedInstOperands,
     /* 208580 */     // GIR_Coverage, 4036,
     /* 208580 */     GIR_EraseRootFromParent_Done,
     /* 208581 */   // Label 3345: @208581
     /* 208581 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(208633), // Rule ID 4033 //
     /* 208586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208589 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208596 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 208609 */     // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 208609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX),
     /* 208612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208617 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208631 */     GIR_RootConstrainSelectedInstOperands,
     /* 208632 */     // GIR_Coverage, 4033,
     /* 208632 */     GIR_EraseRootFromParent_Done,
     /* 208633 */   // Label 3346: @208633
     /* 208633 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(208689), // Rule ID 4035 //
     /* 208638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 208641 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 208663 */     // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 208663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_RTN),
     /* 208666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208673 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208687 */     GIR_RootConstrainSelectedInstOperands,
     /* 208688 */     // GIR_Coverage, 4035,
     /* 208688 */     GIR_EraseRootFromParent_Done,
     /* 208689 */   // Label 3347: @208689
     /* 208689 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(208742), // Rule ID 3682 //
     /* 208694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208697 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208705 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208718 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 208718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
     /* 208721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208726 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208740 */     GIR_RootConstrainSelectedInstOperands,
     /* 208741 */     // GIR_Coverage, 3682,
     /* 208741 */     GIR_EraseRootFromParent_Done,
     /* 208742 */   // Label 3348: @208742
     /* 208742 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(208794), // Rule ID 3742 //
     /* 208747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208750 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208757 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208770 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 208770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
     /* 208773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208778 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208792 */     GIR_RootConstrainSelectedInstOperands,
     /* 208793 */     // GIR_Coverage, 3742,
     /* 208793 */     GIR_EraseRootFromParent_Done,
     /* 208794 */   // Label 3349: @208794
     /* 208794 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(208851), // Rule ID 3681 //
     /* 208799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208802 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208825 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 208825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
     /* 208828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208835 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208849 */     GIR_RootConstrainSelectedInstOperands,
     /* 208850 */     // GIR_Coverage, 3681,
     /* 208850 */     GIR_EraseRootFromParent_Done,
     /* 208851 */   // Label 3350: @208851
     /* 208851 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(208907), // Rule ID 3741 //
     /* 208856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 208859 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 208870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 208881 */     // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 208881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
     /* 208884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 208886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 208891 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 208893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 208898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208905 */     GIR_RootConstrainSelectedInstOperands,
     /* 208906 */     // GIR_Coverage, 3741,
     /* 208906 */     GIR_EraseRootFromParent_Done,
     /* 208907 */   // Label 3351: @208907
     /* 208907 */   GIM_Reject,
     /* 208908 */ // Label 3329: @208908
     /* 208908 */ GIM_Reject,
     /* 208909 */ // Label 3327: @208909
     /* 208909 */ GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(210154),
     /* 208914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208917 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(208979), // Rule ID 5725 //
     /* 208922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 208925 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208932 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 208945 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 208945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64),
     /* 208948 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 208950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 208955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 208960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 208965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 208970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 208977 */     GIR_RootConstrainSelectedInstOperands,
     /* 208978 */     // GIR_Coverage, 5725,
     /* 208978 */     GIR_EraseRootFromParent_Done,
     /* 208979 */   // Label 3353: @208979
     /* 208979 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(209038), // Rule ID 5729 //
     /* 208984 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 208991 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 208993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 208997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 209004 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64),
     /* 209007 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 209014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 209024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 209029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209036 */     GIR_RootConstrainSelectedInstOperands,
     /* 209037 */     // GIR_Coverage, 5729,
     /* 209037 */     GIR_EraseRootFromParent_Done,
     /* 209038 */   // Label 3354: @209038
     /* 209038 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(209104), // Rule ID 5723 //
     /* 209043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209046 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 209068 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN),
     /* 209071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209073 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 209080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 209090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 209095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209102 */     GIR_RootConstrainSelectedInstOperands,
     /* 209103 */     // GIR_Coverage, 5723,
     /* 209103 */     GIR_EraseRootFromParent_Done,
     /* 209104 */   // Label 3355: @209104
     /* 209104 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(209167), // Rule ID 5727 //
     /* 209109 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 209131 */     // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN),
     /* 209134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209136 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 209143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 209153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 209158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209165 */     GIR_RootConstrainSelectedInstOperands,
     /* 209166 */     // GIR_Coverage, 5727,
     /* 209166 */     GIR_EraseRootFromParent_Done,
     /* 209167 */   // Label 3356: @209167
     /* 209167 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(209224), // Rule ID 5724 //
     /* 209172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209175 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209182 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209195 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
     /* 209198 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209222 */     GIR_RootConstrainSelectedInstOperands,
     /* 209223 */     // GIR_Coverage, 5724,
     /* 209223 */     GIR_EraseRootFromParent_Done,
     /* 209224 */   // Label 3357: @209224
     /* 209224 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(209278), // Rule ID 5728 //
     /* 209229 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209236 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209249 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
     /* 209252 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209276 */     GIR_RootConstrainSelectedInstOperands,
     /* 209277 */     // GIR_Coverage, 5728,
     /* 209277 */     GIR_EraseRootFromParent_Done,
     /* 209278 */   // Label 3358: @209278
     /* 209278 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(209339), // Rule ID 5722 //
     /* 209283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 209286 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209308 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
     /* 209311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209313 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209337 */     GIR_RootConstrainSelectedInstOperands,
     /* 209338 */     // GIR_Coverage, 5722,
     /* 209338 */     GIR_EraseRootFromParent_Done,
     /* 209339 */   // Label 3359: @209339
     /* 209339 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(209397), // Rule ID 5726 //
     /* 209344 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 209366 */     // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 209366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
     /* 209369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 209371 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 209373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 209378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 209383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209395 */     GIR_RootConstrainSelectedInstOperands,
     /* 209396 */     // GIR_Coverage, 5726,
     /* 209396 */     GIR_EraseRootFromParent_Done,
     /* 209397 */   // Label 3360: @209397
     /* 209397 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(209447), // Rule ID 8415 //
     /* 209402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 209405 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209410 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209423 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
     /* 209426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209445 */     GIR_RootConstrainSelectedInstOperands,
     /* 209446 */     // GIR_Coverage, 8415,
     /* 209446 */     GIR_EraseRootFromParent_Done,
     /* 209447 */   // Label 3361: @209447
     /* 209447 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(209497), // Rule ID 8417 //
     /* 209452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 209455 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209460 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209473 */     // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_noret_i64>>  =>  (DS_MAX_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64_gfx9),
     /* 209476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209481 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209495 */     GIR_RootConstrainSelectedInstOperands,
     /* 209496 */     // GIR_Coverage, 8417,
     /* 209496 */     GIR_EraseRootFromParent_Done,
     /* 209497 */   // Label 3362: @209497
     /* 209497 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(209547), // Rule ID 8419 //
     /* 209502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 209505 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 209510 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209523 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 209523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
     /* 209526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209531 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209545 */     GIR_RootConstrainSelectedInstOperands,
     /* 209546 */     // GIR_Coverage, 8419,
     /* 209546 */     GIR_EraseRootFromParent_Done,
     /* 209547 */   // Label 3363: @209547
     /* 209547 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(209601), // Rule ID 8414 //
     /* 209552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 209555 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209575 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
     /* 209578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209585 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209599 */     GIR_RootConstrainSelectedInstOperands,
     /* 209600 */     // GIR_Coverage, 8414,
     /* 209600 */     GIR_EraseRootFromParent_Done,
     /* 209601 */   // Label 3364: @209601
     /* 209601 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(209655), // Rule ID 8416 //
     /* 209606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 209609 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 209614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209629 */     // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_i64>>  =>  (DS_MAX_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 209629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64_gfx9),
     /* 209632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209639 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209653 */     GIR_RootConstrainSelectedInstOperands,
     /* 209654 */     // GIR_Coverage, 8416,
     /* 209654 */     GIR_EraseRootFromParent_Done,
     /* 209655 */   // Label 3365: @209655
     /* 209655 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(209709), // Rule ID 8418 //
     /* 209660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 209663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 209668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 209683 */     // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 209683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
     /* 209686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 209693 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 209695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209707 */     GIR_RootConstrainSelectedInstOperands,
     /* 209708 */     // GIR_Coverage, 8418,
     /* 209708 */     GIR_EraseRootFromParent_Done,
     /* 209709 */   // Label 3366: @209709
     /* 209709 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(209766), // Rule ID 4090 //
     /* 209714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209717 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209724 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 209737 */     // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 209737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR),
     /* 209740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 209745 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 209752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209764 */     GIR_RootConstrainSelectedInstOperands,
     /* 209765 */     // GIR_Coverage, 4090,
     /* 209765 */     GIR_EraseRootFromParent_Done,
     /* 209766 */   // Label 3367: @209766
     /* 209766 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(209827), // Rule ID 4092 //
     /* 209771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 209796 */     // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 209796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN),
     /* 209799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 209806 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 209813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 209818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209825 */     GIR_RootConstrainSelectedInstOperands,
     /* 209826 */     // GIR_Coverage, 4092,
     /* 209826 */     GIR_EraseRootFromParent_Done,
     /* 209827 */   // Label 3368: @209827
     /* 209827 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(209879), // Rule ID 4089 //
     /* 209832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209835 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209842 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 209855 */     // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 209855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2),
     /* 209858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209863 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209877 */     GIR_RootConstrainSelectedInstOperands,
     /* 209878 */     // GIR_Coverage, 4089,
     /* 209878 */     GIR_EraseRootFromParent_Done,
     /* 209879 */   // Label 3369: @209879
     /* 209879 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(209935), // Rule ID 4091 //
     /* 209884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 209887 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 209898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 209909 */     // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 209909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_RTN),
     /* 209912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 209914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209919 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209933 */     GIR_RootConstrainSelectedInstOperands,
     /* 209934 */     // GIR_Coverage, 4091,
     /* 209934 */     GIR_EraseRootFromParent_Done,
     /* 209935 */   // Label 3370: @209935
     /* 209935 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(209988), // Rule ID 3708 //
     /* 209940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 209943 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 209951 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 209953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 209957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 209964 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 209964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
     /* 209967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 209972 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 209974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 209979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 209986 */     GIR_RootConstrainSelectedInstOperands,
     /* 209987 */     // GIR_Coverage, 3708,
     /* 209987 */     GIR_EraseRootFromParent_Done,
     /* 209988 */   // Label 3371: @209988
     /* 209988 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(210040), // Rule ID 3768 //
     /* 209993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 209996 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210003 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 210016 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 210016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
     /* 210019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210024 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210038 */     GIR_RootConstrainSelectedInstOperands,
     /* 210039 */     // GIR_Coverage, 3768,
     /* 210039 */     GIR_EraseRootFromParent_Done,
     /* 210040 */   // Label 3372: @210040
     /* 210040 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(210097), // Rule ID 3707 //
     /* 210045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 210048 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 210071 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 210071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
     /* 210074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210081 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210095 */     GIR_RootConstrainSelectedInstOperands,
     /* 210096 */     // GIR_Coverage, 3707,
     /* 210096 */     GIR_EraseRootFromParent_Done,
     /* 210097 */   // Label 3373: @210097
     /* 210097 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(210153), // Rule ID 3767 //
     /* 210102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 210105 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 210116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 210127 */     // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 210127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
     /* 210130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 210137 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 210139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210151 */     GIR_RootConstrainSelectedInstOperands,
     /* 210152 */     // GIR_Coverage, 3767,
     /* 210152 */     GIR_EraseRootFromParent_Done,
     /* 210153 */   // Label 3374: @210153
     /* 210153 */   GIM_Reject,
     /* 210154 */ // Label 3352: @210154
     /* 210154 */ GIM_Reject,
     /* 210155 */ // Label 3328: @210155
     /* 210155 */ GIM_Reject,
     /* 210156 */ // Label 26: @210156
     /* 210156 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3377*/ GIMT_Encode4(212667),
     /* 210167 */ /*GILLT_s32*//*Label 3375*/ GIMT_Encode4(210175),
     /* 210171 */ /*GILLT_s64*//*Label 3376*/ GIMT_Encode4(211421),
     /* 210175 */ // Label 3375: @210175
     /* 210175 */ GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(211420),
     /* 210180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210183 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(210245), // Rule ID 5613 //
     /* 210188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210191 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210198 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210211 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64),
     /* 210214 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210243 */     GIR_RootConstrainSelectedInstOperands,
     /* 210244 */     // GIR_Coverage, 5613,
     /* 210244 */     GIR_EraseRootFromParent_Done,
     /* 210245 */   // Label 3379: @210245
     /* 210245 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(210304), // Rule ID 5617 //
     /* 210250 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210257 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210270 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64),
     /* 210273 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210302 */     GIR_RootConstrainSelectedInstOperands,
     /* 210303 */     // GIR_Coverage, 5617,
     /* 210303 */     GIR_EraseRootFromParent_Done,
     /* 210304 */   // Label 3380: @210304
     /* 210304 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(210370), // Rule ID 5611 //
     /* 210309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210312 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210334 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64_RTN),
     /* 210337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210339 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210368 */     GIR_RootConstrainSelectedInstOperands,
     /* 210369 */     // GIR_Coverage, 5611,
     /* 210369 */     GIR_EraseRootFromParent_Done,
     /* 210370 */   // Label 3381: @210370
     /* 210370 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(210433), // Rule ID 5615 //
     /* 210375 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 210397 */     // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN),
     /* 210400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210402 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 210409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 210419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 210424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210431 */     GIR_RootConstrainSelectedInstOperands,
     /* 210432 */     // GIR_Coverage, 5615,
     /* 210432 */     GIR_EraseRootFromParent_Done,
     /* 210433 */   // Label 3382: @210433
     /* 210433 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(210490), // Rule ID 5612 //
     /* 210438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210448 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210461 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
     /* 210464 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210488 */     GIR_RootConstrainSelectedInstOperands,
     /* 210489 */     // GIR_Coverage, 5612,
     /* 210489 */     GIR_EraseRootFromParent_Done,
     /* 210490 */   // Label 3383: @210490
     /* 210490 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(210544), // Rule ID 5616 //
     /* 210495 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210502 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210515 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
     /* 210518 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210542 */     GIR_RootConstrainSelectedInstOperands,
     /* 210543 */     // GIR_Coverage, 5616,
     /* 210543 */     GIR_EraseRootFromParent_Done,
     /* 210544 */   // Label 3384: @210544
     /* 210544 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(210605), // Rule ID 5610 //
     /* 210549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 210552 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210574 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
     /* 210577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210579 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210603 */     GIR_RootConstrainSelectedInstOperands,
     /* 210604 */     // GIR_Coverage, 5610,
     /* 210604 */     GIR_EraseRootFromParent_Done,
     /* 210605 */   // Label 3385: @210605
     /* 210605 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(210663), // Rule ID 5614 //
     /* 210610 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 210632 */     // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 210632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
     /* 210635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 210637 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 210639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 210644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 210649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 210654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210661 */     GIR_RootConstrainSelectedInstOperands,
     /* 210662 */     // GIR_Coverage, 5614,
     /* 210662 */     GIR_EraseRootFromParent_Done,
     /* 210663 */   // Label 3386: @210663
     /* 210663 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(210713), // Rule ID 8316 //
     /* 210668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 210671 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210676 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210689 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
     /* 210692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210697 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210711 */     GIR_RootConstrainSelectedInstOperands,
     /* 210712 */     // GIR_Coverage, 8316,
     /* 210712 */     GIR_EraseRootFromParent_Done,
     /* 210713 */   // Label 3387: @210713
     /* 210713 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(210763), // Rule ID 8318 //
     /* 210718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 210721 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210726 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210739 */     // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_noret_i32>>  =>  (DS_MIN_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32_gfx9),
     /* 210742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210747 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210761 */     GIR_RootConstrainSelectedInstOperands,
     /* 210762 */     // GIR_Coverage, 8318,
     /* 210762 */     GIR_EraseRootFromParent_Done,
     /* 210763 */   // Label 3388: @210763
     /* 210763 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(210813), // Rule ID 8320 //
     /* 210768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 210771 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 210776 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210789 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 210789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
     /* 210792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210797 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210811 */     GIR_RootConstrainSelectedInstOperands,
     /* 210812 */     // GIR_Coverage, 8320,
     /* 210812 */     GIR_EraseRootFromParent_Done,
     /* 210813 */   // Label 3389: @210813
     /* 210813 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(210867), // Rule ID 8315 //
     /* 210818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 210821 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210841 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
     /* 210844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210851 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210865 */     GIR_RootConstrainSelectedInstOperands,
     /* 210866 */     // GIR_Coverage, 8315,
     /* 210866 */     GIR_EraseRootFromParent_Done,
     /* 210867 */   // Label 3390: @210867
     /* 210867 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(210921), // Rule ID 8317 //
     /* 210872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 210875 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 210880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210895 */     // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_i32>>  =>  (DS_MIN_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 210895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32_gfx9),
     /* 210898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210905 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 210915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210919 */     GIR_RootConstrainSelectedInstOperands,
     /* 210920 */     // GIR_Coverage, 8317,
     /* 210920 */     GIR_EraseRootFromParent_Done,
     /* 210921 */   // Label 3391: @210921
     /* 210921 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(210975), // Rule ID 8319 //
     /* 210926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 210929 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 210934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 210938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 210949 */     // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 210949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
     /* 210952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 210954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 210959 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 210961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 210966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 210969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 210973 */     GIR_RootConstrainSelectedInstOperands,
     /* 210974 */     // GIR_Coverage, 8319,
     /* 210974 */     GIR_EraseRootFromParent_Done,
     /* 210975 */   // Label 3392: @210975
     /* 210975 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(211032), // Rule ID 4042 //
     /* 210980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 210983 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 210990 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 210992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 210996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 211003 */     // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 211003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR),
     /* 211006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 211011 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 211018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211030 */     GIR_RootConstrainSelectedInstOperands,
     /* 211031 */     // GIR_Coverage, 4042,
     /* 211031 */     GIR_EraseRootFromParent_Done,
     /* 211032 */   // Label 3393: @211032
     /* 211032 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(211093), // Rule ID 4044 //
     /* 211037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 211040 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 211062 */     // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 211062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR_RTN),
     /* 211065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 211072 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 211079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211091 */     GIR_RootConstrainSelectedInstOperands,
     /* 211092 */     // GIR_Coverage, 4044,
     /* 211092 */     GIR_EraseRootFromParent_Done,
     /* 211093 */   // Label 3394: @211093
     /* 211093 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(211145), // Rule ID 4041 //
     /* 211098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 211101 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211108 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 211121 */     // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 211121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN),
     /* 211124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211129 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211143 */     GIR_RootConstrainSelectedInstOperands,
     /* 211144 */     // GIR_Coverage, 4041,
     /* 211144 */     GIR_EraseRootFromParent_Done,
     /* 211145 */   // Label 3395: @211145
     /* 211145 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(211201), // Rule ID 4043 //
     /* 211150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 211153 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 211175 */     // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 211175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_RTN),
     /* 211178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211185 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211199 */     GIR_RootConstrainSelectedInstOperands,
     /* 211200 */     // GIR_Coverage, 4043,
     /* 211200 */     GIR_EraseRootFromParent_Done,
     /* 211201 */   // Label 3396: @211201
     /* 211201 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(211254), // Rule ID 3686 //
     /* 211206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211209 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211217 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211230 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 211230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
     /* 211233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211238 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211252 */     GIR_RootConstrainSelectedInstOperands,
     /* 211253 */     // GIR_Coverage, 3686,
     /* 211253 */     GIR_EraseRootFromParent_Done,
     /* 211254 */   // Label 3397: @211254
     /* 211254 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(211306), // Rule ID 3746 //
     /* 211259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211262 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211269 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211282 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 211282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
     /* 211285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211290 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211304 */     GIR_RootConstrainSelectedInstOperands,
     /* 211305 */     // GIR_Coverage, 3746,
     /* 211305 */     GIR_EraseRootFromParent_Done,
     /* 211306 */   // Label 3398: @211306
     /* 211306 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(211363), // Rule ID 3685 //
     /* 211311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211314 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211337 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 211337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
     /* 211340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211347 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211361 */     GIR_RootConstrainSelectedInstOperands,
     /* 211362 */     // GIR_Coverage, 3685,
     /* 211362 */     GIR_EraseRootFromParent_Done,
     /* 211363 */   // Label 3399: @211363
     /* 211363 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(211419), // Rule ID 3745 //
     /* 211368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 211371 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 211382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 211393 */     // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 211393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
     /* 211396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 211398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 211403 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 211405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211417 */     GIR_RootConstrainSelectedInstOperands,
     /* 211418 */     // GIR_Coverage, 3745,
     /* 211418 */     GIR_EraseRootFromParent_Done,
     /* 211419 */   // Label 3400: @211419
     /* 211419 */   GIM_Reject,
     /* 211420 */ // Label 3378: @211420
     /* 211420 */ GIM_Reject,
     /* 211421 */ // Label 3376: @211421
     /* 211421 */ GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(212666),
     /* 211426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211429 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(211491), // Rule ID 5709 //
     /* 211434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211437 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211444 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211457 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64),
     /* 211460 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211489 */     GIR_RootConstrainSelectedInstOperands,
     /* 211490 */     // GIR_Coverage, 5709,
     /* 211490 */     GIR_EraseRootFromParent_Done,
     /* 211491 */   // Label 3402: @211491
     /* 211491 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(211550), // Rule ID 5713 //
     /* 211496 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211503 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211516 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64),
     /* 211519 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211548 */     GIR_RootConstrainSelectedInstOperands,
     /* 211549 */     // GIR_Coverage, 5713,
     /* 211549 */     GIR_EraseRootFromParent_Done,
     /* 211550 */   // Label 3403: @211550
     /* 211550 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(211616), // Rule ID 5707 //
     /* 211555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211558 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211580 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN),
     /* 211583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211585 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211614 */     GIR_RootConstrainSelectedInstOperands,
     /* 211615 */     // GIR_Coverage, 5707,
     /* 211615 */     GIR_EraseRootFromParent_Done,
     /* 211616 */   // Label 3404: @211616
     /* 211616 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(211679), // Rule ID 5711 //
     /* 211621 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 211643 */     // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN),
     /* 211646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211648 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 211655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 211665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 211670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211677 */     GIR_RootConstrainSelectedInstOperands,
     /* 211678 */     // GIR_Coverage, 5711,
     /* 211678 */     GIR_EraseRootFromParent_Done,
     /* 211679 */   // Label 3405: @211679
     /* 211679 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(211736), // Rule ID 5708 //
     /* 211684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211694 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211707 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
     /* 211710 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211734 */     GIR_RootConstrainSelectedInstOperands,
     /* 211735 */     // GIR_Coverage, 5708,
     /* 211735 */     GIR_EraseRootFromParent_Done,
     /* 211736 */   // Label 3406: @211736
     /* 211736 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(211790), // Rule ID 5712 //
     /* 211741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211748 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211761 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
     /* 211764 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211788 */     GIR_RootConstrainSelectedInstOperands,
     /* 211789 */     // GIR_Coverage, 5712,
     /* 211789 */     GIR_EraseRootFromParent_Done,
     /* 211790 */   // Label 3407: @211790
     /* 211790 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(211851), // Rule ID 5706 //
     /* 211795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 211798 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211820 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
     /* 211823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211825 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211849 */     GIR_RootConstrainSelectedInstOperands,
     /* 211850 */     // GIR_Coverage, 5706,
     /* 211850 */     GIR_EraseRootFromParent_Done,
     /* 211851 */   // Label 3408: @211851
     /* 211851 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(211909), // Rule ID 5710 //
     /* 211856 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 211863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 211867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 211878 */     // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 211878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
     /* 211881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 211883 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 211885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 211890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 211895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 211900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 211903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211907 */     GIR_RootConstrainSelectedInstOperands,
     /* 211908 */     // GIR_Coverage, 5710,
     /* 211908 */     GIR_EraseRootFromParent_Done,
     /* 211909 */   // Label 3409: @211909
     /* 211909 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(211959), // Rule ID 8409 //
     /* 211914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 211917 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211922 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211935 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
     /* 211938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211943 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 211950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 211953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 211957 */     GIR_RootConstrainSelectedInstOperands,
     /* 211958 */     // GIR_Coverage, 8409,
     /* 211958 */     GIR_EraseRootFromParent_Done,
     /* 211959 */   // Label 3410: @211959
     /* 211959 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(212009), // Rule ID 8411 //
     /* 211964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 211967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 211972 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 211974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 211978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 211985 */     // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_noret_i64>>  =>  (DS_MIN_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 211985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64_gfx9),
     /* 211988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 211993 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 211995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212007 */     GIR_RootConstrainSelectedInstOperands,
     /* 212008 */     // GIR_Coverage, 8411,
     /* 212008 */     GIR_EraseRootFromParent_Done,
     /* 212009 */   // Label 3411: @212009
     /* 212009 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(212059), // Rule ID 8413 //
     /* 212014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 212017 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 212022 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212035 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 212035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
     /* 212038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212043 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212057 */     GIR_RootConstrainSelectedInstOperands,
     /* 212058 */     // GIR_Coverage, 8413,
     /* 212058 */     GIR_EraseRootFromParent_Done,
     /* 212059 */   // Label 3412: @212059
     /* 212059 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(212113), // Rule ID 8408 //
     /* 212064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 212067 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 212072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212087 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 212087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
     /* 212090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212097 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212111 */     GIR_RootConstrainSelectedInstOperands,
     /* 212112 */     // GIR_Coverage, 8408,
     /* 212112 */     GIR_EraseRootFromParent_Done,
     /* 212113 */   // Label 3413: @212113
     /* 212113 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(212167), // Rule ID 8410 //
     /* 212118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 212121 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 212126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212141 */     // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_i64>>  =>  (DS_MIN_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 212141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64_gfx9),
     /* 212144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212151 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212165 */     GIR_RootConstrainSelectedInstOperands,
     /* 212166 */     // GIR_Coverage, 8410,
     /* 212166 */     GIR_EraseRootFromParent_Done,
     /* 212167 */   // Label 3414: @212167
     /* 212167 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(212221), // Rule ID 8412 //
     /* 212172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 212175 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 212180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 212195 */     // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 212195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
     /* 212198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 212205 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 212207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212219 */     GIR_RootConstrainSelectedInstOperands,
     /* 212220 */     // GIR_Coverage, 8412,
     /* 212220 */     GIR_EraseRootFromParent_Done,
     /* 212221 */   // Label 3415: @212221
     /* 212221 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(212278), // Rule ID 4098 //
     /* 212226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212229 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212236 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 212249 */     // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 212249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR),
     /* 212252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 212257 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 212264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212276 */     GIR_RootConstrainSelectedInstOperands,
     /* 212277 */     // GIR_Coverage, 4098,
     /* 212277 */     GIR_EraseRootFromParent_Done,
     /* 212278 */   // Label 3416: @212278
     /* 212278 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(212339), // Rule ID 4100 //
     /* 212283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212286 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 212308 */     // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 212308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN),
     /* 212311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 212318 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 212325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212337 */     GIR_RootConstrainSelectedInstOperands,
     /* 212338 */     // GIR_Coverage, 4100,
     /* 212338 */     GIR_EraseRootFromParent_Done,
     /* 212339 */   // Label 3417: @212339
     /* 212339 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(212391), // Rule ID 4097 //
     /* 212344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212347 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212354 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 212367 */     // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 212367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2),
     /* 212370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212375 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212389 */     GIR_RootConstrainSelectedInstOperands,
     /* 212390 */     // GIR_Coverage, 4097,
     /* 212390 */     GIR_EraseRootFromParent_Done,
     /* 212391 */   // Label 3418: @212391
     /* 212391 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(212447), // Rule ID 4099 //
     /* 212396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 212399 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 212421 */     // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 212421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_RTN),
     /* 212424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212431 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212445 */     GIR_RootConstrainSelectedInstOperands,
     /* 212446 */     // GIR_Coverage, 4099,
     /* 212446 */     GIR_EraseRootFromParent_Done,
     /* 212447 */   // Label 3419: @212447
     /* 212447 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(212500), // Rule ID 3712 //
     /* 212452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212455 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212463 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212476 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 212476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
     /* 212479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212484 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212498 */     GIR_RootConstrainSelectedInstOperands,
     /* 212499 */     // GIR_Coverage, 3712,
     /* 212499 */     GIR_EraseRootFromParent_Done,
     /* 212500 */   // Label 3420: @212500
     /* 212500 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(212552), // Rule ID 3772 //
     /* 212505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212508 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212515 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212528 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 212528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
     /* 212531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212536 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212550 */     GIR_RootConstrainSelectedInstOperands,
     /* 212551 */     // GIR_Coverage, 3772,
     /* 212551 */     GIR_EraseRootFromParent_Done,
     /* 212552 */   // Label 3421: @212552
     /* 212552 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(212609), // Rule ID 3711 //
     /* 212557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212560 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212583 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 212583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
     /* 212586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212593 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212607 */     GIR_RootConstrainSelectedInstOperands,
     /* 212608 */     // GIR_Coverage, 3711,
     /* 212608 */     GIR_EraseRootFromParent_Done,
     /* 212609 */   // Label 3422: @212609
     /* 212609 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(212665), // Rule ID 3771 //
     /* 212614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 212617 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 212628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 212639 */     // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 212639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
     /* 212642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 212644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 212649 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 212651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 212656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212663 */     GIR_RootConstrainSelectedInstOperands,
     /* 212664 */     // GIR_Coverage, 3771,
     /* 212664 */     GIR_EraseRootFromParent_Done,
     /* 212665 */   // Label 3423: @212665
     /* 212665 */   GIM_Reject,
     /* 212666 */ // Label 3401: @212666
     /* 212666 */ GIM_Reject,
     /* 212667 */ // Label 3377: @212667
     /* 212667 */ GIM_Reject,
     /* 212668 */ // Label 27: @212668
     /* 212668 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3426*/ GIMT_Encode4(215179),
     /* 212679 */ /*GILLT_s32*//*Label 3424*/ GIMT_Encode4(212687),
     /* 212683 */ /*GILLT_s64*//*Label 3425*/ GIMT_Encode4(213933),
     /* 212687 */ // Label 3424: @212687
     /* 212687 */ GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(213932),
     /* 212692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 212695 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(212757), // Rule ID 5637 //
     /* 212700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212703 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212710 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212723 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64),
     /* 212726 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212755 */     GIR_RootConstrainSelectedInstOperands,
     /* 212756 */     // GIR_Coverage, 5637,
     /* 212756 */     GIR_EraseRootFromParent_Done,
     /* 212757 */   // Label 3428: @212757
     /* 212757 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(212816), // Rule ID 5641 //
     /* 212762 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212769 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212782 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64),
     /* 212785 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212814 */     GIR_RootConstrainSelectedInstOperands,
     /* 212815 */     // GIR_Coverage, 5641,
     /* 212815 */     GIR_EraseRootFromParent_Done,
     /* 212816 */   // Label 3429: @212816
     /* 212816 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(212882), // Rule ID 5635 //
     /* 212821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212824 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212846 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64_RTN),
     /* 212849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212851 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212880 */     GIR_RootConstrainSelectedInstOperands,
     /* 212881 */     // GIR_Coverage, 5635,
     /* 212881 */     GIR_EraseRootFromParent_Done,
     /* 212882 */   // Label 3430: @212882
     /* 212882 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(212945), // Rule ID 5639 //
     /* 212887 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 212898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 212909 */     // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN),
     /* 212912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 212914 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 212921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 212931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 212936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 212939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 212943 */     GIR_RootConstrainSelectedInstOperands,
     /* 212944 */     // GIR_Coverage, 5639,
     /* 212944 */     GIR_EraseRootFromParent_Done,
     /* 212945 */   // Label 3431: @212945
     /* 212945 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(213002), // Rule ID 5636 //
     /* 212950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 212953 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 212960 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 212962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 212966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 212973 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 212973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
     /* 212976 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 212978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 212983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 212988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 212993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 212996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213000 */     GIR_RootConstrainSelectedInstOperands,
     /* 213001 */     // GIR_Coverage, 5636,
     /* 213001 */     GIR_EraseRootFromParent_Done,
     /* 213002 */   // Label 3432: @213002
     /* 213002 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(213056), // Rule ID 5640 //
     /* 213007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213014 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 213027 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 213027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
     /* 213030 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 213032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 213037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 213042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213054 */     GIR_RootConstrainSelectedInstOperands,
     /* 213055 */     // GIR_Coverage, 5640,
     /* 213055 */     GIR_EraseRootFromParent_Done,
     /* 213056 */   // Label 3433: @213056
     /* 213056 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(213117), // Rule ID 5634 //
     /* 213061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 213064 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 213086 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 213086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
     /* 213089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 213091 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 213093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 213098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 213103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213115 */     GIR_RootConstrainSelectedInstOperands,
     /* 213116 */     // GIR_Coverage, 5634,
     /* 213116 */     GIR_EraseRootFromParent_Done,
     /* 213117 */   // Label 3434: @213117
     /* 213117 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(213175), // Rule ID 5638 //
     /* 213122 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 213144 */     // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 213144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
     /* 213147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 213149 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 213151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 213156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 213161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213173 */     GIR_RootConstrainSelectedInstOperands,
     /* 213174 */     // GIR_Coverage, 5638,
     /* 213174 */     GIR_EraseRootFromParent_Done,
     /* 213175 */   // Label 3435: @213175
     /* 213175 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(213225), // Rule ID 8334 //
     /* 213180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 213183 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213188 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213201 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
     /* 213204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213209 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213223 */     GIR_RootConstrainSelectedInstOperands,
     /* 213224 */     // GIR_Coverage, 8334,
     /* 213224 */     GIR_EraseRootFromParent_Done,
     /* 213225 */   // Label 3436: @213225
     /* 213225 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(213275), // Rule ID 8336 //
     /* 213230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 213233 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213238 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213251 */     // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i32>>  =>  (DS_MAX_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32_gfx9),
     /* 213254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213259 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213273 */     GIR_RootConstrainSelectedInstOperands,
     /* 213274 */     // GIR_Coverage, 8336,
     /* 213274 */     GIR_EraseRootFromParent_Done,
     /* 213275 */   // Label 3437: @213275
     /* 213275 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(213325), // Rule ID 8338 //
     /* 213280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 213283 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213288 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213301 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 213301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
     /* 213304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213309 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213323 */     GIR_RootConstrainSelectedInstOperands,
     /* 213324 */     // GIR_Coverage, 8338,
     /* 213324 */     GIR_EraseRootFromParent_Done,
     /* 213325 */   // Label 3438: @213325
     /* 213325 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(213379), // Rule ID 8333 //
     /* 213330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 213333 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213353 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
     /* 213356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213363 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213377 */     GIR_RootConstrainSelectedInstOperands,
     /* 213378 */     // GIR_Coverage, 8333,
     /* 213378 */     GIR_EraseRootFromParent_Done,
     /* 213379 */   // Label 3439: @213379
     /* 213379 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(213433), // Rule ID 8335 //
     /* 213384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 213387 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 213392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213407 */     // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_i32>>  =>  (DS_MAX_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 213407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32_gfx9),
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213417 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213431 */     GIR_RootConstrainSelectedInstOperands,
     /* 213432 */     // GIR_Coverage, 8335,
     /* 213432 */     GIR_EraseRootFromParent_Done,
     /* 213433 */   // Label 3440: @213433
     /* 213433 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(213487), // Rule ID 8337 //
     /* 213438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 213441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 213446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 213461 */     // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 213461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
     /* 213464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 213471 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 213473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213485 */     GIR_RootConstrainSelectedInstOperands,
     /* 213486 */     // GIR_Coverage, 8337,
     /* 213486 */     GIR_EraseRootFromParent_Done,
     /* 213487 */   // Label 3441: @213487
     /* 213487 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(213544), // Rule ID 4038 //
     /* 213492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213495 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213502 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 213515 */     // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 213515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR),
     /* 213518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 213523 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 213530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213542 */     GIR_RootConstrainSelectedInstOperands,
     /* 213543 */     // GIR_Coverage, 4038,
     /* 213543 */     GIR_EraseRootFromParent_Done,
     /* 213544 */   // Label 3442: @213544
     /* 213544 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(213605), // Rule ID 4040 //
     /* 213549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213552 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 213574 */     // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 213574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR_RTN),
     /* 213577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 213584 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 213591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 213596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213603 */     GIR_RootConstrainSelectedInstOperands,
     /* 213604 */     // GIR_Coverage, 4040,
     /* 213604 */     GIR_EraseRootFromParent_Done,
     /* 213605 */   // Label 3443: @213605
     /* 213605 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(213657), // Rule ID 4037 //
     /* 213610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213613 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213620 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 213633 */     // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 213633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX),
     /* 213636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213641 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213655 */     GIR_RootConstrainSelectedInstOperands,
     /* 213656 */     // GIR_Coverage, 4037,
     /* 213656 */     GIR_EraseRootFromParent_Done,
     /* 213657 */   // Label 3444: @213657
     /* 213657 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(213713), // Rule ID 4039 //
     /* 213662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 213665 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 213687 */     // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 213687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_RTN),
     /* 213690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213697 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213711 */     GIR_RootConstrainSelectedInstOperands,
     /* 213712 */     // GIR_Coverage, 4039,
     /* 213712 */     GIR_EraseRootFromParent_Done,
     /* 213713 */   // Label 3445: @213713
     /* 213713 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(213766), // Rule ID 3684 //
     /* 213718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213721 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213729 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213742 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 213742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
     /* 213745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213750 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213764 */     GIR_RootConstrainSelectedInstOperands,
     /* 213765 */     // GIR_Coverage, 3684,
     /* 213765 */     GIR_EraseRootFromParent_Done,
     /* 213766 */   // Label 3446: @213766
     /* 213766 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(213818), // Rule ID 3744 //
     /* 213771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213781 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213794 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 213794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
     /* 213797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213802 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213816 */     GIR_RootConstrainSelectedInstOperands,
     /* 213817 */     // GIR_Coverage, 3744,
     /* 213817 */     GIR_EraseRootFromParent_Done,
     /* 213818 */   // Label 3447: @213818
     /* 213818 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(213875), // Rule ID 3683 //
     /* 213823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213826 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213849 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 213849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
     /* 213852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213859 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213873 */     GIR_RootConstrainSelectedInstOperands,
     /* 213874 */     // GIR_Coverage, 3683,
     /* 213874 */     GIR_EraseRootFromParent_Done,
     /* 213875 */   // Label 3448: @213875
     /* 213875 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(213931), // Rule ID 3743 //
     /* 213880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 213883 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 213894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 213905 */     // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 213905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
     /* 213908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 213910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 213915 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 213917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 213922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 213925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 213929 */     GIR_RootConstrainSelectedInstOperands,
     /* 213930 */     // GIR_Coverage, 3743,
     /* 213930 */     GIR_EraseRootFromParent_Done,
     /* 213931 */   // Label 3449: @213931
     /* 213931 */   GIM_Reject,
     /* 213932 */ // Label 3427: @213932
     /* 213932 */ GIM_Reject,
     /* 213933 */ // Label 3425: @213933
     /* 213933 */ GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(215178),
     /* 213938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 213941 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(214003), // Rule ID 5733 //
     /* 213946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 213949 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 213956 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 213958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 213962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 213969 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 213969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64),
     /* 213972 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 213974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 213979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 213984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 213989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 213994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 213997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214001 */     GIR_RootConstrainSelectedInstOperands,
     /* 214002 */     // GIR_Coverage, 5733,
     /* 214002 */     GIR_EraseRootFromParent_Done,
     /* 214003 */   // Label 3451: @214003
     /* 214003 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(214062), // Rule ID 5737 //
     /* 214008 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214015 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 214028 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 214028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64),
     /* 214031 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 214033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 214038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 214043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 214048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 214053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214060 */     GIR_RootConstrainSelectedInstOperands,
     /* 214061 */     // GIR_Coverage, 5737,
     /* 214061 */     GIR_EraseRootFromParent_Done,
     /* 214062 */   // Label 3452: @214062
     /* 214062 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(214128), // Rule ID 5731 //
     /* 214067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 214070 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 214092 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 214092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN),
     /* 214095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 214097 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 214099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 214104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 214109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 214114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 214119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214126 */     GIR_RootConstrainSelectedInstOperands,
     /* 214127 */     // GIR_Coverage, 5731,
     /* 214127 */     GIR_EraseRootFromParent_Done,
     /* 214128 */   // Label 3453: @214128
     /* 214128 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(214191), // Rule ID 5735 //
     /* 214133 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 214155 */     // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 214155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN),
     /* 214158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 214160 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 214162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 214167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 214172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 214177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 214182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214189 */     GIR_RootConstrainSelectedInstOperands,
     /* 214190 */     // GIR_Coverage, 5735,
     /* 214190 */     GIR_EraseRootFromParent_Done,
     /* 214191 */   // Label 3454: @214191
     /* 214191 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(214248), // Rule ID 5732 //
     /* 214196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 214199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214206 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 214219 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 214219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
     /* 214222 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 214224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 214229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 214234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214246 */     GIR_RootConstrainSelectedInstOperands,
     /* 214247 */     // GIR_Coverage, 5732,
     /* 214247 */     GIR_EraseRootFromParent_Done,
     /* 214248 */   // Label 3455: @214248
     /* 214248 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(214302), // Rule ID 5736 //
     /* 214253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214260 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 214273 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 214273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
     /* 214276 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 214278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 214283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 214288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214300 */     GIR_RootConstrainSelectedInstOperands,
     /* 214301 */     // GIR_Coverage, 5736,
     /* 214301 */     GIR_EraseRootFromParent_Done,
     /* 214302 */   // Label 3456: @214302
     /* 214302 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(214363), // Rule ID 5730 //
     /* 214307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 214310 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 214332 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 214332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 214339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 214344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 214349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214361 */     GIR_RootConstrainSelectedInstOperands,
     /* 214362 */     // GIR_Coverage, 5730,
     /* 214362 */     GIR_EraseRootFromParent_Done,
     /* 214363 */   // Label 3457: @214363
     /* 214363 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(214421), // Rule ID 5734 //
     /* 214368 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 214390 */     // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 214390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
     /* 214393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 214395 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 214397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 214402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 214407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214419 */     GIR_RootConstrainSelectedInstOperands,
     /* 214420 */     // GIR_Coverage, 5734,
     /* 214420 */     GIR_EraseRootFromParent_Done,
     /* 214421 */   // Label 3458: @214421
     /* 214421 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(214471), // Rule ID 8427 //
     /* 214426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 214429 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214434 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214447 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
     /* 214450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214455 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214469 */     GIR_RootConstrainSelectedInstOperands,
     /* 214470 */     // GIR_Coverage, 8427,
     /* 214470 */     GIR_EraseRootFromParent_Done,
     /* 214471 */   // Label 3459: @214471
     /* 214471 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(214521), // Rule ID 8429 //
     /* 214476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 214479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214484 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214497 */     // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i64>>  =>  (DS_MAX_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64_gfx9),
     /* 214500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214505 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214519 */     GIR_RootConstrainSelectedInstOperands,
     /* 214520 */     // GIR_Coverage, 8429,
     /* 214520 */     GIR_EraseRootFromParent_Done,
     /* 214521 */   // Label 3460: @214521
     /* 214521 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(214571), // Rule ID 8431 //
     /* 214526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 214529 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 214534 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214547 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 214547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
     /* 214550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214555 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214569 */     GIR_RootConstrainSelectedInstOperands,
     /* 214570 */     // GIR_Coverage, 8431,
     /* 214570 */     GIR_EraseRootFromParent_Done,
     /* 214571 */   // Label 3461: @214571
     /* 214571 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(214625), // Rule ID 8426 //
     /* 214576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 214579 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214599 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
     /* 214602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214609 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214623 */     GIR_RootConstrainSelectedInstOperands,
     /* 214624 */     // GIR_Coverage, 8426,
     /* 214624 */     GIR_EraseRootFromParent_Done,
     /* 214625 */   // Label 3462: @214625
     /* 214625 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(214679), // Rule ID 8428 //
     /* 214630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 214633 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 214638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214653 */     // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_i64>>  =>  (DS_MAX_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 214653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64_gfx9),
     /* 214656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214663 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214677 */     GIR_RootConstrainSelectedInstOperands,
     /* 214678 */     // GIR_Coverage, 8428,
     /* 214678 */     GIR_EraseRootFromParent_Done,
     /* 214679 */   // Label 3463: @214679
     /* 214679 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(214733), // Rule ID 8430 //
     /* 214684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 214687 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 214692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 214707 */     // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 214707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
     /* 214710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 214717 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 214719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214731 */     GIR_RootConstrainSelectedInstOperands,
     /* 214732 */     // GIR_Coverage, 8430,
     /* 214732 */     GIR_EraseRootFromParent_Done,
     /* 214733 */   // Label 3464: @214733
     /* 214733 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(214790), // Rule ID 4094 //
     /* 214738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 214741 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214748 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214761 */     // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR),
     /* 214764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214769 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214788 */     GIR_RootConstrainSelectedInstOperands,
     /* 214789 */     // GIR_Coverage, 4094,
     /* 214789 */     GIR_EraseRootFromParent_Done,
     /* 214790 */   // Label 3465: @214790
     /* 214790 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(214851), // Rule ID 4096 //
     /* 214795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 214798 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 214820 */     // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 214820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN),
     /* 214823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 214830 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 214837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 214842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214849 */     GIR_RootConstrainSelectedInstOperands,
     /* 214850 */     // GIR_Coverage, 4096,
     /* 214850 */     GIR_EraseRootFromParent_Done,
     /* 214851 */   // Label 3466: @214851
     /* 214851 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(214903), // Rule ID 4093 //
     /* 214856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 214859 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214866 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214879 */     // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2),
     /* 214882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214887 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214901 */     GIR_RootConstrainSelectedInstOperands,
     /* 214902 */     // GIR_Coverage, 4093,
     /* 214902 */     GIR_EraseRootFromParent_Done,
     /* 214903 */   // Label 3467: @214903
     /* 214903 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(214959), // Rule ID 4095 //
     /* 214908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 214911 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 214922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 214933 */     // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_RTN),
     /* 214936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 214938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214943 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 214950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 214953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 214957 */     GIR_RootConstrainSelectedInstOperands,
     /* 214958 */     // GIR_Coverage, 4095,
     /* 214958 */     GIR_EraseRootFromParent_Done,
     /* 214959 */   // Label 3468: @214959
     /* 214959 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(215012), // Rule ID 3710 //
     /* 214964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 214967 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 214975 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 214977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 214981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 214988 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 214988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
     /* 214991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 214996 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 214998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215010 */     GIR_RootConstrainSelectedInstOperands,
     /* 215011 */     // GIR_Coverage, 3710,
     /* 215011 */     GIR_EraseRootFromParent_Done,
     /* 215012 */   // Label 3469: @215012
     /* 215012 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(215064), // Rule ID 3770 //
     /* 215017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 215020 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215027 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 215040 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 215040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
     /* 215043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215048 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215062 */     GIR_RootConstrainSelectedInstOperands,
     /* 215063 */     // GIR_Coverage, 3770,
     /* 215063 */     GIR_EraseRootFromParent_Done,
     /* 215064 */   // Label 3470: @215064
     /* 215064 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(215121), // Rule ID 3709 //
     /* 215069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 215072 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 215084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 215095 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 215095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
     /* 215098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215105 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215119 */     GIR_RootConstrainSelectedInstOperands,
     /* 215120 */     // GIR_Coverage, 3709,
     /* 215120 */     GIR_EraseRootFromParent_Done,
     /* 215121 */   // Label 3471: @215121
     /* 215121 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(215177), // Rule ID 3769 //
     /* 215126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 215129 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 215140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 215151 */     // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 215151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
     /* 215154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 215161 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 215163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215175 */     GIR_RootConstrainSelectedInstOperands,
     /* 215176 */     // GIR_Coverage, 3769,
     /* 215176 */     GIR_EraseRootFromParent_Done,
     /* 215177 */   // Label 3472: @215177
     /* 215177 */   GIM_Reject,
     /* 215178 */ // Label 3450: @215178
     /* 215178 */ GIM_Reject,
     /* 215179 */ // Label 3426: @215179
     /* 215179 */ GIM_Reject,
     /* 215180 */ // Label 28: @215180
     /* 215180 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3475*/ GIMT_Encode4(217691),
     /* 215191 */ /*GILLT_s32*//*Label 3473*/ GIMT_Encode4(215199),
     /* 215195 */ /*GILLT_s64*//*Label 3474*/ GIMT_Encode4(216445),
     /* 215199 */ // Label 3473: @215199
     /* 215199 */ GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(216444),
     /* 215204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 215207 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(215269), // Rule ID 5621 //
     /* 215212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 215215 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215222 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 215235 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64),
     /* 215238 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 215245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 215255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 215260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215267 */     GIR_RootConstrainSelectedInstOperands,
     /* 215268 */     // GIR_Coverage, 5621,
     /* 215268 */     GIR_EraseRootFromParent_Done,
     /* 215269 */   // Label 3477: @215269
     /* 215269 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(215328), // Rule ID 5625 //
     /* 215274 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215281 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 215294 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64),
     /* 215297 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 215304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 215314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 215319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215326 */     GIR_RootConstrainSelectedInstOperands,
     /* 215327 */     // GIR_Coverage, 5625,
     /* 215327 */     GIR_EraseRootFromParent_Done,
     /* 215328 */   // Label 3478: @215328
     /* 215328 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(215394), // Rule ID 5619 //
     /* 215333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 215336 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 215358 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64_RTN),
     /* 215361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 215363 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 215370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 215380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 215385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215392 */     GIR_RootConstrainSelectedInstOperands,
     /* 215393 */     // GIR_Coverage, 5619,
     /* 215393 */     GIR_EraseRootFromParent_Done,
     /* 215394 */   // Label 3479: @215394
     /* 215394 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(215457), // Rule ID 5623 //
     /* 215399 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 215421 */     // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN),
     /* 215424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 215426 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 215433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 215443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 215448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215455 */     GIR_RootConstrainSelectedInstOperands,
     /* 215456 */     // GIR_Coverage, 5623,
     /* 215456 */     GIR_EraseRootFromParent_Done,
     /* 215457 */   // Label 3480: @215457
     /* 215457 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(215514), // Rule ID 5620 //
     /* 215462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 215465 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215472 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 215485 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
     /* 215488 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 215500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215512 */     GIR_RootConstrainSelectedInstOperands,
     /* 215513 */     // GIR_Coverage, 5620,
     /* 215513 */     GIR_EraseRootFromParent_Done,
     /* 215514 */   // Label 3481: @215514
     /* 215514 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(215568), // Rule ID 5624 //
     /* 215519 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215526 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 215539 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
     /* 215542 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 215554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215566 */     GIR_RootConstrainSelectedInstOperands,
     /* 215567 */     // GIR_Coverage, 5624,
     /* 215567 */     GIR_EraseRootFromParent_Done,
     /* 215568 */   // Label 3482: @215568
     /* 215568 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(215629), // Rule ID 5618 //
     /* 215573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 215576 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 215598 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
     /* 215601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 215603 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 215615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215627 */     GIR_RootConstrainSelectedInstOperands,
     /* 215628 */     // GIR_Coverage, 5618,
     /* 215628 */     GIR_EraseRootFromParent_Done,
     /* 215629 */   // Label 3483: @215629
     /* 215629 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(215687), // Rule ID 5622 //
     /* 215634 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 215641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 215656 */     // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 215656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
     /* 215659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 215661 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 215663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 215668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 215673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 215678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215685 */     GIR_RootConstrainSelectedInstOperands,
     /* 215686 */     // GIR_Coverage, 5622,
     /* 215686 */     GIR_EraseRootFromParent_Done,
     /* 215687 */   // Label 3484: @215687
     /* 215687 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(215737), // Rule ID 8328 //
     /* 215692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 215695 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215700 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215713 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
     /* 215716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215721 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215735 */     GIR_RootConstrainSelectedInstOperands,
     /* 215736 */     // GIR_Coverage, 8328,
     /* 215736 */     GIR_EraseRootFromParent_Done,
     /* 215737 */   // Label 3485: @215737
     /* 215737 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(215787), // Rule ID 8330 //
     /* 215742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 215745 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215750 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215763 */     // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i32>>  =>  (DS_MIN_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32_gfx9),
     /* 215766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215771 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215785 */     GIR_RootConstrainSelectedInstOperands,
     /* 215786 */     // GIR_Coverage, 8330,
     /* 215786 */     GIR_EraseRootFromParent_Done,
     /* 215787 */   // Label 3486: @215787
     /* 215787 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(215837), // Rule ID 8332 //
     /* 215792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 215795 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215800 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 215802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215813 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
     /* 215816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215821 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215835 */     GIR_RootConstrainSelectedInstOperands,
     /* 215836 */     // GIR_Coverage, 8332,
     /* 215836 */     GIR_EraseRootFromParent_Done,
     /* 215837 */   // Label 3487: @215837
     /* 215837 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(215891), // Rule ID 8327 //
     /* 215842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 215845 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215865 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
     /* 215868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215875 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215889 */     GIR_RootConstrainSelectedInstOperands,
     /* 215890 */     // GIR_Coverage, 8327,
     /* 215890 */     GIR_EraseRootFromParent_Done,
     /* 215891 */   // Label 3488: @215891
     /* 215891 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(215945), // Rule ID 8329 //
     /* 215896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 215899 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 215904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215919 */     // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_i32>>  =>  (DS_MIN_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 215919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32_gfx9),
     /* 215922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215929 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215943 */     GIR_RootConstrainSelectedInstOperands,
     /* 215944 */     // GIR_Coverage, 8329,
     /* 215944 */     GIR_EraseRootFromParent_Done,
     /* 215945 */   // Label 3489: @215945
     /* 215945 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(215999), // Rule ID 8331 //
     /* 215950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 215953 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 215958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 215962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 215966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 215973 */     // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 215973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
     /* 215976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 215978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 215983 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 215985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 215990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 215997 */     GIR_RootConstrainSelectedInstOperands,
     /* 215998 */     // GIR_Coverage, 8331,
     /* 215998 */     GIR_EraseRootFromParent_Done,
     /* 215999 */   // Label 3490: @215999
     /* 215999 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(216056), // Rule ID 4046 //
     /* 216004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 216007 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216014 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 216027 */     // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 216027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR),
     /* 216030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 216035 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 216042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216054 */     GIR_RootConstrainSelectedInstOperands,
     /* 216055 */     // GIR_Coverage, 4046,
     /* 216055 */     GIR_EraseRootFromParent_Done,
     /* 216056 */   // Label 3491: @216056
     /* 216056 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(216117), // Rule ID 4048 //
     /* 216061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 216064 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 216086 */     // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 216086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR_RTN),
     /* 216089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 216096 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 216103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216115 */     GIR_RootConstrainSelectedInstOperands,
     /* 216116 */     // GIR_Coverage, 4048,
     /* 216116 */     GIR_EraseRootFromParent_Done,
     /* 216117 */   // Label 3492: @216117
     /* 216117 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(216169), // Rule ID 4045 //
     /* 216122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 216125 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216132 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 216145 */     // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN),
     /* 216148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216153 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216167 */     GIR_RootConstrainSelectedInstOperands,
     /* 216168 */     // GIR_Coverage, 4045,
     /* 216168 */     GIR_EraseRootFromParent_Done,
     /* 216169 */   // Label 3493: @216169
     /* 216169 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(216225), // Rule ID 4047 //
     /* 216174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 216177 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 216199 */     // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_RTN),
     /* 216202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216209 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216223 */     GIR_RootConstrainSelectedInstOperands,
     /* 216224 */     // GIR_Coverage, 4047,
     /* 216224 */     GIR_EraseRootFromParent_Done,
     /* 216225 */   // Label 3494: @216225
     /* 216225 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(216278), // Rule ID 3688 //
     /* 216230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 216233 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216241 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 216254 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
     /* 216257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216262 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216276 */     GIR_RootConstrainSelectedInstOperands,
     /* 216277 */     // GIR_Coverage, 3688,
     /* 216277 */     GIR_EraseRootFromParent_Done,
     /* 216278 */   // Label 3495: @216278
     /* 216278 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(216330), // Rule ID 3748 //
     /* 216283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 216286 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216293 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 216306 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
     /* 216309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216314 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216328 */     GIR_RootConstrainSelectedInstOperands,
     /* 216329 */     // GIR_Coverage, 3748,
     /* 216329 */     GIR_EraseRootFromParent_Done,
     /* 216330 */   // Label 3496: @216330
     /* 216330 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(216387), // Rule ID 3687 //
     /* 216335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 216338 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 216361 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
     /* 216364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216371 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216385 */     GIR_RootConstrainSelectedInstOperands,
     /* 216386 */     // GIR_Coverage, 3687,
     /* 216386 */     GIR_EraseRootFromParent_Done,
     /* 216387 */   // Label 3497: @216387
     /* 216387 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(216443), // Rule ID 3747 //
     /* 216392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 216395 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 216406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 216417 */     // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 216417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
     /* 216420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 216422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 216427 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 216429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216441 */     GIR_RootConstrainSelectedInstOperands,
     /* 216442 */     // GIR_Coverage, 3747,
     /* 216442 */     GIR_EraseRootFromParent_Done,
     /* 216443 */   // Label 3498: @216443
     /* 216443 */   GIM_Reject,
     /* 216444 */ // Label 3476: @216444
     /* 216444 */ GIM_Reject,
     /* 216445 */ // Label 3474: @216445
     /* 216445 */ GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(217690),
     /* 216450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 216453 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(216515), // Rule ID 5717 //
     /* 216458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 216461 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216468 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216481 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64),
     /* 216484 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216513 */     GIR_RootConstrainSelectedInstOperands,
     /* 216514 */     // GIR_Coverage, 5717,
     /* 216514 */     GIR_EraseRootFromParent_Done,
     /* 216515 */   // Label 3500: @216515
     /* 216515 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(216574), // Rule ID 5721 //
     /* 216520 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216527 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216540 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64),
     /* 216543 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216572 */     GIR_RootConstrainSelectedInstOperands,
     /* 216573 */     // GIR_Coverage, 5721,
     /* 216573 */     GIR_EraseRootFromParent_Done,
     /* 216574 */   // Label 3501: @216574
     /* 216574 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(216640), // Rule ID 5715 //
     /* 216579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 216582 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 216593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216604 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN),
     /* 216607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216609 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216638 */     GIR_RootConstrainSelectedInstOperands,
     /* 216639 */     // GIR_Coverage, 5715,
     /* 216639 */     GIR_EraseRootFromParent_Done,
     /* 216640 */   // Label 3502: @216640
     /* 216640 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(216703), // Rule ID 5719 //
     /* 216645 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 216656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 216667 */     // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN),
     /* 216670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216672 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 216679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 216689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 216694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216701 */     GIR_RootConstrainSelectedInstOperands,
     /* 216702 */     // GIR_Coverage, 5719,
     /* 216702 */     GIR_EraseRootFromParent_Done,
     /* 216703 */   // Label 3503: @216703
     /* 216703 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(216760), // Rule ID 5716 //
     /* 216708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 216711 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216718 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216731 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
     /* 216734 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216758 */     GIR_RootConstrainSelectedInstOperands,
     /* 216759 */     // GIR_Coverage, 5716,
     /* 216759 */     GIR_EraseRootFromParent_Done,
     /* 216760 */   // Label 3504: @216760
     /* 216760 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(216814), // Rule ID 5720 //
     /* 216765 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216772 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216785 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
     /* 216788 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216812 */     GIR_RootConstrainSelectedInstOperands,
     /* 216813 */     // GIR_Coverage, 5720,
     /* 216813 */     GIR_EraseRootFromParent_Done,
     /* 216814 */   // Label 3505: @216814
     /* 216814 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(216875), // Rule ID 5714 //
     /* 216819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 216822 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 216833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216844 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
     /* 216847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216849 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216873 */     GIR_RootConstrainSelectedInstOperands,
     /* 216874 */     // GIR_Coverage, 5714,
     /* 216874 */     GIR_EraseRootFromParent_Done,
     /* 216875 */   // Label 3506: @216875
     /* 216875 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(216933), // Rule ID 5718 //
     /* 216880 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 216887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 216891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 216902 */     // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 216902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
     /* 216905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 216907 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 216909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 216914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 216919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 216924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216931 */     GIR_RootConstrainSelectedInstOperands,
     /* 216932 */     // GIR_Coverage, 5718,
     /* 216932 */     GIR_EraseRootFromParent_Done,
     /* 216933 */   // Label 3507: @216933
     /* 216933 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(216983), // Rule ID 8421 //
     /* 216938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 216941 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216946 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 216952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 216959 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 216959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
     /* 216962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 216967 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 216969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 216974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 216981 */     GIR_RootConstrainSelectedInstOperands,
     /* 216982 */     // GIR_Coverage, 8421,
     /* 216982 */     GIR_EraseRootFromParent_Done,
     /* 216983 */   // Label 3508: @216983
     /* 216983 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(217033), // Rule ID 8423 //
     /* 216988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 216991 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 216996 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 216998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217009 */     // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i64>>  =>  (DS_MIN_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64_gfx9),
     /* 217012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217017 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217031 */     GIR_RootConstrainSelectedInstOperands,
     /* 217032 */     // GIR_Coverage, 8423,
     /* 217032 */     GIR_EraseRootFromParent_Done,
     /* 217033 */   // Label 3509: @217033
     /* 217033 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(217083), // Rule ID 8425 //
     /* 217038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 217041 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 217046 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217059 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 217059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
     /* 217062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217067 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217081 */     GIR_RootConstrainSelectedInstOperands,
     /* 217082 */     // GIR_Coverage, 8425,
     /* 217082 */     GIR_EraseRootFromParent_Done,
     /* 217083 */   // Label 3510: @217083
     /* 217083 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(217137), // Rule ID 8420 //
     /* 217088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 217091 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217111 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
     /* 217114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217121 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217135 */     GIR_RootConstrainSelectedInstOperands,
     /* 217136 */     // GIR_Coverage, 8420,
     /* 217136 */     GIR_EraseRootFromParent_Done,
     /* 217137 */   // Label 3511: @217137
     /* 217137 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(217191), // Rule ID 8422 //
     /* 217142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 217145 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217165 */     // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_i64>>  =>  (DS_MIN_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64_gfx9),
     /* 217168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217175 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217189 */     GIR_RootConstrainSelectedInstOperands,
     /* 217190 */     // GIR_Coverage, 8422,
     /* 217190 */     GIR_EraseRootFromParent_Done,
     /* 217191 */   // Label 3512: @217191
     /* 217191 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(217245), // Rule ID 8424 //
     /* 217196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 217199 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 217204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217219 */     // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 217219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
     /* 217222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217229 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217243 */     GIR_RootConstrainSelectedInstOperands,
     /* 217244 */     // GIR_Coverage, 8424,
     /* 217244 */     GIR_EraseRootFromParent_Done,
     /* 217245 */   // Label 3513: @217245
     /* 217245 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(217302), // Rule ID 4102 //
     /* 217250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 217253 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217260 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 217273 */     // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 217273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR),
     /* 217276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 217281 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 217288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217300 */     GIR_RootConstrainSelectedInstOperands,
     /* 217301 */     // GIR_Coverage, 4102,
     /* 217301 */     GIR_EraseRootFromParent_Done,
     /* 217302 */   // Label 3514: @217302
     /* 217302 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(217363), // Rule ID 4104 //
     /* 217307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 217310 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 217332 */     // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 217332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN),
     /* 217335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 217342 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 217349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 217354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217361 */     GIR_RootConstrainSelectedInstOperands,
     /* 217362 */     // GIR_Coverage, 4104,
     /* 217362 */     GIR_EraseRootFromParent_Done,
     /* 217363 */   // Label 3515: @217363
     /* 217363 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(217415), // Rule ID 4101 //
     /* 217368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 217371 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217378 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 217391 */     // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 217391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2),
     /* 217394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217399 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217413 */     GIR_RootConstrainSelectedInstOperands,
     /* 217414 */     // GIR_Coverage, 4101,
     /* 217414 */     GIR_EraseRootFromParent_Done,
     /* 217415 */   // Label 3516: @217415
     /* 217415 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(217471), // Rule ID 4103 //
     /* 217420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 217423 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 217445 */     // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 217445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_RTN),
     /* 217448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217455 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217469 */     GIR_RootConstrainSelectedInstOperands,
     /* 217470 */     // GIR_Coverage, 4103,
     /* 217470 */     GIR_EraseRootFromParent_Done,
     /* 217471 */   // Label 3517: @217471
     /* 217471 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(217524), // Rule ID 3714 //
     /* 217476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 217479 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217487 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217500 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 217500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
     /* 217503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217508 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217522 */     GIR_RootConstrainSelectedInstOperands,
     /* 217523 */     // GIR_Coverage, 3714,
     /* 217523 */     GIR_EraseRootFromParent_Done,
     /* 217524 */   // Label 3518: @217524
     /* 217524 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(217576), // Rule ID 3774 //
     /* 217529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 217532 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217539 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217552 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 217552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
     /* 217555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217560 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217574 */     GIR_RootConstrainSelectedInstOperands,
     /* 217575 */     // GIR_Coverage, 3774,
     /* 217575 */     GIR_EraseRootFromParent_Done,
     /* 217576 */   // Label 3519: @217576
     /* 217576 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(217633), // Rule ID 3713 //
     /* 217581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 217584 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217607 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 217607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
     /* 217610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217617 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217631 */     GIR_RootConstrainSelectedInstOperands,
     /* 217632 */     // GIR_Coverage, 3713,
     /* 217632 */     GIR_EraseRootFromParent_Done,
     /* 217633 */   // Label 3520: @217633
     /* 217633 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(217689), // Rule ID 3773 //
     /* 217638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 217641 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 217648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 217652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 217663 */     // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 217663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
     /* 217666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 217673 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 217675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217687 */     GIR_RootConstrainSelectedInstOperands,
     /* 217688 */     // GIR_Coverage, 3773,
     /* 217688 */     GIR_EraseRootFromParent_Done,
     /* 217689 */   // Label 3521: @217689
     /* 217689 */   GIM_Reject,
     /* 217690 */ // Label 3499: @217690
     /* 217690 */ GIM_Reject,
     /* 217691 */ // Label 3475: @217691
     /* 217691 */ GIM_Reject,
     /* 217692 */ // Label 29: @217692
     /* 217692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 3525*/ GIMT_Encode4(219902),
     /* 217703 */ /*GILLT_s32*//*Label 3522*/ GIMT_Encode4(217715),
     /* 217707 */ /*GILLT_s64*//*Label 3523*/ GIMT_Encode4(218373),
     /* 217711 */ /*GILLT_v2s16*//*Label 3524*/ GIMT_Encode4(218823),
     /* 217715 */ // Label 3522: @217715
     /* 217715 */ GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(218372),
     /* 217720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217723 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(217773), // Rule ID 8358 //
     /* 217728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
     /* 217731 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217736 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217749 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
     /* 217752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217757 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217771 */     GIR_RootConstrainSelectedInstOperands,
     /* 217772 */     // GIR_Coverage, 8358,
     /* 217772 */     GIR_EraseRootFromParent_Done,
     /* 217773 */   // Label 3527: @217773
     /* 217773 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(217823), // Rule ID 8360 //
     /* 217778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
     /* 217781 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217786 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217799 */     // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f32>>  =>  (DS_ADD_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32_gfx9),
     /* 217802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217807 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217821 */     GIR_RootConstrainSelectedInstOperands,
     /* 217822 */     // GIR_Coverage, 8360,
     /* 217822 */     GIR_EraseRootFromParent_Done,
     /* 217823 */   // Label 3528: @217823
     /* 217823 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(217873), // Rule ID 8362 //
     /* 217828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
     /* 217831 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 217836 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 217838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217849 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 217849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
     /* 217852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217857 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217871 */     GIR_RootConstrainSelectedInstOperands,
     /* 217872 */     // GIR_Coverage, 8362,
     /* 217872 */     GIR_EraseRootFromParent_Done,
     /* 217873 */   // Label 3529: @217873
     /* 217873 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(217927), // Rule ID 8357 //
     /* 217878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
     /* 217881 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217901 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
     /* 217904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217911 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217925 */     GIR_RootConstrainSelectedInstOperands,
     /* 217926 */     // GIR_Coverage, 8357,
     /* 217926 */     GIR_EraseRootFromParent_Done,
     /* 217927 */   // Label 3530: @217927
     /* 217927 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(217981), // Rule ID 8359 //
     /* 217932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
     /* 217935 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 217940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 217948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 217955 */     // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_f32>>  =>  (DS_ADD_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 217955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32_gfx9),
     /* 217958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 217960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 217965 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 217967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 217972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 217979 */     GIR_RootConstrainSelectedInstOperands,
     /* 217980 */     // GIR_Coverage, 8359,
     /* 217980 */     GIR_EraseRootFromParent_Done,
     /* 217981 */   // Label 3531: @217981
     /* 217981 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(218035), // Rule ID 8361 //
     /* 217986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
     /* 217989 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 217994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 217998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218009 */     // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 218009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
     /* 218012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218019 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218033 */     GIR_RootConstrainSelectedInstOperands,
     /* 218034 */     // GIR_Coverage, 8361,
     /* 218034 */     GIR_EraseRootFromParent_Done,
     /* 218035 */   // Label 3532: @218035
     /* 218035 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(218092), // Rule ID 4164 //
     /* 218040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 218043 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218050 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218063 */     // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR),
     /* 218066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218071 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218090 */     GIR_RootConstrainSelectedInstOperands,
     /* 218091 */     // GIR_Coverage, 4164,
     /* 218091 */     GIR_EraseRootFromParent_Done,
     /* 218092 */   // Label 3533: @218092
     /* 218092 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(218153), // Rule ID 4168 //
     /* 218097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 218100 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 218111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218122 */     // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR_RTN),
     /* 218125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218132 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218151 */     GIR_RootConstrainSelectedInstOperands,
     /* 218152 */     // GIR_Coverage, 4168,
     /* 218152 */     GIR_EraseRootFromParent_Done,
     /* 218153 */   // Label 3534: @218153
     /* 218153 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(218205), // Rule ID 4163 //
     /* 218158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 218161 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218168 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218181 */     // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 218181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32),
     /* 218184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218189 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218203 */     GIR_RootConstrainSelectedInstOperands,
     /* 218204 */     // GIR_Coverage, 4163,
     /* 218204 */     GIR_EraseRootFromParent_Done,
     /* 218205 */   // Label 3535: @218205
     /* 218205 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(218261), // Rule ID 4167 //
     /* 218210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 218213 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 218224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218235 */     // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 218235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_RTN),
     /* 218238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218245 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218259 */     GIR_RootConstrainSelectedInstOperands,
     /* 218260 */     // GIR_Coverage, 4167,
     /* 218260 */     GIR_EraseRootFromParent_Done,
     /* 218261 */   // Label 3536: @218261
     /* 218261 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(218314), // Rule ID 4188 //
     /* 218266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
     /* 218269 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218277 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218290 */     // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f32>>  =>  (FLAT_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 218290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32),
     /* 218293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218298 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218312 */     GIR_RootConstrainSelectedInstOperands,
     /* 218313 */     // GIR_Coverage, 4188,
     /* 218313 */     GIR_EraseRootFromParent_Done,
     /* 218314 */   // Label 3537: @218314
     /* 218314 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(218371), // Rule ID 4187 //
     /* 218319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
     /* 218322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 218334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218345 */     // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_f32>>  =>  (FLAT_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 218345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32_RTN),
     /* 218348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218355 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218369 */     GIR_RootConstrainSelectedInstOperands,
     /* 218370 */     // GIR_Coverage, 4187,
     /* 218370 */     GIR_EraseRootFromParent_Done,
     /* 218371 */   // Label 3538: @218371
     /* 218371 */   GIM_Reject,
     /* 218372 */ // Label 3526: @218372
     /* 218372 */ GIM_Reject,
     /* 218373 */ // Label 3523: @218373
     /* 218373 */ GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(218822),
     /* 218378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218381 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(218431), // Rule ID 8455 //
     /* 218386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
     /* 218389 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218394 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218407 */     // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f64>>  =>  (DS_ADD_F64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F64),
     /* 218410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218415 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218429 */     GIR_RootConstrainSelectedInstOperands,
     /* 218430 */     // GIR_Coverage, 8455,
     /* 218430 */     GIR_EraseRootFromParent_Done,
     /* 218431 */   // Label 3540: @218431
     /* 218431 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(218485), // Rule ID 8454 //
     /* 218436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
     /* 218439 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218459 */     // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_f64>>  =>  (DS_ADD_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F64),
     /* 218462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218469 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218483 */     GIR_RootConstrainSelectedInstOperands,
     /* 218484 */     // GIR_Coverage, 8454,
     /* 218484 */     GIR_EraseRootFromParent_Done,
     /* 218485 */   // Label 3541: @218485
     /* 218485 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(218542), // Rule ID 4182 //
     /* 218490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 218493 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218500 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218513 */     // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR),
     /* 218516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218521 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218540 */     GIR_RootConstrainSelectedInstOperands,
     /* 218541 */     // GIR_Coverage, 4182,
     /* 218541 */     GIR_EraseRootFromParent_Done,
     /* 218542 */   // Label 3542: @218542
     /* 218542 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(218603), // Rule ID 4184 //
     /* 218547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 218550 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 218572 */     // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 218572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR_RTN),
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 218582 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 218589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 218594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218601 */     GIR_RootConstrainSelectedInstOperands,
     /* 218602 */     // GIR_Coverage, 4184,
     /* 218602 */     GIR_EraseRootFromParent_Done,
     /* 218603 */   // Label 3543: @218603
     /* 218603 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(218655), // Rule ID 4181 //
     /* 218608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 218611 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218618 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218631 */     // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64),
     /* 218634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218639 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218653 */     GIR_RootConstrainSelectedInstOperands,
     /* 218654 */     // GIR_Coverage, 4181,
     /* 218654 */     GIR_EraseRootFromParent_Done,
     /* 218655 */   // Label 3544: @218655
     /* 218655 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(218711), // Rule ID 4183 //
     /* 218660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 218663 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 218685 */     // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_RTN),
     /* 218688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218695 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218709 */     GIR_RootConstrainSelectedInstOperands,
     /* 218710 */     // GIR_Coverage, 4183,
     /* 218710 */     GIR_EraseRootFromParent_Done,
     /* 218711 */   // Label 3545: @218711
     /* 218711 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(218764), // Rule ID 4186 //
     /* 218716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 218719 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218727 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218740 */     // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f64>>  =>  (FLAT_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64),
     /* 218743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218748 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218762 */     GIR_RootConstrainSelectedInstOperands,
     /* 218763 */     // GIR_Coverage, 4186,
     /* 218763 */     GIR_EraseRootFromParent_Done,
     /* 218764 */   // Label 3546: @218764
     /* 218764 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(218821), // Rule ID 4185 //
     /* 218769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 218772 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 218780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 218784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 218795 */     // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_f64>>  =>  (FLAT_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 218795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64_RTN),
     /* 218798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 218800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 218805 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 218807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218819 */     GIR_RootConstrainSelectedInstOperands,
     /* 218820 */     // GIR_Coverage, 4185,
     /* 218820 */     GIR_EraseRootFromParent_Done,
     /* 218821 */   // Label 3547: @218821
     /* 218821 */   GIM_Reject,
     /* 218822 */ // Label 3539: @218822
     /* 218822 */ GIM_Reject,
     /* 218823 */ // Label 3524: @218823
     /* 218823 */ GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(219901),
     /* 218828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 218831 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(218881), // Rule ID 8352 //
     /* 218836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 218839 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218844 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218857 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 218860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218865 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218879 */     GIR_RootConstrainSelectedInstOperands,
     /* 218880 */     // GIR_Coverage, 8352,
     /* 218880 */     GIR_EraseRootFromParent_Done,
     /* 218881 */   // Label 3549: @218881
     /* 218881 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(218931), // Rule ID 8354 //
     /* 218886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 218889 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218894 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218907 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 218907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
     /* 218910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218915 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218929 */     GIR_RootConstrainSelectedInstOperands,
     /* 218930 */     // GIR_Coverage, 8354,
     /* 218930 */     GIR_EraseRootFromParent_Done,
     /* 218931 */   // Label 3550: @218931
     /* 218931 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(218981), // Rule ID 8356 //
     /* 218936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 218939 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 218944 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 218950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 218957 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 218957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 218960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 218965 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 218967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 218972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 218979 */     GIR_RootConstrainSelectedInstOperands,
     /* 218980 */     // GIR_Coverage, 8356,
     /* 218980 */     GIR_EraseRootFromParent_Done,
     /* 218981 */   // Label 3551: @218981
     /* 218981 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(219031), // Rule ID 8457 //
     /* 218986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 218989 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 218994 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 218996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219007 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 219010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219015 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219029 */     GIR_RootConstrainSelectedInstOperands,
     /* 219030 */     // GIR_Coverage, 8457,
     /* 219030 */     GIR_EraseRootFromParent_Done,
     /* 219031 */   // Label 3552: @219031
     /* 219031 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(219081), // Rule ID 8459 //
     /* 219036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 219039 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219044 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219057 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
     /* 219060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219065 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219079 */     GIR_RootConstrainSelectedInstOperands,
     /* 219080 */     // GIR_Coverage, 8459,
     /* 219080 */     GIR_EraseRootFromParent_Done,
     /* 219081 */   // Label 3553: @219081
     /* 219081 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(219131), // Rule ID 8461 //
     /* 219086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 219089 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 219094 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219107 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 219107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
     /* 219110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219115 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219129 */     GIR_RootConstrainSelectedInstOperands,
     /* 219130 */     // GIR_Coverage, 8461,
     /* 219130 */     GIR_EraseRootFromParent_Done,
     /* 219131 */   // Label 3554: @219131
     /* 219131 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(219185), // Rule ID 8351 //
     /* 219136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 219139 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219159 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 219162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219169 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219183 */     GIR_RootConstrainSelectedInstOperands,
     /* 219184 */     // GIR_Coverage, 8351,
     /* 219184 */     GIR_EraseRootFromParent_Done,
     /* 219185 */   // Label 3555: @219185
     /* 219185 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(219239), // Rule ID 8353 //
     /* 219190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 219193 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219213 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
     /* 219216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219223 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219237 */     GIR_RootConstrainSelectedInstOperands,
     /* 219238 */     // GIR_Coverage, 8353,
     /* 219238 */     GIR_EraseRootFromParent_Done,
     /* 219239 */   // Label 3556: @219239
     /* 219239 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(219293), // Rule ID 8355 //
     /* 219244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 219247 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 219252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219267 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 219267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 219270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219277 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219291 */     GIR_RootConstrainSelectedInstOperands,
     /* 219292 */     // GIR_Coverage, 8355,
     /* 219292 */     GIR_EraseRootFromParent_Done,
     /* 219293 */   // Label 3557: @219293
     /* 219293 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(219347), // Rule ID 8456 //
     /* 219298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
     /* 219301 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219321 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 219324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219331 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219345 */     GIR_RootConstrainSelectedInstOperands,
     /* 219346 */     // GIR_Coverage, 8456,
     /* 219346 */     GIR_EraseRootFromParent_Done,
     /* 219347 */   // Label 3558: @219347
     /* 219347 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(219401), // Rule ID 8458 //
     /* 219352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
     /* 219355 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 219360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219375 */     // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 219375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
     /* 219378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219385 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219399 */     GIR_RootConstrainSelectedInstOperands,
     /* 219400 */     // GIR_Coverage, 8458,
     /* 219400 */     GIR_EraseRootFromParent_Done,
     /* 219401 */   // Label 3559: @219401
     /* 219401 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(219455), // Rule ID 8460 //
     /* 219406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
     /* 219409 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 219414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 219429 */     // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 219429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
     /* 219432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 219439 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 219441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219453 */     GIR_RootConstrainSelectedInstOperands,
     /* 219454 */     // GIR_Coverage, 8460,
     /* 219454 */     GIR_EraseRootFromParent_Done,
     /* 219455 */   // Label 3560: @219455
     /* 219455 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(219512), // Rule ID 4166 //
     /* 219460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 219463 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219470 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 219483 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 219483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
     /* 219486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 219491 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 219498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219510 */     GIR_RootConstrainSelectedInstOperands,
     /* 219511 */     // GIR_Coverage, 4166,
     /* 219511 */     GIR_EraseRootFromParent_Done,
     /* 219512 */   // Label 3561: @219512
     /* 219512 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(219569), // Rule ID 4170 //
     /* 219517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 219520 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219527 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 219540 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 219540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
     /* 219543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 219548 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 219555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219567 */     GIR_RootConstrainSelectedInstOperands,
     /* 219568 */     // GIR_Coverage, 4170,
     /* 219568 */     GIR_EraseRootFromParent_Done,
     /* 219569 */   // Label 3562: @219569
     /* 219569 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(219630), // Rule ID 4172 //
     /* 219574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 219577 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 219599 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN:{ *:[v2f16] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 219599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN),
     /* 219602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 219609 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 219616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 219621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219628 */     GIR_RootConstrainSelectedInstOperands,
     /* 219629 */     // GIR_Coverage, 4172,
     /* 219629 */     GIR_EraseRootFromParent_Done,
     /* 219630 */   // Label 3563: @219630
     /* 219630 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(219682), // Rule ID 4165 //
     /* 219635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 219638 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219645 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 219658 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 219658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
     /* 219661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219666 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219680 */     GIR_RootConstrainSelectedInstOperands,
     /* 219681 */     // GIR_Coverage, 4165,
     /* 219681 */     GIR_EraseRootFromParent_Done,
     /* 219682 */   // Label 3564: @219682
     /* 219682 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(219734), // Rule ID 4169 //
     /* 219687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 219690 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219697 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 219710 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 219710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
     /* 219713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219718 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219732 */     GIR_RootConstrainSelectedInstOperands,
     /* 219733 */     // GIR_Coverage, 4169,
     /* 219733 */     GIR_EraseRootFromParent_Done,
     /* 219734 */   // Label 3565: @219734
     /* 219734 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(219790), // Rule ID 4171 //
     /* 219739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 219742 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 219764 */     // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 219764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_RTN),
     /* 219767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219774 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219788 */     GIR_RootConstrainSelectedInstOperands,
     /* 219789 */     // GIR_Coverage, 4171,
     /* 219789 */     GIR_EraseRootFromParent_Done,
     /* 219790 */   // Label 3566: @219790
     /* 219790 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(219843), // Rule ID 4190 //
     /* 219795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
     /* 219798 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219806 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219819 */     // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 219819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16),
     /* 219822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219827 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219841 */     GIR_RootConstrainSelectedInstOperands,
     /* 219842 */     // GIR_Coverage, 4190,
     /* 219842 */     GIR_EraseRootFromParent_Done,
     /* 219843 */   // Label 3567: @219843
     /* 219843 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(219900), // Rule ID 4189 //
     /* 219848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
     /* 219851 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 219863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 219874 */     // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
     /* 219874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16_RTN),
     /* 219877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 219879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 219884 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 219886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 219891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219898 */     GIR_RootConstrainSelectedInstOperands,
     /* 219899 */     // GIR_Coverage, 4189,
     /* 219899 */     GIR_EraseRootFromParent_Done,
     /* 219900 */   // Label 3568: @219900
     /* 219900 */   GIM_Reject,
     /* 219901 */ // Label 3548: @219901
     /* 219901 */ GIM_Reject,
     /* 219902 */ // Label 3525: @219902
     /* 219902 */ GIM_Reject,
     /* 219903 */ // Label 30: @219903
     /* 219903 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3571*/ GIMT_Encode4(222548),
     /* 219914 */ /*GILLT_s32*//*Label 3569*/ GIMT_Encode4(219922),
     /* 219918 */ /*GILLT_s64*//*Label 3570*/ GIMT_Encode4(221290),
     /* 219922 */ // Label 3569: @219922
     /* 219922 */ GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(221289),
     /* 219927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219930 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(219992), // Rule ID 5789 //
     /* 219935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 219938 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 219945 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 219947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 219951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 219958 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64 anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 219958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64),
     /* 219961 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 219963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 219968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 219973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 219978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 219983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 219990 */     GIR_RootConstrainSelectedInstOperands,
     /* 219991 */     // GIR_Coverage, 5789,
     /* 219991 */     GIR_EraseRootFromParent_Done,
     /* 219992 */   // Label 3573: @219992
     /* 219992 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(220054), // Rule ID 5793 //
     /* 219997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 220000 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220007 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220020 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64 anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64),
     /* 220023 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220052 */     GIR_RootConstrainSelectedInstOperands,
     /* 220053 */     // GIR_Coverage, 5793,
     /* 220053 */     GIR_EraseRootFromParent_Done,
     /* 220054 */   // Label 3574: @220054
     /* 220054 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(220120), // Rule ID 5787 //
     /* 220059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 220062 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220084 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64_RTN),
     /* 220087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220089 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220118 */     GIR_RootConstrainSelectedInstOperands,
     /* 220119 */     // GIR_Coverage, 5787,
     /* 220119 */     GIR_EraseRootFromParent_Done,
     /* 220120 */   // Label 3575: @220120
     /* 220120 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(220186), // Rule ID 5791 //
     /* 220125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 220128 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 220150 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN),
     /* 220153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220155 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 220162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 220172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 220177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220184 */     GIR_RootConstrainSelectedInstOperands,
     /* 220185 */     // GIR_Coverage, 5791,
     /* 220185 */     GIR_EraseRootFromParent_Done,
     /* 220186 */   // Label 3576: @220186
     /* 220186 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(220243), // Rule ID 5788 //
     /* 220191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 220194 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220201 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220214 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
     /* 220217 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220241 */     GIR_RootConstrainSelectedInstOperands,
     /* 220242 */     // GIR_Coverage, 5788,
     /* 220242 */     GIR_EraseRootFromParent_Done,
     /* 220243 */   // Label 3577: @220243
     /* 220243 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(220300), // Rule ID 5792 //
     /* 220248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 220251 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220258 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220271 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
     /* 220274 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220298 */     GIR_RootConstrainSelectedInstOperands,
     /* 220299 */     // GIR_Coverage, 5792,
     /* 220299 */     GIR_EraseRootFromParent_Done,
     /* 220300 */   // Label 3578: @220300
     /* 220300 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(220361), // Rule ID 5786 //
     /* 220305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 220308 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220330 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
     /* 220333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220335 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220359 */     GIR_RootConstrainSelectedInstOperands,
     /* 220360 */     // GIR_Coverage, 5786,
     /* 220360 */     GIR_EraseRootFromParent_Done,
     /* 220361 */   // Label 3579: @220361
     /* 220361 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(220422), // Rule ID 5790 //
     /* 220366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 220369 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 220391 */     // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 220391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
     /* 220394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 220396 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 220398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 220403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 220408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220420 */     GIR_RootConstrainSelectedInstOperands,
     /* 220421 */     // GIR_Coverage, 5790,
     /* 220421 */     GIR_EraseRootFromParent_Done,
     /* 220422 */   // Label 3580: @220422
     /* 220422 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(220472), // Rule ID 8346 //
     /* 220427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 220430 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220435 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220448 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
     /* 220451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220456 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220470 */     GIR_RootConstrainSelectedInstOperands,
     /* 220471 */     // GIR_Coverage, 8346,
     /* 220471 */     GIR_EraseRootFromParent_Done,
     /* 220472 */   // Label 3581: @220472
     /* 220472 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(220522), // Rule ID 8348 //
     /* 220477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 220480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220485 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220498 */     // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f32>>  =>  (DS_MAX_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32_gfx9),
     /* 220501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220506 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220520 */     GIR_RootConstrainSelectedInstOperands,
     /* 220521 */     // GIR_Coverage, 8348,
     /* 220521 */     GIR_EraseRootFromParent_Done,
     /* 220522 */   // Label 3582: @220522
     /* 220522 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(220572), // Rule ID 8350 //
     /* 220527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 220530 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 220535 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220548 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 220548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
     /* 220551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220556 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220570 */     GIR_RootConstrainSelectedInstOperands,
     /* 220571 */     // GIR_Coverage, 8350,
     /* 220571 */     GIR_EraseRootFromParent_Done,
     /* 220572 */   // Label 3583: @220572
     /* 220572 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(220626), // Rule ID 8345 //
     /* 220577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 220580 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220600 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
     /* 220603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220610 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220624 */     GIR_RootConstrainSelectedInstOperands,
     /* 220625 */     // GIR_Coverage, 8345,
     /* 220625 */     GIR_EraseRootFromParent_Done,
     /* 220626 */   // Label 3584: @220626
     /* 220626 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(220680), // Rule ID 8347 //
     /* 220631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 220634 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 220639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220654 */     // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_f32>>  =>  (DS_MAX_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 220654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32_gfx9),
     /* 220657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220664 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220678 */     GIR_RootConstrainSelectedInstOperands,
     /* 220679 */     // GIR_Coverage, 8347,
     /* 220679 */     GIR_EraseRootFromParent_Done,
     /* 220680 */   // Label 3585: @220680
     /* 220680 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(220734), // Rule ID 8349 //
     /* 220685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 220688 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 220693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 220708 */     // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 220708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
     /* 220711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 220718 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 220720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220732 */     GIR_RootConstrainSelectedInstOperands,
     /* 220733 */     // GIR_Coverage, 8349,
     /* 220733 */     GIR_EraseRootFromParent_Done,
     /* 220734 */   // Label 3586: @220734
     /* 220734 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(220791), // Rule ID 4144 //
     /* 220739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 220742 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220749 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 220762 */     // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 220762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
     /* 220765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 220770 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 220777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220789 */     GIR_RootConstrainSelectedInstOperands,
     /* 220790 */     // GIR_Coverage, 4144,
     /* 220790 */     GIR_EraseRootFromParent_Done,
     /* 220791 */   // Label 3587: @220791
     /* 220791 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(220852), // Rule ID 4146 //
     /* 220796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 220799 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 220821 */     // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 220821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
     /* 220824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 220831 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 220838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 220843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220850 */     GIR_RootConstrainSelectedInstOperands,
     /* 220851 */     // GIR_Coverage, 4146,
     /* 220851 */     GIR_EraseRootFromParent_Done,
     /* 220852 */   // Label 3588: @220852
     /* 220852 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(220904), // Rule ID 4143 //
     /* 220857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 220860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220867 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 220880 */     // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 220880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
     /* 220883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220888 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 220898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220902 */     GIR_RootConstrainSelectedInstOperands,
     /* 220903 */     // GIR_Coverage, 4143,
     /* 220903 */     GIR_EraseRootFromParent_Done,
     /* 220904 */   // Label 3589: @220904
     /* 220904 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(220960), // Rule ID 4145 //
     /* 220909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 220912 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 220923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 220934 */     // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 220934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
     /* 220937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 220939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220944 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 220951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 220954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 220958 */     GIR_RootConstrainSelectedInstOperands,
     /* 220959 */     // GIR_Coverage, 4145,
     /* 220959 */     GIR_EraseRootFromParent_Done,
     /* 220960 */   // Label 3590: @220960
     /* 220960 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(221013), // Rule ID 3726 //
     /* 220965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 220968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 220976 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 220978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 220982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 220989 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 220989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 220992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 220997 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 220999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221011 */     GIR_RootConstrainSelectedInstOperands,
     /* 221012 */     // GIR_Coverage, 3726,
     /* 221012 */     GIR_EraseRootFromParent_Done,
     /* 221013 */   // Label 3591: @221013
     /* 221013 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(221065), // Rule ID 3786 //
     /* 221018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 221021 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221028 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221041 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 221041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 221044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221049 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221063 */     GIR_RootConstrainSelectedInstOperands,
     /* 221064 */     // GIR_Coverage, 3786,
     /* 221064 */     GIR_EraseRootFromParent_Done,
     /* 221065 */   // Label 3592: @221065
     /* 221065 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(221118), // Rule ID 4150 //
     /* 221070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 221073 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221081 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221094 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 221094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 221097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221102 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221116 */     GIR_RootConstrainSelectedInstOperands,
     /* 221117 */     // GIR_Coverage, 4150,
     /* 221117 */     GIR_EraseRootFromParent_Done,
     /* 221118 */   // Label 3593: @221118
     /* 221118 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(221175), // Rule ID 3725 //
     /* 221123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 221126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221149 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 221149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 221152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221159 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221173 */     GIR_RootConstrainSelectedInstOperands,
     /* 221174 */     // GIR_Coverage, 3725,
     /* 221174 */     GIR_EraseRootFromParent_Done,
     /* 221175 */   // Label 3594: @221175
     /* 221175 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(221231), // Rule ID 3785 //
     /* 221180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 221183 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221205 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 221205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 221208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221215 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221229 */     GIR_RootConstrainSelectedInstOperands,
     /* 221230 */     // GIR_Coverage, 3785,
     /* 221230 */     GIR_EraseRootFromParent_Done,
     /* 221231 */   // Label 3595: @221231
     /* 221231 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(221288), // Rule ID 4149 //
     /* 221236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 221239 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 221251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 221262 */     // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 221262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 221265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 221272 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 221274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221286 */     GIR_RootConstrainSelectedInstOperands,
     /* 221287 */     // GIR_Coverage, 4149,
     /* 221287 */     GIR_EraseRootFromParent_Done,
     /* 221288 */   // Label 3596: @221288
     /* 221288 */   GIM_Reject,
     /* 221289 */ // Label 3572: @221289
     /* 221289 */ GIM_Reject,
     /* 221290 */ // Label 3570: @221290
     /* 221290 */ GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(222547),
     /* 221295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 221298 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(221360), // Rule ID 5805 //
     /* 221303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221306 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221313 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221326 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64 anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64),
     /* 221329 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221358 */     GIR_RootConstrainSelectedInstOperands,
     /* 221359 */     // GIR_Coverage, 5805,
     /* 221359 */     GIR_EraseRootFromParent_Done,
     /* 221360 */   // Label 3598: @221360
     /* 221360 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(221422), // Rule ID 5809 //
     /* 221365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221368 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221375 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221388 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64 anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64),
     /* 221391 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221420 */     GIR_RootConstrainSelectedInstOperands,
     /* 221421 */     // GIR_Coverage, 5809,
     /* 221421 */     GIR_EraseRootFromParent_Done,
     /* 221422 */   // Label 3599: @221422
     /* 221422 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(221488), // Rule ID 5803 //
     /* 221427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221430 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221452 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64_RTN),
     /* 221455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221457 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221486 */     GIR_RootConstrainSelectedInstOperands,
     /* 221487 */     // GIR_Coverage, 5803,
     /* 221487 */     GIR_EraseRootFromParent_Done,
     /* 221488 */   // Label 3600: @221488
     /* 221488 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(221554), // Rule ID 5807 //
     /* 221493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221496 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 221518 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN),
     /* 221521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221523 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 221530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 221540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 221545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221552 */     GIR_RootConstrainSelectedInstOperands,
     /* 221553 */     // GIR_Coverage, 5807,
     /* 221553 */     GIR_EraseRootFromParent_Done,
     /* 221554 */   // Label 3601: @221554
     /* 221554 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(221611), // Rule ID 5804 //
     /* 221559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221562 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221569 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221582 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 221585 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221609 */     GIR_RootConstrainSelectedInstOperands,
     /* 221610 */     // GIR_Coverage, 5804,
     /* 221610 */     GIR_EraseRootFromParent_Done,
     /* 221611 */   // Label 3602: @221611
     /* 221611 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(221668), // Rule ID 5808 //
     /* 221616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221619 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221626 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221639 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 221642 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221666 */     GIR_RootConstrainSelectedInstOperands,
     /* 221667 */     // GIR_Coverage, 5808,
     /* 221667 */     GIR_EraseRootFromParent_Done,
     /* 221668 */   // Label 3603: @221668
     /* 221668 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(221729), // Rule ID 5802 //
     /* 221673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221676 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221698 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 221701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221703 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221727 */     GIR_RootConstrainSelectedInstOperands,
     /* 221728 */     // GIR_Coverage, 5802,
     /* 221728 */     GIR_EraseRootFromParent_Done,
     /* 221729 */   // Label 3604: @221729
     /* 221729 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(221790), // Rule ID 5806 //
     /* 221734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 221737 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 221744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 221759 */     // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 221759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 221762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 221764 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 221766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 221771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 221776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 221781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221784 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221788 */     GIR_RootConstrainSelectedInstOperands,
     /* 221789 */     // GIR_Coverage, 5806,
     /* 221789 */     GIR_EraseRootFromParent_Done,
     /* 221790 */   // Label 3605: @221790
     /* 221790 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(221840), // Rule ID 8439 //
     /* 221795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 221798 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221803 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221816 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
     /* 221819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221824 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221838 */     GIR_RootConstrainSelectedInstOperands,
     /* 221839 */     // GIR_Coverage, 8439,
     /* 221839 */     GIR_EraseRootFromParent_Done,
     /* 221840 */   // Label 3606: @221840
     /* 221840 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(221890), // Rule ID 8441 //
     /* 221845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 221848 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221853 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221866 */     // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f64>>  =>  (DS_MAX_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64_gfx9),
     /* 221869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221874 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221888 */     GIR_RootConstrainSelectedInstOperands,
     /* 221889 */     // GIR_Coverage, 8441,
     /* 221889 */     GIR_EraseRootFromParent_Done,
     /* 221890 */   // Label 3607: @221890
     /* 221890 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(221940), // Rule ID 8443 //
     /* 221895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 221898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 221903 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 221905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221916 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 221916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
     /* 221919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221924 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221938 */     GIR_RootConstrainSelectedInstOperands,
     /* 221939 */     // GIR_Coverage, 8443,
     /* 221939 */     GIR_EraseRootFromParent_Done,
     /* 221940 */   // Label 3608: @221940
     /* 221940 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(221994), // Rule ID 8438 //
     /* 221945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 221948 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 221953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 221957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 221961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 221968 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 221968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
     /* 221971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 221973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 221978 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 221980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 221985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 221992 */     GIR_RootConstrainSelectedInstOperands,
     /* 221993 */     // GIR_Coverage, 8438,
     /* 221993 */     GIR_EraseRootFromParent_Done,
     /* 221994 */   // Label 3609: @221994
     /* 221994 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(222048), // Rule ID 8440 //
     /* 221999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 222002 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 222007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222022 */     // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_f64>>  =>  (DS_MAX_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 222022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64_gfx9),
     /* 222025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222032 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222046 */     GIR_RootConstrainSelectedInstOperands,
     /* 222047 */     // GIR_Coverage, 8440,
     /* 222047 */     GIR_EraseRootFromParent_Done,
     /* 222048 */   // Label 3610: @222048
     /* 222048 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(222102), // Rule ID 8442 //
     /* 222053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 222056 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 222061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 222076 */     // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 222076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
     /* 222079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 222086 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 222088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222100 */     GIR_RootConstrainSelectedInstOperands,
     /* 222101 */     // GIR_Coverage, 8442,
     /* 222101 */     GIR_EraseRootFromParent_Done,
     /* 222102 */   // Label 3611: @222102
     /* 222102 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(222159), // Rule ID 4178 //
     /* 222107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 222110 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222117 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 222130 */     // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 222130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR),
     /* 222133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 222138 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 222145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222157 */     GIR_RootConstrainSelectedInstOperands,
     /* 222158 */     // GIR_Coverage, 4178,
     /* 222158 */     GIR_EraseRootFromParent_Done,
     /* 222159 */   // Label 3612: @222159
     /* 222159 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(222220), // Rule ID 4180 //
     /* 222164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 222167 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 222189 */     // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 222189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR_RTN),
     /* 222192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 222199 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 222206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222218 */     GIR_RootConstrainSelectedInstOperands,
     /* 222219 */     // GIR_Coverage, 4180,
     /* 222219 */     GIR_EraseRootFromParent_Done,
     /* 222220 */   // Label 3613: @222220
     /* 222220 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(222272), // Rule ID 4177 //
     /* 222225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 222228 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222235 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 222248 */     // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 222248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64),
     /* 222251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222256 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222270 */     GIR_RootConstrainSelectedInstOperands,
     /* 222271 */     // GIR_Coverage, 4177,
     /* 222271 */     GIR_EraseRootFromParent_Done,
     /* 222272 */   // Label 3614: @222272
     /* 222272 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(222328), // Rule ID 4179 //
     /* 222277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 222280 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 222302 */     // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 222302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_RTN),
     /* 222305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222312 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222326 */     GIR_RootConstrainSelectedInstOperands,
     /* 222327 */     // GIR_Coverage, 4179,
     /* 222327 */     GIR_EraseRootFromParent_Done,
     /* 222328 */   // Label 3615: @222328
     /* 222328 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(222381), // Rule ID 3730 //
     /* 222333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 222336 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222344 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222357 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 222357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
     /* 222360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222365 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222379 */     GIR_RootConstrainSelectedInstOperands,
     /* 222380 */     // GIR_Coverage, 3730,
     /* 222380 */     GIR_EraseRootFromParent_Done,
     /* 222381 */   // Label 3616: @222381
     /* 222381 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(222433), // Rule ID 3790 //
     /* 222386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 222389 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222396 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222409 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 222409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
     /* 222412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222417 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222431 */     GIR_RootConstrainSelectedInstOperands,
     /* 222432 */     // GIR_Coverage, 3790,
     /* 222432 */     GIR_EraseRootFromParent_Done,
     /* 222433 */   // Label 3617: @222433
     /* 222433 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(222490), // Rule ID 3729 //
     /* 222438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 222441 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222464 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 222464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
     /* 222467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222474 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222488 */     GIR_RootConstrainSelectedInstOperands,
     /* 222489 */     // GIR_Coverage, 3729,
     /* 222489 */     GIR_EraseRootFromParent_Done,
     /* 222490 */   // Label 3618: @222490
     /* 222490 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(222546), // Rule ID 3789 //
     /* 222495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 222498 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 222509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 222520 */     // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 222520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
     /* 222523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 222525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 222530 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 222532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 222537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222544 */     GIR_RootConstrainSelectedInstOperands,
     /* 222545 */     // GIR_Coverage, 3789,
     /* 222545 */     GIR_EraseRootFromParent_Done,
     /* 222546 */   // Label 3619: @222546
     /* 222546 */   GIM_Reject,
     /* 222547 */ // Label 3597: @222547
     /* 222547 */ GIM_Reject,
     /* 222548 */ // Label 3571: @222548
     /* 222548 */ GIM_Reject,
     /* 222549 */ // Label 31: @222549
     /* 222549 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3622*/ GIMT_Encode4(225194),
     /* 222560 */ /*GILLT_s32*//*Label 3620*/ GIMT_Encode4(222568),
     /* 222564 */ /*GILLT_s64*//*Label 3621*/ GIMT_Encode4(223936),
     /* 222568 */ // Label 3620: @222568
     /* 222568 */ GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(223935),
     /* 222573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 222576 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(222638), // Rule ID 5781 //
     /* 222581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 222584 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222591 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222604 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64 anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64),
     /* 222607 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222636 */     GIR_RootConstrainSelectedInstOperands,
     /* 222637 */     // GIR_Coverage, 5781,
     /* 222637 */     GIR_EraseRootFromParent_Done,
     /* 222638 */   // Label 3624: @222638
     /* 222638 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(222700), // Rule ID 5785 //
     /* 222643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 222646 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222653 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222666 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64 anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64),
     /* 222669 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222698 */     GIR_RootConstrainSelectedInstOperands,
     /* 222699 */     // GIR_Coverage, 5785,
     /* 222699 */     GIR_EraseRootFromParent_Done,
     /* 222700 */   // Label 3625: @222700
     /* 222700 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(222766), // Rule ID 5779 //
     /* 222705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 222708 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222730 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64_RTN),
     /* 222733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222735 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222764 */     GIR_RootConstrainSelectedInstOperands,
     /* 222765 */     // GIR_Coverage, 5779,
     /* 222765 */     GIR_EraseRootFromParent_Done,
     /* 222766 */   // Label 3626: @222766
     /* 222766 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(222832), // Rule ID 5783 //
     /* 222771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 222774 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 222796 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN),
     /* 222799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222801 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 222808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 222818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 222823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222830 */     GIR_RootConstrainSelectedInstOperands,
     /* 222831 */     // GIR_Coverage, 5783,
     /* 222831 */     GIR_EraseRootFromParent_Done,
     /* 222832 */   // Label 3627: @222832
     /* 222832 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(222889), // Rule ID 5780 //
     /* 222837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 222840 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222847 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222860 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
     /* 222863 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222887 */     GIR_RootConstrainSelectedInstOperands,
     /* 222888 */     // GIR_Coverage, 5780,
     /* 222888 */     GIR_EraseRootFromParent_Done,
     /* 222889 */   // Label 3628: @222889
     /* 222889 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(222946), // Rule ID 5784 //
     /* 222894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 222897 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222904 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 222906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222917 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
     /* 222920 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 222944 */     GIR_RootConstrainSelectedInstOperands,
     /* 222945 */     // GIR_Coverage, 5784,
     /* 222945 */     GIR_EraseRootFromParent_Done,
     /* 222946 */   // Label 3629: @222946
     /* 222946 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(223007), // Rule ID 5778 //
     /* 222951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 222954 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 222961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 222965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 222969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 222976 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 222976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
     /* 222979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 222981 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 222983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 222988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 222993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 222998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223005 */     GIR_RootConstrainSelectedInstOperands,
     /* 223006 */     // GIR_Coverage, 5778,
     /* 223006 */     GIR_EraseRootFromParent_Done,
     /* 223007 */   // Label 3630: @223007
     /* 223007 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(223068), // Rule ID 5782 //
     /* 223012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 223015 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 223037 */     // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
     /* 223040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 223042 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 223054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223066 */     GIR_RootConstrainSelectedInstOperands,
     /* 223067 */     // GIR_Coverage, 5782,
     /* 223067 */     GIR_EraseRootFromParent_Done,
     /* 223068 */   // Label 3631: @223068
     /* 223068 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(223118), // Rule ID 8340 //
     /* 223073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 223076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223081 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223094 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
     /* 223097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223102 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223116 */     GIR_RootConstrainSelectedInstOperands,
     /* 223117 */     // GIR_Coverage, 8340,
     /* 223117 */     GIR_EraseRootFromParent_Done,
     /* 223118 */   // Label 3632: @223118
     /* 223118 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(223168), // Rule ID 8342 //
     /* 223123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 223126 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223131 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223144 */     // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f32>>  =>  (DS_MIN_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32_gfx9),
     /* 223147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223152 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223166 */     GIR_RootConstrainSelectedInstOperands,
     /* 223167 */     // GIR_Coverage, 8342,
     /* 223167 */     GIR_EraseRootFromParent_Done,
     /* 223168 */   // Label 3633: @223168
     /* 223168 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(223218), // Rule ID 8344 //
     /* 223173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 223176 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 223181 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223194 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 223194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
     /* 223197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223202 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223216 */     GIR_RootConstrainSelectedInstOperands,
     /* 223217 */     // GIR_Coverage, 8344,
     /* 223217 */     GIR_EraseRootFromParent_Done,
     /* 223218 */   // Label 3634: @223218
     /* 223218 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(223272), // Rule ID 8339 //
     /* 223223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 223226 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223246 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
     /* 223249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223256 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223270 */     GIR_RootConstrainSelectedInstOperands,
     /* 223271 */     // GIR_Coverage, 8339,
     /* 223271 */     GIR_EraseRootFromParent_Done,
     /* 223272 */   // Label 3635: @223272
     /* 223272 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(223326), // Rule ID 8341 //
     /* 223277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 223280 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 223285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223300 */     // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_f32>>  =>  (DS_MIN_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 223300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32_gfx9),
     /* 223303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223310 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223324 */     GIR_RootConstrainSelectedInstOperands,
     /* 223325 */     // GIR_Coverage, 8341,
     /* 223325 */     GIR_EraseRootFromParent_Done,
     /* 223326 */   // Label 3636: @223326
     /* 223326 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(223380), // Rule ID 8343 //
     /* 223331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 223334 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 223339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 223354 */     // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 223354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
     /* 223357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 223364 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 223366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223378 */     GIR_RootConstrainSelectedInstOperands,
     /* 223379 */     // GIR_Coverage, 8343,
     /* 223379 */     GIR_EraseRootFromParent_Done,
     /* 223380 */   // Label 3637: @223380
     /* 223380 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(223437), // Rule ID 4140 //
     /* 223385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 223388 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223395 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 223408 */     // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 223408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
     /* 223411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 223416 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 223423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223435 */     GIR_RootConstrainSelectedInstOperands,
     /* 223436 */     // GIR_Coverage, 4140,
     /* 223436 */     GIR_EraseRootFromParent_Done,
     /* 223437 */   // Label 3638: @223437
     /* 223437 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(223498), // Rule ID 4142 //
     /* 223442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 223445 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 223467 */     // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 223467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
     /* 223470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 223477 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 223484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 223489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223496 */     GIR_RootConstrainSelectedInstOperands,
     /* 223497 */     // GIR_Coverage, 4142,
     /* 223497 */     GIR_EraseRootFromParent_Done,
     /* 223498 */   // Label 3639: @223498
     /* 223498 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(223550), // Rule ID 4139 //
     /* 223503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 223506 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223513 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 223526 */     // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
     /* 223529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223534 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223548 */     GIR_RootConstrainSelectedInstOperands,
     /* 223549 */     // GIR_Coverage, 4139,
     /* 223549 */     GIR_EraseRootFromParent_Done,
     /* 223550 */   // Label 3640: @223550
     /* 223550 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(223606), // Rule ID 4141 //
     /* 223555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
     /* 223558 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 223580 */     // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
     /* 223583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223590 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223604 */     GIR_RootConstrainSelectedInstOperands,
     /* 223605 */     // GIR_Coverage, 4141,
     /* 223605 */     GIR_EraseRootFromParent_Done,
     /* 223606 */   // Label 3641: @223606
     /* 223606 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(223659), // Rule ID 3724 //
     /* 223611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 223614 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223622 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223635 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 223638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223643 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223657 */     GIR_RootConstrainSelectedInstOperands,
     /* 223658 */     // GIR_Coverage, 3724,
     /* 223658 */     GIR_EraseRootFromParent_Done,
     /* 223659 */   // Label 3642: @223659
     /* 223659 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(223711), // Rule ID 3784 //
     /* 223664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 223667 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223674 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223687 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 223690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223695 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223709 */     GIR_RootConstrainSelectedInstOperands,
     /* 223710 */     // GIR_Coverage, 3784,
     /* 223710 */     GIR_EraseRootFromParent_Done,
     /* 223711 */   // Label 3643: @223711
     /* 223711 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(223764), // Rule ID 4148 //
     /* 223716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 223719 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223727 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223740 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 223743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223748 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223762 */     GIR_RootConstrainSelectedInstOperands,
     /* 223763 */     // GIR_Coverage, 4148,
     /* 223763 */     GIR_EraseRootFromParent_Done,
     /* 223764 */   // Label 3644: @223764
     /* 223764 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(223821), // Rule ID 3723 //
     /* 223769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 223772 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223795 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 223798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223805 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223819 */     GIR_RootConstrainSelectedInstOperands,
     /* 223820 */     // GIR_Coverage, 3723,
     /* 223820 */     GIR_EraseRootFromParent_Done,
     /* 223821 */   // Label 3645: @223821
     /* 223821 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(223877), // Rule ID 3783 //
     /* 223826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
     /* 223829 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223851 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 223854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223861 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223875 */     GIR_RootConstrainSelectedInstOperands,
     /* 223876 */     // GIR_Coverage, 3783,
     /* 223876 */     GIR_EraseRootFromParent_Done,
     /* 223877 */   // Label 3646: @223877
     /* 223877 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(223934), // Rule ID 4147 //
     /* 223882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
     /* 223885 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 223897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 223908 */     // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 223908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 223911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 223913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 223918 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 223920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 223925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 223932 */     GIR_RootConstrainSelectedInstOperands,
     /* 223933 */     // GIR_Coverage, 4147,
     /* 223933 */     GIR_EraseRootFromParent_Done,
     /* 223934 */   // Label 3647: @223934
     /* 223934 */   GIM_Reject,
     /* 223935 */ // Label 3623: @223935
     /* 223935 */ GIM_Reject,
     /* 223936 */ // Label 3621: @223936
     /* 223936 */ GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(225193),
     /* 223941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 223944 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(224006), // Rule ID 5797 //
     /* 223949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 223952 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 223959 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 223961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 223965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 223972 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64 anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 223972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64),
     /* 223975 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 223977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 223982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 223987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 223992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 223997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224004 */     GIR_RootConstrainSelectedInstOperands,
     /* 224005 */     // GIR_Coverage, 5797,
     /* 224005 */     GIR_EraseRootFromParent_Done,
     /* 224006 */   // Label 3649: @224006
     /* 224006 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(224068), // Rule ID 5801 //
     /* 224011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 224014 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224021 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 224034 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64 anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64),
     /* 224037 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 224044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 224054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 224059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224066 */     GIR_RootConstrainSelectedInstOperands,
     /* 224067 */     // GIR_Coverage, 5801,
     /* 224067 */     GIR_EraseRootFromParent_Done,
     /* 224068 */   // Label 3650: @224068
     /* 224068 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(224134), // Rule ID 5795 //
     /* 224073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 224076 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 224098 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64_RTN),
     /* 224101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224103 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 224110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 224120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 224125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224132 */     GIR_RootConstrainSelectedInstOperands,
     /* 224133 */     // GIR_Coverage, 5795,
     /* 224133 */     GIR_EraseRootFromParent_Done,
     /* 224134 */   // Label 3651: @224134
     /* 224134 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(224200), // Rule ID 5799 //
     /* 224139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 224142 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 224164 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN),
     /* 224167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224169 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 224176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 224186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 224191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224198 */     GIR_RootConstrainSelectedInstOperands,
     /* 224199 */     // GIR_Coverage, 5799,
     /* 224199 */     GIR_EraseRootFromParent_Done,
     /* 224200 */   // Label 3652: @224200
     /* 224200 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(224257), // Rule ID 5796 //
     /* 224205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 224208 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224215 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224228 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 224231 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224255 */     GIR_RootConstrainSelectedInstOperands,
     /* 224256 */     // GIR_Coverage, 5796,
     /* 224256 */     GIR_EraseRootFromParent_Done,
     /* 224257 */   // Label 3653: @224257
     /* 224257 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(224314), // Rule ID 5800 //
     /* 224262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 224265 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224272 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224285 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 224288 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224312 */     GIR_RootConstrainSelectedInstOperands,
     /* 224313 */     // GIR_Coverage, 5800,
     /* 224313 */     GIR_EraseRootFromParent_Done,
     /* 224314 */   // Label 3654: @224314
     /* 224314 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(224375), // Rule ID 5794 //
     /* 224319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 224322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224344 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 224347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224349 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224373 */     GIR_RootConstrainSelectedInstOperands,
     /* 224374 */     // GIR_Coverage, 5794,
     /* 224374 */     GIR_EraseRootFromParent_Done,
     /* 224375 */   // Label 3655: @224375
     /* 224375 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(224436), // Rule ID 5798 //
     /* 224380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 224383 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 224405 */     // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 224405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 224408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 224410 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 224412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 224417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 224422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224434 */     GIR_RootConstrainSelectedInstOperands,
     /* 224435 */     // GIR_Coverage, 5798,
     /* 224435 */     GIR_EraseRootFromParent_Done,
     /* 224436 */   // Label 3656: @224436
     /* 224436 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(224486), // Rule ID 8433 //
     /* 224441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 224444 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224449 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224462 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
     /* 224465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224470 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224484 */     GIR_RootConstrainSelectedInstOperands,
     /* 224485 */     // GIR_Coverage, 8433,
     /* 224485 */     GIR_EraseRootFromParent_Done,
     /* 224486 */   // Label 3657: @224486
     /* 224486 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(224536), // Rule ID 8435 //
     /* 224491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 224494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224499 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224512 */     // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f64>>  =>  (DS_MIN_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64_gfx9),
     /* 224515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224520 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224534 */     GIR_RootConstrainSelectedInstOperands,
     /* 224535 */     // GIR_Coverage, 8435,
     /* 224535 */     GIR_EraseRootFromParent_Done,
     /* 224536 */   // Label 3658: @224536
     /* 224536 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(224586), // Rule ID 8437 //
     /* 224541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 224544 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 224549 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224562 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 224562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
     /* 224565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224570 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224584 */     GIR_RootConstrainSelectedInstOperands,
     /* 224585 */     // GIR_Coverage, 8437,
     /* 224585 */     GIR_EraseRootFromParent_Done,
     /* 224586 */   // Label 3659: @224586
     /* 224586 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(224640), // Rule ID 8432 //
     /* 224591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 224594 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224614 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
     /* 224617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224624 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224638 */     GIR_RootConstrainSelectedInstOperands,
     /* 224639 */     // GIR_Coverage, 8432,
     /* 224639 */     GIR_EraseRootFromParent_Done,
     /* 224640 */   // Label 3660: @224640
     /* 224640 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(224694), // Rule ID 8434 //
     /* 224645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 224648 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 224653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224668 */     // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_f64>>  =>  (DS_MIN_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 224668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64_gfx9),
     /* 224671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224678 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224692 */     GIR_RootConstrainSelectedInstOperands,
     /* 224693 */     // GIR_Coverage, 8434,
     /* 224693 */     GIR_EraseRootFromParent_Done,
     /* 224694 */   // Label 3661: @224694
     /* 224694 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(224748), // Rule ID 8436 //
     /* 224699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 224702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 224707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 224722 */     // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 224722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
     /* 224725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 224732 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 224734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224746 */     GIR_RootConstrainSelectedInstOperands,
     /* 224747 */     // GIR_Coverage, 8436,
     /* 224747 */     GIR_EraseRootFromParent_Done,
     /* 224748 */   // Label 3662: @224748
     /* 224748 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(224805), // Rule ID 4174 //
     /* 224753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 224756 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224763 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 224776 */     // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 224776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR),
     /* 224779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 224784 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 224791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224803 */     GIR_RootConstrainSelectedInstOperands,
     /* 224804 */     // GIR_Coverage, 4174,
     /* 224804 */     GIR_EraseRootFromParent_Done,
     /* 224805 */   // Label 3663: @224805
     /* 224805 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(224866), // Rule ID 4176 //
     /* 224810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 224813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 224835 */     // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 224835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR_RTN),
     /* 224838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 224845 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 224852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 224857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224864 */     GIR_RootConstrainSelectedInstOperands,
     /* 224865 */     // GIR_Coverage, 4176,
     /* 224865 */     GIR_EraseRootFromParent_Done,
     /* 224866 */   // Label 3664: @224866
     /* 224866 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(224918), // Rule ID 4173 //
     /* 224871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 224874 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224881 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 224894 */     // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 224894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64),
     /* 224897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224902 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224916 */     GIR_RootConstrainSelectedInstOperands,
     /* 224917 */     // GIR_Coverage, 4173,
     /* 224917 */     GIR_EraseRootFromParent_Done,
     /* 224918 */   // Label 3665: @224918
     /* 224918 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(224974), // Rule ID 4175 //
     /* 224923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
     /* 224926 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 224937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 224948 */     // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 224948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_RTN),
     /* 224951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 224953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 224958 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 224960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 224965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 224972 */     GIR_RootConstrainSelectedInstOperands,
     /* 224973 */     // GIR_Coverage, 4175,
     /* 224973 */     GIR_EraseRootFromParent_Done,
     /* 224974 */   // Label 3666: @224974
     /* 224974 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(225027), // Rule ID 3728 //
     /* 224979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 224982 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 224990 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 224992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 224996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225003 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 225003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
     /* 225006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225011 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225025 */     GIR_RootConstrainSelectedInstOperands,
     /* 225026 */     // GIR_Coverage, 3728,
     /* 225026 */     GIR_EraseRootFromParent_Done,
     /* 225027 */   // Label 3667: @225027
     /* 225027 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(225079), // Rule ID 3788 //
     /* 225032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 225035 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225042 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225055 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 225055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
     /* 225058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225063 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225077 */     GIR_RootConstrainSelectedInstOperands,
     /* 225078 */     // GIR_Coverage, 3788,
     /* 225078 */     GIR_EraseRootFromParent_Done,
     /* 225079 */   // Label 3668: @225079
     /* 225079 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(225136), // Rule ID 3727 //
     /* 225084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 225087 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225110 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 225110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
     /* 225113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225120 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225134 */     GIR_RootConstrainSelectedInstOperands,
     /* 225135 */     // GIR_Coverage, 3727,
     /* 225135 */     GIR_EraseRootFromParent_Done,
     /* 225136 */   // Label 3669: @225136
     /* 225136 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(225192), // Rule ID 3787 //
     /* 225141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
     /* 225144 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 225155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 225166 */     // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
     /* 225166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
     /* 225169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 225176 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 225178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225190 */     GIR_RootConstrainSelectedInstOperands,
     /* 225191 */     // GIR_Coverage, 3787,
     /* 225191 */     GIR_EraseRootFromParent_Done,
     /* 225192 */   // Label 3670: @225192
     /* 225192 */   GIM_Reject,
     /* 225193 */ // Label 3648: @225193
     /* 225193 */ GIM_Reject,
     /* 225194 */ // Label 3622: @225194
     /* 225194 */ GIM_Reject,
     /* 225195 */ // Label 32: @225195
     /* 225195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3673*/ GIMT_Encode4(227706),
     /* 225206 */ /*GILLT_s32*//*Label 3671*/ GIMT_Encode4(225214),
     /* 225210 */ /*GILLT_s64*//*Label 3672*/ GIMT_Encode4(226460),
     /* 225214 */ // Label 3671: @225214
     /* 225214 */ GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(226459),
     /* 225219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 225222 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(225284), // Rule ID 5669 //
     /* 225227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225230 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225237 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225250 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64),
     /* 225253 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225282 */     GIR_RootConstrainSelectedInstOperands,
     /* 225283 */     // GIR_Coverage, 5669,
     /* 225283 */     GIR_EraseRootFromParent_Done,
     /* 225284 */   // Label 3675: @225284
     /* 225284 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(225343), // Rule ID 5673 //
     /* 225289 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225296 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225309 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64),
     /* 225312 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225341 */     GIR_RootConstrainSelectedInstOperands,
     /* 225342 */     // GIR_Coverage, 5673,
     /* 225342 */     GIR_EraseRootFromParent_Done,
     /* 225343 */   // Label 3676: @225343
     /* 225343 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(225409), // Rule ID 5667 //
     /* 225348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225351 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225373 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64_RTN),
     /* 225376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225378 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225407 */     GIR_RootConstrainSelectedInstOperands,
     /* 225408 */     // GIR_Coverage, 5667,
     /* 225408 */     GIR_EraseRootFromParent_Done,
     /* 225409 */   // Label 3677: @225409
     /* 225409 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(225472), // Rule ID 5671 //
     /* 225414 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 225436 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN),
     /* 225439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225441 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 225448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 225458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 225463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225470 */     GIR_RootConstrainSelectedInstOperands,
     /* 225471 */     // GIR_Coverage, 5671,
     /* 225471 */     GIR_EraseRootFromParent_Done,
     /* 225472 */   // Label 3678: @225472
     /* 225472 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(225529), // Rule ID 5668 //
     /* 225477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225487 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225500 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
     /* 225503 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225527 */     GIR_RootConstrainSelectedInstOperands,
     /* 225528 */     // GIR_Coverage, 5668,
     /* 225528 */     GIR_EraseRootFromParent_Done,
     /* 225529 */   // Label 3679: @225529
     /* 225529 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(225583), // Rule ID 5672 //
     /* 225534 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225541 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225554 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
     /* 225557 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225581 */     GIR_RootConstrainSelectedInstOperands,
     /* 225582 */     // GIR_Coverage, 5672,
     /* 225582 */     GIR_EraseRootFromParent_Done,
     /* 225583 */   // Label 3680: @225583
     /* 225583 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(225644), // Rule ID 5666 //
     /* 225588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 225591 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225613 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
     /* 225616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225618 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225642 */     GIR_RootConstrainSelectedInstOperands,
     /* 225643 */     // GIR_Coverage, 5666,
     /* 225643 */     GIR_EraseRootFromParent_Done,
     /* 225644 */   // Label 3681: @225644
     /* 225644 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(225702), // Rule ID 5670 //
     /* 225649 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 225656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 225671 */     // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 225671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
     /* 225674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 225676 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 225678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 225683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 225688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 225693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225700 */     GIR_RootConstrainSelectedInstOperands,
     /* 225701 */     // GIR_Coverage, 5670,
     /* 225701 */     GIR_EraseRootFromParent_Done,
     /* 225702 */   // Label 3682: @225702
     /* 225702 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(225752), // Rule ID 8286 //
     /* 225707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 225710 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225715 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225728 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
     /* 225731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225736 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225750 */     GIR_RootConstrainSelectedInstOperands,
     /* 225751 */     // GIR_Coverage, 8286,
     /* 225751 */     GIR_EraseRootFromParent_Done,
     /* 225752 */   // Label 3683: @225752
     /* 225752 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(225802), // Rule ID 8288 //
     /* 225757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 225760 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225765 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225778 */     // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i32>>  =>  (DS_INC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32_gfx9),
     /* 225781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225786 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225800 */     GIR_RootConstrainSelectedInstOperands,
     /* 225801 */     // GIR_Coverage, 8288,
     /* 225801 */     GIR_EraseRootFromParent_Done,
     /* 225802 */   // Label 3684: @225802
     /* 225802 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(225852), // Rule ID 8290 //
     /* 225807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 225810 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 225815 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 225817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225828 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 225828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
     /* 225831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225836 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225850 */     GIR_RootConstrainSelectedInstOperands,
     /* 225851 */     // GIR_Coverage, 8290,
     /* 225851 */     GIR_EraseRootFromParent_Done,
     /* 225852 */   // Label 3685: @225852
     /* 225852 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(225906), // Rule ID 8285 //
     /* 225857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 225860 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225880 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
     /* 225883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225890 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225904 */     GIR_RootConstrainSelectedInstOperands,
     /* 225905 */     // GIR_Coverage, 8285,
     /* 225905 */     GIR_EraseRootFromParent_Done,
     /* 225906 */   // Label 3686: @225906
     /* 225906 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(225960), // Rule ID 8287 //
     /* 225911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 225914 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 225919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225934 */     // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i32>>  =>  (DS_INC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 225934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32_gfx9),
     /* 225937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225944 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 225946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 225951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 225958 */     GIR_RootConstrainSelectedInstOperands,
     /* 225959 */     // GIR_Coverage, 8287,
     /* 225959 */     GIR_EraseRootFromParent_Done,
     /* 225960 */   // Label 3687: @225960
     /* 225960 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(226014), // Rule ID 8289 //
     /* 225965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 225968 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 225973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 225977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 225981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 225988 */     // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 225988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
     /* 225991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 225993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 225998 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 226000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226012 */     GIR_RootConstrainSelectedInstOperands,
     /* 226013 */     // GIR_Coverage, 8289,
     /* 226013 */     GIR_EraseRootFromParent_Done,
     /* 226014 */   // Label 3688: @226014
     /* 226014 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(226071), // Rule ID 4022 //
     /* 226019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226022 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226029 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 226042 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 226042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR),
     /* 226045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 226050 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 226057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226069 */     GIR_RootConstrainSelectedInstOperands,
     /* 226070 */     // GIR_Coverage, 4022,
     /* 226070 */     GIR_EraseRootFromParent_Done,
     /* 226071 */   // Label 3689: @226071
     /* 226071 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(226132), // Rule ID 4024 //
     /* 226076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226079 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 226090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 226101 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 226101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR_RTN),
     /* 226104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 226111 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 226118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226130 */     GIR_RootConstrainSelectedInstOperands,
     /* 226131 */     // GIR_Coverage, 4024,
     /* 226131 */     GIR_EraseRootFromParent_Done,
     /* 226132 */   // Label 3690: @226132
     /* 226132 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(226184), // Rule ID 4021 //
     /* 226137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226140 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226147 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 226160 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 226160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC),
     /* 226163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226168 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226182 */     GIR_RootConstrainSelectedInstOperands,
     /* 226183 */     // GIR_Coverage, 4021,
     /* 226183 */     GIR_EraseRootFromParent_Done,
     /* 226184 */   // Label 3691: @226184
     /* 226184 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(226240), // Rule ID 4023 //
     /* 226189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 226192 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 226203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 226214 */     // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 226214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_RTN),
     /* 226217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226224 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226238 */     GIR_RootConstrainSelectedInstOperands,
     /* 226239 */     // GIR_Coverage, 4023,
     /* 226239 */     GIR_EraseRootFromParent_Done,
     /* 226240 */   // Label 3692: @226240
     /* 226240 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(226293), // Rule ID 3676 //
     /* 226245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226248 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226256 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226269 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 226269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
     /* 226272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226277 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226291 */     GIR_RootConstrainSelectedInstOperands,
     /* 226292 */     // GIR_Coverage, 3676,
     /* 226292 */     GIR_EraseRootFromParent_Done,
     /* 226293 */   // Label 3693: @226293
     /* 226293 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(226345), // Rule ID 3736 //
     /* 226298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226301 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226308 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226321 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 226321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
     /* 226324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226329 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226343 */     GIR_RootConstrainSelectedInstOperands,
     /* 226344 */     // GIR_Coverage, 3736,
     /* 226344 */     GIR_EraseRootFromParent_Done,
     /* 226345 */   // Label 3694: @226345
     /* 226345 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(226402), // Rule ID 3675 //
     /* 226350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226353 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 226365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226376 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 226376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
     /* 226379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226386 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226400 */     GIR_RootConstrainSelectedInstOperands,
     /* 226401 */     // GIR_Coverage, 3675,
     /* 226401 */     GIR_EraseRootFromParent_Done,
     /* 226402 */   // Label 3695: @226402
     /* 226402 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(226458), // Rule ID 3735 //
     /* 226407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 226410 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 226421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 226432 */     // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 226432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
     /* 226435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 226437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 226442 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 226444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226456 */     GIR_RootConstrainSelectedInstOperands,
     /* 226457 */     // GIR_Coverage, 3735,
     /* 226457 */     GIR_EraseRootFromParent_Done,
     /* 226458 */   // Label 3696: @226458
     /* 226458 */   GIM_Reject,
     /* 226459 */ // Label 3674: @226459
     /* 226459 */ GIM_Reject,
     /* 226460 */ // Label 3672: @226460
     /* 226460 */ GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(227705),
     /* 226465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 226468 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(226530), // Rule ID 5765 //
     /* 226473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 226476 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226483 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 226496 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64),
     /* 226499 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 226506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 226516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 226521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226528 */     GIR_RootConstrainSelectedInstOperands,
     /* 226529 */     // GIR_Coverage, 5765,
     /* 226529 */     GIR_EraseRootFromParent_Done,
     /* 226530 */   // Label 3698: @226530
     /* 226530 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(226589), // Rule ID 5769 //
     /* 226535 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226542 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 226555 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64),
     /* 226558 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 226565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 226575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 226580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226587 */     GIR_RootConstrainSelectedInstOperands,
     /* 226588 */     // GIR_Coverage, 5769,
     /* 226588 */     GIR_EraseRootFromParent_Done,
     /* 226589 */   // Label 3699: @226589
     /* 226589 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(226655), // Rule ID 5763 //
     /* 226594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 226597 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 226619 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64_RTN),
     /* 226622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 226624 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 226631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 226641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 226646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226653 */     GIR_RootConstrainSelectedInstOperands,
     /* 226654 */     // GIR_Coverage, 5763,
     /* 226654 */     GIR_EraseRootFromParent_Done,
     /* 226655 */   // Label 3700: @226655
     /* 226655 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(226718), // Rule ID 5767 //
     /* 226660 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 226682 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN),
     /* 226685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 226687 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 226694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 226704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 226709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226716 */     GIR_RootConstrainSelectedInstOperands,
     /* 226717 */     // GIR_Coverage, 5767,
     /* 226717 */     GIR_EraseRootFromParent_Done,
     /* 226718 */   // Label 3701: @226718
     /* 226718 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(226775), // Rule ID 5764 //
     /* 226723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 226726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226733 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 226746 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
     /* 226749 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 226761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226773 */     GIR_RootConstrainSelectedInstOperands,
     /* 226774 */     // GIR_Coverage, 5764,
     /* 226774 */     GIR_EraseRootFromParent_Done,
     /* 226775 */   // Label 3702: @226775
     /* 226775 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(226829), // Rule ID 5768 //
     /* 226780 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226787 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 226800 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
     /* 226803 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 226815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226827 */     GIR_RootConstrainSelectedInstOperands,
     /* 226828 */     // GIR_Coverage, 5768,
     /* 226828 */     GIR_EraseRootFromParent_Done,
     /* 226829 */   // Label 3703: @226829
     /* 226829 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(226890), // Rule ID 5762 //
     /* 226834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 226837 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 226859 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
     /* 226862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 226864 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 226876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226888 */     GIR_RootConstrainSelectedInstOperands,
     /* 226889 */     // GIR_Coverage, 5762,
     /* 226889 */     GIR_EraseRootFromParent_Done,
     /* 226890 */   // Label 3704: @226890
     /* 226890 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(226948), // Rule ID 5766 //
     /* 226895 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 226902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 226906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 226917 */     // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 226917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
     /* 226920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 226922 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 226924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 226929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 226934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 226939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226946 */     GIR_RootConstrainSelectedInstOperands,
     /* 226947 */     // GIR_Coverage, 5766,
     /* 226947 */     GIR_EraseRootFromParent_Done,
     /* 226948 */   // Label 3705: @226948
     /* 226948 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(226998), // Rule ID 8379 //
     /* 226953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 226956 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 226961 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 226963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 226967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 226974 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 226974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
     /* 226977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 226982 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 226984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 226989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 226996 */     GIR_RootConstrainSelectedInstOperands,
     /* 226997 */     // GIR_Coverage, 8379,
     /* 226997 */     GIR_EraseRootFromParent_Done,
     /* 226998 */   // Label 3706: @226998
     /* 226998 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(227048), // Rule ID 8381 //
     /* 227003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 227006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 227011 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 227024 */     // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i64>>  =>  (DS_INC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 227024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64_gfx9),
     /* 227027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 227032 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 227034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227046 */     GIR_RootConstrainSelectedInstOperands,
     /* 227047 */     // GIR_Coverage, 8381,
     /* 227047 */     GIR_EraseRootFromParent_Done,
     /* 227048 */   // Label 3707: @227048
     /* 227048 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(227098), // Rule ID 8383 //
     /* 227053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 227056 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 227061 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 227074 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 227074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
     /* 227077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 227082 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 227084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227096 */     GIR_RootConstrainSelectedInstOperands,
     /* 227097 */     // GIR_Coverage, 8383,
     /* 227097 */     GIR_EraseRootFromParent_Done,
     /* 227098 */   // Label 3708: @227098
     /* 227098 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(227152), // Rule ID 8378 //
     /* 227103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 227106 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 227111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 227115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 227126 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 227126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
     /* 227129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 227136 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 227138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227150 */     GIR_RootConstrainSelectedInstOperands,
     /* 227151 */     // GIR_Coverage, 8378,
     /* 227151 */     GIR_EraseRootFromParent_Done,
     /* 227152 */   // Label 3709: @227152
     /* 227152 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(227206), // Rule ID 8380 //
     /* 227157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 227160 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 227165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 227169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 227180 */     // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i64>>  =>  (DS_INC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 227180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64_gfx9),
     /* 227183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 227190 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 227192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227204 */     GIR_RootConstrainSelectedInstOperands,
     /* 227205 */     // GIR_Coverage, 8380,
     /* 227205 */     GIR_EraseRootFromParent_Done,
     /* 227206 */   // Label 3710: @227206
     /* 227206 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(227260), // Rule ID 8382 //
     /* 227211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 227214 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 227219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 227223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 227234 */     // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 227234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
     /* 227237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 227244 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 227246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227258 */     GIR_RootConstrainSelectedInstOperands,
     /* 227259 */     // GIR_Coverage, 8382,
     /* 227259 */     GIR_EraseRootFromParent_Done,
     /* 227260 */   // Label 3711: @227260
     /* 227260 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(227317), // Rule ID 4078 //
     /* 227265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 227268 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227275 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 227288 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 227288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR),
     /* 227291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 227296 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 227303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 227308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227315 */     GIR_RootConstrainSelectedInstOperands,
     /* 227316 */     // GIR_Coverage, 4078,
     /* 227316 */     GIR_EraseRootFromParent_Done,
     /* 227317 */   // Label 3712: @227317
     /* 227317 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(227378), // Rule ID 4080 //
     /* 227322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 227325 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 227336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 227347 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 227347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR_RTN),
     /* 227350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 227357 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 227364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 227369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227376 */     GIR_RootConstrainSelectedInstOperands,
     /* 227377 */     // GIR_Coverage, 4080,
     /* 227377 */     GIR_EraseRootFromParent_Done,
     /* 227378 */   // Label 3713: @227378
     /* 227378 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(227430), // Rule ID 4077 //
     /* 227383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 227386 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227393 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 227406 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 227406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2),
     /* 227409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 227414 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227428 */     GIR_RootConstrainSelectedInstOperands,
     /* 227429 */     // GIR_Coverage, 4077,
     /* 227429 */     GIR_EraseRootFromParent_Done,
     /* 227430 */   // Label 3714: @227430
     /* 227430 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(227486), // Rule ID 4079 //
     /* 227435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 227438 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 227449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 227460 */     // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 227460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_RTN),
     /* 227463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 227470 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227484 */     GIR_RootConstrainSelectedInstOperands,
     /* 227485 */     // GIR_Coverage, 4079,
     /* 227485 */     GIR_EraseRootFromParent_Done,
     /* 227486 */   // Label 3715: @227486
     /* 227486 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(227539), // Rule ID 3702 //
     /* 227491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 227494 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227502 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 227515 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 227515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
     /* 227518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 227523 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227537 */     GIR_RootConstrainSelectedInstOperands,
     /* 227538 */     // GIR_Coverage, 3702,
     /* 227538 */     GIR_EraseRootFromParent_Done,
     /* 227539 */   // Label 3716: @227539
     /* 227539 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(227591), // Rule ID 3762 //
     /* 227544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 227547 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227554 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 227567 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 227567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
     /* 227570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 227575 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227589 */     GIR_RootConstrainSelectedInstOperands,
     /* 227590 */     // GIR_Coverage, 3762,
     /* 227590 */     GIR_EraseRootFromParent_Done,
     /* 227591 */   // Label 3717: @227591
     /* 227591 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(227648), // Rule ID 3701 //
     /* 227596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 227599 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 227611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 227622 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 227622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
     /* 227625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 227632 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227646 */     GIR_RootConstrainSelectedInstOperands,
     /* 227647 */     // GIR_Coverage, 3701,
     /* 227647 */     GIR_EraseRootFromParent_Done,
     /* 227648 */   // Label 3718: @227648
     /* 227648 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(227704), // Rule ID 3761 //
     /* 227653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 227656 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 227667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 227678 */     // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 227678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
     /* 227681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 227683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 227688 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 227690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 227695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227702 */     GIR_RootConstrainSelectedInstOperands,
     /* 227703 */     // GIR_Coverage, 3761,
     /* 227703 */     GIR_EraseRootFromParent_Done,
     /* 227704 */   // Label 3719: @227704
     /* 227704 */   GIM_Reject,
     /* 227705 */ // Label 3697: @227705
     /* 227705 */ GIM_Reject,
     /* 227706 */ // Label 3673: @227706
     /* 227706 */ GIM_Reject,
     /* 227707 */ // Label 33: @227707
     /* 227707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3722*/ GIMT_Encode4(230218),
     /* 227718 */ /*GILLT_s32*//*Label 3720*/ GIMT_Encode4(227726),
     /* 227722 */ /*GILLT_s64*//*Label 3721*/ GIMT_Encode4(228972),
     /* 227726 */ // Label 3720: @227726
     /* 227726 */ GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(228971),
     /* 227731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227734 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(227796), // Rule ID 5677 //
     /* 227739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 227742 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227749 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 227762 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 227762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64),
     /* 227765 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 227767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 227772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 227777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 227782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 227787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227794 */     GIR_RootConstrainSelectedInstOperands,
     /* 227795 */     // GIR_Coverage, 5677,
     /* 227795 */     GIR_EraseRootFromParent_Done,
     /* 227796 */   // Label 3724: @227796
     /* 227796 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(227855), // Rule ID 5681 //
     /* 227801 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227808 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 227810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 227821 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64 anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 227821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64),
     /* 227824 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 227826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 227831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 227836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 227841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 227846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227853 */     GIR_RootConstrainSelectedInstOperands,
     /* 227854 */     // GIR_Coverage, 5681,
     /* 227854 */     GIR_EraseRootFromParent_Done,
     /* 227855 */   // Label 3725: @227855
     /* 227855 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(227921), // Rule ID 5675 //
     /* 227860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 227863 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 227874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 227885 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 227885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64_RTN),
     /* 227888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 227890 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 227892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 227897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 227902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 227907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 227912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227919 */     GIR_RootConstrainSelectedInstOperands,
     /* 227920 */     // GIR_Coverage, 5675,
     /* 227920 */     GIR_EraseRootFromParent_Done,
     /* 227921 */   // Label 3726: @227921
     /* 227921 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(227984), // Rule ID 5679 //
     /* 227926 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 227937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 227941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 227948 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 227948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN),
     /* 227951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 227953 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 227955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 227960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 227965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 227970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 227975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 227982 */     GIR_RootConstrainSelectedInstOperands,
     /* 227983 */     // GIR_Coverage, 5679,
     /* 227983 */     GIR_EraseRootFromParent_Done,
     /* 227984 */   // Label 3727: @227984
     /* 227984 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(228041), // Rule ID 5676 //
     /* 227989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 227992 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 227999 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 228012 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 228012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
     /* 228015 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 228017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 228022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 228027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 228032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228039 */     GIR_RootConstrainSelectedInstOperands,
     /* 228040 */     // GIR_Coverage, 5676,
     /* 228040 */     GIR_EraseRootFromParent_Done,
     /* 228041 */   // Label 3728: @228041
     /* 228041 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(228095), // Rule ID 5680 //
     /* 228046 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228053 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 228066 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 228066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
     /* 228069 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 228071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 228076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 228081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 228086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228093 */     GIR_RootConstrainSelectedInstOperands,
     /* 228094 */     // GIR_Coverage, 5680,
     /* 228094 */     GIR_EraseRootFromParent_Done,
     /* 228095 */   // Label 3729: @228095
     /* 228095 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(228156), // Rule ID 5674 //
     /* 228100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 228103 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 228125 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 228125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
     /* 228128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 228130 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 228132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 228137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 228142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 228147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228154 */     GIR_RootConstrainSelectedInstOperands,
     /* 228155 */     // GIR_Coverage, 5674,
     /* 228155 */     GIR_EraseRootFromParent_Done,
     /* 228156 */   // Label 3730: @228156
     /* 228156 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(228214), // Rule ID 5678 //
     /* 228161 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 228183 */     // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 228183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
     /* 228186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 228188 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 228190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 228195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 228200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 228205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228212 */     GIR_RootConstrainSelectedInstOperands,
     /* 228213 */     // GIR_Coverage, 5678,
     /* 228213 */     GIR_EraseRootFromParent_Done,
     /* 228214 */   // Label 3731: @228214
     /* 228214 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(228264), // Rule ID 8292 //
     /* 228219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 228222 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 228227 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 228240 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 228240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
     /* 228243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 228248 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 228250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228262 */     GIR_RootConstrainSelectedInstOperands,
     /* 228263 */     // GIR_Coverage, 8292,
     /* 228263 */     GIR_EraseRootFromParent_Done,
     /* 228264 */   // Label 3732: @228264
     /* 228264 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(228314), // Rule ID 8294 //
     /* 228269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 228272 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 228277 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 228290 */     // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i32>>  =>  (DS_DEC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 228290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32_gfx9),
     /* 228293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 228298 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 228300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228312 */     GIR_RootConstrainSelectedInstOperands,
     /* 228313 */     // GIR_Coverage, 8294,
     /* 228313 */     GIR_EraseRootFromParent_Done,
     /* 228314 */   // Label 3733: @228314
     /* 228314 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(228364), // Rule ID 8296 //
     /* 228319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 228322 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 228327 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 228340 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 228340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
     /* 228343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 228348 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 228350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228362 */     GIR_RootConstrainSelectedInstOperands,
     /* 228363 */     // GIR_Coverage, 8296,
     /* 228363 */     GIR_EraseRootFromParent_Done,
     /* 228364 */   // Label 3734: @228364
     /* 228364 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(228418), // Rule ID 8291 //
     /* 228369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 228372 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 228377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 228392 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 228392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
     /* 228395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 228402 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 228404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228416 */     GIR_RootConstrainSelectedInstOperands,
     /* 228417 */     // GIR_Coverage, 8291,
     /* 228417 */     GIR_EraseRootFromParent_Done,
     /* 228418 */   // Label 3735: @228418
     /* 228418 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(228472), // Rule ID 8293 //
     /* 228423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 228426 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 228431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 228446 */     // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i32>>  =>  (DS_DEC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 228446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32_gfx9),
     /* 228449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 228456 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 228458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228470 */     GIR_RootConstrainSelectedInstOperands,
     /* 228471 */     // GIR_Coverage, 8293,
     /* 228471 */     GIR_EraseRootFromParent_Done,
     /* 228472 */   // Label 3736: @228472
     /* 228472 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(228526), // Rule ID 8295 //
     /* 228477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 228480 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 228485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 228500 */     // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 228500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
     /* 228503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 228510 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 228512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228524 */     GIR_RootConstrainSelectedInstOperands,
     /* 228525 */     // GIR_Coverage, 8295,
     /* 228525 */     GIR_EraseRootFromParent_Done,
     /* 228526 */   // Label 3737: @228526
     /* 228526 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(228583), // Rule ID 4026 //
     /* 228531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 228534 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228541 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 228554 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 228554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR),
     /* 228557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 228562 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 228569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 228574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228581 */     GIR_RootConstrainSelectedInstOperands,
     /* 228582 */     // GIR_Coverage, 4026,
     /* 228582 */     GIR_EraseRootFromParent_Done,
     /* 228583 */   // Label 3738: @228583
     /* 228583 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(228644), // Rule ID 4028 //
     /* 228588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 228591 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 228613 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 228613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR_RTN),
     /* 228616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 228623 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 228630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 228635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228642 */     GIR_RootConstrainSelectedInstOperands,
     /* 228643 */     // GIR_Coverage, 4028,
     /* 228643 */     GIR_EraseRootFromParent_Done,
     /* 228644 */   // Label 3739: @228644
     /* 228644 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(228696), // Rule ID 4025 //
     /* 228649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 228652 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228659 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 228672 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 228672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC),
     /* 228675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 228680 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228694 */     GIR_RootConstrainSelectedInstOperands,
     /* 228695 */     // GIR_Coverage, 4025,
     /* 228695 */     GIR_EraseRootFromParent_Done,
     /* 228696 */   // Label 3740: @228696
     /* 228696 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(228752), // Rule ID 4027 //
     /* 228701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 228704 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 228726 */     // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 228726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_RTN),
     /* 228729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 228736 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228750 */     GIR_RootConstrainSelectedInstOperands,
     /* 228751 */     // GIR_Coverage, 4027,
     /* 228751 */     GIR_EraseRootFromParent_Done,
     /* 228752 */   // Label 3741: @228752
     /* 228752 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(228805), // Rule ID 3678 //
     /* 228757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 228760 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228768 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 228781 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 228781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
     /* 228784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 228789 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228803 */     GIR_RootConstrainSelectedInstOperands,
     /* 228804 */     // GIR_Coverage, 3678,
     /* 228804 */     GIR_EraseRootFromParent_Done,
     /* 228805 */   // Label 3742: @228805
     /* 228805 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(228857), // Rule ID 3738 //
     /* 228810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 228813 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228820 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 228833 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 228833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
     /* 228836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 228841 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 228851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228855 */     GIR_RootConstrainSelectedInstOperands,
     /* 228856 */     // GIR_Coverage, 3738,
     /* 228856 */     GIR_EraseRootFromParent_Done,
     /* 228857 */   // Label 3743: @228857
     /* 228857 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(228914), // Rule ID 3677 //
     /* 228862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 228865 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 228888 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 228888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
     /* 228891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 228898 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228912 */     GIR_RootConstrainSelectedInstOperands,
     /* 228913 */     // GIR_Coverage, 3677,
     /* 228913 */     GIR_EraseRootFromParent_Done,
     /* 228914 */   // Label 3744: @228914
     /* 228914 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(228970), // Rule ID 3737 //
     /* 228919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 228922 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 228933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 228937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 228944 */     // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 228944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
     /* 228947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 228949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 228954 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 228956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 228961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 228964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 228968 */     GIR_RootConstrainSelectedInstOperands,
     /* 228969 */     // GIR_Coverage, 3737,
     /* 228969 */     GIR_EraseRootFromParent_Done,
     /* 228970 */   // Label 3745: @228970
     /* 228970 */   GIM_Reject,
     /* 228971 */ // Label 3723: @228971
     /* 228971 */ GIM_Reject,
     /* 228972 */ // Label 3721: @228972
     /* 228972 */ GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(230217),
     /* 228977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228980 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(229042), // Rule ID 5773 //
     /* 228985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 228988 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 228995 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 228997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 229008 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64),
     /* 229011 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 229018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 229028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 229033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229040 */     GIR_RootConstrainSelectedInstOperands,
     /* 229041 */     // GIR_Coverage, 5773,
     /* 229041 */     GIR_EraseRootFromParent_Done,
     /* 229042 */   // Label 3747: @229042
     /* 229042 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(229101), // Rule ID 5777 //
     /* 229047 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229054 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 229067 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64 anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64),
     /* 229070 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 229077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 229087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 229092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229099 */     GIR_RootConstrainSelectedInstOperands,
     /* 229100 */     // GIR_Coverage, 5777,
     /* 229100 */     GIR_EraseRootFromParent_Done,
     /* 229101 */   // Label 3748: @229101
     /* 229101 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(229167), // Rule ID 5771 //
     /* 229106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 229109 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 229131 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64_RTN),
     /* 229134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 229136 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 229143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 229153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 229158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229165 */     GIR_RootConstrainSelectedInstOperands,
     /* 229166 */     // GIR_Coverage, 5771,
     /* 229166 */     GIR_EraseRootFromParent_Done,
     /* 229167 */   // Label 3749: @229167
     /* 229167 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(229230), // Rule ID 5775 //
     /* 229172 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 229194 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN),
     /* 229197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 229199 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 229206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 229216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 229221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229228 */     GIR_RootConstrainSelectedInstOperands,
     /* 229229 */     // GIR_Coverage, 5775,
     /* 229229 */     GIR_EraseRootFromParent_Done,
     /* 229230 */   // Label 3750: @229230
     /* 229230 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(229287), // Rule ID 5772 //
     /* 229235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 229238 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229245 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 229258 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
     /* 229261 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 229273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 229278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229285 */     GIR_RootConstrainSelectedInstOperands,
     /* 229286 */     // GIR_Coverage, 5772,
     /* 229286 */     GIR_EraseRootFromParent_Done,
     /* 229287 */   // Label 3751: @229287
     /* 229287 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(229341), // Rule ID 5776 //
     /* 229292 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229299 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 229312 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
     /* 229315 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 229327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 229332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229339 */     GIR_RootConstrainSelectedInstOperands,
     /* 229340 */     // GIR_Coverage, 5776,
     /* 229340 */     GIR_EraseRootFromParent_Done,
     /* 229341 */   // Label 3752: @229341
     /* 229341 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(229402), // Rule ID 5770 //
     /* 229346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 229349 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 229371 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
     /* 229374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 229376 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 229388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 229393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229400 */     GIR_RootConstrainSelectedInstOperands,
     /* 229401 */     // GIR_Coverage, 5770,
     /* 229401 */     GIR_EraseRootFromParent_Done,
     /* 229402 */   // Label 3753: @229402
     /* 229402 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(229460), // Rule ID 5774 //
     /* 229407 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 229429 */     // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 229429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
     /* 229432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 229434 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 229436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 229441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 229446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 229451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229458 */     GIR_RootConstrainSelectedInstOperands,
     /* 229459 */     // GIR_Coverage, 5774,
     /* 229459 */     GIR_EraseRootFromParent_Done,
     /* 229460 */   // Label 3754: @229460
     /* 229460 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(229510), // Rule ID 8385 //
     /* 229465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 229468 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 229473 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 229486 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 229486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
     /* 229489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 229494 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 229496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229508 */     GIR_RootConstrainSelectedInstOperands,
     /* 229509 */     // GIR_Coverage, 8385,
     /* 229509 */     GIR_EraseRootFromParent_Done,
     /* 229510 */   // Label 3755: @229510
     /* 229510 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(229560), // Rule ID 8387 //
     /* 229515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 229518 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 229523 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 229536 */     // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i64>>  =>  (DS_DEC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 229536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64_gfx9),
     /* 229539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 229544 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 229546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229558 */     GIR_RootConstrainSelectedInstOperands,
     /* 229559 */     // GIR_Coverage, 8387,
     /* 229559 */     GIR_EraseRootFromParent_Done,
     /* 229560 */   // Label 3756: @229560
     /* 229560 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(229610), // Rule ID 8389 //
     /* 229565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 229568 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 229573 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 229586 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 229586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
     /* 229589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 229594 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 229596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229608 */     GIR_RootConstrainSelectedInstOperands,
     /* 229609 */     // GIR_Coverage, 8389,
     /* 229609 */     GIR_EraseRootFromParent_Done,
     /* 229610 */   // Label 3757: @229610
     /* 229610 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(229664), // Rule ID 8384 //
     /* 229615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
     /* 229618 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 229623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 229638 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 229638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
     /* 229641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 229648 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 229650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229662 */     GIR_RootConstrainSelectedInstOperands,
     /* 229663 */     // GIR_Coverage, 8384,
     /* 229663 */     GIR_EraseRootFromParent_Done,
     /* 229664 */   // Label 3758: @229664
     /* 229664 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(229718), // Rule ID 8386 //
     /* 229669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
     /* 229672 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 229677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 229692 */     // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i64>>  =>  (DS_DEC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 229692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64_gfx9),
     /* 229695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 229702 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 229704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229716 */     GIR_RootConstrainSelectedInstOperands,
     /* 229717 */     // GIR_Coverage, 8386,
     /* 229717 */     GIR_EraseRootFromParent_Done,
     /* 229718 */   // Label 3759: @229718
     /* 229718 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(229772), // Rule ID 8388 //
     /* 229723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
     /* 229726 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
     /* 229731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 229746 */     // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9743:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
     /* 229746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
     /* 229749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 229756 */     GIR_RootToRootCopy, /*OpIdx*/2, // value
     /* 229758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229770 */     GIR_RootConstrainSelectedInstOperands,
     /* 229771 */     // GIR_Coverage, 8388,
     /* 229771 */     GIR_EraseRootFromParent_Done,
     /* 229772 */   // Label 3760: @229772
     /* 229772 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(229829), // Rule ID 4082 //
     /* 229777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 229780 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229787 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 229800 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 229800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR),
     /* 229803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 229808 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 229810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 229815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 229820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229827 */     GIR_RootConstrainSelectedInstOperands,
     /* 229828 */     // GIR_Coverage, 4082,
     /* 229828 */     GIR_EraseRootFromParent_Done,
     /* 229829 */   // Label 3761: @229829
     /* 229829 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(229890), // Rule ID 4084 //
     /* 229834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 229837 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 229859 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 229859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR_RTN),
     /* 229862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 229869 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 229871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 229876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 229881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229888 */     GIR_RootConstrainSelectedInstOperands,
     /* 229889 */     // GIR_Coverage, 4084,
     /* 229889 */     GIR_EraseRootFromParent_Done,
     /* 229890 */   // Label 3762: @229890
     /* 229890 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(229942), // Rule ID 4081 //
     /* 229895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 229898 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229905 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 229907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 229918 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 229918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2),
     /* 229921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 229926 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 229928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 229936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229940 */     GIR_RootConstrainSelectedInstOperands,
     /* 229941 */     // GIR_Coverage, 4081,
     /* 229941 */     GIR_EraseRootFromParent_Done,
     /* 229942 */   // Label 3763: @229942
     /* 229942 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(229998), // Rule ID 4083 //
     /* 229947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 229950 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 229957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 229961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 229965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 229972 */     // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 229972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_RTN),
     /* 229975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 229977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 229982 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 229984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 229989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 229992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 229996 */     GIR_RootConstrainSelectedInstOperands,
     /* 229997 */     // GIR_Coverage, 4083,
     /* 229997 */     GIR_EraseRootFromParent_Done,
     /* 229998 */   // Label 3764: @229998
     /* 229998 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(230051), // Rule ID 3704 //
     /* 230003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 230006 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 230014 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 230016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 230020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 230027 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 230027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
     /* 230030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 230035 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 230037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 230042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230049 */     GIR_RootConstrainSelectedInstOperands,
     /* 230050 */     // GIR_Coverage, 3704,
     /* 230050 */     GIR_EraseRootFromParent_Done,
     /* 230051 */   // Label 3765: @230051
     /* 230051 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(230103), // Rule ID 3764 //
     /* 230056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 230059 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 230066 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 230068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 230072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 230079 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 230079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
     /* 230082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 230087 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 230089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 230094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230101 */     GIR_RootConstrainSelectedInstOperands,
     /* 230102 */     // GIR_Coverage, 3764,
     /* 230102 */     GIR_EraseRootFromParent_Done,
     /* 230103 */   // Label 3766: @230103
     /* 230103 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(230160), // Rule ID 3703 //
     /* 230108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 230111 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 230119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 230123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 230127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 230134 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 230134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
     /* 230137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 230144 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 230146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 230151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 230154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230158 */     GIR_RootConstrainSelectedInstOperands,
     /* 230159 */     // GIR_Coverage, 3703,
     /* 230159 */     GIR_EraseRootFromParent_Done,
     /* 230160 */   // Label 3767: @230160
     /* 230160 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(230216), // Rule ID 3763 //
     /* 230165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 230168 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 230175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 230179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 230183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 230190 */     // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 230190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
     /* 230193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 230195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 230200 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 230202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 230207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 230210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230214 */     GIR_RootConstrainSelectedInstOperands,
     /* 230215 */     // GIR_Coverage, 3763,
     /* 230215 */     GIR_EraseRootFromParent_Done,
     /* 230216 */   // Label 3768: @230216
     /* 230216 */   GIM_Reject,
     /* 230217 */ // Label 3746: @230217
     /* 230217 */ GIM_Reject,
     /* 230218 */ // Label 3722: @230218
     /* 230218 */ GIM_Reject,
     /* 230219 */ // Label 34: @230219
     /* 230219 */ GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(230237), // Rule ID 1334 //
     /* 230224 */   // MIs[0] ordering
     /* 230224 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 230227 */   // MIs[0] scope
     /* 230227 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 230230 */   // (atomic_fence (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)  =>  (ATOMIC_FENCE (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)
     /* 230230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::ATOMIC_FENCE),
     /* 230235 */   GIR_RootConstrainSelectedInstOperands,
     /* 230236 */   // GIR_Coverage, 1334,
     /* 230236 */   GIR_Done,
     /* 230237 */ // Label 3769: @230237
     /* 230237 */ GIM_Reject,
     /* 230238 */ // Label 35: @230238
     /* 230238 */ GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(230673),
     /* 230243 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_prefetch),
     /* 230247 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(230356),
     /* 230252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /* 230256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 230259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 230262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 230265 */     GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(230310), // Rule ID 3538 //
     /* 230270 */       GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 230275 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 230282 */       // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 230282 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 230285 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 230290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 230295 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 230301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230304 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230308 */       GIR_RootConstrainSelectedInstOperands,
     /* 230309 */       // GIR_Coverage, 3538,
     /* 230309 */       GIR_EraseRootFromParent_Done,
     /* 230310 */     // Label 3772: @230310
     /* 230310 */     GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(230355), // Rule ID 3541 //
     /* 230315 */       GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 230320 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 230327 */       // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 230327 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 230330 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 230335 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 230340 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 230346 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230349 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230353 */       GIR_RootConstrainSelectedInstOperands,
     /* 230354 */       // GIR_Coverage, 3541,
     /* 230354 */       GIR_EraseRootFromParent_Done,
     /* 230355 */     // Label 3773: @230355
     /* 230355 */     GIM_Reject,
     /* 230356 */   // Label 3771: @230356
     /* 230356 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(230406), // Rule ID 3539 //
     /* 230361 */     // MIs[0] sbase
     /* 230361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 230365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 230369 */     // MIs[0] Operand 1
     /* 230369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 230372 */     // MIs[0] Operand 2
     /* 230372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 230375 */     // MIs[0] Operand 3
     /* 230375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 230378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 230383 */     // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 230383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 230386 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 230388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 230397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230404 */     GIR_RootConstrainSelectedInstOperands,
     /* 230405 */     // GIR_Coverage, 3539,
     /* 230405 */     GIR_EraseRootFromParent_Done,
     /* 230406 */   // Label 3774: @230406
     /* 230406 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(230514), // Rule ID 3540 //
     /* 230411 */     // MIs[0] sbase
     /* 230411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 230415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 230419 */     // MIs[0] Operand 1
     /* 230419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 230422 */     // MIs[0] Operand 2
     /* 230422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 230425 */     // MIs[0] Operand 3
     /* 230425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 230428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
     /* 230433 */     // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 230433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 230436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 230440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230445 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 230448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 230450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 230453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 230457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
     /* 230466 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 230469 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 230472 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 230475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 230480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 230485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 230490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
     /* 230493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 230505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230512 */     GIR_RootConstrainSelectedInstOperands,
     /* 230513 */     // GIR_Coverage, 3540,
     /* 230513 */     GIR_EraseRootFromParent_Done,
     /* 230514 */   // Label 3775: @230514
     /* 230514 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(230564), // Rule ID 3542 //
     /* 230519 */     // MIs[0] sbase
     /* 230519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
     /* 230523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 230527 */     // MIs[0] Operand 1
     /* 230527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 230530 */     // MIs[0] Operand 2
     /* 230530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 230533 */     // MIs[0] Operand 3
     /* 230533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 230536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 230541 */     // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 230541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 230544 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 230546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 230555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230562 */     GIR_RootConstrainSelectedInstOperands,
     /* 230563 */     // GIR_Coverage, 3542,
     /* 230563 */     GIR_EraseRootFromParent_Done,
     /* 230564 */   // Label 3776: @230564
     /* 230564 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(230672), // Rule ID 3543 //
     /* 230569 */     // MIs[0] sbase
     /* 230569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 230573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 230577 */     // MIs[0] Operand 1
     /* 230577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 230580 */     // MIs[0] Operand 2
     /* 230580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 230583 */     // MIs[0] Operand 3
     /* 230583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 230586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
     /* 230591 */     // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
     /* 230591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 230594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 230598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230603 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 230606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 230608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 230611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 230615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230620 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
     /* 230624 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 230627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 230630 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 230633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 230638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 230643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 230648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 230651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 230663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 230666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 230670 */     GIR_RootConstrainSelectedInstOperands,
     /* 230671 */     // GIR_Coverage, 3543,
     /* 230671 */     GIR_EraseRootFromParent_Done,
     /* 230672 */   // Label 3777: @230672
     /* 230672 */   GIM_Reject,
     /* 230673 */ // Label 3770: @230673
     /* 230673 */ GIM_Reject,
     /* 230674 */ // Label 36: @230674
     /* 230674 */ GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(230755),
     /* 230679 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 230682 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(230706), // Rule ID 20 //
     /* 230687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getpc),
     /* 230692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 230695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 230699 */     // (intrinsic_wo_chain:{ *:[i64] } 3266:{ *:[iPTR] })  =>  (S_GETPC_B64_pseudo:{ *:[i64] })
     /* 230699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETPC_B64_pseudo),
     /* 230702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230704 */     GIR_RootConstrainSelectedInstOperands,
     /* 230705 */     // GIR_Coverage, 20,
     /* 230705 */     GIR_EraseRootFromParent_Done,
     /* 230706 */   // Label 3779: @230706
     /* 230706 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(230730), // Rule ID 1344 //
     /* 230711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_groupstaticsize),
     /* 230716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 230719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 230723 */     // (intrinsic_wo_chain:{ *:[i32] } 2324:{ *:[iPTR] })  =>  (GET_GROUPSTATICSIZE:{ *:[i32] })
     /* 230723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GET_GROUPSTATICSIZE),
     /* 230726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 230728 */     GIR_RootConstrainSelectedInstOperands,
     /* 230729 */     // GIR_Coverage, 1344,
     /* 230729 */     GIR_EraseRootFromParent_Done,
     /* 230730 */   // Label 3780: @230730
     /* 230730 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(230754), // Rule ID 1351 //
     /* 230735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ps_live),
     /* 230740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 230743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 230747 */     // (intrinsic_wo_chain:{ *:[i1] } 3189:{ *:[iPTR] })  =>  (SI_PS_LIVE:{ *:[i1] })
     /* 230747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_PS_LIVE),
     /* 230750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230752 */     GIR_RootConstrainSelectedInstOperands,
     /* 230753 */     // GIR_Coverage, 1351,
     /* 230753 */     GIR_EraseRootFromParent_Done,
     /* 230754 */   // Label 3781: @230754
     /* 230754 */   GIM_Reject,
     /* 230755 */ // Label 3778: @230755
     /* 230755 */ GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(234611),
     /* 230760 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 230763 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(230845), // Rule ID 2698 //
     /* 230768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 230771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 230776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 230786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21562),
     /* 230790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 230797 */     // (intrinsic_wo_chain:{ *:[f16] } 2300:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21562>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 230797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 230800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
     /* 230804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 230824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 230829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 230834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 230844 */     // GIR_Coverage, 2698,
     /* 230844 */     GIR_EraseRootFromParent_Done,
     /* 230845 */   // Label 3783: @230845
     /* 230845 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(230927), // Rule ID 2700 //
     /* 230850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 230853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 230858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 230868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21564),
     /* 230872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 230879 */     // (intrinsic_wo_chain:{ *:[f16] } 3117:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21564>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 230879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 230882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
     /* 230886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 230906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 230911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 230916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 230926 */     // GIR_Coverage, 2700,
     /* 230926 */     GIR_EraseRootFromParent_Done,
     /* 230927 */   // Label 3784: @230927
     /* 230927 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(231009), // Rule ID 2702 //
     /* 230932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 230935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 230940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 230943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 230946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 230950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21556),
     /* 230954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 230961 */     // (intrinsic_wo_chain:{ *:[f16] } 3242:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21556>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RCP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 230961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 230964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F16_e64),
     /* 230968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 230978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 230983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 230988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 230993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 230998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231008 */     // GIR_Coverage, 2702,
     /* 231008 */     GIR_EraseRootFromParent_Done,
     /* 231009 */   // Label 3785: @231009
     /* 231009 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(231091), // Rule ID 2704 //
     /* 231014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 231017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 231022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 231025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 231028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21558),
     /* 231036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231043 */     // (intrinsic_wo_chain:{ *:[f16] } 3247:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21558>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RSQ_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 231043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 231046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F16_e64),
     /* 231050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 231080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231090 */     // GIR_Coverage, 2704,
     /* 231090 */     GIR_EraseRootFromParent_Done,
     /* 231091 */   // Label 3786: @231091
     /* 231091 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(231173), // Rule ID 2707 //
     /* 231096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 231099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 231104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 231107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 231110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21560),
     /* 231118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231125 */     // (intrinsic_wo_chain:{ *:[f16] } 3336:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21560>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 231125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 231128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
     /* 231132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 231162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231172 */     // GIR_Coverage, 2707,
     /* 231172 */     GIR_EraseRootFromParent_Done,
     /* 231173 */   // Label 3787: @231173
     /* 231173 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(231206), // Rule ID 16 //
     /* 231178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
     /* 231183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 231193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13708),
     /* 231197 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13708>>  =>  (S_FLBIT_I32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 231197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32),
     /* 231200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 231202 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 231204 */     GIR_RootConstrainSelectedInstOperands,
     /* 231205 */     // GIR_Coverage, 16,
     /* 231205 */     GIR_EraseRootFromParent_Done,
     /* 231206 */   // Label 3788: @231206
     /* 231206 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(231238), // Rule ID 1335 //
     /* 231211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 231214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 231219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 231222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 231229 */     // (intrinsic_wo_chain:{ *:[i1] } 3106:{ *:[iPTR] }, i32:{ *:[i32] }:$mask)  =>  (S_INVERSE_BALLOT_U32:{ *:[i1] } i32:{ *:[i32] }:$mask)
     /* 231229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U32),
     /* 231232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 231234 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 231236 */     GIR_RootConstrainSelectedInstOperands,
     /* 231237 */     // GIR_Coverage, 1335,
     /* 231237 */     GIR_EraseRootFromParent_Done,
     /* 231238 */   // Label 3789: @231238
     /* 231238 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(231270), // Rule ID 1336 //
     /* 231243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 231246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 231251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 231254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 231257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 231261 */     // (intrinsic_wo_chain:{ *:[i1] } 3106:{ *:[iPTR] }, i64:{ *:[i64] }:$mask)  =>  (S_INVERSE_BALLOT_U64:{ *:[i1] } i64:{ *:[i64] }:$mask)
     /* 231261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U64),
     /* 231264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 231266 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 231268 */     GIR_RootConstrainSelectedInstOperands,
     /* 231269 */     // GIR_Coverage, 1336,
     /* 231269 */     GIR_EraseRootFromParent_Done,
     /* 231270 */   // Label 3790: @231270
     /* 231270 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(231331), // Rule ID 6946 //
     /* 231275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 231278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
     /* 231283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 231286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 231289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 231293 */     // (intrinsic_wo_chain:{ *:[i1] } 3106:{ *:[iPTR] }, i64:{ *:[i64] }:$src)  =>  (S_INVERSE_BALLOT_U32:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[i64] }:$src, sub0:{ *:[i32] }))
     /* 231293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 231296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 231300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231305 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 231311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 231316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 231321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U32),
     /* 231324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 231326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231329 */     GIR_RootConstrainSelectedInstOperands,
     /* 231330 */     // GIR_Coverage, 6946,
     /* 231330 */     GIR_EraseRootFromParent_Done,
     /* 231331 */   // Label 3791: @231331
     /* 231331 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(231392), // Rule ID 1076 //
     /* 231336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 231339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 231344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21551),
     /* 231358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231365 */     // (intrinsic_wo_chain:{ *:[f32] } 2300:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21551>>  =>  (V_S_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F32_e64),
     /* 231368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231390 */     GIR_RootConstrainSelectedInstOperands,
     /* 231391 */     // GIR_Coverage, 1076,
     /* 231391 */     GIR_EraseRootFromParent_Done,
     /* 231392 */   // Label 3792: @231392
     /* 231392 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(231453), // Rule ID 1078 //
     /* 231397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 231400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 231405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21554),
     /* 231419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231426 */     // (intrinsic_wo_chain:{ *:[f32] } 3117:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21554>>  =>  (V_S_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F32_e64),
     /* 231429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231451 */     GIR_RootConstrainSelectedInstOperands,
     /* 231452 */     // GIR_Coverage, 1078,
     /* 231452 */     GIR_EraseRootFromParent_Done,
     /* 231453 */   // Label 3793: @231453
     /* 231453 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(231514), // Rule ID 1080 //
     /* 231458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 231461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 231466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21556),
     /* 231480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231487 */     // (intrinsic_wo_chain:{ *:[f32] } 3242:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21556>>  =>  (V_S_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F32_e64),
     /* 231490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231512 */     GIR_RootConstrainSelectedInstOperands,
     /* 231513 */     // GIR_Coverage, 1080,
     /* 231513 */     GIR_EraseRootFromParent_Done,
     /* 231514 */   // Label 3794: @231514
     /* 231514 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(231575), // Rule ID 1082 //
     /* 231519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 231522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 231527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21558),
     /* 231541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231548 */     // (intrinsic_wo_chain:{ *:[f32] } 3247:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21558>>  =>  (V_S_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F32_e64),
     /* 231551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231573 */     GIR_RootConstrainSelectedInstOperands,
     /* 231574 */     // GIR_Coverage, 1082,
     /* 231574 */     GIR_EraseRootFromParent_Done,
     /* 231575 */   // Label 3795: @231575
     /* 231575 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(231636), // Rule ID 1085 //
     /* 231580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 231583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 231588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 231598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21560),
     /* 231602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231609 */     // (intrinsic_wo_chain:{ *:[f32] } 3336:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21560>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
     /* 231612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231634 */     GIR_RootConstrainSelectedInstOperands,
     /* 231635 */     // GIR_Coverage, 1085,
     /* 231635 */     GIR_EraseRootFromParent_Done,
     /* 231636 */   // Label 3796: @231636
     /* 231636 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(231685), // Rule ID 651 //
     /* 231641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_off_f32_i4),
     /* 231646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231663 */     // (intrinsic_wo_chain:{ *:[f32] } 2196:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_OFF_F32_I4_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_OFF_F32_I4_e64),
     /* 231666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 231678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 231683 */     GIR_RootConstrainSelectedInstOperands,
     /* 231684 */     // GIR_Coverage, 651,
     /* 231684 */     GIR_EraseRootFromParent_Done,
     /* 231685 */   // Label 3797: @231685
     /* 231685 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(231739), // Rule ID 656 //
     /* 231690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 231695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231712 */     // (intrinsic_wo_chain:{ *:[f32] } 2314:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F32_e64),
     /* 231715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231737 */     GIR_RootConstrainSelectedInstOperands,
     /* 231738 */     // GIR_Coverage, 656,
     /* 231738 */     GIR_EraseRootFromParent_Done,
     /* 231739 */   // Label 3798: @231739
     /* 231739 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(231793), // Rule ID 662 //
     /* 231744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 231749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231766 */     // (intrinsic_wo_chain:{ *:[f32] } 2300:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
     /* 231769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231791 */     GIR_RootConstrainSelectedInstOperands,
     /* 231792 */     // GIR_Coverage, 662,
     /* 231792 */     GIR_EraseRootFromParent_Done,
     /* 231793 */   // Label 3799: @231793
     /* 231793 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(231847), // Rule ID 664 //
     /* 231798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 231803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231820 */     // (intrinsic_wo_chain:{ *:[f32] } 3117:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
     /* 231823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231845 */     GIR_RootConstrainSelectedInstOperands,
     /* 231846 */     // GIR_Coverage, 664,
     /* 231846 */     GIR_EraseRootFromParent_Done,
     /* 231847 */   // Label 3800: @231847
     /* 231847 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(231901), // Rule ID 666 //
     /* 231852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 231857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231874 */     // (intrinsic_wo_chain:{ *:[f32] } 3242:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F32_e64),
     /* 231877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231899 */     GIR_RootConstrainSelectedInstOperands,
     /* 231900 */     // GIR_Coverage, 666,
     /* 231900 */     GIR_EraseRootFromParent_Done,
     /* 231901 */   // Label 3801: @231901
     /* 231901 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(231955), // Rule ID 669 //
     /* 231906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 231911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231928 */     // (intrinsic_wo_chain:{ *:[f32] } 3247:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F32_e64),
     /* 231931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 231948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 231953 */     GIR_RootConstrainSelectedInstOperands,
     /* 231954 */     // GIR_Coverage, 669,
     /* 231954 */     GIR_EraseRootFromParent_Done,
     /* 231955 */   // Label 3802: @231955
     /* 231955 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(232009), // Rule ID 671 //
     /* 231960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 231965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 231968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 231971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 231975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 231982 */     // (intrinsic_wo_chain:{ *:[f32] } 3336:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 231982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F32_e64),
     /* 231985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 231987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 231992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 231997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232007 */     GIR_RootConstrainSelectedInstOperands,
     /* 232008 */     // GIR_Coverage, 671,
     /* 232008 */     GIR_EraseRootFromParent_Done,
     /* 232009 */   // Label 3803: @232009
     /* 232009 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(232063), // Rule ID 672 //
     /* 232014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 232019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232036 */     // (intrinsic_wo_chain:{ *:[f64] } 3242:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F64_e64),
     /* 232039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232061 */     GIR_RootConstrainSelectedInstOperands,
     /* 232062 */     // GIR_Coverage, 672,
     /* 232062 */     GIR_EraseRootFromParent_Done,
     /* 232063 */   // Label 3804: @232063
     /* 232063 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(232117), // Rule ID 674 //
     /* 232068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 232073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232090 */     // (intrinsic_wo_chain:{ *:[f64] } 3247:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F64_e64),
     /* 232093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232115 */     GIR_RootConstrainSelectedInstOperands,
     /* 232116 */     // GIR_Coverage, 674,
     /* 232116 */     GIR_EraseRootFromParent_Done,
     /* 232117 */   // Label 3805: @232117
     /* 232117 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(232171), // Rule ID 676 //
     /* 232122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 232127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232144 */     // (intrinsic_wo_chain:{ *:[f64] } 3336:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F64_e64),
     /* 232147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232169 */     GIR_RootConstrainSelectedInstOperands,
     /* 232170 */     // GIR_Coverage, 676,
     /* 232170 */     GIR_EraseRootFromParent_Done,
     /* 232171 */   // Label 3806: @232171
     /* 232171 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(232225), // Rule ID 677 //
     /* 232176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 232181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232198 */     // (intrinsic_wo_chain:{ *:[f32] } 3306:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F32_e64),
     /* 232201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232223 */     GIR_RootConstrainSelectedInstOperands,
     /* 232224 */     // GIR_Coverage, 677,
     /* 232224 */     GIR_EraseRootFromParent_Done,
     /* 232225 */   // Label 3807: @232225
     /* 232225 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(232279), // Rule ID 679 //
     /* 232230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 232235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232252 */     // (intrinsic_wo_chain:{ *:[f32] } 2188:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F32_e64),
     /* 232255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232277 */     GIR_RootConstrainSelectedInstOperands,
     /* 232278 */     // GIR_Coverage, 679,
     /* 232278 */     GIR_EraseRootFromParent_Done,
     /* 232279 */   // Label 3808: @232279
     /* 232279 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(232318), // Rule ID 686 //
     /* 232284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
     /* 232289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232306 */     // (intrinsic_wo_chain:{ *:[i32] } 3305:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 232306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_I32_e64),
     /* 232309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232316 */     GIR_RootConstrainSelectedInstOperands,
     /* 232317 */     // GIR_Coverage, 686,
     /* 232317 */     GIR_EraseRootFromParent_Done,
     /* 232318 */   // Label 3809: @232318
     /* 232318 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(232372), // Rule ID 688 //
     /* 232323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 232328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232345 */     // (intrinsic_wo_chain:{ *:[i32] } 2315:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F64_e64),
     /* 232348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232370 */     GIR_RootConstrainSelectedInstOperands,
     /* 232371 */     // GIR_Coverage, 688,
     /* 232371 */     GIR_EraseRootFromParent_Done,
     /* 232372 */   // Label 3810: @232372
     /* 232372 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(232426), // Rule ID 689 //
     /* 232377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 232382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232399 */     // (intrinsic_wo_chain:{ *:[f64] } 2316:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F64_e64),
     /* 232402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232424 */     GIR_RootConstrainSelectedInstOperands,
     /* 232425 */     // GIR_Coverage, 689,
     /* 232425 */     GIR_EraseRootFromParent_Done,
     /* 232426 */   // Label 3811: @232426
     /* 232426 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(232480), // Rule ID 690 //
     /* 232431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 232436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232453 */     // (intrinsic_wo_chain:{ *:[f64] } 2314:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
     /* 232456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232478 */     GIR_RootConstrainSelectedInstOperands,
     /* 232479 */     // GIR_Coverage, 690,
     /* 232479 */     GIR_EraseRootFromParent_Done,
     /* 232480 */   // Label 3812: @232480
     /* 232480 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(232529), // Rule ID 692 //
     /* 232485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 232490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232507 */     // (intrinsic_wo_chain:{ *:[i32] } 2315:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp))  =>  (V_FREXP_EXP_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp)
     /* 232507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F32_e64),
     /* 232510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232527 */     GIR_RootConstrainSelectedInstOperands,
     /* 232528 */     // GIR_Coverage, 692,
     /* 232528 */     GIR_EraseRootFromParent_Done,
     /* 232529 */   // Label 3813: @232529
     /* 232529 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(232583), // Rule ID 693 //
     /* 232534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 232539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232556 */     // (intrinsic_wo_chain:{ *:[f32] } 2316:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F32_e64),
     /* 232559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232581 */     GIR_RootConstrainSelectedInstOperands,
     /* 232582 */     // GIR_Coverage, 693,
     /* 232582 */     GIR_EraseRootFromParent_Done,
     /* 232583 */   // Label 3814: @232583
     /* 232583 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(232640), // Rule ID 694 //
     /* 232588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 232591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log_clamp),
     /* 232596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232613 */     // (intrinsic_wo_chain:{ *:[f32] } 3118:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_CLAMP_F32_e64),
     /* 232616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232638 */     GIR_RootConstrainSelectedInstOperands,
     /* 232639 */     // GIR_Coverage, 694,
     /* 232639 */     GIR_EraseRootFromParent_Done,
     /* 232640 */   // Label 3815: @232640
     /* 232640 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(232697), // Rule ID 695 //
     /* 232645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 232648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp_legacy),
     /* 232653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232670 */     // (intrinsic_wo_chain:{ *:[f32] } 3243:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_LEGACY_F32_e64),
     /* 232673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232695 */     GIR_RootConstrainSelectedInstOperands,
     /* 232696 */     // GIR_Coverage, 695,
     /* 232696 */     GIR_EraseRootFromParent_Done,
     /* 232697 */   // Label 3816: @232697
     /* 232697 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(232754), // Rule ID 697 //
     /* 232702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 232705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
     /* 232710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232727 */     // (intrinsic_wo_chain:{ *:[f32] } 3248:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F32_e64),
     /* 232730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232752 */     GIR_RootConstrainSelectedInstOperands,
     /* 232753 */     // GIR_Coverage, 697,
     /* 232753 */     GIR_EraseRootFromParent_Done,
     /* 232754 */   // Label 3817: @232754
     /* 232754 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(232811), // Rule ID 699 //
     /* 232759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 232762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_legacy),
     /* 232767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 232770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 232773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232784 */     // (intrinsic_wo_chain:{ *:[f32] } 3249:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_LEGACY_F32_e64),
     /* 232787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232809 */     GIR_RootConstrainSelectedInstOperands,
     /* 232810 */     // GIR_Coverage, 699,
     /* 232810 */     GIR_EraseRootFromParent_Done,
     /* 232811 */   // Label 3818: @232811
     /* 232811 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(232868), // Rule ID 700 //
     /* 232816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 232819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
     /* 232824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 232827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 232830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 232834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232841 */     // (intrinsic_wo_chain:{ *:[f64] } 3248:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F64_e64),
     /* 232844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232866 */     GIR_RootConstrainSelectedInstOperands,
     /* 232867 */     // GIR_Coverage, 700,
     /* 232867 */     GIR_EraseRootFromParent_Done,
     /* 232868 */   // Label 3819: @232868
     /* 232868 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(232925), // Rule ID 718 //
     /* 232873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 232876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 232881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 232884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 232887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232898 */     // (intrinsic_wo_chain:{ *:[f16] } 3242:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_e64),
     /* 232901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232923 */     GIR_RootConstrainSelectedInstOperands,
     /* 232924 */     // GIR_Coverage, 718,
     /* 232924 */     GIR_EraseRootFromParent_Done,
     /* 232925 */   // Label 3820: @232925
     /* 232925 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(232982), // Rule ID 722 //
     /* 232930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 232933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 232938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 232941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 232944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 232948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 232955 */     // (intrinsic_wo_chain:{ *:[f16] } 3242:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 232955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_fake16_e64),
     /* 232958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 232960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 232965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 232970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 232975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 232980 */     GIR_RootConstrainSelectedInstOperands,
     /* 232981 */     // GIR_Coverage, 722,
     /* 232981 */     GIR_EraseRootFromParent_Done,
     /* 232982 */   // Label 3821: @232982
     /* 232982 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(233039), // Rule ID 725 //
     /* 232987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 232990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 232995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 232998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233012 */     // (intrinsic_wo_chain:{ *:[f16] } 3336:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
     /* 233015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233037 */     GIR_RootConstrainSelectedInstOperands,
     /* 233038 */     // GIR_Coverage, 725,
     /* 233038 */     GIR_EraseRootFromParent_Done,
     /* 233039 */   // Label 3822: @233039
     /* 233039 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(233096), // Rule ID 729 //
     /* 233044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 233052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233069 */     // (intrinsic_wo_chain:{ *:[f16] } 3336:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
     /* 233072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233094 */     GIR_RootConstrainSelectedInstOperands,
     /* 233095 */     // GIR_Coverage, 729,
     /* 233095 */     GIR_EraseRootFromParent_Done,
     /* 233096 */   // Label 3823: @233096
     /* 233096 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(233153), // Rule ID 730 //
     /* 233101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 233109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233126 */     // (intrinsic_wo_chain:{ *:[f16] } 3247:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_e64),
     /* 233129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233151 */     GIR_RootConstrainSelectedInstOperands,
     /* 233152 */     // GIR_Coverage, 730,
     /* 233152 */     GIR_EraseRootFromParent_Done,
     /* 233153 */   // Label 3824: @233153
     /* 233153 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(233210), // Rule ID 734 //
     /* 233158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 233166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233183 */     // (intrinsic_wo_chain:{ *:[f16] } 3247:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_fake16_e64),
     /* 233186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233208 */     GIR_RootConstrainSelectedInstOperands,
     /* 233209 */     // GIR_Coverage, 734,
     /* 233209 */     GIR_EraseRootFromParent_Done,
     /* 233210 */   // Label 3825: @233210
     /* 233210 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(233267), // Rule ID 736 //
     /* 233215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 233223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233240 */     // (intrinsic_wo_chain:{ *:[f16] } 3117:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
     /* 233243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233265 */     GIR_RootConstrainSelectedInstOperands,
     /* 233266 */     // GIR_Coverage, 736,
     /* 233266 */     GIR_EraseRootFromParent_Done,
     /* 233267 */   // Label 3826: @233267
     /* 233267 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(233324), // Rule ID 740 //
     /* 233272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 233280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233297 */     // (intrinsic_wo_chain:{ *:[f16] } 3117:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
     /* 233300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233322 */     GIR_RootConstrainSelectedInstOperands,
     /* 233323 */     // GIR_Coverage, 740,
     /* 233323 */     GIR_EraseRootFromParent_Done,
     /* 233324 */   // Label 3827: @233324
     /* 233324 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(233381), // Rule ID 742 //
     /* 233329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 233337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233354 */     // (intrinsic_wo_chain:{ *:[f16] } 2300:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
     /* 233357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233379 */     GIR_RootConstrainSelectedInstOperands,
     /* 233380 */     // GIR_Coverage, 742,
     /* 233380 */     GIR_EraseRootFromParent_Done,
     /* 233381 */   // Label 3828: @233381
     /* 233381 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(233438), // Rule ID 746 //
     /* 233386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 233394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233411 */     // (intrinsic_wo_chain:{ *:[f16] } 2300:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
     /* 233414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233436 */     GIR_RootConstrainSelectedInstOperands,
     /* 233437 */     // GIR_Coverage, 746,
     /* 233437 */     GIR_EraseRootFromParent_Done,
     /* 233438 */   // Label 3829: @233438
     /* 233438 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(233495), // Rule ID 748 //
     /* 233443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 233451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233468 */     // (intrinsic_wo_chain:{ *:[f16] } 3306:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_e64),
     /* 233471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233493 */     GIR_RootConstrainSelectedInstOperands,
     /* 233494 */     // GIR_Coverage, 748,
     /* 233494 */     GIR_EraseRootFromParent_Done,
     /* 233495 */   // Label 3830: @233495
     /* 233495 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(233552), // Rule ID 752 //
     /* 233500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 233508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233525 */     // (intrinsic_wo_chain:{ *:[f16] } 3306:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_fake16_e64),
     /* 233528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233550 */     GIR_RootConstrainSelectedInstOperands,
     /* 233551 */     // GIR_Coverage, 752,
     /* 233551 */     GIR_EraseRootFromParent_Done,
     /* 233552 */   // Label 3831: @233552
     /* 233552 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(233609), // Rule ID 754 //
     /* 233557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 233565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233582 */     // (intrinsic_wo_chain:{ *:[f16] } 2188:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_e64),
     /* 233585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233607 */     GIR_RootConstrainSelectedInstOperands,
     /* 233608 */     // GIR_Coverage, 754,
     /* 233608 */     GIR_EraseRootFromParent_Done,
     /* 233609 */   // Label 3832: @233609
     /* 233609 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(233666), // Rule ID 758 //
     /* 233614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 233622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233639 */     // (intrinsic_wo_chain:{ *:[f16] } 2188:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_fake16_e64),
     /* 233642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233664 */     GIR_RootConstrainSelectedInstOperands,
     /* 233665 */     // GIR_Coverage, 758,
     /* 233665 */     GIR_EraseRootFromParent_Done,
     /* 233666 */   // Label 3833: @233666
     /* 233666 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(233723), // Rule ID 760 //
     /* 233671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 233679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233696 */     // (intrinsic_wo_chain:{ *:[f16] } 2316:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_e64),
     /* 233699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233721 */     GIR_RootConstrainSelectedInstOperands,
     /* 233722 */     // GIR_Coverage, 760,
     /* 233722 */     GIR_EraseRootFromParent_Done,
     /* 233723 */   // Label 3834: @233723
     /* 233723 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(233780), // Rule ID 762 //
     /* 233728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 233736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233753 */     // (intrinsic_wo_chain:{ *:[f16] } 2316:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_fake16_e64),
     /* 233756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233778 */     GIR_RootConstrainSelectedInstOperands,
     /* 233779 */     // GIR_Coverage, 762,
     /* 233779 */     GIR_EraseRootFromParent_Done,
     /* 233780 */   // Label 3835: @233780
     /* 233780 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(233837), // Rule ID 763 //
     /* 233785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 233793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233810 */     // (intrinsic_wo_chain:{ *:[i16] } 2315:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_e64),
     /* 233813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233835 */     GIR_RootConstrainSelectedInstOperands,
     /* 233836 */     // GIR_Coverage, 763,
     /* 233836 */     GIR_EraseRootFromParent_Done,
     /* 233837 */   // Label 3836: @233837
     /* 233837 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(233894), // Rule ID 765 //
     /* 233842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 233850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233867 */     // (intrinsic_wo_chain:{ *:[i16] } 2315:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_fake16_e64),
     /* 233870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233892 */     GIR_RootConstrainSelectedInstOperands,
     /* 233893 */     // GIR_Coverage, 765,
     /* 233893 */     GIR_EraseRootFromParent_Done,
     /* 233894 */   // Label 3837: @233894
     /* 233894 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(233951), // Rule ID 778 //
     /* 233899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 233902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 233907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233924 */     // (intrinsic_wo_chain:{ *:[f16] } 2314:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_e64),
     /* 233927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 233944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 233949 */     GIR_RootConstrainSelectedInstOperands,
     /* 233950 */     // GIR_Coverage, 778,
     /* 233950 */     GIR_EraseRootFromParent_Done,
     /* 233951 */   // Label 3838: @233951
     /* 233951 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(234008), // Rule ID 782 //
     /* 233956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 233959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 233964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 233967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 233970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 233974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 233981 */     // (intrinsic_wo_chain:{ *:[f16] } 2314:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 233981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_fake16_e64),
     /* 233984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 233986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 233991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 233996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 234001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 234006 */     GIR_RootConstrainSelectedInstOperands,
     /* 234007 */     // GIR_Coverage, 782,
     /* 234007 */     GIR_EraseRootFromParent_Done,
     /* 234008 */   // Label 3839: @234008
     /* 234008 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(234050), // Rule ID 784 //
     /* 234013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrngInst),
     /* 234016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_prng_b32),
     /* 234021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 234038 */     // (intrinsic_wo_chain:{ *:[i32] } 3188:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_PRNG_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 234038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PRNG_B32_e64),
     /* 234041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234048 */     GIR_RootConstrainSelectedInstOperands,
     /* 234049 */     // GIR_Coverage, 784,
     /* 234049 */     GIR_EraseRootFromParent_Done,
     /* 234050 */   // Label 3840: @234050
     /* 234050 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(234106), // Rule ID 720 //
     /* 234055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
     /* 234063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234080 */     // (intrinsic_wo_chain:{ *:[f16] } 3242:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RCP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_t16_e64),
     /* 234083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234104 */     GIR_RootConstrainSelectedInstOperands,
     /* 234105 */     // GIR_Coverage, 720,
     /* 234105 */     GIR_EraseRootFromParent_Done,
     /* 234106 */   // Label 3841: @234106
     /* 234106 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(234162), // Rule ID 727 //
     /* 234111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
     /* 234119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234136 */     // (intrinsic_wo_chain:{ *:[f16] } 3336:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
     /* 234139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234160 */     GIR_RootConstrainSelectedInstOperands,
     /* 234161 */     // GIR_Coverage, 727,
     /* 234161 */     GIR_EraseRootFromParent_Done,
     /* 234162 */   // Label 3842: @234162
     /* 234162 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(234218), // Rule ID 732 //
     /* 234167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
     /* 234175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234192 */     // (intrinsic_wo_chain:{ *:[f16] } 3247:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RSQ_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_t16_e64),
     /* 234195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234216 */     GIR_RootConstrainSelectedInstOperands,
     /* 234217 */     // GIR_Coverage, 732,
     /* 234217 */     GIR_EraseRootFromParent_Done,
     /* 234218 */   // Label 3843: @234218
     /* 234218 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(234274), // Rule ID 738 //
     /* 234223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
     /* 234231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234248 */     // (intrinsic_wo_chain:{ *:[f16] } 3117:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
     /* 234251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234272 */     GIR_RootConstrainSelectedInstOperands,
     /* 234273 */     // GIR_Coverage, 738,
     /* 234273 */     GIR_EraseRootFromParent_Done,
     /* 234274 */   // Label 3844: @234274
     /* 234274 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(234330), // Rule ID 744 //
     /* 234279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
     /* 234287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234304 */     // (intrinsic_wo_chain:{ *:[f16] } 2300:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
     /* 234307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234328 */     GIR_RootConstrainSelectedInstOperands,
     /* 234329 */     // GIR_Coverage, 744,
     /* 234329 */     GIR_EraseRootFromParent_Done,
     /* 234330 */   // Label 3845: @234330
     /* 234330 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(234386), // Rule ID 750 //
     /* 234335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
     /* 234343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234360 */     // (intrinsic_wo_chain:{ *:[f16] } 3306:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_t16_e64),
     /* 234363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234384 */     GIR_RootConstrainSelectedInstOperands,
     /* 234385 */     // GIR_Coverage, 750,
     /* 234385 */     GIR_EraseRootFromParent_Done,
     /* 234386 */   // Label 3846: @234386
     /* 234386 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(234442), // Rule ID 756 //
     /* 234391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
     /* 234399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234416 */     // (intrinsic_wo_chain:{ *:[f16] } 2188:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_COS_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_t16_e64),
     /* 234419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234440 */     GIR_RootConstrainSelectedInstOperands,
     /* 234441 */     // GIR_Coverage, 756,
     /* 234441 */     GIR_EraseRootFromParent_Done,
     /* 234442 */   // Label 3847: @234442
     /* 234442 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(234498), // Rule ID 761 //
     /* 234447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
     /* 234455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234472 */     // (intrinsic_wo_chain:{ *:[f16] } 2316:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_MANT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_t16_e64),
     /* 234475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234496 */     GIR_RootConstrainSelectedInstOperands,
     /* 234497 */     // GIR_Coverage, 761,
     /* 234497 */     GIR_EraseRootFromParent_Done,
     /* 234498 */   // Label 3848: @234498
     /* 234498 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(234554), // Rule ID 764 //
     /* 234503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
     /* 234511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234528 */     // (intrinsic_wo_chain:{ *:[i16] } 2315:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_EXP_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_t16_e64),
     /* 234531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234552 */     GIR_RootConstrainSelectedInstOperands,
     /* 234553 */     // GIR_Coverage, 764,
     /* 234553 */     GIR_EraseRootFromParent_Done,
     /* 234554 */   // Label 3849: @234554
     /* 234554 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(234610), // Rule ID 780 //
     /* 234559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
     /* 234567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 234570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 234584 */     // (intrinsic_wo_chain:{ *:[f16] } 2314:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FRACT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 234584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_t16_e64),
     /* 234587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234608 */     GIR_RootConstrainSelectedInstOperands,
     /* 234609 */     // GIR_Coverage, 780,
     /* 234609 */     GIR_EraseRootFromParent_Done,
     /* 234610 */   // Label 3850: @234610
     /* 234610 */   GIM_Reject,
     /* 234611 */ // Label 3782: @234611
     /* 234611 */ GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(237149),
     /* 234616 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 234619 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(234668), // Rule ID 1893 //
     /* 234624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 234629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 234632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 234642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 234649 */     // (intrinsic_wo_chain:{ *:[i1] } 2187:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 234649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
     /* 234652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 234654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234664 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234666 */     GIR_RootConstrainSelectedInstOperands,
     /* 234667 */     // GIR_Coverage, 1893,
     /* 234667 */     GIR_EraseRootFromParent_Done,
     /* 234668 */   // Label 3852: @234668
     /* 234668 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(234755), // Rule ID 1895 //
     /* 234673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 234676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 234681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 234684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 234694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 234701 */     // (intrinsic_wo_chain:{ *:[i1] } 2187:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, VSrcT_f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[i32] }:$src1, lo16:{ *:[i32] }), 0:{ *:[i32] })
     /* 234701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 234704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 234708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(2), // src1
     /* 234719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 234724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_t16_e64),
     /* 234732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 234734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234753 */     GIR_RootConstrainSelectedInstOperands,
     /* 234754 */     // GIR_Coverage, 1895,
     /* 234754 */     GIR_EraseRootFromParent_Done,
     /* 234755 */   // Label 3853: @234755
     /* 234755 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(234810), // Rule ID 1897 //
     /* 234760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 234763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 234768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 234771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 234781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 234788 */     // (intrinsic_wo_chain:{ *:[i1] } 2187:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src1)
     /* 234788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
     /* 234791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 234793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234806 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234808 */     GIR_RootConstrainSelectedInstOperands,
     /* 234809 */     // GIR_Coverage, 1897,
     /* 234809 */     GIR_EraseRootFromParent_Done,
     /* 234810 */   // Label 3854: @234810
     /* 234810 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(234859), // Rule ID 1899 //
     /* 234815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 234820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 234823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 234826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 234833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 234840 */     // (intrinsic_wo_chain:{ *:[i1] } 2187:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 234840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 234843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 234845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234855 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234857 */     GIR_RootConstrainSelectedInstOperands,
     /* 234858 */     // GIR_Coverage, 1899,
     /* 234858 */     GIR_EraseRootFromParent_Done,
     /* 234859 */   // Label 3855: @234859
     /* 234859 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(234911), // Rule ID 1901 //
     /* 234864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 234867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
     /* 234872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 234875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 234878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 234885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 234892 */     // (intrinsic_wo_chain:{ *:[i1] } 2187:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1)
     /* 234892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
     /* 234895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 234897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 234902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 234907 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 234909 */     GIR_RootConstrainSelectedInstOperands,
     /* 234910 */     // GIR_Coverage, 1901,
     /* 234910 */     GIR_EraseRootFromParent_Done,
     /* 234911 */   // Label 3856: @234911
     /* 234911 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(234966), // Rule ID 2397 //
     /* 234916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
     /* 234919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 234924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234934 */     // MIs[0] Operand 3
     /* 234934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 234945 */     // (intrinsic_wo_chain:{ *:[f32] } 2195:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 234945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 234948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 234950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 234955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234964 */     GIR_RootConstrainSelectedInstOperands,
     /* 234965 */     // GIR_Coverage, 2397,
     /* 234965 */     GIR_EraseRootFromParent_Done,
     /* 234966 */   // Label 3857: @234966
     /* 234966 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(235021), // Rule ID 2398 //
     /* 234971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
     /* 234974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 234979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 234989 */     // MIs[0] Operand 3
     /* 234989 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 235000 */     // (intrinsic_wo_chain:{ *:[f32] } 2194:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 235000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 235003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235019 */     GIR_RootConstrainSelectedInstOperands,
     /* 235020 */     // GIR_Coverage, 2398,
     /* 235020 */     GIR_EraseRootFromParent_Done,
     /* 235021 */   // Label 3858: @235021
     /* 235021 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(235064), // Rule ID 2399 //
     /* 235026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
     /* 235029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 235034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235044 */     // MIs[0] Operand 3
     /* 235044 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 235055 */     // (intrinsic_wo_chain:{ *:[f32] } 2195:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
     /* 235055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_e32),
     /* 235058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235062 */     GIR_RootConstrainSelectedInstOperands,
     /* 235063 */     // GIR_Coverage, 2399,
     /* 235063 */     GIR_EraseRootFromParent_Done,
     /* 235064 */   // Label 3859: @235064
     /* 235064 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(235107), // Rule ID 2400 //
     /* 235069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
     /* 235072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 235077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235087 */     // MIs[0] Operand 3
     /* 235087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 235098 */     // (intrinsic_wo_chain:{ *:[f32] } 2194:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
     /* 235098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_e32),
     /* 235101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235105 */     GIR_RootConstrainSelectedInstOperands,
     /* 235106 */     // GIR_Coverage, 2400,
     /* 235106 */     GIR_EraseRootFromParent_Done,
     /* 235107 */   // Label 3860: @235107
     /* 235107 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(235162), // Rule ID 2401 //
     /* 235112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 235120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235130 */     // MIs[0] Operand 3
     /* 235130 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 235141 */     // (intrinsic_wo_chain:{ *:[f32] } 2195:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 235141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 235144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235149 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 235160 */     GIR_RootConstrainSelectedInstOperands,
     /* 235161 */     // GIR_Coverage, 2401,
     /* 235161 */     GIR_EraseRootFromParent_Done,
     /* 235162 */   // Label 3861: @235162
     /* 235162 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(235217), // Rule ID 2402 //
     /* 235167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 235175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235185 */     // MIs[0] Operand 3
     /* 235185 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 235196 */     // (intrinsic_wo_chain:{ *:[f32] } 2194:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 235196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 235199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 235215 */     GIR_RootConstrainSelectedInstOperands,
     /* 235216 */     // GIR_Coverage, 2402,
     /* 235216 */     GIR_EraseRootFromParent_Done,
     /* 235217 */   // Label 3862: @235217
     /* 235217 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(235272), // Rule ID 2403 //
     /* 235222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 235230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235240 */     // MIs[0] Operand 3
     /* 235240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 235251 */     // (intrinsic_wo_chain:{ *:[f32] } 2195:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
     /* 235251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 235254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 235270 */     GIR_RootConstrainSelectedInstOperands,
     /* 235271 */     // GIR_Coverage, 2403,
     /* 235271 */     GIR_EraseRootFromParent_Done,
     /* 235272 */   // Label 3863: @235272
     /* 235272 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(235327), // Rule ID 2404 //
     /* 235277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 235285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235295 */     // MIs[0] Operand 3
     /* 235295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 235306 */     // (intrinsic_wo_chain:{ *:[f32] } 2194:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
     /* 235306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 235309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 235325 */     GIR_RootConstrainSelectedInstOperands,
     /* 235326 */     // GIR_Coverage, 2404,
     /* 235326 */     GIR_EraseRootFromParent_Done,
     /* 235327 */   // Label 3864: @235327
     /* 235327 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(235382), // Rule ID 2405 //
     /* 235332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 235340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235350 */     // MIs[0] Operand 3
     /* 235350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 235361 */     // (intrinsic_wo_chain:{ *:[f32] } 2195:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /* 235361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
     /* 235364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 235380 */     GIR_RootConstrainSelectedInstOperands,
     /* 235381 */     // GIR_Coverage, 2405,
     /* 235381 */     GIR_EraseRootFromParent_Done,
     /* 235382 */   // Label 3865: @235382
     /* 235382 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(235437), // Rule ID 2406 //
     /* 235387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 235395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235405 */     // MIs[0] Operand 3
     /* 235405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 235416 */     // (intrinsic_wo_chain:{ *:[f32] } 2194:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /* 235416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
     /* 235419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 235435 */     GIR_RootConstrainSelectedInstOperands,
     /* 235436 */     // GIR_Coverage, 2406,
     /* 235436 */     GIR_EraseRootFromParent_Done,
     /* 235437 */   // Label 3866: @235437
     /* 235437 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(235480), // Rule ID 2407 //
     /* 235442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 235450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235460 */     // MIs[0] Operand 3
     /* 235460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 235471 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2199:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 235471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_e32),
     /* 235474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235478 */     GIR_RootConstrainSelectedInstOperands,
     /* 235479 */     // GIR_Coverage, 2407,
     /* 235479 */     GIR_EraseRootFromParent_Done,
     /* 235480 */   // Label 3867: @235480
     /* 235480 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(235523), // Rule ID 2408 //
     /* 235485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 235493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235503 */     // MIs[0] Operand 3
     /* 235503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 235514 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2198:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 235514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_e32),
     /* 235517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235519 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235521 */     GIR_RootConstrainSelectedInstOperands,
     /* 235522 */     // GIR_Coverage, 2408,
     /* 235522 */     GIR_EraseRootFromParent_Done,
     /* 235523 */   // Label 3868: @235523
     /* 235523 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(235578), // Rule ID 2409 //
     /* 235528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 235536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235546 */     // MIs[0] Operand 3
     /* 235546 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 235557 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2199:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
     /* 235557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_sdwa),
     /* 235560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235565 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 235576 */     GIR_RootConstrainSelectedInstOperands,
     /* 235577 */     // GIR_Coverage, 2409,
     /* 235577 */     GIR_EraseRootFromParent_Done,
     /* 235578 */   // Label 3869: @235578
     /* 235578 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(235633), // Rule ID 2410 //
     /* 235583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
     /* 235586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 235591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235601 */     // MIs[0] Operand 3
     /* 235601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 235612 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2198:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
     /* 235612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_sdwa),
     /* 235615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 235631 */     GIR_RootConstrainSelectedInstOperands,
     /* 235632 */     // GIR_Coverage, 2410,
     /* 235632 */     GIR_EraseRootFromParent_Done,
     /* 235633 */   // Label 3870: @235633
     /* 235633 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(235676), // Rule ID 2413 //
     /* 235638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 235641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 235646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235656 */     // MIs[0] Operand 3
     /* 235656 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 235667 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2199:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 235667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e32),
     /* 235670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235674 */     GIR_RootConstrainSelectedInstOperands,
     /* 235675 */     // GIR_Coverage, 2413,
     /* 235675 */     GIR_EraseRootFromParent_Done,
     /* 235676 */   // Label 3871: @235676
     /* 235676 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(235719), // Rule ID 2414 //
     /* 235681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 235684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 235689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235699 */     // MIs[0] Operand 3
     /* 235699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 235710 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2198:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
     /* 235710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e32),
     /* 235713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235717 */     GIR_RootConstrainSelectedInstOperands,
     /* 235718 */     // GIR_Coverage, 2414,
     /* 235718 */     GIR_EraseRootFromParent_Done,
     /* 235719 */   // Label 3872: @235719
     /* 235719 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(235768), // Rule ID 2415 //
     /* 235724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 235727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
     /* 235732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235742 */     // MIs[0] Operand 3
     /* 235742 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 235753 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2199:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
     /* 235753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e64),
     /* 235756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 235761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235766 */     GIR_RootConstrainSelectedInstOperands,
     /* 235767 */     // GIR_Coverage, 2415,
     /* 235767 */     GIR_EraseRootFromParent_Done,
     /* 235768 */   // Label 3873: @235768
     /* 235768 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(235817), // Rule ID 2416 //
     /* 235773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 235776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
     /* 235781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 235784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235791 */     // MIs[0] Operand 3
     /* 235791 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
     /* 235802 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2198:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
     /* 235802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e64),
     /* 235805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 235810 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 235812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 235815 */     GIR_RootConstrainSelectedInstOperands,
     /* 235816 */     // GIR_Coverage, 2416,
     /* 235816 */     GIR_EraseRootFromParent_Done,
     /* 235817 */   // Label 3874: @235817
     /* 235817 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(235858), // Rule ID 2411 //
     /* 235822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 235825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
     /* 235830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235840 */     // MIs[0] byte_sel
     /* 235840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 235843 */     // (intrinsic_wo_chain:{ *:[f32] } 2195:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_FP8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 235843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_OP_SEL_e64),
     /* 235846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 235850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 235856 */     GIR_RootConstrainSelectedInstOperands,
     /* 235857 */     // GIR_Coverage, 2411,
     /* 235857 */     GIR_EraseRootFromParent_Done,
     /* 235858 */   // Label 3875: @235858
     /* 235858 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(235899), // Rule ID 2412 //
     /* 235863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 235866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
     /* 235871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 235874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 235881 */     // MIs[0] byte_sel
     /* 235881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 235884 */     // (intrinsic_wo_chain:{ *:[f32] } 2194:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_BF8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 235884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_OP_SEL_e64),
     /* 235887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 235889 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 235891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 235897 */     GIR_RootConstrainSelectedInstOperands,
     /* 235898 */     // GIR_Coverage, 2412,
     /* 235898 */     GIR_EraseRootFromParent_Done,
     /* 235899 */   // Label 3876: @235899
     /* 235899 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(235948), // Rule ID 108 //
     /* 235904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 235907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
     /* 235912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 235915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 235925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 235929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 235933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13748),
     /* 235937 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2206:{ *:[iPTR] }, SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13748>>  =>  (S_CVT_PK_RTZ_F16_F32:{ *:[v2f16] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 235937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_PK_RTZ_F16_F32),
     /* 235940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 235942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 235944 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 235946 */     GIR_RootConstrainSelectedInstOperands,
     /* 235947 */     // GIR_Coverage, 108,
     /* 235947 */     GIR_EraseRootFromParent_Done,
     /* 235948 */   // Label 3877: @235948
     /* 235948 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(236051), // Rule ID 2502 //
     /* 235953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /* 235958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 235961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 235964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 235967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 235971 */     // (intrinsic_wo_chain:{ *:[i64] } 3175:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
     /* 235971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 235974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
     /* 235978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 235983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 235987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 235991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 235993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 235996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
     /* 236000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 236009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 236013 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 236016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 236018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 236021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 236026 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 236029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 236032 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 236035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 236040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236050 */     // GIR_Coverage, 2502,
     /* 236050 */     GIR_EraseRootFromParent_Done,
     /* 236051 */   // Label 3878: @236051
     /* 236051 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(236154), // Rule ID 2504 //
     /* 236056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /* 236061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 236064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 236074 */     // (intrinsic_wo_chain:{ *:[i64] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
     /* 236074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 236077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
     /* 236081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 236090 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 236094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 236096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 236099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
     /* 236103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 236108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
     /* 236112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
     /* 236116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 236119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 236121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 236124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 236129 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 236132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 236135 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 236138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 236143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236153 */     // GIR_Coverage, 2504,
     /* 236153 */     GIR_EraseRootFromParent_Done,
     /* 236154 */   // Label 3879: @236154
     /* 236154 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(236228), // Rule ID 789 //
     /* 236159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 236164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 236167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236191 */     // (intrinsic_wo_chain:{ *:[f32] } 2313:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 236191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 236194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 236226 */     GIR_RootConstrainSelectedInstOperands,
     /* 236227 */     // GIR_Coverage, 789,
     /* 236227 */     GIR_EraseRootFromParent_Done,
     /* 236228 */   // Label 3880: @236228
     /* 236228 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(236297), // Rule ID 823 //
     /* 236233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_i16),
     /* 236238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 236241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236265 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2204:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_I16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 236265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_I16_F32_e64),
     /* 236268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236295 */     GIR_RootConstrainSelectedInstOperands,
     /* 236296 */     // GIR_Coverage, 823,
     /* 236296 */     GIR_EraseRootFromParent_Done,
     /* 236297 */   // Label 3881: @236297
     /* 236297 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(236366), // Rule ID 825 //
     /* 236302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_u16),
     /* 236307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 236310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236334 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2205:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_U16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 236334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_U16_F32_e64),
     /* 236337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236364 */     GIR_RootConstrainSelectedInstOperands,
     /* 236365 */     // GIR_Coverage, 825,
     /* 236365 */     GIR_EraseRootFromParent_Done,
     /* 236366 */   // Label 3882: @236366
     /* 236366 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(236440), // Rule ID 827 //
     /* 236371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
     /* 236376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 236379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236403 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2206:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKRTZ_F16_F32_e64:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 236403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKRTZ_F16_F32_e64),
     /* 236406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 236438 */     GIR_RootConstrainSelectedInstOperands,
     /* 236439 */     // GIR_Coverage, 827,
     /* 236439 */     GIR_EraseRootFromParent_Done,
     /* 236440 */   // Label 3883: @236440
     /* 236440 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(236514), // Rule ID 983 //
     /* 236445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_trig_preop),
     /* 236450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 236453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 236456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 236463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236477 */     // (intrinsic_wo_chain:{ *:[f64] } 3402:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_TRIG_PREOP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 236477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRIG_PREOP_F64_e64),
     /* 236480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 236487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 236497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 236502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 236507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 236512 */     GIR_RootConstrainSelectedInstOperands,
     /* 236513 */     // GIR_Coverage, 983,
     /* 236513 */     GIR_EraseRootFromParent_Done,
     /* 236514 */   // Label 3884: @236514
     /* 236514 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(236588), // Rule ID 8551 //
     /* 236519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 236524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 236527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 236544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236551 */     // (intrinsic_wo_chain:{ *:[f32] } 2313:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 236551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 236554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 236561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 236566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 236571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 236576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 236581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 236586 */     GIR_RootConstrainSelectedInstOperands,
     /* 236587 */     // GIR_Coverage, 8551,
     /* 236587 */     GIR_EraseRootFromParent_Done,
     /* 236588 */   // Label 3885: @236588
     /* 236588 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(236635), // Rule ID 1055 //
     /* 236593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 236596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_fp6),
     /* 236601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 236604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 236607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 236614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236621 */     // (intrinsic_wo_chain:{ *:[v32f32] } 2238:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_FP6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 236621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_FP6_e64),
     /* 236624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236631 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236633 */     GIR_RootConstrainSelectedInstOperands,
     /* 236634 */     // GIR_Coverage, 1055,
     /* 236634 */     GIR_EraseRootFromParent_Done,
     /* 236635 */   // Label 3886: @236635
     /* 236635 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(236682), // Rule ID 1056 //
     /* 236640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 236643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_bf6),
     /* 236648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 236651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 236654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 236661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236668 */     // (intrinsic_wo_chain:{ *:[v32f32] } 2237:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_BF6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 236668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_BF6_e64),
     /* 236671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236678 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236680 */     GIR_RootConstrainSelectedInstOperands,
     /* 236681 */     // GIR_Coverage, 1056,
     /* 236681 */     GIR_EraseRootFromParent_Done,
     /* 236682 */   // Label 3887: @236682
     /* 236682 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(236729), // Rule ID 1057 //
     /* 236687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 236690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_fp6),
     /* 236695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 236698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 236701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 236708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236715 */     // (intrinsic_wo_chain:{ *:[v32f16] } 2236:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_FP6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 236715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_FP6_e64),
     /* 236718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236725 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236727 */     GIR_RootConstrainSelectedInstOperands,
     /* 236728 */     // GIR_Coverage, 1057,
     /* 236728 */     GIR_EraseRootFromParent_Done,
     /* 236729 */   // Label 3888: @236729
     /* 236729 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(236776), // Rule ID 1058 //
     /* 236734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
     /* 236737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_bf6),
     /* 236742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 236745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 236748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 236755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236762 */     // (intrinsic_wo_chain:{ *:[v32f16] } 2235:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_BF6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
     /* 236762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_BF6_e64),
     /* 236765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236772 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236774 */     GIR_RootConstrainSelectedInstOperands,
     /* 236775 */     // GIR_Coverage, 1058,
     /* 236775 */     GIR_EraseRootFromParent_Done,
     /* 236776 */   // Label 3889: @236776
     /* 236776 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(236823), // Rule ID 1059 //
     /* 236781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 236784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_fp6_f16),
     /* 236789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 236792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 236795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 236802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236809 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2240:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
     /* 236809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_FP6_F16_e64),
     /* 236812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236819 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236821 */     GIR_RootConstrainSelectedInstOperands,
     /* 236822 */     // GIR_Coverage, 1059,
     /* 236822 */     GIR_EraseRootFromParent_Done,
     /* 236823 */   // Label 3890: @236823
     /* 236823 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(236870), // Rule ID 1060 //
     /* 236828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 236831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_bf6_f16),
     /* 236836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 236839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 236842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 236849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 236856 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2234:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
     /* 236856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_BF6_F16_e64),
     /* 236859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 236866 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236868 */     GIR_RootConstrainSelectedInstOperands,
     /* 236869 */     // GIR_Coverage, 1060,
     /* 236869 */     GIR_EraseRootFromParent_Done,
     /* 236870 */   // Label 3891: @236870
     /* 236870 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(236907), // Rule ID 793 //
     /* 236875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
     /* 236880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 236883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236893 */     // (intrinsic_wo_chain:{ *:[i32] } 3175:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 236893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
     /* 236896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 236900 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236905 */     GIR_RootConstrainSelectedInstOperands,
     /* 236906 */     // GIR_Coverage, 793,
     /* 236906 */     GIR_EraseRootFromParent_Done,
     /* 236907 */   // Label 3892: @236907
     /* 236907 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(236941), // Rule ID 795 //
     /* 236912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_i24),
     /* 236917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 236920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236930 */     // (intrinsic_wo_chain:{ *:[i32] } 3177:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 236930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
     /* 236933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 236937 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236939 */     GIR_RootConstrainSelectedInstOperands,
     /* 236940 */     // GIR_Coverage, 795,
     /* 236940 */     GIR_EraseRootFromParent_Done,
     /* 236941 */   // Label 3893: @236941
     /* 236941 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(236978), // Rule ID 797 //
     /* 236946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
     /* 236951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 236954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 236964 */     // (intrinsic_wo_chain:{ *:[i32] } 3176:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 236964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
     /* 236967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 236969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 236971 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 236973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236976 */     GIR_RootConstrainSelectedInstOperands,
     /* 236977 */     // GIR_Coverage, 797,
     /* 236977 */     GIR_EraseRootFromParent_Done,
     /* 236978 */   // Label 3894: @236978
     /* 236978 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(237012), // Rule ID 799 //
     /* 236983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_u24),
     /* 236988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 236991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 236994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 236997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237001 */     // (intrinsic_wo_chain:{ *:[i32] } 3178:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 237001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
     /* 237004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237008 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237010 */     GIR_RootConstrainSelectedInstOperands,
     /* 237011 */     // GIR_Coverage, 799,
     /* 237011 */     GIR_EraseRootFromParent_Done,
     /* 237012 */   // Label 3895: @237012
     /* 237012 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(237046), // Rule ID 819 //
     /* 237017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_lo),
     /* 237022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237035 */     // (intrinsic_wo_chain:{ *:[i32] } 3122:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_LO_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 237035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_LO_U32_B32_e64),
     /* 237038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237042 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237044 */     GIR_RootConstrainSelectedInstOperands,
     /* 237045 */     // GIR_Coverage, 819,
     /* 237045 */     GIR_EraseRootFromParent_Done,
     /* 237046 */   // Label 3896: @237046
     /* 237046 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(237080), // Rule ID 820 //
     /* 237051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_hi),
     /* 237056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237069 */     // (intrinsic_wo_chain:{ *:[i32] } 3121:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_HI_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 237069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_HI_U32_B32_e64),
     /* 237072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237076 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237078 */     GIR_RootConstrainSelectedInstOperands,
     /* 237079 */     // GIR_Coverage, 820,
     /* 237079 */     GIR_EraseRootFromParent_Done,
     /* 237080 */   // Label 3897: @237080
     /* 237080 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(237114), // Rule ID 829 //
     /* 237085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u16),
     /* 237090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 237093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237103 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2202:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_U16_U32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 237103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U16_U32_e64),
     /* 237106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237108 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237110 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237112 */     GIR_RootConstrainSelectedInstOperands,
     /* 237113 */     // GIR_Coverage, 829,
     /* 237113 */     GIR_EraseRootFromParent_Done,
     /* 237114 */   // Label 3898: @237114
     /* 237114 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(237148), // Rule ID 831 //
     /* 237119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_i16),
     /* 237124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 237127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237137 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2201:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 237137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
     /* 237140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237142 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237144 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237146 */     GIR_RootConstrainSelectedInstOperands,
     /* 237147 */     // GIR_Coverage, 831,
     /* 237147 */     GIR_EraseRootFromParent_Done,
     /* 237148 */   // Label 3899: @237148
     /* 237148 */   GIM_Reject,
     /* 237149 */ // Label 3851: @237149
     /* 237149 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(241713),
     /* 237154 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 237157 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(237250), // Rule ID 2567 //
     /* 237162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 237165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 237170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237207 */     // (intrinsic_wo_chain:{ *:[i32] } 2178:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBYTE_B32_fake16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, VSrc_b32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, VSrc_b32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[i32] }:$src2)
     /* 237207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_fake16_e64),
     /* 237210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237248 */     GIR_RootConstrainSelectedInstOperands,
     /* 237249 */     // GIR_Coverage, 2567,
     /* 237249 */     GIR_EraseRootFromParent_Done,
     /* 237250 */   // Label 3901: @237250
     /* 237250 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(237370), // Rule ID 2568 //
     /* 237255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 237258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 237263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 237300 */     // (intrinsic_wo_chain:{ *:[i32] } 2178:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBYTE_B32_t16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, VSrc_b32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, VSrc_b32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[i16] } VGPR_32:{ *:[i32] }:$src2, lo16:{ *:[i32] }))
     /* 237300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 237303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 237307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 237312 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 237319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 237324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_t16_e64),
     /* 237332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 237362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237368 */     GIR_RootConstrainSelectedInstOperands,
     /* 237369 */     // GIR_Coverage, 2568,
     /* 237369 */     GIR_EraseRootFromParent_Done,
     /* 237370 */   // Label 3902: @237370
     /* 237370 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(237460), // Rule ID 6932 //
     /* 237375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10),
     /* 237380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237417 */     // (intrinsic_wo_chain:{ *:[f32] } 3095:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P10_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 237417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F32_inreg),
     /* 237420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 237458 */     GIR_RootConstrainSelectedInstOperands,
     /* 237459 */     // GIR_Coverage, 6932,
     /* 237459 */     GIR_EraseRootFromParent_Done,
     /* 237460 */   // Label 3903: @237460
     /* 237460 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(237550), // Rule ID 6933 //
     /* 237465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2),
     /* 237470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 237507 */     // (intrinsic_wo_chain:{ *:[f32] } 3097:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P2_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 237507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32_inreg),
     /* 237510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 237517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 237527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 237537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 237548 */     GIR_RootConstrainSelectedInstOperands,
     /* 237549 */     // GIR_Coverage, 6933,
     /* 237549 */     GIR_EraseRootFromParent_Done,
     /* 237550 */   // Label 3904: @237550
     /* 237550 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(237637), // Rule ID 7014 //
     /* 237555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 237558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 237563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237600 */     // (intrinsic_wo_chain:{ *:[f32] } 2311:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 237600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
     /* 237603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237635 */     GIR_RootConstrainSelectedInstOperands,
     /* 237636 */     // GIR_Coverage, 7014,
     /* 237636 */     GIR_EraseRootFromParent_Done,
     /* 237637 */   // Label 3905: @237637
     /* 237637 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(237724), // Rule ID 7018 //
     /* 237642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 237645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 237650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237687 */     // (intrinsic_wo_chain:{ *:[f32] } 2310:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 237687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_LEGACY_F32_e64),
     /* 237690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237722 */     GIR_RootConstrainSelectedInstOperands,
     /* 237723 */     // GIR_Coverage, 7018,
     /* 237723 */     GIR_EraseRootFromParent_Done,
     /* 237724 */   // Label 3906: @237724
     /* 237724 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(237811), // Rule ID 7020 //
     /* 237729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 237732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 237737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 237740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 237743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 237746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 237749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 237774 */     // (intrinsic_wo_chain:{ *:[f16] } 2311:{ *:[iPTR] }, (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 237774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
     /* 237777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 237787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 237795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 237803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237809 */     GIR_RootConstrainSelectedInstOperands,
     /* 237810 */     // GIR_Coverage, 7020,
     /* 237810 */     GIR_EraseRootFromParent_Done,
     /* 237811 */   // Label 3907: @237811
     /* 237811 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(237874), // Rule ID 2759 //
     /* 237816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 237819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_bf8),
     /* 237824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 237847 */     // (intrinsic_wo_chain:{ *:[f32] } 2268:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 237847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_BF8),
     /* 237850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237854 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 237861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 237866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237872 */     GIR_RootConstrainSelectedInstOperands,
     /* 237873 */     // GIR_Coverage, 2759,
     /* 237873 */     GIR_EraseRootFromParent_Done,
     /* 237874 */   // Label 3908: @237874
     /* 237874 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(237937), // Rule ID 2760 //
     /* 237879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 237882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_fp8),
     /* 237887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 237910 */     // (intrinsic_wo_chain:{ *:[f32] } 2267:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 237910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_FP8),
     /* 237913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237917 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 237924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 237929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237935 */     GIR_RootConstrainSelectedInstOperands,
     /* 237936 */     // GIR_Coverage, 2760,
     /* 237936 */     GIR_EraseRootFromParent_Done,
     /* 237937 */   // Label 3909: @237937
     /* 237937 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(238000), // Rule ID 2761 //
     /* 237942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 237945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_fp8),
     /* 237950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 237966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 237973 */     // (intrinsic_wo_chain:{ *:[f32] } 2269:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 237973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_FP8),
     /* 237976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 237978 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 237980 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 237982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 237987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 237992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237998 */     GIR_RootConstrainSelectedInstOperands,
     /* 237999 */     // GIR_Coverage, 2761,
     /* 237999 */     GIR_EraseRootFromParent_Done,
     /* 238000 */   // Label 3910: @238000
     /* 238000 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(238063), // Rule ID 2762 //
     /* 238005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
     /* 238008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_bf8),
     /* 238013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 238036 */     // (intrinsic_wo_chain:{ *:[f32] } 2266:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
     /* 238036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_BF8),
     /* 238039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238043 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 238050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 238055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238061 */     GIR_RootConstrainSelectedInstOperands,
     /* 238062 */     // GIR_Coverage, 2762,
     /* 238062 */     GIR_EraseRootFromParent_Done,
     /* 238063 */   // Label 3911: @238063
     /* 238063 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(238128), // Rule ID 6925 //
     /* 238068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 238071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
     /* 238076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238086 */     // MIs[0] attrchan
     /* 238086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 238089 */     // MIs[0] attr
     /* 238089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 238092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 238096 */     // (intrinsic_wo_chain:{ *:[f32] } 3113:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (LDS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] })
     /* 238096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238100 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
     /* 238110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_PARAM_LOAD),
     /* 238113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238115 */     GIR_RootToRootCopy, /*OpIdx*/3, // attr
     /* 238117 */     GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
     /* 238119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 238126 */     GIR_RootConstrainSelectedInstOperands,
     /* 238127 */     // GIR_Coverage, 6925,
     /* 238127 */     GIR_EraseRootFromParent_Done,
     /* 238128 */   // Label 3912: @238128
     /* 238128 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(238196), // Rule ID 6927 //
     /* 238133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 238136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
     /* 238141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238151 */     // MIs[0] attrchan
     /* 238151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 238154 */     // MIs[0] attr
     /* 238154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 238157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 238161 */     // (intrinsic_wo_chain:{ *:[f32] } 3113:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (DS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 238161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 238165 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 238171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
     /* 238175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PARAM_LOAD),
     /* 238178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238180 */     GIR_RootToRootCopy, /*OpIdx*/3, // attr
     /* 238182 */     GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
     /* 238184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 238190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 238194 */     GIR_RootConstrainSelectedInstOperands,
     /* 238195 */     // GIR_Coverage, 6927,
     /* 238195 */     GIR_EraseRootFromParent_Done,
     /* 238196 */   // Label 3913: @238196
     /* 238196 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(238248), // Rule ID 2633 //
     /* 238201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_fp8),
     /* 238206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238219 */     // MIs[0] index
     /* 238219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238222 */     // (intrinsic_wo_chain:{ *:[f32] } 2212:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_FP8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 238222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_FP8_e64),
     /* 238225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 238233 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 238241 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238246 */     GIR_RootConstrainSelectedInstOperands,
     /* 238247 */     // GIR_Coverage, 2633,
     /* 238247 */     GIR_EraseRootFromParent_Done,
     /* 238248 */   // Label 3914: @238248
     /* 238248 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(238300), // Rule ID 2634 //
     /* 238253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_bf8),
     /* 238258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238271 */     // MIs[0] index
     /* 238271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238274 */     // (intrinsic_wo_chain:{ *:[f32] } 2211:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_BF8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 238274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_BF8_e64),
     /* 238277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 238285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 238293 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238298 */     GIR_RootConstrainSelectedInstOperands,
     /* 238299 */     // GIR_Coverage, 2634,
     /* 238299 */     GIR_EraseRootFromParent_Done,
     /* 238300 */   // Label 3915: @238300
     /* 238300 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(238352), // Rule ID 2635 //
     /* 238305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp4),
     /* 238310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 238313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238323 */     // MIs[0] index
     /* 238323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238326 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2220:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F16_FP4_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 238326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP4_e64),
     /* 238329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 238337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 238345 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238350 */     GIR_RootConstrainSelectedInstOperands,
     /* 238351 */     // GIR_Coverage, 2635,
     /* 238351 */     GIR_EraseRootFromParent_Done,
     /* 238352 */   // Label 3916: @238352
     /* 238352 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(238401), // Rule ID 2642 //
     /* 238357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp8),
     /* 238362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 238365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 238375 */     // MIs[0] word_sel
     /* 238375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238378 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2224:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_FP8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 238378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP8_e64),
     /* 238381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238383 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 238389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238394 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238399 */     GIR_RootConstrainSelectedInstOperands,
     /* 238400 */     // GIR_Coverage, 2642,
     /* 238400 */     GIR_EraseRootFromParent_Done,
     /* 238401 */   // Label 3917: @238401
     /* 238401 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(238450), // Rule ID 2643 //
     /* 238406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_bf8),
     /* 238411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 238414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 238424 */     // MIs[0] word_sel
     /* 238424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238427 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2222:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_BF8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 238427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_BF8_e64),
     /* 238430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 238438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238443 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238448 */     GIR_RootConstrainSelectedInstOperands,
     /* 238449 */     // GIR_Coverage, 2643,
     /* 238449 */     GIR_EraseRootFromParent_Done,
     /* 238450 */   // Label 3918: @238450
     /* 238450 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(238499), // Rule ID 2644 //
     /* 238455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_bf8),
     /* 238460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 238463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238473 */     // MIs[0] word_sel
     /* 238473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238476 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2219:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_BF8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 238476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_BF8_e64),
     /* 238479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 238487 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238492 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238497 */     GIR_RootConstrainSelectedInstOperands,
     /* 238498 */     // GIR_Coverage, 2644,
     /* 238498 */     GIR_EraseRootFromParent_Done,
     /* 238499 */   // Label 3919: @238499
     /* 238499 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(238548), // Rule ID 2645 //
     /* 238504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp8),
     /* 238509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 238512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238522 */     // MIs[0] word_sel
     /* 238522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238525 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2221:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_FP8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
     /* 238525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP8_e64),
     /* 238528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
     /* 238536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238541 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238546 */     GIR_RootConstrainSelectedInstOperands,
     /* 238547 */     // GIR_Coverage, 2645,
     /* 238547 */     GIR_EraseRootFromParent_Done,
     /* 238548 */   // Label 3920: @238548
     /* 238548 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(238600), // Rule ID 2648 //
     /* 238553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp4),
     /* 238558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 238561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 238571 */     // MIs[0] index
     /* 238571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 238574 */     // (intrinsic_wo_chain:{ *:[v2f32] } 2223:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F32_FP4_e64:{ *:[v2f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
     /* 238574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP4_e64),
     /* 238577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
     /* 238585 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238587 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
     /* 238593 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238598 */     GIR_RootConstrainSelectedInstOperands,
     /* 238599 */     // GIR_Coverage, 2648,
     /* 238599 */     GIR_EraseRootFromParent_Done,
     /* 238600 */   // Label 3921: @238600
     /* 238600 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(238642), // Rule ID 2712 //
     /* 238605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u8),
     /* 238610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238626 */     // (intrinsic_wo_chain:{ *:[i32] } 3296:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 238626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U8_e64),
     /* 238629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238633 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238635 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238640 */     GIR_RootConstrainSelectedInstOperands,
     /* 238641 */     // GIR_Coverage, 2712,
     /* 238641 */     GIR_EraseRootFromParent_Done,
     /* 238642 */   // Label 3922: @238642
     /* 238642 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(238684), // Rule ID 2713 //
     /* 238647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_hi_u8),
     /* 238652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238668 */     // (intrinsic_wo_chain:{ *:[i32] } 3294:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_HI_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 238668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_HI_U8_e64),
     /* 238671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238675 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238677 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238682 */     GIR_RootConstrainSelectedInstOperands,
     /* 238683 */     // GIR_Coverage, 2713,
     /* 238683 */     GIR_EraseRootFromParent_Done,
     /* 238684 */   // Label 3923: @238684
     /* 238684 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(238726), // Rule ID 2714 //
     /* 238689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u16),
     /* 238694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238710 */     // (intrinsic_wo_chain:{ *:[i32] } 3295:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 238710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U16_e64),
     /* 238713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238717 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238719 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238724 */     GIR_RootConstrainSelectedInstOperands,
     /* 238725 */     // GIR_Coverage, 2714,
     /* 238725 */     GIR_EraseRootFromParent_Done,
     /* 238726 */   // Label 3924: @238726
     /* 238726 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(238768), // Rule ID 2715 //
     /* 238731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_msad_u8),
     /* 238736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238752 */     // (intrinsic_wo_chain:{ *:[i32] } 3174:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MSAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
     /* 238752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MSAD_U8_e64),
     /* 238755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238759 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238761 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238766 */     GIR_RootConstrainSelectedInstOperands,
     /* 238767 */     // GIR_Coverage, 2715,
     /* 238767 */     GIR_EraseRootFromParent_Done,
     /* 238768 */   // Label 3925: @238768
     /* 238768 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(238810), // Rule ID 2716 //
     /* 238773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_pk_u16_u8),
     /* 238778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 238781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 238784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 238790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 238794 */     // (intrinsic_wo_chain:{ *:[i64] } 3172:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_MQSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /* 238794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_PK_U16_U8_e64),
     /* 238797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238801 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238803 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238808 */     GIR_RootConstrainSelectedInstOperands,
     /* 238809 */     // GIR_Coverage, 2716,
     /* 238809 */     GIR_EraseRootFromParent_Done,
     /* 238810 */   // Label 3926: @238810
     /* 238810 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(238852), // Rule ID 2717 //
     /* 238815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_qsad_pk_u16_u8),
     /* 238820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 238823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 238826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 238832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 238836 */     // (intrinsic_wo_chain:{ *:[i64] } 3190:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_QSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
     /* 238836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_QSAD_PK_U16_U8_e64),
     /* 238839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238841 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238843 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238845 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238850 */     GIR_RootConstrainSelectedInstOperands,
     /* 238851 */     // GIR_Coverage, 2717,
     /* 238851 */     GIR_EraseRootFromParent_Done,
     /* 238852 */   // Label 3927: @238852
     /* 238852 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(238894), // Rule ID 2718 //
     /* 238857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_u32_u8),
     /* 238862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 238865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 238868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 238874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 238878 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3173:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (V_MQSAD_U32_U8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, 0:{ *:[i1] })
     /* 238878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_U32_U8_e64),
     /* 238881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 238885 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 238887 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 238889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 238892 */     GIR_RootConstrainSelectedInstOperands,
     /* 238893 */     // GIR_Coverage, 2718,
     /* 238893 */     GIR_EraseRootFromParent_Done,
     /* 238894 */   // Label 3928: @238894
     /* 238894 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(238991), // Rule ID 923 //
     /* 238899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 238902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 238907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 238910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 238913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 238916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 238919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 238923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 238930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 238937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 238944 */     // (intrinsic_wo_chain:{ *:[f32] } 2311:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 238944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 238947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 238949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 238954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 238959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 238964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 238969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 238974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 238979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 238984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 238989 */     GIR_RootConstrainSelectedInstOperands,
     /* 238990 */     // GIR_Coverage, 923,
     /* 238990 */     GIR_EraseRootFromParent_Done,
     /* 238991 */   // Label 3929: @238991
     /* 238991 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(239088), // Rule ID 925 //
     /* 238996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 238999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 239004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239041 */     // (intrinsic_wo_chain:{ *:[f32] } 2310:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
     /* 239044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239086 */     GIR_RootConstrainSelectedInstOperands,
     /* 239087 */     // GIR_Coverage, 925,
     /* 239087 */     GIR_EraseRootFromParent_Done,
     /* 239088 */   // Label 3930: @239088
     /* 239088 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(239182), // Rule ID 952 //
     /* 239093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubeid),
     /* 239098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239135 */     // (intrinsic_wo_chain:{ *:[f32] } 2190:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEID_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEID_F32_e64),
     /* 239138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239180 */     GIR_RootConstrainSelectedInstOperands,
     /* 239181 */     // GIR_Coverage, 952,
     /* 239181 */     GIR_EraseRootFromParent_Done,
     /* 239182 */   // Label 3931: @239182
     /* 239182 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(239276), // Rule ID 953 //
     /* 239187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubesc),
     /* 239192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239229 */     // (intrinsic_wo_chain:{ *:[f32] } 2192:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBESC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBESC_F32_e64),
     /* 239232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239274 */     GIR_RootConstrainSelectedInstOperands,
     /* 239275 */     // GIR_Coverage, 953,
     /* 239275 */     GIR_EraseRootFromParent_Done,
     /* 239276 */   // Label 3932: @239276
     /* 239276 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(239370), // Rule ID 954 //
     /* 239281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubetc),
     /* 239286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239323 */     // (intrinsic_wo_chain:{ *:[f32] } 2193:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBETC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBETC_F32_e64),
     /* 239326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239368 */     GIR_RootConstrainSelectedInstOperands,
     /* 239369 */     // GIR_Coverage, 954,
     /* 239369 */     GIR_EraseRootFromParent_Done,
     /* 239370 */   // Label 3933: @239370
     /* 239370 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(239464), // Rule ID 955 //
     /* 239375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubema),
     /* 239380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239417 */     // (intrinsic_wo_chain:{ *:[f32] } 2191:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEMA_F32_e64),
     /* 239420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239462 */     GIR_RootConstrainSelectedInstOperands,
     /* 239463 */     // GIR_Coverage, 955,
     /* 239463 */     GIR_EraseRootFromParent_Done,
     /* 239464 */   // Label 3934: @239464
     /* 239464 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(239558), // Rule ID 972 //
     /* 239469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 239474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239511 */     // (intrinsic_wo_chain:{ *:[f32] } 2312:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 239514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239556 */     GIR_RootConstrainSelectedInstOperands,
     /* 239557 */     // GIR_Coverage, 972,
     /* 239557 */     GIR_EraseRootFromParent_Done,
     /* 239558 */   // Label 3935: @239558
     /* 239558 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(239647), // Rule ID 976 //
     /* 239563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u8_f32),
     /* 239568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239605 */     // (intrinsic_wo_chain:{ *:[i32] } 2203:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CVT_PK_U8_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 239605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U8_F32_e64),
     /* 239608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239645 */     GIR_RootConstrainSelectedInstOperands,
     /* 239646 */     // GIR_Coverage, 976,
     /* 239646 */     GIR_EraseRootFromParent_Done,
     /* 239647 */   // Label 3936: @239647
     /* 239647 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(239741), // Rule ID 977 //
     /* 239652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 239657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 239660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 239663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 239666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 239669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239694 */     // (intrinsic_wo_chain:{ *:[f32] } 2263:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F32_e64),
     /* 239697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239739 */     GIR_RootConstrainSelectedInstOperands,
     /* 239740 */     // GIR_Coverage, 977,
     /* 239740 */     GIR_EraseRootFromParent_Done,
     /* 239741 */   // Label 3937: @239741
     /* 239741 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(239835), // Rule ID 979 //
     /* 239746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 239751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 239754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 239757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 239760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 239763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 239767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239788 */     // (intrinsic_wo_chain:{ *:[f64] } 2263:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F64_e64),
     /* 239791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239833 */     GIR_RootConstrainSelectedInstOperands,
     /* 239834 */     // GIR_Coverage, 979,
     /* 239834 */     GIR_EraseRootFromParent_Done,
     /* 239835 */   // Label 3938: @239835
     /* 239835 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(239932), // Rule ID 998 //
     /* 239840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 239843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 239848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 239854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 239857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 239860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239885 */     // (intrinsic_wo_chain:{ *:[f16] } 2263:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_e64),
     /* 239888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 239905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 239910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 239915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 239920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 239925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 239930 */     GIR_RootConstrainSelectedInstOperands,
     /* 239931 */     // GIR_Coverage, 998,
     /* 239931 */     GIR_EraseRootFromParent_Done,
     /* 239932 */   // Label 3939: @239932
     /* 239932 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(240029), // Rule ID 1015 //
     /* 239937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 239940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
     /* 239945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 239948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 239951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 239954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 239957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 239961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 239968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 239982 */     // (intrinsic_wo_chain:{ *:[f16] } 2311:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 239982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 239985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 239987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 239992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 239997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 240022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 240027 */     GIR_RootConstrainSelectedInstOperands,
     /* 240028 */     // GIR_Coverage, 1015,
     /* 240028 */     GIR_EraseRootFromParent_Done,
     /* 240029 */   // Label 3940: @240029
     /* 240029 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(240126), // Rule ID 8586 //
     /* 240034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
     /* 240037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
     /* 240042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 240045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 240072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 240079 */     // (intrinsic_wo_chain:{ *:[f32] } 2310:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 240079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
     /* 240082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 240089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 240094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 240099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 240104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 240119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 240124 */     GIR_RootConstrainSelectedInstOperands,
     /* 240125 */     // GIR_Coverage, 8586,
     /* 240125 */     GIR_EraseRootFromParent_Done,
     /* 240126 */   // Label 3941: @240126
     /* 240126 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(240222), // Rule ID 1002 //
     /* 240131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 240134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 240139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 240145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 240148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240176 */     // (intrinsic_wo_chain:{ *:[f16] } 2263:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_e64),
     /* 240179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240220 */     GIR_RootConstrainSelectedInstOperands,
     /* 240221 */     // GIR_Coverage, 1002,
     /* 240221 */     GIR_EraseRootFromParent_Done,
     /* 240222 */   // Label 3942: @240222
     /* 240222 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(240318), // Rule ID 1004 //
     /* 240227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 240230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 240235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 240241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 240244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 240251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240272 */     // (intrinsic_wo_chain:{ *:[f16] } 2263:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_t16_e64),
     /* 240275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240316 */     GIR_RootConstrainSelectedInstOperands,
     /* 240317 */     // GIR_Coverage, 1004,
     /* 240317 */     GIR_EraseRootFromParent_Done,
     /* 240318 */   // Label 3943: @240318
     /* 240318 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(240414), // Rule ID 1006 //
     /* 240323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 240326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
     /* 240331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 240337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 240340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240368 */     // (intrinsic_wo_chain:{ *:[f16] } 2263:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_fake16_e64),
     /* 240371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240412 */     GIR_RootConstrainSelectedInstOperands,
     /* 240413 */     // GIR_Coverage, 1006,
     /* 240413 */     GIR_EraseRootFromParent_Done,
     /* 240414 */   // Label 3944: @240414
     /* 240414 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(240510), // Rule ID 1019 //
     /* 240419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 240422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 240427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 240433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 240436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240464 */     // (intrinsic_wo_chain:{ *:[f16] } 2312:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 240467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240508 */     GIR_RootConstrainSelectedInstOperands,
     /* 240509 */     // GIR_Coverage, 1019,
     /* 240509 */     GIR_EraseRootFromParent_Done,
     /* 240510 */   // Label 3945: @240510
     /* 240510 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(240606), // Rule ID 1021 //
     /* 240515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 240518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 240523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 240529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 240532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 240539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240560 */     // (intrinsic_wo_chain:{ *:[f16] } 2312:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 240563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240604 */     GIR_RootConstrainSelectedInstOperands,
     /* 240605 */     // GIR_Coverage, 1021,
     /* 240605 */     GIR_EraseRootFromParent_Done,
     /* 240606 */   // Label 3946: @240606
     /* 240606 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(240702), // Rule ID 1023 //
     /* 240611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 240614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
     /* 240619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 240625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 240628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240656 */     // (intrinsic_wo_chain:{ *:[f16] } 2312:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 240659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240700 */     GIR_RootConstrainSelectedInstOperands,
     /* 240701 */     // GIR_Coverage, 1023,
     /* 240701 */     GIR_EraseRootFromParent_Done,
     /* 240702 */   // Label 3947: @240702
     /* 240702 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(240792), // Rule ID 1073 //
     /* 240707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_NotHasTrue16BitInsts),
     /* 240710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 240715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 240721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 240724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240752 */     // (intrinsic_wo_chain:{ *:[f16] } 2305:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_e64),
     /* 240755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240790 */     GIR_RootConstrainSelectedInstOperands,
     /* 240791 */     // GIR_Coverage, 1073,
     /* 240791 */     GIR_EraseRootFromParent_Done,
     /* 240792 */   // Label 3948: @240792
     /* 240792 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(240882), // Rule ID 1074 //
     /* 240797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseRealTrue16Insts),
     /* 240800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 240805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 240811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 240814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 240821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240842 */     // (intrinsic_wo_chain:{ *:[f16] } 2305:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_t16_e64),
     /* 240845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240880 */     GIR_RootConstrainSelectedInstOperands,
     /* 240881 */     // GIR_Coverage, 1074,
     /* 240881 */     GIR_EraseRootFromParent_Done,
     /* 240882 */   // Label 3949: @240882
     /* 240882 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(240972), // Rule ID 1075 //
     /* 240887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseFakeTrue16Insts),
     /* 240890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
     /* 240895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 240901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 240904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 240907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 240911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 240932 */     // (intrinsic_wo_chain:{ *:[f16] } 2305:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 240932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_fake16_e64),
     /* 240935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 240937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 240942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 240947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 240952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 240957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 240962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 240967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 240970 */     GIR_RootConstrainSelectedInstOperands,
     /* 240971 */     // GIR_Coverage, 1075,
     /* 240971 */     GIR_EraseRootFromParent_Done,
     /* 240972 */   // Label 3950: @240972
     /* 240972 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(241062), // Rule ID 1086 //
     /* 240977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /* 240980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_i8_i32),
     /* 240985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 240988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 240991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 240994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 240997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 241008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 241015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 241022 */     // (intrinsic_wo_chain:{ *:[i16] } 2179:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
     /* 241022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
     /* 241025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 241032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 241042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 241047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 241052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 241057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241060 */     GIR_RootConstrainSelectedInstOperands,
     /* 241061 */     // GIR_Coverage, 1086,
     /* 241061 */     GIR_EraseRootFromParent_Done,
     /* 241062 */   // Label 3951: @241062
     /* 241062 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(241152), // Rule ID 1087 //
     /* 241067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
     /* 241070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_u8_i32),
     /* 241075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 241078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 241098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 241105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 241112 */     // (intrinsic_wo_chain:{ *:[i16] } 2180:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
     /* 241112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
     /* 241115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 241122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 241132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 241137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 241142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 241147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 241150 */     GIR_RootConstrainSelectedInstOperands,
     /* 241151 */     // GIR_Coverage, 1087,
     /* 241151 */     GIR_EraseRootFromParent_Done,
     /* 241152 */   // Label 3952: @241152
     /* 241152 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(241201), // Rule ID 928 //
     /* 241157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lerp),
     /* 241162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241185 */     // (intrinsic_wo_chain:{ *:[i32] } 3114:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_LERP_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 241185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LERP_U8_e64),
     /* 241188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241195 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241197 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241199 */     GIR_RootConstrainSelectedInstOperands,
     /* 241200 */     // GIR_Coverage, 928,
     /* 241200 */     GIR_EraseRootFromParent_Done,
     /* 241201 */   // Label 3953: @241201
     /* 241201 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(241250), // Rule ID 956 //
     /* 241206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ubfe),
     /* 241211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241234 */     // (intrinsic_wo_chain:{ *:[i32] } 3403:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 241234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
     /* 241237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241244 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241246 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241248 */     GIR_RootConstrainSelectedInstOperands,
     /* 241249 */     // GIR_Coverage, 956,
     /* 241249 */     GIR_EraseRootFromParent_Done,
     /* 241250 */   // Label 3954: @241250
     /* 241250 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(241299), // Rule ID 958 //
     /* 241255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sbfe),
     /* 241260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241283 */     // (intrinsic_wo_chain:{ *:[i32] } 3297:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 241283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 241286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241293 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241295 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241297 */     GIR_RootConstrainSelectedInstOperands,
     /* 241298 */     // GIR_Coverage, 958,
     /* 241298 */     GIR_EraseRootFromParent_Done,
     /* 241299 */   // Label 3955: @241299
     /* 241299 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(241348), // Rule ID 963 //
     /* 241304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
     /* 241309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241332 */     // (intrinsic_wo_chain:{ *:[i32] } 2178:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBYTE_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 241332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_e64),
     /* 241335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241342 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241344 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241346 */     GIR_RootConstrainSelectedInstOperands,
     /* 241347 */     // GIR_Coverage, 963,
     /* 241347 */     GIR_EraseRootFromParent_Done,
     /* 241348 */   // Label 3956: @241348
     /* 241348 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(241400), // Rule ID 996 //
     /* 241353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 241356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_perm),
     /* 241361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241384 */     // (intrinsic_wo_chain:{ *:[i32] } 3179:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_PERM_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 241384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 241387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241394 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241396 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241398 */     GIR_RootConstrainSelectedInstOperands,
     /* 241399 */     // GIR_Coverage, 996,
     /* 241399 */     GIR_EraseRootFromParent_Done,
     /* 241400 */   // Label 3957: @241400
     /* 241400 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(241452), // Rule ID 1061 //
     /* 241405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 241408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f16),
     /* 241413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 241416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 241419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 241429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241436 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2251:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 241436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F16_e64),
     /* 241439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241446 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241448 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241450 */     GIR_RootConstrainSelectedInstOperands,
     /* 241451 */     // GIR_Coverage, 1061,
     /* 241451 */     GIR_EraseRootFromParent_Done,
     /* 241452 */   // Label 3958: @241452
     /* 241452 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(241504), // Rule ID 1062 //
     /* 241457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 241460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f32),
     /* 241465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 241468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
     /* 241471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 241481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241488 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2252:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 241488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F32_e64),
     /* 241491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241498 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241500 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241502 */     GIR_RootConstrainSelectedInstOperands,
     /* 241503 */     // GIR_Coverage, 1062,
     /* 241503 */     GIR_EraseRootFromParent_Done,
     /* 241504 */   // Label 3959: @241504
     /* 241504 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(241556), // Rule ID 1063 //
     /* 241509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 241512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f16),
     /* 241517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 241520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 241523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 241533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241540 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2254:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 241540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F16_e64),
     /* 241543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241550 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241552 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241554 */     GIR_RootConstrainSelectedInstOperands,
     /* 241555 */     // GIR_Coverage, 1063,
     /* 241555 */     GIR_EraseRootFromParent_Done,
     /* 241556 */   // Label 3960: @241556
     /* 241556 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(241608), // Rule ID 1064 //
     /* 241561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
     /* 241564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f32),
     /* 241569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 241572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
     /* 241575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 241585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241592 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2255:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 241592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F32_e64),
     /* 241595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241602 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241604 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241606 */     GIR_RootConstrainSelectedInstOperands,
     /* 241607 */     // GIR_Coverage, 1064,
     /* 241607 */     GIR_EraseRootFromParent_Done,
     /* 241608 */   // Label 3961: @241608
     /* 241608 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(241660), // Rule ID 1065 //
     /* 241613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 241616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_fp6_f32),
     /* 241621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 241624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 241627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 241630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 241637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241644 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2208:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_FP6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 241644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_FP6_F32_e64),
     /* 241647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241654 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241656 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241658 */     GIR_RootConstrainSelectedInstOperands,
     /* 241659 */     // GIR_Coverage, 1065,
     /* 241659 */     GIR_EraseRootFromParent_Done,
     /* 241660 */   // Label 3962: @241660
     /* 241660 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(241712), // Rule ID 1066 //
     /* 241665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 241668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_bf6_f32),
     /* 241673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
     /* 241676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 241679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 241682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
     /* 241689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 241696 */     // (intrinsic_wo_chain:{ *:[v6i32] } 2207:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_BF6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
     /* 241696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_BF6_F32_e64),
     /* 241699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 241706 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241708 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241710 */     GIR_RootConstrainSelectedInstOperands,
     /* 241711 */     // GIR_Coverage, 1066,
     /* 241711 */     GIR_EraseRootFromParent_Done,
     /* 241712 */   // Label 3963: @241712
     /* 241712 */   GIM_Reject,
     /* 241713 */ // Label 3900: @241713
     /* 241713 */ GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(246946),
     /* 241718 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 241721 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(241774), // Rule ID 2516 //
     /* 241726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot5Insts),
     /* 241729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
     /* 241734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241750 */     // MIs[0] Operand 5
     /* 241750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241761 */     // (intrinsic_wo_chain:{ *:[f32] } 2303:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, v2f16:{ *:[v2f16] }:$src1, f32:{ *:[f32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_F32_F16_e32:{ *:[f32] } ?:{ *:[v2f16] }:$src0, ?:{ *:[v2f16] }:$src1, ?:{ *:[f32] }:$src2)
     /* 241761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_F32_F16_e32),
     /* 241764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241766 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241768 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241770 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241772 */     GIR_RootConstrainSelectedInstOperands,
     /* 241773 */     // GIR_Coverage, 2516,
     /* 241773 */     GIR_EraseRootFromParent_Done,
     /* 241774 */   // Label 3965: @241774
     /* 241774 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(241827), // Rule ID 2518 //
     /* 241779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot6Insts),
     /* 241782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 241787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241803 */     // MIs[0] Operand 5
     /* 241803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241814 */     // (intrinsic_wo_chain:{ *:[i32] } 3301:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT4C_I32_I8_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
     /* 241814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4C_I32_I8_e32),
     /* 241817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241821 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241823 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241825 */     GIR_RootConstrainSelectedInstOperands,
     /* 241826 */     // GIR_Coverage, 2518,
     /* 241826 */     GIR_EraseRootFromParent_Done,
     /* 241827 */   // Label 3966: @241827
     /* 241827 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(241880), // Rule ID 2519 //
     /* 241832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot4Insts),
     /* 241835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
     /* 241840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 241846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 241849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241856 */     // MIs[0] Operand 5
     /* 241856 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241867 */     // (intrinsic_wo_chain:{ *:[i32] } 3300:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_I32_I16_e32:{ *:[i32] } ?:{ *:[v2i16] }:$src0, ?:{ *:[v2i16] }:$src1, ?:{ *:[i32] }:$src2)
     /* 241867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_I32_I16_e32),
     /* 241870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241872 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241874 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241876 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241878 */     GIR_RootConstrainSelectedInstOperands,
     /* 241879 */     // GIR_Coverage, 2519,
     /* 241879 */     GIR_EraseRootFromParent_Done,
     /* 241880 */   // Label 3967: @241880
     /* 241880 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(241933), // Rule ID 2520 //
     /* 241885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot3Insts),
     /* 241888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 241893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241909 */     // MIs[0] Operand 5
     /* 241909 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241920 */     // (intrinsic_wo_chain:{ *:[i32] } 3302:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT8C_I32_I4_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
     /* 241920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8C_I32_I4_e32),
     /* 241923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241925 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 241927 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 241929 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 241931 */     GIR_RootConstrainSelectedInstOperands,
     /* 241932 */     // GIR_Coverage, 2520,
     /* 241932 */     GIR_EraseRootFromParent_Done,
     /* 241933 */   // Label 3968: @241933
     /* 241933 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(242040), // Rule ID 6928 //
     /* 241938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 241941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 241946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 241949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 241952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 241955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 241958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 241962 */     // MIs[0] Operand 5
     /* 241962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 241973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 241980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 241987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 241994 */     // (intrinsic_wo_chain:{ *:[f32] } 3096:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 241994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
     /* 241997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 241999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 242038 */     GIR_RootConstrainSelectedInstOperands,
     /* 242039 */     // GIR_Coverage, 6928,
     /* 242039 */     GIR_EraseRootFromParent_Done,
     /* 242040 */   // Label 3969: @242040
     /* 242040 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(242147), // Rule ID 6929 //
     /* 242045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 242048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 242053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242069 */     // MIs[0] Operand 5
     /* 242069 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 242080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 242087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 242101 */     // (intrinsic_wo_chain:{ *:[f32] } 3096:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 242101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
     /* 242104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 242116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 242145 */     GIR_RootConstrainSelectedInstOperands,
     /* 242146 */     // GIR_Coverage, 6929,
     /* 242146 */     GIR_EraseRootFromParent_Done,
     /* 242147 */   // Label 3970: @242147
     /* 242147 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(242308), // Rule ID 6930 //
     /* 242152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 242155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 242160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242176 */     // MIs[0] Operand 5
     /* 242176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 242187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242208 */     // (intrinsic_wo_chain:{ *:[f32] } 3096:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 242208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 242211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242220 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 242227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 242240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242249 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 242256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
     /* 242269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 242297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 242306 */     GIR_RootConstrainSelectedInstOperands,
     /* 242307 */     // GIR_Coverage, 6930,
     /* 242307 */     GIR_EraseRootFromParent_Done,
     /* 242308 */   // Label 3971: @242308
     /* 242308 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(242469), // Rule ID 6931 //
     /* 242313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 242316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
     /* 242321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242337 */     // MIs[0] Operand 5
     /* 242337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 242348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242369 */     // (intrinsic_wo_chain:{ *:[f32] } 3096:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 242369 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 242372 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242376 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242381 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
     /* 242388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 242401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242410 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 242417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
     /* 242430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 242458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 242467 */     GIR_RootConstrainSelectedInstOperands,
     /* 242468 */     // GIR_Coverage, 6931,
     /* 242468 */     GIR_EraseRootFromParent_Done,
     /* 242469 */   // Label 3972: @242469
     /* 242469 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(242603), // Rule ID 6934 //
     /* 242474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 242477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 242482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 242485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242498 */     // MIs[0] Operand 5
     /* 242498 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 242509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242530 */     // (intrinsic_wo_chain:{ *:[f16] } 3098:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 242530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 242533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242542 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 242549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
     /* 242562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 242601 */     GIR_RootConstrainSelectedInstOperands,
     /* 242602 */     // GIR_Coverage, 6934,
     /* 242602 */     GIR_EraseRootFromParent_Done,
     /* 242603 */   // Label 3973: @242603
     /* 242603 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(242737), // Rule ID 6935 //
     /* 242608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 242611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 242616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 242619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242632 */     // MIs[0] Operand 5
     /* 242632 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 242643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242664 */     // (intrinsic_wo_chain:{ *:[f16] } 3098:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 242664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 242667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242676 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 242683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
     /* 242696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 242726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 242735 */     GIR_RootConstrainSelectedInstOperands,
     /* 242736 */     // GIR_Coverage, 6935,
     /* 242736 */     GIR_EraseRootFromParent_Done,
     /* 242737 */   // Label 3974: @242737
     /* 242737 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(242898), // Rule ID 6936 //
     /* 242742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 242745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 242750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242766 */     // MIs[0] Operand 5
     /* 242766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 242777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242798 */     // (intrinsic_wo_chain:{ *:[f32] } 3102:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 242798 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 242801 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242805 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242810 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 242817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 242830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242839 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 242846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
     /* 242859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 242861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 242866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 242874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 242879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 242884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 242887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 242893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 242896 */     GIR_RootConstrainSelectedInstOperands,
     /* 242897 */     // GIR_Coverage, 6936,
     /* 242897 */     GIR_EraseRootFromParent_Done,
     /* 242898 */   // Label 3975: @242898
     /* 242898 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(243059), // Rule ID 6937 //
     /* 242903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 242906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 242911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 242914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 242917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 242920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 242923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242927 */     // MIs[0] Operand 5
     /* 242927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 242938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 242959 */     // (intrinsic_wo_chain:{ *:[f32] } 3102:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 242959 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 242962 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242966 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242971 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
     /* 242978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 242983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 242988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 242991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 242995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243000 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 243007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 243012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
     /* 243020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 243048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243057 */     GIR_RootConstrainSelectedInstOperands,
     /* 243058 */     // GIR_Coverage, 6937,
     /* 243058 */     GIR_EraseRootFromParent_Done,
     /* 243059 */   // Label 3976: @243059
     /* 243059 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(243193), // Rule ID 6938 //
     /* 243064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 243067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 243072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 243075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 243088 */     // MIs[0] Operand 5
     /* 243088 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 243099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243120 */     // (intrinsic_wo_chain:{ *:[f16] } 3105:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 243123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 243127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243132 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
     /* 243139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 243144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
     /* 243152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243191 */     GIR_RootConstrainSelectedInstOperands,
     /* 243192 */     // GIR_Coverage, 6938,
     /* 243192 */     GIR_EraseRootFromParent_Done,
     /* 243193 */   // Label 3977: @243193
     /* 243193 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(243327), // Rule ID 6939 //
     /* 243198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 243201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 243206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 243209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 243222 */     // MIs[0] Operand 5
     /* 243222 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 243233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243254 */     // (intrinsic_wo_chain:{ *:[f16] } 3105:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 243257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 243261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 243266 */     GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
     /* 243273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 243278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
     /* 243286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 243296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243325 */     GIR_RootConstrainSelectedInstOperands,
     /* 243326 */     // GIR_Coverage, 6939,
     /* 243326 */     GIR_EraseRootFromParent_Done,
     /* 243327 */   // Label 3978: @243327
     /* 243327 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(243434), // Rule ID 6940 //
     /* 243332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 243335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 243340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 243343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243356 */     // MIs[0] Operand 5
     /* 243356 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 243367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243388 */     // (intrinsic_wo_chain:{ *:[f16] } 3098:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
     /* 243391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243432 */     GIR_RootConstrainSelectedInstOperands,
     /* 243433 */     // GIR_Coverage, 6940,
     /* 243433 */     GIR_EraseRootFromParent_Done,
     /* 243434 */   // Label 3979: @243434
     /* 243434 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(243541), // Rule ID 6941 //
     /* 243439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 243442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
     /* 243447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 243450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243463 */     // MIs[0] Operand 5
     /* 243463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 243474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 243481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243495 */     // (intrinsic_wo_chain:{ *:[f16] } 3098:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
     /* 243498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243539 */     GIR_RootConstrainSelectedInstOperands,
     /* 243540 */     // GIR_Coverage, 6941,
     /* 243540 */     GIR_EraseRootFromParent_Done,
     /* 243541 */   // Label 3980: @243541
     /* 243541 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(243648), // Rule ID 6942 //
     /* 243546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 243549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 243554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243570 */     // MIs[0] Operand 5
     /* 243570 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 243581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243602 */     // (intrinsic_wo_chain:{ *:[f32] } 3102:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
     /* 243605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243646 */     GIR_RootConstrainSelectedInstOperands,
     /* 243647 */     // GIR_Coverage, 6942,
     /* 243647 */     GIR_EraseRootFromParent_Done,
     /* 243648 */   // Label 3981: @243648
     /* 243648 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(243755), // Rule ID 6943 //
     /* 243653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 243656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
     /* 243661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243677 */     // MIs[0] Operand 5
     /* 243677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 243688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 243695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 243709 */     // (intrinsic_wo_chain:{ *:[f32] } 3102:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
     /* 243712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243753 */     GIR_RootConstrainSelectedInstOperands,
     /* 243754 */     // GIR_Coverage, 6943,
     /* 243754 */     GIR_EraseRootFromParent_Done,
     /* 243755 */   // Label 3982: @243755
     /* 243755 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(243862), // Rule ID 6944 //
     /* 243760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 243763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 243768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 243771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243784 */     // MIs[0] Operand 5
     /* 243784 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 243795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243816 */     // (intrinsic_wo_chain:{ *:[f16] } 3105:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
     /* 243819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243860 */     GIR_RootConstrainSelectedInstOperands,
     /* 243861 */     // GIR_Coverage, 6944,
     /* 243861 */     GIR_EraseRootFromParent_Done,
     /* 243862 */   // Label 3983: @243862
     /* 243862 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(243969), // Rule ID 6945 //
     /* 243867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 243870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
     /* 243875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 243878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 243891 */     // MIs[0] Operand 5
     /* 243891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 243902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
     /* 243909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
     /* 243923 */     // (intrinsic_wo_chain:{ *:[f16] } 3105:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
     /* 243923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
     /* 243926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 243928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 243933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 243938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 243943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 243948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 243953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 243958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 243964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 243967 */     GIR_RootConstrainSelectedInstOperands,
     /* 243968 */     // GIR_Coverage, 6945,
     /* 243968 */     GIR_EraseRootFromParent_Done,
     /* 243969 */   // Label 3984: @243969
     /* 243969 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(244083), // Rule ID 2689 //
     /* 243974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 243977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 243982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 243985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 243988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 243991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 243994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 243997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
     /* 244005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244026 */     // (intrinsic_wo_chain:{ *:[f32] } 2264:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
     /* 244026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244030 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
     /* 244040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
     /* 244043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 244050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 244055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 244060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 244065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 244070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 244075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244081 */     GIR_RootConstrainSelectedInstOperands,
     /* 244082 */     // GIR_Coverage, 2689,
     /* 244082 */     GIR_EraseRootFromParent_Done,
     /* 244083 */   // Label 3985: @244083
     /* 244083 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(244197), // Rule ID 2691 //
     /* 244088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 244091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 244096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 244105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 244108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 244111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 244115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
     /* 244119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244140 */     // (intrinsic_wo_chain:{ *:[f64] } 2264:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
     /* 244140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244144 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
     /* 244154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
     /* 244157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 244164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 244169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 244174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 244179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 244184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 244189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244195 */     GIR_RootConstrainSelectedInstOperands,
     /* 244196 */     // GIR_Coverage, 2691,
     /* 244196 */     GIR_EraseRootFromParent_Done,
     /* 244197 */   // Label 3986: @244197
     /* 244197 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(244311), // Rule ID 2693 //
     /* 244202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 244205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 244210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 244222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 244225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 244233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244254 */     // (intrinsic_wo_chain:{ *:[f32] } 2264:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
     /* 244254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244258 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
     /* 244268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
     /* 244271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 244278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 244283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 244288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 244293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 244298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 244303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244309 */     GIR_RootConstrainSelectedInstOperands,
     /* 244310 */     // GIR_Coverage, 2693,
     /* 244310 */     GIR_EraseRootFromParent_Done,
     /* 244311 */   // Label 3987: @244311
     /* 244311 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(244425), // Rule ID 2695 //
     /* 244316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 244319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
     /* 244324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 244327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 244330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 244333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 244336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
     /* 244339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 244343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 244347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244368 */     // (intrinsic_wo_chain:{ *:[f64] } 2264:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
     /* 244368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244372 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
     /* 244382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
     /* 244385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 244392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 244397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 244402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 244407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 244412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 244417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244423 */     GIR_RootConstrainSelectedInstOperands,
     /* 244424 */     // GIR_Coverage, 2695,
     /* 244424 */     GIR_EraseRootFromParent_Done,
     /* 244425 */   // Label 3988: @244425
     /* 244425 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(244506), // Rule ID 2596 //
     /* 244430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 244433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 244438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 244450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244454 */     // MIs[0] byte_sel
     /* 244454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244471 */     // (intrinsic_wo_chain:{ *:[i32] } 2259:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_FP8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 244471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_gfx12_e64),
     /* 244474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 244481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 244486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 244491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 244496 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 244498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 244504 */     GIR_RootConstrainSelectedInstOperands,
     /* 244505 */     // GIR_Coverage, 2596,
     /* 244505 */     GIR_EraseRootFromParent_Done,
     /* 244506 */   // Label 3989: @244506
     /* 244506 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(244587), // Rule ID 2597 //
     /* 244511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
     /* 244514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 244519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 244531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244535 */     // MIs[0] byte_sel
     /* 244535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 244552 */     // (intrinsic_wo_chain:{ *:[i32] } 2257:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_BF8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
     /* 244552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_gfx12_e64),
     /* 244555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 244562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 244567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 244572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 244577 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 244579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
     /* 244585 */     GIR_RootConstrainSelectedInstOperands,
     /* 244586 */     // GIR_Coverage, 2597,
     /* 244586 */     GIR_EraseRootFromParent_Done,
     /* 244587 */   // Label 3990: @244587
     /* 244587 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(244650), // Rule ID 1331 //
     /* 244592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
     /* 244595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_mov),
     /* 244600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 244606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244610 */     // MIs[0] vsrc
     /* 244610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 244613 */     // MIs[0] attrchan
     /* 244613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 244616 */     // MIs[0] attr
     /* 244616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 244619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 244623 */     // (intrinsic_wo_chain:{ *:[f32] } 3099:{ *:[iPTR] }, (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_MOV_F32:{ *:[f32] } (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 244623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244627 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 244637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_MOV_F32),
     /* 244640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244642 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 244644 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 244646 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 244648 */     GIR_RootConstrainSelectedInstOperands,
     /* 244649 */     // GIR_Coverage, 1331,
     /* 244649 */     GIR_EraseRootFromParent_Done,
     /* 244650 */   // Label 3991: @244650
     /* 244650 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(244713), // Rule ID 1328 //
     /* 244655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_has32BankLDS_isNotGFX90APlus),
     /* 244658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
     /* 244663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 244672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244676 */     // MIs[0] attrchan
     /* 244676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 244679 */     // MIs[0] attr
     /* 244679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 244682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 244686 */     // (intrinsic_wo_chain:{ *:[f32] } 3100:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 244686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244690 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 244700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32),
     /* 244703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244705 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 244707 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 244709 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 244711 */     GIR_RootConstrainSelectedInstOperands,
     /* 244712 */     // GIR_Coverage, 1328,
     /* 244712 */     GIR_EraseRootFromParent_Done,
     /* 244713 */   // Label 3992: @244713
     /* 244713 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(244776), // Rule ID 1329 //
     /* 244718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_has16BankLDS_isNotGFX90APlus),
     /* 244721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
     /* 244726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 244735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244739 */     // MIs[0] attrchan
     /* 244739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 244742 */     // MIs[0] attr
     /* 244742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 244745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 244749 */     // (intrinsic_wo_chain:{ *:[f32] } 3100:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32_16bank:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 244749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 244753 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 244759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
     /* 244763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32_16bank),
     /* 244766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244768 */     GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
     /* 244770 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 244772 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 244774 */     GIR_RootConstrainSelectedInstOperands,
     /* 244775 */     // GIR_Coverage, 1329,
     /* 244775 */     GIR_EraseRootFromParent_Done,
     /* 244776 */   // Label 3993: @244776
     /* 244776 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(244838), // Rule ID 2578 //
     /* 244781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_NotHasTrue16BitInsts_isGFX9Plus),
     /* 244784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 244789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 244801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244805 */     // MIs[0] Operand 5
     /* 244805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 244816 */     // (intrinsic_wo_chain:{ *:[i32] } 2200:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 244816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
     /* 244819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 244826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244829 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 244831 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 244833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244836 */     GIR_RootConstrainSelectedInstOperands,
     /* 244837 */     // GIR_Coverage, 2578,
     /* 244837 */     GIR_EraseRootFromParent_Done,
     /* 244838 */   // Label 3994: @244838
     /* 244838 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(244900), // Rule ID 2579 //
     /* 244843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_NotHasTrue16BitInsts_isGFX9Plus),
     /* 244846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 244851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 244863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244867 */     // MIs[0] Operand 5
     /* 244867 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 244878 */     // (intrinsic_wo_chain:{ *:[i32] } 2197:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 244878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
     /* 244881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244886 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 244888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244891 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 244893 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 244895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244898 */     GIR_RootConstrainSelectedInstOperands,
     /* 244899 */     // GIR_Coverage, 2579,
     /* 244899 */     GIR_EraseRootFromParent_Done,
     /* 244900 */   // Label 3995: @244900
     /* 244900 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(244962), // Rule ID 2580 //
     /* 244905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_UseFakeTrue16Insts_isGFX9Plus),
     /* 244908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 244913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 244925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244929 */     // MIs[0] Operand 5
     /* 244929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 244940 */     // (intrinsic_wo_chain:{ *:[i32] } 2200:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 244940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_fake16_e64),
     /* 244943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 244945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 244950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244953 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 244955 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 244957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 244960 */     GIR_RootConstrainSelectedInstOperands,
     /* 244961 */     // GIR_Coverage, 2580,
     /* 244961 */     GIR_EraseRootFromParent_Done,
     /* 244962 */   // Label 3996: @244962
     /* 244962 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(245024), // Rule ID 2581 //
     /* 244967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_UseFakeTrue16Insts_isGFX9Plus),
     /* 244970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 244975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 244978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 244981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 244984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 244987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 244991 */     // MIs[0] Operand 5
     /* 244991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 245002 */     // (intrinsic_wo_chain:{ *:[i32] } 2197:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_fake16_e64),
     /* 245005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245015 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245017 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245022 */     GIR_RootConstrainSelectedInstOperands,
     /* 245023 */     // GIR_Coverage, 2581,
     /* 245023 */     GIR_EraseRootFromParent_Done,
     /* 245024 */   // Label 3997: @245024
     /* 245024 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(245086), // Rule ID 2582 //
     /* 245029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_NotHasTrue16BitInsts_isGFX9Plus),
     /* 245032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 245037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245053 */     // MIs[0] Operand 5
     /* 245053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 245064 */     // (intrinsic_wo_chain:{ *:[i32] } 2200:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
     /* 245067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245077 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245079 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245084 */     GIR_RootConstrainSelectedInstOperands,
     /* 245085 */     // GIR_Coverage, 2582,
     /* 245085 */     GIR_EraseRootFromParent_Done,
     /* 245086 */   // Label 3998: @245086
     /* 245086 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(245148), // Rule ID 2583 //
     /* 245091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_NotHasTrue16BitInsts_isGFX9Plus),
     /* 245094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 245099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245115 */     // MIs[0] Operand 5
     /* 245115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 245126 */     // (intrinsic_wo_chain:{ *:[i32] } 2197:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
     /* 245129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245139 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245141 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245146 */     GIR_RootConstrainSelectedInstOperands,
     /* 245147 */     // GIR_Coverage, 2583,
     /* 245147 */     GIR_EraseRootFromParent_Done,
     /* 245148 */   // Label 3999: @245148
     /* 245148 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(245210), // Rule ID 2584 //
     /* 245153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_UseFakeTrue16Insts_isGFX9Plus),
     /* 245156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
     /* 245161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245177 */     // MIs[0] Operand 5
     /* 245177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 245188 */     // (intrinsic_wo_chain:{ *:[i32] } 2200:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_fake16_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_fake16_e64),
     /* 245191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245201 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245203 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245208 */     GIR_RootConstrainSelectedInstOperands,
     /* 245209 */     // GIR_Coverage, 2584,
     /* 245209 */     GIR_EraseRootFromParent_Done,
     /* 245210 */   // Label 4000: @245210
     /* 245210 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(245272), // Rule ID 2585 //
     /* 245215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_UseFakeTrue16Insts_isGFX9Plus),
     /* 245218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
     /* 245223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245239 */     // MIs[0] Operand 5
     /* 245239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 245250 */     // (intrinsic_wo_chain:{ *:[i32] } 2197:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_fake16_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_fake16_e64),
     /* 245253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245258 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245263 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245265 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245270 */     GIR_RootConstrainSelectedInstOperands,
     /* 245271 */     // GIR_Coverage, 2585,
     /* 245271 */     GIR_EraseRootFromParent_Done,
     /* 245272 */   // Label 4001: @245272
     /* 245272 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(245337), // Rule ID 2588 //
     /* 245277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 245285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245301 */     // MIs[0] Operand 5
     /* 245301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 245312 */     // (intrinsic_wo_chain:{ *:[i32] } 2259:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 245315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245325 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245330 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245335 */     GIR_RootConstrainSelectedInstOperands,
     /* 245336 */     // GIR_Coverage, 2588,
     /* 245336 */     GIR_EraseRootFromParent_Done,
     /* 245337 */   // Label 4002: @245337
     /* 245337 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(245402), // Rule ID 2589 //
     /* 245342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 245350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245366 */     // MIs[0] Operand 5
     /* 245366 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 245377 */     // (intrinsic_wo_chain:{ *:[i32] } 2257:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 245380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245390 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245395 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245400 */     GIR_RootConstrainSelectedInstOperands,
     /* 245401 */     // GIR_Coverage, 2589,
     /* 245401 */     GIR_EraseRootFromParent_Done,
     /* 245402 */   // Label 4003: @245402
     /* 245402 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(245467), // Rule ID 2590 //
     /* 245407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 245415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245431 */     // MIs[0] Operand 5
     /* 245431 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 245442 */     // (intrinsic_wo_chain:{ *:[i32] } 2259:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 245445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245450 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245455 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 245460 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245465 */     GIR_RootConstrainSelectedInstOperands,
     /* 245466 */     // GIR_Coverage, 2590,
     /* 245466 */     GIR_EraseRootFromParent_Done,
     /* 245467 */   // Label 4004: @245467
     /* 245467 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(245532), // Rule ID 2591 //
     /* 245472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 245480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245496 */     // MIs[0] Operand 5
     /* 245496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 245507 */     // (intrinsic_wo_chain:{ *:[i32] } 2257:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 245510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245520 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 245525 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245530 */     GIR_RootConstrainSelectedInstOperands,
     /* 245531 */     // GIR_Coverage, 2591,
     /* 245531 */     GIR_EraseRootFromParent_Done,
     /* 245532 */   // Label 4005: @245532
     /* 245532 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(245597), // Rule ID 2592 //
     /* 245537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 245545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245561 */     // MIs[0] Operand 5
     /* 245561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
     /* 245572 */     // (intrinsic_wo_chain:{ *:[i32] } 2259:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 245575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245580 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245585 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245590 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245595 */     GIR_RootConstrainSelectedInstOperands,
     /* 245596 */     // GIR_Coverage, 2592,
     /* 245596 */     GIR_EraseRootFromParent_Done,
     /* 245597 */   // Label 4006: @245597
     /* 245597 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(245662), // Rule ID 2593 //
     /* 245602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 245610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245626 */     // MIs[0] Operand 5
     /* 245626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
     /* 245637 */     // (intrinsic_wo_chain:{ *:[i32] } 2257:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 245640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245650 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245655 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245660 */     GIR_RootConstrainSelectedInstOperands,
     /* 245661 */     // GIR_Coverage, 2593,
     /* 245661 */     GIR_EraseRootFromParent_Done,
     /* 245662 */   // Label 4007: @245662
     /* 245662 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(245727), // Rule ID 2594 //
     /* 245667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
     /* 245675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245691 */     // MIs[0] Operand 5
     /* 245691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
     /* 245702 */     // (intrinsic_wo_chain:{ *:[i32] } 2259:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
     /* 245705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245715 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 245720 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245725 */     GIR_RootConstrainSelectedInstOperands,
     /* 245726 */     // GIR_Coverage, 2594,
     /* 245726 */     GIR_EraseRootFromParent_Done,
     /* 245727 */   // Label 4008: @245727
     /* 245727 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(245792), // Rule ID 2595 //
     /* 245732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
     /* 245735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
     /* 245740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245756 */     // MIs[0] Operand 5
     /* 245756 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
     /* 245767 */     // (intrinsic_wo_chain:{ *:[i32] } 2257:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
     /* 245767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
     /* 245770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 245775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 245777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 245782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 245785 */     GIR_RootToRootCopy, /*OpIdx*/4, // old
     /* 245787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245790 */     GIR_RootConstrainSelectedInstOperands,
     /* 245791 */     // GIR_Coverage, 2595,
     /* 245791 */     GIR_EraseRootFromParent_Done,
     /* 245792 */   // Label 4009: @245792
     /* 245792 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(245846), // Rule ID 2646 //
     /* 245797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f16),
     /* 245802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 245805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 245808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 245811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245818 */     // MIs[0] word_sel
     /* 245818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245821 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2229:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 245821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F16_e64),
     /* 245824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 245832 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 245834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245837 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 245839 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 245841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245844 */     GIR_RootConstrainSelectedInstOperands,
     /* 245845 */     // GIR_Coverage, 2646,
     /* 245845 */     GIR_EraseRootFromParent_Done,
     /* 245846 */   // Label 4010: @245846
     /* 245846 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(245900), // Rule ID 2647 //
     /* 245851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f16),
     /* 245856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 245859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 245862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 245865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245872 */     // MIs[0] word_sel
     /* 245872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245875 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2217:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 245875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F16_e64),
     /* 245878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245880 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 245886 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 245888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245891 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 245893 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 245895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245898 */     GIR_RootConstrainSelectedInstOperands,
     /* 245899 */     // GIR_Coverage, 2647,
     /* 245899 */     GIR_EraseRootFromParent_Done,
     /* 245900 */   // Label 4011: @245900
     /* 245900 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(245960), // Rule ID 2650 //
     /* 245905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f16),
     /* 245910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 245913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 245916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 245919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245926 */     // MIs[0] index
     /* 245926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245929 */     // (intrinsic_wo_chain:{ *:[i32] } 2226:{ *:[iPTR] }, i32:{ *:[i32] }:$src2, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src2)
     /* 245929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F16_e64),
     /* 245932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 245940 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 245942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245945 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 245947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 245953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 245955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 245958 */     GIR_RootConstrainSelectedInstOperands,
     /* 245959 */     // GIR_Coverage, 2650,
     /* 245959 */     GIR_EraseRootFromParent_Done,
     /* 245960 */   // Label 4012: @245960
     /* 245960 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(246017), // Rule ID 2697 //
     /* 245965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF32ToF16BF16ConversionSRInsts),
     /* 245968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_f16_f32),
     /* 245973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 245976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 245979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 245982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 245985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 245989 */     // MIs[0] word_sel
     /* 245989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245992 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2258:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SR_F16_F32_e64:{ *:[v2f16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 245992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_F16_F32_e64),
     /* 245995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 245997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 246003 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 246005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246008 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 246010 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 246012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246015 */     GIR_RootConstrainSelectedInstOperands,
     /* 246016 */     // GIR_Coverage, 2697,
     /* 246016 */     GIR_EraseRootFromParent_Done,
     /* 246017 */   // Label 4013: @246017
     /* 246017 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(246079), // Rule ID 2757 //
     /* 246022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 246025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 246030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246046 */     // MIs[0] clamp
     /* 246046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246049 */     // (intrinsic_wo_chain:{ *:[i32] } 3302:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 246049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
     /* 246052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 246057 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 246059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 246062 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 246064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 246067 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 246069 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246077 */     GIR_RootConstrainSelectedInstOperands,
     /* 246078 */     // GIR_Coverage, 2757,
     /* 246078 */     GIR_EraseRootFromParent_Done,
     /* 246079 */   // Label 4014: @246079
     /* 246079 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(246141), // Rule ID 2758 //
     /* 246084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 246087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 246092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246108 */     // MIs[0] clamp
     /* 246108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246111 */     // (intrinsic_wo_chain:{ *:[i32] } 3301:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 246111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
     /* 246114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 246119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 246121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 246124 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 246126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 246129 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 246131 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246139 */     GIR_RootConstrainSelectedInstOperands,
     /* 246140 */     // GIR_Coverage, 2758,
     /* 246140 */     GIR_EraseRootFromParent_Done,
     /* 246141 */   // Label 4015: @246141
     /* 246141 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(246185), // Rule ID 2685 //
     /* 246146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
     /* 246149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
     /* 246154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246170 */     // MIs[0] bitop3
     /* 246170 */     // No operand predicates
     /* 246170 */     // (intrinsic_wo_chain:{ *:[i32] } 2183:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2, (timm:{ *:[i32] }):$bitop3)
     /* 246170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B32_e64),
     /* 246173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246175 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 246177 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 246179 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 246181 */     GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
     /* 246183 */     GIR_RootConstrainSelectedInstOperands,
     /* 246184 */     // GIR_Coverage, 2685,
     /* 246184 */     GIR_EraseRootFromParent_Done,
     /* 246185 */   // Label 4016: @246185
     /* 246185 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(246241), // Rule ID 2686 //
     /* 246190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
     /* 246193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
     /* 246198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 246201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 246204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 246207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 246210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246214 */     // MIs[0] bitop3
     /* 246214 */     // No operand predicates
     /* 246214 */     // (intrinsic_wo_chain:{ *:[i16] } 2183:{ *:[iPTR] }, i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, (timm:{ *:[i32] }):$bitop3, 0:{ *:[i32] })
     /* 246214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B16_e64),
     /* 246217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 246224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246227 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 246229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246232 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 246234 */     GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
     /* 246236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246239 */     GIR_RootConstrainSelectedInstOperands,
     /* 246240 */     // GIR_Coverage, 2686,
     /* 246240 */     GIR_EraseRootFromParent_Done,
     /* 246241 */   // Label 4017: @246241
     /* 246241 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(246345), // Rule ID 1116 //
     /* 246246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /* 246249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
     /* 246254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 246260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 246263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246270 */     // MIs[0] clamp
     /* 246270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246294 */     // (intrinsic_wo_chain:{ *:[i32] } 3300:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_I32_I16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 246294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
     /* 246297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 246304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 246309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 246314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 246319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 246324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 246329 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246343 */     GIR_RootConstrainSelectedInstOperands,
     /* 246344 */     // GIR_Coverage, 1116,
     /* 246344 */     GIR_EraseRootFromParent_Done,
     /* 246345 */   // Label 4018: @246345
     /* 246345 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(246449), // Rule ID 1117 //
     /* 246350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
     /* 246353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot2),
     /* 246358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 246364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 246367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246374 */     // MIs[0] clamp
     /* 246374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246398 */     // (intrinsic_wo_chain:{ *:[i32] } 3404:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_U32_U16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 246398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
     /* 246401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 246408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 246413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 246418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 246423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 246428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 246433 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246447 */     GIR_RootConstrainSelectedInstOperands,
     /* 246448 */     // GIR_Coverage, 1117,
     /* 246448 */     GIR_EraseRootFromParent_Done,
     /* 246449 */   // Label 4019: @246449
     /* 246449 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(246553), // Rule ID 1118 //
     /* 246454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot10Insts),
     /* 246457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
     /* 246462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 246468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 246471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246478 */     // MIs[0] clamp
     /* 246478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246502 */     // (intrinsic_wo_chain:{ *:[f32] } 2303:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_F32_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 246502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F32_F16),
     /* 246505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 246512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 246517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 246522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 246527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 246532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 246537 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246551 */     GIR_RootConstrainSelectedInstOperands,
     /* 246552 */     // GIR_Coverage, 1118,
     /* 246552 */     GIR_EraseRootFromParent_Done,
     /* 246553 */   // Label 4020: @246553
     /* 246553 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(246651), // Rule ID 1120 //
     /* 246558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /* 246561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot4),
     /* 246566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246582 */     // MIs[0] clamp
     /* 246582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246606 */     // (intrinsic_wo_chain:{ *:[i32] } 3405:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_U32_U8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 246606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
     /* 246609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 246616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 246621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 246626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 246631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 246636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 246641 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246649 */     GIR_RootConstrainSelectedInstOperands,
     /* 246650 */     // GIR_Coverage, 1120,
     /* 246650 */     GIR_EraseRootFromParent_Done,
     /* 246651 */   // Label 4021: @246651
     /* 246651 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(246749), // Rule ID 1121 //
     /* 246656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
     /* 246659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot8),
     /* 246664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246680 */     // MIs[0] clamp
     /* 246680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246704 */     // (intrinsic_wo_chain:{ *:[i32] } 3406:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_U32_U4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 246704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_U32_U4),
     /* 246707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 246714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 246719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 246724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 246729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 246734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 246739 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246747 */     GIR_RootConstrainSelectedInstOperands,
     /* 246748 */     // GIR_Coverage, 1121,
     /* 246748 */     GIR_EraseRootFromParent_Done,
     /* 246749 */   // Label 4022: @246749
     /* 246749 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(246847), // Rule ID 1122 //
     /* 246754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /* 246757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
     /* 246762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246778 */     // MIs[0] clamp
     /* 246778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246802 */     // (intrinsic_wo_chain:{ *:[i32] } 3301:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_I8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 246802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
     /* 246805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 246812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 246817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 246822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 246827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 246832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 246837 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246845 */     GIR_RootConstrainSelectedInstOperands,
     /* 246846 */     // GIR_Coverage, 1122,
     /* 246846 */     GIR_EraseRootFromParent_Done,
     /* 246847 */   // Label 4023: @246847
     /* 246847 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(246945), // Rule ID 1123 //
     /* 246852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
     /* 246855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
     /* 246860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 246863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 246866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246876 */     // MIs[0] clamp
     /* 246876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
     /* 246900 */     // (intrinsic_wo_chain:{ *:[i32] } 3302:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_I4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
     /* 246900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_I4),
     /* 246903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 246910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 246915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 246920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 246925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 246930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 246935 */     GIR_RootToRootCopy, /*OpIdx*/5, // clamp
     /* 246937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 246943 */     GIR_RootConstrainSelectedInstOperands,
     /* 246944 */     // GIR_Coverage, 1123,
     /* 246944 */     GIR_EraseRootFromParent_Done,
     /* 246945 */   // Label 4024: @246945
     /* 246945 */   GIM_Reject,
     /* 246946 */ // Label 3964: @246946
     /* 246946 */ GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(247963),
     /* 246951 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 246954 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(247022), // Rule ID 2636 //
     /* 246959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
     /* 246964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 246967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 246970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 246973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 246976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 246980 */     // MIs[0] src_sel
     /* 246980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246983 */     // MIs[0] Operand 6
     /* 246983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
     /* 246994 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2210:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 246994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
     /* 246997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 246999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
     /* 247005 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
     /* 247013 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247015 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247020 */     GIR_RootConstrainSelectedInstOperands,
     /* 247021 */     // GIR_Coverage, 2636,
     /* 247021 */     GIR_EraseRootFromParent_Done,
     /* 247022 */   // Label 4026: @247022
     /* 247022 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(247090), // Rule ID 2637 //
     /* 247027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
     /* 247032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 247035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 247038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247048 */     // MIs[0] src_sel
     /* 247048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247051 */     // MIs[0] Operand 6
     /* 247051 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
     /* 247062 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2209:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 247062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
     /* 247065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
     /* 247073 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
     /* 247081 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247083 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247088 */     GIR_RootConstrainSelectedInstOperands,
     /* 247089 */     // GIR_Coverage, 2637,
     /* 247089 */     GIR_EraseRootFromParent_Done,
     /* 247090 */   // Label 4027: @247090
     /* 247090 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(247158), // Rule ID 2638 //
     /* 247095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
     /* 247100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 247103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 247106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247116 */     // MIs[0] src_sel
     /* 247116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247119 */     // MIs[0] Operand 6
     /* 247119 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
     /* 247130 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2210:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 247130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
     /* 247133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
     /* 247141 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
     /* 247149 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247151 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247156 */     GIR_RootConstrainSelectedInstOperands,
     /* 247157 */     // GIR_Coverage, 2638,
     /* 247157 */     GIR_EraseRootFromParent_Done,
     /* 247158 */   // Label 4028: @247158
     /* 247158 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(247226), // Rule ID 2639 //
     /* 247163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
     /* 247168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 247171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 247174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247184 */     // MIs[0] src_sel
     /* 247184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247187 */     // MIs[0] Operand 6
     /* 247187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
     /* 247198 */     // (intrinsic_wo_chain:{ *:[v2f16] } 2209:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 247198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
     /* 247201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247203 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
     /* 247209 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
     /* 247217 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247219 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247224 */     GIR_RootConstrainSelectedInstOperands,
     /* 247225 */     // GIR_Coverage, 2639,
     /* 247225 */     GIR_EraseRootFromParent_Done,
     /* 247226 */   // Label 4029: @247226
     /* 247226 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(247294), // Rule ID 1330 //
     /* 247231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
     /* 247234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2),
     /* 247239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 247251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247255 */     // MIs[0] attrchan
     /* 247255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 247258 */     // MIs[0] attr
     /* 247258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247261 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 247265 */     // (intrinsic_wo_chain:{ *:[f32] } 3103:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P2_F32:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
     /* 247265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247269 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
     /* 247279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32),
     /* 247282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 247286 */     GIR_RootToRootCopy, /*OpIdx*/3, // vsrc
     /* 247288 */     GIR_RootToRootCopy, /*OpIdx*/5, // attr
     /* 247290 */     GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
     /* 247292 */     GIR_RootConstrainSelectedInstOperands,
     /* 247293 */     // GIR_Coverage, 1330,
     /* 247293 */     GIR_EraseRootFromParent_Done,
     /* 247294 */   // Label 4030: @247294
     /* 247294 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(247356), // Rule ID 2640 //
     /* 247299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f32),
     /* 247304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 247307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 247310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247323 */     // MIs[0] word_sel
     /* 247323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247326 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2230:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 247326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F32_e64),
     /* 247329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 247337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247342 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247347 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247349 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247354 */     GIR_RootConstrainSelectedInstOperands,
     /* 247355 */     // GIR_Coverage, 2640,
     /* 247355 */     GIR_EraseRootFromParent_Done,
     /* 247356 */   // Label 4031: @247356
     /* 247356 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(247418), // Rule ID 2641 //
     /* 247361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f32),
     /* 247366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 247369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 247372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247385 */     // MIs[0] word_sel
     /* 247385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247388 */     // (intrinsic_wo_chain:{ *:[v2i16] } 2218:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 247388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F32_e64),
     /* 247391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247393 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
     /* 247399 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247404 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247409 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247411 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247416 */     GIR_RootConstrainSelectedInstOperands,
     /* 247417 */     // GIR_Coverage, 2641,
     /* 247417 */     GIR_EraseRootFromParent_Done,
     /* 247418 */   // Label 4032: @247418
     /* 247418 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(247483), // Rule ID 2649 //
     /* 247423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f32),
     /* 247428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247447 */     // MIs[0] index
     /* 247447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247450 */     // (intrinsic_wo_chain:{ *:[i32] } 2227:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 247450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F32_e64),
     /* 247453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247455 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 247461 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247466 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 247474 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247476 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247481 */     GIR_RootConstrainSelectedInstOperands,
     /* 247482 */     // GIR_Coverage, 2649,
     /* 247482 */     GIR_EraseRootFromParent_Done,
     /* 247483 */   // Label 4033: @247483
     /* 247483 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(247548), // Rule ID 2651 //
     /* 247488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f16),
     /* 247493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 247502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247512 */     // MIs[0] index
     /* 247512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247515 */     // (intrinsic_wo_chain:{ *:[i32] } 2248:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 247515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F16_e64),
     /* 247518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 247526 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247531 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 247539 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247541 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247546 */     GIR_RootConstrainSelectedInstOperands,
     /* 247547 */     // GIR_Coverage, 2651,
     /* 247547 */     GIR_EraseRootFromParent_Done,
     /* 247548 */   // Label 4034: @247548
     /* 247548 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(247613), // Rule ID 2652 //
     /* 247553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f32),
     /* 247558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 247567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247577 */     // MIs[0] index
     /* 247577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247580 */     // (intrinsic_wo_chain:{ *:[i32] } 2249:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 247580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F32_e64),
     /* 247583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 247591 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247596 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 247604 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247606 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247611 */     GIR_RootConstrainSelectedInstOperands,
     /* 247612 */     // GIR_Coverage, 2652,
     /* 247612 */     GIR_EraseRootFromParent_Done,
     /* 247613 */   // Label 4035: @247613
     /* 247613 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(247678), // Rule ID 2653 //
     /* 247618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f16),
     /* 247623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 247632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247642 */     // MIs[0] index
     /* 247642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247645 */     // (intrinsic_wo_chain:{ *:[i32] } 2242:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 247645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F16_e64),
     /* 247648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 247656 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247661 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247663 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 247669 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247671 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247676 */     GIR_RootConstrainSelectedInstOperands,
     /* 247677 */     // GIR_Coverage, 2653,
     /* 247677 */     GIR_EraseRootFromParent_Done,
     /* 247678 */   // Label 4036: @247678
     /* 247678 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(247743), // Rule ID 2654 //
     /* 247683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f32),
     /* 247688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247707 */     // MIs[0] index
     /* 247707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247710 */     // (intrinsic_wo_chain:{ *:[i32] } 2243:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 247710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F32_e64),
     /* 247713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 247721 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247726 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 247734 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247736 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247741 */     GIR_RootConstrainSelectedInstOperands,
     /* 247742 */     // GIR_Coverage, 2654,
     /* 247742 */     GIR_EraseRootFromParent_Done,
     /* 247743 */   // Label 4037: @247743
     /* 247743 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(247808), // Rule ID 2655 //
     /* 247748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f16),
     /* 247753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 247762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247772 */     // MIs[0] index
     /* 247772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247775 */     // (intrinsic_wo_chain:{ *:[i32] } 2245:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 247775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F16_e64),
     /* 247778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 247786 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247791 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 247799 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247801 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247806 */     GIR_RootConstrainSelectedInstOperands,
     /* 247807 */     // GIR_Coverage, 2655,
     /* 247807 */     GIR_EraseRootFromParent_Done,
     /* 247808 */   // Label 4038: @247808
     /* 247808 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(247873), // Rule ID 2656 //
     /* 247813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f32),
     /* 247818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 247830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247837 */     // MIs[0] index
     /* 247837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 247840 */     // (intrinsic_wo_chain:{ *:[i32] } 2246:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 247840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F32_e64),
     /* 247843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
     /* 247851 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 247853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247856 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 247858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
     /* 247864 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 247866 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 247868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247871 */     GIR_RootConstrainSelectedInstOperands,
     /* 247872 */     // GIR_Coverage, 2656,
     /* 247872 */     GIR_EraseRootFromParent_Done,
     /* 247873 */   // Label 4039: @247873
     /* 247873 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(247962), // Rule ID 1018 //
     /* 247878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus),
     /* 247881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1_f16),
     /* 247886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 247892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 247895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 247899 */     // MIs[0] attrchan
     /* 247899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 247902 */     // MIs[0] attr
     /* 247902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 247905 */     // MIs[0] high
     /* 247905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 247908 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 247912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 247919 */     // (intrinsic_wo_chain:{ *:[f32] } 3101:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P1LL_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i1] }):$high)
     /* 247919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 247923 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 247929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
     /* 247933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1LL_F16),
     /* 247936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 247938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 247943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 247948 */     GIR_RootToRootCopy, /*OpIdx*/4, // attr
     /* 247950 */     GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
     /* 247952 */     GIR_RootToRootCopy, /*OpIdx*/5, // high
     /* 247954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 247960 */     GIR_RootConstrainSelectedInstOperands,
     /* 247961 */     // GIR_Coverage, 1018,
     /* 247961 */     GIR_EraseRootFromParent_Done,
     /* 247962 */   // Label 4040: @247962
     /* 247962 */   GIM_Reject,
     /* 247963 */ // Label 4025: @247963
     /* 247963 */ GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(248238),
     /* 247968 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 247971 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(248051), // Rule ID 2755 //
     /* 247976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 247979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot4),
     /* 247984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 247987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 247990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 247993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 247996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248000 */     // MIs[0] clamp
     /* 248000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 248003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 248010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 248017 */     // (intrinsic_wo_chain:{ *:[i32] } 3389:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 248017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
     /* 248020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
     /* 248027 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
     /* 248034 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 248036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 248039 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 248041 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 248043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248049 */     GIR_RootConstrainSelectedInstOperands,
     /* 248050 */     // GIR_Coverage, 2755,
     /* 248050 */     GIR_EraseRootFromParent_Done,
     /* 248051 */   // Label 4042: @248051
     /* 248051 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(248131), // Rule ID 2756 //
     /* 248056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
     /* 248059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot8),
     /* 248064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 248073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 248076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248080 */     // MIs[0] clamp
     /* 248080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 248083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 248090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 248097 */     // (intrinsic_wo_chain:{ *:[i32] } 3390:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 248097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
     /* 248100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
     /* 248107 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 248109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
     /* 248114 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 248116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 248119 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 248121 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 248123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248129 */     GIR_RootConstrainSelectedInstOperands,
     /* 248130 */     // GIR_Coverage, 2756,
     /* 248130 */     GIR_EraseRootFromParent_Done,
     /* 248131 */   // Label 4043: @248131
     /* 248131 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(248237), // Rule ID 1017 //
     /* 248136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isNotGFX90APlus),
     /* 248139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_f16),
     /* 248144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 248147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 248150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 248153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 248156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 248160 */     // MIs[0] attrchan
     /* 248160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 248163 */     // MIs[0] attr
     /* 248163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 248166 */     // MIs[0] high
     /* 248166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 248169 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 248173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 248180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 248187 */     // (intrinsic_wo_chain:{ *:[f16] } 3104:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P2_F16:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$high)
     /* 248187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 248191 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 248197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // M0
     /* 248201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16),
     /* 248204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 248206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 248211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 248216 */     GIR_RootToRootCopy, /*OpIdx*/5, // attr
     /* 248218 */     GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
     /* 248220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 248225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 248230 */     GIR_RootToRootCopy, /*OpIdx*/6, // high
     /* 248232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248235 */     GIR_RootConstrainSelectedInstOperands,
     /* 248236 */     // GIR_Coverage, 1017,
     /* 248236 */     GIR_EraseRootFromParent_Done,
     /* 248237 */   // Label 4044: @248237
     /* 248237 */   GIM_Reject,
     /* 248238 */ // Label 4041: @248238
     /* 248238 */ GIM_Reject,
     /* 248239 */ // Label 37: @248239
     /* 248239 */ GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(248413),
     /* 248244 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 248247 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(248262), // Rule ID 1315 //
     /* 248252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv),
     /* 248257 */     // (intrinsic_void 3258:{ *:[iPTR] })  =>  (S_DCACHE_INV)
     /* 248257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV),
     /* 248260 */     GIR_RootConstrainSelectedInstOperands,
     /* 248261 */     // GIR_Coverage, 1315,
     /* 248261 */     GIR_EraseRootFromParent_Done,
     /* 248262 */   // Label 4046: @248262
     /* 248262 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(248280), // Rule ID 1316 //
     /* 248267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7GFX8GFX9),
     /* 248270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv_vol),
     /* 248275 */     // (intrinsic_void 3259:{ *:[iPTR] })  =>  (S_DCACHE_INV_VOL)
     /* 248275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV_VOL),
     /* 248278 */     GIR_RootConstrainSelectedInstOperands,
     /* 248279 */     // GIR_Coverage, 1316,
     /* 248279 */     GIR_EraseRootFromParent_Done,
     /* 248280 */   // Label 4047: @248280
     /* 248280 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(248298), // Rule ID 1317 //
     /* 248285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
     /* 248288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb),
     /* 248293 */     // (intrinsic_void 3260:{ *:[iPTR] })  =>  (S_DCACHE_WB)
     /* 248293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB),
     /* 248296 */     GIR_RootConstrainSelectedInstOperands,
     /* 248297 */     // GIR_Coverage, 1317,
     /* 248297 */     GIR_EraseRootFromParent_Done,
     /* 248298 */   // Label 4048: @248298
     /* 248298 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(248316), // Rule ID 1318 //
     /* 248303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
     /* 248306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb_vol),
     /* 248311 */     // (intrinsic_void 3261:{ *:[iPTR] })  =>  (S_DCACHE_WB_VOL)
     /* 248311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB_VOL),
     /* 248314 */     GIR_RootConstrainSelectedInstOperands,
     /* 248315 */     // GIR_Coverage, 1318,
     /* 248315 */     GIR_EraseRootFromParent_Done,
     /* 248316 */   // Label 4049: @248316
     /* 248316 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(248334), // Rule ID 1325 //
     /* 248321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
     /* 248324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_sc),
     /* 248329 */     // (intrinsic_void 2185:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_SC)
     /* 248329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_SC),
     /* 248332 */     GIR_RootConstrainSelectedInstOperands,
     /* 248333 */     // GIR_Coverage, 1325,
     /* 248333 */     GIR_EraseRootFromParent_Done,
     /* 248334 */   // Label 4050: @248334
     /* 248334 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(248352), // Rule ID 1326 //
     /* 248339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
     /* 248342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1),
     /* 248347 */     // (intrinsic_void 2184:{ *:[iPTR] })  =>  (BUFFER_WBINVL1)
     /* 248347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1),
     /* 248350 */     GIR_RootConstrainSelectedInstOperands,
     /* 248351 */     // GIR_Coverage, 1326,
     /* 248351 */     GIR_EraseRootFromParent_Done,
     /* 248352 */   // Label 4051: @248352
     /* 248352 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(248370), // Rule ID 1327 //
     /* 248357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
     /* 248360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_vol),
     /* 248365 */     // (intrinsic_void 2186:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_VOL)
     /* 248365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_VOL),
     /* 248368 */     GIR_RootConstrainSelectedInstOperands,
     /* 248369 */     // GIR_Coverage, 1327,
     /* 248369 */     GIR_EraseRootFromParent_Done,
     /* 248370 */   // Label 4052: @248370
     /* 248370 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(248391), // Rule ID 1872 //
     /* 248375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 248378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
     /* 248383 */     // (intrinsic_void 3286:{ *:[iPTR] })  =>  (S_WAIT_EVENT 0:{ *:[i16] })
     /* 248383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
     /* 248386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 248389 */     GIR_RootConstrainSelectedInstOperands,
     /* 248390 */     // GIR_Coverage, 1872,
     /* 248390 */     GIR_EraseRootFromParent_Done,
     /* 248391 */   // Label 4053: @248391
     /* 248391 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(248412), // Rule ID 1873 //
     /* 248396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 248399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
     /* 248404 */     // (intrinsic_void 3286:{ *:[iPTR] })  =>  (S_WAIT_EVENT 2:{ *:[i16] })
     /* 248404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
     /* 248407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 248410 */     GIR_RootConstrainSelectedInstOperands,
     /* 248411 */     // GIR_Coverage, 1873,
     /* 248411 */     GIR_EraseRootFromParent_Done,
     /* 248412 */   // Label 4054: @248412
     /* 248412 */   GIM_Reject,
     /* 248413 */ // Label 4045: @248413
     /* 248413 */ GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(249130),
     /* 248418 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 248421 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(248479), // Rule ID 6973 //
     /* 248426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
     /* 248431 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 248434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 248438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 248442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 248446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 248450 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 248454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248456 */     // (intrinsic_void 3110:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
     /* 248456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
     /* 248459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 248463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 248466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 248469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 248472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248477 */     GIR_RootConstrainSelectedInstOperands,
     /* 248478 */     // GIR_Coverage, 6973,
     /* 248478 */     GIR_EraseRootFromParent_Done,
     /* 248479 */   // Label 4056: @248479
     /* 248479 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(248537), // Rule ID 6976 //
     /* 248484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
     /* 248489 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 248492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 248496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 248500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /* 248504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /* 248508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 248512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248514 */     // (intrinsic_void 3434:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
     /* 248514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
     /* 248517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 248521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 248524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 248527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 248530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248535 */     GIR_RootConstrainSelectedInstOperands,
     /* 248536 */     // GIR_Coverage, 6976,
     /* 248536 */     GIR_EraseRootFromParent_Done,
     /* 248537 */   // Label 4057: @248537
     /* 248537 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(248557), // Rule ID 178 //
     /* 248542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_nop),
     /* 248547 */     // MIs[0] simm16
     /* 248547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248550 */     // (intrinsic_void 3271:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_NOP (timm:{ *:[i16] }):$simm16)
     /* 248550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOP),
     /* 248553 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248555 */     GIR_RootConstrainSelectedInstOperands,
     /* 248556 */     // GIR_Coverage, 178,
     /* 248556 */     GIR_EraseRootFromParent_Done,
     /* 248557 */   // Label 4058: @248557
     /* 248557 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(248577), // Rule ID 183 //
     /* 248562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_waitcnt),
     /* 248567 */     // MIs[0] simm16
     /* 248567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248570 */     // (intrinsic_void 3292:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_WAITCNT (timm:{ *:[i32] }):$simm16)
     /* 248570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAITCNT),
     /* 248573 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248575 */     GIR_RootConstrainSelectedInstOperands,
     /* 248576 */     // GIR_Coverage, 183,
     /* 248576 */     GIR_EraseRootFromParent_Done,
     /* 248577 */   // Label 4059: @248577
     /* 248577 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(248597), // Rule ID 184 //
     /* 248582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sethalt),
     /* 248587 */     // MIs[0] simm16
     /* 248587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248590 */     // (intrinsic_void 3277:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SETHALT (timm:{ *:[i32] }):$simm16)
     /* 248590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETHALT),
     /* 248593 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248595 */     GIR_RootConstrainSelectedInstOperands,
     /* 248596 */     // GIR_Coverage, 184,
     /* 248596 */     GIR_EraseRootFromParent_Done,
     /* 248597 */   // Label 4060: @248597
     /* 248597 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(248617), // Rule ID 185 //
     /* 248602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep),
     /* 248607 */     // MIs[0] simm16
     /* 248607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248610 */     // (intrinsic_void 3280:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SLEEP (timm:{ *:[i32] }):$simm16)
     /* 248610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP),
     /* 248613 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248615 */     GIR_RootConstrainSelectedInstOperands,
     /* 248616 */     // GIR_Coverage, 185,
     /* 248616 */     GIR_EraseRootFromParent_Done,
     /* 248617 */   // Label 4061: @248617
     /* 248617 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(248637), // Rule ID 187 //
     /* 248622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setprio),
     /* 248627 */     // MIs[0] simm16
     /* 248627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248630 */     // (intrinsic_void 3278:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_SETPRIO (timm:{ *:[i16] }):$simm16)
     /* 248630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETPRIO),
     /* 248633 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248635 */     GIR_RootConstrainSelectedInstOperands,
     /* 248636 */     // GIR_Coverage, 187,
     /* 248636 */     GIR_EraseRootFromParent_Done,
     /* 248637 */   // Label 4062: @248637
     /* 248637 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(248657), // Rule ID 190 //
     /* 248642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_incperflevel),
     /* 248647 */     // MIs[0] simm16
     /* 248647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248650 */     // (intrinsic_void 3268:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_INCPERFLEVEL (timm:{ *:[i32] }):$simm16)
     /* 248650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INCPERFLEVEL),
     /* 248653 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248655 */     GIR_RootConstrainSelectedInstOperands,
     /* 248656 */     // GIR_Coverage, 190,
     /* 248656 */     GIR_EraseRootFromParent_Done,
     /* 248657 */   // Label 4063: @248657
     /* 248657 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(248677), // Rule ID 191 //
     /* 248662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_decperflevel),
     /* 248667 */     // MIs[0] simm16
     /* 248667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248670 */     // (intrinsic_void 3262:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_DECPERFLEVEL (timm:{ *:[i32] }):$simm16)
     /* 248670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DECPERFLEVEL),
     /* 248673 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248675 */     GIR_RootConstrainSelectedInstOperands,
     /* 248676 */     // GIR_Coverage, 191,
     /* 248676 */     GIR_EraseRootFromParent_Done,
     /* 248677 */   // Label 4064: @248677
     /* 248677 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(248700), // Rule ID 194 //
     /* 248682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 248685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata_imm),
     /* 248690 */     // MIs[0] simm16
     /* 248690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248693 */     // (intrinsic_void 3283:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_TTRACEDATA_IMM (timm:{ *:[i16] }):$simm16)
     /* 248693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA_IMM),
     /* 248696 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248698 */     GIR_RootConstrainSelectedInstOperands,
     /* 248699 */     // GIR_Coverage, 194,
     /* 248699 */     GIR_EraseRootFromParent_Done,
     /* 248700 */   // Label 4065: @248700
     /* 248700 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(248723), // Rule ID 195 //
     /* 248705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 248708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_loadcnt),
     /* 248713 */     // MIs[0] simm16
     /* 248713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248716 */     // (intrinsic_void 3289:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_LOADCNT (timm:{ *:[i16] }):$simm16)
     /* 248716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_LOADCNT),
     /* 248719 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248721 */     GIR_RootConstrainSelectedInstOperands,
     /* 248722 */     // GIR_Coverage, 195,
     /* 248722 */     GIR_EraseRootFromParent_Done,
     /* 248723 */   // Label 4066: @248723
     /* 248723 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(248746), // Rule ID 196 //
     /* 248728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 248731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_storecnt),
     /* 248736 */     // MIs[0] simm16
     /* 248736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248739 */     // (intrinsic_void 3291:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_STORECNT (timm:{ *:[i16] }):$simm16)
     /* 248739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_STORECNT),
     /* 248742 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248744 */     GIR_RootConstrainSelectedInstOperands,
     /* 248745 */     // GIR_Coverage, 196,
     /* 248745 */     GIR_EraseRootFromParent_Done,
     /* 248746 */   // Label 4067: @248746
     /* 248746 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(248769), // Rule ID 197 //
     /* 248751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
     /* 248754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_samplecnt),
     /* 248759 */     // MIs[0] simm16
     /* 248759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248762 */     // (intrinsic_void 3290:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_SAMPLECNT (timm:{ *:[i16] }):$simm16)
     /* 248762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_SAMPLECNT),
     /* 248765 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248767 */     GIR_RootConstrainSelectedInstOperands,
     /* 248768 */     // GIR_Coverage, 197,
     /* 248768 */     GIR_EraseRootFromParent_Done,
     /* 248769 */   // Label 4068: @248769
     /* 248769 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(248792), // Rule ID 198 //
     /* 248774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
     /* 248777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_bvhcnt),
     /* 248782 */     // MIs[0] simm16
     /* 248782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248785 */     // (intrinsic_void 3284:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_BVHCNT (timm:{ *:[i16] }):$simm16)
     /* 248785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_BVHCNT),
     /* 248788 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248790 */     GIR_RootConstrainSelectedInstOperands,
     /* 248791 */     // GIR_Coverage, 198,
     /* 248791 */     GIR_EraseRootFromParent_Done,
     /* 248792 */   // Label 4069: @248792
     /* 248792 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(248815), // Rule ID 199 //
     /* 248797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExportInsts_isGFX12Plus),
     /* 248800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_expcnt),
     /* 248805 */     // MIs[0] simm16
     /* 248805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248808 */     // (intrinsic_void 3287:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_EXPCNT (timm:{ *:[i16] }):$simm16)
     /* 248808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EXPCNT),
     /* 248811 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248813 */     GIR_RootConstrainSelectedInstOperands,
     /* 248814 */     // GIR_Coverage, 199,
     /* 248814 */     GIR_EraseRootFromParent_Done,
     /* 248815 */   // Label 4070: @248815
     /* 248815 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(248838), // Rule ID 200 //
     /* 248820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 248823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_dscnt),
     /* 248828 */     // MIs[0] simm16
     /* 248828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248831 */     // (intrinsic_void 3285:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_DSCNT (timm:{ *:[i16] }):$simm16)
     /* 248831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_DSCNT),
     /* 248834 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248836 */     GIR_RootConstrainSelectedInstOperands,
     /* 248837 */     // GIR_Coverage, 200,
     /* 248837 */     GIR_EraseRootFromParent_Done,
     /* 248838 */   // Label 4071: @248838
     /* 248838 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(248861), // Rule ID 201 //
     /* 248843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 248846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_kmcnt),
     /* 248851 */     // MIs[0] simm16
     /* 248851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248854 */     // (intrinsic_void 3288:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_KMCNT (timm:{ *:[i16] }):$simm16)
     /* 248854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_KMCNT),
     /* 248857 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 248859 */     GIR_RootConstrainSelectedInstOperands,
     /* 248860 */     // GIR_Coverage, 201,
     /* 248860 */     GIR_EraseRootFromParent_Done,
     /* 248861 */   // Label 4072: @248861
     /* 248861 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(248888), // Rule ID 1314 //
     /* 248866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
     /* 248869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memtime),
     /* 248874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 248877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 248881 */     // (intrinsic_w_chain:{ *:[i64] } 3270:{ *:[iPTR] })  =>  (S_MEMTIME:{ *:[i64] })
     /* 248881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
     /* 248884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 248886 */     GIR_RootConstrainSelectedInstOperands,
     /* 248887 */     // GIR_Coverage, 1314,
     /* 248887 */     GIR_EraseRootFromParent_Done,
     /* 248888 */   // Label 4073: @248888
     /* 248888 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(248915), // Rule ID 1319 //
     /* 248893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
     /* 248896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memrealtime),
     /* 248901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 248904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 248908 */     // (intrinsic_w_chain:{ *:[i64] } 3269:{ *:[iPTR] })  =>  (S_MEMREALTIME:{ *:[i64] })
     /* 248908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
     /* 248911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 248913 */     GIR_RootConstrainSelectedInstOperands,
     /* 248914 */     // GIR_Coverage, 1319,
     /* 248914 */     GIR_EraseRootFromParent_Done,
     /* 248915 */   // Label 4074: @248915
     /* 248915 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(248942), // Rule ID 1320 //
     /* 248920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGetWaveIdInst),
     /* 248923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_get_waveid_in_workgroup),
     /* 248928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 248935 */     // (intrinsic_w_chain:{ *:[i32] } 3265:{ *:[iPTR] })  =>  (S_GET_WAVEID_IN_WORKGROUP:{ *:[i32] })
     /* 248935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GET_WAVEID_IN_WORKGROUP),
     /* 248938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 248940 */     GIR_RootConstrainSelectedInstOperands,
     /* 248941 */     // GIR_Coverage, 1320,
     /* 248941 */     GIR_EraseRootFromParent_Done,
     /* 248942 */   // Label 4075: @248942
     /* 248942 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(248970), // Rule ID 1352 //
     /* 248947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_live_mask),
     /* 248952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 248955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 248959 */     // (intrinsic_w_chain:{ *:[i1] } 3115:{ *:[iPTR] })  =>  (SI_LIVE_MASK:{ *:[i1] })
     /* 248959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_LIVE_MASK),
     /* 248962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 248964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248968 */     GIR_RootConstrainSelectedInstOperands,
     /* 248969 */     // GIR_Coverage, 1352,
     /* 248969 */     GIR_EraseRootFromParent_Done,
     /* 248970 */   // Label 4076: @248970
     /* 248970 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(249003), // Rule ID 1876 //
     /* 248975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9GFX10),
     /* 248978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_pops_exiting_wave_id),
     /* 248983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 248986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 248990 */     // (intrinsic_w_chain:{ *:[i32] } 3187:{ *:[iPTR] })  =>  (S_MOV_B32_sideeffects:{ *:[i32] } SRC_POPS_EXITING_WAVE_ID:{ *:[i32] })
     /* 248990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32_sideeffects),
     /* 248993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 248995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SRC_POPS_EXITING_WAVE_ID), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 249001 */     GIR_RootConstrainSelectedInstOperands,
     /* 249002 */     // GIR_Coverage, 1876,
     /* 249002 */     GIR_EraseRootFromParent_Done,
     /* 249003 */   // Label 4077: @249003
     /* 249003 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(249027), // Rule ID 186 //
     /* 249008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep_var),
     /* 249013 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249020 */     // (intrinsic_void 3281:{ *:[iPTR] }, SSrc_b32:{ *:[i32] }:$src0)  =>  (S_SLEEP_VAR SSrc_b32:{ *:[i32] }:$src0)
     /* 249020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP_VAR),
     /* 249023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 249025 */     GIR_RootConstrainSelectedInstOperands,
     /* 249026 */     // GIR_Coverage, 186,
     /* 249026 */     GIR_EraseRootFromParent_Done,
     /* 249027 */   // Label 4078: @249027
     /* 249027 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(249063), // Rule ID 192 //
     /* 249032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata),
     /* 249037 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 249044 */     // (intrinsic_void 3282:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (S_TTRACEDATA)
     /* 249044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249048 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // M0
     /* 249058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA),
     /* 249061 */     GIR_RootConstrainSelectedInstOperands,
     /* 249062 */     // GIR_Coverage, 192,
     /* 249062 */     GIR_EraseRootFromParent_Done,
     /* 249063 */   // Label 4079: @249063
     /* 249063 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(249096), // Rule ID 6972 //
     /* 249068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
     /* 249073 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 249076 */     // (intrinsic_void 3110:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
     /* 249076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
     /* 249079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 249081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 249087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 249090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249094 */     GIR_RootConstrainSelectedInstOperands,
     /* 249095 */     // GIR_Coverage, 6972,
     /* 249095 */     GIR_EraseRootFromParent_Done,
     /* 249096 */   // Label 4080: @249096
     /* 249096 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(249129), // Rule ID 6975 //
     /* 249101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
     /* 249106 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 249109 */     // (intrinsic_void 3434:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
     /* 249109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
     /* 249112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 249114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 249120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
     /* 249123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249127 */     GIR_RootConstrainSelectedInstOperands,
     /* 249128 */     // GIR_Coverage, 6975,
     /* 249128 */     GIR_EraseRootFromParent_Done,
     /* 249129 */   // Label 4081: @249129
     /* 249129 */   GIM_Reject,
     /* 249130 */ // Label 4055: @249130
     /* 249130 */ GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(249696),
     /* 249135 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 249138 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(249207), // Rule ID 3546 //
     /* 249143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 249146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 249151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 249158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 249162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249166 */     // MIs[1] Operand 1
     /* 249166 */     // No operand predicates
     /* 249166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 249175 */     // (intrinsic_void 3272:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 249175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 249178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 249183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 249194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 249200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249205 */     GIR_RootConstrainSelectedInstOperands,
     /* 249206 */     // GIR_Coverage, 3546,
     /* 249206 */     GIR_EraseRootFromParent_Done,
     /* 249207 */   // Label 4083: @249207
     /* 249207 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(249262), // Rule ID 3544 //
     /* 249212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 249215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 249220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 249227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
     /* 249238 */     // (intrinsic_void 3272:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 249238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 249241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
     /* 249246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 249251 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 249253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249260 */     GIR_RootConstrainSelectedInstOperands,
     /* 249261 */     // GIR_Coverage, 3544,
     /* 249261 */     GIR_EraseRootFromParent_Done,
     /* 249262 */   // Label 4084: @249262
     /* 249262 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(249299), // Rule ID 119 //
     /* 249267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setreg),
     /* 249272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249275 */     // MIs[0] simm16
     /* 249275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SIMM16bit),
     /* 249283 */     // (intrinsic_void 3279:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_SIMM16bit>><<X:as_i16timm>>:$simm16, i32:{ *:[i32] }:$sdst)  =>  (S_SETREG_B32 i32:{ *:[i32] }:$sdst, (as_i16timm:{ *:[i32] } (timm:{ *:[i32] }):$simm16))
     /* 249283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETREG_B32),
     /* 249286 */     GIR_RootToRootCopy, /*OpIdx*/2, // sdst
     /* 249288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // simm16
     /* 249294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::MODE*/0,
     /* 249297 */     GIR_RootConstrainSelectedInstOperands,
     /* 249298 */     // GIR_Coverage, 119,
     /* 249298 */     GIR_EraseRootFromParent_Done,
     /* 249299 */   // Label 4085: @249299
     /* 249299 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(249331), // Rule ID 25 //
     /* 249304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 249307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
     /* 249312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249319 */     // MIs[0] src0
     /* 249319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 249322 */     // (intrinsic_w_chain:{ *:[i32] } 3275:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B32:{ *:[i32] } (timm:{ *:[i32] }):$src0)
     /* 249322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B32),
     /* 249325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249327 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249329 */     GIR_RootConstrainSelectedInstOperands,
     /* 249330 */     // GIR_Coverage, 25,
     /* 249330 */     GIR_EraseRootFromParent_Done,
     /* 249331 */   // Label 4086: @249331
     /* 249331 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(249363), // Rule ID 26 //
     /* 249336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 249339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
     /* 249344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249351 */     // MIs[0] src0
     /* 249351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 249354 */     // (intrinsic_w_chain:{ *:[i64] } 3275:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } (timm:{ *:[i32] }):$src0)
     /* 249354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
     /* 249357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 249361 */     GIR_RootConstrainSelectedInstOperands,
     /* 249362 */     // GIR_Coverage, 26,
     /* 249362 */     GIR_EraseRootFromParent_Done,
     /* 249363 */   // Label 4087: @249363
     /* 249363 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(249392), // Rule ID 118 //
     /* 249368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getreg),
     /* 249373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249380 */     // MIs[0] simm16
     /* 249380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 249383 */     // (intrinsic_w_chain:{ *:[i32] } 3267:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_GETREG_B32:{ *:[i32] } (timm:{ *:[i32] }):$simm16)
     /* 249383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 249386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 249388 */     GIR_RootToRootCopy, /*OpIdx*/2, // simm16
     /* 249390 */     GIR_RootConstrainSelectedInstOperands,
     /* 249391 */     // GIR_Coverage, 118,
     /* 249391 */     GIR_EraseRootFromParent_Done,
     /* 249392 */   // Label 4088: @249392
     /* 249392 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(249453), // Rule ID 3547 //
     /* 249397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 249400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 249405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249408 */     // MIs[0] sbase
     /* 249408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 249412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 249420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249424 */     // MIs[1] Operand 1
     /* 249424 */     // No operand predicates
     /* 249424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249426 */     // (intrinsic_void 3272:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 249426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 249429 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 249431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 249440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 249446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249451 */     GIR_RootConstrainSelectedInstOperands,
     /* 249452 */     // GIR_Coverage, 3547,
     /* 249452 */     GIR_EraseRootFromParent_Done,
     /* 249453 */   // Label 4089: @249453
     /* 249453 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(249494), // Rule ID 188 //
     /* 249458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg),
     /* 249463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249466 */     // MIs[0] simm16
     /* 249466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 249473 */     // (intrinsic_void 3274:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSG (timm:{ *:[i32] }):$simm16)
     /* 249473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249477 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 249487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG),
     /* 249490 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 249492 */     GIR_RootConstrainSelectedInstOperands,
     /* 249493 */     // GIR_Coverage, 188,
     /* 249493 */     GIR_EraseRootFromParent_Done,
     /* 249494 */   // Label 4090: @249494
     /* 249494 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(249535), // Rule ID 189 //
     /* 249499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsghalt),
     /* 249504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249507 */     // MIs[0] simm16
     /* 249507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 249514 */     // (intrinsic_void 3276:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSGHALT (timm:{ *:[i32] }):$simm16)
     /* 249514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249518 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 249528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSGHALT),
     /* 249531 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 249533 */     GIR_RootConstrainSelectedInstOperands,
     /* 249534 */     // GIR_Coverage, 189,
     /* 249534 */     GIR_EraseRootFromParent_Done,
     /* 249535 */   // Label 4091: @249535
     /* 249535 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(249590), // Rule ID 6924 //
     /* 249540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 249543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
     /* 249548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 249562 */     // (intrinsic_w_chain:{ *:[f32] } 3111:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (LDS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] })
     /* 249562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249566 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 249576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_DIRECT_LOAD),
     /* 249579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249588 */     GIR_RootConstrainSelectedInstOperands,
     /* 249589 */     // GIR_Coverage, 6924,
     /* 249589 */     GIR_EraseRootFromParent_Done,
     /* 249590 */   // Label 4092: @249590
     /* 249590 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(249648), // Rule ID 6926 //
     /* 249595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 249598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
     /* 249603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 249613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 249617 */     // (intrinsic_w_chain:{ *:[f32] } 3111:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (DS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] }, 1:{ *:[i32] })
     /* 249617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 249621 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
     /* 249631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DIRECT_LOAD),
     /* 249634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 249636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 249642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249646 */     GIR_RootConstrainSelectedInstOperands,
     /* 249647 */     // GIR_Coverage, 6926,
     /* 249647 */     GIR_EraseRootFromParent_Done,
     /* 249648 */   // Label 4093: @249648
     /* 249648 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(249695), // Rule ID 3545 //
     /* 249653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 249656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
     /* 249661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 249664 */     // MIs[0] sbase
     /* 249664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 249668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 249672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 249676 */     // (intrinsic_void 3272:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 249676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
     /* 249679 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 249681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249684 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 249686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249693 */     GIR_RootConstrainSelectedInstOperands,
     /* 249694 */     // GIR_Coverage, 3545,
     /* 249694 */     GIR_EraseRootFromParent_Done,
     /* 249695 */   // Label 4094: @249695
     /* 249695 */   GIM_Reject,
     /* 249696 */ // Label 4082: @249696
     /* 249696 */ GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(251858),
     /* 249701 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 249704 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(249774), // Rule ID 1322 //
     /* 249709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 249712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 249717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 249731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 249738 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 249738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_ADDR64_RTN),
     /* 249741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 249743 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 249745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 249750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 249755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 249760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 249765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 249768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249772 */     GIR_RootConstrainSelectedInstOperands,
     /* 249773 */     // GIR_Coverage, 1322,
     /* 249773 */     GIR_EraseRootFromParent_Done,
     /* 249774 */   // Label 4096: @249774
     /* 249774 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(249844), // Rule ID 1324 //
     /* 249779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 249782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 249787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 249801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 249808 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 249808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN),
     /* 249811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 249813 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 249815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 249820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 249825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 249830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 249835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 249838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249842 */     GIR_RootConstrainSelectedInstOperands,
     /* 249843 */     // GIR_Coverage, 1324,
     /* 249843 */     GIR_EraseRootFromParent_Done,
     /* 249844 */   // Label 4097: @249844
     /* 249844 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(249909), // Rule ID 1321 //
     /* 249849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 249852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 249857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 249871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 249878 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 249878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_OFFSET_RTN),
     /* 249881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 249883 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 249885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 249890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 249895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 249900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 249903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249907 */     GIR_RootConstrainSelectedInstOperands,
     /* 249908 */     // GIR_Coverage, 1321,
     /* 249908 */     GIR_EraseRootFromParent_Done,
     /* 249909 */   // Label 4098: @249909
     /* 249909 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(249974), // Rule ID 1323 //
     /* 249914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
     /* 249917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 249922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 249932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 249936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 249943 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
     /* 249943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN),
     /* 249946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 249948 */     GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
     /* 249950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 249955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 249960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 249965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 249968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249972 */     GIR_RootConstrainSelectedInstOperands,
     /* 249973 */     // GIR_Coverage, 1323,
     /* 249973 */     GIR_EraseRootFromParent_Done,
     /* 249974 */   // Label 4099: @249974
     /* 249974 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(250035), // Rule ID 7926 //
     /* 249979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 249982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 249987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 249990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 249993 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 249998 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 250011 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_local_addrspace>>  =>  (DS_COND_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 250011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_U32),
     /* 250014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 250019 */     GIR_RootToRootCopy, /*OpIdx*/3, // value
     /* 250021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 250026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250033 */     GIR_RootConstrainSelectedInstOperands,
     /* 250034 */     // GIR_Coverage, 7926,
     /* 250034 */     GIR_EraseRootFromParent_Done,
     /* 250035 */   // Label 4100: @250035
     /* 250035 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(250100), // Rule ID 7925 //
     /* 250040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 250043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 250048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250054 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
     /* 250059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 250063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 250074 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_local_addrspace>>  =>  (DS_COND_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9744:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 250074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_RTN_U32),
     /* 250077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 250084 */     GIR_RootToRootCopy, /*OpIdx*/3, // value
     /* 250086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 250091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250098 */     GIR_RootConstrainSelectedInstOperands,
     /* 250099 */     // GIR_Coverage, 7925,
     /* 250099 */     GIR_EraseRootFromParent_Done,
     /* 250100 */   // Label 4101: @250100
     /* 250100 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(250168), // Rule ID 4124 //
     /* 250105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 250108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 250113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250119 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 250126 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250139 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR),
     /* 250142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250147 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250166 */     GIR_RootConstrainSelectedInstOperands,
     /* 250167 */     // GIR_Coverage, 4124,
     /* 250167 */     GIR_EraseRootFromParent_Done,
     /* 250168 */   // Label 4102: @250168
     /* 250168 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(250229), // Rule ID 4068 //
     /* 250173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 250176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 250181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250187 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250200 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR),
     /* 250203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250208 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250227 */     GIR_RootConstrainSelectedInstOperands,
     /* 250228 */     // GIR_Coverage, 4068,
     /* 250228 */     GIR_EraseRootFromParent_Done,
     /* 250229 */   // Label 4103: @250229
     /* 250229 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(250290), // Rule ID 4152 //
     /* 250234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 250242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250248 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250261 */     // (intrinsic_w_chain:{ *:[f32] } 2319:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
     /* 250264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250269 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250288 */     GIR_RootConstrainSelectedInstOperands,
     /* 250289 */     // GIR_Coverage, 4152,
     /* 250289 */     GIR_EraseRootFromParent_Done,
     /* 250290 */   // Label 4104: @250290
     /* 250290 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(250351), // Rule ID 4156 //
     /* 250295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 250303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250309 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250322 */     // (intrinsic_w_chain:{ *:[f32] } 2318:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
     /* 250325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250330 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250349 */     GIR_RootConstrainSelectedInstOperands,
     /* 250350 */     // GIR_Coverage, 4156,
     /* 250350 */     GIR_EraseRootFromParent_Done,
     /* 250351 */   // Label 4105: @250351
     /* 250351 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(250423), // Rule ID 4122 //
     /* 250356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
     /* 250359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 250364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250370 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 250377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 250381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250392 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN),
     /* 250395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250402 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 250417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250421 */     GIR_RootConstrainSelectedInstOperands,
     /* 250422 */     // GIR_Coverage, 4122,
     /* 250422 */     GIR_EraseRootFromParent_Done,
     /* 250423 */   // Label 4106: @250423
     /* 250423 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(250488), // Rule ID 4066 //
     /* 250428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 250431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 250436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 250446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250457 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR_RTN),
     /* 250460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250467 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 250482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250486 */     GIR_RootConstrainSelectedInstOperands,
     /* 250487 */     // GIR_Coverage, 4066,
     /* 250487 */     GIR_EraseRootFromParent_Done,
     /* 250488 */   // Label 4107: @250488
     /* 250488 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(250553), // Rule ID 4126 //
     /* 250493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 250496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
     /* 250501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 250507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 250511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250522 */     // (intrinsic_w_chain:{ *:[i64] } 2320:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN),
     /* 250525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250532 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 250547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250551 */     GIR_RootConstrainSelectedInstOperands,
     /* 250552 */     // GIR_Coverage, 4126,
     /* 250552 */     GIR_EraseRootFromParent_Done,
     /* 250553 */   // Label 4108: @250553
     /* 250553 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(250618), // Rule ID 4154 //
     /* 250558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 250566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 250576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250587 */     // (intrinsic_w_chain:{ *:[f32] } 2319:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
     /* 250590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250597 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 250612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250616 */     GIR_RootConstrainSelectedInstOperands,
     /* 250617 */     // GIR_Coverage, 4154,
     /* 250617 */     GIR_EraseRootFromParent_Done,
     /* 250618 */   // Label 4109: @250618
     /* 250618 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(250683), // Rule ID 4158 //
     /* 250623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 250631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 250641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 250652 */     // (intrinsic_w_chain:{ *:[f32] } 2318:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 250652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
     /* 250655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 250662 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 250669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 250674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 250677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250681 */     GIR_RootConstrainSelectedInstOperands,
     /* 250682 */     // GIR_Coverage, 4158,
     /* 250682 */     GIR_EraseRootFromParent_Done,
     /* 250683 */   // Label 4110: @250683
     /* 250683 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(250746), // Rule ID 4123 //
     /* 250688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 250691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 250696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250702 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 250709 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 250722 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 250722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32),
     /* 250725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 250730 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 250737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250744 */     GIR_RootConstrainSelectedInstOperands,
     /* 250745 */     // GIR_Coverage, 4123,
     /* 250745 */     GIR_EraseRootFromParent_Done,
     /* 250746 */   // Label 4111: @250746
     /* 250746 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(250802), // Rule ID 4067 //
     /* 250751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 250754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 250759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250765 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 250778 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 250778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB),
     /* 250781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 250786 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 250793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250800 */     GIR_RootConstrainSelectedInstOperands,
     /* 250801 */     // GIR_Coverage, 4067,
     /* 250801 */     GIR_EraseRootFromParent_Done,
     /* 250802 */   // Label 4112: @250802
     /* 250802 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(250858), // Rule ID 4151 //
     /* 250807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 250815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250821 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 250834 */     // (intrinsic_w_chain:{ *:[f32] } 2319:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 250834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
     /* 250837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 250842 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 250849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250856 */     GIR_RootConstrainSelectedInstOperands,
     /* 250857 */     // GIR_Coverage, 4151,
     /* 250857 */     GIR_EraseRootFromParent_Done,
     /* 250858 */   // Label 4113: @250858
     /* 250858 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(250914), // Rule ID 4155 //
     /* 250863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 250866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 250871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250877 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 250879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 250890 */     // (intrinsic_w_chain:{ *:[f32] } 2318:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 250890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
     /* 250893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 250898 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 250905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250912 */     GIR_RootConstrainSelectedInstOperands,
     /* 250913 */     // GIR_Coverage, 4155,
     /* 250913 */     GIR_EraseRootFromParent_Done,
     /* 250914 */   // Label 4114: @250914
     /* 250914 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(250981), // Rule ID 4121 //
     /* 250919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
     /* 250922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 250927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 250933 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 250940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 250944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 250948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 250955 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 250955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_RTN),
     /* 250958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 250960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 250965 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 250967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 250972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 250975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250979 */     GIR_RootConstrainSelectedInstOperands,
     /* 250980 */     // GIR_Coverage, 4121,
     /* 250980 */     GIR_EraseRootFromParent_Done,
     /* 250981 */   // Label 4115: @250981
     /* 250981 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(251041), // Rule ID 4065 //
     /* 250986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 250989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
     /* 250994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 251004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 251015 */     // (intrinsic_w_chain:{ *:[i32] } 2317:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_RTN),
     /* 251018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251025 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251039 */     GIR_RootConstrainSelectedInstOperands,
     /* 251040 */     // GIR_Coverage, 4065,
     /* 251040 */     GIR_EraseRootFromParent_Done,
     /* 251041 */   // Label 4116: @251041
     /* 251041 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(251101), // Rule ID 4125 //
     /* 251046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 251049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
     /* 251054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 251060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 251064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 251075 */     // (intrinsic_w_chain:{ *:[i64] } 2320:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 251075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN),
     /* 251078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251085 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251099 */     GIR_RootConstrainSelectedInstOperands,
     /* 251100 */     // GIR_Coverage, 4125,
     /* 251100 */     GIR_EraseRootFromParent_Done,
     /* 251101 */   // Label 4117: @251101
     /* 251101 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(251161), // Rule ID 4153 //
     /* 251106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 251109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
     /* 251114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 251124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 251135 */     // (intrinsic_w_chain:{ *:[f32] } 2319:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
     /* 251138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251145 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251159 */     GIR_RootConstrainSelectedInstOperands,
     /* 251160 */     // GIR_Coverage, 4153,
     /* 251160 */     GIR_EraseRootFromParent_Done,
     /* 251161 */   // Label 4118: @251161
     /* 251161 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(251221), // Rule ID 4157 //
     /* 251166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 251169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
     /* 251174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 251184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 251195 */     // (intrinsic_w_chain:{ *:[f32] } 2318:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
     /* 251198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251205 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251219 */     GIR_RootConstrainSelectedInstOperands,
     /* 251220 */     // GIR_Coverage, 4157,
     /* 251220 */     GIR_EraseRootFromParent_Done,
     /* 251221 */   // Label 4119: @251221
     /* 251221 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(251263), // Rule ID 8463 //
     /* 251226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
     /* 251231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 251241 */     // MIs[0] offset32
     /* 251241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251244 */     // (intrinsic_w_chain:{ *:[i64] } 2270:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
     /* 251244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
     /* 251247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251249 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 251257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251261 */     GIR_RootConstrainSelectedInstOperands,
     /* 251262 */     // GIR_Coverage, 8463,
     /* 251262 */     GIR_EraseRootFromParent_Done,
     /* 251263 */   // Label 4120: @251263
     /* 251263 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(251357), // Rule ID 8464 //
     /* 251268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
     /* 251273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251283 */     // MIs[0] offset32
     /* 251283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251286 */     // (intrinsic_w_chain:{ *:[i32] } 2270:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 251286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 251289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
     /* 251293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
     /* 251302 */     GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 251308 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 251314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 251317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 251329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 251334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251339 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 251346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 251356 */     // GIR_Coverage, 8464,
     /* 251356 */     GIR_EraseRootFromParent_Done,
     /* 251357 */   // Label 4121: @251357
     /* 251357 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(251399), // Rule ID 8465 //
     /* 251362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
     /* 251367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 251377 */     // MIs[0] offset32
     /* 251377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251380 */     // (intrinsic_w_chain:{ *:[i64] } 2292:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
     /* 251380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
     /* 251383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251387 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 251393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251397 */     GIR_RootConstrainSelectedInstOperands,
     /* 251398 */     // GIR_Coverage, 8465,
     /* 251398 */     GIR_EraseRootFromParent_Done,
     /* 251399 */   // Label 4122: @251399
     /* 251399 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(251493), // Rule ID 8466 //
     /* 251404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
     /* 251409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 251415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251419 */     // MIs[0] offset32
     /* 251419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251422 */     // (intrinsic_w_chain:{ *:[i32] } 2292:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 251422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 251425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
     /* 251429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251434 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
     /* 251438 */     GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
     /* 251444 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 251450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 251453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251462 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 251465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 251470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 251475 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 251482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 251492 */     // GIR_Coverage, 8466,
     /* 251492 */     GIR_EraseRootFromParent_Done,
     /* 251493 */   // Label 4123: @251493
     /* 251493 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(251557), // Rule ID 3792 //
     /* 251498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
     /* 251501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 251506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251512 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 251520 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 251522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 251533 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32),
     /* 251536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251541 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251555 */     GIR_RootConstrainSelectedInstOperands,
     /* 251556 */     // GIR_Coverage, 3792,
     /* 251556 */     GIR_EraseRootFromParent_Done,
     /* 251557 */   // Label 4124: @251557
     /* 251557 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(251613), // Rule ID 4160 //
     /* 251562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 251565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
     /* 251570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251576 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 251578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 251589 */     // (intrinsic_w_chain:{ *:[f32] } 2309:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmin_num_noret>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
     /* 251592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251597 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251611 */     GIR_RootConstrainSelectedInstOperands,
     /* 251612 */     // GIR_Coverage, 4160,
     /* 251612 */     GIR_EraseRootFromParent_Done,
     /* 251613 */   // Label 4125: @251613
     /* 251613 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(251669), // Rule ID 4162 //
     /* 251618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 251621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
     /* 251626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251632 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 251634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 251645 */     // (intrinsic_w_chain:{ *:[f32] } 2308:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmax_num_noret>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
     /* 251648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251653 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 251663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251667 */     GIR_RootConstrainSelectedInstOperands,
     /* 251668 */     // GIR_Coverage, 4162,
     /* 251668 */     GIR_EraseRootFromParent_Done,
     /* 251669 */   // Label 4126: @251669
     /* 251669 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(251737), // Rule ID 3791 //
     /* 251674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_isGFX12Plus),
     /* 251677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
     /* 251682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251688 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 251696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 251700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 251711 */     // (intrinsic_w_chain:{ *:[i32] } 2181:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32_RTN),
     /* 251714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251721 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251735 */     GIR_RootConstrainSelectedInstOperands,
     /* 251736 */     // GIR_Coverage, 3791,
     /* 251736 */     GIR_EraseRootFromParent_Done,
     /* 251737 */   // Label 4127: @251737
     /* 251737 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(251797), // Rule ID 4159 //
     /* 251742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 251745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
     /* 251750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 251760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 251771 */     // (intrinsic_w_chain:{ *:[f32] } 2309:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
     /* 251774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251781 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251795 */     GIR_RootConstrainSelectedInstOperands,
     /* 251796 */     // GIR_Coverage, 4159,
     /* 251796 */     GIR_EraseRootFromParent_Done,
     /* 251797 */   // Label 4128: @251797
     /* 251797 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(251857), // Rule ID 4161 //
     /* 251802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 251805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
     /* 251810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 251816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 251820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 251824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 251831 */     // (intrinsic_w_chain:{ *:[f32] } 2308:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9744:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
     /* 251831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
     /* 251834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 251836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 251841 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /* 251843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 251848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251855 */     GIR_RootConstrainSelectedInstOperands,
     /* 251856 */     // GIR_Coverage, 4161,
     /* 251856 */     GIR_EraseRootFromParent_Done,
     /* 251857 */   // Label 4129: @251857
     /* 251857 */   GIM_Reject,
     /* 251858 */ // Label 4095: @251858
     /* 251858 */ GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(252192),
     /* 251863 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 251866 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_compr),
     /* 251871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 251874 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 251877 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251880 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 251883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251887 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 251891 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(251966), // Rule ID 6920 //
     /* 251896 */     // MIs[0] Operand 5
     /* 251896 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 251907 */     // MIs[0] vm
     /* 251907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 251910 */     // (intrinsic_void 2298:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 251910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 251913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 251924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 251927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 251938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 251941 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 251943 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 251945 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 251947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 251953 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 251955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 251958 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 251960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251964 */     GIR_RootConstrainSelectedInstOperands,
     /* 251965 */     // GIR_Coverage, 6920,
     /* 251965 */     GIR_EraseRootFromParent_Done,
     /* 251966 */   // Label 4131: @251966
     /* 251966 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(252041), // Rule ID 6921 //
     /* 251971 */     // MIs[0] Operand 5
     /* 251971 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 251982 */     // MIs[0] vm
     /* 251982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 251985 */     // (intrinsic_void 2298:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 251985 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 251988 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 251992 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 251999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 252002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 252006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 252016 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252018 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252020 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 252028 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 252030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 252033 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252039 */     GIR_RootConstrainSelectedInstOperands,
     /* 252040 */     // GIR_Coverage, 6921,
     /* 252040 */     GIR_EraseRootFromParent_Done,
     /* 252041 */   // Label 4132: @252041
     /* 252041 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(252116), // Rule ID 6922 //
     /* 252046 */     // MIs[0] Operand 5
     /* 252046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 252057 */     // MIs[0] vm
     /* 252057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 252060 */     // (intrinsic_void 2298:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252060 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 252063 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 252067 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 252074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 252077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 252081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 252091 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252093 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252095 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 252103 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 252105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 252108 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252114 */     GIR_RootConstrainSelectedInstOperands,
     /* 252115 */     // GIR_Coverage, 6922,
     /* 252115 */     GIR_EraseRootFromParent_Done,
     /* 252116 */   // Label 4133: @252116
     /* 252116 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(252191), // Rule ID 6923 //
     /* 252121 */     // MIs[0] Operand 5
     /* 252121 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
     /* 252132 */     // MIs[0] vm
     /* 252132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 252135 */     // (intrinsic_void 2298:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 252138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 252142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 252149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 252152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 252156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 252163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 252166 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252168 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252170 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 252178 */     GIR_RootToRootCopy, /*OpIdx*/6, // vm
     /* 252180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 252183 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252189 */     GIR_RootConstrainSelectedInstOperands,
     /* 252190 */     // GIR_Coverage, 6923,
     /* 252190 */     GIR_EraseRootFromParent_Done,
     /* 252191 */   // Label 4134: @252191
     /* 252191 */   GIM_Reject,
     /* 252192 */ // Label 4130: @252192
     /* 252192 */ GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(252949),
     /* 252197 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 252200 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(252284), // Rule ID 6912 //
     /* 252205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 252210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252222 */     // MIs[0] tgt
     /* 252222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252225 */     // MIs[0] en
     /* 252225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252240 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252244 */     // MIs[0] Operand 7
     /* 252244 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 252255 */     // MIs[0] vm
     /* 252255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 252258 */     // (intrinsic_void 2297:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 252261 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252263 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252265 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252267 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252269 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252271 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 252273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252276 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252282 */     GIR_RootConstrainSelectedInstOperands,
     /* 252283 */     // GIR_Coverage, 6912,
     /* 252283 */     GIR_EraseRootFromParent_Done,
     /* 252284 */   // Label 4136: @252284
     /* 252284 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(252368), // Rule ID 6913 //
     /* 252289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 252294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252306 */     // MIs[0] tgt
     /* 252306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252309 */     // MIs[0] en
     /* 252309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252324 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252328 */     // MIs[0] Operand 7
     /* 252328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 252339 */     // MIs[0] vm
     /* 252339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 252342 */     // (intrinsic_void 2297:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 252345 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252347 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252349 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252351 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252353 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252355 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 252357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252360 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252366 */     GIR_RootConstrainSelectedInstOperands,
     /* 252367 */     // GIR_Coverage, 6913,
     /* 252367 */     GIR_EraseRootFromParent_Done,
     /* 252368 */   // Label 4137: @252368
     /* 252368 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(252452), // Rule ID 6914 //
     /* 252373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 252378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252390 */     // MIs[0] tgt
     /* 252390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252393 */     // MIs[0] en
     /* 252393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252408 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252412 */     // MIs[0] Operand 7
     /* 252412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 252423 */     // MIs[0] vm
     /* 252423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 252426 */     // (intrinsic_void 2297:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
     /* 252429 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252433 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252435 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252437 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252439 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 252441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252444 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252450 */     GIR_RootConstrainSelectedInstOperands,
     /* 252451 */     // GIR_Coverage, 6914,
     /* 252451 */     GIR_EraseRootFromParent_Done,
     /* 252452 */   // Label 4138: @252452
     /* 252452 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(252536), // Rule ID 6915 //
     /* 252457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
     /* 252462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252474 */     // MIs[0] tgt
     /* 252474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252477 */     // MIs[0] en
     /* 252477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252492 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252496 */     // MIs[0] Operand 7
     /* 252496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 252507 */     // MIs[0] vm
     /* 252507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 252510 */     // (intrinsic_void 2297:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
     /* 252513 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252515 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252517 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252519 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252521 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252523 */     GIR_RootToRootCopy, /*OpIdx*/8, // vm
     /* 252525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252528 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252534 */     GIR_RootConstrainSelectedInstOperands,
     /* 252535 */     // GIR_Coverage, 6915,
     /* 252535 */     GIR_EraseRootFromParent_Done,
     /* 252536 */   // Label 4139: @252536
     /* 252536 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(252639), // Rule ID 6916 //
     /* 252541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 252546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252558 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 252561 */     // MIs[0] tgt
     /* 252561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252564 */     // MIs[0] en
     /* 252564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252579 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252583 */     // MIs[0] Operand 7
     /* 252583 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 252594 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 252598 */     // (intrinsic_void 2299:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252602 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 252612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
     /* 252615 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252617 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252619 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252621 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252623 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252631 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252637 */     GIR_RootConstrainSelectedInstOperands,
     /* 252638 */     // GIR_Coverage, 6916,
     /* 252638 */     GIR_EraseRootFromParent_Done,
     /* 252639 */   // Label 4140: @252639
     /* 252639 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(252742), // Rule ID 6917 //
     /* 252644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 252649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252661 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 252664 */     // MIs[0] tgt
     /* 252664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252667 */     // MIs[0] en
     /* 252667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252682 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252686 */     // MIs[0] Operand 7
     /* 252686 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 252697 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 252701 */     // (intrinsic_void 2299:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252705 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 252715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
     /* 252718 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252720 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252722 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252724 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252726 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252734 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252740 */     GIR_RootConstrainSelectedInstOperands,
     /* 252741 */     // GIR_Coverage, 6917,
     /* 252741 */     GIR_EraseRootFromParent_Done,
     /* 252742 */   // Label 4141: @252742
     /* 252742 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(252845), // Rule ID 6918 //
     /* 252747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 252752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252764 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 252767 */     // MIs[0] tgt
     /* 252767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252770 */     // MIs[0] en
     /* 252770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252785 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252789 */     // MIs[0] Operand 7
     /* 252789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 252800 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 252804 */     // (intrinsic_void 2299:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252808 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 252818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
     /* 252821 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252823 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252825 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252827 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252829 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252837 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252843 */     GIR_RootConstrainSelectedInstOperands,
     /* 252844 */     // GIR_Coverage, 6918,
     /* 252844 */     GIR_EraseRootFromParent_Done,
     /* 252845 */   // Label 4142: @252845
     /* 252845 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(252948), // Rule ID 6919 //
     /* 252850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
     /* 252855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 252858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 252861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 252864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 252867 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 252870 */     // MIs[0] tgt
     /* 252870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252873 */     // MIs[0] en
     /* 252873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252888 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 252892 */     // MIs[0] Operand 7
     /* 252892 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
     /* 252903 */     GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
     /* 252907 */     // (intrinsic_void 2299:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
     /* 252907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252911 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
     /* 252921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
     /* 252924 */     GIR_RootToRootCopy, /*OpIdx*/1, // tgt
     /* 252926 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 252928 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 252930 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 252932 */     GIR_RootToRootCopy, /*OpIdx*/6, // src3
     /* 252934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252940 */     GIR_RootToRootCopy, /*OpIdx*/2, // en
     /* 252942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252946 */     GIR_RootConstrainSelectedInstOperands,
     /* 252947 */     // GIR_Coverage, 6919,
     /* 252947 */     GIR_EraseRootFromParent_Done,
     /* 252948 */   // Label 4143: @252948
     /* 252948 */   GIM_Reject,
     /* 252949 */ // Label 4135: @252949
     /* 252949 */ GIM_Reject,
     /* 252950 */ // Label 38: @252950
     /* 252950 */ GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(253750),
     /* 252955 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 252958 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(252997), // Rule ID 7700 //
     /* 252963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 252968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 252974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 252978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 252986 */     // MIs[1] Operand 1
     /* 252986 */     // No operand predicates
     /* 252986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252988 */     // (intrinsic_wo_chain:{ *:[i32] } 3244:{ *:[iPTR] }, (imm:{ *:[i32] }):$src)  =>  (S_MOV_B32:{ *:[i32] } SReg_32:{ *:[i32] }:$src)
     /* 252988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 252991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 252993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 252995 */     GIR_RootConstrainSelectedInstOperands,
     /* 252996 */     // GIR_Coverage, 7700,
     /* 252996 */     GIR_EraseRootFromParent_Done,
     /* 252997 */   // Label 4145: @252997
     /* 252997 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(253030), // Rule ID 2383 //
     /* 253002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253021 */     // (intrinsic_wo_chain:{ *:[i32] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 253021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253028 */     GIR_RootConstrainSelectedInstOperands,
     /* 253029 */     // GIR_Coverage, 2383,
     /* 253029 */     GIR_EraseRootFromParent_Done,
     /* 253030 */   // Label 4146: @253030
     /* 253030 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(253063), // Rule ID 2384 //
     /* 253035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253054 */     // (intrinsic_wo_chain:{ *:[f32] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[f32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0)
     /* 253054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253061 */     GIR_RootConstrainSelectedInstOperands,
     /* 253062 */     // GIR_Coverage, 2384,
     /* 253062 */     GIR_EraseRootFromParent_Done,
     /* 253063 */   // Label 4147: @253063
     /* 253063 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(253096), // Rule ID 2385 //
     /* 253068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 253076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 253079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253087 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)
     /* 253087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253094 */     GIR_RootConstrainSelectedInstOperands,
     /* 253095 */     // GIR_Coverage, 2385,
     /* 253095 */     GIR_EraseRootFromParent_Done,
     /* 253096 */   // Label 4148: @253096
     /* 253096 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(253129), // Rule ID 2386 //
     /* 253101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 253109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 253112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253120 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)
     /* 253120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253127 */     GIR_RootConstrainSelectedInstOperands,
     /* 253128 */     // GIR_Coverage, 2386,
     /* 253128 */     GIR_EraseRootFromParent_Done,
     /* 253129 */   // Label 4149: @253129
     /* 253129 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(253162), // Rule ID 2387 //
     /* 253134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 253142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 253145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253153 */     // (intrinsic_wo_chain:{ *:[i32] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 253153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253160 */     GIR_RootConstrainSelectedInstOperands,
     /* 253161 */     // GIR_Coverage, 2387,
     /* 253161 */     GIR_EraseRootFromParent_Done,
     /* 253162 */   // Label 4150: @253162
     /* 253162 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(253195), // Rule ID 2388 //
     /* 253167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 253175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 253178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253186 */     // (intrinsic_wo_chain:{ *:[i32] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 253186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253191 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253193 */     GIR_RootConstrainSelectedInstOperands,
     /* 253194 */     // GIR_Coverage, 2388,
     /* 253194 */     GIR_EraseRootFromParent_Done,
     /* 253195 */   // Label 4151: @253195
     /* 253195 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(253228), // Rule ID 2389 //
     /* 253200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 253208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 253211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253219 */     // (intrinsic_wo_chain:{ *:[i32] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 253219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253226 */     GIR_RootConstrainSelectedInstOperands,
     /* 253227 */     // GIR_Coverage, 2389,
     /* 253227 */     GIR_EraseRootFromParent_Done,
     /* 253228 */   // Label 4152: @253228
     /* 253228 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(253261), // Rule ID 2390 //
     /* 253233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
     /* 253238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 253241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 253244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 253248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
     /* 253252 */     // (intrinsic_wo_chain:{ *:[i32] } 3244:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
     /* 253252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
     /* 253255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253257 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253259 */     GIR_RootConstrainSelectedInstOperands,
     /* 253260 */     // GIR_Coverage, 2390,
     /* 253260 */     GIR_EraseRootFromParent_Done,
     /* 253261 */   // Label 4153: @253261
     /* 253261 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(253294), // Rule ID 2417 //
     /* 253266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253285 */     // (intrinsic_wo_chain:{ *:[i32] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 253285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253292 */     GIR_RootConstrainSelectedInstOperands,
     /* 253293 */     // GIR_Coverage, 2417,
     /* 253293 */     GIR_EraseRootFromParent_Done,
     /* 253294 */   // Label 4154: @253294
     /* 253294 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(253327), // Rule ID 2418 //
     /* 253299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253318 */     // (intrinsic_wo_chain:{ *:[f32] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[f32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[f32] } VRegSrc_32:{ *:[f32] }:$src0)
     /* 253318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253325 */     GIR_RootConstrainSelectedInstOperands,
     /* 253326 */     // GIR_Coverage, 2418,
     /* 253326 */     GIR_EraseRootFromParent_Done,
     /* 253327 */   // Label 4155: @253327
     /* 253327 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(253360), // Rule ID 2419 //
     /* 253332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 253340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 253343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253351 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[v2i16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2i16] } VRegSrc_32:{ *:[v2i16] }:$src0)
     /* 253351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253356 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253358 */     GIR_RootConstrainSelectedInstOperands,
     /* 253359 */     // GIR_Coverage, 2419,
     /* 253359 */     GIR_EraseRootFromParent_Done,
     /* 253360 */   // Label 4156: @253360
     /* 253360 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(253393), // Rule ID 2420 //
     /* 253365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 253373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 253376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253384 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[v2f16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2f16] } VRegSrc_32:{ *:[v2f16] }:$src0)
     /* 253384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253391 */     GIR_RootConstrainSelectedInstOperands,
     /* 253392 */     // GIR_Coverage, 2420,
     /* 253392 */     GIR_EraseRootFromParent_Done,
     /* 253393 */   // Label 4157: @253393
     /* 253393 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(253426), // Rule ID 2421 //
     /* 253398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 253409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253417 */     // (intrinsic_wo_chain:{ *:[i32] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 253417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253424 */     GIR_RootConstrainSelectedInstOperands,
     /* 253425 */     // GIR_Coverage, 2421,
     /* 253425 */     GIR_EraseRootFromParent_Done,
     /* 253426 */   // Label 4158: @253426
     /* 253426 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(253459), // Rule ID 2422 //
     /* 253431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 253442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253450 */     // (intrinsic_wo_chain:{ *:[i32] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 253450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253455 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253457 */     GIR_RootConstrainSelectedInstOperands,
     /* 253458 */     // GIR_Coverage, 2422,
     /* 253458 */     GIR_EraseRootFromParent_Done,
     /* 253459 */   // Label 4159: @253459
     /* 253459 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(253492), // Rule ID 2423 //
     /* 253464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 253475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253483 */     // (intrinsic_wo_chain:{ *:[i32] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 253483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253490 */     GIR_RootConstrainSelectedInstOperands,
     /* 253491 */     // GIR_Coverage, 2423,
     /* 253491 */     GIR_EraseRootFromParent_Done,
     /* 253492 */   // Label 4160: @253492
     /* 253492 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(253525), // Rule ID 2424 //
     /* 253497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
     /* 253502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 253508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253516 */     // (intrinsic_wo_chain:{ *:[i32] } 3184:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
     /* 253516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
     /* 253519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253523 */     GIR_RootConstrainSelectedInstOperands,
     /* 253524 */     // GIR_Coverage, 2424,
     /* 253524 */     GIR_EraseRootFromParent_Done,
     /* 253525 */   // Label 4161: @253525
     /* 253525 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(253557), // Rule ID 2 //
     /* 253530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
     /* 253535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 253545 */     // (intrinsic_wo_chain:{ *:[i32] } 3293:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_WQM_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 253545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
     /* 253548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 253550 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 253555 */     GIR_RootConstrainSelectedInstOperands,
     /* 253556 */     // GIR_Coverage, 2,
     /* 253556 */     GIR_EraseRootFromParent_Done,
     /* 253557 */   // Label 4162: @253557
     /* 253557 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(253589), // Rule ID 3 //
     /* 253562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
     /* 253567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 253577 */     // (intrinsic_wo_chain:{ *:[i64] } 3293:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_WQM_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /* 253577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
     /* 253580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 253582 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 253587 */     GIR_RootConstrainSelectedInstOperands,
     /* 253588 */     // GIR_Coverage, 3,
     /* 253588 */     GIR_EraseRootFromParent_Done,
     /* 253589 */   // Label 4163: @253589
     /* 253589 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(253618), // Rule ID 21 //
     /* 253594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
     /* 253599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 253609 */     // (intrinsic_wo_chain:{ *:[i32] } 3273:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_QUADMASK_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 253609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B32),
     /* 253612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 253614 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253616 */     GIR_RootConstrainSelectedInstOperands,
     /* 253617 */     // GIR_Coverage, 21,
     /* 253617 */     GIR_EraseRootFromParent_Done,
     /* 253618 */   // Label 4164: @253618
     /* 253618 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(253647), // Rule ID 22 //
     /* 253623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
     /* 253628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 253638 */     // (intrinsic_wo_chain:{ *:[i64] } 3273:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_QUADMASK_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
     /* 253638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B64),
     /* 253641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 253643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253645 */     GIR_RootConstrainSelectedInstOperands,
     /* 253646 */     // GIR_Coverage, 22,
     /* 253646 */     GIR_EraseRootFromParent_Done,
     /* 253647 */   // Label 4165: @253647
     /* 253647 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(253679), // Rule ID 24 //
     /* 253652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 253655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_bitreplicate),
     /* 253660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 253670 */     // (intrinsic_wo_chain:{ *:[i64] } 3255:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_BITREPLICATE_B64_B32:{ *:[i64] } i32:{ *:[i32] }:$src0)
     /* 253670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BITREPLICATE_B64_B32),
     /* 253673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 253675 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253677 */     GIR_RootConstrainSelectedInstOperands,
     /* 253678 */     // GIR_Coverage, 24,
     /* 253678 */     GIR_EraseRootFromParent_Done,
     /* 253679 */   // Label 4166: @253679
     /* 253679 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(253714), // Rule ID 1864 //
     /* 253684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 253687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
     /* 253692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 253695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 253698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 253702 */     // (intrinsic_wo_chain:{ *:[i1] } 3435:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B32:{ *:[i1] }:{ *:[i1] } SSrc_b32:{ *:[i1] }:$src0)
     /* 253702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
     /* 253705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 253707 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 253712 */     GIR_RootConstrainSelectedInstOperands,
     /* 253713 */     // GIR_Coverage, 1864,
     /* 253713 */     GIR_EraseRootFromParent_Done,
     /* 253714 */   // Label 4167: @253714
     /* 253714 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(253749), // Rule ID 1865 //
     /* 253719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 253722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
     /* 253727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 253730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 253733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 253737 */     // (intrinsic_wo_chain:{ *:[i1] } 3435:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B64:{ *:[i1] }:{ *:[i1] } SSrc_b64:{ *:[i1] }:$src0)
     /* 253737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
     /* 253740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 253742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 253744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 253747 */     GIR_RootConstrainSelectedInstOperands,
     /* 253748 */     // GIR_Coverage, 1865,
     /* 253748 */     GIR_EraseRootFromParent_Done,
     /* 253749 */   // Label 4168: @253749
     /* 253749 */   GIM_Reject,
     /* 253750 */ // Label 4144: @253750
     /* 253750 */ GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(256075),
     /* 253755 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 253758 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(253810), // Rule ID 1365 //
     /* 253763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 253766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_permute),
     /* 253771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 253784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 253791 */     // (intrinsic_wo_chain:{ *:[i32] } 2287:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_PERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 253791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PERMUTE_B32),
     /* 253794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 253801 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 253803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 253808 */     GIR_RootConstrainSelectedInstOperands,
     /* 253809 */     // GIR_Coverage, 1365,
     /* 253809 */     GIR_EraseRootFromParent_Done,
     /* 253810 */   // Label 4170: @253810
     /* 253810 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(253862), // Rule ID 1366 //
     /* 253815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 253818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_bpermute),
     /* 253823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 253836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 253843 */     // (intrinsic_wo_chain:{ *:[i32] } 2272:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_BPERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 253843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_BPERMUTE_B32),
     /* 253846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 253853 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 253855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 253860 */     GIR_RootConstrainSelectedInstOperands,
     /* 253861 */     // GIR_Coverage, 1366,
     /* 253861 */     GIR_EraseRootFromParent_Done,
     /* 253862 */   // Label 4171: @253862
     /* 253862 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(253914), // Rule ID 1367 //
     /* 253867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 253870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_bpermute_fi_b32),
     /* 253875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 253884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 253888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 253895 */     // (intrinsic_wo_chain:{ *:[i32] } 2273:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_BPERMUTE_FI_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
     /* 253895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_BPERMUTE_FI_B32),
     /* 253898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
     /* 253905 */     GIR_RootToRootCopy, /*OpIdx*/3, // data0
     /* 253907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 253912 */     GIR_RootConstrainSelectedInstOperands,
     /* 253913 */     // GIR_Coverage, 1367,
     /* 253913 */     GIR_EraseRootFromParent_Done,
     /* 253914 */   // Label 4172: @253914
     /* 253914 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(253967), // Rule ID 2447 //
     /* 253919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 253922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 253927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253937 */     // MIs[0] dpp8
     /* 253937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253940 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 253940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 253943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253945 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 253947 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 253949 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 253955 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 253965 */     GIR_RootConstrainSelectedInstOperands,
     /* 253966 */     // GIR_Coverage, 2447,
     /* 253966 */     GIR_EraseRootFromParent_Done,
     /* 253967 */   // Label 4173: @253967
     /* 253967 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(254020), // Rule ID 2448 //
     /* 253972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 253975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 253980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 253990 */     // MIs[0] dpp8
     /* 253990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253993 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 253993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 253996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 253998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254008 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254018 */     GIR_RootConstrainSelectedInstOperands,
     /* 254019 */     // GIR_Coverage, 2448,
     /* 254019 */     GIR_EraseRootFromParent_Done,
     /* 254020 */   // Label 4174: @254020
     /* 254020 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(254073), // Rule ID 2449 //
     /* 254025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 254028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 254039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254043 */     // MIs[0] dpp8
     /* 254043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254046 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 254049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254051 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254061 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254071 */     GIR_RootConstrainSelectedInstOperands,
     /* 254072 */     // GIR_Coverage, 2449,
     /* 254072 */     GIR_EraseRootFromParent_Done,
     /* 254073 */   // Label 4175: @254073
     /* 254073 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(254126), // Rule ID 2450 //
     /* 254078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 254081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 254092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254096 */     // MIs[0] dpp8
     /* 254096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254099 */     // (intrinsic_wo_chain:{ *:[f32] } 3171:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 254102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254108 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254114 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254124 */     GIR_RootConstrainSelectedInstOperands,
     /* 254125 */     // GIR_Coverage, 2450,
     /* 254125 */     GIR_EraseRootFromParent_Done,
     /* 254126 */   // Label 4176: @254126
     /* 254126 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(254179), // Rule ID 2451 //
     /* 254131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 254134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 254145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254149 */     // MIs[0] dpp8
     /* 254149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254152 */     // (intrinsic_wo_chain:{ *:[f32] } 3171:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 254155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254167 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254177 */     GIR_RootConstrainSelectedInstOperands,
     /* 254178 */     // GIR_Coverage, 2451,
     /* 254178 */     GIR_EraseRootFromParent_Done,
     /* 254179 */   // Label 4177: @254179
     /* 254179 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(254232), // Rule ID 2452 //
     /* 254184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 254187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 254198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254202 */     // MIs[0] dpp8
     /* 254202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254205 */     // (intrinsic_wo_chain:{ *:[f32] } 3171:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 254208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254214 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254220 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254230 */     GIR_RootConstrainSelectedInstOperands,
     /* 254231 */     // GIR_Coverage, 2452,
     /* 254231 */     GIR_EraseRootFromParent_Done,
     /* 254232 */   // Label 4178: @254232
     /* 254232 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(254285), // Rule ID 2453 //
     /* 254237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 254240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254255 */     // MIs[0] dpp8
     /* 254255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254258 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3171:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 254261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254273 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254283 */     GIR_RootConstrainSelectedInstOperands,
     /* 254284 */     // GIR_Coverage, 2453,
     /* 254284 */     GIR_EraseRootFromParent_Done,
     /* 254285 */   // Label 4179: @254285
     /* 254285 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(254338), // Rule ID 2454 //
     /* 254290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 254293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254308 */     // MIs[0] dpp8
     /* 254308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254311 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3171:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 254314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254326 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254336 */     GIR_RootConstrainSelectedInstOperands,
     /* 254337 */     // GIR_Coverage, 2454,
     /* 254337 */     GIR_EraseRootFromParent_Done,
     /* 254338 */   // Label 4180: @254338
     /* 254338 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(254391), // Rule ID 2455 //
     /* 254343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 254346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254361 */     // MIs[0] dpp8
     /* 254361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254364 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3171:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 254367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254369 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254371 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254379 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254389 */     GIR_RootConstrainSelectedInstOperands,
     /* 254390 */     // GIR_Coverage, 2455,
     /* 254390 */     GIR_EraseRootFromParent_Done,
     /* 254391 */   // Label 4181: @254391
     /* 254391 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(254444), // Rule ID 2456 //
     /* 254396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 254399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254414 */     // MIs[0] dpp8
     /* 254414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254417 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3171:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 254420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254424 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254426 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254432 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254442 */     GIR_RootConstrainSelectedInstOperands,
     /* 254443 */     // GIR_Coverage, 2456,
     /* 254443 */     GIR_EraseRootFromParent_Done,
     /* 254444 */   // Label 4182: @254444
     /* 254444 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(254497), // Rule ID 2457 //
     /* 254449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 254452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254467 */     // MIs[0] dpp8
     /* 254467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254470 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3171:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 254473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254485 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254495 */     GIR_RootConstrainSelectedInstOperands,
     /* 254496 */     // GIR_Coverage, 2457,
     /* 254496 */     GIR_EraseRootFromParent_Done,
     /* 254497 */   // Label 4183: @254497
     /* 254497 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(254550), // Rule ID 2458 //
     /* 254502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 254505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 254513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 254516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254520 */     // MIs[0] dpp8
     /* 254520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254523 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3171:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 254526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254538 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254548 */     GIR_RootConstrainSelectedInstOperands,
     /* 254549 */     // GIR_Coverage, 2458,
     /* 254549 */     GIR_EraseRootFromParent_Done,
     /* 254550 */   // Label 4184: @254550
     /* 254550 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(254603), // Rule ID 2459 //
     /* 254555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 254558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 254566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 254569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254573 */     // MIs[0] dpp8
     /* 254573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254576 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 254579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254591 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254601 */     GIR_RootConstrainSelectedInstOperands,
     /* 254602 */     // GIR_Coverage, 2459,
     /* 254602 */     GIR_EraseRootFromParent_Done,
     /* 254603 */   // Label 4185: @254603
     /* 254603 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(254656), // Rule ID 2460 //
     /* 254608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 254611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 254619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 254622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254626 */     // MIs[0] dpp8
     /* 254626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254629 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 254632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254644 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254654 */     GIR_RootConstrainSelectedInstOperands,
     /* 254655 */     // GIR_Coverage, 2460,
     /* 254655 */     GIR_EraseRootFromParent_Done,
     /* 254656 */   // Label 4186: @254656
     /* 254656 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(254709), // Rule ID 2461 //
     /* 254661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 254664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 254672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 254675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254679 */     // MIs[0] dpp8
     /* 254679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254682 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 254685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254689 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254697 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254707 */     GIR_RootConstrainSelectedInstOperands,
     /* 254708 */     // GIR_Coverage, 2461,
     /* 254708 */     GIR_EraseRootFromParent_Done,
     /* 254709 */   // Label 4187: @254709
     /* 254709 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(254762), // Rule ID 2462 //
     /* 254714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 254717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 254725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 254728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254732 */     // MIs[0] dpp8
     /* 254732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254735 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 254738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254740 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254750 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254760 */     GIR_RootConstrainSelectedInstOperands,
     /* 254761 */     // GIR_Coverage, 2462,
     /* 254761 */     GIR_EraseRootFromParent_Done,
     /* 254762 */   // Label 4188: @254762
     /* 254762 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(254815), // Rule ID 2463 //
     /* 254767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 254770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 254778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 254781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254785 */     // MIs[0] dpp8
     /* 254785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254788 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 254791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254793 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254803 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254813 */     GIR_RootConstrainSelectedInstOperands,
     /* 254814 */     // GIR_Coverage, 2463,
     /* 254814 */     GIR_EraseRootFromParent_Done,
     /* 254815 */   // Label 4189: @254815
     /* 254815 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(254868), // Rule ID 2464 //
     /* 254820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 254823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 254831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 254834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254838 */     // MIs[0] dpp8
     /* 254838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254841 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 254844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254846 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254848 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254856 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254866 */     GIR_RootConstrainSelectedInstOperands,
     /* 254867 */     // GIR_Coverage, 2464,
     /* 254867 */     GIR_EraseRootFromParent_Done,
     /* 254868 */   // Label 4190: @254868
     /* 254868 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(254921), // Rule ID 2465 //
     /* 254873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 254876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 254884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 254887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254891 */     // MIs[0] dpp8
     /* 254891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254894 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 254897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254899 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254903 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254909 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254919 */     GIR_RootConstrainSelectedInstOperands,
     /* 254920 */     // GIR_Coverage, 2465,
     /* 254920 */     GIR_EraseRootFromParent_Done,
     /* 254921 */   // Label 4191: @254921
     /* 254921 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(254974), // Rule ID 2466 //
     /* 254926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 254929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 254937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 254940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254944 */     // MIs[0] dpp8
     /* 254944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254947 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 254947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 254950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 254952 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 254956 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 254962 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 254972 */     GIR_RootConstrainSelectedInstOperands,
     /* 254973 */     // GIR_Coverage, 2466,
     /* 254973 */     GIR_EraseRootFromParent_Done,
     /* 254974 */   // Label 4192: @254974
     /* 254974 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(255027), // Rule ID 2467 //
     /* 254979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 254982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 254987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 254990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 254993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 254997 */     // MIs[0] dpp8
     /* 254997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255000 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 255000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 255003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255005 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255007 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 255015 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 255025 */     GIR_RootConstrainSelectedInstOperands,
     /* 255026 */     // GIR_Coverage, 2467,
     /* 255026 */     GIR_EraseRootFromParent_Done,
     /* 255027 */   // Label 4193: @255027
     /* 255027 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(255080), // Rule ID 2468 //
     /* 255032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
     /* 255035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 255040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 255043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 255046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255050 */     // MIs[0] dpp8
     /* 255050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255053 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 255053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
     /* 255056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255058 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 255068 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 255078 */     GIR_RootConstrainSelectedInstOperands,
     /* 255079 */     // GIR_Coverage, 2468,
     /* 255079 */     GIR_EraseRootFromParent_Done,
     /* 255080 */   // Label 4194: @255080
     /* 255080 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(255133), // Rule ID 2469 //
     /* 255085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
     /* 255088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 255093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 255096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 255099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255103 */     // MIs[0] dpp8
     /* 255103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255106 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 255106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
     /* 255109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255113 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 255121 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 255131 */     GIR_RootConstrainSelectedInstOperands,
     /* 255132 */     // GIR_Coverage, 2469,
     /* 255132 */     GIR_EraseRootFromParent_Done,
     /* 255133 */   // Label 4195: @255133
     /* 255133 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(255186), // Rule ID 2470 //
     /* 255138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
     /* 255141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
     /* 255146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 255149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 255152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255156 */     // MIs[0] dpp8
     /* 255156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255159 */     // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
     /* 255159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
     /* 255162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
     /* 255174 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
     /* 255184 */     GIR_RootConstrainSelectedInstOperands,
     /* 255185 */     // GIR_Coverage, 2470,
     /* 255185 */     GIR_EraseRootFromParent_Done,
     /* 255186 */   // Label 4196: @255186
     /* 255186 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(255227), // Rule ID 7927 //
     /* 255191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_swizzle),
     /* 255196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 255206 */     // MIs[0] offset16
     /* 255206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 255209 */     // (intrinsic_wo_chain:{ *:[i32] } 2293:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset16)  =>  (DS_SWIZZLE_B32:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, (as_i16timm:{ *:[i16] } ?:{ *:[i32] }:$offset16), 0:{ *:[i1] })
     /* 255209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SWIZZLE_B32),
     /* 255212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255214 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset16
     /* 255222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255225 */     GIR_RootConstrainSelectedInstOperands,
     /* 255226 */     // GIR_Coverage, 7927,
     /* 255226 */     GIR_EraseRootFromParent_Done,
     /* 255227 */   // Label 4197: @255227
     /* 255227 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(255261), // Rule ID 2471 //
     /* 255232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255250 */     // (intrinsic_wo_chain:{ *:[i32] } 3245:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255257 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255259 */     GIR_RootConstrainSelectedInstOperands,
     /* 255260 */     // GIR_Coverage, 2471,
     /* 255260 */     GIR_EraseRootFromParent_Done,
     /* 255261 */   // Label 4198: @255261
     /* 255261 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(255295), // Rule ID 2473 //
     /* 255266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255284 */     // (intrinsic_wo_chain:{ *:[f32] } 3245:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255291 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255293 */     GIR_RootConstrainSelectedInstOperands,
     /* 255294 */     // GIR_Coverage, 2473,
     /* 255294 */     GIR_EraseRootFromParent_Done,
     /* 255295 */   // Label 4199: @255295
     /* 255295 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(255329), // Rule ID 2475 //
     /* 255300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 255308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 255311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255318 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3245:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255325 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255327 */     GIR_RootConstrainSelectedInstOperands,
     /* 255328 */     // GIR_Coverage, 2475,
     /* 255328 */     GIR_EraseRootFromParent_Done,
     /* 255329 */   // Label 4200: @255329
     /* 255329 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(255363), // Rule ID 2477 //
     /* 255334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 255342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 255345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255352 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3245:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255361 */     GIR_RootConstrainSelectedInstOperands,
     /* 255362 */     // GIR_Coverage, 2477,
     /* 255362 */     GIR_EraseRootFromParent_Done,
     /* 255363 */   // Label 4201: @255363
     /* 255363 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(255397), // Rule ID 2479 //
     /* 255368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 255376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 255379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255386 */     // (intrinsic_wo_chain:{ *:[i32] } 3245:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255391 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255393 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255395 */     GIR_RootConstrainSelectedInstOperands,
     /* 255396 */     // GIR_Coverage, 2479,
     /* 255396 */     GIR_EraseRootFromParent_Done,
     /* 255397 */   // Label 4202: @255397
     /* 255397 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(255431), // Rule ID 2481 //
     /* 255402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 255410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 255413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255420 */     // (intrinsic_wo_chain:{ *:[i32] } 3245:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255429 */     GIR_RootConstrainSelectedInstOperands,
     /* 255430 */     // GIR_Coverage, 2481,
     /* 255430 */     GIR_EraseRootFromParent_Done,
     /* 255431 */   // Label 4203: @255431
     /* 255431 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(255465), // Rule ID 2483 //
     /* 255436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 255444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 255447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255454 */     // (intrinsic_wo_chain:{ *:[i32] } 3245:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255461 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255463 */     GIR_RootConstrainSelectedInstOperands,
     /* 255464 */     // GIR_Coverage, 2483,
     /* 255464 */     GIR_EraseRootFromParent_Done,
     /* 255465 */   // Label 4204: @255465
     /* 255465 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(255499), // Rule ID 2485 //
     /* 255470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
     /* 255475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 255478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 255481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 255488 */     // (intrinsic_wo_chain:{ *:[i32] } 3245:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
     /* 255488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
     /* 255491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255493 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 255495 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 255497 */     GIR_RootConstrainSelectedInstOperands,
     /* 255498 */     // GIR_Coverage, 2485,
     /* 255498 */     GIR_EraseRootFromParent_Done,
     /* 255499 */   // Label 4205: @255499
     /* 255499 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(255556), // Rule ID 6951 //
     /* 255504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255522 */     // (intrinsic_wo_chain:{ *:[i32] } 3303:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255549 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255554 */     GIR_RootConstrainSelectedInstOperands,
     /* 255555 */     // GIR_Coverage, 6951,
     /* 255555 */     GIR_EraseRootFromParent_Done,
     /* 255556 */   // Label 4206: @255556
     /* 255556 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(255613), // Rule ID 6952 //
     /* 255561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255579 */     // (intrinsic_wo_chain:{ *:[f32] } 3303:{ *:[iPTR] }, f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[f32] } 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255606 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255611 */     GIR_RootConstrainSelectedInstOperands,
     /* 255612 */     // GIR_Coverage, 6952,
     /* 255612 */     GIR_EraseRootFromParent_Done,
     /* 255613 */   // Label 4207: @255613
     /* 255613 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(255670), // Rule ID 6953 //
     /* 255618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 255626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 255629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 255632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255636 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3303:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, v2i16:{ *:[v2i16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255663 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255668 */     GIR_RootConstrainSelectedInstOperands,
     /* 255669 */     // GIR_Coverage, 6953,
     /* 255669 */     GIR_EraseRootFromParent_Done,
     /* 255670 */   // Label 4208: @255670
     /* 255670 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(255727), // Rule ID 6954 //
     /* 255675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 255683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 255686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 255689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255693 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3303:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, v2f16:{ *:[v2f16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255720 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255725 */     GIR_RootConstrainSelectedInstOperands,
     /* 255726 */     // GIR_Coverage, 6954,
     /* 255726 */     GIR_EraseRootFromParent_Done,
     /* 255727 */   // Label 4209: @255727
     /* 255727 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(255784), // Rule ID 6955 //
     /* 255732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 255740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 255743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 255746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255750 */     // (intrinsic_wo_chain:{ *:[i32] } 3303:{ *:[iPTR] }, p2:{ *:[i32] }:$src, p2:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255772 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255777 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255782 */     GIR_RootConstrainSelectedInstOperands,
     /* 255783 */     // GIR_Coverage, 6955,
     /* 255783 */     GIR_EraseRootFromParent_Done,
     /* 255784 */   // Label 4210: @255784
     /* 255784 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(255841), // Rule ID 6956 //
     /* 255789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 255797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 255800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 255803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255807 */     // (intrinsic_wo_chain:{ *:[i32] } 3303:{ *:[iPTR] }, p3:{ *:[i32] }:$src, p3:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255834 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255839 */     GIR_RootConstrainSelectedInstOperands,
     /* 255840 */     // GIR_Coverage, 6956,
     /* 255840 */     GIR_EraseRootFromParent_Done,
     /* 255841 */   // Label 4211: @255841
     /* 255841 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(255898), // Rule ID 6957 //
     /* 255846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 255854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 255857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 255860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255864 */     // (intrinsic_wo_chain:{ *:[i32] } 3303:{ *:[iPTR] }, p5:{ *:[i32] }:$src, p5:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255886 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255891 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255896 */     GIR_RootConstrainSelectedInstOperands,
     /* 255897 */     // GIR_Coverage, 6957,
     /* 255897 */     GIR_EraseRootFromParent_Done,
     /* 255898 */   // Label 4212: @255898
     /* 255898 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(255955), // Rule ID 6958 //
     /* 255903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
     /* 255908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 255911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 255914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 255917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255921 */     // (intrinsic_wo_chain:{ *:[i32] } 3303:{ *:[iPTR] }, p6:{ *:[i32] }:$src, p6:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 255945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255948 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 255950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 255953 */     GIR_RootConstrainSelectedInstOperands,
     /* 255954 */     // GIR_Coverage, 6958,
     /* 255954 */     GIR_EraseRootFromParent_Done,
     /* 255955 */   // Label 4213: @255955
     /* 255955 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(256012), // Rule ID 6959 //
     /* 255960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive_chain_arg),
     /* 255965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 255968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 255971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 255974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 255978 */     // (intrinsic_wo_chain:{ *:[i32] } 3304:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
     /* 255978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 255981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 255985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 255990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 255992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
     /* 255995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 255997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256005 */     GIR_RootToRootCopy, /*OpIdx*/3, // inactive
     /* 256007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 256010 */     GIR_RootConstrainSelectedInstOperands,
     /* 256011 */     // GIR_Coverage, 6959,
     /* 256011 */     GIR_EraseRootFromParent_Done,
     /* 256012 */   // Label 4214: @256012
     /* 256012 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(256043), // Rule ID 1337 //
     /* 256017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umin),
     /* 256022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 256032 */     // MIs[0] strategy
     /* 256032 */     // No operand predicates
     /* 256032 */     // (intrinsic_wo_chain:{ *:[i32] } 3412:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMIN_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
     /* 256032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMIN_PSEUDO_U32),
     /* 256035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 256037 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256039 */     GIR_RootToRootCopy, /*OpIdx*/3, // strategy
     /* 256041 */     GIR_RootConstrainSelectedInstOperands,
     /* 256042 */     // GIR_Coverage, 1337,
     /* 256042 */     GIR_EraseRootFromParent_Done,
     /* 256043 */   // Label 4215: @256043
     /* 256043 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(256074), // Rule ID 1338 //
     /* 256048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umax),
     /* 256053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 256059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 256063 */     // MIs[0] strategy
     /* 256063 */     // No operand predicates
     /* 256063 */     // (intrinsic_wo_chain:{ *:[i32] } 3411:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMAX_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
     /* 256063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMAX_PSEUDO_U32),
     /* 256066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 256068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 256070 */     GIR_RootToRootCopy, /*OpIdx*/3, // strategy
     /* 256072 */     GIR_RootConstrainSelectedInstOperands,
     /* 256073 */     // GIR_Coverage, 1338,
     /* 256073 */     GIR_EraseRootFromParent_Done,
     /* 256074 */   // Label 4216: @256074
     /* 256074 */   GIM_Reject,
     /* 256075 */ // Label 4169: @256075
     /* 256075 */ GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(258400),
     /* 256080 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 256083 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(256174), // Rule ID 2824 //
     /* 256088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 256096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 256105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 256108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 256133 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3421:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w32_threeaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 256133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_threeaddr),
     /* 256136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256172 */     GIR_RootConstrainSelectedInstOperands,
     /* 256173 */     // GIR_Coverage, 2824,
     /* 256173 */     GIR_EraseRootFromParent_Done,
     /* 256174 */   // Label 4218: @256174
     /* 256174 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(256265), // Rule ID 2857 //
     /* 256179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 256182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 256187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 256196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 256199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 256224 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3421:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 256224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_threeaddr),
     /* 256227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256263 */     GIR_RootConstrainSelectedInstOperands,
     /* 256264 */     // GIR_Coverage, 2857,
     /* 256264 */     GIR_EraseRootFromParent_Done,
     /* 256265 */   // Label 4219: @256265
     /* 256265 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(256358), // Rule ID 2809 //
     /* 256270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 256273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 256278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 256290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256315 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3421:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 256315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w32),
     /* 256318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 256345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256356 */     GIR_RootConstrainSelectedInstOperands,
     /* 256357 */     // GIR_Coverage, 2809,
     /* 256357 */     GIR_EraseRootFromParent_Done,
     /* 256358 */   // Label 4220: @256358
     /* 256358 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(256451), // Rule ID 2810 //
     /* 256363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 256366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 256371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 256383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256408 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3418:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 256408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w32),
     /* 256411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 256438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256449 */     GIR_RootConstrainSelectedInstOperands,
     /* 256450 */     // GIR_Coverage, 2810,
     /* 256450 */     GIR_EraseRootFromParent_Done,
     /* 256451 */   // Label 4221: @256451
     /* 256451 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(256544), // Rule ID 2815 //
     /* 256456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 256464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 256476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256501 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3421:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 256501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w64),
     /* 256504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 256531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256542 */     GIR_RootConstrainSelectedInstOperands,
     /* 256543 */     // GIR_Coverage, 2815,
     /* 256543 */     GIR_EraseRootFromParent_Done,
     /* 256544 */   // Label 4222: @256544
     /* 256544 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(256637), // Rule ID 2816 //
     /* 256549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 256552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 256557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 256563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 256566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 256569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 256594 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3418:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 256594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w64),
     /* 256597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 256624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256635 */     GIR_RootConstrainSelectedInstOperands,
     /* 256636 */     // GIR_Coverage, 2816,
     /* 256636 */     GIR_EraseRootFromParent_Done,
     /* 256637 */   // Label 4223: @256637
     /* 256637 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(256730), // Rule ID 2823 //
     /* 256642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 256650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 256659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 256662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
     /* 256687 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3421:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 256687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_twoaddr),
     /* 256690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 256717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256728 */     GIR_RootConstrainSelectedInstOperands,
     /* 256729 */     // GIR_Coverage, 2823,
     /* 256729 */     GIR_EraseRootFromParent_Done,
     /* 256730 */   // Label 4224: @256730
     /* 256730 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(256823), // Rule ID 2856 //
     /* 256735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 256738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
     /* 256743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 256752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 256755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 256759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 256773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
     /* 256780 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3421:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 256780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_twoaddr),
     /* 256783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 256790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 256795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 256800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 256805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 256810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 256815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256821 */     GIR_RootConstrainSelectedInstOperands,
     /* 256822 */     // GIR_Coverage, 2856,
     /* 256822 */     GIR_EraseRootFromParent_Done,
     /* 256823 */   // Label 4225: @256823
     /* 256823 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(256890), // Rule ID 2826 //
     /* 256828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 256836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 256845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 256848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 256859 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3418:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w32_threeaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 256859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_threeaddr),
     /* 256862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256867 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256872 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 256882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256888 */     GIR_RootConstrainSelectedInstOperands,
     /* 256889 */     // GIR_Coverage, 2826,
     /* 256889 */     GIR_EraseRootFromParent_Done,
     /* 256890 */   // Label 4226: @256890
     /* 256890 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(256951), // Rule ID 2836 //
     /* 256895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 256903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 256909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 256912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 256915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 256926 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3423:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 256926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr),
     /* 256929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256933 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 256943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 256949 */     GIR_RootConstrainSelectedInstOperands,
     /* 256950 */     // GIR_Coverage, 2836,
     /* 256950 */     GIR_EraseRootFromParent_Done,
     /* 256951 */   // Label 4227: @256951
     /* 256951 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(257012), // Rule ID 2838 //
     /* 256956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 256959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 256964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 256967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 256970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 256973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 256976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 256980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 256987 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3422:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 256987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr),
     /* 256990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 256992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 256994 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 256996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 256999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257010 */     GIR_RootConstrainSelectedInstOperands,
     /* 257011 */     // GIR_Coverage, 2838,
     /* 257011 */     GIR_EraseRootFromParent_Done,
     /* 257012 */   // Label 4228: @257012
     /* 257012 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(257073), // Rule ID 2840 //
     /* 257017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 257025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 257037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257048 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3420:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 257048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr),
     /* 257051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257055 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257071 */     GIR_RootConstrainSelectedInstOperands,
     /* 257072 */     // GIR_Coverage, 2840,
     /* 257072 */     GIR_EraseRootFromParent_Done,
     /* 257073 */   // Label 4229: @257073
     /* 257073 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(257134), // Rule ID 2842 //
     /* 257078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 257086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 257098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257109 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3419:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
     /* 257109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr),
     /* 257112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257114 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257116 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257132 */     GIR_RootConstrainSelectedInstOperands,
     /* 257133 */     // GIR_Coverage, 2842,
     /* 257133 */     GIR_EraseRootFromParent_Done,
     /* 257134 */   // Label 4230: @257134
     /* 257134 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(257201), // Rule ID 2859 //
     /* 257139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 257147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 257156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257170 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3418:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w64_threeaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 257170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_threeaddr),
     /* 257173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257178 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257183 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257199 */     GIR_RootConstrainSelectedInstOperands,
     /* 257200 */     // GIR_Coverage, 2859,
     /* 257200 */     GIR_EraseRootFromParent_Done,
     /* 257201 */   // Label 4231: @257201
     /* 257201 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(257262), // Rule ID 2869 //
     /* 257206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 257214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257237 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3423:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 257237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr),
     /* 257240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257242 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257244 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257260 */     GIR_RootConstrainSelectedInstOperands,
     /* 257261 */     // GIR_Coverage, 2869,
     /* 257261 */     GIR_EraseRootFromParent_Done,
     /* 257262 */   // Label 4232: @257262
     /* 257262 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(257323), // Rule ID 2871 //
     /* 257267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 257275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257298 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3422:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 257298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr),
     /* 257301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257305 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257321 */     GIR_RootConstrainSelectedInstOperands,
     /* 257322 */     // GIR_Coverage, 2871,
     /* 257322 */     GIR_EraseRootFromParent_Done,
     /* 257323 */   // Label 4233: @257323
     /* 257323 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(257384), // Rule ID 2873 //
     /* 257328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 257336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257359 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3420:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 257359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr),
     /* 257362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257366 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257382 */     GIR_RootConstrainSelectedInstOperands,
     /* 257383 */     // GIR_Coverage, 2873,
     /* 257383 */     GIR_EraseRootFromParent_Done,
     /* 257384 */   // Label 4234: @257384
     /* 257384 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(257445), // Rule ID 2875 //
     /* 257389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 257397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 257420 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3419:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
     /* 257420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr),
     /* 257423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257427 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257443 */     GIR_RootConstrainSelectedInstOperands,
     /* 257444 */     // GIR_Coverage, 2875,
     /* 257444 */     GIR_EraseRootFromParent_Done,
     /* 257445 */   // Label 4235: @257445
     /* 257445 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(257514), // Rule ID 2825 //
     /* 257450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 257458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 257467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 257470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257481 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3418:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 257481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_twoaddr),
     /* 257484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257494 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257512 */     GIR_RootConstrainSelectedInstOperands,
     /* 257513 */     // GIR_Coverage, 2825,
     /* 257513 */     GIR_EraseRootFromParent_Done,
     /* 257514 */   // Label 4236: @257514
     /* 257514 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(257577), // Rule ID 2835 //
     /* 257519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 257527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 257539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257550 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3423:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 257550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr),
     /* 257553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257555 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257557 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257575 */     GIR_RootConstrainSelectedInstOperands,
     /* 257576 */     // GIR_Coverage, 2835,
     /* 257576 */     GIR_EraseRootFromParent_Done,
     /* 257577 */   // Label 4237: @257577
     /* 257577 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(257640), // Rule ID 2837 //
     /* 257582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 257590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 257602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257613 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3422:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 257613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr),
     /* 257616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257618 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257620 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257638 */     GIR_RootConstrainSelectedInstOperands,
     /* 257639 */     // GIR_Coverage, 2837,
     /* 257639 */     GIR_EraseRootFromParent_Done,
     /* 257640 */   // Label 4238: @257640
     /* 257640 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(257703), // Rule ID 2839 //
     /* 257645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 257653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 257665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257676 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3420:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 257676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr),
     /* 257679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257683 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257701 */     GIR_RootConstrainSelectedInstOperands,
     /* 257702 */     // GIR_Coverage, 2839,
     /* 257702 */     GIR_EraseRootFromParent_Done,
     /* 257703 */   // Label 4239: @257703
     /* 257703 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(257766), // Rule ID 2841 //
     /* 257708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 257711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 257716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 257719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 257725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 257728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 257732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257739 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3419:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
     /* 257739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr),
     /* 257742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257744 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257746 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257764 */     GIR_RootConstrainSelectedInstOperands,
     /* 257765 */     // GIR_Coverage, 2841,
     /* 257765 */     GIR_EraseRootFromParent_Done,
     /* 257766 */   // Label 4240: @257766
     /* 257766 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(257835), // Rule ID 2858 //
     /* 257771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
     /* 257779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 257788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257802 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3418:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 257802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_twoaddr),
     /* 257805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257810 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 257815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257833 */     GIR_RootConstrainSelectedInstOperands,
     /* 257834 */     // GIR_Coverage, 2858,
     /* 257834 */     GIR_EraseRootFromParent_Done,
     /* 257835 */   // Label 4241: @257835
     /* 257835 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(257898), // Rule ID 2868 //
     /* 257840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
     /* 257848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257871 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3423:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 257871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr),
     /* 257874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257876 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257878 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257896 */     GIR_RootConstrainSelectedInstOperands,
     /* 257897 */     // GIR_Coverage, 2868,
     /* 257897 */     GIR_EraseRootFromParent_Done,
     /* 257898 */   // Label 4242: @257898
     /* 257898 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(257961), // Rule ID 2870 //
     /* 257903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
     /* 257911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257934 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3422:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 257934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr),
     /* 257937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 257939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 257941 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 257943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 257948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 257953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 257959 */     GIR_RootConstrainSelectedInstOperands,
     /* 257960 */     // GIR_Coverage, 2870,
     /* 257960 */     GIR_EraseRootFromParent_Done,
     /* 257961 */   // Label 4243: @257961
     /* 257961 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(258024), // Rule ID 2872 //
     /* 257966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 257969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
     /* 257974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 257980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 257983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 257990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 257997 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3420:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 257997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr),
     /* 258000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258004 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 258011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 258016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258022 */     GIR_RootConstrainSelectedInstOperands,
     /* 258023 */     // GIR_Coverage, 2872,
     /* 258023 */     GIR_EraseRootFromParent_Done,
     /* 258024 */   // Label 4244: @258024
     /* 258024 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(258087), // Rule ID 2874 //
     /* 258029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 258032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
     /* 258037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 258043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 258049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 258053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
     /* 258060 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3419:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
     /* 258060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr),
     /* 258063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258065 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258067 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
     /* 258074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 258079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258085 */     GIR_RootConstrainSelectedInstOperands,
     /* 258086 */     // GIR_Coverage, 2874,
     /* 258086 */     GIR_EraseRootFromParent_Done,
     /* 258087 */   // Label 4245: @258087
     /* 258087 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(258126), // Rule ID 2472 //
     /* 258092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 258103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 258109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258113 */     // (intrinsic_wo_chain:{ *:[i32] } 3436:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 258113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258118 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258120 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258122 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258124 */     GIR_RootConstrainSelectedInstOperands,
     /* 258125 */     // GIR_Coverage, 2472,
     /* 258125 */     GIR_EraseRootFromParent_Done,
     /* 258126 */   // Label 4246: @258126
     /* 258126 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(258165), // Rule ID 2474 //
     /* 258131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 258139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 258142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 258148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258152 */     // (intrinsic_wo_chain:{ *:[f32] } 3436:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[f32] } SCSrc_b32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[f32] }:$src2)
     /* 258152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258157 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258159 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258161 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258163 */     GIR_RootConstrainSelectedInstOperands,
     /* 258164 */     // GIR_Coverage, 2474,
     /* 258164 */     GIR_EraseRootFromParent_Done,
     /* 258165 */   // Label 4247: @258165
     /* 258165 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(258204), // Rule ID 2476 //
     /* 258170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 258178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 258181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 258187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258191 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3436:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, v2i16:{ *:[v2i16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2i16] } SCSrc_b32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2i16] }:$src2)
     /* 258191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258198 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258200 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258202 */     GIR_RootConstrainSelectedInstOperands,
     /* 258203 */     // GIR_Coverage, 2476,
     /* 258203 */     GIR_EraseRootFromParent_Done,
     /* 258204 */   // Label 4248: @258204
     /* 258204 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(258243), // Rule ID 2478 //
     /* 258209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 258217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 258220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
     /* 258226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258230 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3436:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, v2f16:{ *:[v2f16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2f16] } SCSrc_b32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$src2)
     /* 258230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258235 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258237 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258239 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258241 */     GIR_RootConstrainSelectedInstOperands,
     /* 258242 */     // GIR_Coverage, 2478,
     /* 258242 */     GIR_EraseRootFromParent_Done,
     /* 258243 */   // Label 4249: @258243
     /* 258243 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(258282), // Rule ID 2480 //
     /* 258248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 258256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 258259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p2s32,
     /* 258265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258269 */     // (intrinsic_wo_chain:{ *:[i32] } 3436:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p2:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 258269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258274 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258276 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258278 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258280 */     GIR_RootConstrainSelectedInstOperands,
     /* 258281 */     // GIR_Coverage, 2480,
     /* 258281 */     GIR_EraseRootFromParent_Done,
     /* 258282 */   // Label 4250: @258282
     /* 258282 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(258321), // Rule ID 2482 //
     /* 258287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 258295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 258298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p3s32,
     /* 258304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258308 */     // (intrinsic_wo_chain:{ *:[i32] } 3436:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p3:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 258308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258315 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258317 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258319 */     GIR_RootConstrainSelectedInstOperands,
     /* 258320 */     // GIR_Coverage, 2482,
     /* 258320 */     GIR_EraseRootFromParent_Done,
     /* 258321 */   // Label 4251: @258321
     /* 258321 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(258360), // Rule ID 2484 //
     /* 258326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 258334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 258337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p5s32,
     /* 258343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258347 */     // (intrinsic_wo_chain:{ *:[i32] } 3436:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p5:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 258347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258356 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258358 */     GIR_RootConstrainSelectedInstOperands,
     /* 258359 */     // GIR_Coverage, 2484,
     /* 258359 */     GIR_EraseRootFromParent_Done,
     /* 258360 */   // Label 4252: @258360
     /* 258360 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(258399), // Rule ID 2486 //
     /* 258365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
     /* 258370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 258373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 258376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 258379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p6s32,
     /* 258382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 258386 */     // (intrinsic_wo_chain:{ *:[i32] } 3436:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p6:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
     /* 258386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
     /* 258389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258391 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 258393 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 258395 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 258397 */     GIR_RootConstrainSelectedInstOperands,
     /* 258398 */     // GIR_Coverage, 2486,
     /* 258398 */     GIR_EraseRootFromParent_Done,
     /* 258399 */   // Label 4253: @258399
     /* 258399 */   GIM_Reject,
     /* 258400 */ // Label 4217: @258400
     /* 258400 */ GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(260873),
     /* 258405 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 258408 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(258510), // Rule ID 2828 //
     /* 258413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 258416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 258421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 258430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 258433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 258437 */     // MIs[0] Operand 5
     /* 258437 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 258448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 258469 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3416:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_threeaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f16:{ *:[v8f16] }:$src2)
     /* 258469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_threeaddr),
     /* 258472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 258479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 258484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 258489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 258494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 258497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 258502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258508 */     GIR_RootConstrainSelectedInstOperands,
     /* 258509 */     // GIR_Coverage, 2828,
     /* 258509 */     GIR_EraseRootFromParent_Done,
     /* 258510 */   // Label 4255: @258510
     /* 258510 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(258612), // Rule ID 2861 //
     /* 258515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 258518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 258523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 258526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 258532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 258535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258539 */     // MIs[0] Operand 5
     /* 258539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 258550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 258571 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3416:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_threeaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f16:{ *:[v4f16] }:$src2)
     /* 258571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_threeaddr),
     /* 258574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 258581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 258586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 258591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 258596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 258599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 258604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258610 */     GIR_RootConstrainSelectedInstOperands,
     /* 258611 */     // GIR_Coverage, 2861,
     /* 258611 */     GIR_EraseRootFromParent_Done,
     /* 258612 */   // Label 4256: @258612
     /* 258612 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(258716), // Rule ID 2827 //
     /* 258617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 258620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 258625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 258634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 258637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 258641 */     // MIs[0] Operand 5
     /* 258641 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 258652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
     /* 258673 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3416:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 258673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_twoaddr),
     /* 258676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 258683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 258688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 258693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 258698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 258703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 258708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258714 */     GIR_RootConstrainSelectedInstOperands,
     /* 258715 */     // GIR_Coverage, 2827,
     /* 258715 */     GIR_EraseRootFromParent_Done,
     /* 258716 */   // Label 4257: @258716
     /* 258716 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(258820), // Rule ID 2860 //
     /* 258721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 258724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 258729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 258732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 258738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 258741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 258745 */     // MIs[0] Operand 5
     /* 258745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 258756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
     /* 258777 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3416:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f16:{ *:[v4f16] }:$src2)
     /* 258777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_twoaddr),
     /* 258780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 258787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 258792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 258797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 258802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 258807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 258812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258818 */     GIR_RootConstrainSelectedInstOperands,
     /* 258819 */     // GIR_Coverage, 2860,
     /* 258819 */     GIR_EraseRootFromParent_Done,
     /* 258820 */   // Label 4258: @258820
     /* 258820 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(258918), // Rule ID 2845 //
     /* 258825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 258828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
     /* 258833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 258836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 258842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 258845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 258848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 258852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 258873 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3396:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 258873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w32_twoaddr),
     /* 258876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 258883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 258888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 258893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 258898 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 258900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 258905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 258910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 258916 */     GIR_RootConstrainSelectedInstOperands,
     /* 258917 */     // GIR_Coverage, 2845,
     /* 258917 */     GIR_EraseRootFromParent_Done,
     /* 258918 */   // Label 4259: @258918
     /* 258918 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(259016), // Rule ID 2847 //
     /* 258923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 258926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
     /* 258931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 258940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 258943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 258946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 258950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 258964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 258971 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3392:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f16:{ *:[v8f16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 258971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w32_twoaddr),
     /* 258974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 258976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 258981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 258986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 258991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 258996 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 258998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 259003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 259008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259014 */     GIR_RootConstrainSelectedInstOperands,
     /* 259015 */     // GIR_Coverage, 2847,
     /* 259015 */     GIR_EraseRootFromParent_Done,
     /* 259016 */   // Label 4260: @259016
     /* 259016 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(259114), // Rule ID 2878 //
     /* 259021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 259024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
     /* 259029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 259038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 259048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 259055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 259062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 259069 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3396:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 259069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w64_twoaddr),
     /* 259072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 259079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 259084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 259089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 259094 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 259101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 259106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259112 */     GIR_RootConstrainSelectedInstOperands,
     /* 259113 */     // GIR_Coverage, 2878,
     /* 259113 */     GIR_EraseRootFromParent_Done,
     /* 259114 */   // Label 4261: @259114
     /* 259114 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(259212), // Rule ID 2880 //
     /* 259119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 259122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
     /* 259127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 259136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 259139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 259153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
     /* 259160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 259167 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3392:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f16:{ *:[v4f16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f16:{ *:[v4f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 259167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w64_twoaddr),
     /* 259170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 259177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 259182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 259187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 259192 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 259199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 259204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259210 */     GIR_RootConstrainSelectedInstOperands,
     /* 259211 */     // GIR_Coverage, 2880,
     /* 259211 */     GIR_EraseRootFromParent_Done,
     /* 259212 */   // Label 4262: @259212
     /* 259212 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(259290), // Rule ID 2830 //
     /* 259217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 259220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 259225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 259234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 259237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 259241 */     // MIs[0] Operand 5
     /* 259241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 259252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 259259 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3414:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_threeaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
     /* 259259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_threeaddr),
     /* 259262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259272 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259288 */     GIR_RootConstrainSelectedInstOperands,
     /* 259289 */     // GIR_Coverage, 2830,
     /* 259289 */     GIR_EraseRootFromParent_Done,
     /* 259290 */   // Label 4263: @259290
     /* 259290 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(259368), // Rule ID 2863 //
     /* 259295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 259298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 259303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 259312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 259315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259319 */     // MIs[0] Operand 5
     /* 259319 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 259330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 259337 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3414:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_threeaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
     /* 259337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_threeaddr),
     /* 259340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259345 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259350 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259366 */     GIR_RootConstrainSelectedInstOperands,
     /* 259367 */     // GIR_Coverage, 2863,
     /* 259367 */     GIR_EraseRootFromParent_Done,
     /* 259368 */   // Label 4264: @259368
     /* 259368 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(259442), // Rule ID 2846 //
     /* 259373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 259376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
     /* 259381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 259384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 259390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 259393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 259400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 259407 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3393:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 259407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr),
     /* 259410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259420 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259422 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 259434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259440 */     GIR_RootConstrainSelectedInstOperands,
     /* 259441 */     // GIR_Coverage, 2846,
     /* 259441 */     GIR_EraseRootFromParent_Done,
     /* 259442 */   // Label 4265: @259442
     /* 259442 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(259516), // Rule ID 2848 //
     /* 259447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 259450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
     /* 259455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 259464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 259467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 259474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 259481 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3391:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 259481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr),
     /* 259484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259494 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259496 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 259508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259514 */     GIR_RootConstrainSelectedInstOperands,
     /* 259515 */     // GIR_Coverage, 2848,
     /* 259515 */     GIR_EraseRootFromParent_Done,
     /* 259516 */   // Label 4266: @259516
     /* 259516 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(259578), // Rule ID 2852 //
     /* 259521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 259524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
     /* 259529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 259532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 259541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 259548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 259555 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3398:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 259555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr),
     /* 259558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259562 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259564 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 259576 */     GIR_RootConstrainSelectedInstOperands,
     /* 259577 */     // GIR_Coverage, 2852,
     /* 259577 */     GIR_EraseRootFromParent_Done,
     /* 259578 */   // Label 4267: @259578
     /* 259578 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(259640), // Rule ID 2853 //
     /* 259583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 259586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
     /* 259591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 259594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 259603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 259610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 259617 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3397:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 259617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr),
     /* 259620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259622 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259624 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259626 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 259638 */     GIR_RootConstrainSelectedInstOperands,
     /* 259639 */     // GIR_Coverage, 2853,
     /* 259639 */     GIR_EraseRootFromParent_Done,
     /* 259640 */   // Label 4268: @259640
     /* 259640 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(259702), // Rule ID 2854 //
     /* 259645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 259648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
     /* 259653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 259656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 259665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 259672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 259679 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3395:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 259679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr),
     /* 259682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259684 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259686 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259688 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 259700 */     GIR_RootConstrainSelectedInstOperands,
     /* 259701 */     // GIR_Coverage, 2854,
     /* 259701 */     GIR_EraseRootFromParent_Done,
     /* 259702 */   // Label 4269: @259702
     /* 259702 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(259764), // Rule ID 2855 //
     /* 259707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 259710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
     /* 259715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 259718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 259721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
     /* 259727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 259734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 259741 */     // (intrinsic_wo_chain:{ *:[v8f32] } 3394:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
     /* 259741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr),
     /* 259744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259746 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259748 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259750 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
     /* 259762 */     GIR_RootConstrainSelectedInstOperands,
     /* 259763 */     // GIR_Coverage, 2855,
     /* 259763 */     GIR_EraseRootFromParent_Done,
     /* 259764 */   // Label 4270: @259764
     /* 259764 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(259838), // Rule ID 2879 //
     /* 259769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 259772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
     /* 259777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 259786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 259796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 259803 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3393:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 259803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr),
     /* 259806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259816 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259818 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 259830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259836 */     GIR_RootConstrainSelectedInstOperands,
     /* 259837 */     // GIR_Coverage, 2879,
     /* 259837 */     GIR_EraseRootFromParent_Done,
     /* 259838 */   // Label 4271: @259838
     /* 259838 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(259912), // Rule ID 2881 //
     /* 259843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 259846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
     /* 259851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 259854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 259857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 259860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 259863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 259870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 259877 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3391:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 259877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr),
     /* 259880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259885 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 259890 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259892 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 259904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259910 */     GIR_RootConstrainSelectedInstOperands,
     /* 259911 */     // GIR_Coverage, 2881,
     /* 259911 */     GIR_EraseRootFromParent_Done,
     /* 259912 */   // Label 4272: @259912
     /* 259912 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(259974), // Rule ID 2885 //
     /* 259917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 259920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
     /* 259925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 259934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 259940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 259944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 259951 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3398:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 259951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr),
     /* 259954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 259956 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 259958 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 259960 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 259962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 259967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 259972 */     GIR_RootConstrainSelectedInstOperands,
     /* 259973 */     // GIR_Coverage, 2885,
     /* 259973 */     GIR_EraseRootFromParent_Done,
     /* 259974 */   // Label 4273: @259974
     /* 259974 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(260036), // Rule ID 2886 //
     /* 259979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 259982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
     /* 259987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 259993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 259996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 260013 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3397:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 260013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr),
     /* 260016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260018 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260020 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260022 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 260024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 260029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 260034 */     GIR_RootConstrainSelectedInstOperands,
     /* 260035 */     // GIR_Coverage, 2886,
     /* 260035 */     GIR_EraseRootFromParent_Done,
     /* 260036 */   // Label 4274: @260036
     /* 260036 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(260098), // Rule ID 2887 //
     /* 260041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 260044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
     /* 260049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 260058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 260075 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3395:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 260075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr),
     /* 260078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260082 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260084 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 260086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 260091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 260096 */     GIR_RootConstrainSelectedInstOperands,
     /* 260097 */     // GIR_Coverage, 2887,
     /* 260097 */     GIR_EraseRootFromParent_Done,
     /* 260098 */   // Label 4275: @260098
     /* 260098 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(260160), // Rule ID 2888 //
     /* 260103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 260106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
     /* 260111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 260114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 260120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 260123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 260126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 260137 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3394:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
     /* 260137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr),
     /* 260140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260142 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260144 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260146 */     GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
     /* 260148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 260153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
     /* 260158 */     GIR_RootConstrainSelectedInstOperands,
     /* 260159 */     // GIR_Coverage, 2888,
     /* 260159 */     GIR_EraseRootFromParent_Done,
     /* 260160 */   // Label 4276: @260160
     /* 260160 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(260232), // Rule ID 2807 //
     /* 260165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 260168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 260173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 260176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 260185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 260189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260196 */     // (intrinsic_wo_chain:{ *:[v16f16] } 3416:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
     /* 260196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w32),
     /* 260199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260209 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260216 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260230 */     GIR_RootConstrainSelectedInstOperands,
     /* 260231 */     // GIR_Coverage, 2807,
     /* 260231 */     GIR_EraseRootFromParent_Done,
     /* 260232 */   // Label 4277: @260232
     /* 260232 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(260304), // Rule ID 2811 //
     /* 260237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 260240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 260245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 260248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 260257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 260261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260268 */     // (intrinsic_wo_chain:{ *:[v16i16] } 3414:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
     /* 260268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w32),
     /* 260271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260276 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260281 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260288 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260302 */     GIR_RootConstrainSelectedInstOperands,
     /* 260303 */     // GIR_Coverage, 2811,
     /* 260303 */     GIR_EraseRootFromParent_Done,
     /* 260304 */   // Label 4278: @260304
     /* 260304 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(260376), // Rule ID 2812 //
     /* 260309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 260312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
     /* 260317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 260320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 260329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 260333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260340 */     // (intrinsic_wo_chain:{ *:[v16f16] } 3417:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
     /* 260340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32),
     /* 260343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260353 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260360 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260374 */     GIR_RootConstrainSelectedInstOperands,
     /* 260375 */     // GIR_Coverage, 2812,
     /* 260375 */     GIR_EraseRootFromParent_Done,
     /* 260376 */   // Label 4279: @260376
     /* 260376 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(260448), // Rule ID 2813 //
     /* 260381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 260384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
     /* 260389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 260392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
     /* 260401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 260405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260412 */     // (intrinsic_wo_chain:{ *:[v16i16] } 3415:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
     /* 260412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32),
     /* 260415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260425 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260432 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260446 */     GIR_RootConstrainSelectedInstOperands,
     /* 260447 */     // GIR_Coverage, 2813,
     /* 260447 */     GIR_EraseRootFromParent_Done,
     /* 260448 */   // Label 4280: @260448
     /* 260448 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(260520), // Rule ID 2817 //
     /* 260453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 260456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
     /* 260461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 260473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260484 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3416:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 260484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w64),
     /* 260487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260492 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260497 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260504 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260518 */     GIR_RootConstrainSelectedInstOperands,
     /* 260519 */     // GIR_Coverage, 2817,
     /* 260519 */     GIR_EraseRootFromParent_Done,
     /* 260520 */   // Label 4281: @260520
     /* 260520 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(260592), // Rule ID 2818 //
     /* 260525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 260528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 260533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 260545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260556 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3414:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
     /* 260556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w64),
     /* 260559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260569 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260576 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260590 */     GIR_RootConstrainSelectedInstOperands,
     /* 260591 */     // GIR_Coverage, 2818,
     /* 260591 */     GIR_EraseRootFromParent_Done,
     /* 260592 */   // Label 4282: @260592
     /* 260592 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(260664), // Rule ID 2819 //
     /* 260597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 260600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
     /* 260605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 260617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260628 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3417:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
     /* 260628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64),
     /* 260631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260641 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260648 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260662 */     GIR_RootConstrainSelectedInstOperands,
     /* 260663 */     // GIR_Coverage, 2819,
     /* 260663 */     GIR_EraseRootFromParent_Done,
     /* 260664 */   // Label 4283: @260664
     /* 260664 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(260736), // Rule ID 2820 //
     /* 260669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 260672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
     /* 260677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 260683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 260686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 260689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
     /* 260700 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3415:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
     /* 260700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64),
     /* 260703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260713 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
     /* 260720 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260734 */     GIR_RootConstrainSelectedInstOperands,
     /* 260735 */     // GIR_Coverage, 2820,
     /* 260735 */     GIR_EraseRootFromParent_Done,
     /* 260736 */   // Label 4284: @260736
     /* 260736 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(260804), // Rule ID 2829 //
     /* 260741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 260744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 260749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 260758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 260761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 260765 */     // MIs[0] Operand 5
     /* 260765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 260776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3414:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
     /* 260776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_twoaddr),
     /* 260779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260789 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260794 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260802 */     GIR_RootConstrainSelectedInstOperands,
     /* 260803 */     // GIR_Coverage, 2829,
     /* 260803 */     GIR_EraseRootFromParent_Done,
     /* 260804 */   // Label 4285: @260804
     /* 260804 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(260872), // Rule ID 2862 //
     /* 260809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 260812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
     /* 260817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 260820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 260826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 260829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 260833 */     // MIs[0] Operand 5
     /* 260833 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
     /* 260844 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3414:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4i16:{ *:[v4i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
     /* 260844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_twoaddr),
     /* 260847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 260854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260857 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 260859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 260862 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 260864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260870 */     GIR_RootConstrainSelectedInstOperands,
     /* 260871 */     // GIR_Coverage, 2862,
     /* 260871 */     GIR_EraseRootFromParent_Done,
     /* 260872 */   // Label 4286: @260872
     /* 260872 */   GIM_Reject,
     /* 260873 */ // Label 4254: @260873
     /* 260873 */ GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(261145),
     /* 260878 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 260881 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(260951), // Rule ID 2425 //
     /* 260886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 260889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
     /* 260894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 260897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 260900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 260904 */     // MIs[0] dpp_ctrl
     /* 260904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 260907 */     // MIs[0] row_mask
     /* 260907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 260910 */     // MIs[0] bank_mask
     /* 260910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260913 */     // MIs[0] bound_ctrl
     /* 260913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260916 */     // (intrinsic_wo_chain:{ *:[i32] } 3170:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 260916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 260919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 260923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 260925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 260931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 260937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 260943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 260949 */     GIR_RootConstrainSelectedInstOperands,
     /* 260950 */     // GIR_Coverage, 2425,
     /* 260950 */     GIR_EraseRootFromParent_Done,
     /* 260951 */   // Label 4288: @260951
     /* 260951 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(261018), // Rule ID 7686 //
     /* 260956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
     /* 260961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 260964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 260967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 260971 */     // MIs[0] dpp_ctrl
     /* 260971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 260974 */     // MIs[0] row_mask
     /* 260974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 260977 */     // MIs[0] bank_mask
     /* 260977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260980 */     // MIs[0] bound_ctrl
     /* 260980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 260983 */     // (intrinsic_wo_chain:{ *:[i64] } 3170:{ *:[iPTR] }, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$src, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 260983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 260986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 260988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 260990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 260992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 260998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 261004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 261010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 261016 */     GIR_RootConstrainSelectedInstOperands,
     /* 261017 */     // GIR_Coverage, 7686,
     /* 261017 */     GIR_EraseRootFromParent_Done,
     /* 261018 */   // Label 4289: @261018
     /* 261018 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(261081), // Rule ID 2683 //
     /* 261023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 261026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16_var),
     /* 261031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 261034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 261043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 261047 */     // MIs[0] fi
     /* 261047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261050 */     // MIs[0] bc
     /* 261050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261053 */     // (intrinsic_wo_chain:{ *:[i32] } 3182:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 261053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_VAR_B32_e64),
     /* 261056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 261064 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261066 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 261072 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 261074 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 261076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261079 */     GIR_RootConstrainSelectedInstOperands,
     /* 261080 */     // GIR_Coverage, 2683,
     /* 261080 */     GIR_EraseRootFromParent_Done,
     /* 261081 */   // Label 4290: @261081
     /* 261081 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(261144), // Rule ID 2684 //
     /* 261086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 261089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16_var),
     /* 261094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 261097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 261100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 261106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 261110 */     // MIs[0] fi
     /* 261110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261113 */     // MIs[0] bc
     /* 261113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 261116 */     // (intrinsic_wo_chain:{ *:[i32] } 3186:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 261116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_VAR_B32_e64),
     /* 261119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 261127 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 261135 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 261137 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 261139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261142 */     GIR_RootConstrainSelectedInstOperands,
     /* 261143 */     // GIR_Coverage, 2684,
     /* 261143 */     GIR_EraseRootFromParent_Done,
     /* 261144 */   // Label 4291: @261144
     /* 261144 */   GIM_Reject,
     /* 261145 */ // Label 4287: @261145
     /* 261145 */ GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(271464),
     /* 261150 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 261153 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(261234), // Rule ID 2832 //
     /* 261158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 261161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 261166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 261169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 261175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 261178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 261182 */     // MIs[0] clamp
     /* 261182 */     // No operand predicates
     /* 261182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 261203 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3425:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_threeaddr),
     /* 261206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261213 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261220 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 261227 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261232 */     GIR_RootConstrainSelectedInstOperands,
     /* 261233 */     // GIR_Coverage, 2832,
     /* 261233 */     GIR_EraseRootFromParent_Done,
     /* 261234 */   // Label 4293: @261234
     /* 261234 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(261315), // Rule ID 2834 //
     /* 261239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 261242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 261247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 261250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 261256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 261259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 261263 */     // MIs[0] clamp
     /* 261263 */     // No operand predicates
     /* 261263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 261284 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3424:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_threeaddr),
     /* 261287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261294 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261301 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 261308 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261313 */     GIR_RootConstrainSelectedInstOperands,
     /* 261314 */     // GIR_Coverage, 2834,
     /* 261314 */     GIR_EraseRootFromParent_Done,
     /* 261315 */   // Label 4294: @261315
     /* 261315 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(261396), // Rule ID 2844 //
     /* 261320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 261323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 261328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 261331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 261337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 261340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 261344 */     // MIs[0] clamp
     /* 261344 */     // No operand predicates
     /* 261344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 261365 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3426:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_threeaddr),
     /* 261368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261375 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261382 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 261389 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261394 */     GIR_RootConstrainSelectedInstOperands,
     /* 261395 */     // GIR_Coverage, 2844,
     /* 261395 */     GIR_EraseRootFromParent_Done,
     /* 261396 */   // Label 4295: @261396
     /* 261396 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(261477), // Rule ID 2865 //
     /* 261401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 261404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 261409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 261418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 261421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261425 */     // MIs[0] clamp
     /* 261425 */     // No operand predicates
     /* 261425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 261446 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3425:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_threeaddr),
     /* 261449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261456 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261463 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 261470 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261475 */     GIR_RootConstrainSelectedInstOperands,
     /* 261476 */     // GIR_Coverage, 2865,
     /* 261476 */     GIR_EraseRootFromParent_Done,
     /* 261477 */   // Label 4296: @261477
     /* 261477 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(261558), // Rule ID 2867 //
     /* 261482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 261485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 261490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 261499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 261502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261506 */     // MIs[0] clamp
     /* 261506 */     // No operand predicates
     /* 261506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 261527 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3424:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_threeaddr),
     /* 261530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261537 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261544 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 261551 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261556 */     GIR_RootConstrainSelectedInstOperands,
     /* 261557 */     // GIR_Coverage, 2867,
     /* 261557 */     GIR_EraseRootFromParent_Done,
     /* 261558 */   // Label 4297: @261558
     /* 261558 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(261639), // Rule ID 2877 //
     /* 261563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 261566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 261571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 261577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 261580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 261583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261587 */     // MIs[0] clamp
     /* 261587 */     // No operand predicates
     /* 261587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
     /* 261608 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3426:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_threeaddr),
     /* 261611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261618 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261625 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 261632 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261637 */     GIR_RootConstrainSelectedInstOperands,
     /* 261638 */     // GIR_Coverage, 2877,
     /* 261638 */     GIR_EraseRootFromParent_Done,
     /* 261639 */   // Label 4298: @261639
     /* 261639 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(261719), // Rule ID 2808 //
     /* 261644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 261647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 261652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 261655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 261661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 261664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 261668 */     // MIs[0] clamp
     /* 261668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261685 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3425:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w32),
     /* 261688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261695 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261702 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 261707 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 261709 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261717 */     GIR_RootConstrainSelectedInstOperands,
     /* 261718 */     // GIR_Coverage, 2808,
     /* 261718 */     GIR_EraseRootFromParent_Done,
     /* 261719 */   // Label 4299: @261719
     /* 261719 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(261799), // Rule ID 2814 //
     /* 261724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
     /* 261727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 261732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 261735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 261741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 261744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 261748 */     // MIs[0] clamp
     /* 261748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261765 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3424:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w32),
     /* 261768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261775 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261782 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 261787 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 261789 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261797 */     GIR_RootConstrainSelectedInstOperands,
     /* 261798 */     // GIR_Coverage, 2814,
     /* 261798 */     GIR_EraseRootFromParent_Done,
     /* 261799 */   // Label 4300: @261799
     /* 261799 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(261879), // Rule ID 2821 //
     /* 261804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 261807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 261812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 261821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 261824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261828 */     // MIs[0] clamp
     /* 261828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3425:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w64),
     /* 261848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261855 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261862 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 261867 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 261869 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261877 */     GIR_RootConstrainSelectedInstOperands,
     /* 261878 */     // GIR_Coverage, 2821,
     /* 261878 */     GIR_EraseRootFromParent_Done,
     /* 261879 */   // Label 4301: @261879
     /* 261879 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(261959), // Rule ID 2822 //
     /* 261884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
     /* 261887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 261892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 261901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 261904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 261908 */     // MIs[0] clamp
     /* 261908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 261911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261925 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3424:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 261925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w64),
     /* 261928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 261930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 261935 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 261937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 261942 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 261944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 261947 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 261949 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 261951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261957 */     GIR_RootConstrainSelectedInstOperands,
     /* 261958 */     // GIR_Coverage, 2822,
     /* 261958 */     GIR_EraseRootFromParent_Done,
     /* 261959 */   // Label 4302: @261959
     /* 261959 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(262030), // Rule ID 2831 //
     /* 261964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 261967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 261972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 261975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 261978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 261981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 261984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 261988 */     // MIs[0] clamp
     /* 261988 */     // No operand predicates
     /* 261988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 261995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262002 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3425:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 262002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_twoaddr),
     /* 262005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 262012 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 262014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 262019 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 262021 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 262023 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 262025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262028 */     GIR_RootConstrainSelectedInstOperands,
     /* 262029 */     // GIR_Coverage, 2831,
     /* 262029 */     GIR_EraseRootFromParent_Done,
     /* 262030 */   // Label 4303: @262030
     /* 262030 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(262101), // Rule ID 2833 //
     /* 262035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 262038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 262043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 262046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 262052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 262055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 262059 */     // MIs[0] clamp
     /* 262059 */     // No operand predicates
     /* 262059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262073 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3424:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 262073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_twoaddr),
     /* 262076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 262083 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 262085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 262090 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 262092 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 262094 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 262096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262099 */     GIR_RootConstrainSelectedInstOperands,
     /* 262100 */     // GIR_Coverage, 2833,
     /* 262100 */     GIR_EraseRootFromParent_Done,
     /* 262101 */   // Label 4304: @262101
     /* 262101 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(262172), // Rule ID 2843 //
     /* 262106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 262109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 262114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 262117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 262120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 262123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 262126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 262130 */     // MIs[0] clamp
     /* 262130 */     // No operand predicates
     /* 262130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262144 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3426:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 262144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_twoaddr),
     /* 262147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 262154 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 262156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 262161 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 262163 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 262165 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 262167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262170 */     GIR_RootConstrainSelectedInstOperands,
     /* 262171 */     // GIR_Coverage, 2843,
     /* 262171 */     GIR_EraseRootFromParent_Done,
     /* 262172 */   // Label 4305: @262172
     /* 262172 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(262243), // Rule ID 2864 //
     /* 262177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 262180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
     /* 262185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 262194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 262197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262201 */     // MIs[0] clamp
     /* 262201 */     // No operand predicates
     /* 262201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3425:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 262215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_twoaddr),
     /* 262218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 262225 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 262227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 262232 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 262234 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 262236 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 262238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262241 */     GIR_RootConstrainSelectedInstOperands,
     /* 262242 */     // GIR_Coverage, 2864,
     /* 262242 */     GIR_EraseRootFromParent_Done,
     /* 262243 */   // Label 4306: @262243
     /* 262243 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(262314), // Rule ID 2866 //
     /* 262248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 262251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
     /* 262256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 262265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 262268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262272 */     // MIs[0] clamp
     /* 262272 */     // No operand predicates
     /* 262272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262286 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3424:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 262286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_twoaddr),
     /* 262289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 262296 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 262298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 262303 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 262305 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 262307 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 262309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262312 */     GIR_RootConstrainSelectedInstOperands,
     /* 262313 */     // GIR_Coverage, 2866,
     /* 262313 */     GIR_EraseRootFromParent_Done,
     /* 262314 */   // Label 4307: @262314
     /* 262314 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(262385), // Rule ID 2876 //
     /* 262319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 262322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
     /* 262327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 262330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 262336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 262339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 262343 */     // MIs[0] clamp
     /* 262343 */     // No operand predicates
     /* 262343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 262357 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3426:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 262357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_twoaddr),
     /* 262360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 262367 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 262369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 262374 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 262376 */     GIR_RootToRootCopy, /*OpIdx*/6, // src2
     /* 262378 */     GIR_RootToRootCopy, /*OpIdx*/7, // clamp
     /* 262380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262383 */     GIR_RootConstrainSelectedInstOperands,
     /* 262384 */     // GIR_Coverage, 2876,
     /* 262384 */     GIR_EraseRootFromParent_Done,
     /* 262385 */   // Label 4308: @262385
     /* 262385 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(262458), // Rule ID 2426 //
     /* 262390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 262401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262411 */     // MIs[0] dpp_ctrl
     /* 262411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262414 */     // MIs[0] row_mask
     /* 262414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262417 */     // MIs[0] bank_mask
     /* 262417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262420 */     // MIs[0] bound_ctrl
     /* 262420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262423 */     // (intrinsic_wo_chain:{ *:[i32] } 3408:{ *:[iPTR] }, i32:{ *:[i32] }:$old, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262428 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262430 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262456 */     GIR_RootConstrainSelectedInstOperands,
     /* 262457 */     // GIR_Coverage, 2426,
     /* 262457 */     GIR_EraseRootFromParent_Done,
     /* 262458 */   // Label 4309: @262458
     /* 262458 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(262531), // Rule ID 2427 //
     /* 262463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 262474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 262477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 262480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262484 */     // MIs[0] dpp_ctrl
     /* 262484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262487 */     // MIs[0] row_mask
     /* 262487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262490 */     // MIs[0] bank_mask
     /* 262490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262493 */     // MIs[0] bound_ctrl
     /* 262493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262496 */     // (intrinsic_wo_chain:{ *:[f32] } 3408:{ *:[iPTR] }, f32:{ *:[f32] }:$old, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[f32] } VGPR_32:{ *:[f32] }:$old, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262501 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262503 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262505 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262517 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262523 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262529 */     GIR_RootConstrainSelectedInstOperands,
     /* 262530 */     // GIR_Coverage, 2427,
     /* 262530 */     GIR_EraseRootFromParent_Done,
     /* 262531 */   // Label 4310: @262531
     /* 262531 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(262604), // Rule ID 2428 //
     /* 262536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 262547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262557 */     // MIs[0] dpp_ctrl
     /* 262557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262560 */     // MIs[0] row_mask
     /* 262560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262563 */     // MIs[0] bank_mask
     /* 262563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262566 */     // MIs[0] bound_ctrl
     /* 262566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262569 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3408:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$old, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$old, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262574 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262576 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262578 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262602 */     GIR_RootConstrainSelectedInstOperands,
     /* 262603 */     // GIR_Coverage, 2428,
     /* 262603 */     GIR_EraseRootFromParent_Done,
     /* 262604 */   // Label 4311: @262604
     /* 262604 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(262677), // Rule ID 2429 //
     /* 262609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 262620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 262623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 262626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262630 */     // MIs[0] dpp_ctrl
     /* 262630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262633 */     // MIs[0] row_mask
     /* 262633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262636 */     // MIs[0] bank_mask
     /* 262636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262639 */     // MIs[0] bound_ctrl
     /* 262639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262642 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3408:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$old, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$old, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262647 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262649 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262651 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262657 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262663 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262669 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262675 */     GIR_RootConstrainSelectedInstOperands,
     /* 262676 */     // GIR_Coverage, 2429,
     /* 262676 */     GIR_EraseRootFromParent_Done,
     /* 262677 */   // Label 4312: @262677
     /* 262677 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(262750), // Rule ID 2430 //
     /* 262682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 262693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 262696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 262699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262703 */     // MIs[0] dpp_ctrl
     /* 262703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262706 */     // MIs[0] row_mask
     /* 262706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262709 */     // MIs[0] bank_mask
     /* 262709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262712 */     // MIs[0] bound_ctrl
     /* 262712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262715 */     // (intrinsic_wo_chain:{ *:[i32] } 3408:{ *:[iPTR] }, p2:{ *:[i32] }:$old, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262720 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262722 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262748 */     GIR_RootConstrainSelectedInstOperands,
     /* 262749 */     // GIR_Coverage, 2430,
     /* 262749 */     GIR_EraseRootFromParent_Done,
     /* 262750 */   // Label 4313: @262750
     /* 262750 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(262823), // Rule ID 2431 //
     /* 262755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 262766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 262769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 262772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262776 */     // MIs[0] dpp_ctrl
     /* 262776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262779 */     // MIs[0] row_mask
     /* 262779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262782 */     // MIs[0] bank_mask
     /* 262782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262785 */     // MIs[0] bound_ctrl
     /* 262785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262788 */     // (intrinsic_wo_chain:{ *:[i32] } 3408:{ *:[iPTR] }, p3:{ *:[i32] }:$old, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262793 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262795 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262821 */     GIR_RootConstrainSelectedInstOperands,
     /* 262822 */     // GIR_Coverage, 2431,
     /* 262822 */     GIR_EraseRootFromParent_Done,
     /* 262823 */   // Label 4314: @262823
     /* 262823 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(262896), // Rule ID 2432 //
     /* 262828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 262839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 262842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 262845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262849 */     // MIs[0] dpp_ctrl
     /* 262849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262852 */     // MIs[0] row_mask
     /* 262852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262855 */     // MIs[0] bank_mask
     /* 262855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262858 */     // MIs[0] bound_ctrl
     /* 262858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262861 */     // (intrinsic_wo_chain:{ *:[i32] } 3408:{ *:[iPTR] }, p5:{ *:[i32] }:$old, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262866 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262868 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262894 */     GIR_RootConstrainSelectedInstOperands,
     /* 262895 */     // GIR_Coverage, 2432,
     /* 262895 */     GIR_EraseRootFromParent_Done,
     /* 262896 */   // Label 4315: @262896
     /* 262896 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(262969), // Rule ID 2433 //
     /* 262901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 262904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 262912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 262915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 262918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 262922 */     // MIs[0] dpp_ctrl
     /* 262922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262925 */     // MIs[0] row_mask
     /* 262925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262928 */     // MIs[0] bank_mask
     /* 262928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 262931 */     // MIs[0] bound_ctrl
     /* 262931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 262934 */     // (intrinsic_wo_chain:{ *:[i32] } 3408:{ *:[iPTR] }, p6:{ *:[i32] }:$old, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 262934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
     /* 262937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 262939 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 262941 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 262943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 262949 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 262955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 262961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 262967 */     GIR_RootConstrainSelectedInstOperands,
     /* 262968 */     // GIR_Coverage, 2433,
     /* 262968 */     GIR_EraseRootFromParent_Done,
     /* 262969 */   // Label 4316: @262969
     /* 262969 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(263039), // Rule ID 7687 //
     /* 262974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 262979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 262982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 262985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 262988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 262992 */     // MIs[0] dpp_ctrl
     /* 262992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 262995 */     // MIs[0] row_mask
     /* 262995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262998 */     // MIs[0] bank_mask
     /* 262998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263001 */     // MIs[0] bound_ctrl
     /* 263001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263004 */     // (intrinsic_wo_chain:{ *:[i64] } 3408:{ *:[iPTR] }, i64:{ *:[i64] }:$old, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263009 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263011 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263037 */     GIR_RootConstrainSelectedInstOperands,
     /* 263038 */     // GIR_Coverage, 7687,
     /* 263038 */     GIR_EraseRootFromParent_Done,
     /* 263039 */   // Label 4317: @263039
     /* 263039 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(263109), // Rule ID 7688 //
     /* 263044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 263052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 263055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 263058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263062 */     // MIs[0] dpp_ctrl
     /* 263062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263065 */     // MIs[0] row_mask
     /* 263065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263068 */     // MIs[0] bank_mask
     /* 263068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263071 */     // MIs[0] bound_ctrl
     /* 263071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263074 */     // (intrinsic_wo_chain:{ *:[f64] } 3408:{ *:[iPTR] }, f64:{ *:[f64] }:$old, f64:{ *:[f64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[f64] } VReg_64_Align2:{ *:[f64] }:$old, VReg_64_Align2:{ *:[f64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263079 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263081 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263107 */     GIR_RootConstrainSelectedInstOperands,
     /* 263108 */     // GIR_Coverage, 7688,
     /* 263108 */     GIR_EraseRootFromParent_Done,
     /* 263109 */   // Label 4318: @263109
     /* 263109 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(263179), // Rule ID 7689 //
     /* 263114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 263122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 263125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 263128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263132 */     // MIs[0] dpp_ctrl
     /* 263132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263135 */     // MIs[0] row_mask
     /* 263135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263138 */     // MIs[0] bank_mask
     /* 263138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263141 */     // MIs[0] bound_ctrl
     /* 263141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263144 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3408:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$old, v2i32:{ *:[v2i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2i32] } VReg_64_Align2:{ *:[v2i32] }:$old, VReg_64_Align2:{ *:[v2i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263149 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263151 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263153 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263159 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263165 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263177 */     GIR_RootConstrainSelectedInstOperands,
     /* 263178 */     // GIR_Coverage, 7689,
     /* 263178 */     GIR_EraseRootFromParent_Done,
     /* 263179 */   // Label 4319: @263179
     /* 263179 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(263249), // Rule ID 7690 //
     /* 263184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 263192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 263195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 263198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263202 */     // MIs[0] dpp_ctrl
     /* 263202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263205 */     // MIs[0] row_mask
     /* 263205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263208 */     // MIs[0] bank_mask
     /* 263208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263211 */     // MIs[0] bound_ctrl
     /* 263211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263214 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3408:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$old, v2f32:{ *:[v2f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2f32] } VReg_64_Align2:{ *:[v2f32] }:$old, VReg_64_Align2:{ *:[v2f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263219 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263221 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263241 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263247 */     GIR_RootConstrainSelectedInstOperands,
     /* 263248 */     // GIR_Coverage, 7690,
     /* 263248 */     GIR_EraseRootFromParent_Done,
     /* 263249 */   // Label 4320: @263249
     /* 263249 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(263319), // Rule ID 7691 //
     /* 263254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 263262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263272 */     // MIs[0] dpp_ctrl
     /* 263272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263275 */     // MIs[0] row_mask
     /* 263275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263278 */     // MIs[0] bank_mask
     /* 263278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263281 */     // MIs[0] bound_ctrl
     /* 263281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263284 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3408:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$old, v4i16:{ *:[v4i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4i16] } VReg_64_Align2:{ *:[v4i16] }:$old, VReg_64_Align2:{ *:[v4i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263289 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263291 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263317 */     GIR_RootConstrainSelectedInstOperands,
     /* 263318 */     // GIR_Coverage, 7691,
     /* 263318 */     GIR_EraseRootFromParent_Done,
     /* 263319 */   // Label 4321: @263319
     /* 263319 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(263389), // Rule ID 7692 //
     /* 263324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 263332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 263338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263342 */     // MIs[0] dpp_ctrl
     /* 263342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263345 */     // MIs[0] row_mask
     /* 263345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263348 */     // MIs[0] bank_mask
     /* 263348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263351 */     // MIs[0] bound_ctrl
     /* 263351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263354 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3408:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$old, v4f16:{ *:[v4f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4f16] } VReg_64_Align2:{ *:[v4f16] }:$old, VReg_64_Align2:{ *:[v4f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263359 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263361 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263387 */     GIR_RootConstrainSelectedInstOperands,
     /* 263388 */     // GIR_Coverage, 7692,
     /* 263388 */     GIR_EraseRootFromParent_Done,
     /* 263389 */   // Label 4322: @263389
     /* 263389 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(263459), // Rule ID 7693 //
     /* 263394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p0s64,
     /* 263402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 263405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 263408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263412 */     // MIs[0] dpp_ctrl
     /* 263412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263415 */     // MIs[0] row_mask
     /* 263415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263418 */     // MIs[0] bank_mask
     /* 263418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263421 */     // MIs[0] bound_ctrl
     /* 263421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263424 */     // (intrinsic_wo_chain:{ *:[i64] } 3408:{ *:[iPTR] }, p0:{ *:[i64] }:$old, p0:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263429 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263451 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263457 */     GIR_RootConstrainSelectedInstOperands,
     /* 263458 */     // GIR_Coverage, 7693,
     /* 263458 */     GIR_EraseRootFromParent_Done,
     /* 263459 */   // Label 4323: @263459
     /* 263459 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(263529), // Rule ID 7694 //
     /* 263464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p1s64,
     /* 263472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p1s64,
     /* 263475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p1s64,
     /* 263478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263482 */     // MIs[0] dpp_ctrl
     /* 263482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263485 */     // MIs[0] row_mask
     /* 263485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263488 */     // MIs[0] bank_mask
     /* 263488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263491 */     // MIs[0] bound_ctrl
     /* 263491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263494 */     // (intrinsic_wo_chain:{ *:[i64] } 3408:{ *:[iPTR] }, p1:{ *:[i64] }:$old, p1:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263499 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263501 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263527 */     GIR_RootConstrainSelectedInstOperands,
     /* 263528 */     // GIR_Coverage, 7694,
     /* 263528 */     GIR_EraseRootFromParent_Done,
     /* 263529 */   // Label 4324: @263529
     /* 263529 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(263599), // Rule ID 7695 //
     /* 263534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
     /* 263539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p4s64,
     /* 263542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p4s64,
     /* 263545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p4s64,
     /* 263548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 263552 */     // MIs[0] dpp_ctrl
     /* 263552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 263555 */     // MIs[0] row_mask
     /* 263555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263558 */     // MIs[0] bank_mask
     /* 263558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263561 */     // MIs[0] bound_ctrl
     /* 263561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263564 */     // (intrinsic_wo_chain:{ *:[i64] } 3408:{ *:[iPTR] }, p4:{ *:[i64] }:$old, p4:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
     /* 263564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
     /* 263567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263569 */     GIR_RootToRootCopy, /*OpIdx*/2, // old
     /* 263571 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 263573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
     /* 263579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
     /* 263585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
     /* 263591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
     /* 263597 */     GIR_RootConstrainSelectedInstOperands,
     /* 263598 */     // GIR_Coverage, 7695,
     /* 263598 */     GIR_EraseRootFromParent_Done,
     /* 263599 */   // Label 4325: @263599
     /* 263599 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(263670), // Rule ID 2658 //
     /* 263604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 263607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 263612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 263615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 263618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 263621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 263624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 263627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 263631 */     // MIs[0] fi
     /* 263631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263634 */     // MIs[0] bc
     /* 263634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263637 */     // (intrinsic_wo_chain:{ *:[i32] } 3180:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 263637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 263640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 263648 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 263650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 263656 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 263658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263661 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 263663 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 263665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263668 */     GIR_RootConstrainSelectedInstOperands,
     /* 263669 */     // GIR_Coverage, 2658,
     /* 263669 */     GIR_EraseRootFromParent_Done,
     /* 263670 */   // Label 4326: @263670
     /* 263670 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(263741), // Rule ID 2659 //
     /* 263675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 263678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 263683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 263686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 263689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 263692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 263695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 263698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 263702 */     // MIs[0] fi
     /* 263702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263705 */     // MIs[0] bc
     /* 263705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263708 */     // (intrinsic_wo_chain:{ *:[i32] } 3185:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 263708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 263711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263713 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 263719 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 263721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 263727 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 263729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263732 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 263734 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 263736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263739 */     GIR_RootConstrainSelectedInstOperands,
     /* 263740 */     // GIR_Coverage, 2659,
     /* 263740 */     GIR_EraseRootFromParent_Done,
     /* 263741 */   // Label 4327: @263741
     /* 263741 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(263812), // Rule ID 2660 //
     /* 263746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 263749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 263754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 263757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 263760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 263763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 263766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 263769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 263773 */     // MIs[0] fi
     /* 263773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263776 */     // MIs[0] bc
     /* 263776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263779 */     // (intrinsic_wo_chain:{ *:[f32] } 3180:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
     /* 263779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 263782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 263790 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 263792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 263798 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 263800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263803 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 263805 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 263807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263810 */     GIR_RootConstrainSelectedInstOperands,
     /* 263811 */     // GIR_Coverage, 2660,
     /* 263811 */     GIR_EraseRootFromParent_Done,
     /* 263812 */   // Label 4328: @263812
     /* 263812 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(263883), // Rule ID 2661 //
     /* 263817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 263820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 263825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 263828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 263831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 263834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 263837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 263840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 263844 */     // MIs[0] fi
     /* 263844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263847 */     // MIs[0] bc
     /* 263847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263850 */     // (intrinsic_wo_chain:{ *:[f32] } 3185:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
     /* 263850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 263853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 263861 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 263863 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 263869 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 263871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263874 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 263876 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 263878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263881 */     GIR_RootConstrainSelectedInstOperands,
     /* 263882 */     // GIR_Coverage, 2661,
     /* 263882 */     GIR_EraseRootFromParent_Done,
     /* 263883 */   // Label 4329: @263883
     /* 263883 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(263954), // Rule ID 2662 //
     /* 263888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 263891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 263896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 263899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 263902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 263905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 263908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 263911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 263915 */     // MIs[0] fi
     /* 263915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263918 */     // MIs[0] bc
     /* 263918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263921 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3180:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 263921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 263924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 263932 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 263934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 263940 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 263942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263945 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 263947 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 263949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263952 */     GIR_RootConstrainSelectedInstOperands,
     /* 263953 */     // GIR_Coverage, 2662,
     /* 263953 */     GIR_EraseRootFromParent_Done,
     /* 263954 */   // Label 4330: @263954
     /* 263954 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(264025), // Rule ID 2663 //
     /* 263959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 263962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 263967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 263970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 263973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 263976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 263979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 263982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 263986 */     // MIs[0] fi
     /* 263986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 263989 */     // MIs[0] bc
     /* 263989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 263992 */     // (intrinsic_wo_chain:{ *:[v2i16] } 3185:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
     /* 263992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 263995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 263997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264003 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264011 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264016 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264018 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264023 */     GIR_RootConstrainSelectedInstOperands,
     /* 264024 */     // GIR_Coverage, 2663,
     /* 264024 */     GIR_EraseRootFromParent_Done,
     /* 264025 */   // Label 4331: @264025
     /* 264025 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(264096), // Rule ID 2664 //
     /* 264030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 264038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 264041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 264044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 264047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264057 */     // MIs[0] fi
     /* 264057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264060 */     // MIs[0] bc
     /* 264060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264063 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3180:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 264063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 264066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264068 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264074 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264082 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264087 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264089 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264094 */     GIR_RootConstrainSelectedInstOperands,
     /* 264095 */     // GIR_Coverage, 2664,
     /* 264095 */     GIR_EraseRootFromParent_Done,
     /* 264096 */   // Label 4332: @264096
     /* 264096 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(264167), // Rule ID 2665 //
     /* 264101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 264109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 264112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 264115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 264118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264128 */     // MIs[0] fi
     /* 264128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264131 */     // MIs[0] bc
     /* 264131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264134 */     // (intrinsic_wo_chain:{ *:[v2f16] } 3185:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
     /* 264134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 264137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264145 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264153 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264158 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264160 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264165 */     GIR_RootConstrainSelectedInstOperands,
     /* 264166 */     // GIR_Coverage, 2665,
     /* 264166 */     GIR_EraseRootFromParent_Done,
     /* 264167 */   // Label 4333: @264167
     /* 264167 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(264238), // Rule ID 2666 //
     /* 264172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 264180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 264183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 264186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 264189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264199 */     // MIs[0] fi
     /* 264199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264202 */     // MIs[0] bc
     /* 264202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264205 */     // (intrinsic_wo_chain:{ *:[i32] } 3180:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 264208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264216 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264224 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264229 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264231 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264236 */     GIR_RootConstrainSelectedInstOperands,
     /* 264237 */     // GIR_Coverage, 2666,
     /* 264237 */     GIR_EraseRootFromParent_Done,
     /* 264238 */   // Label 4334: @264238
     /* 264238 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(264309), // Rule ID 2667 //
     /* 264243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 264251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
     /* 264254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
     /* 264257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
     /* 264260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264270 */     // MIs[0] fi
     /* 264270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264273 */     // MIs[0] bc
     /* 264273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264276 */     // (intrinsic_wo_chain:{ *:[i32] } 3185:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 264279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264281 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264287 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264295 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264300 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264302 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264307 */     GIR_RootConstrainSelectedInstOperands,
     /* 264308 */     // GIR_Coverage, 2667,
     /* 264308 */     GIR_EraseRootFromParent_Done,
     /* 264309 */   // Label 4335: @264309
     /* 264309 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(264380), // Rule ID 2668 //
     /* 264314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 264322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 264325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 264328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 264331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264341 */     // MIs[0] fi
     /* 264341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264344 */     // MIs[0] bc
     /* 264344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264347 */     // (intrinsic_wo_chain:{ *:[i32] } 3180:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 264350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264358 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264366 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264371 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264373 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264378 */     GIR_RootConstrainSelectedInstOperands,
     /* 264379 */     // GIR_Coverage, 2668,
     /* 264379 */     GIR_EraseRootFromParent_Done,
     /* 264380 */   // Label 4336: @264380
     /* 264380 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(264451), // Rule ID 2669 //
     /* 264385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 264393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
     /* 264396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
     /* 264399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
     /* 264402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264412 */     // MIs[0] fi
     /* 264412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264415 */     // MIs[0] bc
     /* 264415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264418 */     // (intrinsic_wo_chain:{ *:[i32] } 3185:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 264421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264429 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264437 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264442 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264444 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264449 */     GIR_RootConstrainSelectedInstOperands,
     /* 264450 */     // GIR_Coverage, 2669,
     /* 264450 */     GIR_EraseRootFromParent_Done,
     /* 264451 */   // Label 4337: @264451
     /* 264451 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(264522), // Rule ID 2670 //
     /* 264456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 264464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 264467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 264470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 264473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264483 */     // MIs[0] fi
     /* 264483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264486 */     // MIs[0] bc
     /* 264486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264489 */     // (intrinsic_wo_chain:{ *:[i32] } 3180:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 264492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264500 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264508 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264513 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264515 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264520 */     GIR_RootConstrainSelectedInstOperands,
     /* 264521 */     // GIR_Coverage, 2670,
     /* 264521 */     GIR_EraseRootFromParent_Done,
     /* 264522 */   // Label 4338: @264522
     /* 264522 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(264593), // Rule ID 2671 //
     /* 264527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 264535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
     /* 264538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
     /* 264541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
     /* 264544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264554 */     // MIs[0] fi
     /* 264554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264557 */     // MIs[0] bc
     /* 264557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264560 */     // (intrinsic_wo_chain:{ *:[i32] } 3185:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 264563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264565 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264571 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264579 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264584 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264586 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264591 */     GIR_RootConstrainSelectedInstOperands,
     /* 264592 */     // GIR_Coverage, 2671,
     /* 264592 */     GIR_EraseRootFromParent_Done,
     /* 264593 */   // Label 4339: @264593
     /* 264593 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(264664), // Rule ID 2672 //
     /* 264598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
     /* 264606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 264609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 264612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 264615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264625 */     // MIs[0] fi
     /* 264625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264628 */     // MIs[0] bc
     /* 264628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264631 */     // (intrinsic_wo_chain:{ *:[i32] } 3180:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
     /* 264634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264642 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264644 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264650 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264655 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264657 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264662 */     GIR_RootConstrainSelectedInstOperands,
     /* 264663 */     // GIR_Coverage, 2672,
     /* 264663 */     GIR_EraseRootFromParent_Done,
     /* 264664 */   // Label 4340: @264664
     /* 264664 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(264735), // Rule ID 2673 //
     /* 264669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
     /* 264672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
     /* 264677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
     /* 264680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
     /* 264683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
     /* 264686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 264689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 264692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 264696 */     // MIs[0] fi
     /* 264696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264699 */     // MIs[0] bc
     /* 264699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264702 */     // (intrinsic_wo_chain:{ *:[i32] } 3185:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
     /* 264702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
     /* 264705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264707 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
     /* 264713 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 264715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
     /* 264721 */     GIR_RootToRootCopy, /*OpIdx*/4, // src1
     /* 264723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264726 */     GIR_RootToRootCopy, /*OpIdx*/5, // src2
     /* 264728 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
     /* 264730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264733 */     GIR_RootConstrainSelectedInstOperands,
     /* 264734 */     // GIR_Coverage, 2673,
     /* 264734 */     GIR_EraseRootFromParent_Done,
     /* 264735 */   // Label 4341: @264735
     /* 264735 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(264796), // Rule ID 1124 //
     /* 264740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 264743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
     /* 264748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 264754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 264757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 264764 */     // MIs[0] cbsz
     /* 264764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264767 */     // MIs[0] abid
     /* 264767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264770 */     // MIs[0] blgp
     /* 264770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23268),
     /* 264777 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3153:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23268>>  =>  (V_MFMA_F32_4X4X1F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_e64),
     /* 264780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264784 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264786 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264788 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264790 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264792 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264794 */     GIR_RootConstrainSelectedInstOperands,
     /* 264795 */     // GIR_Coverage, 1124,
     /* 264795 */     GIR_EraseRootFromParent_Done,
     /* 264796 */   // Label 4342: @264796
     /* 264796 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(264857), // Rule ID 1125 //
     /* 264801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 264804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
     /* 264809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 264815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 264818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 264821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 264825 */     // MIs[0] cbsz
     /* 264825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264828 */     // MIs[0] abid
     /* 264828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264831 */     // MIs[0] blgp
     /* 264831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23270),
     /* 264838 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3153:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23270>>  =>  (V_MFMA_F32_4X4X1F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_vgprcd_e64),
     /* 264841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264843 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264845 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264847 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264849 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264851 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264853 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264855 */     GIR_RootConstrainSelectedInstOperands,
     /* 264856 */     // GIR_Coverage, 1125,
     /* 264856 */     GIR_EraseRootFromParent_Done,
     /* 264857 */   // Label 4343: @264857
     /* 264857 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(264918), // Rule ID 1126 //
     /* 264862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 264865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
     /* 264870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 264876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 264879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 264886 */     // MIs[0] cbsz
     /* 264886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264889 */     // MIs[0] abid
     /* 264889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264892 */     // MIs[0] blgp
     /* 264892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23274),
     /* 264899 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3125:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23274>>  =>  (V_MFMA_F32_16X16X1F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_e64),
     /* 264902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264904 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264906 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264908 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264910 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264912 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264914 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264916 */     GIR_RootConstrainSelectedInstOperands,
     /* 264917 */     // GIR_Coverage, 1126,
     /* 264917 */     GIR_EraseRootFromParent_Done,
     /* 264918 */   // Label 4344: @264918
     /* 264918 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(264979), // Rule ID 1127 //
     /* 264923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 264926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
     /* 264931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 264934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 264937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 264940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 264943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 264947 */     // MIs[0] cbsz
     /* 264947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264950 */     // MIs[0] abid
     /* 264950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 264953 */     // MIs[0] blgp
     /* 264953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 264956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23276),
     /* 264960 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3125:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23276>>  =>  (V_MFMA_F32_16X16X1F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 264960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_vgprcd_e64),
     /* 264963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 264965 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 264967 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 264969 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 264971 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 264973 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 264975 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 264977 */     GIR_RootConstrainSelectedInstOperands,
     /* 264978 */     // GIR_Coverage, 1127,
     /* 264978 */     GIR_EraseRootFromParent_Done,
     /* 264979 */   // Label 4345: @264979
     /* 264979 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(265040), // Rule ID 1128 //
     /* 264984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 264987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
     /* 264992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 264995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 264998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265008 */     // MIs[0] cbsz
     /* 265008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265011 */     // MIs[0] abid
     /* 265011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265014 */     // MIs[0] blgp
     /* 265014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23278),
     /* 265021 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3135:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23278>>  =>  (V_MFMA_F32_16X16X4F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_e64),
     /* 265024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265028 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265030 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265032 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265034 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265036 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265038 */     GIR_RootConstrainSelectedInstOperands,
     /* 265039 */     // GIR_Coverage, 1128,
     /* 265039 */     GIR_EraseRootFromParent_Done,
     /* 265040 */   // Label 4346: @265040
     /* 265040 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(265101), // Rule ID 1129 //
     /* 265045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
     /* 265053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265069 */     // MIs[0] cbsz
     /* 265069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265072 */     // MIs[0] abid
     /* 265072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265075 */     // MIs[0] blgp
     /* 265075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265078 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23280),
     /* 265082 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3135:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23280>>  =>  (V_MFMA_F32_16X16X4F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_vgprcd_e64),
     /* 265085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265087 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265089 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265091 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265093 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265095 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265097 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265099 */     GIR_RootConstrainSelectedInstOperands,
     /* 265100 */     // GIR_Coverage, 1129,
     /* 265100 */     GIR_EraseRootFromParent_Done,
     /* 265101 */   // Label 4347: @265101
     /* 265101 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(265162), // Rule ID 1130 //
     /* 265106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
     /* 265114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 265117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 265126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 265130 */     // MIs[0] cbsz
     /* 265130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265133 */     // MIs[0] abid
     /* 265133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265136 */     // MIs[0] blgp
     /* 265136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23284),
     /* 265143 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3144:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23284>>  =>  (V_MFMA_F32_32X32X1F32_mac_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_e64),
     /* 265146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265150 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265152 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265154 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265156 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265158 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265160 */     GIR_RootConstrainSelectedInstOperands,
     /* 265161 */     // GIR_Coverage, 1130,
     /* 265161 */     GIR_EraseRootFromParent_Done,
     /* 265162 */   // Label 4348: @265162
     /* 265162 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(265223), // Rule ID 1131 //
     /* 265167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
     /* 265175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 265178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 265187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 265191 */     // MIs[0] cbsz
     /* 265191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265194 */     // MIs[0] abid
     /* 265194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265197 */     // MIs[0] blgp
     /* 265197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23286),
     /* 265204 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3144:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23286>>  =>  (V_MFMA_F32_32X32X1F32_mac_vgprcd_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_vgprcd_e64),
     /* 265207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265211 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265213 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265215 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265217 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265219 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265221 */     GIR_RootConstrainSelectedInstOperands,
     /* 265222 */     // GIR_Coverage, 1131,
     /* 265222 */     GIR_EraseRootFromParent_Done,
     /* 265223 */   // Label 4349: @265223
     /* 265223 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(265284), // Rule ID 1132 //
     /* 265228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
     /* 265236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265252 */     // MIs[0] cbsz
     /* 265252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265255 */     // MIs[0] abid
     /* 265255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265258 */     // MIs[0] blgp
     /* 265258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23288),
     /* 265265 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3146:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23288>>  =>  (V_MFMA_F32_32X32X2F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_e64),
     /* 265268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265270 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265272 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265274 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265276 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265278 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265280 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265282 */     GIR_RootConstrainSelectedInstOperands,
     /* 265283 */     // GIR_Coverage, 1132,
     /* 265283 */     GIR_EraseRootFromParent_Done,
     /* 265284 */   // Label 4350: @265284
     /* 265284 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(265345), // Rule ID 1133 //
     /* 265289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
     /* 265297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265313 */     // MIs[0] cbsz
     /* 265313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265316 */     // MIs[0] abid
     /* 265316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265319 */     // MIs[0] blgp
     /* 265319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23290),
     /* 265326 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3146:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23290>>  =>  (V_MFMA_F32_32X32X2F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_vgprcd_e64),
     /* 265329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265331 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265333 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265335 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265337 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265339 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265341 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265343 */     GIR_RootConstrainSelectedInstOperands,
     /* 265344 */     // GIR_Coverage, 1133,
     /* 265344 */     GIR_EraseRootFromParent_Done,
     /* 265345 */   // Label 4351: @265345
     /* 265345 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(265406), // Rule ID 1134 //
     /* 265350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
     /* 265358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265374 */     // MIs[0] cbsz
     /* 265374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265377 */     // MIs[0] abid
     /* 265377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265380 */     // MIs[0] blgp
     /* 265380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23292),
     /* 265387 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3156:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23292>>  =>  (V_MFMA_F32_4X4X4F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_e64),
     /* 265390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265394 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265396 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265398 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265400 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265402 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265404 */     GIR_RootConstrainSelectedInstOperands,
     /* 265405 */     // GIR_Coverage, 1134,
     /* 265405 */     GIR_EraseRootFromParent_Done,
     /* 265406 */   // Label 4352: @265406
     /* 265406 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(265467), // Rule ID 1135 //
     /* 265411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
     /* 265419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265435 */     // MIs[0] cbsz
     /* 265435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265438 */     // MIs[0] abid
     /* 265438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265441 */     // MIs[0] blgp
     /* 265441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23294),
     /* 265448 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3156:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23294>>  =>  (V_MFMA_F32_4X4X4F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_vgprcd_e64),
     /* 265451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265455 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265457 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265459 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265461 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265463 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265465 */     GIR_RootConstrainSelectedInstOperands,
     /* 265466 */     // GIR_Coverage, 1135,
     /* 265466 */     GIR_EraseRootFromParent_Done,
     /* 265467 */   // Label 4353: @265467
     /* 265467 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(265528), // Rule ID 1136 //
     /* 265472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
     /* 265480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265496 */     // MIs[0] cbsz
     /* 265496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265499 */     // MIs[0] abid
     /* 265499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265502 */     // MIs[0] blgp
     /* 265502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23296),
     /* 265509 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3167:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23296>>  =>  (V_MFMA_I32_4X4X4I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_e64),
     /* 265512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265516 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265518 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265520 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265522 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265524 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265526 */     GIR_RootConstrainSelectedInstOperands,
     /* 265527 */     // GIR_Coverage, 1136,
     /* 265527 */     GIR_EraseRootFromParent_Done,
     /* 265528 */   // Label 4354: @265528
     /* 265528 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(265589), // Rule ID 1137 //
     /* 265533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
     /* 265541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265557 */     // MIs[0] cbsz
     /* 265557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265560 */     // MIs[0] abid
     /* 265560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265563 */     // MIs[0] blgp
     /* 265563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23298),
     /* 265570 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3167:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23298>>  =>  (V_MFMA_I32_4X4X4I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_vgprcd_e64),
     /* 265573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265575 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265577 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265579 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265581 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265583 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265585 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265587 */     GIR_RootConstrainSelectedInstOperands,
     /* 265588 */     // GIR_Coverage, 1137,
     /* 265588 */     GIR_EraseRootFromParent_Done,
     /* 265589 */   // Label 4355: @265589
     /* 265589 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(265650), // Rule ID 1138 //
     /* 265594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
     /* 265602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265618 */     // MIs[0] cbsz
     /* 265618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265621 */     // MIs[0] abid
     /* 265621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265624 */     // MIs[0] blgp
     /* 265624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23302),
     /* 265631 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3134:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23302>>  =>  (V_MFMA_F32_16X16X4F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_e64),
     /* 265634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265638 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265640 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265642 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265644 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265646 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265648 */     GIR_RootConstrainSelectedInstOperands,
     /* 265649 */     // GIR_Coverage, 1138,
     /* 265649 */     GIR_EraseRootFromParent_Done,
     /* 265650 */   // Label 4356: @265650
     /* 265650 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(265711), // Rule ID 1139 //
     /* 265655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
     /* 265663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265679 */     // MIs[0] cbsz
     /* 265679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265682 */     // MIs[0] abid
     /* 265682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265685 */     // MIs[0] blgp
     /* 265685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23304),
     /* 265692 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3134:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23304>>  =>  (V_MFMA_F32_16X16X4F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_vgprcd_e64),
     /* 265695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265699 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265701 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265703 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265705 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265707 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265709 */     GIR_RootConstrainSelectedInstOperands,
     /* 265710 */     // GIR_Coverage, 1139,
     /* 265710 */     GIR_EraseRootFromParent_Done,
     /* 265711 */   // Label 4357: @265711
     /* 265711 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(265772), // Rule ID 1140 //
     /* 265716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
     /* 265724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 265740 */     // MIs[0] cbsz
     /* 265740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265743 */     // MIs[0] abid
     /* 265743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265746 */     // MIs[0] blgp
     /* 265746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23306),
     /* 265753 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3124:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23306>>  =>  (V_MFMA_F32_16X16X16F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_e64),
     /* 265756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265760 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265762 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265764 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265766 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265768 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265770 */     GIR_RootConstrainSelectedInstOperands,
     /* 265771 */     // GIR_Coverage, 1140,
     /* 265771 */     GIR_EraseRootFromParent_Done,
     /* 265772 */   // Label 4358: @265772
     /* 265772 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(265833), // Rule ID 1141 //
     /* 265777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
     /* 265785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 265788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 265797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 265801 */     // MIs[0] cbsz
     /* 265801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265804 */     // MIs[0] abid
     /* 265804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265807 */     // MIs[0] blgp
     /* 265807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23308),
     /* 265814 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3124:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23308>>  =>  (V_MFMA_F32_16X16X16F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_vgprcd_e64),
     /* 265817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265821 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265823 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265825 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265827 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265829 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265831 */     GIR_RootConstrainSelectedInstOperands,
     /* 265832 */     // GIR_Coverage, 1141,
     /* 265832 */     GIR_EraseRootFromParent_Done,
     /* 265833 */   // Label 4359: @265833
     /* 265833 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(265894), // Rule ID 1142 //
     /* 265838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
     /* 265846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 265862 */     // MIs[0] cbsz
     /* 265862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265865 */     // MIs[0] abid
     /* 265865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265868 */     // MIs[0] blgp
     /* 265868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23312),
     /* 265875 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3161:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23312>>  =>  (V_MFMA_I32_16X16X4I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_e64),
     /* 265878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265882 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265884 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265886 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265888 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265890 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265892 */     GIR_RootConstrainSelectedInstOperands,
     /* 265893 */     // GIR_Coverage, 1142,
     /* 265893 */     GIR_EraseRootFromParent_Done,
     /* 265894 */   // Label 4360: @265894
     /* 265894 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(265955), // Rule ID 1143 //
     /* 265899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 265902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
     /* 265907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 265910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 265913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 265916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 265919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 265923 */     // MIs[0] cbsz
     /* 265923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265926 */     // MIs[0] abid
     /* 265926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265929 */     // MIs[0] blgp
     /* 265929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23314),
     /* 265936 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3161:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23314>>  =>  (V_MFMA_I32_16X16X4I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_vgprcd_e64),
     /* 265939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 265941 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 265943 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 265945 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 265947 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 265949 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 265951 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 265953 */     GIR_RootConstrainSelectedInstOperands,
     /* 265954 */     // GIR_Coverage, 1143,
     /* 265954 */     GIR_EraseRootFromParent_Done,
     /* 265955 */   // Label 4361: @265955
     /* 265955 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(266016), // Rule ID 1144 //
     /* 265960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 265963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
     /* 265968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 265971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 265977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 265980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 265984 */     // MIs[0] cbsz
     /* 265984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 265987 */     // MIs[0] abid
     /* 265987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 265990 */     // MIs[0] blgp
     /* 265990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 265993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23318),
     /* 265997 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3150:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23318>>  =>  (V_MFMA_F32_32X32X4F16_mac_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 265997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_e64),
     /* 266000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266002 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266004 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266006 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266008 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266010 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266012 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266014 */     GIR_RootConstrainSelectedInstOperands,
     /* 266015 */     // GIR_Coverage, 1144,
     /* 266015 */     GIR_EraseRootFromParent_Done,
     /* 266016 */   // Label 4362: @266016
     /* 266016 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(266077), // Rule ID 1145 //
     /* 266021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 266024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
     /* 266029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 266032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 266038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 266041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 266045 */     // MIs[0] cbsz
     /* 266045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266048 */     // MIs[0] abid
     /* 266048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266051 */     // MIs[0] blgp
     /* 266051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23320),
     /* 266058 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3150:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23320>>  =>  (V_MFMA_F32_32X32X4F16_mac_vgprcd_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_vgprcd_e64),
     /* 266061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266063 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266065 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266067 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266069 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266071 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266073 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266075 */     GIR_RootConstrainSelectedInstOperands,
     /* 266076 */     // GIR_Coverage, 1145,
     /* 266076 */     GIR_EraseRootFromParent_Done,
     /* 266077 */   // Label 4363: @266077
     /* 266077 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(266138), // Rule ID 1146 //
     /* 266082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 266085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
     /* 266090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 266099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 266106 */     // MIs[0] cbsz
     /* 266106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266109 */     // MIs[0] abid
     /* 266109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266112 */     // MIs[0] blgp
     /* 266112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23322),
     /* 266119 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3152:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23322>>  =>  (V_MFMA_F32_32X32X8F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_e64),
     /* 266122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266126 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266128 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266130 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266132 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266134 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266136 */     GIR_RootConstrainSelectedInstOperands,
     /* 266137 */     // GIR_Coverage, 1146,
     /* 266137 */     GIR_EraseRootFromParent_Done,
     /* 266138 */   // Label 4364: @266138
     /* 266138 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(266199), // Rule ID 1147 //
     /* 266143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 266146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
     /* 266151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 266160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 266167 */     // MIs[0] cbsz
     /* 266167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266170 */     // MIs[0] abid
     /* 266170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266173 */     // MIs[0] blgp
     /* 266173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23324),
     /* 266180 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3152:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23324>>  =>  (V_MFMA_F32_32X32X8F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_vgprcd_e64),
     /* 266183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266185 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266187 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266189 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266191 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266193 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266195 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266197 */     GIR_RootConstrainSelectedInstOperands,
     /* 266198 */     // GIR_Coverage, 1147,
     /* 266198 */     GIR_EraseRootFromParent_Done,
     /* 266199 */   // Label 4365: @266199
     /* 266199 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(266260), // Rule ID 1148 //
     /* 266204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
     /* 266207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
     /* 266212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 266215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 266218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 266221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 266224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 266228 */     // MIs[0] cbsz
     /* 266228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266231 */     // MIs[0] abid
     /* 266231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266234 */     // MIs[0] blgp
     /* 266234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23328),
     /* 266241 */     // (intrinsic_wo_chain:{ *:[v32i32] } 3165:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23328>>  =>  (V_MFMA_I32_32X32X4I8_mac_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_e64),
     /* 266244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266246 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266248 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266250 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266252 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266254 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266256 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266258 */     GIR_RootConstrainSelectedInstOperands,
     /* 266259 */     // GIR_Coverage, 1148,
     /* 266259 */     GIR_EraseRootFromParent_Done,
     /* 266260 */   // Label 4366: @266260
     /* 266260 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(266321), // Rule ID 1149 //
     /* 266265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
     /* 266268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
     /* 266273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 266276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 266279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 266282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 266285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 266289 */     // MIs[0] cbsz
     /* 266289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266292 */     // MIs[0] abid
     /* 266292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266295 */     // MIs[0] blgp
     /* 266295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23330),
     /* 266302 */     // (intrinsic_wo_chain:{ *:[v32i32] } 3165:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23330>>  =>  (V_MFMA_I32_32X32X4I8_mac_vgprcd_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_vgprcd_e64),
     /* 266305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266307 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266309 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266311 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266313 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266315 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266317 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266319 */     GIR_RootConstrainSelectedInstOperands,
     /* 266320 */     // GIR_Coverage, 1149,
     /* 266320 */     GIR_EraseRootFromParent_Done,
     /* 266321 */   // Label 4367: @266321
     /* 266321 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(266382), // Rule ID 1150 //
     /* 266326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 266329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
     /* 266334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 266340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 266343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 266350 */     // MIs[0] cbsz
     /* 266350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266353 */     // MIs[0] abid
     /* 266353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266356 */     // MIs[0] blgp
     /* 266356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23332),
     /* 266363 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3159:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23332>>  =>  (V_MFMA_I32_16X16X16I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_e64),
     /* 266366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266368 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266370 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266372 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266374 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266376 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266378 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266380 */     GIR_RootConstrainSelectedInstOperands,
     /* 266381 */     // GIR_Coverage, 1150,
     /* 266381 */     GIR_EraseRootFromParent_Done,
     /* 266382 */   // Label 4368: @266382
     /* 266382 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(266443), // Rule ID 1151 //
     /* 266387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 266390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
     /* 266395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 266401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 266404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 266411 */     // MIs[0] cbsz
     /* 266411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266414 */     // MIs[0] abid
     /* 266414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266417 */     // MIs[0] blgp
     /* 266417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23334),
     /* 266424 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3159:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23334>>  =>  (V_MFMA_I32_16X16X16I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_vgprcd_e64),
     /* 266427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266431 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266433 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266435 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266437 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266439 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266441 */     GIR_RootConstrainSelectedInstOperands,
     /* 266442 */     // GIR_Coverage, 1151,
     /* 266442 */     GIR_EraseRootFromParent_Done,
     /* 266443 */   // Label 4369: @266443
     /* 266443 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(266504), // Rule ID 1152 //
     /* 266448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 266451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
     /* 266456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 266462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 266465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 266472 */     // MIs[0] cbsz
     /* 266472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266475 */     // MIs[0] abid
     /* 266475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266478 */     // MIs[0] blgp
     /* 266478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23336),
     /* 266485 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3166:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23336>>  =>  (V_MFMA_I32_32X32X8I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_e64),
     /* 266488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266490 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266492 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266494 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266496 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266498 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266500 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266502 */     GIR_RootConstrainSelectedInstOperands,
     /* 266503 */     // GIR_Coverage, 1152,
     /* 266503 */     GIR_EraseRootFromParent_Done,
     /* 266504 */   // Label 4370: @266504
     /* 266504 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(266565), // Rule ID 1153 //
     /* 266509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 266512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
     /* 266517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 266523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 266526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 266533 */     // MIs[0] cbsz
     /* 266533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266536 */     // MIs[0] abid
     /* 266536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266539 */     // MIs[0] blgp
     /* 266539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23338),
     /* 266546 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3166:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23338>>  =>  (V_MFMA_I32_32X32X8I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_vgprcd_e64),
     /* 266549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266553 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266555 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266557 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266559 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266561 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266563 */     GIR_RootConstrainSelectedInstOperands,
     /* 266564 */     // GIR_Coverage, 1153,
     /* 266564 */     GIR_EraseRootFromParent_Done,
     /* 266565 */   // Label 4371: @266565
     /* 266565 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(266626), // Rule ID 1154 //
     /* 266570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 266573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
     /* 266578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 266584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 266587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 266594 */     // MIs[0] cbsz
     /* 266594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266597 */     // MIs[0] abid
     /* 266597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266600 */     // MIs[0] blgp
     /* 266600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23340),
     /* 266607 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3154:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23340>>  =>  (V_MFMA_F32_4X4X2BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_e64),
     /* 266610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266612 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266614 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266616 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266618 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266620 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266622 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266624 */     GIR_RootConstrainSelectedInstOperands,
     /* 266625 */     // GIR_Coverage, 1154,
     /* 266625 */     GIR_EraseRootFromParent_Done,
     /* 266626 */   // Label 4372: @266626
     /* 266626 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(266687), // Rule ID 1155 //
     /* 266631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 266634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
     /* 266639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 266645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 266648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 266655 */     // MIs[0] cbsz
     /* 266655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266658 */     // MIs[0] abid
     /* 266658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266661 */     // MIs[0] blgp
     /* 266661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23342),
     /* 266668 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3154:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23342>>  =>  (V_MFMA_F32_4X4X2BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_vgprcd_e64),
     /* 266671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266673 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266675 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266677 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266679 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266681 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266683 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266685 */     GIR_RootConstrainSelectedInstOperands,
     /* 266686 */     // GIR_Coverage, 1155,
     /* 266686 */     GIR_EraseRootFromParent_Done,
     /* 266687 */   // Label 4373: @266687
     /* 266687 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(266748), // Rule ID 1156 //
     /* 266692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 266695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
     /* 266700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 266706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 266709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 266716 */     // MIs[0] cbsz
     /* 266716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266719 */     // MIs[0] abid
     /* 266719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266722 */     // MIs[0] blgp
     /* 266722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23346),
     /* 266729 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3126:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23346>>  =>  (V_MFMA_F32_16X16X2BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_e64),
     /* 266732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266734 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266736 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266738 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266740 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266742 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266744 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266746 */     GIR_RootConstrainSelectedInstOperands,
     /* 266747 */     // GIR_Coverage, 1156,
     /* 266747 */     GIR_EraseRootFromParent_Done,
     /* 266748 */   // Label 4374: @266748
     /* 266748 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(266809), // Rule ID 1157 //
     /* 266753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 266756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
     /* 266761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 266764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 266767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 266770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 266773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 266777 */     // MIs[0] cbsz
     /* 266777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266780 */     // MIs[0] abid
     /* 266780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266783 */     // MIs[0] blgp
     /* 266783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23348),
     /* 266790 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3126:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23348>>  =>  (V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64),
     /* 266793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266797 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266799 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266801 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266803 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266805 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266807 */     GIR_RootConstrainSelectedInstOperands,
     /* 266808 */     // GIR_Coverage, 1157,
     /* 266808 */     GIR_EraseRootFromParent_Done,
     /* 266809 */   // Label 4375: @266809
     /* 266809 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(266870), // Rule ID 1158 //
     /* 266814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 266817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
     /* 266822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 266828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 266831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 266838 */     // MIs[0] cbsz
     /* 266838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266841 */     // MIs[0] abid
     /* 266841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266844 */     // MIs[0] blgp
     /* 266844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23350),
     /* 266851 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3137:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23350>>  =>  (V_MFMA_F32_16X16X8BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_e64),
     /* 266854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266858 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266860 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266862 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266864 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266866 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266868 */     GIR_RootConstrainSelectedInstOperands,
     /* 266869 */     // GIR_Coverage, 1158,
     /* 266869 */     GIR_EraseRootFromParent_Done,
     /* 266870 */   // Label 4376: @266870
     /* 266870 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(266931), // Rule ID 1159 //
     /* 266875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 266878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
     /* 266883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 266886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 266889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 266892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 266895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 266899 */     // MIs[0] cbsz
     /* 266899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266902 */     // MIs[0] abid
     /* 266902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266905 */     // MIs[0] blgp
     /* 266905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23352),
     /* 266912 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3137:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23352>>  =>  (V_MFMA_F32_16X16X8BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_vgprcd_e64),
     /* 266915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266919 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266921 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266923 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266925 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266927 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266929 */     GIR_RootConstrainSelectedInstOperands,
     /* 266930 */     // GIR_Coverage, 1159,
     /* 266930 */     GIR_EraseRootFromParent_Done,
     /* 266931 */   // Label 4377: @266931
     /* 266931 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(266992), // Rule ID 1160 //
     /* 266936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 266939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
     /* 266944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 266947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 266950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 266953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 266956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 266960 */     // MIs[0] cbsz
     /* 266960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 266963 */     // MIs[0] abid
     /* 266963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 266966 */     // MIs[0] blgp
     /* 266966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 266969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23356),
     /* 266973 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3145:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23356>>  =>  (V_MFMA_F32_32X32X2BF16_mac_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 266973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_e64),
     /* 266976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 266978 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 266980 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 266982 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 266984 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 266986 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 266988 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 266990 */     GIR_RootConstrainSelectedInstOperands,
     /* 266991 */     // GIR_Coverage, 1160,
     /* 266991 */     GIR_EraseRootFromParent_Done,
     /* 266992 */   // Label 4378: @266992
     /* 266992 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(267053), // Rule ID 1161 //
     /* 266997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 267000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
     /* 267005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 267008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 267011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 267014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 267017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 267021 */     // MIs[0] cbsz
     /* 267021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267024 */     // MIs[0] abid
     /* 267024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267027 */     // MIs[0] blgp
     /* 267027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23358),
     /* 267034 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3145:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23358>>  =>  (V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64),
     /* 267037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267041 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267043 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267045 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267047 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267049 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267051 */     GIR_RootConstrainSelectedInstOperands,
     /* 267052 */     // GIR_Coverage, 1161,
     /* 267052 */     GIR_EraseRootFromParent_Done,
     /* 267053 */   // Label 4379: @267053
     /* 267053 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(267114), // Rule ID 1162 //
     /* 267058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
     /* 267061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
     /* 267066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 267072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 267075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 267082 */     // MIs[0] cbsz
     /* 267082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267085 */     // MIs[0] abid
     /* 267085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267088 */     // MIs[0] blgp
     /* 267088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23360),
     /* 267095 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3148:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23360>>  =>  (V_MFMA_F32_32X32X4BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_e64),
     /* 267098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267104 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267106 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267108 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267110 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267112 */     GIR_RootConstrainSelectedInstOperands,
     /* 267113 */     // GIR_Coverage, 1162,
     /* 267113 */     GIR_EraseRootFromParent_Done,
     /* 267114 */   // Label 4380: @267114
     /* 267114 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(267175), // Rule ID 1163 //
     /* 267119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
     /* 267122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
     /* 267127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 267133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 267136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 267143 */     // MIs[0] cbsz
     /* 267143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267146 */     // MIs[0] abid
     /* 267146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267149 */     // MIs[0] blgp
     /* 267149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267152 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23362),
     /* 267156 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3148:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23362>>  =>  (V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64),
     /* 267159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267163 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267165 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267167 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267169 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267171 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267173 */     GIR_RootConstrainSelectedInstOperands,
     /* 267174 */     // GIR_Coverage, 1163,
     /* 267174 */     GIR_EraseRootFromParent_Done,
     /* 267175 */   // Label 4381: @267175
     /* 267175 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(267236), // Rule ID 1164 //
     /* 267180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
     /* 267188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 267197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 267204 */     // MIs[0] cbsz
     /* 267204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267207 */     // MIs[0] abid
     /* 267207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267210 */     // MIs[0] blgp
     /* 267210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23364),
     /* 267217 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3130:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23364>>  =>  (V_MFMA_F32_16X16X32_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_e64),
     /* 267220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267224 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267226 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267228 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267230 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267232 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267234 */     GIR_RootConstrainSelectedInstOperands,
     /* 267235 */     // GIR_Coverage, 1164,
     /* 267235 */     GIR_EraseRootFromParent_Done,
     /* 267236 */   // Label 4382: @267236
     /* 267236 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(267297), // Rule ID 1165 //
     /* 267241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 267244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
     /* 267249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 267258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267265 */     // MIs[0] cbsz
     /* 267265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267268 */     // MIs[0] abid
     /* 267268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267271 */     // MIs[0] blgp
     /* 267271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23366),
     /* 267278 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3130:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23366>>  =>  (V_MFMA_F32_16X16X32_F16_vgprcd_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_vgprcd_e64),
     /* 267281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267283 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267285 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267287 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267289 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267291 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267293 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267295 */     GIR_RootConstrainSelectedInstOperands,
     /* 267296 */     // GIR_Coverage, 1165,
     /* 267296 */     GIR_EraseRootFromParent_Done,
     /* 267297 */   // Label 4383: @267297
     /* 267297 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(267358), // Rule ID 1166 //
     /* 267302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
     /* 267310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 267319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 267326 */     // MIs[0] cbsz
     /* 267326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267329 */     // MIs[0] abid
     /* 267329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267332 */     // MIs[0] blgp
     /* 267332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23370),
     /* 267339 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3141:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23370>>  =>  (V_MFMA_F32_32X32X16_F16_mac_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_e64),
     /* 267342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267346 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267348 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267350 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267352 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267354 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267356 */     GIR_RootConstrainSelectedInstOperands,
     /* 267357 */     // GIR_Coverage, 1166,
     /* 267357 */     GIR_EraseRootFromParent_Done,
     /* 267358 */   // Label 4384: @267358
     /* 267358 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(267419), // Rule ID 1167 //
     /* 267363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 267366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
     /* 267371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 267380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 267387 */     // MIs[0] cbsz
     /* 267387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267390 */     // MIs[0] abid
     /* 267390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267393 */     // MIs[0] blgp
     /* 267393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23372),
     /* 267400 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3141:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23372>>  =>  (V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64),
     /* 267403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267405 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267407 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267409 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267411 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267413 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267415 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267417 */     GIR_RootConstrainSelectedInstOperands,
     /* 267418 */     // GIR_Coverage, 1167,
     /* 267418 */     GIR_EraseRootFromParent_Done,
     /* 267419 */   // Label 4385: @267419
     /* 267419 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(267480), // Rule ID 1168 //
     /* 267424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
     /* 267432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 267441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 267448 */     // MIs[0] cbsz
     /* 267448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267451 */     // MIs[0] abid
     /* 267451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267454 */     // MIs[0] blgp
     /* 267454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23378),
     /* 267461 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3162:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23378>>  =>  (V_MFMA_I32_16X16X64_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_e64),
     /* 267464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267468 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267470 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267472 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267474 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267476 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267478 */     GIR_RootConstrainSelectedInstOperands,
     /* 267479 */     // GIR_Coverage, 1168,
     /* 267479 */     GIR_EraseRootFromParent_Done,
     /* 267480 */   // Label 4386: @267480
     /* 267480 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(267541), // Rule ID 1169 //
     /* 267485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 267488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
     /* 267493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 267502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267509 */     // MIs[0] cbsz
     /* 267509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267512 */     // MIs[0] abid
     /* 267512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267515 */     // MIs[0] blgp
     /* 267515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23380),
     /* 267522 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3162:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23380>>  =>  (V_MFMA_I32_16X16X64_I8_vgprcd_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_vgprcd_e64),
     /* 267525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267527 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267529 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267531 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267533 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267535 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267537 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267539 */     GIR_RootConstrainSelectedInstOperands,
     /* 267540 */     // GIR_Coverage, 1169,
     /* 267540 */     GIR_EraseRootFromParent_Done,
     /* 267541 */   // Label 4387: @267541
     /* 267541 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(267602), // Rule ID 1170 //
     /* 267546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 267549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
     /* 267554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 267563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 267570 */     // MIs[0] cbsz
     /* 267570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267573 */     // MIs[0] abid
     /* 267573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267576 */     // MIs[0] blgp
     /* 267576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23390),
     /* 267583 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3164:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23390>>  =>  (V_MFMA_I32_32X32X32_I8_mac_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_e64),
     /* 267586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267588 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267590 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267592 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267594 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267596 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267598 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267600 */     GIR_RootConstrainSelectedInstOperands,
     /* 267601 */     // GIR_Coverage, 1170,
     /* 267601 */     GIR_EraseRootFromParent_Done,
     /* 267602 */   // Label 4388: @267602
     /* 267602 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(267663), // Rule ID 1171 //
     /* 267607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 267610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
     /* 267615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 267621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 267624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 267631 */     // MIs[0] cbsz
     /* 267631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267634 */     // MIs[0] abid
     /* 267634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267637 */     // MIs[0] blgp
     /* 267637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23392),
     /* 267644 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3164:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23392>>  =>  (V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64),
     /* 267647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267651 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267653 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267655 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267657 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267659 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267661 */     GIR_RootConstrainSelectedInstOperands,
     /* 267662 */     // GIR_Coverage, 1171,
     /* 267662 */     GIR_EraseRootFromParent_Done,
     /* 267663 */   // Label 4389: @267663
     /* 267663 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(267724), // Rule ID 1244 //
     /* 267668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 267671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
     /* 267676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 267679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 267688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
     /* 267692 */     // MIs[0] cbsz
     /* 267692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267695 */     // MIs[0] abid
     /* 267695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267698 */     // MIs[0] blgp
     /* 267698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23514),
     /* 267705 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3149:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23514>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_e64),
     /* 267708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267712 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267714 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267716 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267718 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267720 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267722 */     GIR_RootConstrainSelectedInstOperands,
     /* 267723 */     // GIR_Coverage, 1244,
     /* 267723 */     GIR_EraseRootFromParent_Done,
     /* 267724 */   // Label 4390: @267724
     /* 267724 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(267785), // Rule ID 1245 //
     /* 267729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 267732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
     /* 267737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
     /* 267740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
     /* 267749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
     /* 267753 */     // MIs[0] cbsz
     /* 267753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267756 */     // MIs[0] abid
     /* 267756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267759 */     // MIs[0] blgp
     /* 267759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267762 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23516),
     /* 267766 */     // (intrinsic_wo_chain:{ *:[v32f32] } 3149:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23516>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64),
     /* 267769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267771 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267773 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267775 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267777 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267779 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267781 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267783 */     GIR_RootConstrainSelectedInstOperands,
     /* 267784 */     // GIR_Coverage, 1245,
     /* 267784 */     GIR_EraseRootFromParent_Done,
     /* 267785 */   // Label 4391: @267785
     /* 267785 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(267846), // Rule ID 1246 //
     /* 267790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 267793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
     /* 267798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 267814 */     // MIs[0] cbsz
     /* 267814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267817 */     // MIs[0] abid
     /* 267817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267820 */     // MIs[0] blgp
     /* 267820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23520),
     /* 267827 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3133:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23520>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_e64),
     /* 267830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267834 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267836 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267838 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267840 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267842 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267844 */     GIR_RootConstrainSelectedInstOperands,
     /* 267845 */     // GIR_Coverage, 1246,
     /* 267845 */     GIR_EraseRootFromParent_Done,
     /* 267846 */   // Label 4392: @267846
     /* 267846 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(267907), // Rule ID 1247 //
     /* 267851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 267854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
     /* 267859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 267862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 267871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 267875 */     // MIs[0] cbsz
     /* 267875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267878 */     // MIs[0] abid
     /* 267878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267881 */     // MIs[0] blgp
     /* 267881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23522),
     /* 267888 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3133:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23522>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64),
     /* 267891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267895 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267897 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267899 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267901 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267903 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267905 */     GIR_RootConstrainSelectedInstOperands,
     /* 267906 */     // GIR_Coverage, 1247,
     /* 267906 */     GIR_EraseRootFromParent_Done,
     /* 267907 */   // Label 4393: @267907
     /* 267907 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(267968), // Rule ID 1248 //
     /* 267912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 267915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
     /* 267920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 267936 */     // MIs[0] cbsz
     /* 267936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 267939 */     // MIs[0] abid
     /* 267939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 267942 */     // MIs[0] blgp
     /* 267942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 267945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23524),
     /* 267949 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3155:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23524>>  =>  (V_MFMA_F32_4X4X4BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 267949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_e64),
     /* 267952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 267954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 267956 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 267958 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 267960 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 267962 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 267964 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 267966 */     GIR_RootConstrainSelectedInstOperands,
     /* 267967 */     // GIR_Coverage, 1248,
     /* 267967 */     GIR_EraseRootFromParent_Done,
     /* 267968 */   // Label 4394: @267968
     /* 267968 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(268029), // Rule ID 1249 //
     /* 267973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 267976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
     /* 267981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 267984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 267993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 267997 */     // MIs[0] cbsz
     /* 267997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268000 */     // MIs[0] abid
     /* 268000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268003 */     // MIs[0] blgp
     /* 268003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23526),
     /* 268010 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3155:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23526>>  =>  (V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64),
     /* 268013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268015 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268017 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268019 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268021 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268023 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268025 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268027 */     GIR_RootConstrainSelectedInstOperands,
     /* 268028 */     // GIR_Coverage, 1249,
     /* 268028 */     GIR_EraseRootFromParent_Done,
     /* 268029 */   // Label 4395: @268029
     /* 268029 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(268090), // Rule ID 1250 //
     /* 268034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
     /* 268042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 268054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 268058 */     // MIs[0] cbsz
     /* 268058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268061 */     // MIs[0] abid
     /* 268061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268064 */     // MIs[0] blgp
     /* 268064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23528),
     /* 268071 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3151:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23528>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_e64),
     /* 268074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268078 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268080 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268082 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268084 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268086 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268088 */     GIR_RootConstrainSelectedInstOperands,
     /* 268089 */     // GIR_Coverage, 1250,
     /* 268089 */     GIR_EraseRootFromParent_Done,
     /* 268090 */   // Label 4396: @268090
     /* 268090 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(268151), // Rule ID 1251 //
     /* 268095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
     /* 268103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 268115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 268119 */     // MIs[0] cbsz
     /* 268119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268122 */     // MIs[0] abid
     /* 268122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268125 */     // MIs[0] blgp
     /* 268125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23530),
     /* 268132 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3151:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23530>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64),
     /* 268135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268139 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268141 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268143 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268145 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268147 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268149 */     GIR_RootConstrainSelectedInstOperands,
     /* 268150 */     // GIR_Coverage, 1251,
     /* 268150 */     GIR_EraseRootFromParent_Done,
     /* 268151 */   // Label 4397: @268151
     /* 268151 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(268212), // Rule ID 1252 //
     /* 268156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
     /* 268164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268180 */     // MIs[0] cbsz
     /* 268180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268183 */     // MIs[0] abid
     /* 268183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268186 */     // MIs[0] blgp
     /* 268186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23532),
     /* 268193 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3123:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23532>>  =>  (V_MFMA_F32_16X16X16BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_e64),
     /* 268196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268198 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268200 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268202 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268204 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268206 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268208 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268210 */     GIR_RootConstrainSelectedInstOperands,
     /* 268211 */     // GIR_Coverage, 1252,
     /* 268211 */     GIR_EraseRootFromParent_Done,
     /* 268212 */   // Label 4398: @268212
     /* 268212 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(268273), // Rule ID 1253 //
     /* 268217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
     /* 268225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268241 */     // MIs[0] cbsz
     /* 268241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268244 */     // MIs[0] abid
     /* 268244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268247 */     // MIs[0] blgp
     /* 268247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23534),
     /* 268254 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3123:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23534>>  =>  (V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64),
     /* 268257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268261 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268263 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268265 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268267 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268269 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268271 */     GIR_RootConstrainSelectedInstOperands,
     /* 268272 */     // GIR_Coverage, 1253,
     /* 268272 */     GIR_EraseRootFromParent_Done,
     /* 268273 */   // Label 4399: @268273
     /* 268273 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(268334), // Rule ID 1254 //
     /* 268278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
     /* 268286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 268289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
     /* 268298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_256RegClassID),
     /* 268302 */     // MIs[0] cbsz
     /* 268302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268305 */     // MIs[0] abid
     /* 268305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268308 */     // MIs[0] blgp
     /* 268308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23538),
     /* 268315 */     // (intrinsic_wo_chain:{ *:[v4f64] } 3157:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23538>>  =>  (V_MFMA_F64_16X16X4F64_mac_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_e64),
     /* 268318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268322 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268324 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268326 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268328 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268330 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268332 */     GIR_RootConstrainSelectedInstOperands,
     /* 268333 */     // GIR_Coverage, 1254,
     /* 268333 */     GIR_EraseRootFromParent_Done,
     /* 268334 */   // Label 4400: @268334
     /* 268334 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(268395), // Rule ID 1255 //
     /* 268339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
     /* 268347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 268350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
     /* 268359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 268363 */     // MIs[0] cbsz
     /* 268363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268366 */     // MIs[0] abid
     /* 268366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268369 */     // MIs[0] blgp
     /* 268369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23540),
     /* 268376 */     // (intrinsic_wo_chain:{ *:[v4f64] } 3157:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23540>>  =>  (V_MFMA_F64_16X16X4F64_mac_vgprcd_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_vgprcd_e64),
     /* 268379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268381 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268383 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268385 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268387 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268389 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268391 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268393 */     GIR_RootConstrainSelectedInstOperands,
     /* 268394 */     // GIR_Coverage, 1255,
     /* 268394 */     GIR_EraseRootFromParent_Done,
     /* 268395 */   // Label 4401: @268395
     /* 268395 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(268456), // Rule ID 1256 //
     /* 268400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
     /* 268408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 268420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_64RegClassID),
     /* 268424 */     // MIs[0] cbsz
     /* 268424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268427 */     // MIs[0] abid
     /* 268427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268430 */     // MIs[0] blgp
     /* 268430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23542),
     /* 268437 */     // (intrinsic_wo_chain:{ *:[f64] } 3158:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23542>>  =>  (V_MFMA_F64_4X4X4F64_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_e64),
     /* 268440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268442 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268444 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268446 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268448 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268450 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268452 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268454 */     GIR_RootConstrainSelectedInstOperands,
     /* 268455 */     // GIR_Coverage, 1256,
     /* 268455 */     GIR_EraseRootFromParent_Done,
     /* 268456 */   // Label 4402: @268456
     /* 268456 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(268517), // Rule ID 1257 //
     /* 268461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
     /* 268464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
     /* 268469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 268481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 268485 */     // MIs[0] cbsz
     /* 268485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268488 */     // MIs[0] abid
     /* 268488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268491 */     // MIs[0] blgp
     /* 268491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23544),
     /* 268498 */     // (intrinsic_wo_chain:{ *:[f64] } 3158:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23544>>  =>  (V_MFMA_F64_4X4X4F64_vgprcd_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_vgprcd_e64),
     /* 268501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268503 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268505 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268507 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268509 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268511 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268513 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268515 */     GIR_RootConstrainSelectedInstOperands,
     /* 268516 */     // GIR_Coverage, 1257,
     /* 268516 */     GIR_EraseRootFromParent_Done,
     /* 268517 */   // Label 4403: @268517
     /* 268517 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(268578), // Rule ID 1258 //
     /* 268522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 268525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
     /* 268530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 268542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 268546 */     // MIs[0] cbsz
     /* 268546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268549 */     // MIs[0] abid
     /* 268549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268552 */     // MIs[0] blgp
     /* 268552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23548),
     /* 268559 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3163:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23548>>  =>  (V_MFMA_I32_32X32X16I8_mac_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_e64),
     /* 268562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268566 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268568 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268570 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268572 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268574 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268576 */     GIR_RootConstrainSelectedInstOperands,
     /* 268577 */     // GIR_Coverage, 1258,
     /* 268577 */     GIR_EraseRootFromParent_Done,
     /* 268578 */   // Label 4404: @268578
     /* 268578 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(268639), // Rule ID 1259 //
     /* 268583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
     /* 268586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
     /* 268591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 268603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 268607 */     // MIs[0] cbsz
     /* 268607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268610 */     // MIs[0] abid
     /* 268610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268613 */     // MIs[0] blgp
     /* 268613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23550),
     /* 268620 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3163:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23550>>  =>  (V_MFMA_I32_32X32X16I8_mac_vgprcd_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_vgprcd_e64),
     /* 268623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268627 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268629 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268631 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268633 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268635 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268637 */     GIR_RootConstrainSelectedInstOperands,
     /* 268638 */     // GIR_Coverage, 1259,
     /* 268638 */     GIR_EraseRootFromParent_Done,
     /* 268639 */   // Label 4405: @268639
     /* 268639 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(268700), // Rule ID 1260 //
     /* 268644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 268647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
     /* 268652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268668 */     // MIs[0] cbsz
     /* 268668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268671 */     // MIs[0] abid
     /* 268671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268674 */     // MIs[0] blgp
     /* 268674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23552),
     /* 268681 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3160:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23552>>  =>  (V_MFMA_I32_16X16X32I8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_e64),
     /* 268684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268686 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268688 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268690 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268692 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268694 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268696 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268698 */     GIR_RootConstrainSelectedInstOperands,
     /* 268699 */     // GIR_Coverage, 1260,
     /* 268699 */     GIR_EraseRootFromParent_Done,
     /* 268700 */   // Label 4406: @268700
     /* 268700 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(268761), // Rule ID 1261 //
     /* 268705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
     /* 268708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
     /* 268713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 268722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268729 */     // MIs[0] cbsz
     /* 268729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268732 */     // MIs[0] abid
     /* 268732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268735 */     // MIs[0] blgp
     /* 268735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23554),
     /* 268742 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3160:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23554>>  =>  (V_MFMA_I32_16X16X32I8_vgprcd_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_vgprcd_e64),
     /* 268745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268749 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268751 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268753 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268755 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268757 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268759 */     GIR_RootConstrainSelectedInstOperands,
     /* 268760 */     // GIR_Coverage, 1261,
     /* 268760 */     GIR_EraseRootFromParent_Done,
     /* 268761 */   // Label 4407: @268761
     /* 268761 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(268822), // Rule ID 1262 //
     /* 268766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
     /* 268769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
     /* 268774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 268790 */     // MIs[0] cbsz
     /* 268790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268793 */     // MIs[0] abid
     /* 268793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268796 */     // MIs[0] blgp
     /* 268796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23556),
     /* 268803 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3136:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23556>>  =>  (V_MFMA_F32_16X16X8XF32_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_e64),
     /* 268806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268810 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268812 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268814 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268816 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268818 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268820 */     GIR_RootConstrainSelectedInstOperands,
     /* 268821 */     // GIR_Coverage, 1262,
     /* 268821 */     GIR_EraseRootFromParent_Done,
     /* 268822 */   // Label 4408: @268822
     /* 268822 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(268883), // Rule ID 1263 //
     /* 268827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
     /* 268830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
     /* 268835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 268838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 268847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 268851 */     // MIs[0] cbsz
     /* 268851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268854 */     // MIs[0] abid
     /* 268854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268857 */     // MIs[0] blgp
     /* 268857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23558),
     /* 268864 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3136:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23558>>  =>  (V_MFMA_F32_16X16X8XF32_vgprcd_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_vgprcd_e64),
     /* 268867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268871 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268873 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268875 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268877 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268879 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268881 */     GIR_RootConstrainSelectedInstOperands,
     /* 268882 */     // GIR_Coverage, 1263,
     /* 268882 */     GIR_EraseRootFromParent_Done,
     /* 268883 */   // Label 4409: @268883
     /* 268883 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(268944), // Rule ID 1264 //
     /* 268888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
     /* 268891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
     /* 268896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 268908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 268912 */     // MIs[0] cbsz
     /* 268912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268915 */     // MIs[0] abid
     /* 268915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268918 */     // MIs[0] blgp
     /* 268918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23562),
     /* 268925 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3147:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23562>>  =>  (V_MFMA_F32_32X32X4XF32_mac_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_e64),
     /* 268928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268930 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268932 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268934 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268936 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268938 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 268940 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 268942 */     GIR_RootConstrainSelectedInstOperands,
     /* 268943 */     // GIR_Coverage, 1264,
     /* 268943 */     GIR_EraseRootFromParent_Done,
     /* 268944 */   // Label 4410: @268944
     /* 268944 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(269005), // Rule ID 1265 //
     /* 268949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
     /* 268952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
     /* 268957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 268960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 268969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 268973 */     // MIs[0] cbsz
     /* 268973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 268976 */     // MIs[0] abid
     /* 268976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 268979 */     // MIs[0] blgp
     /* 268979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 268982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23564),
     /* 268986 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3147:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23564>>  =>  (V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 268986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64),
     /* 268989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 268991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 268993 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 268995 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 268997 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 268999 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269001 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269003 */     GIR_RootConstrainSelectedInstOperands,
     /* 269004 */     // GIR_Coverage, 1265,
     /* 269004 */     GIR_EraseRootFromParent_Done,
     /* 269005 */   // Label 4411: @269005
     /* 269005 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(269066), // Rule ID 1266 //
     /* 269010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
     /* 269018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 269034 */     // MIs[0] cbsz
     /* 269034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269037 */     // MIs[0] abid
     /* 269037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269040 */     // MIs[0] blgp
     /* 269040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23566),
     /* 269047 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3128:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23566>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_e64),
     /* 269050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269054 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269056 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269058 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269060 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269062 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269064 */     GIR_RootConstrainSelectedInstOperands,
     /* 269065 */     // GIR_Coverage, 1266,
     /* 269065 */     GIR_EraseRootFromParent_Done,
     /* 269066 */   // Label 4412: @269066
     /* 269066 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(269127), // Rule ID 1267 //
     /* 269071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
     /* 269079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 269095 */     // MIs[0] cbsz
     /* 269095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269098 */     // MIs[0] abid
     /* 269098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269101 */     // MIs[0] blgp
     /* 269101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23568),
     /* 269108 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3128:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23568>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64),
     /* 269111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269113 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269115 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269117 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269119 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269121 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269123 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269125 */     GIR_RootConstrainSelectedInstOperands,
     /* 269126 */     // GIR_Coverage, 1267,
     /* 269126 */     GIR_EraseRootFromParent_Done,
     /* 269127 */   // Label 4413: @269127
     /* 269127 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(269188), // Rule ID 1268 //
     /* 269132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
     /* 269140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 269156 */     // MIs[0] cbsz
     /* 269156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269159 */     // MIs[0] abid
     /* 269159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269162 */     // MIs[0] blgp
     /* 269162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23570),
     /* 269169 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3129:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23570>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_e64),
     /* 269172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269176 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269178 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269180 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269182 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269184 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269186 */     GIR_RootConstrainSelectedInstOperands,
     /* 269187 */     // GIR_Coverage, 1268,
     /* 269187 */     GIR_EraseRootFromParent_Done,
     /* 269188 */   // Label 4414: @269188
     /* 269188 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(269249), // Rule ID 1269 //
     /* 269193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
     /* 269201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 269217 */     // MIs[0] cbsz
     /* 269217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269220 */     // MIs[0] abid
     /* 269220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269223 */     // MIs[0] blgp
     /* 269223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23572),
     /* 269230 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3129:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23572>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64),
     /* 269233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269235 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269237 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269239 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269241 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269243 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269245 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269247 */     GIR_RootConstrainSelectedInstOperands,
     /* 269248 */     // GIR_Coverage, 1269,
     /* 269248 */     GIR_EraseRootFromParent_Done,
     /* 269249 */   // Label 4415: @269249
     /* 269249 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(269310), // Rule ID 1270 //
     /* 269254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
     /* 269262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 269278 */     // MIs[0] cbsz
     /* 269278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269281 */     // MIs[0] abid
     /* 269281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269284 */     // MIs[0] blgp
     /* 269284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23574),
     /* 269291 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3131:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23574>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_e64),
     /* 269294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269298 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269300 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269302 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269304 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269306 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269308 */     GIR_RootConstrainSelectedInstOperands,
     /* 269309 */     // GIR_Coverage, 1270,
     /* 269309 */     GIR_EraseRootFromParent_Done,
     /* 269310 */   // Label 4416: @269310
     /* 269310 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(269371), // Rule ID 1271 //
     /* 269315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
     /* 269323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 269339 */     // MIs[0] cbsz
     /* 269339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269342 */     // MIs[0] abid
     /* 269342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269345 */     // MIs[0] blgp
     /* 269345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23576),
     /* 269352 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3131:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23576>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64),
     /* 269355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269361 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269363 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269365 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269367 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269369 */     GIR_RootConstrainSelectedInstOperands,
     /* 269370 */     // GIR_Coverage, 1271,
     /* 269370 */     GIR_EraseRootFromParent_Done,
     /* 269371 */   // Label 4417: @269371
     /* 269371 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(269432), // Rule ID 1272 //
     /* 269376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
     /* 269384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 269400 */     // MIs[0] cbsz
     /* 269400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269403 */     // MIs[0] abid
     /* 269403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269406 */     // MIs[0] blgp
     /* 269406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23578),
     /* 269413 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3132:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23578>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_e64),
     /* 269416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269420 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269422 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269424 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269426 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269428 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269430 */     GIR_RootConstrainSelectedInstOperands,
     /* 269431 */     // GIR_Coverage, 1272,
     /* 269431 */     GIR_EraseRootFromParent_Done,
     /* 269432 */   // Label 4418: @269432
     /* 269432 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(269493), // Rule ID 1273 //
     /* 269437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
     /* 269445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 269457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 269461 */     // MIs[0] cbsz
     /* 269461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269464 */     // MIs[0] abid
     /* 269464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269467 */     // MIs[0] blgp
     /* 269467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23580),
     /* 269474 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3132:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23580>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64),
     /* 269477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269479 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269481 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269483 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269485 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269487 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269489 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269491 */     GIR_RootConstrainSelectedInstOperands,
     /* 269492 */     // GIR_Coverage, 1273,
     /* 269492 */     GIR_EraseRootFromParent_Done,
     /* 269493 */   // Label 4419: @269493
     /* 269493 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(269554), // Rule ID 1274 //
     /* 269498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
     /* 269506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269522 */     // MIs[0] cbsz
     /* 269522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269525 */     // MIs[0] abid
     /* 269525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269528 */     // MIs[0] blgp
     /* 269528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23584),
     /* 269535 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3139:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23584>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_e64),
     /* 269538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269542 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269544 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269546 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269548 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269550 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269552 */     GIR_RootConstrainSelectedInstOperands,
     /* 269553 */     // GIR_Coverage, 1274,
     /* 269553 */     GIR_EraseRootFromParent_Done,
     /* 269554 */   // Label 4420: @269554
     /* 269554 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(269615), // Rule ID 1275 //
     /* 269559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
     /* 269567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269583 */     // MIs[0] cbsz
     /* 269583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269586 */     // MIs[0] abid
     /* 269586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269589 */     // MIs[0] blgp
     /* 269589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23586),
     /* 269596 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3139:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23586>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64),
     /* 269599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269603 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269605 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269607 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269609 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269611 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269613 */     GIR_RootConstrainSelectedInstOperands,
     /* 269614 */     // GIR_Coverage, 1275,
     /* 269614 */     GIR_EraseRootFromParent_Done,
     /* 269615 */   // Label 4421: @269615
     /* 269615 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(269676), // Rule ID 1276 //
     /* 269620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
     /* 269628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269644 */     // MIs[0] cbsz
     /* 269644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269647 */     // MIs[0] abid
     /* 269647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269650 */     // MIs[0] blgp
     /* 269650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23588),
     /* 269657 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3140:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23588>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_e64),
     /* 269660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269662 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269664 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269666 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269668 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269670 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269672 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269674 */     GIR_RootConstrainSelectedInstOperands,
     /* 269675 */     // GIR_Coverage, 1276,
     /* 269675 */     GIR_EraseRootFromParent_Done,
     /* 269676 */   // Label 4422: @269676
     /* 269676 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(269737), // Rule ID 1277 //
     /* 269681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
     /* 269689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269705 */     // MIs[0] cbsz
     /* 269705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269708 */     // MIs[0] abid
     /* 269708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269711 */     // MIs[0] blgp
     /* 269711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23590),
     /* 269718 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3140:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23590>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64),
     /* 269721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269723 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269725 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269727 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269729 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269731 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269733 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269735 */     GIR_RootConstrainSelectedInstOperands,
     /* 269736 */     // GIR_Coverage, 1277,
     /* 269736 */     GIR_EraseRootFromParent_Done,
     /* 269737 */   // Label 4423: @269737
     /* 269737 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(269798), // Rule ID 1278 //
     /* 269742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
     /* 269750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269766 */     // MIs[0] cbsz
     /* 269766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269769 */     // MIs[0] abid
     /* 269769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269772 */     // MIs[0] blgp
     /* 269772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23592),
     /* 269779 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3142:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23592>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_e64),
     /* 269782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269786 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269788 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269790 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269792 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269794 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269796 */     GIR_RootConstrainSelectedInstOperands,
     /* 269797 */     // GIR_Coverage, 1278,
     /* 269797 */     GIR_EraseRootFromParent_Done,
     /* 269798 */   // Label 4424: @269798
     /* 269798 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(269859), // Rule ID 1279 //
     /* 269803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
     /* 269811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269827 */     // MIs[0] cbsz
     /* 269827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269830 */     // MIs[0] abid
     /* 269830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269833 */     // MIs[0] blgp
     /* 269833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23594),
     /* 269840 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3142:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23594>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64),
     /* 269843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269847 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269849 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269851 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269853 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269855 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269857 */     GIR_RootConstrainSelectedInstOperands,
     /* 269858 */     // GIR_Coverage, 1279,
     /* 269858 */     GIR_EraseRootFromParent_Done,
     /* 269859 */   // Label 4425: @269859
     /* 269859 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(269920), // Rule ID 1280 //
     /* 269864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 269867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
     /* 269872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 269888 */     // MIs[0] cbsz
     /* 269888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269891 */     // MIs[0] abid
     /* 269891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269894 */     // MIs[0] blgp
     /* 269894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23596),
     /* 269901 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3143:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23596>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_e64),
     /* 269904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269906 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269908 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269910 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269912 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269914 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269916 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269918 */     GIR_RootConstrainSelectedInstOperands,
     /* 269919 */     // GIR_Coverage, 1280,
     /* 269919 */     GIR_EraseRootFromParent_Done,
     /* 269920 */   // Label 4426: @269920
     /* 269920 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(269981), // Rule ID 1281 //
     /* 269925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
     /* 269928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
     /* 269933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 269936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 269942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 269945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 269949 */     // MIs[0] cbsz
     /* 269949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 269952 */     // MIs[0] abid
     /* 269952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 269955 */     // MIs[0] blgp
     /* 269955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 269958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23598),
     /* 269962 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3143:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_23598>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
     /* 269962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64),
     /* 269965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 269967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 269969 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 269971 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 269973 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 269975 */     GIR_RootToRootCopy, /*OpIdx*/6, // abid
     /* 269977 */     GIR_RootToRootCopy, /*OpIdx*/7, // blgp
     /* 269979 */     GIR_RootConstrainSelectedInstOperands,
     /* 269980 */     // GIR_Coverage, 1281,
     /* 269980 */     GIR_EraseRootFromParent_Done,
     /* 269981 */   // Label 4427: @269981
     /* 269981 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(270038), // Rule ID 1282 //
     /* 269986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 269989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_f16),
     /* 269994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 269997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 270003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270013 */     // MIs[0] cbsz
     /* 270013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270016 */     // MIs[0] abid
     /* 270016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270019 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3312:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 270019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_F16_e64),
     /* 270022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270026 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270028 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270030 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270032 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270034 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270036 */     GIR_RootConstrainSelectedInstOperands,
     /* 270037 */     // GIR_Coverage, 1282,
     /* 270037 */     GIR_EraseRootFromParent_Done,
     /* 270038 */   // Label 4428: @270038
     /* 270038 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(270095), // Rule ID 1283 //
     /* 270043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 270046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_f16),
     /* 270051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 270060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270070 */     // MIs[0] cbsz
     /* 270070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270073 */     // MIs[0] abid
     /* 270073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270076 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3320:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_F16_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 270076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_F16_e64),
     /* 270079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270081 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270083 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270085 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270087 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270089 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270091 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270093 */     GIR_RootConstrainSelectedInstOperands,
     /* 270094 */     // GIR_Coverage, 1283,
     /* 270094 */     GIR_EraseRootFromParent_Done,
     /* 270095 */   // Label 4429: @270095
     /* 270095 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(270152), // Rule ID 1284 //
     /* 270100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 270103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_bf16),
     /* 270108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 270117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270127 */     // MIs[0] cbsz
     /* 270127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270130 */     // MIs[0] abid
     /* 270130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270133 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3311:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_BF16_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 270133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_BF16_e64),
     /* 270136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270140 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270142 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270144 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270146 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270148 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270150 */     GIR_RootConstrainSelectedInstOperands,
     /* 270151 */     // GIR_Coverage, 1284,
     /* 270151 */     GIR_EraseRootFromParent_Done,
     /* 270152 */   // Label 4430: @270152
     /* 270152 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(270209), // Rule ID 1285 //
     /* 270157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 270160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_bf16),
     /* 270165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 270174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270184 */     // MIs[0] cbsz
     /* 270184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270187 */     // MIs[0] abid
     /* 270187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270190 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3319:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_BF16_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 270190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_BF16_e64),
     /* 270193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270197 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270199 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270201 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270203 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270205 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270207 */     GIR_RootConstrainSelectedInstOperands,
     /* 270208 */     // GIR_Coverage, 1285,
     /* 270208 */     GIR_EraseRootFromParent_Done,
     /* 270209 */   // Label 4431: @270209
     /* 270209 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(270266), // Rule ID 1286 //
     /* 270214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 270217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x64_i8),
     /* 270222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270241 */     // MIs[0] cbsz
     /* 270241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270244 */     // MIs[0] abid
     /* 270244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270247 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3332:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X64_I8_e64:{ *:[v4i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
     /* 270247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X64_I8_e64),
     /* 270250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270252 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270254 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270256 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270258 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270260 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270262 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270264 */     GIR_RootConstrainSelectedInstOperands,
     /* 270265 */     // GIR_Coverage, 1286,
     /* 270265 */     GIR_EraseRootFromParent_Done,
     /* 270266 */   // Label 4432: @270266
     /* 270266 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(270323), // Rule ID 1287 //
     /* 270271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
     /* 270274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x32_i8),
     /* 270279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270298 */     // MIs[0] cbsz
     /* 270298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270301 */     // MIs[0] abid
     /* 270301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270304 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3333:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X32_I8_e64:{ *:[v16i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
     /* 270304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X32_I8_e64),
     /* 270307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270309 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270311 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270313 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270315 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270317 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270319 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270321 */     GIR_RootConstrainSelectedInstOperands,
     /* 270322 */     // GIR_Coverage, 1287,
     /* 270322 */     GIR_EraseRootFromParent_Done,
     /* 270323 */   // Label 4433: @270323
     /* 270323 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(270380), // Rule ID 1288 //
     /* 270328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_bf8),
     /* 270336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270355 */     // MIs[0] cbsz
     /* 270355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270358 */     // MIs[0] abid
     /* 270358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270361 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3314:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 270361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_BF8_e64),
     /* 270364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270368 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270370 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270372 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270374 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270376 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270378 */     GIR_RootConstrainSelectedInstOperands,
     /* 270379 */     // GIR_Coverage, 1288,
     /* 270379 */     GIR_EraseRootFromParent_Done,
     /* 270380 */   // Label 4434: @270380
     /* 270380 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(270437), // Rule ID 1289 //
     /* 270385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_fp8),
     /* 270393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270412 */     // MIs[0] cbsz
     /* 270412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270415 */     // MIs[0] abid
     /* 270415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270418 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3315:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 270418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_FP8_e64),
     /* 270421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270423 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270425 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270427 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270429 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270431 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270433 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270435 */     GIR_RootConstrainSelectedInstOperands,
     /* 270436 */     // GIR_Coverage, 1289,
     /* 270436 */     GIR_EraseRootFromParent_Done,
     /* 270437 */   // Label 4435: @270437
     /* 270437 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(270494), // Rule ID 1290 //
     /* 270442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_bf8),
     /* 270450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270469 */     // MIs[0] cbsz
     /* 270469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270472 */     // MIs[0] abid
     /* 270472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270475 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3317:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 270475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_BF8_e64),
     /* 270478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270482 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270484 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270486 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270488 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270490 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270492 */     GIR_RootConstrainSelectedInstOperands,
     /* 270493 */     // GIR_Coverage, 1290,
     /* 270493 */     GIR_EraseRootFromParent_Done,
     /* 270494 */   // Label 4436: @270494
     /* 270494 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(270551), // Rule ID 1291 //
     /* 270499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_fp8),
     /* 270507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270526 */     // MIs[0] cbsz
     /* 270526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270529 */     // MIs[0] abid
     /* 270529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270532 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3318:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 270532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_FP8_e64),
     /* 270535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270539 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270541 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270543 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270545 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270547 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270549 */     GIR_RootConstrainSelectedInstOperands,
     /* 270550 */     // GIR_Coverage, 1291,
     /* 270550 */     GIR_EraseRootFromParent_Done,
     /* 270551 */   // Label 4437: @270551
     /* 270551 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(270608), // Rule ID 1292 //
     /* 270556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_bf8),
     /* 270564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270583 */     // MIs[0] cbsz
     /* 270583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270586 */     // MIs[0] abid
     /* 270586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270589 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3322:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 270589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_BF8_e64),
     /* 270592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270594 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270596 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270598 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270600 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270602 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270604 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270606 */     GIR_RootConstrainSelectedInstOperands,
     /* 270607 */     // GIR_Coverage, 1292,
     /* 270607 */     GIR_EraseRootFromParent_Done,
     /* 270608 */   // Label 4438: @270608
     /* 270608 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(270665), // Rule ID 1293 //
     /* 270613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_fp8),
     /* 270621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270640 */     // MIs[0] cbsz
     /* 270640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270643 */     // MIs[0] abid
     /* 270643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270646 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3323:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 270646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_FP8_e64),
     /* 270649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270651 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270653 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270655 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270657 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270659 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270661 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270663 */     GIR_RootConstrainSelectedInstOperands,
     /* 270664 */     // GIR_Coverage, 1293,
     /* 270664 */     GIR_EraseRootFromParent_Done,
     /* 270665 */   // Label 4439: @270665
     /* 270665 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(270722), // Rule ID 1294 //
     /* 270670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_bf8),
     /* 270678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270697 */     // MIs[0] cbsz
     /* 270697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270700 */     // MIs[0] abid
     /* 270700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270703 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3325:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 270703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_BF8_e64),
     /* 270706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270710 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270712 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270714 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270716 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270718 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270720 */     GIR_RootConstrainSelectedInstOperands,
     /* 270721 */     // GIR_Coverage, 1294,
     /* 270721 */     GIR_EraseRootFromParent_Done,
     /* 270722 */   // Label 4440: @270722
     /* 270722 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(270779), // Rule ID 1295 //
     /* 270727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
     /* 270730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_fp8),
     /* 270735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270754 */     // MIs[0] cbsz
     /* 270754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270757 */     // MIs[0] abid
     /* 270757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270760 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3326:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 270760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_FP8_e64),
     /* 270763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270767 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270769 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270771 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270773 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270775 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270777 */     GIR_RootConstrainSelectedInstOperands,
     /* 270778 */     // GIR_Coverage, 1295,
     /* 270778 */     GIR_EraseRootFromParent_Done,
     /* 270779 */   // Label 4441: @270779
     /* 270779 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(270836), // Rule ID 1296 //
     /* 270784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_f16),
     /* 270792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 270801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270811 */     // MIs[0] cbsz
     /* 270811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270814 */     // MIs[0] abid
     /* 270814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270817 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3316:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 270817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_F16_e64),
     /* 270820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270824 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270826 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270828 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270830 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270832 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270834 */     GIR_RootConstrainSelectedInstOperands,
     /* 270835 */     // GIR_Coverage, 1296,
     /* 270835 */     GIR_EraseRootFromParent_Done,
     /* 270836 */   // Label 4442: @270836
     /* 270836 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(270893), // Rule ID 1297 //
     /* 270841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_f16),
     /* 270849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 270858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270868 */     // MIs[0] cbsz
     /* 270868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270871 */     // MIs[0] abid
     /* 270871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270874 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3324:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_F16_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 270874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_F16_e64),
     /* 270877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270879 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270881 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270883 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270885 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270887 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270889 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270891 */     GIR_RootConstrainSelectedInstOperands,
     /* 270892 */     // GIR_Coverage, 1297,
     /* 270892 */     GIR_EraseRootFromParent_Done,
     /* 270893 */   // Label 4443: @270893
     /* 270893 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(270950), // Rule ID 1298 //
     /* 270898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x128_i8),
     /* 270906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 270909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 270918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 270925 */     // MIs[0] cbsz
     /* 270925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270928 */     // MIs[0] abid
     /* 270928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270931 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3331:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X128_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
     /* 270931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X128_I8_e64),
     /* 270934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270938 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270940 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270942 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 270944 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 270946 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 270948 */     GIR_RootConstrainSelectedInstOperands,
     /* 270949 */     // GIR_Coverage, 1298,
     /* 270949 */     GIR_EraseRootFromParent_Done,
     /* 270950 */   // Label 4444: @270950
     /* 270950 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(271007), // Rule ID 1299 //
     /* 270955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 270958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x64_i8),
     /* 270963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 270966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 270972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 270975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 270978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 270982 */     // MIs[0] cbsz
     /* 270982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 270985 */     // MIs[0] abid
     /* 270985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 270988 */     // (intrinsic_wo_chain:{ *:[v16i32] } 3334:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X64_I8_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
     /* 270988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X64_I8_e64),
     /* 270991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 270993 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 270995 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 270997 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 270999 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271001 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271003 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271005 */     GIR_RootConstrainSelectedInstOperands,
     /* 271006 */     // GIR_Coverage, 1299,
     /* 271006 */     GIR_EraseRootFromParent_Done,
     /* 271007 */   // Label 4445: @271007
     /* 271007 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(271064), // Rule ID 1300 //
     /* 271012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_bf8),
     /* 271020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 271039 */     // MIs[0] cbsz
     /* 271039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271042 */     // MIs[0] abid
     /* 271042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271045 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3307:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 271045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_BF8_e64),
     /* 271048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271052 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271054 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271056 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271058 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271060 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271062 */     GIR_RootConstrainSelectedInstOperands,
     /* 271063 */     // GIR_Coverage, 1300,
     /* 271063 */     GIR_EraseRootFromParent_Done,
     /* 271064 */   // Label 4446: @271064
     /* 271064 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(271121), // Rule ID 1301 //
     /* 271069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_fp8),
     /* 271077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 271096 */     // MIs[0] cbsz
     /* 271096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271099 */     // MIs[0] abid
     /* 271099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271102 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3308:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 271102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_FP8_e64),
     /* 271105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271109 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271111 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271113 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271115 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271117 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271119 */     GIR_RootConstrainSelectedInstOperands,
     /* 271120 */     // GIR_Coverage, 1301,
     /* 271120 */     GIR_EraseRootFromParent_Done,
     /* 271121 */   // Label 4447: @271121
     /* 271121 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(271178), // Rule ID 1302 //
     /* 271126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_bf8),
     /* 271134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 271153 */     // MIs[0] cbsz
     /* 271153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271156 */     // MIs[0] abid
     /* 271156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271159 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3309:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 271159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_BF8_e64),
     /* 271162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271166 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271168 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271170 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271172 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271174 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271176 */     GIR_RootConstrainSelectedInstOperands,
     /* 271177 */     // GIR_Coverage, 1302,
     /* 271177 */     GIR_EraseRootFromParent_Done,
     /* 271178 */   // Label 4448: @271178
     /* 271178 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(271235), // Rule ID 1303 //
     /* 271183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_fp8),
     /* 271191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 271203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 271210 */     // MIs[0] cbsz
     /* 271210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271213 */     // MIs[0] abid
     /* 271213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271216 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3310:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
     /* 271216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_FP8_e64),
     /* 271219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271221 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271223 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271225 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271227 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271229 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271231 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271233 */     GIR_RootConstrainSelectedInstOperands,
     /* 271234 */     // GIR_Coverage, 1303,
     /* 271234 */     GIR_EraseRootFromParent_Done,
     /* 271235 */   // Label 4449: @271235
     /* 271235 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(271292), // Rule ID 1304 //
     /* 271240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_bf8),
     /* 271248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 271251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 271260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 271267 */     // MIs[0] cbsz
     /* 271267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271270 */     // MIs[0] abid
     /* 271270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271273 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3327:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 271273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_BF8_e64),
     /* 271276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271278 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271280 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271282 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271284 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271286 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271288 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271290 */     GIR_RootConstrainSelectedInstOperands,
     /* 271291 */     // GIR_Coverage, 1304,
     /* 271291 */     GIR_EraseRootFromParent_Done,
     /* 271292 */   // Label 4450: @271292
     /* 271292 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(271349), // Rule ID 1305 //
     /* 271297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_fp8),
     /* 271305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 271308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 271317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 271324 */     // MIs[0] cbsz
     /* 271324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271327 */     // MIs[0] abid
     /* 271327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271330 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3328:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 271330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_FP8_e64),
     /* 271333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271339 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271341 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271343 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271345 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271347 */     GIR_RootConstrainSelectedInstOperands,
     /* 271348 */     // GIR_Coverage, 1305,
     /* 271348 */     GIR_EraseRootFromParent_Done,
     /* 271349 */   // Label 4451: @271349
     /* 271349 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(271406), // Rule ID 1306 //
     /* 271354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_bf8),
     /* 271362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 271365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 271374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 271381 */     // MIs[0] cbsz
     /* 271381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271384 */     // MIs[0] abid
     /* 271384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271387 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3329:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 271387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_BF8_e64),
     /* 271390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271392 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271394 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271396 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271398 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271400 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271402 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271404 */     GIR_RootConstrainSelectedInstOperands,
     /* 271405 */     // GIR_Coverage, 1306,
     /* 271405 */     GIR_EraseRootFromParent_Done,
     /* 271406 */   // Label 4452: @271406
     /* 271406 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(271463), // Rule ID 1307 //
     /* 271411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 271414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_fp8),
     /* 271419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 271422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 271425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 271428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 271431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
     /* 271438 */     // MIs[0] cbsz
     /* 271438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 271441 */     // MIs[0] abid
     /* 271441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 271444 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3330:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
     /* 271444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_FP8_e64),
     /* 271447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271449 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 271451 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 271453 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 271455 */     GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
     /* 271457 */     GIR_RootToRootCopy, /*OpIdx*/7, // abid
     /* 271459 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 271461 */     GIR_RootConstrainSelectedInstOperands,
     /* 271462 */     // GIR_Coverage, 1307,
     /* 271462 */     GIR_EraseRootFromParent_Done,
     /* 271463 */   // Label 4453: @271463
     /* 271463 */   GIM_Reject,
     /* 271464 */ // Label 4292: @271464
     /* 271464 */ GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(272004),
     /* 271469 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 271472 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(271563), // Rule ID 2849 //
     /* 271477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 271480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
     /* 271485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 271488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 271491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 271494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 271497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 271500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 271504 */     // MIs[0] clamp
     /* 271504 */     // No operand predicates
     /* 271504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 271525 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3400:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 271525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr),
     /* 271528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 271535 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 271537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 271542 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 271544 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 271546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 271551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 271556 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 271558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271561 */     GIR_RootConstrainSelectedInstOperands,
     /* 271562 */     // GIR_Coverage, 2849,
     /* 271562 */     GIR_EraseRootFromParent_Done,
     /* 271563 */   // Label 4455: @271563
     /* 271563 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(271654), // Rule ID 2850 //
     /* 271568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 271571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
     /* 271576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 271579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 271582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 271585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 271588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 271591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 271595 */     // MIs[0] clamp
     /* 271595 */     // No operand predicates
     /* 271595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 271616 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3399:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 271616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr),
     /* 271619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 271626 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 271628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 271633 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 271635 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 271637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 271642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 271647 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 271649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271652 */     GIR_RootConstrainSelectedInstOperands,
     /* 271653 */     // GIR_Coverage, 2850,
     /* 271653 */     GIR_EraseRootFromParent_Done,
     /* 271654 */   // Label 4456: @271654
     /* 271654 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(271745), // Rule ID 2882 //
     /* 271659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 271662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
     /* 271667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 271673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 271676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 271679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 271682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271686 */     // MIs[0] clamp
     /* 271686 */     // No operand predicates
     /* 271686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
     /* 271707 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3400:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit, i1:{ *:[i1] }:$clamp)
     /* 271707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr),
     /* 271710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 271717 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 271719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 271724 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 271726 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 271728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 271733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
     /* 271738 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 271740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271743 */     GIR_RootConstrainSelectedInstOperands,
     /* 271744 */     // GIR_Coverage, 2882,
     /* 271744 */     GIR_EraseRootFromParent_Done,
     /* 271745 */   // Label 4457: @271745
     /* 271745 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(271836), // Rule ID 2883 //
     /* 271750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 271753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
     /* 271758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 271764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 271767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 271770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 271773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271777 */     // MIs[0] clamp
     /* 271777 */     // No operand predicates
     /* 271777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 271798 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3399:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 271798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr),
     /* 271801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 271808 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 271810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 271815 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 271817 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 271819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 271824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 271829 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 271831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271834 */     GIR_RootConstrainSelectedInstOperands,
     /* 271835 */     // GIR_Coverage, 2883,
     /* 271835 */     GIR_EraseRootFromParent_Done,
     /* 271836 */   // Label 4458: @271836
     /* 271836 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(271927), // Rule ID 2884 //
     /* 271841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 271844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
     /* 271849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 271852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 271855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
     /* 271858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /* 271861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 271864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 271868 */     // MIs[0] clamp
     /* 271868 */     // No operand predicates
     /* 271868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
     /* 271889 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3401:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
     /* 271889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr),
     /* 271892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 271899 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 271901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 271906 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 271908 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 271910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 271915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
     /* 271920 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 271922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271925 */     GIR_RootConstrainSelectedInstOperands,
     /* 271926 */     // GIR_Coverage, 2884,
     /* 271926 */     GIR_EraseRootFromParent_Done,
     /* 271927 */   // Label 4459: @271927
     /* 271927 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(272003), // Rule ID 2851 //
     /* 271932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 271935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
     /* 271940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 271943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 271946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /* 271949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
     /* 271952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 271955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
     /* 271959 */     // MIs[0] clamp
     /* 271959 */     // No operand predicates
     /* 271959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
     /* 271973 */     // (intrinsic_wo_chain:{ *:[v8i32] } 3401:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
     /* 271973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr),
     /* 271976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 271978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
     /* 271983 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 271985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
     /* 271990 */     GIR_RootToRootCopy, /*OpIdx*/5, // src1
     /* 271992 */     GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
     /* 271994 */     GIR_RootToRootCopy, /*OpIdx*/7, // src2
     /* 271996 */     GIR_RootToRootCopy, /*OpIdx*/8, // clamp
     /* 271998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272001 */     GIR_RootConstrainSelectedInstOperands,
     /* 272002 */     // GIR_Coverage, 2851,
     /* 272002 */     GIR_EraseRootFromParent_Done,
     /* 272003 */   // Label 4460: @272003
     /* 272003 */   GIM_Reject,
     /* 272004 */ // Label 4454: @272004
     /* 272004 */ GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(277917),
     /* 272009 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/11,
     /* 272012 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(272082), // Rule ID 1172 //
     /* 272017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272037 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272040 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272047 */     // MIs[0] cbsz
     /* 272047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272050 */     // MIs[0] blgp
     /* 272050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272053 */     // MIs[0] Operand 7
     /* 272053 */     // No operand predicates
     /* 272053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272057 */     // MIs[0] Operand 9
     /* 272057 */     // No operand predicates
     /* 272057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 272065 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64),
     /* 272068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272072 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272074 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272076 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272078 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272080 */     GIR_RootConstrainSelectedInstOperands,
     /* 272081 */     // GIR_Coverage, 1172,
     /* 272081 */     GIR_EraseRootFromParent_Done,
     /* 272082 */   // Label 4462: @272082
     /* 272082 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(272152), // Rule ID 1173 //
     /* 272087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 272090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272107 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272110 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272117 */     // MIs[0] cbsz
     /* 272117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272120 */     // MIs[0] blgp
     /* 272120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272123 */     // MIs[0] Operand 7
     /* 272123 */     // No operand predicates
     /* 272123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272127 */     // MIs[0] Operand 9
     /* 272127 */     // No operand predicates
     /* 272127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 272135 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
     /* 272138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272142 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272144 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272146 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272148 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272150 */     GIR_RootConstrainSelectedInstOperands,
     /* 272151 */     // GIR_Coverage, 1173,
     /* 272151 */     GIR_EraseRootFromParent_Done,
     /* 272152 */   // Label 4463: @272152
     /* 272152 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(272222), // Rule ID 1174 //
     /* 272157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272177 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272180 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272187 */     // MIs[0] cbsz
     /* 272187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272190 */     // MIs[0] blgp
     /* 272190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272193 */     // MIs[0] Operand 7
     /* 272193 */     // No operand predicates
     /* 272193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272197 */     // MIs[0] Operand 9
     /* 272197 */     // No operand predicates
     /* 272197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 272205 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64),
     /* 272208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272210 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272212 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272214 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272216 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272218 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272220 */     GIR_RootConstrainSelectedInstOperands,
     /* 272221 */     // GIR_Coverage, 1174,
     /* 272221 */     GIR_EraseRootFromParent_Done,
     /* 272222 */   // Label 4464: @272222
     /* 272222 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(272292), // Rule ID 1175 //
     /* 272227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 272230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272247 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272250 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272257 */     // MIs[0] cbsz
     /* 272257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272260 */     // MIs[0] blgp
     /* 272260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272263 */     // MIs[0] Operand 7
     /* 272263 */     // No operand predicates
     /* 272263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272267 */     // MIs[0] Operand 9
     /* 272267 */     // No operand predicates
     /* 272267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 272275 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
     /* 272278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272280 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272282 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272284 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272286 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272288 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272290 */     GIR_RootConstrainSelectedInstOperands,
     /* 272291 */     // GIR_Coverage, 1175,
     /* 272291 */     GIR_EraseRootFromParent_Done,
     /* 272292 */   // Label 4465: @272292
     /* 272292 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(272362), // Rule ID 1176 //
     /* 272297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272317 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272320 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272327 */     // MIs[0] cbsz
     /* 272327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272330 */     // MIs[0] blgp
     /* 272330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272333 */     // MIs[0] Operand 7
     /* 272333 */     // No operand predicates
     /* 272333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272337 */     // MIs[0] Operand 9
     /* 272337 */     // No operand predicates
     /* 272337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 272345 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64),
     /* 272348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272352 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272354 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272356 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272358 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272360 */     GIR_RootConstrainSelectedInstOperands,
     /* 272361 */     // GIR_Coverage, 1176,
     /* 272361 */     GIR_EraseRootFromParent_Done,
     /* 272362 */   // Label 4466: @272362
     /* 272362 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(272432), // Rule ID 1177 //
     /* 272367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 272370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272387 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272390 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272397 */     // MIs[0] cbsz
     /* 272397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272400 */     // MIs[0] blgp
     /* 272400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272403 */     // MIs[0] Operand 7
     /* 272403 */     // No operand predicates
     /* 272403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272407 */     // MIs[0] Operand 9
     /* 272407 */     // No operand predicates
     /* 272407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 272415 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
     /* 272418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272420 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272422 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272424 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272426 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272428 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272430 */     GIR_RootConstrainSelectedInstOperands,
     /* 272431 */     // GIR_Coverage, 1177,
     /* 272431 */     GIR_EraseRootFromParent_Done,
     /* 272432 */   // Label 4467: @272432
     /* 272432 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(272502), // Rule ID 1178 //
     /* 272437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272457 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272460 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272467 */     // MIs[0] cbsz
     /* 272467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272470 */     // MIs[0] blgp
     /* 272470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272473 */     // MIs[0] Operand 7
     /* 272473 */     // No operand predicates
     /* 272473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272477 */     // MIs[0] Operand 9
     /* 272477 */     // No operand predicates
     /* 272477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 272485 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64),
     /* 272488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272490 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272492 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272494 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272496 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272498 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272500 */     GIR_RootConstrainSelectedInstOperands,
     /* 272501 */     // GIR_Coverage, 1178,
     /* 272501 */     GIR_EraseRootFromParent_Done,
     /* 272502 */   // Label 4468: @272502
     /* 272502 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(272572), // Rule ID 1179 //
     /* 272507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 272510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 272524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272527 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272530 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272537 */     // MIs[0] cbsz
     /* 272537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272540 */     // MIs[0] blgp
     /* 272540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272543 */     // MIs[0] Operand 7
     /* 272543 */     // No operand predicates
     /* 272543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272547 */     // MIs[0] Operand 9
     /* 272547 */     // No operand predicates
     /* 272547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 272555 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
     /* 272558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272562 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272564 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272566 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272568 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272570 */     GIR_RootConstrainSelectedInstOperands,
     /* 272571 */     // GIR_Coverage, 1179,
     /* 272571 */     GIR_EraseRootFromParent_Done,
     /* 272572 */   // Label 4469: @272572
     /* 272572 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(272642), // Rule ID 1180 //
     /* 272577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272597 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272600 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272607 */     // MIs[0] cbsz
     /* 272607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272610 */     // MIs[0] blgp
     /* 272610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272613 */     // MIs[0] Operand 7
     /* 272613 */     // No operand predicates
     /* 272613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272617 */     // MIs[0] Operand 9
     /* 272617 */     // No operand predicates
     /* 272617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 272625 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64),
     /* 272628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272630 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272632 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272634 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272636 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272638 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272640 */     GIR_RootConstrainSelectedInstOperands,
     /* 272641 */     // GIR_Coverage, 1180,
     /* 272641 */     GIR_EraseRootFromParent_Done,
     /* 272642 */   // Label 4470: @272642
     /* 272642 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(272712), // Rule ID 1181 //
     /* 272647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 272650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 272661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272667 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272670 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272677 */     // MIs[0] cbsz
     /* 272677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272680 */     // MIs[0] blgp
     /* 272680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272683 */     // MIs[0] Operand 7
     /* 272683 */     // No operand predicates
     /* 272683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272687 */     // MIs[0] Operand 9
     /* 272687 */     // No operand predicates
     /* 272687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 272695 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
     /* 272698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272702 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272704 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272706 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272708 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272710 */     GIR_RootConstrainSelectedInstOperands,
     /* 272711 */     // GIR_Coverage, 1181,
     /* 272711 */     GIR_EraseRootFromParent_Done,
     /* 272712 */   // Label 4471: @272712
     /* 272712 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(272782), // Rule ID 1182 //
     /* 272717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272737 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272740 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272747 */     // MIs[0] cbsz
     /* 272747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272750 */     // MIs[0] blgp
     /* 272750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272753 */     // MIs[0] Operand 7
     /* 272753 */     // No operand predicates
     /* 272753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272757 */     // MIs[0] Operand 9
     /* 272757 */     // No operand predicates
     /* 272757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 272765 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64),
     /* 272768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272770 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272772 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272774 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272776 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272778 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272780 */     GIR_RootConstrainSelectedInstOperands,
     /* 272781 */     // GIR_Coverage, 1182,
     /* 272781 */     GIR_EraseRootFromParent_Done,
     /* 272782 */   // Label 4472: @272782
     /* 272782 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(272852), // Rule ID 1183 //
     /* 272787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 272790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 272804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272807 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272810 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272817 */     // MIs[0] cbsz
     /* 272817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272820 */     // MIs[0] blgp
     /* 272820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272823 */     // MIs[0] Operand 7
     /* 272823 */     // No operand predicates
     /* 272823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272827 */     // MIs[0] Operand 9
     /* 272827 */     // No operand predicates
     /* 272827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 272835 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
     /* 272838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272840 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272842 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272844 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272846 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272848 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272850 */     GIR_RootConstrainSelectedInstOperands,
     /* 272851 */     // GIR_Coverage, 1183,
     /* 272851 */     GIR_EraseRootFromParent_Done,
     /* 272852 */   // Label 4473: @272852
     /* 272852 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(272922), // Rule ID 1184 //
     /* 272857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 272860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272877 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272880 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 272887 */     // MIs[0] cbsz
     /* 272887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272890 */     // MIs[0] blgp
     /* 272890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272893 */     // MIs[0] Operand 7
     /* 272893 */     // No operand predicates
     /* 272893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272897 */     // MIs[0] Operand 9
     /* 272897 */     // No operand predicates
     /* 272897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 272905 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64),
     /* 272908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272910 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272912 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272914 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272916 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272918 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272920 */     GIR_RootConstrainSelectedInstOperands,
     /* 272921 */     // GIR_Coverage, 1184,
     /* 272921 */     GIR_EraseRootFromParent_Done,
     /* 272922 */   // Label 4474: @272922
     /* 272922 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(272992), // Rule ID 1185 //
     /* 272927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 272930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 272935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 272938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 272941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 272947 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 272950 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 272953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 272957 */     // MIs[0] cbsz
     /* 272957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 272960 */     // MIs[0] blgp
     /* 272960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 272963 */     // MIs[0] Operand 7
     /* 272963 */     // No operand predicates
     /* 272963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 272967 */     // MIs[0] Operand 9
     /* 272967 */     // No operand predicates
     /* 272967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 272971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 272975 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 272975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
     /* 272978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 272980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 272982 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 272984 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 272986 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 272988 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 272990 */     GIR_RootConstrainSelectedInstOperands,
     /* 272991 */     // GIR_Coverage, 1185,
     /* 272991 */     GIR_EraseRootFromParent_Done,
     /* 272992 */   // Label 4475: @272992
     /* 272992 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(273062), // Rule ID 1186 //
     /* 272997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 273005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 273017 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273020 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 273027 */     // MIs[0] cbsz
     /* 273027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273030 */     // MIs[0] blgp
     /* 273030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273033 */     // MIs[0] Operand 7
     /* 273033 */     // No operand predicates
     /* 273033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273037 */     // MIs[0] Operand 9
     /* 273037 */     // No operand predicates
     /* 273037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 273045 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64),
     /* 273048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273052 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273054 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273056 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273058 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273060 */     GIR_RootConstrainSelectedInstOperands,
     /* 273061 */     // GIR_Coverage, 1186,
     /* 273061 */     GIR_EraseRootFromParent_Done,
     /* 273062 */   // Label 4476: @273062
     /* 273062 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(273132), // Rule ID 1187 //
     /* 273067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 273070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 273075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 273087 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273090 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 273097 */     // MIs[0] cbsz
     /* 273097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273100 */     // MIs[0] blgp
     /* 273100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273103 */     // MIs[0] Operand 7
     /* 273103 */     // No operand predicates
     /* 273103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273107 */     // MIs[0] Operand 9
     /* 273107 */     // No operand predicates
     /* 273107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 273115 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
     /* 273118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273122 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273124 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273126 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273128 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273130 */     GIR_RootConstrainSelectedInstOperands,
     /* 273131 */     // GIR_Coverage, 1187,
     /* 273131 */     GIR_EraseRootFromParent_Done,
     /* 273132 */   // Label 4477: @273132
     /* 273132 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(273202), // Rule ID 1188 //
     /* 273137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 273145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 273157 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273160 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 273167 */     // MIs[0] cbsz
     /* 273167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273170 */     // MIs[0] blgp
     /* 273170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273173 */     // MIs[0] Operand 7
     /* 273173 */     // No operand predicates
     /* 273173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273177 */     // MIs[0] Operand 9
     /* 273177 */     // No operand predicates
     /* 273177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23394),
     /* 273185 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23394>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64),
     /* 273188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273192 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273194 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273196 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273198 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273200 */     GIR_RootConstrainSelectedInstOperands,
     /* 273201 */     // GIR_Coverage, 1188,
     /* 273201 */     GIR_EraseRootFromParent_Done,
     /* 273202 */   // Label 4478: @273202
     /* 273202 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(273272), // Rule ID 1189 //
     /* 273207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 273210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 273215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 273227 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273230 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 273237 */     // MIs[0] cbsz
     /* 273237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273240 */     // MIs[0] blgp
     /* 273240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273243 */     // MIs[0] Operand 7
     /* 273243 */     // No operand predicates
     /* 273243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273247 */     // MIs[0] Operand 9
     /* 273247 */     // No operand predicates
     /* 273247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23396),
     /* 273255 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23396>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
     /* 273258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273262 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273264 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273266 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273268 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273270 */     GIR_RootConstrainSelectedInstOperands,
     /* 273271 */     // GIR_Coverage, 1189,
     /* 273271 */     GIR_EraseRootFromParent_Done,
     /* 273272 */   // Label 4479: @273272
     /* 273272 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(273342), // Rule ID 1190 //
     /* 273277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 273291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 273294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273297 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273300 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273307 */     // MIs[0] cbsz
     /* 273307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273310 */     // MIs[0] blgp
     /* 273310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273313 */     // MIs[0] Operand 7
     /* 273313 */     // No operand predicates
     /* 273313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273317 */     // MIs[0] Operand 9
     /* 273317 */     // No operand predicates
     /* 273317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 273325 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
     /* 273328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273330 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273332 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273334 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273336 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273338 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273340 */     GIR_RootConstrainSelectedInstOperands,
     /* 273341 */     // GIR_Coverage, 1190,
     /* 273341 */     GIR_EraseRootFromParent_Done,
     /* 273342 */   // Label 4480: @273342
     /* 273342 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(273412), // Rule ID 1191 //
     /* 273347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 273350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 273361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 273364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273367 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273370 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273377 */     // MIs[0] cbsz
     /* 273377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273380 */     // MIs[0] blgp
     /* 273380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273383 */     // MIs[0] Operand 7
     /* 273383 */     // No operand predicates
     /* 273383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273387 */     // MIs[0] Operand 9
     /* 273387 */     // No operand predicates
     /* 273387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 273395 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
     /* 273398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273400 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273402 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273404 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273406 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273408 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273410 */     GIR_RootConstrainSelectedInstOperands,
     /* 273411 */     // GIR_Coverage, 1191,
     /* 273411 */     GIR_EraseRootFromParent_Done,
     /* 273412 */   // Label 4481: @273412
     /* 273412 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(273482), // Rule ID 1192 //
     /* 273417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 273431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273437 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273440 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273447 */     // MIs[0] cbsz
     /* 273447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273450 */     // MIs[0] blgp
     /* 273450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273453 */     // MIs[0] Operand 7
     /* 273453 */     // No operand predicates
     /* 273453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273457 */     // MIs[0] Operand 9
     /* 273457 */     // No operand predicates
     /* 273457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 273465 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
     /* 273468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273470 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273472 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273474 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273476 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273478 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273480 */     GIR_RootConstrainSelectedInstOperands,
     /* 273481 */     // GIR_Coverage, 1192,
     /* 273481 */     GIR_EraseRootFromParent_Done,
     /* 273482 */   // Label 4482: @273482
     /* 273482 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(273552), // Rule ID 1193 //
     /* 273487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 273490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 273501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273507 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273510 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273517 */     // MIs[0] cbsz
     /* 273517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273520 */     // MIs[0] blgp
     /* 273520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273523 */     // MIs[0] Operand 7
     /* 273523 */     // No operand predicates
     /* 273523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273527 */     // MIs[0] Operand 9
     /* 273527 */     // No operand predicates
     /* 273527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 273535 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
     /* 273538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273540 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273542 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273544 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273546 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273548 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273550 */     GIR_RootConstrainSelectedInstOperands,
     /* 273551 */     // GIR_Coverage, 1193,
     /* 273551 */     GIR_EraseRootFromParent_Done,
     /* 273552 */   // Label 4483: @273552
     /* 273552 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(273622), // Rule ID 1194 //
     /* 273557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 273574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273577 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273580 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273587 */     // MIs[0] cbsz
     /* 273587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273590 */     // MIs[0] blgp
     /* 273590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273593 */     // MIs[0] Operand 7
     /* 273593 */     // No operand predicates
     /* 273593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273597 */     // MIs[0] Operand 9
     /* 273597 */     // No operand predicates
     /* 273597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 273605 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
     /* 273608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273610 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273612 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273614 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273616 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273618 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273620 */     GIR_RootConstrainSelectedInstOperands,
     /* 273621 */     // GIR_Coverage, 1194,
     /* 273621 */     GIR_EraseRootFromParent_Done,
     /* 273622 */   // Label 4484: @273622
     /* 273622 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(273692), // Rule ID 1195 //
     /* 273627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 273630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 273644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273647 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273650 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273657 */     // MIs[0] cbsz
     /* 273657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273660 */     // MIs[0] blgp
     /* 273660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273663 */     // MIs[0] Operand 7
     /* 273663 */     // No operand predicates
     /* 273663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273667 */     // MIs[0] Operand 9
     /* 273667 */     // No operand predicates
     /* 273667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 273675 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
     /* 273678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273682 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273684 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273686 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273688 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273690 */     GIR_RootConstrainSelectedInstOperands,
     /* 273691 */     // GIR_Coverage, 1195,
     /* 273691 */     GIR_EraseRootFromParent_Done,
     /* 273692 */   // Label 4485: @273692
     /* 273692 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(273762), // Rule ID 1196 //
     /* 273697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273717 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273720 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273727 */     // MIs[0] cbsz
     /* 273727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273730 */     // MIs[0] blgp
     /* 273730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273733 */     // MIs[0] Operand 7
     /* 273733 */     // No operand predicates
     /* 273733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273737 */     // MIs[0] Operand 9
     /* 273737 */     // No operand predicates
     /* 273737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 273745 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
     /* 273748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273750 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273752 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273754 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273756 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273758 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273760 */     GIR_RootConstrainSelectedInstOperands,
     /* 273761 */     // GIR_Coverage, 1196,
     /* 273761 */     GIR_EraseRootFromParent_Done,
     /* 273762 */   // Label 4486: @273762
     /* 273762 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(273832), // Rule ID 1197 //
     /* 273767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 273770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 273781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 273784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273787 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273790 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273797 */     // MIs[0] cbsz
     /* 273797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273800 */     // MIs[0] blgp
     /* 273800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273803 */     // MIs[0] Operand 7
     /* 273803 */     // No operand predicates
     /* 273803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273807 */     // MIs[0] Operand 9
     /* 273807 */     // No operand predicates
     /* 273807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 273815 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
     /* 273818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273820 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273822 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273824 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273826 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273828 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273830 */     GIR_RootConstrainSelectedInstOperands,
     /* 273831 */     // GIR_Coverage, 1197,
     /* 273831 */     GIR_EraseRootFromParent_Done,
     /* 273832 */   // Label 4487: @273832
     /* 273832 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(273902), // Rule ID 1198 //
     /* 273837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 273851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273857 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273860 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 273867 */     // MIs[0] cbsz
     /* 273867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273870 */     // MIs[0] blgp
     /* 273870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273873 */     // MIs[0] Operand 7
     /* 273873 */     // No operand predicates
     /* 273873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273877 */     // MIs[0] Operand 9
     /* 273877 */     // No operand predicates
     /* 273877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 273885 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
     /* 273888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273892 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273894 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273896 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273898 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273900 */     GIR_RootConstrainSelectedInstOperands,
     /* 273901 */     // GIR_Coverage, 1198,
     /* 273901 */     GIR_EraseRootFromParent_Done,
     /* 273902 */   // Label 4488: @273902
     /* 273902 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(273972), // Rule ID 1199 //
     /* 273907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 273910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 273921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273927 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 273930 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 273933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 273937 */     // MIs[0] cbsz
     /* 273937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 273940 */     // MIs[0] blgp
     /* 273940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 273943 */     // MIs[0] Operand 7
     /* 273943 */     // No operand predicates
     /* 273943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 273947 */     // MIs[0] Operand 9
     /* 273947 */     // No operand predicates
     /* 273947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 273951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 273955 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 273955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
     /* 273958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 273960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 273962 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 273964 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 273966 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 273968 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 273970 */     GIR_RootConstrainSelectedInstOperands,
     /* 273971 */     // GIR_Coverage, 1199,
     /* 273971 */     GIR_EraseRootFromParent_Done,
     /* 273972 */   // Label 4489: @273972
     /* 273972 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(274042), // Rule ID 1200 //
     /* 273977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 273980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 273985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 273988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 273994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 273997 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274000 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 274007 */     // MIs[0] cbsz
     /* 274007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274010 */     // MIs[0] blgp
     /* 274010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274013 */     // MIs[0] Operand 7
     /* 274013 */     // No operand predicates
     /* 274013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274017 */     // MIs[0] Operand 9
     /* 274017 */     // No operand predicates
     /* 274017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 274025 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
     /* 274028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274032 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274034 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274036 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274038 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274040 */     GIR_RootConstrainSelectedInstOperands,
     /* 274041 */     // GIR_Coverage, 1200,
     /* 274041 */     GIR_EraseRootFromParent_Done,
     /* 274042 */   // Label 4490: @274042
     /* 274042 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(274112), // Rule ID 1201 //
     /* 274047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 274050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 274055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 274058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 274064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 274067 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274070 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 274077 */     // MIs[0] cbsz
     /* 274077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274080 */     // MIs[0] blgp
     /* 274080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274083 */     // MIs[0] Operand 7
     /* 274083 */     // No operand predicates
     /* 274083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274087 */     // MIs[0] Operand 9
     /* 274087 */     // No operand predicates
     /* 274087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 274095 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
     /* 274098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274104 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274106 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274108 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274110 */     GIR_RootConstrainSelectedInstOperands,
     /* 274111 */     // GIR_Coverage, 1201,
     /* 274111 */     GIR_EraseRootFromParent_Done,
     /* 274112 */   // Label 4491: @274112
     /* 274112 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(274182), // Rule ID 1202 //
     /* 274117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 274125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 274128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 274131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 274134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 274137 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274140 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 274147 */     // MIs[0] cbsz
     /* 274147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274150 */     // MIs[0] blgp
     /* 274150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274153 */     // MIs[0] Operand 7
     /* 274153 */     // No operand predicates
     /* 274153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274157 */     // MIs[0] Operand 9
     /* 274157 */     // No operand predicates
     /* 274157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 274165 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
     /* 274168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274172 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274174 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274176 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274178 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274180 */     GIR_RootConstrainSelectedInstOperands,
     /* 274181 */     // GIR_Coverage, 1202,
     /* 274181 */     GIR_EraseRootFromParent_Done,
     /* 274182 */   // Label 4492: @274182
     /* 274182 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(274252), // Rule ID 1203 //
     /* 274187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 274190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 274195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 274198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 274201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 274204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 274207 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274210 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 274217 */     // MIs[0] cbsz
     /* 274217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274220 */     // MIs[0] blgp
     /* 274220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274223 */     // MIs[0] Operand 7
     /* 274223 */     // No operand predicates
     /* 274223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274227 */     // MIs[0] Operand 9
     /* 274227 */     // No operand predicates
     /* 274227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 274235 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
     /* 274238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274242 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274244 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274246 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274248 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274250 */     GIR_RootConstrainSelectedInstOperands,
     /* 274251 */     // GIR_Coverage, 1203,
     /* 274251 */     GIR_EraseRootFromParent_Done,
     /* 274252 */   // Label 4493: @274252
     /* 274252 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(274322), // Rule ID 1204 //
     /* 274257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 274265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 274268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 274274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 274277 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274280 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 274287 */     // MIs[0] cbsz
     /* 274287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274290 */     // MIs[0] blgp
     /* 274290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274293 */     // MIs[0] Operand 7
     /* 274293 */     // No operand predicates
     /* 274293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274297 */     // MIs[0] Operand 9
     /* 274297 */     // No operand predicates
     /* 274297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 274305 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
     /* 274308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274310 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274312 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274314 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274316 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274318 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274320 */     GIR_RootConstrainSelectedInstOperands,
     /* 274321 */     // GIR_Coverage, 1204,
     /* 274321 */     GIR_EraseRootFromParent_Done,
     /* 274322 */   // Label 4494: @274322
     /* 274322 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(274392), // Rule ID 1205 //
     /* 274327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 274330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 274335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 274338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 274344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 274347 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274350 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 274357 */     // MIs[0] cbsz
     /* 274357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274360 */     // MIs[0] blgp
     /* 274360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274363 */     // MIs[0] Operand 7
     /* 274363 */     // No operand predicates
     /* 274363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274367 */     // MIs[0] Operand 9
     /* 274367 */     // No operand predicates
     /* 274367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 274375 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
     /* 274378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274380 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274382 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274384 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274386 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274388 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274390 */     GIR_RootConstrainSelectedInstOperands,
     /* 274391 */     // GIR_Coverage, 1205,
     /* 274391 */     GIR_EraseRootFromParent_Done,
     /* 274392 */   // Label 4495: @274392
     /* 274392 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(274462), // Rule ID 1206 //
     /* 274397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 274405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 274408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 274414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 274417 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274420 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 274427 */     // MIs[0] cbsz
     /* 274427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274430 */     // MIs[0] blgp
     /* 274430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274433 */     // MIs[0] Operand 7
     /* 274433 */     // No operand predicates
     /* 274433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274437 */     // MIs[0] Operand 9
     /* 274437 */     // No operand predicates
     /* 274437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23416),
     /* 274445 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23416>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
     /* 274448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274450 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274452 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274454 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274456 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274458 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274460 */     GIR_RootConstrainSelectedInstOperands,
     /* 274461 */     // GIR_Coverage, 1206,
     /* 274461 */     GIR_EraseRootFromParent_Done,
     /* 274462 */   // Label 4496: @274462
     /* 274462 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(274532), // Rule ID 1207 //
     /* 274467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
     /* 274470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 274475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 274478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 274484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 274487 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274490 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 274497 */     // MIs[0] cbsz
     /* 274497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274500 */     // MIs[0] blgp
     /* 274500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274503 */     // MIs[0] Operand 7
     /* 274503 */     // No operand predicates
     /* 274503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /* 274507 */     // MIs[0] Operand 9
     /* 274507 */     // No operand predicates
     /* 274507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
     /* 274511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23418),
     /* 274515 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_23418>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
     /* 274515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
     /* 274518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274522 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274524 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274526 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274528 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274530 */     GIR_RootConstrainSelectedInstOperands,
     /* 274531 */     // GIR_Coverage, 1207,
     /* 274531 */     GIR_EraseRootFromParent_Done,
     /* 274532 */   // Label 4497: @274532
     /* 274532 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(274626), // Rule ID 1208 //
     /* 274537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 274545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 274551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 274554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 274557 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274560 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 274567 */     // MIs[0] cbsz
     /* 274567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274570 */     // MIs[0] blgp
     /* 274570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274573 */     // MIs[0] src0_modifiers
     /* 274573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 274576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274581 */     // MIs[0] src1_modifiers
     /* 274581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 274584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 274593 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 274593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64),
     /* 274596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274600 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274602 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274604 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274606 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274608 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 274610 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 274612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 274618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 274624 */     GIR_RootConstrainSelectedInstOperands,
     /* 274625 */     // GIR_Coverage, 1208,
     /* 274625 */     GIR_EraseRootFromParent_Done,
     /* 274626 */   // Label 4498: @274626
     /* 274626 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(274720), // Rule ID 1209 //
     /* 274631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 274639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 274645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 274648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 274651 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274654 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 274661 */     // MIs[0] cbsz
     /* 274661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274664 */     // MIs[0] blgp
     /* 274664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274667 */     // MIs[0] src0_modifiers
     /* 274667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 274670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274675 */     // MIs[0] src1_modifiers
     /* 274675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 274678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 274687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 274687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
     /* 274690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274692 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274694 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274696 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274698 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274700 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274702 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 274704 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 274706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 274712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 274718 */     GIR_RootConstrainSelectedInstOperands,
     /* 274719 */     // GIR_Coverage, 1209,
     /* 274719 */     GIR_EraseRootFromParent_Done,
     /* 274720 */   // Label 4499: @274720
     /* 274720 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(274814), // Rule ID 1210 //
     /* 274725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 274733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 274739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 274742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 274745 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274748 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 274755 */     // MIs[0] cbsz
     /* 274755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274758 */     // MIs[0] blgp
     /* 274758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274761 */     // MIs[0] src0_modifiers
     /* 274761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 274764 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274769 */     // MIs[0] src1_modifiers
     /* 274769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 274772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 274781 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 274781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64),
     /* 274784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274788 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274790 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274792 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274794 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274796 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 274798 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 274800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 274806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 274812 */     GIR_RootConstrainSelectedInstOperands,
     /* 274813 */     // GIR_Coverage, 1210,
     /* 274813 */     GIR_EraseRootFromParent_Done,
     /* 274814 */   // Label 4500: @274814
     /* 274814 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(274908), // Rule ID 1211 //
     /* 274819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 274827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 274833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 274836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 274839 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274842 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 274849 */     // MIs[0] cbsz
     /* 274849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274852 */     // MIs[0] blgp
     /* 274852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274855 */     // MIs[0] src0_modifiers
     /* 274855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 274858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274863 */     // MIs[0] src1_modifiers
     /* 274863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 274866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 274875 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 274875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
     /* 274878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274882 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274884 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274886 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274888 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274890 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 274892 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 274894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 274900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 274906 */     GIR_RootConstrainSelectedInstOperands,
     /* 274907 */     // GIR_Coverage, 1211,
     /* 274907 */     GIR_EraseRootFromParent_Done,
     /* 274908 */   // Label 4501: @274908
     /* 274908 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(275002), // Rule ID 1212 //
     /* 274913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 274916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 274921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 274927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 274930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 274933 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 274936 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 274939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 274943 */     // MIs[0] cbsz
     /* 274943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274946 */     // MIs[0] blgp
     /* 274946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 274949 */     // MIs[0] src0_modifiers
     /* 274949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 274952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274957 */     // MIs[0] src1_modifiers
     /* 274957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 274960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 274965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 274969 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 274969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64),
     /* 274972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 274974 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 274976 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 274978 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 274980 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 274982 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 274984 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 274986 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 274988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 274994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275000 */     GIR_RootConstrainSelectedInstOperands,
     /* 275001 */     // GIR_Coverage, 1212,
     /* 275001 */     GIR_EraseRootFromParent_Done,
     /* 275002 */   // Label 4502: @275002
     /* 275002 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(275096), // Rule ID 1213 //
     /* 275007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 275021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 275024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275027 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275030 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 275037 */     // MIs[0] cbsz
     /* 275037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275040 */     // MIs[0] blgp
     /* 275040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275043 */     // MIs[0] src0_modifiers
     /* 275043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275051 */     // MIs[0] src1_modifiers
     /* 275051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 275063 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
     /* 275066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275070 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275072 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275074 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275076 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275078 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275080 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275094 */     GIR_RootConstrainSelectedInstOperands,
     /* 275095 */     // GIR_Coverage, 1213,
     /* 275095 */     GIR_EraseRootFromParent_Done,
     /* 275096 */   // Label 4503: @275096
     /* 275096 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(275190), // Rule ID 1214 //
     /* 275101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 275115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 275118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275121 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275124 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 275131 */     // MIs[0] cbsz
     /* 275131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275134 */     // MIs[0] blgp
     /* 275134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275137 */     // MIs[0] src0_modifiers
     /* 275137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275145 */     // MIs[0] src1_modifiers
     /* 275145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 275157 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64),
     /* 275160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275164 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275166 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275168 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275170 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275172 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275174 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275188 */     GIR_RootConstrainSelectedInstOperands,
     /* 275189 */     // GIR_Coverage, 1214,
     /* 275189 */     GIR_EraseRootFromParent_Done,
     /* 275190 */   // Label 4504: @275190
     /* 275190 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(275284), // Rule ID 1215 //
     /* 275195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 275209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 275212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275215 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275218 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 275225 */     // MIs[0] cbsz
     /* 275225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275228 */     // MIs[0] blgp
     /* 275228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275231 */     // MIs[0] src0_modifiers
     /* 275231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275239 */     // MIs[0] src1_modifiers
     /* 275239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 275251 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
     /* 275254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275258 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275260 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275262 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275264 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275266 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275268 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275270 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275282 */     GIR_RootConstrainSelectedInstOperands,
     /* 275283 */     // GIR_Coverage, 1215,
     /* 275283 */     GIR_EraseRootFromParent_Done,
     /* 275284 */   // Label 4505: @275284
     /* 275284 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(275378), // Rule ID 1216 //
     /* 275289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 275303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275309 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275312 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 275319 */     // MIs[0] cbsz
     /* 275319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275322 */     // MIs[0] blgp
     /* 275322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275325 */     // MIs[0] src0_modifiers
     /* 275325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275333 */     // MIs[0] src1_modifiers
     /* 275333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 275345 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64),
     /* 275348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275352 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275354 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275356 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275358 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275360 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275362 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275370 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275376 */     GIR_RootConstrainSelectedInstOperands,
     /* 275377 */     // GIR_Coverage, 1216,
     /* 275377 */     GIR_EraseRootFromParent_Done,
     /* 275378 */   // Label 4506: @275378
     /* 275378 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(275472), // Rule ID 1217 //
     /* 275383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 275397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275403 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275406 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 275413 */     // MIs[0] cbsz
     /* 275413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275416 */     // MIs[0] blgp
     /* 275416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275419 */     // MIs[0] src0_modifiers
     /* 275419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275427 */     // MIs[0] src1_modifiers
     /* 275427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 275439 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
     /* 275442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275446 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275448 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275450 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275452 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275454 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275456 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275458 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275470 */     GIR_RootConstrainSelectedInstOperands,
     /* 275471 */     // GIR_Coverage, 1217,
     /* 275471 */     GIR_EraseRootFromParent_Done,
     /* 275472 */   // Label 4507: @275472
     /* 275472 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(275566), // Rule ID 1218 //
     /* 275477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 275494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275497 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275500 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 275507 */     // MIs[0] cbsz
     /* 275507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275510 */     // MIs[0] blgp
     /* 275510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275513 */     // MIs[0] src0_modifiers
     /* 275513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275521 */     // MIs[0] src1_modifiers
     /* 275521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 275533 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64),
     /* 275536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275538 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275540 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275542 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275544 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275546 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275548 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275550 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275564 */     GIR_RootConstrainSelectedInstOperands,
     /* 275565 */     // GIR_Coverage, 1218,
     /* 275565 */     GIR_EraseRootFromParent_Done,
     /* 275566 */   // Label 4508: @275566
     /* 275566 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(275660), // Rule ID 1219 //
     /* 275571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 275588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275591 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275594 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 275601 */     // MIs[0] cbsz
     /* 275601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275604 */     // MIs[0] blgp
     /* 275604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275607 */     // MIs[0] src0_modifiers
     /* 275607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275615 */     // MIs[0] src1_modifiers
     /* 275615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 275627 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
     /* 275630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275634 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275636 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275638 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275640 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275642 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275644 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275658 */     GIR_RootConstrainSelectedInstOperands,
     /* 275659 */     // GIR_Coverage, 1219,
     /* 275659 */     GIR_EraseRootFromParent_Done,
     /* 275660 */   // Label 4509: @275660
     /* 275660 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(275754), // Rule ID 1220 //
     /* 275665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 275679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275685 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275688 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 275695 */     // MIs[0] cbsz
     /* 275695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275698 */     // MIs[0] blgp
     /* 275698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275701 */     // MIs[0] src0_modifiers
     /* 275701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275709 */     // MIs[0] src1_modifiers
     /* 275709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 275721 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64),
     /* 275724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275726 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275728 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275730 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275732 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275734 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275736 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275738 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275752 */     GIR_RootConstrainSelectedInstOperands,
     /* 275753 */     // GIR_Coverage, 1220,
     /* 275753 */     GIR_EraseRootFromParent_Done,
     /* 275754 */   // Label 4510: @275754
     /* 275754 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(275848), // Rule ID 1221 //
     /* 275759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 275773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275779 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275782 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 275789 */     // MIs[0] cbsz
     /* 275789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275792 */     // MIs[0] blgp
     /* 275792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275795 */     // MIs[0] src0_modifiers
     /* 275795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275803 */     // MIs[0] src1_modifiers
     /* 275803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 275815 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
     /* 275818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275820 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275822 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275824 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275826 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275828 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275830 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275832 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275846 */     GIR_RootConstrainSelectedInstOperands,
     /* 275847 */     // GIR_Coverage, 1221,
     /* 275847 */     GIR_EraseRootFromParent_Done,
     /* 275848 */   // Label 4511: @275848
     /* 275848 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(275942), // Rule ID 1222 //
     /* 275853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 275870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275873 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275876 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 275883 */     // MIs[0] cbsz
     /* 275883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275886 */     // MIs[0] blgp
     /* 275886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275889 */     // MIs[0] src0_modifiers
     /* 275889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275897 */     // MIs[0] src1_modifiers
     /* 275897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 275909 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 275909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64),
     /* 275912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 275914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 275916 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 275918 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 275920 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 275922 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 275924 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 275926 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 275928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 275934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 275940 */     GIR_RootConstrainSelectedInstOperands,
     /* 275941 */     // GIR_Coverage, 1222,
     /* 275941 */     GIR_EraseRootFromParent_Done,
     /* 275942 */   // Label 4512: @275942
     /* 275942 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(276036), // Rule ID 1223 //
     /* 275947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 275950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 275955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 275964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 275967 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 275970 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 275973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 275977 */     // MIs[0] cbsz
     /* 275977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 275980 */     // MIs[0] blgp
     /* 275980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 275983 */     // MIs[0] src0_modifiers
     /* 275983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 275986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275991 */     // MIs[0] src1_modifiers
     /* 275991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 275994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 275999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 276003 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
     /* 276006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276010 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276012 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276014 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276016 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276018 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276020 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276034 */     GIR_RootConstrainSelectedInstOperands,
     /* 276035 */     // GIR_Coverage, 1223,
     /* 276035 */     GIR_EraseRootFromParent_Done,
     /* 276036 */   // Label 4513: @276036
     /* 276036 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(276130), // Rule ID 1224 //
     /* 276041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 276049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 276058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 276061 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276064 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
     /* 276071 */     // MIs[0] cbsz
     /* 276071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276074 */     // MIs[0] blgp
     /* 276074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276077 */     // MIs[0] src0_modifiers
     /* 276077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276085 */     // MIs[0] src1_modifiers
     /* 276085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23452),
     /* 276097 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23452>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64),
     /* 276100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276102 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276104 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276106 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276108 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276110 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276112 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276114 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276116 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276122 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276128 */     GIR_RootConstrainSelectedInstOperands,
     /* 276129 */     // GIR_Coverage, 1224,
     /* 276129 */     GIR_EraseRootFromParent_Done,
     /* 276130 */   // Label 4514: @276130
     /* 276130 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(276224), // Rule ID 1225 //
     /* 276135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
     /* 276143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 276152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 276155 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276158 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 276165 */     // MIs[0] cbsz
     /* 276165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276168 */     // MIs[0] blgp
     /* 276168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276171 */     // MIs[0] src0_modifiers
     /* 276171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276179 */     // MIs[0] src1_modifiers
     /* 276179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23454),
     /* 276191 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3168:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23454>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
     /* 276194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276198 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276200 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276202 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276204 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276206 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276208 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276222 */     GIR_RootConstrainSelectedInstOperands,
     /* 276223 */     // GIR_Coverage, 1225,
     /* 276223 */     GIR_EraseRootFromParent_Done,
     /* 276224 */   // Label 4515: @276224
     /* 276224 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(276318), // Rule ID 1226 //
     /* 276229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 276243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 276246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276249 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276252 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 276259 */     // MIs[0] cbsz
     /* 276259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276262 */     // MIs[0] blgp
     /* 276262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276265 */     // MIs[0] src0_modifiers
     /* 276265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276273 */     // MIs[0] src1_modifiers
     /* 276273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 276285 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
     /* 276288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276292 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276294 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276296 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276298 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276300 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276302 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276310 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276316 */     GIR_RootConstrainSelectedInstOperands,
     /* 276317 */     // GIR_Coverage, 1226,
     /* 276317 */     GIR_EraseRootFromParent_Done,
     /* 276318 */   // Label 4516: @276318
     /* 276318 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(276412), // Rule ID 1227 //
     /* 276323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 276337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 276340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276343 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276346 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 276353 */     // MIs[0] cbsz
     /* 276353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276356 */     // MIs[0] blgp
     /* 276356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276359 */     // MIs[0] src0_modifiers
     /* 276359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276367 */     // MIs[0] src1_modifiers
     /* 276367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 276379 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
     /* 276382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276386 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276388 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276390 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276392 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276394 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276396 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276410 */     GIR_RootConstrainSelectedInstOperands,
     /* 276411 */     // GIR_Coverage, 1227,
     /* 276411 */     GIR_EraseRootFromParent_Done,
     /* 276412 */   // Label 4517: @276412
     /* 276412 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(276506), // Rule ID 1228 //
     /* 276417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 276431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 276434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276437 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276440 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 276447 */     // MIs[0] cbsz
     /* 276447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276450 */     // MIs[0] blgp
     /* 276450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276453 */     // MIs[0] src0_modifiers
     /* 276453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276461 */     // MIs[0] src1_modifiers
     /* 276461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 276473 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
     /* 276476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276478 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276480 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276482 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276484 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276486 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276488 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276490 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276504 */     GIR_RootConstrainSelectedInstOperands,
     /* 276505 */     // GIR_Coverage, 1228,
     /* 276505 */     GIR_EraseRootFromParent_Done,
     /* 276506 */   // Label 4518: @276506
     /* 276506 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(276600), // Rule ID 1229 //
     /* 276511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 276525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 276528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276531 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276534 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 276541 */     // MIs[0] cbsz
     /* 276541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276544 */     // MIs[0] blgp
     /* 276544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276547 */     // MIs[0] src0_modifiers
     /* 276547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276555 */     // MIs[0] src1_modifiers
     /* 276555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276563 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 276567 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
     /* 276570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276572 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276574 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276576 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276578 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276580 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276582 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276584 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276598 */     GIR_RootConstrainSelectedInstOperands,
     /* 276599 */     // GIR_Coverage, 1229,
     /* 276599 */     GIR_EraseRootFromParent_Done,
     /* 276600 */   // Label 4519: @276600
     /* 276600 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(276694), // Rule ID 1230 //
     /* 276605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 276619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 276622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276625 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276628 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 276635 */     // MIs[0] cbsz
     /* 276635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276638 */     // MIs[0] blgp
     /* 276638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276641 */     // MIs[0] src0_modifiers
     /* 276641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276649 */     // MIs[0] src1_modifiers
     /* 276649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 276661 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
     /* 276664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276666 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276668 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276670 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276672 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276674 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276676 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276678 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276692 */     GIR_RootConstrainSelectedInstOperands,
     /* 276693 */     // GIR_Coverage, 1230,
     /* 276693 */     GIR_EraseRootFromParent_Done,
     /* 276694 */   // Label 4520: @276694
     /* 276694 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(276788), // Rule ID 1231 //
     /* 276699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 276713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 276716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276719 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276722 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 276729 */     // MIs[0] cbsz
     /* 276729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276732 */     // MIs[0] blgp
     /* 276732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276735 */     // MIs[0] src0_modifiers
     /* 276735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276743 */     // MIs[0] src1_modifiers
     /* 276743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 276755 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
     /* 276758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276760 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276762 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276764 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276766 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276768 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276770 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276772 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276786 */     GIR_RootConstrainSelectedInstOperands,
     /* 276787 */     // GIR_Coverage, 1231,
     /* 276787 */     GIR_EraseRootFromParent_Done,
     /* 276788 */   // Label 4521: @276788
     /* 276788 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(276882), // Rule ID 1232 //
     /* 276793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 276807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 276810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276813 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276816 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 276823 */     // MIs[0] cbsz
     /* 276823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276826 */     // MIs[0] blgp
     /* 276826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276829 */     // MIs[0] src0_modifiers
     /* 276829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276837 */     // MIs[0] src1_modifiers
     /* 276837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 276849 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
     /* 276852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276854 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276856 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276858 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276860 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276862 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276864 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276866 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276880 */     GIR_RootConstrainSelectedInstOperands,
     /* 276881 */     // GIR_Coverage, 1232,
     /* 276881 */     GIR_EraseRootFromParent_Done,
     /* 276882 */   // Label 4522: @276882
     /* 276882 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(276976), // Rule ID 1233 //
     /* 276887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 276901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 276904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 276907 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 276910 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 276913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 276917 */     // MIs[0] cbsz
     /* 276917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276920 */     // MIs[0] blgp
     /* 276920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 276923 */     // MIs[0] src0_modifiers
     /* 276923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 276926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276931 */     // MIs[0] src1_modifiers
     /* 276931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 276934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 276939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 276943 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 276943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
     /* 276946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 276948 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 276950 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 276952 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 276954 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 276956 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 276958 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 276960 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 276962 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 276968 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 276974 */     GIR_RootConstrainSelectedInstOperands,
     /* 276975 */     // GIR_Coverage, 1233,
     /* 276975 */     GIR_EraseRootFromParent_Done,
     /* 276976 */   // Label 4523: @276976
     /* 276976 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(277070), // Rule ID 1234 //
     /* 276981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 276984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 276989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 276992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 276995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 276998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277001 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277004 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 277011 */     // MIs[0] cbsz
     /* 277011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277014 */     // MIs[0] blgp
     /* 277014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277017 */     // MIs[0] src0_modifiers
     /* 277017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277025 */     // MIs[0] src1_modifiers
     /* 277025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 277037 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
     /* 277040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277042 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277044 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277046 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277048 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277050 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277052 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277054 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277068 */     GIR_RootConstrainSelectedInstOperands,
     /* 277069 */     // GIR_Coverage, 1234,
     /* 277069 */     GIR_EraseRootFromParent_Done,
     /* 277070 */   // Label 4524: @277070
     /* 277070 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(277164), // Rule ID 1235 //
     /* 277075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 277089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 277092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277095 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277098 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 277105 */     // MIs[0] cbsz
     /* 277105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277108 */     // MIs[0] blgp
     /* 277108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277111 */     // MIs[0] src0_modifiers
     /* 277111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277119 */     // MIs[0] src1_modifiers
     /* 277119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 277131 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
     /* 277134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277136 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277138 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277140 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277142 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277144 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277146 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277148 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277162 */     GIR_RootConstrainSelectedInstOperands,
     /* 277163 */     // GIR_Coverage, 1235,
     /* 277163 */     GIR_EraseRootFromParent_Done,
     /* 277164 */   // Label 4525: @277164
     /* 277164 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(277258), // Rule ID 1236 //
     /* 277169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 277186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277189 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277192 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 277199 */     // MIs[0] cbsz
     /* 277199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277202 */     // MIs[0] blgp
     /* 277202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277205 */     // MIs[0] src0_modifiers
     /* 277205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277213 */     // MIs[0] src1_modifiers
     /* 277213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 277225 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
     /* 277228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277230 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277232 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277234 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277236 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277238 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277240 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277242 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277256 */     GIR_RootConstrainSelectedInstOperands,
     /* 277257 */     // GIR_Coverage, 1236,
     /* 277257 */     GIR_EraseRootFromParent_Done,
     /* 277258 */   // Label 4526: @277258
     /* 277258 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(277352), // Rule ID 1237 //
     /* 277263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 277280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277283 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277286 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 277293 */     // MIs[0] cbsz
     /* 277293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277296 */     // MIs[0] blgp
     /* 277296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277299 */     // MIs[0] src0_modifiers
     /* 277299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277307 */     // MIs[0] src1_modifiers
     /* 277307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 277319 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
     /* 277322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277326 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277328 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277330 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277332 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277334 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277336 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277350 */     GIR_RootConstrainSelectedInstOperands,
     /* 277351 */     // GIR_Coverage, 1237,
     /* 277351 */     GIR_EraseRootFromParent_Done,
     /* 277352 */   // Label 4527: @277352
     /* 277352 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(277446), // Rule ID 1238 //
     /* 277357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 277371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 277374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277377 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277380 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 277387 */     // MIs[0] cbsz
     /* 277387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277390 */     // MIs[0] blgp
     /* 277390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277393 */     // MIs[0] src0_modifiers
     /* 277393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277401 */     // MIs[0] src1_modifiers
     /* 277401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 277413 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
     /* 277416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277420 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277422 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277424 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277426 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277428 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277430 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277444 */     GIR_RootConstrainSelectedInstOperands,
     /* 277445 */     // GIR_Coverage, 1238,
     /* 277445 */     GIR_EraseRootFromParent_Done,
     /* 277446 */   // Label 4528: @277446
     /* 277446 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(277540), // Rule ID 1239 //
     /* 277451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
     /* 277465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 277468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277471 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277474 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 277481 */     // MIs[0] cbsz
     /* 277481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277484 */     // MIs[0] blgp
     /* 277484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277487 */     // MIs[0] src0_modifiers
     /* 277487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277495 */     // MIs[0] src1_modifiers
     /* 277495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277503 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 277507 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
     /* 277510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277512 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277514 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277516 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277518 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277520 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277522 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277524 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277538 */     GIR_RootConstrainSelectedInstOperands,
     /* 277539 */     // GIR_Coverage, 1239,
     /* 277539 */     GIR_EraseRootFromParent_Done,
     /* 277540 */   // Label 4529: @277540
     /* 277540 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(277634), // Rule ID 1240 //
     /* 277545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 277562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277565 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277568 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 277575 */     // MIs[0] cbsz
     /* 277575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277578 */     // MIs[0] blgp
     /* 277578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277581 */     // MIs[0] src0_modifiers
     /* 277581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277589 */     // MIs[0] src1_modifiers
     /* 277589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 277601 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
     /* 277604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277610 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277612 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277614 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277616 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277618 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277632 */     GIR_RootConstrainSelectedInstOperands,
     /* 277633 */     // GIR_Coverage, 1240,
     /* 277633 */     GIR_EraseRootFromParent_Done,
     /* 277634 */   // Label 4530: @277634
     /* 277634 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(277728), // Rule ID 1241 //
     /* 277639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
     /* 277656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277659 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277662 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 277669 */     // MIs[0] cbsz
     /* 277669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277672 */     // MIs[0] blgp
     /* 277672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277675 */     // MIs[0] src0_modifiers
     /* 277675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277683 */     // MIs[0] src1_modifiers
     /* 277683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 277695 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
     /* 277698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277700 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277702 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277704 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277706 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277708 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277710 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277712 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277720 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277726 */     GIR_RootConstrainSelectedInstOperands,
     /* 277727 */     // GIR_Coverage, 1241,
     /* 277727 */     GIR_EraseRootFromParent_Done,
     /* 277728 */   // Label 4531: @277728
     /* 277728 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(277822), // Rule ID 1242 //
     /* 277733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 277750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277753 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277756 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
     /* 277763 */     // MIs[0] cbsz
     /* 277763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277766 */     // MIs[0] blgp
     /* 277766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277769 */     // MIs[0] src0_modifiers
     /* 277769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277777 */     // MIs[0] src1_modifiers
     /* 277777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23474),
     /* 277789 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23474>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
     /* 277792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277794 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277796 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277798 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277800 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277802 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277804 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277806 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277820 */     GIR_RootConstrainSelectedInstOperands,
     /* 277821 */     // GIR_Coverage, 1242,
     /* 277821 */     GIR_EraseRootFromParent_Done,
     /* 277822 */   // Label 4532: @277822
     /* 277822 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(277916), // Rule ID 1243 //
     /* 277827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 277830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
     /* 277835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 277838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 277844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
     /* 277847 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /* 277850 */     GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
     /* 277853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
     /* 277857 */     // MIs[0] cbsz
     /* 277857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277860 */     // MIs[0] blgp
     /* 277860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 277863 */     // MIs[0] src0_modifiers
     /* 277863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 277866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277871 */     // MIs[0] src1_modifiers
     /* 277871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 277874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
     /* 277879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_23476),
     /* 277883 */     // (intrinsic_wo_chain:{ *:[v16f32] } 3169:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src0_modifiers, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$src1_modifiers, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_23476>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src0_modifiers), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$src1_modifiers))
     /* 277883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
     /* 277886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 277888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 277890 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 277892 */     GIR_RootToRootCopy, /*OpIdx*/4, // src2
     /* 277894 */     GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
     /* 277896 */     GIR_RootToRootCopy, /*OpIdx*/6, // blgp
     /* 277898 */     GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
     /* 277900 */     GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
     /* 277902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src0_modifiers
     /* 277908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // src1_modifiers
     /* 277914 */     GIR_RootConstrainSelectedInstOperands,
     /* 277915 */     // GIR_Coverage, 1243,
     /* 277915 */     GIR_EraseRootFromParent_Done,
     /* 277916 */   // Label 4533: @277916
     /* 277916 */   GIM_Reject,
     /* 277917 */ // Label 4461: @277917
     /* 277917 */ GIM_Reject,
     /* 277918 */ // Label 39: @277918
     /* 277918 */ GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(277994),
     /* 277923 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 277926 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(277941), // Rule ID 181 //
     /* 277931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier),
     /* 277936 */     // (intrinsic_void 3250:{ *:[iPTR] })  =>  (S_BARRIER)
     /* 277936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER),
     /* 277939 */     GIR_RootConstrainSelectedInstOperands,
     /* 277940 */     // GIR_Coverage, 181,
     /* 277940 */     GIR_EraseRootFromParent_Done,
     /* 277941 */   // Label 4535: @277941
     /* 277941 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(277956), // Rule ID 1345 //
     /* 277946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wave_barrier),
     /* 277951 */     // (intrinsic_void 3409:{ *:[iPTR] })  =>  (WAVE_BARRIER)
     /* 277951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_BARRIER),
     /* 277954 */     GIR_RootConstrainSelectedInstOperands,
     /* 277955 */     // GIR_Coverage, 1345,
     /* 277955 */     GIR_EraseRootFromParent_Done,
     /* 277956 */   // Label 4536: @277956
     /* 277956 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(277975), // Rule ID 1353 //
     /* 277961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_unreachable),
     /* 277966 */     // (intrinsic_void 3407:{ *:[iPTR] })  =>  (SI_MASKED_UNREACHABLE)
     /* 277966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_MASKED_UNREACHABLE),
     /* 277969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277973 */     GIR_RootConstrainSelectedInstOperands,
     /* 277974 */     // GIR_Coverage, 1353,
     /* 277974 */     GIR_EraseRootFromParent_Done,
     /* 277975 */   // Label 4537: @277975
     /* 277975 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(277993), // Rule ID 1867 //
     /* 277980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_endpgm),
     /* 277985 */     // (intrinsic_void 2296:{ *:[iPTR] })  =>  (S_ENDPGM 0:{ *:[i16] })
     /* 277985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ENDPGM),
     /* 277988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277991 */     GIR_RootConstrainSelectedInstOperands,
     /* 277992 */     // GIR_Coverage, 1867,
     /* 277992 */     GIR_EraseRootFromParent_Done,
     /* 277993 */   // Label 4538: @277993
     /* 277993 */   GIM_Reject,
     /* 277994 */ // Label 4534: @277994
     /* 277994 */ GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(278133),
     /* 277999 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 278002 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(278022), // Rule ID 41 //
     /* 278007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_signal),
     /* 278012 */     // MIs[0] src0
     /* 278012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278015 */     // (intrinsic_void 3251:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_BARRIER_SIGNAL_IMM (timm:{ *:[i32] }):$src0)
     /* 278015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_SIGNAL_IMM),
     /* 278018 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 278020 */     GIR_RootConstrainSelectedInstOperands,
     /* 278021 */     // GIR_Coverage, 41,
     /* 278021 */     GIR_EraseRootFromParent_Done,
     /* 278022 */   // Label 4540: @278022
     /* 278022 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(278042), // Rule ID 182 //
     /* 278027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_wait),
     /* 278032 */     // MIs[0] simm16
     /* 278032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278035 */     // (intrinsic_void 3254:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_BARRIER_WAIT (timm:{ *:[i16] }):$simm16)
     /* 278035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_WAIT),
     /* 278038 */     GIR_RootToRootCopy, /*OpIdx*/1, // simm16
     /* 278040 */     GIR_RootConstrainSelectedInstOperands,
     /* 278041 */     // GIR_Coverage, 182,
     /* 278041 */     GIR_EraseRootFromParent_Done,
     /* 278042 */   // Label 4541: @278042
     /* 278042 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(278062), // Rule ID 1346 //
     /* 278047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_barrier),
     /* 278052 */     // MIs[0] mask
     /* 278052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278055 */     // (intrinsic_void 3298:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (SCHED_BARRIER (timm:{ *:[i32] }):$mask)
     /* 278055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_BARRIER),
     /* 278058 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 278060 */     GIR_RootConstrainSelectedInstOperands,
     /* 278061 */     // GIR_Coverage, 1346,
     /* 278061 */     GIR_EraseRootFromParent_Done,
     /* 278062 */   // Label 4542: @278062
     /* 278062 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(278082), // Rule ID 1348 //
     /* 278067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_iglp_opt),
     /* 278072 */     // MIs[0] mask
     /* 278072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278075 */     // (intrinsic_void 2328:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (IGLP_OPT (timm:{ *:[i32] }):$mask)
     /* 278075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::IGLP_OPT),
     /* 278078 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 278080 */     GIR_RootConstrainSelectedInstOperands,
     /* 278081 */     // GIR_Coverage, 1348,
     /* 278081 */     GIR_EraseRootFromParent_Done,
     /* 278082 */   // Label 4543: @278082
     /* 278082 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(278105), // Rule ID 1354 //
     /* 278087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec),
     /* 278092 */     // MIs[0] src
     /* 278092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278095 */     // (intrinsic_void 3092:{ *:[iPTR] }, (timm:{ *:[i64] }):$src)  =>  (SI_INIT_EXEC (timm:{ *:[i64] }):$src)
     /* 278095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC),
     /* 278098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 278100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 278103 */     GIR_RootConstrainSelectedInstOperands,
     /* 278104 */     // GIR_Coverage, 1354,
     /* 278104 */     GIR_EraseRootFromParent_Done,
     /* 278105 */   // Label 4544: @278105
     /* 278105 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(278132), // Rule ID 1356 //
     /* 278110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_init_whole_wave),
     /* 278115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 278118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 278122 */     // (intrinsic_w_chain:{ *:[i1] } 3094:{ *:[iPTR] })  =>  (SI_INIT_WHOLE_WAVE:{ *:[i1] })
     /* 278122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_WHOLE_WAVE),
     /* 278125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 278130 */     GIR_RootConstrainSelectedInstOperands,
     /* 278131 */     // GIR_Coverage, 1356,
     /* 278131 */     GIR_EraseRootFromParent_Done,
     /* 278132 */   // Label 4545: @278132
     /* 278132 */   GIM_Reject,
     /* 278133 */ // Label 4539: @278133
     /* 278133 */ GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(279135),
     /* 278138 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 278141 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(278196), // Rule ID 8467 //
     /* 278146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 278149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr4_b64),
     /* 278154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 278157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 278172 */     // (intrinsic_w_chain:{ *:[v2i32] } 2289:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B4:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 278172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B4),
     /* 278175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 278182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278194 */     GIR_RootConstrainSelectedInstOperands,
     /* 278195 */     // GIR_Coverage, 8467,
     /* 278195 */     GIR_EraseRootFromParent_Done,
     /* 278196 */   // Label 4547: @278196
     /* 278196 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(278251), // Rule ID 8468 //
     /* 278201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 278204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr8_b64),
     /* 278209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 278212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 278227 */     // (intrinsic_w_chain:{ *:[v2i32] } 2291:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B8:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 278227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B8),
     /* 278230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 278237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278249 */     GIR_RootConstrainSelectedInstOperands,
     /* 278250 */     // GIR_Coverage, 8468,
     /* 278250 */     GIR_EraseRootFromParent_Done,
     /* 278251 */   // Label 4548: @278251
     /* 278251 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(278306), // Rule ID 8469 //
     /* 278256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 278259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr6_b96),
     /* 278264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v3s32,
     /* 278267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 278271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 278282 */     // (intrinsic_w_chain:{ *:[v3i32] } 2290:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B96_TR_B6:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 278282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_TR_B6),
     /* 278285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 278292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278304 */     GIR_RootConstrainSelectedInstOperands,
     /* 278305 */     // GIR_Coverage, 8469,
     /* 278305 */     GIR_EraseRootFromParent_Done,
     /* 278306 */   // Label 4549: @278306
     /* 278306 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(278361), // Rule ID 8470 //
     /* 278311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 278314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
     /* 278319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 278322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 278337 */     // (intrinsic_w_chain:{ *:[v4i16] } 2288:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 278337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
     /* 278340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 278347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278359 */     GIR_RootConstrainSelectedInstOperands,
     /* 278360 */     // GIR_Coverage, 8470,
     /* 278360 */     GIR_EraseRootFromParent_Done,
     /* 278361 */   // Label 4550: @278361
     /* 278361 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(278416), // Rule ID 8471 //
     /* 278366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
     /* 278369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
     /* 278374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 278377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
     /* 278392 */     // (intrinsic_w_chain:{ *:[v4f16] } 2288:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
     /* 278392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
     /* 278395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
     /* 278402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278414 */     GIR_RootConstrainSelectedInstOperands,
     /* 278415 */     // GIR_Coverage, 8471,
     /* 278415 */     GIR_EraseRootFromParent_Done,
     /* 278416 */   // Label 4551: @278416
     /* 278416 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(278476), // Rule ID 4128 //
     /* 278421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 278424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 278429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 278432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 278447 */     // (intrinsic_w_chain:{ *:[v2i32] } 2323:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 278447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32_SADDR),
     /* 278450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 278457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 278462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 278467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278474 */     GIR_RootConstrainSelectedInstOperands,
     /* 278475 */     // GIR_Coverage, 4128,
     /* 278475 */     GIR_EraseRootFromParent_Done,
     /* 278476 */   // Label 4552: @278476
     /* 278476 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(278536), // Rule ID 4130 //
     /* 278481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 278484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 278489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 278492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 278496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 278507 */     // (intrinsic_w_chain:{ *:[v8i16] } 2322:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 278507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
     /* 278510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 278517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 278522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 278527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278534 */     GIR_RootConstrainSelectedInstOperands,
     /* 278535 */     // GIR_Coverage, 4130,
     /* 278535 */     GIR_EraseRootFromParent_Done,
     /* 278536 */   // Label 4553: @278536
     /* 278536 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(278596), // Rule ID 4132 //
     /* 278541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 278544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 278549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 278552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 278556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 278567 */     // (intrinsic_w_chain:{ *:[v8f16] } 2322:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 278567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
     /* 278570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 278577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 278582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 278587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278594 */     GIR_RootConstrainSelectedInstOperands,
     /* 278595 */     // GIR_Coverage, 4132,
     /* 278595 */     GIR_EraseRootFromParent_Done,
     /* 278596 */   // Label 4554: @278596
     /* 278596 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(278656), // Rule ID 4134 //
     /* 278601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 278604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 278609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 278612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 278616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 278627 */     // (intrinsic_w_chain:{ *:[i32] } 2323:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 278627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64_SADDR),
     /* 278630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 278637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 278642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 278647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278654 */     GIR_RootConstrainSelectedInstOperands,
     /* 278655 */     // GIR_Coverage, 4134,
     /* 278655 */     GIR_EraseRootFromParent_Done,
     /* 278656 */   // Label 4555: @278656
     /* 278656 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(278716), // Rule ID 4136 //
     /* 278661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 278664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 278669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 278672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 278687 */     // (intrinsic_w_chain:{ *:[v4i16] } 2322:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 278687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
     /* 278690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 278697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 278702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 278707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278714 */     GIR_RootConstrainSelectedInstOperands,
     /* 278715 */     // GIR_Coverage, 4136,
     /* 278715 */     GIR_EraseRootFromParent_Done,
     /* 278716 */   // Label 4556: @278716
     /* 278716 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(278776), // Rule ID 4138 //
     /* 278721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 278724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 278729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 278732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 278747 */     // (intrinsic_w_chain:{ *:[v4f16] } 2322:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
     /* 278747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
     /* 278750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 278757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 278762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 278767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278774 */     GIR_RootConstrainSelectedInstOperands,
     /* 278775 */     // GIR_Coverage, 4138,
     /* 278775 */     GIR_EraseRootFromParent_Done,
     /* 278776 */   // Label 4557: @278776
     /* 278776 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(278831), // Rule ID 4127 //
     /* 278781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 278784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 278789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 278792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 278796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 278807 */     // (intrinsic_w_chain:{ *:[v2i32] } 2323:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 278807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32),
     /* 278810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 278817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278829 */     GIR_RootConstrainSelectedInstOperands,
     /* 278830 */     // GIR_Coverage, 4127,
     /* 278830 */     GIR_EraseRootFromParent_Done,
     /* 278831 */   // Label 4558: @278831
     /* 278831 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(278886), // Rule ID 4129 //
     /* 278836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 278839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 278844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 278847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 278851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 278862 */     // (intrinsic_w_chain:{ *:[v8i16] } 2322:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 278862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
     /* 278865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 278872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278884 */     GIR_RootConstrainSelectedInstOperands,
     /* 278885 */     // GIR_Coverage, 4129,
     /* 278885 */     GIR_EraseRootFromParent_Done,
     /* 278886 */   // Label 4559: @278886
     /* 278886 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(278941), // Rule ID 4131 //
     /* 278891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
     /* 278894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 278899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 278902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 278906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 278917 */     // (intrinsic_w_chain:{ *:[v8f16] } 2322:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 278917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
     /* 278920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 278927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278939 */     GIR_RootConstrainSelectedInstOperands,
     /* 278940 */     // GIR_Coverage, 4131,
     /* 278940 */     GIR_EraseRootFromParent_Done,
     /* 278941 */   // Label 4560: @278941
     /* 278941 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(278996), // Rule ID 4133 //
     /* 278946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 278949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
     /* 278954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 278957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 278961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 278965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 278972 */     // (intrinsic_w_chain:{ *:[i32] } 2323:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 278972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64),
     /* 278975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 278977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 278982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 278987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278994 */     GIR_RootConstrainSelectedInstOperands,
     /* 278995 */     // GIR_Coverage, 4133,
     /* 278995 */     GIR_EraseRootFromParent_Done,
     /* 278996 */   // Label 4561: @278996
     /* 278996 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(279051), // Rule ID 4135 //
     /* 279001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 279004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 279009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 279012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 279016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 279020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 279027 */     // (intrinsic_w_chain:{ *:[v4i16] } 2322:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 279027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
     /* 279030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 279032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 279037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 279042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279049 */     GIR_RootConstrainSelectedInstOperands,
     /* 279050 */     // GIR_Coverage, 4135,
     /* 279050 */     GIR_EraseRootFromParent_Done,
     /* 279051 */   // Label 4562: @279051
     /* 279051 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(279106), // Rule ID 4137 //
     /* 279056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
     /* 279059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
     /* 279064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 279067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 279071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 279075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 279082 */     // (intrinsic_w_chain:{ *:[v4f16] } 2322:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
     /* 279082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
     /* 279085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 279087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 279092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 279097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279104 */     GIR_RootConstrainSelectedInstOperands,
     /* 279105 */     // GIR_Coverage, 4137,
     /* 279105 */     GIR_EraseRootFromParent_Done,
     /* 279106 */   // Label 4563: @279106
     /* 279106 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(279134), // Rule ID 1355 //
     /* 279111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec_from_input),
     /* 279116 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279119 */     // MIs[0] shift
     /* 279119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 279122 */     // (intrinsic_void 3093:{ *:[iPTR] }, i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)  =>  (SI_INIT_EXEC_FROM_INPUT i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)
     /* 279122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC_FROM_INPUT),
     /* 279125 */     GIR_RootToRootCopy, /*OpIdx*/1, // input
     /* 279127 */     GIR_RootToRootCopy, /*OpIdx*/2, // shift
     /* 279129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
     /* 279132 */     GIR_RootConstrainSelectedInstOperands,
     /* 279133 */     // GIR_Coverage, 1355,
     /* 279133 */     GIR_EraseRootFromParent_Done,
     /* 279134 */   // Label 4564: @279134
     /* 279134 */   GIM_Reject,
     /* 279135 */ // Label 4546: @279135
     /* 279135 */ GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(279168), // Rule ID 1347 //
     /* 279140 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 279143 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_group_barrier),
     /* 279148 */   // MIs[0] mask
     /* 279148 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 279151 */   // MIs[0] size
     /* 279151 */   GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 279154 */   // MIs[0] syncid
     /* 279154 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 279157 */   // (intrinsic_void 3299:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)  =>  (SCHED_GROUP_BARRIER (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)
     /* 279157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_GROUP_BARRIER),
     /* 279160 */   GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 279162 */   GIR_RootToRootCopy, /*OpIdx*/2, // size
     /* 279164 */   GIR_RootToRootCopy, /*OpIdx*/3, // syncid
     /* 279166 */   GIR_RootConstrainSelectedInstOperands,
     /* 279167 */   // GIR_Coverage, 1347,
     /* 279167 */   GIR_EraseRootFromParent_Done,
     /* 279168 */ // Label 4565: @279168
     /* 279168 */ GIM_Reject,
     /* 279169 */ // Label 40: @279169
     /* 279169 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4569*/ GIMT_Encode4(279731),
     /* 279180 */ /*GILLT_s16*//*Label 4566*/ GIMT_Encode4(279192),
     /* 279184 */ /*GILLT_s32*//*Label 4567*/ GIMT_Encode4(279229),
     /* 279188 */ /*GILLT_s64*//*Label 4568*/ GIMT_Encode4(279328),
     /* 279192 */ // Label 4566: @279192
     /* 279192 */ GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(279228), // Rule ID 2559 //
     /* 279197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 279200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 279203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279207 */   // (anyext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 279207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 279210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 279212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 279224 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 279226 */   GIR_RootConstrainSelectedInstOperands,
     /* 279227 */   // GIR_Coverage, 2559,
     /* 279227 */   GIR_EraseRootFromParent_Done,
     /* 279228 */ // Label 4570: @279228
     /* 279228 */ GIM_Reject,
     /* 279229 */ // Label 4567: @279229
     /* 279229 */ GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(279294), // Rule ID 2443 //
     /* 279234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 279237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279244 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19238),
     /* 279248 */   // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_19238>>  =>  (REG_SEQUENCE:{ *:[i32] } VGPR_32:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] })
     /* 279248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 279269 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /* 279272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279275 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /* 279278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 279288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 279293 */   // GIR_Coverage, 2443,
     /* 279293 */   GIR_EraseRootFromParent_Done,
     /* 279294 */ // Label 4571: @279294
     /* 279294 */ GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(279327), // Rule ID 7449 //
     /* 279299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 279302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279306 */   // (anyext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 279306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 279309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 279311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 279323 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 279325 */   GIR_RootConstrainSelectedInstOperands,
     /* 279326 */   // GIR_Coverage, 7449,
     /* 279326 */   GIR_EraseRootFromParent_Done,
     /* 279327 */ // Label 4572: @279327
     /* 279327 */ GIM_Reject,
     /* 279328 */ // Label 4568: @279328
     /* 279328 */ GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(279411), // Rule ID 2435 //
     /* 279333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 279336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279343 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279355 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 279363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279372 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 279376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279386 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279392 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279410 */   // GIR_Coverage, 2435,
     /* 279410 */   GIR_EraseRootFromParent_Done,
     /* 279411 */ // Label 4573: @279411
     /* 279411 */ GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(279494), // Rule ID 2439 //
     /* 279416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 279419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279426 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 279429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 279433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279438 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 279446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279455 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 279459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279469 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279472 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279475 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279493 */   // GIR_Coverage, 2439,
     /* 279493 */   GIR_EraseRootFromParent_Done,
     /* 279494 */ // Label 4574: @279494
     /* 279494 */ GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(279580), // Rule ID 2444 //
     /* 279499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 279502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279509 */   // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279509 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 279512 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279516 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279542 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 279544 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /* 279547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279550 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /* 279553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279556 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279564 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 279569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 279574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/5, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279579 */   // GIR_Coverage, 2444,
     /* 279579 */   GIR_EraseRootFromParent_Done,
     /* 279580 */ // Label 4575: @279580
     /* 279580 */ GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(279638), // Rule ID 7529 //
     /* 279585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 279592 */   // (anyext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 279595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 279613 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279619 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 279627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 279632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 279637 */   // GIR_Coverage, 7529,
     /* 279637 */   GIR_EraseRootFromParent_Done,
     /* 279638 */ // Label 4576: @279638
     /* 279638 */ GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(279730), // Rule ID 7531 //
     /* 279643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 279646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279650 */   // (anyext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 279650 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 279653 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 279657 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279662 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 279665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 279674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279679 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 279682 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 279685 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 279688 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279691 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 279695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 279700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279705 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 279708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 279711 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 279714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 279719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279724 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 279729 */   // GIR_Coverage, 7531,
     /* 279729 */   GIR_EraseRootFromParent_Done,
     /* 279730 */ // Label 4577: @279730
     /* 279730 */ GIM_Reject,
     /* 279731 */ // Label 4569: @279731
     /* 279731 */ GIM_Reject,
     /* 279732 */ // Label 41: @279732
     /* 279732 */ GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(279971),
     /* 279737 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 279740 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4581*/ GIMT_Encode4(279855),
     /* 279751 */   /*GILLT_s16*//*Label 4579*/ GIMT_Encode4(279759),
     /* 279755 */   /*GILLT_s32*//*Label 4580*/ GIMT_Encode4(279807),
     /* 279759 */   // Label 4579: @279759
     /* 279759 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(279806), // Rule ID 7581 //
     /* 279764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 279768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34924),
     /* 279772 */     // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34924>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
     /* 279772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 279779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279784 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 279791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 279796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 279798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 279804 */     GIR_RootConstrainSelectedInstOperands,
     /* 279805 */     // GIR_Coverage, 7581,
     /* 279805 */     GIR_EraseRootFromParent_Done,
     /* 279806 */   // Label 4582: @279806
     /* 279806 */   GIM_Reject,
     /* 279807 */   // Label 4580: @279807
     /* 279807 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(279854), // Rule ID 7580 //
     /* 279812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 279816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34924),
     /* 279820 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34924>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
     /* 279820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 279823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 279827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 279839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 279844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 279846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 279852 */     GIR_RootConstrainSelectedInstOperands,
     /* 279853 */     // GIR_Coverage, 7580,
     /* 279853 */     GIR_EraseRootFromParent_Done,
     /* 279854 */   // Label 4583: @279854
     /* 279854 */   GIM_Reject,
     /* 279855 */   // Label 4581: @279855
     /* 279855 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4586*/ GIMT_Encode4(279970),
     /* 279866 */   /*GILLT_s16*//*Label 4584*/ GIMT_Encode4(279874),
     /* 279870 */   /*GILLT_s32*//*Label 4585*/ GIMT_Encode4(279922),
     /* 279874 */   // Label 4584: @279874
     /* 279874 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(279921), // Rule ID 7578 //
     /* 279879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34920),
     /* 279883 */     // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34920>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
     /* 279883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 279886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 279890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 279902 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
     /* 279905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
     /* 279910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 279916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 279919 */     GIR_RootConstrainSelectedInstOperands,
     /* 279920 */     // GIR_Coverage, 7578,
     /* 279920 */     GIR_EraseRootFromParent_Done,
     /* 279921 */   // Label 4587: @279921
     /* 279921 */   GIM_Reject,
     /* 279922 */   // Label 4585: @279922
     /* 279922 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(279969), // Rule ID 7577 //
     /* 279927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34920),
     /* 279931 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34920>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
     /* 279931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 279934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 279938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 279950 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
     /* 279953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
     /* 279958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 279964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 279967 */     GIR_RootConstrainSelectedInstOperands,
     /* 279968 */     // GIR_Coverage, 7577,
     /* 279968 */     GIR_EraseRootFromParent_Done,
     /* 279969 */   // Label 4588: @279969
     /* 279969 */   GIM_Reject,
     /* 279970 */   // Label 4586: @279970
     /* 279970 */   GIM_Reject,
     /* 279971 */ // Label 4578: @279971
     /* 279971 */ GIM_Reject,
     /* 279972 */ // Label 42: @279972
     /* 279972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(11), /*)*//*default:*//*Label 4600*/ GIMT_Encode4(280697),
     /* 279983 */ /*GILLT_p0s64*//*Label 4589*/ GIMT_Encode4(280027),
     /* 279987 */ /*GILLT_p1s64*//*Label 4590*/ GIMT_Encode4(280070),
     /* 279991 */ /*GILLT_p2s32*//*Label 4591*/ GIMT_Encode4(280113),
     /* 279995 */ /*GILLT_p3s32*//*Label 4592*/ GIMT_Encode4(280156),
     /* 279999 */ /*GILLT_p4s64*//*Label 4593*/ GIMT_Encode4(280199),
     /* 280003 */ /*GILLT_p5s32*//*Label 4594*/ GIMT_Encode4(280242),
     /* 280007 */ /*GILLT_p6s32*//*Label 4595*/ GIMT_Encode4(280285),
     /* 280011 */ /*GILLT_s1*//*Label 4596*/ GIMT_Encode4(280328),
     /* 280015 */ /*GILLT_s16*//*Label 4597*/ GIMT_Encode4(280373),
     /* 280019 */ /*GILLT_s32*//*Label 4598*/ GIMT_Encode4(280477),
     /* 280023 */ /*GILLT_s64*//*Label 4599*/ GIMT_Encode4(280520),
     /* 280027 */ // Label 4589: @280027
     /* 280027 */ GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(280050), // Rule ID 7434 //
     /* 280032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280036 */   // MIs[0] Operand 1
     /* 280036 */   // No operand predicates
     /* 280036 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34749),
     /* 280040 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34749>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 280043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280045 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280048 */   GIR_RootConstrainSelectedInstOperands,
     /* 280049 */   // GIR_Coverage, 7434,
     /* 280049 */   GIR_EraseRootFromParent_Done,
     /* 280050 */ // Label 4601: @280050
     /* 280050 */ GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(280069), // Rule ID 7436 //
     /* 280055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280059 */   // MIs[0] Operand 1
     /* 280059 */   // No operand predicates
     /* 280059 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 280062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280064 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280067 */   GIR_RootConstrainSelectedInstOperands,
     /* 280068 */   // GIR_Coverage, 7436,
     /* 280068 */   GIR_EraseRootFromParent_Done,
     /* 280069 */ // Label 4602: @280069
     /* 280069 */ GIM_Reject,
     /* 280070 */ // Label 4590: @280070
     /* 280070 */ GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(280093), // Rule ID 7431 //
     /* 280075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280079 */   // MIs[0] Operand 1
     /* 280079 */   // No operand predicates
     /* 280079 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34745),
     /* 280083 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34745>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 280086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280088 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280091 */   GIR_RootConstrainSelectedInstOperands,
     /* 280092 */   // GIR_Coverage, 7431,
     /* 280092 */   GIR_EraseRootFromParent_Done,
     /* 280093 */ // Label 4603: @280093
     /* 280093 */ GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(280112), // Rule ID 7433 //
     /* 280098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280102 */   // MIs[0] Operand 1
     /* 280102 */   // No operand predicates
     /* 280102 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 280105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280107 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280110 */   GIR_RootConstrainSelectedInstOperands,
     /* 280111 */   // GIR_Coverage, 7433,
     /* 280111 */   GIR_EraseRootFromParent_Done,
     /* 280112 */ // Label 4604: @280112
     /* 280112 */ GIM_Reject,
     /* 280113 */ // Label 4591: @280113
     /* 280113 */ GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(280136), // Rule ID 7402 //
     /* 280118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280122 */   // MIs[0] Operand 1
     /* 280122 */   // No operand predicates
     /* 280122 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34699),
     /* 280126 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34699>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280131 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280134 */   GIR_RootConstrainSelectedInstOperands,
     /* 280135 */   // GIR_Coverage, 7402,
     /* 280135 */   GIR_EraseRootFromParent_Done,
     /* 280136 */ // Label 4605: @280136
     /* 280136 */ GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(280155), // Rule ID 7403 //
     /* 280141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280145 */   // MIs[0] Operand 1
     /* 280145 */   // No operand predicates
     /* 280145 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280150 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280153 */   GIR_RootConstrainSelectedInstOperands,
     /* 280154 */   // GIR_Coverage, 7403,
     /* 280154 */   GIR_EraseRootFromParent_Done,
     /* 280155 */ // Label 4606: @280155
     /* 280155 */ GIM_Reject,
     /* 280156 */ // Label 4592: @280156
     /* 280156 */ GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(280179), // Rule ID 7404 //
     /* 280161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280165 */   // MIs[0] Operand 1
     /* 280165 */   // No operand predicates
     /* 280165 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34702),
     /* 280169 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34702>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280174 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280177 */   GIR_RootConstrainSelectedInstOperands,
     /* 280178 */   // GIR_Coverage, 7404,
     /* 280178 */   GIR_EraseRootFromParent_Done,
     /* 280179 */ // Label 4607: @280179
     /* 280179 */ GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(280198), // Rule ID 7405 //
     /* 280184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280188 */   // MIs[0] Operand 1
     /* 280188 */   // No operand predicates
     /* 280188 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280193 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280196 */   GIR_RootConstrainSelectedInstOperands,
     /* 280197 */   // GIR_Coverage, 7405,
     /* 280197 */   GIR_EraseRootFromParent_Done,
     /* 280198 */ // Label 4608: @280198
     /* 280198 */ GIM_Reject,
     /* 280199 */ // Label 4593: @280199
     /* 280199 */ GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(280222), // Rule ID 7437 //
     /* 280204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280208 */   // MIs[0] Operand 1
     /* 280208 */   // No operand predicates
     /* 280208 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34753),
     /* 280212 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34753>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 280215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280217 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280220 */   GIR_RootConstrainSelectedInstOperands,
     /* 280221 */   // GIR_Coverage, 7437,
     /* 280221 */   GIR_EraseRootFromParent_Done,
     /* 280222 */ // Label 4609: @280222
     /* 280222 */ GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(280241), // Rule ID 7439 //
     /* 280227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280231 */   // MIs[0] Operand 1
     /* 280231 */   // No operand predicates
     /* 280231 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 280234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280236 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280239 */   GIR_RootConstrainSelectedInstOperands,
     /* 280240 */   // GIR_Coverage, 7439,
     /* 280240 */   GIR_EraseRootFromParent_Done,
     /* 280241 */ // Label 4610: @280241
     /* 280241 */ GIM_Reject,
     /* 280242 */ // Label 4594: @280242
     /* 280242 */ GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(280265), // Rule ID 7406 //
     /* 280247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280251 */   // MIs[0] Operand 1
     /* 280251 */   // No operand predicates
     /* 280251 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34705),
     /* 280255 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34705>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280260 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280263 */   GIR_RootConstrainSelectedInstOperands,
     /* 280264 */   // GIR_Coverage, 7406,
     /* 280264 */   GIR_EraseRootFromParent_Done,
     /* 280265 */ // Label 4611: @280265
     /* 280265 */ GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(280284), // Rule ID 7407 //
     /* 280270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280274 */   // MIs[0] Operand 1
     /* 280274 */   // No operand predicates
     /* 280274 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280279 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280282 */   GIR_RootConstrainSelectedInstOperands,
     /* 280283 */   // GIR_Coverage, 7407,
     /* 280283 */   GIR_EraseRootFromParent_Done,
     /* 280284 */ // Label 4612: @280284
     /* 280284 */ GIM_Reject,
     /* 280285 */ // Label 4595: @280285
     /* 280285 */ GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(280308), // Rule ID 7408 //
     /* 280290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280294 */   // MIs[0] Operand 1
     /* 280294 */   // No operand predicates
     /* 280294 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34708),
     /* 280298 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34708>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280303 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280306 */   GIR_RootConstrainSelectedInstOperands,
     /* 280307 */   // GIR_Coverage, 7408,
     /* 280307 */   GIR_EraseRootFromParent_Done,
     /* 280308 */ // Label 4613: @280308
     /* 280308 */ GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(280327), // Rule ID 7409 //
     /* 280313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280317 */   // MIs[0] Operand 1
     /* 280317 */   // No operand predicates
     /* 280317 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280322 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280325 */   GIR_RootConstrainSelectedInstOperands,
     /* 280326 */   // GIR_Coverage, 7409,
     /* 280326 */   GIR_EraseRootFromParent_Done,
     /* 280327 */ // Label 4614: @280327
     /* 280327 */ GIM_Reject,
     /* 280328 */ // Label 4596: @280328
     /* 280328 */ GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(280350), // Rule ID 7443 //
     /* 280333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
     /* 280336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280340 */   // MIs[0] Operand 1
     /* 280340 */   // No operand predicates
     /* 280340 */   // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B64:{ *:[i1] } (imm:{ *:[i1] }):$imm)
     /* 280340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 280343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280345 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280348 */   GIR_RootConstrainSelectedInstOperands,
     /* 280349 */   // GIR_Coverage, 7443,
     /* 280349 */   GIR_EraseRootFromParent_Done,
     /* 280350 */ // Label 4615: @280350
     /* 280350 */ GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(280372), // Rule ID 7444 //
     /* 280355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
     /* 280358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280362 */   // MIs[0] Operand 1
     /* 280362 */   // No operand predicates
     /* 280362 */   // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B32:{ *:[i1] } (imm:{ *:[i1] }):$imm)
     /* 280362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280367 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280370 */   GIR_RootConstrainSelectedInstOperands,
     /* 280371 */   // GIR_Coverage, 7444,
     /* 280371 */   GIR_EraseRootFromParent_Done,
     /* 280372 */ // Label 4616: @280372
     /* 280372 */ GIM_Reject,
     /* 280373 */ // Label 4597: @280373
     /* 280373 */ GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(280399), // Rule ID 7414 //
     /* 280378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 280381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280385 */   // MIs[0] Operand 1
     /* 280385 */   // No operand predicates
     /* 280385 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34718),
     /* 280389 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34718>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 280389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280394 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280397 */   GIR_RootConstrainSelectedInstOperands,
     /* 280398 */   // GIR_Coverage, 7414,
     /* 280398 */   GIR_EraseRootFromParent_Done,
     /* 280399 */ // Label 4617: @280399
     /* 280399 */ GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(280425), // Rule ID 7416 //
     /* 280404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 280407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280411 */   // MIs[0] Operand 1
     /* 280411 */   // No operand predicates
     /* 280411 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34718),
     /* 280415 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34718>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 280415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280420 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280423 */   GIR_RootConstrainSelectedInstOperands,
     /* 280424 */   // GIR_Coverage, 7416,
     /* 280424 */   GIR_EraseRootFromParent_Done,
     /* 280425 */ // Label 4618: @280425
     /* 280425 */ GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(280457), // Rule ID 7418 //
     /* 280430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 280433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 280437 */   // MIs[0] Operand 1
     /* 280437 */   // No operand predicates
     /* 280437 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34718),
     /* 280441 */   // (imm:{ *:[i16] })<<P:Predicate_anonymous_34718>>:$imm  =>  (V_MOV_B16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, (imm:{ *:[i16] }):$imm, 0:{ *:[i32] })
     /* 280441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B16_t16_e64),
     /* 280444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280449 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280455 */   GIR_RootConstrainSelectedInstOperands,
     /* 280456 */   // GIR_Coverage, 7418,
     /* 280456 */   GIR_EraseRootFromParent_Done,
     /* 280457 */ // Label 4619: @280457
     /* 280457 */ GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(280476), // Rule ID 1870 //
     /* 280462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280466 */   // MIs[0] Operand 1
     /* 280466 */   // No operand predicates
     /* 280466 */   // (imm:{ *:[i16] }):$imm  =>  (S_MOV_B32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
     /* 280466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280471 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280474 */   GIR_RootConstrainSelectedInstOperands,
     /* 280475 */   // GIR_Coverage, 1870,
     /* 280475 */   GIR_EraseRootFromParent_Done,
     /* 280476 */ // Label 4620: @280476
     /* 280476 */ GIM_Reject,
     /* 280477 */ // Label 4598: @280477
     /* 280477 */ GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(280500), // Rule ID 7400 //
     /* 280482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280486 */   // MIs[0] Operand 1
     /* 280486 */   // No operand predicates
     /* 280486 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34698),
     /* 280490 */   // (imm:{ *:[i32] })<<P:Predicate_anonymous_34698>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280495 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280498 */   GIR_RootConstrainSelectedInstOperands,
     /* 280499 */   // GIR_Coverage, 7400,
     /* 280499 */   GIR_EraseRootFromParent_Done,
     /* 280500 */ // Label 4621: @280500
     /* 280500 */ GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(280519), // Rule ID 7401 //
     /* 280505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280509 */   // MIs[0] Operand 1
     /* 280509 */   // No operand predicates
     /* 280509 */   // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /* 280509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280514 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280517 */   GIR_RootConstrainSelectedInstOperands,
     /* 280518 */   // GIR_Coverage, 7401,
     /* 280518 */   GIR_EraseRootFromParent_Done,
     /* 280519 */ // Label 4622: @280519
     /* 280519 */ GIM_Reject,
     /* 280520 */ // Label 4599: @280520
     /* 280520 */ GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(280543), // Rule ID 7429 //
     /* 280525 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 280529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280533 */   // MIs[0] Operand 1
     /* 280533 */   // No operand predicates
     /* 280533 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 280533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 280536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280541 */   GIR_RootConstrainSelectedInstOperands,
     /* 280542 */   // GIR_Coverage, 7429,
     /* 280542 */   GIR_EraseRootFromParent_Done,
     /* 280543 */ // Label 4623: @280543
     /* 280543 */ GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(280566), // Rule ID 7432 //
     /* 280548 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 280552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280556 */   // MIs[0] Operand 1
     /* 280556 */   // No operand predicates
     /* 280556 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 280556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 280559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280561 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280564 */   GIR_RootConstrainSelectedInstOperands,
     /* 280565 */   // GIR_Coverage, 7432,
     /* 280565 */   GIR_EraseRootFromParent_Done,
     /* 280566 */ // Label 4624: @280566
     /* 280566 */ GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(280589), // Rule ID 7435 //
     /* 280571 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 280575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280579 */   // MIs[0] Operand 1
     /* 280579 */   // No operand predicates
     /* 280579 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 280579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 280582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280584 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280587 */   GIR_RootConstrainSelectedInstOperands,
     /* 280588 */   // GIR_Coverage, 7435,
     /* 280588 */   GIR_EraseRootFromParent_Done,
     /* 280589 */ // Label 4625: @280589
     /* 280589 */ GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(280612), // Rule ID 7438 //
     /* 280594 */   GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
     /* 280598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280602 */   // MIs[0] Operand 1
     /* 280602 */   // No operand predicates
     /* 280602 */   // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
     /* 280602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 280605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280607 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280610 */   GIR_RootConstrainSelectedInstOperands,
     /* 280611 */   // GIR_Coverage, 7438,
     /* 280611 */   GIR_EraseRootFromParent_Done,
     /* 280612 */ // Label 4626: @280612
     /* 280612 */ GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(280635), // Rule ID 7420 //
     /* 280617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280621 */   // MIs[0] Operand 1
     /* 280621 */   // No operand predicates
     /* 280621 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34730),
     /* 280625 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34730>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 280628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280630 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280633 */   GIR_RootConstrainSelectedInstOperands,
     /* 280634 */   // GIR_Coverage, 7420,
     /* 280634 */   GIR_EraseRootFromParent_Done,
     /* 280635 */ // Label 4627: @280635
     /* 280635 */ GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(280658), // Rule ID 7428 //
     /* 280640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280644 */   // MIs[0] Operand 1
     /* 280644 */   // No operand predicates
     /* 280644 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34730),
     /* 280648 */   // (imm:{ *:[i64] })<<P:Predicate_anonymous_34730>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 280651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280653 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280656 */   GIR_RootConstrainSelectedInstOperands,
     /* 280657 */   // GIR_Coverage, 7428,
     /* 280657 */   GIR_EraseRootFromParent_Done,
     /* 280658 */ // Label 4628: @280658
     /* 280658 */ GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(280677), // Rule ID 7422 //
     /* 280663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280667 */   // MIs[0] Operand 1
     /* 280667 */   // No operand predicates
     /* 280667 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 280670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280672 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280675 */   GIR_RootConstrainSelectedInstOperands,
     /* 280676 */   // GIR_Coverage, 7422,
     /* 280676 */   GIR_EraseRootFromParent_Done,
     /* 280677 */ // Label 4629: @280677
     /* 280677 */ GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(280696), // Rule ID 7430 //
     /* 280682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280686 */   // MIs[0] Operand 1
     /* 280686 */   // No operand predicates
     /* 280686 */   // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 280686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 280689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280691 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 280694 */   GIR_RootConstrainSelectedInstOperands,
     /* 280695 */   // GIR_Coverage, 7430,
     /* 280695 */   GIR_EraseRootFromParent_Done,
     /* 280696 */ // Label 4630: @280696
     /* 280696 */ GIM_Reject,
     /* 280697 */ // Label 4600: @280697
     /* 280697 */ GIM_Reject,
     /* 280698 */ // Label 43: @280698
     /* 280698 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4634*/ GIMT_Encode4(280979),
     /* 280709 */ /*GILLT_s16*//*Label 4631*/ GIMT_Encode4(280721),
     /* 280713 */ /*GILLT_s32*//*Label 4632*/ GIMT_Encode4(280793),
     /* 280717 */ /*GILLT_s64*//*Label 4633*/ GIMT_Encode4(280861),
     /* 280721 */ // Label 4631: @280721
     /* 280721 */ GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(280746), // Rule ID 7415 //
     /* 280726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280730 */   // MIs[0] Operand 1
     /* 280730 */   // No operand predicates
     /* 280730 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34720),
     /* 280734 */   // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_34720>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
     /* 280734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280739 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 280744 */   GIR_RootConstrainSelectedInstOperands,
     /* 280745 */   // GIR_Coverage, 7415,
     /* 280745 */   GIR_EraseRootFromParent_Done,
     /* 280746 */ // Label 4635: @280746
     /* 280746 */ GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(280771), // Rule ID 7417 //
     /* 280751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280755 */   // MIs[0] Operand 1
     /* 280755 */   // No operand predicates
     /* 280755 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34720),
     /* 280759 */   // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_34720>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
     /* 280759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280764 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 280769 */   GIR_RootConstrainSelectedInstOperands,
     /* 280770 */   // GIR_Coverage, 7417,
     /* 280770 */   GIR_EraseRootFromParent_Done,
     /* 280771 */ // Label 4636: @280771
     /* 280771 */ GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(280792), // Rule ID 7425 //
     /* 280776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280780 */   // MIs[0] Operand 1
     /* 280780 */   // No operand predicates
     /* 280780 */   // (fpimm:{ *:[f16] }):$imm  =>  (S_MOV_B32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[i32] } ?:{ *:[f16] }:$imm))
     /* 280780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280785 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 280790 */   GIR_RootConstrainSelectedInstOperands,
     /* 280791 */   // GIR_Coverage, 7425,
     /* 280791 */   GIR_EraseRootFromParent_Done,
     /* 280792 */ // Label 4637: @280792
     /* 280792 */ GIM_Reject,
     /* 280793 */ // Label 4632: @280793
     /* 280793 */ GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(280818), // Rule ID 7426 //
     /* 280798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 280802 */   // MIs[0] Operand 1
     /* 280802 */   // No operand predicates
     /* 280802 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34740),
     /* 280806 */   // (fpimm:{ *:[f32] })<<P:Predicate_anonymous_34740>>:$imm  =>  (V_MOV_B32_e32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 280806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 280809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280811 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 280816 */   GIR_RootConstrainSelectedInstOperands,
     /* 280817 */   // GIR_Coverage, 7426,
     /* 280817 */   GIR_EraseRootFromParent_Done,
     /* 280818 */ // Label 4638: @280818
     /* 280818 */ GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(280839), // Rule ID 7424 //
     /* 280823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280827 */   // MIs[0] Operand 1
     /* 280827 */   // No operand predicates
     /* 280827 */   // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 280827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280832 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 280837 */   GIR_RootConstrainSelectedInstOperands,
     /* 280838 */   // GIR_Coverage, 7424,
     /* 280838 */   GIR_EraseRootFromParent_Done,
     /* 280839 */ // Label 4639: @280839
     /* 280839 */ GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(280860), // Rule ID 7427 //
     /* 280844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 280848 */   // MIs[0] Operand 1
     /* 280848 */   // No operand predicates
     /* 280848 */   // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
     /* 280848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 280851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280853 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
     /* 280858 */   GIR_RootConstrainSelectedInstOperands,
     /* 280859 */   // GIR_Coverage, 7427,
     /* 280859 */   GIR_EraseRootFromParent_Done,
     /* 280860 */ // Label 4640: @280860
     /* 280860 */ GIM_Reject,
     /* 280861 */ // Label 4633: @280861
     /* 280861 */ GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(280886), // Rule ID 7441 //
     /* 280866 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_InlineImmFP64),
     /* 280870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280874 */   // MIs[0] Operand 1
     /* 280874 */   // No operand predicates
     /* 280874 */   // (fpimm:{ *:[f64] })<<P:Predicate_InlineImmFP64>>:$imm  =>  (S_MOV_B64:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } ?:{ *:[f64] }:$imm))
     /* 280874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
     /* 280877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280879 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 280884 */   GIR_RootConstrainSelectedInstOperands,
     /* 280885 */   // GIR_Coverage, 7441,
     /* 280885 */   GIR_EraseRootFromParent_Done,
     /* 280886 */ // Label 4641: @280886
     /* 280886 */ GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(280911), // Rule ID 7421 //
     /* 280891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280895 */   // MIs[0] Operand 1
     /* 280895 */   // No operand predicates
     /* 280895 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34732),
     /* 280899 */   // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_34732>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
     /* 280899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 280902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280904 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 280909 */   GIR_RootConstrainSelectedInstOperands,
     /* 280910 */   // GIR_Coverage, 7421,
     /* 280910 */   GIR_EraseRootFromParent_Done,
     /* 280911 */ // Label 4642: @280911
     /* 280911 */ GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(280936), // Rule ID 7440 //
     /* 280916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 280920 */   // MIs[0] Operand 1
     /* 280920 */   // No operand predicates
     /* 280920 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34732),
     /* 280924 */   // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_34732>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
     /* 280924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 280927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 280929 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 280934 */   GIR_RootConstrainSelectedInstOperands,
     /* 280935 */   // GIR_Coverage, 7440,
     /* 280935 */   GIR_EraseRootFromParent_Done,
     /* 280936 */ // Label 4643: @280936
     /* 280936 */ GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(280957), // Rule ID 7423 //
     /* 280941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280945 */   // MIs[0] Operand 1
     /* 280945 */   // No operand predicates
     /* 280945 */   // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
     /* 280945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 280948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280950 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 280955 */   GIR_RootConstrainSelectedInstOperands,
     /* 280956 */   // GIR_Coverage, 7423,
     /* 280956 */   GIR_EraseRootFromParent_Done,
     /* 280957 */ // Label 4644: @280957
     /* 280957 */ GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(280978), // Rule ID 7442 //
     /* 280962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 280966 */   // MIs[0] Operand 1
     /* 280966 */   // No operand predicates
     /* 280966 */   // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
     /* 280966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
     /* 280969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 280971 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
     /* 280976 */   GIR_RootConstrainSelectedInstOperands,
     /* 280977 */   // GIR_Coverage, 7442,
     /* 280977 */   GIR_EraseRootFromParent_Done,
     /* 280978 */ // Label 4645: @280978
     /* 280978 */ GIM_Reject,
     /* 280979 */ // Label 4634: @280979
     /* 280979 */ GIM_Reject,
     /* 280980 */ // Label 44: @280980
     /* 280980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4649*/ GIMT_Encode4(281782),
     /* 280991 */ /*GILLT_s16*//*Label 4646*/ GIMT_Encode4(281003),
     /* 280995 */ /*GILLT_s32*//*Label 4647*/ GIMT_Encode4(281040),
     /* 280999 */ /*GILLT_s64*//*Label 4648*/ GIMT_Encode4(281128),
     /* 281003 */ // Label 4646: @281003
     /* 281003 */ GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(281039), // Rule ID 2560 //
     /* 281008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 281011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 281014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281018 */   // (sext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 281018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 281021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 281035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281037 */   GIR_RootConstrainSelectedInstOperands,
     /* 281038 */   // GIR_Coverage, 2560,
     /* 281038 */   GIR_EraseRootFromParent_Done,
     /* 281039 */ // Label 4650: @281039
     /* 281039 */ GIM_Reject,
     /* 281040 */ // Label 4647: @281040
     /* 281040 */ GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(281063), // Rule ID 1871 //
     /* 281045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 281052 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13761),
     /* 281056 */   // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13761>>  =>  (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src)
     /* 281056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 281061 */   GIR_RootConstrainSelectedInstOperands,
     /* 281062 */   // GIR_Coverage, 1871,
     /* 281062 */   GIR_Done,
     /* 281063 */ // Label 4651: @281063
     /* 281063 */ GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(281094), // Rule ID 2569 //
     /* 281068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281075 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20300),
     /* 281079 */   // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_20300>>  =>  (V_BFE_I32_e64:{ *:[i32] } i16:{ *:[i16] }:$src, 0:{ *:[i32] }, 16:{ *:[i32] })
     /* 281079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 281082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 281092 */   GIR_RootConstrainSelectedInstOperands,
     /* 281093 */   // GIR_Coverage, 2569,
     /* 281093 */   GIR_EraseRootFromParent_Done,
     /* 281094 */ // Label 4652: @281094
     /* 281094 */ GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(281127), // Rule ID 7447 //
     /* 281099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 281102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281106 */   // (sext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 281106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 281109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 281123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 281125 */   GIR_RootConstrainSelectedInstOperands,
     /* 281126 */   // GIR_Coverage, 7447,
     /* 281126 */   GIR_EraseRootFromParent_Done,
     /* 281127 */ // Label 4653: @281127
     /* 281127 */ GIM_Reject,
     /* 281128 */ // Label 4648: @281128
     /* 281128 */ GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(281273), // Rule ID 1881 //
     /* 281133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281140 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13761),
     /* 281144 */   // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13761>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), (S_MOV_B32:{ *:[i1] } 31:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 281144 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 281147 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 281151 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281156 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 281159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 281161 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 281164 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 281168 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281173 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281179 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 281182 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 281186 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281191 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 281194 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 281197 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 281200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281202 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 281205 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281209 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281214 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 281217 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 281222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
     /* 281229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281234 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 281243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281248 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 281251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281254 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 281257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 281267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 281272 */   // GIR_Coverage, 1881,
     /* 281272 */   GIR_EraseRootFromParent_Done,
     /* 281273 */ // Label 4654: @281273
     /* 281273 */ GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(281495), // Rule ID 2570 //
     /* 281278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281285 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20300),
     /* 281289 */   // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_20300>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] })), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e32:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 31:{ *:[i32] }), (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] }))), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 281289 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 281292 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 281296 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281301 */   GIR_AddImm8, /*InsnID*/9, /*Imm*/16,
     /* 281304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 281306 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
     /* 281309 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 281313 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281318 */   GIR_AddImm8, /*InsnID*/8, /*Imm*/0,
     /* 281321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 281323 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 281326 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 281330 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281335 */   GIR_Copy, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281339 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 281342 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
     /* 281345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 281347 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 281350 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 281354 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281359 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 281362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 281364 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 281367 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e32),
     /* 281371 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281376 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 281379 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 281382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 281384 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 281387 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281391 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281396 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 281399 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281404 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 281407 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 281411 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281416 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/16,
     /* 281419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281421 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 281424 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 281428 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281433 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 281436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
     /* 281445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281450 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281454 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281457 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 281465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281470 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 281473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281476 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 281479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281494 */   // GIR_Coverage, 2570,
     /* 281494 */   GIR_EraseRootFromParent_Done,
     /* 281495 */ // Label 4655: @281495
     /* 281495 */ GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(281587), // Rule ID 7532 //
     /* 281500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281507 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13761),
     /* 281511 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_13761>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i32] }:$src, 31:{ *:[i32] }), SReg_32_XM0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 281511 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 281514 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 281518 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281523 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281527 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281530 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 281533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281547 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 281555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 281558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281562 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 281565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281568 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 281571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 281576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 281581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 281586 */   // GIR_Coverage, 7532,
     /* 281586 */   GIR_EraseRootFromParent_Done,
     /* 281587 */ // Label 4656: @281587
     /* 281587 */ GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(281676), // Rule ID 7533 //
     /* 281592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281599 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20300),
     /* 281603 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_20300>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e64:{ *:[i16] } 31:{ *:[i32] }, ?:{ *:[i32] }:$src), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 281603 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 281606 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 281610 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281615 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 281618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281636 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281639 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 281647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281649 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281651 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 281654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281657 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 281660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281670 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281675 */   // GIR_Coverage, 7533,
     /* 281675 */   GIR_EraseRootFromParent_Done,
     /* 281676 */ // Label 4657: @281676
     /* 281676 */ GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(281781), // Rule ID 7534 //
     /* 281681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 281684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281688 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub1:{ *:[i32] })
     /* 281688 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 281691 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 281695 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281700 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 281703 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 281706 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 281709 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 281712 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 281725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281730 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 281733 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 281736 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 281739 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 281742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 281746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 281751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281756 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 281759 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 281762 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 281765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 281770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281780 */   // GIR_Coverage, 7534,
     /* 281780 */   GIR_EraseRootFromParent_Done,
     /* 281781 */ // Label 4658: @281781
     /* 281781 */ GIM_Reject,
     /* 281782 */ // Label 4649: @281782
     /* 281782 */ GIM_Reject,
     /* 281783 */ // Label 45: @281783
     /* 281783 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4662*/ GIMT_Encode4(284985),
     /* 281794 */ /*GILLT_s16*//*Label 4659*/ GIMT_Encode4(281806),
     /* 281798 */ /*GILLT_s32*//*Label 4660*/ GIMT_Encode4(281843),
     /* 281802 */ /*GILLT_s64*//*Label 4661*/ GIMT_Encode4(283131),
     /* 281806 */ // Label 4659: @281806
     /* 281806 */ GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(281842), // Rule ID 2558 //
     /* 281811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 281814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 281817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281821 */   // (zext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
     /* 281821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 281824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 281838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281840 */   GIR_RootConstrainSelectedInstOperands,
     /* 281841 */   // GIR_Coverage, 2558,
     /* 281841 */   GIR_EraseRootFromParent_Done,
     /* 281842 */ // Label 4663: @281842
     /* 281842 */ GIM_Reject,
     /* 281843 */ // Label 4660: @281843
     /* 281843 */ GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(281919), // Rule ID 2555 //
     /* 281848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 281851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 281866 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 281874 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281878 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281882 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 281886 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 281890 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281894 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281898 */   // MIs[3] Operand 1
     /* 281898 */   // No operand predicates
     /* 281898 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 281902 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281904 */   // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 281904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 281907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281909 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 281913 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281917 */   GIR_RootConstrainSelectedInstOperands,
     /* 281918 */   // GIR_Coverage, 2555,
     /* 281918 */   GIR_EraseRootFromParent_Done,
     /* 281919 */ // Label 4664: @281919
     /* 281919 */ GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(281995), // Rule ID 2551 //
     /* 281924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 281927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 281934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 281942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 281946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 281950 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281954 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 281958 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 281962 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 281966 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281970 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281974 */   // MIs[3] Operand 1
     /* 281974 */   // No operand predicates
     /* 281974 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 281978 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281980 */   // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 281980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 281983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 281985 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 281989 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 281993 */   GIR_RootConstrainSelectedInstOperands,
     /* 281994 */   // GIR_Coverage, 2551,
     /* 281994 */   GIR_EraseRootFromParent_Done,
     /* 281995 */ // Label 4665: @281995
     /* 281995 */ GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(282071), // Rule ID 2547 //
     /* 282000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 282018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282022 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282026 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282030 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 282034 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 282038 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 282042 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282046 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282050 */   // MIs[3] Operand 1
     /* 282050 */   // No operand predicates
     /* 282050 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 282054 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282056 */   // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 282059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282061 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 282065 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282069 */   GIR_RootConstrainSelectedInstOperands,
     /* 282070 */   // GIR_Coverage, 2547,
     /* 282070 */   GIR_EraseRootFromParent_Done,
     /* 282071 */ // Label 4666: @282071
     /* 282071 */ GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(282135), // Rule ID 2533 //
     /* 282076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282086 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282090 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 282094 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282098 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282102 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282106 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282110 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
     /* 282114 */   // MIs[2] Operand 1
     /* 282114 */   // No operand predicates
     /* 282114 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282116 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
     /* 282116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 282119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282121 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282125 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
     /* 282130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282133 */   GIR_RootConstrainSelectedInstOperands,
     /* 282134 */   // GIR_Coverage, 2533,
     /* 282134 */   GIR_EraseRootFromParent_Done,
     /* 282135 */ // Label 4667: @282135
     /* 282135 */ GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(282206), // Rule ID 2571 //
     /* 282140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 282158 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282162 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282166 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282170 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 282174 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 282178 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 282182 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282184 */   // (zext:{ *:[i32] } (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
     /* 282184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /* 282187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282189 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 282193 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 282197 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 282201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282204 */   GIR_RootConstrainSelectedInstOperands,
     /* 282205 */   // GIR_Coverage, 2571,
     /* 282205 */   GIR_EraseRootFromParent_Done,
     /* 282206 */ // Label 4668: @282206
     /* 282206 */ GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(282277), // Rule ID 8621 //
     /* 282211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 282229 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282233 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282237 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282241 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 282245 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 282249 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 282253 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282255 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
     /* 282255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
     /* 282258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282260 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 282264 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 282268 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 282272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282275 */   GIR_RootConstrainSelectedInstOperands,
     /* 282276 */   // GIR_Coverage, 8621,
     /* 282276 */   GIR_EraseRootFromParent_Done,
     /* 282277 */ // Label 4669: @282277
     /* 282277 */ GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(282347), // Rule ID 7594 //
     /* 282282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 282285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 282300 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282306 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 282306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 282313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282318 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 282328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 282333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282338 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 282342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282345 */   GIR_RootConstrainSelectedInstOperands,
     /* 282346 */   // GIR_Coverage, 7594,
     /* 282346 */   GIR_EraseRootFromParent_Done,
     /* 282347 */ // Label 4670: @282347
     /* 282347 */ GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(282417), // Rule ID 7596 //
     /* 282352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 282355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 282370 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282376 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 282376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 282383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282388 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 282398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 282403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282408 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 282412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282415 */   GIR_RootConstrainSelectedInstOperands,
     /* 282416 */   // GIR_Coverage, 7596,
     /* 282416 */   GIR_EraseRootFromParent_Done,
     /* 282417 */ // Label 4671: @282417
     /* 282417 */ GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(282504), // Rule ID 7598 //
     /* 282422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX8Plus),
     /* 282425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 282440 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282444 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282446 */   // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, (COPY:{ *:[i16] } VGPR_16:{ *:[i16] }:$a), (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 282446 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 282449 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 282453 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282458 */   GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(202113025),
     /* 282468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282482 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 282486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 282491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282502 */   GIR_RootConstrainSelectedInstOperands,
     /* 282503 */   // GIR_Coverage, 7598,
     /* 282503 */   GIR_EraseRootFromParent_Done,
     /* 282504 */ // Label 4672: @282504
     /* 282504 */ GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(282555), // Rule ID 2521 //
     /* 282509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 282527 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282531 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282537 */   // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_ADD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 282540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282542 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282546 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 282550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282553 */   GIR_RootConstrainSelectedInstOperands,
     /* 282554 */   // GIR_Coverage, 2521,
     /* 282554 */   GIR_EraseRootFromParent_Done,
     /* 282555 */ // Label 4673: @282555
     /* 282555 */ GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(282603), // Rule ID 2554 //
     /* 282560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 282578 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282588 */   // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 282591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282593 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 282597 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282601 */   GIR_RootConstrainSelectedInstOperands,
     /* 282602 */   // GIR_Coverage, 2554,
     /* 282602 */   GIR_EraseRootFromParent_Done,
     /* 282603 */ // Label 4674: @282603
     /* 282603 */ GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(282651), // Rule ID 2550 //
     /* 282608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 282626 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282636 */   // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 282639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282641 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 282645 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282649 */   GIR_RootConstrainSelectedInstOperands,
     /* 282650 */   // GIR_Coverage, 2550,
     /* 282650 */   GIR_EraseRootFromParent_Done,
     /* 282651 */ // Label 4675: @282651
     /* 282651 */ GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(282699), // Rule ID 2534 //
     /* 282656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282666 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282670 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 282674 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282678 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282684 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MUL_LO_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /* 282687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282689 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282693 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 282697 */   GIR_RootConstrainSelectedInstOperands,
     /* 282698 */   // GIR_Coverage, 2534,
     /* 282698 */   GIR_EraseRootFromParent_Done,
     /* 282699 */ // Label 4676: @282699
     /* 282699 */ GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(282747), // Rule ID 2546 //
     /* 282704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 282722 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282730 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282732 */   // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 282735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282737 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 282741 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 282745 */   GIR_RootConstrainSelectedInstOperands,
     /* 282746 */   // GIR_Coverage, 2546,
     /* 282746 */   GIR_EraseRootFromParent_Done,
     /* 282747 */ // Label 4677: @282747
     /* 282747 */ GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(282795), // Rule ID 2540 //
     /* 282752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 282770 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282774 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282778 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282780 */   // (zext:{ *:[i32] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 282783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282785 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282789 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 282793 */   GIR_RootConstrainSelectedInstOperands,
     /* 282794 */   // GIR_Coverage, 2540,
     /* 282794 */   GIR_EraseRootFromParent_Done,
     /* 282795 */ // Label 4678: @282795
     /* 282795 */ GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(282843), // Rule ID 2538 //
     /* 282800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 282818 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282828 */   // (zext:{ *:[i32] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 282831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282833 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282837 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 282841 */   GIR_RootConstrainSelectedInstOperands,
     /* 282842 */   // GIR_Coverage, 2538,
     /* 282842 */   GIR_EraseRootFromParent_Done,
     /* 282843 */ // Label 4679: @282843
     /* 282843 */ GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(282894), // Rule ID 2536 //
     /* 282848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 282866 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282870 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282876 */   // (zext:{ *:[i32] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 282879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282881 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282885 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 282889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282892 */   GIR_RootConstrainSelectedInstOperands,
     /* 282893 */   // GIR_Coverage, 2536,
     /* 282893 */   GIR_EraseRootFromParent_Done,
     /* 282894 */ // Label 4680: @282894
     /* 282894 */ GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(282942), // Rule ID 2544 //
     /* 282899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 282917 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282921 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282927 */   // (zext:{ *:[i32] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 282930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282932 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282936 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 282940 */   GIR_RootConstrainSelectedInstOperands,
     /* 282941 */   // GIR_Coverage, 2544,
     /* 282941 */   GIR_EraseRootFromParent_Done,
     /* 282942 */ // Label 4681: @282942
     /* 282942 */ GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(282990), // Rule ID 2542 //
     /* 282947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 282950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 282957 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282961 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 282965 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282969 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 282973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282975 */   // (zext:{ *:[i32] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
     /* 282975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 282978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 282980 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 282984 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 282988 */   GIR_RootConstrainSelectedInstOperands,
     /* 282989 */   // GIR_Coverage, 2542,
     /* 282989 */   GIR_EraseRootFromParent_Done,
     /* 282990 */ // Label 4682: @282990
     /* 282990 */ GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(283045), // Rule ID 1882 //
     /* 282995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 283002 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13773),
     /* 283006 */   // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13773>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
     /* 283006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 283009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 283013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283018 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 283028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 283033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 283035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 283040 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 283043 */   GIR_RootConstrainSelectedInstOperands,
     /* 283044 */   // GIR_Coverage, 1882,
     /* 283044 */   GIR_EraseRootFromParent_Done,
     /* 283045 */ // Label 4683: @283045
     /* 283045 */ GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(283097), // Rule ID 7573 //
     /* 283050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283057 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34915),
     /* 283061 */   // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_34915>>  =>  (V_AND_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
     /* 283061 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283064 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 283068 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283073 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 283083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 283088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283093 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 283095 */   GIR_RootConstrainSelectedInstOperands,
     /* 283096 */   // GIR_Coverage, 7573,
     /* 283096 */   GIR_EraseRootFromParent_Done,
     /* 283097 */ // Label 4684: @283097
     /* 283097 */ GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(283130), // Rule ID 7448 //
     /* 283102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 283105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283109 */   // (zext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
     /* 283109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 283112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 283114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 283126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 283128 */   GIR_RootConstrainSelectedInstOperands,
     /* 283129 */   // GIR_Coverage, 7448,
     /* 283129 */   GIR_EraseRootFromParent_Done,
     /* 283130 */ // Label 4685: @283130
     /* 283130 */ GIM_Reject,
     /* 283131 */ // Label 4661: @283131
     /* 283131 */ GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(283264), // Rule ID 2557 //
     /* 283136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 283154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283162 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283166 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283170 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 283174 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 283178 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283182 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283186 */   // MIs[3] Operand 1
     /* 283186 */   // No operand predicates
     /* 283186 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283190 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283192 */   // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283192 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283195 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283199 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283204 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 283207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 283216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283221 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 283225 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 283234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283239 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 283242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283245 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 283248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283263 */   // GIR_Coverage, 2557,
     /* 283263 */   GIR_EraseRootFromParent_Done,
     /* 283264 */ // Label 4686: @283264
     /* 283264 */ GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(283397), // Rule ID 2553 //
     /* 283269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283279 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 283287 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283291 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283295 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283299 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283303 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 283307 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 283311 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283315 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283319 */   // MIs[3] Operand 1
     /* 283319 */   // No operand predicates
     /* 283319 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283323 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283325 */   // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283325 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283328 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283332 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283337 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 283340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 283349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 283358 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 283367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283372 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 283375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283378 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 283381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283396 */   // GIR_Coverage, 2553,
     /* 283396 */   GIR_EraseRootFromParent_Done,
     /* 283397 */ // Label 4687: @283397
     /* 283397 */ GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(283530), // Rule ID 2549 //
     /* 283402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 283420 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283424 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283428 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283432 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 283436 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 283440 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 283444 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283448 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283452 */   // MIs[3] Operand 1
     /* 283452 */   // No operand predicates
     /* 283452 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 283456 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283458 */   // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283458 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283461 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283465 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283470 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 283473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283475 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283478 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 283482 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283487 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 283491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 283500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283505 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 283508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283511 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 283514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283529 */   // GIR_Coverage, 2549,
     /* 283529 */   GIR_EraseRootFromParent_Done,
     /* 283530 */ // Label 4688: @283530
     /* 283530 */ GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(283638), // Rule ID 2522 //
     /* 283535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 283553 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283557 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283561 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283563 */   // (zext:{ *:[i64] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ADD_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283563 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283566 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283570 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283575 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 283578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 283587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283592 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283596 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 283600 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 283603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 283608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283613 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 283616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283619 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 283622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283637 */   // GIR_Coverage, 2522,
     /* 283637 */   GIR_EraseRootFromParent_Done,
     /* 283638 */ // Label 4689: @283638
     /* 283638 */ GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(283743), // Rule ID 2556 //
     /* 283643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 283661 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283665 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283669 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283671 */   // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283683 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 283686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 283695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283700 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 283704 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 283713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283718 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 283721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283724 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 283727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283742 */   // GIR_Coverage, 2556,
     /* 283742 */   GIR_EraseRootFromParent_Done,
     /* 283743 */ // Label 4690: @283743
     /* 283743 */ GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(283848), // Rule ID 2552 //
     /* 283748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 283766 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283770 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283776 */   // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283776 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283779 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283783 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283788 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 283791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 283800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283805 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 283809 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 283813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 283818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283823 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 283826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283829 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 283832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283847 */   // GIR_Coverage, 2552,
     /* 283847 */   GIR_EraseRootFromParent_Done,
     /* 283848 */ // Label 4691: @283848
     /* 283848 */ GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(283953), // Rule ID 2535 //
     /* 283853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 283871 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283875 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283881 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_LO_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283881 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283884 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283888 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283893 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 283896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 283901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
     /* 283905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283910 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 283914 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 283918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 283920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 283923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283928 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 283931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 283934 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 283937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 283952 */   // GIR_Coverage, 2535,
     /* 283952 */   GIR_EraseRootFromParent_Done,
     /* 283953 */ // Label 4692: @283953
     /* 283953 */ GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(284058), // Rule ID 2548 //
     /* 283958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 283961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 283968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 283976 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 283980 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 283984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283986 */   // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 283986 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 283989 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 283993 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283998 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 284001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 284010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 284019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 284023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284033 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284039 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284057 */   // GIR_Coverage, 2548,
     /* 284057 */   GIR_EraseRootFromParent_Done,
     /* 284058 */ // Label 4693: @284058
     /* 284058 */ GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(284163), // Rule ID 2541 //
     /* 284063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 284066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 284081 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284085 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 284089 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284091 */   // (zext:{ *:[i64] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284091 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 284094 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 284098 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284103 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 284106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 284115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284120 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 284124 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 284128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284138 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284144 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284162 */   // GIR_Coverage, 2541,
     /* 284162 */   GIR_EraseRootFromParent_Done,
     /* 284163 */ // Label 4694: @284163
     /* 284163 */ GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(284268), // Rule ID 2539 //
     /* 284168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 284171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 284186 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 284194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284196 */   // (zext:{ *:[i64] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284196 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 284199 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 284203 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284208 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 284211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 284220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284225 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 284229 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 284233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284243 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284249 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284252 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284267 */   // GIR_Coverage, 2539,
     /* 284267 */   GIR_EraseRootFromParent_Done,
     /* 284268 */ // Label 4695: @284268
     /* 284268 */ GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(284376), // Rule ID 2537 //
     /* 284273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 284276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 284291 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284295 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 284299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284301 */   // (zext:{ *:[i64] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_SUB_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284301 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 284304 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 284308 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284313 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 284316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 284325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284330 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 284334 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 284338 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284351 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284357 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284375 */   // GIR_Coverage, 2537,
     /* 284375 */   GIR_EraseRootFromParent_Done,
     /* 284376 */ // Label 4696: @284376
     /* 284376 */ GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(284481), // Rule ID 2545 //
     /* 284381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 284384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 284399 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284403 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 284407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284409 */   // (zext:{ *:[i64] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284409 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 284412 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 284416 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284421 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 284424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 284433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284438 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 284442 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 284446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284456 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284462 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284470 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284480 */   // GIR_Coverage, 2545,
     /* 284480 */   GIR_EraseRootFromParent_Done,
     /* 284481 */ // Label 4697: @284481
     /* 284481 */ GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(284586), // Rule ID 2543 //
     /* 284486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
     /* 284489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284496 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284500 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 284504 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 284508 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 284512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284514 */   // (zext:{ *:[i64] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284514 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 284517 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 284521 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284526 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 284529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 284538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284543 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 284547 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 284551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284561 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284567 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284585 */   // GIR_Coverage, 2543,
     /* 284585 */   GIR_EraseRootFromParent_Done,
     /* 284586 */ // Label 4698: @284586
     /* 284586 */ GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(284720), // Rule ID 1880 //
     /* 284591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284598 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13773),
     /* 284602 */   // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13773>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284602 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s1,
     /* 284605 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 284609 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284614 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 284617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284619 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 284622 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 284626 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284631 */   GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(65535),
     /* 284641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 284646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 284650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284655 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 284659 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284662 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 284665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284679 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
     /* 284687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284695 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 284701 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 284714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 284719 */   // GIR_Coverage, 1880,
     /* 284719 */   GIR_EraseRootFromParent_Done,
     /* 284720 */ // Label 4699: @284720
     /* 284720 */ GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(284831), // Rule ID 7574 //
     /* 284725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284732 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34915),
     /* 284736 */   // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_34915>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284736 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 284739 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 284743 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284748 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 284751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284753 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 284756 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 284760 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284765 */   GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
     /* 284775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284777 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284780 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 284784 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284789 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 284796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284806 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 284812 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284830 */   // GIR_Coverage, 7574,
     /* 284830 */   GIR_EraseRootFromParent_Done,
     /* 284831 */ // Label 4700: @284831
     /* 284831 */ GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(284892), // Rule ID 7528 //
     /* 284836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284843 */   // (zext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 284846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 284850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284855 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284867 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284873 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284876 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 284881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 284886 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 284891 */   // GIR_Coverage, 7528,
     /* 284891 */   GIR_EraseRootFromParent_Done,
     /* 284892 */ // Label 4701: @284892
     /* 284892 */ GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(284984), // Rule ID 7530 //
     /* 284897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 284900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284904 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 284904 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 284907 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 284911 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284916 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 284919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 284924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 284928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284933 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284936 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284939 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 284942 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 284945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 284949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 284954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284959 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 284962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284965 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 284968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 284973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284978 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 284983 */   // GIR_Coverage, 7530,
     /* 284983 */   GIR_EraseRootFromParent_Done,
     /* 284984 */ // Label 4702: @284984
     /* 284984 */ GIM_Reject,
     /* 284985 */ // Label 4662: @284985
     /* 284985 */ GIM_Reject,
     /* 284986 */ // Label 46: @284986
     /* 284986 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4707*/ GIMT_Encode4(286521),
     /* 284997 */ /*GILLT_s16*//*Label 4703*/ GIMT_Encode4(285013),
     /* 285001 */ /*GILLT_s32*//*Label 4704*/ GIMT_Encode4(285324),
     /* 285005 */ /*GILLT_s64*//*Label 4705*/ GIMT_Encode4(285965),
     /* 285009 */ /*GILLT_v2s16*//*Label 4706*/ GIMT_Encode4(286352),
     /* 285013 */ // Label 4703: @285013
     /* 285013 */ GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(285323),
     /* 285018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285024 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(285110), // Rule ID 844 //
     /* 285029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 285032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 285036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 285048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 285052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285060 */     // MIs[2] Operand 1
     /* 285060 */     // No operand predicates
     /* 285060 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 285064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 285073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 285080 */     // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
     /* 285083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 285090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 285095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 285100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 285105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285108 */     GIR_RootConstrainSelectedInstOperands,
     /* 285109 */     // GIR_Coverage, 844,
     /* 285109 */     GIR_EraseRootFromParent_Done,
     /* 285110 */   // Label 4709: @285110
     /* 285110 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(285166), // Rule ID 843 //
     /* 285115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 285118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 285122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 285129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 285136 */     // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 285136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
     /* 285139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 285146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 285151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 285156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 285161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285164 */     GIR_RootConstrainSelectedInstOperands,
     /* 285165 */     // GIR_Coverage, 843,
     /* 285165 */     GIR_EraseRootFromParent_Done,
     /* 285166 */   // Label 4710: @285166
     /* 285166 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(285221), // Rule ID 842 //
     /* 285171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 285190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 285194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285202 */     // MIs[2] Operand 1
     /* 285202 */     // No operand predicates
     /* 285202 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 285206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285208 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 285211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 285217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 285219 */     GIR_RootConstrainSelectedInstOperands,
     /* 285220 */     // GIR_Coverage, 842,
     /* 285220 */     GIR_EraseRootFromParent_Done,
     /* 285221 */   // Label 4711: @285221
     /* 285221 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(285276), // Rule ID 846 //
     /* 285226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 285229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 285245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 285249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285257 */     // MIs[2] Operand 1
     /* 285257 */     // No operand predicates
     /* 285257 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 285261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285263 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
     /* 285266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 285272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 285274 */     GIR_RootConstrainSelectedInstOperands,
     /* 285275 */     // GIR_Coverage, 846,
     /* 285275 */     GIR_EraseRootFromParent_Done,
     /* 285276 */   // Label 4712: @285276
     /* 285276 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(285299), // Rule ID 841 //
     /* 285281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 285284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285288 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
     /* 285291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 285297 */     GIR_RootConstrainSelectedInstOperands,
     /* 285298 */     // GIR_Coverage, 841,
     /* 285298 */     GIR_EraseRootFromParent_Done,
     /* 285299 */   // Label 4713: @285299
     /* 285299 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(285322), // Rule ID 845 //
     /* 285304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 285307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285311 */     // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 285311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
     /* 285314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285316 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285318 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 285320 */     GIR_RootConstrainSelectedInstOperands,
     /* 285321 */     // GIR_Coverage, 845,
     /* 285321 */     GIR_EraseRootFromParent_Done,
     /* 285322 */   // Label 4714: @285322
     /* 285322 */   GIM_Reject,
     /* 285323 */ // Label 4708: @285323
     /* 285323 */ GIM_Reject,
     /* 285324 */ // Label 4704: @285324
     /* 285324 */ GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(285964),
     /* 285329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 285335 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(285403), // Rule ID 7701 //
     /* 285340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 285344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 285352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 285368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 285376 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /* 285380 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 285384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35085),
     /* 285388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285390 */     // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_35085>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /* 285390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
     /* 285393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
     /* 285399 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 285401 */     GIR_RootConstrainSelectedInstOperands,
     /* 285402 */     // GIR_Coverage, 7701,
     /* 285402 */     GIR_EraseRootFromParent_Done,
     /* 285403 */   // Label 4716: @285403
     /* 285403 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(285471), // Rule ID 7703 //
     /* 285408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 285420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 285432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 285436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 285444 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /* 285448 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 285452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35087),
     /* 285456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285458 */     // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_35087>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /* 285458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
     /* 285461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
     /* 285467 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 285469 */     GIR_RootConstrainSelectedInstOperands,
     /* 285470 */     // GIR_Coverage, 7703,
     /* 285470 */     GIR_EraseRootFromParent_Done,
     /* 285471 */   // Label 4717: @285471
     /* 285471 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(285566), // Rule ID 2601 //
     /* 285476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 285479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 285491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285499 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 285501 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /* 285505 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /* 285509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 285521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 285525 */     GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/2, // Name : pred:2:z
     /* 285529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 285533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285537 */     // MIs[3] Operand 1
     /* 285537 */     // No operand predicates
     /* 285537 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 285541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20815),
     /* 285545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285547 */     // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20816>>, (and:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:2:z, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:2:Predicate_anonymous_20815>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 285547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
     /* 285550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 285556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 285560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 285564 */     GIR_RootConstrainSelectedInstOperands,
     /* 285565 */     // GIR_Coverage, 2601,
     /* 285565 */     GIR_EraseRootFromParent_Done,
     /* 285566 */   // Label 4718: @285566
     /* 285566 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(285634), // Rule ID 69 //
     /* 285571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 285575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 285579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 285600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285608 */     // MIs[2] Operand 1
     /* 285608 */     // No operand predicates
     /* 285608 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 285612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13734),
     /* 285616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285618 */     // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13734>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 285618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /* 285621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 285623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 285629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 285632 */     GIR_RootConstrainSelectedInstOperands,
     /* 285633 */     // GIR_Coverage, 69,
     /* 285633 */     GIR_EraseRootFromParent_Done,
     /* 285634 */   // Label 4719: @285634
     /* 285634 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(285690), // Rule ID 2492 //
     /* 285639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285667 */     // MIs[2] Operand 1
     /* 285667 */     // No operand predicates
     /* 285667 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 285671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19635),
     /* 285675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285677 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19635>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 285677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 285680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 285686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285688 */     GIR_RootConstrainSelectedInstOperands,
     /* 285689 */     // GIR_Coverage, 2492,
     /* 285689 */     GIR_EraseRootFromParent_Done,
     /* 285690 */   // Label 4720: @285690
     /* 285690 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(285755), // Rule ID 2600 //
     /* 285695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 285698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 285710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285718 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 285720 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /* 285724 */     GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /* 285728 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:2:z
     /* 285732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20815),
     /* 285736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285738 */     // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20816>>, i32:{ *:[i32] }:$src2:$pred:2:z)<<P:2:Predicate_anonymous_20815>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 285738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
     /* 285741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 285747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 285751 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 285753 */     GIR_RootConstrainSelectedInstOperands,
     /* 285754 */     // GIR_Coverage, 2600,
     /* 285754 */     GIR_EraseRootFromParent_Done,
     /* 285755 */   // Label 4721: @285755
     /* 285755 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(285789), // Rule ID 68 //
     /* 285760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 285764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 285768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 285772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13734),
     /* 285776 */     // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13734>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 285776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
     /* 285781 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 285787 */     GIR_RootConstrainSelectedInstOperands,
     /* 285788 */     // GIR_Coverage, 68,
     /* 285788 */     GIR_Done,
     /* 285789 */   // Label 4722: @285789
     /* 285789 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(285813), // Rule ID 2491 //
     /* 285794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285798 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19635),
     /* 285802 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19635>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 285802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 285805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285807 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 285809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285811 */     GIR_RootConstrainSelectedInstOperands,
     /* 285812 */     // GIR_Coverage, 2491,
     /* 285812 */     GIR_EraseRootFromParent_Done,
     /* 285813 */   // Label 4723: @285813
     /* 285813 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(285865), // Rule ID 814 //
     /* 285818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285846 */     // MIs[2] Operand 1
     /* 285846 */     // No operand predicates
     /* 285846 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 285850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285852 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 285852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 285855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 285861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 285863 */     GIR_RootConstrainSelectedInstOperands,
     /* 285864 */     // GIR_Coverage, 814,
     /* 285864 */     GIR_EraseRootFromParent_Done,
     /* 285865 */   // Label 4724: @285865
     /* 285865 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(285920), // Rule ID 840 //
     /* 285870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 285873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 285893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285901 */     // MIs[2] Operand 1
     /* 285901 */     // No operand predicates
     /* 285901 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 285905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285907 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 285907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
     /* 285910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285912 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 285914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 285918 */     GIR_RootConstrainSelectedInstOperands,
     /* 285919 */     // GIR_Coverage, 840,
     /* 285919 */     GIR_EraseRootFromParent_Done,
     /* 285920 */   // Label 4725: @285920
     /* 285920 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(285940), // Rule ID 813 //
     /* 285925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285929 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 285929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 285932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 285934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 285936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 285938 */     GIR_RootConstrainSelectedInstOperands,
     /* 285939 */     // GIR_Coverage, 813,
     /* 285939 */     GIR_EraseRootFromParent_Done,
     /* 285940 */   // Label 4726: @285940
     /* 285940 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(285963), // Rule ID 839 //
     /* 285945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 285948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 285952 */     // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 285952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
     /* 285957 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 285961 */     GIR_RootConstrainSelectedInstOperands,
     /* 285962 */     // GIR_Coverage, 839,
     /* 285962 */     GIR_Done,
     /* 285963 */   // Label 4727: @285963
     /* 285963 */   GIM_Reject,
     /* 285964 */ // Label 4715: @285964
     /* 285964 */ GIM_Reject,
     /* 285965 */ // Label 4705: @285965
     /* 285965 */ GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(286351),
     /* 285970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 285976 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(286044), // Rule ID 71 //
     /* 285981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 285985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 285989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 285997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 286005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 286010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286018 */     // MIs[2] Operand 1
     /* 286018 */     // No operand predicates
     /* 286018 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 286022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13735),
     /* 286026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286028 */     // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13735>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 286028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
     /* 286031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 286035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 286039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 286042 */     GIR_RootConstrainSelectedInstOperands,
     /* 286043 */     // GIR_Coverage, 71,
     /* 286043 */     GIR_EraseRootFromParent_Done,
     /* 286044 */   // Label 4729: @286044
     /* 286044 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(286078), // Rule ID 70 //
     /* 286049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 286053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 286057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 286061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13735),
     /* 286065 */     // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13735>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 286065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
     /* 286070 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 286076 */     GIR_RootConstrainSelectedInstOperands,
     /* 286077 */     // GIR_Coverage, 70,
     /* 286077 */     GIR_Done,
     /* 286078 */   // Label 4730: @286078
     /* 286078 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(286143), // Rule ID 985 //
     /* 286083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 286086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 286090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 286106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286114 */     // MIs[2] Operand 1
     /* 286114 */     // No operand predicates
     /* 286114 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 286118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286127 */     // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
     /* 286130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 286141 */     GIR_RootConstrainSelectedInstOperands,
     /* 286142 */     // GIR_Coverage, 985,
     /* 286142 */     GIR_EraseRootFromParent_Done,
     /* 286143 */   // Label 4731: @286143
     /* 286143 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(286206), // Rule ID 995 //
     /* 286148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
     /* 286151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 286155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 286171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286179 */     // MIs[2] Operand 1
     /* 286179 */     // No operand predicates
     /* 286179 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 286183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286192 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
     /* 286195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286204 */     GIR_RootConstrainSelectedInstOperands,
     /* 286205 */     // GIR_Coverage, 995,
     /* 286205 */     GIR_EraseRootFromParent_Done,
     /* 286206 */   // Label 4732: @286206
     /* 286206 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(286239), // Rule ID 984 //
     /* 286211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 286214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 286218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286225 */     // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 286225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
     /* 286228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286235 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 286237 */     GIR_RootConstrainSelectedInstOperands,
     /* 286238 */     // GIR_Coverage, 984,
     /* 286238 */     GIR_EraseRootFromParent_Done,
     /* 286239 */   // Label 4733: @286239
     /* 286239 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(286272), // Rule ID 994 //
     /* 286244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
     /* 286247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 286251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 286258 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
     /* 286261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 286268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286270 */     GIR_RootConstrainSelectedInstOperands,
     /* 286271 */     // GIR_Coverage, 994,
     /* 286271 */     GIR_EraseRootFromParent_Done,
     /* 286272 */   // Label 4734: @286272
     /* 286272 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(286327), // Rule ID 921 //
     /* 286277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 286280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 286284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 286300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286308 */     // MIs[2] Operand 1
     /* 286308 */     // No operand predicates
     /* 286308 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 286312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286314 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
     /* 286317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 286323 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286325 */     GIR_RootConstrainSelectedInstOperands,
     /* 286326 */     // GIR_Coverage, 921,
     /* 286326 */     GIR_EraseRootFromParent_Done,
     /* 286327 */   // Label 4735: @286327
     /* 286327 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(286350), // Rule ID 920 //
     /* 286332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 286335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 286339 */     // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 286339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
     /* 286342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286348 */     GIR_RootConstrainSelectedInstOperands,
     /* 286349 */     // GIR_Coverage, 920,
     /* 286349 */     GIR_EraseRootFromParent_Done,
     /* 286350 */   // Label 4736: @286350
     /* 286350 */   GIM_Reject,
     /* 286351 */ // Label 4728: @286351
     /* 286351 */ GIM_Reject,
     /* 286352 */ // Label 4706: @286352
     /* 286352 */ GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(286520),
     /* 286357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 286360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 286363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 286367 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(286458), // Rule ID 1109 //
     /* 286372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 286384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 286388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286396 */     // MIs[2] Operand 1
     /* 286396 */     // No operand predicates
     /* 286396 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 286400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 286409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 286416 */     // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 286416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
     /* 286419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 286426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 286431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 286436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 286441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286456 */     GIR_RootConstrainSelectedInstOperands,
     /* 286457 */     // GIR_Coverage, 1109,
     /* 286457 */     GIR_EraseRootFromParent_Done,
     /* 286458 */   // Label 4738: @286458
     /* 286458 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(286519), // Rule ID 1108 //
     /* 286463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 286470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 286477 */     // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 286477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
     /* 286480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 286487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 286492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 286497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 286502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286517 */     GIR_RootConstrainSelectedInstOperands,
     /* 286518 */     // GIR_Coverage, 1108,
     /* 286518 */     GIR_EraseRootFromParent_Done,
     /* 286519 */   // Label 4739: @286519
     /* 286519 */   GIM_Reject,
     /* 286520 */ // Label 4737: @286520
     /* 286520 */ GIM_Reject,
     /* 286521 */ // Label 4707: @286521
     /* 286521 */ GIM_Reject,
     /* 286522 */ // Label 47: @286522
     /* 286522 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4744*/ GIMT_Encode4(287683),
     /* 286533 */ /*GILLT_s16*//*Label 4740*/ GIMT_Encode4(286549),
     /* 286537 */ /*GILLT_s32*//*Label 4741*/ GIMT_Encode4(286860),
     /* 286541 */ /*GILLT_s64*//*Label 4742*/ GIMT_Encode4(287205),
     /* 286545 */ /*GILLT_v2s16*//*Label 4743*/ GIMT_Encode4(287514),
     /* 286549 */ // Label 4740: @286549
     /* 286549 */ GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(286859),
     /* 286554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 286560 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(286646), // Rule ID 850 //
     /* 286565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 286568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 286572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 286588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286596 */     // MIs[2] Operand 1
     /* 286596 */     // No operand predicates
     /* 286596 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 286600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 286609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 286616 */     // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 286616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
     /* 286619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 286626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 286631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 286636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 286641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286644 */     GIR_RootConstrainSelectedInstOperands,
     /* 286645 */     // GIR_Coverage, 850,
     /* 286645 */     GIR_EraseRootFromParent_Done,
     /* 286646 */   // Label 4746: @286646
     /* 286646 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(286702), // Rule ID 849 //
     /* 286651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 286654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 286658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 286665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 286672 */     // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 286672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
     /* 286675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 286682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 286687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 286692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 286697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 286700 */     GIR_RootConstrainSelectedInstOperands,
     /* 286701 */     // GIR_Coverage, 849,
     /* 286701 */     GIR_EraseRootFromParent_Done,
     /* 286702 */   // Label 4747: @286702
     /* 286702 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(286757), // Rule ID 848 //
     /* 286707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 286714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 286730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286738 */     // MIs[2] Operand 1
     /* 286738 */     // No operand predicates
     /* 286738 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 286742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286744 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 286747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 286753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286755 */     GIR_RootConstrainSelectedInstOperands,
     /* 286756 */     // GIR_Coverage, 848,
     /* 286756 */     GIR_EraseRootFromParent_Done,
     /* 286757 */   // Label 4748: @286757
     /* 286757 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(286812), // Rule ID 852 //
     /* 286762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 286765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 286769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 286785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286793 */     // MIs[2] Operand 1
     /* 286793 */     // No operand predicates
     /* 286793 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 286797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286799 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
     /* 286802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 286808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286810 */     GIR_RootConstrainSelectedInstOperands,
     /* 286811 */     // GIR_Coverage, 852,
     /* 286811 */     GIR_EraseRootFromParent_Done,
     /* 286812 */   // Label 4749: @286812
     /* 286812 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(286835), // Rule ID 847 //
     /* 286817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 286820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 286824 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
     /* 286827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286833 */     GIR_RootConstrainSelectedInstOperands,
     /* 286834 */     // GIR_Coverage, 847,
     /* 286834 */     GIR_EraseRootFromParent_Done,
     /* 286835 */   // Label 4750: @286835
     /* 286835 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(286858), // Rule ID 851 //
     /* 286840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 286843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 286847 */     // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 286847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
     /* 286850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 286854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 286856 */     GIR_RootConstrainSelectedInstOperands,
     /* 286857 */     // GIR_Coverage, 851,
     /* 286857 */     GIR_EraseRootFromParent_Done,
     /* 286858 */   // Label 4751: @286858
     /* 286858 */   GIM_Reject,
     /* 286859 */ // Label 4745: @286859
     /* 286859 */ GIM_Reject,
     /* 286860 */ // Label 4741: @286860
     /* 286860 */ GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(287204),
     /* 286865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286871 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(286939), // Rule ID 73 //
     /* 286876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 286880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 286884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 286900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 286905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286913 */     // MIs[2] Operand 1
     /* 286913 */     // No operand predicates
     /* 286913 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 286917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13736),
     /* 286921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286923 */     // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13736>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 286923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
     /* 286926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 286928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 286930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 286934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 286937 */     GIR_RootConstrainSelectedInstOperands,
     /* 286938 */     // GIR_Coverage, 73,
     /* 286938 */     GIR_EraseRootFromParent_Done,
     /* 286939 */   // Label 4753: @286939
     /* 286939 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(286995), // Rule ID 2488 //
     /* 286944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 286948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 286956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 286964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286972 */     // MIs[2] Operand 1
     /* 286972 */     // No operand predicates
     /* 286972 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 286976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19631),
     /* 286980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286982 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19631>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 286982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 286985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 286987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 286991 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 286993 */     GIR_RootConstrainSelectedInstOperands,
     /* 286994 */     // GIR_Coverage, 2488,
     /* 286994 */     GIR_EraseRootFromParent_Done,
     /* 286995 */   // Label 4754: @286995
     /* 286995 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(287029), // Rule ID 72 //
     /* 287000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 287004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 287008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 287012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13736),
     /* 287016 */     // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13736>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 287016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
     /* 287021 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 287027 */     GIR_RootConstrainSelectedInstOperands,
     /* 287028 */     // GIR_Coverage, 72,
     /* 287028 */     GIR_Done,
     /* 287029 */   // Label 4755: @287029
     /* 287029 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(287053), // Rule ID 2487 //
     /* 287034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19631),
     /* 287042 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19631>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 287042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 287045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287047 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 287049 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 287051 */     GIR_RootConstrainSelectedInstOperands,
     /* 287052 */     // GIR_Coverage, 2487,
     /* 287052 */     GIR_EraseRootFromParent_Done,
     /* 287053 */   // Label 4756: @287053
     /* 287053 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(287105), // Rule ID 810 //
     /* 287058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 287078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287086 */     // MIs[2] Operand 1
     /* 287086 */     // No operand predicates
     /* 287086 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 287090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287092 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 287092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 287095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 287101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 287103 */     GIR_RootConstrainSelectedInstOperands,
     /* 287104 */     // GIR_Coverage, 810,
     /* 287104 */     GIR_EraseRootFromParent_Done,
     /* 287105 */   // Label 4757: @287105
     /* 287105 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(287160), // Rule ID 836 //
     /* 287110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 287113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 287133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287141 */     // MIs[2] Operand 1
     /* 287141 */     // No operand predicates
     /* 287141 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 287145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287147 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 287147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
     /* 287150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 287154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 287158 */     GIR_RootConstrainSelectedInstOperands,
     /* 287159 */     // GIR_Coverage, 836,
     /* 287159 */     GIR_EraseRootFromParent_Done,
     /* 287160 */   // Label 4758: @287160
     /* 287160 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(287180), // Rule ID 809 //
     /* 287165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287169 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 287169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 287172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 287176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 287178 */     GIR_RootConstrainSelectedInstOperands,
     /* 287179 */     // GIR_Coverage, 809,
     /* 287179 */     GIR_EraseRootFromParent_Done,
     /* 287180 */   // Label 4759: @287180
     /* 287180 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(287203), // Rule ID 835 //
     /* 287185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 287188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287192 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 287192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
     /* 287197 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 287201 */     GIR_RootConstrainSelectedInstOperands,
     /* 287202 */     // GIR_Coverage, 835,
     /* 287202 */     GIR_Done,
     /* 287203 */   // Label 4760: @287203
     /* 287203 */   GIM_Reject,
     /* 287204 */ // Label 4752: @287204
     /* 287204 */ GIM_Reject,
     /* 287205 */ // Label 4742: @287205
     /* 287205 */ GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(287513),
     /* 287210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 287216 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(287284), // Rule ID 75 //
     /* 287221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 287225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 287229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 287245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 287250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287258 */     // MIs[2] Operand 1
     /* 287258 */     // No operand predicates
     /* 287258 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 287262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13737),
     /* 287266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287268 */     // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13737>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 287268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
     /* 287271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 287273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 287275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 287279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 287282 */     GIR_RootConstrainSelectedInstOperands,
     /* 287283 */     // GIR_Coverage, 75,
     /* 287283 */     GIR_EraseRootFromParent_Done,
     /* 287284 */   // Label 4762: @287284
     /* 287284 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(287318), // Rule ID 74 //
     /* 287289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 287293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 287297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 287301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13737),
     /* 287305 */     // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13737>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 287305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
     /* 287310 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 287316 */     GIR_RootConstrainSelectedInstOperands,
     /* 287317 */     // GIR_Coverage, 74,
     /* 287317 */     GIR_Done,
     /* 287318 */   // Label 4763: @287318
     /* 287318 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(287383), // Rule ID 987 //
     /* 287323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 287326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 287330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 287346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287354 */     // MIs[2] Operand 1
     /* 287354 */     // No operand predicates
     /* 287354 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 287358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287367 */     // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 287367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
     /* 287370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 287381 */     GIR_RootConstrainSelectedInstOperands,
     /* 287382 */     // GIR_Coverage, 987,
     /* 287382 */     GIR_EraseRootFromParent_Done,
     /* 287383 */   // Label 4764: @287383
     /* 287383 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(287446), // Rule ID 991 //
     /* 287388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 287391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 287395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 287411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287419 */     // MIs[2] Operand 1
     /* 287419 */     // No operand predicates
     /* 287419 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 287423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287432 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 287432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
     /* 287435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 287444 */     GIR_RootConstrainSelectedInstOperands,
     /* 287445 */     // GIR_Coverage, 991,
     /* 287445 */     GIR_EraseRootFromParent_Done,
     /* 287446 */   // Label 4765: @287446
     /* 287446 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(287479), // Rule ID 986 //
     /* 287451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 287454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 287458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287465 */     // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 287465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
     /* 287468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 287477 */     GIR_RootConstrainSelectedInstOperands,
     /* 287478 */     // GIR_Coverage, 986,
     /* 287478 */     GIR_EraseRootFromParent_Done,
     /* 287479 */   // Label 4766: @287479
     /* 287479 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(287512), // Rule ID 990 //
     /* 287484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 287487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 287491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 287498 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 287498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
     /* 287501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 287508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 287510 */     GIR_RootConstrainSelectedInstOperands,
     /* 287511 */     // GIR_Coverage, 990,
     /* 287511 */     GIR_EraseRootFromParent_Done,
     /* 287512 */   // Label 4767: @287512
     /* 287512 */   GIM_Reject,
     /* 287513 */ // Label 4761: @287513
     /* 287513 */ GIM_Reject,
     /* 287514 */ // Label 4743: @287514
     /* 287514 */ GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(287682),
     /* 287519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 287522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 287525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287529 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(287620), // Rule ID 1113 //
     /* 287534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 287546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 287550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287558 */     // MIs[2] Operand 1
     /* 287558 */     // No operand predicates
     /* 287558 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 287562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 287571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 287578 */     // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 287578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
     /* 287581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 287588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 287593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 287598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 287603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287618 */     GIR_RootConstrainSelectedInstOperands,
     /* 287619 */     // GIR_Coverage, 1113,
     /* 287619 */     GIR_EraseRootFromParent_Done,
     /* 287620 */   // Label 4769: @287620
     /* 287620 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(287681), // Rule ID 1112 //
     /* 287625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 287632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 287639 */     // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 287639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
     /* 287642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 287649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 287654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 287659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 287664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287679 */     GIR_RootConstrainSelectedInstOperands,
     /* 287680 */     // GIR_Coverage, 1112,
     /* 287680 */     GIR_EraseRootFromParent_Done,
     /* 287681 */   // Label 4770: @287681
     /* 287681 */   GIM_Reject,
     /* 287682 */ // Label 4768: @287682
     /* 287682 */ GIM_Reject,
     /* 287683 */ // Label 4744: @287683
     /* 287683 */ GIM_Reject,
     /* 287684 */ // Label 48: @287684
     /* 287684 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4775*/ GIMT_Encode4(288845),
     /* 287695 */ /*GILLT_s16*//*Label 4771*/ GIMT_Encode4(287711),
     /* 287699 */ /*GILLT_s32*//*Label 4772*/ GIMT_Encode4(288022),
     /* 287703 */ /*GILLT_s64*//*Label 4773*/ GIMT_Encode4(288367),
     /* 287707 */ /*GILLT_v2s16*//*Label 4774*/ GIMT_Encode4(288676),
     /* 287711 */ // Label 4771: @287711
     /* 287711 */ GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(288021),
     /* 287716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 287719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 287722 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(287808), // Rule ID 856 //
     /* 287727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 287730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 287734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 287750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287758 */     // MIs[2] Operand 1
     /* 287758 */     // No operand predicates
     /* 287758 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 287762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 287771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 287778 */     // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 287778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
     /* 287781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 287788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 287793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 287798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 287803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287806 */     GIR_RootConstrainSelectedInstOperands,
     /* 287807 */     // GIR_Coverage, 856,
     /* 287807 */     GIR_EraseRootFromParent_Done,
     /* 287808 */   // Label 4777: @287808
     /* 287808 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(287864), // Rule ID 855 //
     /* 287813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 287816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 287820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 287827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 287834 */     // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 287834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
     /* 287837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 287844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 287849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 287854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 287859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287862 */     GIR_RootConstrainSelectedInstOperands,
     /* 287863 */     // GIR_Coverage, 855,
     /* 287863 */     GIR_EraseRootFromParent_Done,
     /* 287864 */   // Label 4778: @287864
     /* 287864 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(287919), // Rule ID 854 //
     /* 287869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 287892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287900 */     // MIs[2] Operand 1
     /* 287900 */     // No operand predicates
     /* 287900 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 287904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287906 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 287906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 287909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 287915 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 287917 */     GIR_RootConstrainSelectedInstOperands,
     /* 287918 */     // GIR_Coverage, 854,
     /* 287918 */     GIR_EraseRootFromParent_Done,
     /* 287919 */   // Label 4779: @287919
     /* 287919 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(287974), // Rule ID 858 //
     /* 287924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 287927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 287939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 287947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287955 */     // MIs[2] Operand 1
     /* 287955 */     // No operand predicates
     /* 287955 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 287959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287961 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 287961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
     /* 287964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 287970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 287972 */     GIR_RootConstrainSelectedInstOperands,
     /* 287973 */     // GIR_Coverage, 858,
     /* 287973 */     GIR_EraseRootFromParent_Done,
     /* 287974 */   // Label 4780: @287974
     /* 287974 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(287997), // Rule ID 853 //
     /* 287979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 287982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 287986 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 287986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
     /* 287989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 287991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 287993 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 287995 */     GIR_RootConstrainSelectedInstOperands,
     /* 287996 */     // GIR_Coverage, 853,
     /* 287996 */     GIR_EraseRootFromParent_Done,
     /* 287997 */   // Label 4781: @287997
     /* 287997 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(288020), // Rule ID 857 //
     /* 288002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 288005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288009 */     // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 288009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
     /* 288012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288014 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 288016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 288018 */     GIR_RootConstrainSelectedInstOperands,
     /* 288019 */     // GIR_Coverage, 857,
     /* 288019 */     GIR_EraseRootFromParent_Done,
     /* 288020 */   // Label 4782: @288020
     /* 288020 */   GIM_Reject,
     /* 288021 */ // Label 4776: @288021
     /* 288021 */ GIM_Reject,
     /* 288022 */ // Label 4772: @288022
     /* 288022 */ GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(288366),
     /* 288027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 288033 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(288101), // Rule ID 77 //
     /* 288038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 288062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288075 */     // MIs[2] Operand 1
     /* 288075 */     // No operand predicates
     /* 288075 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 288079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13738),
     /* 288083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288085 */     // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13738>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 288085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 288088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 288092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 288096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 288099 */     GIR_RootConstrainSelectedInstOperands,
     /* 288100 */     // GIR_Coverage, 77,
     /* 288100 */     GIR_EraseRootFromParent_Done,
     /* 288101 */   // Label 4784: @288101
     /* 288101 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(288157), // Rule ID 2490 //
     /* 288106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 288126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288134 */     // MIs[2] Operand 1
     /* 288134 */     // No operand predicates
     /* 288134 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 288138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19633),
     /* 288142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288144 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19633>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 288144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 288147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 288153 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 288155 */     GIR_RootConstrainSelectedInstOperands,
     /* 288156 */     // GIR_Coverage, 2490,
     /* 288156 */     GIR_EraseRootFromParent_Done,
     /* 288157 */   // Label 4785: @288157
     /* 288157 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(288191), // Rule ID 76 //
     /* 288162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13738),
     /* 288178 */     // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13738>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 288178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
     /* 288183 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 288189 */     GIR_RootConstrainSelectedInstOperands,
     /* 288190 */     // GIR_Coverage, 76,
     /* 288190 */     GIR_Done,
     /* 288191 */   // Label 4786: @288191
     /* 288191 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(288215), // Rule ID 2489 //
     /* 288196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19633),
     /* 288204 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19633>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
     /* 288204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 288207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288209 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 288211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 288213 */     GIR_RootConstrainSelectedInstOperands,
     /* 288214 */     // GIR_Coverage, 2489,
     /* 288214 */     GIR_EraseRootFromParent_Done,
     /* 288215 */   // Label 4787: @288215
     /* 288215 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(288267), // Rule ID 812 //
     /* 288220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 288240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288248 */     // MIs[2] Operand 1
     /* 288248 */     // No operand predicates
     /* 288248 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 288252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288254 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 288254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 288257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 288263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 288265 */     GIR_RootConstrainSelectedInstOperands,
     /* 288266 */     // GIR_Coverage, 812,
     /* 288266 */     GIR_EraseRootFromParent_Done,
     /* 288267 */   // Label 4788: @288267
     /* 288267 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(288322), // Rule ID 838 //
     /* 288272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 288275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 288295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288303 */     // MIs[2] Operand 1
     /* 288303 */     // No operand predicates
     /* 288303 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
     /* 288307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288309 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 288309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
     /* 288312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 288316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 288320 */     GIR_RootConstrainSelectedInstOperands,
     /* 288321 */     // GIR_Coverage, 838,
     /* 288321 */     GIR_EraseRootFromParent_Done,
     /* 288322 */   // Label 4789: @288322
     /* 288322 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(288342), // Rule ID 811 //
     /* 288327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288331 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 288331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
     /* 288334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288336 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 288338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 288340 */     GIR_RootConstrainSelectedInstOperands,
     /* 288341 */     // GIR_Coverage, 811,
     /* 288341 */     GIR_EraseRootFromParent_Done,
     /* 288342 */   // Label 4790: @288342
     /* 288342 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(288365), // Rule ID 837 //
     /* 288347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 288350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288354 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 288354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
     /* 288359 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 288363 */     GIR_RootConstrainSelectedInstOperands,
     /* 288364 */     // GIR_Coverage, 837,
     /* 288364 */     GIR_Done,
     /* 288365 */   // Label 4791: @288365
     /* 288365 */   GIM_Reject,
     /* 288366 */ // Label 4783: @288366
     /* 288366 */ GIM_Reject,
     /* 288367 */ // Label 4773: @288367
     /* 288367 */ GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(288675),
     /* 288372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 288378 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(288446), // Rule ID 79 //
     /* 288383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 288387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 288391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 288407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288420 */     // MIs[2] Operand 1
     /* 288420 */     // No operand predicates
     /* 288420 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 288424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13739),
     /* 288428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288430 */     // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13739>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 288430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
     /* 288433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 288435 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 288437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 288441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 288444 */     GIR_RootConstrainSelectedInstOperands,
     /* 288445 */     // GIR_Coverage, 79,
     /* 288445 */     GIR_EraseRootFromParent_Done,
     /* 288446 */   // Label 4793: @288446
     /* 288446 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(288480), // Rule ID 78 //
     /* 288451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 288455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 288459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 288463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13739),
     /* 288467 */     // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13739>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 288467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
     /* 288472 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 288478 */     GIR_RootConstrainSelectedInstOperands,
     /* 288479 */     // GIR_Coverage, 78,
     /* 288479 */     GIR_Done,
     /* 288480 */   // Label 4794: @288480
     /* 288480 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(288545), // Rule ID 989 //
     /* 288485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 288488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 288492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 288508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288516 */     // MIs[2] Operand 1
     /* 288516 */     // No operand predicates
     /* 288516 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 288520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288529 */     // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 288529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
     /* 288532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 288543 */     GIR_RootConstrainSelectedInstOperands,
     /* 288544 */     // GIR_Coverage, 989,
     /* 288544 */     GIR_EraseRootFromParent_Done,
     /* 288545 */   // Label 4795: @288545
     /* 288545 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(288608), // Rule ID 993 //
     /* 288550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 288553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 288557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 288573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288581 */     // MIs[2] Operand 1
     /* 288581 */     // No operand predicates
     /* 288581 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
     /* 288585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288594 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 288594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
     /* 288597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 288606 */     GIR_RootConstrainSelectedInstOperands,
     /* 288607 */     // GIR_Coverage, 993,
     /* 288607 */     GIR_EraseRootFromParent_Done,
     /* 288608 */   // Label 4796: @288608
     /* 288608 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(288641), // Rule ID 988 //
     /* 288613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 288616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 288620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288627 */     // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
     /* 288627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
     /* 288630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 288639 */     GIR_RootConstrainSelectedInstOperands,
     /* 288640 */     // GIR_Coverage, 988,
     /* 288640 */     GIR_EraseRootFromParent_Done,
     /* 288641 */   // Label 4797: @288641
     /* 288641 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(288674), // Rule ID 992 //
     /* 288646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 288649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 288653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 288660 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
     /* 288660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
     /* 288663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288670 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 288672 */     GIR_RootConstrainSelectedInstOperands,
     /* 288673 */     // GIR_Coverage, 992,
     /* 288673 */     GIR_EraseRootFromParent_Done,
     /* 288674 */   // Label 4798: @288674
     /* 288674 */   GIM_Reject,
     /* 288675 */ // Label 4792: @288675
     /* 288675 */ GIM_Reject,
     /* 288676 */ // Label 4774: @288676
     /* 288676 */ GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(288844),
     /* 288681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 288684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 288687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288691 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(288782), // Rule ID 1111 //
     /* 288696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 288704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 288708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 288712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288720 */     // MIs[2] Operand 1
     /* 288720 */     // No operand predicates
     /* 288720 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
     /* 288724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 288733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 288740 */     // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 288740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
     /* 288743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 288750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 288755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 288760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 288765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288780 */     GIR_RootConstrainSelectedInstOperands,
     /* 288781 */     // GIR_Coverage, 1111,
     /* 288781 */     GIR_EraseRootFromParent_Done,
     /* 288782 */   // Label 4800: @288782
     /* 288782 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(288843), // Rule ID 1110 //
     /* 288787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 288794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 288801 */     // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 288801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
     /* 288804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 288811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 288816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 288821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 288826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288841 */     GIR_RootConstrainSelectedInstOperands,
     /* 288842 */     // GIR_Coverage, 1110,
     /* 288842 */     GIR_EraseRootFromParent_Done,
     /* 288843 */   // Label 4801: @288843
     /* 288843 */   GIM_Reject,
     /* 288844 */ // Label 4799: @288844
     /* 288844 */ GIM_Reject,
     /* 288845 */ // Label 4775: @288845
     /* 288845 */ GIM_Reject,
     /* 288846 */ // Label 49: @288846
     /* 288846 */ GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(289107),
     /* 288851 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 288854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 288860 */   GIM_SwitchType, /*MI*/0, /*Op*/3, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4805*/ GIMT_Encode4(289068),
     /* 288871 */   /*GILLT_s16*//*Label 4803*/ GIMT_Encode4(288879),
     /* 288875 */   /*GILLT_s32*//*Label 4804*/ GIMT_Encode4(288956),
     /* 288879 */   // Label 4803: @288879
     /* 288879 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(288955), // Rule ID 962 //
     /* 288884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 288887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 288898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 288905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 288912 */     // (fshr:{ *:[i32] } (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 288912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 288915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 288917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 288922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 288927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 288932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 288937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 288942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 288947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288953 */     GIR_RootConstrainSelectedInstOperands,
     /* 288954 */     // GIR_Coverage, 962,
     /* 288954 */     GIR_EraseRootFromParent_Done,
     /* 288955 */   // Label 4806: @288955
     /* 288955 */   GIM_Reject,
     /* 288956 */   // Label 4804: @288956
     /* 288956 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(289067),
     /* 288961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 288965 */     GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(289030), // Rule ID 7469 //
     /* 288970 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 288973 */       // (fshr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_t16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VGPR_32:{ *:[i32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 288973 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288976 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288980 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288985 */       GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(2), // src2
     /* 288991 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 288996 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 289001 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_t16_e64),
     /* 289004 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 289006 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289009 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 289011 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289014 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 289016 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289019 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289022 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289025 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289028 */       GIR_RootConstrainSelectedInstOperands,
     /* 289029 */       // GIR_Coverage, 7469,
     /* 289029 */       GIR_EraseRootFromParent_Done,
     /* 289030 */     // Label 4808: @289030
     /* 289030 */     GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(289066), // Rule ID 7473 //
     /* 289035 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 289038 */       // (fshr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 289038 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 289041 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 289043 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289046 */       GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 289048 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289051 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 289053 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289056 */       GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 289058 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289061 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289064 */       GIR_RootConstrainSelectedInstOperands,
     /* 289065 */       // GIR_Coverage, 7473,
     /* 289065 */       GIR_EraseRootFromParent_Done,
     /* 289066 */     // Label 4809: @289066
     /* 289066 */     GIM_Reject,
     /* 289067 */   // Label 4807: @289067
     /* 289067 */   GIM_Reject,
     /* 289068 */   // Label 4805: @289068
     /* 289068 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(289106), // Rule ID 961 //
     /* 289073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 289076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 289079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 289083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289090 */     // (fshr:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 289090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 289093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 289095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289100 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 289102 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 289104 */     GIR_RootConstrainSelectedInstOperands,
     /* 289105 */     // GIR_Coverage, 961,
     /* 289105 */     GIR_EraseRootFromParent_Done,
     /* 289106 */   // Label 4810: @289106
     /* 289106 */   GIM_Reject,
     /* 289107 */ // Label 4802: @289107
     /* 289107 */ GIM_Reject,
     /* 289108 */ // Label 50: @289108
     /* 289108 */ GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(289184),
     /* 289113 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 289116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 289119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 289122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 289126 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(289147), // Rule ID 7464 //
     /* 289131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 289134 */     // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
     /* 289134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 289137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 289139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 289141 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 289143 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 289145 */     GIR_RootConstrainSelectedInstOperands,
     /* 289146 */     // GIR_Coverage, 7464,
     /* 289146 */     GIR_EraseRootFromParent_Done,
     /* 289147 */   // Label 4812: @289147
     /* 289147 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(289183), // Rule ID 7470 //
     /* 289152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 289155 */     // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ALIGNBIT_B32_fake16_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 289155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 289158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 289160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 289165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 289170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 289175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289181 */     GIR_RootConstrainSelectedInstOperands,
     /* 289182 */     // GIR_Coverage, 7470,
     /* 289182 */     GIR_EraseRootFromParent_Done,
     /* 289183 */   // Label 4813: @289183
     /* 289183 */   GIM_Reject,
     /* 289184 */ // Label 4811: @289184
     /* 289184 */ GIM_Reject,
     /* 289185 */ // Label 51: @289185
     /* 289185 */ GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(290776),
     /* 289190 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 289193 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4818*/ GIMT_Encode4(290476),
     /* 289204 */   /*GILLT_s16*//*Label 4815*/ GIMT_Encode4(289216),
     /* 289208 */   /*GILLT_s32*//*Label 4816*/ GIMT_Encode4(290280),
     /* 289212 */   /*GILLT_s64*//*Label 4817*/ GIMT_Encode4(290378),
     /* 289216 */   // Label 4815: @289216
     /* 289216 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(290279),
     /* 289221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 289224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 289228 */     GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(289285), // Rule ID 460 //
     /* 289233 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289236 */       // MIs[0] Operand 1
     /* 289236 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289241 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289248 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289255 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289255 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_t16_e64),
     /* 289258 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289260 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289265 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289270 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289275 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289280 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289283 */       GIR_RootConstrainSelectedInstOperands,
     /* 289284 */       // GIR_Coverage, 460,
     /* 289284 */       GIR_EraseRootFromParent_Done,
     /* 289285 */     // Label 4820: @289285
     /* 289285 */     GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(289342), // Rule ID 466 //
     /* 289290 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289293 */       // MIs[0] Operand 1
     /* 289293 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289298 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289305 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289312 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289312 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_t16_e64),
     /* 289315 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289317 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289322 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289327 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289332 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289337 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289340 */       GIR_RootConstrainSelectedInstOperands,
     /* 289341 */       // GIR_Coverage, 466,
     /* 289341 */       GIR_EraseRootFromParent_Done,
     /* 289342 */     // Label 4821: @289342
     /* 289342 */     GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(289399), // Rule ID 469 //
     /* 289347 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289350 */       // MIs[0] Operand 1
     /* 289350 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289355 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289362 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289369 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289369 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_t16_e64),
     /* 289372 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289374 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289379 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289384 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289389 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289394 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289397 */       GIR_RootConstrainSelectedInstOperands,
     /* 289398 */       // GIR_Coverage, 469,
     /* 289398 */       GIR_EraseRootFromParent_Done,
     /* 289399 */     // Label 4822: @289399
     /* 289399 */     GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(289456), // Rule ID 475 //
     /* 289404 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289407 */       // MIs[0] Operand 1
     /* 289407 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289412 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289419 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289426 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289426 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_t16_e64),
     /* 289429 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289431 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289436 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289441 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289446 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289451 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289454 */       GIR_RootConstrainSelectedInstOperands,
     /* 289455 */       // GIR_Coverage, 475,
     /* 289455 */       GIR_EraseRootFromParent_Done,
     /* 289456 */     // Label 4823: @289456
     /* 289456 */     GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(289513), // Rule ID 484 //
     /* 289461 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289464 */       // MIs[0] Operand 1
     /* 289464 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 289469 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289476 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289483 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_t16_e64),
     /* 289486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289488 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289493 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289498 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289503 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289508 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289511 */       GIR_RootConstrainSelectedInstOperands,
     /* 289512 */       // GIR_Coverage, 484,
     /* 289512 */       GIR_EraseRootFromParent_Done,
     /* 289513 */     // Label 4824: @289513
     /* 289513 */     GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(289570), // Rule ID 488 //
     /* 289518 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289521 */       // MIs[0] Operand 1
     /* 289521 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289526 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289533 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289540 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289540 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_t16_e64),
     /* 289543 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289545 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289550 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289555 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289560 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289565 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289568 */       GIR_RootConstrainSelectedInstOperands,
     /* 289569 */       // GIR_Coverage, 488,
     /* 289569 */       GIR_EraseRootFromParent_Done,
     /* 289570 */     // Label 4825: @289570
     /* 289570 */     GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(289627), // Rule ID 493 //
     /* 289575 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289578 */       // MIs[0] Operand 1
     /* 289578 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 289583 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289590 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289597 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289597 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_t16_e64),
     /* 289600 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289602 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289607 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289612 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289617 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289622 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289625 */       GIR_RootConstrainSelectedInstOperands,
     /* 289626 */       // GIR_Coverage, 493,
     /* 289626 */       GIR_EraseRootFromParent_Done,
     /* 289627 */     // Label 4826: @289627
     /* 289627 */     GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(289684), // Rule ID 496 //
     /* 289632 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289635 */       // MIs[0] Operand 1
     /* 289635 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289640 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289647 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289654 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289654 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_t16_e64),
     /* 289657 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289659 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289664 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289669 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289674 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289679 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289682 */       GIR_RootConstrainSelectedInstOperands,
     /* 289683 */       // GIR_Coverage, 496,
     /* 289683 */       GIR_EraseRootFromParent_Done,
     /* 289684 */     // Label 4827: @289684
     /* 289684 */     GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(289741), // Rule ID 500 //
     /* 289689 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289692 */       // MIs[0] Operand 1
     /* 289692 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 289697 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289704 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289711 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289711 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_t16_e64),
     /* 289714 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289716 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289721 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289726 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289731 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289736 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289739 */       GIR_RootConstrainSelectedInstOperands,
     /* 289740 */       // GIR_Coverage, 500,
     /* 289740 */       GIR_EraseRootFromParent_Done,
     /* 289741 */     // Label 4828: @289741
     /* 289741 */     GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(289798), // Rule ID 505 //
     /* 289746 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 289749 */       // MIs[0] Operand 1
     /* 289749 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289754 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 289761 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 289768 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 289768 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_t16_e64),
     /* 289771 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289773 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 289778 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 289783 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 289788 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 289793 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289796 */       GIR_RootConstrainSelectedInstOperands,
     /* 289797 */       // GIR_Coverage, 505,
     /* 289797 */       GIR_EraseRootFromParent_Done,
     /* 289798 */     // Label 4829: @289798
     /* 289798 */     GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(289822), // Rule ID 459 //
     /* 289803 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 289806 */       // MIs[0] Operand 1
     /* 289806 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289811 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289811 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_e64),
     /* 289814 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289816 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289818 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289820 */       GIR_RootConstrainSelectedInstOperands,
     /* 289821 */       // GIR_Coverage, 459,
     /* 289821 */       GIR_EraseRootFromParent_Done,
     /* 289822 */     // Label 4830: @289822
     /* 289822 */     GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(289846), // Rule ID 461 //
     /* 289827 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 289830 */       // MIs[0] Operand 1
     /* 289830 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289835 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289835 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_fake16_e64),
     /* 289838 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289840 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289842 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289844 */       GIR_RootConstrainSelectedInstOperands,
     /* 289845 */       // GIR_Coverage, 461,
     /* 289845 */       GIR_EraseRootFromParent_Done,
     /* 289846 */     // Label 4831: @289846
     /* 289846 */     GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(289870), // Rule ID 465 //
     /* 289851 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 289854 */       // MIs[0] Operand 1
     /* 289854 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289859 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289859 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_e64),
     /* 289862 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289864 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289866 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289868 */       GIR_RootConstrainSelectedInstOperands,
     /* 289869 */       // GIR_Coverage, 465,
     /* 289869 */       GIR_EraseRootFromParent_Done,
     /* 289870 */     // Label 4832: @289870
     /* 289870 */     GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(289894), // Rule ID 467 //
     /* 289875 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 289878 */       // MIs[0] Operand 1
     /* 289878 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289883 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289883 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_fake16_e64),
     /* 289886 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289888 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289890 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289892 */       GIR_RootConstrainSelectedInstOperands,
     /* 289893 */       // GIR_Coverage, 467,
     /* 289893 */       GIR_EraseRootFromParent_Done,
     /* 289894 */     // Label 4833: @289894
     /* 289894 */     GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(289918), // Rule ID 468 //
     /* 289899 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 289902 */       // MIs[0] Operand 1
     /* 289902 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289907 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289907 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_e64),
     /* 289910 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289912 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289914 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289916 */       GIR_RootConstrainSelectedInstOperands,
     /* 289917 */       // GIR_Coverage, 468,
     /* 289917 */       GIR_EraseRootFromParent_Done,
     /* 289918 */     // Label 4834: @289918
     /* 289918 */     GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(289942), // Rule ID 470 //
     /* 289923 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 289926 */       // MIs[0] Operand 1
     /* 289926 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289931 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289931 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_fake16_e64),
     /* 289934 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289936 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289938 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289940 */       GIR_RootConstrainSelectedInstOperands,
     /* 289941 */       // GIR_Coverage, 470,
     /* 289941 */       GIR_EraseRootFromParent_Done,
     /* 289942 */     // Label 4835: @289942
     /* 289942 */     GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(289966), // Rule ID 474 //
     /* 289947 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 289950 */       // MIs[0] Operand 1
     /* 289950 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289955 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289955 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_e64),
     /* 289958 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289960 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289962 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289964 */       GIR_RootConstrainSelectedInstOperands,
     /* 289965 */       // GIR_Coverage, 474,
     /* 289965 */       GIR_EraseRootFromParent_Done,
     /* 289966 */     // Label 4836: @289966
     /* 289966 */     GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(289990), // Rule ID 476 //
     /* 289971 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 289974 */       // MIs[0] Operand 1
     /* 289974 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289979 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 289979 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_fake16_e64),
     /* 289982 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 289984 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 289986 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 289988 */       GIR_RootConstrainSelectedInstOperands,
     /* 289989 */       // GIR_Coverage, 476,
     /* 289989 */       GIR_EraseRootFromParent_Done,
     /* 289990 */     // Label 4837: @289990
     /* 289990 */     GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(290014), // Rule ID 483 //
     /* 289995 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 289998 */       // MIs[0] Operand 1
     /* 289998 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290003 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290003 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_e64),
     /* 290006 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290008 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290010 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290012 */       GIR_RootConstrainSelectedInstOperands,
     /* 290013 */       // GIR_Coverage, 483,
     /* 290013 */       GIR_EraseRootFromParent_Done,
     /* 290014 */     // Label 4838: @290014
     /* 290014 */     GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(290038), // Rule ID 485 //
     /* 290019 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 290022 */       // MIs[0] Operand 1
     /* 290022 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290027 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290027 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_fake16_e64),
     /* 290030 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290032 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290034 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290036 */       GIR_RootConstrainSelectedInstOperands,
     /* 290037 */       // GIR_Coverage, 485,
     /* 290037 */       GIR_EraseRootFromParent_Done,
     /* 290038 */     // Label 4839: @290038
     /* 290038 */     GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(290062), // Rule ID 486 //
     /* 290043 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 290046 */       // MIs[0] Operand 1
     /* 290046 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290051 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290051 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_e64),
     /* 290054 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290056 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290058 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290060 */       GIR_RootConstrainSelectedInstOperands,
     /* 290061 */       // GIR_Coverage, 486,
     /* 290061 */       GIR_EraseRootFromParent_Done,
     /* 290062 */     // Label 4840: @290062
     /* 290062 */     GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(290086), // Rule ID 490 //
     /* 290067 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 290070 */       // MIs[0] Operand 1
     /* 290070 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290075 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290075 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_fake16_e64),
     /* 290078 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290080 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290082 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290084 */       GIR_RootConstrainSelectedInstOperands,
     /* 290085 */       // GIR_Coverage, 490,
     /* 290085 */       GIR_EraseRootFromParent_Done,
     /* 290086 */     // Label 4841: @290086
     /* 290086 */     GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(290110), // Rule ID 492 //
     /* 290091 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 290094 */       // MIs[0] Operand 1
     /* 290094 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290099 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_e64),
     /* 290102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290104 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290106 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290108 */       GIR_RootConstrainSelectedInstOperands,
     /* 290109 */       // GIR_Coverage, 492,
     /* 290109 */       GIR_EraseRootFromParent_Done,
     /* 290110 */     // Label 4842: @290110
     /* 290110 */     GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(290134), // Rule ID 494 //
     /* 290115 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 290118 */       // MIs[0] Operand 1
     /* 290118 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290123 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290123 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_fake16_e64),
     /* 290126 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290128 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290130 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290132 */       GIR_RootConstrainSelectedInstOperands,
     /* 290133 */       // GIR_Coverage, 494,
     /* 290133 */       GIR_EraseRootFromParent_Done,
     /* 290134 */     // Label 4843: @290134
     /* 290134 */     GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(290158), // Rule ID 495 //
     /* 290139 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 290142 */       // MIs[0] Operand 1
     /* 290142 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290147 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290147 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_e64),
     /* 290150 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290152 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290154 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290156 */       GIR_RootConstrainSelectedInstOperands,
     /* 290157 */       // GIR_Coverage, 495,
     /* 290157 */       GIR_EraseRootFromParent_Done,
     /* 290158 */     // Label 4844: @290158
     /* 290158 */     GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(290182), // Rule ID 497 //
     /* 290163 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 290166 */       // MIs[0] Operand 1
     /* 290166 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290171 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290171 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_fake16_e64),
     /* 290174 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290176 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290178 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290180 */       GIR_RootConstrainSelectedInstOperands,
     /* 290181 */       // GIR_Coverage, 497,
     /* 290181 */       GIR_EraseRootFromParent_Done,
     /* 290182 */     // Label 4845: @290182
     /* 290182 */     GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(290206), // Rule ID 498 //
     /* 290187 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 290190 */       // MIs[0] Operand 1
     /* 290190 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 290195 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290195 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_e64),
     /* 290198 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290200 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290202 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290204 */       GIR_RootConstrainSelectedInstOperands,
     /* 290205 */       // GIR_Coverage, 498,
     /* 290205 */       GIR_EraseRootFromParent_Done,
     /* 290206 */     // Label 4846: @290206
     /* 290206 */     GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(290230), // Rule ID 502 //
     /* 290211 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 290214 */       // MIs[0] Operand 1
     /* 290214 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 290219 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290219 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_fake16_e64),
     /* 290222 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290224 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290226 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290228 */       GIR_RootConstrainSelectedInstOperands,
     /* 290229 */       // GIR_Coverage, 502,
     /* 290229 */       GIR_EraseRootFromParent_Done,
     /* 290230 */     // Label 4847: @290230
     /* 290230 */     GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(290254), // Rule ID 504 //
     /* 290235 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 290238 */       // MIs[0] Operand 1
     /* 290238 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290243 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290243 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_e64),
     /* 290246 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290248 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290250 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290252 */       GIR_RootConstrainSelectedInstOperands,
     /* 290253 */       // GIR_Coverage, 504,
     /* 290253 */       GIR_EraseRootFromParent_Done,
     /* 290254 */     // Label 4848: @290254
     /* 290254 */     GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(290278), // Rule ID 506 //
     /* 290259 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 290262 */       // MIs[0] Operand 1
     /* 290262 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290267 */       // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 290267 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_fake16_e64),
     /* 290270 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290272 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290274 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290276 */       GIR_RootConstrainSelectedInstOperands,
     /* 290277 */       // GIR_Coverage, 506,
     /* 290277 */       GIR_EraseRootFromParent_Done,
     /* 290278 */     // Label 4849: @290278
     /* 290278 */     GIM_Reject,
     /* 290279 */   // Label 4819: @290279
     /* 290279 */   GIM_Reject,
     /* 290280 */   // Label 4816: @290280
     /* 290280 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(290377),
     /* 290285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 290288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 290292 */     GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(290313), // Rule ID 559 //
     /* 290297 */       // MIs[0] Operand 1
     /* 290297 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290302 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290302 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I32_e64),
     /* 290305 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290307 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290309 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290311 */       GIR_RootConstrainSelectedInstOperands,
     /* 290312 */       // GIR_Coverage, 559,
     /* 290312 */       GIR_EraseRootFromParent_Done,
     /* 290313 */     // Label 4851: @290313
     /* 290313 */     GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(290334), // Rule ID 561 //
     /* 290318 */       // MIs[0] Operand 1
     /* 290318 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290323 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290323 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I32_e64),
     /* 290326 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290328 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290330 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290332 */       GIR_RootConstrainSelectedInstOperands,
     /* 290333 */       // GIR_Coverage, 561,
     /* 290333 */       GIR_EraseRootFromParent_Done,
     /* 290334 */     // Label 4852: @290334
     /* 290334 */     GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(290355), // Rule ID 562 //
     /* 290339 */       // MIs[0] Operand 1
     /* 290339 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290344 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290344 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I32_e64),
     /* 290347 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290349 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290351 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290353 */       GIR_RootConstrainSelectedInstOperands,
     /* 290354 */       // GIR_Coverage, 562,
     /* 290354 */       GIR_EraseRootFromParent_Done,
     /* 290355 */     // Label 4853: @290355
     /* 290355 */     GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(290376), // Rule ID 564 //
     /* 290360 */       // MIs[0] Operand 1
     /* 290360 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290365 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290365 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I32_e64),
     /* 290368 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290370 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290372 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290374 */       GIR_RootConstrainSelectedInstOperands,
     /* 290375 */       // GIR_Coverage, 564,
     /* 290375 */       GIR_EraseRootFromParent_Done,
     /* 290376 */     // Label 4854: @290376
     /* 290376 */     GIM_Reject,
     /* 290377 */   // Label 4850: @290377
     /* 290377 */   GIM_Reject,
     /* 290378 */   // Label 4817: @290378
     /* 290378 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(290475),
     /* 290383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 290386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 290390 */     GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(290411), // Rule ID 575 //
     /* 290395 */       // MIs[0] Operand 1
     /* 290395 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290400 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290400 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I64_e64),
     /* 290403 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290405 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290407 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290409 */       GIR_RootConstrainSelectedInstOperands,
     /* 290410 */       // GIR_Coverage, 575,
     /* 290410 */       GIR_EraseRootFromParent_Done,
     /* 290411 */     // Label 4856: @290411
     /* 290411 */     GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(290432), // Rule ID 577 //
     /* 290416 */       // MIs[0] Operand 1
     /* 290416 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290421 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290421 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I64_e64),
     /* 290424 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290426 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290428 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290430 */       GIR_RootConstrainSelectedInstOperands,
     /* 290431 */       // GIR_Coverage, 577,
     /* 290431 */       GIR_EraseRootFromParent_Done,
     /* 290432 */     // Label 4857: @290432
     /* 290432 */     GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(290453), // Rule ID 578 //
     /* 290437 */       // MIs[0] Operand 1
     /* 290437 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290442 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290442 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I64_e64),
     /* 290445 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290447 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290449 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290451 */       GIR_RootConstrainSelectedInstOperands,
     /* 290452 */       // GIR_Coverage, 578,
     /* 290452 */       GIR_EraseRootFromParent_Done,
     /* 290453 */     // Label 4858: @290453
     /* 290453 */     GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(290474), // Rule ID 580 //
     /* 290458 */       // MIs[0] Operand 1
     /* 290458 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290463 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290463 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I64_e64),
     /* 290466 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290468 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290470 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290472 */       GIR_RootConstrainSelectedInstOperands,
     /* 290473 */       // GIR_Coverage, 580,
     /* 290473 */       GIR_EraseRootFromParent_Done,
     /* 290474 */     // Label 4859: @290474
     /* 290474 */     GIM_Reject,
     /* 290475 */   // Label 4855: @290475
     /* 290475 */   GIM_Reject,
     /* 290476 */   // Label 4818: @290476
     /* 290476 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 4862*/ GIMT_Encode4(290775),
     /* 290487 */   /*GILLT_s32*//*Label 4860*/ GIMT_Encode4(290495),
     /* 290491 */   /*GILLT_s64*//*Label 4861*/ GIMT_Encode4(290635),
     /* 290495 */   // Label 4860: @290495
     /* 290495 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(290634),
     /* 290500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 290503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 290507 */     GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(290528), // Rule ID 591 //
     /* 290512 */       // MIs[0] Operand 1
     /* 290512 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290517 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290517 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U32_e64),
     /* 290520 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290522 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290524 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290526 */       GIR_RootConstrainSelectedInstOperands,
     /* 290527 */       // GIR_Coverage, 591,
     /* 290527 */       GIR_EraseRootFromParent_Done,
     /* 290528 */     // Label 4864: @290528
     /* 290528 */     GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(290549), // Rule ID 592 //
     /* 290533 */       // MIs[0] Operand 1
     /* 290533 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290538 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290538 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
     /* 290541 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290543 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290545 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290547 */       GIR_RootConstrainSelectedInstOperands,
     /* 290548 */       // GIR_Coverage, 592,
     /* 290548 */       GIR_EraseRootFromParent_Done,
     /* 290549 */     // Label 4865: @290549
     /* 290549 */     GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(290570), // Rule ID 594 //
     /* 290554 */       // MIs[0] Operand 1
     /* 290554 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290559 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U32_e64),
     /* 290562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290564 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290566 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290568 */       GIR_RootConstrainSelectedInstOperands,
     /* 290569 */       // GIR_Coverage, 594,
     /* 290569 */       GIR_EraseRootFromParent_Done,
     /* 290570 */     // Label 4866: @290570
     /* 290570 */     GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(290591), // Rule ID 595 //
     /* 290575 */       // MIs[0] Operand 1
     /* 290575 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290580 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290580 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U32_e64),
     /* 290583 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290585 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290587 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290589 */       GIR_RootConstrainSelectedInstOperands,
     /* 290590 */       // GIR_Coverage, 595,
     /* 290590 */       GIR_EraseRootFromParent_Done,
     /* 290591 */     // Label 4867: @290591
     /* 290591 */     GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(290612), // Rule ID 596 //
     /* 290596 */       // MIs[0] Operand 1
     /* 290596 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 290601 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290601 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U32_e64),
     /* 290604 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290606 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290608 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290610 */       GIR_RootConstrainSelectedInstOperands,
     /* 290611 */       // GIR_Coverage, 596,
     /* 290611 */       GIR_EraseRootFromParent_Done,
     /* 290612 */     // Label 4868: @290612
     /* 290612 */     GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(290633), // Rule ID 598 //
     /* 290617 */       // MIs[0] Operand 1
     /* 290617 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290622 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 290622 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U32_e64),
     /* 290625 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290627 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290629 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290631 */       GIR_RootConstrainSelectedInstOperands,
     /* 290632 */       // GIR_Coverage, 598,
     /* 290632 */       GIR_EraseRootFromParent_Done,
     /* 290633 */     // Label 4869: @290633
     /* 290633 */     GIM_Reject,
     /* 290634 */   // Label 4863: @290634
     /* 290634 */   GIM_Reject,
     /* 290635 */   // Label 4861: @290635
     /* 290635 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(290774),
     /* 290640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 290643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 290647 */     GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(290668), // Rule ID 609 //
     /* 290652 */       // MIs[0] Operand 1
     /* 290652 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290657 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290657 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U64_e64),
     /* 290660 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290662 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290664 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290666 */       GIR_RootConstrainSelectedInstOperands,
     /* 290667 */       // GIR_Coverage, 609,
     /* 290667 */       GIR_EraseRootFromParent_Done,
     /* 290668 */     // Label 4871: @290668
     /* 290668 */     GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(290689), // Rule ID 610 //
     /* 290673 */       // MIs[0] Operand 1
     /* 290673 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290678 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290678 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U64_e64),
     /* 290681 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290683 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290685 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290687 */       GIR_RootConstrainSelectedInstOperands,
     /* 290688 */       // GIR_Coverage, 610,
     /* 290688 */       GIR_EraseRootFromParent_Done,
     /* 290689 */     // Label 4872: @290689
     /* 290689 */     GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(290710), // Rule ID 612 //
     /* 290694 */       // MIs[0] Operand 1
     /* 290694 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290699 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U64_e64),
     /* 290702 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290704 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290706 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290708 */       GIR_RootConstrainSelectedInstOperands,
     /* 290709 */       // GIR_Coverage, 612,
     /* 290709 */       GIR_EraseRootFromParent_Done,
     /* 290710 */     // Label 4873: @290710
     /* 290710 */     GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(290731), // Rule ID 613 //
     /* 290715 */       // MIs[0] Operand 1
     /* 290715 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290720 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290720 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U64_e64),
     /* 290723 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290725 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290727 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290729 */       GIR_RootConstrainSelectedInstOperands,
     /* 290730 */       // GIR_Coverage, 613,
     /* 290730 */       GIR_EraseRootFromParent_Done,
     /* 290731 */     // Label 4874: @290731
     /* 290731 */     GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(290752), // Rule ID 614 //
     /* 290736 */       // MIs[0] Operand 1
     /* 290736 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 290741 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290741 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U64_e64),
     /* 290744 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290746 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290748 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290750 */       GIR_RootConstrainSelectedInstOperands,
     /* 290751 */       // GIR_Coverage, 614,
     /* 290751 */       GIR_EraseRootFromParent_Done,
     /* 290752 */     // Label 4875: @290752
     /* 290752 */     GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(290773), // Rule ID 616 //
     /* 290757 */       // MIs[0] Operand 1
     /* 290757 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290762 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
     /* 290762 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U64_e64),
     /* 290765 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290767 */       GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 290769 */       GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 290771 */       GIR_RootConstrainSelectedInstOperands,
     /* 290772 */       // GIR_Coverage, 616,
     /* 290772 */       GIR_EraseRootFromParent_Done,
     /* 290773 */     // Label 4876: @290773
     /* 290773 */     GIM_Reject,
     /* 290774 */   // Label 4870: @290774
     /* 290774 */   GIM_Reject,
     /* 290775 */   // Label 4862: @290775
     /* 290775 */   GIM_Reject,
     /* 290776 */ // Label 4814: @290776
     /* 290776 */ GIM_Reject,
     /* 290777 */ // Label 52: @290777
     /* 290777 */ GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(294939),
     /* 290782 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 290785 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4881*/ GIMT_Encode4(294938),
     /* 290796 */   /*GILLT_s16*//*Label 4878*/ GIMT_Encode4(290808),
     /* 290800 */   /*GILLT_s32*//*Label 4879*/ GIMT_Encode4(293342),
     /* 290804 */   /*GILLT_s64*//*Label 4880*/ GIMT_Encode4(294140),
     /* 290808 */   // Label 4878: @290808
     /* 290808 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(293341),
     /* 290813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 290816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 290820 */     GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(290879), // Rule ID 345 //
     /* 290825 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 290828 */       // MIs[0] Operand 1
     /* 290828 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 290833 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290840 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290847 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290847 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_e64),
     /* 290850 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290852 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290857 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290862 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290867 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290872 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290877 */       GIR_RootConstrainSelectedInstOperands,
     /* 290878 */       // GIR_Coverage, 345,
     /* 290878 */       GIR_EraseRootFromParent_Done,
     /* 290879 */     // Label 4883: @290879
     /* 290879 */     GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(290941), // Rule ID 347 //
     /* 290884 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 290887 */       // MIs[0] Operand 1
     /* 290887 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 290892 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290899 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290906 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290906 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_t16_e64),
     /* 290909 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290911 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290916 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290921 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290926 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290931 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290936 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 290939 */       GIR_RootConstrainSelectedInstOperands,
     /* 290940 */       // GIR_Coverage, 347,
     /* 290940 */       GIR_EraseRootFromParent_Done,
     /* 290941 */     // Label 4884: @290941
     /* 290941 */     GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(291000), // Rule ID 349 //
     /* 290946 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 290949 */       // MIs[0] Operand 1
     /* 290949 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 290954 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 290961 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 290968 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 290968 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_fake16_e64),
     /* 290971 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 290973 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 290978 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 290983 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 290988 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 290993 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 290998 */       GIR_RootConstrainSelectedInstOperands,
     /* 290999 */       // GIR_Coverage, 349,
     /* 290999 */       GIR_EraseRootFromParent_Done,
     /* 291000 */     // Label 4885: @291000
     /* 291000 */     GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(291059), // Rule ID 351 //
     /* 291005 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 291008 */       // MIs[0] Operand 1
     /* 291008 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 291013 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291020 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291027 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291027 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 291030 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291032 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291037 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291042 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291047 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291052 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291057 */       GIR_RootConstrainSelectedInstOperands,
     /* 291058 */       // GIR_Coverage, 351,
     /* 291058 */       GIR_EraseRootFromParent_Done,
     /* 291059 */     // Label 4886: @291059
     /* 291059 */     GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(291121), // Rule ID 353 //
     /* 291064 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 291067 */       // MIs[0] Operand 1
     /* 291067 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 291072 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291079 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291086 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291086 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 291089 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291091 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291096 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291101 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291106 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291111 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291116 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291119 */       GIR_RootConstrainSelectedInstOperands,
     /* 291120 */       // GIR_Coverage, 353,
     /* 291120 */       GIR_EraseRootFromParent_Done,
     /* 291121 */     // Label 4887: @291121
     /* 291121 */     GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(291180), // Rule ID 355 //
     /* 291126 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 291129 */       // MIs[0] Operand 1
     /* 291129 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 291134 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291141 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291148 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291148 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 291151 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291153 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291158 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291163 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291168 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291173 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291178 */       GIR_RootConstrainSelectedInstOperands,
     /* 291179 */       // GIR_Coverage, 355,
     /* 291179 */       GIR_EraseRootFromParent_Done,
     /* 291180 */     // Label 4888: @291180
     /* 291180 */     GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(291239), // Rule ID 357 //
     /* 291185 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 291188 */       // MIs[0] Operand 1
     /* 291188 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 291193 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291200 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291207 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291207 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_e64),
     /* 291210 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291212 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291217 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291222 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291227 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291232 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291237 */       GIR_RootConstrainSelectedInstOperands,
     /* 291238 */       // GIR_Coverage, 357,
     /* 291238 */       GIR_EraseRootFromParent_Done,
     /* 291239 */     // Label 4889: @291239
     /* 291239 */     GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(291301), // Rule ID 359 //
     /* 291244 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 291247 */       // MIs[0] Operand 1
     /* 291247 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 291252 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291259 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291266 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291266 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_t16_e64),
     /* 291269 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291271 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291276 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291281 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291286 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291291 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291296 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291299 */       GIR_RootConstrainSelectedInstOperands,
     /* 291300 */       // GIR_Coverage, 359,
     /* 291300 */       GIR_EraseRootFromParent_Done,
     /* 291301 */     // Label 4890: @291301
     /* 291301 */     GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(291360), // Rule ID 361 //
     /* 291306 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 291309 */       // MIs[0] Operand 1
     /* 291309 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 291314 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291321 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291328 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291328 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_fake16_e64),
     /* 291331 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291333 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291338 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291343 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291348 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291353 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291358 */       GIR_RootConstrainSelectedInstOperands,
     /* 291359 */       // GIR_Coverage, 361,
     /* 291359 */       GIR_EraseRootFromParent_Done,
     /* 291360 */     // Label 4891: @291360
     /* 291360 */     GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(291419), // Rule ID 363 //
     /* 291365 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 291368 */       // MIs[0] Operand 1
     /* 291368 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 291373 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291380 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291387 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291387 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_e64),
     /* 291390 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291392 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291397 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291402 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291407 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291412 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291417 */       GIR_RootConstrainSelectedInstOperands,
     /* 291418 */       // GIR_Coverage, 363,
     /* 291418 */       GIR_EraseRootFromParent_Done,
     /* 291419 */     // Label 4892: @291419
     /* 291419 */     GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(291481), // Rule ID 365 //
     /* 291424 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 291427 */       // MIs[0] Operand 1
     /* 291427 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 291432 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291439 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291446 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291446 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_t16_e64),
     /* 291449 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291451 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291456 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291461 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291466 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291471 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291476 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291479 */       GIR_RootConstrainSelectedInstOperands,
     /* 291480 */       // GIR_Coverage, 365,
     /* 291480 */       GIR_EraseRootFromParent_Done,
     /* 291481 */     // Label 4893: @291481
     /* 291481 */     GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(291540), // Rule ID 367 //
     /* 291486 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 291489 */       // MIs[0] Operand 1
     /* 291489 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 291494 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291501 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291508 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291508 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_fake16_e64),
     /* 291511 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291513 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291518 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291523 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291528 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291533 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291538 */       GIR_RootConstrainSelectedInstOperands,
     /* 291539 */       // GIR_Coverage, 367,
     /* 291539 */       GIR_EraseRootFromParent_Done,
     /* 291540 */     // Label 4894: @291540
     /* 291540 */     GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(291599), // Rule ID 369 //
     /* 291545 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 291548 */       // MIs[0] Operand 1
     /* 291548 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 291553 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291560 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291567 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291567 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_e64),
     /* 291570 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291572 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291577 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291582 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291587 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291592 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291597 */       GIR_RootConstrainSelectedInstOperands,
     /* 291598 */       // GIR_Coverage, 369,
     /* 291598 */       GIR_EraseRootFromParent_Done,
     /* 291599 */     // Label 4895: @291599
     /* 291599 */     GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(291661), // Rule ID 371 //
     /* 291604 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 291607 */       // MIs[0] Operand 1
     /* 291607 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 291612 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291619 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291626 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291626 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_t16_e64),
     /* 291629 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291631 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291636 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291641 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291646 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291651 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291656 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291659 */       GIR_RootConstrainSelectedInstOperands,
     /* 291660 */       // GIR_Coverage, 371,
     /* 291660 */       GIR_EraseRootFromParent_Done,
     /* 291661 */     // Label 4896: @291661
     /* 291661 */     GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(291720), // Rule ID 373 //
     /* 291666 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 291669 */       // MIs[0] Operand 1
     /* 291669 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 291674 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291681 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291688 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291688 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_fake16_e64),
     /* 291691 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291693 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291698 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291703 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291708 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291713 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291718 */       GIR_RootConstrainSelectedInstOperands,
     /* 291719 */       // GIR_Coverage, 373,
     /* 291719 */       GIR_EraseRootFromParent_Done,
     /* 291720 */     // Label 4897: @291720
     /* 291720 */     GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(291779), // Rule ID 375 //
     /* 291725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 291728 */       // MIs[0] Operand 1
     /* 291728 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 291733 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291740 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291747 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291747 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_e64),
     /* 291750 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291752 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291757 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291762 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291767 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291772 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291777 */       GIR_RootConstrainSelectedInstOperands,
     /* 291778 */       // GIR_Coverage, 375,
     /* 291778 */       GIR_EraseRootFromParent_Done,
     /* 291779 */     // Label 4898: @291779
     /* 291779 */     GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(291841), // Rule ID 377 //
     /* 291784 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 291787 */       // MIs[0] Operand 1
     /* 291787 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 291792 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291799 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291806 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_t16_e64),
     /* 291809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291811 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291816 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291821 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291826 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291831 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291836 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 291839 */       GIR_RootConstrainSelectedInstOperands,
     /* 291840 */       // GIR_Coverage, 377,
     /* 291840 */       GIR_EraseRootFromParent_Done,
     /* 291841 */     // Label 4899: @291841
     /* 291841 */     GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(291900), // Rule ID 379 //
     /* 291846 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 291849 */       // MIs[0] Operand 1
     /* 291849 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 291854 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291861 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291868 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_fake16_e64),
     /* 291871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291873 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291878 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291883 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291888 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291893 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291898 */       GIR_RootConstrainSelectedInstOperands,
     /* 291899 */       // GIR_Coverage, 379,
     /* 291899 */       GIR_EraseRootFromParent_Done,
     /* 291900 */     // Label 4900: @291900
     /* 291900 */     GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(291959), // Rule ID 381 //
     /* 291905 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 291908 */       // MIs[0] Operand 1
     /* 291908 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 291913 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291920 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291927 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291927 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_e64),
     /* 291930 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291932 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291937 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 291942 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 291947 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 291952 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 291957 */       GIR_RootConstrainSelectedInstOperands,
     /* 291958 */       // GIR_Coverage, 381,
     /* 291958 */       GIR_EraseRootFromParent_Done,
     /* 291959 */     // Label 4901: @291959
     /* 291959 */     GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(292021), // Rule ID 382 //
     /* 291964 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 291967 */       // MIs[0] Operand 1
     /* 291967 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 291972 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 291979 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 291986 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 291986 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_t16_e64),
     /* 291989 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 291991 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 291996 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292001 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292006 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292011 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292016 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292019 */       GIR_RootConstrainSelectedInstOperands,
     /* 292020 */       // GIR_Coverage, 382,
     /* 292020 */       GIR_EraseRootFromParent_Done,
     /* 292021 */     // Label 4902: @292021
     /* 292021 */     GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(292080), // Rule ID 383 //
     /* 292026 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 292029 */       // MIs[0] Operand 1
     /* 292029 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 292034 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292041 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292048 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292048 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_fake16_e64),
     /* 292051 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292053 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292058 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292063 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292068 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292073 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292078 */       GIR_RootConstrainSelectedInstOperands,
     /* 292079 */       // GIR_Coverage, 383,
     /* 292079 */       GIR_EraseRootFromParent_Done,
     /* 292080 */     // Label 4903: @292080
     /* 292080 */     GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(292139), // Rule ID 384 //
     /* 292085 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292088 */       // MIs[0] Operand 1
     /* 292088 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 292093 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292100 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292107 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292107 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_e64),
     /* 292110 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292112 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292117 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292122 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292127 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292132 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292137 */       GIR_RootConstrainSelectedInstOperands,
     /* 292138 */       // GIR_Coverage, 384,
     /* 292138 */       GIR_EraseRootFromParent_Done,
     /* 292139 */     // Label 4904: @292139
     /* 292139 */     GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(292201), // Rule ID 385 //
     /* 292144 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 292147 */       // MIs[0] Operand 1
     /* 292147 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 292152 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292159 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292166 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292166 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_t16_e64),
     /* 292169 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292171 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292176 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292181 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292186 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292191 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292196 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292199 */       GIR_RootConstrainSelectedInstOperands,
     /* 292200 */       // GIR_Coverage, 385,
     /* 292200 */       GIR_EraseRootFromParent_Done,
     /* 292201 */     // Label 4905: @292201
     /* 292201 */     GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(292260), // Rule ID 386 //
     /* 292206 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 292209 */       // MIs[0] Operand 1
     /* 292209 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 292214 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292221 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292228 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292228 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_fake16_e64),
     /* 292231 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292233 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292238 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292243 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292248 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292253 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292258 */       GIR_RootConstrainSelectedInstOperands,
     /* 292259 */       // GIR_Coverage, 386,
     /* 292259 */       GIR_EraseRootFromParent_Done,
     /* 292260 */     // Label 4906: @292260
     /* 292260 */     GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(292319), // Rule ID 387 //
     /* 292265 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292268 */       // MIs[0] Operand 1
     /* 292268 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 292273 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292280 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292287 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292287 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_e64),
     /* 292290 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292292 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292297 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292302 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292307 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292312 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292317 */       GIR_RootConstrainSelectedInstOperands,
     /* 292318 */       // GIR_Coverage, 387,
     /* 292318 */       GIR_EraseRootFromParent_Done,
     /* 292319 */     // Label 4907: @292319
     /* 292319 */     GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(292381), // Rule ID 388 //
     /* 292324 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 292327 */       // MIs[0] Operand 1
     /* 292327 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 292332 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292339 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292346 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292346 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_t16_e64),
     /* 292349 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292351 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292356 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292361 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292366 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292371 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292376 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292379 */       GIR_RootConstrainSelectedInstOperands,
     /* 292380 */       // GIR_Coverage, 388,
     /* 292380 */       GIR_EraseRootFromParent_Done,
     /* 292381 */     // Label 4908: @292381
     /* 292381 */     GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(292440), // Rule ID 389 //
     /* 292386 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 292389 */       // MIs[0] Operand 1
     /* 292389 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 292394 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292401 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292408 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292408 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_fake16_e64),
     /* 292411 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292413 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292418 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292423 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292428 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292433 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292438 */       GIR_RootConstrainSelectedInstOperands,
     /* 292439 */       // GIR_Coverage, 389,
     /* 292439 */       GIR_EraseRootFromParent_Done,
     /* 292440 */     // Label 4909: @292440
     /* 292440 */     GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(292499), // Rule ID 390 //
     /* 292445 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292448 */       // MIs[0] Operand 1
     /* 292448 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 292453 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292460 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292467 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292467 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_e64),
     /* 292470 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292472 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292477 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292482 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292487 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292492 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292497 */       GIR_RootConstrainSelectedInstOperands,
     /* 292498 */       // GIR_Coverage, 390,
     /* 292498 */       GIR_EraseRootFromParent_Done,
     /* 292499 */     // Label 4910: @292499
     /* 292499 */     GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(292561), // Rule ID 391 //
     /* 292504 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 292507 */       // MIs[0] Operand 1
     /* 292507 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 292512 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292519 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292526 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292526 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_t16_e64),
     /* 292529 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292531 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292536 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292541 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292546 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292551 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292556 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292559 */       GIR_RootConstrainSelectedInstOperands,
     /* 292560 */       // GIR_Coverage, 391,
     /* 292560 */       GIR_EraseRootFromParent_Done,
     /* 292561 */     // Label 4911: @292561
     /* 292561 */     GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(292620), // Rule ID 392 //
     /* 292566 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 292569 */       // MIs[0] Operand 1
     /* 292569 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 292574 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292581 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292588 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292588 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_fake16_e64),
     /* 292591 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292593 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292598 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292603 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292608 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292613 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292618 */       GIR_RootConstrainSelectedInstOperands,
     /* 292619 */       // GIR_Coverage, 392,
     /* 292619 */       GIR_EraseRootFromParent_Done,
     /* 292620 */     // Label 4912: @292620
     /* 292620 */     GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(292679), // Rule ID 393 //
     /* 292625 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292628 */       // MIs[0] Operand 1
     /* 292628 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 292633 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292640 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292647 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292647 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_e64),
     /* 292650 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292652 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292657 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292662 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292667 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292672 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292677 */       GIR_RootConstrainSelectedInstOperands,
     /* 292678 */       // GIR_Coverage, 393,
     /* 292678 */       GIR_EraseRootFromParent_Done,
     /* 292679 */     // Label 4913: @292679
     /* 292679 */     GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(292741), // Rule ID 394 //
     /* 292684 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 292687 */       // MIs[0] Operand 1
     /* 292687 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 292692 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292699 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292706 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292706 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_t16_e64),
     /* 292709 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292711 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292716 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292721 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292726 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292731 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292736 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292739 */       GIR_RootConstrainSelectedInstOperands,
     /* 292740 */       // GIR_Coverage, 394,
     /* 292740 */       GIR_EraseRootFromParent_Done,
     /* 292741 */     // Label 4914: @292741
     /* 292741 */     GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(292800), // Rule ID 395 //
     /* 292746 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 292749 */       // MIs[0] Operand 1
     /* 292749 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 292754 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292761 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292768 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292768 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_fake16_e64),
     /* 292771 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292773 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292778 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292783 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292788 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292793 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292798 */       GIR_RootConstrainSelectedInstOperands,
     /* 292799 */       // GIR_Coverage, 395,
     /* 292799 */       GIR_EraseRootFromParent_Done,
     /* 292800 */     // Label 4915: @292800
     /* 292800 */     GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(292859), // Rule ID 396 //
     /* 292805 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292808 */       // MIs[0] Operand 1
     /* 292808 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 292813 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292820 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292827 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292827 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_e64),
     /* 292830 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292832 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292837 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292842 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292847 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292852 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292857 */       GIR_RootConstrainSelectedInstOperands,
     /* 292858 */       // GIR_Coverage, 396,
     /* 292858 */       GIR_EraseRootFromParent_Done,
     /* 292859 */     // Label 4916: @292859
     /* 292859 */     GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(292921), // Rule ID 397 //
     /* 292864 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 292867 */       // MIs[0] Operand 1
     /* 292867 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 292872 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292879 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292886 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292886 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_t16_e64),
     /* 292889 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292891 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292896 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292901 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292906 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292911 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292916 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 292919 */       GIR_RootConstrainSelectedInstOperands,
     /* 292920 */       // GIR_Coverage, 397,
     /* 292920 */       GIR_EraseRootFromParent_Done,
     /* 292921 */     // Label 4917: @292921
     /* 292921 */     GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(292980), // Rule ID 398 //
     /* 292926 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 292929 */       // MIs[0] Operand 1
     /* 292929 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 292934 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 292941 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 292948 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 292948 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_fake16_e64),
     /* 292951 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 292953 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 292958 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 292963 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 292968 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 292973 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 292978 */       GIR_RootConstrainSelectedInstOperands,
     /* 292979 */       // GIR_Coverage, 398,
     /* 292979 */       GIR_EraseRootFromParent_Done,
     /* 292980 */     // Label 4918: @292980
     /* 292980 */     GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(293039), // Rule ID 399 //
     /* 292985 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 292988 */       // MIs[0] Operand 1
     /* 292988 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 292993 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293000 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293007 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293007 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_e64),
     /* 293010 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293012 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293017 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293022 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293027 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293032 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293037 */       GIR_RootConstrainSelectedInstOperands,
     /* 293038 */       // GIR_Coverage, 399,
     /* 293038 */       GIR_EraseRootFromParent_Done,
     /* 293039 */     // Label 4919: @293039
     /* 293039 */     GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(293101), // Rule ID 400 //
     /* 293044 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 293047 */       // MIs[0] Operand 1
     /* 293047 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 293052 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293059 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293066 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293066 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_t16_e64),
     /* 293069 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293071 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293076 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293081 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293086 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293091 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293096 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293099 */       GIR_RootConstrainSelectedInstOperands,
     /* 293100 */       // GIR_Coverage, 400,
     /* 293100 */       GIR_EraseRootFromParent_Done,
     /* 293101 */     // Label 4920: @293101
     /* 293101 */     GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(293160), // Rule ID 401 //
     /* 293106 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 293109 */       // MIs[0] Operand 1
     /* 293109 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 293114 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293121 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293128 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293128 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_fake16_e64),
     /* 293131 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293133 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293138 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293143 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293148 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293153 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293158 */       GIR_RootConstrainSelectedInstOperands,
     /* 293159 */       // GIR_Coverage, 401,
     /* 293159 */       GIR_EraseRootFromParent_Done,
     /* 293160 */     // Label 4921: @293160
     /* 293160 */     GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(293219), // Rule ID 402 //
     /* 293165 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 293168 */       // MIs[0] Operand 1
     /* 293168 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 293173 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293180 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293187 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293187 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_e64),
     /* 293190 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293192 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293197 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293202 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293207 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293212 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293217 */       GIR_RootConstrainSelectedInstOperands,
     /* 293218 */       // GIR_Coverage, 402,
     /* 293218 */       GIR_EraseRootFromParent_Done,
     /* 293219 */     // Label 4922: @293219
     /* 293219 */     GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(293281), // Rule ID 403 //
     /* 293224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
     /* 293227 */       // MIs[0] Operand 1
     /* 293227 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 293232 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293239 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293246 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293246 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_t16_e64),
     /* 293249 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293251 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293256 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293261 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293266 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293271 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293276 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 293279 */       GIR_RootConstrainSelectedInstOperands,
     /* 293280 */       // GIR_Coverage, 403,
     /* 293280 */       GIR_EraseRootFromParent_Done,
     /* 293281 */     // Label 4923: @293281
     /* 293281 */     GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(293340), // Rule ID 404 //
     /* 293286 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
     /* 293289 */       // MIs[0] Operand 1
     /* 293289 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 293294 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293301 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293308 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293308 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_fake16_e64),
     /* 293311 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293313 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293318 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293323 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293328 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293333 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293338 */       GIR_RootConstrainSelectedInstOperands,
     /* 293339 */       // GIR_Coverage, 404,
     /* 293339 */       GIR_EraseRootFromParent_Done,
     /* 293340 */     // Label 4924: @293340
     /* 293340 */     GIM_Reject,
     /* 293341 */   // Label 4882: @293341
     /* 293341 */   GIM_Reject,
     /* 293342 */   // Label 4879: @293342
     /* 293342 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(294139),
     /* 293347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 293350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 293354 */     GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(293410), // Rule ID 203 //
     /* 293359 */       // MIs[0] Operand 1
     /* 293359 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 293364 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293371 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293378 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293378 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F32_e64),
     /* 293381 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293383 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293388 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293393 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293398 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293403 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293408 */       GIR_RootConstrainSelectedInstOperands,
     /* 293409 */       // GIR_Coverage, 203,
     /* 293409 */       GIR_EraseRootFromParent_Done,
     /* 293410 */     // Label 4926: @293410
     /* 293410 */     GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(293466), // Rule ID 205 //
     /* 293415 */       // MIs[0] Operand 1
     /* 293415 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 293420 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293427 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293434 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293434 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 293437 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293439 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293444 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293449 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293454 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293459 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293464 */       GIR_RootConstrainSelectedInstOperands,
     /* 293465 */       // GIR_Coverage, 205,
     /* 293465 */       GIR_EraseRootFromParent_Done,
     /* 293466 */     // Label 4927: @293466
     /* 293466 */     GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(293522), // Rule ID 207 //
     /* 293471 */       // MIs[0] Operand 1
     /* 293471 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 293476 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293483 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293490 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293490 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F32_e64),
     /* 293493 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293495 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293500 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293505 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293510 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293515 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293520 */       GIR_RootConstrainSelectedInstOperands,
     /* 293521 */       // GIR_Coverage, 207,
     /* 293521 */       GIR_EraseRootFromParent_Done,
     /* 293522 */     // Label 4928: @293522
     /* 293522 */     GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(293578), // Rule ID 209 //
     /* 293527 */       // MIs[0] Operand 1
     /* 293527 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 293532 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293539 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293546 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293546 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F32_e64),
     /* 293549 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293551 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293556 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293561 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293566 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293571 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293576 */       GIR_RootConstrainSelectedInstOperands,
     /* 293577 */       // GIR_Coverage, 209,
     /* 293577 */       GIR_EraseRootFromParent_Done,
     /* 293578 */     // Label 4929: @293578
     /* 293578 */     GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(293634), // Rule ID 211 //
     /* 293583 */       // MIs[0] Operand 1
     /* 293583 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 293588 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293595 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293602 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293602 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F32_e64),
     /* 293605 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293607 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293612 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293617 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293622 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293627 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293632 */       GIR_RootConstrainSelectedInstOperands,
     /* 293633 */       // GIR_Coverage, 211,
     /* 293633 */       GIR_EraseRootFromParent_Done,
     /* 293634 */     // Label 4930: @293634
     /* 293634 */     GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(293690), // Rule ID 213 //
     /* 293639 */       // MIs[0] Operand 1
     /* 293639 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 293644 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293651 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293658 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293658 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F32_e64),
     /* 293661 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293663 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293668 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293673 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293678 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293683 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293688 */       GIR_RootConstrainSelectedInstOperands,
     /* 293689 */       // GIR_Coverage, 213,
     /* 293689 */       GIR_EraseRootFromParent_Done,
     /* 293690 */     // Label 4931: @293690
     /* 293690 */     GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(293746), // Rule ID 215 //
     /* 293695 */       // MIs[0] Operand 1
     /* 293695 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 293700 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293707 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293714 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293714 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F32_e64),
     /* 293717 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293719 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293724 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293729 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293734 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293739 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293744 */       GIR_RootConstrainSelectedInstOperands,
     /* 293745 */       // GIR_Coverage, 215,
     /* 293745 */       GIR_EraseRootFromParent_Done,
     /* 293746 */     // Label 4932: @293746
     /* 293746 */     GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(293802), // Rule ID 216 //
     /* 293751 */       // MIs[0] Operand 1
     /* 293751 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 293756 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293763 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293770 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293770 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F32_e64),
     /* 293773 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293775 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293780 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293785 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293790 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293795 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293800 */       GIR_RootConstrainSelectedInstOperands,
     /* 293801 */       // GIR_Coverage, 216,
     /* 293801 */       GIR_EraseRootFromParent_Done,
     /* 293802 */     // Label 4933: @293802
     /* 293802 */     GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(293858), // Rule ID 217 //
     /* 293807 */       // MIs[0] Operand 1
     /* 293807 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 293812 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293819 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293826 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293826 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F32_e64),
     /* 293829 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293831 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293836 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293841 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293846 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293851 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293856 */       GIR_RootConstrainSelectedInstOperands,
     /* 293857 */       // GIR_Coverage, 217,
     /* 293857 */       GIR_EraseRootFromParent_Done,
     /* 293858 */     // Label 4934: @293858
     /* 293858 */     GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(293914), // Rule ID 218 //
     /* 293863 */       // MIs[0] Operand 1
     /* 293863 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 293868 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293875 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293882 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293882 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F32_e64),
     /* 293885 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293887 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293892 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293897 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293902 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293907 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293912 */       GIR_RootConstrainSelectedInstOperands,
     /* 293913 */       // GIR_Coverage, 218,
     /* 293913 */       GIR_EraseRootFromParent_Done,
     /* 293914 */     // Label 4935: @293914
     /* 293914 */     GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(293970), // Rule ID 219 //
     /* 293919 */       // MIs[0] Operand 1
     /* 293919 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 293924 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293931 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293938 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293938 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F32_e64),
     /* 293941 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293943 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 293948 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 293953 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 293958 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 293963 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 293968 */       GIR_RootConstrainSelectedInstOperands,
     /* 293969 */       // GIR_Coverage, 219,
     /* 293969 */       GIR_EraseRootFromParent_Done,
     /* 293970 */     // Label 4936: @293970
     /* 293970 */     GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(294026), // Rule ID 220 //
     /* 293975 */       // MIs[0] Operand 1
     /* 293975 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 293980 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 293987 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 293994 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 293994 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F32_e64),
     /* 293997 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 293999 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294004 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294009 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294014 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294019 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294024 */       GIR_RootConstrainSelectedInstOperands,
     /* 294025 */       // GIR_Coverage, 220,
     /* 294025 */       GIR_EraseRootFromParent_Done,
     /* 294026 */     // Label 4937: @294026
     /* 294026 */     GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(294082), // Rule ID 221 //
     /* 294031 */       // MIs[0] Operand 1
     /* 294031 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 294036 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294043 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294050 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294050 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F32_e64),
     /* 294053 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294055 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294060 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294065 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294070 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294075 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294080 */       GIR_RootConstrainSelectedInstOperands,
     /* 294081 */       // GIR_Coverage, 221,
     /* 294081 */       GIR_EraseRootFromParent_Done,
     /* 294082 */     // Label 4938: @294082
     /* 294082 */     GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(294138), // Rule ID 222 //
     /* 294087 */       // MIs[0] Operand 1
     /* 294087 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 294092 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294099 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294106 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294106 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F32_e64),
     /* 294109 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294111 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294116 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294121 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294126 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294131 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294136 */       GIR_RootConstrainSelectedInstOperands,
     /* 294137 */       // GIR_Coverage, 222,
     /* 294137 */       GIR_EraseRootFromParent_Done,
     /* 294138 */     // Label 4939: @294138
     /* 294138 */     GIM_Reject,
     /* 294139 */   // Label 4925: @294139
     /* 294139 */   GIM_Reject,
     /* 294140 */   // Label 4880: @294140
     /* 294140 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(294937),
     /* 294145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 294148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 294152 */     GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(294208), // Rule ID 241 //
     /* 294157 */       // MIs[0] Operand 1
     /* 294157 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 294162 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294169 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294176 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294176 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F64_e64),
     /* 294179 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294181 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294186 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294191 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294196 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294201 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294206 */       GIR_RootConstrainSelectedInstOperands,
     /* 294207 */       // GIR_Coverage, 241,
     /* 294207 */       GIR_EraseRootFromParent_Done,
     /* 294208 */     // Label 4941: @294208
     /* 294208 */     GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(294264), // Rule ID 243 //
     /* 294213 */       // MIs[0] Operand 1
     /* 294213 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 294218 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294225 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294232 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294232 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 294235 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294237 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294242 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294247 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294252 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294257 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294262 */       GIR_RootConstrainSelectedInstOperands,
     /* 294263 */       // GIR_Coverage, 243,
     /* 294263 */       GIR_EraseRootFromParent_Done,
     /* 294264 */     // Label 4942: @294264
     /* 294264 */     GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(294320), // Rule ID 245 //
     /* 294269 */       // MIs[0] Operand 1
     /* 294269 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 294274 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294281 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294288 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294288 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F64_e64),
     /* 294291 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294293 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294298 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294303 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294308 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294313 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294318 */       GIR_RootConstrainSelectedInstOperands,
     /* 294319 */       // GIR_Coverage, 245,
     /* 294319 */       GIR_EraseRootFromParent_Done,
     /* 294320 */     // Label 4943: @294320
     /* 294320 */     GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(294376), // Rule ID 247 //
     /* 294325 */       // MIs[0] Operand 1
     /* 294325 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 294330 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294337 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294344 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294344 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F64_e64),
     /* 294347 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294349 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294354 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294359 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294364 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294369 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294374 */       GIR_RootConstrainSelectedInstOperands,
     /* 294375 */       // GIR_Coverage, 247,
     /* 294375 */       GIR_EraseRootFromParent_Done,
     /* 294376 */     // Label 4944: @294376
     /* 294376 */     GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(294432), // Rule ID 249 //
     /* 294381 */       // MIs[0] Operand 1
     /* 294381 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 294386 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294393 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294400 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294400 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F64_e64),
     /* 294403 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294405 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294410 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294415 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294420 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294425 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294430 */       GIR_RootConstrainSelectedInstOperands,
     /* 294431 */       // GIR_Coverage, 249,
     /* 294431 */       GIR_EraseRootFromParent_Done,
     /* 294432 */     // Label 4945: @294432
     /* 294432 */     GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(294488), // Rule ID 251 //
     /* 294437 */       // MIs[0] Operand 1
     /* 294437 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
     /* 294442 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294449 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294456 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294456 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F64_e64),
     /* 294459 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294461 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294466 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294471 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294476 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294481 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294486 */       GIR_RootConstrainSelectedInstOperands,
     /* 294487 */       // GIR_Coverage, 251,
     /* 294487 */       GIR_EraseRootFromParent_Done,
     /* 294488 */     // Label 4946: @294488
     /* 294488 */     GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(294544), // Rule ID 253 //
     /* 294493 */       // MIs[0] Operand 1
     /* 294493 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 294498 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294505 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294512 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294512 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F64_e64),
     /* 294515 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294517 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294522 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294527 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294532 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294537 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294542 */       GIR_RootConstrainSelectedInstOperands,
     /* 294543 */       // GIR_Coverage, 253,
     /* 294543 */       GIR_EraseRootFromParent_Done,
     /* 294544 */     // Label 4947: @294544
     /* 294544 */     GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(294600), // Rule ID 254 //
     /* 294549 */       // MIs[0] Operand 1
     /* 294549 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 294554 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294561 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294568 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294568 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F64_e64),
     /* 294571 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294573 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294578 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294583 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294588 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294593 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294598 */       GIR_RootConstrainSelectedInstOperands,
     /* 294599 */       // GIR_Coverage, 254,
     /* 294599 */       GIR_EraseRootFromParent_Done,
     /* 294600 */     // Label 4948: @294600
     /* 294600 */     GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(294656), // Rule ID 255 //
     /* 294605 */       // MIs[0] Operand 1
     /* 294605 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 294610 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294617 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294624 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294624 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F64_e64),
     /* 294627 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294629 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294634 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294639 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294644 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294649 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294654 */       GIR_RootConstrainSelectedInstOperands,
     /* 294655 */       // GIR_Coverage, 255,
     /* 294655 */       GIR_EraseRootFromParent_Done,
     /* 294656 */     // Label 4949: @294656
     /* 294656 */     GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(294712), // Rule ID 256 //
     /* 294661 */       // MIs[0] Operand 1
     /* 294661 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 294666 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294673 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294680 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294680 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F64_e64),
     /* 294683 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294685 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294690 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294695 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294700 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294705 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294710 */       GIR_RootConstrainSelectedInstOperands,
     /* 294711 */       // GIR_Coverage, 256,
     /* 294711 */       GIR_EraseRootFromParent_Done,
     /* 294712 */     // Label 4950: @294712
     /* 294712 */     GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(294768), // Rule ID 257 //
     /* 294717 */       // MIs[0] Operand 1
     /* 294717 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 294722 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294729 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294736 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294736 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F64_e64),
     /* 294739 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294741 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294746 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294751 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294756 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294761 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294766 */       GIR_RootConstrainSelectedInstOperands,
     /* 294767 */       // GIR_Coverage, 257,
     /* 294767 */       GIR_EraseRootFromParent_Done,
     /* 294768 */     // Label 4951: @294768
     /* 294768 */     GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(294824), // Rule ID 258 //
     /* 294773 */       // MIs[0] Operand 1
     /* 294773 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
     /* 294778 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294785 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294792 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294792 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F64_e64),
     /* 294795 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294797 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294802 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294807 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294812 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294817 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294822 */       GIR_RootConstrainSelectedInstOperands,
     /* 294823 */       // GIR_Coverage, 258,
     /* 294823 */       GIR_EraseRootFromParent_Done,
     /* 294824 */     // Label 4952: @294824
     /* 294824 */     GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(294880), // Rule ID 259 //
     /* 294829 */       // MIs[0] Operand 1
     /* 294829 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 294834 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294841 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294848 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294848 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F64_e64),
     /* 294851 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294853 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294858 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294863 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294868 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294873 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294878 */       GIR_RootConstrainSelectedInstOperands,
     /* 294879 */       // GIR_Coverage, 259,
     /* 294879 */       GIR_EraseRootFromParent_Done,
     /* 294880 */     // Label 4953: @294880
     /* 294880 */     GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(294936), // Rule ID 260 //
     /* 294885 */       // MIs[0] Operand 1
     /* 294885 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 294890 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 294897 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 294904 */       // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
     /* 294904 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F64_e64),
     /* 294907 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 294909 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 294914 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 294919 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 294924 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 294929 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 294934 */       GIR_RootConstrainSelectedInstOperands,
     /* 294935 */       // GIR_Coverage, 260,
     /* 294935 */       GIR_EraseRootFromParent_Done,
     /* 294936 */     // Label 4954: @294936
     /* 294936 */     GIM_Reject,
     /* 294937 */   // Label 4940: @294937
     /* 294937 */   GIM_Reject,
     /* 294938 */   // Label 4881: @294938
     /* 294938 */   GIM_Reject,
     /* 294939 */ // Label 4877: @294939
     /* 294939 */ GIM_Reject,
     /* 294940 */ // Label 53: @294940
     /* 294940 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4957*/ GIMT_Encode4(295283),
     /* 294951 */ /*GILLT_s16*//*Label 4955*/ GIMT_Encode4(294959),
     /* 294955 */ /*GILLT_s32*//*Label 4956*/ GIMT_Encode4(295167),
     /* 294959 */ // Label 4955: @294959
     /* 294959 */ GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(295166),
     /* 294964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 294967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 294970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 294973 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(295004), // Rule ID 7026 //
     /* 294978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 294981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 294985 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 294985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 294988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 294990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294993 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 294995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 294998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295002 */     GIR_RootConstrainSelectedInstOperands,
     /* 295003 */     // GIR_Coverage, 7026,
     /* 295003 */     GIR_EraseRootFromParent_Done,
     /* 295004 */   // Label 4959: @295004
     /* 295004 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(295035), // Rule ID 7027 //
     /* 295009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 295012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295016 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 295016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 295019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295024 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 295026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295029 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295031 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295033 */     GIR_RootConstrainSelectedInstOperands,
     /* 295034 */     // GIR_Coverage, 7027,
     /* 295034 */     GIR_EraseRootFromParent_Done,
     /* 295035 */   // Label 4960: @295035
     /* 295035 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(295066), // Rule ID 7028 //
     /* 295040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 295043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295047 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 295047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 295050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295055 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 295057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295064 */     GIR_RootConstrainSelectedInstOperands,
     /* 295065 */     // GIR_Coverage, 7028,
     /* 295065 */     GIR_EraseRootFromParent_Done,
     /* 295066 */   // Label 4961: @295066
     /* 295066 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(295097), // Rule ID 7029 //
     /* 295071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 295074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295078 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 295078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 295081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295086 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 295088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295091 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295093 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295095 */     GIR_RootConstrainSelectedInstOperands,
     /* 295096 */     // GIR_Coverage, 7029,
     /* 295096 */     GIR_EraseRootFromParent_Done,
     /* 295097 */   // Label 4962: @295097
     /* 295097 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(295131), // Rule ID 7030 //
     /* 295102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 295105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 295109 */     // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 295109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B16_t16_e64),
     /* 295112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295117 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 295119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295122 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295129 */     GIR_RootConstrainSelectedInstOperands,
     /* 295130 */     // GIR_Coverage, 7030,
     /* 295130 */     GIR_EraseRootFromParent_Done,
     /* 295131 */   // Label 4963: @295131
     /* 295131 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(295165), // Rule ID 7031 //
     /* 295136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 295139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 295143 */     // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 295143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B16_t16_e64),
     /* 295146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295151 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 295153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295156 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295163 */     GIR_RootConstrainSelectedInstOperands,
     /* 295164 */     // GIR_Coverage, 7031,
     /* 295164 */     GIR_EraseRootFromParent_Done,
     /* 295165 */   // Label 4964: @295165
     /* 295165 */   GIM_Reject,
     /* 295166 */ // Label 4958: @295166
     /* 295166 */ GIM_Reject,
     /* 295167 */ // Label 4956: @295167
     /* 295167 */ GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(295282),
     /* 295172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 295175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295178 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 295181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295185 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(295233), // Rule ID 7024 //
     /* 295190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 295197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 295204 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[i32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[i32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[i32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 295204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 295207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
     /* 295214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
     /* 295219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 295224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 295229 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295231 */     GIR_RootConstrainSelectedInstOperands,
     /* 295232 */     // GIR_Coverage, 7024,
     /* 295232 */     GIR_EraseRootFromParent_Done,
     /* 295233 */   // Label 4966: @295233
     /* 295233 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(295281), // Rule ID 7025 //
     /* 295238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 295245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 295252 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[f32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[f32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[f32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
     /* 295252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 295255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
     /* 295262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
     /* 295267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 295272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 295277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295279 */     GIR_RootConstrainSelectedInstOperands,
     /* 295280 */     // GIR_Coverage, 7025,
     /* 295280 */     GIR_EraseRootFromParent_Done,
     /* 295281 */   // Label 4967: @295281
     /* 295281 */   GIM_Reject,
     /* 295282 */ // Label 4965: @295282
     /* 295282 */ GIM_Reject,
     /* 295283 */ // Label 4957: @295283
     /* 295283 */ GIM_Reject,
     /* 295284 */ // Label 54: @295284
     /* 295284 */ GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(295392),
     /* 295289 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 295292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295298 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(295329), // Rule ID 86 //
     /* 295303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 295306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13741),
     /* 295322 */     // (mulhu:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13741>>  =>  (S_MUL_HI_U32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 295322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_U32),
     /* 295327 */     GIR_RootConstrainSelectedInstOperands,
     /* 295328 */     // GIR_Coverage, 86,
     /* 295328 */     GIR_Done,
     /* 295329 */   // Label 4969: @295329
     /* 295329 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(295391),
     /* 295334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295338 */     GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(295364), // Rule ID 940 //
     /* 295343 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295350 */       // (mulhu:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 295350 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
     /* 295353 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295355 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295360 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295362 */       GIR_RootConstrainSelectedInstOperands,
     /* 295363 */       // GIR_Coverage, 940,
     /* 295363 */       GIR_EraseRootFromParent_Done,
     /* 295364 */     // Label 4971: @295364
     /* 295364 */     GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(295390), // Rule ID 8600 //
     /* 295369 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295376 */       // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 295376 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
     /* 295379 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295381 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295386 */       GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 295388 */       GIR_RootConstrainSelectedInstOperands,
     /* 295389 */       // GIR_Coverage, 8600,
     /* 295389 */       GIR_EraseRootFromParent_Done,
     /* 295390 */     // Label 4972: @295390
     /* 295390 */     GIM_Reject,
     /* 295391 */   // Label 4970: @295391
     /* 295391 */   GIM_Reject,
     /* 295392 */ // Label 4968: @295392
     /* 295392 */ GIM_Reject,
     /* 295393 */ // Label 55: @295393
     /* 295393 */ GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(295501),
     /* 295398 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 295401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295407 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(295438), // Rule ID 87 //
     /* 295412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 295415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 295427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13742),
     /* 295431 */     // (mulhs:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13742>>  =>  (S_MUL_HI_I32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
     /* 295431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_I32),
     /* 295436 */     GIR_RootConstrainSelectedInstOperands,
     /* 295437 */     // GIR_Coverage, 87,
     /* 295437 */     GIR_Done,
     /* 295438 */   // Label 4974: @295438
     /* 295438 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(295500),
     /* 295443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295447 */     GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(295473), // Rule ID 941 //
     /* 295452 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295459 */       // (mulhs:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 295459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
     /* 295462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295464 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295469 */       GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295471 */       GIR_RootConstrainSelectedInstOperands,
     /* 295472 */       // GIR_Coverage, 941,
     /* 295472 */       GIR_EraseRootFromParent_Done,
     /* 295473 */     // Label 4976: @295473
     /* 295473 */     GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(295499), // Rule ID 8601 //
     /* 295478 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 295485 */       // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 295485 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
     /* 295488 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295490 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295495 */       GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 295497 */       GIR_RootConstrainSelectedInstOperands,
     /* 295498 */       // GIR_Coverage, 8601,
     /* 295498 */       GIR_EraseRootFromParent_Done,
     /* 295499 */     // Label 4977: @295499
     /* 295499 */     GIM_Reject,
     /* 295500 */   // Label 4975: @295500
     /* 295500 */   GIM_Reject,
     /* 295501 */ // Label 4973: @295501
     /* 295501 */ GIM_Reject,
     /* 295502 */ // Label 56: @295502
     /* 295502 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4981*/ GIMT_Encode4(295889),
     /* 295513 */ /*GILLT_s16*//*Label 4978*/ GIMT_Encode4(295529),
     /* 295517 */ /*GILLT_s32*//*Label 4979*/ GIMT_Encode4(295745), GIMT_Encode4(0),
     /* 295525 */ /*GILLT_v2s16*//*Label 4980*/ GIMT_Encode4(295814),
     /* 295529 */ // Label 4978: @295529
     /* 295529 */ GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(295744),
     /* 295534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 295540 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(295599), // Rule ID 2674 //
     /* 295545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 295548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295566 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 295566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
     /* 295569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295597 */     GIR_RootConstrainSelectedInstOperands,
     /* 295598 */     // GIR_Coverage, 2674,
     /* 295598 */     GIR_EraseRootFromParent_Done,
     /* 295599 */   // Label 4983: @295599
     /* 295599 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(295658), // Rule ID 2677 //
     /* 295604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 295607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 295611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295625 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 295625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
     /* 295628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295656 */     GIR_RootConstrainSelectedInstOperands,
     /* 295657 */     // GIR_Coverage, 2677,
     /* 295657 */     GIR_EraseRootFromParent_Done,
     /* 295658 */   // Label 4984: @295658
     /* 295658 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(295717), // Rule ID 2680 //
     /* 295663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 295666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295684 */     // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 295684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
     /* 295687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295715 */     GIR_RootConstrainSelectedInstOperands,
     /* 295716 */     // GIR_Coverage, 2680,
     /* 295716 */     GIR_EraseRootFromParent_Done,
     /* 295717 */   // Label 4985: @295717
     /* 295717 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(295743), // Rule ID 2565 //
     /* 295722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
     /* 295725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295729 */     // (uaddsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
     /* 295729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
     /* 295732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295734 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295741 */     GIR_RootConstrainSelectedInstOperands,
     /* 295742 */     // GIR_Coverage, 2565,
     /* 295742 */     GIR_EraseRootFromParent_Done,
     /* 295743 */   // Label 4986: @295743
     /* 295743 */   GIM_Reject,
     /* 295744 */ // Label 4982: @295744
     /* 295744 */ GIM_Reject,
     /* 295745 */ // Label 4979: @295745
     /* 295745 */ GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(295813),
     /* 295750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 295753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 295756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295760 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(295782), // Rule ID 2563 //
     /* 295765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
     /* 295768 */     // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 295768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
     /* 295771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295775 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295780 */     GIR_RootConstrainSelectedInstOperands,
     /* 295781 */     // GIR_Coverage, 2563,
     /* 295781 */     GIR_EraseRootFromParent_Done,
     /* 295782 */   // Label 4988: @295782
     /* 295782 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(295812), // Rule ID 2561 //
     /* 295787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
     /* 295790 */     // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 295790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 295793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
     /* 295796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295798 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 295803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 295805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 295807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295810 */     GIR_RootConstrainSelectedInstOperands,
     /* 295811 */     // GIR_Coverage, 2561,
     /* 295811 */     GIR_EraseRootFromParent_Done,
     /* 295812 */   // Label 4989: @295812
     /* 295812 */   GIM_Reject,
     /* 295813 */ // Label 4987: @295813
     /* 295813 */ GIM_Reject,
     /* 295814 */ // Label 4980: @295814
     /* 295814 */ GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(295888), // Rule ID 2721 //
     /* 295819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 295822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 295825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 295828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 295846 */   // (uaddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 295846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
     /* 295849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295886 */   GIR_RootConstrainSelectedInstOperands,
     /* 295887 */   // GIR_Coverage, 2721,
     /* 295887 */   GIR_EraseRootFromParent_Done,
     /* 295888 */ // Label 4990: @295888
     /* 295888 */ GIM_Reject,
     /* 295889 */ // Label 4981: @295889
     /* 295889 */ GIM_Reject,
     /* 295890 */ // Label 57: @295890
     /* 295890 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4994*/ GIMT_Encode4(296215),
     /* 295901 */ /*GILLT_s16*//*Label 4991*/ GIMT_Encode4(295917),
     /* 295905 */ /*GILLT_s32*//*Label 4992*/ GIMT_Encode4(296107), GIMT_Encode4(0),
     /* 295913 */ /*GILLT_v2s16*//*Label 4993*/ GIMT_Encode4(296140),
     /* 295917 */ // Label 4991: @295917
     /* 295917 */ GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(296106),
     /* 295922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 295925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 295928 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(295987), // Rule ID 2614 //
     /* 295933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 295936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 295940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 295954 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 295954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_e64),
     /* 295957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 295959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 295964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 295969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 295974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 295979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 295982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295985 */     GIR_RootConstrainSelectedInstOperands,
     /* 295986 */     // GIR_Coverage, 2614,
     /* 295986 */     GIR_EraseRootFromParent_Done,
     /* 295987 */   // Label 4996: @295987
     /* 295987 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(296046), // Rule ID 2616 //
     /* 295992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 295995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 295999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296013 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_t16_e64),
     /* 296016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296044 */     GIR_RootConstrainSelectedInstOperands,
     /* 296045 */     // GIR_Coverage, 2616,
     /* 296045 */     GIR_EraseRootFromParent_Done,
     /* 296046 */   // Label 4997: @296046
     /* 296046 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(296105), // Rule ID 2618 //
     /* 296051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 296054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296072 */     // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_fake16_e64),
     /* 296075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296103 */     GIR_RootConstrainSelectedInstOperands,
     /* 296104 */     // GIR_Coverage, 2618,
     /* 296104 */     GIR_EraseRootFromParent_Done,
     /* 296105 */   // Label 4998: @296105
     /* 296105 */   GIM_Reject,
     /* 296106 */ // Label 4995: @296106
     /* 296106 */ GIM_Reject,
     /* 296107 */ // Label 4992: @296107
     /* 296107 */ GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(296139), // Rule ID 2611 //
     /* 296112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 296115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 296118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 296121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296125 */   // (saddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 296125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I32_e64),
     /* 296128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296130 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 296132 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 296134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296137 */   GIR_RootConstrainSelectedInstOperands,
     /* 296138 */   // GIR_Coverage, 2611,
     /* 296138 */   GIR_EraseRootFromParent_Done,
     /* 296139 */ // Label 4999: @296139
     /* 296139 */ GIM_Reject,
     /* 296140 */ // Label 4993: @296140
     /* 296140 */ GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(296214), // Rule ID 2722 //
     /* 296145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 296148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 296151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 296154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 296165 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 296172 */   // (saddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 296172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_I16),
     /* 296175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296212 */   GIR_RootConstrainSelectedInstOperands,
     /* 296213 */   // GIR_Coverage, 2722,
     /* 296213 */   GIR_EraseRootFromParent_Done,
     /* 296214 */ // Label 5000: @296214
     /* 296214 */ GIM_Reject,
     /* 296215 */ // Label 4994: @296215
     /* 296215 */ GIM_Reject,
     /* 296216 */ // Label 58: @296216
     /* 296216 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5004*/ GIMT_Encode4(296603),
     /* 296227 */ /*GILLT_s16*//*Label 5001*/ GIMT_Encode4(296243),
     /* 296231 */ /*GILLT_s32*//*Label 5002*/ GIMT_Encode4(296459), GIMT_Encode4(0),
     /* 296239 */ /*GILLT_v2s16*//*Label 5003*/ GIMT_Encode4(296528),
     /* 296243 */ // Label 5001: @296243
     /* 296243 */ GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(296458),
     /* 296248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 296251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 296254 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(296313), // Rule ID 2675 //
     /* 296259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 296262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296280 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
     /* 296283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296311 */     GIR_RootConstrainSelectedInstOperands,
     /* 296312 */     // GIR_Coverage, 2675,
     /* 296312 */     GIR_EraseRootFromParent_Done,
     /* 296313 */   // Label 5006: @296313
     /* 296313 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(296372), // Rule ID 2678 //
     /* 296318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 296321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 296325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296339 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
     /* 296342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296370 */     GIR_RootConstrainSelectedInstOperands,
     /* 296371 */     // GIR_Coverage, 2678,
     /* 296371 */     GIR_EraseRootFromParent_Done,
     /* 296372 */   // Label 5007: @296372
     /* 296372 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(296431), // Rule ID 2681 //
     /* 296377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 296380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296398 */     // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
     /* 296401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296429 */     GIR_RootConstrainSelectedInstOperands,
     /* 296430 */     // GIR_Coverage, 2681,
     /* 296430 */     GIR_EraseRootFromParent_Done,
     /* 296431 */   // Label 5008: @296431
     /* 296431 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(296457), // Rule ID 2566 //
     /* 296436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
     /* 296439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296443 */     // (usubsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
     /* 296443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
     /* 296446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 296450 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 296452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296455 */     GIR_RootConstrainSelectedInstOperands,
     /* 296456 */     // GIR_Coverage, 2566,
     /* 296456 */     GIR_EraseRootFromParent_Done,
     /* 296457 */   // Label 5009: @296457
     /* 296457 */   GIM_Reject,
     /* 296458 */ // Label 5005: @296458
     /* 296458 */ GIM_Reject,
     /* 296459 */ // Label 5002: @296459
     /* 296459 */ GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(296527),
     /* 296464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 296467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 296470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296474 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(296496), // Rule ID 2564 //
     /* 296479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
     /* 296482 */     // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 296482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
     /* 296485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296487 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 296489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 296491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296494 */     GIR_RootConstrainSelectedInstOperands,
     /* 296495 */     // GIR_Coverage, 2564,
     /* 296495 */     GIR_EraseRootFromParent_Done,
     /* 296496 */   // Label 5011: @296496
     /* 296496 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(296526), // Rule ID 2562 //
     /* 296501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
     /* 296504 */     // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 296504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 296507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
     /* 296510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296512 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 296517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 296519 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 296521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296524 */     GIR_RootConstrainSelectedInstOperands,
     /* 296525 */     // GIR_Coverage, 2562,
     /* 296525 */     GIR_EraseRootFromParent_Done,
     /* 296526 */   // Label 5012: @296526
     /* 296526 */   GIM_Reject,
     /* 296527 */ // Label 5010: @296527
     /* 296527 */ GIM_Reject,
     /* 296528 */ // Label 5003: @296528
     /* 296528 */ GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(296602), // Rule ID 2723 //
     /* 296533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 296536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 296539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 296542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296546 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 296553 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 296560 */   // (usubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 296560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_U16),
     /* 296563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296600 */   GIR_RootConstrainSelectedInstOperands,
     /* 296601 */   // GIR_Coverage, 2723,
     /* 296601 */   GIR_EraseRootFromParent_Done,
     /* 296602 */ // Label 5013: @296602
     /* 296602 */ GIM_Reject,
     /* 296603 */ // Label 5004: @296603
     /* 296603 */ GIM_Reject,
     /* 296604 */ // Label 59: @296604
     /* 296604 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5017*/ GIMT_Encode4(296929),
     /* 296615 */ /*GILLT_s16*//*Label 5014*/ GIMT_Encode4(296631),
     /* 296619 */ /*GILLT_s32*//*Label 5015*/ GIMT_Encode4(296821), GIMT_Encode4(0),
     /* 296627 */ /*GILLT_v2s16*//*Label 5016*/ GIMT_Encode4(296854),
     /* 296631 */ // Label 5014: @296631
     /* 296631 */ GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(296820),
     /* 296636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 296639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 296642 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(296701), // Rule ID 2615 //
     /* 296647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 296650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296668 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_e64),
     /* 296671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296699 */     GIR_RootConstrainSelectedInstOperands,
     /* 296700 */     // GIR_Coverage, 2615,
     /* 296700 */     GIR_EraseRootFromParent_Done,
     /* 296701 */   // Label 5019: @296701
     /* 296701 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(296760), // Rule ID 2617 //
     /* 296706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 296709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 296713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296727 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_t16_e64),
     /* 296730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296758 */     GIR_RootConstrainSelectedInstOperands,
     /* 296759 */     // GIR_Coverage, 2617,
     /* 296759 */     GIR_EraseRootFromParent_Done,
     /* 296760 */   // Label 5020: @296760
     /* 296760 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(296819), // Rule ID 2619 //
     /* 296765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 296768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
     /* 296786 */     // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 296786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_fake16_e64),
     /* 296789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296817 */     GIR_RootConstrainSelectedInstOperands,
     /* 296818 */     // GIR_Coverage, 2619,
     /* 296818 */     GIR_EraseRootFromParent_Done,
     /* 296819 */   // Label 5021: @296819
     /* 296819 */   GIM_Reject,
     /* 296820 */ // Label 5018: @296820
     /* 296820 */ GIM_Reject,
     /* 296821 */ // Label 5015: @296821
     /* 296821 */ GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(296853), // Rule ID 2612 //
     /* 296826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 296829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 296832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 296835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296839 */   // (ssubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
     /* 296839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I32_e64),
     /* 296842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 296846 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 296848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296851 */   GIR_RootConstrainSelectedInstOperands,
     /* 296852 */   // GIR_Coverage, 2612,
     /* 296852 */   GIR_EraseRootFromParent_Done,
     /* 296853 */ // Label 5022: @296853
     /* 296853 */ GIM_Reject,
     /* 296854 */ // Label 5016: @296854
     /* 296854 */ GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(296928), // Rule ID 2724 //
     /* 296859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 296862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 296865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 296868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 296872 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 296879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 296886 */   // (ssubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
     /* 296886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
     /* 296889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 296891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 296896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 296901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 296906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 296911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 296914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296926 */   GIR_RootConstrainSelectedInstOperands,
     /* 296927 */   // GIR_Coverage, 2724,
     /* 296927 */   GIR_EraseRootFromParent_Done,
     /* 296928 */ // Label 5023: @296928
     /* 296928 */ GIM_Reject,
     /* 296929 */ // Label 5017: @296929
     /* 296929 */ GIM_Reject,
     /* 296930 */ // Label 60: @296930
     /* 296930 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5029*/ GIMT_Encode4(298287),
     /* 296941 */ /*GILLT_s16*//*Label 5024*/ GIMT_Encode4(296961),
     /* 296945 */ /*GILLT_s32*//*Label 5025*/ GIMT_Encode4(297323),
     /* 296949 */ /*GILLT_s64*//*Label 5026*/ GIMT_Encode4(297887),
     /* 296953 */ /*GILLT_v2s16*//*Label 5027*/ GIMT_Encode4(298140),
     /* 296957 */ /*GILLT_v2s32*//*Label 5028*/ GIMT_Encode4(298212),
     /* 296961 */ // Label 5024: @296961
     /* 296961 */ GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(297322),
     /* 296966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 296969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 296972 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(297007), // Rule ID 97 //
     /* 296977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 296980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 296992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /* 296996 */     // (fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13743>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 296996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
     /* 297001 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 297005 */     GIR_RootConstrainSelectedInstOperands,
     /* 297006 */     // GIR_Coverage, 97,
     /* 297006 */     GIR_Done,
     /* 297007 */   // Label 5031: @297007
     /* 297007 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(297070), // Rule ID 860 //
     /* 297012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 297015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297033 */     // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 297036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297068 */     GIR_RootConstrainSelectedInstOperands,
     /* 297069 */     // GIR_Coverage, 860,
     /* 297069 */     GIR_EraseRootFromParent_Done,
     /* 297070 */   // Label 5032: @297070
     /* 297070 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(297133), // Rule ID 864 //
     /* 297075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 297078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297096 */     // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 297099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297131 */     GIR_RootConstrainSelectedInstOperands,
     /* 297132 */     // GIR_Coverage, 864,
     /* 297132 */     GIR_EraseRootFromParent_Done,
     /* 297133 */   // Label 5033: @297133
     /* 297133 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(297196), // Rule ID 8561 //
     /* 297138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 297141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297159 */     // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 297162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297194 */     GIR_RootConstrainSelectedInstOperands,
     /* 297195 */     // GIR_Coverage, 8561,
     /* 297195 */     GIR_EraseRootFromParent_Done,
     /* 297196 */   // Label 5034: @297196
     /* 297196 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(297259), // Rule ID 8563 //
     /* 297201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 297204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297222 */     // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 297225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297257 */     GIR_RootConstrainSelectedInstOperands,
     /* 297258 */     // GIR_Coverage, 8563,
     /* 297258 */     GIR_EraseRootFromParent_Done,
     /* 297259 */   // Label 5035: @297259
     /* 297259 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(297321), // Rule ID 862 //
     /* 297264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 297267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 297271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 297278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 297285 */     // (fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 297285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
     /* 297288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297319 */     GIR_RootConstrainSelectedInstOperands,
     /* 297320 */     // GIR_Coverage, 862,
     /* 297320 */     GIR_EraseRootFromParent_Done,
     /* 297321 */   // Label 5036: @297321
     /* 297321 */   GIM_Reject,
     /* 297322 */ // Label 5030: @297322
     /* 297322 */ GIM_Reject,
     /* 297323 */ // Label 5025: @297323
     /* 297323 */ GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(297886),
     /* 297328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 297331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 297334 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(297430), // Rule ID 11281 //
     /* 297339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
     /* 297342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297354 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297357 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 297362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297366 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297393 */     // (fadd:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2), (intrinsic_wo_chain:{ *:[f32] } 2313:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 297393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
     /* 297396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 297414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 297422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297428 */     GIR_RootConstrainSelectedInstOperands,
     /* 297429 */     // GIR_Coverage, 11281,
     /* 297429 */     GIR_EraseRootFromParent_Done,
     /* 297430 */   // Label 5038: @297430
     /* 297430 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(297532), // Rule ID 11283 //
     /* 297435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
     /* 297438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297450 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297453 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 297458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297462 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297489 */     // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod), (intrinsic_wo_chain:{ *:[f32] } 2313:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 297489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
     /* 297492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mod
     /* 297499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mod
     /* 297509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 297514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mod
     /* 297519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 297524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297530 */     GIR_RootConstrainSelectedInstOperands,
     /* 297531 */     // GIR_Coverage, 11283,
     /* 297531 */     GIR_EraseRootFromParent_Done,
     /* 297532 */   // Label 5039: @297532
     /* 297532 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(297628), // Rule ID 7016 //
     /* 297537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
     /* 297540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297552 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297555 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 297560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 297591 */     // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2313:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 297591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
     /* 297594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297626 */     GIR_RootConstrainSelectedInstOperands,
     /* 297627 */     // GIR_Coverage, 7016,
     /* 297627 */     GIR_EraseRootFromParent_Done,
     /* 297628 */   // Label 5040: @297628
     /* 297628 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(297730), // Rule ID 7022 //
     /* 297633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
     /* 297636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 297648 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 297651 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
     /* 297656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 297660 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 297664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297687 */     // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2313:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 297687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
     /* 297690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mod
     /* 297697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mod
     /* 297707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mod
     /* 297717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 297722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297728 */     GIR_RootConstrainSelectedInstOperands,
     /* 297729 */     // GIR_Coverage, 7022,
     /* 297729 */     GIR_EraseRootFromParent_Done,
     /* 297730 */   // Label 5041: @297730
     /* 297730 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(297765), // Rule ID 89 //
     /* 297735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 297738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 297742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 297746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 297750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /* 297754 */     // (fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13743>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 297754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
     /* 297759 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 297763 */     GIR_RootConstrainSelectedInstOperands,
     /* 297764 */     // GIR_Coverage, 89,
     /* 297764 */     GIR_Done,
     /* 297765 */   // Label 5042: @297765
     /* 297765 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(297825), // Rule ID 786 //
     /* 297770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297788 */     // (fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 297791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297823 */     GIR_RootConstrainSelectedInstOperands,
     /* 297824 */     // GIR_Coverage, 786,
     /* 297824 */     GIR_EraseRootFromParent_Done,
     /* 297825 */   // Label 5043: @297825
     /* 297825 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(297885), // Rule ID 8550 //
     /* 297830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 297834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297848 */     // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 297851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 297858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 297863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 297868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 297873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 297878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 297883 */     GIR_RootConstrainSelectedInstOperands,
     /* 297884 */     // GIR_Coverage, 8550,
     /* 297884 */     GIR_EraseRootFromParent_Done,
     /* 297885 */   // Label 5044: @297885
     /* 297885 */   GIM_Reject,
     /* 297886 */ // Label 5037: @297886
     /* 297886 */ GIM_Reject,
     /* 297887 */ // Label 5026: @297887
     /* 297887 */ GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(298139),
     /* 297892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 297902 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(297961), // Rule ID 914 //
     /* 297907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 297910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297924 */     // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 297927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 297944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 297949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 297954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 297959 */     GIR_RootConstrainSelectedInstOperands,
     /* 297960 */     // GIR_Coverage, 914,
     /* 297960 */     GIR_EraseRootFromParent_Done,
     /* 297961 */   // Label 5046: @297961
     /* 297961 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(298020), // Rule ID 932 //
     /* 297966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 297969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 297976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 297983 */     // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 297983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 297986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 297988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 297993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 297998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298018 */     GIR_RootConstrainSelectedInstOperands,
     /* 298019 */     // GIR_Coverage, 932,
     /* 298019 */     GIR_EraseRootFromParent_Done,
     /* 298020 */   // Label 5047: @298020
     /* 298020 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(298079), // Rule ID 8579 //
     /* 298025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 298028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298042 */     // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 298045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 298052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 298062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 298072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 298077 */     GIR_RootConstrainSelectedInstOperands,
     /* 298078 */     // GIR_Coverage, 8579,
     /* 298078 */     GIR_EraseRootFromParent_Done,
     /* 298079 */   // Label 5048: @298079
     /* 298079 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(298138), // Rule ID 8592 //
     /* 298084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 298087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298101 */     // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 298104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 298111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 298121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 298131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 298136 */     GIR_RootConstrainSelectedInstOperands,
     /* 298137 */     // GIR_Coverage, 8592,
     /* 298137 */     GIR_EraseRootFromParent_Done,
     /* 298138 */   // Label 5049: @298138
     /* 298138 */   GIM_Reject,
     /* 298139 */ // Label 5045: @298139
     /* 298139 */ GIM_Reject,
     /* 298140 */ // Label 5027: @298140
     /* 298140 */ GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(298211), // Rule ID 1092 //
     /* 298145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 298148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 298151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298155 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 298162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 298169 */   // (fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 298169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
     /* 298172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298209 */   GIR_RootConstrainSelectedInstOperands,
     /* 298210 */   // GIR_Coverage, 1092,
     /* 298210 */   GIR_EraseRootFromParent_Done,
     /* 298211 */ // Label 5050: @298211
     /* 298211 */ GIM_Reject,
     /* 298212 */ // Label 5028: @298212
     /* 298212 */ GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(298286), // Rule ID 1313 //
     /* 298217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 298220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 298230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 298237 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 298244 */   // (fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 298244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 298247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298284 */   GIR_RootConstrainSelectedInstOperands,
     /* 298285 */   // GIR_Coverage, 1313,
     /* 298285 */   GIR_EraseRootFromParent_Done,
     /* 298286 */ // Label 5051: @298286
     /* 298286 */ GIM_Reject,
     /* 298287 */ // Label 5029: @298287
     /* 298287 */ GIM_Reject,
     /* 298288 */ // Label 61: @298288
     /* 298288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5054*/ GIMT_Encode4(298651),
     /* 298299 */ /*GILLT_s16*//*Label 5052*/ GIMT_Encode4(298307),
     /* 298303 */ /*GILLT_s32*//*Label 5053*/ GIMT_Encode4(298543),
     /* 298307 */ // Label 5052: @298307
     /* 298307 */ GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(298542),
     /* 298312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 298315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 298318 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(298353), // Rule ID 105 //
     /* 298323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 298326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13747),
     /* 298342 */     // (fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13747>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 298342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
     /* 298347 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 298351 */     GIR_RootConstrainSelectedInstOperands,
     /* 298352 */     // GIR_Coverage, 105,
     /* 298352 */     GIR_Done,
     /* 298353 */   // Label 5056: @298353
     /* 298353 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(298416), // Rule ID 866 //
     /* 298358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 298361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298379 */     // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
     /* 298382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298414 */     GIR_RootConstrainSelectedInstOperands,
     /* 298415 */     // GIR_Coverage, 866,
     /* 298415 */     GIR_EraseRootFromParent_Done,
     /* 298416 */   // Label 5057: @298416
     /* 298416 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(298479), // Rule ID 870 //
     /* 298421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 298424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298442 */     // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
     /* 298445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298477 */     GIR_RootConstrainSelectedInstOperands,
     /* 298478 */     // GIR_Coverage, 870,
     /* 298478 */     GIR_EraseRootFromParent_Done,
     /* 298479 */   // Label 5058: @298479
     /* 298479 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(298541), // Rule ID 868 //
     /* 298484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 298487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 298491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 298498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 298505 */     // (fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 298505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
     /* 298508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298539 */     GIR_RootConstrainSelectedInstOperands,
     /* 298540 */     // GIR_Coverage, 868,
     /* 298540 */     GIR_EraseRootFromParent_Done,
     /* 298541 */   // Label 5059: @298541
     /* 298541 */   GIM_Reject,
     /* 298542 */ // Label 5055: @298542
     /* 298542 */ GIM_Reject,
     /* 298543 */ // Label 5053: @298543
     /* 298543 */ GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(298650),
     /* 298548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 298551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 298554 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(298589), // Rule ID 107 //
     /* 298559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 298562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13747),
     /* 298578 */     // (fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13747>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 298578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
     /* 298583 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 298587 */     GIR_RootConstrainSelectedInstOperands,
     /* 298588 */     // GIR_Coverage, 107,
     /* 298588 */     GIR_Done,
     /* 298589 */   // Label 5061: @298589
     /* 298589 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(298649), // Rule ID 788 //
     /* 298594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298612 */     // (fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
     /* 298615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298647 */     GIR_RootConstrainSelectedInstOperands,
     /* 298648 */     // GIR_Coverage, 788,
     /* 298648 */     GIR_EraseRootFromParent_Done,
     /* 298649 */   // Label 5062: @298649
     /* 298649 */   GIM_Reject,
     /* 298650 */ // Label 5060: @298650
     /* 298650 */ GIM_Reject,
     /* 298651 */ // Label 5054: @298651
     /* 298651 */ GIM_Reject,
     /* 298652 */ // Label 62: @298652
     /* 298652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5068*/ GIMT_Encode4(300037),
     /* 298663 */ /*GILLT_s16*//*Label 5063*/ GIMT_Encode4(298683),
     /* 298667 */ /*GILLT_s32*//*Label 5064*/ GIMT_Encode4(299045),
     /* 298671 */ /*GILLT_s64*//*Label 5065*/ GIMT_Encode4(299213),
     /* 298675 */ /*GILLT_v2s16*//*Label 5066*/ GIMT_Encode4(299890),
     /* 298679 */ /*GILLT_v2s32*//*Label 5067*/ GIMT_Encode4(299962),
     /* 298683 */ // Label 5063: @298683
     /* 298683 */ GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(299044),
     /* 298688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 298691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 298694 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(298729), // Rule ID 99 //
     /* 298699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 298702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 298714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13746),
     /* 298718 */     // (fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13746>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 298718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
     /* 298723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 298727 */     GIR_RootConstrainSelectedInstOperands,
     /* 298728 */     // GIR_Coverage, 99,
     /* 298728 */     GIR_Done,
     /* 298729 */   // Label 5070: @298729
     /* 298729 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(298792), // Rule ID 872 //
     /* 298734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 298737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298755 */     // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 298758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298790 */     GIR_RootConstrainSelectedInstOperands,
     /* 298791 */     // GIR_Coverage, 872,
     /* 298791 */     GIR_EraseRootFromParent_Done,
     /* 298792 */   // Label 5071: @298792
     /* 298792 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(298855), // Rule ID 876 //
     /* 298797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 298800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298818 */     // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 298821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 298828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 298833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 298838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 298843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 298848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 298853 */     GIR_RootConstrainSelectedInstOperands,
     /* 298854 */     // GIR_Coverage, 876,
     /* 298854 */     GIR_EraseRootFromParent_Done,
     /* 298855 */   // Label 5072: @298855
     /* 298855 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(298918), // Rule ID 8565 //
     /* 298860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 298863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298881 */     // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 298884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 298891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 298901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 298911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 298916 */     GIR_RootConstrainSelectedInstOperands,
     /* 298917 */     // GIR_Coverage, 8565,
     /* 298917 */     GIR_EraseRootFromParent_Done,
     /* 298918 */   // Label 5073: @298918
     /* 298918 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(298981), // Rule ID 8567 //
     /* 298923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 298926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 298930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 298937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 298944 */     // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 298944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 298947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 298949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 298954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 298959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 298964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 298969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 298974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 298979 */     GIR_RootConstrainSelectedInstOperands,
     /* 298980 */     // GIR_Coverage, 8567,
     /* 298980 */     GIR_EraseRootFromParent_Done,
     /* 298981 */   // Label 5074: @298981
     /* 298981 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(299043), // Rule ID 874 //
     /* 298986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 298989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 298993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 299000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 299007 */     // (fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 299007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 299010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299041 */     GIR_RootConstrainSelectedInstOperands,
     /* 299042 */     // GIR_Coverage, 874,
     /* 299042 */     GIR_EraseRootFromParent_Done,
     /* 299043 */   // Label 5075: @299043
     /* 299043 */   GIM_Reject,
     /* 299044 */ // Label 5069: @299044
     /* 299044 */ GIM_Reject,
     /* 299045 */ // Label 5064: @299045
     /* 299045 */ GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(299212),
     /* 299050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 299053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 299056 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(299091), // Rule ID 95 //
     /* 299061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 299064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 299076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13746),
     /* 299080 */     // (fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13746>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 299080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
     /* 299085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 299089 */     GIR_RootConstrainSelectedInstOperands,
     /* 299090 */     // GIR_Coverage, 95,
     /* 299090 */     GIR_Done,
     /* 299091 */   // Label 5077: @299091
     /* 299091 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(299151), // Rule ID 792 //
     /* 299096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299114 */     // (fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 299117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299149 */     GIR_RootConstrainSelectedInstOperands,
     /* 299150 */     // GIR_Coverage, 792,
     /* 299150 */     GIR_EraseRootFromParent_Done,
     /* 299151 */   // Label 5078: @299151
     /* 299151 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(299211), // Rule ID 8554 //
     /* 299156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299174 */     // (fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 299177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 299184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 299189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 299194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 299199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 299204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 299209 */     GIR_RootConstrainSelectedInstOperands,
     /* 299210 */     // GIR_Coverage, 8554,
     /* 299210 */     GIR_EraseRootFromParent_Done,
     /* 299211 */   // Label 5079: @299211
     /* 299211 */   GIM_Reject,
     /* 299212 */ // Label 5076: @299212
     /* 299212 */ GIM_Reject,
     /* 299213 */ // Label 5065: @299213
     /* 299213 */ GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(299889),
     /* 299218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 299224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 299228 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(299302), // Rule ID 7920 //
     /* 299233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299241 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 299245 */     // MIs[1] Operand 1
     /* 299245 */     // No operand predicates
     /* 299245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299254 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 299254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299266 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 299271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 299283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299300 */     GIR_RootConstrainSelectedInstOperands,
     /* 299301 */     // GIR_Coverage, 7920,
     /* 299301 */     GIR_EraseRootFromParent_Done,
     /* 299302 */   // Label 5081: @299302
     /* 299302 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(299376), // Rule ID 13586 //
     /* 299307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299315 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 299319 */     // MIs[1] Operand 1
     /* 299319 */     // No operand predicates
     /* 299319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299328 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 299328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299340 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 299345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 299357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299374 */     GIR_RootConstrainSelectedInstOperands,
     /* 299375 */     // GIR_Coverage, 13586,
     /* 299375 */     GIR_EraseRootFromParent_Done,
     /* 299376 */   // Label 5082: @299376
     /* 299376 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(299452), // Rule ID 7924 //
     /* 299381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299401 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 299405 */     // MIs[2] Operand 1
     /* 299405 */     // No operand predicates
     /* 299405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299407 */     // (fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 299407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299419 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 299424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 299434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 299438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299450 */     GIR_RootConstrainSelectedInstOperands,
     /* 299451 */     // GIR_Coverage, 7924,
     /* 299451 */     GIR_EraseRootFromParent_Done,
     /* 299452 */   // Label 5083: @299452
     /* 299452 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(299528), // Rule ID 13590 //
     /* 299457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299465 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 299469 */     // MIs[1] Operand 1
     /* 299469 */     // No operand predicates
     /* 299469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 299477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 299481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299483 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 299483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299495 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 299500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 299510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 299514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299526 */     GIR_RootConstrainSelectedInstOperands,
     /* 299527 */     // GIR_Coverage, 13590,
     /* 299527 */     GIR_EraseRootFromParent_Done,
     /* 299528 */   // Label 5084: @299528
     /* 299528 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(299590), // Rule ID 13588 //
     /* 299533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299541 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 299545 */     // MIs[1] Operand 1
     /* 299545 */     // No operand predicates
     /* 299545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299547 */     // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 299547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299559 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 299564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 299574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 299576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299588 */     GIR_RootConstrainSelectedInstOperands,
     /* 299589 */     // GIR_Coverage, 13588,
     /* 299589 */     GIR_EraseRootFromParent_Done,
     /* 299590 */   // Label 5085: @299590
     /* 299590 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(299652), // Rule ID 7922 //
     /* 299595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299603 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 299607 */     // MIs[1] Operand 1
     /* 299607 */     // No operand predicates
     /* 299607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299609 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 299609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 299612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 299616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299621 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 299626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 299631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 299636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 299638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299650 */     GIR_RootConstrainSelectedInstOperands,
     /* 299651 */     // GIR_Coverage, 7922,
     /* 299651 */     GIR_EraseRootFromParent_Done,
     /* 299652 */   // Label 5086: @299652
     /* 299652 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(299711), // Rule ID 915 //
     /* 299657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 299660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299674 */     // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
     /* 299677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299709 */     GIR_RootConstrainSelectedInstOperands,
     /* 299710 */     // GIR_Coverage, 915,
     /* 299710 */     GIR_EraseRootFromParent_Done,
     /* 299711 */   // Label 5087: @299711
     /* 299711 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(299770), // Rule ID 934 //
     /* 299716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 299719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299733 */     // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 299736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 299763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 299768 */     GIR_RootConstrainSelectedInstOperands,
     /* 299769 */     // GIR_Coverage, 934,
     /* 299769 */     GIR_EraseRootFromParent_Done,
     /* 299770 */   // Label 5088: @299770
     /* 299770 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(299829), // Rule ID 8580 //
     /* 299775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 299778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299792 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
     /* 299795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 299802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 299807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 299812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 299817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 299822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 299827 */     GIR_RootConstrainSelectedInstOperands,
     /* 299828 */     // GIR_Coverage, 8580,
     /* 299828 */     GIR_EraseRootFromParent_Done,
     /* 299829 */   // Label 5089: @299829
     /* 299829 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(299888), // Rule ID 8594 //
     /* 299834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 299837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 299844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 299851 */     // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 299851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 299854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 299861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 299866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 299871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 299876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 299881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 299886 */     GIR_RootConstrainSelectedInstOperands,
     /* 299887 */     // GIR_Coverage, 8594,
     /* 299887 */     GIR_EraseRootFromParent_Done,
     /* 299888 */   // Label 5090: @299888
     /* 299888 */   GIM_Reject,
     /* 299889 */ // Label 5080: @299889
     /* 299889 */ GIM_Reject,
     /* 299890 */ // Label 5066: @299890
     /* 299890 */ GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(299961), // Rule ID 1094 //
     /* 299895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 299898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 299901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 299905 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 299912 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 299919 */   // (fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 299919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 299922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 299929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 299934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 299939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 299944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299959 */   GIR_RootConstrainSelectedInstOperands,
     /* 299960 */   // GIR_Coverage, 1094,
     /* 299960 */   GIR_EraseRootFromParent_Done,
     /* 299961 */ // Label 5091: @299961
     /* 299961 */ GIM_Reject,
     /* 299962 */ // Label 5067: @299962
     /* 299962 */ GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(300036), // Rule ID 1311 //
     /* 299967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 299970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 299980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 299987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 299994 */   // (fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 299994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 299997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 299999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 300004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 300014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300034 */   GIR_RootConstrainSelectedInstOperands,
     /* 300035 */   // GIR_Coverage, 1311,
     /* 300035 */   GIR_EraseRootFromParent_Done,
     /* 300036 */ // Label 5092: @300036
     /* 300036 */ GIM_Reject,
     /* 300037 */ // Label 5068: @300037
     /* 300037 */ GIM_Reject,
     /* 300038 */ // Label 63: @300038
     /* 300038 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5098*/ GIMT_Encode4(301906),
     /* 300049 */ /*GILLT_s16*//*Label 5093*/ GIMT_Encode4(300069),
     /* 300053 */ /*GILLT_s32*//*Label 5094*/ GIMT_Encode4(300734),
     /* 300057 */ /*GILLT_s64*//*Label 5095*/ GIMT_Encode4(301487),
     /* 300061 */ /*GILLT_v2s16*//*Label 5096*/ GIMT_Encode4(301719),
     /* 300065 */ /*GILLT_v2s32*//*Label 5097*/ GIMT_Encode4(301811),
     /* 300069 */ // Label 5093: @300069
     /* 300069 */ GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(300733),
     /* 300074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 300077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 300080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 300083 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(300122), // Rule ID 113 //
     /* 300088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 300091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 300107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13749),
     /* 300111 */     // (fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13749>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
     /* 300111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
     /* 300116 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 300120 */     GIR_RootConstrainSelectedInstOperands,
     /* 300121 */     // GIR_Coverage, 113,
     /* 300121 */     GIR_Done,
     /* 300122 */   // Label 5100: @300122
     /* 300122 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(300192), // Rule ID 7632 //
     /* 300127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
     /* 300130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300155 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
     /* 300155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_e64),
     /* 300158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300190 */     GIR_RootConstrainSelectedInstOperands,
     /* 300191 */     // GIR_Coverage, 7632,
     /* 300191 */     GIR_EraseRootFromParent_Done,
     /* 300192 */   // Label 5101: @300192
     /* 300192 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(300265), // Rule ID 7633 //
     /* 300197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
     /* 300200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 300204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300225 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_FMAC_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2)
     /* 300225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_t16_e64),
     /* 300228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300263 */     GIR_RootConstrainSelectedInstOperands,
     /* 300264 */     // GIR_Coverage, 7633,
     /* 300264 */     GIR_EraseRootFromParent_Done,
     /* 300265 */   // Label 5102: @300265
     /* 300265 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(300335), // Rule ID 7634 //
     /* 300270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
     /* 300273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 300298 */     // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_FMAC_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2)
     /* 300298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_fake16_e64),
     /* 300301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300333 */     GIR_RootConstrainSelectedInstOperands,
     /* 300334 */     // GIR_Coverage, 7634,
     /* 300334 */     GIR_EraseRootFromParent_Done,
     /* 300335 */   // Label 5103: @300335
     /* 300335 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(300415), // Rule ID 1001 //
     /* 300340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 300343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 300354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 300361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 300368 */     // (fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 300368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 300371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 300378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 300388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 300398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 300408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 300413 */     GIR_RootConstrainSelectedInstOperands,
     /* 300414 */     // GIR_Coverage, 1001,
     /* 300414 */     GIR_EraseRootFromParent_Done,
     /* 300415 */   // Label 5104: @300415
     /* 300415 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(300495), // Rule ID 8607 //
     /* 300420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 300423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 300434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 300441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 300448 */     // (fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 300448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 300451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 300458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 300463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 300468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 300473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 300478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 300488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 300493 */     GIR_RootConstrainSelectedInstOperands,
     /* 300494 */     // GIR_Coverage, 8607,
     /* 300494 */     GIR_EraseRootFromParent_Done,
     /* 300495 */   // Label 5105: @300495
     /* 300495 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(300574), // Rule ID 1009 //
     /* 300500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 300503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300528 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 300528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
     /* 300531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 300538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 300548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 300558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300572 */     GIR_RootConstrainSelectedInstOperands,
     /* 300573 */     // GIR_Coverage, 1009,
     /* 300573 */     GIR_EraseRootFromParent_Done,
     /* 300574 */   // Label 5106: @300574
     /* 300574 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(300653), // Rule ID 1011 //
     /* 300579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 300582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 300586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300607 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 300607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_t16_e64),
     /* 300610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 300617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 300627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 300637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300651 */     GIR_RootConstrainSelectedInstOperands,
     /* 300652 */     // GIR_Coverage, 1011,
     /* 300652 */     GIR_EraseRootFromParent_Done,
     /* 300653 */   // Label 5107: @300653
     /* 300653 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(300732), // Rule ID 1013 //
     /* 300658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 300661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 300686 */     // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 300686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_fake16_e64),
     /* 300689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 300696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 300706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 300716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300730 */     GIR_RootConstrainSelectedInstOperands,
     /* 300731 */     // GIR_Coverage, 1013,
     /* 300731 */     GIR_EraseRootFromParent_Done,
     /* 300732 */   // Label 5108: @300732
     /* 300732 */   GIM_Reject,
     /* 300733 */ // Label 5099: @300733
     /* 300733 */ GIM_Reject,
     /* 300734 */ // Label 5094: @300734
     /* 300734 */ GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(301486),
     /* 300739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 300742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 300745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 300748 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(300827), // Rule ID 2741 //
     /* 300753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 300756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 300767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 300774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 300781 */     // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 300781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 300784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 300791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 300801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 300811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300825 */     GIR_RootConstrainSelectedInstOperands,
     /* 300826 */     // GIR_Coverage, 2741,
     /* 300826 */     GIR_EraseRootFromParent_Done,
     /* 300827 */   // Label 5110: @300827
     /* 300827 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(300906), // Rule ID 2742 //
     /* 300832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 300835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 300846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 300853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 300860 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 300860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 300863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 300870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 300880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 300890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300904 */     GIR_RootConstrainSelectedInstOperands,
     /* 300905 */     // GIR_Coverage, 2742,
     /* 300905 */     GIR_EraseRootFromParent_Done,
     /* 300906 */   // Label 5111: @300906
     /* 300906 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(300985), // Rule ID 2743 //
     /* 300911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 300914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 300925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 300932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 300939 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 300939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 300942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 300944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 300949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 300954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 300959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 300964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 300969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 300974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300983 */     GIR_RootConstrainSelectedInstOperands,
     /* 300984 */     // GIR_Coverage, 2743,
     /* 300984 */     GIR_EraseRootFromParent_Done,
     /* 300985 */   // Label 5112: @300985
     /* 300985 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(301064), // Rule ID 8650 //
     /* 300990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 300993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 300997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 301011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301018 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 301018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 301021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 301028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 301033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 301038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 301043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 301048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301062 */     GIR_RootConstrainSelectedInstOperands,
     /* 301063 */     // GIR_Coverage, 8650,
     /* 301063 */     GIR_EraseRootFromParent_Done,
     /* 301064 */   // Label 5113: @301064
     /* 301064 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(301143), // Rule ID 8651 //
     /* 301069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 301072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 301083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301097 */     // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 301097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 301100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 301107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 301112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 301117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 301122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 301127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301141 */     GIR_RootConstrainSelectedInstOperands,
     /* 301142 */     // GIR_Coverage, 8651,
     /* 301142 */     GIR_EraseRootFromParent_Done,
     /* 301143 */   // Label 5114: @301143
     /* 301143 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(301222), // Rule ID 8652 //
     /* 301148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 301151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 301169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 301176 */     // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 301176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
     /* 301179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 301186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 301191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 301196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 301201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 301206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301220 */     GIR_RootConstrainSelectedInstOperands,
     /* 301221 */     // GIR_Coverage, 8652,
     /* 301221 */     GIR_EraseRootFromParent_Done,
     /* 301222 */   // Label 5115: @301222
     /* 301222 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(301261), // Rule ID 111 //
     /* 301227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 301230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 301246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13749),
     /* 301250 */     // (fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13749>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
     /* 301250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
     /* 301255 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 301259 */     GIR_RootConstrainSelectedInstOperands,
     /* 301260 */     // GIR_Coverage, 111,
     /* 301260 */     GIR_Done,
     /* 301261 */   // Label 5116: @301261
     /* 301261 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(301331), // Rule ID 7631 //
     /* 301266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
     /* 301269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301294 */     // (fma:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
     /* 301294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F32_e64),
     /* 301297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301329 */     GIR_RootConstrainSelectedInstOperands,
     /* 301330 */     // GIR_Coverage, 7631,
     /* 301330 */     GIR_EraseRootFromParent_Done,
     /* 301331 */   // Label 5117: @301331
     /* 301331 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(301408), // Rule ID 927 //
     /* 301336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301361 */     // (fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 301364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 301381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301406 */     GIR_RootConstrainSelectedInstOperands,
     /* 301407 */     // GIR_Coverage, 927,
     /* 301407 */     GIR_EraseRootFromParent_Done,
     /* 301408 */   // Label 5118: @301408
     /* 301408 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(301485), // Rule ID 8588 //
     /* 301413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301438 */     // (fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 301441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 301448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 301453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 301458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 301463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 301478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 301483 */     GIR_RootConstrainSelectedInstOperands,
     /* 301484 */     // GIR_Coverage, 8588,
     /* 301484 */     GIR_EraseRootFromParent_Done,
     /* 301485 */   // Label 5119: @301485
     /* 301485 */   GIM_Reject,
     /* 301486 */ // Label 5109: @301486
     /* 301486 */ GIM_Reject,
     /* 301487 */ // Label 5095: @301487
     /* 301487 */ GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(301718),
     /* 301492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301498 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 301501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301505 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(301571), // Rule ID 7635 //
     /* 301510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmacF64Inst),
     /* 301513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301534 */     // (fma:{ *:[f64] } (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src0), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src1), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src2))  =>  (V_FMAC_F64_e64:{ *:[f64] } 0:{ *:[i32] }, ?:{ *:[f64] }:$src0, 0:{ *:[i32] }, ?:{ *:[f64] }:$src1, 0:{ *:[i32] }, ?:{ *:[f64] }:$src2)
     /* 301534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F64_e64),
     /* 301537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301569 */     GIR_RootConstrainSelectedInstOperands,
     /* 301570 */     // GIR_Coverage, 7635,
     /* 301570 */     GIR_EraseRootFromParent_Done,
     /* 301571 */   // Label 5121: @301571
     /* 301571 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(301644), // Rule ID 930 //
     /* 301576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301597 */     // (fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 301600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 301617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 301637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 301642 */     GIR_RootConstrainSelectedInstOperands,
     /* 301643 */     // GIR_Coverage, 930,
     /* 301643 */     GIR_EraseRootFromParent_Done,
     /* 301644 */   // Label 5122: @301644
     /* 301644 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(301717), // Rule ID 8590 //
     /* 301649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 301663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 301670 */     // (fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 301670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 301673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 301680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 301685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 301690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 301695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 301710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 301715 */     GIR_RootConstrainSelectedInstOperands,
     /* 301716 */     // GIR_Coverage, 8590,
     /* 301716 */     GIR_EraseRootFromParent_Done,
     /* 301717 */   // Label 5123: @301717
     /* 301717 */   GIM_Reject,
     /* 301718 */ // Label 5120: @301718
     /* 301718 */ GIM_Reject,
     /* 301719 */ // Label 5096: @301719
     /* 301719 */ GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(301810), // Rule ID 1090 //
     /* 301724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 301727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 301730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 301733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 301744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 301751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 301758 */   // (fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
     /* 301758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
     /* 301761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 301778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301808 */   GIR_RootConstrainSelectedInstOperands,
     /* 301809 */   // GIR_Coverage, 1090,
     /* 301809 */   GIR_EraseRootFromParent_Done,
     /* 301810 */ // Label 5124: @301810
     /* 301810 */ GIM_Reject,
     /* 301811 */ // Label 5097: @301811
     /* 301811 */ GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(301905), // Rule ID 1309 //
     /* 301816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 301819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 301832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 301839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 301846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 301853 */   // (fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
     /* 301853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
     /* 301856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 301863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 301873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 301883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 301888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301903 */   GIR_RootConstrainSelectedInstOperands,
     /* 301904 */   // GIR_Coverage, 1309,
     /* 301904 */   GIR_EraseRootFromParent_Done,
     /* 301905 */ // Label 5125: @301905
     /* 301905 */ GIM_Reject,
     /* 301906 */ // Label 5098: @301906
     /* 301906 */ GIM_Reject,
     /* 301907 */ // Label 64: @301907
     /* 301907 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5128*/ GIMT_Encode4(302852),
     /* 301918 */ /*GILLT_s16*//*Label 5126*/ GIMT_Encode4(301926),
     /* 301922 */ /*GILLT_s32*//*Label 5127*/ GIMT_Encode4(302164),
     /* 301926 */ // Label 5126: @301926
     /* 301926 */ GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(302163),
     /* 301931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 301934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 301937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 301940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 301944 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(302010), // Rule ID 7019 //
     /* 301949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 301952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 301973 */     // (fmad:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 301973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
     /* 301976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 301978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 301986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 301994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302008 */     GIR_RootConstrainSelectedInstOperands,
     /* 302009 */     // GIR_Coverage, 7019,
     /* 302009 */     GIR_EraseRootFromParent_Done,
     /* 302010 */   // Label 5130: @302010
     /* 302010 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(302086), // Rule ID 1014 //
     /* 302015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 302018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302039 */     // (fmad:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 302042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 302069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302084 */     GIR_RootConstrainSelectedInstOperands,
     /* 302085 */     // GIR_Coverage, 1014,
     /* 302085 */     GIR_EraseRootFromParent_Done,
     /* 302086 */   // Label 5131: @302086
     /* 302086 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(302162), // Rule ID 8608 //
     /* 302091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
     /* 302094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302115 */     // (fmad:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
     /* 302118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 302125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 302130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 302135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 302140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 302145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 302155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 302160 */     GIR_RootConstrainSelectedInstOperands,
     /* 302161 */     // GIR_Coverage, 8608,
     /* 302161 */     GIR_EraseRootFromParent_Done,
     /* 302162 */   // Label 5132: @302162
     /* 302162 */   GIM_Reject,
     /* 302163 */ // Label 5129: @302163
     /* 302163 */ GIM_Reject,
     /* 302164 */ // Label 5127: @302164
     /* 302164 */ GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(302851),
     /* 302169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 302175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 302178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302182 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(302257), // Rule ID 2725 //
     /* 302187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 302197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302211 */     // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 302211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 302214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 302221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 302231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 302241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302255 */     GIR_RootConstrainSelectedInstOperands,
     /* 302256 */     // GIR_Coverage, 2725,
     /* 302256 */     GIR_EraseRootFromParent_Done,
     /* 302257 */   // Label 5134: @302257
     /* 302257 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(302332), // Rule ID 2726 //
     /* 302262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 302279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302286 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 302286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 302289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 302296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 302306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 302316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302330 */     GIR_RootConstrainSelectedInstOperands,
     /* 302331 */     // GIR_Coverage, 2726,
     /* 302331 */     GIR_EraseRootFromParent_Done,
     /* 302332 */   // Label 5135: @302332
     /* 302332 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(302407), // Rule ID 2727 //
     /* 302337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 302361 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 302361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 302364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 302371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 302381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 302391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302405 */     GIR_RootConstrainSelectedInstOperands,
     /* 302406 */     // GIR_Coverage, 2727,
     /* 302406 */     GIR_EraseRootFromParent_Done,
     /* 302407 */   // Label 5136: @302407
     /* 302407 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(302473), // Rule ID 7013 //
     /* 302412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 302415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 302422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 302429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
     /* 302436 */     // (fmad:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 302436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
     /* 302439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302471 */     GIR_RootConstrainSelectedInstOperands,
     /* 302472 */     // GIR_Coverage, 7013,
     /* 302472 */     GIR_EraseRootFromParent_Done,
     /* 302473 */   // Label 5137: @302473
     /* 302473 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(302548), // Rule ID 8647 //
     /* 302478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 302495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302502 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 302502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 302505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 302512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 302517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 302522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 302527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 302532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302546 */     GIR_RootConstrainSelectedInstOperands,
     /* 302547 */     // GIR_Coverage, 8647,
     /* 302547 */     GIR_EraseRootFromParent_Done,
     /* 302548 */   // Label 5138: @302548
     /* 302548 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(302623), // Rule ID 8648 //
     /* 302553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 302563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302577 */     // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
     /* 302577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 302580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 302587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 302592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 302597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 302602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 302607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302621 */     GIR_RootConstrainSelectedInstOperands,
     /* 302622 */     // GIR_Coverage, 8648,
     /* 302622 */     GIR_EraseRootFromParent_Done,
     /* 302623 */   // Label 5139: @302623
     /* 302623 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(302698), // Rule ID 8649 //
     /* 302628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 302631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 302645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
     /* 302652 */     // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
     /* 302652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
     /* 302655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 302662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 302667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 302672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 302677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 302682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302696 */     GIR_RootConstrainSelectedInstOperands,
     /* 302697 */     // GIR_Coverage, 8649,
     /* 302697 */     GIR_EraseRootFromParent_Done,
     /* 302698 */   // Label 5140: @302698
     /* 302698 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(302774), // Rule ID 922 //
     /* 302703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 302706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302727 */     // (fmad:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 302730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 302737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 302747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 302757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 302767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 302772 */     GIR_RootConstrainSelectedInstOperands,
     /* 302773 */     // GIR_Coverage, 922,
     /* 302773 */     GIR_EraseRootFromParent_Done,
     /* 302774 */   // Label 5141: @302774
     /* 302774 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(302850), // Rule ID 8585 //
     /* 302779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
     /* 302782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 302796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302803 */     // (fmad:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 302803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
     /* 302806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 302813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 302818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 302823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 302828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 302833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 302838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 302843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 302848 */     GIR_RootConstrainSelectedInstOperands,
     /* 302849 */     // GIR_Coverage, 8585,
     /* 302849 */     GIR_EraseRootFromParent_Done,
     /* 302850 */   // Label 5142: @302850
     /* 302850 */   GIM_Reject,
     /* 302851 */ // Label 5133: @302851
     /* 302851 */ GIM_Reject,
     /* 302852 */ // Label 5128: @302852
     /* 302852 */ GIM_Reject,
     /* 302853 */ // Label 65: @302853
     /* 302853 */ GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(302970), // Rule ID 7446 //
     /* 302858 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 302861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 302867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 302871 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 302885 */   // (fpow:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_EXP_F32_e64:{ *:[f32] } 0:{ *:[i32] }, (V_MUL_LEGACY_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, (V_LOG_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0), 0:{ *:[i1] }, 0:{ *:[i32] }))
     /* 302885 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 302888 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
     /* 302892 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 302902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 302907 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302910 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 302913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
     /* 302922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 302932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 302937 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302940 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 302943 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302946 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 302951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
     /* 302954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 302956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302968 */   GIR_RootConstrainSelectedInstOperands,
     /* 302969 */   // GIR_Coverage, 7446,
     /* 302969 */   GIR_EraseRootFromParent_Done,
     /* 302970 */ // Label 5143: @302970
     /* 302970 */ GIM_Reject,
     /* 302971 */ // Label 66: @302971
     /* 302971 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(303193),
     /* 302976 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 302979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302982 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(303053), // Rule ID 2699 //
     /* 302987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 302990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 302994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21562),
     /* 302998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303005 */     // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21562>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 303005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
     /* 303012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 303052 */     // GIR_Coverage, 2699,
     /* 303052 */     GIR_EraseRootFromParent_Done,
     /* 303053 */   // Label 5145: @303053
     /* 303053 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(303147),
     /* 303058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303062 */     GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(303104), // Rule ID 743 //
     /* 303067 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 303070 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303077 */       // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303077 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
     /* 303080 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303082 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303087 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303092 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303097 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303102 */       GIR_RootConstrainSelectedInstOperands,
     /* 303103 */       // GIR_Coverage, 743,
     /* 303103 */       GIR_EraseRootFromParent_Done,
     /* 303104 */     // Label 5147: @303104
     /* 303104 */     GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(303146), // Rule ID 747 //
     /* 303109 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303112 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303119 */       // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303119 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
     /* 303122 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303124 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303129 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303134 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303139 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303144 */       GIR_RootConstrainSelectedInstOperands,
     /* 303145 */       // GIR_Coverage, 747,
     /* 303145 */       GIR_EraseRootFromParent_Done,
     /* 303146 */     // Label 5148: @303146
     /* 303146 */     GIM_Reject,
     /* 303147 */   // Label 5146: @303147
     /* 303147 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(303192), // Rule ID 745 //
     /* 303152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 303166 */     // (fexp2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 303166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
     /* 303169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303190 */     GIR_RootConstrainSelectedInstOperands,
     /* 303191 */     // GIR_Coverage, 745,
     /* 303191 */     GIR_EraseRootFromParent_Done,
     /* 303192 */   // Label 5149: @303192
     /* 303192 */   GIM_Reject,
     /* 303193 */ // Label 5144: @303193
     /* 303193 */ GIM_Reject,
     /* 303194 */ // Label 67: @303194
     /* 303194 */ GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(303416),
     /* 303199 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 303202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303205 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(303276), // Rule ID 2701 //
     /* 303210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 303213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 303217 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21564),
     /* 303221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303228 */     // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21564>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 303228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
     /* 303235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 303275 */     // GIR_Coverage, 2701,
     /* 303275 */     GIR_EraseRootFromParent_Done,
     /* 303276 */   // Label 5151: @303276
     /* 303276 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(303370),
     /* 303281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303285 */     GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(303327), // Rule ID 737 //
     /* 303290 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 303293 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303300 */       // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303300 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
     /* 303303 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303305 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303310 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303315 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303320 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303325 */       GIR_RootConstrainSelectedInstOperands,
     /* 303326 */       // GIR_Coverage, 737,
     /* 303326 */       GIR_EraseRootFromParent_Done,
     /* 303327 */     // Label 5153: @303327
     /* 303327 */     GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(303369), // Rule ID 741 //
     /* 303332 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303335 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303342 */       // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303342 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
     /* 303345 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303347 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303352 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303357 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303362 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303367 */       GIR_RootConstrainSelectedInstOperands,
     /* 303368 */       // GIR_Coverage, 741,
     /* 303368 */       GIR_EraseRootFromParent_Done,
     /* 303369 */     // Label 5154: @303369
     /* 303369 */     GIM_Reject,
     /* 303370 */   // Label 5152: @303370
     /* 303370 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(303415), // Rule ID 739 //
     /* 303375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 303389 */     // (flog2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 303389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
     /* 303392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303413 */     GIR_RootConstrainSelectedInstOperands,
     /* 303414 */     // GIR_Coverage, 739,
     /* 303414 */     GIR_EraseRootFromParent_Done,
     /* 303415 */   // Label 5155: @303415
     /* 303415 */   GIM_Reject,
     /* 303416 */ // Label 5150: @303416
     /* 303416 */ GIM_Reject,
     /* 303417 */ // Label 68: @303417
     /* 303417 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5159*/ GIMT_Encode4(303779),
     /* 303428 */ /*GILLT_s16*//*Label 5156*/ GIMT_Encode4(303440),
     /* 303432 */ /*GILLT_s32*//*Label 5157*/ GIMT_Encode4(303645),
     /* 303436 */ /*GILLT_s64*//*Label 5158*/ GIMT_Encode4(303712),
     /* 303440 */ // Label 5156: @303440
     /* 303440 */ GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(303644),
     /* 303445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303451 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(303514), // Rule ID 2507 //
     /* 303456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 303459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303477 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 303477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
     /* 303480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 303497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 303502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303512 */     GIR_RootConstrainSelectedInstOperands,
     /* 303513 */     // GIR_Coverage, 2507,
     /* 303513 */     GIR_EraseRootFromParent_Done,
     /* 303514 */   // Label 5161: @303514
     /* 303514 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(303580), // Rule ID 2509 //
     /* 303519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303540 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
     /* 303540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
     /* 303543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 303560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 303565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303578 */     GIR_RootConstrainSelectedInstOperands,
     /* 303579 */     // GIR_Coverage, 2509,
     /* 303579 */     GIR_EraseRootFromParent_Done,
     /* 303580 */   // Label 5162: @303580
     /* 303580 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(303643), // Rule ID 2511 //
     /* 303585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 303588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303606 */     // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 303606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
     /* 303609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 303626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 303631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303641 */     GIR_RootConstrainSelectedInstOperands,
     /* 303642 */     // GIR_Coverage, 2511,
     /* 303642 */     GIR_EraseRootFromParent_Done,
     /* 303643 */   // Label 5163: @303643
     /* 303643 */   GIM_Reject,
     /* 303644 */ // Label 5160: @303644
     /* 303644 */ GIM_Reject,
     /* 303645 */ // Label 5157: @303645
     /* 303645 */ GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(303711), // Rule ID 822 //
     /* 303650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303660 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303667 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303674 */   // (fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
     /* 303677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 303694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 303699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303709 */   GIR_RootConstrainSelectedInstOperands,
     /* 303710 */   // GIR_Coverage, 822,
     /* 303710 */   GIR_EraseRootFromParent_Done,
     /* 303711 */ // Label 5164: @303711
     /* 303711 */ GIM_Reject,
     /* 303712 */ // Label 5158: @303712
     /* 303712 */ GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(303778), // Rule ID 982 //
     /* 303717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 303727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 303734 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 303741 */   // (fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 303741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 303744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303746 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 303751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 303756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 303761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 303766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 303771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 303776 */   GIR_RootConstrainSelectedInstOperands,
     /* 303777 */   // GIR_Coverage, 982,
     /* 303777 */   GIR_EraseRootFromParent_Done,
     /* 303778 */ // Label 5165: @303778
     /* 303778 */ GIM_Reject,
     /* 303779 */ // Label 5159: @303779
     /* 303779 */ GIM_Reject,
     /* 303780 */ // Label 69: @303780
     /* 303780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5171*/ GIMT_Encode4(305642),
     /* 303791 */ /*GILLT_s16*//*Label 5166*/ GIMT_Encode4(303811),
     /* 303795 */ /*GILLT_s32*//*Label 5167*/ GIMT_Encode4(304297),
     /* 303799 */ /*GILLT_s64*//*Label 5168*/ GIMT_Encode4(304551),
     /* 303803 */ /*GILLT_v2s16*//*Label 5169*/ GIMT_Encode4(305229),
     /* 303807 */ /*GILLT_v2s32*//*Label 5170*/ GIMT_Encode4(305585),
     /* 303811 */ // Label 5166: @303811
     /* 303811 */ GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(304296),
     /* 303816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303819 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(303892), // Rule ID 7364 //
     /* 303824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 303828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 303836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 303845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 303849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303851 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src))<<P:Predicate_anonymous_34635>>  =>  (S_OR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
     /* 303851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 303854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 303858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303863 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 303873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 303878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 303880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 303884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 303890 */     GIR_RootConstrainSelectedInstOperands,
     /* 303891 */     // GIR_Coverage, 7364,
     /* 303891 */     GIR_EraseRootFromParent_Done,
     /* 303892 */   // Label 5173: @303892
     /* 303892 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(303961), // Rule ID 7380 //
     /* 303897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 303900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 303912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 303921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303923 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 303923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 303930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303935 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 303945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 303947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 303950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 303959 */     GIR_RootConstrainSelectedInstOperands,
     /* 303960 */     // GIR_Coverage, 7380,
     /* 303960 */     GIR_EraseRootFromParent_Done,
     /* 303961 */   // Label 5174: @303961
     /* 303961 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(304022), // Rule ID 7383 //
     /* 303966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 303969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 303981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 303990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303992 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src))  =>  (V_OR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 303992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
     /* 303995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 303997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304000 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
     /* 304010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 304017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304020 */     GIR_RootConstrainSelectedInstOperands,
     /* 304021 */     // GIR_Coverage, 7383,
     /* 304021 */     GIR_EraseRootFromParent_Done,
     /* 304022 */   // Label 5175: @304022
     /* 304022 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(304091), // Rule ID 7386 //
     /* 304027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 304042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 304046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304053 */     // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 304053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304065 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 304075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 304080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 304089 */     GIR_RootConstrainSelectedInstOperands,
     /* 304090 */     // GIR_Coverage, 7386,
     /* 304090 */     GIR_EraseRootFromParent_Done,
     /* 304091 */   // Label 5176: @304091
     /* 304091 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(304147), // Rule ID 7362 //
     /* 304096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 304108 */     // (fneg:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_34635>>  =>  (S_XOR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
     /* 304108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 304111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304120 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 304130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 304135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 304137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 304145 */     GIR_RootConstrainSelectedInstOperands,
     /* 304146 */     // GIR_Coverage, 7362,
     /* 304146 */     GIR_EraseRootFromParent_Done,
     /* 304147 */   // Label 5177: @304147
     /* 304147 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(304199), // Rule ID 7379 //
     /* 304152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 304155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304163 */     // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 304163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304175 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 304185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 304190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304197 */     GIR_RootConstrainSelectedInstOperands,
     /* 304198 */     // GIR_Coverage, 7379,
     /* 304198 */     GIR_EraseRootFromParent_Done,
     /* 304199 */   // Label 5178: @304199
     /* 304199 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(304243), // Rule ID 7382 //
     /* 304204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 304207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 304215 */     // (fneg:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_XOR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 304215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
     /* 304218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304223 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
     /* 304233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304236 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304241 */     GIR_RootConstrainSelectedInstOperands,
     /* 304242 */     // GIR_Coverage, 7382,
     /* 304242 */     GIR_EraseRootFromParent_Done,
     /* 304243 */   // Label 5179: @304243
     /* 304243 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(304295), // Rule ID 7385 //
     /* 304248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 304251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304259 */     // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 304259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304271 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
     /* 304281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 304286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304293 */     GIR_RootConstrainSelectedInstOperands,
     /* 304294 */     // GIR_Coverage, 7385,
     /* 304294 */     GIR_EraseRootFromParent_Done,
     /* 304295 */   // Label 5180: @304295
     /* 304295 */   GIM_Reject,
     /* 304296 */ // Label 5172: @304296
     /* 304296 */ GIM_Reject,
     /* 304297 */ // Label 5167: @304297
     /* 304297 */ GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(304550),
     /* 304302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304305 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(304378), // Rule ID 7359 //
     /* 304310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 304322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 304335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304337 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src))<<P:Predicate_anonymous_34635>>  =>  (S_OR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
     /* 304337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 304340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304349 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 304359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 304364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 304366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 304370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 304376 */     GIR_RootConstrainSelectedInstOperands,
     /* 304377 */     // GIR_Coverage, 7359,
     /* 304377 */     GIR_EraseRootFromParent_Done,
     /* 304378 */   // Label 5182: @304378
     /* 304378 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(304444), // Rule ID 7375 //
     /* 304383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 304395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304406 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src))  =>  (V_OR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 304406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304418 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 304428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 304433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 304442 */     GIR_RootConstrainSelectedInstOperands,
     /* 304443 */     // GIR_Coverage, 7375,
     /* 304443 */     GIR_EraseRootFromParent_Done,
     /* 304444 */   // Label 5183: @304444
     /* 304444 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(304500), // Rule ID 7361 //
     /* 304449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 304461 */     // (fneg:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_34635>>  =>  (S_XOR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
     /* 304461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 304464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304473 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 304483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 304488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 304490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 304498 */     GIR_RootConstrainSelectedInstOperands,
     /* 304499 */     // GIR_Coverage, 7361,
     /* 304499 */     GIR_EraseRootFromParent_Done,
     /* 304500 */   // Label 5184: @304500
     /* 304500 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(304549), // Rule ID 7377 //
     /* 304505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304513 */     // (fneg:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_XOR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 304513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304525 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
     /* 304535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 304537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 304540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 304542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 304547 */     GIR_RootConstrainSelectedInstOperands,
     /* 304548 */     // GIR_Coverage, 7377,
     /* 304548 */     GIR_EraseRootFromParent_Done,
     /* 304549 */   // Label 5185: @304549
     /* 304549 */   GIM_Reject,
     /* 304550 */ // Label 5181: @304550
     /* 304550 */ GIM_Reject,
     /* 304551 */ // Label 5168: @304551
     /* 304551 */ GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(305228),
     /* 304556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304559 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(304747), // Rule ID 7374 //
     /* 304564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 304576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 304589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304591 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src))<<P:Predicate_anonymous_34635>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_OR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 304591 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 304594 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304598 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304603 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
     /* 304613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304615 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 304618 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304622 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304627 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 304633 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 304638 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304643 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 304646 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 304650 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304655 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304658 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304661 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 304664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 304666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 304669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304678 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 304686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304698 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 304704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 304709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 304717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304722 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 304725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 304728 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 304731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 304741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 304746 */     // GIR_Coverage, 7374,
     /* 304746 */     GIR_EraseRootFromParent_Done,
     /* 304747 */   // Label 5187: @304747
     /* 304747 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(304908), // Rule ID 7392 //
     /* 304752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 304756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 304764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 304773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304775 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src))  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_OR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 304775 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 304778 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304782 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304787 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 304793 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304798 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 304803 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 304806 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304810 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304815 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
     /* 304825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 304827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 304830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 304834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304839 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 304842 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 304845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304859 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 304865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 304875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 304878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304883 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 304886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 304889 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 304892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 304897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 304907 */     // GIR_Coverage, 7392,
     /* 304907 */     GIR_EraseRootFromParent_Done,
     /* 304908 */   // Label 5188: @304908
     /* 304908 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(305081), // Rule ID 7373 //
     /* 304913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 304925 */     // (fneg:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_34635>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_XOR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 304925 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 304928 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 304932 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304937 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
     /* 304947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304949 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 304952 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304956 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304961 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 304967 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 304972 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 304977 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 304980 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 304984 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304989 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304992 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 304995 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 304998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 305003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305012 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 305038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 305043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 305048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 305051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305056 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 305059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 305062 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 305065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 305070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 305075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 305080 */     // GIR_Coverage, 7373,
     /* 305080 */     GIR_EraseRootFromParent_Done,
     /* 305081 */   // Label 5189: @305081
     /* 305081 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(305227), // Rule ID 7391 //
     /* 305086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305094 */     // (fneg:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_XOR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 305094 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 305097 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305101 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305106 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 305112 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305117 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 305125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305134 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
     /* 305144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 305149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 305153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305158 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 305161 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 305164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305178 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 305184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 305197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305202 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 305205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 305208 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 305211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305226 */     // GIR_Coverage, 7391,
     /* 305226 */     GIR_EraseRootFromParent_Done,
     /* 305227 */   // Label 5190: @305227
     /* 305227 */   GIM_Reject,
     /* 305228 */ // Label 5186: @305228
     /* 305228 */ GIM_Reject,
     /* 305229 */ // Label 5169: @305229
     /* 305229 */ GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(305584),
     /* 305234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 305237 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(305339), // Rule ID 7367 //
     /* 305242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 305254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 305266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 305270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 305274 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 305276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305281 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2147450879),
     /* 305292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 305296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305298 */     // (fneg:{ *:[v2f16] } (bitconvert:{ *:[v2f16] } (and:{ *:[i32] } SReg_32:{ *:[i32] }:$src, 2147450879:{ *:[i32] })<<P:Predicate_and_oneuse>>))<<P:Predicate_anonymous_34635>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 305298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 305301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305310 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 305320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 305325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 305327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /* 305331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 305337 */     GIR_RootConstrainSelectedInstOperands,
     /* 305338 */     // GIR_Coverage, 7367,
     /* 305338 */     GIR_EraseRootFromParent_Done,
     /* 305339 */   // Label 5192: @305339
     /* 305339 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(305412), // Rule ID 7368 //
     /* 305344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 305356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 305360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 305369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305371 */     // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src))<<P:Predicate_anonymous_34635>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 305371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 305374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305383 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 305393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
     /* 305398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 305400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 305404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 305410 */     GIR_RootConstrainSelectedInstOperands,
     /* 305411 */     // GIR_Coverage, 7368,
     /* 305411 */     GIR_EraseRootFromParent_Done,
     /* 305412 */   // Label 5193: @305412
     /* 305412 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(305478), // Rule ID 7389 //
     /* 305417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 305429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 305433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305440 */     // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src))  =>  (V_OR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 305440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305452 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 305462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
     /* 305467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 305476 */     GIR_RootConstrainSelectedInstOperands,
     /* 305477 */     // GIR_Coverage, 7389,
     /* 305477 */     GIR_EraseRootFromParent_Done,
     /* 305478 */   // Label 5194: @305478
     /* 305478 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(305534), // Rule ID 7365 //
     /* 305483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34635),
     /* 305495 */     // (fneg:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_34635>>  =>  (S_XOR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
     /* 305495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 305498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305507 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 305517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
     /* 305522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 305524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 305532 */     GIR_RootConstrainSelectedInstOperands,
     /* 305533 */     // GIR_Coverage, 7365,
     /* 305533 */     GIR_EraseRootFromParent_Done,
     /* 305534 */   // Label 5195: @305534
     /* 305534 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(305583), // Rule ID 7387 //
     /* 305539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305547 */     // (fneg:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 305547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 305554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305559 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
     /* 305569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
     /* 305574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305579 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305581 */     GIR_RootConstrainSelectedInstOperands,
     /* 305582 */     // GIR_Coverage, 7387,
     /* 305582 */     GIR_EraseRootFromParent_Done,
     /* 305583 */   // Label 5196: @305583
     /* 305583 */   GIM_Reject,
     /* 305584 */ // Label 5191: @305584
     /* 305584 */ GIM_Reject,
     /* 305585 */ // Label 5170: @305585
     /* 305585 */ GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(305641), // Rule ID 7393 //
     /* 305590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 305593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 305596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305604 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34683),
     /* 305608 */   // (fneg:{ *:[v2f32] } VReg_64:{ *:[v2f32] }:$src)<<P:Predicate_anonymous_34683>>  =>  (V_PK_ADD_F32:{ *:[v2f32] } 11:{ *:[i32] }, VReg_64:{ *:[v2f32] }:$src, 11:{ *:[i32] }, 0:{ *:[i64] }, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 305608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 305611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 305616 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 305618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 305621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305639 */   GIR_RootConstrainSelectedInstOperands,
     /* 305640 */   // GIR_Coverage, 7393,
     /* 305640 */   GIR_EraseRootFromParent_Done,
     /* 305641 */ // Label 5197: @305641
     /* 305641 */ GIM_Reject,
     /* 305642 */ // Label 5171: @305642
     /* 305642 */ GIM_Reject,
     /* 305643 */ // Label 70: @305643
     /* 305643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 5200*/ GIMT_Encode4(306042),
     /* 305654 */ /*GILLT_s32*//*Label 5198*/ GIMT_Encode4(305662),
     /* 305658 */ /*GILLT_s64*//*Label 5199*/ GIMT_Encode4(305836),
     /* 305662 */ // Label 5198: @305662
     /* 305662 */ GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(305835),
     /* 305667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305670 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(305697), // Rule ID 31 //
     /* 305675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 305678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 305682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13716),
     /* 305686 */     // (fpextend:{ *:[f32] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13716>>  =>  (S_CVT_F32_F16:{ *:[f32] } f16:{ *:[f16] }:$src0)
     /* 305686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_F16),
     /* 305691 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 305695 */     GIR_RootConstrainSelectedInstOperands,
     /* 305696 */     // GIR_Coverage, 31,
     /* 305696 */     GIR_Done,
     /* 305697 */   // Label 5202: @305697
     /* 305697 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(305743), // Rule ID 644 //
     /* 305702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 305705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305716 */     // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 305719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 305726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 305736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 305741 */     GIR_RootConstrainSelectedInstOperands,
     /* 305742 */     // GIR_Coverage, 644,
     /* 305742 */     GIR_EraseRootFromParent_Done,
     /* 305743 */   // Label 5203: @305743
     /* 305743 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(305789), // Rule ID 648 //
     /* 305748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 305762 */     // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_fake16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 305762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 305765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 305772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 305782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 305787 */     GIR_RootConstrainSelectedInstOperands,
     /* 305788 */     // GIR_Coverage, 648,
     /* 305788 */     GIR_EraseRootFromParent_Done,
     /* 305789 */   // Label 5204: @305789
     /* 305789 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(305834), // Rule ID 646 //
     /* 305794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 305801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 305808 */     // (fpextend:{ *:[f32] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F32_F16_t16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 305808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 305811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 305818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 305823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305832 */     GIR_RootConstrainSelectedInstOperands,
     /* 305833 */     // GIR_Coverage, 646,
     /* 305833 */     GIR_EraseRootFromParent_Done,
     /* 305834 */   // Label 5205: @305834
     /* 305834 */   GIM_Reject,
     /* 305835 */ // Label 5201: @305835
     /* 305835 */ GIM_Reject,
     /* 305836 */ // Label 5199: @305836
     /* 305836 */ GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(305888), // Rule ID 6996 //
     /* 305841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 305844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305851 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 305851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 305858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305863 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305870 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305873 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 305881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305886 */   GIR_RootConstrainSelectedInstOperands,
     /* 305887 */   // GIR_Coverage, 6996,
     /* 305887 */   GIR_EraseRootFromParent_Done,
     /* 305888 */ // Label 5206: @305888
     /* 305888 */ GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(305943), // Rule ID 7002 //
     /* 305893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 305896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305903 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 305903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 305910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305915 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305918 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305922 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305925 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305928 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 305936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305941 */   GIR_RootConstrainSelectedInstOperands,
     /* 305942 */   // GIR_Coverage, 7002,
     /* 305942 */   GIR_EraseRootFromParent_Done,
     /* 305943 */ // Label 5207: @305943
     /* 305943 */ GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(305995), // Rule ID 7008 //
     /* 305948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 305951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 305958 */   // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
     /* 305958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 305965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305970 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305973 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 305977 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305980 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 305985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
     /* 305988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 305990 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305993 */   GIR_RootConstrainSelectedInstOperands,
     /* 305994 */   // GIR_Coverage, 7008,
     /* 305994 */   GIR_EraseRootFromParent_Done,
     /* 305995 */ // Label 5208: @305995
     /* 305995 */ GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(306041), // Rule ID 630 //
     /* 306000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306007 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 306014 */   // (fpextend:{ *:[f64] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_F32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 306014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e64),
     /* 306017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 306034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 306039 */   GIR_RootConstrainSelectedInstOperands,
     /* 306040 */   // GIR_Coverage, 630,
     /* 306040 */   GIR_EraseRootFromParent_Done,
     /* 306041 */ // Label 5209: @306041
     /* 306041 */ GIM_Reject,
     /* 306042 */ // Label 5200: @306042
     /* 306042 */ GIM_Reject,
     /* 306043 */ // Label 71: @306043
     /* 306043 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5213*/ GIMT_Encode4(306978),
     /* 306054 */ /*GILLT_s16*//*Label 5210*/ GIMT_Encode4(306070),
     /* 306058 */ /*GILLT_s32*//*Label 5211*/ GIMT_Encode4(306686), GIMT_Encode4(0),
     /* 306066 */ /*GILLT_v2s16*//*Label 5212*/ GIMT_Encode4(306733),
     /* 306070 */ // Label 5210: @306070
     /* 306070 */ GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(306685),
     /* 306075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306078 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(306196), // Rule ID 2747 //
     /* 306083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 306086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 306098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 306106 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 306110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306133 */     // (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 306133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 306150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 306167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 306172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 306177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 306182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306194 */     GIR_RootConstrainSelectedInstOperands,
     /* 306195 */     // GIR_Coverage, 2747,
     /* 306195 */     GIR_EraseRootFromParent_Done,
     /* 306196 */   // Label 5215: @306196
     /* 306196 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(306314), // Rule ID 2731 //
     /* 306201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 306204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 306216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 306224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 306228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306251 */     // (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 306251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 306268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 306285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 306290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 306295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 306300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306312 */     GIR_RootConstrainSelectedInstOperands,
     /* 306313 */     // GIR_Coverage, 2731,
     /* 306313 */     GIR_EraseRootFromParent_Done,
     /* 306314 */   // Label 5216: @306314
     /* 306314 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(306417), // Rule ID 2729 //
     /* 306319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 306322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 306334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 306342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306358 */     // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 306358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 306375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 306392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 306397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306415 */     GIR_RootConstrainSelectedInstOperands,
     /* 306416 */     // GIR_Coverage, 2729,
     /* 306416 */     GIR_EraseRootFromParent_Done,
     /* 306417 */   // Label 5217: @306417
     /* 306417 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(306520), // Rule ID 2745 //
     /* 306422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 306425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 306437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 306445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 306461 */     // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
     /* 306461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 306478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 306495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 306500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306518 */     GIR_RootConstrainSelectedInstOperands,
     /* 306519 */     // GIR_Coverage, 2745,
     /* 306519 */     GIR_EraseRootFromParent_Done,
     /* 306520 */   // Label 5218: @306520
     /* 306520 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(306547), // Rule ID 36 //
     /* 306525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 306528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 306532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13721),
     /* 306536 */     // (fpround:{ *:[f16] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13721>>  =>  (S_CVT_F16_F32:{ *:[f16] } f32:{ *:[f32] }:$src0)
     /* 306536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F16_F32),
     /* 306541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 306545 */     GIR_RootConstrainSelectedInstOperands,
     /* 306546 */     // GIR_Coverage, 36,
     /* 306546 */     GIR_Done,
     /* 306547 */   // Label 5219: @306547
     /* 306547 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(306593), // Rule ID 638 //
     /* 306552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 306555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 306566 */     // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 306566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 306569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 306586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 306591 */     GIR_RootConstrainSelectedInstOperands,
     /* 306592 */     // GIR_Coverage, 638,
     /* 306592 */     GIR_EraseRootFromParent_Done,
     /* 306593 */   // Label 5220: @306593
     /* 306593 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(306639), // Rule ID 642 //
     /* 306598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 306601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 306612 */     // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 306612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 306615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 306632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 306637 */     GIR_RootConstrainSelectedInstOperands,
     /* 306638 */     // GIR_Coverage, 642,
     /* 306638 */     GIR_EraseRootFromParent_Done,
     /* 306639 */   // Label 5221: @306639
     /* 306639 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(306684), // Rule ID 640 //
     /* 306644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 306647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 306651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 306658 */     // (fpround:{ *:[f16] } (VOP3OpSelMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0)
     /* 306658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 306661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306682 */     GIR_RootConstrainSelectedInstOperands,
     /* 306683 */     // GIR_Coverage, 640,
     /* 306683 */     GIR_EraseRootFromParent_Done,
     /* 306684 */   // Label 5222: @306684
     /* 306684 */   GIM_Reject,
     /* 306685 */ // Label 5214: @306685
     /* 306685 */ GIM_Reject,
     /* 306686 */ // Label 5211: @306686
     /* 306686 */ GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(306732), // Rule ID 628 //
     /* 306691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306698 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 306705 */   // (fpround:{ *:[f32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F64_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 306705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 306708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 306715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 306720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 306725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 306730 */   GIR_RootConstrainSelectedInstOperands,
     /* 306731 */   // GIR_Coverage, 628,
     /* 306731 */   GIR_EraseRootFromParent_Done,
     /* 306732 */ // Label 5223: @306732
     /* 306732 */ GIM_Reject,
     /* 306733 */ // Label 5212: @306733
     /* 306733 */ GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(306829), // Rule ID 2630 //
     /* 306738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /* 306741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306748 */   // (fpround:{ *:[v2f16] } v2f32:{ *:[v2f32] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub1:{ *:[i32] }))
     /* 306748 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306751 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306755 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306760 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 306766 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306771 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306788 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 306794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /* 306807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306827 */   GIR_RootConstrainSelectedInstOperands,
     /* 306828 */   // GIR_Coverage, 2630,
     /* 306828 */   GIR_EraseRootFromParent_Done,
     /* 306829 */ // Label 5224: @306829
     /* 306829 */ GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(306977), // Rule ID 2631 //
     /* 306834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
     /* 306837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 306844 */   // (fpround:{ *:[v2f16] } v2f64:{ *:[v2f64] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub0_sub1:{ *:[i32] })), 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub2_sub3:{ *:[i32] })))
     /* 306844 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 306847 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306851 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306856 */   GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(24), // src
     /* 306862 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306867 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 306872 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 306875 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 306879 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306884 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 306887 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 306890 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 306893 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 306896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306898 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 306901 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306905 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306910 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 306916 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 306921 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 306926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
     /* 306933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306938 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306944 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306947 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
     /* 306955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 306957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306960 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 306969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306975 */   GIR_RootConstrainSelectedInstOperands,
     /* 306976 */   // GIR_Coverage, 2631,
     /* 306976 */   GIR_EraseRootFromParent_Done,
     /* 306977 */ // Label 5225: @306977
     /* 306977 */ GIM_Reject,
     /* 306978 */ // Label 5213: @306978
     /* 306978 */ GIM_Reject,
     /* 306979 */ // Label 72: @306979
     /* 306979 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5229*/ GIMT_Encode4(307704),
     /* 306990 */ /*GILLT_s1*//*Label 5226*/ GIMT_Encode4(307002),
     /* 306994 */ /*GILLT_s16*//*Label 5227*/ GIMT_Encode4(307275),
     /* 306998 */ /*GILLT_s32*//*Label 5228*/ GIMT_Encode4(307422),
     /* 307002 */ // Label 5226: @307002
     /* 307002 */ GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(307057), // Rule ID 7536 //
     /* 307007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 307010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307024 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 307024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 307027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307032 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307055 */   GIR_RootConstrainSelectedInstOperands,
     /* 307056 */   // GIR_Coverage, 7536,
     /* 307056 */   GIR_EraseRootFromParent_Done,
     /* 307057 */ // Label 5230: @307057
     /* 307057 */ GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(307115), // Rule ID 7538 //
     /* 307062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307079 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 307079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 307082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307087 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307113 */   GIR_RootConstrainSelectedInstOperands,
     /* 307114 */   // GIR_Coverage, 7538,
     /* 307114 */   GIR_EraseRootFromParent_Done,
     /* 307115 */ // Label 5231: @307115
     /* 307115 */ GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(307170), // Rule ID 7540 //
     /* 307120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307137 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 307137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 307140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307145 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 307155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307168 */   GIR_RootConstrainSelectedInstOperands,
     /* 307169 */   // GIR_Coverage, 7540,
     /* 307169 */   GIR_EraseRootFromParent_Done,
     /* 307170 */ // Label 5232: @307170
     /* 307170 */ GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(307222), // Rule ID 7542 //
     /* 307175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307182 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307189 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
     /* 307189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 307192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307197 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 307207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307220 */   GIR_RootConstrainSelectedInstOperands,
     /* 307221 */   // GIR_Coverage, 7542,
     /* 307221 */   GIR_EraseRootFromParent_Done,
     /* 307222 */ // Label 5233: @307222
     /* 307222 */ GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(307274), // Rule ID 7544 //
     /* 307227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307241 */   // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, -4616189618054758400:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
     /* 307241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 307244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307249 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-4616189618054758400),
     /* 307259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307272 */   GIR_RootConstrainSelectedInstOperands,
     /* 307273 */   // GIR_Coverage, 7544,
     /* 307273 */   GIR_EraseRootFromParent_Done,
     /* 307274 */ // Label 5234: @307274
     /* 307274 */ GIM_Reject,
     /* 307275 */ // Label 5227: @307275
     /* 307275 */ GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(307421),
     /* 307280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307283 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(307329), // Rule ID 715 //
     /* 307288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 307291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 307302 */     // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 307302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_e64),
     /* 307305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 307322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 307327 */     GIR_RootConstrainSelectedInstOperands,
     /* 307328 */     // GIR_Coverage, 715,
     /* 307328 */     GIR_EraseRootFromParent_Done,
     /* 307329 */   // Label 5236: @307329
     /* 307329 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(307375), // Rule ID 717 //
     /* 307334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 307348 */     // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 307348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_fake16_e64),
     /* 307351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 307368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 307373 */     GIR_RootConstrainSelectedInstOperands,
     /* 307374 */     // GIR_Coverage, 717,
     /* 307374 */     GIR_EraseRootFromParent_Done,
     /* 307375 */   // Label 5237: @307375
     /* 307375 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(307420), // Rule ID 716 //
     /* 307380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 307387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 307394 */     // (fp_to_sint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 307394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_t16_e64),
     /* 307397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307418 */     GIR_RootConstrainSelectedInstOperands,
     /* 307419 */     // GIR_Coverage, 716,
     /* 307419 */     GIR_EraseRootFromParent_Done,
     /* 307420 */   // Label 5238: @307420
     /* 307420 */   GIM_Reject,
     /* 307421 */ // Label 5235: @307421
     /* 307421 */ GIM_Reject,
     /* 307422 */ // Label 5228: @307422
     /* 307422 */ GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(307452), // Rule ID 29 //
     /* 307427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 307430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 307437 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13714),
     /* 307441 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13714>>  =>  (S_CVT_I32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
     /* 307441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_I32_F32),
     /* 307446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 307450 */   GIR_RootConstrainSelectedInstOperands,
     /* 307451 */   // GIR_Coverage, 29,
     /* 307451 */   GIR_Done,
     /* 307452 */ // Label 5239: @307452
     /* 307452 */ GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(307504), // Rule ID 6997 //
     /* 307457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 307460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307467 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
     /* 307467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 307474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307479 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307482 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 307486 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307489 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 307497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307502 */   GIR_RootConstrainSelectedInstOperands,
     /* 307503 */   // GIR_Coverage, 6997,
     /* 307503 */   GIR_EraseRootFromParent_Done,
     /* 307504 */ // Label 5240: @307504
     /* 307504 */ GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(307559), // Rule ID 7003 //
     /* 307509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307519 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
     /* 307519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 307526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307531 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307534 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 307538 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307541 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307544 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 307552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307557 */   GIR_RootConstrainSelectedInstOperands,
     /* 307558 */   // GIR_Coverage, 7003,
     /* 307558 */   GIR_EraseRootFromParent_Done,
     /* 307559 */ // Label 5241: @307559
     /* 307559 */ GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(307611), // Rule ID 7009 //
     /* 307564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307574 */   // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
     /* 307574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 307581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307586 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307589 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 307593 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307596 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 307599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
     /* 307604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307609 */   GIR_RootConstrainSelectedInstOperands,
     /* 307610 */   // GIR_Coverage, 7009,
     /* 307610 */   GIR_EraseRootFromParent_Done,
     /* 307611 */ // Label 5242: @307611
     /* 307611 */ GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(307657), // Rule ID 626 //
     /* 307616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 307630 */   // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 307630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F64_e64),
     /* 307633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 307650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 307655 */   GIR_RootConstrainSelectedInstOperands,
     /* 307656 */   // GIR_Coverage, 626,
     /* 307656 */   GIR_EraseRootFromParent_Done,
     /* 307657 */ // Label 5243: @307657
     /* 307657 */ GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(307703), // Rule ID 636 //
     /* 307662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 307669 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 307676 */   // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 307676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e64),
     /* 307679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 307681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 307696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 307701 */   GIR_RootConstrainSelectedInstOperands,
     /* 307702 */   // GIR_Coverage, 636,
     /* 307702 */   GIR_EraseRootFromParent_Done,
     /* 307703 */ // Label 5244: @307703
     /* 307703 */ GIM_Reject,
     /* 307704 */ // Label 5229: @307704
     /* 307704 */ GIM_Reject,
     /* 307705 */ // Label 73: @307705
     /* 307705 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5248*/ GIMT_Encode4(308430),
     /* 307716 */ /*GILLT_s1*//*Label 5245*/ GIMT_Encode4(307728),
     /* 307720 */ /*GILLT_s16*//*Label 5246*/ GIMT_Encode4(308001),
     /* 307724 */ /*GILLT_s32*//*Label 5247*/ GIMT_Encode4(308148),
     /* 307728 */ // Label 5245: @307728
     /* 307728 */ GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(307783), // Rule ID 7535 //
     /* 307733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 307736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307750 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 307750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
     /* 307753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307758 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307781 */   GIR_RootConstrainSelectedInstOperands,
     /* 307782 */   // GIR_Coverage, 7535,
     /* 307782 */   GIR_EraseRootFromParent_Done,
     /* 307783 */ // Label 5249: @307783
     /* 307783 */ GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(307841), // Rule ID 7537 //
     /* 307788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 307791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307798 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307805 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 307805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
     /* 307808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307813 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307839 */   GIR_RootConstrainSelectedInstOperands,
     /* 307840 */   // GIR_Coverage, 7537,
     /* 307840 */   GIR_EraseRootFromParent_Done,
     /* 307841 */ // Label 5250: @307841
     /* 307841 */ GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(307896), // Rule ID 7539 //
     /* 307846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 307849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307856 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307863 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
     /* 307863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
     /* 307866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307871 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 307881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307894 */   GIR_RootConstrainSelectedInstOperands,
     /* 307895 */   // GIR_Coverage, 7539,
     /* 307895 */   GIR_EraseRootFromParent_Done,
     /* 307896 */ // Label 5251: @307896
     /* 307896 */ GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(307948), // Rule ID 7541 //
     /* 307901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307915 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
     /* 307915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
     /* 307918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307923 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 307933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307946 */   GIR_RootConstrainSelectedInstOperands,
     /* 307947 */   // GIR_Coverage, 7541,
     /* 307947 */   GIR_EraseRootFromParent_Done,
     /* 307948 */ // Label 5252: @307948
     /* 307948 */ GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(308000), // Rule ID 7543 //
     /* 307953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 307960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 307967 */   // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
     /* 307967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
     /* 307970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 307972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307975 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
     /* 307985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 307990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 307995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307998 */   GIR_RootConstrainSelectedInstOperands,
     /* 307999 */   // GIR_Coverage, 7543,
     /* 307999 */   GIR_EraseRootFromParent_Done,
     /* 308000 */ // Label 5253: @308000
     /* 308000 */ GIM_Reject,
     /* 308001 */ // Label 5246: @308001
     /* 308001 */ GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(308147),
     /* 308006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308009 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(308055), // Rule ID 712 //
     /* 308014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 308017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 308028 */     // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 308028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_e64),
     /* 308031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 308038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 308048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 308053 */     GIR_RootConstrainSelectedInstOperands,
     /* 308054 */     // GIR_Coverage, 712,
     /* 308054 */     GIR_EraseRootFromParent_Done,
     /* 308055 */   // Label 5255: @308055
     /* 308055 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(308101), // Rule ID 714 //
     /* 308060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 308063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 308074 */     // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 308074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_fake16_e64),
     /* 308077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 308084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 308094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 308099 */     GIR_RootConstrainSelectedInstOperands,
     /* 308100 */     // GIR_Coverage, 714,
     /* 308100 */     GIR_EraseRootFromParent_Done,
     /* 308101 */   // Label 5256: @308101
     /* 308101 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(308146), // Rule ID 713 //
     /* 308106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 308109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 308113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 308120 */     // (fp_to_uint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_U16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 308120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_t16_e64),
     /* 308123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 308130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308144 */     GIR_RootConstrainSelectedInstOperands,
     /* 308145 */     // GIR_Coverage, 713,
     /* 308145 */     GIR_EraseRootFromParent_Done,
     /* 308146 */   // Label 5257: @308146
     /* 308146 */   GIM_Reject,
     /* 308147 */ // Label 5254: @308147
     /* 308147 */ GIM_Reject,
     /* 308148 */ // Label 5247: @308148
     /* 308148 */ GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(308178), // Rule ID 30 //
     /* 308153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 308156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 308163 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13715),
     /* 308167 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13715>>  =>  (S_CVT_U32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
     /* 308167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_U32_F32),
     /* 308172 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 308176 */   GIR_RootConstrainSelectedInstOperands,
     /* 308177 */   // GIR_Coverage, 30,
     /* 308177 */   GIR_Done,
     /* 308178 */ // Label 5258: @308178
     /* 308178 */ GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(308230), // Rule ID 6998 //
     /* 308183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 308186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308193 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
     /* 308193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
     /* 308200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308205 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308208 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308212 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308215 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 308223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308228 */   GIR_RootConstrainSelectedInstOperands,
     /* 308229 */   // GIR_Coverage, 6998,
     /* 308229 */   GIR_EraseRootFromParent_Done,
     /* 308230 */ // Label 5259: @308230
     /* 308230 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(308285), // Rule ID 7004 //
     /* 308235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 308238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308245 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
     /* 308245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
     /* 308252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308257 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308260 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308264 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308267 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308270 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 308278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308283 */   GIR_RootConstrainSelectedInstOperands,
     /* 308284 */   // GIR_Coverage, 7004,
     /* 308284 */   GIR_EraseRootFromParent_Done,
     /* 308285 */ // Label 5260: @308285
     /* 308285 */ GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(308337), // Rule ID 7010 //
     /* 308290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 308293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308300 */   // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
     /* 308300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
     /* 308307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308312 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308315 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308319 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308322 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
     /* 308330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308335 */   GIR_RootConstrainSelectedInstOperands,
     /* 308336 */   // GIR_Coverage, 7010,
     /* 308336 */   GIR_EraseRootFromParent_Done,
     /* 308337 */ // Label 5261: @308337
     /* 308337 */ GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(308383), // Rule ID 631 //
     /* 308342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308349 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 308356 */   // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 308356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F64_e64),
     /* 308359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 308366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 308376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 308381 */   GIR_RootConstrainSelectedInstOperands,
     /* 308382 */   // GIR_Coverage, 631,
     /* 308382 */   GIR_EraseRootFromParent_Done,
     /* 308383 */ // Label 5262: @308383
     /* 308383 */ GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(308429), // Rule ID 635 //
     /* 308388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 308402 */   // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 308402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e64),
     /* 308405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 308412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 308422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 308427 */   GIR_RootConstrainSelectedInstOperands,
     /* 308428 */   // GIR_Coverage, 635,
     /* 308428 */   GIR_EraseRootFromParent_Done,
     /* 308429 */ // Label 5263: @308429
     /* 308429 */ GIM_Reject,
     /* 308430 */ // Label 5248: @308430
     /* 308430 */ GIM_Reject,
     /* 308431 */ // Label 74: @308431
     /* 308431 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5267*/ GIMT_Encode4(309163),
     /* 308442 */ /*GILLT_s16*//*Label 5264*/ GIMT_Encode4(308454),
     /* 308446 */ /*GILLT_s32*//*Label 5265*/ GIMT_Encode4(308957),
     /* 308450 */ /*GILLT_s64*//*Label 5266*/ GIMT_Encode4(309069),
     /* 308454 */ // Label 5264: @308454
     /* 308454 */ GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(308506), // Rule ID 6999 //
     /* 308459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 308462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308469 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 308469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 308476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 308490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308504 */   GIR_RootConstrainSelectedInstOperands,
     /* 308505 */   // GIR_Coverage, 6999,
     /* 308505 */   GIR_EraseRootFromParent_Done,
     /* 308506 */ // Label 5268: @308506
     /* 308506 */ GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(308561), // Rule ID 7005 //
     /* 308511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 308514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 308521 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 308521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 308528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308533 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 308542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308559 */   GIR_RootConstrainSelectedInstOperands,
     /* 308560 */   // GIR_Coverage, 7005,
     /* 308560 */   GIR_EraseRootFromParent_Done,
     /* 308561 */ // Label 5269: @308561
     /* 308561 */ GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(308613), // Rule ID 7011 //
     /* 308566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 308569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308576 */   // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 308576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
     /* 308583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308588 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 308597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308611 */   GIR_RootConstrainSelectedInstOperands,
     /* 308612 */   // GIR_Coverage, 7011,
     /* 308612 */   GIR_EraseRootFromParent_Done,
     /* 308613 */ // Label 5270: @308613
     /* 308613 */ GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(308675), // Rule ID 7561 //
     /* 308618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 308621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 308624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308628 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 308628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 308635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308640 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308643 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308646 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308649 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 308659 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
     /* 308668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308673 */   GIR_RootConstrainSelectedInstOperands,
     /* 308674 */   // GIR_Coverage, 7561,
     /* 308674 */   GIR_EraseRootFromParent_Done,
     /* 308675 */ // Label 5271: @308675
     /* 308675 */ GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(308749), // Rule ID 7562 //
     /* 308680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 308683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 308686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 308690 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 308690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 308697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308702 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308705 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308708 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308711 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 308721 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 308730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308747 */   GIR_RootConstrainSelectedInstOperands,
     /* 308748 */   // GIR_Coverage, 7562,
     /* 308748 */   GIR_EraseRootFromParent_Done,
     /* 308749 */ // Label 5272: @308749
     /* 308749 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(308820), // Rule ID 7563 //
     /* 308754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 308757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 308760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308764 */   // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 308764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 308771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308776 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308779 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308782 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 308785 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
     /* 308795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 308804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308818 */   GIR_RootConstrainSelectedInstOperands,
     /* 308819 */   // GIR_Coverage, 7563,
     /* 308819 */   GIR_EraseRootFromParent_Done,
     /* 308820 */ // Label 5273: @308820
     /* 308820 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(308864), // Rule ID 709 //
     /* 308825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 308828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 308842 */   // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 308842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_e64),
     /* 308845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 308857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 308862 */   GIR_RootConstrainSelectedInstOperands,
     /* 308863 */   // GIR_Coverage, 709,
     /* 308863 */   GIR_EraseRootFromParent_Done,
     /* 308864 */ // Label 5274: @308864
     /* 308864 */ GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(308908), // Rule ID 711 //
     /* 308869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 308872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 308886 */   // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 308886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_fake16_e64),
     /* 308889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 308901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 308906 */   GIR_RootConstrainSelectedInstOperands,
     /* 308907 */   // GIR_Coverage, 711,
     /* 308907 */   GIR_EraseRootFromParent_Done,
     /* 308908 */ // Label 5275: @308908
     /* 308908 */ GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(308956), // Rule ID 710 //
     /* 308913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 308916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 308923 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 308930 */   // (sint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_I16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
     /* 308930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_t16_e64),
     /* 308933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 308935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 308940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 308945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308954 */   GIR_RootConstrainSelectedInstOperands,
     /* 308955 */   // GIR_Coverage, 710,
     /* 308955 */   GIR_EraseRootFromParent_Done,
     /* 308956 */ // Label 5276: @308956
     /* 308956 */ GIM_Reject,
     /* 308957 */ // Label 5265: @308957
     /* 308957 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(308987), // Rule ID 27 //
     /* 308962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 308965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 308972 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13712),
     /* 308976 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13712>>  =>  (S_CVT_F32_I32:{ *:[f32] } i32:{ *:[i32] }:$src0)
     /* 308976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_I32),
     /* 308981 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 308985 */   GIR_RootConstrainSelectedInstOperands,
     /* 308986 */   // GIR_Coverage, 27,
     /* 308986 */   GIR_Done,
     /* 308987 */ // Label 5277: @308987
     /* 308987 */ GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(309027), // Rule ID 7567 //
     /* 308992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 308995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 308999 */   // (sint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
     /* 308999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 309002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309013 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 309023 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 309025 */   GIR_RootConstrainSelectedInstOperands,
     /* 309026 */   // GIR_Coverage, 7567,
     /* 309026 */   GIR_EraseRootFromParent_Done,
     /* 309027 */ // Label 5278: @309027
     /* 309027 */ GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(309068), // Rule ID 633 //
     /* 309032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309039 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 309046 */   // (sint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_I32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 309046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e64),
     /* 309049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 309061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 309066 */   GIR_RootConstrainSelectedInstOperands,
     /* 309067 */   // GIR_Coverage, 633,
     /* 309067 */   GIR_EraseRootFromParent_Done,
     /* 309068 */ // Label 5279: @309068
     /* 309068 */ GIM_Reject,
     /* 309069 */ // Label 5266: @309069
     /* 309069 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(309121), // Rule ID 7569 //
     /* 309074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 309077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 309081 */   // (sint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_I32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 309081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 309088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309093 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309096 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309099 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309102 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 309105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e32),
     /* 309114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309119 */   GIR_RootConstrainSelectedInstOperands,
     /* 309120 */   // GIR_Coverage, 7569,
     /* 309120 */   GIR_EraseRootFromParent_Done,
     /* 309121 */ // Label 5280: @309121
     /* 309121 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(309162), // Rule ID 627 //
     /* 309126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 309133 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 309140 */   // (sint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_I32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 309140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e64),
     /* 309143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 309155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 309160 */   GIR_RootConstrainSelectedInstOperands,
     /* 309161 */   // GIR_Coverage, 627,
     /* 309161 */   GIR_EraseRootFromParent_Done,
     /* 309162 */ // Label 5281: @309162
     /* 309162 */ GIM_Reject,
     /* 309163 */ // Label 5267: @309163
     /* 309163 */ GIM_Reject,
     /* 309164 */ // Label 75: @309164
     /* 309164 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5285*/ GIMT_Encode4(309896),
     /* 309175 */ /*GILLT_s16*//*Label 5282*/ GIMT_Encode4(309187),
     /* 309179 */ /*GILLT_s32*//*Label 5283*/ GIMT_Encode4(309690),
     /* 309183 */ /*GILLT_s64*//*Label 5284*/ GIMT_Encode4(309802),
     /* 309187 */ // Label 5282: @309187
     /* 309187 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(309239), // Rule ID 7000 //
     /* 309192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 309195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309202 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 309202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 309209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309214 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
     /* 309223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309237 */   GIR_RootConstrainSelectedInstOperands,
     /* 309238 */   // GIR_Coverage, 7000,
     /* 309238 */   GIR_EraseRootFromParent_Done,
     /* 309239 */ // Label 5286: @309239
     /* 309239 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(309294), // Rule ID 7006 //
     /* 309244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 309247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309254 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 309254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 309261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309266 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 309275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309292 */   GIR_RootConstrainSelectedInstOperands,
     /* 309293 */   // GIR_Coverage, 7006,
     /* 309293 */   GIR_EraseRootFromParent_Done,
     /* 309294 */ // Label 5287: @309294
     /* 309294 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(309346), // Rule ID 7012 //
     /* 309299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 309302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309309 */   // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
     /* 309309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
     /* 309316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309321 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 309330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309344 */   GIR_RootConstrainSelectedInstOperands,
     /* 309345 */   // GIR_Coverage, 7012,
     /* 309345 */   GIR_EraseRootFromParent_Done,
     /* 309346 */ // Label 5288: @309346
     /* 309346 */ GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(309408), // Rule ID 7564 //
     /* 309351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 309354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 309357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309361 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 309361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 309368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309373 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309376 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309379 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309382 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 309392 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
     /* 309401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309406 */   GIR_RootConstrainSelectedInstOperands,
     /* 309407 */   // GIR_Coverage, 7564,
     /* 309407 */   GIR_EraseRootFromParent_Done,
     /* 309408 */ // Label 5289: @309408
     /* 309408 */ GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(309482), // Rule ID 7565 //
     /* 309413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 309416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 309419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309423 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 309423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 309430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309435 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309438 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309441 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309444 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 309454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
     /* 309463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309480 */   GIR_RootConstrainSelectedInstOperands,
     /* 309481 */   // GIR_Coverage, 7565,
     /* 309481 */   GIR_EraseRootFromParent_Done,
     /* 309482 */ // Label 5290: @309482
     /* 309482 */ GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(309553), // Rule ID 7566 //
     /* 309487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 309490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 309493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309497 */   // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 309497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 309504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309509 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309512 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309515 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309518 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
     /* 309528 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
     /* 309537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309551 */   GIR_RootConstrainSelectedInstOperands,
     /* 309552 */   // GIR_Coverage, 7566,
     /* 309552 */   GIR_EraseRootFromParent_Done,
     /* 309553 */ // Label 5291: @309553
     /* 309553 */ GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(309597), // Rule ID 706 //
     /* 309558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 309561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 309575 */   // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 309575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_e64),
     /* 309578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 309590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 309595 */   GIR_RootConstrainSelectedInstOperands,
     /* 309596 */   // GIR_Coverage, 706,
     /* 309596 */   GIR_EraseRootFromParent_Done,
     /* 309597 */ // Label 5292: @309597
     /* 309597 */ GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(309641), // Rule ID 708 //
     /* 309602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 309605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 309619 */   // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 309619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_fake16_e64),
     /* 309622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 309634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 309639 */   GIR_RootConstrainSelectedInstOperands,
     /* 309640 */   // GIR_Coverage, 708,
     /* 309640 */   GIR_EraseRootFromParent_Done,
     /* 309641 */ // Label 5293: @309641
     /* 309641 */ GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(309689), // Rule ID 707 //
     /* 309646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 309649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 309656 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 309663 */   // (uint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_U16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
     /* 309663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_t16_e64),
     /* 309666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 309673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309687 */   GIR_RootConstrainSelectedInstOperands,
     /* 309688 */   // GIR_Coverage, 707,
     /* 309688 */   GIR_EraseRootFromParent_Done,
     /* 309689 */ // Label 5294: @309689
     /* 309689 */ GIM_Reject,
     /* 309690 */ // Label 5283: @309690
     /* 309690 */ GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(309720), // Rule ID 28 //
     /* 309695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 309698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 309705 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13713),
     /* 309709 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13713>>  =>  (S_CVT_F32_U32:{ *:[f32] } i32:{ *:[i32] }:$src0)
     /* 309709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_U32),
     /* 309714 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 309718 */   GIR_RootConstrainSelectedInstOperands,
     /* 309719 */   // GIR_Coverage, 28,
     /* 309719 */   GIR_Done,
     /* 309720 */ // Label 5295: @309720
     /* 309720 */ GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(309760), // Rule ID 7568 //
     /* 309725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 309728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309732 */   // (uint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
     /* 309732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 309735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309746 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 309756 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 309758 */   GIR_RootConstrainSelectedInstOperands,
     /* 309759 */   // GIR_Coverage, 7568,
     /* 309759 */   GIR_EraseRootFromParent_Done,
     /* 309760 */ // Label 5296: @309760
     /* 309760 */ GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(309801), // Rule ID 634 //
     /* 309765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 309772 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 309779 */   // (uint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_U32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 309779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e64),
     /* 309782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 309794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 309799 */   GIR_RootConstrainSelectedInstOperands,
     /* 309800 */   // GIR_Coverage, 634,
     /* 309800 */   GIR_EraseRootFromParent_Done,
     /* 309801 */ // Label 5297: @309801
     /* 309801 */ GIM_Reject,
     /* 309802 */ // Label 5284: @309802
     /* 309802 */ GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(309854), // Rule ID 7570 //
     /* 309807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 309810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 309814 */   // (uint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_U32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
     /* 309814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
     /* 309821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309826 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309829 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309832 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 309835 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 309838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 309842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e32),
     /* 309847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309852 */   GIR_RootConstrainSelectedInstOperands,
     /* 309853 */   // GIR_Coverage, 7570,
     /* 309853 */   GIR_EraseRootFromParent_Done,
     /* 309854 */ // Label 5298: @309854
     /* 309854 */ GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(309895), // Rule ID 632 //
     /* 309859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 309866 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 309873 */   // (uint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_U32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 309873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e64),
     /* 309876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 309878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 309883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 309888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 309893 */   GIR_RootConstrainSelectedInstOperands,
     /* 309894 */   // GIR_Coverage, 632,
     /* 309894 */   GIR_EraseRootFromParent_Done,
     /* 309895 */ // Label 5299: @309895
     /* 309895 */ GIM_Reject,
     /* 309896 */ // Label 5285: @309896
     /* 309896 */ GIM_Reject,
     /* 309897 */ // Label 76: @309897
     /* 309897 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5304*/ GIMT_Encode4(310697),
     /* 309908 */ /*GILLT_s16*//*Label 5300*/ GIMT_Encode4(309924),
     /* 309912 */ /*GILLT_s32*//*Label 5301*/ GIMT_Encode4(310138),
     /* 309916 */ /*GILLT_s64*//*Label 5302*/ GIMT_Encode4(310253),
     /* 309920 */ /*GILLT_v2s16*//*Label 5303*/ GIMT_Encode4(310582),
     /* 309924 */ // Label 5300: @309924
     /* 309924 */ GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(310137),
     /* 309929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309932 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(309988), // Rule ID 7363 //
     /* 309937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 309941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 309945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34637),
     /* 309949 */     // (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_34637>>  =>  (S_AND_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32767:{ *:[i32] }))
     /* 309949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 309952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 309956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309961 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 309971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 309976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 309978 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 309980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 309986 */     GIR_RootConstrainSelectedInstOperands,
     /* 309987 */     // GIR_Coverage, 7363,
     /* 309987 */     GIR_EraseRootFromParent_Done,
     /* 309988 */   // Label 5306: @309988
     /* 309988 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(310040), // Rule ID 7378 //
     /* 309993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 309996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310004 */     // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 310004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310016 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 310026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 310031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 310038 */     GIR_RootConstrainSelectedInstOperands,
     /* 310039 */     // GIR_Coverage, 7378,
     /* 310039 */     GIR_EraseRootFromParent_Done,
     /* 310040 */   // Label 5307: @310040
     /* 310040 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(310084), // Rule ID 7381 //
     /* 310045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 310048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 310052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 310056 */     // (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_AND_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32767:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
     /* 310056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
     /* 310059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310064 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32767),
     /* 310074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 310079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 310082 */     GIR_RootConstrainSelectedInstOperands,
     /* 310083 */     // GIR_Coverage, 7381,
     /* 310083 */     GIR_EraseRootFromParent_Done,
     /* 310084 */   // Label 5308: @310084
     /* 310084 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(310136), // Rule ID 7384 //
     /* 310089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 310092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310100 */     // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
     /* 310100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310112 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 310122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 310127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310132 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 310134 */     GIR_RootConstrainSelectedInstOperands,
     /* 310135 */     // GIR_Coverage, 7384,
     /* 310135 */     GIR_EraseRootFromParent_Done,
     /* 310136 */   // Label 5309: @310136
     /* 310136 */   GIM_Reject,
     /* 310137 */ // Label 5305: @310137
     /* 310137 */ GIM_Reject,
     /* 310138 */ // Label 5301: @310138
     /* 310138 */ GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(310252),
     /* 310143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310146 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(310202), // Rule ID 7360 //
     /* 310151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 310155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 310159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34637),
     /* 310163 */     // (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_34637>>  =>  (S_AND_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] }))
     /* 310163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 310166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310175 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 310185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 310190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 310192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 310194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 310200 */     GIR_RootConstrainSelectedInstOperands,
     /* 310201 */     // GIR_Coverage, 7360,
     /* 310201 */     GIR_EraseRootFromParent_Done,
     /* 310202 */   // Label 5311: @310202
     /* 310202 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(310251), // Rule ID 7376 //
     /* 310207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310215 */     // (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_AND_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
     /* 310215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310227 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 310237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 310242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 310249 */     GIR_RootConstrainSelectedInstOperands,
     /* 310250 */     // GIR_Coverage, 7376,
     /* 310250 */     GIR_EraseRootFromParent_Done,
     /* 310251 */   // Label 5312: @310251
     /* 310251 */   GIM_Reject,
     /* 310252 */ // Label 5310: @310252
     /* 310252 */ GIM_Reject,
     /* 310253 */ // Label 5302: @310253
     /* 310253 */ GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(310581),
     /* 310258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310261 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(310434), // Rule ID 7372 //
     /* 310266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 310270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 310274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34637),
     /* 310278 */     // (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_34637>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
     /* 310278 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 310281 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310285 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310290 */     GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483647),
     /* 310300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 310302 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 310305 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310309 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310314 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 310320 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 310325 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 310330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 310333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 310337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310342 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 310345 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 310348 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
     /* 310351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 310356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310365 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 310373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310385 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 310391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 310396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 310401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 310404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310409 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 310412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310415 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 310418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 310423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 310428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 310433 */     // GIR_Coverage, 7372,
     /* 310433 */     GIR_EraseRootFromParent_Done,
     /* 310434 */   // Label 5314: @310434
     /* 310434 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(310580), // Rule ID 7390 //
     /* 310439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 310443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 310447 */     // (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483647:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
     /* 310447 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 310450 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310454 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310459 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 310465 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310470 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 310475 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 310478 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310482 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310487 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483647),
     /* 310497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 310499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 310506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310511 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310514 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 310517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310531 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 310537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 310547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 310550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310555 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 310558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310561 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 310564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 310569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310579 */     // GIR_Coverage, 7390,
     /* 310579 */     GIR_EraseRootFromParent_Done,
     /* 310580 */   // Label 5315: @310580
     /* 310580 */   GIM_Reject,
     /* 310581 */ // Label 5313: @310581
     /* 310581 */ GIM_Reject,
     /* 310582 */ // Label 5303: @310582
     /* 310582 */ GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(310696),
     /* 310587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 310590 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(310646), // Rule ID 7366 //
     /* 310595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 310599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 310603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34637),
     /* 310607 */     // (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_34637>>  =>  (S_AND_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147450879:{ *:[i32] }))
     /* 310607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 310610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310619 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
     /* 310629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 310634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 310636 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 310638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 310644 */     GIR_RootConstrainSelectedInstOperands,
     /* 310645 */     // GIR_Coverage, 7366,
     /* 310645 */     GIR_EraseRootFromParent_Done,
     /* 310646 */   // Label 5317: @310646
     /* 310646 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(310695), // Rule ID 7388 //
     /* 310651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310659 */     // (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_AND_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147450879:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
     /* 310659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310671 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
     /* 310681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
     /* 310686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 310693 */     GIR_RootConstrainSelectedInstOperands,
     /* 310694 */     // GIR_Coverage, 7388,
     /* 310694 */     GIR_EraseRootFromParent_Done,
     /* 310695 */   // Label 5318: @310695
     /* 310695 */   GIM_Reject,
     /* 310696 */ // Label 5316: @310696
     /* 310696 */ GIM_Reject,
     /* 310697 */ // Label 5304: @310697
     /* 310697 */ GIM_Reject,
     /* 310698 */ // Label 77: @310698
     /* 310698 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5322*/ GIMT_Encode4(311122),
     /* 310709 */ /*GILLT_s16*//*Label 5319*/ GIMT_Encode4(310725),
     /* 310713 */ /*GILLT_s32*//*Label 5320*/ GIMT_Encode4(310857), GIMT_Encode4(0),
     /* 310721 */ /*GILLT_v2s16*//*Label 5321*/ GIMT_Encode4(311068),
     /* 310725 */ // Label 5319: @310725
     /* 310725 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(310856),
     /* 310730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310733 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(310783), // Rule ID 7394 //
     /* 310738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 310741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310745 */     // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, ?:{ *:[f16] }:$src1)
     /* 310745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310757 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 310767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 310772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310777 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 310779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 310781 */     GIR_RootConstrainSelectedInstOperands,
     /* 310782 */     // GIR_Coverage, 7394,
     /* 310782 */     GIR_EraseRootFromParent_Done,
     /* 310783 */   // Label 5324: @310783
     /* 310783 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(310855), // Rule ID 7397 //
     /* 310788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 310791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310795 */     // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, (V_LSHRREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f32] }:$src1))
     /* 310795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
     /* 310802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310807 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
     /* 310810 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 310814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310828 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 310838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 310843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 310850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310853 */     GIR_RootConstrainSelectedInstOperands,
     /* 310854 */     // GIR_Coverage, 7397,
     /* 310854 */     GIR_EraseRootFromParent_Done,
     /* 310855 */   // Label 5325: @310855
     /* 310855 */   GIM_Reject,
     /* 310856 */ // Label 5323: @310856
     /* 310856 */ GIM_Reject,
     /* 310857 */ // Label 5320: @310857
     /* 310857 */ GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(311067),
     /* 310862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310865 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(310937), // Rule ID 7395 //
     /* 310870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 310873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310877 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (V_LSHLREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f16] }:$src1))
     /* 310877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
     /* 310884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310889 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
     /* 310892 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 310896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310910 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 310920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 310925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 310932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310935 */     GIR_RootConstrainSelectedInstOperands,
     /* 310936 */     // GIR_Coverage, 7395,
     /* 310936 */     GIR_EraseRootFromParent_Done,
     /* 310937 */   // Label 5327: @310937
     /* 310937 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(310987), // Rule ID 7460 //
     /* 310942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 310945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310949 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, ?:{ *:[f32] }:$src1)
     /* 310949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 310956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310961 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 310971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 310976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 310978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 310983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 310985 */     GIR_RootConstrainSelectedInstOperands,
     /* 310986 */     // GIR_Coverage, 7460,
     /* 310986 */     GIR_EraseRootFromParent_Done,
     /* 310987 */   // Label 5328: @310987
     /* 310987 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(311066), // Rule ID 7461 //
     /* 310992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 310995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 310999 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f64:{ *:[f64] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src1, sub1:{ *:[i32] }))
     /* 310999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 311002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311011 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // src1
     /* 311017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 311022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 311027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 311034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311039 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
     /* 311049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 311054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 311061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 311064 */     GIR_RootConstrainSelectedInstOperands,
     /* 311065 */     // GIR_Coverage, 7461,
     /* 311065 */     GIR_EraseRootFromParent_Done,
     /* 311066 */   // Label 5329: @311066
     /* 311066 */   GIM_Reject,
     /* 311067 */ // Label 5326: @311067
     /* 311067 */ GIM_Reject,
     /* 311068 */ // Label 5321: @311068
     /* 311068 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(311121), // Rule ID 7399 //
     /* 311073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 311076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 311079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311083 */   // (fcopysign:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, v2f16:{ *:[v2f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147450879:{ *:[i32] }), ?:{ *:[v2f16] }:$src0, ?:{ *:[v2f16] }:$src1)
     /* 311083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 311090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311095 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
     /* 311105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 311110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 311117 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 311119 */   GIR_RootConstrainSelectedInstOperands,
     /* 311120 */   // GIR_Coverage, 7399,
     /* 311120 */   GIR_EraseRootFromParent_Done,
     /* 311121 */ // Label 5330: @311121
     /* 311121 */ GIM_Reject,
     /* 311122 */ // Label 5322: @311122
     /* 311122 */ GIM_Reject,
     /* 311123 */ // Label 78: @311123
     /* 311123 */ GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(311453),
     /* 311128 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 311131 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5335*/ GIMT_Encode4(311452),
     /* 311142 */   /*GILLT_s16*//*Label 5332*/ GIMT_Encode4(311154),
     /* 311146 */   /*GILLT_s32*//*Label 5333*/ GIMT_Encode4(311336),
     /* 311150 */   /*GILLT_s64*//*Label 5334*/ GIMT_Encode4(311394),
     /* 311154 */   // Label 5332: @311154
     /* 311154 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(311335),
     /* 311159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 311163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 311166 */     GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(311219), // Rule ID 2889 //
     /* 311171 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 311174 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 311181 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 311181 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311184 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 311188 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311193 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 311197 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311199 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
     /* 311202 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 311204 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311209 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311214 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311217 */       GIR_RootConstrainSelectedInstOperands,
     /* 311218 */       // GIR_Coverage, 2889,
     /* 311218 */       GIR_EraseRootFromParent_Done,
     /* 311219 */     // Label 5337: @311219
     /* 311219 */     GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(311278), // Rule ID 2890 //
     /* 311224 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 311227 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 311234 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 311234 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311237 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 311241 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311246 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 311250 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311252 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_t16_e64),
     /* 311255 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 311257 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311262 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311267 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311270 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311273 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311276 */       GIR_RootConstrainSelectedInstOperands,
     /* 311277 */       // GIR_Coverage, 2890,
     /* 311277 */       GIR_EraseRootFromParent_Done,
     /* 311278 */     // Label 5338: @311278
     /* 311278 */     GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(311334), // Rule ID 2891 //
     /* 311283 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 311286 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 311293 */       // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 311293 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311296 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 311300 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311305 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 311309 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311311 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
     /* 311314 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 311316 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311321 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311326 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311329 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311332 */       GIR_RootConstrainSelectedInstOperands,
     /* 311333 */       // GIR_Coverage, 2891,
     /* 311333 */       GIR_EraseRootFromParent_Done,
     /* 311334 */     // Label 5339: @311334
     /* 311334 */     GIM_Reject,
     /* 311335 */   // Label 5336: @311335
     /* 311335 */   GIM_Reject,
     /* 311336 */   // Label 5333: @311336
     /* 311336 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(311393), // Rule ID 2892 //
     /* 311341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 311345 */     // MIs[0] mask
     /* 311345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 311348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 311355 */     // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f32:{ *:[f32] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 311355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 311362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311367 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 311371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
     /* 311376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 311378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311391 */     GIR_RootConstrainSelectedInstOperands,
     /* 311392 */     // GIR_Coverage, 2892,
     /* 311392 */     GIR_EraseRootFromParent_Done,
     /* 311393 */   // Label 5340: @311393
     /* 311393 */   GIM_Reject,
     /* 311394 */   // Label 5334: @311394
     /* 311394 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(311451), // Rule ID 2893 //
     /* 311399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
     /* 311403 */     // MIs[0] mask
     /* 311403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 311406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
     /* 311413 */     // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f64:{ *:[f64] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
     /* 311413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
     /* 311420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
     /* 311429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 311434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 311436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 311441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 311446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311449 */     GIR_RootConstrainSelectedInstOperands,
     /* 311450 */     // GIR_Coverage, 2893,
     /* 311450 */     GIR_EraseRootFromParent_Done,
     /* 311451 */   // Label 5341: @311451
     /* 311451 */   GIM_Reject,
     /* 311452 */   // Label 5335: @311452
     /* 311452 */   GIM_Reject,
     /* 311453 */ // Label 5331: @311453
     /* 311453 */ GIM_Reject,
     /* 311454 */ // Label 79: @311454
     /* 311454 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5347*/ GIMT_Encode4(312921),
     /* 311465 */ /*GILLT_s16*//*Label 5342*/ GIMT_Encode4(311485),
     /* 311469 */ /*GILLT_s32*//*Label 5343*/ GIMT_Encode4(312191),
     /* 311473 */ /*GILLT_s64*//*Label 5344*/ GIMT_Encode4(312411),
     /* 311477 */ /*GILLT_v2s16*//*Label 5345*/ GIMT_Encode4(312668),
     /* 311481 */ /*GILLT_v2s32*//*Label 5346*/ GIMT_Encode4(312853),
     /* 311485 */ // Label 5342: @311485
     /* 311485 */ GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(312190),
     /* 311490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311493 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(311545), // Rule ID 7620 //
     /* 311498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts),
     /* 311501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311512 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 311515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311543 */     GIR_RootConstrainSelectedInstOperands,
     /* 311544 */     // GIR_Coverage, 7620,
     /* 311544 */     GIR_EraseRootFromParent_Done,
     /* 311545 */   // Label 5349: @311545
     /* 311545 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(311600), // Rule ID 7621 //
     /* 311550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseRealTrue16Insts),
     /* 311553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311564 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 311567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311598 */     GIR_RootConstrainSelectedInstOperands,
     /* 311599 */     // GIR_Coverage, 7621,
     /* 311599 */     GIR_EraseRootFromParent_Done,
     /* 311600 */   // Label 5350: @311600
     /* 311600 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(311652), // Rule ID 7622 //
     /* 311605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_UseFakeTrue16Insts),
     /* 311608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311619 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 311622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311650 */     GIR_RootConstrainSelectedInstOperands,
     /* 311651 */     // GIR_Coverage, 7622,
     /* 311651 */     GIR_EraseRootFromParent_Done,
     /* 311652 */   // Label 5351: @311652
     /* 311652 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(311704), // Rule ID 7627 //
     /* 311657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts),
     /* 311660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311671 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 311674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311702 */     GIR_RootConstrainSelectedInstOperands,
     /* 311703 */     // GIR_Coverage, 7627,
     /* 311703 */     GIR_EraseRootFromParent_Done,
     /* 311704 */   // Label 5352: @311704
     /* 311704 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(311759), // Rule ID 7628 //
     /* 311709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseRealTrue16Insts),
     /* 311712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311723 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 311726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311757 */     GIR_RootConstrainSelectedInstOperands,
     /* 311758 */     // GIR_Coverage, 7628,
     /* 311758 */     GIR_EraseRootFromParent_Done,
     /* 311759 */   // Label 5353: @311759
     /* 311759 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(311811), // Rule ID 7629 //
     /* 311764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_UseFakeTrue16Insts),
     /* 311767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311778 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 311778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 311781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311809 */     GIR_RootConstrainSelectedInstOperands,
     /* 311810 */     // GIR_Coverage, 7629,
     /* 311810 */     GIR_EraseRootFromParent_Done,
     /* 311811 */   // Label 5354: @311811
     /* 311811 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(311880), // Rule ID 7607 //
     /* 311816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 311819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311844 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 311844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 311847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311852 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 311862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311878 */     GIR_RootConstrainSelectedInstOperands,
     /* 311879 */     // GIR_Coverage, 7607,
     /* 311879 */     GIR_EraseRootFromParent_Done,
     /* 311880 */   // Label 5355: @311880
     /* 311880 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(311952), // Rule ID 7609 //
     /* 311885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 311888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 311892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311913 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 311913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 311916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311921 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 311931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 311936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 311941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311950 */     GIR_RootConstrainSelectedInstOperands,
     /* 311951 */     // GIR_Coverage, 7609,
     /* 311951 */     GIR_EraseRootFromParent_Done,
     /* 311952 */   // Label 5356: @311952
     /* 311952 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(312021), // Rule ID 7611 //
     /* 311957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 311960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 311964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 311985 */     // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 311985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 311988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 311990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 311993 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
     /* 312003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312019 */     GIR_RootConstrainSelectedInstOperands,
     /* 312020 */     // GIR_Coverage, 7611,
     /* 312020 */     GIR_EraseRootFromParent_Done,
     /* 312021 */   // Label 5357: @312021
     /* 312021 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(312076), // Rule ID 7606 //
     /* 312026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 312029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312040 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 312040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 312043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312048 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 312058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312074 */     GIR_RootConstrainSelectedInstOperands,
     /* 312075 */     // GIR_Coverage, 7606,
     /* 312075 */     GIR_EraseRootFromParent_Done,
     /* 312076 */   // Label 5358: @312076
     /* 312076 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(312134), // Rule ID 7608 //
     /* 312081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 312084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 312088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312095 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 312095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 312098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312103 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 312113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312132 */     GIR_RootConstrainSelectedInstOperands,
     /* 312133 */     // GIR_Coverage, 7608,
     /* 312133 */     GIR_EraseRootFromParent_Done,
     /* 312134 */   // Label 5359: @312134
     /* 312134 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(312189), // Rule ID 7610 //
     /* 312139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 312142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312153 */     // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
     /* 312153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 312156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312161 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 312171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312187 */     GIR_RootConstrainSelectedInstOperands,
     /* 312188 */     // GIR_Coverage, 7610,
     /* 312188 */     GIR_EraseRootFromParent_Done,
     /* 312189 */   // Label 5360: @312189
     /* 312189 */   GIM_Reject,
     /* 312190 */ // Label 5348: @312190
     /* 312190 */ GIM_Reject,
     /* 312191 */ // Label 5343: @312191
     /* 312191 */ GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(312410),
     /* 312196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312203 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(312251), // Rule ID 7617 //
     /* 312208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
     /* 312211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312218 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 312218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 312221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312249 */     GIR_RootConstrainSelectedInstOperands,
     /* 312250 */     // GIR_Coverage, 7617,
     /* 312250 */     GIR_EraseRootFromParent_Done,
     /* 312251 */   // Label 5362: @312251
     /* 312251 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(312299), // Rule ID 7624 //
     /* 312256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FalsePredicate_NotHasMinMaxDenormModes),
     /* 312259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312266 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 312266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 312269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312297 */     GIR_RootConstrainSelectedInstOperands,
     /* 312298 */     // GIR_Coverage, 7624,
     /* 312298 */     GIR_EraseRootFromParent_Done,
     /* 312299 */   // Label 5363: @312299
     /* 312299 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(312361), // Rule ID 7614 //
     /* 312304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312325 */     // (fcanonicalize:{ *:[f32] } (fneg:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 312325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 312328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312333 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
     /* 312343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312359 */     GIR_RootConstrainSelectedInstOperands,
     /* 312360 */     // GIR_Coverage, 7614,
     /* 312360 */     GIR_EraseRootFromParent_Done,
     /* 312361 */   // Label 5364: @312361
     /* 312361 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(312409), // Rule ID 7613 //
     /* 312366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312373 */     // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
     /* 312373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 312376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312381 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 312391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312407 */     GIR_RootConstrainSelectedInstOperands,
     /* 312408 */     // GIR_Coverage, 7613,
     /* 312408 */     GIR_EraseRootFromParent_Done,
     /* 312409 */   // Label 5365: @312409
     /* 312409 */   GIM_Reject,
     /* 312410 */ // Label 5361: @312410
     /* 312410 */ GIM_Reject,
     /* 312411 */ // Label 5344: @312411
     /* 312411 */ GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(312667),
     /* 312416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 312423 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(312471), // Rule ID 7618 //
     /* 312428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isNotGFX12Plus),
     /* 312431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312438 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 312438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 312441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312469 */     GIR_RootConstrainSelectedInstOperands,
     /* 312470 */     // GIR_Coverage, 7618,
     /* 312470 */     GIR_EraseRootFromParent_Done,
     /* 312471 */   // Label 5367: @312471
     /* 312471 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(312519), // Rule ID 7619 //
     /* 312476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isGFX12Plus),
     /* 312479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312486 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 312486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 312489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312517 */     GIR_RootConstrainSelectedInstOperands,
     /* 312518 */     // GIR_Coverage, 7619,
     /* 312518 */     GIR_EraseRootFromParent_Done,
     /* 312519 */   // Label 5368: @312519
     /* 312519 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(312567), // Rule ID 7625 //
     /* 312524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus),
     /* 312527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312534 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 312534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 312537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312565 */     GIR_RootConstrainSelectedInstOperands,
     /* 312566 */     // GIR_Coverage, 7625,
     /* 312566 */     GIR_EraseRootFromParent_Done,
     /* 312567 */   // Label 5369: @312567
     /* 312567 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(312615), // Rule ID 7626 //
     /* 312572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus),
     /* 312575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312582 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 312582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 312585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312613 */     GIR_RootConstrainSelectedInstOperands,
     /* 312614 */     // GIR_Coverage, 7626,
     /* 312614 */     GIR_EraseRootFromParent_Done,
     /* 312615 */   // Label 5370: @312615
     /* 312615 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(312666), // Rule ID 7616 //
     /* 312620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 312623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 312630 */     // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F64_e64:{ *:[f64] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
     /* 312630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 312633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312638 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
     /* 312648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312664 */     GIR_RootConstrainSelectedInstOperands,
     /* 312665 */     // GIR_Coverage, 7616,
     /* 312665 */     GIR_EraseRootFromParent_Done,
     /* 312666 */   // Label 5371: @312666
     /* 312666 */   GIM_Reject,
     /* 312667 */ // Label 5366: @312667
     /* 312667 */ GIM_Reject,
     /* 312668 */ // Label 5345: @312668
     /* 312668 */ GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(312852),
     /* 312673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 312676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312680 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(312737), // Rule ID 7623 //
     /* 312685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
     /* 312688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 312695 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 312695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 312698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312735 */     GIR_RootConstrainSelectedInstOperands,
     /* 312736 */     // GIR_Coverage, 7623,
     /* 312736 */     GIR_EraseRootFromParent_Done,
     /* 312737 */   // Label 5373: @312737
     /* 312737 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(312794), // Rule ID 7630 //
     /* 312742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_NotHasMinMaxDenormModes),
     /* 312745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 312752 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 312752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 312755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312792 */     GIR_RootConstrainSelectedInstOperands,
     /* 312793 */     // GIR_Coverage, 7630,
     /* 312793 */     GIR_EraseRootFromParent_Done,
     /* 312794 */   // Label 5374: @312794
     /* 312794 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(312851), // Rule ID 7612 //
     /* 312799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 312806 */     // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F16:{ *:[v2f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
     /* 312806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 312809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312814 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
     /* 312824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312849 */     GIR_RootConstrainSelectedInstOperands,
     /* 312850 */     // GIR_Coverage, 7612,
     /* 312850 */     GIR_EraseRootFromParent_Done,
     /* 312851 */   // Label 5375: @312851
     /* 312851 */   GIM_Reject,
     /* 312852 */ // Label 5372: @312852
     /* 312852 */ GIM_Reject,
     /* 312853 */ // Label 5346: @312853
     /* 312853 */ GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(312920), // Rule ID 7615 //
     /* 312858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 312861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 312868 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 312875 */   // (fcanonicalize:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F32:{ *:[v2f32] } 0:{ *:[i32] }, 1065353216:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f32] }:$src)
     /* 312875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 312878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 312880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312883 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
     /* 312893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
     /* 312898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
     /* 312903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 312918 */   GIR_RootConstrainSelectedInstOperands,
     /* 312919 */   // GIR_Coverage, 7615,
     /* 312919 */   GIR_EraseRootFromParent_Done,
     /* 312920 */ // Label 5376: @312920
     /* 312920 */ GIM_Reject,
     /* 312921 */ // Label 5347: @312921
     /* 312921 */ GIM_Reject,
     /* 312922 */ // Label 80: @312922
     /* 312922 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5381*/ GIMT_Encode4(384700),
     /* 312933 */ /*GILLT_s16*//*Label 5377*/ GIMT_Encode4(312949),
     /* 312937 */ /*GILLT_s32*//*Label 5378*/ GIMT_Encode4(366863),
     /* 312941 */ /*GILLT_s64*//*Label 5379*/ GIMT_Encode4(384375),
     /* 312945 */ /*GILLT_v2s16*//*Label 5380*/ GIMT_Encode4(384628),
     /* 312949 */ // Label 5377: @312949
     /* 312949 */ GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(366862),
     /* 312954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 312960 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(313095), // Rule ID 12397 //
     /* 312965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 312968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 312972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 312988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 312996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313012 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313049 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 313052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313093 */     GIR_RootConstrainSelectedInstOperands,
     /* 313094 */     // GIR_Coverage, 12397,
     /* 313094 */     GIR_EraseRootFromParent_Done,
     /* 313095 */   // Label 5383: @313095
     /* 313095 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(313230), // Rule ID 12398 //
     /* 313100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 313103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313184 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 313187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313228 */     GIR_RootConstrainSelectedInstOperands,
     /* 313229 */     // GIR_Coverage, 12398,
     /* 313229 */     GIR_EraseRootFromParent_Done,
     /* 313230 */   // Label 5384: @313230
     /* 313230 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(313365), // Rule ID 12401 //
     /* 313235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 313238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313319 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 313322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313363 */     GIR_RootConstrainSelectedInstOperands,
     /* 313364 */     // GIR_Coverage, 12401,
     /* 313364 */     GIR_EraseRootFromParent_Done,
     /* 313365 */   // Label 5385: @313365
     /* 313365 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(313500), // Rule ID 12402 //
     /* 313370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 313373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 313377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313454 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 313457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313498 */     GIR_RootConstrainSelectedInstOperands,
     /* 313499 */     // GIR_Coverage, 12402,
     /* 313499 */     GIR_EraseRootFromParent_Done,
     /* 313500 */   // Label 5386: @313500
     /* 313500 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(313635), // Rule ID 12877 //
     /* 313505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313552 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313557 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313589 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313633 */     GIR_RootConstrainSelectedInstOperands,
     /* 313634 */     // GIR_Coverage, 12877,
     /* 313634 */     GIR_EraseRootFromParent_Done,
     /* 313635 */   // Label 5387: @313635
     /* 313635 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(313770), // Rule ID 12878 //
     /* 313640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313687 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313724 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 313734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 313739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 313744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 313749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313768 */     GIR_RootConstrainSelectedInstOperands,
     /* 313769 */     // GIR_Coverage, 12878,
     /* 313769 */     GIR_EraseRootFromParent_Done,
     /* 313770 */   // Label 5388: @313770
     /* 313770 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(313905), // Rule ID 12881 //
     /* 313775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313822 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313859 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 313869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 313874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 313879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 313884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 313889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 313894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 313903 */     GIR_RootConstrainSelectedInstOperands,
     /* 313904 */     // GIR_Coverage, 12881,
     /* 313904 */     GIR_EraseRootFromParent_Done,
     /* 313905 */   // Label 5389: @313905
     /* 313905 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(314040), // Rule ID 12882 //
     /* 313910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 313913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 313917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 313933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 313941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 313945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 313949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 313957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 313957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 313962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 313962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 313967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 313971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 313994 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 313994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 313997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 313999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314038 */     GIR_RootConstrainSelectedInstOperands,
     /* 314039 */     // GIR_Coverage, 12882,
     /* 314039 */     GIR_EraseRootFromParent_Done,
     /* 314040 */   // Label 5390: @314040
     /* 314040 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(314175), // Rule ID 13357 //
     /* 314045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 314092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314129 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314173 */     GIR_RootConstrainSelectedInstOperands,
     /* 314174 */     // GIR_Coverage, 13357,
     /* 314174 */     GIR_EraseRootFromParent_Done,
     /* 314175 */   // Label 5391: @314175
     /* 314175 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(314310), // Rule ID 13358 //
     /* 314180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 314227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314264 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314308 */     GIR_RootConstrainSelectedInstOperands,
     /* 314309 */     // GIR_Coverage, 13358,
     /* 314309 */     GIR_EraseRootFromParent_Done,
     /* 314310 */   // Label 5392: @314310
     /* 314310 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(314445), // Rule ID 13361 //
     /* 314315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 314362 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314367 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314376 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314399 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314443 */     GIR_RootConstrainSelectedInstOperands,
     /* 314444 */     // GIR_Coverage, 13361,
     /* 314444 */     GIR_EraseRootFromParent_Done,
     /* 314445 */   // Label 5393: @314445
     /* 314445 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(314580), // Rule ID 13362 //
     /* 314450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 314453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 314497 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314534 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 314537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314578 */     GIR_RootConstrainSelectedInstOperands,
     /* 314579 */     // GIR_Coverage, 13362,
     /* 314579 */     GIR_EraseRootFromParent_Done,
     /* 314580 */   // Label 5394: @314580
     /* 314580 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(314715), // Rule ID 12382 //
     /* 314585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314632 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314669 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314713 */     GIR_RootConstrainSelectedInstOperands,
     /* 314714 */     // GIR_Coverage, 12382,
     /* 314714 */     GIR_EraseRootFromParent_Done,
     /* 314715 */   // Label 5395: @314715
     /* 314715 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(314850), // Rule ID 12383 //
     /* 314720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314804 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 314814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 314819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 314824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 314829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314848 */     GIR_RootConstrainSelectedInstOperands,
     /* 314849 */     // GIR_Coverage, 12383,
     /* 314849 */     GIR_EraseRootFromParent_Done,
     /* 314850 */   // Label 5396: @314850
     /* 314850 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(314985), // Rule ID 12386 //
     /* 314855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 314874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 314878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 314886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 314890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 314894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 314902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 314902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 314907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 314907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 314912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 314916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 314939 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 314939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 314942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 314944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 314949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 314954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 314959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 314964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 314969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 314974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 314983 */     GIR_RootConstrainSelectedInstOperands,
     /* 314984 */     // GIR_Coverage, 12386,
     /* 314984 */     GIR_EraseRootFromParent_Done,
     /* 314985 */   // Label 5397: @314985
     /* 314985 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(315120), // Rule ID 12387 //
     /* 314990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 314993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 314997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315042 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315074 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 315077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315118 */     GIR_RootConstrainSelectedInstOperands,
     /* 315119 */     // GIR_Coverage, 12387,
     /* 315119 */     GIR_EraseRootFromParent_Done,
     /* 315120 */   // Label 5398: @315120
     /* 315120 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(315255), // Rule ID 12862 //
     /* 315125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315172 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315209 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315253 */     GIR_RootConstrainSelectedInstOperands,
     /* 315254 */     // GIR_Coverage, 12862,
     /* 315254 */     GIR_EraseRootFromParent_Done,
     /* 315255 */   // Label 5399: @315255
     /* 315255 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(315390), // Rule ID 12863 //
     /* 315260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315307 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315344 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315388 */     GIR_RootConstrainSelectedInstOperands,
     /* 315389 */     // GIR_Coverage, 12863,
     /* 315389 */     GIR_EraseRootFromParent_Done,
     /* 315390 */   // Label 5400: @315390
     /* 315390 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(315525), // Rule ID 12866 //
     /* 315395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315479 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315523 */     GIR_RootConstrainSelectedInstOperands,
     /* 315524 */     // GIR_Coverage, 12866,
     /* 315524 */     GIR_EraseRootFromParent_Done,
     /* 315525 */   // Label 5401: @315525
     /* 315525 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(315660), // Rule ID 12867 //
     /* 315530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 315533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 315537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315614 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 315617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 315624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 315629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 315634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 315639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315658 */     GIR_RootConstrainSelectedInstOperands,
     /* 315659 */     // GIR_Coverage, 12867,
     /* 315659 */     GIR_EraseRootFromParent_Done,
     /* 315660 */   // Label 5402: @315660
     /* 315660 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(315795), // Rule ID 13342 //
     /* 315665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 315668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315722 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315749 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 315752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315793 */     GIR_RootConstrainSelectedInstOperands,
     /* 315794 */     // GIR_Coverage, 13342,
     /* 315794 */     GIR_EraseRootFromParent_Done,
     /* 315795 */   // Label 5403: @315795
     /* 315795 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(315930), // Rule ID 13343 //
     /* 315800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 315803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315852 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315877 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 315884 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 315884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 315887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 315889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 315894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 315899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 315904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 315909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 315914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 315919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 315928 */     GIR_RootConstrainSelectedInstOperands,
     /* 315929 */     // GIR_Coverage, 13343,
     /* 315929 */     GIR_EraseRootFromParent_Done,
     /* 315930 */   // Label 5404: @315930
     /* 315930 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(316065), // Rule ID 13346 //
     /* 315935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 315938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 315942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 315954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 315958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 315966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 315970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 315974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 315982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 315982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 315987 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 315987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 315992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 315996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316019 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316063 */     GIR_RootConstrainSelectedInstOperands,
     /* 316064 */     // GIR_Coverage, 13346,
     /* 316064 */     GIR_EraseRootFromParent_Done,
     /* 316065 */   // Label 5405: @316065
     /* 316065 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(316200), // Rule ID 13347 //
     /* 316070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 316117 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316154 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316198 */     GIR_RootConstrainSelectedInstOperands,
     /* 316199 */     // GIR_Coverage, 13347,
     /* 316199 */     GIR_EraseRootFromParent_Done,
     /* 316200 */   // Label 5406: @316200
     /* 316200 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(316335), // Rule ID 7780 //
     /* 316205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316289 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 316292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316333 */     GIR_RootConstrainSelectedInstOperands,
     /* 316334 */     // GIR_Coverage, 7780,
     /* 316334 */     GIR_EraseRootFromParent_Done,
     /* 316335 */   // Label 5407: @316335
     /* 316335 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(316470), // Rule ID 7812 //
     /* 316340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 316343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 316347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316387 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316392 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316424 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 316427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316468 */     GIR_RootConstrainSelectedInstOperands,
     /* 316469 */     // GIR_Coverage, 7812,
     /* 316469 */     GIR_EraseRootFromParent_Done,
     /* 316470 */   // Label 5408: @316470
     /* 316470 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(316605), // Rule ID 7844 //
     /* 316475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 316478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316527 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316559 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 316562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316603 */     GIR_RootConstrainSelectedInstOperands,
     /* 316604 */     // GIR_Coverage, 7844,
     /* 316604 */     GIR_EraseRootFromParent_Done,
     /* 316605 */   // Label 5409: @316605
     /* 316605 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(316740), // Rule ID 12396 //
     /* 316610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316694 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 316697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 316704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 316709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 316714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 316719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316738 */     GIR_RootConstrainSelectedInstOperands,
     /* 316739 */     // GIR_Coverage, 12396,
     /* 316739 */     GIR_EraseRootFromParent_Done,
     /* 316740 */   // Label 5410: @316740
     /* 316740 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(316875), // Rule ID 12399 //
     /* 316745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316829 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 316832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 316873 */     GIR_RootConstrainSelectedInstOperands,
     /* 316874 */     // GIR_Coverage, 12399,
     /* 316874 */     GIR_EraseRootFromParent_Done,
     /* 316875 */   // Label 5411: @316875
     /* 316875 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(317010), // Rule ID 12400 //
     /* 316880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 316883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 316887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 316899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 316903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 316911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 316915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 316919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 316927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 316927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 316932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 316932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 316937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 316941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 316964 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 316964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 316967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 316969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 316974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 316979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 316984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 316989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 316994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 316999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317008 */     GIR_RootConstrainSelectedInstOperands,
     /* 317009 */     // GIR_Coverage, 12400,
     /* 317009 */     GIR_EraseRootFromParent_Done,
     /* 317010 */   // Label 5412: @317010
     /* 317010 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(317145), // Rule ID 12876 //
     /* 317015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 317062 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317067 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317099 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317143 */     GIR_RootConstrainSelectedInstOperands,
     /* 317144 */     // GIR_Coverage, 12876,
     /* 317144 */     GIR_EraseRootFromParent_Done,
     /* 317145 */   // Label 5413: @317145
     /* 317145 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(317280), // Rule ID 12879 //
     /* 317150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 317197 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317202 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317234 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317278 */     GIR_RootConstrainSelectedInstOperands,
     /* 317279 */     // GIR_Coverage, 12879,
     /* 317279 */     GIR_EraseRootFromParent_Done,
     /* 317280 */   // Label 5414: @317280
     /* 317280 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(317415), // Rule ID 12880 //
     /* 317285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 317332 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317337 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317342 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317369 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 317372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317413 */     GIR_RootConstrainSelectedInstOperands,
     /* 317414 */     // GIR_Coverage, 12880,
     /* 317414 */     GIR_EraseRootFromParent_Done,
     /* 317415 */   // Label 5415: @317415
     /* 317415 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(317550), // Rule ID 13356 //
     /* 317420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 317423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 317467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317504 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 317507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317548 */     GIR_RootConstrainSelectedInstOperands,
     /* 317549 */     // GIR_Coverage, 13356,
     /* 317549 */     GIR_EraseRootFromParent_Done,
     /* 317550 */   // Label 5416: @317550
     /* 317550 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(317685), // Rule ID 13359 //
     /* 317555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 317558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 317602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317639 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 317642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317683 */     GIR_RootConstrainSelectedInstOperands,
     /* 317684 */     // GIR_Coverage, 13359,
     /* 317684 */     GIR_EraseRootFromParent_Done,
     /* 317685 */   // Label 5417: @317685
     /* 317685 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(317820), // Rule ID 13360 //
     /* 317690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 317693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 317737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317774 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 317777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 317784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 317789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 317794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 317799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317818 */     GIR_RootConstrainSelectedInstOperands,
     /* 317819 */     // GIR_Coverage, 13360,
     /* 317819 */     GIR_EraseRootFromParent_Done,
     /* 317820 */   // Label 5418: @317820
     /* 317820 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(317955), // Rule ID 7779 //
     /* 317825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 317828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 317832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 317868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 317872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 317872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 317877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 317877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 317882 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 317886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 317909 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 317909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 317912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 317914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 317919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 317924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 317929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 317934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 317939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 317944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 317953 */     GIR_RootConstrainSelectedInstOperands,
     /* 317954 */     // GIR_Coverage, 7779,
     /* 317954 */     GIR_EraseRootFromParent_Done,
     /* 317955 */   // Label 5419: @317955
     /* 317955 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(318090), // Rule ID 7811 //
     /* 317960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 317963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 317967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 317991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 317995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 317999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318007 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318012 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318037 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318044 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 318047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318088 */     GIR_RootConstrainSelectedInstOperands,
     /* 318089 */     // GIR_Coverage, 7811,
     /* 318089 */     GIR_EraseRootFromParent_Done,
     /* 318090 */   // Label 5420: @318090
     /* 318090 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(318225), // Rule ID 7843 //
     /* 318095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 318098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318152 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318172 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318179 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 318182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318223 */     GIR_RootConstrainSelectedInstOperands,
     /* 318224 */     // GIR_Coverage, 7843,
     /* 318224 */     GIR_EraseRootFromParent_Done,
     /* 318225 */   // Label 5421: @318225
     /* 318225 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(318360), // Rule ID 12381 //
     /* 318230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318314 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 318317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318358 */     GIR_RootConstrainSelectedInstOperands,
     /* 318359 */     // GIR_Coverage, 12381,
     /* 318359 */     GIR_EraseRootFromParent_Done,
     /* 318360 */   // Label 5422: @318360
     /* 318360 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(318495), // Rule ID 12384 //
     /* 318365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318449 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 318452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318493 */     GIR_RootConstrainSelectedInstOperands,
     /* 318494 */     // GIR_Coverage, 12384,
     /* 318494 */     GIR_EraseRootFromParent_Done,
     /* 318495 */   // Label 5423: @318495
     /* 318495 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(318630), // Rule ID 12385 //
     /* 318500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 318503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 318507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318552 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318584 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 318587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318628 */     GIR_RootConstrainSelectedInstOperands,
     /* 318629 */     // GIR_Coverage, 12385,
     /* 318629 */     GIR_EraseRootFromParent_Done,
     /* 318630 */   // Label 5424: @318630
     /* 318630 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(318765), // Rule ID 12861 //
     /* 318635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 318638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 318642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318682 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318687 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318692 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318719 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 318722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 318729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 318734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 318739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 318744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318763 */     GIR_RootConstrainSelectedInstOperands,
     /* 318764 */     // GIR_Coverage, 12861,
     /* 318764 */     GIR_EraseRootFromParent_Done,
     /* 318765 */   // Label 5425: @318765
     /* 318765 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(318900), // Rule ID 12864 //
     /* 318770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 318773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 318777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318817 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318822 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318847 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318854 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 318857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 318869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 318874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 318879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 318884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 318889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318898 */     GIR_RootConstrainSelectedInstOperands,
     /* 318899 */     // GIR_Coverage, 12864,
     /* 318899 */     GIR_EraseRootFromParent_Done,
     /* 318900 */   // Label 5426: @318900
     /* 318900 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(319035), // Rule ID 12865 //
     /* 318905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 318908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 318912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 318924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 318928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 318936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 318940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 318944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 318948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 318952 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 318952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 318957 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 318957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 318962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 318966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 318989 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 318989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 318992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 318994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 318999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319033 */     GIR_RootConstrainSelectedInstOperands,
     /* 319034 */     // GIR_Coverage, 12865,
     /* 319034 */     GIR_EraseRootFromParent_Done,
     /* 319035 */   // Label 5427: @319035
     /* 319035 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(319170), // Rule ID 13341 //
     /* 319040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 319087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319124 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319168 */     GIR_RootConstrainSelectedInstOperands,
     /* 319169 */     // GIR_Coverage, 13341,
     /* 319169 */     GIR_EraseRootFromParent_Done,
     /* 319170 */   // Label 5428: @319170
     /* 319170 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(319305), // Rule ID 13344 //
     /* 319175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 319222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319259 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319303 */     GIR_RootConstrainSelectedInstOperands,
     /* 319304 */     // GIR_Coverage, 13344,
     /* 319304 */     GIR_EraseRootFromParent_Done,
     /* 319305 */   // Label 5429: @319305
     /* 319305 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(319440), // Rule ID 13345 //
     /* 319310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 319313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 319353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 319357 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319362 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319394 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 319397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319438 */     GIR_RootConstrainSelectedInstOperands,
     /* 319439 */     // GIR_Coverage, 13345,
     /* 319439 */     GIR_EraseRootFromParent_Done,
     /* 319440 */   // Label 5430: @319440
     /* 319440 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(319575), // Rule ID 12367 //
     /* 319445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 319448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319492 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319497 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319529 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319573 */     GIR_RootConstrainSelectedInstOperands,
     /* 319574 */     // GIR_Coverage, 12367,
     /* 319574 */     GIR_EraseRootFromParent_Done,
     /* 319575 */   // Label 5431: @319575
     /* 319575 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(319710), // Rule ID 12368 //
     /* 319580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 319583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319632 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319664 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 319674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 319679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 319684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 319689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319708 */     GIR_RootConstrainSelectedInstOperands,
     /* 319709 */     // GIR_Coverage, 12368,
     /* 319709 */     GIR_EraseRootFromParent_Done,
     /* 319710 */   // Label 5432: @319710
     /* 319710 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(319845), // Rule ID 12371 //
     /* 319715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 319718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319799 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319843 */     GIR_RootConstrainSelectedInstOperands,
     /* 319844 */     // GIR_Coverage, 12371,
     /* 319844 */     GIR_EraseRootFromParent_Done,
     /* 319845 */   // Label 5433: @319845
     /* 319845 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(319980), // Rule ID 12372 //
     /* 319850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 319853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 319857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 319865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 319869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 319873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 319881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 319885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 319889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 319897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 319897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 319902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 319902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 319907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 319911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 319934 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 319934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 319937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 319939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 319944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 319949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 319954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 319959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 319964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 319969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319978 */     GIR_RootConstrainSelectedInstOperands,
     /* 319979 */     // GIR_Coverage, 12372,
     /* 319979 */     GIR_EraseRootFromParent_Done,
     /* 319980 */   // Label 5434: @319980
     /* 319980 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(320115), // Rule ID 12847 //
     /* 319985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 319988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 319992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320069 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320113 */     GIR_RootConstrainSelectedInstOperands,
     /* 320114 */     // GIR_Coverage, 12847,
     /* 320114 */     GIR_EraseRootFromParent_Done,
     /* 320115 */   // Label 5435: @320115
     /* 320115 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(320250), // Rule ID 12848 //
     /* 320120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320167 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320172 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320177 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320204 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320248 */     GIR_RootConstrainSelectedInstOperands,
     /* 320249 */     // GIR_Coverage, 12848,
     /* 320249 */     GIR_EraseRootFromParent_Done,
     /* 320250 */   // Label 5436: @320250
     /* 320250 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(320385), // Rule ID 12851 //
     /* 320255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320302 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320307 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320339 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320383 */     GIR_RootConstrainSelectedInstOperands,
     /* 320384 */     // GIR_Coverage, 12851,
     /* 320384 */     GIR_EraseRootFromParent_Done,
     /* 320385 */   // Label 5437: @320385
     /* 320385 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(320520), // Rule ID 12852 //
     /* 320390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 320393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 320397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320437 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320474 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 320477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320518 */     GIR_RootConstrainSelectedInstOperands,
     /* 320519 */     // GIR_Coverage, 12852,
     /* 320519 */     GIR_EraseRootFromParent_Done,
     /* 320520 */   // Label 5438: @320520
     /* 320520 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(320655), // Rule ID 13327 //
     /* 320525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 320528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320609 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 320612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320653 */     GIR_RootConstrainSelectedInstOperands,
     /* 320654 */     // GIR_Coverage, 13327,
     /* 320654 */     GIR_EraseRootFromParent_Done,
     /* 320655 */   // Label 5439: @320655
     /* 320655 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(320790), // Rule ID 13328 //
     /* 320660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 320663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320744 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 320747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 320754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 320759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 320764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 320769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320788 */     GIR_RootConstrainSelectedInstOperands,
     /* 320789 */     // GIR_Coverage, 13328,
     /* 320789 */     GIR_EraseRootFromParent_Done,
     /* 320790 */   // Label 5440: @320790
     /* 320790 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(320925), // Rule ID 13331 //
     /* 320795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 320798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 320879 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 320879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 320882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 320884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 320889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 320894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 320899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 320904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 320909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 320914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320923 */     GIR_RootConstrainSelectedInstOperands,
     /* 320924 */     // GIR_Coverage, 13331,
     /* 320924 */     GIR_EraseRootFromParent_Done,
     /* 320925 */   // Label 5441: @320925
     /* 320925 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(321060), // Rule ID 13332 //
     /* 320930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 320933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 320937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 320945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 320949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 320953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 320961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 320965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 320969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 320977 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 320977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 320982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 320982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 320987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 320991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321014 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 321017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321058 */     GIR_RootConstrainSelectedInstOperands,
     /* 321059 */     // GIR_Coverage, 13332,
     /* 321059 */     GIR_EraseRootFromParent_Done,
     /* 321060 */   // Label 5442: @321060
     /* 321060 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(321195), // Rule ID 12352 //
     /* 321065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321112 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321117 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321149 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 321159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 321164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321193 */     GIR_RootConstrainSelectedInstOperands,
     /* 321194 */     // GIR_Coverage, 12352,
     /* 321194 */     GIR_EraseRootFromParent_Done,
     /* 321195 */   // Label 5443: @321195
     /* 321195 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(321330), // Rule ID 12353 //
     /* 321200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321284 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 321294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 321299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321328 */     GIR_RootConstrainSelectedInstOperands,
     /* 321329 */     // GIR_Coverage, 12353,
     /* 321329 */     GIR_EraseRootFromParent_Done,
     /* 321330 */   // Label 5444: @321330
     /* 321330 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(321465), // Rule ID 12356 //
     /* 321335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321419 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321463 */     GIR_RootConstrainSelectedInstOperands,
     /* 321464 */     // GIR_Coverage, 12356,
     /* 321464 */     GIR_EraseRootFromParent_Done,
     /* 321465 */   // Label 5445: @321465
     /* 321465 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(321600), // Rule ID 12357 //
     /* 321470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 321473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 321477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321554 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 321557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321598 */     GIR_RootConstrainSelectedInstOperands,
     /* 321599 */     // GIR_Coverage, 12357,
     /* 321599 */     GIR_EraseRootFromParent_Done,
     /* 321600 */   // Label 5446: @321600
     /* 321600 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(321735), // Rule ID 12832 //
     /* 321605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 321608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 321612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321689 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 321692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 321699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 321704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321733 */     GIR_RootConstrainSelectedInstOperands,
     /* 321734 */     // GIR_Coverage, 12832,
     /* 321734 */     GIR_EraseRootFromParent_Done,
     /* 321735 */   // Label 5447: @321735
     /* 321735 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(321870), // Rule ID 12833 //
     /* 321740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 321743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 321747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321787 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321797 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321824 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 321827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 321834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 321839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 321844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 321849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321868 */     GIR_RootConstrainSelectedInstOperands,
     /* 321869 */     // GIR_Coverage, 12833,
     /* 321869 */     GIR_EraseRootFromParent_Done,
     /* 321870 */   // Label 5448: @321870
     /* 321870 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(322005), // Rule ID 12836 //
     /* 321875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 321878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 321882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 321890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 321906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 321914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 321922 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 321922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 321927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 321927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 321932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 321936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 321959 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 321959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 321962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 321964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 321969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 321974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 321979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 321984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 321989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 321994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322003 */     GIR_RootConstrainSelectedInstOperands,
     /* 322004 */     // GIR_Coverage, 12836,
     /* 322004 */     GIR_EraseRootFromParent_Done,
     /* 322005 */   // Label 5449: @322005
     /* 322005 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(322140), // Rule ID 12837 //
     /* 322010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 322057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 322062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 322067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322094 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 322114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 322119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 322124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 322129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322138 */     GIR_RootConstrainSelectedInstOperands,
     /* 322139 */     // GIR_Coverage, 12837,
     /* 322139 */     GIR_EraseRootFromParent_Done,
     /* 322140 */   // Label 5450: @322140
     /* 322140 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(322275), // Rule ID 13312 //
     /* 322145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 322192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 322197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 322202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322229 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 322239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 322244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 322259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 322264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322273 */     GIR_RootConstrainSelectedInstOperands,
     /* 322274 */     // GIR_Coverage, 13312,
     /* 322274 */     GIR_EraseRootFromParent_Done,
     /* 322275 */   // Label 5451: @322275
     /* 322275 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(322410), // Rule ID 13313 //
     /* 322280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 322327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 322332 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 322337 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322364 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 322374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 322379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 322394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 322399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322408 */     GIR_RootConstrainSelectedInstOperands,
     /* 322409 */     // GIR_Coverage, 13313,
     /* 322409 */     GIR_EraseRootFromParent_Done,
     /* 322410 */   // Label 5452: @322410
     /* 322410 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(322545), // Rule ID 13316 //
     /* 322415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 322462 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 322467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 322472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322499 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 322519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 322524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 322529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 322534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322543 */     GIR_RootConstrainSelectedInstOperands,
     /* 322544 */     // GIR_Coverage, 13316,
     /* 322544 */     GIR_EraseRootFromParent_Done,
     /* 322545 */   // Label 5453: @322545
     /* 322545 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(322680), // Rule ID 13317 //
     /* 322550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 322597 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 322602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 322607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322634 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 322637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 322644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 322649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 322654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 322659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 322664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 322669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322678 */     GIR_RootConstrainSelectedInstOperands,
     /* 322679 */     // GIR_Coverage, 13317,
     /* 322679 */     GIR_EraseRootFromParent_Done,
     /* 322680 */   // Label 5454: @322680
     /* 322680 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(322815), // Rule ID 7778 //
     /* 322685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 322688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 322728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 322737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 322742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322769 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 322772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 322779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 322784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 322799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 322804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322813 */     GIR_RootConstrainSelectedInstOperands,
     /* 322814 */     // GIR_Coverage, 7778,
     /* 322814 */     GIR_EraseRootFromParent_Done,
     /* 322815 */   // Label 5455: @322815
     /* 322815 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(322950), // Rule ID 7810 //
     /* 322820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 322823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 322827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 322863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 322867 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 322867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 322872 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 322872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 322877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 322881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 322904 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 322904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 322907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 322909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 322914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 322919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 322924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 322929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 322934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 322939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322948 */     GIR_RootConstrainSelectedInstOperands,
     /* 322949 */     // GIR_Coverage, 7810,
     /* 322949 */     GIR_EraseRootFromParent_Done,
     /* 322950 */   // Label 5456: @322950
     /* 322950 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(323085), // Rule ID 7842 //
     /* 322955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 322958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 322962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 322970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 322986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 322994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 322998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323039 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 323042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 323049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 323054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 323069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 323074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323083 */     GIR_RootConstrainSelectedInstOperands,
     /* 323084 */     // GIR_Coverage, 7842,
     /* 323084 */     GIR_EraseRootFromParent_Done,
     /* 323085 */   // Label 5457: @323085
     /* 323085 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(323220), // Rule ID 12366 //
     /* 323090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 323133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323174 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 323184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 323189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 323204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 323209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323218 */     GIR_RootConstrainSelectedInstOperands,
     /* 323219 */     // GIR_Coverage, 12366,
     /* 323219 */     GIR_EraseRootFromParent_Done,
     /* 323220 */   // Label 5458: @323220
     /* 323220 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(323355), // Rule ID 12369 //
     /* 323225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 323268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323309 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 323329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 323334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 323339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 323344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323353 */     GIR_RootConstrainSelectedInstOperands,
     /* 323354 */     // GIR_Coverage, 12369,
     /* 323354 */     GIR_EraseRootFromParent_Done,
     /* 323355 */   // Label 5459: @323355
     /* 323355 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(323490), // Rule ID 12370 //
     /* 323360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 323363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 323403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323444 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 323447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 323464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 323469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 323474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 323479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323488 */     GIR_RootConstrainSelectedInstOperands,
     /* 323489 */     // GIR_Coverage, 12370,
     /* 323489 */     GIR_EraseRootFromParent_Done,
     /* 323490 */   // Label 5460: @323490
     /* 323490 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(323625), // Rule ID 12846 //
     /* 323495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 323498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 323502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 323538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323542 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323547 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323579 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 323582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 323589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 323594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 323599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 323604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 323609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 323614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323623 */     GIR_RootConstrainSelectedInstOperands,
     /* 323624 */     // GIR_Coverage, 12846,
     /* 323624 */     GIR_EraseRootFromParent_Done,
     /* 323625 */   // Label 5461: @323625
     /* 323625 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(323760), // Rule ID 12849 //
     /* 323630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 323633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 323637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 323673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323677 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323682 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323714 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 323717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 323734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 323739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 323744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 323749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323758 */     GIR_RootConstrainSelectedInstOperands,
     /* 323759 */     // GIR_Coverage, 12849,
     /* 323759 */     GIR_EraseRootFromParent_Done,
     /* 323760 */   // Label 5462: @323760
     /* 323760 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(323895), // Rule ID 12850 //
     /* 323765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 323768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 323772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 323808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323812 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323817 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323849 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 323852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 323859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 323864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 323869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 323874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 323879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 323884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323893 */     GIR_RootConstrainSelectedInstOperands,
     /* 323894 */     // GIR_Coverage, 12850,
     /* 323894 */     GIR_EraseRootFromParent_Done,
     /* 323895 */   // Label 5463: @323895
     /* 323895 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(324030), // Rule ID 13326 //
     /* 323900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 323903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 323907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 323915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 323923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 323931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 323935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 323939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 323943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 323947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 323947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 323952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 323952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 323957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 323961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 323984 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 323984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 323987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 323989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 323994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 323999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324028 */     GIR_RootConstrainSelectedInstOperands,
     /* 324029 */     // GIR_Coverage, 13326,
     /* 324029 */     GIR_EraseRootFromParent_Done,
     /* 324030 */   // Label 5464: @324030
     /* 324030 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(324165), // Rule ID 13329 //
     /* 324035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 324078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 324087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 324092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324119 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 324139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 324144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324163 */     GIR_RootConstrainSelectedInstOperands,
     /* 324164 */     // GIR_Coverage, 13329,
     /* 324164 */     GIR_EraseRootFromParent_Done,
     /* 324165 */   // Label 5465: @324165
     /* 324165 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(324300), // Rule ID 13330 //
     /* 324170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 324213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 324217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 324222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 324227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324254 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 324274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 324279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324298 */     GIR_RootConstrainSelectedInstOperands,
     /* 324299 */     // GIR_Coverage, 13330,
     /* 324299 */     GIR_EraseRootFromParent_Done,
     /* 324300 */   // Label 5466: @324300
     /* 324300 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(324435), // Rule ID 7777 //
     /* 324305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 324308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 324348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 324352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 324357 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 324362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324389 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 324392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 324399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 324404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324433 */     GIR_RootConstrainSelectedInstOperands,
     /* 324434 */     // GIR_Coverage, 7777,
     /* 324434 */     GIR_EraseRootFromParent_Done,
     /* 324435 */   // Label 5467: @324435
     /* 324435 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(324570), // Rule ID 7809 //
     /* 324440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 324443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 324447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 324483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 324487 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 324492 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 324497 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324524 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 324527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 324534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 324539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324568 */     GIR_RootConstrainSelectedInstOperands,
     /* 324569 */     // GIR_Coverage, 7809,
     /* 324569 */     GIR_EraseRootFromParent_Done,
     /* 324570 */   // Label 5468: @324570
     /* 324570 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(324705), // Rule ID 7841 //
     /* 324575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 324578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 324618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 324622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 324627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 324632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324659 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 324662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 324669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 324674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324703 */     GIR_RootConstrainSelectedInstOperands,
     /* 324704 */     // GIR_Coverage, 7841,
     /* 324704 */     GIR_EraseRootFromParent_Done,
     /* 324705 */   // Label 5469: @324705
     /* 324705 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(324840), // Rule ID 12351 //
     /* 324710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 324713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 324753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 324757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 324762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 324767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324794 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 324797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 324804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 324809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 324814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 324819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324838 */     GIR_RootConstrainSelectedInstOperands,
     /* 324839 */     // GIR_Coverage, 12351,
     /* 324839 */     GIR_EraseRootFromParent_Done,
     /* 324840 */   // Label 5470: @324840
     /* 324840 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(324975), // Rule ID 12354 //
     /* 324845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 324848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 324868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 324876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 324884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 324888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 324892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 324892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 324897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 324897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 324902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 324906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 324929 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 324929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 324932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 324934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 324939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 324944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 324949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 324954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 324959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 324964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324973 */     GIR_RootConstrainSelectedInstOperands,
     /* 324974 */     // GIR_Coverage, 12354,
     /* 324974 */     GIR_EraseRootFromParent_Done,
     /* 324975 */   // Label 5471: @324975
     /* 324975 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(325110), // Rule ID 12355 //
     /* 324980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 324983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 324987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 324995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 325011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 325023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 325032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 325037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325064 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 325067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 325084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 325089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 325094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 325099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325108 */     GIR_RootConstrainSelectedInstOperands,
     /* 325109 */     // GIR_Coverage, 12355,
     /* 325109 */     GIR_EraseRootFromParent_Done,
     /* 325110 */   // Label 5472: @325110
     /* 325110 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(325245), // Rule ID 12831 //
     /* 325115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 325146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 325158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325162 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 325167 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 325172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325199 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 325209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 325214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 325229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 325234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325243 */     GIR_RootConstrainSelectedInstOperands,
     /* 325244 */     // GIR_Coverage, 12831,
     /* 325244 */     GIR_EraseRootFromParent_Done,
     /* 325245 */   // Label 5473: @325245
     /* 325245 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(325380), // Rule ID 12834 //
     /* 325250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 325281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 325293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325297 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 325302 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 325307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325334 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 325354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 325359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 325364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 325369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325378 */     GIR_RootConstrainSelectedInstOperands,
     /* 325379 */     // GIR_Coverage, 12834,
     /* 325379 */     GIR_EraseRootFromParent_Done,
     /* 325380 */   // Label 5474: @325380
     /* 325380 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(325515), // Rule ID 12835 //
     /* 325385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 325388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 325392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 325416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 325428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325432 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 325437 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 325442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325469 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 325472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 325489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 325494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 325499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 325504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325513 */     GIR_RootConstrainSelectedInstOperands,
     /* 325514 */     // GIR_Coverage, 12835,
     /* 325514 */     GIR_EraseRootFromParent_Done,
     /* 325515 */   // Label 5475: @325515
     /* 325515 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(325650), // Rule ID 13311 //
     /* 325520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 325523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 325551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 325563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 325572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 325577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325604 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 325607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 325614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 325619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 325624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 325629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 325634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 325639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325648 */     GIR_RootConstrainSelectedInstOperands,
     /* 325649 */     // GIR_Coverage, 13311,
     /* 325649 */     GIR_EraseRootFromParent_Done,
     /* 325650 */   // Label 5476: @325650
     /* 325650 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(325785), // Rule ID 13314 //
     /* 325655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 325658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 325686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 325698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 325707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 325712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325739 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 325742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 325759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 325764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 325769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 325774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325783 */     GIR_RootConstrainSelectedInstOperands,
     /* 325784 */     // GIR_Coverage, 13314,
     /* 325784 */     GIR_EraseRootFromParent_Done,
     /* 325785 */   // Label 5477: @325785
     /* 325785 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(325920), // Rule ID 13315 //
     /* 325790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 325793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 325821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 325833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 325837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 325842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 325847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325874 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 325874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 325877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 325879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 325884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 325889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 325894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 325899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 325904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 325909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325918 */     GIR_RootConstrainSelectedInstOperands,
     /* 325919 */     // GIR_Coverage, 13315,
     /* 325919 */     GIR_EraseRootFromParent_Done,
     /* 325920 */   // Label 5478: @325920
     /* 325920 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(326055), // Rule ID 12407 //
     /* 325925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 325928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 325932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 325956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 325964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 325968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 325972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 325972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 325977 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 325977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 325982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 325986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 325995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326009 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326053 */     GIR_RootConstrainSelectedInstOperands,
     /* 326054 */     // GIR_Coverage, 12407,
     /* 326054 */     GIR_EraseRootFromParent_Done,
     /* 326055 */   // Label 5479: @326055
     /* 326055 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(326190), // Rule ID 12408 //
     /* 326060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 326091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326107 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326112 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326130 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326144 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326188 */     GIR_RootConstrainSelectedInstOperands,
     /* 326189 */     // GIR_Coverage, 12408,
     /* 326189 */     GIR_EraseRootFromParent_Done,
     /* 326190 */   // Label 5480: @326190
     /* 326190 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(326325), // Rule ID 12409 //
     /* 326195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 326226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326279 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326323 */     GIR_RootConstrainSelectedInstOperands,
     /* 326324 */     // GIR_Coverage, 12409,
     /* 326324 */     GIR_EraseRootFromParent_Done,
     /* 326325 */   // Label 5481: @326325
     /* 326325 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(326460), // Rule ID 12410 //
     /* 326330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 326333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 326337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 326361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326414 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 326417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326458 */     GIR_RootConstrainSelectedInstOperands,
     /* 326459 */     // GIR_Coverage, 12410,
     /* 326459 */     GIR_EraseRootFromParent_Done,
     /* 326460 */   // Label 5482: @326460
     /* 326460 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(326595), // Rule ID 12887 //
     /* 326465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 326468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 326472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 326496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326549 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 326552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326593 */     GIR_RootConstrainSelectedInstOperands,
     /* 326594 */     // GIR_Coverage, 12887,
     /* 326594 */     GIR_EraseRootFromParent_Done,
     /* 326595 */   // Label 5483: @326595
     /* 326595 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(326730), // Rule ID 12888 //
     /* 326600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 326603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 326607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 326631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326684 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 326687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 326694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 326699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 326704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 326709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326728 */     GIR_RootConstrainSelectedInstOperands,
     /* 326729 */     // GIR_Coverage, 12888,
     /* 326729 */     GIR_EraseRootFromParent_Done,
     /* 326730 */   // Label 5484: @326730
     /* 326730 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(326865), // Rule ID 12889 //
     /* 326735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 326738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 326742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 326766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326787 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326819 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 326822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326863 */     GIR_RootConstrainSelectedInstOperands,
     /* 326864 */     // GIR_Coverage, 12889,
     /* 326864 */     GIR_EraseRootFromParent_Done,
     /* 326865 */   // Label 5485: @326865
     /* 326865 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(327000), // Rule ID 12890 //
     /* 326870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 326873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 326877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 326901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 326905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 326909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 326913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 326917 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 326917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 326922 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 326922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 326927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 326931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 326954 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 326954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 326957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 326959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 326964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 326969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 326974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 326979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 326984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 326989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 326998 */     GIR_RootConstrainSelectedInstOperands,
     /* 326999 */     // GIR_Coverage, 12890,
     /* 326999 */     GIR_EraseRootFromParent_Done,
     /* 327000 */   // Label 5486: @327000
     /* 327000 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(327135), // Rule ID 13367 //
     /* 327005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327089 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327133 */     GIR_RootConstrainSelectedInstOperands,
     /* 327134 */     // GIR_Coverage, 13367,
     /* 327134 */     GIR_EraseRootFromParent_Done,
     /* 327135 */   // Label 5487: @327135
     /* 327135 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(327270), // Rule ID 13368 //
     /* 327140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327224 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327268 */     GIR_RootConstrainSelectedInstOperands,
     /* 327269 */     // GIR_Coverage, 13368,
     /* 327269 */     GIR_EraseRootFromParent_Done,
     /* 327270 */   // Label 5488: @327270
     /* 327270 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(327405), // Rule ID 13369 //
     /* 327275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327359 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327403 */     GIR_RootConstrainSelectedInstOperands,
     /* 327404 */     // GIR_Coverage, 13369,
     /* 327404 */     GIR_EraseRootFromParent_Done,
     /* 327405 */   // Label 5489: @327405
     /* 327405 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(327540), // Rule ID 13370 //
     /* 327410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 327413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327462 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327494 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 327497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327538 */     GIR_RootConstrainSelectedInstOperands,
     /* 327539 */     // GIR_Coverage, 13370,
     /* 327539 */     GIR_EraseRootFromParent_Done,
     /* 327540 */   // Label 5490: @327540
     /* 327540 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(327675), // Rule ID 12347 //
     /* 327545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 327548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327592 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327597 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327629 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 327632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327673 */     GIR_RootConstrainSelectedInstOperands,
     /* 327674 */     // GIR_Coverage, 12347,
     /* 327674 */     GIR_EraseRootFromParent_Done,
     /* 327675 */   // Label 5491: @327675
     /* 327675 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(327810), // Rule ID 12348 //
     /* 327680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 327683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327764 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 327767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 327774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 327779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 327784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 327789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327808 */     GIR_RootConstrainSelectedInstOperands,
     /* 327809 */     // GIR_Coverage, 12348,
     /* 327809 */     GIR_EraseRootFromParent_Done,
     /* 327810 */   // Label 5492: @327810
     /* 327810 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(327945), // Rule ID 12349 //
     /* 327815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 327818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 327862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 327867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 327872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 327876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 327899 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 327899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 327902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 327904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 327909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 327914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 327919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 327924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 327929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 327934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 327943 */     GIR_RootConstrainSelectedInstOperands,
     /* 327944 */     // GIR_Coverage, 12349,
     /* 327944 */     GIR_EraseRootFromParent_Done,
     /* 327945 */   // Label 5493: @327945
     /* 327945 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(328080), // Rule ID 12350 //
     /* 327950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 327953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 327957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 327965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 327981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 327985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 327989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 327993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 327997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 327997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328034 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 328037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 328044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 328049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328078 */     GIR_RootConstrainSelectedInstOperands,
     /* 328079 */     // GIR_Coverage, 12350,
     /* 328079 */     GIR_EraseRootFromParent_Done,
     /* 328080 */   // Label 5494: @328080
     /* 328080 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(328215), // Rule ID 12827 //
     /* 328085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328169 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 328189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 328194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328213 */     GIR_RootConstrainSelectedInstOperands,
     /* 328214 */     // GIR_Coverage, 12827,
     /* 328214 */     GIR_EraseRootFromParent_Done,
     /* 328215 */   // Label 5495: @328215
     /* 328215 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(328350), // Rule ID 12828 //
     /* 328220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328304 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 328324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 328329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328348 */     GIR_RootConstrainSelectedInstOperands,
     /* 328349 */     // GIR_Coverage, 12828,
     /* 328349 */     GIR_EraseRootFromParent_Done,
     /* 328350 */   // Label 5496: @328350
     /* 328350 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(328485), // Rule ID 12829 //
     /* 328355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328439 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 328449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 328454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328483 */     GIR_RootConstrainSelectedInstOperands,
     /* 328484 */     // GIR_Coverage, 12829,
     /* 328484 */     GIR_EraseRootFromParent_Done,
     /* 328485 */   // Label 5497: @328485
     /* 328485 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(328620), // Rule ID 12830 //
     /* 328490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 328493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 328497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328574 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 328577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 328584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 328589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 328599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328618 */     GIR_RootConstrainSelectedInstOperands,
     /* 328619 */     // GIR_Coverage, 12830,
     /* 328619 */     GIR_EraseRootFromParent_Done,
     /* 328620 */   // Label 5498: @328620
     /* 328620 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(328755), // Rule ID 13307 //
     /* 328625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 328628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328709 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 328712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 328729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 328734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328753 */     GIR_RootConstrainSelectedInstOperands,
     /* 328754 */     // GIR_Coverage, 13307,
     /* 328754 */     GIR_EraseRootFromParent_Done,
     /* 328755 */   // Label 5499: @328755
     /* 328755 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(328890), // Rule ID 13308 //
     /* 328760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 328763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328844 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 328847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 328854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 328859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 328864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 328869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 328874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 328879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 328888 */     GIR_RootConstrainSelectedInstOperands,
     /* 328889 */     // GIR_Coverage, 13308,
     /* 328889 */     GIR_EraseRootFromParent_Done,
     /* 328890 */   // Label 5500: @328890
     /* 328890 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(329025), // Rule ID 13309 //
     /* 328895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 328898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 328902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 328910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 328914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 328918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 328926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 328930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 328934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 328938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 328942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 328942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 328947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 328947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 328952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 328956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 328979 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 328979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 328982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 328984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 328989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 328994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 328999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329023 */     GIR_RootConstrainSelectedInstOperands,
     /* 329024 */     // GIR_Coverage, 13309,
     /* 329024 */     GIR_EraseRootFromParent_Done,
     /* 329025 */   // Label 5501: @329025
     /* 329025 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(329160), // Rule ID 13310 //
     /* 329030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 329033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 329061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 329077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329114 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 329117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 329124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 329129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329158 */     GIR_RootConstrainSelectedInstOperands,
     /* 329159 */     // GIR_Coverage, 13310,
     /* 329159 */     GIR_EraseRootFromParent_Done,
     /* 329160 */   // Label 5502: @329160
     /* 329160 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(329295), // Rule ID 12392 //
     /* 329165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 329196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329249 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 329269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 329274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329293 */     GIR_RootConstrainSelectedInstOperands,
     /* 329294 */     // GIR_Coverage, 12392,
     /* 329294 */     GIR_EraseRootFromParent_Done,
     /* 329295 */   // Label 5503: @329295
     /* 329295 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(329430), // Rule ID 12393 //
     /* 329300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 329331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329384 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 329404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 329409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329428 */     GIR_RootConstrainSelectedInstOperands,
     /* 329429 */     // GIR_Coverage, 12393,
     /* 329429 */     GIR_EraseRootFromParent_Done,
     /* 329430 */   // Label 5504: @329430
     /* 329430 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(329565), // Rule ID 12394 //
     /* 329435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 329466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329519 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 329529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 329534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329563 */     GIR_RootConstrainSelectedInstOperands,
     /* 329564 */     // GIR_Coverage, 12394,
     /* 329564 */     GIR_EraseRootFromParent_Done,
     /* 329565 */   // Label 5505: @329565
     /* 329565 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(329700), // Rule ID 12395 //
     /* 329570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 329573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 329577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 329601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329654 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 329657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 329664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 329669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 329674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 329679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329698 */     GIR_RootConstrainSelectedInstOperands,
     /* 329699 */     // GIR_Coverage, 12395,
     /* 329699 */     GIR_EraseRootFromParent_Done,
     /* 329700 */   // Label 5506: @329700
     /* 329700 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(329835), // Rule ID 12872 //
     /* 329705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 329708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 329712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 329736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329762 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329789 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 329792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 329809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 329814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329833 */     GIR_RootConstrainSelectedInstOperands,
     /* 329834 */     // GIR_Coverage, 12872,
     /* 329834 */     GIR_EraseRootFromParent_Done,
     /* 329835 */   // Label 5507: @329835
     /* 329835 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(329970), // Rule ID 12873 //
     /* 329840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 329843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 329847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 329871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 329875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 329879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 329883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 329887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 329892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 329892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 329897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 329901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 329924 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 329924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 329927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 329929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 329934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 329939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 329944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 329949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 329954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 329959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 329968 */     GIR_RootConstrainSelectedInstOperands,
     /* 329969 */     // GIR_Coverage, 12873,
     /* 329969 */     GIR_EraseRootFromParent_Done,
     /* 329970 */   // Label 5508: @329970
     /* 329970 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(330105), // Rule ID 12874 //
     /* 329975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 329978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 329982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 329990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 329994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 329998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330059 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 330069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 330074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 330089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 330094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330103 */     GIR_RootConstrainSelectedInstOperands,
     /* 330104 */     // GIR_Coverage, 12874,
     /* 330104 */     GIR_EraseRootFromParent_Done,
     /* 330105 */   // Label 5509: @330105
     /* 330105 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(330240), // Rule ID 12875 //
     /* 330110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 330113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 330117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330194 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 330197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 330204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 330209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 330224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 330229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330238 */     GIR_RootConstrainSelectedInstOperands,
     /* 330239 */     // GIR_Coverage, 12875,
     /* 330239 */     GIR_EraseRootFromParent_Done,
     /* 330240 */   // Label 5510: @330240
     /* 330240 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(330375), // Rule ID 13352 //
     /* 330245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330329 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 330332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 330349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 330354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 330359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 330364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330373 */     GIR_RootConstrainSelectedInstOperands,
     /* 330374 */     // GIR_Coverage, 13352,
     /* 330374 */     GIR_EraseRootFromParent_Done,
     /* 330375 */   // Label 5511: @330375
     /* 330375 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(330510), // Rule ID 13353 //
     /* 330380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330432 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330464 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 330467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 330484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 330489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 330494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 330499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330508 */     GIR_RootConstrainSelectedInstOperands,
     /* 330509 */     // GIR_Coverage, 13353,
     /* 330509 */     GIR_EraseRootFromParent_Done,
     /* 330510 */   // Label 5512: @330510
     /* 330510 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(330645), // Rule ID 13354 //
     /* 330515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330599 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 330602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 330609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 330614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 330629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 330634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330643 */     GIR_RootConstrainSelectedInstOperands,
     /* 330644 */     // GIR_Coverage, 13354,
     /* 330644 */     GIR_EraseRootFromParent_Done,
     /* 330645 */   // Label 5513: @330645
     /* 330645 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(330780), // Rule ID 13355 //
     /* 330650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 330653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330734 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 330737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 330744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 330749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 330754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 330759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 330764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 330769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330778 */     GIR_RootConstrainSelectedInstOperands,
     /* 330779 */     // GIR_Coverage, 13355,
     /* 330779 */     GIR_EraseRootFromParent_Done,
     /* 330780 */   // Label 5514: @330780
     /* 330780 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(330915), // Rule ID 12332 //
     /* 330785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 330788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330869 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 330869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 330872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 330874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 330879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 330884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 330889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 330894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 330899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 330904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330913 */     GIR_RootConstrainSelectedInstOperands,
     /* 330914 */     // GIR_Coverage, 12332,
     /* 330914 */     GIR_EraseRootFromParent_Done,
     /* 330915 */   // Label 5515: @330915
     /* 330915 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(331050), // Rule ID 12333 //
     /* 330920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 330923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 330927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 330935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 330939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 330943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 330951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 330955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 330959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 330963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 330967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 330967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 330972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 330972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 330977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 330981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 330997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331004 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 331024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 331029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331048 */     GIR_RootConstrainSelectedInstOperands,
     /* 331049 */     // GIR_Coverage, 12333,
     /* 331049 */     GIR_EraseRootFromParent_Done,
     /* 331050 */   // Label 5516: @331050
     /* 331050 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(331185), // Rule ID 12334 //
     /* 331055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331107 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331112 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331139 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 331149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 331154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331183 */     GIR_RootConstrainSelectedInstOperands,
     /* 331184 */     // GIR_Coverage, 12334,
     /* 331184 */     GIR_EraseRootFromParent_Done,
     /* 331185 */   // Label 5517: @331185
     /* 331185 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(331320), // Rule ID 12335 //
     /* 331190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 331193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331274 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 331277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 331284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 331289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331318 */     GIR_RootConstrainSelectedInstOperands,
     /* 331319 */     // GIR_Coverage, 12335,
     /* 331319 */     GIR_EraseRootFromParent_Done,
     /* 331320 */   // Label 5518: @331320
     /* 331320 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(331455), // Rule ID 12812 //
     /* 331325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 331328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 331332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331409 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 331412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 331429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 331434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331453 */     GIR_RootConstrainSelectedInstOperands,
     /* 331454 */     // GIR_Coverage, 12812,
     /* 331454 */     GIR_EraseRootFromParent_Done,
     /* 331455 */   // Label 5519: @331455
     /* 331455 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(331590), // Rule ID 12813 //
     /* 331460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 331463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 331467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331544 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 331547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 331564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 331569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331588 */     GIR_RootConstrainSelectedInstOperands,
     /* 331589 */     // GIR_Coverage, 12813,
     /* 331589 */     GIR_EraseRootFromParent_Done,
     /* 331590 */   // Label 5520: @331590
     /* 331590 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(331725), // Rule ID 12814 //
     /* 331595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 331598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 331602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331679 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 331682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 331689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 331694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331723 */     GIR_RootConstrainSelectedInstOperands,
     /* 331724 */     // GIR_Coverage, 12814,
     /* 331724 */     GIR_EraseRootFromParent_Done,
     /* 331725 */   // Label 5521: @331725
     /* 331725 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(331860), // Rule ID 12815 //
     /* 331730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 331733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 331737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331814 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 331817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 331824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 331829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 331834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 331839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331858 */     GIR_RootConstrainSelectedInstOperands,
     /* 331859 */     // GIR_Coverage, 12815,
     /* 331859 */     GIR_EraseRootFromParent_Done,
     /* 331860 */   // Label 5522: @331860
     /* 331860 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(331995), // Rule ID 13292 //
     /* 331865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 331868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 331872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 331880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 331884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 331888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 331892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 331896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 331900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 331904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 331908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 331912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 331912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 331917 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 331917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 331922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 331926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 331928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 331949 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 331949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 331952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 331954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 331959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 331964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 331969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 331974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 331979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 331984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331993 */     GIR_RootConstrainSelectedInstOperands,
     /* 331994 */     // GIR_Coverage, 13292,
     /* 331994 */     GIR_EraseRootFromParent_Done,
     /* 331995 */   // Label 5523: @331995
     /* 331995 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(332130), // Rule ID 13293 //
     /* 332000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 332047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332084 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 332104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 332109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 332114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 332119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332128 */     GIR_RootConstrainSelectedInstOperands,
     /* 332129 */     // GIR_Coverage, 13293,
     /* 332129 */     GIR_EraseRootFromParent_Done,
     /* 332130 */   // Label 5524: @332130
     /* 332130 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(332265), // Rule ID 13294 //
     /* 332135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 332182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332219 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 332229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 332234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 332249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 332254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332263 */     GIR_RootConstrainSelectedInstOperands,
     /* 332264 */     // GIR_Coverage, 13294,
     /* 332264 */     GIR_EraseRootFromParent_Done,
     /* 332265 */   // Label 5525: @332265
     /* 332265 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(332400), // Rule ID 13295 //
     /* 332270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 332273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 332301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 332317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332354 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 332357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 332364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 332369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 332384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 332389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332398 */     GIR_RootConstrainSelectedInstOperands,
     /* 332399 */     // GIR_Coverage, 13295,
     /* 332399 */     GIR_EraseRootFromParent_Done,
     /* 332400 */   // Label 5526: @332400
     /* 332400 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(332535), // Rule ID 12403 //
     /* 332405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 332408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 332436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332489 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 332492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332533 */     GIR_RootConstrainSelectedInstOperands,
     /* 332534 */     // GIR_Coverage, 12403,
     /* 332534 */     GIR_EraseRootFromParent_Done,
     /* 332535 */   // Label 5527: @332535
     /* 332535 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(332670), // Rule ID 12404 //
     /* 332540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 332543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 332571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332592 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332624 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 332627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 332634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 332639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 332644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 332649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332668 */     GIR_RootConstrainSelectedInstOperands,
     /* 332669 */     // GIR_Coverage, 12404,
     /* 332669 */     GIR_EraseRootFromParent_Done,
     /* 332670 */   // Label 5528: @332670
     /* 332670 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(332805), // Rule ID 12405 //
     /* 332675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 332678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 332706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332759 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 332762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332803 */     GIR_RootConstrainSelectedInstOperands,
     /* 332804 */     // GIR_Coverage, 12405,
     /* 332804 */     GIR_EraseRootFromParent_Done,
     /* 332805 */   // Label 5529: @332805
     /* 332805 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(332940), // Rule ID 12406 //
     /* 332810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 332813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 332817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 332841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332857 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 332867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 332871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 332894 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 332894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 332897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 332899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 332904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 332909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 332914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 332919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 332924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 332929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332938 */     GIR_RootConstrainSelectedInstOperands,
     /* 332939 */     // GIR_Coverage, 12406,
     /* 332939 */     GIR_EraseRootFromParent_Done,
     /* 332940 */   // Label 5530: @332940
     /* 332940 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(333075), // Rule ID 12883 //
     /* 332945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 332948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 332952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 332968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 332976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 332980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 332984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 332988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 332992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 332992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 332997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 332997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333029 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333073 */     GIR_RootConstrainSelectedInstOperands,
     /* 333074 */     // GIR_Coverage, 12883,
     /* 333074 */     GIR_EraseRootFromParent_Done,
     /* 333075 */   // Label 5531: @333075
     /* 333075 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(333210), // Rule ID 12884 //
     /* 333080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 333111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333164 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333208 */     GIR_RootConstrainSelectedInstOperands,
     /* 333209 */     // GIR_Coverage, 12884,
     /* 333209 */     GIR_EraseRootFromParent_Done,
     /* 333210 */   // Label 5532: @333210
     /* 333210 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(333345), // Rule ID 12885 //
     /* 333215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 333246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333299 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333343 */     GIR_RootConstrainSelectedInstOperands,
     /* 333344 */     // GIR_Coverage, 12885,
     /* 333344 */     GIR_EraseRootFromParent_Done,
     /* 333345 */   // Label 5533: @333345
     /* 333345 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(333480), // Rule ID 12886 //
     /* 333350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 333353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 333357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 333381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333397 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333407 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333434 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 333437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333478 */     GIR_RootConstrainSelectedInstOperands,
     /* 333479 */     // GIR_Coverage, 12886,
     /* 333479 */     GIR_EraseRootFromParent_Done,
     /* 333480 */   // Label 5534: @333480
     /* 333480 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(333615), // Rule ID 13363 //
     /* 333485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 333488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 333516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333569 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 333572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333613 */     GIR_RootConstrainSelectedInstOperands,
     /* 333614 */     // GIR_Coverage, 13363,
     /* 333614 */     GIR_EraseRootFromParent_Done,
     /* 333615 */   // Label 5535: @333615
     /* 333615 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(333750), // Rule ID 13364 //
     /* 333620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 333623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 333651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333704 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 333707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 333714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 333719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 333724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 333729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333748 */     GIR_RootConstrainSelectedInstOperands,
     /* 333749 */     // GIR_Coverage, 13364,
     /* 333749 */     GIR_EraseRootFromParent_Done,
     /* 333750 */   // Label 5536: @333750
     /* 333750 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(333885), // Rule ID 13365 //
     /* 333755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 333758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 333786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333839 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 333842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 333869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 333874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 333883 */     GIR_RootConstrainSelectedInstOperands,
     /* 333884 */     // GIR_Coverage, 13365,
     /* 333884 */     GIR_EraseRootFromParent_Done,
     /* 333885 */   // Label 5537: @333885
     /* 333885 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(334020), // Rule ID 13366 //
     /* 333890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 333893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 333897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 333909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 333913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 333917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 333921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 333925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 333929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 333933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 333937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 333937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 333942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 333942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 333947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 333951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 333974 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 333974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 333977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 333979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 333984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 333989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 333994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 333999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334018 */     GIR_RootConstrainSelectedInstOperands,
     /* 334019 */     // GIR_Coverage, 13366,
     /* 334019 */     GIR_EraseRootFromParent_Done,
     /* 334020 */   // Label 5538: @334020
     /* 334020 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(334155), // Rule ID 12343 //
     /* 334025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334109 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334153 */     GIR_RootConstrainSelectedInstOperands,
     /* 334154 */     // GIR_Coverage, 12343,
     /* 334154 */     GIR_EraseRootFromParent_Done,
     /* 334155 */   // Label 5539: @334155
     /* 334155 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(334290), // Rule ID 12344 //
     /* 334160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334207 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334217 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334244 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334288 */     GIR_RootConstrainSelectedInstOperands,
     /* 334289 */     // GIR_Coverage, 12344,
     /* 334289 */     GIR_EraseRootFromParent_Done,
     /* 334290 */   // Label 5540: @334290
     /* 334290 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(334425), // Rule ID 12345 //
     /* 334295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334379 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334423 */     GIR_RootConstrainSelectedInstOperands,
     /* 334424 */     // GIR_Coverage, 12345,
     /* 334424 */     GIR_EraseRootFromParent_Done,
     /* 334425 */   // Label 5541: @334425
     /* 334425 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(334560), // Rule ID 12346 //
     /* 334430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 334433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 334437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334514 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 334517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334558 */     GIR_RootConstrainSelectedInstOperands,
     /* 334559 */     // GIR_Coverage, 12346,
     /* 334559 */     GIR_EraseRootFromParent_Done,
     /* 334560 */   // Label 5542: @334560
     /* 334560 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(334695), // Rule ID 12823 //
     /* 334565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 334568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 334572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334649 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 334652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334693 */     GIR_RootConstrainSelectedInstOperands,
     /* 334694 */     // GIR_Coverage, 12823,
     /* 334694 */     GIR_EraseRootFromParent_Done,
     /* 334695 */   // Label 5543: @334695
     /* 334695 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(334830), // Rule ID 12824 //
     /* 334700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 334703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 334707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334784 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 334787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 334794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 334799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 334804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 334809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334828 */     GIR_RootConstrainSelectedInstOperands,
     /* 334829 */     // GIR_Coverage, 12824,
     /* 334829 */     GIR_EraseRootFromParent_Done,
     /* 334830 */   // Label 5544: @334830
     /* 334830 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(334965), // Rule ID 12825 //
     /* 334835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 334838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 334842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 334866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 334870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 334874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 334878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 334882 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 334882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 334887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 334887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 334892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 334896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 334919 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 334919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 334922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 334924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 334929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 334934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 334939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 334944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 334949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 334954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334963 */     GIR_RootConstrainSelectedInstOperands,
     /* 334964 */     // GIR_Coverage, 12825,
     /* 334964 */     GIR_EraseRootFromParent_Done,
     /* 334965 */   // Label 5545: @334965
     /* 334965 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(335100), // Rule ID 12826 //
     /* 334970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 334973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 334977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 334985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 334989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 334993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 334997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335054 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 335057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335098 */     GIR_RootConstrainSelectedInstOperands,
     /* 335099 */     // GIR_Coverage, 12826,
     /* 335099 */     GIR_EraseRootFromParent_Done,
     /* 335100 */   // Label 5546: @335100
     /* 335100 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(335235), // Rule ID 13303 //
     /* 335105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335189 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335233 */     GIR_RootConstrainSelectedInstOperands,
     /* 335234 */     // GIR_Coverage, 13303,
     /* 335234 */     GIR_EraseRootFromParent_Done,
     /* 335235 */   // Label 5547: @335235
     /* 335235 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(335370), // Rule ID 13304 //
     /* 335240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335324 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335368 */     GIR_RootConstrainSelectedInstOperands,
     /* 335369 */     // GIR_Coverage, 13304,
     /* 335369 */     GIR_EraseRootFromParent_Done,
     /* 335370 */   // Label 5548: @335370
     /* 335370 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(335505), // Rule ID 13305 //
     /* 335375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335436 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335459 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335503 */     GIR_RootConstrainSelectedInstOperands,
     /* 335504 */     // GIR_Coverage, 13305,
     /* 335504 */     GIR_EraseRootFromParent_Done,
     /* 335505 */   // Label 5549: @335505
     /* 335505 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(335640), // Rule ID 13306 //
     /* 335510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 335513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 335541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 335557 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335594 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 335597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 335604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 335609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 335614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 335619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335638 */     GIR_RootConstrainSelectedInstOperands,
     /* 335639 */     // GIR_Coverage, 13306,
     /* 335639 */     GIR_EraseRootFromParent_Done,
     /* 335640 */   // Label 5550: @335640
     /* 335640 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(335775), // Rule ID 12388 //
     /* 335645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 335648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 335676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335729 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 335732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335773 */     GIR_RootConstrainSelectedInstOperands,
     /* 335774 */     // GIR_Coverage, 12388,
     /* 335774 */     GIR_EraseRootFromParent_Done,
     /* 335775 */   // Label 5551: @335775
     /* 335775 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(335910), // Rule ID 12389 //
     /* 335780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 335783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 335811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335864 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 335867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 335869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 335874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 335879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 335884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 335889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 335894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 335899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335908 */     GIR_RootConstrainSelectedInstOperands,
     /* 335909 */     // GIR_Coverage, 12389,
     /* 335909 */     GIR_EraseRootFromParent_Done,
     /* 335910 */   // Label 5552: @335910
     /* 335910 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(336045), // Rule ID 12390 //
     /* 335915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 335918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 335922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 335934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 335938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 335946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 335950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 335954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 335958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 335962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 335962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 335967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 335967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 335972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 335976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 335999 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 335999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336043 */     GIR_RootConstrainSelectedInstOperands,
     /* 336044 */     // GIR_Coverage, 12390,
     /* 336044 */     GIR_EraseRootFromParent_Done,
     /* 336045 */   // Label 5553: @336045
     /* 336045 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(336180), // Rule ID 12391 //
     /* 336050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 336053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 336093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 336102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 336107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336134 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 336137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336178 */     GIR_RootConstrainSelectedInstOperands,
     /* 336179 */     // GIR_Coverage, 12391,
     /* 336179 */     GIR_EraseRootFromParent_Done,
     /* 336180 */   // Label 5554: @336180
     /* 336180 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(336315), // Rule ID 12868 //
     /* 336185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 336228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 336237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 336242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336269 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 336272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336313 */     GIR_RootConstrainSelectedInstOperands,
     /* 336314 */     // GIR_Coverage, 12868,
     /* 336314 */     GIR_EraseRootFromParent_Done,
     /* 336315 */   // Label 5555: @336315
     /* 336315 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(336450), // Rule ID 12869 //
     /* 336320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 336363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336367 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 336372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 336377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336404 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 336407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336448 */     GIR_RootConstrainSelectedInstOperands,
     /* 336449 */     // GIR_Coverage, 12869,
     /* 336449 */     GIR_EraseRootFromParent_Done,
     /* 336450 */   // Label 5556: @336450
     /* 336450 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(336585), // Rule ID 12870 //
     /* 336455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 336498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 336507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 336512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336539 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 336542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336583 */     GIR_RootConstrainSelectedInstOperands,
     /* 336584 */     // GIR_Coverage, 12870,
     /* 336584 */     GIR_EraseRootFromParent_Done,
     /* 336585 */   // Label 5557: @336585
     /* 336585 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(336720), // Rule ID 12871 //
     /* 336590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 336593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 336597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 336633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 336642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 336647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336674 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 336677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 336684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 336689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 336694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 336699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336718 */     GIR_RootConstrainSelectedInstOperands,
     /* 336719 */     // GIR_Coverage, 12871,
     /* 336719 */     GIR_EraseRootFromParent_Done,
     /* 336720 */   // Label 5558: @336720
     /* 336720 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(336855), // Rule ID 13348 //
     /* 336725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 336728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 336768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 336777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 336782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336809 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 336812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336853 */     GIR_RootConstrainSelectedInstOperands,
     /* 336854 */     // GIR_Coverage, 13348,
     /* 336854 */     GIR_EraseRootFromParent_Done,
     /* 336855 */   // Label 5559: @336855
     /* 336855 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(336990), // Rule ID 13349 //
     /* 336860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 336863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 336867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 336883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 336891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 336895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 336899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 336903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 336907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 336907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 336912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 336912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 336917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 336921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 336944 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 336944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 336947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 336949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 336954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 336959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 336964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 336969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 336974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 336979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336988 */     GIR_RootConstrainSelectedInstOperands,
     /* 336989 */     // GIR_Coverage, 13349,
     /* 336989 */     GIR_EraseRootFromParent_Done,
     /* 336990 */   // Label 5560: @336990
     /* 336990 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(337125), // Rule ID 13350 //
     /* 336995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 336998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337042 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337079 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337123 */     GIR_RootConstrainSelectedInstOperands,
     /* 337124 */     // GIR_Coverage, 13350,
     /* 337124 */     GIR_EraseRootFromParent_Done,
     /* 337125 */   // Label 5561: @337125
     /* 337125 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(337260), // Rule ID 13351 //
     /* 337130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 337133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337214 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 337217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337258 */     GIR_RootConstrainSelectedInstOperands,
     /* 337259 */     // GIR_Coverage, 13351,
     /* 337259 */     GIR_EraseRootFromParent_Done,
     /* 337260 */   // Label 5562: @337260
     /* 337260 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(337395), // Rule ID 12328 //
     /* 337265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 337268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337349 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 337352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337393 */     GIR_RootConstrainSelectedInstOperands,
     /* 337394 */     // GIR_Coverage, 12328,
     /* 337394 */     GIR_EraseRootFromParent_Done,
     /* 337395 */   // Label 5563: @337395
     /* 337395 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(337530), // Rule ID 12329 //
     /* 337400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 337403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337484 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 337487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337528 */     GIR_RootConstrainSelectedInstOperands,
     /* 337529 */     // GIR_Coverage, 12329,
     /* 337529 */     GIR_EraseRootFromParent_Done,
     /* 337530 */   // Label 5564: @337530
     /* 337530 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(337665), // Rule ID 12330 //
     /* 337535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 337538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337619 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 337622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337663 */     GIR_RootConstrainSelectedInstOperands,
     /* 337664 */     // GIR_Coverage, 12330,
     /* 337664 */     GIR_EraseRootFromParent_Done,
     /* 337665 */   // Label 5565: @337665
     /* 337665 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(337800), // Rule ID 12331 //
     /* 337670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 337673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 337677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337754 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 337757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 337764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 337769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 337774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 337779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337798 */     GIR_RootConstrainSelectedInstOperands,
     /* 337799 */     // GIR_Coverage, 12331,
     /* 337799 */     GIR_EraseRootFromParent_Done,
     /* 337800 */   // Label 5566: @337800
     /* 337800 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(337935), // Rule ID 12808 //
     /* 337805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 337808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 337812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337852 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337857 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 337866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 337889 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 337889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 337892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 337894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 337899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 337904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 337909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 337914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 337919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 337924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337933 */     GIR_RootConstrainSelectedInstOperands,
     /* 337934 */     // GIR_Coverage, 12808,
     /* 337934 */     GIR_EraseRootFromParent_Done,
     /* 337935 */   // Label 5567: @337935
     /* 337935 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(338070), // Rule ID 12809 //
     /* 337940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 337943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 337947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 337955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 337963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 337971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 337975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 337979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 337983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 337987 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 337987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 337992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 337992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 337997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338024 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338068 */     GIR_RootConstrainSelectedInstOperands,
     /* 338069 */     // GIR_Coverage, 12809,
     /* 338069 */     GIR_EraseRootFromParent_Done,
     /* 338070 */   // Label 5568: @338070
     /* 338070 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(338205), // Rule ID 12810 //
     /* 338075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 338102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 338106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 338118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338122 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 338127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 338132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338159 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338203 */     GIR_RootConstrainSelectedInstOperands,
     /* 338204 */     // GIR_Coverage, 12810,
     /* 338204 */     GIR_EraseRootFromParent_Done,
     /* 338205 */   // Label 5569: @338205
     /* 338205 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(338340), // Rule ID 12811 //
     /* 338210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 338213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 338217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 338237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 338241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 338253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 338262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 338267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338294 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 338297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338338 */     GIR_RootConstrainSelectedInstOperands,
     /* 338339 */     // GIR_Coverage, 12811,
     /* 338339 */     GIR_EraseRootFromParent_Done,
     /* 338340 */   // Label 5570: @338340
     /* 338340 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(338475), // Rule ID 13288 //
     /* 338345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 338348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 338372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 338376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 338388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 338397 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 338402 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338429 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 338432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338473 */     GIR_RootConstrainSelectedInstOperands,
     /* 338474 */     // GIR_Coverage, 13288,
     /* 338474 */     GIR_EraseRootFromParent_Done,
     /* 338475 */   // Label 5571: @338475
     /* 338475 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(338610), // Rule ID 13289 //
     /* 338480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 338483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 338507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 338511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 338523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338527 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 338532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 338537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338541 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338543 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338564 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 338567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338608 */     GIR_RootConstrainSelectedInstOperands,
     /* 338609 */     // GIR_Coverage, 13289,
     /* 338609 */     GIR_EraseRootFromParent_Done,
     /* 338610 */   // Label 5572: @338610
     /* 338610 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(338745), // Rule ID 13290 //
     /* 338615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 338618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 338642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 338646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 338658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 338667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 338672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338699 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 338702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338743 */     GIR_RootConstrainSelectedInstOperands,
     /* 338744 */     // GIR_Coverage, 13290,
     /* 338744 */     GIR_EraseRootFromParent_Done,
     /* 338745 */   // Label 5573: @338745
     /* 338745 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(338880), // Rule ID 13291 //
     /* 338750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 338753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 338777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 338781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 338793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 338802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 338807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338834 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 338837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 338844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 338849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 338854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 338859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 338869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338878 */     GIR_RootConstrainSelectedInstOperands,
     /* 338879 */     // GIR_Coverage, 13291,
     /* 338879 */     GIR_EraseRootFromParent_Done,
     /* 338880 */   // Label 5574: @338880
     /* 338880 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(339015), // Rule ID 12337 //
     /* 338885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 338888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 338892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 338900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 338904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 338908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 338916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 338920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 338924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 338928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 338932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 338932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 338937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 338937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 338942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 338946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 338969 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 338969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 338972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 338974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 338979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 338984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 338989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 338994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 338999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339013 */     GIR_RootConstrainSelectedInstOperands,
     /* 339014 */     // GIR_Coverage, 12337,
     /* 339014 */     GIR_EraseRootFromParent_Done,
     /* 339015 */   // Label 5575: @339015
     /* 339015 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(339150), // Rule ID 12338 //
     /* 339020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 339023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339067 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339104 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 339107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339148 */     GIR_RootConstrainSelectedInstOperands,
     /* 339149 */     // GIR_Coverage, 12338,
     /* 339149 */     GIR_EraseRootFromParent_Done,
     /* 339150 */   // Label 5576: @339150
     /* 339150 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(339285), // Rule ID 12341 //
     /* 339155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 339158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339202 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339207 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339212 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339232 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339239 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 339242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339283 */     GIR_RootConstrainSelectedInstOperands,
     /* 339284 */     // GIR_Coverage, 12341,
     /* 339284 */     GIR_EraseRootFromParent_Done,
     /* 339285 */   // Label 5577: @339285
     /* 339285 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(339420), // Rule ID 12342 //
     /* 339290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 339293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339337 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339374 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 339377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339418 */     GIR_RootConstrainSelectedInstOperands,
     /* 339419 */     // GIR_Coverage, 12342,
     /* 339419 */     GIR_EraseRootFromParent_Done,
     /* 339420 */   // Label 5578: @339420
     /* 339420 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(339555), // Rule ID 12817 //
     /* 339425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 339428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 339432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339509 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339553 */     GIR_RootConstrainSelectedInstOperands,
     /* 339554 */     // GIR_Coverage, 12817,
     /* 339554 */     GIR_EraseRootFromParent_Done,
     /* 339555 */   // Label 5579: @339555
     /* 339555 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(339690), // Rule ID 12818 //
     /* 339560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 339563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 339567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339644 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 339654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 339659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 339664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 339669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339688 */     GIR_RootConstrainSelectedInstOperands,
     /* 339689 */     // GIR_Coverage, 12818,
     /* 339689 */     GIR_EraseRootFromParent_Done,
     /* 339690 */   // Label 5580: @339690
     /* 339690 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(339825), // Rule ID 12821 //
     /* 339695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 339698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 339702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339779 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339823 */     GIR_RootConstrainSelectedInstOperands,
     /* 339824 */     // GIR_Coverage, 12821,
     /* 339824 */     GIR_EraseRootFromParent_Done,
     /* 339825 */   // Label 5581: @339825
     /* 339825 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(339960), // Rule ID 12822 //
     /* 339830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 339833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 339837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 339865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 339869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 339877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 339877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 339882 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 339882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 339887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 339891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339907 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 339914 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 339914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 339917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 339919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 339924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 339929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 339934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 339939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 339944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 339949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339958 */     GIR_RootConstrainSelectedInstOperands,
     /* 339959 */     // GIR_Coverage, 12822,
     /* 339959 */     GIR_EraseRootFromParent_Done,
     /* 339960 */   // Label 5582: @339960
     /* 339960 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(340095), // Rule ID 13297 //
     /* 339965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 339968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 339972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 339980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 339984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 339988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 339996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 340012 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340022 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340049 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340093 */     GIR_RootConstrainSelectedInstOperands,
     /* 340094 */     // GIR_Coverage, 13297,
     /* 340094 */     GIR_EraseRootFromParent_Done,
     /* 340095 */   // Label 5583: @340095
     /* 340095 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(340230), // Rule ID 13298 //
     /* 340100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 340147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340184 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340228 */     GIR_RootConstrainSelectedInstOperands,
     /* 340229 */     // GIR_Coverage, 13298,
     /* 340229 */     GIR_EraseRootFromParent_Done,
     /* 340230 */   // Label 5584: @340230
     /* 340230 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(340365), // Rule ID 13301 //
     /* 340235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 340282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340319 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340363 */     GIR_RootConstrainSelectedInstOperands,
     /* 340364 */     // GIR_Coverage, 13301,
     /* 340364 */     GIR_EraseRootFromParent_Done,
     /* 340365 */   // Label 5585: @340365
     /* 340365 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(340500), // Rule ID 13302 //
     /* 340370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 340373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 340417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340454 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 340457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340498 */     GIR_RootConstrainSelectedInstOperands,
     /* 340499 */     // GIR_Coverage, 13302,
     /* 340499 */     GIR_EraseRootFromParent_Done,
     /* 340500 */   // Label 5586: @340500
     /* 340500 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(340635), // Rule ID 12322 //
     /* 340505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340552 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340557 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340562 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340589 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340633 */     GIR_RootConstrainSelectedInstOperands,
     /* 340634 */     // GIR_Coverage, 12322,
     /* 340634 */     GIR_EraseRootFromParent_Done,
     /* 340635 */   // Label 5587: @340635
     /* 340635 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(340770), // Rule ID 12323 //
     /* 340640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340687 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340724 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 340734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 340739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 340744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 340749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340768 */     GIR_RootConstrainSelectedInstOperands,
     /* 340769 */     // GIR_Coverage, 12323,
     /* 340769 */     GIR_EraseRootFromParent_Done,
     /* 340770 */   // Label 5588: @340770
     /* 340770 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(340905), // Rule ID 12326 //
     /* 340775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340822 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340859 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 340869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 340874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 340879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 340884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 340889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 340894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340903 */     GIR_RootConstrainSelectedInstOperands,
     /* 340904 */     // GIR_Coverage, 12326,
     /* 340904 */     GIR_EraseRootFromParent_Done,
     /* 340905 */   // Label 5589: @340905
     /* 340905 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(341040), // Rule ID 12327 //
     /* 340910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 340913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 340917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 340925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 340929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 340933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 340941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 340945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 340949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 340953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 340957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 340957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 340962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 340962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 340967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 340971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 340994 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 340994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 340997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 340999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341038 */     GIR_RootConstrainSelectedInstOperands,
     /* 341039 */     // GIR_Coverage, 12327,
     /* 341039 */     GIR_EraseRootFromParent_Done,
     /* 341040 */   // Label 5590: @341040
     /* 341040 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(341175), // Rule ID 12802 //
     /* 341045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341129 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341173 */     GIR_RootConstrainSelectedInstOperands,
     /* 341174 */     // GIR_Coverage, 12802,
     /* 341174 */     GIR_EraseRootFromParent_Done,
     /* 341175 */   // Label 5591: @341175
     /* 341175 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(341310), // Rule ID 12803 //
     /* 341180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341264 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341308 */     GIR_RootConstrainSelectedInstOperands,
     /* 341309 */     // GIR_Coverage, 12803,
     /* 341309 */     GIR_EraseRootFromParent_Done,
     /* 341310 */   // Label 5592: @341310
     /* 341310 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(341445), // Rule ID 12806 //
     /* 341315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341362 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341367 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341376 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341399 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341443 */     GIR_RootConstrainSelectedInstOperands,
     /* 341444 */     // GIR_Coverage, 12806,
     /* 341444 */     GIR_EraseRootFromParent_Done,
     /* 341445 */   // Label 5593: @341445
     /* 341445 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(341580), // Rule ID 12807 //
     /* 341450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 341453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 341457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341497 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341534 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 341537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341578 */     GIR_RootConstrainSelectedInstOperands,
     /* 341579 */     // GIR_Coverage, 12807,
     /* 341579 */     GIR_EraseRootFromParent_Done,
     /* 341580 */   // Label 5594: @341580
     /* 341580 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(341715), // Rule ID 13282 //
     /* 341585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 341588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341632 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341669 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 341672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341713 */     GIR_RootConstrainSelectedInstOperands,
     /* 341714 */     // GIR_Coverage, 13282,
     /* 341714 */     GIR_EraseRootFromParent_Done,
     /* 341715 */   // Label 5595: @341715
     /* 341715 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(341850), // Rule ID 13283 //
     /* 341720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 341723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341777 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341804 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 341807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 341814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 341819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 341824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 341829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341848 */     GIR_RootConstrainSelectedInstOperands,
     /* 341849 */     // GIR_Coverage, 13283,
     /* 341849 */     GIR_EraseRootFromParent_Done,
     /* 341850 */   // Label 5596: @341850
     /* 341850 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(341985), // Rule ID 13286 //
     /* 341855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 341858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 341870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 341886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 341890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 341894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 341898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 341902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 341902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 341907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 341907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 341912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 341916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 341918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 341939 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 341939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 341942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 341944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 341949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 341954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 341959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 341964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 341969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 341974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341983 */     GIR_RootConstrainSelectedInstOperands,
     /* 341984 */     // GIR_Coverage, 13286,
     /* 341984 */     GIR_EraseRootFromParent_Done,
     /* 341985 */   // Label 5597: @341985
     /* 341985 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(342120), // Rule ID 13287 //
     /* 341990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 341993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 341997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 342033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 342037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342042 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342074 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342118 */     GIR_RootConstrainSelectedInstOperands,
     /* 342119 */     // GIR_Coverage, 13287,
     /* 342119 */     GIR_EraseRootFromParent_Done,
     /* 342120 */   // Label 5598: @342120
     /* 342120 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(342255), // Rule ID 7776 //
     /* 342125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 342168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342172 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342202 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342209 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342253 */     GIR_RootConstrainSelectedInstOperands,
     /* 342254 */     // GIR_Coverage, 7776,
     /* 342254 */     GIR_EraseRootFromParent_Done,
     /* 342255 */   // Label 5599: @342255
     /* 342255 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(342390), // Rule ID 7808 //
     /* 342260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 342263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 342267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 342303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342307 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342312 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342344 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 342347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342388 */     GIR_RootConstrainSelectedInstOperands,
     /* 342389 */     // GIR_Coverage, 7808,
     /* 342389 */     GIR_EraseRootFromParent_Done,
     /* 342390 */   // Label 5600: @342390
     /* 342390 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(342525), // Rule ID 7840 //
     /* 342395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 342398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 342438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342479 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 342482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342523 */     GIR_RootConstrainSelectedInstOperands,
     /* 342524 */     // GIR_Coverage, 7840,
     /* 342524 */     GIR_EraseRootFromParent_Done,
     /* 342525 */   // Label 5601: @342525
     /* 342525 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(342660), // Rule ID 12336 //
     /* 342530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 342573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342614 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 342624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 342629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 342634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 342639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342658 */     GIR_RootConstrainSelectedInstOperands,
     /* 342659 */     // GIR_Coverage, 12336,
     /* 342659 */     GIR_EraseRootFromParent_Done,
     /* 342660 */   // Label 5602: @342660
     /* 342660 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(342795), // Rule ID 12339 //
     /* 342665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 342708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342722 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342742 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342749 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342793 */     GIR_RootConstrainSelectedInstOperands,
     /* 342794 */     // GIR_Coverage, 12339,
     /* 342794 */     GIR_EraseRootFromParent_Done,
     /* 342795 */   // Label 5603: @342795
     /* 342795 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(342930), // Rule ID 12340 //
     /* 342800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 342803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 342807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 342843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342852 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342852 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342877 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 342884 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 342884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 342887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 342889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 342894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 342899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 342904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 342909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 342914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 342919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342928 */     GIR_RootConstrainSelectedInstOperands,
     /* 342929 */     // GIR_Coverage, 12340,
     /* 342929 */     GIR_EraseRootFromParent_Done,
     /* 342930 */   // Label 5604: @342930
     /* 342930 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(343065), // Rule ID 12816 //
     /* 342935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 342938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 342942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 342950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 342954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 342958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 342966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 342970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 342974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 342978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 342982 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 342982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 342987 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 342987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 342992 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 342996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343019 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343063 */     GIR_RootConstrainSelectedInstOperands,
     /* 343064 */     // GIR_Coverage, 12816,
     /* 343064 */     GIR_EraseRootFromParent_Done,
     /* 343065 */   // Label 5605: @343065
     /* 343065 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(343200), // Rule ID 12819 //
     /* 343070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 343101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 343113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 343117 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343122 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343122 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343154 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343198 */     GIR_RootConstrainSelectedInstOperands,
     /* 343199 */     // GIR_Coverage, 12819,
     /* 343199 */     GIR_EraseRootFromParent_Done,
     /* 343200 */   // Label 5606: @343200
     /* 343200 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(343335), // Rule ID 12820 //
     /* 343205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 343236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 343248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 343252 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343257 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343289 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343333 */     GIR_RootConstrainSelectedInstOperands,
     /* 343334 */     // GIR_Coverage, 12820,
     /* 343334 */     GIR_EraseRootFromParent_Done,
     /* 343335 */   // Label 5607: @343335
     /* 343335 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(343470), // Rule ID 13296 //
     /* 343340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 343343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 343371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 343383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 343387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343424 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 343427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343468 */     GIR_RootConstrainSelectedInstOperands,
     /* 343469 */     // GIR_Coverage, 13296,
     /* 343469 */     GIR_EraseRootFromParent_Done,
     /* 343470 */   // Label 5608: @343470
     /* 343470 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(343605), // Rule ID 13299 //
     /* 343475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 343478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 343506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 343518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 343522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343527 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343559 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 343562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343603 */     GIR_RootConstrainSelectedInstOperands,
     /* 343604 */     // GIR_Coverage, 13299,
     /* 343604 */     GIR_EraseRootFromParent_Done,
     /* 343605 */   // Label 5609: @343605
     /* 343605 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(343740), // Rule ID 13300 //
     /* 343610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 343613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 343641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 343653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 343657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343662 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343687 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343694 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 343697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 343704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 343709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 343714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 343719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343738 */     GIR_RootConstrainSelectedInstOperands,
     /* 343739 */     // GIR_Coverage, 13300,
     /* 343739 */     GIR_EraseRootFromParent_Done,
     /* 343740 */   // Label 5610: @343740
     /* 343740 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(343875), // Rule ID 7775 //
     /* 343745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 343748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 343752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 343776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 343788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343792 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343829 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 343832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343873 */     GIR_RootConstrainSelectedInstOperands,
     /* 343874 */     // GIR_Coverage, 7775,
     /* 343874 */     GIR_EraseRootFromParent_Done,
     /* 343875 */   // Label 5611: @343875
     /* 343875 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(344010), // Rule ID 7807 //
     /* 343880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 343883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 343887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 343895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 343899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 343903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 343911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 343915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 343919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 343923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 343927 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 343927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 343932 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 343932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 343937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 343941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 343964 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 343964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 343967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 343969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 343974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 343979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 343984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 343989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 343994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 343999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344008 */     GIR_RootConstrainSelectedInstOperands,
     /* 344009 */     // GIR_Coverage, 7807,
     /* 344009 */     GIR_EraseRootFromParent_Done,
     /* 344010 */   // Label 5612: @344010
     /* 344010 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(344145), // Rule ID 7839 //
     /* 344015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344067 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344072 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344076 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344099 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 344102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344143 */     GIR_RootConstrainSelectedInstOperands,
     /* 344144 */     // GIR_Coverage, 7839,
     /* 344144 */     GIR_EraseRootFromParent_Done,
     /* 344145 */   // Label 5613: @344145
     /* 344145 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(344280), // Rule ID 12321 //
     /* 344150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344202 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344234 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344278 */     GIR_RootConstrainSelectedInstOperands,
     /* 344279 */     // GIR_Coverage, 12321,
     /* 344279 */     GIR_EraseRootFromParent_Done,
     /* 344280 */   // Label 5614: @344280
     /* 344280 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(344415), // Rule ID 12324 //
     /* 344285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344332 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344337 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344337 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344342 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344369 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344413 */     GIR_RootConstrainSelectedInstOperands,
     /* 344414 */     // GIR_Coverage, 12324,
     /* 344414 */     GIR_EraseRootFromParent_Done,
     /* 344415 */   // Label 5615: @344415
     /* 344415 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(344550), // Rule ID 12325 //
     /* 344420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 344423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344467 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344472 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344477 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344504 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 344507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344548 */     GIR_RootConstrainSelectedInstOperands,
     /* 344549 */     // GIR_Coverage, 12325,
     /* 344549 */     GIR_EraseRootFromParent_Done,
     /* 344550 */   // Label 5616: @344550
     /* 344550 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(344685), // Rule ID 12801 //
     /* 344555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 344558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 344562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344602 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344607 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344639 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 344642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 344649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 344654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 344659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 344664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344683 */     GIR_RootConstrainSelectedInstOperands,
     /* 344684 */     // GIR_Coverage, 12801,
     /* 344684 */     GIR_EraseRootFromParent_Done,
     /* 344685 */   // Label 5617: @344685
     /* 344685 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(344820), // Rule ID 12804 //
     /* 344690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 344693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 344697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344737 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344742 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344774 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 344777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344818 */     GIR_RootConstrainSelectedInstOperands,
     /* 344819 */     // GIR_Coverage, 12804,
     /* 344819 */     GIR_EraseRootFromParent_Done,
     /* 344820 */   // Label 5618: @344820
     /* 344820 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(344955), // Rule ID 12805 //
     /* 344825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 344828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 344832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 344868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 344872 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 344872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 344877 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 344877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 344882 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 344886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 344909 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 344909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 344912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 344914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 344919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 344924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 344929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 344934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 344939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 344944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344953 */     GIR_RootConstrainSelectedInstOperands,
     /* 344954 */     // GIR_Coverage, 12805,
     /* 344954 */     GIR_EraseRootFromParent_Done,
     /* 344955 */   // Label 5619: @344955
     /* 344955 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(345090), // Rule ID 13281 //
     /* 344960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 344963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 344967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 344975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 344979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 344983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 344991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 344995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 344999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 345007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345012 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345012 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345037 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345044 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345088 */     GIR_RootConstrainSelectedInstOperands,
     /* 345089 */     // GIR_Coverage, 13281,
     /* 345089 */     GIR_EraseRootFromParent_Done,
     /* 345090 */   // Label 5620: @345090
     /* 345090 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(345225), // Rule ID 13284 //
     /* 345095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 345126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 345142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345147 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345152 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345172 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345179 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345223 */     GIR_RootConstrainSelectedInstOperands,
     /* 345224 */     // GIR_Coverage, 13284,
     /* 345224 */     GIR_EraseRootFromParent_Done,
     /* 345225 */   // Label 5621: @345225
     /* 345225 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(345360), // Rule ID 13285 //
     /* 345230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 345233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 345261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 345273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 345277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345314 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 345317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345358 */     GIR_RootConstrainSelectedInstOperands,
     /* 345359 */     // GIR_Coverage, 13285,
     /* 345359 */     GIR_EraseRootFromParent_Done,
     /* 345360 */   // Label 5622: @345360
     /* 345360 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(345495), // Rule ID 12307 //
     /* 345365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 345368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 345408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345412 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345417 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345417 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345449 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 345452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345493 */     GIR_RootConstrainSelectedInstOperands,
     /* 345494 */     // GIR_Coverage, 12307,
     /* 345494 */     GIR_EraseRootFromParent_Done,
     /* 345495 */   // Label 5623: @345495
     /* 345495 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(345630), // Rule ID 12308 //
     /* 345500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 345503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 345543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345552 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345584 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 345587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 345599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 345604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 345609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345628 */     GIR_RootConstrainSelectedInstOperands,
     /* 345629 */     // GIR_Coverage, 12308,
     /* 345629 */     GIR_EraseRootFromParent_Done,
     /* 345630 */   // Label 5624: @345630
     /* 345630 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(345765), // Rule ID 12311 //
     /* 345635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 345638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 345678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345682 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345687 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345692 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345719 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 345722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345763 */     GIR_RootConstrainSelectedInstOperands,
     /* 345764 */     // GIR_Coverage, 12311,
     /* 345764 */     GIR_EraseRootFromParent_Done,
     /* 345765 */   // Label 5625: @345765
     /* 345765 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(345900), // Rule ID 12312 //
     /* 345770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 345773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 345777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 345813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345817 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345822 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345847 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345854 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 345857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 345864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 345869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 345874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 345879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 345884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 345889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345898 */     GIR_RootConstrainSelectedInstOperands,
     /* 345899 */     // GIR_Coverage, 12312,
     /* 345899 */     GIR_EraseRootFromParent_Done,
     /* 345900 */   // Label 5626: @345900
     /* 345900 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(346035), // Rule ID 12787 //
     /* 345905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 345908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 345912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 345924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 345928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 345936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 345940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 345944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 345948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 345952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 345952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 345957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 345957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 345962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 345966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 345968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 345989 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 345989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 345992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 345994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 345999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346033 */     GIR_RootConstrainSelectedInstOperands,
     /* 346034 */     // GIR_Coverage, 12787,
     /* 346034 */     GIR_EraseRootFromParent_Done,
     /* 346035 */   // Label 5627: @346035
     /* 346035 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(346170), // Rule ID 12788 //
     /* 346040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346124 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346168 */     GIR_RootConstrainSelectedInstOperands,
     /* 346169 */     // GIR_Coverage, 12788,
     /* 346169 */     GIR_EraseRootFromParent_Done,
     /* 346170 */   // Label 5628: @346170
     /* 346170 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(346305), // Rule ID 12791 //
     /* 346175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346259 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346303 */     GIR_RootConstrainSelectedInstOperands,
     /* 346304 */     // GIR_Coverage, 12791,
     /* 346304 */     GIR_EraseRootFromParent_Done,
     /* 346305 */   // Label 5629: @346305
     /* 346305 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(346440), // Rule ID 12792 //
     /* 346310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 346313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 346317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346357 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346362 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346362 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346367 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346394 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 346397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346438 */     GIR_RootConstrainSelectedInstOperands,
     /* 346439 */     // GIR_Coverage, 12792,
     /* 346439 */     GIR_EraseRootFromParent_Done,
     /* 346440 */   // Label 5630: @346440
     /* 346440 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(346575), // Rule ID 13267 //
     /* 346445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 346448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346492 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346497 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346502 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346529 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 346532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346573 */     GIR_RootConstrainSelectedInstOperands,
     /* 346574 */     // GIR_Coverage, 13267,
     /* 346574 */     GIR_EraseRootFromParent_Done,
     /* 346575 */   // Label 5631: @346575
     /* 346575 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(346710), // Rule ID 13268 //
     /* 346580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 346583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346632 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346664 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 346667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 346674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 346679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 346684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 346689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346708 */     GIR_RootConstrainSelectedInstOperands,
     /* 346709 */     // GIR_Coverage, 13268,
     /* 346709 */     GIR_EraseRootFromParent_Done,
     /* 346710 */   // Label 5632: @346710
     /* 346710 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(346845), // Rule ID 13271 //
     /* 346715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 346718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346767 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346799 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 346802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346843 */     GIR_RootConstrainSelectedInstOperands,
     /* 346844 */     // GIR_Coverage, 13271,
     /* 346844 */     GIR_EraseRootFromParent_Done,
     /* 346845 */   // Label 5633: @346845
     /* 346845 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(346980), // Rule ID 13272 //
     /* 346850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 346853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 346869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 346873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 346881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 346885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 346889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 346897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 346897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 346902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 346902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 346907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 346911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 346934 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 346934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 346937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 346939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 346944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 346949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 346954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 346959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 346964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 346969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346978 */     GIR_RootConstrainSelectedInstOperands,
     /* 346979 */     // GIR_Coverage, 13272,
     /* 346979 */     GIR_EraseRootFromParent_Done,
     /* 346980 */   // Label 5634: @346980
     /* 346980 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(347115), // Rule ID 12292 //
     /* 346985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 346988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 346992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347069 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 347079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 347084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347113 */     GIR_RootConstrainSelectedInstOperands,
     /* 347114 */     // GIR_Coverage, 12292,
     /* 347114 */     GIR_EraseRootFromParent_Done,
     /* 347115 */   // Label 5635: @347115
     /* 347115 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(347250), // Rule ID 12293 //
     /* 347120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347167 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347172 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347172 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347177 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347204 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 347214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 347219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347248 */     GIR_RootConstrainSelectedInstOperands,
     /* 347249 */     // GIR_Coverage, 12293,
     /* 347249 */     GIR_EraseRootFromParent_Done,
     /* 347250 */   // Label 5636: @347250
     /* 347250 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(347385), // Rule ID 12296 //
     /* 347255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347302 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347307 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347312 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347339 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347383 */     GIR_RootConstrainSelectedInstOperands,
     /* 347384 */     // GIR_Coverage, 12296,
     /* 347384 */     GIR_EraseRootFromParent_Done,
     /* 347385 */   // Label 5637: @347385
     /* 347385 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(347520), // Rule ID 12297 //
     /* 347390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 347393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 347397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347437 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347474 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 347477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347518 */     GIR_RootConstrainSelectedInstOperands,
     /* 347519 */     // GIR_Coverage, 12297,
     /* 347519 */     GIR_EraseRootFromParent_Done,
     /* 347520 */   // Label 5638: @347520
     /* 347520 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(347655), // Rule ID 12772 //
     /* 347525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 347528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 347532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347609 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 347612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 347619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 347624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347653 */     GIR_RootConstrainSelectedInstOperands,
     /* 347654 */     // GIR_Coverage, 12772,
     /* 347654 */     GIR_EraseRootFromParent_Done,
     /* 347655 */   // Label 5639: @347655
     /* 347655 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(347790), // Rule ID 12773 //
     /* 347660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 347663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 347667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347712 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347744 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 347747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 347754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 347759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 347764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 347769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347788 */     GIR_RootConstrainSelectedInstOperands,
     /* 347789 */     // GIR_Coverage, 12773,
     /* 347789 */     GIR_EraseRootFromParent_Done,
     /* 347790 */   // Label 5640: @347790
     /* 347790 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(347925), // Rule ID 12776 //
     /* 347795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 347798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 347802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347847 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347847 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 347879 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 347879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 347882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 347884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 347889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 347894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 347899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 347904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 347909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 347914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347923 */     GIR_RootConstrainSelectedInstOperands,
     /* 347924 */     // GIR_Coverage, 12776,
     /* 347924 */     GIR_EraseRootFromParent_Done,
     /* 347925 */   // Label 5641: @347925
     /* 347925 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(348060), // Rule ID 12777 //
     /* 347930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 347933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 347937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 347949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 347953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 347961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 347965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 347969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 347973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 347977 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 347977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 347982 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 347982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 347987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 347991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348014 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 348034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 348039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348058 */     GIR_RootConstrainSelectedInstOperands,
     /* 348059 */     // GIR_Coverage, 12777,
     /* 348059 */     GIR_EraseRootFromParent_Done,
     /* 348060 */   // Label 5642: @348060
     /* 348060 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(348195), // Rule ID 13252 //
     /* 348065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348104 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 348108 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 348112 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 348117 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348117 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 348122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348149 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 348159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 348164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348193 */     GIR_RootConstrainSelectedInstOperands,
     /* 348194 */     // GIR_Coverage, 13252,
     /* 348194 */     GIR_EraseRootFromParent_Done,
     /* 348195 */   // Label 5643: @348195
     /* 348195 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(348330), // Rule ID 13253 //
     /* 348200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 348243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 348247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 348252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 348257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348284 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 348294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 348299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348328 */     GIR_RootConstrainSelectedInstOperands,
     /* 348329 */     // GIR_Coverage, 13253,
     /* 348329 */     GIR_EraseRootFromParent_Done,
     /* 348330 */   // Label 5644: @348330
     /* 348330 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(348465), // Rule ID 13256 //
     /* 348335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 348378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 348382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 348387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 348392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348419 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 348439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 348444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348463 */     GIR_RootConstrainSelectedInstOperands,
     /* 348464 */     // GIR_Coverage, 13256,
     /* 348464 */     GIR_EraseRootFromParent_Done,
     /* 348465 */   // Label 5645: @348465
     /* 348465 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(348600), // Rule ID 13257 //
     /* 348470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 348513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 348517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 348522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 348527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348554 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 348564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 348569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 348574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 348579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348598 */     GIR_RootConstrainSelectedInstOperands,
     /* 348599 */     // GIR_Coverage, 13257,
     /* 348599 */     GIR_EraseRootFromParent_Done,
     /* 348600 */   // Label 5646: @348600
     /* 348600 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(348735), // Rule ID 7774 //
     /* 348605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 348608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 348648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 348657 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 348662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348689 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 348692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 348699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 348704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348733 */     GIR_RootConstrainSelectedInstOperands,
     /* 348734 */     // GIR_Coverage, 7774,
     /* 348734 */     GIR_EraseRootFromParent_Done,
     /* 348735 */   // Label 5647: @348735
     /* 348735 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(348870), // Rule ID 7806 //
     /* 348740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 348743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 348747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 348783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348787 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 348792 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 348797 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348824 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 348827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 348834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 348839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348868 */     GIR_RootConstrainSelectedInstOperands,
     /* 348869 */     // GIR_Coverage, 7806,
     /* 348869 */     GIR_EraseRootFromParent_Done,
     /* 348870 */   // Label 5648: @348870
     /* 348870 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(349005), // Rule ID 7838 //
     /* 348875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 348878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 348882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 348894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 348898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 348906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 348910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 348914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 348918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 348922 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 348922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 348927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 348927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 348932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 348936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 348959 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 348959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 348962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 348964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 348969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 348974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 348979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 348984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 348989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 348994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349003 */     GIR_RootConstrainSelectedInstOperands,
     /* 349004 */     // GIR_Coverage, 7838,
     /* 349004 */     GIR_EraseRootFromParent_Done,
     /* 349005 */   // Label 5649: @349005
     /* 349005 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(349140), // Rule ID 12306 //
     /* 349010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 349062 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349062 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 349067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349094 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 349104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 349109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 349124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 349129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349138 */     GIR_RootConstrainSelectedInstOperands,
     /* 349139 */     // GIR_Coverage, 12306,
     /* 349139 */     GIR_EraseRootFromParent_Done,
     /* 349140 */   // Label 5650: @349140
     /* 349140 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(349275), // Rule ID 12309 //
     /* 349145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 349197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 349202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349229 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 349249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 349254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 349259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 349264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349273 */     GIR_RootConstrainSelectedInstOperands,
     /* 349274 */     // GIR_Coverage, 12309,
     /* 349274 */     GIR_EraseRootFromParent_Done,
     /* 349275 */   // Label 5651: @349275
     /* 349275 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(349410), // Rule ID 12310 //
     /* 349280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 349283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 349332 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349332 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 349337 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349364 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 349367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 349384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 349389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 349394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 349399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349408 */     GIR_RootConstrainSelectedInstOperands,
     /* 349409 */     // GIR_Coverage, 12310,
     /* 349409 */     GIR_EraseRootFromParent_Done,
     /* 349410 */   // Label 5652: @349410
     /* 349410 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(349545), // Rule ID 12786 //
     /* 349415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349462 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 349467 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 349472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349499 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 349502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 349509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 349514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 349529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 349534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349543 */     GIR_RootConstrainSelectedInstOperands,
     /* 349544 */     // GIR_Coverage, 12786,
     /* 349544 */     GIR_EraseRootFromParent_Done,
     /* 349545 */   // Label 5653: @349545
     /* 349545 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(349680), // Rule ID 12789 //
     /* 349550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349597 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 349602 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 349607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349634 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 349637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 349654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 349659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 349664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 349669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349678 */     GIR_RootConstrainSelectedInstOperands,
     /* 349679 */     // GIR_Coverage, 12789,
     /* 349679 */     GIR_EraseRootFromParent_Done,
     /* 349680 */   // Label 5654: @349680
     /* 349680 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(349815), // Rule ID 12790 //
     /* 349685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 349688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 349692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349732 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 349737 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 349742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349769 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 349772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 349779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 349784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 349789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 349794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 349799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 349804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349813 */     GIR_RootConstrainSelectedInstOperands,
     /* 349814 */     // GIR_Coverage, 12790,
     /* 349814 */     GIR_EraseRootFromParent_Done,
     /* 349815 */   // Label 5655: @349815
     /* 349815 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(349950), // Rule ID 13266 //
     /* 349820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 349823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 349867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 349867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 349872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 349872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 349877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 349881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 349904 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 349904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 349907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 349909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 349914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 349919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 349924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 349929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 349934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 349939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349948 */     GIR_RootConstrainSelectedInstOperands,
     /* 349949 */     // GIR_Coverage, 13266,
     /* 349949 */     GIR_EraseRootFromParent_Done,
     /* 349950 */   // Label 5656: @349950
     /* 349950 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(350085), // Rule ID 13269 //
     /* 349955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 349958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 349962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 349974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 349978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 349986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 349990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 349994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 349998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350007 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350007 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350012 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350039 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 350059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 350064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 350069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 350074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350083 */     GIR_RootConstrainSelectedInstOperands,
     /* 350084 */     // GIR_Coverage, 13269,
     /* 350084 */     GIR_EraseRootFromParent_Done,
     /* 350085 */   // Label 5657: @350085
     /* 350085 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(350220), // Rule ID 13270 //
     /* 350090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 350133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 350137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350142 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350174 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 350194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 350199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 350204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 350209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350218 */     GIR_RootConstrainSelectedInstOperands,
     /* 350219 */     // GIR_Coverage, 13270,
     /* 350219 */     GIR_EraseRootFromParent_Done,
     /* 350220 */   // Label 5658: @350220
     /* 350220 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(350355), // Rule ID 7773 //
     /* 350225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 350268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350277 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350286 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350309 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 350312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 350319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 350324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 350339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 350344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350353 */     GIR_RootConstrainSelectedInstOperands,
     /* 350354 */     // GIR_Coverage, 7773,
     /* 350354 */     GIR_EraseRootFromParent_Done,
     /* 350355 */   // Label 5659: @350355
     /* 350355 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(350490), // Rule ID 7805 //
     /* 350360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 350363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 350367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 350403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350407 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350412 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350444 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 350447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 350454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 350459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 350474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 350479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350488 */     GIR_RootConstrainSelectedInstOperands,
     /* 350489 */     // GIR_Coverage, 7805,
     /* 350489 */     GIR_EraseRootFromParent_Done,
     /* 350490 */   // Label 5660: @350490
     /* 350490 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(350625), // Rule ID 7837 //
     /* 350495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 350498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 350538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350579 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 350582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 350589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 350594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 350609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 350614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350623 */     GIR_RootConstrainSelectedInstOperands,
     /* 350624 */     // GIR_Coverage, 7837,
     /* 350624 */     GIR_EraseRootFromParent_Done,
     /* 350625 */   // Label 5661: @350625
     /* 350625 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(350760), // Rule ID 12291 //
     /* 350630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 350673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350682 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350714 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 350717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 350724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 350729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 350734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 350739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 350744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 350749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350758 */     GIR_RootConstrainSelectedInstOperands,
     /* 350759 */     // GIR_Coverage, 12291,
     /* 350759 */     GIR_EraseRootFromParent_Done,
     /* 350760 */   // Label 5662: @350760
     /* 350760 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(350895), // Rule ID 12294 //
     /* 350765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 350808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350817 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350817 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350822 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350849 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 350852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 350869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 350874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 350879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 350884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350893 */     GIR_RootConstrainSelectedInstOperands,
     /* 350894 */     // GIR_Coverage, 12294,
     /* 350894 */     GIR_EraseRootFromParent_Done,
     /* 350895 */   // Label 5663: @350895
     /* 350895 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(351030), // Rule ID 12295 //
     /* 350900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 350903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 350907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 350919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 350923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 350931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 350935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 350939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 350943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 350947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 350947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 350952 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 350952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 350957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 350961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 350984 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 350984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 350987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 350989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 350994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 350999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 351004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 351009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 351014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 351019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351028 */     GIR_RootConstrainSelectedInstOperands,
     /* 351029 */     // GIR_Coverage, 12295,
     /* 351029 */     GIR_EraseRootFromParent_Done,
     /* 351030 */   // Label 5664: @351030
     /* 351030 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(351165), // Rule ID 12771 //
     /* 351035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 351078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351082 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 351087 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 351092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351119 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 351129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 351134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 351149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 351154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351163 */     GIR_RootConstrainSelectedInstOperands,
     /* 351164 */     // GIR_Coverage, 12771,
     /* 351164 */     GIR_EraseRootFromParent_Done,
     /* 351165 */   // Label 5665: @351165
     /* 351165 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(351300), // Rule ID 12774 //
     /* 351170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 351213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351217 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 351222 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 351227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351254 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 351274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 351279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 351284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 351289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351298 */     GIR_RootConstrainSelectedInstOperands,
     /* 351299 */     // GIR_Coverage, 12774,
     /* 351299 */     GIR_EraseRootFromParent_Done,
     /* 351300 */   // Label 5666: @351300
     /* 351300 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(351435), // Rule ID 12775 //
     /* 351305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 351308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 351312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 351348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351352 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 351357 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351357 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 351362 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351389 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 351392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 351409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 351414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 351419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 351424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351433 */     GIR_RootConstrainSelectedInstOperands,
     /* 351434 */     // GIR_Coverage, 12775,
     /* 351434 */     GIR_EraseRootFromParent_Done,
     /* 351435 */   // Label 5667: @351435
     /* 351435 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(351570), // Rule ID 13251 //
     /* 351440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 351443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 351483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 351492 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 351497 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351524 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 351527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 351534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 351539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 351544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 351549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 351554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 351559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351568 */     GIR_RootConstrainSelectedInstOperands,
     /* 351569 */     // GIR_Coverage, 13251,
     /* 351569 */     GIR_EraseRootFromParent_Done,
     /* 351570 */   // Label 5668: @351570
     /* 351570 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(351705), // Rule ID 13254 //
     /* 351575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 351578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 351618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 351627 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351627 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 351632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351659 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 351662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 351679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 351684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 351689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 351694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351703 */     GIR_RootConstrainSelectedInstOperands,
     /* 351704 */     // GIR_Coverage, 13254,
     /* 351704 */     GIR_EraseRootFromParent_Done,
     /* 351705 */   // Label 5669: @351705
     /* 351705 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(351840), // Rule ID 13255 //
     /* 351710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 351713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 351753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 351757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 351762 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351762 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 351767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351794 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 351797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 351814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 351819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 351824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 351829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351838 */     GIR_RootConstrainSelectedInstOperands,
     /* 351839 */     // GIR_Coverage, 13255,
     /* 351839 */     GIR_EraseRootFromParent_Done,
     /* 351840 */   // Label 5670: @351840
     /* 351840 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(351975), // Rule ID 12377 //
     /* 351845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 351848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 351868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 351876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 351880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 351884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 351888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 351892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 351892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 351897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 351897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 351902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 351906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 351929 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 351929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 351932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 351934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 351939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 351944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 351949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 351954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 351959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 351964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351973 */     GIR_RootConstrainSelectedInstOperands,
     /* 351974 */     // GIR_Coverage, 12377,
     /* 351974 */     GIR_EraseRootFromParent_Done,
     /* 351975 */   // Label 5671: @351975
     /* 351975 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(352110), // Rule ID 12378 //
     /* 351980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 351983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 351987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 351995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 351999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352064 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352108 */     GIR_RootConstrainSelectedInstOperands,
     /* 352109 */     // GIR_Coverage, 12378,
     /* 352109 */     GIR_EraseRootFromParent_Done,
     /* 352110 */   // Label 5672: @352110
     /* 352110 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(352245), // Rule ID 12379 //
     /* 352115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352167 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352199 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352243 */     GIR_RootConstrainSelectedInstOperands,
     /* 352244 */     // GIR_Coverage, 12379,
     /* 352244 */     GIR_EraseRootFromParent_Done,
     /* 352245 */   // Label 5673: @352245
     /* 352245 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(352380), // Rule ID 12380 //
     /* 352250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 352253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352302 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352302 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352307 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352334 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 352337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352378 */     GIR_RootConstrainSelectedInstOperands,
     /* 352379 */     // GIR_Coverage, 12380,
     /* 352379 */     GIR_EraseRootFromParent_Done,
     /* 352380 */   // Label 5674: @352380
     /* 352380 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(352515), // Rule ID 12857 //
     /* 352385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 352388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 352392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352432 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352437 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352442 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352469 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 352472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352513 */     GIR_RootConstrainSelectedInstOperands,
     /* 352514 */     // GIR_Coverage, 12857,
     /* 352514 */     GIR_EraseRootFromParent_Done,
     /* 352515 */   // Label 5675: @352515
     /* 352515 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(352650), // Rule ID 12858 //
     /* 352520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 352523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 352527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352604 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 352607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 352614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 352619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 352624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 352629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352648 */     GIR_RootConstrainSelectedInstOperands,
     /* 352649 */     // GIR_Coverage, 12858,
     /* 352649 */     GIR_EraseRootFromParent_Done,
     /* 352650 */   // Label 5676: @352650
     /* 352650 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(352785), // Rule ID 12859 //
     /* 352655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 352658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 352662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352739 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 352742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352783 */     GIR_RootConstrainSelectedInstOperands,
     /* 352784 */     // GIR_Coverage, 12859,
     /* 352784 */     GIR_EraseRootFromParent_Done,
     /* 352785 */   // Label 5677: @352785
     /* 352785 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(352920), // Rule ID 12860 //
     /* 352790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 352793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 352797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352874 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 352874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 352877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 352879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 352884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 352889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 352894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 352899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 352904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 352909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352918 */     GIR_RootConstrainSelectedInstOperands,
     /* 352919 */     // GIR_Coverage, 12860,
     /* 352919 */     GIR_EraseRootFromParent_Done,
     /* 352920 */   // Label 5678: @352920
     /* 352920 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(353055), // Rule ID 13337 //
     /* 352925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 352928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 352932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 352940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 352944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 352948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 352956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 352960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 352964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 352968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 352972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 352972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 352977 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 352977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 352982 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 352986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 352995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353009 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353053 */     GIR_RootConstrainSelectedInstOperands,
     /* 353054 */     // GIR_Coverage, 13337,
     /* 353054 */     GIR_EraseRootFromParent_Done,
     /* 353055 */   // Label 5679: @353055
     /* 353055 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(353190), // Rule ID 13338 //
     /* 353060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 353107 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353112 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353130 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353144 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353188 */     GIR_RootConstrainSelectedInstOperands,
     /* 353189 */     // GIR_Coverage, 13338,
     /* 353189 */     GIR_EraseRootFromParent_Done,
     /* 353190 */   // Label 5680: @353190
     /* 353190 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(353325), // Rule ID 13339 //
     /* 353195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 353242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353279 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353323 */     GIR_RootConstrainSelectedInstOperands,
     /* 353324 */     // GIR_Coverage, 13339,
     /* 353324 */     GIR_EraseRootFromParent_Done,
     /* 353325 */   // Label 5681: @353325
     /* 353325 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(353460), // Rule ID 13340 //
     /* 353330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 353333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 353377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353414 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 353417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353458 */     GIR_RootConstrainSelectedInstOperands,
     /* 353459 */     // GIR_Coverage, 13340,
     /* 353459 */     GIR_EraseRootFromParent_Done,
     /* 353460 */   // Label 5682: @353460
     /* 353460 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(353595), // Rule ID 12317 //
     /* 353465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 353468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353549 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 353552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353593 */     GIR_RootConstrainSelectedInstOperands,
     /* 353594 */     // GIR_Coverage, 12317,
     /* 353594 */     GIR_EraseRootFromParent_Done,
     /* 353595 */   // Label 5683: @353595
     /* 353595 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(353730), // Rule ID 12318 //
     /* 353600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 353603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353684 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 353687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 353694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 353699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 353704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 353709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353728 */     GIR_RootConstrainSelectedInstOperands,
     /* 353729 */     // GIR_Coverage, 12318,
     /* 353729 */     GIR_EraseRootFromParent_Done,
     /* 353730 */   // Label 5684: @353730
     /* 353730 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(353865), // Rule ID 12319 //
     /* 353735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 353738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353787 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353787 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353819 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 353822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353863 */     GIR_RootConstrainSelectedInstOperands,
     /* 353864 */     // GIR_Coverage, 12319,
     /* 353864 */     GIR_EraseRootFromParent_Done,
     /* 353865 */   // Label 5685: @353865
     /* 353865 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(354000), // Rule ID 12320 //
     /* 353870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 353873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 353877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 353889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 353893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 353901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 353905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 353909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 353913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 353917 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 353917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 353922 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 353922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 353927 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 353931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 353954 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 353954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 353957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 353959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 353964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 353969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 353974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 353979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 353984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 353989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353998 */     GIR_RootConstrainSelectedInstOperands,
     /* 353999 */     // GIR_Coverage, 12320,
     /* 353999 */     GIR_EraseRootFromParent_Done,
     /* 354000 */   // Label 5686: @354000
     /* 354000 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(354135), // Rule ID 12797 //
     /* 354005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354057 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354089 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 354109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 354114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354133 */     GIR_RootConstrainSelectedInstOperands,
     /* 354134 */     // GIR_Coverage, 12797,
     /* 354134 */     GIR_EraseRootFromParent_Done,
     /* 354135 */   // Label 5687: @354135
     /* 354135 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(354270), // Rule ID 12798 //
     /* 354140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354224 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 354244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 354249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354268 */     GIR_RootConstrainSelectedInstOperands,
     /* 354269 */     // GIR_Coverage, 12798,
     /* 354269 */     GIR_EraseRootFromParent_Done,
     /* 354270 */   // Label 5688: @354270
     /* 354270 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(354405), // Rule ID 12799 //
     /* 354275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354359 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 354369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 354374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354403 */     GIR_RootConstrainSelectedInstOperands,
     /* 354404 */     // GIR_Coverage, 12799,
     /* 354404 */     GIR_EraseRootFromParent_Done,
     /* 354405 */   // Label 5689: @354405
     /* 354405 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(354540), // Rule ID 12800 //
     /* 354410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 354413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 354417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354462 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354462 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354467 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354494 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 354497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 354504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 354509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354538 */     GIR_RootConstrainSelectedInstOperands,
     /* 354539 */     // GIR_Coverage, 12800,
     /* 354539 */     GIR_EraseRootFromParent_Done,
     /* 354540 */   // Label 5690: @354540
     /* 354540 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(354675), // Rule ID 13277 //
     /* 354545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 354548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354592 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354597 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354629 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 354632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 354649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 354654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354673 */     GIR_RootConstrainSelectedInstOperands,
     /* 354674 */     // GIR_Coverage, 13277,
     /* 354674 */     GIR_EraseRootFromParent_Done,
     /* 354675 */   // Label 5691: @354675
     /* 354675 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(354810), // Rule ID 13278 //
     /* 354680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 354683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354764 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 354767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 354774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 354779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 354784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 354789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354808 */     GIR_RootConstrainSelectedInstOperands,
     /* 354809 */     // GIR_Coverage, 13278,
     /* 354809 */     GIR_EraseRootFromParent_Done,
     /* 354810 */   // Label 5692: @354810
     /* 354810 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(354945), // Rule ID 13279 //
     /* 354815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 354818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 354862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 354867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 354872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 354876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 354899 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 354899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 354902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 354904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 354909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 354914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 354919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 354924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 354929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 354934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354943 */     GIR_RootConstrainSelectedInstOperands,
     /* 354944 */     // GIR_Coverage, 13279,
     /* 354944 */     GIR_EraseRootFromParent_Done,
     /* 354945 */   // Label 5693: @354945
     /* 354945 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(355080), // Rule ID 13280 //
     /* 354950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 354953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 354957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 354969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 354973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 354981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 354985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 354989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 354993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 354997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 354997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355002 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355034 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 355037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 355044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 355049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 355064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 355069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355078 */     GIR_RootConstrainSelectedInstOperands,
     /* 355079 */     // GIR_Coverage, 13280,
     /* 355079 */     GIR_EraseRootFromParent_Done,
     /* 355080 */   // Label 5694: @355080
     /* 355080 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(355215), // Rule ID 12362 //
     /* 355085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 355116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355137 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355169 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 355189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 355194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 355199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 355204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355213 */     GIR_RootConstrainSelectedInstOperands,
     /* 355214 */     // GIR_Coverage, 12362,
     /* 355214 */     GIR_EraseRootFromParent_Done,
     /* 355215 */   // Label 5695: @355215
     /* 355215 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(355350), // Rule ID 12363 //
     /* 355220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 355251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355272 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355272 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355277 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355304 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 355324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 355329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 355334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 355339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355348 */     GIR_RootConstrainSelectedInstOperands,
     /* 355349 */     // GIR_Coverage, 12363,
     /* 355349 */     GIR_EraseRootFromParent_Done,
     /* 355350 */   // Label 5696: @355350
     /* 355350 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(355485), // Rule ID 12364 //
     /* 355355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 355386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355407 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355412 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355439 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 355449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 355454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 355469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 355474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355483 */     GIR_RootConstrainSelectedInstOperands,
     /* 355484 */     // GIR_Coverage, 12364,
     /* 355484 */     GIR_EraseRootFromParent_Done,
     /* 355485 */   // Label 5697: @355485
     /* 355485 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(355620), // Rule ID 12365 //
     /* 355490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 355493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 355497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 355521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355574 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 355577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 355584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 355589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 355599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 355604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 355609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355618 */     GIR_RootConstrainSelectedInstOperands,
     /* 355619 */     // GIR_Coverage, 12365,
     /* 355619 */     GIR_EraseRootFromParent_Done,
     /* 355620 */   // Label 5698: @355620
     /* 355620 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(355755), // Rule ID 12842 //
     /* 355625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 355628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 355632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 355656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355709 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 355712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 355729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 355734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 355739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 355744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355753 */     GIR_RootConstrainSelectedInstOperands,
     /* 355754 */     // GIR_Coverage, 12842,
     /* 355754 */     GIR_EraseRootFromParent_Done,
     /* 355755 */   // Label 5699: @355755
     /* 355755 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(355890), // Rule ID 12843 //
     /* 355760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 355763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 355767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 355791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355844 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 355847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 355854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 355859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 355864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 355869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 355874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 355879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355888 */     GIR_RootConstrainSelectedInstOperands,
     /* 355889 */     // GIR_Coverage, 12843,
     /* 355889 */     GIR_EraseRootFromParent_Done,
     /* 355890 */   // Label 5700: @355890
     /* 355890 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(356025), // Rule ID 12844 //
     /* 355895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 355898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 355902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 355910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 355914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 355918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 355926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 355930 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 355934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 355938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 355942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 355942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 355947 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 355947 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 355952 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 355956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 355979 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 355979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 355982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 355984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 355989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 355994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 355999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356023 */     GIR_RootConstrainSelectedInstOperands,
     /* 356024 */     // GIR_Coverage, 12844,
     /* 356024 */     GIR_EraseRootFromParent_Done,
     /* 356025 */   // Label 5701: @356025
     /* 356025 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(356160), // Rule ID 12845 //
     /* 356030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 356033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 356037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 356061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 356077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356082 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356114 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 356117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 356124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 356129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356158 */     GIR_RootConstrainSelectedInstOperands,
     /* 356159 */     // GIR_Coverage, 12845,
     /* 356159 */     GIR_EraseRootFromParent_Done,
     /* 356160 */   // Label 5702: @356160
     /* 356160 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(356295), // Rule ID 13322 //
     /* 356165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 356196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 356212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356249 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 356269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 356274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356293 */     GIR_RootConstrainSelectedInstOperands,
     /* 356294 */     // GIR_Coverage, 13322,
     /* 356294 */     GIR_EraseRootFromParent_Done,
     /* 356295 */   // Label 5703: @356295
     /* 356295 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(356430), // Rule ID 13323 //
     /* 356300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 356331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 356347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356384 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 356404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 356409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356428 */     GIR_RootConstrainSelectedInstOperands,
     /* 356429 */     // GIR_Coverage, 13323,
     /* 356429 */     GIR_EraseRootFromParent_Done,
     /* 356430 */   // Label 5704: @356430
     /* 356430 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(356565), // Rule ID 13324 //
     /* 356435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 356466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 356482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356519 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 356529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 356534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356563 */     GIR_RootConstrainSelectedInstOperands,
     /* 356564 */     // GIR_Coverage, 13324,
     /* 356564 */     GIR_EraseRootFromParent_Done,
     /* 356565 */   // Label 5705: @356565
     /* 356565 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(356700), // Rule ID 13325 //
     /* 356570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 356573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 356601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 356617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356622 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356654 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 356657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 356664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 356669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 356674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 356679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356698 */     GIR_RootConstrainSelectedInstOperands,
     /* 356699 */     // GIR_Coverage, 13325,
     /* 356699 */     GIR_EraseRootFromParent_Done,
     /* 356700 */   // Label 5706: @356700
     /* 356700 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(356835), // Rule ID 12302 //
     /* 356705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 356708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 356736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356757 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356757 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356762 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356789 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 356792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 356809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 356814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356833 */     GIR_RootConstrainSelectedInstOperands,
     /* 356834 */     // GIR_Coverage, 12302,
     /* 356834 */     GIR_EraseRootFromParent_Done,
     /* 356835 */   // Label 5707: @356835
     /* 356835 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(356970), // Rule ID 12303 //
     /* 356840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 356843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 356871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 356875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 356879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 356883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 356887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 356892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 356892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 356897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 356901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 356924 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 356924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 356927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 356929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 356934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 356939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 356944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 356949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 356954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 356959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356968 */     GIR_RootConstrainSelectedInstOperands,
     /* 356969 */     // GIR_Coverage, 12303,
     /* 356969 */     GIR_EraseRootFromParent_Done,
     /* 356970 */   // Label 5708: @356970
     /* 356970 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(357105), // Rule ID 12304 //
     /* 356975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 356978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 356982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 356990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 356994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 356998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357059 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 357069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 357074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 357089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 357094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357103 */     GIR_RootConstrainSelectedInstOperands,
     /* 357104 */     // GIR_Coverage, 12304,
     /* 357104 */     GIR_EraseRootFromParent_Done,
     /* 357105 */   // Label 5709: @357105
     /* 357105 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(357240), // Rule ID 12305 //
     /* 357110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 357113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357194 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 357197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 357204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 357209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 357224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 357229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357238 */     GIR_RootConstrainSelectedInstOperands,
     /* 357239 */     // GIR_Coverage, 12305,
     /* 357239 */     GIR_EraseRootFromParent_Done,
     /* 357240 */   // Label 5710: @357240
     /* 357240 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(357375), // Rule ID 12782 //
     /* 357245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357329 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 357332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 357349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 357354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 357359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 357364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357373 */     GIR_RootConstrainSelectedInstOperands,
     /* 357374 */     // GIR_Coverage, 12782,
     /* 357374 */     GIR_EraseRootFromParent_Done,
     /* 357375 */   // Label 5711: @357375
     /* 357375 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(357510), // Rule ID 12783 //
     /* 357380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357432 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357432 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357464 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 357467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 357484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 357489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 357494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 357499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357508 */     GIR_RootConstrainSelectedInstOperands,
     /* 357509 */     // GIR_Coverage, 12783,
     /* 357509 */     GIR_EraseRootFromParent_Done,
     /* 357510 */   // Label 5712: @357510
     /* 357510 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(357645), // Rule ID 12784 //
     /* 357515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357567 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357599 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 357602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 357609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 357614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 357629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 357634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357643 */     GIR_RootConstrainSelectedInstOperands,
     /* 357644 */     // GIR_Coverage, 12784,
     /* 357644 */     GIR_EraseRootFromParent_Done,
     /* 357645 */   // Label 5713: @357645
     /* 357645 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(357780), // Rule ID 12785 //
     /* 357650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 357653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 357657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357734 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 357737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 357744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 357749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 357754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 357759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 357764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 357769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357778 */     GIR_RootConstrainSelectedInstOperands,
     /* 357779 */     // GIR_Coverage, 12785,
     /* 357779 */     GIR_EraseRootFromParent_Done,
     /* 357780 */   // Label 5714: @357780
     /* 357780 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(357915), // Rule ID 13262 //
     /* 357785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 357788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357869 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 357869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 357872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 357874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 357879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 357884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 357889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 357894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 357899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 357904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357913 */     GIR_RootConstrainSelectedInstOperands,
     /* 357914 */     // GIR_Coverage, 13262,
     /* 357914 */     GIR_EraseRootFromParent_Done,
     /* 357915 */   // Label 5715: @357915
     /* 357915 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(358050), // Rule ID 13263 //
     /* 357920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 357923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 357927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 357939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 357943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 357947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 357951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 357955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 357959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 357963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 357967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 357967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 357972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 357972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 357977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 357981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 357983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 357997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358004 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 358024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 358029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 358034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 358039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358048 */     GIR_RootConstrainSelectedInstOperands,
     /* 358049 */     // GIR_Coverage, 13263,
     /* 358049 */     GIR_EraseRootFromParent_Done,
     /* 358050 */   // Label 5716: @358050
     /* 358050 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(358185), // Rule ID 13264 //
     /* 358055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358107 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358112 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358139 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 358149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 358154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 358169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 358174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358183 */     GIR_RootConstrainSelectedInstOperands,
     /* 358184 */     // GIR_Coverage, 13264,
     /* 358184 */     GIR_EraseRootFromParent_Done,
     /* 358185 */   // Label 5717: @358185
     /* 358185 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(358320), // Rule ID 13265 //
     /* 358190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 358193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 358217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 358221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358242 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358247 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358274 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 358277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 358284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 358289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 358304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 358309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358318 */     GIR_RootConstrainSelectedInstOperands,
     /* 358319 */     // GIR_Coverage, 13265,
     /* 358319 */     GIR_EraseRootFromParent_Done,
     /* 358320 */   // Label 5718: @358320
     /* 358320 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(358455), // Rule ID 12373 //
     /* 358325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 358328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 358356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358409 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 358412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358453 */     GIR_RootConstrainSelectedInstOperands,
     /* 358454 */     // GIR_Coverage, 12373,
     /* 358454 */     GIR_EraseRootFromParent_Done,
     /* 358455 */   // Label 5719: @358455
     /* 358455 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(358590), // Rule ID 12374 //
     /* 358460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 358463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 358491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358544 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 358547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358588 */     GIR_RootConstrainSelectedInstOperands,
     /* 358589 */     // GIR_Coverage, 12374,
     /* 358589 */     GIR_EraseRootFromParent_Done,
     /* 358590 */   // Label 5720: @358590
     /* 358590 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(358725), // Rule ID 12375 //
     /* 358595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 358598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 358626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358679 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 358682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358723 */     GIR_RootConstrainSelectedInstOperands,
     /* 358724 */     // GIR_Coverage, 12375,
     /* 358724 */     GIR_EraseRootFromParent_Done,
     /* 358725 */   // Label 5721: @358725
     /* 358725 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(358860), // Rule ID 12376 //
     /* 358730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 358733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 358737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 358761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358782 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358782 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358814 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 358817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 358824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 358829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 358834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 358839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358858 */     GIR_RootConstrainSelectedInstOperands,
     /* 358859 */     // GIR_Coverage, 12376,
     /* 358859 */     GIR_EraseRootFromParent_Done,
     /* 358860 */   // Label 5722: @358860
     /* 358860 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(358995), // Rule ID 12853 //
     /* 358865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 358868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 358872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 358880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 358884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 358888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 358892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 358896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 358900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 358904 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 358908 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 358912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 358912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 358917 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 358917 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 358922 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 358926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 358949 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 358949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 358952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 358954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 358959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 358964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 358969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 358974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 358979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 358984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358993 */     GIR_RootConstrainSelectedInstOperands,
     /* 358994 */     // GIR_Coverage, 12853,
     /* 358994 */     GIR_EraseRootFromParent_Done,
     /* 358995 */   // Label 5723: @358995
     /* 358995 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(359130), // Rule ID 12854 //
     /* 359000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 359047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359052 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359084 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359128 */     GIR_RootConstrainSelectedInstOperands,
     /* 359129 */     // GIR_Coverage, 12854,
     /* 359129 */     GIR_EraseRootFromParent_Done,
     /* 359130 */   // Label 5724: @359130
     /* 359130 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(359265), // Rule ID 12855 //
     /* 359135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 359182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359219 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359263 */     GIR_RootConstrainSelectedInstOperands,
     /* 359264 */     // GIR_Coverage, 12855,
     /* 359264 */     GIR_EraseRootFromParent_Done,
     /* 359265 */   // Label 5725: @359265
     /* 359265 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(359400), // Rule ID 12856 //
     /* 359270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 359273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 359277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 359317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359354 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 359357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359398 */     GIR_RootConstrainSelectedInstOperands,
     /* 359399 */     // GIR_Coverage, 12856,
     /* 359399 */     GIR_EraseRootFromParent_Done,
     /* 359400 */   // Label 5726: @359400
     /* 359400 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(359535), // Rule ID 13333 //
     /* 359405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 359408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 359452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359489 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 359492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359533 */     GIR_RootConstrainSelectedInstOperands,
     /* 359534 */     // GIR_Coverage, 13333,
     /* 359534 */     GIR_EraseRootFromParent_Done,
     /* 359535 */   // Label 5727: @359535
     /* 359535 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(359670), // Rule ID 13334 //
     /* 359540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 359543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 359587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359592 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359592 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359624 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 359627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 359634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 359639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 359644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 359649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359668 */     GIR_RootConstrainSelectedInstOperands,
     /* 359669 */     // GIR_Coverage, 13334,
     /* 359669 */     GIR_EraseRootFromParent_Done,
     /* 359670 */   // Label 5728: @359670
     /* 359670 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(359805), // Rule ID 13335 //
     /* 359675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 359678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 359722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359727 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359759 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 359762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359803 */     GIR_RootConstrainSelectedInstOperands,
     /* 359804 */     // GIR_Coverage, 13335,
     /* 359804 */     GIR_EraseRootFromParent_Done,
     /* 359805 */   // Label 5729: @359805
     /* 359805 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(359940), // Rule ID 13336 //
     /* 359810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 359813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 359857 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 359867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 359871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 359894 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 359894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 359897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 359899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 359904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 359909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 359914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 359919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 359924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 359929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359938 */     GIR_RootConstrainSelectedInstOperands,
     /* 359939 */     // GIR_Coverage, 13336,
     /* 359939 */     GIR_EraseRootFromParent_Done,
     /* 359940 */   // Label 5730: @359940
     /* 359940 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(360075), // Rule ID 12313 //
     /* 359945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 359948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 359952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 359964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 359968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 359976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 359980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 359984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 359988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 359992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 359992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 359997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 359997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360029 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 360032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360073 */     GIR_RootConstrainSelectedInstOperands,
     /* 360074 */     // GIR_Coverage, 12313,
     /* 360074 */     GIR_EraseRootFromParent_Done,
     /* 360075 */   // Label 5731: @360075
     /* 360075 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(360210), // Rule ID 12314 //
     /* 360080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 360083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 360111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360164 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 360167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360208 */     GIR_RootConstrainSelectedInstOperands,
     /* 360209 */     // GIR_Coverage, 12314,
     /* 360209 */     GIR_EraseRootFromParent_Done,
     /* 360210 */   // Label 5732: @360210
     /* 360210 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(360345), // Rule ID 12315 //
     /* 360215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 360218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 360246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360267 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360299 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 360302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360343 */     GIR_RootConstrainSelectedInstOperands,
     /* 360344 */     // GIR_Coverage, 12315,
     /* 360344 */     GIR_EraseRootFromParent_Done,
     /* 360345 */   // Label 5733: @360345
     /* 360345 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(360480), // Rule ID 12316 //
     /* 360350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 360353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 360357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 360381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360397 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360397 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360402 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360402 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360407 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360434 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 360437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360478 */     GIR_RootConstrainSelectedInstOperands,
     /* 360479 */     // GIR_Coverage, 12316,
     /* 360479 */     GIR_EraseRootFromParent_Done,
     /* 360480 */   // Label 5734: @360480
     /* 360480 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(360615), // Rule ID 12793 //
     /* 360485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 360488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 360516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360532 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360569 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 360572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360613 */     GIR_RootConstrainSelectedInstOperands,
     /* 360614 */     // GIR_Coverage, 12793,
     /* 360614 */     GIR_EraseRootFromParent_Done,
     /* 360615 */   // Label 5735: @360615
     /* 360615 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(360750), // Rule ID 12794 //
     /* 360620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 360623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 360651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360704 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 360707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 360714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 360719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 360724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 360729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360748 */     GIR_RootConstrainSelectedInstOperands,
     /* 360749 */     // GIR_Coverage, 12794,
     /* 360749 */     GIR_EraseRootFromParent_Done,
     /* 360750 */   // Label 5736: @360750
     /* 360750 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(360885), // Rule ID 12795 //
     /* 360755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 360758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 360786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360839 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 360842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 360869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 360874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360883 */     GIR_RootConstrainSelectedInstOperands,
     /* 360884 */     // GIR_Coverage, 12795,
     /* 360884 */     GIR_EraseRootFromParent_Done,
     /* 360885 */   // Label 5737: @360885
     /* 360885 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(361020), // Rule ID 12796 //
     /* 360890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 360893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 360897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 360909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 360913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 360921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 360925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 360929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 360933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 360937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 360937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 360942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 360942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 360947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 360951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 360974 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 360974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 360977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 360979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 360984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 360989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 360994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 360999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361018 */     GIR_RootConstrainSelectedInstOperands,
     /* 361019 */     // GIR_Coverage, 12796,
     /* 361019 */     GIR_EraseRootFromParent_Done,
     /* 361020 */   // Label 5738: @361020
     /* 361020 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(361155), // Rule ID 13273 //
     /* 361025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 361028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 361056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361072 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 361072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 361077 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 361077 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 361082 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 361086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361102 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361109 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 361112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361153 */     GIR_RootConstrainSelectedInstOperands,
     /* 361154 */     // GIR_Coverage, 13273,
     /* 361154 */     GIR_EraseRootFromParent_Done,
     /* 361155 */   // Label 5739: @361155
     /* 361155 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(361290), // Rule ID 13274 //
     /* 361160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 361163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 361191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361207 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 361207 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 361212 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 361212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 361217 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 361221 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361244 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 361247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361288 */     GIR_RootConstrainSelectedInstOperands,
     /* 361289 */     // GIR_Coverage, 13274,
     /* 361289 */     GIR_EraseRootFromParent_Done,
     /* 361290 */   // Label 5740: @361290
     /* 361290 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(361425), // Rule ID 13275 //
     /* 361295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 361298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 361326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361342 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 361342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 361347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 361347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 361352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 361356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361379 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 361382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 361399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 361404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361423 */     GIR_RootConstrainSelectedInstOperands,
     /* 361424 */     // GIR_Coverage, 13275,
     /* 361424 */     GIR_EraseRootFromParent_Done,
     /* 361425 */   // Label 5741: @361425
     /* 361425 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(361560), // Rule ID 13276 //
     /* 361430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 361433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 361461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361477 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 361477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 361482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 361482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 361487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 361491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361514 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 361517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 361534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 361539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361558 */     GIR_RootConstrainSelectedInstOperands,
     /* 361559 */     // GIR_Coverage, 13276,
     /* 361559 */     GIR_EraseRootFromParent_Done,
     /* 361560 */   // Label 5742: @361560
     /* 361560 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(361695), // Rule ID 12358 //
     /* 361565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 361568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 361596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 361612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 361617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 361617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 361622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 361626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361649 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 361652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361693 */     GIR_RootConstrainSelectedInstOperands,
     /* 361694 */     // GIR_Coverage, 12358,
     /* 361694 */     GIR_EraseRootFromParent_Done,
     /* 361695 */   // Label 5743: @361695
     /* 361695 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(361830), // Rule ID 12359 //
     /* 361700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 361703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 361731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 361747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 361752 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 361752 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 361757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 361761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361784 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 361787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 361794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 361799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 361804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 361809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361828 */     GIR_RootConstrainSelectedInstOperands,
     /* 361829 */     // GIR_Coverage, 12359,
     /* 361829 */     GIR_EraseRootFromParent_Done,
     /* 361830 */   // Label 5744: @361830
     /* 361830 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(361965), // Rule ID 12360 //
     /* 361835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 361838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 361866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 361870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 361874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 361878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 361882 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 361882 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 361887 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 361887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 361892 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 361896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 361919 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 361919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 361922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 361924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 361929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 361934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 361939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 361944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 361949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 361954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361963 */     GIR_RootConstrainSelectedInstOperands,
     /* 361964 */     // GIR_Coverage, 12360,
     /* 361964 */     GIR_EraseRootFromParent_Done,
     /* 361965 */   // Label 5745: @361965
     /* 361965 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(362100), // Rule ID 12361 //
     /* 361970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 361973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 361977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 361985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 361989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 361993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362017 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362054 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 362057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 362064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 362074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362098 */     GIR_RootConstrainSelectedInstOperands,
     /* 362099 */     // GIR_Coverage, 12361,
     /* 362099 */     GIR_EraseRootFromParent_Done,
     /* 362100 */   // Label 5746: @362100
     /* 362100 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(362235), // Rule ID 12838 //
     /* 362105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 362108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362189 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 362192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362233 */     GIR_RootConstrainSelectedInstOperands,
     /* 362234 */     // GIR_Coverage, 12838,
     /* 362234 */     GIR_EraseRootFromParent_Done,
     /* 362235 */   // Label 5747: @362235
     /* 362235 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(362370), // Rule ID 12839 //
     /* 362240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 362243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362324 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 362327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362368 */     GIR_RootConstrainSelectedInstOperands,
     /* 362369 */     // GIR_Coverage, 12839,
     /* 362369 */     GIR_EraseRootFromParent_Done,
     /* 362370 */   // Label 5748: @362370
     /* 362370 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(362505), // Rule ID 12840 //
     /* 362375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 362378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362422 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362422 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362427 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362427 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362436 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362459 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 362462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 362469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 362479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362503 */     GIR_RootConstrainSelectedInstOperands,
     /* 362504 */     // GIR_Coverage, 12840,
     /* 362504 */     GIR_EraseRootFromParent_Done,
     /* 362505 */   // Label 5749: @362505
     /* 362505 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(362640), // Rule ID 12841 //
     /* 362510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 362513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 362517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362557 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362562 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362587 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362594 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 362597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 362604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 362609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 362614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 362619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362638 */     GIR_RootConstrainSelectedInstOperands,
     /* 362639 */     // GIR_Coverage, 12841,
     /* 362639 */     GIR_EraseRootFromParent_Done,
     /* 362640 */   // Label 5750: @362640
     /* 362640 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(362775), // Rule ID 13318 //
     /* 362645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 362648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362692 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362697 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362702 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362722 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362729 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 362732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362773 */     GIR_RootConstrainSelectedInstOperands,
     /* 362774 */     // GIR_Coverage, 13318,
     /* 362774 */     GIR_EraseRootFromParent_Done,
     /* 362775 */   // Label 5751: @362775
     /* 362775 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(362910), // Rule ID 13319 //
     /* 362780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 362783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362864 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 362867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 362869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 362874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 362879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 362884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 362889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 362894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 362899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362908 */     GIR_RootConstrainSelectedInstOperands,
     /* 362909 */     // GIR_Coverage, 13319,
     /* 362909 */     GIR_EraseRootFromParent_Done,
     /* 362910 */   // Label 5752: @362910
     /* 362910 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(363045), // Rule ID 13320 //
     /* 362915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 362918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 362922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 362930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 362934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 362938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 362946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 362950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 362954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 362958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 362962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 362962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 362967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 362967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 362972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 362976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 362999 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 362999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 363002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363043 */     GIR_RootConstrainSelectedInstOperands,
     /* 363044 */     // GIR_Coverage, 13320,
     /* 363044 */     GIR_EraseRootFromParent_Done,
     /* 363045 */   // Label 5753: @363045
     /* 363045 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(363180), // Rule ID 13321 //
     /* 363050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 363053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 363069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 363073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 363085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 363089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 363097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 363102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 363107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363134 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 363137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363178 */     GIR_RootConstrainSelectedInstOperands,
     /* 363179 */     // GIR_Coverage, 13321,
     /* 363179 */     GIR_EraseRootFromParent_Done,
     /* 363180 */   // Label 5754: @363180
     /* 363180 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(363315), // Rule ID 12298 //
     /* 363185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 363188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 363204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 363208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 363220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 363224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 363237 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 363242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363262 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363269 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 363272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363313 */     GIR_RootConstrainSelectedInstOperands,
     /* 363314 */     // GIR_Coverage, 12298,
     /* 363314 */     GIR_EraseRootFromParent_Done,
     /* 363315 */   // Label 5755: @363315
     /* 363315 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(363450), // Rule ID 12299 //
     /* 363320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 363323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 363339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 363343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 363355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 363359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363367 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 363372 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 363377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363381 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363397 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363404 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 363407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363448 */     GIR_RootConstrainSelectedInstOperands,
     /* 363449 */     // GIR_Coverage, 12299,
     /* 363449 */     GIR_EraseRootFromParent_Done,
     /* 363450 */   // Label 5756: @363450
     /* 363450 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(363585), // Rule ID 12300 //
     /* 363455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 363458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 363474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 363478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 363490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 363494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363502 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 363507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 363512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363539 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 363542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363583 */     GIR_RootConstrainSelectedInstOperands,
     /* 363584 */     // GIR_Coverage, 12300,
     /* 363584 */     GIR_EraseRootFromParent_Done,
     /* 363585 */   // Label 5757: @363585
     /* 363585 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(363720), // Rule ID 12301 //
     /* 363590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 363593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 363597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 363609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 363613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 363625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 363629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 363642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 363647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363674 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 363677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 363684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 363689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 363694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 363699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363718 */     GIR_RootConstrainSelectedInstOperands,
     /* 363719 */     // GIR_Coverage, 12301,
     /* 363719 */     GIR_EraseRootFromParent_Done,
     /* 363720 */   // Label 5758: @363720
     /* 363720 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(363855), // Rule ID 12778 //
     /* 363725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 363728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 363732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 363744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 363748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 363760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 363764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363772 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363772 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 363777 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363777 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 363782 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363788 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363809 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 363812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363853 */     GIR_RootConstrainSelectedInstOperands,
     /* 363854 */     // GIR_Coverage, 12778,
     /* 363854 */     GIR_EraseRootFromParent_Done,
     /* 363855 */   // Label 5759: @363855
     /* 363855 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(363990), // Rule ID 12779 //
     /* 363860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 363863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 363867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 363879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 363883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 363887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 363891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 363895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 363899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 363903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 363907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 363907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 363912 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 363912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 363917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 363921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 363944 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 363944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 363947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 363949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 363954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 363959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 363964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 363969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 363974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 363979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363988 */     GIR_RootConstrainSelectedInstOperands,
     /* 363989 */     // GIR_Coverage, 12779,
     /* 363989 */     GIR_EraseRootFromParent_Done,
     /* 363990 */   // Label 5760: @363990
     /* 363990 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(364125), // Rule ID 12780 //
     /* 363995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 363998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 364002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 364018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364042 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 364047 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 364052 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364072 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364079 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 364082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364123 */     GIR_RootConstrainSelectedInstOperands,
     /* 364124 */     // GIR_Coverage, 12780,
     /* 364124 */     GIR_EraseRootFromParent_Done,
     /* 364125 */   // Label 5761: @364125
     /* 364125 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(364260), // Rule ID 12781 //
     /* 364130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 364133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 364137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 364153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364177 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 364182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 364187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364214 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 364217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364258 */     GIR_RootConstrainSelectedInstOperands,
     /* 364259 */     // GIR_Coverage, 12781,
     /* 364259 */     GIR_EraseRootFromParent_Done,
     /* 364260 */   // Label 5762: @364260
     /* 364260 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(364395), // Rule ID 13258 //
     /* 364265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 364268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 364288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 364317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 364322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364349 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 364352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364393 */     GIR_RootConstrainSelectedInstOperands,
     /* 364394 */     // GIR_Coverage, 13258,
     /* 364394 */     GIR_EraseRootFromParent_Done,
     /* 364395 */   // Label 5763: @364395
     /* 364395 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(364530), // Rule ID 13259 //
     /* 364400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 364403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 364423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 364452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 364457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364484 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 364487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 364494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 364499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 364504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 364509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364528 */     GIR_RootConstrainSelectedInstOperands,
     /* 364529 */     // GIR_Coverage, 13259,
     /* 364529 */     GIR_EraseRootFromParent_Done,
     /* 364530 */   // Label 5764: @364530
     /* 364530 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(364665), // Rule ID 13260 //
     /* 364535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 364538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 364558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 364587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 364592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364619 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 364622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364663 */     GIR_RootConstrainSelectedInstOperands,
     /* 364664 */     // GIR_Coverage, 13260,
     /* 364664 */     GIR_EraseRootFromParent_Done,
     /* 364665 */   // Label 5765: @364665
     /* 364665 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(364800), // Rule ID 13261 //
     /* 364670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 364673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 364693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 364701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 364713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 364717 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 364717 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 364722 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 364722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 364727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 364731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 364733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364754 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 364757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 364774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 364779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 364784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 364789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364798 */     GIR_RootConstrainSelectedInstOperands,
     /* 364799 */     // GIR_Coverage, 13261,
     /* 364799 */     GIR_EraseRootFromParent_Done,
     /* 364800 */   // Label 5766: @364800
     /* 364800 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(364915), // Rule ID 13406 //
     /* 364805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 364808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 364812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 364820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364840 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 364842 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 364846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364869 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 364872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 364889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 364894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 364899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 364904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364913 */     GIR_RootConstrainSelectedInstOperands,
     /* 364914 */     // GIR_Coverage, 13406,
     /* 364914 */     GIR_EraseRootFromParent_Done,
     /* 364915 */   // Label 5767: @364915
     /* 364915 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(365030), // Rule ID 13422 //
     /* 364920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 364923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 364927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 364935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 364939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 364943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 364947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 364951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 364955 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 364957 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 364961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364970 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 364984 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 364984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 364987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 364989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 364994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 364999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 365004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 365009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 365014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 365019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365028 */     GIR_RootConstrainSelectedInstOperands,
     /* 365029 */     // GIR_Coverage, 13422,
     /* 365029 */     GIR_EraseRootFromParent_Done,
     /* 365030 */   // Label 5768: @365030
     /* 365030 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(365145), // Rule ID 13405 //
     /* 365035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 365038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 365042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 365050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 365070 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 365072 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 365076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365092 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365099 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 365102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 365119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 365124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 365129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 365134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365143 */     GIR_RootConstrainSelectedInstOperands,
     /* 365144 */     // GIR_Coverage, 13405,
     /* 365144 */     GIR_EraseRootFromParent_Done,
     /* 365145 */   // Label 5769: @365145
     /* 365145 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(365260), // Rule ID 13421 //
     /* 365150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 365153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 365165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 365185 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 365187 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 365191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365214 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 365217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 365234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 365239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 365244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 365249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365258 */     GIR_RootConstrainSelectedInstOperands,
     /* 365259 */     // GIR_Coverage, 13421,
     /* 365259 */     GIR_EraseRootFromParent_Done,
     /* 365260 */   // Label 5770: @365260
     /* 365260 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(365375), // Rule ID 7880 //
     /* 365265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 365268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 365272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 365280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 365300 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 365302 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 365306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365329 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 365332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365373 */     GIR_RootConstrainSelectedInstOperands,
     /* 365374 */     // GIR_Coverage, 7880,
     /* 365374 */     GIR_EraseRootFromParent_Done,
     /* 365375 */   // Label 5771: @365375
     /* 365375 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(365490), // Rule ID 7896 //
     /* 365380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 365383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 365395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 365415 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 365417 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 365421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365444 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 365447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365488 */     GIR_RootConstrainSelectedInstOperands,
     /* 365489 */     // GIR_Coverage, 7896,
     /* 365489 */     GIR_EraseRootFromParent_Done,
     /* 365490 */   // Label 5772: @365490
     /* 365490 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(365605), // Rule ID 7879 //
     /* 365495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 365498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 365502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 365510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 365530 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 365532 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 365536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365559 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 365562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365603 */     GIR_RootConstrainSelectedInstOperands,
     /* 365604 */     // GIR_Coverage, 7879,
     /* 365604 */     GIR_EraseRootFromParent_Done,
     /* 365605 */   // Label 5773: @365605
     /* 365605 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(365720), // Rule ID 7895 //
     /* 365610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 365613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 365625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 365633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 365641 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 365645 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 365647 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 365651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365674 */     // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 365677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 365684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 365689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 365694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 365699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 365704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 365709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365718 */     GIR_RootConstrainSelectedInstOperands,
     /* 365719 */     // GIR_Coverage, 7895,
     /* 365719 */     GIR_EraseRootFromParent_Done,
     /* 365720 */   // Label 5774: @365720
     /* 365720 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(365819), // Rule ID 13398 //
     /* 365725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 365728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 365732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 365748 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 365750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365773 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 365776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 365793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 365798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 365803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 365808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365817 */     GIR_RootConstrainSelectedInstOperands,
     /* 365818 */     // GIR_Coverage, 13398,
     /* 365818 */     GIR_EraseRootFromParent_Done,
     /* 365819 */   // Label 5775: @365819
     /* 365819 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(365918), // Rule ID 13414 //
     /* 365824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 365827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 365831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 365839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 365847 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 365849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365872 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 365875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 365892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 365897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 365902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 365907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365916 */     GIR_RootConstrainSelectedInstOperands,
     /* 365917 */     // GIR_Coverage, 13414,
     /* 365917 */     GIR_EraseRootFromParent_Done,
     /* 365918 */   // Label 5776: @365918
     /* 365918 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(366017), // Rule ID 13397 //
     /* 365923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 365926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 365930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 365934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 365938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 365942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 365946 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 365948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 365971 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 365971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 365974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 365976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 365981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 365986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 365991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 365996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 366001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 366006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366015 */     GIR_RootConstrainSelectedInstOperands,
     /* 366016 */     // GIR_Coverage, 13397,
     /* 366016 */     GIR_EraseRootFromParent_Done,
     /* 366017 */   // Label 5777: @366017
     /* 366017 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(366116), // Rule ID 13413 //
     /* 366022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 366025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 366045 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 366047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366070 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 366073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 366080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 366090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 366095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 366100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 366105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366114 */     GIR_RootConstrainSelectedInstOperands,
     /* 366115 */     // GIR_Coverage, 13413,
     /* 366115 */     GIR_EraseRootFromParent_Done,
     /* 366116 */   // Label 5778: @366116
     /* 366116 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(366215), // Rule ID 7872 //
     /* 366121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 366124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 366128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 366144 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 366146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366169 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 366172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366213 */     GIR_RootConstrainSelectedInstOperands,
     /* 366214 */     // GIR_Coverage, 7872,
     /* 366214 */     GIR_EraseRootFromParent_Done,
     /* 366215 */   // Label 5779: @366215
     /* 366215 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(366314), // Rule ID 7888 //
     /* 366220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 366223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 366243 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 366245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366254 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366268 */     // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 366271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366312 */     GIR_RootConstrainSelectedInstOperands,
     /* 366313 */     // GIR_Coverage, 7888,
     /* 366313 */     GIR_EraseRootFromParent_Done,
     /* 366314 */   // Label 5780: @366314
     /* 366314 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(366413), // Rule ID 7871 //
     /* 366319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 366322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 366326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 366342 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 366344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366367 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 366370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366411 */     GIR_RootConstrainSelectedInstOperands,
     /* 366412 */     // GIR_Coverage, 7871,
     /* 366412 */     GIR_EraseRootFromParent_Done,
     /* 366413 */   // Label 5781: @366413
     /* 366413 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(366512), // Rule ID 7887 //
     /* 366418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 366421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 366433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 366437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 366441 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 366443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366466 */     // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 366469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366510 */     GIR_RootConstrainSelectedInstOperands,
     /* 366511 */     // GIR_Coverage, 7887,
     /* 366511 */     GIR_EraseRootFromParent_Done,
     /* 366512 */   // Label 5782: @366512
     /* 366512 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(366547), // Rule ID 101 //
     /* 366517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 366520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 366524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 366528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 366532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13744),
     /* 366536 */     // (fminnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13744>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 366536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
     /* 366541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 366545 */     GIR_RootConstrainSelectedInstOperands,
     /* 366546 */     // GIR_Coverage, 101,
     /* 366546 */     GIR_Done,
     /* 366547 */   // Label 5783: @366547
     /* 366547 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(366610), // Rule ID 887 //
     /* 366552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 366555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 366566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366573 */     // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 366573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 366576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 366583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 366593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 366603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 366608 */     GIR_RootConstrainSelectedInstOperands,
     /* 366609 */     // GIR_Coverage, 887,
     /* 366609 */     GIR_EraseRootFromParent_Done,
     /* 366610 */   // Label 5784: @366610
     /* 366610 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(366673), // Rule ID 891 //
     /* 366615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 366618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 366629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366636 */     // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 366636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 366639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 366646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 366656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 366666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 366671 */     GIR_RootConstrainSelectedInstOperands,
     /* 366672 */     // GIR_Coverage, 891,
     /* 366672 */     GIR_EraseRootFromParent_Done,
     /* 366673 */   // Label 5785: @366673
     /* 366673 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(366736), // Rule ID 8573 //
     /* 366678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 366681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 366699 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 366699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 366702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 366709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 366719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 366729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 366734 */     GIR_RootConstrainSelectedInstOperands,
     /* 366735 */     // GIR_Coverage, 8573,
     /* 366735 */     GIR_EraseRootFromParent_Done,
     /* 366736 */   // Label 5786: @366736
     /* 366736 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(366799), // Rule ID 8575 //
     /* 366741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 366744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 366762 */     // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 366762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 366765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 366772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 366777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 366782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 366787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 366792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 366797 */     GIR_RootConstrainSelectedInstOperands,
     /* 366798 */     // GIR_Coverage, 8575,
     /* 366798 */     GIR_EraseRootFromParent_Done,
     /* 366799 */   // Label 5787: @366799
     /* 366799 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(366861), // Rule ID 889 //
     /* 366804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 366807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 366811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 366818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 366825 */     // (fminnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 366825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
     /* 366828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 366835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 366845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366859 */     GIR_RootConstrainSelectedInstOperands,
     /* 366860 */     // GIR_Coverage, 889,
     /* 366860 */     GIR_EraseRootFromParent_Done,
     /* 366861 */   // Label 5788: @366861
     /* 366861 */   GIM_Reject,
     /* 366862 */ // Label 5382: @366862
     /* 366862 */ GIM_Reject,
     /* 366863 */ // Label 5378: @366863
     /* 366863 */ GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(384374),
     /* 366868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366874 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(367003), // Rule ID 11887 //
     /* 366879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 366883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 366907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 366915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 366923 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 366923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 366928 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 366928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 366933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 366937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 366960 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 366960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 366963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 366965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 366970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 366975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 366980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 366985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 366990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 366995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367001 */     GIR_RootConstrainSelectedInstOperands,
     /* 367002 */     // GIR_Coverage, 11887,
     /* 367002 */     GIR_EraseRootFromParent_Done,
     /* 367003 */   // Label 5790: @367003
     /* 367003 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(367132), // Rule ID 11888 //
     /* 367008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367044 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367048 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367052 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367057 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367057 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367089 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 367099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 367104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 367119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 367124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367130 */     GIR_RootConstrainSelectedInstOperands,
     /* 367131 */     // GIR_Coverage, 11888,
     /* 367131 */     GIR_EraseRootFromParent_Done,
     /* 367132 */   // Label 5791: @367132
     /* 367132 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(367261), // Rule ID 11891 //
     /* 367137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367218 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 367238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 367243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 367248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 367253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367259 */     GIR_RootConstrainSelectedInstOperands,
     /* 367260 */     // GIR_Coverage, 11891,
     /* 367260 */     GIR_EraseRootFromParent_Done,
     /* 367261 */   // Label 5792: @367261
     /* 367261 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(367390), // Rule ID 11892 //
     /* 367266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367310 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367315 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367347 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 367367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 367372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 367377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 367382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367388 */     GIR_RootConstrainSelectedInstOperands,
     /* 367389 */     // GIR_Coverage, 11892,
     /* 367389 */     GIR_EraseRootFromParent_Done,
     /* 367390 */   // Label 5793: @367390
     /* 367390 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(367519), // Rule ID 11872 //
     /* 367395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367476 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 367486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 367491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 367506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 367511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367517 */     GIR_RootConstrainSelectedInstOperands,
     /* 367518 */     // GIR_Coverage, 11872,
     /* 367518 */     GIR_EraseRootFromParent_Done,
     /* 367519 */   // Label 5794: @367519
     /* 367519 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(367648), // Rule ID 11873 //
     /* 367524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367556 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367568 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367573 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367573 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367578 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367605 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 367615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 367620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 367625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 367630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 367635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 367640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367646 */     GIR_RootConstrainSelectedInstOperands,
     /* 367647 */     // GIR_Coverage, 11873,
     /* 367647 */     GIR_EraseRootFromParent_Done,
     /* 367648 */   // Label 5795: @367648
     /* 367648 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(367777), // Rule ID 11876 //
     /* 367653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367697 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367697 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367702 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367734 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 367754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 367759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 367764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 367769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367775 */     GIR_RootConstrainSelectedInstOperands,
     /* 367776 */     // GIR_Coverage, 11876,
     /* 367776 */     GIR_EraseRootFromParent_Done,
     /* 367777 */   // Label 5796: @367777
     /* 367777 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(367906), // Rule ID 11877 //
     /* 367782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 367826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367863 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 367873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 367878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 367883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 367888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 367893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 367898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367904 */     GIR_RootConstrainSelectedInstOperands,
     /* 367905 */     // GIR_Coverage, 11877,
     /* 367905 */     GIR_EraseRootFromParent_Done,
     /* 367906 */   // Label 5797: @367906
     /* 367906 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(368035), // Rule ID 7746 //
     /* 367911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 367915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 367939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 367947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 367955 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 367955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 367960 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 367960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 367965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 367969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 367992 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 367992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 367995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 367997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 368002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 368007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368033 */     GIR_RootConstrainSelectedInstOperands,
     /* 368034 */     // GIR_Coverage, 7746,
     /* 368034 */     GIR_EraseRootFromParent_Done,
     /* 368035 */   // Label 5798: @368035
     /* 368035 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(368164), // Rule ID 11886 //
     /* 368040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368121 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 368131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 368136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368162 */     GIR_RootConstrainSelectedInstOperands,
     /* 368163 */     // GIR_Coverage, 11886,
     /* 368163 */     GIR_EraseRootFromParent_Done,
     /* 368164 */   // Label 5799: @368164
     /* 368164 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(368293), // Rule ID 11889 //
     /* 368169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368213 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368218 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368223 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368229 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368250 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 368270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 368275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368291 */     GIR_RootConstrainSelectedInstOperands,
     /* 368292 */     // GIR_Coverage, 11889,
     /* 368292 */     GIR_EraseRootFromParent_Done,
     /* 368293 */   // Label 5800: @368293
     /* 368293 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(368422), // Rule ID 11890 //
     /* 368298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368342 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368342 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368347 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368379 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 368399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 368404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368420 */     GIR_RootConstrainSelectedInstOperands,
     /* 368421 */     // GIR_Coverage, 11890,
     /* 368421 */     GIR_EraseRootFromParent_Done,
     /* 368422 */   // Label 5801: @368422
     /* 368422 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(368551), // Rule ID 7745 //
     /* 368427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368508 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 368518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 368523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368549 */     GIR_RootConstrainSelectedInstOperands,
     /* 368550 */     // GIR_Coverage, 7745,
     /* 368550 */     GIR_EraseRootFromParent_Done,
     /* 368551 */   // Label 5802: @368551
     /* 368551 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(368680), // Rule ID 11871 //
     /* 368556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368600 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368605 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368637 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 368647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 368652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 368657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 368662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368678 */     GIR_RootConstrainSelectedInstOperands,
     /* 368679 */     // GIR_Coverage, 11871,
     /* 368679 */     GIR_EraseRootFromParent_Done,
     /* 368680 */   // Label 5803: @368680
     /* 368680 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(368809), // Rule ID 11874 //
     /* 368685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368766 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 368786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 368791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368807 */     GIR_RootConstrainSelectedInstOperands,
     /* 368808 */     // GIR_Coverage, 11874,
     /* 368808 */     GIR_EraseRootFromParent_Done,
     /* 368809 */   // Label 5804: @368809
     /* 368809 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(368938), // Rule ID 11875 //
     /* 368814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 368854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 368858 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368863 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368868 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 368872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 368895 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 368895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 368898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 368900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 368905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 368910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 368915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 368920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 368925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 368930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368936 */     GIR_RootConstrainSelectedInstOperands,
     /* 368937 */     // GIR_Coverage, 11875,
     /* 368937 */     GIR_EraseRootFromParent_Done,
     /* 368938 */   // Label 5805: @368938
     /* 368938 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(369067), // Rule ID 11857 //
     /* 368943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 368947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 368955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 368963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 368971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 368975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 368979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 368987 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 368987 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 368992 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 368992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 368997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369024 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369065 */     GIR_RootConstrainSelectedInstOperands,
     /* 369066 */     // GIR_Coverage, 11857,
     /* 369066 */     GIR_EraseRootFromParent_Done,
     /* 369067 */   // Label 5806: @369067
     /* 369067 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(369196), // Rule ID 11858 //
     /* 369072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 369121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369153 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369194 */     GIR_RootConstrainSelectedInstOperands,
     /* 369195 */     // GIR_Coverage, 11858,
     /* 369195 */     GIR_EraseRootFromParent_Done,
     /* 369196 */   // Label 5807: @369196
     /* 369196 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(369325), // Rule ID 11861 //
     /* 369201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369245 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 369250 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369282 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369323 */     GIR_RootConstrainSelectedInstOperands,
     /* 369324 */     // GIR_Coverage, 11861,
     /* 369324 */     GIR_EraseRootFromParent_Done,
     /* 369325 */   // Label 5808: @369325
     /* 369325 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(369454), // Rule ID 11862 //
     /* 369330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 369374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 369384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369411 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369452 */     GIR_RootConstrainSelectedInstOperands,
     /* 369453 */     // GIR_Coverage, 11862,
     /* 369453 */     GIR_EraseRootFromParent_Done,
     /* 369454 */   // Label 5809: @369454
     /* 369454 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(369583), // Rule ID 11842 //
     /* 369459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 369503 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369503 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369508 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 369513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369540 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369581 */     GIR_RootConstrainSelectedInstOperands,
     /* 369582 */     // GIR_Coverage, 11842,
     /* 369582 */     GIR_EraseRootFromParent_Done,
     /* 369583 */   // Label 5810: @369583
     /* 369583 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(369712), // Rule ID 11843 //
     /* 369588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 369632 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 369637 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369669 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 369679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 369684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 369689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 369694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369710 */     GIR_RootConstrainSelectedInstOperands,
     /* 369711 */     // GIR_Coverage, 11843,
     /* 369711 */     GIR_EraseRootFromParent_Done,
     /* 369712 */   // Label 5811: @369712
     /* 369712 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(369841), // Rule ID 11846 //
     /* 369717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 369761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 369766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369798 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369839 */     GIR_RootConstrainSelectedInstOperands,
     /* 369840 */     // GIR_Coverage, 11846,
     /* 369840 */     GIR_EraseRootFromParent_Done,
     /* 369841 */   // Label 5812: @369841
     /* 369841 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(369970), // Rule ID 11847 //
     /* 369846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 369874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 369878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 369882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 369890 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 369890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369895 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 369895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 369900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 369904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 369927 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 369927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 369930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 369932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 369937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 369942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 369947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 369952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 369957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 369962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369968 */     GIR_RootConstrainSelectedInstOperands,
     /* 369969 */     // GIR_Coverage, 11847,
     /* 369969 */     GIR_EraseRootFromParent_Done,
     /* 369970 */   // Label 5813: @369970
     /* 369970 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(370099), // Rule ID 7744 //
     /* 369975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 369979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 369987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 369995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 370019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370056 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370097 */     GIR_RootConstrainSelectedInstOperands,
     /* 370098 */     // GIR_Coverage, 7744,
     /* 370098 */     GIR_EraseRootFromParent_Done,
     /* 370099 */   // Label 5814: @370099
     /* 370099 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(370228), // Rule ID 11856 //
     /* 370104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 370148 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370148 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370153 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370158 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370185 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370226 */     GIR_RootConstrainSelectedInstOperands,
     /* 370227 */     // GIR_Coverage, 11856,
     /* 370227 */     GIR_EraseRootFromParent_Done,
     /* 370228 */   // Label 5815: @370228
     /* 370228 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(370357), // Rule ID 11859 //
     /* 370233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 370277 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370277 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370282 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370287 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370314 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370355 */     GIR_RootConstrainSelectedInstOperands,
     /* 370356 */     // GIR_Coverage, 11859,
     /* 370356 */     GIR_EraseRootFromParent_Done,
     /* 370357 */   // Label 5816: @370357
     /* 370357 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(370486), // Rule ID 11860 //
     /* 370362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 370406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370443 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370484 */     GIR_RootConstrainSelectedInstOperands,
     /* 370485 */     // GIR_Coverage, 11860,
     /* 370485 */     GIR_EraseRootFromParent_Done,
     /* 370486 */   // Label 5817: @370486
     /* 370486 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(370615), // Rule ID 7743 //
     /* 370491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370535 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370540 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370572 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370613 */     GIR_RootConstrainSelectedInstOperands,
     /* 370614 */     // GIR_Coverage, 7743,
     /* 370614 */     GIR_EraseRootFromParent_Done,
     /* 370615 */   // Label 5818: @370615
     /* 370615 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(370744), // Rule ID 11841 //
     /* 370620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370701 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 370711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 370716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 370721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 370726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370742 */     GIR_RootConstrainSelectedInstOperands,
     /* 370743 */     // GIR_Coverage, 11841,
     /* 370743 */     GIR_EraseRootFromParent_Done,
     /* 370744 */   // Label 5819: @370744
     /* 370744 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(370873), // Rule ID 11844 //
     /* 370749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370793 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370798 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370830 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370871 */     GIR_RootConstrainSelectedInstOperands,
     /* 370872 */     // GIR_Coverage, 11844,
     /* 370872 */     GIR_EraseRootFromParent_Done,
     /* 370873 */   // Label 5820: @370873
     /* 370873 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(371002), // Rule ID 11845 //
     /* 370878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 370882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 370890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 370898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 370906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 370910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 370914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 370918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 370922 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 370922 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370927 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 370927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 370932 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 370936 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 370959 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 370959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 370962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 370964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 370969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 370974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 370979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 370984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 370989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 370994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371000 */     GIR_RootConstrainSelectedInstOperands,
     /* 371001 */     // GIR_Coverage, 11845,
     /* 371001 */     GIR_EraseRootFromParent_Done,
     /* 371002 */   // Label 5821: @371002
     /* 371002 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(371131), // Rule ID 11897 //
     /* 371007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371088 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 371108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 371113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 371118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 371123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371129 */     GIR_RootConstrainSelectedInstOperands,
     /* 371130 */     // GIR_Coverage, 11897,
     /* 371130 */     GIR_EraseRootFromParent_Done,
     /* 371131 */   // Label 5822: @371131
     /* 371131 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(371260), // Rule ID 11898 //
     /* 371136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371180 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371185 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371217 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 371237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 371242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 371247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 371252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371258 */     GIR_RootConstrainSelectedInstOperands,
     /* 371259 */     // GIR_Coverage, 11898,
     /* 371259 */     GIR_EraseRootFromParent_Done,
     /* 371260 */   // Label 5823: @371260
     /* 371260 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(371389), // Rule ID 11899 //
     /* 371265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371346 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 371356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 371361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 371376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 371381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371387 */     GIR_RootConstrainSelectedInstOperands,
     /* 371388 */     // GIR_Coverage, 11899,
     /* 371388 */     GIR_EraseRootFromParent_Done,
     /* 371389 */   // Label 5824: @371389
     /* 371389 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(371518), // Rule ID 11900 //
     /* 371394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371438 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371438 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371443 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371475 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 371485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 371490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 371505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 371510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371516 */     GIR_RootConstrainSelectedInstOperands,
     /* 371517 */     // GIR_Coverage, 11900,
     /* 371517 */     GIR_EraseRootFromParent_Done,
     /* 371518 */   // Label 5825: @371518
     /* 371518 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(371647), // Rule ID 11837 //
     /* 371523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371567 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371567 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371572 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371577 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371604 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 371624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 371629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 371634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 371639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371645 */     GIR_RootConstrainSelectedInstOperands,
     /* 371646 */     // GIR_Coverage, 11837,
     /* 371646 */     GIR_EraseRootFromParent_Done,
     /* 371647 */   // Label 5826: @371647
     /* 371647 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(371776), // Rule ID 11838 //
     /* 371652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371733 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 371743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 371748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 371753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 371758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 371763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 371768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371774 */     GIR_RootConstrainSelectedInstOperands,
     /* 371775 */     // GIR_Coverage, 11838,
     /* 371775 */     GIR_EraseRootFromParent_Done,
     /* 371776 */   // Label 5827: @371776
     /* 371776 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(371905), // Rule ID 11839 //
     /* 371781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371825 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371830 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371862 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 371872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 371877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 371882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 371887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 371892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 371897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371903 */     GIR_RootConstrainSelectedInstOperands,
     /* 371904 */     // GIR_Coverage, 11839,
     /* 371904 */     GIR_EraseRootFromParent_Done,
     /* 371905 */   // Label 5828: @371905
     /* 371905 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(372034), // Rule ID 11840 //
     /* 371910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 371914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 371922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 371926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 371930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 371938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 371942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 371946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 371954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 371954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 371959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 371959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 371964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 371968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 371991 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 371991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 371994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 371996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 372001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 372006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372032 */     GIR_RootConstrainSelectedInstOperands,
     /* 372033 */     // GIR_Coverage, 11840,
     /* 372033 */     GIR_EraseRootFromParent_Done,
     /* 372034 */   // Label 5829: @372034
     /* 372034 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(372163), // Rule ID 11882 //
     /* 372039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372083 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372083 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372088 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372120 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 372140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 372145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372161 */     GIR_RootConstrainSelectedInstOperands,
     /* 372162 */     // GIR_Coverage, 11882,
     /* 372162 */     GIR_EraseRootFromParent_Done,
     /* 372163 */   // Label 5830: @372163
     /* 372163 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(372292), // Rule ID 11883 //
     /* 372168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372212 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372212 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372217 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372222 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372226 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372249 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 372269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 372274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372290 */     GIR_RootConstrainSelectedInstOperands,
     /* 372291 */     // GIR_Coverage, 11883,
     /* 372291 */     GIR_EraseRootFromParent_Done,
     /* 372292 */   // Label 5831: @372292
     /* 372292 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(372421), // Rule ID 11884 //
     /* 372297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372378 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 372388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 372393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372419 */     GIR_RootConstrainSelectedInstOperands,
     /* 372420 */     // GIR_Coverage, 11884,
     /* 372420 */     GIR_EraseRootFromParent_Done,
     /* 372421 */   // Label 5832: @372421
     /* 372421 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(372550), // Rule ID 11885 //
     /* 372426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372470 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372475 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372507 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 372517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 372522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372548 */     GIR_RootConstrainSelectedInstOperands,
     /* 372549 */     // GIR_Coverage, 11885,
     /* 372549 */     GIR_EraseRootFromParent_Done,
     /* 372550 */   // Label 5833: @372550
     /* 372550 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(372679), // Rule ID 11822 //
     /* 372555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372636 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 372656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 372661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372677 */     GIR_RootConstrainSelectedInstOperands,
     /* 372678 */     // GIR_Coverage, 11822,
     /* 372678 */     GIR_EraseRootFromParent_Done,
     /* 372679 */   // Label 5834: @372679
     /* 372679 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(372808), // Rule ID 11823 //
     /* 372684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372728 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372733 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372765 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 372775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 372780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 372785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 372790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372806 */     GIR_RootConstrainSelectedInstOperands,
     /* 372807 */     // GIR_Coverage, 11823,
     /* 372807 */     GIR_EraseRootFromParent_Done,
     /* 372808 */   // Label 5835: @372808
     /* 372808 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(372937), // Rule ID 11824 //
     /* 372813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372857 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372857 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372862 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 372871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 372894 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 372894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 372897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 372899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 372904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 372909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 372914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 372919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 372924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 372929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372935 */     GIR_RootConstrainSelectedInstOperands,
     /* 372936 */     // GIR_Coverage, 11824,
     /* 372936 */     GIR_EraseRootFromParent_Done,
     /* 372937 */   // Label 5836: @372937
     /* 372937 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(373066), // Rule ID 11825 //
     /* 372942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 372946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 372954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 372958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 372962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 372970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 372974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 372978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 372986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 372986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 372991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 372991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 372996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373023 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 373033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 373038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 373053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 373058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373064 */     GIR_RootConstrainSelectedInstOperands,
     /* 373065 */     // GIR_Coverage, 11825,
     /* 373065 */     GIR_EraseRootFromParent_Done,
     /* 373066 */   // Label 5837: @373066
     /* 373066 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(373195), // Rule ID 11893 //
     /* 373071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373115 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 373120 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 373125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373152 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373193 */     GIR_RootConstrainSelectedInstOperands,
     /* 373194 */     // GIR_Coverage, 11893,
     /* 373194 */     GIR_EraseRootFromParent_Done,
     /* 373195 */   // Label 5838: @373195
     /* 373195 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(373324), // Rule ID 11894 //
     /* 373200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 373249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 373254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373281 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373322 */     GIR_RootConstrainSelectedInstOperands,
     /* 373323 */     // GIR_Coverage, 11894,
     /* 373323 */     GIR_EraseRootFromParent_Done,
     /* 373324 */   // Label 5839: @373324
     /* 373324 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(373453), // Rule ID 11895 //
     /* 373329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373373 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 373378 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 373383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373410 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373451 */     GIR_RootConstrainSelectedInstOperands,
     /* 373452 */     // GIR_Coverage, 11895,
     /* 373452 */     GIR_EraseRootFromParent_Done,
     /* 373453 */   // Label 5840: @373453
     /* 373453 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(373582), // Rule ID 11896 //
     /* 373458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373502 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373502 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 373507 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 373512 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373516 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373539 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373580 */     GIR_RootConstrainSelectedInstOperands,
     /* 373581 */     // GIR_Coverage, 11896,
     /* 373581 */     GIR_EraseRootFromParent_Done,
     /* 373582 */   // Label 5841: @373582
     /* 373582 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(373711), // Rule ID 11833 //
     /* 373587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 373636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 373641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373668 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373709 */     GIR_RootConstrainSelectedInstOperands,
     /* 373710 */     // GIR_Coverage, 11833,
     /* 373710 */     GIR_EraseRootFromParent_Done,
     /* 373711 */   // Label 5842: @373711
     /* 373711 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(373840), // Rule ID 11834 //
     /* 373716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373760 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 373765 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 373770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373783 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373797 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 373807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 373812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 373817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 373822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373838 */     GIR_RootConstrainSelectedInstOperands,
     /* 373839 */     // GIR_Coverage, 11834,
     /* 373839 */     GIR_EraseRootFromParent_Done,
     /* 373840 */   // Label 5843: @373840
     /* 373840 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(373969), // Rule ID 11835 //
     /* 373845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 373873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 373877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 373881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 373889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 373889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 373894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 373894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 373899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 373903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 373926 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 373926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 373929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 373931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 373936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 373941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 373946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 373951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 373956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 373961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373967 */     GIR_RootConstrainSelectedInstOperands,
     /* 373968 */     // GIR_Coverage, 11835,
     /* 373968 */     GIR_EraseRootFromParent_Done,
     /* 373969 */   // Label 5844: @373969
     /* 373969 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(374098), // Rule ID 11836 //
     /* 373974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 373978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 373986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 373994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 374002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374018 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374018 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374023 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374055 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374096 */     GIR_RootConstrainSelectedInstOperands,
     /* 374097 */     // GIR_Coverage, 11836,
     /* 374097 */     GIR_EraseRootFromParent_Done,
     /* 374098 */   // Label 5845: @374098
     /* 374098 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(374227), // Rule ID 11878 //
     /* 374103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374147 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374152 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374157 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374184 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374225 */     GIR_RootConstrainSelectedInstOperands,
     /* 374226 */     // GIR_Coverage, 11878,
     /* 374226 */     GIR_EraseRootFromParent_Done,
     /* 374227 */   // Label 5846: @374227
     /* 374227 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(374356), // Rule ID 11879 //
     /* 374232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374313 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374354 */     GIR_RootConstrainSelectedInstOperands,
     /* 374355 */     // GIR_Coverage, 11879,
     /* 374355 */     GIR_EraseRootFromParent_Done,
     /* 374356 */   // Label 5847: @374356
     /* 374356 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(374485), // Rule ID 11880 //
     /* 374361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374405 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374410 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374442 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374483 */     GIR_RootConstrainSelectedInstOperands,
     /* 374484 */     // GIR_Coverage, 11880,
     /* 374484 */     GIR_EraseRootFromParent_Done,
     /* 374485 */   // Label 5848: @374485
     /* 374485 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(374614), // Rule ID 11881 //
     /* 374490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374557 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374571 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374612 */     GIR_RootConstrainSelectedInstOperands,
     /* 374613 */     // GIR_Coverage, 11881,
     /* 374613 */     GIR_EraseRootFromParent_Done,
     /* 374614 */   // Label 5849: @374614
     /* 374614 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(374743), // Rule ID 11818 //
     /* 374619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374663 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374668 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374673 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374693 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374700 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374741 */     GIR_RootConstrainSelectedInstOperands,
     /* 374742 */     // GIR_Coverage, 11818,
     /* 374742 */     GIR_EraseRootFromParent_Done,
     /* 374743 */   // Label 5850: @374743
     /* 374743 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(374872), // Rule ID 11819 //
     /* 374748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374792 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374792 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374797 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374802 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374822 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374829 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 374839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 374844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 374849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 374854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374870 */     GIR_RootConstrainSelectedInstOperands,
     /* 374871 */     // GIR_Coverage, 11819,
     /* 374871 */     GIR_EraseRootFromParent_Done,
     /* 374872 */   // Label 5851: @374872
     /* 374872 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(375001), // Rule ID 11820 //
     /* 374877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 374881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 374889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 374897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 374905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 374913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 374921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 374921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 374926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 374926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 374931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 374935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 374958 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 374958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 374961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 374963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 374968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 374973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 374978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 374983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 374988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 374993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374999 */     GIR_RootConstrainSelectedInstOperands,
     /* 375000 */     // GIR_Coverage, 11820,
     /* 375000 */     GIR_EraseRootFromParent_Done,
     /* 375001 */   // Label 5852: @375001
     /* 375001 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(375130), // Rule ID 11821 //
     /* 375006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 375034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375050 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 375055 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 375060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375073 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375087 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 375107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 375112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375128 */     GIR_RootConstrainSelectedInstOperands,
     /* 375129 */     // GIR_Coverage, 11821,
     /* 375129 */     GIR_EraseRootFromParent_Done,
     /* 375130 */   // Label 5853: @375130
     /* 375130 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(375259), // Rule ID 11827 //
     /* 375135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375216 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 375226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 375231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375257 */     GIR_RootConstrainSelectedInstOperands,
     /* 375258 */     // GIR_Coverage, 11827,
     /* 375258 */     GIR_EraseRootFromParent_Done,
     /* 375259 */   // Label 5854: @375259
     /* 375259 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(375388), // Rule ID 11828 //
     /* 375264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375308 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375313 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375318 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375345 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 375355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 375360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375386 */     GIR_RootConstrainSelectedInstOperands,
     /* 375387 */     // GIR_Coverage, 11828,
     /* 375387 */     GIR_EraseRootFromParent_Done,
     /* 375388 */   // Label 5855: @375388
     /* 375388 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(375517), // Rule ID 11831 //
     /* 375393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375437 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375442 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375447 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375474 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 375494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 375499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375515 */     GIR_RootConstrainSelectedInstOperands,
     /* 375516 */     // GIR_Coverage, 11831,
     /* 375516 */     GIR_EraseRootFromParent_Done,
     /* 375517 */   // Label 5856: @375517
     /* 375517 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(375646), // Rule ID 11832 //
     /* 375522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 375566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375603 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 375613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 375618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 375623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 375628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375644 */     GIR_RootConstrainSelectedInstOperands,
     /* 375645 */     // GIR_Coverage, 11832,
     /* 375645 */     GIR_EraseRootFromParent_Done,
     /* 375646 */   // Label 5857: @375646
     /* 375646 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(375775), // Rule ID 11812 //
     /* 375651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 375695 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375700 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375732 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 375742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 375747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375773 */     GIR_RootConstrainSelectedInstOperands,
     /* 375774 */     // GIR_Coverage, 11812,
     /* 375774 */     GIR_EraseRootFromParent_Done,
     /* 375775 */   // Label 5858: @375775
     /* 375775 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(375904), // Rule ID 11813 //
     /* 375780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 375824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375861 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 375871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 375876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 375881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 375886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 375891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 375896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375902 */     GIR_RootConstrainSelectedInstOperands,
     /* 375903 */     // GIR_Coverage, 11813,
     /* 375903 */     GIR_EraseRootFromParent_Done,
     /* 375904 */   // Label 5859: @375904
     /* 375904 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(376033), // Rule ID 11816 //
     /* 375909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 375913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 375921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 375929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 375937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 375945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 375953 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 375953 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 375958 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 375958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 375963 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 375967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 375990 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 375990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 375993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 375995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 376010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 376015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376031 */     GIR_RootConstrainSelectedInstOperands,
     /* 376032 */     // GIR_Coverage, 11816,
     /* 376032 */     GIR_EraseRootFromParent_Done,
     /* 376033 */   // Label 5860: @376033
     /* 376033 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(376162), // Rule ID 11817 //
     /* 376038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376082 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376087 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376119 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 376139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 376144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376160 */     GIR_RootConstrainSelectedInstOperands,
     /* 376161 */     // GIR_Coverage, 11817,
     /* 376161 */     GIR_EraseRootFromParent_Done,
     /* 376162 */   // Label 5861: @376162
     /* 376162 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(376291), // Rule ID 7742 //
     /* 376167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 376211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376248 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 376258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 376263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376289 */     GIR_RootConstrainSelectedInstOperands,
     /* 376290 */     // GIR_Coverage, 7742,
     /* 376290 */     GIR_EraseRootFromParent_Done,
     /* 376291 */   // Label 5862: @376291
     /* 376291 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(376420), // Rule ID 11826 //
     /* 376296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 376340 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376345 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376377 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 376387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 376392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376418 */     GIR_RootConstrainSelectedInstOperands,
     /* 376419 */     // GIR_Coverage, 11826,
     /* 376419 */     GIR_EraseRootFromParent_Done,
     /* 376420 */   // Label 5863: @376420
     /* 376420 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(376549), // Rule ID 11829 //
     /* 376425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 376469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376506 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 376526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 376531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376547 */     GIR_RootConstrainSelectedInstOperands,
     /* 376548 */     // GIR_Coverage, 11829,
     /* 376548 */     GIR_EraseRootFromParent_Done,
     /* 376549 */   // Label 5864: @376549
     /* 376549 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(376678), // Rule ID 11830 //
     /* 376554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 376598 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376598 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376603 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376608 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376635 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 376645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 376650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 376655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 376660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376676 */     GIR_RootConstrainSelectedInstOperands,
     /* 376677 */     // GIR_Coverage, 11830,
     /* 376677 */     GIR_EraseRootFromParent_Done,
     /* 376678 */   // Label 5865: @376678
     /* 376678 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(376807), // Rule ID 7741 //
     /* 376683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376727 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376732 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376764 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 376774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 376779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376805 */     GIR_RootConstrainSelectedInstOperands,
     /* 376806 */     // GIR_Coverage, 7741,
     /* 376806 */     GIR_EraseRootFromParent_Done,
     /* 376807 */   // Label 5866: @376807
     /* 376807 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(376936), // Rule ID 11811 //
     /* 376812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 376893 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 376893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 376896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 376898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 376903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 376908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 376913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 376918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 376923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 376928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376934 */     GIR_RootConstrainSelectedInstOperands,
     /* 376935 */     // GIR_Coverage, 11811,
     /* 376935 */     GIR_EraseRootFromParent_Done,
     /* 376936 */   // Label 5867: @376936
     /* 376936 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(377065), // Rule ID 11814 //
     /* 376941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 376945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 376953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 376961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 376969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 376977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 376985 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 376985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 376990 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 376990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 376995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 376999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377022 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377063 */     GIR_RootConstrainSelectedInstOperands,
     /* 377064 */     // GIR_Coverage, 11814,
     /* 377064 */     GIR_EraseRootFromParent_Done,
     /* 377065 */   // Label 5868: @377065
     /* 377065 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(377194), // Rule ID 11815 //
     /* 377070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 377098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 377110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 377114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 377119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 377124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377151 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377192 */     GIR_RootConstrainSelectedInstOperands,
     /* 377193 */     // GIR_Coverage, 11815,
     /* 377193 */     GIR_EraseRootFromParent_Done,
     /* 377194 */   // Label 5869: @377194
     /* 377194 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(377323), // Rule ID 11797 //
     /* 377199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377243 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 377248 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 377253 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377280 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377321 */     GIR_RootConstrainSelectedInstOperands,
     /* 377322 */     // GIR_Coverage, 11797,
     /* 377322 */     GIR_EraseRootFromParent_Done,
     /* 377323 */   // Label 5870: @377323
     /* 377323 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(377452), // Rule ID 11798 //
     /* 377328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377372 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 377377 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 377382 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377409 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377450 */     GIR_RootConstrainSelectedInstOperands,
     /* 377451 */     // GIR_Coverage, 11798,
     /* 377451 */     GIR_EraseRootFromParent_Done,
     /* 377452 */   // Label 5871: @377452
     /* 377452 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(377581), // Rule ID 11801 //
     /* 377457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 377506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 377511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377538 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377579 */     GIR_RootConstrainSelectedInstOperands,
     /* 377580 */     // GIR_Coverage, 11801,
     /* 377580 */     GIR_EraseRootFromParent_Done,
     /* 377581 */   // Label 5872: @377581
     /* 377581 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(377710), // Rule ID 11802 //
     /* 377586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 377630 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 377635 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 377640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377667 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 377677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 377682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 377687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 377692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377708 */     GIR_RootConstrainSelectedInstOperands,
     /* 377709 */     // GIR_Coverage, 11802,
     /* 377709 */     GIR_EraseRootFromParent_Done,
     /* 377710 */   // Label 5873: @377710
     /* 377710 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(377839), // Rule ID 11782 //
     /* 377715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 377759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 377764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 377769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377796 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377837 */     GIR_RootConstrainSelectedInstOperands,
     /* 377838 */     // GIR_Coverage, 11782,
     /* 377838 */     GIR_EraseRootFromParent_Done,
     /* 377839 */   // Label 5874: @377839
     /* 377839 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(377968), // Rule ID 11783 //
     /* 377844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 377876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 377880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 377888 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 377888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 377893 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 377893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 377898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 377902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377918 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 377925 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 377925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 377928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 377930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 377935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 377940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 377945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 377950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 377955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 377960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377966 */     GIR_RootConstrainSelectedInstOperands,
     /* 377967 */     // GIR_Coverage, 11783,
     /* 377967 */     GIR_EraseRootFromParent_Done,
     /* 377968 */   // Label 5875: @377968
     /* 377968 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(378097), // Rule ID 11786 //
     /* 377973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 377977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 377985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 377993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378017 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378022 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378027 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378054 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378095 */     GIR_RootConstrainSelectedInstOperands,
     /* 378096 */     // GIR_Coverage, 11786,
     /* 378096 */     GIR_EraseRootFromParent_Done,
     /* 378097 */   // Label 5876: @378097
     /* 378097 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(378226), // Rule ID 11787 //
     /* 378102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378183 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378224 */     GIR_RootConstrainSelectedInstOperands,
     /* 378225 */     // GIR_Coverage, 11787,
     /* 378225 */     GIR_EraseRootFromParent_Done,
     /* 378226 */   // Label 5877: @378226
     /* 378226 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(378355), // Rule ID 7740 //
     /* 378231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 378275 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378280 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378312 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378353 */     GIR_RootConstrainSelectedInstOperands,
     /* 378354 */     // GIR_Coverage, 7740,
     /* 378354 */     GIR_EraseRootFromParent_Done,
     /* 378355 */   // Label 5878: @378355
     /* 378355 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(378484), // Rule ID 11796 //
     /* 378360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 378404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378441 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378482 */     GIR_RootConstrainSelectedInstOperands,
     /* 378483 */     // GIR_Coverage, 11796,
     /* 378483 */     GIR_EraseRootFromParent_Done,
     /* 378484 */   // Label 5879: @378484
     /* 378484 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(378613), // Rule ID 11799 //
     /* 378489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 378533 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378533 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378538 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378543 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378570 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378611 */     GIR_RootConstrainSelectedInstOperands,
     /* 378612 */     // GIR_Coverage, 11799,
     /* 378612 */     GIR_EraseRootFromParent_Done,
     /* 378613 */   // Label 5880: @378613
     /* 378613 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(378742), // Rule ID 11800 //
     /* 378618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 378662 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378667 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378672 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378699 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 378709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 378714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 378719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 378724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378740 */     GIR_RootConstrainSelectedInstOperands,
     /* 378741 */     // GIR_Coverage, 11800,
     /* 378741 */     GIR_EraseRootFromParent_Done,
     /* 378742 */   // Label 5881: @378742
     /* 378742 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(378871), // Rule ID 7739 //
     /* 378747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378828 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378869 */     GIR_RootConstrainSelectedInstOperands,
     /* 378870 */     // GIR_Coverage, 7739,
     /* 378870 */     GIR_EraseRootFromParent_Done,
     /* 378871 */   // Label 5882: @378871
     /* 378871 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(379000), // Rule ID 11781 //
     /* 378876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 378880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 378892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 378896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 378904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 378912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 378920 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 378920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 378925 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 378925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 378930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 378934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 378957 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 378957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 378960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 378962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 378967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 378972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 378977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 378982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 378987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 378992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378998 */     GIR_RootConstrainSelectedInstOperands,
     /* 378999 */     // GIR_Coverage, 11781,
     /* 378999 */     GIR_EraseRootFromParent_Done,
     /* 379000 */   // Label 5883: @379000
     /* 379000 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(379129), // Rule ID 11784 //
     /* 379005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 379049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 379054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 379059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379086 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 379106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 379111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379127 */     GIR_RootConstrainSelectedInstOperands,
     /* 379128 */     // GIR_Coverage, 11784,
     /* 379128 */     GIR_EraseRootFromParent_Done,
     /* 379129 */   // Label 5884: @379129
     /* 379129 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(379258), // Rule ID 11785 //
     /* 379134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 379178 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 379183 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 379188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379194 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379215 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 379235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 379240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 379245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 379250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379256 */     GIR_RootConstrainSelectedInstOperands,
     /* 379257 */     // GIR_Coverage, 11785,
     /* 379257 */     GIR_EraseRootFromParent_Done,
     /* 379258 */   // Label 5885: @379258
     /* 379258 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(379387), // Rule ID 11867 //
     /* 379263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 379291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379307 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379307 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379312 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379317 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379344 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379385 */     GIR_RootConstrainSelectedInstOperands,
     /* 379386 */     // GIR_Coverage, 11867,
     /* 379386 */     GIR_EraseRootFromParent_Done,
     /* 379387 */   // Label 5886: @379387
     /* 379387 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(379516), // Rule ID 11868 //
     /* 379392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 379420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379473 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379514 */     GIR_RootConstrainSelectedInstOperands,
     /* 379515 */     // GIR_Coverage, 11868,
     /* 379515 */     GIR_EraseRootFromParent_Done,
     /* 379516 */   // Label 5887: @379516
     /* 379516 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(379645), // Rule ID 11869 //
     /* 379521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 379549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379565 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379570 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379602 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 379612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 379617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379643 */     GIR_RootConstrainSelectedInstOperands,
     /* 379644 */     // GIR_Coverage, 11869,
     /* 379644 */     GIR_EraseRootFromParent_Done,
     /* 379645 */   // Label 5888: @379645
     /* 379645 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(379774), // Rule ID 11870 //
     /* 379650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 379678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 379694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379731 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 379741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 379746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 379751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 379756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379772 */     GIR_RootConstrainSelectedInstOperands,
     /* 379773 */     // GIR_Coverage, 11870,
     /* 379773 */     GIR_EraseRootFromParent_Done,
     /* 379774 */   // Label 5889: @379774
     /* 379774 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(379903), // Rule ID 11807 //
     /* 379779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 379807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379823 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379828 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379833 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379837 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379860 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 379875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 379880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 379885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 379890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 379895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379901 */     GIR_RootConstrainSelectedInstOperands,
     /* 379902 */     // GIR_Coverage, 11807,
     /* 379902 */     GIR_EraseRootFromParent_Done,
     /* 379903 */   // Label 5890: @379903
     /* 379903 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(380032), // Rule ID 11808 //
     /* 379908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 379912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 379928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 379936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 379944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 379952 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 379952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 379957 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 379957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 379962 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 379966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 379989 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 379989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 379992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 379994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 379999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 380009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 380014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380030 */     GIR_RootConstrainSelectedInstOperands,
     /* 380031 */     // GIR_Coverage, 11808,
     /* 380031 */     GIR_EraseRootFromParent_Done,
     /* 380032 */   // Label 5891: @380032
     /* 380032 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(380161), // Rule ID 11809 //
     /* 380037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380118 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 380121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 380128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 380133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380159 */     GIR_RootConstrainSelectedInstOperands,
     /* 380160 */     // GIR_Coverage, 11809,
     /* 380160 */     GIR_EraseRootFromParent_Done,
     /* 380161 */   // Label 5892: @380161
     /* 380161 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(380290), // Rule ID 11810 //
     /* 380166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 380194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380210 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380215 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380247 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 380250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 380257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 380262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380288 */     GIR_RootConstrainSelectedInstOperands,
     /* 380289 */     // GIR_Coverage, 11810,
     /* 380289 */     GIR_EraseRootFromParent_Done,
     /* 380290 */   // Label 5893: @380290
     /* 380290 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(380419), // Rule ID 11852 //
     /* 380295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 380323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380362 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380376 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 380379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 380386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 380396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 380401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380417 */     GIR_RootConstrainSelectedInstOperands,
     /* 380418 */     // GIR_Coverage, 11852,
     /* 380418 */     GIR_EraseRootFromParent_Done,
     /* 380419 */   // Label 5894: @380419
     /* 380419 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(380548), // Rule ID 11853 //
     /* 380424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 380452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380468 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380468 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380473 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380505 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 380508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 380515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 380525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 380530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380546 */     GIR_RootConstrainSelectedInstOperands,
     /* 380547 */     // GIR_Coverage, 11853,
     /* 380547 */     GIR_EraseRootFromParent_Done,
     /* 380548 */   // Label 5895: @380548
     /* 380548 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(380677), // Rule ID 11854 //
     /* 380553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 380581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380597 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380602 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380607 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380634 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 380637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 380644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 380649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380675 */     GIR_RootConstrainSelectedInstOperands,
     /* 380676 */     // GIR_Coverage, 11854,
     /* 380676 */     GIR_EraseRootFromParent_Done,
     /* 380677 */   // Label 5896: @380677
     /* 380677 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(380806), // Rule ID 11855 //
     /* 380682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 380710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 380726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380763 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 380766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 380773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 380778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 380783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 380788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380804 */     GIR_RootConstrainSelectedInstOperands,
     /* 380805 */     // GIR_Coverage, 11855,
     /* 380805 */     GIR_EraseRootFromParent_Done,
     /* 380806 */   // Label 5897: @380806
     /* 380806 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(380935), // Rule ID 11792 //
     /* 380811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 380839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380855 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380860 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 380892 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 380892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 380895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 380897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 380902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 380907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 380912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 380917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 380922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 380927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380933 */     GIR_RootConstrainSelectedInstOperands,
     /* 380934 */     // GIR_Coverage, 11792,
     /* 380934 */     GIR_EraseRootFromParent_Done,
     /* 380935 */   // Label 5898: @380935
     /* 380935 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(381064), // Rule ID 11793 //
     /* 380940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 380944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 380960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 380968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 380976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 380984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 380984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 380989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 380989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 380994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 380998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381021 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 381041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 381046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 381051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 381056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381062 */     GIR_RootConstrainSelectedInstOperands,
     /* 381063 */     // GIR_Coverage, 11793,
     /* 381063 */     GIR_EraseRootFromParent_Done,
     /* 381064 */   // Label 5899: @381064
     /* 381064 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(381193), // Rule ID 11794 //
     /* 381069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 381097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 381105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381113 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381113 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 381118 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 381123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 381127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381150 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 381160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 381165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 381180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 381185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381191 */     GIR_RootConstrainSelectedInstOperands,
     /* 381192 */     // GIR_Coverage, 11794,
     /* 381192 */     GIR_EraseRootFromParent_Done,
     /* 381193 */   // Label 5900: @381193
     /* 381193 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(381322), // Rule ID 11795 //
     /* 381198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 381226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 381234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381242 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 381247 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 381252 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 381256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381279 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 381289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 381294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 381309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 381314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381320 */     GIR_RootConstrainSelectedInstOperands,
     /* 381321 */     // GIR_Coverage, 11795,
     /* 381321 */     GIR_EraseRootFromParent_Done,
     /* 381322 */   // Label 5901: @381322
     /* 381322 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(381451), // Rule ID 11863 //
     /* 381327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 381363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 381376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 381381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 381385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381408 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381449 */     GIR_RootConstrainSelectedInstOperands,
     /* 381450 */     // GIR_Coverage, 11863,
     /* 381450 */     GIR_EraseRootFromParent_Done,
     /* 381451 */   // Label 5902: @381451
     /* 381451 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(381580), // Rule ID 11864 //
     /* 381456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 381492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381500 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 381505 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 381510 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 381514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381537 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381578 */     GIR_RootConstrainSelectedInstOperands,
     /* 381579 */     // GIR_Coverage, 11864,
     /* 381579 */     GIR_EraseRootFromParent_Done,
     /* 381580 */   // Label 5903: @381580
     /* 381580 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(381709), // Rule ID 11865 //
     /* 381585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 381621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 381634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 381639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 381643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381666 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381707 */     GIR_RootConstrainSelectedInstOperands,
     /* 381708 */     // GIR_Coverage, 11865,
     /* 381708 */     GIR_EraseRootFromParent_Done,
     /* 381709 */   // Label 5904: @381709
     /* 381709 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(381838), // Rule ID 11866 //
     /* 381714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 381750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 381758 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 381763 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 381768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 381772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381795 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 381805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 381810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 381815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 381820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381836 */     GIR_RootConstrainSelectedInstOperands,
     /* 381837 */     // GIR_Coverage, 11866,
     /* 381837 */     GIR_EraseRootFromParent_Done,
     /* 381838 */   // Label 5905: @381838
     /* 381838 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(381967), // Rule ID 11803 //
     /* 381843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 381871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 381879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381887 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 381887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 381892 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 381892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 381897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 381901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 381924 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 381924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 381927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 381929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 381934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 381939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 381944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 381949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 381954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 381959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381965 */     GIR_RootConstrainSelectedInstOperands,
     /* 381966 */     // GIR_Coverage, 11803,
     /* 381966 */     GIR_EraseRootFromParent_Done,
     /* 381967 */   // Label 5906: @381967
     /* 381967 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(382096), // Rule ID 11804 //
     /* 381972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 381976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 381984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 381992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382053 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382094 */     GIR_RootConstrainSelectedInstOperands,
     /* 382095 */     // GIR_Coverage, 11804,
     /* 382095 */     GIR_EraseRootFromParent_Done,
     /* 382096 */   // Label 5907: @382096
     /* 382096 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(382225), // Rule ID 11805 //
     /* 382101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 382121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382145 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382150 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382182 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382223 */     GIR_RootConstrainSelectedInstOperands,
     /* 382224 */     // GIR_Coverage, 11805,
     /* 382224 */     GIR_EraseRootFromParent_Done,
     /* 382225 */   // Label 5908: @382225
     /* 382225 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(382354), // Rule ID 11806 //
     /* 382230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 382250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 382258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382311 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382352 */     GIR_RootConstrainSelectedInstOperands,
     /* 382353 */     // GIR_Coverage, 11806,
     /* 382353 */     GIR_EraseRootFromParent_Done,
     /* 382354 */   // Label 5909: @382354
     /* 382354 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(382483), // Rule ID 11848 //
     /* 382359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 382379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 382387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 382403 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382408 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382440 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382481 */     GIR_RootConstrainSelectedInstOperands,
     /* 382482 */     // GIR_Coverage, 11848,
     /* 382482 */     GIR_EraseRootFromParent_Done,
     /* 382483 */   // Label 5910: @382483
     /* 382483 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(382612), // Rule ID 11849 //
     /* 382488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 382508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 382516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 382532 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382537 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382569 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382610 */     GIR_RootConstrainSelectedInstOperands,
     /* 382611 */     // GIR_Coverage, 11849,
     /* 382611 */     GIR_EraseRootFromParent_Done,
     /* 382612 */   // Label 5911: @382612
     /* 382612 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(382741), // Rule ID 11850 //
     /* 382617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 382637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 382645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 382661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382698 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382739 */     GIR_RootConstrainSelectedInstOperands,
     /* 382740 */     // GIR_Coverage, 11850,
     /* 382740 */     GIR_EraseRootFromParent_Done,
     /* 382741 */   // Label 5912: @382741
     /* 382741 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(382870), // Rule ID 11851 //
     /* 382746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 382766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 382774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 382790 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382795 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382827 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 382837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 382842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 382847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 382852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382868 */     GIR_RootConstrainSelectedInstOperands,
     /* 382869 */     // GIR_Coverage, 11851,
     /* 382869 */     GIR_EraseRootFromParent_Done,
     /* 382870 */   // Label 5913: @382870
     /* 382870 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(382999), // Rule ID 11788 //
     /* 382875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 382879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 382895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 382903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 382907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 382911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 382919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 382919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 382924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 382924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 382929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 382933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 382956 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 382956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 382959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 382961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 382966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 382971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 382976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 382981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 382986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 382991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382997 */     GIR_RootConstrainSelectedInstOperands,
     /* 382998 */     // GIR_Coverage, 11788,
     /* 382998 */     GIR_EraseRootFromParent_Done,
     /* 382999 */   // Label 5914: @382999
     /* 382999 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(383128), // Rule ID 11789 //
     /* 383004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 383024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 383032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 383040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383048 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383048 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 383053 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 383058 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 383062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383085 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 383088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383126 */     GIR_RootConstrainSelectedInstOperands,
     /* 383127 */     // GIR_Coverage, 11789,
     /* 383127 */     GIR_EraseRootFromParent_Done,
     /* 383128 */   // Label 5915: @383128
     /* 383128 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(383257), // Rule ID 11790 //
     /* 383133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 383153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 383161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 383169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383177 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 383182 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 383187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 383191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383214 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 383217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383255 */     GIR_RootConstrainSelectedInstOperands,
     /* 383256 */     // GIR_Coverage, 11790,
     /* 383256 */     GIR_EraseRootFromParent_Done,
     /* 383257 */   // Label 5916: @383257
     /* 383257 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(383386), // Rule ID 11791 //
     /* 383262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 383282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 383290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 383298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 383306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 383311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 383311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 383316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 383320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383343 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 383346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 383363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 383368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383384 */     GIR_RootConstrainSelectedInstOperands,
     /* 383385 */     // GIR_Coverage, 11791,
     /* 383385 */     GIR_EraseRootFromParent_Done,
     /* 383386 */   // Label 5917: @383386
     /* 383386 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(383498), // Rule ID 13390 //
     /* 383391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 383394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 383406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 383418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 383426 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 383428 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 383432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383455 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 383458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 383475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 383480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 383485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 383490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383496 */     GIR_RootConstrainSelectedInstOperands,
     /* 383497 */     // GIR_Coverage, 13390,
     /* 383497 */     GIR_EraseRootFromParent_Done,
     /* 383498 */   // Label 5918: @383498
     /* 383498 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(383610), // Rule ID 13389 //
     /* 383503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 383506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 383518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 383538 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 383540 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 383544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383567 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 383570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 383587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 383592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 383597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 383602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383608 */     GIR_RootConstrainSelectedInstOperands,
     /* 383609 */     // GIR_Coverage, 13389,
     /* 383609 */     GIR_EraseRootFromParent_Done,
     /* 383610 */   // Label 5919: @383610
     /* 383610 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(383722), // Rule ID 7864 //
     /* 383615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 383618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 383630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 383642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 383650 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 383652 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 383656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383679 */     // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 383682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383720 */     GIR_RootConstrainSelectedInstOperands,
     /* 383721 */     // GIR_Coverage, 7864,
     /* 383721 */     GIR_EraseRootFromParent_Done,
     /* 383722 */   // Label 5920: @383722
     /* 383722 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(383834), // Rule ID 7863 //
     /* 383727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 383730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 383742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 383758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 383762 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 383764 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 383768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383791 */     // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 383794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 383801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 383806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 383811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 383816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 383821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 383826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383832 */     GIR_RootConstrainSelectedInstOperands,
     /* 383833 */     // GIR_Coverage, 7863,
     /* 383833 */     GIR_EraseRootFromParent_Done,
     /* 383834 */   // Label 5921: @383834
     /* 383834 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(383930), // Rule ID 13382 //
     /* 383839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 383842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 383854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 383862 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 383864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383887 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 383890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 383907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 383912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 383917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 383922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383928 */     GIR_RootConstrainSelectedInstOperands,
     /* 383929 */     // GIR_Coverage, 13382,
     /* 383929 */     GIR_EraseRootFromParent_Done,
     /* 383930 */   // Label 5922: @383930
     /* 383930 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(384026), // Rule ID 13381 //
     /* 383935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 383938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 383942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 383950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 383954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 383958 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 383960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 383983 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 383983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 383986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 383988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 383993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 383998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 384003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 384008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 384013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 384018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384024 */     GIR_RootConstrainSelectedInstOperands,
     /* 384025 */     // GIR_Coverage, 13381,
     /* 384025 */     GIR_EraseRootFromParent_Done,
     /* 384026 */   // Label 5923: @384026
     /* 384026 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(384122), // Rule ID 7856 //
     /* 384031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 384034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 384054 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 384056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384079 */     // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 384082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384120 */     GIR_RootConstrainSelectedInstOperands,
     /* 384121 */     // GIR_Coverage, 7856,
     /* 384121 */     GIR_EraseRootFromParent_Done,
     /* 384122 */   // Label 5924: @384122
     /* 384122 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(384218), // Rule ID 7855 //
     /* 384127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 384130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 384142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 384150 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 384152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384175 */     // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 384178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384216 */     GIR_RootConstrainSelectedInstOperands,
     /* 384217 */     // GIR_Coverage, 7855,
     /* 384217 */     GIR_EraseRootFromParent_Done,
     /* 384218 */   // Label 5925: @384218
     /* 384218 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(384253), // Rule ID 91 //
     /* 384223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 384226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 384230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 384234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 384238 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13744),
     /* 384242 */     // (fminnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13744>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 384242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
     /* 384247 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 384251 */     GIR_RootConstrainSelectedInstOperands,
     /* 384252 */     // GIR_Coverage, 91,
     /* 384252 */     GIR_Done,
     /* 384253 */   // Label 5926: @384253
     /* 384253 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(384313), // Rule ID 802 //
     /* 384258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 384269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384276 */     // (fminnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 384276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 384279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 384286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 384296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 384306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 384311 */     GIR_RootConstrainSelectedInstOperands,
     /* 384312 */     // GIR_Coverage, 802,
     /* 384312 */     GIR_EraseRootFromParent_Done,
     /* 384313 */   // Label 5927: @384313
     /* 384313 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(384373), // Rule ID 8556 //
     /* 384318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 384336 */     // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 384336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 384339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 384346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 384356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 384366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 384371 */     GIR_RootConstrainSelectedInstOperands,
     /* 384372 */     // GIR_Coverage, 8556,
     /* 384372 */     GIR_EraseRootFromParent_Done,
     /* 384373 */   // Label 5928: @384373
     /* 384373 */   GIM_Reject,
     /* 384374 */ // Label 5789: @384374
     /* 384374 */ GIM_Reject,
     /* 384375 */ // Label 5379: @384375
     /* 384375 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(384627),
     /* 384380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 384383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 384386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 384390 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(384449), // Rule ID 917 //
     /* 384395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 384398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 384405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384412 */     // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 384412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 384415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 384422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 384432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 384442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 384447 */     GIR_RootConstrainSelectedInstOperands,
     /* 384448 */     // GIR_Coverage, 917,
     /* 384448 */     GIR_EraseRootFromParent_Done,
     /* 384449 */   // Label 5930: @384449
     /* 384449 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(384508), // Rule ID 936 //
     /* 384454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 384457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 384464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384471 */     // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 384471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 384474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 384481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 384491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 384501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 384506 */     GIR_RootConstrainSelectedInstOperands,
     /* 384507 */     // GIR_Coverage, 936,
     /* 384507 */     GIR_EraseRootFromParent_Done,
     /* 384508 */   // Label 5931: @384508
     /* 384508 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(384567), // Rule ID 8582 //
     /* 384513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 384516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 384530 */     // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 384530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 384533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 384540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 384550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 384560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 384565 */     GIR_RootConstrainSelectedInstOperands,
     /* 384566 */     // GIR_Coverage, 8582,
     /* 384566 */     GIR_EraseRootFromParent_Done,
     /* 384567 */   // Label 5932: @384567
     /* 384567 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(384626), // Rule ID 8596 //
     /* 384572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 384575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 384589 */     // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 384589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 384592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 384599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 384604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 384609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 384614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 384619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 384624 */     GIR_RootConstrainSelectedInstOperands,
     /* 384625 */     // GIR_Coverage, 8596,
     /* 384625 */     GIR_EraseRootFromParent_Done,
     /* 384626 */   // Label 5933: @384626
     /* 384626 */   GIM_Reject,
     /* 384627 */ // Label 5929: @384627
     /* 384627 */ GIM_Reject,
     /* 384628 */ // Label 5380: @384628
     /* 384628 */ GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(384699), // Rule ID 1098 //
     /* 384633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 384636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 384639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384643 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 384650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 384657 */   // (fminnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 384657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
     /* 384660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 384667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 384677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384697 */   GIR_RootConstrainSelectedInstOperands,
     /* 384698 */   // GIR_Coverage, 1098,
     /* 384698 */   GIR_EraseRootFromParent_Done,
     /* 384699 */ // Label 5934: @384699
     /* 384699 */ GIM_Reject,
     /* 384700 */ // Label 5381: @384700
     /* 384700 */ GIM_Reject,
     /* 384701 */ // Label 81: @384701
     /* 384701 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5939*/ GIMT_Encode4(456479),
     /* 384712 */ /*GILLT_s16*//*Label 5935*/ GIMT_Encode4(384728),
     /* 384716 */ /*GILLT_s32*//*Label 5936*/ GIMT_Encode4(438642),
     /* 384720 */ /*GILLT_s64*//*Label 5937*/ GIMT_Encode4(456154),
     /* 384724 */ /*GILLT_v2s16*//*Label 5938*/ GIMT_Encode4(456407),
     /* 384728 */ // Label 5935: @384728
     /* 384728 */ GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(438641),
     /* 384733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 384736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384739 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(384874), // Rule ID 12157 //
     /* 384744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 384747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384828 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384872 */     GIR_RootConstrainSelectedInstOperands,
     /* 384873 */     // GIR_Coverage, 12157,
     /* 384873 */     GIR_EraseRootFromParent_Done,
     /* 384874 */   // Label 5941: @384874
     /* 384874 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(385009), // Rule ID 12158 //
     /* 384879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 384882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 384886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 384902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 384910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 384914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 384918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 384926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 384926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 384931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 384931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 384936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 384940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 384963 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 384963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 384966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 384968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 384973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 384978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 384983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 384988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 384993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 384998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385007 */     GIR_RootConstrainSelectedInstOperands,
     /* 385008 */     // GIR_Coverage, 12158,
     /* 385008 */     GIR_EraseRootFromParent_Done,
     /* 385009 */   // Label 5942: @385009
     /* 385009 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(385144), // Rule ID 12161 //
     /* 385014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385098 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385142 */     GIR_RootConstrainSelectedInstOperands,
     /* 385143 */     // GIR_Coverage, 12161,
     /* 385143 */     GIR_EraseRootFromParent_Done,
     /* 385144 */   // Label 5943: @385144
     /* 385144 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(385279), // Rule ID 12162 //
     /* 385149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 385152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385233 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 385236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385277 */     GIR_RootConstrainSelectedInstOperands,
     /* 385278 */     // GIR_Coverage, 12162,
     /* 385278 */     GIR_EraseRootFromParent_Done,
     /* 385279 */   // Label 5944: @385279
     /* 385279 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(385414), // Rule ID 12637 //
     /* 385284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 385287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 385291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385368 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 385371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385412 */     GIR_RootConstrainSelectedInstOperands,
     /* 385413 */     // GIR_Coverage, 12637,
     /* 385413 */     GIR_EraseRootFromParent_Done,
     /* 385414 */   // Label 5945: @385414
     /* 385414 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(385549), // Rule ID 12638 //
     /* 385419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 385422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 385426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385503 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 385506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385547 */     GIR_RootConstrainSelectedInstOperands,
     /* 385548 */     // GIR_Coverage, 12638,
     /* 385548 */     GIR_EraseRootFromParent_Done,
     /* 385549 */   // Label 5946: @385549
     /* 385549 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(385684), // Rule ID 12641 //
     /* 385554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 385557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 385561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385638 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 385641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385682 */     GIR_RootConstrainSelectedInstOperands,
     /* 385683 */     // GIR_Coverage, 12641,
     /* 385683 */     GIR_EraseRootFromParent_Done,
     /* 385684 */   // Label 5947: @385684
     /* 385684 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(385819), // Rule ID 12642 //
     /* 385689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 385692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 385696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385773 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 385776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 385783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 385788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 385793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 385798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385817 */     GIR_RootConstrainSelectedInstOperands,
     /* 385818 */     // GIR_Coverage, 12642,
     /* 385818 */     GIR_EraseRootFromParent_Done,
     /* 385819 */   // Label 5948: @385819
     /* 385819 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(385954), // Rule ID 13117 //
     /* 385824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 385871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 385871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 385876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 385876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 385881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 385885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 385908 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 385908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 385911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 385913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 385918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 385923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 385928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 385933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 385938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 385943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385952 */     GIR_RootConstrainSelectedInstOperands,
     /* 385953 */     // GIR_Coverage, 13117,
     /* 385953 */     GIR_EraseRootFromParent_Done,
     /* 385954 */   // Label 5949: @385954
     /* 385954 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(386089), // Rule ID 13118 //
     /* 385959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 385962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 385966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 385978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 385982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 385990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 385994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 385998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 386006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386043 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386087 */     GIR_RootConstrainSelectedInstOperands,
     /* 386088 */     // GIR_Coverage, 13118,
     /* 386088 */     GIR_EraseRootFromParent_Done,
     /* 386089 */   // Label 5950: @386089
     /* 386089 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(386224), // Rule ID 13121 //
     /* 386094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 386141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386178 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386222 */     GIR_RootConstrainSelectedInstOperands,
     /* 386223 */     // GIR_Coverage, 13121,
     /* 386223 */     GIR_EraseRootFromParent_Done,
     /* 386224 */   // Label 5951: @386224
     /* 386224 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(386359), // Rule ID 13122 //
     /* 386229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 386232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 386276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386313 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 386316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386357 */     GIR_RootConstrainSelectedInstOperands,
     /* 386358 */     // GIR_Coverage, 13122,
     /* 386358 */     GIR_EraseRootFromParent_Done,
     /* 386359 */   // Label 5952: @386359
     /* 386359 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(386494), // Rule ID 12142 //
     /* 386364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386448 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 386451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386492 */     GIR_RootConstrainSelectedInstOperands,
     /* 386493 */     // GIR_Coverage, 12142,
     /* 386493 */     GIR_EraseRootFromParent_Done,
     /* 386494 */   // Label 5953: @386494
     /* 386494 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(386629), // Rule ID 12143 //
     /* 386499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386583 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 386586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 386598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 386603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 386608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386627 */     GIR_RootConstrainSelectedInstOperands,
     /* 386628 */     // GIR_Coverage, 12143,
     /* 386628 */     GIR_EraseRootFromParent_Done,
     /* 386629 */   // Label 5954: @386629
     /* 386629 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(386764), // Rule ID 12146 //
     /* 386634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386718 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 386721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386762 */     GIR_RootConstrainSelectedInstOperands,
     /* 386763 */     // GIR_Coverage, 12146,
     /* 386763 */     GIR_EraseRootFromParent_Done,
     /* 386764 */   // Label 5955: @386764
     /* 386764 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(386899), // Rule ID 12147 //
     /* 386769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 386772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 386776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386853 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 386856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 386863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 386868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 386873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 386878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 386883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 386888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386897 */     GIR_RootConstrainSelectedInstOperands,
     /* 386898 */     // GIR_Coverage, 12147,
     /* 386898 */     GIR_EraseRootFromParent_Done,
     /* 386899 */   // Label 5956: @386899
     /* 386899 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(387034), // Rule ID 12622 //
     /* 386904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 386907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 386911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 386927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 386935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 386943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 386951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 386951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 386956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 386956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 386961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 386965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 386988 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 386988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 386991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 386993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 386998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387032 */     GIR_RootConstrainSelectedInstOperands,
     /* 387033 */     // GIR_Coverage, 12622,
     /* 387033 */     GIR_EraseRootFromParent_Done,
     /* 387034 */   // Label 5957: @387034
     /* 387034 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(387169), // Rule ID 12623 //
     /* 387039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387123 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387167 */     GIR_RootConstrainSelectedInstOperands,
     /* 387168 */     // GIR_Coverage, 12623,
     /* 387168 */     GIR_EraseRootFromParent_Done,
     /* 387169 */   // Label 5958: @387169
     /* 387169 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(387304), // Rule ID 12626 //
     /* 387174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387258 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387302 */     GIR_RootConstrainSelectedInstOperands,
     /* 387303 */     // GIR_Coverage, 12626,
     /* 387303 */     GIR_EraseRootFromParent_Done,
     /* 387304 */   // Label 5959: @387304
     /* 387304 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(387439), // Rule ID 12627 //
     /* 387309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 387312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 387316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387393 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 387396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387437 */     GIR_RootConstrainSelectedInstOperands,
     /* 387438 */     // GIR_Coverage, 12627,
     /* 387438 */     GIR_EraseRootFromParent_Done,
     /* 387439 */   // Label 5960: @387439
     /* 387439 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(387574), // Rule ID 13102 //
     /* 387444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 387447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387528 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 387531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387572 */     GIR_RootConstrainSelectedInstOperands,
     /* 387573 */     // GIR_Coverage, 13102,
     /* 387573 */     GIR_EraseRootFromParent_Done,
     /* 387574 */   // Label 5961: @387574
     /* 387574 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(387709), // Rule ID 13103 //
     /* 387579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 387582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387663 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 387666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 387673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 387678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 387683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 387688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387707 */     GIR_RootConstrainSelectedInstOperands,
     /* 387708 */     // GIR_Coverage, 13103,
     /* 387708 */     GIR_EraseRootFromParent_Done,
     /* 387709 */   // Label 5962: @387709
     /* 387709 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(387844), // Rule ID 13106 //
     /* 387714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 387717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387798 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 387801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387842 */     GIR_RootConstrainSelectedInstOperands,
     /* 387843 */     // GIR_Coverage, 13106,
     /* 387843 */     GIR_EraseRootFromParent_Done,
     /* 387844 */   // Label 5963: @387844
     /* 387844 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(387979), // Rule ID 13107 //
     /* 387849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 387852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 387868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 387872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 387884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 387888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 387896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 387896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 387901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 387901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 387906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 387910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 387933 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 387933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 387936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 387938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 387943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 387948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 387953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 387958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 387963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 387968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387977 */     GIR_RootConstrainSelectedInstOperands,
     /* 387978 */     // GIR_Coverage, 13107,
     /* 387978 */     GIR_EraseRootFromParent_Done,
     /* 387979 */   // Label 5964: @387979
     /* 387979 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(388114), // Rule ID 7764 //
     /* 387984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 387987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 387991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 387999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388068 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388112 */     GIR_RootConstrainSelectedInstOperands,
     /* 388113 */     // GIR_Coverage, 7764,
     /* 388113 */     GIR_EraseRootFromParent_Done,
     /* 388114 */   // Label 5965: @388114
     /* 388114 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(388249), // Rule ID 7796 //
     /* 388119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 388122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 388126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388166 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388171 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388203 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 388206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388247 */     GIR_RootConstrainSelectedInstOperands,
     /* 388248 */     // GIR_Coverage, 7796,
     /* 388248 */     GIR_EraseRootFromParent_Done,
     /* 388249 */   // Label 5966: @388249
     /* 388249 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(388384), // Rule ID 7828 //
     /* 388254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 388257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388338 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 388341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388382 */     GIR_RootConstrainSelectedInstOperands,
     /* 388383 */     // GIR_Coverage, 7828,
     /* 388383 */     GIR_EraseRootFromParent_Done,
     /* 388384 */   // Label 5967: @388384
     /* 388384 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(388519), // Rule ID 12156 //
     /* 388389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388473 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388517 */     GIR_RootConstrainSelectedInstOperands,
     /* 388518 */     // GIR_Coverage, 12156,
     /* 388518 */     GIR_EraseRootFromParent_Done,
     /* 388519 */   // Label 5968: @388519
     /* 388519 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(388654), // Rule ID 12159 //
     /* 388524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388608 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388652 */     GIR_RootConstrainSelectedInstOperands,
     /* 388653 */     // GIR_Coverage, 12159,
     /* 388653 */     GIR_EraseRootFromParent_Done,
     /* 388654 */   // Label 5969: @388654
     /* 388654 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(388789), // Rule ID 12160 //
     /* 388659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 388662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 388666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388743 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 388746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 388753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 388758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 388763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 388768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388787 */     GIR_RootConstrainSelectedInstOperands,
     /* 388788 */     // GIR_Coverage, 12160,
     /* 388788 */     GIR_EraseRootFromParent_Done,
     /* 388789 */   // Label 5970: @388789
     /* 388789 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(388924), // Rule ID 12636 //
     /* 388794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 388797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 388801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388841 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388846 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388878 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 388878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 388881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 388883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 388888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 388893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 388898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 388903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 388908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 388913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388922 */     GIR_RootConstrainSelectedInstOperands,
     /* 388923 */     // GIR_Coverage, 12636,
     /* 388923 */     GIR_EraseRootFromParent_Done,
     /* 388924 */   // Label 5971: @388924
     /* 388924 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(389059), // Rule ID 12639 //
     /* 388929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 388932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 388936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 388952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 388960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 388968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 388972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 388976 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 388976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 388981 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 388981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 388986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 388990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 388999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389013 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389057 */     GIR_RootConstrainSelectedInstOperands,
     /* 389058 */     // GIR_Coverage, 12639,
     /* 389058 */     GIR_EraseRootFromParent_Done,
     /* 389059 */   // Label 5972: @389059
     /* 389059 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(389194), // Rule ID 12640 //
     /* 389064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 389107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 389111 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389116 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389148 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389192 */     GIR_RootConstrainSelectedInstOperands,
     /* 389193 */     // GIR_Coverage, 12640,
     /* 389193 */     GIR_EraseRootFromParent_Done,
     /* 389194 */   // Label 5973: @389194
     /* 389194 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(389329), // Rule ID 13116 //
     /* 389199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 389242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 389246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389283 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389327 */     GIR_RootConstrainSelectedInstOperands,
     /* 389328 */     // GIR_Coverage, 13116,
     /* 389328 */     GIR_EraseRootFromParent_Done,
     /* 389329 */   // Label 5974: @389329
     /* 389329 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(389464), // Rule ID 13119 //
     /* 389334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 389377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 389381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389418 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389462 */     GIR_RootConstrainSelectedInstOperands,
     /* 389463 */     // GIR_Coverage, 13119,
     /* 389463 */     GIR_EraseRootFromParent_Done,
     /* 389464 */   // Label 5975: @389464
     /* 389464 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(389599), // Rule ID 13120 //
     /* 389469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 389512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 389516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389553 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 389563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 389568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 389573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 389578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389597 */     GIR_RootConstrainSelectedInstOperands,
     /* 389598 */     // GIR_Coverage, 13120,
     /* 389598 */     GIR_EraseRootFromParent_Done,
     /* 389599 */   // Label 5976: @389599
     /* 389599 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(389734), // Rule ID 7763 //
     /* 389604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 389607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 389647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389688 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 389691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389732 */     GIR_RootConstrainSelectedInstOperands,
     /* 389733 */     // GIR_Coverage, 7763,
     /* 389733 */     GIR_EraseRootFromParent_Done,
     /* 389734 */   // Label 5977: @389734
     /* 389734 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(389869), // Rule ID 7795 //
     /* 389739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 389742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 389746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 389782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389786 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389791 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389823 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 389826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389867 */     GIR_RootConstrainSelectedInstOperands,
     /* 389868 */     // GIR_Coverage, 7795,
     /* 389868 */     GIR_EraseRootFromParent_Done,
     /* 389869 */   // Label 5978: @389869
     /* 389869 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(390004), // Rule ID 7827 //
     /* 389874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 389877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 389881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 389897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 389905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 389913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 389917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 389921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 389921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 389926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 389926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 389931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 389935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 389958 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 389958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 389961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 389963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 389968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 389973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 389978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 389983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 389988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 389993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390002 */     GIR_RootConstrainSelectedInstOperands,
     /* 390003 */     // GIR_Coverage, 7827,
     /* 390003 */     GIR_EraseRootFromParent_Done,
     /* 390004 */   // Label 5979: @390004
     /* 390004 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(390139), // Rule ID 12141 //
     /* 390009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390093 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390137 */     GIR_RootConstrainSelectedInstOperands,
     /* 390138 */     // GIR_Coverage, 12141,
     /* 390138 */     GIR_EraseRootFromParent_Done,
     /* 390139 */   // Label 5980: @390139
     /* 390139 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(390274), // Rule ID 12144 //
     /* 390144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390228 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390272 */     GIR_RootConstrainSelectedInstOperands,
     /* 390273 */     // GIR_Coverage, 12144,
     /* 390273 */     GIR_EraseRootFromParent_Done,
     /* 390274 */   // Label 5981: @390274
     /* 390274 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(390409), // Rule ID 12145 //
     /* 390279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 390282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390363 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 390366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390407 */     GIR_RootConstrainSelectedInstOperands,
     /* 390408 */     // GIR_Coverage, 12145,
     /* 390408 */     GIR_EraseRootFromParent_Done,
     /* 390409 */   // Label 5982: @390409
     /* 390409 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(390544), // Rule ID 12621 //
     /* 390414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 390417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 390421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390461 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390466 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390498 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 390501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390542 */     GIR_RootConstrainSelectedInstOperands,
     /* 390543 */     // GIR_Coverage, 12621,
     /* 390543 */     GIR_EraseRootFromParent_Done,
     /* 390544 */   // Label 5983: @390544
     /* 390544 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(390679), // Rule ID 12624 //
     /* 390549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 390552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 390556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390596 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390601 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390633 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 390636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390677 */     GIR_RootConstrainSelectedInstOperands,
     /* 390678 */     // GIR_Coverage, 12624,
     /* 390678 */     GIR_EraseRootFromParent_Done,
     /* 390679 */   // Label 5984: @390679
     /* 390679 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(390814), // Rule ID 12625 //
     /* 390684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 390687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 390691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390731 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390736 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390768 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 390771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 390778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 390783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 390788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 390793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390812 */     GIR_RootConstrainSelectedInstOperands,
     /* 390813 */     // GIR_Coverage, 12625,
     /* 390813 */     GIR_EraseRootFromParent_Done,
     /* 390814 */   // Label 5985: @390814
     /* 390814 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(390949), // Rule ID 13101 //
     /* 390819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 390822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 390866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 390866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 390871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 390871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 390876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 390880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 390903 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 390903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 390906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 390908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 390913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 390918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 390923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 390928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 390933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 390938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390947 */     GIR_RootConstrainSelectedInstOperands,
     /* 390948 */     // GIR_Coverage, 13101,
     /* 390948 */     GIR_EraseRootFromParent_Done,
     /* 390949 */   // Label 5986: @390949
     /* 390949 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(391084), // Rule ID 13104 //
     /* 390954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 390957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 390961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 390977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 390985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 390993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 390997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 391001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391038 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391082 */     GIR_RootConstrainSelectedInstOperands,
     /* 391083 */     // GIR_Coverage, 13104,
     /* 391083 */     GIR_EraseRootFromParent_Done,
     /* 391084 */   // Label 5987: @391084
     /* 391084 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(391219), // Rule ID 13105 //
     /* 391089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 391092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 391136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391173 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 391176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391217 */     GIR_RootConstrainSelectedInstOperands,
     /* 391218 */     // GIR_Coverage, 13105,
     /* 391218 */     GIR_EraseRootFromParent_Done,
     /* 391219 */   // Label 5988: @391219
     /* 391219 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(391354), // Rule ID 12127 //
     /* 391224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 391227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391308 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 391311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391352 */     GIR_RootConstrainSelectedInstOperands,
     /* 391353 */     // GIR_Coverage, 12127,
     /* 391353 */     GIR_EraseRootFromParent_Done,
     /* 391354 */   // Label 5989: @391354
     /* 391354 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(391489), // Rule ID 12128 //
     /* 391359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 391362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391443 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 391446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391487 */     GIR_RootConstrainSelectedInstOperands,
     /* 391488 */     // GIR_Coverage, 12128,
     /* 391488 */     GIR_EraseRootFromParent_Done,
     /* 391489 */   // Label 5990: @391489
     /* 391489 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(391624), // Rule ID 12131 //
     /* 391494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 391497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391578 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 391581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391622 */     GIR_RootConstrainSelectedInstOperands,
     /* 391623 */     // GIR_Coverage, 12131,
     /* 391623 */     GIR_EraseRootFromParent_Done,
     /* 391624 */   // Label 5991: @391624
     /* 391624 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(391759), // Rule ID 12132 //
     /* 391629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 391632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 391636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391713 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 391716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 391723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 391728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 391733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 391738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391757 */     GIR_RootConstrainSelectedInstOperands,
     /* 391758 */     // GIR_Coverage, 12132,
     /* 391758 */     GIR_EraseRootFromParent_Done,
     /* 391759 */   // Label 5992: @391759
     /* 391759 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(391894), // Rule ID 12607 //
     /* 391764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 391767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 391771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391848 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 391868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 391873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 391878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 391883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391892 */     GIR_RootConstrainSelectedInstOperands,
     /* 391893 */     // GIR_Coverage, 12607,
     /* 391893 */     GIR_EraseRootFromParent_Done,
     /* 391894 */   // Label 5993: @391894
     /* 391894 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(392029), // Rule ID 12608 //
     /* 391899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 391902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 391906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 391914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 391922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 391930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 391938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 391946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 391946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 391951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 391951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 391956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 391960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 391983 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 391983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 391986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 391988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 391993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 391998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392027 */     GIR_RootConstrainSelectedInstOperands,
     /* 392028 */     // GIR_Coverage, 12608,
     /* 392028 */     GIR_EraseRootFromParent_Done,
     /* 392029 */   // Label 5994: @392029
     /* 392029 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(392164), // Rule ID 12611 //
     /* 392034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 392081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392118 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392162 */     GIR_RootConstrainSelectedInstOperands,
     /* 392163 */     // GIR_Coverage, 12611,
     /* 392163 */     GIR_EraseRootFromParent_Done,
     /* 392164 */   // Label 5995: @392164
     /* 392164 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(392299), // Rule ID 12612 //
     /* 392169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 392172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 392176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 392216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392253 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 392256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392297 */     GIR_RootConstrainSelectedInstOperands,
     /* 392298 */     // GIR_Coverage, 12612,
     /* 392298 */     GIR_EraseRootFromParent_Done,
     /* 392299 */   // Label 5996: @392299
     /* 392299 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(392434), // Rule ID 13087 //
     /* 392304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 392307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 392351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392388 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 392391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392432 */     GIR_RootConstrainSelectedInstOperands,
     /* 392433 */     // GIR_Coverage, 13087,
     /* 392433 */     GIR_EraseRootFromParent_Done,
     /* 392434 */   // Label 5997: @392434
     /* 392434 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(392569), // Rule ID 13088 //
     /* 392439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 392442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 392486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392523 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 392526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392567 */     GIR_RootConstrainSelectedInstOperands,
     /* 392568 */     // GIR_Coverage, 13088,
     /* 392568 */     GIR_EraseRootFromParent_Done,
     /* 392569 */   // Label 5998: @392569
     /* 392569 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(392704), // Rule ID 13091 //
     /* 392574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 392577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 392621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392658 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 392661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392702 */     GIR_RootConstrainSelectedInstOperands,
     /* 392703 */     // GIR_Coverage, 13091,
     /* 392703 */     GIR_EraseRootFromParent_Done,
     /* 392704 */   // Label 5999: @392704
     /* 392704 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(392839), // Rule ID 13092 //
     /* 392709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 392712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 392756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392793 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 392796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 392803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 392808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 392813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 392818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392837 */     GIR_RootConstrainSelectedInstOperands,
     /* 392838 */     // GIR_Coverage, 13092,
     /* 392838 */     GIR_EraseRootFromParent_Done,
     /* 392839 */   // Label 6000: @392839
     /* 392839 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(392974), // Rule ID 12112 //
     /* 392844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 392867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 392875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 392883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 392887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 392891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 392891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 392896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 392896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 392901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 392905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 392907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 392928 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 392928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 392931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 392933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 392938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 392943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 392948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 392953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 392958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 392963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392972 */     GIR_RootConstrainSelectedInstOperands,
     /* 392973 */     // GIR_Coverage, 12112,
     /* 392973 */     GIR_EraseRootFromParent_Done,
     /* 392974 */   // Label 6001: @392974
     /* 392974 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(393109), // Rule ID 12113 //
     /* 392979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 392982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 392986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 392994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393063 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 393073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 393078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 393083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 393088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393107 */     GIR_RootConstrainSelectedInstOperands,
     /* 393108 */     // GIR_Coverage, 12113,
     /* 393108 */     GIR_EraseRootFromParent_Done,
     /* 393109 */   // Label 6002: @393109
     /* 393109 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(393244), // Rule ID 12116 //
     /* 393114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393198 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393242 */     GIR_RootConstrainSelectedInstOperands,
     /* 393243 */     // GIR_Coverage, 12116,
     /* 393243 */     GIR_EraseRootFromParent_Done,
     /* 393244 */   // Label 6003: @393244
     /* 393244 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(393379), // Rule ID 12117 //
     /* 393249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 393252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393333 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 393336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393377 */     GIR_RootConstrainSelectedInstOperands,
     /* 393378 */     // GIR_Coverage, 12117,
     /* 393378 */     GIR_EraseRootFromParent_Done,
     /* 393379 */   // Label 6004: @393379
     /* 393379 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(393514), // Rule ID 12592 //
     /* 393384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 393387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 393391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393468 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 393471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 393478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 393483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 393488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 393493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393512 */     GIR_RootConstrainSelectedInstOperands,
     /* 393513 */     // GIR_Coverage, 12592,
     /* 393513 */     GIR_EraseRootFromParent_Done,
     /* 393514 */   // Label 6005: @393514
     /* 393514 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(393649), // Rule ID 12593 //
     /* 393519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 393522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 393526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393603 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 393606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 393613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 393618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 393623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 393628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393647 */     GIR_RootConstrainSelectedInstOperands,
     /* 393648 */     // GIR_Coverage, 12593,
     /* 393648 */     GIR_EraseRootFromParent_Done,
     /* 393649 */   // Label 6006: @393649
     /* 393649 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(393784), // Rule ID 12596 //
     /* 393654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 393657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 393661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393738 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 393741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393782 */     GIR_RootConstrainSelectedInstOperands,
     /* 393783 */     // GIR_Coverage, 12596,
     /* 393783 */     GIR_EraseRootFromParent_Done,
     /* 393784 */   // Label 6007: @393784
     /* 393784 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(393919), // Rule ID 12597 //
     /* 393789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 393792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 393796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393873 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 393873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 393876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 393878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 393883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 393888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 393893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 393898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 393903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 393908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 393917 */     GIR_RootConstrainSelectedInstOperands,
     /* 393918 */     // GIR_Coverage, 12597,
     /* 393918 */     GIR_EraseRootFromParent_Done,
     /* 393919 */   // Label 6008: @393919
     /* 393919 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(394054), // Rule ID 13072 //
     /* 393924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 393927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 393931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 393939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 393943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 393947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 393955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 393959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 393963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 393967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 393971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 393971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 393976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 393981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 393985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 393994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394008 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 394018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 394023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394052 */     GIR_RootConstrainSelectedInstOperands,
     /* 394053 */     // GIR_Coverage, 13072,
     /* 394053 */     GIR_EraseRootFromParent_Done,
     /* 394054 */   // Label 6009: @394054
     /* 394054 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(394189), // Rule ID 13073 //
     /* 394059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 394102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 394106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 394111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394143 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 394153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 394158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394187 */     GIR_RootConstrainSelectedInstOperands,
     /* 394188 */     // GIR_Coverage, 13073,
     /* 394188 */     GIR_EraseRootFromParent_Done,
     /* 394189 */   // Label 6010: @394189
     /* 394189 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(394324), // Rule ID 13076 //
     /* 394194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 394237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 394241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 394246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394278 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 394298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 394303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394322 */     GIR_RootConstrainSelectedInstOperands,
     /* 394323 */     // GIR_Coverage, 13076,
     /* 394323 */     GIR_EraseRootFromParent_Done,
     /* 394324 */   // Label 6011: @394324
     /* 394324 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(394459), // Rule ID 13077 //
     /* 394329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 394372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 394376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 394386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394413 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 394423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 394428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 394433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 394438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394457 */     GIR_RootConstrainSelectedInstOperands,
     /* 394458 */     // GIR_Coverage, 13077,
     /* 394458 */     GIR_EraseRootFromParent_Done,
     /* 394459 */   // Label 6012: @394459
     /* 394459 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(394594), // Rule ID 7762 //
     /* 394464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 394467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 394507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 394521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394548 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 394551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 394558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 394563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394592 */     GIR_RootConstrainSelectedInstOperands,
     /* 394593 */     // GIR_Coverage, 7762,
     /* 394593 */     GIR_EraseRootFromParent_Done,
     /* 394594 */   // Label 6013: @394594
     /* 394594 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(394729), // Rule ID 7794 //
     /* 394599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 394602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 394606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 394642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394646 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394651 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 394656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394683 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 394686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 394693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 394698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394727 */     GIR_RootConstrainSelectedInstOperands,
     /* 394728 */     // GIR_Coverage, 7794,
     /* 394728 */     GIR_EraseRootFromParent_Done,
     /* 394729 */   // Label 6014: @394729
     /* 394729 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(394864), // Rule ID 7826 //
     /* 394734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 394737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 394777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 394791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394818 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 394821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 394828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 394833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394862 */     GIR_RootConstrainSelectedInstOperands,
     /* 394863 */     // GIR_Coverage, 7826,
     /* 394863 */     GIR_EraseRootFromParent_Done,
     /* 394864 */   // Label 6015: @394864
     /* 394864 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(394999), // Rule ID 12126 //
     /* 394869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 394872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 394876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 394884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 394888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 394892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 394900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 394904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 394908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 394912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 394916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 394916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 394921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 394921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 394930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 394953 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 394953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 394956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 394958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 394963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 394968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 394973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 394978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 394983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 394988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 394997 */     GIR_RootConstrainSelectedInstOperands,
     /* 394998 */     // GIR_Coverage, 12126,
     /* 394998 */     GIR_EraseRootFromParent_Done,
     /* 394999 */   // Label 6016: @394999
     /* 394999 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(395134), // Rule ID 12129 //
     /* 395004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 395056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395088 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 395108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 395113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 395118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 395123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395132 */     GIR_RootConstrainSelectedInstOperands,
     /* 395133 */     // GIR_Coverage, 12129,
     /* 395133 */     GIR_EraseRootFromParent_Done,
     /* 395134 */   // Label 6017: @395134
     /* 395134 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(395269), // Rule ID 12130 //
     /* 395139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 395142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 395196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395223 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 395226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 395243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 395248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 395253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 395258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395267 */     GIR_RootConstrainSelectedInstOperands,
     /* 395268 */     // GIR_Coverage, 12130,
     /* 395268 */     GIR_EraseRootFromParent_Done,
     /* 395269 */   // Label 6018: @395269
     /* 395269 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(395404), // Rule ID 12606 //
     /* 395274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395321 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 395326 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395358 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 395368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 395373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 395388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 395393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395402 */     GIR_RootConstrainSelectedInstOperands,
     /* 395403 */     // GIR_Coverage, 12606,
     /* 395403 */     GIR_EraseRootFromParent_Done,
     /* 395404 */   // Label 6019: @395404
     /* 395404 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(395539), // Rule ID 12609 //
     /* 395409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395456 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 395461 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395493 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 395513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 395518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 395523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 395528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395537 */     GIR_RootConstrainSelectedInstOperands,
     /* 395538 */     // GIR_Coverage, 12609,
     /* 395538 */     GIR_EraseRootFromParent_Done,
     /* 395539 */   // Label 6020: @395539
     /* 395539 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(395674), // Rule ID 12610 //
     /* 395544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 395547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 395551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395591 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395596 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 395601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395628 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 395631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 395648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 395653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 395658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 395663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395672 */     GIR_RootConstrainSelectedInstOperands,
     /* 395673 */     // GIR_Coverage, 12610,
     /* 395673 */     GIR_EraseRootFromParent_Done,
     /* 395674 */   // Label 6021: @395674
     /* 395674 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(395809), // Rule ID 13086 //
     /* 395679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 395682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 395731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395763 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 395766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 395773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 395778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 395783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 395788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 395793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 395798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395807 */     GIR_RootConstrainSelectedInstOperands,
     /* 395808 */     // GIR_Coverage, 13086,
     /* 395808 */     GIR_EraseRootFromParent_Done,
     /* 395809 */   // Label 6022: @395809
     /* 395809 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(395944), // Rule ID 13089 //
     /* 395814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 395817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 395861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 395866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 395875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 395877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 395898 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 395898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 395901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 395903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 395908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 395913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 395918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 395923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 395928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 395933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 395942 */     GIR_RootConstrainSelectedInstOperands,
     /* 395943 */     // GIR_Coverage, 13089,
     /* 395943 */     GIR_EraseRootFromParent_Done,
     /* 395944 */   // Label 6023: @395944
     /* 395944 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(396079), // Rule ID 13090 //
     /* 395949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 395952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 395956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 395964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 395968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 395972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 395980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 395984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 395988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 395992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 395996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 395996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396033 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 396053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 396058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 396063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 396068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396077 */     GIR_RootConstrainSelectedInstOperands,
     /* 396078 */     // GIR_Coverage, 13090,
     /* 396078 */     GIR_EraseRootFromParent_Done,
     /* 396079 */   // Label 6024: @396079
     /* 396079 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(396214), // Rule ID 7761 //
     /* 396084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 396127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396168 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 396178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 396183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 396198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 396203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396212 */     GIR_RootConstrainSelectedInstOperands,
     /* 396213 */     // GIR_Coverage, 7761,
     /* 396213 */     GIR_EraseRootFromParent_Done,
     /* 396214 */   // Label 6025: @396214
     /* 396214 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(396349), // Rule ID 7793 //
     /* 396219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 396222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 396226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 396262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396266 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396271 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396303 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 396306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 396313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 396318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 396333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 396338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396347 */     GIR_RootConstrainSelectedInstOperands,
     /* 396348 */     // GIR_Coverage, 7793,
     /* 396348 */     GIR_EraseRootFromParent_Done,
     /* 396349 */   // Label 6026: @396349
     /* 396349 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(396484), // Rule ID 7825 //
     /* 396354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 396357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 396397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396438 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 396441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 396448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 396453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 396468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 396473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396482 */     GIR_RootConstrainSelectedInstOperands,
     /* 396483 */     // GIR_Coverage, 7825,
     /* 396483 */     GIR_EraseRootFromParent_Done,
     /* 396484 */   // Label 6027: @396484
     /* 396484 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(396619), // Rule ID 12111 //
     /* 396489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 396532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396573 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 396583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 396588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 396598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 396603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 396608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396617 */     GIR_RootConstrainSelectedInstOperands,
     /* 396618 */     // GIR_Coverage, 12111,
     /* 396618 */     GIR_EraseRootFromParent_Done,
     /* 396619 */   // Label 6028: @396619
     /* 396619 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(396754), // Rule ID 12114 //
     /* 396624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 396667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396708 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 396728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 396733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 396738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 396743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396752 */     GIR_RootConstrainSelectedInstOperands,
     /* 396753 */     // GIR_Coverage, 12114,
     /* 396753 */     GIR_EraseRootFromParent_Done,
     /* 396754 */   // Label 6029: @396754
     /* 396754 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(396889), // Rule ID 12115 //
     /* 396759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 396762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 396766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 396802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396843 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 396846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 396853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 396858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 396863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 396868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 396873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 396878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396887 */     GIR_RootConstrainSelectedInstOperands,
     /* 396888 */     // GIR_Coverage, 12115,
     /* 396888 */     GIR_EraseRootFromParent_Done,
     /* 396889 */   // Label 6030: @396889
     /* 396889 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(397024), // Rule ID 12591 //
     /* 396894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 396897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 396901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 396909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 396913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 396917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 396925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 396929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 396933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 396937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 396941 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 396941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 396946 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 396946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 396955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 396978 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 396978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 396981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 396983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 396988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 396993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 396998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 397008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 397013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397022 */     GIR_RootConstrainSelectedInstOperands,
     /* 397023 */     // GIR_Coverage, 12591,
     /* 397023 */     GIR_EraseRootFromParent_Done,
     /* 397024 */   // Label 6031: @397024
     /* 397024 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(397159), // Rule ID 12594 //
     /* 397029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 397060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 397072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397076 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 397081 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397113 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 397133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 397138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 397143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 397148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397157 */     GIR_RootConstrainSelectedInstOperands,
     /* 397158 */     // GIR_Coverage, 12594,
     /* 397158 */     GIR_EraseRootFromParent_Done,
     /* 397159 */   // Label 6032: @397159
     /* 397159 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(397294), // Rule ID 12595 //
     /* 397164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 397167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 397171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 397195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 397207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397211 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397216 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 397221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397248 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 397251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 397268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 397273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 397278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 397283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397292 */     GIR_RootConstrainSelectedInstOperands,
     /* 397293 */     // GIR_Coverage, 12595,
     /* 397293 */     GIR_EraseRootFromParent_Done,
     /* 397294 */   // Label 6033: @397294
     /* 397294 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(397429), // Rule ID 13071 //
     /* 397299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 397302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 397330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 397342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 397351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397383 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 397386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 397393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 397398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 397403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 397408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 397413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 397418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397427 */     GIR_RootConstrainSelectedInstOperands,
     /* 397428 */     // GIR_Coverage, 13071,
     /* 397428 */     GIR_EraseRootFromParent_Done,
     /* 397429 */   // Label 6034: @397429
     /* 397429 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(397564), // Rule ID 13074 //
     /* 397434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 397437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 397465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 397477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 397486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397518 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 397521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 397538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 397543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 397548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 397553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397562 */     GIR_RootConstrainSelectedInstOperands,
     /* 397563 */     // GIR_Coverage, 13074,
     /* 397563 */     GIR_EraseRootFromParent_Done,
     /* 397564 */   // Label 6035: @397564
     /* 397564 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(397699), // Rule ID 13075 //
     /* 397569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 397572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 397600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 397612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 397616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 397621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 397626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397653 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 397656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 397673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 397678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 397683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 397688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397697 */     GIR_RootConstrainSelectedInstOperands,
     /* 397698 */     // GIR_Coverage, 13075,
     /* 397698 */     GIR_EraseRootFromParent_Done,
     /* 397699 */   // Label 6036: @397699
     /* 397699 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(397834), // Rule ID 12167 //
     /* 397704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 397707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 397735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397788 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 397791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397832 */     GIR_RootConstrainSelectedInstOperands,
     /* 397833 */     // GIR_Coverage, 12167,
     /* 397833 */     GIR_EraseRootFromParent_Done,
     /* 397834 */   // Label 6037: @397834
     /* 397834 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(397969), // Rule ID 12168 //
     /* 397839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 397842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 397870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 397874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 397878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 397886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 397891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 397891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 397896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 397900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 397923 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 397923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 397926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 397928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 397933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 397938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 397943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 397948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 397953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 397958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397967 */     GIR_RootConstrainSelectedInstOperands,
     /* 397968 */     // GIR_Coverage, 12168,
     /* 397968 */     GIR_EraseRootFromParent_Done,
     /* 397969 */   // Label 6038: @397969
     /* 397969 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(398104), // Rule ID 12169 //
     /* 397974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 397977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 397981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 397989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 397993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 397997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398058 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398102 */     GIR_RootConstrainSelectedInstOperands,
     /* 398103 */     // GIR_Coverage, 12169,
     /* 398103 */     GIR_EraseRootFromParent_Done,
     /* 398104 */   // Label 6039: @398104
     /* 398104 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(398239), // Rule ID 12170 //
     /* 398109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 398112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398193 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 398196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398237 */     GIR_RootConstrainSelectedInstOperands,
     /* 398238 */     // GIR_Coverage, 12170,
     /* 398238 */     GIR_EraseRootFromParent_Done,
     /* 398239 */   // Label 6040: @398239
     /* 398239 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(398374), // Rule ID 12647 //
     /* 398244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398328 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 398331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398372 */     GIR_RootConstrainSelectedInstOperands,
     /* 398373 */     // GIR_Coverage, 12647,
     /* 398373 */     GIR_EraseRootFromParent_Done,
     /* 398374 */   // Label 6041: @398374
     /* 398374 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(398509), // Rule ID 12648 //
     /* 398379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398463 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 398466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398507 */     GIR_RootConstrainSelectedInstOperands,
     /* 398508 */     // GIR_Coverage, 12648,
     /* 398508 */     GIR_EraseRootFromParent_Done,
     /* 398509 */   // Label 6042: @398509
     /* 398509 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(398644), // Rule ID 12649 //
     /* 398514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398598 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 398601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398642 */     GIR_RootConstrainSelectedInstOperands,
     /* 398643 */     // GIR_Coverage, 12649,
     /* 398643 */     GIR_EraseRootFromParent_Done,
     /* 398644 */   // Label 6043: @398644
     /* 398644 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(398779), // Rule ID 12650 //
     /* 398649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 398652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 398656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398733 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 398736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 398743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 398748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 398753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 398758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398777 */     GIR_RootConstrainSelectedInstOperands,
     /* 398778 */     // GIR_Coverage, 12650,
     /* 398778 */     GIR_EraseRootFromParent_Done,
     /* 398779 */   // Label 6044: @398779
     /* 398779 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(398914), // Rule ID 13127 //
     /* 398784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 398787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398868 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 398868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 398871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 398873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 398878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 398883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 398888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 398893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 398898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 398903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398912 */     GIR_RootConstrainSelectedInstOperands,
     /* 398913 */     // GIR_Coverage, 13127,
     /* 398913 */     GIR_EraseRootFromParent_Done,
     /* 398914 */   // Label 6045: @398914
     /* 398914 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(399049), // Rule ID 13128 //
     /* 398919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 398922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 398926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 398938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 398942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 398950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 398954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 398958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 398966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 398966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 398971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 398971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 398976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 398980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 398996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399003 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399047 */     GIR_RootConstrainSelectedInstOperands,
     /* 399048 */     // GIR_Coverage, 13128,
     /* 399048 */     GIR_EraseRootFromParent_Done,
     /* 399049 */   // Label 6046: @399049
     /* 399049 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(399184), // Rule ID 13129 //
     /* 399054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399138 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399182 */     GIR_RootConstrainSelectedInstOperands,
     /* 399183 */     // GIR_Coverage, 13129,
     /* 399183 */     GIR_EraseRootFromParent_Done,
     /* 399184 */   // Label 6047: @399184
     /* 399184 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(399319), // Rule ID 13130 //
     /* 399189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 399192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399273 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 399276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399317 */     GIR_RootConstrainSelectedInstOperands,
     /* 399318 */     // GIR_Coverage, 13130,
     /* 399318 */     GIR_EraseRootFromParent_Done,
     /* 399319 */   // Label 6048: @399319
     /* 399319 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(399454), // Rule ID 12107 //
     /* 399324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 399327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399408 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 399411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399452 */     GIR_RootConstrainSelectedInstOperands,
     /* 399453 */     // GIR_Coverage, 12107,
     /* 399453 */     GIR_EraseRootFromParent_Done,
     /* 399454 */   // Label 6049: @399454
     /* 399454 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(399589), // Rule ID 12108 //
     /* 399459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 399462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399543 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 399546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399587 */     GIR_RootConstrainSelectedInstOperands,
     /* 399588 */     // GIR_Coverage, 12108,
     /* 399588 */     GIR_EraseRootFromParent_Done,
     /* 399589 */   // Label 6050: @399589
     /* 399589 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(399724), // Rule ID 12109 //
     /* 399594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 399597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399678 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 399681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399722 */     GIR_RootConstrainSelectedInstOperands,
     /* 399723 */     // GIR_Coverage, 12109,
     /* 399723 */     GIR_EraseRootFromParent_Done,
     /* 399724 */   // Label 6051: @399724
     /* 399724 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(399859), // Rule ID 12110 //
     /* 399729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 399732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 399736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399813 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 399816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 399823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 399828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 399833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 399838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399857 */     GIR_RootConstrainSelectedInstOperands,
     /* 399858 */     // GIR_Coverage, 12110,
     /* 399858 */     GIR_EraseRootFromParent_Done,
     /* 399859 */   // Label 6052: @399859
     /* 399859 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(399994), // Rule ID 12587 //
     /* 399864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 399867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 399871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 399879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 399883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 399887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 399895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 399899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 399903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 399907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 399911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 399911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 399916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 399916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 399921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 399925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 399948 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 399948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 399951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 399953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 399958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 399963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 399968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 399973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 399978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 399983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399992 */     GIR_RootConstrainSelectedInstOperands,
     /* 399993 */     // GIR_Coverage, 12587,
     /* 399993 */     GIR_EraseRootFromParent_Done,
     /* 399994 */   // Label 6053: @399994
     /* 399994 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(400129), // Rule ID 12588 //
     /* 399999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 400046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400083 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 400103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 400108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400127 */     GIR_RootConstrainSelectedInstOperands,
     /* 400128 */     // GIR_Coverage, 12588,
     /* 400128 */     GIR_EraseRootFromParent_Done,
     /* 400129 */   // Label 6054: @400129
     /* 400129 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(400264), // Rule ID 12589 //
     /* 400134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 400181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400218 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 400228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 400233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400262 */     GIR_RootConstrainSelectedInstOperands,
     /* 400263 */     // GIR_Coverage, 12589,
     /* 400263 */     GIR_EraseRootFromParent_Done,
     /* 400264 */   // Label 6055: @400264
     /* 400264 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(400399), // Rule ID 12590 //
     /* 400269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 400272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 400276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 400316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400353 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 400356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 400363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 400368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400397 */     GIR_RootConstrainSelectedInstOperands,
     /* 400398 */     // GIR_Coverage, 12590,
     /* 400398 */     GIR_EraseRootFromParent_Done,
     /* 400399 */   // Label 6056: @400399
     /* 400399 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(400534), // Rule ID 13067 //
     /* 400404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 400407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 400451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400488 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 400491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 400508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 400513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400532 */     GIR_RootConstrainSelectedInstOperands,
     /* 400533 */     // GIR_Coverage, 13067,
     /* 400533 */     GIR_EraseRootFromParent_Done,
     /* 400534 */   // Label 6057: @400534
     /* 400534 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(400669), // Rule ID 13068 //
     /* 400539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 400542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 400586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400623 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 400626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 400633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 400638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 400643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 400648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400667 */     GIR_RootConstrainSelectedInstOperands,
     /* 400668 */     // GIR_Coverage, 13068,
     /* 400668 */     GIR_EraseRootFromParent_Done,
     /* 400669 */   // Label 6058: @400669
     /* 400669 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(400804), // Rule ID 13069 //
     /* 400674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 400677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 400721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400758 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 400761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 400768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 400773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400802 */     GIR_RootConstrainSelectedInstOperands,
     /* 400803 */     // GIR_Coverage, 13069,
     /* 400803 */     GIR_EraseRootFromParent_Done,
     /* 400804 */   // Label 6059: @400804
     /* 400804 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(400939), // Rule ID 13070 //
     /* 400809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 400812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 400840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 400856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 400866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 400870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 400893 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 400893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 400896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 400898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 400903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 400908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 400913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 400918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 400923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 400928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400937 */     GIR_RootConstrainSelectedInstOperands,
     /* 400938 */     // GIR_Coverage, 13070,
     /* 400938 */     GIR_EraseRootFromParent_Done,
     /* 400939 */   // Label 6060: @400939
     /* 400939 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(401074), // Rule ID 12152 //
     /* 400944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 400947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 400951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 400963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 400967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 400975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 400979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 400983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 400987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 400991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 400991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 400996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 400996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401028 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 401048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 401053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 401058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 401063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401072 */     GIR_RootConstrainSelectedInstOperands,
     /* 401073 */     // GIR_Coverage, 12152,
     /* 401073 */     GIR_EraseRootFromParent_Done,
     /* 401074 */   // Label 6061: @401074
     /* 401074 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(401209), // Rule ID 12153 //
     /* 401079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 401110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401163 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 401183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 401188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 401193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 401198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401207 */     GIR_RootConstrainSelectedInstOperands,
     /* 401208 */     // GIR_Coverage, 12153,
     /* 401208 */     GIR_EraseRootFromParent_Done,
     /* 401209 */   // Label 6062: @401209
     /* 401209 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(401344), // Rule ID 12154 //
     /* 401214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 401245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401298 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 401308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 401313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 401328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 401333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401342 */     GIR_RootConstrainSelectedInstOperands,
     /* 401343 */     // GIR_Coverage, 12154,
     /* 401343 */     GIR_EraseRootFromParent_Done,
     /* 401344 */   // Label 6063: @401344
     /* 401344 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(401479), // Rule ID 12155 //
     /* 401349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 401352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 401356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 401380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401433 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 401436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 401443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 401448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 401463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 401468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401477 */     GIR_RootConstrainSelectedInstOperands,
     /* 401478 */     // GIR_Coverage, 12155,
     /* 401478 */     GIR_EraseRootFromParent_Done,
     /* 401479 */   // Label 6064: @401479
     /* 401479 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(401614), // Rule ID 12632 //
     /* 401484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 401487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 401491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 401515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401568 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 401571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 401588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 401593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 401598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 401603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401612 */     GIR_RootConstrainSelectedInstOperands,
     /* 401613 */     // GIR_Coverage, 12632,
     /* 401613 */     GIR_EraseRootFromParent_Done,
     /* 401614 */   // Label 6065: @401614
     /* 401614 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(401749), // Rule ID 12633 //
     /* 401619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 401622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 401626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 401650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401703 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 401706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 401713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 401718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 401723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 401728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 401733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 401738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401747 */     GIR_RootConstrainSelectedInstOperands,
     /* 401748 */     // GIR_Coverage, 12633,
     /* 401748 */     GIR_EraseRootFromParent_Done,
     /* 401749 */   // Label 6066: @401749
     /* 401749 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(401884), // Rule ID 12634 //
     /* 401754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 401757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 401761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 401785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401838 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 401841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 401848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 401853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 401868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 401873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 401882 */     GIR_RootConstrainSelectedInstOperands,
     /* 401883 */     // GIR_Coverage, 12634,
     /* 401883 */     GIR_EraseRootFromParent_Done,
     /* 401884 */   // Label 6067: @401884
     /* 401884 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(402019), // Rule ID 12635 //
     /* 401889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 401892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 401896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 401912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 401920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 401928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 401936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 401936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 401941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 401941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 401946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 401950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 401973 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 401973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 401976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 401978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 401983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 401988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 401993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 401998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402017 */     GIR_RootConstrainSelectedInstOperands,
     /* 402018 */     // GIR_Coverage, 12635,
     /* 402018 */     GIR_EraseRootFromParent_Done,
     /* 402019 */   // Label 6068: @402019
     /* 402019 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(402154), // Rule ID 13112 //
     /* 402024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 402055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402108 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 402128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 402133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402152 */     GIR_RootConstrainSelectedInstOperands,
     /* 402153 */     // GIR_Coverage, 13112,
     /* 402153 */     GIR_EraseRootFromParent_Done,
     /* 402154 */   // Label 6069: @402154
     /* 402154 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(402289), // Rule ID 13113 //
     /* 402159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 402190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402243 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 402263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 402268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402287 */     GIR_RootConstrainSelectedInstOperands,
     /* 402288 */     // GIR_Coverage, 13113,
     /* 402288 */     GIR_EraseRootFromParent_Done,
     /* 402289 */   // Label 6070: @402289
     /* 402289 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(402424), // Rule ID 13114 //
     /* 402294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 402325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402378 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 402388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 402393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402422 */     GIR_RootConstrainSelectedInstOperands,
     /* 402423 */     // GIR_Coverage, 13114,
     /* 402423 */     GIR_EraseRootFromParent_Done,
     /* 402424 */   // Label 6071: @402424
     /* 402424 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(402559), // Rule ID 13115 //
     /* 402429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 402432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 402460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402513 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 402516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 402523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 402528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402557 */     GIR_RootConstrainSelectedInstOperands,
     /* 402558 */     // GIR_Coverage, 13115,
     /* 402558 */     GIR_EraseRootFromParent_Done,
     /* 402559 */   // Label 6072: @402559
     /* 402559 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(402694), // Rule ID 12092 //
     /* 402564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 402567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 402595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402648 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 402651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 402668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 402673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402692 */     GIR_RootConstrainSelectedInstOperands,
     /* 402693 */     // GIR_Coverage, 12092,
     /* 402693 */     GIR_EraseRootFromParent_Done,
     /* 402694 */   // Label 6073: @402694
     /* 402694 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(402829), // Rule ID 12093 //
     /* 402699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 402702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 402730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402783 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 402786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 402793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 402798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 402803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 402808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402827 */     GIR_RootConstrainSelectedInstOperands,
     /* 402828 */     // GIR_Coverage, 12093,
     /* 402828 */     GIR_EraseRootFromParent_Done,
     /* 402829 */   // Label 6074: @402829
     /* 402829 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(402964), // Rule ID 12094 //
     /* 402834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 402837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 402865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 402873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 402881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 402881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 402886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 402886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 402891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 402895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 402918 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 402918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 402921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 402923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 402928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 402933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 402938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 402943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 402948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 402953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402962 */     GIR_RootConstrainSelectedInstOperands,
     /* 402963 */     // GIR_Coverage, 12094,
     /* 402963 */     GIR_EraseRootFromParent_Done,
     /* 402964 */   // Label 6075: @402964
     /* 402964 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(403099), // Rule ID 12095 //
     /* 402969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 402972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 402976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 402984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 402992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403053 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 403056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 403063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 403068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 403083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 403088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403097 */     GIR_RootConstrainSelectedInstOperands,
     /* 403098 */     // GIR_Coverage, 12095,
     /* 403098 */     GIR_EraseRootFromParent_Done,
     /* 403099 */   // Label 6076: @403099
     /* 403099 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(403234), // Rule ID 12572 //
     /* 403104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403188 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 403208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 403213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 403218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 403223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403232 */     GIR_RootConstrainSelectedInstOperands,
     /* 403233 */     // GIR_Coverage, 12572,
     /* 403233 */     GIR_EraseRootFromParent_Done,
     /* 403234 */   // Label 6077: @403234
     /* 403234 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(403369), // Rule ID 12573 //
     /* 403239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403323 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 403343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 403348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 403353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 403358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403367 */     GIR_RootConstrainSelectedInstOperands,
     /* 403368 */     // GIR_Coverage, 12573,
     /* 403368 */     GIR_EraseRootFromParent_Done,
     /* 403369 */   // Label 6078: @403369
     /* 403369 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(403504), // Rule ID 12574 //
     /* 403374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403458 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 403468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 403473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 403488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 403493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403502 */     GIR_RootConstrainSelectedInstOperands,
     /* 403503 */     // GIR_Coverage, 12574,
     /* 403503 */     GIR_EraseRootFromParent_Done,
     /* 403504 */   // Label 6079: @403504
     /* 403504 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(403639), // Rule ID 12575 //
     /* 403509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 403512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 403516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403593 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 403596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 403603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 403608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 403613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 403618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 403623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 403628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403637 */     GIR_RootConstrainSelectedInstOperands,
     /* 403638 */     // GIR_Coverage, 12575,
     /* 403638 */     GIR_EraseRootFromParent_Done,
     /* 403639 */   // Label 6080: @403639
     /* 403639 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(403774), // Rule ID 13052 //
     /* 403644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 403647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403728 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 403731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 403748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 403753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 403758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 403763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403772 */     GIR_RootConstrainSelectedInstOperands,
     /* 403773 */     // GIR_Coverage, 13052,
     /* 403773 */     GIR_EraseRootFromParent_Done,
     /* 403774 */   // Label 6081: @403774
     /* 403774 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(403909), // Rule ID 13053 //
     /* 403779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 403782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403863 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 403866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 403868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 403873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 403878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 403883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 403888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 403893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 403898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403907 */     GIR_RootConstrainSelectedInstOperands,
     /* 403908 */     // GIR_Coverage, 13053,
     /* 403908 */     GIR_EraseRootFromParent_Done,
     /* 403909 */   // Label 6082: @403909
     /* 403909 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(404044), // Rule ID 13054 //
     /* 403914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 403917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 403921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 403929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 403937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 403945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 403953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 403961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 403961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 403966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 403966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 403971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 403975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 403998 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 403998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 404008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 404013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 404028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 404033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404042 */     GIR_RootConstrainSelectedInstOperands,
     /* 404043 */     // GIR_Coverage, 13054,
     /* 404043 */     GIR_EraseRootFromParent_Done,
     /* 404044 */   // Label 6083: @404044
     /* 404044 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(404179), // Rule ID 13055 //
     /* 404049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 404052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 404080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 404096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404133 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 404136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 404143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 404148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 404163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 404168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404177 */     GIR_RootConstrainSelectedInstOperands,
     /* 404178 */     // GIR_Coverage, 13055,
     /* 404178 */     GIR_EraseRootFromParent_Done,
     /* 404179 */   // Label 6084: @404179
     /* 404179 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(404314), // Rule ID 12163 //
     /* 404184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 404215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404268 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 404271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404312 */     GIR_RootConstrainSelectedInstOperands,
     /* 404313 */     // GIR_Coverage, 12163,
     /* 404313 */     GIR_EraseRootFromParent_Done,
     /* 404314 */   // Label 6085: @404314
     /* 404314 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(404449), // Rule ID 12164 //
     /* 404319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 404350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404403 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 404406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404447 */     GIR_RootConstrainSelectedInstOperands,
     /* 404448 */     // GIR_Coverage, 12164,
     /* 404448 */     GIR_EraseRootFromParent_Done,
     /* 404449 */   // Label 6086: @404449
     /* 404449 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(404584), // Rule ID 12165 //
     /* 404454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 404485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404538 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 404541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404582 */     GIR_RootConstrainSelectedInstOperands,
     /* 404583 */     // GIR_Coverage, 12165,
     /* 404583 */     GIR_EraseRootFromParent_Done,
     /* 404584 */   // Label 6087: @404584
     /* 404584 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(404719), // Rule ID 12166 //
     /* 404589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 404592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 404596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 404620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404673 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 404676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 404683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 404688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 404693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 404698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404717 */     GIR_RootConstrainSelectedInstOperands,
     /* 404718 */     // GIR_Coverage, 12166,
     /* 404718 */     GIR_EraseRootFromParent_Done,
     /* 404719 */   // Label 6088: @404719
     /* 404719 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(404854), // Rule ID 12643 //
     /* 404724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 404727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 404731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 404755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404808 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 404811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404852 */     GIR_RootConstrainSelectedInstOperands,
     /* 404853 */     // GIR_Coverage, 12643,
     /* 404853 */     GIR_EraseRootFromParent_Done,
     /* 404854 */   // Label 6089: @404854
     /* 404854 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(404989), // Rule ID 12644 //
     /* 404859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 404862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 404866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 404882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 404890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 404894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 404898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 404906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 404906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 404911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 404911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 404916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 404920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 404943 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 404943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 404946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 404948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 404953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 404958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 404963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 404968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 404973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 404978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404987 */     GIR_RootConstrainSelectedInstOperands,
     /* 404988 */     // GIR_Coverage, 12644,
     /* 404988 */     GIR_EraseRootFromParent_Done,
     /* 404989 */   // Label 6090: @404989
     /* 404989 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(405124), // Rule ID 12645 //
     /* 404994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 404997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405078 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405122 */     GIR_RootConstrainSelectedInstOperands,
     /* 405123 */     // GIR_Coverage, 12645,
     /* 405123 */     GIR_EraseRootFromParent_Done,
     /* 405124 */   // Label 6091: @405124
     /* 405124 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(405259), // Rule ID 12646 //
     /* 405129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 405132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 405136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405213 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 405216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405257 */     GIR_RootConstrainSelectedInstOperands,
     /* 405258 */     // GIR_Coverage, 12646,
     /* 405258 */     GIR_EraseRootFromParent_Done,
     /* 405259 */   // Label 6092: @405259
     /* 405259 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(405394), // Rule ID 13123 //
     /* 405264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405348 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 405351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405392 */     GIR_RootConstrainSelectedInstOperands,
     /* 405393 */     // GIR_Coverage, 13123,
     /* 405393 */     GIR_EraseRootFromParent_Done,
     /* 405394 */   // Label 6093: @405394
     /* 405394 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(405529), // Rule ID 13124 //
     /* 405399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405483 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 405486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405527 */     GIR_RootConstrainSelectedInstOperands,
     /* 405528 */     // GIR_Coverage, 13124,
     /* 405528 */     GIR_EraseRootFromParent_Done,
     /* 405529 */   // Label 6094: @405529
     /* 405529 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(405664), // Rule ID 13125 //
     /* 405534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405618 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 405621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405662 */     GIR_RootConstrainSelectedInstOperands,
     /* 405663 */     // GIR_Coverage, 13125,
     /* 405663 */     GIR_EraseRootFromParent_Done,
     /* 405664 */   // Label 6095: @405664
     /* 405664 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(405799), // Rule ID 13126 //
     /* 405669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 405672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405726 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405753 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 405756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 405763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 405768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 405773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 405778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405797 */     GIR_RootConstrainSelectedInstOperands,
     /* 405798 */     // GIR_Coverage, 13126,
     /* 405798 */     GIR_EraseRootFromParent_Done,
     /* 405799 */   // Label 6096: @405799
     /* 405799 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(405934), // Rule ID 12103 //
     /* 405804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 405807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 405865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 405888 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 405888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 405891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 405893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 405898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 405903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 405908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 405913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 405918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 405923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 405932 */     GIR_RootConstrainSelectedInstOperands,
     /* 405933 */     // GIR_Coverage, 12103,
     /* 405933 */     GIR_EraseRootFromParent_Done,
     /* 405934 */   // Label 6097: @405934
     /* 405934 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(406069), // Rule ID 12104 //
     /* 405939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 405942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 405946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 405954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 405958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 405962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 405970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 405974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 405978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 405986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 405986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 405991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 405991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 405996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406023 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406067 */     GIR_RootConstrainSelectedInstOperands,
     /* 406068 */     // GIR_Coverage, 12104,
     /* 406068 */     GIR_EraseRootFromParent_Done,
     /* 406069 */   // Label 6098: @406069
     /* 406069 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(406204), // Rule ID 12105 //
     /* 406074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406158 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406202 */     GIR_RootConstrainSelectedInstOperands,
     /* 406203 */     // GIR_Coverage, 12105,
     /* 406203 */     GIR_EraseRootFromParent_Done,
     /* 406204 */   // Label 6099: @406204
     /* 406204 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(406339), // Rule ID 12106 //
     /* 406209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 406212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406293 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 406296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406337 */     GIR_RootConstrainSelectedInstOperands,
     /* 406338 */     // GIR_Coverage, 12106,
     /* 406338 */     GIR_EraseRootFromParent_Done,
     /* 406339 */   // Label 6100: @406339
     /* 406339 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(406474), // Rule ID 12583 //
     /* 406344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 406347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 406351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406428 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 406431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406472 */     GIR_RootConstrainSelectedInstOperands,
     /* 406473 */     // GIR_Coverage, 12583,
     /* 406473 */     GIR_EraseRootFromParent_Done,
     /* 406474 */   // Label 6101: @406474
     /* 406474 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(406609), // Rule ID 12584 //
     /* 406479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 406482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 406486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406563 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 406566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406607 */     GIR_RootConstrainSelectedInstOperands,
     /* 406608 */     // GIR_Coverage, 12584,
     /* 406608 */     GIR_EraseRootFromParent_Done,
     /* 406609 */   // Label 6102: @406609
     /* 406609 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(406744), // Rule ID 12585 //
     /* 406614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 406617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 406621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406698 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 406701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406742 */     GIR_RootConstrainSelectedInstOperands,
     /* 406743 */     // GIR_Coverage, 12585,
     /* 406743 */     GIR_EraseRootFromParent_Done,
     /* 406744 */   // Label 6103: @406744
     /* 406744 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(406879), // Rule ID 12586 //
     /* 406749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 406752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 406756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406833 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 406836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 406843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 406848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 406853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 406858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 406868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 406877 */     GIR_RootConstrainSelectedInstOperands,
     /* 406878 */     // GIR_Coverage, 12586,
     /* 406878 */     GIR_EraseRootFromParent_Done,
     /* 406879 */   // Label 6104: @406879
     /* 406879 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(407014), // Rule ID 13063 //
     /* 406884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 406887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 406891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 406899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 406903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 406907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 406915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 406919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 406923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 406931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 406931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 406936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 406936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 406941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 406945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 406968 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 406968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 406971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 406973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 406978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 406983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 406988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 406993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 406998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407012 */     GIR_RootConstrainSelectedInstOperands,
     /* 407013 */     // GIR_Coverage, 13063,
     /* 407013 */     GIR_EraseRootFromParent_Done,
     /* 407014 */   // Label 6105: @407014
     /* 407014 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(407149), // Rule ID 13064 //
     /* 407019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 407071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 407076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407103 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407147 */     GIR_RootConstrainSelectedInstOperands,
     /* 407148 */     // GIR_Coverage, 13064,
     /* 407148 */     GIR_EraseRootFromParent_Done,
     /* 407149 */   // Label 6106: @407149
     /* 407149 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(407284), // Rule ID 13065 //
     /* 407154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 407206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 407211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407238 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407282 */     GIR_RootConstrainSelectedInstOperands,
     /* 407283 */     // GIR_Coverage, 13065,
     /* 407283 */     GIR_EraseRootFromParent_Done,
     /* 407284 */   // Label 6107: @407284
     /* 407284 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(407419), // Rule ID 13066 //
     /* 407289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 407292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 407320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 407336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 407341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 407346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407373 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 407376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407417 */     GIR_RootConstrainSelectedInstOperands,
     /* 407418 */     // GIR_Coverage, 13066,
     /* 407418 */     GIR_EraseRootFromParent_Done,
     /* 407419 */   // Label 6108: @407419
     /* 407419 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(407554), // Rule ID 12148 //
     /* 407424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 407427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 407455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 407476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 407481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407508 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 407511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407552 */     GIR_RootConstrainSelectedInstOperands,
     /* 407553 */     // GIR_Coverage, 12148,
     /* 407553 */     GIR_EraseRootFromParent_Done,
     /* 407554 */   // Label 6109: @407554
     /* 407554 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(407689), // Rule ID 12149 //
     /* 407559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 407562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 407590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 407611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 407616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407643 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 407646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 407653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 407658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 407663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 407668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407687 */     GIR_RootConstrainSelectedInstOperands,
     /* 407688 */     // GIR_Coverage, 12149,
     /* 407688 */     GIR_EraseRootFromParent_Done,
     /* 407689 */   // Label 6110: @407689
     /* 407689 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(407824), // Rule ID 12150 //
     /* 407694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 407697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 407725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 407746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 407751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407778 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 407781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407822 */     GIR_RootConstrainSelectedInstOperands,
     /* 407823 */     // GIR_Coverage, 12150,
     /* 407823 */     GIR_EraseRootFromParent_Done,
     /* 407824 */   // Label 6111: @407824
     /* 407824 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(407959), // Rule ID 12151 //
     /* 407829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 407832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 407836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 407860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 407868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 407876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 407881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 407881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 407886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 407890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 407913 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 407913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 407916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 407918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 407923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 407928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 407933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 407938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 407943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 407948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407957 */     GIR_RootConstrainSelectedInstOperands,
     /* 407958 */     // GIR_Coverage, 12151,
     /* 407958 */     GIR_EraseRootFromParent_Done,
     /* 407959 */   // Label 6112: @407959
     /* 407959 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(408094), // Rule ID 12628 //
     /* 407964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 407967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 407971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 407979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 407983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 407987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 407995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 407999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408048 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408092 */     GIR_RootConstrainSelectedInstOperands,
     /* 408093 */     // GIR_Coverage, 12628,
     /* 408093 */     GIR_EraseRootFromParent_Done,
     /* 408094 */   // Label 6113: @408094
     /* 408094 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(408229), // Rule ID 12629 //
     /* 408099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408183 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408227 */     GIR_RootConstrainSelectedInstOperands,
     /* 408228 */     // GIR_Coverage, 12629,
     /* 408228 */     GIR_EraseRootFromParent_Done,
     /* 408229 */   // Label 6114: @408229
     /* 408229 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(408364), // Rule ID 12630 //
     /* 408234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408318 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408362 */     GIR_RootConstrainSelectedInstOperands,
     /* 408363 */     // GIR_Coverage, 12630,
     /* 408363 */     GIR_EraseRootFromParent_Done,
     /* 408364 */   // Label 6115: @408364
     /* 408364 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(408499), // Rule ID 12631 //
     /* 408369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 408372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 408376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408453 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 408456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408497 */     GIR_RootConstrainSelectedInstOperands,
     /* 408498 */     // GIR_Coverage, 12631,
     /* 408498 */     GIR_EraseRootFromParent_Done,
     /* 408499 */   // Label 6116: @408499
     /* 408499 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(408634), // Rule ID 13108 //
     /* 408504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 408507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408588 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 408591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408632 */     GIR_RootConstrainSelectedInstOperands,
     /* 408633 */     // GIR_Coverage, 13108,
     /* 408633 */     GIR_EraseRootFromParent_Done,
     /* 408634 */   // Label 6117: @408634
     /* 408634 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(408769), // Rule ID 13109 //
     /* 408639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 408642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408723 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 408726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 408733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 408738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 408743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 408748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408767 */     GIR_RootConstrainSelectedInstOperands,
     /* 408768 */     // GIR_Coverage, 13109,
     /* 408768 */     GIR_EraseRootFromParent_Done,
     /* 408769 */   // Label 6118: @408769
     /* 408769 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(408904), // Rule ID 13110 //
     /* 408774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 408777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408858 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 408861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 408868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 408873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 408878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 408883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 408888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 408893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408902 */     GIR_RootConstrainSelectedInstOperands,
     /* 408903 */     // GIR_Coverage, 13110,
     /* 408903 */     GIR_EraseRootFromParent_Done,
     /* 408904 */   // Label 6119: @408904
     /* 408904 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(409039), // Rule ID 13111 //
     /* 408909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 408912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 408916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 408928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 408932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 408940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 408944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 408948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 408956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 408956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 408961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 408961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 408966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 408970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 408993 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 408993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 408996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 408998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409037 */     GIR_RootConstrainSelectedInstOperands,
     /* 409038 */     // GIR_Coverage, 13111,
     /* 409038 */     GIR_EraseRootFromParent_Done,
     /* 409039 */   // Label 6120: @409039
     /* 409039 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(409174), // Rule ID 12088 //
     /* 409044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 409047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 409096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 409101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409128 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 409131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409172 */     GIR_RootConstrainSelectedInstOperands,
     /* 409173 */     // GIR_Coverage, 12088,
     /* 409173 */     GIR_EraseRootFromParent_Done,
     /* 409174 */   // Label 6121: @409174
     /* 409174 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(409309), // Rule ID 12089 //
     /* 409179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 409182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 409231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 409236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409263 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 409266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409307 */     GIR_RootConstrainSelectedInstOperands,
     /* 409308 */     // GIR_Coverage, 12089,
     /* 409308 */     GIR_EraseRootFromParent_Done,
     /* 409309 */   // Label 6122: @409309
     /* 409309 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(409444), // Rule ID 12090 //
     /* 409314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 409317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 409366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 409371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409398 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 409401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409442 */     GIR_RootConstrainSelectedInstOperands,
     /* 409443 */     // GIR_Coverage, 12090,
     /* 409443 */     GIR_EraseRootFromParent_Done,
     /* 409444 */   // Label 6123: @409444
     /* 409444 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(409579), // Rule ID 12091 //
     /* 409449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 409452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 409456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 409501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 409506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409533 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 409536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409577 */     GIR_RootConstrainSelectedInstOperands,
     /* 409578 */     // GIR_Coverage, 12091,
     /* 409578 */     GIR_EraseRootFromParent_Done,
     /* 409579 */   // Label 6124: @409579
     /* 409579 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(409714), // Rule ID 12568 //
     /* 409584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 409587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 409591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 409636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 409641 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409668 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 409671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409712 */     GIR_RootConstrainSelectedInstOperands,
     /* 409713 */     // GIR_Coverage, 12568,
     /* 409713 */     GIR_EraseRootFromParent_Done,
     /* 409714 */   // Label 6125: @409714
     /* 409714 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(409849), // Rule ID 12569 //
     /* 409719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 409722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 409726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409766 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 409771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 409776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409803 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 409806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 409813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 409818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 409823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 409828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409847 */     GIR_RootConstrainSelectedInstOperands,
     /* 409848 */     // GIR_Coverage, 12569,
     /* 409848 */     GIR_EraseRootFromParent_Done,
     /* 409849 */   // Label 6126: @409849
     /* 409849 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(409984), // Rule ID 12570 //
     /* 409854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 409857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 409861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 409869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 409873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 409877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 409885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 409889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 409893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 409901 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 409901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 409906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 409906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 409911 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 409915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 409938 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 409938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 409941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 409943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 409948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 409953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 409958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 409963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 409968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 409973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409982 */     GIR_RootConstrainSelectedInstOperands,
     /* 409983 */     // GIR_Coverage, 12570,
     /* 409983 */     GIR_EraseRootFromParent_Done,
     /* 409984 */   // Label 6127: @409984
     /* 409984 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(410119), // Rule ID 12571 //
     /* 409989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 409992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 409996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 410020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410036 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 410041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 410046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410073 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 410076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410117 */     GIR_RootConstrainSelectedInstOperands,
     /* 410118 */     // GIR_Coverage, 12571,
     /* 410118 */     GIR_EraseRootFromParent_Done,
     /* 410119 */   // Label 6128: @410119
     /* 410119 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(410254), // Rule ID 13048 //
     /* 410124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 410155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 410176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 410181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410208 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 410211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410252 */     GIR_RootConstrainSelectedInstOperands,
     /* 410253 */     // GIR_Coverage, 13048,
     /* 410253 */     GIR_EraseRootFromParent_Done,
     /* 410254 */   // Label 6129: @410254
     /* 410254 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(410389), // Rule ID 13049 //
     /* 410259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 410290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 410311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 410316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410343 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 410346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410387 */     GIR_RootConstrainSelectedInstOperands,
     /* 410388 */     // GIR_Coverage, 13049,
     /* 410388 */     GIR_EraseRootFromParent_Done,
     /* 410389 */   // Label 6130: @410389
     /* 410389 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(410524), // Rule ID 13050 //
     /* 410394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 410425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 410446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 410451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410478 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 410481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410522 */     GIR_RootConstrainSelectedInstOperands,
     /* 410523 */     // GIR_Coverage, 13050,
     /* 410523 */     GIR_EraseRootFromParent_Done,
     /* 410524 */   // Label 6131: @410524
     /* 410524 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(410659), // Rule ID 13051 //
     /* 410529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 410532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 410560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 410581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 410586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410613 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 410616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 410623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 410628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 410633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 410638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410657 */     GIR_RootConstrainSelectedInstOperands,
     /* 410658 */     // GIR_Coverage, 13051,
     /* 410658 */     GIR_EraseRootFromParent_Done,
     /* 410659 */   // Label 6132: @410659
     /* 410659 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(410794), // Rule ID 12097 //
     /* 410664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410748 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 410751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410792 */     GIR_RootConstrainSelectedInstOperands,
     /* 410793 */     // GIR_Coverage, 12097,
     /* 410793 */     GIR_EraseRootFromParent_Done,
     /* 410794 */   // Label 6133: @410794
     /* 410794 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(410929), // Rule ID 12098 //
     /* 410799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410856 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 410883 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 410883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 410886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 410888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 410893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 410898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 410903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 410908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 410913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 410918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410927 */     GIR_RootConstrainSelectedInstOperands,
     /* 410928 */     // GIR_Coverage, 12098,
     /* 410928 */     GIR_EraseRootFromParent_Done,
     /* 410929 */   // Label 6134: @410929
     /* 410929 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(411064), // Rule ID 12101 //
     /* 410934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 410937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 410941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 410949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 410953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 410957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 410965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 410969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 410973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 410981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 410981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 410986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 410986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 410991 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 410995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411011 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411018 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411062 */     GIR_RootConstrainSelectedInstOperands,
     /* 411063 */     // GIR_Coverage, 12101,
     /* 411063 */     GIR_EraseRootFromParent_Done,
     /* 411064 */   // Label 6135: @411064
     /* 411064 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(411199), // Rule ID 12102 //
     /* 411069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 411072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411104 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411153 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 411156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411197 */     GIR_RootConstrainSelectedInstOperands,
     /* 411198 */     // GIR_Coverage, 12102,
     /* 411198 */     GIR_EraseRootFromParent_Done,
     /* 411199 */   // Label 6136: @411199
     /* 411199 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(411334), // Rule ID 12577 //
     /* 411204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 411207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 411211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411288 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 411291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411332 */     GIR_RootConstrainSelectedInstOperands,
     /* 411333 */     // GIR_Coverage, 12577,
     /* 411333 */     GIR_EraseRootFromParent_Done,
     /* 411334 */   // Label 6137: @411334
     /* 411334 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(411469), // Rule ID 12578 //
     /* 411339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 411342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 411346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411423 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 411426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411467 */     GIR_RootConstrainSelectedInstOperands,
     /* 411468 */     // GIR_Coverage, 12578,
     /* 411468 */     GIR_EraseRootFromParent_Done,
     /* 411469 */   // Label 6138: @411469
     /* 411469 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(411604), // Rule ID 12581 //
     /* 411474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 411477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 411481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411521 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411551 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411558 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 411561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411602 */     GIR_RootConstrainSelectedInstOperands,
     /* 411603 */     // GIR_Coverage, 12581,
     /* 411603 */     GIR_EraseRootFromParent_Done,
     /* 411604 */   // Label 6139: @411604
     /* 411604 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(411739), // Rule ID 12582 //
     /* 411609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 411612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 411616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411656 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411666 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411686 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411693 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 411696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 411703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 411708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 411713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 411718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411737 */     GIR_RootConstrainSelectedInstOperands,
     /* 411738 */     // GIR_Coverage, 12582,
     /* 411738 */     GIR_EraseRootFromParent_Done,
     /* 411739 */   // Label 6140: @411739
     /* 411739 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(411874), // Rule ID 13057 //
     /* 411744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 411747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411801 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411828 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411872 */     GIR_RootConstrainSelectedInstOperands,
     /* 411873 */     // GIR_Coverage, 13057,
     /* 411873 */     GIR_EraseRootFromParent_Done,
     /* 411874 */   // Label 6141: @411874
     /* 411874 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(412009), // Rule ID 13058 //
     /* 411879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 411882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 411886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 411894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 411898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 411902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 411910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 411914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 411918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 411926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 411926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 411931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 411931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 411936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 411940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 411963 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 411963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 411966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 411968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 411973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 411978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 411983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 411988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 411993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 411998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412007 */     GIR_RootConstrainSelectedInstOperands,
     /* 412008 */     // GIR_Coverage, 13058,
     /* 412008 */     GIR_EraseRootFromParent_Done,
     /* 412009 */   // Label 6142: @412009
     /* 412009 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(412144), // Rule ID 13061 //
     /* 412014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 412061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412098 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412142 */     GIR_RootConstrainSelectedInstOperands,
     /* 412143 */     // GIR_Coverage, 13061,
     /* 412143 */     GIR_EraseRootFromParent_Done,
     /* 412144 */   // Label 6143: @412144
     /* 412144 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(412279), // Rule ID 13062 //
     /* 412149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 412152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 412196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412212 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412233 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 412236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412277 */     GIR_RootConstrainSelectedInstOperands,
     /* 412278 */     // GIR_Coverage, 13062,
     /* 412278 */     GIR_EraseRootFromParent_Done,
     /* 412279 */   // Label 6144: @412279
     /* 412279 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(412414), // Rule ID 12082 //
     /* 412284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412368 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412412 */     GIR_RootConstrainSelectedInstOperands,
     /* 412413 */     // GIR_Coverage, 12082,
     /* 412413 */     GIR_EraseRootFromParent_Done,
     /* 412414 */   // Label 6145: @412414
     /* 412414 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(412549), // Rule ID 12083 //
     /* 412419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412454 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412476 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412503 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412547 */     GIR_RootConstrainSelectedInstOperands,
     /* 412548 */     // GIR_Coverage, 12083,
     /* 412548 */     GIR_EraseRootFromParent_Done,
     /* 412549 */   // Label 6146: @412549
     /* 412549 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(412684), // Rule ID 12086 //
     /* 412554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412638 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412682 */     GIR_RootConstrainSelectedInstOperands,
     /* 412683 */     // GIR_Coverage, 12086,
     /* 412683 */     GIR_EraseRootFromParent_Done,
     /* 412684 */   // Label 6147: @412684
     /* 412684 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(412819), // Rule ID 12087 //
     /* 412689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 412692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 412696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412773 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 412776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 412783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 412788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 412793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 412798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412817 */     GIR_RootConstrainSelectedInstOperands,
     /* 412818 */     // GIR_Coverage, 12087,
     /* 412818 */     GIR_EraseRootFromParent_Done,
     /* 412819 */   // Label 6148: @412819
     /* 412819 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(412954), // Rule ID 12562 //
     /* 412824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 412827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 412831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 412871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 412871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 412876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 412876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 412881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 412885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 412908 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 412908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 412911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 412913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 412918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 412923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 412928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 412933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 412938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 412943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412952 */     GIR_RootConstrainSelectedInstOperands,
     /* 412953 */     // GIR_Coverage, 12562,
     /* 412953 */     GIR_EraseRootFromParent_Done,
     /* 412954 */   // Label 6149: @412954
     /* 412954 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(413089), // Rule ID 12563 //
     /* 412959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 412962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 412966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 412974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 412978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 412982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 412990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 412994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 412998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 413006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413043 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413087 */     GIR_RootConstrainSelectedInstOperands,
     /* 413088 */     // GIR_Coverage, 12563,
     /* 413088 */     GIR_EraseRootFromParent_Done,
     /* 413089 */   // Label 6150: @413089
     /* 413089 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(413224), // Rule ID 12566 //
     /* 413094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 413125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 413141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413157 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413171 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413178 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413222 */     GIR_RootConstrainSelectedInstOperands,
     /* 413223 */     // GIR_Coverage, 12566,
     /* 413223 */     GIR_EraseRootFromParent_Done,
     /* 413224 */   // Label 6151: @413224
     /* 413224 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(413359), // Rule ID 12567 //
     /* 413229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 413232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 413236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 413260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 413276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413286 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413313 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 413316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413357 */     GIR_RootConstrainSelectedInstOperands,
     /* 413358 */     // GIR_Coverage, 12567,
     /* 413358 */     GIR_EraseRootFromParent_Done,
     /* 413359 */   // Label 6152: @413359
     /* 413359 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(413494), // Rule ID 13042 //
     /* 413364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 413367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 413395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 413411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413448 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 413451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413492 */     GIR_RootConstrainSelectedInstOperands,
     /* 413493 */     // GIR_Coverage, 13042,
     /* 413493 */     GIR_EraseRootFromParent_Done,
     /* 413494 */   // Label 6153: @413494
     /* 413494 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(413629), // Rule ID 13043 //
     /* 413499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 413502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 413530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 413546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413576 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413583 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 413586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 413598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 413603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 413608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413627 */     GIR_RootConstrainSelectedInstOperands,
     /* 413628 */     // GIR_Coverage, 13043,
     /* 413628 */     GIR_EraseRootFromParent_Done,
     /* 413629 */   // Label 6154: @413629
     /* 413629 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(413764), // Rule ID 13046 //
     /* 413634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 413637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 413665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 413681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413704 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413718 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 413721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413762 */     GIR_RootConstrainSelectedInstOperands,
     /* 413763 */     // GIR_Coverage, 13046,
     /* 413763 */     GIR_EraseRootFromParent_Done,
     /* 413764 */   // Label 6155: @413764
     /* 413764 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(413899), // Rule ID 13047 //
     /* 413769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 413772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 413800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 413816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413826 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413853 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 413856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 413863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 413868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 413873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 413878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 413883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 413888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413897 */     GIR_RootConstrainSelectedInstOperands,
     /* 413898 */     // GIR_Coverage, 13047,
     /* 413898 */     GIR_EraseRootFromParent_Done,
     /* 413899 */   // Label 6156: @413899
     /* 413899 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(414034), // Rule ID 7760 //
     /* 413904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 413907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 413911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 413919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 413927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 413935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 413943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 413947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 413951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 413951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 413956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 413956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 413961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 413965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 413988 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 413988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 413991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 413993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 413998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414032 */     GIR_RootConstrainSelectedInstOperands,
     /* 414033 */     // GIR_Coverage, 7760,
     /* 414033 */     GIR_EraseRootFromParent_Done,
     /* 414034 */   // Label 6157: @414034
     /* 414034 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(414169), // Rule ID 7792 //
     /* 414039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 414042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 414046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 414070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 414082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414086 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414091 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414123 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 414126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414167 */     GIR_RootConstrainSelectedInstOperands,
     /* 414168 */     // GIR_Coverage, 7792,
     /* 414168 */     GIR_EraseRootFromParent_Done,
     /* 414169 */   // Label 6158: @414169
     /* 414169 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(414304), // Rule ID 7824 //
     /* 414174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 414177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 414205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 414217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414258 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 414261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414302 */     GIR_RootConstrainSelectedInstOperands,
     /* 414303 */     // GIR_Coverage, 7824,
     /* 414303 */     GIR_EraseRootFromParent_Done,
     /* 414304 */   // Label 6159: @414304
     /* 414304 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(414439), // Rule ID 12096 //
     /* 414309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 414340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 414352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414393 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414437 */     GIR_RootConstrainSelectedInstOperands,
     /* 414438 */     // GIR_Coverage, 12096,
     /* 414438 */     GIR_EraseRootFromParent_Done,
     /* 414439 */   // Label 6160: @414439
     /* 414439 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(414574), // Rule ID 12099 //
     /* 414444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 414475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 414487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414528 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414572 */     GIR_RootConstrainSelectedInstOperands,
     /* 414573 */     // GIR_Coverage, 12099,
     /* 414573 */     GIR_EraseRootFromParent_Done,
     /* 414574 */   // Label 6161: @414574
     /* 414574 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(414709), // Rule ID 12100 //
     /* 414579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 414582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 414586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 414610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 414622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414631 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414631 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414649 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414656 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414663 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 414666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414707 */     GIR_RootConstrainSelectedInstOperands,
     /* 414708 */     // GIR_Coverage, 12100,
     /* 414708 */     GIR_EraseRootFromParent_Done,
     /* 414709 */   // Label 6162: @414709
     /* 414709 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(414844), // Rule ID 12576 //
     /* 414714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 414717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 414721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 414745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 414757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414761 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414766 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414771 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414798 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 414801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 414808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 414813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 414818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 414823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414842 */     GIR_RootConstrainSelectedInstOperands,
     /* 414843 */     // GIR_Coverage, 12576,
     /* 414843 */     GIR_EraseRootFromParent_Done,
     /* 414844 */   // Label 6163: @414844
     /* 414844 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(414979), // Rule ID 12579 //
     /* 414849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 414852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 414856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 414872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 414880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 414888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 414892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 414896 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 414896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 414901 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 414901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 414906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 414910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 414933 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 414933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 414936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 414938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 414943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 414948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 414953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 414958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 414963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 414968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414977 */     GIR_RootConstrainSelectedInstOperands,
     /* 414978 */     // GIR_Coverage, 12579,
     /* 414978 */     GIR_EraseRootFromParent_Done,
     /* 414979 */   // Label 6164: @414979
     /* 414979 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(415114), // Rule ID 12580 //
     /* 414984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 414987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 414991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 414999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 415031 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415036 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415068 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415112 */     GIR_RootConstrainSelectedInstOperands,
     /* 415113 */     // GIR_Coverage, 12580,
     /* 415113 */     GIR_EraseRootFromParent_Done,
     /* 415114 */   // Label 6165: @415114
     /* 415114 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(415249), // Rule ID 13056 //
     /* 415119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 415166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415171 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415171 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415203 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415247 */     GIR_RootConstrainSelectedInstOperands,
     /* 415248 */     // GIR_Coverage, 13056,
     /* 415248 */     GIR_EraseRootFromParent_Done,
     /* 415249 */   // Label 6166: @415249
     /* 415249 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(415384), // Rule ID 13059 //
     /* 415254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 415301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415306 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415306 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415338 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415382 */     GIR_RootConstrainSelectedInstOperands,
     /* 415383 */     // GIR_Coverage, 13059,
     /* 415383 */     GIR_EraseRootFromParent_Done,
     /* 415384 */   // Label 6167: @415384
     /* 415384 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(415519), // Rule ID 13060 //
     /* 415389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 415436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415441 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415473 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 415483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 415488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 415493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 415498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415517 */     GIR_RootConstrainSelectedInstOperands,
     /* 415518 */     // GIR_Coverage, 13060,
     /* 415518 */     GIR_EraseRootFromParent_Done,
     /* 415519 */   // Label 6168: @415519
     /* 415519 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(415654), // Rule ID 7759 //
     /* 415524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 415527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415571 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415608 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 415611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415652 */     GIR_RootConstrainSelectedInstOperands,
     /* 415653 */     // GIR_Coverage, 7759,
     /* 415653 */     GIR_EraseRootFromParent_Done,
     /* 415654 */   // Label 6169: @415654
     /* 415654 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(415789), // Rule ID 7791 //
     /* 415659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 415662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 415666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415706 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415711 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415743 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 415746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415787 */     GIR_RootConstrainSelectedInstOperands,
     /* 415788 */     // GIR_Coverage, 7791,
     /* 415788 */     GIR_EraseRootFromParent_Done,
     /* 415789 */   // Label 6170: @415789
     /* 415789 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(415924), // Rule ID 7823 //
     /* 415794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 415797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415846 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415851 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415855 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415878 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 415878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 415881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 415883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 415888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 415893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 415898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 415903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 415908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 415913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415922 */     GIR_RootConstrainSelectedInstOperands,
     /* 415923 */     // GIR_Coverage, 7823,
     /* 415923 */     GIR_EraseRootFromParent_Done,
     /* 415924 */   // Label 6171: @415924
     /* 415924 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(416059), // Rule ID 12081 //
     /* 415929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 415932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 415936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 415944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 415952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 415960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 415964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 415968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 415972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 415976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 415976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 415981 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 415981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 415986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 415990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 415999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416013 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416057 */     GIR_RootConstrainSelectedInstOperands,
     /* 416058 */     // GIR_Coverage, 12081,
     /* 416058 */     GIR_EraseRootFromParent_Done,
     /* 416059 */   // Label 6172: @416059
     /* 416059 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(416194), // Rule ID 12084 //
     /* 416064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 416095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416116 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416116 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416148 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416192 */     GIR_RootConstrainSelectedInstOperands,
     /* 416193 */     // GIR_Coverage, 12084,
     /* 416193 */     GIR_EraseRootFromParent_Done,
     /* 416194 */   // Label 6173: @416194
     /* 416194 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(416329), // Rule ID 12085 //
     /* 416199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 416202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 416230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416246 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416251 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416251 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416283 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 416286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416327 */     GIR_RootConstrainSelectedInstOperands,
     /* 416328 */     // GIR_Coverage, 12085,
     /* 416328 */     GIR_EraseRootFromParent_Done,
     /* 416329 */   // Label 6174: @416329
     /* 416329 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(416464), // Rule ID 12561 //
     /* 416334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 416337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 416341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 416365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416381 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416386 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416418 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 416421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416462 */     GIR_RootConstrainSelectedInstOperands,
     /* 416463 */     // GIR_Coverage, 12561,
     /* 416463 */     GIR_EraseRootFromParent_Done,
     /* 416464 */   // Label 6175: @416464
     /* 416464 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(416599), // Rule ID 12564 //
     /* 416469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 416472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 416476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 416500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416516 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416521 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416553 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 416556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416597 */     GIR_RootConstrainSelectedInstOperands,
     /* 416598 */     // GIR_Coverage, 12564,
     /* 416598 */     GIR_EraseRootFromParent_Done,
     /* 416599 */   // Label 6176: @416599
     /* 416599 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(416734), // Rule ID 12565 //
     /* 416604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 416607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 416611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 416635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416651 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416656 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416656 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416661 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416688 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 416691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416732 */     GIR_RootConstrainSelectedInstOperands,
     /* 416733 */     // GIR_Coverage, 12565,
     /* 416733 */     GIR_EraseRootFromParent_Done,
     /* 416734 */   // Label 6177: @416734
     /* 416734 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(416869), // Rule ID 13041 //
     /* 416739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 416742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 416770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416791 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416823 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 416826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 416833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 416838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 416843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 416848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416867 */     GIR_RootConstrainSelectedInstOperands,
     /* 416868 */     // GIR_Coverage, 13041,
     /* 416868 */     GIR_EraseRootFromParent_Done,
     /* 416869 */   // Label 6178: @416869
     /* 416869 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(417004), // Rule ID 13044 //
     /* 416874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 416877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 416881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 416889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 416897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 416905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 416913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 416917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 416921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 416921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 416926 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 416926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 416931 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 416935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416951 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 416958 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 416958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 416961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 416963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 416968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 416973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 416978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 416983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 416988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 416993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417002 */     GIR_RootConstrainSelectedInstOperands,
     /* 417003 */     // GIR_Coverage, 13044,
     /* 417003 */     GIR_EraseRootFromParent_Done,
     /* 417004 */   // Label 6179: @417004
     /* 417004 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(417139), // Rule ID 13045 //
     /* 417009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 417012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 417040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 417052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 417056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417093 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 417096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417137 */     GIR_RootConstrainSelectedInstOperands,
     /* 417138 */     // GIR_Coverage, 13045,
     /* 417138 */     GIR_EraseRootFromParent_Done,
     /* 417139 */   // Label 6180: @417139
     /* 417139 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(417274), // Rule ID 12067 //
     /* 417144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 417147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417191 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417196 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417196 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417221 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417228 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 417231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417272 */     GIR_RootConstrainSelectedInstOperands,
     /* 417273 */     // GIR_Coverage, 12067,
     /* 417273 */     GIR_EraseRootFromParent_Done,
     /* 417274 */   // Label 6181: @417274
     /* 417274 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(417409), // Rule ID 12068 //
     /* 417279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 417282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417314 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417331 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417363 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 417366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417407 */     GIR_RootConstrainSelectedInstOperands,
     /* 417408 */     // GIR_Coverage, 12068,
     /* 417408 */     GIR_EraseRootFromParent_Done,
     /* 417409 */   // Label 6182: @417409
     /* 417409 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(417544), // Rule ID 12071 //
     /* 417414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 417417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417466 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417498 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 417501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417542 */     GIR_RootConstrainSelectedInstOperands,
     /* 417543 */     // GIR_Coverage, 12071,
     /* 417543 */     GIR_EraseRootFromParent_Done,
     /* 417544 */   // Label 6183: @417544
     /* 417544 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(417679), // Rule ID 12072 //
     /* 417549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 417552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 417556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417601 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417601 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417606 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417633 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 417636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 417643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 417648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 417653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 417658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417677 */     GIR_RootConstrainSelectedInstOperands,
     /* 417678 */     // GIR_Coverage, 12072,
     /* 417678 */     GIR_EraseRootFromParent_Done,
     /* 417679 */   // Label 6184: @417679
     /* 417679 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(417814), // Rule ID 12547 //
     /* 417684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417768 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 417771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417812 */     GIR_RootConstrainSelectedInstOperands,
     /* 417813 */     // GIR_Coverage, 12547,
     /* 417813 */     GIR_EraseRootFromParent_Done,
     /* 417814 */   // Label 6185: @417814
     /* 417814 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(417949), // Rule ID 12548 //
     /* 417819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 417866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 417866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 417871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 417871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 417876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 417880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 417882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 417903 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 417903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 417906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 417908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 417913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 417918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 417923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 417928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 417933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 417938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417947 */     GIR_RootConstrainSelectedInstOperands,
     /* 417948 */     // GIR_Coverage, 12548,
     /* 417948 */     GIR_EraseRootFromParent_Done,
     /* 417949 */   // Label 6186: @417949
     /* 417949 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(418084), // Rule ID 12551 //
     /* 417954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 417957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 417961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 417977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 417981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 417985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 417989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 417993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 417997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 418001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418006 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418038 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418082 */     GIR_RootConstrainSelectedInstOperands,
     /* 418083 */     // GIR_Coverage, 12551,
     /* 418083 */     GIR_EraseRootFromParent_Done,
     /* 418084 */   // Label 6187: @418084
     /* 418084 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(418219), // Rule ID 12552 //
     /* 418089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 418092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 418096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 418132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 418136 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418141 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418141 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418173 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 418176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418217 */     GIR_RootConstrainSelectedInstOperands,
     /* 418218 */     // GIR_Coverage, 12552,
     /* 418218 */     GIR_EraseRootFromParent_Done,
     /* 418219 */   // Label 6188: @418219
     /* 418219 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(418354), // Rule ID 13027 //
     /* 418224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 418227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 418267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 418271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418276 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418308 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 418311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418352 */     GIR_RootConstrainSelectedInstOperands,
     /* 418353 */     // GIR_Coverage, 13027,
     /* 418353 */     GIR_EraseRootFromParent_Done,
     /* 418354 */   // Label 6189: @418354
     /* 418354 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(418489), // Rule ID 13028 //
     /* 418359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 418362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 418402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 418406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418411 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418443 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 418446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418487 */     GIR_RootConstrainSelectedInstOperands,
     /* 418488 */     // GIR_Coverage, 13028,
     /* 418488 */     GIR_EraseRootFromParent_Done,
     /* 418489 */   // Label 6190: @418489
     /* 418489 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(418624), // Rule ID 13031 //
     /* 418494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 418497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 418537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 418541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418546 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418546 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418578 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 418581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418622 */     GIR_RootConstrainSelectedInstOperands,
     /* 418623 */     // GIR_Coverage, 13031,
     /* 418623 */     GIR_EraseRootFromParent_Done,
     /* 418624 */   // Label 6191: @418624
     /* 418624 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(418759), // Rule ID 13032 //
     /* 418629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 418632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 418672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 418676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418681 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418713 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 418716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 418723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 418728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 418733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 418738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418757 */     GIR_RootConstrainSelectedInstOperands,
     /* 418758 */     // GIR_Coverage, 13032,
     /* 418758 */     GIR_EraseRootFromParent_Done,
     /* 418759 */   // Label 6192: @418759
     /* 418759 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(418894), // Rule ID 12052 //
     /* 418764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 418767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 418807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418816 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418816 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418848 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 418868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 418873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 418878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 418883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 418892 */     GIR_RootConstrainSelectedInstOperands,
     /* 418893 */     // GIR_Coverage, 12052,
     /* 418893 */     GIR_EraseRootFromParent_Done,
     /* 418894 */   // Label 6193: @418894
     /* 418894 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(419029), // Rule ID 12053 //
     /* 418899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 418902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 418906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 418918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 418922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 418926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 418930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 418934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 418938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 418942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 418946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 418946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 418951 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 418951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 418956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 418960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 418962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 418983 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 418983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 418986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 418988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 418993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 418998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419027 */     GIR_RootConstrainSelectedInstOperands,
     /* 419028 */     // GIR_Coverage, 12053,
     /* 419028 */     GIR_EraseRootFromParent_Done,
     /* 419029 */   // Label 6194: @419029
     /* 419029 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(419164), // Rule ID 12056 //
     /* 419034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 419077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419086 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419118 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419162 */     GIR_RootConstrainSelectedInstOperands,
     /* 419163 */     // GIR_Coverage, 12056,
     /* 419163 */     GIR_EraseRootFromParent_Done,
     /* 419164 */   // Label 6195: @419164
     /* 419164 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(419299), // Rule ID 12057 //
     /* 419169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 419172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 419212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419253 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 419256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419297 */     GIR_RootConstrainSelectedInstOperands,
     /* 419298 */     // GIR_Coverage, 12057,
     /* 419298 */     GIR_EraseRootFromParent_Done,
     /* 419299 */   // Label 6196: @419299
     /* 419299 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(419434), // Rule ID 12532 //
     /* 419304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 419307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 419311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 419347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419388 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 419391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 419398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 419403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419432 */     GIR_RootConstrainSelectedInstOperands,
     /* 419433 */     // GIR_Coverage, 12532,
     /* 419433 */     GIR_EraseRootFromParent_Done,
     /* 419434 */   // Label 6197: @419434
     /* 419434 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(419569), // Rule ID 12533 //
     /* 419439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 419442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 419446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 419482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419491 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419523 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 419526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 419533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 419538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419567 */     GIR_RootConstrainSelectedInstOperands,
     /* 419568 */     // GIR_Coverage, 12533,
     /* 419568 */     GIR_EraseRootFromParent_Done,
     /* 419569 */   // Label 6198: @419569
     /* 419569 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(419704), // Rule ID 12536 //
     /* 419574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 419577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 419581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 419617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419626 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419626 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419631 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419658 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 419661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419702 */     GIR_RootConstrainSelectedInstOperands,
     /* 419703 */     // GIR_Coverage, 12536,
     /* 419703 */     GIR_EraseRootFromParent_Done,
     /* 419704 */   // Label 6199: @419704
     /* 419704 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(419839), // Rule ID 12537 //
     /* 419709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 419712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 419716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 419752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419761 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419766 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419793 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 419796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 419803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 419808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 419813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 419818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419837 */     GIR_RootConstrainSelectedInstOperands,
     /* 419838 */     // GIR_Coverage, 12537,
     /* 419838 */     GIR_EraseRootFromParent_Done,
     /* 419839 */   // Label 6200: @419839
     /* 419839 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(419974), // Rule ID 13012 //
     /* 419844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 419847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 419867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 419871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 419879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 419883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 419887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 419891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 419891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 419896 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 419896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 419901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 419905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 419907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419921 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 419928 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 419928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 419931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 419933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 419938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 419943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 419948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 419953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 419958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 419963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 419972 */     GIR_RootConstrainSelectedInstOperands,
     /* 419973 */     // GIR_Coverage, 13012,
     /* 419973 */     GIR_EraseRootFromParent_Done,
     /* 419974 */   // Label 6201: @419974
     /* 419974 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(420109), // Rule ID 13013 //
     /* 419979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 419982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 419986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 419994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 419998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 420022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 420026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420063 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 420073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 420078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 420093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 420098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420107 */     GIR_RootConstrainSelectedInstOperands,
     /* 420108 */     // GIR_Coverage, 13013,
     /* 420108 */     GIR_EraseRootFromParent_Done,
     /* 420109 */   // Label 6202: @420109
     /* 420109 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(420244), // Rule ID 13016 //
     /* 420114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 420157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 420161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420166 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420198 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 420218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 420223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 420228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 420233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420242 */     GIR_RootConstrainSelectedInstOperands,
     /* 420243 */     // GIR_Coverage, 13016,
     /* 420243 */     GIR_EraseRootFromParent_Done,
     /* 420244 */   // Label 6203: @420244
     /* 420244 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(420379), // Rule ID 13017 //
     /* 420249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 420292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 420296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420301 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420306 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420326 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420333 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 420343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 420348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 420353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 420358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 420363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 420368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420377 */     GIR_RootConstrainSelectedInstOperands,
     /* 420378 */     // GIR_Coverage, 13017,
     /* 420378 */     GIR_EraseRootFromParent_Done,
     /* 420379 */   // Label 6204: @420379
     /* 420379 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(420514), // Rule ID 7758 //
     /* 420384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 420387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 420427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420436 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420468 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 420471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 420478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 420483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 420498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 420503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420512 */     GIR_RootConstrainSelectedInstOperands,
     /* 420513 */     // GIR_Coverage, 7758,
     /* 420513 */     GIR_EraseRootFromParent_Done,
     /* 420514 */   // Label 6205: @420514
     /* 420514 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(420649), // Rule ID 7790 //
     /* 420519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 420522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 420526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 420562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420566 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420571 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420576 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420603 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 420606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 420613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 420618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 420633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 420638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420647 */     GIR_RootConstrainSelectedInstOperands,
     /* 420648 */     // GIR_Coverage, 7790,
     /* 420648 */     GIR_EraseRootFromParent_Done,
     /* 420649 */   // Label 6206: @420649
     /* 420649 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(420784), // Rule ID 7822 //
     /* 420654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 420657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 420697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420738 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 420741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 420748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 420753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 420768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 420773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420782 */     GIR_RootConstrainSelectedInstOperands,
     /* 420783 */     // GIR_Coverage, 7822,
     /* 420783 */     GIR_EraseRootFromParent_Done,
     /* 420784 */   // Label 6207: @420784
     /* 420784 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(420919), // Rule ID 12066 //
     /* 420789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 420792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 420832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420841 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420846 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420866 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420873 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 420873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 420876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 420878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 420883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 420888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 420893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 420898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 420903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 420908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 420917 */     GIR_RootConstrainSelectedInstOperands,
     /* 420918 */     // GIR_Coverage, 12066,
     /* 420918 */     GIR_EraseRootFromParent_Done,
     /* 420919 */   // Label 6208: @420919
     /* 420919 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(421054), // Rule ID 12069 //
     /* 420924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 420927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 420931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 420935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 420943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 420947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 420951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 420955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 420959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 420963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 420967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 420971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 420971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 420976 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 420976 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 420981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 420985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 420987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 420994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421008 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 421028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 421033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421052 */     GIR_RootConstrainSelectedInstOperands,
     /* 421053 */     // GIR_Coverage, 12069,
     /* 421053 */     GIR_EraseRootFromParent_Done,
     /* 421054 */   // Label 6209: @421054
     /* 421054 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(421189), // Rule ID 12070 //
     /* 421059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 421062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 421086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 421102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 421111 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 421116 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421136 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421143 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 421146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 421163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 421168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421187 */     GIR_RootConstrainSelectedInstOperands,
     /* 421188 */     // GIR_Coverage, 12070,
     /* 421188 */     GIR_EraseRootFromParent_Done,
     /* 421189 */   // Label 6210: @421189
     /* 421189 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(421324), // Rule ID 12546 //
     /* 421194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 421221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 421237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421241 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 421246 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421246 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 421251 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421278 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 421288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 421293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421322 */     GIR_RootConstrainSelectedInstOperands,
     /* 421323 */     // GIR_Coverage, 12546,
     /* 421323 */     GIR_EraseRootFromParent_Done,
     /* 421324 */   // Label 6211: @421324
     /* 421324 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(421459), // Rule ID 12549 //
     /* 421329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 421356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 421372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421376 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 421381 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 421386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421413 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 421433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 421438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421457 */     GIR_RootConstrainSelectedInstOperands,
     /* 421458 */     // GIR_Coverage, 12549,
     /* 421458 */     GIR_EraseRootFromParent_Done,
     /* 421459 */   // Label 6212: @421459
     /* 421459 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(421594), // Rule ID 12550 //
     /* 421464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 421467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 421471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 421491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 421507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421511 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 421516 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 421521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421548 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 421551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 421568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 421573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421592 */     GIR_RootConstrainSelectedInstOperands,
     /* 421593 */     // GIR_Coverage, 12550,
     /* 421593 */     GIR_EraseRootFromParent_Done,
     /* 421594 */   // Label 6213: @421594
     /* 421594 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(421729), // Rule ID 13026 //
     /* 421599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 421602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 421626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 421642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 421651 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 421656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421683 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 421686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 421693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 421698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 421703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 421708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421727 */     GIR_RootConstrainSelectedInstOperands,
     /* 421728 */     // GIR_Coverage, 13026,
     /* 421728 */     GIR_EraseRootFromParent_Done,
     /* 421729 */   // Label 6214: @421729
     /* 421729 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(421864), // Rule ID 13029 //
     /* 421734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 421737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 421761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 421777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 421786 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 421791 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421818 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 421821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 421838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 421843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421862 */     GIR_RootConstrainSelectedInstOperands,
     /* 421863 */     // GIR_Coverage, 13029,
     /* 421863 */     GIR_EraseRootFromParent_Done,
     /* 421864 */   // Label 6215: @421864
     /* 421864 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(421999), // Rule ID 13030 //
     /* 421869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 421872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 421876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 421888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 421892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 421896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 421900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 421904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 421908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 421912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 421916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 421916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 421921 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 421921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 421926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 421930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 421932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 421953 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 421953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 421956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 421958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 421963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 421968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 421973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 421978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 421983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 421988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421997 */     GIR_RootConstrainSelectedInstOperands,
     /* 421998 */     // GIR_Coverage, 13030,
     /* 421998 */     GIR_EraseRootFromParent_Done,
     /* 421999 */   // Label 6216: @421999
     /* 421999 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(422134), // Rule ID 7757 //
     /* 422004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422056 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 422061 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422088 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 422098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 422103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 422118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 422123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422132 */     GIR_RootConstrainSelectedInstOperands,
     /* 422133 */     // GIR_Coverage, 7757,
     /* 422133 */     GIR_EraseRootFromParent_Done,
     /* 422134 */   // Label 6217: @422134
     /* 422134 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(422269), // Rule ID 7789 //
     /* 422139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 422142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 422146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422186 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422191 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 422196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422223 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 422226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 422233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 422238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 422253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 422258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422267 */     GIR_RootConstrainSelectedInstOperands,
     /* 422268 */     // GIR_Coverage, 7789,
     /* 422268 */     GIR_EraseRootFromParent_Done,
     /* 422269 */   // Label 6218: @422269
     /* 422269 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(422404), // Rule ID 7821 //
     /* 422274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 422277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422326 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 422331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422358 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 422361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 422368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 422373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 422388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 422393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422402 */     GIR_RootConstrainSelectedInstOperands,
     /* 422403 */     // GIR_Coverage, 7821,
     /* 422403 */     GIR_EraseRootFromParent_Done,
     /* 422404 */   // Label 6219: @422404
     /* 422404 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(422539), // Rule ID 12051 //
     /* 422409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 422461 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422461 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422466 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422479 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422493 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 422503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 422508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 422523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 422528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422537 */     GIR_RootConstrainSelectedInstOperands,
     /* 422538 */     // GIR_Coverage, 12051,
     /* 422538 */     GIR_EraseRootFromParent_Done,
     /* 422539 */   // Label 6220: @422539
     /* 422539 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(422674), // Rule ID 12054 //
     /* 422544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 422596 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422596 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422621 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422628 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 422648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 422653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 422658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 422663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422672 */     GIR_RootConstrainSelectedInstOperands,
     /* 422673 */     // GIR_Coverage, 12054,
     /* 422673 */     GIR_EraseRootFromParent_Done,
     /* 422674 */   // Label 6221: @422674
     /* 422674 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(422809), // Rule ID 12055 //
     /* 422679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 422682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 422686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422731 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 422736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422763 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 422766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 422773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 422778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 422783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 422788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 422793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 422798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422807 */     GIR_RootConstrainSelectedInstOperands,
     /* 422808 */     // GIR_Coverage, 12055,
     /* 422808 */     GIR_EraseRootFromParent_Done,
     /* 422809 */   // Label 6222: @422809
     /* 422809 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(422944), // Rule ID 12531 //
     /* 422814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 422817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 422821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422861 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 422861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 422866 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 422871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 422875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 422877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 422898 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 422898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 422901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 422903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 422908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 422913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 422918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 422923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 422928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 422933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422942 */     GIR_RootConstrainSelectedInstOperands,
     /* 422943 */     // GIR_Coverage, 12531,
     /* 422943 */     GIR_EraseRootFromParent_Done,
     /* 422944 */   // Label 6223: @422944
     /* 422944 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(423079), // Rule ID 12534 //
     /* 422949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 422952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 422956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 422968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 422972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 422976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 422980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 422984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 422988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 422992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 422996 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 422996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 423001 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423033 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 423053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 423058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 423063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 423068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423077 */     GIR_RootConstrainSelectedInstOperands,
     /* 423078 */     // GIR_Coverage, 12534,
     /* 423078 */     GIR_EraseRootFromParent_Done,
     /* 423079 */   // Label 6224: @423079
     /* 423079 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(423214), // Rule ID 12535 //
     /* 423084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 423087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 423091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 423127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423131 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423136 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423136 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 423141 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423168 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 423171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 423188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 423193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 423198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 423203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423212 */     GIR_RootConstrainSelectedInstOperands,
     /* 423213 */     // GIR_Coverage, 12535,
     /* 423213 */     GIR_EraseRootFromParent_Done,
     /* 423214 */   // Label 6225: @423214
     /* 423214 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(423349), // Rule ID 13011 //
     /* 423219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 423262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 423271 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423303 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 423306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 423313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 423318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 423328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 423333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 423338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423347 */     GIR_RootConstrainSelectedInstOperands,
     /* 423348 */     // GIR_Coverage, 13011,
     /* 423348 */     GIR_EraseRootFromParent_Done,
     /* 423349 */   // Label 6226: @423349
     /* 423349 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(423484), // Rule ID 13014 //
     /* 423354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 423397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 423406 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423438 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 423441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 423458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 423463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 423468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 423473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423482 */     GIR_RootConstrainSelectedInstOperands,
     /* 423483 */     // GIR_Coverage, 13014,
     /* 423483 */     GIR_EraseRootFromParent_Done,
     /* 423484 */   // Label 6227: @423484
     /* 423484 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(423619), // Rule ID 13015 //
     /* 423489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 423492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 423532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 423536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423541 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423541 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 423546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423573 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 423576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 423593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 423598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 423603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 423608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423617 */     GIR_RootConstrainSelectedInstOperands,
     /* 423618 */     // GIR_Coverage, 13015,
     /* 423618 */     GIR_EraseRootFromParent_Done,
     /* 423619 */   // Label 6228: @423619
     /* 423619 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(423754), // Rule ID 12137 //
     /* 423624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 423627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 423655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423708 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 423711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423752 */     GIR_RootConstrainSelectedInstOperands,
     /* 423753 */     // GIR_Coverage, 12137,
     /* 423753 */     GIR_EraseRootFromParent_Done,
     /* 423754 */   // Label 6229: @423754
     /* 423754 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(423889), // Rule ID 12138 //
     /* 423759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 423762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 423790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423811 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423843 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 423846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 423853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 423858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 423863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 423868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 423873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 423878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423887 */     GIR_RootConstrainSelectedInstOperands,
     /* 423888 */     // GIR_Coverage, 12138,
     /* 423888 */     GIR_EraseRootFromParent_Done,
     /* 423889 */   // Label 6230: @423889
     /* 423889 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(424024), // Rule ID 12139 //
     /* 423894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 423897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 423901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 423909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 423913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 423917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 423921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 423925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 423929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 423933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 423937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 423941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 423941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 423946 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 423946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 423951 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 423955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423971 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 423978 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 423978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 423981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 423983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 423988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 423993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 423998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424022 */     GIR_RootConstrainSelectedInstOperands,
     /* 424023 */     // GIR_Coverage, 12139,
     /* 424023 */     GIR_EraseRootFromParent_Done,
     /* 424024 */   // Label 6231: @424024
     /* 424024 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(424159), // Rule ID 12140 //
     /* 424029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 424032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 424060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424081 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424081 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424113 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 424116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424157 */     GIR_RootConstrainSelectedInstOperands,
     /* 424158 */     // GIR_Coverage, 12140,
     /* 424158 */     GIR_EraseRootFromParent_Done,
     /* 424159 */   // Label 6232: @424159
     /* 424159 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(424294), // Rule ID 12617 //
     /* 424164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 424195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424216 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424221 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424241 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424248 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424292 */     GIR_RootConstrainSelectedInstOperands,
     /* 424293 */     // GIR_Coverage, 12617,
     /* 424293 */     GIR_EraseRootFromParent_Done,
     /* 424294 */   // Label 6233: @424294
     /* 424294 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(424429), // Rule ID 12618 //
     /* 424299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 424330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424383 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424427 */     GIR_RootConstrainSelectedInstOperands,
     /* 424428 */     // GIR_Coverage, 12618,
     /* 424428 */     GIR_EraseRootFromParent_Done,
     /* 424429 */   // Label 6234: @424429
     /* 424429 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(424564), // Rule ID 12619 //
     /* 424434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 424465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424518 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424562 */     GIR_RootConstrainSelectedInstOperands,
     /* 424563 */     // GIR_Coverage, 12619,
     /* 424563 */     GIR_EraseRootFromParent_Done,
     /* 424564 */   // Label 6235: @424564
     /* 424564 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(424699), // Rule ID 12620 //
     /* 424569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 424572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 424576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 424600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424621 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424621 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424646 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424653 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 424656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 424663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 424668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 424673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 424678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424697 */     GIR_RootConstrainSelectedInstOperands,
     /* 424698 */     // GIR_Coverage, 12620,
     /* 424698 */     GIR_EraseRootFromParent_Done,
     /* 424699 */   // Label 6236: @424699
     /* 424699 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(424834), // Rule ID 13097 //
     /* 424704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 424707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 424735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424756 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424788 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 424791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424832 */     GIR_RootConstrainSelectedInstOperands,
     /* 424833 */     // GIR_Coverage, 13097,
     /* 424833 */     GIR_EraseRootFromParent_Done,
     /* 424834 */   // Label 6237: @424834
     /* 424834 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(424969), // Rule ID 13098 //
     /* 424839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 424842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 424866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 424870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 424874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 424878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 424882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 424886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 424886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 424891 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 424891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 424896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 424900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 424923 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 424923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 424926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 424928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 424933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 424938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 424943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 424948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 424953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 424958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 424967 */     GIR_RootConstrainSelectedInstOperands,
     /* 424968 */     // GIR_Coverage, 13098,
     /* 424968 */     GIR_EraseRootFromParent_Done,
     /* 424969 */   // Label 6238: @424969
     /* 424969 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(425104), // Rule ID 13099 //
     /* 424974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 424977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 424981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 424989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 424993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 424997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 425021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425058 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425102 */     GIR_RootConstrainSelectedInstOperands,
     /* 425103 */     // GIR_Coverage, 13099,
     /* 425103 */     GIR_EraseRootFromParent_Done,
     /* 425104 */   // Label 6239: @425104
     /* 425104 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(425239), // Rule ID 13100 //
     /* 425109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 425112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 425156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425193 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 425196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425237 */     GIR_RootConstrainSelectedInstOperands,
     /* 425238 */     // GIR_Coverage, 13100,
     /* 425238 */     GIR_EraseRootFromParent_Done,
     /* 425239 */   // Label 6240: @425239
     /* 425239 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(425374), // Rule ID 12077 //
     /* 425244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425296 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425328 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 425331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425372 */     GIR_RootConstrainSelectedInstOperands,
     /* 425373 */     // GIR_Coverage, 12077,
     /* 425373 */     GIR_EraseRootFromParent_Done,
     /* 425374 */   // Label 6241: @425374
     /* 425374 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(425509), // Rule ID 12078 //
     /* 425379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425431 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425436 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425463 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 425466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425507 */     GIR_RootConstrainSelectedInstOperands,
     /* 425508 */     // GIR_Coverage, 12078,
     /* 425508 */     GIR_EraseRootFromParent_Done,
     /* 425509 */   // Label 6242: @425509
     /* 425509 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(425644), // Rule ID 12079 //
     /* 425514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425566 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425566 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425598 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 425601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425642 */     GIR_RootConstrainSelectedInstOperands,
     /* 425643 */     // GIR_Coverage, 12079,
     /* 425643 */     GIR_EraseRootFromParent_Done,
     /* 425644 */   // Label 6243: @425644
     /* 425644 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(425779), // Rule ID 12080 //
     /* 425649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 425652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 425656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425688 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425692 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425701 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425706 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425733 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 425736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 425743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 425748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 425753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 425758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425777 */     GIR_RootConstrainSelectedInstOperands,
     /* 425778 */     // GIR_Coverage, 12080,
     /* 425778 */     GIR_EraseRootFromParent_Done,
     /* 425779 */   // Label 6244: @425779
     /* 425779 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(425914), // Rule ID 12557 //
     /* 425784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 425787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 425791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425836 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425868 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 425868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 425871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 425873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 425878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 425883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 425888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 425893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 425898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 425903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 425912 */     GIR_RootConstrainSelectedInstOperands,
     /* 425913 */     // GIR_Coverage, 12557,
     /* 425913 */     GIR_EraseRootFromParent_Done,
     /* 425914 */   // Label 6245: @425914
     /* 425914 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(426049), // Rule ID 12558 //
     /* 425919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 425922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 425926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 425938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 425942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 425946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 425950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 425954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 425958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 425962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 425966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 425966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 425971 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 425971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 425976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 425980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 425996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426003 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 426023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 426028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426047 */     GIR_RootConstrainSelectedInstOperands,
     /* 426048 */     // GIR_Coverage, 12558,
     /* 426048 */     GIR_EraseRootFromParent_Done,
     /* 426049 */   // Label 6246: @426049
     /* 426049 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(426184), // Rule ID 12559 //
     /* 426054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 426081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426106 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426106 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426138 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 426148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 426153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426182 */     GIR_RootConstrainSelectedInstOperands,
     /* 426183 */     // GIR_Coverage, 12559,
     /* 426183 */     GIR_EraseRootFromParent_Done,
     /* 426184 */   // Label 6247: @426184
     /* 426184 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(426319), // Rule ID 12560 //
     /* 426189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 426192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 426196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 426216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426241 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426241 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426273 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 426276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 426283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 426288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426317 */     GIR_RootConstrainSelectedInstOperands,
     /* 426318 */     // GIR_Coverage, 12560,
     /* 426318 */     GIR_EraseRootFromParent_Done,
     /* 426319 */   // Label 6248: @426319
     /* 426319 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(426454), // Rule ID 13037 //
     /* 426324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 426327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 426351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426376 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426408 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 426411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 426428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 426433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426452 */     GIR_RootConstrainSelectedInstOperands,
     /* 426453 */     // GIR_Coverage, 13037,
     /* 426453 */     GIR_EraseRootFromParent_Done,
     /* 426454 */   // Label 6249: @426454
     /* 426454 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(426589), // Rule ID 13038 //
     /* 426459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 426462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 426486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426543 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 426546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 426563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 426568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426587 */     GIR_RootConstrainSelectedInstOperands,
     /* 426588 */     // GIR_Coverage, 13038,
     /* 426588 */     GIR_EraseRootFromParent_Done,
     /* 426589 */   // Label 6250: @426589
     /* 426589 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(426724), // Rule ID 13039 //
     /* 426594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 426597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 426621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426678 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 426681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 426688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 426693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426722 */     GIR_RootConstrainSelectedInstOperands,
     /* 426723 */     // GIR_Coverage, 13039,
     /* 426723 */     GIR_EraseRootFromParent_Done,
     /* 426724 */   // Label 6251: @426724
     /* 426724 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(426859), // Rule ID 13040 //
     /* 426729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 426732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 426756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 426760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426781 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426813 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 426816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 426823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 426828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 426833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 426838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426857 */     GIR_RootConstrainSelectedInstOperands,
     /* 426858 */     // GIR_Coverage, 13040,
     /* 426858 */     GIR_EraseRootFromParent_Done,
     /* 426859 */   // Label 6252: @426859
     /* 426859 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(426994), // Rule ID 12122 //
     /* 426864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 426867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 426871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 426879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 426883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 426887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 426891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 426895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 426899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 426903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 426907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 426911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 426911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 426916 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 426916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 426921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 426925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 426927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426941 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 426948 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 426948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 426951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 426953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 426958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 426963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 426968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 426973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 426978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 426983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 426992 */     GIR_RootConstrainSelectedInstOperands,
     /* 426993 */     // GIR_Coverage, 12122,
     /* 426993 */     GIR_EraseRootFromParent_Done,
     /* 426994 */   // Label 6253: @426994
     /* 426994 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(427129), // Rule ID 12123 //
     /* 426999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427051 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427051 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427083 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 427103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 427108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 427113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 427118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427127 */     GIR_RootConstrainSelectedInstOperands,
     /* 427128 */     // GIR_Coverage, 12123,
     /* 427128 */     GIR_EraseRootFromParent_Done,
     /* 427129 */   // Label 6254: @427129
     /* 427129 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(427264), // Rule ID 12124 //
     /* 427134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427169 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427186 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427186 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427211 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427218 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 427228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 427233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 427248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 427253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427262 */     GIR_RootConstrainSelectedInstOperands,
     /* 427263 */     // GIR_Coverage, 12124,
     /* 427263 */     GIR_EraseRootFromParent_Done,
     /* 427264 */   // Label 6255: @427264
     /* 427264 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(427399), // Rule ID 12125 //
     /* 427269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 427272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427353 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 427356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 427363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 427368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 427383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 427388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427397 */     GIR_RootConstrainSelectedInstOperands,
     /* 427398 */     // GIR_Coverage, 12125,
     /* 427398 */     GIR_EraseRootFromParent_Done,
     /* 427399 */   // Label 6256: @427399
     /* 427399 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(427534), // Rule ID 12602 //
     /* 427404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 427407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 427411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427456 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427488 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 427491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 427508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 427513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 427518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 427523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427532 */     GIR_RootConstrainSelectedInstOperands,
     /* 427533 */     // GIR_Coverage, 12602,
     /* 427533 */     GIR_EraseRootFromParent_Done,
     /* 427534 */   // Label 6257: @427534
     /* 427534 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(427669), // Rule ID 12603 //
     /* 427539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 427542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 427546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427591 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427591 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427596 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427616 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427623 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 427626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 427633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 427638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 427643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 427648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 427653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 427658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427667 */     GIR_RootConstrainSelectedInstOperands,
     /* 427668 */     // GIR_Coverage, 12603,
     /* 427668 */     GIR_EraseRootFromParent_Done,
     /* 427669 */   // Label 6258: @427669
     /* 427669 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(427804), // Rule ID 12604 //
     /* 427674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 427677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 427681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427726 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427726 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427758 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 427761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 427768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 427773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 427788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 427793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427802 */     GIR_RootConstrainSelectedInstOperands,
     /* 427803 */     // GIR_Coverage, 12604,
     /* 427803 */     GIR_EraseRootFromParent_Done,
     /* 427804 */   // Label 6259: @427804
     /* 427804 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(427939), // Rule ID 12605 //
     /* 427809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 427812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 427816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427861 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 427866 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 427870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 427872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427886 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 427893 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 427893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 427896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 427898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 427903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 427908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 427913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 427918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 427923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 427928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 427937 */     GIR_RootConstrainSelectedInstOperands,
     /* 427938 */     // GIR_Coverage, 12605,
     /* 427938 */     GIR_EraseRootFromParent_Done,
     /* 427939 */   // Label 6260: @427939
     /* 427939 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(428074), // Rule ID 13082 //
     /* 427944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 427947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 427951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 427959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 427963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 427967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 427971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 427975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 427979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 427983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 427987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 427991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 427991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 427996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 427996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428028 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 428048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 428053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 428058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 428063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428072 */     GIR_RootConstrainSelectedInstOperands,
     /* 428073 */     // GIR_Coverage, 13082,
     /* 428073 */     GIR_EraseRootFromParent_Done,
     /* 428074 */   // Label 6261: @428074
     /* 428074 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(428209), // Rule ID 13083 //
     /* 428079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 428106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 428126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428163 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 428183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 428188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 428193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 428198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428207 */     GIR_RootConstrainSelectedInstOperands,
     /* 428208 */     // GIR_Coverage, 13083,
     /* 428208 */     GIR_EraseRootFromParent_Done,
     /* 428209 */   // Label 6262: @428209
     /* 428209 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(428344), // Rule ID 13084 //
     /* 428214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 428241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 428261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428266 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428266 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428298 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 428308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 428313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 428328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 428333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428342 */     GIR_RootConstrainSelectedInstOperands,
     /* 428343 */     // GIR_Coverage, 13084,
     /* 428343 */     GIR_EraseRootFromParent_Done,
     /* 428344 */   // Label 6263: @428344
     /* 428344 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(428479), // Rule ID 13085 //
     /* 428349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 428352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 428376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 428396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428401 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428433 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 428436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 428443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 428448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 428463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 428468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428477 */     GIR_RootConstrainSelectedInstOperands,
     /* 428478 */     // GIR_Coverage, 13085,
     /* 428478 */     GIR_EraseRootFromParent_Done,
     /* 428479 */   // Label 6264: @428479
     /* 428479 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(428614), // Rule ID 12062 //
     /* 428484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 428487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 428511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428536 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428536 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428568 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 428571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 428588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 428593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 428598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 428603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428612 */     GIR_RootConstrainSelectedInstOperands,
     /* 428613 */     // GIR_Coverage, 12062,
     /* 428613 */     GIR_EraseRootFromParent_Done,
     /* 428614 */   // Label 6265: @428614
     /* 428614 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(428749), // Rule ID 12063 //
     /* 428619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 428622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 428646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428703 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 428706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 428713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 428718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 428723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 428728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 428733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 428738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428747 */     GIR_RootConstrainSelectedInstOperands,
     /* 428748 */     // GIR_Coverage, 12063,
     /* 428748 */     GIR_EraseRootFromParent_Done,
     /* 428749 */   // Label 6266: @428749
     /* 428749 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(428884), // Rule ID 12064 //
     /* 428754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 428757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 428781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428838 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 428841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 428848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 428853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 428868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 428873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428882 */     GIR_RootConstrainSelectedInstOperands,
     /* 428883 */     // GIR_Coverage, 12064,
     /* 428883 */     GIR_EraseRootFromParent_Done,
     /* 428884 */   // Label 6267: @428884
     /* 428884 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(429019), // Rule ID 12065 //
     /* 428889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 428892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 428896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 428908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 428912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 428916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 428920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 428924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 428928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 428932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 428936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 428936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 428941 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 428941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 428946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 428950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 428952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 428973 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 428973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 428976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 428978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 428983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 428988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 428993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 428998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429017 */     GIR_RootConstrainSelectedInstOperands,
     /* 429018 */     // GIR_Coverage, 12065,
     /* 429018 */     GIR_EraseRootFromParent_Done,
     /* 429019 */   // Label 6268: @429019
     /* 429019 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(429154), // Rule ID 12542 //
     /* 429024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429076 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429108 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 429128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 429133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429152 */     GIR_RootConstrainSelectedInstOperands,
     /* 429153 */     // GIR_Coverage, 12542,
     /* 429153 */     GIR_EraseRootFromParent_Done,
     /* 429154 */   // Label 6269: @429154
     /* 429154 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(429289), // Rule ID 12543 //
     /* 429159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429211 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429211 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429236 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429243 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 429263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 429268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429287 */     GIR_RootConstrainSelectedInstOperands,
     /* 429288 */     // GIR_Coverage, 12543,
     /* 429288 */     GIR_EraseRootFromParent_Done,
     /* 429289 */   // Label 6270: @429289
     /* 429289 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(429424), // Rule ID 12544 //
     /* 429294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429346 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429357 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429378 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 429388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 429393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429422 */     GIR_RootConstrainSelectedInstOperands,
     /* 429423 */     // GIR_Coverage, 12544,
     /* 429423 */     GIR_EraseRootFromParent_Done,
     /* 429424 */   // Label 6271: @429424
     /* 429424 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(429559), // Rule ID 12545 //
     /* 429429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 429432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 429436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429513 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 429516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 429523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 429528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429557 */     GIR_RootConstrainSelectedInstOperands,
     /* 429558 */     // GIR_Coverage, 12545,
     /* 429558 */     GIR_EraseRootFromParent_Done,
     /* 429559 */   // Label 6272: @429559
     /* 429559 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(429694), // Rule ID 13022 //
     /* 429564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 429567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429616 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429648 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 429651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 429668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 429673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429692 */     GIR_RootConstrainSelectedInstOperands,
     /* 429693 */     // GIR_Coverage, 13022,
     /* 429693 */     GIR_EraseRootFromParent_Done,
     /* 429694 */   // Label 6273: @429694
     /* 429694 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(429829), // Rule ID 13023 //
     /* 429699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 429702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429751 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429783 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 429786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 429793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 429798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 429803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 429808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429827 */     GIR_RootConstrainSelectedInstOperands,
     /* 429828 */     // GIR_Coverage, 13023,
     /* 429828 */     GIR_EraseRootFromParent_Done,
     /* 429829 */   // Label 6274: @429829
     /* 429829 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(429964), // Rule ID 13024 //
     /* 429834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 429837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 429865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 429869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 429873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 429877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 429881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 429886 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 429886 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 429891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 429895 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 429918 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 429918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 429921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 429923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 429928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 429933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 429938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 429943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 429948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 429953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429962 */     GIR_RootConstrainSelectedInstOperands,
     /* 429963 */     // GIR_Coverage, 13024,
     /* 429963 */     GIR_EraseRootFromParent_Done,
     /* 429964 */   // Label 6275: @429964
     /* 429964 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(430099), // Rule ID 13025 //
     /* 429969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 429972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 429976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 429984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 429988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 429992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 429996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 430000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430021 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430053 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 430056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 430063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 430068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 430083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 430088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430097 */     GIR_RootConstrainSelectedInstOperands,
     /* 430098 */     // GIR_Coverage, 13025,
     /* 430098 */     GIR_EraseRootFromParent_Done,
     /* 430099 */   // Label 6276: @430099
     /* 430099 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(430234), // Rule ID 12133 //
     /* 430104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 430135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430188 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430232 */     GIR_RootConstrainSelectedInstOperands,
     /* 430233 */     // GIR_Coverage, 12133,
     /* 430233 */     GIR_EraseRootFromParent_Done,
     /* 430234 */   // Label 6277: @430234
     /* 430234 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(430369), // Rule ID 12134 //
     /* 430239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 430270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430323 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430367 */     GIR_RootConstrainSelectedInstOperands,
     /* 430368 */     // GIR_Coverage, 12134,
     /* 430368 */     GIR_EraseRootFromParent_Done,
     /* 430369 */   // Label 6278: @430369
     /* 430369 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(430504), // Rule ID 12135 //
     /* 430374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 430405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430426 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430458 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430502 */     GIR_RootConstrainSelectedInstOperands,
     /* 430503 */     // GIR_Coverage, 12135,
     /* 430503 */     GIR_EraseRootFromParent_Done,
     /* 430504 */   // Label 6279: @430504
     /* 430504 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(430639), // Rule ID 12136 //
     /* 430509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 430512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 430516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 430540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430561 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430561 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430593 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 430596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 430603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 430608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 430613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 430618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430637 */     GIR_RootConstrainSelectedInstOperands,
     /* 430638 */     // GIR_Coverage, 12136,
     /* 430638 */     GIR_EraseRootFromParent_Done,
     /* 430639 */   // Label 6280: @430639
     /* 430639 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(430774), // Rule ID 12613 //
     /* 430644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 430647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 430651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 430675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430679 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430696 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430696 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430728 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 430731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430772 */     GIR_RootConstrainSelectedInstOperands,
     /* 430773 */     // GIR_Coverage, 12613,
     /* 430773 */     GIR_EraseRootFromParent_Done,
     /* 430774 */   // Label 6281: @430774
     /* 430774 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(430909), // Rule ID 12614 //
     /* 430779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 430782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 430786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 430810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430831 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430836 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430863 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 430866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 430868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 430873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 430878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 430883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 430888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 430893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 430898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430907 */     GIR_RootConstrainSelectedInstOperands,
     /* 430908 */     // GIR_Coverage, 12614,
     /* 430908 */     GIR_EraseRootFromParent_Done,
     /* 430909 */   // Label 6282: @430909
     /* 430909 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(431044), // Rule ID 12615 //
     /* 430914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 430917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 430921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 430929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 430933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 430937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 430945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 430949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 430953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 430957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 430961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 430961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 430966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 430966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 430971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 430975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 430998 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 430998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431042 */     GIR_RootConstrainSelectedInstOperands,
     /* 431043 */     // GIR_Coverage, 12615,
     /* 431043 */     GIR_EraseRootFromParent_Done,
     /* 431044 */   // Label 6283: @431044
     /* 431044 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(431179), // Rule ID 12616 //
     /* 431049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 431052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 431056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 431080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 431096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431101 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431133 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 431136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431177 */     GIR_RootConstrainSelectedInstOperands,
     /* 431178 */     // GIR_Coverage, 12616,
     /* 431178 */     GIR_EraseRootFromParent_Done,
     /* 431179 */   // Label 6284: @431179
     /* 431179 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(431314), // Rule ID 13093 //
     /* 431184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 431215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 431231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431236 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431236 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431268 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 431271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431312 */     GIR_RootConstrainSelectedInstOperands,
     /* 431313 */     // GIR_Coverage, 13093,
     /* 431313 */     GIR_EraseRootFromParent_Done,
     /* 431314 */   // Label 6285: @431314
     /* 431314 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(431449), // Rule ID 13094 //
     /* 431319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 431350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 431366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431371 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431376 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431396 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431403 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 431406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431447 */     GIR_RootConstrainSelectedInstOperands,
     /* 431448 */     // GIR_Coverage, 13094,
     /* 431448 */     GIR_EraseRootFromParent_Done,
     /* 431449 */   // Label 6286: @431449
     /* 431449 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(431584), // Rule ID 13095 //
     /* 431454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 431485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 431501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431506 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431511 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431538 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 431541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431582 */     GIR_RootConstrainSelectedInstOperands,
     /* 431583 */     // GIR_Coverage, 13095,
     /* 431583 */     GIR_EraseRootFromParent_Done,
     /* 431584 */   // Label 6287: @431584
     /* 431584 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(431719), // Rule ID 13096 //
     /* 431589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 431592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 431620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 431636 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431673 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 431676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 431683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 431688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 431693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 431698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431717 */     GIR_RootConstrainSelectedInstOperands,
     /* 431718 */     // GIR_Coverage, 13096,
     /* 431718 */     GIR_EraseRootFromParent_Done,
     /* 431719 */   // Label 6288: @431719
     /* 431719 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(431854), // Rule ID 12073 //
     /* 431724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 431727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 431755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431808 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 431811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431852 */     GIR_RootConstrainSelectedInstOperands,
     /* 431853 */     // GIR_Coverage, 12073,
     /* 431853 */     GIR_EraseRootFromParent_Done,
     /* 431854 */   // Label 6289: @431854
     /* 431854 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(431989), // Rule ID 12074 //
     /* 431859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 431862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 431866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 431878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 431882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 431890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 431894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 431898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 431902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 431906 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 431906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 431911 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 431911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 431916 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 431920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 431943 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 431943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 431946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 431948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 431953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 431958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 431963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 431968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 431973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 431978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 431987 */     GIR_RootConstrainSelectedInstOperands,
     /* 431988 */     // GIR_Coverage, 12074,
     /* 431988 */     GIR_EraseRootFromParent_Done,
     /* 431989 */   // Label 6290: @431989
     /* 431989 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(432124), // Rule ID 12075 //
     /* 431994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 431997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432041 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432041 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432046 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432046 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432051 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432078 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 432081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 432098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432122 */     GIR_RootConstrainSelectedInstOperands,
     /* 432123 */     // GIR_Coverage, 12075,
     /* 432123 */     GIR_EraseRootFromParent_Done,
     /* 432124 */   // Label 6291: @432124
     /* 432124 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(432259), // Rule ID 12076 //
     /* 432129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 432132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432176 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432176 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432181 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432181 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432190 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432213 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 432216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 432233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432257 */     GIR_RootConstrainSelectedInstOperands,
     /* 432258 */     // GIR_Coverage, 12076,
     /* 432258 */     GIR_EraseRootFromParent_Done,
     /* 432259 */   // Label 6292: @432259
     /* 432259 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(432394), // Rule ID 12553 //
     /* 432264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 432267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432311 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432348 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 432351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432392 */     GIR_RootConstrainSelectedInstOperands,
     /* 432393 */     // GIR_Coverage, 12553,
     /* 432393 */     GIR_EraseRootFromParent_Done,
     /* 432394 */   // Label 6293: @432394
     /* 432394 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(432529), // Rule ID 12554 //
     /* 432399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 432402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432483 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 432486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432527 */     GIR_RootConstrainSelectedInstOperands,
     /* 432528 */     // GIR_Coverage, 12554,
     /* 432528 */     GIR_EraseRootFromParent_Done,
     /* 432529 */   // Label 6294: @432529
     /* 432529 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(432664), // Rule ID 12555 //
     /* 432534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 432537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432586 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432618 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 432621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 432638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432662 */     GIR_RootConstrainSelectedInstOperands,
     /* 432663 */     // GIR_Coverage, 12555,
     /* 432663 */     GIR_EraseRootFromParent_Done,
     /* 432664 */   // Label 6295: @432664
     /* 432664 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(432799), // Rule ID 12556 //
     /* 432669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 432672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 432676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432716 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432721 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432721 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432726 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432746 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432753 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 432756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 432763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 432768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 432773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 432778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432797 */     GIR_RootConstrainSelectedInstOperands,
     /* 432798 */     // GIR_Coverage, 12556,
     /* 432798 */     GIR_EraseRootFromParent_Done,
     /* 432799 */   // Label 6296: @432799
     /* 432799 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(432934), // Rule ID 13033 //
     /* 432804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 432807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432851 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432856 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432861 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 432865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 432867 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 432888 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 432888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 432891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 432893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 432898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 432903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 432908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 432913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 432918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 432923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432932 */     GIR_RootConstrainSelectedInstOperands,
     /* 432933 */     // GIR_Coverage, 13033,
     /* 432933 */     GIR_EraseRootFromParent_Done,
     /* 432934 */   // Label 6297: @432934
     /* 432934 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(433069), // Rule ID 13034 //
     /* 432939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 432942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 432946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 432958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 432962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 432966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 432970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 432974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 432978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 432982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 432986 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 432986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 432991 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 432991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 432996 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433023 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 433026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433067 */     GIR_RootConstrainSelectedInstOperands,
     /* 433068 */     // GIR_Coverage, 13034,
     /* 433068 */     GIR_EraseRootFromParent_Done,
     /* 433069 */   // Label 6298: @433069
     /* 433069 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(433204), // Rule ID 13035 //
     /* 433074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 433077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 433105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 433117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433121 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 433121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 433126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 433126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 433131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433158 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 433161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 433178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 433183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433202 */     GIR_RootConstrainSelectedInstOperands,
     /* 433203 */     // GIR_Coverage, 13035,
     /* 433203 */     GIR_EraseRootFromParent_Done,
     /* 433204 */   // Label 6299: @433204
     /* 433204 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(433339), // Rule ID 13036 //
     /* 433209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 433212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 433240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 433252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433256 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 433256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 433261 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 433261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 433266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433293 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 433296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 433313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 433318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433337 */     GIR_RootConstrainSelectedInstOperands,
     /* 433338 */     // GIR_Coverage, 13036,
     /* 433338 */     GIR_EraseRootFromParent_Done,
     /* 433339 */   // Label 6300: @433339
     /* 433339 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(433474), // Rule ID 12118 //
     /* 433344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 433347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 433375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 433387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433391 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 433391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 433396 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 433396 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 433401 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433428 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 433431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433472 */     GIR_RootConstrainSelectedInstOperands,
     /* 433473 */     // GIR_Coverage, 12118,
     /* 433473 */     GIR_EraseRootFromParent_Done,
     /* 433474 */   // Label 6301: @433474
     /* 433474 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(433609), // Rule ID 12119 //
     /* 433479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 433482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 433510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 433522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433526 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 433526 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 433531 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 433531 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 433536 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433563 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 433566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433607 */     GIR_RootConstrainSelectedInstOperands,
     /* 433608 */     // GIR_Coverage, 12119,
     /* 433608 */     GIR_EraseRootFromParent_Done,
     /* 433609 */   // Label 6302: @433609
     /* 433609 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(433744), // Rule ID 12120 //
     /* 433614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 433617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 433645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 433657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433661 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 433661 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 433666 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 433666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 433671 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433677 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433698 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 433701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 433718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 433723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433742 */     GIR_RootConstrainSelectedInstOperands,
     /* 433743 */     // GIR_Coverage, 12120,
     /* 433743 */     GIR_EraseRootFromParent_Done,
     /* 433744 */   // Label 6303: @433744
     /* 433744 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(433879), // Rule ID 12121 //
     /* 433749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 433752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 433756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 433780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 433792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433796 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 433796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 433801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 433801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 433806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433833 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 433836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 433843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 433848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 433853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 433858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 433868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433877 */     GIR_RootConstrainSelectedInstOperands,
     /* 433878 */     // GIR_Coverage, 12121,
     /* 433878 */     GIR_EraseRootFromParent_Done,
     /* 433879 */   // Label 6304: @433879
     /* 433879 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(434014), // Rule ID 12598 //
     /* 433884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 433887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 433891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 433899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 433903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 433907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 433915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 433919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 433923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 433927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 433931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 433931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 433936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 433936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 433941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 433945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 433968 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 433968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 433971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 433973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 433978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 433983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 433988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 433993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 433998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434012 */     GIR_RootConstrainSelectedInstOperands,
     /* 434013 */     // GIR_Coverage, 12598,
     /* 434013 */     GIR_EraseRootFromParent_Done,
     /* 434014 */   // Label 6305: @434014
     /* 434014 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(434149), // Rule ID 12599 //
     /* 434019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 434022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 434026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 434058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 434062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 434071 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 434076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434103 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 434106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434147 */     GIR_RootConstrainSelectedInstOperands,
     /* 434148 */     // GIR_Coverage, 12599,
     /* 434148 */     GIR_EraseRootFromParent_Done,
     /* 434149 */   // Label 6306: @434149
     /* 434149 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(434284), // Rule ID 12600 //
     /* 434154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 434157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 434161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 434193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 434197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434201 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434201 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 434206 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434206 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 434211 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434238 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 434241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 434248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 434258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434282 */     GIR_RootConstrainSelectedInstOperands,
     /* 434283 */     // GIR_Coverage, 12600,
     /* 434283 */     GIR_EraseRootFromParent_Done,
     /* 434284 */   // Label 6307: @434284
     /* 434284 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(434419), // Rule ID 12601 //
     /* 434289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 434292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 434296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 434328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 434332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434336 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 434341 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 434346 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434373 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 434376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 434383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 434393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434417 */     GIR_RootConstrainSelectedInstOperands,
     /* 434418 */     // GIR_Coverage, 12601,
     /* 434418 */     GIR_EraseRootFromParent_Done,
     /* 434419 */   // Label 6308: @434419
     /* 434419 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(434554), // Rule ID 13078 //
     /* 434424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 434427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 434463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 434467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434471 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 434476 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 434481 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434485 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434508 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 434511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434552 */     GIR_RootConstrainSelectedInstOperands,
     /* 434553 */     // GIR_Coverage, 13078,
     /* 434553 */     GIR_EraseRootFromParent_Done,
     /* 434554 */   // Label 6309: @434554
     /* 434554 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(434689), // Rule ID 13079 //
     /* 434559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 434562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 434598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 434602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 434611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 434616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434643 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 434646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 434653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 434658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 434663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 434668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434687 */     GIR_RootConstrainSelectedInstOperands,
     /* 434688 */     // GIR_Coverage, 13079,
     /* 434688 */     GIR_EraseRootFromParent_Done,
     /* 434689 */   // Label 6310: @434689
     /* 434689 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(434824), // Rule ID 13080 //
     /* 434694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 434697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 434733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 434737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 434746 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 434751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434778 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 434781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 434788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 434798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434822 */     GIR_RootConstrainSelectedInstOperands,
     /* 434823 */     // GIR_Coverage, 13080,
     /* 434823 */     GIR_EraseRootFromParent_Done,
     /* 434824 */   // Label 6311: @434824
     /* 434824 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(434959), // Rule ID 13081 //
     /* 434829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 434832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 434868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 434872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 434876 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 434876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 434881 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 434881 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 434886 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 434890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 434913 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 434913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 434916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 434918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 434923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 434928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 434933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 434938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 434943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 434948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434957 */     GIR_RootConstrainSelectedInstOperands,
     /* 434958 */     // GIR_Coverage, 13081,
     /* 434958 */     GIR_EraseRootFromParent_Done,
     /* 434959 */   // Label 6312: @434959
     /* 434959 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(435094), // Rule ID 12058 //
     /* 434964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 434967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 434971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 434979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 434983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 434987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 434995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 434999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435011 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435016 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435016 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435021 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435048 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 435051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435092 */     GIR_RootConstrainSelectedInstOperands,
     /* 435093 */     // GIR_Coverage, 12058,
     /* 435093 */     GIR_EraseRootFromParent_Done,
     /* 435094 */   // Label 6313: @435094
     /* 435094 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(435229), // Rule ID 12059 //
     /* 435099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 435102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 435118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 435122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 435134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435146 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435146 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435151 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435183 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 435186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435227 */     GIR_RootConstrainSelectedInstOperands,
     /* 435228 */     // GIR_Coverage, 12059,
     /* 435228 */     GIR_EraseRootFromParent_Done,
     /* 435229 */   // Label 6314: @435229
     /* 435229 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(435364), // Rule ID 12060 //
     /* 435234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 435237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 435253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 435257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 435269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435281 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435318 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 435321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435362 */     GIR_RootConstrainSelectedInstOperands,
     /* 435363 */     // GIR_Coverage, 12060,
     /* 435363 */     GIR_EraseRootFromParent_Done,
     /* 435364 */   // Label 6315: @435364
     /* 435364 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(435499), // Rule ID 12061 //
     /* 435369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 435372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 435376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 435388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 435392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 435404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435453 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 435456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435497 */     GIR_RootConstrainSelectedInstOperands,
     /* 435498 */     // GIR_Coverage, 12061,
     /* 435498 */     GIR_EraseRootFromParent_Done,
     /* 435499 */   // Label 6316: @435499
     /* 435499 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(435634), // Rule ID 12538 //
     /* 435504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 435507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 435511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 435523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 435527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 435539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435551 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435556 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435556 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435565 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435581 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435588 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 435591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435632 */     GIR_RootConstrainSelectedInstOperands,
     /* 435633 */     // GIR_Coverage, 12538,
     /* 435633 */     GIR_EraseRootFromParent_Done,
     /* 435634 */   // Label 6317: @435634
     /* 435634 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(435769), // Rule ID 12539 //
     /* 435639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 435642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 435646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 435658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 435662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 435674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435686 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435686 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435691 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435691 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435723 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 435726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 435733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 435738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 435743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 435748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435767 */     GIR_RootConstrainSelectedInstOperands,
     /* 435768 */     // GIR_Coverage, 12539,
     /* 435768 */     GIR_EraseRootFromParent_Done,
     /* 435769 */   // Label 6318: @435769
     /* 435769 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(435904), // Rule ID 12540 //
     /* 435774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 435777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 435781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 435793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 435797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 435809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435821 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435826 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435831 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435858 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 435861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 435868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 435873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 435878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 435883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 435888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 435893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 435902 */     GIR_RootConstrainSelectedInstOperands,
     /* 435903 */     // GIR_Coverage, 12540,
     /* 435903 */     GIR_EraseRootFromParent_Done,
     /* 435904 */   // Label 6319: @435904
     /* 435904 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(436039), // Rule ID 12541 //
     /* 435909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 435912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 435916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 435928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 435932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 435940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 435944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 435948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 435952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 435956 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 435956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 435961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 435961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 435966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 435970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 435993 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 435993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 435996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 435998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436037 */     GIR_RootConstrainSelectedInstOperands,
     /* 436038 */     // GIR_Coverage, 12541,
     /* 436038 */     GIR_EraseRootFromParent_Done,
     /* 436039 */   // Label 6320: @436039
     /* 436039 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(436174), // Rule ID 13018 //
     /* 436044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 436047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 436067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 436087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 436096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 436101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436128 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 436131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436172 */     GIR_RootConstrainSelectedInstOperands,
     /* 436173 */     // GIR_Coverage, 13018,
     /* 436173 */     GIR_EraseRootFromParent_Done,
     /* 436174 */   // Label 6321: @436174
     /* 436174 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(436309), // Rule ID 13019 //
     /* 436179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 436182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 436202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 436222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 436231 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 436236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436263 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 436266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 436273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 436278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 436283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 436288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436307 */     GIR_RootConstrainSelectedInstOperands,
     /* 436308 */     // GIR_Coverage, 13019,
     /* 436308 */     GIR_EraseRootFromParent_Done,
     /* 436309 */   // Label 6322: @436309
     /* 436309 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(436444), // Rule ID 13020 //
     /* 436314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 436317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 436337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 436357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436361 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 436366 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 436371 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436398 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 436401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436442 */     GIR_RootConstrainSelectedInstOperands,
     /* 436443 */     // GIR_Coverage, 13020,
     /* 436443 */     GIR_EraseRootFromParent_Done,
     /* 436444 */   // Label 6323: @436444
     /* 436444 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(436579), // Rule ID 13021 //
     /* 436449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 436452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 436460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 436472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 436480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 436492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436496 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 436496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 436501 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 436501 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 436506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 436510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 436512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436526 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436533 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 436536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 436553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 436558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 436563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 436568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436577 */     GIR_RootConstrainSelectedInstOperands,
     /* 436578 */     // GIR_Coverage, 13021,
     /* 436578 */     GIR_EraseRootFromParent_Done,
     /* 436579 */   // Label 6324: @436579
     /* 436579 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(436694), // Rule ID 13402 //
     /* 436584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 436587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 436591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 436599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436619 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 436621 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 436625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436648 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 436651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 436668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 436673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 436678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 436683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436692 */     GIR_RootConstrainSelectedInstOperands,
     /* 436693 */     // GIR_Coverage, 13402,
     /* 436693 */     GIR_EraseRootFromParent_Done,
     /* 436694 */   // Label 6325: @436694
     /* 436694 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(436809), // Rule ID 13418 //
     /* 436699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 436702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 436714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 436726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436734 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 436736 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 436740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436763 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 436766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 436783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 436788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 436793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 436798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436807 */     GIR_RootConstrainSelectedInstOperands,
     /* 436808 */     // GIR_Coverage, 13418,
     /* 436808 */     GIR_EraseRootFromParent_Done,
     /* 436809 */   // Label 6326: @436809
     /* 436809 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(436924), // Rule ID 13401 //
     /* 436814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 436817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 436821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 436829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436849 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 436851 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 436855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436878 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 436881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 436888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 436893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 436898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 436903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 436908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 436913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 436922 */     GIR_RootConstrainSelectedInstOperands,
     /* 436923 */     // GIR_Coverage, 13401,
     /* 436923 */     GIR_EraseRootFromParent_Done,
     /* 436924 */   // Label 6327: @436924
     /* 436924 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(437039), // Rule ID 13417 //
     /* 436929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 436932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 436936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 436944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 436948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 436952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 436956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 436960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 436964 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 436966 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 436970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 436993 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 436993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 436996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 436998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 437013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 437018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 437023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 437028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437037 */     GIR_RootConstrainSelectedInstOperands,
     /* 437038 */     // GIR_Coverage, 13417,
     /* 437038 */     GIR_EraseRootFromParent_Done,
     /* 437039 */   // Label 6328: @437039
     /* 437039 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(437154), // Rule ID 7876 //
     /* 437044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 437047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 437051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 437059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 437075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 437079 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 437081 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 437085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437108 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 437111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437152 */     GIR_RootConstrainSelectedInstOperands,
     /* 437153 */     // GIR_Coverage, 7876,
     /* 437153 */     GIR_EraseRootFromParent_Done,
     /* 437154 */   // Label 6329: @437154
     /* 437154 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(437269), // Rule ID 7892 //
     /* 437159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 437162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 437174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 437190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 437194 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 437196 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 437200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437223 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 437226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437267 */     GIR_RootConstrainSelectedInstOperands,
     /* 437268 */     // GIR_Coverage, 7892,
     /* 437268 */     GIR_EraseRootFromParent_Done,
     /* 437269 */   // Label 6330: @437269
     /* 437269 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(437384), // Rule ID 7875 //
     /* 437274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 437277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 437281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 437289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 437305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 437309 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 437311 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 437315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437331 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437338 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 437341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437382 */     GIR_RootConstrainSelectedInstOperands,
     /* 437383 */     // GIR_Coverage, 7875,
     /* 437383 */     GIR_EraseRootFromParent_Done,
     /* 437384 */   // Label 6331: @437384
     /* 437384 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(437499), // Rule ID 7891 //
     /* 437389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 437392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 437404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 437412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 437420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 437424 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 437426 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 437430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 437432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437453 */     // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 437456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437497 */     GIR_RootConstrainSelectedInstOperands,
     /* 437498 */     // GIR_Coverage, 7891,
     /* 437498 */     GIR_EraseRootFromParent_Done,
     /* 437499 */   // Label 6332: @437499
     /* 437499 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(437598), // Rule ID 13394 //
     /* 437504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 437507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 437511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 437527 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 437529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437552 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 437555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 437572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 437577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 437582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 437587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437596 */     GIR_RootConstrainSelectedInstOperands,
     /* 437597 */     // GIR_Coverage, 13394,
     /* 437597 */     GIR_EraseRootFromParent_Done,
     /* 437598 */   // Label 6333: @437598
     /* 437598 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(437697), // Rule ID 13410 //
     /* 437603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 437606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 437626 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 437628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437651 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 437654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 437671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 437676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 437681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 437686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437695 */     GIR_RootConstrainSelectedInstOperands,
     /* 437696 */     // GIR_Coverage, 13410,
     /* 437696 */     GIR_EraseRootFromParent_Done,
     /* 437697 */   // Label 6334: @437697
     /* 437697 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(437796), // Rule ID 13393 //
     /* 437702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 437705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 437709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 437725 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 437727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437750 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 437753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 437770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 437775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 437780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 437785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437794 */     GIR_RootConstrainSelectedInstOperands,
     /* 437795 */     // GIR_Coverage, 13393,
     /* 437795 */     GIR_EraseRootFromParent_Done,
     /* 437796 */   // Label 6335: @437796
     /* 437796 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(437895), // Rule ID 13409 //
     /* 437801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 437804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 437808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 437816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 437824 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 437826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437849 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 437852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 437859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 437864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 437869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 437874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 437879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 437884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437893 */     GIR_RootConstrainSelectedInstOperands,
     /* 437894 */     // GIR_Coverage, 13409,
     /* 437894 */     GIR_EraseRootFromParent_Done,
     /* 437895 */   // Label 6336: @437895
     /* 437895 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(437994), // Rule ID 7868 //
     /* 437900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 437903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 437907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 437911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 437915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 437919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 437923 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 437925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 437948 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 437948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 437951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 437953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 437958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 437963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 437968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 437973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 437978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 437983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 437992 */     GIR_RootConstrainSelectedInstOperands,
     /* 437993 */     // GIR_Coverage, 7868,
     /* 437993 */     GIR_EraseRootFromParent_Done,
     /* 437994 */   // Label 6337: @437994
     /* 437994 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(438093), // Rule ID 7884 //
     /* 437999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 438002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 438018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 438022 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 438024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438047 */     // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 438050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438091 */     GIR_RootConstrainSelectedInstOperands,
     /* 438092 */     // GIR_Coverage, 7884,
     /* 438092 */     GIR_EraseRootFromParent_Done,
     /* 438093 */   // Label 6338: @438093
     /* 438093 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(438192), // Rule ID 7867 //
     /* 438098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 438101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 438105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 438117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 438121 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 438123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438146 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 438149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438190 */     GIR_RootConstrainSelectedInstOperands,
     /* 438191 */     // GIR_Coverage, 7867,
     /* 438191 */     GIR_EraseRootFromParent_Done,
     /* 438192 */   // Label 6339: @438192
     /* 438192 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(438291), // Rule ID 7883 //
     /* 438197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 438200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 438212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 438216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 438220 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 438222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438245 */     // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 438248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438289 */     GIR_RootConstrainSelectedInstOperands,
     /* 438290 */     // GIR_Coverage, 7883,
     /* 438290 */     GIR_EraseRootFromParent_Done,
     /* 438291 */   // Label 6340: @438291
     /* 438291 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(438326), // Rule ID 103 //
     /* 438296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 438299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 438303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 438307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 438311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13745),
     /* 438315 */     // (fmaxnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13745>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 438315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
     /* 438320 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 438324 */     GIR_RootConstrainSelectedInstOperands,
     /* 438325 */     // GIR_Coverage, 103,
     /* 438325 */     GIR_Done,
     /* 438326 */   // Label 6341: @438326
     /* 438326 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(438389), // Rule ID 881 //
     /* 438331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 438334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 438345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438352 */     // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 438352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 438355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 438362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 438372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 438382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 438387 */     GIR_RootConstrainSelectedInstOperands,
     /* 438388 */     // GIR_Coverage, 881,
     /* 438388 */     GIR_EraseRootFromParent_Done,
     /* 438389 */   // Label 6342: @438389
     /* 438389 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(438452), // Rule ID 885 //
     /* 438394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 438397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 438408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438415 */     // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 438415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 438418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 438425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 438435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 438445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 438450 */     GIR_RootConstrainSelectedInstOperands,
     /* 438451 */     // GIR_Coverage, 885,
     /* 438451 */     GIR_EraseRootFromParent_Done,
     /* 438452 */   // Label 6343: @438452
     /* 438452 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(438515), // Rule ID 8569 //
     /* 438457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 438460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 438478 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 438478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 438481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 438488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 438498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 438503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 438508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 438513 */     GIR_RootConstrainSelectedInstOperands,
     /* 438514 */     // GIR_Coverage, 8569,
     /* 438514 */     GIR_EraseRootFromParent_Done,
     /* 438515 */   // Label 6344: @438515
     /* 438515 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(438578), // Rule ID 8571 //
     /* 438520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 438523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 438541 */     // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 438541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 438544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 438551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 438556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 438561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 438566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 438571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 438576 */     GIR_RootConstrainSelectedInstOperands,
     /* 438577 */     // GIR_Coverage, 8571,
     /* 438577 */     GIR_EraseRootFromParent_Done,
     /* 438578 */   // Label 6345: @438578
     /* 438578 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(438640), // Rule ID 883 //
     /* 438583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 438586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 438590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 438597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 438604 */     // (fmaxnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 438604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 438607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 438614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 438624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438638 */     GIR_RootConstrainSelectedInstOperands,
     /* 438639 */     // GIR_Coverage, 883,
     /* 438639 */     GIR_EraseRootFromParent_Done,
     /* 438640 */   // Label 6346: @438640
     /* 438640 */   GIM_Reject,
     /* 438641 */ // Label 5940: @438641
     /* 438641 */ GIM_Reject,
     /* 438642 */ // Label 5936: @438642
     /* 438642 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(456153),
     /* 438647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 438650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 438653 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(438782), // Rule ID 11647 //
     /* 438658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 438698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438702 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438702 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438707 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438739 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438780 */     GIR_RootConstrainSelectedInstOperands,
     /* 438781 */     // GIR_Coverage, 11647,
     /* 438781 */     GIR_EraseRootFromParent_Done,
     /* 438782 */   // Label 6348: @438782
     /* 438782 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(438911), // Rule ID 11648 //
     /* 438787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 438827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438831 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438836 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438841 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438868 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 438871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 438873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 438878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 438883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 438888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 438893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 438898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 438903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 438909 */     GIR_RootConstrainSelectedInstOperands,
     /* 438910 */     // GIR_Coverage, 11648,
     /* 438910 */     GIR_EraseRootFromParent_Done,
     /* 438911 */   // Label 6349: @438911
     /* 438911 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(439040), // Rule ID 11651 //
     /* 438916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 438920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 438924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 438932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 438936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 438940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 438944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 438948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 438952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 438956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 438960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 438960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 438965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 438965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 438970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 438974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 438976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 438997 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 438997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 439017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 439022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439038 */     GIR_RootConstrainSelectedInstOperands,
     /* 439039 */     // GIR_Coverage, 11651,
     /* 439039 */     GIR_EraseRootFromParent_Done,
     /* 439040 */   // Label 6350: @439040
     /* 439040 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(439169), // Rule ID 11652 //
     /* 439045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 439085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439089 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 439094 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439126 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 439146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 439151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439167 */     GIR_RootConstrainSelectedInstOperands,
     /* 439168 */     // GIR_Coverage, 11652,
     /* 439168 */     GIR_EraseRootFromParent_Done,
     /* 439169 */   // Label 6351: @439169
     /* 439169 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(439298), // Rule ID 11632 //
     /* 439174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 439214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439218 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 439223 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439232 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439255 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 439265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 439270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439296 */     GIR_RootConstrainSelectedInstOperands,
     /* 439297 */     // GIR_Coverage, 11632,
     /* 439297 */     GIR_EraseRootFromParent_Done,
     /* 439298 */   // Label 6352: @439298
     /* 439298 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(439427), // Rule ID 11633 //
     /* 439303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 439343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439347 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439347 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439352 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 439357 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439384 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 439394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 439399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439425 */     GIR_RootConstrainSelectedInstOperands,
     /* 439426 */     // GIR_Coverage, 11633,
     /* 439426 */     GIR_EraseRootFromParent_Done,
     /* 439427 */   // Label 6353: @439427
     /* 439427 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(439556), // Rule ID 11636 //
     /* 439432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 439472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439476 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439481 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 439486 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439513 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 439533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 439538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439554 */     GIR_RootConstrainSelectedInstOperands,
     /* 439555 */     // GIR_Coverage, 11636,
     /* 439555 */     GIR_EraseRootFromParent_Done,
     /* 439556 */   // Label 6354: @439556
     /* 439556 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(439685), // Rule ID 11637 //
     /* 439561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 439601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 439605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 439610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439642 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 439652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 439657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 439662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 439667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439683 */     GIR_RootConstrainSelectedInstOperands,
     /* 439684 */     // GIR_Coverage, 11637,
     /* 439684 */     GIR_EraseRootFromParent_Done,
     /* 439685 */   // Label 6355: @439685
     /* 439685 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(439814), // Rule ID 7730 //
     /* 439690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 439730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439734 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 439739 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439771 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 439781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 439786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439812 */     GIR_RootConstrainSelectedInstOperands,
     /* 439813 */     // GIR_Coverage, 7730,
     /* 439813 */     GIR_EraseRootFromParent_Done,
     /* 439814 */   // Label 6356: @439814
     /* 439814 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(439943), // Rule ID 11646 //
     /* 439819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 439859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439863 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439868 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 439873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 439877 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 439879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 439900 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 439900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 439903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 439905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 439910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 439915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 439920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 439925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 439930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 439935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 439941 */     GIR_RootConstrainSelectedInstOperands,
     /* 439942 */     // GIR_Coverage, 11646,
     /* 439942 */     GIR_EraseRootFromParent_Done,
     /* 439943 */   // Label 6357: @439943
     /* 439943 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(440072), // Rule ID 11649 //
     /* 439948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 439952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 439956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 439964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 439968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 439972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 439976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 439980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 439984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 439988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 439992 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 439992 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 439997 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 439997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440029 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 440049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 440054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440070 */     GIR_RootConstrainSelectedInstOperands,
     /* 440071 */     // GIR_Coverage, 11649,
     /* 440071 */     GIR_EraseRootFromParent_Done,
     /* 440072 */   // Label 6358: @440072
     /* 440072 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(440201), // Rule ID 11650 //
     /* 440077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 440101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 440117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440121 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440121 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440126 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 440131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440158 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 440178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 440183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440199 */     GIR_RootConstrainSelectedInstOperands,
     /* 440200 */     // GIR_Coverage, 11650,
     /* 440200 */     GIR_EraseRootFromParent_Done,
     /* 440201 */   // Label 6359: @440201
     /* 440201 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(440330), // Rule ID 7729 //
     /* 440206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 440230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 440246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 440260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440287 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440328 */     GIR_RootConstrainSelectedInstOperands,
     /* 440329 */     // GIR_Coverage, 7729,
     /* 440329 */     GIR_EraseRootFromParent_Done,
     /* 440330 */   // Label 6360: @440330
     /* 440330 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(440459), // Rule ID 11631 //
     /* 440335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 440359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 440375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440379 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 440384 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440416 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440457 */     GIR_RootConstrainSelectedInstOperands,
     /* 440458 */     // GIR_Coverage, 11631,
     /* 440458 */     GIR_EraseRootFromParent_Done,
     /* 440459 */   // Label 6361: @440459
     /* 440459 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(440588), // Rule ID 11634 //
     /* 440464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 440488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 440504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440508 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440508 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 440513 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440545 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 440565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 440570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440586 */     GIR_RootConstrainSelectedInstOperands,
     /* 440587 */     // GIR_Coverage, 11634,
     /* 440587 */     GIR_EraseRootFromParent_Done,
     /* 440588 */   // Label 6362: @440588
     /* 440588 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(440717), // Rule ID 11635 //
     /* 440593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 440617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 440633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 440637 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440642 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 440647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440674 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 440684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 440689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 440694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 440699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440715 */     GIR_RootConstrainSelectedInstOperands,
     /* 440716 */     // GIR_Coverage, 11635,
     /* 440716 */     GIR_EraseRootFromParent_Done,
     /* 440717 */   // Label 6363: @440717
     /* 440717 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(440846), // Rule ID 11617 //
     /* 440722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 440746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 440762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440766 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440771 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 440776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440803 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440844 */     GIR_RootConstrainSelectedInstOperands,
     /* 440845 */     // GIR_Coverage, 11617,
     /* 440845 */     GIR_EraseRootFromParent_Done,
     /* 440846 */   // Label 6364: @440846
     /* 440846 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(440975), // Rule ID 11618 //
     /* 440851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 440871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 440875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 440879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 440883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 440887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 440891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 440895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 440895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 440900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 440900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 440905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 440909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 440911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 440932 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 440932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 440935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 440937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 440942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 440947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 440952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 440957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 440962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 440967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 440973 */     GIR_RootConstrainSelectedInstOperands,
     /* 440974 */     // GIR_Coverage, 11618,
     /* 440974 */     GIR_EraseRootFromParent_Done,
     /* 440975 */   // Label 6365: @440975
     /* 440975 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(441104), // Rule ID 11621 //
     /* 440980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 440984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 440988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 440992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 440996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 441020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441029 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441061 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441102 */     GIR_RootConstrainSelectedInstOperands,
     /* 441103 */     // GIR_Coverage, 11621,
     /* 441103 */     GIR_EraseRootFromParent_Done,
     /* 441104 */   // Label 6366: @441104
     /* 441104 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(441233), // Rule ID 11622 //
     /* 441109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 441149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441153 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441158 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441163 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441190 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441231 */     GIR_RootConstrainSelectedInstOperands,
     /* 441232 */     // GIR_Coverage, 11622,
     /* 441232 */     GIR_EraseRootFromParent_Done,
     /* 441233 */   // Label 6367: @441233
     /* 441233 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(441362), // Rule ID 11602 //
     /* 441238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 441278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441282 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441282 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441287 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441319 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441360 */     GIR_RootConstrainSelectedInstOperands,
     /* 441361 */     // GIR_Coverage, 11602,
     /* 441361 */     GIR_EraseRootFromParent_Done,
     /* 441362 */   // Label 6368: @441362
     /* 441362 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(441491), // Rule ID 11603 //
     /* 441367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 441407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441411 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441411 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441416 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441421 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441448 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441489 */     GIR_RootConstrainSelectedInstOperands,
     /* 441490 */     // GIR_Coverage, 11603,
     /* 441490 */     GIR_EraseRootFromParent_Done,
     /* 441491 */   // Label 6369: @441491
     /* 441491 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(441620), // Rule ID 11606 //
     /* 441496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 441536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441577 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441618 */     GIR_RootConstrainSelectedInstOperands,
     /* 441619 */     // GIR_Coverage, 11606,
     /* 441619 */     GIR_EraseRootFromParent_Done,
     /* 441620 */   // Label 6370: @441620
     /* 441620 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(441749), // Rule ID 11607 //
     /* 441625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 441665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 441669 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441674 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441706 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 441716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 441721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 441726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 441731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441747 */     GIR_RootConstrainSelectedInstOperands,
     /* 441748 */     // GIR_Coverage, 11607,
     /* 441748 */     GIR_EraseRootFromParent_Done,
     /* 441749 */   // Label 6371: @441749
     /* 441749 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(441878), // Rule ID 7728 //
     /* 441754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 441794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441798 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441803 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441808 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441835 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 441876 */     GIR_RootConstrainSelectedInstOperands,
     /* 441877 */     // GIR_Coverage, 7728,
     /* 441877 */     GIR_EraseRootFromParent_Done,
     /* 441878 */   // Label 6372: @441878
     /* 441878 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(442007), // Rule ID 11616 //
     /* 441883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 441887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 441891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 441895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 441899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 441903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 441907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 441911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 441915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 441919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 441923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 441927 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 441927 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 441932 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 441932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 441937 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 441941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 441943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 441964 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 441964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 441967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 441969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 441974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 441979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 441984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 441989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 441994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 441999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442005 */     GIR_RootConstrainSelectedInstOperands,
     /* 442006 */     // GIR_Coverage, 11616,
     /* 442006 */     GIR_EraseRootFromParent_Done,
     /* 442007 */   // Label 6373: @442007
     /* 442007 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(442136), // Rule ID 11619 //
     /* 442012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 442052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442056 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442056 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442061 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442066 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442093 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442134 */     GIR_RootConstrainSelectedInstOperands,
     /* 442135 */     // GIR_Coverage, 11619,
     /* 442135 */     GIR_EraseRootFromParent_Done,
     /* 442136 */   // Label 6374: @442136
     /* 442136 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(442265), // Rule ID 11620 //
     /* 442141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 442181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442222 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442263 */     GIR_RootConstrainSelectedInstOperands,
     /* 442264 */     // GIR_Coverage, 11620,
     /* 442264 */     GIR_EraseRootFromParent_Done,
     /* 442265 */   // Label 6375: @442265
     /* 442265 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(442394), // Rule ID 7727 //
     /* 442270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 442310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442314 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442351 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442392 */     GIR_RootConstrainSelectedInstOperands,
     /* 442393 */     // GIR_Coverage, 7727,
     /* 442393 */     GIR_EraseRootFromParent_Done,
     /* 442394 */   // Label 6376: @442394
     /* 442394 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(442523), // Rule ID 11601 //
     /* 442399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 442439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442443 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442448 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442480 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 442490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 442495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 442500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 442505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442521 */     GIR_RootConstrainSelectedInstOperands,
     /* 442522 */     // GIR_Coverage, 11601,
     /* 442522 */     GIR_EraseRootFromParent_Done,
     /* 442523 */   // Label 6377: @442523
     /* 442523 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(442652), // Rule ID 11604 //
     /* 442528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 442568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442572 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442572 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442577 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442609 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442650 */     GIR_RootConstrainSelectedInstOperands,
     /* 442651 */     // GIR_Coverage, 11604,
     /* 442651 */     GIR_EraseRootFromParent_Done,
     /* 442652 */   // Label 6378: @442652
     /* 442652 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(442781), // Rule ID 11605 //
     /* 442657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 442681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 442685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 442697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 442701 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442701 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 442706 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 442711 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442738 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 442758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 442763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 442768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 442773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442779 */     GIR_RootConstrainSelectedInstOperands,
     /* 442780 */     // GIR_Coverage, 11605,
     /* 442780 */     GIR_EraseRootFromParent_Done,
     /* 442781 */   // Label 6379: @442781
     /* 442781 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(442910), // Rule ID 11657 //
     /* 442786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 442810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442867 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 442872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 442877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 442882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 442887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 442892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 442897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 442902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 442908 */     GIR_RootConstrainSelectedInstOperands,
     /* 442909 */     // GIR_Coverage, 11657,
     /* 442909 */     GIR_EraseRootFromParent_Done,
     /* 442910 */   // Label 6380: @442910
     /* 442910 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(443039), // Rule ID 11658 //
     /* 442915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 442919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 442923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 442931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 442935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 442939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 442943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 442947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 442951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 442955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 442959 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 442959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 442964 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 442964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 442969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 442973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 442975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442982 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 442996 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 442996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 442999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 443016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 443021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443037 */     GIR_RootConstrainSelectedInstOperands,
     /* 443038 */     // GIR_Coverage, 11658,
     /* 443038 */     GIR_EraseRootFromParent_Done,
     /* 443039 */   // Label 6381: @443039
     /* 443039 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(443168), // Rule ID 11659 //
     /* 443044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443088 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443093 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 443098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443125 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 443135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 443140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443166 */     GIR_RootConstrainSelectedInstOperands,
     /* 443167 */     // GIR_Coverage, 11659,
     /* 443167 */     GIR_EraseRootFromParent_Done,
     /* 443168 */   // Label 6382: @443168
     /* 443168 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(443297), // Rule ID 11660 //
     /* 443173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443217 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 443222 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443254 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 443264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 443269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443295 */     GIR_RootConstrainSelectedInstOperands,
     /* 443296 */     // GIR_Coverage, 11660,
     /* 443296 */     GIR_EraseRootFromParent_Done,
     /* 443297 */   // Label 6383: @443297
     /* 443297 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(443426), // Rule ID 11597 //
     /* 443302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443346 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 443351 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443383 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 443403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 443408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443424 */     GIR_RootConstrainSelectedInstOperands,
     /* 443425 */     // GIR_Coverage, 11597,
     /* 443425 */     GIR_EraseRootFromParent_Done,
     /* 443426 */   // Label 6384: @443426
     /* 443426 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(443555), // Rule ID 11598 //
     /* 443431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 443485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443512 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 443532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 443537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443553 */     GIR_RootConstrainSelectedInstOperands,
     /* 443554 */     // GIR_Coverage, 11598,
     /* 443554 */     GIR_EraseRootFromParent_Done,
     /* 443555 */   // Label 6385: @443555
     /* 443555 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(443684), // Rule ID 11599 //
     /* 443560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443604 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443609 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 443614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443641 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 443651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 443656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443682 */     GIR_RootConstrainSelectedInstOperands,
     /* 443683 */     // GIR_Coverage, 11599,
     /* 443683 */     GIR_EraseRootFromParent_Done,
     /* 443684 */   // Label 6386: @443684
     /* 443684 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(443813), // Rule ID 11600 //
     /* 443689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 443717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 443733 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 443738 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443770 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 443780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 443785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 443790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 443795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443811 */     GIR_RootConstrainSelectedInstOperands,
     /* 443812 */     // GIR_Coverage, 11600,
     /* 443812 */     GIR_EraseRootFromParent_Done,
     /* 443813 */   // Label 6387: @443813
     /* 443813 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(443942), // Rule ID 11642 //
     /* 443818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443862 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443862 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 443867 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443872 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 443876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 443878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 443899 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 443899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 443902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 443904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 443909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 443914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 443919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 443924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 443929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 443934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 443940 */     GIR_RootConstrainSelectedInstOperands,
     /* 443941 */     // GIR_Coverage, 11642,
     /* 443941 */     GIR_EraseRootFromParent_Done,
     /* 443942 */   // Label 6388: @443942
     /* 443942 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(444071), // Rule ID 11643 //
     /* 443947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 443951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 443955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 443963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 443967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 443971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 443975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 443979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 443983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 443987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 443991 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 443991 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 443996 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 443996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444028 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 444048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 444053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 444058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 444063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444069 */     GIR_RootConstrainSelectedInstOperands,
     /* 444070 */     // GIR_Coverage, 11643,
     /* 444070 */     GIR_EraseRootFromParent_Done,
     /* 444071 */   // Label 6389: @444071
     /* 444071 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(444200), // Rule ID 11644 //
     /* 444076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 444100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 444116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 444125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444157 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 444167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 444172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 444187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 444192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444198 */     GIR_RootConstrainSelectedInstOperands,
     /* 444199 */     // GIR_Coverage, 11644,
     /* 444199 */     GIR_EraseRootFromParent_Done,
     /* 444200 */   // Label 6390: @444200
     /* 444200 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(444329), // Rule ID 11645 //
     /* 444205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 444229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 444245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444249 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444254 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 444259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444286 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 444296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 444301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 444316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 444321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444327 */     GIR_RootConstrainSelectedInstOperands,
     /* 444328 */     // GIR_Coverage, 11645,
     /* 444328 */     GIR_EraseRootFromParent_Done,
     /* 444329 */   // Label 6391: @444329
     /* 444329 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(444458), // Rule ID 11582 //
     /* 444334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 444358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 444374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444378 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444383 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 444388 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444415 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 444435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 444440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 444445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 444450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444456 */     GIR_RootConstrainSelectedInstOperands,
     /* 444457 */     // GIR_Coverage, 11582,
     /* 444457 */     GIR_EraseRootFromParent_Done,
     /* 444458 */   // Label 6392: @444458
     /* 444458 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(444587), // Rule ID 11583 //
     /* 444463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 444487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 444503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444507 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 444512 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444544 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 444554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 444559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 444564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 444569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 444574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 444579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444585 */     GIR_RootConstrainSelectedInstOperands,
     /* 444586 */     // GIR_Coverage, 11583,
     /* 444586 */     GIR_EraseRootFromParent_Done,
     /* 444587 */   // Label 6393: @444587
     /* 444587 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(444716), // Rule ID 11584 //
     /* 444592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 444616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 444632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444636 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444636 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 444641 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444673 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 444683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 444688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 444703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 444708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444714 */     GIR_RootConstrainSelectedInstOperands,
     /* 444715 */     // GIR_Coverage, 11584,
     /* 444715 */     GIR_EraseRootFromParent_Done,
     /* 444716 */   // Label 6394: @444716
     /* 444716 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(444845), // Rule ID 11585 //
     /* 444721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 444745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 444749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 444761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 444765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 444775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444802 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 444812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 444817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 444832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 444837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444843 */     GIR_RootConstrainSelectedInstOperands,
     /* 444844 */     // GIR_Coverage, 11585,
     /* 444844 */     GIR_EraseRootFromParent_Done,
     /* 444845 */   // Label 6395: @444845
     /* 444845 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(444974), // Rule ID 11653 //
     /* 444850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 444874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 444878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 444882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 444886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 444890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444894 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 444894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 444899 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 444899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 444904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 444908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 444910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 444931 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 444931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 444934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 444936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 444941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 444946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 444951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 444956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 444961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 444966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 444972 */     GIR_RootConstrainSelectedInstOperands,
     /* 444973 */     // GIR_Coverage, 11653,
     /* 444973 */     GIR_EraseRootFromParent_Done,
     /* 444974 */   // Label 6396: @444974
     /* 444974 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(445103), // Rule ID 11654 //
     /* 444979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 444983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 444987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 444991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 444995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 444999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445023 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445023 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445028 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445046 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445060 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445101 */     GIR_RootConstrainSelectedInstOperands,
     /* 445102 */     // GIR_Coverage, 11654,
     /* 445102 */     GIR_EraseRootFromParent_Done,
     /* 445103 */   // Label 6397: @445103
     /* 445103 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(445232), // Rule ID 11655 //
     /* 445108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445152 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445157 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445162 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445189 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445230 */     GIR_RootConstrainSelectedInstOperands,
     /* 445231 */     // GIR_Coverage, 11655,
     /* 445231 */     GIR_EraseRootFromParent_Done,
     /* 445232 */   // Label 6398: @445232
     /* 445232 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(445361), // Rule ID 11656 //
     /* 445237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445281 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445286 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445291 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445318 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445359 */     GIR_RootConstrainSelectedInstOperands,
     /* 445360 */     // GIR_Coverage, 11656,
     /* 445360 */     GIR_EraseRootFromParent_Done,
     /* 445361 */   // Label 6399: @445361
     /* 445361 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(445490), // Rule ID 11593 //
     /* 445366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445447 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445488 */     GIR_RootConstrainSelectedInstOperands,
     /* 445489 */     // GIR_Coverage, 11593,
     /* 445489 */     GIR_EraseRootFromParent_Done,
     /* 445490 */   // Label 6400: @445490
     /* 445490 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(445619), // Rule ID 11594 //
     /* 445495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445539 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445544 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445562 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445576 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445617 */     GIR_RootConstrainSelectedInstOperands,
     /* 445618 */     // GIR_Coverage, 11594,
     /* 445618 */     GIR_EraseRootFromParent_Done,
     /* 445619 */   // Label 6401: @445619
     /* 445619 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(445748), // Rule ID 11595 //
     /* 445624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445656 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445668 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445673 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445705 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445746 */     GIR_RootConstrainSelectedInstOperands,
     /* 445747 */     // GIR_Coverage, 11595,
     /* 445747 */     GIR_EraseRootFromParent_Done,
     /* 445748 */   // Label 6402: @445748
     /* 445748 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(445877), // Rule ID 11596 //
     /* 445753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 445781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 445797 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445802 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445834 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 445844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 445849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 445854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 445859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 445875 */     GIR_RootConstrainSelectedInstOperands,
     /* 445876 */     // GIR_Coverage, 11596,
     /* 445876 */     GIR_EraseRootFromParent_Done,
     /* 445877 */   // Label 6403: @445877
     /* 445877 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(446006), // Rule ID 11638 //
     /* 445882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 445886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 445890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 445898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 445902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 445906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 445910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 445914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 445918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 445922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 445926 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 445926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 445931 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 445931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 445936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 445940 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 445942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 445963 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 445963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 445966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 445968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 445973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 445978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 445983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 445988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 445993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 445998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446004 */     GIR_RootConstrainSelectedInstOperands,
     /* 446005 */     // GIR_Coverage, 11638,
     /* 446005 */     GIR_EraseRootFromParent_Done,
     /* 446006 */   // Label 6404: @446006
     /* 446006 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(446135), // Rule ID 11639 //
     /* 446011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 446035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446092 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446133 */     GIR_RootConstrainSelectedInstOperands,
     /* 446134 */     // GIR_Coverage, 11639,
     /* 446134 */     GIR_EraseRootFromParent_Done,
     /* 446135 */   // Label 6405: @446135
     /* 446135 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(446264), // Rule ID 11640 //
     /* 446140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 446164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446184 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446189 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446221 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446262 */     GIR_RootConstrainSelectedInstOperands,
     /* 446263 */     // GIR_Coverage, 11640,
     /* 446263 */     GIR_EraseRootFromParent_Done,
     /* 446264 */   // Label 6406: @446264
     /* 446264 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(446393), // Rule ID 11641 //
     /* 446269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 446293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446313 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446318 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446323 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446343 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446350 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446391 */     GIR_RootConstrainSelectedInstOperands,
     /* 446392 */     // GIR_Coverage, 11641,
     /* 446392 */     GIR_EraseRootFromParent_Done,
     /* 446393 */   // Label 6407: @446393
     /* 446393 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(446522), // Rule ID 11578 //
     /* 446398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 446422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446442 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446442 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446447 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446479 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446520 */     GIR_RootConstrainSelectedInstOperands,
     /* 446521 */     // GIR_Coverage, 11578,
     /* 446521 */     GIR_EraseRootFromParent_Done,
     /* 446522 */   // Label 6408: @446522
     /* 446522 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(446651), // Rule ID 11579 //
     /* 446527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 446551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446571 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446576 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446608 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 446618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 446623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 446628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 446633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446649 */     GIR_RootConstrainSelectedInstOperands,
     /* 446650 */     // GIR_Coverage, 11579,
     /* 446650 */     GIR_EraseRootFromParent_Done,
     /* 446651 */   // Label 6409: @446651
     /* 446651 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(446780), // Rule ID 11580 //
     /* 446656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 446680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446737 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446778 */     GIR_RootConstrainSelectedInstOperands,
     /* 446779 */     // GIR_Coverage, 11580,
     /* 446779 */     GIR_EraseRootFromParent_Done,
     /* 446780 */   // Label 6410: @446780
     /* 446780 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(446909), // Rule ID 11581 //
     /* 446785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 446809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 446813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 446825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446829 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 446834 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 446839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446866 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 446871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 446876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 446881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 446886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 446891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 446896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 446901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 446907 */     GIR_RootConstrainSelectedInstOperands,
     /* 446908 */     // GIR_Coverage, 11581,
     /* 446908 */     GIR_EraseRootFromParent_Done,
     /* 446909 */   // Label 6411: @446909
     /* 446909 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(447038), // Rule ID 11587 //
     /* 446914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 446918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 446922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 446926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 446930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 446934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 446938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 446942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 446946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 446950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 446954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 446958 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 446958 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 446963 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 446963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 446968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 446972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 446974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 446995 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 446995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 446998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 447005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 447010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447036 */     GIR_RootConstrainSelectedInstOperands,
     /* 447037 */     // GIR_Coverage, 11587,
     /* 447037 */     GIR_EraseRootFromParent_Done,
     /* 447038 */   // Label 6412: @447038
     /* 447038 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(447167), // Rule ID 11588 //
     /* 447043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 447083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447087 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 447092 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447097 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447124 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 447134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 447139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447165 */     GIR_RootConstrainSelectedInstOperands,
     /* 447166 */     // GIR_Coverage, 11588,
     /* 447166 */     GIR_EraseRootFromParent_Done,
     /* 447167 */   // Label 6413: @447167
     /* 447167 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(447296), // Rule ID 11591 //
     /* 447172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 447212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447216 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447216 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 447221 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447246 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447253 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 447273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 447278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447294 */     GIR_RootConstrainSelectedInstOperands,
     /* 447295 */     // GIR_Coverage, 11591,
     /* 447295 */     GIR_EraseRootFromParent_Done,
     /* 447296 */   // Label 6414: @447296
     /* 447296 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(447425), // Rule ID 11592 //
     /* 447301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 447341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 447355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447382 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 447402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 447407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447423 */     GIR_RootConstrainSelectedInstOperands,
     /* 447424 */     // GIR_Coverage, 11592,
     /* 447424 */     GIR_EraseRootFromParent_Done,
     /* 447425 */   // Label 6415: @447425
     /* 447425 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(447554), // Rule ID 11572 //
     /* 447430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 447470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447474 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447479 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 447484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447511 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 447521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 447526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447552 */     GIR_RootConstrainSelectedInstOperands,
     /* 447553 */     // GIR_Coverage, 11572,
     /* 447553 */     GIR_EraseRootFromParent_Done,
     /* 447554 */   // Label 6416: @447554
     /* 447554 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(447683), // Rule ID 11573 //
     /* 447559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 447599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447603 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447603 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 447608 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447613 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447640 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 447650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 447655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 447660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 447665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447681 */     GIR_RootConstrainSelectedInstOperands,
     /* 447682 */     // GIR_Coverage, 11573,
     /* 447682 */     GIR_EraseRootFromParent_Done,
     /* 447683 */   // Label 6417: @447683
     /* 447683 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(447812), // Rule ID 11576 //
     /* 447688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 447728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447732 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447732 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 447737 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447769 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 447789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 447794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447810 */     GIR_RootConstrainSelectedInstOperands,
     /* 447811 */     // GIR_Coverage, 11576,
     /* 447811 */     GIR_EraseRootFromParent_Done,
     /* 447812 */   // Label 6418: @447812
     /* 447812 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(447941), // Rule ID 11577 //
     /* 447817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 447857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 447861 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447861 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447866 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 447871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 447875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 447877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 447898 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 447898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 447901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 447903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 447908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 447913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 447918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 447923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 447928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 447933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 447939 */     GIR_RootConstrainSelectedInstOperands,
     /* 447940 */     // GIR_Coverage, 11577,
     /* 447940 */     GIR_EraseRootFromParent_Done,
     /* 447941 */   // Label 6419: @447941
     /* 447941 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(448070), // Rule ID 7726 //
     /* 447946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 447950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 447954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 447958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 447962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 447966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 447970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 447974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 447978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 447982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 447986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 447990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 447990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 447995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 447995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448027 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 448037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 448042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448068 */     GIR_RootConstrainSelectedInstOperands,
     /* 448069 */     // GIR_Coverage, 7726,
     /* 448069 */     GIR_EraseRootFromParent_Done,
     /* 448070 */   // Label 6420: @448070
     /* 448070 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(448199), // Rule ID 11586 //
     /* 448075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 448099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 448115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 448119 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 448129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448156 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 448166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 448171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448197 */     GIR_RootConstrainSelectedInstOperands,
     /* 448198 */     // GIR_Coverage, 11586,
     /* 448198 */     GIR_EraseRootFromParent_Done,
     /* 448199 */   // Label 6421: @448199
     /* 448199 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(448328), // Rule ID 11589 //
     /* 448204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 448228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 448244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 448248 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448253 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 448258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448285 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 448305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 448310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448326 */     GIR_RootConstrainSelectedInstOperands,
     /* 448327 */     // GIR_Coverage, 11589,
     /* 448327 */     GIR_EraseRootFromParent_Done,
     /* 448328 */   // Label 6422: @448328
     /* 448328 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(448457), // Rule ID 11590 //
     /* 448333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 448357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 448373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 448377 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448377 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 448382 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448387 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448414 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 448434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 448439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448455 */     GIR_RootConstrainSelectedInstOperands,
     /* 448456 */     // GIR_Coverage, 11590,
     /* 448456 */     GIR_EraseRootFromParent_Done,
     /* 448457 */   // Label 6423: @448457
     /* 448457 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(448586), // Rule ID 7725 //
     /* 448462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 448486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 448502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448506 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448506 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 448511 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448543 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 448553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 448558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448584 */     GIR_RootConstrainSelectedInstOperands,
     /* 448585 */     // GIR_Coverage, 7725,
     /* 448585 */     GIR_EraseRootFromParent_Done,
     /* 448586 */   // Label 6424: @448586
     /* 448586 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(448715), // Rule ID 11571 //
     /* 448591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 448615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 448631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 448645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448672 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 448682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 448687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 448692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 448697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448713 */     GIR_RootConstrainSelectedInstOperands,
     /* 448714 */     // GIR_Coverage, 11571,
     /* 448714 */     GIR_EraseRootFromParent_Done,
     /* 448715 */   // Label 6425: @448715
     /* 448715 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(448844), // Rule ID 11574 //
     /* 448720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 448744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 448760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448764 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 448774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448801 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 448821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 448826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448842 */     GIR_RootConstrainSelectedInstOperands,
     /* 448843 */     // GIR_Coverage, 11574,
     /* 448843 */     GIR_EraseRootFromParent_Done,
     /* 448844 */   // Label 6426: @448844
     /* 448844 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(448973), // Rule ID 11575 //
     /* 448849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 448873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 448877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 448881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 448885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 448889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 448893 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 448893 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 448898 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 448898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 448903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 448907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 448909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 448930 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 448930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 448933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 448935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 448940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 448945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 448950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 448955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 448960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 448965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 448971 */     GIR_RootConstrainSelectedInstOperands,
     /* 448972 */     // GIR_Coverage, 11575,
     /* 448972 */     GIR_EraseRootFromParent_Done,
     /* 448973 */   // Label 6427: @448973
     /* 448973 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(449102), // Rule ID 11557 //
     /* 448978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 448982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 448986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 448990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 448994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 448998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449022 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449027 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449059 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449100 */     GIR_RootConstrainSelectedInstOperands,
     /* 449101 */     // GIR_Coverage, 11557,
     /* 449101 */     GIR_EraseRootFromParent_Done,
     /* 449102 */   // Label 6428: @449102
     /* 449102 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(449231), // Rule ID 11558 //
     /* 449107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449151 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449156 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449188 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449229 */     GIR_RootConstrainSelectedInstOperands,
     /* 449230 */     // GIR_Coverage, 11558,
     /* 449230 */     GIR_EraseRootFromParent_Done,
     /* 449231 */   // Label 6429: @449231
     /* 449231 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(449360), // Rule ID 11561 //
     /* 449236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449317 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449358 */     GIR_RootConstrainSelectedInstOperands,
     /* 449359 */     // GIR_Coverage, 11561,
     /* 449359 */     GIR_EraseRootFromParent_Done,
     /* 449360 */   // Label 6430: @449360
     /* 449360 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(449489), // Rule ID 11562 //
     /* 449365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 449409 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449414 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449446 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449487 */     GIR_RootConstrainSelectedInstOperands,
     /* 449488 */     // GIR_Coverage, 11562,
     /* 449488 */     GIR_EraseRootFromParent_Done,
     /* 449489 */   // Label 6431: @449489
     /* 449489 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(449618), // Rule ID 11542 //
     /* 449494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 449538 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449538 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449543 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449548 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449575 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449616 */     GIR_RootConstrainSelectedInstOperands,
     /* 449617 */     // GIR_Coverage, 11542,
     /* 449617 */     GIR_EraseRootFromParent_Done,
     /* 449618 */   // Label 6432: @449618
     /* 449618 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(449747), // Rule ID 11543 //
     /* 449623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 449667 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449672 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449677 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449704 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 449714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 449719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 449724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 449729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449745 */     GIR_RootConstrainSelectedInstOperands,
     /* 449746 */     // GIR_Coverage, 11543,
     /* 449746 */     GIR_EraseRootFromParent_Done,
     /* 449747 */   // Label 6433: @449747
     /* 449747 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(449876), // Rule ID 11546 //
     /* 449752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 449796 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449796 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449801 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449806 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449833 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 449874 */     GIR_RootConstrainSelectedInstOperands,
     /* 449875 */     // GIR_Coverage, 11546,
     /* 449875 */     GIR_EraseRootFromParent_Done,
     /* 449876 */   // Label 6434: @449876
     /* 449876 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(450005), // Rule ID 11547 //
     /* 449881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 449885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 449889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 449897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 449901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 449905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 449909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 449913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 449917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 449921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 449925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 449925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 449930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 449930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 449935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 449939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 449941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 449962 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 449962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 449965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 449967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 449972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 449977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 449982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 449987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 449992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 449997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450003 */     GIR_RootConstrainSelectedInstOperands,
     /* 450004 */     // GIR_Coverage, 11547,
     /* 450004 */     GIR_EraseRootFromParent_Done,
     /* 450005 */   // Label 6435: @450005
     /* 450005 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(450134), // Rule ID 7724 //
     /* 450010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 450054 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450059 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450091 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450132 */     GIR_RootConstrainSelectedInstOperands,
     /* 450133 */     // GIR_Coverage, 7724,
     /* 450133 */     GIR_EraseRootFromParent_Done,
     /* 450134 */   // Label 6436: @450134
     /* 450134 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(450263), // Rule ID 11556 //
     /* 450139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 450183 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450183 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450188 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450213 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450220 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450261 */     GIR_RootConstrainSelectedInstOperands,
     /* 450262 */     // GIR_Coverage, 11556,
     /* 450262 */     GIR_EraseRootFromParent_Done,
     /* 450263 */   // Label 6437: @450263
     /* 450263 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(450392), // Rule ID 11559 //
     /* 450268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 450312 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450312 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450317 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450349 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450390 */     GIR_RootConstrainSelectedInstOperands,
     /* 450391 */     // GIR_Coverage, 11559,
     /* 450391 */     GIR_EraseRootFromParent_Done,
     /* 450392 */   // Label 6438: @450392
     /* 450392 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(450521), // Rule ID 11560 //
     /* 450397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 450441 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450446 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450471 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450478 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450519 */     GIR_RootConstrainSelectedInstOperands,
     /* 450520 */     // GIR_Coverage, 11560,
     /* 450520 */     GIR_EraseRootFromParent_Done,
     /* 450521 */   // Label 6439: @450521
     /* 450521 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(450650), // Rule ID 7723 //
     /* 450526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450607 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450648 */     GIR_RootConstrainSelectedInstOperands,
     /* 450649 */     // GIR_Coverage, 7723,
     /* 450649 */     GIR_EraseRootFromParent_Done,
     /* 450650 */   // Label 6440: @450650
     /* 450650 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(450779), // Rule ID 11541 //
     /* 450655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450699 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450704 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450736 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 450746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 450751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 450756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 450761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450777 */     GIR_RootConstrainSelectedInstOperands,
     /* 450778 */     // GIR_Coverage, 11541,
     /* 450778 */     GIR_EraseRootFromParent_Done,
     /* 450779 */   // Label 6441: @450779
     /* 450779 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(450908), // Rule ID 11544 //
     /* 450784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450828 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450828 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450833 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450865 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 450875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 450880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 450885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 450890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 450895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 450900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 450906 */     GIR_RootConstrainSelectedInstOperands,
     /* 450907 */     // GIR_Coverage, 11544,
     /* 450907 */     GIR_EraseRootFromParent_Done,
     /* 450908 */   // Label 6442: @450908
     /* 450908 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(451037), // Rule ID 11545 //
     /* 450913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 450917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 450921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 450929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 450933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 450937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 450941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 450945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 450949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 450953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 450957 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 450957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 450962 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 450962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 450967 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 450971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 450973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450987 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 450994 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 450994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 450997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 450999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 451014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 451019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 451024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 451029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451035 */     GIR_RootConstrainSelectedInstOperands,
     /* 451036 */     // GIR_Coverage, 11545,
     /* 451036 */     GIR_EraseRootFromParent_Done,
     /* 451037 */   // Label 6443: @451037
     /* 451037 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(451166), // Rule ID 11627 //
     /* 451042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451074 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451086 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451086 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451091 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 451100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 451102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451123 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 451126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451164 */     GIR_RootConstrainSelectedInstOperands,
     /* 451165 */     // GIR_Coverage, 11627,
     /* 451165 */     GIR_EraseRootFromParent_Done,
     /* 451166 */   // Label 6444: @451166
     /* 451166 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(451295), // Rule ID 11628 //
     /* 451171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 451229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 451231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451252 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 451255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451293 */     GIR_RootConstrainSelectedInstOperands,
     /* 451294 */     // GIR_Coverage, 11628,
     /* 451294 */     GIR_EraseRootFromParent_Done,
     /* 451295 */   // Label 6445: @451295
     /* 451295 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(451424), // Rule ID 11629 //
     /* 451300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451344 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451349 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 451358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 451360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451367 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451381 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 451384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 451391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 451396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451422 */     GIR_RootConstrainSelectedInstOperands,
     /* 451423 */     // GIR_Coverage, 11629,
     /* 451423 */     GIR_EraseRootFromParent_Done,
     /* 451424 */   // Label 6446: @451424
     /* 451424 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(451553), // Rule ID 11630 //
     /* 451429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 451473 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451473 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451478 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 451487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 451489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451510 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 451513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 451520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 451525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451551 */     GIR_RootConstrainSelectedInstOperands,
     /* 451552 */     // GIR_Coverage, 11630,
     /* 451552 */     GIR_EraseRootFromParent_Done,
     /* 451553 */   // Label 6447: @451553
     /* 451553 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(451682), // Rule ID 11567 //
     /* 451558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451602 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451607 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 451616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 451618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451639 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 451642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451680 */     GIR_RootConstrainSelectedInstOperands,
     /* 451681 */     // GIR_Coverage, 11567,
     /* 451681 */     GIR_EraseRootFromParent_Done,
     /* 451682 */   // Label 6448: @451682
     /* 451682 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(451811), // Rule ID 11568 //
     /* 451687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451731 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451731 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451736 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 451745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 451747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451768 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 451771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 451778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 451783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 451788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 451793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451809 */     GIR_RootConstrainSelectedInstOperands,
     /* 451810 */     // GIR_Coverage, 11568,
     /* 451810 */     GIR_EraseRootFromParent_Done,
     /* 451811 */   // Label 6449: @451811
     /* 451811 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(451940), // Rule ID 11569 //
     /* 451816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 451874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 451876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451883 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 451897 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 451897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 451900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 451902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 451907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 451912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 451917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 451922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 451927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 451932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 451938 */     GIR_RootConstrainSelectedInstOperands,
     /* 451939 */     // GIR_Coverage, 11569,
     /* 451939 */     GIR_EraseRootFromParent_Done,
     /* 451940 */   // Label 6450: @451940
     /* 451940 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(452069), // Rule ID 11570 //
     /* 451945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 451949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 451953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 451961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 451965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 451969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 451973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 451977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 451981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 451985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 451989 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 451989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 451994 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 451994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 451999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452026 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 452036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 452041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452067 */     GIR_RootConstrainSelectedInstOperands,
     /* 452068 */     // GIR_Coverage, 11570,
     /* 452068 */     GIR_EraseRootFromParent_Done,
     /* 452069 */   // Label 6451: @452069
     /* 452069 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(452198), // Rule ID 11612 //
     /* 452074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 452098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 452102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 452106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 452110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 452114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452118 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452118 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 452123 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 452128 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452155 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 452175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 452180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452196 */     GIR_RootConstrainSelectedInstOperands,
     /* 452197 */     // GIR_Coverage, 11612,
     /* 452197 */     GIR_EraseRootFromParent_Done,
     /* 452198 */   // Label 6452: @452198
     /* 452198 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(452327), // Rule ID 11613 //
     /* 452203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 452227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 452231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 452235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 452239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 452243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452247 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452247 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 452252 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 452257 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452284 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 452304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 452309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452325 */     GIR_RootConstrainSelectedInstOperands,
     /* 452326 */     // GIR_Coverage, 11613,
     /* 452326 */     GIR_EraseRootFromParent_Done,
     /* 452327 */   // Label 6453: @452327
     /* 452327 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(452456), // Rule ID 11614 //
     /* 452332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 452356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 452360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 452364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 452368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 452372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452376 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452376 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 452381 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 452386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452413 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 452423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 452428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452454 */     GIR_RootConstrainSelectedInstOperands,
     /* 452455 */     // GIR_Coverage, 11614,
     /* 452455 */     GIR_EraseRootFromParent_Done,
     /* 452456 */   // Label 6454: @452456
     /* 452456 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(452585), // Rule ID 11615 //
     /* 452461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 452485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 452489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 452493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 452497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 452501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 452505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 452510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 452515 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452542 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 452552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 452557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452583 */     GIR_RootConstrainSelectedInstOperands,
     /* 452584 */     // GIR_Coverage, 11615,
     /* 452584 */     GIR_EraseRootFromParent_Done,
     /* 452585 */   // Label 6455: @452585
     /* 452585 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(452714), // Rule ID 11552 //
     /* 452590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 452614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 452618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 452622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 452626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 452630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452634 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 452639 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 452644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452671 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 452691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 452696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452712 */     GIR_RootConstrainSelectedInstOperands,
     /* 452713 */     // GIR_Coverage, 11552,
     /* 452713 */     GIR_EraseRootFromParent_Done,
     /* 452714 */   // Label 6456: @452714
     /* 452714 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(452843), // Rule ID 11553 //
     /* 452719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 452743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 452747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 452751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 452755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 452759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452763 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 452768 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 452773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452800 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 452810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 452815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 452820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 452825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452841 */     GIR_RootConstrainSelectedInstOperands,
     /* 452842 */     // GIR_Coverage, 11553,
     /* 452842 */     GIR_EraseRootFromParent_Done,
     /* 452843 */   // Label 6457: @452843
     /* 452843 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(452972), // Rule ID 11554 //
     /* 452848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 452872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 452876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 452880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 452884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 452888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452892 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 452892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 452897 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 452897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 452902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 452906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 452908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 452929 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 452929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 452932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 452934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 452939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 452944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 452949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 452954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 452959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 452964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 452970 */     GIR_RootConstrainSelectedInstOperands,
     /* 452971 */     // GIR_Coverage, 11554,
     /* 452971 */     GIR_EraseRootFromParent_Done,
     /* 452972 */   // Label 6458: @452972
     /* 452972 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(453101), // Rule ID 11555 //
     /* 452977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 452981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 452985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 452989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 452993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 452997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 453001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 453005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453021 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453026 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453058 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 453068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 453073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 453088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 453093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453099 */     GIR_RootConstrainSelectedInstOperands,
     /* 453100 */     // GIR_Coverage, 11555,
     /* 453100 */     GIR_EraseRootFromParent_Done,
     /* 453101 */   // Label 6459: @453101
     /* 453101 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(453230), // Rule ID 11623 //
     /* 453106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 453122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 453126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 453130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453187 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453228 */     GIR_RootConstrainSelectedInstOperands,
     /* 453229 */     // GIR_Coverage, 11623,
     /* 453229 */     GIR_EraseRootFromParent_Done,
     /* 453230 */   // Label 6460: @453230
     /* 453230 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(453359), // Rule ID 11624 //
     /* 453235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 453251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 453255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 453259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453279 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453284 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453316 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453357 */     GIR_RootConstrainSelectedInstOperands,
     /* 453358 */     // GIR_Coverage, 11624,
     /* 453358 */     GIR_EraseRootFromParent_Done,
     /* 453359 */   // Label 6461: @453359
     /* 453359 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(453488), // Rule ID 11625 //
     /* 453364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 453380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 453384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 453388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453408 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453413 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453445 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453486 */     GIR_RootConstrainSelectedInstOperands,
     /* 453487 */     // GIR_Coverage, 11625,
     /* 453487 */     GIR_EraseRootFromParent_Done,
     /* 453488 */   // Label 6462: @453488
     /* 453488 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(453617), // Rule ID 11626 //
     /* 453493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 453509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 453513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 453517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 453537 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453542 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453553 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453574 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453615 */     GIR_RootConstrainSelectedInstOperands,
     /* 453616 */     // GIR_Coverage, 11626,
     /* 453616 */     GIR_EraseRootFromParent_Done,
     /* 453617 */   // Label 6463: @453617
     /* 453617 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(453746), // Rule ID 11563 //
     /* 453622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 453638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 453642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 453646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453666 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453671 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453676 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453703 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453744 */     GIR_RootConstrainSelectedInstOperands,
     /* 453745 */     // GIR_Coverage, 11563,
     /* 453745 */     GIR_EraseRootFromParent_Done,
     /* 453746 */   // Label 6464: @453746
     /* 453746 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(453875), // Rule ID 11564 //
     /* 453751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 453767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 453771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 453775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453832 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 453842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 453847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 453852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 453857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453873 */     GIR_RootConstrainSelectedInstOperands,
     /* 453874 */     // GIR_Coverage, 11564,
     /* 453874 */     GIR_EraseRootFromParent_Done,
     /* 453875 */   // Label 6465: @453875
     /* 453875 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(454004), // Rule ID 11565 //
     /* 453880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 453884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 453888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 453896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 453900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 453904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 453908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 453912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 453916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 453920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 453924 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 453924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 453929 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 453929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 453934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 453938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 453940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 453961 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 453961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 453964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 453966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 453971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 453976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 453981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 453986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 453991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 453996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 453999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454002 */     GIR_RootConstrainSelectedInstOperands,
     /* 454003 */     // GIR_Coverage, 11565,
     /* 454003 */     GIR_EraseRootFromParent_Done,
     /* 454004 */   // Label 6466: @454004
     /* 454004 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(454133), // Rule ID 11566 //
     /* 454009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 454037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454053 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454053 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454058 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454063 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454090 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454131 */     GIR_RootConstrainSelectedInstOperands,
     /* 454132 */     // GIR_Coverage, 11566,
     /* 454132 */     GIR_EraseRootFromParent_Done,
     /* 454133 */   // Label 6467: @454133
     /* 454133 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(454262), // Rule ID 11608 //
     /* 454138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 454166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 454182 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454187 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454219 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454260 */     GIR_RootConstrainSelectedInstOperands,
     /* 454261 */     // GIR_Coverage, 11608,
     /* 454261 */     GIR_EraseRootFromParent_Done,
     /* 454262 */   // Label 6468: @454262
     /* 454262 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(454391), // Rule ID 11609 //
     /* 454267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 454295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 454311 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454316 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454321 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454348 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454389 */     GIR_RootConstrainSelectedInstOperands,
     /* 454390 */     // GIR_Coverage, 11609,
     /* 454390 */     GIR_EraseRootFromParent_Done,
     /* 454391 */   // Label 6469: @454391
     /* 454391 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(454520), // Rule ID 11610 //
     /* 454396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 454424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 454440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454477 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454518 */     GIR_RootConstrainSelectedInstOperands,
     /* 454519 */     // GIR_Coverage, 11610,
     /* 454519 */     GIR_EraseRootFromParent_Done,
     /* 454520 */   // Label 6470: @454520
     /* 454520 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(454649), // Rule ID 11611 //
     /* 454525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 454553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 454569 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454574 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454606 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 454616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 454621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 454626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 454631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454647 */     GIR_RootConstrainSelectedInstOperands,
     /* 454648 */     // GIR_Coverage, 11611,
     /* 454648 */     GIR_EraseRootFromParent_Done,
     /* 454649 */   // Label 6471: @454649
     /* 454649 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(454778), // Rule ID 11548 //
     /* 454654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 454682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454698 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454703 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454708 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454714 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454735 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454776 */     GIR_RootConstrainSelectedInstOperands,
     /* 454777 */     // GIR_Coverage, 11548,
     /* 454777 */     GIR_EraseRootFromParent_Done,
     /* 454778 */   // Label 6472: @454778
     /* 454778 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(454907), // Rule ID 11549 //
     /* 454783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 454811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454827 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454832 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454864 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 454874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 454879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 454884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 454889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 454894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 454899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 454905 */     GIR_RootConstrainSelectedInstOperands,
     /* 454906 */     // GIR_Coverage, 11549,
     /* 454906 */     GIR_EraseRootFromParent_Done,
     /* 454907 */   // Label 6473: @454907
     /* 454907 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(455036), // Rule ID 11550 //
     /* 454912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 454916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 454920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 454928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 454932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 454936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 454940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 454944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 454948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 454952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 454956 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 454956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 454961 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 454961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 454966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 454970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 454972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 454993 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 454993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 454996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 454998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455034 */     GIR_RootConstrainSelectedInstOperands,
     /* 455035 */     // GIR_Coverage, 11550,
     /* 455035 */     GIR_EraseRootFromParent_Done,
     /* 455036 */   // Label 6474: @455036
     /* 455036 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(455165), // Rule ID 11551 //
     /* 455041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 455061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 455065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 455069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 455073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 455077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 455081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 455085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 455090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 455090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 455095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 455099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 455101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455122 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 455125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 455142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 455147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455163 */     GIR_RootConstrainSelectedInstOperands,
     /* 455164 */     // GIR_Coverage, 11551,
     /* 455164 */     GIR_EraseRootFromParent_Done,
     /* 455165 */   // Label 6475: @455165
     /* 455165 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(455277), // Rule ID 13386 //
     /* 455170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 455181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 455185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 455193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 455201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 455205 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 455207 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 455211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 455213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455234 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 455254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 455259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 455264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 455269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455275 */     GIR_RootConstrainSelectedInstOperands,
     /* 455276 */     // GIR_Coverage, 13386,
     /* 455276 */     GIR_EraseRootFromParent_Done,
     /* 455277 */   // Label 6476: @455277
     /* 455277 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(455389), // Rule ID 13385 //
     /* 455282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 455293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 455297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 455305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 455313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 455317 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 455319 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 455323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 455325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455346 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 455366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 455371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 455376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 455381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455387 */     GIR_RootConstrainSelectedInstOperands,
     /* 455388 */     // GIR_Coverage, 13385,
     /* 455388 */     GIR_EraseRootFromParent_Done,
     /* 455389 */   // Label 6477: @455389
     /* 455389 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(455501), // Rule ID 7860 //
     /* 455394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 455409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 455417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 455425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 455429 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 455431 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 455435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 455437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455458 */     // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455499 */     GIR_RootConstrainSelectedInstOperands,
     /* 455500 */     // GIR_Coverage, 7860,
     /* 455500 */     GIR_EraseRootFromParent_Done,
     /* 455501 */   // Label 6478: @455501
     /* 455501 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(455613), // Rule ID 7859 //
     /* 455506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 455521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 455529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 455537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 455541 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 455543 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 455547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 455549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455563 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455570 */     // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455611 */     GIR_RootConstrainSelectedInstOperands,
     /* 455612 */     // GIR_Coverage, 7859,
     /* 455612 */     GIR_EraseRootFromParent_Done,
     /* 455613 */   // Label 6479: @455613
     /* 455613 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(455709), // Rule ID 13378 //
     /* 455618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 455629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 455641 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 455643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 455645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455666 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 455686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 455691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 455696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 455701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455707 */     GIR_RootConstrainSelectedInstOperands,
     /* 455708 */     // GIR_Coverage, 13378,
     /* 455708 */     GIR_EraseRootFromParent_Done,
     /* 455709 */   // Label 6480: @455709
     /* 455709 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(455805), // Rule ID 13377 //
     /* 455714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 455725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 455737 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 455739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 455741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455762 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 455772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 455777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 455782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 455787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 455792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 455797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455803 */     GIR_RootConstrainSelectedInstOperands,
     /* 455804 */     // GIR_Coverage, 13377,
     /* 455804 */     GIR_EraseRootFromParent_Done,
     /* 455805 */   // Label 6481: @455805
     /* 455805 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(455901), // Rule ID 7852 //
     /* 455810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 455825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 455833 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 455835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 455837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455858 */     // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455899 */     GIR_RootConstrainSelectedInstOperands,
     /* 455900 */     // GIR_Coverage, 7852,
     /* 455900 */     GIR_EraseRootFromParent_Done,
     /* 455901 */   // Label 6482: @455901
     /* 455901 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(455997), // Rule ID 7851 //
     /* 455906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 455909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 455913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 455917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 455921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 455925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 455929 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 455931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 455933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 455954 */     // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 455954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 455957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 455959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 455964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 455969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 455974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 455979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 455984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 455989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 455995 */     GIR_RootConstrainSelectedInstOperands,
     /* 455996 */     // GIR_Coverage, 7851,
     /* 455996 */     GIR_EraseRootFromParent_Done,
     /* 455997 */   // Label 6483: @455997
     /* 455997 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(456032), // Rule ID 93 //
     /* 456002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 456005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 456009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 456013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 456017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13745),
     /* 456021 */     // (fmaxnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13745>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 456021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
     /* 456026 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 456030 */     GIR_RootConstrainSelectedInstOperands,
     /* 456031 */     // GIR_Coverage, 93,
     /* 456031 */     GIR_Done,
     /* 456032 */   // Label 6484: @456032
     /* 456032 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(456092), // Rule ID 804 //
     /* 456037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 456048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456055 */     // (fmaxnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 456055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 456058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 456065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 456075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 456085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 456090 */     GIR_RootConstrainSelectedInstOperands,
     /* 456091 */     // GIR_Coverage, 804,
     /* 456091 */     GIR_EraseRootFromParent_Done,
     /* 456092 */   // Label 6485: @456092
     /* 456092 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(456152), // Rule ID 8558 //
     /* 456097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 456115 */     // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 456115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 456118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 456125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 456135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 456145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 456150 */     GIR_RootConstrainSelectedInstOperands,
     /* 456151 */     // GIR_Coverage, 8558,
     /* 456151 */     GIR_EraseRootFromParent_Done,
     /* 456152 */   // Label 6486: @456152
     /* 456152 */   GIM_Reject,
     /* 456153 */ // Label 6347: @456153
     /* 456153 */ GIM_Reject,
     /* 456154 */ // Label 5937: @456154
     /* 456154 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(456406),
     /* 456159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 456162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 456165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 456169 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(456228), // Rule ID 919 //
     /* 456174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 456177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 456184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456191 */     // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 456191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 456194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 456201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 456211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 456221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 456226 */     GIR_RootConstrainSelectedInstOperands,
     /* 456227 */     // GIR_Coverage, 919,
     /* 456227 */     GIR_EraseRootFromParent_Done,
     /* 456228 */   // Label 6488: @456228
     /* 456228 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(456287), // Rule ID 938 //
     /* 456233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 456236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 456243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456250 */     // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 456250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 456253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 456260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 456270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 456280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 456285 */     GIR_RootConstrainSelectedInstOperands,
     /* 456286 */     // GIR_Coverage, 938,
     /* 456286 */     GIR_EraseRootFromParent_Done,
     /* 456287 */   // Label 6489: @456287
     /* 456287 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(456346), // Rule ID 8584 //
     /* 456292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 456295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 456309 */     // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 456309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 456312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 456319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 456329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 456339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 456344 */     GIR_RootConstrainSelectedInstOperands,
     /* 456345 */     // GIR_Coverage, 8584,
     /* 456345 */     GIR_EraseRootFromParent_Done,
     /* 456346 */   // Label 6490: @456346
     /* 456346 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(456405), // Rule ID 8598 //
     /* 456351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 456354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 456368 */     // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 456368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 456371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 456378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 456388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 456398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 456403 */     GIR_RootConstrainSelectedInstOperands,
     /* 456404 */     // GIR_Coverage, 8598,
     /* 456404 */     GIR_EraseRootFromParent_Done,
     /* 456405 */   // Label 6491: @456405
     /* 456405 */   GIM_Reject,
     /* 456406 */ // Label 6487: @456406
     /* 456406 */ GIM_Reject,
     /* 456407 */ // Label 5938: @456407
     /* 456407 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(456478), // Rule ID 1096 //
     /* 456412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 456415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 456418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 456429 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 456436 */   // (fmaxnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 456436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 456439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 456446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 456456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456476 */   GIR_RootConstrainSelectedInstOperands,
     /* 456477 */   // GIR_Coverage, 1096,
     /* 456477 */   GIR_EraseRootFromParent_Done,
     /* 456478 */ // Label 6492: @456478
     /* 456478 */ GIM_Reject,
     /* 456479 */ // Label 5939: @456479
     /* 456479 */ GIM_Reject,
     /* 456480 */ // Label 82: @456480
     /* 456480 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 6497*/ GIMT_Encode4(528258),
     /* 456491 */ /*GILLT_s16*//*Label 6493*/ GIMT_Encode4(456507),
     /* 456495 */ /*GILLT_s32*//*Label 6494*/ GIMT_Encode4(510421),
     /* 456499 */ /*GILLT_s64*//*Label 6495*/ GIMT_Encode4(527933),
     /* 456503 */ /*GILLT_v2s16*//*Label 6496*/ GIMT_Encode4(528186),
     /* 456507 */ // Label 6493: @456507
     /* 456507 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(510420),
     /* 456512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 456515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 456518 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(456653), // Rule ID 12277 //
     /* 456523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 456566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456607 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 456610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 456617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456651 */     GIR_RootConstrainSelectedInstOperands,
     /* 456652 */     // GIR_Coverage, 12277,
     /* 456652 */     GIR_EraseRootFromParent_Done,
     /* 456653 */   // Label 6499: @456653
     /* 456653 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(456788), // Rule ID 12278 //
     /* 456658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 456701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456742 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 456745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 456752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 456757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 456762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 456767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456786 */     GIR_RootConstrainSelectedInstOperands,
     /* 456787 */     // GIR_Coverage, 12278,
     /* 456787 */     GIR_EraseRootFromParent_Done,
     /* 456788 */   // Label 6500: @456788
     /* 456788 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(456923), // Rule ID 12281 //
     /* 456793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 456836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456877 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 456877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 456880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 456882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 456887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 456892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 456897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 456902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 456907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 456912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 456921 */     GIR_RootConstrainSelectedInstOperands,
     /* 456922 */     // GIR_Coverage, 12281,
     /* 456922 */     GIR_EraseRootFromParent_Done,
     /* 456923 */   // Label 6501: @456923
     /* 456923 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(457058), // Rule ID 12282 //
     /* 456928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 456931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 456935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 456939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 456947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 456951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 456955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 456959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 456963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 456967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 456971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 456975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 456975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 456980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 456980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 456985 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 456989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 456991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 456998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457012 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 457015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457056 */     GIR_RootConstrainSelectedInstOperands,
     /* 457057 */     // GIR_Coverage, 12282,
     /* 457057 */     GIR_EraseRootFromParent_Done,
     /* 457058 */   // Label 6502: @457058
     /* 457058 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(457193), // Rule ID 12757 //
     /* 457063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 457106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457147 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457191 */     GIR_RootConstrainSelectedInstOperands,
     /* 457192 */     // GIR_Coverage, 12757,
     /* 457192 */     GIR_EraseRootFromParent_Done,
     /* 457193 */   // Label 6503: @457193
     /* 457193 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(457328), // Rule ID 12758 //
     /* 457198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 457241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457282 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457326 */     GIR_RootConstrainSelectedInstOperands,
     /* 457327 */     // GIR_Coverage, 12758,
     /* 457327 */     GIR_EraseRootFromParent_Done,
     /* 457328 */   // Label 6504: @457328
     /* 457328 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(457463), // Rule ID 12761 //
     /* 457333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 457376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457417 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457461 */     GIR_RootConstrainSelectedInstOperands,
     /* 457462 */     // GIR_Coverage, 12761,
     /* 457462 */     GIR_EraseRootFromParent_Done,
     /* 457463 */   // Label 6505: @457463
     /* 457463 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(457598), // Rule ID 12762 //
     /* 457468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 457471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 457475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 457511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457552 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 457555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457596 */     GIR_RootConstrainSelectedInstOperands,
     /* 457597 */     // GIR_Coverage, 12762,
     /* 457597 */     GIR_EraseRootFromParent_Done,
     /* 457598 */   // Label 6506: @457598
     /* 457598 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(457733), // Rule ID 13237 //
     /* 457603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 457606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 457646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457655 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457680 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457687 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 457690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457731 */     GIR_RootConstrainSelectedInstOperands,
     /* 457732 */     // GIR_Coverage, 13237,
     /* 457732 */     GIR_EraseRootFromParent_Done,
     /* 457733 */   // Label 6507: @457733
     /* 457733 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(457868), // Rule ID 13238 //
     /* 457738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 457741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 457781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457795 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457822 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 457825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 457832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 457837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 457842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 457847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457866 */     GIR_RootConstrainSelectedInstOperands,
     /* 457867 */     // GIR_Coverage, 13238,
     /* 457867 */     GIR_EraseRootFromParent_Done,
     /* 457868 */   // Label 6508: @457868
     /* 457868 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(458003), // Rule ID 13241 //
     /* 457873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 457876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 457880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 457884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 457892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 457896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 457900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 457904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 457908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 457912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 457916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 457920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 457920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 457925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 457925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 457930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 457934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 457936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 457957 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 457957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 457960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 457962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 457967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 457972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 457977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 457982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 457987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 457992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 457998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458001 */     GIR_RootConstrainSelectedInstOperands,
     /* 458002 */     // GIR_Coverage, 13241,
     /* 458002 */     GIR_EraseRootFromParent_Done,
     /* 458003 */   // Label 6509: @458003
     /* 458003 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(458138), // Rule ID 13242 //
     /* 458008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 458011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 458055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458092 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 458095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458136 */     GIR_RootConstrainSelectedInstOperands,
     /* 458137 */     // GIR_Coverage, 13242,
     /* 458137 */     GIR_EraseRootFromParent_Done,
     /* 458138 */   // Label 6510: @458138
     /* 458138 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(458273), // Rule ID 12262 //
     /* 458143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458227 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458271 */     GIR_RootConstrainSelectedInstOperands,
     /* 458272 */     // GIR_Coverage, 12262,
     /* 458272 */     GIR_EraseRootFromParent_Done,
     /* 458273 */   // Label 6511: @458273
     /* 458273 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(458408), // Rule ID 12263 //
     /* 458278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458362 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458406 */     GIR_RootConstrainSelectedInstOperands,
     /* 458407 */     // GIR_Coverage, 12263,
     /* 458407 */     GIR_EraseRootFromParent_Done,
     /* 458408 */   // Label 6512: @458408
     /* 458408 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(458543), // Rule ID 12266 //
     /* 458413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458497 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458541 */     GIR_RootConstrainSelectedInstOperands,
     /* 458542 */     // GIR_Coverage, 12266,
     /* 458542 */     GIR_EraseRootFromParent_Done,
     /* 458543 */   // Label 6513: @458543
     /* 458543 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(458678), // Rule ID 12267 //
     /* 458548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 458551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 458555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458632 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 458635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 458642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 458647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 458652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 458657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458676 */     GIR_RootConstrainSelectedInstOperands,
     /* 458677 */     // GIR_Coverage, 12267,
     /* 458677 */     GIR_EraseRootFromParent_Done,
     /* 458678 */   // Label 6514: @458678
     /* 458678 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(458813), // Rule ID 12742 //
     /* 458683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 458686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 458690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458767 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 458770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458811 */     GIR_RootConstrainSelectedInstOperands,
     /* 458812 */     // GIR_Coverage, 12742,
     /* 458812 */     GIR_EraseRootFromParent_Done,
     /* 458813 */   // Label 6515: @458813
     /* 458813 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(458948), // Rule ID 12743 //
     /* 458818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 458821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 458825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 458865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 458865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 458870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 458870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 458875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 458879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 458881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 458902 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 458902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 458905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 458907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 458912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 458917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 458922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 458927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 458932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 458937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 458946 */     GIR_RootConstrainSelectedInstOperands,
     /* 458947 */     // GIR_Coverage, 12743,
     /* 458947 */     GIR_EraseRootFromParent_Done,
     /* 458948 */   // Label 6516: @458948
     /* 458948 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(459083), // Rule ID 12746 //
     /* 458953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 458956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 458960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 458964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 458972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 458976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 458980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 458984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 458988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 458992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 458996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 459000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459037 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459081 */     GIR_RootConstrainSelectedInstOperands,
     /* 459082 */     // GIR_Coverage, 12746,
     /* 459082 */     GIR_EraseRootFromParent_Done,
     /* 459083 */   // Label 6517: @459083
     /* 459083 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(459218), // Rule ID 12747 //
     /* 459088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 459135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459172 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459216 */     GIR_RootConstrainSelectedInstOperands,
     /* 459217 */     // GIR_Coverage, 12747,
     /* 459217 */     GIR_EraseRootFromParent_Done,
     /* 459218 */   // Label 6518: @459218
     /* 459218 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(459353), // Rule ID 13222 //
     /* 459223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 459270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459307 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 459310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459351 */     GIR_RootConstrainSelectedInstOperands,
     /* 459352 */     // GIR_Coverage, 13222,
     /* 459352 */     GIR_EraseRootFromParent_Done,
     /* 459353 */   // Label 6519: @459353
     /* 459353 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(459488), // Rule ID 13223 //
     /* 459358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 459405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459442 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 459445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459486 */     GIR_RootConstrainSelectedInstOperands,
     /* 459487 */     // GIR_Coverage, 13223,
     /* 459487 */     GIR_EraseRootFromParent_Done,
     /* 459488 */   // Label 6520: @459488
     /* 459488 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(459623), // Rule ID 13226 //
     /* 459493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 459540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459577 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 459580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459621 */     GIR_RootConstrainSelectedInstOperands,
     /* 459622 */     // GIR_Coverage, 13226,
     /* 459622 */     GIR_EraseRootFromParent_Done,
     /* 459623 */   // Label 6521: @459623
     /* 459623 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(459758), // Rule ID 13227 //
     /* 459628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 459631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 459671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 459675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459680 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459712 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 459715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 459722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 459727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 459732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 459737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459756 */     GIR_RootConstrainSelectedInstOperands,
     /* 459757 */     // GIR_Coverage, 13227,
     /* 459757 */     GIR_EraseRootFromParent_Done,
     /* 459758 */   // Label 6522: @459758
     /* 459758 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(459893), // Rule ID 7772 //
     /* 459763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 459766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 459770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 459806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459815 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459847 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 459850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 459867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 459872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 459877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 459882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 459891 */     GIR_RootConstrainSelectedInstOperands,
     /* 459892 */     // GIR_Coverage, 7772,
     /* 459892 */     GIR_EraseRootFromParent_Done,
     /* 459893 */   // Label 6523: @459893
     /* 459893 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(460028), // Rule ID 7804 //
     /* 459898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 459901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 459905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 459909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 459917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 459921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 459925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 459929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 459933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 459937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 459941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 459945 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 459945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 459950 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 459950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 459955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 459959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 459961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 459982 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 459982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 459985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 459987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 459992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 459997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460026 */     GIR_RootConstrainSelectedInstOperands,
     /* 460027 */     // GIR_Coverage, 7804,
     /* 460027 */     GIR_EraseRootFromParent_Done,
     /* 460028 */   // Label 6524: @460028
     /* 460028 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(460163), // Rule ID 7836 //
     /* 460033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 460036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 460076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460117 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 460120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460161 */     GIR_RootConstrainSelectedInstOperands,
     /* 460162 */     // GIR_Coverage, 7836,
     /* 460162 */     GIR_EraseRootFromParent_Done,
     /* 460163 */   // Label 6525: @460163
     /* 460163 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(460298), // Rule ID 12276 //
     /* 460168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 460211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460252 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460296 */     GIR_RootConstrainSelectedInstOperands,
     /* 460297 */     // GIR_Coverage, 12276,
     /* 460297 */     GIR_EraseRootFromParent_Done,
     /* 460298 */   // Label 6526: @460298
     /* 460298 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(460433), // Rule ID 12279 //
     /* 460303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 460346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460387 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460431 */     GIR_RootConstrainSelectedInstOperands,
     /* 460432 */     // GIR_Coverage, 12279,
     /* 460432 */     GIR_EraseRootFromParent_Done,
     /* 460433 */   // Label 6527: @460433
     /* 460433 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(460568), // Rule ID 12280 //
     /* 460438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 460441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 460481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460522 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 460525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460566 */     GIR_RootConstrainSelectedInstOperands,
     /* 460567 */     // GIR_Coverage, 12280,
     /* 460567 */     GIR_EraseRootFromParent_Done,
     /* 460568 */   // Label 6528: @460568
     /* 460568 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(460703), // Rule ID 12756 //
     /* 460573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 460576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 460580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 460616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460620 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460625 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460630 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460657 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 460660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 460667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 460672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 460677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 460682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460701 */     GIR_RootConstrainSelectedInstOperands,
     /* 460702 */     // GIR_Coverage, 12756,
     /* 460702 */     GIR_EraseRootFromParent_Done,
     /* 460703 */   // Label 6529: @460703
     /* 460703 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(460838), // Rule ID 12759 //
     /* 460708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 460711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 460715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 460751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460755 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460760 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460792 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 460795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460836 */     GIR_RootConstrainSelectedInstOperands,
     /* 460837 */     // GIR_Coverage, 12759,
     /* 460837 */     GIR_EraseRootFromParent_Done,
     /* 460838 */   // Label 6530: @460838
     /* 460838 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(460973), // Rule ID 12760 //
     /* 460843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 460846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 460850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 460866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 460870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 460878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 460882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 460886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 460890 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 460890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 460895 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 460895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 460900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 460904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 460906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 460927 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 460927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 460930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 460932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 460937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 460942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 460947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 460952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 460957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 460962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 460971 */     GIR_RootConstrainSelectedInstOperands,
     /* 460972 */     // GIR_Coverage, 12760,
     /* 460972 */     GIR_EraseRootFromParent_Done,
     /* 460973 */   // Label 6531: @460973
     /* 460973 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(461108), // Rule ID 13236 //
     /* 460978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 460981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 460985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 460989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 460993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 460997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 461025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461062 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461106 */     GIR_RootConstrainSelectedInstOperands,
     /* 461107 */     // GIR_Coverage, 13236,
     /* 461107 */     GIR_EraseRootFromParent_Done,
     /* 461108 */   // Label 6532: @461108
     /* 461108 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(461243), // Rule ID 13239 //
     /* 461113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 461160 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461165 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461197 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461241 */     GIR_RootConstrainSelectedInstOperands,
     /* 461242 */     // GIR_Coverage, 13239,
     /* 461242 */     GIR_EraseRootFromParent_Done,
     /* 461243 */   // Label 6533: @461243
     /* 461243 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(461378), // Rule ID 13240 //
     /* 461248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 461295 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461300 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461325 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461332 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 461342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 461347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 461352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 461357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461376 */     GIR_RootConstrainSelectedInstOperands,
     /* 461377 */     // GIR_Coverage, 13240,
     /* 461377 */     GIR_EraseRootFromParent_Done,
     /* 461378 */   // Label 6534: @461378
     /* 461378 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(461513), // Rule ID 7771 //
     /* 461383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 461386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461430 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461435 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461444 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461467 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 461470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461511 */     GIR_RootConstrainSelectedInstOperands,
     /* 461512 */     // GIR_Coverage, 7771,
     /* 461512 */     GIR_EraseRootFromParent_Done,
     /* 461513 */   // Label 6535: @461513
     /* 461513 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(461648), // Rule ID 7803 //
     /* 461518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 461521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 461525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461565 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461570 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461602 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 461605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461646 */     GIR_RootConstrainSelectedInstOperands,
     /* 461647 */     // GIR_Coverage, 7803,
     /* 461647 */     GIR_EraseRootFromParent_Done,
     /* 461648 */   // Label 6536: @461648
     /* 461648 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(461783), // Rule ID 7835 //
     /* 461653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 461656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461737 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 461740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461781 */     GIR_RootConstrainSelectedInstOperands,
     /* 461782 */     // GIR_Coverage, 7835,
     /* 461782 */     GIR_EraseRootFromParent_Done,
     /* 461783 */   // Label 6537: @461783
     /* 461783 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(461918), // Rule ID 12261 //
     /* 461788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 461791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461872 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 461872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 461875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 461877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 461882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 461887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 461892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 461897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 461902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 461907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 461916 */     GIR_RootConstrainSelectedInstOperands,
     /* 461917 */     // GIR_Coverage, 12261,
     /* 461917 */     GIR_EraseRootFromParent_Done,
     /* 461918 */   // Label 6538: @461918
     /* 461918 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(462053), // Rule ID 12264 //
     /* 461923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 461926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 461930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 461934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 461942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 461946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 461950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 461954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 461958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 461962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 461966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 461970 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 461970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 461975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 461975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 461980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 461984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 461986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 461993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462007 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462051 */     GIR_RootConstrainSelectedInstOperands,
     /* 462052 */     // GIR_Coverage, 12264,
     /* 462052 */     GIR_EraseRootFromParent_Done,
     /* 462053 */   // Label 6539: @462053
     /* 462053 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(462188), // Rule ID 12265 //
     /* 462058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 462061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462105 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462105 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462142 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 462145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462186 */     GIR_RootConstrainSelectedInstOperands,
     /* 462187 */     // GIR_Coverage, 12265,
     /* 462187 */     GIR_EraseRootFromParent_Done,
     /* 462188 */   // Label 6540: @462188
     /* 462188 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(462323), // Rule ID 12741 //
     /* 462193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462240 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462245 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462277 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462321 */     GIR_RootConstrainSelectedInstOperands,
     /* 462322 */     // GIR_Coverage, 12741,
     /* 462322 */     GIR_EraseRootFromParent_Done,
     /* 462323 */   // Label 6541: @462323
     /* 462323 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(462458), // Rule ID 12744 //
     /* 462328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462375 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462380 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462405 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462412 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462456 */     GIR_RootConstrainSelectedInstOperands,
     /* 462457 */     // GIR_Coverage, 12744,
     /* 462457 */     GIR_EraseRootFromParent_Done,
     /* 462458 */   // Label 6542: @462458
     /* 462458 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(462593), // Rule ID 12745 //
     /* 462463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 462466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 462470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462510 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462515 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462547 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 462550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462591 */     GIR_RootConstrainSelectedInstOperands,
     /* 462592 */     // GIR_Coverage, 12745,
     /* 462592 */     GIR_EraseRootFromParent_Done,
     /* 462593 */   // Label 6543: @462593
     /* 462593 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(462728), // Rule ID 13221 //
     /* 462598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 462601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462682 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 462685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 462692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 462697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 462702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 462707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462726 */     GIR_RootConstrainSelectedInstOperands,
     /* 462727 */     // GIR_Coverage, 13221,
     /* 462727 */     GIR_EraseRootFromParent_Done,
     /* 462728 */   // Label 6544: @462728
     /* 462728 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(462863), // Rule ID 13224 //
     /* 462733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 462736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462810 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462817 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 462820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462861 */     GIR_RootConstrainSelectedInstOperands,
     /* 462862 */     // GIR_Coverage, 13224,
     /* 462862 */     GIR_EraseRootFromParent_Done,
     /* 462863 */   // Label 6545: @462863
     /* 462863 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(462998), // Rule ID 13225 //
     /* 462868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 462871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 462875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 462879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 462887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 462891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 462895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 462899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 462903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 462907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 462911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 462915 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 462915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 462920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 462920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 462925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 462929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 462931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 462952 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 462952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 462955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 462957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 462962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 462967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 462972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 462977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 462982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 462987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 462996 */     GIR_RootConstrainSelectedInstOperands,
     /* 462997 */     // GIR_Coverage, 13225,
     /* 462997 */     GIR_EraseRootFromParent_Done,
     /* 462998 */   // Label 6546: @462998
     /* 462998 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(463133), // Rule ID 12247 //
     /* 463003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463087 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 463090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463131 */     GIR_RootConstrainSelectedInstOperands,
     /* 463132 */     // GIR_Coverage, 12247,
     /* 463132 */     GIR_EraseRootFromParent_Done,
     /* 463133 */   // Label 6547: @463133
     /* 463133 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(463268), // Rule ID 12248 //
     /* 463138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463222 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 463225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463266 */     GIR_RootConstrainSelectedInstOperands,
     /* 463267 */     // GIR_Coverage, 12248,
     /* 463267 */     GIR_EraseRootFromParent_Done,
     /* 463268 */   // Label 6548: @463268
     /* 463268 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(463403), // Rule ID 12251 //
     /* 463273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463357 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 463360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463401 */     GIR_RootConstrainSelectedInstOperands,
     /* 463402 */     // GIR_Coverage, 12251,
     /* 463402 */     GIR_EraseRootFromParent_Done,
     /* 463403 */   // Label 6549: @463403
     /* 463403 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(463538), // Rule ID 12252 //
     /* 463408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 463411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 463415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463492 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 463495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463536 */     GIR_RootConstrainSelectedInstOperands,
     /* 463537 */     // GIR_Coverage, 12252,
     /* 463537 */     GIR_EraseRootFromParent_Done,
     /* 463538 */   // Label 6550: @463538
     /* 463538 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(463673), // Rule ID 12727 //
     /* 463543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463627 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463671 */     GIR_RootConstrainSelectedInstOperands,
     /* 463672 */     // GIR_Coverage, 12727,
     /* 463672 */     GIR_EraseRootFromParent_Done,
     /* 463673 */   // Label 6551: @463673
     /* 463673 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(463808), // Rule ID 12728 //
     /* 463678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463762 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 463772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 463777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 463782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 463787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463806 */     GIR_RootConstrainSelectedInstOperands,
     /* 463807 */     // GIR_Coverage, 12728,
     /* 463807 */     GIR_EraseRootFromParent_Done,
     /* 463808 */   // Label 6552: @463808
     /* 463808 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(463943), // Rule ID 12731 //
     /* 463813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 463860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 463865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 463870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 463874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 463876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 463897 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 463897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 463900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 463902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 463907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 463912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 463917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 463922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 463927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 463932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 463941 */     GIR_RootConstrainSelectedInstOperands,
     /* 463942 */     // GIR_Coverage, 12731,
     /* 463942 */     GIR_EraseRootFromParent_Done,
     /* 463943 */   // Label 6553: @463943
     /* 463943 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(464078), // Rule ID 12732 //
     /* 463948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 463951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 463955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 463959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 463963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 463967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 463971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 463975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 463979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 463983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 463987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 463991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 463995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 463995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464032 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 464035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464076 */     GIR_RootConstrainSelectedInstOperands,
     /* 464077 */     // GIR_Coverage, 12732,
     /* 464077 */     GIR_EraseRootFromParent_Done,
     /* 464078 */   // Label 6554: @464078
     /* 464078 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(464213), // Rule ID 13207 //
     /* 464083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 464126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 464130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464167 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 464170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464211 */     GIR_RootConstrainSelectedInstOperands,
     /* 464212 */     // GIR_Coverage, 13207,
     /* 464212 */     GIR_EraseRootFromParent_Done,
     /* 464213 */   // Label 6555: @464213
     /* 464213 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(464348), // Rule ID 13208 //
     /* 464218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 464261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 464265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464295 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464302 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 464305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464346 */     GIR_RootConstrainSelectedInstOperands,
     /* 464347 */     // GIR_Coverage, 13208,
     /* 464347 */     GIR_EraseRootFromParent_Done,
     /* 464348 */   // Label 6556: @464348
     /* 464348 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(464483), // Rule ID 13211 //
     /* 464353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 464396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 464400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464437 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 464440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464481 */     GIR_RootConstrainSelectedInstOperands,
     /* 464482 */     // GIR_Coverage, 13211,
     /* 464482 */     GIR_EraseRootFromParent_Done,
     /* 464483 */   // Label 6557: @464483
     /* 464483 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(464618), // Rule ID 13212 //
     /* 464488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 464491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 464531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 464535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464572 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 464575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 464597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464616 */     GIR_RootConstrainSelectedInstOperands,
     /* 464617 */     // GIR_Coverage, 13212,
     /* 464617 */     GIR_EraseRootFromParent_Done,
     /* 464618 */   // Label 6558: @464618
     /* 464618 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(464753), // Rule ID 12232 //
     /* 464623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 464626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 464666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464707 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464751 */     GIR_RootConstrainSelectedInstOperands,
     /* 464752 */     // GIR_Coverage, 12232,
     /* 464752 */     GIR_EraseRootFromParent_Done,
     /* 464753 */   // Label 6559: @464753
     /* 464753 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(464888), // Rule ID 12233 //
     /* 464758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 464761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 464801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464842 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 464852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 464857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 464862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 464867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 464872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 464877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 464886 */     GIR_RootConstrainSelectedInstOperands,
     /* 464887 */     // GIR_Coverage, 12233,
     /* 464887 */     GIR_EraseRootFromParent_Done,
     /* 464888 */   // Label 6560: @464888
     /* 464888 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(465023), // Rule ID 12236 //
     /* 464893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 464896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 464900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 464904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 464908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 464912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 464916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 464920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 464924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 464928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 464932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 464936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 464940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 464940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 464945 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 464945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 464950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 464954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 464956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464970 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 464977 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 464977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 464980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 464982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 464987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 464992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 464997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 465002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465021 */     GIR_RootConstrainSelectedInstOperands,
     /* 465022 */     // GIR_Coverage, 12236,
     /* 465022 */     GIR_EraseRootFromParent_Done,
     /* 465023 */   // Label 6561: @465023
     /* 465023 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(465158), // Rule ID 12237 //
     /* 465028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 465031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 465071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465112 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 465115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 465132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 465137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465156 */     GIR_RootConstrainSelectedInstOperands,
     /* 465157 */     // GIR_Coverage, 12237,
     /* 465157 */     GIR_EraseRootFromParent_Done,
     /* 465158 */   // Label 6562: @465158
     /* 465158 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(465293), // Rule ID 12712 //
     /* 465163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 465206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465247 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 465257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 465262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465291 */     GIR_RootConstrainSelectedInstOperands,
     /* 465292 */     // GIR_Coverage, 12712,
     /* 465292 */     GIR_EraseRootFromParent_Done,
     /* 465293 */   // Label 6563: @465293
     /* 465293 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(465428), // Rule ID 12713 //
     /* 465298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 465341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465382 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 465392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 465397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465426 */     GIR_RootConstrainSelectedInstOperands,
     /* 465427 */     // GIR_Coverage, 12713,
     /* 465427 */     GIR_EraseRootFromParent_Done,
     /* 465428 */   // Label 6564: @465428
     /* 465428 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(465563), // Rule ID 12716 //
     /* 465433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 465476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465490 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465517 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 465537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 465542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465561 */     GIR_RootConstrainSelectedInstOperands,
     /* 465562 */     // GIR_Coverage, 12716,
     /* 465562 */     GIR_EraseRootFromParent_Done,
     /* 465563 */   // Label 6565: @465563
     /* 465563 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(465698), // Rule ID 12717 //
     /* 465568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 465571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 465575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 465611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465615 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465620 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465645 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465652 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 465655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 465662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 465667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 465672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 465677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465696 */     GIR_RootConstrainSelectedInstOperands,
     /* 465697 */     // GIR_Coverage, 12717,
     /* 465697 */     GIR_EraseRootFromParent_Done,
     /* 465698 */   // Label 6566: @465698
     /* 465698 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(465833), // Rule ID 13192 //
     /* 465703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 465706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 465746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465750 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465755 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465780 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465787 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 465790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 465797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 465802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465831 */     GIR_RootConstrainSelectedInstOperands,
     /* 465832 */     // GIR_Coverage, 13192,
     /* 465832 */     GIR_EraseRootFromParent_Done,
     /* 465833 */   // Label 6567: @465833
     /* 465833 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(465968), // Rule ID 13193 //
     /* 465838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 465841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 465865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 465869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 465873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 465877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 465881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 465885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 465885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 465890 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 465890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 465895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 465899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 465901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 465922 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 465922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 465925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 465927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 465932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 465937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 465942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 465947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 465952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 465957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 465966 */     GIR_RootConstrainSelectedInstOperands,
     /* 465967 */     // GIR_Coverage, 13193,
     /* 465967 */     GIR_EraseRootFromParent_Done,
     /* 465968 */   // Label 6568: @465968
     /* 465968 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(466103), // Rule ID 13196 //
     /* 465973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 465976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 465980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 465984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 465988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 465992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 465996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 466016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 466020 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466057 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 466077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 466082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 466087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 466092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466101 */     GIR_RootConstrainSelectedInstOperands,
     /* 466102 */     // GIR_Coverage, 13196,
     /* 466102 */     GIR_EraseRootFromParent_Done,
     /* 466103 */   // Label 6569: @466103
     /* 466103 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(466238), // Rule ID 13197 //
     /* 466108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 466151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 466155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466160 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466192 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 466212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 466217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 466222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 466227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466236 */     GIR_RootConstrainSelectedInstOperands,
     /* 466237 */     // GIR_Coverage, 13197,
     /* 466237 */     GIR_EraseRootFromParent_Done,
     /* 466238 */   // Label 6570: @466238
     /* 466238 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(466373), // Rule ID 7770 //
     /* 466243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 466286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466295 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466327 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 466330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 466337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 466342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 466357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 466362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466371 */     GIR_RootConstrainSelectedInstOperands,
     /* 466372 */     // GIR_Coverage, 7770,
     /* 466372 */     GIR_EraseRootFromParent_Done,
     /* 466373 */   // Label 6571: @466373
     /* 466373 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(466508), // Rule ID 7802 //
     /* 466378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 466381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 466385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 466421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466425 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466430 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466462 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 466465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 466472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 466477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 466492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 466497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466506 */     GIR_RootConstrainSelectedInstOperands,
     /* 466507 */     // GIR_Coverage, 7802,
     /* 466507 */     GIR_EraseRootFromParent_Done,
     /* 466508 */   // Label 6572: @466508
     /* 466508 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(466643), // Rule ID 7834 //
     /* 466513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 466516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 466556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466560 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466565 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466597 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 466600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 466607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 466612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 466627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 466632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466641 */     GIR_RootConstrainSelectedInstOperands,
     /* 466642 */     // GIR_Coverage, 7834,
     /* 466642 */     GIR_EraseRootFromParent_Done,
     /* 466643 */   // Label 6573: @466643
     /* 466643 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(466778), // Rule ID 12246 //
     /* 466648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 466691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466695 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466732 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 466735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 466742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 466747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 466752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 466757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 466762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 466767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466776 */     GIR_RootConstrainSelectedInstOperands,
     /* 466777 */     // GIR_Coverage, 12246,
     /* 466777 */     GIR_EraseRootFromParent_Done,
     /* 466778 */   // Label 6574: @466778
     /* 466778 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(466913), // Rule ID 12249 //
     /* 466783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 466826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466867 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 466867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 466870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 466872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 466877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 466882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 466887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 466892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 466897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 466902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 466911 */     GIR_RootConstrainSelectedInstOperands,
     /* 466912 */     // GIR_Coverage, 12249,
     /* 466912 */     GIR_EraseRootFromParent_Done,
     /* 466913 */   // Label 6575: @466913
     /* 466913 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(467048), // Rule ID 12250 //
     /* 466918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 466921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 466925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 466929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 466933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 466937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 466941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 466945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 466949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 466953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 466957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 466961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 466965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 466965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 466970 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 466970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 466975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 466979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 466981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 466995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467002 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 467022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 467027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467046 */     GIR_RootConstrainSelectedInstOperands,
     /* 467047 */     // GIR_Coverage, 12250,
     /* 467047 */     GIR_EraseRootFromParent_Done,
     /* 467048 */   // Label 6576: @467048
     /* 467048 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(467183), // Rule ID 12726 //
     /* 467053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 467080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 467096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467100 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 467105 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467105 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 467110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467130 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467137 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 467147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 467152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467181 */     GIR_RootConstrainSelectedInstOperands,
     /* 467182 */     // GIR_Coverage, 12726,
     /* 467182 */     GIR_EraseRootFromParent_Done,
     /* 467183 */   // Label 6577: @467183
     /* 467183 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(467318), // Rule ID 12729 //
     /* 467188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 467215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 467231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467235 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 467240 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 467245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467272 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 467292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 467297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467316 */     GIR_RootConstrainSelectedInstOperands,
     /* 467317 */     // GIR_Coverage, 12729,
     /* 467317 */     GIR_EraseRootFromParent_Done,
     /* 467318 */   // Label 6578: @467318
     /* 467318 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(467453), // Rule ID 12730 //
     /* 467323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 467326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 467330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 467350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 467366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467370 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 467375 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 467380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467407 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 467410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 467427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 467432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467451 */     GIR_RootConstrainSelectedInstOperands,
     /* 467452 */     // GIR_Coverage, 12730,
     /* 467452 */     GIR_EraseRootFromParent_Done,
     /* 467453 */   // Label 6579: @467453
     /* 467453 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(467588), // Rule ID 13206 //
     /* 467458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 467461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 467485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 467501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 467510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 467515 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467542 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 467545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 467552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 467557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467586 */     GIR_RootConstrainSelectedInstOperands,
     /* 467587 */     // GIR_Coverage, 13206,
     /* 467587 */     GIR_EraseRootFromParent_Done,
     /* 467588 */   // Label 6580: @467588
     /* 467588 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(467723), // Rule ID 13209 //
     /* 467593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 467596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 467620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 467636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 467645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 467650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467677 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 467680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 467697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 467702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467721 */     GIR_RootConstrainSelectedInstOperands,
     /* 467722 */     // GIR_Coverage, 13209,
     /* 467722 */     GIR_EraseRootFromParent_Done,
     /* 467723 */   // Label 6581: @467723
     /* 467723 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(467858), // Rule ID 13210 //
     /* 467728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 467731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 467755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 467771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 467775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 467780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 467785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467812 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 467815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 467822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 467827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 467832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 467837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467856 */     GIR_RootConstrainSelectedInstOperands,
     /* 467857 */     // GIR_Coverage, 13210,
     /* 467857 */     GIR_EraseRootFromParent_Done,
     /* 467858 */   // Label 6582: @467858
     /* 467858 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(467993), // Rule ID 7769 //
     /* 467863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 467866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 467870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 467874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 467878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 467882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 467886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 467890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 467894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 467898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 467902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 467906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 467910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 467910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 467915 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 467915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 467920 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 467924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 467926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 467947 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 467947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 467950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 467952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 467957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 467962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 467967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 467972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 467977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 467982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 467991 */     GIR_RootConstrainSelectedInstOperands,
     /* 467992 */     // GIR_Coverage, 7769,
     /* 467992 */     GIR_EraseRootFromParent_Done,
     /* 467993 */   // Label 6583: @467993
     /* 467993 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(468128), // Rule ID 7801 //
     /* 467998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 468001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 468005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468045 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468050 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 468055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468082 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 468085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 468092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 468097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 468112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 468117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468126 */     GIR_RootConstrainSelectedInstOperands,
     /* 468127 */     // GIR_Coverage, 7801,
     /* 468127 */     GIR_EraseRootFromParent_Done,
     /* 468128 */   // Label 6584: @468128
     /* 468128 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(468263), // Rule ID 7833 //
     /* 468133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 468136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468180 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 468190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468217 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 468220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 468227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 468232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 468247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 468252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468261 */     GIR_RootConstrainSelectedInstOperands,
     /* 468262 */     // GIR_Coverage, 7833,
     /* 468262 */     GIR_EraseRootFromParent_Done,
     /* 468263 */   // Label 6585: @468263
     /* 468263 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(468398), // Rule ID 12231 //
     /* 468268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 468320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468352 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 468362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 468367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 468382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 468387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468396 */     GIR_RootConstrainSelectedInstOperands,
     /* 468397 */     // GIR_Coverage, 12231,
     /* 468397 */     GIR_EraseRootFromParent_Done,
     /* 468398 */   // Label 6586: @468398
     /* 468398 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(468533), // Rule ID 12234 //
     /* 468403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 468455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468487 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 468507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 468512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 468517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 468522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468531 */     GIR_RootConstrainSelectedInstOperands,
     /* 468532 */     // GIR_Coverage, 12234,
     /* 468532 */     GIR_EraseRootFromParent_Done,
     /* 468533 */   // Label 6587: @468533
     /* 468533 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(468668), // Rule ID 12235 //
     /* 468538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 468541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 468545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 468595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468608 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468622 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 468625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 468642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 468647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 468652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 468657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468666 */     GIR_RootConstrainSelectedInstOperands,
     /* 468667 */     // GIR_Coverage, 12235,
     /* 468667 */     GIR_EraseRootFromParent_Done,
     /* 468668 */   // Label 6588: @468668
     /* 468668 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(468803), // Rule ID 12711 //
     /* 468673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 468676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 468680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468720 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 468725 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468757 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 468760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 468767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 468772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 468777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 468782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 468787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 468792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468801 */     GIR_RootConstrainSelectedInstOperands,
     /* 468802 */     // GIR_Coverage, 12711,
     /* 468802 */     GIR_EraseRootFromParent_Done,
     /* 468803 */   // Label 6589: @468803
     /* 468803 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(468938), // Rule ID 12714 //
     /* 468808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 468811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 468815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468855 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 468860 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 468869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 468871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468878 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 468892 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 468892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 468895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 468897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 468902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 468907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 468912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 468917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 468922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 468927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 468936 */     GIR_RootConstrainSelectedInstOperands,
     /* 468937 */     // GIR_Coverage, 12714,
     /* 468937 */     GIR_EraseRootFromParent_Done,
     /* 468938 */   // Label 6590: @468938
     /* 468938 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(469073), // Rule ID 12715 //
     /* 468943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 468946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 468950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 468954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 468958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 468962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 468966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 468970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 468974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 468978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 468982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 468986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 468990 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 468990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 468995 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 468995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 469000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469027 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 469030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 469047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 469052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 469057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 469062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469071 */     GIR_RootConstrainSelectedInstOperands,
     /* 469072 */     // GIR_Coverage, 12715,
     /* 469072 */     GIR_EraseRootFromParent_Done,
     /* 469073 */   // Label 6591: @469073
     /* 469073 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(469208), // Rule ID 13191 //
     /* 469078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 469105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 469109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 469121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 469130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 469135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469162 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 469172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 469177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 469192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 469197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469206 */     GIR_RootConstrainSelectedInstOperands,
     /* 469207 */     // GIR_Coverage, 13191,
     /* 469207 */     GIR_EraseRootFromParent_Done,
     /* 469208 */   // Label 6592: @469208
     /* 469208 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(469343), // Rule ID 13194 //
     /* 469213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 469240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 469244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 469256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 469265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 469270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469297 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 469317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 469322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 469327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 469332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469341 */     GIR_RootConstrainSelectedInstOperands,
     /* 469342 */     // GIR_Coverage, 13194,
     /* 469342 */     GIR_EraseRootFromParent_Done,
     /* 469343 */   // Label 6593: @469343
     /* 469343 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(469478), // Rule ID 13195 //
     /* 469348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 469351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 469375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 469379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 469391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 469395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 469400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 469405 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469432 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 469435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 469452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 469457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 469462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 469467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469476 */     GIR_RootConstrainSelectedInstOperands,
     /* 469477 */     // GIR_Coverage, 13195,
     /* 469477 */     GIR_EraseRootFromParent_Done,
     /* 469478 */   // Label 6594: @469478
     /* 469478 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(469613), // Rule ID 12287 //
     /* 469483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 469486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 469514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469540 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469567 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 469570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469611 */     GIR_RootConstrainSelectedInstOperands,
     /* 469612 */     // GIR_Coverage, 12287,
     /* 469612 */     GIR_EraseRootFromParent_Done,
     /* 469613 */   // Label 6595: @469613
     /* 469613 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(469748), // Rule ID 12288 //
     /* 469618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 469621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 469649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469702 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 469705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 469712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 469717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 469722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 469727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469746 */     GIR_RootConstrainSelectedInstOperands,
     /* 469747 */     // GIR_Coverage, 12288,
     /* 469747 */     GIR_EraseRootFromParent_Done,
     /* 469748 */   // Label 6596: @469748
     /* 469748 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(469883), // Rule ID 12289 //
     /* 469753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 469756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 469784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469837 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 469840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 469867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 469872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 469881 */     GIR_RootConstrainSelectedInstOperands,
     /* 469882 */     // GIR_Coverage, 12289,
     /* 469882 */     GIR_EraseRootFromParent_Done,
     /* 469883 */   // Label 6597: @469883
     /* 469883 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(470018), // Rule ID 12290 //
     /* 469888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 469891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 469895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 469899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 469907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 469911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 469915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 469919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 469923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 469927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 469931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 469935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 469935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 469940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 469940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 469945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 469949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 469951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 469972 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 469972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 469975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 469977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 469982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 469987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 469992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 469997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470016 */     GIR_RootConstrainSelectedInstOperands,
     /* 470017 */     // GIR_Coverage, 12290,
     /* 470017 */     GIR_EraseRootFromParent_Done,
     /* 470018 */   // Label 6598: @470018
     /* 470018 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(470153), // Rule ID 12767 //
     /* 470023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470080 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470107 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470151 */     GIR_RootConstrainSelectedInstOperands,
     /* 470152 */     // GIR_Coverage, 12767,
     /* 470152 */     GIR_EraseRootFromParent_Done,
     /* 470153 */   // Label 6599: @470153
     /* 470153 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(470288), // Rule ID 12768 //
     /* 470158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470242 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470286 */     GIR_RootConstrainSelectedInstOperands,
     /* 470287 */     // GIR_Coverage, 12768,
     /* 470287 */     GIR_EraseRootFromParent_Done,
     /* 470288 */   // Label 6600: @470288
     /* 470288 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(470423), // Rule ID 12769 //
     /* 470293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470377 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470421 */     GIR_RootConstrainSelectedInstOperands,
     /* 470422 */     // GIR_Coverage, 12769,
     /* 470422 */     GIR_EraseRootFromParent_Done,
     /* 470423 */   // Label 6601: @470423
     /* 470423 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(470558), // Rule ID 12770 //
     /* 470428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 470431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 470435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470512 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 470515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470556 */     GIR_RootConstrainSelectedInstOperands,
     /* 470557 */     // GIR_Coverage, 12770,
     /* 470557 */     GIR_EraseRootFromParent_Done,
     /* 470558 */   // Label 6602: @470558
     /* 470558 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(470693), // Rule ID 13247 //
     /* 470563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 470566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470615 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470647 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 470650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470691 */     GIR_RootConstrainSelectedInstOperands,
     /* 470692 */     // GIR_Coverage, 13247,
     /* 470692 */     GIR_EraseRootFromParent_Done,
     /* 470693 */   // Label 6603: @470693
     /* 470693 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(470828), // Rule ID 13248 //
     /* 470698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 470701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470750 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470782 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 470785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 470792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 470797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 470802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 470807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470826 */     GIR_RootConstrainSelectedInstOperands,
     /* 470827 */     // GIR_Coverage, 13248,
     /* 470827 */     GIR_EraseRootFromParent_Done,
     /* 470828 */   // Label 6604: @470828
     /* 470828 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(470963), // Rule ID 13249 //
     /* 470833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 470836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 470868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 470872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 470876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 470880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 470885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 470885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 470890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 470894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 470896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 470917 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 470917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 470920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 470922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 470927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 470932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 470937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 470942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 470947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 470952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 470961 */     GIR_RootConstrainSelectedInstOperands,
     /* 470962 */     // GIR_Coverage, 13249,
     /* 470962 */     GIR_EraseRootFromParent_Done,
     /* 470963 */   // Label 6605: @470963
     /* 470963 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(471098), // Rule ID 13250 //
     /* 470968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 470971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 470975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 470979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 470983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 470987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 470991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 470995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 470999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471020 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471038 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471052 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 471055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471096 */     GIR_RootConstrainSelectedInstOperands,
     /* 471097 */     // GIR_Coverage, 13250,
     /* 471097 */     GIR_EraseRootFromParent_Done,
     /* 471098 */   // Label 6606: @471098
     /* 471098 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(471233), // Rule ID 12227 //
     /* 471103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471187 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471231 */     GIR_RootConstrainSelectedInstOperands,
     /* 471232 */     // GIR_Coverage, 12227,
     /* 471232 */     GIR_EraseRootFromParent_Done,
     /* 471233 */   // Label 6607: @471233
     /* 471233 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(471368), // Rule ID 12228 //
     /* 471238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471322 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471366 */     GIR_RootConstrainSelectedInstOperands,
     /* 471367 */     // GIR_Coverage, 12228,
     /* 471367 */     GIR_EraseRootFromParent_Done,
     /* 471368 */   // Label 6608: @471368
     /* 471368 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(471503), // Rule ID 12229 //
     /* 471373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471425 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471457 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471501 */     GIR_RootConstrainSelectedInstOperands,
     /* 471502 */     // GIR_Coverage, 12229,
     /* 471502 */     GIR_EraseRootFromParent_Done,
     /* 471503 */   // Label 6609: @471503
     /* 471503 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(471638), // Rule ID 12230 //
     /* 471508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 471511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 471515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471560 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471592 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 471595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 471602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 471607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 471612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 471617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471636 */     GIR_RootConstrainSelectedInstOperands,
     /* 471637 */     // GIR_Coverage, 12230,
     /* 471637 */     GIR_EraseRootFromParent_Done,
     /* 471638 */   // Label 6610: @471638
     /* 471638 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(471773), // Rule ID 12707 //
     /* 471643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 471646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 471650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471690 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471695 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471727 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 471730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471771 */     GIR_RootConstrainSelectedInstOperands,
     /* 471772 */     // GIR_Coverage, 12707,
     /* 471772 */     GIR_EraseRootFromParent_Done,
     /* 471773 */   // Label 6611: @471773
     /* 471773 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(471908), // Rule ID 12708 //
     /* 471778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 471781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 471785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471825 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471862 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 471865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 471867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 471872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 471877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 471882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 471887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 471892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 471897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 471906 */     GIR_RootConstrainSelectedInstOperands,
     /* 471907 */     // GIR_Coverage, 12708,
     /* 471907 */     GIR_EraseRootFromParent_Done,
     /* 471908 */   // Label 6612: @471908
     /* 471908 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(472043), // Rule ID 12709 //
     /* 471913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 471916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 471920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 471924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 471928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 471932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 471936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 471940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 471944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 471948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 471952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 471956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 471960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 471960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 471965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 471965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 471970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 471974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 471976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 471997 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 471997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 472007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 472012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472041 */     GIR_RootConstrainSelectedInstOperands,
     /* 472042 */     // GIR_Coverage, 12709,
     /* 472042 */     GIR_EraseRootFromParent_Done,
     /* 472043 */   // Label 6613: @472043
     /* 472043 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(472178), // Rule ID 12710 //
     /* 472048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 472051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 472055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 472075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 472095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472100 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472132 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 472135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 472142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 472147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472176 */     GIR_RootConstrainSelectedInstOperands,
     /* 472177 */     // GIR_Coverage, 12710,
     /* 472177 */     GIR_EraseRootFromParent_Done,
     /* 472178 */   // Label 6614: @472178
     /* 472178 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(472313), // Rule ID 13187 //
     /* 472183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 472210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 472230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472235 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472267 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 472270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 472287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 472292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472311 */     GIR_RootConstrainSelectedInstOperands,
     /* 472312 */     // GIR_Coverage, 13187,
     /* 472312 */     GIR_EraseRootFromParent_Done,
     /* 472313 */   // Label 6615: @472313
     /* 472313 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(472448), // Rule ID 13188 //
     /* 472318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 472345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 472365 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472370 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472402 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 472405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 472422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 472427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472446 */     GIR_RootConstrainSelectedInstOperands,
     /* 472447 */     // GIR_Coverage, 13188,
     /* 472447 */     GIR_EraseRootFromParent_Done,
     /* 472448 */   // Label 6616: @472448
     /* 472448 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(472583), // Rule ID 13189 //
     /* 472453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 472480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 472500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472510 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472537 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 472540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 472547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 472552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472581 */     GIR_RootConstrainSelectedInstOperands,
     /* 472582 */     // GIR_Coverage, 13189,
     /* 472582 */     GIR_EraseRootFromParent_Done,
     /* 472583 */   // Label 6617: @472583
     /* 472583 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(472718), // Rule ID 13190 //
     /* 472588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 472591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 472615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 472619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 472635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472672 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 472675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 472682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 472687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 472692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 472697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472716 */     GIR_RootConstrainSelectedInstOperands,
     /* 472717 */     // GIR_Coverage, 13190,
     /* 472717 */     GIR_EraseRootFromParent_Done,
     /* 472718 */   // Label 6618: @472718
     /* 472718 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(472853), // Rule ID 12272 //
     /* 472723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 472726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 472750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 472754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472807 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 472810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 472827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 472832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472851 */     GIR_RootConstrainSelectedInstOperands,
     /* 472852 */     // GIR_Coverage, 12272,
     /* 472852 */     GIR_EraseRootFromParent_Done,
     /* 472853 */   // Label 6619: @472853
     /* 472853 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(472988), // Rule ID 12273 //
     /* 472858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 472861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 472865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 472869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 472877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 472881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 472885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 472889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 472893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 472897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 472901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 472905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 472905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 472910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 472910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 472915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 472919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 472921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 472942 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 472942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 472945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 472947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 472952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 472957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 472962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 472967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 472972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 472977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 472986 */     GIR_RootConstrainSelectedInstOperands,
     /* 472987 */     // GIR_Coverage, 12273,
     /* 472987 */     GIR_EraseRootFromParent_Done,
     /* 472988 */   // Label 6620: @472988
     /* 472988 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(473123), // Rule ID 12274 //
     /* 472993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 472996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473040 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473045 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473077 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 473087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 473092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 473107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 473112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473121 */     GIR_RootConstrainSelectedInstOperands,
     /* 473122 */     // GIR_Coverage, 12274,
     /* 473122 */     GIR_EraseRootFromParent_Done,
     /* 473123 */   // Label 6621: @473123
     /* 473123 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(473258), // Rule ID 12275 //
     /* 473128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 473131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473175 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473180 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473212 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 473215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 473222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 473227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 473242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 473247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473256 */     GIR_RootConstrainSelectedInstOperands,
     /* 473257 */     // GIR_Coverage, 12275,
     /* 473257 */     GIR_EraseRootFromParent_Done,
     /* 473258 */   // Label 6622: @473258
     /* 473258 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(473393), // Rule ID 12752 //
     /* 473263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 473270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473347 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 473350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 473367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 473372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 473377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 473382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473391 */     GIR_RootConstrainSelectedInstOperands,
     /* 473392 */     // GIR_Coverage, 12752,
     /* 473392 */     GIR_EraseRootFromParent_Done,
     /* 473393 */   // Label 6623: @473393
     /* 473393 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(473528), // Rule ID 12753 //
     /* 473398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 473405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473482 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 473485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 473502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 473507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 473512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 473517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473526 */     GIR_RootConstrainSelectedInstOperands,
     /* 473527 */     // GIR_Coverage, 12753,
     /* 473527 */     GIR_EraseRootFromParent_Done,
     /* 473528 */   // Label 6624: @473528
     /* 473528 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(473663), // Rule ID 12754 //
     /* 473533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 473540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473617 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 473620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 473627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 473632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 473647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 473652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473661 */     GIR_RootConstrainSelectedInstOperands,
     /* 473662 */     // GIR_Coverage, 12754,
     /* 473662 */     GIR_EraseRootFromParent_Done,
     /* 473663 */   // Label 6625: @473663
     /* 473663 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(473798), // Rule ID 12755 //
     /* 473668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 473671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 473675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473720 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473752 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 473755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 473762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 473767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 473772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 473777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 473782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 473787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473796 */     GIR_RootConstrainSelectedInstOperands,
     /* 473797 */     // GIR_Coverage, 12755,
     /* 473797 */     GIR_EraseRootFromParent_Done,
     /* 473798 */   // Label 6626: @473798
     /* 473798 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(473933), // Rule ID 13232 //
     /* 473803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 473806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473850 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 473866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 473887 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 473887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 473890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 473892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 473897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 473902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 473907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 473912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 473917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 473922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 473931 */     GIR_RootConstrainSelectedInstOperands,
     /* 473932 */     // GIR_Coverage, 13232,
     /* 473932 */     GIR_EraseRootFromParent_Done,
     /* 473933 */   // Label 6627: @473933
     /* 473933 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(474068), // Rule ID 13233 //
     /* 473938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 473941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 473945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 473949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 473957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 473961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 473965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 473969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 473973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 473977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 473981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 473985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 473985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 473990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 473990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 473995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 473999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474022 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 474042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 474047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 474057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474066 */     GIR_RootConstrainSelectedInstOperands,
     /* 474067 */     // GIR_Coverage, 13233,
     /* 474067 */     GIR_EraseRootFromParent_Done,
     /* 474068 */   // Label 6628: @474068
     /* 474068 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(474203), // Rule ID 13234 //
     /* 474073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 474100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474157 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 474167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 474172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 474192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474201 */     GIR_RootConstrainSelectedInstOperands,
     /* 474202 */     // GIR_Coverage, 13234,
     /* 474202 */     GIR_EraseRootFromParent_Done,
     /* 474203 */   // Label 6629: @474203
     /* 474203 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(474338), // Rule ID 13235 //
     /* 474208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 474211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 474235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474292 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 474295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 474302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 474307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 474327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474336 */     GIR_RootConstrainSelectedInstOperands,
     /* 474337 */     // GIR_Coverage, 13235,
     /* 474337 */     GIR_EraseRootFromParent_Done,
     /* 474338 */   // Label 6630: @474338
     /* 474338 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(474473), // Rule ID 12212 //
     /* 474343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 474346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 474370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474427 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 474430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 474447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 474452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 474462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474471 */     GIR_RootConstrainSelectedInstOperands,
     /* 474472 */     // GIR_Coverage, 12212,
     /* 474472 */     GIR_EraseRootFromParent_Done,
     /* 474473 */   // Label 6631: @474473
     /* 474473 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(474608), // Rule ID 12213 //
     /* 474478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 474481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 474505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474525 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474562 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 474565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 474582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 474587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 474597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474606 */     GIR_RootConstrainSelectedInstOperands,
     /* 474607 */     // GIR_Coverage, 12213,
     /* 474607 */     GIR_EraseRootFromParent_Done,
     /* 474608 */   // Label 6632: @474608
     /* 474608 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(474743), // Rule ID 12214 //
     /* 474613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 474616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 474640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474697 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 474700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 474707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 474712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 474732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474741 */     GIR_RootConstrainSelectedInstOperands,
     /* 474742 */     // GIR_Coverage, 12214,
     /* 474742 */     GIR_EraseRootFromParent_Done,
     /* 474743 */   // Label 6633: @474743
     /* 474743 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(474878), // Rule ID 12215 //
     /* 474748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 474751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 474755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 474775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474832 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 474835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 474842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 474847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 474852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 474857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 474867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 474876 */     GIR_RootConstrainSelectedInstOperands,
     /* 474877 */     // GIR_Coverage, 12215,
     /* 474877 */     GIR_EraseRootFromParent_Done,
     /* 474878 */   // Label 6634: @474878
     /* 474878 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(475013), // Rule ID 12692 //
     /* 474883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 474886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 474890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 474894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 474898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 474902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 474906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 474910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 474914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 474918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 474922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 474926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 474930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 474930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 474935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 474935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 474940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 474944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 474946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 474967 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 474967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 474970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 474972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 474977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 474982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 474987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 474992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 474997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475011 */     GIR_RootConstrainSelectedInstOperands,
     /* 475012 */     // GIR_Coverage, 12692,
     /* 475012 */     GIR_EraseRootFromParent_Done,
     /* 475013 */   // Label 6635: @475013
     /* 475013 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(475148), // Rule ID 12693 //
     /* 475018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 475045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 475065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475102 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 475122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 475127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 475132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475146 */     GIR_RootConstrainSelectedInstOperands,
     /* 475147 */     // GIR_Coverage, 12693,
     /* 475147 */     GIR_EraseRootFromParent_Done,
     /* 475148 */   // Label 6636: @475148
     /* 475148 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(475283), // Rule ID 12694 //
     /* 475153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 475180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 475200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475210 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475237 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 475247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 475252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 475267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475281 */     GIR_RootConstrainSelectedInstOperands,
     /* 475282 */     // GIR_Coverage, 12694,
     /* 475282 */     GIR_EraseRootFromParent_Done,
     /* 475283 */   // Label 6637: @475283
     /* 475283 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(475418), // Rule ID 12695 //
     /* 475288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 475291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 475295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 475315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 475335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475372 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 475375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 475382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 475387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 475402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475416 */     GIR_RootConstrainSelectedInstOperands,
     /* 475417 */     // GIR_Coverage, 12695,
     /* 475417 */     GIR_EraseRootFromParent_Done,
     /* 475418 */   // Label 6638: @475418
     /* 475418 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(475553), // Rule ID 13172 //
     /* 475423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 475426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 475450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 475470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475507 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 475510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 475527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 475532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 475537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475551 */     GIR_RootConstrainSelectedInstOperands,
     /* 475552 */     // GIR_Coverage, 13172,
     /* 475552 */     GIR_EraseRootFromParent_Done,
     /* 475553 */   // Label 6639: @475553
     /* 475553 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(475688), // Rule ID 13173 //
     /* 475558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 475561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 475585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 475605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475642 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 475645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 475652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 475657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 475662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 475667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 475672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475686 */     GIR_RootConstrainSelectedInstOperands,
     /* 475687 */     // GIR_Coverage, 13173,
     /* 475687 */     GIR_EraseRootFromParent_Done,
     /* 475688 */   // Label 6640: @475688
     /* 475688 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(475823), // Rule ID 13174 //
     /* 475693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 475696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 475720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 475740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475777 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 475780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 475787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 475792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 475807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475821 */     GIR_RootConstrainSelectedInstOperands,
     /* 475822 */     // GIR_Coverage, 13174,
     /* 475822 */     GIR_EraseRootFromParent_Done,
     /* 475823 */   // Label 6641: @475823
     /* 475823 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(475958), // Rule ID 13175 //
     /* 475828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 475831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 475855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 475859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 475867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 475871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 475875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 475875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 475880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 475880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 475885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 475889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 475891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 475912 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 475912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 475915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 475917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 475922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 475927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 475932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 475937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 475942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 475947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 475956 */     GIR_RootConstrainSelectedInstOperands,
     /* 475957 */     // GIR_Coverage, 13175,
     /* 475957 */     GIR_EraseRootFromParent_Done,
     /* 475958 */   // Label 6642: @475958
     /* 475958 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(476093), // Rule ID 12283 //
     /* 475963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 475966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 475970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 475974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 475978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 475982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 475986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 475990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 475994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 475998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476047 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476091 */     GIR_RootConstrainSelectedInstOperands,
     /* 476092 */     // GIR_Coverage, 12283,
     /* 476092 */     GIR_EraseRootFromParent_Done,
     /* 476093 */   // Label 6643: @476093
     /* 476093 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(476228), // Rule ID 12284 //
     /* 476098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 476129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476182 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476226 */     GIR_RootConstrainSelectedInstOperands,
     /* 476227 */     // GIR_Coverage, 12284,
     /* 476227 */     GIR_EraseRootFromParent_Done,
     /* 476228 */   // Label 6644: @476228
     /* 476228 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(476363), // Rule ID 12285 //
     /* 476233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 476264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476317 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476361 */     GIR_RootConstrainSelectedInstOperands,
     /* 476362 */     // GIR_Coverage, 12285,
     /* 476362 */     GIR_EraseRootFromParent_Done,
     /* 476363 */   // Label 6645: @476363
     /* 476363 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(476498), // Rule ID 12286 //
     /* 476368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 476371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 476375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 476399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476452 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 476455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476496 */     GIR_RootConstrainSelectedInstOperands,
     /* 476497 */     // GIR_Coverage, 12286,
     /* 476497 */     GIR_EraseRootFromParent_Done,
     /* 476498 */   // Label 6646: @476498
     /* 476498 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(476633), // Rule ID 12763 //
     /* 476503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 476506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 476510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 476534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476587 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 476590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476631 */     GIR_RootConstrainSelectedInstOperands,
     /* 476632 */     // GIR_Coverage, 12763,
     /* 476632 */     GIR_EraseRootFromParent_Done,
     /* 476633 */   // Label 6647: @476633
     /* 476633 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(476768), // Rule ID 12764 //
     /* 476638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 476641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 476645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 476669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476690 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476722 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 476725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 476732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 476737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 476742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 476747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476766 */     GIR_RootConstrainSelectedInstOperands,
     /* 476767 */     // GIR_Coverage, 12764,
     /* 476767 */     GIR_EraseRootFromParent_Done,
     /* 476768 */   // Label 6648: @476768
     /* 476768 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(476903), // Rule ID 12765 //
     /* 476773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 476776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 476780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 476804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476820 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476825 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476857 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 476860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 476867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 476872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 476877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 476882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 476887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 476892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 476901 */     GIR_RootConstrainSelectedInstOperands,
     /* 476902 */     // GIR_Coverage, 12765,
     /* 476902 */     GIR_EraseRootFromParent_Done,
     /* 476903 */   // Label 6649: @476903
     /* 476903 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(477038), // Rule ID 12766 //
     /* 476908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 476911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 476915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 476919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 476927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 476931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 476935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 476939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 476943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 476947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 476951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 476955 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 476955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 476960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 476960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 476965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 476969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 476971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 476992 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 476992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 476995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 476997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477036 */     GIR_RootConstrainSelectedInstOperands,
     /* 477037 */     // GIR_Coverage, 12766,
     /* 477037 */     GIR_EraseRootFromParent_Done,
     /* 477038 */   // Label 6650: @477038
     /* 477038 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(477173), // Rule ID 13243 //
     /* 477043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 477074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477127 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477171 */     GIR_RootConstrainSelectedInstOperands,
     /* 477172 */     // GIR_Coverage, 13243,
     /* 477172 */     GIR_EraseRootFromParent_Done,
     /* 477173 */   // Label 6651: @477173
     /* 477173 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(477308), // Rule ID 13244 //
     /* 477178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 477209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477262 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477306 */     GIR_RootConstrainSelectedInstOperands,
     /* 477307 */     // GIR_Coverage, 13244,
     /* 477307 */     GIR_EraseRootFromParent_Done,
     /* 477308 */   // Label 6652: @477308
     /* 477308 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(477443), // Rule ID 13245 //
     /* 477313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 477344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477365 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477397 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477441 */     GIR_RootConstrainSelectedInstOperands,
     /* 477442 */     // GIR_Coverage, 13245,
     /* 477442 */     GIR_EraseRootFromParent_Done,
     /* 477443 */   // Label 6653: @477443
     /* 477443 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(477578), // Rule ID 13246 //
     /* 477448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 477451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 477479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477495 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477532 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 477535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477576 */     GIR_RootConstrainSelectedInstOperands,
     /* 477577 */     // GIR_Coverage, 13246,
     /* 477577 */     GIR_EraseRootFromParent_Done,
     /* 477578 */   // Label 6654: @477578
     /* 477578 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(477713), // Rule ID 12223 //
     /* 477583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 477586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 477614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477667 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 477670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477711 */     GIR_RootConstrainSelectedInstOperands,
     /* 477712 */     // GIR_Coverage, 12223,
     /* 477712 */     GIR_EraseRootFromParent_Done,
     /* 477713 */   // Label 6655: @477713
     /* 477713 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(477848), // Rule ID 12224 //
     /* 477718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 477721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 477749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477802 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 477805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 477812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 477817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 477822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 477827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477846 */     GIR_RootConstrainSelectedInstOperands,
     /* 477847 */     // GIR_Coverage, 12224,
     /* 477847 */     GIR_EraseRootFromParent_Done,
     /* 477848 */   // Label 6656: @477848
     /* 477848 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(477983), // Rule ID 12225 //
     /* 477853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 477856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 477868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 477872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 477876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 477880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 477884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 477888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 477892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 477896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 477900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 477900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 477905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 477905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 477910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 477914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 477916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 477937 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 477937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 477940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 477942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 477947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 477952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 477957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 477962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 477967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 477972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 477981 */     GIR_RootConstrainSelectedInstOperands,
     /* 477982 */     // GIR_Coverage, 12225,
     /* 477982 */     GIR_EraseRootFromParent_Done,
     /* 477983 */   // Label 6657: @477983
     /* 477983 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(478118), // Rule ID 12226 //
     /* 477988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 477991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 477995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 477999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478035 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478040 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478072 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 478075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478116 */     GIR_RootConstrainSelectedInstOperands,
     /* 478117 */     // GIR_Coverage, 12226,
     /* 478117 */     GIR_EraseRootFromParent_Done,
     /* 478118 */   // Label 6658: @478118
     /* 478118 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(478253), // Rule ID 12703 //
     /* 478123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478170 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478175 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478207 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478251 */     GIR_RootConstrainSelectedInstOperands,
     /* 478252 */     // GIR_Coverage, 12703,
     /* 478252 */     GIR_EraseRootFromParent_Done,
     /* 478253 */   // Label 6659: @478253
     /* 478253 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(478388), // Rule ID 12704 //
     /* 478258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478342 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478386 */     GIR_RootConstrainSelectedInstOperands,
     /* 478387 */     // GIR_Coverage, 12704,
     /* 478387 */     GIR_EraseRootFromParent_Done,
     /* 478388 */   // Label 6660: @478388
     /* 478388 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(478523), // Rule ID 12705 //
     /* 478393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478477 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478521 */     GIR_RootConstrainSelectedInstOperands,
     /* 478522 */     // GIR_Coverage, 12705,
     /* 478522 */     GIR_EraseRootFromParent_Done,
     /* 478523 */   // Label 6661: @478523
     /* 478523 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(478658), // Rule ID 12706 //
     /* 478528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 478531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 478535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478612 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 478615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 478622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 478627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 478632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 478637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478656 */     GIR_RootConstrainSelectedInstOperands,
     /* 478657 */     // GIR_Coverage, 12706,
     /* 478657 */     GIR_EraseRootFromParent_Done,
     /* 478658 */   // Label 6662: @478658
     /* 478658 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(478793), // Rule ID 13183 //
     /* 478663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 478666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478747 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 478750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478791 */     GIR_RootConstrainSelectedInstOperands,
     /* 478792 */     // GIR_Coverage, 13183,
     /* 478792 */     GIR_EraseRootFromParent_Done,
     /* 478793 */   // Label 6663: @478793
     /* 478793 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(478928), // Rule ID 13184 //
     /* 478798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 478801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478850 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 478882 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 478882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 478885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 478887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 478892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 478897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 478902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 478907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 478912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 478917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 478926 */     GIR_RootConstrainSelectedInstOperands,
     /* 478927 */     // GIR_Coverage, 13184,
     /* 478927 */     GIR_EraseRootFromParent_Done,
     /* 478928 */   // Label 6664: @478928
     /* 478928 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(479063), // Rule ID 13185 //
     /* 478933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 478936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 478940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 478944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 478948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 478952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 478956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 478960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 478964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 478968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 478972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 478976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 478980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 478980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 478985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 478985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 478990 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 478994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 478996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479017 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479061 */     GIR_RootConstrainSelectedInstOperands,
     /* 479062 */     // GIR_Coverage, 13185,
     /* 479062 */     GIR_EraseRootFromParent_Done,
     /* 479063 */   // Label 6665: @479063
     /* 479063 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(479198), // Rule ID 13186 //
     /* 479068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 479071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 479095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 479099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 479111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 479115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 479120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 479125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479152 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 479155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479196 */     GIR_RootConstrainSelectedInstOperands,
     /* 479197 */     // GIR_Coverage, 13186,
     /* 479197 */     GIR_EraseRootFromParent_Done,
     /* 479198 */   // Label 6666: @479198
     /* 479198 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(479333), // Rule ID 12268 //
     /* 479203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 479230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 479246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 479255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 479260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479287 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 479290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479331 */     GIR_RootConstrainSelectedInstOperands,
     /* 479332 */     // GIR_Coverage, 12268,
     /* 479332 */     GIR_EraseRootFromParent_Done,
     /* 479333 */   // Label 6667: @479333
     /* 479333 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(479468), // Rule ID 12269 //
     /* 479338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 479365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 479381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 479390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 479395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479422 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 479425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479466 */     GIR_RootConstrainSelectedInstOperands,
     /* 479467 */     // GIR_Coverage, 12269,
     /* 479467 */     GIR_EraseRootFromParent_Done,
     /* 479468 */   // Label 6668: @479468
     /* 479468 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(479603), // Rule ID 12270 //
     /* 479473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 479500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 479516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 479525 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 479530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479557 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 479560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479601 */     GIR_RootConstrainSelectedInstOperands,
     /* 479602 */     // GIR_Coverage, 12270,
     /* 479602 */     GIR_EraseRootFromParent_Done,
     /* 479603 */   // Label 6669: @479603
     /* 479603 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(479738), // Rule ID 12271 //
     /* 479608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 479611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 479615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 479635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 479651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479655 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 479660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 479665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479692 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 479695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 479702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 479707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 479712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 479717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479736 */     GIR_RootConstrainSelectedInstOperands,
     /* 479737 */     // GIR_Coverage, 12271,
     /* 479737 */     GIR_EraseRootFromParent_Done,
     /* 479738 */   // Label 6670: @479738
     /* 479738 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(479873), // Rule ID 12748 //
     /* 479743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 479746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 479750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 479770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 479786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 479795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 479800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479827 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 479830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 479871 */     GIR_RootConstrainSelectedInstOperands,
     /* 479872 */     // GIR_Coverage, 12748,
     /* 479872 */     GIR_EraseRootFromParent_Done,
     /* 479873 */   // Label 6671: @479873
     /* 479873 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(480008), // Rule ID 12749 //
     /* 479878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 479881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 479885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 479889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 479897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 479901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 479905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 479909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 479913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 479917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 479921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 479925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 479925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 479930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 479930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 479935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 479939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 479941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 479962 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 479962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 479965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 479967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 479972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 479977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 479982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 479987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 479992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 479997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480006 */     GIR_RootConstrainSelectedInstOperands,
     /* 480007 */     // GIR_Coverage, 12749,
     /* 480007 */     GIR_EraseRootFromParent_Done,
     /* 480008 */   // Label 6672: @480008
     /* 480008 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(480143), // Rule ID 12750 //
     /* 480013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 480056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 480065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 480070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480097 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480141 */     GIR_RootConstrainSelectedInstOperands,
     /* 480142 */     // GIR_Coverage, 12750,
     /* 480142 */     GIR_EraseRootFromParent_Done,
     /* 480143 */   // Label 6673: @480143
     /* 480143 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(480278), // Rule ID 12751 //
     /* 480148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 480151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 480155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 480191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 480200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 480205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480232 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 480235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480276 */     GIR_RootConstrainSelectedInstOperands,
     /* 480277 */     // GIR_Coverage, 12751,
     /* 480277 */     GIR_EraseRootFromParent_Done,
     /* 480278 */   // Label 6674: @480278
     /* 480278 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(480413), // Rule ID 13228 //
     /* 480283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 480286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 480326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 480335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 480340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480367 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 480370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480411 */     GIR_RootConstrainSelectedInstOperands,
     /* 480412 */     // GIR_Coverage, 13228,
     /* 480412 */     GIR_EraseRootFromParent_Done,
     /* 480413 */   // Label 6675: @480413
     /* 480413 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(480548), // Rule ID 13229 //
     /* 480418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 480421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 480461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 480470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 480475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480502 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 480505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480546 */     GIR_RootConstrainSelectedInstOperands,
     /* 480547 */     // GIR_Coverage, 13229,
     /* 480547 */     GIR_EraseRootFromParent_Done,
     /* 480548 */   // Label 6676: @480548
     /* 480548 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(480683), // Rule ID 13230 //
     /* 480553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 480556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 480596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 480605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 480610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480637 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 480640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480681 */     GIR_RootConstrainSelectedInstOperands,
     /* 480682 */     // GIR_Coverage, 13230,
     /* 480682 */     GIR_EraseRootFromParent_Done,
     /* 480683 */   // Label 6677: @480683
     /* 480683 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(480818), // Rule ID 13231 //
     /* 480688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 480691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 480731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 480740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 480745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480772 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 480775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 480782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 480787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 480792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 480797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480816 */     GIR_RootConstrainSelectedInstOperands,
     /* 480817 */     // GIR_Coverage, 13231,
     /* 480817 */     GIR_EraseRootFromParent_Done,
     /* 480818 */   // Label 6678: @480818
     /* 480818 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(480953), // Rule ID 12208 //
     /* 480823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 480826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 480866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 480870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 480870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 480875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 480875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 480880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 480884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 480886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 480907 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 480907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 480910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 480912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 480917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 480922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 480927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 480932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 480937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 480942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 480951 */     GIR_RootConstrainSelectedInstOperands,
     /* 480952 */     // GIR_Coverage, 12208,
     /* 480952 */     GIR_EraseRootFromParent_Done,
     /* 480953 */   // Label 6679: @480953
     /* 480953 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(481088), // Rule ID 12209 //
     /* 480958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 480961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 480965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 480969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 480973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 480977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 480981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 480985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 480989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 480993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 480997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481015 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481042 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 481045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481086 */     GIR_RootConstrainSelectedInstOperands,
     /* 481087 */     // GIR_Coverage, 12209,
     /* 481087 */     GIR_EraseRootFromParent_Done,
     /* 481088 */   // Label 6680: @481088
     /* 481088 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(481223), // Rule ID 12210 //
     /* 481093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 481120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481177 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 481180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481221 */     GIR_RootConstrainSelectedInstOperands,
     /* 481222 */     // GIR_Coverage, 12210,
     /* 481222 */     GIR_EraseRootFromParent_Done,
     /* 481223 */   // Label 6681: @481223
     /* 481223 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(481358), // Rule ID 12211 //
     /* 481228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 481231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 481255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481312 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 481315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481356 */     GIR_RootConstrainSelectedInstOperands,
     /* 481357 */     // GIR_Coverage, 12211,
     /* 481357 */     GIR_EraseRootFromParent_Done,
     /* 481358 */   // Label 6682: @481358
     /* 481358 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(481493), // Rule ID 12688 //
     /* 481363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 481366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 481370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 481390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481433 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481447 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 481450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481491 */     GIR_RootConstrainSelectedInstOperands,
     /* 481492 */     // GIR_Coverage, 12688,
     /* 481492 */     GIR_EraseRootFromParent_Done,
     /* 481493 */   // Label 6683: @481493
     /* 481493 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(481628), // Rule ID 12689 //
     /* 481498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 481501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 481505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 481525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481545 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481582 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 481585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 481597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 481602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 481607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481626 */     GIR_RootConstrainSelectedInstOperands,
     /* 481627 */     // GIR_Coverage, 12689,
     /* 481627 */     GIR_EraseRootFromParent_Done,
     /* 481628 */   // Label 6684: @481628
     /* 481628 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(481763), // Rule ID 12690 //
     /* 481633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 481636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 481640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 481660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481680 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481690 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481696 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481717 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 481720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481761 */     GIR_RootConstrainSelectedInstOperands,
     /* 481762 */     // GIR_Coverage, 12690,
     /* 481762 */     GIR_EraseRootFromParent_Done,
     /* 481763 */   // Label 6685: @481763
     /* 481763 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(481898), // Rule ID 12691 //
     /* 481768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 481771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 481775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 481795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481815 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481820 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481825 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481852 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 481855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 481862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 481867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 481872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 481877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 481882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 481887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 481896 */     GIR_RootConstrainSelectedInstOperands,
     /* 481897 */     // GIR_Coverage, 12691,
     /* 481897 */     GIR_EraseRootFromParent_Done,
     /* 481898 */   // Label 6686: @481898
     /* 481898 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(482033), // Rule ID 13168 //
     /* 481903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 481906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 481910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 481914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 481918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 481922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 481926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 481930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 481934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 481938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 481942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 481946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 481950 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 481950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 481955 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 481955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 481960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 481964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 481966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481980 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 481987 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 481987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 481990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 481992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 481997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482031 */     GIR_RootConstrainSelectedInstOperands,
     /* 482032 */     // GIR_Coverage, 13168,
     /* 482032 */     GIR_EraseRootFromParent_Done,
     /* 482033 */   // Label 6687: @482033
     /* 482033 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(482168), // Rule ID 13169 //
     /* 482038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 482065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 482069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 482081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 482090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 482095 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482101 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482122 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482166 */     GIR_RootConstrainSelectedInstOperands,
     /* 482167 */     // GIR_Coverage, 13169,
     /* 482167 */     GIR_EraseRootFromParent_Done,
     /* 482168 */   // Label 6688: @482168
     /* 482168 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(482303), // Rule ID 13170 //
     /* 482173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 482200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 482204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 482216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 482225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 482230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482257 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482301 */     GIR_RootConstrainSelectedInstOperands,
     /* 482302 */     // GIR_Coverage, 13170,
     /* 482302 */     GIR_EraseRootFromParent_Done,
     /* 482303 */   // Label 6689: @482303
     /* 482303 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(482438), // Rule ID 13171 //
     /* 482308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 482311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 482335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 482339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 482351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 482360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 482365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482392 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 482395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482436 */     GIR_RootConstrainSelectedInstOperands,
     /* 482437 */     // GIR_Coverage, 13171,
     /* 482437 */     GIR_EraseRootFromParent_Done,
     /* 482438 */   // Label 6690: @482438
     /* 482438 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(482573), // Rule ID 12217 //
     /* 482443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 482446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 482486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482495 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482500 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482527 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482571 */     GIR_RootConstrainSelectedInstOperands,
     /* 482572 */     // GIR_Coverage, 12217,
     /* 482572 */     GIR_EraseRootFromParent_Done,
     /* 482573 */   // Label 6691: @482573
     /* 482573 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(482708), // Rule ID 12218 //
     /* 482578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 482581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 482621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482625 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482662 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 482672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 482677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 482682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 482687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482706 */     GIR_RootConstrainSelectedInstOperands,
     /* 482707 */     // GIR_Coverage, 12218,
     /* 482707 */     GIR_EraseRootFromParent_Done,
     /* 482708 */   // Label 6692: @482708
     /* 482708 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(482843), // Rule ID 12221 //
     /* 482713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 482716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 482756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482760 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482776 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482797 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482841 */     GIR_RootConstrainSelectedInstOperands,
     /* 482842 */     // GIR_Coverage, 12221,
     /* 482842 */     GIR_EraseRootFromParent_Done,
     /* 482843 */   // Label 6693: @482843
     /* 482843 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(482978), // Rule ID 12222 //
     /* 482848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 482851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 482855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 482867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 482871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 482875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 482879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 482883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 482887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 482891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 482895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 482895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 482900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 482900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 482905 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 482909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 482911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 482932 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 482932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 482935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 482937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 482942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 482947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 482952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 482957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 482962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 482967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 482976 */     GIR_RootConstrainSelectedInstOperands,
     /* 482977 */     // GIR_Coverage, 12222,
     /* 482977 */     GIR_EraseRootFromParent_Done,
     /* 482978 */   // Label 6694: @482978
     /* 482978 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(483113), // Rule ID 12697 //
     /* 482983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 482986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 482990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 482994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 482998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483035 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483040 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483067 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483111 */     GIR_RootConstrainSelectedInstOperands,
     /* 483112 */     // GIR_Coverage, 12697,
     /* 483112 */     GIR_EraseRootFromParent_Done,
     /* 483113 */   // Label 6695: @483113
     /* 483113 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(483248), // Rule ID 12698 //
     /* 483118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483165 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483170 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483175 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483188 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483195 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483202 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483246 */     GIR_RootConstrainSelectedInstOperands,
     /* 483247 */     // GIR_Coverage, 12698,
     /* 483247 */     GIR_EraseRootFromParent_Done,
     /* 483248 */   // Label 6696: @483248
     /* 483248 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(483383), // Rule ID 12701 //
     /* 483253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483300 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483310 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483316 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483323 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483337 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483381 */     GIR_RootConstrainSelectedInstOperands,
     /* 483382 */     // GIR_Coverage, 12701,
     /* 483382 */     GIR_EraseRootFromParent_Done,
     /* 483383 */   // Label 6697: @483383
     /* 483383 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(483518), // Rule ID 12702 //
     /* 483388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 483391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 483395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483435 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483472 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 483475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483516 */     GIR_RootConstrainSelectedInstOperands,
     /* 483517 */     // GIR_Coverage, 12702,
     /* 483517 */     GIR_EraseRootFromParent_Done,
     /* 483518 */   // Label 6698: @483518
     /* 483518 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(483653), // Rule ID 13177 //
     /* 483523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 483526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483558 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483586 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483600 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483607 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 483610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483651 */     GIR_RootConstrainSelectedInstOperands,
     /* 483652 */     // GIR_Coverage, 13177,
     /* 483652 */     GIR_EraseRootFromParent_Done,
     /* 483653 */   // Label 6699: @483653
     /* 483653 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(483788), // Rule ID 13178 //
     /* 483658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 483661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483742 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 483745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 483752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 483757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 483762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 483767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483786 */     GIR_RootConstrainSelectedInstOperands,
     /* 483787 */     // GIR_Coverage, 13178,
     /* 483787 */     GIR_EraseRootFromParent_Done,
     /* 483788 */   // Label 6700: @483788
     /* 483788 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(483923), // Rule ID 13181 //
     /* 483793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 483796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483877 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 483877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 483880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 483882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 483887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 483892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 483897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 483902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 483907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 483912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 483921 */     GIR_RootConstrainSelectedInstOperands,
     /* 483922 */     // GIR_Coverage, 13181,
     /* 483922 */     GIR_EraseRootFromParent_Done,
     /* 483923 */   // Label 6701: @483923
     /* 483923 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(484058), // Rule ID 13182 //
     /* 483928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 483931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 483935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 483939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 483943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 483947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 483951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 483955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 483959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 483963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 483967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 483971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 483975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 483975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 483980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 483980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 483985 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 483989 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 483991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 483998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484005 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484012 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 484015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484056 */     GIR_RootConstrainSelectedInstOperands,
     /* 484057 */     // GIR_Coverage, 13182,
     /* 484057 */     GIR_EraseRootFromParent_Done,
     /* 484058 */   // Label 6702: @484058
     /* 484058 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(484193), // Rule ID 12202 //
     /* 484063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484147 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484191 */     GIR_RootConstrainSelectedInstOperands,
     /* 484192 */     // GIR_Coverage, 12202,
     /* 484192 */     GIR_EraseRootFromParent_Done,
     /* 484193 */   // Label 6703: @484193
     /* 484193 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(484328), // Rule ID 12203 //
     /* 484198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484255 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484282 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484326 */     GIR_RootConstrainSelectedInstOperands,
     /* 484327 */     // GIR_Coverage, 12203,
     /* 484327 */     GIR_EraseRootFromParent_Done,
     /* 484328 */   // Label 6704: @484328
     /* 484328 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(484463), // Rule ID 12206 //
     /* 484333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484417 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484461 */     GIR_RootConstrainSelectedInstOperands,
     /* 484462 */     // GIR_Coverage, 12206,
     /* 484462 */     GIR_EraseRootFromParent_Done,
     /* 484463 */   // Label 6705: @484463
     /* 484463 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(484598), // Rule ID 12207 //
     /* 484468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 484471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 484475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484552 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 484555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484596 */     GIR_RootConstrainSelectedInstOperands,
     /* 484597 */     // GIR_Coverage, 12207,
     /* 484597 */     GIR_EraseRootFromParent_Done,
     /* 484598 */   // Label 6706: @484598
     /* 484598 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(484733), // Rule ID 12682 //
     /* 484603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 484606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 484610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484655 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484673 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484680 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484687 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 484690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484731 */     GIR_RootConstrainSelectedInstOperands,
     /* 484732 */     // GIR_Coverage, 12682,
     /* 484732 */     GIR_EraseRootFromParent_Done,
     /* 484733 */   // Label 6707: @484733
     /* 484733 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(484868), // Rule ID 12683 //
     /* 484738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 484741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 484745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484795 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484815 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484822 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 484825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 484832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 484837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 484842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 484847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484866 */     GIR_RootConstrainSelectedInstOperands,
     /* 484867 */     // GIR_Coverage, 12683,
     /* 484867 */     GIR_EraseRootFromParent_Done,
     /* 484868 */   // Label 6708: @484868
     /* 484868 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(485003), // Rule ID 12686 //
     /* 484873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 484876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 484880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 484884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 484888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 484892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 484896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 484900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 484904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 484908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 484912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 484916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 484920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 484920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 484925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 484925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 484930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 484934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 484936 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 484957 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 484957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 484960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 484962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 484967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 484972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 484977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 484982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 484987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 484992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 484998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485001 */     GIR_RootConstrainSelectedInstOperands,
     /* 485002 */     // GIR_Coverage, 12686,
     /* 485002 */     GIR_EraseRootFromParent_Done,
     /* 485003 */   // Label 6709: @485003
     /* 485003 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(485138), // Rule ID 12687 //
     /* 485008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 485055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485092 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485136 */     GIR_RootConstrainSelectedInstOperands,
     /* 485137 */     // GIR_Coverage, 12687,
     /* 485137 */     GIR_EraseRootFromParent_Done,
     /* 485138 */   // Label 6710: @485138
     /* 485138 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(485273), // Rule ID 13162 //
     /* 485143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 485190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485227 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485271 */     GIR_RootConstrainSelectedInstOperands,
     /* 485272 */     // GIR_Coverage, 13162,
     /* 485272 */     GIR_EraseRootFromParent_Done,
     /* 485273 */   // Label 6711: @485273
     /* 485273 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(485408), // Rule ID 13163 //
     /* 485278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 485325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485362 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485406 */     GIR_RootConstrainSelectedInstOperands,
     /* 485407 */     // GIR_Coverage, 13163,
     /* 485407 */     GIR_EraseRootFromParent_Done,
     /* 485408 */   // Label 6712: @485408
     /* 485408 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(485543), // Rule ID 13166 //
     /* 485413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 485460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485470 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485497 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485541 */     GIR_RootConstrainSelectedInstOperands,
     /* 485542 */     // GIR_Coverage, 13166,
     /* 485542 */     GIR_EraseRootFromParent_Done,
     /* 485543 */   // Label 6713: @485543
     /* 485543 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(485678), // Rule ID 13167 //
     /* 485548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 485591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 485595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485605 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485618 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485625 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485632 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 485635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 485642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 485647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 485652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 485657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485676 */     GIR_RootConstrainSelectedInstOperands,
     /* 485677 */     // GIR_Coverage, 13167,
     /* 485677 */     GIR_EraseRootFromParent_Done,
     /* 485678 */   // Label 6714: @485678
     /* 485678 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(485813), // Rule ID 7768 //
     /* 485683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 485686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 485726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485767 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 485770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485811 */     GIR_RootConstrainSelectedInstOperands,
     /* 485812 */     // GIR_Coverage, 7768,
     /* 485812 */     GIR_EraseRootFromParent_Done,
     /* 485813 */   // Label 6715: @485813
     /* 485813 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(485948), // Rule ID 7800 //
     /* 485818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 485821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 485825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 485861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 485865 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 485865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 485870 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 485870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 485875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 485879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 485881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 485902 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 485902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 485905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 485907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 485912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 485917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 485922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 485927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 485932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 485937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 485946 */     GIR_RootConstrainSelectedInstOperands,
     /* 485947 */     // GIR_Coverage, 7800,
     /* 485947 */     GIR_EraseRootFromParent_Done,
     /* 485948 */   // Label 6716: @485948
     /* 485948 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(486083), // Rule ID 7832 //
     /* 485953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 485956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 485960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 485964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 485968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 485972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 485976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 485980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 485984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 485988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 485992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 485996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486037 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 486040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486081 */     GIR_RootConstrainSelectedInstOperands,
     /* 486082 */     // GIR_Coverage, 7832,
     /* 486082 */     GIR_EraseRootFromParent_Done,
     /* 486083 */   // Label 6717: @486083
     /* 486083 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(486218), // Rule ID 12216 //
     /* 486088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 486119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 486131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486172 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486216 */     GIR_RootConstrainSelectedInstOperands,
     /* 486217 */     // GIR_Coverage, 12216,
     /* 486217 */     GIR_EraseRootFromParent_Done,
     /* 486218 */   // Label 6718: @486218
     /* 486218 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(486353), // Rule ID 12219 //
     /* 486223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 486254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 486266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486307 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486351 */     GIR_RootConstrainSelectedInstOperands,
     /* 486352 */     // GIR_Coverage, 12219,
     /* 486352 */     GIR_EraseRootFromParent_Done,
     /* 486353 */   // Label 6719: @486353
     /* 486353 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(486488), // Rule ID 12220 //
     /* 486358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 486361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 486389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 486401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486410 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486415 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486421 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486442 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 486445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486486 */     GIR_RootConstrainSelectedInstOperands,
     /* 486487 */     // GIR_Coverage, 12220,
     /* 486487 */     GIR_EraseRootFromParent_Done,
     /* 486488 */   // Label 6720: @486488
     /* 486488 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(486623), // Rule ID 12696 //
     /* 486493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 486496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 486500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 486524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 486536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486540 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486545 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486550 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486577 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 486580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 486597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 486602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486621 */     GIR_RootConstrainSelectedInstOperands,
     /* 486622 */     // GIR_Coverage, 12696,
     /* 486622 */     GIR_EraseRootFromParent_Done,
     /* 486623 */   // Label 6721: @486623
     /* 486623 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(486758), // Rule ID 12699 //
     /* 486628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 486631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 486635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 486659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 486671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486675 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486680 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486712 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 486715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486756 */     GIR_RootConstrainSelectedInstOperands,
     /* 486757 */     // GIR_Coverage, 12699,
     /* 486757 */     GIR_EraseRootFromParent_Done,
     /* 486758 */   // Label 6722: @486758
     /* 486758 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(486893), // Rule ID 12700 //
     /* 486763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 486766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 486770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 486794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 486806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486810 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486815 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486815 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486847 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 486850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 486857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 486862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 486867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 486872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 486877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 486882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 486891 */     GIR_RootConstrainSelectedInstOperands,
     /* 486892 */     // GIR_Coverage, 12700,
     /* 486892 */     GIR_EraseRootFromParent_Done,
     /* 486893 */   // Label 6723: @486893
     /* 486893 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(487028), // Rule ID 13176 //
     /* 486898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 486901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 486905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 486909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 486913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 486917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 486921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 486925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 486929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 486933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 486937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 486941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 486945 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 486945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 486950 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 486950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 486955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 486959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 486961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 486982 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 486982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 486985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 486987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 486992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 486997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487026 */     GIR_RootConstrainSelectedInstOperands,
     /* 487027 */     // GIR_Coverage, 13176,
     /* 487027 */     GIR_EraseRootFromParent_Done,
     /* 487028 */   // Label 6724: @487028
     /* 487028 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(487163), // Rule ID 13179 //
     /* 487033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 487064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 487080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487085 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487085 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487117 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487161 */     GIR_RootConstrainSelectedInstOperands,
     /* 487162 */     // GIR_Coverage, 13179,
     /* 487162 */     GIR_EraseRootFromParent_Done,
     /* 487163 */   // Label 6725: @487163
     /* 487163 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(487298), // Rule ID 13180 //
     /* 487168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 487199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 487215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487220 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487252 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487296 */     GIR_RootConstrainSelectedInstOperands,
     /* 487297 */     // GIR_Coverage, 13180,
     /* 487297 */     GIR_EraseRootFromParent_Done,
     /* 487298 */   // Label 6726: @487298
     /* 487298 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(487433), // Rule ID 7767 //
     /* 487303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 487306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 487334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487350 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487387 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 487390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487431 */     GIR_RootConstrainSelectedInstOperands,
     /* 487432 */     // GIR_Coverage, 7767,
     /* 487432 */     GIR_EraseRootFromParent_Done,
     /* 487433 */   // Label 6727: @487433
     /* 487433 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(487568), // Rule ID 7799 //
     /* 487438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 487441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 487445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 487469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487485 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487490 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487522 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 487525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487566 */     GIR_RootConstrainSelectedInstOperands,
     /* 487567 */     // GIR_Coverage, 7799,
     /* 487567 */     GIR_EraseRootFromParent_Done,
     /* 487568 */   // Label 6728: @487568
     /* 487568 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(487703), // Rule ID 7831 //
     /* 487573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 487576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 487604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487620 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487625 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487630 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487657 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 487660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487701 */     GIR_RootConstrainSelectedInstOperands,
     /* 487702 */     // GIR_Coverage, 7831,
     /* 487702 */     GIR_EraseRootFromParent_Done,
     /* 487703 */   // Label 6729: @487703
     /* 487703 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(487838), // Rule ID 12201 //
     /* 487708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 487711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 487739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487755 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487760 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487778 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487792 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 487795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 487802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 487807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 487812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 487817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487836 */     GIR_RootConstrainSelectedInstOperands,
     /* 487837 */     // GIR_Coverage, 12201,
     /* 487837 */     GIR_EraseRootFromParent_Done,
     /* 487838 */   // Label 6730: @487838
     /* 487838 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(487973), // Rule ID 12204 //
     /* 487843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 487846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 487866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 487870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 487874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 487878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 487882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 487886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 487890 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 487890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 487895 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 487895 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 487900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 487904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 487906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 487927 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 487927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 487930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 487932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 487937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 487942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 487947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 487952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 487957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 487962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 487971 */     GIR_RootConstrainSelectedInstOperands,
     /* 487972 */     // GIR_Coverage, 12204,
     /* 487972 */     GIR_EraseRootFromParent_Done,
     /* 487973 */   // Label 6731: @487973
     /* 487973 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(488108), // Rule ID 12205 //
     /* 487978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 487981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 487985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 487989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 487993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 487997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 488009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 488025 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488030 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488030 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488062 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 488065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488106 */     GIR_RootConstrainSelectedInstOperands,
     /* 488107 */     // GIR_Coverage, 12205,
     /* 488107 */     GIR_EraseRootFromParent_Done,
     /* 488108 */   // Label 6732: @488108
     /* 488108 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(488243), // Rule ID 12681 //
     /* 488113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 488144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 488160 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488165 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488197 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488241 */     GIR_RootConstrainSelectedInstOperands,
     /* 488242 */     // GIR_Coverage, 12681,
     /* 488242 */     GIR_EraseRootFromParent_Done,
     /* 488243 */   // Label 6733: @488243
     /* 488243 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(488378), // Rule ID 12684 //
     /* 488248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 488279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 488295 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488300 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488305 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488318 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488325 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488332 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488376 */     GIR_RootConstrainSelectedInstOperands,
     /* 488377 */     // GIR_Coverage, 12684,
     /* 488377 */     GIR_EraseRootFromParent_Done,
     /* 488378 */   // Label 6734: @488378
     /* 488378 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(488513), // Rule ID 12685 //
     /* 488383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 488386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 488390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 488414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 488430 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488435 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488435 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488440 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488444 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488467 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 488470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488511 */     GIR_RootConstrainSelectedInstOperands,
     /* 488512 */     // GIR_Coverage, 12685,
     /* 488512 */     GIR_EraseRootFromParent_Done,
     /* 488513 */   // Label 6735: @488513
     /* 488513 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(488648), // Rule ID 13161 //
     /* 488518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 488521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 488549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 488565 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488570 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488602 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 488605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 488612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 488617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 488622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 488627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488646 */     GIR_RootConstrainSelectedInstOperands,
     /* 488647 */     // GIR_Coverage, 13161,
     /* 488647 */     GIR_EraseRootFromParent_Done,
     /* 488648 */   // Label 6736: @488648
     /* 488648 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(488783), // Rule ID 13164 //
     /* 488653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 488656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 488684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 488700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488705 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488710 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488737 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 488740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488781 */     GIR_RootConstrainSelectedInstOperands,
     /* 488782 */     // GIR_Coverage, 13164,
     /* 488782 */     GIR_EraseRootFromParent_Done,
     /* 488783 */   // Label 6737: @488783
     /* 488783 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(488918), // Rule ID 13165 //
     /* 488788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 488791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 488819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 488831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 488835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488872 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 488872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 488875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 488877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 488882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 488887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 488892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 488897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 488902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 488907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 488916 */     GIR_RootConstrainSelectedInstOperands,
     /* 488917 */     // GIR_Coverage, 13165,
     /* 488917 */     GIR_EraseRootFromParent_Done,
     /* 488918 */   // Label 6738: @488918
     /* 488918 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(489053), // Rule ID 12187 //
     /* 488923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 488926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 488930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 488934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 488942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 488946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 488950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 488954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 488958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 488962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 488966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 488970 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 488970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 488975 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 488975 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 488980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 488984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 488986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 488993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489007 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489051 */     GIR_RootConstrainSelectedInstOperands,
     /* 489052 */     // GIR_Coverage, 12187,
     /* 489052 */     GIR_EraseRootFromParent_Done,
     /* 489053 */   // Label 6739: @489053
     /* 489053 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(489188), // Rule ID 12188 //
     /* 489058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 489061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 489101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489105 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489105 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489110 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489110 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489115 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489142 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489186 */     GIR_RootConstrainSelectedInstOperands,
     /* 489187 */     // GIR_Coverage, 12188,
     /* 489187 */     GIR_EraseRootFromParent_Done,
     /* 489188 */   // Label 6740: @489188
     /* 489188 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(489323), // Rule ID 12191 //
     /* 489193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 489196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 489236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489240 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489245 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489277 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489321 */     GIR_RootConstrainSelectedInstOperands,
     /* 489322 */     // GIR_Coverage, 12191,
     /* 489322 */     GIR_EraseRootFromParent_Done,
     /* 489323 */   // Label 6741: @489323
     /* 489323 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(489458), // Rule ID 12192 //
     /* 489328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 489331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 489335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 489371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489375 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489380 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489385 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489405 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489412 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 489415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489456 */     GIR_RootConstrainSelectedInstOperands,
     /* 489457 */     // GIR_Coverage, 12192,
     /* 489457 */     GIR_EraseRootFromParent_Done,
     /* 489458 */   // Label 6742: @489458
     /* 489458 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(489593), // Rule ID 12667 //
     /* 489463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 489466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 489470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 489506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489547 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489591 */     GIR_RootConstrainSelectedInstOperands,
     /* 489592 */     // GIR_Coverage, 12667,
     /* 489592 */     GIR_EraseRootFromParent_Done,
     /* 489593 */   // Label 6743: @489593
     /* 489593 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(489728), // Rule ID 12668 //
     /* 489598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 489601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 489605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 489641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489682 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 489692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 489697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 489702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 489707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489726 */     GIR_RootConstrainSelectedInstOperands,
     /* 489727 */     // GIR_Coverage, 12668,
     /* 489727 */     GIR_EraseRootFromParent_Done,
     /* 489728 */   // Label 6744: @489728
     /* 489728 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(489863), // Rule ID 12671 //
     /* 489733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 489736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 489740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 489776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489785 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489790 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489810 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489817 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489861 */     GIR_RootConstrainSelectedInstOperands,
     /* 489862 */     // GIR_Coverage, 12671,
     /* 489862 */     GIR_EraseRootFromParent_Done,
     /* 489863 */   // Label 6745: @489863
     /* 489863 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(489998), // Rule ID 12672 //
     /* 489868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 489871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 489875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 489879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 489887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 489891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 489895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 489899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 489903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 489907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 489911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 489915 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 489915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 489920 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 489920 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 489925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 489929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 489931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489938 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 489952 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 489952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 489955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 489957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 489962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 489967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 489972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 489977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 489982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 489987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 489996 */     GIR_RootConstrainSelectedInstOperands,
     /* 489997 */     // GIR_Coverage, 12672,
     /* 489997 */     GIR_EraseRootFromParent_Done,
     /* 489998 */   // Label 6746: @489998
     /* 489998 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(490133), // Rule ID 13147 //
     /* 490003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 490050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490055 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490060 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490073 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490087 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490131 */     GIR_RootConstrainSelectedInstOperands,
     /* 490132 */     // GIR_Coverage, 13147,
     /* 490132 */     GIR_EraseRootFromParent_Done,
     /* 490133 */   // Label 6747: @490133
     /* 490133 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(490268), // Rule ID 13148 //
     /* 490138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 490185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490190 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490222 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490266 */     GIR_RootConstrainSelectedInstOperands,
     /* 490267 */     // GIR_Coverage, 13148,
     /* 490267 */     GIR_EraseRootFromParent_Done,
     /* 490268 */   // Label 6748: @490268
     /* 490268 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(490403), // Rule ID 13151 //
     /* 490273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 490320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490325 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490334 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490357 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490401 */     GIR_RootConstrainSelectedInstOperands,
     /* 490402 */     // GIR_Coverage, 13151,
     /* 490402 */     GIR_EraseRootFromParent_Done,
     /* 490403 */   // Label 6749: @490403
     /* 490403 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(490538), // Rule ID 13152 //
     /* 490408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 490411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 490455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490460 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490492 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 490495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490536 */     GIR_RootConstrainSelectedInstOperands,
     /* 490537 */     // GIR_Coverage, 13152,
     /* 490537 */     GIR_EraseRootFromParent_Done,
     /* 490538 */   // Label 6750: @490538
     /* 490538 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(490673), // Rule ID 12172 //
     /* 490543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490595 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490627 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 490630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490671 */     GIR_RootConstrainSelectedInstOperands,
     /* 490672 */     // GIR_Coverage, 12172,
     /* 490672 */     GIR_EraseRootFromParent_Done,
     /* 490673 */   // Label 6751: @490673
     /* 490673 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(490808), // Rule ID 12173 //
     /* 490678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490730 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490730 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490735 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490748 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490762 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 490765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 490772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 490777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 490782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 490787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490806 */     GIR_RootConstrainSelectedInstOperands,
     /* 490807 */     // GIR_Coverage, 12173,
     /* 490807 */     GIR_EraseRootFromParent_Done,
     /* 490808 */   // Label 6752: @490808
     /* 490808 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(490943), // Rule ID 12176 //
     /* 490813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 490860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 490865 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 490870 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 490874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 490876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 490897 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 490897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 490900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 490902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 490907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 490912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 490917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 490922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 490927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 490932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 490941 */     GIR_RootConstrainSelectedInstOperands,
     /* 490942 */     // GIR_Coverage, 12176,
     /* 490942 */     GIR_EraseRootFromParent_Done,
     /* 490943 */   // Label 6753: @490943
     /* 490943 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(491078), // Rule ID 12177 //
     /* 490948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 490951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 490955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 490959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 490967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 490971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 490975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 490979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 490983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 490987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 490991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 490995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 490995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491032 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 491035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 491052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 491057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491076 */     GIR_RootConstrainSelectedInstOperands,
     /* 491077 */     // GIR_Coverage, 12177,
     /* 491077 */     GIR_EraseRootFromParent_Done,
     /* 491078 */   // Label 6754: @491078
     /* 491078 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(491213), // Rule ID 12652 //
     /* 491083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 491126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491167 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 491177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 491182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491211 */     GIR_RootConstrainSelectedInstOperands,
     /* 491212 */     // GIR_Coverage, 12652,
     /* 491212 */     GIR_EraseRootFromParent_Done,
     /* 491213 */   // Label 6755: @491213
     /* 491213 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(491348), // Rule ID 12653 //
     /* 491218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 491261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491270 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491295 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491302 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 491312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 491317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491346 */     GIR_RootConstrainSelectedInstOperands,
     /* 491347 */     // GIR_Coverage, 12653,
     /* 491347 */     GIR_EraseRootFromParent_Done,
     /* 491348 */   // Label 6756: @491348
     /* 491348 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(491483), // Rule ID 12656 //
     /* 491353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 491396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491405 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491405 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491437 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 491457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 491462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491481 */     GIR_RootConstrainSelectedInstOperands,
     /* 491482 */     // GIR_Coverage, 12656,
     /* 491482 */     GIR_EraseRootFromParent_Done,
     /* 491483 */   // Label 6757: @491483
     /* 491483 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(491618), // Rule ID 12657 //
     /* 491488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 491491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 491495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 491531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491540 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491572 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 491575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 491592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 491597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491616 */     GIR_RootConstrainSelectedInstOperands,
     /* 491617 */     // GIR_Coverage, 12657,
     /* 491617 */     GIR_EraseRootFromParent_Done,
     /* 491618 */   // Label 6758: @491618
     /* 491618 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(491753), // Rule ID 13132 //
     /* 491623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 491626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 491666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491675 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491700 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491707 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 491710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 491717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 491722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491751 */     GIR_RootConstrainSelectedInstOperands,
     /* 491752 */     // GIR_Coverage, 13132,
     /* 491752 */     GIR_EraseRootFromParent_Done,
     /* 491753 */   // Label 6759: @491753
     /* 491753 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(491888), // Rule ID 13133 //
     /* 491758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 491761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 491801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491828 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491842 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 491845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 491852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 491857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 491862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 491867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 491872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 491877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 491886 */     GIR_RootConstrainSelectedInstOperands,
     /* 491887 */     // GIR_Coverage, 13133,
     /* 491887 */     GIR_EraseRootFromParent_Done,
     /* 491888 */   // Label 6760: @491888
     /* 491888 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(492023), // Rule ID 13136 //
     /* 491893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 491896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 491900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 491904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 491912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 491916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 491920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 491924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 491928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 491932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 491936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 491940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 491940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 491945 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 491945 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 491950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 491954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 491956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491970 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 491977 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 491977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 491980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 491982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 491987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 491992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 491997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 492002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492021 */     GIR_RootConstrainSelectedInstOperands,
     /* 492022 */     // GIR_Coverage, 13136,
     /* 492022 */     GIR_EraseRootFromParent_Done,
     /* 492023 */   // Label 6761: @492023
     /* 492023 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(492158), // Rule ID 13137 //
     /* 492028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 492055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 492071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 492075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 492080 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 492085 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492098 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492112 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 492132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 492137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492156 */     GIR_RootConstrainSelectedInstOperands,
     /* 492157 */     // GIR_Coverage, 13137,
     /* 492157 */     GIR_EraseRootFromParent_Done,
     /* 492158 */   // Label 6762: @492158
     /* 492158 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(492293), // Rule ID 7766 //
     /* 492163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 492190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 492206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 492215 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492215 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 492220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492247 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 492257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 492262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492291 */     GIR_RootConstrainSelectedInstOperands,
     /* 492292 */     // GIR_Coverage, 7766,
     /* 492292 */     GIR_EraseRootFromParent_Done,
     /* 492293 */   // Label 6763: @492293
     /* 492293 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(492428), // Rule ID 7798 //
     /* 492298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 492301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 492305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 492325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 492341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492345 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 492350 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 492355 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492382 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 492385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 492392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 492397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492426 */     GIR_RootConstrainSelectedInstOperands,
     /* 492427 */     // GIR_Coverage, 7798,
     /* 492427 */     GIR_EraseRootFromParent_Done,
     /* 492428 */   // Label 6764: @492428
     /* 492428 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(492563), // Rule ID 7830 //
     /* 492433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 492436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 492460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 492476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 492485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 492490 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492517 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 492520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 492527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 492532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492561 */     GIR_RootConstrainSelectedInstOperands,
     /* 492562 */     // GIR_Coverage, 7830,
     /* 492562 */     GIR_EraseRootFromParent_Done,
     /* 492563 */   // Label 6765: @492563
     /* 492563 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(492698), // Rule ID 12186 //
     /* 492568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 492595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 492611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492615 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 492620 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 492625 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492638 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492645 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492652 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 492662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 492667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 492672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 492677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492696 */     GIR_RootConstrainSelectedInstOperands,
     /* 492697 */     // GIR_Coverage, 12186,
     /* 492697 */     GIR_EraseRootFromParent_Done,
     /* 492698 */   // Label 6766: @492698
     /* 492698 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(492833), // Rule ID 12189 //
     /* 492703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 492730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 492746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492750 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 492755 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 492760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492780 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492787 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 492807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 492812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492831 */     GIR_RootConstrainSelectedInstOperands,
     /* 492832 */     // GIR_Coverage, 12189,
     /* 492832 */     GIR_EraseRootFromParent_Done,
     /* 492833 */   // Label 6767: @492833
     /* 492833 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(492968), // Rule ID 12190 //
     /* 492838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 492841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 492845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 492865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 492873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 492877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 492881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 492885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 492885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 492890 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 492890 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 492895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 492899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 492901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492908 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 492922 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 492922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 492925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 492927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 492932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 492937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 492942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 492947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 492952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 492957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 492966 */     GIR_RootConstrainSelectedInstOperands,
     /* 492967 */     // GIR_Coverage, 12190,
     /* 492967 */     GIR_EraseRootFromParent_Done,
     /* 492968 */   // Label 6768: @492968
     /* 492968 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(493103), // Rule ID 12666 //
     /* 492973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 492976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 492980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 492984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 492988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 492992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 492996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493020 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493025 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493025 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493057 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 493067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 493072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 493087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 493092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493101 */     GIR_RootConstrainSelectedInstOperands,
     /* 493102 */     // GIR_Coverage, 12666,
     /* 493102 */     GIR_EraseRootFromParent_Done,
     /* 493103 */   // Label 6769: @493103
     /* 493103 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(493238), // Rule ID 12669 //
     /* 493108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493155 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493160 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493192 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 493212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 493217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 493222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 493227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493236 */     GIR_RootConstrainSelectedInstOperands,
     /* 493237 */     // GIR_Coverage, 12669,
     /* 493237 */     GIR_EraseRootFromParent_Done,
     /* 493238 */   // Label 6770: @493238
     /* 493238 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(493373), // Rule ID 12670 //
     /* 493243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493290 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493295 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493327 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 493330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 493347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 493352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 493357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 493362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493371 */     GIR_RootConstrainSelectedInstOperands,
     /* 493372 */     // GIR_Coverage, 12670,
     /* 493372 */     GIR_EraseRootFromParent_Done,
     /* 493373 */   // Label 6771: @493373
     /* 493373 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(493508), // Rule ID 13146 //
     /* 493378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 493381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493425 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493430 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493455 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493462 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 493465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 493472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 493477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 493492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 493497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493506 */     GIR_RootConstrainSelectedInstOperands,
     /* 493507 */     // GIR_Coverage, 13146,
     /* 493507 */     GIR_EraseRootFromParent_Done,
     /* 493508 */   // Label 6772: @493508
     /* 493508 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(493643), // Rule ID 13149 //
     /* 493513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 493516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493560 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493565 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493597 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 493600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 493617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 493622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 493627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 493632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493641 */     GIR_RootConstrainSelectedInstOperands,
     /* 493642 */     // GIR_Coverage, 13149,
     /* 493642 */     GIR_EraseRootFromParent_Done,
     /* 493643 */   // Label 6773: @493643
     /* 493643 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(493778), // Rule ID 13150 //
     /* 493648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 493651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 493695 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493700 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493725 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493732 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 493735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 493742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 493747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 493752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 493757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 493762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 493767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493776 */     GIR_RootConstrainSelectedInstOperands,
     /* 493777 */     // GIR_Coverage, 13150,
     /* 493777 */     GIR_EraseRootFromParent_Done,
     /* 493778 */   // Label 6774: @493778
     /* 493778 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(493913), // Rule ID 7765 //
     /* 493783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 493786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 493790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 493830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493835 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493867 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 493867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 493870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 493872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 493877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 493882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 493887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 493892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 493897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 493902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 493911 */     GIR_RootConstrainSelectedInstOperands,
     /* 493912 */     // GIR_Coverage, 7765,
     /* 493912 */     GIR_EraseRootFromParent_Done,
     /* 493913 */   // Label 6775: @493913
     /* 493913 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(494048), // Rule ID 7797 //
     /* 493918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 493921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 493925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 493929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 493937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 493941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 493945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 493949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 493953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 493957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 493961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 493965 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 493965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 493970 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 493970 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 493975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 493979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 493981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 493995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494002 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 494005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 494012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 494017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494046 */     GIR_RootConstrainSelectedInstOperands,
     /* 494047 */     // GIR_Coverage, 7797,
     /* 494047 */     GIR_EraseRootFromParent_Done,
     /* 494048 */   // Label 6776: @494048
     /* 494048 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(494183), // Rule ID 7829 //
     /* 494053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 494056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 494080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 494096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494100 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 494105 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494105 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 494110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494130 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494137 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 494140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 494147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 494152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494181 */     GIR_RootConstrainSelectedInstOperands,
     /* 494182 */     // GIR_Coverage, 7829,
     /* 494182 */     GIR_EraseRootFromParent_Done,
     /* 494183 */   // Label 6777: @494183
     /* 494183 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(494318), // Rule ID 12171 //
     /* 494188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 494215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 494231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494235 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 494240 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 494245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494272 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 494282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 494287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494316 */     GIR_RootConstrainSelectedInstOperands,
     /* 494317 */     // GIR_Coverage, 12171,
     /* 494317 */     GIR_EraseRootFromParent_Done,
     /* 494318 */   // Label 6778: @494318
     /* 494318 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(494453), // Rule ID 12174 //
     /* 494323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 494350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 494366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494370 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 494375 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 494380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494407 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 494427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 494432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494451 */     GIR_RootConstrainSelectedInstOperands,
     /* 494452 */     // GIR_Coverage, 12174,
     /* 494452 */     GIR_EraseRootFromParent_Done,
     /* 494453 */   // Label 6779: @494453
     /* 494453 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(494588), // Rule ID 12175 //
     /* 494458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 494461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 494465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 494485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 494501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 494510 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 494515 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494542 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 494545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 494562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 494567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494586 */     GIR_RootConstrainSelectedInstOperands,
     /* 494587 */     // GIR_Coverage, 12175,
     /* 494587 */     GIR_EraseRootFromParent_Done,
     /* 494588 */   // Label 6780: @494588
     /* 494588 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(494723), // Rule ID 12651 //
     /* 494593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 494596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 494600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 494620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 494636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494640 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 494645 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 494650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494677 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 494680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 494687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 494692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 494697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 494702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494721 */     GIR_RootConstrainSelectedInstOperands,
     /* 494722 */     // GIR_Coverage, 12651,
     /* 494722 */     GIR_EraseRootFromParent_Done,
     /* 494723 */   // Label 6781: @494723
     /* 494723 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(494858), // Rule ID 12654 //
     /* 494728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 494731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 494735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 494755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 494771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494775 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 494780 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 494785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494812 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 494815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 494832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 494837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494856 */     GIR_RootConstrainSelectedInstOperands,
     /* 494857 */     // GIR_Coverage, 12654,
     /* 494857 */     GIR_EraseRootFromParent_Done,
     /* 494858 */   // Label 6782: @494858
     /* 494858 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(494993), // Rule ID 12655 //
     /* 494863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 494866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 494870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 494874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 494882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 494886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 494890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 494894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 494898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 494902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 494906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 494910 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 494910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 494915 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 494915 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 494920 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 494924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 494926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 494947 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 494947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 494950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 494952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 494957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 494962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 494967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 494972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 494977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 494982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 494991 */     GIR_RootConstrainSelectedInstOperands,
     /* 494992 */     // GIR_Coverage, 12655,
     /* 494992 */     GIR_EraseRootFromParent_Done,
     /* 494993 */   // Label 6783: @494993
     /* 494993 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(495128), // Rule ID 13131 //
     /* 494998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 495025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 495041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495045 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 495050 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495050 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 495055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495082 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 495092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 495097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 495112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 495117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495126 */     GIR_RootConstrainSelectedInstOperands,
     /* 495127 */     // GIR_Coverage, 13131,
     /* 495127 */     GIR_EraseRootFromParent_Done,
     /* 495128 */   // Label 6784: @495128
     /* 495128 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(495263), // Rule ID 13134 //
     /* 495133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 495160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 495176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495180 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 495185 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 495190 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495217 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 495237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 495242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 495247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 495252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495261 */     GIR_RootConstrainSelectedInstOperands,
     /* 495262 */     // GIR_Coverage, 13134,
     /* 495262 */     GIR_EraseRootFromParent_Done,
     /* 495263 */   // Label 6785: @495263
     /* 495263 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(495398), // Rule ID 13135 //
     /* 495268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 495271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 495295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 495311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 495315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 495320 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 495325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495331 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495352 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 495355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 495372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 495377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 495382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 495387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495396 */     GIR_RootConstrainSelectedInstOperands,
     /* 495397 */     // GIR_Coverage, 13135,
     /* 495397 */     GIR_EraseRootFromParent_Done,
     /* 495398 */   // Label 6786: @495398
     /* 495398 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(495533), // Rule ID 12257 //
     /* 495403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 495406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 495434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495487 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 495490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495531 */     GIR_RootConstrainSelectedInstOperands,
     /* 495532 */     // GIR_Coverage, 12257,
     /* 495532 */     GIR_EraseRootFromParent_Done,
     /* 495533 */   // Label 6787: @495533
     /* 495533 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(495668), // Rule ID 12258 //
     /* 495538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 495541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 495569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495590 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495595 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495608 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495622 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 495625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 495632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 495637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 495642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 495647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495666 */     GIR_RootConstrainSelectedInstOperands,
     /* 495667 */     // GIR_Coverage, 12258,
     /* 495667 */     GIR_EraseRootFromParent_Done,
     /* 495668 */   // Label 6788: @495668
     /* 495668 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(495803), // Rule ID 12259 //
     /* 495673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 495676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 495704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495720 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495725 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495725 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495730 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495757 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 495760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495801 */     GIR_RootConstrainSelectedInstOperands,
     /* 495802 */     // GIR_Coverage, 12259,
     /* 495802 */     GIR_EraseRootFromParent_Done,
     /* 495803 */   // Label 6789: @495803
     /* 495803 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(495938), // Rule ID 12260 //
     /* 495808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 495811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 495815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 495839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495860 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 495865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 495869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 495871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 495892 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 495892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 495895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 495897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 495902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 495907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 495912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 495917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 495922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 495927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 495936 */     GIR_RootConstrainSelectedInstOperands,
     /* 495937 */     // GIR_Coverage, 12260,
     /* 495937 */     GIR_EraseRootFromParent_Done,
     /* 495938 */   // Label 6790: @495938
     /* 495938 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(496073), // Rule ID 12737 //
     /* 495943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 495946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 495950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 495954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 495958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 495962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 495966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 495970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 495974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 495978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 495982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 495986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 495990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 495990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 495995 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 495995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496006 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496027 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496071 */     GIR_RootConstrainSelectedInstOperands,
     /* 496072 */     // GIR_Coverage, 12737,
     /* 496072 */     GIR_EraseRootFromParent_Done,
     /* 496073 */   // Label 6791: @496073
     /* 496073 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(496208), // Rule ID 12738 //
     /* 496078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 496109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496162 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496206 */     GIR_RootConstrainSelectedInstOperands,
     /* 496207 */     // GIR_Coverage, 12738,
     /* 496207 */     GIR_EraseRootFromParent_Done,
     /* 496208 */   // Label 6792: @496208
     /* 496208 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(496343), // Rule ID 12739 //
     /* 496213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 496244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496297 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496341 */     GIR_RootConstrainSelectedInstOperands,
     /* 496342 */     // GIR_Coverage, 12739,
     /* 496342 */     GIR_EraseRootFromParent_Done,
     /* 496343 */   // Label 6793: @496343
     /* 496343 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(496478), // Rule ID 12740 //
     /* 496348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 496351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 496355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 496379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496400 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496405 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496425 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496432 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 496435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496476 */     GIR_RootConstrainSelectedInstOperands,
     /* 496477 */     // GIR_Coverage, 12740,
     /* 496477 */     GIR_EraseRootFromParent_Done,
     /* 496478 */   // Label 6794: @496478
     /* 496478 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(496613), // Rule ID 13217 //
     /* 496483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 496486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 496514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496522 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496526 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496535 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496540 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496546 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496567 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 496570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496611 */     GIR_RootConstrainSelectedInstOperands,
     /* 496612 */     // GIR_Coverage, 13217,
     /* 496612 */     GIR_EraseRootFromParent_Done,
     /* 496613 */   // Label 6795: @496613
     /* 496613 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(496748), // Rule ID 13218 //
     /* 496618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 496621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 496649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496670 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496688 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496702 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 496705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 496712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 496717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 496722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 496727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496746 */     GIR_RootConstrainSelectedInstOperands,
     /* 496747 */     // GIR_Coverage, 13218,
     /* 496747 */     GIR_EraseRootFromParent_Done,
     /* 496748 */   // Label 6796: @496748
     /* 496748 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(496883), // Rule ID 13219 //
     /* 496753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 496756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 496784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496837 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 496840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 496867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 496872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 496881 */     GIR_RootConstrainSelectedInstOperands,
     /* 496882 */     // GIR_Coverage, 13219,
     /* 496882 */     GIR_EraseRootFromParent_Done,
     /* 496883 */   // Label 6797: @496883
     /* 496883 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(497018), // Rule ID 13220 //
     /* 496888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 496891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 496895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 496899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 496903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 496907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 496911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 496915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 496919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 496923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 496927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 496931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 496935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 496935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 496940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 496940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 496945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 496949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 496951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 496972 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 496972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 496975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 496977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 496982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 496987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 496992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 496997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497016 */     GIR_RootConstrainSelectedInstOperands,
     /* 497017 */     // GIR_Coverage, 13220,
     /* 497017 */     GIR_EraseRootFromParent_Done,
     /* 497018 */   // Label 6798: @497018
     /* 497018 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(497153), // Rule ID 12197 //
     /* 497023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497075 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497080 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497107 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497151 */     GIR_RootConstrainSelectedInstOperands,
     /* 497152 */     // GIR_Coverage, 12197,
     /* 497152 */     GIR_EraseRootFromParent_Done,
     /* 497153 */   // Label 6799: @497153
     /* 497153 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(497288), // Rule ID 12198 //
     /* 497158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497210 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497215 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497242 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497286 */     GIR_RootConstrainSelectedInstOperands,
     /* 497287 */     // GIR_Coverage, 12198,
     /* 497287 */     GIR_EraseRootFromParent_Done,
     /* 497288 */   // Label 6800: @497288
     /* 497288 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(497423), // Rule ID 12199 //
     /* 497293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497345 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497377 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497421 */     GIR_RootConstrainSelectedInstOperands,
     /* 497422 */     // GIR_Coverage, 12199,
     /* 497422 */     GIR_EraseRootFromParent_Done,
     /* 497423 */   // Label 6801: @497423
     /* 497423 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(497558), // Rule ID 12200 //
     /* 497428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 497431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 497435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497480 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497485 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497512 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 497515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497556 */     GIR_RootConstrainSelectedInstOperands,
     /* 497557 */     // GIR_Coverage, 12200,
     /* 497557 */     GIR_EraseRootFromParent_Done,
     /* 497558 */   // Label 6802: @497558
     /* 497558 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(497693), // Rule ID 12677 //
     /* 497563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 497566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 497570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497615 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497647 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 497650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497691 */     GIR_RootConstrainSelectedInstOperands,
     /* 497692 */     // GIR_Coverage, 12677,
     /* 497692 */     GIR_EraseRootFromParent_Done,
     /* 497693 */   // Label 6803: @497693
     /* 497693 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(497828), // Rule ID 12678 //
     /* 497698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 497701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 497705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497750 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497755 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497775 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497782 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 497785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 497792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 497797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 497802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 497807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497826 */     GIR_RootConstrainSelectedInstOperands,
     /* 497827 */     // GIR_Coverage, 12678,
     /* 497827 */     GIR_EraseRootFromParent_Done,
     /* 497828 */   // Label 6804: @497828
     /* 497828 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(497963), // Rule ID 12679 //
     /* 497833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 497836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 497840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 497868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 497872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 497876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 497880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 497885 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 497885 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 497890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 497894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 497896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497903 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497910 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 497917 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 497917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 497920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 497922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 497927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 497932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 497937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 497942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 497947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 497952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 497961 */     GIR_RootConstrainSelectedInstOperands,
     /* 497962 */     // GIR_Coverage, 12679,
     /* 497962 */     GIR_EraseRootFromParent_Done,
     /* 497963 */   // Label 6805: @497963
     /* 497963 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(498098), // Rule ID 12680 //
     /* 497968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 497971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 497975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 497979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 497983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 497987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 497991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 497995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 497999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498020 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498025 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498038 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498052 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 498055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 498062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 498067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 498082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 498087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498096 */     GIR_RootConstrainSelectedInstOperands,
     /* 498097 */     // GIR_Coverage, 12680,
     /* 498097 */     GIR_EraseRootFromParent_Done,
     /* 498098 */   // Label 6806: @498098
     /* 498098 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(498233), // Rule ID 13157 //
     /* 498103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 498130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498155 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498160 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498187 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 498207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 498212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 498217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 498222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498231 */     GIR_RootConstrainSelectedInstOperands,
     /* 498232 */     // GIR_Coverage, 13157,
     /* 498232 */     GIR_EraseRootFromParent_Done,
     /* 498233 */   // Label 6807: @498233
     /* 498233 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(498368), // Rule ID 13158 //
     /* 498238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 498265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498322 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 498342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 498347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 498352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 498357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498366 */     GIR_RootConstrainSelectedInstOperands,
     /* 498367 */     // GIR_Coverage, 13158,
     /* 498367 */     GIR_EraseRootFromParent_Done,
     /* 498368 */   // Label 6808: @498368
     /* 498368 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(498503), // Rule ID 13159 //
     /* 498373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 498400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498425 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498457 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 498467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 498472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 498487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 498492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498501 */     GIR_RootConstrainSelectedInstOperands,
     /* 498502 */     // GIR_Coverage, 13159,
     /* 498502 */     GIR_EraseRootFromParent_Done,
     /* 498503 */   // Label 6809: @498503
     /* 498503 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(498638), // Rule ID 13160 //
     /* 498508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 498511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 498535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 498539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498560 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498560 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498565 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498592 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 498595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 498602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 498607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 498612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 498617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 498622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 498627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498636 */     GIR_RootConstrainSelectedInstOperands,
     /* 498637 */     // GIR_Coverage, 13160,
     /* 498637 */     GIR_EraseRootFromParent_Done,
     /* 498638 */   // Label 6810: @498638
     /* 498638 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(498773), // Rule ID 12242 //
     /* 498643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 498646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 498670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 498674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498690 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498695 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498727 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 498730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 498747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 498752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 498757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 498762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498771 */     GIR_RootConstrainSelectedInstOperands,
     /* 498772 */     // GIR_Coverage, 12242,
     /* 498772 */     GIR_EraseRootFromParent_Done,
     /* 498773 */   // Label 6811: @498773
     /* 498773 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(498908), // Rule ID 12243 //
     /* 498778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 498781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 498805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 498809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498825 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498830 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498835 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498848 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498862 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 498865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 498867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 498872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 498877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 498882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 498887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 498892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 498897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 498906 */     GIR_RootConstrainSelectedInstOperands,
     /* 498907 */     // GIR_Coverage, 12243,
     /* 498907 */     GIR_EraseRootFromParent_Done,
     /* 498908 */   // Label 6812: @498908
     /* 498908 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(499043), // Rule ID 12244 //
     /* 498913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 498916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 498920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 498924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 498928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 498932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 498936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 498940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 498944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 498948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 498952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 498956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 498960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 498960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 498965 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 498965 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 498970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 498974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 498976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498983 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 498997 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 498997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 499007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 499012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499041 */     GIR_RootConstrainSelectedInstOperands,
     /* 499042 */     // GIR_Coverage, 12244,
     /* 499042 */     GIR_EraseRootFromParent_Done,
     /* 499043 */   // Label 6813: @499043
     /* 499043 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(499178), // Rule ID 12245 //
     /* 499048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 499051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 499075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 499079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499100 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499132 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 499135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 499142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 499147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499176 */     GIR_RootConstrainSelectedInstOperands,
     /* 499177 */     // GIR_Coverage, 12245,
     /* 499177 */     GIR_EraseRootFromParent_Done,
     /* 499178 */   // Label 6814: @499178
     /* 499178 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(499313), // Rule ID 12722 //
     /* 499183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 499210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 499214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499235 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499240 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499253 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499267 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 499270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 499287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 499292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499311 */     GIR_RootConstrainSelectedInstOperands,
     /* 499312 */     // GIR_Coverage, 12722,
     /* 499312 */     GIR_EraseRootFromParent_Done,
     /* 499313 */   // Label 6815: @499313
     /* 499313 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(499448), // Rule ID 12723 //
     /* 499318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 499345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 499349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499365 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499370 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499370 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499395 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499402 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 499405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 499422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 499427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499446 */     GIR_RootConstrainSelectedInstOperands,
     /* 499447 */     // GIR_Coverage, 12723,
     /* 499447 */     GIR_EraseRootFromParent_Done,
     /* 499448 */   // Label 6816: @499448
     /* 499448 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(499583), // Rule ID 12724 //
     /* 499453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 499480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 499484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499505 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499510 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499537 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 499540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 499547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 499552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499581 */     GIR_RootConstrainSelectedInstOperands,
     /* 499582 */     // GIR_Coverage, 12724,
     /* 499582 */     GIR_EraseRootFromParent_Done,
     /* 499583 */   // Label 6817: @499583
     /* 499583 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(499718), // Rule ID 12725 //
     /* 499588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 499591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 499595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 499615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 499619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499640 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499672 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 499675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 499682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 499687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 499692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 499697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499716 */     GIR_RootConstrainSelectedInstOperands,
     /* 499717 */     // GIR_Coverage, 12725,
     /* 499717 */     GIR_EraseRootFromParent_Done,
     /* 499718 */   // Label 6818: @499718
     /* 499718 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(499853), // Rule ID 13202 //
     /* 499723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 499726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 499750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 499754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499807 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 499810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 499827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 499832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499851 */     GIR_RootConstrainSelectedInstOperands,
     /* 499852 */     // GIR_Coverage, 13202,
     /* 499852 */     GIR_EraseRootFromParent_Done,
     /* 499853 */   // Label 6819: @499853
     /* 499853 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(499988), // Rule ID 13203 //
     /* 499858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 499861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 499865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 499869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 499873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 499877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 499881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 499885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 499889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 499893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 499897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 499901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 499905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 499905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 499910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 499910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 499915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 499919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 499921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 499942 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 499942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 499945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 499947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 499952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 499957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 499962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 499967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 499972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 499977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 499986 */     GIR_RootConstrainSelectedInstOperands,
     /* 499987 */     // GIR_Coverage, 13203,
     /* 499987 */     GIR_EraseRootFromParent_Done,
     /* 499988 */   // Label 6820: @499988
     /* 499988 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(500123), // Rule ID 13204 //
     /* 499993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 499996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 500040 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500045 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500045 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500070 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500077 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 500087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 500092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 500107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 500112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500121 */     GIR_RootConstrainSelectedInstOperands,
     /* 500122 */     // GIR_Coverage, 13204,
     /* 500122 */     GIR_EraseRootFromParent_Done,
     /* 500123 */   // Label 6821: @500123
     /* 500123 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(500258), // Rule ID 13205 //
     /* 500128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 500131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 500175 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500180 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500198 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500212 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 500215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 500222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 500227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 500242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 500247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500256 */     GIR_RootConstrainSelectedInstOperands,
     /* 500257 */     // GIR_Coverage, 13205,
     /* 500257 */     GIR_EraseRootFromParent_Done,
     /* 500258 */   // Label 6822: @500258
     /* 500258 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(500393), // Rule ID 12182 //
     /* 500263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500315 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500320 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500347 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 500350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 500367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 500372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 500377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 500382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500391 */     GIR_RootConstrainSelectedInstOperands,
     /* 500392 */     // GIR_Coverage, 12182,
     /* 500392 */     GIR_EraseRootFromParent_Done,
     /* 500393 */   // Label 6823: @500393
     /* 500393 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(500528), // Rule ID 12183 //
     /* 500398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500482 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 500485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 500502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 500507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 500512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 500517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500526 */     GIR_RootConstrainSelectedInstOperands,
     /* 500527 */     // GIR_Coverage, 12183,
     /* 500527 */     GIR_EraseRootFromParent_Done,
     /* 500528 */   // Label 6824: @500528
     /* 500528 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(500663), // Rule ID 12184 //
     /* 500533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500603 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500617 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 500620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 500627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 500632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 500647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 500652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500661 */     GIR_RootConstrainSelectedInstOperands,
     /* 500662 */     // GIR_Coverage, 12184,
     /* 500662 */     GIR_EraseRootFromParent_Done,
     /* 500663 */   // Label 6825: @500663
     /* 500663 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(500798), // Rule ID 12185 //
     /* 500668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 500671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 500675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500720 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500752 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 500755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 500762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 500767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 500772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 500777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 500782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 500787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500796 */     GIR_RootConstrainSelectedInstOperands,
     /* 500797 */     // GIR_Coverage, 12185,
     /* 500797 */     GIR_EraseRootFromParent_Done,
     /* 500798 */   // Label 6826: @500798
     /* 500798 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(500933), // Rule ID 12662 //
     /* 500803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 500806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 500810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500850 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500855 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500860 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 500866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 500887 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 500887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 500890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 500892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 500897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 500902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 500907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 500912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 500917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 500922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 500931 */     GIR_RootConstrainSelectedInstOperands,
     /* 500932 */     // GIR_Coverage, 12662,
     /* 500932 */     GIR_EraseRootFromParent_Done,
     /* 500933 */   // Label 6827: @500933
     /* 500933 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(501068), // Rule ID 12663 //
     /* 500938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 500941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 500945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 500949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 500957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 500961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 500965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 500969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 500973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 500977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 500981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 500985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 500985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 500990 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 500990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 500995 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 500999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501022 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 501042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 501047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 501052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 501057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501066 */     GIR_RootConstrainSelectedInstOperands,
     /* 501067 */     // GIR_Coverage, 12663,
     /* 501067 */     GIR_EraseRootFromParent_Done,
     /* 501068 */   // Label 6828: @501068
     /* 501068 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(501203), // Rule ID 12664 //
     /* 501073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 501100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501125 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501130 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501143 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501157 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 501167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 501172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 501187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 501192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501201 */     GIR_RootConstrainSelectedInstOperands,
     /* 501202 */     // GIR_Coverage, 12664,
     /* 501202 */     GIR_EraseRootFromParent_Done,
     /* 501203 */   // Label 6829: @501203
     /* 501203 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(501338), // Rule ID 12665 //
     /* 501208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 501211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 501215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 501235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501292 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 501295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 501302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 501307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 501322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 501327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501336 */     GIR_RootConstrainSelectedInstOperands,
     /* 501337 */     // GIR_Coverage, 12665,
     /* 501337 */     GIR_EraseRootFromParent_Done,
     /* 501338 */   // Label 6830: @501338
     /* 501338 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(501473), // Rule ID 13142 //
     /* 501343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 501346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 501370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501395 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501395 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501427 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 501430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 501447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 501452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 501457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 501462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501471 */     GIR_RootConstrainSelectedInstOperands,
     /* 501472 */     // GIR_Coverage, 13142,
     /* 501472 */     GIR_EraseRootFromParent_Done,
     /* 501473 */   // Label 6831: @501473
     /* 501473 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(501608), // Rule ID 13143 //
     /* 501478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 501481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 501505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501525 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501530 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501530 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501562 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 501565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 501572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 501577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 501582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 501587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 501592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 501597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501606 */     GIR_RootConstrainSelectedInstOperands,
     /* 501607 */     // GIR_Coverage, 13143,
     /* 501607 */     GIR_EraseRootFromParent_Done,
     /* 501608 */   // Label 6832: @501608
     /* 501608 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(501743), // Rule ID 13144 //
     /* 501613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 501616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 501640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501665 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501697 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 501700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 501707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 501712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 501727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 501732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501741 */     GIR_RootConstrainSelectedInstOperands,
     /* 501742 */     // GIR_Coverage, 13144,
     /* 501742 */     GIR_EraseRootFromParent_Done,
     /* 501743 */   // Label 6833: @501743
     /* 501743 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(501878), // Rule ID 13145 //
     /* 501748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 501751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 501775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 501779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501800 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501805 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501818 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501832 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 501835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 501842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 501847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 501862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 501867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 501876 */     GIR_RootConstrainSelectedInstOperands,
     /* 501877 */     // GIR_Coverage, 13145,
     /* 501877 */     GIR_EraseRootFromParent_Done,
     /* 501878 */   // Label 6834: @501878
     /* 501878 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(502013), // Rule ID 12253 //
     /* 501883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 501886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 501890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 501894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 501898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 501902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 501906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 501910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 501914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 501918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 501922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 501926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 501930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 501930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 501935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 501935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 501940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 501944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 501946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 501967 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 501967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 501970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 501972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 501977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 501982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 501987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 501992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 501997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502011 */     GIR_RootConstrainSelectedInstOperands,
     /* 502012 */     // GIR_Coverage, 12253,
     /* 502012 */     GIR_EraseRootFromParent_Done,
     /* 502013 */   // Label 6835: @502013
     /* 502013 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(502148), // Rule ID 12254 //
     /* 502018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502102 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502146 */     GIR_RootConstrainSelectedInstOperands,
     /* 502147 */     // GIR_Coverage, 12254,
     /* 502147 */     GIR_EraseRootFromParent_Done,
     /* 502148 */   // Label 6836: @502148
     /* 502148 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(502283), // Rule ID 12255 //
     /* 502153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502205 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502210 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502237 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502281 */     GIR_RootConstrainSelectedInstOperands,
     /* 502282 */     // GIR_Coverage, 12255,
     /* 502282 */     GIR_EraseRootFromParent_Done,
     /* 502283 */   // Label 6837: @502283
     /* 502283 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(502418), // Rule ID 12256 //
     /* 502288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 502291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502340 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502372 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 502375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502416 */     GIR_RootConstrainSelectedInstOperands,
     /* 502417 */     // GIR_Coverage, 12256,
     /* 502417 */     GIR_EraseRootFromParent_Done,
     /* 502418 */   // Label 6838: @502418
     /* 502418 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(502553), // Rule ID 12733 //
     /* 502423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 502426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 502430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502475 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502480 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502493 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502507 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 502510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502551 */     GIR_RootConstrainSelectedInstOperands,
     /* 502552 */     // GIR_Coverage, 12733,
     /* 502552 */     GIR_EraseRootFromParent_Done,
     /* 502553 */   // Label 6839: @502553
     /* 502553 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(502688), // Rule ID 12734 //
     /* 502558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 502561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 502565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502610 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502642 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 502645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 502652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 502657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 502662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 502667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502686 */     GIR_RootConstrainSelectedInstOperands,
     /* 502687 */     // GIR_Coverage, 12734,
     /* 502687 */     GIR_EraseRootFromParent_Done,
     /* 502688 */   // Label 6840: @502688
     /* 502688 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(502823), // Rule ID 12735 //
     /* 502693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 502696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 502700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502777 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 502780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502821 */     GIR_RootConstrainSelectedInstOperands,
     /* 502822 */     // GIR_Coverage, 12735,
     /* 502822 */     GIR_EraseRootFromParent_Done,
     /* 502823 */   // Label 6841: @502823
     /* 502823 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(502958), // Rule ID 12736 //
     /* 502828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 502831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 502835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 502867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 502871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 502875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 502875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 502880 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 502880 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 502885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 502889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 502891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 502912 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 502912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 502915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 502917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 502922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 502927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 502932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 502937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 502942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 502947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 502956 */     GIR_RootConstrainSelectedInstOperands,
     /* 502957 */     // GIR_Coverage, 12736,
     /* 502957 */     GIR_EraseRootFromParent_Done,
     /* 502958 */   // Label 6842: @502958
     /* 502958 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(503093), // Rule ID 13213 //
     /* 502963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 502966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 502970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 502974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 502978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 502982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 502986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 502990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 502994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 502998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 503010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503015 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503047 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503091 */     GIR_RootConstrainSelectedInstOperands,
     /* 503092 */     // GIR_Coverage, 13213,
     /* 503092 */     GIR_EraseRootFromParent_Done,
     /* 503093 */   // Label 6843: @503093
     /* 503093 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(503228), // Rule ID 13214 //
     /* 503098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 503129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 503145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503150 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503155 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503168 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503175 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503182 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503226 */     GIR_RootConstrainSelectedInstOperands,
     /* 503227 */     // GIR_Coverage, 13214,
     /* 503227 */     GIR_EraseRootFromParent_Done,
     /* 503228 */   // Label 6844: @503228
     /* 503228 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(503363), // Rule ID 13215 //
     /* 503233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 503264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 503280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503285 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503296 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503303 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503317 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503361 */     GIR_RootConstrainSelectedInstOperands,
     /* 503362 */     // GIR_Coverage, 13215,
     /* 503362 */     GIR_EraseRootFromParent_Done,
     /* 503363 */   // Label 6845: @503363
     /* 503363 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(503498), // Rule ID 13216 //
     /* 503368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 503371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 503399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 503415 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503452 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 503455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503496 */     GIR_RootConstrainSelectedInstOperands,
     /* 503497 */     // GIR_Coverage, 13216,
     /* 503497 */     GIR_EraseRootFromParent_Done,
     /* 503498 */   // Label 6846: @503498
     /* 503498 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(503633), // Rule ID 12193 //
     /* 503503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 503506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 503534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503587 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 503590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503631 */     GIR_RootConstrainSelectedInstOperands,
     /* 503632 */     // GIR_Coverage, 12193,
     /* 503632 */     GIR_EraseRootFromParent_Done,
     /* 503633 */   // Label 6847: @503633
     /* 503633 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(503768), // Rule ID 12194 //
     /* 503638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 503641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 503669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503685 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503685 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503690 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503690 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503699 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503715 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503722 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 503725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 503732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 503737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 503742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 503747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503766 */     GIR_RootConstrainSelectedInstOperands,
     /* 503767 */     // GIR_Coverage, 12194,
     /* 503767 */     GIR_EraseRootFromParent_Done,
     /* 503768 */   // Label 6848: @503768
     /* 503768 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(503903), // Rule ID 12195 //
     /* 503773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 503776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 503804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503820 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503825 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503836 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503843 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503857 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 503860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 503867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 503872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 503877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 503882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 503887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 503892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 503901 */     GIR_RootConstrainSelectedInstOperands,
     /* 503902 */     // GIR_Coverage, 12195,
     /* 503902 */     GIR_EraseRootFromParent_Done,
     /* 503903 */   // Label 6849: @503903
     /* 503903 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(504038), // Rule ID 12196 //
     /* 503908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 503911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 503915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 503919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 503927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 503931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 503935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 503939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 503943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 503947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 503951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 503955 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 503955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 503960 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 503960 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 503965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 503969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 503971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 503992 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 503992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 503995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 503997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 504012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 504017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504036 */     GIR_RootConstrainSelectedInstOperands,
     /* 504037 */     // GIR_Coverage, 12196,
     /* 504037 */     GIR_EraseRootFromParent_Done,
     /* 504038 */   // Label 6850: @504038
     /* 504038 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(504173), // Rule ID 12673 //
     /* 504043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 504046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 504074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504090 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504127 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 504130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504171 */     GIR_RootConstrainSelectedInstOperands,
     /* 504172 */     // GIR_Coverage, 12673,
     /* 504172 */     GIR_EraseRootFromParent_Done,
     /* 504173 */   // Label 6851: @504173
     /* 504173 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(504308), // Rule ID 12674 //
     /* 504178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 504181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 504209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504248 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504262 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 504265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504306 */     GIR_RootConstrainSelectedInstOperands,
     /* 504307 */     // GIR_Coverage, 12674,
     /* 504307 */     GIR_EraseRootFromParent_Done,
     /* 504308 */   // Label 6852: @504308
     /* 504308 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(504443), // Rule ID 12675 //
     /* 504313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 504316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 504344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504365 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504365 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504376 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504390 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504397 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 504400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 504417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 504422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504441 */     GIR_RootConstrainSelectedInstOperands,
     /* 504442 */     // GIR_Coverage, 12675,
     /* 504442 */     GIR_EraseRootFromParent_Done,
     /* 504443 */   // Label 6853: @504443
     /* 504443 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(504578), // Rule ID 12676 //
     /* 504448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 504451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 504455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 504479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504495 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504500 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504518 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504532 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 504535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 504552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 504557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504576 */     GIR_RootConstrainSelectedInstOperands,
     /* 504577 */     // GIR_Coverage, 12676,
     /* 504577 */     GIR_EraseRootFromParent_Done,
     /* 504578 */   // Label 6854: @504578
     /* 504578 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(504713), // Rule ID 13153 //
     /* 504583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 504586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 504614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504630 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504635 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504667 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 504670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504711 */     GIR_RootConstrainSelectedInstOperands,
     /* 504712 */     // GIR_Coverage, 13153,
     /* 504712 */     GIR_EraseRootFromParent_Done,
     /* 504713 */   // Label 6855: @504713
     /* 504713 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(504848), // Rule ID 13154 //
     /* 504718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 504721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 504749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504765 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504770 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504802 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 504805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 504812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 504817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 504822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 504827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504846 */     GIR_RootConstrainSelectedInstOperands,
     /* 504847 */     // GIR_Coverage, 13154,
     /* 504847 */     GIR_EraseRootFromParent_Done,
     /* 504848 */   // Label 6856: @504848
     /* 504848 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(504983), // Rule ID 13155 //
     /* 504853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 504856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 504872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 504876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 504880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 504884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 504888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 504892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 504896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 504900 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 504900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 504905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 504905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 504910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 504914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 504916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504923 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 504937 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 504937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 504940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 504942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 504947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 504952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 504957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 504962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 504967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 504972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 504981 */     GIR_RootConstrainSelectedInstOperands,
     /* 504982 */     // GIR_Coverage, 13155,
     /* 504982 */     GIR_EraseRootFromParent_Done,
     /* 504983 */   // Label 6857: @504983
     /* 504983 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(505118), // Rule ID 13156 //
     /* 504988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 504991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 504995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 504999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 505019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505035 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505040 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505040 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505045 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505051 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505072 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 505075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 505092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 505097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505116 */     GIR_RootConstrainSelectedInstOperands,
     /* 505117 */     // GIR_Coverage, 13156,
     /* 505117 */     GIR_EraseRootFromParent_Done,
     /* 505118 */   // Label 6858: @505118
     /* 505118 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(505253), // Rule ID 12238 //
     /* 505123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 505126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 505154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505170 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505175 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505207 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 505210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505251 */     GIR_RootConstrainSelectedInstOperands,
     /* 505252 */     // GIR_Coverage, 12238,
     /* 505252 */     GIR_EraseRootFromParent_Done,
     /* 505253 */   // Label 6859: @505253
     /* 505253 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(505388), // Rule ID 12239 //
     /* 505258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 505261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 505289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505305 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505310 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505342 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 505345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505386 */     GIR_RootConstrainSelectedInstOperands,
     /* 505387 */     // GIR_Coverage, 12239,
     /* 505387 */     GIR_EraseRootFromParent_Done,
     /* 505388 */   // Label 6860: @505388
     /* 505388 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(505523), // Rule ID 12240 //
     /* 505393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 505396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 505424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505440 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505440 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505445 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505456 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505477 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 505480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 505497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 505502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505521 */     GIR_RootConstrainSelectedInstOperands,
     /* 505522 */     // GIR_Coverage, 12240,
     /* 505522 */     GIR_EraseRootFromParent_Done,
     /* 505523 */   // Label 6861: @505523
     /* 505523 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(505658), // Rule ID 12241 //
     /* 505528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 505531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 505535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 505559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505575 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505598 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505612 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 505615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 505622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 505627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 505632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 505637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505656 */     GIR_RootConstrainSelectedInstOperands,
     /* 505657 */     // GIR_Coverage, 12241,
     /* 505657 */     GIR_EraseRootFromParent_Done,
     /* 505658 */   // Label 6862: @505658
     /* 505658 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(505793), // Rule ID 12718 //
     /* 505663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 505666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 505694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505747 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 505750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505791 */     GIR_RootConstrainSelectedInstOperands,
     /* 505792 */     // GIR_Coverage, 12718,
     /* 505792 */     GIR_EraseRootFromParent_Done,
     /* 505793 */   // Label 6863: @505793
     /* 505793 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(505928), // Rule ID 12719 //
     /* 505798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 505801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 505829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505850 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505850 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 505882 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 505882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 505885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 505887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 505892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 505897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 505902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 505907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 505912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 505917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 505926 */     GIR_RootConstrainSelectedInstOperands,
     /* 505927 */     // GIR_Coverage, 12719,
     /* 505927 */     GIR_EraseRootFromParent_Done,
     /* 505928 */   // Label 6864: @505928
     /* 505928 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(506063), // Rule ID 12720 //
     /* 505933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 505936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 505940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 505944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 505948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 505952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 505956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 505960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 505964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 505968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 505972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 505976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 505980 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 505980 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 505985 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 505985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 505990 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 505994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 505996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506010 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506017 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 506020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506061 */     GIR_RootConstrainSelectedInstOperands,
     /* 506062 */     // GIR_Coverage, 12720,
     /* 506062 */     GIR_EraseRootFromParent_Done,
     /* 506063 */   // Label 6865: @506063
     /* 506063 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(506198), // Rule ID 12721 //
     /* 506068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 506071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 506075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 506087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 506091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 506095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 506103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 506107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 506111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506115 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 506120 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 506125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506145 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506152 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 506155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506196 */     GIR_RootConstrainSelectedInstOperands,
     /* 506197 */     // GIR_Coverage, 12721,
     /* 506197 */     GIR_EraseRootFromParent_Done,
     /* 506198 */   // Label 6866: @506198
     /* 506198 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(506333), // Rule ID 13198 //
     /* 506203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 506206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 506222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 506226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 506230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 506238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 506242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 506246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506250 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 506255 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 506260 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506273 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506287 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 506290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506331 */     GIR_RootConstrainSelectedInstOperands,
     /* 506332 */     // GIR_Coverage, 13198,
     /* 506332 */     GIR_EraseRootFromParent_Done,
     /* 506333 */   // Label 6867: @506333
     /* 506333 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(506468), // Rule ID 13199 //
     /* 506338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 506341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 506357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 506361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 506365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 506373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 506377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 506381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 506390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 506395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506422 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 506425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506466 */     GIR_RootConstrainSelectedInstOperands,
     /* 506467 */     // GIR_Coverage, 13199,
     /* 506467 */     GIR_EraseRootFromParent_Done,
     /* 506468 */   // Label 6868: @506468
     /* 506468 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(506603), // Rule ID 13200 //
     /* 506473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 506476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 506492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 506496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 506500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 506508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 506512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 506516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 506525 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506525 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 506530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506557 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 506560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506601 */     GIR_RootConstrainSelectedInstOperands,
     /* 506602 */     // GIR_Coverage, 13200,
     /* 506602 */     GIR_EraseRootFromParent_Done,
     /* 506603 */   // Label 6869: @506603
     /* 506603 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(506738), // Rule ID 13201 //
     /* 506608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 506611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 506627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 506631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 506635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 506643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 506647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 506651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 506655 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 506660 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 506665 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506692 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 506695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 506702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 506707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 506712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 506717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506736 */     GIR_RootConstrainSelectedInstOperands,
     /* 506737 */     // GIR_Coverage, 13201,
     /* 506737 */     GIR_EraseRootFromParent_Done,
     /* 506738 */   // Label 6870: @506738
     /* 506738 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(506873), // Rule ID 12178 //
     /* 506743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 506746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 506762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 506766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 506770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 506778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 506782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 506786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506790 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 506795 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506795 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 506800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506827 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 506830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 506871 */     GIR_RootConstrainSelectedInstOperands,
     /* 506872 */     // GIR_Coverage, 12178,
     /* 506872 */     GIR_EraseRootFromParent_Done,
     /* 506873 */   // Label 6871: @506873
     /* 506873 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(507008), // Rule ID 12179 //
     /* 506878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 506881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 506885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 506889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 506897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 506901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 506905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 506909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 506913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 506917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 506921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 506925 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 506925 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 506930 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 506930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 506935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 506939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 506941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506948 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506955 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 506962 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 506962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 506965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 506967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 506972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 506977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 506982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 506987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 506992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 506997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507006 */     GIR_RootConstrainSelectedInstOperands,
     /* 507007 */     // GIR_Coverage, 12179,
     /* 507007 */     GIR_EraseRootFromParent_Done,
     /* 507008 */   // Label 6872: @507008
     /* 507008 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(507143), // Rule ID 12180 //
     /* 507013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 507016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 507056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507060 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 507065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 507070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507097 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 507100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507141 */     GIR_RootConstrainSelectedInstOperands,
     /* 507142 */     // GIR_Coverage, 12180,
     /* 507142 */     GIR_EraseRootFromParent_Done,
     /* 507143 */   // Label 6873: @507143
     /* 507143 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(507278), // Rule ID 12181 //
     /* 507148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 507151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 507191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 507200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 507205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507232 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 507235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507276 */     GIR_RootConstrainSelectedInstOperands,
     /* 507277 */     // GIR_Coverage, 12181,
     /* 507277 */     GIR_EraseRootFromParent_Done,
     /* 507278 */   // Label 6874: @507278
     /* 507278 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(507413), // Rule ID 12658 //
     /* 507283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 507286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 507290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 507326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507330 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507330 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 507335 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 507340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507367 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 507370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507411 */     GIR_RootConstrainSelectedInstOperands,
     /* 507412 */     // GIR_Coverage, 12658,
     /* 507412 */     GIR_EraseRootFromParent_Done,
     /* 507413 */   // Label 6875: @507413
     /* 507413 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(507548), // Rule ID 12659 //
     /* 507418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 507421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 507425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 507461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507465 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 507470 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 507475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507502 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 507505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507546 */     GIR_RootConstrainSelectedInstOperands,
     /* 507547 */     // GIR_Coverage, 12659,
     /* 507547 */     GIR_EraseRootFromParent_Done,
     /* 507548 */   // Label 6876: @507548
     /* 507548 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(507683), // Rule ID 12660 //
     /* 507553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 507556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 507560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 507596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507600 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507600 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 507605 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 507610 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507637 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 507640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507681 */     GIR_RootConstrainSelectedInstOperands,
     /* 507682 */     // GIR_Coverage, 12660,
     /* 507682 */     GIR_EraseRootFromParent_Done,
     /* 507683 */   // Label 6877: @507683
     /* 507683 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(507818), // Rule ID 12661 //
     /* 507688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 507691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 507695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 507731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507735 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 507740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 507745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507772 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 507775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 507782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 507787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 507792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 507797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507816 */     GIR_RootConstrainSelectedInstOperands,
     /* 507817 */     // GIR_Coverage, 12661,
     /* 507817 */     GIR_EraseRootFromParent_Done,
     /* 507818 */   // Label 6878: @507818
     /* 507818 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(507953), // Rule ID 13138 //
     /* 507823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 507826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 507866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 507870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 507875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 507875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 507880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 507884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 507886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507893 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 507907 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 507907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 507910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 507912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 507917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 507922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 507927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 507932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 507937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 507942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 507951 */     GIR_RootConstrainSelectedInstOperands,
     /* 507952 */     // GIR_Coverage, 13138,
     /* 507952 */     GIR_EraseRootFromParent_Done,
     /* 507953 */   // Label 6879: @507953
     /* 507953 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(508088), // Rule ID 13139 //
     /* 507958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 507961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 507965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 507969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 507973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 507977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 507981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 507985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 507989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 507993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 507997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 508001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 508010 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508010 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 508015 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508042 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 508045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508086 */     GIR_RootConstrainSelectedInstOperands,
     /* 508087 */     // GIR_Coverage, 13139,
     /* 508087 */     GIR_EraseRootFromParent_Done,
     /* 508088 */   // Label 6880: @508088
     /* 508088 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(508223), // Rule ID 13140 //
     /* 508093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 508096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 508116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 508136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508140 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 508145 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 508150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508156 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508163 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508177 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 508180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508221 */     GIR_RootConstrainSelectedInstOperands,
     /* 508222 */     // GIR_Coverage, 13140,
     /* 508222 */     GIR_EraseRootFromParent_Done,
     /* 508223 */   // Label 6881: @508223
     /* 508223 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(508358), // Rule ID 13141 //
     /* 508228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 508231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 508251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 508259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 508271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508275 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 508275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 508280 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 508280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 508285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 508289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 508291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508298 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508312 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 508315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 508332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 508337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508356 */     GIR_RootConstrainSelectedInstOperands,
     /* 508357 */     // GIR_Coverage, 13141,
     /* 508357 */     GIR_EraseRootFromParent_Done,
     /* 508358 */   // Label 6882: @508358
     /* 508358 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(508473), // Rule ID 13404 //
     /* 508363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 508366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 508370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 508374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 508378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508398 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 508400 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 508404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 508406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508427 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 508430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 508447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 508452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 508457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 508462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508471 */     GIR_RootConstrainSelectedInstOperands,
     /* 508472 */     // GIR_Coverage, 13404,
     /* 508472 */     GIR_EraseRootFromParent_Done,
     /* 508473 */   // Label 6883: @508473
     /* 508473 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(508588), // Rule ID 13420 //
     /* 508478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 508481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 508489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 508493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508513 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 508515 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 508519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 508521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508528 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508542 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 508545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 508562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 508567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 508572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 508577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508586 */     GIR_RootConstrainSelectedInstOperands,
     /* 508587 */     // GIR_Coverage, 13420,
     /* 508587 */     GIR_EraseRootFromParent_Done,
     /* 508588 */   // Label 6884: @508588
     /* 508588 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(508703), // Rule ID 13403 //
     /* 508593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 508596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 508600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 508604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 508608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508628 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 508630 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 508634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 508636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508657 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 508660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 508677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 508682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 508687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 508692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508701 */     GIR_RootConstrainSelectedInstOperands,
     /* 508702 */     // GIR_Coverage, 13403,
     /* 508702 */     GIR_EraseRootFromParent_Done,
     /* 508703 */   // Label 6885: @508703
     /* 508703 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(508818), // Rule ID 13419 //
     /* 508708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 508711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 508719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 508723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 508735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508743 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 508745 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 508749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 508751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508772 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 508775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 508782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 508787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 508792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 508797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 508802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 508807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508816 */     GIR_RootConstrainSelectedInstOperands,
     /* 508817 */     // GIR_Coverage, 13419,
     /* 508817 */     GIR_EraseRootFromParent_Done,
     /* 508818 */   // Label 6886: @508818
     /* 508818 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(508933), // Rule ID 7878 //
     /* 508823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 508826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 508830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 508838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508858 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 508860 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 508864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 508866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508880 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508887 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 508887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 508890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 508892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 508897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 508902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 508907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 508912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 508917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 508922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 508931 */     GIR_RootConstrainSelectedInstOperands,
     /* 508932 */     // GIR_Coverage, 7878,
     /* 508932 */     GIR_EraseRootFromParent_Done,
     /* 508933 */   // Label 6887: @508933
     /* 508933 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(509048), // Rule ID 7894 //
     /* 508938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 508941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 508945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 508949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 508953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 508957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 508961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 508965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 508969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 508973 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 508975 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 508979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 508981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508988 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 508995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509002 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 509005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509046 */     GIR_RootConstrainSelectedInstOperands,
     /* 509047 */     // GIR_Coverage, 7894,
     /* 509047 */     GIR_EraseRootFromParent_Done,
     /* 509048 */   // Label 6888: @509048
     /* 509048 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(509163), // Rule ID 7877 //
     /* 509053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 509056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 509060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 509068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 509076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 509084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 509088 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 509090 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 509094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 509096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509117 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 509120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509161 */     GIR_RootConstrainSelectedInstOperands,
     /* 509162 */     // GIR_Coverage, 7877,
     /* 509162 */     GIR_EraseRootFromParent_Done,
     /* 509163 */   // Label 6889: @509163
     /* 509163 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(509278), // Rule ID 7893 //
     /* 509168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 509171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 509183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 509191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 509199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 509203 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 509205 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 509209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 509211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509232 */     // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 509235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509276 */     GIR_RootConstrainSelectedInstOperands,
     /* 509277 */     // GIR_Coverage, 7893,
     /* 509277 */     GIR_EraseRootFromParent_Done,
     /* 509278 */   // Label 6890: @509278
     /* 509278 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(509377), // Rule ID 13396 //
     /* 509283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 509286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 509290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 509294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509306 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 509308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 509310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509331 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 509334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 509351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 509356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 509361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 509366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509375 */     GIR_RootConstrainSelectedInstOperands,
     /* 509376 */     // GIR_Coverage, 13396,
     /* 509376 */     GIR_EraseRootFromParent_Done,
     /* 509377 */   // Label 6891: @509377
     /* 509377 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(509476), // Rule ID 13412 //
     /* 509382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 509385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 509393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509405 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 509407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 509409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509430 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 509433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 509450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 509455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 509460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 509465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509474 */     GIR_RootConstrainSelectedInstOperands,
     /* 509475 */     // GIR_Coverage, 13412,
     /* 509475 */     GIR_EraseRootFromParent_Done,
     /* 509476 */   // Label 6892: @509476
     /* 509476 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(509575), // Rule ID 13395 //
     /* 509481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 509484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 509488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 509492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509504 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 509506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 509508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509529 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 509532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 509549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 509554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 509559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 509564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509573 */     GIR_RootConstrainSelectedInstOperands,
     /* 509574 */     // GIR_Coverage, 13395,
     /* 509574 */     GIR_EraseRootFromParent_Done,
     /* 509575 */   // Label 6893: @509575
     /* 509575 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(509674), // Rule ID 13411 //
     /* 509580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 509583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 509591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509603 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 509605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 509607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509628 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 509631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 509638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 509643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 509648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 509653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 509658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 509663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509672 */     GIR_RootConstrainSelectedInstOperands,
     /* 509673 */     // GIR_Coverage, 13411,
     /* 509673 */     GIR_EraseRootFromParent_Done,
     /* 509674 */   // Label 6894: @509674
     /* 509674 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(509773), // Rule ID 7870 //
     /* 509679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 509682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 509686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509702 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 509704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 509706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509727 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 509730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509771 */     GIR_RootConstrainSelectedInstOperands,
     /* 509772 */     // GIR_Coverage, 7870,
     /* 509772 */     GIR_EraseRootFromParent_Done,
     /* 509773 */   // Label 6895: @509773
     /* 509773 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(509872), // Rule ID 7886 //
     /* 509778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 509781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 509793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509801 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 509803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 509805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509826 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 509829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509870 */     GIR_RootConstrainSelectedInstOperands,
     /* 509871 */     // GIR_Coverage, 7886,
     /* 509871 */     GIR_EraseRootFromParent_Done,
     /* 509872 */   // Label 6896: @509872
     /* 509872 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(509971), // Rule ID 7869 //
     /* 509877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 509880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 509884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509900 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 509902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 509904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 509925 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 509925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_t16_e64),
     /* 509928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 509930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 509935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 509940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 509945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 509950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 509955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 509960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 509969 */     GIR_RootConstrainSelectedInstOperands,
     /* 509970 */     // GIR_Coverage, 7869,
     /* 509970 */     GIR_EraseRootFromParent_Done,
     /* 509971 */   // Label 6897: @509971
     /* 509971 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(510070), // Rule ID 7885 //
     /* 509976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 509979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 509983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 509987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 509991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 509995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 509999 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 510001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 510003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510024 */     // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_fake16_e64),
     /* 510027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 510034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510068 */     GIR_RootConstrainSelectedInstOperands,
     /* 510069 */     // GIR_Coverage, 7885,
     /* 510069 */     GIR_EraseRootFromParent_Done,
     /* 510070 */   // Label 6898: @510070
     /* 510070 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(510105), // Rule ID 100 //
     /* 510075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 510078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 510082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 510086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 510090 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13744),
     /* 510094 */     // (fminnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13744>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 510094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
     /* 510099 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 510103 */     GIR_RootConstrainSelectedInstOperands,
     /* 510104 */     // GIR_Coverage, 100,
     /* 510104 */     GIR_Done,
     /* 510105 */   // Label 6899: @510105
     /* 510105 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(510168), // Rule ID 886 //
     /* 510110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 510113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 510124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510131 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 510131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 510134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 510141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 510151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 510161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 510166 */     GIR_RootConstrainSelectedInstOperands,
     /* 510167 */     // GIR_Coverage, 886,
     /* 510167 */     GIR_EraseRootFromParent_Done,
     /* 510168 */   // Label 6900: @510168
     /* 510168 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(510231), // Rule ID 890 //
     /* 510173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 510176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 510187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510194 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 510194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 510197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 510204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 510214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 510224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 510229 */     GIR_RootConstrainSelectedInstOperands,
     /* 510230 */     // GIR_Coverage, 890,
     /* 510230 */     GIR_EraseRootFromParent_Done,
     /* 510231 */   // Label 6901: @510231
     /* 510231 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(510294), // Rule ID 8572 //
     /* 510236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 510239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 510257 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 510257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
     /* 510260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 510267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 510277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 510282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 510287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 510292 */     GIR_RootConstrainSelectedInstOperands,
     /* 510293 */     // GIR_Coverage, 8572,
     /* 510293 */     GIR_EraseRootFromParent_Done,
     /* 510294 */   // Label 6902: @510294
     /* 510294 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(510357), // Rule ID 8574 //
     /* 510299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 510302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 510320 */     // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 510320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
     /* 510323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 510330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 510340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 510345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 510350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 510355 */     GIR_RootConstrainSelectedInstOperands,
     /* 510356 */     // GIR_Coverage, 8574,
     /* 510356 */     GIR_EraseRootFromParent_Done,
     /* 510357 */   // Label 6903: @510357
     /* 510357 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(510419), // Rule ID 888 //
     /* 510362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 510365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 510369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 510376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 510383 */     // (fminnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 510383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
     /* 510386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 510393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 510403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510417 */     GIR_RootConstrainSelectedInstOperands,
     /* 510418 */     // GIR_Coverage, 888,
     /* 510418 */     GIR_EraseRootFromParent_Done,
     /* 510419 */   // Label 6904: @510419
     /* 510419 */   GIM_Reject,
     /* 510420 */ // Label 6498: @510420
     /* 510420 */ GIM_Reject,
     /* 510421 */ // Label 6494: @510421
     /* 510421 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(527932),
     /* 510426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 510429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 510432 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(510561), // Rule ID 11767 //
     /* 510437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 510477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510481 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510481 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510486 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510518 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 510528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510559 */     GIR_RootConstrainSelectedInstOperands,
     /* 510560 */     // GIR_Coverage, 11767,
     /* 510560 */     GIR_EraseRootFromParent_Done,
     /* 510561 */   // Label 6906: @510561
     /* 510561 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(510690), // Rule ID 11768 //
     /* 510566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 510606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510610 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510615 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510647 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 510657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 510662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 510667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 510672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510688 */     GIR_RootConstrainSelectedInstOperands,
     /* 510689 */     // GIR_Coverage, 11768,
     /* 510689 */     GIR_EraseRootFromParent_Done,
     /* 510690 */   // Label 6907: @510690
     /* 510690 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(510819), // Rule ID 11771 //
     /* 510695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 510735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510776 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 510796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 510801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510817 */     GIR_RootConstrainSelectedInstOperands,
     /* 510818 */     // GIR_Coverage, 11771,
     /* 510818 */     GIR_EraseRootFromParent_Done,
     /* 510819 */   // Label 6908: @510819
     /* 510819 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(510948), // Rule ID 11772 //
     /* 510824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 510864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 510868 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 510868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 510873 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510873 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 510878 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 510882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 510884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 510905 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 510905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 510908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 510910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 510915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 510920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 510925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 510930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 510935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 510940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 510946 */     GIR_RootConstrainSelectedInstOperands,
     /* 510947 */     // GIR_Coverage, 11772,
     /* 510947 */     GIR_EraseRootFromParent_Done,
     /* 510948 */   // Label 6909: @510948
     /* 510948 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(511077), // Rule ID 11752 //
     /* 510953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 510957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 510961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 510969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 510973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 510977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 510981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 510985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 510989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 510993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 510997 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 510997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511002 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511007 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511034 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 511044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 511049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511075 */     GIR_RootConstrainSelectedInstOperands,
     /* 511076 */     // GIR_Coverage, 11752,
     /* 511076 */     GIR_EraseRootFromParent_Done,
     /* 511077 */   // Label 6910: @511077
     /* 511077 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(511206), // Rule ID 11753 //
     /* 511082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 511106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 511122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511126 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511126 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511131 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511131 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511163 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 511173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 511178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511204 */     GIR_RootConstrainSelectedInstOperands,
     /* 511205 */     // GIR_Coverage, 11753,
     /* 511205 */     GIR_EraseRootFromParent_Done,
     /* 511206 */   // Label 6911: @511206
     /* 511206 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(511335), // Rule ID 11756 //
     /* 511211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 511235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 511251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511255 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511260 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511271 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511292 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 511312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 511317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511333 */     GIR_RootConstrainSelectedInstOperands,
     /* 511334 */     // GIR_Coverage, 11756,
     /* 511334 */     GIR_EraseRootFromParent_Done,
     /* 511335 */   // Label 6912: @511335
     /* 511335 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(511464), // Rule ID 11757 //
     /* 511340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 511364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 511380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 511384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511421 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 511441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 511446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511462 */     GIR_RootConstrainSelectedInstOperands,
     /* 511463 */     // GIR_Coverage, 11757,
     /* 511463 */     GIR_EraseRootFromParent_Done,
     /* 511464 */   // Label 6913: @511464
     /* 511464 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(511593), // Rule ID 7738 //
     /* 511469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 511493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 511509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511513 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511513 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511518 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511523 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511550 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 511560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 511565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511591 */     GIR_RootConstrainSelectedInstOperands,
     /* 511592 */     // GIR_Coverage, 7738,
     /* 511592 */     GIR_EraseRootFromParent_Done,
     /* 511593 */   // Label 6914: @511593
     /* 511593 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(511722), // Rule ID 11766 //
     /* 511598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 511622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 511638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511642 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511647 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511652 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511679 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 511689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 511694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 511699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 511704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511720 */     GIR_RootConstrainSelectedInstOperands,
     /* 511721 */     // GIR_Coverage, 11766,
     /* 511721 */     GIR_EraseRootFromParent_Done,
     /* 511722 */   // Label 6915: @511722
     /* 511722 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(511851), // Rule ID 11769 //
     /* 511727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 511751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 511767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511771 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511771 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511776 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511808 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 511828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 511833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511849 */     GIR_RootConstrainSelectedInstOperands,
     /* 511850 */     // GIR_Coverage, 11769,
     /* 511850 */     GIR_EraseRootFromParent_Done,
     /* 511851 */   // Label 6916: @511851
     /* 511851 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(511980), // Rule ID 11770 //
     /* 511856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 511872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 511876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 511880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 511888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 511892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 511896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 511900 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 511900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 511905 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 511905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 511910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 511914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 511916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 511937 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 511937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 511940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 511942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 511947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 511952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 511957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 511962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 511967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 511972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 511978 */     GIR_RootConstrainSelectedInstOperands,
     /* 511979 */     // GIR_Coverage, 11770,
     /* 511979 */     GIR_EraseRootFromParent_Done,
     /* 511980 */   // Label 6917: @511980
     /* 511980 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(512109), // Rule ID 7737 //
     /* 511985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 511989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 511993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 511997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 512025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512052 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512066 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512107 */     GIR_RootConstrainSelectedInstOperands,
     /* 512108 */     // GIR_Coverage, 7737,
     /* 512108 */     GIR_EraseRootFromParent_Done,
     /* 512109 */   // Label 6918: @512109
     /* 512109 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(512238), // Rule ID 11751 //
     /* 512114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 512154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512158 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512163 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512168 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512195 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512236 */     GIR_RootConstrainSelectedInstOperands,
     /* 512237 */     // GIR_Coverage, 11751,
     /* 512237 */     GIR_EraseRootFromParent_Done,
     /* 512238 */   // Label 6919: @512238
     /* 512238 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(512367), // Rule ID 11754 //
     /* 512243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 512283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512287 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512292 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512324 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512365 */     GIR_RootConstrainSelectedInstOperands,
     /* 512366 */     // GIR_Coverage, 11754,
     /* 512366 */     GIR_EraseRootFromParent_Done,
     /* 512367 */   // Label 6920: @512367
     /* 512367 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(512496), // Rule ID 11755 //
     /* 512372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 512412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 512416 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512416 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512421 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512430 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512439 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512446 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512453 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512494 */     GIR_RootConstrainSelectedInstOperands,
     /* 512495 */     // GIR_Coverage, 11755,
     /* 512495 */     GIR_EraseRootFromParent_Done,
     /* 512496 */   // Label 6921: @512496
     /* 512496 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(512625), // Rule ID 11737 //
     /* 512501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 512541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512545 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512545 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512550 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512575 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512582 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512623 */     GIR_RootConstrainSelectedInstOperands,
     /* 512624 */     // GIR_Coverage, 11737,
     /* 512624 */     GIR_EraseRootFromParent_Done,
     /* 512625 */   // Label 6922: @512625
     /* 512625 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(512754), // Rule ID 11738 //
     /* 512630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 512670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512711 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 512721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 512726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 512731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 512736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512752 */     GIR_RootConstrainSelectedInstOperands,
     /* 512753 */     // GIR_Coverage, 11738,
     /* 512753 */     GIR_EraseRootFromParent_Done,
     /* 512754 */   // Label 6923: @512754
     /* 512754 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(512883), // Rule ID 11741 //
     /* 512759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 512799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512803 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512808 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512840 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 512875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 512881 */     GIR_RootConstrainSelectedInstOperands,
     /* 512882 */     // GIR_Coverage, 11741,
     /* 512882 */     GIR_EraseRootFromParent_Done,
     /* 512883 */   // Label 6924: @512883
     /* 512883 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(513012), // Rule ID 11742 //
     /* 512888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 512892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 512896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 512900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 512904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 512908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 512912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 512916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 512920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 512924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 512928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 512932 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 512932 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 512937 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 512937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 512942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 512946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 512948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 512969 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 512969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 512972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 512974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 512979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 512984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 512989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 512994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 512999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513010 */     GIR_RootConstrainSelectedInstOperands,
     /* 513011 */     // GIR_Coverage, 11742,
     /* 513011 */     GIR_EraseRootFromParent_Done,
     /* 513012 */   // Label 6925: @513012
     /* 513012 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(513141), // Rule ID 11722 //
     /* 513017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 513057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513061 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513061 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513066 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513071 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513098 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513139 */     GIR_RootConstrainSelectedInstOperands,
     /* 513140 */     // GIR_Coverage, 11722,
     /* 513140 */     GIR_EraseRootFromParent_Done,
     /* 513141 */   // Label 6926: @513141
     /* 513141 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(513270), // Rule ID 11723 //
     /* 513146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 513186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513190 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513195 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513200 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513220 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513227 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513268 */     GIR_RootConstrainSelectedInstOperands,
     /* 513269 */     // GIR_Coverage, 11723,
     /* 513269 */     GIR_EraseRootFromParent_Done,
     /* 513270 */   // Label 6927: @513270
     /* 513270 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(513399), // Rule ID 11726 //
     /* 513275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 513315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513356 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513397 */     GIR_RootConstrainSelectedInstOperands,
     /* 513398 */     // GIR_Coverage, 11726,
     /* 513398 */     GIR_EraseRootFromParent_Done,
     /* 513399 */   // Label 6928: @513399
     /* 513399 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(513528), // Rule ID 11727 //
     /* 513404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 513444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 513448 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513453 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513485 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513526 */     GIR_RootConstrainSelectedInstOperands,
     /* 513527 */     // GIR_Coverage, 11727,
     /* 513527 */     GIR_EraseRootFromParent_Done,
     /* 513528 */   // Label 6929: @513528
     /* 513528 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(513657), // Rule ID 7736 //
     /* 513533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 513573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513577 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513582 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513587 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513614 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513655 */     GIR_RootConstrainSelectedInstOperands,
     /* 513656 */     // GIR_Coverage, 7736,
     /* 513656 */     GIR_EraseRootFromParent_Done,
     /* 513657 */   // Label 6930: @513657
     /* 513657 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(513786), // Rule ID 11736 //
     /* 513662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 513702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513706 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513711 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513743 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 513753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 513758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 513763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 513768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513784 */     GIR_RootConstrainSelectedInstOperands,
     /* 513785 */     // GIR_Coverage, 11736,
     /* 513785 */     GIR_EraseRootFromParent_Done,
     /* 513786 */   // Label 6931: @513786
     /* 513786 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(513915), // Rule ID 11739 //
     /* 513791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 513831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513835 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513835 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513840 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513849 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513872 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 513872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 513875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 513877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 513882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 513887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 513892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 513897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 513902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 513907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 513913 */     GIR_RootConstrainSelectedInstOperands,
     /* 513914 */     // GIR_Coverage, 11739,
     /* 513914 */     GIR_EraseRootFromParent_Done,
     /* 513915 */   // Label 6932: @513915
     /* 513915 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(514044), // Rule ID 11740 //
     /* 513920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 513924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 513928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 513932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 513936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 513940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 513944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 513948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 513952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 513956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 513960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 513964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 513964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 513969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 513969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 513974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 513978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 513980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 513994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514001 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514042 */     GIR_RootConstrainSelectedInstOperands,
     /* 514043 */     // GIR_Coverage, 11740,
     /* 514043 */     GIR_EraseRootFromParent_Done,
     /* 514044 */   // Label 6933: @514044
     /* 514044 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(514173), // Rule ID 7735 //
     /* 514049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 514089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514093 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514098 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514130 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514171 */     GIR_RootConstrainSelectedInstOperands,
     /* 514172 */     // GIR_Coverage, 7735,
     /* 514172 */     GIR_EraseRootFromParent_Done,
     /* 514173 */   // Label 6934: @514173
     /* 514173 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(514302), // Rule ID 11721 //
     /* 514178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 514218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514222 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514227 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514259 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 514269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 514274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514300 */     GIR_RootConstrainSelectedInstOperands,
     /* 514301 */     // GIR_Coverage, 11721,
     /* 514301 */     GIR_EraseRootFromParent_Done,
     /* 514302 */   // Label 6935: @514302
     /* 514302 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(514431), // Rule ID 11724 //
     /* 514307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 514347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514351 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514351 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514356 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514361 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514388 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514429 */     GIR_RootConstrainSelectedInstOperands,
     /* 514430 */     // GIR_Coverage, 11724,
     /* 514430 */     GIR_EraseRootFromParent_Done,
     /* 514431 */   // Label 6936: @514431
     /* 514431 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(514560), // Rule ID 11725 //
     /* 514436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 514460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 514464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 514476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 514480 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514480 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 514485 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 514490 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514517 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 514537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 514542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 514547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 514552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514558 */     GIR_RootConstrainSelectedInstOperands,
     /* 514559 */     // GIR_Coverage, 11725,
     /* 514559 */     GIR_EraseRootFromParent_Done,
     /* 514560 */   // Label 6937: @514560
     /* 514560 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(514689), // Rule ID 11777 //
     /* 514565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 514589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514646 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 514666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 514671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 514676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 514681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514687 */     GIR_RootConstrainSelectedInstOperands,
     /* 514688 */     // GIR_Coverage, 11777,
     /* 514688 */     GIR_EraseRootFromParent_Done,
     /* 514689 */   // Label 6938: @514689
     /* 514689 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(514818), // Rule ID 11778 //
     /* 514694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 514718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514738 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514743 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514761 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514775 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 514785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 514790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 514795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 514800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 514805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 514810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514816 */     GIR_RootConstrainSelectedInstOperands,
     /* 514817 */     // GIR_Coverage, 11778,
     /* 514817 */     GIR_EraseRootFromParent_Done,
     /* 514818 */   // Label 6939: @514818
     /* 514818 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(514947), // Rule ID 11779 //
     /* 514823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 514847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514867 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 514867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 514872 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 514877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 514881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 514883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 514904 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 514904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 514907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 514909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 514914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 514919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 514924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 514929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 514934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 514939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 514945 */     GIR_RootConstrainSelectedInstOperands,
     /* 514946 */     // GIR_Coverage, 11779,
     /* 514946 */     GIR_EraseRootFromParent_Done,
     /* 514947 */   // Label 6940: @514947
     /* 514947 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(515076), // Rule ID 11780 //
     /* 514952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 514956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 514960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 514968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 514972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 514976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 514980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 514984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 514988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 514992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 514996 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 514996 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515001 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515033 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 515043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 515048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515074 */     GIR_RootConstrainSelectedInstOperands,
     /* 515075 */     // GIR_Coverage, 11780,
     /* 515075 */     GIR_EraseRootFromParent_Done,
     /* 515076 */   // Label 6941: @515076
     /* 515076 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(515205), // Rule ID 11717 //
     /* 515081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 515105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 515121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515125 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515130 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515135 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515139 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515155 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515162 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 515182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 515187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515203 */     GIR_RootConstrainSelectedInstOperands,
     /* 515204 */     // GIR_Coverage, 11717,
     /* 515204 */     GIR_EraseRootFromParent_Done,
     /* 515205 */   // Label 6942: @515205
     /* 515205 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(515334), // Rule ID 11718 //
     /* 515210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 515234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 515250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515291 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 515311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 515316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515332 */     GIR_RootConstrainSelectedInstOperands,
     /* 515333 */     // GIR_Coverage, 11718,
     /* 515333 */     GIR_EraseRootFromParent_Done,
     /* 515334 */   // Label 6943: @515334
     /* 515334 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(515463), // Rule ID 11719 //
     /* 515339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 515363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 515379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515383 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515383 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515388 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515420 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 515430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 515435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515461 */     GIR_RootConstrainSelectedInstOperands,
     /* 515462 */     // GIR_Coverage, 11719,
     /* 515462 */     GIR_EraseRootFromParent_Done,
     /* 515463 */   // Label 6944: @515463
     /* 515463 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(515592), // Rule ID 11720 //
     /* 515468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 515492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 515496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 515508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 515512 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515517 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515522 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515528 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515549 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 515559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 515564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515590 */     GIR_RootConstrainSelectedInstOperands,
     /* 515591 */     // GIR_Coverage, 11720,
     /* 515591 */     GIR_EraseRootFromParent_Done,
     /* 515592 */   // Label 6945: @515592
     /* 515592 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(515721), // Rule ID 11762 //
     /* 515597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 515621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 515637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515641 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515641 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515646 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515678 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 515698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 515703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515719 */     GIR_RootConstrainSelectedInstOperands,
     /* 515720 */     // GIR_Coverage, 11762,
     /* 515720 */     GIR_EraseRootFromParent_Done,
     /* 515721 */   // Label 6946: @515721
     /* 515721 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(515850), // Rule ID 11763 //
     /* 515726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 515750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 515766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515770 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515775 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515780 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515793 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515807 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 515817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 515822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 515827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 515832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515848 */     GIR_RootConstrainSelectedInstOperands,
     /* 515849 */     // GIR_Coverage, 11763,
     /* 515849 */     GIR_EraseRootFromParent_Done,
     /* 515850 */   // Label 6947: @515850
     /* 515850 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(515979), // Rule ID 11764 //
     /* 515855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 515871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 515875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 515879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 515883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 515887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 515891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 515895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 515899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 515904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 515904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 515909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 515913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 515915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 515936 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 515936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 515939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 515941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 515946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 515951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 515956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 515961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 515966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 515971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 515977 */     GIR_RootConstrainSelectedInstOperands,
     /* 515978 */     // GIR_Coverage, 11764,
     /* 515978 */     GIR_EraseRootFromParent_Done,
     /* 515979 */   // Label 6948: @515979
     /* 515979 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(516108), // Rule ID 11765 //
     /* 515984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 515988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 515992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 515996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 516008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516028 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516028 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516033 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516044 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516065 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 516075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 516080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 516095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 516100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516106 */     GIR_RootConstrainSelectedInstOperands,
     /* 516107 */     // GIR_Coverage, 11765,
     /* 516107 */     GIR_EraseRootFromParent_Done,
     /* 516108 */   // Label 6949: @516108
     /* 516108 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(516237), // Rule ID 11702 //
     /* 516113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 516137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516157 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516162 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516180 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516194 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 516214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 516219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 516224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 516229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516235 */     GIR_RootConstrainSelectedInstOperands,
     /* 516236 */     // GIR_Coverage, 11702,
     /* 516236 */     GIR_EraseRootFromParent_Done,
     /* 516237 */   // Label 6950: @516237
     /* 516237 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(516366), // Rule ID 11703 //
     /* 516242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 516266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516286 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516286 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516291 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516296 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516323 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 516343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 516348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 516353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 516358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516364 */     GIR_RootConstrainSelectedInstOperands,
     /* 516365 */     // GIR_Coverage, 11703,
     /* 516365 */     GIR_EraseRootFromParent_Done,
     /* 516366 */   // Label 6951: @516366
     /* 516366 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(516495), // Rule ID 11704 //
     /* 516371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 516395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516415 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516420 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516425 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516452 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 516462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 516467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 516482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 516487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516493 */     GIR_RootConstrainSelectedInstOperands,
     /* 516494 */     // GIR_Coverage, 11704,
     /* 516494 */     GIR_EraseRootFromParent_Done,
     /* 516495 */   // Label 6952: @516495
     /* 516495 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(516624), // Rule ID 11705 //
     /* 516500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 516524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 516528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 516544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516581 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 516591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 516596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 516611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 516616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516622 */     GIR_RootConstrainSelectedInstOperands,
     /* 516623 */     // GIR_Coverage, 11705,
     /* 516623 */     GIR_EraseRootFromParent_Done,
     /* 516624 */   // Label 6953: @516624
     /* 516624 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(516753), // Rule ID 11773 //
     /* 516629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 516653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516673 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516678 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516696 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516703 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516710 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516751 */     GIR_RootConstrainSelectedInstOperands,
     /* 516752 */     // GIR_Coverage, 11773,
     /* 516752 */     GIR_EraseRootFromParent_Done,
     /* 516753 */   // Label 6954: @516753
     /* 516753 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(516882), // Rule ID 11774 //
     /* 516758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 516782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516802 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516802 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516807 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516839 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 516849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 516854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 516859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 516864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 516874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 516880 */     GIR_RootConstrainSelectedInstOperands,
     /* 516881 */     // GIR_Coverage, 11774,
     /* 516881 */     GIR_EraseRootFromParent_Done,
     /* 516882 */   // Label 6955: @516882
     /* 516882 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(517011), // Rule ID 11775 //
     /* 516887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 516891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 516895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 516903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 516907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 516911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 516915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 516919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 516923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 516927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 516931 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 516931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 516936 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 516936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 516941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 516945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 516947 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516961 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 516968 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 516968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 516971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 516973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 516978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 516983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 516988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 516993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 516998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517009 */     GIR_RootConstrainSelectedInstOperands,
     /* 517010 */     // GIR_Coverage, 11775,
     /* 517010 */     GIR_EraseRootFromParent_Done,
     /* 517011 */   // Label 6956: @517011
     /* 517011 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(517140), // Rule ID 11776 //
     /* 517016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517060 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517065 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517070 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517090 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517097 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517138 */     GIR_RootConstrainSelectedInstOperands,
     /* 517139 */     // GIR_Coverage, 11776,
     /* 517139 */     GIR_EraseRootFromParent_Done,
     /* 517140 */   // Label 6957: @517140
     /* 517140 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(517269), // Rule ID 11713 //
     /* 517145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517226 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517267 */     GIR_RootConstrainSelectedInstOperands,
     /* 517268 */     // GIR_Coverage, 11713,
     /* 517268 */     GIR_EraseRootFromParent_Done,
     /* 517269 */   // Label 6958: @517269
     /* 517269 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(517398), // Rule ID 11714 //
     /* 517274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517318 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517318 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517323 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517328 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517341 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517355 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517396 */     GIR_RootConstrainSelectedInstOperands,
     /* 517397 */     // GIR_Coverage, 11714,
     /* 517397 */     GIR_EraseRootFromParent_Done,
     /* 517398 */   // Label 6959: @517398
     /* 517398 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(517527), // Rule ID 11715 //
     /* 517403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517447 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517447 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517452 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517477 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517484 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517525 */     GIR_RootConstrainSelectedInstOperands,
     /* 517526 */     // GIR_Coverage, 11715,
     /* 517526 */     GIR_EraseRootFromParent_Done,
     /* 517527 */   // Label 6960: @517527
     /* 517527 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(517656), // Rule ID 11716 //
     /* 517532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 517560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 517576 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517576 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517581 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517592 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517613 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 517623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 517628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 517633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 517638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517654 */     GIR_RootConstrainSelectedInstOperands,
     /* 517655 */     // GIR_Coverage, 11716,
     /* 517655 */     GIR_EraseRootFromParent_Done,
     /* 517656 */   // Label 6961: @517656
     /* 517656 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(517785), // Rule ID 11758 //
     /* 517661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517705 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517705 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517710 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517728 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517735 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517742 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517783 */     GIR_RootConstrainSelectedInstOperands,
     /* 517784 */     // GIR_Coverage, 11758,
     /* 517784 */     GIR_EraseRootFromParent_Done,
     /* 517785 */   // Label 6962: @517785
     /* 517785 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(517914), // Rule ID 11759 //
     /* 517790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517871 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 517871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 517874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 517876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 517881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 517886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 517891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 517896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 517901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 517906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 517912 */     GIR_RootConstrainSelectedInstOperands,
     /* 517913 */     // GIR_Coverage, 11759,
     /* 517913 */     GIR_EraseRootFromParent_Done,
     /* 517914 */   // Label 6963: @517914
     /* 517914 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(518043), // Rule ID 11760 //
     /* 517919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 517923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 517927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 517935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 517939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 517943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 517947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 517951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 517955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 517959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 517963 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 517963 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 517968 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 517968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 517973 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 517977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 517979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517986 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 517993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518000 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518041 */     GIR_RootConstrainSelectedInstOperands,
     /* 518042 */     // GIR_Coverage, 11760,
     /* 518042 */     GIR_EraseRootFromParent_Done,
     /* 518043 */   // Label 6964: @518043
     /* 518043 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(518172), // Rule ID 11761 //
     /* 518048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 518072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518092 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518097 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518129 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518170 */     GIR_RootConstrainSelectedInstOperands,
     /* 518171 */     // GIR_Coverage, 11761,
     /* 518171 */     GIR_EraseRootFromParent_Done,
     /* 518172 */   // Label 6965: @518172
     /* 518172 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(518301), // Rule ID 11698 //
     /* 518177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 518201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518221 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518226 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518258 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 518268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 518273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518299 */     GIR_RootConstrainSelectedInstOperands,
     /* 518300 */     // GIR_Coverage, 11698,
     /* 518300 */     GIR_EraseRootFromParent_Done,
     /* 518301 */   // Label 6966: @518301
     /* 518301 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(518430), // Rule ID 11699 //
     /* 518306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 518330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518350 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518355 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518387 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 518397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 518402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518428 */     GIR_RootConstrainSelectedInstOperands,
     /* 518429 */     // GIR_Coverage, 11699,
     /* 518429 */     GIR_EraseRootFromParent_Done,
     /* 518430 */   // Label 6967: @518430
     /* 518430 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(518559), // Rule ID 11700 //
     /* 518435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 518459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518502 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518516 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518557 */     GIR_RootConstrainSelectedInstOperands,
     /* 518558 */     // GIR_Coverage, 11700,
     /* 518558 */     GIR_EraseRootFromParent_Done,
     /* 518559 */   // Label 6968: @518559
     /* 518559 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(518688), // Rule ID 11701 //
     /* 518564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 518588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 518592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 518604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518608 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518608 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 518613 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 518618 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518638 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518645 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 518655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 518660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 518665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 518670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518686 */     GIR_RootConstrainSelectedInstOperands,
     /* 518687 */     // GIR_Coverage, 11701,
     /* 518687 */     GIR_EraseRootFromParent_Done,
     /* 518688 */   // Label 6969: @518688
     /* 518688 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(518817), // Rule ID 11707 //
     /* 518693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 518733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518737 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518737 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518742 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518774 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 518784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 518789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518815 */     GIR_RootConstrainSelectedInstOperands,
     /* 518816 */     // GIR_Coverage, 11707,
     /* 518816 */     GIR_EraseRootFromParent_Done,
     /* 518817 */   // Label 6970: @518817
     /* 518817 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(518946), // Rule ID 11708 //
     /* 518822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 518862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518866 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 518866 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 518871 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 518876 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 518880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 518882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 518903 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 518903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 518906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 518908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 518913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 518918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 518923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 518928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 518933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 518938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 518944 */     GIR_RootConstrainSelectedInstOperands,
     /* 518945 */     // GIR_Coverage, 11708,
     /* 518945 */     GIR_EraseRootFromParent_Done,
     /* 518946 */   // Label 6971: @518946
     /* 518946 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(519075), // Rule ID 11711 //
     /* 518951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 518955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 518959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 518963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 518967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 518971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 518975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 518979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 518983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 518987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 518991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 518995 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 518995 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519000 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519005 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519032 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 519052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 519057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519073 */     GIR_RootConstrainSelectedInstOperands,
     /* 519074 */     // GIR_Coverage, 11711,
     /* 519074 */     GIR_EraseRootFromParent_Done,
     /* 519075 */   // Label 6972: @519075
     /* 519075 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(519204), // Rule ID 11712 //
     /* 519080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 519104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 519120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519161 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 519181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 519186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519202 */     GIR_RootConstrainSelectedInstOperands,
     /* 519203 */     // GIR_Coverage, 11712,
     /* 519203 */     GIR_EraseRootFromParent_Done,
     /* 519204 */   // Label 6973: @519204
     /* 519204 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(519333), // Rule ID 11692 //
     /* 519209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 519233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 519249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519253 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519253 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519258 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519283 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519290 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 519300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 519305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519331 */     GIR_RootConstrainSelectedInstOperands,
     /* 519332 */     // GIR_Coverage, 11692,
     /* 519332 */     GIR_EraseRootFromParent_Done,
     /* 519333 */   // Label 6974: @519333
     /* 519333 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(519462), // Rule ID 11693 //
     /* 519338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 519362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 519378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519382 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519382 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519387 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519419 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 519429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 519434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519460 */     GIR_RootConstrainSelectedInstOperands,
     /* 519461 */     // GIR_Coverage, 11693,
     /* 519461 */     GIR_EraseRootFromParent_Done,
     /* 519462 */   // Label 6975: @519462
     /* 519462 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(519591), // Rule ID 11696 //
     /* 519467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 519491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 519507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519511 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519516 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519541 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519548 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 519568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 519573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519589 */     GIR_RootConstrainSelectedInstOperands,
     /* 519590 */     // GIR_Coverage, 11696,
     /* 519590 */     GIR_EraseRootFromParent_Done,
     /* 519591 */   // Label 6976: @519591
     /* 519591 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(519720), // Rule ID 11697 //
     /* 519596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 519620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 519636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 519640 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519645 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519670 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519677 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 519687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 519692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 519697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 519702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519718 */     GIR_RootConstrainSelectedInstOperands,
     /* 519719 */     // GIR_Coverage, 11697,
     /* 519719 */     GIR_EraseRootFromParent_Done,
     /* 519720 */   // Label 6977: @519720
     /* 519720 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(519849), // Rule ID 7734 //
     /* 519725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 519749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 519765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519806 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 519816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 519821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519847 */     GIR_RootConstrainSelectedInstOperands,
     /* 519848 */     // GIR_Coverage, 7734,
     /* 519848 */     GIR_EraseRootFromParent_Done,
     /* 519849 */   // Label 6978: @519849
     /* 519849 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(519978), // Rule ID 11706 //
     /* 519854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 519874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 519878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 519882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 519886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 519890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 519894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 519898 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 519898 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 519903 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 519903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 519908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 519912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 519914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519928 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 519935 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 519935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 519938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 519940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 519945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 519950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 519955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 519960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 519965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 519970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 519976 */     GIR_RootConstrainSelectedInstOperands,
     /* 519977 */     // GIR_Coverage, 11706,
     /* 519977 */     GIR_EraseRootFromParent_Done,
     /* 519978 */   // Label 6979: @519978
     /* 519978 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(520107), // Rule ID 11709 //
     /* 519983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 519987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 519991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 519995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 519999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 520023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520027 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520032 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520064 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 520084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 520089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520105 */     GIR_RootConstrainSelectedInstOperands,
     /* 520106 */     // GIR_Coverage, 11709,
     /* 520106 */     GIR_EraseRootFromParent_Done,
     /* 520107 */   // Label 6980: @520107
     /* 520107 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(520236), // Rule ID 11710 //
     /* 520112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 520152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520156 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520156 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520161 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520193 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 520213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 520218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520234 */     GIR_RootConstrainSelectedInstOperands,
     /* 520235 */     // GIR_Coverage, 11710,
     /* 520235 */     GIR_EraseRootFromParent_Done,
     /* 520236 */   // Label 6981: @520236
     /* 520236 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(520365), // Rule ID 7733 //
     /* 520241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 520281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520285 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520285 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520290 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520295 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520322 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520363 */     GIR_RootConstrainSelectedInstOperands,
     /* 520364 */     // GIR_Coverage, 7733,
     /* 520364 */     GIR_EraseRootFromParent_Done,
     /* 520365 */   // Label 6982: @520365
     /* 520365 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(520494), // Rule ID 11691 //
     /* 520370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 520410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520451 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520492 */     GIR_RootConstrainSelectedInstOperands,
     /* 520493 */     // GIR_Coverage, 11691,
     /* 520493 */     GIR_EraseRootFromParent_Done,
     /* 520494 */   // Label 6983: @520494
     /* 520494 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(520623), // Rule ID 11694 //
     /* 520499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 520539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520543 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520543 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520548 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520553 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520573 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520580 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 520600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 520605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520621 */     GIR_RootConstrainSelectedInstOperands,
     /* 520622 */     // GIR_Coverage, 11694,
     /* 520622 */     GIR_EraseRootFromParent_Done,
     /* 520623 */   // Label 6984: @520623
     /* 520623 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(520752), // Rule ID 11695 //
     /* 520628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 520656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 520668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 520672 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520677 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520682 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520709 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 520719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 520724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 520729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 520734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520750 */     GIR_RootConstrainSelectedInstOperands,
     /* 520751 */     // GIR_Coverage, 11695,
     /* 520751 */     GIR_EraseRootFromParent_Done,
     /* 520752 */   // Label 6985: @520752
     /* 520752 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(520881), // Rule ID 11677 //
     /* 520757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 520797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520801 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520806 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520831 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520838 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 520873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 520879 */     GIR_RootConstrainSelectedInstOperands,
     /* 520880 */     // GIR_Coverage, 11677,
     /* 520880 */     GIR_EraseRootFromParent_Done,
     /* 520881 */   // Label 6986: @520881
     /* 520881 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(521010), // Rule ID 11678 //
     /* 520886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 520890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 520894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 520902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 520906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 520910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 520914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 520918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 520922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 520926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 520930 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 520930 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 520935 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 520935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 520940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 520944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 520946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 520967 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 520967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 520970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 520972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 520977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 520982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 520987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 520992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 520997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521008 */     GIR_RootConstrainSelectedInstOperands,
     /* 521009 */     // GIR_Coverage, 11678,
     /* 521009 */     GIR_EraseRootFromParent_Done,
     /* 521010 */   // Label 6987: @521010
     /* 521010 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(521139), // Rule ID 11681 //
     /* 521015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 521055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521096 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521137 */     GIR_RootConstrainSelectedInstOperands,
     /* 521138 */     // GIR_Coverage, 11681,
     /* 521138 */     GIR_EraseRootFromParent_Done,
     /* 521139 */   // Label 6988: @521139
     /* 521139 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(521268), // Rule ID 11682 //
     /* 521144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 521184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521188 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521188 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521193 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521225 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521266 */     GIR_RootConstrainSelectedInstOperands,
     /* 521267 */     // GIR_Coverage, 11682,
     /* 521267 */     GIR_EraseRootFromParent_Done,
     /* 521268 */   // Label 6989: @521268
     /* 521268 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(521397), // Rule ID 11662 //
     /* 521273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521309 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 521313 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521317 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521322 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521354 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521395 */     GIR_RootConstrainSelectedInstOperands,
     /* 521396 */     // GIR_Coverage, 11662,
     /* 521396 */     GIR_EraseRootFromParent_Done,
     /* 521397 */   // Label 6990: @521397
     /* 521397 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(521526), // Rule ID 11663 //
     /* 521402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 521442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521446 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521451 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521483 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521524 */     GIR_RootConstrainSelectedInstOperands,
     /* 521525 */     // GIR_Coverage, 11663,
     /* 521525 */     GIR_EraseRootFromParent_Done,
     /* 521526 */   // Label 6991: @521526
     /* 521526 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(521655), // Rule ID 11666 //
     /* 521531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 521571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521575 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521580 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521589 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521612 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521653 */     GIR_RootConstrainSelectedInstOperands,
     /* 521654 */     // GIR_Coverage, 11666,
     /* 521654 */     GIR_EraseRootFromParent_Done,
     /* 521655 */   // Label 6992: @521655
     /* 521655 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(521784), // Rule ID 11667 //
     /* 521660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 521700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 521704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521741 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 521751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 521756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 521761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 521766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521782 */     GIR_RootConstrainSelectedInstOperands,
     /* 521783 */     // GIR_Coverage, 11667,
     /* 521783 */     GIR_EraseRootFromParent_Done,
     /* 521784 */   // Label 6993: @521784
     /* 521784 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(521913), // Rule ID 7732 //
     /* 521789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 521829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521833 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521838 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521863 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521870 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 521873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 521875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 521880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 521885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 521890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 521895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 521900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 521905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 521911 */     GIR_RootConstrainSelectedInstOperands,
     /* 521912 */     // GIR_Coverage, 7732,
     /* 521912 */     GIR_EraseRootFromParent_Done,
     /* 521913 */   // Label 6994: @521913
     /* 521913 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(522042), // Rule ID 11676 //
     /* 521918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 521922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 521926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 521934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 521938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 521942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 521946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 521950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 521954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 521958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 521962 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 521962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 521967 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 521967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 521972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 521976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 521978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521992 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 521999 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 521999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522040 */     GIR_RootConstrainSelectedInstOperands,
     /* 522041 */     // GIR_Coverage, 11676,
     /* 522041 */     GIR_EraseRootFromParent_Done,
     /* 522042 */   // Label 6995: @522042
     /* 522042 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(522171), // Rule ID 11679 //
     /* 522047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 522071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 522087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 522091 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522091 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 522096 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 522101 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522128 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522169 */     GIR_RootConstrainSelectedInstOperands,
     /* 522170 */     // GIR_Coverage, 11679,
     /* 522170 */     GIR_EraseRootFromParent_Done,
     /* 522171 */   // Label 6996: @522171
     /* 522171 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(522300), // Rule ID 11680 //
     /* 522176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 522200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 522216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 522220 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 522225 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 522230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522257 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522298 */     GIR_RootConstrainSelectedInstOperands,
     /* 522299 */     // GIR_Coverage, 11680,
     /* 522299 */     GIR_EraseRootFromParent_Done,
     /* 522300 */   // Label 6997: @522300
     /* 522300 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(522429), // Rule ID 7731 //
     /* 522305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 522329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 522345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 522354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 522359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522386 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522427 */     GIR_RootConstrainSelectedInstOperands,
     /* 522428 */     // GIR_Coverage, 7731,
     /* 522428 */     GIR_EraseRootFromParent_Done,
     /* 522429 */   // Label 6998: @522429
     /* 522429 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(522558), // Rule ID 11661 //
     /* 522434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 522458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 522474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522478 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522478 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 522483 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 522488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522515 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 522525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 522530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 522535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 522540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522556 */     GIR_RootConstrainSelectedInstOperands,
     /* 522557 */     // GIR_Coverage, 11661,
     /* 522557 */     GIR_EraseRootFromParent_Done,
     /* 522558 */   // Label 6999: @522558
     /* 522558 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(522687), // Rule ID 11664 //
     /* 522563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 522587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 522603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522607 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522607 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 522612 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 522617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522644 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522685 */     GIR_RootConstrainSelectedInstOperands,
     /* 522686 */     // GIR_Coverage, 11664,
     /* 522686 */     GIR_EraseRootFromParent_Done,
     /* 522687 */   // Label 7000: @522687
     /* 522687 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(522816), // Rule ID 11665 //
     /* 522692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 522716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 522732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 522736 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522736 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 522741 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 522746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522752 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522773 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 522793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 522798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 522803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 522808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522814 */     GIR_RootConstrainSelectedInstOperands,
     /* 522815 */     // GIR_Coverage, 11665,
     /* 522815 */     GIR_EraseRootFromParent_Done,
     /* 522816 */   // Label 7001: @522816
     /* 522816 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(522945), // Rule ID 11747 //
     /* 522821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 522845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 522849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522865 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 522870 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 522879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 522881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522895 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 522902 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 522902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 522905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 522907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 522912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 522917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 522922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 522927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 522932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 522937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 522943 */     GIR_RootConstrainSelectedInstOperands,
     /* 522944 */     // GIR_Coverage, 11747,
     /* 522944 */     GIR_EraseRootFromParent_Done,
     /* 522945 */   // Label 7002: @522945
     /* 522945 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(523074), // Rule ID 11748 //
     /* 522950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 522954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 522958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 522962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 522966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 522970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 522974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 522978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 522982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 522986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 522990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 522994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 522994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 522999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 522999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523031 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523072 */     GIR_RootConstrainSelectedInstOperands,
     /* 523073 */     // GIR_Coverage, 11748,
     /* 523073 */     GIR_EraseRootFromParent_Done,
     /* 523074 */   // Label 7003: @523074
     /* 523074 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(523203), // Rule ID 11749 //
     /* 523079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 523103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523111 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 523119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523123 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523123 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 523128 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523139 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523160 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 523170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 523175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523201 */     GIR_RootConstrainSelectedInstOperands,
     /* 523202 */     // GIR_Coverage, 11749,
     /* 523202 */     GIR_EraseRootFromParent_Done,
     /* 523203 */   // Label 7004: @523203
     /* 523203 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(523332), // Rule ID 11750 //
     /* 523208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 523232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 523248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523252 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523252 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523257 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 523262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523289 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 523299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 523304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523330 */     GIR_RootConstrainSelectedInstOperands,
     /* 523331 */     // GIR_Coverage, 11750,
     /* 523331 */     GIR_EraseRootFromParent_Done,
     /* 523332 */   // Label 7005: @523332
     /* 523332 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(523461), // Rule ID 11687 //
     /* 523337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 523361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 523377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523381 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523386 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 523391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523418 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523459 */     GIR_RootConstrainSelectedInstOperands,
     /* 523460 */     // GIR_Coverage, 11687,
     /* 523460 */     GIR_EraseRootFromParent_Done,
     /* 523461 */   // Label 7006: @523461
     /* 523461 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(523590), // Rule ID 11688 //
     /* 523466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 523490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 523506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523510 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 523515 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523547 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523588 */     GIR_RootConstrainSelectedInstOperands,
     /* 523589 */     // GIR_Coverage, 11688,
     /* 523589 */     GIR_EraseRootFromParent_Done,
     /* 523590 */   // Label 7007: @523590
     /* 523590 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(523719), // Rule ID 11689 //
     /* 523595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 523619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 523635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 523644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523676 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 523686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 523691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523717 */     GIR_RootConstrainSelectedInstOperands,
     /* 523718 */     // GIR_Coverage, 11689,
     /* 523718 */     GIR_EraseRootFromParent_Done,
     /* 523719 */   // Label 7008: @523719
     /* 523719 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(523848), // Rule ID 11690 //
     /* 523724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 523748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 523752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 523764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523768 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523768 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523773 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 523778 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523805 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 523815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 523820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 523825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 523830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523846 */     GIR_RootConstrainSelectedInstOperands,
     /* 523847 */     // GIR_Coverage, 11690,
     /* 523847 */     GIR_EraseRootFromParent_Done,
     /* 523848 */   // Label 7009: @523848
     /* 523848 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(523977), // Rule ID 11732 //
     /* 523853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 523873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 523877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 523881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 523885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 523889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 523893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 523897 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 523897 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 523902 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 523902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 523907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 523911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 523913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 523934 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 523934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 523937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 523939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 523944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 523949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 523954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 523959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 523964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 523969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 523975 */     GIR_RootConstrainSelectedInstOperands,
     /* 523976 */     // GIR_Coverage, 11732,
     /* 523976 */     GIR_EraseRootFromParent_Done,
     /* 523977 */   // Label 7010: @523977
     /* 523977 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(524106), // Rule ID 11733 //
     /* 523982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 523986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 523990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 523994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 523998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 524006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 524010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524026 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524031 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524063 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 524083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 524088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 524093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 524098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524104 */     GIR_RootConstrainSelectedInstOperands,
     /* 524105 */     // GIR_Coverage, 11733,
     /* 524105 */     GIR_EraseRootFromParent_Done,
     /* 524106 */   // Label 7011: @524106
     /* 524106 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(524235), // Rule ID 11734 //
     /* 524111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 524127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 524135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 524139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524155 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524155 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524160 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524165 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524192 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 524202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 524207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 524222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 524227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524233 */     GIR_RootConstrainSelectedInstOperands,
     /* 524234 */     // GIR_Coverage, 11734,
     /* 524234 */     GIR_EraseRootFromParent_Done,
     /* 524235 */   // Label 7012: @524235
     /* 524235 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(524364), // Rule ID 11735 //
     /* 524240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 524256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 524264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 524268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524321 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 524331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 524336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 524351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 524356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524362 */     GIR_RootConstrainSelectedInstOperands,
     /* 524363 */     // GIR_Coverage, 11735,
     /* 524363 */     GIR_EraseRootFromParent_Done,
     /* 524364 */   // Label 7013: @524364
     /* 524364 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(524493), // Rule ID 11672 //
     /* 524369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 524385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 524393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 524397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524413 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524418 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524423 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524436 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524450 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 524470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 524475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 524480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 524485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524491 */     GIR_RootConstrainSelectedInstOperands,
     /* 524492 */     // GIR_Coverage, 11672,
     /* 524492 */     GIR_EraseRootFromParent_Done,
     /* 524493 */   // Label 7014: @524493
     /* 524493 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(524622), // Rule ID 11673 //
     /* 524498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 524514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 524522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 524526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524542 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524547 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524552 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524565 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524579 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 524589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 524594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 524599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 524604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 524609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 524614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524620 */     GIR_RootConstrainSelectedInstOperands,
     /* 524621 */     // GIR_Coverage, 11673,
     /* 524621 */     GIR_EraseRootFromParent_Done,
     /* 524622 */   // Label 7015: @524622
     /* 524622 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(524751), // Rule ID 11674 //
     /* 524627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 524643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 524651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 524655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524671 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524676 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524708 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 524718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 524723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 524738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 524743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524749 */     GIR_RootConstrainSelectedInstOperands,
     /* 524750 */     // GIR_Coverage, 11674,
     /* 524750 */     GIR_EraseRootFromParent_Done,
     /* 524751 */   // Label 7016: @524751
     /* 524751 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(524880), // Rule ID 11675 //
     /* 524756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 524772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 524780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 524784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524800 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524800 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524805 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524810 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524816 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524837 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 524847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 524852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 524867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 524872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 524878 */     GIR_RootConstrainSelectedInstOperands,
     /* 524879 */     // GIR_Coverage, 11675,
     /* 524879 */     GIR_EraseRootFromParent_Done,
     /* 524880 */   // Label 7017: @524880
     /* 524880 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(525009), // Rule ID 11743 //
     /* 524885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 524889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 524893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 524897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 524901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 524905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 524909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 524913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 524917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 524921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 524925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 524929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 524929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 524934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 524934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 524939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 524943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 524945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 524966 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 524966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 524969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 524971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 524976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 524981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 524986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 524991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 524996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525007 */     GIR_RootConstrainSelectedInstOperands,
     /* 525008 */     // GIR_Coverage, 11743,
     /* 525008 */     GIR_EraseRootFromParent_Done,
     /* 525009 */   // Label 7018: @525009
     /* 525009 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(525138), // Rule ID 11744 //
     /* 525014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525058 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525058 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525063 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525068 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525095 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 525098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525136 */     GIR_RootConstrainSelectedInstOperands,
     /* 525137 */     // GIR_Coverage, 11744,
     /* 525137 */     GIR_EraseRootFromParent_Done,
     /* 525138 */   // Label 7019: @525138
     /* 525138 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(525267), // Rule ID 11745 //
     /* 525143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525187 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525192 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525197 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525224 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 525227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525265 */     GIR_RootConstrainSelectedInstOperands,
     /* 525266 */     // GIR_Coverage, 11745,
     /* 525266 */     GIR_EraseRootFromParent_Done,
     /* 525267 */   // Label 7020: @525267
     /* 525267 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(525396), // Rule ID 11746 //
     /* 525272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525316 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525321 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525326 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525332 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525353 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 525356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525394 */     GIR_RootConstrainSelectedInstOperands,
     /* 525395 */     // GIR_Coverage, 11746,
     /* 525395 */     GIR_EraseRootFromParent_Done,
     /* 525396 */   // Label 7021: @525396
     /* 525396 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(525525), // Rule ID 11683 //
     /* 525401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525445 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525445 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525450 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525455 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525468 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525482 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 525485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525523 */     GIR_RootConstrainSelectedInstOperands,
     /* 525524 */     // GIR_Coverage, 11683,
     /* 525524 */     GIR_EraseRootFromParent_Done,
     /* 525525 */   // Label 7022: @525525
     /* 525525 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(525654), // Rule ID 11684 //
     /* 525530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525611 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 525614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 525621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 525626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 525631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 525636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525652 */     GIR_RootConstrainSelectedInstOperands,
     /* 525653 */     // GIR_Coverage, 11684,
     /* 525653 */     GIR_EraseRootFromParent_Done,
     /* 525654 */   // Label 7023: @525654
     /* 525654 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(525783), // Rule ID 11685 //
     /* 525659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525703 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525708 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525713 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525740 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 525743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525781 */     GIR_RootConstrainSelectedInstOperands,
     /* 525782 */     // GIR_Coverage, 11685,
     /* 525782 */     GIR_EraseRootFromParent_Done,
     /* 525783 */   // Label 7024: @525783
     /* 525783 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(525912), // Rule ID 11686 //
     /* 525788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 525816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525832 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525837 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525842 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525869 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 525872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 525874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 525879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 525884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 525889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 525894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 525899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 525904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 525910 */     GIR_RootConstrainSelectedInstOperands,
     /* 525911 */     // GIR_Coverage, 11686,
     /* 525911 */     GIR_EraseRootFromParent_Done,
     /* 525912 */   // Label 7025: @525912
     /* 525912 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(526041), // Rule ID 11728 //
     /* 525917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 525921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 525925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 525929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 525933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 525937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 525941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 525945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 525949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 525953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 525957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 525961 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 525961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 525966 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 525966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 525971 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 525975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 525977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 525998 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 525998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526039 */     GIR_RootConstrainSelectedInstOperands,
     /* 526040 */     // GIR_Coverage, 11728,
     /* 526040 */     GIR_EraseRootFromParent_Done,
     /* 526041 */   // Label 7026: @526041
     /* 526041 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(526170), // Rule ID 11729 //
     /* 526046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 526066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 526074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 526086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 526090 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526090 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 526095 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 526100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 526104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526127 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526168 */     GIR_RootConstrainSelectedInstOperands,
     /* 526169 */     // GIR_Coverage, 11729,
     /* 526169 */     GIR_EraseRootFromParent_Done,
     /* 526170 */   // Label 7027: @526170
     /* 526170 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(526299), // Rule ID 11730 //
     /* 526175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 526195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 526203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 526215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 526219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 526224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 526229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 526233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526256 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526297 */     GIR_RootConstrainSelectedInstOperands,
     /* 526298 */     // GIR_Coverage, 11730,
     /* 526298 */     GIR_EraseRootFromParent_Done,
     /* 526299 */   // Label 7028: @526299
     /* 526299 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(526428), // Rule ID 11731 //
     /* 526304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 526324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 526332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 526344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 526348 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 526353 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 526358 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 526362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526385 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526426 */     GIR_RootConstrainSelectedInstOperands,
     /* 526427 */     // GIR_Coverage, 11731,
     /* 526427 */     GIR_EraseRootFromParent_Done,
     /* 526428 */   // Label 7029: @526428
     /* 526428 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(526557), // Rule ID 11668 //
     /* 526433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 526453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 526461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 526473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526477 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526477 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 526482 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 526487 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 526491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526514 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526555 */     GIR_RootConstrainSelectedInstOperands,
     /* 526556 */     // GIR_Coverage, 11668,
     /* 526556 */     GIR_EraseRootFromParent_Done,
     /* 526557 */   // Label 7030: @526557
     /* 526557 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(526686), // Rule ID 11669 //
     /* 526562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 526582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 526590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 526602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526606 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526606 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 526611 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 526616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 526620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526643 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 526653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 526658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 526663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 526668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526684 */     GIR_RootConstrainSelectedInstOperands,
     /* 526685 */     // GIR_Coverage, 11669,
     /* 526685 */     GIR_EraseRootFromParent_Done,
     /* 526686 */   // Label 7031: @526686
     /* 526686 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(526815), // Rule ID 11670 //
     /* 526691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 526711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 526719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 526731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526735 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 526740 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 526745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 526749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526772 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526813 */     GIR_RootConstrainSelectedInstOperands,
     /* 526814 */     // GIR_Coverage, 11670,
     /* 526814 */     GIR_EraseRootFromParent_Done,
     /* 526815 */   // Label 7032: @526815
     /* 526815 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(526944), // Rule ID 11671 //
     /* 526820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 526828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 526840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 526848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 526860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 526864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 526864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 526869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 526869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 526874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
     /* 526878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 526880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526901 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 526901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 526904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 526906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 526911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 526916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 526921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 526926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 526931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 526936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 526942 */     GIR_RootConstrainSelectedInstOperands,
     /* 526943 */     // GIR_Coverage, 11671,
     /* 526943 */     GIR_EraseRootFromParent_Done,
     /* 526944 */   // Label 7033: @526944
     /* 526944 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(527056), // Rule ID 13388 //
     /* 526949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 526952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 526956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 526960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 526964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 526968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 526972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 526976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 526980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 526984 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 526986 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 526990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 526992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 526999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527013 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 527033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 527038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 527043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 527048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527054 */     GIR_RootConstrainSelectedInstOperands,
     /* 527055 */     // GIR_Coverage, 13388,
     /* 527055 */     GIR_EraseRootFromParent_Done,
     /* 527056 */   // Label 7034: @527056
     /* 527056 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(527168), // Rule ID 13387 //
     /* 527061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 527064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 527072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 527076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 527080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 527084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 527092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 527096 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 527098 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 527102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 527104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527111 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527125 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 527145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 527150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 527155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 527160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527166 */     GIR_RootConstrainSelectedInstOperands,
     /* 527167 */     // GIR_Coverage, 13387,
     /* 527167 */     GIR_EraseRootFromParent_Done,
     /* 527168 */   // Label 7035: @527168
     /* 527168 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(527280), // Rule ID 7862 //
     /* 527173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 527176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 527188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 527192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 527196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 527204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 527208 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 527210 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 527214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 527216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527237 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527278 */     GIR_RootConstrainSelectedInstOperands,
     /* 527279 */     // GIR_Coverage, 7862,
     /* 527279 */     GIR_EraseRootFromParent_Done,
     /* 527280 */   // Label 7036: @527280
     /* 527280 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(527392), // Rule ID 7861 //
     /* 527285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 527288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 527300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 527304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 527308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 527316 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 527320 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 527322 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 527326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 527328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527342 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527349 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527390 */     GIR_RootConstrainSelectedInstOperands,
     /* 527391 */     // GIR_Coverage, 7861,
     /* 527391 */     GIR_EraseRootFromParent_Done,
     /* 527392 */   // Label 7037: @527392
     /* 527392 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(527488), // Rule ID 13380 //
     /* 527397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 527400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 527408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 527416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 527420 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 527422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 527424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527445 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 527465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 527470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 527475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 527480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527486 */     GIR_RootConstrainSelectedInstOperands,
     /* 527487 */     // GIR_Coverage, 13380,
     /* 527487 */     GIR_EraseRootFromParent_Done,
     /* 527488 */   // Label 7038: @527488
     /* 527488 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(527584), // Rule ID 13379 //
     /* 527493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 527496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 527504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 527512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 527516 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 527518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 527520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527541 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 527551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 527561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 527566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 527571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 527576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527582 */     GIR_RootConstrainSelectedInstOperands,
     /* 527583 */     // GIR_Coverage, 13379,
     /* 527583 */     GIR_EraseRootFromParent_Done,
     /* 527584 */   // Label 7039: @527584
     /* 527584 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(527680), // Rule ID 7854 //
     /* 527589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 527592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 527604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 527608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 527612 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 527614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 527616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527637 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527678 */     GIR_RootConstrainSelectedInstOperands,
     /* 527679 */     // GIR_Coverage, 7854,
     /* 527679 */     GIR_EraseRootFromParent_Done,
     /* 527680 */   // Label 7040: @527680
     /* 527680 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(527776), // Rule ID 7853 //
     /* 527685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 527688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 527696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 527700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 527704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 527708 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 527710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 527712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527733 */     // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 527733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
     /* 527736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 527743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 527753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 527763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 527768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 527774 */     GIR_RootConstrainSelectedInstOperands,
     /* 527775 */     // GIR_Coverage, 7853,
     /* 527775 */     GIR_EraseRootFromParent_Done,
     /* 527776 */   // Label 7041: @527776
     /* 527776 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(527811), // Rule ID 90 //
     /* 527781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 527784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 527788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 527792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 527796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13744),
     /* 527800 */     // (fminnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13744>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 527800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
     /* 527805 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 527809 */     GIR_RootConstrainSelectedInstOperands,
     /* 527810 */     // GIR_Coverage, 90,
     /* 527810 */     GIR_Done,
     /* 527811 */   // Label 7042: @527811
     /* 527811 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(527871), // Rule ID 801 //
     /* 527816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 527827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527834 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 527834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 527837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 527844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 527854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 527864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 527869 */     GIR_RootConstrainSelectedInstOperands,
     /* 527870 */     // GIR_Coverage, 801,
     /* 527870 */     GIR_EraseRootFromParent_Done,
     /* 527871 */   // Label 7043: @527871
     /* 527871 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(527931), // Rule ID 8555 //
     /* 527876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 527880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 527894 */     // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 527894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
     /* 527897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 527904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 527909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 527914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 527919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 527924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 527929 */     GIR_RootConstrainSelectedInstOperands,
     /* 527930 */     // GIR_Coverage, 8555,
     /* 527930 */     GIR_EraseRootFromParent_Done,
     /* 527931 */   // Label 7044: @527931
     /* 527931 */   GIM_Reject,
     /* 527932 */ // Label 6905: @527932
     /* 527932 */ GIM_Reject,
     /* 527933 */ // Label 6495: @527933
     /* 527933 */ GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(528185),
     /* 527938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 527941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 527944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 527948 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(528007), // Rule ID 916 //
     /* 527953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 527956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 527963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 527970 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 527970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 527973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 527975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 527980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 527985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 527990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 527995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 528000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 528005 */     GIR_RootConstrainSelectedInstOperands,
     /* 528006 */     // GIR_Coverage, 916,
     /* 528006 */     GIR_EraseRootFromParent_Done,
     /* 528007 */   // Label 7046: @528007
     /* 528007 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(528066), // Rule ID 935 //
     /* 528012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 528015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 528022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528029 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 528029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 528032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 528039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 528049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 528059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 528064 */     GIR_RootConstrainSelectedInstOperands,
     /* 528065 */     // GIR_Coverage, 935,
     /* 528065 */     GIR_EraseRootFromParent_Done,
     /* 528066 */   // Label 7047: @528066
     /* 528066 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(528125), // Rule ID 8581 //
     /* 528071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 528074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 528088 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 528088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
     /* 528091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 528098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 528108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 528118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 528123 */     GIR_RootConstrainSelectedInstOperands,
     /* 528124 */     // GIR_Coverage, 8581,
     /* 528124 */     GIR_EraseRootFromParent_Done,
     /* 528125 */   // Label 7048: @528125
     /* 528125 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(528184), // Rule ID 8595 //
     /* 528130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 528133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 528147 */     // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 528147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 528150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 528157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 528167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 528177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 528182 */     GIR_RootConstrainSelectedInstOperands,
     /* 528183 */     // GIR_Coverage, 8595,
     /* 528183 */     GIR_EraseRootFromParent_Done,
     /* 528184 */   // Label 7049: @528184
     /* 528184 */   GIM_Reject,
     /* 528185 */ // Label 7045: @528185
     /* 528185 */ GIM_Reject,
     /* 528186 */ // Label 6496: @528186
     /* 528186 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(528257), // Rule ID 1097 //
     /* 528191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 528194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 528197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528201 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 528208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 528215 */   // (fminnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 528215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
     /* 528218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 528225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 528235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528255 */   GIR_RootConstrainSelectedInstOperands,
     /* 528256 */   // GIR_Coverage, 1097,
     /* 528256 */   GIR_EraseRootFromParent_Done,
     /* 528257 */ // Label 7050: @528257
     /* 528257 */ GIM_Reject,
     /* 528258 */ // Label 6497: @528258
     /* 528258 */ GIM_Reject,
     /* 528259 */ // Label 83: @528259
     /* 528259 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7055*/ GIMT_Encode4(600037),
     /* 528270 */ /*GILLT_s16*//*Label 7051*/ GIMT_Encode4(528286),
     /* 528274 */ /*GILLT_s32*//*Label 7052*/ GIMT_Encode4(582200),
     /* 528278 */ /*GILLT_s64*//*Label 7053*/ GIMT_Encode4(599712),
     /* 528282 */ /*GILLT_v2s16*//*Label 7054*/ GIMT_Encode4(599965),
     /* 528286 */ // Label 7051: @528286
     /* 528286 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(582199),
     /* 528291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 528294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 528297 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(528432), // Rule ID 12037 //
     /* 528302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 528305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 528345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528386 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 528389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528430 */     GIR_RootConstrainSelectedInstOperands,
     /* 528431 */     // GIR_Coverage, 12037,
     /* 528431 */     GIR_EraseRootFromParent_Done,
     /* 528432 */   // Label 7057: @528432
     /* 528432 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(528567), // Rule ID 12038 //
     /* 528437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 528440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 528480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528521 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 528524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528565 */     GIR_RootConstrainSelectedInstOperands,
     /* 528566 */     // GIR_Coverage, 12038,
     /* 528566 */     GIR_EraseRootFromParent_Done,
     /* 528567 */   // Label 7058: @528567
     /* 528567 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(528702), // Rule ID 12041 //
     /* 528572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 528575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 528615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528624 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528656 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 528659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528700 */     GIR_RootConstrainSelectedInstOperands,
     /* 528701 */     // GIR_Coverage, 12041,
     /* 528701 */     GIR_EraseRootFromParent_Done,
     /* 528702 */   // Label 7059: @528702
     /* 528702 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(528837), // Rule ID 12042 //
     /* 528707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 528710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 528714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 528750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528791 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 528794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 528801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 528806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 528811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 528816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528835 */     GIR_RootConstrainSelectedInstOperands,
     /* 528836 */     // GIR_Coverage, 12042,
     /* 528836 */     GIR_EraseRootFromParent_Done,
     /* 528837 */   // Label 7060: @528837
     /* 528837 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(528972), // Rule ID 12517 //
     /* 528842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 528865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 528869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 528877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 528881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 528885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 528889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 528889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 528894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 528894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 528899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 528903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 528905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 528926 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 528926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 528929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 528931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 528936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 528941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 528946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 528951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 528956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 528961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 528970 */     GIR_RootConstrainSelectedInstOperands,
     /* 528971 */     // GIR_Coverage, 12517,
     /* 528971 */     GIR_EraseRootFromParent_Done,
     /* 528972 */   // Label 7061: @528972
     /* 528972 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(529107), // Rule ID 12518 //
     /* 528977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 528980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 528984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 528988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 528992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 528996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 529024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529061 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529105 */     GIR_RootConstrainSelectedInstOperands,
     /* 529106 */     // GIR_Coverage, 12518,
     /* 529106 */     GIR_EraseRootFromParent_Done,
     /* 529107 */   // Label 7062: @529107
     /* 529107 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(529242), // Rule ID 12521 //
     /* 529112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 529159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529196 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529240 */     GIR_RootConstrainSelectedInstOperands,
     /* 529241 */     // GIR_Coverage, 12521,
     /* 529241 */     GIR_EraseRootFromParent_Done,
     /* 529242 */   // Label 7063: @529242
     /* 529242 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(529377), // Rule ID 12522 //
     /* 529247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 529250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 529254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 529294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529299 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529331 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 529334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529375 */     GIR_RootConstrainSelectedInstOperands,
     /* 529376 */     // GIR_Coverage, 12522,
     /* 529376 */     GIR_EraseRootFromParent_Done,
     /* 529377 */   // Label 7064: @529377
     /* 529377 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(529512), // Rule ID 12997 //
     /* 529382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 529385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 529429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529434 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529466 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 529469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529510 */     GIR_RootConstrainSelectedInstOperands,
     /* 529511 */     // GIR_Coverage, 12997,
     /* 529511 */     GIR_EraseRootFromParent_Done,
     /* 529512 */   // Label 7065: @529512
     /* 529512 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(529647), // Rule ID 12998 //
     /* 529517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 529520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 529564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529601 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 529604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 529611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 529616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 529621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 529626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529645 */     GIR_RootConstrainSelectedInstOperands,
     /* 529646 */     // GIR_Coverage, 12998,
     /* 529646 */     GIR_EraseRootFromParent_Done,
     /* 529647 */   // Label 7066: @529647
     /* 529647 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(529782), // Rule ID 13001 //
     /* 529652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 529655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 529699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529736 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 529739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529780 */     GIR_RootConstrainSelectedInstOperands,
     /* 529781 */     // GIR_Coverage, 13001,
     /* 529781 */     GIR_EraseRootFromParent_Done,
     /* 529782 */   // Label 7067: @529782
     /* 529782 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(529917), // Rule ID 13002 //
     /* 529787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 529790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 529834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529871 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 529871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 529874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 529876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 529881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 529886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 529891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 529896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 529901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 529906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 529915 */     GIR_RootConstrainSelectedInstOperands,
     /* 529916 */     // GIR_Coverage, 13002,
     /* 529916 */     GIR_EraseRootFromParent_Done,
     /* 529917 */   // Label 7068: @529917
     /* 529917 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(530052), // Rule ID 12022 //
     /* 529922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 529925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 529929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 529933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 529941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 529945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 529949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 529953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 529957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 529961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 529965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 529969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 529969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 529974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 529974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 529979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 529983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 529985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 529999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530006 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530050 */     GIR_RootConstrainSelectedInstOperands,
     /* 530051 */     // GIR_Coverage, 12022,
     /* 530051 */     GIR_EraseRootFromParent_Done,
     /* 530052 */   // Label 7069: @530052
     /* 530052 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(530187), // Rule ID 12023 //
     /* 530057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530141 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530185 */     GIR_RootConstrainSelectedInstOperands,
     /* 530186 */     // GIR_Coverage, 12023,
     /* 530186 */     GIR_EraseRootFromParent_Done,
     /* 530187 */   // Label 7070: @530187
     /* 530187 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(530322), // Rule ID 12026 //
     /* 530192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530276 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530320 */     GIR_RootConstrainSelectedInstOperands,
     /* 530321 */     // GIR_Coverage, 12026,
     /* 530321 */     GIR_EraseRootFromParent_Done,
     /* 530322 */   // Label 7071: @530322
     /* 530322 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(530457), // Rule ID 12027 //
     /* 530327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 530330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 530334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530411 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 530414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530455 */     GIR_RootConstrainSelectedInstOperands,
     /* 530456 */     // GIR_Coverage, 12027,
     /* 530456 */     GIR_EraseRootFromParent_Done,
     /* 530457 */   // Label 7072: @530457
     /* 530457 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(530592), // Rule ID 12502 //
     /* 530462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 530465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 530469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530546 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 530549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530590 */     GIR_RootConstrainSelectedInstOperands,
     /* 530591 */     // GIR_Coverage, 12502,
     /* 530591 */     GIR_EraseRootFromParent_Done,
     /* 530592 */   // Label 7073: @530592
     /* 530592 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(530727), // Rule ID 12503 //
     /* 530597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 530600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 530604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530681 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 530684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 530691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 530696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 530701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 530706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530725 */     GIR_RootConstrainSelectedInstOperands,
     /* 530726 */     // GIR_Coverage, 12503,
     /* 530726 */     GIR_EraseRootFromParent_Done,
     /* 530727 */   // Label 7074: @530727
     /* 530727 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(530862), // Rule ID 12506 //
     /* 530732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 530735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 530739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530816 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 530819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530860 */     GIR_RootConstrainSelectedInstOperands,
     /* 530861 */     // GIR_Coverage, 12506,
     /* 530861 */     GIR_EraseRootFromParent_Done,
     /* 530862 */   // Label 7075: @530862
     /* 530862 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(530997), // Rule ID 12507 //
     /* 530867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 530870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 530874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 530878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 530886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 530890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 530894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 530898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 530902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 530906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 530910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 530914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 530914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 530919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 530919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 530924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 530928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 530930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 530951 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 530951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 530954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 530956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 530961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 530966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 530971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 530976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 530981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 530986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 530995 */     GIR_RootConstrainSelectedInstOperands,
     /* 530996 */     // GIR_Coverage, 12507,
     /* 530996 */     GIR_EraseRootFromParent_Done,
     /* 530997 */   // Label 7076: @530997
     /* 530997 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(531132), // Rule ID 12982 //
     /* 531002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 531049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531086 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531130 */     GIR_RootConstrainSelectedInstOperands,
     /* 531131 */     // GIR_Coverage, 12982,
     /* 531131 */     GIR_EraseRootFromParent_Done,
     /* 531132 */   // Label 7077: @531132
     /* 531132 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(531267), // Rule ID 12983 //
     /* 531137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 531184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531221 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531265 */     GIR_RootConstrainSelectedInstOperands,
     /* 531266 */     // GIR_Coverage, 12983,
     /* 531266 */     GIR_EraseRootFromParent_Done,
     /* 531267 */   // Label 7078: @531267
     /* 531267 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(531402), // Rule ID 12986 //
     /* 531272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 531319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531356 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531400 */     GIR_RootConstrainSelectedInstOperands,
     /* 531401 */     // GIR_Coverage, 12986,
     /* 531401 */     GIR_EraseRootFromParent_Done,
     /* 531402 */   // Label 7079: @531402
     /* 531402 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(531537), // Rule ID 12987 //
     /* 531407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 531450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 531454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531459 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531491 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 531501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 531506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 531511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 531516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531535 */     GIR_RootConstrainSelectedInstOperands,
     /* 531536 */     // GIR_Coverage, 12987,
     /* 531536 */     GIR_EraseRootFromParent_Done,
     /* 531537 */   // Label 7080: @531537
     /* 531537 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(531672), // Rule ID 7756 //
     /* 531542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 531545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 531585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531589 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531594 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531626 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 531629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531670 */     GIR_RootConstrainSelectedInstOperands,
     /* 531671 */     // GIR_Coverage, 7756,
     /* 531671 */     GIR_EraseRootFromParent_Done,
     /* 531672 */   // Label 7081: @531672
     /* 531672 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(531807), // Rule ID 7788 //
     /* 531677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 531680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 531684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 531720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531724 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531729 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531761 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 531764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531805 */     GIR_RootConstrainSelectedInstOperands,
     /* 531806 */     // GIR_Coverage, 7788,
     /* 531806 */     GIR_EraseRootFromParent_Done,
     /* 531807 */   // Label 7082: @531807
     /* 531807 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(531942), // Rule ID 7820 //
     /* 531812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 531815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 531855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 531864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 531873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 531875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 531896 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 531896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 531899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 531901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 531906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 531911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 531916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 531921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 531926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 531931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 531940 */     GIR_RootConstrainSelectedInstOperands,
     /* 531941 */     // GIR_Coverage, 7820,
     /* 531941 */     GIR_EraseRootFromParent_Done,
     /* 531942 */   // Label 7083: @531942
     /* 531942 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(532077), // Rule ID 12036 //
     /* 531947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 531950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 531954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 531958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 531966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 531970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 531974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 531978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 531982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 531986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 531990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 531994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 531994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 531999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 531999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532031 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532075 */     GIR_RootConstrainSelectedInstOperands,
     /* 532076 */     // GIR_Coverage, 12036,
     /* 532076 */     GIR_EraseRootFromParent_Done,
     /* 532077 */   // Label 7084: @532077
     /* 532077 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(532212), // Rule ID 12039 //
     /* 532082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 532125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532166 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532210 */     GIR_RootConstrainSelectedInstOperands,
     /* 532211 */     // GIR_Coverage, 12039,
     /* 532211 */     GIR_EraseRootFromParent_Done,
     /* 532212 */   // Label 7085: @532212
     /* 532212 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(532347), // Rule ID 12040 //
     /* 532217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 532220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 532260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532264 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532269 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532301 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 532304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532345 */     GIR_RootConstrainSelectedInstOperands,
     /* 532346 */     // GIR_Coverage, 12040,
     /* 532346 */     GIR_EraseRootFromParent_Done,
     /* 532347 */   // Label 7086: @532347
     /* 532347 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(532482), // Rule ID 12516 //
     /* 532352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 532395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532399 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532404 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532436 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 532439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532480 */     GIR_RootConstrainSelectedInstOperands,
     /* 532481 */     // GIR_Coverage, 12516,
     /* 532481 */     GIR_EraseRootFromParent_Done,
     /* 532482 */   // Label 7087: @532482
     /* 532482 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(532617), // Rule ID 12519 //
     /* 532487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 532530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532534 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532539 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532571 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 532574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532615 */     GIR_RootConstrainSelectedInstOperands,
     /* 532616 */     // GIR_Coverage, 12519,
     /* 532616 */     GIR_EraseRootFromParent_Done,
     /* 532617 */   // Label 7088: @532617
     /* 532617 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(532752), // Rule ID 12520 //
     /* 532622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 532625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 532629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 532665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532669 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532674 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532706 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 532709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 532731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532750 */     GIR_RootConstrainSelectedInstOperands,
     /* 532751 */     // GIR_Coverage, 12520,
     /* 532751 */     GIR_EraseRootFromParent_Done,
     /* 532752 */   // Label 7089: @532752
     /* 532752 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(532887), // Rule ID 12996 //
     /* 532757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 532760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 532800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532841 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 532844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 532851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 532856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 532861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 532866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 532871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 532876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 532885 */     GIR_RootConstrainSelectedInstOperands,
     /* 532886 */     // GIR_Coverage, 12996,
     /* 532886 */     GIR_EraseRootFromParent_Done,
     /* 532887 */   // Label 7090: @532887
     /* 532887 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(533022), // Rule ID 12999 //
     /* 532892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 532895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 532899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 532903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 532911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 532915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 532919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 532923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 532927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 532931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 532935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 532939 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 532939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 532944 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 532944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 532949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 532953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 532955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 532976 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 532976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 532979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 532981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 532986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 532991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 532996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533020 */     GIR_RootConstrainSelectedInstOperands,
     /* 533021 */     // GIR_Coverage, 12999,
     /* 533021 */     GIR_EraseRootFromParent_Done,
     /* 533022 */   // Label 7091: @533022
     /* 533022 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(533157), // Rule ID 13000 //
     /* 533027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 533074 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533079 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533111 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533155 */     GIR_RootConstrainSelectedInstOperands,
     /* 533156 */     // GIR_Coverage, 13000,
     /* 533156 */     GIR_EraseRootFromParent_Done,
     /* 533157 */   // Label 7092: @533157
     /* 533157 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(533292), // Rule ID 7755 //
     /* 533162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 533165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533209 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533246 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 533249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533290 */     GIR_RootConstrainSelectedInstOperands,
     /* 533291 */     // GIR_Coverage, 7755,
     /* 533291 */     GIR_EraseRootFromParent_Done,
     /* 533292 */   // Label 7093: @533292
     /* 533292 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(533427), // Rule ID 7787 //
     /* 533297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 533300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 533304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533344 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533349 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533381 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 533384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533425 */     GIR_RootConstrainSelectedInstOperands,
     /* 533426 */     // GIR_Coverage, 7787,
     /* 533426 */     GIR_EraseRootFromParent_Done,
     /* 533427 */   // Label 7094: @533427
     /* 533427 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(533562), // Rule ID 7819 //
     /* 533432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 533435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533516 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 533519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533560 */     GIR_RootConstrainSelectedInstOperands,
     /* 533561 */     // GIR_Coverage, 7819,
     /* 533561 */     GIR_EraseRootFromParent_Done,
     /* 533562 */   // Label 7095: @533562
     /* 533562 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(533697), // Rule ID 12021 //
     /* 533567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 533570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533651 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 533654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 533661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 533666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 533671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 533676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533695 */     GIR_RootConstrainSelectedInstOperands,
     /* 533696 */     // GIR_Coverage, 12021,
     /* 533696 */     GIR_EraseRootFromParent_Done,
     /* 533697 */   // Label 7096: @533697
     /* 533697 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(533832), // Rule ID 12024 //
     /* 533702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 533705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533749 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533759 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533786 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 533789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533830 */     GIR_RootConstrainSelectedInstOperands,
     /* 533831 */     // GIR_Coverage, 12024,
     /* 533831 */     GIR_EraseRootFromParent_Done,
     /* 533832 */   // Label 7097: @533832
     /* 533832 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(533967), // Rule ID 12025 //
     /* 533837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 533840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 533844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 533872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 533876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 533880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 533884 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 533884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 533889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 533889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 533894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 533898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 533900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 533921 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 533921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 533924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 533926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 533931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 533936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 533941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 533946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 533951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 533956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 533965 */     GIR_RootConstrainSelectedInstOperands,
     /* 533966 */     // GIR_Coverage, 12025,
     /* 533966 */     GIR_EraseRootFromParent_Done,
     /* 533967 */   // Label 7098: @533967
     /* 533967 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(534102), // Rule ID 12501 //
     /* 533972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 533975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 533979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 533983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 533987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 533991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 533995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 533999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 534019 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534024 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534056 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534100 */     GIR_RootConstrainSelectedInstOperands,
     /* 534101 */     // GIR_Coverage, 12501,
     /* 534101 */     GIR_EraseRootFromParent_Done,
     /* 534102 */   // Label 7099: @534102
     /* 534102 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(534237), // Rule ID 12504 //
     /* 534107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 534154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534159 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534191 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534235 */     GIR_RootConstrainSelectedInstOperands,
     /* 534236 */     // GIR_Coverage, 12504,
     /* 534236 */     GIR_EraseRootFromParent_Done,
     /* 534237 */   // Label 7100: @534237
     /* 534237 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(534372), // Rule ID 12505 //
     /* 534242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 534245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 534249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 534289 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534294 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534326 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 534329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534370 */     GIR_RootConstrainSelectedInstOperands,
     /* 534371 */     // GIR_Coverage, 12505,
     /* 534371 */     GIR_EraseRootFromParent_Done,
     /* 534372 */   // Label 7101: @534372
     /* 534372 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(534507), // Rule ID 12981 //
     /* 534377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 534380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 534424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534461 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 534464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534505 */     GIR_RootConstrainSelectedInstOperands,
     /* 534506 */     // GIR_Coverage, 12981,
     /* 534506 */     GIR_EraseRootFromParent_Done,
     /* 534507 */   // Label 7102: @534507
     /* 534507 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(534642), // Rule ID 12984 //
     /* 534512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 534515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 534559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534596 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 534599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534640 */     GIR_RootConstrainSelectedInstOperands,
     /* 534641 */     // GIR_Coverage, 12984,
     /* 534641 */     GIR_EraseRootFromParent_Done,
     /* 534642 */   // Label 7103: @534642
     /* 534642 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(534777), // Rule ID 12985 //
     /* 534647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 534650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 534690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 534694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534731 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 534734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 534741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 534746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 534751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 534756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534775 */     GIR_RootConstrainSelectedInstOperands,
     /* 534776 */     // GIR_Coverage, 12985,
     /* 534776 */     GIR_EraseRootFromParent_Done,
     /* 534777 */   // Label 7104: @534777
     /* 534777 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(534912), // Rule ID 12007 //
     /* 534782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 534825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534866 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 534866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 534869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 534871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 534876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 534881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 534886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 534891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 534896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 534901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 534910 */     GIR_RootConstrainSelectedInstOperands,
     /* 534911 */     // GIR_Coverage, 12007,
     /* 534911 */     GIR_EraseRootFromParent_Done,
     /* 534912 */   // Label 7105: @534912
     /* 534912 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(535047), // Rule ID 12008 //
     /* 534917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 534920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 534924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 534928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 534932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 534936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 534940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 534944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 534948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 534952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 534956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 534960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 534964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 534964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 534969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 534969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 534974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 534978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 534980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 534994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535001 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535045 */     GIR_RootConstrainSelectedInstOperands,
     /* 535046 */     // GIR_Coverage, 12008,
     /* 535046 */     GIR_EraseRootFromParent_Done,
     /* 535047 */   // Label 7106: @535047
     /* 535047 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(535182), // Rule ID 12011 //
     /* 535052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 535095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535136 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535180 */     GIR_RootConstrainSelectedInstOperands,
     /* 535181 */     // GIR_Coverage, 12011,
     /* 535181 */     GIR_EraseRootFromParent_Done,
     /* 535182 */   // Label 7107: @535182
     /* 535182 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(535317), // Rule ID 12012 //
     /* 535187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 535190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 535230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535271 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 535274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535315 */     GIR_RootConstrainSelectedInstOperands,
     /* 535316 */     // GIR_Coverage, 12012,
     /* 535316 */     GIR_EraseRootFromParent_Done,
     /* 535317 */   // Label 7108: @535317
     /* 535317 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(535452), // Rule ID 12487 //
     /* 535322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 535325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 535329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 535365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535406 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 535409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535450 */     GIR_RootConstrainSelectedInstOperands,
     /* 535451 */     // GIR_Coverage, 12487,
     /* 535451 */     GIR_EraseRootFromParent_Done,
     /* 535452 */   // Label 7109: @535452
     /* 535452 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(535587), // Rule ID 12488 //
     /* 535457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 535460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 535464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 535500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535541 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 535544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535585 */     GIR_RootConstrainSelectedInstOperands,
     /* 535586 */     // GIR_Coverage, 12488,
     /* 535586 */     GIR_EraseRootFromParent_Done,
     /* 535587 */   // Label 7110: @535587
     /* 535587 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(535722), // Rule ID 12491 //
     /* 535592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 535595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 535599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 535635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535676 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 535679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535720 */     GIR_RootConstrainSelectedInstOperands,
     /* 535721 */     // GIR_Coverage, 12491,
     /* 535721 */     GIR_EraseRootFromParent_Done,
     /* 535722 */   // Label 7111: @535722
     /* 535722 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(535857), // Rule ID 12492 //
     /* 535727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 535730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 535734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 535770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535811 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 535814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 535821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 535826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 535831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 535836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535855 */     GIR_RootConstrainSelectedInstOperands,
     /* 535856 */     // GIR_Coverage, 12492,
     /* 535856 */     GIR_EraseRootFromParent_Done,
     /* 535857 */   // Label 7112: @535857
     /* 535857 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(535992), // Rule ID 12967 //
     /* 535862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 535865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 535869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 535873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 535877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 535881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 535885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 535889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 535893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 535897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 535901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 535905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 535909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 535909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 535914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 535914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 535919 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 535923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 535925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 535946 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 535946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 535949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 535951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 535956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 535961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 535966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 535971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 535976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 535981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 535990 */     GIR_RootConstrainSelectedInstOperands,
     /* 535991 */     // GIR_Coverage, 12967,
     /* 535991 */     GIR_EraseRootFromParent_Done,
     /* 535992 */   // Label 7113: @535992
     /* 535992 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(536127), // Rule ID 12968 //
     /* 535997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 536044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536081 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536125 */     GIR_RootConstrainSelectedInstOperands,
     /* 536126 */     // GIR_Coverage, 12968,
     /* 536126 */     GIR_EraseRootFromParent_Done,
     /* 536127 */   // Label 7114: @536127
     /* 536127 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(536262), // Rule ID 12971 //
     /* 536132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 536179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536216 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536260 */     GIR_RootConstrainSelectedInstOperands,
     /* 536261 */     // GIR_Coverage, 12971,
     /* 536261 */     GIR_EraseRootFromParent_Done,
     /* 536262 */   // Label 7115: @536262
     /* 536262 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(536397), // Rule ID 12972 //
     /* 536267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 536270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 536314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536351 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 536354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536395 */     GIR_RootConstrainSelectedInstOperands,
     /* 536396 */     // GIR_Coverage, 12972,
     /* 536396 */     GIR_EraseRootFromParent_Done,
     /* 536397 */   // Label 7116: @536397
     /* 536397 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(536532), // Rule ID 11992 //
     /* 536402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536486 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536530 */     GIR_RootConstrainSelectedInstOperands,
     /* 536531 */     // GIR_Coverage, 11992,
     /* 536531 */     GIR_EraseRootFromParent_Done,
     /* 536532 */   // Label 7117: @536532
     /* 536532 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(536667), // Rule ID 11993 //
     /* 536537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536589 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536614 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536621 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 536631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 536636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 536641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 536646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536665 */     GIR_RootConstrainSelectedInstOperands,
     /* 536666 */     // GIR_Coverage, 11993,
     /* 536666 */     GIR_EraseRootFromParent_Done,
     /* 536667 */   // Label 7118: @536667
     /* 536667 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(536802), // Rule ID 11996 //
     /* 536672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536724 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536756 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536800 */     GIR_RootConstrainSelectedInstOperands,
     /* 536801 */     // GIR_Coverage, 11996,
     /* 536801 */     GIR_EraseRootFromParent_Done,
     /* 536802 */   // Label 7119: @536802
     /* 536802 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(536937), // Rule ID 11997 //
     /* 536807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 536810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 536814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 536868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 536870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 536891 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 536891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 536894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 536896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 536901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 536906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 536911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 536916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 536921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 536926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 536935 */     GIR_RootConstrainSelectedInstOperands,
     /* 536936 */     // GIR_Coverage, 11997,
     /* 536936 */     GIR_EraseRootFromParent_Done,
     /* 536937 */   // Label 7120: @536937
     /* 536937 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(537072), // Rule ID 12472 //
     /* 536942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 536945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 536949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 536953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 536957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 536961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 536965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 536969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 536973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 536977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 536981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 536985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 536989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 536989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 536994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 536994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 536999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537026 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 537036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 537041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537070 */     GIR_RootConstrainSelectedInstOperands,
     /* 537071 */     // GIR_Coverage, 12472,
     /* 537071 */     GIR_EraseRootFromParent_Done,
     /* 537072 */   // Label 7121: @537072
     /* 537072 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(537207), // Rule ID 12473 //
     /* 537077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 537120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537161 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 537171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 537176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537205 */     GIR_RootConstrainSelectedInstOperands,
     /* 537206 */     // GIR_Coverage, 12473,
     /* 537206 */     GIR_EraseRootFromParent_Done,
     /* 537207 */   // Label 7122: @537207
     /* 537207 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(537342), // Rule ID 12476 //
     /* 537212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 537255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537264 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537296 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 537316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 537321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537340 */     GIR_RootConstrainSelectedInstOperands,
     /* 537341 */     // GIR_Coverage, 12476,
     /* 537341 */     GIR_EraseRootFromParent_Done,
     /* 537342 */   // Label 7123: @537342
     /* 537342 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(537477), // Rule ID 12477 //
     /* 537347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 537350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 537354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 537390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537394 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537399 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537431 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 537434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 537451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 537456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537475 */     GIR_RootConstrainSelectedInstOperands,
     /* 537476 */     // GIR_Coverage, 12477,
     /* 537476 */     GIR_EraseRootFromParent_Done,
     /* 537477 */   // Label 7124: @537477
     /* 537477 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(537612), // Rule ID 12952 //
     /* 537482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 537485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 537525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537529 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537559 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537566 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 537569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 537576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 537581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537610 */     GIR_RootConstrainSelectedInstOperands,
     /* 537611 */     // GIR_Coverage, 12952,
     /* 537611 */     GIR_EraseRootFromParent_Done,
     /* 537612 */   // Label 7125: @537612
     /* 537612 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(537747), // Rule ID 12953 //
     /* 537617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 537620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 537660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537701 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 537704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 537711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 537716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 537721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 537726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537745 */     GIR_RootConstrainSelectedInstOperands,
     /* 537746 */     // GIR_Coverage, 12953,
     /* 537746 */     GIR_EraseRootFromParent_Done,
     /* 537747 */   // Label 7126: @537747
     /* 537747 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(537882), // Rule ID 12956 //
     /* 537752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 537755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 537795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537836 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 537839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 537856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 537861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 537866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 537871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 537880 */     GIR_RootConstrainSelectedInstOperands,
     /* 537881 */     // GIR_Coverage, 12956,
     /* 537881 */     GIR_EraseRootFromParent_Done,
     /* 537882 */   // Label 7127: @537882
     /* 537882 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(538017), // Rule ID 12957 //
     /* 537887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 537890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 537894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 537898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 537902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 537906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 537910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 537914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 537918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 537922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 537926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 537930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 537934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 537934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 537939 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 537939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 537944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 537948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 537950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 537971 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 537971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 537974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 537976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 537981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 537986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 537991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 537996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538015 */     GIR_RootConstrainSelectedInstOperands,
     /* 538016 */     // GIR_Coverage, 12957,
     /* 538016 */     GIR_EraseRootFromParent_Done,
     /* 538017 */   // Label 7128: @538017
     /* 538017 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(538152), // Rule ID 7754 //
     /* 538022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 538065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538069 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 538074 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 538079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538106 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 538116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 538121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538150 */     GIR_RootConstrainSelectedInstOperands,
     /* 538151 */     // GIR_Coverage, 7754,
     /* 538151 */     GIR_EraseRootFromParent_Done,
     /* 538152 */   // Label 7129: @538152
     /* 538152 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(538287), // Rule ID 7786 //
     /* 538157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 538160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 538164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 538200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538204 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 538209 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 538214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538241 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 538244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 538251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 538256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538285 */     GIR_RootConstrainSelectedInstOperands,
     /* 538286 */     // GIR_Coverage, 7786,
     /* 538286 */     GIR_EraseRootFromParent_Done,
     /* 538287 */   // Label 7130: @538287
     /* 538287 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(538422), // Rule ID 7818 //
     /* 538292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 538295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 538335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 538344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 538349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538376 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 538379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 538386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 538391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538420 */     GIR_RootConstrainSelectedInstOperands,
     /* 538421 */     // GIR_Coverage, 7818,
     /* 538421 */     GIR_EraseRootFromParent_Done,
     /* 538422 */   // Label 7131: @538422
     /* 538422 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(538557), // Rule ID 12006 //
     /* 538427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 538470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 538479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 538484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538511 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 538521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 538526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538555 */     GIR_RootConstrainSelectedInstOperands,
     /* 538556 */     // GIR_Coverage, 12006,
     /* 538556 */     GIR_EraseRootFromParent_Done,
     /* 538557 */   // Label 7132: @538557
     /* 538557 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(538692), // Rule ID 12009 //
     /* 538562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 538605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 538614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 538619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538646 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 538666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 538671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538690 */     GIR_RootConstrainSelectedInstOperands,
     /* 538691 */     // GIR_Coverage, 12009,
     /* 538691 */     GIR_EraseRootFromParent_Done,
     /* 538692 */   // Label 7133: @538692
     /* 538692 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(538827), // Rule ID 12010 //
     /* 538697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 538700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 538704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 538740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 538749 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 538754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538781 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 538784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 538791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 538796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 538801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 538806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538825 */     GIR_RootConstrainSelectedInstOperands,
     /* 538826 */     // GIR_Coverage, 12010,
     /* 538826 */     GIR_EraseRootFromParent_Done,
     /* 538827 */   // Label 7134: @538827
     /* 538827 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(538962), // Rule ID 12486 //
     /* 538832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 538835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 538839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 538867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 538871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 538875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 538879 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 538879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 538884 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 538884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 538889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 538893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 538895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 538916 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 538916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 538919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 538921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 538926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 538931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 538936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 538941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 538946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 538951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 538960 */     GIR_RootConstrainSelectedInstOperands,
     /* 538961 */     // GIR_Coverage, 12486,
     /* 538961 */     GIR_EraseRootFromParent_Done,
     /* 538962 */   // Label 7135: @538962
     /* 538962 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(539097), // Rule ID 12489 //
     /* 538967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 538970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 538974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 538978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 538982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 538986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 538990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 538994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 538998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539014 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539019 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539051 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 539071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 539076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 539081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 539086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539095 */     GIR_RootConstrainSelectedInstOperands,
     /* 539096 */     // GIR_Coverage, 12489,
     /* 539096 */     GIR_EraseRootFromParent_Done,
     /* 539097 */   // Label 7136: @539097
     /* 539097 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(539232), // Rule ID 12490 //
     /* 539102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 539129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539149 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539154 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539186 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 539206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 539211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 539216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 539221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539230 */     GIR_RootConstrainSelectedInstOperands,
     /* 539231 */     // GIR_Coverage, 12490,
     /* 539231 */     GIR_EraseRootFromParent_Done,
     /* 539232 */   // Label 7137: @539232
     /* 539232 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(539367), // Rule ID 12966 //
     /* 539237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 539264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539321 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 539331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 539336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 539351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 539356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539365 */     GIR_RootConstrainSelectedInstOperands,
     /* 539366 */     // GIR_Coverage, 12966,
     /* 539366 */     GIR_EraseRootFromParent_Done,
     /* 539367 */   // Label 7138: @539367
     /* 539367 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(539502), // Rule ID 12969 //
     /* 539372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 539399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539456 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 539476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 539481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 539486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 539491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539500 */     GIR_RootConstrainSelectedInstOperands,
     /* 539501 */     // GIR_Coverage, 12969,
     /* 539501 */     GIR_EraseRootFromParent_Done,
     /* 539502 */   // Label 7139: @539502
     /* 539502 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(539637), // Rule ID 12970 //
     /* 539507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 539534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 539554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539591 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 539601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 539606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 539611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 539616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 539621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 539626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539635 */     GIR_RootConstrainSelectedInstOperands,
     /* 539636 */     // GIR_Coverage, 12970,
     /* 539636 */     GIR_EraseRootFromParent_Done,
     /* 539637 */   // Label 7140: @539637
     /* 539637 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(539772), // Rule ID 7753 //
     /* 539642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 539645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 539669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 539689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539726 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 539729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 539736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 539741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 539756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 539761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539770 */     GIR_RootConstrainSelectedInstOperands,
     /* 539771 */     // GIR_Coverage, 7753,
     /* 539771 */     GIR_EraseRootFromParent_Done,
     /* 539772 */   // Label 7141: @539772
     /* 539772 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(539907), // Rule ID 7785 //
     /* 539777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 539780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 539784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 539804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 539824 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539829 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539861 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 539864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 539866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 539871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 539876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 539881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 539886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 539891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 539896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 539905 */     GIR_RootConstrainSelectedInstOperands,
     /* 539906 */     // GIR_Coverage, 7785,
     /* 539906 */     GIR_EraseRootFromParent_Done,
     /* 539907 */   // Label 7142: @539907
     /* 539907 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(540042), // Rule ID 7817 //
     /* 539912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 539915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 539919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 539923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 539927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 539931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 539935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 539939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 539943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 539947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 539951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 539955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 539959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 539959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 539964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 539964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 539969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 539973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 539975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 539996 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 539996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 539999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 540006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 540011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540040 */     GIR_RootConstrainSelectedInstOperands,
     /* 540041 */     // GIR_Coverage, 7817,
     /* 540041 */     GIR_EraseRootFromParent_Done,
     /* 540042 */   // Label 7143: @540042
     /* 540042 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(540177), // Rule ID 11991 //
     /* 540047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 540074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 540090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 540099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 540104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540131 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 540141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 540146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540175 */     GIR_RootConstrainSelectedInstOperands,
     /* 540176 */     // GIR_Coverage, 11991,
     /* 540176 */     GIR_EraseRootFromParent_Done,
     /* 540177 */   // Label 7144: @540177
     /* 540177 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(540312), // Rule ID 11994 //
     /* 540182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 540209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 540225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 540234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 540239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540266 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 540286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 540291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540310 */     GIR_RootConstrainSelectedInstOperands,
     /* 540311 */     // GIR_Coverage, 11994,
     /* 540311 */     GIR_EraseRootFromParent_Done,
     /* 540312 */   // Label 7145: @540312
     /* 540312 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(540447), // Rule ID 11995 //
     /* 540317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 540320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 540344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 540360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 540369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 540374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540401 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 540404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 540421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 540426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540445 */     GIR_RootConstrainSelectedInstOperands,
     /* 540446 */     // GIR_Coverage, 11995,
     /* 540446 */     GIR_EraseRootFromParent_Done,
     /* 540447 */   // Label 7146: @540447
     /* 540447 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(540582), // Rule ID 12471 //
     /* 540452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 540455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 540459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 540479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 540495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540499 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 540504 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 540509 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540536 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 540539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 540546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 540551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540580 */     GIR_RootConstrainSelectedInstOperands,
     /* 540581 */     // GIR_Coverage, 12471,
     /* 540581 */     GIR_EraseRootFromParent_Done,
     /* 540582 */   // Label 7147: @540582
     /* 540582 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(540717), // Rule ID 12474 //
     /* 540587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 540590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 540594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 540614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 540630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540634 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 540639 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 540644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540671 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 540674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 540691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 540696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540715 */     GIR_RootConstrainSelectedInstOperands,
     /* 540716 */     // GIR_Coverage, 12474,
     /* 540716 */     GIR_EraseRootFromParent_Done,
     /* 540717 */   // Label 7148: @540717
     /* 540717 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(540852), // Rule ID 12475 //
     /* 540722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 540725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 540729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 540749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 540765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540769 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 540774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 540779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540806 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 540809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 540816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 540821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 540826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 540831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540850 */     GIR_RootConstrainSelectedInstOperands,
     /* 540851 */     // GIR_Coverage, 12475,
     /* 540851 */     GIR_EraseRootFromParent_Done,
     /* 540852 */   // Label 7149: @540852
     /* 540852 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(540987), // Rule ID 12951 //
     /* 540857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 540860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 540868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 540872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 540876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 540880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 540884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 540888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 540892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 540896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 540900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 540904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 540904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 540909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 540909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 540914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 540918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 540920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 540941 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 540941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 540944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 540946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 540951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 540956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 540961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 540966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 540971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 540976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 540985 */     GIR_RootConstrainSelectedInstOperands,
     /* 540986 */     // GIR_Coverage, 12951,
     /* 540986 */     GIR_EraseRootFromParent_Done,
     /* 540987 */   // Label 7150: @540987
     /* 540987 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(541122), // Rule ID 12954 //
     /* 540992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 540995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 540999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 541019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 541023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 541035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 541044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 541049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541076 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 541096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 541101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 541106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 541111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541120 */     GIR_RootConstrainSelectedInstOperands,
     /* 541121 */     // GIR_Coverage, 12954,
     /* 541121 */     GIR_EraseRootFromParent_Done,
     /* 541122 */   // Label 7151: @541122
     /* 541122 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(541257), // Rule ID 12955 //
     /* 541127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 541130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 541154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 541158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 541170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 541174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 541179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 541184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541211 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 541214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 541231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 541236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 541241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 541246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541255 */     GIR_RootConstrainSelectedInstOperands,
     /* 541256 */     // GIR_Coverage, 12955,
     /* 541256 */     GIR_EraseRootFromParent_Done,
     /* 541257 */   // Label 7152: @541257
     /* 541257 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(541392), // Rule ID 12047 //
     /* 541262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 541293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541346 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 541349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541390 */     GIR_RootConstrainSelectedInstOperands,
     /* 541391 */     // GIR_Coverage, 12047,
     /* 541391 */     GIR_EraseRootFromParent_Done,
     /* 541392 */   // Label 7153: @541392
     /* 541392 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(541527), // Rule ID 12048 //
     /* 541397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 541428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541481 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 541484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541525 */     GIR_RootConstrainSelectedInstOperands,
     /* 541526 */     // GIR_Coverage, 12048,
     /* 541526 */     GIR_EraseRootFromParent_Done,
     /* 541527 */   // Label 7154: @541527
     /* 541527 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(541662), // Rule ID 12049 //
     /* 541532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 541563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541616 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 541619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541660 */     GIR_RootConstrainSelectedInstOperands,
     /* 541661 */     // GIR_Coverage, 12049,
     /* 541661 */     GIR_EraseRootFromParent_Done,
     /* 541662 */   // Label 7155: @541662
     /* 541662 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(541797), // Rule ID 12050 //
     /* 541667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 541670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 541674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 541698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541751 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 541754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 541761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 541766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 541771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 541776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541795 */     GIR_RootConstrainSelectedInstOperands,
     /* 541796 */     // GIR_Coverage, 12050,
     /* 541796 */     GIR_EraseRootFromParent_Done,
     /* 541797 */   // Label 7156: @541797
     /* 541797 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(541932), // Rule ID 12527 //
     /* 541802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 541805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 541809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 541833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 541865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 541886 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 541886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 541889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 541891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 541896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 541901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 541906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 541911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 541916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 541921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 541930 */     GIR_RootConstrainSelectedInstOperands,
     /* 541931 */     // GIR_Coverage, 12527,
     /* 541931 */     GIR_EraseRootFromParent_Done,
     /* 541932 */   // Label 7157: @541932
     /* 541932 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(542067), // Rule ID 12528 //
     /* 541937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 541940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 541944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 541948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 541956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 541960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 541964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 541968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 541972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 541976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 541980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 541984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 541984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 541989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 541989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 541994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 541998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542021 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542065 */     GIR_RootConstrainSelectedInstOperands,
     /* 542066 */     // GIR_Coverage, 12528,
     /* 542066 */     GIR_EraseRootFromParent_Done,
     /* 542067 */   // Label 7158: @542067
     /* 542067 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(542202), // Rule ID 12529 //
     /* 542072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 542103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542156 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542200 */     GIR_RootConstrainSelectedInstOperands,
     /* 542201 */     // GIR_Coverage, 12529,
     /* 542201 */     GIR_EraseRootFromParent_Done,
     /* 542202 */   // Label 7159: @542202
     /* 542202 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(542337), // Rule ID 12530 //
     /* 542207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 542210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 542214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 542238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542291 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 542294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542335 */     GIR_RootConstrainSelectedInstOperands,
     /* 542336 */     // GIR_Coverage, 12530,
     /* 542336 */     GIR_EraseRootFromParent_Done,
     /* 542337 */   // Label 7160: @542337
     /* 542337 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(542472), // Rule ID 13007 //
     /* 542342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 542345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 542373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542394 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542426 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 542429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542470 */     GIR_RootConstrainSelectedInstOperands,
     /* 542471 */     // GIR_Coverage, 13007,
     /* 542471 */     GIR_EraseRootFromParent_Done,
     /* 542472 */   // Label 7161: @542472
     /* 542472 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(542607), // Rule ID 13008 //
     /* 542477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 542480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 542508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542524 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542529 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542561 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 542564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542605 */     GIR_RootConstrainSelectedInstOperands,
     /* 542606 */     // GIR_Coverage, 13008,
     /* 542606 */     GIR_EraseRootFromParent_Done,
     /* 542607 */   // Label 7162: @542607
     /* 542607 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(542742), // Rule ID 13009 //
     /* 542612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 542615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 542643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542696 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 542699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542740 */     GIR_RootConstrainSelectedInstOperands,
     /* 542741 */     // GIR_Coverage, 13009,
     /* 542741 */     GIR_EraseRootFromParent_Done,
     /* 542742 */   // Label 7163: @542742
     /* 542742 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(542877), // Rule ID 13010 //
     /* 542747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 542750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 542778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542831 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 542834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 542841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 542846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 542851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 542856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 542866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 542875 */     GIR_RootConstrainSelectedInstOperands,
     /* 542876 */     // GIR_Coverage, 13010,
     /* 542876 */     GIR_EraseRootFromParent_Done,
     /* 542877 */   // Label 7164: @542877
     /* 542877 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(543012), // Rule ID 11987 //
     /* 542882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 542885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 542889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 542893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 542897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 542901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 542905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 542909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 542913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 542917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 542921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 542925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 542929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 542929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 542934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 542934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 542939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 542943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 542945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 542966 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 542966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 542969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 542971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 542976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 542981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 542986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 542991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 542996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543010 */     GIR_RootConstrainSelectedInstOperands,
     /* 543011 */     // GIR_Coverage, 11987,
     /* 543011 */     GIR_EraseRootFromParent_Done,
     /* 543012 */   // Label 7165: @543012
     /* 543012 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(543147), // Rule ID 11988 //
     /* 543017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543069 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543101 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 543121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 543126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543145 */     GIR_RootConstrainSelectedInstOperands,
     /* 543146 */     // GIR_Coverage, 11988,
     /* 543146 */     GIR_EraseRootFromParent_Done,
     /* 543147 */   // Label 7166: @543147
     /* 543147 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(543282), // Rule ID 11989 //
     /* 543152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543199 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543204 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543236 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543280 */     GIR_RootConstrainSelectedInstOperands,
     /* 543281 */     // GIR_Coverage, 11989,
     /* 543281 */     GIR_EraseRootFromParent_Done,
     /* 543282 */   // Label 7167: @543282
     /* 543282 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(543417), // Rule ID 11990 //
     /* 543287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 543290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543371 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 543374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543415 */     GIR_RootConstrainSelectedInstOperands,
     /* 543416 */     // GIR_Coverage, 11990,
     /* 543416 */     GIR_EraseRootFromParent_Done,
     /* 543417 */   // Label 7168: @543417
     /* 543417 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(543552), // Rule ID 12467 //
     /* 543422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 543425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 543429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543506 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 543509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 543526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 543531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543550 */     GIR_RootConstrainSelectedInstOperands,
     /* 543551 */     // GIR_Coverage, 12467,
     /* 543551 */     GIR_EraseRootFromParent_Done,
     /* 543552 */   // Label 7169: @543552
     /* 543552 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(543687), // Rule ID 12468 //
     /* 543557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 543560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 543564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543641 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 543644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 543651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 543656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 543661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 543666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543685 */     GIR_RootConstrainSelectedInstOperands,
     /* 543686 */     // GIR_Coverage, 12468,
     /* 543686 */     GIR_EraseRootFromParent_Done,
     /* 543687 */   // Label 7170: @543687
     /* 543687 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(543822), // Rule ID 12469 //
     /* 543692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 543695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 543699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543776 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 543779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543820 */     GIR_RootConstrainSelectedInstOperands,
     /* 543821 */     // GIR_Coverage, 12469,
     /* 543821 */     GIR_EraseRootFromParent_Done,
     /* 543822 */   // Label 7171: @543822
     /* 543822 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(543957), // Rule ID 12470 //
     /* 543827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 543830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 543834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 543866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 543870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 543874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 543874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 543879 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 543879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 543884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 543888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 543890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 543911 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 543911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 543914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 543916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 543921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 543926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 543931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 543936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 543941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 543946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 543955 */     GIR_RootConstrainSelectedInstOperands,
     /* 543956 */     // GIR_Coverage, 12470,
     /* 543956 */     GIR_EraseRootFromParent_Done,
     /* 543957 */   // Label 7172: @543957
     /* 543957 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(544092), // Rule ID 12947 //
     /* 543962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 543965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 543969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 543973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 543977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 543981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 543985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 543989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 543993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 543997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 544009 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544014 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544046 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 544066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 544071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 544076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 544081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544090 */     GIR_RootConstrainSelectedInstOperands,
     /* 544091 */     // GIR_Coverage, 12947,
     /* 544091 */     GIR_EraseRootFromParent_Done,
     /* 544092 */   // Label 7173: @544092
     /* 544092 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(544227), // Rule ID 12948 //
     /* 544097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 544124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 544144 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544181 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 544201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 544206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 544211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 544216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544225 */     GIR_RootConstrainSelectedInstOperands,
     /* 544226 */     // GIR_Coverage, 12948,
     /* 544226 */     GIR_EraseRootFromParent_Done,
     /* 544227 */   // Label 7174: @544227
     /* 544227 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(544362), // Rule ID 12949 //
     /* 544232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 544259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 544279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544316 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 544326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 544331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 544346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 544351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544360 */     GIR_RootConstrainSelectedInstOperands,
     /* 544361 */     // GIR_Coverage, 12949,
     /* 544361 */     GIR_EraseRootFromParent_Done,
     /* 544362 */   // Label 7175: @544362
     /* 544362 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(544497), // Rule ID 12950 //
     /* 544367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 544370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 544394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 544398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 544414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544451 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 544454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 544461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 544466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 544481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 544486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544495 */     GIR_RootConstrainSelectedInstOperands,
     /* 544496 */     // GIR_Coverage, 12950,
     /* 544496 */     GIR_EraseRootFromParent_Done,
     /* 544497 */   // Label 7176: @544497
     /* 544497 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(544632), // Rule ID 12032 //
     /* 544502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 544505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 544529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 544533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544586 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 544589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 544606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 544611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 544616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 544621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544630 */     GIR_RootConstrainSelectedInstOperands,
     /* 544631 */     // GIR_Coverage, 12032,
     /* 544631 */     GIR_EraseRootFromParent_Done,
     /* 544632 */   // Label 7177: @544632
     /* 544632 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(544767), // Rule ID 12033 //
     /* 544637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 544640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 544664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 544668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544721 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 544724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 544731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 544736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 544741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 544746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 544751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 544756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544765 */     GIR_RootConstrainSelectedInstOperands,
     /* 544766 */     // GIR_Coverage, 12033,
     /* 544766 */     GIR_EraseRootFromParent_Done,
     /* 544767 */   // Label 7178: @544767
     /* 544767 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(544902), // Rule ID 12034 //
     /* 544772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 544775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 544799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 544803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544819 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544856 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 544859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 544866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 544871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 544876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 544881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 544886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 544891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 544900 */     GIR_RootConstrainSelectedInstOperands,
     /* 544901 */     // GIR_Coverage, 12034,
     /* 544901 */     GIR_EraseRootFromParent_Done,
     /* 544902 */   // Label 7179: @544902
     /* 544902 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(545037), // Rule ID 12035 //
     /* 544907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 544910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 544914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 544918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 544926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 544930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 544934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 544938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 544942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 544946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 544950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 544954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 544954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 544959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 544959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 544964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 544968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 544970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 544991 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 544991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 544994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 544996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 545001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 545006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545035 */     GIR_RootConstrainSelectedInstOperands,
     /* 545036 */     // GIR_Coverage, 12035,
     /* 545036 */     GIR_EraseRootFromParent_Done,
     /* 545037 */   // Label 7180: @545037
     /* 545037 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(545172), // Rule ID 12512 //
     /* 545042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 545069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 545073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545126 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 545146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 545151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545170 */     GIR_RootConstrainSelectedInstOperands,
     /* 545171 */     // GIR_Coverage, 12512,
     /* 545171 */     GIR_EraseRootFromParent_Done,
     /* 545172 */   // Label 7181: @545172
     /* 545172 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(545307), // Rule ID 12513 //
     /* 545177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 545204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 545208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545261 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 545281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 545286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545305 */     GIR_RootConstrainSelectedInstOperands,
     /* 545306 */     // GIR_Coverage, 12513,
     /* 545306 */     GIR_EraseRootFromParent_Done,
     /* 545307 */   // Label 7182: @545307
     /* 545307 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(545442), // Rule ID 12514 //
     /* 545312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 545339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 545343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545396 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 545406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 545411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545440 */     GIR_RootConstrainSelectedInstOperands,
     /* 545441 */     // GIR_Coverage, 12514,
     /* 545441 */     GIR_EraseRootFromParent_Done,
     /* 545442 */   // Label 7183: @545442
     /* 545442 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(545577), // Rule ID 12515 //
     /* 545447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 545450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 545454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 545474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 545478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545494 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545499 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545531 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 545534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 545541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 545546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545575 */     GIR_RootConstrainSelectedInstOperands,
     /* 545576 */     // GIR_Coverage, 12515,
     /* 545576 */     GIR_EraseRootFromParent_Done,
     /* 545577 */   // Label 7184: @545577
     /* 545577 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(545712), // Rule ID 12992 //
     /* 545582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 545585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 545609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 545613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545666 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 545669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 545686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 545691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545710 */     GIR_RootConstrainSelectedInstOperands,
     /* 545711 */     // GIR_Coverage, 12992,
     /* 545711 */     GIR_EraseRootFromParent_Done,
     /* 545712 */   // Label 7185: @545712
     /* 545712 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(545847), // Rule ID 12993 //
     /* 545717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 545720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 545744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 545748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545801 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 545804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 545811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 545816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 545821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 545826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545845 */     GIR_RootConstrainSelectedInstOperands,
     /* 545846 */     // GIR_Coverage, 12993,
     /* 545846 */     GIR_EraseRootFromParent_Done,
     /* 545847 */   // Label 7186: @545847
     /* 545847 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(545982), // Rule ID 12994 //
     /* 545852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 545855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 545871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 545875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 545879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 545883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 545887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 545891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 545895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 545899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 545899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 545904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 545904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 545909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 545913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 545915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 545936 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 545936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 545939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 545941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 545946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 545951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 545956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 545961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 545966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 545971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 545980 */     GIR_RootConstrainSelectedInstOperands,
     /* 545981 */     // GIR_Coverage, 12994,
     /* 545981 */     GIR_EraseRootFromParent_Done,
     /* 545982 */   // Label 7187: @545982
     /* 545982 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(546117), // Rule ID 12995 //
     /* 545987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 545990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 545994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 545998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546071 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 546074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 546081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 546086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 546101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 546106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546115 */     GIR_RootConstrainSelectedInstOperands,
     /* 546116 */     // GIR_Coverage, 12995,
     /* 546116 */     GIR_EraseRootFromParent_Done,
     /* 546117 */   // Label 7188: @546117
     /* 546117 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(546252), // Rule ID 11972 //
     /* 546122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546179 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546206 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 546226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 546231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 546236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 546241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546250 */     GIR_RootConstrainSelectedInstOperands,
     /* 546251 */     // GIR_Coverage, 11972,
     /* 546251 */     GIR_EraseRootFromParent_Done,
     /* 546252 */   // Label 7189: @546252
     /* 546252 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(546387), // Rule ID 11973 //
     /* 546257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546341 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 546361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 546366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 546371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 546376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546385 */     GIR_RootConstrainSelectedInstOperands,
     /* 546386 */     // GIR_Coverage, 11973,
     /* 546386 */     GIR_EraseRootFromParent_Done,
     /* 546387 */   // Label 7190: @546387
     /* 546387 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(546522), // Rule ID 11974 //
     /* 546392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546476 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 546486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 546491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 546506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 546511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546520 */     GIR_RootConstrainSelectedInstOperands,
     /* 546521 */     // GIR_Coverage, 11974,
     /* 546521 */     GIR_EraseRootFromParent_Done,
     /* 546522 */   // Label 7191: @546522
     /* 546522 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(546657), // Rule ID 11975 //
     /* 546527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 546530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 546534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546611 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 546614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 546621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 546626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 546631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 546636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 546641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 546646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546655 */     GIR_RootConstrainSelectedInstOperands,
     /* 546656 */     // GIR_Coverage, 11975,
     /* 546656 */     GIR_EraseRootFromParent_Done,
     /* 546657 */   // Label 7192: @546657
     /* 546657 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(546792), // Rule ID 12452 //
     /* 546662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 546665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 546669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546746 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 546749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 546766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 546771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 546776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 546781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546790 */     GIR_RootConstrainSelectedInstOperands,
     /* 546791 */     // GIR_Coverage, 12452,
     /* 546791 */     GIR_EraseRootFromParent_Done,
     /* 546792 */   // Label 7193: @546792
     /* 546792 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(546927), // Rule ID 12453 //
     /* 546797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 546800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 546804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 546881 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 546881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 546884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 546886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 546891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 546896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 546901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 546906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 546911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 546916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 546925 */     GIR_RootConstrainSelectedInstOperands,
     /* 546926 */     // GIR_Coverage, 12453,
     /* 546926 */     GIR_EraseRootFromParent_Done,
     /* 546927 */   // Label 7194: @546927
     /* 546927 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(547062), // Rule ID 12454 //
     /* 546932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 546935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 546939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 546943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 546947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 546951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 546955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 546959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 546963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 546967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 546971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 546975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 546979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 546979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 546984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 546984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 546989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 546993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 546995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547016 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 547026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 547031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 547046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 547051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547060 */     GIR_RootConstrainSelectedInstOperands,
     /* 547061 */     // GIR_Coverage, 12454,
     /* 547061 */     GIR_EraseRootFromParent_Done,
     /* 547062 */   // Label 7195: @547062
     /* 547062 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(547197), // Rule ID 12455 //
     /* 547067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 547070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 547074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 547094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 547114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547151 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 547154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 547161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 547166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 547181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 547186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547195 */     GIR_RootConstrainSelectedInstOperands,
     /* 547196 */     // GIR_Coverage, 12455,
     /* 547196 */     GIR_EraseRootFromParent_Done,
     /* 547197 */   // Label 7196: @547197
     /* 547197 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(547332), // Rule ID 12932 //
     /* 547202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 547229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 547249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547286 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 547289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 547306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 547311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 547316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 547321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547330 */     GIR_RootConstrainSelectedInstOperands,
     /* 547331 */     // GIR_Coverage, 12932,
     /* 547331 */     GIR_EraseRootFromParent_Done,
     /* 547332 */   // Label 7197: @547332
     /* 547332 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(547467), // Rule ID 12933 //
     /* 547337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 547364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 547384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547421 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 547424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 547431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 547436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 547441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 547446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 547451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 547456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547465 */     GIR_RootConstrainSelectedInstOperands,
     /* 547466 */     // GIR_Coverage, 12933,
     /* 547466 */     GIR_EraseRootFromParent_Done,
     /* 547467 */   // Label 7198: @547467
     /* 547467 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(547602), // Rule ID 12934 //
     /* 547472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 547499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 547519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547524 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547556 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 547559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 547566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 547571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 547586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 547591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547600 */     GIR_RootConstrainSelectedInstOperands,
     /* 547601 */     // GIR_Coverage, 12934,
     /* 547601 */     GIR_EraseRootFromParent_Done,
     /* 547602 */   // Label 7199: @547602
     /* 547602 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(547737), // Rule ID 12935 //
     /* 547607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 547610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 547634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 547638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 547654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547691 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 547694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 547701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 547706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 547721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 547726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547735 */     GIR_RootConstrainSelectedInstOperands,
     /* 547736 */     // GIR_Coverage, 12935,
     /* 547736 */     GIR_EraseRootFromParent_Done,
     /* 547737 */   // Label 7200: @547737
     /* 547737 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(547872), // Rule ID 12043 //
     /* 547742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 547745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 547773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547826 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 547829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547870 */     GIR_RootConstrainSelectedInstOperands,
     /* 547871 */     // GIR_Coverage, 12043,
     /* 547871 */     GIR_EraseRootFromParent_Done,
     /* 547872 */   // Label 7201: @547872
     /* 547872 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(548007), // Rule ID 12044 //
     /* 547877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 547880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 547884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 547888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 547896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 547900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 547904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 547908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 547912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 547916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 547920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 547924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 547924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 547929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 547929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 547934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 547938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 547940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 547961 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 547961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 547964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 547966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 547971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 547976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 547981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 547986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 547991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 547996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 547999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548005 */     GIR_RootConstrainSelectedInstOperands,
     /* 548006 */     // GIR_Coverage, 12044,
     /* 548006 */     GIR_EraseRootFromParent_Done,
     /* 548007 */   // Label 7202: @548007
     /* 548007 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(548142), // Rule ID 12045 //
     /* 548012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548096 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548140 */     GIR_RootConstrainSelectedInstOperands,
     /* 548141 */     // GIR_Coverage, 12045,
     /* 548141 */     GIR_EraseRootFromParent_Done,
     /* 548142 */   // Label 7203: @548142
     /* 548142 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(548277), // Rule ID 12046 //
     /* 548147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 548150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548199 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548231 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 548234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548275 */     GIR_RootConstrainSelectedInstOperands,
     /* 548276 */     // GIR_Coverage, 12046,
     /* 548276 */     GIR_EraseRootFromParent_Done,
     /* 548277 */   // Label 7204: @548277
     /* 548277 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(548412), // Rule ID 12523 //
     /* 548282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 548285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 548289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548329 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548366 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 548369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548410 */     GIR_RootConstrainSelectedInstOperands,
     /* 548411 */     // GIR_Coverage, 12523,
     /* 548411 */     GIR_EraseRootFromParent_Done,
     /* 548412 */   // Label 7205: @548412
     /* 548412 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(548547), // Rule ID 12524 //
     /* 548417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 548420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 548424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548464 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548501 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 548504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548545 */     GIR_RootConstrainSelectedInstOperands,
     /* 548546 */     // GIR_Coverage, 12524,
     /* 548546 */     GIR_EraseRootFromParent_Done,
     /* 548547 */   // Label 7206: @548547
     /* 548547 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(548682), // Rule ID 12525 //
     /* 548552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 548555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 548559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548636 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 548639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548680 */     GIR_RootConstrainSelectedInstOperands,
     /* 548681 */     // GIR_Coverage, 12525,
     /* 548681 */     GIR_EraseRootFromParent_Done,
     /* 548682 */   // Label 7207: @548682
     /* 548682 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(548817), // Rule ID 12526 //
     /* 548687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 548690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 548694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548771 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 548774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 548781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 548786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 548791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 548796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548815 */     GIR_RootConstrainSelectedInstOperands,
     /* 548816 */     // GIR_Coverage, 12526,
     /* 548816 */     GIR_EraseRootFromParent_Done,
     /* 548817 */   // Label 7208: @548817
     /* 548817 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(548952), // Rule ID 13003 //
     /* 548822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 548825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 548865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 548869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 548874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 548874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 548879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 548883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 548885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 548906 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 548906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 548909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 548911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 548916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 548921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 548926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 548931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 548936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 548941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 548950 */     GIR_RootConstrainSelectedInstOperands,
     /* 548951 */     // GIR_Coverage, 13003,
     /* 548951 */     GIR_EraseRootFromParent_Done,
     /* 548952 */   // Label 7209: @548952
     /* 548952 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(549087), // Rule ID 13004 //
     /* 548957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 548960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 548964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 548968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 548972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 548976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 548980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 548984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 548988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 548992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 548996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549004 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549009 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549041 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549085 */     GIR_RootConstrainSelectedInstOperands,
     /* 549086 */     // GIR_Coverage, 13004,
     /* 549086 */     GIR_EraseRootFromParent_Done,
     /* 549087 */   // Label 7210: @549087
     /* 549087 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(549222), // Rule ID 13005 //
     /* 549092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549139 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549144 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549176 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549220 */     GIR_RootConstrainSelectedInstOperands,
     /* 549221 */     // GIR_Coverage, 13005,
     /* 549221 */     GIR_EraseRootFromParent_Done,
     /* 549222 */   // Label 7211: @549222
     /* 549222 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(549357), // Rule ID 13006 //
     /* 549227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 549230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549311 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 549314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549355 */     GIR_RootConstrainSelectedInstOperands,
     /* 549356 */     // GIR_Coverage, 13006,
     /* 549356 */     GIR_EraseRootFromParent_Done,
     /* 549357 */   // Label 7212: @549357
     /* 549357 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(549492), // Rule ID 11983 //
     /* 549362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 549365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549446 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 549449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549490 */     GIR_RootConstrainSelectedInstOperands,
     /* 549491 */     // GIR_Coverage, 11983,
     /* 549491 */     GIR_EraseRootFromParent_Done,
     /* 549492 */   // Label 7213: @549492
     /* 549492 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(549627), // Rule ID 11984 //
     /* 549497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 549500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549581 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 549584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 549596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 549601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 549606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549625 */     GIR_RootConstrainSelectedInstOperands,
     /* 549626 */     // GIR_Coverage, 11984,
     /* 549626 */     GIR_EraseRootFromParent_Done,
     /* 549627 */   // Label 7214: @549627
     /* 549627 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(549762), // Rule ID 11985 //
     /* 549632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 549635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549716 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 549719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549760 */     GIR_RootConstrainSelectedInstOperands,
     /* 549761 */     // GIR_Coverage, 11985,
     /* 549761 */     GIR_EraseRootFromParent_Done,
     /* 549762 */   // Label 7215: @549762
     /* 549762 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(549897), // Rule ID 11986 //
     /* 549767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 549770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 549774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549814 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549819 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549824 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549851 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 549854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 549861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 549866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 549871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 549876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 549881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 549886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 549895 */     GIR_RootConstrainSelectedInstOperands,
     /* 549896 */     // GIR_Coverage, 11986,
     /* 549896 */     GIR_EraseRootFromParent_Done,
     /* 549897 */   // Label 7216: @549897
     /* 549897 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(550032), // Rule ID 12463 //
     /* 549902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 549905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 549909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 549913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 549917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 549921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 549925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 549929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 549933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 549937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 549941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 549945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 549949 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 549949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 549954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 549954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 549959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 549963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 549965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 549986 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 549986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 549989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 549991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 549996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550030 */     GIR_RootConstrainSelectedInstOperands,
     /* 550031 */     // GIR_Coverage, 12463,
     /* 550031 */     GIR_EraseRootFromParent_Done,
     /* 550032 */   // Label 7217: @550032
     /* 550032 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(550167), // Rule ID 12464 //
     /* 550037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 550064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550121 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550165 */     GIR_RootConstrainSelectedInstOperands,
     /* 550166 */     // GIR_Coverage, 12464,
     /* 550166 */     GIR_EraseRootFromParent_Done,
     /* 550167 */   // Label 7218: @550167
     /* 550167 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(550302), // Rule ID 12465 //
     /* 550172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 550199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550256 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550300 */     GIR_RootConstrainSelectedInstOperands,
     /* 550301 */     // GIR_Coverage, 12465,
     /* 550301 */     GIR_EraseRootFromParent_Done,
     /* 550302 */   // Label 7219: @550302
     /* 550302 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(550437), // Rule ID 12466 //
     /* 550307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 550310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 550314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 550334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550391 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 550394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550435 */     GIR_RootConstrainSelectedInstOperands,
     /* 550436 */     // GIR_Coverage, 12466,
     /* 550436 */     GIR_EraseRootFromParent_Done,
     /* 550437 */   // Label 7220: @550437
     /* 550437 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(550572), // Rule ID 12943 //
     /* 550442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 550445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 550469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550494 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550526 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 550529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550570 */     GIR_RootConstrainSelectedInstOperands,
     /* 550571 */     // GIR_Coverage, 12943,
     /* 550571 */     GIR_EraseRootFromParent_Done,
     /* 550572 */   // Label 7221: @550572
     /* 550572 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(550707), // Rule ID 12944 //
     /* 550577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 550580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 550604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550624 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550661 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 550664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 550671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 550676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 550681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 550686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550705 */     GIR_RootConstrainSelectedInstOperands,
     /* 550706 */     // GIR_Coverage, 12944,
     /* 550706 */     GIR_EraseRootFromParent_Done,
     /* 550707 */   // Label 7222: @550707
     /* 550707 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(550842), // Rule ID 12945 //
     /* 550712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 550715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 550739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550796 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 550799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550840 */     GIR_RootConstrainSelectedInstOperands,
     /* 550841 */     // GIR_Coverage, 12945,
     /* 550841 */     GIR_EraseRootFromParent_Done,
     /* 550842 */   // Label 7223: @550842
     /* 550842 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(550977), // Rule ID 12946 //
     /* 550847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 550850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 550866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 550870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 550874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 550878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 550882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 550886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 550890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 550894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 550894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 550899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 550899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 550904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 550908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 550910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 550931 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 550931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 550934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 550936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 550941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 550946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 550951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 550956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 550961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 550966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 550975 */     GIR_RootConstrainSelectedInstOperands,
     /* 550976 */     // GIR_Coverage, 12946,
     /* 550976 */     GIR_EraseRootFromParent_Done,
     /* 550977 */   // Label 7224: @550977
     /* 550977 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(551112), // Rule ID 12028 //
     /* 550982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 550985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 550989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 550993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 550997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551066 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551110 */     GIR_RootConstrainSelectedInstOperands,
     /* 551111 */     // GIR_Coverage, 12028,
     /* 551111 */     GIR_EraseRootFromParent_Done,
     /* 551112 */   // Label 7225: @551112
     /* 551112 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(551247), // Rule ID 12029 //
     /* 551117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551201 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551245 */     GIR_RootConstrainSelectedInstOperands,
     /* 551246 */     // GIR_Coverage, 12029,
     /* 551246 */     GIR_EraseRootFromParent_Done,
     /* 551247 */   // Label 7226: @551247
     /* 551247 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(551382), // Rule ID 12030 //
     /* 551252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551299 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551336 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551380 */     GIR_RootConstrainSelectedInstOperands,
     /* 551381 */     // GIR_Coverage, 12030,
     /* 551381 */     GIR_EraseRootFromParent_Done,
     /* 551382 */   // Label 7227: @551382
     /* 551382 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(551517), // Rule ID 12031 //
     /* 551387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 551390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 551394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551434 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551471 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 551474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551515 */     GIR_RootConstrainSelectedInstOperands,
     /* 551516 */     // GIR_Coverage, 12031,
     /* 551516 */     GIR_EraseRootFromParent_Done,
     /* 551517 */   // Label 7228: @551517
     /* 551517 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(551652), // Rule ID 12508 //
     /* 551522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 551525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 551529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551606 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 551609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551650 */     GIR_RootConstrainSelectedInstOperands,
     /* 551651 */     // GIR_Coverage, 12508,
     /* 551651 */     GIR_EraseRootFromParent_Done,
     /* 551652 */   // Label 7229: @551652
     /* 551652 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(551787), // Rule ID 12509 //
     /* 551657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 551660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 551664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551741 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 551744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 551751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 551756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 551761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 551766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551785 */     GIR_RootConstrainSelectedInstOperands,
     /* 551786 */     // GIR_Coverage, 12509,
     /* 551786 */     GIR_EraseRootFromParent_Done,
     /* 551787 */   // Label 7230: @551787
     /* 551787 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(551922), // Rule ID 12510 //
     /* 551792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 551795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 551799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551876 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 551876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 551879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 551881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 551886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 551891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 551896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 551901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 551906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 551911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 551920 */     GIR_RootConstrainSelectedInstOperands,
     /* 551921 */     // GIR_Coverage, 12510,
     /* 551921 */     GIR_EraseRootFromParent_Done,
     /* 551922 */   // Label 7231: @551922
     /* 551922 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(552057), // Rule ID 12511 //
     /* 551927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 551930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 551934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 551938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 551946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 551950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 551954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 551958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 551962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 551966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 551970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 551974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 551974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 551979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 551979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 551984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 551988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 551990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 551997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552011 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 552014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552055 */     GIR_RootConstrainSelectedInstOperands,
     /* 552056 */     // GIR_Coverage, 12511,
     /* 552056 */     GIR_EraseRootFromParent_Done,
     /* 552057 */   // Label 7232: @552057
     /* 552057 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(552192), // Rule ID 12988 //
     /* 552062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 552089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 552105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 552114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 552119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552146 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552190 */     GIR_RootConstrainSelectedInstOperands,
     /* 552191 */     // GIR_Coverage, 12988,
     /* 552191 */     GIR_EraseRootFromParent_Done,
     /* 552192 */   // Label 7233: @552192
     /* 552192 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(552327), // Rule ID 12989 //
     /* 552197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 552224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 552240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 552249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 552254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552281 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552325 */     GIR_RootConstrainSelectedInstOperands,
     /* 552326 */     // GIR_Coverage, 12989,
     /* 552326 */     GIR_EraseRootFromParent_Done,
     /* 552327 */   // Label 7234: @552327
     /* 552327 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(552462), // Rule ID 12990 //
     /* 552332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 552359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 552375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 552384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 552389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552416 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552460 */     GIR_RootConstrainSelectedInstOperands,
     /* 552461 */     // GIR_Coverage, 12990,
     /* 552461 */     GIR_EraseRootFromParent_Done,
     /* 552462 */   // Label 7235: @552462
     /* 552462 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(552597), // Rule ID 12991 //
     /* 552467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 552470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 552494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 552510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 552519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 552524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552551 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 552554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552595 */     GIR_RootConstrainSelectedInstOperands,
     /* 552596 */     // GIR_Coverage, 12991,
     /* 552596 */     GIR_EraseRootFromParent_Done,
     /* 552597 */   // Label 7236: @552597
     /* 552597 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(552732), // Rule ID 11968 //
     /* 552602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 552605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 552629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 552645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 552654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 552659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552686 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 552689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552730 */     GIR_RootConstrainSelectedInstOperands,
     /* 552731 */     // GIR_Coverage, 11968,
     /* 552731 */     GIR_EraseRootFromParent_Done,
     /* 552732 */   // Label 7237: @552732
     /* 552732 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(552867), // Rule ID 11969 //
     /* 552737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 552740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 552764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 552780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 552789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 552794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552821 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 552824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 552831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 552836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 552841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 552846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552865 */     GIR_RootConstrainSelectedInstOperands,
     /* 552866 */     // GIR_Coverage, 11969,
     /* 552866 */     GIR_EraseRootFromParent_Done,
     /* 552867 */   // Label 7238: @552867
     /* 552867 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(553002), // Rule ID 11970 //
     /* 552872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 552875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 552879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 552883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 552887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 552891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 552895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 552899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 552903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 552907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 552911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 552915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 552919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 552919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 552924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 552924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 552929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 552933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 552935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 552956 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 552956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 552959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 552961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 552966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 552971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 552976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 552981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 552986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 552991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 552997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553000 */     GIR_RootConstrainSelectedInstOperands,
     /* 553001 */     // GIR_Coverage, 11970,
     /* 553001 */     GIR_EraseRootFromParent_Done,
     /* 553002 */   // Label 7239: @553002
     /* 553002 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(553137), // Rule ID 11971 //
     /* 553007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 553010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 553059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 553064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553091 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 553094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553135 */     GIR_RootConstrainSelectedInstOperands,
     /* 553136 */     // GIR_Coverage, 11971,
     /* 553136 */     GIR_EraseRootFromParent_Done,
     /* 553137 */   // Label 7240: @553137
     /* 553137 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(553272), // Rule ID 12448 //
     /* 553142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 553194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 553199 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553212 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553226 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 553229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553270 */     GIR_RootConstrainSelectedInstOperands,
     /* 553271 */     // GIR_Coverage, 12448,
     /* 553271 */     GIR_EraseRootFromParent_Done,
     /* 553272 */   // Label 7241: @553272
     /* 553272 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(553407), // Rule ID 12449 //
     /* 553277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553324 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 553329 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 553334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553361 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 553364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553405 */     GIR_RootConstrainSelectedInstOperands,
     /* 553406 */     // GIR_Coverage, 12449,
     /* 553406 */     GIR_EraseRootFromParent_Done,
     /* 553407 */   // Label 7242: @553407
     /* 553407 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(553542), // Rule ID 12450 //
     /* 553412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553459 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 553464 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 553469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553496 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 553499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553540 */     GIR_RootConstrainSelectedInstOperands,
     /* 553541 */     // GIR_Coverage, 12450,
     /* 553541 */     GIR_EraseRootFromParent_Done,
     /* 553542 */   // Label 7243: @553542
     /* 553542 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(553677), // Rule ID 12451 //
     /* 553547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 553550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 553554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553594 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 553599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 553604 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553631 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 553634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 553641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 553646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 553651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 553656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553675 */     GIR_RootConstrainSelectedInstOperands,
     /* 553676 */     // GIR_Coverage, 12451,
     /* 553676 */     GIR_EraseRootFromParent_Done,
     /* 553677 */   // Label 7244: @553677
     /* 553677 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(553812), // Rule ID 12928 //
     /* 553682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 553685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 553734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 553739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553752 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553766 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 553769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553810 */     GIR_RootConstrainSelectedInstOperands,
     /* 553811 */     // GIR_Coverage, 12928,
     /* 553811 */     GIR_EraseRootFromParent_Done,
     /* 553812 */   // Label 7245: @553812
     /* 553812 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(553947), // Rule ID 12929 //
     /* 553817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 553820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 553864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 553869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 553874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 553878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 553880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553887 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 553901 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 553901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 553904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 553906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 553911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 553916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 553921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 553926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 553931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 553936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 553945 */     GIR_RootConstrainSelectedInstOperands,
     /* 553946 */     // GIR_Coverage, 12929,
     /* 553946 */     GIR_EraseRootFromParent_Done,
     /* 553947 */   // Label 7246: @553947
     /* 553947 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(554082), // Rule ID 12930 //
     /* 553952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 553955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 553959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 553963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 553967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 553971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 553975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 553979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 553983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 553987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 553991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 553995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 553999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 553999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 554004 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 554009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554036 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554080 */     GIR_RootConstrainSelectedInstOperands,
     /* 554081 */     // GIR_Coverage, 12930,
     /* 554081 */     GIR_EraseRootFromParent_Done,
     /* 554082 */   // Label 7247: @554082
     /* 554082 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(554217), // Rule ID 12931 //
     /* 554087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 554090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 554114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 554118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 554130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 554139 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 554144 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554171 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 554174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554215 */     GIR_RootConstrainSelectedInstOperands,
     /* 554216 */     // GIR_Coverage, 12931,
     /* 554216 */     GIR_EraseRootFromParent_Done,
     /* 554217 */   // Label 7248: @554217
     /* 554217 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(554352), // Rule ID 11977 //
     /* 554222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 554225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 554265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554269 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554279 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554306 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 554309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554350 */     GIR_RootConstrainSelectedInstOperands,
     /* 554351 */     // GIR_Coverage, 11977,
     /* 554351 */     GIR_EraseRootFromParent_Done,
     /* 554352 */   // Label 7249: @554352
     /* 554352 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(554487), // Rule ID 11978 //
     /* 554357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 554360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 554400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554441 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 554444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554485 */     GIR_RootConstrainSelectedInstOperands,
     /* 554486 */     // GIR_Coverage, 11978,
     /* 554486 */     GIR_EraseRootFromParent_Done,
     /* 554487 */   // Label 7250: @554487
     /* 554487 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(554622), // Rule ID 11981 //
     /* 554492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 554495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 554535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554555 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554576 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 554579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554620 */     GIR_RootConstrainSelectedInstOperands,
     /* 554621 */     // GIR_Coverage, 11981,
     /* 554621 */     GIR_EraseRootFromParent_Done,
     /* 554622 */   // Label 7251: @554622
     /* 554622 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(554757), // Rule ID 11982 //
     /* 554627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 554630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 554634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 554670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554684 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554711 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 554714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 554721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 554726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 554731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 554736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554755 */     GIR_RootConstrainSelectedInstOperands,
     /* 554756 */     // GIR_Coverage, 11982,
     /* 554756 */     GIR_EraseRootFromParent_Done,
     /* 554757 */   // Label 7252: @554757
     /* 554757 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(554892), // Rule ID 12457 //
     /* 554762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 554765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 554769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 554805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554814 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554846 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 554866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 554871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 554876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 554881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 554890 */     GIR_RootConstrainSelectedInstOperands,
     /* 554891 */     // GIR_Coverage, 12457,
     /* 554891 */     GIR_EraseRootFromParent_Done,
     /* 554892 */   // Label 7253: @554892
     /* 554892 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(555027), // Rule ID 12458 //
     /* 554897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 554900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 554904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 554908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 554912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 554916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 554920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 554924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 554928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 554932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 554936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 554940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 554944 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 554944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 554949 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 554949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 554954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 554958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 554960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 554981 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 554981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 554984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 554986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 554991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 554996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555025 */     GIR_RootConstrainSelectedInstOperands,
     /* 555026 */     // GIR_Coverage, 12458,
     /* 555026 */     GIR_EraseRootFromParent_Done,
     /* 555027 */   // Label 7254: @555027
     /* 555027 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(555162), // Rule ID 12461 //
     /* 555032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 555075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 555079 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555089 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555116 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555160 */     GIR_RootConstrainSelectedInstOperands,
     /* 555161 */     // GIR_Coverage, 12461,
     /* 555161 */     GIR_EraseRootFromParent_Done,
     /* 555162 */   // Label 7255: @555162
     /* 555162 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(555297), // Rule ID 12462 //
     /* 555167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 555170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 555174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 555210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 555214 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555251 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 555254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555295 */     GIR_RootConstrainSelectedInstOperands,
     /* 555296 */     // GIR_Coverage, 12462,
     /* 555296 */     GIR_EraseRootFromParent_Done,
     /* 555297 */   // Label 7256: @555297
     /* 555297 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(555432), // Rule ID 12937 //
     /* 555302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 555305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 555345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 555349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555386 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 555389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555430 */     GIR_RootConstrainSelectedInstOperands,
     /* 555431 */     // GIR_Coverage, 12937,
     /* 555431 */     GIR_EraseRootFromParent_Done,
     /* 555432 */   // Label 7257: @555432
     /* 555432 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(555567), // Rule ID 12938 //
     /* 555437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 555440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 555480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 555484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555521 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 555524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555565 */     GIR_RootConstrainSelectedInstOperands,
     /* 555566 */     // GIR_Coverage, 12938,
     /* 555566 */     GIR_EraseRootFromParent_Done,
     /* 555567 */   // Label 7258: @555567
     /* 555567 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(555702), // Rule ID 12941 //
     /* 555572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 555575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 555615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 555619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555624 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555642 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555649 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555656 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 555659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555700 */     GIR_RootConstrainSelectedInstOperands,
     /* 555701 */     // GIR_Coverage, 12941,
     /* 555701 */     GIR_EraseRootFromParent_Done,
     /* 555702 */   // Label 7259: @555702
     /* 555702 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(555837), // Rule ID 12942 //
     /* 555707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 555710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 555750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 555754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555764 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555784 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555791 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 555794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 555801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 555806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 555811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 555816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555835 */     GIR_RootConstrainSelectedInstOperands,
     /* 555836 */     // GIR_Coverage, 12942,
     /* 555836 */     GIR_EraseRootFromParent_Done,
     /* 555837 */   // Label 7260: @555837
     /* 555837 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(555972), // Rule ID 11962 //
     /* 555842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 555865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 555869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 555873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 555877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 555881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 555885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 555889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 555889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 555894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 555894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 555899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 555903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 555905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555919 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 555926 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 555926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 555929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 555931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 555936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 555941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 555946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 555951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 555956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 555961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 555970 */     GIR_RootConstrainSelectedInstOperands,
     /* 555971 */     // GIR_Coverage, 11962,
     /* 555971 */     GIR_EraseRootFromParent_Done,
     /* 555972 */   // Label 7261: @555972
     /* 555972 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(556107), // Rule ID 11963 //
     /* 555977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 555980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 555984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 555988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 555992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 555996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556061 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556105 */     GIR_RootConstrainSelectedInstOperands,
     /* 556106 */     // GIR_Coverage, 11963,
     /* 556106 */     GIR_EraseRootFromParent_Done,
     /* 556107 */   // Label 7262: @556107
     /* 556107 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(556242), // Rule ID 11966 //
     /* 556112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556169 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556189 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556196 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556240 */     GIR_RootConstrainSelectedInstOperands,
     /* 556241 */     // GIR_Coverage, 11966,
     /* 556241 */     GIR_EraseRootFromParent_Done,
     /* 556242 */   // Label 7263: @556242
     /* 556242 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(556377), // Rule ID 11967 //
     /* 556247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 556250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556282 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556299 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556310 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556331 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 556334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556375 */     GIR_RootConstrainSelectedInstOperands,
     /* 556376 */     // GIR_Coverage, 11967,
     /* 556376 */     GIR_EraseRootFromParent_Done,
     /* 556377 */   // Label 7264: @556377
     /* 556377 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(556512), // Rule ID 12442 //
     /* 556382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 556385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 556389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556434 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556439 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556466 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 556469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556510 */     GIR_RootConstrainSelectedInstOperands,
     /* 556511 */     // GIR_Coverage, 12442,
     /* 556511 */     GIR_EraseRootFromParent_Done,
     /* 556512 */   // Label 7265: @556512
     /* 556512 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(556647), // Rule ID 12443 //
     /* 556517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 556520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 556524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556587 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556601 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 556604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 556611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 556616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 556621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 556626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556645 */     GIR_RootConstrainSelectedInstOperands,
     /* 556646 */     // GIR_Coverage, 12443,
     /* 556646 */     GIR_EraseRootFromParent_Done,
     /* 556647 */   // Label 7266: @556647
     /* 556647 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(556782), // Rule ID 12446 //
     /* 556652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 556655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 556659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556736 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 556739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556780 */     GIR_RootConstrainSelectedInstOperands,
     /* 556781 */     // GIR_Coverage, 12446,
     /* 556781 */     GIR_EraseRootFromParent_Done,
     /* 556782 */   // Label 7267: @556782
     /* 556782 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(556917), // Rule ID 12447 //
     /* 556787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 556790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 556794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556844 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556871 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 556871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 556874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 556876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 556881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 556886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 556891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 556896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 556901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 556906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 556915 */     GIR_RootConstrainSelectedInstOperands,
     /* 556916 */     // GIR_Coverage, 12447,
     /* 556916 */     GIR_EraseRootFromParent_Done,
     /* 556917 */   // Label 7268: @556917
     /* 556917 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(557052), // Rule ID 12922 //
     /* 556922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 556925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 556929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 556933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 556937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 556941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 556945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 556949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 556953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 556957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 556961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 556965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 556969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 556969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 556974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 556974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 556979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 556983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 556985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 556999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557006 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557050 */     GIR_RootConstrainSelectedInstOperands,
     /* 557051 */     // GIR_Coverage, 12922,
     /* 557051 */     GIR_EraseRootFromParent_Done,
     /* 557052 */   // Label 7269: @557052
     /* 557052 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(557187), // Rule ID 12923 //
     /* 557057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 557088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 557104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557141 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557185 */     GIR_RootConstrainSelectedInstOperands,
     /* 557186 */     // GIR_Coverage, 12923,
     /* 557186 */     GIR_EraseRootFromParent_Done,
     /* 557187 */   // Label 7270: @557187
     /* 557187 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(557322), // Rule ID 12926 //
     /* 557192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 557223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 557239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557269 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557276 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557320 */     GIR_RootConstrainSelectedInstOperands,
     /* 557321 */     // GIR_Coverage, 12926,
     /* 557321 */     GIR_EraseRootFromParent_Done,
     /* 557322 */   // Label 7271: @557322
     /* 557322 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(557457), // Rule ID 12927 //
     /* 557327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 557358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 557370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 557374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557411 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 557421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 557426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 557431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 557436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557455 */     GIR_RootConstrainSelectedInstOperands,
     /* 557456 */     // GIR_Coverage, 12927,
     /* 557456 */     GIR_EraseRootFromParent_Done,
     /* 557457 */   // Label 7272: @557457
     /* 557457 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(557592), // Rule ID 7752 //
     /* 557462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 557465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 557493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 557505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557519 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557546 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 557549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557590 */     GIR_RootConstrainSelectedInstOperands,
     /* 557591 */     // GIR_Coverage, 7752,
     /* 557591 */     GIR_EraseRootFromParent_Done,
     /* 557592 */   // Label 7273: @557592
     /* 557592 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(557727), // Rule ID 7784 //
     /* 557597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 557600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 557604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 557628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 557640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557644 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557649 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557681 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 557684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557725 */     GIR_RootConstrainSelectedInstOperands,
     /* 557726 */     // GIR_Coverage, 7784,
     /* 557726 */     GIR_EraseRootFromParent_Done,
     /* 557727 */   // Label 7274: @557727
     /* 557727 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(557862), // Rule ID 7816 //
     /* 557732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 557735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 557763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 557775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557816 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 557819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557860 */     GIR_RootConstrainSelectedInstOperands,
     /* 557861 */     // GIR_Coverage, 7816,
     /* 557861 */     GIR_EraseRootFromParent_Done,
     /* 557862 */   // Label 7275: @557862
     /* 557862 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(557997), // Rule ID 11976 //
     /* 557867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 557870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 557874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 557878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 557882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 557886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 557890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 557894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 557898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 557902 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 557906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 557910 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 557914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 557914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 557919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 557919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 557924 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 557928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 557930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 557951 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 557951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 557954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 557956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 557961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 557966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 557971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 557976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 557981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 557986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 557995 */     GIR_RootConstrainSelectedInstOperands,
     /* 557996 */     // GIR_Coverage, 11976,
     /* 557996 */     GIR_EraseRootFromParent_Done,
     /* 557997 */   // Label 7276: @557997
     /* 557997 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(558132), // Rule ID 11979 //
     /* 558002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558059 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558079 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558086 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558130 */     GIR_RootConstrainSelectedInstOperands,
     /* 558131 */     // GIR_Coverage, 11979,
     /* 558131 */     GIR_EraseRootFromParent_Done,
     /* 558132 */   // Label 7277: @558132
     /* 558132 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(558267), // Rule ID 11980 //
     /* 558137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 558140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558189 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558214 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558221 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 558224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558265 */     GIR_RootConstrainSelectedInstOperands,
     /* 558266 */     // GIR_Coverage, 11980,
     /* 558266 */     GIR_EraseRootFromParent_Done,
     /* 558267 */   // Label 7278: @558267
     /* 558267 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(558402), // Rule ID 12456 //
     /* 558272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558319 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558324 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558349 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558356 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558400 */     GIR_RootConstrainSelectedInstOperands,
     /* 558401 */     // GIR_Coverage, 12456,
     /* 558401 */     GIR_EraseRootFromParent_Done,
     /* 558402 */   // Label 7279: @558402
     /* 558402 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(558537), // Rule ID 12459 //
     /* 558407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558454 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558459 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558464 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558491 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558535 */     GIR_RootConstrainSelectedInstOperands,
     /* 558536 */     // GIR_Coverage, 12459,
     /* 558536 */     GIR_EraseRootFromParent_Done,
     /* 558537 */   // Label 7280: @558537
     /* 558537 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(558672), // Rule ID 12460 //
     /* 558542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 558545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 558549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558589 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558594 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558599 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558612 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558626 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 558629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558670 */     GIR_RootConstrainSelectedInstOperands,
     /* 558671 */     // GIR_Coverage, 12460,
     /* 558671 */     GIR_EraseRootFromParent_Done,
     /* 558672 */   // Label 7281: @558672
     /* 558672 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(558807), // Rule ID 12936 //
     /* 558677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 558680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558724 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558729 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558729 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558734 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558738 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558740 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558761 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 558764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 558771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 558776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 558781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 558786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558805 */     GIR_RootConstrainSelectedInstOperands,
     /* 558806 */     // GIR_Coverage, 12936,
     /* 558806 */     GIR_EraseRootFromParent_Done,
     /* 558807 */   // Label 7282: @558807
     /* 558807 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(558942), // Rule ID 12939 //
     /* 558812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 558815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 558864 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 558873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 558875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 558896 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 558896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 558899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 558901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 558906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 558911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 558916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 558921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 558926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 558931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 558940 */     GIR_RootConstrainSelectedInstOperands,
     /* 558941 */     // GIR_Coverage, 12939,
     /* 558941 */     GIR_EraseRootFromParent_Done,
     /* 558942 */   // Label 7283: @558942
     /* 558942 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(559077), // Rule ID 12940 //
     /* 558947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 558950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 558954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 558958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 558962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 558966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 558970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 558974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 558978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 558982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 558986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 558990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 558994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 558994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 558999 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 558999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559004 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559031 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559075 */     GIR_RootConstrainSelectedInstOperands,
     /* 559076 */     // GIR_Coverage, 12940,
     /* 559076 */     GIR_EraseRootFromParent_Done,
     /* 559077 */   // Label 7284: @559077
     /* 559077 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(559212), // Rule ID 7751 //
     /* 559082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 559085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 559113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559129 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559134 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559166 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 559169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559210 */     GIR_RootConstrainSelectedInstOperands,
     /* 559211 */     // GIR_Coverage, 7751,
     /* 559211 */     GIR_EraseRootFromParent_Done,
     /* 559212 */   // Label 7285: @559212
     /* 559212 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(559347), // Rule ID 7783 //
     /* 559217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 559220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 559224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 559248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559264 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559269 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559294 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559301 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 559304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559345 */     GIR_RootConstrainSelectedInstOperands,
     /* 559346 */     // GIR_Coverage, 7783,
     /* 559346 */     GIR_EraseRootFromParent_Done,
     /* 559347 */   // Label 7286: @559347
     /* 559347 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(559482), // Rule ID 7815 //
     /* 559352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 559355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 559383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559399 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559404 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559404 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559409 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559436 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 559439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559480 */     GIR_RootConstrainSelectedInstOperands,
     /* 559481 */     // GIR_Coverage, 7815,
     /* 559481 */     GIR_EraseRootFromParent_Done,
     /* 559482 */   // Label 7287: @559482
     /* 559482 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(559617), // Rule ID 11961 //
     /* 559487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 559490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 559518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559522 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559539 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559571 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 559574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 559596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559615 */     GIR_RootConstrainSelectedInstOperands,
     /* 559616 */     // GIR_Coverage, 11961,
     /* 559616 */     GIR_EraseRootFromParent_Done,
     /* 559617 */   // Label 7288: @559617
     /* 559617 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(559752), // Rule ID 11964 //
     /* 559622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 559625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 559653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559674 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559683 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559706 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 559709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559750 */     GIR_RootConstrainSelectedInstOperands,
     /* 559751 */     // GIR_Coverage, 11964,
     /* 559751 */     GIR_EraseRootFromParent_Done,
     /* 559752 */   // Label 7289: @559752
     /* 559752 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(559887), // Rule ID 11965 //
     /* 559757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 559760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 559764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 559788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559804 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559809 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559809 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559841 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 559844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 559851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 559856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 559861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 559866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 559871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 559876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 559885 */     GIR_RootConstrainSelectedInstOperands,
     /* 559886 */     // GIR_Coverage, 11965,
     /* 559886 */     GIR_EraseRootFromParent_Done,
     /* 559887 */   // Label 7290: @559887
     /* 559887 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(560022), // Rule ID 12441 //
     /* 559892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 559895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 559899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 559903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 559907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 559911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 559915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 559919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 559923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 559927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 559931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 559935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 559939 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 559939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 559944 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 559944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 559949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 559953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 559955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 559976 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 559976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 559979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 559981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 559986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 559991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 559996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560020 */     GIR_RootConstrainSelectedInstOperands,
     /* 560021 */     // GIR_Coverage, 12441,
     /* 560021 */     GIR_EraseRootFromParent_Done,
     /* 560022 */   // Label 7291: @560022
     /* 560022 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(560157), // Rule ID 12444 //
     /* 560027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 560058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 560074 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560079 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560111 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560155 */     GIR_RootConstrainSelectedInstOperands,
     /* 560156 */     // GIR_Coverage, 12444,
     /* 560156 */     GIR_EraseRootFromParent_Done,
     /* 560157 */   // Label 7292: @560157
     /* 560157 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(560292), // Rule ID 12445 //
     /* 560162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 560165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 560169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 560193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 560209 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560214 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560214 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560219 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560246 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 560249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560290 */     GIR_RootConstrainSelectedInstOperands,
     /* 560291 */     // GIR_Coverage, 12445,
     /* 560291 */     GIR_EraseRootFromParent_Done,
     /* 560292 */   // Label 7293: @560292
     /* 560292 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(560427), // Rule ID 12921 //
     /* 560297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 560300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 560328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 560344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560349 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560381 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 560384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560425 */     GIR_RootConstrainSelectedInstOperands,
     /* 560426 */     // GIR_Coverage, 12921,
     /* 560426 */     GIR_EraseRootFromParent_Done,
     /* 560427 */   // Label 7294: @560427
     /* 560427 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(560562), // Rule ID 12924 //
     /* 560432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 560435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 560463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 560479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560484 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560516 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 560519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560560 */     GIR_RootConstrainSelectedInstOperands,
     /* 560561 */     // GIR_Coverage, 12924,
     /* 560561 */     GIR_EraseRootFromParent_Done,
     /* 560562 */   // Label 7295: @560562
     /* 560562 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(560697), // Rule ID 12925 //
     /* 560567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 560570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 560598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 560610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 560614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560619 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560651 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 560654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 560661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 560666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 560671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 560676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560695 */     GIR_RootConstrainSelectedInstOperands,
     /* 560696 */     // GIR_Coverage, 12925,
     /* 560696 */     GIR_EraseRootFromParent_Done,
     /* 560697 */   // Label 7296: @560697
     /* 560697 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(560832), // Rule ID 11947 //
     /* 560702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 560745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560749 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560754 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560759 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560779 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560786 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560830 */     GIR_RootConstrainSelectedInstOperands,
     /* 560831 */     // GIR_Coverage, 11947,
     /* 560831 */     GIR_EraseRootFromParent_Done,
     /* 560832 */   // Label 7297: @560832
     /* 560832 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(560967), // Rule ID 11948 //
     /* 560837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 560872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 560876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 560880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 560884 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 560884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 560889 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 560889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 560894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 560898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 560900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560907 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 560921 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 560921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 560924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 560926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 560931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 560936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 560941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 560946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 560951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 560956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 560965 */     GIR_RootConstrainSelectedInstOperands,
     /* 560966 */     // GIR_Coverage, 11948,
     /* 560966 */     GIR_EraseRootFromParent_Done,
     /* 560967 */   // Label 7298: @560967
     /* 560967 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(561102), // Rule ID 11951 //
     /* 560972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 560975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 560979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 560983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 560987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 560991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 560995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 560999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561024 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561024 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561029 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561042 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561049 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561056 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561100 */     GIR_RootConstrainSelectedInstOperands,
     /* 561101 */     // GIR_Coverage, 11951,
     /* 561101 */     GIR_EraseRootFromParent_Done,
     /* 561102 */   // Label 7299: @561102
     /* 561102 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(561237), // Rule ID 11952 //
     /* 561107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 561110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561159 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561191 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 561194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561235 */     GIR_RootConstrainSelectedInstOperands,
     /* 561236 */     // GIR_Coverage, 11952,
     /* 561236 */     GIR_EraseRootFromParent_Done,
     /* 561237 */   // Label 7300: @561237
     /* 561237 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(561372), // Rule ID 12427 //
     /* 561242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 561245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 561249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561294 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561326 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 561329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561370 */     GIR_RootConstrainSelectedInstOperands,
     /* 561371 */     // GIR_Coverage, 12427,
     /* 561371 */     GIR_EraseRootFromParent_Done,
     /* 561372 */   // Label 7301: @561372
     /* 561372 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(561507), // Rule ID 12428 //
     /* 561377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 561380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 561384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561424 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561429 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561461 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 561464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561505 */     GIR_RootConstrainSelectedInstOperands,
     /* 561506 */     // GIR_Coverage, 12428,
     /* 561506 */     GIR_EraseRootFromParent_Done,
     /* 561507 */   // Label 7302: @561507
     /* 561507 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(561642), // Rule ID 12431 //
     /* 561512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 561515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 561519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561559 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561564 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561569 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561589 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561596 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 561599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561640 */     GIR_RootConstrainSelectedInstOperands,
     /* 561641 */     // GIR_Coverage, 12431,
     /* 561641 */     GIR_EraseRootFromParent_Done,
     /* 561642 */   // Label 7303: @561642
     /* 561642 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(561777), // Rule ID 12432 //
     /* 561647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 561650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 561654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561694 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561699 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561699 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561704 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561731 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 561734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 561741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 561746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 561751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 561756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561775 */     GIR_RootConstrainSelectedInstOperands,
     /* 561776 */     // GIR_Coverage, 12432,
     /* 561776 */     GIR_EraseRootFromParent_Done,
     /* 561777 */   // Label 7304: @561777
     /* 561777 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(561912), // Rule ID 12907 //
     /* 561782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561834 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561839 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561866 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 561866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 561869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 561871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 561876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 561881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 561886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 561891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 561896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 561901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 561910 */     GIR_RootConstrainSelectedInstOperands,
     /* 561911 */     // GIR_Coverage, 12907,
     /* 561911 */     GIR_EraseRootFromParent_Done,
     /* 561912 */   // Label 7305: @561912
     /* 561912 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(562047), // Rule ID 12908 //
     /* 561917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 561920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 561924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 561928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 561936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 561940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 561944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 561948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 561952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 561956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 561960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 561964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 561964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 561969 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 561969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 561974 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 561978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 561980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 561994 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562001 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562045 */     GIR_RootConstrainSelectedInstOperands,
     /* 562046 */     // GIR_Coverage, 12908,
     /* 562046 */     GIR_EraseRootFromParent_Done,
     /* 562047 */   // Label 7306: @562047
     /* 562047 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(562182), // Rule ID 12911 //
     /* 562052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 562095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 562099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562104 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562109 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562129 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562136 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562180 */     GIR_RootConstrainSelectedInstOperands,
     /* 562181 */     // GIR_Coverage, 12911,
     /* 562181 */     GIR_EraseRootFromParent_Done,
     /* 562182 */   // Label 7307: @562182
     /* 562182 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(562317), // Rule ID 12912 //
     /* 562187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 562190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 562230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 562234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562239 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562239 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562271 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 562274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562315 */     GIR_RootConstrainSelectedInstOperands,
     /* 562316 */     // GIR_Coverage, 12912,
     /* 562316 */     GIR_EraseRootFromParent_Done,
     /* 562317 */   // Label 7308: @562317
     /* 562317 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(562452), // Rule ID 11932 //
     /* 562322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 562325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 562365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562374 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562379 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562392 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562399 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562406 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562450 */     GIR_RootConstrainSelectedInstOperands,
     /* 562451 */     // GIR_Coverage, 11932,
     /* 562451 */     GIR_EraseRootFromParent_Done,
     /* 562452 */   // Label 7309: @562452
     /* 562452 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(562587), // Rule ID 11933 //
     /* 562457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 562460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 562500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562509 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562541 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562585 */     GIR_RootConstrainSelectedInstOperands,
     /* 562586 */     // GIR_Coverage, 11933,
     /* 562586 */     GIR_EraseRootFromParent_Done,
     /* 562587 */   // Label 7310: @562587
     /* 562587 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(562722), // Rule ID 11936 //
     /* 562592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 562595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 562635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562644 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562676 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562720 */     GIR_RootConstrainSelectedInstOperands,
     /* 562721 */     // GIR_Coverage, 11936,
     /* 562721 */     GIR_EraseRootFromParent_Done,
     /* 562722 */   // Label 7311: @562722
     /* 562722 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(562857), // Rule ID 11937 //
     /* 562727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 562730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 562734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 562770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562779 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562811 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 562814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 562821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 562826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 562831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 562836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562855 */     GIR_RootConstrainSelectedInstOperands,
     /* 562856 */     // GIR_Coverage, 11937,
     /* 562856 */     GIR_EraseRootFromParent_Done,
     /* 562857 */   // Label 7312: @562857
     /* 562857 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(562992), // Rule ID 12412 //
     /* 562862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 562865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 562869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 562873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 562881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 562885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 562889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 562893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 562897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 562901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 562905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 562909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 562909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 562914 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 562914 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 562919 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 562923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 562925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 562946 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 562946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 562949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 562951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 562956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 562961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 562966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 562971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 562976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 562981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 562990 */     GIR_RootConstrainSelectedInstOperands,
     /* 562991 */     // GIR_Coverage, 12412,
     /* 562991 */     GIR_EraseRootFromParent_Done,
     /* 562992 */   // Label 7313: @562992
     /* 562992 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(563127), // Rule ID 12413 //
     /* 562997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 563040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 563044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563049 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563054 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563058 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563074 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563081 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 563091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 563096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563125 */     GIR_RootConstrainSelectedInstOperands,
     /* 563126 */     // GIR_Coverage, 12413,
     /* 563126 */     GIR_EraseRootFromParent_Done,
     /* 563127 */   // Label 7314: @563127
     /* 563127 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(563262), // Rule ID 12416 //
     /* 563132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 563175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 563179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563184 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563189 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563209 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563216 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 563236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 563241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563260 */     GIR_RootConstrainSelectedInstOperands,
     /* 563261 */     // GIR_Coverage, 12416,
     /* 563261 */     GIR_EraseRootFromParent_Done,
     /* 563262 */   // Label 7315: @563262
     /* 563262 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(563397), // Rule ID 12417 //
     /* 563267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 563270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 563274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 563310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 563314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563319 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563319 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563324 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563351 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 563354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 563371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 563376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563395 */     GIR_RootConstrainSelectedInstOperands,
     /* 563396 */     // GIR_Coverage, 12417,
     /* 563396 */     GIR_EraseRootFromParent_Done,
     /* 563397 */   // Label 7316: @563397
     /* 563397 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(563532), // Rule ID 12892 //
     /* 563402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 563405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 563445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 563449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563454 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563472 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563486 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 563489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 563496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 563501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563530 */     GIR_RootConstrainSelectedInstOperands,
     /* 563531 */     // GIR_Coverage, 12892,
     /* 563531 */     GIR_EraseRootFromParent_Done,
     /* 563532 */   // Label 7317: @563532
     /* 563532 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(563667), // Rule ID 12893 //
     /* 563537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 563540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 563580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 563584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563589 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563600 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563614 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563621 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 563624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 563631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 563636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 563641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 563646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563665 */     GIR_RootConstrainSelectedInstOperands,
     /* 563666 */     // GIR_Coverage, 12893,
     /* 563666 */     GIR_EraseRootFromParent_Done,
     /* 563667 */   // Label 7318: @563667
     /* 563667 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(563802), // Rule ID 12896 //
     /* 563672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 563675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 563715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 563719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563724 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563724 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563729 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563742 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563749 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563756 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 563759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 563776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 563781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563800 */     GIR_RootConstrainSelectedInstOperands,
     /* 563801 */     // GIR_Coverage, 12896,
     /* 563801 */     GIR_EraseRootFromParent_Done,
     /* 563802 */   // Label 7319: @563802
     /* 563802 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(563937), // Rule ID 12897 //
     /* 563807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 563810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 563850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 563854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563859 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 563868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 563870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 563891 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 563891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 563894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 563896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 563901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 563906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 563911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 563916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 563921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 563926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 563935 */     GIR_RootConstrainSelectedInstOperands,
     /* 563936 */     // GIR_Coverage, 12897,
     /* 563936 */     GIR_EraseRootFromParent_Done,
     /* 563937 */   // Label 7320: @563937
     /* 563937 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(564072), // Rule ID 7750 //
     /* 563942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 563945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 563949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 563953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 563961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 563965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 563969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 563973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 563977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 563981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 563985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 563989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 563989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 563994 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 563994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 563999 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564026 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 564036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 564041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 564056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 564061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564070 */     GIR_RootConstrainSelectedInstOperands,
     /* 564071 */     // GIR_Coverage, 7750,
     /* 564071 */     GIR_EraseRootFromParent_Done,
     /* 564072 */   // Label 7321: @564072
     /* 564072 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(564207), // Rule ID 7782 //
     /* 564077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 564080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 564084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 564104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 564120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564124 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 564129 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 564134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564161 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 564164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 564171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 564176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 564191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 564196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564205 */     GIR_RootConstrainSelectedInstOperands,
     /* 564206 */     // GIR_Coverage, 7782,
     /* 564206 */     GIR_EraseRootFromParent_Done,
     /* 564207 */   // Label 7322: @564207
     /* 564207 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(564342), // Rule ID 7814 //
     /* 564212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 564215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 564239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 564255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 564264 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 564269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564296 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 564299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 564306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 564311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 564326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 564331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564340 */     GIR_RootConstrainSelectedInstOperands,
     /* 564341 */     // GIR_Coverage, 7814,
     /* 564341 */     GIR_EraseRootFromParent_Done,
     /* 564342 */   // Label 7323: @564342
     /* 564342 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(564477), // Rule ID 11946 //
     /* 564347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 564374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 564390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564394 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 564399 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564399 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 564404 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564424 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564431 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 564441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 564446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 564461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 564466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564475 */     GIR_RootConstrainSelectedInstOperands,
     /* 564476 */     // GIR_Coverage, 11946,
     /* 564476 */     GIR_EraseRootFromParent_Done,
     /* 564477 */   // Label 7324: @564477
     /* 564477 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(564612), // Rule ID 11949 //
     /* 564482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 564509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 564525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564529 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 564534 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 564539 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564543 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564559 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564566 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 564586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 564591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 564596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 564601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564610 */     GIR_RootConstrainSelectedInstOperands,
     /* 564611 */     // GIR_Coverage, 11949,
     /* 564611 */     GIR_EraseRootFromParent_Done,
     /* 564612 */   // Label 7325: @564612
     /* 564612 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(564747), // Rule ID 11950 //
     /* 564617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 564620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 564624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 564644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 564660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 564669 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 564674 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564680 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564701 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 564704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 564721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 564726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 564731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 564736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564745 */     GIR_RootConstrainSelectedInstOperands,
     /* 564746 */     // GIR_Coverage, 11950,
     /* 564746 */     GIR_EraseRootFromParent_Done,
     /* 564747 */   // Label 7326: @564747
     /* 564747 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(564882), // Rule ID 12426 //
     /* 564752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 564755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 564759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 564779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 564795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564799 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 564804 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564804 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 564809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564836 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 564839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 564846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 564851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 564856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 564861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 564866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 564871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 564880 */     GIR_RootConstrainSelectedInstOperands,
     /* 564881 */     // GIR_Coverage, 12426,
     /* 564881 */     GIR_EraseRootFromParent_Done,
     /* 564882 */   // Label 7327: @564882
     /* 564882 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(565017), // Rule ID 12429 //
     /* 564887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 564890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 564894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 564898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 564906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 564910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 564914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 564918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 564922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 564926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 564930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 564934 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 564934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 564939 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 564939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 564944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 564948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 564950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 564971 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 564971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 564974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 564976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 564981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 564986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 564991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 564996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565015 */     GIR_RootConstrainSelectedInstOperands,
     /* 565016 */     // GIR_Coverage, 12429,
     /* 565016 */     GIR_EraseRootFromParent_Done,
     /* 565017 */   // Label 7328: @565017
     /* 565017 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(565152), // Rule ID 12430 //
     /* 565022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 565065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565069 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 565074 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565074 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 565079 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565106 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 565126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 565131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565150 */     GIR_RootConstrainSelectedInstOperands,
     /* 565151 */     // GIR_Coverage, 12430,
     /* 565151 */     GIR_EraseRootFromParent_Done,
     /* 565152 */   // Label 7329: @565152
     /* 565152 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(565287), // Rule ID 12906 //
     /* 565157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 565200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565204 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 565209 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565209 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 565214 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565234 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565241 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 565251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 565256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565285 */     GIR_RootConstrainSelectedInstOperands,
     /* 565286 */     // GIR_Coverage, 12906,
     /* 565286 */     GIR_EraseRootFromParent_Done,
     /* 565287 */   // Label 7330: @565287
     /* 565287 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(565422), // Rule ID 12909 //
     /* 565292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 565335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 565344 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565344 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 565349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565376 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 565396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 565401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565420 */     GIR_RootConstrainSelectedInstOperands,
     /* 565421 */     // GIR_Coverage, 12909,
     /* 565421 */     GIR_EraseRootFromParent_Done,
     /* 565422 */   // Label 7331: @565422
     /* 565422 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(565557), // Rule ID 12910 //
     /* 565427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 565470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 565474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 565479 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 565484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565504 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565511 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 565521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 565526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 565531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 565536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565555 */     GIR_RootConstrainSelectedInstOperands,
     /* 565556 */     // GIR_Coverage, 12910,
     /* 565556 */     GIR_EraseRootFromParent_Done,
     /* 565557 */   // Label 7332: @565557
     /* 565557 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(565692), // Rule ID 7749 //
     /* 565562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 565565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 565605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 565609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 565614 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 565619 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565646 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 565649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 565656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 565661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565690 */     GIR_RootConstrainSelectedInstOperands,
     /* 565691 */     // GIR_Coverage, 7749,
     /* 565691 */     GIR_EraseRootFromParent_Done,
     /* 565692 */   // Label 7333: @565692
     /* 565692 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(565827), // Rule ID 7781 //
     /* 565697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 565700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 565704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 565740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 565744 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 565749 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 565754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565781 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 565784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 565791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 565796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565825 */     GIR_RootConstrainSelectedInstOperands,
     /* 565826 */     // GIR_Coverage, 7781,
     /* 565826 */     GIR_EraseRootFromParent_Done,
     /* 565827 */   // Label 7334: @565827
     /* 565827 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(565962), // Rule ID 7813 //
     /* 565832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 565835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 565867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 565871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 565875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 565879 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 565879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 565884 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 565884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 565889 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 565893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 565895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565909 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 565916 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 565916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 565919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 565921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 565926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 565931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 565936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 565941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 565946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 565951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 565960 */     GIR_RootConstrainSelectedInstOperands,
     /* 565961 */     // GIR_Coverage, 7813,
     /* 565961 */     GIR_EraseRootFromParent_Done,
     /* 565962 */   // Label 7335: @565962
     /* 565962 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(566097), // Rule ID 11931 //
     /* 565967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 565970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 565974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 565978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 565986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 565990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 565994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 565998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566014 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566019 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566051 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 566061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 566066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 566081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 566086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566095 */     GIR_RootConstrainSelectedInstOperands,
     /* 566096 */     // GIR_Coverage, 11931,
     /* 566096 */     GIR_EraseRootFromParent_Done,
     /* 566097 */   // Label 7336: @566097
     /* 566097 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(566232), // Rule ID 11934 //
     /* 566102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 566129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566154 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566159 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566179 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566186 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 566206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 566211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 566216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 566221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566230 */     GIR_RootConstrainSelectedInstOperands,
     /* 566231 */     // GIR_Coverage, 11934,
     /* 566231 */     GIR_EraseRootFromParent_Done,
     /* 566232 */   // Label 7337: @566232
     /* 566232 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(566367), // Rule ID 11935 //
     /* 566237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 566240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 566264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566289 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566321 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 566324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 566341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 566346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 566351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 566356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566365 */     GIR_RootConstrainSelectedInstOperands,
     /* 566366 */     // GIR_Coverage, 11935,
     /* 566366 */     GIR_EraseRootFromParent_Done,
     /* 566367 */   // Label 7338: @566367
     /* 566367 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(566502), // Rule ID 12411 //
     /* 566372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 566399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566419 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566424 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566456 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 566459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 566466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 566471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 566486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 566491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566500 */     GIR_RootConstrainSelectedInstOperands,
     /* 566501 */     // GIR_Coverage, 12411,
     /* 566501 */     GIR_EraseRootFromParent_Done,
     /* 566502 */   // Label 7339: @566502
     /* 566502 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(566637), // Rule ID 12414 //
     /* 566507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 566534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566554 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566559 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566577 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566591 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 566594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 566611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 566616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 566621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 566626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566635 */     GIR_RootConstrainSelectedInstOperands,
     /* 566636 */     // GIR_Coverage, 12414,
     /* 566636 */     GIR_EraseRootFromParent_Done,
     /* 566637 */   // Label 7340: @566637
     /* 566637 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(566772), // Rule ID 12415 //
     /* 566642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 566645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 566649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 566669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566689 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566694 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566694 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566699 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566726 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 566729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 566736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 566741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 566746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 566751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 566756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 566761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566770 */     GIR_RootConstrainSelectedInstOperands,
     /* 566771 */     // GIR_Coverage, 12415,
     /* 566771 */     GIR_EraseRootFromParent_Done,
     /* 566772 */   // Label 7341: @566772
     /* 566772 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(566907), // Rule ID 12891 //
     /* 566777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 566780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 566804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566829 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566840 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566861 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 566864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 566866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 566871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 566876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 566881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 566886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 566891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 566896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 566905 */     GIR_RootConstrainSelectedInstOperands,
     /* 566906 */     // GIR_Coverage, 12891,
     /* 566906 */     GIR_EraseRootFromParent_Done,
     /* 566907 */   // Label 7342: @566907
     /* 566907 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(567042), // Rule ID 12894 //
     /* 566912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 566915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 566919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 566923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 566931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 566935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 566939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 566943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 566947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 566951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 566955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 566959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 566959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 566964 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 566964 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 566969 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 566973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 566975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 566996 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 566996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 566999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 567016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 567021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 567026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 567031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567040 */     GIR_RootConstrainSelectedInstOperands,
     /* 567041 */     // GIR_Coverage, 12894,
     /* 567041 */     GIR_EraseRootFromParent_Done,
     /* 567042 */   // Label 7343: @567042
     /* 567042 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(567177), // Rule ID 12895 //
     /* 567047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 567050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 567074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 567090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 567094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 567099 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 567104 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567117 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567131 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 567134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 567151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 567156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 567161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 567166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567175 */     GIR_RootConstrainSelectedInstOperands,
     /* 567176 */     // GIR_Coverage, 12895,
     /* 567176 */     GIR_EraseRootFromParent_Done,
     /* 567177 */   // Label 7344: @567177
     /* 567177 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(567312), // Rule ID 12017 //
     /* 567182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 567213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567234 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567234 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567239 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567266 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 567269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567310 */     GIR_RootConstrainSelectedInstOperands,
     /* 567311 */     // GIR_Coverage, 12017,
     /* 567311 */     GIR_EraseRootFromParent_Done,
     /* 567312 */   // Label 7345: @567312
     /* 567312 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(567447), // Rule ID 12018 //
     /* 567317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 567348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567369 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567374 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567387 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567401 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 567404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567445 */     GIR_RootConstrainSelectedInstOperands,
     /* 567446 */     // GIR_Coverage, 12018,
     /* 567446 */     GIR_EraseRootFromParent_Done,
     /* 567447 */   // Label 7346: @567447
     /* 567447 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(567582), // Rule ID 12019 //
     /* 567452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 567483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567499 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567504 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567509 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567536 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 567539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567580 */     GIR_RootConstrainSelectedInstOperands,
     /* 567581 */     // GIR_Coverage, 12019,
     /* 567581 */     GIR_EraseRootFromParent_Done,
     /* 567582 */   // Label 7347: @567582
     /* 567582 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(567717), // Rule ID 12020 //
     /* 567587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 567590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 567594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 567618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567639 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567639 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567650 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567657 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567671 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 567674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 567681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 567686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 567691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 567696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567715 */     GIR_RootConstrainSelectedInstOperands,
     /* 567716 */     // GIR_Coverage, 12020,
     /* 567716 */     GIR_EraseRootFromParent_Done,
     /* 567717 */   // Label 7348: @567717
     /* 567717 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(567852), // Rule ID 12497 //
     /* 567722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 567725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 567729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 567753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567774 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567806 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 567809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567850 */     GIR_RootConstrainSelectedInstOperands,
     /* 567851 */     // GIR_Coverage, 12497,
     /* 567851 */     GIR_EraseRootFromParent_Done,
     /* 567852 */   // Label 7349: @567852
     /* 567852 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(567987), // Rule ID 12498 //
     /* 567857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 567860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 567864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 567868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 567872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 567876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 567880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 567884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 567888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 567892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 567896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 567900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 567904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 567904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 567909 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 567909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 567914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 567918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 567920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 567941 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 567941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 567944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 567946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 567951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 567956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 567961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 567966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 567971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 567976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 567985 */     GIR_RootConstrainSelectedInstOperands,
     /* 567986 */     // GIR_Coverage, 12498,
     /* 567986 */     GIR_EraseRootFromParent_Done,
     /* 567987 */   // Label 7350: @567987
     /* 567987 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(568122), // Rule ID 12499 //
     /* 567992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 567995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 567999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 568039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568044 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568076 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568120 */     GIR_RootConstrainSelectedInstOperands,
     /* 568121 */     // GIR_Coverage, 12499,
     /* 568121 */     GIR_EraseRootFromParent_Done,
     /* 568122 */   // Label 7351: @568122
     /* 568122 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(568257), // Rule ID 12500 //
     /* 568127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 568130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 568134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 568174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568179 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568179 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568211 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 568214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568255 */     GIR_RootConstrainSelectedInstOperands,
     /* 568256 */     // GIR_Coverage, 12500,
     /* 568256 */     GIR_EraseRootFromParent_Done,
     /* 568257 */   // Label 7352: @568257
     /* 568257 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(568392), // Rule ID 12977 //
     /* 568262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 568309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568314 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568314 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568319 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568346 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 568349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568390 */     GIR_RootConstrainSelectedInstOperands,
     /* 568391 */     // GIR_Coverage, 12977,
     /* 568391 */     GIR_EraseRootFromParent_Done,
     /* 568392 */   // Label 7353: @568392
     /* 568392 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(568527), // Rule ID 12978 //
     /* 568397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 568444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568449 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568454 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568460 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568474 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568481 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 568484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568525 */     GIR_RootConstrainSelectedInstOperands,
     /* 568526 */     // GIR_Coverage, 12978,
     /* 568526 */     GIR_EraseRootFromParent_Done,
     /* 568527 */   // Label 7354: @568527
     /* 568527 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(568662), // Rule ID 12979 //
     /* 568532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 568579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568584 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568616 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 568619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568660 */     GIR_RootConstrainSelectedInstOperands,
     /* 568661 */     // GIR_Coverage, 12979,
     /* 568661 */     GIR_EraseRootFromParent_Done,
     /* 568662 */   // Label 7355: @568662
     /* 568662 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(568797), // Rule ID 12980 //
     /* 568667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 568670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 568714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568719 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568719 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568751 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 568754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 568761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 568766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 568771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 568776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568795 */     GIR_RootConstrainSelectedInstOperands,
     /* 568796 */     // GIR_Coverage, 12980,
     /* 568796 */     GIR_EraseRootFromParent_Done,
     /* 568797 */   // Label 7356: @568797
     /* 568797 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(568932), // Rule ID 11957 //
     /* 568802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 568805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568854 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568854 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 568865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568879 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 568886 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 568886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 568889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 568891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 568896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 568901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 568906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 568911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 568916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 568921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 568930 */     GIR_RootConstrainSelectedInstOperands,
     /* 568931 */     // GIR_Coverage, 11957,
     /* 568931 */     GIR_EraseRootFromParent_Done,
     /* 568932 */   // Label 7357: @568932
     /* 568932 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(569067), // Rule ID 11958 //
     /* 568937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 568940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 568944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 568948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 568956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 568960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 568964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 568968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 568972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 568976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 568980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 568984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 568984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 568989 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 568989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 568994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 568998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569014 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569021 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 569041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 569046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569065 */     GIR_RootConstrainSelectedInstOperands,
     /* 569066 */     // GIR_Coverage, 11958,
     /* 569066 */     GIR_EraseRootFromParent_Done,
     /* 569067 */   // Label 7358: @569067
     /* 569067 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(569202), // Rule ID 11959 //
     /* 569072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569124 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569149 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569156 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569200 */     GIR_RootConstrainSelectedInstOperands,
     /* 569201 */     // GIR_Coverage, 11959,
     /* 569201 */     GIR_EraseRootFromParent_Done,
     /* 569202 */   // Label 7359: @569202
     /* 569202 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(569337), // Rule ID 11960 //
     /* 569207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 569210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569259 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569264 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569291 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 569294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569335 */     GIR_RootConstrainSelectedInstOperands,
     /* 569336 */     // GIR_Coverage, 11960,
     /* 569336 */     GIR_EraseRootFromParent_Done,
     /* 569337 */   // Label 7360: @569337
     /* 569337 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(569472), // Rule ID 12437 //
     /* 569342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 569345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 569349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569394 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569426 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 569429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 569446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 569451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569470 */     GIR_RootConstrainSelectedInstOperands,
     /* 569471 */     // GIR_Coverage, 12437,
     /* 569471 */     GIR_EraseRootFromParent_Done,
     /* 569472 */   // Label 7361: @569472
     /* 569472 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(569607), // Rule ID 12438 //
     /* 569477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 569480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 569484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569524 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569529 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569540 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569561 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 569564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 569581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 569586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569605 */     GIR_RootConstrainSelectedInstOperands,
     /* 569606 */     // GIR_Coverage, 12438,
     /* 569606 */     GIR_EraseRootFromParent_Done,
     /* 569607 */   // Label 7362: @569607
     /* 569607 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(569742), // Rule ID 12439 //
     /* 569612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 569615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 569619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569664 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569664 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569682 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569696 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 569699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569740 */     GIR_RootConstrainSelectedInstOperands,
     /* 569741 */     // GIR_Coverage, 12439,
     /* 569741 */     GIR_EraseRootFromParent_Done,
     /* 569742 */   // Label 7363: @569742
     /* 569742 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(569877), // Rule ID 12440 //
     /* 569747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 569750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 569754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569799 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569831 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 569834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 569841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 569846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 569851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 569856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 569866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 569875 */     GIR_RootConstrainSelectedInstOperands,
     /* 569876 */     // GIR_Coverage, 12440,
     /* 569876 */     GIR_EraseRootFromParent_Done,
     /* 569877 */   // Label 7364: @569877
     /* 569877 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(570012), // Rule ID 12917 //
     /* 569882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 569885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 569889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 569893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 569901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 569905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 569909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 569913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 569917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 569921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 569925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 569929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 569929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 569934 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 569934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 569939 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 569943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 569945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 569966 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 569966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 569969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 569971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 569976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 569981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 569986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 569991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 569996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570010 */     GIR_RootConstrainSelectedInstOperands,
     /* 570011 */     // GIR_Coverage, 12917,
     /* 570011 */     GIR_EraseRootFromParent_Done,
     /* 570012 */   // Label 7365: @570012
     /* 570012 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(570147), // Rule ID 12918 //
     /* 570017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570069 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570101 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 570121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 570126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 570131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570145 */     GIR_RootConstrainSelectedInstOperands,
     /* 570146 */     // GIR_Coverage, 12918,
     /* 570146 */     GIR_EraseRootFromParent_Done,
     /* 570147 */   // Label 7366: @570147
     /* 570147 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(570282), // Rule ID 12919 //
     /* 570152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570199 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570204 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570204 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570236 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 570246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 570251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 570266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570280 */     GIR_RootConstrainSelectedInstOperands,
     /* 570281 */     // GIR_Coverage, 12919,
     /* 570281 */     GIR_EraseRootFromParent_Done,
     /* 570282 */   // Label 7367: @570282
     /* 570282 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(570417), // Rule ID 12920 //
     /* 570287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 570290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 570318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570339 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570344 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570350 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570357 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570364 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570371 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 570374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 570381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 570386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 570401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570415 */     GIR_RootConstrainSelectedInstOperands,
     /* 570416 */     // GIR_Coverage, 12920,
     /* 570416 */     GIR_EraseRootFromParent_Done,
     /* 570417 */   // Label 7368: @570417
     /* 570417 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(570552), // Rule ID 12002 //
     /* 570422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 570425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 570453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570474 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570474 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570506 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 570509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 570526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 570531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 570536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570550 */     GIR_RootConstrainSelectedInstOperands,
     /* 570551 */     // GIR_Coverage, 12002,
     /* 570551 */     GIR_EraseRootFromParent_Done,
     /* 570552 */   // Label 7369: @570552
     /* 570552 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(570687), // Rule ID 12003 //
     /* 570557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 570560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 570588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570609 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570614 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570641 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 570644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 570651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 570656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 570661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 570666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 570671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570685 */     GIR_RootConstrainSelectedInstOperands,
     /* 570686 */     // GIR_Coverage, 12003,
     /* 570686 */     GIR_EraseRootFromParent_Done,
     /* 570687 */   // Label 7370: @570687
     /* 570687 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(570822), // Rule ID 12004 //
     /* 570692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 570695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 570723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570744 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570749 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570762 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570776 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 570779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 570786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 570791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 570806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570820 */     GIR_RootConstrainSelectedInstOperands,
     /* 570821 */     // GIR_Coverage, 12004,
     /* 570821 */     GIR_EraseRootFromParent_Done,
     /* 570822 */   // Label 7371: @570822
     /* 570822 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(570957), // Rule ID 12005 //
     /* 570827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 570830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 570834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 570858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 570866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 570870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 570874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 570874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 570879 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 570879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 570884 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 570888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 570890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570904 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 570911 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 570911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 570914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 570916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 570921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 570926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 570931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 570936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 570941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 570946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 570955 */     GIR_RootConstrainSelectedInstOperands,
     /* 570956 */     // GIR_Coverage, 12005,
     /* 570956 */     GIR_EraseRootFromParent_Done,
     /* 570957 */   // Label 7372: @570957
     /* 570957 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(571092), // Rule ID 12482 //
     /* 570962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 570965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 570969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 570973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 570977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 570981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 570985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 570989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 570993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 570997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571009 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571014 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571019 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571046 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 571066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 571071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 571076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 571081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571090 */     GIR_RootConstrainSelectedInstOperands,
     /* 571091 */     // GIR_Coverage, 12482,
     /* 571091 */     GIR_EraseRootFromParent_Done,
     /* 571092 */   // Label 7373: @571092
     /* 571092 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(571227), // Rule ID 12483 //
     /* 571097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 571124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 571128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571132 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571144 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571149 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571149 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571154 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571167 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571181 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 571201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 571206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 571211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 571216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571225 */     GIR_RootConstrainSelectedInstOperands,
     /* 571226 */     // GIR_Coverage, 12483,
     /* 571226 */     GIR_EraseRootFromParent_Done,
     /* 571227 */   // Label 7374: @571227
     /* 571227 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(571362), // Rule ID 12484 //
     /* 571232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 571259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 571263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571284 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571284 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571295 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571302 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571316 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 571326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 571331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 571346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 571351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571360 */     GIR_RootConstrainSelectedInstOperands,
     /* 571361 */     // GIR_Coverage, 12484,
     /* 571361 */     GIR_EraseRootFromParent_Done,
     /* 571362 */   // Label 7375: @571362
     /* 571362 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(571497), // Rule ID 12485 //
     /* 571367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 571370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 571374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 571394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 571398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571419 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571451 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 571454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 571461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 571466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 571481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 571486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571495 */     GIR_RootConstrainSelectedInstOperands,
     /* 571496 */     // GIR_Coverage, 12485,
     /* 571496 */     GIR_EraseRootFromParent_Done,
     /* 571497 */   // Label 7376: @571497
     /* 571497 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(571632), // Rule ID 12962 //
     /* 571502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 571505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 571529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 571533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571554 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571586 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 571589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 571606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 571611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 571616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 571621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571630 */     GIR_RootConstrainSelectedInstOperands,
     /* 571631 */     // GIR_Coverage, 12962,
     /* 571631 */     GIR_EraseRootFromParent_Done,
     /* 571632 */   // Label 7377: @571632
     /* 571632 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(571767), // Rule ID 12963 //
     /* 571637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 571640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 571664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 571668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571689 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571689 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571721 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 571724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 571731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 571736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 571741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 571746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 571751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 571756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571765 */     GIR_RootConstrainSelectedInstOperands,
     /* 571766 */     // GIR_Coverage, 12963,
     /* 571766 */     GIR_EraseRootFromParent_Done,
     /* 571767 */   // Label 7378: @571767
     /* 571767 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(571902), // Rule ID 12964 //
     /* 571772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 571775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 571799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 571803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571819 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571824 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571824 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571856 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 571859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 571866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 571871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 571876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 571881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 571886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 571891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 571900 */     GIR_RootConstrainSelectedInstOperands,
     /* 571901 */     // GIR_Coverage, 12964,
     /* 571901 */     GIR_EraseRootFromParent_Done,
     /* 571902 */   // Label 7379: @571902
     /* 571902 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(572037), // Rule ID 12965 //
     /* 571907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 571910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 571914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 571918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 571922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 571926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 571930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 571934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 571938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 571942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 571946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 571950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 571954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 571954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 571959 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 571959 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 571964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 571968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 571970 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 571991 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 571991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 571994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 571996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 572001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 572006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572035 */     GIR_RootConstrainSelectedInstOperands,
     /* 572036 */     // GIR_Coverage, 12965,
     /* 572036 */     GIR_EraseRootFromParent_Done,
     /* 572037 */   // Label 7380: @572037
     /* 572037 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(572172), // Rule ID 11942 //
     /* 572042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 572069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572094 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572094 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572119 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572126 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 572146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 572151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572170 */     GIR_RootConstrainSelectedInstOperands,
     /* 572171 */     // GIR_Coverage, 11942,
     /* 572171 */     GIR_EraseRootFromParent_Done,
     /* 572172 */   // Label 7381: @572172
     /* 572172 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(572307), // Rule ID 11943 //
     /* 572177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 572204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572229 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572261 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 572281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 572286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572305 */     GIR_RootConstrainSelectedInstOperands,
     /* 572306 */     // GIR_Coverage, 11943,
     /* 572306 */     GIR_EraseRootFromParent_Done,
     /* 572307 */   // Label 7382: @572307
     /* 572307 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(572442), // Rule ID 11944 //
     /* 572312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 572339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572364 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572364 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572369 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572396 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 572406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 572411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572440 */     GIR_RootConstrainSelectedInstOperands,
     /* 572441 */     // GIR_Coverage, 11944,
     /* 572441 */     GIR_EraseRootFromParent_Done,
     /* 572442 */   // Label 7383: @572442
     /* 572442 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(572577), // Rule ID 11945 //
     /* 572447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 572450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 572454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 572474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572494 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572499 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572508 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572531 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 572534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 572541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 572546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572575 */     GIR_RootConstrainSelectedInstOperands,
     /* 572576 */     // GIR_Coverage, 11945,
     /* 572576 */     GIR_EraseRootFromParent_Done,
     /* 572577 */   // Label 7384: @572577
     /* 572577 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(572712), // Rule ID 12422 //
     /* 572582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 572585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 572589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 572609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572634 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572643 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572666 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 572669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 572686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 572691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572710 */     GIR_RootConstrainSelectedInstOperands,
     /* 572711 */     // GIR_Coverage, 12422,
     /* 572711 */     GIR_EraseRootFromParent_Done,
     /* 572712 */   // Label 7385: @572712
     /* 572712 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(572847), // Rule ID 12423 //
     /* 572717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 572720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 572724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 572744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572769 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572769 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572787 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572801 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 572804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 572811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 572816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 572821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 572826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572845 */     GIR_RootConstrainSelectedInstOperands,
     /* 572846 */     // GIR_Coverage, 12423,
     /* 572846 */     GIR_EraseRootFromParent_Done,
     /* 572847 */   // Label 7386: @572847
     /* 572847 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(572982), // Rule ID 12424 //
     /* 572852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 572855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 572859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 572871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 572875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 572879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 572883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 572887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 572891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 572895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 572899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 572899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 572904 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 572904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 572909 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 572913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 572915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 572936 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 572936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 572939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 572941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 572946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 572951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 572956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 572961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 572966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 572971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 572980 */     GIR_RootConstrainSelectedInstOperands,
     /* 572981 */     // GIR_Coverage, 12424,
     /* 572981 */     GIR_EraseRootFromParent_Done,
     /* 572982 */   // Label 7387: @572982
     /* 572982 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(573117), // Rule ID 12425 //
     /* 572987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 572990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 572994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 572998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 573014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573039 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573071 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 573074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 573081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 573086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 573101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 573106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573115 */     GIR_RootConstrainSelectedInstOperands,
     /* 573116 */     // GIR_Coverage, 12425,
     /* 573116 */     GIR_EraseRootFromParent_Done,
     /* 573117 */   // Label 7388: @573117
     /* 573117 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(573252), // Rule ID 12902 //
     /* 573122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 573149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573174 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573174 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573179 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573206 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 573226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 573231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 573236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 573241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573250 */     GIR_RootConstrainSelectedInstOperands,
     /* 573251 */     // GIR_Coverage, 12902,
     /* 573251 */     GIR_EraseRootFromParent_Done,
     /* 573252 */   // Label 7389: @573252
     /* 573252 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(573387), // Rule ID 12903 //
     /* 573257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 573284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573309 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573309 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573341 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 573351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 573356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 573361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 573366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 573371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 573376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573385 */     GIR_RootConstrainSelectedInstOperands,
     /* 573386 */     // GIR_Coverage, 12903,
     /* 573386 */     GIR_EraseRootFromParent_Done,
     /* 573387 */   // Label 7390: @573387
     /* 573387 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(573522), // Rule ID 12904 //
     /* 573392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 573419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573444 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573462 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573469 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573476 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 573486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 573491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 573506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 573511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573520 */     GIR_RootConstrainSelectedInstOperands,
     /* 573521 */     // GIR_Coverage, 12904,
     /* 573521 */     GIR_EraseRootFromParent_Done,
     /* 573522 */   // Label 7391: @573522
     /* 573522 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(573657), // Rule ID 12905 //
     /* 573527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 573530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 573554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 573558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573579 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573611 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 573614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 573621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 573626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 573641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 573646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573655 */     GIR_RootConstrainSelectedInstOperands,
     /* 573656 */     // GIR_Coverage, 12905,
     /* 573656 */     GIR_EraseRootFromParent_Done,
     /* 573657 */   // Label 7392: @573657
     /* 573657 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(573792), // Rule ID 12013 //
     /* 573662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 573665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 573693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573714 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573746 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 573749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573790 */     GIR_RootConstrainSelectedInstOperands,
     /* 573791 */     // GIR_Coverage, 12013,
     /* 573791 */     GIR_EraseRootFromParent_Done,
     /* 573792 */   // Label 7393: @573792
     /* 573792 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(573927), // Rule ID 12014 //
     /* 573797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 573800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 573828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573849 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573849 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573874 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 573881 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 573881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 573884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 573886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 573891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 573896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 573901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 573906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 573911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 573916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 573925 */     GIR_RootConstrainSelectedInstOperands,
     /* 573926 */     // GIR_Coverage, 12014,
     /* 573926 */     GIR_EraseRootFromParent_Done,
     /* 573927 */   // Label 7394: @573927
     /* 573927 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(574062), // Rule ID 12015 //
     /* 573932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 573935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 573939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 573943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 573947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 573951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 573955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 573959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 573963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 573967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 573971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 573975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 573979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 573979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 573984 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 573984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 573989 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 573993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 573995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574016 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574060 */     GIR_RootConstrainSelectedInstOperands,
     /* 574061 */     // GIR_Coverage, 12015,
     /* 574061 */     GIR_EraseRootFromParent_Done,
     /* 574062 */   // Label 7395: @574062
     /* 574062 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(574197), // Rule ID 12016 //
     /* 574067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 574070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 574098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574119 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574124 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574151 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 574154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574195 */     GIR_RootConstrainSelectedInstOperands,
     /* 574196 */     // GIR_Coverage, 12016,
     /* 574196 */     GIR_EraseRootFromParent_Done,
     /* 574197 */   // Label 7396: @574197
     /* 574197 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(574332), // Rule ID 12493 //
     /* 574202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 574233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574254 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574272 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574286 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 574289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574330 */     GIR_RootConstrainSelectedInstOperands,
     /* 574331 */     // GIR_Coverage, 12493,
     /* 574331 */     GIR_EraseRootFromParent_Done,
     /* 574332 */   // Label 7397: @574332
     /* 574332 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(574467), // Rule ID 12494 //
     /* 574337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 574368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574389 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574394 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574421 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 574424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574465 */     GIR_RootConstrainSelectedInstOperands,
     /* 574466 */     // GIR_Coverage, 12494,
     /* 574466 */     GIR_EraseRootFromParent_Done,
     /* 574467 */   // Label 7398: @574467
     /* 574467 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(574602), // Rule ID 12495 //
     /* 574472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 574503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574524 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574529 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574542 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574556 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 574559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574600 */     GIR_RootConstrainSelectedInstOperands,
     /* 574601 */     // GIR_Coverage, 12495,
     /* 574601 */     GIR_EraseRootFromParent_Done,
     /* 574602 */   // Label 7399: @574602
     /* 574602 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(574737), // Rule ID 12496 //
     /* 574607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 574610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 574614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 574638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574659 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574659 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574664 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574684 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574691 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 574694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 574701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 574706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 574711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 574716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574735 */     GIR_RootConstrainSelectedInstOperands,
     /* 574736 */     // GIR_Coverage, 12496,
     /* 574736 */     GIR_EraseRootFromParent_Done,
     /* 574737 */   // Label 7400: @574737
     /* 574737 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(574872), // Rule ID 12973 //
     /* 574742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 574745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 574773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574794 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574826 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 574829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574870 */     GIR_RootConstrainSelectedInstOperands,
     /* 574871 */     // GIR_Coverage, 12973,
     /* 574871 */     GIR_EraseRootFromParent_Done,
     /* 574872 */   // Label 7401: @574872
     /* 574872 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(575007), // Rule ID 12974 //
     /* 574877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 574880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 574884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 574888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 574892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 574896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 574900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 574904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 574908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 574912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 574916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 574920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 574924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 574924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 574929 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 574929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 574934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 574938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 574940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 574961 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 574961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 574964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 574966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 574971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 574976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 574981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 574986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 574991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 574996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 574999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575005 */     GIR_RootConstrainSelectedInstOperands,
     /* 575006 */     // GIR_Coverage, 12974,
     /* 575006 */     GIR_EraseRootFromParent_Done,
     /* 575007 */   // Label 7402: @575007
     /* 575007 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(575142), // Rule ID 12975 //
     /* 575012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 575059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575064 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575069 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575089 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575096 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575140 */     GIR_RootConstrainSelectedInstOperands,
     /* 575141 */     // GIR_Coverage, 12975,
     /* 575141 */     GIR_EraseRootFromParent_Done,
     /* 575142 */   // Label 7403: @575142
     /* 575142 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(575277), // Rule ID 12976 //
     /* 575147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 575150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 575194 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575199 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575231 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 575234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575275 */     GIR_RootConstrainSelectedInstOperands,
     /* 575276 */     // GIR_Coverage, 12976,
     /* 575276 */     GIR_EraseRootFromParent_Done,
     /* 575277 */   // Label 7404: @575277
     /* 575277 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(575412), // Rule ID 11953 //
     /* 575282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 575285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575329 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575334 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575366 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 575369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575410 */     GIR_RootConstrainSelectedInstOperands,
     /* 575411 */     // GIR_Coverage, 11953,
     /* 575411 */     GIR_EraseRootFromParent_Done,
     /* 575412 */   // Label 7405: @575412
     /* 575412 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(575547), // Rule ID 11954 //
     /* 575417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 575420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575464 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575469 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575469 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575501 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 575504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575545 */     GIR_RootConstrainSelectedInstOperands,
     /* 575546 */     // GIR_Coverage, 11954,
     /* 575546 */     GIR_EraseRootFromParent_Done,
     /* 575547 */   // Label 7406: @575547
     /* 575547 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(575682), // Rule ID 11955 //
     /* 575552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 575555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575599 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575599 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575604 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575622 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575636 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 575639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575680 */     GIR_RootConstrainSelectedInstOperands,
     /* 575681 */     // GIR_Coverage, 11955,
     /* 575681 */     GIR_EraseRootFromParent_Done,
     /* 575682 */   // Label 7407: @575682
     /* 575682 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(575817), // Rule ID 11956 //
     /* 575687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 575690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 575694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575734 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575734 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575739 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575744 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575771 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 575774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 575781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 575786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 575791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 575796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575815 */     GIR_RootConstrainSelectedInstOperands,
     /* 575816 */     // GIR_Coverage, 11956,
     /* 575816 */     GIR_EraseRootFromParent_Done,
     /* 575817 */   // Label 7408: @575817
     /* 575817 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(575952), // Rule ID 12433 //
     /* 575822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 575825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 575865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575869 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 575869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 575874 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 575874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 575879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 575883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 575885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 575906 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 575906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 575909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 575911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 575916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 575921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 575926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 575931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 575936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 575941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 575950 */     GIR_RootConstrainSelectedInstOperands,
     /* 575951 */     // GIR_Coverage, 12433,
     /* 575951 */     GIR_EraseRootFromParent_Done,
     /* 575952 */   // Label 7409: @575952
     /* 575952 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(576087), // Rule ID 12434 //
     /* 575957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 575960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 575964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 575968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 575972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 575976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 575980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 575984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 575988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 575992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 575996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576004 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576009 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576041 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 576044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576085 */     GIR_RootConstrainSelectedInstOperands,
     /* 576086 */     // GIR_Coverage, 12434,
     /* 576086 */     GIR_EraseRootFromParent_Done,
     /* 576087 */   // Label 7410: @576087
     /* 576087 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(576222), // Rule ID 12435 //
     /* 576092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 576095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 576123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576139 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576139 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576144 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576149 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576162 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576176 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 576179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 576196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 576201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576220 */     GIR_RootConstrainSelectedInstOperands,
     /* 576221 */     // GIR_Coverage, 12435,
     /* 576221 */     GIR_EraseRootFromParent_Done,
     /* 576222 */   // Label 7411: @576222
     /* 576222 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(576357), // Rule ID 12436 //
     /* 576227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 576230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 576234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 576258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576274 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576279 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576284 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576297 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576311 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 576314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 576331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 576336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576355 */     GIR_RootConstrainSelectedInstOperands,
     /* 576356 */     // GIR_Coverage, 12436,
     /* 576356 */     GIR_EraseRootFromParent_Done,
     /* 576357 */   // Label 7412: @576357
     /* 576357 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(576492), // Rule ID 12913 //
     /* 576362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 576365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 576393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576409 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576414 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576446 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 576449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576490 */     GIR_RootConstrainSelectedInstOperands,
     /* 576491 */     // GIR_Coverage, 12913,
     /* 576491 */     GIR_EraseRootFromParent_Done,
     /* 576492 */   // Label 7413: @576492
     /* 576492 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(576627), // Rule ID 12914 //
     /* 576497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 576500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 576528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576544 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576549 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576554 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576581 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 576584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 576596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 576601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 576606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576625 */     GIR_RootConstrainSelectedInstOperands,
     /* 576626 */     // GIR_Coverage, 12914,
     /* 576626 */     GIR_EraseRootFromParent_Done,
     /* 576627 */   // Label 7414: @576627
     /* 576627 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(576762), // Rule ID 12915 //
     /* 576632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 576635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 576663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576679 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576684 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576716 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 576719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 576736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 576741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576760 */     GIR_RootConstrainSelectedInstOperands,
     /* 576761 */     // GIR_Coverage, 12915,
     /* 576761 */     GIR_EraseRootFromParent_Done,
     /* 576762 */   // Label 7415: @576762
     /* 576762 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(576897), // Rule ID 12916 //
     /* 576767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 576770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 576798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576814 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576814 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576819 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576819 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576824 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576830 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576844 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576851 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 576854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 576861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 576866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 576871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 576876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 576881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 576886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 576895 */     GIR_RootConstrainSelectedInstOperands,
     /* 576896 */     // GIR_Coverage, 12916,
     /* 576896 */     GIR_EraseRootFromParent_Done,
     /* 576897 */   // Label 7416: @576897
     /* 576897 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(577032), // Rule ID 11998 //
     /* 576902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 576905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 576909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 576913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 576917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 576921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 576925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 576929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 576933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 576937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 576941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 576945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 576949 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 576949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 576954 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 576954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 576959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 576963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 576965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576979 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 576986 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 576986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 576989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 576991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 576996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577030 */     GIR_RootConstrainSelectedInstOperands,
     /* 577031 */     // GIR_Coverage, 11998,
     /* 577031 */     GIR_EraseRootFromParent_Done,
     /* 577032 */   // Label 7417: @577032
     /* 577032 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(577167), // Rule ID 11999 //
     /* 577037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 577040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 577064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 577068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 577072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 577076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 577080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577084 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 577089 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577089 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 577094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577121 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 577124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577165 */     GIR_RootConstrainSelectedInstOperands,
     /* 577166 */     // GIR_Coverage, 11999,
     /* 577166 */     GIR_EraseRootFromParent_Done,
     /* 577167 */   // Label 7418: @577167
     /* 577167 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(577302), // Rule ID 12000 //
     /* 577172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 577175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 577199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 577203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 577207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 577211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 577215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577219 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577219 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 577224 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 577229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577256 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 577259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 577266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 577276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577300 */     GIR_RootConstrainSelectedInstOperands,
     /* 577301 */     // GIR_Coverage, 12000,
     /* 577301 */     GIR_EraseRootFromParent_Done,
     /* 577302 */   // Label 7419: @577302
     /* 577302 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(577437), // Rule ID 12001 //
     /* 577307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 577310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 577334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 577338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 577342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 577346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 577350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577354 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 577359 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 577364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577391 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 577394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 577401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 577411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577435 */     GIR_RootConstrainSelectedInstOperands,
     /* 577436 */     // GIR_Coverage, 12001,
     /* 577436 */     GIR_EraseRootFromParent_Done,
     /* 577437 */   // Label 7420: @577437
     /* 577437 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(577572), // Rule ID 12478 //
     /* 577442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 577445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 577469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 577473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 577477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 577481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 577485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577489 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 577494 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577494 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 577499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577503 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577526 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 577529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577570 */     GIR_RootConstrainSelectedInstOperands,
     /* 577571 */     // GIR_Coverage, 12478,
     /* 577571 */     GIR_EraseRootFromParent_Done,
     /* 577572 */   // Label 7421: @577572
     /* 577572 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(577707), // Rule ID 12479 //
     /* 577577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 577580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 577604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 577608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 577612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 577616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 577620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577624 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577624 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 577629 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 577634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577647 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577661 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 577664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 577671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 577676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 577681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 577686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577705 */     GIR_RootConstrainSelectedInstOperands,
     /* 577706 */     // GIR_Coverage, 12479,
     /* 577706 */     GIR_EraseRootFromParent_Done,
     /* 577707 */   // Label 7422: @577707
     /* 577707 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(577842), // Rule ID 12480 //
     /* 577712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 577715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 577739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 577743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 577747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 577751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 577755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577759 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577759 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 577764 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577764 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 577769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577796 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 577799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 577806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 577816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577840 */     GIR_RootConstrainSelectedInstOperands,
     /* 577841 */     // GIR_Coverage, 12480,
     /* 577841 */     GIR_EraseRootFromParent_Done,
     /* 577842 */   // Label 7423: @577842
     /* 577842 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(577977), // Rule ID 12481 //
     /* 577847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 577850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 577854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 577866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 577870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 577874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 577878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 577882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 577886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 577890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 577894 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 577894 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 577899 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 577899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 577904 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 577908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 577910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 577931 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 577931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 577934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 577936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 577941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 577946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 577951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 577956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 577961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 577966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 577975 */     GIR_RootConstrainSelectedInstOperands,
     /* 577976 */     // GIR_Coverage, 12481,
     /* 577976 */     GIR_EraseRootFromParent_Done,
     /* 577977 */   // Label 7424: @577977
     /* 577977 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(578112), // Rule ID 12958 //
     /* 577982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 577985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 577989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 577993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 577997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578029 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578034 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578039 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578066 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 578069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578110 */     GIR_RootConstrainSelectedInstOperands,
     /* 578111 */     // GIR_Coverage, 12958,
     /* 578111 */     GIR_EraseRootFromParent_Done,
     /* 578112 */   // Label 7425: @578112
     /* 578112 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(578247), // Rule ID 12959 //
     /* 578117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 578120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578164 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578164 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578169 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578169 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578187 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578201 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 578204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578245 */     GIR_RootConstrainSelectedInstOperands,
     /* 578246 */     // GIR_Coverage, 12959,
     /* 578246 */     GIR_EraseRootFromParent_Done,
     /* 578247 */   // Label 7426: @578247
     /* 578247 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(578382), // Rule ID 12960 //
     /* 578252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 578255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578299 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578299 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578304 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578304 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578336 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 578339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578380 */     GIR_RootConstrainSelectedInstOperands,
     /* 578381 */     // GIR_Coverage, 12960,
     /* 578381 */     GIR_EraseRootFromParent_Done,
     /* 578382 */   // Label 7427: @578382
     /* 578382 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(578517), // Rule ID 12961 //
     /* 578387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 578390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 578434 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578439 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578457 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578471 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 578474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578515 */     GIR_RootConstrainSelectedInstOperands,
     /* 578516 */     // GIR_Coverage, 12961,
     /* 578516 */     GIR_EraseRootFromParent_Done,
     /* 578517 */   // Label 7428: @578517
     /* 578517 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(578652), // Rule ID 11938 //
     /* 578522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 578525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578569 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578574 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578606 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 578609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578650 */     GIR_RootConstrainSelectedInstOperands,
     /* 578651 */     // GIR_Coverage, 11938,
     /* 578651 */     GIR_EraseRootFromParent_Done,
     /* 578652 */   // Label 7429: @578652
     /* 578652 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(578787), // Rule ID 11939 //
     /* 578657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 578660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578704 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578704 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578709 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578718 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578720 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578741 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 578744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 578751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 578756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 578761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 578766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578785 */     GIR_RootConstrainSelectedInstOperands,
     /* 578786 */     // GIR_Coverage, 11939,
     /* 578786 */     GIR_EraseRootFromParent_Done,
     /* 578787 */   // Label 7430: @578787
     /* 578787 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(578922), // Rule ID 11940 //
     /* 578792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 578795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578839 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578844 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578876 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 578876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 578879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 578881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 578886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 578891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 578896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 578901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 578906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 578911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 578920 */     GIR_RootConstrainSelectedInstOperands,
     /* 578921 */     // GIR_Coverage, 11940,
     /* 578921 */     GIR_EraseRootFromParent_Done,
     /* 578922 */   // Label 7431: @578922
     /* 578922 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(579057), // Rule ID 11941 //
     /* 578927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
     /* 578930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 578934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 578938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 578946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 578950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 578954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 578958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 578962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 578966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 578970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 578974 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 578974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 578979 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 578979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 578984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 578988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 578990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 578997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579011 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 579014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579055 */     GIR_RootConstrainSelectedInstOperands,
     /* 579056 */     // GIR_Coverage, 11941,
     /* 579056 */     GIR_EraseRootFromParent_Done,
     /* 579057 */   // Label 7432: @579057
     /* 579057 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(579192), // Rule ID 12418 //
     /* 579062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 579065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 579069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 579081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 579085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 579089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 579097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 579101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 579105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579109 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 579114 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 579119 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579146 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 579149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579190 */     GIR_RootConstrainSelectedInstOperands,
     /* 579191 */     // GIR_Coverage, 12418,
     /* 579191 */     GIR_EraseRootFromParent_Done,
     /* 579192 */   // Label 7433: @579192
     /* 579192 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(579327), // Rule ID 12419 //
     /* 579197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 579200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 579204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 579216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 579220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 579224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 579232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 579236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 579240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579244 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579244 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 579249 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579249 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 579254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579274 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579281 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 579284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579325 */     GIR_RootConstrainSelectedInstOperands,
     /* 579326 */     // GIR_Coverage, 12419,
     /* 579326 */     GIR_EraseRootFromParent_Done,
     /* 579327 */   // Label 7434: @579327
     /* 579327 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(579462), // Rule ID 12420 //
     /* 579332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 579335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 579339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 579351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 579355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 579359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 579367 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 579371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 579375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579379 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579379 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 579384 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579384 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 579389 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579395 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579402 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579409 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579416 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 579419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579460 */     GIR_RootConstrainSelectedInstOperands,
     /* 579461 */     // GIR_Coverage, 12420,
     /* 579461 */     GIR_EraseRootFromParent_Done,
     /* 579462 */   // Label 7435: @579462
     /* 579462 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(579597), // Rule ID 12421 //
     /* 579467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseRealTrue16Insts),
     /* 579470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 579474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 579486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 579490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 579494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 579502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 579506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 579510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579514 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 579519 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 579524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579551 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 579554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579595 */     GIR_RootConstrainSelectedInstOperands,
     /* 579596 */     // GIR_Coverage, 12421,
     /* 579596 */     GIR_EraseRootFromParent_Done,
     /* 579597 */   // Label 7436: @579597
     /* 579597 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(579732), // Rule ID 12898 //
     /* 579602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 579605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 579621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 579625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 579629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 579637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 579641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 579645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579649 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 579654 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579654 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 579659 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579679 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579686 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 579689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579730 */     GIR_RootConstrainSelectedInstOperands,
     /* 579731 */     // GIR_Coverage, 12898,
     /* 579731 */     GIR_EraseRootFromParent_Done,
     /* 579732 */   // Label 7437: @579732
     /* 579732 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(579867), // Rule ID 12899 //
     /* 579737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 579740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 579756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 579760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 579764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 579772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 579776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 579780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579784 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579784 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 579789 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 579794 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579821 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 579824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 579831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 579836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 579841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 579846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579865 */     GIR_RootConstrainSelectedInstOperands,
     /* 579866 */     // GIR_Coverage, 12899,
     /* 579866 */     GIR_EraseRootFromParent_Done,
     /* 579867 */   // Label 7438: @579867
     /* 579867 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(580002), // Rule ID 12900 //
     /* 579872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 579875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 579879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 579883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 579891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 579895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 579899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 579903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 579907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 579911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 579915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 579919 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 579919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 579924 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 579924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 579929 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 579933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 579935 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579942 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 579956 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 579956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 579959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 579961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 579966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 579971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 579976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 579981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 579986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 579991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 579997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580000 */     GIR_RootConstrainSelectedInstOperands,
     /* 580001 */     // GIR_Coverage, 12900,
     /* 580001 */     GIR_EraseRootFromParent_Done,
     /* 580002 */   // Label 7439: @580002
     /* 580002 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(580137), // Rule ID 12901 //
     /* 580007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
     /* 580010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 580030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 580038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 580050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580054 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 580054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 580059 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 580059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 580064 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 580068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 580070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580084 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580091 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 580094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 580111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 580116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580135 */     GIR_RootConstrainSelectedInstOperands,
     /* 580136 */     // GIR_Coverage, 12901,
     /* 580136 */     GIR_EraseRootFromParent_Done,
     /* 580137 */   // Label 7440: @580137
     /* 580137 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(580252), // Rule ID 13400 //
     /* 580142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 580145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 580149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 580153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580177 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580179 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580199 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580206 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 580209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 580226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 580231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 580236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 580241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580250 */     GIR_RootConstrainSelectedInstOperands,
     /* 580251 */     // GIR_Coverage, 13400,
     /* 580251 */     GIR_EraseRootFromParent_Done,
     /* 580252 */   // Label 7441: @580252
     /* 580252 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(580367), // Rule ID 13416 //
     /* 580257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 580260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 580268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580292 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580294 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580307 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580321 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 580324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 580341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 580346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 580351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 580356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580365 */     GIR_RootConstrainSelectedInstOperands,
     /* 580366 */     // GIR_Coverage, 13416,
     /* 580366 */     GIR_EraseRootFromParent_Done,
     /* 580367 */   // Label 7442: @580367
     /* 580367 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(580482), // Rule ID 13399 //
     /* 580372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 580375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 580379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 580383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580407 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580409 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580436 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 580439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 580456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 580461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 580466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 580471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580480 */     GIR_RootConstrainSelectedInstOperands,
     /* 580481 */     // GIR_Coverage, 13399,
     /* 580481 */     GIR_EraseRootFromParent_Done,
     /* 580482 */   // Label 7443: @580482
     /* 580482 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(580597), // Rule ID 13415 //
     /* 580487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 580490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 580498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580522 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580524 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580551 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 580554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 580561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 580566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 580571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 580576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 580581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 580586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580595 */     GIR_RootConstrainSelectedInstOperands,
     /* 580596 */     // GIR_Coverage, 13415,
     /* 580596 */     GIR_EraseRootFromParent_Done,
     /* 580597 */   // Label 7444: @580597
     /* 580597 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(580712), // Rule ID 7874 //
     /* 580602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 580605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 580609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580637 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580639 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580666 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 580669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580710 */     GIR_RootConstrainSelectedInstOperands,
     /* 580711 */     // GIR_Coverage, 7874,
     /* 580711 */     GIR_EraseRootFromParent_Done,
     /* 580712 */   // Label 7445: @580712
     /* 580712 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(580827), // Rule ID 7890 //
     /* 580717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 580720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 580744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580752 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580754 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580774 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580781 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 580784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580825 */     GIR_RootConstrainSelectedInstOperands,
     /* 580826 */     // GIR_Coverage, 7890,
     /* 580826 */     GIR_EraseRootFromParent_Done,
     /* 580827 */   // Label 7446: @580827
     /* 580827 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(580942), // Rule ID 7873 //
     /* 580832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 580835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 580839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580867 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580869 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580889 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580896 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 580896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 580899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 580901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 580906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 580911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 580916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 580921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 580926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 580931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 580940 */     GIR_RootConstrainSelectedInstOperands,
     /* 580941 */     // GIR_Coverage, 7873,
     /* 580941 */     GIR_EraseRootFromParent_Done,
     /* 580942 */   // Label 7447: @580942
     /* 580942 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(581057), // Rule ID 7889 //
     /* 580947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 580950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 580954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 580958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 580962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 580966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 580970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 580974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 580978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 580982 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 580984 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 580988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 580990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 580997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581011 */     // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 581014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581055 */     GIR_RootConstrainSelectedInstOperands,
     /* 581056 */     // GIR_Coverage, 7889,
     /* 581056 */     GIR_EraseRootFromParent_Done,
     /* 581057 */   // Label 7448: @581057
     /* 581057 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(581156), // Rule ID 13392 //
     /* 581062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 581065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 581069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 581073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581085 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581110 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 581113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 581130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 581135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 581140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 581145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581154 */     GIR_RootConstrainSelectedInstOperands,
     /* 581155 */     // GIR_Coverage, 13392,
     /* 581155 */     GIR_EraseRootFromParent_Done,
     /* 581156 */   // Label 7449: @581156
     /* 581156 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(581255), // Rule ID 13408 //
     /* 581161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 581164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 581172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581184 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581209 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 581212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 581229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 581234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 581239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 581244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581253 */     GIR_RootConstrainSelectedInstOperands,
     /* 581254 */     // GIR_Coverage, 13408,
     /* 581254 */     GIR_EraseRootFromParent_Done,
     /* 581255 */   // Label 7450: @581255
     /* 581255 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(581354), // Rule ID 13391 //
     /* 581260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 581263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 581267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 581271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581283 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581308 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 581311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 581328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 581333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 581338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 581343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581352 */     GIR_RootConstrainSelectedInstOperands,
     /* 581353 */     // GIR_Coverage, 13391,
     /* 581353 */     GIR_EraseRootFromParent_Done,
     /* 581354 */   // Label 7451: @581354
     /* 581354 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(581453), // Rule ID 13407 //
     /* 581359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 581362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 581370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581382 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581407 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 581410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 581417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 581422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 581427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 581432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 581437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 581442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581451 */     GIR_RootConstrainSelectedInstOperands,
     /* 581452 */     // GIR_Coverage, 13407,
     /* 581452 */     GIR_EraseRootFromParent_Done,
     /* 581453 */   // Label 7452: @581453
     /* 581453 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(581552), // Rule ID 7866 //
     /* 581458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 581461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 581465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581481 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581506 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 581509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581550 */     GIR_RootConstrainSelectedInstOperands,
     /* 581551 */     // GIR_Coverage, 7866,
     /* 581551 */     GIR_EraseRootFromParent_Done,
     /* 581552 */   // Label 7453: @581552
     /* 581552 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(581651), // Rule ID 7882 //
     /* 581557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 581560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 581572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581580 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581605 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 581608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581649 */     GIR_RootConstrainSelectedInstOperands,
     /* 581650 */     // GIR_Coverage, 7882,
     /* 581650 */     GIR_EraseRootFromParent_Done,
     /* 581651 */   // Label 7454: @581651
     /* 581651 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(581750), // Rule ID 7865 //
     /* 581656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 581659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 581663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581679 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581704 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_t16_e64),
     /* 581707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581748 */     GIR_RootConstrainSelectedInstOperands,
     /* 581749 */     // GIR_Coverage, 7865,
     /* 581749 */     GIR_EraseRootFromParent_Done,
     /* 581750 */   // Label 7455: @581750
     /* 581750 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(581849), // Rule ID 7881 //
     /* 581755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 581758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 581766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 581770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 581774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 581778 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 581780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 581782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581803 */     // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 581803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_fake16_e64),
     /* 581806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 581813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 581823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 581833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 581838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 581847 */     GIR_RootConstrainSelectedInstOperands,
     /* 581848 */     // GIR_Coverage, 7881,
     /* 581848 */     GIR_EraseRootFromParent_Done,
     /* 581849 */   // Label 7456: @581849
     /* 581849 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(581884), // Rule ID 102 //
     /* 581854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 581857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 581861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 581865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 581869 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13745),
     /* 581873 */     // (fmaxnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13745>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 581873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
     /* 581878 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 581882 */     GIR_RootConstrainSelectedInstOperands,
     /* 581883 */     // GIR_Coverage, 102,
     /* 581883 */     GIR_Done,
     /* 581884 */   // Label 7457: @581884
     /* 581884 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(581947), // Rule ID 880 //
     /* 581889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 581892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 581903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581910 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 581910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 581913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 581920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 581930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 581940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 581945 */     GIR_RootConstrainSelectedInstOperands,
     /* 581946 */     // GIR_Coverage, 880,
     /* 581946 */     GIR_EraseRootFromParent_Done,
     /* 581947 */   // Label 7458: @581947
     /* 581947 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(582010), // Rule ID 884 //
     /* 581952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 581955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 581959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 581966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 581973 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 581973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 581976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 581978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 581983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 581988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 581993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 581998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 582003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 582008 */     GIR_RootConstrainSelectedInstOperands,
     /* 582009 */     // GIR_Coverage, 884,
     /* 582009 */     GIR_EraseRootFromParent_Done,
     /* 582010 */   // Label 7459: @582010
     /* 582010 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(582073), // Rule ID 8568 //
     /* 582015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 582018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 582036 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 582036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 582039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 582046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 582056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 582061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 582066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 582071 */     GIR_RootConstrainSelectedInstOperands,
     /* 582072 */     // GIR_Coverage, 8568,
     /* 582072 */     GIR_EraseRootFromParent_Done,
     /* 582073 */   // Label 7460: @582073
     /* 582073 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(582136), // Rule ID 8570 //
     /* 582078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 582081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 582099 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 582099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 582102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 582109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 582119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 582124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 582129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 582134 */     GIR_RootConstrainSelectedInstOperands,
     /* 582135 */     // GIR_Coverage, 8570,
     /* 582135 */     GIR_EraseRootFromParent_Done,
     /* 582136 */   // Label 7461: @582136
     /* 582136 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(582198), // Rule ID 882 //
     /* 582141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 582144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 582148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 582155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 582162 */     // (fmaxnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 582162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 582165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 582172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 582177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 582182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582196 */     GIR_RootConstrainSelectedInstOperands,
     /* 582197 */     // GIR_Coverage, 882,
     /* 582197 */     GIR_EraseRootFromParent_Done,
     /* 582198 */   // Label 7462: @582198
     /* 582198 */   GIM_Reject,
     /* 582199 */ // Label 7056: @582199
     /* 582199 */ GIM_Reject,
     /* 582200 */ // Label 7052: @582200
     /* 582200 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(599711),
     /* 582205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 582208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 582211 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(582340), // Rule ID 11527 //
     /* 582216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 582240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 582256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582260 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582265 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582270 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582283 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582297 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 582307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 582312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582338 */     GIR_RootConstrainSelectedInstOperands,
     /* 582339 */     // GIR_Coverage, 11527,
     /* 582339 */     GIR_EraseRootFromParent_Done,
     /* 582340 */   // Label 7464: @582340
     /* 582340 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(582469), // Rule ID 11528 //
     /* 582345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 582369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 582385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582389 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582394 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582426 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 582436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 582441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582467 */     GIR_RootConstrainSelectedInstOperands,
     /* 582468 */     // GIR_Coverage, 11528,
     /* 582468 */     GIR_EraseRootFromParent_Done,
     /* 582469 */   // Label 7465: @582469
     /* 582469 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(582598), // Rule ID 11531 //
     /* 582474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 582498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 582514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582518 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582518 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582523 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582523 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582528 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582555 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 582575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 582580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582596 */     GIR_RootConstrainSelectedInstOperands,
     /* 582597 */     // GIR_Coverage, 11531,
     /* 582597 */     GIR_EraseRootFromParent_Done,
     /* 582598 */   // Label 7466: @582598
     /* 582598 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(582727), // Rule ID 11532 //
     /* 582603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 582627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 582643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 582647 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582652 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582684 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 582694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 582699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 582704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 582709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582725 */     GIR_RootConstrainSelectedInstOperands,
     /* 582726 */     // GIR_Coverage, 11532,
     /* 582726 */     GIR_EraseRootFromParent_Done,
     /* 582727 */   // Label 7467: @582727
     /* 582727 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(582856), // Rule ID 11512 //
     /* 582732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 582756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582764 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 582772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 582776 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582776 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582781 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582786 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582813 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 582823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 582828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582854 */     GIR_RootConstrainSelectedInstOperands,
     /* 582855 */     // GIR_Coverage, 11512,
     /* 582855 */     GIR_EraseRootFromParent_Done,
     /* 582856 */   // Label 7468: @582856
     /* 582856 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(582985), // Rule ID 11513 //
     /* 582861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 582877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 582881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 582885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 582889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 582893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 582897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 582901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 582905 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 582905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 582910 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 582910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 582915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 582919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 582921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 582942 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 582942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 582945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 582947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 582952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 582957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 582962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 582967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 582972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 582977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 582983 */     GIR_RootConstrainSelectedInstOperands,
     /* 582984 */     // GIR_Coverage, 11513,
     /* 582984 */     GIR_EraseRootFromParent_Done,
     /* 582985 */   // Label 7469: @582985
     /* 582985 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(583114), // Rule ID 11516 //
     /* 582990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 582994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 582998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 583030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583034 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583039 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583071 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 583091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 583096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 583101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 583106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583112 */     GIR_RootConstrainSelectedInstOperands,
     /* 583113 */     // GIR_Coverage, 11516,
     /* 583113 */     GIR_EraseRootFromParent_Done,
     /* 583114 */   // Label 7470: @583114
     /* 583114 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(583243), // Rule ID 11517 //
     /* 583119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 583159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583163 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583163 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583168 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583168 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583173 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583193 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583200 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 583220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 583225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 583230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 583235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583241 */     GIR_RootConstrainSelectedInstOperands,
     /* 583242 */     // GIR_Coverage, 11517,
     /* 583242 */     GIR_EraseRootFromParent_Done,
     /* 583243 */   // Label 7471: @583243
     /* 583243 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(583372), // Rule ID 7722 //
     /* 583248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 583288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 583292 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583292 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583297 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583297 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583302 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583329 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 583339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 583344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 583359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 583364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583370 */     GIR_RootConstrainSelectedInstOperands,
     /* 583371 */     // GIR_Coverage, 7722,
     /* 583371 */     GIR_EraseRootFromParent_Done,
     /* 583372 */   // Label 7472: @583372
     /* 583372 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(583501), // Rule ID 11526 //
     /* 583377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 583417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 583421 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583426 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583431 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583458 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 583468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 583473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 583488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 583493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583499 */     GIR_RootConstrainSelectedInstOperands,
     /* 583500 */     // GIR_Coverage, 11526,
     /* 583500 */     GIR_EraseRootFromParent_Done,
     /* 583501 */   // Label 7473: @583501
     /* 583501 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(583630), // Rule ID 11529 //
     /* 583506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 583546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 583550 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583550 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583555 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583555 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583587 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 583607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 583612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 583617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 583622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583628 */     GIR_RootConstrainSelectedInstOperands,
     /* 583629 */     // GIR_Coverage, 11529,
     /* 583629 */     GIR_EraseRootFromParent_Done,
     /* 583630 */   // Label 7474: @583630
     /* 583630 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(583759), // Rule ID 11530 //
     /* 583635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 583675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 583679 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583679 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583684 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583684 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583709 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583716 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 583726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 583731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 583736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 583741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 583746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 583751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583757 */     GIR_RootConstrainSelectedInstOperands,
     /* 583758 */     // GIR_Coverage, 11530,
     /* 583758 */     GIR_EraseRootFromParent_Done,
     /* 583759 */   // Label 7475: @583759
     /* 583759 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(583888), // Rule ID 7721 //
     /* 583764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 583804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583808 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583808 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583813 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583818 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583845 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 583855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 583860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 583875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 583880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 583886 */     GIR_RootConstrainSelectedInstOperands,
     /* 583887 */     // GIR_Coverage, 7721,
     /* 583887 */     GIR_EraseRootFromParent_Done,
     /* 583888 */   // Label 7476: @583888
     /* 583888 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(584017), // Rule ID 11511 //
     /* 583893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 583897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 583901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 583909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 583913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 583917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 583921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 583925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 583929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 583933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 583937 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 583937 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 583942 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 583942 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 583947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 583951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 583953 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583967 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 583974 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 583974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 583977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 583979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 583984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 583989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 583994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 583999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584015 */     GIR_RootConstrainSelectedInstOperands,
     /* 584016 */     // GIR_Coverage, 11511,
     /* 584016 */     GIR_EraseRootFromParent_Done,
     /* 584017 */   // Label 7477: @584017
     /* 584017 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(584146), // Rule ID 11514 //
     /* 584022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 584062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 584066 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584071 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584076 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584096 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584103 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584144 */     GIR_RootConstrainSelectedInstOperands,
     /* 584145 */     // GIR_Coverage, 11514,
     /* 584145 */     GIR_EraseRootFromParent_Done,
     /* 584146 */   // Label 7478: @584146
     /* 584146 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(584275), // Rule ID 11515 //
     /* 584151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 584191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 584195 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584195 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584200 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584200 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584225 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584232 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584273 */     GIR_RootConstrainSelectedInstOperands,
     /* 584274 */     // GIR_Coverage, 11515,
     /* 584274 */     GIR_EraseRootFromParent_Done,
     /* 584275 */   // Label 7479: @584275
     /* 584275 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(584404), // Rule ID 11497 //
     /* 584280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 584320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584324 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584324 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584329 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584329 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584354 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584361 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584402 */     GIR_RootConstrainSelectedInstOperands,
     /* 584403 */     // GIR_Coverage, 11497,
     /* 584403 */     GIR_EraseRootFromParent_Done,
     /* 584404 */   // Label 7480: @584404
     /* 584404 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(584533), // Rule ID 11498 //
     /* 584409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 584449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584453 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584453 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584458 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584458 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584490 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584531 */     GIR_RootConstrainSelectedInstOperands,
     /* 584532 */     // GIR_Coverage, 11498,
     /* 584532 */     GIR_EraseRootFromParent_Done,
     /* 584533 */   // Label 7481: @584533
     /* 584533 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(584662), // Rule ID 11501 //
     /* 584538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 584578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584582 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584587 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584619 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584660 */     GIR_RootConstrainSelectedInstOperands,
     /* 584661 */     // GIR_Coverage, 11501,
     /* 584661 */     GIR_EraseRootFromParent_Done,
     /* 584662 */   // Label 7482: @584662
     /* 584662 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(584791), // Rule ID 11502 //
     /* 584667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 584707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 584711 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584711 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584716 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584716 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584748 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 584758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 584763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 584768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 584773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584789 */     GIR_RootConstrainSelectedInstOperands,
     /* 584790 */     // GIR_Coverage, 11502,
     /* 584790 */     GIR_EraseRootFromParent_Done,
     /* 584791 */   // Label 7483: @584791
     /* 584791 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(584920), // Rule ID 11482 //
     /* 584796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 584836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 584840 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584840 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584845 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584845 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584863 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584877 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 584877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 584880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 584882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 584887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 584892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 584897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 584902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 584907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 584912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 584918 */     GIR_RootConstrainSelectedInstOperands,
     /* 584919 */     // GIR_Coverage, 11482,
     /* 584919 */     GIR_EraseRootFromParent_Done,
     /* 584920 */   // Label 7484: @584920
     /* 584920 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(585049), // Rule ID 11483 //
     /* 584925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 584929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 584933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 584937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 584941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 584945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 584949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 584953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 584957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 584961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 584965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 584969 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 584969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 584974 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 584974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 584979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 584983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 584985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 584999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585006 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585047 */     GIR_RootConstrainSelectedInstOperands,
     /* 585048 */     // GIR_Coverage, 11483,
     /* 585048 */     GIR_EraseRootFromParent_Done,
     /* 585049 */   // Label 7485: @585049
     /* 585049 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(585178), // Rule ID 11486 //
     /* 585054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 585094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585098 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585098 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 585103 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585103 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 585108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585112 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585114 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585135 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585176 */     GIR_RootConstrainSelectedInstOperands,
     /* 585177 */     // GIR_Coverage, 11486,
     /* 585177 */     GIR_EraseRootFromParent_Done,
     /* 585178 */   // Label 7486: @585178
     /* 585178 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(585307), // Rule ID 11487 //
     /* 585183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 585223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585227 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 585232 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585232 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 585237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585243 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585264 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585305 */     GIR_RootConstrainSelectedInstOperands,
     /* 585306 */     // GIR_Coverage, 11487,
     /* 585306 */     GIR_EraseRootFromParent_Done,
     /* 585307 */   // Label 7487: @585307
     /* 585307 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(585436), // Rule ID 7720 //
     /* 585312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 585352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 585356 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585356 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 585361 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 585366 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585393 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585434 */     GIR_RootConstrainSelectedInstOperands,
     /* 585435 */     // GIR_Coverage, 7720,
     /* 585435 */     GIR_EraseRootFromParent_Done,
     /* 585436 */   // Label 7488: @585436
     /* 585436 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(585565), // Rule ID 11496 //
     /* 585441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 585481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 585485 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585485 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 585490 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585490 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 585495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585522 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585563 */     GIR_RootConstrainSelectedInstOperands,
     /* 585564 */     // GIR_Coverage, 11496,
     /* 585564 */     GIR_EraseRootFromParent_Done,
     /* 585565 */   // Label 7489: @585565
     /* 585565 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(585694), // Rule ID 11499 //
     /* 585570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 585610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 585614 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 585619 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 585624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585651 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585692 */     GIR_RootConstrainSelectedInstOperands,
     /* 585693 */     // GIR_Coverage, 11499,
     /* 585693 */     GIR_EraseRootFromParent_Done,
     /* 585694 */   // Label 7490: @585694
     /* 585694 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(585823), // Rule ID 11500 //
     /* 585699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 585739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 585743 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 585748 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 585753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585759 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585780 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 585790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 585795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 585800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 585805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585821 */     GIR_RootConstrainSelectedInstOperands,
     /* 585822 */     // GIR_Coverage, 11500,
     /* 585822 */     GIR_EraseRootFromParent_Done,
     /* 585823 */   // Label 7491: @585823
     /* 585823 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(585952), // Rule ID 7719 //
     /* 585828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 585868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 585872 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 585872 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 585877 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 585877 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 585882 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 585886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 585888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 585909 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 585909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 585912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 585914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 585919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 585924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 585929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 585934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 585939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 585944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 585950 */     GIR_RootConstrainSelectedInstOperands,
     /* 585951 */     // GIR_Coverage, 7719,
     /* 585951 */     GIR_EraseRootFromParent_Done,
     /* 585952 */   // Label 7492: @585952
     /* 585952 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(586081), // Rule ID 11481 //
     /* 585957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 585961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 585965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 585969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 585973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 585977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 585981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 585985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 585989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 585993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 585997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586001 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586006 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586011 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586031 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586038 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 586048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 586053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586079 */     GIR_RootConstrainSelectedInstOperands,
     /* 586080 */     // GIR_Coverage, 11481,
     /* 586080 */     GIR_EraseRootFromParent_Done,
     /* 586081 */   // Label 7493: @586081
     /* 586081 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(586210), // Rule ID 11484 //
     /* 586086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 586126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586130 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586135 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586140 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586167 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586208 */     GIR_RootConstrainSelectedInstOperands,
     /* 586209 */     // GIR_Coverage, 11484,
     /* 586209 */     GIR_EraseRootFromParent_Done,
     /* 586210 */   // Label 7494: @586210
     /* 586210 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(586339), // Rule ID 11485 //
     /* 586215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 586239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 586255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 586259 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586259 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 586264 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586264 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 586269 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586296 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 586316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 586321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 586326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 586331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586337 */     GIR_RootConstrainSelectedInstOperands,
     /* 586338 */     // GIR_Coverage, 11485,
     /* 586338 */     GIR_EraseRootFromParent_Done,
     /* 586339 */   // Label 7495: @586339
     /* 586339 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(586468), // Rule ID 11537 //
     /* 586344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 586368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 586384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586388 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586388 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586393 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586398 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586402 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586411 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586425 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 586445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 586450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 586455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 586460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586466 */     GIR_RootConstrainSelectedInstOperands,
     /* 586467 */     // GIR_Coverage, 11537,
     /* 586467 */     GIR_EraseRootFromParent_Done,
     /* 586468 */   // Label 7496: @586468
     /* 586468 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(586597), // Rule ID 11538 //
     /* 586473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 586497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 586513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586517 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586522 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586522 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586540 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586547 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586554 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 586574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 586579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 586584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 586589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586595 */     GIR_RootConstrainSelectedInstOperands,
     /* 586596 */     // GIR_Coverage, 11538,
     /* 586596 */     GIR_EraseRootFromParent_Done,
     /* 586597 */   // Label 7497: @586597
     /* 586597 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(586726), // Rule ID 11539 //
     /* 586602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 586626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 586642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586646 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586646 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586651 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586651 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586669 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586683 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 586693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 586698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 586713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 586718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586724 */     GIR_RootConstrainSelectedInstOperands,
     /* 586725 */     // GIR_Coverage, 11539,
     /* 586725 */     GIR_EraseRootFromParent_Done,
     /* 586726 */   // Label 7498: @586726
     /* 586726 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(586855), // Rule ID 11540 //
     /* 586731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 586755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 586771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586775 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586780 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586785 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586805 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586812 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 586822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 586827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 586832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 586837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 586842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 586847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586853 */     GIR_RootConstrainSelectedInstOperands,
     /* 586854 */     // GIR_Coverage, 11540,
     /* 586854 */     GIR_EraseRootFromParent_Done,
     /* 586855 */   // Label 7499: @586855
     /* 586855 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(586984), // Rule ID 11477 //
     /* 586860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 586872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 586876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 586880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 586884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 586888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 586892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 586896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 586900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 586904 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 586904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 586909 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 586909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 586914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 586918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 586920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 586941 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 586941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 586944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 586946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 586951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 586956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 586961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 586966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 586971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 586976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 586982 */     GIR_RootConstrainSelectedInstOperands,
     /* 586983 */     // GIR_Coverage, 11477,
     /* 586983 */     GIR_EraseRootFromParent_Done,
     /* 586984 */   // Label 7500: @586984
     /* 586984 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(587113), // Rule ID 11478 //
     /* 586989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 586993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 586997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587033 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587033 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587038 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587038 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587043 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587063 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587070 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 587090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 587095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 587100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 587105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587111 */     GIR_RootConstrainSelectedInstOperands,
     /* 587112 */     // GIR_Coverage, 11478,
     /* 587112 */     GIR_EraseRootFromParent_Done,
     /* 587113 */   // Label 7501: @587113
     /* 587113 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(587242), // Rule ID 11479 //
     /* 587118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587162 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587167 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587192 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587199 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 587209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 587214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 587229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 587234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587240 */     GIR_RootConstrainSelectedInstOperands,
     /* 587241 */     // GIR_Coverage, 11479,
     /* 587241 */     GIR_EraseRootFromParent_Done,
     /* 587242 */   // Label 7502: @587242
     /* 587242 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(587371), // Rule ID 11480 //
     /* 587247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 587275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587291 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587296 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587328 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 587338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 587343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 587358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 587363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587369 */     GIR_RootConstrainSelectedInstOperands,
     /* 587370 */     // GIR_Coverage, 11480,
     /* 587370 */     GIR_EraseRootFromParent_Done,
     /* 587371 */   // Label 7503: @587371
     /* 587371 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(587500), // Rule ID 11522 //
     /* 587376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587420 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587425 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587443 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587457 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 587477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 587482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 587487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 587492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587498 */     GIR_RootConstrainSelectedInstOperands,
     /* 587499 */     // GIR_Coverage, 11522,
     /* 587499 */     GIR_EraseRootFromParent_Done,
     /* 587500 */   // Label 7504: @587500
     /* 587500 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(587629), // Rule ID 11523 //
     /* 587505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587549 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587554 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587559 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587586 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 587606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 587611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 587616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 587621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587627 */     GIR_RootConstrainSelectedInstOperands,
     /* 587628 */     // GIR_Coverage, 11523,
     /* 587628 */     GIR_EraseRootFromParent_Done,
     /* 587629 */   // Label 7505: @587629
     /* 587629 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(587758), // Rule ID 11524 //
     /* 587634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587678 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587678 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587683 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587688 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587715 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 587725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 587730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 587745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 587750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587756 */     GIR_RootConstrainSelectedInstOperands,
     /* 587757 */     // GIR_Coverage, 11524,
     /* 587757 */     GIR_EraseRootFromParent_Done,
     /* 587758 */   // Label 7506: @587758
     /* 587758 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(587887), // Rule ID 11525 //
     /* 587763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587795 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587807 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587812 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587812 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587823 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587830 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587844 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 587854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 587859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 587864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 587869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 587874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 587879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 587885 */     GIR_RootConstrainSelectedInstOperands,
     /* 587886 */     // GIR_Coverage, 11525,
     /* 587886 */     GIR_EraseRootFromParent_Done,
     /* 587887 */   // Label 7507: @587887
     /* 587887 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(588016), // Rule ID 11462 //
     /* 587892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 587896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 587900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 587904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 587908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 587912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 587916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 587920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 587924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 587928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 587932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 587936 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 587936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 587941 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 587941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 587946 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 587950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 587952 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587959 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 587973 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 587973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 587976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 587978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 587983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 587988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 587993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 587998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 588003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 588008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588014 */     GIR_RootConstrainSelectedInstOperands,
     /* 588015 */     // GIR_Coverage, 11462,
     /* 588015 */     GIR_EraseRootFromParent_Done,
     /* 588016 */   // Label 7508: @588016
     /* 588016 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(588145), // Rule ID 11463 //
     /* 588021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 588045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588065 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588070 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588102 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 588122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 588127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 588132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 588137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588143 */     GIR_RootConstrainSelectedInstOperands,
     /* 588144 */     // GIR_Coverage, 11463,
     /* 588144 */     GIR_EraseRootFromParent_Done,
     /* 588145 */   // Label 7509: @588145
     /* 588145 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(588274), // Rule ID 11464 //
     /* 588150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 588174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588194 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588199 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588199 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588231 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 588241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 588246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 588261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 588266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588272 */     GIR_RootConstrainSelectedInstOperands,
     /* 588273 */     // GIR_Coverage, 11464,
     /* 588273 */     GIR_EraseRootFromParent_Done,
     /* 588274 */   // Label 7510: @588274
     /* 588274 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(588403), // Rule ID 11465 //
     /* 588279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 588303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 588307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588323 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588328 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588353 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588360 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 588370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 588375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 588390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 588395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588401 */     GIR_RootConstrainSelectedInstOperands,
     /* 588402 */     // GIR_Coverage, 11465,
     /* 588402 */     GIR_EraseRootFromParent_Done,
     /* 588403 */   // Label 7511: @588403
     /* 588403 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(588532), // Rule ID 11533 //
     /* 588408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 588432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588452 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588452 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588457 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588457 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588462 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588489 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588530 */     GIR_RootConstrainSelectedInstOperands,
     /* 588531 */     // GIR_Coverage, 11533,
     /* 588531 */     GIR_EraseRootFromParent_Done,
     /* 588532 */   // Label 7512: @588532
     /* 588532 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(588661), // Rule ID 11534 //
     /* 588537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 588561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588581 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588586 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588586 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588591 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588604 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588618 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 588628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 588633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 588638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 588643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588659 */     GIR_RootConstrainSelectedInstOperands,
     /* 588660 */     // GIR_Coverage, 11534,
     /* 588660 */     GIR_EraseRootFromParent_Done,
     /* 588661 */   // Label 7513: @588661
     /* 588661 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(588790), // Rule ID 11535 //
     /* 588666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 588690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588710 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588710 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588715 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588720 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588740 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588747 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588788 */     GIR_RootConstrainSelectedInstOperands,
     /* 588789 */     // GIR_Coverage, 11535,
     /* 588789 */     GIR_EraseRootFromParent_Done,
     /* 588790 */   // Label 7514: @588790
     /* 588790 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(588919), // Rule ID 11536 //
     /* 588795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 588819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588839 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588839 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588844 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588844 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588849 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588862 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588869 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588876 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 588876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 588879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 588881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 588886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 588891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 588896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 588901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 588906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 588911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 588917 */     GIR_RootConstrainSelectedInstOperands,
     /* 588918 */     // GIR_Coverage, 11536,
     /* 588918 */     GIR_EraseRootFromParent_Done,
     /* 588919 */   // Label 7515: @588919
     /* 588919 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(589048), // Rule ID 11473 //
     /* 588924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 588928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 588932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 588936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 588940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 588944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 588948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 588952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 588956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 588960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 588964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 588968 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 588968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 588973 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 588973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 588978 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 588982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 588984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 588998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589005 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589046 */     GIR_RootConstrainSelectedInstOperands,
     /* 589047 */     // GIR_Coverage, 11473,
     /* 589047 */     GIR_EraseRootFromParent_Done,
     /* 589048 */   // Label 7516: @589048
     /* 589048 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(589177), // Rule ID 11474 //
     /* 589053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589097 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589097 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 589102 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589102 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 589107 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589120 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589134 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589175 */     GIR_RootConstrainSelectedInstOperands,
     /* 589176 */     // GIR_Coverage, 11474,
     /* 589176 */     GIR_EraseRootFromParent_Done,
     /* 589177 */   // Label 7517: @589177
     /* 589177 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(589306), // Rule ID 11475 //
     /* 589182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589226 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589226 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 589231 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589231 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 589236 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589263 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589304 */     GIR_RootConstrainSelectedInstOperands,
     /* 589305 */     // GIR_Coverage, 11475,
     /* 589305 */     GIR_EraseRootFromParent_Done,
     /* 589306 */   // Label 7518: @589306
     /* 589306 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(589435), // Rule ID 11476 //
     /* 589311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 589339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 589355 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589355 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 589360 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589360 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 589365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589392 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589433 */     GIR_RootConstrainSelectedInstOperands,
     /* 589434 */     // GIR_Coverage, 11476,
     /* 589434 */     GIR_EraseRootFromParent_Done,
     /* 589435 */   // Label 7519: @589435
     /* 589435 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(589564), // Rule ID 11518 //
     /* 589440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589484 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 589489 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589489 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 589494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589521 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589562 */     GIR_RootConstrainSelectedInstOperands,
     /* 589563 */     // GIR_Coverage, 11518,
     /* 589563 */     GIR_EraseRootFromParent_Done,
     /* 589564 */   // Label 7520: @589564
     /* 589564 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(589693), // Rule ID 11519 //
     /* 589569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589613 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 589618 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589618 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 589623 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589636 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589650 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 589660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 589665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 589670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 589675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589691 */     GIR_RootConstrainSelectedInstOperands,
     /* 589692 */     // GIR_Coverage, 11519,
     /* 589692 */     GIR_EraseRootFromParent_Done,
     /* 589693 */   // Label 7521: @589693
     /* 589693 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(589822), // Rule ID 11520 //
     /* 589698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589742 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589742 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 589747 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 589752 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589765 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589779 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589820 */     GIR_RootConstrainSelectedInstOperands,
     /* 589821 */     // GIR_Coverage, 11520,
     /* 589821 */     GIR_EraseRootFromParent_Done,
     /* 589822 */   // Label 7522: @589822
     /* 589822 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(589951), // Rule ID 11521 //
     /* 589827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589871 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 589871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 589876 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 589876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 589881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 589885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 589887 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 589908 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 589908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 589911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 589913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 589918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 589923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 589928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 589933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 589938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 589943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 589949 */     GIR_RootConstrainSelectedInstOperands,
     /* 589950 */     // GIR_Coverage, 11521,
     /* 589950 */     GIR_EraseRootFromParent_Done,
     /* 589951 */   // Label 7523: @589951
     /* 589951 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(590080), // Rule ID 11458 //
     /* 589956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 589960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 589964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 589968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 589972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 589976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 589980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 589984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 589988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 589992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 589996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590000 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590000 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590005 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590005 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590010 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590037 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 590047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 590052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590078 */     GIR_RootConstrainSelectedInstOperands,
     /* 590079 */     // GIR_Coverage, 11458,
     /* 590079 */     GIR_EraseRootFromParent_Done,
     /* 590080 */   // Label 7524: @590080
     /* 590080 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(590209), // Rule ID 11459 //
     /* 590085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 590109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590129 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590129 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590134 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590139 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590166 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 590176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 590181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590207 */     GIR_RootConstrainSelectedInstOperands,
     /* 590208 */     // GIR_Coverage, 11459,
     /* 590208 */     GIR_EraseRootFromParent_Done,
     /* 590209 */   // Label 7525: @590209
     /* 590209 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(590338), // Rule ID 11460 //
     /* 590214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 590238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590258 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590263 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590268 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590288 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590295 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590336 */     GIR_RootConstrainSelectedInstOperands,
     /* 590337 */     // GIR_Coverage, 11460,
     /* 590337 */     GIR_EraseRootFromParent_Done,
     /* 590338 */   // Label 7526: @590338
     /* 590338 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(590467), // Rule ID 11461 //
     /* 590343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 590367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 590371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 590383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590387 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590387 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 590392 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590392 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 590397 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590424 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590465 */     GIR_RootConstrainSelectedInstOperands,
     /* 590466 */     // GIR_Coverage, 11461,
     /* 590466 */     GIR_EraseRootFromParent_Done,
     /* 590467 */   // Label 7527: @590467
     /* 590467 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(590596), // Rule ID 11467 //
     /* 590472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 590512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590516 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590521 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590521 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590553 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 590563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 590568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590594 */     GIR_RootConstrainSelectedInstOperands,
     /* 590595 */     // GIR_Coverage, 11467,
     /* 590595 */     GIR_EraseRootFromParent_Done,
     /* 590596 */   // Label 7528: @590596
     /* 590596 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(590725), // Rule ID 11468 //
     /* 590601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 590641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590645 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590650 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590655 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590682 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 590692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 590697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 590702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 590707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590723 */     GIR_RootConstrainSelectedInstOperands,
     /* 590724 */     // GIR_Coverage, 11468,
     /* 590724 */     GIR_EraseRootFromParent_Done,
     /* 590725 */   // Label 7529: @590725
     /* 590725 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(590854), // Rule ID 11471 //
     /* 590730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 590770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590774 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590779 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590779 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590811 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590852 */     GIR_RootConstrainSelectedInstOperands,
     /* 590853 */     // GIR_Coverage, 11471,
     /* 590853 */     GIR_EraseRootFromParent_Done,
     /* 590854 */   // Label 7530: @590854
     /* 590854 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(590983), // Rule ID 11472 //
     /* 590859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 590871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 590875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 590879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 590883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 590887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 590891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 590895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 590899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 590903 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 590903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 590908 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 590908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 590913 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 590917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 590919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 590940 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 590940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 590943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 590945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 590950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 590955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 590960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 590965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 590970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 590975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 590981 */     GIR_RootConstrainSelectedInstOperands,
     /* 590982 */     // GIR_Coverage, 11472,
     /* 590982 */     GIR_EraseRootFromParent_Done,
     /* 590983 */   // Label 7531: @590983
     /* 590983 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(591112), // Rule ID 11452 //
     /* 590988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 590992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 590996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 591028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591032 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591037 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591069 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 591079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 591084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 591099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 591104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591110 */     GIR_RootConstrainSelectedInstOperands,
     /* 591111 */     // GIR_Coverage, 11452,
     /* 591111 */     GIR_EraseRootFromParent_Done,
     /* 591112 */   // Label 7532: @591112
     /* 591112 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(591241), // Rule ID 11453 //
     /* 591117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 591157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591161 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591161 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591166 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591166 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591171 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591198 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 591208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 591213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 591228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 591233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591239 */     GIR_RootConstrainSelectedInstOperands,
     /* 591240 */     // GIR_Coverage, 11453,
     /* 591240 */     GIR_EraseRootFromParent_Done,
     /* 591241 */   // Label 7533: @591241
     /* 591241 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(591370), // Rule ID 11456 //
     /* 591246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 591286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591290 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591290 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591295 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591304 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591327 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 591347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 591352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 591357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 591362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591368 */     GIR_RootConstrainSelectedInstOperands,
     /* 591369 */     // GIR_Coverage, 11456,
     /* 591369 */     GIR_EraseRootFromParent_Done,
     /* 591370 */   // Label 7534: @591370
     /* 591370 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(591499), // Rule ID 11457 //
     /* 591375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 591415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 591419 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591424 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591429 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591456 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 591476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 591481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 591486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 591491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591497 */     GIR_RootConstrainSelectedInstOperands,
     /* 591498 */     // GIR_Coverage, 11457,
     /* 591498 */     GIR_EraseRootFromParent_Done,
     /* 591499 */   // Label 7535: @591499
     /* 591499 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(591628), // Rule ID 7718 //
     /* 591504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 591544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591548 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591548 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591553 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591553 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591585 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 591595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 591600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 591615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 591620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591626 */     GIR_RootConstrainSelectedInstOperands,
     /* 591627 */     // GIR_Coverage, 7718,
     /* 591627 */     GIR_EraseRootFromParent_Done,
     /* 591628 */   // Label 7536: @591628
     /* 591628 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(591757), // Rule ID 11466 //
     /* 591633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 591673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591677 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591677 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591682 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591687 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591714 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 591724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 591729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 591734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 591739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 591744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 591749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591755 */     GIR_RootConstrainSelectedInstOperands,
     /* 591756 */     // GIR_Coverage, 11466,
     /* 591756 */     GIR_EraseRootFromParent_Done,
     /* 591757 */   // Label 7537: @591757
     /* 591757 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(591886), // Rule ID 11469 //
     /* 591762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 591802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591806 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591811 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591811 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591816 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591829 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591843 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 591863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 591868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 591873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 591878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 591884 */     GIR_RootConstrainSelectedInstOperands,
     /* 591885 */     // GIR_Coverage, 11469,
     /* 591885 */     GIR_EraseRootFromParent_Done,
     /* 591886 */   // Label 7538: @591886
     /* 591886 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(592015), // Rule ID 11470 //
     /* 591891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 591895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 591899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 591903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 591907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 591911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 591915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 591919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 591923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 591927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 591931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 591935 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 591935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 591940 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 591940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 591945 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 591949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 591951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 591972 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 591972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 591975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 591977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 591982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 591987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 591992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 591997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592013 */     GIR_RootConstrainSelectedInstOperands,
     /* 592014 */     // GIR_Coverage, 11470,
     /* 592014 */     GIR_EraseRootFromParent_Done,
     /* 592015 */   // Label 7539: @592015
     /* 592015 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(592144), // Rule ID 7717 //
     /* 592020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 592060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592064 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592069 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592069 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592074 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592094 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592101 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592142 */     GIR_RootConstrainSelectedInstOperands,
     /* 592143 */     // GIR_Coverage, 7717,
     /* 592143 */     GIR_EraseRootFromParent_Done,
     /* 592144 */   // Label 7540: @592144
     /* 592144 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(592273), // Rule ID 11451 //
     /* 592149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 592189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592193 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592198 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592230 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592271 */     GIR_RootConstrainSelectedInstOperands,
     /* 592272 */     // GIR_Coverage, 11451,
     /* 592272 */     GIR_EraseRootFromParent_Done,
     /* 592273 */   // Label 7541: @592273
     /* 592273 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(592402), // Rule ID 11454 //
     /* 592278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 592318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592322 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592322 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592327 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592327 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592359 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 592379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 592384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592400 */     GIR_RootConstrainSelectedInstOperands,
     /* 592401 */     // GIR_Coverage, 11454,
     /* 592401 */     GIR_EraseRootFromParent_Done,
     /* 592402 */   // Label 7542: @592402
     /* 592402 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(592531), // Rule ID 11455 //
     /* 592407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 592435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 592447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 592451 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592456 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592461 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592488 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 592508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 592513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592529 */     GIR_RootConstrainSelectedInstOperands,
     /* 592530 */     // GIR_Coverage, 11455,
     /* 592530 */     GIR_EraseRootFromParent_Done,
     /* 592531 */   // Label 7543: @592531
     /* 592531 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(592660), // Rule ID 11437 //
     /* 592536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 592576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592580 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592585 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592617 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592658 */     GIR_RootConstrainSelectedInstOperands,
     /* 592659 */     // GIR_Coverage, 11437,
     /* 592659 */     GIR_EraseRootFromParent_Done,
     /* 592660 */   // Label 7544: @592660
     /* 592660 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(592789), // Rule ID 11438 //
     /* 592665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 592705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592709 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592714 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592719 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592732 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592739 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592746 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 592756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 592761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 592766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 592771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592787 */     GIR_RootConstrainSelectedInstOperands,
     /* 592788 */     // GIR_Coverage, 11438,
     /* 592788 */     GIR_EraseRootFromParent_Done,
     /* 592789 */   // Label 7545: @592789
     /* 592789 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(592918), // Rule ID 11441 //
     /* 592794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 592834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592838 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592843 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592875 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 592875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 592878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 592880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 592885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 592890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 592895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 592900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 592905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 592910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 592916 */     GIR_RootConstrainSelectedInstOperands,
     /* 592917 */     // GIR_Coverage, 11441,
     /* 592917 */     GIR_EraseRootFromParent_Done,
     /* 592918 */   // Label 7546: @592918
     /* 592918 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(593047), // Rule ID 11442 //
     /* 592923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 592927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 592931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 592939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 592943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 592947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 592951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 592955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 592959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 592963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 592967 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 592967 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 592972 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 592972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 592977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 592981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 592983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 592997 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593004 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593045 */     GIR_RootConstrainSelectedInstOperands,
     /* 593046 */     // GIR_Coverage, 11442,
     /* 593046 */     GIR_EraseRootFromParent_Done,
     /* 593047 */   // Label 7547: @593047
     /* 593047 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(593176), // Rule ID 11422 //
     /* 593052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 593092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593096 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593096 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 593101 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 593106 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593133 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593174 */     GIR_RootConstrainSelectedInstOperands,
     /* 593175 */     // GIR_Coverage, 11422,
     /* 593175 */     GIR_EraseRootFromParent_Done,
     /* 593176 */   // Label 7548: @593176
     /* 593176 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(593305), // Rule ID 11423 //
     /* 593181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 593221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593225 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 593230 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 593235 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593262 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593303 */     GIR_RootConstrainSelectedInstOperands,
     /* 593304 */     // GIR_Coverage, 11423,
     /* 593304 */     GIR_EraseRootFromParent_Done,
     /* 593305 */   // Label 7549: @593305
     /* 593305 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(593434), // Rule ID 11426 //
     /* 593310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 593350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593354 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 593359 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593359 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 593364 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593384 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593391 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593432 */     GIR_RootConstrainSelectedInstOperands,
     /* 593433 */     // GIR_Coverage, 11426,
     /* 593433 */     GIR_EraseRootFromParent_Done,
     /* 593434 */   // Label 7550: @593434
     /* 593434 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(593563), // Rule ID 11427 //
     /* 593439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 593479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 593483 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 593488 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 593493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593520 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593561 */     GIR_RootConstrainSelectedInstOperands,
     /* 593562 */     // GIR_Coverage, 11427,
     /* 593562 */     GIR_EraseRootFromParent_Done,
     /* 593563 */   // Label 7551: @593563
     /* 593563 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(593692), // Rule ID 7716 //
     /* 593568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 593608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593612 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593612 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 593617 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 593622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593642 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593649 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593690 */     GIR_RootConstrainSelectedInstOperands,
     /* 593691 */     // GIR_Coverage, 7716,
     /* 593691 */     GIR_EraseRootFromParent_Done,
     /* 593692 */   // Label 7552: @593692
     /* 593692 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(593821), // Rule ID 11436 //
     /* 593697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 593737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593741 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 593746 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593746 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 593751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593764 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593778 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 593788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 593793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 593798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 593803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593819 */     GIR_RootConstrainSelectedInstOperands,
     /* 593820 */     // GIR_Coverage, 11436,
     /* 593820 */     GIR_EraseRootFromParent_Done,
     /* 593821 */   // Label 7553: @593821
     /* 593821 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(593950), // Rule ID 11439 //
     /* 593826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593858 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 593866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593870 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 593870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 593875 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593875 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 593880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 593884 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 593886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 593907 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 593907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 593910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 593912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 593917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 593922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 593927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 593932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 593937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 593942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 593948 */     GIR_RootConstrainSelectedInstOperands,
     /* 593949 */     // GIR_Coverage, 11439,
     /* 593949 */     GIR_EraseRootFromParent_Done,
     /* 593950 */   // Label 7554: @593950
     /* 593950 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(594079), // Rule ID 11440 //
     /* 593955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 593959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 593963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 593971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 593975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 593979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 593983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 593987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 593991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 593995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 593999 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 593999 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 594004 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594004 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 594009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594015 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594036 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594077 */     GIR_RootConstrainSelectedInstOperands,
     /* 594078 */     // GIR_Coverage, 11440,
     /* 594078 */     GIR_EraseRootFromParent_Done,
     /* 594079 */   // Label 7555: @594079
     /* 594079 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(594208), // Rule ID 7715 //
     /* 594084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 594108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 594124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594128 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594128 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 594133 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 594138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594144 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594165 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594206 */     GIR_RootConstrainSelectedInstOperands,
     /* 594207 */     // GIR_Coverage, 7715,
     /* 594207 */     GIR_EraseRootFromParent_Done,
     /* 594208 */   // Label 7556: @594208
     /* 594208 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(594337), // Rule ID 11421 //
     /* 594213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 594237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 594253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594257 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594257 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 594262 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594262 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 594267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594294 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 594304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 594309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594335 */     GIR_RootConstrainSelectedInstOperands,
     /* 594336 */     // GIR_Coverage, 11421,
     /* 594336 */     GIR_EraseRootFromParent_Done,
     /* 594337 */   // Label 7557: @594337
     /* 594337 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(594466), // Rule ID 11424 //
     /* 594342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 594366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 594382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594386 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 594391 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594391 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 594396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594423 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594464 */     GIR_RootConstrainSelectedInstOperands,
     /* 594465 */     // GIR_Coverage, 11424,
     /* 594465 */     GIR_EraseRootFromParent_Done,
     /* 594466 */   // Label 7558: @594466
     /* 594466 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(594595), // Rule ID 11425 //
     /* 594471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 594495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 594511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 594515 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594515 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 594520 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594520 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 594525 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594552 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 594572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 594577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 594582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 594587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594593 */     GIR_RootConstrainSelectedInstOperands,
     /* 594594 */     // GIR_Coverage, 11425,
     /* 594594 */     GIR_EraseRootFromParent_Done,
     /* 594595 */   // Label 7559: @594595
     /* 594595 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(594724), // Rule ID 11507 //
     /* 594600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 594624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 594628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594644 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594649 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594649 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594674 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594681 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594722 */     GIR_RootConstrainSelectedInstOperands,
     /* 594723 */     // GIR_Coverage, 11507,
     /* 594723 */     GIR_EraseRootFromParent_Done,
     /* 594724 */   // Label 7560: @594724
     /* 594724 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(594853), // Rule ID 11508 //
     /* 594729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 594753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 594757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594773 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594778 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594796 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594810 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 594820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 594825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 594830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 594835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594851 */     GIR_RootConstrainSelectedInstOperands,
     /* 594852 */     // GIR_Coverage, 11508,
     /* 594852 */     GIR_EraseRootFromParent_Done,
     /* 594853 */   // Label 7561: @594853
     /* 594853 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(594982), // Rule ID 11509 //
     /* 594858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 594874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 594878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 594882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 594886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 594890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 594894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 594898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 594902 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 594902 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 594907 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 594907 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 594912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 594916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 594918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 594939 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 594939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 594942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 594944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 594949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 594954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 594959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 594964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 594969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 594974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 594980 */     GIR_RootConstrainSelectedInstOperands,
     /* 594981 */     // GIR_Coverage, 11509,
     /* 594981 */     GIR_EraseRootFromParent_Done,
     /* 594982 */   // Label 7562: @594982
     /* 594982 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(595111), // Rule ID 11510 //
     /* 594987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 594991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 594995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 594999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 595015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 595031 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595036 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595036 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595061 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595068 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 595078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 595083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595109 */     GIR_RootConstrainSelectedInstOperands,
     /* 595110 */     // GIR_Coverage, 11510,
     /* 595110 */     GIR_EraseRootFromParent_Done,
     /* 595111 */   // Label 7563: @595111
     /* 595111 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(595240), // Rule ID 11447 //
     /* 595116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 595144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595160 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595160 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595165 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595197 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595238 */     GIR_RootConstrainSelectedInstOperands,
     /* 595239 */     // GIR_Coverage, 11447,
     /* 595239 */     GIR_EraseRootFromParent_Done,
     /* 595240 */   // Label 7564: @595240
     /* 595240 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(595369), // Rule ID 11448 //
     /* 595245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 595273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595289 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595289 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595294 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595294 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595299 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595326 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595367 */     GIR_RootConstrainSelectedInstOperands,
     /* 595368 */     // GIR_Coverage, 11448,
     /* 595368 */     GIR_EraseRootFromParent_Done,
     /* 595369 */   // Label 7565: @595369
     /* 595369 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(595498), // Rule ID 11449 //
     /* 595374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 595402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595418 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595423 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595423 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595448 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595455 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 595465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 595470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595496 */     GIR_RootConstrainSelectedInstOperands,
     /* 595497 */     // GIR_Coverage, 11449,
     /* 595497 */     GIR_EraseRootFromParent_Done,
     /* 595498 */   // Label 7566: @595498
     /* 595498 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(595627), // Rule ID 11450 //
     /* 595503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 595531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595547 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595552 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595584 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 595594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 595599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595625 */     GIR_RootConstrainSelectedInstOperands,
     /* 595626 */     // GIR_Coverage, 11450,
     /* 595626 */     GIR_EraseRootFromParent_Done,
     /* 595627 */   // Label 7567: @595627
     /* 595627 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(595756), // Rule ID 11492 //
     /* 595632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 595660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 595676 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595676 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595681 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595681 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595686 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595699 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595713 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595754 */     GIR_RootConstrainSelectedInstOperands,
     /* 595755 */     // GIR_Coverage, 11492,
     /* 595755 */     GIR_EraseRootFromParent_Done,
     /* 595756 */   // Label 7568: @595756
     /* 595756 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(595885), // Rule ID 11493 //
     /* 595761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 595789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 595805 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595810 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595815 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595828 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595842 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 595852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 595857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 595862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 595867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 595872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 595877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 595883 */     GIR_RootConstrainSelectedInstOperands,
     /* 595884 */     // GIR_Coverage, 11493,
     /* 595884 */     GIR_EraseRootFromParent_Done,
     /* 595885 */   // Label 7569: @595885
     /* 595885 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(596014), // Rule ID 11494 //
     /* 595890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 595894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 595898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 595902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 595906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 595910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 595914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 595918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 595922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 595926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 595930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 595934 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 595934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 595939 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 595939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 595944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 595948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 595950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595957 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595964 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 595971 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 595971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 595974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 595976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 595981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 595986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 595991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 595996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596012 */     GIR_RootConstrainSelectedInstOperands,
     /* 596013 */     // GIR_Coverage, 11494,
     /* 596013 */     GIR_EraseRootFromParent_Done,
     /* 596014 */   // Label 7570: @596014
     /* 596014 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(596143), // Rule ID 11495 //
     /* 596019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 596043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 596047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 596063 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596068 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596068 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596093 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596100 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 596103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 596110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 596115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596141 */     GIR_RootConstrainSelectedInstOperands,
     /* 596142 */     // GIR_Coverage, 11495,
     /* 596142 */     GIR_EraseRootFromParent_Done,
     /* 596143 */   // Label 7571: @596143
     /* 596143 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(596272), // Rule ID 11432 //
     /* 596148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 596172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 596176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596192 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596192 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596197 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596202 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596229 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 596232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596270 */     GIR_RootConstrainSelectedInstOperands,
     /* 596271 */     // GIR_Coverage, 11432,
     /* 596271 */     GIR_EraseRootFromParent_Done,
     /* 596272 */   // Label 7572: @596272
     /* 596272 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(596401), // Rule ID 11433 //
     /* 596277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 596301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 596305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596321 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596326 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596331 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596344 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596358 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 596361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 596368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 596373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 596378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 596383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596399 */     GIR_RootConstrainSelectedInstOperands,
     /* 596400 */     // GIR_Coverage, 11433,
     /* 596400 */     GIR_EraseRootFromParent_Done,
     /* 596401 */   // Label 7573: @596401
     /* 596401 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(596530), // Rule ID 11434 //
     /* 596406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 596430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 596434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596450 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596455 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596466 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596473 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596487 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 596490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 596497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 596502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596528 */     GIR_RootConstrainSelectedInstOperands,
     /* 596529 */     // GIR_Coverage, 11434,
     /* 596529 */     GIR_EraseRootFromParent_Done,
     /* 596530 */   // Label 7574: @596530
     /* 596530 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(596659), // Rule ID 11435 //
     /* 596535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 596559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 596563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596579 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596579 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596584 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596589 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596616 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 596619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
     /* 596626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
     /* 596631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 596646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 596651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596657 */     GIR_RootConstrainSelectedInstOperands,
     /* 596658 */     // GIR_Coverage, 11435,
     /* 596658 */     GIR_EraseRootFromParent_Done,
     /* 596659 */   // Label 7575: @596659
     /* 596659 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(596788), // Rule ID 11503 //
     /* 596664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 596692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 596708 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596713 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596713 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596718 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596738 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596745 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 596748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596786 */     GIR_RootConstrainSelectedInstOperands,
     /* 596787 */     // GIR_Coverage, 11503,
     /* 596787 */     GIR_EraseRootFromParent_Done,
     /* 596788 */   // Label 7576: @596788
     /* 596788 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(596917), // Rule ID 11504 //
     /* 596793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 596821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 596837 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596837 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596842 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596842 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596874 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 596874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 596877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 596879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 596884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 596889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 596894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 596899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 596904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 596909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 596915 */     GIR_RootConstrainSelectedInstOperands,
     /* 596916 */     // GIR_Coverage, 11504,
     /* 596916 */     GIR_EraseRootFromParent_Done,
     /* 596917 */   // Label 7577: @596917
     /* 596917 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(597046), // Rule ID 11505 //
     /* 596922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 596926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 596930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 596934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 596938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 596942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 596946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 596950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 596954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 596958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 596962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 596966 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 596966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 596971 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 596971 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 596976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 596980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 596982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 596996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597003 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 597023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597044 */     GIR_RootConstrainSelectedInstOperands,
     /* 597045 */     // GIR_Coverage, 11505,
     /* 597045 */     GIR_EraseRootFromParent_Done,
     /* 597046 */   // Label 7578: @597046
     /* 597046 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(597175), // Rule ID 11506 //
     /* 597051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 597079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 597095 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 597095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 597100 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 597105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 597109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 597111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597132 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 597152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597173 */     GIR_RootConstrainSelectedInstOperands,
     /* 597174 */     // GIR_Coverage, 11506,
     /* 597174 */     GIR_EraseRootFromParent_Done,
     /* 597175 */   // Label 7579: @597175
     /* 597175 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(597304), // Rule ID 11443 //
     /* 597180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 597208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597216 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597220 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597224 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597224 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 597229 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 597229 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 597234 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 597238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 597240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597261 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597302 */     GIR_RootConstrainSelectedInstOperands,
     /* 597303 */     // GIR_Coverage, 11443,
     /* 597303 */     GIR_EraseRootFromParent_Done,
     /* 597304 */   // Label 7580: @597304
     /* 597304 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(597433), // Rule ID 11444 //
     /* 597309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 597337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597353 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 597353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 597358 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 597363 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 597367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 597369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597390 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597431 */     GIR_RootConstrainSelectedInstOperands,
     /* 597432 */     // GIR_Coverage, 11444,
     /* 597432 */     GIR_EraseRootFromParent_Done,
     /* 597433 */   // Label 7581: @597433
     /* 597433 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(597562), // Rule ID 11445 //
     /* 597438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 597466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597482 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597482 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 597487 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 597487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 597492 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 597496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 597498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597519 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 597539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597560 */     GIR_RootConstrainSelectedInstOperands,
     /* 597561 */     // GIR_Coverage, 11445,
     /* 597561 */     GIR_EraseRootFromParent_Done,
     /* 597562 */   // Label 7582: @597562
     /* 597562 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(597691), // Rule ID 11446 //
     /* 597567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
     /* 597595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597611 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 597611 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 597616 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597616 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 597621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 597625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 597627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597648 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 597658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 597663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 597668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 597673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597689 */     GIR_RootConstrainSelectedInstOperands,
     /* 597690 */     // GIR_Coverage, 11446,
     /* 597690 */     GIR_EraseRootFromParent_Done,
     /* 597691 */   // Label 7583: @597691
     /* 597691 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(597820), // Rule ID 11488 //
     /* 597696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 597724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 597740 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 597745 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 597745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 597750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 597754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 597756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597770 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597777 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597818 */     GIR_RootConstrainSelectedInstOperands,
     /* 597819 */     // GIR_Coverage, 11488,
     /* 597819 */     GIR_EraseRootFromParent_Done,
     /* 597820 */   // Label 7584: @597820
     /* 597820 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(597949), // Rule ID 11489 //
     /* 597825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 597853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 597869 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 597869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 597874 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 597879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 597883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 597885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 597906 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 597906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 597909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 597911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 597916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 597921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 597926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 597931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 597936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 597941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 597947 */     GIR_RootConstrainSelectedInstOperands,
     /* 597948 */     // GIR_Coverage, 11489,
     /* 597948 */     GIR_EraseRootFromParent_Done,
     /* 597949 */   // Label 7585: @597949
     /* 597949 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(598078), // Rule ID 11490 //
     /* 597954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 597958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 597962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 597966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 597970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 597974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 597978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 597982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 597986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 597990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 597994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 597998 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 597998 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 598003 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 598003 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 598008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 598012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 598014 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598021 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598035 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 598038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 598055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 598060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598076 */     GIR_RootConstrainSelectedInstOperands,
     /* 598077 */     // GIR_Coverage, 11490,
     /* 598077 */     GIR_EraseRootFromParent_Done,
     /* 598078 */   // Label 7586: @598078
     /* 598078 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(598207), // Rule ID 11491 //
     /* 598083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 598103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 598111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 598123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 598127 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 598127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 598132 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 598132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 598137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 598141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 598143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598150 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598164 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 598167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 598184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 598189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598205 */     GIR_RootConstrainSelectedInstOperands,
     /* 598206 */     // GIR_Coverage, 11491,
     /* 598206 */     GIR_EraseRootFromParent_Done,
     /* 598207 */   // Label 7587: @598207
     /* 598207 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(598336), // Rule ID 11428 //
     /* 598212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 598232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 598240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 598252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598256 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 598256 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 598261 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 598261 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 598266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 598270 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 598272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598293 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 598296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598334 */     GIR_RootConstrainSelectedInstOperands,
     /* 598335 */     // GIR_Coverage, 11428,
     /* 598335 */     GIR_EraseRootFromParent_Done,
     /* 598336 */   // Label 7588: @598336
     /* 598336 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(598465), // Rule ID 11429 //
     /* 598341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 598361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 598369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 598381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598385 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 598385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 598390 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 598390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 598395 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 598399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 598401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598408 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598422 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 598425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 598432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 598437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 598442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 598447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598463 */     GIR_RootConstrainSelectedInstOperands,
     /* 598464 */     // GIR_Coverage, 11429,
     /* 598464 */     GIR_EraseRootFromParent_Done,
     /* 598465 */   // Label 7589: @598465
     /* 598465 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(598594), // Rule ID 11430 //
     /* 598470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 598490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 598498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 598510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598514 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 598514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 598519 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 598519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 598524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 598528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 598530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598551 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 598554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 598571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 598576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598592 */     GIR_RootConstrainSelectedInstOperands,
     /* 598593 */     // GIR_Coverage, 11430,
     /* 598593 */     GIR_EraseRootFromParent_Done,
     /* 598594 */   // Label 7590: @598594
     /* 598594 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(598723), // Rule ID 11431 //
     /* 598599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 598619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
     /* 598627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 598639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598643 */     // MIs[3] VOP3Mods:src1:src1_mods
     /* 598643 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 598648 */     // MIs[3] VOP3Mods:src0:src0_mods
     /* 598648 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 598653 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
     /* 598657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 598659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598666 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598680 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 598683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
     /* 598700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 598705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 598710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 598715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598721 */     GIR_RootConstrainSelectedInstOperands,
     /* 598722 */     // GIR_Coverage, 11431,
     /* 598722 */     GIR_EraseRootFromParent_Done,
     /* 598723 */   // Label 7591: @598723
     /* 598723 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(598835), // Rule ID 13384 //
     /* 598728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 598731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 598755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598763 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598765 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 598769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598792 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 598795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598833 */     GIR_RootConstrainSelectedInstOperands,
     /* 598834 */     // GIR_Coverage, 13384,
     /* 598834 */     GIR_EraseRootFromParent_Done,
     /* 598835 */   // Label 7592: @598835
     /* 598835 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(598947), // Rule ID 13383 //
     /* 598840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 598843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 598851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 598867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598875 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598877 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 598881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 598904 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 598904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 598907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 598909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 598914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 598919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 598924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 598929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 598934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 598939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 598945 */     GIR_RootConstrainSelectedInstOperands,
     /* 598946 */     // GIR_Coverage, 13383,
     /* 598946 */     GIR_EraseRootFromParent_Done,
     /* 598947 */   // Label 7593: @598947
     /* 598947 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(599059), // Rule ID 7858 //
     /* 598952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 598955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 598959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 598963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 598967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 598971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 598975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 598979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 598983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 598987 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 598989 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 598993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 598995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599002 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599016 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 599019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599057 */     GIR_RootConstrainSelectedInstOperands,
     /* 599058 */     // GIR_Coverage, 7858,
     /* 599058 */     GIR_EraseRootFromParent_Done,
     /* 599059 */   // Label 7594: @599059
     /* 599059 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(599171), // Rule ID 7857 //
     /* 599064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 599067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 599075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 599079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 599087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 599091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 599095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 599099 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 599101 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 599105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 599107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599121 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599128 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 599131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599169 */     GIR_RootConstrainSelectedInstOperands,
     /* 599170 */     // GIR_Coverage, 7857,
     /* 599170 */     GIR_EraseRootFromParent_Done,
     /* 599171 */   // Label 7595: @599171
     /* 599171 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(599267), // Rule ID 13376 //
     /* 599176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 599179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 599187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 599191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599199 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599224 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 599227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 599234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 599244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 599249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 599254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 599259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599265 */     GIR_RootConstrainSelectedInstOperands,
     /* 599266 */     // GIR_Coverage, 13376,
     /* 599266 */     GIR_EraseRootFromParent_Done,
     /* 599267 */   // Label 7596: @599267
     /* 599267 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(599363), // Rule ID 13375 //
     /* 599272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 599275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 599283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 599287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599295 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599320 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 599323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 599330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 599340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 599345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 599350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 599355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599361 */     GIR_RootConstrainSelectedInstOperands,
     /* 599362 */     // GIR_Coverage, 13375,
     /* 599362 */     GIR_EraseRootFromParent_Done,
     /* 599363 */   // Label 7597: @599363
     /* 599363 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(599459), // Rule ID 7850 //
     /* 599368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 599371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 599379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
     /* 599383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599391 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599416 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 599419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599457 */     GIR_RootConstrainSelectedInstOperands,
     /* 599458 */     // GIR_Coverage, 7850,
     /* 599458 */     GIR_EraseRootFromParent_Done,
     /* 599459 */   // Label 7598: @599459
     /* 599459 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(599555), // Rule ID 7849 //
     /* 599464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 599467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 599475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
     /* 599479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 599483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 599487 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 599489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 599491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599512 */     // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 599512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
     /* 599515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 599522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 599532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 599542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 599547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 599553 */     GIR_RootConstrainSelectedInstOperands,
     /* 599554 */     // GIR_Coverage, 7849,
     /* 599554 */     GIR_EraseRootFromParent_Done,
     /* 599555 */   // Label 7599: @599555
     /* 599555 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(599590), // Rule ID 92 //
     /* 599560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 599563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 599575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13745),
     /* 599579 */     // (fmaxnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13745>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 599579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
     /* 599584 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 599588 */     GIR_RootConstrainSelectedInstOperands,
     /* 599589 */     // GIR_Coverage, 92,
     /* 599589 */     GIR_Done,
     /* 599590 */   // Label 7600: @599590
     /* 599590 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(599650), // Rule ID 803 //
     /* 599595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599613 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 599616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 599643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 599648 */     GIR_RootConstrainSelectedInstOperands,
     /* 599649 */     // GIR_Coverage, 803,
     /* 599649 */     GIR_EraseRootFromParent_Done,
     /* 599650 */   // Label 7601: @599650
     /* 599650 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(599710), // Rule ID 8557 //
     /* 599655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599673 */     // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 599676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 599683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 599693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 599698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 599703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 599708 */     GIR_RootConstrainSelectedInstOperands,
     /* 599709 */     // GIR_Coverage, 8557,
     /* 599709 */     GIR_EraseRootFromParent_Done,
     /* 599710 */   // Label 7602: @599710
     /* 599710 */   GIM_Reject,
     /* 599711 */ // Label 7463: @599711
     /* 599711 */ GIM_Reject,
     /* 599712 */ // Label 7053: @599712
     /* 599712 */ GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(599964),
     /* 599717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 599720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 599723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 599727 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(599786), // Rule ID 918 //
     /* 599732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599749 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 599752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 599779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 599784 */     GIR_RootConstrainSelectedInstOperands,
     /* 599785 */     // GIR_Coverage, 918,
     /* 599785 */     GIR_EraseRootFromParent_Done,
     /* 599786 */   // Label 7604: @599786
     /* 599786 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(599845), // Rule ID 937 //
     /* 599791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 599794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599808 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 599811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 599818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 599823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 599828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 599833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 599838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 599843 */     GIR_RootConstrainSelectedInstOperands,
     /* 599844 */     // GIR_Coverage, 937,
     /* 599844 */     GIR_EraseRootFromParent_Done,
     /* 599845 */   // Label 7605: @599845
     /* 599845 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(599904), // Rule ID 8583 //
     /* 599850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 599853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599867 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 599870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 599877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 599887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 599892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 599897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 599902 */     GIR_RootConstrainSelectedInstOperands,
     /* 599903 */     // GIR_Coverage, 8583,
     /* 599903 */     GIR_EraseRootFromParent_Done,
     /* 599904 */   // Label 7606: @599904
     /* 599904 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(599963), // Rule ID 8597 //
     /* 599909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 599912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 599919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 599926 */     // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 599926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 599929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 599936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 599941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 599946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 599951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 599956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 599961 */     GIR_RootConstrainSelectedInstOperands,
     /* 599962 */     // GIR_Coverage, 8597,
     /* 599962 */     GIR_EraseRootFromParent_Done,
     /* 599963 */   // Label 7607: @599963
     /* 599963 */   GIM_Reject,
     /* 599964 */ // Label 7603: @599964
     /* 599964 */ GIM_Reject,
     /* 599965 */ // Label 7054: @599965
     /* 599965 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(600036), // Rule ID 1095 //
     /* 599970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 599973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 599976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 599980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 599987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 599994 */   // (fmaxnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 599994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 599997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 599999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 600004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 600009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 600014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600034 */   GIR_RootConstrainSelectedInstOperands,
     /* 600035 */   // GIR_Coverage, 1095,
     /* 600035 */   GIR_EraseRootFromParent_Done,
     /* 600036 */ // Label 7608: @600036
     /* 600036 */ GIM_Reject,
     /* 600037 */ // Label 7055: @600037
     /* 600037 */ GIM_Reject,
     /* 600038 */ // Label 84: @600038
     /* 600038 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7613*/ GIMT_Encode4(602152),
     /* 600049 */ /*GILLT_s16*//*Label 7609*/ GIMT_Encode4(600065),
     /* 600053 */ /*GILLT_s32*//*Label 7610*/ GIMT_Encode4(601187),
     /* 600057 */ /*GILLT_s64*//*Label 7611*/ GIMT_Encode4(601862),
     /* 600061 */ /*GILLT_v2s16*//*Label 7612*/ GIMT_Encode4(601997),
     /* 600065 */ // Label 7609: @600065
     /* 600065 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(601186),
     /* 600070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 600073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 600076 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(600195), // Rule ID 13580 //
     /* 600081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 600084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 600092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 600096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600116 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 600118 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 600122 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 600128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600142 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600149 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35116>>)<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 600152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 600159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 600164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 600169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 600174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 600179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 600184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600193 */     GIR_RootConstrainSelectedInstOperands,
     /* 600194 */     // GIR_Coverage, 13580,
     /* 600194 */     GIR_EraseRootFromParent_Done,
     /* 600195 */   // Label 7615: @600195
     /* 600195 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(600314), // Rule ID 13584 //
     /* 600200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 600203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 600211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 600215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600235 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 600237 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 600241 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 600247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600268 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35116>>)<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 600271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 600278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 600283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 600288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 600293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 600298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 600303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600312 */     GIR_RootConstrainSelectedInstOperands,
     /* 600313 */     // GIR_Coverage, 13584,
     /* 600313 */     GIR_EraseRootFromParent_Done,
     /* 600314 */   // Label 7616: @600314
     /* 600314 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(600433), // Rule ID 7914 //
     /* 600319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 600322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 600334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600354 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 600356 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 600360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 600366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600387 */     // (fminimum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 600390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 600397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 600402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 600407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 600417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 600422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600431 */     GIR_RootConstrainSelectedInstOperands,
     /* 600432 */     // GIR_Coverage, 7914,
     /* 600432 */     GIR_EraseRootFromParent_Done,
     /* 600433 */   // Label 7617: @600433
     /* 600433 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(600552), // Rule ID 7918 //
     /* 600438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 600441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 600453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 600461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 600469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 600473 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 600475 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 600479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 600485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600506 */     // (fminimum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 600509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 600516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 600521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 600526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 600536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 600541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600550 */     GIR_RootConstrainSelectedInstOperands,
     /* 600551 */     // GIR_Coverage, 7918,
     /* 600551 */     GIR_EraseRootFromParent_Done,
     /* 600552 */   // Label 7618: @600552
     /* 600552 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(600655), // Rule ID 13578 //
     /* 600557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 600560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 600568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600580 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 600582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 600588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600609 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 600612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 600619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 600624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 600629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 600634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 600639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 600644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600653 */     GIR_RootConstrainSelectedInstOperands,
     /* 600654 */     // GIR_Coverage, 13578,
     /* 600654 */     GIR_EraseRootFromParent_Done,
     /* 600655 */   // Label 7619: @600655
     /* 600655 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(600758), // Rule ID 13582 //
     /* 600660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 600663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 600671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600683 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 600685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 600691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600712 */     // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 600715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 600722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 600727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 600732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 600737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 600742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 600747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600756 */     GIR_RootConstrainSelectedInstOperands,
     /* 600757 */     // GIR_Coverage, 13582,
     /* 600757 */     GIR_EraseRootFromParent_Done,
     /* 600758 */   // Label 7620: @600758
     /* 600758 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(600861), // Rule ID 7912 //
     /* 600763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 600766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 600770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600786 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 600788 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 600794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600815 */     // (fminimum:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_t16_e64),
     /* 600818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 600825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 600830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 600835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 600845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 600850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600859 */     GIR_RootConstrainSelectedInstOperands,
     /* 600860 */     // GIR_Coverage, 7912,
     /* 600860 */     GIR_EraseRootFromParent_Done,
     /* 600861 */   // Label 7621: @600861
     /* 600861 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(600964), // Rule ID 7916 //
     /* 600866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 600869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 600873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 600877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 600881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 600885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 600889 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 600891 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 600895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 600897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 600918 */     // (fminimum:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 600918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_fake16_e64),
     /* 600921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 600923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 600928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 600933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 600938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 600943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 600948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 600953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 600962 */     GIR_RootConstrainSelectedInstOperands,
     /* 600963 */     // GIR_Coverage, 7916,
     /* 600963 */     GIR_EraseRootFromParent_Done,
     /* 600964 */   // Label 7622: @600964
     /* 600964 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(600999), // Rule ID 116 //
     /* 600969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 600972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 600976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 600980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 600984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13750),
     /* 600988 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13751),
     /* 600992 */     // (fminimum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13750>><<P:Predicate_anonymous_13751>>  =>  (S_MINIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 600992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F16),
     /* 600997 */     GIR_RootConstrainSelectedInstOperands,
     /* 600998 */     // GIR_Coverage, 116,
     /* 600998 */     GIR_Done,
     /* 600999 */   // Label 7623: @600999
     /* 600999 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(601061), // Rule ID 944 //
     /* 601004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX12Plus),
     /* 601007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 601018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 601025 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 601025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_e64),
     /* 601028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 601035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 601045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601059 */     GIR_RootConstrainSelectedInstOperands,
     /* 601060 */     // GIR_Coverage, 944,
     /* 601060 */     GIR_EraseRootFromParent_Done,
     /* 601061 */   // Label 7624: @601061
     /* 601061 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(601123), // Rule ID 945 //
     /* 601066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 601069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 601073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 601080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 601087 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 601087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_t16_e64),
     /* 601090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 601097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 601107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601121 */     GIR_RootConstrainSelectedInstOperands,
     /* 601122 */     // GIR_Coverage, 945,
     /* 601122 */     GIR_EraseRootFromParent_Done,
     /* 601123 */   // Label 7625: @601123
     /* 601123 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(601185), // Rule ID 946 //
     /* 601128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 601131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 601142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 601149 */     // (fminimum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 601149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_fake16_e64),
     /* 601152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 601159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 601169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601183 */     GIR_RootConstrainSelectedInstOperands,
     /* 601184 */     // GIR_Coverage, 946,
     /* 601184 */     GIR_EraseRootFromParent_Done,
     /* 601185 */   // Label 7626: @601185
     /* 601185 */   GIM_Reject,
     /* 601186 */ // Label 7614: @601186
     /* 601186 */ GIM_Reject,
     /* 601187 */ // Label 7610: @601187
     /* 601187 */ GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(601861),
     /* 601192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 601195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 601198 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(601314), // Rule ID 13576 //
     /* 601203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 601214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 601218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 601222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 601230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 601234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 601238 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 601240 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 601244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 601248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 601250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601271 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35116>>)<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 601271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 601274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 601281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 601286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 601291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 601296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 601301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 601306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601312 */     GIR_RootConstrainSelectedInstOperands,
     /* 601313 */     // GIR_Coverage, 13576,
     /* 601313 */     GIR_EraseRootFromParent_Done,
     /* 601314 */   // Label 7628: @601314
     /* 601314 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(601430), // Rule ID 7910 //
     /* 601319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 601334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 601338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 601342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 601346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 601350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 601354 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 601356 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 601360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 601364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 601366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601380 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601387 */     // (fminimum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 601387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 601390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 601397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 601407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 601417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 601422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601428 */     GIR_RootConstrainSelectedInstOperands,
     /* 601429 */     // GIR_Coverage, 7910,
     /* 601429 */     GIR_EraseRootFromParent_Done,
     /* 601430 */   // Label 7629: @601430
     /* 601430 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(601530), // Rule ID 13574 //
     /* 601435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 601446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 601450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 601454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 601458 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 601460 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 601464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 601466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601487 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 601487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 601490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 601497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 601502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 601507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 601512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 601517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 601522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601528 */     GIR_RootConstrainSelectedInstOperands,
     /* 601529 */     // GIR_Coverage, 13574,
     /* 601529 */     GIR_EraseRootFromParent_Done,
     /* 601530 */   // Label 7630: @601530
     /* 601530 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(601630), // Rule ID 7908 //
     /* 601535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 601546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
     /* 601550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 601554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 601558 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 601560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35156),
     /* 601564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 601566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601580 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601587 */     // (fminimum:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35156>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 601587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
     /* 601590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 601597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 601607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 601617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 601622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601628 */     GIR_RootConstrainSelectedInstOperands,
     /* 601629 */     // GIR_Coverage, 7908,
     /* 601629 */     GIR_EraseRootFromParent_Done,
     /* 601630 */   // Label 7631: @601630
     /* 601630 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(601665), // Rule ID 114 //
     /* 601635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 601642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 601646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 601650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13750),
     /* 601654 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13751),
     /* 601658 */     // (fminimum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13750>><<P:Predicate_anonymous_13751>>  =>  (S_MINIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 601658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F32),
     /* 601663 */     GIR_RootConstrainSelectedInstOperands,
     /* 601664 */     // GIR_Coverage, 114,
     /* 601664 */     GIR_Done,
     /* 601665 */   // Label 7632: @601665
     /* 601665 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(601728), // Rule ID 942 //
     /* 601670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 601684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601691 */     // (fminimum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 601691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
     /* 601694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 601701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 601711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 601721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 601726 */     GIR_RootConstrainSelectedInstOperands,
     /* 601727 */     // GIR_Coverage, 942,
     /* 601727 */     GIR_EraseRootFromParent_Done,
     /* 601728 */   // Label 7633: @601728
     /* 601728 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(601791), // Rule ID 8602 //
     /* 601733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 601754 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 601754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
     /* 601757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 601764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 601769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 601774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 601779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 601784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 601789 */     GIR_RootConstrainSelectedInstOperands,
     /* 601790 */     // GIR_Coverage, 8602,
     /* 601790 */     GIR_EraseRootFromParent_Done,
     /* 601791 */   // Label 7634: @601791
     /* 601791 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(601860), // Rule ID 2719 //
     /* 601796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
     /* 601799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 601803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601817 */     // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MINIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
     /* 601817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM3_F32_e64),
     /* 601820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 601827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 601837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 601847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 601858 */     GIR_RootConstrainSelectedInstOperands,
     /* 601859 */     // GIR_Coverage, 2719,
     /* 601859 */     GIR_EraseRootFromParent_Done,
     /* 601860 */   // Label 7635: @601860
     /* 601860 */   GIM_Reject,
     /* 601861 */ // Label 7627: @601861
     /* 601861 */ GIM_Reject,
     /* 601862 */ // Label 7611: @601862
     /* 601862 */ GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(601996),
     /* 601867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 601870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 601873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 601877 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(601936), // Rule ID 950 //
     /* 601882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 601892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601899 */     // (fminimum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 601899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
     /* 601902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 601909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 601914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 601919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 601924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 601929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 601934 */     GIR_RootConstrainSelectedInstOperands,
     /* 601935 */     // GIR_Coverage, 950,
     /* 601935 */     GIR_EraseRootFromParent_Done,
     /* 601936 */   // Label 7637: @601936
     /* 601936 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(601995), // Rule ID 8604 //
     /* 601941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 601944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 601951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 601958 */     // (fminimum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 601958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
     /* 601961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 601963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 601968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 601973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 601978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 601983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 601988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 601993 */     GIR_RootConstrainSelectedInstOperands,
     /* 601994 */     // GIR_Coverage, 8604,
     /* 601994 */     GIR_EraseRootFromParent_Done,
     /* 601995 */   // Label 7638: @601995
     /* 601995 */   GIM_Reject,
     /* 601996 */ // Label 7636: @601996
     /* 601996 */ GIM_Reject,
     /* 601997 */ // Label 7612: @601997
     /* 601997 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(602151),
     /* 602002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 602005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 602008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602012 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(602086), // Rule ID 2737 //
     /* 602017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
     /* 602020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 602027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 602034 */     // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MINIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
     /* 602034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM3_F16),
     /* 602037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 602044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 602049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 602054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 602059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 602064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 602069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602084 */     GIR_RootConstrainSelectedInstOperands,
     /* 602085 */     // GIR_Coverage, 2737,
     /* 602085 */     GIR_EraseRootFromParent_Done,
     /* 602086 */   // Label 7640: @602086
     /* 602086 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(602150), // Rule ID 1106 //
     /* 602091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 602094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 602101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 602108 */     // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MINIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 602108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM_F16),
     /* 602111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 602118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 602123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 602128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 602133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602148 */     GIR_RootConstrainSelectedInstOperands,
     /* 602149 */     // GIR_Coverage, 1106,
     /* 602149 */     GIR_EraseRootFromParent_Done,
     /* 602150 */   // Label 7641: @602150
     /* 602150 */   GIM_Reject,
     /* 602151 */ // Label 7639: @602151
     /* 602151 */ GIM_Reject,
     /* 602152 */ // Label 7613: @602152
     /* 602152 */ GIM_Reject,
     /* 602153 */ // Label 85: @602153
     /* 602153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7646*/ GIMT_Encode4(604267),
     /* 602164 */ /*GILLT_s16*//*Label 7642*/ GIMT_Encode4(602180),
     /* 602168 */ /*GILLT_s32*//*Label 7643*/ GIMT_Encode4(603302),
     /* 602172 */ /*GILLT_s64*//*Label 7644*/ GIMT_Encode4(603977),
     /* 602176 */ /*GILLT_v2s16*//*Label 7645*/ GIMT_Encode4(604112),
     /* 602180 */ // Label 7642: @602180
     /* 602180 */ GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(603301),
     /* 602185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 602188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 602191 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(602310), // Rule ID 13579 //
     /* 602196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 602199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 602207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 602211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 602219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602231 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 602233 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 602237 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 602241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 602243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602257 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602264 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35116>>)<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 602264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 602267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 602274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 602279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 602284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 602289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 602294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 602299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602308 */     GIR_RootConstrainSelectedInstOperands,
     /* 602309 */     // GIR_Coverage, 13579,
     /* 602309 */     GIR_EraseRootFromParent_Done,
     /* 602310 */   // Label 7648: @602310
     /* 602310 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(602429), // Rule ID 13583 //
     /* 602315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 602318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 602326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 602330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 602338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602350 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 602352 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 602356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 602360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 602362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602383 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35116>>)<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 602383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 602386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 602393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 602398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 602403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 602408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 602413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 602418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602427 */     GIR_RootConstrainSelectedInstOperands,
     /* 602428 */     // GIR_Coverage, 13583,
     /* 602428 */     GIR_EraseRootFromParent_Done,
     /* 602429 */   // Label 7649: @602429
     /* 602429 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(602548), // Rule ID 7913 //
     /* 602434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 602437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 602449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 602457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602469 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 602471 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 602475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 602479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 602481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602502 */     // (fmaximum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 602502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 602505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 602512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 602517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 602522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 602527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 602532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 602537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602546 */     GIR_RootConstrainSelectedInstOperands,
     /* 602547 */     // GIR_Coverage, 7913,
     /* 602547 */     GIR_EraseRootFromParent_Done,
     /* 602548 */   // Label 7650: @602548
     /* 602548 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(602667), // Rule ID 7917 //
     /* 602553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 602556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 602568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 602576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 602584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 602588 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 602590 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 602594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 602598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 602600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602614 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602621 */     // (fmaximum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 602621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 602624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 602631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 602636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 602641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 602646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 602651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 602656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602665 */     GIR_RootConstrainSelectedInstOperands,
     /* 602666 */     // GIR_Coverage, 7917,
     /* 602666 */     GIR_EraseRootFromParent_Done,
     /* 602667 */   // Label 7651: @602667
     /* 602667 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(602770), // Rule ID 13577 //
     /* 602672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 602675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 602683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602695 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 602697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 602701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 602703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602710 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602724 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 602724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 602727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 602734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 602739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 602744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 602749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 602754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 602759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602768 */     GIR_RootConstrainSelectedInstOperands,
     /* 602769 */     // GIR_Coverage, 13577,
     /* 602769 */     GIR_EraseRootFromParent_Done,
     /* 602770 */   // Label 7652: @602770
     /* 602770 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(602873), // Rule ID 13581 //
     /* 602775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 602778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 602786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602798 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 602800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 602804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 602806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602820 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602827 */     // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 602827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 602830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 602837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 602842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 602847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 602852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 602857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 602862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602871 */     GIR_RootConstrainSelectedInstOperands,
     /* 602872 */     // GIR_Coverage, 13581,
     /* 602872 */     GIR_EraseRootFromParent_Done,
     /* 602873 */   // Label 7653: @602873
     /* 602873 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(602976), // Rule ID 7911 //
     /* 602878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 602881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 602885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 602897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 602901 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 602903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 602907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 602909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 602930 */     // (fmaximum:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 602930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_t16_e64),
     /* 602933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 602935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 602940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 602945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 602950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 602955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 602960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 602965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 602974 */     GIR_RootConstrainSelectedInstOperands,
     /* 602975 */     // GIR_Coverage, 7911,
     /* 602975 */     GIR_EraseRootFromParent_Done,
     /* 602976 */   // Label 7654: @602976
     /* 602976 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(603079), // Rule ID 7915 //
     /* 602981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 602984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 602988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 602992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 602996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 603000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 603004 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 603006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 603010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 603012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603019 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603033 */     // (fmaximum:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 603033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_fake16_e64),
     /* 603036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 603043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 603053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 603063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 603068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603077 */     GIR_RootConstrainSelectedInstOperands,
     /* 603078 */     // GIR_Coverage, 7915,
     /* 603078 */     GIR_EraseRootFromParent_Done,
     /* 603079 */   // Label 7655: @603079
     /* 603079 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(603114), // Rule ID 117 //
     /* 603084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 603091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 603095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 603099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /* 603103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /* 603107 */     // (fmaximum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13752>><<P:Predicate_anonymous_13753>>  =>  (S_MAXIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 603107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F16),
     /* 603112 */     GIR_RootConstrainSelectedInstOperands,
     /* 603113 */     // GIR_Coverage, 117,
     /* 603113 */     GIR_Done,
     /* 603114 */   // Label 7656: @603114
     /* 603114 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(603176), // Rule ID 947 //
     /* 603119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX12Plus),
     /* 603122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 603133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 603140 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 603140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_e64),
     /* 603143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 603150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 603160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603174 */     GIR_RootConstrainSelectedInstOperands,
     /* 603175 */     // GIR_Coverage, 947,
     /* 603175 */     GIR_EraseRootFromParent_Done,
     /* 603176 */   // Label 7657: @603176
     /* 603176 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(603238), // Rule ID 948 //
     /* 603181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX12Plus),
     /* 603184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 603188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 603195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 603202 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 603202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_t16_e64),
     /* 603205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 603212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 603222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603236 */     GIR_RootConstrainSelectedInstOperands,
     /* 603237 */     // GIR_Coverage, 948,
     /* 603237 */     GIR_EraseRootFromParent_Done,
     /* 603238 */   // Label 7658: @603238
     /* 603238 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(603300), // Rule ID 949 //
     /* 603243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX12Plus),
     /* 603246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 603257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 603264 */     // (fmaximum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 603264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_fake16_e64),
     /* 603267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 603274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 603284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603298 */     GIR_RootConstrainSelectedInstOperands,
     /* 603299 */     // GIR_Coverage, 949,
     /* 603299 */     GIR_EraseRootFromParent_Done,
     /* 603300 */   // Label 7659: @603300
     /* 603300 */   GIM_Reject,
     /* 603301 */ // Label 7647: @603301
     /* 603301 */ GIM_Reject,
     /* 603302 */ // Label 7643: @603302
     /* 603302 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(603976),
     /* 603307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 603310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 603313 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(603429), // Rule ID 13575 //
     /* 603318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 603329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 603333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 603337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 603341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 603345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 603349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 603353 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 603355 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 603359 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 603363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 603365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603379 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603386 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35116>>)<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 603386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 603389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 603396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 603401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 603406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 603411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 603416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 603421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603427 */     GIR_RootConstrainSelectedInstOperands,
     /* 603428 */     // GIR_Coverage, 13575,
     /* 603428 */     GIR_EraseRootFromParent_Done,
     /* 603429 */   // Label 7661: @603429
     /* 603429 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(603545), // Rule ID 7909 //
     /* 603434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 603449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 603453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 603457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 603461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 603465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 603469 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 603471 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35116),
     /* 603475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 603479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 603481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603488 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603495 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603502 */     // (fmaximum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35116>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 603502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 603505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 603512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 603522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 603532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 603537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603543 */     GIR_RootConstrainSelectedInstOperands,
     /* 603544 */     // GIR_Coverage, 7909,
     /* 603544 */     GIR_EraseRootFromParent_Done,
     /* 603545 */   // Label 7662: @603545
     /* 603545 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(603645), // Rule ID 13573 //
     /* 603550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 603561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 603565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 603569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 603573 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 603575 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 603579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 603581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603588 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603602 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 603602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 603605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
     /* 603612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 603617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
     /* 603622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
     /* 603627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
     /* 603632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
     /* 603637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603643 */     GIR_RootConstrainSelectedInstOperands,
     /* 603644 */     // GIR_Coverage, 13573,
     /* 603644 */     GIR_EraseRootFromParent_Done,
     /* 603645 */   // Label 7663: @603645
     /* 603645 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(603745), // Rule ID 7907 //
     /* 603650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 603661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
     /* 603665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 603669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 603673 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 603675 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35154),
     /* 603679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 603681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603702 */     // (fmaximum:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_35154>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
     /* 603702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
     /* 603705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 603712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 603722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
     /* 603732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 603737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603743 */     GIR_RootConstrainSelectedInstOperands,
     /* 603744 */     // GIR_Coverage, 7907,
     /* 603744 */     GIR_EraseRootFromParent_Done,
     /* 603745 */   // Label 7664: @603745
     /* 603745 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(603780), // Rule ID 115 //
     /* 603750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 603757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 603761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 603765 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13752),
     /* 603769 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13753),
     /* 603773 */     // (fmaximum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13752>><<P:Predicate_anonymous_13753>>  =>  (S_MAXIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 603773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F32),
     /* 603778 */     GIR_RootConstrainSelectedInstOperands,
     /* 603779 */     // GIR_Coverage, 115,
     /* 603779 */     GIR_Done,
     /* 603780 */   // Label 7665: @603780
     /* 603780 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(603843), // Rule ID 943 //
     /* 603785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 603799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603806 */     // (fmaximum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 603806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
     /* 603809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 603816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 603826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 603836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 603841 */     GIR_RootConstrainSelectedInstOperands,
     /* 603842 */     // GIR_Coverage, 943,
     /* 603842 */     GIR_EraseRootFromParent_Done,
     /* 603843 */   // Label 7666: @603843
     /* 603843 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(603906), // Rule ID 8603 //
     /* 603848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 603851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 603869 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 603869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
     /* 603872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 603879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 603884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 603889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 603894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 603899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 603904 */     GIR_RootConstrainSelectedInstOperands,
     /* 603905 */     // GIR_Coverage, 8603,
     /* 603905 */     GIR_EraseRootFromParent_Done,
     /* 603906 */   // Label 7667: @603906
     /* 603906 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(603975), // Rule ID 2720 //
     /* 603911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
     /* 603914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 603918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 603932 */     // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MAXIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
     /* 603932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM3_F32_e64),
     /* 603935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 603937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 603942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 603947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 603952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 603962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 603967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 603973 */     GIR_RootConstrainSelectedInstOperands,
     /* 603974 */     // GIR_Coverage, 2720,
     /* 603974 */     GIR_EraseRootFromParent_Done,
     /* 603975 */   // Label 7668: @603975
     /* 603975 */   GIM_Reject,
     /* 603976 */ // Label 7660: @603976
     /* 603976 */ GIM_Reject,
     /* 603977 */ // Label 7644: @603977
     /* 603977 */ GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(604111),
     /* 603982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 603985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 603988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 603992 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(604051), // Rule ID 951 //
     /* 603997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 604000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 604007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 604014 */     // (fmaximum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 604014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
     /* 604017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 604024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 604029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 604034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 604039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 604044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 604049 */     GIR_RootConstrainSelectedInstOperands,
     /* 604050 */     // GIR_Coverage, 951,
     /* 604050 */     GIR_EraseRootFromParent_Done,
     /* 604051 */   // Label 7670: @604051
     /* 604051 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(604110), // Rule ID 8605 //
     /* 604056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 604059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 604066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 604073 */     // (fmaximum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 604073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
     /* 604076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 604083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 604088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 604093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 604098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 604103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 604108 */     GIR_RootConstrainSelectedInstOperands,
     /* 604109 */     // GIR_Coverage, 8605,
     /* 604109 */     GIR_EraseRootFromParent_Done,
     /* 604110 */   // Label 7671: @604110
     /* 604110 */   GIM_Reject,
     /* 604111 */ // Label 7669: @604111
     /* 604111 */ GIM_Reject,
     /* 604112 */ // Label 7645: @604112
     /* 604112 */ GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(604266),
     /* 604117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 604120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 604123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604127 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(604201), // Rule ID 2738 //
     /* 604132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
     /* 604135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 604142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 604149 */     // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MAXIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
     /* 604149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM3_F16),
     /* 604152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 604159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 604164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 604169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 604174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
     /* 604179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 604184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604199 */     GIR_RootConstrainSelectedInstOperands,
     /* 604200 */     // GIR_Coverage, 2738,
     /* 604200 */     GIR_EraseRootFromParent_Done,
     /* 604201 */   // Label 7673: @604201
     /* 604201 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(604265), // Rule ID 1105 //
     /* 604206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 604209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 604216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 604223 */     // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAXIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 604223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM_F16),
     /* 604226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 604233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 604238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 604243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 604248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604263 */     GIR_RootConstrainSelectedInstOperands,
     /* 604264 */     // GIR_Coverage, 1105,
     /* 604264 */     GIR_EraseRootFromParent_Done,
     /* 604265 */   // Label 7674: @604265
     /* 604265 */   GIM_Reject,
     /* 604266 */ // Label 7672: @604266
     /* 604266 */ GIM_Reject,
     /* 604267 */ // Label 7646: @604267
     /* 604267 */ GIM_Reject,
     /* 604268 */ // Label 86: @604268
     /* 604268 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(604391),
     /* 604273 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 604276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 604280 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(604335), // Rule ID 1874 //
     /* 604285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 604288 */     // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 8909823:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 47105:{ *:[i32] }))
     /* 604288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 604291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 604295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 604300 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(47105),
     /* 604310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 604312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 604315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 604317 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(8909823),
     /* 604327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 604330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 604333 */     GIR_RootConstrainSelectedInstOperands,
     /* 604334 */     // GIR_Coverage, 1874,
     /* 604334 */     GIR_EraseRootFromParent_Done,
     /* 604335 */   // Label 7676: @604335
     /* 604335 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(604390), // Rule ID 1875 //
     /* 604340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 604343 */     // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 521215:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 36865:{ *:[i32] }))
     /* 604343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 604346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
     /* 604350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 604355 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(36865),
     /* 604365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 604367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
     /* 604370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 604372 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(521215),
     /* 604382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 604385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 604388 */     GIR_RootConstrainSelectedInstOperands,
     /* 604389 */     // GIR_Coverage, 1875,
     /* 604389 */     GIR_EraseRootFromParent_Done,
     /* 604390 */   // Label 7677: @604390
     /* 604390 */   GIM_Reject,
     /* 604391 */ // Label 7675: @604391
     /* 604391 */ GIM_Reject,
     /* 604392 */ // Label 87: @604392
     /* 604392 */ GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(604468), // Rule ID 2603 //
     /* 604397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 604400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 604403 */   // MIs[0] DstI[vdst]
     /* 604403 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
     /* 604407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604411 */   // MIs[0] Operand 1
     /* 604411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 604415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_PTR_ADD),
     /* 604423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 604427 */   GIM_CheckHasOneUse, /*MI*/1,
     /* 604429 */   // MIs[1] src0
     /* 604429 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/32,
     /* 604433 */   GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /* 604437 */   GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /* 604441 */   GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:4:z
     /* 604445 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20820),
     /* 604449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 604451 */   // (ptradd:{ *:[i32] } (ptradd:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:4:x, i32:{ *:[i32] }:$src1:$pred:4:y)<<P:Predicate_anonymous_20821>>, i32:{ *:[i32] }:$src2:$pred:4:z)<<P:4:Predicate_anonymous_20820>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 604451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
     /* 604454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604456 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 604460 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 604464 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 604466 */   GIR_RootConstrainSelectedInstOperands,
     /* 604467 */   // GIR_Coverage, 2603,
     /* 604467 */   GIR_EraseRootFromParent_Done,
     /* 604468 */ // Label 7678: @604468
     /* 604468 */ GIM_Reject,
     /* 604469 */ // Label 88: @604469
     /* 604469 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7682*/ GIMT_Encode4(610832),
     /* 604480 */ /*GILLT_s16*//*Label 7679*/ GIMT_Encode4(604496),
     /* 604484 */ /*GILLT_s32*//*Label 7680*/ GIMT_Encode4(609315), GIMT_Encode4(0),
     /* 604492 */ /*GILLT_v2s16*//*Label 7681*/ GIMT_Encode4(610760),
     /* 604496 */ // Label 7679: @604496
     /* 604496 */ GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(609314),
     /* 604501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 604504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 604507 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(604605), // Rule ID 11923 //
     /* 604512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 604515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 604539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 604555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604559 */     // MIs[3] src0
     /* 604559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 604564 */     // MIs[3] src1
     /* 604564 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 604569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604571 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 604574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 604583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 604590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 604597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604603 */     GIR_RootConstrainSelectedInstOperands,
     /* 604604 */     // GIR_Coverage, 11923,
     /* 604604 */     GIR_EraseRootFromParent_Done,
     /* 604605 */   // Label 7684: @604605
     /* 604605 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(604703), // Rule ID 11924 //
     /* 604610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 604613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 604637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 604653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604657 */     // MIs[3] src1
     /* 604657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 604662 */     // MIs[3] src0
     /* 604662 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 604667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604669 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 604672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 604681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 604688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 604695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604701 */     GIR_RootConstrainSelectedInstOperands,
     /* 604702 */     // GIR_Coverage, 11924,
     /* 604702 */     GIR_EraseRootFromParent_Done,
     /* 604703 */   // Label 7685: @604703
     /* 604703 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(604801), // Rule ID 11925 //
     /* 604708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 604711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 604735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604747 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 604751 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604755 */     // MIs[3] src0
     /* 604755 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 604760 */     // MIs[3] src1
     /* 604760 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 604765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604767 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 604770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 604779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 604786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 604793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604799 */     GIR_RootConstrainSelectedInstOperands,
     /* 604800 */     // GIR_Coverage, 11925,
     /* 604800 */     GIR_EraseRootFromParent_Done,
     /* 604801 */   // Label 7686: @604801
     /* 604801 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(604899), // Rule ID 11926 //
     /* 604806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 604809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 604813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 604833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 604849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604853 */     // MIs[3] src1
     /* 604853 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 604858 */     // MIs[3] src0
     /* 604858 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 604863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604865 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 604868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 604877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 604884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 604891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604897 */     GIR_RootConstrainSelectedInstOperands,
     /* 604898 */     // GIR_Coverage, 11926,
     /* 604898 */     GIR_EraseRootFromParent_Done,
     /* 604899 */   // Label 7687: @604899
     /* 604899 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(604997), // Rule ID 13475 //
     /* 604904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 604907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 604911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 604915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 604923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 604927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 604931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 604935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 604939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 604943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 604947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 604951 */     // MIs[3] src0
     /* 604951 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 604956 */     // MIs[3] src1
     /* 604956 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 604961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 604963 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 604963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 604966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 604968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 604975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 604982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 604989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 604995 */     GIR_RootConstrainSelectedInstOperands,
     /* 604996 */     // GIR_Coverage, 13475,
     /* 604996 */     GIR_EraseRootFromParent_Done,
     /* 604997 */   // Label 7688: @604997
     /* 604997 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(605095), // Rule ID 13476 //
     /* 605002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 605005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 605009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605049 */     // MIs[3] src1
     /* 605049 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605054 */     // MIs[3] src0
     /* 605054 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605061 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 605064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605093 */     GIR_RootConstrainSelectedInstOperands,
     /* 605094 */     // GIR_Coverage, 13476,
     /* 605094 */     GIR_EraseRootFromParent_Done,
     /* 605095 */   // Label 7689: @605095
     /* 605095 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(605193), // Rule ID 13477 //
     /* 605100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 605103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 605107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605147 */     // MIs[3] src0
     /* 605147 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605152 */     // MIs[3] src1
     /* 605152 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605159 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 605162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605191 */     GIR_RootConstrainSelectedInstOperands,
     /* 605192 */     // GIR_Coverage, 13477,
     /* 605192 */     GIR_EraseRootFromParent_Done,
     /* 605193 */   // Label 7690: @605193
     /* 605193 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(605291), // Rule ID 13478 //
     /* 605198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 605201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 605205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605245 */     // MIs[3] src1
     /* 605245 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605250 */     // MIs[3] src0
     /* 605250 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605257 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 605260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605289 */     GIR_RootConstrainSelectedInstOperands,
     /* 605290 */     // GIR_Coverage, 13478,
     /* 605290 */     GIR_EraseRootFromParent_Done,
     /* 605291 */   // Label 7691: @605291
     /* 605291 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(605389), // Rule ID 13535 //
     /* 605296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 605299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605343 */     // MIs[3] src0
     /* 605343 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605348 */     // MIs[3] src1
     /* 605348 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605355 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 605358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605387 */     GIR_RootConstrainSelectedInstOperands,
     /* 605388 */     // GIR_Coverage, 13535,
     /* 605388 */     GIR_EraseRootFromParent_Done,
     /* 605389 */   // Label 7692: @605389
     /* 605389 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(605487), // Rule ID 13536 //
     /* 605394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 605397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605441 */     // MIs[3] src1
     /* 605441 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605446 */     // MIs[3] src0
     /* 605446 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605453 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 605456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605485 */     GIR_RootConstrainSelectedInstOperands,
     /* 605486 */     // GIR_Coverage, 13536,
     /* 605486 */     GIR_EraseRootFromParent_Done,
     /* 605487 */   // Label 7693: @605487
     /* 605487 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(605585), // Rule ID 13537 //
     /* 605492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 605495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605539 */     // MIs[3] src0
     /* 605539 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605544 */     // MIs[3] src1
     /* 605544 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605551 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 605554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605583 */     GIR_RootConstrainSelectedInstOperands,
     /* 605584 */     // GIR_Coverage, 13537,
     /* 605584 */     GIR_EraseRootFromParent_Done,
     /* 605585 */   // Label 7694: @605585
     /* 605585 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(605683), // Rule ID 13538 //
     /* 605590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 605593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 605617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605637 */     // MIs[3] src1
     /* 605637 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605642 */     // MIs[3] src0
     /* 605642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605649 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 605652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 605675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605681 */     GIR_RootConstrainSelectedInstOperands,
     /* 605682 */     // GIR_Coverage, 13538,
     /* 605682 */     GIR_EraseRootFromParent_Done,
     /* 605683 */   // Label 7695: @605683
     /* 605683 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(605781), // Rule ID 11927 //
     /* 605688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 605691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605735 */     // MIs[3] src0
     /* 605735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605740 */     // MIs[3] src1
     /* 605740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605747 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 605750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605779 */     GIR_RootConstrainSelectedInstOperands,
     /* 605780 */     // GIR_Coverage, 11927,
     /* 605780 */     GIR_EraseRootFromParent_Done,
     /* 605781 */   // Label 7696: @605781
     /* 605781 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(605879), // Rule ID 11928 //
     /* 605786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 605789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605833 */     // MIs[3] src1
     /* 605833 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605838 */     // MIs[3] src0
     /* 605838 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605843 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605845 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 605848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 605857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 605864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605877 */     GIR_RootConstrainSelectedInstOperands,
     /* 605878 */     // GIR_Coverage, 11928,
     /* 605878 */     GIR_EraseRootFromParent_Done,
     /* 605879 */   // Label 7697: @605879
     /* 605879 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(605977), // Rule ID 11929 //
     /* 605884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 605887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 605903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 605907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 605911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 605915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 605919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 605923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 605927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605931 */     // MIs[3] src0
     /* 605931 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 605936 */     // MIs[3] src1
     /* 605936 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 605941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 605943 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 605943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 605946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 605948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 605955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 605962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 605969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 605975 */     GIR_RootConstrainSelectedInstOperands,
     /* 605976 */     // GIR_Coverage, 11929,
     /* 605976 */     GIR_EraseRootFromParent_Done,
     /* 605977 */   // Label 7698: @605977
     /* 605977 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(606075), // Rule ID 11930 //
     /* 605982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 605985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 605989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 605993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 605997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606029 */     // MIs[3] src1
     /* 606029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606034 */     // MIs[3] src0
     /* 606034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606041 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 606053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 606060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606073 */     GIR_RootConstrainSelectedInstOperands,
     /* 606074 */     // GIR_Coverage, 11930,
     /* 606074 */     GIR_EraseRootFromParent_Done,
     /* 606075 */   // Label 7699: @606075
     /* 606075 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(606173), // Rule ID 13479 //
     /* 606080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 606083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 606087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606127 */     // MIs[3] src0
     /* 606127 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606132 */     // MIs[3] src1
     /* 606132 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606139 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 606142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606171 */     GIR_RootConstrainSelectedInstOperands,
     /* 606172 */     // GIR_Coverage, 13479,
     /* 606172 */     GIR_EraseRootFromParent_Done,
     /* 606173 */   // Label 7700: @606173
     /* 606173 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(606271), // Rule ID 13480 //
     /* 606178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 606181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 606185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606225 */     // MIs[3] src1
     /* 606225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606230 */     // MIs[3] src0
     /* 606230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606237 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 606240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606269 */     GIR_RootConstrainSelectedInstOperands,
     /* 606270 */     // GIR_Coverage, 13480,
     /* 606270 */     GIR_EraseRootFromParent_Done,
     /* 606271 */   // Label 7701: @606271
     /* 606271 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(606369), // Rule ID 13481 //
     /* 606276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 606279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 606283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606323 */     // MIs[3] src0
     /* 606323 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606328 */     // MIs[3] src1
     /* 606328 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606335 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 606338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 606347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 606354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606367 */     GIR_RootConstrainSelectedInstOperands,
     /* 606368 */     // GIR_Coverage, 13481,
     /* 606368 */     GIR_EraseRootFromParent_Done,
     /* 606369 */   // Label 7702: @606369
     /* 606369 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(606467), // Rule ID 13482 //
     /* 606374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 606377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 606381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606421 */     // MIs[3] src1
     /* 606421 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606426 */     // MIs[3] src0
     /* 606426 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606433 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 606436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 606445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 606452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606465 */     GIR_RootConstrainSelectedInstOperands,
     /* 606466 */     // GIR_Coverage, 13482,
     /* 606466 */     GIR_EraseRootFromParent_Done,
     /* 606467 */   // Label 7703: @606467
     /* 606467 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(606565), // Rule ID 13539 //
     /* 606472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 606475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606519 */     // MIs[3] src0
     /* 606519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606524 */     // MIs[3] src1
     /* 606524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606531 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 606534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606563 */     GIR_RootConstrainSelectedInstOperands,
     /* 606564 */     // GIR_Coverage, 13539,
     /* 606564 */     GIR_EraseRootFromParent_Done,
     /* 606565 */   // Label 7704: @606565
     /* 606565 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(606663), // Rule ID 13540 //
     /* 606570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 606573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606617 */     // MIs[3] src1
     /* 606617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606622 */     // MIs[3] src0
     /* 606622 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606629 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 606632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 606641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 606648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606661 */     GIR_RootConstrainSelectedInstOperands,
     /* 606662 */     // GIR_Coverage, 13540,
     /* 606662 */     GIR_EraseRootFromParent_Done,
     /* 606663 */   // Label 7705: @606663
     /* 606663 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(606761), // Rule ID 13541 //
     /* 606668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 606671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606715 */     // MIs[3] src0
     /* 606715 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606720 */     // MIs[3] src1
     /* 606720 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606727 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 606730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 606739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 606746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606759 */     GIR_RootConstrainSelectedInstOperands,
     /* 606760 */     // GIR_Coverage, 13541,
     /* 606760 */     GIR_EraseRootFromParent_Done,
     /* 606761 */   // Label 7706: @606761
     /* 606761 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(606859), // Rule ID 13542 //
     /* 606766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 606769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 606793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 606809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606813 */     // MIs[3] src1
     /* 606813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 606818 */     // MIs[3] src0
     /* 606818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 606823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606825 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 606828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 606837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 606844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 606851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606857 */     GIR_RootConstrainSelectedInstOperands,
     /* 606858 */     // GIR_Coverage, 13542,
     /* 606858 */     GIR_EraseRootFromParent_Done,
     /* 606859 */   // Label 7707: @606859
     /* 606859 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(606957), // Rule ID 7748 //
     /* 606864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 606867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 606871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 606903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 606907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 606911 */     // MIs[3] src0
     /* 606911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 606916 */     // MIs[3] src1
     /* 606916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 606921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 606923 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 606923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 606926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 606928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 606935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 606942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 606949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 606955 */     GIR_RootConstrainSelectedInstOperands,
     /* 606956 */     // GIR_Coverage, 7748,
     /* 606956 */     GIR_EraseRootFromParent_Done,
     /* 606957 */   // Label 7708: @606957
     /* 606957 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(607055), // Rule ID 7900 //
     /* 606962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 606965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 606969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 606973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 606981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 606985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 606989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 606993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 606997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607009 */     // MIs[3] src0
     /* 607009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607014 */     // MIs[3] src1
     /* 607014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607021 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 607033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 607040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607053 */     GIR_RootConstrainSelectedInstOperands,
     /* 607054 */     // GIR_Coverage, 7900,
     /* 607054 */     GIR_EraseRootFromParent_Done,
     /* 607055 */   // Label 7709: @607055
     /* 607055 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(607153), // Rule ID 7904 //
     /* 607060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607107 */     // MIs[3] src0
     /* 607107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607112 */     // MIs[3] src1
     /* 607112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607119 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 607131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 607138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607151 */     GIR_RootConstrainSelectedInstOperands,
     /* 607152 */     // GIR_Coverage, 7904,
     /* 607152 */     GIR_EraseRootFromParent_Done,
     /* 607153 */   // Label 7710: @607153
     /* 607153 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(607251), // Rule ID 11916 //
     /* 607158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607205 */     // MIs[3] src1
     /* 607205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607210 */     // MIs[3] src0
     /* 607210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607217 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 607229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 607236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607249 */     GIR_RootConstrainSelectedInstOperands,
     /* 607250 */     // GIR_Coverage, 11916,
     /* 607250 */     GIR_EraseRootFromParent_Done,
     /* 607251 */   // Label 7711: @607251
     /* 607251 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(607349), // Rule ID 11919 //
     /* 607256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607303 */     // MIs[3] src0
     /* 607303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607308 */     // MIs[3] src1
     /* 607308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607315 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 607327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 607334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607347 */     GIR_RootConstrainSelectedInstOperands,
     /* 607348 */     // GIR_Coverage, 11919,
     /* 607348 */     GIR_EraseRootFromParent_Done,
     /* 607349 */   // Label 7712: @607349
     /* 607349 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(607447), // Rule ID 11920 //
     /* 607354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 607357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607401 */     // MIs[3] src1
     /* 607401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607406 */     // MIs[3] src0
     /* 607406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607413 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 607416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 607425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 607432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607445 */     GIR_RootConstrainSelectedInstOperands,
     /* 607446 */     // GIR_Coverage, 11920,
     /* 607446 */     GIR_EraseRootFromParent_Done,
     /* 607447 */   // Label 7713: @607447
     /* 607447 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(607545), // Rule ID 13468 //
     /* 607452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607499 */     // MIs[3] src1
     /* 607499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607504 */     // MIs[3] src0
     /* 607504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607511 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 607523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 607530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607543 */     GIR_RootConstrainSelectedInstOperands,
     /* 607544 */     // GIR_Coverage, 13468,
     /* 607544 */     GIR_EraseRootFromParent_Done,
     /* 607545 */   // Label 7714: @607545
     /* 607545 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(607643), // Rule ID 13471 //
     /* 607550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607597 */     // MIs[3] src0
     /* 607597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607602 */     // MIs[3] src1
     /* 607602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607609 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 607621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 607628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607641 */     GIR_RootConstrainSelectedInstOperands,
     /* 607642 */     // GIR_Coverage, 13471,
     /* 607642 */     GIR_EraseRootFromParent_Done,
     /* 607643 */   // Label 7715: @607643
     /* 607643 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(607741), // Rule ID 13472 //
     /* 607648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 607651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 607655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607695 */     // MIs[3] src1
     /* 607695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607700 */     // MIs[3] src0
     /* 607700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607707 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 607710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 607719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 607726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607739 */     GIR_RootConstrainSelectedInstOperands,
     /* 607740 */     // GIR_Coverage, 13472,
     /* 607740 */     GIR_EraseRootFromParent_Done,
     /* 607741 */   // Label 7716: @607741
     /* 607741 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(607839), // Rule ID 13528 //
     /* 607746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607793 */     // MIs[3] src1
     /* 607793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607798 */     // MIs[3] src0
     /* 607798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607805 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 607817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 607824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607837 */     GIR_RootConstrainSelectedInstOperands,
     /* 607838 */     // GIR_Coverage, 13528,
     /* 607838 */     GIR_EraseRootFromParent_Done,
     /* 607839 */   // Label 7717: @607839
     /* 607839 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(607937), // Rule ID 13531 //
     /* 607844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607891 */     // MIs[3] src0
     /* 607891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607896 */     // MIs[3] src1
     /* 607896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 607903 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 607903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 607906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 607908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 607915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 607922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 607929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 607935 */     GIR_RootConstrainSelectedInstOperands,
     /* 607936 */     // GIR_Coverage, 13531,
     /* 607936 */     GIR_EraseRootFromParent_Done,
     /* 607937 */   // Label 7718: @607937
     /* 607937 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(608035), // Rule ID 13532 //
     /* 607942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 607945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 607949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 607953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 607961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 607965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 607969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 607973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 607977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 607981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 607985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 607989 */     // MIs[3] src1
     /* 607989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 607994 */     // MIs[3] src0
     /* 607994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 607999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608001 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 608013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 608020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 608027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608033 */     GIR_RootConstrainSelectedInstOperands,
     /* 608034 */     // GIR_Coverage, 13532,
     /* 608034 */     GIR_EraseRootFromParent_Done,
     /* 608035 */   // Label 7719: @608035
     /* 608035 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(608133), // Rule ID 11917 //
     /* 608040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608087 */     // MIs[3] src0
     /* 608087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608092 */     // MIs[3] src1
     /* 608092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608099 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 608111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 608118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608131 */     GIR_RootConstrainSelectedInstOperands,
     /* 608132 */     // GIR_Coverage, 11917,
     /* 608132 */     GIR_EraseRootFromParent_Done,
     /* 608133 */   // Label 7720: @608133
     /* 608133 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(608231), // Rule ID 11918 //
     /* 608138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608185 */     // MIs[3] src1
     /* 608185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608190 */     // MIs[3] src0
     /* 608190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608197 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 608209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 608216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608229 */     GIR_RootConstrainSelectedInstOperands,
     /* 608230 */     // GIR_Coverage, 11918,
     /* 608230 */     GIR_EraseRootFromParent_Done,
     /* 608231 */   // Label 7721: @608231
     /* 608231 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(608329), // Rule ID 11921 //
     /* 608236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608283 */     // MIs[3] src0
     /* 608283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608288 */     // MIs[3] src1
     /* 608288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608295 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 608307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 608314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608327 */     GIR_RootConstrainSelectedInstOperands,
     /* 608328 */     // GIR_Coverage, 11921,
     /* 608328 */     GIR_EraseRootFromParent_Done,
     /* 608329 */   // Label 7722: @608329
     /* 608329 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(608427), // Rule ID 11922 //
     /* 608334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 608337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608381 */     // MIs[3] src1
     /* 608381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608386 */     // MIs[3] src0
     /* 608386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608393 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 608396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 608405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 608412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608425 */     GIR_RootConstrainSelectedInstOperands,
     /* 608426 */     // GIR_Coverage, 11922,
     /* 608426 */     GIR_EraseRootFromParent_Done,
     /* 608427 */   // Label 7723: @608427
     /* 608427 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(608525), // Rule ID 13469 //
     /* 608432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608479 */     // MIs[3] src0
     /* 608479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608484 */     // MIs[3] src1
     /* 608484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608491 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 608503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 608510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608523 */     GIR_RootConstrainSelectedInstOperands,
     /* 608524 */     // GIR_Coverage, 13469,
     /* 608524 */     GIR_EraseRootFromParent_Done,
     /* 608525 */   // Label 7724: @608525
     /* 608525 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(608623), // Rule ID 13470 //
     /* 608530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608577 */     // MIs[3] src1
     /* 608577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608582 */     // MIs[3] src0
     /* 608582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608589 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 608601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 608608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608621 */     GIR_RootConstrainSelectedInstOperands,
     /* 608622 */     // GIR_Coverage, 13470,
     /* 608622 */     GIR_EraseRootFromParent_Done,
     /* 608623 */   // Label 7725: @608623
     /* 608623 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(608721), // Rule ID 13473 //
     /* 608628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608675 */     // MIs[3] src0
     /* 608675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608680 */     // MIs[3] src1
     /* 608680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608687 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 608699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 608706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608719 */     GIR_RootConstrainSelectedInstOperands,
     /* 608720 */     // GIR_Coverage, 13473,
     /* 608720 */     GIR_EraseRootFromParent_Done,
     /* 608721 */   // Label 7726: @608721
     /* 608721 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(608819), // Rule ID 13474 //
     /* 608726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 608729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 608733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608773 */     // MIs[3] src1
     /* 608773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608778 */     // MIs[3] src0
     /* 608778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608785 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 608788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 608797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 608804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608817 */     GIR_RootConstrainSelectedInstOperands,
     /* 608818 */     // GIR_Coverage, 13474,
     /* 608818 */     GIR_EraseRootFromParent_Done,
     /* 608819 */   // Label 7727: @608819
     /* 608819 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(608917), // Rule ID 13529 //
     /* 608824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608871 */     // MIs[3] src0
     /* 608871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608876 */     // MIs[3] src1
     /* 608876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608883 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 608895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 608902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 608909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608915 */     GIR_RootConstrainSelectedInstOperands,
     /* 608916 */     // GIR_Coverage, 13529,
     /* 608916 */     GIR_EraseRootFromParent_Done,
     /* 608917 */   // Label 7728: @608917
     /* 608917 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(609015), // Rule ID 13530 //
     /* 608922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 608925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 608929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 608933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 608941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 608945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 608949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 608953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 608957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 608961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 608965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 608969 */     // MIs[3] src1
     /* 608969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 608974 */     // MIs[3] src0
     /* 608974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 608979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 608981 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 608981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 608984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 608986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 608993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 608996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 609000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 609007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609013 */     GIR_RootConstrainSelectedInstOperands,
     /* 609014 */     // GIR_Coverage, 13530,
     /* 609014 */     GIR_EraseRootFromParent_Done,
     /* 609015 */   // Label 7729: @609015
     /* 609015 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(609113), // Rule ID 13533 //
     /* 609020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 609063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609067 */     // MIs[3] src0
     /* 609067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609072 */     // MIs[3] src1
     /* 609072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609079 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 609105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609111 */     GIR_RootConstrainSelectedInstOperands,
     /* 609112 */     // GIR_Coverage, 13533,
     /* 609112 */     GIR_EraseRootFromParent_Done,
     /* 609113 */   // Label 7730: @609113
     /* 609113 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(609211), // Rule ID 13534 //
     /* 609118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 609121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 609137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 609141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 609153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 609157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 609161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609165 */     // MIs[3] src1
     /* 609165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 609170 */     // MIs[3] src0
     /* 609170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 609175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609177 */     // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 609177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 609180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 609189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 609196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 609203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609209 */     GIR_RootConstrainSelectedInstOperands,
     /* 609210 */     // GIR_Coverage, 13534,
     /* 609210 */     GIR_EraseRootFromParent_Done,
     /* 609211 */   // Label 7731: @609211
     /* 609211 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(609267), // Rule ID 902 //
     /* 609216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 609219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 609223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 609230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 609237 */     // (smin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 609237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_t16_e64),
     /* 609240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 609247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 609252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 609257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 609262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 609265 */     GIR_RootConstrainSelectedInstOperands,
     /* 609266 */     // GIR_Coverage, 902,
     /* 609266 */     GIR_EraseRootFromParent_Done,
     /* 609267 */   // Label 7732: @609267
     /* 609267 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(609290), // Rule ID 901 //
     /* 609272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 609275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609279 */     // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 609279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
     /* 609284 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 609288 */     GIR_RootConstrainSelectedInstOperands,
     /* 609289 */     // GIR_Coverage, 901,
     /* 609289 */     GIR_Done,
     /* 609290 */   // Label 7733: @609290
     /* 609290 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(609313), // Rule ID 903 //
     /* 609295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 609298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609302 */     // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 609302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_fake16_e64),
     /* 609307 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 609311 */     GIR_RootConstrainSelectedInstOperands,
     /* 609312 */     // GIR_Coverage, 903,
     /* 609312 */     GIR_Done,
     /* 609313 */   // Label 7734: @609313
     /* 609313 */   GIM_Reject,
     /* 609314 */ // Label 7683: @609314
     /* 609314 */ GIM_Reject,
     /* 609315 */ // Label 7680: @609315
     /* 609315 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(610759),
     /* 609320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 609323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 609326 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(609406), // Rule ID 11368 //
     /* 609331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 609355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609375 */     // MIs[3] src0
     /* 609375 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609380 */     // MIs[3] src1
     /* 609380 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609387 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 609396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 609400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 609404 */     GIR_RootConstrainSelectedInstOperands,
     /* 609405 */     // GIR_Coverage, 11368,
     /* 609405 */     GIR_EraseRootFromParent_Done,
     /* 609406 */   // Label 7736: @609406
     /* 609406 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(609486), // Rule ID 11369 //
     /* 609411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 609435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609455 */     // MIs[3] src1
     /* 609455 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609460 */     // MIs[3] src0
     /* 609460 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609467 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 609476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 609480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 609484 */     GIR_RootConstrainSelectedInstOperands,
     /* 609485 */     // GIR_Coverage, 11369,
     /* 609485 */     GIR_EraseRootFromParent_Done,
     /* 609486 */   // Label 7737: @609486
     /* 609486 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(609566), // Rule ID 11370 //
     /* 609491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 609515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609535 */     // MIs[3] src0
     /* 609535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609540 */     // MIs[3] src1
     /* 609540 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609547 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 609556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 609560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 609564 */     GIR_RootConstrainSelectedInstOperands,
     /* 609565 */     // GIR_Coverage, 11370,
     /* 609565 */     GIR_EraseRootFromParent_Done,
     /* 609566 */   // Label 7738: @609566
     /* 609566 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(609646), // Rule ID 11371 //
     /* 609571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 609595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609615 */     // MIs[3] src1
     /* 609615 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609620 */     // MIs[3] src0
     /* 609620 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609627 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 609636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 609640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 609644 */     GIR_RootConstrainSelectedInstOperands,
     /* 609645 */     // GIR_Coverage, 11371,
     /* 609645 */     GIR_EraseRootFromParent_Done,
     /* 609646 */   // Label 7739: @609646
     /* 609646 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(609726), // Rule ID 11372 //
     /* 609651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 609675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609695 */     // MIs[3] src0
     /* 609695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609700 */     // MIs[3] src1
     /* 609700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609707 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 609716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 609720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 609724 */     GIR_RootConstrainSelectedInstOperands,
     /* 609725 */     // GIR_Coverage, 11372,
     /* 609725 */     GIR_EraseRootFromParent_Done,
     /* 609726 */   // Label 7740: @609726
     /* 609726 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(609806), // Rule ID 11373 //
     /* 609731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 609755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609775 */     // MIs[3] src1
     /* 609775 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609780 */     // MIs[3] src0
     /* 609780 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609787 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 609796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 609800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 609804 */     GIR_RootConstrainSelectedInstOperands,
     /* 609805 */     // GIR_Coverage, 11373,
     /* 609805 */     GIR_EraseRootFromParent_Done,
     /* 609806 */   // Label 7741: @609806
     /* 609806 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(609886), // Rule ID 11374 //
     /* 609811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 609835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609855 */     // MIs[3] src0
     /* 609855 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609860 */     // MIs[3] src1
     /* 609860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609867 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 609876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 609880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 609884 */     GIR_RootConstrainSelectedInstOperands,
     /* 609885 */     // GIR_Coverage, 11374,
     /* 609885 */     GIR_EraseRootFromParent_Done,
     /* 609886 */   // Label 7742: @609886
     /* 609886 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(609966), // Rule ID 11375 //
     /* 609891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 609915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 609919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 609923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 609927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 609931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609935 */     // MIs[3] src1
     /* 609935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 609940 */     // MIs[3] src0
     /* 609940 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 609945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 609947 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 609947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 609950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 609952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 609956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 609960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 609964 */     GIR_RootConstrainSelectedInstOperands,
     /* 609965 */     // GIR_Coverage, 11375,
     /* 609965 */     GIR_EraseRootFromParent_Done,
     /* 609966 */   // Label 7743: @609966
     /* 609966 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(610046), // Rule ID 7711 //
     /* 609971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 609975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 609979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 609987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 609991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 609995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 609999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 610011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610015 */     // MIs[3] src0
     /* 610015 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610020 */     // MIs[3] src1
     /* 610020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610027 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 610044 */     GIR_RootConstrainSelectedInstOperands,
     /* 610045 */     // GIR_Coverage, 7711,
     /* 610045 */     GIR_EraseRootFromParent_Done,
     /* 610046 */   // Label 7744: @610046
     /* 610046 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(610126), // Rule ID 11361 //
     /* 610051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 610091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610095 */     // MIs[3] src1
     /* 610095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610100 */     // MIs[3] src0
     /* 610100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610107 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 610124 */     GIR_RootConstrainSelectedInstOperands,
     /* 610125 */     // GIR_Coverage, 11361,
     /* 610125 */     GIR_EraseRootFromParent_Done,
     /* 610126 */   // Label 7745: @610126
     /* 610126 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(610206), // Rule ID 11364 //
     /* 610131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610167 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 610171 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610175 */     // MIs[3] src0
     /* 610175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610180 */     // MIs[3] src1
     /* 610180 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610187 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 610204 */     GIR_RootConstrainSelectedInstOperands,
     /* 610205 */     // GIR_Coverage, 11364,
     /* 610205 */     GIR_EraseRootFromParent_Done,
     /* 610206 */   // Label 7746: @610206
     /* 610206 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(610286), // Rule ID 11365 //
     /* 610211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 610251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610255 */     // MIs[3] src1
     /* 610255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610260 */     // MIs[3] src0
     /* 610260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610267 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 610284 */     GIR_RootConstrainSelectedInstOperands,
     /* 610285 */     // GIR_Coverage, 11365,
     /* 610285 */     GIR_EraseRootFromParent_Done,
     /* 610286 */   // Label 7747: @610286
     /* 610286 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(610366), // Rule ID 11362 //
     /* 610291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610335 */     // MIs[3] src0
     /* 610335 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610340 */     // MIs[3] src1
     /* 610340 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610345 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610347 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610364 */     GIR_RootConstrainSelectedInstOperands,
     /* 610365 */     // GIR_Coverage, 11362,
     /* 610365 */     GIR_EraseRootFromParent_Done,
     /* 610366 */   // Label 7748: @610366
     /* 610366 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(610446), // Rule ID 11363 //
     /* 610371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610415 */     // MIs[3] src1
     /* 610415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610420 */     // MIs[3] src0
     /* 610420 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610427 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610444 */     GIR_RootConstrainSelectedInstOperands,
     /* 610445 */     // GIR_Coverage, 11363,
     /* 610445 */     GIR_EraseRootFromParent_Done,
     /* 610446 */   // Label 7749: @610446
     /* 610446 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(610526), // Rule ID 11366 //
     /* 610451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610495 */     // MIs[3] src0
     /* 610495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610500 */     // MIs[3] src1
     /* 610500 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610507 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610524 */     GIR_RootConstrainSelectedInstOperands,
     /* 610525 */     // GIR_Coverage, 11366,
     /* 610525 */     GIR_EraseRootFromParent_Done,
     /* 610526 */   // Label 7750: @610526
     /* 610526 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(610606), // Rule ID 11367 //
     /* 610531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 610555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 610563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 610567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 610571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610575 */     // MIs[3] src1
     /* 610575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 610580 */     // MIs[3] src0
     /* 610580 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 610585 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610587 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 610590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 610596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 610600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 610604 */     GIR_RootConstrainSelectedInstOperands,
     /* 610605 */     // GIR_Coverage, 11367,
     /* 610605 */     GIR_EraseRootFromParent_Done,
     /* 610606 */   // Label 7751: @610606
     /* 610606 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(610659), // Rule ID 7845 //
     /* 610611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 610614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610634 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 610636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35118),
     /* 610640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 610642 */     // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35118>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
     /* 610645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 610657 */     GIR_RootConstrainSelectedInstOperands,
     /* 610658 */     // GIR_Coverage, 7845,
     /* 610658 */     GIR_EraseRootFromParent_Done,
     /* 610659 */   // Label 7752: @610659
     /* 610659 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(610712), // Rule ID 13371 //
     /* 610664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 610667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 610675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 610683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 610687 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 610689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35118),
     /* 610693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 610695 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>)<<P:Predicate_anonymous_35118>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 610695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
     /* 610698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 610704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 610708 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 610710 */     GIR_RootConstrainSelectedInstOperands,
     /* 610711 */     // GIR_Coverage, 13371,
     /* 610711 */     GIR_EraseRootFromParent_Done,
     /* 610712 */   // Label 7753: @610712
     /* 610712 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(610738), // Rule ID 47 //
     /* 610717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 610721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13726),
     /* 610725 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13726>>  =>  (S_MIN_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 610725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_I32),
     /* 610730 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 610736 */     GIR_RootConstrainSelectedInstOperands,
     /* 610737 */     // GIR_Coverage, 47,
     /* 610737 */     GIR_Done,
     /* 610738 */   // Label 7754: @610738
     /* 610738 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(610758), // Rule ID 805 //
     /* 610743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610747 */     // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 610747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I32_e64),
     /* 610752 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 610756 */     GIR_RootConstrainSelectedInstOperands,
     /* 610757 */     // GIR_Coverage, 805,
     /* 610757 */     GIR_Done,
     /* 610758 */   // Label 7755: @610758
     /* 610758 */   GIM_Reject,
     /* 610759 */ // Label 7735: @610759
     /* 610759 */ GIM_Reject,
     /* 610760 */ // Label 7681: @610760
     /* 610760 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(610831), // Rule ID 1101 //
     /* 610765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 610768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 610771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610775 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 610782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 610789 */   // (smin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 610789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_I16),
     /* 610792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 610799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 610804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 610809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 610814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610829 */   GIR_RootConstrainSelectedInstOperands,
     /* 610830 */   // GIR_Coverage, 1101,
     /* 610830 */   GIR_EraseRootFromParent_Done,
     /* 610831 */ // Label 7756: @610831
     /* 610831 */ GIM_Reject,
     /* 610832 */ // Label 7682: @610832
     /* 610832 */ GIM_Reject,
     /* 610833 */ // Label 89: @610833
     /* 610833 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7760*/ GIMT_Encode4(617358),
     /* 610844 */ /*GILLT_s16*//*Label 7757*/ GIMT_Encode4(610860),
     /* 610848 */ /*GILLT_s32*//*Label 7758*/ GIMT_Encode4(615679), GIMT_Encode4(0),
     /* 610856 */ /*GILLT_v2s16*//*Label 7759*/ GIMT_Encode4(617286),
     /* 610860 */ // Label 7757: @610860
     /* 610860 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(615678),
     /* 610865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 610868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 610871 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(610969), // Rule ID 11908 //
     /* 610876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 610903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 610907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 610911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 610915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 610919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610923 */     // MIs[3] src0
     /* 610923 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 610928 */     // MIs[3] src1
     /* 610928 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 610933 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 610935 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 610935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 610938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 610940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 610947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 610954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 610961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 610967 */     GIR_RootConstrainSelectedInstOperands,
     /* 610968 */     // GIR_Coverage, 11908,
     /* 610968 */     GIR_EraseRootFromParent_Done,
     /* 610969 */   // Label 7762: @610969
     /* 610969 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(611067), // Rule ID 11909 //
     /* 610974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 610977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 610981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 610985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 610989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 610993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 610997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611021 */     // MIs[3] src1
     /* 611021 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611026 */     // MIs[3] src0
     /* 611026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611033 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 611036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611065 */     GIR_RootConstrainSelectedInstOperands,
     /* 611066 */     // GIR_Coverage, 11909,
     /* 611066 */     GIR_EraseRootFromParent_Done,
     /* 611067 */   // Label 7763: @611067
     /* 611067 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(611165), // Rule ID 11910 //
     /* 611072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 611075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611119 */     // MIs[3] src0
     /* 611119 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611124 */     // MIs[3] src1
     /* 611124 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611131 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 611134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611163 */     GIR_RootConstrainSelectedInstOperands,
     /* 611164 */     // GIR_Coverage, 11910,
     /* 611164 */     GIR_EraseRootFromParent_Done,
     /* 611165 */   // Label 7764: @611165
     /* 611165 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(611263), // Rule ID 11911 //
     /* 611170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 611173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611217 */     // MIs[3] src1
     /* 611217 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611222 */     // MIs[3] src0
     /* 611222 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611229 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 611232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611261 */     GIR_RootConstrainSelectedInstOperands,
     /* 611262 */     // GIR_Coverage, 11911,
     /* 611262 */     GIR_EraseRootFromParent_Done,
     /* 611263 */   // Label 7765: @611263
     /* 611263 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(611361), // Rule ID 13460 //
     /* 611268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 611271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 611275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611315 */     // MIs[3] src0
     /* 611315 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611320 */     // MIs[3] src1
     /* 611320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611327 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 611330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611359 */     GIR_RootConstrainSelectedInstOperands,
     /* 611360 */     // GIR_Coverage, 13460,
     /* 611360 */     GIR_EraseRootFromParent_Done,
     /* 611361 */   // Label 7766: @611361
     /* 611361 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(611459), // Rule ID 13461 //
     /* 611366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 611369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 611373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611413 */     // MIs[3] src1
     /* 611413 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611418 */     // MIs[3] src0
     /* 611418 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611425 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 611428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611457 */     GIR_RootConstrainSelectedInstOperands,
     /* 611458 */     // GIR_Coverage, 13461,
     /* 611458 */     GIR_EraseRootFromParent_Done,
     /* 611459 */   // Label 7767: @611459
     /* 611459 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(611557), // Rule ID 13462 //
     /* 611464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 611467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 611471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611511 */     // MIs[3] src0
     /* 611511 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611516 */     // MIs[3] src1
     /* 611516 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611523 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 611526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611555 */     GIR_RootConstrainSelectedInstOperands,
     /* 611556 */     // GIR_Coverage, 13462,
     /* 611556 */     GIR_EraseRootFromParent_Done,
     /* 611557 */   // Label 7768: @611557
     /* 611557 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(611655), // Rule ID 13463 //
     /* 611562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 611565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 611569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611609 */     // MIs[3] src1
     /* 611609 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611614 */     // MIs[3] src0
     /* 611614 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611621 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 611624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611653 */     GIR_RootConstrainSelectedInstOperands,
     /* 611654 */     // GIR_Coverage, 13463,
     /* 611654 */     GIR_EraseRootFromParent_Done,
     /* 611655 */   // Label 7769: @611655
     /* 611655 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(611753), // Rule ID 13520 //
     /* 611660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611707 */     // MIs[3] src0
     /* 611707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611712 */     // MIs[3] src1
     /* 611712 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611719 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611751 */     GIR_RootConstrainSelectedInstOperands,
     /* 611752 */     // GIR_Coverage, 13520,
     /* 611752 */     GIR_EraseRootFromParent_Done,
     /* 611753 */   // Label 7770: @611753
     /* 611753 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(611851), // Rule ID 13521 //
     /* 611758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611805 */     // MIs[3] src1
     /* 611805 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611810 */     // MIs[3] src0
     /* 611810 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611817 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 611829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 611836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611849 */     GIR_RootConstrainSelectedInstOperands,
     /* 611850 */     // GIR_Coverage, 13521,
     /* 611850 */     GIR_EraseRootFromParent_Done,
     /* 611851 */   // Label 7771: @611851
     /* 611851 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(611949), // Rule ID 13522 //
     /* 611856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611903 */     // MIs[3] src0
     /* 611903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 611908 */     // MIs[3] src1
     /* 611908 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 611913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 611915 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 611915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 611918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 611920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 611927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 611934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 611941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 611947 */     GIR_RootConstrainSelectedInstOperands,
     /* 611948 */     // GIR_Coverage, 13522,
     /* 611948 */     GIR_EraseRootFromParent_Done,
     /* 611949 */   // Label 7772: @611949
     /* 611949 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(612047), // Rule ID 13523 //
     /* 611954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 611957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 611961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 611965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 611969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 611973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 611977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 611981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 611985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 611989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 611993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 611997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612001 */     // MIs[3] src1
     /* 612001 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612006 */     // MIs[3] src0
     /* 612006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612013 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 612016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 612025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 612032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 612039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612045 */     GIR_RootConstrainSelectedInstOperands,
     /* 612046 */     // GIR_Coverage, 13523,
     /* 612046 */     GIR_EraseRootFromParent_Done,
     /* 612047 */   // Label 7773: @612047
     /* 612047 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(612145), // Rule ID 11912 //
     /* 612052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 612055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612099 */     // MIs[3] src0
     /* 612099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612104 */     // MIs[3] src1
     /* 612104 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612111 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 612114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 612123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 612130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612143 */     GIR_RootConstrainSelectedInstOperands,
     /* 612144 */     // GIR_Coverage, 11912,
     /* 612144 */     GIR_EraseRootFromParent_Done,
     /* 612145 */   // Label 7774: @612145
     /* 612145 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(612243), // Rule ID 11913 //
     /* 612150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 612153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612197 */     // MIs[3] src1
     /* 612197 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612202 */     // MIs[3] src0
     /* 612202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612209 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 612212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 612221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 612228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612241 */     GIR_RootConstrainSelectedInstOperands,
     /* 612242 */     // GIR_Coverage, 11913,
     /* 612242 */     GIR_EraseRootFromParent_Done,
     /* 612243 */   // Label 7775: @612243
     /* 612243 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(612341), // Rule ID 11914 //
     /* 612248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 612251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612295 */     // MIs[3] src0
     /* 612295 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612300 */     // MIs[3] src1
     /* 612300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612307 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 612310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 612319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 612326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612339 */     GIR_RootConstrainSelectedInstOperands,
     /* 612340 */     // GIR_Coverage, 11914,
     /* 612340 */     GIR_EraseRootFromParent_Done,
     /* 612341 */   // Label 7776: @612341
     /* 612341 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(612439), // Rule ID 11915 //
     /* 612346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 612349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612393 */     // MIs[3] src1
     /* 612393 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612398 */     // MIs[3] src0
     /* 612398 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612405 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 612408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 612417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 612424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612437 */     GIR_RootConstrainSelectedInstOperands,
     /* 612438 */     // GIR_Coverage, 11915,
     /* 612438 */     GIR_EraseRootFromParent_Done,
     /* 612439 */   // Label 7777: @612439
     /* 612439 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(612537), // Rule ID 13464 //
     /* 612444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 612447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 612451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612491 */     // MIs[3] src0
     /* 612491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612496 */     // MIs[3] src1
     /* 612496 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612503 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 612506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 612515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 612522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612535 */     GIR_RootConstrainSelectedInstOperands,
     /* 612536 */     // GIR_Coverage, 13464,
     /* 612536 */     GIR_EraseRootFromParent_Done,
     /* 612537 */   // Label 7778: @612537
     /* 612537 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(612635), // Rule ID 13465 //
     /* 612542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 612545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 612549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612589 */     // MIs[3] src1
     /* 612589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612594 */     // MIs[3] src0
     /* 612594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612601 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 612604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 612613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 612620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612633 */     GIR_RootConstrainSelectedInstOperands,
     /* 612634 */     // GIR_Coverage, 13465,
     /* 612634 */     GIR_EraseRootFromParent_Done,
     /* 612635 */   // Label 7779: @612635
     /* 612635 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(612733), // Rule ID 13466 //
     /* 612640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 612643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 612647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612687 */     // MIs[3] src0
     /* 612687 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612692 */     // MIs[3] src1
     /* 612692 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612699 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 612702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 612711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 612718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612731 */     GIR_RootConstrainSelectedInstOperands,
     /* 612732 */     // GIR_Coverage, 13466,
     /* 612732 */     GIR_EraseRootFromParent_Done,
     /* 612733 */   // Label 7780: @612733
     /* 612733 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(612831), // Rule ID 13467 //
     /* 612738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 612741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 612745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612785 */     // MIs[3] src1
     /* 612785 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612790 */     // MIs[3] src0
     /* 612790 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612797 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 612800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 612809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 612816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612829 */     GIR_RootConstrainSelectedInstOperands,
     /* 612830 */     // GIR_Coverage, 13467,
     /* 612830 */     GIR_EraseRootFromParent_Done,
     /* 612831 */   // Label 7781: @612831
     /* 612831 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(612929), // Rule ID 13524 //
     /* 612836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 612839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612883 */     // MIs[3] src0
     /* 612883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612888 */     // MIs[3] src1
     /* 612888 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612895 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 612898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 612907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 612914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 612921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 612927 */     GIR_RootConstrainSelectedInstOperands,
     /* 612928 */     // GIR_Coverage, 13524,
     /* 612928 */     GIR_EraseRootFromParent_Done,
     /* 612929 */   // Label 7782: @612929
     /* 612929 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(613027), // Rule ID 13525 //
     /* 612934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 612937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 612941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 612945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 612953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 612957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 612961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 612965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 612969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 612973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 612977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 612981 */     // MIs[3] src1
     /* 612981 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 612986 */     // MIs[3] src0
     /* 612986 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 612991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 612993 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 612993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 612996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 612998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 613005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 613012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 613019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613025 */     GIR_RootConstrainSelectedInstOperands,
     /* 613026 */     // GIR_Coverage, 13525,
     /* 613026 */     GIR_EraseRootFromParent_Done,
     /* 613027 */   // Label 7783: @613027
     /* 613027 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(613125), // Rule ID 13526 //
     /* 613032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 613035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 613059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613079 */     // MIs[3] src0
     /* 613079 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613084 */     // MIs[3] src1
     /* 613084 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613091 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 613094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 613117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613123 */     GIR_RootConstrainSelectedInstOperands,
     /* 613124 */     // GIR_Coverage, 13526,
     /* 613124 */     GIR_EraseRootFromParent_Done,
     /* 613125 */   // Label 7784: @613125
     /* 613125 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(613223), // Rule ID 13527 //
     /* 613130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 613133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 613157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 613173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613177 */     // MIs[3] src1
     /* 613177 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 613182 */     // MIs[3] src0
     /* 613182 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 613187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613189 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 613192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 613201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 613208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 613215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613221 */     GIR_RootConstrainSelectedInstOperands,
     /* 613222 */     // GIR_Coverage, 13527,
     /* 613222 */     GIR_EraseRootFromParent_Done,
     /* 613223 */   // Label 7785: @613223
     /* 613223 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(613321), // Rule ID 7747 //
     /* 613228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613275 */     // MIs[3] src0
     /* 613275 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613280 */     // MIs[3] src1
     /* 613280 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613287 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 613290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 613299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 613306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613319 */     GIR_RootConstrainSelectedInstOperands,
     /* 613320 */     // GIR_Coverage, 7747,
     /* 613320 */     GIR_EraseRootFromParent_Done,
     /* 613321 */   // Label 7786: @613321
     /* 613321 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(613419), // Rule ID 7899 //
     /* 613326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613373 */     // MIs[3] src0
     /* 613373 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613378 */     // MIs[3] src1
     /* 613378 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613385 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 613388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 613397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 613404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613417 */     GIR_RootConstrainSelectedInstOperands,
     /* 613418 */     // GIR_Coverage, 7899,
     /* 613418 */     GIR_EraseRootFromParent_Done,
     /* 613419 */   // Label 7787: @613419
     /* 613419 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(613517), // Rule ID 7903 //
     /* 613424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 613427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613471 */     // MIs[3] src0
     /* 613471 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613476 */     // MIs[3] src1
     /* 613476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613483 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 613486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 613495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 613502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613515 */     GIR_RootConstrainSelectedInstOperands,
     /* 613516 */     // GIR_Coverage, 7903,
     /* 613516 */     GIR_EraseRootFromParent_Done,
     /* 613517 */   // Label 7788: @613517
     /* 613517 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(613615), // Rule ID 11901 //
     /* 613522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613569 */     // MIs[3] src1
     /* 613569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613574 */     // MIs[3] src0
     /* 613574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613581 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 613584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 613593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 613600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613613 */     GIR_RootConstrainSelectedInstOperands,
     /* 613614 */     // GIR_Coverage, 11901,
     /* 613614 */     GIR_EraseRootFromParent_Done,
     /* 613615 */   // Label 7789: @613615
     /* 613615 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(613713), // Rule ID 11904 //
     /* 613620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613667 */     // MIs[3] src0
     /* 613667 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613672 */     // MIs[3] src1
     /* 613672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613679 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 613682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 613691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 613698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613711 */     GIR_RootConstrainSelectedInstOperands,
     /* 613712 */     // GIR_Coverage, 11904,
     /* 613712 */     GIR_EraseRootFromParent_Done,
     /* 613713 */   // Label 7790: @613713
     /* 613713 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(613811), // Rule ID 11905 //
     /* 613718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 613721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 613725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613765 */     // MIs[3] src1
     /* 613765 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613770 */     // MIs[3] src0
     /* 613770 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613775 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613777 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 613780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 613789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 613796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613809 */     GIR_RootConstrainSelectedInstOperands,
     /* 613810 */     // GIR_Coverage, 11905,
     /* 613810 */     GIR_EraseRootFromParent_Done,
     /* 613811 */   // Label 7791: @613811
     /* 613811 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(613909), // Rule ID 13453 //
     /* 613816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613863 */     // MIs[3] src1
     /* 613863 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613868 */     // MIs[3] src0
     /* 613868 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613875 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 613878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 613887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 613894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613907 */     GIR_RootConstrainSelectedInstOperands,
     /* 613908 */     // GIR_Coverage, 13453,
     /* 613908 */     GIR_EraseRootFromParent_Done,
     /* 613909 */   // Label 7792: @613909
     /* 613909 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(614007), // Rule ID 13456 //
     /* 613914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 613917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 613921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 613925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 613933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 613937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 613941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 613945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 613949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 613953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 613957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 613961 */     // MIs[3] src0
     /* 613961 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 613966 */     // MIs[3] src1
     /* 613966 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 613971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 613973 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 613973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 613976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 613978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 613985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 613992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 613995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 613999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614005 */     GIR_RootConstrainSelectedInstOperands,
     /* 614006 */     // GIR_Coverage, 13456,
     /* 614006 */     GIR_EraseRootFromParent_Done,
     /* 614007 */   // Label 7793: @614007
     /* 614007 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(614105), // Rule ID 13457 //
     /* 614012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 614055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614059 */     // MIs[3] src1
     /* 614059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614064 */     // MIs[3] src0
     /* 614064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614071 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 614074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 614083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 614090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 614097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614103 */     GIR_RootConstrainSelectedInstOperands,
     /* 614104 */     // GIR_Coverage, 13457,
     /* 614104 */     GIR_EraseRootFromParent_Done,
     /* 614105 */   // Label 7794: @614105
     /* 614105 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(614203), // Rule ID 13513 //
     /* 614110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 614153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614157 */     // MIs[3] src1
     /* 614157 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614162 */     // MIs[3] src0
     /* 614162 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614167 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614169 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 614172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 614181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 614188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 614195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614201 */     GIR_RootConstrainSelectedInstOperands,
     /* 614202 */     // GIR_Coverage, 13513,
     /* 614202 */     GIR_EraseRootFromParent_Done,
     /* 614203 */   // Label 7795: @614203
     /* 614203 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(614301), // Rule ID 13516 //
     /* 614208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 614251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614255 */     // MIs[3] src0
     /* 614255 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614260 */     // MIs[3] src1
     /* 614260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614267 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 614270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 614279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 614286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 614293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614299 */     GIR_RootConstrainSelectedInstOperands,
     /* 614300 */     // GIR_Coverage, 13516,
     /* 614300 */     GIR_EraseRootFromParent_Done,
     /* 614301 */   // Label 7796: @614301
     /* 614301 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(614399), // Rule ID 13517 //
     /* 614306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 614309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 614349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614353 */     // MIs[3] src1
     /* 614353 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614358 */     // MIs[3] src0
     /* 614358 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614365 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 614368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 614377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 614384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 614391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614397 */     GIR_RootConstrainSelectedInstOperands,
     /* 614398 */     // GIR_Coverage, 13517,
     /* 614398 */     GIR_EraseRootFromParent_Done,
     /* 614399 */   // Label 7797: @614399
     /* 614399 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(614497), // Rule ID 11902 //
     /* 614404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 614447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614451 */     // MIs[3] src0
     /* 614451 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614456 */     // MIs[3] src1
     /* 614456 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614463 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 614466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 614475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 614482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 614489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614495 */     GIR_RootConstrainSelectedInstOperands,
     /* 614496 */     // GIR_Coverage, 11902,
     /* 614496 */     GIR_EraseRootFromParent_Done,
     /* 614497 */   // Label 7798: @614497
     /* 614497 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(614595), // Rule ID 11903 //
     /* 614502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 614545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614549 */     // MIs[3] src1
     /* 614549 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614554 */     // MIs[3] src0
     /* 614554 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614561 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 614564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 614573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 614580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 614587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614593 */     GIR_RootConstrainSelectedInstOperands,
     /* 614594 */     // GIR_Coverage, 11903,
     /* 614594 */     GIR_EraseRootFromParent_Done,
     /* 614595 */   // Label 7799: @614595
     /* 614595 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(614693), // Rule ID 11906 //
     /* 614600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 614643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614647 */     // MIs[3] src0
     /* 614647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614652 */     // MIs[3] src1
     /* 614652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614659 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 614662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 614671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 614678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 614685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614691 */     GIR_RootConstrainSelectedInstOperands,
     /* 614692 */     // GIR_Coverage, 11906,
     /* 614692 */     GIR_EraseRootFromParent_Done,
     /* 614693 */   // Label 7800: @614693
     /* 614693 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(614791), // Rule ID 11907 //
     /* 614698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 614701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 614705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 614741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614745 */     // MIs[3] src1
     /* 614745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614750 */     // MIs[3] src0
     /* 614750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614757 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 614760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 614769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 614776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 614783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614789 */     GIR_RootConstrainSelectedInstOperands,
     /* 614790 */     // GIR_Coverage, 11907,
     /* 614790 */     GIR_EraseRootFromParent_Done,
     /* 614791 */   // Label 7801: @614791
     /* 614791 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(614889), // Rule ID 13454 //
     /* 614796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 614839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614843 */     // MIs[3] src0
     /* 614843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614848 */     // MIs[3] src1
     /* 614848 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614855 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 614858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 614867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 614874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 614881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614887 */     GIR_RootConstrainSelectedInstOperands,
     /* 614888 */     // GIR_Coverage, 13454,
     /* 614888 */     GIR_EraseRootFromParent_Done,
     /* 614889 */   // Label 7802: @614889
     /* 614889 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(614987), // Rule ID 13455 //
     /* 614894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 614905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 614913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 614917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 614921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 614925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 614929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 614933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 614937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 614941 */     // MIs[3] src1
     /* 614941 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 614946 */     // MIs[3] src0
     /* 614946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 614951 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 614953 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 614953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 614956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 614958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 614965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 614972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 614979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 614985 */     GIR_RootConstrainSelectedInstOperands,
     /* 614986 */     // GIR_Coverage, 13455,
     /* 614986 */     GIR_EraseRootFromParent_Done,
     /* 614987 */   // Label 7803: @614987
     /* 614987 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(615085), // Rule ID 13458 //
     /* 614992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 614995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 614999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 615035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615039 */     // MIs[3] src0
     /* 615039 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615044 */     // MIs[3] src1
     /* 615044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615051 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 615054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 615063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 615070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 615077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615083 */     GIR_RootConstrainSelectedInstOperands,
     /* 615084 */     // GIR_Coverage, 13458,
     /* 615084 */     GIR_EraseRootFromParent_Done,
     /* 615085 */   // Label 7804: @615085
     /* 615085 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(615183), // Rule ID 13459 //
     /* 615090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 615093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 615097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 615133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615137 */     // MIs[3] src1
     /* 615137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615142 */     // MIs[3] src0
     /* 615142 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615149 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 615152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 615161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 615168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 615175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615181 */     GIR_RootConstrainSelectedInstOperands,
     /* 615182 */     // GIR_Coverage, 13459,
     /* 615182 */     GIR_EraseRootFromParent_Done,
     /* 615183 */   // Label 7805: @615183
     /* 615183 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(615281), // Rule ID 13514 //
     /* 615188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 615231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615235 */     // MIs[3] src0
     /* 615235 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615240 */     // MIs[3] src1
     /* 615240 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615247 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 615250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 615273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615279 */     GIR_RootConstrainSelectedInstOperands,
     /* 615280 */     // GIR_Coverage, 13514,
     /* 615280 */     GIR_EraseRootFromParent_Done,
     /* 615281 */   // Label 7806: @615281
     /* 615281 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(615379), // Rule ID 13515 //
     /* 615286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 615329 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615333 */     // MIs[3] src1
     /* 615333 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615338 */     // MIs[3] src0
     /* 615338 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615345 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 615348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 615357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 615364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 615371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615377 */     GIR_RootConstrainSelectedInstOperands,
     /* 615378 */     // GIR_Coverage, 13515,
     /* 615378 */     GIR_EraseRootFromParent_Done,
     /* 615379 */   // Label 7807: @615379
     /* 615379 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(615477), // Rule ID 13518 //
     /* 615384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 615427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615431 */     // MIs[3] src0
     /* 615431 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615436 */     // MIs[3] src1
     /* 615436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615441 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615443 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 615446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 615455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 615462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 615469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615475 */     GIR_RootConstrainSelectedInstOperands,
     /* 615476 */     // GIR_Coverage, 13518,
     /* 615476 */     GIR_EraseRootFromParent_Done,
     /* 615477 */   // Label 7808: @615477
     /* 615477 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(615575), // Rule ID 13519 //
     /* 615482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 615485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 615501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 615505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 615509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 615517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 615521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 615525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615529 */     // MIs[3] src1
     /* 615529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 615534 */     // MIs[3] src0
     /* 615534 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 615539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615541 */     // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 615541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 615544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 615553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 615560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 615567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615573 */     GIR_RootConstrainSelectedInstOperands,
     /* 615574 */     // GIR_Coverage, 13519,
     /* 615574 */     GIR_EraseRootFromParent_Done,
     /* 615575 */   // Label 7809: @615575
     /* 615575 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(615631), // Rule ID 896 //
     /* 615580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 615583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 615587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 615594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 615601 */     // (smax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 615601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_t16_e64),
     /* 615604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 615611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 615616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 615621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 615626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 615629 */     GIR_RootConstrainSelectedInstOperands,
     /* 615630 */     // GIR_Coverage, 896,
     /* 615630 */     GIR_EraseRootFromParent_Done,
     /* 615631 */   // Label 7810: @615631
     /* 615631 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(615654), // Rule ID 895 //
     /* 615636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 615639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615643 */     // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 615643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
     /* 615648 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 615652 */     GIR_RootConstrainSelectedInstOperands,
     /* 615653 */     // GIR_Coverage, 895,
     /* 615653 */     GIR_Done,
     /* 615654 */   // Label 7811: @615654
     /* 615654 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(615677), // Rule ID 897 //
     /* 615659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 615662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615666 */     // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 615666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_fake16_e64),
     /* 615671 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 615675 */     GIR_RootConstrainSelectedInstOperands,
     /* 615676 */     // GIR_Coverage, 897,
     /* 615676 */     GIR_Done,
     /* 615677 */   // Label 7812: @615677
     /* 615677 */   GIM_Reject,
     /* 615678 */ // Label 7761: @615678
     /* 615678 */ GIM_Reject,
     /* 615679 */ // Label 7758: @615679
     /* 615679 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(617285),
     /* 615684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 615687 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(615770), // Rule ID 11383 //
     /* 615692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 615695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 615711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 615715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 615719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 615727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 615731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615739 */     // MIs[3] src0
     /* 615739 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615744 */     // MIs[3] src1
     /* 615744 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615751 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 615751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 615754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 615760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 615764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 615768 */     GIR_RootConstrainSelectedInstOperands,
     /* 615769 */     // GIR_Coverage, 11383,
     /* 615769 */     GIR_EraseRootFromParent_Done,
     /* 615770 */   // Label 7814: @615770
     /* 615770 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(615853), // Rule ID 11384 //
     /* 615775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 615778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 615794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 615798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 615802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 615810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 615814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615822 */     // MIs[3] src1
     /* 615822 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615827 */     // MIs[3] src0
     /* 615827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615834 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 615834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 615837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 615843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 615847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 615851 */     GIR_RootConstrainSelectedInstOperands,
     /* 615852 */     // GIR_Coverage, 11384,
     /* 615852 */     GIR_EraseRootFromParent_Done,
     /* 615853 */   // Label 7815: @615853
     /* 615853 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(615936), // Rule ID 11385 //
     /* 615858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 615861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 615877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 615881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 615885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 615893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 615897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615905 */     // MIs[3] src0
     /* 615905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615910 */     // MIs[3] src1
     /* 615910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 615917 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 615917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 615920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 615922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 615926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 615930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 615934 */     GIR_RootConstrainSelectedInstOperands,
     /* 615935 */     // GIR_Coverage, 11385,
     /* 615935 */     GIR_EraseRootFromParent_Done,
     /* 615936 */   // Label 7816: @615936
     /* 615936 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(616019), // Rule ID 11386 //
     /* 615941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 615944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 615948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 615952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 615960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 615964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 615968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 615972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 615976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 615980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 615984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 615988 */     // MIs[3] src1
     /* 615988 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 615993 */     // MIs[3] src0
     /* 615993 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 615998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616000 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 616009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 616013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 616017 */     GIR_RootConstrainSelectedInstOperands,
     /* 616018 */     // GIR_Coverage, 11386,
     /* 616018 */     GIR_EraseRootFromParent_Done,
     /* 616019 */   // Label 7817: @616019
     /* 616019 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(616102), // Rule ID 11387 //
     /* 616024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 616051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 616067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616071 */     // MIs[3] src0
     /* 616071 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 616076 */     // MIs[3] src1
     /* 616076 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 616081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616083 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 616092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 616096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 616100 */     GIR_RootConstrainSelectedInstOperands,
     /* 616101 */     // GIR_Coverage, 11387,
     /* 616101 */     GIR_EraseRootFromParent_Done,
     /* 616102 */   // Label 7818: @616102
     /* 616102 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(616185), // Rule ID 11388 //
     /* 616107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 616134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 616150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616154 */     // MIs[3] src1
     /* 616154 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 616159 */     // MIs[3] src0
     /* 616159 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 616164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616166 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 616175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 616179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 616183 */     GIR_RootConstrainSelectedInstOperands,
     /* 616184 */     // GIR_Coverage, 11388,
     /* 616184 */     GIR_EraseRootFromParent_Done,
     /* 616185 */   // Label 7819: @616185
     /* 616185 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(616268), // Rule ID 11389 //
     /* 616190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 616217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 616233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616237 */     // MIs[3] src0
     /* 616237 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 616242 */     // MIs[3] src1
     /* 616242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 616247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616249 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 616258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 616262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 616266 */     GIR_RootConstrainSelectedInstOperands,
     /* 616267 */     // GIR_Coverage, 11389,
     /* 616267 */     GIR_EraseRootFromParent_Done,
     /* 616268 */   // Label 7820: @616268
     /* 616268 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(616351), // Rule ID 11390 //
     /* 616273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 616300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616308 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 616316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616320 */     // MIs[3] src1
     /* 616320 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 616325 */     // MIs[3] src0
     /* 616325 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 616330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616332 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 616341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 616345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 616349 */     GIR_RootConstrainSelectedInstOperands,
     /* 616350 */     // GIR_Coverage, 11390,
     /* 616350 */     GIR_EraseRootFromParent_Done,
     /* 616351 */   // Label 7821: @616351
     /* 616351 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(616434), // Rule ID 7712 //
     /* 616356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616403 */     // MIs[3] src0
     /* 616403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616408 */     // MIs[3] src1
     /* 616408 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616415 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616432 */     GIR_RootConstrainSelectedInstOperands,
     /* 616433 */     // GIR_Coverage, 7712,
     /* 616433 */     GIR_EraseRootFromParent_Done,
     /* 616434 */   // Label 7822: @616434
     /* 616434 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(616517), // Rule ID 11376 //
     /* 616439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616486 */     // MIs[3] src1
     /* 616486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616491 */     // MIs[3] src0
     /* 616491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616498 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616515 */     GIR_RootConstrainSelectedInstOperands,
     /* 616516 */     // GIR_Coverage, 11376,
     /* 616516 */     GIR_EraseRootFromParent_Done,
     /* 616517 */   // Label 7823: @616517
     /* 616517 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(616600), // Rule ID 11379 //
     /* 616522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616569 */     // MIs[3] src0
     /* 616569 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616574 */     // MIs[3] src1
     /* 616574 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616581 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616598 */     GIR_RootConstrainSelectedInstOperands,
     /* 616599 */     // GIR_Coverage, 11379,
     /* 616599 */     GIR_EraseRootFromParent_Done,
     /* 616600 */   // Label 7824: @616600
     /* 616600 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(616683), // Rule ID 11380 //
     /* 616605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 616648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616652 */     // MIs[3] src1
     /* 616652 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616657 */     // MIs[3] src0
     /* 616657 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616664 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 616681 */     GIR_RootConstrainSelectedInstOperands,
     /* 616682 */     // GIR_Coverage, 11380,
     /* 616682 */     GIR_EraseRootFromParent_Done,
     /* 616683 */   // Label 7825: @616683
     /* 616683 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(616766), // Rule ID 11377 //
     /* 616688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616735 */     // MIs[3] src0
     /* 616735 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616740 */     // MIs[3] src1
     /* 616740 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616747 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616764 */     GIR_RootConstrainSelectedInstOperands,
     /* 616765 */     // GIR_Coverage, 11377,
     /* 616765 */     GIR_EraseRootFromParent_Done,
     /* 616766 */   // Label 7826: @616766
     /* 616766 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(616849), // Rule ID 11378 //
     /* 616771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616818 */     // MIs[3] src1
     /* 616818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616823 */     // MIs[3] src0
     /* 616823 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616830 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 616839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 616843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616847 */     GIR_RootConstrainSelectedInstOperands,
     /* 616848 */     // GIR_Coverage, 11378,
     /* 616848 */     GIR_EraseRootFromParent_Done,
     /* 616849 */   // Label 7827: @616849
     /* 616849 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(616932), // Rule ID 11381 //
     /* 616854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616901 */     // MIs[3] src0
     /* 616901 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616906 */     // MIs[3] src1
     /* 616906 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616913 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 616918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 616922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 616926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 616930 */     GIR_RootConstrainSelectedInstOperands,
     /* 616931 */     // GIR_Coverage, 11381,
     /* 616931 */     GIR_EraseRootFromParent_Done,
     /* 616932 */   // Label 7828: @616932
     /* 616932 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(617015), // Rule ID 11382 //
     /* 616937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 616940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 616944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 616948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 616956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 616960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 616964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 616968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 616972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 616976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 616980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
     /* 616984 */     // MIs[3] src1
     /* 616984 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 616989 */     // MIs[3] src0
     /* 616989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 616994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 616996 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 616996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 616999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 617005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 617009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 617013 */     GIR_RootConstrainSelectedInstOperands,
     /* 617014 */     // GIR_Coverage, 11382,
     /* 617014 */     GIR_EraseRootFromParent_Done,
     /* 617015 */   // Label 7829: @617015
     /* 617015 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(617069), // Rule ID 8610 //
     /* 617020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 617024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 617032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 617036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 617040 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 617044 */     // MIs[0] x
     /* 617044 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 617049 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13728),
     /* 617053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 617055 */     // (smax:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$x)<<P:Predicate_anonymous_13728>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
     /* 617055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 617058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 617060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // x
     /* 617064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 617067 */     GIR_RootConstrainSelectedInstOperands,
     /* 617068 */     // GIR_Coverage, 8610,
     /* 617068 */     GIR_EraseRootFromParent_Done,
     /* 617069 */   // Label 7830: @617069
     /* 617069 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(617120), // Rule ID 1869 //
     /* 617074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 617077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 617081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 617085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 617089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 617093 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 617097 */     // MIs[1] x
     /* 617097 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 617102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13728),
     /* 617106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 617108 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$x, (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_13728>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
     /* 617108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 617111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 617113 */     GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 617115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
     /* 617118 */     GIR_RootConstrainSelectedInstOperands,
     /* 617119 */     // GIR_Coverage, 1869,
     /* 617119 */     GIR_EraseRootFromParent_Done,
     /* 617120 */   // Label 7831: @617120
     /* 617120 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(617176), // Rule ID 7846 //
     /* 617125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 617128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 617131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 617143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 617147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 617151 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 617153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35120),
     /* 617157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 617159 */     // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35120>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 617159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
     /* 617162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617172 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 617174 */     GIR_RootConstrainSelectedInstOperands,
     /* 617175 */     // GIR_Coverage, 7846,
     /* 617175 */     GIR_EraseRootFromParent_Done,
     /* 617176 */   // Label 7832: @617176
     /* 617176 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(617232), // Rule ID 13372 //
     /* 617181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 617184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 617187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 617195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
     /* 617199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 617203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 617207 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 617209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35120),
     /* 617213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 617215 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>)<<P:Predicate_anonymous_35120>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 617215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
     /* 617218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 617224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 617228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 617230 */     GIR_RootConstrainSelectedInstOperands,
     /* 617231 */     // GIR_Coverage, 13372,
     /* 617231 */     GIR_EraseRootFromParent_Done,
     /* 617232 */   // Label 7833: @617232
     /* 617232 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(617261), // Rule ID 49 //
     /* 617237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 617240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 617244 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13728),
     /* 617248 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13728>>  =>  (S_MAX_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 617248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_I32),
     /* 617253 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 617259 */     GIR_RootConstrainSelectedInstOperands,
     /* 617260 */     // GIR_Coverage, 49,
     /* 617260 */     GIR_Done,
     /* 617261 */   // Label 7834: @617261
     /* 617261 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(617284), // Rule ID 806 //
     /* 617266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 617269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617273 */     // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 617273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 617278 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 617282 */     GIR_RootConstrainSelectedInstOperands,
     /* 617283 */     // GIR_Coverage, 806,
     /* 617283 */     GIR_Done,
     /* 617284 */   // Label 7835: @617284
     /* 617284 */   GIM_Reject,
     /* 617285 */ // Label 7813: @617285
     /* 617285 */ GIM_Reject,
     /* 617286 */ // Label 7759: @617286
     /* 617286 */ GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(617357), // Rule ID 1103 //
     /* 617291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 617294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 617297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 617308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 617315 */   // (smax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 617315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_I16),
     /* 617318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 617325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 617330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 617335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 617340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617355 */   GIR_RootConstrainSelectedInstOperands,
     /* 617356 */   // GIR_Coverage, 1103,
     /* 617356 */   GIR_EraseRootFromParent_Done,
     /* 617357 */ // Label 7836: @617357
     /* 617357 */ GIM_Reject,
     /* 617358 */ // Label 7760: @617358
     /* 617358 */ GIM_Reject,
     /* 617359 */ // Label 90: @617359
     /* 617359 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7840*/ GIMT_Encode4(623722),
     /* 617370 */ /*GILLT_s16*//*Label 7837*/ GIMT_Encode4(617386),
     /* 617374 */ /*GILLT_s32*//*Label 7838*/ GIMT_Encode4(622205), GIMT_Encode4(0),
     /* 617382 */ /*GILLT_v2s16*//*Label 7839*/ GIMT_Encode4(623650),
     /* 617386 */ // Label 7837: @617386
     /* 617386 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(622204),
     /* 617391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 617394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 617397 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(617495), // Rule ID 13445 //
     /* 617402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 617405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617449 */     // MIs[3] src0
     /* 617449 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617454 */     // MIs[3] src1
     /* 617454 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617461 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 617464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 617473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 617480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617493 */     GIR_RootConstrainSelectedInstOperands,
     /* 617494 */     // GIR_Coverage, 13445,
     /* 617494 */     GIR_EraseRootFromParent_Done,
     /* 617495 */   // Label 7842: @617495
     /* 617495 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(617593), // Rule ID 13446 //
     /* 617500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 617503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617547 */     // MIs[3] src1
     /* 617547 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617552 */     // MIs[3] src0
     /* 617552 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617559 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 617562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 617571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 617578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617591 */     GIR_RootConstrainSelectedInstOperands,
     /* 617592 */     // GIR_Coverage, 13446,
     /* 617592 */     GIR_EraseRootFromParent_Done,
     /* 617593 */   // Label 7843: @617593
     /* 617593 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(617691), // Rule ID 13447 //
     /* 617598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 617601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617645 */     // MIs[3] src0
     /* 617645 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617650 */     // MIs[3] src1
     /* 617650 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617657 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 617660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 617669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 617676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617689 */     GIR_RootConstrainSelectedInstOperands,
     /* 617690 */     // GIR_Coverage, 13447,
     /* 617690 */     GIR_EraseRootFromParent_Done,
     /* 617691 */   // Label 7844: @617691
     /* 617691 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(617789), // Rule ID 13448 //
     /* 617696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 617699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 617703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617743 */     // MIs[3] src1
     /* 617743 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617748 */     // MIs[3] src0
     /* 617748 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617755 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 617758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 617767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 617774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617787 */     GIR_RootConstrainSelectedInstOperands,
     /* 617788 */     // GIR_Coverage, 13448,
     /* 617788 */     GIR_EraseRootFromParent_Done,
     /* 617789 */   // Label 7845: @617789
     /* 617789 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(617887), // Rule ID 13505 //
     /* 617794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617841 */     // MIs[3] src0
     /* 617841 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617846 */     // MIs[3] src1
     /* 617846 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617853 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 617865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 617872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617885 */     GIR_RootConstrainSelectedInstOperands,
     /* 617886 */     // GIR_Coverage, 13505,
     /* 617886 */     GIR_EraseRootFromParent_Done,
     /* 617887 */   // Label 7846: @617887
     /* 617887 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(617985), // Rule ID 13506 //
     /* 617892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 617903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 617911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 617915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 617919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 617923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 617927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 617931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 617935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 617939 */     // MIs[3] src1
     /* 617939 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 617944 */     // MIs[3] src0
     /* 617944 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 617949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 617951 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 617951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 617954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 617956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 617963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 617970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 617977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 617983 */     GIR_RootConstrainSelectedInstOperands,
     /* 617984 */     // GIR_Coverage, 13506,
     /* 617984 */     GIR_EraseRootFromParent_Done,
     /* 617985 */   // Label 7847: @617985
     /* 617985 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(618083), // Rule ID 13507 //
     /* 617990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 617993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 617997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618037 */     // MIs[3] src0
     /* 618037 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618042 */     // MIs[3] src1
     /* 618042 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618049 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 618052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618081 */     GIR_RootConstrainSelectedInstOperands,
     /* 618082 */     // GIR_Coverage, 13507,
     /* 618082 */     GIR_EraseRootFromParent_Done,
     /* 618083 */   // Label 7848: @618083
     /* 618083 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(618181), // Rule ID 13508 //
     /* 618088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 618091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 618095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618135 */     // MIs[3] src1
     /* 618135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618140 */     // MIs[3] src0
     /* 618140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618147 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 618150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618179 */     GIR_RootConstrainSelectedInstOperands,
     /* 618180 */     // GIR_Coverage, 13508,
     /* 618180 */     GIR_EraseRootFromParent_Done,
     /* 618181 */   // Label 7849: @618181
     /* 618181 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(618279), // Rule ID 13565 //
     /* 618186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 618189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618233 */     // MIs[3] src0
     /* 618233 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618238 */     // MIs[3] src1
     /* 618238 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618245 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 618248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618277 */     GIR_RootConstrainSelectedInstOperands,
     /* 618278 */     // GIR_Coverage, 13565,
     /* 618278 */     GIR_EraseRootFromParent_Done,
     /* 618279 */   // Label 7850: @618279
     /* 618279 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(618377), // Rule ID 13566 //
     /* 618284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 618287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618331 */     // MIs[3] src1
     /* 618331 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618336 */     // MIs[3] src0
     /* 618336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618343 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 618346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618375 */     GIR_RootConstrainSelectedInstOperands,
     /* 618376 */     // GIR_Coverage, 13566,
     /* 618376 */     GIR_EraseRootFromParent_Done,
     /* 618377 */   // Label 7851: @618377
     /* 618377 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(618475), // Rule ID 13567 //
     /* 618382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 618385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618429 */     // MIs[3] src0
     /* 618429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618434 */     // MIs[3] src1
     /* 618434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618441 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 618444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618473 */     GIR_RootConstrainSelectedInstOperands,
     /* 618474 */     // GIR_Coverage, 13567,
     /* 618474 */     GIR_EraseRootFromParent_Done,
     /* 618475 */   // Label 7852: @618475
     /* 618475 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(618573), // Rule ID 13568 //
     /* 618480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 618483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 618507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618527 */     // MIs[3] src1
     /* 618527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618532 */     // MIs[3] src0
     /* 618532 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618539 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 618542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 618565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618571 */     GIR_RootConstrainSelectedInstOperands,
     /* 618572 */     // GIR_Coverage, 13568,
     /* 618572 */     GIR_EraseRootFromParent_Done,
     /* 618573 */   // Label 7853: @618573
     /* 618573 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(618671), // Rule ID 13449 //
     /* 618578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 618581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618625 */     // MIs[3] src0
     /* 618625 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618630 */     // MIs[3] src1
     /* 618630 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618637 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 618640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618669 */     GIR_RootConstrainSelectedInstOperands,
     /* 618670 */     // GIR_Coverage, 13449,
     /* 618670 */     GIR_EraseRootFromParent_Done,
     /* 618671 */   // Label 7854: @618671
     /* 618671 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(618769), // Rule ID 13450 //
     /* 618676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 618679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618723 */     // MIs[3] src1
     /* 618723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618728 */     // MIs[3] src0
     /* 618728 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618733 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618735 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 618738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 618747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 618754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618767 */     GIR_RootConstrainSelectedInstOperands,
     /* 618768 */     // GIR_Coverage, 13450,
     /* 618768 */     GIR_EraseRootFromParent_Done,
     /* 618769 */   // Label 7855: @618769
     /* 618769 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(618867), // Rule ID 13451 //
     /* 618774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 618777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618821 */     // MIs[3] src0
     /* 618821 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618826 */     // MIs[3] src1
     /* 618826 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618833 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 618836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618865 */     GIR_RootConstrainSelectedInstOperands,
     /* 618866 */     // GIR_Coverage, 13451,
     /* 618866 */     GIR_EraseRootFromParent_Done,
     /* 618867 */   // Label 7856: @618867
     /* 618867 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(618965), // Rule ID 13452 //
     /* 618872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 618875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 618879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 618903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 618907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 618911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 618915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618919 */     // MIs[3] src1
     /* 618919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 618924 */     // MIs[3] src0
     /* 618924 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 618929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 618931 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 618931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 618934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 618936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 618943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 618950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 618957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 618963 */     GIR_RootConstrainSelectedInstOperands,
     /* 618964 */     // GIR_Coverage, 13452,
     /* 618964 */     GIR_EraseRootFromParent_Done,
     /* 618965 */   // Label 7857: @618965
     /* 618965 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(619063), // Rule ID 13509 //
     /* 618970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 618973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 618977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 618981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 618985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 618989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 618993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 618997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619017 */     // MIs[3] src0
     /* 619017 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619022 */     // MIs[3] src1
     /* 619022 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619029 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 619032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619061 */     GIR_RootConstrainSelectedInstOperands,
     /* 619062 */     // GIR_Coverage, 13509,
     /* 619062 */     GIR_EraseRootFromParent_Done,
     /* 619063 */   // Label 7858: @619063
     /* 619063 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(619161), // Rule ID 13510 //
     /* 619068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 619071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 619075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 619095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619115 */     // MIs[3] src1
     /* 619115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619120 */     // MIs[3] src0
     /* 619120 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619127 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 619130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619159 */     GIR_RootConstrainSelectedInstOperands,
     /* 619160 */     // GIR_Coverage, 13510,
     /* 619160 */     GIR_EraseRootFromParent_Done,
     /* 619161 */   // Label 7859: @619161
     /* 619161 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(619259), // Rule ID 13511 //
     /* 619166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 619169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 619173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 619193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619201 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619213 */     // MIs[3] src0
     /* 619213 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619218 */     // MIs[3] src1
     /* 619218 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619225 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 619228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 619237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 619244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619257 */     GIR_RootConstrainSelectedInstOperands,
     /* 619258 */     // GIR_Coverage, 13511,
     /* 619258 */     GIR_EraseRootFromParent_Done,
     /* 619259 */   // Label 7860: @619259
     /* 619259 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(619357), // Rule ID 13512 //
     /* 619264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 619267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 619271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 619291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619311 */     // MIs[3] src1
     /* 619311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619316 */     // MIs[3] src0
     /* 619316 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619323 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 619326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 619335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 619342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619355 */     GIR_RootConstrainSelectedInstOperands,
     /* 619356 */     // GIR_Coverage, 13512,
     /* 619356 */     GIR_EraseRootFromParent_Done,
     /* 619357 */   // Label 7861: @619357
     /* 619357 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(619455), // Rule ID 13569 //
     /* 619362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 619365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 619389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619409 */     // MIs[3] src0
     /* 619409 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619414 */     // MIs[3] src1
     /* 619414 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619421 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 619424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619453 */     GIR_RootConstrainSelectedInstOperands,
     /* 619454 */     // GIR_Coverage, 13569,
     /* 619454 */     GIR_EraseRootFromParent_Done,
     /* 619455 */   // Label 7862: @619455
     /* 619455 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(619553), // Rule ID 13570 //
     /* 619460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 619463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 619487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619507 */     // MIs[3] src1
     /* 619507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619512 */     // MIs[3] src0
     /* 619512 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619519 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 619522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 619531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 619538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619551 */     GIR_RootConstrainSelectedInstOperands,
     /* 619552 */     // GIR_Coverage, 13570,
     /* 619552 */     GIR_EraseRootFromParent_Done,
     /* 619553 */   // Label 7863: @619553
     /* 619553 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(619651), // Rule ID 13571 //
     /* 619558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 619561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 619585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619605 */     // MIs[3] src0
     /* 619605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619610 */     // MIs[3] src1
     /* 619610 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619617 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 619620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 619629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 619636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619649 */     GIR_RootConstrainSelectedInstOperands,
     /* 619650 */     // GIR_Coverage, 13571,
     /* 619650 */     GIR_EraseRootFromParent_Done,
     /* 619651 */   // Label 7864: @619651
     /* 619651 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(619749), // Rule ID 13572 //
     /* 619656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 619659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 619683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 619699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619703 */     // MIs[3] src1
     /* 619703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 619708 */     // MIs[3] src0
     /* 619708 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 619713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619715 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 619718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 619727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 619734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 619741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619747 */     GIR_RootConstrainSelectedInstOperands,
     /* 619748 */     // GIR_Coverage, 13572,
     /* 619748 */     GIR_EraseRootFromParent_Done,
     /* 619749 */   // Label 7865: @619749
     /* 619749 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(619847), // Rule ID 7898 //
     /* 619754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 619757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619789 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 619797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619801 */     // MIs[3] src0
     /* 619801 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619806 */     // MIs[3] src1
     /* 619806 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619813 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 619816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 619839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619845 */     GIR_RootConstrainSelectedInstOperands,
     /* 619846 */     // GIR_Coverage, 7898,
     /* 619846 */     GIR_EraseRootFromParent_Done,
     /* 619847 */   // Label 7866: @619847
     /* 619847 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(619945), // Rule ID 7902 //
     /* 619852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 619855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 619859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 619895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619899 */     // MIs[3] src0
     /* 619899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 619904 */     // MIs[3] src1
     /* 619904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 619909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 619911 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 619911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 619914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 619916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 619923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 619930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 619937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 619943 */     GIR_RootConstrainSelectedInstOperands,
     /* 619944 */     // GIR_Coverage, 7902,
     /* 619944 */     GIR_EraseRootFromParent_Done,
     /* 619945 */   // Label 7867: @619945
     /* 619945 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(620043), // Rule ID 7906 //
     /* 619950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 619953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 619957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 619961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 619969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 619973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 619977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 619981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 619985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 619989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 619993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 619997 */     // MIs[3] src0
     /* 619997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620002 */     // MIs[3] src1
     /* 620002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620007 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620009 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 620021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 620028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620041 */     GIR_RootConstrainSelectedInstOperands,
     /* 620042 */     // GIR_Coverage, 7906,
     /* 620042 */     GIR_EraseRootFromParent_Done,
     /* 620043 */   // Label 7868: @620043
     /* 620043 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(620141), // Rule ID 13438 //
     /* 620048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620095 */     // MIs[3] src1
     /* 620095 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620100 */     // MIs[3] src0
     /* 620100 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620107 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 620119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 620126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620139 */     GIR_RootConstrainSelectedInstOperands,
     /* 620140 */     // GIR_Coverage, 13438,
     /* 620140 */     GIR_EraseRootFromParent_Done,
     /* 620141 */   // Label 7869: @620141
     /* 620141 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(620239), // Rule ID 13441 //
     /* 620146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620193 */     // MIs[3] src0
     /* 620193 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620198 */     // MIs[3] src1
     /* 620198 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620205 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 620217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 620224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620237 */     GIR_RootConstrainSelectedInstOperands,
     /* 620238 */     // GIR_Coverage, 13441,
     /* 620238 */     GIR_EraseRootFromParent_Done,
     /* 620239 */   // Label 7870: @620239
     /* 620239 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(620337), // Rule ID 13442 //
     /* 620244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620291 */     // MIs[3] src1
     /* 620291 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620296 */     // MIs[3] src0
     /* 620296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620303 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 620315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 620322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620335 */     GIR_RootConstrainSelectedInstOperands,
     /* 620336 */     // GIR_Coverage, 13442,
     /* 620336 */     GIR_EraseRootFromParent_Done,
     /* 620337 */   // Label 7871: @620337
     /* 620337 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(620435), // Rule ID 13498 //
     /* 620342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620389 */     // MIs[3] src1
     /* 620389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620394 */     // MIs[3] src0
     /* 620394 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620401 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 620413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 620420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620433 */     GIR_RootConstrainSelectedInstOperands,
     /* 620434 */     // GIR_Coverage, 13498,
     /* 620434 */     GIR_EraseRootFromParent_Done,
     /* 620435 */   // Label 7872: @620435
     /* 620435 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(620533), // Rule ID 13501 //
     /* 620440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620487 */     // MIs[3] src0
     /* 620487 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620492 */     // MIs[3] src1
     /* 620492 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620499 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 620511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 620518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620531 */     GIR_RootConstrainSelectedInstOperands,
     /* 620532 */     // GIR_Coverage, 13501,
     /* 620532 */     GIR_EraseRootFromParent_Done,
     /* 620533 */   // Label 7873: @620533
     /* 620533 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(620631), // Rule ID 13502 //
     /* 620538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 620541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 620545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620585 */     // MIs[3] src1
     /* 620585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620590 */     // MIs[3] src0
     /* 620590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620597 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 620600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 620609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 620616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620629 */     GIR_RootConstrainSelectedInstOperands,
     /* 620630 */     // GIR_Coverage, 13502,
     /* 620630 */     GIR_EraseRootFromParent_Done,
     /* 620631 */   // Label 7874: @620631
     /* 620631 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(620729), // Rule ID 13558 //
     /* 620636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620683 */     // MIs[3] src1
     /* 620683 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620688 */     // MIs[3] src0
     /* 620688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620695 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 620707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 620714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620727 */     GIR_RootConstrainSelectedInstOperands,
     /* 620728 */     // GIR_Coverage, 13558,
     /* 620728 */     GIR_EraseRootFromParent_Done,
     /* 620729 */   // Label 7875: @620729
     /* 620729 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(620827), // Rule ID 13561 //
     /* 620734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620769 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620781 */     // MIs[3] src0
     /* 620781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620786 */     // MIs[3] src1
     /* 620786 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620793 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 620805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 620812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620825 */     GIR_RootConstrainSelectedInstOperands,
     /* 620826 */     // GIR_Coverage, 13561,
     /* 620826 */     GIR_EraseRootFromParent_Done,
     /* 620827 */   // Label 7876: @620827
     /* 620827 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(620925), // Rule ID 13562 //
     /* 620832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 620835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 620875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620879 */     // MIs[3] src1
     /* 620879 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620884 */     // MIs[3] src0
     /* 620884 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620891 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 620894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 620903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 620910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 620917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620923 */     GIR_RootConstrainSelectedInstOperands,
     /* 620924 */     // GIR_Coverage, 13562,
     /* 620924 */     GIR_EraseRootFromParent_Done,
     /* 620925 */   // Label 7877: @620925
     /* 620925 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(621023), // Rule ID 13439 //
     /* 620930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 620933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 620937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 620941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 620949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 620953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 620957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 620961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 620965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 620969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 620973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 620977 */     // MIs[3] src0
     /* 620977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 620982 */     // MIs[3] src1
     /* 620982 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 620987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 620989 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 620989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 620992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 620994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 620997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621021 */     GIR_RootConstrainSelectedInstOperands,
     /* 621022 */     // GIR_Coverage, 13439,
     /* 621022 */     GIR_EraseRootFromParent_Done,
     /* 621023 */   // Label 7878: @621023
     /* 621023 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(621121), // Rule ID 13440 //
     /* 621028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 621031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621075 */     // MIs[3] src1
     /* 621075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621080 */     // MIs[3] src0
     /* 621080 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621087 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 621090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621119 */     GIR_RootConstrainSelectedInstOperands,
     /* 621120 */     // GIR_Coverage, 13440,
     /* 621120 */     GIR_EraseRootFromParent_Done,
     /* 621121 */   // Label 7879: @621121
     /* 621121 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(621219), // Rule ID 13443 //
     /* 621126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 621129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621173 */     // MIs[3] src0
     /* 621173 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621178 */     // MIs[3] src1
     /* 621178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621185 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 621188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 621197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 621204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621217 */     GIR_RootConstrainSelectedInstOperands,
     /* 621218 */     // GIR_Coverage, 13443,
     /* 621218 */     GIR_EraseRootFromParent_Done,
     /* 621219 */   // Label 7880: @621219
     /* 621219 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(621317), // Rule ID 13444 //
     /* 621224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 621227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621271 */     // MIs[3] src1
     /* 621271 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621276 */     // MIs[3] src0
     /* 621276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621283 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 621286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 621295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 621302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621315 */     GIR_RootConstrainSelectedInstOperands,
     /* 621316 */     // GIR_Coverage, 13444,
     /* 621316 */     GIR_EraseRootFromParent_Done,
     /* 621317 */   // Label 7881: @621317
     /* 621317 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(621415), // Rule ID 13499 //
     /* 621322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621369 */     // MIs[3] src0
     /* 621369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621374 */     // MIs[3] src1
     /* 621374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621381 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621413 */     GIR_RootConstrainSelectedInstOperands,
     /* 621414 */     // GIR_Coverage, 13499,
     /* 621414 */     GIR_EraseRootFromParent_Done,
     /* 621415 */   // Label 7882: @621415
     /* 621415 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(621513), // Rule ID 13500 //
     /* 621420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621467 */     // MIs[3] src1
     /* 621467 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621472 */     // MIs[3] src0
     /* 621472 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621479 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621511 */     GIR_RootConstrainSelectedInstOperands,
     /* 621512 */     // GIR_Coverage, 13500,
     /* 621512 */     GIR_EraseRootFromParent_Done,
     /* 621513 */   // Label 7883: @621513
     /* 621513 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(621611), // Rule ID 13503 //
     /* 621518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621565 */     // MIs[3] src0
     /* 621565 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621570 */     // MIs[3] src1
     /* 621570 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621577 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 621589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 621596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621609 */     GIR_RootConstrainSelectedInstOperands,
     /* 621610 */     // GIR_Coverage, 13503,
     /* 621610 */     GIR_EraseRootFromParent_Done,
     /* 621611 */   // Label 7884: @621611
     /* 621611 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(621709), // Rule ID 13504 //
     /* 621616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 621619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 621623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621663 */     // MIs[3] src1
     /* 621663 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621668 */     // MIs[3] src0
     /* 621668 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621675 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 621678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 621687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 621694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621707 */     GIR_RootConstrainSelectedInstOperands,
     /* 621708 */     // GIR_Coverage, 13504,
     /* 621708 */     GIR_EraseRootFromParent_Done,
     /* 621709 */   // Label 7885: @621709
     /* 621709 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(621807), // Rule ID 13559 //
     /* 621714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621761 */     // MIs[3] src0
     /* 621761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621766 */     // MIs[3] src1
     /* 621766 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621773 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621805 */     GIR_RootConstrainSelectedInstOperands,
     /* 621806 */     // GIR_Coverage, 13559,
     /* 621806 */     GIR_EraseRootFromParent_Done,
     /* 621807 */   // Label 7886: @621807
     /* 621807 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(621905), // Rule ID 13560 //
     /* 621812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621859 */     // MIs[3] src1
     /* 621859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621864 */     // MIs[3] src0
     /* 621864 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621871 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 621883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 621890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621903 */     GIR_RootConstrainSelectedInstOperands,
     /* 621904 */     // GIR_Coverage, 13560,
     /* 621904 */     GIR_EraseRootFromParent_Done,
     /* 621905 */   // Label 7887: @621905
     /* 621905 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(622003), // Rule ID 13563 //
     /* 621910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 621913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 621917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 621921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 621929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 621933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 621937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 621941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 621945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 621949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 621953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 621957 */     // MIs[3] src0
     /* 621957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 621962 */     // MIs[3] src1
     /* 621962 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 621967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 621969 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 621969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 621972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 621974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 621981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 621988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 621995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 621998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622001 */     GIR_RootConstrainSelectedInstOperands,
     /* 622002 */     // GIR_Coverage, 13563,
     /* 622002 */     GIR_EraseRootFromParent_Done,
     /* 622003 */   // Label 7888: @622003
     /* 622003 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(622101), // Rule ID 13564 //
     /* 622008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 622011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 622027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 622031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 622043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 622047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 622051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622055 */     // MIs[3] src1
     /* 622055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622060 */     // MIs[3] src0
     /* 622060 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622067 */     // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 622067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 622070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 622079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 622086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 622093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622099 */     GIR_RootConstrainSelectedInstOperands,
     /* 622100 */     // GIR_Coverage, 13564,
     /* 622100 */     GIR_EraseRootFromParent_Done,
     /* 622101 */   // Label 7889: @622101
     /* 622101 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(622157), // Rule ID 899 //
     /* 622106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 622109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 622113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 622120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 622127 */     // (umin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 622127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_t16_e64),
     /* 622130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 622137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 622142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 622147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 622152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 622155 */     GIR_RootConstrainSelectedInstOperands,
     /* 622156 */     // GIR_Coverage, 899,
     /* 622156 */     GIR_EraseRootFromParent_Done,
     /* 622157 */   // Label 7890: @622157
     /* 622157 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(622180), // Rule ID 898 //
     /* 622162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 622165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622169 */     // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 622169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
     /* 622174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 622178 */     GIR_RootConstrainSelectedInstOperands,
     /* 622179 */     // GIR_Coverage, 898,
     /* 622179 */     GIR_Done,
     /* 622180 */   // Label 7891: @622180
     /* 622180 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(622203), // Rule ID 900 //
     /* 622185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 622188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622192 */     // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 622192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_fake16_e64),
     /* 622197 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 622201 */     GIR_RootConstrainSelectedInstOperands,
     /* 622202 */     // GIR_Coverage, 900,
     /* 622202 */     GIR_Done,
     /* 622203 */   // Label 7892: @622203
     /* 622203 */   GIM_Reject,
     /* 622204 */ // Label 7841: @622204
     /* 622204 */ GIM_Reject,
     /* 622205 */ // Label 7838: @622205
     /* 622205 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(623649),
     /* 622210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 622213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 622216 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(622296), // Rule ID 11398 //
     /* 622221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 622245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622265 */     // MIs[3] src0
     /* 622265 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622270 */     // MIs[3] src1
     /* 622270 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622277 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 622286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 622290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 622294 */     GIR_RootConstrainSelectedInstOperands,
     /* 622295 */     // GIR_Coverage, 11398,
     /* 622295 */     GIR_EraseRootFromParent_Done,
     /* 622296 */   // Label 7894: @622296
     /* 622296 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(622376), // Rule ID 11399 //
     /* 622301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 622325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622345 */     // MIs[3] src1
     /* 622345 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622350 */     // MIs[3] src0
     /* 622350 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622357 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 622366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 622370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 622374 */     GIR_RootConstrainSelectedInstOperands,
     /* 622375 */     // GIR_Coverage, 11399,
     /* 622375 */     GIR_EraseRootFromParent_Done,
     /* 622376 */   // Label 7895: @622376
     /* 622376 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(622456), // Rule ID 11400 //
     /* 622381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 622405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622425 */     // MIs[3] src0
     /* 622425 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622430 */     // MIs[3] src1
     /* 622430 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622437 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 622446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 622450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 622454 */     GIR_RootConstrainSelectedInstOperands,
     /* 622455 */     // GIR_Coverage, 11400,
     /* 622455 */     GIR_EraseRootFromParent_Done,
     /* 622456 */   // Label 7896: @622456
     /* 622456 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(622536), // Rule ID 11401 //
     /* 622461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 622485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622505 */     // MIs[3] src1
     /* 622505 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622510 */     // MIs[3] src0
     /* 622510 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622517 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 622526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 622530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 622534 */     GIR_RootConstrainSelectedInstOperands,
     /* 622535 */     // GIR_Coverage, 11401,
     /* 622535 */     GIR_EraseRootFromParent_Done,
     /* 622536 */   // Label 7897: @622536
     /* 622536 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(622616), // Rule ID 11402 //
     /* 622541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 622565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622585 */     // MIs[3] src0
     /* 622585 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622590 */     // MIs[3] src1
     /* 622590 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622597 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 622606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 622610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 622614 */     GIR_RootConstrainSelectedInstOperands,
     /* 622615 */     // GIR_Coverage, 11402,
     /* 622615 */     GIR_EraseRootFromParent_Done,
     /* 622616 */   // Label 7898: @622616
     /* 622616 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(622696), // Rule ID 11403 //
     /* 622621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 622645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622665 */     // MIs[3] src1
     /* 622665 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622670 */     // MIs[3] src0
     /* 622670 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622677 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 622686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 622690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 622694 */     GIR_RootConstrainSelectedInstOperands,
     /* 622695 */     // GIR_Coverage, 11403,
     /* 622695 */     GIR_EraseRootFromParent_Done,
     /* 622696 */   // Label 7899: @622696
     /* 622696 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(622776), // Rule ID 11404 //
     /* 622701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 622725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622745 */     // MIs[3] src0
     /* 622745 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622750 */     // MIs[3] src1
     /* 622750 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622755 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622757 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 622766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 622770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 622774 */     GIR_RootConstrainSelectedInstOperands,
     /* 622775 */     // GIR_Coverage, 11404,
     /* 622775 */     GIR_EraseRootFromParent_Done,
     /* 622776 */   // Label 7900: @622776
     /* 622776 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(622856), // Rule ID 11405 //
     /* 622781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 622805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 622821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622825 */     // MIs[3] src1
     /* 622825 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 622830 */     // MIs[3] src0
     /* 622830 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 622835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622837 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 622846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 622850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 622854 */     GIR_RootConstrainSelectedInstOperands,
     /* 622855 */     // GIR_Coverage, 11405,
     /* 622855 */     GIR_EraseRootFromParent_Done,
     /* 622856 */   // Label 7901: @622856
     /* 622856 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(622936), // Rule ID 7713 //
     /* 622861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622905 */     // MIs[3] src0
     /* 622905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622910 */     // MIs[3] src1
     /* 622910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622917 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 622920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 622922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 622926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 622930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 622934 */     GIR_RootConstrainSelectedInstOperands,
     /* 622935 */     // GIR_Coverage, 7713,
     /* 622935 */     GIR_EraseRootFromParent_Done,
     /* 622936 */   // Label 7902: @622936
     /* 622936 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(623016), // Rule ID 11391 //
     /* 622941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 622945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 622949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 622957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 622961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 622965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 622969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 622973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 622977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 622981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 622985 */     // MIs[3] src1
     /* 622985 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 622990 */     // MIs[3] src0
     /* 622990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 622995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 622997 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 622997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 623000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 623014 */     GIR_RootConstrainSelectedInstOperands,
     /* 623015 */     // GIR_Coverage, 11391,
     /* 623015 */     GIR_EraseRootFromParent_Done,
     /* 623016 */   // Label 7903: @623016
     /* 623016 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(623096), // Rule ID 11394 //
     /* 623021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 623053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 623057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 623061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623065 */     // MIs[3] src0
     /* 623065 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623070 */     // MIs[3] src1
     /* 623070 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623077 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 623080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 623094 */     GIR_RootConstrainSelectedInstOperands,
     /* 623095 */     // GIR_Coverage, 11394,
     /* 623095 */     GIR_EraseRootFromParent_Done,
     /* 623096 */   // Label 7904: @623096
     /* 623096 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(623176), // Rule ID 11395 //
     /* 623101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 623133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 623137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 623141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623145 */     // MIs[3] src1
     /* 623145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623150 */     // MIs[3] src0
     /* 623150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623157 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 623160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 623174 */     GIR_RootConstrainSelectedInstOperands,
     /* 623175 */     // GIR_Coverage, 11395,
     /* 623175 */     GIR_EraseRootFromParent_Done,
     /* 623176 */   // Label 7905: @623176
     /* 623176 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(623256), // Rule ID 11392 //
     /* 623181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 623213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 623217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623225 */     // MIs[3] src0
     /* 623225 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623230 */     // MIs[3] src1
     /* 623230 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623237 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 623240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623254 */     GIR_RootConstrainSelectedInstOperands,
     /* 623255 */     // GIR_Coverage, 11392,
     /* 623255 */     GIR_EraseRootFromParent_Done,
     /* 623256 */   // Label 7906: @623256
     /* 623256 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(623336), // Rule ID 11393 //
     /* 623261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 623293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 623297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623305 */     // MIs[3] src1
     /* 623305 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623310 */     // MIs[3] src0
     /* 623310 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623317 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 623320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623334 */     GIR_RootConstrainSelectedInstOperands,
     /* 623335 */     // GIR_Coverage, 11393,
     /* 623335 */     GIR_EraseRootFromParent_Done,
     /* 623336 */   // Label 7907: @623336
     /* 623336 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(623416), // Rule ID 11396 //
     /* 623341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 623373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 623377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623385 */     // MIs[3] src0
     /* 623385 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623390 */     // MIs[3] src1
     /* 623390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623397 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 623400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623414 */     GIR_RootConstrainSelectedInstOperands,
     /* 623415 */     // GIR_Coverage, 11396,
     /* 623415 */     GIR_EraseRootFromParent_Done,
     /* 623416 */   // Label 7908: @623416
     /* 623416 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(623496), // Rule ID 11397 //
     /* 623421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 623445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 623453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 623457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 623461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623465 */     // MIs[3] src1
     /* 623465 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 623470 */     // MIs[3] src0
     /* 623470 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 623475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623477 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 623480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 623486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 623490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 623494 */     GIR_RootConstrainSelectedInstOperands,
     /* 623495 */     // GIR_Coverage, 11397,
     /* 623495 */     GIR_EraseRootFromParent_Done,
     /* 623496 */   // Label 7909: @623496
     /* 623496 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(623549), // Rule ID 7847 //
     /* 623501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 623504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623524 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 623526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35122),
     /* 623530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 623532 */     // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35122>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
     /* 623535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 623547 */     GIR_RootConstrainSelectedInstOperands,
     /* 623548 */     // GIR_Coverage, 7847,
     /* 623548 */     GIR_EraseRootFromParent_Done,
     /* 623549 */   // Label 7910: @623549
     /* 623549 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(623602), // Rule ID 13373 //
     /* 623554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 623557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 623565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 623573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 623577 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 623579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35122),
     /* 623583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 623585 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>)<<P:Predicate_anonymous_35122>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 623585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
     /* 623588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 623594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 623598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 623600 */     GIR_RootConstrainSelectedInstOperands,
     /* 623601 */     // GIR_Coverage, 13373,
     /* 623601 */     GIR_EraseRootFromParent_Done,
     /* 623602 */   // Label 7911: @623602
     /* 623602 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(623628), // Rule ID 48 //
     /* 623607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 623611 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13727),
     /* 623615 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13727>>  =>  (S_MIN_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 623615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_U32),
     /* 623620 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 623626 */     GIR_RootConstrainSelectedInstOperands,
     /* 623627 */     // GIR_Coverage, 48,
     /* 623627 */     GIR_Done,
     /* 623628 */   // Label 7912: @623628
     /* 623628 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(623648), // Rule ID 807 //
     /* 623633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623637 */     // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 623637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U32_e64),
     /* 623642 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 623646 */     GIR_RootConstrainSelectedInstOperands,
     /* 623647 */     // GIR_Coverage, 807,
     /* 623647 */     GIR_Done,
     /* 623648 */   // Label 7913: @623648
     /* 623648 */   GIM_Reject,
     /* 623649 */ // Label 7893: @623649
     /* 623649 */ GIM_Reject,
     /* 623650 */ // Label 7839: @623650
     /* 623650 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(623721), // Rule ID 1102 //
     /* 623655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 623658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 623661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 623672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 623679 */   // (umin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 623679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_U16),
     /* 623682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 623689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 623694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 623699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 623704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623719 */   GIR_RootConstrainSelectedInstOperands,
     /* 623720 */   // GIR_Coverage, 1102,
     /* 623720 */   GIR_EraseRootFromParent_Done,
     /* 623721 */ // Label 7914: @623721
     /* 623721 */ GIM_Reject,
     /* 623722 */ // Label 7840: @623722
     /* 623722 */ GIM_Reject,
     /* 623723 */ // Label 91: @623723
     /* 623723 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7918*/ GIMT_Encode4(630086),
     /* 623734 */ /*GILLT_s16*//*Label 7915*/ GIMT_Encode4(623750),
     /* 623738 */ /*GILLT_s32*//*Label 7916*/ GIMT_Encode4(628569), GIMT_Encode4(0),
     /* 623746 */ /*GILLT_v2s16*//*Label 7917*/ GIMT_Encode4(630014),
     /* 623750 */ // Label 7915: @623750
     /* 623750 */ GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(628568),
     /* 623755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 623758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 623761 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(623859), // Rule ID 13430 //
     /* 623766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 623793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 623809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623813 */     // MIs[3] src0
     /* 623813 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 623818 */     // MIs[3] src1
     /* 623818 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 623823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623825 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 623837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 623844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 623851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623857 */     GIR_RootConstrainSelectedInstOperands,
     /* 623858 */     // GIR_Coverage, 13430,
     /* 623858 */     GIR_EraseRootFromParent_Done,
     /* 623859 */   // Label 7920: @623859
     /* 623859 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(623957), // Rule ID 13431 //
     /* 623864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 623891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 623903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 623907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623911 */     // MIs[3] src1
     /* 623911 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 623916 */     // MIs[3] src0
     /* 623916 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 623921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 623923 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 623923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 623926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 623928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 623935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 623942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 623949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 623955 */     GIR_RootConstrainSelectedInstOperands,
     /* 623956 */     // GIR_Coverage, 13431,
     /* 623956 */     GIR_EraseRootFromParent_Done,
     /* 623957 */   // Label 7921: @623957
     /* 623957 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(624055), // Rule ID 13432 //
     /* 623962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 623965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 623969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 623973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 623977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 623981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 623985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 623989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 623993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 623997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624009 */     // MIs[3] src0
     /* 624009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624014 */     // MIs[3] src1
     /* 624014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624021 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 624024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624053 */     GIR_RootConstrainSelectedInstOperands,
     /* 624054 */     // GIR_Coverage, 13432,
     /* 624054 */     GIR_EraseRootFromParent_Done,
     /* 624055 */   // Label 7922: @624055
     /* 624055 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(624153), // Rule ID 13433 //
     /* 624060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 624063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624107 */     // MIs[3] src1
     /* 624107 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624112 */     // MIs[3] src0
     /* 624112 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624119 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 624122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624151 */     GIR_RootConstrainSelectedInstOperands,
     /* 624152 */     // GIR_Coverage, 13433,
     /* 624152 */     GIR_EraseRootFromParent_Done,
     /* 624153 */   // Label 7923: @624153
     /* 624153 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(624251), // Rule ID 13490 //
     /* 624158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 624161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 624165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624205 */     // MIs[3] src0
     /* 624205 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624210 */     // MIs[3] src1
     /* 624210 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624215 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624217 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 624220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624249 */     GIR_RootConstrainSelectedInstOperands,
     /* 624250 */     // GIR_Coverage, 13490,
     /* 624250 */     GIR_EraseRootFromParent_Done,
     /* 624251 */   // Label 7924: @624251
     /* 624251 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(624349), // Rule ID 13491 //
     /* 624256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 624259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 624263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624303 */     // MIs[3] src1
     /* 624303 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624308 */     // MIs[3] src0
     /* 624308 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624313 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624315 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 624318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624347 */     GIR_RootConstrainSelectedInstOperands,
     /* 624348 */     // GIR_Coverage, 13491,
     /* 624348 */     GIR_EraseRootFromParent_Done,
     /* 624349 */   // Label 7925: @624349
     /* 624349 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(624447), // Rule ID 13492 //
     /* 624354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 624357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 624361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624401 */     // MIs[3] src0
     /* 624401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624406 */     // MIs[3] src1
     /* 624406 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624413 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 624416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624445 */     GIR_RootConstrainSelectedInstOperands,
     /* 624446 */     // GIR_Coverage, 13492,
     /* 624446 */     GIR_EraseRootFromParent_Done,
     /* 624447 */   // Label 7926: @624447
     /* 624447 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(624545), // Rule ID 13493 //
     /* 624452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 624455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 624459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624499 */     // MIs[3] src1
     /* 624499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624504 */     // MIs[3] src0
     /* 624504 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624509 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624511 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 624514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624543 */     GIR_RootConstrainSelectedInstOperands,
     /* 624544 */     // GIR_Coverage, 13493,
     /* 624544 */     GIR_EraseRootFromParent_Done,
     /* 624545 */   // Label 7927: @624545
     /* 624545 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(624643), // Rule ID 13550 //
     /* 624550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 624553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624593 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624597 */     // MIs[3] src0
     /* 624597 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624602 */     // MIs[3] src1
     /* 624602 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624609 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624641 */     GIR_RootConstrainSelectedInstOperands,
     /* 624642 */     // GIR_Coverage, 13550,
     /* 624642 */     GIR_EraseRootFromParent_Done,
     /* 624643 */   // Label 7928: @624643
     /* 624643 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(624741), // Rule ID 13551 //
     /* 624648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 624651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624695 */     // MIs[3] src1
     /* 624695 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624700 */     // MIs[3] src0
     /* 624700 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624707 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 624719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 624726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624739 */     GIR_RootConstrainSelectedInstOperands,
     /* 624740 */     // GIR_Coverage, 13551,
     /* 624740 */     GIR_EraseRootFromParent_Done,
     /* 624741 */   // Label 7929: @624741
     /* 624741 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(624839), // Rule ID 13552 //
     /* 624746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 624749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624793 */     // MIs[3] src0
     /* 624793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624798 */     // MIs[3] src1
     /* 624798 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624805 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624837 */     GIR_RootConstrainSelectedInstOperands,
     /* 624838 */     // GIR_Coverage, 13552,
     /* 624838 */     GIR_EraseRootFromParent_Done,
     /* 624839 */   // Label 7930: @624839
     /* 624839 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(624937), // Rule ID 13553 //
     /* 624844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 624847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 624871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624891 */     // MIs[3] src1
     /* 624891 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624896 */     // MIs[3] src0
     /* 624896 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 624903 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 624903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 624906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 624908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 624915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 624922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 624929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 624935 */     GIR_RootConstrainSelectedInstOperands,
     /* 624936 */     // GIR_Coverage, 13553,
     /* 624936 */     GIR_EraseRootFromParent_Done,
     /* 624937 */   // Label 7931: @624937
     /* 624937 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(625035), // Rule ID 13434 //
     /* 624942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 624945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 624949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 624953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 624961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 624965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 624969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 624973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 624977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 624981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 624985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 624989 */     // MIs[3] src0
     /* 624989 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 624994 */     // MIs[3] src1
     /* 624994 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 624999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625001 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 625004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 625013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 625020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625033 */     GIR_RootConstrainSelectedInstOperands,
     /* 625034 */     // GIR_Coverage, 13434,
     /* 625034 */     GIR_EraseRootFromParent_Done,
     /* 625035 */   // Label 7932: @625035
     /* 625035 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(625133), // Rule ID 13435 //
     /* 625040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 625043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625087 */     // MIs[3] src1
     /* 625087 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625092 */     // MIs[3] src0
     /* 625092 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625099 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 625102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 625111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 625118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625131 */     GIR_RootConstrainSelectedInstOperands,
     /* 625132 */     // GIR_Coverage, 13435,
     /* 625132 */     GIR_EraseRootFromParent_Done,
     /* 625133 */   // Label 7933: @625133
     /* 625133 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(625231), // Rule ID 13436 //
     /* 625138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 625141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625185 */     // MIs[3] src0
     /* 625185 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625190 */     // MIs[3] src1
     /* 625190 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625197 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 625200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 625209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 625216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625229 */     GIR_RootConstrainSelectedInstOperands,
     /* 625230 */     // GIR_Coverage, 13436,
     /* 625230 */     GIR_EraseRootFromParent_Done,
     /* 625231 */   // Label 7934: @625231
     /* 625231 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(625329), // Rule ID 13437 //
     /* 625236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 625239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625283 */     // MIs[3] src1
     /* 625283 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625288 */     // MIs[3] src0
     /* 625288 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625295 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 625298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 625307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 625314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625327 */     GIR_RootConstrainSelectedInstOperands,
     /* 625328 */     // GIR_Coverage, 13437,
     /* 625328 */     GIR_EraseRootFromParent_Done,
     /* 625329 */   // Label 7935: @625329
     /* 625329 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(625427), // Rule ID 13494 //
     /* 625334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 625337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 625341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625381 */     // MIs[3] src0
     /* 625381 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625386 */     // MIs[3] src1
     /* 625386 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625393 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 625396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 625405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 625412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625425 */     GIR_RootConstrainSelectedInstOperands,
     /* 625426 */     // GIR_Coverage, 13494,
     /* 625426 */     GIR_EraseRootFromParent_Done,
     /* 625427 */   // Label 7936: @625427
     /* 625427 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(625525), // Rule ID 13495 //
     /* 625432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 625435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 625439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625479 */     // MIs[3] src1
     /* 625479 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625484 */     // MIs[3] src0
     /* 625484 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625491 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 625494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 625503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 625510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625523 */     GIR_RootConstrainSelectedInstOperands,
     /* 625524 */     // GIR_Coverage, 13495,
     /* 625524 */     GIR_EraseRootFromParent_Done,
     /* 625525 */   // Label 7937: @625525
     /* 625525 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(625623), // Rule ID 13496 //
     /* 625530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 625533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 625537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625577 */     // MIs[3] src0
     /* 625577 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625582 */     // MIs[3] src1
     /* 625582 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625589 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 625592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 625601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 625608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625621 */     GIR_RootConstrainSelectedInstOperands,
     /* 625622 */     // GIR_Coverage, 13496,
     /* 625622 */     GIR_EraseRootFromParent_Done,
     /* 625623 */   // Label 7938: @625623
     /* 625623 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(625721), // Rule ID 13497 //
     /* 625628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 625631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 625635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625675 */     // MIs[3] src1
     /* 625675 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625680 */     // MIs[3] src0
     /* 625680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625685 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625687 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 625690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 625699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 625706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625719 */     GIR_RootConstrainSelectedInstOperands,
     /* 625720 */     // GIR_Coverage, 13497,
     /* 625720 */     GIR_EraseRootFromParent_Done,
     /* 625721 */   // Label 7939: @625721
     /* 625721 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(625819), // Rule ID 13554 //
     /* 625726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 625729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625773 */     // MIs[3] src0
     /* 625773 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625778 */     // MIs[3] src1
     /* 625778 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625785 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 625788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 625797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 625804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625817 */     GIR_RootConstrainSelectedInstOperands,
     /* 625818 */     // GIR_Coverage, 13554,
     /* 625818 */     GIR_EraseRootFromParent_Done,
     /* 625819 */   // Label 7940: @625819
     /* 625819 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(625917), // Rule ID 13555 //
     /* 625824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 625827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625871 */     // MIs[3] src1
     /* 625871 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625876 */     // MIs[3] src0
     /* 625876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625883 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 625886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 625895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 625902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 625909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625915 */     GIR_RootConstrainSelectedInstOperands,
     /* 625916 */     // GIR_Coverage, 13555,
     /* 625916 */     GIR_EraseRootFromParent_Done,
     /* 625917 */   // Label 7941: @625917
     /* 625917 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(626015), // Rule ID 13556 //
     /* 625922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 625925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 625929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 625933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 625941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 625945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 625949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 625953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 625957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 625961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 625965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 625969 */     // MIs[3] src0
     /* 625969 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 625974 */     // MIs[3] src1
     /* 625974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 625979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 625981 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 625981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 625984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 625986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 625993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 625996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 626000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 626007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626013 */     GIR_RootConstrainSelectedInstOperands,
     /* 626014 */     // GIR_Coverage, 13556,
     /* 626014 */     GIR_EraseRootFromParent_Done,
     /* 626015 */   // Label 7942: @626015
     /* 626015 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(626113), // Rule ID 13557 //
     /* 626020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 626023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 626047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 626063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626067 */     // MIs[3] src1
     /* 626067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 626072 */     // MIs[3] src0
     /* 626072 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 626077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626079 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 626082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 626091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 626098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 626105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626111 */     GIR_RootConstrainSelectedInstOperands,
     /* 626112 */     // GIR_Coverage, 13557,
     /* 626112 */     GIR_EraseRootFromParent_Done,
     /* 626113 */   // Label 7943: @626113
     /* 626113 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(626211), // Rule ID 7897 //
     /* 626118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 626121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626165 */     // MIs[3] src0
     /* 626165 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626170 */     // MIs[3] src1
     /* 626170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626177 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 626180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 626189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 626196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626209 */     GIR_RootConstrainSelectedInstOperands,
     /* 626210 */     // GIR_Coverage, 7897,
     /* 626210 */     GIR_EraseRootFromParent_Done,
     /* 626211 */   // Label 7944: @626211
     /* 626211 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(626309), // Rule ID 7901 //
     /* 626216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 626219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626263 */     // MIs[3] src0
     /* 626263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626268 */     // MIs[3] src1
     /* 626268 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626275 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 626278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 626287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 626294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626307 */     GIR_RootConstrainSelectedInstOperands,
     /* 626308 */     // GIR_Coverage, 7901,
     /* 626308 */     GIR_EraseRootFromParent_Done,
     /* 626309 */   // Label 7945: @626309
     /* 626309 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(626407), // Rule ID 7905 //
     /* 626314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 626317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626361 */     // MIs[3] src0
     /* 626361 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626366 */     // MIs[3] src1
     /* 626366 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626373 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 626376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 626385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 626392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626405 */     GIR_RootConstrainSelectedInstOperands,
     /* 626406 */     // GIR_Coverage, 7905,
     /* 626406 */     GIR_EraseRootFromParent_Done,
     /* 626407 */   // Label 7946: @626407
     /* 626407 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(626505), // Rule ID 13423 //
     /* 626412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 626415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626447 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626459 */     // MIs[3] src1
     /* 626459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626464 */     // MIs[3] src0
     /* 626464 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626471 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 626474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 626483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 626490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626503 */     GIR_RootConstrainSelectedInstOperands,
     /* 626504 */     // GIR_Coverage, 13423,
     /* 626504 */     GIR_EraseRootFromParent_Done,
     /* 626505 */   // Label 7947: @626505
     /* 626505 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(626603), // Rule ID 13426 //
     /* 626510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 626513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626557 */     // MIs[3] src0
     /* 626557 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626562 */     // MIs[3] src1
     /* 626562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626569 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 626572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 626581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 626588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626601 */     GIR_RootConstrainSelectedInstOperands,
     /* 626602 */     // GIR_Coverage, 13426,
     /* 626602 */     GIR_EraseRootFromParent_Done,
     /* 626603 */   // Label 7948: @626603
     /* 626603 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(626701), // Rule ID 13427 //
     /* 626608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 626611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 626615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626655 */     // MIs[3] src1
     /* 626655 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626660 */     // MIs[3] src0
     /* 626660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626667 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 626670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 626679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 626686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626699 */     GIR_RootConstrainSelectedInstOperands,
     /* 626700 */     // GIR_Coverage, 13427,
     /* 626700 */     GIR_EraseRootFromParent_Done,
     /* 626701 */   // Label 7949: @626701
     /* 626701 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(626799), // Rule ID 13483 //
     /* 626706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 626709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626753 */     // MIs[3] src1
     /* 626753 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626758 */     // MIs[3] src0
     /* 626758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626765 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 626768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 626777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 626784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626797 */     GIR_RootConstrainSelectedInstOperands,
     /* 626798 */     // GIR_Coverage, 13483,
     /* 626798 */     GIR_EraseRootFromParent_Done,
     /* 626799 */   // Label 7950: @626799
     /* 626799 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(626897), // Rule ID 13486 //
     /* 626804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 626807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626851 */     // MIs[3] src0
     /* 626851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626856 */     // MIs[3] src1
     /* 626856 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626863 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 626866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 626875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 626882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626895 */     GIR_RootConstrainSelectedInstOperands,
     /* 626896 */     // GIR_Coverage, 13486,
     /* 626896 */     GIR_EraseRootFromParent_Done,
     /* 626897 */   // Label 7951: @626897
     /* 626897 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(626995), // Rule ID 13487 //
     /* 626902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 626905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 626909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 626913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 626921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 626925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 626929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 626933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 626937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 626941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 626945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 626949 */     // MIs[3] src1
     /* 626949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 626954 */     // MIs[3] src0
     /* 626954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 626959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 626961 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 626961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 626964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 626966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 626973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 626980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 626987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 626993 */     GIR_RootConstrainSelectedInstOperands,
     /* 626994 */     // GIR_Coverage, 13487,
     /* 626994 */     GIR_EraseRootFromParent_Done,
     /* 626995 */   // Label 7952: @626995
     /* 626995 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(627093), // Rule ID 13543 //
     /* 627000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 627003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 627043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627047 */     // MIs[3] src1
     /* 627047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627052 */     // MIs[3] src0
     /* 627052 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627059 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 627062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 627071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 627078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 627085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627091 */     GIR_RootConstrainSelectedInstOperands,
     /* 627092 */     // GIR_Coverage, 13543,
     /* 627092 */     GIR_EraseRootFromParent_Done,
     /* 627093 */   // Label 7953: @627093
     /* 627093 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(627191), // Rule ID 13546 //
     /* 627098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 627101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 627141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627145 */     // MIs[3] src0
     /* 627145 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627150 */     // MIs[3] src1
     /* 627150 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627157 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 627160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 627169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 627176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 627183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627189 */     GIR_RootConstrainSelectedInstOperands,
     /* 627190 */     // GIR_Coverage, 13546,
     /* 627190 */     GIR_EraseRootFromParent_Done,
     /* 627191 */   // Label 7954: @627191
     /* 627191 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(627289), // Rule ID 13547 //
     /* 627196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 627199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 627239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627243 */     // MIs[3] src1
     /* 627243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627248 */     // MIs[3] src0
     /* 627248 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627255 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 627258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 627267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 627274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 627281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627287 */     GIR_RootConstrainSelectedInstOperands,
     /* 627288 */     // GIR_Coverage, 13547,
     /* 627288 */     GIR_EraseRootFromParent_Done,
     /* 627289 */   // Label 7955: @627289
     /* 627289 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(627387), // Rule ID 13424 //
     /* 627294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 627297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 627337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627341 */     // MIs[3] src0
     /* 627341 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627346 */     // MIs[3] src1
     /* 627346 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627353 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 627356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 627365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 627372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 627379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627385 */     GIR_RootConstrainSelectedInstOperands,
     /* 627386 */     // GIR_Coverage, 13424,
     /* 627386 */     GIR_EraseRootFromParent_Done,
     /* 627387 */   // Label 7956: @627387
     /* 627387 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(627485), // Rule ID 13425 //
     /* 627392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 627395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 627435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627439 */     // MIs[3] src1
     /* 627439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627444 */     // MIs[3] src0
     /* 627444 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627451 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 627454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 627463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 627470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 627477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627483 */     GIR_RootConstrainSelectedInstOperands,
     /* 627484 */     // GIR_Coverage, 13425,
     /* 627484 */     GIR_EraseRootFromParent_Done,
     /* 627485 */   // Label 7957: @627485
     /* 627485 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(627583), // Rule ID 13428 //
     /* 627490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 627493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 627533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627537 */     // MIs[3] src0
     /* 627537 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627542 */     // MIs[3] src1
     /* 627542 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627549 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 627552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 627561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 627568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 627575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627581 */     GIR_RootConstrainSelectedInstOperands,
     /* 627582 */     // GIR_Coverage, 13428,
     /* 627582 */     GIR_EraseRootFromParent_Done,
     /* 627583 */   // Label 7958: @627583
     /* 627583 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(627681), // Rule ID 13429 //
     /* 627588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 627591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 627595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 627631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627635 */     // MIs[3] src1
     /* 627635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627640 */     // MIs[3] src0
     /* 627640 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627647 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 627650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 627659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 627666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 627673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627679 */     GIR_RootConstrainSelectedInstOperands,
     /* 627680 */     // GIR_Coverage, 13429,
     /* 627680 */     GIR_EraseRootFromParent_Done,
     /* 627681 */   // Label 7959: @627681
     /* 627681 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(627779), // Rule ID 13484 //
     /* 627686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 627689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 627693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 627729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627733 */     // MIs[3] src0
     /* 627733 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627738 */     // MIs[3] src1
     /* 627738 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627745 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 627748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 627757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 627764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 627771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627777 */     GIR_RootConstrainSelectedInstOperands,
     /* 627778 */     // GIR_Coverage, 13484,
     /* 627778 */     GIR_EraseRootFromParent_Done,
     /* 627779 */   // Label 7960: @627779
     /* 627779 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(627877), // Rule ID 13485 //
     /* 627784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 627787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 627791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 627827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627831 */     // MIs[3] src1
     /* 627831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627836 */     // MIs[3] src0
     /* 627836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627843 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 627846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 627855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 627862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 627869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627875 */     GIR_RootConstrainSelectedInstOperands,
     /* 627876 */     // GIR_Coverage, 13485,
     /* 627876 */     GIR_EraseRootFromParent_Done,
     /* 627877 */   // Label 7961: @627877
     /* 627877 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(627975), // Rule ID 13488 //
     /* 627882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 627885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 627889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 627905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 627909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 627917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 627921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 627925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 627929 */     // MIs[3] src0
     /* 627929 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 627934 */     // MIs[3] src1
     /* 627934 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 627939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 627941 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 627941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 627944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 627946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 627953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 627960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 627967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 627973 */     GIR_RootConstrainSelectedInstOperands,
     /* 627974 */     // GIR_Coverage, 13488,
     /* 627974 */     GIR_EraseRootFromParent_Done,
     /* 627975 */   // Label 7962: @627975
     /* 627975 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(628073), // Rule ID 13489 //
     /* 627980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 627983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 627987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 627991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 627995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 627999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 628003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 628007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 628015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 628019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 628023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628027 */     // MIs[3] src1
     /* 628027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 628032 */     // MIs[3] src0
     /* 628032 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 628037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628039 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrcT_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 628039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 628042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 628051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 628058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 628065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628071 */     GIR_RootConstrainSelectedInstOperands,
     /* 628072 */     // GIR_Coverage, 13489,
     /* 628072 */     GIR_EraseRootFromParent_Done,
     /* 628073 */   // Label 7963: @628073
     /* 628073 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(628171), // Rule ID 13544 //
     /* 628078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 628081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 628097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 628101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 628105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 628113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 628117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 628121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628125 */     // MIs[3] src0
     /* 628125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 628130 */     // MIs[3] src1
     /* 628130 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 628135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628137 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 628137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 628140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 628149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 628156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 628163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628169 */     GIR_RootConstrainSelectedInstOperands,
     /* 628170 */     // GIR_Coverage, 13544,
     /* 628170 */     GIR_EraseRootFromParent_Done,
     /* 628171 */   // Label 7964: @628171
     /* 628171 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(628269), // Rule ID 13545 //
     /* 628176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 628179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 628195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 628199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 628203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 628211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 628215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 628219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628223 */     // MIs[3] src1
     /* 628223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 628228 */     // MIs[3] src0
     /* 628228 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 628233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628235 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 628235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 628238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 628247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 628254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 628261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628267 */     GIR_RootConstrainSelectedInstOperands,
     /* 628268 */     // GIR_Coverage, 13545,
     /* 628268 */     GIR_EraseRootFromParent_Done,
     /* 628269 */   // Label 7965: @628269
     /* 628269 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(628367), // Rule ID 13548 //
     /* 628274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 628277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 628293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 628297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 628301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 628309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 628313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 628317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628321 */     // MIs[3] src0
     /* 628321 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 628326 */     // MIs[3] src1
     /* 628326 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 628331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628333 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 628333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 628336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 628345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 628352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 628359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628365 */     GIR_RootConstrainSelectedInstOperands,
     /* 628366 */     // GIR_Coverage, 13548,
     /* 628366 */     GIR_EraseRootFromParent_Done,
     /* 628367 */   // Label 7966: @628367
     /* 628367 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(628465), // Rule ID 13549 //
     /* 628372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 628375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 628391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 628395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 628399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 628407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
     /* 628411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 628415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628419 */     // MIs[3] src1
     /* 628419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 628424 */     // MIs[3] src0
     /* 628424 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 628429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628431 */     // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
     /* 628431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 628434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 628443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 628450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 628457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628463 */     GIR_RootConstrainSelectedInstOperands,
     /* 628464 */     // GIR_Coverage, 13549,
     /* 628464 */     GIR_EraseRootFromParent_Done,
     /* 628465 */   // Label 7967: @628465
     /* 628465 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(628521), // Rule ID 893 //
     /* 628470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 628473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 628477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 628484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 628491 */     // (umax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
     /* 628491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_t16_e64),
     /* 628494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 628501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 628506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 628511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 628516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 628519 */     GIR_RootConstrainSelectedInstOperands,
     /* 628520 */     // GIR_Coverage, 893,
     /* 628520 */     GIR_EraseRootFromParent_Done,
     /* 628521 */   // Label 7968: @628521
     /* 628521 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(628544), // Rule ID 892 //
     /* 628526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 628529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628533 */     // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 628533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
     /* 628538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 628542 */     GIR_RootConstrainSelectedInstOperands,
     /* 628543 */     // GIR_Coverage, 892,
     /* 628543 */     GIR_Done,
     /* 628544 */   // Label 7969: @628544
     /* 628544 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(628567), // Rule ID 894 //
     /* 628549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 628552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628556 */     // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
     /* 628556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_fake16_e64),
     /* 628561 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 628565 */     GIR_RootConstrainSelectedInstOperands,
     /* 628566 */     // GIR_Coverage, 894,
     /* 628566 */     GIR_Done,
     /* 628567 */   // Label 7970: @628567
     /* 628567 */   GIM_Reject,
     /* 628568 */ // Label 7919: @628568
     /* 628568 */ GIM_Reject,
     /* 628569 */ // Label 7916: @628569
     /* 628569 */ GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(630013),
     /* 628574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 628577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 628580 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(628660), // Rule ID 11413 //
     /* 628585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 628601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 628605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 628609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 628617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 628621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 628625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628629 */     // MIs[3] src0
     /* 628629 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 628634 */     // MIs[3] src1
     /* 628634 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 628639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628641 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 628641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 628644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 628650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 628654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 628658 */     GIR_RootConstrainSelectedInstOperands,
     /* 628659 */     // GIR_Coverage, 11413,
     /* 628659 */     GIR_EraseRootFromParent_Done,
     /* 628660 */   // Label 7972: @628660
     /* 628660 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(628740), // Rule ID 11414 //
     /* 628665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 628681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 628685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 628689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 628697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 628701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 628705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628709 */     // MIs[3] src1
     /* 628709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 628714 */     // MIs[3] src0
     /* 628714 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 628719 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628721 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 628721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 628724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 628730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 628734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 628738 */     GIR_RootConstrainSelectedInstOperands,
     /* 628739 */     // GIR_Coverage, 11414,
     /* 628739 */     GIR_EraseRootFromParent_Done,
     /* 628740 */   // Label 7973: @628740
     /* 628740 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(628820), // Rule ID 11415 //
     /* 628745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 628761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 628765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 628769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 628777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 628781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 628785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628789 */     // MIs[3] src0
     /* 628789 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 628794 */     // MIs[3] src1
     /* 628794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 628799 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628801 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 628801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 628804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 628810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 628814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 628818 */     GIR_RootConstrainSelectedInstOperands,
     /* 628819 */     // GIR_Coverage, 11415,
     /* 628819 */     GIR_EraseRootFromParent_Done,
     /* 628820 */   // Label 7974: @628820
     /* 628820 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(628900), // Rule ID 11416 //
     /* 628825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 628841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 628845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 628849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 628857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 628861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 628865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628869 */     // MIs[3] src1
     /* 628869 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 628874 */     // MIs[3] src0
     /* 628874 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 628879 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628881 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 628881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 628884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 628890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 628894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 628898 */     GIR_RootConstrainSelectedInstOperands,
     /* 628899 */     // GIR_Coverage, 11416,
     /* 628899 */     GIR_EraseRootFromParent_Done,
     /* 628900 */   // Label 7975: @628900
     /* 628900 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(628980), // Rule ID 11417 //
     /* 628905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 628921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 628925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 628929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 628933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 628937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 628941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 628945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628949 */     // MIs[3] src0
     /* 628949 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 628954 */     // MIs[3] src1
     /* 628954 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 628959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 628961 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 628961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 628964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 628966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 628970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 628974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 628978 */     GIR_RootConstrainSelectedInstOperands,
     /* 628979 */     // GIR_Coverage, 11417,
     /* 628979 */     GIR_EraseRootFromParent_Done,
     /* 628980 */   // Label 7976: @628980
     /* 628980 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(629060), // Rule ID 11418 //
     /* 628985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 628989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 628993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 628997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 629009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 629025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629029 */     // MIs[3] src1
     /* 629029 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 629034 */     // MIs[3] src0
     /* 629034 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 629039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629041 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 629050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
     /* 629054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 629058 */     GIR_RootConstrainSelectedInstOperands,
     /* 629059 */     // GIR_Coverage, 11418,
     /* 629059 */     GIR_EraseRootFromParent_Done,
     /* 629060 */   // Label 7977: @629060
     /* 629060 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(629140), // Rule ID 11419 //
     /* 629065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 629089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 629105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629109 */     // MIs[3] src0
     /* 629109 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 629114 */     // MIs[3] src1
     /* 629114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 629119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629121 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 629130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 629134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 629138 */     GIR_RootConstrainSelectedInstOperands,
     /* 629139 */     // GIR_Coverage, 11419,
     /* 629139 */     GIR_EraseRootFromParent_Done,
     /* 629140 */   // Label 7978: @629140
     /* 629140 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(629220), // Rule ID 11420 //
     /* 629145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 629169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629177 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 629185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629189 */     // MIs[3] src1
     /* 629189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /* 629194 */     // MIs[3] src0
     /* 629194 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /* 629199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629201 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
     /* 629210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /* 629214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /* 629218 */     GIR_RootConstrainSelectedInstOperands,
     /* 629219 */     // GIR_Coverage, 11420,
     /* 629219 */     GIR_EraseRootFromParent_Done,
     /* 629220 */   // Label 7979: @629220
     /* 629220 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(629300), // Rule ID 7714 //
     /* 629225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 629265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629269 */     // MIs[3] src0
     /* 629269 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629274 */     // MIs[3] src1
     /* 629274 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629281 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 629290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 629294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 629298 */     GIR_RootConstrainSelectedInstOperands,
     /* 629299 */     // GIR_Coverage, 7714,
     /* 629299 */     GIR_EraseRootFromParent_Done,
     /* 629300 */   // Label 7980: @629300
     /* 629300 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(629380), // Rule ID 11406 //
     /* 629305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 629345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629349 */     // MIs[3] src1
     /* 629349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629354 */     // MIs[3] src0
     /* 629354 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629361 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 629370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 629374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 629378 */     GIR_RootConstrainSelectedInstOperands,
     /* 629379 */     // GIR_Coverage, 11406,
     /* 629379 */     GIR_EraseRootFromParent_Done,
     /* 629380 */   // Label 7981: @629380
     /* 629380 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(629460), // Rule ID 11409 //
     /* 629385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 629425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629429 */     // MIs[3] src0
     /* 629429 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629434 */     // MIs[3] src1
     /* 629434 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629441 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 629450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 629454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 629458 */     GIR_RootConstrainSelectedInstOperands,
     /* 629459 */     // GIR_Coverage, 11409,
     /* 629459 */     GIR_EraseRootFromParent_Done,
     /* 629460 */   // Label 7982: @629460
     /* 629460 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(629540), // Rule ID 11410 //
     /* 629465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 629505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629509 */     // MIs[3] src1
     /* 629509 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629514 */     // MIs[3] src0
     /* 629514 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629521 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 629530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 629534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /* 629538 */     GIR_RootConstrainSelectedInstOperands,
     /* 629539 */     // GIR_Coverage, 11410,
     /* 629539 */     GIR_EraseRootFromParent_Done,
     /* 629540 */   // Label 7983: @629540
     /* 629540 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(629620), // Rule ID 11407 //
     /* 629545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 629585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629589 */     // MIs[3] src0
     /* 629589 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629594 */     // MIs[3] src1
     /* 629594 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629601 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 629610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 629614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 629618 */     GIR_RootConstrainSelectedInstOperands,
     /* 629619 */     // GIR_Coverage, 11407,
     /* 629619 */     GIR_EraseRootFromParent_Done,
     /* 629620 */   // Label 7984: @629620
     /* 629620 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(629700), // Rule ID 11408 //
     /* 629625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 629665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629669 */     // MIs[3] src1
     /* 629669 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629674 */     // MIs[3] src0
     /* 629674 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629681 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 629690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 629694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 629698 */     GIR_RootConstrainSelectedInstOperands,
     /* 629699 */     // GIR_Coverage, 11408,
     /* 629699 */     GIR_EraseRootFromParent_Done,
     /* 629700 */   // Label 7985: @629700
     /* 629700 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(629780), // Rule ID 11411 //
     /* 629705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 629745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629749 */     // MIs[3] src0
     /* 629749 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629754 */     // MIs[3] src1
     /* 629754 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629761 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 629770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 629774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 629778 */     GIR_RootConstrainSelectedInstOperands,
     /* 629779 */     // GIR_Coverage, 11411,
     /* 629779 */     GIR_EraseRootFromParent_Done,
     /* 629780 */   // Label 7986: @629780
     /* 629780 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(629860), // Rule ID 11412 //
     /* 629785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 629809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 629817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 629821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 629825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
     /* 629829 */     // MIs[3] src1
     /* 629829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 629834 */     // MIs[3] src0
     /* 629834 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 629839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 629841 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 629844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
     /* 629850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 629854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /* 629858 */     GIR_RootConstrainSelectedInstOperands,
     /* 629859 */     // GIR_Coverage, 11412,
     /* 629859 */     GIR_EraseRootFromParent_Done,
     /* 629860 */   // Label 7987: @629860
     /* 629860 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(629913), // Rule ID 7848 //
     /* 629865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 629868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 629876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629888 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 629890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35124),
     /* 629894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 629896 */     // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_35124>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
     /* 629899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 629905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 629909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 629911 */     GIR_RootConstrainSelectedInstOperands,
     /* 629912 */     // GIR_Coverage, 7848,
     /* 629912 */     GIR_EraseRootFromParent_Done,
     /* 629913 */   // Label 7988: @629913
     /* 629913 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(629966), // Rule ID 13374 //
     /* 629918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
     /* 629921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 629925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 629929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
     /* 629933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 629937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 629941 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 629943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_35124),
     /* 629947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 629949 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>)<<P:Predicate_anonymous_35124>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
     /* 629949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
     /* 629952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 629954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 629958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 629962 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 629964 */     GIR_RootConstrainSelectedInstOperands,
     /* 629965 */     // GIR_Coverage, 13374,
     /* 629965 */     GIR_EraseRootFromParent_Done,
     /* 629966 */   // Label 7989: @629966
     /* 629966 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(629992), // Rule ID 50 //
     /* 629971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 629975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13729),
     /* 629979 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13729>>  =>  (S_MAX_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 629979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_U32),
     /* 629984 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 629990 */     GIR_RootConstrainSelectedInstOperands,
     /* 629991 */     // GIR_Coverage, 50,
     /* 629991 */     GIR_Done,
     /* 629992 */   // Label 7990: @629992
     /* 629992 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(630012), // Rule ID 808 //
     /* 629997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630001 */     // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 630001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U32_e64),
     /* 630006 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 630010 */     GIR_RootConstrainSelectedInstOperands,
     /* 630011 */     // GIR_Coverage, 808,
     /* 630011 */     GIR_Done,
     /* 630012 */   // Label 7991: @630012
     /* 630012 */   GIM_Reject,
     /* 630013 */ // Label 7971: @630013
     /* 630013 */ GIM_Reject,
     /* 630014 */ // Label 7917: @630014
     /* 630014 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(630085), // Rule ID 1104 //
     /* 630019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 630022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 630025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630036 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 630043 */   // (umax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
     /* 630043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_U16),
     /* 630046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 630053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 630063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 630068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630083 */   GIR_RootConstrainSelectedInstOperands,
     /* 630084 */   // GIR_Coverage, 1104,
     /* 630084 */   GIR_EraseRootFromParent_Done,
     /* 630085 */ // Label 7992: @630085
     /* 630085 */ GIM_Reject,
     /* 630086 */ // Label 7918: @630086
     /* 630086 */ GIM_Reject,
     /* 630087 */ // Label 92: @630087
     /* 630087 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(630223),
     /* 630092 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 630095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630098 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(630147), // Rule ID 7572 //
     /* 630103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
     /* 630106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34912),
     /* 630114 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_34912>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
     /* 630114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 630117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e32),
     /* 630121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 630129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 630133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 630135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 630138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 630143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 630145 */     GIR_RootConstrainSelectedInstOperands,
     /* 630146 */     // GIR_Coverage, 7572,
     /* 630146 */     GIR_EraseRootFromParent_Done,
     /* 630147 */   // Label 7994: @630147
     /* 630147 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(630173), // Rule ID 23 //
     /* 630152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630156 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13711),
     /* 630160 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13711>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 630160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
     /* 630165 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 630171 */     GIR_RootConstrainSelectedInstOperands,
     /* 630172 */     // GIR_Coverage, 23,
     /* 630172 */     GIR_Done,
     /* 630173 */   // Label 7995: @630173
     /* 630173 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(630222), // Rule ID 7571 //
     /* 630178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34912),
     /* 630186 */     // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_34912>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_CO_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
     /* 630186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 630189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e32),
     /* 630193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 630201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 630205 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::VCC*/0,
     /* 630208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 630210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
     /* 630213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 630218 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 630220 */     GIR_RootConstrainSelectedInstOperands,
     /* 630221 */     // GIR_Coverage, 7571,
     /* 630221 */     GIR_EraseRootFromParent_Done,
     /* 630222 */   // Label 7996: @630222
     /* 630222 */   GIM_Reject,
     /* 630223 */ // Label 7993: @630223
     /* 630223 */ GIM_Reject,
     /* 630224 */ // Label 93: @630224
     /* 630224 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(630257),
     /* 630229 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 630232 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(630244), // Rule ID 179 //
     /* 630237 */     // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH (bb:{ *:[Other] }):$simm16)
     /* 630237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH),
     /* 630242 */     GIR_RootConstrainSelectedInstOperands,
     /* 630243 */     // GIR_Coverage, 179,
     /* 630243 */     GIR_Done,
     /* 630244 */   // Label 7998: @630244
     /* 630244 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(630256), // Rule ID 180 //
     /* 630249 */     // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH_pad_s_nop (bb:{ *:[Other] }):$simm16)
     /* 630249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH_pad_s_nop),
     /* 630254 */     GIR_RootConstrainSelectedInstOperands,
     /* 630255 */     // GIR_Coverage, 180,
     /* 630255 */     GIR_Done,
     /* 630256 */   // Label 7999: @630256
     /* 630256 */   GIM_Reject,
     /* 630257 */ // Label 7997: @630257
     /* 630257 */ GIM_Reject,
     /* 630258 */ // Label 94: @630258
     /* 630258 */ GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(630356),
     /* 630263 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 630266 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8003*/ GIMT_Encode4(630355),
     /* 630277 */   /*GILLT_s32*//*Label 8001*/ GIMT_Encode4(630285),
     /* 630281 */   /*GILLT_s64*//*Label 8002*/ GIMT_Encode4(630334),
     /* 630285 */   // Label 8001: @630285
     /* 630285 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(630305), // Rule ID 10 //
     /* 630290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630294 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13706),
     /* 630298 */     // (cttz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13706>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 630298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
     /* 630303 */     GIR_RootConstrainSelectedInstOperands,
     /* 630304 */     // GIR_Coverage, 10,
     /* 630304 */     GIR_Done,
     /* 630305 */   // Label 8004: @630305
     /* 630305 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(630333), // Rule ID 684 //
     /* 630310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630321 */     // (cttz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 630321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
     /* 630324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630331 */     GIR_RootConstrainSelectedInstOperands,
     /* 630332 */     // GIR_Coverage, 684,
     /* 630332 */     GIR_EraseRootFromParent_Done,
     /* 630333 */   // Label 8005: @630333
     /* 630333 */   GIM_Reject,
     /* 630334 */   // Label 8002: @630334
     /* 630334 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(630354), // Rule ID 8 //
     /* 630339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13706),
     /* 630347 */     // (cttz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13706>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 630347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
     /* 630352 */     GIR_RootConstrainSelectedInstOperands,
     /* 630353 */     // GIR_Coverage, 8,
     /* 630353 */     GIR_Done,
     /* 630354 */   // Label 8006: @630354
     /* 630354 */   GIM_Reject,
     /* 630355 */   // Label 8003: @630355
     /* 630355 */   GIM_Reject,
     /* 630356 */ // Label 8000: @630356
     /* 630356 */ GIM_Reject,
     /* 630357 */ // Label 95: @630357
     /* 630357 */ GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(630458),
     /* 630362 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 630365 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8010*/ GIMT_Encode4(630426),
     /* 630376 */   /*GILLT_s32*//*Label 8008*/ GIMT_Encode4(630384),
     /* 630380 */   /*GILLT_s64*//*Label 8009*/ GIMT_Encode4(630405),
     /* 630384 */   // Label 8008: @630384
     /* 630384 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(630404), // Rule ID 12 //
     /* 630389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13707),
     /* 630397 */     // (ctlz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13707>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 630397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
     /* 630402 */     GIR_RootConstrainSelectedInstOperands,
     /* 630403 */     // GIR_Coverage, 12,
     /* 630403 */     GIR_Done,
     /* 630404 */   // Label 8011: @630404
     /* 630404 */   GIM_Reject,
     /* 630405 */   // Label 8009: @630405
     /* 630405 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(630425), // Rule ID 14 //
     /* 630410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13707),
     /* 630418 */     // (ctlz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13707>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 630418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
     /* 630423 */     GIR_RootConstrainSelectedInstOperands,
     /* 630424 */     // GIR_Coverage, 14,
     /* 630424 */     GIR_Done,
     /* 630425 */   // Label 8012: @630425
     /* 630425 */   GIM_Reject,
     /* 630426 */   // Label 8010: @630426
     /* 630426 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(630457), // Rule ID 682 //
     /* 630431 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 630445 */     // (ctlz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 630445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
     /* 630448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 630455 */     GIR_RootConstrainSelectedInstOperands,
     /* 630456 */     // GIR_Coverage, 682,
     /* 630456 */     GIR_EraseRootFromParent_Done,
     /* 630457 */   // Label 8013: @630457
     /* 630457 */   GIM_Reject,
     /* 630458 */ // Label 8007: @630458
     /* 630458 */ GIM_Reject,
     /* 630459 */ // Label 96: @630459
     /* 630459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8016*/ GIMT_Encode4(630673),
     /* 630470 */ /*GILLT_s32*//*Label 8014*/ GIMT_Encode4(630478),
     /* 630474 */ /*GILLT_s64*//*Label 8015*/ GIMT_Encode4(630565),
     /* 630478 */ // Label 8014: @630478
     /* 630478 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(630507), // Rule ID 6 //
     /* 630483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630490 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13705),
     /* 630494 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13705>>  =>  (S_BCNT1_I32_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
     /* 630494 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B32),
     /* 630499 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 630505 */   GIR_RootConstrainSelectedInstOperands,
     /* 630506 */   // GIR_Coverage, 6,
     /* 630506 */   GIR_Done,
     /* 630507 */ // Label 8017: @630507
     /* 630507 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(630536), // Rule ID 7 //
     /* 630512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 630515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630519 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13705),
     /* 630523 */   // (ctpop:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13705>>  =>  (S_BCNT1_I32_B64:{ *:[i32] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
     /* 630523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
     /* 630528 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
     /* 630534 */   GIR_RootConstrainSelectedInstOperands,
     /* 630535 */   // GIR_Coverage, 7,
     /* 630535 */   GIR_Done,
     /* 630536 */ // Label 8018: @630536
     /* 630536 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(630564), // Rule ID 7033 //
     /* 630541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630548 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34197),
     /* 630552 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_34197>>  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$popcnt, 0:{ *:[i32] })
     /* 630552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
     /* 630555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630557 */   GIR_RootToRootCopy, /*OpIdx*/1, // popcnt
     /* 630559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630562 */   GIR_RootConstrainSelectedInstOperands,
     /* 630563 */   // GIR_Coverage, 7033,
     /* 630563 */   GIR_EraseRootFromParent_Done,
     /* 630564 */ // Label 8019: @630564
     /* 630564 */ GIM_Reject,
     /* 630565 */ // Label 8015: @630565
     /* 630565 */ GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(630672), // Rule ID 1868 //
     /* 630570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 630573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 630577 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13705),
     /* 630581 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$src)<<P:Predicate_anonymous_13705>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_BCNT1_I32_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i64] }:$src), SReg_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
     /* 630581 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 630584 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 630588 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630593 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 630596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 630598 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 630601 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
     /* 630605 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630610 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 630614 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
     /* 630617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 630619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 630622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 630626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630631 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 630634 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 630639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 630642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 630644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 630647 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 630650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 630653 */   GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 630656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 630661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
     /* 630666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
     /* 630671 */   // GIR_Coverage, 1868,
     /* 630671 */   GIR_EraseRootFromParent_Done,
     /* 630672 */ // Label 8020: @630672
     /* 630672 */ GIM_Reject,
     /* 630673 */ // Label 8016: @630673
     /* 630673 */ GIM_Reject,
     /* 630674 */ // Label 97: @630674
     /* 630674 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 8025*/ GIMT_Encode4(632422),
     /* 630685 */ /*GILLT_s16*//*Label 8021*/ GIMT_Encode4(630701),
     /* 630689 */ /*GILLT_s32*//*Label 8022*/ GIMT_Encode4(630913),
     /* 630693 */ /*GILLT_s64*//*Label 8023*/ GIMT_Encode4(631200),
     /* 630697 */ /*GILLT_v2s16*//*Label 8024*/ GIMT_Encode4(632367),
     /* 630701 */ // Label 8021: @630701
     /* 630701 */ GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(630912),
     /* 630706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 630709 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(630760), // Rule ID 7593 //
     /* 630714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
     /* 630717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630721 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 630721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 630724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 630728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630733 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 630743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 630745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 630748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630753 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 630755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 630758 */     GIR_RootConstrainSelectedInstOperands,
     /* 630759 */     // GIR_Coverage, 7593,
     /* 630759 */     GIR_EraseRootFromParent_Done,
     /* 630760 */   // Label 8027: @630760
     /* 630760 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(630811), // Rule ID 7595 //
     /* 630765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
     /* 630768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630772 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
     /* 630772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 630775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 630779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630784 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
     /* 630794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 630796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 630799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630804 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 630806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 630809 */     GIR_RootConstrainSelectedInstOperands,
     /* 630810 */     // GIR_Coverage, 7595,
     /* 630810 */     GIR_EraseRootFromParent_Done,
     /* 630811 */   // Label 8028: @630811
     /* 630811 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(630911), // Rule ID 7597 //
     /* 630816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX8Plus),
     /* 630819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 630823 */     // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i16] } (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (COPY:{ *:[i16] } VGPR_16:{ *:[i16] }:$a), (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] })), lo16:{ *:[i32] })
     /* 630823 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 630826 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 630830 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630835 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(202113025),
     /* 630845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 630847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 630850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 630854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 630863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 630865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 630868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 630872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 630880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 630883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 630886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 630888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 630891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 630893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::lo16),
     /* 630900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 630905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630910 */     // GIR_Coverage, 7597,
     /* 630910 */     GIR_EraseRootFromParent_Done,
     /* 630911 */   // Label 8029: @630911
     /* 630911 */   GIM_Reject,
     /* 630912 */ // Label 8026: @630912
     /* 630912 */ GIM_Reject,
     /* 630913 */ // Label 8022: @630913
     /* 630913 */ GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(631199),
     /* 630918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 630921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 630925 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(630972), // Rule ID 7591 //
     /* 630930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 630933 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] }))
     /* 630933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 630936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 630940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630945 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(66051),
     /* 630955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 630957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 630960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 630962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 630965 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 630967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 630970 */     GIR_RootConstrainSelectedInstOperands,
     /* 630971 */     // GIR_Coverage, 7591,
     /* 630971 */     GIR_EraseRootFromParent_Done,
     /* 630972 */   // Label 8031: @630972
     /* 630972 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(631070), // Rule ID 7587 //
     /* 630977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 630980 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_BFI_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 8:{ *:[i32] }))
     /* 630980 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 630983 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 630987 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 630992 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 630996 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 631000 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/8,
     /* 631003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 631005 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 631008 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 631012 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631017 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 631021 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 631025 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 631028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 631030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631042 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(16711935),
     /* 631052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 631057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 631065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 631068 */     GIR_RootConstrainSelectedInstOperands,
     /* 631069 */     // GIR_Coverage, 7587,
     /* 631069 */     GIR_EraseRootFromParent_Done,
     /* 631070 */   // Label 8032: @631070
     /* 631070 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(631198), // Rule ID 7588 //
     /* 631075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 631078 */     // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_BFI_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }))
     /* 631078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 631081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 631085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631090 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 631093 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 631097 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 631100 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 631104 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 631107 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/8,
     /* 631110 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 631113 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 631116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 631118 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 631121 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 631125 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631130 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 631133 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 631137 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 631140 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 631144 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 631147 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 631150 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 631153 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 631156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 631158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631170 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(16711935),
     /* 631180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 631185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 631187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 631193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 631196 */     GIR_RootConstrainSelectedInstOperands,
     /* 631197 */     // GIR_Coverage, 7588,
     /* 631197 */     GIR_EraseRootFromParent_Done,
     /* 631198 */   // Label 8033: @631198
     /* 631198 */   GIM_Reject,
     /* 631199 */ // Label 8030: @631199
     /* 631199 */ GIM_Reject,
     /* 631200 */ // Label 8023: @631200
     /* 631200 */ GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(632366),
     /* 631205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 631208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631212 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(631403), // Rule ID 7592 //
     /* 631217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 631220 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub0:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub1:{ *:[i32] })
     /* 631220 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 631223 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631227 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631232 */     GIR_AddImm, /*InsnID*/6, /*Imm*/GIMT_Encode8(66051),
     /* 631242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 631244 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 631247 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631251 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631256 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631262 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631267 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631272 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 631275 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 631279 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631284 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 631287 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 631290 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/5,
     /* 631293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 631295 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 631298 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631302 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631307 */     GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(66051),
     /* 631317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 631319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 631322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631331 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 631337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 631354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 631362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 631365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 631368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 631373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 631375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631378 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 631381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 631384 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 631387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631402 */     // GIR_Coverage, 7592,
     /* 631402 */     GIR_EraseRootFromParent_Done,
     /* 631403 */   // Label 8035: @631403
     /* 631403 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(631854), // Rule ID 7589 //
     /* 631408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 631411 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 8:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 8:{ *:[i32] })), sub1:{ *:[i32] })
     /* 631411 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 631414 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631418 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631423 */     GIR_CopySubReg, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631429 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631434 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631439 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 631442 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631446 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631451 */     GIR_CopySubReg, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631457 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631462 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631467 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s16,
     /* 631470 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 631474 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631479 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 631482 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 631485 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/8,
     /* 631488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 631490 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 631493 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631497 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631502 */     GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631508 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631513 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631518 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 631521 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631525 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631530 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631536 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631541 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631546 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s16,
     /* 631549 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 631553 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631558 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 631561 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 631564 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/24,
     /* 631567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 631569 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s16,
     /* 631572 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631576 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631581 */     GIR_AddImm, /*InsnID*/10, /*Imm*/GIMT_Encode8(16711935),
     /* 631591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 631593 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 631596 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 631600 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631605 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 631608 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 631611 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 631614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 631616 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 631619 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631623 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631628 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 631634 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631639 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631644 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 631647 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631651 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631656 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 631662 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631667 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631672 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 631675 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 631679 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631684 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 631687 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/7,
     /* 631690 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/8,
     /* 631693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 631695 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 631698 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631702 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631707 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 631713 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631718 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631723 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 631726 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631730 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631735 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 631741 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631746 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631751 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 631754 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
     /* 631758 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631763 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 631766 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 631769 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 631772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 631774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 631777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 631781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631786 */     GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(16711935),
     /* 631796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 631798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 631801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 631805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 631813 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 631816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 631819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 631821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 631824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 631826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 631829 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 631832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 631835 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 631838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631853 */     // GIR_Coverage, 7589,
     /* 631853 */     GIR_EraseRootFromParent_Done,
     /* 631854 */   // Label 8036: @631854
     /* 631854 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(632365), // Rule ID 7590 //
     /* 631859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 631862 */     // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, 24:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] }), (V_ALIGNBIT_B32_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 0:{ *:[i32] }, 8:{ *:[i32] }, 0:{ *:[i1] }, 0:{ *:[i32] })), sub1:{ *:[i32] })
     /* 631862 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 631865 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631869 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631874 */     GIR_CopySubReg, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631880 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631885 */     GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631890 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 631893 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631897 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631902 */     GIR_CopySubReg, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631908 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631913 */     GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631918 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s16,
     /* 631921 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 631925 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631930 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 631933 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 631936 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 631939 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 631942 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 631945 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/8,
     /* 631948 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 631951 */     GIR_AddImm8, /*InsnID*/14, /*Imm*/0,
     /* 631954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 631956 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 631959 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631963 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631968 */     GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 631974 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 631979 */     GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 631984 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 631987 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 631991 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 631996 */     GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 632002 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632007 */     GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632012 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s16,
     /* 632015 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 632019 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632024 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 632027 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 632030 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 632033 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 632036 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 632039 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/24,
     /* 632042 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 632045 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/0,
     /* 632048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 632050 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s16,
     /* 632053 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 632057 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632062 */     GIR_AddImm, /*InsnID*/10, /*Imm*/GIMT_Encode8(16711935),
     /* 632072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 632074 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
     /* 632077 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 632081 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632086 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 632089 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 632092 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 632095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 632097 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 632100 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 632104 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632109 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 632115 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632120 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632125 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 632128 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 632132 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632137 */     GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 632143 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632148 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632153 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
     /* 632156 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 632160 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632165 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 632168 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 632171 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 632174 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/7,
     /* 632177 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 632180 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/8,
     /* 632183 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 632186 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 632189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 632191 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 632194 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 632198 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632203 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 632209 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632214 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632219 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 632222 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 632226 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632231 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 632237 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632242 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 632250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_fake16_e64),
     /* 632254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632259 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 632262 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 632265 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 632268 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 632271 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 632274 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 632277 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 632280 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 632283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 632285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 632288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 632292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632297 */     GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(16711935),
     /* 632307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 632309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 632312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
     /* 632316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632321 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 632324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 632327 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /* 632330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 632332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 632335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 632337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 632340 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 632343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 632346 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 632349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632364 */     // GIR_Coverage, 7590,
     /* 632364 */     GIR_EraseRootFromParent_Done,
     /* 632365 */   // Label 8037: @632365
     /* 632365 */   GIM_Reject,
     /* 632366 */ // Label 8034: @632366
     /* 632366 */ GIM_Reject,
     /* 632367 */ // Label 8024: @632367
     /* 632367 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(632421), // Rule ID 7599 //
     /* 632372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
     /* 632375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 632378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632382 */   // (bswap:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$a, (S_MOV_B32:{ *:[i16] } 33751041:{ *:[i32] }))
     /* 632382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 632385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 632389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632394 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(33751041),
     /* 632404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 632406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
     /* 632409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632414 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 632416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 632419 */   GIR_RootConstrainSelectedInstOperands,
     /* 632420 */   // GIR_Coverage, 7599,
     /* 632420 */   GIR_EraseRootFromParent_Done,
     /* 632421 */ // Label 8038: @632421
     /* 632421 */ GIM_Reject,
     /* 632422 */ // Label 8025: @632422
     /* 632422 */ GIM_Reject,
     /* 632423 */ // Label 98: @632423
     /* 632423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8041*/ GIMT_Encode4(632670),
     /* 632434 */ /*GILLT_s32*//*Label 8039*/ GIMT_Encode4(632442),
     /* 632438 */ /*GILLT_s64*//*Label 8040*/ GIMT_Encode4(632504),
     /* 632442 */ // Label 8039: @632442
     /* 632442 */ GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(632503),
     /* 632447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 632450 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(632470), // Rule ID 4 //
     /* 632455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13704),
     /* 632463 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13704>>  =>  (S_BREV_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 632463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B32),
     /* 632468 */     GIR_RootConstrainSelectedInstOperands,
     /* 632469 */     // GIR_Coverage, 4,
     /* 632469 */     GIR_Done,
     /* 632470 */   // Label 8043: @632470
     /* 632470 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(632502), // Rule ID 681 //
     /* 632475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_18315),
     /* 632483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632490 */     // (bitreverse:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_18315>>  =>  (V_BFREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 632490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 632493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632500 */     GIR_RootConstrainSelectedInstOperands,
     /* 632501 */     // GIR_Coverage, 681,
     /* 632501 */     GIR_EraseRootFromParent_Done,
     /* 632502 */   // Label 8044: @632502
     /* 632502 */   GIM_Reject,
     /* 632503 */ // Label 8042: @632503
     /* 632503 */ GIM_Reject,
     /* 632504 */ // Label 8040: @632504
     /* 632504 */ GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(632669),
     /* 632509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 632512 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(632532), // Rule ID 5 //
     /* 632517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
     /* 632521 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13704),
     /* 632525 */     // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13704>>  =>  (S_BREV_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
     /* 632525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B64),
     /* 632530 */     GIR_RootConstrainSelectedInstOperands,
     /* 632531 */     // GIR_Coverage, 5,
     /* 632531 */     GIR_Done,
     /* 632532 */   // Label 8046: @632532
     /* 632532 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(632668), // Rule ID 7600 //
     /* 632537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_18315),
     /* 632545 */     // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$a)<<P:Predicate_anonymous_18315>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] })), sub1:{ *:[i32] })
     /* 632545 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 632548 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 632552 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632557 */     GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
     /* 632563 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632568 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632573 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 632576 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 632580 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632585 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 632588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 632590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 632593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 632597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632602 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
     /* 632608 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 632621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
     /* 632625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 632630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 632633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 632635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 632638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 632640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 632643 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
     /* 632646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 632649 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
     /* 632652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632667 */     // GIR_Coverage, 7600,
     /* 632667 */     GIR_EraseRootFromParent_Done,
     /* 632668 */   // Label 8047: @632668
     /* 632668 */   GIM_Reject,
     /* 632669 */ // Label 8045: @632669
     /* 632669 */ GIM_Reject,
     /* 632670 */ // Label 8041: @632670
     /* 632670 */ GIM_Reject,
     /* 632671 */ // Label 99: @632671
     /* 632671 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 8051*/ GIMT_Encode4(632998),
     /* 632682 */ /*GILLT_s16*//*Label 8048*/ GIMT_Encode4(632694),
     /* 632686 */ /*GILLT_s32*//*Label 8049*/ GIMT_Encode4(632868),
     /* 632690 */ /*GILLT_s64*//*Label 8050*/ GIMT_Encode4(632948),
     /* 632694 */ // Label 8048: @632694
     /* 632694 */ GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(632867),
     /* 632699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 632702 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(632729), // Rule ID 37 //
     /* 632707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 632710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632714 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13717),
     /* 632718 */     // (fceil:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13717>>  =>  (S_CEIL_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /* 632718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F16),
     /* 632723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 632727 */     GIR_RootConstrainSelectedInstOperands,
     /* 632728 */     // GIR_Coverage, 37,
     /* 632728 */     GIR_Done,
     /* 632729 */   // Label 8053: @632729
     /* 632729 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(632775), // Rule ID 769 //
     /* 632734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 632737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632748 */     // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_e64),
     /* 632751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632773 */     GIR_RootConstrainSelectedInstOperands,
     /* 632774 */     // GIR_Coverage, 769,
     /* 632774 */     GIR_EraseRootFromParent_Done,
     /* 632775 */   // Label 8054: @632775
     /* 632775 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(632821), // Rule ID 771 //
     /* 632780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 632783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632794 */     // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_fake16_e64),
     /* 632797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632819 */     GIR_RootConstrainSelectedInstOperands,
     /* 632820 */     // GIR_Coverage, 771,
     /* 632820 */     GIR_EraseRootFromParent_Done,
     /* 632821 */   // Label 8055: @632821
     /* 632821 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(632866), // Rule ID 770 //
     /* 632826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 632829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 632833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 632840 */     // (fceil:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CEIL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 632840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_t16_e64),
     /* 632843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 632864 */     GIR_RootConstrainSelectedInstOperands,
     /* 632865 */     // GIR_Coverage, 770,
     /* 632865 */     GIR_EraseRootFromParent_Done,
     /* 632866 */   // Label 8056: @632866
     /* 632866 */   GIM_Reject,
     /* 632867 */ // Label 8052: @632867
     /* 632867 */ GIM_Reject,
     /* 632868 */ // Label 8049: @632868
     /* 632868 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(632947),
     /* 632873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 632876 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(632903), // Rule ID 32 //
     /* 632881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 632884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 632888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13717),
     /* 632892 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13717>>  =>  (S_CEIL_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /* 632892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F32),
     /* 632897 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 632901 */     GIR_RootConstrainSelectedInstOperands,
     /* 632902 */     // GIR_Coverage, 32,
     /* 632902 */     GIR_Done,
     /* 632903 */   // Label 8058: @632903
     /* 632903 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(632946), // Rule ID 659 //
     /* 632908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 632912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632919 */     // (fceil:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F32_e64),
     /* 632922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632944 */     GIR_RootConstrainSelectedInstOperands,
     /* 632945 */     // GIR_Coverage, 659,
     /* 632945 */     GIR_EraseRootFromParent_Done,
     /* 632946 */   // Label 8059: @632946
     /* 632946 */   GIM_Reject,
     /* 632947 */ // Label 8057: @632947
     /* 632947 */ GIM_Reject,
     /* 632948 */ // Label 8050: @632948
     /* 632948 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(632997), // Rule ID 703 //
     /* 632953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /* 632956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 632959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 632963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 632970 */   // (fceil:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 632970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F64_e64),
     /* 632973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 632975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 632980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 632985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 632990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 632995 */   GIR_RootConstrainSelectedInstOperands,
     /* 632996 */   // GIR_Coverage, 703,
     /* 632996 */   GIR_EraseRootFromParent_Done,
     /* 632997 */ // Label 8060: @632997
     /* 632997 */ GIM_Reject,
     /* 632998 */ // Label 8051: @632998
     /* 632998 */ GIM_Reject,
     /* 632999 */ // Label 100: @632999
     /* 632999 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 8063*/ GIMT_Encode4(633290),
     /* 633010 */ /*GILLT_s16*//*Label 8061*/ GIMT_Encode4(633018),
     /* 633014 */ /*GILLT_s32*//*Label 8062*/ GIMT_Encode4(633236),
     /* 633018 */ // Label 8061: @633018
     /* 633018 */ GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(633235),
     /* 633023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 633026 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(633097), // Rule ID 2706 //
     /* 633031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 633034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 633038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21560),
     /* 633042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633049 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21560>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
     /* 633049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 633052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
     /* 633056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 633083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 633086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 633088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 633091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 633096 */     // GIR_Coverage, 2706,
     /* 633096 */     GIR_EraseRootFromParent_Done,
     /* 633097 */   // Label 8065: @633097
     /* 633097 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(633143), // Rule ID 724 //
     /* 633102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 633105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633116 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
     /* 633119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633141 */     GIR_RootConstrainSelectedInstOperands,
     /* 633142 */     // GIR_Coverage, 724,
     /* 633142 */     GIR_EraseRootFromParent_Done,
     /* 633143 */   // Label 8066: @633143
     /* 633143 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(633189), // Rule ID 728 //
     /* 633148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 633151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633162 */     // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
     /* 633165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633187 */     GIR_RootConstrainSelectedInstOperands,
     /* 633188 */     // GIR_Coverage, 728,
     /* 633188 */     GIR_EraseRootFromParent_Done,
     /* 633189 */   // Label 8067: @633189
     /* 633189 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(633234), // Rule ID 726 //
     /* 633194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 633197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 633201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 633208 */     // (fsqrt:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 633208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
     /* 633211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633232 */     GIR_RootConstrainSelectedInstOperands,
     /* 633233 */     // GIR_Coverage, 726,
     /* 633233 */     GIR_EraseRootFromParent_Done,
     /* 633234 */   // Label 8068: @633234
     /* 633234 */   GIM_Reject,
     /* 633235 */ // Label 8064: @633235
     /* 633235 */ GIM_Reject,
     /* 633236 */ // Label 8062: @633236
     /* 633236 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(633289), // Rule ID 1084 //
     /* 633241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
     /* 633244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 633247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
     /* 633251 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_21560),
     /* 633255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633262 */   // (fsqrt:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_21560>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
     /* 633265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633287 */   GIR_RootConstrainSelectedInstOperands,
     /* 633288 */   // GIR_Coverage, 1084,
     /* 633288 */   GIR_EraseRootFromParent_Done,
     /* 633289 */ // Label 8069: @633289
     /* 633289 */ GIM_Reject,
     /* 633290 */ // Label 8063: @633290
     /* 633290 */ GIM_Reject,
     /* 633291 */ // Label 101: @633291
     /* 633291 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 8073*/ GIMT_Encode4(633804),
     /* 633302 */ /*GILLT_s16*//*Label 8070*/ GIMT_Encode4(633314),
     /* 633306 */ /*GILLT_s32*//*Label 8071*/ GIMT_Encode4(633488),
     /* 633310 */ /*GILLT_s64*//*Label 8072*/ GIMT_Encode4(633568),
     /* 633314 */ // Label 8070: @633314
     /* 633314 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(633487),
     /* 633319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 633322 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(633349), // Rule ID 38 //
     /* 633327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 633330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 633334 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13718),
     /* 633338 */     // (ffloor:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13718>>  =>  (S_FLOOR_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
     /* 633338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F16),
     /* 633343 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 633347 */     GIR_RootConstrainSelectedInstOperands,
     /* 633348 */     // GIR_Coverage, 38,
     /* 633348 */     GIR_Done,
     /* 633349 */   // Label 8075: @633349
     /* 633349 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(633395), // Rule ID 766 //
     /* 633354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 633357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633368 */     // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_e64),
     /* 633371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633393 */     GIR_RootConstrainSelectedInstOperands,
     /* 633394 */     // GIR_Coverage, 766,
     /* 633394 */     GIR_EraseRootFromParent_Done,
     /* 633395 */   // Label 8076: @633395
     /* 633395 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(633441), // Rule ID 768 //
     /* 633400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 633403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633414 */     // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_fake16_e64),
     /* 633417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633439 */     GIR_RootConstrainSelectedInstOperands,
     /* 633440 */     // GIR_Coverage, 768,
     /* 633440 */     GIR_EraseRootFromParent_Done,
     /* 633441 */   // Label 8077: @633441
     /* 633441 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(633486), // Rule ID 767 //
     /* 633446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 633449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 633453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 633460 */     // (ffloor:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FLOOR_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
     /* 633460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_t16_e64),
     /* 633463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633484 */     GIR_RootConstrainSelectedInstOperands,
     /* 633485 */     // GIR_Coverage, 767,
     /* 633485 */     GIR_EraseRootFromParent_Done,
     /* 633486 */   // Label 8078: @633486
     /* 633486 */   GIM_Reject,
     /* 633487 */ // Label 8074: @633487
     /* 633487 */ GIM_Reject,
     /* 633488 */ // Label 8071: @633488
     /* 633488 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(633567),
     /* 633493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 633496 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(633523), // Rule ID 33 //
     /* 633501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 633504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 633508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13718),
     /* 633512 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13718>>  =>  (S_FLOOR_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
     /* 633512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F32),
     /* 633517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 633521 */     GIR_RootConstrainSelectedInstOperands,
     /* 633522 */     // GIR_Coverage, 33,
     /* 633522 */     GIR_Done,
     /* 633523 */   // Label 8080: @633523
     /* 633523 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(633566), // Rule ID 661 //
     /* 633528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633539 */     // (ffloor:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F32_e64),
     /* 633542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633564 */     GIR_RootConstrainSelectedInstOperands,
     /* 633565 */     // GIR_Coverage, 661,
     /* 633565 */     GIR_EraseRootFromParent_Done,
     /* 633566 */   // Label 8081: @633566
     /* 633566 */   GIM_Reject,
     /* 633567 */ // Label 8079: @633567
     /* 633567 */ GIM_Reject,
     /* 633568 */ // Label 8072: @633568
     /* 633568 */ GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(633803),
     /* 633573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 633576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 633580 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(633760), // Rule ID 7696 //
     /* 633585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
     /* 633588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633595 */     // (ffloor:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$x, i32:{ *:[i32] }:$mods))  =>  (V_ADD_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x, 1:{ *:[i32] }, (V_CNDMASK_B64_PSEUDO:{ *:[i64] } (V_MIN_F64_e64:{ *:[i64] } 0:{ *:[i32] }, (V_FRACT_F64_e64:{ *:[i64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x), 0:{ *:[i32] }, (V_MOV_B64_PSEUDO:{ *:[i64] } 4607182418800017407:{ *:[i64] })), ?:{ *:[f64] }:$x, (V_CMP_CLASS_F64_e64:{ *:[i1] } 0:{ *:[i32] }, ?:{ *:[f64] }:$x, 3:{ *:[i32] })))
     /* 633595 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
     /* 633598 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
     /* 633602 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633607 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/0,
     /* 633610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 633615 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/3,
     /* 633618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 633620 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 633623 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
     /* 633627 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633632 */     GIR_AddImm, /*InsnID*/4, /*Imm*/GIMT_Encode8(4607182418800017407),
     /* 633642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 633644 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 633647 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
     /* 633651 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
     /* 633661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 633666 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 633669 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 633672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 633674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 633677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
     /* 633681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633686 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 633689 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 633692 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 633695 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 633698 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 633701 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 633704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 633706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 633709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B64_PSEUDO),
     /* 633713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 633718 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 633721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 633726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 633729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 633731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 633734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
     /* 633741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
     /* 633746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 633749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 633752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 633758 */     GIR_RootConstrainSelectedInstOperands,
     /* 633759 */     // GIR_Coverage, 7696,
     /* 633759 */     GIR_EraseRootFromParent_Done,
     /* 633760 */   // Label 8083: @633760
     /* 633760 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(633802), // Rule ID 705 //
     /* 633765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
     /* 633768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633775 */     // (ffloor:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F64_e64),
     /* 633778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633800 */     GIR_RootConstrainSelectedInstOperands,
     /* 633801 */     // GIR_Coverage, 705,
     /* 633801 */     GIR_EraseRootFromParent_Done,
     /* 633802 */   // Label 8084: @633802
     /* 633802 */   GIM_Reject,
     /* 633803 */ // Label 8082: @633803
     /* 633803 */ GIM_Reject,
     /* 633804 */ // Label 8073: @633804
     /* 633804 */ GIM_Reject,
     /* 633805 */ // Label 102: @633805
     /* 633805 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 8090*/ GIMT_Encode4(634766),
     /* 633816 */ /*GILLT_s16*//*Label 8085*/ GIMT_Encode4(633836),
     /* 633820 */ /*GILLT_s32*//*Label 8086*/ GIMT_Encode4(634198),
     /* 633824 */ /*GILLT_s64*//*Label 8087*/ GIMT_Encode4(634366),
     /* 633828 */ /*GILLT_v2s16*//*Label 8088*/ GIMT_Encode4(634619),
     /* 633832 */ /*GILLT_v2s32*//*Label 8089*/ GIMT_Encode4(634691),
     /* 633836 */ // Label 8085: @633836
     /* 633836 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(634197),
     /* 633841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 633844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 633847 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(633882), // Rule ID 96 //
     /* 633852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 633855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 633859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 633863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 633867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /* 633871 */     // (strict_fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13743>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 633871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
     /* 633876 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 633880 */     GIR_RootConstrainSelectedInstOperands,
     /* 633881 */     // GIR_Coverage, 96,
     /* 633881 */     GIR_Done,
     /* 633882 */   // Label 8092: @633882
     /* 633882 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(633945), // Rule ID 859 //
     /* 633887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 633890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633908 */     // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 633911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 633938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 633943 */     GIR_RootConstrainSelectedInstOperands,
     /* 633944 */     // GIR_Coverage, 859,
     /* 633944 */     GIR_EraseRootFromParent_Done,
     /* 633945 */   // Label 8093: @633945
     /* 633945 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(634008), // Rule ID 863 //
     /* 633950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 633953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 633957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 633964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 633971 */     // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 633971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 633974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 633976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 633981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 633986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 633991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 633996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 634001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 634006 */     GIR_RootConstrainSelectedInstOperands,
     /* 634007 */     // GIR_Coverage, 863,
     /* 634007 */     GIR_EraseRootFromParent_Done,
     /* 634008 */   // Label 8094: @634008
     /* 634008 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(634071), // Rule ID 8560 //
     /* 634013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 634016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634034 */     // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
     /* 634037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 634044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 634049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 634054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 634059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 634064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 634069 */     GIR_RootConstrainSelectedInstOperands,
     /* 634070 */     // GIR_Coverage, 8560,
     /* 634070 */     GIR_EraseRootFromParent_Done,
     /* 634071 */   // Label 8095: @634071
     /* 634071 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(634134), // Rule ID 8562 //
     /* 634076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 634079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634097 */     // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
     /* 634100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 634107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 634112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 634117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 634122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 634127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 634132 */     GIR_RootConstrainSelectedInstOperands,
     /* 634133 */     // GIR_Coverage, 8562,
     /* 634133 */     GIR_EraseRootFromParent_Done,
     /* 634134 */   // Label 8096: @634134
     /* 634134 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(634196), // Rule ID 861 //
     /* 634139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 634142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 634146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 634153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 634160 */     // (strict_fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 634160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
     /* 634163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634194 */     GIR_RootConstrainSelectedInstOperands,
     /* 634195 */     // GIR_Coverage, 861,
     /* 634195 */     GIR_EraseRootFromParent_Done,
     /* 634196 */   // Label 8097: @634196
     /* 634196 */   GIM_Reject,
     /* 634197 */ // Label 8091: @634197
     /* 634197 */ GIM_Reject,
     /* 634198 */ // Label 8086: @634198
     /* 634198 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(634365),
     /* 634203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 634206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 634209 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(634244), // Rule ID 88 //
     /* 634214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 634217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 634221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 634225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 634229 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13743),
     /* 634233 */     // (strict_fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13743>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 634233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
     /* 634238 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 634242 */     GIR_RootConstrainSelectedInstOperands,
     /* 634243 */     // GIR_Coverage, 88,
     /* 634243 */     GIR_Done,
     /* 634244 */   // Label 8099: @634244
     /* 634244 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(634304), // Rule ID 785 //
     /* 634249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634267 */     // (strict_fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 634270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 634297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 634302 */     GIR_RootConstrainSelectedInstOperands,
     /* 634303 */     // GIR_Coverage, 785,
     /* 634303 */     GIR_EraseRootFromParent_Done,
     /* 634304 */   // Label 8100: @634304
     /* 634304 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(634364), // Rule ID 8549 //
     /* 634309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634327 */     // (strict_fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
     /* 634330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 634337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 634342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 634347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 634352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 634357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 634362 */     GIR_RootConstrainSelectedInstOperands,
     /* 634363 */     // GIR_Coverage, 8549,
     /* 634363 */     GIR_EraseRootFromParent_Done,
     /* 634364 */   // Label 8101: @634364
     /* 634364 */   GIM_Reject,
     /* 634365 */ // Label 8098: @634365
     /* 634365 */ GIM_Reject,
     /* 634366 */ // Label 8087: @634366
     /* 634366 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(634618),
     /* 634371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 634374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 634377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634381 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(634440), // Rule ID 913 //
     /* 634386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 634389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634403 */     // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 634406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 634433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 634438 */     GIR_RootConstrainSelectedInstOperands,
     /* 634439 */     // GIR_Coverage, 913,
     /* 634439 */     GIR_EraseRootFromParent_Done,
     /* 634440 */   // Label 8103: @634440
     /* 634440 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(634499), // Rule ID 931 //
     /* 634445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 634448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634462 */     // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 634465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 634492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 634497 */     GIR_RootConstrainSelectedInstOperands,
     /* 634498 */     // GIR_Coverage, 931,
     /* 634498 */     GIR_EraseRootFromParent_Done,
     /* 634499 */   // Label 8104: @634499
     /* 634499 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(634558), // Rule ID 8578 //
     /* 634504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 634507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634521 */     // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
     /* 634524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 634531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 634536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 634541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 634546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 634551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 634556 */     GIR_RootConstrainSelectedInstOperands,
     /* 634557 */     // GIR_Coverage, 8578,
     /* 634557 */     GIR_EraseRootFromParent_Done,
     /* 634558 */   // Label 8105: @634558
     /* 634558 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(634617), // Rule ID 8591 //
     /* 634563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 634566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634580 */     // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
     /* 634583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 634590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 634595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 634600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 634605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 634610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 634615 */     GIR_RootConstrainSelectedInstOperands,
     /* 634616 */     // GIR_Coverage, 8591,
     /* 634616 */     GIR_EraseRootFromParent_Done,
     /* 634617 */   // Label 8106: @634617
     /* 634617 */   GIM_Reject,
     /* 634618 */ // Label 8102: @634618
     /* 634618 */ GIM_Reject,
     /* 634619 */ // Label 8088: @634619
     /* 634619 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(634690), // Rule ID 1091 //
     /* 634624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 634627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 634630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 634641 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 634648 */   // (strict_fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 634648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
     /* 634651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634668 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634688 */   GIR_RootConstrainSelectedInstOperands,
     /* 634689 */   // GIR_Coverage, 1091,
     /* 634689 */   GIR_EraseRootFromParent_Done,
     /* 634690 */ // Label 8107: @634690
     /* 634690 */ GIM_Reject,
     /* 634691 */ // Label 8089: @634691
     /* 634691 */ GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(634765), // Rule ID 1312 //
     /* 634696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 634699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 634702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 634705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 634709 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 634716 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 634723 */   // (strict_fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 634723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
     /* 634726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 634763 */   GIR_RootConstrainSelectedInstOperands,
     /* 634764 */   // GIR_Coverage, 1312,
     /* 634764 */   GIR_EraseRootFromParent_Done,
     /* 634765 */ // Label 8108: @634765
     /* 634765 */ GIM_Reject,
     /* 634766 */ // Label 8090: @634766
     /* 634766 */ GIM_Reject,
     /* 634767 */ // Label 103: @634767
     /* 634767 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 8111*/ GIMT_Encode4(635130),
     /* 634778 */ /*GILLT_s16*//*Label 8109*/ GIMT_Encode4(634786),
     /* 634782 */ /*GILLT_s32*//*Label 8110*/ GIMT_Encode4(635022),
     /* 634786 */ // Label 8109: @634786
     /* 634786 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(635021),
     /* 634791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 634794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 634797 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(634832), // Rule ID 104 //
     /* 634802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 634805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 634809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 634813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 634817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13747),
     /* 634821 */     // (strict_fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13747>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 634821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
     /* 634826 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 634830 */     GIR_RootConstrainSelectedInstOperands,
     /* 634831 */     // GIR_Coverage, 104,
     /* 634831 */     GIR_Done,
     /* 634832 */   // Label 8113: @634832
     /* 634832 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(634895), // Rule ID 865 //
     /* 634837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 634840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634858 */     // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
     /* 634861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 634888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 634893 */     GIR_RootConstrainSelectedInstOperands,
     /* 634894 */     // GIR_Coverage, 865,
     /* 634894 */     GIR_EraseRootFromParent_Done,
     /* 634895 */   // Label 8114: @634895
     /* 634895 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(634958), // Rule ID 869 //
     /* 634900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 634903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 634907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 634914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 634921 */     // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 634921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
     /* 634924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 634941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 634946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 634951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 634956 */     GIR_RootConstrainSelectedInstOperands,
     /* 634957 */     // GIR_Coverage, 869,
     /* 634957 */     GIR_EraseRootFromParent_Done,
     /* 634958 */   // Label 8115: @634958
     /* 634958 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(635020), // Rule ID 867 //
     /* 634963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 634966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 634970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 634977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 634984 */     // (strict_fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 634984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
     /* 634987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 634989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 634994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 634999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 635004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 635009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635018 */     GIR_RootConstrainSelectedInstOperands,
     /* 635019 */     // GIR_Coverage, 867,
     /* 635019 */     GIR_EraseRootFromParent_Done,
     /* 635020 */   // Label 8116: @635020
     /* 635020 */   GIM_Reject,
     /* 635021 */ // Label 8112: @635021
     /* 635021 */ GIM_Reject,
     /* 635022 */ // Label 8110: @635022
     /* 635022 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(635129),
     /* 635027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 635030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 635033 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(635068), // Rule ID 106 //
     /* 635038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 635041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13747),
     /* 635057 */     // (strict_fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13747>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 635057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
     /* 635062 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 635066 */     GIR_RootConstrainSelectedInstOperands,
     /* 635067 */     // GIR_Coverage, 106,
     /* 635067 */     GIR_Done,
     /* 635068 */   // Label 8118: @635068
     /* 635068 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(635128), // Rule ID 787 //
     /* 635073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 635077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 635084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635091 */     // (strict_fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 635091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
     /* 635094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 635101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 635106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 635111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 635116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 635121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 635126 */     GIR_RootConstrainSelectedInstOperands,
     /* 635127 */     // GIR_Coverage, 787,
     /* 635127 */     GIR_EraseRootFromParent_Done,
     /* 635128 */   // Label 8119: @635128
     /* 635128 */   GIM_Reject,
     /* 635129 */ // Label 8117: @635129
     /* 635129 */ GIM_Reject,
     /* 635130 */ // Label 8111: @635130
     /* 635130 */ GIM_Reject,
     /* 635131 */ // Label 104: @635131
     /* 635131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 8125*/ GIMT_Encode4(636398),
     /* 635142 */ /*GILLT_s16*//*Label 8120*/ GIMT_Encode4(635162),
     /* 635146 */ /*GILLT_s32*//*Label 8121*/ GIMT_Encode4(635524),
     /* 635150 */ /*GILLT_s64*//*Label 8122*/ GIMT_Encode4(635692),
     /* 635154 */ /*GILLT_v2s16*//*Label 8123*/ GIMT_Encode4(636251),
     /* 635158 */ /*GILLT_v2s32*//*Label 8124*/ GIMT_Encode4(636323),
     /* 635162 */ // Label 8120: @635162
     /* 635162 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(635523),
     /* 635167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 635170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 635173 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(635208), // Rule ID 98 //
     /* 635178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 635181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13746),
     /* 635197 */     // (strict_fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13746>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
     /* 635197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
     /* 635202 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 635206 */     GIR_RootConstrainSelectedInstOperands,
     /* 635207 */     // GIR_Coverage, 98,
     /* 635207 */     GIR_Done,
     /* 635208 */   // Label 8127: @635208
     /* 635208 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(635271), // Rule ID 871 //
     /* 635213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 635216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 635220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 635227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635234 */     // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 635234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 635237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 635244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 635249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 635254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 635259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 635264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 635269 */     GIR_RootConstrainSelectedInstOperands,
     /* 635270 */     // GIR_Coverage, 871,
     /* 635270 */     GIR_EraseRootFromParent_Done,
     /* 635271 */   // Label 8128: @635271
     /* 635271 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(635334), // Rule ID 875 //
     /* 635276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 635279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 635283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 635290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635297 */     // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 635297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 635300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 635307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 635312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 635317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 635322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 635327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 635332 */     GIR_RootConstrainSelectedInstOperands,
     /* 635333 */     // GIR_Coverage, 875,
     /* 635333 */     GIR_EraseRootFromParent_Done,
     /* 635334 */   // Label 8129: @635334
     /* 635334 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(635397), // Rule ID 8564 //
     /* 635339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
     /* 635342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 635346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 635360 */     // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 635360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
     /* 635363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 635370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 635375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 635380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 635385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 635390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 635395 */     GIR_RootConstrainSelectedInstOperands,
     /* 635396 */     // GIR_Coverage, 8564,
     /* 635396 */     GIR_EraseRootFromParent_Done,
     /* 635397 */   // Label 8130: @635397
     /* 635397 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(635460), // Rule ID 8566 //
     /* 635402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 635405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 635409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 635423 */     // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 635423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
     /* 635426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 635433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 635438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 635443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 635448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 635453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 635458 */     GIR_RootConstrainSelectedInstOperands,
     /* 635459 */     // GIR_Coverage, 8566,
     /* 635459 */     GIR_EraseRootFromParent_Done,
     /* 635460 */   // Label 8131: @635460
     /* 635460 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(635522), // Rule ID 873 //
     /* 635465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 635468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 635472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 635479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 635486 */     // (strict_fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
     /* 635486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
     /* 635489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 635496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 635501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 635506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 635511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635520 */     GIR_RootConstrainSelectedInstOperands,
     /* 635521 */     // GIR_Coverage, 873,
     /* 635521 */     GIR_EraseRootFromParent_Done,
     /* 635522 */   // Label 8132: @635522
     /* 635522 */   GIM_Reject,
     /* 635523 */ // Label 8126: @635523
     /* 635523 */ GIM_Reject,
     /* 635524 */ // Label 8121: @635524
     /* 635524 */ GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(635691),
     /* 635529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 635532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 635535 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(635570), // Rule ID 94 //
     /* 635540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 635543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 635555 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13746),
     /* 635559 */     // (strict_fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13746>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
     /* 635559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
     /* 635564 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 635568 */     GIR_RootConstrainSelectedInstOperands,
     /* 635569 */     // GIR_Coverage, 94,
     /* 635569 */     GIR_Done,
     /* 635570 */   // Label 8134: @635570
     /* 635570 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(635630), // Rule ID 791 //
     /* 635575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 635579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 635586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635593 */     // (strict_fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 635593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 635596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 635603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 635608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 635613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 635618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 635623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 635628 */     GIR_RootConstrainSelectedInstOperands,
     /* 635629 */     // GIR_Coverage, 791,
     /* 635629 */     GIR_EraseRootFromParent_Done,
     /* 635630 */   // Label 8135: @635630
     /* 635630 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(635690), // Rule ID 8553 //
     /* 635635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 635639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 635653 */     // (strict_fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 635653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
     /* 635656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 635663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 635668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 635673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 635678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 635683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 635688 */     GIR_RootConstrainSelectedInstOperands,
     /* 635689 */     // GIR_Coverage, 8553,
     /* 635689 */     GIR_EraseRootFromParent_Done,
     /* 635690 */   // Label 8136: @635690
     /* 635690 */   GIM_Reject,
     /* 635691 */ // Label 8133: @635691
     /* 635691 */ GIM_Reject,
     /* 635692 */ // Label 8122: @635692
     /* 635692 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(636250),
     /* 635697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 635700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 635703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 635707 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(635781), // Rule ID 7919 //
     /* 635712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 635716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 635720 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 635724 */     // MIs[1] Operand 1
     /* 635724 */     // No operand predicates
     /* 635724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 635726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635733 */     // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 635733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 635736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 635740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635745 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 635750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 635752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 635755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 635762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 635767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 635773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635779 */     GIR_RootConstrainSelectedInstOperands,
     /* 635780 */     // GIR_Coverage, 7919,
     /* 635780 */     GIR_EraseRootFromParent_Done,
     /* 635781 */   // Label 8138: @635781
     /* 635781 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(635855), // Rule ID 13585 //
     /* 635786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 635790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 635794 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
     /* 635798 */     // MIs[1] Operand 1
     /* 635798 */     // No operand predicates
     /* 635798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 635800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 635807 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 635807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 635810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 635814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635819 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 635824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 635826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 635829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
     /* 635836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 635841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 635847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635853 */     GIR_RootConstrainSelectedInstOperands,
     /* 635854 */     // GIR_Coverage, 13585,
     /* 635854 */     GIR_EraseRootFromParent_Done,
     /* 635855 */   // Label 8139: @635855
     /* 635855 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(635931), // Rule ID 7923 //
     /* 635860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 635864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 635868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 635872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 635876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 635880 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 635884 */     // MIs[2] Operand 1
     /* 635884 */     // No operand predicates
     /* 635884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 635886 */     // (strict_fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 635886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 635889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 635893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635898 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 635903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 635905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 635908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 635913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
     /* 635917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 635923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635929 */     GIR_RootConstrainSelectedInstOperands,
     /* 635930 */     // GIR_Coverage, 7923,
     /* 635930 */     GIR_EraseRootFromParent_Done,
     /* 635931 */   // Label 8140: @635931
     /* 635931 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(636007), // Rule ID 13589 //
     /* 635936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 635940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 635944 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 635948 */     // MIs[1] Operand 1
     /* 635948 */     // No operand predicates
     /* 635948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 635952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 635956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 635960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 635962 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 635962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 635965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 635969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 635974 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 635979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 635981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 635984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 635986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 635989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
     /* 635993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 635996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 635999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636005 */     GIR_RootConstrainSelectedInstOperands,
     /* 636006 */     // GIR_Coverage, 13589,
     /* 636006 */     GIR_EraseRootFromParent_Done,
     /* 636007 */   // Label 8141: @636007
     /* 636007 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(636069), // Rule ID 13587 //
     /* 636012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 636016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 636020 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 636024 */     // MIs[1] Operand 1
     /* 636024 */     // No operand predicates
     /* 636024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 636026 */     // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 636026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 636029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 636033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636038 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 636043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 636045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 636048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 636053 */     GIR_RootToRootCopy, /*OpIdx*/2, // src0
     /* 636055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636067 */     GIR_RootConstrainSelectedInstOperands,
     /* 636068 */     // GIR_Coverage, 13587,
     /* 636068 */     GIR_EraseRootFromParent_Done,
     /* 636069 */   // Label 8142: @636069
     /* 636069 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(636131), // Rule ID 7921 //
     /* 636074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 636078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 636082 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
     /* 636086 */     // MIs[1] Operand 1
     /* 636086 */     // No operand predicates
     /* 636086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 636088 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
     /* 636088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 636091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
     /* 636095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 636100 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
     /* 636105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 636107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 636110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 636115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 636117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 636123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636129 */     GIR_RootConstrainSelectedInstOperands,
     /* 636130 */     // GIR_Coverage, 7921,
     /* 636130 */     GIR_EraseRootFromParent_Done,
     /* 636131 */   // Label 8143: @636131
     /* 636131 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(636190), // Rule ID 933 //
     /* 636136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 636139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 636146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636153 */     // (strict_fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 636153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 636156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 636183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 636188 */     GIR_RootConstrainSelectedInstOperands,
     /* 636189 */     // GIR_Coverage, 933,
     /* 636189 */     GIR_EraseRootFromParent_Done,
     /* 636190 */   // Label 8144: @636190
     /* 636190 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(636249), // Rule ID 8593 //
     /* 636195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 636198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 636212 */     // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 636212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
     /* 636215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 636222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 636227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 636232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 636237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 636242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 636247 */     GIR_RootConstrainSelectedInstOperands,
     /* 636248 */     // GIR_Coverage, 8593,
     /* 636248 */     GIR_EraseRootFromParent_Done,
     /* 636249 */   // Label 8145: @636249
     /* 636249 */   GIM_Reject,
     /* 636250 */ // Label 8137: @636250
     /* 636250 */ GIM_Reject,
     /* 636251 */ // Label 8123: @636251
     /* 636251 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(636322), // Rule ID 1093 //
     /* 636256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 636259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 636262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 636273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 636280 */   // (strict_fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
     /* 636280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
     /* 636283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636320 */   GIR_RootConstrainSelectedInstOperands,
     /* 636321 */   // GIR_Coverage, 1093,
     /* 636321 */   GIR_EraseRootFromParent_Done,
     /* 636322 */ // Label 8146: @636322
     /* 636322 */ GIM_Reject,
     /* 636323 */ // Label 8124: @636323
     /* 636323 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(636397), // Rule ID 1310 //
     /* 636328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 636331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 636334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 636337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 636341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 636348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 636355 */   // (strict_fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
     /* 636355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
     /* 636358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636395 */   GIR_RootConstrainSelectedInstOperands,
     /* 636396 */   // GIR_Coverage, 1310,
     /* 636396 */   GIR_EraseRootFromParent_Done,
     /* 636397 */ // Label 8147: @636397
     /* 636397 */ GIM_Reject,
     /* 636398 */ // Label 8125: @636398
     /* 636398 */ GIM_Reject,
     /* 636399 */ // Label 105: @636399
     /* 636399 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 8153*/ GIMT_Encode4(637444),
     /* 636410 */ /*GILLT_s16*//*Label 8148*/ GIMT_Encode4(636430),
     /* 636414 */ /*GILLT_s32*//*Label 8149*/ GIMT_Encode4(636882),
     /* 636418 */ /*GILLT_s64*//*Label 8150*/ GIMT_Encode4(637091),
     /* 636422 */ /*GILLT_v2s16*//*Label 8151*/ GIMT_Encode4(637257),
     /* 636426 */ /*GILLT_v2s32*//*Label 8152*/ GIMT_Encode4(637349),
     /* 636430 */ // Label 8148: @636430
     /* 636430 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(636881),
     /* 636435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 636438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 636441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 636444 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(636483), // Rule ID 112 //
     /* 636449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 636452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13749),
     /* 636472 */     // (strict_fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13749>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
     /* 636472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
     /* 636477 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 636481 */     GIR_RootConstrainSelectedInstOperands,
     /* 636482 */     // GIR_Coverage, 112,
     /* 636482 */     GIR_Done,
     /* 636483 */   // Label 8155: @636483
     /* 636483 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(636563), // Rule ID 1000 //
     /* 636488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 636491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 636502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636516 */     // (strict_fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 636516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 636519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 636546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 636551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 636556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 636561 */     GIR_RootConstrainSelectedInstOperands,
     /* 636562 */     // GIR_Coverage, 1000,
     /* 636562 */     GIR_EraseRootFromParent_Done,
     /* 636563 */   // Label 8156: @636563
     /* 636563 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(636643), // Rule ID 8606 //
     /* 636568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
     /* 636571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 636589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636596 */     // (strict_fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 636596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
     /* 636599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 636606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 636611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 636616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 636621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 636626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 636631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 636636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 636641 */     GIR_RootConstrainSelectedInstOperands,
     /* 636642 */     // GIR_Coverage, 8606,
     /* 636642 */     GIR_EraseRootFromParent_Done,
     /* 636643 */   // Label 8157: @636643
     /* 636643 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(636722), // Rule ID 1008 //
     /* 636648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 636651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636676 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 636676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
     /* 636679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 636706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 636711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636720 */     GIR_RootConstrainSelectedInstOperands,
     /* 636721 */     // GIR_Coverage, 1008,
     /* 636721 */     GIR_EraseRootFromParent_Done,
     /* 636722 */   // Label 8158: @636722
     /* 636722 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(636801), // Rule ID 1010 //
     /* 636727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 636730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 636734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636755 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 636755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_t16_e64),
     /* 636758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 636785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 636790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636799 */     GIR_RootConstrainSelectedInstOperands,
     /* 636800 */     // GIR_Coverage, 1010,
     /* 636800 */     GIR_EraseRootFromParent_Done,
     /* 636801 */   // Label 8159: @636801
     /* 636801 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(636880), // Rule ID 1012 //
     /* 636806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 636809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 636834 */     // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 636834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_fake16_e64),
     /* 636837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 636864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 636869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 636878 */     GIR_RootConstrainSelectedInstOperands,
     /* 636879 */     // GIR_Coverage, 1012,
     /* 636879 */     GIR_EraseRootFromParent_Done,
     /* 636880 */   // Label 8160: @636880
     /* 636880 */   GIM_Reject,
     /* 636881 */ // Label 8154: @636881
     /* 636881 */ GIM_Reject,
     /* 636882 */ // Label 8149: @636882
     /* 636882 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(637090),
     /* 636887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 636890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 636893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 636896 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(636935), // Rule ID 110 //
     /* 636901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
     /* 636904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 636920 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13749),
     /* 636924 */     // (strict_fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13749>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
     /* 636924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
     /* 636929 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
     /* 636933 */     GIR_RootConstrainSelectedInstOperands,
     /* 636934 */     // GIR_Coverage, 110,
     /* 636934 */     GIR_Done,
     /* 636935 */   // Label 8162: @636935
     /* 636935 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(637012), // Rule ID 926 //
     /* 636940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 636944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 636951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 636965 */     // (strict_fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 636965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 636968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 636970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 636975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 636980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 636985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 636990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 636995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 637000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 637005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 637010 */     GIR_RootConstrainSelectedInstOperands,
     /* 637011 */     // GIR_Coverage, 926,
     /* 637011 */     GIR_EraseRootFromParent_Done,
     /* 637012 */   // Label 8163: @637012
     /* 637012 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(637089), // Rule ID 8587 //
     /* 637017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637042 */     // (strict_fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 637042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
     /* 637045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 637052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 637057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 637062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 637067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 637072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 637077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 637082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 637087 */     GIR_RootConstrainSelectedInstOperands,
     /* 637088 */     // GIR_Coverage, 8587,
     /* 637088 */     GIR_EraseRootFromParent_Done,
     /* 637089 */   // Label 8164: @637089
     /* 637089 */   GIM_Reject,
     /* 637090 */ // Label 8161: @637090
     /* 637090 */ GIM_Reject,
     /* 637091 */ // Label 8150: @637091
     /* 637091 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(637256),
     /* 637096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 637099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 637102 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 637105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637109 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(637182), // Rule ID 929 //
     /* 637114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637135 */     // (strict_fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 637135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 637138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 637165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 637170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 637175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 637180 */     GIR_RootConstrainSelectedInstOperands,
     /* 637181 */     // GIR_Coverage, 929,
     /* 637181 */     GIR_EraseRootFromParent_Done,
     /* 637182 */   // Label 8166: @637182
     /* 637182 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(637255), // Rule ID 8589 //
     /* 637187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637208 */     // (strict_fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 637208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
     /* 637211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
     /* 637218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
     /* 637223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
     /* 637228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
     /* 637233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 637238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 637243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
     /* 637248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
     /* 637253 */     GIR_RootConstrainSelectedInstOperands,
     /* 637254 */     // GIR_Coverage, 8589,
     /* 637254 */     GIR_EraseRootFromParent_Done,
     /* 637255 */   // Label 8167: @637255
     /* 637255 */   GIM_Reject,
     /* 637256 */ // Label 8165: @637256
     /* 637256 */ GIM_Reject,
     /* 637257 */ // Label 8151: @637257
     /* 637257 */ GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(637348), // Rule ID 1089 //
     /* 637262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 637265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 637268 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 637271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 637282 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 637289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 637296 */   // (strict_fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
     /* 637296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
     /* 637299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 637326 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 637331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637346 */   GIR_RootConstrainSelectedInstOperands,
     /* 637347 */   // GIR_Coverage, 1089,
     /* 637347 */   GIR_EraseRootFromParent_Done,
     /* 637348 */ // Label 8168: @637348
     /* 637348 */ GIM_Reject,
     /* 637349 */ // Label 8152: @637349
     /* 637349 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(637443), // Rule ID 1308 //
     /* 637354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
     /* 637357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 637360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 637363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 637366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637370 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 637377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 637384 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 637391 */   // (strict_fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
     /* 637391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
     /* 637394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 637421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 637426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637441 */   GIR_RootConstrainSelectedInstOperands,
     /* 637442 */   // GIR_Coverage, 1308,
     /* 637442 */   GIR_EraseRootFromParent_Done,
     /* 637443 */ // Label 8169: @637443
     /* 637443 */ GIM_Reject,
     /* 637444 */ // Label 8153: @637444
     /* 637444 */ GIM_Reject,
     /* 637445 */ // Label 106: @637445
     /* 637445 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 8173*/ GIMT_Encode4(637807),
     /* 637456 */ /*GILLT_s16*//*Label 8170*/ GIMT_Encode4(637468),
     /* 637460 */ /*GILLT_s32*//*Label 8171*/ GIMT_Encode4(637673),
     /* 637464 */ /*GILLT_s64*//*Label 8172*/ GIMT_Encode4(637740),
     /* 637468 */ // Label 8170: @637468
     /* 637468 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(637672),
     /* 637473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 637476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 637479 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(637542), // Rule ID 2506 //
     /* 637484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 637487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637505 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 637505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
     /* 637508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 637535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 637540 */     GIR_RootConstrainSelectedInstOperands,
     /* 637541 */     // GIR_Coverage, 2506,
     /* 637541 */     GIR_EraseRootFromParent_Done,
     /* 637542 */   // Label 8175: @637542
     /* 637542 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(637608), // Rule ID 2508 //
     /* 637547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 637550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 637554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637568 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
     /* 637568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
     /* 637571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 637598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 637603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637606 */     GIR_RootConstrainSelectedInstOperands,
     /* 637607 */     // GIR_Coverage, 2508,
     /* 637607 */     GIR_EraseRootFromParent_Done,
     /* 637608 */   // Label 8176: @637608
     /* 637608 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(637671), // Rule ID 2510 //
     /* 637613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 637616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637634 */     // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
     /* 637634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
     /* 637637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 637664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 637669 */     GIR_RootConstrainSelectedInstOperands,
     /* 637670 */     // GIR_Coverage, 2510,
     /* 637670 */     GIR_EraseRootFromParent_Done,
     /* 637671 */   // Label 8177: @637671
     /* 637671 */   GIM_Reject,
     /* 637672 */ // Label 8174: @637672
     /* 637672 */ GIM_Reject,
     /* 637673 */ // Label 8171: @637673
     /* 637673 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(637739), // Rule ID 821 //
     /* 637678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 637681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 637684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637695 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637702 */   // (strict_fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 637702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
     /* 637705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637712 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637717 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 637732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 637737 */   GIR_RootConstrainSelectedInstOperands,
     /* 637738 */   // GIR_Coverage, 821,
     /* 637738 */   GIR_EraseRootFromParent_Done,
     /* 637739 */ // Label 8178: @637739
     /* 637739 */ GIM_Reject,
     /* 637740 */ // Label 8172: @637740
     /* 637740 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(637806), // Rule ID 981 //
     /* 637745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 637748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 637751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 637755 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 637762 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 637769 */   // (strict_fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 637769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
     /* 637772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 637774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 637779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 637784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 637789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 637794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 637799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 637804 */   GIR_RootConstrainSelectedInstOperands,
     /* 637805 */   // GIR_Coverage, 981,
     /* 637805 */   GIR_EraseRootFromParent_Done,
     /* 637806 */ // Label 8179: @637806
     /* 637806 */ GIM_Reject,
     /* 637807 */ // Label 8173: @637807
     /* 637807 */ GIM_Reject,
     /* 637808 */ // Label 107: @637808
     /* 637808 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8182*/ GIMT_Encode4(640111),
     /* 637819 */ /*GILLT_s32*//*Label 8180*/ GIMT_Encode4(637827),
     /* 637823 */ /*GILLT_s64*//*Label 8181*/ GIMT_Encode4(638969),
     /* 637827 */ // Label 8180: @637827
     /* 637827 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(638968),
     /* 637832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 637835 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(637897), // Rule ID 5811 //
     /* 637840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637843 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 637850 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 637856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 637863 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 637863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64),
     /* 637866 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 637868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 637873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 637878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 637883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 637888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637895 */     GIR_RootConstrainSelectedInstOperands,
     /* 637896 */     // GIR_Coverage, 5811,
     /* 637896 */     GIR_EraseRootFromParent_Done,
     /* 637897 */   // Label 8184: @637897
     /* 637897 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(637956), // Rule ID 5815 //
     /* 637902 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 637909 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 637911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 637915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 637922 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 637922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64),
     /* 637925 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 637927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 637932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 637937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 637942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 637947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 637950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 637954 */     GIR_RootConstrainSelectedInstOperands,
     /* 637955 */     // GIR_Coverage, 5815,
     /* 637955 */     GIR_EraseRootFromParent_Done,
     /* 637956 */   // Label 8185: @637956
     /* 637956 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(638074), // Rule ID 5587 //
     /* 637961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 637964 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 637971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 637975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 637979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 637986 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 637986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 637989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN),
     /* 637993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 637998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 638002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 638007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 638012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 638017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 638022 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 638025 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 638031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 638034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 638046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 638056 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 638063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638073 */     // GIR_Coverage, 5587,
     /* 638073 */     GIR_EraseRootFromParent_Done,
     /* 638074 */   // Label 8186: @638074
     /* 638074 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(638189), // Rule ID 5813 //
     /* 638079 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 638101 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 638101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 638104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN),
     /* 638108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638113 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 638117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 638122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 638127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 638132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 638137 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 638140 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 638146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 638149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 638161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 638171 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 638178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638188 */     // GIR_Coverage, 5813,
     /* 638188 */     GIR_EraseRootFromParent_Done,
     /* 638189 */   // Label 8187: @638189
     /* 638189 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(638246), // Rule ID 5810 //
     /* 638194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638197 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638204 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 638217 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 638217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
     /* 638220 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 638222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 638227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 638232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 638237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 638240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638244 */     GIR_RootConstrainSelectedInstOperands,
     /* 638245 */     // GIR_Coverage, 5810,
     /* 638245 */     GIR_EraseRootFromParent_Done,
     /* 638246 */   // Label 8188: @638246
     /* 638246 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(638300), // Rule ID 5814 //
     /* 638251 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638258 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 638271 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 638271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
     /* 638274 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 638276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 638281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 638286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 638291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 638294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638298 */     GIR_RootConstrainSelectedInstOperands,
     /* 638299 */     // GIR_Coverage, 5814,
     /* 638299 */     GIR_EraseRootFromParent_Done,
     /* 638300 */   // Label 8189: @638300
     /* 638300 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(638413), // Rule ID 5586 //
     /* 638305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638308 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 638330 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 638330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 638333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
     /* 638337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 638346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 638351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 638356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 638361 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 638364 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 638370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 638373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 638385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 638395 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 638402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638412 */     // GIR_Coverage, 5586,
     /* 638412 */     GIR_EraseRootFromParent_Done,
     /* 638413 */   // Label 8190: @638413
     /* 638413 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(638523), // Rule ID 5812 //
     /* 638418 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 638440 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
     /* 638440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 638443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
     /* 638447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 638456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 638461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 638466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 638471 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 638474 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 638480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 638483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 638492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 638495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 638503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 638505 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 638512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 638517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 638522 */     // GIR_Coverage, 5812,
     /* 638522 */     GIR_EraseRootFromParent_Done,
     /* 638523 */   // Label 8191: @638523
     /* 638523 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(638580), // Rule ID 4058 //
     /* 638528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 638531 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638538 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 638551 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 638551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR),
     /* 638554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 638559 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 638566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 638571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 638574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638578 */     GIR_RootConstrainSelectedInstOperands,
     /* 638579 */     // GIR_Coverage, 4058,
     /* 638579 */     GIR_EraseRootFromParent_Done,
     /* 638580 */   // Label 8192: @638580
     /* 638580 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(638641), // Rule ID 4060 //
     /* 638585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 638588 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 638610 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 638610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN),
     /* 638613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 638615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 638620 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 638627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 638632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 638635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638639 */     GIR_RootConstrainSelectedInstOperands,
     /* 638640 */     // GIR_Coverage, 4060,
     /* 638640 */     GIR_EraseRootFromParent_Done,
     /* 638641 */   // Label 8193: @638641
     /* 638641 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(638693), // Rule ID 4057 //
     /* 638646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 638649 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638656 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 638669 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 638669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP),
     /* 638672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 638677 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 638684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 638687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638691 */     GIR_RootConstrainSelectedInstOperands,
     /* 638692 */     // GIR_Coverage, 4057,
     /* 638692 */     GIR_EraseRootFromParent_Done,
     /* 638693 */   // Label 8194: @638693
     /* 638693 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(638749), // Rule ID 4059 //
     /* 638698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 638701 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 638723 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 638723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_RTN),
     /* 638726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 638728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 638733 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 638740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 638743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638747 */     GIR_RootConstrainSelectedInstOperands,
     /* 638748 */     // GIR_Coverage, 4059,
     /* 638748 */     GIR_EraseRootFromParent_Done,
     /* 638749 */   // Label 8195: @638749
     /* 638749 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(638802), // Rule ID 3694 //
     /* 638754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 638757 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638765 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 638778 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 638778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
     /* 638781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 638786 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 638793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 638796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638800 */     GIR_RootConstrainSelectedInstOperands,
     /* 638801 */     // GIR_Coverage, 3694,
     /* 638801 */     GIR_EraseRootFromParent_Done,
     /* 638802 */   // Label 8196: @638802
     /* 638802 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(638854), // Rule ID 3754 //
     /* 638807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 638810 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638817 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 638830 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 638830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
     /* 638833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 638838 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 638845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 638848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638852 */     GIR_RootConstrainSelectedInstOperands,
     /* 638853 */     // GIR_Coverage, 3754,
     /* 638853 */     GIR_EraseRootFromParent_Done,
     /* 638854 */   // Label 8197: @638854
     /* 638854 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(638911), // Rule ID 3693 //
     /* 638859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 638862 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 638885 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 638885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
     /* 638888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 638890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 638895 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 638902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 638905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638909 */     GIR_RootConstrainSelectedInstOperands,
     /* 638910 */     // GIR_Coverage, 3693,
     /* 638910 */     GIR_EraseRootFromParent_Done,
     /* 638911 */   // Label 8198: @638911
     /* 638911 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(638967), // Rule ID 3753 //
     /* 638916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 638919 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 638930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 638941 */     // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9743:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
     /* 638941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
     /* 638944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 638946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 638951 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 638953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 638958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 638961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 638965 */     GIR_RootConstrainSelectedInstOperands,
     /* 638966 */     // GIR_Coverage, 3753,
     /* 638966 */     GIR_EraseRootFromParent_Done,
     /* 638967 */   // Label 8199: @638967
     /* 638967 */   GIM_Reject,
     /* 638968 */ // Label 8183: @638968
     /* 638968 */ GIM_Reject,
     /* 638969 */ // Label 8181: @638969
     /* 638969 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(640110),
     /* 638974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 638977 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(639039), // Rule ID 5819 //
     /* 638982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 638985 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 638992 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 638994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 638998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 639005 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 639005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64),
     /* 639008 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 639010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 639015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 639025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 639030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639037 */     GIR_RootConstrainSelectedInstOperands,
     /* 639038 */     // GIR_Coverage, 5819,
     /* 639038 */     GIR_EraseRootFromParent_Done,
     /* 639039 */   // Label 8201: @639039
     /* 639039 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(639098), // Rule ID 5823 //
     /* 639044 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639051 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 639064 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 639064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64),
     /* 639067 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 639069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 639074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 639084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 639089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639096 */     GIR_RootConstrainSelectedInstOperands,
     /* 639097 */     // GIR_Coverage, 5823,
     /* 639097 */     GIR_EraseRootFromParent_Done,
     /* 639098 */   // Label 8202: @639098
     /* 639098 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(639216), // Rule ID 5817 //
     /* 639103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639106 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 639128 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 639128 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 639131 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN),
     /* 639135 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639140 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 639144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 639149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 639159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 639164 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 639167 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 639173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 639188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 639198 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 639205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639215 */     // GIR_Coverage, 5817,
     /* 639215 */     GIR_EraseRootFromParent_Done,
     /* 639216 */   // Label 8203: @639216
     /* 639216 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(639331), // Rule ID 5821 //
     /* 639221 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
     /* 639243 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 639243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 639246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN),
     /* 639250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 639259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
     /* 639264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
     /* 639274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
     /* 639279 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 639282 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 639288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 639303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 639313 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 639320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639330 */     // GIR_Coverage, 5821,
     /* 639330 */     GIR_EraseRootFromParent_Done,
     /* 639331 */   // Label 8204: @639331
     /* 639331 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(639388), // Rule ID 5818 //
     /* 639336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639339 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639346 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 639359 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 639359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
     /* 639362 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 639364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 639374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 639379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639386 */     GIR_RootConstrainSelectedInstOperands,
     /* 639387 */     // GIR_Coverage, 5818,
     /* 639387 */     GIR_EraseRootFromParent_Done,
     /* 639388 */   // Label 8205: @639388
     /* 639388 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(639442), // Rule ID 5822 //
     /* 639393 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639400 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 639413 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
     /* 639413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
     /* 639416 */     GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
     /* 639418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 639428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 639433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639440 */     GIR_RootConstrainSelectedInstOperands,
     /* 639441 */     // GIR_Coverage, 5822,
     /* 639441 */     GIR_EraseRootFromParent_Done,
     /* 639442 */   // Label 8206: @639442
     /* 639442 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(639555), // Rule ID 5816 //
     /* 639447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 639450 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 639472 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 639472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 639475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
     /* 639479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639484 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 639488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 639498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 639503 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 639506 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 639512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639524 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 639527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 639537 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 639544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639554 */     // GIR_Coverage, 5816,
     /* 639554 */     GIR_EraseRootFromParent_Done,
     /* 639555 */   // Label 8207: @639555
     /* 639555 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(639665), // Rule ID 5820 //
     /* 639560 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
     /* 639582 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
     /* 639582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 639585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
     /* 639589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639594 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
     /* 639598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
     /* 639603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
     /* 639608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 639613 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 639616 */     GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 639622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 639625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 639634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 639637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 639645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 639647 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 639654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 639659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 639664 */     // GIR_Coverage, 5820,
     /* 639664 */     GIR_EraseRootFromParent_Done,
     /* 639665 */   // Label 8208: @639665
     /* 639665 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(639722), // Rule ID 4114 //
     /* 639670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 639673 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639680 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 639693 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 639693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR),
     /* 639696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 639701 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 639703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 639708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 639713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639720 */     GIR_RootConstrainSelectedInstOperands,
     /* 639721 */     // GIR_Coverage, 4114,
     /* 639721 */     GIR_EraseRootFromParent_Done,
     /* 639722 */   // Label 8209: @639722
     /* 639722 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(639783), // Rule ID 4116 //
     /* 639727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 639730 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
     /* 639752 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
     /* 639752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN),
     /* 639755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 639757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
     /* 639762 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 639764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
     /* 639769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 639774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 639777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639781 */     GIR_RootConstrainSelectedInstOperands,
     /* 639782 */     // GIR_Coverage, 4116,
     /* 639782 */     GIR_EraseRootFromParent_Done,
     /* 639783 */   // Label 8210: @639783
     /* 639783 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(639835), // Rule ID 4113 //
     /* 639788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 639791 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639798 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 639811 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 639811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2),
     /* 639814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 639819 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 639821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 639826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639833 */     GIR_RootConstrainSelectedInstOperands,
     /* 639834 */     // GIR_Coverage, 4113,
     /* 639834 */     GIR_EraseRootFromParent_Done,
     /* 639835 */   // Label 8211: @639835
     /* 639835 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(639891), // Rule ID 4115 //
     /* 639840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
     /* 639843 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 639854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
     /* 639865 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 639865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_RTN),
     /* 639868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 639870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 639875 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 639877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 639882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 639885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639889 */     GIR_RootConstrainSelectedInstOperands,
     /* 639890 */     // GIR_Coverage, 4115,
     /* 639890 */     GIR_EraseRootFromParent_Done,
     /* 639891 */   // Label 8212: @639891
     /* 639891 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(639944), // Rule ID 3720 //
     /* 639896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 639899 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639907 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 639920 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 639920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
     /* 639923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 639928 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 639930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 639935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639942 */     GIR_RootConstrainSelectedInstOperands,
     /* 639943 */     // GIR_Coverage, 3720,
     /* 639943 */     GIR_EraseRootFromParent_Done,
     /* 639944 */   // Label 8213: @639944
     /* 639944 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(639996), // Rule ID 3780 //
     /* 639949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 639952 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 639959 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 639961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 639965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 639972 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 639972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
     /* 639975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 639980 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 639982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 639987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 639990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 639994 */     GIR_RootConstrainSelectedInstOperands,
     /* 639995 */     // GIR_Coverage, 3780,
     /* 639995 */     GIR_EraseRootFromParent_Done,
     /* 639996 */   // Label 8214: @639996
     /* 639996 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(640053), // Rule ID 3719 //
     /* 640001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 640004 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 640012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 640020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 640027 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 640027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
     /* 640030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 640032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 640037 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 640039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 640044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 640047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640051 */     GIR_RootConstrainSelectedInstOperands,
     /* 640052 */     // GIR_Coverage, 3719,
     /* 640052 */     GIR_EraseRootFromParent_Done,
     /* 640053 */   // Label 8215: @640053
     /* 640053 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(640109), // Rule ID 3779 //
     /* 640058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
     /* 640061 */     GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
     /* 640068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 640072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 640076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
     /* 640083 */     // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9741:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
     /* 640083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
     /* 640086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 640088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
     /* 640093 */     GIR_RootToRootCopy, /*OpIdx*/2, // data
     /* 640095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 640100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 640103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640107 */     GIR_RootConstrainSelectedInstOperands,
     /* 640108 */     // GIR_Coverage, 3779,
     /* 640108 */     GIR_EraseRootFromParent_Done,
     /* 640109 */   // Label 8216: @640109
     /* 640109 */   GIM_Reject,
     /* 640110 */ // Label 8200: @640110
     /* 640110 */ GIM_Reject,
     /* 640111 */ // Label 8182: @640111
     /* 640111 */ GIM_Reject,
     /* 640112 */ // Label 108: @640112
     /* 640112 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8219*/ GIMT_Encode4(642495),
     /* 640123 */ /*GILLT_s32*//*Label 8217*/ GIMT_Encode4(640131),
     /* 640127 */ /*GILLT_s64*//*Label 8218*/ GIMT_Encode4(641313),
     /* 640131 */ // Label 8217: @640131
     /* 640131 */ GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(641312),
     /* 640136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 640139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 640142 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 640145 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 640148 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 640151 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(640219), // Rule ID 5860 //
     /* 640156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640159 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640169 */     // MIs[0] offset
     /* 640169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640172 */     // MIs[0] auxiliary
     /* 640172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640175 */     // MIs[0] Operand 8
     /* 640175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640193 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
     /* 640196 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640205 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640217 */     GIR_RootConstrainSelectedInstOperands,
     /* 640218 */     // GIR_Coverage, 5860,
     /* 640218 */     GIR_EraseRootFromParent_Done,
     /* 640219 */   // Label 8221: @640219
     /* 640219 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(640284), // Rule ID 5868 //
     /* 640224 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640234 */     // MIs[0] offset
     /* 640234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640237 */     // MIs[0] auxiliary
     /* 640237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640240 */     // MIs[0] Operand 8
     /* 640240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640258 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
     /* 640261 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640270 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640272 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640282 */     GIR_RootConstrainSelectedInstOperands,
     /* 640283 */     // GIR_Coverage, 5868,
     /* 640283 */     GIR_EraseRootFromParent_Done,
     /* 640284 */   // Label 8222: @640284
     /* 640284 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(640356), // Rule ID 5856 //
     /* 640289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640304 */     // MIs[0] offset
     /* 640304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640307 */     // MIs[0] auxiliary
     /* 640307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640310 */     // MIs[0] Operand 8
     /* 640310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640328 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
     /* 640331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640333 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640342 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640344 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640354 */     GIR_RootConstrainSelectedInstOperands,
     /* 640355 */     // GIR_Coverage, 5856,
     /* 640355 */     GIR_EraseRootFromParent_Done,
     /* 640356 */   // Label 8223: @640356
     /* 640356 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(640425), // Rule ID 5864 //
     /* 640361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640373 */     // MIs[0] offset
     /* 640373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640376 */     // MIs[0] auxiliary
     /* 640376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640379 */     // MIs[0] Operand 8
     /* 640379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640397 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
     /* 640400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640402 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640411 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640423 */     GIR_RootConstrainSelectedInstOperands,
     /* 640424 */     // GIR_Coverage, 5864,
     /* 640424 */     GIR_EraseRootFromParent_Done,
     /* 640425 */   // Label 8224: @640425
     /* 640425 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(640491), // Rule ID 5862 //
     /* 640430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640433 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640439 */     // MIs[0] offset
     /* 640439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640442 */     // MIs[0] auxiliary
     /* 640442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640445 */     // MIs[0] Operand 8
     /* 640445 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640463 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN),
     /* 640466 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640468 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 640470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640477 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640489 */     GIR_RootConstrainSelectedInstOperands,
     /* 640490 */     // GIR_Coverage, 5862,
     /* 640490 */     GIR_EraseRootFromParent_Done,
     /* 640491 */   // Label 8225: @640491
     /* 640491 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(640554), // Rule ID 5870 //
     /* 640496 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640502 */     // MIs[0] offset
     /* 640502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640505 */     // MIs[0] auxiliary
     /* 640505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640508 */     // MIs[0] Operand 8
     /* 640508 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640526 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN),
     /* 640529 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640531 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 640533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640540 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640542 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640552 */     GIR_RootConstrainSelectedInstOperands,
     /* 640553 */     // GIR_Coverage, 5870,
     /* 640553 */     GIR_EraseRootFromParent_Done,
     /* 640554 */   // Label 8226: @640554
     /* 640554 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(640624), // Rule ID 5858 //
     /* 640559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640570 */     // MIs[0] offset
     /* 640570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640573 */     // MIs[0] auxiliary
     /* 640573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640576 */     // MIs[0] Operand 8
     /* 640576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640594 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN_RTN),
     /* 640597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640599 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640601 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 640603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640610 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640622 */     GIR_RootConstrainSelectedInstOperands,
     /* 640623 */     // GIR_Coverage, 5858,
     /* 640623 */     GIR_EraseRootFromParent_Done,
     /* 640624 */   // Label 8227: @640624
     /* 640624 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(640691), // Rule ID 5866 //
     /* 640629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 640637 */     // MIs[0] offset
     /* 640637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640640 */     // MIs[0] auxiliary
     /* 640640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640643 */     // MIs[0] Operand 8
     /* 640643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 640654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640661 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN),
     /* 640664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640666 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640668 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 640670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640677 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640679 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640689 */     GIR_RootConstrainSelectedInstOperands,
     /* 640690 */     // GIR_Coverage, 5866,
     /* 640690 */     GIR_EraseRootFromParent_Done,
     /* 640691 */   // Label 8228: @640691
     /* 640691 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(640749), // Rule ID 5861 //
     /* 640696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640699 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640705 */     // MIs[0] offset
     /* 640705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640708 */     // MIs[0] auxiliary
     /* 640708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640711 */     // MIs[0] Operand 8
     /* 640711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640721 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN),
     /* 640724 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640726 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640735 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640737 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640747 */     GIR_RootConstrainSelectedInstOperands,
     /* 640748 */     // GIR_Coverage, 5861,
     /* 640748 */     GIR_EraseRootFromParent_Done,
     /* 640749 */   // Label 8229: @640749
     /* 640749 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(640804), // Rule ID 5869 //
     /* 640754 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640760 */     // MIs[0] offset
     /* 640760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640763 */     // MIs[0] auxiliary
     /* 640763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640766 */     // MIs[0] Operand 8
     /* 640766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640776 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN),
     /* 640779 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640781 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640790 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 640798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640802 */     GIR_RootConstrainSelectedInstOperands,
     /* 640803 */     // GIR_Coverage, 5869,
     /* 640803 */     GIR_EraseRootFromParent_Done,
     /* 640804 */   // Label 8230: @640804
     /* 640804 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(640866), // Rule ID 5857 //
     /* 640809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640820 */     // MIs[0] offset
     /* 640820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640823 */     // MIs[0] auxiliary
     /* 640823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640826 */     // MIs[0] Operand 8
     /* 640826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640836 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN_RTN),
     /* 640839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640841 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640843 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640852 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640864 */     GIR_RootConstrainSelectedInstOperands,
     /* 640865 */     // GIR_Coverage, 5857,
     /* 640865 */     GIR_EraseRootFromParent_Done,
     /* 640866 */   // Label 8231: @640866
     /* 640866 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(640925), // Rule ID 5865 //
     /* 640871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 640875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 640879 */     // MIs[0] offset
     /* 640879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640882 */     // MIs[0] auxiliary
     /* 640882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640885 */     // MIs[0] Operand 8
     /* 640885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640895 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN),
     /* 640898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 640900 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640902 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 640904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 640906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 640911 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 640913 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 640919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 640923 */     GIR_RootConstrainSelectedInstOperands,
     /* 640924 */     // GIR_Coverage, 5865,
     /* 640924 */     GIR_EraseRootFromParent_Done,
     /* 640925 */   // Label 8232: @640925
     /* 640925 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(641021), // Rule ID 5863 //
     /* 640930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 640933 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 640935 */     // MIs[0] offset
     /* 640935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 640938 */     // MIs[0] auxiliary
     /* 640938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 640941 */     // MIs[0] Operand 8
     /* 640941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 640944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 640951 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 640951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 640954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 640958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 640963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 640967 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 640970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 640974 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 640977 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 640982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 640992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN),
     /* 640995 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 640997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641007 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641019 */     GIR_RootConstrainSelectedInstOperands,
     /* 641020 */     // GIR_Coverage, 5863,
     /* 641020 */     GIR_EraseRootFromParent_Done,
     /* 641021 */   // Label 8233: @641021
     /* 641021 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(641114), // Rule ID 5871 //
     /* 641026 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641028 */     // MIs[0] offset
     /* 641028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641031 */     // MIs[0] auxiliary
     /* 641031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641034 */     // MIs[0] Operand 8
     /* 641034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641044 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 641060 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 641067 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN),
     /* 641088 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641100 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641102 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641112 */     GIR_RootConstrainSelectedInstOperands,
     /* 641113 */     // GIR_Coverage, 5871,
     /* 641113 */     GIR_EraseRootFromParent_Done,
     /* 641114 */   // Label 8234: @641114
     /* 641114 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(641214), // Rule ID 5859 //
     /* 641119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641126 */     // MIs[0] offset
     /* 641126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641129 */     // MIs[0] auxiliary
     /* 641129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641132 */     // MIs[0] Operand 8
     /* 641132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641142 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 641158 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 641165 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN_RTN),
     /* 641186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 641188 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641200 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641212 */     GIR_RootConstrainSelectedInstOperands,
     /* 641213 */     // GIR_Coverage, 5859,
     /* 641213 */     GIR_EraseRootFromParent_Done,
     /* 641214 */   // Label 8235: @641214
     /* 641214 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(641311), // Rule ID 5867 //
     /* 641219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 641223 */     // MIs[0] offset
     /* 641223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641226 */     // MIs[0] auxiliary
     /* 641226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641229 */     // MIs[0] Operand 8
     /* 641229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641239 */     // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 641242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 641246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 641251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 641255 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 641258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 641262 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 641265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 641270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 641280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN),
     /* 641283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 641285 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 641290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641297 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641309 */     GIR_RootConstrainSelectedInstOperands,
     /* 641310 */     // GIR_Coverage, 5867,
     /* 641310 */     GIR_EraseRootFromParent_Done,
     /* 641311 */   // Label 8236: @641311
     /* 641311 */   GIM_Reject,
     /* 641312 */ // Label 8220: @641312
     /* 641312 */ GIM_Reject,
     /* 641313 */ // Label 8218: @641313
     /* 641313 */ GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(642494),
     /* 641318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 641321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 641324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 641327 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 641330 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 641333 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(641401), // Rule ID 6060 //
     /* 641338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641341 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641351 */     // MIs[0] offset
     /* 641351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641354 */     // MIs[0] auxiliary
     /* 641354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641357 */     // MIs[0] Operand 8
     /* 641357 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641375 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
     /* 641378 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641387 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641389 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641399 */     GIR_RootConstrainSelectedInstOperands,
     /* 641400 */     // GIR_Coverage, 6060,
     /* 641400 */     GIR_EraseRootFromParent_Done,
     /* 641401 */   // Label 8238: @641401
     /* 641401 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(641466), // Rule ID 6068 //
     /* 641406 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641416 */     // MIs[0] offset
     /* 641416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641419 */     // MIs[0] auxiliary
     /* 641419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641422 */     // MIs[0] Operand 8
     /* 641422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641440 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
     /* 641443 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641452 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641464 */     GIR_RootConstrainSelectedInstOperands,
     /* 641465 */     // GIR_Coverage, 6068,
     /* 641465 */     GIR_EraseRootFromParent_Done,
     /* 641466 */   // Label 8239: @641466
     /* 641466 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(641538), // Rule ID 6056 //
     /* 641471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641486 */     // MIs[0] offset
     /* 641486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641489 */     // MIs[0] auxiliary
     /* 641489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641492 */     // MIs[0] Operand 8
     /* 641492 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641510 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
     /* 641513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 641515 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641524 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641536 */     GIR_RootConstrainSelectedInstOperands,
     /* 641537 */     // GIR_Coverage, 6056,
     /* 641537 */     GIR_EraseRootFromParent_Done,
     /* 641538 */   // Label 8240: @641538
     /* 641538 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(641607), // Rule ID 6064 //
     /* 641543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641555 */     // MIs[0] offset
     /* 641555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641558 */     // MIs[0] auxiliary
     /* 641558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641561 */     // MIs[0] Operand 8
     /* 641561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641579 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
     /* 641582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 641584 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641593 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641605 */     GIR_RootConstrainSelectedInstOperands,
     /* 641606 */     // GIR_Coverage, 6064,
     /* 641606 */     GIR_EraseRootFromParent_Done,
     /* 641607 */   // Label 8241: @641607
     /* 641607 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(641673), // Rule ID 6062 //
     /* 641612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641615 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641621 */     // MIs[0] offset
     /* 641621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641624 */     // MIs[0] auxiliary
     /* 641624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641627 */     // MIs[0] Operand 8
     /* 641627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641645 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN),
     /* 641648 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641650 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 641652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641659 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641671 */     GIR_RootConstrainSelectedInstOperands,
     /* 641672 */     // GIR_Coverage, 6062,
     /* 641672 */     GIR_EraseRootFromParent_Done,
     /* 641673 */   // Label 8242: @641673
     /* 641673 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(641736), // Rule ID 6070 //
     /* 641678 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641684 */     // MIs[0] offset
     /* 641684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641687 */     // MIs[0] auxiliary
     /* 641687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641690 */     // MIs[0] Operand 8
     /* 641690 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641708 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN),
     /* 641711 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641713 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 641715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641722 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641734 */     GIR_RootConstrainSelectedInstOperands,
     /* 641735 */     // GIR_Coverage, 6070,
     /* 641735 */     GIR_EraseRootFromParent_Done,
     /* 641736 */   // Label 8243: @641736
     /* 641736 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(641806), // Rule ID 6058 //
     /* 641741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641752 */     // MIs[0] offset
     /* 641752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641755 */     // MIs[0] auxiliary
     /* 641755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641758 */     // MIs[0] Operand 8
     /* 641758 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641776 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN_RTN),
     /* 641779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 641781 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641783 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 641785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641792 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641804 */     GIR_RootConstrainSelectedInstOperands,
     /* 641805 */     // GIR_Coverage, 6058,
     /* 641805 */     GIR_EraseRootFromParent_Done,
     /* 641806 */   // Label 8244: @641806
     /* 641806 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(641873), // Rule ID 6066 //
     /* 641811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 641819 */     // MIs[0] offset
     /* 641819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641822 */     // MIs[0] auxiliary
     /* 641822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641825 */     // MIs[0] Operand 8
     /* 641825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 641836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641843 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN),
     /* 641846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 641848 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641850 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 641852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641859 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 641867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641871 */     GIR_RootConstrainSelectedInstOperands,
     /* 641872 */     // GIR_Coverage, 6066,
     /* 641872 */     GIR_EraseRootFromParent_Done,
     /* 641873 */   // Label 8245: @641873
     /* 641873 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(641931), // Rule ID 6061 //
     /* 641878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641881 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641887 */     // MIs[0] offset
     /* 641887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641890 */     // MIs[0] auxiliary
     /* 641890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641893 */     // MIs[0] Operand 8
     /* 641893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641903 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN),
     /* 641906 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641908 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 641910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641917 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641929 */     GIR_RootConstrainSelectedInstOperands,
     /* 641930 */     // GIR_Coverage, 6061,
     /* 641930 */     GIR_EraseRootFromParent_Done,
     /* 641931 */   // Label 8246: @641931
     /* 641931 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(641986), // Rule ID 6069 //
     /* 641936 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 641938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 641942 */     // MIs[0] offset
     /* 641942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 641945 */     // MIs[0] auxiliary
     /* 641945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 641948 */     // MIs[0] Operand 8
     /* 641948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 641951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 641958 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 641958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN),
     /* 641961 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 641963 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 641965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 641967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 641972 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 641974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 641980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 641984 */     GIR_RootConstrainSelectedInstOperands,
     /* 641985 */     // GIR_Coverage, 6069,
     /* 641985 */     GIR_EraseRootFromParent_Done,
     /* 641986 */   // Label 8247: @641986
     /* 641986 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(642048), // Rule ID 6057 //
     /* 641991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 641994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 641998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642002 */     // MIs[0] offset
     /* 642002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642005 */     // MIs[0] auxiliary
     /* 642005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642008 */     // MIs[0] Operand 8
     /* 642008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642018 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN_RTN),
     /* 642021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 642023 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642025 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 642027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642034 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642046 */     GIR_RootConstrainSelectedInstOperands,
     /* 642047 */     // GIR_Coverage, 6057,
     /* 642047 */     GIR_EraseRootFromParent_Done,
     /* 642048 */   // Label 8248: @642048
     /* 642048 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(642107), // Rule ID 6065 //
     /* 642053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642061 */     // MIs[0] offset
     /* 642061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642064 */     // MIs[0] auxiliary
     /* 642064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642067 */     // MIs[0] Operand 8
     /* 642067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642077 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN),
     /* 642080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 642082 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642084 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 642086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642093 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642105 */     GIR_RootConstrainSelectedInstOperands,
     /* 642106 */     // GIR_Coverage, 6065,
     /* 642106 */     GIR_EraseRootFromParent_Done,
     /* 642107 */   // Label 8249: @642107
     /* 642107 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(642203), // Rule ID 6063 //
     /* 642112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642115 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642117 */     // MIs[0] offset
     /* 642117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642120 */     // MIs[0] auxiliary
     /* 642120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642123 */     // MIs[0] Operand 8
     /* 642123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642133 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 642149 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 642156 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN),
     /* 642177 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642189 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642201 */     GIR_RootConstrainSelectedInstOperands,
     /* 642202 */     // GIR_Coverage, 6063,
     /* 642202 */     GIR_EraseRootFromParent_Done,
     /* 642203 */   // Label 8250: @642203
     /* 642203 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(642296), // Rule ID 6071 //
     /* 642208 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642210 */     // MIs[0] offset
     /* 642210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642213 */     // MIs[0] auxiliary
     /* 642213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642216 */     // MIs[0] Operand 8
     /* 642216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642226 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 642242 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 642249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN),
     /* 642270 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642282 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642294 */     GIR_RootConstrainSelectedInstOperands,
     /* 642295 */     // GIR_Coverage, 6071,
     /* 642295 */     GIR_EraseRootFromParent_Done,
     /* 642296 */   // Label 8251: @642296
     /* 642296 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(642396), // Rule ID 6059 //
     /* 642301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642308 */     // MIs[0] offset
     /* 642308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642311 */     // MIs[0] auxiliary
     /* 642311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642314 */     // MIs[0] Operand 8
     /* 642314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642324 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 642340 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 642347 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN),
     /* 642368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 642370 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642382 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642394 */     GIR_RootConstrainSelectedInstOperands,
     /* 642395 */     // GIR_Coverage, 6059,
     /* 642395 */     GIR_EraseRootFromParent_Done,
     /* 642396 */   // Label 8252: @642396
     /* 642396 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(642493), // Rule ID 6067 //
     /* 642401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 642405 */     // MIs[0] offset
     /* 642405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642408 */     // MIs[0] auxiliary
     /* 642408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642411 */     // MIs[0] Operand 8
     /* 642411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 642414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642421 */     // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 642424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 642428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 642433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 642437 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 642440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 642444 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 642447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 642452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 642462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN),
     /* 642465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 642467 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 642472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642479 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642491 */     GIR_RootConstrainSelectedInstOperands,
     /* 642492 */     // GIR_Coverage, 6067,
     /* 642492 */     GIR_EraseRootFromParent_Done,
     /* 642493 */   // Label 8253: @642493
     /* 642493 */   GIM_Reject,
     /* 642494 */ // Label 8237: @642494
     /* 642494 */ GIM_Reject,
     /* 642495 */ // Label 8219: @642495
     /* 642495 */ GIM_Reject,
     /* 642496 */ // Label 109: @642496
     /* 642496 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8256*/ GIMT_Encode4(644879),
     /* 642507 */ /*GILLT_s32*//*Label 8254*/ GIMT_Encode4(642515),
     /* 642511 */ /*GILLT_s64*//*Label 8255*/ GIMT_Encode4(643697),
     /* 642515 */ // Label 8254: @642515
     /* 642515 */ GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(643696),
     /* 642520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 642523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 642526 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 642529 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 642532 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 642535 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(642603), // Rule ID 5956 //
     /* 642540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642543 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 642549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642553 */     // MIs[0] offset
     /* 642553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642556 */     // MIs[0] auxiliary
     /* 642556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642559 */     // MIs[0] Operand 8
     /* 642559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 642570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642577 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
     /* 642580 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642589 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642601 */     GIR_RootConstrainSelectedInstOperands,
     /* 642602 */     // GIR_Coverage, 5956,
     /* 642602 */     GIR_EraseRootFromParent_Done,
     /* 642603 */   // Label 8258: @642603
     /* 642603 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(642668), // Rule ID 5964 //
     /* 642608 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 642614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642618 */     // MIs[0] offset
     /* 642618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642621 */     // MIs[0] auxiliary
     /* 642621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642624 */     // MIs[0] Operand 8
     /* 642624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 642635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642642 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
     /* 642645 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642654 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642666 */     GIR_RootConstrainSelectedInstOperands,
     /* 642667 */     // GIR_Coverage, 5964,
     /* 642667 */     GIR_EraseRootFromParent_Done,
     /* 642668 */   // Label 8259: @642668
     /* 642668 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(642740), // Rule ID 5952 //
     /* 642673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 642684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642688 */     // MIs[0] offset
     /* 642688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642691 */     // MIs[0] auxiliary
     /* 642691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642694 */     // MIs[0] Operand 8
     /* 642694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 642705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642712 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
     /* 642715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 642717 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642726 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642738 */     GIR_RootConstrainSelectedInstOperands,
     /* 642739 */     // GIR_Coverage, 5952,
     /* 642739 */     GIR_EraseRootFromParent_Done,
     /* 642740 */   // Label 8260: @642740
     /* 642740 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(642809), // Rule ID 5960 //
     /* 642745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 642753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 642757 */     // MIs[0] offset
     /* 642757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642760 */     // MIs[0] auxiliary
     /* 642760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642763 */     // MIs[0] Operand 8
     /* 642763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 642774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642781 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
     /* 642784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 642786 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642795 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 642803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642807 */     GIR_RootConstrainSelectedInstOperands,
     /* 642808 */     // GIR_Coverage, 5960,
     /* 642808 */     GIR_EraseRootFromParent_Done,
     /* 642809 */   // Label 8261: @642809
     /* 642809 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(642875), // Rule ID 5958 //
     /* 642814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642817 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 642823 */     // MIs[0] offset
     /* 642823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642826 */     // MIs[0] auxiliary
     /* 642826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642829 */     // MIs[0] Operand 8
     /* 642829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 642840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642847 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN),
     /* 642850 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642852 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 642854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642861 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642863 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642873 */     GIR_RootConstrainSelectedInstOperands,
     /* 642874 */     // GIR_Coverage, 5958,
     /* 642874 */     GIR_EraseRootFromParent_Done,
     /* 642875 */   // Label 8262: @642875
     /* 642875 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(642938), // Rule ID 5966 //
     /* 642880 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 642882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 642886 */     // MIs[0] offset
     /* 642886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642889 */     // MIs[0] auxiliary
     /* 642889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642892 */     // MIs[0] Operand 8
     /* 642892 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 642903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642910 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN),
     /* 642913 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642915 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 642917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642924 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 642932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 642936 */     GIR_RootConstrainSelectedInstOperands,
     /* 642937 */     // GIR_Coverage, 5966,
     /* 642937 */     GIR_EraseRootFromParent_Done,
     /* 642938 */   // Label 8263: @642938
     /* 642938 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(643008), // Rule ID 5954 //
     /* 642943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 642946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 642950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 642954 */     // MIs[0] offset
     /* 642954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 642957 */     // MIs[0] auxiliary
     /* 642957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 642960 */     // MIs[0] Operand 8
     /* 642960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 642971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 642978 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 642978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN_RTN),
     /* 642981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 642983 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 642985 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 642987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 642989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 642994 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 642996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643006 */     GIR_RootConstrainSelectedInstOperands,
     /* 643007 */     // GIR_Coverage, 5954,
     /* 643007 */     GIR_EraseRootFromParent_Done,
     /* 643008 */   // Label 8264: @643008
     /* 643008 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(643075), // Rule ID 5962 //
     /* 643013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 643017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 643021 */     // MIs[0] offset
     /* 643021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643024 */     // MIs[0] auxiliary
     /* 643024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643027 */     // MIs[0] Operand 8
     /* 643027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 643038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643045 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN),
     /* 643048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 643050 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643052 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 643054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643061 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643073 */     GIR_RootConstrainSelectedInstOperands,
     /* 643074 */     // GIR_Coverage, 5962,
     /* 643074 */     GIR_EraseRootFromParent_Done,
     /* 643075 */   // Label 8265: @643075
     /* 643075 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(643133), // Rule ID 5957 //
     /* 643080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643083 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643089 */     // MIs[0] offset
     /* 643089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643092 */     // MIs[0] auxiliary
     /* 643092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643095 */     // MIs[0] Operand 8
     /* 643095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643105 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN),
     /* 643108 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643110 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 643112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643119 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643131 */     GIR_RootConstrainSelectedInstOperands,
     /* 643132 */     // GIR_Coverage, 5957,
     /* 643132 */     GIR_EraseRootFromParent_Done,
     /* 643133 */   // Label 8266: @643133
     /* 643133 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(643188), // Rule ID 5965 //
     /* 643138 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643144 */     // MIs[0] offset
     /* 643144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643147 */     // MIs[0] auxiliary
     /* 643147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643150 */     // MIs[0] Operand 8
     /* 643150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643160 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN),
     /* 643163 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643165 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 643167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643174 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643186 */     GIR_RootConstrainSelectedInstOperands,
     /* 643187 */     // GIR_Coverage, 5965,
     /* 643187 */     GIR_EraseRootFromParent_Done,
     /* 643188 */   // Label 8267: @643188
     /* 643188 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(643250), // Rule ID 5953 //
     /* 643193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 643200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643204 */     // MIs[0] offset
     /* 643204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643207 */     // MIs[0] auxiliary
     /* 643207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643210 */     // MIs[0] Operand 8
     /* 643210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643220 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN_RTN),
     /* 643223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 643225 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643227 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 643229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643236 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643248 */     GIR_RootConstrainSelectedInstOperands,
     /* 643249 */     // GIR_Coverage, 5953,
     /* 643249 */     GIR_EraseRootFromParent_Done,
     /* 643250 */   // Label 8268: @643250
     /* 643250 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(643309), // Rule ID 5961 //
     /* 643255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 643259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643263 */     // MIs[0] offset
     /* 643263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643266 */     // MIs[0] auxiliary
     /* 643266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643269 */     // MIs[0] Operand 8
     /* 643269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643279 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN),
     /* 643282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 643284 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643286 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 643288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643295 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643307 */     GIR_RootConstrainSelectedInstOperands,
     /* 643308 */     // GIR_Coverage, 5961,
     /* 643308 */     GIR_EraseRootFromParent_Done,
     /* 643309 */   // Label 8269: @643309
     /* 643309 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(643405), // Rule ID 5959 //
     /* 643314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643317 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643319 */     // MIs[0] offset
     /* 643319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643322 */     // MIs[0] auxiliary
     /* 643322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643325 */     // MIs[0] Operand 8
     /* 643325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643335 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 643338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 643351 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 643354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 643358 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 643361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN),
     /* 643379 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643391 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643393 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643403 */     GIR_RootConstrainSelectedInstOperands,
     /* 643404 */     // GIR_Coverage, 5959,
     /* 643404 */     GIR_EraseRootFromParent_Done,
     /* 643405 */   // Label 8270: @643405
     /* 643405 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(643498), // Rule ID 5967 //
     /* 643410 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643412 */     // MIs[0] offset
     /* 643412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643415 */     // MIs[0] auxiliary
     /* 643415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643418 */     // MIs[0] Operand 8
     /* 643418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643428 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 643431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 643444 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 643447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 643451 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 643454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN),
     /* 643472 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643484 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643496 */     GIR_RootConstrainSelectedInstOperands,
     /* 643497 */     // GIR_Coverage, 5967,
     /* 643497 */     GIR_EraseRootFromParent_Done,
     /* 643498 */   // Label 8271: @643498
     /* 643498 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(643598), // Rule ID 5955 //
     /* 643503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 643510 */     // MIs[0] offset
     /* 643510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643513 */     // MIs[0] auxiliary
     /* 643513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643516 */     // MIs[0] Operand 8
     /* 643516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643526 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 643529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 643542 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 643545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 643549 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 643552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN_RTN),
     /* 643570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 643572 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643584 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643596 */     GIR_RootConstrainSelectedInstOperands,
     /* 643597 */     // GIR_Coverage, 5955,
     /* 643597 */     GIR_EraseRootFromParent_Done,
     /* 643598 */   // Label 8272: @643598
     /* 643598 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(643695), // Rule ID 5963 //
     /* 643603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 643607 */     // MIs[0] offset
     /* 643607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643610 */     // MIs[0] auxiliary
     /* 643610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643613 */     // MIs[0] Operand 8
     /* 643613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 643616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643623 */     // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 643626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 643630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 643635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 643639 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 643642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 643646 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 643649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 643654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 643664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN),
     /* 643667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 643669 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 643674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643681 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643683 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643693 */     GIR_RootConstrainSelectedInstOperands,
     /* 643694 */     // GIR_Coverage, 5963,
     /* 643694 */     GIR_EraseRootFromParent_Done,
     /* 643695 */   // Label 8273: @643695
     /* 643695 */   GIM_Reject,
     /* 643696 */ // Label 8257: @643696
     /* 643696 */ GIM_Reject,
     /* 643697 */ // Label 8255: @643697
     /* 643697 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(644878),
     /* 643702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 643705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 643708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 643711 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 643714 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 643717 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(643785), // Rule ID 6156 //
     /* 643722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643725 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 643731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643735 */     // MIs[0] offset
     /* 643735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643738 */     // MIs[0] auxiliary
     /* 643738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643741 */     // MIs[0] Operand 8
     /* 643741 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 643752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643759 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
     /* 643762 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643771 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643783 */     GIR_RootConstrainSelectedInstOperands,
     /* 643784 */     // GIR_Coverage, 6156,
     /* 643784 */     GIR_EraseRootFromParent_Done,
     /* 643785 */   // Label 8275: @643785
     /* 643785 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(643850), // Rule ID 6164 //
     /* 643790 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 643792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 643796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643800 */     // MIs[0] offset
     /* 643800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643803 */     // MIs[0] auxiliary
     /* 643803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643806 */     // MIs[0] Operand 8
     /* 643806 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 643817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643824 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
     /* 643827 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643836 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 643844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643848 */     GIR_RootConstrainSelectedInstOperands,
     /* 643849 */     // GIR_Coverage, 6164,
     /* 643849 */     GIR_EraseRootFromParent_Done,
     /* 643850 */   // Label 8276: @643850
     /* 643850 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(643922), // Rule ID 6152 //
     /* 643855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 643866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643870 */     // MIs[0] offset
     /* 643870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643873 */     // MIs[0] auxiliary
     /* 643873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643876 */     // MIs[0] Operand 8
     /* 643876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 643887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643894 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
     /* 643897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 643899 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643908 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643920 */     GIR_RootConstrainSelectedInstOperands,
     /* 643921 */     // GIR_Coverage, 6152,
     /* 643921 */     GIR_EraseRootFromParent_Done,
     /* 643922 */   // Label 8277: @643922
     /* 643922 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(643991), // Rule ID 6160 //
     /* 643927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 643931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 643935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 643939 */     // MIs[0] offset
     /* 643939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 643942 */     // MIs[0] auxiliary
     /* 643942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 643945 */     // MIs[0] Operand 8
     /* 643945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 643956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 643963 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 643963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
     /* 643966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 643968 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 643970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 643972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 643977 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 643979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 643985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 643989 */     GIR_RootConstrainSelectedInstOperands,
     /* 643990 */     // GIR_Coverage, 6160,
     /* 643990 */     GIR_EraseRootFromParent_Done,
     /* 643991 */   // Label 8278: @643991
     /* 643991 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(644057), // Rule ID 6158 //
     /* 643996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 643999 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 644005 */     // MIs[0] offset
     /* 644005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644008 */     // MIs[0] auxiliary
     /* 644008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644011 */     // MIs[0] Operand 8
     /* 644011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 644022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644029 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN),
     /* 644032 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644034 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 644036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644043 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644055 */     GIR_RootConstrainSelectedInstOperands,
     /* 644056 */     // GIR_Coverage, 6158,
     /* 644056 */     GIR_EraseRootFromParent_Done,
     /* 644057 */   // Label 8279: @644057
     /* 644057 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(644120), // Rule ID 6166 //
     /* 644062 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 644068 */     // MIs[0] offset
     /* 644068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644071 */     // MIs[0] auxiliary
     /* 644071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644074 */     // MIs[0] Operand 8
     /* 644074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 644085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644092 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN),
     /* 644095 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644097 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 644099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644106 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644108 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644118 */     GIR_RootConstrainSelectedInstOperands,
     /* 644119 */     // GIR_Coverage, 6166,
     /* 644119 */     GIR_EraseRootFromParent_Done,
     /* 644120 */   // Label 8280: @644120
     /* 644120 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(644190), // Rule ID 6154 //
     /* 644125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 644136 */     // MIs[0] offset
     /* 644136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644139 */     // MIs[0] auxiliary
     /* 644139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644142 */     // MIs[0] Operand 8
     /* 644142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 644153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644160 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN_RTN),
     /* 644163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 644165 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644167 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 644169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644176 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644188 */     GIR_RootConstrainSelectedInstOperands,
     /* 644189 */     // GIR_Coverage, 6154,
     /* 644189 */     GIR_EraseRootFromParent_Done,
     /* 644190 */   // Label 8281: @644190
     /* 644190 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(644257), // Rule ID 6162 //
     /* 644195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 644203 */     // MIs[0] offset
     /* 644203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644206 */     // MIs[0] auxiliary
     /* 644206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644209 */     // MIs[0] Operand 8
     /* 644209 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 644220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644227 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN),
     /* 644230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 644232 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644234 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 644236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644243 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644255 */     GIR_RootConstrainSelectedInstOperands,
     /* 644256 */     // GIR_Coverage, 6162,
     /* 644256 */     GIR_EraseRootFromParent_Done,
     /* 644257 */   // Label 8282: @644257
     /* 644257 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(644315), // Rule ID 6157 //
     /* 644262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644265 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 644271 */     // MIs[0] offset
     /* 644271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644274 */     // MIs[0] auxiliary
     /* 644274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644277 */     // MIs[0] Operand 8
     /* 644277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644287 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN),
     /* 644290 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644292 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 644294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644301 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644313 */     GIR_RootConstrainSelectedInstOperands,
     /* 644314 */     // GIR_Coverage, 6157,
     /* 644314 */     GIR_EraseRootFromParent_Done,
     /* 644315 */   // Label 8283: @644315
     /* 644315 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(644370), // Rule ID 6165 //
     /* 644320 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 644326 */     // MIs[0] offset
     /* 644326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644329 */     // MIs[0] auxiliary
     /* 644329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644332 */     // MIs[0] Operand 8
     /* 644332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644342 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN),
     /* 644345 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644347 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 644349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644356 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644368 */     GIR_RootConstrainSelectedInstOperands,
     /* 644369 */     // GIR_Coverage, 6165,
     /* 644369 */     GIR_EraseRootFromParent_Done,
     /* 644370 */   // Label 8284: @644370
     /* 644370 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(644432), // Rule ID 6153 //
     /* 644375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 644386 */     // MIs[0] offset
     /* 644386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644389 */     // MIs[0] auxiliary
     /* 644389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644392 */     // MIs[0] Operand 8
     /* 644392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644402 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN_RTN),
     /* 644405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 644407 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644409 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 644411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644418 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644420 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644430 */     GIR_RootConstrainSelectedInstOperands,
     /* 644431 */     // GIR_Coverage, 6153,
     /* 644431 */     GIR_EraseRootFromParent_Done,
     /* 644432 */   // Label 8285: @644432
     /* 644432 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(644491), // Rule ID 6161 //
     /* 644437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 644445 */     // MIs[0] offset
     /* 644445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644448 */     // MIs[0] auxiliary
     /* 644448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644451 */     // MIs[0] Operand 8
     /* 644451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644461 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN),
     /* 644464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 644466 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644468 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 644470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644477 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644489 */     GIR_RootConstrainSelectedInstOperands,
     /* 644490 */     // GIR_Coverage, 6161,
     /* 644490 */     GIR_EraseRootFromParent_Done,
     /* 644491 */   // Label 8286: @644491
     /* 644491 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(644587), // Rule ID 6159 //
     /* 644496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644499 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644501 */     // MIs[0] offset
     /* 644501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644504 */     // MIs[0] auxiliary
     /* 644504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644507 */     // MIs[0] Operand 8
     /* 644507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644517 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 644520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 644533 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 644536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 644540 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 644543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN),
     /* 644561 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644573 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644585 */     GIR_RootConstrainSelectedInstOperands,
     /* 644586 */     // GIR_Coverage, 6159,
     /* 644586 */     GIR_EraseRootFromParent_Done,
     /* 644587 */   // Label 8287: @644587
     /* 644587 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(644680), // Rule ID 6167 //
     /* 644592 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644594 */     // MIs[0] offset
     /* 644594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644597 */     // MIs[0] auxiliary
     /* 644597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644600 */     // MIs[0] Operand 8
     /* 644600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644610 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 644613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 644626 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 644629 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 644633 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 644636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN),
     /* 644654 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644666 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 644674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644678 */     GIR_RootConstrainSelectedInstOperands,
     /* 644679 */     // GIR_Coverage, 6167,
     /* 644679 */     GIR_EraseRootFromParent_Done,
     /* 644680 */   // Label 8288: @644680
     /* 644680 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(644780), // Rule ID 6155 //
     /* 644685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644692 */     // MIs[0] offset
     /* 644692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644695 */     // MIs[0] auxiliary
     /* 644695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644698 */     // MIs[0] Operand 8
     /* 644698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644708 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 644711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 644724 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 644727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 644731 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 644734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN_RTN),
     /* 644752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 644754 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644766 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644778 */     GIR_RootConstrainSelectedInstOperands,
     /* 644779 */     // GIR_Coverage, 6155,
     /* 644779 */     GIR_EraseRootFromParent_Done,
     /* 644780 */   // Label 8289: @644780
     /* 644780 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(644877), // Rule ID 6163 //
     /* 644785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 644789 */     // MIs[0] offset
     /* 644789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 644792 */     // MIs[0] auxiliary
     /* 644792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644795 */     // MIs[0] Operand 8
     /* 644795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644805 */     // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 644808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 644821 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 644824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 644828 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 644831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 644846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN),
     /* 644849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 644851 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 644853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 644856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 644858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 644863 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 644865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 644871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 644875 */     GIR_RootConstrainSelectedInstOperands,
     /* 644876 */     // GIR_Coverage, 6163,
     /* 644876 */     GIR_EraseRootFromParent_Done,
     /* 644877 */   // Label 8290: @644877
     /* 644877 */   GIM_Reject,
     /* 644878 */ // Label 8274: @644878
     /* 644878 */ GIM_Reject,
     /* 644879 */ // Label 8256: @644879
     /* 644879 */ GIM_Reject,
     /* 644880 */ // Label 110: @644880
     /* 644880 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8293*/ GIMT_Encode4(649173),
     /* 644891 */ /*GILLT_s32*//*Label 8291*/ GIMT_Encode4(644899),
     /* 644895 */ /*GILLT_s64*//*Label 8292*/ GIMT_Encode4(647036),
     /* 644899 */ // Label 8291: @644899
     /* 644899 */ GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(647035),
     /* 644904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 644907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 644910 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 644913 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 644916 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 644919 */   GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 644922 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(645032), // Rule ID 6396 //
     /* 644927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 644930 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 644932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 644936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 644940 */     // MIs[0] offset
     /* 644940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 644943 */     // MIs[0] auxiliary
     /* 644943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 644946 */     // MIs[0] Operand 9
     /* 644946 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 644957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 644964 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 644964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 644967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 644971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 644976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 644980 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 644983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 644987 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 644990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 644995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
     /* 645008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 645013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645018 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 645020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645030 */     GIR_RootConstrainSelectedInstOperands,
     /* 645031 */     // GIR_Coverage, 6396,
     /* 645031 */     GIR_EraseRootFromParent_Done,
     /* 645032 */   // Label 8295: @645032
     /* 645032 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(645139), // Rule ID 6404 //
     /* 645037 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 645047 */     // MIs[0] offset
     /* 645047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645050 */     // MIs[0] auxiliary
     /* 645050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645053 */     // MIs[0] Operand 9
     /* 645053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 645064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645071 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645087 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645094 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
     /* 645115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 645120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645125 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 645127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645137 */     GIR_RootConstrainSelectedInstOperands,
     /* 645138 */     // GIR_Coverage, 6404,
     /* 645138 */     GIR_EraseRootFromParent_Done,
     /* 645139 */   // Label 8296: @645139
     /* 645139 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(645287), // Rule ID 6392 //
     /* 645144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 645159 */     // MIs[0] offset
     /* 645159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645162 */     // MIs[0] auxiliary
     /* 645162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645165 */     // MIs[0] Operand 9
     /* 645165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 645176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645183 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 645183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 645186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645199 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 645202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645206 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 645209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
     /* 645231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 645239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 645243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 645252 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645258 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 645264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 645267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 645269 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 645276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 645286 */     // GIR_Coverage, 6392,
     /* 645286 */     GIR_EraseRootFromParent_Done,
     /* 645287 */   // Label 8297: @645287
     /* 645287 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(645432), // Rule ID 6400 //
     /* 645292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 645304 */     // MIs[0] offset
     /* 645304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645307 */     // MIs[0] auxiliary
     /* 645307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645310 */     // MIs[0] Operand 9
     /* 645310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 645321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645328 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 645328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 645331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645340 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645344 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 645347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645351 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 645354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645359 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645364 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
     /* 645376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 645384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 645388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 645397 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645403 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 645409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 645412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 645414 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 645421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 645431 */     // GIR_Coverage, 6400,
     /* 645431 */     GIR_EraseRootFromParent_Done,
     /* 645432 */   // Label 8298: @645432
     /* 645432 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(645540), // Rule ID 6398 //
     /* 645437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645440 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645446 */     // MIs[0] offset
     /* 645446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645449 */     // MIs[0] auxiliary
     /* 645449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645452 */     // MIs[0] Operand 9
     /* 645452 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 645463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645470 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645486 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645493 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN),
     /* 645514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645517 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 645519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 645521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645526 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 645528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645538 */     GIR_RootConstrainSelectedInstOperands,
     /* 645539 */     // GIR_Coverage, 6398,
     /* 645539 */     GIR_EraseRootFromParent_Done,
     /* 645540 */   // Label 8299: @645540
     /* 645540 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(645645), // Rule ID 6406 //
     /* 645545 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645551 */     // MIs[0] offset
     /* 645551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645554 */     // MIs[0] auxiliary
     /* 645554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645557 */     // MIs[0] Operand 9
     /* 645557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 645568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645575 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645591 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645598 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN),
     /* 645619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 645622 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 645624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 645626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645631 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 645633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 645639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645643 */     GIR_RootConstrainSelectedInstOperands,
     /* 645644 */     // GIR_Coverage, 6406,
     /* 645644 */     GIR_EraseRootFromParent_Done,
     /* 645645 */   // Label 8300: @645645
     /* 645645 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(645793), // Rule ID 6394 //
     /* 645650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645661 */     // MIs[0] offset
     /* 645661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645664 */     // MIs[0] auxiliary
     /* 645664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645667 */     // MIs[0] Operand 9
     /* 645667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 645678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645685 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 645685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 645688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645697 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645701 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 645704 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645708 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 645711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN),
     /* 645733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645738 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 645741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 645745 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 645749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 645758 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645764 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 645770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 645773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 645775 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 645782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 645792 */     // GIR_Coverage, 6394,
     /* 645792 */     GIR_EraseRootFromParent_Done,
     /* 645793 */   // Label 8301: @645793
     /* 645793 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(645938), // Rule ID 6402 //
     /* 645798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 645806 */     // MIs[0] offset
     /* 645806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645809 */     // MIs[0] auxiliary
     /* 645809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645812 */     // MIs[0] Operand 9
     /* 645812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 645823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645830 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 645830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 645833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645842 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645846 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 645849 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645853 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 645856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 645871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN),
     /* 645878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 645886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 645890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 645894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 645899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 645903 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 645909 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 645913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 645915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 645918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 645920 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 645927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 645932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 645937 */     // GIR_Coverage, 6402,
     /* 645937 */     GIR_EraseRootFromParent_Done,
     /* 645938 */   // Label 8302: @645938
     /* 645938 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(646038), // Rule ID 6397 //
     /* 645943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 645946 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 645948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 645952 */     // MIs[0] offset
     /* 645952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 645955 */     // MIs[0] auxiliary
     /* 645955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 645958 */     // MIs[0] Operand 9
     /* 645958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 645961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 645968 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 645968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 645971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 645975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 645980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 645984 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 645987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 645991 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 645994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 645999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN),
     /* 646012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 646017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 646019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646024 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 646026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646036 */     GIR_RootConstrainSelectedInstOperands,
     /* 646037 */     // GIR_Coverage, 6397,
     /* 646037 */     GIR_EraseRootFromParent_Done,
     /* 646038 */   // Label 8303: @646038
     /* 646038 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(646135), // Rule ID 6405 //
     /* 646043 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 646049 */     // MIs[0] offset
     /* 646049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646052 */     // MIs[0] auxiliary
     /* 646052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646055 */     // MIs[0] Operand 9
     /* 646055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 646058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646065 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 646081 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 646088 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN),
     /* 646109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646112 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 646114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 646116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646121 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 646123 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646133 */     GIR_RootConstrainSelectedInstOperands,
     /* 646134 */     // GIR_Coverage, 6405,
     /* 646134 */     GIR_EraseRootFromParent_Done,
     /* 646135 */   // Label 8304: @646135
     /* 646135 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(646275), // Rule ID 6393 //
     /* 646140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 646151 */     // MIs[0] offset
     /* 646151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646154 */     // MIs[0] auxiliary
     /* 646154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646157 */     // MIs[0] Operand 9
     /* 646157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 646160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646167 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 646167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 646170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 646183 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 646186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 646190 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 646193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN),
     /* 646215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646220 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 646223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 646227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 646231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 646240 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646246 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 646252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 646255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 646257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 646264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 646274 */     // GIR_Coverage, 6393,
     /* 646274 */     GIR_EraseRootFromParent_Done,
     /* 646275 */   // Label 8305: @646275
     /* 646275 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(646412), // Rule ID 6401 //
     /* 646280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 646288 */     // MIs[0] offset
     /* 646288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646291 */     // MIs[0] auxiliary
     /* 646291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646294 */     // MIs[0] Operand 9
     /* 646294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 646297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646304 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 646304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 646307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 646320 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 646323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 646327 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 646330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN),
     /* 646352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646357 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 646360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 646364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 646368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 646377 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646383 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 646389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 646392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 646394 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 646401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 646411 */     // GIR_Coverage, 6401,
     /* 646411 */     GIR_EraseRootFromParent_Done,
     /* 646412 */   // Label 8306: @646412
     /* 646412 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(646550), // Rule ID 6399 //
     /* 646417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646420 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646422 */     // MIs[0] offset
     /* 646422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646425 */     // MIs[0] auxiliary
     /* 646425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646428 */     // MIs[0] Operand 9
     /* 646428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 646431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646438 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646438 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 646441 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646445 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646450 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 646454 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 646457 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 646461 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 646464 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646474 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 646495 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 646502 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN),
     /* 646523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 646529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 646531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646536 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 646538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646548 */     GIR_RootConstrainSelectedInstOperands,
     /* 646549 */     // GIR_Coverage, 6399,
     /* 646549 */     GIR_EraseRootFromParent_Done,
     /* 646550 */   // Label 8307: @646550
     /* 646550 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(646685), // Rule ID 6407 //
     /* 646555 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 646557 */     // MIs[0] offset
     /* 646557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646560 */     // MIs[0] auxiliary
     /* 646560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646563 */     // MIs[0] Operand 9
     /* 646563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 646566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646573 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 646573 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 646576 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646580 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646585 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 646589 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 646592 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 646596 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 646599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646609 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 646630 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 646633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 646637 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 646640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN),
     /* 646658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 646661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 646664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 646666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646671 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 646673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 646679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646683 */     GIR_RootConstrainSelectedInstOperands,
     /* 646684 */     // GIR_Coverage, 6407,
     /* 646684 */     GIR_EraseRootFromParent_Done,
     /* 646685 */   // Label 8308: @646685
     /* 646685 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(646861), // Rule ID 6395 //
     /* 646690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 646693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646697 */     // MIs[0] offset
     /* 646697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646700 */     // MIs[0] auxiliary
     /* 646700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646703 */     // MIs[0] Operand 9
     /* 646703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 646706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646713 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 646713 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 646716 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646720 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646725 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 646729 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 646732 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 646736 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 646739 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646744 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646749 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646754 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 646757 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646761 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646766 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 646770 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 646773 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 646777 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 646780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646785 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646790 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN),
     /* 646802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646807 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 646810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 646813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 646817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 646826 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 646832 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 646836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 646838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 646841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 646843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 646850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 646860 */     // GIR_Coverage, 6395,
     /* 646860 */     GIR_EraseRootFromParent_Done,
     /* 646861 */   // Label 8309: @646861
     /* 646861 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(647034), // Rule ID 6403 //
     /* 646866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 646870 */     // MIs[0] offset
     /* 646870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 646873 */     // MIs[0] auxiliary
     /* 646873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 646876 */     // MIs[0] Operand 9
     /* 646876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 646879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 646886 */     // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9744:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
     /* 646886 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 646889 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646893 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646898 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 646902 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 646905 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 646909 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 646912 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646917 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646922 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 646930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 646934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 646943 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 646946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 646950 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 646953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 646958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 646968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 646971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN),
     /* 646975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 646980 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 646983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 646986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 646990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 646995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 646999 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647005 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 647011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 647014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 647016 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
     /* 647023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 647028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647033 */     // GIR_Coverage, 6403,
     /* 647033 */     GIR_EraseRootFromParent_Done,
     /* 647034 */   // Label 8310: @647034
     /* 647034 */   GIM_Reject,
     /* 647035 */ // Label 8294: @647035
     /* 647035 */ GIM_Reject,
     /* 647036 */ // Label 8292: @647036
     /* 647036 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(649172),
     /* 647041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 647044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 647047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 647050 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 647053 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 647056 */   GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 647059 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(647169), // Rule ID 6412 //
     /* 647064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647067 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 647077 */     // MIs[0] offset
     /* 647077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647080 */     // MIs[0] auxiliary
     /* 647080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647083 */     // MIs[0] Operand 9
     /* 647083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647101 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 647104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647117 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 647120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647124 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 647127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
     /* 647145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 647150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647155 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 647157 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647167 */     GIR_RootConstrainSelectedInstOperands,
     /* 647168 */     // GIR_Coverage, 6412,
     /* 647168 */     GIR_EraseRootFromParent_Done,
     /* 647169 */   // Label 8312: @647169
     /* 647169 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(647276), // Rule ID 6420 //
     /* 647174 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 647184 */     // MIs[0] offset
     /* 647184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647187 */     // MIs[0] auxiliary
     /* 647187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647190 */     // MIs[0] Operand 9
     /* 647190 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647208 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 647211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647224 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 647227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647231 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 647234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
     /* 647252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 647257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647262 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 647264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647274 */     GIR_RootConstrainSelectedInstOperands,
     /* 647275 */     // GIR_Coverage, 6420,
     /* 647275 */     GIR_EraseRootFromParent_Done,
     /* 647276 */   // Label 8313: @647276
     /* 647276 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(647424), // Rule ID 6408 //
     /* 647281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 647296 */     // MIs[0] offset
     /* 647296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647299 */     // MIs[0] auxiliary
     /* 647299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647302 */     // MIs[0] Operand 9
     /* 647302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647320 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 647320 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 647323 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647327 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647332 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647336 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 647339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647343 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 647346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 647364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
     /* 647368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 647376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 647380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647385 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 647389 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647395 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 647401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 647404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 647406 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 647413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 647423 */     // GIR_Coverage, 6408,
     /* 647423 */     GIR_EraseRootFromParent_Done,
     /* 647424 */   // Label 8314: @647424
     /* 647424 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(647569), // Rule ID 6416 //
     /* 647429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 647441 */     // MIs[0] offset
     /* 647441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647444 */     // MIs[0] auxiliary
     /* 647444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647447 */     // MIs[0] Operand 9
     /* 647447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647465 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 647465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 647468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647477 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647481 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 647484 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647488 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 647491 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647496 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647501 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 647509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
     /* 647513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647518 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 647521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 647525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 647534 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 647546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 647549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 647551 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 647558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 647568 */     // GIR_Coverage, 6416,
     /* 647568 */     GIR_EraseRootFromParent_Done,
     /* 647569 */   // Label 8315: @647569
     /* 647569 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(647677), // Rule ID 6414 //
     /* 647574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647577 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647583 */     // MIs[0] offset
     /* 647583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647586 */     // MIs[0] auxiliary
     /* 647586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647589 */     // MIs[0] Operand 9
     /* 647589 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647607 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 647610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647623 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 647626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647630 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 647633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN),
     /* 647651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647654 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 647656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 647658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647663 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 647665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647675 */     GIR_RootConstrainSelectedInstOperands,
     /* 647676 */     // GIR_Coverage, 6414,
     /* 647676 */     GIR_EraseRootFromParent_Done,
     /* 647677 */   // Label 8316: @647677
     /* 647677 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(647782), // Rule ID 6422 //
     /* 647682 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 647684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647688 */     // MIs[0] offset
     /* 647688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647691 */     // MIs[0] auxiliary
     /* 647691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647694 */     // MIs[0] Operand 9
     /* 647694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647712 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 647712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 647715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647728 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 647731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647735 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 647738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN),
     /* 647756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 647759 */     GIR_RootToRootCopy, /*OpIdx*/5, // voffset
     /* 647761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 647763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647768 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 647770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 647776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647780 */     GIR_RootConstrainSelectedInstOperands,
     /* 647781 */     // GIR_Coverage, 6422,
     /* 647781 */     GIR_EraseRootFromParent_Done,
     /* 647782 */   // Label 8317: @647782
     /* 647782 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(647930), // Rule ID 6410 //
     /* 647787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 647790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647798 */     // MIs[0] offset
     /* 647798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647801 */     // MIs[0] auxiliary
     /* 647801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647804 */     // MIs[0] Operand 9
     /* 647804 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647822 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 647822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 647825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647834 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647838 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 647841 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647845 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 647848 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 647863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 647866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN),
     /* 647870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 647878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 647882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 647886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 647891 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 647895 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 647901 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 647905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 647907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 647910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 647912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 647919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 647929 */     // GIR_Coverage, 6410,
     /* 647929 */     GIR_EraseRootFromParent_Done,
     /* 647930 */   // Label 8318: @647930
     /* 647930 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(648075), // Rule ID 6418 //
     /* 647935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 647939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 647943 */     // MIs[0] offset
     /* 647943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 647946 */     // MIs[0] auxiliary
     /* 647946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 647949 */     // MIs[0] Operand 9
     /* 647949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
     /* 647960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 647967 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 647967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 647970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 647974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 647979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 647983 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 647986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 647990 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 647993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 647998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN),
     /* 648015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 648023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 648027 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 648031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 648040 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648046 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 648052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 648055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 648057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 648064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 648069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 648074 */     // GIR_Coverage, 6418,
     /* 648074 */     GIR_EraseRootFromParent_Done,
     /* 648075 */   // Label 8319: @648075
     /* 648075 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(648175), // Rule ID 6413 //
     /* 648080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 648083 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 648089 */     // MIs[0] offset
     /* 648089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648092 */     // MIs[0] auxiliary
     /* 648092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648095 */     // MIs[0] Operand 9
     /* 648095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 648098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648105 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 648121 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 648124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 648128 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 648131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 648136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN),
     /* 648149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 648154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 648156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648161 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 648163 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648173 */     GIR_RootConstrainSelectedInstOperands,
     /* 648174 */     // GIR_Coverage, 6413,
     /* 648174 */     GIR_EraseRootFromParent_Done,
     /* 648175 */   // Label 8320: @648175
     /* 648175 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(648272), // Rule ID 6421 //
     /* 648180 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 648186 */     // MIs[0] offset
     /* 648186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648189 */     // MIs[0] auxiliary
     /* 648189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648192 */     // MIs[0] Operand 9
     /* 648192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 648195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648202 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 648218 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 648221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 648225 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 648228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 648233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN),
     /* 648246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vindex
     /* 648251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 648253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648258 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 648260 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648270 */     GIR_RootConstrainSelectedInstOperands,
     /* 648271 */     // GIR_Coverage, 6421,
     /* 648271 */     GIR_EraseRootFromParent_Done,
     /* 648272 */   // Label 8321: @648272
     /* 648272 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(648412), // Rule ID 6409 //
     /* 648277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 648280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 648284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 648288 */     // MIs[0] offset
     /* 648288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648291 */     // MIs[0] auxiliary
     /* 648291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648294 */     // MIs[0] Operand 9
     /* 648294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 648297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648304 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 648304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 648307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 648320 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 648323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 648327 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 648330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 648335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN),
     /* 648352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648357 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 648360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 648364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 648368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 648377 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648383 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 648389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 648392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 648394 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 648401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 648406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 648411 */     // GIR_Coverage, 6409,
     /* 648411 */     GIR_EraseRootFromParent_Done,
     /* 648412 */   // Label 8322: @648412
     /* 648412 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(648549), // Rule ID 6417 //
     /* 648417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 648421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /* 648425 */     // MIs[0] offset
     /* 648425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648428 */     // MIs[0] auxiliary
     /* 648428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648431 */     // MIs[0] Operand 9
     /* 648431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 648434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648441 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 648441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 648444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648453 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 648457 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 648460 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 648464 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 648467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 648472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN),
     /* 648489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648494 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 648497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 648501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 648505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 648514 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 648526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 648529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 648531 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 648538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 648543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 648548 */     // GIR_Coverage, 6417,
     /* 648548 */     GIR_EraseRootFromParent_Done,
     /* 648549 */   // Label 8323: @648549
     /* 648549 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(648687), // Rule ID 6415 //
     /* 648554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 648557 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648559 */     // MIs[0] offset
     /* 648559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648562 */     // MIs[0] auxiliary
     /* 648562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648565 */     // MIs[0] Operand 9
     /* 648565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 648568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648575 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 648578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 648591 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 648594 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 648598 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 648601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648606 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648611 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 648632 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 648635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 648639 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 648642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 648647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN),
     /* 648660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 648666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 648668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648673 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 648675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648685 */     GIR_RootConstrainSelectedInstOperands,
     /* 648686 */     // GIR_Coverage, 6415,
     /* 648686 */     GIR_EraseRootFromParent_Done,
     /* 648687 */   // Label 8324: @648687
     /* 648687 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(648822), // Rule ID 6423 //
     /* 648692 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 648694 */     // MIs[0] offset
     /* 648694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648697 */     // MIs[0] auxiliary
     /* 648697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648700 */     // MIs[0] Operand 9
     /* 648700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 648703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648710 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 648710 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 648713 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648717 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648722 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 648726 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
     /* 648729 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 648733 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
     /* 648736 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648741 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 648767 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /* 648770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 648774 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
     /* 648777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 648782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN),
     /* 648795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 648798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 648801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
     /* 648803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648808 */     GIR_RootToRootCopy, /*OpIdx*/7, // offset
     /* 648810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 648816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648820 */     GIR_RootConstrainSelectedInstOperands,
     /* 648821 */     // GIR_Coverage, 6423,
     /* 648821 */     GIR_EraseRootFromParent_Done,
     /* 648822 */   // Label 8325: @648822
     /* 648822 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(648998), // Rule ID 6411 //
     /* 648827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 648830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 648834 */     // MIs[0] offset
     /* 648834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 648837 */     // MIs[0] auxiliary
     /* 648837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 648840 */     // MIs[0] Operand 9
     /* 648840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 648843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 648850 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 648850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 648853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648862 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 648866 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 648869 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 648873 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 648876 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648881 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648886 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 648891 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 648894 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 648898 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648903 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 648907 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 648910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 648914 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 648917 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 648922 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648927 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 648932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 648935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN),
     /* 648939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 648944 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 648947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 648950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 648954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 648959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 648963 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 648969 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 648973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 648975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 648978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 648980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 648987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 648992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 648997 */     // GIR_Coverage, 6411,
     /* 648997 */     GIR_EraseRootFromParent_Done,
     /* 648998 */   // Label 8326: @648998
     /* 648998 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(649171), // Rule ID 6419 //
     /* 649003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649007 */     // MIs[0] offset
     /* 649007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649010 */     // MIs[0] auxiliary
     /* 649010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649013 */     // MIs[0] Operand 9
     /* 649013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/9,
     /* 649016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649023 */     // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9743:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
     /* 649023 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 649026 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649030 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649035 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
     /* 649039 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
     /* 649042 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
     /* 649046 */     GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
     /* 649049 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649054 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649059 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 649067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649076 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
     /* 649080 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
     /* 649083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
     /* 649087 */     GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
     /* 649090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
     /* 649095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 649108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN),
     /* 649112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 649120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 649123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
     /* 649127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
     /* 649136 */     GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649142 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 649148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 649151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 649153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
     /* 649160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 649165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 649170 */     // GIR_Coverage, 6419,
     /* 649170 */     GIR_EraseRootFromParent_Done,
     /* 649171 */   // Label 8327: @649171
     /* 649171 */   GIM_Reject,
     /* 649172 */ // Label 8311: @649172
     /* 649172 */ GIM_Reject,
     /* 649173 */ // Label 8293: @649173
     /* 649173 */ GIM_Reject,
     /* 649174 */ // Label 111: @649174
     /* 649174 */ GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(649790),
     /* 649179 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 649182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 649185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 649188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 649191 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 649194 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 649197 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(649265), // Rule ID 6244 //
     /* 649202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 649205 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649215 */     // MIs[0] offset
     /* 649215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649218 */     // MIs[0] auxiliary
     /* 649218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649221 */     // MIs[0] Operand 8
     /* 649221 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649239 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET),
     /* 649242 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649251 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649263 */     GIR_RootConstrainSelectedInstOperands,
     /* 649264 */     // GIR_Coverage, 6244,
     /* 649264 */     GIR_EraseRootFromParent_Done,
     /* 649265 */   // Label 8329: @649265
     /* 649265 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(649337), // Rule ID 6240 //
     /* 649270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 649273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 649277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649285 */     // MIs[0] offset
     /* 649285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649288 */     // MIs[0] auxiliary
     /* 649288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649291 */     // MIs[0] Operand 8
     /* 649291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649309 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN),
     /* 649312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649314 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649323 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649335 */     GIR_RootConstrainSelectedInstOperands,
     /* 649336 */     // GIR_Coverage, 6240,
     /* 649336 */     GIR_EraseRootFromParent_Done,
     /* 649337 */   // Label 8330: @649337
     /* 649337 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(649403), // Rule ID 6246 //
     /* 649342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 649345 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649351 */     // MIs[0] offset
     /* 649351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649354 */     // MIs[0] auxiliary
     /* 649354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649357 */     // MIs[0] Operand 8
     /* 649357 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649375 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN),
     /* 649378 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649380 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649389 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649401 */     GIR_RootConstrainSelectedInstOperands,
     /* 649402 */     // GIR_Coverage, 6246,
     /* 649402 */     GIR_EraseRootFromParent_Done,
     /* 649403 */   // Label 8331: @649403
     /* 649403 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(649473), // Rule ID 6242 //
     /* 649408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 649411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 649415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649419 */     // MIs[0] offset
     /* 649419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649422 */     // MIs[0] auxiliary
     /* 649422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649425 */     // MIs[0] Operand 8
     /* 649425 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649443 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN),
     /* 649446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649448 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649450 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 649452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649459 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649461 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649471 */     GIR_RootConstrainSelectedInstOperands,
     /* 649472 */     // GIR_Coverage, 6242,
     /* 649472 */     GIR_EraseRootFromParent_Done,
     /* 649473 */   // Label 8332: @649473
     /* 649473 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(649531), // Rule ID 6245 //
     /* 649478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 649481 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649487 */     // MIs[0] offset
     /* 649487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649490 */     // MIs[0] auxiliary
     /* 649490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649493 */     // MIs[0] Operand 8
     /* 649493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649503 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN),
     /* 649506 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649508 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649517 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649519 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649529 */     GIR_RootConstrainSelectedInstOperands,
     /* 649530 */     // GIR_Coverage, 6245,
     /* 649530 */     GIR_EraseRootFromParent_Done,
     /* 649531 */   // Label 8333: @649531
     /* 649531 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(649593), // Rule ID 6241 //
     /* 649536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 649539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 649543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649547 */     // MIs[0] offset
     /* 649547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649550 */     // MIs[0] auxiliary
     /* 649550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649553 */     // MIs[0] Operand 8
     /* 649553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649563 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN),
     /* 649566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649568 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649570 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 649572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649579 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649591 */     GIR_RootConstrainSelectedInstOperands,
     /* 649592 */     // GIR_Coverage, 6241,
     /* 649592 */     GIR_EraseRootFromParent_Done,
     /* 649593 */   // Label 8334: @649593
     /* 649593 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(649689), // Rule ID 6247 //
     /* 649598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
     /* 649601 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649603 */     // MIs[0] offset
     /* 649603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649606 */     // MIs[0] auxiliary
     /* 649606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649609 */     // MIs[0] Operand 8
     /* 649609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649619 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 649622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 649635 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 649638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 649642 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 649645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN),
     /* 649663 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 649668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649675 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649687 */     GIR_RootConstrainSelectedInstOperands,
     /* 649688 */     // GIR_Coverage, 6247,
     /* 649688 */     GIR_EraseRootFromParent_Done,
     /* 649689 */   // Label 8335: @649689
     /* 649689 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(649789), // Rule ID 6243 //
     /* 649694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 649697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 649701 */     // MIs[0] offset
     /* 649701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649704 */     // MIs[0] auxiliary
     /* 649704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649707 */     // MIs[0] Operand 8
     /* 649707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 649710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649717 */     // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 649720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 649724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 649729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 649733 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 649736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 649740 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 649743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 649748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 649758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN),
     /* 649761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 649763 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 649768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649775 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 649783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649787 */     GIR_RootConstrainSelectedInstOperands,
     /* 649788 */     // GIR_Coverage, 6243,
     /* 649788 */     GIR_EraseRootFromParent_Done,
     /* 649789 */   // Label 8336: @649789
     /* 649789 */   GIM_Reject,
     /* 649790 */ // Label 8328: @649790
     /* 649790 */ GIM_Reject,
     /* 649791 */ // Label 112: @649791
     /* 649791 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8339*/ GIMT_Encode4(652174),
     /* 649802 */ /*GILLT_s32*//*Label 8337*/ GIMT_Encode4(649810),
     /* 649806 */ /*GILLT_s64*//*Label 8338*/ GIMT_Encode4(650992),
     /* 649810 */ // Label 8337: @649810
     /* 649810 */ GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(650991),
     /* 649815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 649818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 649821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 649824 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 649827 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 649830 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(649898), // Rule ID 6020 //
     /* 649835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 649838 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649848 */     // MIs[0] offset
     /* 649848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649851 */     // MIs[0] auxiliary
     /* 649851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649854 */     // MIs[0] Operand 8
     /* 649854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649872 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
     /* 649875 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649884 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649896 */     GIR_RootConstrainSelectedInstOperands,
     /* 649897 */     // GIR_Coverage, 6020,
     /* 649897 */     GIR_EraseRootFromParent_Done,
     /* 649898 */   // Label 8341: @649898
     /* 649898 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(649963), // Rule ID 6028 //
     /* 649903 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 649905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649913 */     // MIs[0] offset
     /* 649913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649916 */     // MIs[0] auxiliary
     /* 649916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649919 */     // MIs[0] Operand 8
     /* 649919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 649930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 649937 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 649937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
     /* 649940 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 649942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 649944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 649949 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 649951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 649957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 649961 */     GIR_RootConstrainSelectedInstOperands,
     /* 649962 */     // GIR_Coverage, 6028,
     /* 649962 */     GIR_EraseRootFromParent_Done,
     /* 649963 */   // Label 8342: @649963
     /* 649963 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(650035), // Rule ID 6016 //
     /* 649968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 649971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 649975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 649979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 649983 */     // MIs[0] offset
     /* 649983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 649986 */     // MIs[0] auxiliary
     /* 649986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 649989 */     // MIs[0] Operand 8
     /* 649989 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650007 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
     /* 650010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650012 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650021 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650033 */     GIR_RootConstrainSelectedInstOperands,
     /* 650034 */     // GIR_Coverage, 6016,
     /* 650034 */     GIR_EraseRootFromParent_Done,
     /* 650035 */   // Label 8343: @650035
     /* 650035 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(650104), // Rule ID 6024 //
     /* 650040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650052 */     // MIs[0] offset
     /* 650052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650055 */     // MIs[0] auxiliary
     /* 650055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650058 */     // MIs[0] Operand 8
     /* 650058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650076 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
     /* 650079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650081 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650090 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650102 */     GIR_RootConstrainSelectedInstOperands,
     /* 650103 */     // GIR_Coverage, 6024,
     /* 650103 */     GIR_EraseRootFromParent_Done,
     /* 650104 */   // Label 8344: @650104
     /* 650104 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(650170), // Rule ID 6022 //
     /* 650109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 650112 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650118 */     // MIs[0] offset
     /* 650118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650121 */     // MIs[0] auxiliary
     /* 650121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650124 */     // MIs[0] Operand 8
     /* 650124 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650142 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN),
     /* 650145 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650147 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650156 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650168 */     GIR_RootConstrainSelectedInstOperands,
     /* 650169 */     // GIR_Coverage, 6022,
     /* 650169 */     GIR_EraseRootFromParent_Done,
     /* 650170 */   // Label 8345: @650170
     /* 650170 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(650233), // Rule ID 6030 //
     /* 650175 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650181 */     // MIs[0] offset
     /* 650181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650184 */     // MIs[0] auxiliary
     /* 650184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650187 */     // MIs[0] Operand 8
     /* 650187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650205 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN),
     /* 650208 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650210 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650219 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650231 */     GIR_RootConstrainSelectedInstOperands,
     /* 650232 */     // GIR_Coverage, 6030,
     /* 650232 */     GIR_EraseRootFromParent_Done,
     /* 650233 */   // Label 8346: @650233
     /* 650233 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(650303), // Rule ID 6018 //
     /* 650238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 650241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650249 */     // MIs[0] offset
     /* 650249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650252 */     // MIs[0] auxiliary
     /* 650252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650255 */     // MIs[0] Operand 8
     /* 650255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650273 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN_RTN),
     /* 650276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650278 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650280 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650289 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650301 */     GIR_RootConstrainSelectedInstOperands,
     /* 650302 */     // GIR_Coverage, 6018,
     /* 650302 */     GIR_EraseRootFromParent_Done,
     /* 650303 */   // Label 8347: @650303
     /* 650303 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(650370), // Rule ID 6026 //
     /* 650308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 650316 */     // MIs[0] offset
     /* 650316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650319 */     // MIs[0] auxiliary
     /* 650319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650322 */     // MIs[0] Operand 8
     /* 650322 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 650333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650340 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN),
     /* 650343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650345 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650347 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 650349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650356 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650368 */     GIR_RootConstrainSelectedInstOperands,
     /* 650369 */     // GIR_Coverage, 6026,
     /* 650369 */     GIR_EraseRootFromParent_Done,
     /* 650370 */   // Label 8348: @650370
     /* 650370 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(650428), // Rule ID 6021 //
     /* 650375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 650378 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650384 */     // MIs[0] offset
     /* 650384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650387 */     // MIs[0] auxiliary
     /* 650387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650390 */     // MIs[0] Operand 8
     /* 650390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650400 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN),
     /* 650403 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650405 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650414 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650426 */     GIR_RootConstrainSelectedInstOperands,
     /* 650427 */     // GIR_Coverage, 6021,
     /* 650427 */     GIR_EraseRootFromParent_Done,
     /* 650428 */   // Label 8349: @650428
     /* 650428 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(650483), // Rule ID 6029 //
     /* 650433 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650439 */     // MIs[0] offset
     /* 650439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650442 */     // MIs[0] auxiliary
     /* 650442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650445 */     // MIs[0] Operand 8
     /* 650445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650455 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN),
     /* 650458 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650460 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650469 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650481 */     GIR_RootConstrainSelectedInstOperands,
     /* 650482 */     // GIR_Coverage, 6029,
     /* 650482 */     GIR_EraseRootFromParent_Done,
     /* 650483 */   // Label 8350: @650483
     /* 650483 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(650545), // Rule ID 6017 //
     /* 650488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 650491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650499 */     // MIs[0] offset
     /* 650499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650502 */     // MIs[0] auxiliary
     /* 650502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650505 */     // MIs[0] Operand 8
     /* 650505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650515 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN_RTN),
     /* 650518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650520 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650522 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650531 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650543 */     GIR_RootConstrainSelectedInstOperands,
     /* 650544 */     // GIR_Coverage, 6017,
     /* 650544 */     GIR_EraseRootFromParent_Done,
     /* 650545 */   // Label 8351: @650545
     /* 650545 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(650604), // Rule ID 6025 //
     /* 650550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 650558 */     // MIs[0] offset
     /* 650558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650561 */     // MIs[0] auxiliary
     /* 650561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650564 */     // MIs[0] Operand 8
     /* 650564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650574 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN),
     /* 650577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650579 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650581 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 650583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650590 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650602 */     GIR_RootConstrainSelectedInstOperands,
     /* 650603 */     // GIR_Coverage, 6025,
     /* 650603 */     GIR_EraseRootFromParent_Done,
     /* 650604 */   // Label 8352: @650604
     /* 650604 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(650700), // Rule ID 6023 //
     /* 650609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 650612 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650614 */     // MIs[0] offset
     /* 650614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650617 */     // MIs[0] auxiliary
     /* 650617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650620 */     // MIs[0] Operand 8
     /* 650620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650630 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650646 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650653 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN),
     /* 650674 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650686 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650698 */     GIR_RootConstrainSelectedInstOperands,
     /* 650699 */     // GIR_Coverage, 6023,
     /* 650699 */     GIR_EraseRootFromParent_Done,
     /* 650700 */   // Label 8353: @650700
     /* 650700 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(650793), // Rule ID 6031 //
     /* 650705 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 650707 */     // MIs[0] offset
     /* 650707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650710 */     // MIs[0] auxiliary
     /* 650710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650713 */     // MIs[0] Operand 8
     /* 650713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650723 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650739 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650746 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN),
     /* 650767 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650779 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 650787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650791 */     GIR_RootConstrainSelectedInstOperands,
     /* 650792 */     // GIR_Coverage, 6031,
     /* 650792 */     GIR_EraseRootFromParent_Done,
     /* 650793 */   // Label 8354: @650793
     /* 650793 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(650893), // Rule ID 6019 //
     /* 650798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 650801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650805 */     // MIs[0] offset
     /* 650805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650808 */     // MIs[0] auxiliary
     /* 650808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650811 */     // MIs[0] Operand 8
     /* 650811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650821 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650837 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650844 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN_RTN),
     /* 650865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650867 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650879 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650891 */     GIR_RootConstrainSelectedInstOperands,
     /* 650892 */     // GIR_Coverage, 6019,
     /* 650892 */     GIR_EraseRootFromParent_Done,
     /* 650893 */   // Label 8355: @650893
     /* 650893 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(650990), // Rule ID 6027 //
     /* 650898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 650902 */     // MIs[0] offset
     /* 650902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 650905 */     // MIs[0] auxiliary
     /* 650905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 650908 */     // MIs[0] Operand 8
     /* 650908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 650911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 650918 */     // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 650918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 650921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 650925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 650930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 650934 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 650937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 650941 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 650944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 650949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 650959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN),
     /* 650962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 650964 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 650966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 650969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 650971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 650976 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 650978 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 650984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 650988 */     GIR_RootConstrainSelectedInstOperands,
     /* 650989 */     // GIR_Coverage, 6027,
     /* 650989 */     GIR_EraseRootFromParent_Done,
     /* 650990 */   // Label 8356: @650990
     /* 650990 */   GIM_Reject,
     /* 650991 */ // Label 8340: @650991
     /* 650991 */ GIM_Reject,
     /* 650992 */ // Label 8338: @650992
     /* 650992 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(652173),
     /* 650997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 651000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 651003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 651006 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 651009 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 651012 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(651080), // Rule ID 6220 //
     /* 651017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651020 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651030 */     // MIs[0] offset
     /* 651030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651033 */     // MIs[0] auxiliary
     /* 651033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651036 */     // MIs[0] Operand 8
     /* 651036 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651054 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
     /* 651057 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651066 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651068 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651078 */     GIR_RootConstrainSelectedInstOperands,
     /* 651079 */     // GIR_Coverage, 6220,
     /* 651079 */     GIR_EraseRootFromParent_Done,
     /* 651080 */   // Label 8358: @651080
     /* 651080 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(651145), // Rule ID 6228 //
     /* 651085 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651095 */     // MIs[0] offset
     /* 651095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651098 */     // MIs[0] auxiliary
     /* 651098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651101 */     // MIs[0] Operand 8
     /* 651101 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651119 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
     /* 651122 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651131 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651143 */     GIR_RootConstrainSelectedInstOperands,
     /* 651144 */     // GIR_Coverage, 6228,
     /* 651144 */     GIR_EraseRootFromParent_Done,
     /* 651145 */   // Label 8359: @651145
     /* 651145 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(651217), // Rule ID 6216 //
     /* 651150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 651157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651165 */     // MIs[0] offset
     /* 651165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651168 */     // MIs[0] auxiliary
     /* 651168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651171 */     // MIs[0] Operand 8
     /* 651171 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651189 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
     /* 651192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651194 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651203 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651205 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651215 */     GIR_RootConstrainSelectedInstOperands,
     /* 651216 */     // GIR_Coverage, 6216,
     /* 651216 */     GIR_EraseRootFromParent_Done,
     /* 651217 */   // Label 8360: @651217
     /* 651217 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(651286), // Rule ID 6224 //
     /* 651222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 651226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651234 */     // MIs[0] offset
     /* 651234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651237 */     // MIs[0] auxiliary
     /* 651237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651240 */     // MIs[0] Operand 8
     /* 651240 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651258 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
     /* 651261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651263 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651272 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651284 */     GIR_RootConstrainSelectedInstOperands,
     /* 651285 */     // GIR_Coverage, 6224,
     /* 651285 */     GIR_EraseRootFromParent_Done,
     /* 651286 */   // Label 8361: @651286
     /* 651286 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(651352), // Rule ID 6222 //
     /* 651291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651294 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651300 */     // MIs[0] offset
     /* 651300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651303 */     // MIs[0] auxiliary
     /* 651303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651306 */     // MIs[0] Operand 8
     /* 651306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651324 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN),
     /* 651327 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651329 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651338 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651340 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651350 */     GIR_RootConstrainSelectedInstOperands,
     /* 651351 */     // GIR_Coverage, 6222,
     /* 651351 */     GIR_EraseRootFromParent_Done,
     /* 651352 */   // Label 8362: @651352
     /* 651352 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(651415), // Rule ID 6230 //
     /* 651357 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651363 */     // MIs[0] offset
     /* 651363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651366 */     // MIs[0] auxiliary
     /* 651366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651369 */     // MIs[0] Operand 8
     /* 651369 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651387 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN),
     /* 651390 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651392 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651401 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651413 */     GIR_RootConstrainSelectedInstOperands,
     /* 651414 */     // GIR_Coverage, 6230,
     /* 651414 */     GIR_EraseRootFromParent_Done,
     /* 651415 */   // Label 8363: @651415
     /* 651415 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(651485), // Rule ID 6218 //
     /* 651420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 651427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651431 */     // MIs[0] offset
     /* 651431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651434 */     // MIs[0] auxiliary
     /* 651434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651437 */     // MIs[0] Operand 8
     /* 651437 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651455 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN_RTN),
     /* 651458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651460 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651462 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651471 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651483 */     GIR_RootConstrainSelectedInstOperands,
     /* 651484 */     // GIR_Coverage, 6218,
     /* 651484 */     GIR_EraseRootFromParent_Done,
     /* 651485 */   // Label 8364: @651485
     /* 651485 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(651552), // Rule ID 6226 //
     /* 651490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 651494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 651498 */     // MIs[0] offset
     /* 651498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651501 */     // MIs[0] auxiliary
     /* 651501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651504 */     // MIs[0] Operand 8
     /* 651504 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 651515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651522 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN),
     /* 651525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651527 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651529 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 651531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651538 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651540 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651550 */     GIR_RootConstrainSelectedInstOperands,
     /* 651551 */     // GIR_Coverage, 6226,
     /* 651551 */     GIR_EraseRootFromParent_Done,
     /* 651552 */   // Label 8365: @651552
     /* 651552 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(651610), // Rule ID 6221 //
     /* 651557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651560 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651566 */     // MIs[0] offset
     /* 651566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651569 */     // MIs[0] auxiliary
     /* 651569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651572 */     // MIs[0] Operand 8
     /* 651572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651582 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN),
     /* 651585 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651587 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651596 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651608 */     GIR_RootConstrainSelectedInstOperands,
     /* 651609 */     // GIR_Coverage, 6221,
     /* 651609 */     GIR_EraseRootFromParent_Done,
     /* 651610 */   // Label 8366: @651610
     /* 651610 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(651665), // Rule ID 6229 //
     /* 651615 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651621 */     // MIs[0] offset
     /* 651621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651624 */     // MIs[0] auxiliary
     /* 651624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651627 */     // MIs[0] Operand 8
     /* 651627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651637 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN),
     /* 651640 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651642 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651651 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651663 */     GIR_RootConstrainSelectedInstOperands,
     /* 651664 */     // GIR_Coverage, 6229,
     /* 651664 */     GIR_EraseRootFromParent_Done,
     /* 651665 */   // Label 8367: @651665
     /* 651665 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(651727), // Rule ID 6217 //
     /* 651670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 651677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651681 */     // MIs[0] offset
     /* 651681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651684 */     // MIs[0] auxiliary
     /* 651684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651687 */     // MIs[0] Operand 8
     /* 651687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651697 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN_RTN),
     /* 651700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651702 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651704 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651713 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651725 */     GIR_RootConstrainSelectedInstOperands,
     /* 651726 */     // GIR_Coverage, 6217,
     /* 651726 */     GIR_EraseRootFromParent_Done,
     /* 651727 */   // Label 8368: @651727
     /* 651727 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(651786), // Rule ID 6225 //
     /* 651732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 651736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 651740 */     // MIs[0] offset
     /* 651740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651743 */     // MIs[0] auxiliary
     /* 651743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651746 */     // MIs[0] Operand 8
     /* 651746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651756 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN),
     /* 651759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 651761 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651763 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 651765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651772 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 651780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651784 */     GIR_RootConstrainSelectedInstOperands,
     /* 651785 */     // GIR_Coverage, 6225,
     /* 651785 */     GIR_EraseRootFromParent_Done,
     /* 651786 */   // Label 8369: @651786
     /* 651786 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(651882), // Rule ID 6223 //
     /* 651791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651794 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651796 */     // MIs[0] offset
     /* 651796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651799 */     // MIs[0] auxiliary
     /* 651799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651802 */     // MIs[0] Operand 8
     /* 651802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651812 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651828 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651835 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN),
     /* 651856 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651868 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651880 */     GIR_RootConstrainSelectedInstOperands,
     /* 651881 */     // GIR_Coverage, 6223,
     /* 651881 */     GIR_EraseRootFromParent_Done,
     /* 651882 */   // Label 8370: @651882
     /* 651882 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(651975), // Rule ID 6231 //
     /* 651887 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 651889 */     // MIs[0] offset
     /* 651889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651892 */     // MIs[0] auxiliary
     /* 651892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651895 */     // MIs[0] Operand 8
     /* 651895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 651905 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 651905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 651908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 651912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 651917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 651921 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 651924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 651928 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 651931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 651936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 651946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN),
     /* 651949 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 651951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 651954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 651956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 651961 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 651963 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 651969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 651973 */     GIR_RootConstrainSelectedInstOperands,
     /* 651974 */     // GIR_Coverage, 6231,
     /* 651974 */     GIR_EraseRootFromParent_Done,
     /* 651975 */   // Label 8371: @651975
     /* 651975 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(652075), // Rule ID 6219 //
     /* 651980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 651983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 651987 */     // MIs[0] offset
     /* 651987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 651990 */     // MIs[0] auxiliary
     /* 651990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 651993 */     // MIs[0] Operand 8
     /* 651993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 651996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652003 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652015 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652019 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652026 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN),
     /* 652047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652049 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652061 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652073 */     GIR_RootConstrainSelectedInstOperands,
     /* 652074 */     // GIR_Coverage, 6219,
     /* 652074 */     GIR_EraseRootFromParent_Done,
     /* 652075 */   // Label 8372: @652075
     /* 652075 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(652172), // Rule ID 6227 //
     /* 652080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 652084 */     // MIs[0] offset
     /* 652084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652087 */     // MIs[0] auxiliary
     /* 652087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652090 */     // MIs[0] Operand 8
     /* 652090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652100 */     // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 652103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 652107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 652112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 652116 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 652119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 652123 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 652126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 652131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 652141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN),
     /* 652144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652146 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 652151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652158 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652170 */     GIR_RootConstrainSelectedInstOperands,
     /* 652171 */     // GIR_Coverage, 6227,
     /* 652171 */     GIR_EraseRootFromParent_Done,
     /* 652172 */   // Label 8373: @652172
     /* 652172 */   GIM_Reject,
     /* 652173 */ // Label 8357: @652173
     /* 652173 */ GIM_Reject,
     /* 652174 */ // Label 8339: @652174
     /* 652174 */ GIM_Reject,
     /* 652175 */ // Label 113: @652175
     /* 652175 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8377*/ GIMT_Encode4(655816),
     /* 652186 */ /*GILLT_s32*//*Label 8374*/ GIMT_Encode4(652198),
     /* 652190 */ /*GILLT_s64*//*Label 8375*/ GIMT_Encode4(653404),
     /* 652194 */ /*GILLT_v2s16*//*Label 8376*/ GIMT_Encode4(654610),
     /* 652198 */ // Label 8374: @652198
     /* 652198 */ GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(653403),
     /* 652203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 652206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 652209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 652212 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 652215 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 652218 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(652286), // Rule ID 6312 //
     /* 652223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 652226 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652236 */     // MIs[0] offset
     /* 652236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652239 */     // MIs[0] auxiliary
     /* 652239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652242 */     // MIs[0] Operand 8
     /* 652242 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652260 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET),
     /* 652263 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652272 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652284 */     GIR_RootConstrainSelectedInstOperands,
     /* 652285 */     // GIR_Coverage, 6312,
     /* 652285 */     GIR_EraseRootFromParent_Done,
     /* 652286 */   // Label 8379: @652286
     /* 652286 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(652354), // Rule ID 6316 //
     /* 652291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 652294 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652304 */     // MIs[0] offset
     /* 652304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652307 */     // MIs[0] auxiliary
     /* 652307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652310 */     // MIs[0] Operand 8
     /* 652310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652328 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET),
     /* 652331 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652340 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652352 */     GIR_RootConstrainSelectedInstOperands,
     /* 652353 */     // GIR_Coverage, 6316,
     /* 652353 */     GIR_EraseRootFromParent_Done,
     /* 652354 */   // Label 8380: @652354
     /* 652354 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(652426), // Rule ID 6328 //
     /* 652359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 652362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652374 */     // MIs[0] offset
     /* 652374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652377 */     // MIs[0] auxiliary
     /* 652377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652380 */     // MIs[0] Operand 8
     /* 652380 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652398 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET_RTN),
     /* 652401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652403 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652412 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652414 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652424 */     GIR_RootConstrainSelectedInstOperands,
     /* 652425 */     // GIR_Coverage, 6328,
     /* 652425 */     GIR_EraseRootFromParent_Done,
     /* 652426 */   // Label 8381: @652426
     /* 652426 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(652498), // Rule ID 6332 //
     /* 652431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 652434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652446 */     // MIs[0] offset
     /* 652446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652449 */     // MIs[0] auxiliary
     /* 652449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652452 */     // MIs[0] Operand 8
     /* 652452 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652470 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN),
     /* 652473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652475 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652484 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652496 */     GIR_RootConstrainSelectedInstOperands,
     /* 652497 */     // GIR_Coverage, 6332,
     /* 652497 */     GIR_EraseRootFromParent_Done,
     /* 652498 */   // Label 8382: @652498
     /* 652498 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(652564), // Rule ID 6314 //
     /* 652503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 652506 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652512 */     // MIs[0] offset
     /* 652512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652515 */     // MIs[0] auxiliary
     /* 652515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652518 */     // MIs[0] Operand 8
     /* 652518 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652536 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN),
     /* 652539 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652541 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652550 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652562 */     GIR_RootConstrainSelectedInstOperands,
     /* 652563 */     // GIR_Coverage, 6314,
     /* 652563 */     GIR_EraseRootFromParent_Done,
     /* 652564 */   // Label 8383: @652564
     /* 652564 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(652630), // Rule ID 6318 //
     /* 652569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 652572 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652578 */     // MIs[0] offset
     /* 652578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652581 */     // MIs[0] auxiliary
     /* 652581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652584 */     // MIs[0] Operand 8
     /* 652584 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652602 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN),
     /* 652605 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652607 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652616 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652628 */     GIR_RootConstrainSelectedInstOperands,
     /* 652629 */     // GIR_Coverage, 6318,
     /* 652629 */     GIR_EraseRootFromParent_Done,
     /* 652630 */   // Label 8384: @652630
     /* 652630 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(652700), // Rule ID 6330 //
     /* 652635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 652638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652646 */     // MIs[0] offset
     /* 652646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652649 */     // MIs[0] auxiliary
     /* 652649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652652 */     // MIs[0] Operand 8
     /* 652652 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652670 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN_RTN),
     /* 652673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652675 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652677 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652686 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652698 */     GIR_RootConstrainSelectedInstOperands,
     /* 652699 */     // GIR_Coverage, 6330,
     /* 652699 */     GIR_EraseRootFromParent_Done,
     /* 652700 */   // Label 8385: @652700
     /* 652700 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(652770), // Rule ID 6334 //
     /* 652705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 652708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 652716 */     // MIs[0] offset
     /* 652716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652719 */     // MIs[0] auxiliary
     /* 652719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652722 */     // MIs[0] Operand 8
     /* 652722 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 652733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652740 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN),
     /* 652743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652745 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652747 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 652749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652756 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652768 */     GIR_RootConstrainSelectedInstOperands,
     /* 652769 */     // GIR_Coverage, 6334,
     /* 652769 */     GIR_EraseRootFromParent_Done,
     /* 652770 */   // Label 8386: @652770
     /* 652770 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(652828), // Rule ID 6313 //
     /* 652775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 652778 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652784 */     // MIs[0] offset
     /* 652784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652787 */     // MIs[0] auxiliary
     /* 652787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652790 */     // MIs[0] Operand 8
     /* 652790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652800 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN),
     /* 652803 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652805 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652814 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652826 */     GIR_RootConstrainSelectedInstOperands,
     /* 652827 */     // GIR_Coverage, 6313,
     /* 652827 */     GIR_EraseRootFromParent_Done,
     /* 652828 */   // Label 8387: @652828
     /* 652828 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(652886), // Rule ID 6317 //
     /* 652833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 652836 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 652838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652842 */     // MIs[0] offset
     /* 652842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652845 */     // MIs[0] auxiliary
     /* 652845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652848 */     // MIs[0] Operand 8
     /* 652848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652858 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN),
     /* 652861 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652863 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652872 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 652880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652884 */     GIR_RootConstrainSelectedInstOperands,
     /* 652885 */     // GIR_Coverage, 6317,
     /* 652885 */     GIR_EraseRootFromParent_Done,
     /* 652886 */   // Label 8388: @652886
     /* 652886 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(652948), // Rule ID 6329 //
     /* 652891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 652894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652902 */     // MIs[0] offset
     /* 652902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652905 */     // MIs[0] auxiliary
     /* 652905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652908 */     // MIs[0] Operand 8
     /* 652908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652918 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN_RTN),
     /* 652921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652923 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652925 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652934 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 652942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 652946 */     GIR_RootConstrainSelectedInstOperands,
     /* 652947 */     // GIR_Coverage, 6329,
     /* 652947 */     GIR_EraseRootFromParent_Done,
     /* 652948 */   // Label 8389: @652948
     /* 652948 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(653010), // Rule ID 6333 //
     /* 652953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 652956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 652960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 652964 */     // MIs[0] offset
     /* 652964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 652967 */     // MIs[0] auxiliary
     /* 652967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 652970 */     // MIs[0] Operand 8
     /* 652970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 652973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 652980 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 652980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN),
     /* 652983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 652985 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 652987 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 652989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 652991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 652996 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 652998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653008 */     GIR_RootConstrainSelectedInstOperands,
     /* 653009 */     // GIR_Coverage, 6333,
     /* 653009 */     GIR_EraseRootFromParent_Done,
     /* 653010 */   // Label 8390: @653010
     /* 653010 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(653106), // Rule ID 6315 //
     /* 653015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
     /* 653018 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653020 */     // MIs[0] offset
     /* 653020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653023 */     // MIs[0] auxiliary
     /* 653023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653026 */     // MIs[0] Operand 8
     /* 653026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653036 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 653039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 653043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 653048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 653052 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 653055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 653059 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 653062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 653067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN),
     /* 653080 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 653085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653092 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653104 */     GIR_RootConstrainSelectedInstOperands,
     /* 653105 */     // GIR_Coverage, 6315,
     /* 653105 */     GIR_EraseRootFromParent_Done,
     /* 653106 */   // Label 8391: @653106
     /* 653106 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(653202), // Rule ID 6319 //
     /* 653111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
     /* 653114 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653116 */     // MIs[0] offset
     /* 653116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653119 */     // MIs[0] auxiliary
     /* 653119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653122 */     // MIs[0] Operand 8
     /* 653122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653132 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 653135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 653139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 653144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 653148 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 653151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 653155 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 653158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 653163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN),
     /* 653176 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 653181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653188 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653200 */     GIR_RootConstrainSelectedInstOperands,
     /* 653201 */     // GIR_Coverage, 6319,
     /* 653201 */     GIR_EraseRootFromParent_Done,
     /* 653202 */   // Label 8392: @653202
     /* 653202 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(653302), // Rule ID 6331 //
     /* 653207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
     /* 653210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 653214 */     // MIs[0] offset
     /* 653214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653217 */     // MIs[0] auxiliary
     /* 653217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653220 */     // MIs[0] Operand 8
     /* 653220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653230 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 653233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 653237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 653242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 653246 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 653249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 653253 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 653256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 653261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN),
     /* 653274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653276 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 653281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653288 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653300 */     GIR_RootConstrainSelectedInstOperands,
     /* 653301 */     // GIR_Coverage, 6331,
     /* 653301 */     GIR_EraseRootFromParent_Done,
     /* 653302 */   // Label 8393: @653302
     /* 653302 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(653402), // Rule ID 6335 //
     /* 653307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
     /* 653310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 653314 */     // MIs[0] offset
     /* 653314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653317 */     // MIs[0] auxiliary
     /* 653317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653320 */     // MIs[0] Operand 8
     /* 653320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653330 */     // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 653333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 653337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 653342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 653346 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 653349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 653353 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 653356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 653361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 653371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN),
     /* 653374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653376 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 653381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653388 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653400 */     GIR_RootConstrainSelectedInstOperands,
     /* 653401 */     // GIR_Coverage, 6335,
     /* 653401 */     GIR_EraseRootFromParent_Done,
     /* 653402 */   // Label 8394: @653402
     /* 653402 */   GIM_Reject,
     /* 653403 */ // Label 8378: @653403
     /* 653403 */ GIM_Reject,
     /* 653404 */ // Label 8375: @653404
     /* 653404 */ GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(654609),
     /* 653409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 653412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 653415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 653418 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 653421 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 653424 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(653492), // Rule ID 6348 //
     /* 653429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 653432 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653442 */     // MIs[0] offset
     /* 653442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653445 */     // MIs[0] auxiliary
     /* 653445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653448 */     // MIs[0] Operand 8
     /* 653448 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653466 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET),
     /* 653469 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653478 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653490 */     GIR_RootConstrainSelectedInstOperands,
     /* 653491 */     // GIR_Coverage, 6348,
     /* 653491 */     GIR_EraseRootFromParent_Done,
     /* 653492 */   // Label 8396: @653492
     /* 653492 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(653560), // Rule ID 6356 //
     /* 653497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 653500 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653510 */     // MIs[0] offset
     /* 653510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653513 */     // MIs[0] auxiliary
     /* 653513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653516 */     // MIs[0] Operand 8
     /* 653516 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653534 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET),
     /* 653537 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653546 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653548 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653558 */     GIR_RootConstrainSelectedInstOperands,
     /* 653559 */     // GIR_Coverage, 6356,
     /* 653559 */     GIR_EraseRootFromParent_Done,
     /* 653560 */   // Label 8397: @653560
     /* 653560 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(653632), // Rule ID 6344 //
     /* 653565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 653568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653580 */     // MIs[0] offset
     /* 653580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653583 */     // MIs[0] auxiliary
     /* 653583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653586 */     // MIs[0] Operand 8
     /* 653586 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653604 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET_RTN),
     /* 653607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653609 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653618 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653630 */     GIR_RootConstrainSelectedInstOperands,
     /* 653631 */     // GIR_Coverage, 6344,
     /* 653631 */     GIR_EraseRootFromParent_Done,
     /* 653632 */   // Label 8398: @653632
     /* 653632 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(653704), // Rule ID 6352 //
     /* 653637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 653640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653652 */     // MIs[0] offset
     /* 653652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653655 */     // MIs[0] auxiliary
     /* 653655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653658 */     // MIs[0] Operand 8
     /* 653658 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653676 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN),
     /* 653679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653681 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653690 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653692 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653702 */     GIR_RootConstrainSelectedInstOperands,
     /* 653703 */     // GIR_Coverage, 6352,
     /* 653703 */     GIR_EraseRootFromParent_Done,
     /* 653704 */   // Label 8399: @653704
     /* 653704 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(653770), // Rule ID 6350 //
     /* 653709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 653712 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653718 */     // MIs[0] offset
     /* 653718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653721 */     // MIs[0] auxiliary
     /* 653721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653724 */     // MIs[0] Operand 8
     /* 653724 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653742 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN),
     /* 653745 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653747 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653756 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653768 */     GIR_RootConstrainSelectedInstOperands,
     /* 653769 */     // GIR_Coverage, 6350,
     /* 653769 */     GIR_EraseRootFromParent_Done,
     /* 653770 */   // Label 8400: @653770
     /* 653770 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(653836), // Rule ID 6358 //
     /* 653775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 653778 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653784 */     // MIs[0] offset
     /* 653784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653787 */     // MIs[0] auxiliary
     /* 653787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653790 */     // MIs[0] Operand 8
     /* 653790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653808 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN),
     /* 653811 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653813 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653822 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 653830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653834 */     GIR_RootConstrainSelectedInstOperands,
     /* 653835 */     // GIR_Coverage, 6358,
     /* 653835 */     GIR_EraseRootFromParent_Done,
     /* 653836 */   // Label 8401: @653836
     /* 653836 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(653906), // Rule ID 6346 //
     /* 653841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 653844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653852 */     // MIs[0] offset
     /* 653852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653855 */     // MIs[0] auxiliary
     /* 653855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653858 */     // MIs[0] Operand 8
     /* 653858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653876 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN_RTN),
     /* 653879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653881 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653883 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653892 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653904 */     GIR_RootConstrainSelectedInstOperands,
     /* 653905 */     // GIR_Coverage, 6346,
     /* 653905 */     GIR_EraseRootFromParent_Done,
     /* 653906 */   // Label 8402: @653906
     /* 653906 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(653976), // Rule ID 6354 //
     /* 653911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 653914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 653918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 653922 */     // MIs[0] offset
     /* 653922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653925 */     // MIs[0] auxiliary
     /* 653925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653928 */     // MIs[0] Operand 8
     /* 653928 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 653939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 653946 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 653946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN),
     /* 653949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 653951 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 653953 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 653955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 653957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 653962 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 653964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 653970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 653974 */     GIR_RootConstrainSelectedInstOperands,
     /* 653975 */     // GIR_Coverage, 6354,
     /* 653975 */     GIR_EraseRootFromParent_Done,
     /* 653976 */   // Label 8403: @653976
     /* 653976 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(654034), // Rule ID 6349 //
     /* 653981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 653984 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 653986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 653990 */     // MIs[0] offset
     /* 653990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 653993 */     // MIs[0] auxiliary
     /* 653993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 653996 */     // MIs[0] Operand 8
     /* 653996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 653999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654006 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN),
     /* 654009 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654011 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654020 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654032 */     GIR_RootConstrainSelectedInstOperands,
     /* 654033 */     // GIR_Coverage, 6349,
     /* 654033 */     GIR_EraseRootFromParent_Done,
     /* 654034 */   // Label 8404: @654034
     /* 654034 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(654092), // Rule ID 6357 //
     /* 654039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 654042 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654048 */     // MIs[0] offset
     /* 654048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654051 */     // MIs[0] auxiliary
     /* 654051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654054 */     // MIs[0] Operand 8
     /* 654054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654064 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN),
     /* 654067 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654069 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654078 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654090 */     GIR_RootConstrainSelectedInstOperands,
     /* 654091 */     // GIR_Coverage, 6357,
     /* 654091 */     GIR_EraseRootFromParent_Done,
     /* 654092 */   // Label 8405: @654092
     /* 654092 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(654154), // Rule ID 6345 //
     /* 654097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 654100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654108 */     // MIs[0] offset
     /* 654108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654111 */     // MIs[0] auxiliary
     /* 654111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654114 */     // MIs[0] Operand 8
     /* 654114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654124 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN_RTN),
     /* 654127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654129 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654131 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654140 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654152 */     GIR_RootConstrainSelectedInstOperands,
     /* 654153 */     // GIR_Coverage, 6345,
     /* 654153 */     GIR_EraseRootFromParent_Done,
     /* 654154 */   // Label 8406: @654154
     /* 654154 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(654216), // Rule ID 6353 //
     /* 654159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 654162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654170 */     // MIs[0] offset
     /* 654170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654173 */     // MIs[0] auxiliary
     /* 654173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654176 */     // MIs[0] Operand 8
     /* 654176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654186 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN),
     /* 654189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654191 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654193 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 654195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654202 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654214 */     GIR_RootConstrainSelectedInstOperands,
     /* 654215 */     // GIR_Coverage, 6353,
     /* 654215 */     GIR_EraseRootFromParent_Done,
     /* 654216 */   // Label 8407: @654216
     /* 654216 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(654312), // Rule ID 6351 //
     /* 654221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 654224 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654226 */     // MIs[0] offset
     /* 654226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654229 */     // MIs[0] auxiliary
     /* 654229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654232 */     // MIs[0] Operand 8
     /* 654232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654242 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654258 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654265 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN),
     /* 654286 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654298 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654310 */     GIR_RootConstrainSelectedInstOperands,
     /* 654311 */     // GIR_Coverage, 6351,
     /* 654311 */     GIR_EraseRootFromParent_Done,
     /* 654312 */   // Label 8408: @654312
     /* 654312 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(654408), // Rule ID 6359 //
     /* 654317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 654320 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654322 */     // MIs[0] offset
     /* 654322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654325 */     // MIs[0] auxiliary
     /* 654325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654328 */     // MIs[0] Operand 8
     /* 654328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654338 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654354 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN),
     /* 654382 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654394 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654406 */     GIR_RootConstrainSelectedInstOperands,
     /* 654407 */     // GIR_Coverage, 6359,
     /* 654407 */     GIR_EraseRootFromParent_Done,
     /* 654408 */   // Label 8409: @654408
     /* 654408 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(654508), // Rule ID 6347 //
     /* 654413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
     /* 654416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654420 */     // MIs[0] offset
     /* 654420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654423 */     // MIs[0] auxiliary
     /* 654423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654426 */     // MIs[0] Operand 8
     /* 654426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654436 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654452 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654459 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN),
     /* 654480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654482 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654494 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654506 */     GIR_RootConstrainSelectedInstOperands,
     /* 654507 */     // GIR_Coverage, 6347,
     /* 654507 */     GIR_EraseRootFromParent_Done,
     /* 654508 */   // Label 8410: @654508
     /* 654508 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(654608), // Rule ID 6355 //
     /* 654513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
     /* 654516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 654520 */     // MIs[0] offset
     /* 654520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654523 */     // MIs[0] auxiliary
     /* 654523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654526 */     // MIs[0] Operand 8
     /* 654526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 654529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654536 */     // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 654539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 654543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 654548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 654552 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 654555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 654559 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 654562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 654567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 654577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN),
     /* 654580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654582 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 654587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654594 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654606 */     GIR_RootConstrainSelectedInstOperands,
     /* 654607 */     // GIR_Coverage, 6355,
     /* 654607 */     GIR_EraseRootFromParent_Done,
     /* 654608 */   // Label 8411: @654608
     /* 654608 */   GIM_Reject,
     /* 654609 */ // Label 8395: @654609
     /* 654609 */ GIM_Reject,
     /* 654610 */ // Label 8376: @654610
     /* 654610 */ GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(655815),
     /* 654615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 654618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 654621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 654624 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 654627 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 654630 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(654698), // Rule ID 6320 //
     /* 654635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 654638 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 654644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654648 */     // MIs[0] offset
     /* 654648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654651 */     // MIs[0] auxiliary
     /* 654651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654654 */     // MIs[0] Operand 8
     /* 654654 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 654665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654672 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET anonymous_9744:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET),
     /* 654675 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654684 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654696 */     GIR_RootConstrainSelectedInstOperands,
     /* 654697 */     // GIR_Coverage, 6320,
     /* 654697 */     GIR_EraseRootFromParent_Done,
     /* 654698 */   // Label 8413: @654698
     /* 654698 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(654766), // Rule ID 6324 //
     /* 654703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 654706 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 654712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654716 */     // MIs[0] offset
     /* 654716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654719 */     // MIs[0] auxiliary
     /* 654719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654722 */     // MIs[0] Operand 8
     /* 654722 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 654733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654740 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET anonymous_9744:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET),
     /* 654743 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654752 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654764 */     GIR_RootConstrainSelectedInstOperands,
     /* 654765 */     // GIR_Coverage, 6324,
     /* 654765 */     GIR_EraseRootFromParent_Done,
     /* 654766 */   // Label 8414: @654766
     /* 654766 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(654838), // Rule ID 6336 //
     /* 654771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 654774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 654778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 654782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654786 */     // MIs[0] offset
     /* 654786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654789 */     // MIs[0] auxiliary
     /* 654789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654792 */     // MIs[0] Operand 8
     /* 654792 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 654803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654810 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN),
     /* 654813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654815 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654824 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654836 */     GIR_RootConstrainSelectedInstOperands,
     /* 654837 */     // GIR_Coverage, 6336,
     /* 654837 */     GIR_EraseRootFromParent_Done,
     /* 654838 */   // Label 8415: @654838
     /* 654838 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(654910), // Rule ID 6340 //
     /* 654843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 654846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 654850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 654854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 654858 */     // MIs[0] offset
     /* 654858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654861 */     // MIs[0] auxiliary
     /* 654861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654864 */     // MIs[0] Operand 8
     /* 654864 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 654875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654882 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN),
     /* 654885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 654887 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654896 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 654904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654908 */     GIR_RootConstrainSelectedInstOperands,
     /* 654909 */     // GIR_Coverage, 6340,
     /* 654909 */     GIR_EraseRootFromParent_Done,
     /* 654910 */   // Label 8416: @654910
     /* 654910 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(654976), // Rule ID 6322 //
     /* 654915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 654918 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 654924 */     // MIs[0] offset
     /* 654924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654927 */     // MIs[0] auxiliary
     /* 654927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654930 */     // MIs[0] Operand 8
     /* 654930 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 654941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 654948 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 654948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN),
     /* 654951 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 654953 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 654955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 654957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 654962 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 654964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 654970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 654974 */     GIR_RootConstrainSelectedInstOperands,
     /* 654975 */     // GIR_Coverage, 6322,
     /* 654975 */     GIR_EraseRootFromParent_Done,
     /* 654976 */   // Label 8417: @654976
     /* 654976 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(655042), // Rule ID 6326 //
     /* 654981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 654984 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 654986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 654990 */     // MIs[0] offset
     /* 654990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 654993 */     // MIs[0] auxiliary
     /* 654993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 654996 */     // MIs[0] Operand 8
     /* 654996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655014 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN),
     /* 655017 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655019 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655028 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655040 */     GIR_RootConstrainSelectedInstOperands,
     /* 655041 */     // GIR_Coverage, 6326,
     /* 655041 */     GIR_EraseRootFromParent_Done,
     /* 655042 */   // Label 8418: @655042
     /* 655042 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(655112), // Rule ID 6338 //
     /* 655047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 655050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655058 */     // MIs[0] offset
     /* 655058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655061 */     // MIs[0] auxiliary
     /* 655061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655064 */     // MIs[0] Operand 8
     /* 655064 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655082 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN),
     /* 655085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655087 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655089 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655098 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655110 */     GIR_RootConstrainSelectedInstOperands,
     /* 655111 */     // GIR_Coverage, 6338,
     /* 655111 */     GIR_EraseRootFromParent_Done,
     /* 655112 */   // Label 8419: @655112
     /* 655112 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(655182), // Rule ID 6342 //
     /* 655117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 655120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655128 */     // MIs[0] offset
     /* 655128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655131 */     // MIs[0] auxiliary
     /* 655131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655134 */     // MIs[0] Operand 8
     /* 655134 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655152 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN),
     /* 655155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655157 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655159 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 655161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655168 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655180 */     GIR_RootConstrainSelectedInstOperands,
     /* 655181 */     // GIR_Coverage, 6342,
     /* 655181 */     GIR_EraseRootFromParent_Done,
     /* 655182 */   // Label 8420: @655182
     /* 655182 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(655240), // Rule ID 6321 //
     /* 655187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 655190 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655196 */     // MIs[0] offset
     /* 655196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655199 */     // MIs[0] auxiliary
     /* 655199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655202 */     // MIs[0] Operand 8
     /* 655202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655212 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN),
     /* 655215 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655217 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655226 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655238 */     GIR_RootConstrainSelectedInstOperands,
     /* 655239 */     // GIR_Coverage, 6321,
     /* 655239 */     GIR_EraseRootFromParent_Done,
     /* 655240 */   // Label 8421: @655240
     /* 655240 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(655298), // Rule ID 6325 //
     /* 655245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 655248 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655254 */     // MIs[0] offset
     /* 655254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655257 */     // MIs[0] auxiliary
     /* 655257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655260 */     // MIs[0] Operand 8
     /* 655260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655270 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN),
     /* 655273 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655275 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655284 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655296 */     GIR_RootConstrainSelectedInstOperands,
     /* 655297 */     // GIR_Coverage, 6325,
     /* 655297 */     GIR_EraseRootFromParent_Done,
     /* 655298 */   // Label 8422: @655298
     /* 655298 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(655360), // Rule ID 6337 //
     /* 655303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 655306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655314 */     // MIs[0] offset
     /* 655314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655317 */     // MIs[0] auxiliary
     /* 655317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655320 */     // MIs[0] Operand 8
     /* 655320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655330 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN),
     /* 655333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655335 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655337 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655346 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655358 */     GIR_RootConstrainSelectedInstOperands,
     /* 655359 */     // GIR_Coverage, 6337,
     /* 655359 */     GIR_EraseRootFromParent_Done,
     /* 655360 */   // Label 8423: @655360
     /* 655360 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(655422), // Rule ID 6341 //
     /* 655365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 655368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655376 */     // MIs[0] offset
     /* 655376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655379 */     // MIs[0] auxiliary
     /* 655379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655382 */     // MIs[0] Operand 8
     /* 655382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655392 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN),
     /* 655395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655397 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655399 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 655401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655408 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655420 */     GIR_RootConstrainSelectedInstOperands,
     /* 655421 */     // GIR_Coverage, 6341,
     /* 655421 */     GIR_EraseRootFromParent_Done,
     /* 655422 */   // Label 8424: @655422
     /* 655422 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(655518), // Rule ID 6323 //
     /* 655427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
     /* 655430 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655432 */     // MIs[0] offset
     /* 655432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655435 */     // MIs[0] auxiliary
     /* 655435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655438 */     // MIs[0] Operand 8
     /* 655438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655448 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN anonymous_9744:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655460 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655464 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655471 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN),
     /* 655492 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655504 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655516 */     GIR_RootConstrainSelectedInstOperands,
     /* 655517 */     // GIR_Coverage, 6323,
     /* 655517 */     GIR_EraseRootFromParent_Done,
     /* 655518 */   // Label 8425: @655518
     /* 655518 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(655614), // Rule ID 6327 //
     /* 655523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
     /* 655526 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655528 */     // MIs[0] offset
     /* 655528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655531 */     // MIs[0] auxiliary
     /* 655531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655534 */     // MIs[0] Operand 8
     /* 655534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655544 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN anonymous_9744:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655560 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655567 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN),
     /* 655588 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655600 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655612 */     GIR_RootConstrainSelectedInstOperands,
     /* 655613 */     // GIR_Coverage, 6327,
     /* 655613 */     GIR_EraseRootFromParent_Done,
     /* 655614 */   // Label 8426: @655614
     /* 655614 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(655714), // Rule ID 6339 //
     /* 655619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
     /* 655622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655626 */     // MIs[0] offset
     /* 655626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655629 */     // MIs[0] auxiliary
     /* 655629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655632 */     // MIs[0] Operand 8
     /* 655632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655642 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655658 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655665 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN),
     /* 655686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655688 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655700 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655712 */     GIR_RootConstrainSelectedInstOperands,
     /* 655713 */     // GIR_Coverage, 6339,
     /* 655713 */     GIR_EraseRootFromParent_Done,
     /* 655714 */   // Label 8427: @655714
     /* 655714 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(655814), // Rule ID 6343 //
     /* 655719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
     /* 655722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 655726 */     // MIs[0] offset
     /* 655726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655729 */     // MIs[0] auxiliary
     /* 655729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655732 */     // MIs[0] Operand 8
     /* 655732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 655735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655742 */     // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN:{ *:[v2f16] } anonymous_9744:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 655745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 655749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 655754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 655758 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 655761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 655765 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 655768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 655773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 655783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN),
     /* 655786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 655788 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 655793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655800 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 655808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655812 */     GIR_RootConstrainSelectedInstOperands,
     /* 655813 */     // GIR_Coverage, 6343,
     /* 655813 */     GIR_EraseRootFromParent_Done,
     /* 655814 */   // Label 8428: @655814
     /* 655814 */   GIM_Reject,
     /* 655815 */ // Label 8412: @655815
     /* 655815 */ GIM_Reject,
     /* 655816 */ // Label 8377: @655816
     /* 655816 */ GIM_Reject,
     /* 655817 */ // Label 114: @655817
     /* 655817 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8431*/ GIMT_Encode4(659432),
     /* 655828 */ /*GILLT_s32*//*Label 8429*/ GIMT_Encode4(655836),
     /* 655832 */ /*GILLT_s64*//*Label 8430*/ GIMT_Encode4(657042),
     /* 655836 */ // Label 8429: @655836
     /* 655836 */ GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(657041),
     /* 655841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 655844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 655847 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 655850 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 655853 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 655856 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(655924), // Rule ID 6268 //
     /* 655861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 655864 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655874 */     // MIs[0] offset
     /* 655874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655877 */     // MIs[0] auxiliary
     /* 655877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655880 */     // MIs[0] Operand 8
     /* 655880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655898 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
     /* 655901 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655910 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655922 */     GIR_RootConstrainSelectedInstOperands,
     /* 655923 */     // GIR_Coverage, 6268,
     /* 655923 */     GIR_EraseRootFromParent_Done,
     /* 655924 */   // Label 8433: @655924
     /* 655924 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(655992), // Rule ID 6276 //
     /* 655929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 655932 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 655934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 655938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 655942 */     // MIs[0] offset
     /* 655942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 655945 */     // MIs[0] auxiliary
     /* 655945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 655948 */     // MIs[0] Operand 8
     /* 655948 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 655959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 655966 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 655966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
     /* 655969 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 655971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 655973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 655978 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 655980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 655986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 655990 */     GIR_RootConstrainSelectedInstOperands,
     /* 655991 */     // GIR_Coverage, 6276,
     /* 655991 */     GIR_EraseRootFromParent_Done,
     /* 655992 */   // Label 8434: @655992
     /* 655992 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(656064), // Rule ID 6264 //
     /* 655997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656012 */     // MIs[0] offset
     /* 656012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656015 */     // MIs[0] auxiliary
     /* 656015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656018 */     // MIs[0] Operand 8
     /* 656018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656036 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
     /* 656039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656041 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656050 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656062 */     GIR_RootConstrainSelectedInstOperands,
     /* 656063 */     // GIR_Coverage, 6264,
     /* 656063 */     GIR_EraseRootFromParent_Done,
     /* 656064 */   // Label 8435: @656064
     /* 656064 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(656136), // Rule ID 6272 //
     /* 656069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656084 */     // MIs[0] offset
     /* 656084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656087 */     // MIs[0] auxiliary
     /* 656087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656090 */     // MIs[0] Operand 8
     /* 656090 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656108 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
     /* 656111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656113 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656122 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656134 */     GIR_RootConstrainSelectedInstOperands,
     /* 656135 */     // GIR_Coverage, 6272,
     /* 656135 */     GIR_EraseRootFromParent_Done,
     /* 656136 */   // Label 8436: @656136
     /* 656136 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(656202), // Rule ID 6270 //
     /* 656141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656144 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656150 */     // MIs[0] offset
     /* 656150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656153 */     // MIs[0] auxiliary
     /* 656153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656156 */     // MIs[0] Operand 8
     /* 656156 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656174 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN),
     /* 656177 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656179 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 656181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656188 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656200 */     GIR_RootConstrainSelectedInstOperands,
     /* 656201 */     // GIR_Coverage, 6270,
     /* 656201 */     GIR_EraseRootFromParent_Done,
     /* 656202 */   // Label 8437: @656202
     /* 656202 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(656268), // Rule ID 6278 //
     /* 656207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656210 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656216 */     // MIs[0] offset
     /* 656216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656219 */     // MIs[0] auxiliary
     /* 656219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656222 */     // MIs[0] Operand 8
     /* 656222 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656240 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN),
     /* 656243 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656245 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 656247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656254 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656266 */     GIR_RootConstrainSelectedInstOperands,
     /* 656267 */     // GIR_Coverage, 6278,
     /* 656267 */     GIR_EraseRootFromParent_Done,
     /* 656268 */   // Label 8438: @656268
     /* 656268 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(656338), // Rule ID 6266 //
     /* 656273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656284 */     // MIs[0] offset
     /* 656284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656287 */     // MIs[0] auxiliary
     /* 656287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656290 */     // MIs[0] Operand 8
     /* 656290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656308 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN_RTN),
     /* 656311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656313 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656315 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 656317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656324 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656336 */     GIR_RootConstrainSelectedInstOperands,
     /* 656337 */     // GIR_Coverage, 6266,
     /* 656337 */     GIR_EraseRootFromParent_Done,
     /* 656338 */   // Label 8439: @656338
     /* 656338 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(656408), // Rule ID 6274 //
     /* 656343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 656354 */     // MIs[0] offset
     /* 656354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656357 */     // MIs[0] auxiliary
     /* 656357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656360 */     // MIs[0] Operand 8
     /* 656360 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 656371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656378 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN),
     /* 656381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656383 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656385 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 656387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656394 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656406 */     GIR_RootConstrainSelectedInstOperands,
     /* 656407 */     // GIR_Coverage, 6274,
     /* 656407 */     GIR_EraseRootFromParent_Done,
     /* 656408 */   // Label 8440: @656408
     /* 656408 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(656466), // Rule ID 6269 //
     /* 656413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656416 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656422 */     // MIs[0] offset
     /* 656422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656425 */     // MIs[0] auxiliary
     /* 656425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656428 */     // MIs[0] Operand 8
     /* 656428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656438 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN),
     /* 656441 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656443 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 656445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656452 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656464 */     GIR_RootConstrainSelectedInstOperands,
     /* 656465 */     // GIR_Coverage, 6269,
     /* 656465 */     GIR_EraseRootFromParent_Done,
     /* 656466 */   // Label 8441: @656466
     /* 656466 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(656524), // Rule ID 6277 //
     /* 656471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656474 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656480 */     // MIs[0] offset
     /* 656480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656483 */     // MIs[0] auxiliary
     /* 656483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656486 */     // MIs[0] Operand 8
     /* 656486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656496 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN),
     /* 656499 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656501 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 656503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656510 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656522 */     GIR_RootConstrainSelectedInstOperands,
     /* 656523 */     // GIR_Coverage, 6277,
     /* 656523 */     GIR_EraseRootFromParent_Done,
     /* 656524 */   // Label 8442: @656524
     /* 656524 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(656586), // Rule ID 6265 //
     /* 656529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656540 */     // MIs[0] offset
     /* 656540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656543 */     // MIs[0] auxiliary
     /* 656543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656546 */     // MIs[0] Operand 8
     /* 656546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656556 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN_RTN),
     /* 656559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656561 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656563 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 656565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656572 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656584 */     GIR_RootConstrainSelectedInstOperands,
     /* 656585 */     // GIR_Coverage, 6265,
     /* 656585 */     GIR_EraseRootFromParent_Done,
     /* 656586 */   // Label 8443: @656586
     /* 656586 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(656648), // Rule ID 6273 //
     /* 656591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 656602 */     // MIs[0] offset
     /* 656602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656605 */     // MIs[0] auxiliary
     /* 656605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656608 */     // MIs[0] Operand 8
     /* 656608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656618 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN),
     /* 656621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656623 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656625 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 656627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656634 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656646 */     GIR_RootConstrainSelectedInstOperands,
     /* 656647 */     // GIR_Coverage, 6273,
     /* 656647 */     GIR_EraseRootFromParent_Done,
     /* 656648 */   // Label 8444: @656648
     /* 656648 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(656744), // Rule ID 6271 //
     /* 656653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656656 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656658 */     // MIs[0] offset
     /* 656658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656661 */     // MIs[0] auxiliary
     /* 656661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656664 */     // MIs[0] Operand 8
     /* 656664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656674 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656690 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656697 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN),
     /* 656718 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656730 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656742 */     GIR_RootConstrainSelectedInstOperands,
     /* 656743 */     // GIR_Coverage, 6271,
     /* 656743 */     GIR_EraseRootFromParent_Done,
     /* 656744 */   // Label 8445: @656744
     /* 656744 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(656840), // Rule ID 6279 //
     /* 656749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656752 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 656754 */     // MIs[0] offset
     /* 656754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656757 */     // MIs[0] auxiliary
     /* 656757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656760 */     // MIs[0] Operand 8
     /* 656760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656770 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656786 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656789 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656793 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN),
     /* 656814 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656826 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 656834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656838 */     GIR_RootConstrainSelectedInstOperands,
     /* 656839 */     // GIR_Coverage, 6279,
     /* 656839 */     GIR_EraseRootFromParent_Done,
     /* 656840 */   // Label 8446: @656840
     /* 656840 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(656940), // Rule ID 6267 //
     /* 656845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 656848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656852 */     // MIs[0] offset
     /* 656852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656855 */     // MIs[0] auxiliary
     /* 656855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656858 */     // MIs[0] Operand 8
     /* 656858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656868 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656884 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656891 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 656909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN_RTN),
     /* 656912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 656914 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 656916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 656919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 656921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 656926 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 656928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 656934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 656938 */     GIR_RootConstrainSelectedInstOperands,
     /* 656939 */     // GIR_Coverage, 6267,
     /* 656939 */     GIR_EraseRootFromParent_Done,
     /* 656940 */   // Label 8447: @656940
     /* 656940 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(657040), // Rule ID 6275 //
     /* 656945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 656948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 656952 */     // MIs[0] offset
     /* 656952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 656955 */     // MIs[0] auxiliary
     /* 656955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 656958 */     // MIs[0] Operand 8
     /* 656958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 656961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 656968 */     // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 656968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 656971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 656975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 656980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 656984 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 656987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 656991 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 656994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 656999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 657004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 657009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN),
     /* 657012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657014 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 657019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657026 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657038 */     GIR_RootConstrainSelectedInstOperands,
     /* 657039 */     // GIR_Coverage, 6275,
     /* 657039 */     GIR_EraseRootFromParent_Done,
     /* 657040 */   // Label 8448: @657040
     /* 657040 */   GIM_Reject,
     /* 657041 */ // Label 8432: @657041
     /* 657041 */ GIM_Reject,
     /* 657042 */ // Label 8430: @657042
     /* 657042 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(659431),
     /* 657047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 657050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 657053 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 657056 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 657059 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 657062 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(657130), // Rule ID 6300 //
     /* 657067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657070 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657080 */     // MIs[0] offset
     /* 657080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657083 */     // MIs[0] auxiliary
     /* 657083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657086 */     // MIs[0] Operand 8
     /* 657086 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657104 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 657107 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657116 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657118 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657128 */     GIR_RootConstrainSelectedInstOperands,
     /* 657129 */     // GIR_Coverage, 6300,
     /* 657129 */     GIR_EraseRootFromParent_Done,
     /* 657130 */   // Label 8450: @657130
     /* 657130 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(657198), // Rule ID 6308 //
     /* 657135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657138 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657148 */     // MIs[0] offset
     /* 657148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657151 */     // MIs[0] auxiliary
     /* 657151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657154 */     // MIs[0] Operand 8
     /* 657154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657172 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 657175 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657184 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657186 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657196 */     GIR_RootConstrainSelectedInstOperands,
     /* 657197 */     // GIR_Coverage, 6308,
     /* 657197 */     GIR_EraseRootFromParent_Done,
     /* 657198 */   // Label 8451: @657198
     /* 657198 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(657266), // Rule ID 6380 //
     /* 657203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657206 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657216 */     // MIs[0] offset
     /* 657216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657219 */     // MIs[0] auxiliary
     /* 657219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657222 */     // MIs[0] Operand 8
     /* 657222 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657240 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
     /* 657243 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657252 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657264 */     GIR_RootConstrainSelectedInstOperands,
     /* 657265 */     // GIR_Coverage, 6380,
     /* 657265 */     GIR_EraseRootFromParent_Done,
     /* 657266 */   // Label 8452: @657266
     /* 657266 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(657334), // Rule ID 6388 //
     /* 657271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657274 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657284 */     // MIs[0] offset
     /* 657284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657287 */     // MIs[0] auxiliary
     /* 657287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657290 */     // MIs[0] Operand 8
     /* 657290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657308 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
     /* 657311 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657320 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657322 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657332 */     GIR_RootConstrainSelectedInstOperands,
     /* 657333 */     // GIR_Coverage, 6388,
     /* 657333 */     GIR_EraseRootFromParent_Done,
     /* 657334 */   // Label 8453: @657334
     /* 657334 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(657406), // Rule ID 6296 //
     /* 657339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657354 */     // MIs[0] offset
     /* 657354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657357 */     // MIs[0] auxiliary
     /* 657357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657360 */     // MIs[0] Operand 8
     /* 657360 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657378 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 657381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657383 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657392 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657404 */     GIR_RootConstrainSelectedInstOperands,
     /* 657405 */     // GIR_Coverage, 6296,
     /* 657405 */     GIR_EraseRootFromParent_Done,
     /* 657406 */   // Label 8454: @657406
     /* 657406 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(657478), // Rule ID 6304 //
     /* 657411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657426 */     // MIs[0] offset
     /* 657426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657429 */     // MIs[0] auxiliary
     /* 657429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657432 */     // MIs[0] Operand 8
     /* 657432 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657450 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 657453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657455 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657464 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657476 */     GIR_RootConstrainSelectedInstOperands,
     /* 657477 */     // GIR_Coverage, 6304,
     /* 657477 */     GIR_EraseRootFromParent_Done,
     /* 657478 */   // Label 8455: @657478
     /* 657478 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(657550), // Rule ID 6376 //
     /* 657483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657498 */     // MIs[0] offset
     /* 657498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657501 */     // MIs[0] auxiliary
     /* 657501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657504 */     // MIs[0] Operand 8
     /* 657504 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657522 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
     /* 657525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657527 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657536 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657548 */     GIR_RootConstrainSelectedInstOperands,
     /* 657549 */     // GIR_Coverage, 6376,
     /* 657549 */     GIR_EraseRootFromParent_Done,
     /* 657550 */   // Label 8456: @657550
     /* 657550 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(657622), // Rule ID 6384 //
     /* 657555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 657570 */     // MIs[0] offset
     /* 657570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657573 */     // MIs[0] auxiliary
     /* 657573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657576 */     // MIs[0] Operand 8
     /* 657576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657594 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
     /* 657597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657599 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657608 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657610 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657620 */     GIR_RootConstrainSelectedInstOperands,
     /* 657621 */     // GIR_Coverage, 6384,
     /* 657621 */     GIR_EraseRootFromParent_Done,
     /* 657622 */   // Label 8457: @657622
     /* 657622 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(657688), // Rule ID 6302 //
     /* 657627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657630 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657636 */     // MIs[0] offset
     /* 657636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657639 */     // MIs[0] auxiliary
     /* 657639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657642 */     // MIs[0] Operand 8
     /* 657642 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657660 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
     /* 657663 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657665 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657674 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657676 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657686 */     GIR_RootConstrainSelectedInstOperands,
     /* 657687 */     // GIR_Coverage, 6302,
     /* 657687 */     GIR_EraseRootFromParent_Done,
     /* 657688 */   // Label 8458: @657688
     /* 657688 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(657754), // Rule ID 6310 //
     /* 657693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657696 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657702 */     // MIs[0] offset
     /* 657702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657705 */     // MIs[0] auxiliary
     /* 657705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657708 */     // MIs[0] Operand 8
     /* 657708 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657726 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
     /* 657729 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657731 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657740 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657752 */     GIR_RootConstrainSelectedInstOperands,
     /* 657753 */     // GIR_Coverage, 6310,
     /* 657753 */     GIR_EraseRootFromParent_Done,
     /* 657754 */   // Label 8459: @657754
     /* 657754 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(657820), // Rule ID 6382 //
     /* 657759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657762 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657768 */     // MIs[0] offset
     /* 657768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657771 */     // MIs[0] auxiliary
     /* 657771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657774 */     // MIs[0] Operand 8
     /* 657774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657792 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
     /* 657795 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657797 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657806 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657818 */     GIR_RootConstrainSelectedInstOperands,
     /* 657819 */     // GIR_Coverage, 6382,
     /* 657819 */     GIR_EraseRootFromParent_Done,
     /* 657820 */   // Label 8460: @657820
     /* 657820 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(657886), // Rule ID 6390 //
     /* 657825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657828 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 657830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657834 */     // MIs[0] offset
     /* 657834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657837 */     // MIs[0] auxiliary
     /* 657837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657840 */     // MIs[0] Operand 8
     /* 657840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657858 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
     /* 657861 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657863 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657872 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 657880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657884 */     GIR_RootConstrainSelectedInstOperands,
     /* 657885 */     // GIR_Coverage, 6390,
     /* 657885 */     GIR_EraseRootFromParent_Done,
     /* 657886 */   // Label 8461: @657886
     /* 657886 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(657956), // Rule ID 6298 //
     /* 657891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 657894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657902 */     // MIs[0] offset
     /* 657902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657905 */     // MIs[0] auxiliary
     /* 657905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657908 */     // MIs[0] Operand 8
     /* 657908 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657926 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
     /* 657929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 657931 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 657933 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 657935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 657937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 657942 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 657944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 657950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 657954 */     GIR_RootConstrainSelectedInstOperands,
     /* 657955 */     // GIR_Coverage, 6298,
     /* 657955 */     GIR_EraseRootFromParent_Done,
     /* 657956 */   // Label 8462: @657956
     /* 657956 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(658026), // Rule ID 6306 //
     /* 657961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 657964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 657968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 657972 */     // MIs[0] offset
     /* 657972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 657975 */     // MIs[0] auxiliary
     /* 657975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 657978 */     // MIs[0] Operand 8
     /* 657978 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 657989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 657996 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 657996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
     /* 657999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658001 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658003 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 658005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658012 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658024 */     GIR_RootConstrainSelectedInstOperands,
     /* 658025 */     // GIR_Coverage, 6306,
     /* 658025 */     GIR_EraseRootFromParent_Done,
     /* 658026 */   // Label 8463: @658026
     /* 658026 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(658096), // Rule ID 6378 //
     /* 658031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658042 */     // MIs[0] offset
     /* 658042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658045 */     // MIs[0] auxiliary
     /* 658045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658048 */     // MIs[0] Operand 8
     /* 658048 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 658059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658066 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
     /* 658069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658073 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 658075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658082 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658094 */     GIR_RootConstrainSelectedInstOperands,
     /* 658095 */     // GIR_Coverage, 6378,
     /* 658095 */     GIR_EraseRootFromParent_Done,
     /* 658096 */   // Label 8464: @658096
     /* 658096 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(658166), // Rule ID 6386 //
     /* 658101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 658112 */     // MIs[0] offset
     /* 658112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658115 */     // MIs[0] auxiliary
     /* 658115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658118 */     // MIs[0] Operand 8
     /* 658118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 658129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658136 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
     /* 658139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658141 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658143 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 658145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658152 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658164 */     GIR_RootConstrainSelectedInstOperands,
     /* 658165 */     // GIR_Coverage, 6386,
     /* 658165 */     GIR_EraseRootFromParent_Done,
     /* 658166 */   // Label 8465: @658166
     /* 658166 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(658224), // Rule ID 6301 //
     /* 658171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658174 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658180 */     // MIs[0] offset
     /* 658180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658183 */     // MIs[0] auxiliary
     /* 658183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658186 */     // MIs[0] Operand 8
     /* 658186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658196 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
     /* 658199 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658201 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658210 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658222 */     GIR_RootConstrainSelectedInstOperands,
     /* 658223 */     // GIR_Coverage, 6301,
     /* 658223 */     GIR_EraseRootFromParent_Done,
     /* 658224 */   // Label 8466: @658224
     /* 658224 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(658282), // Rule ID 6309 //
     /* 658229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658232 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658238 */     // MIs[0] offset
     /* 658238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658241 */     // MIs[0] auxiliary
     /* 658241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658244 */     // MIs[0] Operand 8
     /* 658244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658254 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
     /* 658257 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658259 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658268 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658270 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658280 */     GIR_RootConstrainSelectedInstOperands,
     /* 658281 */     // GIR_Coverage, 6309,
     /* 658281 */     GIR_EraseRootFromParent_Done,
     /* 658282 */   // Label 8467: @658282
     /* 658282 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(658340), // Rule ID 6381 //
     /* 658287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658290 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658296 */     // MIs[0] offset
     /* 658296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658299 */     // MIs[0] auxiliary
     /* 658299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658302 */     // MIs[0] Operand 8
     /* 658302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658312 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
     /* 658315 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658317 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658326 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658328 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658338 */     GIR_RootConstrainSelectedInstOperands,
     /* 658339 */     // GIR_Coverage, 6381,
     /* 658339 */     GIR_EraseRootFromParent_Done,
     /* 658340 */   // Label 8468: @658340
     /* 658340 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(658398), // Rule ID 6389 //
     /* 658345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658348 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658354 */     // MIs[0] offset
     /* 658354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658357 */     // MIs[0] auxiliary
     /* 658357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658360 */     // MIs[0] Operand 8
     /* 658360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658370 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
     /* 658373 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658375 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658384 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658396 */     GIR_RootConstrainSelectedInstOperands,
     /* 658397 */     // GIR_Coverage, 6389,
     /* 658397 */     GIR_EraseRootFromParent_Done,
     /* 658398 */   // Label 8469: @658398
     /* 658398 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(658460), // Rule ID 6297 //
     /* 658403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658414 */     // MIs[0] offset
     /* 658414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658417 */     // MIs[0] auxiliary
     /* 658417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658420 */     // MIs[0] Operand 8
     /* 658420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658430 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
     /* 658433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658435 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658437 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658446 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658458 */     GIR_RootConstrainSelectedInstOperands,
     /* 658459 */     // GIR_Coverage, 6297,
     /* 658459 */     GIR_EraseRootFromParent_Done,
     /* 658460 */   // Label 8470: @658460
     /* 658460 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(658522), // Rule ID 6305 //
     /* 658465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658476 */     // MIs[0] offset
     /* 658476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658479 */     // MIs[0] auxiliary
     /* 658479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658482 */     // MIs[0] Operand 8
     /* 658482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658492 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
     /* 658495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658497 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658499 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658508 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658510 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658520 */     GIR_RootConstrainSelectedInstOperands,
     /* 658521 */     // GIR_Coverage, 6305,
     /* 658521 */     GIR_EraseRootFromParent_Done,
     /* 658522 */   // Label 8471: @658522
     /* 658522 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(658584), // Rule ID 6377 //
     /* 658527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658538 */     // MIs[0] offset
     /* 658538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658541 */     // MIs[0] auxiliary
     /* 658541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658544 */     // MIs[0] Operand 8
     /* 658544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658554 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
     /* 658557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658559 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658561 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658570 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658582 */     GIR_RootConstrainSelectedInstOperands,
     /* 658583 */     // GIR_Coverage, 6377,
     /* 658583 */     GIR_EraseRootFromParent_Done,
     /* 658584 */   // Label 8472: @658584
     /* 658584 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(658646), // Rule ID 6385 //
     /* 658589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 658596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 658600 */     // MIs[0] offset
     /* 658600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658603 */     // MIs[0] auxiliary
     /* 658603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658606 */     // MIs[0] Operand 8
     /* 658606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658616 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
     /* 658619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 658621 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658623 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 658625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658632 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 658640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658644 */     GIR_RootConstrainSelectedInstOperands,
     /* 658645 */     // GIR_Coverage, 6385,
     /* 658645 */     GIR_EraseRootFromParent_Done,
     /* 658646 */   // Label 8473: @658646
     /* 658646 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(658742), // Rule ID 6303 //
     /* 658651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658654 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658656 */     // MIs[0] offset
     /* 658656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658659 */     // MIs[0] auxiliary
     /* 658659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658662 */     // MIs[0] Operand 8
     /* 658662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658672 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658688 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658691 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658695 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
     /* 658716 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658728 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658740 */     GIR_RootConstrainSelectedInstOperands,
     /* 658741 */     // GIR_Coverage, 6303,
     /* 658741 */     GIR_EraseRootFromParent_Done,
     /* 658742 */   // Label 8474: @658742
     /* 658742 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(658838), // Rule ID 6311 //
     /* 658747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658750 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658752 */     // MIs[0] offset
     /* 658752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658755 */     // MIs[0] auxiliary
     /* 658755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658758 */     // MIs[0] Operand 8
     /* 658758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658768 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658784 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658791 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
     /* 658812 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658824 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658836 */     GIR_RootConstrainSelectedInstOperands,
     /* 658837 */     // GIR_Coverage, 6311,
     /* 658837 */     GIR_EraseRootFromParent_Done,
     /* 658838 */   // Label 8475: @658838
     /* 658838 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(658934), // Rule ID 6383 //
     /* 658843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 658846 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658848 */     // MIs[0] offset
     /* 658848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658851 */     // MIs[0] auxiliary
     /* 658851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658854 */     // MIs[0] Operand 8
     /* 658854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658864 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658880 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658887 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
     /* 658908 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 658910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 658913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 658915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 658920 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 658922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 658928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 658932 */     GIR_RootConstrainSelectedInstOperands,
     /* 658933 */     // GIR_Coverage, 6383,
     /* 658933 */     GIR_EraseRootFromParent_Done,
     /* 658934 */   // Label 8476: @658934
     /* 658934 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(659030), // Rule ID 6391 //
     /* 658939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 658942 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 658944 */     // MIs[0] offset
     /* 658944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 658947 */     // MIs[0] auxiliary
     /* 658947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 658950 */     // MIs[0] Operand 8
     /* 658950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 658953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 658960 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 658960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 658963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 658967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 658972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 658976 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 658979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 658983 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 658986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 658991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 658996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
     /* 659004 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659016 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659028 */     GIR_RootConstrainSelectedInstOperands,
     /* 659029 */     // GIR_Coverage, 6391,
     /* 659029 */     GIR_EraseRootFromParent_Done,
     /* 659030 */   // Label 8477: @659030
     /* 659030 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(659130), // Rule ID 6299 //
     /* 659035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 659038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 659042 */     // MIs[0] offset
     /* 659042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659045 */     // MIs[0] auxiliary
     /* 659045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659048 */     // MIs[0] Operand 8
     /* 659048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659058 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659074 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659081 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
     /* 659102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659104 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659116 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659118 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659128 */     GIR_RootConstrainSelectedInstOperands,
     /* 659129 */     // GIR_Coverage, 6299,
     /* 659129 */     GIR_EraseRootFromParent_Done,
     /* 659130 */   // Label 8478: @659130
     /* 659130 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(659230), // Rule ID 6307 //
     /* 659135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 659138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 659142 */     // MIs[0] offset
     /* 659142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659145 */     // MIs[0] auxiliary
     /* 659145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659148 */     // MIs[0] Operand 8
     /* 659148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659158 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659174 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659181 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
     /* 659202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659204 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659216 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659228 */     GIR_RootConstrainSelectedInstOperands,
     /* 659229 */     // GIR_Coverage, 6307,
     /* 659229 */     GIR_EraseRootFromParent_Done,
     /* 659230 */   // Label 8479: @659230
     /* 659230 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(659330), // Rule ID 6379 //
     /* 659235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 659238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 659242 */     // MIs[0] offset
     /* 659242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659245 */     // MIs[0] auxiliary
     /* 659245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659248 */     // MIs[0] Operand 8
     /* 659248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659258 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659274 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659281 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
     /* 659302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659304 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659316 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659328 */     GIR_RootConstrainSelectedInstOperands,
     /* 659329 */     // GIR_Coverage, 6379,
     /* 659329 */     GIR_EraseRootFromParent_Done,
     /* 659330 */   // Label 8480: @659330
     /* 659330 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(659430), // Rule ID 6387 //
     /* 659335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 659338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 659342 */     // MIs[0] offset
     /* 659342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659345 */     // MIs[0] auxiliary
     /* 659345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659348 */     // MIs[0] Operand 8
     /* 659348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 659351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659358 */     // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 659361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 659365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 659370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 659374 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 659377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 659381 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 659384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 659389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 659399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
     /* 659402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659404 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 659409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659416 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659428 */     GIR_RootConstrainSelectedInstOperands,
     /* 659429 */     // GIR_Coverage, 6387,
     /* 659429 */     GIR_EraseRootFromParent_Done,
     /* 659430 */   // Label 8481: @659430
     /* 659430 */   GIM_Reject,
     /* 659431 */ // Label 8449: @659431
     /* 659431 */ GIM_Reject,
     /* 659432 */ // Label 8431: @659432
     /* 659432 */ GIM_Reject,
     /* 659433 */ // Label 115: @659433
     /* 659433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8484*/ GIMT_Encode4(663048),
     /* 659444 */ /*GILLT_s32*//*Label 8482*/ GIMT_Encode4(659452),
     /* 659448 */ /*GILLT_s64*//*Label 8483*/ GIMT_Encode4(660658),
     /* 659452 */ // Label 8482: @659452
     /* 659452 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(660657),
     /* 659457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 659460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 659463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 659466 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 659469 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 659472 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(659540), // Rule ID 6252 //
     /* 659477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 659480 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659490 */     // MIs[0] offset
     /* 659490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659493 */     // MIs[0] auxiliary
     /* 659493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659496 */     // MIs[0] Operand 8
     /* 659496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659514 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
     /* 659517 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659526 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659538 */     GIR_RootConstrainSelectedInstOperands,
     /* 659539 */     // GIR_Coverage, 6252,
     /* 659539 */     GIR_EraseRootFromParent_Done,
     /* 659540 */   // Label 8486: @659540
     /* 659540 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(659608), // Rule ID 6260 //
     /* 659545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 659548 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659558 */     // MIs[0] offset
     /* 659558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659561 */     // MIs[0] auxiliary
     /* 659561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659564 */     // MIs[0] Operand 8
     /* 659564 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659582 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
     /* 659585 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659594 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659606 */     GIR_RootConstrainSelectedInstOperands,
     /* 659607 */     // GIR_Coverage, 6260,
     /* 659607 */     GIR_EraseRootFromParent_Done,
     /* 659608 */   // Label 8487: @659608
     /* 659608 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(659680), // Rule ID 6248 //
     /* 659613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 659616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659628 */     // MIs[0] offset
     /* 659628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659631 */     // MIs[0] auxiliary
     /* 659631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659634 */     // MIs[0] Operand 8
     /* 659634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659652 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
     /* 659655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659657 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659666 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659678 */     GIR_RootConstrainSelectedInstOperands,
     /* 659679 */     // GIR_Coverage, 6248,
     /* 659679 */     GIR_EraseRootFromParent_Done,
     /* 659680 */   // Label 8488: @659680
     /* 659680 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(659752), // Rule ID 6256 //
     /* 659685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 659688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 659700 */     // MIs[0] offset
     /* 659700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659703 */     // MIs[0] auxiliary
     /* 659703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659706 */     // MIs[0] Operand 8
     /* 659706 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659724 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
     /* 659727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659729 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659738 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659750 */     GIR_RootConstrainSelectedInstOperands,
     /* 659751 */     // GIR_Coverage, 6256,
     /* 659751 */     GIR_EraseRootFromParent_Done,
     /* 659752 */   // Label 8489: @659752
     /* 659752 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(659818), // Rule ID 6254 //
     /* 659757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 659760 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659766 */     // MIs[0] offset
     /* 659766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659769 */     // MIs[0] auxiliary
     /* 659769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659772 */     // MIs[0] Operand 8
     /* 659772 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659790 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN),
     /* 659793 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659795 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659804 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659806 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659816 */     GIR_RootConstrainSelectedInstOperands,
     /* 659817 */     // GIR_Coverage, 6254,
     /* 659817 */     GIR_EraseRootFromParent_Done,
     /* 659818 */   // Label 8490: @659818
     /* 659818 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(659884), // Rule ID 6262 //
     /* 659823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 659826 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 659828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659832 */     // MIs[0] offset
     /* 659832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659835 */     // MIs[0] auxiliary
     /* 659835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659838 */     // MIs[0] Operand 8
     /* 659838 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659856 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN),
     /* 659859 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659861 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659870 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 659878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659882 */     GIR_RootConstrainSelectedInstOperands,
     /* 659883 */     // GIR_Coverage, 6262,
     /* 659883 */     GIR_EraseRootFromParent_Done,
     /* 659884 */   // Label 8491: @659884
     /* 659884 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(659954), // Rule ID 6250 //
     /* 659889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 659892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659900 */     // MIs[0] offset
     /* 659900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659903 */     // MIs[0] auxiliary
     /* 659903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659906 */     // MIs[0] Operand 8
     /* 659906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659924 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN_RTN),
     /* 659927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659929 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 659931 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 659933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 659935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 659940 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 659942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 659948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 659952 */     GIR_RootConstrainSelectedInstOperands,
     /* 659953 */     // GIR_Coverage, 6250,
     /* 659953 */     GIR_EraseRootFromParent_Done,
     /* 659954 */   // Label 8492: @659954
     /* 659954 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(660024), // Rule ID 6258 //
     /* 659959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 659962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 659966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 659970 */     // MIs[0] offset
     /* 659970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 659973 */     // MIs[0] auxiliary
     /* 659973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 659976 */     // MIs[0] Operand 8
     /* 659976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 659987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 659994 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 659994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN),
     /* 659997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 659999 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660001 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 660003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660010 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660022 */     GIR_RootConstrainSelectedInstOperands,
     /* 660023 */     // GIR_Coverage, 6258,
     /* 660023 */     GIR_EraseRootFromParent_Done,
     /* 660024 */   // Label 8493: @660024
     /* 660024 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(660082), // Rule ID 6253 //
     /* 660029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 660032 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660038 */     // MIs[0] offset
     /* 660038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660041 */     // MIs[0] auxiliary
     /* 660041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660044 */     // MIs[0] Operand 8
     /* 660044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660054 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN),
     /* 660057 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660059 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660068 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660080 */     GIR_RootConstrainSelectedInstOperands,
     /* 660081 */     // GIR_Coverage, 6253,
     /* 660081 */     GIR_EraseRootFromParent_Done,
     /* 660082 */   // Label 8494: @660082
     /* 660082 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(660140), // Rule ID 6261 //
     /* 660087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 660090 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660096 */     // MIs[0] offset
     /* 660096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660099 */     // MIs[0] auxiliary
     /* 660099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660102 */     // MIs[0] Operand 8
     /* 660102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660112 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN),
     /* 660115 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660117 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660126 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660128 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660138 */     GIR_RootConstrainSelectedInstOperands,
     /* 660139 */     // GIR_Coverage, 6261,
     /* 660139 */     GIR_EraseRootFromParent_Done,
     /* 660140 */   // Label 8495: @660140
     /* 660140 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(660202), // Rule ID 6249 //
     /* 660145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 660148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 660152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660156 */     // MIs[0] offset
     /* 660156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660159 */     // MIs[0] auxiliary
     /* 660159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660162 */     // MIs[0] Operand 8
     /* 660162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660172 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN_RTN),
     /* 660175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660177 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660179 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660188 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660190 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660200 */     GIR_RootConstrainSelectedInstOperands,
     /* 660201 */     // GIR_Coverage, 6249,
     /* 660201 */     GIR_EraseRootFromParent_Done,
     /* 660202 */   // Label 8496: @660202
     /* 660202 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(660264), // Rule ID 6257 //
     /* 660207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 660210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 660214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660218 */     // MIs[0] offset
     /* 660218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660221 */     // MIs[0] auxiliary
     /* 660221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660224 */     // MIs[0] Operand 8
     /* 660224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660234 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN),
     /* 660237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660239 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660241 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 660243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660250 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660262 */     GIR_RootConstrainSelectedInstOperands,
     /* 660263 */     // GIR_Coverage, 6257,
     /* 660263 */     GIR_EraseRootFromParent_Done,
     /* 660264 */   // Label 8497: @660264
     /* 660264 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(660360), // Rule ID 6255 //
     /* 660269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 660272 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660274 */     // MIs[0] offset
     /* 660274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660277 */     // MIs[0] auxiliary
     /* 660277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660280 */     // MIs[0] Operand 8
     /* 660280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660290 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660306 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660313 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN),
     /* 660334 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660346 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660358 */     GIR_RootConstrainSelectedInstOperands,
     /* 660359 */     // GIR_Coverage, 6255,
     /* 660359 */     GIR_EraseRootFromParent_Done,
     /* 660360 */   // Label 8498: @660360
     /* 660360 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(660456), // Rule ID 6263 //
     /* 660365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 660368 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660370 */     // MIs[0] offset
     /* 660370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660373 */     // MIs[0] auxiliary
     /* 660373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660376 */     // MIs[0] Operand 8
     /* 660376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660386 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660402 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660409 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN),
     /* 660430 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660442 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660444 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660454 */     GIR_RootConstrainSelectedInstOperands,
     /* 660455 */     // GIR_Coverage, 6263,
     /* 660455 */     GIR_EraseRootFromParent_Done,
     /* 660456 */   // Label 8499: @660456
     /* 660456 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(660556), // Rule ID 6251 //
     /* 660461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
     /* 660464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 660468 */     // MIs[0] offset
     /* 660468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660471 */     // MIs[0] auxiliary
     /* 660471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660474 */     // MIs[0] Operand 8
     /* 660474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660484 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660500 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660507 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN_RTN),
     /* 660528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660530 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660542 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660554 */     GIR_RootConstrainSelectedInstOperands,
     /* 660555 */     // GIR_Coverage, 6251,
     /* 660555 */     GIR_EraseRootFromParent_Done,
     /* 660556 */   // Label 8500: @660556
     /* 660556 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(660656), // Rule ID 6259 //
     /* 660561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
     /* 660564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 660568 */     // MIs[0] offset
     /* 660568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660571 */     // MIs[0] auxiliary
     /* 660571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660574 */     // MIs[0] Operand 8
     /* 660574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 660577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660584 */     // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 660587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 660591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 660596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 660600 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 660603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 660607 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 660610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 660615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 660625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN),
     /* 660628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660630 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 660635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660642 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660644 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 660650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660654 */     GIR_RootConstrainSelectedInstOperands,
     /* 660655 */     // GIR_Coverage, 6259,
     /* 660655 */     GIR_EraseRootFromParent_Done,
     /* 660656 */   // Label 8501: @660656
     /* 660656 */   GIM_Reject,
     /* 660657 */ // Label 8485: @660657
     /* 660657 */ GIM_Reject,
     /* 660658 */ // Label 8483: @660658
     /* 660658 */ GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(663047),
     /* 660663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 660666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 660669 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 660672 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 660675 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 660678 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(660746), // Rule ID 6284 //
     /* 660683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 660686 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660696 */     // MIs[0] offset
     /* 660696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660699 */     // MIs[0] auxiliary
     /* 660699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660702 */     // MIs[0] Operand 8
     /* 660702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660720 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 660723 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660732 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660744 */     GIR_RootConstrainSelectedInstOperands,
     /* 660745 */     // GIR_Coverage, 6284,
     /* 660745 */     GIR_EraseRootFromParent_Done,
     /* 660746 */   // Label 8503: @660746
     /* 660746 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(660814), // Rule ID 6292 //
     /* 660751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 660754 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660764 */     // MIs[0] offset
     /* 660764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660767 */     // MIs[0] auxiliary
     /* 660767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660770 */     // MIs[0] Operand 8
     /* 660770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660788 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 660791 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660800 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660812 */     GIR_RootConstrainSelectedInstOperands,
     /* 660813 */     // GIR_Coverage, 6292,
     /* 660813 */     GIR_EraseRootFromParent_Done,
     /* 660814 */   // Label 8504: @660814
     /* 660814 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(660882), // Rule ID 6364 //
     /* 660819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 660822 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660832 */     // MIs[0] offset
     /* 660832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660835 */     // MIs[0] auxiliary
     /* 660835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660838 */     // MIs[0] Operand 8
     /* 660838 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660856 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
     /* 660859 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660868 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660870 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660880 */     GIR_RootConstrainSelectedInstOperands,
     /* 660881 */     // GIR_Coverage, 6364,
     /* 660881 */     GIR_EraseRootFromParent_Done,
     /* 660882 */   // Label 8505: @660882
     /* 660882 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(660950), // Rule ID 6372 //
     /* 660887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 660890 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 660892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660900 */     // MIs[0] offset
     /* 660900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660903 */     // MIs[0] auxiliary
     /* 660903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660906 */     // MIs[0] Operand 8
     /* 660906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660924 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
     /* 660927 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 660929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 660931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 660936 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 660938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 660944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 660948 */     GIR_RootConstrainSelectedInstOperands,
     /* 660949 */     // GIR_Coverage, 6372,
     /* 660949 */     GIR_EraseRootFromParent_Done,
     /* 660950 */   // Label 8506: @660950
     /* 660950 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(661022), // Rule ID 6280 //
     /* 660955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 660958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 660962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 660966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 660970 */     // MIs[0] offset
     /* 660970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 660973 */     // MIs[0] auxiliary
     /* 660973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 660976 */     // MIs[0] Operand 8
     /* 660976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 660987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 660994 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 660994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 660997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 660999 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661008 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661020 */     GIR_RootConstrainSelectedInstOperands,
     /* 661021 */     // GIR_Coverage, 6280,
     /* 661021 */     GIR_EraseRootFromParent_Done,
     /* 661022 */   // Label 8507: @661022
     /* 661022 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(661094), // Rule ID 6288 //
     /* 661027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661042 */     // MIs[0] offset
     /* 661042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661045 */     // MIs[0] auxiliary
     /* 661045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661048 */     // MIs[0] Operand 8
     /* 661048 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661066 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 661069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661071 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661080 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661092 */     GIR_RootConstrainSelectedInstOperands,
     /* 661093 */     // GIR_Coverage, 6288,
     /* 661093 */     GIR_EraseRootFromParent_Done,
     /* 661094 */   // Label 8508: @661094
     /* 661094 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(661166), // Rule ID 6360 //
     /* 661099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 661102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661114 */     // MIs[0] offset
     /* 661114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661117 */     // MIs[0] auxiliary
     /* 661117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661120 */     // MIs[0] Operand 8
     /* 661120 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661138 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
     /* 661141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661143 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661152 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661164 */     GIR_RootConstrainSelectedInstOperands,
     /* 661165 */     // GIR_Coverage, 6360,
     /* 661165 */     GIR_EraseRootFromParent_Done,
     /* 661166 */   // Label 8509: @661166
     /* 661166 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(661238), // Rule ID 6368 //
     /* 661171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661186 */     // MIs[0] offset
     /* 661186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661189 */     // MIs[0] auxiliary
     /* 661189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661192 */     // MIs[0] Operand 8
     /* 661192 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661210 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
     /* 661213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661215 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661224 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661236 */     GIR_RootConstrainSelectedInstOperands,
     /* 661237 */     // GIR_Coverage, 6368,
     /* 661237 */     GIR_EraseRootFromParent_Done,
     /* 661238 */   // Label 8510: @661238
     /* 661238 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(661304), // Rule ID 6286 //
     /* 661243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 661246 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661252 */     // MIs[0] offset
     /* 661252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661255 */     // MIs[0] auxiliary
     /* 661255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661258 */     // MIs[0] Operand 8
     /* 661258 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661276 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
     /* 661279 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661281 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661290 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661302 */     GIR_RootConstrainSelectedInstOperands,
     /* 661303 */     // GIR_Coverage, 6286,
     /* 661303 */     GIR_EraseRootFromParent_Done,
     /* 661304 */   // Label 8511: @661304
     /* 661304 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(661370), // Rule ID 6294 //
     /* 661309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661312 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661318 */     // MIs[0] offset
     /* 661318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661321 */     // MIs[0] auxiliary
     /* 661321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661324 */     // MIs[0] Operand 8
     /* 661324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661342 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
     /* 661345 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661347 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661356 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661368 */     GIR_RootConstrainSelectedInstOperands,
     /* 661369 */     // GIR_Coverage, 6294,
     /* 661369 */     GIR_EraseRootFromParent_Done,
     /* 661370 */   // Label 8512: @661370
     /* 661370 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(661436), // Rule ID 6366 //
     /* 661375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 661378 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661384 */     // MIs[0] offset
     /* 661384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661387 */     // MIs[0] auxiliary
     /* 661387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661390 */     // MIs[0] Operand 8
     /* 661390 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661408 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
     /* 661411 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661413 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661422 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661434 */     GIR_RootConstrainSelectedInstOperands,
     /* 661435 */     // GIR_Coverage, 6366,
     /* 661435 */     GIR_EraseRootFromParent_Done,
     /* 661436 */   // Label 8513: @661436
     /* 661436 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(661502), // Rule ID 6374 //
     /* 661441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661444 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661450 */     // MIs[0] offset
     /* 661450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661453 */     // MIs[0] auxiliary
     /* 661453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661456 */     // MIs[0] Operand 8
     /* 661456 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661474 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
     /* 661477 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661479 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661488 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661490 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661500 */     GIR_RootConstrainSelectedInstOperands,
     /* 661501 */     // GIR_Coverage, 6374,
     /* 661501 */     GIR_EraseRootFromParent_Done,
     /* 661502 */   // Label 8514: @661502
     /* 661502 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(661572), // Rule ID 6282 //
     /* 661507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 661510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661518 */     // MIs[0] offset
     /* 661518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661521 */     // MIs[0] auxiliary
     /* 661521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661524 */     // MIs[0] Operand 8
     /* 661524 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661542 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
     /* 661545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661547 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661549 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661558 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661570 */     GIR_RootConstrainSelectedInstOperands,
     /* 661571 */     // GIR_Coverage, 6282,
     /* 661571 */     GIR_EraseRootFromParent_Done,
     /* 661572 */   // Label 8515: @661572
     /* 661572 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(661642), // Rule ID 6290 //
     /* 661577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661588 */     // MIs[0] offset
     /* 661588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661591 */     // MIs[0] auxiliary
     /* 661591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661594 */     // MIs[0] Operand 8
     /* 661594 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661612 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
     /* 661615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661617 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661619 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661628 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661640 */     GIR_RootConstrainSelectedInstOperands,
     /* 661641 */     // GIR_Coverage, 6290,
     /* 661641 */     GIR_EraseRootFromParent_Done,
     /* 661642 */   // Label 8516: @661642
     /* 661642 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(661712), // Rule ID 6362 //
     /* 661647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 661650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661658 */     // MIs[0] offset
     /* 661658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661661 */     // MIs[0] auxiliary
     /* 661661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661664 */     // MIs[0] Operand 8
     /* 661664 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661682 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
     /* 661685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661687 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661689 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661698 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661710 */     GIR_RootConstrainSelectedInstOperands,
     /* 661711 */     // GIR_Coverage, 6362,
     /* 661711 */     GIR_EraseRootFromParent_Done,
     /* 661712 */   // Label 8517: @661712
     /* 661712 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(661782), // Rule ID 6370 //
     /* 661717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 661724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 661728 */     // MIs[0] offset
     /* 661728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661731 */     // MIs[0] auxiliary
     /* 661731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661734 */     // MIs[0] Operand 8
     /* 661734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 661745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661752 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
     /* 661755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 661757 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661759 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 661761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661768 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 661776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661780 */     GIR_RootConstrainSelectedInstOperands,
     /* 661781 */     // GIR_Coverage, 6370,
     /* 661781 */     GIR_EraseRootFromParent_Done,
     /* 661782 */   // Label 8518: @661782
     /* 661782 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(661840), // Rule ID 6285 //
     /* 661787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 661790 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661796 */     // MIs[0] offset
     /* 661796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661799 */     // MIs[0] auxiliary
     /* 661799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661802 */     // MIs[0] Operand 8
     /* 661802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661812 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
     /* 661815 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661817 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661826 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661838 */     GIR_RootConstrainSelectedInstOperands,
     /* 661839 */     // GIR_Coverage, 6285,
     /* 661839 */     GIR_EraseRootFromParent_Done,
     /* 661840 */   // Label 8519: @661840
     /* 661840 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(661898), // Rule ID 6293 //
     /* 661845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661848 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661854 */     // MIs[0] offset
     /* 661854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661857 */     // MIs[0] auxiliary
     /* 661857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661860 */     // MIs[0] Operand 8
     /* 661860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661870 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
     /* 661873 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661875 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661884 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661896 */     GIR_RootConstrainSelectedInstOperands,
     /* 661897 */     // GIR_Coverage, 6293,
     /* 661897 */     GIR_EraseRootFromParent_Done,
     /* 661898 */   // Label 8520: @661898
     /* 661898 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(661956), // Rule ID 6365 //
     /* 661903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 661906 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661912 */     // MIs[0] offset
     /* 661912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661915 */     // MIs[0] auxiliary
     /* 661915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661918 */     // MIs[0] Operand 8
     /* 661918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661928 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
     /* 661931 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661933 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 661942 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 661944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 661950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 661954 */     GIR_RootConstrainSelectedInstOperands,
     /* 661955 */     // GIR_Coverage, 6365,
     /* 661955 */     GIR_EraseRootFromParent_Done,
     /* 661956 */   // Label 8521: @661956
     /* 661956 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(662014), // Rule ID 6373 //
     /* 661961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 661964 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 661966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 661970 */     // MIs[0] offset
     /* 661970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 661973 */     // MIs[0] auxiliary
     /* 661973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 661976 */     // MIs[0] Operand 8
     /* 661976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 661979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 661986 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 661986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
     /* 661989 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 661991 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 661993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 661995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662000 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662012 */     GIR_RootConstrainSelectedInstOperands,
     /* 662013 */     // GIR_Coverage, 6373,
     /* 662013 */     GIR_EraseRootFromParent_Done,
     /* 662014 */   // Label 8522: @662014
     /* 662014 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(662076), // Rule ID 6281 //
     /* 662019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 662022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662030 */     // MIs[0] offset
     /* 662030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662033 */     // MIs[0] auxiliary
     /* 662033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662036 */     // MIs[0] Operand 8
     /* 662036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662046 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
     /* 662049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662051 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662053 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662062 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662074 */     GIR_RootConstrainSelectedInstOperands,
     /* 662075 */     // GIR_Coverage, 6281,
     /* 662075 */     GIR_EraseRootFromParent_Done,
     /* 662076 */   // Label 8523: @662076
     /* 662076 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(662138), // Rule ID 6289 //
     /* 662081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 662084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662092 */     // MIs[0] offset
     /* 662092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662095 */     // MIs[0] auxiliary
     /* 662095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662098 */     // MIs[0] Operand 8
     /* 662098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662108 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
     /* 662111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662113 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662115 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662124 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662136 */     GIR_RootConstrainSelectedInstOperands,
     /* 662137 */     // GIR_Coverage, 6289,
     /* 662137 */     GIR_EraseRootFromParent_Done,
     /* 662138 */   // Label 8524: @662138
     /* 662138 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(662200), // Rule ID 6361 //
     /* 662143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 662146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662154 */     // MIs[0] offset
     /* 662154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662157 */     // MIs[0] auxiliary
     /* 662157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662160 */     // MIs[0] Operand 8
     /* 662160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662170 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
     /* 662173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662175 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662177 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662186 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662198 */     GIR_RootConstrainSelectedInstOperands,
     /* 662199 */     // GIR_Coverage, 6361,
     /* 662199 */     GIR_EraseRootFromParent_Done,
     /* 662200 */   // Label 8525: @662200
     /* 662200 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(662262), // Rule ID 6369 //
     /* 662205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 662208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 662216 */     // MIs[0] offset
     /* 662216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662219 */     // MIs[0] auxiliary
     /* 662219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662222 */     // MIs[0] Operand 8
     /* 662222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662232 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
     /* 662235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662237 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662239 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 662241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662248 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662260 */     GIR_RootConstrainSelectedInstOperands,
     /* 662261 */     // GIR_Coverage, 6369,
     /* 662261 */     GIR_EraseRootFromParent_Done,
     /* 662262 */   // Label 8526: @662262
     /* 662262 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(662358), // Rule ID 6287 //
     /* 662267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 662270 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662272 */     // MIs[0] offset
     /* 662272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662275 */     // MIs[0] auxiliary
     /* 662275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662278 */     // MIs[0] Operand 8
     /* 662278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662288 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662311 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
     /* 662332 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662344 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662356 */     GIR_RootConstrainSelectedInstOperands,
     /* 662357 */     // GIR_Coverage, 6287,
     /* 662357 */     GIR_EraseRootFromParent_Done,
     /* 662358 */   // Label 8527: @662358
     /* 662358 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(662454), // Rule ID 6295 //
     /* 662363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 662366 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662368 */     // MIs[0] offset
     /* 662368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662371 */     // MIs[0] auxiliary
     /* 662371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662374 */     // MIs[0] Operand 8
     /* 662374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662384 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662400 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662403 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662407 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
     /* 662428 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662440 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662452 */     GIR_RootConstrainSelectedInstOperands,
     /* 662453 */     // GIR_Coverage, 6295,
     /* 662453 */     GIR_EraseRootFromParent_Done,
     /* 662454 */   // Label 8528: @662454
     /* 662454 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(662550), // Rule ID 6367 //
     /* 662459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 662462 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662464 */     // MIs[0] offset
     /* 662464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662467 */     // MIs[0] auxiliary
     /* 662467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662470 */     // MIs[0] Operand 8
     /* 662470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662480 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662496 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662503 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
     /* 662524 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662536 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662548 */     GIR_RootConstrainSelectedInstOperands,
     /* 662549 */     // GIR_Coverage, 6367,
     /* 662549 */     GIR_EraseRootFromParent_Done,
     /* 662550 */   // Label 8529: @662550
     /* 662550 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(662646), // Rule ID 6375 //
     /* 662555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 662558 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 662560 */     // MIs[0] offset
     /* 662560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662563 */     // MIs[0] auxiliary
     /* 662563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662566 */     // MIs[0] Operand 8
     /* 662566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662576 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662592 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662599 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
     /* 662620 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662632 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 662640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662644 */     GIR_RootConstrainSelectedInstOperands,
     /* 662645 */     // GIR_Coverage, 6375,
     /* 662645 */     GIR_EraseRootFromParent_Done,
     /* 662646 */   // Label 8530: @662646
     /* 662646 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(662746), // Rule ID 6283 //
     /* 662651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 662654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662658 */     // MIs[0] offset
     /* 662658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662661 */     // MIs[0] auxiliary
     /* 662661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662664 */     // MIs[0] Operand 8
     /* 662664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662674 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662690 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662697 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
     /* 662718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662720 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662732 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662744 */     GIR_RootConstrainSelectedInstOperands,
     /* 662745 */     // GIR_Coverage, 6283,
     /* 662745 */     GIR_EraseRootFromParent_Done,
     /* 662746 */   // Label 8531: @662746
     /* 662746 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(662846), // Rule ID 6291 //
     /* 662751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 662754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662758 */     // MIs[0] offset
     /* 662758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662761 */     // MIs[0] auxiliary
     /* 662761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662764 */     // MIs[0] Operand 8
     /* 662764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662774 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662790 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662793 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662797 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
     /* 662818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662820 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662832 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662844 */     GIR_RootConstrainSelectedInstOperands,
     /* 662845 */     // GIR_Coverage, 6291,
     /* 662845 */     GIR_EraseRootFromParent_Done,
     /* 662846 */   // Label 8532: @662846
     /* 662846 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(662946), // Rule ID 6363 //
     /* 662851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
     /* 662854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662858 */     // MIs[0] offset
     /* 662858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662861 */     // MIs[0] auxiliary
     /* 662861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662864 */     // MIs[0] Operand 8
     /* 662864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662874 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662890 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662897 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 662900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 662905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 662915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
     /* 662918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 662920 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 662922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 662925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 662927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 662932 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 662934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 662940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 662944 */     GIR_RootConstrainSelectedInstOperands,
     /* 662945 */     // GIR_Coverage, 6363,
     /* 662945 */     GIR_EraseRootFromParent_Done,
     /* 662946 */   // Label 8533: @662946
     /* 662946 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(663046), // Rule ID 6371 //
     /* 662951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
     /* 662954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 662958 */     // MIs[0] offset
     /* 662958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 662961 */     // MIs[0] auxiliary
     /* 662961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 662964 */     // MIs[0] Operand 8
     /* 662964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 662967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 662974 */     // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9743:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 662974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 662977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 662981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 662986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 662990 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 662993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 662997 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
     /* 663018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663020 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663032 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663044 */     GIR_RootConstrainSelectedInstOperands,
     /* 663045 */     // GIR_Coverage, 6371,
     /* 663045 */     GIR_EraseRootFromParent_Done,
     /* 663046 */   // Label 8534: @663046
     /* 663046 */   GIM_Reject,
     /* 663047 */ // Label 8502: @663047
     /* 663047 */ GIM_Reject,
     /* 663048 */ // Label 8484: @663048
     /* 663048 */ GIM_Reject,
     /* 663049 */ // Label 116: @663049
     /* 663049 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8537*/ GIMT_Encode4(665432),
     /* 663060 */ /*GILLT_s32*//*Label 8535*/ GIMT_Encode4(663068),
     /* 663064 */ /*GILLT_s64*//*Label 8536*/ GIMT_Encode4(664250),
     /* 663068 */ // Label 8535: @663068
     /* 663068 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(664249),
     /* 663073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 663076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 663079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 663082 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 663085 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 663088 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(663156), // Rule ID 6004 //
     /* 663093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663096 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663106 */     // MIs[0] offset
     /* 663106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663109 */     // MIs[0] auxiliary
     /* 663109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663112 */     // MIs[0] Operand 8
     /* 663112 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663130 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
     /* 663133 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663142 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663154 */     GIR_RootConstrainSelectedInstOperands,
     /* 663155 */     // GIR_Coverage, 6004,
     /* 663155 */     GIR_EraseRootFromParent_Done,
     /* 663156 */   // Label 8539: @663156
     /* 663156 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(663221), // Rule ID 6012 //
     /* 663161 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663171 */     // MIs[0] offset
     /* 663171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663174 */     // MIs[0] auxiliary
     /* 663174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663177 */     // MIs[0] Operand 8
     /* 663177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663195 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
     /* 663198 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663207 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663219 */     GIR_RootConstrainSelectedInstOperands,
     /* 663220 */     // GIR_Coverage, 6012,
     /* 663220 */     GIR_EraseRootFromParent_Done,
     /* 663221 */   // Label 8540: @663221
     /* 663221 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(663293), // Rule ID 6000 //
     /* 663226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663241 */     // MIs[0] offset
     /* 663241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663244 */     // MIs[0] auxiliary
     /* 663244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663247 */     // MIs[0] Operand 8
     /* 663247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663265 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
     /* 663268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663270 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663279 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663281 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663291 */     GIR_RootConstrainSelectedInstOperands,
     /* 663292 */     // GIR_Coverage, 6000,
     /* 663292 */     GIR_EraseRootFromParent_Done,
     /* 663293 */   // Label 8541: @663293
     /* 663293 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(663362), // Rule ID 6008 //
     /* 663298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663310 */     // MIs[0] offset
     /* 663310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663313 */     // MIs[0] auxiliary
     /* 663313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663316 */     // MIs[0] Operand 8
     /* 663316 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663334 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
     /* 663337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663339 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663348 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663360 */     GIR_RootConstrainSelectedInstOperands,
     /* 663361 */     // GIR_Coverage, 6008,
     /* 663361 */     GIR_EraseRootFromParent_Done,
     /* 663362 */   // Label 8542: @663362
     /* 663362 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(663428), // Rule ID 6006 //
     /* 663367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663370 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663376 */     // MIs[0] offset
     /* 663376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663379 */     // MIs[0] auxiliary
     /* 663379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663382 */     // MIs[0] Operand 8
     /* 663382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663400 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN),
     /* 663403 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663405 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663414 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663426 */     GIR_RootConstrainSelectedInstOperands,
     /* 663427 */     // GIR_Coverage, 6006,
     /* 663427 */     GIR_EraseRootFromParent_Done,
     /* 663428 */   // Label 8543: @663428
     /* 663428 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(663491), // Rule ID 6014 //
     /* 663433 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663439 */     // MIs[0] offset
     /* 663439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663442 */     // MIs[0] auxiliary
     /* 663442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663445 */     // MIs[0] Operand 8
     /* 663445 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663463 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN),
     /* 663466 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663468 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663477 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663489 */     GIR_RootConstrainSelectedInstOperands,
     /* 663490 */     // GIR_Coverage, 6014,
     /* 663490 */     GIR_EraseRootFromParent_Done,
     /* 663491 */   // Label 8544: @663491
     /* 663491 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(663561), // Rule ID 6002 //
     /* 663496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663507 */     // MIs[0] offset
     /* 663507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663510 */     // MIs[0] auxiliary
     /* 663510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663513 */     // MIs[0] Operand 8
     /* 663513 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663531 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN_RTN),
     /* 663534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663536 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663538 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663547 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663559 */     GIR_RootConstrainSelectedInstOperands,
     /* 663560 */     // GIR_Coverage, 6002,
     /* 663560 */     GIR_EraseRootFromParent_Done,
     /* 663561 */   // Label 8545: @663561
     /* 663561 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(663628), // Rule ID 6010 //
     /* 663566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 663574 */     // MIs[0] offset
     /* 663574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663577 */     // MIs[0] auxiliary
     /* 663577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663580 */     // MIs[0] Operand 8
     /* 663580 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 663591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663598 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN),
     /* 663601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663603 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663605 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 663607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663614 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663616 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663626 */     GIR_RootConstrainSelectedInstOperands,
     /* 663627 */     // GIR_Coverage, 6010,
     /* 663627 */     GIR_EraseRootFromParent_Done,
     /* 663628 */   // Label 8546: @663628
     /* 663628 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(663686), // Rule ID 6005 //
     /* 663633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663636 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663642 */     // MIs[0] offset
     /* 663642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663645 */     // MIs[0] auxiliary
     /* 663645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663648 */     // MIs[0] Operand 8
     /* 663648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663658 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN),
     /* 663661 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663663 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663672 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663684 */     GIR_RootConstrainSelectedInstOperands,
     /* 663685 */     // GIR_Coverage, 6005,
     /* 663685 */     GIR_EraseRootFromParent_Done,
     /* 663686 */   // Label 8547: @663686
     /* 663686 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(663741), // Rule ID 6013 //
     /* 663691 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663697 */     // MIs[0] offset
     /* 663697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663700 */     // MIs[0] auxiliary
     /* 663700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663703 */     // MIs[0] Operand 8
     /* 663703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663713 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN),
     /* 663716 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663718 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663727 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663739 */     GIR_RootConstrainSelectedInstOperands,
     /* 663740 */     // GIR_Coverage, 6013,
     /* 663740 */     GIR_EraseRootFromParent_Done,
     /* 663741 */   // Label 8548: @663741
     /* 663741 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(663803), // Rule ID 6001 //
     /* 663746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663757 */     // MIs[0] offset
     /* 663757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663760 */     // MIs[0] auxiliary
     /* 663760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663763 */     // MIs[0] Operand 8
     /* 663763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663773 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN_RTN),
     /* 663776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663778 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663780 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663789 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663801 */     GIR_RootConstrainSelectedInstOperands,
     /* 663802 */     // GIR_Coverage, 6001,
     /* 663802 */     GIR_EraseRootFromParent_Done,
     /* 663803 */   // Label 8549: @663803
     /* 663803 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(663862), // Rule ID 6009 //
     /* 663808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 663812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 663816 */     // MIs[0] offset
     /* 663816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663819 */     // MIs[0] auxiliary
     /* 663819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663822 */     // MIs[0] Operand 8
     /* 663822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663832 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN),
     /* 663835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 663837 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663839 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 663841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663848 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 663856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663860 */     GIR_RootConstrainSelectedInstOperands,
     /* 663861 */     // GIR_Coverage, 6009,
     /* 663861 */     GIR_EraseRootFromParent_Done,
     /* 663862 */   // Label 8550: @663862
     /* 663862 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(663958), // Rule ID 6007 //
     /* 663867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 663870 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663872 */     // MIs[0] offset
     /* 663872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663875 */     // MIs[0] auxiliary
     /* 663875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663878 */     // MIs[0] Operand 8
     /* 663878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663888 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663904 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 663907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 663911 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 663914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 663919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 663929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN),
     /* 663932 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 663934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 663937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 663939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 663944 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 663946 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 663952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 663956 */     GIR_RootConstrainSelectedInstOperands,
     /* 663957 */     // GIR_Coverage, 6007,
     /* 663957 */     GIR_EraseRootFromParent_Done,
     /* 663958 */   // Label 8551: @663958
     /* 663958 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(664051), // Rule ID 6015 //
     /* 663963 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 663965 */     // MIs[0] offset
     /* 663965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 663968 */     // MIs[0] auxiliary
     /* 663968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 663971 */     // MIs[0] Operand 8
     /* 663971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 663974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 663981 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 663981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 663984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 663988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 663993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 663997 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664004 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN),
     /* 664025 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664037 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664049 */     GIR_RootConstrainSelectedInstOperands,
     /* 664050 */     // GIR_Coverage, 6015,
     /* 664050 */     GIR_EraseRootFromParent_Done,
     /* 664051 */   // Label 8552: @664051
     /* 664051 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(664151), // Rule ID 6003 //
     /* 664056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664063 */     // MIs[0] offset
     /* 664063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664066 */     // MIs[0] auxiliary
     /* 664066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664069 */     // MIs[0] Operand 8
     /* 664069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664079 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664095 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664102 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN_RTN),
     /* 664123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664125 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664137 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664149 */     GIR_RootConstrainSelectedInstOperands,
     /* 664150 */     // GIR_Coverage, 6003,
     /* 664150 */     GIR_EraseRootFromParent_Done,
     /* 664151 */   // Label 8553: @664151
     /* 664151 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(664248), // Rule ID 6011 //
     /* 664156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 664160 */     // MIs[0] offset
     /* 664160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664163 */     // MIs[0] auxiliary
     /* 664163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664166 */     // MIs[0] Operand 8
     /* 664166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664176 */     // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 664179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 664183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 664188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 664192 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 664195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 664199 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 664202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 664207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 664217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN),
     /* 664220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664222 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 664227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664234 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664246 */     GIR_RootConstrainSelectedInstOperands,
     /* 664247 */     // GIR_Coverage, 6011,
     /* 664247 */     GIR_EraseRootFromParent_Done,
     /* 664248 */   // Label 8554: @664248
     /* 664248 */   GIM_Reject,
     /* 664249 */ // Label 8538: @664249
     /* 664249 */ GIM_Reject,
     /* 664250 */ // Label 8536: @664250
     /* 664250 */ GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(665431),
     /* 664255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 664258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 664261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 664264 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 664267 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 664270 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(664338), // Rule ID 6204 //
     /* 664275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664278 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664288 */     // MIs[0] offset
     /* 664288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664291 */     // MIs[0] auxiliary
     /* 664291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664294 */     // MIs[0] Operand 8
     /* 664294 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664312 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
     /* 664315 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664324 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664336 */     GIR_RootConstrainSelectedInstOperands,
     /* 664337 */     // GIR_Coverage, 6204,
     /* 664337 */     GIR_EraseRootFromParent_Done,
     /* 664338 */   // Label 8556: @664338
     /* 664338 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(664403), // Rule ID 6212 //
     /* 664343 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664353 */     // MIs[0] offset
     /* 664353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664356 */     // MIs[0] auxiliary
     /* 664356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664359 */     // MIs[0] Operand 8
     /* 664359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664377 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
     /* 664380 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664389 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664401 */     GIR_RootConstrainSelectedInstOperands,
     /* 664402 */     // GIR_Coverage, 6212,
     /* 664402 */     GIR_EraseRootFromParent_Done,
     /* 664403 */   // Label 8557: @664403
     /* 664403 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(664475), // Rule ID 6200 //
     /* 664408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664423 */     // MIs[0] offset
     /* 664423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664426 */     // MIs[0] auxiliary
     /* 664426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664429 */     // MIs[0] Operand 8
     /* 664429 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664447 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
     /* 664450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664452 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664461 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664463 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664473 */     GIR_RootConstrainSelectedInstOperands,
     /* 664474 */     // GIR_Coverage, 6200,
     /* 664474 */     GIR_EraseRootFromParent_Done,
     /* 664475 */   // Label 8558: @664475
     /* 664475 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(664544), // Rule ID 6208 //
     /* 664480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664492 */     // MIs[0] offset
     /* 664492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664495 */     // MIs[0] auxiliary
     /* 664495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664498 */     // MIs[0] Operand 8
     /* 664498 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664516 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
     /* 664519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664521 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664530 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664542 */     GIR_RootConstrainSelectedInstOperands,
     /* 664543 */     // GIR_Coverage, 6208,
     /* 664543 */     GIR_EraseRootFromParent_Done,
     /* 664544 */   // Label 8559: @664544
     /* 664544 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(664610), // Rule ID 6206 //
     /* 664549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664552 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664558 */     // MIs[0] offset
     /* 664558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664561 */     // MIs[0] auxiliary
     /* 664561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664564 */     // MIs[0] Operand 8
     /* 664564 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664582 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN),
     /* 664585 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664587 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664596 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664608 */     GIR_RootConstrainSelectedInstOperands,
     /* 664609 */     // GIR_Coverage, 6206,
     /* 664609 */     GIR_EraseRootFromParent_Done,
     /* 664610 */   // Label 8560: @664610
     /* 664610 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(664673), // Rule ID 6214 //
     /* 664615 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664621 */     // MIs[0] offset
     /* 664621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664624 */     // MIs[0] auxiliary
     /* 664624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664627 */     // MIs[0] Operand 8
     /* 664627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664645 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN),
     /* 664648 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664650 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664659 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664671 */     GIR_RootConstrainSelectedInstOperands,
     /* 664672 */     // GIR_Coverage, 6214,
     /* 664672 */     GIR_EraseRootFromParent_Done,
     /* 664673 */   // Label 8561: @664673
     /* 664673 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(664743), // Rule ID 6202 //
     /* 664678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664689 */     // MIs[0] offset
     /* 664689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664692 */     // MIs[0] auxiliary
     /* 664692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664695 */     // MIs[0] Operand 8
     /* 664695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664713 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN_RTN),
     /* 664716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664718 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664720 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664729 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664741 */     GIR_RootConstrainSelectedInstOperands,
     /* 664742 */     // GIR_Coverage, 6202,
     /* 664742 */     GIR_EraseRootFromParent_Done,
     /* 664743 */   // Label 8562: @664743
     /* 664743 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(664810), // Rule ID 6210 //
     /* 664748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 664756 */     // MIs[0] offset
     /* 664756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664759 */     // MIs[0] auxiliary
     /* 664759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664762 */     // MIs[0] Operand 8
     /* 664762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 664773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664780 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN),
     /* 664783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664785 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664787 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 664789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664796 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664808 */     GIR_RootConstrainSelectedInstOperands,
     /* 664809 */     // GIR_Coverage, 6210,
     /* 664809 */     GIR_EraseRootFromParent_Done,
     /* 664810 */   // Label 8563: @664810
     /* 664810 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(664868), // Rule ID 6205 //
     /* 664815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664818 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664824 */     // MIs[0] offset
     /* 664824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664827 */     // MIs[0] auxiliary
     /* 664827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664830 */     // MIs[0] Operand 8
     /* 664830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664840 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN),
     /* 664843 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664845 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664854 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664866 */     GIR_RootConstrainSelectedInstOperands,
     /* 664867 */     // GIR_Coverage, 6205,
     /* 664867 */     GIR_EraseRootFromParent_Done,
     /* 664868 */   // Label 8564: @664868
     /* 664868 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(664923), // Rule ID 6213 //
     /* 664873 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 664875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664879 */     // MIs[0] offset
     /* 664879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664882 */     // MIs[0] auxiliary
     /* 664882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664885 */     // MIs[0] Operand 8
     /* 664885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664895 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN),
     /* 664898 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664900 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664909 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664911 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 664917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664921 */     GIR_RootConstrainSelectedInstOperands,
     /* 664922 */     // GIR_Coverage, 6213,
     /* 664922 */     GIR_EraseRootFromParent_Done,
     /* 664923 */   // Label 8565: @664923
     /* 664923 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(664985), // Rule ID 6201 //
     /* 664928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 664931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664939 */     // MIs[0] offset
     /* 664939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 664942 */     // MIs[0] auxiliary
     /* 664942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 664945 */     // MIs[0] Operand 8
     /* 664945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 664948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 664955 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 664955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN_RTN),
     /* 664958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 664960 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 664962 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 664964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 664966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 664971 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 664973 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 664979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 664983 */     GIR_RootConstrainSelectedInstOperands,
     /* 664984 */     // GIR_Coverage, 6201,
     /* 664984 */     GIR_EraseRootFromParent_Done,
     /* 664985 */   // Label 8566: @664985
     /* 664985 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(665044), // Rule ID 6209 //
     /* 664990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 664994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 664998 */     // MIs[0] offset
     /* 664998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665001 */     // MIs[0] auxiliary
     /* 665001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665004 */     // MIs[0] Operand 8
     /* 665004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665014 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN),
     /* 665017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665019 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665021 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 665023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665030 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665032 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665042 */     GIR_RootConstrainSelectedInstOperands,
     /* 665043 */     // GIR_Coverage, 6209,
     /* 665043 */     GIR_EraseRootFromParent_Done,
     /* 665044 */   // Label 8567: @665044
     /* 665044 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(665140), // Rule ID 6207 //
     /* 665049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665052 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665054 */     // MIs[0] offset
     /* 665054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665057 */     // MIs[0] auxiliary
     /* 665057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665060 */     // MIs[0] Operand 8
     /* 665060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665070 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665086 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665093 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN),
     /* 665114 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665126 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665128 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665138 */     GIR_RootConstrainSelectedInstOperands,
     /* 665139 */     // GIR_Coverage, 6207,
     /* 665139 */     GIR_EraseRootFromParent_Done,
     /* 665140 */   // Label 8568: @665140
     /* 665140 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(665233), // Rule ID 6215 //
     /* 665145 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665147 */     // MIs[0] offset
     /* 665147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665150 */     // MIs[0] auxiliary
     /* 665150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665153 */     // MIs[0] Operand 8
     /* 665153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665163 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665179 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665186 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN),
     /* 665207 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665219 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665231 */     GIR_RootConstrainSelectedInstOperands,
     /* 665232 */     // GIR_Coverage, 6215,
     /* 665232 */     GIR_EraseRootFromParent_Done,
     /* 665233 */   // Label 8569: @665233
     /* 665233 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(665333), // Rule ID 6203 //
     /* 665238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665245 */     // MIs[0] offset
     /* 665245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665248 */     // MIs[0] auxiliary
     /* 665248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665251 */     // MIs[0] Operand 8
     /* 665251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665261 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665284 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN_RTN),
     /* 665305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665307 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665319 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665331 */     GIR_RootConstrainSelectedInstOperands,
     /* 665332 */     // GIR_Coverage, 6203,
     /* 665332 */     GIR_EraseRootFromParent_Done,
     /* 665333 */   // Label 8570: @665333
     /* 665333 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(665430), // Rule ID 6211 //
     /* 665338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 665342 */     // MIs[0] offset
     /* 665342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665345 */     // MIs[0] auxiliary
     /* 665345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665348 */     // MIs[0] Operand 8
     /* 665348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 665351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665358 */     // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 665361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 665365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 665370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 665374 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 665377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 665381 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 665384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 665389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 665399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN),
     /* 665402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665404 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 665409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665416 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665428 */     GIR_RootConstrainSelectedInstOperands,
     /* 665429 */     // GIR_Coverage, 6211,
     /* 665429 */     GIR_EraseRootFromParent_Done,
     /* 665430 */   // Label 8571: @665430
     /* 665430 */   GIM_Reject,
     /* 665431 */ // Label 8555: @665431
     /* 665431 */ GIM_Reject,
     /* 665432 */ // Label 8537: @665432
     /* 665432 */ GIM_Reject,
     /* 665433 */ // Label 117: @665433
     /* 665433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8574*/ GIMT_Encode4(667816),
     /* 665444 */ /*GILLT_s32*//*Label 8572*/ GIMT_Encode4(665452),
     /* 665448 */ /*GILLT_s64*//*Label 8573*/ GIMT_Encode4(666634),
     /* 665452 */ // Label 8572: @665452
     /* 665452 */ GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(666633),
     /* 665457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 665460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 665463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 665466 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 665469 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 665472 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(665540), // Rule ID 5972 //
     /* 665477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665480 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665490 */     // MIs[0] offset
     /* 665490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665493 */     // MIs[0] auxiliary
     /* 665493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665496 */     // MIs[0] Operand 8
     /* 665496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665514 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
     /* 665517 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665526 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665538 */     GIR_RootConstrainSelectedInstOperands,
     /* 665539 */     // GIR_Coverage, 5972,
     /* 665539 */     GIR_EraseRootFromParent_Done,
     /* 665540 */   // Label 8576: @665540
     /* 665540 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(665605), // Rule ID 5980 //
     /* 665545 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665555 */     // MIs[0] offset
     /* 665555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665558 */     // MIs[0] auxiliary
     /* 665558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665561 */     // MIs[0] Operand 8
     /* 665561 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665579 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
     /* 665582 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665591 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665603 */     GIR_RootConstrainSelectedInstOperands,
     /* 665604 */     // GIR_Coverage, 5980,
     /* 665604 */     GIR_EraseRootFromParent_Done,
     /* 665605 */   // Label 8577: @665605
     /* 665605 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(665677), // Rule ID 5968 //
     /* 665610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 665617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665625 */     // MIs[0] offset
     /* 665625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665628 */     // MIs[0] auxiliary
     /* 665628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665631 */     // MIs[0] Operand 8
     /* 665631 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665649 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
     /* 665652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665654 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665663 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665675 */     GIR_RootConstrainSelectedInstOperands,
     /* 665676 */     // GIR_Coverage, 5968,
     /* 665676 */     GIR_EraseRootFromParent_Done,
     /* 665677 */   // Label 8578: @665677
     /* 665677 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(665746), // Rule ID 5976 //
     /* 665682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 665686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 665694 */     // MIs[0] offset
     /* 665694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665697 */     // MIs[0] auxiliary
     /* 665697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665700 */     // MIs[0] Operand 8
     /* 665700 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665718 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
     /* 665721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665723 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665732 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665744 */     GIR_RootConstrainSelectedInstOperands,
     /* 665745 */     // GIR_Coverage, 5976,
     /* 665745 */     GIR_EraseRootFromParent_Done,
     /* 665746 */   // Label 8579: @665746
     /* 665746 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(665812), // Rule ID 5974 //
     /* 665751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665754 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665760 */     // MIs[0] offset
     /* 665760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665763 */     // MIs[0] auxiliary
     /* 665763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665766 */     // MIs[0] Operand 8
     /* 665766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665784 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN),
     /* 665787 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665789 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665798 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665810 */     GIR_RootConstrainSelectedInstOperands,
     /* 665811 */     // GIR_Coverage, 5974,
     /* 665811 */     GIR_EraseRootFromParent_Done,
     /* 665812 */   // Label 8580: @665812
     /* 665812 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(665875), // Rule ID 5982 //
     /* 665817 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 665819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665823 */     // MIs[0] offset
     /* 665823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665826 */     // MIs[0] auxiliary
     /* 665826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665829 */     // MIs[0] Operand 8
     /* 665829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665847 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN),
     /* 665850 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665852 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665861 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665863 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 665869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665873 */     GIR_RootConstrainSelectedInstOperands,
     /* 665874 */     // GIR_Coverage, 5982,
     /* 665874 */     GIR_EraseRootFromParent_Done,
     /* 665875 */   // Label 8581: @665875
     /* 665875 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(665945), // Rule ID 5970 //
     /* 665880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 665883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 665887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665891 */     // MIs[0] offset
     /* 665891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665894 */     // MIs[0] auxiliary
     /* 665894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665897 */     // MIs[0] Operand 8
     /* 665897 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665915 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN_RTN),
     /* 665918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665920 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665922 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665931 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 665933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 665939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 665943 */     GIR_RootConstrainSelectedInstOperands,
     /* 665944 */     // GIR_Coverage, 5970,
     /* 665944 */     GIR_EraseRootFromParent_Done,
     /* 665945 */   // Label 8582: @665945
     /* 665945 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(666012), // Rule ID 5978 //
     /* 665950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 665954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 665958 */     // MIs[0] offset
     /* 665958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 665961 */     // MIs[0] auxiliary
     /* 665961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 665964 */     // MIs[0] Operand 8
     /* 665964 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 665975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 665982 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 665982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN),
     /* 665985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 665987 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 665989 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 665991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 665993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 665998 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666010 */     GIR_RootConstrainSelectedInstOperands,
     /* 666011 */     // GIR_Coverage, 5978,
     /* 666011 */     GIR_EraseRootFromParent_Done,
     /* 666012 */   // Label 8583: @666012
     /* 666012 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(666070), // Rule ID 5973 //
     /* 666017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666020 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666026 */     // MIs[0] offset
     /* 666026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666029 */     // MIs[0] auxiliary
     /* 666029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666032 */     // MIs[0] Operand 8
     /* 666032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666042 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN),
     /* 666045 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666047 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666056 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666068 */     GIR_RootConstrainSelectedInstOperands,
     /* 666069 */     // GIR_Coverage, 5973,
     /* 666069 */     GIR_EraseRootFromParent_Done,
     /* 666070 */   // Label 8584: @666070
     /* 666070 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(666125), // Rule ID 5981 //
     /* 666075 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666081 */     // MIs[0] offset
     /* 666081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666084 */     // MIs[0] auxiliary
     /* 666084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666087 */     // MIs[0] Operand 8
     /* 666087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666097 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN),
     /* 666100 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666102 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666111 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666123 */     GIR_RootConstrainSelectedInstOperands,
     /* 666124 */     // GIR_Coverage, 5981,
     /* 666124 */     GIR_EraseRootFromParent_Done,
     /* 666125 */   // Label 8585: @666125
     /* 666125 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(666187), // Rule ID 5969 //
     /* 666130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666141 */     // MIs[0] offset
     /* 666141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666144 */     // MIs[0] auxiliary
     /* 666144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666147 */     // MIs[0] Operand 8
     /* 666147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666157 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN_RTN),
     /* 666160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666162 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666164 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666173 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666185 */     GIR_RootConstrainSelectedInstOperands,
     /* 666186 */     // GIR_Coverage, 5969,
     /* 666186 */     GIR_EraseRootFromParent_Done,
     /* 666187 */   // Label 8586: @666187
     /* 666187 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(666246), // Rule ID 5977 //
     /* 666192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666200 */     // MIs[0] offset
     /* 666200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666203 */     // MIs[0] auxiliary
     /* 666203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666206 */     // MIs[0] Operand 8
     /* 666206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666216 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN),
     /* 666219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666221 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666223 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 666225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666232 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666234 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666244 */     GIR_RootConstrainSelectedInstOperands,
     /* 666245 */     // GIR_Coverage, 5977,
     /* 666245 */     GIR_EraseRootFromParent_Done,
     /* 666246 */   // Label 8587: @666246
     /* 666246 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(666342), // Rule ID 5975 //
     /* 666251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666254 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666256 */     // MIs[0] offset
     /* 666256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666259 */     // MIs[0] auxiliary
     /* 666259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666262 */     // MIs[0] Operand 8
     /* 666262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666272 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666288 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666291 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666295 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN),
     /* 666316 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666328 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666340 */     GIR_RootConstrainSelectedInstOperands,
     /* 666341 */     // GIR_Coverage, 5975,
     /* 666341 */     GIR_EraseRootFromParent_Done,
     /* 666342 */   // Label 8588: @666342
     /* 666342 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(666435), // Rule ID 5983 //
     /* 666347 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666349 */     // MIs[0] offset
     /* 666349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666352 */     // MIs[0] auxiliary
     /* 666352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666355 */     // MIs[0] Operand 8
     /* 666355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666365 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666381 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666388 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN),
     /* 666409 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666421 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666433 */     GIR_RootConstrainSelectedInstOperands,
     /* 666434 */     // GIR_Coverage, 5983,
     /* 666434 */     GIR_EraseRootFromParent_Done,
     /* 666435 */   // Label 8589: @666435
     /* 666435 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(666535), // Rule ID 5971 //
     /* 666440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666447 */     // MIs[0] offset
     /* 666447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666450 */     // MIs[0] auxiliary
     /* 666450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666453 */     // MIs[0] Operand 8
     /* 666453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666463 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666479 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666486 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN_RTN),
     /* 666507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666509 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666521 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666523 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666533 */     GIR_RootConstrainSelectedInstOperands,
     /* 666534 */     // GIR_Coverage, 5971,
     /* 666534 */     GIR_EraseRootFromParent_Done,
     /* 666535 */   // Label 8590: @666535
     /* 666535 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(666632), // Rule ID 5979 //
     /* 666540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 666544 */     // MIs[0] offset
     /* 666544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666547 */     // MIs[0] auxiliary
     /* 666547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666550 */     // MIs[0] Operand 8
     /* 666550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 666553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666560 */     // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 666563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 666567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 666572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 666576 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 666579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 666583 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 666586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 666591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 666601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN),
     /* 666604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666606 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 666611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666618 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666630 */     GIR_RootConstrainSelectedInstOperands,
     /* 666631 */     // GIR_Coverage, 5979,
     /* 666631 */     GIR_EraseRootFromParent_Done,
     /* 666632 */   // Label 8591: @666632
     /* 666632 */   GIM_Reject,
     /* 666633 */ // Label 8575: @666633
     /* 666633 */ GIM_Reject,
     /* 666634 */ // Label 8573: @666634
     /* 666634 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(667815),
     /* 666639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 666642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 666645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 666648 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 666651 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 666654 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(666722), // Rule ID 6172 //
     /* 666659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666662 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666672 */     // MIs[0] offset
     /* 666672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666675 */     // MIs[0] auxiliary
     /* 666675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666678 */     // MIs[0] Operand 8
     /* 666678 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666696 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
     /* 666699 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666708 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666720 */     GIR_RootConstrainSelectedInstOperands,
     /* 666721 */     // GIR_Coverage, 6172,
     /* 666721 */     GIR_EraseRootFromParent_Done,
     /* 666722 */   // Label 8593: @666722
     /* 666722 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(666787), // Rule ID 6180 //
     /* 666727 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666737 */     // MIs[0] offset
     /* 666737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666740 */     // MIs[0] auxiliary
     /* 666740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666743 */     // MIs[0] Operand 8
     /* 666743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666761 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
     /* 666764 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666773 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666775 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666785 */     GIR_RootConstrainSelectedInstOperands,
     /* 666786 */     // GIR_Coverage, 6180,
     /* 666786 */     GIR_EraseRootFromParent_Done,
     /* 666787 */   // Label 8594: @666787
     /* 666787 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(666859), // Rule ID 6168 //
     /* 666792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 666799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666807 */     // MIs[0] offset
     /* 666807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666810 */     // MIs[0] auxiliary
     /* 666810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666813 */     // MIs[0] Operand 8
     /* 666813 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666831 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
     /* 666834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666836 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666845 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666857 */     GIR_RootConstrainSelectedInstOperands,
     /* 666858 */     // GIR_Coverage, 6168,
     /* 666858 */     GIR_EraseRootFromParent_Done,
     /* 666859 */   // Label 8595: @666859
     /* 666859 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(666928), // Rule ID 6176 //
     /* 666864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 666868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 666876 */     // MIs[0] offset
     /* 666876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666879 */     // MIs[0] auxiliary
     /* 666879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666882 */     // MIs[0] Operand 8
     /* 666882 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666900 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
     /* 666903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 666905 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666914 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 666922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666926 */     GIR_RootConstrainSelectedInstOperands,
     /* 666927 */     // GIR_Coverage, 6176,
     /* 666927 */     GIR_EraseRootFromParent_Done,
     /* 666928 */   // Label 8596: @666928
     /* 666928 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(666994), // Rule ID 6174 //
     /* 666933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 666936 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 666938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 666942 */     // MIs[0] offset
     /* 666942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 666945 */     // MIs[0] auxiliary
     /* 666945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 666948 */     // MIs[0] Operand 8
     /* 666948 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 666959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 666966 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 666966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN),
     /* 666969 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 666971 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 666973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 666975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 666980 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 666982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 666988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 666992 */     GIR_RootConstrainSelectedInstOperands,
     /* 666993 */     // GIR_Coverage, 6174,
     /* 666993 */     GIR_EraseRootFromParent_Done,
     /* 666994 */   // Label 8597: @666994
     /* 666994 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(667057), // Rule ID 6182 //
     /* 666999 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667005 */     // MIs[0] offset
     /* 667005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667008 */     // MIs[0] auxiliary
     /* 667008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667011 */     // MIs[0] Operand 8
     /* 667011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667029 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN),
     /* 667032 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667034 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667043 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667055 */     GIR_RootConstrainSelectedInstOperands,
     /* 667056 */     // GIR_Coverage, 6182,
     /* 667056 */     GIR_EraseRootFromParent_Done,
     /* 667057 */   // Label 8598: @667057
     /* 667057 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(667127), // Rule ID 6170 //
     /* 667062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667073 */     // MIs[0] offset
     /* 667073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667076 */     // MIs[0] auxiliary
     /* 667076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667079 */     // MIs[0] Operand 8
     /* 667079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667097 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN_RTN),
     /* 667100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667102 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667104 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667113 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667125 */     GIR_RootConstrainSelectedInstOperands,
     /* 667126 */     // GIR_Coverage, 6170,
     /* 667126 */     GIR_EraseRootFromParent_Done,
     /* 667127 */   // Label 8599: @667127
     /* 667127 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(667194), // Rule ID 6178 //
     /* 667132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667140 */     // MIs[0] offset
     /* 667140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667143 */     // MIs[0] auxiliary
     /* 667143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667146 */     // MIs[0] Operand 8
     /* 667146 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667164 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN),
     /* 667167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667169 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667171 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 667173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667180 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667192 */     GIR_RootConstrainSelectedInstOperands,
     /* 667193 */     // GIR_Coverage, 6178,
     /* 667193 */     GIR_EraseRootFromParent_Done,
     /* 667194 */   // Label 8600: @667194
     /* 667194 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(667252), // Rule ID 6173 //
     /* 667199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667202 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667208 */     // MIs[0] offset
     /* 667208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667211 */     // MIs[0] auxiliary
     /* 667211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667214 */     // MIs[0] Operand 8
     /* 667214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667224 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN),
     /* 667227 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667229 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667238 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667240 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667250 */     GIR_RootConstrainSelectedInstOperands,
     /* 667251 */     // GIR_Coverage, 6173,
     /* 667251 */     GIR_EraseRootFromParent_Done,
     /* 667252 */   // Label 8601: @667252
     /* 667252 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(667307), // Rule ID 6181 //
     /* 667257 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667263 */     // MIs[0] offset
     /* 667263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667266 */     // MIs[0] auxiliary
     /* 667266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667269 */     // MIs[0] Operand 8
     /* 667269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667279 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN),
     /* 667282 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667284 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667293 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667295 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667305 */     GIR_RootConstrainSelectedInstOperands,
     /* 667306 */     // GIR_Coverage, 6181,
     /* 667306 */     GIR_EraseRootFromParent_Done,
     /* 667307 */   // Label 8602: @667307
     /* 667307 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(667369), // Rule ID 6169 //
     /* 667312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667323 */     // MIs[0] offset
     /* 667323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667326 */     // MIs[0] auxiliary
     /* 667326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667329 */     // MIs[0] Operand 8
     /* 667329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667339 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN_RTN),
     /* 667342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667344 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667346 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667355 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667367 */     GIR_RootConstrainSelectedInstOperands,
     /* 667368 */     // GIR_Coverage, 6169,
     /* 667368 */     GIR_EraseRootFromParent_Done,
     /* 667369 */   // Label 8603: @667369
     /* 667369 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(667428), // Rule ID 6177 //
     /* 667374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667382 */     // MIs[0] offset
     /* 667382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667385 */     // MIs[0] auxiliary
     /* 667385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667388 */     // MIs[0] Operand 8
     /* 667388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667398 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN),
     /* 667401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667403 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667405 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 667407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667414 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667426 */     GIR_RootConstrainSelectedInstOperands,
     /* 667427 */     // GIR_Coverage, 6177,
     /* 667427 */     GIR_EraseRootFromParent_Done,
     /* 667428 */   // Label 8604: @667428
     /* 667428 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(667524), // Rule ID 6175 //
     /* 667433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667436 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667438 */     // MIs[0] offset
     /* 667438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667441 */     // MIs[0] auxiliary
     /* 667441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667444 */     // MIs[0] Operand 8
     /* 667444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667454 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667470 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667477 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN),
     /* 667498 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667510 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667522 */     GIR_RootConstrainSelectedInstOperands,
     /* 667523 */     // GIR_Coverage, 6175,
     /* 667523 */     GIR_EraseRootFromParent_Done,
     /* 667524 */   // Label 8605: @667524
     /* 667524 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(667617), // Rule ID 6183 //
     /* 667529 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667531 */     // MIs[0] offset
     /* 667531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667534 */     // MIs[0] auxiliary
     /* 667534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667537 */     // MIs[0] Operand 8
     /* 667537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667547 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667563 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN),
     /* 667591 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667603 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667615 */     GIR_RootConstrainSelectedInstOperands,
     /* 667616 */     // GIR_Coverage, 6183,
     /* 667616 */     GIR_EraseRootFromParent_Done,
     /* 667617 */   // Label 8606: @667617
     /* 667617 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(667717), // Rule ID 6171 //
     /* 667622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667629 */     // MIs[0] offset
     /* 667629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667632 */     // MIs[0] auxiliary
     /* 667632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667635 */     // MIs[0] Operand 8
     /* 667635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667645 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667661 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667668 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN_RTN),
     /* 667689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667691 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667703 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667715 */     GIR_RootConstrainSelectedInstOperands,
     /* 667716 */     // GIR_Coverage, 6171,
     /* 667716 */     GIR_EraseRootFromParent_Done,
     /* 667717 */   // Label 8607: @667717
     /* 667717 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(667814), // Rule ID 6179 //
     /* 667722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 667726 */     // MIs[0] offset
     /* 667726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667729 */     // MIs[0] auxiliary
     /* 667729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667732 */     // MIs[0] Operand 8
     /* 667732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 667735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667742 */     // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 667745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 667749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 667754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 667758 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 667761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 667765 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 667768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 667773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 667783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN),
     /* 667786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 667788 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 667793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667800 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 667808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667812 */     GIR_RootConstrainSelectedInstOperands,
     /* 667813 */     // GIR_Coverage, 6179,
     /* 667813 */     GIR_EraseRootFromParent_Done,
     /* 667814 */   // Label 8608: @667814
     /* 667814 */   GIM_Reject,
     /* 667815 */ // Label 8592: @667815
     /* 667815 */ GIM_Reject,
     /* 667816 */ // Label 8574: @667816
     /* 667816 */ GIM_Reject,
     /* 667817 */ // Label 118: @667817
     /* 667817 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8611*/ GIMT_Encode4(670200),
     /* 667828 */ /*GILLT_s32*//*Label 8609*/ GIMT_Encode4(667836),
     /* 667832 */ /*GILLT_s64*//*Label 8610*/ GIMT_Encode4(669018),
     /* 667836 */ // Label 8609: @667836
     /* 667836 */ GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(669017),
     /* 667841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 667844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 667847 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 667850 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 667853 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 667856 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(667924), // Rule ID 5924 //
     /* 667861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667864 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667874 */     // MIs[0] offset
     /* 667874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667877 */     // MIs[0] auxiliary
     /* 667877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667880 */     // MIs[0] Operand 8
     /* 667880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667898 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
     /* 667901 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667910 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667922 */     GIR_RootConstrainSelectedInstOperands,
     /* 667923 */     // GIR_Coverage, 5924,
     /* 667923 */     GIR_EraseRootFromParent_Done,
     /* 667924 */   // Label 8613: @667924
     /* 667924 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(667989), // Rule ID 5932 //
     /* 667929 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 667931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 667935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 667939 */     // MIs[0] offset
     /* 667939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 667942 */     // MIs[0] auxiliary
     /* 667942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 667945 */     // MIs[0] Operand 8
     /* 667945 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 667956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 667963 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 667963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
     /* 667966 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 667968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 667970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 667975 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 667977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 667983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 667987 */     GIR_RootConstrainSelectedInstOperands,
     /* 667988 */     // GIR_Coverage, 5932,
     /* 667988 */     GIR_EraseRootFromParent_Done,
     /* 667989 */   // Label 8614: @667989
     /* 667989 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(668061), // Rule ID 5920 //
     /* 667994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 667997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668009 */     // MIs[0] offset
     /* 668009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668012 */     // MIs[0] auxiliary
     /* 668012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668015 */     // MIs[0] Operand 8
     /* 668015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668033 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
     /* 668036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668038 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668047 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668059 */     GIR_RootConstrainSelectedInstOperands,
     /* 668060 */     // GIR_Coverage, 5920,
     /* 668060 */     GIR_EraseRootFromParent_Done,
     /* 668061 */   // Label 8615: @668061
     /* 668061 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(668130), // Rule ID 5928 //
     /* 668066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668078 */     // MIs[0] offset
     /* 668078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668081 */     // MIs[0] auxiliary
     /* 668081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668084 */     // MIs[0] Operand 8
     /* 668084 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668102 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
     /* 668105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668107 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668116 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668118 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668128 */     GIR_RootConstrainSelectedInstOperands,
     /* 668129 */     // GIR_Coverage, 5928,
     /* 668129 */     GIR_EraseRootFromParent_Done,
     /* 668130 */   // Label 8616: @668130
     /* 668130 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(668196), // Rule ID 5926 //
     /* 668135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668138 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668144 */     // MIs[0] offset
     /* 668144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668147 */     // MIs[0] auxiliary
     /* 668147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668150 */     // MIs[0] Operand 8
     /* 668150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668168 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN),
     /* 668171 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668173 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668182 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668194 */     GIR_RootConstrainSelectedInstOperands,
     /* 668195 */     // GIR_Coverage, 5926,
     /* 668195 */     GIR_EraseRootFromParent_Done,
     /* 668196 */   // Label 8617: @668196
     /* 668196 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(668259), // Rule ID 5934 //
     /* 668201 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668207 */     // MIs[0] offset
     /* 668207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668210 */     // MIs[0] auxiliary
     /* 668210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668213 */     // MIs[0] Operand 8
     /* 668213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668231 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN),
     /* 668234 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668236 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668245 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668257 */     GIR_RootConstrainSelectedInstOperands,
     /* 668258 */     // GIR_Coverage, 5934,
     /* 668258 */     GIR_EraseRootFromParent_Done,
     /* 668259 */   // Label 8618: @668259
     /* 668259 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(668329), // Rule ID 5922 //
     /* 668264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668275 */     // MIs[0] offset
     /* 668275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668278 */     // MIs[0] auxiliary
     /* 668278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668281 */     // MIs[0] Operand 8
     /* 668281 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668299 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN_RTN),
     /* 668302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668304 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668306 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668315 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668317 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668327 */     GIR_RootConstrainSelectedInstOperands,
     /* 668328 */     // GIR_Coverage, 5922,
     /* 668328 */     GIR_EraseRootFromParent_Done,
     /* 668329 */   // Label 8619: @668329
     /* 668329 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(668396), // Rule ID 5930 //
     /* 668334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 668342 */     // MIs[0] offset
     /* 668342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668345 */     // MIs[0] auxiliary
     /* 668345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668348 */     // MIs[0] Operand 8
     /* 668348 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 668359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668366 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN),
     /* 668369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668371 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668373 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 668375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668382 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668394 */     GIR_RootConstrainSelectedInstOperands,
     /* 668395 */     // GIR_Coverage, 5930,
     /* 668395 */     GIR_EraseRootFromParent_Done,
     /* 668396 */   // Label 8620: @668396
     /* 668396 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(668454), // Rule ID 5925 //
     /* 668401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668404 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668410 */     // MIs[0] offset
     /* 668410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668413 */     // MIs[0] auxiliary
     /* 668413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668416 */     // MIs[0] Operand 8
     /* 668416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668426 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN),
     /* 668429 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668431 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668440 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668452 */     GIR_RootConstrainSelectedInstOperands,
     /* 668453 */     // GIR_Coverage, 5925,
     /* 668453 */     GIR_EraseRootFromParent_Done,
     /* 668454 */   // Label 8621: @668454
     /* 668454 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(668509), // Rule ID 5933 //
     /* 668459 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668465 */     // MIs[0] offset
     /* 668465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668468 */     // MIs[0] auxiliary
     /* 668468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668471 */     // MIs[0] Operand 8
     /* 668471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668481 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN),
     /* 668484 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668486 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668495 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668497 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668507 */     GIR_RootConstrainSelectedInstOperands,
     /* 668508 */     // GIR_Coverage, 5933,
     /* 668508 */     GIR_EraseRootFromParent_Done,
     /* 668509 */   // Label 8622: @668509
     /* 668509 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(668571), // Rule ID 5921 //
     /* 668514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668525 */     // MIs[0] offset
     /* 668525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668528 */     // MIs[0] auxiliary
     /* 668528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668531 */     // MIs[0] Operand 8
     /* 668531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668541 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN_RTN),
     /* 668544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668546 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668548 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668557 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668559 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668569 */     GIR_RootConstrainSelectedInstOperands,
     /* 668570 */     // GIR_Coverage, 5921,
     /* 668570 */     GIR_EraseRootFromParent_Done,
     /* 668571 */   // Label 8623: @668571
     /* 668571 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(668630), // Rule ID 5929 //
     /* 668576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 668584 */     // MIs[0] offset
     /* 668584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668587 */     // MIs[0] auxiliary
     /* 668587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668590 */     // MIs[0] Operand 8
     /* 668590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668600 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN),
     /* 668603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668605 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668607 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 668609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668616 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668628 */     GIR_RootConstrainSelectedInstOperands,
     /* 668629 */     // GIR_Coverage, 5929,
     /* 668629 */     GIR_EraseRootFromParent_Done,
     /* 668630 */   // Label 8624: @668630
     /* 668630 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(668726), // Rule ID 5927 //
     /* 668635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668638 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668640 */     // MIs[0] offset
     /* 668640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668643 */     // MIs[0] auxiliary
     /* 668643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668646 */     // MIs[0] Operand 8
     /* 668646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668656 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668672 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668679 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN),
     /* 668700 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668712 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668714 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668724 */     GIR_RootConstrainSelectedInstOperands,
     /* 668725 */     // GIR_Coverage, 5927,
     /* 668725 */     GIR_EraseRootFromParent_Done,
     /* 668726 */   // Label 8625: @668726
     /* 668726 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(668819), // Rule ID 5935 //
     /* 668731 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 668733 */     // MIs[0] offset
     /* 668733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668736 */     // MIs[0] auxiliary
     /* 668736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668739 */     // MIs[0] Operand 8
     /* 668739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668749 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668765 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668772 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN),
     /* 668793 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668805 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 668813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668817 */     GIR_RootConstrainSelectedInstOperands,
     /* 668818 */     // GIR_Coverage, 5935,
     /* 668818 */     GIR_EraseRootFromParent_Done,
     /* 668819 */   // Label 8626: @668819
     /* 668819 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(668919), // Rule ID 5923 //
     /* 668824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 668827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668831 */     // MIs[0] offset
     /* 668831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668834 */     // MIs[0] auxiliary
     /* 668834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668837 */     // MIs[0] Operand 8
     /* 668837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668847 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668863 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668870 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN_RTN),
     /* 668891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668893 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 668905 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 668907 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 668913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 668917 */     GIR_RootConstrainSelectedInstOperands,
     /* 668918 */     // GIR_Coverage, 5923,
     /* 668918 */     GIR_EraseRootFromParent_Done,
     /* 668919 */   // Label 8627: @668919
     /* 668919 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(669016), // Rule ID 5931 //
     /* 668924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 668928 */     // MIs[0] offset
     /* 668928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 668931 */     // MIs[0] auxiliary
     /* 668931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 668934 */     // MIs[0] Operand 8
     /* 668934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 668937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 668944 */     // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 668944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 668947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 668951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 668956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 668960 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 668963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 668967 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 668970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 668975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 668985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN),
     /* 668988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 668990 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 668992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 668995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 668997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669002 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669014 */     GIR_RootConstrainSelectedInstOperands,
     /* 669015 */     // GIR_Coverage, 5931,
     /* 669015 */     GIR_EraseRootFromParent_Done,
     /* 669016 */   // Label 8628: @669016
     /* 669016 */   GIM_Reject,
     /* 669017 */ // Label 8612: @669017
     /* 669017 */ GIM_Reject,
     /* 669018 */ // Label 8610: @669018
     /* 669018 */ GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(670199),
     /* 669023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 669026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 669029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 669032 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 669035 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 669038 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(669106), // Rule ID 6124 //
     /* 669043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669046 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669056 */     // MIs[0] offset
     /* 669056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669059 */     // MIs[0] auxiliary
     /* 669059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669062 */     // MIs[0] Operand 8
     /* 669062 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669080 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
     /* 669083 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669092 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669104 */     GIR_RootConstrainSelectedInstOperands,
     /* 669105 */     // GIR_Coverage, 6124,
     /* 669105 */     GIR_EraseRootFromParent_Done,
     /* 669106 */   // Label 8630: @669106
     /* 669106 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(669171), // Rule ID 6132 //
     /* 669111 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669121 */     // MIs[0] offset
     /* 669121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669124 */     // MIs[0] auxiliary
     /* 669124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669127 */     // MIs[0] Operand 8
     /* 669127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669145 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
     /* 669148 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669157 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669159 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669169 */     GIR_RootConstrainSelectedInstOperands,
     /* 669170 */     // GIR_Coverage, 6132,
     /* 669170 */     GIR_EraseRootFromParent_Done,
     /* 669171 */   // Label 8631: @669171
     /* 669171 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(669243), // Rule ID 6120 //
     /* 669176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669191 */     // MIs[0] offset
     /* 669191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669194 */     // MIs[0] auxiliary
     /* 669194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669197 */     // MIs[0] Operand 8
     /* 669197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669215 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
     /* 669218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669220 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669229 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669241 */     GIR_RootConstrainSelectedInstOperands,
     /* 669242 */     // GIR_Coverage, 6120,
     /* 669242 */     GIR_EraseRootFromParent_Done,
     /* 669243 */   // Label 8632: @669243
     /* 669243 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(669312), // Rule ID 6128 //
     /* 669248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669260 */     // MIs[0] offset
     /* 669260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669263 */     // MIs[0] auxiliary
     /* 669263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669266 */     // MIs[0] Operand 8
     /* 669266 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669284 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
     /* 669287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669289 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669298 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669310 */     GIR_RootConstrainSelectedInstOperands,
     /* 669311 */     // GIR_Coverage, 6128,
     /* 669311 */     GIR_EraseRootFromParent_Done,
     /* 669312 */   // Label 8633: @669312
     /* 669312 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(669378), // Rule ID 6126 //
     /* 669317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669320 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669326 */     // MIs[0] offset
     /* 669326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669329 */     // MIs[0] auxiliary
     /* 669329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669332 */     // MIs[0] Operand 8
     /* 669332 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669350 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN),
     /* 669353 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669355 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669364 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669366 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669376 */     GIR_RootConstrainSelectedInstOperands,
     /* 669377 */     // GIR_Coverage, 6126,
     /* 669377 */     GIR_EraseRootFromParent_Done,
     /* 669378 */   // Label 8634: @669378
     /* 669378 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(669441), // Rule ID 6134 //
     /* 669383 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669389 */     // MIs[0] offset
     /* 669389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669392 */     // MIs[0] auxiliary
     /* 669392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669395 */     // MIs[0] Operand 8
     /* 669395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669413 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN),
     /* 669416 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669418 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669427 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669439 */     GIR_RootConstrainSelectedInstOperands,
     /* 669440 */     // GIR_Coverage, 6134,
     /* 669440 */     GIR_EraseRootFromParent_Done,
     /* 669441 */   // Label 8635: @669441
     /* 669441 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(669511), // Rule ID 6122 //
     /* 669446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669457 */     // MIs[0] offset
     /* 669457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669460 */     // MIs[0] auxiliary
     /* 669460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669463 */     // MIs[0] Operand 8
     /* 669463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669481 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN),
     /* 669484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669486 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669488 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669497 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669499 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669509 */     GIR_RootConstrainSelectedInstOperands,
     /* 669510 */     // GIR_Coverage, 6122,
     /* 669510 */     GIR_EraseRootFromParent_Done,
     /* 669511 */   // Label 8636: @669511
     /* 669511 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(669578), // Rule ID 6130 //
     /* 669516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 669524 */     // MIs[0] offset
     /* 669524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669527 */     // MIs[0] auxiliary
     /* 669527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669530 */     // MIs[0] Operand 8
     /* 669530 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 669541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669548 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN),
     /* 669551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669553 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669555 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 669557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669564 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669576 */     GIR_RootConstrainSelectedInstOperands,
     /* 669577 */     // GIR_Coverage, 6130,
     /* 669577 */     GIR_EraseRootFromParent_Done,
     /* 669578 */   // Label 8637: @669578
     /* 669578 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(669636), // Rule ID 6125 //
     /* 669583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669586 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669592 */     // MIs[0] offset
     /* 669592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669595 */     // MIs[0] auxiliary
     /* 669595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669598 */     // MIs[0] Operand 8
     /* 669598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669608 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN),
     /* 669611 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669613 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669622 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669634 */     GIR_RootConstrainSelectedInstOperands,
     /* 669635 */     // GIR_Coverage, 6125,
     /* 669635 */     GIR_EraseRootFromParent_Done,
     /* 669636 */   // Label 8638: @669636
     /* 669636 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(669691), // Rule ID 6133 //
     /* 669641 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669647 */     // MIs[0] offset
     /* 669647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669650 */     // MIs[0] auxiliary
     /* 669650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669653 */     // MIs[0] Operand 8
     /* 669653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669663 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN),
     /* 669666 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669668 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669677 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669679 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669689 */     GIR_RootConstrainSelectedInstOperands,
     /* 669690 */     // GIR_Coverage, 6133,
     /* 669690 */     GIR_EraseRootFromParent_Done,
     /* 669691 */   // Label 8639: @669691
     /* 669691 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(669753), // Rule ID 6121 //
     /* 669696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669707 */     // MIs[0] offset
     /* 669707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669710 */     // MIs[0] auxiliary
     /* 669710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669713 */     // MIs[0] Operand 8
     /* 669713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669723 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN),
     /* 669726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669728 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669730 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669739 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669751 */     GIR_RootConstrainSelectedInstOperands,
     /* 669752 */     // GIR_Coverage, 6121,
     /* 669752 */     GIR_EraseRootFromParent_Done,
     /* 669753 */   // Label 8640: @669753
     /* 669753 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(669812), // Rule ID 6129 //
     /* 669758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 669762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 669766 */     // MIs[0] offset
     /* 669766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669769 */     // MIs[0] auxiliary
     /* 669769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669772 */     // MIs[0] Operand 8
     /* 669772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669782 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN),
     /* 669785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 669787 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669789 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 669791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669798 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 669806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669810 */     GIR_RootConstrainSelectedInstOperands,
     /* 669811 */     // GIR_Coverage, 6129,
     /* 669811 */     GIR_EraseRootFromParent_Done,
     /* 669812 */   // Label 8641: @669812
     /* 669812 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(669908), // Rule ID 6127 //
     /* 669817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 669820 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669822 */     // MIs[0] offset
     /* 669822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669825 */     // MIs[0] auxiliary
     /* 669825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669828 */     // MIs[0] Operand 8
     /* 669828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669838 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669854 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669861 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN),
     /* 669882 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669894 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669906 */     GIR_RootConstrainSelectedInstOperands,
     /* 669907 */     // GIR_Coverage, 6127,
     /* 669907 */     GIR_EraseRootFromParent_Done,
     /* 669908 */   // Label 8642: @669908
     /* 669908 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(670001), // Rule ID 6135 //
     /* 669913 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 669915 */     // MIs[0] offset
     /* 669915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 669918 */     // MIs[0] auxiliary
     /* 669918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 669921 */     // MIs[0] Operand 8
     /* 669921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 669924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 669931 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 669931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 669934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 669938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 669943 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 669947 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 669950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 669954 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 669957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 669962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 669972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN),
     /* 669975 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 669977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 669980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 669982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 669987 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 669989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 669995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 669999 */     GIR_RootConstrainSelectedInstOperands,
     /* 670000 */     // GIR_Coverage, 6135,
     /* 670000 */     GIR_EraseRootFromParent_Done,
     /* 670001 */   // Label 8643: @670001
     /* 670001 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(670101), // Rule ID 6123 //
     /* 670006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670013 */     // MIs[0] offset
     /* 670013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670016 */     // MIs[0] auxiliary
     /* 670016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670019 */     // MIs[0] Operand 8
     /* 670019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670029 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670045 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670052 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN),
     /* 670073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670075 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670087 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670099 */     GIR_RootConstrainSelectedInstOperands,
     /* 670100 */     // GIR_Coverage, 6123,
     /* 670100 */     GIR_EraseRootFromParent_Done,
     /* 670101 */   // Label 8644: @670101
     /* 670101 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(670198), // Rule ID 6131 //
     /* 670106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 670110 */     // MIs[0] offset
     /* 670110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670113 */     // MIs[0] auxiliary
     /* 670113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670116 */     // MIs[0] Operand 8
     /* 670116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670126 */     // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 670129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 670133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 670138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 670142 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 670145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 670149 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 670152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 670157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 670167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN),
     /* 670170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670172 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 670177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670184 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670186 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670196 */     GIR_RootConstrainSelectedInstOperands,
     /* 670197 */     // GIR_Coverage, 6131,
     /* 670197 */     GIR_EraseRootFromParent_Done,
     /* 670198 */   // Label 8645: @670198
     /* 670198 */   GIM_Reject,
     /* 670199 */ // Label 8629: @670199
     /* 670199 */ GIM_Reject,
     /* 670200 */ // Label 8611: @670200
     /* 670200 */ GIM_Reject,
     /* 670201 */ // Label 119: @670201
     /* 670201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8648*/ GIMT_Encode4(672584),
     /* 670212 */ /*GILLT_s32*//*Label 8646*/ GIMT_Encode4(670220),
     /* 670216 */ /*GILLT_s64*//*Label 8647*/ GIMT_Encode4(671402),
     /* 670220 */ // Label 8646: @670220
     /* 670220 */ GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(671401),
     /* 670225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 670228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 670231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 670234 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 670237 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 670240 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(670308), // Rule ID 5892 //
     /* 670245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670248 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670258 */     // MIs[0] offset
     /* 670258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670261 */     // MIs[0] auxiliary
     /* 670261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670264 */     // MIs[0] Operand 8
     /* 670264 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670282 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
     /* 670285 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670294 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670296 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670306 */     GIR_RootConstrainSelectedInstOperands,
     /* 670307 */     // GIR_Coverage, 5892,
     /* 670307 */     GIR_EraseRootFromParent_Done,
     /* 670308 */   // Label 8650: @670308
     /* 670308 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(670373), // Rule ID 5900 //
     /* 670313 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670323 */     // MIs[0] offset
     /* 670323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670326 */     // MIs[0] auxiliary
     /* 670326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670329 */     // MIs[0] Operand 8
     /* 670329 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670347 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
     /* 670350 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670359 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670361 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670371 */     GIR_RootConstrainSelectedInstOperands,
     /* 670372 */     // GIR_Coverage, 5900,
     /* 670372 */     GIR_EraseRootFromParent_Done,
     /* 670373 */   // Label 8651: @670373
     /* 670373 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(670445), // Rule ID 5888 //
     /* 670378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670393 */     // MIs[0] offset
     /* 670393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670396 */     // MIs[0] auxiliary
     /* 670396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670399 */     // MIs[0] Operand 8
     /* 670399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670417 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
     /* 670420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670422 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670431 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670443 */     GIR_RootConstrainSelectedInstOperands,
     /* 670444 */     // GIR_Coverage, 5888,
     /* 670444 */     GIR_EraseRootFromParent_Done,
     /* 670445 */   // Label 8652: @670445
     /* 670445 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(670514), // Rule ID 5896 //
     /* 670450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670462 */     // MIs[0] offset
     /* 670462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670465 */     // MIs[0] auxiliary
     /* 670465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670468 */     // MIs[0] Operand 8
     /* 670468 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670486 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
     /* 670489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670491 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670500 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670512 */     GIR_RootConstrainSelectedInstOperands,
     /* 670513 */     // GIR_Coverage, 5896,
     /* 670513 */     GIR_EraseRootFromParent_Done,
     /* 670514 */   // Label 8653: @670514
     /* 670514 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(670580), // Rule ID 5894 //
     /* 670519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670522 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670528 */     // MIs[0] offset
     /* 670528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670531 */     // MIs[0] auxiliary
     /* 670531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670534 */     // MIs[0] Operand 8
     /* 670534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670552 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN),
     /* 670555 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670557 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670566 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670578 */     GIR_RootConstrainSelectedInstOperands,
     /* 670579 */     // GIR_Coverage, 5894,
     /* 670579 */     GIR_EraseRootFromParent_Done,
     /* 670580 */   // Label 8654: @670580
     /* 670580 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(670643), // Rule ID 5902 //
     /* 670585 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670591 */     // MIs[0] offset
     /* 670591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670594 */     // MIs[0] auxiliary
     /* 670594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670597 */     // MIs[0] Operand 8
     /* 670597 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670615 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN),
     /* 670618 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670620 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670629 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670631 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670641 */     GIR_RootConstrainSelectedInstOperands,
     /* 670642 */     // GIR_Coverage, 5902,
     /* 670642 */     GIR_EraseRootFromParent_Done,
     /* 670643 */   // Label 8655: @670643
     /* 670643 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(670713), // Rule ID 5890 //
     /* 670648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670659 */     // MIs[0] offset
     /* 670659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670662 */     // MIs[0] auxiliary
     /* 670662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670665 */     // MIs[0] Operand 8
     /* 670665 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670683 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN_RTN),
     /* 670686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670688 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670690 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670699 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670711 */     GIR_RootConstrainSelectedInstOperands,
     /* 670712 */     // GIR_Coverage, 5890,
     /* 670712 */     GIR_EraseRootFromParent_Done,
     /* 670713 */   // Label 8656: @670713
     /* 670713 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(670780), // Rule ID 5898 //
     /* 670718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 670726 */     // MIs[0] offset
     /* 670726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670729 */     // MIs[0] auxiliary
     /* 670729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670732 */     // MIs[0] Operand 8
     /* 670732 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 670743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670750 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN),
     /* 670753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670755 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670757 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 670759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670766 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670778 */     GIR_RootConstrainSelectedInstOperands,
     /* 670779 */     // GIR_Coverage, 5898,
     /* 670779 */     GIR_EraseRootFromParent_Done,
     /* 670780 */   // Label 8657: @670780
     /* 670780 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(670838), // Rule ID 5893 //
     /* 670785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670788 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670794 */     // MIs[0] offset
     /* 670794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670797 */     // MIs[0] auxiliary
     /* 670797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670800 */     // MIs[0] Operand 8
     /* 670800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670810 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN),
     /* 670813 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670815 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670824 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670836 */     GIR_RootConstrainSelectedInstOperands,
     /* 670837 */     // GIR_Coverage, 5893,
     /* 670837 */     GIR_EraseRootFromParent_Done,
     /* 670838 */   // Label 8658: @670838
     /* 670838 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(670893), // Rule ID 5901 //
     /* 670843 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 670845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670849 */     // MIs[0] offset
     /* 670849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670852 */     // MIs[0] auxiliary
     /* 670852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670855 */     // MIs[0] Operand 8
     /* 670855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670865 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN),
     /* 670868 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670870 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670879 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 670887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670891 */     GIR_RootConstrainSelectedInstOperands,
     /* 670892 */     // GIR_Coverage, 5901,
     /* 670892 */     GIR_EraseRootFromParent_Done,
     /* 670893 */   // Label 8659: @670893
     /* 670893 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(670955), // Rule ID 5889 //
     /* 670898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 670901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670909 */     // MIs[0] offset
     /* 670909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670912 */     // MIs[0] auxiliary
     /* 670912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670915 */     // MIs[0] Operand 8
     /* 670915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670925 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN_RTN),
     /* 670928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670930 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670932 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 670941 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 670943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 670949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 670953 */     GIR_RootConstrainSelectedInstOperands,
     /* 670954 */     // GIR_Coverage, 5889,
     /* 670954 */     GIR_EraseRootFromParent_Done,
     /* 670955 */   // Label 8660: @670955
     /* 670955 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(671014), // Rule ID 5897 //
     /* 670960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 670964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 670968 */     // MIs[0] offset
     /* 670968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 670971 */     // MIs[0] auxiliary
     /* 670971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 670974 */     // MIs[0] Operand 8
     /* 670974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 670977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 670984 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 670984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN),
     /* 670987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 670989 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 670991 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 670993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 670995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671000 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671012 */     GIR_RootConstrainSelectedInstOperands,
     /* 671013 */     // GIR_Coverage, 5897,
     /* 671013 */     GIR_EraseRootFromParent_Done,
     /* 671014 */   // Label 8661: @671014
     /* 671014 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(671110), // Rule ID 5895 //
     /* 671019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671022 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671024 */     // MIs[0] offset
     /* 671024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671027 */     // MIs[0] auxiliary
     /* 671027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671030 */     // MIs[0] Operand 8
     /* 671030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671040 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 671043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 671047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 671052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 671056 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 671059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 671063 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 671066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 671071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN),
     /* 671084 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 671089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671096 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671108 */     GIR_RootConstrainSelectedInstOperands,
     /* 671109 */     // GIR_Coverage, 5895,
     /* 671109 */     GIR_EraseRootFromParent_Done,
     /* 671110 */   // Label 8662: @671110
     /* 671110 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(671203), // Rule ID 5903 //
     /* 671115 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671117 */     // MIs[0] offset
     /* 671117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671120 */     // MIs[0] auxiliary
     /* 671120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671123 */     // MIs[0] Operand 8
     /* 671123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671133 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 671136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 671140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 671145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 671149 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 671152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 671156 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 671159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 671164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN),
     /* 671177 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 671182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671189 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671201 */     GIR_RootConstrainSelectedInstOperands,
     /* 671202 */     // GIR_Coverage, 5903,
     /* 671202 */     GIR_EraseRootFromParent_Done,
     /* 671203 */   // Label 8663: @671203
     /* 671203 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(671303), // Rule ID 5891 //
     /* 671208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671215 */     // MIs[0] offset
     /* 671215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671218 */     // MIs[0] auxiliary
     /* 671218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671221 */     // MIs[0] Operand 8
     /* 671221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671231 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 671234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 671238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 671243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 671247 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 671250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 671254 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 671257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 671262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN_RTN),
     /* 671275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671277 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 671282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671289 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671301 */     GIR_RootConstrainSelectedInstOperands,
     /* 671302 */     // GIR_Coverage, 5891,
     /* 671302 */     GIR_EraseRootFromParent_Done,
     /* 671303 */   // Label 8664: @671303
     /* 671303 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(671400), // Rule ID 5899 //
     /* 671308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 671312 */     // MIs[0] offset
     /* 671312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671315 */     // MIs[0] auxiliary
     /* 671315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671318 */     // MIs[0] Operand 8
     /* 671318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671328 */     // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 671331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 671335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 671340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 671344 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 671347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 671351 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 671354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 671359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 671369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN),
     /* 671372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671374 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 671379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671386 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671388 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671398 */     GIR_RootConstrainSelectedInstOperands,
     /* 671399 */     // GIR_Coverage, 5899,
     /* 671399 */     GIR_EraseRootFromParent_Done,
     /* 671400 */   // Label 8665: @671400
     /* 671400 */   GIM_Reject,
     /* 671401 */ // Label 8649: @671401
     /* 671401 */ GIM_Reject,
     /* 671402 */ // Label 8647: @671402
     /* 671402 */ GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(672583),
     /* 671407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 671410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 671413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 671416 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 671419 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 671422 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(671490), // Rule ID 6092 //
     /* 671427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671430 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671440 */     // MIs[0] offset
     /* 671440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671443 */     // MIs[0] auxiliary
     /* 671443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671446 */     // MIs[0] Operand 8
     /* 671446 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671464 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
     /* 671467 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671476 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671488 */     GIR_RootConstrainSelectedInstOperands,
     /* 671489 */     // GIR_Coverage, 6092,
     /* 671489 */     GIR_EraseRootFromParent_Done,
     /* 671490 */   // Label 8667: @671490
     /* 671490 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(671555), // Rule ID 6100 //
     /* 671495 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671505 */     // MIs[0] offset
     /* 671505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671508 */     // MIs[0] auxiliary
     /* 671508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671511 */     // MIs[0] Operand 8
     /* 671511 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671529 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
     /* 671532 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671541 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671553 */     GIR_RootConstrainSelectedInstOperands,
     /* 671554 */     // GIR_Coverage, 6100,
     /* 671554 */     GIR_EraseRootFromParent_Done,
     /* 671555 */   // Label 8668: @671555
     /* 671555 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(671627), // Rule ID 6088 //
     /* 671560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 671567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671575 */     // MIs[0] offset
     /* 671575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671578 */     // MIs[0] auxiliary
     /* 671578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671581 */     // MIs[0] Operand 8
     /* 671581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671599 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
     /* 671602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671604 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671613 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671625 */     GIR_RootConstrainSelectedInstOperands,
     /* 671626 */     // GIR_Coverage, 6088,
     /* 671626 */     GIR_EraseRootFromParent_Done,
     /* 671627 */   // Label 8669: @671627
     /* 671627 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(671696), // Rule ID 6096 //
     /* 671632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 671636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671644 */     // MIs[0] offset
     /* 671644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671647 */     // MIs[0] auxiliary
     /* 671647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671650 */     // MIs[0] Operand 8
     /* 671650 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671668 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
     /* 671671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671673 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671682 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671684 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671694 */     GIR_RootConstrainSelectedInstOperands,
     /* 671695 */     // GIR_Coverage, 6096,
     /* 671695 */     GIR_EraseRootFromParent_Done,
     /* 671696 */   // Label 8670: @671696
     /* 671696 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(671762), // Rule ID 6094 //
     /* 671701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671704 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671710 */     // MIs[0] offset
     /* 671710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671713 */     // MIs[0] auxiliary
     /* 671713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671716 */     // MIs[0] Operand 8
     /* 671716 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671734 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN),
     /* 671737 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671739 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671748 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671760 */     GIR_RootConstrainSelectedInstOperands,
     /* 671761 */     // GIR_Coverage, 6094,
     /* 671761 */     GIR_EraseRootFromParent_Done,
     /* 671762 */   // Label 8671: @671762
     /* 671762 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(671825), // Rule ID 6102 //
     /* 671767 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671773 */     // MIs[0] offset
     /* 671773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671776 */     // MIs[0] auxiliary
     /* 671776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671779 */     // MIs[0] Operand 8
     /* 671779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671797 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN),
     /* 671800 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671802 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671811 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671813 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 671819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671823 */     GIR_RootConstrainSelectedInstOperands,
     /* 671824 */     // GIR_Coverage, 6102,
     /* 671824 */     GIR_EraseRootFromParent_Done,
     /* 671825 */   // Label 8672: @671825
     /* 671825 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(671895), // Rule ID 6090 //
     /* 671830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 671837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671841 */     // MIs[0] offset
     /* 671841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671844 */     // MIs[0] auxiliary
     /* 671844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671847 */     // MIs[0] Operand 8
     /* 671847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671865 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN),
     /* 671868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671870 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671872 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671881 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671893 */     GIR_RootConstrainSelectedInstOperands,
     /* 671894 */     // GIR_Coverage, 6090,
     /* 671894 */     GIR_EraseRootFromParent_Done,
     /* 671895 */   // Label 8673: @671895
     /* 671895 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(671962), // Rule ID 6098 //
     /* 671900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 671904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 671908 */     // MIs[0] offset
     /* 671908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671911 */     // MIs[0] auxiliary
     /* 671911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671914 */     // MIs[0] Operand 8
     /* 671914 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 671925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671932 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN),
     /* 671935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 671937 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671939 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 671941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 671943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 671948 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 671950 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 671956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 671960 */     GIR_RootConstrainSelectedInstOperands,
     /* 671961 */     // GIR_Coverage, 6098,
     /* 671961 */     GIR_EraseRootFromParent_Done,
     /* 671962 */   // Label 8674: @671962
     /* 671962 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(672020), // Rule ID 6093 //
     /* 671967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 671970 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 671972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 671976 */     // MIs[0] offset
     /* 671976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 671979 */     // MIs[0] auxiliary
     /* 671979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 671982 */     // MIs[0] Operand 8
     /* 671982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 671985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 671992 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 671992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN),
     /* 671995 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 671997 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 671999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672006 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672018 */     GIR_RootConstrainSelectedInstOperands,
     /* 672019 */     // GIR_Coverage, 6093,
     /* 672019 */     GIR_EraseRootFromParent_Done,
     /* 672020 */   // Label 8675: @672020
     /* 672020 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(672075), // Rule ID 6101 //
     /* 672025 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672031 */     // MIs[0] offset
     /* 672031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672034 */     // MIs[0] auxiliary
     /* 672034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672037 */     // MIs[0] Operand 8
     /* 672037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672047 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN),
     /* 672050 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672052 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672061 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672073 */     GIR_RootConstrainSelectedInstOperands,
     /* 672074 */     // GIR_Coverage, 6101,
     /* 672074 */     GIR_EraseRootFromParent_Done,
     /* 672075 */   // Label 8676: @672075
     /* 672075 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(672137), // Rule ID 6089 //
     /* 672080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 672087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672091 */     // MIs[0] offset
     /* 672091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672094 */     // MIs[0] auxiliary
     /* 672094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672097 */     // MIs[0] Operand 8
     /* 672097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672107 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN),
     /* 672110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672112 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672114 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672123 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672135 */     GIR_RootConstrainSelectedInstOperands,
     /* 672136 */     // GIR_Coverage, 6089,
     /* 672136 */     GIR_EraseRootFromParent_Done,
     /* 672137 */   // Label 8677: @672137
     /* 672137 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(672196), // Rule ID 6097 //
     /* 672142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 672146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672150 */     // MIs[0] offset
     /* 672150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672153 */     // MIs[0] auxiliary
     /* 672153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672156 */     // MIs[0] Operand 8
     /* 672156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672166 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN),
     /* 672169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672171 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672173 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 672175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672182 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672184 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672194 */     GIR_RootConstrainSelectedInstOperands,
     /* 672195 */     // GIR_Coverage, 6097,
     /* 672195 */     GIR_EraseRootFromParent_Done,
     /* 672196 */   // Label 8678: @672196
     /* 672196 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(672292), // Rule ID 6095 //
     /* 672201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672204 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672206 */     // MIs[0] offset
     /* 672206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672209 */     // MIs[0] auxiliary
     /* 672209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672212 */     // MIs[0] Operand 8
     /* 672212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672222 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672238 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672245 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN),
     /* 672266 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672278 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672290 */     GIR_RootConstrainSelectedInstOperands,
     /* 672291 */     // GIR_Coverage, 6095,
     /* 672291 */     GIR_EraseRootFromParent_Done,
     /* 672292 */   // Label 8679: @672292
     /* 672292 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(672385), // Rule ID 6103 //
     /* 672297 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672299 */     // MIs[0] offset
     /* 672299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672302 */     // MIs[0] auxiliary
     /* 672302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672305 */     // MIs[0] Operand 8
     /* 672305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672315 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672331 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672338 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN),
     /* 672359 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672371 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672383 */     GIR_RootConstrainSelectedInstOperands,
     /* 672384 */     // GIR_Coverage, 6103,
     /* 672384 */     GIR_EraseRootFromParent_Done,
     /* 672385 */   // Label 8680: @672385
     /* 672385 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(672485), // Rule ID 6091 //
     /* 672390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 672397 */     // MIs[0] offset
     /* 672397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672400 */     // MIs[0] auxiliary
     /* 672400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672403 */     // MIs[0] Operand 8
     /* 672403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672413 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672429 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672436 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN),
     /* 672457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672459 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672471 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672483 */     GIR_RootConstrainSelectedInstOperands,
     /* 672484 */     // GIR_Coverage, 6091,
     /* 672484 */     GIR_EraseRootFromParent_Done,
     /* 672485 */   // Label 8681: @672485
     /* 672485 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(672582), // Rule ID 6099 //
     /* 672490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 672494 */     // MIs[0] offset
     /* 672494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672497 */     // MIs[0] auxiliary
     /* 672497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672500 */     // MIs[0] Operand 8
     /* 672500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 672503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672510 */     // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 672513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 672517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 672522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 672526 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 672529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 672533 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 672536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 672541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 672551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN),
     /* 672554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672556 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 672561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672568 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672580 */     GIR_RootConstrainSelectedInstOperands,
     /* 672581 */     // GIR_Coverage, 6099,
     /* 672581 */     GIR_EraseRootFromParent_Done,
     /* 672582 */   // Label 8682: @672582
     /* 672582 */   GIM_Reject,
     /* 672583 */ // Label 8666: @672583
     /* 672583 */ GIM_Reject,
     /* 672584 */ // Label 8648: @672584
     /* 672584 */ GIM_Reject,
     /* 672585 */ // Label 120: @672585
     /* 672585 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8685*/ GIMT_Encode4(674968),
     /* 672596 */ /*GILLT_s32*//*Label 8683*/ GIMT_Encode4(672604),
     /* 672600 */ /*GILLT_s64*//*Label 8684*/ GIMT_Encode4(673786),
     /* 672604 */ // Label 8683: @672604
     /* 672604 */ GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(673785),
     /* 672609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 672612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 672615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 672618 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 672621 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 672624 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(672692), // Rule ID 5876 //
     /* 672629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672632 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 672638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672642 */     // MIs[0] offset
     /* 672642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672645 */     // MIs[0] auxiliary
     /* 672645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672648 */     // MIs[0] Operand 8
     /* 672648 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 672659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672666 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
     /* 672669 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672678 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672690 */     GIR_RootConstrainSelectedInstOperands,
     /* 672691 */     // GIR_Coverage, 5876,
     /* 672691 */     GIR_EraseRootFromParent_Done,
     /* 672692 */   // Label 8687: @672692
     /* 672692 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(672757), // Rule ID 5884 //
     /* 672697 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 672703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672707 */     // MIs[0] offset
     /* 672707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672710 */     // MIs[0] auxiliary
     /* 672710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672713 */     // MIs[0] Operand 8
     /* 672713 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 672724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672731 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
     /* 672734 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672743 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672755 */     GIR_RootConstrainSelectedInstOperands,
     /* 672756 */     // GIR_Coverage, 5884,
     /* 672756 */     GIR_EraseRootFromParent_Done,
     /* 672757 */   // Label 8688: @672757
     /* 672757 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(672829), // Rule ID 5872 //
     /* 672762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 672773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672777 */     // MIs[0] offset
     /* 672777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672780 */     // MIs[0] auxiliary
     /* 672780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672783 */     // MIs[0] Operand 8
     /* 672783 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 672794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672801 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
     /* 672804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672806 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672815 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672827 */     GIR_RootConstrainSelectedInstOperands,
     /* 672828 */     // GIR_Coverage, 5872,
     /* 672828 */     GIR_EraseRootFromParent_Done,
     /* 672829 */   // Label 8689: @672829
     /* 672829 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(672898), // Rule ID 5880 //
     /* 672834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 672838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 672842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 672846 */     // MIs[0] offset
     /* 672846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672849 */     // MIs[0] auxiliary
     /* 672849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672852 */     // MIs[0] Operand 8
     /* 672852 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 672863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672870 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
     /* 672873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 672875 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672884 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 672892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672896 */     GIR_RootConstrainSelectedInstOperands,
     /* 672897 */     // GIR_Coverage, 5880,
     /* 672897 */     GIR_EraseRootFromParent_Done,
     /* 672898 */   // Label 8690: @672898
     /* 672898 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(672964), // Rule ID 5878 //
     /* 672903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 672906 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 672912 */     // MIs[0] offset
     /* 672912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672915 */     // MIs[0] auxiliary
     /* 672915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672918 */     // MIs[0] Operand 8
     /* 672918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 672929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672936 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN),
     /* 672939 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 672941 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 672943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 672945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 672950 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 672952 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 672958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 672962 */     GIR_RootConstrainSelectedInstOperands,
     /* 672963 */     // GIR_Coverage, 5878,
     /* 672963 */     GIR_EraseRootFromParent_Done,
     /* 672964 */   // Label 8691: @672964
     /* 672964 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(673027), // Rule ID 5886 //
     /* 672969 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 672971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 672975 */     // MIs[0] offset
     /* 672975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 672978 */     // MIs[0] auxiliary
     /* 672978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 672981 */     // MIs[0] Operand 8
     /* 672981 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 672992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 672999 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 672999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN),
     /* 673002 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673004 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673013 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673015 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673025 */     GIR_RootConstrainSelectedInstOperands,
     /* 673026 */     // GIR_Coverage, 5886,
     /* 673026 */     GIR_EraseRootFromParent_Done,
     /* 673027 */   // Label 8692: @673027
     /* 673027 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(673097), // Rule ID 5874 //
     /* 673032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673043 */     // MIs[0] offset
     /* 673043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673046 */     // MIs[0] auxiliary
     /* 673046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673049 */     // MIs[0] Operand 8
     /* 673049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673067 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN_RTN),
     /* 673070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673072 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673074 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673083 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673095 */     GIR_RootConstrainSelectedInstOperands,
     /* 673096 */     // GIR_Coverage, 5874,
     /* 673096 */     GIR_EraseRootFromParent_Done,
     /* 673097 */   // Label 8693: @673097
     /* 673097 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(673164), // Rule ID 5882 //
     /* 673102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673110 */     // MIs[0] offset
     /* 673110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673113 */     // MIs[0] auxiliary
     /* 673113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673116 */     // MIs[0] Operand 8
     /* 673116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673134 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN),
     /* 673137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673139 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673141 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 673143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673150 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673162 */     GIR_RootConstrainSelectedInstOperands,
     /* 673163 */     // GIR_Coverage, 5882,
     /* 673163 */     GIR_EraseRootFromParent_Done,
     /* 673164 */   // Label 8694: @673164
     /* 673164 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(673222), // Rule ID 5877 //
     /* 673169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673172 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673178 */     // MIs[0] offset
     /* 673178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673181 */     // MIs[0] auxiliary
     /* 673181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673184 */     // MIs[0] Operand 8
     /* 673184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673194 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN),
     /* 673197 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673199 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673208 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673220 */     GIR_RootConstrainSelectedInstOperands,
     /* 673221 */     // GIR_Coverage, 5877,
     /* 673221 */     GIR_EraseRootFromParent_Done,
     /* 673222 */   // Label 8695: @673222
     /* 673222 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(673277), // Rule ID 5885 //
     /* 673227 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673233 */     // MIs[0] offset
     /* 673233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673236 */     // MIs[0] auxiliary
     /* 673236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673239 */     // MIs[0] Operand 8
     /* 673239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673249 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN),
     /* 673252 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673254 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673263 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673275 */     GIR_RootConstrainSelectedInstOperands,
     /* 673276 */     // GIR_Coverage, 5885,
     /* 673276 */     GIR_EraseRootFromParent_Done,
     /* 673277 */   // Label 8696: @673277
     /* 673277 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(673339), // Rule ID 5873 //
     /* 673282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673293 */     // MIs[0] offset
     /* 673293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673296 */     // MIs[0] auxiliary
     /* 673296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673299 */     // MIs[0] Operand 8
     /* 673299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673309 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN_RTN),
     /* 673312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673314 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673316 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673325 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673337 */     GIR_RootConstrainSelectedInstOperands,
     /* 673338 */     // GIR_Coverage, 5873,
     /* 673338 */     GIR_EraseRootFromParent_Done,
     /* 673339 */   // Label 8697: @673339
     /* 673339 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(673398), // Rule ID 5881 //
     /* 673344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673352 */     // MIs[0] offset
     /* 673352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673355 */     // MIs[0] auxiliary
     /* 673355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673358 */     // MIs[0] Operand 8
     /* 673358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673368 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN),
     /* 673371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673373 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673375 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 673377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673384 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673396 */     GIR_RootConstrainSelectedInstOperands,
     /* 673397 */     // GIR_Coverage, 5881,
     /* 673397 */     GIR_EraseRootFromParent_Done,
     /* 673398 */   // Label 8698: @673398
     /* 673398 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(673494), // Rule ID 5879 //
     /* 673403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673406 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673408 */     // MIs[0] offset
     /* 673408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673411 */     // MIs[0] auxiliary
     /* 673411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673414 */     // MIs[0] Operand 8
     /* 673414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673424 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673440 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673447 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN),
     /* 673468 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673480 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673492 */     GIR_RootConstrainSelectedInstOperands,
     /* 673493 */     // GIR_Coverage, 5879,
     /* 673493 */     GIR_EraseRootFromParent_Done,
     /* 673494 */   // Label 8699: @673494
     /* 673494 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(673587), // Rule ID 5887 //
     /* 673499 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673501 */     // MIs[0] offset
     /* 673501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673504 */     // MIs[0] auxiliary
     /* 673504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673507 */     // MIs[0] Operand 8
     /* 673507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673517 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673533 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673540 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN),
     /* 673561 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673573 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673585 */     GIR_RootConstrainSelectedInstOperands,
     /* 673586 */     // GIR_Coverage, 5887,
     /* 673586 */     GIR_EraseRootFromParent_Done,
     /* 673587 */   // Label 8700: @673587
     /* 673587 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(673687), // Rule ID 5875 //
     /* 673592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673599 */     // MIs[0] offset
     /* 673599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673602 */     // MIs[0] auxiliary
     /* 673602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673605 */     // MIs[0] Operand 8
     /* 673605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673615 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673631 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673638 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN_RTN),
     /* 673659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673661 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673673 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673685 */     GIR_RootConstrainSelectedInstOperands,
     /* 673686 */     // GIR_Coverage, 5875,
     /* 673686 */     GIR_EraseRootFromParent_Done,
     /* 673687 */   // Label 8701: @673687
     /* 673687 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(673784), // Rule ID 5883 //
     /* 673692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 673696 */     // MIs[0] offset
     /* 673696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673699 */     // MIs[0] auxiliary
     /* 673699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673702 */     // MIs[0] Operand 8
     /* 673702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 673705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673712 */     // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 673715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 673719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 673724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 673728 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 673731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 673735 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 673738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 673743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 673753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN),
     /* 673756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673758 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 673763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673770 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673772 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 673778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673782 */     GIR_RootConstrainSelectedInstOperands,
     /* 673783 */     // GIR_Coverage, 5883,
     /* 673783 */     GIR_EraseRootFromParent_Done,
     /* 673784 */   // Label 8702: @673784
     /* 673784 */   GIM_Reject,
     /* 673785 */ // Label 8686: @673785
     /* 673785 */ GIM_Reject,
     /* 673786 */ // Label 8684: @673786
     /* 673786 */ GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(674967),
     /* 673791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 673794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 673797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 673800 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 673803 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 673806 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(673874), // Rule ID 6076 //
     /* 673811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673814 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673824 */     // MIs[0] offset
     /* 673824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673827 */     // MIs[0] auxiliary
     /* 673827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673830 */     // MIs[0] Operand 8
     /* 673830 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673848 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
     /* 673851 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673860 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673872 */     GIR_RootConstrainSelectedInstOperands,
     /* 673873 */     // GIR_Coverage, 6076,
     /* 673873 */     GIR_EraseRootFromParent_Done,
     /* 673874 */   // Label 8704: @673874
     /* 673874 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(673939), // Rule ID 6084 //
     /* 673879 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 673881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673889 */     // MIs[0] offset
     /* 673889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673892 */     // MIs[0] auxiliary
     /* 673892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673895 */     // MIs[0] Operand 8
     /* 673895 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673913 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
     /* 673916 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673925 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 673933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 673937 */     GIR_RootConstrainSelectedInstOperands,
     /* 673938 */     // GIR_Coverage, 6084,
     /* 673938 */     GIR_EraseRootFromParent_Done,
     /* 673939 */   // Label 8705: @673939
     /* 673939 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(674011), // Rule ID 6072 //
     /* 673944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 673947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 673951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 673955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 673959 */     // MIs[0] offset
     /* 673959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 673962 */     // MIs[0] auxiliary
     /* 673962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 673965 */     // MIs[0] Operand 8
     /* 673965 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 673976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 673983 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 673983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
     /* 673986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 673988 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 673990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 673992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 673997 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 673999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674009 */     GIR_RootConstrainSelectedInstOperands,
     /* 674010 */     // GIR_Coverage, 6072,
     /* 674010 */     GIR_EraseRootFromParent_Done,
     /* 674011 */   // Label 8706: @674011
     /* 674011 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(674080), // Rule ID 6080 //
     /* 674016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674028 */     // MIs[0] offset
     /* 674028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674031 */     // MIs[0] auxiliary
     /* 674031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674034 */     // MIs[0] Operand 8
     /* 674034 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674052 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
     /* 674055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674057 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674066 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674068 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674078 */     GIR_RootConstrainSelectedInstOperands,
     /* 674079 */     // GIR_Coverage, 6080,
     /* 674079 */     GIR_EraseRootFromParent_Done,
     /* 674080 */   // Label 8707: @674080
     /* 674080 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(674146), // Rule ID 6078 //
     /* 674085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674088 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674094 */     // MIs[0] offset
     /* 674094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674097 */     // MIs[0] auxiliary
     /* 674097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674100 */     // MIs[0] Operand 8
     /* 674100 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674118 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN),
     /* 674121 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674123 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674132 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674144 */     GIR_RootConstrainSelectedInstOperands,
     /* 674145 */     // GIR_Coverage, 6078,
     /* 674145 */     GIR_EraseRootFromParent_Done,
     /* 674146 */   // Label 8708: @674146
     /* 674146 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(674209), // Rule ID 6086 //
     /* 674151 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674157 */     // MIs[0] offset
     /* 674157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674160 */     // MIs[0] auxiliary
     /* 674160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674163 */     // MIs[0] Operand 8
     /* 674163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674181 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN),
     /* 674184 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674186 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674195 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674197 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674207 */     GIR_RootConstrainSelectedInstOperands,
     /* 674208 */     // GIR_Coverage, 6086,
     /* 674208 */     GIR_EraseRootFromParent_Done,
     /* 674209 */   // Label 8709: @674209
     /* 674209 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(674279), // Rule ID 6074 //
     /* 674214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674225 */     // MIs[0] offset
     /* 674225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674228 */     // MIs[0] auxiliary
     /* 674228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674231 */     // MIs[0] Operand 8
     /* 674231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674249 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN_RTN),
     /* 674252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674254 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674256 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674265 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674277 */     GIR_RootConstrainSelectedInstOperands,
     /* 674278 */     // GIR_Coverage, 6074,
     /* 674278 */     GIR_EraseRootFromParent_Done,
     /* 674279 */   // Label 8710: @674279
     /* 674279 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(674346), // Rule ID 6082 //
     /* 674284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 674292 */     // MIs[0] offset
     /* 674292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674295 */     // MIs[0] auxiliary
     /* 674295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674298 */     // MIs[0] Operand 8
     /* 674298 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 674309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674316 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN),
     /* 674319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674321 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674323 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 674325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674332 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674334 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674344 */     GIR_RootConstrainSelectedInstOperands,
     /* 674345 */     // GIR_Coverage, 6082,
     /* 674345 */     GIR_EraseRootFromParent_Done,
     /* 674346 */   // Label 8711: @674346
     /* 674346 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(674404), // Rule ID 6077 //
     /* 674351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674354 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674360 */     // MIs[0] offset
     /* 674360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674363 */     // MIs[0] auxiliary
     /* 674363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674366 */     // MIs[0] Operand 8
     /* 674366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674376 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN),
     /* 674379 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674381 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674390 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674402 */     GIR_RootConstrainSelectedInstOperands,
     /* 674403 */     // GIR_Coverage, 6077,
     /* 674403 */     GIR_EraseRootFromParent_Done,
     /* 674404 */   // Label 8712: @674404
     /* 674404 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(674459), // Rule ID 6085 //
     /* 674409 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674415 */     // MIs[0] offset
     /* 674415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674418 */     // MIs[0] auxiliary
     /* 674418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674421 */     // MIs[0] Operand 8
     /* 674421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674431 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN),
     /* 674434 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674436 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674445 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674457 */     GIR_RootConstrainSelectedInstOperands,
     /* 674458 */     // GIR_Coverage, 6085,
     /* 674458 */     GIR_EraseRootFromParent_Done,
     /* 674459 */   // Label 8713: @674459
     /* 674459 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(674521), // Rule ID 6073 //
     /* 674464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674475 */     // MIs[0] offset
     /* 674475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674478 */     // MIs[0] auxiliary
     /* 674478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674481 */     // MIs[0] Operand 8
     /* 674481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674491 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN_RTN),
     /* 674494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674496 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674498 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674507 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674519 */     GIR_RootConstrainSelectedInstOperands,
     /* 674520 */     // GIR_Coverage, 6073,
     /* 674520 */     GIR_EraseRootFromParent_Done,
     /* 674521 */   // Label 8714: @674521
     /* 674521 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(674580), // Rule ID 6081 //
     /* 674526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 674534 */     // MIs[0] offset
     /* 674534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674537 */     // MIs[0] auxiliary
     /* 674537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674540 */     // MIs[0] Operand 8
     /* 674540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674550 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN),
     /* 674553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674555 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674557 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 674559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674566 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674578 */     GIR_RootConstrainSelectedInstOperands,
     /* 674579 */     // GIR_Coverage, 6081,
     /* 674579 */     GIR_EraseRootFromParent_Done,
     /* 674580 */   // Label 8715: @674580
     /* 674580 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(674676), // Rule ID 6079 //
     /* 674585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674588 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674590 */     // MIs[0] offset
     /* 674590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674593 */     // MIs[0] auxiliary
     /* 674593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674596 */     // MIs[0] Operand 8
     /* 674596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674606 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674622 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674629 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN),
     /* 674650 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674662 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674674 */     GIR_RootConstrainSelectedInstOperands,
     /* 674675 */     // GIR_Coverage, 6079,
     /* 674675 */     GIR_EraseRootFromParent_Done,
     /* 674676 */   // Label 8716: @674676
     /* 674676 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(674769), // Rule ID 6087 //
     /* 674681 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 674683 */     // MIs[0] offset
     /* 674683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674686 */     // MIs[0] auxiliary
     /* 674686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674689 */     // MIs[0] Operand 8
     /* 674689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674699 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674715 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674722 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN),
     /* 674743 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674755 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674757 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 674763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674767 */     GIR_RootConstrainSelectedInstOperands,
     /* 674768 */     // GIR_Coverage, 6087,
     /* 674768 */     GIR_EraseRootFromParent_Done,
     /* 674769 */   // Label 8717: @674769
     /* 674769 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(674869), // Rule ID 6075 //
     /* 674774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 674777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674781 */     // MIs[0] offset
     /* 674781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674784 */     // MIs[0] auxiliary
     /* 674784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674787 */     // MIs[0] Operand 8
     /* 674787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674797 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674813 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674820 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN),
     /* 674841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674843 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674855 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674867 */     GIR_RootConstrainSelectedInstOperands,
     /* 674868 */     // GIR_Coverage, 6075,
     /* 674868 */     GIR_EraseRootFromParent_Done,
     /* 674869 */   // Label 8718: @674869
     /* 674869 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(674966), // Rule ID 6083 //
     /* 674874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 674878 */     // MIs[0] offset
     /* 674878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 674881 */     // MIs[0] auxiliary
     /* 674881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 674884 */     // MIs[0] Operand 8
     /* 674884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 674887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 674894 */     // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 674894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 674897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 674901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 674906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 674910 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 674913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 674917 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 674920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 674925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 674935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN),
     /* 674938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 674940 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 674942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 674945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 674947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 674952 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 674954 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 674960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 674964 */     GIR_RootConstrainSelectedInstOperands,
     /* 674965 */     // GIR_Coverage, 6083,
     /* 674965 */     GIR_EraseRootFromParent_Done,
     /* 674966 */   // Label 8719: @674966
     /* 674966 */   GIM_Reject,
     /* 674967 */ // Label 8703: @674967
     /* 674967 */ GIM_Reject,
     /* 674968 */ // Label 8685: @674968
     /* 674968 */ GIM_Reject,
     /* 674969 */ // Label 121: @674969
     /* 674969 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8722*/ GIMT_Encode4(678512),
     /* 674980 */ /*GILLT_s32*//*Label 8720*/ GIMT_Encode4(674988),
     /* 674984 */ /*GILLT_s64*//*Label 8721*/ GIMT_Encode4(677330),
     /* 674988 */ // Label 8720: @674988
     /* 674988 */ GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(677329),
     /* 674993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 674996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 674999 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 675002 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 675005 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 675008 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(675076), // Rule ID 5828 //
     /* 675013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675016 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675026 */     // MIs[0] offset
     /* 675026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675029 */     // MIs[0] auxiliary
     /* 675029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675032 */     // MIs[0] Operand 8
     /* 675032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675050 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 675053 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675062 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675074 */     GIR_RootConstrainSelectedInstOperands,
     /* 675075 */     // GIR_Coverage, 5828,
     /* 675075 */     GIR_EraseRootFromParent_Done,
     /* 675076 */   // Label 8724: @675076
     /* 675076 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(675141), // Rule ID 5836 //
     /* 675081 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675091 */     // MIs[0] offset
     /* 675091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675094 */     // MIs[0] auxiliary
     /* 675094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675097 */     // MIs[0] Operand 8
     /* 675097 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675115 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 675118 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675127 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675139 */     GIR_RootConstrainSelectedInstOperands,
     /* 675140 */     // GIR_Coverage, 5836,
     /* 675140 */     GIR_EraseRootFromParent_Done,
     /* 675141 */   // Label 8725: @675141
     /* 675141 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(675209), // Rule ID 5844 //
     /* 675146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675149 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675159 */     // MIs[0] offset
     /* 675159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675162 */     // MIs[0] auxiliary
     /* 675162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675165 */     // MIs[0] Operand 8
     /* 675165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675183 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
     /* 675186 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675195 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675197 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675207 */     GIR_RootConstrainSelectedInstOperands,
     /* 675208 */     // GIR_Coverage, 5844,
     /* 675208 */     GIR_EraseRootFromParent_Done,
     /* 675209 */   // Label 8726: @675209
     /* 675209 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(675274), // Rule ID 5852 //
     /* 675214 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675224 */     // MIs[0] offset
     /* 675224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675227 */     // MIs[0] auxiliary
     /* 675227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675230 */     // MIs[0] Operand 8
     /* 675230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675248 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
     /* 675251 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675260 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675262 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675272 */     GIR_RootConstrainSelectedInstOperands,
     /* 675273 */     // GIR_Coverage, 5852,
     /* 675273 */     GIR_EraseRootFromParent_Done,
     /* 675274 */   // Label 8727: @675274
     /* 675274 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(675346), // Rule ID 5824 //
     /* 675279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675294 */     // MIs[0] offset
     /* 675294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675297 */     // MIs[0] auxiliary
     /* 675297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675300 */     // MIs[0] Operand 8
     /* 675300 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675318 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 675321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675323 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675332 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675334 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675344 */     GIR_RootConstrainSelectedInstOperands,
     /* 675345 */     // GIR_Coverage, 5824,
     /* 675345 */     GIR_EraseRootFromParent_Done,
     /* 675346 */   // Label 8728: @675346
     /* 675346 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(675415), // Rule ID 5832 //
     /* 675351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675363 */     // MIs[0] offset
     /* 675363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675366 */     // MIs[0] auxiliary
     /* 675366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675369 */     // MIs[0] Operand 8
     /* 675369 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675387 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 675390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675392 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675401 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675413 */     GIR_RootConstrainSelectedInstOperands,
     /* 675414 */     // GIR_Coverage, 5832,
     /* 675414 */     GIR_EraseRootFromParent_Done,
     /* 675415 */   // Label 8729: @675415
     /* 675415 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(675487), // Rule ID 5840 //
     /* 675420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675435 */     // MIs[0] offset
     /* 675435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675438 */     // MIs[0] auxiliary
     /* 675438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675441 */     // MIs[0] Operand 8
     /* 675441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675459 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
     /* 675462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675464 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675473 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675485 */     GIR_RootConstrainSelectedInstOperands,
     /* 675486 */     // GIR_Coverage, 5840,
     /* 675486 */     GIR_EraseRootFromParent_Done,
     /* 675487 */   // Label 8730: @675487
     /* 675487 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(675556), // Rule ID 5848 //
     /* 675492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 675504 */     // MIs[0] offset
     /* 675504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675507 */     // MIs[0] auxiliary
     /* 675507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675510 */     // MIs[0] Operand 8
     /* 675510 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675528 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
     /* 675531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675533 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675542 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675554 */     GIR_RootConstrainSelectedInstOperands,
     /* 675555 */     // GIR_Coverage, 5848,
     /* 675555 */     GIR_EraseRootFromParent_Done,
     /* 675556 */   // Label 8731: @675556
     /* 675556 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(675622), // Rule ID 5830 //
     /* 675561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675564 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675570 */     // MIs[0] offset
     /* 675570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675573 */     // MIs[0] auxiliary
     /* 675573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675576 */     // MIs[0] Operand 8
     /* 675576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675594 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
     /* 675597 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675599 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675608 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675610 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675620 */     GIR_RootConstrainSelectedInstOperands,
     /* 675621 */     // GIR_Coverage, 5830,
     /* 675621 */     GIR_EraseRootFromParent_Done,
     /* 675622 */   // Label 8732: @675622
     /* 675622 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(675685), // Rule ID 5838 //
     /* 675627 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675633 */     // MIs[0] offset
     /* 675633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675636 */     // MIs[0] auxiliary
     /* 675636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675639 */     // MIs[0] Operand 8
     /* 675639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675657 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
     /* 675660 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675662 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675671 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675683 */     GIR_RootConstrainSelectedInstOperands,
     /* 675684 */     // GIR_Coverage, 5838,
     /* 675684 */     GIR_EraseRootFromParent_Done,
     /* 675685 */   // Label 8733: @675685
     /* 675685 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(675751), // Rule ID 5846 //
     /* 675690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675693 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675699 */     // MIs[0] offset
     /* 675699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675702 */     // MIs[0] auxiliary
     /* 675702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675705 */     // MIs[0] Operand 8
     /* 675705 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675723 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
     /* 675726 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675728 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675737 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675739 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675749 */     GIR_RootConstrainSelectedInstOperands,
     /* 675750 */     // GIR_Coverage, 5846,
     /* 675750 */     GIR_EraseRootFromParent_Done,
     /* 675751 */   // Label 8734: @675751
     /* 675751 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(675814), // Rule ID 5854 //
     /* 675756 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 675758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675762 */     // MIs[0] offset
     /* 675762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675765 */     // MIs[0] auxiliary
     /* 675765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675768 */     // MIs[0] Operand 8
     /* 675768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675786 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
     /* 675789 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675791 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675800 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675802 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 675808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675812 */     GIR_RootConstrainSelectedInstOperands,
     /* 675813 */     // GIR_Coverage, 5854,
     /* 675813 */     GIR_EraseRootFromParent_Done,
     /* 675814 */   // Label 8735: @675814
     /* 675814 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(675884), // Rule ID 5826 //
     /* 675819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675830 */     // MIs[0] offset
     /* 675830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675833 */     // MIs[0] auxiliary
     /* 675833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675836 */     // MIs[0] Operand 8
     /* 675836 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675854 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
     /* 675857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675859 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675861 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675870 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675882 */     GIR_RootConstrainSelectedInstOperands,
     /* 675883 */     // GIR_Coverage, 5826,
     /* 675883 */     GIR_EraseRootFromParent_Done,
     /* 675884 */   // Label 8736: @675884
     /* 675884 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(675951), // Rule ID 5834 //
     /* 675889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675897 */     // MIs[0] offset
     /* 675897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675900 */     // MIs[0] auxiliary
     /* 675900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675903 */     // MIs[0] Operand 8
     /* 675903 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675921 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
     /* 675924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675926 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675928 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 675930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 675932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 675937 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 675939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 675945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 675949 */     GIR_RootConstrainSelectedInstOperands,
     /* 675950 */     // GIR_Coverage, 5834,
     /* 675950 */     GIR_EraseRootFromParent_Done,
     /* 675951 */   // Label 8737: @675951
     /* 675951 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(676021), // Rule ID 5842 //
     /* 675956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 675959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 675963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 675967 */     // MIs[0] offset
     /* 675967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 675970 */     // MIs[0] auxiliary
     /* 675970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 675973 */     // MIs[0] Operand 8
     /* 675973 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 675984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 675991 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 675991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
     /* 675994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 675996 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 675998 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676007 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676019 */     GIR_RootConstrainSelectedInstOperands,
     /* 676020 */     // GIR_Coverage, 5842,
     /* 676020 */     GIR_EraseRootFromParent_Done,
     /* 676021 */   // Label 8738: @676021
     /* 676021 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(676088), // Rule ID 5850 //
     /* 676026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 676034 */     // MIs[0] offset
     /* 676034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676037 */     // MIs[0] auxiliary
     /* 676037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676040 */     // MIs[0] Operand 8
     /* 676040 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 676051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676058 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
     /* 676061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676063 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676065 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 676067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676074 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676086 */     GIR_RootConstrainSelectedInstOperands,
     /* 676087 */     // GIR_Coverage, 5850,
     /* 676087 */     GIR_EraseRootFromParent_Done,
     /* 676088 */   // Label 8739: @676088
     /* 676088 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(676146), // Rule ID 5829 //
     /* 676093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676096 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676102 */     // MIs[0] offset
     /* 676102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676105 */     // MIs[0] auxiliary
     /* 676105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676108 */     // MIs[0] Operand 8
     /* 676108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676118 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
     /* 676121 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676123 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676132 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676144 */     GIR_RootConstrainSelectedInstOperands,
     /* 676145 */     // GIR_Coverage, 5829,
     /* 676145 */     GIR_EraseRootFromParent_Done,
     /* 676146 */   // Label 8740: @676146
     /* 676146 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(676201), // Rule ID 5837 //
     /* 676151 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676157 */     // MIs[0] offset
     /* 676157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676160 */     // MIs[0] auxiliary
     /* 676160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676163 */     // MIs[0] Operand 8
     /* 676163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676173 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
     /* 676176 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676178 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676187 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676199 */     GIR_RootConstrainSelectedInstOperands,
     /* 676200 */     // GIR_Coverage, 5837,
     /* 676200 */     GIR_EraseRootFromParent_Done,
     /* 676201 */   // Label 8741: @676201
     /* 676201 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(676259), // Rule ID 5845 //
     /* 676206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676209 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676215 */     // MIs[0] offset
     /* 676215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676218 */     // MIs[0] auxiliary
     /* 676218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676221 */     // MIs[0] Operand 8
     /* 676221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676231 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
     /* 676234 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676236 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676245 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676257 */     GIR_RootConstrainSelectedInstOperands,
     /* 676258 */     // GIR_Coverage, 5845,
     /* 676258 */     GIR_EraseRootFromParent_Done,
     /* 676259 */   // Label 8742: @676259
     /* 676259 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(676314), // Rule ID 5853 //
     /* 676264 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676270 */     // MIs[0] offset
     /* 676270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676273 */     // MIs[0] auxiliary
     /* 676273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676276 */     // MIs[0] Operand 8
     /* 676276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676286 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
     /* 676289 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676291 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676300 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676302 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676312 */     GIR_RootConstrainSelectedInstOperands,
     /* 676313 */     // GIR_Coverage, 5853,
     /* 676313 */     GIR_EraseRootFromParent_Done,
     /* 676314 */   // Label 8743: @676314
     /* 676314 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(676376), // Rule ID 5825 //
     /* 676319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676330 */     // MIs[0] offset
     /* 676330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676333 */     // MIs[0] auxiliary
     /* 676333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676336 */     // MIs[0] Operand 8
     /* 676336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676346 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
     /* 676349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676351 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676353 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676362 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676374 */     GIR_RootConstrainSelectedInstOperands,
     /* 676375 */     // GIR_Coverage, 5825,
     /* 676375 */     GIR_EraseRootFromParent_Done,
     /* 676376 */   // Label 8744: @676376
     /* 676376 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(676435), // Rule ID 5833 //
     /* 676381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676389 */     // MIs[0] offset
     /* 676389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676392 */     // MIs[0] auxiliary
     /* 676392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676395 */     // MIs[0] Operand 8
     /* 676395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676405 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
     /* 676408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676410 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676412 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676421 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676433 */     GIR_RootConstrainSelectedInstOperands,
     /* 676434 */     // GIR_Coverage, 5833,
     /* 676434 */     GIR_EraseRootFromParent_Done,
     /* 676435 */   // Label 8745: @676435
     /* 676435 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(676497), // Rule ID 5841 //
     /* 676440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676451 */     // MIs[0] offset
     /* 676451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676454 */     // MIs[0] auxiliary
     /* 676454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676457 */     // MIs[0] Operand 8
     /* 676457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676467 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
     /* 676470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676472 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676474 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676483 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676485 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676495 */     GIR_RootConstrainSelectedInstOperands,
     /* 676496 */     // GIR_Coverage, 5841,
     /* 676496 */     GIR_EraseRootFromParent_Done,
     /* 676497 */   // Label 8746: @676497
     /* 676497 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(676556), // Rule ID 5849 //
     /* 676502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 676510 */     // MIs[0] offset
     /* 676510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676513 */     // MIs[0] auxiliary
     /* 676513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676516 */     // MIs[0] Operand 8
     /* 676516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676526 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
     /* 676529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 676531 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676533 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 676535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676542 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676544 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 676550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676554 */     GIR_RootConstrainSelectedInstOperands,
     /* 676555 */     // GIR_Coverage, 5849,
     /* 676555 */     GIR_EraseRootFromParent_Done,
     /* 676556 */   // Label 8747: @676556
     /* 676556 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(676652), // Rule ID 5831 //
     /* 676561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676564 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676566 */     // MIs[0] offset
     /* 676566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676569 */     // MIs[0] auxiliary
     /* 676569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676572 */     // MIs[0] Operand 8
     /* 676572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676582 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676598 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676605 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
     /* 676626 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676638 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676650 */     GIR_RootConstrainSelectedInstOperands,
     /* 676651 */     // GIR_Coverage, 5831,
     /* 676651 */     GIR_EraseRootFromParent_Done,
     /* 676652 */   // Label 8748: @676652
     /* 676652 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(676745), // Rule ID 5839 //
     /* 676657 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676659 */     // MIs[0] offset
     /* 676659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676662 */     // MIs[0] auxiliary
     /* 676662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676665 */     // MIs[0] Operand 8
     /* 676665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676675 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676691 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676698 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
     /* 676719 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676731 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676743 */     GIR_RootConstrainSelectedInstOperands,
     /* 676744 */     // GIR_Coverage, 5839,
     /* 676744 */     GIR_EraseRootFromParent_Done,
     /* 676745 */   // Label 8749: @676745
     /* 676745 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(676841), // Rule ID 5847 //
     /* 676750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676753 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676755 */     // MIs[0] offset
     /* 676755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676758 */     // MIs[0] auxiliary
     /* 676758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676761 */     // MIs[0] Operand 8
     /* 676761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676771 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676787 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676794 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
     /* 676815 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676827 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676839 */     GIR_RootConstrainSelectedInstOperands,
     /* 676840 */     // GIR_Coverage, 5847,
     /* 676840 */     GIR_EraseRootFromParent_Done,
     /* 676841 */   // Label 8750: @676841
     /* 676841 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(676934), // Rule ID 5855 //
     /* 676846 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 676848 */     // MIs[0] offset
     /* 676848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676851 */     // MIs[0] auxiliary
     /* 676851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676854 */     // MIs[0] Operand 8
     /* 676854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676864 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676880 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676887 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
     /* 676908 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 676910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 676913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 676915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 676920 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 676922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 676928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 676932 */     GIR_RootConstrainSelectedInstOperands,
     /* 676933 */     // GIR_Coverage, 5855,
     /* 676933 */     GIR_EraseRootFromParent_Done,
     /* 676934 */   // Label 8751: @676934
     /* 676934 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(677034), // Rule ID 5827 //
     /* 676939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 676942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 676946 */     // MIs[0] offset
     /* 676946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 676949 */     // MIs[0] auxiliary
     /* 676949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 676952 */     // MIs[0] Operand 8
     /* 676952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 676955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 676962 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 676962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 676965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 676969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 676974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 676978 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 676981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 676985 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 676988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 676993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 676998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
     /* 677006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677008 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677020 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677032 */     GIR_RootConstrainSelectedInstOperands,
     /* 677033 */     // GIR_Coverage, 5827,
     /* 677033 */     GIR_EraseRootFromParent_Done,
     /* 677034 */   // Label 8752: @677034
     /* 677034 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(677131), // Rule ID 5835 //
     /* 677039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677043 */     // MIs[0] offset
     /* 677043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677046 */     // MIs[0] auxiliary
     /* 677046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677049 */     // MIs[0] Operand 8
     /* 677049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677059 */     // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677071 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677075 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677082 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
     /* 677103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677105 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677117 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677119 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677129 */     GIR_RootConstrainSelectedInstOperands,
     /* 677130 */     // GIR_Coverage, 5835,
     /* 677130 */     GIR_EraseRootFromParent_Done,
     /* 677131 */   // Label 8753: @677131
     /* 677131 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(677231), // Rule ID 5843 //
     /* 677136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677143 */     // MIs[0] offset
     /* 677143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677146 */     // MIs[0] auxiliary
     /* 677146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677149 */     // MIs[0] Operand 8
     /* 677149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677159 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677175 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677182 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
     /* 677203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677205 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677217 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677229 */     GIR_RootConstrainSelectedInstOperands,
     /* 677230 */     // GIR_Coverage, 5843,
     /* 677230 */     GIR_EraseRootFromParent_Done,
     /* 677231 */   // Label 8754: @677231
     /* 677231 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(677328), // Rule ID 5851 //
     /* 677236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 677240 */     // MIs[0] offset
     /* 677240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677243 */     // MIs[0] auxiliary
     /* 677243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677246 */     // MIs[0] Operand 8
     /* 677246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677256 */     // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9744:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 677259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 677263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 677268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 677272 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 677275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 677279 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 677282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 677287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 677297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
     /* 677300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677302 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 677307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677314 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677316 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677326 */     GIR_RootConstrainSelectedInstOperands,
     /* 677327 */     // GIR_Coverage, 5851,
     /* 677327 */     GIR_EraseRootFromParent_Done,
     /* 677328 */   // Label 8755: @677328
     /* 677328 */   GIM_Reject,
     /* 677329 */ // Label 8723: @677329
     /* 677329 */ GIM_Reject,
     /* 677330 */ // Label 8721: @677330
     /* 677330 */ GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(678511),
     /* 677335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 677338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 677341 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 677344 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 677347 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 677350 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(677418), // Rule ID 6044 //
     /* 677355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677358 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677368 */     // MIs[0] offset
     /* 677368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677371 */     // MIs[0] auxiliary
     /* 677371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677374 */     // MIs[0] Operand 8
     /* 677374 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677392 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
     /* 677395 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677404 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677406 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677416 */     GIR_RootConstrainSelectedInstOperands,
     /* 677417 */     // GIR_Coverage, 6044,
     /* 677417 */     GIR_EraseRootFromParent_Done,
     /* 677418 */   // Label 8757: @677418
     /* 677418 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(677483), // Rule ID 6052 //
     /* 677423 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677433 */     // MIs[0] offset
     /* 677433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677436 */     // MIs[0] auxiliary
     /* 677436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677439 */     // MIs[0] Operand 8
     /* 677439 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677457 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
     /* 677460 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677469 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677481 */     GIR_RootConstrainSelectedInstOperands,
     /* 677482 */     // GIR_Coverage, 6052,
     /* 677482 */     GIR_EraseRootFromParent_Done,
     /* 677483 */   // Label 8758: @677483
     /* 677483 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(677555), // Rule ID 6040 //
     /* 677488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 677495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677503 */     // MIs[0] offset
     /* 677503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677506 */     // MIs[0] auxiliary
     /* 677506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677509 */     // MIs[0] Operand 8
     /* 677509 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677527 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
     /* 677530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677532 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677541 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677553 */     GIR_RootConstrainSelectedInstOperands,
     /* 677554 */     // GIR_Coverage, 6040,
     /* 677554 */     GIR_EraseRootFromParent_Done,
     /* 677555 */   // Label 8759: @677555
     /* 677555 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(677624), // Rule ID 6048 //
     /* 677560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 677564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677572 */     // MIs[0] offset
     /* 677572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677575 */     // MIs[0] auxiliary
     /* 677575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677578 */     // MIs[0] Operand 8
     /* 677578 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677596 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
     /* 677599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677601 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677610 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677622 */     GIR_RootConstrainSelectedInstOperands,
     /* 677623 */     // GIR_Coverage, 6048,
     /* 677623 */     GIR_EraseRootFromParent_Done,
     /* 677624 */   // Label 8760: @677624
     /* 677624 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(677690), // Rule ID 6046 //
     /* 677629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677632 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677638 */     // MIs[0] offset
     /* 677638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677641 */     // MIs[0] auxiliary
     /* 677641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677644 */     // MIs[0] Operand 8
     /* 677644 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677662 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN),
     /* 677665 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677667 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677676 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677678 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677688 */     GIR_RootConstrainSelectedInstOperands,
     /* 677689 */     // GIR_Coverage, 6046,
     /* 677689 */     GIR_EraseRootFromParent_Done,
     /* 677690 */   // Label 8761: @677690
     /* 677690 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(677753), // Rule ID 6054 //
     /* 677695 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677701 */     // MIs[0] offset
     /* 677701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677704 */     // MIs[0] auxiliary
     /* 677704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677707 */     // MIs[0] Operand 8
     /* 677707 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677725 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN),
     /* 677728 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677730 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677739 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677751 */     GIR_RootConstrainSelectedInstOperands,
     /* 677752 */     // GIR_Coverage, 6054,
     /* 677752 */     GIR_EraseRootFromParent_Done,
     /* 677753 */   // Label 8762: @677753
     /* 677753 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(677823), // Rule ID 6042 //
     /* 677758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 677765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677769 */     // MIs[0] offset
     /* 677769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677772 */     // MIs[0] auxiliary
     /* 677772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677775 */     // MIs[0] Operand 8
     /* 677775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677793 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN),
     /* 677796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677798 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677800 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677809 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677811 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677821 */     GIR_RootConstrainSelectedInstOperands,
     /* 677822 */     // GIR_Coverage, 6042,
     /* 677822 */     GIR_EraseRootFromParent_Done,
     /* 677823 */   // Label 8763: @677823
     /* 677823 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(677890), // Rule ID 6050 //
     /* 677828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 677832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 677836 */     // MIs[0] offset
     /* 677836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677839 */     // MIs[0] auxiliary
     /* 677839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677842 */     // MIs[0] Operand 8
     /* 677842 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 677853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677860 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN),
     /* 677863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 677865 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677867 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 677869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677876 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 677884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677888 */     GIR_RootConstrainSelectedInstOperands,
     /* 677889 */     // GIR_Coverage, 6050,
     /* 677889 */     GIR_EraseRootFromParent_Done,
     /* 677890 */   // Label 8764: @677890
     /* 677890 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(677948), // Rule ID 6045 //
     /* 677895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 677898 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677904 */     // MIs[0] offset
     /* 677904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677907 */     // MIs[0] auxiliary
     /* 677907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677910 */     // MIs[0] Operand 8
     /* 677910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677920 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN),
     /* 677923 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677925 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677934 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 677946 */     GIR_RootConstrainSelectedInstOperands,
     /* 677947 */     // GIR_Coverage, 6045,
     /* 677947 */     GIR_EraseRootFromParent_Done,
     /* 677948 */   // Label 8765: @677948
     /* 677948 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(678003), // Rule ID 6053 //
     /* 677953 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 677955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 677959 */     // MIs[0] offset
     /* 677959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 677962 */     // MIs[0] auxiliary
     /* 677962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 677965 */     // MIs[0] Operand 8
     /* 677965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 677968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 677975 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 677975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN),
     /* 677978 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 677980 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 677982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 677984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 677989 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 677991 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 677997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678001 */     GIR_RootConstrainSelectedInstOperands,
     /* 678002 */     // GIR_Coverage, 6053,
     /* 678002 */     GIR_EraseRootFromParent_Done,
     /* 678003 */   // Label 8766: @678003
     /* 678003 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(678065), // Rule ID 6041 //
     /* 678008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678019 */     // MIs[0] offset
     /* 678019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678022 */     // MIs[0] auxiliary
     /* 678022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678025 */     // MIs[0] Operand 8
     /* 678025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678035 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN),
     /* 678038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678040 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678042 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678051 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678053 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678063 */     GIR_RootConstrainSelectedInstOperands,
     /* 678064 */     // GIR_Coverage, 6041,
     /* 678064 */     GIR_EraseRootFromParent_Done,
     /* 678065 */   // Label 8767: @678065
     /* 678065 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(678124), // Rule ID 6049 //
     /* 678070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678078 */     // MIs[0] offset
     /* 678078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678081 */     // MIs[0] auxiliary
     /* 678081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678084 */     // MIs[0] Operand 8
     /* 678084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678094 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN),
     /* 678097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678099 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678101 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 678103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678110 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678112 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678122 */     GIR_RootConstrainSelectedInstOperands,
     /* 678123 */     // GIR_Coverage, 6049,
     /* 678123 */     GIR_EraseRootFromParent_Done,
     /* 678124 */   // Label 8768: @678124
     /* 678124 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(678220), // Rule ID 6047 //
     /* 678129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678132 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678134 */     // MIs[0] offset
     /* 678134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678137 */     // MIs[0] auxiliary
     /* 678137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678140 */     // MIs[0] Operand 8
     /* 678140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678150 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678166 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678173 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN),
     /* 678194 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678206 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678218 */     GIR_RootConstrainSelectedInstOperands,
     /* 678219 */     // GIR_Coverage, 6047,
     /* 678219 */     GIR_EraseRootFromParent_Done,
     /* 678220 */   // Label 8769: @678220
     /* 678220 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(678313), // Rule ID 6055 //
     /* 678225 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678227 */     // MIs[0] offset
     /* 678227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678230 */     // MIs[0] auxiliary
     /* 678230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678233 */     // MIs[0] Operand 8
     /* 678233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678243 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678255 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678259 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678266 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN),
     /* 678287 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678299 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678301 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678311 */     GIR_RootConstrainSelectedInstOperands,
     /* 678312 */     // GIR_Coverage, 6055,
     /* 678312 */     GIR_EraseRootFromParent_Done,
     /* 678313 */   // Label 8770: @678313
     /* 678313 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(678413), // Rule ID 6043 //
     /* 678318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678325 */     // MIs[0] offset
     /* 678325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678328 */     // MIs[0] auxiliary
     /* 678328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678331 */     // MIs[0] Operand 8
     /* 678331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678341 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678357 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678364 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN),
     /* 678385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678387 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678399 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678401 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678411 */     GIR_RootConstrainSelectedInstOperands,
     /* 678412 */     // GIR_Coverage, 6043,
     /* 678412 */     GIR_EraseRootFromParent_Done,
     /* 678413 */   // Label 8771: @678413
     /* 678413 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(678510), // Rule ID 6051 //
     /* 678418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 678422 */     // MIs[0] offset
     /* 678422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678425 */     // MIs[0] auxiliary
     /* 678425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678428 */     // MIs[0] Operand 8
     /* 678428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 678431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678438 */     // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 678441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 678445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 678450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 678454 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 678457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 678461 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 678464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 678469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 678479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN),
     /* 678482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678484 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 678489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678496 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678508 */     GIR_RootConstrainSelectedInstOperands,
     /* 678509 */     // GIR_Coverage, 6051,
     /* 678509 */     GIR_EraseRootFromParent_Done,
     /* 678510 */   // Label 8772: @678510
     /* 678510 */   GIM_Reject,
     /* 678511 */ // Label 8756: @678511
     /* 678511 */ GIM_Reject,
     /* 678512 */ // Label 8722: @678512
     /* 678512 */ GIM_Reject,
     /* 678513 */ // Label 122: @678513
     /* 678513 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8775*/ GIMT_Encode4(680896),
     /* 678524 */ /*GILLT_s32*//*Label 8773*/ GIMT_Encode4(678532),
     /* 678528 */ /*GILLT_s64*//*Label 8774*/ GIMT_Encode4(679714),
     /* 678532 */ // Label 8773: @678532
     /* 678532 */ GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(679713),
     /* 678537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 678540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 678543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 678546 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 678549 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 678552 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(678620), // Rule ID 5940 //
     /* 678557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678560 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678570 */     // MIs[0] offset
     /* 678570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678573 */     // MIs[0] auxiliary
     /* 678573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678576 */     // MIs[0] Operand 8
     /* 678576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678594 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
     /* 678597 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678606 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678608 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678618 */     GIR_RootConstrainSelectedInstOperands,
     /* 678619 */     // GIR_Coverage, 5940,
     /* 678619 */     GIR_EraseRootFromParent_Done,
     /* 678620 */   // Label 8777: @678620
     /* 678620 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(678685), // Rule ID 5948 //
     /* 678625 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678635 */     // MIs[0] offset
     /* 678635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678638 */     // MIs[0] auxiliary
     /* 678638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678641 */     // MIs[0] Operand 8
     /* 678641 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678659 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
     /* 678662 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678671 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678683 */     GIR_RootConstrainSelectedInstOperands,
     /* 678684 */     // GIR_Coverage, 5948,
     /* 678684 */     GIR_EraseRootFromParent_Done,
     /* 678685 */   // Label 8778: @678685
     /* 678685 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(678757), // Rule ID 5936 //
     /* 678690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 678697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678705 */     // MIs[0] offset
     /* 678705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678708 */     // MIs[0] auxiliary
     /* 678708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678711 */     // MIs[0] Operand 8
     /* 678711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678729 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
     /* 678732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678734 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678743 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678755 */     GIR_RootConstrainSelectedInstOperands,
     /* 678756 */     // GIR_Coverage, 5936,
     /* 678756 */     GIR_EraseRootFromParent_Done,
     /* 678757 */   // Label 8779: @678757
     /* 678757 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(678826), // Rule ID 5944 //
     /* 678762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 678766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 678774 */     // MIs[0] offset
     /* 678774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678777 */     // MIs[0] auxiliary
     /* 678777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678780 */     // MIs[0] Operand 8
     /* 678780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678798 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
     /* 678801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 678803 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678812 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 678820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678824 */     GIR_RootConstrainSelectedInstOperands,
     /* 678825 */     // GIR_Coverage, 5944,
     /* 678825 */     GIR_EraseRootFromParent_Done,
     /* 678826 */   // Label 8780: @678826
     /* 678826 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(678892), // Rule ID 5942 //
     /* 678831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678834 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678840 */     // MIs[0] offset
     /* 678840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678843 */     // MIs[0] auxiliary
     /* 678843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678846 */     // MIs[0] Operand 8
     /* 678846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678864 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN),
     /* 678867 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678869 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678878 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678880 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678890 */     GIR_RootConstrainSelectedInstOperands,
     /* 678891 */     // GIR_Coverage, 5942,
     /* 678891 */     GIR_EraseRootFromParent_Done,
     /* 678892 */   // Label 8781: @678892
     /* 678892 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(678955), // Rule ID 5950 //
     /* 678897 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 678899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678903 */     // MIs[0] offset
     /* 678903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678906 */     // MIs[0] auxiliary
     /* 678906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678909 */     // MIs[0] Operand 8
     /* 678909 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678927 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN),
     /* 678930 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 678932 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 678934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 678936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 678941 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 678943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 678949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 678953 */     GIR_RootConstrainSelectedInstOperands,
     /* 678954 */     // GIR_Coverage, 5950,
     /* 678954 */     GIR_EraseRootFromParent_Done,
     /* 678955 */   // Label 8782: @678955
     /* 678955 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(679025), // Rule ID 5938 //
     /* 678960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 678963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 678967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 678971 */     // MIs[0] offset
     /* 678971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 678974 */     // MIs[0] auxiliary
     /* 678974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 678977 */     // MIs[0] Operand 8
     /* 678977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 678988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 678995 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 678995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN_RTN),
     /* 678998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679000 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679002 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679011 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679023 */     GIR_RootConstrainSelectedInstOperands,
     /* 679024 */     // GIR_Coverage, 5938,
     /* 679024 */     GIR_EraseRootFromParent_Done,
     /* 679025 */   // Label 8783: @679025
     /* 679025 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(679092), // Rule ID 5946 //
     /* 679030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679038 */     // MIs[0] offset
     /* 679038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679041 */     // MIs[0] auxiliary
     /* 679041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679044 */     // MIs[0] Operand 8
     /* 679044 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679062 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN),
     /* 679065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679067 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679069 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 679071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679078 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679090 */     GIR_RootConstrainSelectedInstOperands,
     /* 679091 */     // GIR_Coverage, 5946,
     /* 679091 */     GIR_EraseRootFromParent_Done,
     /* 679092 */   // Label 8784: @679092
     /* 679092 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(679150), // Rule ID 5941 //
     /* 679097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679100 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679106 */     // MIs[0] offset
     /* 679106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679109 */     // MIs[0] auxiliary
     /* 679109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679112 */     // MIs[0] Operand 8
     /* 679112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679122 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN),
     /* 679125 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679127 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679136 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679148 */     GIR_RootConstrainSelectedInstOperands,
     /* 679149 */     // GIR_Coverage, 5941,
     /* 679149 */     GIR_EraseRootFromParent_Done,
     /* 679150 */   // Label 8785: @679150
     /* 679150 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(679205), // Rule ID 5949 //
     /* 679155 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679161 */     // MIs[0] offset
     /* 679161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679164 */     // MIs[0] auxiliary
     /* 679164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679167 */     // MIs[0] Operand 8
     /* 679167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679177 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN),
     /* 679180 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679182 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679191 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679203 */     GIR_RootConstrainSelectedInstOperands,
     /* 679204 */     // GIR_Coverage, 5949,
     /* 679204 */     GIR_EraseRootFromParent_Done,
     /* 679205 */   // Label 8786: @679205
     /* 679205 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(679267), // Rule ID 5937 //
     /* 679210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679221 */     // MIs[0] offset
     /* 679221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679224 */     // MIs[0] auxiliary
     /* 679224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679227 */     // MIs[0] Operand 8
     /* 679227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679237 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN_RTN),
     /* 679240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679242 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679244 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679253 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679255 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679265 */     GIR_RootConstrainSelectedInstOperands,
     /* 679266 */     // GIR_Coverage, 5937,
     /* 679266 */     GIR_EraseRootFromParent_Done,
     /* 679267 */   // Label 8787: @679267
     /* 679267 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(679326), // Rule ID 5945 //
     /* 679272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679280 */     // MIs[0] offset
     /* 679280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679283 */     // MIs[0] auxiliary
     /* 679283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679286 */     // MIs[0] Operand 8
     /* 679286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679296 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN),
     /* 679299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679301 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679303 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 679305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679312 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679324 */     GIR_RootConstrainSelectedInstOperands,
     /* 679325 */     // GIR_Coverage, 5945,
     /* 679325 */     GIR_EraseRootFromParent_Done,
     /* 679326 */   // Label 8788: @679326
     /* 679326 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(679422), // Rule ID 5943 //
     /* 679331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679334 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679336 */     // MIs[0] offset
     /* 679336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679339 */     // MIs[0] auxiliary
     /* 679339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679342 */     // MIs[0] Operand 8
     /* 679342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679352 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679375 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN),
     /* 679396 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679408 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679420 */     GIR_RootConstrainSelectedInstOperands,
     /* 679421 */     // GIR_Coverage, 5943,
     /* 679421 */     GIR_EraseRootFromParent_Done,
     /* 679422 */   // Label 8789: @679422
     /* 679422 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(679515), // Rule ID 5951 //
     /* 679427 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679429 */     // MIs[0] offset
     /* 679429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679432 */     // MIs[0] auxiliary
     /* 679432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679435 */     // MIs[0] Operand 8
     /* 679435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679445 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679461 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679468 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN),
     /* 679489 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679501 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679513 */     GIR_RootConstrainSelectedInstOperands,
     /* 679514 */     // GIR_Coverage, 5951,
     /* 679514 */     GIR_EraseRootFromParent_Done,
     /* 679515 */   // Label 8790: @679515
     /* 679515 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(679615), // Rule ID 5939 //
     /* 679520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679527 */     // MIs[0] offset
     /* 679527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679530 */     // MIs[0] auxiliary
     /* 679530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679533 */     // MIs[0] Operand 8
     /* 679533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679543 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679559 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679566 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN_RTN),
     /* 679587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679589 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679601 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679613 */     GIR_RootConstrainSelectedInstOperands,
     /* 679614 */     // GIR_Coverage, 5939,
     /* 679614 */     GIR_EraseRootFromParent_Done,
     /* 679615 */   // Label 8791: @679615
     /* 679615 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(679712), // Rule ID 5947 //
     /* 679620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 679624 */     // MIs[0] offset
     /* 679624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679627 */     // MIs[0] auxiliary
     /* 679627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679630 */     // MIs[0] Operand 8
     /* 679630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 679633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679640 */     // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 679643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 679647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 679652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 679656 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 679659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 679663 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 679666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 679671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 679681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN),
     /* 679684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679686 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 679691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679698 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679710 */     GIR_RootConstrainSelectedInstOperands,
     /* 679711 */     // GIR_Coverage, 5947,
     /* 679711 */     GIR_EraseRootFromParent_Done,
     /* 679712 */   // Label 8792: @679712
     /* 679712 */   GIM_Reject,
     /* 679713 */ // Label 8776: @679713
     /* 679713 */ GIM_Reject,
     /* 679714 */ // Label 8774: @679714
     /* 679714 */ GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(680895),
     /* 679719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 679722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 679725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 679728 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 679731 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 679734 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(679802), // Rule ID 6140 //
     /* 679739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679742 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679752 */     // MIs[0] offset
     /* 679752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679755 */     // MIs[0] auxiliary
     /* 679755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679758 */     // MIs[0] Operand 8
     /* 679758 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679776 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
     /* 679779 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679788 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679790 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679800 */     GIR_RootConstrainSelectedInstOperands,
     /* 679801 */     // GIR_Coverage, 6140,
     /* 679801 */     GIR_EraseRootFromParent_Done,
     /* 679802 */   // Label 8794: @679802
     /* 679802 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(679867), // Rule ID 6148 //
     /* 679807 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 679809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679817 */     // MIs[0] offset
     /* 679817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679820 */     // MIs[0] auxiliary
     /* 679820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679823 */     // MIs[0] Operand 8
     /* 679823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679841 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
     /* 679844 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679853 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 679861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679865 */     GIR_RootConstrainSelectedInstOperands,
     /* 679866 */     // GIR_Coverage, 6148,
     /* 679866 */     GIR_EraseRootFromParent_Done,
     /* 679867 */   // Label 8795: @679867
     /* 679867 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(679939), // Rule ID 6136 //
     /* 679872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 679875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 679879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679887 */     // MIs[0] offset
     /* 679887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679890 */     // MIs[0] auxiliary
     /* 679890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679893 */     // MIs[0] Operand 8
     /* 679893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679911 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
     /* 679914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679916 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679925 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 679933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 679937 */     GIR_RootConstrainSelectedInstOperands,
     /* 679938 */     // GIR_Coverage, 6136,
     /* 679938 */     GIR_EraseRootFromParent_Done,
     /* 679939 */   // Label 8796: @679939
     /* 679939 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(680008), // Rule ID 6144 //
     /* 679944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 679948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 679952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 679956 */     // MIs[0] offset
     /* 679956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 679959 */     // MIs[0] auxiliary
     /* 679959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 679962 */     // MIs[0] Operand 8
     /* 679962 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 679973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 679980 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 679980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
     /* 679983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 679985 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 679987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 679989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 679994 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 679996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680006 */     GIR_RootConstrainSelectedInstOperands,
     /* 680007 */     // GIR_Coverage, 6144,
     /* 680007 */     GIR_EraseRootFromParent_Done,
     /* 680008 */   // Label 8797: @680008
     /* 680008 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(680074), // Rule ID 6142 //
     /* 680013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680016 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680022 */     // MIs[0] offset
     /* 680022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680025 */     // MIs[0] auxiliary
     /* 680025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680028 */     // MIs[0] Operand 8
     /* 680028 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680046 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN),
     /* 680049 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680051 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680060 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680072 */     GIR_RootConstrainSelectedInstOperands,
     /* 680073 */     // GIR_Coverage, 6142,
     /* 680073 */     GIR_EraseRootFromParent_Done,
     /* 680074 */   // Label 8798: @680074
     /* 680074 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(680137), // Rule ID 6150 //
     /* 680079 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680085 */     // MIs[0] offset
     /* 680085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680088 */     // MIs[0] auxiliary
     /* 680088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680091 */     // MIs[0] Operand 8
     /* 680091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680109 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN),
     /* 680112 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680114 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680123 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680135 */     GIR_RootConstrainSelectedInstOperands,
     /* 680136 */     // GIR_Coverage, 6150,
     /* 680136 */     GIR_EraseRootFromParent_Done,
     /* 680137 */   // Label 8799: @680137
     /* 680137 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(680207), // Rule ID 6138 //
     /* 680142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680153 */     // MIs[0] offset
     /* 680153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680156 */     // MIs[0] auxiliary
     /* 680156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680159 */     // MIs[0] Operand 8
     /* 680159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680177 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN),
     /* 680180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680182 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680184 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680193 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680205 */     GIR_RootConstrainSelectedInstOperands,
     /* 680206 */     // GIR_Coverage, 6138,
     /* 680206 */     GIR_EraseRootFromParent_Done,
     /* 680207 */   // Label 8800: @680207
     /* 680207 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(680274), // Rule ID 6146 //
     /* 680212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680220 */     // MIs[0] offset
     /* 680220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680223 */     // MIs[0] auxiliary
     /* 680223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680226 */     // MIs[0] Operand 8
     /* 680226 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680244 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN),
     /* 680247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680249 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680251 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 680253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680260 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680262 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680272 */     GIR_RootConstrainSelectedInstOperands,
     /* 680273 */     // GIR_Coverage, 6146,
     /* 680273 */     GIR_EraseRootFromParent_Done,
     /* 680274 */   // Label 8801: @680274
     /* 680274 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(680332), // Rule ID 6141 //
     /* 680279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680282 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680288 */     // MIs[0] offset
     /* 680288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680291 */     // MIs[0] auxiliary
     /* 680291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680294 */     // MIs[0] Operand 8
     /* 680294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680304 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN),
     /* 680307 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680309 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680318 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680330 */     GIR_RootConstrainSelectedInstOperands,
     /* 680331 */     // GIR_Coverage, 6141,
     /* 680331 */     GIR_EraseRootFromParent_Done,
     /* 680332 */   // Label 8802: @680332
     /* 680332 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(680387), // Rule ID 6149 //
     /* 680337 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680343 */     // MIs[0] offset
     /* 680343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680346 */     // MIs[0] auxiliary
     /* 680346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680349 */     // MIs[0] Operand 8
     /* 680349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680359 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN),
     /* 680362 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680364 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680373 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680385 */     GIR_RootConstrainSelectedInstOperands,
     /* 680386 */     // GIR_Coverage, 6149,
     /* 680386 */     GIR_EraseRootFromParent_Done,
     /* 680387 */   // Label 8803: @680387
     /* 680387 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(680449), // Rule ID 6137 //
     /* 680392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680403 */     // MIs[0] offset
     /* 680403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680406 */     // MIs[0] auxiliary
     /* 680406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680409 */     // MIs[0] Operand 8
     /* 680409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680419 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN),
     /* 680422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680424 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680426 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680435 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680447 */     GIR_RootConstrainSelectedInstOperands,
     /* 680448 */     // GIR_Coverage, 6137,
     /* 680448 */     GIR_EraseRootFromParent_Done,
     /* 680449 */   // Label 8804: @680449
     /* 680449 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(680508), // Rule ID 6145 //
     /* 680454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680462 */     // MIs[0] offset
     /* 680462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680465 */     // MIs[0] auxiliary
     /* 680465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680468 */     // MIs[0] Operand 8
     /* 680468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680478 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN),
     /* 680481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680483 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680485 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 680487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680494 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680506 */     GIR_RootConstrainSelectedInstOperands,
     /* 680507 */     // GIR_Coverage, 6145,
     /* 680507 */     GIR_EraseRootFromParent_Done,
     /* 680508 */   // Label 8805: @680508
     /* 680508 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(680604), // Rule ID 6143 //
     /* 680513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680516 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680518 */     // MIs[0] offset
     /* 680518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680521 */     // MIs[0] auxiliary
     /* 680521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680524 */     // MIs[0] Operand 8
     /* 680524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680534 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680550 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680557 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN),
     /* 680578 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680590 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680602 */     GIR_RootConstrainSelectedInstOperands,
     /* 680603 */     // GIR_Coverage, 6143,
     /* 680603 */     GIR_EraseRootFromParent_Done,
     /* 680604 */   // Label 8806: @680604
     /* 680604 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(680697), // Rule ID 6151 //
     /* 680609 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680611 */     // MIs[0] offset
     /* 680611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680614 */     // MIs[0] auxiliary
     /* 680614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680617 */     // MIs[0] Operand 8
     /* 680617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680627 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680643 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680650 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN),
     /* 680671 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680683 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680695 */     GIR_RootConstrainSelectedInstOperands,
     /* 680696 */     // GIR_Coverage, 6151,
     /* 680696 */     GIR_EraseRootFromParent_Done,
     /* 680697 */   // Label 8807: @680697
     /* 680697 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(680797), // Rule ID 6139 //
     /* 680702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680709 */     // MIs[0] offset
     /* 680709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680712 */     // MIs[0] auxiliary
     /* 680712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680715 */     // MIs[0] Operand 8
     /* 680715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680725 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680741 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680748 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN),
     /* 680769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680771 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680783 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680795 */     GIR_RootConstrainSelectedInstOperands,
     /* 680796 */     // GIR_Coverage, 6139,
     /* 680796 */     GIR_EraseRootFromParent_Done,
     /* 680797 */   // Label 8808: @680797
     /* 680797 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(680894), // Rule ID 6147 //
     /* 680802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 680806 */     // MIs[0] offset
     /* 680806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680809 */     // MIs[0] auxiliary
     /* 680809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680812 */     // MIs[0] Operand 8
     /* 680812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 680815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680822 */     // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 680825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 680829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 680834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 680838 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 680841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 680845 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 680848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 680853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 680863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN),
     /* 680866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 680868 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 680873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680880 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 680888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 680892 */     GIR_RootConstrainSelectedInstOperands,
     /* 680893 */     // GIR_Coverage, 6147,
     /* 680893 */     GIR_EraseRootFromParent_Done,
     /* 680894 */   // Label 8809: @680894
     /* 680894 */   GIM_Reject,
     /* 680895 */ // Label 8793: @680895
     /* 680895 */ GIM_Reject,
     /* 680896 */ // Label 8775: @680896
     /* 680896 */ GIM_Reject,
     /* 680897 */ // Label 123: @680897
     /* 680897 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8812*/ GIMT_Encode4(683280),
     /* 680908 */ /*GILLT_s32*//*Label 8810*/ GIMT_Encode4(680916),
     /* 680912 */ /*GILLT_s64*//*Label 8811*/ GIMT_Encode4(682098),
     /* 680916 */ // Label 8810: @680916
     /* 680916 */ GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(682097),
     /* 680921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 680924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 680927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 680930 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 680933 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 680936 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(681004), // Rule ID 5908 //
     /* 680941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 680944 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 680946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 680950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 680954 */     // MIs[0] offset
     /* 680954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 680957 */     // MIs[0] auxiliary
     /* 680957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 680960 */     // MIs[0] Operand 8
     /* 680960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 680971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 680978 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 680978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
     /* 680981 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 680983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 680985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 680990 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 680992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 680998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681002 */     GIR_RootConstrainSelectedInstOperands,
     /* 681003 */     // GIR_Coverage, 5908,
     /* 681003 */     GIR_EraseRootFromParent_Done,
     /* 681004 */   // Label 8814: @681004
     /* 681004 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(681069), // Rule ID 5916 //
     /* 681009 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681019 */     // MIs[0] offset
     /* 681019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681022 */     // MIs[0] auxiliary
     /* 681022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681025 */     // MIs[0] Operand 8
     /* 681025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 681036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681043 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
     /* 681046 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681055 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681067 */     GIR_RootConstrainSelectedInstOperands,
     /* 681068 */     // GIR_Coverage, 5916,
     /* 681068 */     GIR_EraseRootFromParent_Done,
     /* 681069 */   // Label 8815: @681069
     /* 681069 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(681141), // Rule ID 5904 //
     /* 681074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 681081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681089 */     // MIs[0] offset
     /* 681089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681092 */     // MIs[0] auxiliary
     /* 681092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681095 */     // MIs[0] Operand 8
     /* 681095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 681106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681113 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
     /* 681116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681118 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681127 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681139 */     GIR_RootConstrainSelectedInstOperands,
     /* 681140 */     // GIR_Coverage, 5904,
     /* 681140 */     GIR_EraseRootFromParent_Done,
     /* 681141 */   // Label 8816: @681141
     /* 681141 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(681210), // Rule ID 5912 //
     /* 681146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 681150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681158 */     // MIs[0] offset
     /* 681158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681161 */     // MIs[0] auxiliary
     /* 681161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681164 */     // MIs[0] Operand 8
     /* 681164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 681175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681182 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
     /* 681185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681187 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681196 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681208 */     GIR_RootConstrainSelectedInstOperands,
     /* 681209 */     // GIR_Coverage, 5912,
     /* 681209 */     GIR_EraseRootFromParent_Done,
     /* 681210 */   // Label 8817: @681210
     /* 681210 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(681276), // Rule ID 5910 //
     /* 681215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681218 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681224 */     // MIs[0] offset
     /* 681224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681227 */     // MIs[0] auxiliary
     /* 681227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681230 */     // MIs[0] Operand 8
     /* 681230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 681241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681248 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN),
     /* 681251 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681253 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 681255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681262 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681274 */     GIR_RootConstrainSelectedInstOperands,
     /* 681275 */     // GIR_Coverage, 5910,
     /* 681275 */     GIR_EraseRootFromParent_Done,
     /* 681276 */   // Label 8818: @681276
     /* 681276 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(681339), // Rule ID 5918 //
     /* 681281 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681287 */     // MIs[0] offset
     /* 681287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681290 */     // MIs[0] auxiliary
     /* 681290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681293 */     // MIs[0] Operand 8
     /* 681293 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 681304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681311 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN),
     /* 681314 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681316 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 681318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681325 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681327 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681337 */     GIR_RootConstrainSelectedInstOperands,
     /* 681338 */     // GIR_Coverage, 5918,
     /* 681338 */     GIR_EraseRootFromParent_Done,
     /* 681339 */   // Label 8819: @681339
     /* 681339 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(681409), // Rule ID 5906 //
     /* 681344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 681351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681355 */     // MIs[0] offset
     /* 681355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681358 */     // MIs[0] auxiliary
     /* 681358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681361 */     // MIs[0] Operand 8
     /* 681361 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 681372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681379 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN_RTN),
     /* 681382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681384 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681386 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 681388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681395 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681407 */     GIR_RootConstrainSelectedInstOperands,
     /* 681408 */     // GIR_Coverage, 5906,
     /* 681408 */     GIR_EraseRootFromParent_Done,
     /* 681409 */   // Label 8820: @681409
     /* 681409 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(681476), // Rule ID 5914 //
     /* 681414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 681418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 681422 */     // MIs[0] offset
     /* 681422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681425 */     // MIs[0] auxiliary
     /* 681425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681428 */     // MIs[0] Operand 8
     /* 681428 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 681439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681446 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN),
     /* 681449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681451 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681453 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 681455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681462 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681474 */     GIR_RootConstrainSelectedInstOperands,
     /* 681475 */     // GIR_Coverage, 5914,
     /* 681475 */     GIR_EraseRootFromParent_Done,
     /* 681476 */   // Label 8821: @681476
     /* 681476 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(681534), // Rule ID 5909 //
     /* 681481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681484 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681490 */     // MIs[0] offset
     /* 681490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681493 */     // MIs[0] auxiliary
     /* 681493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681496 */     // MIs[0] Operand 8
     /* 681496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681506 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN),
     /* 681509 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681511 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 681513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681520 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681532 */     GIR_RootConstrainSelectedInstOperands,
     /* 681533 */     // GIR_Coverage, 5909,
     /* 681533 */     GIR_EraseRootFromParent_Done,
     /* 681534 */   // Label 8822: @681534
     /* 681534 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(681589), // Rule ID 5917 //
     /* 681539 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681545 */     // MIs[0] offset
     /* 681545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681548 */     // MIs[0] auxiliary
     /* 681548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681551 */     // MIs[0] Operand 8
     /* 681551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681561 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN),
     /* 681564 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681566 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 681568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681575 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681587 */     GIR_RootConstrainSelectedInstOperands,
     /* 681588 */     // GIR_Coverage, 5917,
     /* 681588 */     GIR_EraseRootFromParent_Done,
     /* 681589 */   // Label 8823: @681589
     /* 681589 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(681651), // Rule ID 5905 //
     /* 681594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 681601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681605 */     // MIs[0] offset
     /* 681605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681608 */     // MIs[0] auxiliary
     /* 681608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681611 */     // MIs[0] Operand 8
     /* 681611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681621 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN_RTN),
     /* 681624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681626 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681628 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 681630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681637 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681649 */     GIR_RootConstrainSelectedInstOperands,
     /* 681650 */     // GIR_Coverage, 5905,
     /* 681650 */     GIR_EraseRootFromParent_Done,
     /* 681651 */   // Label 8824: @681651
     /* 681651 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(681710), // Rule ID 5913 //
     /* 681656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 681660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 681664 */     // MIs[0] offset
     /* 681664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681667 */     // MIs[0] auxiliary
     /* 681667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681670 */     // MIs[0] Operand 8
     /* 681670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681680 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN),
     /* 681683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681685 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681687 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 681689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681696 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681708 */     GIR_RootConstrainSelectedInstOperands,
     /* 681709 */     // GIR_Coverage, 5913,
     /* 681709 */     GIR_EraseRootFromParent_Done,
     /* 681710 */   // Label 8825: @681710
     /* 681710 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(681806), // Rule ID 5911 //
     /* 681715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681718 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681720 */     // MIs[0] offset
     /* 681720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681723 */     // MIs[0] auxiliary
     /* 681723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681726 */     // MIs[0] Operand 8
     /* 681726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681736 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN),
     /* 681780 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681792 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681804 */     GIR_RootConstrainSelectedInstOperands,
     /* 681805 */     // GIR_Coverage, 5911,
     /* 681805 */     GIR_EraseRootFromParent_Done,
     /* 681806 */   // Label 8826: @681806
     /* 681806 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(681899), // Rule ID 5919 //
     /* 681811 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 681813 */     // MIs[0] offset
     /* 681813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681816 */     // MIs[0] auxiliary
     /* 681816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681819 */     // MIs[0] Operand 8
     /* 681819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681829 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681845 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681852 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN),
     /* 681873 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681885 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 681893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681897 */     GIR_RootConstrainSelectedInstOperands,
     /* 681898 */     // GIR_Coverage, 5919,
     /* 681898 */     GIR_EraseRootFromParent_Done,
     /* 681899 */   // Label 8827: @681899
     /* 681899 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(681999), // Rule ID 5907 //
     /* 681904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 681907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 681911 */     // MIs[0] offset
     /* 681911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 681914 */     // MIs[0] auxiliary
     /* 681914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 681917 */     // MIs[0] Operand 8
     /* 681917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 681920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 681927 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 681927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 681930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 681934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 681939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 681943 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 681946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 681950 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 681953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 681958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 681968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN_RTN),
     /* 681971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 681973 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 681975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 681978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 681980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 681985 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 681987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 681993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 681997 */     GIR_RootConstrainSelectedInstOperands,
     /* 681998 */     // GIR_Coverage, 5907,
     /* 681998 */     GIR_EraseRootFromParent_Done,
     /* 681999 */   // Label 8828: @681999
     /* 681999 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(682096), // Rule ID 5915 //
     /* 682004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 682008 */     // MIs[0] offset
     /* 682008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682011 */     // MIs[0] auxiliary
     /* 682011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682014 */     // MIs[0] Operand 8
     /* 682014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 682017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682024 */     // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 682040 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 682047 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN),
     /* 682068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682070 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682082 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 682090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682094 */     GIR_RootConstrainSelectedInstOperands,
     /* 682095 */     // GIR_Coverage, 5915,
     /* 682095 */     GIR_EraseRootFromParent_Done,
     /* 682096 */   // Label 8829: @682096
     /* 682096 */   GIM_Reject,
     /* 682097 */ // Label 8813: @682097
     /* 682097 */ GIM_Reject,
     /* 682098 */ // Label 8811: @682098
     /* 682098 */ GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(683279),
     /* 682103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 682106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 682109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 682112 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 682115 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 682118 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(682186), // Rule ID 6108 //
     /* 682123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682126 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682136 */     // MIs[0] offset
     /* 682136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682139 */     // MIs[0] auxiliary
     /* 682139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682142 */     // MIs[0] Operand 8
     /* 682142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682160 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
     /* 682163 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682172 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682184 */     GIR_RootConstrainSelectedInstOperands,
     /* 682185 */     // GIR_Coverage, 6108,
     /* 682185 */     GIR_EraseRootFromParent_Done,
     /* 682186 */   // Label 8831: @682186
     /* 682186 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(682251), // Rule ID 6116 //
     /* 682191 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682201 */     // MIs[0] offset
     /* 682201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682204 */     // MIs[0] auxiliary
     /* 682204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682207 */     // MIs[0] Operand 8
     /* 682207 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682225 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
     /* 682228 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682237 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682249 */     GIR_RootConstrainSelectedInstOperands,
     /* 682250 */     // GIR_Coverage, 6116,
     /* 682250 */     GIR_EraseRootFromParent_Done,
     /* 682251 */   // Label 8832: @682251
     /* 682251 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(682323), // Rule ID 6104 //
     /* 682256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682271 */     // MIs[0] offset
     /* 682271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682274 */     // MIs[0] auxiliary
     /* 682274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682277 */     // MIs[0] Operand 8
     /* 682277 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682295 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
     /* 682298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682300 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682309 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 682317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682321 */     GIR_RootConstrainSelectedInstOperands,
     /* 682322 */     // GIR_Coverage, 6104,
     /* 682322 */     GIR_EraseRootFromParent_Done,
     /* 682323 */   // Label 8833: @682323
     /* 682323 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(682392), // Rule ID 6112 //
     /* 682328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682340 */     // MIs[0] offset
     /* 682340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682343 */     // MIs[0] auxiliary
     /* 682343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682346 */     // MIs[0] Operand 8
     /* 682346 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682364 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
     /* 682367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682369 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682378 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682380 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 682386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682390 */     GIR_RootConstrainSelectedInstOperands,
     /* 682391 */     // GIR_Coverage, 6112,
     /* 682391 */     GIR_EraseRootFromParent_Done,
     /* 682392 */   // Label 8834: @682392
     /* 682392 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(682458), // Rule ID 6110 //
     /* 682397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682400 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682406 */     // MIs[0] offset
     /* 682406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682409 */     // MIs[0] auxiliary
     /* 682409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682412 */     // MIs[0] Operand 8
     /* 682412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682430 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN),
     /* 682433 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682435 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 682437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682444 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682456 */     GIR_RootConstrainSelectedInstOperands,
     /* 682457 */     // GIR_Coverage, 6110,
     /* 682457 */     GIR_EraseRootFromParent_Done,
     /* 682458 */   // Label 8835: @682458
     /* 682458 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(682521), // Rule ID 6118 //
     /* 682463 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682469 */     // MIs[0] offset
     /* 682469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682472 */     // MIs[0] auxiliary
     /* 682472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682475 */     // MIs[0] Operand 8
     /* 682475 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682493 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN),
     /* 682496 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682498 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 682500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682507 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682519 */     GIR_RootConstrainSelectedInstOperands,
     /* 682520 */     // GIR_Coverage, 6118,
     /* 682520 */     GIR_EraseRootFromParent_Done,
     /* 682521 */   // Label 8836: @682521
     /* 682521 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(682591), // Rule ID 6106 //
     /* 682526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682537 */     // MIs[0] offset
     /* 682537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682540 */     // MIs[0] auxiliary
     /* 682540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682543 */     // MIs[0] Operand 8
     /* 682543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682561 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN),
     /* 682564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682566 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682568 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 682570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682577 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 682585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682589 */     GIR_RootConstrainSelectedInstOperands,
     /* 682590 */     // GIR_Coverage, 6106,
     /* 682590 */     GIR_EraseRootFromParent_Done,
     /* 682591 */   // Label 8837: @682591
     /* 682591 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(682658), // Rule ID 6114 //
     /* 682596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 682604 */     // MIs[0] offset
     /* 682604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682607 */     // MIs[0] auxiliary
     /* 682607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682610 */     // MIs[0] Operand 8
     /* 682610 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 682621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682628 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN),
     /* 682631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682633 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682635 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 682637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682644 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 682652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682656 */     GIR_RootConstrainSelectedInstOperands,
     /* 682657 */     // GIR_Coverage, 6114,
     /* 682657 */     GIR_EraseRootFromParent_Done,
     /* 682658 */   // Label 8838: @682658
     /* 682658 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(682716), // Rule ID 6109 //
     /* 682663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682666 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682672 */     // MIs[0] offset
     /* 682672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682675 */     // MIs[0] auxiliary
     /* 682675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682678 */     // MIs[0] Operand 8
     /* 682678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 682681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682688 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN),
     /* 682691 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682693 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 682695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682702 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682714 */     GIR_RootConstrainSelectedInstOperands,
     /* 682715 */     // GIR_Coverage, 6109,
     /* 682715 */     GIR_EraseRootFromParent_Done,
     /* 682716 */   // Label 8839: @682716
     /* 682716 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(682771), // Rule ID 6117 //
     /* 682721 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682727 */     // MIs[0] offset
     /* 682727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682730 */     // MIs[0] auxiliary
     /* 682730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682733 */     // MIs[0] Operand 8
     /* 682733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 682736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682743 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN),
     /* 682746 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682748 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 682750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682757 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682769 */     GIR_RootConstrainSelectedInstOperands,
     /* 682770 */     // GIR_Coverage, 6117,
     /* 682770 */     GIR_EraseRootFromParent_Done,
     /* 682771 */   // Label 8840: @682771
     /* 682771 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(682833), // Rule ID 6105 //
     /* 682776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682787 */     // MIs[0] offset
     /* 682787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682790 */     // MIs[0] auxiliary
     /* 682790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682793 */     // MIs[0] Operand 8
     /* 682793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 682796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682803 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN),
     /* 682806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682808 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682810 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 682812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682819 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 682827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682831 */     GIR_RootConstrainSelectedInstOperands,
     /* 682832 */     // GIR_Coverage, 6105,
     /* 682832 */     GIR_EraseRootFromParent_Done,
     /* 682833 */   // Label 8841: @682833
     /* 682833 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(682892), // Rule ID 6113 //
     /* 682838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 682842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 682846 */     // MIs[0] offset
     /* 682846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682849 */     // MIs[0] auxiliary
     /* 682849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682852 */     // MIs[0] Operand 8
     /* 682852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 682855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682862 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN),
     /* 682865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 682867 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682869 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 682871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682878 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682880 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 682886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682890 */     GIR_RootConstrainSelectedInstOperands,
     /* 682891 */     // GIR_Coverage, 6113,
     /* 682891 */     GIR_EraseRootFromParent_Done,
     /* 682892 */   // Label 8842: @682892
     /* 682892 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(682988), // Rule ID 6111 //
     /* 682897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 682900 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682902 */     // MIs[0] offset
     /* 682902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682905 */     // MIs[0] auxiliary
     /* 682905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 682908 */     // MIs[0] Operand 8
     /* 682908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 682911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 682918 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 682918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 682921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 682925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 682930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 682934 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 682937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 682941 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 682944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 682949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 682959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN),
     /* 682962 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 682964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 682967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 682969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 682974 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 682976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 682982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 682986 */     GIR_RootConstrainSelectedInstOperands,
     /* 682987 */     // GIR_Coverage, 6111,
     /* 682987 */     GIR_EraseRootFromParent_Done,
     /* 682988 */   // Label 8843: @682988
     /* 682988 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(683081), // Rule ID 6119 //
     /* 682993 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 682995 */     // MIs[0] offset
     /* 682995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 682998 */     // MIs[0] auxiliary
     /* 682998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683001 */     // MIs[0] Operand 8
     /* 683001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 683004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683011 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 683027 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 683034 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN),
     /* 683055 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683067 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683079 */     GIR_RootConstrainSelectedInstOperands,
     /* 683080 */     // GIR_Coverage, 6119,
     /* 683080 */     GIR_EraseRootFromParent_Done,
     /* 683081 */   // Label 8844: @683081
     /* 683081 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(683181), // Rule ID 6107 //
     /* 683086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 683093 */     // MIs[0] offset
     /* 683093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683096 */     // MIs[0] auxiliary
     /* 683096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683099 */     // MIs[0] Operand 8
     /* 683099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 683102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683109 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683121 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 683125 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 683132 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN),
     /* 683153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683155 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683167 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 683175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683179 */     GIR_RootConstrainSelectedInstOperands,
     /* 683180 */     // GIR_Coverage, 6107,
     /* 683180 */     GIR_EraseRootFromParent_Done,
     /* 683181 */   // Label 8845: @683181
     /* 683181 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(683278), // Rule ID 6115 //
     /* 683186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 683190 */     // MIs[0] offset
     /* 683190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683193 */     // MIs[0] auxiliary
     /* 683193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683196 */     // MIs[0] Operand 8
     /* 683196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 683199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683206 */     // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 683209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 683213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 683218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 683222 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 683225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 683229 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 683232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 683237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 683247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN),
     /* 683250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683252 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 683257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683264 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683266 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 683272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683276 */     GIR_RootConstrainSelectedInstOperands,
     /* 683277 */     // GIR_Coverage, 6115,
     /* 683277 */     GIR_EraseRootFromParent_Done,
     /* 683278 */   // Label 8846: @683278
     /* 683278 */   GIM_Reject,
     /* 683279 */ // Label 8830: @683279
     /* 683279 */ GIM_Reject,
     /* 683280 */ // Label 8812: @683280
     /* 683280 */ GIM_Reject,
     /* 683281 */ // Label 124: @683281
     /* 683281 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8849*/ GIMT_Encode4(685664),
     /* 683292 */ /*GILLT_s32*//*Label 8847*/ GIMT_Encode4(683300),
     /* 683296 */ /*GILLT_s64*//*Label 8848*/ GIMT_Encode4(684482),
     /* 683300 */ // Label 8847: @683300
     /* 683300 */ GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(684481),
     /* 683305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 683308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 683311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 683314 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 683317 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 683320 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(683388), // Rule ID 5988 //
     /* 683325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683328 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 683330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 683338 */     // MIs[0] offset
     /* 683338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683341 */     // MIs[0] auxiliary
     /* 683341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683344 */     // MIs[0] Operand 8
     /* 683344 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683362 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
     /* 683365 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683374 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683376 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683386 */     GIR_RootConstrainSelectedInstOperands,
     /* 683387 */     // GIR_Coverage, 5988,
     /* 683387 */     GIR_EraseRootFromParent_Done,
     /* 683388 */   // Label 8851: @683388
     /* 683388 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(683453), // Rule ID 5996 //
     /* 683393 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 683395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 683403 */     // MIs[0] offset
     /* 683403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683406 */     // MIs[0] auxiliary
     /* 683406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683409 */     // MIs[0] Operand 8
     /* 683409 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683427 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
     /* 683430 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683439 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683441 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683451 */     GIR_RootConstrainSelectedInstOperands,
     /* 683452 */     // GIR_Coverage, 5996,
     /* 683452 */     GIR_EraseRootFromParent_Done,
     /* 683453 */   // Label 8852: @683453
     /* 683453 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(683525), // Rule ID 5984 //
     /* 683458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 683465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 683473 */     // MIs[0] offset
     /* 683473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683476 */     // MIs[0] auxiliary
     /* 683476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683479 */     // MIs[0] Operand 8
     /* 683479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683497 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
     /* 683500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683502 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683511 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 683519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683523 */     GIR_RootConstrainSelectedInstOperands,
     /* 683524 */     // GIR_Coverage, 5984,
     /* 683524 */     GIR_EraseRootFromParent_Done,
     /* 683525 */   // Label 8853: @683525
     /* 683525 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(683594), // Rule ID 5992 //
     /* 683530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 683534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 683542 */     // MIs[0] offset
     /* 683542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683545 */     // MIs[0] auxiliary
     /* 683545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683548 */     // MIs[0] Operand 8
     /* 683548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683566 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
     /* 683569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683571 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683580 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683582 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 683588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683592 */     GIR_RootConstrainSelectedInstOperands,
     /* 683593 */     // GIR_Coverage, 5992,
     /* 683593 */     GIR_EraseRootFromParent_Done,
     /* 683594 */   // Label 8854: @683594
     /* 683594 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(683660), // Rule ID 5990 //
     /* 683599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683602 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 683604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683608 */     // MIs[0] offset
     /* 683608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683611 */     // MIs[0] auxiliary
     /* 683611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683614 */     // MIs[0] Operand 8
     /* 683614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683632 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN),
     /* 683635 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683637 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 683639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683646 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683658 */     GIR_RootConstrainSelectedInstOperands,
     /* 683659 */     // GIR_Coverage, 5990,
     /* 683659 */     GIR_EraseRootFromParent_Done,
     /* 683660 */   // Label 8855: @683660
     /* 683660 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(683723), // Rule ID 5998 //
     /* 683665 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 683667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683671 */     // MIs[0] offset
     /* 683671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683674 */     // MIs[0] auxiliary
     /* 683674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683677 */     // MIs[0] Operand 8
     /* 683677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683695 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN),
     /* 683698 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683700 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 683702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683709 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683721 */     GIR_RootConstrainSelectedInstOperands,
     /* 683722 */     // GIR_Coverage, 5998,
     /* 683722 */     GIR_EraseRootFromParent_Done,
     /* 683723 */   // Label 8856: @683723
     /* 683723 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(683793), // Rule ID 5986 //
     /* 683728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 683735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683739 */     // MIs[0] offset
     /* 683739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683742 */     // MIs[0] auxiliary
     /* 683742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683745 */     // MIs[0] Operand 8
     /* 683745 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683763 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN_RTN),
     /* 683766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683768 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683770 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 683772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683779 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 683787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683791 */     GIR_RootConstrainSelectedInstOperands,
     /* 683792 */     // GIR_Coverage, 5986,
     /* 683792 */     GIR_EraseRootFromParent_Done,
     /* 683793 */   // Label 8857: @683793
     /* 683793 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(683860), // Rule ID 5994 //
     /* 683798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 683802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 683806 */     // MIs[0] offset
     /* 683806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683809 */     // MIs[0] auxiliary
     /* 683809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683812 */     // MIs[0] Operand 8
     /* 683812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 683823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683830 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN),
     /* 683833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 683835 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683837 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 683839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683846 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 683854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683858 */     GIR_RootConstrainSelectedInstOperands,
     /* 683859 */     // GIR_Coverage, 5994,
     /* 683859 */     GIR_EraseRootFromParent_Done,
     /* 683860 */   // Label 8858: @683860
     /* 683860 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(683918), // Rule ID 5989 //
     /* 683865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683868 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 683870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 683874 */     // MIs[0] offset
     /* 683874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683877 */     // MIs[0] auxiliary
     /* 683877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683880 */     // MIs[0] Operand 8
     /* 683880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 683883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683890 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN),
     /* 683893 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683895 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 683897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683904 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683916 */     GIR_RootConstrainSelectedInstOperands,
     /* 683917 */     // GIR_Coverage, 5989,
     /* 683917 */     GIR_EraseRootFromParent_Done,
     /* 683918 */   // Label 8859: @683918
     /* 683918 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(683973), // Rule ID 5997 //
     /* 683923 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 683925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 683929 */     // MIs[0] offset
     /* 683929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683932 */     // MIs[0] auxiliary
     /* 683932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683935 */     // MIs[0] Operand 8
     /* 683935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 683938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 683945 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 683945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN),
     /* 683948 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 683950 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 683952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 683954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 683959 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 683961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 683967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 683971 */     GIR_RootConstrainSelectedInstOperands,
     /* 683972 */     // GIR_Coverage, 5997,
     /* 683972 */     GIR_EraseRootFromParent_Done,
     /* 683973 */   // Label 8860: @683973
     /* 683973 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(684035), // Rule ID 5985 //
     /* 683978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 683981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 683985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 683989 */     // MIs[0] offset
     /* 683989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 683992 */     // MIs[0] auxiliary
     /* 683992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 683995 */     // MIs[0] Operand 8
     /* 683995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 683998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684005 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN_RTN),
     /* 684008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684010 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684012 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 684014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684021 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 684029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684033 */     GIR_RootConstrainSelectedInstOperands,
     /* 684034 */     // GIR_Coverage, 5985,
     /* 684034 */     GIR_EraseRootFromParent_Done,
     /* 684035 */   // Label 8861: @684035
     /* 684035 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(684094), // Rule ID 5993 //
     /* 684040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 684044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 684048 */     // MIs[0] offset
     /* 684048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684051 */     // MIs[0] auxiliary
     /* 684051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684054 */     // MIs[0] Operand 8
     /* 684054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 684057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684064 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN),
     /* 684067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684069 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684071 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 684073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684080 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 684088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684092 */     GIR_RootConstrainSelectedInstOperands,
     /* 684093 */     // GIR_Coverage, 5993,
     /* 684093 */     GIR_EraseRootFromParent_Done,
     /* 684094 */   // Label 8862: @684094
     /* 684094 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(684190), // Rule ID 5991 //
     /* 684099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684102 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 684104 */     // MIs[0] offset
     /* 684104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684107 */     // MIs[0] auxiliary
     /* 684107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684110 */     // MIs[0] Operand 8
     /* 684110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 684113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684120 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 684136 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684139 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 684143 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN),
     /* 684164 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684176 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684188 */     GIR_RootConstrainSelectedInstOperands,
     /* 684189 */     // GIR_Coverage, 5991,
     /* 684189 */     GIR_EraseRootFromParent_Done,
     /* 684190 */   // Label 8863: @684190
     /* 684190 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(684283), // Rule ID 5999 //
     /* 684195 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 684197 */     // MIs[0] offset
     /* 684197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684200 */     // MIs[0] auxiliary
     /* 684200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684203 */     // MIs[0] Operand 8
     /* 684203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 684206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684213 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 684229 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 684236 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN),
     /* 684257 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684269 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684281 */     GIR_RootConstrainSelectedInstOperands,
     /* 684282 */     // GIR_Coverage, 5999,
     /* 684282 */     GIR_EraseRootFromParent_Done,
     /* 684283 */   // Label 8864: @684283
     /* 684283 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(684383), // Rule ID 5987 //
     /* 684288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 684295 */     // MIs[0] offset
     /* 684295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684298 */     // MIs[0] auxiliary
     /* 684298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684301 */     // MIs[0] Operand 8
     /* 684301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 684304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684311 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 684327 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 684334 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN_RTN),
     /* 684355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684357 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684369 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 684377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684381 */     GIR_RootConstrainSelectedInstOperands,
     /* 684382 */     // GIR_Coverage, 5987,
     /* 684382 */     GIR_EraseRootFromParent_Done,
     /* 684383 */   // Label 8865: @684383
     /* 684383 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(684480), // Rule ID 5995 //
     /* 684388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 684392 */     // MIs[0] offset
     /* 684392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684395 */     // MIs[0] auxiliary
     /* 684395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684398 */     // MIs[0] Operand 8
     /* 684398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 684401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684408 */     // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9744:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 684411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 684415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 684420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 684424 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 684427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 684431 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 684434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 684439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 684449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN),
     /* 684452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684454 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 684459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684466 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 684474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684478 */     GIR_RootConstrainSelectedInstOperands,
     /* 684479 */     // GIR_Coverage, 5995,
     /* 684479 */     GIR_EraseRootFromParent_Done,
     /* 684480 */   // Label 8866: @684480
     /* 684480 */   GIM_Reject,
     /* 684481 */ // Label 8850: @684481
     /* 684481 */ GIM_Reject,
     /* 684482 */ // Label 8848: @684482
     /* 684482 */ GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(685663),
     /* 684487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 684490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 684493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 684496 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 684499 */   GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 684502 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(684570), // Rule ID 6188 //
     /* 684507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684510 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 684512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 684520 */     // MIs[0] offset
     /* 684520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684523 */     // MIs[0] auxiliary
     /* 684523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684526 */     // MIs[0] Operand 8
     /* 684526 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 684537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684544 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
     /* 684547 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684556 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684568 */     GIR_RootConstrainSelectedInstOperands,
     /* 684569 */     // GIR_Coverage, 6188,
     /* 684569 */     GIR_EraseRootFromParent_Done,
     /* 684570 */   // Label 8868: @684570
     /* 684570 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(684635), // Rule ID 6196 //
     /* 684575 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 684577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 684585 */     // MIs[0] offset
     /* 684585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684588 */     // MIs[0] auxiliary
     /* 684588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684591 */     // MIs[0] Operand 8
     /* 684591 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 684602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684609 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
     /* 684612 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684621 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684633 */     GIR_RootConstrainSelectedInstOperands,
     /* 684634 */     // GIR_Coverage, 6196,
     /* 684634 */     GIR_EraseRootFromParent_Done,
     /* 684635 */   // Label 8869: @684635
     /* 684635 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(684707), // Rule ID 6184 //
     /* 684640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 684647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 684655 */     // MIs[0] offset
     /* 684655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684658 */     // MIs[0] auxiliary
     /* 684658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684661 */     // MIs[0] Operand 8
     /* 684661 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 684672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684679 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
     /* 684682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684684 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684693 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 684701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684705 */     GIR_RootConstrainSelectedInstOperands,
     /* 684706 */     // GIR_Coverage, 6184,
     /* 684706 */     GIR_EraseRootFromParent_Done,
     /* 684707 */   // Label 8870: @684707
     /* 684707 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(684776), // Rule ID 6192 //
     /* 684712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 684716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 684724 */     // MIs[0] offset
     /* 684724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684727 */     // MIs[0] auxiliary
     /* 684727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684730 */     // MIs[0] Operand 8
     /* 684730 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 684741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684748 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
     /* 684751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684753 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684762 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 684770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684774 */     GIR_RootConstrainSelectedInstOperands,
     /* 684775 */     // GIR_Coverage, 6192,
     /* 684775 */     GIR_EraseRootFromParent_Done,
     /* 684776 */   // Label 8871: @684776
     /* 684776 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(684842), // Rule ID 6190 //
     /* 684781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684784 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 684786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684790 */     // MIs[0] offset
     /* 684790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684793 */     // MIs[0] auxiliary
     /* 684793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684796 */     // MIs[0] Operand 8
     /* 684796 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 684807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684814 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN),
     /* 684817 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684819 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 684821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684828 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684830 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684840 */     GIR_RootConstrainSelectedInstOperands,
     /* 684841 */     // GIR_Coverage, 6190,
     /* 684841 */     GIR_EraseRootFromParent_Done,
     /* 684842 */   // Label 8872: @684842
     /* 684842 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(684905), // Rule ID 6198 //
     /* 684847 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 684849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684853 */     // MIs[0] offset
     /* 684853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684856 */     // MIs[0] auxiliary
     /* 684856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684859 */     // MIs[0] Operand 8
     /* 684859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 684870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684877 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN),
     /* 684880 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684882 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 684884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684891 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684893 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 684899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684903 */     GIR_RootConstrainSelectedInstOperands,
     /* 684904 */     // GIR_Coverage, 6198,
     /* 684904 */     GIR_EraseRootFromParent_Done,
     /* 684905 */   // Label 8873: @684905
     /* 684905 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(684975), // Rule ID 6186 //
     /* 684910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 684913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 684917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684921 */     // MIs[0] offset
     /* 684921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684924 */     // MIs[0] auxiliary
     /* 684924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684927 */     // MIs[0] Operand 8
     /* 684927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 684938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 684945 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 684945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN_RTN),
     /* 684948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 684950 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 684952 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 684954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 684956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 684961 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 684963 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 684969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 684973 */     GIR_RootConstrainSelectedInstOperands,
     /* 684974 */     // GIR_Coverage, 6186,
     /* 684974 */     GIR_EraseRootFromParent_Done,
     /* 684975 */   // Label 8874: @684975
     /* 684975 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(685042), // Rule ID 6194 //
     /* 684980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 684984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 684988 */     // MIs[0] offset
     /* 684988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 684991 */     // MIs[0] auxiliary
     /* 684991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 684994 */     // MIs[0] Operand 8
     /* 684994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 685005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685012 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN),
     /* 685015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685017 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685019 */     GIR_RootToRootCopy, /*OpIdx*/4, // voffset
     /* 685021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685028 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 685036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685040 */     GIR_RootConstrainSelectedInstOperands,
     /* 685041 */     // GIR_Coverage, 6194,
     /* 685041 */     GIR_EraseRootFromParent_Done,
     /* 685042 */   // Label 8875: @685042
     /* 685042 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(685100), // Rule ID 6189 //
     /* 685047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685050 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 685052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 685056 */     // MIs[0] offset
     /* 685056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685059 */     // MIs[0] auxiliary
     /* 685059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685062 */     // MIs[0] Operand 8
     /* 685062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685072 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN),
     /* 685075 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685077 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 685079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685086 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685098 */     GIR_RootConstrainSelectedInstOperands,
     /* 685099 */     // GIR_Coverage, 6189,
     /* 685099 */     GIR_EraseRootFromParent_Done,
     /* 685100 */   // Label 8876: @685100
     /* 685100 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(685155), // Rule ID 6197 //
     /* 685105 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 685107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 685111 */     // MIs[0] offset
     /* 685111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685114 */     // MIs[0] auxiliary
     /* 685114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685117 */     // MIs[0] Operand 8
     /* 685117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685127 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN),
     /* 685130 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685132 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 685134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685141 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685153 */     GIR_RootConstrainSelectedInstOperands,
     /* 685154 */     // GIR_Coverage, 6197,
     /* 685154 */     GIR_EraseRootFromParent_Done,
     /* 685155 */   // Label 8877: @685155
     /* 685155 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(685217), // Rule ID 6185 //
     /* 685160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 685167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 685171 */     // MIs[0] offset
     /* 685171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685174 */     // MIs[0] auxiliary
     /* 685174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685177 */     // MIs[0] Operand 8
     /* 685177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685187 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN_RTN),
     /* 685190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685192 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685194 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 685196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685203 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685205 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 685211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685215 */     GIR_RootConstrainSelectedInstOperands,
     /* 685216 */     // GIR_Coverage, 6185,
     /* 685216 */     GIR_EraseRootFromParent_Done,
     /* 685217 */   // Label 8878: @685217
     /* 685217 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(685276), // Rule ID 6193 //
     /* 685222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 685226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 685230 */     // MIs[0] offset
     /* 685230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685233 */     // MIs[0] auxiliary
     /* 685233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685236 */     // MIs[0] Operand 8
     /* 685236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685246 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN),
     /* 685249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685251 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685253 */     GIR_RootToRootCopy, /*OpIdx*/3, // vindex
     /* 685255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685262 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 685270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685274 */     GIR_RootConstrainSelectedInstOperands,
     /* 685275 */     // GIR_Coverage, 6193,
     /* 685275 */     GIR_EraseRootFromParent_Done,
     /* 685276 */   // Label 8879: @685276
     /* 685276 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(685372), // Rule ID 6191 //
     /* 685281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685284 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 685286 */     // MIs[0] offset
     /* 685286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685289 */     // MIs[0] auxiliary
     /* 685289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685292 */     // MIs[0] Operand 8
     /* 685292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685302 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 685318 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 685325 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN),
     /* 685346 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685358 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685370 */     GIR_RootConstrainSelectedInstOperands,
     /* 685371 */     // GIR_Coverage, 6191,
     /* 685371 */     GIR_EraseRootFromParent_Done,
     /* 685372 */   // Label 8880: @685372
     /* 685372 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(685465), // Rule ID 6199 //
     /* 685377 */     GIM_CheckHasNoUse, /*MI*/0,
     /* 685379 */     // MIs[0] offset
     /* 685379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685382 */     // MIs[0] auxiliary
     /* 685382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685385 */     // MIs[0] Operand 8
     /* 685385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685395 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 685411 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 685418 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN),
     /* 685439 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685451 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685463 */     GIR_RootConstrainSelectedInstOperands,
     /* 685464 */     // GIR_Coverage, 6199,
     /* 685464 */     GIR_EraseRootFromParent_Done,
     /* 685465 */   // Label 8881: @685465
     /* 685465 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(685565), // Rule ID 6187 //
     /* 685470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 685477 */     // MIs[0] offset
     /* 685477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685480 */     // MIs[0] auxiliary
     /* 685480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685483 */     // MIs[0] Operand 8
     /* 685483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685493 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685505 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 685509 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 685516 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN),
     /* 685537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685539 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685551 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 685559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685563 */     GIR_RootConstrainSelectedInstOperands,
     /* 685564 */     // GIR_Coverage, 6187,
     /* 685564 */     GIR_EraseRootFromParent_Done,
     /* 685565 */   // Label 8882: @685565
     /* 685565 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(685662), // Rule ID 6195 //
     /* 685570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 685574 */     // MIs[0] offset
     /* 685574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685577 */     // MIs[0] auxiliary
     /* 685577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 685580 */     // MIs[0] Operand 8
     /* 685580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 685583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685590 */     // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9743:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
     /* 685590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 685593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 685597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 685602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
     /* 685606 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 685609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
     /* 685613 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 685616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 685621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 685631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN),
     /* 685634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685636 */     GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
     /* 685638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 685641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
     /* 685643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685648 */     GIR_RootToRootCopy, /*OpIdx*/6, // offset
     /* 685650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
     /* 685656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685660 */     GIR_RootConstrainSelectedInstOperands,
     /* 685661 */     // GIR_Coverage, 6195,
     /* 685661 */     GIR_EraseRootFromParent_Done,
     /* 685662 */   // Label 8883: @685662
     /* 685662 */   GIM_Reject,
     /* 685663 */ // Label 8867: @685663
     /* 685663 */ GIM_Reject,
     /* 685664 */ // Label 8849: @685664
     /* 685664 */ GIM_Reject,
     /* 685665 */ // Label 125: @685665
     /* 685665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 8900*/ GIMT_Encode4(701036),
     /* 685676 */ /*GILLT_p0s64*//*Label 8884*/ GIMT_Encode4(685768),
     /* 685680 */ /*GILLT_p1s64*//*Label 8885*/ GIMT_Encode4(686387),
     /* 685684 */ /*GILLT_p2s32*//*Label 8886*/ GIMT_Encode4(687006),
     /* 685688 */ /*GILLT_p3s32*//*Label 8887*/ GIMT_Encode4(687625),
     /* 685692 */ /*GILLT_p4s64*//*Label 8888*/ GIMT_Encode4(688244),
     /* 685696 */ /*GILLT_p5s32*//*Label 8889*/ GIMT_Encode4(688863),
     /* 685700 */ /*GILLT_p6s32*//*Label 8890*/ GIMT_Encode4(689482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 685712 */ /*GILLT_s32*//*Label 8891*/ GIMT_Encode4(690101),
     /* 685716 */ /*GILLT_s64*//*Label 8892*/ GIMT_Encode4(691316),
     /* 685720 */ /*GILLT_v2s16*//*Label 8893*/ GIMT_Encode4(692531),
     /* 685724 */ /*GILLT_v2s32*//*Label 8894*/ GIMT_Encode4(693746),
     /* 685728 */ /*GILLT_v2s64*//*Label 8895*/ GIMT_Encode4(694961),
     /* 685732 */ /*GILLT_v3s32*//*Label 8896*/ GIMT_Encode4(696176), GIMT_Encode4(0),
     /* 685740 */ /*GILLT_v4s16*//*Label 8897*/ GIMT_Encode4(697391),
     /* 685744 */ /*GILLT_v4s32*//*Label 8898*/ GIMT_Encode4(698606), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 685764 */ /*GILLT_v8s16*//*Label 8899*/ GIMT_Encode4(699821),
     /* 685768 */ // Label 8884: @685768
     /* 685768 */ GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(686386),
     /* 685773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 685776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 685779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 685782 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 685785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 685789 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(685861), // Rule ID 5016 //
     /* 685794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685805 */     // MIs[0] offset
     /* 685805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685808 */     // MIs[0] auxiliary
     /* 685808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685811 */     // MIs[0] Operand 7
     /* 685811 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685829 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 685832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685841 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685859 */     GIR_RootConstrainSelectedInstOperands,
     /* 685860 */     // GIR_Coverage, 5016,
     /* 685860 */     GIR_EraseRootFromParent_Done,
     /* 685861 */   // Label 8902: @685861
     /* 685861 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(685930), // Rule ID 5020 //
     /* 685866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 685874 */     // MIs[0] offset
     /* 685874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685877 */     // MIs[0] auxiliary
     /* 685877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685880 */     // MIs[0] Operand 7
     /* 685880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685898 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 685901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685910 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685928 */     GIR_RootConstrainSelectedInstOperands,
     /* 685929 */     // GIR_Coverage, 5020,
     /* 685929 */     GIR_EraseRootFromParent_Done,
     /* 685930 */   // Label 8903: @685930
     /* 685930 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(686000), // Rule ID 5017 //
     /* 685935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 685938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 685942 */     // MIs[0] offset
     /* 685942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 685945 */     // MIs[0] auxiliary
     /* 685945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 685948 */     // MIs[0] Operand 7
     /* 685948 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 685959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 685966 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 685966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 685969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 685971 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 685973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 685975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 685980 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 685982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 685988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 685994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 685998 */     GIR_RootConstrainSelectedInstOperands,
     /* 685999 */     // GIR_Coverage, 5017,
     /* 685999 */     GIR_EraseRootFromParent_Done,
     /* 686000 */   // Label 8904: @686000
     /* 686000 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(686067), // Rule ID 5021 //
     /* 686005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686009 */     // MIs[0] offset
     /* 686009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686012 */     // MIs[0] auxiliary
     /* 686012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686015 */     // MIs[0] Operand 7
     /* 686015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686033 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 686036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686038 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686047 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686065 */     GIR_RootConstrainSelectedInstOperands,
     /* 686066 */     // GIR_Coverage, 5021,
     /* 686066 */     GIR_EraseRootFromParent_Done,
     /* 686067 */   // Label 8905: @686067
     /* 686067 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(686129), // Rule ID 5018 //
     /* 686072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686079 */     // MIs[0] offset
     /* 686079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686082 */     // MIs[0] auxiliary
     /* 686082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686085 */     // MIs[0] Operand 7
     /* 686085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686095 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 686098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686100 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686109 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686127 */     GIR_RootConstrainSelectedInstOperands,
     /* 686128 */     // GIR_Coverage, 5018,
     /* 686128 */     GIR_EraseRootFromParent_Done,
     /* 686129 */   // Label 8906: @686129
     /* 686129 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(686188), // Rule ID 5022 //
     /* 686134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686138 */     // MIs[0] offset
     /* 686138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686141 */     // MIs[0] auxiliary
     /* 686141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686144 */     // MIs[0] Operand 7
     /* 686144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686154 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 686157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686159 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686168 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686186 */     GIR_RootConstrainSelectedInstOperands,
     /* 686187 */     // GIR_Coverage, 5022,
     /* 686187 */     GIR_EraseRootFromParent_Done,
     /* 686188 */   // Label 8907: @686188
     /* 686188 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(686288), // Rule ID 5019 //
     /* 686193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686196 */     // MIs[0] offset
     /* 686196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686199 */     // MIs[0] auxiliary
     /* 686199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686202 */     // MIs[0] Operand 7
     /* 686202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686212 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686228 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686235 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 686256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686268 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686270 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686286 */     GIR_RootConstrainSelectedInstOperands,
     /* 686287 */     // GIR_Coverage, 5019,
     /* 686287 */     GIR_EraseRootFromParent_Done,
     /* 686288 */   // Label 8908: @686288
     /* 686288 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(686385), // Rule ID 5023 //
     /* 686293 */     // MIs[0] offset
     /* 686293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686296 */     // MIs[0] auxiliary
     /* 686296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686299 */     // MIs[0] Operand 7
     /* 686299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686309 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686325 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686332 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 686353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686365 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686383 */     GIR_RootConstrainSelectedInstOperands,
     /* 686384 */     // GIR_Coverage, 5023,
     /* 686384 */     GIR_EraseRootFromParent_Done,
     /* 686385 */   // Label 8909: @686385
     /* 686385 */   GIM_Reject,
     /* 686386 */ // Label 8901: @686386
     /* 686386 */ GIM_Reject,
     /* 686387 */ // Label 8885: @686387
     /* 686387 */ GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(687005),
     /* 686392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 686395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 686398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 686401 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 686404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 686408 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(686480), // Rule ID 5024 //
     /* 686413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686424 */     // MIs[0] offset
     /* 686424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686427 */     // MIs[0] auxiliary
     /* 686427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686430 */     // MIs[0] Operand 7
     /* 686430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686448 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 686451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686460 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686478 */     GIR_RootConstrainSelectedInstOperands,
     /* 686479 */     // GIR_Coverage, 5024,
     /* 686479 */     GIR_EraseRootFromParent_Done,
     /* 686480 */   // Label 8911: @686480
     /* 686480 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(686549), // Rule ID 5028 //
     /* 686485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686493 */     // MIs[0] offset
     /* 686493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686496 */     // MIs[0] auxiliary
     /* 686496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686499 */     // MIs[0] Operand 7
     /* 686499 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686517 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 686520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686529 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686547 */     GIR_RootConstrainSelectedInstOperands,
     /* 686548 */     // GIR_Coverage, 5028,
     /* 686548 */     GIR_EraseRootFromParent_Done,
     /* 686549 */   // Label 8912: @686549
     /* 686549 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(686619), // Rule ID 5025 //
     /* 686554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686561 */     // MIs[0] offset
     /* 686561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686564 */     // MIs[0] auxiliary
     /* 686564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686567 */     // MIs[0] Operand 7
     /* 686567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686585 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 686588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686590 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686599 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686617 */     GIR_RootConstrainSelectedInstOperands,
     /* 686618 */     // GIR_Coverage, 5025,
     /* 686618 */     GIR_EraseRootFromParent_Done,
     /* 686619 */   // Label 8913: @686619
     /* 686619 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(686686), // Rule ID 5029 //
     /* 686624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 686628 */     // MIs[0] offset
     /* 686628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686631 */     // MIs[0] auxiliary
     /* 686631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686634 */     // MIs[0] Operand 7
     /* 686634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 686645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686652 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 686655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686657 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 686659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686666 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686684 */     GIR_RootConstrainSelectedInstOperands,
     /* 686685 */     // GIR_Coverage, 5029,
     /* 686685 */     GIR_EraseRootFromParent_Done,
     /* 686686 */   // Label 8914: @686686
     /* 686686 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(686748), // Rule ID 5026 //
     /* 686691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686698 */     // MIs[0] offset
     /* 686698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686701 */     // MIs[0] auxiliary
     /* 686701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686704 */     // MIs[0] Operand 7
     /* 686704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686714 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 686717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686719 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686728 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686746 */     GIR_RootConstrainSelectedInstOperands,
     /* 686747 */     // GIR_Coverage, 5026,
     /* 686747 */     GIR_EraseRootFromParent_Done,
     /* 686748 */   // Label 8915: @686748
     /* 686748 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(686807), // Rule ID 5030 //
     /* 686753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 686757 */     // MIs[0] offset
     /* 686757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686760 */     // MIs[0] auxiliary
     /* 686760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686763 */     // MIs[0] Operand 7
     /* 686763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686773 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 686776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686778 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 686780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686787 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686795 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686805 */     GIR_RootConstrainSelectedInstOperands,
     /* 686806 */     // GIR_Coverage, 5030,
     /* 686806 */     GIR_EraseRootFromParent_Done,
     /* 686807 */   // Label 8916: @686807
     /* 686807 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(686907), // Rule ID 5027 //
     /* 686812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 686815 */     // MIs[0] offset
     /* 686815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686818 */     // MIs[0] auxiliary
     /* 686818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686821 */     // MIs[0] Operand 7
     /* 686821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686831 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686847 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686854 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 686875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686887 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 686905 */     GIR_RootConstrainSelectedInstOperands,
     /* 686906 */     // GIR_Coverage, 5027,
     /* 686906 */     GIR_EraseRootFromParent_Done,
     /* 686907 */   // Label 8917: @686907
     /* 686907 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(687004), // Rule ID 5031 //
     /* 686912 */     // MIs[0] offset
     /* 686912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 686915 */     // MIs[0] auxiliary
     /* 686915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 686918 */     // MIs[0] Operand 7
     /* 686918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 686921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 686928 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 686928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 686931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 686935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 686940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 686944 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 686947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 686951 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 686954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 686959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 686969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 686972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 686974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 686977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 686979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 686984 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 686986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 686992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 686998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687002 */     GIR_RootConstrainSelectedInstOperands,
     /* 687003 */     // GIR_Coverage, 5031,
     /* 687003 */     GIR_EraseRootFromParent_Done,
     /* 687004 */   // Label 8918: @687004
     /* 687004 */   GIM_Reject,
     /* 687005 */ // Label 8910: @687005
     /* 687005 */ GIM_Reject,
     /* 687006 */ // Label 8886: @687006
     /* 687006 */ GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(687624),
     /* 687011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 687014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 687017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 687020 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 687023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 687027 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(687099), // Rule ID 4936 //
     /* 687032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687043 */     // MIs[0] offset
     /* 687043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687046 */     // MIs[0] auxiliary
     /* 687046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687049 */     // MIs[0] Operand 7
     /* 687049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687067 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 687070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687079 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687097 */     GIR_RootConstrainSelectedInstOperands,
     /* 687098 */     // GIR_Coverage, 4936,
     /* 687098 */     GIR_EraseRootFromParent_Done,
     /* 687099 */   // Label 8920: @687099
     /* 687099 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(687168), // Rule ID 4940 //
     /* 687104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687112 */     // MIs[0] offset
     /* 687112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687115 */     // MIs[0] auxiliary
     /* 687115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687118 */     // MIs[0] Operand 7
     /* 687118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687136 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 687139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687148 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687166 */     GIR_RootConstrainSelectedInstOperands,
     /* 687167 */     // GIR_Coverage, 4940,
     /* 687167 */     GIR_EraseRootFromParent_Done,
     /* 687168 */   // Label 8921: @687168
     /* 687168 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(687238), // Rule ID 4937 //
     /* 687173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687180 */     // MIs[0] offset
     /* 687180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687183 */     // MIs[0] auxiliary
     /* 687183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687186 */     // MIs[0] Operand 7
     /* 687186 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687204 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 687207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687209 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687218 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687220 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687236 */     GIR_RootConstrainSelectedInstOperands,
     /* 687237 */     // GIR_Coverage, 4937,
     /* 687237 */     GIR_EraseRootFromParent_Done,
     /* 687238 */   // Label 8922: @687238
     /* 687238 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(687305), // Rule ID 4941 //
     /* 687243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687247 */     // MIs[0] offset
     /* 687247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687250 */     // MIs[0] auxiliary
     /* 687250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687253 */     // MIs[0] Operand 7
     /* 687253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687271 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 687274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687276 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687285 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687303 */     GIR_RootConstrainSelectedInstOperands,
     /* 687304 */     // GIR_Coverage, 4941,
     /* 687304 */     GIR_EraseRootFromParent_Done,
     /* 687305 */   // Label 8923: @687305
     /* 687305 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(687367), // Rule ID 4938 //
     /* 687310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687317 */     // MIs[0] offset
     /* 687317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687320 */     // MIs[0] auxiliary
     /* 687320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687323 */     // MIs[0] Operand 7
     /* 687323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687333 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 687336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687338 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687347 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687365 */     GIR_RootConstrainSelectedInstOperands,
     /* 687366 */     // GIR_Coverage, 4938,
     /* 687366 */     GIR_EraseRootFromParent_Done,
     /* 687367 */   // Label 8924: @687367
     /* 687367 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(687426), // Rule ID 4942 //
     /* 687372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687376 */     // MIs[0] offset
     /* 687376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687379 */     // MIs[0] auxiliary
     /* 687379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687382 */     // MIs[0] Operand 7
     /* 687382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687392 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 687395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687397 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687406 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687414 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687424 */     GIR_RootConstrainSelectedInstOperands,
     /* 687425 */     // GIR_Coverage, 4942,
     /* 687425 */     GIR_EraseRootFromParent_Done,
     /* 687426 */   // Label 8925: @687426
     /* 687426 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(687526), // Rule ID 4939 //
     /* 687431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687434 */     // MIs[0] offset
     /* 687434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687437 */     // MIs[0] auxiliary
     /* 687437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687440 */     // MIs[0] Operand 7
     /* 687440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687450 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 687453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 687457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 687462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 687466 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 687469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 687473 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 687476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 687481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 687494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 687499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687506 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687524 */     GIR_RootConstrainSelectedInstOperands,
     /* 687525 */     // GIR_Coverage, 4939,
     /* 687525 */     GIR_EraseRootFromParent_Done,
     /* 687526 */   // Label 8926: @687526
     /* 687526 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(687623), // Rule ID 4943 //
     /* 687531 */     // MIs[0] offset
     /* 687531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687534 */     // MIs[0] auxiliary
     /* 687534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687537 */     // MIs[0] Operand 7
     /* 687537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687547 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 687550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 687554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 687559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 687563 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 687566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 687570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 687573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 687578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 687588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 687591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 687596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687603 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687621 */     GIR_RootConstrainSelectedInstOperands,
     /* 687622 */     // GIR_Coverage, 4943,
     /* 687622 */     GIR_EraseRootFromParent_Done,
     /* 687623 */   // Label 8927: @687623
     /* 687623 */   GIM_Reject,
     /* 687624 */ // Label 8919: @687624
     /* 687624 */ GIM_Reject,
     /* 687625 */ // Label 8887: @687625
     /* 687625 */ GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(688243),
     /* 687630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 687633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 687636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 687639 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 687642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 687646 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(687718), // Rule ID 4944 //
     /* 687651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687662 */     // MIs[0] offset
     /* 687662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687665 */     // MIs[0] auxiliary
     /* 687665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687668 */     // MIs[0] Operand 7
     /* 687668 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687686 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 687689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687698 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687716 */     GIR_RootConstrainSelectedInstOperands,
     /* 687717 */     // GIR_Coverage, 4944,
     /* 687717 */     GIR_EraseRootFromParent_Done,
     /* 687718 */   // Label 8929: @687718
     /* 687718 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(687787), // Rule ID 4948 //
     /* 687723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687731 */     // MIs[0] offset
     /* 687731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687734 */     // MIs[0] auxiliary
     /* 687734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687737 */     // MIs[0] Operand 7
     /* 687737 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687755 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 687758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687767 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687769 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687775 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687785 */     GIR_RootConstrainSelectedInstOperands,
     /* 687786 */     // GIR_Coverage, 4948,
     /* 687786 */     GIR_EraseRootFromParent_Done,
     /* 687787 */   // Label 8930: @687787
     /* 687787 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(687857), // Rule ID 4945 //
     /* 687792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687799 */     // MIs[0] offset
     /* 687799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687802 */     // MIs[0] auxiliary
     /* 687802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687805 */     // MIs[0] Operand 7
     /* 687805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687823 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 687826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687828 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687837 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687855 */     GIR_RootConstrainSelectedInstOperands,
     /* 687856 */     // GIR_Coverage, 4945,
     /* 687856 */     GIR_EraseRootFromParent_Done,
     /* 687857 */   // Label 8931: @687857
     /* 687857 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(687924), // Rule ID 4949 //
     /* 687862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 687866 */     // MIs[0] offset
     /* 687866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687869 */     // MIs[0] auxiliary
     /* 687869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687872 */     // MIs[0] Operand 7
     /* 687872 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 687883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687890 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 687893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687895 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 687897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687904 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687922 */     GIR_RootConstrainSelectedInstOperands,
     /* 687923 */     // GIR_Coverage, 4949,
     /* 687923 */     GIR_EraseRootFromParent_Done,
     /* 687924 */   // Label 8932: @687924
     /* 687924 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(687986), // Rule ID 4946 //
     /* 687929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 687932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687936 */     // MIs[0] offset
     /* 687936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687939 */     // MIs[0] auxiliary
     /* 687939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 687942 */     // MIs[0] Operand 7
     /* 687942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 687945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 687952 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 687952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 687955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 687957 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 687959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 687961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 687966 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 687968 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 687974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 687980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 687984 */     GIR_RootConstrainSelectedInstOperands,
     /* 687985 */     // GIR_Coverage, 4946,
     /* 687985 */     GIR_EraseRootFromParent_Done,
     /* 687986 */   // Label 8933: @687986
     /* 687986 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(688045), // Rule ID 4950 //
     /* 687991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 687995 */     // MIs[0] offset
     /* 687995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 687998 */     // MIs[0] auxiliary
     /* 687998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688001 */     // MIs[0] Operand 7
     /* 688001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688011 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 688014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688016 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688025 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688027 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688033 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688043 */     GIR_RootConstrainSelectedInstOperands,
     /* 688044 */     // GIR_Coverage, 4950,
     /* 688044 */     GIR_EraseRootFromParent_Done,
     /* 688045 */   // Label 8934: @688045
     /* 688045 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(688145), // Rule ID 4947 //
     /* 688050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688053 */     // MIs[0] offset
     /* 688053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688056 */     // MIs[0] auxiliary
     /* 688056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688059 */     // MIs[0] Operand 7
     /* 688059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688069 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688081 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688085 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688092 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 688113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688125 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688143 */     GIR_RootConstrainSelectedInstOperands,
     /* 688144 */     // GIR_Coverage, 4947,
     /* 688144 */     GIR_EraseRootFromParent_Done,
     /* 688145 */   // Label 8935: @688145
     /* 688145 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(688242), // Rule ID 4951 //
     /* 688150 */     // MIs[0] offset
     /* 688150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688153 */     // MIs[0] auxiliary
     /* 688153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688156 */     // MIs[0] Operand 7
     /* 688156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688166 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688182 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688189 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 688210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688222 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688224 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688240 */     GIR_RootConstrainSelectedInstOperands,
     /* 688241 */     // GIR_Coverage, 4951,
     /* 688241 */     GIR_EraseRootFromParent_Done,
     /* 688242 */   // Label 8936: @688242
     /* 688242 */   GIM_Reject,
     /* 688243 */ // Label 8928: @688243
     /* 688243 */ GIM_Reject,
     /* 688244 */ // Label 8888: @688244
     /* 688244 */ GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(688862),
     /* 688249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 688252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 688255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 688258 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 688261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 688265 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(688337), // Rule ID 5032 //
     /* 688270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688281 */     // MIs[0] offset
     /* 688281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688284 */     // MIs[0] auxiliary
     /* 688284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688287 */     // MIs[0] Operand 7
     /* 688287 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688305 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 688308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688317 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688335 */     GIR_RootConstrainSelectedInstOperands,
     /* 688336 */     // GIR_Coverage, 5032,
     /* 688336 */     GIR_EraseRootFromParent_Done,
     /* 688337 */   // Label 8938: @688337
     /* 688337 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(688406), // Rule ID 5036 //
     /* 688342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688350 */     // MIs[0] offset
     /* 688350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688353 */     // MIs[0] auxiliary
     /* 688353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688356 */     // MIs[0] Operand 7
     /* 688356 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688374 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 688377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688386 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688388 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688404 */     GIR_RootConstrainSelectedInstOperands,
     /* 688405 */     // GIR_Coverage, 5036,
     /* 688405 */     GIR_EraseRootFromParent_Done,
     /* 688406 */   // Label 8939: @688406
     /* 688406 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(688476), // Rule ID 5033 //
     /* 688411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688418 */     // MIs[0] offset
     /* 688418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688421 */     // MIs[0] auxiliary
     /* 688421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688424 */     // MIs[0] Operand 7
     /* 688424 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688442 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 688445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688447 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688456 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688458 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688474 */     GIR_RootConstrainSelectedInstOperands,
     /* 688475 */     // GIR_Coverage, 5033,
     /* 688475 */     GIR_EraseRootFromParent_Done,
     /* 688476 */   // Label 8940: @688476
     /* 688476 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(688543), // Rule ID 5037 //
     /* 688481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688485 */     // MIs[0] offset
     /* 688485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688488 */     // MIs[0] auxiliary
     /* 688488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688491 */     // MIs[0] Operand 7
     /* 688491 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688509 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 688512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688514 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 688516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688523 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688525 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688541 */     GIR_RootConstrainSelectedInstOperands,
     /* 688542 */     // GIR_Coverage, 5037,
     /* 688542 */     GIR_EraseRootFromParent_Done,
     /* 688543 */   // Label 8941: @688543
     /* 688543 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(688605), // Rule ID 5034 //
     /* 688548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688555 */     // MIs[0] offset
     /* 688555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688558 */     // MIs[0] auxiliary
     /* 688558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688561 */     // MIs[0] Operand 7
     /* 688561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688571 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 688574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688576 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688585 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688587 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688603 */     GIR_RootConstrainSelectedInstOperands,
     /* 688604 */     // GIR_Coverage, 5034,
     /* 688604 */     GIR_EraseRootFromParent_Done,
     /* 688605 */   // Label 8942: @688605
     /* 688605 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(688664), // Rule ID 5038 //
     /* 688610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688614 */     // MIs[0] offset
     /* 688614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688617 */     // MIs[0] auxiliary
     /* 688617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688620 */     // MIs[0] Operand 7
     /* 688620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688630 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 688633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688635 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 688637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688644 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688646 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688652 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688662 */     GIR_RootConstrainSelectedInstOperands,
     /* 688663 */     // GIR_Coverage, 5038,
     /* 688663 */     GIR_EraseRootFromParent_Done,
     /* 688664 */   // Label 8943: @688664
     /* 688664 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(688764), // Rule ID 5035 //
     /* 688669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688672 */     // MIs[0] offset
     /* 688672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688675 */     // MIs[0] auxiliary
     /* 688675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688678 */     // MIs[0] Operand 7
     /* 688678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688688 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688704 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688711 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 688732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688744 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688762 */     GIR_RootConstrainSelectedInstOperands,
     /* 688763 */     // GIR_Coverage, 5035,
     /* 688763 */     GIR_EraseRootFromParent_Done,
     /* 688764 */   // Label 8944: @688764
     /* 688764 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(688861), // Rule ID 5039 //
     /* 688769 */     // MIs[0] offset
     /* 688769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688772 */     // MIs[0] auxiliary
     /* 688772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688775 */     // MIs[0] Operand 7
     /* 688775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 688778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688785 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 688788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 688792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 688797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 688801 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 688804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 688808 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 688811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 688816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 688826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 688829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 688834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688841 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688859 */     GIR_RootConstrainSelectedInstOperands,
     /* 688860 */     // GIR_Coverage, 5039,
     /* 688860 */     GIR_EraseRootFromParent_Done,
     /* 688861 */   // Label 8945: @688861
     /* 688861 */   GIM_Reject,
     /* 688862 */ // Label 8937: @688862
     /* 688862 */ GIM_Reject,
     /* 688863 */ // Label 8889: @688863
     /* 688863 */ GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(689481),
     /* 688868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 688871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 688874 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 688877 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 688880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 688884 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(688956), // Rule ID 4952 //
     /* 688889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 688892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688900 */     // MIs[0] offset
     /* 688900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688903 */     // MIs[0] auxiliary
     /* 688903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688906 */     // MIs[0] Operand 7
     /* 688906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688924 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 688927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 688931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 688936 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 688938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 688944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 688950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 688954 */     GIR_RootConstrainSelectedInstOperands,
     /* 688955 */     // GIR_Coverage, 4952,
     /* 688955 */     GIR_EraseRootFromParent_Done,
     /* 688956 */   // Label 8947: @688956
     /* 688956 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(689025), // Rule ID 4956 //
     /* 688961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 688965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 688969 */     // MIs[0] offset
     /* 688969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 688972 */     // MIs[0] auxiliary
     /* 688972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 688975 */     // MIs[0] Operand 7
     /* 688975 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 688986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 688993 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 688993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 688996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 688998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689005 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689007 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689023 */     GIR_RootConstrainSelectedInstOperands,
     /* 689024 */     // GIR_Coverage, 4956,
     /* 689024 */     GIR_EraseRootFromParent_Done,
     /* 689025 */   // Label 8948: @689025
     /* 689025 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(689095), // Rule ID 4953 //
     /* 689030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689037 */     // MIs[0] offset
     /* 689037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689040 */     // MIs[0] auxiliary
     /* 689040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689043 */     // MIs[0] Operand 7
     /* 689043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689061 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 689064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689066 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689075 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689093 */     GIR_RootConstrainSelectedInstOperands,
     /* 689094 */     // GIR_Coverage, 4953,
     /* 689094 */     GIR_EraseRootFromParent_Done,
     /* 689095 */   // Label 8949: @689095
     /* 689095 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(689162), // Rule ID 4957 //
     /* 689100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689104 */     // MIs[0] offset
     /* 689104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689107 */     // MIs[0] auxiliary
     /* 689107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689110 */     // MIs[0] Operand 7
     /* 689110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689128 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 689131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689133 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689142 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689160 */     GIR_RootConstrainSelectedInstOperands,
     /* 689161 */     // GIR_Coverage, 4957,
     /* 689161 */     GIR_EraseRootFromParent_Done,
     /* 689162 */   // Label 8950: @689162
     /* 689162 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(689224), // Rule ID 4954 //
     /* 689167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689174 */     // MIs[0] offset
     /* 689174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689177 */     // MIs[0] auxiliary
     /* 689177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689180 */     // MIs[0] Operand 7
     /* 689180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689190 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 689193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689195 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689204 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689222 */     GIR_RootConstrainSelectedInstOperands,
     /* 689223 */     // GIR_Coverage, 4954,
     /* 689223 */     GIR_EraseRootFromParent_Done,
     /* 689224 */   // Label 8951: @689224
     /* 689224 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(689283), // Rule ID 4958 //
     /* 689229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689233 */     // MIs[0] offset
     /* 689233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689236 */     // MIs[0] auxiliary
     /* 689236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689239 */     // MIs[0] Operand 7
     /* 689239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689249 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 689252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689254 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689263 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689281 */     GIR_RootConstrainSelectedInstOperands,
     /* 689282 */     // GIR_Coverage, 4958,
     /* 689282 */     GIR_EraseRootFromParent_Done,
     /* 689283 */   // Label 8952: @689283
     /* 689283 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(689383), // Rule ID 4955 //
     /* 689288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689291 */     // MIs[0] offset
     /* 689291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689294 */     // MIs[0] auxiliary
     /* 689294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689297 */     // MIs[0] Operand 7
     /* 689297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689307 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689323 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689330 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 689351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689363 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689381 */     GIR_RootConstrainSelectedInstOperands,
     /* 689382 */     // GIR_Coverage, 4955,
     /* 689382 */     GIR_EraseRootFromParent_Done,
     /* 689383 */   // Label 8953: @689383
     /* 689383 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(689480), // Rule ID 4959 //
     /* 689388 */     // MIs[0] offset
     /* 689388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689391 */     // MIs[0] auxiliary
     /* 689391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689394 */     // MIs[0] Operand 7
     /* 689394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689404 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689420 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689427 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 689448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689460 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689478 */     GIR_RootConstrainSelectedInstOperands,
     /* 689479 */     // GIR_Coverage, 4959,
     /* 689479 */     GIR_EraseRootFromParent_Done,
     /* 689480 */   // Label 8954: @689480
     /* 689480 */   GIM_Reject,
     /* 689481 */ // Label 8946: @689481
     /* 689481 */ GIM_Reject,
     /* 689482 */ // Label 8890: @689482
     /* 689482 */ GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(690100),
     /* 689487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 689490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 689493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 689496 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 689499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 689503 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(689575), // Rule ID 4960 //
     /* 689508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689519 */     // MIs[0] offset
     /* 689519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689522 */     // MIs[0] auxiliary
     /* 689522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689525 */     // MIs[0] Operand 7
     /* 689525 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689543 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 689546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689555 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689563 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689573 */     GIR_RootConstrainSelectedInstOperands,
     /* 689574 */     // GIR_Coverage, 4960,
     /* 689574 */     GIR_EraseRootFromParent_Done,
     /* 689575 */   // Label 8956: @689575
     /* 689575 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(689644), // Rule ID 4964 //
     /* 689580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689588 */     // MIs[0] offset
     /* 689588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689591 */     // MIs[0] auxiliary
     /* 689591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689594 */     // MIs[0] Operand 7
     /* 689594 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689612 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 689615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689624 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689632 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689642 */     GIR_RootConstrainSelectedInstOperands,
     /* 689643 */     // GIR_Coverage, 4964,
     /* 689643 */     GIR_EraseRootFromParent_Done,
     /* 689644 */   // Label 8957: @689644
     /* 689644 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(689714), // Rule ID 4961 //
     /* 689649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689656 */     // MIs[0] offset
     /* 689656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689659 */     // MIs[0] auxiliary
     /* 689659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689662 */     // MIs[0] Operand 7
     /* 689662 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689680 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 689683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689685 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689694 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689696 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689702 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689712 */     GIR_RootConstrainSelectedInstOperands,
     /* 689713 */     // GIR_Coverage, 4961,
     /* 689713 */     GIR_EraseRootFromParent_Done,
     /* 689714 */   // Label 8958: @689714
     /* 689714 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(689781), // Rule ID 4965 //
     /* 689719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 689723 */     // MIs[0] offset
     /* 689723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689726 */     // MIs[0] auxiliary
     /* 689726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689729 */     // MIs[0] Operand 7
     /* 689729 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 689740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689747 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 689750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689752 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 689754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689761 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689763 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689769 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689779 */     GIR_RootConstrainSelectedInstOperands,
     /* 689780 */     // GIR_Coverage, 4965,
     /* 689780 */     GIR_EraseRootFromParent_Done,
     /* 689781 */   // Label 8959: @689781
     /* 689781 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(689843), // Rule ID 4962 //
     /* 689786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689793 */     // MIs[0] offset
     /* 689793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689796 */     // MIs[0] auxiliary
     /* 689796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689799 */     // MIs[0] Operand 7
     /* 689799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689809 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 689812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689814 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689823 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689825 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689841 */     GIR_RootConstrainSelectedInstOperands,
     /* 689842 */     // GIR_Coverage, 4962,
     /* 689842 */     GIR_EraseRootFromParent_Done,
     /* 689843 */   // Label 8960: @689843
     /* 689843 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(689902), // Rule ID 4966 //
     /* 689848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 689852 */     // MIs[0] offset
     /* 689852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689855 */     // MIs[0] auxiliary
     /* 689855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689858 */     // MIs[0] Operand 7
     /* 689858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689868 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 689871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689873 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 689875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689882 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 689900 */     GIR_RootConstrainSelectedInstOperands,
     /* 689901 */     // GIR_Coverage, 4966,
     /* 689901 */     GIR_EraseRootFromParent_Done,
     /* 689902 */   // Label 8961: @689902
     /* 689902 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(690002), // Rule ID 4963 //
     /* 689907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 689910 */     // MIs[0] offset
     /* 689910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 689913 */     // MIs[0] auxiliary
     /* 689913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 689916 */     // MIs[0] Operand 7
     /* 689916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 689919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 689926 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 689926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 689929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 689933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 689938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 689942 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 689945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 689949 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 689952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 689957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 689967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 689970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 689972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 689975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 689977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 689982 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 689984 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 689990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 689996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690000 */     GIR_RootConstrainSelectedInstOperands,
     /* 690001 */     // GIR_Coverage, 4963,
     /* 690001 */     GIR_EraseRootFromParent_Done,
     /* 690002 */   // Label 8962: @690002
     /* 690002 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(690099), // Rule ID 4967 //
     /* 690007 */     // MIs[0] offset
     /* 690007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690010 */     // MIs[0] auxiliary
     /* 690010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690013 */     // MIs[0] Operand 7
     /* 690013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690023 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690039 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690046 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 690067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690079 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690097 */     GIR_RootConstrainSelectedInstOperands,
     /* 690098 */     // GIR_Coverage, 4967,
     /* 690098 */     GIR_EraseRootFromParent_Done,
     /* 690099 */   // Label 8963: @690099
     /* 690099 */   GIM_Reject,
     /* 690100 */ // Label 8955: @690100
     /* 690100 */ GIM_Reject,
     /* 690101 */ // Label 8891: @690101
     /* 690101 */ GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(691315),
     /* 690106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 690109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 690112 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 690115 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 690118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 690122 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(690194), // Rule ID 4904 //
     /* 690127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690138 */     // MIs[0] offset
     /* 690138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690141 */     // MIs[0] auxiliary
     /* 690141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690144 */     // MIs[0] Operand 7
     /* 690144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690162 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 690165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690174 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690192 */     GIR_RootConstrainSelectedInstOperands,
     /* 690193 */     // GIR_Coverage, 4904,
     /* 690193 */     GIR_EraseRootFromParent_Done,
     /* 690194 */   // Label 8965: @690194
     /* 690194 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(690263), // Rule ID 4908 //
     /* 690199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690207 */     // MIs[0] offset
     /* 690207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690210 */     // MIs[0] auxiliary
     /* 690210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690213 */     // MIs[0] Operand 7
     /* 690213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690231 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 690234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690243 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690261 */     GIR_RootConstrainSelectedInstOperands,
     /* 690262 */     // GIR_Coverage, 4908,
     /* 690262 */     GIR_EraseRootFromParent_Done,
     /* 690263 */   // Label 8966: @690263
     /* 690263 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(690335), // Rule ID 4912 //
     /* 690268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690279 */     // MIs[0] offset
     /* 690279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690282 */     // MIs[0] auxiliary
     /* 690282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690285 */     // MIs[0] Operand 7
     /* 690285 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690303 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 690306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690315 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690317 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690323 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690333 */     GIR_RootConstrainSelectedInstOperands,
     /* 690334 */     // GIR_Coverage, 4912,
     /* 690334 */     GIR_EraseRootFromParent_Done,
     /* 690335 */   // Label 8967: @690335
     /* 690335 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(690404), // Rule ID 4916 //
     /* 690340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690348 */     // MIs[0] offset
     /* 690348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690351 */     // MIs[0] auxiliary
     /* 690351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690354 */     // MIs[0] Operand 7
     /* 690354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690372 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 690375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690384 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690402 */     GIR_RootConstrainSelectedInstOperands,
     /* 690403 */     // GIR_Coverage, 4916,
     /* 690403 */     GIR_EraseRootFromParent_Done,
     /* 690404 */   // Label 8968: @690404
     /* 690404 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(690474), // Rule ID 4905 //
     /* 690409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690416 */     // MIs[0] offset
     /* 690416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690419 */     // MIs[0] auxiliary
     /* 690419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690422 */     // MIs[0] Operand 7
     /* 690422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690440 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 690443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690445 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690454 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690472 */     GIR_RootConstrainSelectedInstOperands,
     /* 690473 */     // GIR_Coverage, 4905,
     /* 690473 */     GIR_EraseRootFromParent_Done,
     /* 690474 */   // Label 8969: @690474
     /* 690474 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(690541), // Rule ID 4909 //
     /* 690479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690483 */     // MIs[0] offset
     /* 690483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690486 */     // MIs[0] auxiliary
     /* 690486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690489 */     // MIs[0] Operand 7
     /* 690489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690507 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 690510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690512 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690521 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690523 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690539 */     GIR_RootConstrainSelectedInstOperands,
     /* 690540 */     // GIR_Coverage, 4909,
     /* 690540 */     GIR_EraseRootFromParent_Done,
     /* 690541 */   // Label 8970: @690541
     /* 690541 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(690611), // Rule ID 4913 //
     /* 690546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690553 */     // MIs[0] offset
     /* 690553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690556 */     // MIs[0] auxiliary
     /* 690556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690559 */     // MIs[0] Operand 7
     /* 690559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690577 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 690580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690582 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690609 */     GIR_RootConstrainSelectedInstOperands,
     /* 690610 */     // GIR_Coverage, 4913,
     /* 690610 */     GIR_EraseRootFromParent_Done,
     /* 690611 */   // Label 8971: @690611
     /* 690611 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(690678), // Rule ID 4917 //
     /* 690616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 690620 */     // MIs[0] offset
     /* 690620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690623 */     // MIs[0] auxiliary
     /* 690623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690626 */     // MIs[0] Operand 7
     /* 690626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 690637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690644 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 690647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690649 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 690651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690658 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690676 */     GIR_RootConstrainSelectedInstOperands,
     /* 690677 */     // GIR_Coverage, 4917,
     /* 690677 */     GIR_EraseRootFromParent_Done,
     /* 690678 */   // Label 8972: @690678
     /* 690678 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(690740), // Rule ID 4906 //
     /* 690683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690690 */     // MIs[0] offset
     /* 690690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690693 */     // MIs[0] auxiliary
     /* 690693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690696 */     // MIs[0] Operand 7
     /* 690696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690706 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 690709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690711 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690720 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690738 */     GIR_RootConstrainSelectedInstOperands,
     /* 690739 */     // GIR_Coverage, 4906,
     /* 690739 */     GIR_EraseRootFromParent_Done,
     /* 690740 */   // Label 8973: @690740
     /* 690740 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(690799), // Rule ID 4910 //
     /* 690745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690749 */     // MIs[0] offset
     /* 690749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690752 */     // MIs[0] auxiliary
     /* 690752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690755 */     // MIs[0] Operand 7
     /* 690755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690765 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 690768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690770 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690779 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690797 */     GIR_RootConstrainSelectedInstOperands,
     /* 690798 */     // GIR_Coverage, 4910,
     /* 690798 */     GIR_EraseRootFromParent_Done,
     /* 690799 */   // Label 8974: @690799
     /* 690799 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(690861), // Rule ID 4914 //
     /* 690804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690811 */     // MIs[0] offset
     /* 690811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690814 */     // MIs[0] auxiliary
     /* 690814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690817 */     // MIs[0] Operand 7
     /* 690817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690827 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 690830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690832 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690841 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690859 */     GIR_RootConstrainSelectedInstOperands,
     /* 690860 */     // GIR_Coverage, 4914,
     /* 690860 */     GIR_EraseRootFromParent_Done,
     /* 690861 */   // Label 8975: @690861
     /* 690861 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(690920), // Rule ID 4918 //
     /* 690866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 690870 */     // MIs[0] offset
     /* 690870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690873 */     // MIs[0] auxiliary
     /* 690873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690876 */     // MIs[0] Operand 7
     /* 690876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690886 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 690889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690891 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 690893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 690900 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 690902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 690908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 690914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 690918 */     GIR_RootConstrainSelectedInstOperands,
     /* 690919 */     // GIR_Coverage, 4918,
     /* 690919 */     GIR_EraseRootFromParent_Done,
     /* 690920 */   // Label 8976: @690920
     /* 690920 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(691020), // Rule ID 4907 //
     /* 690925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 690928 */     // MIs[0] offset
     /* 690928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 690931 */     // MIs[0] auxiliary
     /* 690931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 690934 */     // MIs[0] Operand 7
     /* 690934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 690937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 690944 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 690944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 690947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 690951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 690956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 690960 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 690963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 690967 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 690970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 690975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 690985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 690988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 690990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 690993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 690995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691000 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691018 */     GIR_RootConstrainSelectedInstOperands,
     /* 691019 */     // GIR_Coverage, 4907,
     /* 691019 */     GIR_EraseRootFromParent_Done,
     /* 691020 */   // Label 8977: @691020
     /* 691020 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(691117), // Rule ID 4911 //
     /* 691025 */     // MIs[0] offset
     /* 691025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691028 */     // MIs[0] auxiliary
     /* 691028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691031 */     // MIs[0] Operand 7
     /* 691031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691041 */     // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691057 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691064 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 691085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691097 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691115 */     GIR_RootConstrainSelectedInstOperands,
     /* 691116 */     // GIR_Coverage, 4911,
     /* 691116 */     GIR_EraseRootFromParent_Done,
     /* 691117 */   // Label 8978: @691117
     /* 691117 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(691217), // Rule ID 4915 //
     /* 691122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691125 */     // MIs[0] offset
     /* 691125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691128 */     // MIs[0] auxiliary
     /* 691128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691131 */     // MIs[0] Operand 7
     /* 691131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691141 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691157 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691164 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 691185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691197 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691205 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691215 */     GIR_RootConstrainSelectedInstOperands,
     /* 691216 */     // GIR_Coverage, 4915,
     /* 691216 */     GIR_EraseRootFromParent_Done,
     /* 691217 */   // Label 8979: @691217
     /* 691217 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(691314), // Rule ID 4919 //
     /* 691222 */     // MIs[0] offset
     /* 691222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691225 */     // MIs[0] auxiliary
     /* 691225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691228 */     // MIs[0] Operand 7
     /* 691228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691238 */     // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 691241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 691245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 691250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 691254 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 691257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 691261 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 691264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 691269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 691279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 691282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 691287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691294 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691296 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691302 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691312 */     GIR_RootConstrainSelectedInstOperands,
     /* 691313 */     // GIR_Coverage, 4919,
     /* 691313 */     GIR_EraseRootFromParent_Done,
     /* 691314 */   // Label 8980: @691314
     /* 691314 */   GIM_Reject,
     /* 691315 */ // Label 8964: @691315
     /* 691315 */ GIM_Reject,
     /* 691316 */ // Label 8892: @691316
     /* 691316 */ GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(692530),
     /* 691321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 691324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 691327 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 691330 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 691333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 691337 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(691409), // Rule ID 4968 //
     /* 691342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691353 */     // MIs[0] offset
     /* 691353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691356 */     // MIs[0] auxiliary
     /* 691356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691359 */     // MIs[0] Operand 7
     /* 691359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691377 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 691380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691389 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691407 */     GIR_RootConstrainSelectedInstOperands,
     /* 691408 */     // GIR_Coverage, 4968,
     /* 691408 */     GIR_EraseRootFromParent_Done,
     /* 691409 */   // Label 8982: @691409
     /* 691409 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(691478), // Rule ID 4972 //
     /* 691414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691422 */     // MIs[0] offset
     /* 691422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691425 */     // MIs[0] auxiliary
     /* 691425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691428 */     // MIs[0] Operand 7
     /* 691428 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691446 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 691449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691458 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691460 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691476 */     GIR_RootConstrainSelectedInstOperands,
     /* 691477 */     // GIR_Coverage, 4972,
     /* 691477 */     GIR_EraseRootFromParent_Done,
     /* 691478 */   // Label 8983: @691478
     /* 691478 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(691550), // Rule ID 4976 //
     /* 691483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691494 */     // MIs[0] offset
     /* 691494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691497 */     // MIs[0] auxiliary
     /* 691497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691500 */     // MIs[0] Operand 7
     /* 691500 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691518 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 691521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691530 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691538 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691548 */     GIR_RootConstrainSelectedInstOperands,
     /* 691549 */     // GIR_Coverage, 4976,
     /* 691549 */     GIR_EraseRootFromParent_Done,
     /* 691550 */   // Label 8984: @691550
     /* 691550 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(691619), // Rule ID 4980 //
     /* 691555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691563 */     // MIs[0] offset
     /* 691563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691566 */     // MIs[0] auxiliary
     /* 691566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691569 */     // MIs[0] Operand 7
     /* 691569 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691587 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 691590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691599 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691601 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691617 */     GIR_RootConstrainSelectedInstOperands,
     /* 691618 */     // GIR_Coverage, 4980,
     /* 691618 */     GIR_EraseRootFromParent_Done,
     /* 691619 */   // Label 8985: @691619
     /* 691619 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(691689), // Rule ID 4969 //
     /* 691624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691631 */     // MIs[0] offset
     /* 691631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691634 */     // MIs[0] auxiliary
     /* 691634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691637 */     // MIs[0] Operand 7
     /* 691637 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691655 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 691658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691660 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691669 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691677 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691687 */     GIR_RootConstrainSelectedInstOperands,
     /* 691688 */     // GIR_Coverage, 4969,
     /* 691688 */     GIR_EraseRootFromParent_Done,
     /* 691689 */   // Label 8986: @691689
     /* 691689 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(691756), // Rule ID 4973 //
     /* 691694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691698 */     // MIs[0] offset
     /* 691698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691701 */     // MIs[0] auxiliary
     /* 691701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691704 */     // MIs[0] Operand 7
     /* 691704 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691722 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 691725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691727 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691736 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691754 */     GIR_RootConstrainSelectedInstOperands,
     /* 691755 */     // GIR_Coverage, 4973,
     /* 691755 */     GIR_EraseRootFromParent_Done,
     /* 691756 */   // Label 8987: @691756
     /* 691756 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(691826), // Rule ID 4977 //
     /* 691761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691768 */     // MIs[0] offset
     /* 691768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691771 */     // MIs[0] auxiliary
     /* 691771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691774 */     // MIs[0] Operand 7
     /* 691774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691792 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 691795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691797 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691806 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691824 */     GIR_RootConstrainSelectedInstOperands,
     /* 691825 */     // GIR_Coverage, 4977,
     /* 691825 */     GIR_EraseRootFromParent_Done,
     /* 691826 */   // Label 8988: @691826
     /* 691826 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(691893), // Rule ID 4981 //
     /* 691831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 691835 */     // MIs[0] offset
     /* 691835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691838 */     // MIs[0] auxiliary
     /* 691838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691841 */     // MIs[0] Operand 7
     /* 691841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 691852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691859 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 691862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691864 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 691866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691873 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691891 */     GIR_RootConstrainSelectedInstOperands,
     /* 691892 */     // GIR_Coverage, 4981,
     /* 691892 */     GIR_EraseRootFromParent_Done,
     /* 691893 */   // Label 8989: @691893
     /* 691893 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(691955), // Rule ID 4970 //
     /* 691898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 691901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691905 */     // MIs[0] offset
     /* 691905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691908 */     // MIs[0] auxiliary
     /* 691908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691911 */     // MIs[0] Operand 7
     /* 691911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691921 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 691924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691926 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691935 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 691943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 691949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 691953 */     GIR_RootConstrainSelectedInstOperands,
     /* 691954 */     // GIR_Coverage, 4970,
     /* 691954 */     GIR_EraseRootFromParent_Done,
     /* 691955 */   // Label 8990: @691955
     /* 691955 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(692014), // Rule ID 4974 //
     /* 691960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 691964 */     // MIs[0] offset
     /* 691964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 691967 */     // MIs[0] auxiliary
     /* 691967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 691970 */     // MIs[0] Operand 7
     /* 691970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 691973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 691980 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 691980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 691983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 691985 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 691987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 691989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 691994 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 691996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692012 */     GIR_RootConstrainSelectedInstOperands,
     /* 692013 */     // GIR_Coverage, 4974,
     /* 692013 */     GIR_EraseRootFromParent_Done,
     /* 692014 */   // Label 8991: @692014
     /* 692014 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(692076), // Rule ID 4978 //
     /* 692019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692026 */     // MIs[0] offset
     /* 692026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692029 */     // MIs[0] auxiliary
     /* 692029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692032 */     // MIs[0] Operand 7
     /* 692032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692042 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 692045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692047 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692056 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692058 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692074 */     GIR_RootConstrainSelectedInstOperands,
     /* 692075 */     // GIR_Coverage, 4978,
     /* 692075 */     GIR_EraseRootFromParent_Done,
     /* 692076 */   // Label 8992: @692076
     /* 692076 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(692135), // Rule ID 4982 //
     /* 692081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692085 */     // MIs[0] offset
     /* 692085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692088 */     // MIs[0] auxiliary
     /* 692088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692091 */     // MIs[0] Operand 7
     /* 692091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692101 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 692104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692106 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 692108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692115 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692123 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692133 */     GIR_RootConstrainSelectedInstOperands,
     /* 692134 */     // GIR_Coverage, 4982,
     /* 692134 */     GIR_EraseRootFromParent_Done,
     /* 692135 */   // Label 8993: @692135
     /* 692135 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(692235), // Rule ID 4971 //
     /* 692140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692143 */     // MIs[0] offset
     /* 692143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692146 */     // MIs[0] auxiliary
     /* 692146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692149 */     // MIs[0] Operand 7
     /* 692149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692159 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692175 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692182 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 692203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692215 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692217 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692233 */     GIR_RootConstrainSelectedInstOperands,
     /* 692234 */     // GIR_Coverage, 4971,
     /* 692234 */     GIR_EraseRootFromParent_Done,
     /* 692235 */   // Label 8994: @692235
     /* 692235 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(692332), // Rule ID 4975 //
     /* 692240 */     // MIs[0] offset
     /* 692240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692243 */     // MIs[0] auxiliary
     /* 692243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692246 */     // MIs[0] Operand 7
     /* 692246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692256 */     // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692272 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692279 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 692300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692312 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692330 */     GIR_RootConstrainSelectedInstOperands,
     /* 692331 */     // GIR_Coverage, 4975,
     /* 692331 */     GIR_EraseRootFromParent_Done,
     /* 692332 */   // Label 8995: @692332
     /* 692332 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(692432), // Rule ID 4979 //
     /* 692337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692340 */     // MIs[0] offset
     /* 692340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692343 */     // MIs[0] auxiliary
     /* 692343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692346 */     // MIs[0] Operand 7
     /* 692346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692356 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692372 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692375 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692379 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 692400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692412 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692414 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692420 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692430 */     GIR_RootConstrainSelectedInstOperands,
     /* 692431 */     // GIR_Coverage, 4979,
     /* 692431 */     GIR_EraseRootFromParent_Done,
     /* 692432 */   // Label 8996: @692432
     /* 692432 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(692529), // Rule ID 4983 //
     /* 692437 */     // MIs[0] offset
     /* 692437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692440 */     // MIs[0] auxiliary
     /* 692440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692443 */     // MIs[0] Operand 7
     /* 692443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 692446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692453 */     // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 692456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 692460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 692465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 692469 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 692472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 692476 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 692479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 692484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 692494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 692497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 692502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692509 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692517 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692527 */     GIR_RootConstrainSelectedInstOperands,
     /* 692528 */     // GIR_Coverage, 4983,
     /* 692528 */     GIR_EraseRootFromParent_Done,
     /* 692529 */   // Label 8997: @692529
     /* 692529 */   GIM_Reject,
     /* 692530 */ // Label 8981: @692530
     /* 692530 */ GIM_Reject,
     /* 692531 */ // Label 8893: @692531
     /* 692531 */ GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(693745),
     /* 692536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 692539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 692542 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 692545 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 692548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 692552 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(692624), // Rule ID 4920 //
     /* 692557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692568 */     // MIs[0] offset
     /* 692568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692571 */     // MIs[0] auxiliary
     /* 692571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692574 */     // MIs[0] Operand 7
     /* 692574 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692592 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 692595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692604 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692622 */     GIR_RootConstrainSelectedInstOperands,
     /* 692623 */     // GIR_Coverage, 4920,
     /* 692623 */     GIR_EraseRootFromParent_Done,
     /* 692624 */   // Label 8999: @692624
     /* 692624 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(692693), // Rule ID 4924 //
     /* 692629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692637 */     // MIs[0] offset
     /* 692637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692640 */     // MIs[0] auxiliary
     /* 692640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692643 */     // MIs[0] Operand 7
     /* 692643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692661 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 692664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692673 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692691 */     GIR_RootConstrainSelectedInstOperands,
     /* 692692 */     // GIR_Coverage, 4924,
     /* 692692 */     GIR_EraseRootFromParent_Done,
     /* 692693 */   // Label 9000: @692693
     /* 692693 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(692765), // Rule ID 4928 //
     /* 692698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692709 */     // MIs[0] offset
     /* 692709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692712 */     // MIs[0] auxiliary
     /* 692712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692715 */     // MIs[0] Operand 7
     /* 692715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692733 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
     /* 692736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692745 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692747 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692763 */     GIR_RootConstrainSelectedInstOperands,
     /* 692764 */     // GIR_Coverage, 4928,
     /* 692764 */     GIR_EraseRootFromParent_Done,
     /* 692765 */   // Label 9001: @692765
     /* 692765 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(692834), // Rule ID 4932 //
     /* 692770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 692778 */     // MIs[0] offset
     /* 692778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692781 */     // MIs[0] auxiliary
     /* 692781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692784 */     // MIs[0] Operand 7
     /* 692784 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692802 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
     /* 692805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692814 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692832 */     GIR_RootConstrainSelectedInstOperands,
     /* 692833 */     // GIR_Coverage, 4932,
     /* 692833 */     GIR_EraseRootFromParent_Done,
     /* 692834 */   // Label 9002: @692834
     /* 692834 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(692904), // Rule ID 4921 //
     /* 692839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692846 */     // MIs[0] offset
     /* 692846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692849 */     // MIs[0] auxiliary
     /* 692849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692852 */     // MIs[0] Operand 7
     /* 692852 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692870 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 692873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692875 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692902 */     GIR_RootConstrainSelectedInstOperands,
     /* 692903 */     // GIR_Coverage, 4921,
     /* 692903 */     GIR_EraseRootFromParent_Done,
     /* 692904 */   // Label 9003: @692904
     /* 692904 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(692971), // Rule ID 4925 //
     /* 692909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692913 */     // MIs[0] offset
     /* 692913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692916 */     // MIs[0] auxiliary
     /* 692916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692919 */     // MIs[0] Operand 7
     /* 692919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 692930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 692937 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 692937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 692940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 692942 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 692944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 692946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 692951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 692953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 692959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 692965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 692969 */     GIR_RootConstrainSelectedInstOperands,
     /* 692970 */     // GIR_Coverage, 4925,
     /* 692970 */     GIR_EraseRootFromParent_Done,
     /* 692971 */   // Label 9004: @692971
     /* 692971 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(693041), // Rule ID 4929 //
     /* 692976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 692979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 692983 */     // MIs[0] offset
     /* 692983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 692986 */     // MIs[0] auxiliary
     /* 692986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 692989 */     // MIs[0] Operand 7
     /* 692989 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693007 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
     /* 693010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693012 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693021 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693039 */     GIR_RootConstrainSelectedInstOperands,
     /* 693040 */     // GIR_Coverage, 4929,
     /* 693040 */     GIR_EraseRootFromParent_Done,
     /* 693041 */   // Label 9005: @693041
     /* 693041 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(693108), // Rule ID 4933 //
     /* 693046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693050 */     // MIs[0] offset
     /* 693050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693053 */     // MIs[0] auxiliary
     /* 693053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693056 */     // MIs[0] Operand 7
     /* 693056 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693074 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
     /* 693077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693079 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 693081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693088 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693096 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693106 */     GIR_RootConstrainSelectedInstOperands,
     /* 693107 */     // GIR_Coverage, 4933,
     /* 693107 */     GIR_EraseRootFromParent_Done,
     /* 693108 */   // Label 9006: @693108
     /* 693108 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(693170), // Rule ID 4922 //
     /* 693113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693120 */     // MIs[0] offset
     /* 693120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693123 */     // MIs[0] auxiliary
     /* 693123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693126 */     // MIs[0] Operand 7
     /* 693126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693136 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 693139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693141 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693150 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693168 */     GIR_RootConstrainSelectedInstOperands,
     /* 693169 */     // GIR_Coverage, 4922,
     /* 693169 */     GIR_EraseRootFromParent_Done,
     /* 693170 */   // Label 9007: @693170
     /* 693170 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(693229), // Rule ID 4926 //
     /* 693175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693179 */     // MIs[0] offset
     /* 693179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693182 */     // MIs[0] auxiliary
     /* 693182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693185 */     // MIs[0] Operand 7
     /* 693185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693195 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 693198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693200 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693209 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693217 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693227 */     GIR_RootConstrainSelectedInstOperands,
     /* 693228 */     // GIR_Coverage, 4926,
     /* 693228 */     GIR_EraseRootFromParent_Done,
     /* 693229 */   // Label 9008: @693229
     /* 693229 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(693291), // Rule ID 4930 //
     /* 693234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693241 */     // MIs[0] offset
     /* 693241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693244 */     // MIs[0] auxiliary
     /* 693244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693247 */     // MIs[0] Operand 7
     /* 693247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693257 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
     /* 693260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693262 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693271 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693289 */     GIR_RootConstrainSelectedInstOperands,
     /* 693290 */     // GIR_Coverage, 4930,
     /* 693290 */     GIR_EraseRootFromParent_Done,
     /* 693291 */   // Label 9009: @693291
     /* 693291 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(693350), // Rule ID 4934 //
     /* 693296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693300 */     // MIs[0] offset
     /* 693300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693303 */     // MIs[0] auxiliary
     /* 693303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693306 */     // MIs[0] Operand 7
     /* 693306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693316 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
     /* 693319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693321 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 693323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693330 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693348 */     GIR_RootConstrainSelectedInstOperands,
     /* 693349 */     // GIR_Coverage, 4934,
     /* 693349 */     GIR_EraseRootFromParent_Done,
     /* 693350 */   // Label 9010: @693350
     /* 693350 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(693450), // Rule ID 4923 //
     /* 693355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693358 */     // MIs[0] offset
     /* 693358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693361 */     // MIs[0] auxiliary
     /* 693361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693364 */     // MIs[0] Operand 7
     /* 693364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693374 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693390 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693397 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 693418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693430 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693448 */     GIR_RootConstrainSelectedInstOperands,
     /* 693449 */     // GIR_Coverage, 4923,
     /* 693449 */     GIR_EraseRootFromParent_Done,
     /* 693450 */   // Label 9011: @693450
     /* 693450 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(693547), // Rule ID 4927 //
     /* 693455 */     // MIs[0] offset
     /* 693455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693458 */     // MIs[0] auxiliary
     /* 693458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693461 */     // MIs[0] Operand 7
     /* 693461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693471 */     // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693487 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693494 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 693515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693527 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693545 */     GIR_RootConstrainSelectedInstOperands,
     /* 693546 */     // GIR_Coverage, 4927,
     /* 693546 */     GIR_EraseRootFromParent_Done,
     /* 693547 */   // Label 9012: @693547
     /* 693547 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(693647), // Rule ID 4931 //
     /* 693552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693555 */     // MIs[0] offset
     /* 693555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693558 */     // MIs[0] auxiliary
     /* 693558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693561 */     // MIs[0] Operand 7
     /* 693561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693571 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693587 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693594 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
     /* 693615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693627 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693645 */     GIR_RootConstrainSelectedInstOperands,
     /* 693646 */     // GIR_Coverage, 4931,
     /* 693646 */     GIR_EraseRootFromParent_Done,
     /* 693647 */   // Label 9013: @693647
     /* 693647 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(693744), // Rule ID 4935 //
     /* 693652 */     // MIs[0] offset
     /* 693652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693655 */     // MIs[0] auxiliary
     /* 693655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693658 */     // MIs[0] Operand 7
     /* 693658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 693661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693668 */     // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 693671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 693675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 693680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 693684 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 693687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 693691 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 693694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 693699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 693709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
     /* 693712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 693717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693724 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693742 */     GIR_RootConstrainSelectedInstOperands,
     /* 693743 */     // GIR_Coverage, 4935,
     /* 693743 */     GIR_EraseRootFromParent_Done,
     /* 693744 */   // Label 9014: @693744
     /* 693744 */   GIM_Reject,
     /* 693745 */ // Label 8998: @693745
     /* 693745 */ GIM_Reject,
     /* 693746 */ // Label 8894: @693746
     /* 693746 */ GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(694960),
     /* 693751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 693754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 693757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 693760 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 693763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 693767 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(693839), // Rule ID 4984 //
     /* 693772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693783 */     // MIs[0] offset
     /* 693783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693786 */     // MIs[0] auxiliary
     /* 693786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693789 */     // MIs[0] Operand 7
     /* 693789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693807 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 693810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693819 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693837 */     GIR_RootConstrainSelectedInstOperands,
     /* 693838 */     // GIR_Coverage, 4984,
     /* 693838 */     GIR_EraseRootFromParent_Done,
     /* 693839 */   // Label 9016: @693839
     /* 693839 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(693908), // Rule ID 4988 //
     /* 693844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693852 */     // MIs[0] offset
     /* 693852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693855 */     // MIs[0] auxiliary
     /* 693855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693858 */     // MIs[0] Operand 7
     /* 693858 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693876 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 693879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693888 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693890 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693906 */     GIR_RootConstrainSelectedInstOperands,
     /* 693907 */     // GIR_Coverage, 4988,
     /* 693907 */     GIR_EraseRootFromParent_Done,
     /* 693908 */   // Label 9017: @693908
     /* 693908 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(693980), // Rule ID 4992 //
     /* 693913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 693916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693924 */     // MIs[0] offset
     /* 693924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693927 */     // MIs[0] auxiliary
     /* 693927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693930 */     // MIs[0] Operand 7
     /* 693930 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 693941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 693948 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 693948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 693951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 693953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 693955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 693960 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 693962 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 693968 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 693974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 693978 */     GIR_RootConstrainSelectedInstOperands,
     /* 693979 */     // GIR_Coverage, 4992,
     /* 693979 */     GIR_EraseRootFromParent_Done,
     /* 693980 */   // Label 9018: @693980
     /* 693980 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(694049), // Rule ID 4996 //
     /* 693985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 693989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 693993 */     // MIs[0] offset
     /* 693993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 693996 */     // MIs[0] auxiliary
     /* 693996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 693999 */     // MIs[0] Operand 7
     /* 693999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694017 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 694020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694029 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694047 */     GIR_RootConstrainSelectedInstOperands,
     /* 694048 */     // GIR_Coverage, 4996,
     /* 694048 */     GIR_EraseRootFromParent_Done,
     /* 694049 */   // Label 9019: @694049
     /* 694049 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(694119), // Rule ID 4985 //
     /* 694054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694061 */     // MIs[0] offset
     /* 694061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694064 */     // MIs[0] auxiliary
     /* 694064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694067 */     // MIs[0] Operand 7
     /* 694067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694085 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 694088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694090 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694099 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694117 */     GIR_RootConstrainSelectedInstOperands,
     /* 694118 */     // GIR_Coverage, 4985,
     /* 694118 */     GIR_EraseRootFromParent_Done,
     /* 694119 */   // Label 9020: @694119
     /* 694119 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(694186), // Rule ID 4989 //
     /* 694124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694128 */     // MIs[0] offset
     /* 694128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694131 */     // MIs[0] auxiliary
     /* 694131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694134 */     // MIs[0] Operand 7
     /* 694134 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694152 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 694155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694157 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694166 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694184 */     GIR_RootConstrainSelectedInstOperands,
     /* 694185 */     // GIR_Coverage, 4989,
     /* 694185 */     GIR_EraseRootFromParent_Done,
     /* 694186 */   // Label 9021: @694186
     /* 694186 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(694256), // Rule ID 4993 //
     /* 694191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694198 */     // MIs[0] offset
     /* 694198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694201 */     // MIs[0] auxiliary
     /* 694201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694204 */     // MIs[0] Operand 7
     /* 694204 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694222 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 694225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694227 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694236 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694254 */     GIR_RootConstrainSelectedInstOperands,
     /* 694255 */     // GIR_Coverage, 4993,
     /* 694255 */     GIR_EraseRootFromParent_Done,
     /* 694256 */   // Label 9022: @694256
     /* 694256 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(694323), // Rule ID 4997 //
     /* 694261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694265 */     // MIs[0] offset
     /* 694265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694268 */     // MIs[0] auxiliary
     /* 694268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694271 */     // MIs[0] Operand 7
     /* 694271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 694282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694289 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 694292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694294 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 694296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694303 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694321 */     GIR_RootConstrainSelectedInstOperands,
     /* 694322 */     // GIR_Coverage, 4997,
     /* 694322 */     GIR_EraseRootFromParent_Done,
     /* 694323 */   // Label 9023: @694323
     /* 694323 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(694385), // Rule ID 4986 //
     /* 694328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694335 */     // MIs[0] offset
     /* 694335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694338 */     // MIs[0] auxiliary
     /* 694338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694341 */     // MIs[0] Operand 7
     /* 694341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694351 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 694354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694356 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694365 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694383 */     GIR_RootConstrainSelectedInstOperands,
     /* 694384 */     // GIR_Coverage, 4986,
     /* 694384 */     GIR_EraseRootFromParent_Done,
     /* 694385 */   // Label 9024: @694385
     /* 694385 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(694444), // Rule ID 4990 //
     /* 694390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694394 */     // MIs[0] offset
     /* 694394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694397 */     // MIs[0] auxiliary
     /* 694397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694400 */     // MIs[0] Operand 7
     /* 694400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694410 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 694413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694415 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694424 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694426 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694442 */     GIR_RootConstrainSelectedInstOperands,
     /* 694443 */     // GIR_Coverage, 4990,
     /* 694443 */     GIR_EraseRootFromParent_Done,
     /* 694444 */   // Label 9025: @694444
     /* 694444 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(694506), // Rule ID 4994 //
     /* 694449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694456 */     // MIs[0] offset
     /* 694456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694459 */     // MIs[0] auxiliary
     /* 694459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694462 */     // MIs[0] Operand 7
     /* 694462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694472 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 694475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694477 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694486 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694488 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694504 */     GIR_RootConstrainSelectedInstOperands,
     /* 694505 */     // GIR_Coverage, 4994,
     /* 694505 */     GIR_EraseRootFromParent_Done,
     /* 694506 */   // Label 9026: @694506
     /* 694506 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(694565), // Rule ID 4998 //
     /* 694511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694515 */     // MIs[0] offset
     /* 694515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694518 */     // MIs[0] auxiliary
     /* 694518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694521 */     // MIs[0] Operand 7
     /* 694521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694531 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 694534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694536 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 694538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694545 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694563 */     GIR_RootConstrainSelectedInstOperands,
     /* 694564 */     // GIR_Coverage, 4998,
     /* 694564 */     GIR_EraseRootFromParent_Done,
     /* 694565 */   // Label 9027: @694565
     /* 694565 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(694665), // Rule ID 4987 //
     /* 694570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694573 */     // MIs[0] offset
     /* 694573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694576 */     // MIs[0] auxiliary
     /* 694576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694579 */     // MIs[0] Operand 7
     /* 694579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694589 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694605 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694612 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 694633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694645 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694663 */     GIR_RootConstrainSelectedInstOperands,
     /* 694664 */     // GIR_Coverage, 4987,
     /* 694664 */     GIR_EraseRootFromParent_Done,
     /* 694665 */   // Label 9028: @694665
     /* 694665 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(694762), // Rule ID 4991 //
     /* 694670 */     // MIs[0] offset
     /* 694670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694673 */     // MIs[0] auxiliary
     /* 694673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694676 */     // MIs[0] Operand 7
     /* 694676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694686 */     // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694702 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694709 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 694730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694742 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694760 */     GIR_RootConstrainSelectedInstOperands,
     /* 694761 */     // GIR_Coverage, 4991,
     /* 694761 */     GIR_EraseRootFromParent_Done,
     /* 694762 */   // Label 9029: @694762
     /* 694762 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(694862), // Rule ID 4995 //
     /* 694767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694770 */     // MIs[0] offset
     /* 694770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694773 */     // MIs[0] auxiliary
     /* 694773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694776 */     // MIs[0] Operand 7
     /* 694776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694786 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694802 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694809 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 694830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694842 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694844 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694860 */     GIR_RootConstrainSelectedInstOperands,
     /* 694861 */     // GIR_Coverage, 4995,
     /* 694861 */     GIR_EraseRootFromParent_Done,
     /* 694862 */   // Label 9030: @694862
     /* 694862 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(694959), // Rule ID 4999 //
     /* 694867 */     // MIs[0] offset
     /* 694867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 694870 */     // MIs[0] auxiliary
     /* 694870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 694873 */     // MIs[0] Operand 7
     /* 694873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 694876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 694883 */     // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 694883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 694886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 694890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 694895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 694899 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 694902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 694906 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 694909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 694914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 694924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 694927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 694929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 694932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 694934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 694939 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 694941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 694947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 694953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 694957 */     GIR_RootConstrainSelectedInstOperands,
     /* 694958 */     // GIR_Coverage, 4999,
     /* 694958 */     GIR_EraseRootFromParent_Done,
     /* 694959 */   // Label 9031: @694959
     /* 694959 */   GIM_Reject,
     /* 694960 */ // Label 9015: @694960
     /* 694960 */ GIM_Reject,
     /* 694961 */ // Label 8895: @694961
     /* 694961 */ GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(696175),
     /* 694966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 694969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 694972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 694975 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 694978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 694982 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(695054), // Rule ID 5072 //
     /* 694987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 694990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 694994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 694998 */     // MIs[0] offset
     /* 694998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695001 */     // MIs[0] auxiliary
     /* 695001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695004 */     // MIs[0] Operand 7
     /* 695004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695022 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 695025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695034 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695052 */     GIR_RootConstrainSelectedInstOperands,
     /* 695053 */     // GIR_Coverage, 5072,
     /* 695053 */     GIR_EraseRootFromParent_Done,
     /* 695054 */   // Label 9033: @695054
     /* 695054 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(695123), // Rule ID 5076 //
     /* 695059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695067 */     // MIs[0] offset
     /* 695067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695070 */     // MIs[0] auxiliary
     /* 695070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695073 */     // MIs[0] Operand 7
     /* 695073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695091 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 695094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695103 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695121 */     GIR_RootConstrainSelectedInstOperands,
     /* 695122 */     // GIR_Coverage, 5076,
     /* 695122 */     GIR_EraseRootFromParent_Done,
     /* 695123 */   // Label 9034: @695123
     /* 695123 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(695195), // Rule ID 5080 //
     /* 695128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695139 */     // MIs[0] offset
     /* 695139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695142 */     // MIs[0] auxiliary
     /* 695142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695145 */     // MIs[0] Operand 7
     /* 695145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695163 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 695166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695175 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695193 */     GIR_RootConstrainSelectedInstOperands,
     /* 695194 */     // GIR_Coverage, 5080,
     /* 695194 */     GIR_EraseRootFromParent_Done,
     /* 695195 */   // Label 9035: @695195
     /* 695195 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(695264), // Rule ID 5084 //
     /* 695200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695208 */     // MIs[0] offset
     /* 695208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695211 */     // MIs[0] auxiliary
     /* 695211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695214 */     // MIs[0] Operand 7
     /* 695214 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695232 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 695235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695262 */     GIR_RootConstrainSelectedInstOperands,
     /* 695263 */     // GIR_Coverage, 5084,
     /* 695263 */     GIR_EraseRootFromParent_Done,
     /* 695264 */   // Label 9036: @695264
     /* 695264 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(695334), // Rule ID 5073 //
     /* 695269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695276 */     // MIs[0] offset
     /* 695276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695279 */     // MIs[0] auxiliary
     /* 695279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695282 */     // MIs[0] Operand 7
     /* 695282 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695300 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 695303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695305 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695314 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695316 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695322 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695332 */     GIR_RootConstrainSelectedInstOperands,
     /* 695333 */     // GIR_Coverage, 5073,
     /* 695333 */     GIR_EraseRootFromParent_Done,
     /* 695334 */   // Label 9037: @695334
     /* 695334 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(695401), // Rule ID 5077 //
     /* 695339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695343 */     // MIs[0] offset
     /* 695343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695346 */     // MIs[0] auxiliary
     /* 695346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695349 */     // MIs[0] Operand 7
     /* 695349 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695367 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 695370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695372 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695381 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695383 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695389 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695399 */     GIR_RootConstrainSelectedInstOperands,
     /* 695400 */     // GIR_Coverage, 5077,
     /* 695400 */     GIR_EraseRootFromParent_Done,
     /* 695401 */   // Label 9038: @695401
     /* 695401 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(695471), // Rule ID 5081 //
     /* 695406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695413 */     // MIs[0] offset
     /* 695413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695416 */     // MIs[0] auxiliary
     /* 695416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695419 */     // MIs[0] Operand 7
     /* 695419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695437 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 695440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695442 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695451 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695469 */     GIR_RootConstrainSelectedInstOperands,
     /* 695470 */     // GIR_Coverage, 5081,
     /* 695470 */     GIR_EraseRootFromParent_Done,
     /* 695471 */   // Label 9039: @695471
     /* 695471 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(695538), // Rule ID 5085 //
     /* 695476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 695480 */     // MIs[0] offset
     /* 695480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695483 */     // MIs[0] auxiliary
     /* 695483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695486 */     // MIs[0] Operand 7
     /* 695486 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 695497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695504 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 695507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695509 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 695511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695518 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695536 */     GIR_RootConstrainSelectedInstOperands,
     /* 695537 */     // GIR_Coverage, 5085,
     /* 695537 */     GIR_EraseRootFromParent_Done,
     /* 695538 */   // Label 9040: @695538
     /* 695538 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(695600), // Rule ID 5074 //
     /* 695543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695550 */     // MIs[0] offset
     /* 695550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695553 */     // MIs[0] auxiliary
     /* 695553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695556 */     // MIs[0] Operand 7
     /* 695556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695566 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 695569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695571 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695580 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695582 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695588 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695598 */     GIR_RootConstrainSelectedInstOperands,
     /* 695599 */     // GIR_Coverage, 5074,
     /* 695599 */     GIR_EraseRootFromParent_Done,
     /* 695600 */   // Label 9041: @695600
     /* 695600 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(695659), // Rule ID 5078 //
     /* 695605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695609 */     // MIs[0] offset
     /* 695609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695612 */     // MIs[0] auxiliary
     /* 695612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695615 */     // MIs[0] Operand 7
     /* 695615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695625 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 695628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695630 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695639 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695657 */     GIR_RootConstrainSelectedInstOperands,
     /* 695658 */     // GIR_Coverage, 5078,
     /* 695658 */     GIR_EraseRootFromParent_Done,
     /* 695659 */   // Label 9042: @695659
     /* 695659 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(695721), // Rule ID 5082 //
     /* 695664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695671 */     // MIs[0] offset
     /* 695671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695674 */     // MIs[0] auxiliary
     /* 695674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695677 */     // MIs[0] Operand 7
     /* 695677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695687 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 695690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695692 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695701 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695719 */     GIR_RootConstrainSelectedInstOperands,
     /* 695720 */     // GIR_Coverage, 5082,
     /* 695720 */     GIR_EraseRootFromParent_Done,
     /* 695721 */   // Label 9043: @695721
     /* 695721 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(695780), // Rule ID 5086 //
     /* 695726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 695730 */     // MIs[0] offset
     /* 695730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695733 */     // MIs[0] auxiliary
     /* 695733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695736 */     // MIs[0] Operand 7
     /* 695736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695746 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 695749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695751 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 695753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695760 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695778 */     GIR_RootConstrainSelectedInstOperands,
     /* 695779 */     // GIR_Coverage, 5086,
     /* 695779 */     GIR_EraseRootFromParent_Done,
     /* 695780 */   // Label 9044: @695780
     /* 695780 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(695880), // Rule ID 5075 //
     /* 695785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695788 */     // MIs[0] offset
     /* 695788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695791 */     // MIs[0] auxiliary
     /* 695791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695794 */     // MIs[0] Operand 7
     /* 695794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695804 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695820 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695827 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 695848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695860 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695878 */     GIR_RootConstrainSelectedInstOperands,
     /* 695879 */     // GIR_Coverage, 5075,
     /* 695879 */     GIR_EraseRootFromParent_Done,
     /* 695880 */   // Label 9045: @695880
     /* 695880 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(695977), // Rule ID 5079 //
     /* 695885 */     // MIs[0] offset
     /* 695885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695888 */     // MIs[0] auxiliary
     /* 695888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695891 */     // MIs[0] Operand 7
     /* 695891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 695901 */     // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 695901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 695904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 695908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 695913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 695917 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 695920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 695924 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 695927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 695932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 695942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 695945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 695947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 695950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 695952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 695957 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 695959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 695965 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 695971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 695975 */     GIR_RootConstrainSelectedInstOperands,
     /* 695976 */     // GIR_Coverage, 5079,
     /* 695976 */     GIR_EraseRootFromParent_Done,
     /* 695977 */   // Label 9046: @695977
     /* 695977 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(696077), // Rule ID 5083 //
     /* 695982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 695985 */     // MIs[0] offset
     /* 695985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 695988 */     // MIs[0] auxiliary
     /* 695988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 695991 */     // MIs[0] Operand 7
     /* 695991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 695994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696001 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696017 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696024 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 696045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696057 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696059 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696075 */     GIR_RootConstrainSelectedInstOperands,
     /* 696076 */     // GIR_Coverage, 5083,
     /* 696076 */     GIR_EraseRootFromParent_Done,
     /* 696077 */   // Label 9047: @696077
     /* 696077 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(696174), // Rule ID 5087 //
     /* 696082 */     // MIs[0] offset
     /* 696082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696085 */     // MIs[0] auxiliary
     /* 696085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696088 */     // MIs[0] Operand 7
     /* 696088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696098 */     // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 696101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 696105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 696110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 696114 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 696117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 696121 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 696124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 696129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 696139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 696142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 696147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696154 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696172 */     GIR_RootConstrainSelectedInstOperands,
     /* 696173 */     // GIR_Coverage, 5087,
     /* 696173 */     GIR_EraseRootFromParent_Done,
     /* 696174 */   // Label 9048: @696174
     /* 696174 */   GIM_Reject,
     /* 696175 */ // Label 9032: @696175
     /* 696175 */ GIM_Reject,
     /* 696176 */ // Label 8896: @696176
     /* 696176 */ GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(697390),
     /* 696181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 696184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 696187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 696190 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 696193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 696197 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(696269), // Rule ID 5040 //
     /* 696202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696213 */     // MIs[0] offset
     /* 696213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696216 */     // MIs[0] auxiliary
     /* 696216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696219 */     // MIs[0] Operand 7
     /* 696219 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696237 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 696240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696249 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696267 */     GIR_RootConstrainSelectedInstOperands,
     /* 696268 */     // GIR_Coverage, 5040,
     /* 696268 */     GIR_EraseRootFromParent_Done,
     /* 696269 */   // Label 9050: @696269
     /* 696269 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(696338), // Rule ID 5044 //
     /* 696274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696282 */     // MIs[0] offset
     /* 696282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696285 */     // MIs[0] auxiliary
     /* 696285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696288 */     // MIs[0] Operand 7
     /* 696288 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696306 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 696309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696318 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696336 */     GIR_RootConstrainSelectedInstOperands,
     /* 696337 */     // GIR_Coverage, 5044,
     /* 696337 */     GIR_EraseRootFromParent_Done,
     /* 696338 */   // Label 9051: @696338
     /* 696338 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(696410), // Rule ID 5048 //
     /* 696343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696354 */     // MIs[0] offset
     /* 696354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696357 */     // MIs[0] auxiliary
     /* 696357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696360 */     // MIs[0] Operand 7
     /* 696360 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696378 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
     /* 696381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696390 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696408 */     GIR_RootConstrainSelectedInstOperands,
     /* 696409 */     // GIR_Coverage, 5048,
     /* 696409 */     GIR_EraseRootFromParent_Done,
     /* 696410 */   // Label 9052: @696410
     /* 696410 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(696479), // Rule ID 5052 //
     /* 696415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696423 */     // MIs[0] offset
     /* 696423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696426 */     // MIs[0] auxiliary
     /* 696426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696429 */     // MIs[0] Operand 7
     /* 696429 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696447 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
     /* 696450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696459 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696461 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696467 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696477 */     GIR_RootConstrainSelectedInstOperands,
     /* 696478 */     // GIR_Coverage, 5052,
     /* 696478 */     GIR_EraseRootFromParent_Done,
     /* 696479 */   // Label 9053: @696479
     /* 696479 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(696549), // Rule ID 5041 //
     /* 696484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696491 */     // MIs[0] offset
     /* 696491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696494 */     // MIs[0] auxiliary
     /* 696494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696497 */     // MIs[0] Operand 7
     /* 696497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696515 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 696518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696520 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696529 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696531 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696547 */     GIR_RootConstrainSelectedInstOperands,
     /* 696548 */     // GIR_Coverage, 5041,
     /* 696548 */     GIR_EraseRootFromParent_Done,
     /* 696549 */   // Label 9054: @696549
     /* 696549 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(696616), // Rule ID 5045 //
     /* 696554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696558 */     // MIs[0] offset
     /* 696558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696561 */     // MIs[0] auxiliary
     /* 696561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696564 */     // MIs[0] Operand 7
     /* 696564 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696582 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 696585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696587 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696596 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696604 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696614 */     GIR_RootConstrainSelectedInstOperands,
     /* 696615 */     // GIR_Coverage, 5045,
     /* 696615 */     GIR_EraseRootFromParent_Done,
     /* 696616 */   // Label 9055: @696616
     /* 696616 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(696686), // Rule ID 5049 //
     /* 696621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696628 */     // MIs[0] offset
     /* 696628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696631 */     // MIs[0] auxiliary
     /* 696631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696634 */     // MIs[0] Operand 7
     /* 696634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696652 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
     /* 696655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696657 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696666 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696684 */     GIR_RootConstrainSelectedInstOperands,
     /* 696685 */     // GIR_Coverage, 5049,
     /* 696685 */     GIR_EraseRootFromParent_Done,
     /* 696686 */   // Label 9056: @696686
     /* 696686 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(696753), // Rule ID 5053 //
     /* 696691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 696695 */     // MIs[0] offset
     /* 696695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696698 */     // MIs[0] auxiliary
     /* 696698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696701 */     // MIs[0] Operand 7
     /* 696701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 696712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696719 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
     /* 696722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696724 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 696726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696733 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696735 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696751 */     GIR_RootConstrainSelectedInstOperands,
     /* 696752 */     // GIR_Coverage, 5053,
     /* 696752 */     GIR_EraseRootFromParent_Done,
     /* 696753 */   // Label 9057: @696753
     /* 696753 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(696815), // Rule ID 5042 //
     /* 696758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696765 */     // MIs[0] offset
     /* 696765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696768 */     // MIs[0] auxiliary
     /* 696768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696771 */     // MIs[0] Operand 7
     /* 696771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696781 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
     /* 696784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696786 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696795 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696813 */     GIR_RootConstrainSelectedInstOperands,
     /* 696814 */     // GIR_Coverage, 5042,
     /* 696814 */     GIR_EraseRootFromParent_Done,
     /* 696815 */   // Label 9058: @696815
     /* 696815 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(696874), // Rule ID 5046 //
     /* 696820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696824 */     // MIs[0] offset
     /* 696824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696827 */     // MIs[0] auxiliary
     /* 696827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696830 */     // MIs[0] Operand 7
     /* 696830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696840 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
     /* 696843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696845 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696854 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696872 */     GIR_RootConstrainSelectedInstOperands,
     /* 696873 */     // GIR_Coverage, 5046,
     /* 696873 */     GIR_EraseRootFromParent_Done,
     /* 696874 */   // Label 9059: @696874
     /* 696874 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(696936), // Rule ID 5050 //
     /* 696879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 696882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696886 */     // MIs[0] offset
     /* 696886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696889 */     // MIs[0] auxiliary
     /* 696889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696892 */     // MIs[0] Operand 7
     /* 696892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696902 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
     /* 696905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696907 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696916 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696934 */     GIR_RootConstrainSelectedInstOperands,
     /* 696935 */     // GIR_Coverage, 5050,
     /* 696935 */     GIR_EraseRootFromParent_Done,
     /* 696936 */   // Label 9060: @696936
     /* 696936 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(696995), // Rule ID 5054 //
     /* 696941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 696945 */     // MIs[0] offset
     /* 696945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 696948 */     // MIs[0] auxiliary
     /* 696948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 696951 */     // MIs[0] Operand 7
     /* 696951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 696954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 696961 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 696961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
     /* 696964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 696966 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 696968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 696970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 696975 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 696977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 696983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 696989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 696993 */     GIR_RootConstrainSelectedInstOperands,
     /* 696994 */     // GIR_Coverage, 5054,
     /* 696994 */     GIR_EraseRootFromParent_Done,
     /* 696995 */   // Label 9061: @696995
     /* 696995 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(697095), // Rule ID 5043 //
     /* 697000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697003 */     // MIs[0] offset
     /* 697003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697006 */     // MIs[0] auxiliary
     /* 697006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697009 */     // MIs[0] Operand 7
     /* 697009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697019 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697035 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697042 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
     /* 697063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697075 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697093 */     GIR_RootConstrainSelectedInstOperands,
     /* 697094 */     // GIR_Coverage, 5043,
     /* 697094 */     GIR_EraseRootFromParent_Done,
     /* 697095 */   // Label 9062: @697095
     /* 697095 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(697192), // Rule ID 5047 //
     /* 697100 */     // MIs[0] offset
     /* 697100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697103 */     // MIs[0] auxiliary
     /* 697103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697106 */     // MIs[0] Operand 7
     /* 697106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697116 */     // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697132 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697139 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
     /* 697160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697172 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697190 */     GIR_RootConstrainSelectedInstOperands,
     /* 697191 */     // GIR_Coverage, 5047,
     /* 697191 */     GIR_EraseRootFromParent_Done,
     /* 697192 */   // Label 9063: @697192
     /* 697192 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(697292), // Rule ID 5051 //
     /* 697197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697200 */     // MIs[0] offset
     /* 697200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697203 */     // MIs[0] auxiliary
     /* 697203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697206 */     // MIs[0] Operand 7
     /* 697206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697216 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697232 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697239 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
     /* 697260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697272 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697290 */     GIR_RootConstrainSelectedInstOperands,
     /* 697291 */     // GIR_Coverage, 5051,
     /* 697291 */     GIR_EraseRootFromParent_Done,
     /* 697292 */   // Label 9064: @697292
     /* 697292 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(697389), // Rule ID 5055 //
     /* 697297 */     // MIs[0] offset
     /* 697297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697300 */     // MIs[0] auxiliary
     /* 697300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697303 */     // MIs[0] Operand 7
     /* 697303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697313 */     // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 697316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 697320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 697325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 697329 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 697332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 697336 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 697339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 697344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 697354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
     /* 697357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 697362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697369 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697387 */     GIR_RootConstrainSelectedInstOperands,
     /* 697388 */     // GIR_Coverage, 5055,
     /* 697388 */     GIR_EraseRootFromParent_Done,
     /* 697389 */   // Label 9065: @697389
     /* 697389 */   GIM_Reject,
     /* 697390 */ // Label 9049: @697390
     /* 697390 */ GIM_Reject,
     /* 697391 */ // Label 8897: @697391
     /* 697391 */ GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(698605),
     /* 697396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 697399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 697402 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 697405 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 697408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 697412 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(697484), // Rule ID 5000 //
     /* 697417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697428 */     // MIs[0] offset
     /* 697428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697431 */     // MIs[0] auxiliary
     /* 697431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697434 */     // MIs[0] Operand 7
     /* 697434 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697452 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 697455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697464 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697466 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697472 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697482 */     GIR_RootConstrainSelectedInstOperands,
     /* 697483 */     // GIR_Coverage, 5000,
     /* 697483 */     GIR_EraseRootFromParent_Done,
     /* 697484 */   // Label 9067: @697484
     /* 697484 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(697553), // Rule ID 5004 //
     /* 697489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697497 */     // MIs[0] offset
     /* 697497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697500 */     // MIs[0] auxiliary
     /* 697500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697503 */     // MIs[0] Operand 7
     /* 697503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697521 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 697524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697533 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697551 */     GIR_RootConstrainSelectedInstOperands,
     /* 697552 */     // GIR_Coverage, 5004,
     /* 697552 */     GIR_EraseRootFromParent_Done,
     /* 697553 */   // Label 9068: @697553
     /* 697553 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(697625), // Rule ID 5008 //
     /* 697558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697569 */     // MIs[0] offset
     /* 697569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697572 */     // MIs[0] auxiliary
     /* 697572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697575 */     // MIs[0] Operand 7
     /* 697575 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697593 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
     /* 697596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697605 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697607 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697613 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697623 */     GIR_RootConstrainSelectedInstOperands,
     /* 697624 */     // GIR_Coverage, 5008,
     /* 697624 */     GIR_EraseRootFromParent_Done,
     /* 697625 */   // Label 9069: @697625
     /* 697625 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(697694), // Rule ID 5012 //
     /* 697630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697638 */     // MIs[0] offset
     /* 697638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697641 */     // MIs[0] auxiliary
     /* 697641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697644 */     // MIs[0] Operand 7
     /* 697644 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697662 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
     /* 697665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697674 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697676 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697682 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697692 */     GIR_RootConstrainSelectedInstOperands,
     /* 697693 */     // GIR_Coverage, 5012,
     /* 697693 */     GIR_EraseRootFromParent_Done,
     /* 697694 */   // Label 9070: @697694
     /* 697694 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(697764), // Rule ID 5001 //
     /* 697699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697706 */     // MIs[0] offset
     /* 697706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697709 */     // MIs[0] auxiliary
     /* 697709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697712 */     // MIs[0] Operand 7
     /* 697712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697730 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 697733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697735 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697744 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697762 */     GIR_RootConstrainSelectedInstOperands,
     /* 697763 */     // GIR_Coverage, 5001,
     /* 697763 */     GIR_EraseRootFromParent_Done,
     /* 697764 */   // Label 9071: @697764
     /* 697764 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(697831), // Rule ID 5005 //
     /* 697769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697773 */     // MIs[0] offset
     /* 697773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697776 */     // MIs[0] auxiliary
     /* 697776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697779 */     // MIs[0] Operand 7
     /* 697779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697797 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 697800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697802 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697811 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697813 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697819 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697829 */     GIR_RootConstrainSelectedInstOperands,
     /* 697830 */     // GIR_Coverage, 5005,
     /* 697830 */     GIR_EraseRootFromParent_Done,
     /* 697831 */   // Label 9072: @697831
     /* 697831 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(697901), // Rule ID 5009 //
     /* 697836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697843 */     // MIs[0] offset
     /* 697843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697846 */     // MIs[0] auxiliary
     /* 697846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697849 */     // MIs[0] Operand 7
     /* 697849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697867 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
     /* 697870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697872 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697881 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697899 */     GIR_RootConstrainSelectedInstOperands,
     /* 697900 */     // GIR_Coverage, 5009,
     /* 697900 */     GIR_EraseRootFromParent_Done,
     /* 697901 */   // Label 9073: @697901
     /* 697901 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(697968), // Rule ID 5013 //
     /* 697906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 697910 */     // MIs[0] offset
     /* 697910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697913 */     // MIs[0] auxiliary
     /* 697913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697916 */     // MIs[0] Operand 7
     /* 697916 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 697927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697934 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
     /* 697937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 697939 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 697941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 697943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 697948 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 697950 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 697956 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 697962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 697966 */     GIR_RootConstrainSelectedInstOperands,
     /* 697967 */     // GIR_Coverage, 5013,
     /* 697967 */     GIR_EraseRootFromParent_Done,
     /* 697968 */   // Label 9074: @697968
     /* 697968 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(698030), // Rule ID 5002 //
     /* 697973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 697976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 697980 */     // MIs[0] offset
     /* 697980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 697983 */     // MIs[0] auxiliary
     /* 697983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 697986 */     // MIs[0] Operand 7
     /* 697986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 697989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 697996 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 697996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 697999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698001 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698010 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698028 */     GIR_RootConstrainSelectedInstOperands,
     /* 698029 */     // GIR_Coverage, 5002,
     /* 698029 */     GIR_EraseRootFromParent_Done,
     /* 698030 */   // Label 9075: @698030
     /* 698030 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(698089), // Rule ID 5006 //
     /* 698035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698039 */     // MIs[0] offset
     /* 698039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698042 */     // MIs[0] auxiliary
     /* 698042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698045 */     // MIs[0] Operand 7
     /* 698045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698055 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 698058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698060 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698069 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698087 */     GIR_RootConstrainSelectedInstOperands,
     /* 698088 */     // GIR_Coverage, 5006,
     /* 698088 */     GIR_EraseRootFromParent_Done,
     /* 698089 */   // Label 9076: @698089
     /* 698089 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(698151), // Rule ID 5010 //
     /* 698094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698101 */     // MIs[0] offset
     /* 698101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698104 */     // MIs[0] auxiliary
     /* 698104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698107 */     // MIs[0] Operand 7
     /* 698107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698117 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
     /* 698120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698122 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698131 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698149 */     GIR_RootConstrainSelectedInstOperands,
     /* 698150 */     // GIR_Coverage, 5010,
     /* 698150 */     GIR_EraseRootFromParent_Done,
     /* 698151 */   // Label 9077: @698151
     /* 698151 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(698210), // Rule ID 5014 //
     /* 698156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698160 */     // MIs[0] offset
     /* 698160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698163 */     // MIs[0] auxiliary
     /* 698163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698166 */     // MIs[0] Operand 7
     /* 698166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698176 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
     /* 698179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698181 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 698183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698190 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698192 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698208 */     GIR_RootConstrainSelectedInstOperands,
     /* 698209 */     // GIR_Coverage, 5014,
     /* 698209 */     GIR_EraseRootFromParent_Done,
     /* 698210 */   // Label 9078: @698210
     /* 698210 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(698310), // Rule ID 5003 //
     /* 698215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698218 */     // MIs[0] offset
     /* 698218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698221 */     // MIs[0] auxiliary
     /* 698221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698224 */     // MIs[0] Operand 7
     /* 698224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698234 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698250 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698257 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 698278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698290 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698308 */     GIR_RootConstrainSelectedInstOperands,
     /* 698309 */     // GIR_Coverage, 5003,
     /* 698309 */     GIR_EraseRootFromParent_Done,
     /* 698310 */   // Label 9079: @698310
     /* 698310 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(698407), // Rule ID 5007 //
     /* 698315 */     // MIs[0] offset
     /* 698315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698318 */     // MIs[0] auxiliary
     /* 698318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698321 */     // MIs[0] Operand 7
     /* 698321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698331 */     // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698347 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698354 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 698375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698387 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698389 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698395 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698405 */     GIR_RootConstrainSelectedInstOperands,
     /* 698406 */     // GIR_Coverage, 5007,
     /* 698406 */     GIR_EraseRootFromParent_Done,
     /* 698407 */   // Label 9080: @698407
     /* 698407 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(698507), // Rule ID 5011 //
     /* 698412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698415 */     // MIs[0] offset
     /* 698415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698418 */     // MIs[0] auxiliary
     /* 698418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698421 */     // MIs[0] Operand 7
     /* 698421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698431 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698447 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698454 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
     /* 698475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698505 */     GIR_RootConstrainSelectedInstOperands,
     /* 698506 */     // GIR_Coverage, 5011,
     /* 698506 */     GIR_EraseRootFromParent_Done,
     /* 698507 */   // Label 9081: @698507
     /* 698507 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(698604), // Rule ID 5015 //
     /* 698512 */     // MIs[0] offset
     /* 698512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698515 */     // MIs[0] auxiliary
     /* 698515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698518 */     // MIs[0] Operand 7
     /* 698518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 698521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698528 */     // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 698531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 698535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 698540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 698544 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 698547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 698551 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 698554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 698559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 698569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
     /* 698572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 698577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698584 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698602 */     GIR_RootConstrainSelectedInstOperands,
     /* 698603 */     // GIR_Coverage, 5015,
     /* 698603 */     GIR_EraseRootFromParent_Done,
     /* 698604 */   // Label 9082: @698604
     /* 698604 */   GIM_Reject,
     /* 698605 */ // Label 9066: @698605
     /* 698605 */ GIM_Reject,
     /* 698606 */ // Label 8898: @698606
     /* 698606 */ GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(699820),
     /* 698611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 698614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 698617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 698620 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 698623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 698627 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(698699), // Rule ID 5056 //
     /* 698632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698643 */     // MIs[0] offset
     /* 698643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698646 */     // MIs[0] auxiliary
     /* 698646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698649 */     // MIs[0] Operand 7
     /* 698649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698667 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 698670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698679 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698697 */     GIR_RootConstrainSelectedInstOperands,
     /* 698698 */     // GIR_Coverage, 5056,
     /* 698698 */     GIR_EraseRootFromParent_Done,
     /* 698699 */   // Label 9084: @698699
     /* 698699 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(698768), // Rule ID 5060 //
     /* 698704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698712 */     // MIs[0] offset
     /* 698712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698715 */     // MIs[0] auxiliary
     /* 698715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698718 */     // MIs[0] Operand 7
     /* 698718 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698736 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 698739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698748 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698756 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698766 */     GIR_RootConstrainSelectedInstOperands,
     /* 698767 */     // GIR_Coverage, 5060,
     /* 698767 */     GIR_EraseRootFromParent_Done,
     /* 698768 */   // Label 9085: @698768
     /* 698768 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(698840), // Rule ID 5064 //
     /* 698773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698784 */     // MIs[0] offset
     /* 698784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698787 */     // MIs[0] auxiliary
     /* 698787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698790 */     // MIs[0] Operand 7
     /* 698790 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698808 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 698811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698820 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698838 */     GIR_RootConstrainSelectedInstOperands,
     /* 698839 */     // GIR_Coverage, 5064,
     /* 698839 */     GIR_EraseRootFromParent_Done,
     /* 698840 */   // Label 9086: @698840
     /* 698840 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(698909), // Rule ID 5068 //
     /* 698845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 698853 */     // MIs[0] offset
     /* 698853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698856 */     // MIs[0] auxiliary
     /* 698856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698859 */     // MIs[0] Operand 7
     /* 698859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698877 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 698880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698889 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698897 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698907 */     GIR_RootConstrainSelectedInstOperands,
     /* 698908 */     // GIR_Coverage, 5068,
     /* 698908 */     GIR_EraseRootFromParent_Done,
     /* 698909 */   // Label 9087: @698909
     /* 698909 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(698979), // Rule ID 5057 //
     /* 698914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 698917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698921 */     // MIs[0] offset
     /* 698921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698924 */     // MIs[0] auxiliary
     /* 698924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698927 */     // MIs[0] Operand 7
     /* 698927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 698938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 698945 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 698945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 698948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 698950 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 698952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 698954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 698959 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 698961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 698967 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 698973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 698977 */     GIR_RootConstrainSelectedInstOperands,
     /* 698978 */     // GIR_Coverage, 5057,
     /* 698978 */     GIR_EraseRootFromParent_Done,
     /* 698979 */   // Label 9088: @698979
     /* 698979 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(699046), // Rule ID 5061 //
     /* 698984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 698988 */     // MIs[0] offset
     /* 698988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 698991 */     // MIs[0] auxiliary
     /* 698991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 698994 */     // MIs[0] Operand 7
     /* 698994 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699012 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 699015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699017 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699026 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699044 */     GIR_RootConstrainSelectedInstOperands,
     /* 699045 */     // GIR_Coverage, 5061,
     /* 699045 */     GIR_EraseRootFromParent_Done,
     /* 699046 */   // Label 9089: @699046
     /* 699046 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(699116), // Rule ID 5065 //
     /* 699051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699058 */     // MIs[0] offset
     /* 699058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699061 */     // MIs[0] auxiliary
     /* 699061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699064 */     // MIs[0] Operand 7
     /* 699064 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699082 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 699085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699087 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699096 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699104 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699114 */     GIR_RootConstrainSelectedInstOperands,
     /* 699115 */     // GIR_Coverage, 5065,
     /* 699115 */     GIR_EraseRootFromParent_Done,
     /* 699116 */   // Label 9090: @699116
     /* 699116 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(699183), // Rule ID 5069 //
     /* 699121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699125 */     // MIs[0] offset
     /* 699125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699128 */     // MIs[0] auxiliary
     /* 699128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699131 */     // MIs[0] Operand 7
     /* 699131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699149 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 699152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699154 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 699156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699163 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699165 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699181 */     GIR_RootConstrainSelectedInstOperands,
     /* 699182 */     // GIR_Coverage, 5069,
     /* 699182 */     GIR_EraseRootFromParent_Done,
     /* 699183 */   // Label 9091: @699183
     /* 699183 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(699245), // Rule ID 5058 //
     /* 699188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699195 */     // MIs[0] offset
     /* 699195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699198 */     // MIs[0] auxiliary
     /* 699198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699201 */     // MIs[0] Operand 7
     /* 699201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699211 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 699214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699216 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699225 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699243 */     GIR_RootConstrainSelectedInstOperands,
     /* 699244 */     // GIR_Coverage, 5058,
     /* 699244 */     GIR_EraseRootFromParent_Done,
     /* 699245 */   // Label 9092: @699245
     /* 699245 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(699304), // Rule ID 5062 //
     /* 699250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699254 */     // MIs[0] offset
     /* 699254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699257 */     // MIs[0] auxiliary
     /* 699257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699260 */     // MIs[0] Operand 7
     /* 699260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699270 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 699273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699275 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699284 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699302 */     GIR_RootConstrainSelectedInstOperands,
     /* 699303 */     // GIR_Coverage, 5062,
     /* 699303 */     GIR_EraseRootFromParent_Done,
     /* 699304 */   // Label 9093: @699304
     /* 699304 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(699366), // Rule ID 5066 //
     /* 699309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699316 */     // MIs[0] offset
     /* 699316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699319 */     // MIs[0] auxiliary
     /* 699319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699322 */     // MIs[0] Operand 7
     /* 699322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699332 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 699335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699337 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699346 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699364 */     GIR_RootConstrainSelectedInstOperands,
     /* 699365 */     // GIR_Coverage, 5066,
     /* 699365 */     GIR_EraseRootFromParent_Done,
     /* 699366 */   // Label 9094: @699366
     /* 699366 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(699425), // Rule ID 5070 //
     /* 699371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699375 */     // MIs[0] offset
     /* 699375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699378 */     // MIs[0] auxiliary
     /* 699378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699381 */     // MIs[0] Operand 7
     /* 699381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699391 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 699394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699396 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 699398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699405 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699407 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699423 */     GIR_RootConstrainSelectedInstOperands,
     /* 699424 */     // GIR_Coverage, 5070,
     /* 699424 */     GIR_EraseRootFromParent_Done,
     /* 699425 */   // Label 9095: @699425
     /* 699425 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(699525), // Rule ID 5059 //
     /* 699430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699433 */     // MIs[0] offset
     /* 699433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699436 */     // MIs[0] auxiliary
     /* 699436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699439 */     // MIs[0] Operand 7
     /* 699439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699449 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699465 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699472 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 699493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699505 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699523 */     GIR_RootConstrainSelectedInstOperands,
     /* 699524 */     // GIR_Coverage, 5059,
     /* 699524 */     GIR_EraseRootFromParent_Done,
     /* 699525 */   // Label 9096: @699525
     /* 699525 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(699622), // Rule ID 5063 //
     /* 699530 */     // MIs[0] offset
     /* 699530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699533 */     // MIs[0] auxiliary
     /* 699533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699536 */     // MIs[0] Operand 7
     /* 699536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699546 */     // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699562 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699569 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 699590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699602 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699604 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699610 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699620 */     GIR_RootConstrainSelectedInstOperands,
     /* 699621 */     // GIR_Coverage, 5063,
     /* 699621 */     GIR_EraseRootFromParent_Done,
     /* 699622 */   // Label 9097: @699622
     /* 699622 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(699722), // Rule ID 5067 //
     /* 699627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699630 */     // MIs[0] offset
     /* 699630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699633 */     // MIs[0] auxiliary
     /* 699633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699636 */     // MIs[0] Operand 7
     /* 699636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699646 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699662 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699669 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 699690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699720 */     GIR_RootConstrainSelectedInstOperands,
     /* 699721 */     // GIR_Coverage, 5067,
     /* 699721 */     GIR_EraseRootFromParent_Done,
     /* 699722 */   // Label 9098: @699722
     /* 699722 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(699819), // Rule ID 5071 //
     /* 699727 */     // MIs[0] offset
     /* 699727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699730 */     // MIs[0] auxiliary
     /* 699730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699733 */     // MIs[0] Operand 7
     /* 699733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 699736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699743 */     // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 699746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 699750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 699755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 699759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 699762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 699766 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 699769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 699774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 699784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 699787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 699792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699799 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699817 */     GIR_RootConstrainSelectedInstOperands,
     /* 699818 */     // GIR_Coverage, 5071,
     /* 699818 */     GIR_EraseRootFromParent_Done,
     /* 699819 */   // Label 9099: @699819
     /* 699819 */   GIM_Reject,
     /* 699820 */ // Label 9083: @699820
     /* 699820 */ GIM_Reject,
     /* 699821 */ // Label 8899: @699821
     /* 699821 */ GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(701035),
     /* 699826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 699829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 699832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 699835 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 699838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 699842 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(699914), // Rule ID 5088 //
     /* 699847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699858 */     // MIs[0] offset
     /* 699858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699861 */     // MIs[0] auxiliary
     /* 699861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699864 */     // MIs[0] Operand 7
     /* 699864 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699882 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 699885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699894 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699912 */     GIR_RootConstrainSelectedInstOperands,
     /* 699913 */     // GIR_Coverage, 5088,
     /* 699913 */     GIR_EraseRootFromParent_Done,
     /* 699914 */   // Label 9101: @699914
     /* 699914 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(699983), // Rule ID 5092 //
     /* 699919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699927 */     // MIs[0] offset
     /* 699927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 699930 */     // MIs[0] auxiliary
     /* 699930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 699933 */     // MIs[0] Operand 7
     /* 699933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 699944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 699951 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 699951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 699954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 699956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 699958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 699963 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 699965 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 699971 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 699977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 699981 */     GIR_RootConstrainSelectedInstOperands,
     /* 699982 */     // GIR_Coverage, 5092,
     /* 699982 */     GIR_EraseRootFromParent_Done,
     /* 699983 */   // Label 9102: @699983
     /* 699983 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(700055), // Rule ID 5096 //
     /* 699988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 699991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 699995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 699999 */     // MIs[0] offset
     /* 699999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700002 */     // MIs[0] auxiliary
     /* 700002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700005 */     // MIs[0] Operand 7
     /* 700005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700023 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
     /* 700026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700035 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700053 */     GIR_RootConstrainSelectedInstOperands,
     /* 700054 */     // GIR_Coverage, 5096,
     /* 700054 */     GIR_EraseRootFromParent_Done,
     /* 700055 */   // Label 9103: @700055
     /* 700055 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(700124), // Rule ID 5100 //
     /* 700060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700068 */     // MIs[0] offset
     /* 700068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700071 */     // MIs[0] auxiliary
     /* 700071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700074 */     // MIs[0] Operand 7
     /* 700074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700092 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
     /* 700095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700104 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700112 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700122 */     GIR_RootConstrainSelectedInstOperands,
     /* 700123 */     // GIR_Coverage, 5100,
     /* 700123 */     GIR_EraseRootFromParent_Done,
     /* 700124 */   // Label 9104: @700124
     /* 700124 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(700194), // Rule ID 5089 //
     /* 700129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700136 */     // MIs[0] offset
     /* 700136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700139 */     // MIs[0] auxiliary
     /* 700139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700142 */     // MIs[0] Operand 7
     /* 700142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700160 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 700163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700165 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700174 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700192 */     GIR_RootConstrainSelectedInstOperands,
     /* 700193 */     // GIR_Coverage, 5089,
     /* 700193 */     GIR_EraseRootFromParent_Done,
     /* 700194 */   // Label 9105: @700194
     /* 700194 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(700261), // Rule ID 5093 //
     /* 700199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700203 */     // MIs[0] offset
     /* 700203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700206 */     // MIs[0] auxiliary
     /* 700206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700209 */     // MIs[0] Operand 7
     /* 700209 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700227 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 700230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700232 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700241 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700243 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700249 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700259 */     GIR_RootConstrainSelectedInstOperands,
     /* 700260 */     // GIR_Coverage, 5093,
     /* 700260 */     GIR_EraseRootFromParent_Done,
     /* 700261 */   // Label 9106: @700261
     /* 700261 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(700331), // Rule ID 5097 //
     /* 700266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700273 */     // MIs[0] offset
     /* 700273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700276 */     // MIs[0] auxiliary
     /* 700276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700279 */     // MIs[0] Operand 7
     /* 700279 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700297 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
     /* 700300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700302 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700311 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700313 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700329 */     GIR_RootConstrainSelectedInstOperands,
     /* 700330 */     // GIR_Coverage, 5097,
     /* 700330 */     GIR_EraseRootFromParent_Done,
     /* 700331 */   // Label 9107: @700331
     /* 700331 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(700398), // Rule ID 5101 //
     /* 700336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 700340 */     // MIs[0] offset
     /* 700340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700343 */     // MIs[0] auxiliary
     /* 700343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700346 */     // MIs[0] Operand 7
     /* 700346 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 700357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700364 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
     /* 700367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700369 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 700371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700378 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700380 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700396 */     GIR_RootConstrainSelectedInstOperands,
     /* 700397 */     // GIR_Coverage, 5101,
     /* 700397 */     GIR_EraseRootFromParent_Done,
     /* 700398 */   // Label 9108: @700398
     /* 700398 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(700460), // Rule ID 5090 //
     /* 700403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700410 */     // MIs[0] offset
     /* 700410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700413 */     // MIs[0] auxiliary
     /* 700413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700416 */     // MIs[0] Operand 7
     /* 700416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700426 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 700429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700431 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700440 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700458 */     GIR_RootConstrainSelectedInstOperands,
     /* 700459 */     // GIR_Coverage, 5090,
     /* 700459 */     GIR_EraseRootFromParent_Done,
     /* 700460 */   // Label 9109: @700460
     /* 700460 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(700519), // Rule ID 5094 //
     /* 700465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700469 */     // MIs[0] offset
     /* 700469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700472 */     // MIs[0] auxiliary
     /* 700472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700475 */     // MIs[0] Operand 7
     /* 700475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700485 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 700488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700490 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700499 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700517 */     GIR_RootConstrainSelectedInstOperands,
     /* 700518 */     // GIR_Coverage, 5094,
     /* 700518 */     GIR_EraseRootFromParent_Done,
     /* 700519 */   // Label 9110: @700519
     /* 700519 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(700581), // Rule ID 5098 //
     /* 700524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700531 */     // MIs[0] offset
     /* 700531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700534 */     // MIs[0] auxiliary
     /* 700534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700537 */     // MIs[0] Operand 7
     /* 700537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700547 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
     /* 700550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700552 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700561 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700563 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700579 */     GIR_RootConstrainSelectedInstOperands,
     /* 700580 */     // GIR_Coverage, 5098,
     /* 700580 */     GIR_EraseRootFromParent_Done,
     /* 700581 */   // Label 9111: @700581
     /* 700581 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(700640), // Rule ID 5102 //
     /* 700586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 700590 */     // MIs[0] offset
     /* 700590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700593 */     // MIs[0] auxiliary
     /* 700593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700596 */     // MIs[0] Operand 7
     /* 700596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700606 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
     /* 700609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700611 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 700613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700620 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700622 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700638 */     GIR_RootConstrainSelectedInstOperands,
     /* 700639 */     // GIR_Coverage, 5102,
     /* 700639 */     GIR_EraseRootFromParent_Done,
     /* 700640 */   // Label 9112: @700640
     /* 700640 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(700740), // Rule ID 5091 //
     /* 700645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700648 */     // MIs[0] offset
     /* 700648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700651 */     // MIs[0] auxiliary
     /* 700651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700654 */     // MIs[0] Operand 7
     /* 700654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700664 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700680 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700687 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 700708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700720 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700728 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700738 */     GIR_RootConstrainSelectedInstOperands,
     /* 700739 */     // GIR_Coverage, 5091,
     /* 700739 */     GIR_EraseRootFromParent_Done,
     /* 700740 */   // Label 9113: @700740
     /* 700740 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(700837), // Rule ID 5095 //
     /* 700745 */     // MIs[0] offset
     /* 700745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700748 */     // MIs[0] auxiliary
     /* 700748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700751 */     // MIs[0] Operand 7
     /* 700751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700761 */     // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700777 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700784 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 700805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700817 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700819 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700825 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700835 */     GIR_RootConstrainSelectedInstOperands,
     /* 700836 */     // GIR_Coverage, 5095,
     /* 700836 */     GIR_EraseRootFromParent_Done,
     /* 700837 */   // Label 9114: @700837
     /* 700837 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(700937), // Rule ID 5099 //
     /* 700842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 700845 */     // MIs[0] offset
     /* 700845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700848 */     // MIs[0] auxiliary
     /* 700848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700851 */     // MIs[0] Operand 7
     /* 700851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700861 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700877 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700884 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
     /* 700905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 700907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 700910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 700912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 700917 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 700919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 700925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 700931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 700935 */     GIR_RootConstrainSelectedInstOperands,
     /* 700936 */     // GIR_Coverage, 5099,
     /* 700936 */     GIR_EraseRootFromParent_Done,
     /* 700937 */   // Label 9115: @700937
     /* 700937 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(701034), // Rule ID 5103 //
     /* 700942 */     // MIs[0] offset
     /* 700942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 700945 */     // MIs[0] auxiliary
     /* 700945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 700948 */     // MIs[0] Operand 7
     /* 700948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 700951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 700958 */     // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 700958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 700961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 700965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 700970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 700974 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 700977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 700981 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 700984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 700989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 700999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
     /* 701002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701014 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701032 */     GIR_RootConstrainSelectedInstOperands,
     /* 701033 */     // GIR_Coverage, 5103,
     /* 701033 */     GIR_EraseRootFromParent_Done,
     /* 701034 */   // Label 9116: @701034
     /* 701034 */   GIM_Reject,
     /* 701035 */ // Label 9100: @701035
     /* 701035 */ GIM_Reject,
     /* 701036 */ // Label 8900: @701036
     /* 701036 */ GIM_Reject,
     /* 701037 */ // Label 126: @701037
     /* 701037 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9121*/ GIMT_Encode4(705944),
     /* 701048 */ /*GILLT_s32*//*Label 9117*/ GIMT_Encode4(701084), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 701060 */ /*GILLT_v2s32*//*Label 9118*/ GIMT_Encode4(702299), GIMT_Encode4(0),
     /* 701068 */ /*GILLT_v3s32*//*Label 9119*/ GIMT_Encode4(703514), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 701080 */ /*GILLT_v4s32*//*Label 9120*/ GIMT_Encode4(704729),
     /* 701084 */ // Label 9117: @701084
     /* 701084 */ GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(702298),
     /* 701089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 701092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 701095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 701098 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 701101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 701105 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(701177), // Rule ID 4712 //
     /* 701110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701121 */     // MIs[0] offset
     /* 701121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701124 */     // MIs[0] auxiliary
     /* 701124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701127 */     // MIs[0] Operand 7
     /* 701127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701145 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
     /* 701148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701157 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701159 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701165 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701175 */     GIR_RootConstrainSelectedInstOperands,
     /* 701176 */     // GIR_Coverage, 4712,
     /* 701176 */     GIR_EraseRootFromParent_Done,
     /* 701177 */   // Label 9123: @701177
     /* 701177 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(701246), // Rule ID 4716 //
     /* 701182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701190 */     // MIs[0] offset
     /* 701190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701193 */     // MIs[0] auxiliary
     /* 701193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701196 */     // MIs[0] Operand 7
     /* 701196 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701214 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 701217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701226 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701234 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701244 */     GIR_RootConstrainSelectedInstOperands,
     /* 701245 */     // GIR_Coverage, 4716,
     /* 701245 */     GIR_EraseRootFromParent_Done,
     /* 701246 */   // Label 9124: @701246
     /* 701246 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(701318), // Rule ID 4720 //
     /* 701251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701262 */     // MIs[0] offset
     /* 701262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701265 */     // MIs[0] auxiliary
     /* 701265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701268 */     // MIs[0] Operand 7
     /* 701268 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701286 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
     /* 701289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701298 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701316 */     GIR_RootConstrainSelectedInstOperands,
     /* 701317 */     // GIR_Coverage, 4720,
     /* 701317 */     GIR_EraseRootFromParent_Done,
     /* 701318 */   // Label 9125: @701318
     /* 701318 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(701387), // Rule ID 4724 //
     /* 701323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701331 */     // MIs[0] offset
     /* 701331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701334 */     // MIs[0] auxiliary
     /* 701334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701337 */     // MIs[0] Operand 7
     /* 701337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701355 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 701358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701367 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701369 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701385 */     GIR_RootConstrainSelectedInstOperands,
     /* 701386 */     // GIR_Coverage, 4724,
     /* 701386 */     GIR_EraseRootFromParent_Done,
     /* 701387 */   // Label 9126: @701387
     /* 701387 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(701457), // Rule ID 4713 //
     /* 701392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701399 */     // MIs[0] offset
     /* 701399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701402 */     // MIs[0] auxiliary
     /* 701402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701405 */     // MIs[0] Operand 7
     /* 701405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701423 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
     /* 701426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701428 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 701430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701437 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701455 */     GIR_RootConstrainSelectedInstOperands,
     /* 701456 */     // GIR_Coverage, 4713,
     /* 701456 */     GIR_EraseRootFromParent_Done,
     /* 701457 */   // Label 9127: @701457
     /* 701457 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(701524), // Rule ID 4717 //
     /* 701462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701466 */     // MIs[0] offset
     /* 701466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701469 */     // MIs[0] auxiliary
     /* 701469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701472 */     // MIs[0] Operand 7
     /* 701472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701490 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 701493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701495 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 701497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701504 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701522 */     GIR_RootConstrainSelectedInstOperands,
     /* 701523 */     // GIR_Coverage, 4717,
     /* 701523 */     GIR_EraseRootFromParent_Done,
     /* 701524 */   // Label 9128: @701524
     /* 701524 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(701594), // Rule ID 4721 //
     /* 701529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701536 */     // MIs[0] offset
     /* 701536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701539 */     // MIs[0] auxiliary
     /* 701539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701542 */     // MIs[0] Operand 7
     /* 701542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701560 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
     /* 701563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701565 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 701567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701574 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701576 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701582 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701592 */     GIR_RootConstrainSelectedInstOperands,
     /* 701593 */     // GIR_Coverage, 4721,
     /* 701593 */     GIR_EraseRootFromParent_Done,
     /* 701594 */   // Label 9129: @701594
     /* 701594 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(701661), // Rule ID 4725 //
     /* 701599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 701603 */     // MIs[0] offset
     /* 701603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701606 */     // MIs[0] auxiliary
     /* 701606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701609 */     // MIs[0] Operand 7
     /* 701609 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 701620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701627 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 701630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701632 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 701634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701641 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701643 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701649 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701659 */     GIR_RootConstrainSelectedInstOperands,
     /* 701660 */     // GIR_Coverage, 4725,
     /* 701660 */     GIR_EraseRootFromParent_Done,
     /* 701661 */   // Label 9130: @701661
     /* 701661 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(701723), // Rule ID 4714 //
     /* 701666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701673 */     // MIs[0] offset
     /* 701673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701676 */     // MIs[0] auxiliary
     /* 701676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701679 */     // MIs[0] Operand 7
     /* 701679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701689 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
     /* 701692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701694 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701703 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701721 */     GIR_RootConstrainSelectedInstOperands,
     /* 701722 */     // GIR_Coverage, 4714,
     /* 701722 */     GIR_EraseRootFromParent_Done,
     /* 701723 */   // Label 9131: @701723
     /* 701723 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(701782), // Rule ID 4718 //
     /* 701728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701732 */     // MIs[0] offset
     /* 701732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701735 */     // MIs[0] auxiliary
     /* 701735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701738 */     // MIs[0] Operand 7
     /* 701738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701748 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 701751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701753 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701762 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701780 */     GIR_RootConstrainSelectedInstOperands,
     /* 701781 */     // GIR_Coverage, 4718,
     /* 701781 */     GIR_EraseRootFromParent_Done,
     /* 701782 */   // Label 9132: @701782
     /* 701782 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(701844), // Rule ID 4722 //
     /* 701787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701794 */     // MIs[0] offset
     /* 701794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701797 */     // MIs[0] auxiliary
     /* 701797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701800 */     // MIs[0] Operand 7
     /* 701800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701810 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
     /* 701813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701815 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701824 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701842 */     GIR_RootConstrainSelectedInstOperands,
     /* 701843 */     // GIR_Coverage, 4722,
     /* 701843 */     GIR_EraseRootFromParent_Done,
     /* 701844 */   // Label 9133: @701844
     /* 701844 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(701903), // Rule ID 4726 //
     /* 701849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 701853 */     // MIs[0] offset
     /* 701853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701856 */     // MIs[0] auxiliary
     /* 701856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701859 */     // MIs[0] Operand 7
     /* 701859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701869 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 701872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701874 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 701876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701883 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701885 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 701901 */     GIR_RootConstrainSelectedInstOperands,
     /* 701902 */     // GIR_Coverage, 4726,
     /* 701902 */     GIR_EraseRootFromParent_Done,
     /* 701903 */   // Label 9134: @701903
     /* 701903 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(702003), // Rule ID 4715 //
     /* 701908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 701911 */     // MIs[0] offset
     /* 701911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 701914 */     // MIs[0] auxiliary
     /* 701914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 701917 */     // MIs[0] Operand 7
     /* 701917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 701920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 701927 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 701927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 701930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 701934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 701939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 701943 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 701946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 701950 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 701953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 701958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 701968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 701971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 701973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 701976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 701978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 701983 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 701985 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 701991 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 701997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702001 */     GIR_RootConstrainSelectedInstOperands,
     /* 702002 */     // GIR_Coverage, 4715,
     /* 702002 */     GIR_EraseRootFromParent_Done,
     /* 702003 */   // Label 9135: @702003
     /* 702003 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(702100), // Rule ID 4719 //
     /* 702008 */     // MIs[0] offset
     /* 702008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702011 */     // MIs[0] auxiliary
     /* 702011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702014 */     // MIs[0] Operand 7
     /* 702014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702024 */     // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 702027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 702031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 702036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 702040 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 702043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 702047 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 702050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 702055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 702068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 702073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702080 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702098 */     GIR_RootConstrainSelectedInstOperands,
     /* 702099 */     // GIR_Coverage, 4719,
     /* 702099 */     GIR_EraseRootFromParent_Done,
     /* 702100 */   // Label 9136: @702100
     /* 702100 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(702200), // Rule ID 4723 //
     /* 702105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 702108 */     // MIs[0] offset
     /* 702108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702111 */     // MIs[0] auxiliary
     /* 702111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702114 */     // MIs[0] Operand 7
     /* 702114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702124 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 702127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 702131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 702136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 702140 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 702143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 702147 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 702150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 702155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 702168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 702173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702180 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702198 */     GIR_RootConstrainSelectedInstOperands,
     /* 702199 */     // GIR_Coverage, 4723,
     /* 702199 */     GIR_EraseRootFromParent_Done,
     /* 702200 */   // Label 9137: @702200
     /* 702200 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(702297), // Rule ID 4727 //
     /* 702205 */     // MIs[0] offset
     /* 702205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702208 */     // MIs[0] auxiliary
     /* 702208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702211 */     // MIs[0] Operand 7
     /* 702211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702221 */     // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 702224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 702228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 702233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 702237 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 702240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 702244 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 702247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 702252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 702262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 702265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 702270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702277 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702295 */     GIR_RootConstrainSelectedInstOperands,
     /* 702296 */     // GIR_Coverage, 4727,
     /* 702296 */     GIR_EraseRootFromParent_Done,
     /* 702297 */   // Label 9138: @702297
     /* 702297 */   GIM_Reject,
     /* 702298 */ // Label 9122: @702298
     /* 702298 */ GIM_Reject,
     /* 702299 */ // Label 9118: @702299
     /* 702299 */ GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(703513),
     /* 702304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 702307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 702310 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 702313 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 702316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 702320 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(702392), // Rule ID 4728 //
     /* 702325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 702328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702336 */     // MIs[0] offset
     /* 702336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702339 */     // MIs[0] auxiliary
     /* 702339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702342 */     // MIs[0] Operand 7
     /* 702342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702360 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 702363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702372 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702380 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702390 */     GIR_RootConstrainSelectedInstOperands,
     /* 702391 */     // GIR_Coverage, 4728,
     /* 702391 */     GIR_EraseRootFromParent_Done,
     /* 702392 */   // Label 9140: @702392
     /* 702392 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(702461), // Rule ID 4732 //
     /* 702397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702405 */     // MIs[0] offset
     /* 702405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702408 */     // MIs[0] auxiliary
     /* 702408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702411 */     // MIs[0] Operand 7
     /* 702411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702429 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 702432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702441 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702459 */     GIR_RootConstrainSelectedInstOperands,
     /* 702460 */     // GIR_Coverage, 4732,
     /* 702460 */     GIR_EraseRootFromParent_Done,
     /* 702461 */   // Label 9141: @702461
     /* 702461 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(702533), // Rule ID 4736 //
     /* 702466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 702469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702477 */     // MIs[0] offset
     /* 702477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702480 */     // MIs[0] auxiliary
     /* 702480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702483 */     // MIs[0] Operand 7
     /* 702483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702501 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 702504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702513 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702531 */     GIR_RootConstrainSelectedInstOperands,
     /* 702532 */     // GIR_Coverage, 4736,
     /* 702532 */     GIR_EraseRootFromParent_Done,
     /* 702533 */   // Label 9142: @702533
     /* 702533 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(702602), // Rule ID 4740 //
     /* 702538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702546 */     // MIs[0] offset
     /* 702546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702549 */     // MIs[0] auxiliary
     /* 702549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702552 */     // MIs[0] Operand 7
     /* 702552 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702570 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 702573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702582 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702584 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702590 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702600 */     GIR_RootConstrainSelectedInstOperands,
     /* 702601 */     // GIR_Coverage, 4740,
     /* 702601 */     GIR_EraseRootFromParent_Done,
     /* 702602 */   // Label 9143: @702602
     /* 702602 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(702672), // Rule ID 4729 //
     /* 702607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 702610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702614 */     // MIs[0] offset
     /* 702614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702617 */     // MIs[0] auxiliary
     /* 702617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702620 */     // MIs[0] Operand 7
     /* 702620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702638 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 702641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702643 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702652 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702670 */     GIR_RootConstrainSelectedInstOperands,
     /* 702671 */     // GIR_Coverage, 4729,
     /* 702671 */     GIR_EraseRootFromParent_Done,
     /* 702672 */   // Label 9144: @702672
     /* 702672 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(702739), // Rule ID 4733 //
     /* 702677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702681 */     // MIs[0] offset
     /* 702681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702684 */     // MIs[0] auxiliary
     /* 702684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702687 */     // MIs[0] Operand 7
     /* 702687 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702705 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 702708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702710 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702719 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702737 */     GIR_RootConstrainSelectedInstOperands,
     /* 702738 */     // GIR_Coverage, 4733,
     /* 702738 */     GIR_EraseRootFromParent_Done,
     /* 702739 */   // Label 9145: @702739
     /* 702739 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(702809), // Rule ID 4737 //
     /* 702744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 702747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702751 */     // MIs[0] offset
     /* 702751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702754 */     // MIs[0] auxiliary
     /* 702754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702757 */     // MIs[0] Operand 7
     /* 702757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702775 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 702778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702780 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702789 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702807 */     GIR_RootConstrainSelectedInstOperands,
     /* 702808 */     // GIR_Coverage, 4737,
     /* 702808 */     GIR_EraseRootFromParent_Done,
     /* 702809 */   // Label 9146: @702809
     /* 702809 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(702876), // Rule ID 4741 //
     /* 702814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 702818 */     // MIs[0] offset
     /* 702818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702821 */     // MIs[0] auxiliary
     /* 702821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702824 */     // MIs[0] Operand 7
     /* 702824 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 702835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702842 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 702845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702847 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 702849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702856 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702864 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702874 */     GIR_RootConstrainSelectedInstOperands,
     /* 702875 */     // GIR_Coverage, 4741,
     /* 702875 */     GIR_EraseRootFromParent_Done,
     /* 702876 */   // Label 9147: @702876
     /* 702876 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(702938), // Rule ID 4730 //
     /* 702881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 702884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702888 */     // MIs[0] offset
     /* 702888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702891 */     // MIs[0] auxiliary
     /* 702891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702894 */     // MIs[0] Operand 7
     /* 702894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702904 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 702907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702909 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702918 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702936 */     GIR_RootConstrainSelectedInstOperands,
     /* 702937 */     // GIR_Coverage, 4730,
     /* 702937 */     GIR_EraseRootFromParent_Done,
     /* 702938 */   // Label 9148: @702938
     /* 702938 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(702997), // Rule ID 4734 //
     /* 702943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 702947 */     // MIs[0] offset
     /* 702947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 702950 */     // MIs[0] auxiliary
     /* 702950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 702953 */     // MIs[0] Operand 7
     /* 702953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 702956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 702963 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 702963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 702966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 702968 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 702970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 702972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 702977 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 702979 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 702985 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 702991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 702995 */     GIR_RootConstrainSelectedInstOperands,
     /* 702996 */     // GIR_Coverage, 4734,
     /* 702996 */     GIR_EraseRootFromParent_Done,
     /* 702997 */   // Label 9149: @702997
     /* 702997 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(703059), // Rule ID 4738 //
     /* 703002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 703005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703009 */     // MIs[0] offset
     /* 703009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703012 */     // MIs[0] auxiliary
     /* 703012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703015 */     // MIs[0] Operand 7
     /* 703015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703025 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 703028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703030 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 703032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703039 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703047 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703057 */     GIR_RootConstrainSelectedInstOperands,
     /* 703058 */     // GIR_Coverage, 4738,
     /* 703058 */     GIR_EraseRootFromParent_Done,
     /* 703059 */   // Label 9150: @703059
     /* 703059 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(703118), // Rule ID 4742 //
     /* 703064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703068 */     // MIs[0] offset
     /* 703068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703071 */     // MIs[0] auxiliary
     /* 703071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703074 */     // MIs[0] Operand 7
     /* 703074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703084 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 703087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703089 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 703091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703098 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703116 */     GIR_RootConstrainSelectedInstOperands,
     /* 703117 */     // GIR_Coverage, 4742,
     /* 703117 */     GIR_EraseRootFromParent_Done,
     /* 703118 */   // Label 9151: @703118
     /* 703118 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(703218), // Rule ID 4731 //
     /* 703123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 703126 */     // MIs[0] offset
     /* 703126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703129 */     // MIs[0] auxiliary
     /* 703129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703132 */     // MIs[0] Operand 7
     /* 703132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703142 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703158 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703165 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 703186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703198 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703216 */     GIR_RootConstrainSelectedInstOperands,
     /* 703217 */     // GIR_Coverage, 4731,
     /* 703217 */     GIR_EraseRootFromParent_Done,
     /* 703218 */   // Label 9152: @703218
     /* 703218 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(703315), // Rule ID 4735 //
     /* 703223 */     // MIs[0] offset
     /* 703223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703226 */     // MIs[0] auxiliary
     /* 703226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703229 */     // MIs[0] Operand 7
     /* 703229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703239 */     // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703251 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703255 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703262 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 703283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703295 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703313 */     GIR_RootConstrainSelectedInstOperands,
     /* 703314 */     // GIR_Coverage, 4735,
     /* 703314 */     GIR_EraseRootFromParent_Done,
     /* 703315 */   // Label 9153: @703315
     /* 703315 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(703415), // Rule ID 4739 //
     /* 703320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 703323 */     // MIs[0] offset
     /* 703323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703326 */     // MIs[0] auxiliary
     /* 703326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703329 */     // MIs[0] Operand 7
     /* 703329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703339 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703355 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703362 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 703383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703395 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703413 */     GIR_RootConstrainSelectedInstOperands,
     /* 703414 */     // GIR_Coverage, 4739,
     /* 703414 */     GIR_EraseRootFromParent_Done,
     /* 703415 */   // Label 9154: @703415
     /* 703415 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(703512), // Rule ID 4743 //
     /* 703420 */     // MIs[0] offset
     /* 703420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703423 */     // MIs[0] auxiliary
     /* 703423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703426 */     // MIs[0] Operand 7
     /* 703426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 703429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703436 */     // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 703439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 703443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 703448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 703452 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 703455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 703459 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 703462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 703467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 703477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 703480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 703485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703492 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703494 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703510 */     GIR_RootConstrainSelectedInstOperands,
     /* 703511 */     // GIR_Coverage, 4743,
     /* 703511 */     GIR_EraseRootFromParent_Done,
     /* 703512 */   // Label 9155: @703512
     /* 703512 */   GIM_Reject,
     /* 703513 */ // Label 9139: @703513
     /* 703513 */ GIM_Reject,
     /* 703514 */ // Label 9119: @703514
     /* 703514 */ GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(704728),
     /* 703519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 703522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 703525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 703528 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 703531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 703535 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(703607), // Rule ID 4744 //
     /* 703540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 703543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703551 */     // MIs[0] offset
     /* 703551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703554 */     // MIs[0] auxiliary
     /* 703554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703557 */     // MIs[0] Operand 7
     /* 703557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703575 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 703578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703587 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703589 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703595 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703605 */     GIR_RootConstrainSelectedInstOperands,
     /* 703606 */     // GIR_Coverage, 4744,
     /* 703606 */     GIR_EraseRootFromParent_Done,
     /* 703607 */   // Label 9157: @703607
     /* 703607 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(703676), // Rule ID 4748 //
     /* 703612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703620 */     // MIs[0] offset
     /* 703620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703623 */     // MIs[0] auxiliary
     /* 703623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703626 */     // MIs[0] Operand 7
     /* 703626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703644 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 703647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703656 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703674 */     GIR_RootConstrainSelectedInstOperands,
     /* 703675 */     // GIR_Coverage, 4748,
     /* 703675 */     GIR_EraseRootFromParent_Done,
     /* 703676 */   // Label 9158: @703676
     /* 703676 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(703748), // Rule ID 4752 //
     /* 703681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 703684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703692 */     // MIs[0] offset
     /* 703692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703695 */     // MIs[0] auxiliary
     /* 703695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703698 */     // MIs[0] Operand 7
     /* 703698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703716 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 703719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703728 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703746 */     GIR_RootConstrainSelectedInstOperands,
     /* 703747 */     // GIR_Coverage, 4752,
     /* 703747 */     GIR_EraseRootFromParent_Done,
     /* 703748 */   // Label 9159: @703748
     /* 703748 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(703817), // Rule ID 4756 //
     /* 703753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 703761 */     // MIs[0] offset
     /* 703761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703764 */     // MIs[0] auxiliary
     /* 703764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703767 */     // MIs[0] Operand 7
     /* 703767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703785 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 703788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703797 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703799 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703805 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703815 */     GIR_RootConstrainSelectedInstOperands,
     /* 703816 */     // GIR_Coverage, 4756,
     /* 703816 */     GIR_EraseRootFromParent_Done,
     /* 703817 */   // Label 9160: @703817
     /* 703817 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(703887), // Rule ID 4745 //
     /* 703822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 703825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703829 */     // MIs[0] offset
     /* 703829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703832 */     // MIs[0] auxiliary
     /* 703832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703835 */     // MIs[0] Operand 7
     /* 703835 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703853 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 703856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703858 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 703860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703867 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703869 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703885 */     GIR_RootConstrainSelectedInstOperands,
     /* 703886 */     // GIR_Coverage, 4745,
     /* 703886 */     GIR_EraseRootFromParent_Done,
     /* 703887 */   // Label 9161: @703887
     /* 703887 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(703954), // Rule ID 4749 //
     /* 703892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703896 */     // MIs[0] offset
     /* 703896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703899 */     // MIs[0] auxiliary
     /* 703899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703902 */     // MIs[0] Operand 7
     /* 703902 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703920 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 703923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703925 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 703927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 703934 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 703936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 703942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 703948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 703952 */     GIR_RootConstrainSelectedInstOperands,
     /* 703953 */     // GIR_Coverage, 4749,
     /* 703953 */     GIR_EraseRootFromParent_Done,
     /* 703954 */   // Label 9162: @703954
     /* 703954 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(704024), // Rule ID 4753 //
     /* 703959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 703962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 703966 */     // MIs[0] offset
     /* 703966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 703969 */     // MIs[0] auxiliary
     /* 703969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 703972 */     // MIs[0] Operand 7
     /* 703972 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 703983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 703990 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 703990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 703993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 703995 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 703997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 703999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704004 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704006 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704022 */     GIR_RootConstrainSelectedInstOperands,
     /* 704023 */     // GIR_Coverage, 4753,
     /* 704023 */     GIR_EraseRootFromParent_Done,
     /* 704024 */   // Label 9163: @704024
     /* 704024 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(704091), // Rule ID 4757 //
     /* 704029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704033 */     // MIs[0] offset
     /* 704033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704036 */     // MIs[0] auxiliary
     /* 704036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704039 */     // MIs[0] Operand 7
     /* 704039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704057 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 704060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704062 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 704064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704071 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704089 */     GIR_RootConstrainSelectedInstOperands,
     /* 704090 */     // GIR_Coverage, 4757,
     /* 704090 */     GIR_EraseRootFromParent_Done,
     /* 704091 */   // Label 9164: @704091
     /* 704091 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(704153), // Rule ID 4746 //
     /* 704096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 704099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704103 */     // MIs[0] offset
     /* 704103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704106 */     // MIs[0] auxiliary
     /* 704106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704109 */     // MIs[0] Operand 7
     /* 704109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704119 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 704122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704124 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704133 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704151 */     GIR_RootConstrainSelectedInstOperands,
     /* 704152 */     // GIR_Coverage, 4746,
     /* 704152 */     GIR_EraseRootFromParent_Done,
     /* 704153 */   // Label 9165: @704153
     /* 704153 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(704212), // Rule ID 4750 //
     /* 704158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704162 */     // MIs[0] offset
     /* 704162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704165 */     // MIs[0] auxiliary
     /* 704165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704168 */     // MIs[0] Operand 7
     /* 704168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704178 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 704181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704183 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704192 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704210 */     GIR_RootConstrainSelectedInstOperands,
     /* 704211 */     // GIR_Coverage, 4750,
     /* 704211 */     GIR_EraseRootFromParent_Done,
     /* 704212 */   // Label 9166: @704212
     /* 704212 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(704274), // Rule ID 4754 //
     /* 704217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 704220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704224 */     // MIs[0] offset
     /* 704224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704227 */     // MIs[0] auxiliary
     /* 704227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704230 */     // MIs[0] Operand 7
     /* 704230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704240 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 704243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704245 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704254 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704262 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704272 */     GIR_RootConstrainSelectedInstOperands,
     /* 704273 */     // GIR_Coverage, 4754,
     /* 704273 */     GIR_EraseRootFromParent_Done,
     /* 704274 */   // Label 9167: @704274
     /* 704274 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(704333), // Rule ID 4758 //
     /* 704279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704283 */     // MIs[0] offset
     /* 704283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704286 */     // MIs[0] auxiliary
     /* 704286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704289 */     // MIs[0] Operand 7
     /* 704289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704299 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 704302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704304 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 704306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704313 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704331 */     GIR_RootConstrainSelectedInstOperands,
     /* 704332 */     // GIR_Coverage, 4758,
     /* 704332 */     GIR_EraseRootFromParent_Done,
     /* 704333 */   // Label 9168: @704333
     /* 704333 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(704433), // Rule ID 4747 //
     /* 704338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 704341 */     // MIs[0] offset
     /* 704341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704344 */     // MIs[0] auxiliary
     /* 704344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704347 */     // MIs[0] Operand 7
     /* 704347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704357 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704369 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704373 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704380 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 704401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704413 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704421 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704431 */     GIR_RootConstrainSelectedInstOperands,
     /* 704432 */     // GIR_Coverage, 4747,
     /* 704432 */     GIR_EraseRootFromParent_Done,
     /* 704433 */   // Label 9169: @704433
     /* 704433 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(704530), // Rule ID 4751 //
     /* 704438 */     // MIs[0] offset
     /* 704438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704441 */     // MIs[0] auxiliary
     /* 704441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704444 */     // MIs[0] Operand 7
     /* 704444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704454 */     // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704470 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704477 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 704498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704510 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704528 */     GIR_RootConstrainSelectedInstOperands,
     /* 704529 */     // GIR_Coverage, 4751,
     /* 704529 */     GIR_EraseRootFromParent_Done,
     /* 704530 */   // Label 9170: @704530
     /* 704530 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(704630), // Rule ID 4755 //
     /* 704535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 704538 */     // MIs[0] offset
     /* 704538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704541 */     // MIs[0] auxiliary
     /* 704541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704544 */     // MIs[0] Operand 7
     /* 704544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704554 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704570 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704577 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 704598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704610 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704628 */     GIR_RootConstrainSelectedInstOperands,
     /* 704629 */     // GIR_Coverage, 4755,
     /* 704629 */     GIR_EraseRootFromParent_Done,
     /* 704630 */   // Label 9171: @704630
     /* 704630 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(704727), // Rule ID 4759 //
     /* 704635 */     // MIs[0] offset
     /* 704635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704638 */     // MIs[0] auxiliary
     /* 704638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704641 */     // MIs[0] Operand 7
     /* 704641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 704644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704651 */     // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 704654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 704658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 704663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 704667 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 704670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 704674 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 704677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 704682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 704692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 704695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 704700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704707 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704709 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704715 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704725 */     GIR_RootConstrainSelectedInstOperands,
     /* 704726 */     // GIR_Coverage, 4759,
     /* 704726 */     GIR_EraseRootFromParent_Done,
     /* 704727 */   // Label 9172: @704727
     /* 704727 */   GIM_Reject,
     /* 704728 */ // Label 9156: @704728
     /* 704728 */ GIM_Reject,
     /* 704729 */ // Label 9120: @704729
     /* 704729 */ GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(705943),
     /* 704734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 704737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 704740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 704743 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 704746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 704750 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(704822), // Rule ID 4760 //
     /* 704755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 704758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704766 */     // MIs[0] offset
     /* 704766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704769 */     // MIs[0] auxiliary
     /* 704769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704772 */     // MIs[0] Operand 7
     /* 704772 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704790 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 704793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704802 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704804 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704820 */     GIR_RootConstrainSelectedInstOperands,
     /* 704821 */     // GIR_Coverage, 4760,
     /* 704821 */     GIR_EraseRootFromParent_Done,
     /* 704822 */   // Label 9174: @704822
     /* 704822 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(704891), // Rule ID 4764 //
     /* 704827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704835 */     // MIs[0] offset
     /* 704835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704838 */     // MIs[0] auxiliary
     /* 704838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704841 */     // MIs[0] Operand 7
     /* 704841 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704859 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 704862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704871 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704889 */     GIR_RootConstrainSelectedInstOperands,
     /* 704890 */     // GIR_Coverage, 4764,
     /* 704890 */     GIR_EraseRootFromParent_Done,
     /* 704891 */   // Label 9175: @704891
     /* 704891 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(704963), // Rule ID 4768 //
     /* 704896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 704899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704907 */     // MIs[0] offset
     /* 704907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704910 */     // MIs[0] auxiliary
     /* 704910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704913 */     // MIs[0] Operand 7
     /* 704913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 704931 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 704931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 704934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 704936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 704938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 704943 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 704945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 704951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 704957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 704961 */     GIR_RootConstrainSelectedInstOperands,
     /* 704962 */     // GIR_Coverage, 4768,
     /* 704962 */     GIR_EraseRootFromParent_Done,
     /* 704963 */   // Label 9176: @704963
     /* 704963 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(705032), // Rule ID 4772 //
     /* 704968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 704972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 704976 */     // MIs[0] offset
     /* 704976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 704979 */     // MIs[0] auxiliary
     /* 704979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 704982 */     // MIs[0] Operand 7
     /* 704982 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 704993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705000 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 705003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705012 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705030 */     GIR_RootConstrainSelectedInstOperands,
     /* 705031 */     // GIR_Coverage, 4772,
     /* 705031 */     GIR_EraseRootFromParent_Done,
     /* 705032 */   // Label 9177: @705032
     /* 705032 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(705102), // Rule ID 4761 //
     /* 705037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 705040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705044 */     // MIs[0] offset
     /* 705044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705047 */     // MIs[0] auxiliary
     /* 705047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705050 */     // MIs[0] Operand 7
     /* 705050 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705068 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 705071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705073 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705082 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705100 */     GIR_RootConstrainSelectedInstOperands,
     /* 705101 */     // GIR_Coverage, 4761,
     /* 705101 */     GIR_EraseRootFromParent_Done,
     /* 705102 */   // Label 9178: @705102
     /* 705102 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(705169), // Rule ID 4765 //
     /* 705107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705111 */     // MIs[0] offset
     /* 705111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705114 */     // MIs[0] auxiliary
     /* 705114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705117 */     // MIs[0] Operand 7
     /* 705117 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705135 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 705138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705140 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705149 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705157 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705167 */     GIR_RootConstrainSelectedInstOperands,
     /* 705168 */     // GIR_Coverage, 4765,
     /* 705168 */     GIR_EraseRootFromParent_Done,
     /* 705169 */   // Label 9179: @705169
     /* 705169 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(705239), // Rule ID 4769 //
     /* 705174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 705177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705181 */     // MIs[0] offset
     /* 705181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705184 */     // MIs[0] auxiliary
     /* 705184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705187 */     // MIs[0] Operand 7
     /* 705187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705205 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 705208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705210 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705219 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705237 */     GIR_RootConstrainSelectedInstOperands,
     /* 705238 */     // GIR_Coverage, 4769,
     /* 705238 */     GIR_EraseRootFromParent_Done,
     /* 705239 */   // Label 9180: @705239
     /* 705239 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(705306), // Rule ID 4773 //
     /* 705244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 705248 */     // MIs[0] offset
     /* 705248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705251 */     // MIs[0] auxiliary
     /* 705251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705254 */     // MIs[0] Operand 7
     /* 705254 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 705265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705272 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 705275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705277 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 705279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705286 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705304 */     GIR_RootConstrainSelectedInstOperands,
     /* 705305 */     // GIR_Coverage, 4773,
     /* 705305 */     GIR_EraseRootFromParent_Done,
     /* 705306 */   // Label 9181: @705306
     /* 705306 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(705368), // Rule ID 4762 //
     /* 705311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 705314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705318 */     // MIs[0] offset
     /* 705318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705321 */     // MIs[0] auxiliary
     /* 705321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705324 */     // MIs[0] Operand 7
     /* 705324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705334 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 705337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705339 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705348 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705366 */     GIR_RootConstrainSelectedInstOperands,
     /* 705367 */     // GIR_Coverage, 4762,
     /* 705367 */     GIR_EraseRootFromParent_Done,
     /* 705368 */   // Label 9182: @705368
     /* 705368 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(705427), // Rule ID 4766 //
     /* 705373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705377 */     // MIs[0] offset
     /* 705377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705380 */     // MIs[0] auxiliary
     /* 705380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705383 */     // MIs[0] Operand 7
     /* 705383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705393 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 705396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705398 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705407 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705425 */     GIR_RootConstrainSelectedInstOperands,
     /* 705426 */     // GIR_Coverage, 4766,
     /* 705426 */     GIR_EraseRootFromParent_Done,
     /* 705427 */   // Label 9183: @705427
     /* 705427 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(705489), // Rule ID 4770 //
     /* 705432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 705435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705439 */     // MIs[0] offset
     /* 705439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705442 */     // MIs[0] auxiliary
     /* 705442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705445 */     // MIs[0] Operand 7
     /* 705445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705455 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 705458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705460 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705469 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705477 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705487 */     GIR_RootConstrainSelectedInstOperands,
     /* 705488 */     // GIR_Coverage, 4770,
     /* 705488 */     GIR_EraseRootFromParent_Done,
     /* 705489 */   // Label 9184: @705489
     /* 705489 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(705548), // Rule ID 4774 //
     /* 705494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 705498 */     // MIs[0] offset
     /* 705498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705501 */     // MIs[0] auxiliary
     /* 705501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705504 */     // MIs[0] Operand 7
     /* 705504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705514 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 705517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705519 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 705521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705528 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705536 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705546 */     GIR_RootConstrainSelectedInstOperands,
     /* 705547 */     // GIR_Coverage, 4774,
     /* 705547 */     GIR_EraseRootFromParent_Done,
     /* 705548 */   // Label 9185: @705548
     /* 705548 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(705648), // Rule ID 4763 //
     /* 705553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 705556 */     // MIs[0] offset
     /* 705556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705559 */     // MIs[0] auxiliary
     /* 705559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705562 */     // MIs[0] Operand 7
     /* 705562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705572 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705588 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705595 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 705616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705628 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705646 */     GIR_RootConstrainSelectedInstOperands,
     /* 705647 */     // GIR_Coverage, 4763,
     /* 705647 */     GIR_EraseRootFromParent_Done,
     /* 705648 */   // Label 9186: @705648
     /* 705648 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(705745), // Rule ID 4767 //
     /* 705653 */     // MIs[0] offset
     /* 705653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705656 */     // MIs[0] auxiliary
     /* 705656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705659 */     // MIs[0] Operand 7
     /* 705659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705669 */     // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705685 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705692 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 705713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705725 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705743 */     GIR_RootConstrainSelectedInstOperands,
     /* 705744 */     // GIR_Coverage, 4767,
     /* 705744 */     GIR_EraseRootFromParent_Done,
     /* 705745 */   // Label 9187: @705745
     /* 705745 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(705845), // Rule ID 4771 //
     /* 705750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 705753 */     // MIs[0] offset
     /* 705753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705756 */     // MIs[0] auxiliary
     /* 705756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705759 */     // MIs[0] Operand 7
     /* 705759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705769 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705785 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705792 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 705813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705825 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705843 */     GIR_RootConstrainSelectedInstOperands,
     /* 705844 */     // GIR_Coverage, 4771,
     /* 705844 */     GIR_EraseRootFromParent_Done,
     /* 705845 */   // Label 9188: @705845
     /* 705845 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(705942), // Rule ID 4775 //
     /* 705850 */     // MIs[0] offset
     /* 705850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 705853 */     // MIs[0] auxiliary
     /* 705853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 705856 */     // MIs[0] Operand 7
     /* 705856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 705859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 705866 */     // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 705866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 705869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 705873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 705878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 705882 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 705885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 705889 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 705892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 705897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 705907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 705910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 705912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 705915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 705917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 705922 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 705924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 705930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 705936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 705940 */     GIR_RootConstrainSelectedInstOperands,
     /* 705941 */     // GIR_Coverage, 4775,
     /* 705941 */     GIR_EraseRootFromParent_Done,
     /* 705942 */   // Label 9189: @705942
     /* 705942 */   GIM_Reject,
     /* 705943 */ // Label 9173: @705943
     /* 705943 */ GIM_Reject,
     /* 705944 */ // Label 9121: @705944
     /* 705944 */ GIM_Reject,
     /* 705945 */ // Label 127: @705945
     /* 705945 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9197*/ GIMT_Encode4(713689),
     /* 705956 */ /*GILLT_s16*//*Label 9190*/ GIMT_Encode4(705996),
     /* 705960 */ /*GILLT_s32*//*Label 9191*/ GIMT_Encode4(707843), GIMT_Encode4(0),
     /* 705968 */ /*GILLT_v2s16*//*Label 9192*/ GIMT_Encode4(708778),
     /* 705972 */ /*GILLT_v2s32*//*Label 9193*/ GIMT_Encode4(710017), GIMT_Encode4(0),
     /* 705980 */ /*GILLT_v3s32*//*Label 9194*/ GIMT_Encode4(710344), GIMT_Encode4(0),
     /* 705988 */ /*GILLT_v4s16*//*Label 9195*/ GIMT_Encode4(710671),
     /* 705992 */ /*GILLT_v4s32*//*Label 9196*/ GIMT_Encode4(713362),
     /* 705996 */ // Label 9190: @705996
     /* 705996 */ GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(707842),
     /* 706001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 706004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 706007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 706010 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 706013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 706017 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(706089), // Rule ID 4808 //
     /* 706022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706033 */     // MIs[0] offset
     /* 706033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706036 */     // MIs[0] auxiliary
     /* 706036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706039 */     // MIs[0] Operand 7
     /* 706039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706057 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 706060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706069 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706087 */     GIR_RootConstrainSelectedInstOperands,
     /* 706088 */     // GIR_Coverage, 4808,
     /* 706088 */     GIR_EraseRootFromParent_Done,
     /* 706089 */   // Label 9199: @706089
     /* 706089 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(706161), // Rule ID 4812 //
     /* 706094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706105 */     // MIs[0] offset
     /* 706105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706108 */     // MIs[0] auxiliary
     /* 706108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706111 */     // MIs[0] Operand 7
     /* 706111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706129 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 706132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706141 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706143 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706159 */     GIR_RootConstrainSelectedInstOperands,
     /* 706160 */     // GIR_Coverage, 4812,
     /* 706160 */     GIR_EraseRootFromParent_Done,
     /* 706161 */   // Label 9200: @706161
     /* 706161 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(706233), // Rule ID 4832 //
     /* 706166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706177 */     // MIs[0] offset
     /* 706177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706180 */     // MIs[0] auxiliary
     /* 706180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706183 */     // MIs[0] Operand 7
     /* 706183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706201 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 706204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706213 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706231 */     GIR_RootConstrainSelectedInstOperands,
     /* 706232 */     // GIR_Coverage, 4832,
     /* 706232 */     GIR_EraseRootFromParent_Done,
     /* 706233 */   // Label 9201: @706233
     /* 706233 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(706305), // Rule ID 4836 //
     /* 706238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706249 */     // MIs[0] offset
     /* 706249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706252 */     // MIs[0] auxiliary
     /* 706252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706255 */     // MIs[0] Operand 7
     /* 706255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706273 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 706276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706285 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706293 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706303 */     GIR_RootConstrainSelectedInstOperands,
     /* 706304 */     // GIR_Coverage, 4836,
     /* 706304 */     GIR_EraseRootFromParent_Done,
     /* 706305 */   // Label 9202: @706305
     /* 706305 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(706377), // Rule ID 4840 //
     /* 706310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706321 */     // MIs[0] offset
     /* 706321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706324 */     // MIs[0] auxiliary
     /* 706324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706327 */     // MIs[0] Operand 7
     /* 706327 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706345 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 706348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706357 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706375 */     GIR_RootConstrainSelectedInstOperands,
     /* 706376 */     // GIR_Coverage, 4840,
     /* 706376 */     GIR_EraseRootFromParent_Done,
     /* 706377 */   // Label 9203: @706377
     /* 706377 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(706449), // Rule ID 4844 //
     /* 706382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706393 */     // MIs[0] offset
     /* 706393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706396 */     // MIs[0] auxiliary
     /* 706396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706399 */     // MIs[0] Operand 7
     /* 706399 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706417 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 706420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706429 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706447 */     GIR_RootConstrainSelectedInstOperands,
     /* 706448 */     // GIR_Coverage, 4844,
     /* 706448 */     GIR_EraseRootFromParent_Done,
     /* 706449 */   // Label 9204: @706449
     /* 706449 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(706519), // Rule ID 4809 //
     /* 706454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706461 */     // MIs[0] offset
     /* 706461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706464 */     // MIs[0] auxiliary
     /* 706464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706467 */     // MIs[0] Operand 7
     /* 706467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706485 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 706488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706490 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706499 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706517 */     GIR_RootConstrainSelectedInstOperands,
     /* 706518 */     // GIR_Coverage, 4809,
     /* 706518 */     GIR_EraseRootFromParent_Done,
     /* 706519 */   // Label 9205: @706519
     /* 706519 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(706589), // Rule ID 4813 //
     /* 706524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706531 */     // MIs[0] offset
     /* 706531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706534 */     // MIs[0] auxiliary
     /* 706534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706537 */     // MIs[0] Operand 7
     /* 706537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706555 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 706558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706560 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706587 */     GIR_RootConstrainSelectedInstOperands,
     /* 706588 */     // GIR_Coverage, 4813,
     /* 706588 */     GIR_EraseRootFromParent_Done,
     /* 706589 */   // Label 9206: @706589
     /* 706589 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(706659), // Rule ID 4833 //
     /* 706594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706601 */     // MIs[0] offset
     /* 706601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706604 */     // MIs[0] auxiliary
     /* 706604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706607 */     // MIs[0] Operand 7
     /* 706607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706625 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 706628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706630 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706639 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706657 */     GIR_RootConstrainSelectedInstOperands,
     /* 706658 */     // GIR_Coverage, 4833,
     /* 706658 */     GIR_EraseRootFromParent_Done,
     /* 706659 */   // Label 9207: @706659
     /* 706659 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(706729), // Rule ID 4837 //
     /* 706664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706671 */     // MIs[0] offset
     /* 706671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706674 */     // MIs[0] auxiliary
     /* 706674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706677 */     // MIs[0] Operand 7
     /* 706677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706695 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 706698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706700 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706709 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706727 */     GIR_RootConstrainSelectedInstOperands,
     /* 706728 */     // GIR_Coverage, 4837,
     /* 706728 */     GIR_EraseRootFromParent_Done,
     /* 706729 */   // Label 9208: @706729
     /* 706729 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(706799), // Rule ID 4841 //
     /* 706734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 706737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706741 */     // MIs[0] offset
     /* 706741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706744 */     // MIs[0] auxiliary
     /* 706744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706747 */     // MIs[0] Operand 7
     /* 706747 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706765 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 706768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706770 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706779 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706797 */     GIR_RootConstrainSelectedInstOperands,
     /* 706798 */     // GIR_Coverage, 4841,
     /* 706798 */     GIR_EraseRootFromParent_Done,
     /* 706799 */   // Label 9209: @706799
     /* 706799 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(706869), // Rule ID 4845 //
     /* 706804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 706807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 706811 */     // MIs[0] offset
     /* 706811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706814 */     // MIs[0] auxiliary
     /* 706814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706817 */     // MIs[0] Operand 7
     /* 706817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 706828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706835 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 706838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706840 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 706842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706849 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706867 */     GIR_RootConstrainSelectedInstOperands,
     /* 706868 */     // GIR_Coverage, 4845,
     /* 706868 */     GIR_EraseRootFromParent_Done,
     /* 706869 */   // Label 9210: @706869
     /* 706869 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(706931), // Rule ID 4810 //
     /* 706874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706881 */     // MIs[0] offset
     /* 706881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706884 */     // MIs[0] auxiliary
     /* 706884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706887 */     // MIs[0] Operand 7
     /* 706887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706897 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 706900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706902 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 706904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706911 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706913 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706929 */     GIR_RootConstrainSelectedInstOperands,
     /* 706930 */     // GIR_Coverage, 4810,
     /* 706930 */     GIR_EraseRootFromParent_Done,
     /* 706931 */   // Label 9211: @706931
     /* 706931 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(706993), // Rule ID 4814 //
     /* 706936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 706939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 706943 */     // MIs[0] offset
     /* 706943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 706946 */     // MIs[0] auxiliary
     /* 706946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 706949 */     // MIs[0] Operand 7
     /* 706949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 706952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 706959 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 706959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 706962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 706964 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 706966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 706968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 706973 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 706975 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 706981 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 706987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 706991 */     GIR_RootConstrainSelectedInstOperands,
     /* 706992 */     // GIR_Coverage, 4814,
     /* 706992 */     GIR_EraseRootFromParent_Done,
     /* 706993 */   // Label 9212: @706993
     /* 706993 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(707055), // Rule ID 4834 //
     /* 706998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707005 */     // MIs[0] offset
     /* 707005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707008 */     // MIs[0] auxiliary
     /* 707008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707011 */     // MIs[0] Operand 7
     /* 707011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707021 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 707024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707026 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707035 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707053 */     GIR_RootConstrainSelectedInstOperands,
     /* 707054 */     // GIR_Coverage, 4834,
     /* 707054 */     GIR_EraseRootFromParent_Done,
     /* 707055 */   // Label 9213: @707055
     /* 707055 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(707117), // Rule ID 4838 //
     /* 707060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707067 */     // MIs[0] offset
     /* 707067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707070 */     // MIs[0] auxiliary
     /* 707070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707073 */     // MIs[0] Operand 7
     /* 707073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707083 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 707086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707088 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707097 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707115 */     GIR_RootConstrainSelectedInstOperands,
     /* 707116 */     // GIR_Coverage, 4838,
     /* 707116 */     GIR_EraseRootFromParent_Done,
     /* 707117 */   // Label 9214: @707117
     /* 707117 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(707179), // Rule ID 4842 //
     /* 707122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707129 */     // MIs[0] offset
     /* 707129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707132 */     // MIs[0] auxiliary
     /* 707132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707135 */     // MIs[0] Operand 7
     /* 707135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707145 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 707148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707150 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707159 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707177 */     GIR_RootConstrainSelectedInstOperands,
     /* 707178 */     // GIR_Coverage, 4842,
     /* 707178 */     GIR_EraseRootFromParent_Done,
     /* 707179 */   // Label 9215: @707179
     /* 707179 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(707241), // Rule ID 4846 //
     /* 707184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707191 */     // MIs[0] offset
     /* 707191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707194 */     // MIs[0] auxiliary
     /* 707194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707197 */     // MIs[0] Operand 7
     /* 707197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707207 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 707210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707212 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 707214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707221 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707239 */     GIR_RootConstrainSelectedInstOperands,
     /* 707240 */     // GIR_Coverage, 4846,
     /* 707240 */     GIR_EraseRootFromParent_Done,
     /* 707241 */   // Label 9216: @707241
     /* 707241 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(707341), // Rule ID 4811 //
     /* 707246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 707249 */     // MIs[0] offset
     /* 707249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707252 */     // MIs[0] auxiliary
     /* 707252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707255 */     // MIs[0] Operand 7
     /* 707255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707265 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 707268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 707272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 707277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 707281 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 707284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 707288 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 707291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 707296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 707309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 707314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707321 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707323 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707329 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707339 */     GIR_RootConstrainSelectedInstOperands,
     /* 707340 */     // GIR_Coverage, 4811,
     /* 707340 */     GIR_EraseRootFromParent_Done,
     /* 707341 */   // Label 9217: @707341
     /* 707341 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(707441), // Rule ID 4815 //
     /* 707346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 707349 */     // MIs[0] offset
     /* 707349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707352 */     // MIs[0] auxiliary
     /* 707352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707355 */     // MIs[0] Operand 7
     /* 707355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707365 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 707368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 707372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 707377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 707381 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 707384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 707388 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 707391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 707396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 707409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 707414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707421 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707429 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707439 */     GIR_RootConstrainSelectedInstOperands,
     /* 707440 */     // GIR_Coverage, 4815,
     /* 707440 */     GIR_EraseRootFromParent_Done,
     /* 707441 */   // Label 9218: @707441
     /* 707441 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(707541), // Rule ID 4835 //
     /* 707446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707449 */     // MIs[0] offset
     /* 707449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707452 */     // MIs[0] auxiliary
     /* 707452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707455 */     // MIs[0] Operand 7
     /* 707455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707465 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 707468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 707472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 707477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 707481 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 707484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 707488 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 707491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 707496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 707509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 707514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707521 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707523 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707539 */     GIR_RootConstrainSelectedInstOperands,
     /* 707540 */     // GIR_Coverage, 4835,
     /* 707540 */     GIR_EraseRootFromParent_Done,
     /* 707541 */   // Label 9219: @707541
     /* 707541 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(707641), // Rule ID 4839 //
     /* 707546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707549 */     // MIs[0] offset
     /* 707549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707552 */     // MIs[0] auxiliary
     /* 707552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707555 */     // MIs[0] Operand 7
     /* 707555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707565 */     // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 707568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 707572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 707577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 707581 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 707584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 707588 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 707591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 707596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 707609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 707614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707621 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707623 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707639 */     GIR_RootConstrainSelectedInstOperands,
     /* 707640 */     // GIR_Coverage, 4839,
     /* 707640 */     GIR_EraseRootFromParent_Done,
     /* 707641 */   // Label 9220: @707641
     /* 707641 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(707741), // Rule ID 4843 //
     /* 707646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707649 */     // MIs[0] offset
     /* 707649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707652 */     // MIs[0] auxiliary
     /* 707652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707655 */     // MIs[0] Operand 7
     /* 707655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707665 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 707668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 707672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 707677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 707681 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 707684 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 707688 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 707691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 707696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 707709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 707714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707721 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707729 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707739 */     GIR_RootConstrainSelectedInstOperands,
     /* 707740 */     // GIR_Coverage, 4843,
     /* 707740 */     GIR_EraseRootFromParent_Done,
     /* 707741 */   // Label 9221: @707741
     /* 707741 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(707841), // Rule ID 4847 //
     /* 707746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 707749 */     // MIs[0] offset
     /* 707749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707752 */     // MIs[0] auxiliary
     /* 707752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707755 */     // MIs[0] Operand 7
     /* 707755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 707758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707765 */     // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 707768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 707772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 707777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 707781 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 707784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 707788 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 707791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 707796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 707806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 707809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 707814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707821 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707829 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707839 */     GIR_RootConstrainSelectedInstOperands,
     /* 707840 */     // GIR_Coverage, 4847,
     /* 707840 */     GIR_EraseRootFromParent_Done,
     /* 707841 */   // Label 9222: @707841
     /* 707841 */   GIM_Reject,
     /* 707842 */ // Label 9198: @707842
     /* 707842 */ GIM_Reject,
     /* 707843 */ // Label 9191: @707843
     /* 707843 */ GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(708777),
     /* 707848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 707851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 707854 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 707857 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 707860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 707864 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(707936), // Rule ID 4816 //
     /* 707869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 707872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707880 */     // MIs[0] offset
     /* 707880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707883 */     // MIs[0] auxiliary
     /* 707883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707886 */     // MIs[0] Operand 7
     /* 707886 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707904 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 707907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707916 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 707930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 707934 */     GIR_RootConstrainSelectedInstOperands,
     /* 707935 */     // GIR_Coverage, 4816,
     /* 707935 */     GIR_EraseRootFromParent_Done,
     /* 707936 */   // Label 9224: @707936
     /* 707936 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(708008), // Rule ID 4848 //
     /* 707941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 707944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 707948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 707952 */     // MIs[0] offset
     /* 707952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 707955 */     // MIs[0] auxiliary
     /* 707955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 707958 */     // MIs[0] Operand 7
     /* 707958 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 707969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 707976 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 707976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 707979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 707981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 707983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 707988 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 707990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 707996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708006 */     GIR_RootConstrainSelectedInstOperands,
     /* 708007 */     // GIR_Coverage, 4848,
     /* 708007 */     GIR_EraseRootFromParent_Done,
     /* 708008 */   // Label 9225: @708008
     /* 708008 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(708080), // Rule ID 4852 //
     /* 708013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708024 */     // MIs[0] offset
     /* 708024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708027 */     // MIs[0] auxiliary
     /* 708027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708030 */     // MIs[0] Operand 7
     /* 708030 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 708041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708048 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 708051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708060 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708068 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708078 */     GIR_RootConstrainSelectedInstOperands,
     /* 708079 */     // GIR_Coverage, 4852,
     /* 708079 */     GIR_EraseRootFromParent_Done,
     /* 708080 */   // Label 9226: @708080
     /* 708080 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(708150), // Rule ID 4817 //
     /* 708085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 708088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708092 */     // MIs[0] offset
     /* 708092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708095 */     // MIs[0] auxiliary
     /* 708095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708098 */     // MIs[0] Operand 7
     /* 708098 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 708109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708116 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 708119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708121 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 708123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708130 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708138 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708148 */     GIR_RootConstrainSelectedInstOperands,
     /* 708149 */     // GIR_Coverage, 4817,
     /* 708149 */     GIR_EraseRootFromParent_Done,
     /* 708150 */   // Label 9227: @708150
     /* 708150 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(708220), // Rule ID 4849 //
     /* 708155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708162 */     // MIs[0] offset
     /* 708162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708165 */     // MIs[0] auxiliary
     /* 708165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708168 */     // MIs[0] Operand 7
     /* 708168 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 708179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708186 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 708189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708191 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 708193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708200 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708208 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708218 */     GIR_RootConstrainSelectedInstOperands,
     /* 708219 */     // GIR_Coverage, 4849,
     /* 708219 */     GIR_EraseRootFromParent_Done,
     /* 708220 */   // Label 9228: @708220
     /* 708220 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(708290), // Rule ID 4853 //
     /* 708225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708232 */     // MIs[0] offset
     /* 708232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708235 */     // MIs[0] auxiliary
     /* 708235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708238 */     // MIs[0] Operand 7
     /* 708238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 708249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708256 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 708259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708261 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 708263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708270 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708272 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708278 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708288 */     GIR_RootConstrainSelectedInstOperands,
     /* 708289 */     // GIR_Coverage, 4853,
     /* 708289 */     GIR_EraseRootFromParent_Done,
     /* 708290 */   // Label 9229: @708290
     /* 708290 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(708352), // Rule ID 4818 //
     /* 708295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 708298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708302 */     // MIs[0] offset
     /* 708302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708305 */     // MIs[0] auxiliary
     /* 708305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708308 */     // MIs[0] Operand 7
     /* 708308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708318 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 708321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708323 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708332 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708334 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708340 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708350 */     GIR_RootConstrainSelectedInstOperands,
     /* 708351 */     // GIR_Coverage, 4818,
     /* 708351 */     GIR_EraseRootFromParent_Done,
     /* 708352 */   // Label 9230: @708352
     /* 708352 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(708414), // Rule ID 4850 //
     /* 708357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708364 */     // MIs[0] offset
     /* 708364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708367 */     // MIs[0] auxiliary
     /* 708367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708370 */     // MIs[0] Operand 7
     /* 708370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708380 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 708383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708385 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708394 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708396 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708412 */     GIR_RootConstrainSelectedInstOperands,
     /* 708413 */     // GIR_Coverage, 4850,
     /* 708413 */     GIR_EraseRootFromParent_Done,
     /* 708414 */   // Label 9231: @708414
     /* 708414 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(708476), // Rule ID 4854 //
     /* 708419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708426 */     // MIs[0] offset
     /* 708426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708429 */     // MIs[0] auxiliary
     /* 708429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708432 */     // MIs[0] Operand 7
     /* 708432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708442 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 708445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708447 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 708449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708456 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708458 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708474 */     GIR_RootConstrainSelectedInstOperands,
     /* 708475 */     // GIR_Coverage, 4854,
     /* 708475 */     GIR_EraseRootFromParent_Done,
     /* 708476 */   // Label 9232: @708476
     /* 708476 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(708576), // Rule ID 4819 //
     /* 708481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 708484 */     // MIs[0] offset
     /* 708484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708487 */     // MIs[0] auxiliary
     /* 708487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708490 */     // MIs[0] Operand 7
     /* 708490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708500 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708516 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708523 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 708544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708556 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708574 */     GIR_RootConstrainSelectedInstOperands,
     /* 708575 */     // GIR_Coverage, 4819,
     /* 708575 */     GIR_EraseRootFromParent_Done,
     /* 708576 */   // Label 9233: @708576
     /* 708576 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(708676), // Rule ID 4851 //
     /* 708581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708584 */     // MIs[0] offset
     /* 708584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708587 */     // MIs[0] auxiliary
     /* 708587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708590 */     // MIs[0] Operand 7
     /* 708590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708600 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708616 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708623 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 708644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708656 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708674 */     GIR_RootConstrainSelectedInstOperands,
     /* 708675 */     // GIR_Coverage, 4851,
     /* 708675 */     GIR_EraseRootFromParent_Done,
     /* 708676 */   // Label 9234: @708676
     /* 708676 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(708776), // Rule ID 4855 //
     /* 708681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708684 */     // MIs[0] offset
     /* 708684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708687 */     // MIs[0] auxiliary
     /* 708687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708690 */     // MIs[0] Operand 7
     /* 708690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 708693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708700 */     // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 708703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 708707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 708712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 708716 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 708719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 708723 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 708726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 708731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 708741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 708744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 708749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708756 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708774 */     GIR_RootConstrainSelectedInstOperands,
     /* 708775 */     // GIR_Coverage, 4855,
     /* 708775 */     GIR_EraseRootFromParent_Done,
     /* 708776 */   // Label 9235: @708776
     /* 708776 */   GIM_Reject,
     /* 708777 */ // Label 9223: @708777
     /* 708777 */ GIM_Reject,
     /* 708778 */ // Label 9192: @708778
     /* 708778 */ GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(710016),
     /* 708783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 708786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 708789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 708792 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 708795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 708799 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(708871), // Rule ID 4856 //
     /* 708804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708815 */     // MIs[0] offset
     /* 708815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708818 */     // MIs[0] auxiliary
     /* 708818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708821 */     // MIs[0] Operand 7
     /* 708821 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 708832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708839 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 708842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708851 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708853 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708869 */     GIR_RootConstrainSelectedInstOperands,
     /* 708870 */     // GIR_Coverage, 4856,
     /* 708870 */     GIR_EraseRootFromParent_Done,
     /* 708871 */   // Label 9237: @708871
     /* 708871 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(708943), // Rule ID 4860 //
     /* 708876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 708879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708887 */     // MIs[0] offset
     /* 708887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708890 */     // MIs[0] auxiliary
     /* 708890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708893 */     // MIs[0] Operand 7
     /* 708893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 708904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708911 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 708914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708923 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 708931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 708937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 708941 */     GIR_RootConstrainSelectedInstOperands,
     /* 708942 */     // GIR_Coverage, 4860,
     /* 708942 */     GIR_EraseRootFromParent_Done,
     /* 708943 */   // Label 9238: @708943
     /* 708943 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(709015), // Rule ID 4864 //
     /* 708948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 708951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 708955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 708959 */     // MIs[0] offset
     /* 708959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 708962 */     // MIs[0] auxiliary
     /* 708962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 708965 */     // MIs[0] Operand 7
     /* 708965 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 708976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 708983 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 708983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 708986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 708988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 708990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 708995 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 708997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709003 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709013 */     GIR_RootConstrainSelectedInstOperands,
     /* 709014 */     // GIR_Coverage, 4864,
     /* 709014 */     GIR_EraseRootFromParent_Done,
     /* 709015 */   // Label 9239: @709015
     /* 709015 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(709087), // Rule ID 4868 //
     /* 709020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709031 */     // MIs[0] offset
     /* 709031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709034 */     // MIs[0] auxiliary
     /* 709034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709037 */     // MIs[0] Operand 7
     /* 709037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709055 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 709058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709067 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709085 */     GIR_RootConstrainSelectedInstOperands,
     /* 709086 */     // GIR_Coverage, 4868,
     /* 709086 */     GIR_EraseRootFromParent_Done,
     /* 709087 */   // Label 9240: @709087
     /* 709087 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(709157), // Rule ID 4857 //
     /* 709092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 709095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709099 */     // MIs[0] offset
     /* 709099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709102 */     // MIs[0] auxiliary
     /* 709102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709105 */     // MIs[0] Operand 7
     /* 709105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709123 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 709126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709128 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709137 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709155 */     GIR_RootConstrainSelectedInstOperands,
     /* 709156 */     // GIR_Coverage, 4857,
     /* 709156 */     GIR_EraseRootFromParent_Done,
     /* 709157 */   // Label 9241: @709157
     /* 709157 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(709227), // Rule ID 4861 //
     /* 709162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709169 */     // MIs[0] offset
     /* 709169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709172 */     // MIs[0] auxiliary
     /* 709172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709175 */     // MIs[0] Operand 7
     /* 709175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709193 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 709196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709198 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709207 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709225 */     GIR_RootConstrainSelectedInstOperands,
     /* 709226 */     // GIR_Coverage, 4861,
     /* 709226 */     GIR_EraseRootFromParent_Done,
     /* 709227 */   // Label 9242: @709227
     /* 709227 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(709297), // Rule ID 4865 //
     /* 709232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 709235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709239 */     // MIs[0] offset
     /* 709239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709242 */     // MIs[0] auxiliary
     /* 709242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709245 */     // MIs[0] Operand 7
     /* 709245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709263 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 709266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709268 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709277 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709295 */     GIR_RootConstrainSelectedInstOperands,
     /* 709296 */     // GIR_Coverage, 4865,
     /* 709296 */     GIR_EraseRootFromParent_Done,
     /* 709297 */   // Label 9243: @709297
     /* 709297 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(709367), // Rule ID 4869 //
     /* 709302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 709309 */     // MIs[0] offset
     /* 709309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709312 */     // MIs[0] auxiliary
     /* 709312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709315 */     // MIs[0] Operand 7
     /* 709315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 709326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709333 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 709336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709338 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 709340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709347 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709365 */     GIR_RootConstrainSelectedInstOperands,
     /* 709366 */     // GIR_Coverage, 4869,
     /* 709366 */     GIR_EraseRootFromParent_Done,
     /* 709367 */   // Label 9244: @709367
     /* 709367 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(709429), // Rule ID 4858 //
     /* 709372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 709375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709379 */     // MIs[0] offset
     /* 709379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709382 */     // MIs[0] auxiliary
     /* 709382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709385 */     // MIs[0] Operand 7
     /* 709385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709395 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 709398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709400 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709409 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709427 */     GIR_RootConstrainSelectedInstOperands,
     /* 709428 */     // GIR_Coverage, 4858,
     /* 709428 */     GIR_EraseRootFromParent_Done,
     /* 709429 */   // Label 9245: @709429
     /* 709429 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(709491), // Rule ID 4862 //
     /* 709434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709441 */     // MIs[0] offset
     /* 709441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709444 */     // MIs[0] auxiliary
     /* 709444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709447 */     // MIs[0] Operand 7
     /* 709447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709457 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 709460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709462 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709471 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709489 */     GIR_RootConstrainSelectedInstOperands,
     /* 709490 */     // GIR_Coverage, 4862,
     /* 709490 */     GIR_EraseRootFromParent_Done,
     /* 709491 */   // Label 9246: @709491
     /* 709491 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(709553), // Rule ID 4866 //
     /* 709496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 709499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709503 */     // MIs[0] offset
     /* 709503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709506 */     // MIs[0] auxiliary
     /* 709506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709509 */     // MIs[0] Operand 7
     /* 709509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709519 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 709522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709524 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709533 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709551 */     GIR_RootConstrainSelectedInstOperands,
     /* 709552 */     // GIR_Coverage, 4866,
     /* 709552 */     GIR_EraseRootFromParent_Done,
     /* 709553 */   // Label 9247: @709553
     /* 709553 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(709615), // Rule ID 4870 //
     /* 709558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 709565 */     // MIs[0] offset
     /* 709565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709568 */     // MIs[0] auxiliary
     /* 709568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709571 */     // MIs[0] Operand 7
     /* 709571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709581 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 709584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709586 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 709588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709595 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709613 */     GIR_RootConstrainSelectedInstOperands,
     /* 709614 */     // GIR_Coverage, 4870,
     /* 709614 */     GIR_EraseRootFromParent_Done,
     /* 709615 */   // Label 9248: @709615
     /* 709615 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(709715), // Rule ID 4859 //
     /* 709620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 709623 */     // MIs[0] offset
     /* 709623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709626 */     // MIs[0] auxiliary
     /* 709626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709629 */     // MIs[0] Operand 7
     /* 709629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709639 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709662 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 709683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709695 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709697 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709703 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709713 */     GIR_RootConstrainSelectedInstOperands,
     /* 709714 */     // GIR_Coverage, 4859,
     /* 709714 */     GIR_EraseRootFromParent_Done,
     /* 709715 */   // Label 9249: @709715
     /* 709715 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(709815), // Rule ID 4863 //
     /* 709720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709723 */     // MIs[0] offset
     /* 709723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709726 */     // MIs[0] auxiliary
     /* 709726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709729 */     // MIs[0] Operand 7
     /* 709729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709739 */     // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709755 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709762 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 709783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709795 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709813 */     GIR_RootConstrainSelectedInstOperands,
     /* 709814 */     // GIR_Coverage, 4863,
     /* 709814 */     GIR_EraseRootFromParent_Done,
     /* 709815 */   // Label 9250: @709815
     /* 709815 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(709915), // Rule ID 4867 //
     /* 709820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 709823 */     // MIs[0] offset
     /* 709823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709826 */     // MIs[0] auxiliary
     /* 709826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709829 */     // MIs[0] Operand 7
     /* 709829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709839 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709855 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709862 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 709883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709895 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709897 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 709903 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 709909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 709913 */     GIR_RootConstrainSelectedInstOperands,
     /* 709914 */     // GIR_Coverage, 4867,
     /* 709914 */     GIR_EraseRootFromParent_Done,
     /* 709915 */   // Label 9251: @709915
     /* 709915 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(710015), // Rule ID 4871 //
     /* 709920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 709923 */     // MIs[0] offset
     /* 709923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 709926 */     // MIs[0] auxiliary
     /* 709926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 709929 */     // MIs[0] Operand 7
     /* 709929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 709932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 709939 */     // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 709939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 709942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 709946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 709951 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 709955 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 709958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 709962 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 709965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 709970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 709980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 709983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 709985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 709988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 709990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 709995 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 709997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710003 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710013 */     GIR_RootConstrainSelectedInstOperands,
     /* 710014 */     // GIR_Coverage, 4871,
     /* 710014 */     GIR_EraseRootFromParent_Done,
     /* 710015 */   // Label 9252: @710015
     /* 710015 */   GIM_Reject,
     /* 710016 */ // Label 9236: @710016
     /* 710016 */ GIM_Reject,
     /* 710017 */ // Label 9193: @710017
     /* 710017 */ GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(710343),
     /* 710022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 710025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 710028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 710031 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 710034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 710038 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(710110), // Rule ID 4820 //
     /* 710043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710054 */     // MIs[0] offset
     /* 710054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710057 */     // MIs[0] auxiliary
     /* 710057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710060 */     // MIs[0] Operand 7
     /* 710060 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710078 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
     /* 710081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710090 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710108 */     GIR_RootConstrainSelectedInstOperands,
     /* 710109 */     // GIR_Coverage, 4820,
     /* 710109 */     GIR_EraseRootFromParent_Done,
     /* 710110 */   // Label 9254: @710110
     /* 710110 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(710180), // Rule ID 4821 //
     /* 710115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710122 */     // MIs[0] offset
     /* 710122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710125 */     // MIs[0] auxiliary
     /* 710125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710128 */     // MIs[0] Operand 7
     /* 710128 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710146 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
     /* 710149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710151 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710160 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710178 */     GIR_RootConstrainSelectedInstOperands,
     /* 710179 */     // GIR_Coverage, 4821,
     /* 710179 */     GIR_EraseRootFromParent_Done,
     /* 710180 */   // Label 9255: @710180
     /* 710180 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(710242), // Rule ID 4822 //
     /* 710185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710192 */     // MIs[0] offset
     /* 710192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710195 */     // MIs[0] auxiliary
     /* 710195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710198 */     // MIs[0] Operand 7
     /* 710198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710208 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
     /* 710211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710213 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710222 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710224 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710240 */     GIR_RootConstrainSelectedInstOperands,
     /* 710241 */     // GIR_Coverage, 4822,
     /* 710241 */     GIR_EraseRootFromParent_Done,
     /* 710242 */   // Label 9256: @710242
     /* 710242 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(710342), // Rule ID 4823 //
     /* 710247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710250 */     // MIs[0] offset
     /* 710250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710253 */     // MIs[0] auxiliary
     /* 710253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710256 */     // MIs[0] Operand 7
     /* 710256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710266 */     // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710282 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710289 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
     /* 710310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710322 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710324 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710330 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710340 */     GIR_RootConstrainSelectedInstOperands,
     /* 710341 */     // GIR_Coverage, 4823,
     /* 710341 */     GIR_EraseRootFromParent_Done,
     /* 710342 */   // Label 9257: @710342
     /* 710342 */   GIM_Reject,
     /* 710343 */ // Label 9253: @710343
     /* 710343 */ GIM_Reject,
     /* 710344 */ // Label 9194: @710344
     /* 710344 */ GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(710670),
     /* 710349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 710352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 710355 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 710358 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 710361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 710365 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(710437), // Rule ID 4824 //
     /* 710370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710381 */     // MIs[0] offset
     /* 710381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710384 */     // MIs[0] auxiliary
     /* 710384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710387 */     // MIs[0] Operand 7
     /* 710387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710405 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
     /* 710408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710435 */     GIR_RootConstrainSelectedInstOperands,
     /* 710436 */     // GIR_Coverage, 4824,
     /* 710436 */     GIR_EraseRootFromParent_Done,
     /* 710437 */   // Label 9259: @710437
     /* 710437 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(710507), // Rule ID 4825 //
     /* 710442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710449 */     // MIs[0] offset
     /* 710449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710452 */     // MIs[0] auxiliary
     /* 710452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710455 */     // MIs[0] Operand 7
     /* 710455 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710473 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
     /* 710476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710478 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 710480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710487 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710505 */     GIR_RootConstrainSelectedInstOperands,
     /* 710506 */     // GIR_Coverage, 4825,
     /* 710506 */     GIR_EraseRootFromParent_Done,
     /* 710507 */   // Label 9260: @710507
     /* 710507 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(710569), // Rule ID 4826 //
     /* 710512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710519 */     // MIs[0] offset
     /* 710519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710522 */     // MIs[0] auxiliary
     /* 710522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710525 */     // MIs[0] Operand 7
     /* 710525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710535 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
     /* 710538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710540 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 710542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710549 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710551 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710567 */     GIR_RootConstrainSelectedInstOperands,
     /* 710568 */     // GIR_Coverage, 4826,
     /* 710568 */     GIR_EraseRootFromParent_Done,
     /* 710569 */   // Label 9261: @710569
     /* 710569 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(710669), // Rule ID 4827 //
     /* 710574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 710577 */     // MIs[0] offset
     /* 710577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710580 */     // MIs[0] auxiliary
     /* 710580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710583 */     // MIs[0] Operand 7
     /* 710583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 710586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710593 */     // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 710596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 710600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 710605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 710609 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 710612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 710616 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 710619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 710624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 710634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
     /* 710637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 710642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710649 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710651 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710657 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710667 */     GIR_RootConstrainSelectedInstOperands,
     /* 710668 */     // GIR_Coverage, 4827,
     /* 710668 */     GIR_EraseRootFromParent_Done,
     /* 710669 */   // Label 9262: @710669
     /* 710669 */   GIM_Reject,
     /* 710670 */ // Label 9258: @710670
     /* 710670 */ GIM_Reject,
     /* 710671 */ // Label 9195: @710671
     /* 710671 */ GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(713361),
     /* 710676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 710679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 710682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 710685 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 710688 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(710771), // Rule ID 4872 //
     /* 710693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 710696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 710703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 710707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710715 */     // MIs[0] offset
     /* 710715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710718 */     // MIs[0] auxiliary
     /* 710718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710721 */     // MIs[0] Operand 7
     /* 710721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710739 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 710742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710751 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710769 */     GIR_RootConstrainSelectedInstOperands,
     /* 710770 */     // GIR_Coverage, 4872,
     /* 710770 */     GIR_EraseRootFromParent_Done,
     /* 710771 */   // Label 9264: @710771
     /* 710771 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(710854), // Rule ID 4876 //
     /* 710776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 710779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 710786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 710790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710798 */     // MIs[0] offset
     /* 710798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710801 */     // MIs[0] auxiliary
     /* 710801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710804 */     // MIs[0] Operand 7
     /* 710804 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710822 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 710825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710834 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710836 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710852 */     GIR_RootConstrainSelectedInstOperands,
     /* 710853 */     // GIR_Coverage, 4876,
     /* 710853 */     GIR_EraseRootFromParent_Done,
     /* 710854 */   // Label 9265: @710854
     /* 710854 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(710937), // Rule ID 4880 //
     /* 710859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 710862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 710869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 710873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710881 */     // MIs[0] offset
     /* 710881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710884 */     // MIs[0] auxiliary
     /* 710884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710887 */     // MIs[0] Operand 7
     /* 710887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710905 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 710908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 710917 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 710919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 710925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 710931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 710935 */     GIR_RootConstrainSelectedInstOperands,
     /* 710936 */     // GIR_Coverage, 4880,
     /* 710936 */     GIR_EraseRootFromParent_Done,
     /* 710937 */   // Label 9266: @710937
     /* 710937 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(711020), // Rule ID 4884 //
     /* 710942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 710945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 710952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 710956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 710960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 710964 */     // MIs[0] offset
     /* 710964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 710967 */     // MIs[0] auxiliary
     /* 710967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 710970 */     // MIs[0] Operand 7
     /* 710970 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 710981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 710988 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 710988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 710991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 710993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 710995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711000 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711018 */     GIR_RootConstrainSelectedInstOperands,
     /* 711019 */     // GIR_Coverage, 4884,
     /* 711019 */     GIR_EraseRootFromParent_Done,
     /* 711020 */   // Label 9267: @711020
     /* 711020 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(711096), // Rule ID 4888 //
     /* 711025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 711028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711040 */     // MIs[0] offset
     /* 711040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711043 */     // MIs[0] auxiliary
     /* 711043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711046 */     // MIs[0] Operand 7
     /* 711046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711064 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 711067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711076 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711094 */     GIR_RootConstrainSelectedInstOperands,
     /* 711095 */     // GIR_Coverage, 4888,
     /* 711095 */     GIR_EraseRootFromParent_Done,
     /* 711096 */   // Label 9268: @711096
     /* 711096 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(711172), // Rule ID 4892 //
     /* 711101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 711104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711116 */     // MIs[0] offset
     /* 711116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711119 */     // MIs[0] auxiliary
     /* 711119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711122 */     // MIs[0] Operand 7
     /* 711122 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711140 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 711143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711152 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711170 */     GIR_RootConstrainSelectedInstOperands,
     /* 711171 */     // GIR_Coverage, 4892,
     /* 711171 */     GIR_EraseRootFromParent_Done,
     /* 711172 */   // Label 9269: @711172
     /* 711172 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(711248), // Rule ID 4896 //
     /* 711177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 711180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711192 */     // MIs[0] offset
     /* 711192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711195 */     // MIs[0] auxiliary
     /* 711195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711198 */     // MIs[0] Operand 7
     /* 711198 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711216 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 711219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711228 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711246 */     GIR_RootConstrainSelectedInstOperands,
     /* 711247 */     // GIR_Coverage, 4896,
     /* 711247 */     GIR_EraseRootFromParent_Done,
     /* 711248 */   // Label 9270: @711248
     /* 711248 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(711324), // Rule ID 4900 //
     /* 711253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 711256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711268 */     // MIs[0] offset
     /* 711268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711271 */     // MIs[0] auxiliary
     /* 711271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711274 */     // MIs[0] Operand 7
     /* 711274 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711292 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 711295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711304 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711322 */     GIR_RootConstrainSelectedInstOperands,
     /* 711323 */     // GIR_Coverage, 4900,
     /* 711323 */     GIR_EraseRootFromParent_Done,
     /* 711324 */   // Label 9271: @711324
     /* 711324 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(711405), // Rule ID 4873 //
     /* 711329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 711332 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 711339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711347 */     // MIs[0] offset
     /* 711347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711350 */     // MIs[0] auxiliary
     /* 711350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711353 */     // MIs[0] Operand 7
     /* 711353 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711371 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 711374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711376 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711385 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711387 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711393 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711403 */     GIR_RootConstrainSelectedInstOperands,
     /* 711404 */     // GIR_Coverage, 4873,
     /* 711404 */     GIR_EraseRootFromParent_Done,
     /* 711405 */   // Label 9272: @711405
     /* 711405 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(711486), // Rule ID 4877 //
     /* 711410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 711413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 711420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711428 */     // MIs[0] offset
     /* 711428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711431 */     // MIs[0] auxiliary
     /* 711431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711434 */     // MIs[0] Operand 7
     /* 711434 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711452 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 711455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711457 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711466 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711484 */     GIR_RootConstrainSelectedInstOperands,
     /* 711485 */     // GIR_Coverage, 4877,
     /* 711485 */     GIR_EraseRootFromParent_Done,
     /* 711486 */   // Label 9273: @711486
     /* 711486 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(711567), // Rule ID 4881 //
     /* 711491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 711494 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 711501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711509 */     // MIs[0] offset
     /* 711509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711512 */     // MIs[0] auxiliary
     /* 711512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711515 */     // MIs[0] Operand 7
     /* 711515 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711533 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 711536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711538 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711547 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711555 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711565 */     GIR_RootConstrainSelectedInstOperands,
     /* 711566 */     // GIR_Coverage, 4881,
     /* 711566 */     GIR_EraseRootFromParent_Done,
     /* 711567 */   // Label 9274: @711567
     /* 711567 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(711648), // Rule ID 4885 //
     /* 711572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 711575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 711582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711590 */     // MIs[0] offset
     /* 711590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711593 */     // MIs[0] auxiliary
     /* 711593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711596 */     // MIs[0] Operand 7
     /* 711596 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711614 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 711617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711619 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711628 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711646 */     GIR_RootConstrainSelectedInstOperands,
     /* 711647 */     // GIR_Coverage, 4885,
     /* 711647 */     GIR_EraseRootFromParent_Done,
     /* 711648 */   // Label 9275: @711648
     /* 711648 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(711722), // Rule ID 4889 //
     /* 711653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 711656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711664 */     // MIs[0] offset
     /* 711664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711667 */     // MIs[0] auxiliary
     /* 711667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711670 */     // MIs[0] Operand 7
     /* 711670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711688 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 711691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711693 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711720 */     GIR_RootConstrainSelectedInstOperands,
     /* 711721 */     // GIR_Coverage, 4889,
     /* 711721 */     GIR_EraseRootFromParent_Done,
     /* 711722 */   // Label 9276: @711722
     /* 711722 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(711796), // Rule ID 4893 //
     /* 711727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 711730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711738 */     // MIs[0] offset
     /* 711738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711741 */     // MIs[0] auxiliary
     /* 711741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711744 */     // MIs[0] Operand 7
     /* 711744 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711762 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 711765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711767 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711776 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711778 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711784 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711794 */     GIR_RootConstrainSelectedInstOperands,
     /* 711795 */     // GIR_Coverage, 4893,
     /* 711795 */     GIR_EraseRootFromParent_Done,
     /* 711796 */   // Label 9277: @711796
     /* 711796 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(711870), // Rule ID 4897 //
     /* 711801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 711804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711812 */     // MIs[0] offset
     /* 711812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711815 */     // MIs[0] auxiliary
     /* 711815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711818 */     // MIs[0] Operand 7
     /* 711818 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711836 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 711839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711841 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711850 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711852 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711868 */     GIR_RootConstrainSelectedInstOperands,
     /* 711869 */     // GIR_Coverage, 4897,
     /* 711869 */     GIR_EraseRootFromParent_Done,
     /* 711870 */   // Label 9278: @711870
     /* 711870 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(711944), // Rule ID 4901 //
     /* 711875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 711878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 711886 */     // MIs[0] offset
     /* 711886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711889 */     // MIs[0] auxiliary
     /* 711889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711892 */     // MIs[0] Operand 7
     /* 711892 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 711903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711910 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 711913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711915 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 711917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711924 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 711932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 711938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 711942 */     GIR_RootConstrainSelectedInstOperands,
     /* 711943 */     // GIR_Coverage, 4901,
     /* 711943 */     GIR_EraseRootFromParent_Done,
     /* 711944 */   // Label 9279: @711944
     /* 711944 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(712017), // Rule ID 4874 //
     /* 711949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 711952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 711959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 711963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 711967 */     // MIs[0] offset
     /* 711967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 711970 */     // MIs[0] auxiliary
     /* 711970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 711973 */     // MIs[0] Operand 7
     /* 711973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 711976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 711983 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 711983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 711986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 711988 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 711990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 711992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 711997 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 711999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712015 */     GIR_RootConstrainSelectedInstOperands,
     /* 712016 */     // GIR_Coverage, 4874,
     /* 712016 */     GIR_EraseRootFromParent_Done,
     /* 712017 */   // Label 9280: @712017
     /* 712017 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(712090), // Rule ID 4878 //
     /* 712022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 712025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 712032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712040 */     // MIs[0] offset
     /* 712040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712043 */     // MIs[0] auxiliary
     /* 712043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712046 */     // MIs[0] Operand 7
     /* 712046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712056 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 712059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712061 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712070 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712072 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712078 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712088 */     GIR_RootConstrainSelectedInstOperands,
     /* 712089 */     // GIR_Coverage, 4878,
     /* 712089 */     GIR_EraseRootFromParent_Done,
     /* 712090 */   // Label 9281: @712090
     /* 712090 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(712163), // Rule ID 4882 //
     /* 712095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 712098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 712105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712113 */     // MIs[0] offset
     /* 712113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712116 */     // MIs[0] auxiliary
     /* 712116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712119 */     // MIs[0] Operand 7
     /* 712119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712129 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 712132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712134 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712143 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712151 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712161 */     GIR_RootConstrainSelectedInstOperands,
     /* 712162 */     // GIR_Coverage, 4882,
     /* 712162 */     GIR_EraseRootFromParent_Done,
     /* 712163 */   // Label 9282: @712163
     /* 712163 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(712236), // Rule ID 4886 //
     /* 712168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 712171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 712178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712186 */     // MIs[0] offset
     /* 712186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712189 */     // MIs[0] auxiliary
     /* 712189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712192 */     // MIs[0] Operand 7
     /* 712192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712202 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 712205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712207 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712216 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712224 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712234 */     GIR_RootConstrainSelectedInstOperands,
     /* 712235 */     // GIR_Coverage, 4886,
     /* 712235 */     GIR_EraseRootFromParent_Done,
     /* 712236 */   // Label 9283: @712236
     /* 712236 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(712302), // Rule ID 4890 //
     /* 712241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 712244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712252 */     // MIs[0] offset
     /* 712252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712255 */     // MIs[0] auxiliary
     /* 712255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712258 */     // MIs[0] Operand 7
     /* 712258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712268 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 712271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712273 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712282 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712284 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712300 */     GIR_RootConstrainSelectedInstOperands,
     /* 712301 */     // GIR_Coverage, 4890,
     /* 712301 */     GIR_EraseRootFromParent_Done,
     /* 712302 */   // Label 9284: @712302
     /* 712302 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(712368), // Rule ID 4894 //
     /* 712307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 712310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712318 */     // MIs[0] offset
     /* 712318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712321 */     // MIs[0] auxiliary
     /* 712321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712324 */     // MIs[0] Operand 7
     /* 712324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712334 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 712337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712339 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712348 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712366 */     GIR_RootConstrainSelectedInstOperands,
     /* 712367 */     // GIR_Coverage, 4894,
     /* 712367 */     GIR_EraseRootFromParent_Done,
     /* 712368 */   // Label 9285: @712368
     /* 712368 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(712434), // Rule ID 4898 //
     /* 712373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 712376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712384 */     // MIs[0] offset
     /* 712384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712387 */     // MIs[0] auxiliary
     /* 712387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712390 */     // MIs[0] Operand 7
     /* 712390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712400 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 712403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712405 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712414 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712422 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712432 */     GIR_RootConstrainSelectedInstOperands,
     /* 712433 */     // GIR_Coverage, 4898,
     /* 712433 */     GIR_EraseRootFromParent_Done,
     /* 712434 */   // Label 9286: @712434
     /* 712434 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(712500), // Rule ID 4902 //
     /* 712439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 712442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 712450 */     // MIs[0] offset
     /* 712450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712453 */     // MIs[0] auxiliary
     /* 712453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712456 */     // MIs[0] Operand 7
     /* 712456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712466 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 712469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712471 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 712473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712480 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712488 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712498 */     GIR_RootConstrainSelectedInstOperands,
     /* 712499 */     // GIR_Coverage, 4902,
     /* 712499 */     GIR_EraseRootFromParent_Done,
     /* 712500 */   // Label 9287: @712500
     /* 712500 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(712611), // Rule ID 4875 //
     /* 712505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 712508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 712515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712519 */     // MIs[0] offset
     /* 712519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712522 */     // MIs[0] auxiliary
     /* 712522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712525 */     // MIs[0] Operand 7
     /* 712525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712535 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712551 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712558 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 712579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712609 */     GIR_RootConstrainSelectedInstOperands,
     /* 712610 */     // GIR_Coverage, 4875,
     /* 712610 */     GIR_EraseRootFromParent_Done,
     /* 712611 */   // Label 9288: @712611
     /* 712611 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(712722), // Rule ID 4879 //
     /* 712616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 712619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 712626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712630 */     // MIs[0] offset
     /* 712630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712633 */     // MIs[0] auxiliary
     /* 712633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712636 */     // MIs[0] Operand 7
     /* 712636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712646 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31408>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712662 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712665 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712669 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 712690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712702 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712720 */     GIR_RootConstrainSelectedInstOperands,
     /* 712721 */     // GIR_Coverage, 4879,
     /* 712721 */     GIR_EraseRootFromParent_Done,
     /* 712722 */   // Label 9289: @712722
     /* 712722 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(712833), // Rule ID 4883 //
     /* 712727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 712730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 712737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712741 */     // MIs[0] offset
     /* 712741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712744 */     // MIs[0] auxiliary
     /* 712744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712747 */     // MIs[0] Operand 7
     /* 712747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712757 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712773 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712780 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 712801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712813 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712831 */     GIR_RootConstrainSelectedInstOperands,
     /* 712832 */     // GIR_Coverage, 4883,
     /* 712832 */     GIR_EraseRootFromParent_Done,
     /* 712833 */   // Label 9290: @712833
     /* 712833 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(712944), // Rule ID 4887 //
     /* 712838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 712841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 712848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712852 */     // MIs[0] offset
     /* 712852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712855 */     // MIs[0] auxiliary
     /* 712855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712858 */     // MIs[0] Operand 7
     /* 712858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712868 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31418>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712884 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712891 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 712899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 712909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 712912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 712914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 712917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 712919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 712924 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 712926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 712932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 712938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 712942 */     GIR_RootConstrainSelectedInstOperands,
     /* 712943 */     // GIR_Coverage, 4887,
     /* 712943 */     GIR_EraseRootFromParent_Done,
     /* 712944 */   // Label 9291: @712944
     /* 712944 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(713048), // Rule ID 4891 //
     /* 712949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 712952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 712956 */     // MIs[0] offset
     /* 712956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 712959 */     // MIs[0] auxiliary
     /* 712959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 712962 */     // MIs[0] Operand 7
     /* 712962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 712965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 712972 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 712972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 712975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 712979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 712984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 712988 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 712991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 712995 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 712998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 713016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713028 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713046 */     GIR_RootConstrainSelectedInstOperands,
     /* 713047 */     // GIR_Coverage, 4891,
     /* 713047 */     GIR_EraseRootFromParent_Done,
     /* 713048 */   // Label 9292: @713048
     /* 713048 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(713152), // Rule ID 4895 //
     /* 713053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 713056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 713060 */     // MIs[0] offset
     /* 713060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713063 */     // MIs[0] auxiliary
     /* 713063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713066 */     // MIs[0] Operand 7
     /* 713066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713076 */     // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713092 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713099 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 713120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713132 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713140 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713150 */     GIR_RootConstrainSelectedInstOperands,
     /* 713151 */     // GIR_Coverage, 4895,
     /* 713151 */     GIR_EraseRootFromParent_Done,
     /* 713152 */   // Label 9293: @713152
     /* 713152 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(713256), // Rule ID 4899 //
     /* 713157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 713160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 713164 */     // MIs[0] offset
     /* 713164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713167 */     // MIs[0] auxiliary
     /* 713167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713170 */     // MIs[0] Operand 7
     /* 713170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713180 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713196 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713203 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 713224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713236 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713254 */     GIR_RootConstrainSelectedInstOperands,
     /* 713255 */     // GIR_Coverage, 4899,
     /* 713255 */     GIR_EraseRootFromParent_Done,
     /* 713256 */   // Label 9294: @713256
     /* 713256 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(713360), // Rule ID 4903 //
     /* 713261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 713264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 713268 */     // MIs[0] offset
     /* 713268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713271 */     // MIs[0] auxiliary
     /* 713271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713274 */     // MIs[0] Operand 7
     /* 713274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713284 */     // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713300 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713307 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 713328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713340 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713358 */     GIR_RootConstrainSelectedInstOperands,
     /* 713359 */     // GIR_Coverage, 4903,
     /* 713359 */     GIR_EraseRootFromParent_Done,
     /* 713360 */   // Label 9295: @713360
     /* 713360 */   GIM_Reject,
     /* 713361 */ // Label 9263: @713361
     /* 713361 */ GIM_Reject,
     /* 713362 */ // Label 9196: @713362
     /* 713362 */ GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(713688),
     /* 713367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 713370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 713373 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 713376 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 713379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 713383 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(713455), // Rule ID 4828 //
     /* 713388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 713391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713399 */     // MIs[0] offset
     /* 713399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713402 */     // MIs[0] auxiliary
     /* 713402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713405 */     // MIs[0] Operand 7
     /* 713405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713423 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
     /* 713426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713435 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713453 */     GIR_RootConstrainSelectedInstOperands,
     /* 713454 */     // GIR_Coverage, 4828,
     /* 713454 */     GIR_EraseRootFromParent_Done,
     /* 713455 */   // Label 9297: @713455
     /* 713455 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(713525), // Rule ID 4829 //
     /* 713460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 713463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713467 */     // MIs[0] offset
     /* 713467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713470 */     // MIs[0] auxiliary
     /* 713470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713473 */     // MIs[0] Operand 7
     /* 713473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713491 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
     /* 713494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713496 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713505 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713523 */     GIR_RootConstrainSelectedInstOperands,
     /* 713524 */     // GIR_Coverage, 4829,
     /* 713524 */     GIR_EraseRootFromParent_Done,
     /* 713525 */   // Label 9298: @713525
     /* 713525 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(713587), // Rule ID 4830 //
     /* 713530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 713533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713537 */     // MIs[0] offset
     /* 713537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713540 */     // MIs[0] auxiliary
     /* 713540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713543 */     // MIs[0] Operand 7
     /* 713543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713553 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
     /* 713556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713558 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 713560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713567 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713585 */     GIR_RootConstrainSelectedInstOperands,
     /* 713586 */     // GIR_Coverage, 4830,
     /* 713586 */     GIR_EraseRootFromParent_Done,
     /* 713587 */   // Label 9299: @713587
     /* 713587 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(713687), // Rule ID 4831 //
     /* 713592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 713595 */     // MIs[0] offset
     /* 713595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713598 */     // MIs[0] auxiliary
     /* 713598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713601 */     // MIs[0] Operand 7
     /* 713601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 713604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713611 */     // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 713614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 713618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 713623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 713627 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 713630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 713634 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 713637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 713642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 713652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
     /* 713655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 713660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713667 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713669 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713685 */     GIR_RootConstrainSelectedInstOperands,
     /* 713686 */     // GIR_Coverage, 4831,
     /* 713686 */     GIR_EraseRootFromParent_Done,
     /* 713687 */   // Label 9300: @713687
     /* 713687 */   GIM_Reject,
     /* 713688 */ // Label 9296: @713688
     /* 713688 */ GIM_Reject,
     /* 713689 */ // Label 9197: @713689
     /* 713689 */ GIM_Reject,
     /* 713690 */ // Label 128: @713690
     /* 713690 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 9305*/ GIMT_Encode4(716209),
     /* 713701 */ /*GILLT_v2s32*//*Label 9301*/ GIMT_Encode4(713733), GIMT_Encode4(0),
     /* 713709 */ /*GILLT_v3s32*//*Label 9302*/ GIMT_Encode4(714352), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 713721 */ /*GILLT_v4s32*//*Label 9303*/ GIMT_Encode4(714971), GIMT_Encode4(0),
     /* 713729 */ /*GILLT_v5s32*//*Label 9304*/ GIMT_Encode4(715590),
     /* 713733 */ // Label 9301: @713733
     /* 713733 */ GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(714351),
     /* 713738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 713741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 713744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 713747 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 713750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 713754 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(713826), // Rule ID 4776 //
     /* 713759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713770 */     // MIs[0] offset
     /* 713770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713773 */     // MIs[0] auxiliary
     /* 713773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713776 */     // MIs[0] Operand 7
     /* 713776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713794 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFSET),
     /* 713797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713806 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713824 */     GIR_RootConstrainSelectedInstOperands,
     /* 713825 */     // GIR_Coverage, 4776,
     /* 713825 */     GIR_EraseRootFromParent_Done,
     /* 713826 */   // Label 9307: @713826
     /* 713826 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(713895), // Rule ID 4780 //
     /* 713831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 713839 */     // MIs[0] offset
     /* 713839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713842 */     // MIs[0] auxiliary
     /* 713842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713845 */     // MIs[0] Operand 7
     /* 713845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713863 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET),
     /* 713866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713875 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713893 */     GIR_RootConstrainSelectedInstOperands,
     /* 713894 */     // GIR_Coverage, 4780,
     /* 713894 */     GIR_EraseRootFromParent_Done,
     /* 713895 */   // Label 9308: @713895
     /* 713895 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(713965), // Rule ID 4777 //
     /* 713900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 713903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713907 */     // MIs[0] offset
     /* 713907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713910 */     // MIs[0] auxiliary
     /* 713910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713913 */     // MIs[0] Operand 7
     /* 713913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713931 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFEN),
     /* 713934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 713936 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 713938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 713940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 713945 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 713947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 713953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 713959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 713963 */     GIR_RootConstrainSelectedInstOperands,
     /* 713964 */     // GIR_Coverage, 4777,
     /* 713964 */     GIR_EraseRootFromParent_Done,
     /* 713965 */   // Label 9309: @713965
     /* 713965 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(714032), // Rule ID 4781 //
     /* 713970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 713974 */     // MIs[0] offset
     /* 713974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 713977 */     // MIs[0] auxiliary
     /* 713977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 713980 */     // MIs[0] Operand 7
     /* 713980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 713991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 713998 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 713998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN),
     /* 714001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714003 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714012 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714030 */     GIR_RootConstrainSelectedInstOperands,
     /* 714031 */     // GIR_Coverage, 4781,
     /* 714031 */     GIR_EraseRootFromParent_Done,
     /* 714032 */   // Label 9310: @714032
     /* 714032 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(714094), // Rule ID 4778 //
     /* 714037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714044 */     // MIs[0] offset
     /* 714044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714047 */     // MIs[0] auxiliary
     /* 714047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714050 */     // MIs[0] Operand 7
     /* 714050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714060 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_IDXEN),
     /* 714063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714065 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714074 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714082 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714092 */     GIR_RootConstrainSelectedInstOperands,
     /* 714093 */     // GIR_Coverage, 4778,
     /* 714093 */     GIR_EraseRootFromParent_Done,
     /* 714094 */   // Label 9311: @714094
     /* 714094 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(714153), // Rule ID 4782 //
     /* 714099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714103 */     // MIs[0] offset
     /* 714103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714106 */     // MIs[0] auxiliary
     /* 714106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714109 */     // MIs[0] Operand 7
     /* 714109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714119 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN),
     /* 714122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714124 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714133 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714151 */     GIR_RootConstrainSelectedInstOperands,
     /* 714152 */     // GIR_Coverage, 4782,
     /* 714152 */     GIR_EraseRootFromParent_Done,
     /* 714153 */   // Label 9312: @714153
     /* 714153 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(714253), // Rule ID 4779 //
     /* 714158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714161 */     // MIs[0] offset
     /* 714161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714164 */     // MIs[0] auxiliary
     /* 714164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714167 */     // MIs[0] Operand 7
     /* 714167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714177 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714193 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714200 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_BOTHEN),
     /* 714221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714233 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714241 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714251 */     GIR_RootConstrainSelectedInstOperands,
     /* 714252 */     // GIR_Coverage, 4779,
     /* 714252 */     GIR_EraseRootFromParent_Done,
     /* 714253 */   // Label 9313: @714253
     /* 714253 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(714350), // Rule ID 4783 //
     /* 714258 */     // MIs[0] offset
     /* 714258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714261 */     // MIs[0] auxiliary
     /* 714261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714264 */     // MIs[0] Operand 7
     /* 714264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714274 */     // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714290 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714297 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN),
     /* 714318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714330 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714348 */     GIR_RootConstrainSelectedInstOperands,
     /* 714349 */     // GIR_Coverage, 4783,
     /* 714349 */     GIR_EraseRootFromParent_Done,
     /* 714350 */   // Label 9314: @714350
     /* 714350 */   GIM_Reject,
     /* 714351 */ // Label 9306: @714351
     /* 714351 */ GIM_Reject,
     /* 714352 */ // Label 9302: @714352
     /* 714352 */ GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(714970),
     /* 714357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 714360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 714363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 714366 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 714369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 714373 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(714445), // Rule ID 4784 //
     /* 714378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714389 */     // MIs[0] offset
     /* 714389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714392 */     // MIs[0] auxiliary
     /* 714392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714395 */     // MIs[0] Operand 7
     /* 714395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714413 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFSET),
     /* 714416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714425 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714443 */     GIR_RootConstrainSelectedInstOperands,
     /* 714444 */     // GIR_Coverage, 4784,
     /* 714444 */     GIR_EraseRootFromParent_Done,
     /* 714445 */   // Label 9316: @714445
     /* 714445 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(714514), // Rule ID 4788 //
     /* 714450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714458 */     // MIs[0] offset
     /* 714458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714461 */     // MIs[0] auxiliary
     /* 714461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714464 */     // MIs[0] Operand 7
     /* 714464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714482 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET),
     /* 714485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714494 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714512 */     GIR_RootConstrainSelectedInstOperands,
     /* 714513 */     // GIR_Coverage, 4788,
     /* 714513 */     GIR_EraseRootFromParent_Done,
     /* 714514 */   // Label 9317: @714514
     /* 714514 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(714584), // Rule ID 4785 //
     /* 714519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714526 */     // MIs[0] offset
     /* 714526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714529 */     // MIs[0] auxiliary
     /* 714529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714532 */     // MIs[0] Operand 7
     /* 714532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714550 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFEN),
     /* 714553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714555 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714564 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714566 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714572 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714582 */     GIR_RootConstrainSelectedInstOperands,
     /* 714583 */     // GIR_Coverage, 4785,
     /* 714583 */     GIR_EraseRootFromParent_Done,
     /* 714584 */   // Label 9318: @714584
     /* 714584 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(714651), // Rule ID 4789 //
     /* 714589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 714593 */     // MIs[0] offset
     /* 714593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714596 */     // MIs[0] auxiliary
     /* 714596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714599 */     // MIs[0] Operand 7
     /* 714599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 714610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714617 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN),
     /* 714620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714622 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 714624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714631 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714649 */     GIR_RootConstrainSelectedInstOperands,
     /* 714650 */     // GIR_Coverage, 4789,
     /* 714650 */     GIR_EraseRootFromParent_Done,
     /* 714651 */   // Label 9319: @714651
     /* 714651 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(714713), // Rule ID 4786 //
     /* 714656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714663 */     // MIs[0] offset
     /* 714663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714666 */     // MIs[0] auxiliary
     /* 714666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714669 */     // MIs[0] Operand 7
     /* 714669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714679 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_IDXEN),
     /* 714682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714684 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714693 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714711 */     GIR_RootConstrainSelectedInstOperands,
     /* 714712 */     // GIR_Coverage, 4786,
     /* 714712 */     GIR_EraseRootFromParent_Done,
     /* 714713 */   // Label 9320: @714713
     /* 714713 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(714772), // Rule ID 4790 //
     /* 714718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 714722 */     // MIs[0] offset
     /* 714722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714725 */     // MIs[0] auxiliary
     /* 714725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714728 */     // MIs[0] Operand 7
     /* 714728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714738 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN),
     /* 714741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714743 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 714745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714752 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714770 */     GIR_RootConstrainSelectedInstOperands,
     /* 714771 */     // GIR_Coverage, 4790,
     /* 714771 */     GIR_EraseRootFromParent_Done,
     /* 714772 */   // Label 9321: @714772
     /* 714772 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(714872), // Rule ID 4787 //
     /* 714777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 714780 */     // MIs[0] offset
     /* 714780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714783 */     // MIs[0] auxiliary
     /* 714783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714786 */     // MIs[0] Operand 7
     /* 714786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714796 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714812 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714819 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN),
     /* 714840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714852 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714854 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714860 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714870 */     GIR_RootConstrainSelectedInstOperands,
     /* 714871 */     // GIR_Coverage, 4787,
     /* 714871 */     GIR_EraseRootFromParent_Done,
     /* 714872 */   // Label 9322: @714872
     /* 714872 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(714969), // Rule ID 4791 //
     /* 714877 */     // MIs[0] offset
     /* 714877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 714880 */     // MIs[0] auxiliary
     /* 714880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 714883 */     // MIs[0] Operand 7
     /* 714883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 714886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 714893 */     // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 714893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 714896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 714900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 714905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 714909 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 714912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 714916 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 714919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 714924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 714934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN),
     /* 714937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 714939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 714942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 714944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 714949 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 714951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 714957 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 714963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 714967 */     GIR_RootConstrainSelectedInstOperands,
     /* 714968 */     // GIR_Coverage, 4791,
     /* 714968 */     GIR_EraseRootFromParent_Done,
     /* 714969 */   // Label 9323: @714969
     /* 714969 */   GIM_Reject,
     /* 714970 */ // Label 9315: @714970
     /* 714970 */ GIM_Reject,
     /* 714971 */ // Label 9303: @714971
     /* 714971 */ GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(715589),
     /* 714976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 714979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 714982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 714985 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 714988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 714992 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(715064), // Rule ID 4792 //
     /* 714997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715008 */     // MIs[0] offset
     /* 715008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715011 */     // MIs[0] auxiliary
     /* 715011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715014 */     // MIs[0] Operand 7
     /* 715014 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715032 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET),
     /* 715035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715044 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715046 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715052 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715062 */     GIR_RootConstrainSelectedInstOperands,
     /* 715063 */     // GIR_Coverage, 4792,
     /* 715063 */     GIR_EraseRootFromParent_Done,
     /* 715064 */   // Label 9325: @715064
     /* 715064 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(715133), // Rule ID 4796 //
     /* 715069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715077 */     // MIs[0] offset
     /* 715077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715080 */     // MIs[0] auxiliary
     /* 715080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715083 */     // MIs[0] Operand 7
     /* 715083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715101 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET),
     /* 715104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715113 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715131 */     GIR_RootConstrainSelectedInstOperands,
     /* 715132 */     // GIR_Coverage, 4796,
     /* 715132 */     GIR_EraseRootFromParent_Done,
     /* 715133 */   // Label 9326: @715133
     /* 715133 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(715203), // Rule ID 4793 //
     /* 715138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715145 */     // MIs[0] offset
     /* 715145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715148 */     // MIs[0] auxiliary
     /* 715148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715151 */     // MIs[0] Operand 7
     /* 715151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715169 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN),
     /* 715172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715174 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715183 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715201 */     GIR_RootConstrainSelectedInstOperands,
     /* 715202 */     // GIR_Coverage, 4793,
     /* 715202 */     GIR_EraseRootFromParent_Done,
     /* 715203 */   // Label 9327: @715203
     /* 715203 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(715270), // Rule ID 4797 //
     /* 715208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715212 */     // MIs[0] offset
     /* 715212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715215 */     // MIs[0] auxiliary
     /* 715215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715218 */     // MIs[0] Operand 7
     /* 715218 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715236 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN),
     /* 715239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715241 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715250 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715258 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715268 */     GIR_RootConstrainSelectedInstOperands,
     /* 715269 */     // GIR_Coverage, 4797,
     /* 715269 */     GIR_EraseRootFromParent_Done,
     /* 715270 */   // Label 9328: @715270
     /* 715270 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(715332), // Rule ID 4794 //
     /* 715275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715282 */     // MIs[0] offset
     /* 715282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715285 */     // MIs[0] auxiliary
     /* 715285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715288 */     // MIs[0] Operand 7
     /* 715288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715298 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN),
     /* 715301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715303 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715312 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715330 */     GIR_RootConstrainSelectedInstOperands,
     /* 715331 */     // GIR_Coverage, 4794,
     /* 715331 */     GIR_EraseRootFromParent_Done,
     /* 715332 */   // Label 9329: @715332
     /* 715332 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(715391), // Rule ID 4798 //
     /* 715337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715341 */     // MIs[0] offset
     /* 715341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715344 */     // MIs[0] auxiliary
     /* 715344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715347 */     // MIs[0] Operand 7
     /* 715347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715357 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN),
     /* 715360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715362 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715371 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715379 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715389 */     GIR_RootConstrainSelectedInstOperands,
     /* 715390 */     // GIR_Coverage, 4798,
     /* 715390 */     GIR_EraseRootFromParent_Done,
     /* 715391 */   // Label 9330: @715391
     /* 715391 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(715491), // Rule ID 4795 //
     /* 715396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715399 */     // MIs[0] offset
     /* 715399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715402 */     // MIs[0] auxiliary
     /* 715402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715405 */     // MIs[0] Operand 7
     /* 715405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715415 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715431 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715438 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN),
     /* 715459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715471 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715473 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715489 */     GIR_RootConstrainSelectedInstOperands,
     /* 715490 */     // GIR_Coverage, 4795,
     /* 715490 */     GIR_EraseRootFromParent_Done,
     /* 715491 */   // Label 9331: @715491
     /* 715491 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(715588), // Rule ID 4799 //
     /* 715496 */     // MIs[0] offset
     /* 715496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715499 */     // MIs[0] auxiliary
     /* 715499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715502 */     // MIs[0] Operand 7
     /* 715502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715512 */     // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 715515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 715519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 715524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 715528 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 715531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 715535 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 715538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 715543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 715553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN),
     /* 715556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 715561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715568 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715576 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715586 */     GIR_RootConstrainSelectedInstOperands,
     /* 715587 */     // GIR_Coverage, 4799,
     /* 715587 */     GIR_EraseRootFromParent_Done,
     /* 715588 */   // Label 9332: @715588
     /* 715588 */   GIM_Reject,
     /* 715589 */ // Label 9324: @715589
     /* 715589 */ GIM_Reject,
     /* 715590 */ // Label 9304: @715590
     /* 715590 */ GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(716208),
     /* 715595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 715598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 715601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 715604 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 715607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
     /* 715611 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(715683), // Rule ID 4800 //
     /* 715616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715627 */     // MIs[0] offset
     /* 715627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715630 */     // MIs[0] auxiliary
     /* 715630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715633 */     // MIs[0] Operand 7
     /* 715633 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715651 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET),
     /* 715654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715663 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715671 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715681 */     GIR_RootConstrainSelectedInstOperands,
     /* 715682 */     // GIR_Coverage, 4800,
     /* 715682 */     GIR_EraseRootFromParent_Done,
     /* 715683 */   // Label 9334: @715683
     /* 715683 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(715752), // Rule ID 4804 //
     /* 715688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715696 */     // MIs[0] offset
     /* 715696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715699 */     // MIs[0] auxiliary
     /* 715699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715702 */     // MIs[0] Operand 7
     /* 715702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715720 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET),
     /* 715723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715732 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715750 */     GIR_RootConstrainSelectedInstOperands,
     /* 715751 */     // GIR_Coverage, 4804,
     /* 715751 */     GIR_EraseRootFromParent_Done,
     /* 715752 */   // Label 9335: @715752
     /* 715752 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(715822), // Rule ID 4801 //
     /* 715757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715764 */     // MIs[0] offset
     /* 715764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715767 */     // MIs[0] auxiliary
     /* 715767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715770 */     // MIs[0] Operand 7
     /* 715770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715788 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN),
     /* 715791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715793 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715802 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715804 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715820 */     GIR_RootConstrainSelectedInstOperands,
     /* 715821 */     // GIR_Coverage, 4801,
     /* 715821 */     GIR_EraseRootFromParent_Done,
     /* 715822 */   // Label 9336: @715822
     /* 715822 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(715889), // Rule ID 4805 //
     /* 715827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 715831 */     // MIs[0] offset
     /* 715831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715834 */     // MIs[0] auxiliary
     /* 715834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715837 */     // MIs[0] Operand 7
     /* 715837 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 715848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715855 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN),
     /* 715858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715860 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 715862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715869 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715887 */     GIR_RootConstrainSelectedInstOperands,
     /* 715888 */     // GIR_Coverage, 4805,
     /* 715888 */     GIR_EraseRootFromParent_Done,
     /* 715889 */   // Label 9337: @715889
     /* 715889 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(715951), // Rule ID 4802 //
     /* 715894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 715897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715901 */     // MIs[0] offset
     /* 715901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715904 */     // MIs[0] auxiliary
     /* 715904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715907 */     // MIs[0] Operand 7
     /* 715907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715917 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN),
     /* 715920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715922 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715931 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 715945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 715949 */     GIR_RootConstrainSelectedInstOperands,
     /* 715950 */     // GIR_Coverage, 4802,
     /* 715950 */     GIR_EraseRootFromParent_Done,
     /* 715951 */   // Label 9338: @715951
     /* 715951 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(716010), // Rule ID 4806 //
     /* 715956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 715960 */     // MIs[0] offset
     /* 715960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 715963 */     // MIs[0] auxiliary
     /* 715963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 715966 */     // MIs[0] Operand 7
     /* 715966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 715969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 715976 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 715976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN),
     /* 715979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 715981 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 715983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 715985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 715990 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 715992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 715998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716008 */     GIR_RootConstrainSelectedInstOperands,
     /* 716009 */     // GIR_Coverage, 4806,
     /* 716009 */     GIR_EraseRootFromParent_Done,
     /* 716010 */   // Label 9339: @716010
     /* 716010 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(716110), // Rule ID 4803 //
     /* 716015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716018 */     // MIs[0] offset
     /* 716018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716021 */     // MIs[0] auxiliary
     /* 716021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716024 */     // MIs[0] Operand 7
     /* 716024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716034 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716050 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716057 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN),
     /* 716078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716090 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716108 */     GIR_RootConstrainSelectedInstOperands,
     /* 716109 */     // GIR_Coverage, 4803,
     /* 716109 */     GIR_EraseRootFromParent_Done,
     /* 716110 */   // Label 9340: @716110
     /* 716110 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(716207), // Rule ID 4807 //
     /* 716115 */     // MIs[0] offset
     /* 716115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716118 */     // MIs[0] auxiliary
     /* 716118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716121 */     // MIs[0] Operand 7
     /* 716121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716131 */     // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716147 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716154 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN),
     /* 716175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716187 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716189 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716195 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716205 */     GIR_RootConstrainSelectedInstOperands,
     /* 716206 */     // GIR_Coverage, 4807,
     /* 716206 */     GIR_EraseRootFromParent_Done,
     /* 716207 */   // Label 9341: @716207
     /* 716207 */   GIM_Reject,
     /* 716208 */ // Label 9333: @716208
     /* 716208 */ GIM_Reject,
     /* 716209 */ // Label 9305: @716209
     /* 716209 */ GIM_Reject,
     /* 716210 */ // Label 129: @716210
     /* 716210 */ GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(716815),
     /* 716215 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 716218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 716221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 716224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 716227 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 716230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 716234 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(716506),
     /* 716239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716243 */     GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(716311), // Rule ID 5104 //
     /* 716248 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716251 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716255 */       // MIs[0] offset
     /* 716255 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716258 */       // MIs[0] auxiliary
     /* 716258 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716261 */       // MIs[0] Operand 7
     /* 716261 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716272 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716279 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716279 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
     /* 716282 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716284 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716286 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716291 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716293 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716299 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716305 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716309 */       GIR_RootConstrainSelectedInstOperands,
     /* 716310 */       // GIR_Coverage, 5104,
     /* 716310 */       GIR_EraseRootFromParent_Done,
     /* 716311 */     // Label 9344: @716311
     /* 716311 */     GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(716376), // Rule ID 5108 //
     /* 716316 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716320 */       // MIs[0] offset
     /* 716320 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716323 */       // MIs[0] auxiliary
     /* 716323 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716326 */       // MIs[0] Operand 7
     /* 716326 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716337 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716344 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716344 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
     /* 716347 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716349 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716351 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716356 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716358 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716364 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716370 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716374 */       GIR_RootConstrainSelectedInstOperands,
     /* 716375 */       // GIR_Coverage, 5108,
     /* 716375 */       GIR_EraseRootFromParent_Done,
     /* 716376 */     // Label 9345: @716376
     /* 716376 */     GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(716442), // Rule ID 5105 //
     /* 716381 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716384 */       // MIs[0] offset
     /* 716384 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716387 */       // MIs[0] auxiliary
     /* 716387 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716390 */       // MIs[0] Operand 7
     /* 716390 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716401 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716408 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716408 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
     /* 716411 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716413 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716415 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716417 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716422 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716424 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716430 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716436 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716440 */       GIR_RootConstrainSelectedInstOperands,
     /* 716441 */       // GIR_Coverage, 5105,
     /* 716441 */       GIR_EraseRootFromParent_Done,
     /* 716442 */     // Label 9346: @716442
     /* 716442 */     GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(716505), // Rule ID 5109 //
     /* 716447 */       // MIs[0] offset
     /* 716447 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716450 */       // MIs[0] auxiliary
     /* 716450 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716453 */       // MIs[0] Operand 7
     /* 716453 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716464 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716471 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716471 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
     /* 716474 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716476 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 716478 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716480 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716485 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716487 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716493 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716499 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716503 */       GIR_RootConstrainSelectedInstOperands,
     /* 716504 */       // GIR_Coverage, 5109,
     /* 716504 */       GIR_EraseRootFromParent_Done,
     /* 716505 */     // Label 9347: @716505
     /* 716505 */     GIM_Reject,
     /* 716506 */   // Label 9343: @716506
     /* 716506 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(716620),
     /* 716511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716524 */     GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(716573), // Rule ID 5106 //
     /* 716529 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716532 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716539 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716539 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_IDXEN),
     /* 716542 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716544 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716546 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716548 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716553 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716555 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716561 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716567 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716571 */       GIR_RootConstrainSelectedInstOperands,
     /* 716572 */       // GIR_Coverage, 5106,
     /* 716572 */       GIR_EraseRootFromParent_Done,
     /* 716573 */     // Label 9349: @716573
     /* 716573 */     GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(716619), // Rule ID 5110 //
     /* 716578 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716585 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716585 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_IDXEN),
     /* 716588 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716590 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 716592 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716594 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716599 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716601 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716607 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716613 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716617 */       GIR_RootConstrainSelectedInstOperands,
     /* 716618 */       // GIR_Coverage, 5110,
     /* 716618 */       GIR_EraseRootFromParent_Done,
     /* 716619 */     // Label 9350: @716619
     /* 716619 */     GIM_Reject,
     /* 716620 */   // Label 9348: @716620
     /* 716620 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(716814),
     /* 716625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 716634 */     GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(716725), // Rule ID 5107 //
     /* 716639 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716642 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716649 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716649 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716652 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716656 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716661 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716665 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716668 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716672 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716675 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716680 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716685 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716690 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_BOTHEN),
     /* 716693 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716695 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716698 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716700 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716705 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716707 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716713 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716719 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716723 */       GIR_RootConstrainSelectedInstOperands,
     /* 716724 */       // GIR_Coverage, 5107,
     /* 716724 */       GIR_EraseRootFromParent_Done,
     /* 716725 */     // Label 9352: @716725
     /* 716725 */     GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(716813), // Rule ID 5111 //
     /* 716730 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716737 */       // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716737 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 716740 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 716744 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 716749 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 716753 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 716756 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 716760 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 716763 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 716768 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716773 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 716778 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN),
     /* 716781 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716783 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 716786 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716788 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716793 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716795 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716801 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716807 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716811 */       GIR_RootConstrainSelectedInstOperands,
     /* 716812 */       // GIR_Coverage, 5111,
     /* 716812 */       GIR_EraseRootFromParent_Done,
     /* 716813 */     // Label 9353: @716813
     /* 716813 */     GIM_Reject,
     /* 716814 */   // Label 9351: @716814
     /* 716814 */   GIM_Reject,
     /* 716815 */ // Label 9342: @716815
     /* 716815 */ GIM_Reject,
     /* 716816 */ // Label 130: @716816
     /* 716816 */ GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(717421),
     /* 716821 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 716824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 716827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 716830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 716833 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 716836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 716840 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(717112),
     /* 716845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 716849 */     GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(716917), // Rule ID 5168 //
     /* 716854 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716857 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716861 */       // MIs[0] offset
     /* 716861 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716864 */       // MIs[0] auxiliary
     /* 716864 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716867 */       // MIs[0] Operand 7
     /* 716867 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716878 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716885 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716885 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFSET),
     /* 716888 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716890 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716892 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716897 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716899 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716905 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716911 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716915 */       GIR_RootConstrainSelectedInstOperands,
     /* 716916 */       // GIR_Coverage, 5168,
     /* 716916 */       GIR_EraseRootFromParent_Done,
     /* 716917 */     // Label 9356: @716917
     /* 716917 */     GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(716982), // Rule ID 5172 //
     /* 716922 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 716926 */       // MIs[0] offset
     /* 716926 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716929 */       // MIs[0] auxiliary
     /* 716929 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716932 */       // MIs[0] Operand 7
     /* 716932 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 716943 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 716950 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 716950 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET),
     /* 716953 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 716955 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 716957 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 716962 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 716964 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 716970 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 716976 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 716980 */       GIR_RootConstrainSelectedInstOperands,
     /* 716981 */       // GIR_Coverage, 5172,
     /* 716981 */       GIR_EraseRootFromParent_Done,
     /* 716982 */     // Label 9357: @716982
     /* 716982 */     GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(717048), // Rule ID 5169 //
     /* 716987 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 716990 */       // MIs[0] offset
     /* 716990 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 716993 */       // MIs[0] auxiliary
     /* 716993 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 716996 */       // MIs[0] Operand 7
     /* 716996 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717007 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717014 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717014 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFEN),
     /* 717017 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717019 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717021 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717023 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717028 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717030 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717036 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717042 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717046 */       GIR_RootConstrainSelectedInstOperands,
     /* 717047 */       // GIR_Coverage, 5169,
     /* 717047 */       GIR_EraseRootFromParent_Done,
     /* 717048 */     // Label 9358: @717048
     /* 717048 */     GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(717111), // Rule ID 5173 //
     /* 717053 */       // MIs[0] offset
     /* 717053 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717056 */       // MIs[0] auxiliary
     /* 717056 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717059 */       // MIs[0] Operand 7
     /* 717059 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717070 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717077 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717077 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN),
     /* 717080 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717082 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717084 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717086 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717091 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717093 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717099 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717105 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717109 */       GIR_RootConstrainSelectedInstOperands,
     /* 717110 */       // GIR_Coverage, 5173,
     /* 717110 */       GIR_EraseRootFromParent_Done,
     /* 717111 */     // Label 9359: @717111
     /* 717111 */     GIM_Reject,
     /* 717112 */   // Label 9355: @717112
     /* 717112 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(717226),
     /* 717117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717130 */     GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(717179), // Rule ID 5170 //
     /* 717135 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717138 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717145 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717145 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_IDXEN),
     /* 717148 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717150 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717152 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717154 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717159 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717161 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717167 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717173 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717177 */       GIR_RootConstrainSelectedInstOperands,
     /* 717178 */       // GIR_Coverage, 5170,
     /* 717178 */       GIR_EraseRootFromParent_Done,
     /* 717179 */     // Label 9361: @717179
     /* 717179 */     GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(717225), // Rule ID 5174 //
     /* 717184 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717191 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717191 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN),
     /* 717194 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717196 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717198 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717200 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717205 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717207 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717213 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717219 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717223 */       GIR_RootConstrainSelectedInstOperands,
     /* 717224 */       // GIR_Coverage, 5174,
     /* 717224 */       GIR_EraseRootFromParent_Done,
     /* 717225 */     // Label 9362: @717225
     /* 717225 */     GIM_Reject,
     /* 717226 */   // Label 9360: @717226
     /* 717226 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(717420),
     /* 717231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717240 */     GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(717331), // Rule ID 5171 //
     /* 717245 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717248 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717255 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717255 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717258 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717262 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717267 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717271 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717274 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717278 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717281 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717286 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717291 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717296 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_BOTHEN),
     /* 717299 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717301 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717304 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717306 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717311 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717313 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717319 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717325 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717329 */       GIR_RootConstrainSelectedInstOperands,
     /* 717330 */       // GIR_Coverage, 5171,
     /* 717330 */       GIR_EraseRootFromParent_Done,
     /* 717331 */     // Label 9364: @717331
     /* 717331 */     GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(717419), // Rule ID 5175 //
     /* 717336 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717343 */       // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717343 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717346 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717350 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717355 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717359 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717362 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717366 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717369 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717374 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717379 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717384 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN),
     /* 717387 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717389 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717392 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717394 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717399 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717401 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717407 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717413 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717417 */       GIR_RootConstrainSelectedInstOperands,
     /* 717418 */       // GIR_Coverage, 5175,
     /* 717418 */       GIR_EraseRootFromParent_Done,
     /* 717419 */     // Label 9365: @717419
     /* 717419 */     GIM_Reject,
     /* 717420 */   // Label 9363: @717420
     /* 717420 */   GIM_Reject,
     /* 717421 */ // Label 9354: @717421
     /* 717421 */ GIM_Reject,
     /* 717422 */ // Label 131: @717422
     /* 717422 */ GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(718027),
     /* 717427 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 717430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 717433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 717436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 717439 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 717442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 717446 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(717718),
     /* 717451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 717455 */     GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(717523), // Rule ID 5112 //
     /* 717460 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717463 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717467 */       // MIs[0] offset
     /* 717467 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717470 */       // MIs[0] auxiliary
     /* 717470 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717473 */       // MIs[0] Operand 7
     /* 717473 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717484 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717491 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717491 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
     /* 717494 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717496 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717498 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717503 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717505 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717511 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717517 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717521 */       GIR_RootConstrainSelectedInstOperands,
     /* 717522 */       // GIR_Coverage, 5112,
     /* 717522 */       GIR_EraseRootFromParent_Done,
     /* 717523 */     // Label 9368: @717523
     /* 717523 */     GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(717588), // Rule ID 5116 //
     /* 717528 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717532 */       // MIs[0] offset
     /* 717532 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717535 */       // MIs[0] auxiliary
     /* 717535 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717538 */       // MIs[0] Operand 7
     /* 717538 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717549 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717556 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717556 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
     /* 717559 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717561 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717563 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717568 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717570 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717576 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717582 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717586 */       GIR_RootConstrainSelectedInstOperands,
     /* 717587 */       // GIR_Coverage, 5116,
     /* 717587 */       GIR_EraseRootFromParent_Done,
     /* 717588 */     // Label 9369: @717588
     /* 717588 */     GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(717654), // Rule ID 5113 //
     /* 717593 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717596 */       // MIs[0] offset
     /* 717596 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717599 */       // MIs[0] auxiliary
     /* 717599 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717602 */       // MIs[0] Operand 7
     /* 717602 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717613 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717620 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717620 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
     /* 717623 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717625 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717627 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717629 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717634 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717636 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717642 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717648 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717652 */       GIR_RootConstrainSelectedInstOperands,
     /* 717653 */       // GIR_Coverage, 5113,
     /* 717653 */       GIR_EraseRootFromParent_Done,
     /* 717654 */     // Label 9370: @717654
     /* 717654 */     GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(717717), // Rule ID 5117 //
     /* 717659 */       // MIs[0] offset
     /* 717659 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717662 */       // MIs[0] auxiliary
     /* 717662 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717665 */       // MIs[0] Operand 7
     /* 717665 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 717676 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717683 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717683 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
     /* 717686 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717688 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 717690 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717692 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717697 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717699 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717705 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717711 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717715 */       GIR_RootConstrainSelectedInstOperands,
     /* 717716 */       // GIR_Coverage, 5117,
     /* 717716 */       GIR_EraseRootFromParent_Done,
     /* 717717 */     // Label 9371: @717717
     /* 717717 */     GIM_Reject,
     /* 717718 */   // Label 9367: @717718
     /* 717718 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(717832),
     /* 717723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 717727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717736 */     GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(717785), // Rule ID 5114 //
     /* 717741 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717744 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717751 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717751 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_IDXEN),
     /* 717754 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717756 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717758 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717760 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717765 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717767 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717773 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717779 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717783 */       GIR_RootConstrainSelectedInstOperands,
     /* 717784 */       // GIR_Coverage, 5114,
     /* 717784 */       GIR_EraseRootFromParent_Done,
     /* 717785 */     // Label 9373: @717785
     /* 717785 */     GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(717831), // Rule ID 5118 //
     /* 717790 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717797 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717797 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_IDXEN),
     /* 717800 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717802 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 717804 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717806 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717811 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717813 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717819 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717825 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717829 */       GIR_RootConstrainSelectedInstOperands,
     /* 717830 */       // GIR_Coverage, 5118,
     /* 717830 */       GIR_EraseRootFromParent_Done,
     /* 717831 */     // Label 9374: @717831
     /* 717831 */     GIM_Reject,
     /* 717832 */   // Label 9372: @717832
     /* 717832 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(718026),
     /* 717837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 717840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 717843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 717846 */     GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(717937), // Rule ID 5115 //
     /* 717851 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 717854 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717861 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717861 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717864 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717868 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717873 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717877 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717880 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717884 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717887 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717892 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717897 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_BOTHEN),
     /* 717905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717907 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717910 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 717912 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 717917 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 717919 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 717925 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 717931 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 717935 */       GIR_RootConstrainSelectedInstOperands,
     /* 717936 */       // GIR_Coverage, 5115,
     /* 717936 */       GIR_EraseRootFromParent_Done,
     /* 717937 */     // Label 9376: @717937
     /* 717937 */     GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(718025), // Rule ID 5119 //
     /* 717942 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 717949 */       // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 717949 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 717952 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 717956 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 717961 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 717965 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 717968 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 717972 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 717975 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 717980 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717985 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 717990 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN),
     /* 717993 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 717995 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 717998 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718000 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718005 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718007 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718013 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718019 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718023 */       GIR_RootConstrainSelectedInstOperands,
     /* 718024 */       // GIR_Coverage, 5119,
     /* 718024 */       GIR_EraseRootFromParent_Done,
     /* 718025 */     // Label 9377: @718025
     /* 718025 */     GIM_Reject,
     /* 718026 */   // Label 9375: @718026
     /* 718026 */   GIM_Reject,
     /* 718027 */ // Label 9366: @718027
     /* 718027 */ GIM_Reject,
     /* 718028 */ // Label 132: @718028
     /* 718028 */ GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(718633),
     /* 718033 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 718036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 718039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 718042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 718045 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 718048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 718052 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(718324),
     /* 718057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718061 */     GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(718129), // Rule ID 5176 //
     /* 718066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718069 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718073 */       // MIs[0] offset
     /* 718073 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718076 */       // MIs[0] auxiliary
     /* 718076 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718079 */       // MIs[0] Operand 7
     /* 718079 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718090 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718097 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718097 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFSET),
     /* 718100 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718102 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718104 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718109 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718111 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718117 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718123 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718127 */       GIR_RootConstrainSelectedInstOperands,
     /* 718128 */       // GIR_Coverage, 5176,
     /* 718128 */       GIR_EraseRootFromParent_Done,
     /* 718129 */     // Label 9380: @718129
     /* 718129 */     GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(718194), // Rule ID 5180 //
     /* 718134 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718138 */       // MIs[0] offset
     /* 718138 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718141 */       // MIs[0] auxiliary
     /* 718141 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718144 */       // MIs[0] Operand 7
     /* 718144 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718155 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718162 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718162 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET),
     /* 718165 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718167 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718169 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718174 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718176 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718182 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718188 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718192 */       GIR_RootConstrainSelectedInstOperands,
     /* 718193 */       // GIR_Coverage, 5180,
     /* 718193 */       GIR_EraseRootFromParent_Done,
     /* 718194 */     // Label 9381: @718194
     /* 718194 */     GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(718260), // Rule ID 5177 //
     /* 718199 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718202 */       // MIs[0] offset
     /* 718202 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718205 */       // MIs[0] auxiliary
     /* 718205 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718208 */       // MIs[0] Operand 7
     /* 718208 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718219 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718226 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718226 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFEN),
     /* 718229 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718231 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718233 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718235 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718240 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718242 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718248 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718254 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718258 */       GIR_RootConstrainSelectedInstOperands,
     /* 718259 */       // GIR_Coverage, 5177,
     /* 718259 */       GIR_EraseRootFromParent_Done,
     /* 718260 */     // Label 9382: @718260
     /* 718260 */     GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(718323), // Rule ID 5181 //
     /* 718265 */       // MIs[0] offset
     /* 718265 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718268 */       // MIs[0] auxiliary
     /* 718268 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718271 */       // MIs[0] Operand 7
     /* 718271 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718282 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718289 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718289 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN),
     /* 718292 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718294 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718296 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718298 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718303 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718305 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718311 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718317 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718321 */       GIR_RootConstrainSelectedInstOperands,
     /* 718322 */       // GIR_Coverage, 5181,
     /* 718322 */       GIR_EraseRootFromParent_Done,
     /* 718323 */     // Label 9383: @718323
     /* 718323 */     GIM_Reject,
     /* 718324 */   // Label 9379: @718324
     /* 718324 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(718438),
     /* 718329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718342 */     GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(718391), // Rule ID 5178 //
     /* 718347 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718350 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718357 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_IDXEN),
     /* 718360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718362 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718364 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718366 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718371 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718373 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718379 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718385 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718389 */       GIR_RootConstrainSelectedInstOperands,
     /* 718390 */       // GIR_Coverage, 5178,
     /* 718390 */       GIR_EraseRootFromParent_Done,
     /* 718391 */     // Label 9385: @718391
     /* 718391 */     GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(718437), // Rule ID 5182 //
     /* 718396 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718403 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718403 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN),
     /* 718406 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718408 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 718410 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718412 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718417 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718419 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718425 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718431 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718435 */       GIR_RootConstrainSelectedInstOperands,
     /* 718436 */       // GIR_Coverage, 5182,
     /* 718436 */       GIR_EraseRootFromParent_Done,
     /* 718437 */     // Label 9386: @718437
     /* 718437 */     GIM_Reject,
     /* 718438 */   // Label 9384: @718438
     /* 718438 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(718632),
     /* 718443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718452 */     GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(718543), // Rule ID 5179 //
     /* 718457 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718460 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718467 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718467 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718470 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718474 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718479 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718483 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718486 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718490 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718493 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718498 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718503 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718508 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_BOTHEN),
     /* 718511 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718513 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718516 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718518 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718523 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718525 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718531 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718537 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718541 */       GIR_RootConstrainSelectedInstOperands,
     /* 718542 */       // GIR_Coverage, 5179,
     /* 718542 */       GIR_EraseRootFromParent_Done,
     /* 718543 */     // Label 9388: @718543
     /* 718543 */     GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(718631), // Rule ID 5183 //
     /* 718548 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718555 */       // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718555 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 718558 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 718562 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 718567 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 718571 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 718574 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 718578 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 718581 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 718586 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718591 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 718596 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN),
     /* 718599 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718601 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 718604 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718606 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718611 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718613 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718619 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718625 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718629 */       GIR_RootConstrainSelectedInstOperands,
     /* 718630 */       // GIR_Coverage, 5183,
     /* 718630 */       GIR_EraseRootFromParent_Done,
     /* 718631 */     // Label 9389: @718631
     /* 718631 */     GIM_Reject,
     /* 718632 */   // Label 9387: @718632
     /* 718632 */   GIM_Reject,
     /* 718633 */ // Label 9378: @718633
     /* 718633 */ GIM_Reject,
     /* 718634 */ // Label 133: @718634
     /* 718634 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 9394*/ GIMT_Encode4(721153),
     /* 718645 */ /*GILLT_v2s32*//*Label 9390*/ GIMT_Encode4(718677), GIMT_Encode4(0),
     /* 718653 */ /*GILLT_v3s32*//*Label 9391*/ GIMT_Encode4(719296), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 718665 */ /*GILLT_v4s32*//*Label 9392*/ GIMT_Encode4(719915), GIMT_Encode4(0),
     /* 718673 */ /*GILLT_v5s32*//*Label 9393*/ GIMT_Encode4(720534),
     /* 718677 */ // Label 9390: @718677
     /* 718677 */ GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(719295),
     /* 718682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 718685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 718688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 718691 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 718694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 718698 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(718770), // Rule ID 5136 //
     /* 718703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718714 */     // MIs[0] offset
     /* 718714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718717 */     // MIs[0] auxiliary
     /* 718717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718720 */     // MIs[0] Operand 7
     /* 718720 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718738 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFSET),
     /* 718741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718750 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718768 */     GIR_RootConstrainSelectedInstOperands,
     /* 718769 */     // GIR_Coverage, 5136,
     /* 718769 */     GIR_EraseRootFromParent_Done,
     /* 718770 */   // Label 9396: @718770
     /* 718770 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(718839), // Rule ID 5140 //
     /* 718775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718783 */     // MIs[0] offset
     /* 718783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718786 */     // MIs[0] auxiliary
     /* 718786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718789 */     // MIs[0] Operand 7
     /* 718789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718807 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET),
     /* 718810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718819 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718837 */     GIR_RootConstrainSelectedInstOperands,
     /* 718838 */     // GIR_Coverage, 5140,
     /* 718838 */     GIR_EraseRootFromParent_Done,
     /* 718839 */   // Label 9397: @718839
     /* 718839 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(718909), // Rule ID 5137 //
     /* 718844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718851 */     // MIs[0] offset
     /* 718851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718854 */     // MIs[0] auxiliary
     /* 718854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718857 */     // MIs[0] Operand 7
     /* 718857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718875 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFEN),
     /* 718878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718880 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718889 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718897 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718907 */     GIR_RootConstrainSelectedInstOperands,
     /* 718908 */     // GIR_Coverage, 5137,
     /* 718908 */     GIR_EraseRootFromParent_Done,
     /* 718909 */   // Label 9398: @718909
     /* 718909 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(718976), // Rule ID 5141 //
     /* 718914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 718918 */     // MIs[0] offset
     /* 718918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718921 */     // MIs[0] auxiliary
     /* 718921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718924 */     // MIs[0] Operand 7
     /* 718924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 718935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 718942 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 718942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN),
     /* 718945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 718947 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 718949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 718951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 718956 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 718958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 718964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 718970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 718974 */     GIR_RootConstrainSelectedInstOperands,
     /* 718975 */     // GIR_Coverage, 5141,
     /* 718975 */     GIR_EraseRootFromParent_Done,
     /* 718976 */   // Label 9399: @718976
     /* 718976 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(719038), // Rule ID 5138 //
     /* 718981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 718984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 718988 */     // MIs[0] offset
     /* 718988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 718991 */     // MIs[0] auxiliary
     /* 718991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 718994 */     // MIs[0] Operand 7
     /* 718994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 718997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719004 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_IDXEN),
     /* 719007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719009 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719018 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719036 */     GIR_RootConstrainSelectedInstOperands,
     /* 719037 */     // GIR_Coverage, 5138,
     /* 719037 */     GIR_EraseRootFromParent_Done,
     /* 719038 */   // Label 9400: @719038
     /* 719038 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(719097), // Rule ID 5142 //
     /* 719043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719047 */     // MIs[0] offset
     /* 719047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719050 */     // MIs[0] auxiliary
     /* 719050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719053 */     // MIs[0] Operand 7
     /* 719053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719063 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN),
     /* 719066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719068 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719077 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719095 */     GIR_RootConstrainSelectedInstOperands,
     /* 719096 */     // GIR_Coverage, 5142,
     /* 719096 */     GIR_EraseRootFromParent_Done,
     /* 719097 */   // Label 9401: @719097
     /* 719097 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(719197), // Rule ID 5139 //
     /* 719102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719105 */     // MIs[0] offset
     /* 719105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719108 */     // MIs[0] auxiliary
     /* 719108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719111 */     // MIs[0] Operand 7
     /* 719111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719121 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719137 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719144 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_BOTHEN),
     /* 719165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719177 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719179 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719195 */     GIR_RootConstrainSelectedInstOperands,
     /* 719196 */     // GIR_Coverage, 5139,
     /* 719196 */     GIR_EraseRootFromParent_Done,
     /* 719197 */   // Label 9402: @719197
     /* 719197 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(719294), // Rule ID 5143 //
     /* 719202 */     // MIs[0] offset
     /* 719202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719205 */     // MIs[0] auxiliary
     /* 719205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719208 */     // MIs[0] Operand 7
     /* 719208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719218 */     // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719234 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719241 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN),
     /* 719262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719274 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719292 */     GIR_RootConstrainSelectedInstOperands,
     /* 719293 */     // GIR_Coverage, 5143,
     /* 719293 */     GIR_EraseRootFromParent_Done,
     /* 719294 */   // Label 9403: @719294
     /* 719294 */   GIM_Reject,
     /* 719295 */ // Label 9395: @719295
     /* 719295 */ GIM_Reject,
     /* 719296 */ // Label 9391: @719296
     /* 719296 */ GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(719914),
     /* 719301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 719304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 719307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 719310 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 719313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 719317 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(719389), // Rule ID 5144 //
     /* 719322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719333 */     // MIs[0] offset
     /* 719333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719336 */     // MIs[0] auxiliary
     /* 719336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719339 */     // MIs[0] Operand 7
     /* 719339 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719357 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFSET),
     /* 719360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719369 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719387 */     GIR_RootConstrainSelectedInstOperands,
     /* 719388 */     // GIR_Coverage, 5144,
     /* 719388 */     GIR_EraseRootFromParent_Done,
     /* 719389 */   // Label 9405: @719389
     /* 719389 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(719458), // Rule ID 5148 //
     /* 719394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719402 */     // MIs[0] offset
     /* 719402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719405 */     // MIs[0] auxiliary
     /* 719405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719408 */     // MIs[0] Operand 7
     /* 719408 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719426 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET),
     /* 719429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719438 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719456 */     GIR_RootConstrainSelectedInstOperands,
     /* 719457 */     // GIR_Coverage, 5148,
     /* 719457 */     GIR_EraseRootFromParent_Done,
     /* 719458 */   // Label 9406: @719458
     /* 719458 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(719528), // Rule ID 5145 //
     /* 719463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719470 */     // MIs[0] offset
     /* 719470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719473 */     // MIs[0] auxiliary
     /* 719473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719476 */     // MIs[0] Operand 7
     /* 719476 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719494 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFEN),
     /* 719497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719499 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719508 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719510 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719526 */     GIR_RootConstrainSelectedInstOperands,
     /* 719527 */     // GIR_Coverage, 5145,
     /* 719527 */     GIR_EraseRootFromParent_Done,
     /* 719528 */   // Label 9407: @719528
     /* 719528 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(719595), // Rule ID 5149 //
     /* 719533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719537 */     // MIs[0] offset
     /* 719537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719540 */     // MIs[0] auxiliary
     /* 719540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719543 */     // MIs[0] Operand 7
     /* 719543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719561 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN),
     /* 719564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719566 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 719568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719575 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719593 */     GIR_RootConstrainSelectedInstOperands,
     /* 719594 */     // GIR_Coverage, 5149,
     /* 719594 */     GIR_EraseRootFromParent_Done,
     /* 719595 */   // Label 9408: @719595
     /* 719595 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(719657), // Rule ID 5146 //
     /* 719600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719607 */     // MIs[0] offset
     /* 719607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719610 */     // MIs[0] auxiliary
     /* 719610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719613 */     // MIs[0] Operand 7
     /* 719613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719623 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_IDXEN),
     /* 719626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719628 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719637 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719655 */     GIR_RootConstrainSelectedInstOperands,
     /* 719656 */     // GIR_Coverage, 5146,
     /* 719656 */     GIR_EraseRootFromParent_Done,
     /* 719657 */   // Label 9409: @719657
     /* 719657 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(719716), // Rule ID 5150 //
     /* 719662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719666 */     // MIs[0] offset
     /* 719666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719669 */     // MIs[0] auxiliary
     /* 719669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719672 */     // MIs[0] Operand 7
     /* 719672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719682 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN),
     /* 719685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719687 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 719689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719696 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719714 */     GIR_RootConstrainSelectedInstOperands,
     /* 719715 */     // GIR_Coverage, 5150,
     /* 719715 */     GIR_EraseRootFromParent_Done,
     /* 719716 */   // Label 9410: @719716
     /* 719716 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(719816), // Rule ID 5147 //
     /* 719721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719724 */     // MIs[0] offset
     /* 719724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719727 */     // MIs[0] auxiliary
     /* 719727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719730 */     // MIs[0] Operand 7
     /* 719730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719740 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719756 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719763 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_BOTHEN),
     /* 719784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719796 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719798 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719804 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719814 */     GIR_RootConstrainSelectedInstOperands,
     /* 719815 */     // GIR_Coverage, 5147,
     /* 719815 */     GIR_EraseRootFromParent_Done,
     /* 719816 */   // Label 9411: @719816
     /* 719816 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(719913), // Rule ID 5151 //
     /* 719821 */     // MIs[0] offset
     /* 719821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719824 */     // MIs[0] auxiliary
     /* 719824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719827 */     // MIs[0] Operand 7
     /* 719827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 719830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719837 */     // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 719840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 719844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 719849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 719853 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 719856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 719860 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 719863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 719868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 719878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN),
     /* 719881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 719886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719893 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719901 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 719907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 719911 */     GIR_RootConstrainSelectedInstOperands,
     /* 719912 */     // GIR_Coverage, 5151,
     /* 719912 */     GIR_EraseRootFromParent_Done,
     /* 719913 */   // Label 9412: @719913
     /* 719913 */   GIM_Reject,
     /* 719914 */ // Label 9404: @719914
     /* 719914 */ GIM_Reject,
     /* 719915 */ // Label 9392: @719915
     /* 719915 */ GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(720533),
     /* 719920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 719923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 719926 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 719929 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 719932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 719936 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(720008), // Rule ID 5152 //
     /* 719941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 719944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 719948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 719952 */     // MIs[0] offset
     /* 719952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 719955 */     // MIs[0] auxiliary
     /* 719955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 719958 */     // MIs[0] Operand 7
     /* 719958 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 719969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 719976 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 719976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFSET),
     /* 719979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 719981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 719983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 719988 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 719990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 719996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720006 */     GIR_RootConstrainSelectedInstOperands,
     /* 720007 */     // GIR_Coverage, 5152,
     /* 720007 */     GIR_EraseRootFromParent_Done,
     /* 720008 */   // Label 9414: @720008
     /* 720008 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(720077), // Rule ID 5156 //
     /* 720013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720021 */     // MIs[0] offset
     /* 720021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720024 */     // MIs[0] auxiliary
     /* 720024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720027 */     // MIs[0] Operand 7
     /* 720027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720045 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET),
     /* 720048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720057 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720059 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720075 */     GIR_RootConstrainSelectedInstOperands,
     /* 720076 */     // GIR_Coverage, 5156,
     /* 720076 */     GIR_EraseRootFromParent_Done,
     /* 720077 */   // Label 9415: @720077
     /* 720077 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(720147), // Rule ID 5153 //
     /* 720082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720089 */     // MIs[0] offset
     /* 720089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720092 */     // MIs[0] auxiliary
     /* 720092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720095 */     // MIs[0] Operand 7
     /* 720095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720113 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFEN),
     /* 720116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720118 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720127 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720145 */     GIR_RootConstrainSelectedInstOperands,
     /* 720146 */     // GIR_Coverage, 5153,
     /* 720146 */     GIR_EraseRootFromParent_Done,
     /* 720147 */   // Label 9416: @720147
     /* 720147 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(720214), // Rule ID 5157 //
     /* 720152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720156 */     // MIs[0] offset
     /* 720156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720159 */     // MIs[0] auxiliary
     /* 720159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720162 */     // MIs[0] Operand 7
     /* 720162 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720180 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN),
     /* 720183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720185 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720194 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720202 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720212 */     GIR_RootConstrainSelectedInstOperands,
     /* 720213 */     // GIR_Coverage, 5157,
     /* 720213 */     GIR_EraseRootFromParent_Done,
     /* 720214 */   // Label 9417: @720214
     /* 720214 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(720276), // Rule ID 5154 //
     /* 720219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720226 */     // MIs[0] offset
     /* 720226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720229 */     // MIs[0] auxiliary
     /* 720229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720232 */     // MIs[0] Operand 7
     /* 720232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720242 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_IDXEN),
     /* 720245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720247 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720256 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720258 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720264 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720274 */     GIR_RootConstrainSelectedInstOperands,
     /* 720275 */     // GIR_Coverage, 5154,
     /* 720275 */     GIR_EraseRootFromParent_Done,
     /* 720276 */   // Label 9418: @720276
     /* 720276 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(720335), // Rule ID 5158 //
     /* 720281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720285 */     // MIs[0] offset
     /* 720285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720288 */     // MIs[0] auxiliary
     /* 720288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720291 */     // MIs[0] Operand 7
     /* 720291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720301 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN),
     /* 720304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720306 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720315 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720317 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720323 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720333 */     GIR_RootConstrainSelectedInstOperands,
     /* 720334 */     // GIR_Coverage, 5158,
     /* 720334 */     GIR_EraseRootFromParent_Done,
     /* 720335 */   // Label 9419: @720335
     /* 720335 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(720435), // Rule ID 5155 //
     /* 720340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720343 */     // MIs[0] offset
     /* 720343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720346 */     // MIs[0] auxiliary
     /* 720346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720349 */     // MIs[0] Operand 7
     /* 720349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720359 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720375 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720382 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_BOTHEN),
     /* 720403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720415 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720417 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720423 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720433 */     GIR_RootConstrainSelectedInstOperands,
     /* 720434 */     // GIR_Coverage, 5155,
     /* 720434 */     GIR_EraseRootFromParent_Done,
     /* 720435 */   // Label 9420: @720435
     /* 720435 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(720532), // Rule ID 5159 //
     /* 720440 */     // MIs[0] offset
     /* 720440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720443 */     // MIs[0] auxiliary
     /* 720443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720446 */     // MIs[0] Operand 7
     /* 720446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720456 */     // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720472 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 720479 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 720482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 720487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 720497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN),
     /* 720500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 720505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720512 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720530 */     GIR_RootConstrainSelectedInstOperands,
     /* 720531 */     // GIR_Coverage, 5159,
     /* 720531 */     GIR_EraseRootFromParent_Done,
     /* 720532 */   // Label 9421: @720532
     /* 720532 */   GIM_Reject,
     /* 720533 */ // Label 9413: @720533
     /* 720533 */ GIM_Reject,
     /* 720534 */ // Label 9393: @720534
     /* 720534 */ GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(721152),
     /* 720539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 720542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 720545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 720548 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 720551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
     /* 720555 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(720627), // Rule ID 5160 //
     /* 720560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720571 */     // MIs[0] offset
     /* 720571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720574 */     // MIs[0] auxiliary
     /* 720574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720577 */     // MIs[0] Operand 7
     /* 720577 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720595 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFSET),
     /* 720598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720607 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720625 */     GIR_RootConstrainSelectedInstOperands,
     /* 720626 */     // GIR_Coverage, 5160,
     /* 720626 */     GIR_EraseRootFromParent_Done,
     /* 720627 */   // Label 9423: @720627
     /* 720627 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(720696), // Rule ID 5164 //
     /* 720632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720640 */     // MIs[0] offset
     /* 720640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720643 */     // MIs[0] auxiliary
     /* 720643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720646 */     // MIs[0] Operand 7
     /* 720646 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720664 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET),
     /* 720667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720676 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720678 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720684 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720694 */     GIR_RootConstrainSelectedInstOperands,
     /* 720695 */     // GIR_Coverage, 5164,
     /* 720695 */     GIR_EraseRootFromParent_Done,
     /* 720696 */   // Label 9424: @720696
     /* 720696 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(720766), // Rule ID 5161 //
     /* 720701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720708 */     // MIs[0] offset
     /* 720708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720711 */     // MIs[0] auxiliary
     /* 720711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720714 */     // MIs[0] Operand 7
     /* 720714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720732 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFEN),
     /* 720735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720737 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720746 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720748 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720764 */     GIR_RootConstrainSelectedInstOperands,
     /* 720765 */     // GIR_Coverage, 5161,
     /* 720765 */     GIR_EraseRootFromParent_Done,
     /* 720766 */   // Label 9425: @720766
     /* 720766 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(720833), // Rule ID 5165 //
     /* 720771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 720775 */     // MIs[0] offset
     /* 720775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720778 */     // MIs[0] auxiliary
     /* 720778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720781 */     // MIs[0] Operand 7
     /* 720781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 720792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720799 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN),
     /* 720802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720804 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 720806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720813 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720815 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720831 */     GIR_RootConstrainSelectedInstOperands,
     /* 720832 */     // GIR_Coverage, 5165,
     /* 720832 */     GIR_EraseRootFromParent_Done,
     /* 720833 */   // Label 9426: @720833
     /* 720833 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(720895), // Rule ID 5162 //
     /* 720838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720845 */     // MIs[0] offset
     /* 720845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720848 */     // MIs[0] auxiliary
     /* 720848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720851 */     // MIs[0] Operand 7
     /* 720851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720861 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_IDXEN),
     /* 720864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720866 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720875 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720877 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720893 */     GIR_RootConstrainSelectedInstOperands,
     /* 720894 */     // GIR_Coverage, 5162,
     /* 720894 */     GIR_EraseRootFromParent_Done,
     /* 720895 */   // Label 9427: @720895
     /* 720895 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(720954), // Rule ID 5166 //
     /* 720900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 720904 */     // MIs[0] offset
     /* 720904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720907 */     // MIs[0] auxiliary
     /* 720907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720910 */     // MIs[0] Operand 7
     /* 720910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720920 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN),
     /* 720923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 720925 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 720927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 720929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 720934 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 720936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 720942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 720948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 720952 */     GIR_RootConstrainSelectedInstOperands,
     /* 720953 */     // GIR_Coverage, 5166,
     /* 720953 */     GIR_EraseRootFromParent_Done,
     /* 720954 */   // Label 9428: @720954
     /* 720954 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(721054), // Rule ID 5163 //
     /* 720959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 720962 */     // MIs[0] offset
     /* 720962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 720965 */     // MIs[0] auxiliary
     /* 720965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 720968 */     // MIs[0] Operand 7
     /* 720968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 720971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 720978 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 720978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 720981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 720985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 720990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 720994 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 720997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721001 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_BOTHEN),
     /* 721022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721034 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721036 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721052 */     GIR_RootConstrainSelectedInstOperands,
     /* 721053 */     // GIR_Coverage, 5163,
     /* 721053 */     GIR_EraseRootFromParent_Done,
     /* 721054 */   // Label 9429: @721054
     /* 721054 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(721151), // Rule ID 5167 //
     /* 721059 */     // MIs[0] offset
     /* 721059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721062 */     // MIs[0] auxiliary
     /* 721062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721065 */     // MIs[0] Operand 7
     /* 721065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721075 */     // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721087 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721091 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721098 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN),
     /* 721119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721131 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721149 */     GIR_RootConstrainSelectedInstOperands,
     /* 721150 */     // GIR_Coverage, 5167,
     /* 721150 */     GIR_EraseRootFromParent_Done,
     /* 721151 */   // Label 9430: @721151
     /* 721151 */   GIM_Reject,
     /* 721152 */ // Label 9422: @721152
     /* 721152 */ GIM_Reject,
     /* 721153 */ // Label 9394: @721153
     /* 721153 */ GIM_Reject,
     /* 721154 */ // Label 134: @721154
     /* 721154 */ GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(721759),
     /* 721159 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 721162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 721165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 721168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 721171 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 721174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 721178 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(721450),
     /* 721183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721187 */     GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(721255), // Rule ID 5120 //
     /* 721192 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721195 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721199 */       // MIs[0] offset
     /* 721199 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721202 */       // MIs[0] auxiliary
     /* 721202 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721205 */       // MIs[0] Operand 7
     /* 721205 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721216 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721223 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721223 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
     /* 721226 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721228 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721230 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721235 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721237 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721243 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721249 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721253 */       GIR_RootConstrainSelectedInstOperands,
     /* 721254 */       // GIR_Coverage, 5120,
     /* 721254 */       GIR_EraseRootFromParent_Done,
     /* 721255 */     // Label 9433: @721255
     /* 721255 */     GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(721320), // Rule ID 5124 //
     /* 721260 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721264 */       // MIs[0] offset
     /* 721264 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721267 */       // MIs[0] auxiliary
     /* 721267 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721270 */       // MIs[0] Operand 7
     /* 721270 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721281 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721288 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721288 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
     /* 721291 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721293 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721295 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721300 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721302 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721308 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721314 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721318 */       GIR_RootConstrainSelectedInstOperands,
     /* 721319 */       // GIR_Coverage, 5124,
     /* 721319 */       GIR_EraseRootFromParent_Done,
     /* 721320 */     // Label 9434: @721320
     /* 721320 */     GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(721386), // Rule ID 5121 //
     /* 721325 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721328 */       // MIs[0] offset
     /* 721328 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721331 */       // MIs[0] auxiliary
     /* 721331 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721334 */       // MIs[0] Operand 7
     /* 721334 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721345 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721352 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
     /* 721355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721357 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721359 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721361 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721366 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721368 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721374 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721380 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721384 */       GIR_RootConstrainSelectedInstOperands,
     /* 721385 */       // GIR_Coverage, 5121,
     /* 721385 */       GIR_EraseRootFromParent_Done,
     /* 721386 */     // Label 9435: @721386
     /* 721386 */     GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(721449), // Rule ID 5125 //
     /* 721391 */       // MIs[0] offset
     /* 721391 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721394 */       // MIs[0] auxiliary
     /* 721394 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721397 */       // MIs[0] Operand 7
     /* 721397 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721408 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721415 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
     /* 721418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721420 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721422 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721424 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721429 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721431 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721437 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721443 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721447 */       GIR_RootConstrainSelectedInstOperands,
     /* 721448 */       // GIR_Coverage, 5125,
     /* 721448 */       GIR_EraseRootFromParent_Done,
     /* 721449 */     // Label 9436: @721449
     /* 721449 */     GIM_Reject,
     /* 721450 */   // Label 9432: @721450
     /* 721450 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(721564),
     /* 721455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721468 */     GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(721517), // Rule ID 5122 //
     /* 721473 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721476 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721483 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_IDXEN),
     /* 721486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721488 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721490 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721492 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721497 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721499 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721505 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721511 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721515 */       GIR_RootConstrainSelectedInstOperands,
     /* 721516 */       // GIR_Coverage, 5122,
     /* 721516 */       GIR_EraseRootFromParent_Done,
     /* 721517 */     // Label 9438: @721517
     /* 721517 */     GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(721563), // Rule ID 5126 //
     /* 721522 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721529 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721529 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_IDXEN),
     /* 721532 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721534 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 721536 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721538 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721543 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721545 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721551 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721557 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721561 */       GIR_RootConstrainSelectedInstOperands,
     /* 721562 */       // GIR_Coverage, 5126,
     /* 721562 */       GIR_EraseRootFromParent_Done,
     /* 721563 */     // Label 9439: @721563
     /* 721563 */     GIM_Reject,
     /* 721564 */   // Label 9437: @721564
     /* 721564 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(721758),
     /* 721569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 721578 */     GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(721669), // Rule ID 5123 //
     /* 721583 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721586 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721593 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721593 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721596 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721600 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721605 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721609 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721612 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721616 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721619 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721624 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721629 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721634 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_BOTHEN),
     /* 721637 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721639 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721642 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721644 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721649 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721651 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721657 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721663 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721667 */       GIR_RootConstrainSelectedInstOperands,
     /* 721668 */       // GIR_Coverage, 5123,
     /* 721668 */       GIR_EraseRootFromParent_Done,
     /* 721669 */     // Label 9441: @721669
     /* 721669 */     GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(721757), // Rule ID 5127 //
     /* 721674 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721681 */       // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 721684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 721688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 721693 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 721697 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 721700 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 721704 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 721707 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 721712 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721717 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 721722 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN),
     /* 721725 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721727 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 721730 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721732 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721737 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721739 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721745 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721751 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721755 */       GIR_RootConstrainSelectedInstOperands,
     /* 721756 */       // GIR_Coverage, 5127,
     /* 721756 */       GIR_EraseRootFromParent_Done,
     /* 721757 */     // Label 9442: @721757
     /* 721757 */     GIM_Reject,
     /* 721758 */   // Label 9440: @721758
     /* 721758 */   GIM_Reject,
     /* 721759 */ // Label 9431: @721759
     /* 721759 */ GIM_Reject,
     /* 721760 */ // Label 135: @721760
     /* 721760 */ GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(722365),
     /* 721765 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 721768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 721771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 721774 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 721777 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 721780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 721784 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(722056),
     /* 721789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 721793 */     GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(721861), // Rule ID 5184 //
     /* 721798 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721801 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721805 */       // MIs[0] offset
     /* 721805 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721808 */       // MIs[0] auxiliary
     /* 721808 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721811 */       // MIs[0] Operand 7
     /* 721811 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721822 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721829 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721829 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFSET),
     /* 721832 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721834 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721836 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721841 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721843 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721849 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721855 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721859 */       GIR_RootConstrainSelectedInstOperands,
     /* 721860 */       // GIR_Coverage, 5184,
     /* 721860 */       GIR_EraseRootFromParent_Done,
     /* 721861 */     // Label 9445: @721861
     /* 721861 */     GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(721926), // Rule ID 5188 //
     /* 721866 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 721870 */       // MIs[0] offset
     /* 721870 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721873 */       // MIs[0] auxiliary
     /* 721873 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721876 */       // MIs[0] Operand 7
     /* 721876 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721887 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721894 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721894 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET),
     /* 721897 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721899 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721901 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721906 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721908 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721914 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721920 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721924 */       GIR_RootConstrainSelectedInstOperands,
     /* 721925 */       // GIR_Coverage, 5188,
     /* 721925 */       GIR_EraseRootFromParent_Done,
     /* 721926 */     // Label 9446: @721926
     /* 721926 */     GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(721992), // Rule ID 5185 //
     /* 721931 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 721934 */       // MIs[0] offset
     /* 721934 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 721937 */       // MIs[0] auxiliary
     /* 721937 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 721940 */       // MIs[0] Operand 7
     /* 721940 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 721951 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 721958 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 721958 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFEN),
     /* 721961 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 721963 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 721965 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 721967 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 721972 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 721974 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 721980 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 721986 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 721990 */       GIR_RootConstrainSelectedInstOperands,
     /* 721991 */       // GIR_Coverage, 5185,
     /* 721991 */       GIR_EraseRootFromParent_Done,
     /* 721992 */     // Label 9447: @721992
     /* 721992 */     GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(722055), // Rule ID 5189 //
     /* 721997 */       // MIs[0] offset
     /* 721997 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722000 */       // MIs[0] auxiliary
     /* 722000 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722003 */       // MIs[0] Operand 7
     /* 722003 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722014 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722021 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722021 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN),
     /* 722024 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722026 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722028 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722030 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722035 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722037 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722043 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722049 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722053 */       GIR_RootConstrainSelectedInstOperands,
     /* 722054 */       // GIR_Coverage, 5189,
     /* 722054 */       GIR_EraseRootFromParent_Done,
     /* 722055 */     // Label 9448: @722055
     /* 722055 */     GIM_Reject,
     /* 722056 */   // Label 9444: @722056
     /* 722056 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(722170),
     /* 722061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722074 */     GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(722123), // Rule ID 5186 //
     /* 722079 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722082 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722089 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722089 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_IDXEN),
     /* 722092 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722094 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722096 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722098 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722103 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722105 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722111 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722117 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722121 */       GIR_RootConstrainSelectedInstOperands,
     /* 722122 */       // GIR_Coverage, 5186,
     /* 722122 */       GIR_EraseRootFromParent_Done,
     /* 722123 */     // Label 9450: @722123
     /* 722123 */     GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(722169), // Rule ID 5190 //
     /* 722128 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722135 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722135 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN),
     /* 722138 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722140 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722142 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722144 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722149 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722151 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722157 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722163 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722167 */       GIR_RootConstrainSelectedInstOperands,
     /* 722168 */       // GIR_Coverage, 5190,
     /* 722168 */       GIR_EraseRootFromParent_Done,
     /* 722169 */     // Label 9451: @722169
     /* 722169 */     GIM_Reject,
     /* 722170 */   // Label 9449: @722170
     /* 722170 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(722364),
     /* 722175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722184 */     GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(722275), // Rule ID 5187 //
     /* 722189 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722192 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722199 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722199 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722202 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722206 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722211 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722215 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722218 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722222 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722225 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722230 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722235 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722240 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_BOTHEN),
     /* 722243 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722245 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722248 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722250 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722255 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722257 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722263 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722269 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722273 */       GIR_RootConstrainSelectedInstOperands,
     /* 722274 */       // GIR_Coverage, 5187,
     /* 722274 */       GIR_EraseRootFromParent_Done,
     /* 722275 */     // Label 9453: @722275
     /* 722275 */     GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(722363), // Rule ID 5191 //
     /* 722280 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722287 */       // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722287 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722290 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722294 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722299 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722303 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722306 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722310 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722313 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722318 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722323 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722328 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN),
     /* 722331 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722333 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722336 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722338 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722343 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722345 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722351 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722357 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722361 */       GIR_RootConstrainSelectedInstOperands,
     /* 722362 */       // GIR_Coverage, 5191,
     /* 722362 */       GIR_EraseRootFromParent_Done,
     /* 722363 */     // Label 9454: @722363
     /* 722363 */     GIM_Reject,
     /* 722364 */   // Label 9452: @722364
     /* 722364 */   GIM_Reject,
     /* 722365 */ // Label 9443: @722365
     /* 722365 */ GIM_Reject,
     /* 722366 */ // Label 136: @722366
     /* 722366 */ GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(722971),
     /* 722371 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 722374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 722377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 722380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 722383 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 722386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 722390 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(722662),
     /* 722395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 722399 */     GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(722467), // Rule ID 5128 //
     /* 722404 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722407 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722411 */       // MIs[0] offset
     /* 722411 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722414 */       // MIs[0] auxiliary
     /* 722414 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722417 */       // MIs[0] Operand 7
     /* 722417 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722428 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722435 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
     /* 722438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722440 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722442 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722447 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722449 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722455 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722461 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722465 */       GIR_RootConstrainSelectedInstOperands,
     /* 722466 */       // GIR_Coverage, 5128,
     /* 722466 */       GIR_EraseRootFromParent_Done,
     /* 722467 */     // Label 9457: @722467
     /* 722467 */     GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(722532), // Rule ID 5132 //
     /* 722472 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722476 */       // MIs[0] offset
     /* 722476 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722479 */       // MIs[0] auxiliary
     /* 722479 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722482 */       // MIs[0] Operand 7
     /* 722482 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722493 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722500 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722500 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
     /* 722503 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722505 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722507 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722512 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722514 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722520 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722526 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722530 */       GIR_RootConstrainSelectedInstOperands,
     /* 722531 */       // GIR_Coverage, 5132,
     /* 722531 */       GIR_EraseRootFromParent_Done,
     /* 722532 */     // Label 9458: @722532
     /* 722532 */     GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(722598), // Rule ID 5129 //
     /* 722537 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722540 */       // MIs[0] offset
     /* 722540 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722543 */       // MIs[0] auxiliary
     /* 722543 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722546 */       // MIs[0] Operand 7
     /* 722546 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722557 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722564 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722564 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
     /* 722567 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722569 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722571 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722573 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722578 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722580 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722586 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722592 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722596 */       GIR_RootConstrainSelectedInstOperands,
     /* 722597 */       // GIR_Coverage, 5129,
     /* 722597 */       GIR_EraseRootFromParent_Done,
     /* 722598 */     // Label 9459: @722598
     /* 722598 */     GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(722661), // Rule ID 5133 //
     /* 722603 */       // MIs[0] offset
     /* 722603 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722606 */       // MIs[0] auxiliary
     /* 722606 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722609 */       // MIs[0] Operand 7
     /* 722609 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 722620 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722627 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722627 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
     /* 722630 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722632 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 722634 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722636 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722641 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722643 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722649 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722655 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722659 */       GIR_RootConstrainSelectedInstOperands,
     /* 722660 */       // GIR_Coverage, 5133,
     /* 722660 */       GIR_EraseRootFromParent_Done,
     /* 722661 */     // Label 9460: @722661
     /* 722661 */     GIM_Reject,
     /* 722662 */   // Label 9456: @722662
     /* 722662 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(722776),
     /* 722667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 722671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722680 */     GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(722729), // Rule ID 5130 //
     /* 722685 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722688 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722695 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722695 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_IDXEN),
     /* 722698 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722700 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722702 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722704 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722709 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722711 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722717 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722723 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722727 */       GIR_RootConstrainSelectedInstOperands,
     /* 722728 */       // GIR_Coverage, 5130,
     /* 722728 */       GIR_EraseRootFromParent_Done,
     /* 722729 */     // Label 9462: @722729
     /* 722729 */     GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(722775), // Rule ID 5134 //
     /* 722734 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722741 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722741 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_IDXEN),
     /* 722744 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722746 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 722748 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722750 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722755 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722757 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722763 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722769 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722773 */       GIR_RootConstrainSelectedInstOperands,
     /* 722774 */       // GIR_Coverage, 5134,
     /* 722774 */       GIR_EraseRootFromParent_Done,
     /* 722775 */     // Label 9463: @722775
     /* 722775 */     GIM_Reject,
     /* 722776 */   // Label 9461: @722776
     /* 722776 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(722970),
     /* 722781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 722784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 722787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 722790 */     GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(722881), // Rule ID 5131 //
     /* 722795 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 722798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722805 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722805 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722808 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722812 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722817 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722821 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722824 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722828 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722831 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722836 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722841 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722846 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_BOTHEN),
     /* 722849 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722851 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722854 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722856 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722861 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722863 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722869 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722875 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722879 */       GIR_RootConstrainSelectedInstOperands,
     /* 722880 */       // GIR_Coverage, 5131,
     /* 722880 */       GIR_EraseRootFromParent_Done,
     /* 722881 */     // Label 9465: @722881
     /* 722881 */     GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(722969), // Rule ID 5135 //
     /* 722886 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 722893 */       // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 722893 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 722896 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 722900 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 722905 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 722909 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 722912 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 722916 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 722919 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 722924 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722929 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 722934 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_BOTHEN),
     /* 722937 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 722939 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 722942 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 722944 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 722949 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 722951 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 722957 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 722963 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 722967 */       GIR_RootConstrainSelectedInstOperands,
     /* 722968 */       // GIR_Coverage, 5135,
     /* 722968 */       GIR_EraseRootFromParent_Done,
     /* 722969 */     // Label 9466: @722969
     /* 722969 */     GIM_Reject,
     /* 722970 */   // Label 9464: @722970
     /* 722970 */   GIM_Reject,
     /* 722971 */ // Label 9455: @722971
     /* 722971 */ GIM_Reject,
     /* 722972 */ // Label 137: @722972
     /* 722972 */ GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(723577),
     /* 722977 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 722980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 722983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 722986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 722989 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 722992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 722996 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(723268),
     /* 723001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723005 */     GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(723073), // Rule ID 5192 //
     /* 723010 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723013 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723017 */       // MIs[0] offset
     /* 723017 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723020 */       // MIs[0] auxiliary
     /* 723020 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723023 */       // MIs[0] Operand 7
     /* 723023 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723034 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723041 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723041 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFSET),
     /* 723044 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723046 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723048 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723053 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723055 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723061 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723067 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723071 */       GIR_RootConstrainSelectedInstOperands,
     /* 723072 */       // GIR_Coverage, 5192,
     /* 723072 */       GIR_EraseRootFromParent_Done,
     /* 723073 */     // Label 9469: @723073
     /* 723073 */     GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(723138), // Rule ID 5196 //
     /* 723078 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723082 */       // MIs[0] offset
     /* 723082 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723085 */       // MIs[0] auxiliary
     /* 723085 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723088 */       // MIs[0] Operand 7
     /* 723088 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723099 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723106 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723106 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET),
     /* 723109 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723111 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723113 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723118 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723120 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723126 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723132 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723136 */       GIR_RootConstrainSelectedInstOperands,
     /* 723137 */       // GIR_Coverage, 5196,
     /* 723137 */       GIR_EraseRootFromParent_Done,
     /* 723138 */     // Label 9470: @723138
     /* 723138 */     GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(723204), // Rule ID 5193 //
     /* 723143 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723146 */       // MIs[0] offset
     /* 723146 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723149 */       // MIs[0] auxiliary
     /* 723149 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723152 */       // MIs[0] Operand 7
     /* 723152 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723163 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723170 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723170 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFEN),
     /* 723173 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723175 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723177 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723179 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723184 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723186 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723192 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723198 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723202 */       GIR_RootConstrainSelectedInstOperands,
     /* 723203 */       // GIR_Coverage, 5193,
     /* 723203 */       GIR_EraseRootFromParent_Done,
     /* 723204 */     // Label 9471: @723204
     /* 723204 */     GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(723267), // Rule ID 5197 //
     /* 723209 */       // MIs[0] offset
     /* 723209 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723212 */       // MIs[0] auxiliary
     /* 723212 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723215 */       // MIs[0] Operand 7
     /* 723215 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723226 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723233 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723233 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN),
     /* 723236 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723238 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723240 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723242 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723247 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723249 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723255 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723261 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723265 */       GIR_RootConstrainSelectedInstOperands,
     /* 723266 */       // GIR_Coverage, 5197,
     /* 723266 */       GIR_EraseRootFromParent_Done,
     /* 723267 */     // Label 9472: @723267
     /* 723267 */     GIM_Reject,
     /* 723268 */   // Label 9468: @723268
     /* 723268 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(723382),
     /* 723273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723286 */     GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(723335), // Rule ID 5194 //
     /* 723291 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723294 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723301 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723301 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_IDXEN),
     /* 723304 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723306 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 723308 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723310 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723315 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723317 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723323 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723329 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723333 */       GIR_RootConstrainSelectedInstOperands,
     /* 723334 */       // GIR_Coverage, 5194,
     /* 723334 */       GIR_EraseRootFromParent_Done,
     /* 723335 */     // Label 9474: @723335
     /* 723335 */     GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(723381), // Rule ID 5198 //
     /* 723340 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723347 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723347 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN),
     /* 723350 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723352 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 723354 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723356 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723361 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723363 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723369 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723375 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723379 */       GIR_RootConstrainSelectedInstOperands,
     /* 723380 */       // GIR_Coverage, 5198,
     /* 723380 */       GIR_EraseRootFromParent_Done,
     /* 723381 */     // Label 9475: @723381
     /* 723381 */     GIM_Reject,
     /* 723382 */   // Label 9473: @723382
     /* 723382 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(723576),
     /* 723387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723396 */     GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(723487), // Rule ID 5195 //
     /* 723401 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723404 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723411 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723411 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723414 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723418 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723423 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723427 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723430 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723434 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723447 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_BOTHEN),
     /* 723455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723457 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723460 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723462 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723467 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723469 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723475 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723481 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723485 */       GIR_RootConstrainSelectedInstOperands,
     /* 723486 */       // GIR_Coverage, 5195,
     /* 723486 */       GIR_EraseRootFromParent_Done,
     /* 723487 */     // Label 9477: @723487
     /* 723487 */     GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(723575), // Rule ID 5199 //
     /* 723492 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723499 */       // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723499 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 723502 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 723506 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 723511 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 723515 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 723518 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 723522 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 723525 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 723530 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723535 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 723540 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN),
     /* 723543 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 723545 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 723548 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723550 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723555 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723557 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723563 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723569 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723573 */       GIR_RootConstrainSelectedInstOperands,
     /* 723574 */       // GIR_Coverage, 5199,
     /* 723574 */       GIR_EraseRootFromParent_Done,
     /* 723575 */     // Label 9478: @723575
     /* 723575 */     GIM_Reject,
     /* 723576 */   // Label 9476: @723576
     /* 723576 */   GIM_Reject,
     /* 723577 */ // Label 9467: @723577
     /* 723577 */ GIM_Reject,
     /* 723578 */ // Label 138: @723578
     /* 723578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 9495*/ GIMT_Encode4(738885),
     /* 723589 */ /*GILLT_p0s64*//*Label 9479*/ GIMT_Encode4(723681),
     /* 723593 */ /*GILLT_p1s64*//*Label 9480*/ GIMT_Encode4(724296),
     /* 723597 */ /*GILLT_p2s32*//*Label 9481*/ GIMT_Encode4(724911),
     /* 723601 */ /*GILLT_p3s32*//*Label 9482*/ GIMT_Encode4(725526),
     /* 723605 */ /*GILLT_p4s64*//*Label 9483*/ GIMT_Encode4(726141),
     /* 723609 */ /*GILLT_p5s32*//*Label 9484*/ GIMT_Encode4(726756),
     /* 723613 */ /*GILLT_p6s32*//*Label 9485*/ GIMT_Encode4(727371), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 723625 */ /*GILLT_s32*//*Label 9486*/ GIMT_Encode4(727986),
     /* 723629 */ /*GILLT_s64*//*Label 9487*/ GIMT_Encode4(729197),
     /* 723633 */ /*GILLT_v2s16*//*Label 9488*/ GIMT_Encode4(730408),
     /* 723637 */ /*GILLT_v2s32*//*Label 9489*/ GIMT_Encode4(731619),
     /* 723641 */ /*GILLT_v2s64*//*Label 9490*/ GIMT_Encode4(732830),
     /* 723645 */ /*GILLT_v3s32*//*Label 9491*/ GIMT_Encode4(734041), GIMT_Encode4(0),
     /* 723653 */ /*GILLT_v4s16*//*Label 9492*/ GIMT_Encode4(735252),
     /* 723657 */ /*GILLT_v4s32*//*Label 9493*/ GIMT_Encode4(736463), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 723677 */ /*GILLT_v8s16*//*Label 9494*/ GIMT_Encode4(737674),
     /* 723681 */ // Label 9479: @723681
     /* 723681 */ GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(724295),
     /* 723686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 723689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 723692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 723695 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 723698 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(723770), // Rule ID 5480 //
     /* 723703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723714 */     // MIs[0] offset
     /* 723714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723717 */     // MIs[0] auxiliary
     /* 723717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723720 */     // MIs[0] Operand 7
     /* 723720 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723738 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 723741 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723750 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723768 */     GIR_RootConstrainSelectedInstOperands,
     /* 723769 */     // GIR_Coverage, 5480,
     /* 723769 */     GIR_EraseRootFromParent_Done,
     /* 723770 */   // Label 9497: @723770
     /* 723770 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(723839), // Rule ID 5484 //
     /* 723775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723783 */     // MIs[0] offset
     /* 723783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723786 */     // MIs[0] auxiliary
     /* 723786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723789 */     // MIs[0] Operand 7
     /* 723789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723807 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 723810 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723819 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723837 */     GIR_RootConstrainSelectedInstOperands,
     /* 723838 */     // GIR_Coverage, 5484,
     /* 723838 */     GIR_EraseRootFromParent_Done,
     /* 723839 */   // Label 9498: @723839
     /* 723839 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(723909), // Rule ID 5481 //
     /* 723844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723851 */     // MIs[0] offset
     /* 723851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723854 */     // MIs[0] auxiliary
     /* 723854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723857 */     // MIs[0] Operand 7
     /* 723857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723875 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 723878 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723880 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723889 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723897 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723907 */     GIR_RootConstrainSelectedInstOperands,
     /* 723908 */     // GIR_Coverage, 5481,
     /* 723908 */     GIR_EraseRootFromParent_Done,
     /* 723909 */   // Label 9499: @723909
     /* 723909 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(723976), // Rule ID 5485 //
     /* 723914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 723918 */     // MIs[0] offset
     /* 723918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723921 */     // MIs[0] auxiliary
     /* 723921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723924 */     // MIs[0] Operand 7
     /* 723924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 723935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 723942 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 723942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 723945 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 723947 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 723949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 723951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 723956 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 723958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 723964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 723970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 723974 */     GIR_RootConstrainSelectedInstOperands,
     /* 723975 */     // GIR_Coverage, 5485,
     /* 723975 */     GIR_EraseRootFromParent_Done,
     /* 723976 */   // Label 9500: @723976
     /* 723976 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(724038), // Rule ID 5482 //
     /* 723981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 723984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 723988 */     // MIs[0] offset
     /* 723988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 723991 */     // MIs[0] auxiliary
     /* 723991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 723994 */     // MIs[0] Operand 7
     /* 723994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 723997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724004 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 724007 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724009 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724018 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724020 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724026 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724036 */     GIR_RootConstrainSelectedInstOperands,
     /* 724037 */     // GIR_Coverage, 5482,
     /* 724037 */     GIR_EraseRootFromParent_Done,
     /* 724038 */   // Label 9501: @724038
     /* 724038 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(724097), // Rule ID 5486 //
     /* 724043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724047 */     // MIs[0] offset
     /* 724047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724050 */     // MIs[0] auxiliary
     /* 724050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724053 */     // MIs[0] Operand 7
     /* 724053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724063 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 724066 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724068 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724077 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724079 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724095 */     GIR_RootConstrainSelectedInstOperands,
     /* 724096 */     // GIR_Coverage, 5486,
     /* 724096 */     GIR_EraseRootFromParent_Done,
     /* 724097 */   // Label 9502: @724097
     /* 724097 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(724197), // Rule ID 5483 //
     /* 724102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724105 */     // MIs[0] offset
     /* 724105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724108 */     // MIs[0] auxiliary
     /* 724108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724111 */     // MIs[0] Operand 7
     /* 724111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724121 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724137 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724144 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 724165 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724177 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724179 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724185 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724195 */     GIR_RootConstrainSelectedInstOperands,
     /* 724196 */     // GIR_Coverage, 5483,
     /* 724196 */     GIR_EraseRootFromParent_Done,
     /* 724197 */   // Label 9503: @724197
     /* 724197 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(724294), // Rule ID 5487 //
     /* 724202 */     // MIs[0] offset
     /* 724202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724205 */     // MIs[0] auxiliary
     /* 724205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724208 */     // MIs[0] Operand 7
     /* 724208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724218 */     // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724234 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724241 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 724262 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724274 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724276 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724292 */     GIR_RootConstrainSelectedInstOperands,
     /* 724293 */     // GIR_Coverage, 5487,
     /* 724293 */     GIR_EraseRootFromParent_Done,
     /* 724294 */   // Label 9504: @724294
     /* 724294 */   GIM_Reject,
     /* 724295 */ // Label 9496: @724295
     /* 724295 */ GIM_Reject,
     /* 724296 */ // Label 9480: @724296
     /* 724296 */ GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(724910),
     /* 724301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 724304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 724307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 724310 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 724313 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(724385), // Rule ID 5488 //
     /* 724318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724329 */     // MIs[0] offset
     /* 724329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724332 */     // MIs[0] auxiliary
     /* 724332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724335 */     // MIs[0] Operand 7
     /* 724335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724353 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 724356 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724365 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724367 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724373 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724383 */     GIR_RootConstrainSelectedInstOperands,
     /* 724384 */     // GIR_Coverage, 5488,
     /* 724384 */     GIR_EraseRootFromParent_Done,
     /* 724385 */   // Label 9506: @724385
     /* 724385 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(724454), // Rule ID 5492 //
     /* 724390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724398 */     // MIs[0] offset
     /* 724398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724401 */     // MIs[0] auxiliary
     /* 724401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724404 */     // MIs[0] Operand 7
     /* 724404 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724422 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 724425 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724434 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724452 */     GIR_RootConstrainSelectedInstOperands,
     /* 724453 */     // GIR_Coverage, 5492,
     /* 724453 */     GIR_EraseRootFromParent_Done,
     /* 724454 */   // Label 9507: @724454
     /* 724454 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(724524), // Rule ID 5489 //
     /* 724459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724466 */     // MIs[0] offset
     /* 724466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724469 */     // MIs[0] auxiliary
     /* 724469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724472 */     // MIs[0] Operand 7
     /* 724472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724490 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 724493 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724495 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724504 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724522 */     GIR_RootConstrainSelectedInstOperands,
     /* 724523 */     // GIR_Coverage, 5489,
     /* 724523 */     GIR_EraseRootFromParent_Done,
     /* 724524 */   // Label 9508: @724524
     /* 724524 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(724591), // Rule ID 5493 //
     /* 724529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724533 */     // MIs[0] offset
     /* 724533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724536 */     // MIs[0] auxiliary
     /* 724536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724539 */     // MIs[0] Operand 7
     /* 724539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724557 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 724560 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724562 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 724564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724571 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724573 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724589 */     GIR_RootConstrainSelectedInstOperands,
     /* 724590 */     // GIR_Coverage, 5493,
     /* 724590 */     GIR_EraseRootFromParent_Done,
     /* 724591 */   // Label 9509: @724591
     /* 724591 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(724653), // Rule ID 5490 //
     /* 724596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724603 */     // MIs[0] offset
     /* 724603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724606 */     // MIs[0] auxiliary
     /* 724606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724609 */     // MIs[0] Operand 7
     /* 724609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724619 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 724622 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724624 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724633 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724651 */     GIR_RootConstrainSelectedInstOperands,
     /* 724652 */     // GIR_Coverage, 5490,
     /* 724652 */     GIR_EraseRootFromParent_Done,
     /* 724653 */   // Label 9510: @724653
     /* 724653 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(724712), // Rule ID 5494 //
     /* 724658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724662 */     // MIs[0] offset
     /* 724662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724665 */     // MIs[0] auxiliary
     /* 724665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724668 */     // MIs[0] Operand 7
     /* 724668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724678 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 724681 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724683 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 724685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724692 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724694 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724710 */     GIR_RootConstrainSelectedInstOperands,
     /* 724711 */     // GIR_Coverage, 5494,
     /* 724711 */     GIR_EraseRootFromParent_Done,
     /* 724712 */   // Label 9511: @724712
     /* 724712 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(724812), // Rule ID 5491 //
     /* 724717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724720 */     // MIs[0] offset
     /* 724720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724723 */     // MIs[0] auxiliary
     /* 724723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724726 */     // MIs[0] Operand 7
     /* 724726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724736 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 724780 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724792 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724794 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724800 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724810 */     GIR_RootConstrainSelectedInstOperands,
     /* 724811 */     // GIR_Coverage, 5491,
     /* 724811 */     GIR_EraseRootFromParent_Done,
     /* 724812 */   // Label 9512: @724812
     /* 724812 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(724909), // Rule ID 5495 //
     /* 724817 */     // MIs[0] offset
     /* 724817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724820 */     // MIs[0] auxiliary
     /* 724820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724823 */     // MIs[0] Operand 7
     /* 724823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 724826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724833 */     // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 724836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 724840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 724845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 724849 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 724852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 724856 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 724859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 724864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 724874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 724877 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 724882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724889 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724891 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724897 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724907 */     GIR_RootConstrainSelectedInstOperands,
     /* 724908 */     // GIR_Coverage, 5495,
     /* 724908 */     GIR_EraseRootFromParent_Done,
     /* 724909 */   // Label 9513: @724909
     /* 724909 */   GIM_Reject,
     /* 724910 */ // Label 9505: @724910
     /* 724910 */ GIM_Reject,
     /* 724911 */ // Label 9481: @724911
     /* 724911 */ GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(725525),
     /* 724916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 724919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 724922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 724925 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 724928 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(725000), // Rule ID 5400 //
     /* 724933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 724936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 724940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 724944 */     // MIs[0] offset
     /* 724944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 724947 */     // MIs[0] auxiliary
     /* 724947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 724950 */     // MIs[0] Operand 7
     /* 724950 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 724961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 724968 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 724968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 724971 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 724973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 724975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 724980 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 724982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 724988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 724994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 724998 */     GIR_RootConstrainSelectedInstOperands,
     /* 724999 */     // GIR_Coverage, 5400,
     /* 724999 */     GIR_EraseRootFromParent_Done,
     /* 725000 */   // Label 9515: @725000
     /* 725000 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(725069), // Rule ID 5404 //
     /* 725005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725013 */     // MIs[0] offset
     /* 725013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725016 */     // MIs[0] auxiliary
     /* 725016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725019 */     // MIs[0] Operand 7
     /* 725019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725037 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 725040 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725049 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725067 */     GIR_RootConstrainSelectedInstOperands,
     /* 725068 */     // GIR_Coverage, 5404,
     /* 725068 */     GIR_EraseRootFromParent_Done,
     /* 725069 */   // Label 9516: @725069
     /* 725069 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(725139), // Rule ID 5401 //
     /* 725074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725081 */     // MIs[0] offset
     /* 725081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725084 */     // MIs[0] auxiliary
     /* 725084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725087 */     // MIs[0] Operand 7
     /* 725087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725105 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 725108 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725110 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725119 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725137 */     GIR_RootConstrainSelectedInstOperands,
     /* 725138 */     // GIR_Coverage, 5401,
     /* 725138 */     GIR_EraseRootFromParent_Done,
     /* 725139 */   // Label 9517: @725139
     /* 725139 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(725206), // Rule ID 5405 //
     /* 725144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725148 */     // MIs[0] offset
     /* 725148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725151 */     // MIs[0] auxiliary
     /* 725151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725154 */     // MIs[0] Operand 7
     /* 725154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725172 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 725175 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725177 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725186 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725204 */     GIR_RootConstrainSelectedInstOperands,
     /* 725205 */     // GIR_Coverage, 5405,
     /* 725205 */     GIR_EraseRootFromParent_Done,
     /* 725206 */   // Label 9518: @725206
     /* 725206 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(725268), // Rule ID 5402 //
     /* 725211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725218 */     // MIs[0] offset
     /* 725218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725221 */     // MIs[0] auxiliary
     /* 725221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725224 */     // MIs[0] Operand 7
     /* 725224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725234 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 725237 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725239 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725248 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725266 */     GIR_RootConstrainSelectedInstOperands,
     /* 725267 */     // GIR_Coverage, 5402,
     /* 725267 */     GIR_EraseRootFromParent_Done,
     /* 725268 */   // Label 9519: @725268
     /* 725268 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(725327), // Rule ID 5406 //
     /* 725273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725277 */     // MIs[0] offset
     /* 725277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725280 */     // MIs[0] auxiliary
     /* 725280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725283 */     // MIs[0] Operand 7
     /* 725283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725293 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 725296 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725298 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725307 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725325 */     GIR_RootConstrainSelectedInstOperands,
     /* 725326 */     // GIR_Coverage, 5406,
     /* 725326 */     GIR_EraseRootFromParent_Done,
     /* 725327 */   // Label 9520: @725327
     /* 725327 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(725427), // Rule ID 5403 //
     /* 725332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725335 */     // MIs[0] offset
     /* 725335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725338 */     // MIs[0] auxiliary
     /* 725338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725341 */     // MIs[0] Operand 7
     /* 725341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725351 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725367 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725374 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 725395 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725407 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725425 */     GIR_RootConstrainSelectedInstOperands,
     /* 725426 */     // GIR_Coverage, 5403,
     /* 725426 */     GIR_EraseRootFromParent_Done,
     /* 725427 */   // Label 9521: @725427
     /* 725427 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(725524), // Rule ID 5407 //
     /* 725432 */     // MIs[0] offset
     /* 725432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725435 */     // MIs[0] auxiliary
     /* 725435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725438 */     // MIs[0] Operand 7
     /* 725438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725448 */     // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725460 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725464 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725471 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 725489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 725492 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 725497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725504 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725522 */     GIR_RootConstrainSelectedInstOperands,
     /* 725523 */     // GIR_Coverage, 5407,
     /* 725523 */     GIR_EraseRootFromParent_Done,
     /* 725524 */   // Label 9522: @725524
     /* 725524 */   GIM_Reject,
     /* 725525 */ // Label 9514: @725525
     /* 725525 */ GIM_Reject,
     /* 725526 */ // Label 9482: @725526
     /* 725526 */ GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(726140),
     /* 725531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 725534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 725537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 725540 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 725543 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(725615), // Rule ID 5408 //
     /* 725548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725559 */     // MIs[0] offset
     /* 725559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725562 */     // MIs[0] auxiliary
     /* 725562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725565 */     // MIs[0] Operand 7
     /* 725565 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725583 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 725586 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725595 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725613 */     GIR_RootConstrainSelectedInstOperands,
     /* 725614 */     // GIR_Coverage, 5408,
     /* 725614 */     GIR_EraseRootFromParent_Done,
     /* 725615 */   // Label 9524: @725615
     /* 725615 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(725684), // Rule ID 5412 //
     /* 725620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725628 */     // MIs[0] offset
     /* 725628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725631 */     // MIs[0] auxiliary
     /* 725631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725634 */     // MIs[0] Operand 7
     /* 725634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725652 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 725655 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725664 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725666 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725672 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725682 */     GIR_RootConstrainSelectedInstOperands,
     /* 725683 */     // GIR_Coverage, 5412,
     /* 725683 */     GIR_EraseRootFromParent_Done,
     /* 725684 */   // Label 9525: @725684
     /* 725684 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(725754), // Rule ID 5409 //
     /* 725689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725696 */     // MIs[0] offset
     /* 725696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725699 */     // MIs[0] auxiliary
     /* 725699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725702 */     // MIs[0] Operand 7
     /* 725702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725720 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 725723 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725725 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725734 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725752 */     GIR_RootConstrainSelectedInstOperands,
     /* 725753 */     // GIR_Coverage, 5409,
     /* 725753 */     GIR_EraseRootFromParent_Done,
     /* 725754 */   // Label 9526: @725754
     /* 725754 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(725821), // Rule ID 5413 //
     /* 725759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 725763 */     // MIs[0] offset
     /* 725763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725766 */     // MIs[0] auxiliary
     /* 725766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725769 */     // MIs[0] Operand 7
     /* 725769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 725780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725787 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 725790 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725792 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 725794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725801 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725819 */     GIR_RootConstrainSelectedInstOperands,
     /* 725820 */     // GIR_Coverage, 5413,
     /* 725820 */     GIR_EraseRootFromParent_Done,
     /* 725821 */   // Label 9527: @725821
     /* 725821 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(725883), // Rule ID 5410 //
     /* 725826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725833 */     // MIs[0] offset
     /* 725833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725836 */     // MIs[0] auxiliary
     /* 725836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725839 */     // MIs[0] Operand 7
     /* 725839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725849 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 725852 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725854 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725863 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725881 */     GIR_RootConstrainSelectedInstOperands,
     /* 725882 */     // GIR_Coverage, 5410,
     /* 725882 */     GIR_EraseRootFromParent_Done,
     /* 725883 */   // Label 9528: @725883
     /* 725883 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(725942), // Rule ID 5414 //
     /* 725888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 725892 */     // MIs[0] offset
     /* 725892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725895 */     // MIs[0] auxiliary
     /* 725895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725898 */     // MIs[0] Operand 7
     /* 725898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725908 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 725911 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 725913 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 725915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 725917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 725922 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 725924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 725930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 725936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 725940 */     GIR_RootConstrainSelectedInstOperands,
     /* 725941 */     // GIR_Coverage, 5414,
     /* 725941 */     GIR_EraseRootFromParent_Done,
     /* 725942 */   // Label 9529: @725942
     /* 725942 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(726042), // Rule ID 5411 //
     /* 725947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 725950 */     // MIs[0] offset
     /* 725950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 725953 */     // MIs[0] auxiliary
     /* 725953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 725956 */     // MIs[0] Operand 7
     /* 725956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 725959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 725966 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 725966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 725969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 725973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 725978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 725982 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 725985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 725989 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 725992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 725997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 726010 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726022 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726030 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726040 */     GIR_RootConstrainSelectedInstOperands,
     /* 726041 */     // GIR_Coverage, 5411,
     /* 726041 */     GIR_EraseRootFromParent_Done,
     /* 726042 */   // Label 9530: @726042
     /* 726042 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(726139), // Rule ID 5415 //
     /* 726047 */     // MIs[0] offset
     /* 726047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726050 */     // MIs[0] auxiliary
     /* 726050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726053 */     // MIs[0] Operand 7
     /* 726053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726063 */     // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726079 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726086 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 726107 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726119 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726137 */     GIR_RootConstrainSelectedInstOperands,
     /* 726138 */     // GIR_Coverage, 5415,
     /* 726138 */     GIR_EraseRootFromParent_Done,
     /* 726139 */   // Label 9531: @726139
     /* 726139 */   GIM_Reject,
     /* 726140 */ // Label 9523: @726140
     /* 726140 */ GIM_Reject,
     /* 726141 */ // Label 9483: @726141
     /* 726141 */ GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(726755),
     /* 726146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 726149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 726152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 726155 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 726158 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(726230), // Rule ID 5496 //
     /* 726163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726174 */     // MIs[0] offset
     /* 726174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726177 */     // MIs[0] auxiliary
     /* 726177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726180 */     // MIs[0] Operand 7
     /* 726180 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726198 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 726201 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726210 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726218 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726228 */     GIR_RootConstrainSelectedInstOperands,
     /* 726229 */     // GIR_Coverage, 5496,
     /* 726229 */     GIR_EraseRootFromParent_Done,
     /* 726230 */   // Label 9533: @726230
     /* 726230 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(726299), // Rule ID 5500 //
     /* 726235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726243 */     // MIs[0] offset
     /* 726243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726246 */     // MIs[0] auxiliary
     /* 726246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726249 */     // MIs[0] Operand 7
     /* 726249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726267 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 726270 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726279 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726281 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726287 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726297 */     GIR_RootConstrainSelectedInstOperands,
     /* 726298 */     // GIR_Coverage, 5500,
     /* 726298 */     GIR_EraseRootFromParent_Done,
     /* 726299 */   // Label 9534: @726299
     /* 726299 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(726369), // Rule ID 5497 //
     /* 726304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726311 */     // MIs[0] offset
     /* 726311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726314 */     // MIs[0] auxiliary
     /* 726314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726317 */     // MIs[0] Operand 7
     /* 726317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726335 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 726338 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726340 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726349 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726351 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726367 */     GIR_RootConstrainSelectedInstOperands,
     /* 726368 */     // GIR_Coverage, 5497,
     /* 726368 */     GIR_EraseRootFromParent_Done,
     /* 726369 */   // Label 9535: @726369
     /* 726369 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(726436), // Rule ID 5501 //
     /* 726374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726378 */     // MIs[0] offset
     /* 726378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726381 */     // MIs[0] auxiliary
     /* 726381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726384 */     // MIs[0] Operand 7
     /* 726384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726402 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 726405 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726407 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726416 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726434 */     GIR_RootConstrainSelectedInstOperands,
     /* 726435 */     // GIR_Coverage, 5501,
     /* 726435 */     GIR_EraseRootFromParent_Done,
     /* 726436 */   // Label 9536: @726436
     /* 726436 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(726498), // Rule ID 5498 //
     /* 726441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726448 */     // MIs[0] offset
     /* 726448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726451 */     // MIs[0] auxiliary
     /* 726451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726454 */     // MIs[0] Operand 7
     /* 726454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726464 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 726467 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726469 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726478 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726496 */     GIR_RootConstrainSelectedInstOperands,
     /* 726497 */     // GIR_Coverage, 5498,
     /* 726497 */     GIR_EraseRootFromParent_Done,
     /* 726498 */   // Label 9537: @726498
     /* 726498 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(726557), // Rule ID 5502 //
     /* 726503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726507 */     // MIs[0] offset
     /* 726507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726510 */     // MIs[0] auxiliary
     /* 726510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726513 */     // MIs[0] Operand 7
     /* 726513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726523 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 726526 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726528 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 726530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726537 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726555 */     GIR_RootConstrainSelectedInstOperands,
     /* 726556 */     // GIR_Coverage, 5502,
     /* 726556 */     GIR_EraseRootFromParent_Done,
     /* 726557 */   // Label 9538: @726557
     /* 726557 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(726657), // Rule ID 5499 //
     /* 726562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726565 */     // MIs[0] offset
     /* 726565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726568 */     // MIs[0] auxiliary
     /* 726568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726571 */     // MIs[0] Operand 7
     /* 726571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726581 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726597 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726600 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726604 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 726625 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726637 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726655 */     GIR_RootConstrainSelectedInstOperands,
     /* 726656 */     // GIR_Coverage, 5499,
     /* 726656 */     GIR_EraseRootFromParent_Done,
     /* 726657 */   // Label 9539: @726657
     /* 726657 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(726754), // Rule ID 5503 //
     /* 726662 */     // MIs[0] offset
     /* 726662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726665 */     // MIs[0] auxiliary
     /* 726665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726668 */     // MIs[0] Operand 7
     /* 726668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 726671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726678 */     // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 726681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 726685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 726690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 726694 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 726697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 726701 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 726704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 726709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 726719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 726722 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 726727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726734 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726742 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726752 */     GIR_RootConstrainSelectedInstOperands,
     /* 726753 */     // GIR_Coverage, 5503,
     /* 726753 */     GIR_EraseRootFromParent_Done,
     /* 726754 */   // Label 9540: @726754
     /* 726754 */   GIM_Reject,
     /* 726755 */ // Label 9532: @726755
     /* 726755 */ GIM_Reject,
     /* 726756 */ // Label 9484: @726756
     /* 726756 */ GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(727370),
     /* 726761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 726764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 726767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 726770 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 726773 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(726845), // Rule ID 5416 //
     /* 726778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726789 */     // MIs[0] offset
     /* 726789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726792 */     // MIs[0] auxiliary
     /* 726792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726795 */     // MIs[0] Operand 7
     /* 726795 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726813 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 726816 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726825 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726833 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726843 */     GIR_RootConstrainSelectedInstOperands,
     /* 726844 */     // GIR_Coverage, 5416,
     /* 726844 */     GIR_EraseRootFromParent_Done,
     /* 726845 */   // Label 9542: @726845
     /* 726845 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(726914), // Rule ID 5420 //
     /* 726850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 726858 */     // MIs[0] offset
     /* 726858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726861 */     // MIs[0] auxiliary
     /* 726861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726864 */     // MIs[0] Operand 7
     /* 726864 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726882 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 726885 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726894 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726912 */     GIR_RootConstrainSelectedInstOperands,
     /* 726913 */     // GIR_Coverage, 5420,
     /* 726913 */     GIR_EraseRootFromParent_Done,
     /* 726914 */   // Label 9543: @726914
     /* 726914 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(726984), // Rule ID 5417 //
     /* 726919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 726922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726926 */     // MIs[0] offset
     /* 726926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726929 */     // MIs[0] auxiliary
     /* 726929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726932 */     // MIs[0] Operand 7
     /* 726932 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 726943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 726950 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 726950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 726953 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 726955 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 726957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 726959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 726964 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 726966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 726972 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 726978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 726982 */     GIR_RootConstrainSelectedInstOperands,
     /* 726983 */     // GIR_Coverage, 5417,
     /* 726983 */     GIR_EraseRootFromParent_Done,
     /* 726984 */   // Label 9544: @726984
     /* 726984 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(727051), // Rule ID 5421 //
     /* 726989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 726993 */     // MIs[0] offset
     /* 726993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 726996 */     // MIs[0] auxiliary
     /* 726996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 726999 */     // MIs[0] Operand 7
     /* 726999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727017 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 727020 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727022 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727031 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727033 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727049 */     GIR_RootConstrainSelectedInstOperands,
     /* 727050 */     // GIR_Coverage, 5421,
     /* 727050 */     GIR_EraseRootFromParent_Done,
     /* 727051 */   // Label 9545: @727051
     /* 727051 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(727113), // Rule ID 5418 //
     /* 727056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727063 */     // MIs[0] offset
     /* 727063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727066 */     // MIs[0] auxiliary
     /* 727066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727069 */     // MIs[0] Operand 7
     /* 727069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727079 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 727082 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727084 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727093 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727101 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727111 */     GIR_RootConstrainSelectedInstOperands,
     /* 727112 */     // GIR_Coverage, 5418,
     /* 727112 */     GIR_EraseRootFromParent_Done,
     /* 727113 */   // Label 9546: @727113
     /* 727113 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(727172), // Rule ID 5422 //
     /* 727118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727122 */     // MIs[0] offset
     /* 727122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727125 */     // MIs[0] auxiliary
     /* 727125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727128 */     // MIs[0] Operand 7
     /* 727128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727138 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 727141 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727143 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727152 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727154 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727160 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727170 */     GIR_RootConstrainSelectedInstOperands,
     /* 727171 */     // GIR_Coverage, 5422,
     /* 727171 */     GIR_EraseRootFromParent_Done,
     /* 727172 */   // Label 9547: @727172
     /* 727172 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(727272), // Rule ID 5419 //
     /* 727177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727180 */     // MIs[0] offset
     /* 727180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727183 */     // MIs[0] auxiliary
     /* 727183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727186 */     // MIs[0] Operand 7
     /* 727186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727196 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727212 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727219 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 727240 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727252 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727260 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727270 */     GIR_RootConstrainSelectedInstOperands,
     /* 727271 */     // GIR_Coverage, 5419,
     /* 727271 */     GIR_EraseRootFromParent_Done,
     /* 727272 */   // Label 9548: @727272
     /* 727272 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(727369), // Rule ID 5423 //
     /* 727277 */     // MIs[0] offset
     /* 727277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727280 */     // MIs[0] auxiliary
     /* 727280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727283 */     // MIs[0] Operand 7
     /* 727283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727293 */     // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727309 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727316 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 727337 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727349 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727351 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727367 */     GIR_RootConstrainSelectedInstOperands,
     /* 727368 */     // GIR_Coverage, 5423,
     /* 727368 */     GIR_EraseRootFromParent_Done,
     /* 727369 */   // Label 9549: @727369
     /* 727369 */   GIM_Reject,
     /* 727370 */ // Label 9541: @727370
     /* 727370 */ GIM_Reject,
     /* 727371 */ // Label 9485: @727371
     /* 727371 */ GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(727985),
     /* 727376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 727379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 727382 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 727385 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 727388 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(727460), // Rule ID 5424 //
     /* 727393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727404 */     // MIs[0] offset
     /* 727404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727407 */     // MIs[0] auxiliary
     /* 727407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727410 */     // MIs[0] Operand 7
     /* 727410 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727428 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 727431 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727440 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727458 */     GIR_RootConstrainSelectedInstOperands,
     /* 727459 */     // GIR_Coverage, 5424,
     /* 727459 */     GIR_EraseRootFromParent_Done,
     /* 727460 */   // Label 9551: @727460
     /* 727460 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(727529), // Rule ID 5428 //
     /* 727465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727473 */     // MIs[0] offset
     /* 727473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727476 */     // MIs[0] auxiliary
     /* 727476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727479 */     // MIs[0] Operand 7
     /* 727479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727497 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 727500 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727509 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727511 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727517 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727527 */     GIR_RootConstrainSelectedInstOperands,
     /* 727528 */     // GIR_Coverage, 5428,
     /* 727528 */     GIR_EraseRootFromParent_Done,
     /* 727529 */   // Label 9552: @727529
     /* 727529 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(727599), // Rule ID 5425 //
     /* 727534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727541 */     // MIs[0] offset
     /* 727541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727544 */     // MIs[0] auxiliary
     /* 727544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727547 */     // MIs[0] Operand 7
     /* 727547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727565 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 727568 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727570 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727579 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727587 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727597 */     GIR_RootConstrainSelectedInstOperands,
     /* 727598 */     // GIR_Coverage, 5425,
     /* 727598 */     GIR_EraseRootFromParent_Done,
     /* 727599 */   // Label 9553: @727599
     /* 727599 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(727666), // Rule ID 5429 //
     /* 727604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 727608 */     // MIs[0] offset
     /* 727608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727611 */     // MIs[0] auxiliary
     /* 727611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727614 */     // MIs[0] Operand 7
     /* 727614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 727625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727632 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 727635 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727637 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 727639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727646 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727664 */     GIR_RootConstrainSelectedInstOperands,
     /* 727665 */     // GIR_Coverage, 5429,
     /* 727665 */     GIR_EraseRootFromParent_Done,
     /* 727666 */   // Label 9554: @727666
     /* 727666 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(727728), // Rule ID 5426 //
     /* 727671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727678 */     // MIs[0] offset
     /* 727678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727681 */     // MIs[0] auxiliary
     /* 727681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727684 */     // MIs[0] Operand 7
     /* 727684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727694 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 727697 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727699 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727708 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727726 */     GIR_RootConstrainSelectedInstOperands,
     /* 727727 */     // GIR_Coverage, 5426,
     /* 727727 */     GIR_EraseRootFromParent_Done,
     /* 727728 */   // Label 9555: @727728
     /* 727728 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(727787), // Rule ID 5430 //
     /* 727733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 727737 */     // MIs[0] offset
     /* 727737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727740 */     // MIs[0] auxiliary
     /* 727740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727743 */     // MIs[0] Operand 7
     /* 727743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727753 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 727756 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727758 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 727760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727767 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727769 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727775 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727785 */     GIR_RootConstrainSelectedInstOperands,
     /* 727786 */     // GIR_Coverage, 5430,
     /* 727786 */     GIR_EraseRootFromParent_Done,
     /* 727787 */   // Label 9556: @727787
     /* 727787 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(727887), // Rule ID 5427 //
     /* 727792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 727795 */     // MIs[0] offset
     /* 727795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727798 */     // MIs[0] auxiliary
     /* 727798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727801 */     // MIs[0] Operand 7
     /* 727801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727811 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727827 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727834 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 727855 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727867 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727869 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727885 */     GIR_RootConstrainSelectedInstOperands,
     /* 727886 */     // GIR_Coverage, 5427,
     /* 727886 */     GIR_EraseRootFromParent_Done,
     /* 727887 */   // Label 9557: @727887
     /* 727887 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(727984), // Rule ID 5431 //
     /* 727892 */     // MIs[0] offset
     /* 727892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 727895 */     // MIs[0] auxiliary
     /* 727895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 727898 */     // MIs[0] Operand 7
     /* 727898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 727901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 727908 */     // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 727908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 727911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 727915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 727920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 727924 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 727927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 727931 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 727934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 727939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 727949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 727952 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 727954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 727957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 727959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 727964 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 727966 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 727972 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 727978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 727982 */     GIR_RootConstrainSelectedInstOperands,
     /* 727983 */     // GIR_Coverage, 5431,
     /* 727983 */     GIR_EraseRootFromParent_Done,
     /* 727984 */   // Label 9558: @727984
     /* 727984 */   GIM_Reject,
     /* 727985 */ // Label 9550: @727985
     /* 727985 */ GIM_Reject,
     /* 727986 */ // Label 9486: @727986
     /* 727986 */ GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(729196),
     /* 727991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 727994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 727997 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 728000 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 728003 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(728075), // Rule ID 5368 //
     /* 728008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728019 */     // MIs[0] offset
     /* 728019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728022 */     // MIs[0] auxiliary
     /* 728022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728025 */     // MIs[0] Operand 7
     /* 728025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728043 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 728046 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728055 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728073 */     GIR_RootConstrainSelectedInstOperands,
     /* 728074 */     // GIR_Coverage, 5368,
     /* 728074 */     GIR_EraseRootFromParent_Done,
     /* 728075 */   // Label 9560: @728075
     /* 728075 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(728144), // Rule ID 5372 //
     /* 728080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728088 */     // MIs[0] offset
     /* 728088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728091 */     // MIs[0] auxiliary
     /* 728091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728094 */     // MIs[0] Operand 7
     /* 728094 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728112 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 728115 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728124 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728142 */     GIR_RootConstrainSelectedInstOperands,
     /* 728143 */     // GIR_Coverage, 5372,
     /* 728143 */     GIR_EraseRootFromParent_Done,
     /* 728144 */   // Label 9561: @728144
     /* 728144 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(728216), // Rule ID 5376 //
     /* 728149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728160 */     // MIs[0] offset
     /* 728160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728163 */     // MIs[0] auxiliary
     /* 728163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728166 */     // MIs[0] Operand 7
     /* 728166 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728184 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 728187 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728196 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728214 */     GIR_RootConstrainSelectedInstOperands,
     /* 728215 */     // GIR_Coverage, 5376,
     /* 728215 */     GIR_EraseRootFromParent_Done,
     /* 728216 */   // Label 9562: @728216
     /* 728216 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(728285), // Rule ID 5380 //
     /* 728221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728229 */     // MIs[0] offset
     /* 728229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728232 */     // MIs[0] auxiliary
     /* 728232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728235 */     // MIs[0] Operand 7
     /* 728235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728253 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 728256 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728265 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728267 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728283 */     GIR_RootConstrainSelectedInstOperands,
     /* 728284 */     // GIR_Coverage, 5380,
     /* 728284 */     GIR_EraseRootFromParent_Done,
     /* 728285 */   // Label 9563: @728285
     /* 728285 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(728355), // Rule ID 5369 //
     /* 728290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728297 */     // MIs[0] offset
     /* 728297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728300 */     // MIs[0] auxiliary
     /* 728300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728303 */     // MIs[0] Operand 7
     /* 728303 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728321 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 728324 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728326 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728335 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728353 */     GIR_RootConstrainSelectedInstOperands,
     /* 728354 */     // GIR_Coverage, 5369,
     /* 728354 */     GIR_EraseRootFromParent_Done,
     /* 728355 */   // Label 9564: @728355
     /* 728355 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(728422), // Rule ID 5373 //
     /* 728360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728364 */     // MIs[0] offset
     /* 728364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728367 */     // MIs[0] auxiliary
     /* 728367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728370 */     // MIs[0] Operand 7
     /* 728370 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728388 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 728391 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728393 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728402 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728420 */     GIR_RootConstrainSelectedInstOperands,
     /* 728421 */     // GIR_Coverage, 5373,
     /* 728421 */     GIR_EraseRootFromParent_Done,
     /* 728422 */   // Label 9565: @728422
     /* 728422 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(728492), // Rule ID 5377 //
     /* 728427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728434 */     // MIs[0] offset
     /* 728434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728437 */     // MIs[0] auxiliary
     /* 728437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728440 */     // MIs[0] Operand 7
     /* 728440 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728458 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 728461 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728463 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728472 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728490 */     GIR_RootConstrainSelectedInstOperands,
     /* 728491 */     // GIR_Coverage, 5377,
     /* 728491 */     GIR_EraseRootFromParent_Done,
     /* 728492 */   // Label 9566: @728492
     /* 728492 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(728559), // Rule ID 5381 //
     /* 728497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 728501 */     // MIs[0] offset
     /* 728501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728504 */     // MIs[0] auxiliary
     /* 728504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728507 */     // MIs[0] Operand 7
     /* 728507 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 728518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728525 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 728528 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728530 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 728532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728539 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728557 */     GIR_RootConstrainSelectedInstOperands,
     /* 728558 */     // GIR_Coverage, 5381,
     /* 728558 */     GIR_EraseRootFromParent_Done,
     /* 728559 */   // Label 9567: @728559
     /* 728559 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(728621), // Rule ID 5370 //
     /* 728564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728571 */     // MIs[0] offset
     /* 728571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728574 */     // MIs[0] auxiliary
     /* 728574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728577 */     // MIs[0] Operand 7
     /* 728577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728587 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 728590 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728592 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728601 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728619 */     GIR_RootConstrainSelectedInstOperands,
     /* 728620 */     // GIR_Coverage, 5370,
     /* 728620 */     GIR_EraseRootFromParent_Done,
     /* 728621 */   // Label 9568: @728621
     /* 728621 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(728680), // Rule ID 5374 //
     /* 728626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728630 */     // MIs[0] offset
     /* 728630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728633 */     // MIs[0] auxiliary
     /* 728633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728636 */     // MIs[0] Operand 7
     /* 728636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728646 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 728649 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728651 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728660 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728678 */     GIR_RootConstrainSelectedInstOperands,
     /* 728679 */     // GIR_Coverage, 5374,
     /* 728679 */     GIR_EraseRootFromParent_Done,
     /* 728680 */   // Label 9569: @728680
     /* 728680 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(728742), // Rule ID 5378 //
     /* 728685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728692 */     // MIs[0] offset
     /* 728692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728695 */     // MIs[0] auxiliary
     /* 728695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728698 */     // MIs[0] Operand 7
     /* 728698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728708 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 728711 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728713 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728722 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728740 */     GIR_RootConstrainSelectedInstOperands,
     /* 728741 */     // GIR_Coverage, 5378,
     /* 728741 */     GIR_EraseRootFromParent_Done,
     /* 728742 */   // Label 9570: @728742
     /* 728742 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(728801), // Rule ID 5382 //
     /* 728747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 728751 */     // MIs[0] offset
     /* 728751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728754 */     // MIs[0] auxiliary
     /* 728754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728757 */     // MIs[0] Operand 7
     /* 728757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728767 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 728770 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728772 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 728774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728781 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728799 */     GIR_RootConstrainSelectedInstOperands,
     /* 728800 */     // GIR_Coverage, 5382,
     /* 728800 */     GIR_EraseRootFromParent_Done,
     /* 728801 */   // Label 9571: @728801
     /* 728801 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(728901), // Rule ID 5371 //
     /* 728806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 728809 */     // MIs[0] offset
     /* 728809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728812 */     // MIs[0] auxiliary
     /* 728812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728815 */     // MIs[0] Operand 7
     /* 728815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728825 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728841 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728848 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 728869 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728881 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728899 */     GIR_RootConstrainSelectedInstOperands,
     /* 728900 */     // GIR_Coverage, 5371,
     /* 728900 */     GIR_EraseRootFromParent_Done,
     /* 728901 */   // Label 9572: @728901
     /* 728901 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(728998), // Rule ID 5375 //
     /* 728906 */     // MIs[0] offset
     /* 728906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 728909 */     // MIs[0] auxiliary
     /* 728909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 728912 */     // MIs[0] Operand 7
     /* 728912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 728915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 728922 */     // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 728922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 728925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 728929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 728934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 728938 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 728941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 728945 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 728948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 728953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 728963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 728966 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 728968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 728971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 728973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 728978 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 728980 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 728986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 728992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 728996 */     GIR_RootConstrainSelectedInstOperands,
     /* 728997 */     // GIR_Coverage, 5375,
     /* 728997 */     GIR_EraseRootFromParent_Done,
     /* 728998 */   // Label 9573: @728998
     /* 728998 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(729098), // Rule ID 5379 //
     /* 729003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729006 */     // MIs[0] offset
     /* 729006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729009 */     // MIs[0] auxiliary
     /* 729009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729012 */     // MIs[0] Operand 7
     /* 729012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729022 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729038 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729045 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 729066 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729078 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729096 */     GIR_RootConstrainSelectedInstOperands,
     /* 729097 */     // GIR_Coverage, 5379,
     /* 729097 */     GIR_EraseRootFromParent_Done,
     /* 729098 */   // Label 9574: @729098
     /* 729098 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(729195), // Rule ID 5383 //
     /* 729103 */     // MIs[0] offset
     /* 729103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729106 */     // MIs[0] auxiliary
     /* 729106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729109 */     // MIs[0] Operand 7
     /* 729109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729119 */     // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 729122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 729126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 729131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 729135 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 729138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 729142 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 729145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 729150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 729160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 729163 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 729168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729175 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729193 */     GIR_RootConstrainSelectedInstOperands,
     /* 729194 */     // GIR_Coverage, 5383,
     /* 729194 */     GIR_EraseRootFromParent_Done,
     /* 729195 */   // Label 9575: @729195
     /* 729195 */   GIM_Reject,
     /* 729196 */ // Label 9559: @729196
     /* 729196 */ GIM_Reject,
     /* 729197 */ // Label 9487: @729197
     /* 729197 */ GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(730407),
     /* 729202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 729205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 729208 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 729211 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 729214 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(729286), // Rule ID 5432 //
     /* 729219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729230 */     // MIs[0] offset
     /* 729230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729233 */     // MIs[0] auxiliary
     /* 729233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729236 */     // MIs[0] Operand 7
     /* 729236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729254 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 729257 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729266 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729268 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729284 */     GIR_RootConstrainSelectedInstOperands,
     /* 729285 */     // GIR_Coverage, 5432,
     /* 729285 */     GIR_EraseRootFromParent_Done,
     /* 729286 */   // Label 9577: @729286
     /* 729286 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(729355), // Rule ID 5436 //
     /* 729291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729299 */     // MIs[0] offset
     /* 729299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729302 */     // MIs[0] auxiliary
     /* 729302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729305 */     // MIs[0] Operand 7
     /* 729305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729323 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 729326 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729335 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729353 */     GIR_RootConstrainSelectedInstOperands,
     /* 729354 */     // GIR_Coverage, 5436,
     /* 729354 */     GIR_EraseRootFromParent_Done,
     /* 729355 */   // Label 9578: @729355
     /* 729355 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(729427), // Rule ID 5440 //
     /* 729360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729371 */     // MIs[0] offset
     /* 729371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729374 */     // MIs[0] auxiliary
     /* 729374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729377 */     // MIs[0] Operand 7
     /* 729377 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729395 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 729398 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729407 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729425 */     GIR_RootConstrainSelectedInstOperands,
     /* 729426 */     // GIR_Coverage, 5440,
     /* 729426 */     GIR_EraseRootFromParent_Done,
     /* 729427 */   // Label 9579: @729427
     /* 729427 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(729496), // Rule ID 5444 //
     /* 729432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729440 */     // MIs[0] offset
     /* 729440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729443 */     // MIs[0] auxiliary
     /* 729443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729446 */     // MIs[0] Operand 7
     /* 729446 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729464 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 729467 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729476 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729478 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729484 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729494 */     GIR_RootConstrainSelectedInstOperands,
     /* 729495 */     // GIR_Coverage, 5444,
     /* 729495 */     GIR_EraseRootFromParent_Done,
     /* 729496 */   // Label 9580: @729496
     /* 729496 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(729566), // Rule ID 5433 //
     /* 729501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729508 */     // MIs[0] offset
     /* 729508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729511 */     // MIs[0] auxiliary
     /* 729511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729514 */     // MIs[0] Operand 7
     /* 729514 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729532 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 729535 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729537 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729546 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729548 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729564 */     GIR_RootConstrainSelectedInstOperands,
     /* 729565 */     // GIR_Coverage, 5433,
     /* 729565 */     GIR_EraseRootFromParent_Done,
     /* 729566 */   // Label 9581: @729566
     /* 729566 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(729633), // Rule ID 5437 //
     /* 729571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729575 */     // MIs[0] offset
     /* 729575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729578 */     // MIs[0] auxiliary
     /* 729578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729581 */     // MIs[0] Operand 7
     /* 729581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729599 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 729602 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729604 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729613 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729621 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729631 */     GIR_RootConstrainSelectedInstOperands,
     /* 729632 */     // GIR_Coverage, 5437,
     /* 729632 */     GIR_EraseRootFromParent_Done,
     /* 729633 */   // Label 9582: @729633
     /* 729633 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(729703), // Rule ID 5441 //
     /* 729638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729645 */     // MIs[0] offset
     /* 729645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729648 */     // MIs[0] auxiliary
     /* 729648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729651 */     // MIs[0] Operand 7
     /* 729651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729669 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 729672 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729674 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729683 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729685 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729691 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729701 */     GIR_RootConstrainSelectedInstOperands,
     /* 729702 */     // GIR_Coverage, 5441,
     /* 729702 */     GIR_EraseRootFromParent_Done,
     /* 729703 */   // Label 9583: @729703
     /* 729703 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(729770), // Rule ID 5445 //
     /* 729708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 729712 */     // MIs[0] offset
     /* 729712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729715 */     // MIs[0] auxiliary
     /* 729715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729718 */     // MIs[0] Operand 7
     /* 729718 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 729729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729736 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 729739 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729741 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 729743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729750 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729768 */     GIR_RootConstrainSelectedInstOperands,
     /* 729769 */     // GIR_Coverage, 5445,
     /* 729769 */     GIR_EraseRootFromParent_Done,
     /* 729770 */   // Label 9584: @729770
     /* 729770 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(729832), // Rule ID 5434 //
     /* 729775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729782 */     // MIs[0] offset
     /* 729782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729785 */     // MIs[0] auxiliary
     /* 729785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729788 */     // MIs[0] Operand 7
     /* 729788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729798 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 729801 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729803 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729812 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729830 */     GIR_RootConstrainSelectedInstOperands,
     /* 729831 */     // GIR_Coverage, 5434,
     /* 729831 */     GIR_EraseRootFromParent_Done,
     /* 729832 */   // Label 9585: @729832
     /* 729832 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(729891), // Rule ID 5438 //
     /* 729837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729841 */     // MIs[0] offset
     /* 729841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729844 */     // MIs[0] auxiliary
     /* 729844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729847 */     // MIs[0] Operand 7
     /* 729847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729857 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 729860 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729862 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729871 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729889 */     GIR_RootConstrainSelectedInstOperands,
     /* 729890 */     // GIR_Coverage, 5438,
     /* 729890 */     GIR_EraseRootFromParent_Done,
     /* 729891 */   // Label 9586: @729891
     /* 729891 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(729953), // Rule ID 5442 //
     /* 729896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 729899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729903 */     // MIs[0] offset
     /* 729903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729906 */     // MIs[0] auxiliary
     /* 729906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729909 */     // MIs[0] Operand 7
     /* 729909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729919 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 729922 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729924 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729933 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729935 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 729941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 729947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 729951 */     GIR_RootConstrainSelectedInstOperands,
     /* 729952 */     // GIR_Coverage, 5442,
     /* 729952 */     GIR_EraseRootFromParent_Done,
     /* 729953 */   // Label 9587: @729953
     /* 729953 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(730012), // Rule ID 5446 //
     /* 729958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 729962 */     // MIs[0] offset
     /* 729962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 729965 */     // MIs[0] auxiliary
     /* 729965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 729968 */     // MIs[0] Operand 7
     /* 729968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 729971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 729978 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 729978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 729981 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 729983 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 729985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 729987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 729992 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 729994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730010 */     GIR_RootConstrainSelectedInstOperands,
     /* 730011 */     // GIR_Coverage, 5446,
     /* 730011 */     GIR_EraseRootFromParent_Done,
     /* 730012 */   // Label 9588: @730012
     /* 730012 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(730112), // Rule ID 5435 //
     /* 730017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730020 */     // MIs[0] offset
     /* 730020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730023 */     // MIs[0] auxiliary
     /* 730023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730026 */     // MIs[0] Operand 7
     /* 730026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730036 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730052 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730059 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 730080 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730092 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730110 */     GIR_RootConstrainSelectedInstOperands,
     /* 730111 */     // GIR_Coverage, 5435,
     /* 730111 */     GIR_EraseRootFromParent_Done,
     /* 730112 */   // Label 9589: @730112
     /* 730112 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(730209), // Rule ID 5439 //
     /* 730117 */     // MIs[0] offset
     /* 730117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730120 */     // MIs[0] auxiliary
     /* 730120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730123 */     // MIs[0] Operand 7
     /* 730123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730133 */     // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730145 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730149 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730156 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 730177 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730189 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730197 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730207 */     GIR_RootConstrainSelectedInstOperands,
     /* 730208 */     // GIR_Coverage, 5439,
     /* 730208 */     GIR_EraseRootFromParent_Done,
     /* 730209 */   // Label 9590: @730209
     /* 730209 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(730309), // Rule ID 5443 //
     /* 730214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730217 */     // MIs[0] offset
     /* 730217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730220 */     // MIs[0] auxiliary
     /* 730220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730223 */     // MIs[0] Operand 7
     /* 730223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730233 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730256 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 730277 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730289 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730307 */     GIR_RootConstrainSelectedInstOperands,
     /* 730308 */     // GIR_Coverage, 5443,
     /* 730308 */     GIR_EraseRootFromParent_Done,
     /* 730309 */   // Label 9591: @730309
     /* 730309 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(730406), // Rule ID 5447 //
     /* 730314 */     // MIs[0] offset
     /* 730314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730317 */     // MIs[0] auxiliary
     /* 730317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730320 */     // MIs[0] Operand 7
     /* 730320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 730323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730330 */     // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 730333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 730337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 730342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 730346 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 730349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 730353 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 730356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 730361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 730371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 730374 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 730379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730386 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730388 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730394 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730404 */     GIR_RootConstrainSelectedInstOperands,
     /* 730405 */     // GIR_Coverage, 5447,
     /* 730405 */     GIR_EraseRootFromParent_Done,
     /* 730406 */   // Label 9592: @730406
     /* 730406 */   GIM_Reject,
     /* 730407 */ // Label 9576: @730407
     /* 730407 */ GIM_Reject,
     /* 730408 */ // Label 9488: @730408
     /* 730408 */ GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(731618),
     /* 730413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 730416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 730419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 730422 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 730425 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(730497), // Rule ID 5384 //
     /* 730430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730441 */     // MIs[0] offset
     /* 730441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730444 */     // MIs[0] auxiliary
     /* 730444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730447 */     // MIs[0] Operand 7
     /* 730447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730465 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 730468 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730477 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730485 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730495 */     GIR_RootConstrainSelectedInstOperands,
     /* 730496 */     // GIR_Coverage, 5384,
     /* 730496 */     GIR_EraseRootFromParent_Done,
     /* 730497 */   // Label 9594: @730497
     /* 730497 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(730566), // Rule ID 5388 //
     /* 730502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730510 */     // MIs[0] offset
     /* 730510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730513 */     // MIs[0] auxiliary
     /* 730513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730516 */     // MIs[0] Operand 7
     /* 730516 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730534 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 730537 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730546 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730548 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730564 */     GIR_RootConstrainSelectedInstOperands,
     /* 730565 */     // GIR_Coverage, 5388,
     /* 730565 */     GIR_EraseRootFromParent_Done,
     /* 730566 */   // Label 9595: @730566
     /* 730566 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(730638), // Rule ID 5392 //
     /* 730571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730582 */     // MIs[0] offset
     /* 730582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730585 */     // MIs[0] auxiliary
     /* 730585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730588 */     // MIs[0] Operand 7
     /* 730588 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730606 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9744:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
     /* 730609 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730618 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730620 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730626 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730636 */     GIR_RootConstrainSelectedInstOperands,
     /* 730637 */     // GIR_Coverage, 5392,
     /* 730637 */     GIR_EraseRootFromParent_Done,
     /* 730638 */   // Label 9596: @730638
     /* 730638 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(730707), // Rule ID 5396 //
     /* 730643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730651 */     // MIs[0] offset
     /* 730651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730654 */     // MIs[0] auxiliary
     /* 730654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730657 */     // MIs[0] Operand 7
     /* 730657 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730675 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9744:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
     /* 730678 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730687 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730689 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730705 */     GIR_RootConstrainSelectedInstOperands,
     /* 730706 */     // GIR_Coverage, 5396,
     /* 730706 */     GIR_EraseRootFromParent_Done,
     /* 730707 */   // Label 9597: @730707
     /* 730707 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(730777), // Rule ID 5385 //
     /* 730712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730719 */     // MIs[0] offset
     /* 730719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730722 */     // MIs[0] auxiliary
     /* 730722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730725 */     // MIs[0] Operand 7
     /* 730725 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730743 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 730746 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730748 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730757 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730775 */     GIR_RootConstrainSelectedInstOperands,
     /* 730776 */     // GIR_Coverage, 5385,
     /* 730776 */     GIR_EraseRootFromParent_Done,
     /* 730777 */   // Label 9598: @730777
     /* 730777 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(730844), // Rule ID 5389 //
     /* 730782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730786 */     // MIs[0] offset
     /* 730786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730789 */     // MIs[0] auxiliary
     /* 730789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730792 */     // MIs[0] Operand 7
     /* 730792 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730810 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 730813 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730815 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730824 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730826 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730832 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730842 */     GIR_RootConstrainSelectedInstOperands,
     /* 730843 */     // GIR_Coverage, 5389,
     /* 730843 */     GIR_EraseRootFromParent_Done,
     /* 730844 */   // Label 9599: @730844
     /* 730844 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(730914), // Rule ID 5393 //
     /* 730849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730856 */     // MIs[0] offset
     /* 730856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730859 */     // MIs[0] auxiliary
     /* 730859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730862 */     // MIs[0] Operand 7
     /* 730862 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730880 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
     /* 730883 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730885 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730894 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730912 */     GIR_RootConstrainSelectedInstOperands,
     /* 730913 */     // GIR_Coverage, 5393,
     /* 730913 */     GIR_EraseRootFromParent_Done,
     /* 730914 */   // Label 9600: @730914
     /* 730914 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(730981), // Rule ID 5397 //
     /* 730919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 730923 */     // MIs[0] offset
     /* 730923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730926 */     // MIs[0] auxiliary
     /* 730926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730929 */     // MIs[0] Operand 7
     /* 730929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 730940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 730947 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 730947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
     /* 730950 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 730952 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 730954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 730956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 730961 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 730963 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 730969 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 730975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 730979 */     GIR_RootConstrainSelectedInstOperands,
     /* 730980 */     // GIR_Coverage, 5397,
     /* 730980 */     GIR_EraseRootFromParent_Done,
     /* 730981 */   // Label 9601: @730981
     /* 730981 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(731043), // Rule ID 5386 //
     /* 730986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 730989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 730993 */     // MIs[0] offset
     /* 730993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 730996 */     // MIs[0] auxiliary
     /* 730996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 730999 */     // MIs[0] Operand 7
     /* 730999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731009 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 731012 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731014 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731023 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731041 */     GIR_RootConstrainSelectedInstOperands,
     /* 731042 */     // GIR_Coverage, 5386,
     /* 731042 */     GIR_EraseRootFromParent_Done,
     /* 731043 */   // Label 9602: @731043
     /* 731043 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(731102), // Rule ID 5390 //
     /* 731048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731052 */     // MIs[0] offset
     /* 731052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731055 */     // MIs[0] auxiliary
     /* 731055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731058 */     // MIs[0] Operand 7
     /* 731058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731068 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 731071 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731073 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731082 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731084 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731100 */     GIR_RootConstrainSelectedInstOperands,
     /* 731101 */     // GIR_Coverage, 5390,
     /* 731101 */     GIR_EraseRootFromParent_Done,
     /* 731102 */   // Label 9603: @731102
     /* 731102 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(731164), // Rule ID 5394 //
     /* 731107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731114 */     // MIs[0] offset
     /* 731114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731117 */     // MIs[0] auxiliary
     /* 731117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731120 */     // MIs[0] Operand 7
     /* 731120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731130 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
     /* 731133 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731135 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731144 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731146 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731162 */     GIR_RootConstrainSelectedInstOperands,
     /* 731163 */     // GIR_Coverage, 5394,
     /* 731163 */     GIR_EraseRootFromParent_Done,
     /* 731164 */   // Label 9604: @731164
     /* 731164 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(731223), // Rule ID 5398 //
     /* 731169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731173 */     // MIs[0] offset
     /* 731173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731176 */     // MIs[0] auxiliary
     /* 731176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731179 */     // MIs[0] Operand 7
     /* 731179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731189 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
     /* 731192 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731194 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 731196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731203 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731205 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731221 */     GIR_RootConstrainSelectedInstOperands,
     /* 731222 */     // GIR_Coverage, 5398,
     /* 731222 */     GIR_EraseRootFromParent_Done,
     /* 731223 */   // Label 9605: @731223
     /* 731223 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(731323), // Rule ID 5387 //
     /* 731228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731231 */     // MIs[0] offset
     /* 731231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731234 */     // MIs[0] auxiliary
     /* 731234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731237 */     // MIs[0] Operand 7
     /* 731237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731247 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731263 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731270 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 731291 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731303 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731321 */     GIR_RootConstrainSelectedInstOperands,
     /* 731322 */     // GIR_Coverage, 5387,
     /* 731322 */     GIR_EraseRootFromParent_Done,
     /* 731323 */   // Label 9606: @731323
     /* 731323 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(731420), // Rule ID 5391 //
     /* 731328 */     // MIs[0] offset
     /* 731328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731331 */     // MIs[0] auxiliary
     /* 731331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731334 */     // MIs[0] Operand 7
     /* 731334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731344 */     // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731360 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731367 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 731388 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731400 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731402 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731418 */     GIR_RootConstrainSelectedInstOperands,
     /* 731419 */     // GIR_Coverage, 5391,
     /* 731419 */     GIR_EraseRootFromParent_Done,
     /* 731420 */   // Label 9607: @731420
     /* 731420 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(731520), // Rule ID 5395 //
     /* 731425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731428 */     // MIs[0] offset
     /* 731428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731431 */     // MIs[0] auxiliary
     /* 731431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731434 */     // MIs[0] Operand 7
     /* 731434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731444 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731460 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731467 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
     /* 731488 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731500 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731518 */     GIR_RootConstrainSelectedInstOperands,
     /* 731519 */     // GIR_Coverage, 5395,
     /* 731519 */     GIR_EraseRootFromParent_Done,
     /* 731520 */   // Label 9608: @731520
     /* 731520 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(731617), // Rule ID 5399 //
     /* 731525 */     // MIs[0] offset
     /* 731525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731528 */     // MIs[0] auxiliary
     /* 731528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731531 */     // MIs[0] Operand 7
     /* 731531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 731534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731541 */     // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 731544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 731548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 731553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 731557 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 731560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 731564 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 731567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 731572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 731582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
     /* 731585 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 731590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731597 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731605 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731615 */     GIR_RootConstrainSelectedInstOperands,
     /* 731616 */     // GIR_Coverage, 5399,
     /* 731616 */     GIR_EraseRootFromParent_Done,
     /* 731617 */   // Label 9609: @731617
     /* 731617 */   GIM_Reject,
     /* 731618 */ // Label 9593: @731618
     /* 731618 */ GIM_Reject,
     /* 731619 */ // Label 9489: @731619
     /* 731619 */ GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(732829),
     /* 731624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 731627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 731630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 731633 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 731636 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(731708), // Rule ID 5448 //
     /* 731641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731652 */     // MIs[0] offset
     /* 731652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731655 */     // MIs[0] auxiliary
     /* 731655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731658 */     // MIs[0] Operand 7
     /* 731658 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731676 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 731679 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731688 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731696 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731706 */     GIR_RootConstrainSelectedInstOperands,
     /* 731707 */     // GIR_Coverage, 5448,
     /* 731707 */     GIR_EraseRootFromParent_Done,
     /* 731708 */   // Label 9611: @731708
     /* 731708 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(731777), // Rule ID 5452 //
     /* 731713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731721 */     // MIs[0] offset
     /* 731721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731724 */     // MIs[0] auxiliary
     /* 731724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731727 */     // MIs[0] Operand 7
     /* 731727 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731745 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 731748 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731757 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731775 */     GIR_RootConstrainSelectedInstOperands,
     /* 731776 */     // GIR_Coverage, 5452,
     /* 731776 */     GIR_EraseRootFromParent_Done,
     /* 731777 */   // Label 9612: @731777
     /* 731777 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(731849), // Rule ID 5456 //
     /* 731782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731793 */     // MIs[0] offset
     /* 731793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731796 */     // MIs[0] auxiliary
     /* 731796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731799 */     // MIs[0] Operand 7
     /* 731799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731817 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 731820 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731829 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731847 */     GIR_RootConstrainSelectedInstOperands,
     /* 731848 */     // GIR_Coverage, 5456,
     /* 731848 */     GIR_EraseRootFromParent_Done,
     /* 731849 */   // Label 9613: @731849
     /* 731849 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(731918), // Rule ID 5460 //
     /* 731854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 731862 */     // MIs[0] offset
     /* 731862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731865 */     // MIs[0] auxiliary
     /* 731865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731868 */     // MIs[0] Operand 7
     /* 731868 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731886 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 731889 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731898 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731900 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731916 */     GIR_RootConstrainSelectedInstOperands,
     /* 731917 */     // GIR_Coverage, 5460,
     /* 731917 */     GIR_EraseRootFromParent_Done,
     /* 731918 */   // Label 9614: @731918
     /* 731918 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(731988), // Rule ID 5449 //
     /* 731923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 731926 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731930 */     // MIs[0] offset
     /* 731930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 731933 */     // MIs[0] auxiliary
     /* 731933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 731936 */     // MIs[0] Operand 7
     /* 731936 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 731947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 731954 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 731954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 731957 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 731959 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 731961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 731963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 731968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 731970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 731976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 731982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 731986 */     GIR_RootConstrainSelectedInstOperands,
     /* 731987 */     // GIR_Coverage, 5449,
     /* 731987 */     GIR_EraseRootFromParent_Done,
     /* 731988 */   // Label 9615: @731988
     /* 731988 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(732055), // Rule ID 5453 //
     /* 731993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 731997 */     // MIs[0] offset
     /* 731997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732000 */     // MIs[0] auxiliary
     /* 732000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732003 */     // MIs[0] Operand 7
     /* 732003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732021 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 732024 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732026 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732035 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732037 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732053 */     GIR_RootConstrainSelectedInstOperands,
     /* 732054 */     // GIR_Coverage, 5453,
     /* 732054 */     GIR_EraseRootFromParent_Done,
     /* 732055 */   // Label 9616: @732055
     /* 732055 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(732125), // Rule ID 5457 //
     /* 732060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732067 */     // MIs[0] offset
     /* 732067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732070 */     // MIs[0] auxiliary
     /* 732070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732073 */     // MIs[0] Operand 7
     /* 732073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732091 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 732094 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732096 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732105 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732123 */     GIR_RootConstrainSelectedInstOperands,
     /* 732124 */     // GIR_Coverage, 5457,
     /* 732124 */     GIR_EraseRootFromParent_Done,
     /* 732125 */   // Label 9617: @732125
     /* 732125 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(732192), // Rule ID 5461 //
     /* 732130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732134 */     // MIs[0] offset
     /* 732134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732137 */     // MIs[0] auxiliary
     /* 732137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732140 */     // MIs[0] Operand 7
     /* 732140 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732158 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 732161 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732163 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 732165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732172 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732180 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732190 */     GIR_RootConstrainSelectedInstOperands,
     /* 732191 */     // GIR_Coverage, 5461,
     /* 732191 */     GIR_EraseRootFromParent_Done,
     /* 732192 */   // Label 9618: @732192
     /* 732192 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(732254), // Rule ID 5450 //
     /* 732197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732204 */     // MIs[0] offset
     /* 732204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732207 */     // MIs[0] auxiliary
     /* 732207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732210 */     // MIs[0] Operand 7
     /* 732210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732220 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 732223 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732225 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732234 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732252 */     GIR_RootConstrainSelectedInstOperands,
     /* 732253 */     // GIR_Coverage, 5450,
     /* 732253 */     GIR_EraseRootFromParent_Done,
     /* 732254 */   // Label 9619: @732254
     /* 732254 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(732313), // Rule ID 5454 //
     /* 732259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732263 */     // MIs[0] offset
     /* 732263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732266 */     // MIs[0] auxiliary
     /* 732266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732269 */     // MIs[0] Operand 7
     /* 732269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732279 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 732282 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732284 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732293 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732295 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732301 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732311 */     GIR_RootConstrainSelectedInstOperands,
     /* 732312 */     // GIR_Coverage, 5454,
     /* 732312 */     GIR_EraseRootFromParent_Done,
     /* 732313 */   // Label 9620: @732313
     /* 732313 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(732375), // Rule ID 5458 //
     /* 732318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732325 */     // MIs[0] offset
     /* 732325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732328 */     // MIs[0] auxiliary
     /* 732328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732331 */     // MIs[0] Operand 7
     /* 732331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732341 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 732344 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732346 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732355 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732373 */     GIR_RootConstrainSelectedInstOperands,
     /* 732374 */     // GIR_Coverage, 5458,
     /* 732374 */     GIR_EraseRootFromParent_Done,
     /* 732375 */   // Label 9621: @732375
     /* 732375 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(732434), // Rule ID 5462 //
     /* 732380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732384 */     // MIs[0] offset
     /* 732384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732387 */     // MIs[0] auxiliary
     /* 732387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732390 */     // MIs[0] Operand 7
     /* 732390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732400 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 732403 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732405 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 732407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732414 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732422 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732432 */     GIR_RootConstrainSelectedInstOperands,
     /* 732433 */     // GIR_Coverage, 5462,
     /* 732433 */     GIR_EraseRootFromParent_Done,
     /* 732434 */   // Label 9622: @732434
     /* 732434 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(732534), // Rule ID 5451 //
     /* 732439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732442 */     // MIs[0] offset
     /* 732442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732445 */     // MIs[0] auxiliary
     /* 732445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732448 */     // MIs[0] Operand 7
     /* 732448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732458 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732474 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732481 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 732502 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732514 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732532 */     GIR_RootConstrainSelectedInstOperands,
     /* 732533 */     // GIR_Coverage, 5451,
     /* 732533 */     GIR_EraseRootFromParent_Done,
     /* 732534 */   // Label 9623: @732534
     /* 732534 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(732631), // Rule ID 5455 //
     /* 732539 */     // MIs[0] offset
     /* 732539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732542 */     // MIs[0] auxiliary
     /* 732542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732545 */     // MIs[0] Operand 7
     /* 732545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732555 */     // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732571 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732578 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 732599 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732611 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732613 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732619 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732629 */     GIR_RootConstrainSelectedInstOperands,
     /* 732630 */     // GIR_Coverage, 5455,
     /* 732630 */     GIR_EraseRootFromParent_Done,
     /* 732631 */   // Label 9624: @732631
     /* 732631 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(732731), // Rule ID 5459 //
     /* 732636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732639 */     // MIs[0] offset
     /* 732639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732642 */     // MIs[0] auxiliary
     /* 732642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732645 */     // MIs[0] Operand 7
     /* 732645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732655 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732671 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732678 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 732699 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732711 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732713 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732719 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732729 */     GIR_RootConstrainSelectedInstOperands,
     /* 732730 */     // GIR_Coverage, 5459,
     /* 732730 */     GIR_EraseRootFromParent_Done,
     /* 732731 */   // Label 9625: @732731
     /* 732731 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(732828), // Rule ID 5463 //
     /* 732736 */     // MIs[0] offset
     /* 732736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732739 */     // MIs[0] auxiliary
     /* 732739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732742 */     // MIs[0] Operand 7
     /* 732742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 732745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732752 */     // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 732755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 732759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 732764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 732768 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 732771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 732775 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 732778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 732783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 732793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 732796 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 732801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732808 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732810 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732826 */     GIR_RootConstrainSelectedInstOperands,
     /* 732827 */     // GIR_Coverage, 5463,
     /* 732827 */     GIR_EraseRootFromParent_Done,
     /* 732828 */   // Label 9626: @732828
     /* 732828 */   GIM_Reject,
     /* 732829 */ // Label 9610: @732829
     /* 732829 */ GIM_Reject,
     /* 732830 */ // Label 9490: @732830
     /* 732830 */ GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(734040),
     /* 732835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 732838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 732841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 732844 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 732847 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(732919), // Rule ID 5536 //
     /* 732852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732863 */     // MIs[0] offset
     /* 732863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732866 */     // MIs[0] auxiliary
     /* 732866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732869 */     // MIs[0] Operand 7
     /* 732869 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732887 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9741:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 732890 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732899 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732901 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732907 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732917 */     GIR_RootConstrainSelectedInstOperands,
     /* 732918 */     // GIR_Coverage, 5536,
     /* 732918 */     GIR_EraseRootFromParent_Done,
     /* 732919 */   // Label 9628: @732919
     /* 732919 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(732988), // Rule ID 5540 //
     /* 732924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 732928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 732932 */     // MIs[0] offset
     /* 732932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 732935 */     // MIs[0] auxiliary
     /* 732935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 732938 */     // MIs[0] Operand 7
     /* 732938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 732949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 732956 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 732956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 732959 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 732961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 732963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 732968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 732970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 732976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 732982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 732986 */     GIR_RootConstrainSelectedInstOperands,
     /* 732987 */     // GIR_Coverage, 5540,
     /* 732987 */     GIR_EraseRootFromParent_Done,
     /* 732988 */   // Label 9629: @732988
     /* 732988 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(733060), // Rule ID 5544 //
     /* 732993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 732996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733004 */     // MIs[0] offset
     /* 733004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733007 */     // MIs[0] auxiliary
     /* 733007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733010 */     // MIs[0] Operand 7
     /* 733010 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733028 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9741:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 733031 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733040 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733058 */     GIR_RootConstrainSelectedInstOperands,
     /* 733059 */     // GIR_Coverage, 5544,
     /* 733059 */     GIR_EraseRootFromParent_Done,
     /* 733060 */   // Label 9630: @733060
     /* 733060 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(733129), // Rule ID 5548 //
     /* 733065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733073 */     // MIs[0] offset
     /* 733073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733076 */     // MIs[0] auxiliary
     /* 733076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733079 */     // MIs[0] Operand 7
     /* 733079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733097 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 733100 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733109 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733111 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733117 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733127 */     GIR_RootConstrainSelectedInstOperands,
     /* 733128 */     // GIR_Coverage, 5548,
     /* 733128 */     GIR_EraseRootFromParent_Done,
     /* 733129 */   // Label 9631: @733129
     /* 733129 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(733199), // Rule ID 5537 //
     /* 733134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733141 */     // MIs[0] offset
     /* 733141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733144 */     // MIs[0] auxiliary
     /* 733144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733147 */     // MIs[0] Operand 7
     /* 733147 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733165 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9741:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 733168 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733170 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733179 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733181 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733197 */     GIR_RootConstrainSelectedInstOperands,
     /* 733198 */     // GIR_Coverage, 5537,
     /* 733198 */     GIR_EraseRootFromParent_Done,
     /* 733199 */   // Label 9632: @733199
     /* 733199 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(733266), // Rule ID 5541 //
     /* 733204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733208 */     // MIs[0] offset
     /* 733208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733211 */     // MIs[0] auxiliary
     /* 733211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733214 */     // MIs[0] Operand 7
     /* 733214 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733232 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 733235 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733237 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733246 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733248 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733254 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733264 */     GIR_RootConstrainSelectedInstOperands,
     /* 733265 */     // GIR_Coverage, 5541,
     /* 733265 */     GIR_EraseRootFromParent_Done,
     /* 733266 */   // Label 9633: @733266
     /* 733266 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(733336), // Rule ID 5545 //
     /* 733271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733278 */     // MIs[0] offset
     /* 733278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733281 */     // MIs[0] auxiliary
     /* 733281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733284 */     // MIs[0] Operand 7
     /* 733284 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733302 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9741:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 733305 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733307 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733316 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733324 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733334 */     GIR_RootConstrainSelectedInstOperands,
     /* 733335 */     // GIR_Coverage, 5545,
     /* 733335 */     GIR_EraseRootFromParent_Done,
     /* 733336 */   // Label 9634: @733336
     /* 733336 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(733403), // Rule ID 5549 //
     /* 733341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 733345 */     // MIs[0] offset
     /* 733345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733348 */     // MIs[0] auxiliary
     /* 733348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733351 */     // MIs[0] Operand 7
     /* 733351 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 733362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733369 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 733372 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733374 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 733376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733383 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733385 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733401 */     GIR_RootConstrainSelectedInstOperands,
     /* 733402 */     // GIR_Coverage, 5549,
     /* 733402 */     GIR_EraseRootFromParent_Done,
     /* 733403 */   // Label 9635: @733403
     /* 733403 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(733465), // Rule ID 5538 //
     /* 733408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733415 */     // MIs[0] offset
     /* 733415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733418 */     // MIs[0] auxiliary
     /* 733418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733421 */     // MIs[0] Operand 7
     /* 733421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733431 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9741:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 733434 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733436 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733445 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733447 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733453 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733463 */     GIR_RootConstrainSelectedInstOperands,
     /* 733464 */     // GIR_Coverage, 5538,
     /* 733464 */     GIR_EraseRootFromParent_Done,
     /* 733465 */   // Label 9636: @733465
     /* 733465 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(733524), // Rule ID 5542 //
     /* 733470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733474 */     // MIs[0] offset
     /* 733474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733477 */     // MIs[0] auxiliary
     /* 733477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733480 */     // MIs[0] Operand 7
     /* 733480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733490 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 733493 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733495 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733504 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733522 */     GIR_RootConstrainSelectedInstOperands,
     /* 733523 */     // GIR_Coverage, 5542,
     /* 733523 */     GIR_EraseRootFromParent_Done,
     /* 733524 */   // Label 9637: @733524
     /* 733524 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(733586), // Rule ID 5546 //
     /* 733529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733536 */     // MIs[0] offset
     /* 733536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733539 */     // MIs[0] auxiliary
     /* 733539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733542 */     // MIs[0] Operand 7
     /* 733542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733552 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9741:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 733555 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733557 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733566 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733574 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733584 */     GIR_RootConstrainSelectedInstOperands,
     /* 733585 */     // GIR_Coverage, 5546,
     /* 733585 */     GIR_EraseRootFromParent_Done,
     /* 733586 */   // Label 9638: @733586
     /* 733586 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(733645), // Rule ID 5550 //
     /* 733591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 733595 */     // MIs[0] offset
     /* 733595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733598 */     // MIs[0] auxiliary
     /* 733598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733601 */     // MIs[0] Operand 7
     /* 733601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733611 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 733614 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733616 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 733618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733625 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733627 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733643 */     GIR_RootConstrainSelectedInstOperands,
     /* 733644 */     // GIR_Coverage, 5550,
     /* 733644 */     GIR_EraseRootFromParent_Done,
     /* 733645 */   // Label 9639: @733645
     /* 733645 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(733745), // Rule ID 5539 //
     /* 733650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733653 */     // MIs[0] offset
     /* 733653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733656 */     // MIs[0] auxiliary
     /* 733656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733659 */     // MIs[0] Operand 7
     /* 733659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733669 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9741:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733685 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733692 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733705 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 733713 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733725 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733743 */     GIR_RootConstrainSelectedInstOperands,
     /* 733744 */     // GIR_Coverage, 5539,
     /* 733744 */     GIR_EraseRootFromParent_Done,
     /* 733745 */   // Label 9640: @733745
     /* 733745 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(733842), // Rule ID 5543 //
     /* 733750 */     // MIs[0] offset
     /* 733750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733753 */     // MIs[0] auxiliary
     /* 733753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733756 */     // MIs[0] Operand 7
     /* 733756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733766 */     // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733782 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733785 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733789 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 733810 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733822 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733824 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733830 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733840 */     GIR_RootConstrainSelectedInstOperands,
     /* 733841 */     // GIR_Coverage, 5543,
     /* 733841 */     GIR_EraseRootFromParent_Done,
     /* 733842 */   // Label 9641: @733842
     /* 733842 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(733942), // Rule ID 5547 //
     /* 733847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 733850 */     // MIs[0] offset
     /* 733850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733853 */     // MIs[0] auxiliary
     /* 733853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733856 */     // MIs[0] Operand 7
     /* 733856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733866 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9741:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733882 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733889 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 733910 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 733912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 733915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 733917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 733922 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 733924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 733930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 733936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 733940 */     GIR_RootConstrainSelectedInstOperands,
     /* 733941 */     // GIR_Coverage, 5547,
     /* 733941 */     GIR_EraseRootFromParent_Done,
     /* 733942 */   // Label 9642: @733942
     /* 733942 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(734039), // Rule ID 5551 //
     /* 733947 */     // MIs[0] offset
     /* 733947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 733950 */     // MIs[0] auxiliary
     /* 733950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 733953 */     // MIs[0] Operand 7
     /* 733953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 733956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 733963 */     // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 733963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 733966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 733970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 733975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 733979 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 733982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 733986 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 733989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 733994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 733999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 734007 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734019 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734027 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734037 */     GIR_RootConstrainSelectedInstOperands,
     /* 734038 */     // GIR_Coverage, 5551,
     /* 734038 */     GIR_EraseRootFromParent_Done,
     /* 734039 */   // Label 9643: @734039
     /* 734039 */   GIM_Reject,
     /* 734040 */ // Label 9627: @734040
     /* 734040 */ GIM_Reject,
     /* 734041 */ // Label 9491: @734041
     /* 734041 */ GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(735251),
     /* 734046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 734049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 734052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 734055 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 734058 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(734130), // Rule ID 5504 //
     /* 734063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734074 */     // MIs[0] offset
     /* 734074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734077 */     // MIs[0] auxiliary
     /* 734077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734080 */     // MIs[0] Operand 7
     /* 734080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734098 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
     /* 734101 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734110 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734112 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734118 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734128 */     GIR_RootConstrainSelectedInstOperands,
     /* 734129 */     // GIR_Coverage, 5504,
     /* 734129 */     GIR_EraseRootFromParent_Done,
     /* 734130 */   // Label 9645: @734130
     /* 734130 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(734199), // Rule ID 5508 //
     /* 734135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734143 */     // MIs[0] offset
     /* 734143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734146 */     // MIs[0] auxiliary
     /* 734146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734149 */     // MIs[0] Operand 7
     /* 734149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734167 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
     /* 734170 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734179 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734181 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734197 */     GIR_RootConstrainSelectedInstOperands,
     /* 734198 */     // GIR_Coverage, 5508,
     /* 734198 */     GIR_EraseRootFromParent_Done,
     /* 734199 */   // Label 9646: @734199
     /* 734199 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(734271), // Rule ID 5512 //
     /* 734204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734215 */     // MIs[0] offset
     /* 734215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734218 */     // MIs[0] auxiliary
     /* 734218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734221 */     // MIs[0] Operand 7
     /* 734221 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734239 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9742:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
     /* 734242 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734251 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734269 */     GIR_RootConstrainSelectedInstOperands,
     /* 734270 */     // GIR_Coverage, 5512,
     /* 734270 */     GIR_EraseRootFromParent_Done,
     /* 734271 */   // Label 9647: @734271
     /* 734271 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(734340), // Rule ID 5516 //
     /* 734276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734284 */     // MIs[0] offset
     /* 734284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734287 */     // MIs[0] auxiliary
     /* 734287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734290 */     // MIs[0] Operand 7
     /* 734290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734308 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9742:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
     /* 734311 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734320 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734322 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734328 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734338 */     GIR_RootConstrainSelectedInstOperands,
     /* 734339 */     // GIR_Coverage, 5516,
     /* 734339 */     GIR_EraseRootFromParent_Done,
     /* 734340 */   // Label 9648: @734340
     /* 734340 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(734410), // Rule ID 5505 //
     /* 734345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734352 */     // MIs[0] offset
     /* 734352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734355 */     // MIs[0] auxiliary
     /* 734355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734358 */     // MIs[0] Operand 7
     /* 734358 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734376 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
     /* 734379 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734381 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734390 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734408 */     GIR_RootConstrainSelectedInstOperands,
     /* 734409 */     // GIR_Coverage, 5505,
     /* 734409 */     GIR_EraseRootFromParent_Done,
     /* 734410 */   // Label 9649: @734410
     /* 734410 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(734477), // Rule ID 5509 //
     /* 734415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734419 */     // MIs[0] offset
     /* 734419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734422 */     // MIs[0] auxiliary
     /* 734422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734425 */     // MIs[0] Operand 7
     /* 734425 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734443 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
     /* 734446 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734448 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734457 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734459 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734465 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734475 */     GIR_RootConstrainSelectedInstOperands,
     /* 734476 */     // GIR_Coverage, 5509,
     /* 734476 */     GIR_EraseRootFromParent_Done,
     /* 734477 */   // Label 9650: @734477
     /* 734477 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(734547), // Rule ID 5513 //
     /* 734482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734489 */     // MIs[0] offset
     /* 734489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734492 */     // MIs[0] auxiliary
     /* 734492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734495 */     // MIs[0] Operand 7
     /* 734495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734513 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
     /* 734516 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734518 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734527 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734545 */     GIR_RootConstrainSelectedInstOperands,
     /* 734546 */     // GIR_Coverage, 5513,
     /* 734546 */     GIR_EraseRootFromParent_Done,
     /* 734547 */   // Label 9651: @734547
     /* 734547 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(734614), // Rule ID 5517 //
     /* 734552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 734556 */     // MIs[0] offset
     /* 734556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734559 */     // MIs[0] auxiliary
     /* 734559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734562 */     // MIs[0] Operand 7
     /* 734562 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 734573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734580 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
     /* 734583 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734585 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 734587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734594 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734596 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734612 */     GIR_RootConstrainSelectedInstOperands,
     /* 734613 */     // GIR_Coverage, 5517,
     /* 734613 */     GIR_EraseRootFromParent_Done,
     /* 734614 */   // Label 9652: @734614
     /* 734614 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(734676), // Rule ID 5506 //
     /* 734619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734626 */     // MIs[0] offset
     /* 734626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734629 */     // MIs[0] auxiliary
     /* 734629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734632 */     // MIs[0] Operand 7
     /* 734632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734642 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
     /* 734645 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734647 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734656 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734674 */     GIR_RootConstrainSelectedInstOperands,
     /* 734675 */     // GIR_Coverage, 5506,
     /* 734675 */     GIR_EraseRootFromParent_Done,
     /* 734676 */   // Label 9653: @734676
     /* 734676 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(734735), // Rule ID 5510 //
     /* 734681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734685 */     // MIs[0] offset
     /* 734685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734688 */     // MIs[0] auxiliary
     /* 734688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734691 */     // MIs[0] Operand 7
     /* 734691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734701 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
     /* 734704 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734706 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734715 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734723 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734733 */     GIR_RootConstrainSelectedInstOperands,
     /* 734734 */     // GIR_Coverage, 5510,
     /* 734734 */     GIR_EraseRootFromParent_Done,
     /* 734735 */   // Label 9654: @734735
     /* 734735 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(734797), // Rule ID 5514 //
     /* 734740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734747 */     // MIs[0] offset
     /* 734747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734750 */     // MIs[0] auxiliary
     /* 734750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734753 */     // MIs[0] Operand 7
     /* 734753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734763 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
     /* 734766 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734768 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734777 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734795 */     GIR_RootConstrainSelectedInstOperands,
     /* 734796 */     // GIR_Coverage, 5514,
     /* 734796 */     GIR_EraseRootFromParent_Done,
     /* 734797 */   // Label 9655: @734797
     /* 734797 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(734856), // Rule ID 5518 //
     /* 734802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 734806 */     // MIs[0] offset
     /* 734806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734809 */     // MIs[0] auxiliary
     /* 734809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734812 */     // MIs[0] Operand 7
     /* 734812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734822 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
     /* 734825 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734827 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 734829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734836 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734838 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734844 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734854 */     GIR_RootConstrainSelectedInstOperands,
     /* 734855 */     // GIR_Coverage, 5518,
     /* 734855 */     GIR_EraseRootFromParent_Done,
     /* 734856 */   // Label 9656: @734856
     /* 734856 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(734956), // Rule ID 5507 //
     /* 734861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 734864 */     // MIs[0] offset
     /* 734864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734867 */     // MIs[0] auxiliary
     /* 734867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734870 */     // MIs[0] Operand 7
     /* 734870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734880 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734896 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 734903 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 734906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 734911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 734921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
     /* 734924 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 734926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 734929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 734931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 734936 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 734938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 734944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 734950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 734954 */     GIR_RootConstrainSelectedInstOperands,
     /* 734955 */     // GIR_Coverage, 5507,
     /* 734955 */     GIR_EraseRootFromParent_Done,
     /* 734956 */   // Label 9657: @734956
     /* 734956 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(735053), // Rule ID 5511 //
     /* 734961 */     // MIs[0] offset
     /* 734961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 734964 */     // MIs[0] auxiliary
     /* 734964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 734967 */     // MIs[0] Operand 7
     /* 734967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 734970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 734977 */     // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 734977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 734980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 734984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 734989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 734993 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 734996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 735000 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 735003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 735008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
     /* 735021 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 735026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735033 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735035 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735051 */     GIR_RootConstrainSelectedInstOperands,
     /* 735052 */     // GIR_Coverage, 5511,
     /* 735052 */     GIR_EraseRootFromParent_Done,
     /* 735053 */   // Label 9658: @735053
     /* 735053 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(735153), // Rule ID 5515 //
     /* 735058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735061 */     // MIs[0] offset
     /* 735061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735064 */     // MIs[0] auxiliary
     /* 735064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735067 */     // MIs[0] Operand 7
     /* 735067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735077 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 735080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 735084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 735089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 735093 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 735096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 735100 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 735103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 735108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
     /* 735121 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 735126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735133 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735151 */     GIR_RootConstrainSelectedInstOperands,
     /* 735152 */     // GIR_Coverage, 5515,
     /* 735152 */     GIR_EraseRootFromParent_Done,
     /* 735153 */   // Label 9659: @735153
     /* 735153 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(735250), // Rule ID 5519 //
     /* 735158 */     // MIs[0] offset
     /* 735158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735161 */     // MIs[0] auxiliary
     /* 735161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735164 */     // MIs[0] Operand 7
     /* 735164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735174 */     // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 735177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 735181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 735186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 735190 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 735193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 735197 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 735200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 735205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 735215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
     /* 735218 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 735223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735230 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735248 */     GIR_RootConstrainSelectedInstOperands,
     /* 735249 */     // GIR_Coverage, 5519,
     /* 735249 */     GIR_EraseRootFromParent_Done,
     /* 735250 */   // Label 9660: @735250
     /* 735250 */   GIM_Reject,
     /* 735251 */ // Label 9644: @735251
     /* 735251 */ GIM_Reject,
     /* 735252 */ // Label 9492: @735252
     /* 735252 */ GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(736462),
     /* 735257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 735260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 735263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 735266 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 735269 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(735341), // Rule ID 5464 //
     /* 735274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735285 */     // MIs[0] offset
     /* 735285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735288 */     // MIs[0] auxiliary
     /* 735288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735291 */     // MIs[0] Operand 7
     /* 735291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735309 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 735312 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735321 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735323 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735329 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735339 */     GIR_RootConstrainSelectedInstOperands,
     /* 735340 */     // GIR_Coverage, 5464,
     /* 735340 */     GIR_EraseRootFromParent_Done,
     /* 735341 */   // Label 9662: @735341
     /* 735341 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(735410), // Rule ID 5468 //
     /* 735346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735354 */     // MIs[0] offset
     /* 735354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735357 */     // MIs[0] auxiliary
     /* 735357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735360 */     // MIs[0] Operand 7
     /* 735360 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735378 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 735381 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735390 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735408 */     GIR_RootConstrainSelectedInstOperands,
     /* 735409 */     // GIR_Coverage, 5468,
     /* 735409 */     GIR_EraseRootFromParent_Done,
     /* 735410 */   // Label 9663: @735410
     /* 735410 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(735482), // Rule ID 5472 //
     /* 735415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735426 */     // MIs[0] offset
     /* 735426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735429 */     // MIs[0] auxiliary
     /* 735429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735432 */     // MIs[0] Operand 7
     /* 735432 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735450 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
     /* 735453 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735462 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735470 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735480 */     GIR_RootConstrainSelectedInstOperands,
     /* 735481 */     // GIR_Coverage, 5472,
     /* 735481 */     GIR_EraseRootFromParent_Done,
     /* 735482 */   // Label 9664: @735482
     /* 735482 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(735551), // Rule ID 5476 //
     /* 735487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735495 */     // MIs[0] offset
     /* 735495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735498 */     // MIs[0] auxiliary
     /* 735498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735501 */     // MIs[0] Operand 7
     /* 735501 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735519 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
     /* 735522 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735531 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735549 */     GIR_RootConstrainSelectedInstOperands,
     /* 735550 */     // GIR_Coverage, 5476,
     /* 735550 */     GIR_EraseRootFromParent_Done,
     /* 735551 */   // Label 9665: @735551
     /* 735551 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(735621), // Rule ID 5465 //
     /* 735556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735563 */     // MIs[0] offset
     /* 735563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735566 */     // MIs[0] auxiliary
     /* 735566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735569 */     // MIs[0] Operand 7
     /* 735569 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735587 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 735590 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735592 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735601 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735619 */     GIR_RootConstrainSelectedInstOperands,
     /* 735620 */     // GIR_Coverage, 5465,
     /* 735620 */     GIR_EraseRootFromParent_Done,
     /* 735621 */   // Label 9666: @735621
     /* 735621 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(735688), // Rule ID 5469 //
     /* 735626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735630 */     // MIs[0] offset
     /* 735630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735633 */     // MIs[0] auxiliary
     /* 735633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735636 */     // MIs[0] Operand 7
     /* 735636 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735654 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 735657 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735659 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735668 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735670 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735676 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735686 */     GIR_RootConstrainSelectedInstOperands,
     /* 735687 */     // GIR_Coverage, 5469,
     /* 735687 */     GIR_EraseRootFromParent_Done,
     /* 735688 */   // Label 9667: @735688
     /* 735688 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(735758), // Rule ID 5473 //
     /* 735693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735700 */     // MIs[0] offset
     /* 735700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735703 */     // MIs[0] auxiliary
     /* 735703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735706 */     // MIs[0] Operand 7
     /* 735706 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735724 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
     /* 735727 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735729 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735738 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735756 */     GIR_RootConstrainSelectedInstOperands,
     /* 735757 */     // GIR_Coverage, 5473,
     /* 735757 */     GIR_EraseRootFromParent_Done,
     /* 735758 */   // Label 9668: @735758
     /* 735758 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(735825), // Rule ID 5477 //
     /* 735763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 735767 */     // MIs[0] offset
     /* 735767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735770 */     // MIs[0] auxiliary
     /* 735770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735773 */     // MIs[0] Operand 7
     /* 735773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 735784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735791 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
     /* 735794 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735796 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 735798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735805 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735813 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735823 */     GIR_RootConstrainSelectedInstOperands,
     /* 735824 */     // GIR_Coverage, 5477,
     /* 735824 */     GIR_EraseRootFromParent_Done,
     /* 735825 */   // Label 9669: @735825
     /* 735825 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(735887), // Rule ID 5466 //
     /* 735830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735837 */     // MIs[0] offset
     /* 735837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735840 */     // MIs[0] auxiliary
     /* 735840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735843 */     // MIs[0] Operand 7
     /* 735843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735853 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 735856 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735858 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735867 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735869 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735875 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735885 */     GIR_RootConstrainSelectedInstOperands,
     /* 735886 */     // GIR_Coverage, 5466,
     /* 735886 */     GIR_EraseRootFromParent_Done,
     /* 735887 */   // Label 9670: @735887
     /* 735887 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(735946), // Rule ID 5470 //
     /* 735892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735896 */     // MIs[0] offset
     /* 735896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735899 */     // MIs[0] auxiliary
     /* 735899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735902 */     // MIs[0] Operand 7
     /* 735902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735912 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 735915 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735917 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735926 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 735940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 735944 */     GIR_RootConstrainSelectedInstOperands,
     /* 735945 */     // GIR_Coverage, 5470,
     /* 735945 */     GIR_EraseRootFromParent_Done,
     /* 735946 */   // Label 9671: @735946
     /* 735946 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(736008), // Rule ID 5474 //
     /* 735951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 735954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 735958 */     // MIs[0] offset
     /* 735958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 735961 */     // MIs[0] auxiliary
     /* 735961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 735964 */     // MIs[0] Operand 7
     /* 735964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 735967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 735974 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 735974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
     /* 735977 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 735979 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 735981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 735983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 735988 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 735990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 735996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736006 */     GIR_RootConstrainSelectedInstOperands,
     /* 736007 */     // GIR_Coverage, 5474,
     /* 736007 */     GIR_EraseRootFromParent_Done,
     /* 736008 */   // Label 9672: @736008
     /* 736008 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(736067), // Rule ID 5478 //
     /* 736013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736017 */     // MIs[0] offset
     /* 736017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736020 */     // MIs[0] auxiliary
     /* 736020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736023 */     // MIs[0] Operand 7
     /* 736023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736033 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
     /* 736036 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736038 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 736040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736047 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736065 */     GIR_RootConstrainSelectedInstOperands,
     /* 736066 */     // GIR_Coverage, 5478,
     /* 736066 */     GIR_EraseRootFromParent_Done,
     /* 736067 */   // Label 9673: @736067
     /* 736067 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(736167), // Rule ID 5467 //
     /* 736072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736075 */     // MIs[0] offset
     /* 736075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736078 */     // MIs[0] auxiliary
     /* 736078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736081 */     // MIs[0] Operand 7
     /* 736081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736091 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736107 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736114 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 736135 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736147 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736155 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736165 */     GIR_RootConstrainSelectedInstOperands,
     /* 736166 */     // GIR_Coverage, 5467,
     /* 736166 */     GIR_EraseRootFromParent_Done,
     /* 736167 */   // Label 9674: @736167
     /* 736167 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(736264), // Rule ID 5471 //
     /* 736172 */     // MIs[0] offset
     /* 736172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736175 */     // MIs[0] auxiliary
     /* 736175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736178 */     // MIs[0] Operand 7
     /* 736178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736188 */     // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736204 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736211 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 736232 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736244 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736246 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736262 */     GIR_RootConstrainSelectedInstOperands,
     /* 736263 */     // GIR_Coverage, 5471,
     /* 736263 */     GIR_EraseRootFromParent_Done,
     /* 736264 */   // Label 9675: @736264
     /* 736264 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(736364), // Rule ID 5475 //
     /* 736269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736272 */     // MIs[0] offset
     /* 736272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736275 */     // MIs[0] auxiliary
     /* 736275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736278 */     // MIs[0] Operand 7
     /* 736278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736288 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736311 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
     /* 736332 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736344 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736362 */     GIR_RootConstrainSelectedInstOperands,
     /* 736363 */     // GIR_Coverage, 5475,
     /* 736363 */     GIR_EraseRootFromParent_Done,
     /* 736364 */   // Label 9676: @736364
     /* 736364 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(736461), // Rule ID 5479 //
     /* 736369 */     // MIs[0] offset
     /* 736369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736372 */     // MIs[0] auxiliary
     /* 736372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736375 */     // MIs[0] Operand 7
     /* 736375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 736378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736385 */     // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 736388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 736392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 736397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 736401 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 736404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 736408 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 736411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 736416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 736426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
     /* 736429 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 736434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736441 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736459 */     GIR_RootConstrainSelectedInstOperands,
     /* 736460 */     // GIR_Coverage, 5479,
     /* 736460 */     GIR_EraseRootFromParent_Done,
     /* 736461 */   // Label 9677: @736461
     /* 736461 */   GIM_Reject,
     /* 736462 */ // Label 9661: @736462
     /* 736462 */ GIM_Reject,
     /* 736463 */ // Label 9493: @736463
     /* 736463 */ GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(737673),
     /* 736468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 736471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 736474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 736477 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 736480 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(736552), // Rule ID 5520 //
     /* 736485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736496 */     // MIs[0] offset
     /* 736496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736499 */     // MIs[0] auxiliary
     /* 736499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736502 */     // MIs[0] Operand 7
     /* 736502 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736520 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 736523 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736532 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736534 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736540 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736550 */     GIR_RootConstrainSelectedInstOperands,
     /* 736551 */     // GIR_Coverage, 5520,
     /* 736551 */     GIR_EraseRootFromParent_Done,
     /* 736552 */   // Label 9679: @736552
     /* 736552 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(736621), // Rule ID 5524 //
     /* 736557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736565 */     // MIs[0] offset
     /* 736565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736568 */     // MIs[0] auxiliary
     /* 736568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736571 */     // MIs[0] Operand 7
     /* 736571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736589 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 736592 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736601 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736603 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736619 */     GIR_RootConstrainSelectedInstOperands,
     /* 736620 */     // GIR_Coverage, 5524,
     /* 736620 */     GIR_EraseRootFromParent_Done,
     /* 736621 */   // Label 9680: @736621
     /* 736621 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(736693), // Rule ID 5528 //
     /* 736626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736637 */     // MIs[0] offset
     /* 736637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736640 */     // MIs[0] auxiliary
     /* 736640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736643 */     // MIs[0] Operand 7
     /* 736643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736661 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9741:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 736664 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736673 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736691 */     GIR_RootConstrainSelectedInstOperands,
     /* 736692 */     // GIR_Coverage, 5528,
     /* 736692 */     GIR_EraseRootFromParent_Done,
     /* 736693 */   // Label 9681: @736693
     /* 736693 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(736762), // Rule ID 5532 //
     /* 736698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 736706 */     // MIs[0] offset
     /* 736706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736709 */     // MIs[0] auxiliary
     /* 736709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736712 */     // MIs[0] Operand 7
     /* 736712 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736730 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 736733 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736742 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736760 */     GIR_RootConstrainSelectedInstOperands,
     /* 736761 */     // GIR_Coverage, 5532,
     /* 736761 */     GIR_EraseRootFromParent_Done,
     /* 736762 */   // Label 9682: @736762
     /* 736762 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(736832), // Rule ID 5521 //
     /* 736767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736774 */     // MIs[0] offset
     /* 736774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736777 */     // MIs[0] auxiliary
     /* 736777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736780 */     // MIs[0] Operand 7
     /* 736780 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736798 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 736801 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736803 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 736805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736812 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736830 */     GIR_RootConstrainSelectedInstOperands,
     /* 736831 */     // GIR_Coverage, 5521,
     /* 736831 */     GIR_EraseRootFromParent_Done,
     /* 736832 */   // Label 9683: @736832
     /* 736832 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(736899), // Rule ID 5525 //
     /* 736837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736841 */     // MIs[0] offset
     /* 736841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736844 */     // MIs[0] auxiliary
     /* 736844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736847 */     // MIs[0] Operand 7
     /* 736847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736865 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 736868 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736870 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 736872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736879 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736881 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736887 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736897 */     GIR_RootConstrainSelectedInstOperands,
     /* 736898 */     // GIR_Coverage, 5525,
     /* 736898 */     GIR_EraseRootFromParent_Done,
     /* 736899 */   // Label 9684: @736899
     /* 736899 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(736969), // Rule ID 5529 //
     /* 736904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 736907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736911 */     // MIs[0] offset
     /* 736911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736914 */     // MIs[0] auxiliary
     /* 736914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736917 */     // MIs[0] Operand 7
     /* 736917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 736935 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 736935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 736938 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 736940 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 736942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 736944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 736949 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 736951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 736957 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 736963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 736967 */     GIR_RootConstrainSelectedInstOperands,
     /* 736968 */     // GIR_Coverage, 5529,
     /* 736968 */     GIR_EraseRootFromParent_Done,
     /* 736969 */   // Label 9685: @736969
     /* 736969 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(737036), // Rule ID 5533 //
     /* 736974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 736978 */     // MIs[0] offset
     /* 736978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 736981 */     // MIs[0] auxiliary
     /* 736981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 736984 */     // MIs[0] Operand 7
     /* 736984 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 736995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737002 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 737005 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737007 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 737009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737016 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737034 */     GIR_RootConstrainSelectedInstOperands,
     /* 737035 */     // GIR_Coverage, 5533,
     /* 737035 */     GIR_EraseRootFromParent_Done,
     /* 737036 */   // Label 9686: @737036
     /* 737036 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(737098), // Rule ID 5522 //
     /* 737041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737048 */     // MIs[0] offset
     /* 737048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737051 */     // MIs[0] auxiliary
     /* 737051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737054 */     // MIs[0] Operand 7
     /* 737054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737064 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 737067 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737069 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737078 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737096 */     GIR_RootConstrainSelectedInstOperands,
     /* 737097 */     // GIR_Coverage, 5522,
     /* 737097 */     GIR_EraseRootFromParent_Done,
     /* 737098 */   // Label 9687: @737098
     /* 737098 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(737157), // Rule ID 5526 //
     /* 737103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737107 */     // MIs[0] offset
     /* 737107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737110 */     // MIs[0] auxiliary
     /* 737110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737113 */     // MIs[0] Operand 7
     /* 737113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737123 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 737126 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737128 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737137 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737155 */     GIR_RootConstrainSelectedInstOperands,
     /* 737156 */     // GIR_Coverage, 5526,
     /* 737156 */     GIR_EraseRootFromParent_Done,
     /* 737157 */   // Label 9688: @737157
     /* 737157 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(737219), // Rule ID 5530 //
     /* 737162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737169 */     // MIs[0] offset
     /* 737169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737172 */     // MIs[0] auxiliary
     /* 737172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737175 */     // MIs[0] Operand 7
     /* 737175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737185 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 737188 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737190 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737199 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737201 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737207 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737217 */     GIR_RootConstrainSelectedInstOperands,
     /* 737218 */     // GIR_Coverage, 5530,
     /* 737218 */     GIR_EraseRootFromParent_Done,
     /* 737219 */   // Label 9689: @737219
     /* 737219 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(737278), // Rule ID 5534 //
     /* 737224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737228 */     // MIs[0] offset
     /* 737228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737231 */     // MIs[0] auxiliary
     /* 737231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737234 */     // MIs[0] Operand 7
     /* 737234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737244 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 737247 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737249 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 737251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737258 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737260 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737266 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737276 */     GIR_RootConstrainSelectedInstOperands,
     /* 737277 */     // GIR_Coverage, 5534,
     /* 737277 */     GIR_EraseRootFromParent_Done,
     /* 737278 */   // Label 9690: @737278
     /* 737278 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(737378), // Rule ID 5523 //
     /* 737283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737286 */     // MIs[0] offset
     /* 737286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737289 */     // MIs[0] auxiliary
     /* 737289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737292 */     // MIs[0] Operand 7
     /* 737292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737302 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737318 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737325 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 737346 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737358 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737360 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737366 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737376 */     GIR_RootConstrainSelectedInstOperands,
     /* 737377 */     // GIR_Coverage, 5523,
     /* 737377 */     GIR_EraseRootFromParent_Done,
     /* 737378 */   // Label 9691: @737378
     /* 737378 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(737475), // Rule ID 5527 //
     /* 737383 */     // MIs[0] offset
     /* 737383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737386 */     // MIs[0] auxiliary
     /* 737386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737389 */     // MIs[0] Operand 7
     /* 737389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737399 */     // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737415 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737422 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 737443 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737455 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737457 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737463 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737473 */     GIR_RootConstrainSelectedInstOperands,
     /* 737474 */     // GIR_Coverage, 5527,
     /* 737474 */     GIR_EraseRootFromParent_Done,
     /* 737475 */   // Label 9692: @737475
     /* 737475 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(737575), // Rule ID 5531 //
     /* 737480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737483 */     // MIs[0] offset
     /* 737483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737486 */     // MIs[0] auxiliary
     /* 737486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737489 */     // MIs[0] Operand 7
     /* 737489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737499 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737515 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737522 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 737543 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737555 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737557 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737563 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737573 */     GIR_RootConstrainSelectedInstOperands,
     /* 737574 */     // GIR_Coverage, 5531,
     /* 737574 */     GIR_EraseRootFromParent_Done,
     /* 737575 */   // Label 9693: @737575
     /* 737575 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(737672), // Rule ID 5535 //
     /* 737580 */     // MIs[0] offset
     /* 737580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737583 */     // MIs[0] auxiliary
     /* 737583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737586 */     // MIs[0] Operand 7
     /* 737586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 737589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737596 */     // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 737599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 737603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 737608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 737612 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 737615 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 737619 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 737622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 737627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 737637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 737640 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 737645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737652 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737660 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737670 */     GIR_RootConstrainSelectedInstOperands,
     /* 737671 */     // GIR_Coverage, 5535,
     /* 737671 */     GIR_EraseRootFromParent_Done,
     /* 737672 */   // Label 9694: @737672
     /* 737672 */   GIM_Reject,
     /* 737673 */ // Label 9678: @737673
     /* 737673 */ GIM_Reject,
     /* 737674 */ // Label 9494: @737674
     /* 737674 */ GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(738884),
     /* 737679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 737682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 737685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 737688 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 737691 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(737763), // Rule ID 5552 //
     /* 737696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737707 */     // MIs[0] offset
     /* 737707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737710 */     // MIs[0] auxiliary
     /* 737710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737713 */     // MIs[0] Operand 7
     /* 737713 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737731 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9741:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 737734 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737743 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737751 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737761 */     GIR_RootConstrainSelectedInstOperands,
     /* 737762 */     // GIR_Coverage, 5552,
     /* 737762 */     GIR_EraseRootFromParent_Done,
     /* 737763 */   // Label 9696: @737763
     /* 737763 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(737832), // Rule ID 5556 //
     /* 737768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737776 */     // MIs[0] offset
     /* 737776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737779 */     // MIs[0] auxiliary
     /* 737779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737782 */     // MIs[0] Operand 7
     /* 737782 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737800 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 737803 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737812 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737820 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737830 */     GIR_RootConstrainSelectedInstOperands,
     /* 737831 */     // GIR_Coverage, 5556,
     /* 737831 */     GIR_EraseRootFromParent_Done,
     /* 737832 */   // Label 9697: @737832
     /* 737832 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(737904), // Rule ID 5560 //
     /* 737837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737848 */     // MIs[0] offset
     /* 737848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737851 */     // MIs[0] auxiliary
     /* 737851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737854 */     // MIs[0] Operand 7
     /* 737854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737872 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9741:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
     /* 737875 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737902 */     GIR_RootConstrainSelectedInstOperands,
     /* 737903 */     // GIR_Coverage, 5560,
     /* 737903 */     GIR_EraseRootFromParent_Done,
     /* 737904 */   // Label 9698: @737904
     /* 737904 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(737973), // Rule ID 5564 //
     /* 737909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 737917 */     // MIs[0] offset
     /* 737917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737920 */     // MIs[0] auxiliary
     /* 737920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737923 */     // MIs[0] Operand 7
     /* 737923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 737934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 737941 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 737941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
     /* 737944 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 737946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 737948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 737953 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 737955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 737961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 737967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 737971 */     GIR_RootConstrainSelectedInstOperands,
     /* 737972 */     // GIR_Coverage, 5564,
     /* 737972 */     GIR_EraseRootFromParent_Done,
     /* 737973 */   // Label 9699: @737973
     /* 737973 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(738043), // Rule ID 5553 //
     /* 737978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 737981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 737985 */     // MIs[0] offset
     /* 737985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 737988 */     // MIs[0] auxiliary
     /* 737988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 737991 */     // MIs[0] Operand 7
     /* 737991 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738009 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9741:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 738012 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738014 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738023 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738041 */     GIR_RootConstrainSelectedInstOperands,
     /* 738042 */     // GIR_Coverage, 5553,
     /* 738042 */     GIR_EraseRootFromParent_Done,
     /* 738043 */   // Label 9700: @738043
     /* 738043 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(738110), // Rule ID 5557 //
     /* 738048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738052 */     // MIs[0] offset
     /* 738052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738055 */     // MIs[0] auxiliary
     /* 738055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738058 */     // MIs[0] Operand 7
     /* 738058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738076 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 738079 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738081 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738090 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738092 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738108 */     GIR_RootConstrainSelectedInstOperands,
     /* 738109 */     // GIR_Coverage, 5557,
     /* 738109 */     GIR_EraseRootFromParent_Done,
     /* 738110 */   // Label 9701: @738110
     /* 738110 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(738180), // Rule ID 5561 //
     /* 738115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738122 */     // MIs[0] offset
     /* 738122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738125 */     // MIs[0] auxiliary
     /* 738125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738128 */     // MIs[0] Operand 7
     /* 738128 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738146 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9741:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
     /* 738149 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738151 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738160 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738178 */     GIR_RootConstrainSelectedInstOperands,
     /* 738179 */     // GIR_Coverage, 5561,
     /* 738179 */     GIR_EraseRootFromParent_Done,
     /* 738180 */   // Label 9702: @738180
     /* 738180 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(738247), // Rule ID 5565 //
     /* 738185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738189 */     // MIs[0] offset
     /* 738189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738192 */     // MIs[0] auxiliary
     /* 738192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738195 */     // MIs[0] Operand 7
     /* 738195 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738213 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
     /* 738216 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738218 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 738220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738227 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738245 */     GIR_RootConstrainSelectedInstOperands,
     /* 738246 */     // GIR_Coverage, 5565,
     /* 738246 */     GIR_EraseRootFromParent_Done,
     /* 738247 */   // Label 9703: @738247
     /* 738247 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(738309), // Rule ID 5554 //
     /* 738252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738259 */     // MIs[0] offset
     /* 738259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738262 */     // MIs[0] auxiliary
     /* 738262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738265 */     // MIs[0] Operand 7
     /* 738265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738275 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9741:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 738278 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738280 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738289 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738307 */     GIR_RootConstrainSelectedInstOperands,
     /* 738308 */     // GIR_Coverage, 5554,
     /* 738308 */     GIR_EraseRootFromParent_Done,
     /* 738309 */   // Label 9704: @738309
     /* 738309 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(738368), // Rule ID 5558 //
     /* 738314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738318 */     // MIs[0] offset
     /* 738318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738321 */     // MIs[0] auxiliary
     /* 738321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738324 */     // MIs[0] Operand 7
     /* 738324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738334 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 738337 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738339 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738348 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738366 */     GIR_RootConstrainSelectedInstOperands,
     /* 738367 */     // GIR_Coverage, 5558,
     /* 738367 */     GIR_EraseRootFromParent_Done,
     /* 738368 */   // Label 9705: @738368
     /* 738368 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(738430), // Rule ID 5562 //
     /* 738373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738380 */     // MIs[0] offset
     /* 738380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738383 */     // MIs[0] auxiliary
     /* 738383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738386 */     // MIs[0] Operand 7
     /* 738386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738396 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9741:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
     /* 738399 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738401 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738410 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738412 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738428 */     GIR_RootConstrainSelectedInstOperands,
     /* 738429 */     // GIR_Coverage, 5562,
     /* 738429 */     GIR_EraseRootFromParent_Done,
     /* 738430 */   // Label 9706: @738430
     /* 738430 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(738489), // Rule ID 5566 //
     /* 738435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738439 */     // MIs[0] offset
     /* 738439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738442 */     // MIs[0] auxiliary
     /* 738442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738445 */     // MIs[0] Operand 7
     /* 738445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738455 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
     /* 738458 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738460 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 738462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738469 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738471 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738477 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738487 */     GIR_RootConstrainSelectedInstOperands,
     /* 738488 */     // GIR_Coverage, 5566,
     /* 738488 */     GIR_EraseRootFromParent_Done,
     /* 738489 */   // Label 9707: @738489
     /* 738489 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(738589), // Rule ID 5555 //
     /* 738494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738497 */     // MIs[0] offset
     /* 738497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738500 */     // MIs[0] auxiliary
     /* 738500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738503 */     // MIs[0] Operand 7
     /* 738503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738513 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9741:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738529 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738536 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 738557 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738587 */     GIR_RootConstrainSelectedInstOperands,
     /* 738588 */     // GIR_Coverage, 5555,
     /* 738588 */     GIR_EraseRootFromParent_Done,
     /* 738589 */   // Label 9708: @738589
     /* 738589 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(738686), // Rule ID 5559 //
     /* 738594 */     // MIs[0] offset
     /* 738594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738597 */     // MIs[0] auxiliary
     /* 738597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738600 */     // MIs[0] Operand 7
     /* 738600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738610 */     // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738626 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738629 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738633 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 738654 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738666 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738684 */     GIR_RootConstrainSelectedInstOperands,
     /* 738685 */     // GIR_Coverage, 5559,
     /* 738685 */     GIR_EraseRootFromParent_Done,
     /* 738686 */   // Label 9709: @738686
     /* 738686 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(738786), // Rule ID 5563 //
     /* 738691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738694 */     // MIs[0] offset
     /* 738694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738697 */     // MIs[0] auxiliary
     /* 738697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738700 */     // MIs[0] Operand 7
     /* 738700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738710 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9741:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738726 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738733 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
     /* 738754 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738766 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738784 */     GIR_RootConstrainSelectedInstOperands,
     /* 738785 */     // GIR_Coverage, 5563,
     /* 738785 */     GIR_EraseRootFromParent_Done,
     /* 738786 */   // Label 9710: @738786
     /* 738786 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(738883), // Rule ID 5567 //
     /* 738791 */     // MIs[0] offset
     /* 738791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738794 */     // MIs[0] auxiliary
     /* 738794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738797 */     // MIs[0] Operand 7
     /* 738797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 738800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738807 */     // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 738810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 738814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 738819 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 738823 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 738826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 738830 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 738833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 738838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 738848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
     /* 738851 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 738856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738863 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738881 */     GIR_RootConstrainSelectedInstOperands,
     /* 738882 */     // GIR_Coverage, 5567,
     /* 738882 */     GIR_EraseRootFromParent_Done,
     /* 738883 */   // Label 9711: @738883
     /* 738883 */   GIM_Reject,
     /* 738884 */ // Label 9695: @738884
     /* 738884 */ GIM_Reject,
     /* 738885 */ // Label 9495: @738885
     /* 738885 */ GIM_Reject,
     /* 738886 */ // Label 139: @738886
     /* 738886 */ GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(739487),
     /* 738891 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 738894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 738897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 738900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 738903 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 738906 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(739178),
     /* 738911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 738915 */     GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(738983), // Rule ID 5568 //
     /* 738920 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 738923 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738927 */       // MIs[0] offset
     /* 738927 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738930 */       // MIs[0] auxiliary
     /* 738930 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738933 */       // MIs[0] Operand 7
     /* 738933 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 738944 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 738951 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 738951 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET_exact),
     /* 738954 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 738956 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 738958 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 738963 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 738965 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 738971 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 738977 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 738981 */       GIR_RootConstrainSelectedInstOperands,
     /* 738982 */       // GIR_Coverage, 5568,
     /* 738982 */       GIR_EraseRootFromParent_Done,
     /* 738983 */     // Label 9714: @738983
     /* 738983 */     GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(739048), // Rule ID 5572 //
     /* 738988 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 738992 */       // MIs[0] offset
     /* 738992 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 738995 */       // MIs[0] auxiliary
     /* 738995 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 738998 */       // MIs[0] Operand 7
     /* 738998 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739009 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739016 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739016 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact),
     /* 739019 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739021 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739023 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739028 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739030 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739036 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739042 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739046 */       GIR_RootConstrainSelectedInstOperands,
     /* 739047 */       // GIR_Coverage, 5572,
     /* 739047 */       GIR_EraseRootFromParent_Done,
     /* 739048 */     // Label 9715: @739048
     /* 739048 */     GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(739114), // Rule ID 5569 //
     /* 739053 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739056 */       // MIs[0] offset
     /* 739056 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739059 */       // MIs[0] auxiliary
     /* 739059 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739062 */       // MIs[0] Operand 7
     /* 739062 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739073 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739080 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739080 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN_exact),
     /* 739083 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739085 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739087 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739089 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739094 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739096 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739102 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739108 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739112 */       GIR_RootConstrainSelectedInstOperands,
     /* 739113 */       // GIR_Coverage, 5569,
     /* 739113 */       GIR_EraseRootFromParent_Done,
     /* 739114 */     // Label 9716: @739114
     /* 739114 */     GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(739177), // Rule ID 5573 //
     /* 739119 */       // MIs[0] offset
     /* 739119 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739122 */       // MIs[0] auxiliary
     /* 739122 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739125 */       // MIs[0] Operand 7
     /* 739125 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739136 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739143 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739143 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact),
     /* 739146 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739148 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739150 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739152 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739157 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739159 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739165 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739171 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739175 */       GIR_RootConstrainSelectedInstOperands,
     /* 739176 */       // GIR_Coverage, 5573,
     /* 739176 */       GIR_EraseRootFromParent_Done,
     /* 739177 */     // Label 9717: @739177
     /* 739177 */     GIM_Reject,
     /* 739178 */   // Label 9713: @739178
     /* 739178 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(739292),
     /* 739183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739196 */     GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(739245), // Rule ID 5570 //
     /* 739201 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739204 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739211 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739211 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_IDXEN_exact),
     /* 739214 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739216 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 739218 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739220 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739225 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739227 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739233 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739239 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739243 */       GIR_RootConstrainSelectedInstOperands,
     /* 739244 */       // GIR_Coverage, 5570,
     /* 739244 */       GIR_EraseRootFromParent_Done,
     /* 739245 */     // Label 9719: @739245
     /* 739245 */     GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(739291), // Rule ID 5574 //
     /* 739250 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739257 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739257 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact),
     /* 739260 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739262 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 739264 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739266 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739271 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739273 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739279 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739285 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739289 */       GIR_RootConstrainSelectedInstOperands,
     /* 739290 */       // GIR_Coverage, 5574,
     /* 739290 */       GIR_EraseRootFromParent_Done,
     /* 739291 */     // Label 9720: @739291
     /* 739291 */     GIM_Reject,
     /* 739292 */   // Label 9718: @739292
     /* 739292 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(739486),
     /* 739297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 739306 */     GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(739397), // Rule ID 5571 //
     /* 739311 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739314 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739321 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739321 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739324 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739328 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739333 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739337 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739340 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739344 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739357 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739362 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_BOTHEN_exact),
     /* 739365 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739367 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739370 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739372 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739377 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739379 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739385 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739391 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739395 */       GIR_RootConstrainSelectedInstOperands,
     /* 739396 */       // GIR_Coverage, 5571,
     /* 739396 */       GIR_EraseRootFromParent_Done,
     /* 739397 */     // Label 9722: @739397
     /* 739397 */     GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(739485), // Rule ID 5575 //
     /* 739402 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739409 */       // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739409 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 739412 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 739416 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 739421 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 739425 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 739428 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 739432 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 739435 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 739440 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739445 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 739450 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact),
     /* 739453 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739455 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 739458 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739460 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739465 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739467 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739473 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739479 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739483 */       GIR_RootConstrainSelectedInstOperands,
     /* 739484 */       // GIR_Coverage, 5575,
     /* 739484 */       GIR_EraseRootFromParent_Done,
     /* 739485 */     // Label 9723: @739485
     /* 739485 */     GIM_Reject,
     /* 739486 */   // Label 9721: @739486
     /* 739486 */   GIM_Reject,
     /* 739487 */ // Label 9712: @739487
     /* 739487 */ GIM_Reject,
     /* 739488 */ // Label 140: @739488
     /* 739488 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9728*/ GIMT_Encode4(744975),
     /* 739499 */ /*GILLT_s32*//*Label 9724*/ GIMT_Encode4(739535), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 739511 */ /*GILLT_v2s32*//*Label 9725*/ GIMT_Encode4(740746), GIMT_Encode4(0),
     /* 739519 */ /*GILLT_v3s32*//*Label 9726*/ GIMT_Encode4(742553), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 739531 */ /*GILLT_v4s32*//*Label 9727*/ GIMT_Encode4(743764),
     /* 739535 */ // Label 9724: @739535
     /* 739535 */ GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(740745),
     /* 739540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 739543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 739546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 739549 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 739552 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(739624), // Rule ID 5200 //
     /* 739557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739568 */     // MIs[0] offset
     /* 739568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739571 */     // MIs[0] auxiliary
     /* 739571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739574 */     // MIs[0] Operand 7
     /* 739574 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739592 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9744:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 739595 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739604 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739606 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739622 */     GIR_RootConstrainSelectedInstOperands,
     /* 739623 */     // GIR_Coverage, 5200,
     /* 739623 */     GIR_EraseRootFromParent_Done,
     /* 739624 */   // Label 9730: @739624
     /* 739624 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(739693), // Rule ID 5204 //
     /* 739629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739637 */     // MIs[0] offset
     /* 739637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739640 */     // MIs[0] auxiliary
     /* 739640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739643 */     // MIs[0] Operand 7
     /* 739643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739661 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 739664 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739673 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739675 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739691 */     GIR_RootConstrainSelectedInstOperands,
     /* 739692 */     // GIR_Coverage, 5204,
     /* 739692 */     GIR_EraseRootFromParent_Done,
     /* 739693 */   // Label 9731: @739693
     /* 739693 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(739765), // Rule ID 5208 //
     /* 739698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739709 */     // MIs[0] offset
     /* 739709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739712 */     // MIs[0] auxiliary
     /* 739712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739715 */     // MIs[0] Operand 7
     /* 739715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739733 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 739736 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739745 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739747 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739763 */     GIR_RootConstrainSelectedInstOperands,
     /* 739764 */     // GIR_Coverage, 5208,
     /* 739764 */     GIR_EraseRootFromParent_Done,
     /* 739765 */   // Label 9732: @739765
     /* 739765 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(739834), // Rule ID 5212 //
     /* 739770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 739778 */     // MIs[0] offset
     /* 739778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739781 */     // MIs[0] auxiliary
     /* 739781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739784 */     // MIs[0] Operand 7
     /* 739784 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739802 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 739805 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739814 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739832 */     GIR_RootConstrainSelectedInstOperands,
     /* 739833 */     // GIR_Coverage, 5212,
     /* 739833 */     GIR_EraseRootFromParent_Done,
     /* 739834 */   // Label 9733: @739834
     /* 739834 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(739904), // Rule ID 5201 //
     /* 739839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739846 */     // MIs[0] offset
     /* 739846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739849 */     // MIs[0] auxiliary
     /* 739849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739852 */     // MIs[0] Operand 7
     /* 739852 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739870 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 739873 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739875 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739902 */     GIR_RootConstrainSelectedInstOperands,
     /* 739903 */     // GIR_Coverage, 5201,
     /* 739903 */     GIR_EraseRootFromParent_Done,
     /* 739904 */   // Label 9734: @739904
     /* 739904 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(739971), // Rule ID 5205 //
     /* 739909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739913 */     // MIs[0] offset
     /* 739913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739916 */     // MIs[0] auxiliary
     /* 739916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739919 */     // MIs[0] Operand 7
     /* 739919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 739930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 739937 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 739937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 739940 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 739942 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 739944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 739946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 739951 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 739953 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 739959 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 739965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 739969 */     GIR_RootConstrainSelectedInstOperands,
     /* 739970 */     // GIR_Coverage, 5205,
     /* 739970 */     GIR_EraseRootFromParent_Done,
     /* 739971 */   // Label 9735: @739971
     /* 739971 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(740041), // Rule ID 5209 //
     /* 739976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 739979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 739983 */     // MIs[0] offset
     /* 739983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 739986 */     // MIs[0] auxiliary
     /* 739986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 739989 */     // MIs[0] Operand 7
     /* 739989 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740007 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 740010 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740012 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 740014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740021 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740039 */     GIR_RootConstrainSelectedInstOperands,
     /* 740040 */     // GIR_Coverage, 5209,
     /* 740040 */     GIR_EraseRootFromParent_Done,
     /* 740041 */   // Label 9736: @740041
     /* 740041 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(740108), // Rule ID 5213 //
     /* 740046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740050 */     // MIs[0] offset
     /* 740050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740053 */     // MIs[0] auxiliary
     /* 740053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740056 */     // MIs[0] Operand 7
     /* 740056 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740074 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 740077 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740079 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 740081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740088 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740096 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740106 */     GIR_RootConstrainSelectedInstOperands,
     /* 740107 */     // GIR_Coverage, 5213,
     /* 740107 */     GIR_EraseRootFromParent_Done,
     /* 740108 */   // Label 9737: @740108
     /* 740108 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(740170), // Rule ID 5202 //
     /* 740113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740120 */     // MIs[0] offset
     /* 740120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740123 */     // MIs[0] auxiliary
     /* 740123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740126 */     // MIs[0] Operand 7
     /* 740126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740136 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 740139 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740141 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740150 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740168 */     GIR_RootConstrainSelectedInstOperands,
     /* 740169 */     // GIR_Coverage, 5202,
     /* 740169 */     GIR_EraseRootFromParent_Done,
     /* 740170 */   // Label 9738: @740170
     /* 740170 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(740229), // Rule ID 5206 //
     /* 740175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740179 */     // MIs[0] offset
     /* 740179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740182 */     // MIs[0] auxiliary
     /* 740182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740185 */     // MIs[0] Operand 7
     /* 740185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740195 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 740198 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740200 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740209 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740217 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740227 */     GIR_RootConstrainSelectedInstOperands,
     /* 740228 */     // GIR_Coverage, 5206,
     /* 740228 */     GIR_EraseRootFromParent_Done,
     /* 740229 */   // Label 9739: @740229
     /* 740229 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(740291), // Rule ID 5210 //
     /* 740234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740241 */     // MIs[0] offset
     /* 740241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740244 */     // MIs[0] auxiliary
     /* 740244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740247 */     // MIs[0] Operand 7
     /* 740247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740257 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 740260 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740262 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740271 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740289 */     GIR_RootConstrainSelectedInstOperands,
     /* 740290 */     // GIR_Coverage, 5210,
     /* 740290 */     GIR_EraseRootFromParent_Done,
     /* 740291 */   // Label 9740: @740291
     /* 740291 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(740350), // Rule ID 5214 //
     /* 740296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740300 */     // MIs[0] offset
     /* 740300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740303 */     // MIs[0] auxiliary
     /* 740303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740306 */     // MIs[0] Operand 7
     /* 740306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740316 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 740319 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740321 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 740323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740330 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740348 */     GIR_RootConstrainSelectedInstOperands,
     /* 740349 */     // GIR_Coverage, 5214,
     /* 740349 */     GIR_EraseRootFromParent_Done,
     /* 740350 */   // Label 9741: @740350
     /* 740350 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(740450), // Rule ID 5203 //
     /* 740355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740358 */     // MIs[0] offset
     /* 740358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740361 */     // MIs[0] auxiliary
     /* 740361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740364 */     // MIs[0] Operand 7
     /* 740364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740374 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9744:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740390 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740397 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 740418 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740430 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740432 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740438 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740448 */     GIR_RootConstrainSelectedInstOperands,
     /* 740449 */     // GIR_Coverage, 5203,
     /* 740449 */     GIR_EraseRootFromParent_Done,
     /* 740450 */   // Label 9742: @740450
     /* 740450 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(740547), // Rule ID 5207 //
     /* 740455 */     // MIs[0] offset
     /* 740455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740458 */     // MIs[0] auxiliary
     /* 740458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740461 */     // MIs[0] Operand 7
     /* 740461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740471 */     // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740487 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740494 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 740515 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740527 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740529 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740535 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740545 */     GIR_RootConstrainSelectedInstOperands,
     /* 740546 */     // GIR_Coverage, 5207,
     /* 740546 */     GIR_EraseRootFromParent_Done,
     /* 740547 */   // Label 9743: @740547
     /* 740547 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(740647), // Rule ID 5211 //
     /* 740552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740555 */     // MIs[0] offset
     /* 740555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740558 */     // MIs[0] auxiliary
     /* 740558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740561 */     // MIs[0] Operand 7
     /* 740561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740571 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740587 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740594 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 740615 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740627 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740629 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740645 */     GIR_RootConstrainSelectedInstOperands,
     /* 740646 */     // GIR_Coverage, 5211,
     /* 740646 */     GIR_EraseRootFromParent_Done,
     /* 740647 */   // Label 9744: @740647
     /* 740647 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(740744), // Rule ID 5215 //
     /* 740652 */     // MIs[0] offset
     /* 740652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740655 */     // MIs[0] auxiliary
     /* 740655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740658 */     // MIs[0] Operand 7
     /* 740658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 740661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740668 */     // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 740671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 740675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 740680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 740684 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 740687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 740691 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 740694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 740699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 740709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 740712 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 740717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740724 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740732 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740742 */     GIR_RootConstrainSelectedInstOperands,
     /* 740743 */     // GIR_Coverage, 5215,
     /* 740743 */     GIR_EraseRootFromParent_Done,
     /* 740744 */   // Label 9745: @740744
     /* 740744 */   GIM_Reject,
     /* 740745 */ // Label 9729: @740745
     /* 740745 */ GIM_Reject,
     /* 740746 */ // Label 9725: @740746
     /* 740746 */ GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(742552),
     /* 740751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 740754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 740757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 740760 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 740763 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(740835), // Rule ID 5216 //
     /* 740768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740779 */     // MIs[0] offset
     /* 740779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740782 */     // MIs[0] auxiliary
     /* 740782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740785 */     // MIs[0] Operand 7
     /* 740785 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740803 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9743:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 740806 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740815 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740833 */     GIR_RootConstrainSelectedInstOperands,
     /* 740834 */     // GIR_Coverage, 5216,
     /* 740834 */     GIR_EraseRootFromParent_Done,
     /* 740835 */   // Label 9747: @740835
     /* 740835 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(740904), // Rule ID 5220 //
     /* 740840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740848 */     // MIs[0] offset
     /* 740848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740851 */     // MIs[0] auxiliary
     /* 740851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740854 */     // MIs[0] Operand 7
     /* 740854 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740872 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 740875 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740902 */     GIR_RootConstrainSelectedInstOperands,
     /* 740903 */     // GIR_Coverage, 5220,
     /* 740903 */     GIR_EraseRootFromParent_Done,
     /* 740904 */   // Label 9748: @740904
     /* 740904 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(740976), // Rule ID 5224 //
     /* 740909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 740912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740920 */     // MIs[0] offset
     /* 740920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740923 */     // MIs[0] auxiliary
     /* 740923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740926 */     // MIs[0] Operand 7
     /* 740926 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 740937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 740944 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 740944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 740947 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 740949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 740951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 740956 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 740958 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 740964 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 740970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 740974 */     GIR_RootConstrainSelectedInstOperands,
     /* 740975 */     // GIR_Coverage, 5224,
     /* 740975 */     GIR_EraseRootFromParent_Done,
     /* 740976 */   // Label 9749: @740976
     /* 740976 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(741045), // Rule ID 5228 //
     /* 740981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 740985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 740989 */     // MIs[0] offset
     /* 740989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 740992 */     // MIs[0] auxiliary
     /* 740992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 740995 */     // MIs[0] Operand 7
     /* 740995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741013 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 741016 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741025 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741027 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741033 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741043 */     GIR_RootConstrainSelectedInstOperands,
     /* 741044 */     // GIR_Coverage, 5228,
     /* 741044 */     GIR_EraseRootFromParent_Done,
     /* 741045 */   // Label 9750: @741045
     /* 741045 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(741117), // Rule ID 5232 //
     /* 741050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741061 */     // MIs[0] offset
     /* 741061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741064 */     // MIs[0] auxiliary
     /* 741064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741067 */     // MIs[0] Operand 7
     /* 741067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741085 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 741088 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741097 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741115 */     GIR_RootConstrainSelectedInstOperands,
     /* 741116 */     // GIR_Coverage, 5232,
     /* 741116 */     GIR_EraseRootFromParent_Done,
     /* 741117 */   // Label 9751: @741117
     /* 741117 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(741186), // Rule ID 5236 //
     /* 741122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741130 */     // MIs[0] offset
     /* 741130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741133 */     // MIs[0] auxiliary
     /* 741133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741136 */     // MIs[0] Operand 7
     /* 741136 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741154 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 741157 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741166 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741184 */     GIR_RootConstrainSelectedInstOperands,
     /* 741185 */     // GIR_Coverage, 5236,
     /* 741185 */     GIR_EraseRootFromParent_Done,
     /* 741186 */   // Label 9752: @741186
     /* 741186 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(741256), // Rule ID 5217 //
     /* 741191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741198 */     // MIs[0] offset
     /* 741198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741201 */     // MIs[0] auxiliary
     /* 741201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741204 */     // MIs[0] Operand 7
     /* 741204 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741222 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 741225 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741227 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741236 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741254 */     GIR_RootConstrainSelectedInstOperands,
     /* 741255 */     // GIR_Coverage, 5217,
     /* 741255 */     GIR_EraseRootFromParent_Done,
     /* 741256 */   // Label 9753: @741256
     /* 741256 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(741323), // Rule ID 5221 //
     /* 741261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741265 */     // MIs[0] offset
     /* 741265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741268 */     // MIs[0] auxiliary
     /* 741268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741271 */     // MIs[0] Operand 7
     /* 741271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741289 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 741292 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741294 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741303 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741321 */     GIR_RootConstrainSelectedInstOperands,
     /* 741322 */     // GIR_Coverage, 5221,
     /* 741322 */     GIR_EraseRootFromParent_Done,
     /* 741323 */   // Label 9754: @741323
     /* 741323 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(741393), // Rule ID 5225 //
     /* 741328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741335 */     // MIs[0] offset
     /* 741335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741338 */     // MIs[0] auxiliary
     /* 741338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741341 */     // MIs[0] Operand 7
     /* 741341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741359 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 741362 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741364 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741373 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741391 */     GIR_RootConstrainSelectedInstOperands,
     /* 741392 */     // GIR_Coverage, 5225,
     /* 741392 */     GIR_EraseRootFromParent_Done,
     /* 741393 */   // Label 9755: @741393
     /* 741393 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(741460), // Rule ID 5229 //
     /* 741398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741402 */     // MIs[0] offset
     /* 741402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741405 */     // MIs[0] auxiliary
     /* 741405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741408 */     // MIs[0] Operand 7
     /* 741408 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741426 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 741429 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741431 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741440 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741458 */     GIR_RootConstrainSelectedInstOperands,
     /* 741459 */     // GIR_Coverage, 5229,
     /* 741459 */     GIR_EraseRootFromParent_Done,
     /* 741460 */   // Label 9756: @741460
     /* 741460 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(741530), // Rule ID 5233 //
     /* 741465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741472 */     // MIs[0] offset
     /* 741472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741475 */     // MIs[0] auxiliary
     /* 741475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741478 */     // MIs[0] Operand 7
     /* 741478 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741496 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 741499 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741501 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741510 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741512 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741518 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741528 */     GIR_RootConstrainSelectedInstOperands,
     /* 741529 */     // GIR_Coverage, 5233,
     /* 741529 */     GIR_EraseRootFromParent_Done,
     /* 741530 */   // Label 9757: @741530
     /* 741530 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(741597), // Rule ID 5237 //
     /* 741535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 741539 */     // MIs[0] offset
     /* 741539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741542 */     // MIs[0] auxiliary
     /* 741542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741545 */     // MIs[0] Operand 7
     /* 741545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 741556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741563 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 741566 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741568 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 741570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741577 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741595 */     GIR_RootConstrainSelectedInstOperands,
     /* 741596 */     // GIR_Coverage, 5237,
     /* 741596 */     GIR_EraseRootFromParent_Done,
     /* 741597 */   // Label 9758: @741597
     /* 741597 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(741659), // Rule ID 5218 //
     /* 741602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741609 */     // MIs[0] offset
     /* 741609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741612 */     // MIs[0] auxiliary
     /* 741612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741615 */     // MIs[0] Operand 7
     /* 741615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741625 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 741628 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741630 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741639 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741657 */     GIR_RootConstrainSelectedInstOperands,
     /* 741658 */     // GIR_Coverage, 5218,
     /* 741658 */     GIR_EraseRootFromParent_Done,
     /* 741659 */   // Label 9759: @741659
     /* 741659 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(741718), // Rule ID 5222 //
     /* 741664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741668 */     // MIs[0] offset
     /* 741668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741671 */     // MIs[0] auxiliary
     /* 741671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741674 */     // MIs[0] Operand 7
     /* 741674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741684 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 741687 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741689 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741698 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741716 */     GIR_RootConstrainSelectedInstOperands,
     /* 741717 */     // GIR_Coverage, 5222,
     /* 741717 */     GIR_EraseRootFromParent_Done,
     /* 741718 */   // Label 9760: @741718
     /* 741718 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(741780), // Rule ID 5226 //
     /* 741723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741730 */     // MIs[0] offset
     /* 741730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741733 */     // MIs[0] auxiliary
     /* 741733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741736 */     // MIs[0] Operand 7
     /* 741736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741746 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 741749 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741751 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741760 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741778 */     GIR_RootConstrainSelectedInstOperands,
     /* 741779 */     // GIR_Coverage, 5226,
     /* 741779 */     GIR_EraseRootFromParent_Done,
     /* 741780 */   // Label 9761: @741780
     /* 741780 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(741839), // Rule ID 5230 //
     /* 741785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741789 */     // MIs[0] offset
     /* 741789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741792 */     // MIs[0] auxiliary
     /* 741792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741795 */     // MIs[0] Operand 7
     /* 741795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741805 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 741808 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741810 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741819 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741821 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741827 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741837 */     GIR_RootConstrainSelectedInstOperands,
     /* 741838 */     // GIR_Coverage, 5230,
     /* 741838 */     GIR_EraseRootFromParent_Done,
     /* 741839 */   // Label 9762: @741839
     /* 741839 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(741901), // Rule ID 5234 //
     /* 741844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741851 */     // MIs[0] offset
     /* 741851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741854 */     // MIs[0] auxiliary
     /* 741854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741857 */     // MIs[0] Operand 7
     /* 741857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741867 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 741870 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741872 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741881 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741883 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741899 */     GIR_RootConstrainSelectedInstOperands,
     /* 741900 */     // GIR_Coverage, 5234,
     /* 741900 */     GIR_EraseRootFromParent_Done,
     /* 741901 */   // Label 9763: @741901
     /* 741901 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(741960), // Rule ID 5238 //
     /* 741906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 741910 */     // MIs[0] offset
     /* 741910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741913 */     // MIs[0] auxiliary
     /* 741913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741916 */     // MIs[0] Operand 7
     /* 741916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741926 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 741929 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 741931 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 741933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 741935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 741940 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 741942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 741948 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 741954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 741958 */     GIR_RootConstrainSelectedInstOperands,
     /* 741959 */     // GIR_Coverage, 5238,
     /* 741959 */     GIR_EraseRootFromParent_Done,
     /* 741960 */   // Label 9764: @741960
     /* 741960 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(742060), // Rule ID 5219 //
     /* 741965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 741968 */     // MIs[0] offset
     /* 741968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 741971 */     // MIs[0] auxiliary
     /* 741971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 741974 */     // MIs[0] Operand 7
     /* 741974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 741977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 741984 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 741984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 741987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 741991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 741996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742000 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742007 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 742028 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742040 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742042 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742048 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742058 */     GIR_RootConstrainSelectedInstOperands,
     /* 742059 */     // GIR_Coverage, 5219,
     /* 742059 */     GIR_EraseRootFromParent_Done,
     /* 742060 */   // Label 9765: @742060
     /* 742060 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(742157), // Rule ID 5223 //
     /* 742065 */     // MIs[0] offset
     /* 742065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742068 */     // MIs[0] auxiliary
     /* 742068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742071 */     // MIs[0] Operand 7
     /* 742071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742081 */     // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742093 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742097 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742104 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 742125 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742137 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742139 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742145 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742155 */     GIR_RootConstrainSelectedInstOperands,
     /* 742156 */     // GIR_Coverage, 5223,
     /* 742156 */     GIR_EraseRootFromParent_Done,
     /* 742157 */   // Label 9766: @742157
     /* 742157 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(742257), // Rule ID 5227 //
     /* 742162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 742165 */     // MIs[0] offset
     /* 742165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742168 */     // MIs[0] auxiliary
     /* 742168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742171 */     // MIs[0] Operand 7
     /* 742171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742181 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742197 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742204 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 742225 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742237 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742255 */     GIR_RootConstrainSelectedInstOperands,
     /* 742256 */     // GIR_Coverage, 5227,
     /* 742256 */     GIR_EraseRootFromParent_Done,
     /* 742257 */   // Label 9767: @742257
     /* 742257 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(742354), // Rule ID 5231 //
     /* 742262 */     // MIs[0] offset
     /* 742262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742265 */     // MIs[0] auxiliary
     /* 742265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742268 */     // MIs[0] Operand 7
     /* 742268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742278 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742294 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742301 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 742322 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742334 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742352 */     GIR_RootConstrainSelectedInstOperands,
     /* 742353 */     // GIR_Coverage, 5231,
     /* 742353 */     GIR_EraseRootFromParent_Done,
     /* 742354 */   // Label 9768: @742354
     /* 742354 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(742454), // Rule ID 5235 //
     /* 742359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 742362 */     // MIs[0] offset
     /* 742362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742365 */     // MIs[0] auxiliary
     /* 742365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742368 */     // MIs[0] Operand 7
     /* 742368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742378 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742394 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742401 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 742422 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742434 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742452 */     GIR_RootConstrainSelectedInstOperands,
     /* 742453 */     // GIR_Coverage, 5235,
     /* 742453 */     GIR_EraseRootFromParent_Done,
     /* 742454 */   // Label 9769: @742454
     /* 742454 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(742551), // Rule ID 5239 //
     /* 742459 */     // MIs[0] offset
     /* 742459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742462 */     // MIs[0] auxiliary
     /* 742462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742465 */     // MIs[0] Operand 7
     /* 742465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 742468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742475 */     // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 742478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 742482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 742487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 742491 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 742494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 742498 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 742501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 742506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 742516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 742519 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 742524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742531 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742549 */     GIR_RootConstrainSelectedInstOperands,
     /* 742550 */     // GIR_Coverage, 5239,
     /* 742550 */     GIR_EraseRootFromParent_Done,
     /* 742551 */   // Label 9770: @742551
     /* 742551 */   GIM_Reject,
     /* 742552 */ // Label 9746: @742552
     /* 742552 */ GIM_Reject,
     /* 742553 */ // Label 9726: @742553
     /* 742553 */ GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(743763),
     /* 742558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 742561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 742564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 742567 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 742570 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(742642), // Rule ID 5240 //
     /* 742575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 742578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742586 */     // MIs[0] offset
     /* 742586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742589 */     // MIs[0] auxiliary
     /* 742589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742592 */     // MIs[0] Operand 7
     /* 742592 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742610 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9742:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 742613 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742622 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742640 */     GIR_RootConstrainSelectedInstOperands,
     /* 742641 */     // GIR_Coverage, 5240,
     /* 742641 */     GIR_EraseRootFromParent_Done,
     /* 742642 */   // Label 9772: @742642
     /* 742642 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(742711), // Rule ID 5244 //
     /* 742647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742651 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742655 */     // MIs[0] offset
     /* 742655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742658 */     // MIs[0] auxiliary
     /* 742658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742661 */     // MIs[0] Operand 7
     /* 742661 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742679 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9742:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 742682 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742691 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742693 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742699 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742709 */     GIR_RootConstrainSelectedInstOperands,
     /* 742710 */     // GIR_Coverage, 5244,
     /* 742710 */     GIR_EraseRootFromParent_Done,
     /* 742711 */   // Label 9773: @742711
     /* 742711 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(742783), // Rule ID 5248 //
     /* 742716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 742719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742727 */     // MIs[0] offset
     /* 742727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742730 */     // MIs[0] auxiliary
     /* 742730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742733 */     // MIs[0] Operand 7
     /* 742733 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742751 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 742754 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742763 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742781 */     GIR_RootConstrainSelectedInstOperands,
     /* 742782 */     // GIR_Coverage, 5248,
     /* 742782 */     GIR_EraseRootFromParent_Done,
     /* 742783 */   // Label 9774: @742783
     /* 742783 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(742852), // Rule ID 5252 //
     /* 742788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 742796 */     // MIs[0] offset
     /* 742796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742799 */     // MIs[0] auxiliary
     /* 742799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742802 */     // MIs[0] Operand 7
     /* 742802 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742820 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 742823 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742832 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742850 */     GIR_RootConstrainSelectedInstOperands,
     /* 742851 */     // GIR_Coverage, 5252,
     /* 742851 */     GIR_EraseRootFromParent_Done,
     /* 742852 */   // Label 9775: @742852
     /* 742852 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(742922), // Rule ID 5241 //
     /* 742857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 742860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742864 */     // MIs[0] offset
     /* 742864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742867 */     // MIs[0] auxiliary
     /* 742867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742870 */     // MIs[0] Operand 7
     /* 742870 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742888 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 742891 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742893 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 742895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742902 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742920 */     GIR_RootConstrainSelectedInstOperands,
     /* 742921 */     // GIR_Coverage, 5241,
     /* 742921 */     GIR_EraseRootFromParent_Done,
     /* 742922 */   // Label 9776: @742922
     /* 742922 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(742989), // Rule ID 5245 //
     /* 742927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 742931 */     // MIs[0] offset
     /* 742931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 742934 */     // MIs[0] auxiliary
     /* 742934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 742937 */     // MIs[0] Operand 7
     /* 742937 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 742948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 742955 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 742955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 742958 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 742960 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 742962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 742964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 742969 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 742971 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 742977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 742983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 742987 */     GIR_RootConstrainSelectedInstOperands,
     /* 742988 */     // GIR_Coverage, 5245,
     /* 742988 */     GIR_EraseRootFromParent_Done,
     /* 742989 */   // Label 9777: @742989
     /* 742989 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(743059), // Rule ID 5249 //
     /* 742994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 742997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743001 */     // MIs[0] offset
     /* 743001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743004 */     // MIs[0] auxiliary
     /* 743004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743007 */     // MIs[0] Operand 7
     /* 743007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743025 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 743028 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743030 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743039 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743041 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743047 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743057 */     GIR_RootConstrainSelectedInstOperands,
     /* 743058 */     // GIR_Coverage, 5249,
     /* 743058 */     GIR_EraseRootFromParent_Done,
     /* 743059 */   // Label 9778: @743059
     /* 743059 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(743126), // Rule ID 5253 //
     /* 743064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743068 */     // MIs[0] offset
     /* 743068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743071 */     // MIs[0] auxiliary
     /* 743071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743074 */     // MIs[0] Operand 7
     /* 743074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743092 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 743095 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743097 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 743099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743106 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743108 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743114 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743124 */     GIR_RootConstrainSelectedInstOperands,
     /* 743125 */     // GIR_Coverage, 5253,
     /* 743125 */     GIR_EraseRootFromParent_Done,
     /* 743126 */   // Label 9779: @743126
     /* 743126 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(743188), // Rule ID 5242 //
     /* 743131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 743134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743138 */     // MIs[0] offset
     /* 743138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743141 */     // MIs[0] auxiliary
     /* 743141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743144 */     // MIs[0] Operand 7
     /* 743144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743154 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 743157 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743159 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743168 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743186 */     GIR_RootConstrainSelectedInstOperands,
     /* 743187 */     // GIR_Coverage, 5242,
     /* 743187 */     GIR_EraseRootFromParent_Done,
     /* 743188 */   // Label 9780: @743188
     /* 743188 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(743247), // Rule ID 5246 //
     /* 743193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743197 */     // MIs[0] offset
     /* 743197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743200 */     // MIs[0] auxiliary
     /* 743200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743203 */     // MIs[0] Operand 7
     /* 743203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743213 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 743216 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743218 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743227 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743235 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743245 */     GIR_RootConstrainSelectedInstOperands,
     /* 743246 */     // GIR_Coverage, 5246,
     /* 743246 */     GIR_EraseRootFromParent_Done,
     /* 743247 */   // Label 9781: @743247
     /* 743247 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(743309), // Rule ID 5250 //
     /* 743252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 743255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743259 */     // MIs[0] offset
     /* 743259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743262 */     // MIs[0] auxiliary
     /* 743262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743265 */     // MIs[0] Operand 7
     /* 743265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743275 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 743278 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743280 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743289 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743297 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743307 */     GIR_RootConstrainSelectedInstOperands,
     /* 743308 */     // GIR_Coverage, 5250,
     /* 743308 */     GIR_EraseRootFromParent_Done,
     /* 743309 */   // Label 9782: @743309
     /* 743309 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(743368), // Rule ID 5254 //
     /* 743314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743318 */     // MIs[0] offset
     /* 743318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743321 */     // MIs[0] auxiliary
     /* 743321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743324 */     // MIs[0] Operand 7
     /* 743324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743334 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 743337 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743339 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 743341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743348 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743366 */     GIR_RootConstrainSelectedInstOperands,
     /* 743367 */     // GIR_Coverage, 5254,
     /* 743367 */     GIR_EraseRootFromParent_Done,
     /* 743368 */   // Label 9783: @743368
     /* 743368 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(743468), // Rule ID 5243 //
     /* 743373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 743376 */     // MIs[0] offset
     /* 743376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743379 */     // MIs[0] auxiliary
     /* 743379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743382 */     // MIs[0] Operand 7
     /* 743382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743392 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743408 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743415 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 743436 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743448 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743466 */     GIR_RootConstrainSelectedInstOperands,
     /* 743467 */     // GIR_Coverage, 5243,
     /* 743467 */     GIR_EraseRootFromParent_Done,
     /* 743468 */   // Label 9784: @743468
     /* 743468 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(743565), // Rule ID 5247 //
     /* 743473 */     // MIs[0] offset
     /* 743473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743476 */     // MIs[0] auxiliary
     /* 743476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743479 */     // MIs[0] Operand 7
     /* 743479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743489 */     // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743505 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743512 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 743533 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743545 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743563 */     GIR_RootConstrainSelectedInstOperands,
     /* 743564 */     // GIR_Coverage, 5247,
     /* 743564 */     GIR_EraseRootFromParent_Done,
     /* 743565 */   // Label 9785: @743565
     /* 743565 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(743665), // Rule ID 5251 //
     /* 743570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 743573 */     // MIs[0] offset
     /* 743573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743576 */     // MIs[0] auxiliary
     /* 743576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743579 */     // MIs[0] Operand 7
     /* 743579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743589 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743605 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743612 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 743633 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743645 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743663 */     GIR_RootConstrainSelectedInstOperands,
     /* 743664 */     // GIR_Coverage, 5251,
     /* 743664 */     GIR_EraseRootFromParent_Done,
     /* 743665 */   // Label 9786: @743665
     /* 743665 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(743762), // Rule ID 5255 //
     /* 743670 */     // MIs[0] offset
     /* 743670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743673 */     // MIs[0] auxiliary
     /* 743673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743676 */     // MIs[0] Operand 7
     /* 743676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 743679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743686 */     // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 743689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 743693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 743698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 743702 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 743705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 743709 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 743712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 743717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 743727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 743730 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 743735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743742 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743760 */     GIR_RootConstrainSelectedInstOperands,
     /* 743761 */     // GIR_Coverage, 5255,
     /* 743761 */     GIR_EraseRootFromParent_Done,
     /* 743762 */   // Label 9787: @743762
     /* 743762 */   GIM_Reject,
     /* 743763 */ // Label 9771: @743763
     /* 743763 */ GIM_Reject,
     /* 743764 */ // Label 9727: @743764
     /* 743764 */ GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(744974),
     /* 743769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 743772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 743775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 743778 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 743781 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(743853), // Rule ID 5256 //
     /* 743786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 743789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743797 */     // MIs[0] offset
     /* 743797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743800 */     // MIs[0] auxiliary
     /* 743800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743803 */     // MIs[0] Operand 7
     /* 743803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743821 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9741:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 743824 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743833 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743835 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743851 */     GIR_RootConstrainSelectedInstOperands,
     /* 743852 */     // GIR_Coverage, 5256,
     /* 743852 */     GIR_EraseRootFromParent_Done,
     /* 743853 */   // Label 9789: @743853
     /* 743853 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(743922), // Rule ID 5260 //
     /* 743858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743866 */     // MIs[0] offset
     /* 743866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743869 */     // MIs[0] auxiliary
     /* 743869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743872 */     // MIs[0] Operand 7
     /* 743872 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743890 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 743893 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743902 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743920 */     GIR_RootConstrainSelectedInstOperands,
     /* 743921 */     // GIR_Coverage, 5260,
     /* 743921 */     GIR_EraseRootFromParent_Done,
     /* 743922 */   // Label 9790: @743922
     /* 743922 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(743994), // Rule ID 5264 //
     /* 743927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 743930 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 743934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 743938 */     // MIs[0] offset
     /* 743938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 743941 */     // MIs[0] auxiliary
     /* 743941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 743944 */     // MIs[0] Operand 7
     /* 743944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 743955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 743962 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 743962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 743965 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 743967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 743969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 743974 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 743976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 743982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 743988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 743992 */     GIR_RootConstrainSelectedInstOperands,
     /* 743993 */     // GIR_Coverage, 5264,
     /* 743993 */     GIR_EraseRootFromParent_Done,
     /* 743994 */   // Label 9791: @743994
     /* 743994 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(744063), // Rule ID 5268 //
     /* 743999 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744007 */     // MIs[0] offset
     /* 744007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744010 */     // MIs[0] auxiliary
     /* 744010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744013 */     // MIs[0] Operand 7
     /* 744013 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744031 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 744034 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744043 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744061 */     GIR_RootConstrainSelectedInstOperands,
     /* 744062 */     // GIR_Coverage, 5268,
     /* 744062 */     GIR_EraseRootFromParent_Done,
     /* 744063 */   // Label 9792: @744063
     /* 744063 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(744133), // Rule ID 5257 //
     /* 744068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 744071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744075 */     // MIs[0] offset
     /* 744075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744078 */     // MIs[0] auxiliary
     /* 744078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744081 */     // MIs[0] Operand 7
     /* 744081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744099 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 744102 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744104 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744113 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744131 */     GIR_RootConstrainSelectedInstOperands,
     /* 744132 */     // GIR_Coverage, 5257,
     /* 744132 */     GIR_EraseRootFromParent_Done,
     /* 744133 */   // Label 9793: @744133
     /* 744133 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(744200), // Rule ID 5261 //
     /* 744138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744142 */     // MIs[0] offset
     /* 744142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744145 */     // MIs[0] auxiliary
     /* 744145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744148 */     // MIs[0] Operand 7
     /* 744148 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744166 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 744169 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744171 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744180 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744198 */     GIR_RootConstrainSelectedInstOperands,
     /* 744199 */     // GIR_Coverage, 5261,
     /* 744199 */     GIR_EraseRootFromParent_Done,
     /* 744200 */   // Label 9794: @744200
     /* 744200 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(744270), // Rule ID 5265 //
     /* 744205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 744208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744212 */     // MIs[0] offset
     /* 744212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744215 */     // MIs[0] auxiliary
     /* 744215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744218 */     // MIs[0] Operand 7
     /* 744218 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744236 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 744239 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744241 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744250 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744252 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744258 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744268 */     GIR_RootConstrainSelectedInstOperands,
     /* 744269 */     // GIR_Coverage, 5265,
     /* 744269 */     GIR_EraseRootFromParent_Done,
     /* 744270 */   // Label 9795: @744270
     /* 744270 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(744337), // Rule ID 5269 //
     /* 744275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 744279 */     // MIs[0] offset
     /* 744279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744282 */     // MIs[0] auxiliary
     /* 744282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744285 */     // MIs[0] Operand 7
     /* 744285 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 744296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744303 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 744306 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744308 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 744310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744317 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744319 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744335 */     GIR_RootConstrainSelectedInstOperands,
     /* 744336 */     // GIR_Coverage, 5269,
     /* 744336 */     GIR_EraseRootFromParent_Done,
     /* 744337 */   // Label 9796: @744337
     /* 744337 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(744399), // Rule ID 5258 //
     /* 744342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 744345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744349 */     // MIs[0] offset
     /* 744349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744352 */     // MIs[0] auxiliary
     /* 744352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744355 */     // MIs[0] Operand 7
     /* 744355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744365 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 744368 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744370 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744379 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744387 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744397 */     GIR_RootConstrainSelectedInstOperands,
     /* 744398 */     // GIR_Coverage, 5258,
     /* 744398 */     GIR_EraseRootFromParent_Done,
     /* 744399 */   // Label 9797: @744399
     /* 744399 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(744458), // Rule ID 5262 //
     /* 744404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744408 */     // MIs[0] offset
     /* 744408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744411 */     // MIs[0] auxiliary
     /* 744411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744414 */     // MIs[0] Operand 7
     /* 744414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744424 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 744427 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744429 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744438 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744456 */     GIR_RootConstrainSelectedInstOperands,
     /* 744457 */     // GIR_Coverage, 5262,
     /* 744457 */     GIR_EraseRootFromParent_Done,
     /* 744458 */   // Label 9798: @744458
     /* 744458 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(744520), // Rule ID 5266 //
     /* 744463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 744466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744470 */     // MIs[0] offset
     /* 744470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744473 */     // MIs[0] auxiliary
     /* 744473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744476 */     // MIs[0] Operand 7
     /* 744476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744486 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 744489 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744491 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744500 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744508 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744518 */     GIR_RootConstrainSelectedInstOperands,
     /* 744519 */     // GIR_Coverage, 5266,
     /* 744519 */     GIR_EraseRootFromParent_Done,
     /* 744520 */   // Label 9799: @744520
     /* 744520 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(744579), // Rule ID 5270 //
     /* 744525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 744529 */     // MIs[0] offset
     /* 744529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744532 */     // MIs[0] auxiliary
     /* 744532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744535 */     // MIs[0] Operand 7
     /* 744535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744545 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 744548 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744550 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 744552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744559 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744561 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744567 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744577 */     GIR_RootConstrainSelectedInstOperands,
     /* 744578 */     // GIR_Coverage, 5270,
     /* 744578 */     GIR_EraseRootFromParent_Done,
     /* 744579 */   // Label 9800: @744579
     /* 744579 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(744679), // Rule ID 5259 //
     /* 744584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 744587 */     // MIs[0] offset
     /* 744587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744590 */     // MIs[0] auxiliary
     /* 744590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744593 */     // MIs[0] Operand 7
     /* 744593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744603 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744615 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744619 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744626 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 744647 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744659 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744661 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744677 */     GIR_RootConstrainSelectedInstOperands,
     /* 744678 */     // GIR_Coverage, 5259,
     /* 744678 */     GIR_EraseRootFromParent_Done,
     /* 744679 */   // Label 9801: @744679
     /* 744679 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(744776), // Rule ID 5263 //
     /* 744684 */     // MIs[0] offset
     /* 744684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744687 */     // MIs[0] auxiliary
     /* 744687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744690 */     // MIs[0] Operand 7
     /* 744690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744700 */     // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744716 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744723 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 744744 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744756 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744764 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744774 */     GIR_RootConstrainSelectedInstOperands,
     /* 744775 */     // GIR_Coverage, 5263,
     /* 744775 */     GIR_EraseRootFromParent_Done,
     /* 744776 */   // Label 9802: @744776
     /* 744776 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(744876), // Rule ID 5267 //
     /* 744781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 744784 */     // MIs[0] offset
     /* 744784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744787 */     // MIs[0] auxiliary
     /* 744787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744790 */     // MIs[0] Operand 7
     /* 744790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744800 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744816 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744819 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744823 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 744844 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744856 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744858 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744864 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744874 */     GIR_RootConstrainSelectedInstOperands,
     /* 744875 */     // GIR_Coverage, 5267,
     /* 744875 */     GIR_EraseRootFromParent_Done,
     /* 744876 */   // Label 9803: @744876
     /* 744876 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(744973), // Rule ID 5271 //
     /* 744881 */     // MIs[0] offset
     /* 744881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 744884 */     // MIs[0] auxiliary
     /* 744884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 744887 */     // MIs[0] Operand 7
     /* 744887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 744890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 744897 */     // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 744897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 744900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 744904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 744909 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 744913 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 744916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 744920 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 744923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 744928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 744938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 744941 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 744943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 744946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 744948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 744953 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 744955 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 744961 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 744967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 744971 */     GIR_RootConstrainSelectedInstOperands,
     /* 744972 */     // GIR_Coverage, 5271,
     /* 744972 */     GIR_EraseRootFromParent_Done,
     /* 744973 */   // Label 9804: @744973
     /* 744973 */   GIM_Reject,
     /* 744974 */ // Label 9788: @744974
     /* 744974 */ GIM_Reject,
     /* 744975 */ // Label 9728: @744975
     /* 744975 */ GIM_Reject,
     /* 744976 */ // Label 141: @744976
     /* 744976 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9812*/ GIMT_Encode4(752568),
     /* 744987 */ /*GILLT_s16*//*Label 9805*/ GIMT_Encode4(745027),
     /* 744991 */ /*GILLT_s32*//*Label 9806*/ GIMT_Encode4(746870), GIMT_Encode4(0),
     /* 744999 */ /*GILLT_v2s16*//*Label 9807*/ GIMT_Encode4(747801),
     /* 745003 */ /*GILLT_v2s32*//*Label 9808*/ GIMT_Encode4(749036), GIMT_Encode4(0),
     /* 745011 */ /*GILLT_v3s32*//*Label 9809*/ GIMT_Encode4(749359), GIMT_Encode4(0),
     /* 745019 */ /*GILLT_v4s16*//*Label 9810*/ GIMT_Encode4(749682),
     /* 745023 */ /*GILLT_v4s32*//*Label 9811*/ GIMT_Encode4(752245),
     /* 745027 */ // Label 9805: @745027
     /* 745027 */ GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(746869),
     /* 745032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 745035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 745038 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 745041 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 745044 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(745116), // Rule ID 5272 //
     /* 745049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745060 */     // MIs[0] offset
     /* 745060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745063 */     // MIs[0] auxiliary
     /* 745063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745066 */     // MIs[0] Operand 7
     /* 745066 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745084 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9744:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 745087 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745096 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745098 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745104 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745114 */     GIR_RootConstrainSelectedInstOperands,
     /* 745115 */     // GIR_Coverage, 5272,
     /* 745115 */     GIR_EraseRootFromParent_Done,
     /* 745116 */   // Label 9814: @745116
     /* 745116 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(745188), // Rule ID 5276 //
     /* 745121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745132 */     // MIs[0] offset
     /* 745132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745135 */     // MIs[0] auxiliary
     /* 745135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745138 */     // MIs[0] Operand 7
     /* 745138 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745156 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9744:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 745159 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745168 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745186 */     GIR_RootConstrainSelectedInstOperands,
     /* 745187 */     // GIR_Coverage, 5276,
     /* 745187 */     GIR_EraseRootFromParent_Done,
     /* 745188 */   // Label 9815: @745188
     /* 745188 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(745260), // Rule ID 5296 //
     /* 745193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745204 */     // MIs[0] offset
     /* 745204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745207 */     // MIs[0] auxiliary
     /* 745207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745210 */     // MIs[0] Operand 7
     /* 745210 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745228 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9744:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 745231 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745240 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745248 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745258 */     GIR_RootConstrainSelectedInstOperands,
     /* 745259 */     // GIR_Coverage, 5296,
     /* 745259 */     GIR_EraseRootFromParent_Done,
     /* 745260 */   // Label 9816: @745260
     /* 745260 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(745332), // Rule ID 5300 //
     /* 745265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745276 */     // MIs[0] offset
     /* 745276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745279 */     // MIs[0] auxiliary
     /* 745279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745282 */     // MIs[0] Operand 7
     /* 745282 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745300 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 745303 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745312 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745314 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745330 */     GIR_RootConstrainSelectedInstOperands,
     /* 745331 */     // GIR_Coverage, 5300,
     /* 745331 */     GIR_EraseRootFromParent_Done,
     /* 745332 */   // Label 9817: @745332
     /* 745332 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(745404), // Rule ID 5304 //
     /* 745337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745348 */     // MIs[0] offset
     /* 745348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745351 */     // MIs[0] auxiliary
     /* 745351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745354 */     // MIs[0] Operand 7
     /* 745354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745372 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9744:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 745375 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745384 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745402 */     GIR_RootConstrainSelectedInstOperands,
     /* 745403 */     // GIR_Coverage, 5304,
     /* 745403 */     GIR_EraseRootFromParent_Done,
     /* 745404 */   // Label 9818: @745404
     /* 745404 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(745476), // Rule ID 5308 //
     /* 745409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745420 */     // MIs[0] offset
     /* 745420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745423 */     // MIs[0] auxiliary
     /* 745423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745426 */     // MIs[0] Operand 7
     /* 745426 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745444 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 745447 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745456 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745458 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745464 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745474 */     GIR_RootConstrainSelectedInstOperands,
     /* 745475 */     // GIR_Coverage, 5308,
     /* 745475 */     GIR_EraseRootFromParent_Done,
     /* 745476 */   // Label 9819: @745476
     /* 745476 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(745546), // Rule ID 5273 //
     /* 745481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745488 */     // MIs[0] offset
     /* 745488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745491 */     // MIs[0] auxiliary
     /* 745491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745494 */     // MIs[0] Operand 7
     /* 745494 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745512 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 745515 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745517 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745526 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745528 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745534 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745544 */     GIR_RootConstrainSelectedInstOperands,
     /* 745545 */     // GIR_Coverage, 5273,
     /* 745545 */     GIR_EraseRootFromParent_Done,
     /* 745546 */   // Label 9820: @745546
     /* 745546 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(745616), // Rule ID 5277 //
     /* 745551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745558 */     // MIs[0] offset
     /* 745558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745561 */     // MIs[0] auxiliary
     /* 745561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745564 */     // MIs[0] Operand 7
     /* 745564 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745582 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9744:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 745585 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745587 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745596 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745604 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745614 */     GIR_RootConstrainSelectedInstOperands,
     /* 745615 */     // GIR_Coverage, 5277,
     /* 745615 */     GIR_EraseRootFromParent_Done,
     /* 745616 */   // Label 9821: @745616
     /* 745616 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(745686), // Rule ID 5297 //
     /* 745621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745628 */     // MIs[0] offset
     /* 745628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745631 */     // MIs[0] auxiliary
     /* 745631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745634 */     // MIs[0] Operand 7
     /* 745634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745652 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 745655 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745657 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745666 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745684 */     GIR_RootConstrainSelectedInstOperands,
     /* 745685 */     // GIR_Coverage, 5297,
     /* 745685 */     GIR_EraseRootFromParent_Done,
     /* 745686 */   // Label 9822: @745686
     /* 745686 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(745756), // Rule ID 5301 //
     /* 745691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745698 */     // MIs[0] offset
     /* 745698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745701 */     // MIs[0] auxiliary
     /* 745701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745704 */     // MIs[0] Operand 7
     /* 745704 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745722 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 745725 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745727 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745736 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745744 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745754 */     GIR_RootConstrainSelectedInstOperands,
     /* 745755 */     // GIR_Coverage, 5301,
     /* 745755 */     GIR_EraseRootFromParent_Done,
     /* 745756 */   // Label 9823: @745756
     /* 745756 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(745826), // Rule ID 5305 //
     /* 745761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 745764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745768 */     // MIs[0] offset
     /* 745768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745771 */     // MIs[0] auxiliary
     /* 745771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745774 */     // MIs[0] Operand 7
     /* 745774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745792 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9744:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 745795 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745797 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745806 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745808 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745814 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745824 */     GIR_RootConstrainSelectedInstOperands,
     /* 745825 */     // GIR_Coverage, 5305,
     /* 745825 */     GIR_EraseRootFromParent_Done,
     /* 745826 */   // Label 9824: @745826
     /* 745826 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(745896), // Rule ID 5309 //
     /* 745831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 745834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 745838 */     // MIs[0] offset
     /* 745838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745841 */     // MIs[0] auxiliary
     /* 745841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745844 */     // MIs[0] Operand 7
     /* 745844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 745855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745862 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 745865 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745867 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 745869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745876 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745884 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745894 */     GIR_RootConstrainSelectedInstOperands,
     /* 745895 */     // GIR_Coverage, 5309,
     /* 745895 */     GIR_EraseRootFromParent_Done,
     /* 745896 */   // Label 9825: @745896
     /* 745896 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(745958), // Rule ID 5274 //
     /* 745901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745908 */     // MIs[0] offset
     /* 745908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745911 */     // MIs[0] auxiliary
     /* 745911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745914 */     // MIs[0] Operand 7
     /* 745914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745924 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 745927 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745929 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 745931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 745938 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 745940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 745946 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 745952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 745956 */     GIR_RootConstrainSelectedInstOperands,
     /* 745957 */     // GIR_Coverage, 5274,
     /* 745957 */     GIR_EraseRootFromParent_Done,
     /* 745958 */   // Label 9826: @745958
     /* 745958 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(746020), // Rule ID 5278 //
     /* 745963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 745966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 745970 */     // MIs[0] offset
     /* 745970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 745973 */     // MIs[0] auxiliary
     /* 745973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 745976 */     // MIs[0] Operand 7
     /* 745976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 745979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 745986 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9744:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 745986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 745989 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 745991 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 745993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 745995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746000 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746018 */     GIR_RootConstrainSelectedInstOperands,
     /* 746019 */     // GIR_Coverage, 5278,
     /* 746019 */     GIR_EraseRootFromParent_Done,
     /* 746020 */   // Label 9827: @746020
     /* 746020 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(746082), // Rule ID 5298 //
     /* 746025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746032 */     // MIs[0] offset
     /* 746032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746035 */     // MIs[0] auxiliary
     /* 746035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746038 */     // MIs[0] Operand 7
     /* 746038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746048 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 746051 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746053 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746062 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746080 */     GIR_RootConstrainSelectedInstOperands,
     /* 746081 */     // GIR_Coverage, 5298,
     /* 746081 */     GIR_EraseRootFromParent_Done,
     /* 746082 */   // Label 9828: @746082
     /* 746082 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(746144), // Rule ID 5302 //
     /* 746087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746094 */     // MIs[0] offset
     /* 746094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746097 */     // MIs[0] auxiliary
     /* 746097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746100 */     // MIs[0] Operand 7
     /* 746100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746110 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 746113 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746115 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746124 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746126 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746132 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746142 */     GIR_RootConstrainSelectedInstOperands,
     /* 746143 */     // GIR_Coverage, 5302,
     /* 746143 */     GIR_EraseRootFromParent_Done,
     /* 746144 */   // Label 9829: @746144
     /* 746144 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(746206), // Rule ID 5306 //
     /* 746149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746156 */     // MIs[0] offset
     /* 746156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746159 */     // MIs[0] auxiliary
     /* 746159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746162 */     // MIs[0] Operand 7
     /* 746162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746172 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9744:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 746175 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746177 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746186 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746204 */     GIR_RootConstrainSelectedInstOperands,
     /* 746205 */     // GIR_Coverage, 5306,
     /* 746205 */     GIR_EraseRootFromParent_Done,
     /* 746206 */   // Label 9830: @746206
     /* 746206 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(746268), // Rule ID 5310 //
     /* 746211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746218 */     // MIs[0] offset
     /* 746218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746221 */     // MIs[0] auxiliary
     /* 746221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746224 */     // MIs[0] Operand 7
     /* 746224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746234 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 746237 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746239 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 746241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746248 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746256 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746266 */     GIR_RootConstrainSelectedInstOperands,
     /* 746267 */     // GIR_Coverage, 5310,
     /* 746267 */     GIR_EraseRootFromParent_Done,
     /* 746268 */   // Label 9831: @746268
     /* 746268 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(746368), // Rule ID 5275 //
     /* 746273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746276 */     // MIs[0] offset
     /* 746276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746279 */     // MIs[0] auxiliary
     /* 746279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746282 */     // MIs[0] Operand 7
     /* 746282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746292 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9744:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746308 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746315 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 746336 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746348 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746350 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746366 */     GIR_RootConstrainSelectedInstOperands,
     /* 746367 */     // GIR_Coverage, 5275,
     /* 746367 */     GIR_EraseRootFromParent_Done,
     /* 746368 */   // Label 9832: @746368
     /* 746368 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(746468), // Rule ID 5279 //
     /* 746373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746376 */     // MIs[0] offset
     /* 746376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746379 */     // MIs[0] auxiliary
     /* 746379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746382 */     // MIs[0] Operand 7
     /* 746382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746392 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9744:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746408 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746415 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 746436 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746448 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746450 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746466 */     GIR_RootConstrainSelectedInstOperands,
     /* 746467 */     // GIR_Coverage, 5279,
     /* 746467 */     GIR_EraseRootFromParent_Done,
     /* 746468 */   // Label 9833: @746468
     /* 746468 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(746568), // Rule ID 5299 //
     /* 746473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746476 */     // MIs[0] offset
     /* 746476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746479 */     // MIs[0] auxiliary
     /* 746479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746482 */     // MIs[0] Operand 7
     /* 746482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746492 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9744:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746508 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746515 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 746536 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746548 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746550 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746556 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746566 */     GIR_RootConstrainSelectedInstOperands,
     /* 746567 */     // GIR_Coverage, 5299,
     /* 746567 */     GIR_EraseRootFromParent_Done,
     /* 746568 */   // Label 9834: @746568
     /* 746568 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(746668), // Rule ID 5303 //
     /* 746573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746576 */     // MIs[0] offset
     /* 746576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746579 */     // MIs[0] auxiliary
     /* 746579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746582 */     // MIs[0] Operand 7
     /* 746582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746592 */     // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746608 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746615 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 746636 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746648 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746650 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746666 */     GIR_RootConstrainSelectedInstOperands,
     /* 746667 */     // GIR_Coverage, 5303,
     /* 746667 */     GIR_EraseRootFromParent_Done,
     /* 746668 */   // Label 9835: @746668
     /* 746668 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(746768), // Rule ID 5307 //
     /* 746673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746676 */     // MIs[0] offset
     /* 746676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746679 */     // MIs[0] auxiliary
     /* 746679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746682 */     // MIs[0] Operand 7
     /* 746682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746692 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9744:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746708 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746715 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 746736 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746748 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746750 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746756 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746766 */     GIR_RootConstrainSelectedInstOperands,
     /* 746767 */     // GIR_Coverage, 5307,
     /* 746767 */     GIR_EraseRootFromParent_Done,
     /* 746768 */   // Label 9836: @746768
     /* 746768 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(746868), // Rule ID 5311 //
     /* 746773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 746776 */     // MIs[0] offset
     /* 746776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746779 */     // MIs[0] auxiliary
     /* 746779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746782 */     // MIs[0] Operand 7
     /* 746782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 746785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746792 */     // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 746795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 746799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 746804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 746808 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 746811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 746815 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 746818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 746823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 746833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 746836 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 746841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746848 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746866 */     GIR_RootConstrainSelectedInstOperands,
     /* 746867 */     // GIR_Coverage, 5311,
     /* 746867 */     GIR_EraseRootFromParent_Done,
     /* 746868 */   // Label 9837: @746868
     /* 746868 */   GIM_Reject,
     /* 746869 */ // Label 9813: @746869
     /* 746869 */ GIM_Reject,
     /* 746870 */ // Label 9806: @746870
     /* 746870 */ GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(747800),
     /* 746875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 746878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 746881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 746884 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 746887 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(746959), // Rule ID 5280 //
     /* 746892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 746895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746903 */     // MIs[0] offset
     /* 746903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746906 */     // MIs[0] auxiliary
     /* 746906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746909 */     // MIs[0] Operand 7
     /* 746909 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746927 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 746930 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 746932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 746934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 746939 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 746941 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 746947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 746953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 746957 */     GIR_RootConstrainSelectedInstOperands,
     /* 746958 */     // GIR_Coverage, 5280,
     /* 746958 */     GIR_EraseRootFromParent_Done,
     /* 746959 */   // Label 9839: @746959
     /* 746959 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(747031), // Rule ID 5312 //
     /* 746964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 746967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 746971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 746975 */     // MIs[0] offset
     /* 746975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 746978 */     // MIs[0] auxiliary
     /* 746978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 746981 */     // MIs[0] Operand 7
     /* 746981 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 746992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 746999 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 746999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 747002 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747011 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747013 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747019 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747029 */     GIR_RootConstrainSelectedInstOperands,
     /* 747030 */     // GIR_Coverage, 5312,
     /* 747030 */     GIR_EraseRootFromParent_Done,
     /* 747031 */   // Label 9840: @747031
     /* 747031 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(747103), // Rule ID 5316 //
     /* 747036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 747039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747047 */     // MIs[0] offset
     /* 747047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747050 */     // MIs[0] auxiliary
     /* 747050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747053 */     // MIs[0] Operand 7
     /* 747053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747071 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 747074 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747083 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747101 */     GIR_RootConstrainSelectedInstOperands,
     /* 747102 */     // GIR_Coverage, 5316,
     /* 747102 */     GIR_EraseRootFromParent_Done,
     /* 747103 */   // Label 9841: @747103
     /* 747103 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(747173), // Rule ID 5281 //
     /* 747108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 747111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747115 */     // MIs[0] offset
     /* 747115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747118 */     // MIs[0] auxiliary
     /* 747118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747121 */     // MIs[0] Operand 7
     /* 747121 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747139 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 747142 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747144 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 747146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747153 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747155 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747171 */     GIR_RootConstrainSelectedInstOperands,
     /* 747172 */     // GIR_Coverage, 5281,
     /* 747172 */     GIR_EraseRootFromParent_Done,
     /* 747173 */   // Label 9842: @747173
     /* 747173 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(747243), // Rule ID 5313 //
     /* 747178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 747181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747185 */     // MIs[0] offset
     /* 747185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747188 */     // MIs[0] auxiliary
     /* 747188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747191 */     // MIs[0] Operand 7
     /* 747191 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747209 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 747212 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747214 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 747216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747223 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747241 */     GIR_RootConstrainSelectedInstOperands,
     /* 747242 */     // GIR_Coverage, 5313,
     /* 747242 */     GIR_EraseRootFromParent_Done,
     /* 747243 */   // Label 9843: @747243
     /* 747243 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(747313), // Rule ID 5317 //
     /* 747248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 747251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747255 */     // MIs[0] offset
     /* 747255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747258 */     // MIs[0] auxiliary
     /* 747258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747261 */     // MIs[0] Operand 7
     /* 747261 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747279 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 747282 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747284 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 747286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747293 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747295 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747301 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747311 */     GIR_RootConstrainSelectedInstOperands,
     /* 747312 */     // GIR_Coverage, 5317,
     /* 747312 */     GIR_EraseRootFromParent_Done,
     /* 747313 */   // Label 9844: @747313
     /* 747313 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(747375), // Rule ID 5282 //
     /* 747318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 747321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747325 */     // MIs[0] offset
     /* 747325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747328 */     // MIs[0] auxiliary
     /* 747328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747331 */     // MIs[0] Operand 7
     /* 747331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747341 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 747344 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747346 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747355 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747373 */     GIR_RootConstrainSelectedInstOperands,
     /* 747374 */     // GIR_Coverage, 5282,
     /* 747374 */     GIR_EraseRootFromParent_Done,
     /* 747375 */   // Label 9845: @747375
     /* 747375 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(747437), // Rule ID 5314 //
     /* 747380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 747383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747387 */     // MIs[0] offset
     /* 747387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747390 */     // MIs[0] auxiliary
     /* 747390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747393 */     // MIs[0] Operand 7
     /* 747393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747403 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 747406 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747408 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747435 */     GIR_RootConstrainSelectedInstOperands,
     /* 747436 */     // GIR_Coverage, 5314,
     /* 747436 */     GIR_EraseRootFromParent_Done,
     /* 747437 */   // Label 9846: @747437
     /* 747437 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(747499), // Rule ID 5318 //
     /* 747442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 747445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747449 */     // MIs[0] offset
     /* 747449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747452 */     // MIs[0] auxiliary
     /* 747452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747455 */     // MIs[0] Operand 7
     /* 747455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747465 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 747468 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747470 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 747472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747479 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747487 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747497 */     GIR_RootConstrainSelectedInstOperands,
     /* 747498 */     // GIR_Coverage, 5318,
     /* 747498 */     GIR_EraseRootFromParent_Done,
     /* 747499 */   // Label 9847: @747499
     /* 747499 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(747599), // Rule ID 5283 //
     /* 747504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 747507 */     // MIs[0] offset
     /* 747507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747510 */     // MIs[0] auxiliary
     /* 747510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747513 */     // MIs[0] Operand 7
     /* 747513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747523 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747539 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747546 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 747567 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747579 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747587 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747597 */     GIR_RootConstrainSelectedInstOperands,
     /* 747598 */     // GIR_Coverage, 5283,
     /* 747598 */     GIR_EraseRootFromParent_Done,
     /* 747599 */   // Label 9848: @747599
     /* 747599 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(747699), // Rule ID 5315 //
     /* 747604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 747607 */     // MIs[0] offset
     /* 747607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747610 */     // MIs[0] auxiliary
     /* 747610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747613 */     // MIs[0] Operand 7
     /* 747613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747623 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747639 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747646 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 747667 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747679 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747681 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747697 */     GIR_RootConstrainSelectedInstOperands,
     /* 747698 */     // GIR_Coverage, 5315,
     /* 747698 */     GIR_EraseRootFromParent_Done,
     /* 747699 */   // Label 9849: @747699
     /* 747699 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(747799), // Rule ID 5319 //
     /* 747704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 747707 */     // MIs[0] offset
     /* 747707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747710 */     // MIs[0] auxiliary
     /* 747710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747713 */     // MIs[0] Operand 7
     /* 747713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 747716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747723 */     // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 747726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 747730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 747735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 747739 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 747742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 747746 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 747749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 747754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 747764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 747767 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 747772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747779 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747781 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747797 */     GIR_RootConstrainSelectedInstOperands,
     /* 747798 */     // GIR_Coverage, 5319,
     /* 747798 */     GIR_EraseRootFromParent_Done,
     /* 747799 */   // Label 9850: @747799
     /* 747799 */   GIM_Reject,
     /* 747800 */ // Label 9838: @747800
     /* 747800 */ GIM_Reject,
     /* 747801 */ // Label 9807: @747801
     /* 747801 */ GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(749035),
     /* 747806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 747809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 747812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 747815 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 747818 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(747890), // Rule ID 5320 //
     /* 747823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 747826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747834 */     // MIs[0] offset
     /* 747834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747837 */     // MIs[0] auxiliary
     /* 747837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747840 */     // MIs[0] Operand 7
     /* 747840 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747858 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9744:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 747861 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747870 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747872 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747888 */     GIR_RootConstrainSelectedInstOperands,
     /* 747889 */     // GIR_Coverage, 5320,
     /* 747889 */     GIR_EraseRootFromParent_Done,
     /* 747890 */   // Label 9852: @747890
     /* 747890 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(747962), // Rule ID 5324 //
     /* 747895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 747898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747906 */     // MIs[0] offset
     /* 747906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747909 */     // MIs[0] auxiliary
     /* 747909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747912 */     // MIs[0] Operand 7
     /* 747912 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 747930 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9744:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 747930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 747933 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 747935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 747937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 747942 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 747944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 747950 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 747956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 747960 */     GIR_RootConstrainSelectedInstOperands,
     /* 747961 */     // GIR_Coverage, 5324,
     /* 747961 */     GIR_EraseRootFromParent_Done,
     /* 747962 */   // Label 9853: @747962
     /* 747962 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(748034), // Rule ID 5328 //
     /* 747967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 747970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 747974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 747978 */     // MIs[0] offset
     /* 747978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 747981 */     // MIs[0] auxiliary
     /* 747981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 747984 */     // MIs[0] Operand 7
     /* 747984 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 747995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748002 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9744:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 748005 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748014 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748032 */     GIR_RootConstrainSelectedInstOperands,
     /* 748033 */     // GIR_Coverage, 5328,
     /* 748033 */     GIR_EraseRootFromParent_Done,
     /* 748034 */   // Label 9854: @748034
     /* 748034 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(748106), // Rule ID 5332 //
     /* 748039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 748042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 748046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 748050 */     // MIs[0] offset
     /* 748050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748053 */     // MIs[0] auxiliary
     /* 748053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748056 */     // MIs[0] Operand 7
     /* 748056 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 748067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748074 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9744:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 748077 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748086 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748104 */     GIR_RootConstrainSelectedInstOperands,
     /* 748105 */     // GIR_Coverage, 5332,
     /* 748105 */     GIR_EraseRootFromParent_Done,
     /* 748106 */   // Label 9855: @748106
     /* 748106 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(748176), // Rule ID 5321 //
     /* 748111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 748114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 748118 */     // MIs[0] offset
     /* 748118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748121 */     // MIs[0] auxiliary
     /* 748121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748124 */     // MIs[0] Operand 7
     /* 748124 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 748135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748142 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 748145 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748147 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 748149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748156 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748158 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748164 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748174 */     GIR_RootConstrainSelectedInstOperands,
     /* 748175 */     // GIR_Coverage, 5321,
     /* 748175 */     GIR_EraseRootFromParent_Done,
     /* 748176 */   // Label 9856: @748176
     /* 748176 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(748246), // Rule ID 5325 //
     /* 748181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 748184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 748188 */     // MIs[0] offset
     /* 748188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748191 */     // MIs[0] auxiliary
     /* 748191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748194 */     // MIs[0] Operand 7
     /* 748194 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 748205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748212 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 748215 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748217 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 748219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748226 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748234 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748244 */     GIR_RootConstrainSelectedInstOperands,
     /* 748245 */     // GIR_Coverage, 5325,
     /* 748245 */     GIR_EraseRootFromParent_Done,
     /* 748246 */   // Label 9857: @748246
     /* 748246 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(748316), // Rule ID 5329 //
     /* 748251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 748254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 748258 */     // MIs[0] offset
     /* 748258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748261 */     // MIs[0] auxiliary
     /* 748261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748264 */     // MIs[0] Operand 7
     /* 748264 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 748275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748282 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 748285 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748287 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 748289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748296 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748298 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748304 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748314 */     GIR_RootConstrainSelectedInstOperands,
     /* 748315 */     // GIR_Coverage, 5329,
     /* 748315 */     GIR_EraseRootFromParent_Done,
     /* 748316 */   // Label 9858: @748316
     /* 748316 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(748386), // Rule ID 5333 //
     /* 748321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 748324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 748328 */     // MIs[0] offset
     /* 748328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748331 */     // MIs[0] auxiliary
     /* 748331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748334 */     // MIs[0] Operand 7
     /* 748334 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 748345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748352 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 748355 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748357 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 748359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748366 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748384 */     GIR_RootConstrainSelectedInstOperands,
     /* 748385 */     // GIR_Coverage, 5333,
     /* 748385 */     GIR_EraseRootFromParent_Done,
     /* 748386 */   // Label 9859: @748386
     /* 748386 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(748448), // Rule ID 5322 //
     /* 748391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 748394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 748398 */     // MIs[0] offset
     /* 748398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748401 */     // MIs[0] auxiliary
     /* 748401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748404 */     // MIs[0] Operand 7
     /* 748404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748414 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 748417 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748419 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 748421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748446 */     GIR_RootConstrainSelectedInstOperands,
     /* 748447 */     // GIR_Coverage, 5322,
     /* 748447 */     GIR_EraseRootFromParent_Done,
     /* 748448 */   // Label 9860: @748448
     /* 748448 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(748510), // Rule ID 5326 //
     /* 748453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 748456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 748460 */     // MIs[0] offset
     /* 748460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748463 */     // MIs[0] auxiliary
     /* 748463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748466 */     // MIs[0] Operand 7
     /* 748466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748476 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 748479 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748481 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 748483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748490 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748508 */     GIR_RootConstrainSelectedInstOperands,
     /* 748509 */     // GIR_Coverage, 5326,
     /* 748509 */     GIR_EraseRootFromParent_Done,
     /* 748510 */   // Label 9861: @748510
     /* 748510 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(748572), // Rule ID 5330 //
     /* 748515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 748518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 748522 */     // MIs[0] offset
     /* 748522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748525 */     // MIs[0] auxiliary
     /* 748525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748528 */     // MIs[0] Operand 7
     /* 748528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748538 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 748541 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748543 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 748545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748552 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748560 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748570 */     GIR_RootConstrainSelectedInstOperands,
     /* 748571 */     // GIR_Coverage, 5330,
     /* 748571 */     GIR_EraseRootFromParent_Done,
     /* 748572 */   // Label 9862: @748572
     /* 748572 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(748634), // Rule ID 5334 //
     /* 748577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 748580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 748584 */     // MIs[0] offset
     /* 748584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748587 */     // MIs[0] auxiliary
     /* 748587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748590 */     // MIs[0] Operand 7
     /* 748590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748600 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 748603 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748605 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 748607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748614 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748616 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748622 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748632 */     GIR_RootConstrainSelectedInstOperands,
     /* 748633 */     // GIR_Coverage, 5334,
     /* 748633 */     GIR_EraseRootFromParent_Done,
     /* 748634 */   // Label 9863: @748634
     /* 748634 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(748734), // Rule ID 5323 //
     /* 748639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 748642 */     // MIs[0] offset
     /* 748642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748645 */     // MIs[0] auxiliary
     /* 748645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748648 */     // MIs[0] Operand 7
     /* 748648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748658 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 748661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 748665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 748674 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 748677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 748681 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 748684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 748689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 748702 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 748707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748714 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748716 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748722 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748732 */     GIR_RootConstrainSelectedInstOperands,
     /* 748733 */     // GIR_Coverage, 5323,
     /* 748733 */     GIR_EraseRootFromParent_Done,
     /* 748734 */   // Label 9864: @748734
     /* 748734 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(748834), // Rule ID 5327 //
     /* 748739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 748742 */     // MIs[0] offset
     /* 748742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748745 */     // MIs[0] auxiliary
     /* 748745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748748 */     // MIs[0] Operand 7
     /* 748748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748758 */     // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 748761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 748765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 748774 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 748777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 748781 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 748784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 748789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 748802 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 748807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748814 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748822 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748832 */     GIR_RootConstrainSelectedInstOperands,
     /* 748833 */     // GIR_Coverage, 5327,
     /* 748833 */     GIR_EraseRootFromParent_Done,
     /* 748834 */   // Label 9865: @748834
     /* 748834 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(748934), // Rule ID 5331 //
     /* 748839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 748842 */     // MIs[0] offset
     /* 748842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748845 */     // MIs[0] auxiliary
     /* 748845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748848 */     // MIs[0] Operand 7
     /* 748848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748858 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 748861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 748865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 748874 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 748877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 748881 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 748884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 748889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 748902 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 748904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 748907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 748909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 748914 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 748916 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 748922 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 748928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 748932 */     GIR_RootConstrainSelectedInstOperands,
     /* 748933 */     // GIR_Coverage, 5331,
     /* 748933 */     GIR_EraseRootFromParent_Done,
     /* 748934 */   // Label 9866: @748934
     /* 748934 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(749034), // Rule ID 5335 //
     /* 748939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 748942 */     // MIs[0] offset
     /* 748942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 748945 */     // MIs[0] auxiliary
     /* 748945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 748948 */     // MIs[0] Operand 7
     /* 748948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 748951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 748958 */     // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 748958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 748961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 748965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 748970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 748974 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 748977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 748981 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 748984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 748989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 748999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 749002 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 749007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749014 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749032 */     GIR_RootConstrainSelectedInstOperands,
     /* 749033 */     // GIR_Coverage, 5335,
     /* 749033 */     GIR_EraseRootFromParent_Done,
     /* 749034 */   // Label 9867: @749034
     /* 749034 */   GIM_Reject,
     /* 749035 */ // Label 9851: @749035
     /* 749035 */ GIM_Reject,
     /* 749036 */ // Label 9808: @749036
     /* 749036 */ GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(749358),
     /* 749041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 749044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 749050 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 749053 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(749125), // Rule ID 5284 //
     /* 749058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749069 */     // MIs[0] offset
     /* 749069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749072 */     // MIs[0] auxiliary
     /* 749072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749075 */     // MIs[0] Operand 7
     /* 749075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749093 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
     /* 749096 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749105 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749107 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749113 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749123 */     GIR_RootConstrainSelectedInstOperands,
     /* 749124 */     // GIR_Coverage, 5284,
     /* 749124 */     GIR_EraseRootFromParent_Done,
     /* 749125 */   // Label 9869: @749125
     /* 749125 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(749195), // Rule ID 5285 //
     /* 749130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749137 */     // MIs[0] offset
     /* 749137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749140 */     // MIs[0] auxiliary
     /* 749140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749143 */     // MIs[0] Operand 7
     /* 749143 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749161 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
     /* 749164 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749166 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 749168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749175 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749177 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749183 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749193 */     GIR_RootConstrainSelectedInstOperands,
     /* 749194 */     // GIR_Coverage, 5285,
     /* 749194 */     GIR_EraseRootFromParent_Done,
     /* 749195 */   // Label 9870: @749195
     /* 749195 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(749257), // Rule ID 5286 //
     /* 749200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749207 */     // MIs[0] offset
     /* 749207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749210 */     // MIs[0] auxiliary
     /* 749210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749213 */     // MIs[0] Operand 7
     /* 749213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 749216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749223 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
     /* 749226 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749228 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 749230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749237 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749255 */     GIR_RootConstrainSelectedInstOperands,
     /* 749256 */     // GIR_Coverage, 5286,
     /* 749256 */     GIR_EraseRootFromParent_Done,
     /* 749257 */   // Label 9871: @749257
     /* 749257 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(749357), // Rule ID 5287 //
     /* 749262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749265 */     // MIs[0] offset
     /* 749265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749268 */     // MIs[0] auxiliary
     /* 749268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749271 */     // MIs[0] Operand 7
     /* 749271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 749274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749281 */     // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 749284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 749288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 749293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 749297 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 749300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 749304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 749307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 749312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
     /* 749325 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 749330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749337 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749339 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749345 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749355 */     GIR_RootConstrainSelectedInstOperands,
     /* 749356 */     // GIR_Coverage, 5287,
     /* 749356 */     GIR_EraseRootFromParent_Done,
     /* 749357 */   // Label 9872: @749357
     /* 749357 */   GIM_Reject,
     /* 749358 */ // Label 9868: @749358
     /* 749358 */ GIM_Reject,
     /* 749359 */ // Label 9809: @749359
     /* 749359 */ GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(749681),
     /* 749364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 749367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 749373 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 749376 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(749448), // Rule ID 5288 //
     /* 749381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749392 */     // MIs[0] offset
     /* 749392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749395 */     // MIs[0] auxiliary
     /* 749395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749398 */     // MIs[0] Operand 7
     /* 749398 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749416 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
     /* 749419 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749446 */     GIR_RootConstrainSelectedInstOperands,
     /* 749447 */     // GIR_Coverage, 5288,
     /* 749447 */     GIR_EraseRootFromParent_Done,
     /* 749448 */   // Label 9874: @749448
     /* 749448 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(749518), // Rule ID 5289 //
     /* 749453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749460 */     // MIs[0] offset
     /* 749460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749463 */     // MIs[0] auxiliary
     /* 749463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749466 */     // MIs[0] Operand 7
     /* 749466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749484 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
     /* 749487 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749489 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 749491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749498 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749500 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749506 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749516 */     GIR_RootConstrainSelectedInstOperands,
     /* 749517 */     // GIR_Coverage, 5289,
     /* 749517 */     GIR_EraseRootFromParent_Done,
     /* 749518 */   // Label 9875: @749518
     /* 749518 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(749580), // Rule ID 5290 //
     /* 749523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749530 */     // MIs[0] offset
     /* 749530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749533 */     // MIs[0] auxiliary
     /* 749533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749536 */     // MIs[0] Operand 7
     /* 749536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 749539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749546 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
     /* 749549 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749551 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 749553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749560 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749562 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749568 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749578 */     GIR_RootConstrainSelectedInstOperands,
     /* 749579 */     // GIR_Coverage, 5290,
     /* 749579 */     GIR_EraseRootFromParent_Done,
     /* 749580 */   // Label 9876: @749580
     /* 749580 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(749680), // Rule ID 5291 //
     /* 749585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 749588 */     // MIs[0] offset
     /* 749588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749591 */     // MIs[0] auxiliary
     /* 749591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749594 */     // MIs[0] Operand 7
     /* 749594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 749597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749604 */     // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 749607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 749611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 749616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 749620 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 749623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 749627 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 749630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 749635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 749645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
     /* 749648 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 749653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749660 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749678 */     GIR_RootConstrainSelectedInstOperands,
     /* 749679 */     // GIR_Coverage, 5291,
     /* 749679 */     GIR_EraseRootFromParent_Done,
     /* 749680 */   // Label 9877: @749680
     /* 749680 */   GIM_Reject,
     /* 749681 */ // Label 9873: @749681
     /* 749681 */ GIM_Reject,
     /* 749682 */ // Label 9810: @749682
     /* 749682 */ GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(752244),
     /* 749687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 749690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 749693 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 749696 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 749699 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(749778), // Rule ID 5336 //
     /* 749704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 749707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 749714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749722 */     // MIs[0] offset
     /* 749722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749725 */     // MIs[0] auxiliary
     /* 749725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749728 */     // MIs[0] Operand 7
     /* 749728 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749746 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_OFFSET_exact),
     /* 749749 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749758 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749766 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749776 */     GIR_RootConstrainSelectedInstOperands,
     /* 749777 */     // GIR_Coverage, 5336,
     /* 749777 */     GIR_EraseRootFromParent_Done,
     /* 749778 */   // Label 9879: @749778
     /* 749778 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(749857), // Rule ID 5340 //
     /* 749783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 749786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 749793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749801 */     // MIs[0] offset
     /* 749801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749804 */     // MIs[0] auxiliary
     /* 749804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749807 */     // MIs[0] Operand 7
     /* 749807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749825 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFSET_exact),
     /* 749828 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749837 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749839 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749855 */     GIR_RootConstrainSelectedInstOperands,
     /* 749856 */     // GIR_Coverage, 5340,
     /* 749856 */     GIR_EraseRootFromParent_Done,
     /* 749857 */   // Label 9880: @749857
     /* 749857 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(749936), // Rule ID 5344 //
     /* 749862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 749865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 749872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749880 */     // MIs[0] offset
     /* 749880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749883 */     // MIs[0] auxiliary
     /* 749883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749886 */     // MIs[0] Operand 7
     /* 749886 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749904 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_OFFSET_exact anonymous_9743:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_OFFSET_exact),
     /* 749907 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749916 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 749924 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 749930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 749934 */     GIR_RootConstrainSelectedInstOperands,
     /* 749935 */     // GIR_Coverage, 5344,
     /* 749935 */     GIR_EraseRootFromParent_Done,
     /* 749936 */   // Label 9881: @749936
     /* 749936 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(750015), // Rule ID 5348 //
     /* 749941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 749944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 749951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 749955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 749959 */     // MIs[0] offset
     /* 749959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 749962 */     // MIs[0] auxiliary
     /* 749962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 749965 */     // MIs[0] Operand 7
     /* 749965 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 749976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 749983 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 749983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFSET_exact),
     /* 749986 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 749988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 749990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 749995 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 749997 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750003 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750013 */     GIR_RootConstrainSelectedInstOperands,
     /* 750014 */     // GIR_Coverage, 5348,
     /* 750014 */     GIR_EraseRootFromParent_Done,
     /* 750015 */   // Label 9882: @750015
     /* 750015 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(750087), // Rule ID 5352 //
     /* 750020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 750023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 750031 */     // MIs[0] offset
     /* 750031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750034 */     // MIs[0] auxiliary
     /* 750034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750037 */     // MIs[0] Operand 7
     /* 750037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750055 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 750058 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750067 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750069 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750075 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750085 */     GIR_RootConstrainSelectedInstOperands,
     /* 750086 */     // GIR_Coverage, 5352,
     /* 750086 */     GIR_EraseRootFromParent_Done,
     /* 750087 */   // Label 9883: @750087
     /* 750087 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(750159), // Rule ID 5356 //
     /* 750092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 750095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 750103 */     // MIs[0] offset
     /* 750103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750106 */     // MIs[0] auxiliary
     /* 750106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750109 */     // MIs[0] Operand 7
     /* 750109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750127 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 750130 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750139 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750157 */     GIR_RootConstrainSelectedInstOperands,
     /* 750158 */     // GIR_Coverage, 5356,
     /* 750158 */     GIR_EraseRootFromParent_Done,
     /* 750159 */   // Label 9884: @750159
     /* 750159 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(750231), // Rule ID 5360 //
     /* 750164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 750167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 750175 */     // MIs[0] offset
     /* 750175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750178 */     // MIs[0] auxiliary
     /* 750178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750181 */     // MIs[0] Operand 7
     /* 750181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750199 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9743:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 750202 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750211 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750213 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750219 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750229 */     GIR_RootConstrainSelectedInstOperands,
     /* 750230 */     // GIR_Coverage, 5360,
     /* 750230 */     GIR_EraseRootFromParent_Done,
     /* 750231 */   // Label 9885: @750231
     /* 750231 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(750303), // Rule ID 5364 //
     /* 750236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 750239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 750247 */     // MIs[0] offset
     /* 750247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750250 */     // MIs[0] auxiliary
     /* 750250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750253 */     // MIs[0] Operand 7
     /* 750253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750271 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 750274 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750283 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750285 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750291 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750301 */     GIR_RootConstrainSelectedInstOperands,
     /* 750302 */     // GIR_Coverage, 5364,
     /* 750302 */     GIR_EraseRootFromParent_Done,
     /* 750303 */   // Label 9886: @750303
     /* 750303 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(750380), // Rule ID 5337 //
     /* 750308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 750311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 750318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750322 */     // MIs[0] offset
     /* 750322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750325 */     // MIs[0] auxiliary
     /* 750325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750328 */     // MIs[0] Operand 7
     /* 750328 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750346 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_OFFEN_exact),
     /* 750349 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750351 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750360 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750378 */     GIR_RootConstrainSelectedInstOperands,
     /* 750379 */     // GIR_Coverage, 5337,
     /* 750379 */     GIR_EraseRootFromParent_Done,
     /* 750380 */   // Label 9887: @750380
     /* 750380 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(750457), // Rule ID 5341 //
     /* 750385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 750388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 750395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750399 */     // MIs[0] offset
     /* 750399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750402 */     // MIs[0] auxiliary
     /* 750402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750405 */     // MIs[0] Operand 7
     /* 750405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750423 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFEN_exact),
     /* 750426 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750428 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750437 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750445 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750455 */     GIR_RootConstrainSelectedInstOperands,
     /* 750456 */     // GIR_Coverage, 5341,
     /* 750456 */     GIR_EraseRootFromParent_Done,
     /* 750457 */   // Label 9888: @750457
     /* 750457 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(750534), // Rule ID 5345 //
     /* 750462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 750465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 750472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750476 */     // MIs[0] offset
     /* 750476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750479 */     // MIs[0] auxiliary
     /* 750479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750482 */     // MIs[0] Operand 7
     /* 750482 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750500 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_OFFEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_OFFEN_exact),
     /* 750503 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750505 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750514 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750516 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750522 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750532 */     GIR_RootConstrainSelectedInstOperands,
     /* 750533 */     // GIR_Coverage, 5345,
     /* 750533 */     GIR_EraseRootFromParent_Done,
     /* 750534 */   // Label 9889: @750534
     /* 750534 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(750611), // Rule ID 5349 //
     /* 750539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 750542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 750549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750553 */     // MIs[0] offset
     /* 750553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750556 */     // MIs[0] auxiliary
     /* 750556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750559 */     // MIs[0] Operand 7
     /* 750559 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750577 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFEN_exact),
     /* 750580 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750582 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750591 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750593 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750599 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750609 */     GIR_RootConstrainSelectedInstOperands,
     /* 750610 */     // GIR_Coverage, 5349,
     /* 750610 */     GIR_EraseRootFromParent_Done,
     /* 750611 */   // Label 9890: @750611
     /* 750611 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(750681), // Rule ID 5353 //
     /* 750616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 750619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750623 */     // MIs[0] offset
     /* 750623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750626 */     // MIs[0] auxiliary
     /* 750626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750629 */     // MIs[0] Operand 7
     /* 750629 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750647 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 750650 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750652 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750661 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750663 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750669 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750679 */     GIR_RootConstrainSelectedInstOperands,
     /* 750680 */     // GIR_Coverage, 5353,
     /* 750680 */     GIR_EraseRootFromParent_Done,
     /* 750681 */   // Label 9891: @750681
     /* 750681 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(750751), // Rule ID 5357 //
     /* 750686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 750689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750693 */     // MIs[0] offset
     /* 750693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750696 */     // MIs[0] auxiliary
     /* 750696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750699 */     // MIs[0] Operand 7
     /* 750699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750717 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 750720 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750722 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750731 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750739 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750749 */     GIR_RootConstrainSelectedInstOperands,
     /* 750750 */     // GIR_Coverage, 5357,
     /* 750750 */     GIR_EraseRootFromParent_Done,
     /* 750751 */   // Label 9892: @750751
     /* 750751 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(750821), // Rule ID 5361 //
     /* 750756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 750759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750763 */     // MIs[0] offset
     /* 750763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750766 */     // MIs[0] auxiliary
     /* 750766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750769 */     // MIs[0] Operand 7
     /* 750769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750787 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 750790 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750792 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750801 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750803 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750819 */     GIR_RootConstrainSelectedInstOperands,
     /* 750820 */     // GIR_Coverage, 5361,
     /* 750820 */     GIR_EraseRootFromParent_Done,
     /* 750821 */   // Label 9893: @750821
     /* 750821 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(750891), // Rule ID 5365 //
     /* 750826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 750829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 750833 */     // MIs[0] offset
     /* 750833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750836 */     // MIs[0] auxiliary
     /* 750836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750839 */     // MIs[0] Operand 7
     /* 750839 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 750850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750857 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 750860 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750862 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 750864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750871 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750889 */     GIR_RootConstrainSelectedInstOperands,
     /* 750890 */     // GIR_Coverage, 5365,
     /* 750890 */     GIR_EraseRootFromParent_Done,
     /* 750891 */   // Label 9894: @750891
     /* 750891 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(750960), // Rule ID 5338 //
     /* 750896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 750899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 750906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 750910 */     // MIs[0] offset
     /* 750910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750913 */     // MIs[0] auxiliary
     /* 750913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750916 */     // MIs[0] Operand 7
     /* 750916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 750919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750926 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_IDXEN_exact),
     /* 750929 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 750931 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 750933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 750935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 750940 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 750942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 750948 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 750954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 750958 */     GIR_RootConstrainSelectedInstOperands,
     /* 750959 */     // GIR_Coverage, 5338,
     /* 750959 */     GIR_EraseRootFromParent_Done,
     /* 750960 */   // Label 9895: @750960
     /* 750960 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(751029), // Rule ID 5342 //
     /* 750965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 750968 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 750975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 750979 */     // MIs[0] offset
     /* 750979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 750982 */     // MIs[0] auxiliary
     /* 750982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 750985 */     // MIs[0] Operand 7
     /* 750985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 750988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 750995 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 750995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_IDXEN_exact),
     /* 750998 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751000 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 751002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751009 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751027 */     GIR_RootConstrainSelectedInstOperands,
     /* 751028 */     // GIR_Coverage, 5342,
     /* 751028 */     GIR_EraseRootFromParent_Done,
     /* 751029 */   // Label 9896: @751029
     /* 751029 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(751098), // Rule ID 5346 //
     /* 751034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 751037 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 751044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 751048 */     // MIs[0] offset
     /* 751048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751051 */     // MIs[0] auxiliary
     /* 751051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751054 */     // MIs[0] Operand 7
     /* 751054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751064 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_IDXEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_IDXEN_exact),
     /* 751067 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751069 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 751071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751078 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751080 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751086 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751096 */     GIR_RootConstrainSelectedInstOperands,
     /* 751097 */     // GIR_Coverage, 5346,
     /* 751097 */     GIR_EraseRootFromParent_Done,
     /* 751098 */   // Label 9897: @751098
     /* 751098 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(751167), // Rule ID 5350 //
     /* 751103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 751106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 751113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 751117 */     // MIs[0] offset
     /* 751117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751120 */     // MIs[0] auxiliary
     /* 751120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751123 */     // MIs[0] Operand 7
     /* 751123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751133 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_IDXEN_exact),
     /* 751136 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751138 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 751140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751147 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751149 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751155 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751165 */     GIR_RootConstrainSelectedInstOperands,
     /* 751166 */     // GIR_Coverage, 5350,
     /* 751166 */     GIR_EraseRootFromParent_Done,
     /* 751167 */   // Label 9898: @751167
     /* 751167 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(751229), // Rule ID 5354 //
     /* 751172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 751175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 751179 */     // MIs[0] offset
     /* 751179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751182 */     // MIs[0] auxiliary
     /* 751182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751185 */     // MIs[0] Operand 7
     /* 751185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751195 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 751198 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751200 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 751202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751209 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751211 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751217 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751227 */     GIR_RootConstrainSelectedInstOperands,
     /* 751228 */     // GIR_Coverage, 5354,
     /* 751228 */     GIR_EraseRootFromParent_Done,
     /* 751229 */   // Label 9899: @751229
     /* 751229 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(751291), // Rule ID 5358 //
     /* 751234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 751237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 751241 */     // MIs[0] offset
     /* 751241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751244 */     // MIs[0] auxiliary
     /* 751244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751247 */     // MIs[0] Operand 7
     /* 751247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751257 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 751260 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751262 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 751264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751271 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751273 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751279 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751289 */     GIR_RootConstrainSelectedInstOperands,
     /* 751290 */     // GIR_Coverage, 5358,
     /* 751290 */     GIR_EraseRootFromParent_Done,
     /* 751291 */   // Label 9900: @751291
     /* 751291 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(751353), // Rule ID 5362 //
     /* 751296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 751299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 751303 */     // MIs[0] offset
     /* 751303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751306 */     // MIs[0] auxiliary
     /* 751306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751309 */     // MIs[0] Operand 7
     /* 751309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751319 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 751322 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751324 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 751326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751333 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751335 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751341 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751351 */     GIR_RootConstrainSelectedInstOperands,
     /* 751352 */     // GIR_Coverage, 5362,
     /* 751352 */     GIR_EraseRootFromParent_Done,
     /* 751353 */   // Label 9901: @751353
     /* 751353 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(751415), // Rule ID 5366 //
     /* 751358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 751361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 751365 */     // MIs[0] offset
     /* 751365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751368 */     // MIs[0] auxiliary
     /* 751368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751371 */     // MIs[0] Operand 7
     /* 751371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751381 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 751384 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751386 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 751388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751395 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751413 */     GIR_RootConstrainSelectedInstOperands,
     /* 751414 */     // GIR_Coverage, 5366,
     /* 751414 */     GIR_EraseRootFromParent_Done,
     /* 751415 */   // Label 9902: @751415
     /* 751415 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(751522), // Rule ID 5339 //
     /* 751420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 751423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 751430 */     // MIs[0] offset
     /* 751430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751433 */     // MIs[0] auxiliary
     /* 751433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751436 */     // MIs[0] Operand 7
     /* 751436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751446 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 751449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 751453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 751458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 751462 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 751465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 751469 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 751472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 751477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_BOTHEN_exact),
     /* 751490 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 751495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751502 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751504 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751510 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751520 */     GIR_RootConstrainSelectedInstOperands,
     /* 751521 */     // GIR_Coverage, 5339,
     /* 751521 */     GIR_EraseRootFromParent_Done,
     /* 751522 */   // Label 9903: @751522
     /* 751522 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(751629), // Rule ID 5343 //
     /* 751527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 751530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 751537 */     // MIs[0] offset
     /* 751537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751540 */     // MIs[0] auxiliary
     /* 751540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751543 */     // MIs[0] Operand 7
     /* 751543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751553 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31940>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 751556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 751560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 751565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 751569 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 751572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 751576 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 751579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 751584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_BOTHEN_exact),
     /* 751597 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 751602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751609 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751611 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751617 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751627 */     GIR_RootConstrainSelectedInstOperands,
     /* 751628 */     // GIR_Coverage, 5343,
     /* 751628 */     GIR_EraseRootFromParent_Done,
     /* 751629 */   // Label 9904: @751629
     /* 751629 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(751736), // Rule ID 5347 //
     /* 751634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 751637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 751644 */     // MIs[0] offset
     /* 751644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751647 */     // MIs[0] auxiliary
     /* 751647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751650 */     // MIs[0] Operand 7
     /* 751650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751660 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_BOTHEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 751663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 751667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 751672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 751676 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 751679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 751683 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 751686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 751691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_BOTHEN_exact),
     /* 751704 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 751709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751716 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751734 */     GIR_RootConstrainSelectedInstOperands,
     /* 751735 */     // GIR_Coverage, 5347,
     /* 751735 */     GIR_EraseRootFromParent_Done,
     /* 751736 */   // Label 9905: @751736
     /* 751736 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(751843), // Rule ID 5351 //
     /* 751741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 751744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 751751 */     // MIs[0] offset
     /* 751751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751754 */     // MIs[0] auxiliary
     /* 751754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751757 */     // MIs[0] Operand 7
     /* 751757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751767 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_31950>>  =>  (BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 751770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 751774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 751779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 751783 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 751786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 751790 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 751793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 751798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_BOTHEN_exact),
     /* 751811 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 751816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751823 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751825 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751841 */     GIR_RootConstrainSelectedInstOperands,
     /* 751842 */     // GIR_Coverage, 5351,
     /* 751842 */     GIR_EraseRootFromParent_Done,
     /* 751843 */   // Label 9906: @751843
     /* 751843 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(751943), // Rule ID 5355 //
     /* 751848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 751851 */     // MIs[0] offset
     /* 751851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751854 */     // MIs[0] auxiliary
     /* 751854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751857 */     // MIs[0] Operand 7
     /* 751857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751867 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 751870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 751874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 751879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 751883 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 751886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 751890 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 751893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 751898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 751908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 751911 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 751913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 751916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 751918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 751923 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 751925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 751931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 751937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 751941 */     GIR_RootConstrainSelectedInstOperands,
     /* 751942 */     // GIR_Coverage, 5355,
     /* 751942 */     GIR_EraseRootFromParent_Done,
     /* 751943 */   // Label 9907: @751943
     /* 751943 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(752043), // Rule ID 5359 //
     /* 751948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 751951 */     // MIs[0] offset
     /* 751951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 751954 */     // MIs[0] auxiliary
     /* 751954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 751957 */     // MIs[0] Operand 7
     /* 751957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 751960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 751967 */     // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 751967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 751970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 751974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 751979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 751983 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 751986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 751990 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 751993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 751998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 752011 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 752016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752023 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752025 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752031 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752041 */     GIR_RootConstrainSelectedInstOperands,
     /* 752042 */     // GIR_Coverage, 5359,
     /* 752042 */     GIR_EraseRootFromParent_Done,
     /* 752043 */   // Label 9908: @752043
     /* 752043 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(752143), // Rule ID 5363 //
     /* 752048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 752051 */     // MIs[0] offset
     /* 752051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752054 */     // MIs[0] auxiliary
     /* 752054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752057 */     // MIs[0] Operand 7
     /* 752057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752067 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 752070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 752074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 752079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 752083 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 752086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 752090 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 752093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 752098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 752111 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 752116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752123 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752141 */     GIR_RootConstrainSelectedInstOperands,
     /* 752142 */     // GIR_Coverage, 5363,
     /* 752142 */     GIR_EraseRootFromParent_Done,
     /* 752143 */   // Label 9909: @752143
     /* 752143 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(752243), // Rule ID 5367 //
     /* 752148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 752151 */     // MIs[0] offset
     /* 752151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752154 */     // MIs[0] auxiliary
     /* 752154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752157 */     // MIs[0] Operand 7
     /* 752157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752167 */     // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 752170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 752174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 752179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 752183 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 752186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 752190 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 752193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 752198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 752211 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 752216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752223 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752225 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752231 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752241 */     GIR_RootConstrainSelectedInstOperands,
     /* 752242 */     // GIR_Coverage, 5367,
     /* 752242 */     GIR_EraseRootFromParent_Done,
     /* 752243 */   // Label 9910: @752243
     /* 752243 */   GIM_Reject,
     /* 752244 */ // Label 9878: @752244
     /* 752244 */ GIM_Reject,
     /* 752245 */ // Label 9811: @752245
     /* 752245 */ GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(752567),
     /* 752250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752256 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 752259 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 752262 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(752334), // Rule ID 5292 //
     /* 752267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 752270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752278 */     // MIs[0] offset
     /* 752278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752281 */     // MIs[0] auxiliary
     /* 752281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752284 */     // MIs[0] Operand 7
     /* 752284 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 752295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752302 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
     /* 752305 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752314 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752316 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752322 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752332 */     GIR_RootConstrainSelectedInstOperands,
     /* 752333 */     // GIR_Coverage, 5292,
     /* 752333 */     GIR_EraseRootFromParent_Done,
     /* 752334 */   // Label 9912: @752334
     /* 752334 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(752404), // Rule ID 5293 //
     /* 752339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 752342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752346 */     // MIs[0] offset
     /* 752346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752349 */     // MIs[0] auxiliary
     /* 752349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752352 */     // MIs[0] Operand 7
     /* 752352 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 752363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752370 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
     /* 752373 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752375 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 752377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752384 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752386 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752392 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752402 */     GIR_RootConstrainSelectedInstOperands,
     /* 752403 */     // GIR_Coverage, 5293,
     /* 752403 */     GIR_EraseRootFromParent_Done,
     /* 752404 */   // Label 9913: @752404
     /* 752404 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(752466), // Rule ID 5294 //
     /* 752409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 752412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752416 */     // MIs[0] offset
     /* 752416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752419 */     // MIs[0] auxiliary
     /* 752419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752422 */     // MIs[0] Operand 7
     /* 752422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752432 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
     /* 752435 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752437 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 752439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752446 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752464 */     GIR_RootConstrainSelectedInstOperands,
     /* 752465 */     // GIR_Coverage, 5294,
     /* 752465 */     GIR_EraseRootFromParent_Done,
     /* 752466 */   // Label 9914: @752466
     /* 752466 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(752566), // Rule ID 5295 //
     /* 752471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 752474 */     // MIs[0] offset
     /* 752474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752477 */     // MIs[0] auxiliary
     /* 752477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752480 */     // MIs[0] Operand 7
     /* 752480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752490 */     // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 752493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 752497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 752502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 752506 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 752509 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 752513 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 752516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 752521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 752531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
     /* 752534 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 752539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752546 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752548 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752554 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752564 */     GIR_RootConstrainSelectedInstOperands,
     /* 752565 */     // GIR_Coverage, 5295,
     /* 752565 */     GIR_EraseRootFromParent_Done,
     /* 752566 */   // Label 9915: @752566
     /* 752566 */   GIM_Reject,
     /* 752567 */ // Label 9911: @752567
     /* 752567 */ GIM_Reject,
     /* 752568 */ // Label 9812: @752568
     /* 752568 */ GIM_Reject,
     /* 752569 */ // Label 142: @752569
     /* 752569 */ GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(753170),
     /* 752574 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 752577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 752580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 752583 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 752586 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 752589 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(752861),
     /* 752594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 752598 */     GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(752666), // Rule ID 5576 //
     /* 752603 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 752606 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752610 */       // MIs[0] offset
     /* 752610 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752613 */       // MIs[0] auxiliary
     /* 752613 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752616 */       // MIs[0] Operand 7
     /* 752616 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 752627 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752634 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752634 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET_exact),
     /* 752637 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752639 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752641 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752646 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752648 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752654 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752660 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752664 */       GIR_RootConstrainSelectedInstOperands,
     /* 752665 */       // GIR_Coverage, 5576,
     /* 752665 */       GIR_EraseRootFromParent_Done,
     /* 752666 */     // Label 9918: @752666
     /* 752666 */     GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(752731), // Rule ID 5580 //
     /* 752671 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752675 */       // MIs[0] offset
     /* 752675 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752678 */       // MIs[0] auxiliary
     /* 752678 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752681 */       // MIs[0] Operand 7
     /* 752681 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 752692 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752699 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact),
     /* 752702 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752704 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752706 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752711 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752713 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752719 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752725 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752729 */       GIR_RootConstrainSelectedInstOperands,
     /* 752730 */       // GIR_Coverage, 5580,
     /* 752730 */       GIR_EraseRootFromParent_Done,
     /* 752731 */     // Label 9919: @752731
     /* 752731 */     GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(752797), // Rule ID 5577 //
     /* 752736 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 752739 */       // MIs[0] offset
     /* 752739 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752742 */       // MIs[0] auxiliary
     /* 752742 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752745 */       // MIs[0] Operand 7
     /* 752745 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 752756 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752763 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752763 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN_exact),
     /* 752766 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752768 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 752770 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752772 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752777 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752779 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752785 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752791 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752795 */       GIR_RootConstrainSelectedInstOperands,
     /* 752796 */       // GIR_Coverage, 5577,
     /* 752796 */       GIR_EraseRootFromParent_Done,
     /* 752797 */     // Label 9920: @752797
     /* 752797 */     GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(752860), // Rule ID 5581 //
     /* 752802 */       // MIs[0] offset
     /* 752802 */       GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752805 */       // MIs[0] auxiliary
     /* 752805 */       GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752808 */       // MIs[0] Operand 7
     /* 752808 */       GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
     /* 752819 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752826 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752826 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact),
     /* 752829 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752831 */       GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 752833 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752835 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752840 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752842 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752848 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752854 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752858 */       GIR_RootConstrainSelectedInstOperands,
     /* 752859 */       // GIR_Coverage, 5581,
     /* 752859 */       GIR_EraseRootFromParent_Done,
     /* 752860 */     // Label 9921: @752860
     /* 752860 */     GIM_Reject,
     /* 752861 */   // Label 9917: @752861
     /* 752861 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(752975),
     /* 752866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 752870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752879 */     GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(752928), // Rule ID 5578 //
     /* 752884 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 752887 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752894 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752894 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_IDXEN_exact),
     /* 752897 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752899 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 752901 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752903 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752908 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752910 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752916 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752922 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752926 */       GIR_RootConstrainSelectedInstOperands,
     /* 752927 */       // GIR_Coverage, 5578,
     /* 752927 */       GIR_EraseRootFromParent_Done,
     /* 752928 */     // Label 9923: @752928
     /* 752928 */     GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(752974), // Rule ID 5582 //
     /* 752933 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 752940 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 752940 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact),
     /* 752943 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 752945 */       GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 752947 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 752949 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 752954 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 752956 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 752962 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 752968 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 752972 */       GIR_RootConstrainSelectedInstOperands,
     /* 752973 */       // GIR_Coverage, 5582,
     /* 752973 */       GIR_EraseRootFromParent_Done,
     /* 752974 */     // Label 9924: @752974
     /* 752974 */     GIM_Reject,
     /* 752975 */   // Label 9922: @752975
     /* 752975 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(753169),
     /* 752980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 752983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 752986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 752989 */     GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(753080), // Rule ID 5579 //
     /* 752994 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 752997 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753004 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753004 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 753007 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 753011 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753016 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 753020 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 753023 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 753027 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 753030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753040 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753045 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_BOTHEN_exact),
     /* 753048 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 753050 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753053 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753055 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753060 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753062 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753068 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753074 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753078 */       GIR_RootConstrainSelectedInstOperands,
     /* 753079 */       // GIR_Coverage, 5579,
     /* 753079 */       GIR_EraseRootFromParent_Done,
     /* 753080 */     // Label 9926: @753080
     /* 753080 */     GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(753168), // Rule ID 5583 //
     /* 753085 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 753092 */       // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 753092 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 753095 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 753099 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753104 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 753108 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 753111 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 753115 */       GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 753118 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753123 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753128 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753133 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact),
     /* 753136 */       GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 753138 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753141 */       GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 753143 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 753148 */       GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 753150 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 753156 */       GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 753162 */       GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 753166 */       GIR_RootConstrainSelectedInstOperands,
     /* 753167 */       // GIR_Coverage, 5583,
     /* 753167 */       GIR_EraseRootFromParent_Done,
     /* 753168 */     // Label 9927: @753168
     /* 753168 */     GIM_Reject,
     /* 753169 */   // Label 9925: @753169
     /* 753169 */   GIM_Reject,
     /* 753170 */ // Label 9916: @753170
     /* 753170 */ GIM_Reject,
     /* 753171 */ // Label 143: @753171
     /* 753171 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 9932*/ GIMT_Encode4(754109),
     /* 753182 */ /*GILLT_s16*//*Label 9928*/ GIMT_Encode4(753198),
     /* 753186 */ /*GILLT_s32*//*Label 9929*/ GIMT_Encode4(753367),
     /* 753190 */ /*GILLT_s64*//*Label 9930*/ GIMT_Encode4(753420),
     /* 753194 */ /*GILLT_v2s16*//*Label 9931*/ GIMT_Encode4(753530),
     /* 753198 */ // Label 9928: @753198
     /* 753198 */ GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(753366),
     /* 753203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 753206 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(753258), // Rule ID 7355 //
     /* 753211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
     /* 753214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 753225 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 753225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
     /* 753228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 753230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 753253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753256 */     GIR_RootConstrainSelectedInstOperands,
     /* 753257 */     // GIR_Coverage, 7355,
     /* 753257 */     GIR_EraseRootFromParent_Done,
     /* 753258 */   // Label 9934: @753258
     /* 753258 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(753313), // Rule ID 7356 //
     /* 753263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
     /* 753266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 753270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 753277 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 753277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
     /* 753280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 753282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 753305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753311 */     GIR_RootConstrainSelectedInstOperands,
     /* 753312 */     // GIR_Coverage, 7356,
     /* 753312 */     GIR_EraseRootFromParent_Done,
     /* 753313 */   // Label 9935: @753313
     /* 753313 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(753365), // Rule ID 7357 //
     /* 753318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
     /* 753321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 753332 */     // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 753332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
     /* 753335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 753337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 753360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753363 */     GIR_RootConstrainSelectedInstOperands,
     /* 753364 */     // GIR_Coverage, 7357,
     /* 753364 */     GIR_EraseRootFromParent_Done,
     /* 753365 */   // Label 9936: @753365
     /* 753365 */   GIM_Reject,
     /* 753366 */ // Label 9933: @753366
     /* 753366 */ GIM_Reject,
     /* 753367 */ // Label 9929: @753367
     /* 753367 */ GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(753419), // Rule ID 7352 //
     /* 753372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 753375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753379 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 753386 */   // (AMDGPUclamp:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 753386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
     /* 753389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 753391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 753414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753417 */   GIR_RootConstrainSelectedInstOperands,
     /* 753418 */   // GIR_Coverage, 7352,
     /* 753418 */   GIR_EraseRootFromParent_Done,
     /* 753419 */ // Label 9937: @753419
     /* 753419 */ GIM_Reject,
     /* 753420 */ // Label 9930: @753420
     /* 753420 */ GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(753529),
     /* 753425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 753428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 753432 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(753480), // Rule ID 7353 //
     /* 753437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
     /* 753440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 753447 */     // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 753447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
     /* 753450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 753452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 753475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753478 */     GIR_RootConstrainSelectedInstOperands,
     /* 753479 */     // GIR_Coverage, 7353,
     /* 753479 */     GIR_EraseRootFromParent_Done,
     /* 753480 */   // Label 9939: @753480
     /* 753480 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(753528), // Rule ID 7354 //
     /* 753485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 753488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
     /* 753495 */     // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
     /* 753495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
     /* 753498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 753500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 753515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 753520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 753523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753526 */     GIR_RootConstrainSelectedInstOperands,
     /* 753527 */     // GIR_Coverage, 7354,
     /* 753527 */     GIR_EraseRootFromParent_Done,
     /* 753528 */   // Label 9940: @753528
     /* 753528 */   GIM_Reject,
     /* 753529 */ // Label 9938: @753529
     /* 753529 */ GIM_Reject,
     /* 753530 */ // Label 9931: @753530
     /* 753530 */ GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(754108),
     /* 753535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 753538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 753542 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(753796), // Rule ID 2744 //
     /* 753547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
     /* 753550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 753554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 753558 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 753561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 753565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 753569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 753573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 753577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 753581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 753585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 753589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 753593 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 753597 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /* 753601 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /* 753605 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 753609 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 753613 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /* 753617 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 753621 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /* 753625 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /* 753629 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /* 753633 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 753635 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753642 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753649 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753656 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753663 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753670 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753677 */     // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_FMA_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
     /* 753677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 753680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 753684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 753691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 753694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
     /* 753698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
     /* 753708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
     /* 753713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
     /* 753718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
     /* 753723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
     /* 753728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
     /* 753733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 753736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 753739 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 753742 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 753745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 753747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
     /* 753750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 753752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
     /* 753757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
     /* 753762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
     /* 753767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
     /* 753772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
     /* 753777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
     /* 753782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 753785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 753788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 753794 */     GIR_RootConstrainSelectedInstOperands,
     /* 753795 */     // GIR_Coverage, 2744,
     /* 753795 */     GIR_EraseRootFromParent_Done,
     /* 753796 */   // Label 9942: @753796
     /* 753796 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(754050), // Rule ID 2728 //
     /* 753801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
     /* 753804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 753808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 753812 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 753815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 753819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 753823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 753827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 753831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 753835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 753839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 753843 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 753847 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 753851 */     GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
     /* 753855 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /* 753859 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 753863 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 753867 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /* 753871 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMAD),
     /* 753875 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /* 753879 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /* 753883 */     GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
     /* 753887 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 753889 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753896 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753903 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753910 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753917 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753924 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
     /* 753931 */     // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_MAD_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
     /* 753931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 753934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 753938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 753945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 753948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
     /* 753952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 753957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
     /* 753962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
     /* 753967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
     /* 753972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
     /* 753977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
     /* 753982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
     /* 753987 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 753990 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 753993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 753996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 753999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 754001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
     /* 754004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
     /* 754011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
     /* 754016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
     /* 754021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
     /* 754026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
     /* 754031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
     /* 754036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 754039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 754042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754048 */     GIR_RootConstrainSelectedInstOperands,
     /* 754049 */     // GIR_Coverage, 2728,
     /* 754049 */     GIR_EraseRootFromParent_Done,
     /* 754050 */   // Label 9943: @754050
     /* 754050 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(754107), // Rule ID 7358 //
     /* 754055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
     /* 754058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
     /* 754065 */     // (AMDGPUclamp:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, 1:{ *:[i1] })
     /* 754065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
     /* 754068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 754093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754105 */     GIR_RootConstrainSelectedInstOperands,
     /* 754106 */     // GIR_Coverage, 7358,
     /* 754106 */     GIR_EraseRootFromParent_Done,
     /* 754107 */   // Label 9944: @754107
     /* 754107 */   GIM_Reject,
     /* 754108 */ // Label 9941: @754108
     /* 754108 */ GIM_Reject,
     /* 754109 */ // Label 9932: @754109
     /* 754109 */ GIM_Reject,
     /* 754110 */ // Label 144: @754110
     /* 754110 */ GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(754154), // Rule ID 652 //
     /* 754115 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754125 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754132 */   // (AMDGPUcvt_f32_ubyte0:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE0_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 754132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE0_e64),
     /* 754135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 754147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 754152 */   GIR_RootConstrainSelectedInstOperands,
     /* 754153 */   // GIR_Coverage, 652,
     /* 754153 */   GIR_EraseRootFromParent_Done,
     /* 754154 */ // Label 9945: @754154
     /* 754154 */ GIM_Reject,
     /* 754155 */ // Label 145: @754155
     /* 754155 */ GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(754199), // Rule ID 653 //
     /* 754160 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754177 */   // (AMDGPUcvt_f32_ubyte1:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE1_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 754177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE1_e64),
     /* 754180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 754192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 754197 */   GIR_RootConstrainSelectedInstOperands,
     /* 754198 */   // GIR_Coverage, 653,
     /* 754198 */   GIR_EraseRootFromParent_Done,
     /* 754199 */ // Label 9946: @754199
     /* 754199 */ GIM_Reject,
     /* 754200 */ // Label 146: @754200
     /* 754200 */ GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(754244), // Rule ID 654 //
     /* 754205 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754222 */   // (AMDGPUcvt_f32_ubyte2:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE2_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 754222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE2_e64),
     /* 754225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 754237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 754242 */   GIR_RootConstrainSelectedInstOperands,
     /* 754243 */   // GIR_Coverage, 654,
     /* 754243 */   GIR_EraseRootFromParent_Done,
     /* 754244 */ // Label 9947: @754244
     /* 754244 */ GIM_Reject,
     /* 754245 */ // Label 147: @754245
     /* 754245 */ GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(754289), // Rule ID 655 //
     /* 754250 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754260 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754267 */   // (AMDGPUcvt_f32_ubyte3:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE3_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 754267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE3_e64),
     /* 754270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
     /* 754282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
     /* 754287 */   GIR_RootConstrainSelectedInstOperands,
     /* 754288 */   // GIR_Coverage, 655,
     /* 754288 */   GIR_EraseRootFromParent_Done,
     /* 754289 */ // Label 9948: @754289
     /* 754289 */ GIM_Reject,
     /* 754290 */ // Label 148: @754290
     /* 754290 */ GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(754319), // Rule ID 832 //
     /* 754295 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 754298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 754304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754308 */   // (AMDGPUpk_i16_i32_impl:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
     /* 754308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
     /* 754313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
     /* 754317 */   GIR_RootConstrainSelectedInstOperands,
     /* 754318 */   // GIR_Coverage, 832,
     /* 754318 */   GIR_Done,
     /* 754319 */ // Label 9949: @754319
     /* 754319 */ GIM_Reject,
     /* 754320 */ // Label 149: @754320
     /* 754320 */ GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(754421),
     /* 754325 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754328 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9953*/ GIMT_Encode4(754389),
     /* 754339 */   /*GILLT_s32*//*Label 9951*/ GIMT_Encode4(754347),
     /* 754343 */   /*GILLT_s64*//*Label 9952*/ GIMT_Encode4(754368),
     /* 754347 */   // Label 9951: @754347
     /* 754347 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(754367), // Rule ID 13 //
     /* 754352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 754356 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13707),
     /* 754360 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13707>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 754360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
     /* 754365 */     GIR_RootConstrainSelectedInstOperands,
     /* 754366 */     // GIR_Coverage, 13,
     /* 754366 */     GIR_Done,
     /* 754367 */   // Label 9954: @754367
     /* 754367 */   GIM_Reject,
     /* 754368 */   // Label 9952: @754368
     /* 754368 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(754388), // Rule ID 15 //
     /* 754373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 754377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13707),
     /* 754381 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13707>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 754381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
     /* 754386 */     GIR_RootConstrainSelectedInstOperands,
     /* 754387 */     // GIR_Coverage, 15,
     /* 754387 */     GIR_Done,
     /* 754388 */   // Label 9955: @754388
     /* 754388 */   GIM_Reject,
     /* 754389 */   // Label 9953: @754389
     /* 754389 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(754420), // Rule ID 683 //
     /* 754394 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754408 */     // (AMDGPUffbh_u32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 754408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
     /* 754411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754418 */     GIR_RootConstrainSelectedInstOperands,
     /* 754419 */     // GIR_Coverage, 683,
     /* 754419 */     GIR_EraseRootFromParent_Done,
     /* 754420 */   // Label 9956: @754420
     /* 754420 */   GIM_Reject,
     /* 754421 */ // Label 9950: @754421
     /* 754421 */ GIM_Reject,
     /* 754422 */ // Label 150: @754422
     /* 754422 */ GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(754520),
     /* 754427 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754430 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9960*/ GIMT_Encode4(754519),
     /* 754441 */   /*GILLT_s32*//*Label 9958*/ GIMT_Encode4(754449),
     /* 754445 */   /*GILLT_s64*//*Label 9959*/ GIMT_Encode4(754498),
     /* 754449 */   // Label 9958: @754449
     /* 754449 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(754469), // Rule ID 11 //
     /* 754454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 754458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13706),
     /* 754462 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13706>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 754462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
     /* 754467 */     GIR_RootConstrainSelectedInstOperands,
     /* 754468 */     // GIR_Coverage, 11,
     /* 754468 */     GIR_Done,
     /* 754469 */   // Label 9961: @754469
     /* 754469 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(754497), // Rule ID 685 //
     /* 754474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754485 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
     /* 754485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
     /* 754488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754495 */     GIR_RootConstrainSelectedInstOperands,
     /* 754496 */     // GIR_Coverage, 685,
     /* 754496 */     GIR_EraseRootFromParent_Done,
     /* 754497 */   // Label 9962: @754497
     /* 754497 */   GIM_Reject,
     /* 754498 */   // Label 9959: @754498
     /* 754498 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(754518), // Rule ID 9 //
     /* 754503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 754507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13706),
     /* 754511 */     // (AMDGPUffbl_b32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13706>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
     /* 754511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
     /* 754516 */     GIR_RootConstrainSelectedInstOperands,
     /* 754517 */     // GIR_Coverage, 9,
     /* 754517 */     GIR_Done,
     /* 754518 */   // Label 9963: @754518
     /* 754518 */   GIM_Reject,
     /* 754519 */   // Label 9960: @754519
     /* 754519 */   GIM_Reject,
     /* 754520 */ // Label 9957: @754520
     /* 754520 */ GIM_Reject,
     /* 754521 */ // Label 151: @754521
     /* 754521 */ GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(754593), // Rule ID 834 //
     /* 754526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 754529 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 754538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754542 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 754556 */   // (AMDGPUfmax_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 754556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_LEGACY_F32_e64),
     /* 754559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 754576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 754581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 754586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 754591 */   GIR_RootConstrainSelectedInstOperands,
     /* 754592 */   // GIR_Coverage, 834,
     /* 754592 */   GIR_EraseRootFromParent_Done,
     /* 754593 */ // Label 9964: @754593
     /* 754593 */ GIM_Reject,
     /* 754594 */ // Label 152: @754594
     /* 754594 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9967*/ GIMT_Encode4(754953),
     /* 754605 */ /*GILLT_s16*//*Label 9965*/ GIMT_Encode4(754613),
     /* 754609 */ /*GILLT_s32*//*Label 9966*/ GIMT_Encode4(754866),
     /* 754613 */ // Label 9965: @754613
     /* 754613 */ GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(754865),
     /* 754618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 754621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 754624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 754627 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(754706), // Rule ID 1020 //
     /* 754632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 754635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754660 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 754660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
     /* 754663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 754680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 754685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 754690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 754695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754704 */     GIR_RootConstrainSelectedInstOperands,
     /* 754705 */     // GIR_Coverage, 1020,
     /* 754705 */     GIR_EraseRootFromParent_Done,
     /* 754706 */   // Label 9969: @754706
     /* 754706 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(754785), // Rule ID 1022 //
     /* 754711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 754714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 754718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754739 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 754739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
     /* 754742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 754759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 754764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 754769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 754774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754783 */     GIR_RootConstrainSelectedInstOperands,
     /* 754784 */     // GIR_Coverage, 1022,
     /* 754784 */     GIR_EraseRootFromParent_Done,
     /* 754785 */   // Label 9970: @754785
     /* 754785 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(754864), // Rule ID 1024 //
     /* 754790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 754793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 754818 */     // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
     /* 754818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
     /* 754821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 754838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 754843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 754848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 754853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 754862 */     GIR_RootConstrainSelectedInstOperands,
     /* 754863 */     // GIR_Coverage, 1024,
     /* 754863 */     GIR_EraseRootFromParent_Done,
     /* 754864 */   // Label 9971: @754864
     /* 754864 */   GIM_Reject,
     /* 754865 */ // Label 9968: @754865
     /* 754865 */ GIM_Reject,
     /* 754866 */ // Label 9966: @754866
     /* 754866 */ GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(754952), // Rule ID 973 //
     /* 754871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 754877 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 754880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754891 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 754898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
     /* 754905 */   // (AMDGPUfmed3_impl:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 754905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
     /* 754908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 754920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 754925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 754930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 754935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 754940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 754945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 754950 */   GIR_RootConstrainSelectedInstOperands,
     /* 754951 */   // GIR_Coverage, 973,
     /* 754951 */   GIR_EraseRootFromParent_Done,
     /* 754952 */ // Label 9972: @754952
     /* 754952 */ GIM_Reject,
     /* 754953 */ // Label 9967: @754953
     /* 754953 */ GIM_Reject,
     /* 754954 */ // Label 153: @754954
     /* 754954 */ GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(755026), // Rule ID 833 //
     /* 754959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
     /* 754962 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 754965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 754968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 754971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 754975 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 754982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
     /* 754989 */   // (AMDGPUfmin_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 754989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_LEGACY_F32_e64),
     /* 754992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 754994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 754999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 755004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 755009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 755014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 755019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 755024 */   GIR_RootConstrainSelectedInstOperands,
     /* 755025 */   // GIR_Coverage, 833,
     /* 755025 */   GIR_EraseRootFromParent_Done,
     /* 755026 */ // Label 9973: @755026
     /* 755026 */ GIM_Reject,
     /* 755027 */ // Label 154: @755027
     /* 755027 */ GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(755076), // Rule ID 668 //
     /* 755032 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 755035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 755038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 755049 */   // (AMDGPUrcp_iflag:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_IFLAG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
     /* 755049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_IFLAG_F32_e64),
     /* 755052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 755054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 755059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 755064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
     /* 755069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
     /* 755074 */   GIR_RootConstrainSelectedInstOperands,
     /* 755075 */   // GIR_Coverage, 668,
     /* 755075 */   GIR_EraseRootFromParent_Done,
     /* 755076 */ // Label 9974: @755076
     /* 755076 */ GIM_Reject,
     /* 755077 */ // Label 155: @755077
     /* 755077 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9977*/ GIMT_Encode4(755382),
     /* 755088 */ /*GILLT_s16*//*Label 9975*/ GIMT_Encode4(755096),
     /* 755092 */ /*GILLT_s32*//*Label 9976*/ GIMT_Encode4(755340),
     /* 755096 */ // Label 9975: @755096
     /* 755096 */ GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(755339),
     /* 755101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 755104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 755107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 755110 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(755186), // Rule ID 1025 //
     /* 755115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 755118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755143 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 755143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
     /* 755146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 755148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 755153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 755158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 755163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 755168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 755173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 755178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755184 */     GIR_RootConstrainSelectedInstOperands,
     /* 755185 */     // GIR_Coverage, 1025,
     /* 755185 */     GIR_EraseRootFromParent_Done,
     /* 755186 */   // Label 9979: @755186
     /* 755186 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(755262), // Rule ID 1026 //
     /* 755191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 755194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 755198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755219 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 755219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
     /* 755222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 755224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 755229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 755234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 755239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 755244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 755249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 755254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755260 */     GIR_RootConstrainSelectedInstOperands,
     /* 755261 */     // GIR_Coverage, 1026,
     /* 755261 */     GIR_EraseRootFromParent_Done,
     /* 755262 */   // Label 9980: @755262
     /* 755262 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(755338), // Rule ID 1027 //
     /* 755267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 755270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 755295 */     // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 755295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
     /* 755298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 755300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 755305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 755310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 755315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 755320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 755325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 755330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755336 */     GIR_RootConstrainSelectedInstOperands,
     /* 755337 */     // GIR_Coverage, 1027,
     /* 755337 */     GIR_EraseRootFromParent_Done,
     /* 755338 */   // Label 9981: @755338
     /* 755338 */   GIM_Reject,
     /* 755339 */ // Label 9978: @755339
     /* 755339 */ GIM_Reject,
     /* 755340 */ // Label 9976: @755340
     /* 755340 */ GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(755381), // Rule ID 968 //
     /* 755345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 755348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 755351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 755354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 755358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 755365 */   // (AMDGPUsmed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 755365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
     /* 755368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 755370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 755375 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 755377 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 755379 */   GIR_RootConstrainSelectedInstOperands,
     /* 755380 */   // GIR_Coverage, 968,
     /* 755380 */   GIR_EraseRootFromParent_Done,
     /* 755381 */ // Label 9982: @755381
     /* 755381 */ GIM_Reject,
     /* 755382 */ // Label 9977: @755382
     /* 755382 */ GIM_Reject,
     /* 755383 */ // Label 156: @755383
     /* 755383 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(31), /*)*//*default:*//*Label 9989*/ GIMT_Encode4(757684),
     /* 755394 */ /*GILLT_s32*//*Label 9983*/ GIMT_Encode4(755482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 755406 */ /*GILLT_v2s32*//*Label 9984*/ GIMT_Encode4(755862), GIMT_Encode4(0),
     /* 755414 */ /*GILLT_v3s32*//*Label 9985*/ GIMT_Encode4(756242), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 755426 */ /*GILLT_v4s32*//*Label 9986*/ GIMT_Encode4(756544), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 755450 */ /*GILLT_v8s32*//*Label 9987*/ GIMT_Encode4(756924), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 755478 */ /*GILLT_v16s32*//*Label 9988*/ GIMT_Encode4(757304),
     /* 755482 */ // Label 9983: @755482
     /* 755482 */ GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(755861),
     /* 755487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 755490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 755493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 755497 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 755500 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(755544), // Rule ID 2904 //
     /* 755505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 755508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 755515 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 755518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755520 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 755532 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755542 */     GIR_RootConstrainSelectedInstOperands,
     /* 755543 */     // GIR_Coverage, 2904,
     /* 755543 */     GIR_EraseRootFromParent_Done,
     /* 755544 */   // Label 9991: @755544
     /* 755544 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(755588), // Rule ID 3509 //
     /* 755549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 755552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 755559 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 755562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755564 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 755576 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755586 */     GIR_RootConstrainSelectedInstOperands,
     /* 755587 */     // GIR_Coverage, 3509,
     /* 755587 */     GIR_EraseRootFromParent_Done,
     /* 755588 */   // Label 9992: @755588
     /* 755588 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(755624), // Rule ID 2900 //
     /* 755593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 755600 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
     /* 755603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755605 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 755612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755622 */     GIR_RootConstrainSelectedInstOperands,
     /* 755623 */     // GIR_Coverage, 2900,
     /* 755623 */     GIR_EraseRootFromParent_Done,
     /* 755624 */   // Label 9993: @755624
     /* 755624 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(755660), // Rule ID 3505 //
     /* 755629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 755636 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
     /* 755639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755641 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 755648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755658 */     GIR_RootConstrainSelectedInstOperands,
     /* 755659 */     // GIR_Coverage, 3505,
     /* 755659 */     GIR_EraseRootFromParent_Done,
     /* 755660 */   // Label 9994: @755660
     /* 755660 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(755699), // Rule ID 2901 //
     /* 755665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 755668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 755675 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
     /* 755678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755680 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 755687 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755697 */     GIR_RootConstrainSelectedInstOperands,
     /* 755698 */     // GIR_Coverage, 2901,
     /* 755698 */     GIR_EraseRootFromParent_Done,
     /* 755699 */   // Label 9995: @755699
     /* 755699 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(755738), // Rule ID 3506 //
     /* 755704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 755707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 755714 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
     /* 755717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755719 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 755726 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755736 */     GIR_RootConstrainSelectedInstOperands,
     /* 755737 */     // GIR_Coverage, 3506,
     /* 755737 */     GIR_EraseRootFromParent_Done,
     /* 755738 */   // Label 9996: @755738
     /* 755738 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(755767), // Rule ID 2902 //
     /* 755743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 755746 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
     /* 755749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755751 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755753 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 755755 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755765 */     GIR_RootConstrainSelectedInstOperands,
     /* 755766 */     // GIR_Coverage, 2902,
     /* 755766 */     GIR_EraseRootFromParent_Done,
     /* 755767 */   // Label 9997: @755767
     /* 755767 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(755799), // Rule ID 2903 //
     /* 755772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 755775 */     // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 755778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755780 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755782 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 755784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755797 */     GIR_RootConstrainSelectedInstOperands,
     /* 755798 */     // GIR_Coverage, 2903,
     /* 755798 */     GIR_EraseRootFromParent_Done,
     /* 755799 */   // Label 9998: @755799
     /* 755799 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(755828), // Rule ID 3507 //
     /* 755804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 755807 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
     /* 755810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755812 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755814 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 755816 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755826 */     GIR_RootConstrainSelectedInstOperands,
     /* 755827 */     // GIR_Coverage, 3507,
     /* 755827 */     GIR_EraseRootFromParent_Done,
     /* 755828 */   // Label 9999: @755828
     /* 755828 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(755860), // Rule ID 3508 //
     /* 755833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 755836 */     // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
     /* 755839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755841 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755843 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 755845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 755848 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755858 */     GIR_RootConstrainSelectedInstOperands,
     /* 755859 */     // GIR_Coverage, 3508,
     /* 755859 */     GIR_EraseRootFromParent_Done,
     /* 755860 */   // Label 10000: @755860
     /* 755860 */   GIM_Reject,
     /* 755861 */ // Label 9990: @755861
     /* 755861 */ GIM_Reject,
     /* 755862 */ // Label 9984: @755862
     /* 755862 */ GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(756241),
     /* 755867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 755870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 755873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
     /* 755877 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 755880 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(755924), // Rule ID 3485 //
     /* 755885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 755888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 755895 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 755898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755900 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 755912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755922 */     GIR_RootConstrainSelectedInstOperands,
     /* 755923 */     // GIR_Coverage, 3485,
     /* 755923 */     GIR_EraseRootFromParent_Done,
     /* 755924 */   // Label 10002: @755924
     /* 755924 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(755968), // Rule ID 3514 //
     /* 755929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 755932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 755939 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 755942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755944 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 755951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 755956 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 755966 */     GIR_RootConstrainSelectedInstOperands,
     /* 755967 */     // GIR_Coverage, 3514,
     /* 755967 */     GIR_EraseRootFromParent_Done,
     /* 755968 */   // Label 10003: @755968
     /* 755968 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(756004), // Rule ID 3481 //
     /* 755973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 755980 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 755980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
     /* 755983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 755985 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 755987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 755992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 755998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756002 */     GIR_RootConstrainSelectedInstOperands,
     /* 756003 */     // GIR_Coverage, 3481,
     /* 756003 */     GIR_EraseRootFromParent_Done,
     /* 756004 */   // Label 10004: @756004
     /* 756004 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(756040), // Rule ID 3510 //
     /* 756009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 756016 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
     /* 756019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756021 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756038 */     GIR_RootConstrainSelectedInstOperands,
     /* 756039 */     // GIR_Coverage, 3510,
     /* 756039 */     GIR_EraseRootFromParent_Done,
     /* 756040 */   // Label 10005: @756040
     /* 756040 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(756079), // Rule ID 3482 //
     /* 756045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 756048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 756055 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
     /* 756058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756060 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756077 */     GIR_RootConstrainSelectedInstOperands,
     /* 756078 */     // GIR_Coverage, 3482,
     /* 756078 */     GIR_EraseRootFromParent_Done,
     /* 756079 */   // Label 10006: @756079
     /* 756079 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(756118), // Rule ID 3511 //
     /* 756084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 756087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 756094 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
     /* 756097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756099 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756106 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756116 */     GIR_RootConstrainSelectedInstOperands,
     /* 756117 */     // GIR_Coverage, 3511,
     /* 756117 */     GIR_EraseRootFromParent_Done,
     /* 756118 */   // Label 10007: @756118
     /* 756118 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(756147), // Rule ID 3483 //
     /* 756123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 756126 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
     /* 756129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756131 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756133 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756145 */     GIR_RootConstrainSelectedInstOperands,
     /* 756146 */     // GIR_Coverage, 3483,
     /* 756146 */     GIR_EraseRootFromParent_Done,
     /* 756147 */   // Label 10008: @756147
     /* 756147 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(756179), // Rule ID 3484 //
     /* 756152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756155 */     // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 756158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756160 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756162 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 756167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756177 */     GIR_RootConstrainSelectedInstOperands,
     /* 756178 */     // GIR_Coverage, 3484,
     /* 756178 */     GIR_EraseRootFromParent_Done,
     /* 756179 */   // Label 10009: @756179
     /* 756179 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(756208), // Rule ID 3512 //
     /* 756184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 756187 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
     /* 756190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756192 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756194 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756196 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756206 */     GIR_RootConstrainSelectedInstOperands,
     /* 756207 */     // GIR_Coverage, 3512,
     /* 756207 */     GIR_EraseRootFromParent_Done,
     /* 756208 */   // Label 10010: @756208
     /* 756208 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(756240), // Rule ID 3513 //
     /* 756213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756216 */     // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
     /* 756219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756221 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756223 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 756228 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756238 */     GIR_RootConstrainSelectedInstOperands,
     /* 756239 */     // GIR_Coverage, 3513,
     /* 756239 */     GIR_EraseRootFromParent_Done,
     /* 756240 */   // Label 10011: @756240
     /* 756240 */   GIM_Reject,
     /* 756241 */ // Label 10001: @756241
     /* 756241 */ GIM_Reject,
     /* 756242 */ // Label 9985: @756242
     /* 756242 */ GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(756543),
     /* 756247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 756250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 756253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
     /* 756257 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 756260 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(756304), // Rule ID 3489 //
     /* 756265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 756275 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 756278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756280 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 756292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756302 */     GIR_RootConstrainSelectedInstOperands,
     /* 756303 */     // GIR_Coverage, 3489,
     /* 756303 */     GIR_EraseRootFromParent_Done,
     /* 756304 */   // Label 10013: @756304
     /* 756304 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(756348), // Rule ID 3518 //
     /* 756309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 756319 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 756322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756324 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 756336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756346 */     GIR_RootConstrainSelectedInstOperands,
     /* 756347 */     // GIR_Coverage, 3518,
     /* 756347 */     GIR_EraseRootFromParent_Done,
     /* 756348 */   // Label 10014: @756348
     /* 756348 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(756384), // Rule ID 3486 //
     /* 756353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 756360 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
     /* 756363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756365 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756372 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756382 */     GIR_RootConstrainSelectedInstOperands,
     /* 756383 */     // GIR_Coverage, 3486,
     /* 756383 */     GIR_EraseRootFromParent_Done,
     /* 756384 */   // Label 10015: @756384
     /* 756384 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(756420), // Rule ID 3515 //
     /* 756389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 756396 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
     /* 756399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756401 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756408 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756418 */     GIR_RootConstrainSelectedInstOperands,
     /* 756419 */     // GIR_Coverage, 3515,
     /* 756419 */     GIR_EraseRootFromParent_Done,
     /* 756420 */   // Label 10016: @756420
     /* 756420 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(756449), // Rule ID 3487 //
     /* 756425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 756428 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
     /* 756431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756433 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756435 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756437 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756447 */     GIR_RootConstrainSelectedInstOperands,
     /* 756448 */     // GIR_Coverage, 3487,
     /* 756448 */     GIR_EraseRootFromParent_Done,
     /* 756449 */   // Label 10017: @756449
     /* 756449 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(756481), // Rule ID 3488 //
     /* 756454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756457 */     // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 756460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756462 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756464 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 756469 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756479 */     GIR_RootConstrainSelectedInstOperands,
     /* 756480 */     // GIR_Coverage, 3488,
     /* 756480 */     GIR_EraseRootFromParent_Done,
     /* 756481 */   // Label 10018: @756481
     /* 756481 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(756510), // Rule ID 3516 //
     /* 756486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 756489 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
     /* 756492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756494 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756496 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756508 */     GIR_RootConstrainSelectedInstOperands,
     /* 756509 */     // GIR_Coverage, 3516,
     /* 756509 */     GIR_EraseRootFromParent_Done,
     /* 756510 */   // Label 10019: @756510
     /* 756510 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(756542), // Rule ID 3517 //
     /* 756515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756518 */     // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
     /* 756521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756523 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756525 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 756530 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756540 */     GIR_RootConstrainSelectedInstOperands,
     /* 756541 */     // GIR_Coverage, 3517,
     /* 756541 */     GIR_EraseRootFromParent_Done,
     /* 756542 */   // Label 10020: @756542
     /* 756542 */   GIM_Reject,
     /* 756543 */ // Label 10012: @756543
     /* 756543 */ GIM_Reject,
     /* 756544 */ // Label 9986: @756544
     /* 756544 */ GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(756923),
     /* 756549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 756552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 756555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
     /* 756559 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 756562 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(756606), // Rule ID 3494 //
     /* 756567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 756577 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 756580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756582 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 756594 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756604 */     GIR_RootConstrainSelectedInstOperands,
     /* 756605 */     // GIR_Coverage, 3494,
     /* 756605 */     GIR_EraseRootFromParent_Done,
     /* 756606 */   // Label 10022: @756606
     /* 756606 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(756650), // Rule ID 3523 //
     /* 756611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 756621 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 756624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756626 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 756638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756648 */     GIR_RootConstrainSelectedInstOperands,
     /* 756649 */     // GIR_Coverage, 3523,
     /* 756649 */     GIR_EraseRootFromParent_Done,
     /* 756650 */   // Label 10023: @756650
     /* 756650 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(756686), // Rule ID 3490 //
     /* 756655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 756662 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
     /* 756665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756667 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756674 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756684 */     GIR_RootConstrainSelectedInstOperands,
     /* 756685 */     // GIR_Coverage, 3490,
     /* 756685 */     GIR_EraseRootFromParent_Done,
     /* 756686 */   // Label 10024: @756686
     /* 756686 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(756722), // Rule ID 3519 //
     /* 756691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 756698 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
     /* 756701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756703 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756720 */     GIR_RootConstrainSelectedInstOperands,
     /* 756721 */     // GIR_Coverage, 3519,
     /* 756721 */     GIR_EraseRootFromParent_Done,
     /* 756722 */   // Label 10025: @756722
     /* 756722 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(756761), // Rule ID 3491 //
     /* 756727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 756730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 756737 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
     /* 756740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756742 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756749 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756759 */     GIR_RootConstrainSelectedInstOperands,
     /* 756760 */     // GIR_Coverage, 3491,
     /* 756760 */     GIR_EraseRootFromParent_Done,
     /* 756761 */   // Label 10026: @756761
     /* 756761 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(756800), // Rule ID 3520 //
     /* 756766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 756769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 756776 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
     /* 756779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756781 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 756788 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756798 */     GIR_RootConstrainSelectedInstOperands,
     /* 756799 */     // GIR_Coverage, 3520,
     /* 756799 */     GIR_EraseRootFromParent_Done,
     /* 756800 */   // Label 10027: @756800
     /* 756800 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(756829), // Rule ID 3492 //
     /* 756805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 756808 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
     /* 756811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756813 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756815 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756827 */     GIR_RootConstrainSelectedInstOperands,
     /* 756828 */     // GIR_Coverage, 3492,
     /* 756828 */     GIR_EraseRootFromParent_Done,
     /* 756829 */   // Label 10028: @756829
     /* 756829 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(756861), // Rule ID 3493 //
     /* 756834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756837 */     // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 756840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756842 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756844 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 756849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756859 */     GIR_RootConstrainSelectedInstOperands,
     /* 756860 */     // GIR_Coverage, 3493,
     /* 756860 */     GIR_EraseRootFromParent_Done,
     /* 756861 */   // Label 10029: @756861
     /* 756861 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(756890), // Rule ID 3521 //
     /* 756866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 756869 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
     /* 756872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756874 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756876 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756878 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756888 */     GIR_RootConstrainSelectedInstOperands,
     /* 756889 */     // GIR_Coverage, 3521,
     /* 756889 */     GIR_EraseRootFromParent_Done,
     /* 756890 */   // Label 10030: @756890
     /* 756890 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(756922), // Rule ID 3522 //
     /* 756895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756898 */     // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
     /* 756901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756903 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756905 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 756907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 756910 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756920 */     GIR_RootConstrainSelectedInstOperands,
     /* 756921 */     // GIR_Coverage, 3522,
     /* 756921 */     GIR_EraseRootFromParent_Done,
     /* 756922 */   // Label 10031: @756922
     /* 756922 */   GIM_Reject,
     /* 756923 */ // Label 10021: @756923
     /* 756923 */ GIM_Reject,
     /* 756924 */ // Label 9987: @756924
     /* 756924 */ GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(757303),
     /* 756929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 756932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 756935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
     /* 756939 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 756942 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(756986), // Rule ID 3499 //
     /* 756947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 756957 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 756957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 756960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 756962 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 756964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 756969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 756974 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 756980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 756984 */     GIR_RootConstrainSelectedInstOperands,
     /* 756985 */     // GIR_Coverage, 3499,
     /* 756985 */     GIR_EraseRootFromParent_Done,
     /* 756986 */   // Label 10033: @756986
     /* 756986 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(757030), // Rule ID 3528 //
     /* 756991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 756994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 757001 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 757004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757006 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 757018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757028 */     GIR_RootConstrainSelectedInstOperands,
     /* 757029 */     // GIR_Coverage, 3528,
     /* 757029 */     GIR_EraseRootFromParent_Done,
     /* 757030 */   // Label 10034: @757030
     /* 757030 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(757066), // Rule ID 3495 //
     /* 757035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 757042 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
     /* 757045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757047 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757054 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757064 */     GIR_RootConstrainSelectedInstOperands,
     /* 757065 */     // GIR_Coverage, 3495,
     /* 757065 */     GIR_EraseRootFromParent_Done,
     /* 757066 */   // Label 10035: @757066
     /* 757066 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(757102), // Rule ID 3524 //
     /* 757071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 757078 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
     /* 757081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757083 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757090 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757100 */     GIR_RootConstrainSelectedInstOperands,
     /* 757101 */     // GIR_Coverage, 3524,
     /* 757101 */     GIR_EraseRootFromParent_Done,
     /* 757102 */   // Label 10036: @757102
     /* 757102 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(757141), // Rule ID 3496 //
     /* 757107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 757110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 757117 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
     /* 757120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757122 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757139 */     GIR_RootConstrainSelectedInstOperands,
     /* 757140 */     // GIR_Coverage, 3496,
     /* 757140 */     GIR_EraseRootFromParent_Done,
     /* 757141 */   // Label 10037: @757141
     /* 757141 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(757180), // Rule ID 3525 //
     /* 757146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 757149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 757156 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
     /* 757159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757161 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757178 */     GIR_RootConstrainSelectedInstOperands,
     /* 757179 */     // GIR_Coverage, 3525,
     /* 757179 */     GIR_EraseRootFromParent_Done,
     /* 757180 */   // Label 10038: @757180
     /* 757180 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(757209), // Rule ID 3497 //
     /* 757185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 757188 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
     /* 757191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757193 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757195 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757197 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757207 */     GIR_RootConstrainSelectedInstOperands,
     /* 757208 */     // GIR_Coverage, 3497,
     /* 757208 */     GIR_EraseRootFromParent_Done,
     /* 757209 */   // Label 10039: @757209
     /* 757209 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(757241), // Rule ID 3498 //
     /* 757214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 757217 */     // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 757220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757222 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757224 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 757229 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757239 */     GIR_RootConstrainSelectedInstOperands,
     /* 757240 */     // GIR_Coverage, 3498,
     /* 757240 */     GIR_EraseRootFromParent_Done,
     /* 757241 */   // Label 10040: @757241
     /* 757241 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(757270), // Rule ID 3526 //
     /* 757246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 757249 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
     /* 757252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757254 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757256 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757258 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757268 */     GIR_RootConstrainSelectedInstOperands,
     /* 757269 */     // GIR_Coverage, 3526,
     /* 757269 */     GIR_EraseRootFromParent_Done,
     /* 757270 */   // Label 10041: @757270
     /* 757270 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(757302), // Rule ID 3527 //
     /* 757275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 757278 */     // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
     /* 757281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757283 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757285 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 757290 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757300 */     GIR_RootConstrainSelectedInstOperands,
     /* 757301 */     // GIR_Coverage, 3527,
     /* 757301 */     GIR_EraseRootFromParent_Done,
     /* 757302 */   // Label 10042: @757302
     /* 757302 */   GIM_Reject,
     /* 757303 */ // Label 10032: @757303
     /* 757303 */ GIM_Reject,
     /* 757304 */ // Label 9988: @757304
     /* 757304 */ GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(757683),
     /* 757309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 757312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 757315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
     /* 757319 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 757322 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(757366), // Rule ID 3504 //
     /* 757327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 757330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 757337 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 757340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757342 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 757354 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757364 */     GIR_RootConstrainSelectedInstOperands,
     /* 757365 */     // GIR_Coverage, 3504,
     /* 757365 */     GIR_EraseRootFromParent_Done,
     /* 757366 */   // Label 10044: @757366
     /* 757366 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(757410), // Rule ID 3533 //
     /* 757371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 757374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 757381 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 757384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757386 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 757398 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757408 */     GIR_RootConstrainSelectedInstOperands,
     /* 757409 */     // GIR_Coverage, 3533,
     /* 757409 */     GIR_EraseRootFromParent_Done,
     /* 757410 */   // Label 10045: @757410
     /* 757410 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(757446), // Rule ID 3500 //
     /* 757415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 757422 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
     /* 757425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757427 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757434 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757444 */     GIR_RootConstrainSelectedInstOperands,
     /* 757445 */     // GIR_Coverage, 3500,
     /* 757445 */     GIR_EraseRootFromParent_Done,
     /* 757446 */   // Label 10046: @757446
     /* 757446 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(757482), // Rule ID 3529 //
     /* 757451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 757458 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
     /* 757461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757463 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757470 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757480 */     GIR_RootConstrainSelectedInstOperands,
     /* 757481 */     // GIR_Coverage, 3529,
     /* 757481 */     GIR_EraseRootFromParent_Done,
     /* 757482 */   // Label 10047: @757482
     /* 757482 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(757521), // Rule ID 3501 //
     /* 757487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 757490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 757497 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
     /* 757500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757502 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757519 */     GIR_RootConstrainSelectedInstOperands,
     /* 757520 */     // GIR_Coverage, 3501,
     /* 757520 */     GIR_EraseRootFromParent_Done,
     /* 757521 */   // Label 10048: @757521
     /* 757521 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(757560), // Rule ID 3530 //
     /* 757526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
     /* 757529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
     /* 757536 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
     /* 757539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757541 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757548 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757558 */     GIR_RootConstrainSelectedInstOperands,
     /* 757559 */     // GIR_Coverage, 3530,
     /* 757559 */     GIR_EraseRootFromParent_Done,
     /* 757560 */   // Label 10049: @757560
     /* 757560 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(757589), // Rule ID 3502 //
     /* 757565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 757568 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
     /* 757571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757573 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757575 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757587 */     GIR_RootConstrainSelectedInstOperands,
     /* 757588 */     // GIR_Coverage, 3502,
     /* 757588 */     GIR_EraseRootFromParent_Done,
     /* 757589 */   // Label 10050: @757589
     /* 757589 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(757621), // Rule ID 3503 //
     /* 757594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 757597 */     // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 757600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757602 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757604 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 757609 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757619 */     GIR_RootConstrainSelectedInstOperands,
     /* 757620 */     // GIR_Coverage, 3503,
     /* 757620 */     GIR_EraseRootFromParent_Done,
     /* 757621 */   // Label 10051: @757621
     /* 757621 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(757650), // Rule ID 3531 //
     /* 757626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
     /* 757629 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
     /* 757632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757634 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757636 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757638 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757648 */     GIR_RootConstrainSelectedInstOperands,
     /* 757649 */     // GIR_Coverage, 3531,
     /* 757649 */     GIR_EraseRootFromParent_Done,
     /* 757650 */   // Label 10052: @757650
     /* 757650 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(757682), // Rule ID 3532 //
     /* 757655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
     /* 757658 */     // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
     /* 757661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757663 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757665 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 757670 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757680 */     GIR_RootConstrainSelectedInstOperands,
     /* 757681 */     // GIR_Coverage, 3532,
     /* 757681 */     GIR_EraseRootFromParent_Done,
     /* 757682 */   // Label 10053: @757682
     /* 757682 */   GIM_Reject,
     /* 757683 */ // Label 10043: @757683
     /* 757683 */ GIM_Reject,
     /* 757684 */ // Label 9989: @757684
     /* 757684 */ GIM_Reject,
     /* 757685 */ // Label 157: @757685
     /* 757685 */ GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(757822),
     /* 757690 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 757693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 757696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 757699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 757703 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 757706 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(757750), // Rule ID 2911 //
     /* 757711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 757714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 757721 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
     /* 757724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757726 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 757738 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757748 */     GIR_RootConstrainSelectedInstOperands,
     /* 757749 */     // GIR_Coverage, 2911,
     /* 757749 */     GIR_EraseRootFromParent_Done,
     /* 757750 */   // Label 10055: @757750
     /* 757750 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(757789), // Rule ID 2909 //
     /* 757755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 757758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 757765 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_IMM),
     /* 757768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757770 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757787 */     GIR_RootConstrainSelectedInstOperands,
     /* 757788 */     // GIR_Coverage, 2909,
     /* 757788 */     GIR_EraseRootFromParent_Done,
     /* 757789 */   // Label 10056: @757789
     /* 757789 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(757821), // Rule ID 2910 //
     /* 757794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 757797 */     // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
     /* 757800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757802 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757804 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 757809 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757819 */     GIR_RootConstrainSelectedInstOperands,
     /* 757820 */     // GIR_Coverage, 2910,
     /* 757820 */     GIR_EraseRootFromParent_Done,
     /* 757821 */   // Label 10057: @757821
     /* 757821 */   GIM_Reject,
     /* 757822 */ // Label 10054: @757822
     /* 757822 */ GIM_Reject,
     /* 757823 */ // Label 158: @757823
     /* 757823 */ GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(757960),
     /* 757828 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 757831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 757834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 757837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 757841 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 757844 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(757888), // Rule ID 2937 //
     /* 757849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 757852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 757859 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
     /* 757862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757864 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 757871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 757876 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757886 */     GIR_RootConstrainSelectedInstOperands,
     /* 757887 */     // GIR_Coverage, 2937,
     /* 757887 */     GIR_EraseRootFromParent_Done,
     /* 757888 */   // Label 10059: @757888
     /* 757888 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(757927), // Rule ID 2935 //
     /* 757893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 757896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 757903 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_IMM),
     /* 757906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757908 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 757915 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757925 */     GIR_RootConstrainSelectedInstOperands,
     /* 757926 */     // GIR_Coverage, 2935,
     /* 757926 */     GIR_EraseRootFromParent_Done,
     /* 757927 */   // Label 10060: @757927
     /* 757927 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(757959), // Rule ID 2936 //
     /* 757932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 757935 */     // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
     /* 757938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 757940 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 757942 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 757944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 757947 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 757953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 757957 */     GIR_RootConstrainSelectedInstOperands,
     /* 757958 */     // GIR_Coverage, 2936,
     /* 757958 */     GIR_EraseRootFromParent_Done,
     /* 757959 */   // Label 10061: @757959
     /* 757959 */   GIM_Reject,
     /* 757960 */ // Label 10058: @757960
     /* 757960 */ GIM_Reject,
     /* 757961 */ // Label 159: @757961
     /* 757961 */ GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(758098),
     /* 757966 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 757969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 757972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 757975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 757979 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 757982 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(758026), // Rule ID 2934 //
     /* 757987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 757990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 757997 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 757997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
     /* 758000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 758002 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 758004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 758014 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 758020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758024 */     GIR_RootConstrainSelectedInstOperands,
     /* 758025 */     // GIR_Coverage, 2934,
     /* 758025 */     GIR_EraseRootFromParent_Done,
     /* 758026 */   // Label 10063: @758026
     /* 758026 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(758065), // Rule ID 2932 //
     /* 758031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 758034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 758041 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 758041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_IMM),
     /* 758044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 758046 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 758048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 758053 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 758059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758063 */     GIR_RootConstrainSelectedInstOperands,
     /* 758064 */     // GIR_Coverage, 2932,
     /* 758064 */     GIR_EraseRootFromParent_Done,
     /* 758065 */   // Label 10064: @758065
     /* 758065 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(758097), // Rule ID 2933 //
     /* 758070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 758073 */     // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 758073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
     /* 758076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 758078 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 758080 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 758082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 758085 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 758091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758095 */     GIR_RootConstrainSelectedInstOperands,
     /* 758096 */     // GIR_Coverage, 2933,
     /* 758096 */     GIR_EraseRootFromParent_Done,
     /* 758097 */   // Label 10065: @758097
     /* 758097 */   GIM_Reject,
     /* 758098 */ // Label 10062: @758098
     /* 758098 */ GIM_Reject,
     /* 758099 */ // Label 160: @758099
     /* 758099 */ GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(758236),
     /* 758104 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 758107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 758110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 758113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
     /* 758117 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 758120 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(758164), // Rule ID 2940 //
     /* 758125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 758128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
     /* 758135 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 758135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
     /* 758138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 758140 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 758142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 758152 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 758158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758162 */     GIR_RootConstrainSelectedInstOperands,
     /* 758163 */     // GIR_Coverage, 2940,
     /* 758163 */     GIR_EraseRootFromParent_Done,
     /* 758164 */   // Label 10067: @758164
     /* 758164 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(758203), // Rule ID 2938 //
     /* 758169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 758172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 758179 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 758179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_IMM),
     /* 758182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 758184 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 758186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 758191 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 758197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758201 */     GIR_RootConstrainSelectedInstOperands,
     /* 758202 */     // GIR_Coverage, 2938,
     /* 758202 */     GIR_EraseRootFromParent_Done,
     /* 758203 */   // Label 10068: @758203
     /* 758203 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(758235), // Rule ID 2939 //
     /* 758208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 758211 */     // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
     /* 758211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
     /* 758214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
     /* 758216 */     GIR_RootToRootCopy, /*OpIdx*/1, // sbase
     /* 758218 */     GIR_RootToRootCopy, /*OpIdx*/2, // soffset
     /* 758220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 758223 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
     /* 758229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758233 */     GIR_RootConstrainSelectedInstOperands,
     /* 758234 */     // GIR_Coverage, 2939,
     /* 758234 */     GIR_EraseRootFromParent_Done,
     /* 758235 */   // Label 10069: @758235
     /* 758235 */   GIM_Reject,
     /* 758236 */ // Label 10066: @758236
     /* 758236 */ GIM_Reject,
     /* 758237 */ // Label 161: @758237
     /* 758237 */ GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(758343),
     /* 758242 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 758245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 758248 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(758302), // Rule ID 3549 //
     /* 758253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 758256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 758260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 758264 */     // MIs[1] Operand 1
     /* 758264 */     // No operand predicates
     /* 758264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 758266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 758273 */     // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
     /* 758273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
     /* 758276 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 758278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 758283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 758289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
     /* 758295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 758300 */     GIR_RootConstrainSelectedInstOperands,
     /* 758301 */     // GIR_Coverage, 3549,
     /* 758301 */     GIR_EraseRootFromParent_Done,
     /* 758302 */   // Label 10071: @758302
     /* 758302 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(758342), // Rule ID 3548 //
     /* 758307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
     /* 758310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
     /* 758314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
     /* 758321 */     // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
     /* 758321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
     /* 758324 */     GIR_RootToRootCopy, /*OpIdx*/0, // sbase
     /* 758326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
     /* 758331 */     GIR_RootToRootCopy, /*OpIdx*/2, // len
     /* 758333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 758336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758340 */     GIR_RootConstrainSelectedInstOperands,
     /* 758341 */     // GIR_Coverage, 3548,
     /* 758341 */     GIR_EraseRootFromParent_Done,
     /* 758342 */   // Label 10072: @758342
     /* 758342 */   GIM_Reject,
     /* 758343 */ // Label 10070: @758343
     /* 758343 */ GIM_Reject,
     /* 758344 */ // Label 162: @758344
     /* 758344 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 10077*/ GIMT_Encode4(763827),
     /* 758355 */ /*GILLT_s32*//*Label 10073*/ GIMT_Encode4(758391), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 758367 */ /*GILLT_v2s32*//*Label 10074*/ GIMT_Encode4(759750), GIMT_Encode4(0),
     /* 758375 */ /*GILLT_v3s32*//*Label 10075*/ GIMT_Encode4(761109), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 758387 */ /*GILLT_v4s32*//*Label 10076*/ GIMT_Encode4(762468),
     /* 758391 */ // Label 10073: @758391
     /* 758391 */ GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(759749),
     /* 758396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 758399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 758402 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 758405 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 758408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 758412 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(758493), // Rule ID 6664 //
     /* 758417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 758420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758428 */     // MIs[0] offset
     /* 758428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758431 */     // MIs[0] format
     /* 758431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758434 */     // MIs[0] auxiliary
     /* 758434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758437 */     // MIs[0] Operand 8
     /* 758437 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758455 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
     /* 758458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758467 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758469 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758475 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758481 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758491 */     GIR_RootConstrainSelectedInstOperands,
     /* 758492 */     // GIR_Coverage, 6664,
     /* 758492 */     GIR_EraseRootFromParent_Done,
     /* 758493 */   // Label 10079: @758493
     /* 758493 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(758571), // Rule ID 6668 //
     /* 758498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758506 */     // MIs[0] offset
     /* 758506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758509 */     // MIs[0] format
     /* 758509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758512 */     // MIs[0] auxiliary
     /* 758512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758515 */     // MIs[0] Operand 8
     /* 758515 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758533 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 758536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758545 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758559 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758569 */     GIR_RootConstrainSelectedInstOperands,
     /* 758570 */     // GIR_Coverage, 6668,
     /* 758570 */     GIR_EraseRootFromParent_Done,
     /* 758571 */   // Label 10080: @758571
     /* 758571 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(758652), // Rule ID 6696 //
     /* 758576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 758579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758587 */     // MIs[0] offset
     /* 758587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758590 */     // MIs[0] format
     /* 758590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758593 */     // MIs[0] auxiliary
     /* 758593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758596 */     // MIs[0] Operand 8
     /* 758596 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758614 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
     /* 758617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758626 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758628 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758634 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758640 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758650 */     GIR_RootConstrainSelectedInstOperands,
     /* 758651 */     // GIR_Coverage, 6696,
     /* 758651 */     GIR_EraseRootFromParent_Done,
     /* 758652 */   // Label 10081: @758652
     /* 758652 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(758730), // Rule ID 6700 //
     /* 758657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 758665 */     // MIs[0] offset
     /* 758665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758668 */     // MIs[0] format
     /* 758668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758671 */     // MIs[0] auxiliary
     /* 758671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758674 */     // MIs[0] Operand 8
     /* 758674 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758692 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
     /* 758695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758704 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758728 */     GIR_RootConstrainSelectedInstOperands,
     /* 758729 */     // GIR_Coverage, 6700,
     /* 758729 */     GIR_EraseRootFromParent_Done,
     /* 758730 */   // Label 10082: @758730
     /* 758730 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(758809), // Rule ID 6666 //
     /* 758735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 758738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758742 */     // MIs[0] offset
     /* 758742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758745 */     // MIs[0] format
     /* 758745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758748 */     // MIs[0] auxiliary
     /* 758748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758751 */     // MIs[0] Operand 8
     /* 758751 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758769 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
     /* 758772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758774 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758783 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758791 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758797 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758807 */     GIR_RootConstrainSelectedInstOperands,
     /* 758808 */     // GIR_Coverage, 6666,
     /* 758808 */     GIR_EraseRootFromParent_Done,
     /* 758809 */   // Label 10083: @758809
     /* 758809 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(758885), // Rule ID 6670 //
     /* 758814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758818 */     // MIs[0] offset
     /* 758818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758821 */     // MIs[0] format
     /* 758821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758824 */     // MIs[0] auxiliary
     /* 758824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758827 */     // MIs[0] Operand 8
     /* 758827 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758845 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 758848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758850 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758859 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758883 */     GIR_RootConstrainSelectedInstOperands,
     /* 758884 */     // GIR_Coverage, 6670,
     /* 758884 */     GIR_EraseRootFromParent_Done,
     /* 758885 */   // Label 10084: @758885
     /* 758885 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(758964), // Rule ID 6698 //
     /* 758890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 758893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758897 */     // MIs[0] offset
     /* 758897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758900 */     // MIs[0] format
     /* 758900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758903 */     // MIs[0] auxiliary
     /* 758903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758906 */     // MIs[0] Operand 8
     /* 758906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 758924 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 758924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
     /* 758927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 758929 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 758931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 758933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 758938 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 758940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 758946 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 758952 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 758958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 758962 */     GIR_RootConstrainSelectedInstOperands,
     /* 758963 */     // GIR_Coverage, 6698,
     /* 758963 */     GIR_EraseRootFromParent_Done,
     /* 758964 */   // Label 10085: @758964
     /* 758964 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(759040), // Rule ID 6702 //
     /* 758969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 758973 */     // MIs[0] offset
     /* 758973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 758976 */     // MIs[0] format
     /* 758976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 758979 */     // MIs[0] auxiliary
     /* 758979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 758982 */     // MIs[0] Operand 8
     /* 758982 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 758993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759000 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
     /* 759003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759005 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 759007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759014 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759038 */     GIR_RootConstrainSelectedInstOperands,
     /* 759039 */     // GIR_Coverage, 6702,
     /* 759039 */     GIR_EraseRootFromParent_Done,
     /* 759040 */   // Label 10086: @759040
     /* 759040 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(759111), // Rule ID 6665 //
     /* 759045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 759048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759052 */     // MIs[0] offset
     /* 759052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759055 */     // MIs[0] format
     /* 759055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759058 */     // MIs[0] auxiliary
     /* 759058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759061 */     // MIs[0] Operand 8
     /* 759061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759071 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
     /* 759074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759076 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759085 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759109 */     GIR_RootConstrainSelectedInstOperands,
     /* 759110 */     // GIR_Coverage, 6665,
     /* 759110 */     GIR_EraseRootFromParent_Done,
     /* 759111 */   // Label 10087: @759111
     /* 759111 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(759179), // Rule ID 6669 //
     /* 759116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759120 */     // MIs[0] offset
     /* 759120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759123 */     // MIs[0] format
     /* 759123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759126 */     // MIs[0] auxiliary
     /* 759126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759129 */     // MIs[0] Operand 8
     /* 759129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759139 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 759142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759144 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759153 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759155 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759161 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759177 */     GIR_RootConstrainSelectedInstOperands,
     /* 759178 */     // GIR_Coverage, 6669,
     /* 759178 */     GIR_EraseRootFromParent_Done,
     /* 759179 */   // Label 10088: @759179
     /* 759179 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(759250), // Rule ID 6697 //
     /* 759184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 759187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759191 */     // MIs[0] offset
     /* 759191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759194 */     // MIs[0] format
     /* 759194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759197 */     // MIs[0] auxiliary
     /* 759197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759200 */     // MIs[0] Operand 8
     /* 759200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759210 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
     /* 759213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759215 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759224 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759248 */     GIR_RootConstrainSelectedInstOperands,
     /* 759249 */     // GIR_Coverage, 6697,
     /* 759249 */     GIR_EraseRootFromParent_Done,
     /* 759250 */   // Label 10089: @759250
     /* 759250 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(759318), // Rule ID 6701 //
     /* 759255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759259 */     // MIs[0] offset
     /* 759259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759262 */     // MIs[0] format
     /* 759262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759265 */     // MIs[0] auxiliary
     /* 759265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759268 */     // MIs[0] Operand 8
     /* 759268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759278 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
     /* 759281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759283 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 759285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759292 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759306 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759316 */     GIR_RootConstrainSelectedInstOperands,
     /* 759317 */     // GIR_Coverage, 6701,
     /* 759317 */     GIR_EraseRootFromParent_Done,
     /* 759318 */   // Label 10090: @759318
     /* 759318 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(759427), // Rule ID 6667 //
     /* 759323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 759326 */     // MIs[0] offset
     /* 759326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759329 */     // MIs[0] format
     /* 759329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759332 */     // MIs[0] auxiliary
     /* 759332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759335 */     // MIs[0] Operand 8
     /* 759335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759345 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759361 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759368 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 759389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759401 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759409 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759415 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759425 */     GIR_RootConstrainSelectedInstOperands,
     /* 759426 */     // GIR_Coverage, 6667,
     /* 759426 */     GIR_EraseRootFromParent_Done,
     /* 759427 */   // Label 10091: @759427
     /* 759427 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(759533), // Rule ID 6671 //
     /* 759432 */     // MIs[0] offset
     /* 759432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759435 */     // MIs[0] format
     /* 759435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759438 */     // MIs[0] auxiliary
     /* 759438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759441 */     // MIs[0] Operand 8
     /* 759441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759451 */     // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759467 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759474 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 759495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759507 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759531 */     GIR_RootConstrainSelectedInstOperands,
     /* 759532 */     // GIR_Coverage, 6671,
     /* 759532 */     GIR_EraseRootFromParent_Done,
     /* 759533 */   // Label 10092: @759533
     /* 759533 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(759642), // Rule ID 6699 //
     /* 759538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 759541 */     // MIs[0] offset
     /* 759541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759544 */     // MIs[0] format
     /* 759544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759547 */     // MIs[0] auxiliary
     /* 759547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759550 */     // MIs[0] Operand 8
     /* 759550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759560 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759576 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759583 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
     /* 759604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759616 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759640 */     GIR_RootConstrainSelectedInstOperands,
     /* 759641 */     // GIR_Coverage, 6699,
     /* 759641 */     GIR_EraseRootFromParent_Done,
     /* 759642 */   // Label 10093: @759642
     /* 759642 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(759748), // Rule ID 6703 //
     /* 759647 */     // MIs[0] offset
     /* 759647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759650 */     // MIs[0] format
     /* 759650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759653 */     // MIs[0] auxiliary
     /* 759653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759656 */     // MIs[0] Operand 8
     /* 759656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 759659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759666 */     // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 759669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 759673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 759678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 759682 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 759685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 759689 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 759692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 759697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 759707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
     /* 759710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 759715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759722 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759724 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759730 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759736 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759746 */     GIR_RootConstrainSelectedInstOperands,
     /* 759747 */     // GIR_Coverage, 6703,
     /* 759747 */     GIR_EraseRootFromParent_Done,
     /* 759748 */   // Label 10094: @759748
     /* 759748 */   GIM_Reject,
     /* 759749 */ // Label 10078: @759749
     /* 759749 */ GIM_Reject,
     /* 759750 */ // Label 10074: @759750
     /* 759750 */ GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(761108),
     /* 759755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 759758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 759761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 759764 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 759767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 759771 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(759852), // Rule ID 6672 //
     /* 759776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 759779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759787 */     // MIs[0] offset
     /* 759787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759790 */     // MIs[0] format
     /* 759790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759793 */     // MIs[0] auxiliary
     /* 759793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759796 */     // MIs[0] Operand 8
     /* 759796 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759814 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 759817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759826 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759850 */     GIR_RootConstrainSelectedInstOperands,
     /* 759851 */     // GIR_Coverage, 6672,
     /* 759851 */     GIR_EraseRootFromParent_Done,
     /* 759852 */   // Label 10096: @759852
     /* 759852 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(759930), // Rule ID 6676 //
     /* 759857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759865 */     // MIs[0] offset
     /* 759865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759868 */     // MIs[0] format
     /* 759868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759871 */     // MIs[0] auxiliary
     /* 759871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759874 */     // MIs[0] Operand 8
     /* 759874 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759892 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 759895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759904 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759906 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759912 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759918 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 759924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 759928 */     GIR_RootConstrainSelectedInstOperands,
     /* 759929 */     // GIR_Coverage, 6676,
     /* 759929 */     GIR_EraseRootFromParent_Done,
     /* 759930 */   // Label 10097: @759930
     /* 759930 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(760011), // Rule ID 6704 //
     /* 759935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 759938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 759942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 759946 */     // MIs[0] offset
     /* 759946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 759949 */     // MIs[0] format
     /* 759949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 759952 */     // MIs[0] auxiliary
     /* 759952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 759955 */     // MIs[0] Operand 8
     /* 759955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 759966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 759973 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 759973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
     /* 759976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 759978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 759980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 759985 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 759987 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 759993 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 759999 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760009 */     GIR_RootConstrainSelectedInstOperands,
     /* 760010 */     // GIR_Coverage, 6704,
     /* 760010 */     GIR_EraseRootFromParent_Done,
     /* 760011 */   // Label 10098: @760011
     /* 760011 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(760089), // Rule ID 6708 //
     /* 760016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760024 */     // MIs[0] offset
     /* 760024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760027 */     // MIs[0] format
     /* 760027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760030 */     // MIs[0] auxiliary
     /* 760030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760033 */     // MIs[0] Operand 8
     /* 760033 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760051 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
     /* 760054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760063 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760087 */     GIR_RootConstrainSelectedInstOperands,
     /* 760088 */     // GIR_Coverage, 6708,
     /* 760088 */     GIR_EraseRootFromParent_Done,
     /* 760089 */   // Label 10099: @760089
     /* 760089 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(760168), // Rule ID 6674 //
     /* 760094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 760097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760101 */     // MIs[0] offset
     /* 760101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760104 */     // MIs[0] format
     /* 760104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760107 */     // MIs[0] auxiliary
     /* 760107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760110 */     // MIs[0] Operand 8
     /* 760110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760128 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 760131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760133 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760142 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760144 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760150 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760156 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760166 */     GIR_RootConstrainSelectedInstOperands,
     /* 760167 */     // GIR_Coverage, 6674,
     /* 760167 */     GIR_EraseRootFromParent_Done,
     /* 760168 */   // Label 10100: @760168
     /* 760168 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(760244), // Rule ID 6678 //
     /* 760173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760177 */     // MIs[0] offset
     /* 760177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760180 */     // MIs[0] format
     /* 760180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760183 */     // MIs[0] auxiliary
     /* 760183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760186 */     // MIs[0] Operand 8
     /* 760186 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760204 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 760207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760209 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760218 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760220 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760226 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760242 */     GIR_RootConstrainSelectedInstOperands,
     /* 760243 */     // GIR_Coverage, 6678,
     /* 760243 */     GIR_EraseRootFromParent_Done,
     /* 760244 */   // Label 10101: @760244
     /* 760244 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(760323), // Rule ID 6706 //
     /* 760249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 760252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760256 */     // MIs[0] offset
     /* 760256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760259 */     // MIs[0] format
     /* 760259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760262 */     // MIs[0] auxiliary
     /* 760262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760265 */     // MIs[0] Operand 8
     /* 760265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760283 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
     /* 760286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760288 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760297 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760299 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760305 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760311 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760321 */     GIR_RootConstrainSelectedInstOperands,
     /* 760322 */     // GIR_Coverage, 6706,
     /* 760322 */     GIR_EraseRootFromParent_Done,
     /* 760323 */   // Label 10102: @760323
     /* 760323 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(760399), // Rule ID 6710 //
     /* 760328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 760332 */     // MIs[0] offset
     /* 760332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760335 */     // MIs[0] format
     /* 760335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760338 */     // MIs[0] auxiliary
     /* 760338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760341 */     // MIs[0] Operand 8
     /* 760341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 760352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760359 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
     /* 760362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760364 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 760366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760373 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760375 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760381 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760387 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760397 */     GIR_RootConstrainSelectedInstOperands,
     /* 760398 */     // GIR_Coverage, 6710,
     /* 760398 */     GIR_EraseRootFromParent_Done,
     /* 760399 */   // Label 10103: @760399
     /* 760399 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(760470), // Rule ID 6673 //
     /* 760404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 760407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760411 */     // MIs[0] offset
     /* 760411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760414 */     // MIs[0] format
     /* 760414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760417 */     // MIs[0] auxiliary
     /* 760417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760420 */     // MIs[0] Operand 8
     /* 760420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760430 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 760433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760435 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760444 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760452 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760458 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760468 */     GIR_RootConstrainSelectedInstOperands,
     /* 760469 */     // GIR_Coverage, 6673,
     /* 760469 */     GIR_EraseRootFromParent_Done,
     /* 760470 */   // Label 10104: @760470
     /* 760470 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(760538), // Rule ID 6677 //
     /* 760475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760479 */     // MIs[0] offset
     /* 760479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760482 */     // MIs[0] format
     /* 760482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760485 */     // MIs[0] auxiliary
     /* 760485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760488 */     // MIs[0] Operand 8
     /* 760488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760498 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 760501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760503 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760512 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760514 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760520 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760526 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760536 */     GIR_RootConstrainSelectedInstOperands,
     /* 760537 */     // GIR_Coverage, 6677,
     /* 760537 */     GIR_EraseRootFromParent_Done,
     /* 760538 */   // Label 10105: @760538
     /* 760538 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(760609), // Rule ID 6705 //
     /* 760543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 760546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760550 */     // MIs[0] offset
     /* 760550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760553 */     // MIs[0] format
     /* 760553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760556 */     // MIs[0] auxiliary
     /* 760556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760559 */     // MIs[0] Operand 8
     /* 760559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760569 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
     /* 760572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760574 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760583 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760597 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760607 */     GIR_RootConstrainSelectedInstOperands,
     /* 760608 */     // GIR_Coverage, 6705,
     /* 760608 */     GIR_EraseRootFromParent_Done,
     /* 760609 */   // Label 10106: @760609
     /* 760609 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(760677), // Rule ID 6709 //
     /* 760614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 760618 */     // MIs[0] offset
     /* 760618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760621 */     // MIs[0] format
     /* 760621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760624 */     // MIs[0] auxiliary
     /* 760624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760627 */     // MIs[0] Operand 8
     /* 760627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760637 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
     /* 760640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760642 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 760644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760651 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760659 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760665 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760675 */     GIR_RootConstrainSelectedInstOperands,
     /* 760676 */     // GIR_Coverage, 6709,
     /* 760676 */     GIR_EraseRootFromParent_Done,
     /* 760677 */   // Label 10107: @760677
     /* 760677 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(760786), // Rule ID 6675 //
     /* 760682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 760685 */     // MIs[0] offset
     /* 760685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760688 */     // MIs[0] format
     /* 760688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760691 */     // MIs[0] auxiliary
     /* 760691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760694 */     // MIs[0] Operand 8
     /* 760694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760704 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760720 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760727 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 760748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760760 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760762 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760768 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760784 */     GIR_RootConstrainSelectedInstOperands,
     /* 760785 */     // GIR_Coverage, 6675,
     /* 760785 */     GIR_EraseRootFromParent_Done,
     /* 760786 */   // Label 10108: @760786
     /* 760786 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(760892), // Rule ID 6679 //
     /* 760791 */     // MIs[0] offset
     /* 760791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760794 */     // MIs[0] format
     /* 760794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760797 */     // MIs[0] auxiliary
     /* 760797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760800 */     // MIs[0] Operand 8
     /* 760800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760810 */     // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760826 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760833 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 760854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760866 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760880 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760890 */     GIR_RootConstrainSelectedInstOperands,
     /* 760891 */     // GIR_Coverage, 6679,
     /* 760891 */     GIR_EraseRootFromParent_Done,
     /* 760892 */   // Label 10109: @760892
     /* 760892 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(761001), // Rule ID 6707 //
     /* 760897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 760900 */     // MIs[0] offset
     /* 760900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 760903 */     // MIs[0] format
     /* 760903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 760906 */     // MIs[0] auxiliary
     /* 760906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 760909 */     // MIs[0] Operand 8
     /* 760909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 760912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 760919 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 760919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 760922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 760926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 760931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 760935 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 760938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 760942 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 760945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 760950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 760960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
     /* 760963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 760965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 760968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 760970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 760975 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 760977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 760983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 760989 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 760995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 760999 */     GIR_RootConstrainSelectedInstOperands,
     /* 761000 */     // GIR_Coverage, 6707,
     /* 761000 */     GIR_EraseRootFromParent_Done,
     /* 761001 */   // Label 10110: @761001
     /* 761001 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(761107), // Rule ID 6711 //
     /* 761006 */     // MIs[0] offset
     /* 761006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761009 */     // MIs[0] format
     /* 761009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761012 */     // MIs[0] auxiliary
     /* 761012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761015 */     // MIs[0] Operand 8
     /* 761015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761025 */     // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 761028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 761032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 761037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 761041 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 761044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 761048 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 761051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 761056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 761066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
     /* 761069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 761074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761081 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761083 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761089 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761095 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761105 */     GIR_RootConstrainSelectedInstOperands,
     /* 761106 */     // GIR_Coverage, 6711,
     /* 761106 */     GIR_EraseRootFromParent_Done,
     /* 761107 */   // Label 10111: @761107
     /* 761107 */   GIM_Reject,
     /* 761108 */ // Label 10095: @761108
     /* 761108 */ GIM_Reject,
     /* 761109 */ // Label 10075: @761109
     /* 761109 */ GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(762467),
     /* 761114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 761117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 761120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 761123 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 761126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 761130 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(761211), // Rule ID 6680 //
     /* 761135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 761138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761146 */     // MIs[0] offset
     /* 761146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761149 */     // MIs[0] format
     /* 761149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761152 */     // MIs[0] auxiliary
     /* 761152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761155 */     // MIs[0] Operand 8
     /* 761155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761173 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 761176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761185 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761187 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761193 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761199 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761209 */     GIR_RootConstrainSelectedInstOperands,
     /* 761210 */     // GIR_Coverage, 6680,
     /* 761210 */     GIR_EraseRootFromParent_Done,
     /* 761211 */   // Label 10113: @761211
     /* 761211 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(761289), // Rule ID 6684 //
     /* 761216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761224 */     // MIs[0] offset
     /* 761224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761227 */     // MIs[0] format
     /* 761227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761230 */     // MIs[0] auxiliary
     /* 761230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761233 */     // MIs[0] Operand 8
     /* 761233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761251 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 761254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761263 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761287 */     GIR_RootConstrainSelectedInstOperands,
     /* 761288 */     // GIR_Coverage, 6684,
     /* 761288 */     GIR_EraseRootFromParent_Done,
     /* 761289 */   // Label 10114: @761289
     /* 761289 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(761370), // Rule ID 6712 //
     /* 761294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 761297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761305 */     // MIs[0] offset
     /* 761305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761308 */     // MIs[0] format
     /* 761308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761311 */     // MIs[0] auxiliary
     /* 761311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761314 */     // MIs[0] Operand 8
     /* 761314 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761332 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
     /* 761335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761344 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761368 */     GIR_RootConstrainSelectedInstOperands,
     /* 761369 */     // GIR_Coverage, 6712,
     /* 761369 */     GIR_EraseRootFromParent_Done,
     /* 761370 */   // Label 10115: @761370
     /* 761370 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(761448), // Rule ID 6716 //
     /* 761375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761383 */     // MIs[0] offset
     /* 761383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761386 */     // MIs[0] format
     /* 761386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761389 */     // MIs[0] auxiliary
     /* 761389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761392 */     // MIs[0] Operand 8
     /* 761392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761410 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
     /* 761413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761422 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761446 */     GIR_RootConstrainSelectedInstOperands,
     /* 761447 */     // GIR_Coverage, 6716,
     /* 761447 */     GIR_EraseRootFromParent_Done,
     /* 761448 */   // Label 10116: @761448
     /* 761448 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(761527), // Rule ID 6682 //
     /* 761453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 761456 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761460 */     // MIs[0] offset
     /* 761460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761463 */     // MIs[0] format
     /* 761463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761466 */     // MIs[0] auxiliary
     /* 761466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761469 */     // MIs[0] Operand 8
     /* 761469 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761487 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 761490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761492 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761501 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761503 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761509 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761515 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761525 */     GIR_RootConstrainSelectedInstOperands,
     /* 761526 */     // GIR_Coverage, 6682,
     /* 761526 */     GIR_EraseRootFromParent_Done,
     /* 761527 */   // Label 10117: @761527
     /* 761527 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(761603), // Rule ID 6686 //
     /* 761532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761536 */     // MIs[0] offset
     /* 761536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761539 */     // MIs[0] format
     /* 761539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761542 */     // MIs[0] auxiliary
     /* 761542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761545 */     // MIs[0] Operand 8
     /* 761545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761563 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 761566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761568 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761577 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761579 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761585 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761591 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761601 */     GIR_RootConstrainSelectedInstOperands,
     /* 761602 */     // GIR_Coverage, 6686,
     /* 761602 */     GIR_EraseRootFromParent_Done,
     /* 761603 */   // Label 10118: @761603
     /* 761603 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(761682), // Rule ID 6714 //
     /* 761608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 761611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761615 */     // MIs[0] offset
     /* 761615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761618 */     // MIs[0] format
     /* 761618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761621 */     // MIs[0] auxiliary
     /* 761621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761624 */     // MIs[0] Operand 8
     /* 761624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761642 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
     /* 761645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761647 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761656 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761658 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761664 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761670 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761680 */     GIR_RootConstrainSelectedInstOperands,
     /* 761681 */     // GIR_Coverage, 6714,
     /* 761681 */     GIR_EraseRootFromParent_Done,
     /* 761682 */   // Label 10119: @761682
     /* 761682 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(761758), // Rule ID 6718 //
     /* 761687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 761691 */     // MIs[0] offset
     /* 761691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761694 */     // MIs[0] format
     /* 761694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761697 */     // MIs[0] auxiliary
     /* 761697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761700 */     // MIs[0] Operand 8
     /* 761700 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 761711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761718 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
     /* 761721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761723 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 761725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761732 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761734 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761740 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761756 */     GIR_RootConstrainSelectedInstOperands,
     /* 761757 */     // GIR_Coverage, 6718,
     /* 761757 */     GIR_EraseRootFromParent_Done,
     /* 761758 */   // Label 10120: @761758
     /* 761758 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(761829), // Rule ID 6681 //
     /* 761763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 761766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761770 */     // MIs[0] offset
     /* 761770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761773 */     // MIs[0] format
     /* 761773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761776 */     // MIs[0] auxiliary
     /* 761776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761779 */     // MIs[0] Operand 8
     /* 761779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761789 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 761792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761794 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 761796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761803 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761805 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761811 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761827 */     GIR_RootConstrainSelectedInstOperands,
     /* 761828 */     // GIR_Coverage, 6681,
     /* 761828 */     GIR_EraseRootFromParent_Done,
     /* 761829 */   // Label 10121: @761829
     /* 761829 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(761897), // Rule ID 6685 //
     /* 761834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761838 */     // MIs[0] offset
     /* 761838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761841 */     // MIs[0] format
     /* 761841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761844 */     // MIs[0] auxiliary
     /* 761844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761847 */     // MIs[0] Operand 8
     /* 761847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761857 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 761860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761862 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 761864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761871 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761885 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761895 */     GIR_RootConstrainSelectedInstOperands,
     /* 761896 */     // GIR_Coverage, 6685,
     /* 761896 */     GIR_EraseRootFromParent_Done,
     /* 761897 */   // Label 10122: @761897
     /* 761897 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(761968), // Rule ID 6713 //
     /* 761902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 761905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761909 */     // MIs[0] offset
     /* 761909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761912 */     // MIs[0] format
     /* 761912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761915 */     // MIs[0] auxiliary
     /* 761915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761918 */     // MIs[0] Operand 8
     /* 761918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761928 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
     /* 761931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 761933 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 761935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 761937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 761942 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 761944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 761950 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 761956 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 761962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 761966 */     GIR_RootConstrainSelectedInstOperands,
     /* 761967 */     // GIR_Coverage, 6713,
     /* 761967 */     GIR_EraseRootFromParent_Done,
     /* 761968 */   // Label 10123: @761968
     /* 761968 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(762036), // Rule ID 6717 //
     /* 761973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 761977 */     // MIs[0] offset
     /* 761977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 761980 */     // MIs[0] format
     /* 761980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 761983 */     // MIs[0] auxiliary
     /* 761983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 761986 */     // MIs[0] Operand 8
     /* 761986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 761989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 761996 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 761996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
     /* 761999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762001 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 762003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762010 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762034 */     GIR_RootConstrainSelectedInstOperands,
     /* 762035 */     // GIR_Coverage, 6717,
     /* 762035 */     GIR_EraseRootFromParent_Done,
     /* 762036 */   // Label 10124: @762036
     /* 762036 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(762145), // Rule ID 6683 //
     /* 762041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 762044 */     // MIs[0] offset
     /* 762044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762047 */     // MIs[0] format
     /* 762047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762050 */     // MIs[0] auxiliary
     /* 762050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762053 */     // MIs[0] Operand 8
     /* 762053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762063 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 762066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 762070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 762075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 762079 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 762082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 762086 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 762089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 762094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 762107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 762112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762119 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762143 */     GIR_RootConstrainSelectedInstOperands,
     /* 762144 */     // GIR_Coverage, 6683,
     /* 762144 */     GIR_EraseRootFromParent_Done,
     /* 762145 */   // Label 10125: @762145
     /* 762145 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(762251), // Rule ID 6687 //
     /* 762150 */     // MIs[0] offset
     /* 762150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762153 */     // MIs[0] format
     /* 762153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762156 */     // MIs[0] auxiliary
     /* 762156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762159 */     // MIs[0] Operand 8
     /* 762159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762169 */     // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 762172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 762176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 762181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 762185 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 762188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 762192 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 762195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 762200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 762213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 762218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762225 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762227 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762233 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762239 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762249 */     GIR_RootConstrainSelectedInstOperands,
     /* 762250 */     // GIR_Coverage, 6687,
     /* 762250 */     GIR_EraseRootFromParent_Done,
     /* 762251 */   // Label 10126: @762251
     /* 762251 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(762360), // Rule ID 6715 //
     /* 762256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 762259 */     // MIs[0] offset
     /* 762259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762262 */     // MIs[0] format
     /* 762262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762265 */     // MIs[0] auxiliary
     /* 762265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762268 */     // MIs[0] Operand 8
     /* 762268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762278 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 762281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 762285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 762290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 762294 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 762297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 762301 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 762304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 762309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
     /* 762322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 762327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762334 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762336 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762342 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762348 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762358 */     GIR_RootConstrainSelectedInstOperands,
     /* 762359 */     // GIR_Coverage, 6715,
     /* 762359 */     GIR_EraseRootFromParent_Done,
     /* 762360 */   // Label 10127: @762360
     /* 762360 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(762466), // Rule ID 6719 //
     /* 762365 */     // MIs[0] offset
     /* 762365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762368 */     // MIs[0] format
     /* 762368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762371 */     // MIs[0] auxiliary
     /* 762371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762374 */     // MIs[0] Operand 8
     /* 762374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 762377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762384 */     // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 762387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 762391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 762396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 762400 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 762403 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 762407 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 762410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 762415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 762425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
     /* 762428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 762433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762440 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762448 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762454 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762464 */     GIR_RootConstrainSelectedInstOperands,
     /* 762465 */     // GIR_Coverage, 6719,
     /* 762465 */     GIR_EraseRootFromParent_Done,
     /* 762466 */   // Label 10128: @762466
     /* 762466 */   GIM_Reject,
     /* 762467 */ // Label 10112: @762467
     /* 762467 */ GIM_Reject,
     /* 762468 */ // Label 10076: @762468
     /* 762468 */ GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(763826),
     /* 762473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 762476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 762479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 762482 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 762485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 762489 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(762570), // Rule ID 6688 //
     /* 762494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 762497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762505 */     // MIs[0] offset
     /* 762505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762508 */     // MIs[0] format
     /* 762508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762511 */     // MIs[0] auxiliary
     /* 762511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762514 */     // MIs[0] Operand 8
     /* 762514 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762532 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 762535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762544 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762546 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762552 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762568 */     GIR_RootConstrainSelectedInstOperands,
     /* 762569 */     // GIR_Coverage, 6688,
     /* 762569 */     GIR_EraseRootFromParent_Done,
     /* 762570 */   // Label 10130: @762570
     /* 762570 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(762648), // Rule ID 6692 //
     /* 762575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762583 */     // MIs[0] offset
     /* 762583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762586 */     // MIs[0] format
     /* 762586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762589 */     // MIs[0] auxiliary
     /* 762589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762592 */     // MIs[0] Operand 8
     /* 762592 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762610 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 762613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762622 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762630 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762636 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762646 */     GIR_RootConstrainSelectedInstOperands,
     /* 762647 */     // GIR_Coverage, 6692,
     /* 762647 */     GIR_EraseRootFromParent_Done,
     /* 762648 */   // Label 10131: @762648
     /* 762648 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(762729), // Rule ID 6720 //
     /* 762653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 762656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762664 */     // MIs[0] offset
     /* 762664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762667 */     // MIs[0] format
     /* 762667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762670 */     // MIs[0] auxiliary
     /* 762670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762673 */     // MIs[0] Operand 8
     /* 762673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762691 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
     /* 762694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762703 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762705 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762711 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762717 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762727 */     GIR_RootConstrainSelectedInstOperands,
     /* 762728 */     // GIR_Coverage, 6720,
     /* 762728 */     GIR_EraseRootFromParent_Done,
     /* 762729 */   // Label 10132: @762729
     /* 762729 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(762807), // Rule ID 6724 //
     /* 762734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 762742 */     // MIs[0] offset
     /* 762742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762745 */     // MIs[0] format
     /* 762745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762748 */     // MIs[0] auxiliary
     /* 762748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762751 */     // MIs[0] Operand 8
     /* 762751 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762769 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
     /* 762772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762781 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762795 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762805 */     GIR_RootConstrainSelectedInstOperands,
     /* 762806 */     // GIR_Coverage, 6724,
     /* 762806 */     GIR_EraseRootFromParent_Done,
     /* 762807 */   // Label 10133: @762807
     /* 762807 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(762886), // Rule ID 6690 //
     /* 762812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 762815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762819 */     // MIs[0] offset
     /* 762819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762822 */     // MIs[0] format
     /* 762822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762825 */     // MIs[0] auxiliary
     /* 762825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762828 */     // MIs[0] Operand 8
     /* 762828 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762846 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 762849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762851 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762860 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762868 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762874 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762884 */     GIR_RootConstrainSelectedInstOperands,
     /* 762885 */     // GIR_Coverage, 6690,
     /* 762885 */     GIR_EraseRootFromParent_Done,
     /* 762886 */   // Label 10134: @762886
     /* 762886 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(762962), // Rule ID 6694 //
     /* 762891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762895 */     // MIs[0] offset
     /* 762895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762898 */     // MIs[0] format
     /* 762898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762901 */     // MIs[0] auxiliary
     /* 762901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762904 */     // MIs[0] Operand 8
     /* 762904 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 762922 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 762922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 762925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 762927 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 762929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 762931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 762936 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 762938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 762944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 762950 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 762956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 762960 */     GIR_RootConstrainSelectedInstOperands,
     /* 762961 */     // GIR_Coverage, 6694,
     /* 762961 */     GIR_EraseRootFromParent_Done,
     /* 762962 */   // Label 10135: @762962
     /* 762962 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(763041), // Rule ID 6722 //
     /* 762967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 762970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 762974 */     // MIs[0] offset
     /* 762974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 762977 */     // MIs[0] format
     /* 762977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 762980 */     // MIs[0] auxiliary
     /* 762980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 762983 */     // MIs[0] Operand 8
     /* 762983 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 762994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763001 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
     /* 763004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763006 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 763008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763015 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763023 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763029 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763039 */     GIR_RootConstrainSelectedInstOperands,
     /* 763040 */     // GIR_Coverage, 6722,
     /* 763040 */     GIR_EraseRootFromParent_Done,
     /* 763041 */   // Label 10136: @763041
     /* 763041 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(763117), // Rule ID 6726 //
     /* 763046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763050 */     // MIs[0] offset
     /* 763050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763053 */     // MIs[0] format
     /* 763053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763056 */     // MIs[0] auxiliary
     /* 763056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763059 */     // MIs[0] Operand 8
     /* 763059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763077 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
     /* 763080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763082 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 763084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763091 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763105 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763115 */     GIR_RootConstrainSelectedInstOperands,
     /* 763116 */     // GIR_Coverage, 6726,
     /* 763116 */     GIR_EraseRootFromParent_Done,
     /* 763117 */   // Label 10137: @763117
     /* 763117 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(763188), // Rule ID 6689 //
     /* 763122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763129 */     // MIs[0] offset
     /* 763129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763132 */     // MIs[0] format
     /* 763132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763135 */     // MIs[0] auxiliary
     /* 763135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763138 */     // MIs[0] Operand 8
     /* 763138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763148 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 763151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763153 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 763155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763162 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763164 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763186 */     GIR_RootConstrainSelectedInstOperands,
     /* 763187 */     // GIR_Coverage, 6689,
     /* 763187 */     GIR_EraseRootFromParent_Done,
     /* 763188 */   // Label 10138: @763188
     /* 763188 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(763256), // Rule ID 6693 //
     /* 763193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763197 */     // MIs[0] offset
     /* 763197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763200 */     // MIs[0] format
     /* 763200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763203 */     // MIs[0] auxiliary
     /* 763203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763206 */     // MIs[0] Operand 8
     /* 763206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763216 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 763219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763221 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 763223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763230 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763232 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763254 */     GIR_RootConstrainSelectedInstOperands,
     /* 763255 */     // GIR_Coverage, 6693,
     /* 763255 */     GIR_EraseRootFromParent_Done,
     /* 763256 */   // Label 10139: @763256
     /* 763256 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(763327), // Rule ID 6721 //
     /* 763261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763268 */     // MIs[0] offset
     /* 763268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763271 */     // MIs[0] format
     /* 763271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763274 */     // MIs[0] auxiliary
     /* 763274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763277 */     // MIs[0] Operand 8
     /* 763277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763287 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
     /* 763290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763292 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 763294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763301 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763303 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763325 */     GIR_RootConstrainSelectedInstOperands,
     /* 763326 */     // GIR_Coverage, 6721,
     /* 763326 */     GIR_EraseRootFromParent_Done,
     /* 763327 */   // Label 10140: @763327
     /* 763327 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(763395), // Rule ID 6725 //
     /* 763332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763336 */     // MIs[0] offset
     /* 763336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763339 */     // MIs[0] format
     /* 763339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763342 */     // MIs[0] auxiliary
     /* 763342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763345 */     // MIs[0] Operand 8
     /* 763345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763355 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
     /* 763358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763360 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 763362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763369 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763383 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763393 */     GIR_RootConstrainSelectedInstOperands,
     /* 763394 */     // GIR_Coverage, 6725,
     /* 763394 */     GIR_EraseRootFromParent_Done,
     /* 763395 */   // Label 10141: @763395
     /* 763395 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(763504), // Rule ID 6691 //
     /* 763400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763403 */     // MIs[0] offset
     /* 763403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763406 */     // MIs[0] format
     /* 763406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763409 */     // MIs[0] auxiliary
     /* 763409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763412 */     // MIs[0] Operand 8
     /* 763412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763422 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763438 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763445 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 763466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763478 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763502 */     GIR_RootConstrainSelectedInstOperands,
     /* 763503 */     // GIR_Coverage, 6691,
     /* 763503 */     GIR_EraseRootFromParent_Done,
     /* 763504 */   // Label 10142: @763504
     /* 763504 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(763610), // Rule ID 6695 //
     /* 763509 */     // MIs[0] offset
     /* 763509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763512 */     // MIs[0] format
     /* 763512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763515 */     // MIs[0] auxiliary
     /* 763515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763518 */     // MIs[0] Operand 8
     /* 763518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763528 */     // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763544 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763551 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 763572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763584 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763586 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763608 */     GIR_RootConstrainSelectedInstOperands,
     /* 763609 */     // GIR_Coverage, 6695,
     /* 763609 */     GIR_EraseRootFromParent_Done,
     /* 763610 */   // Label 10143: @763610
     /* 763610 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(763719), // Rule ID 6723 //
     /* 763615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 763618 */     // MIs[0] offset
     /* 763618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763621 */     // MIs[0] format
     /* 763621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763624 */     // MIs[0] auxiliary
     /* 763624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763627 */     // MIs[0] Operand 8
     /* 763627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763637 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763653 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763660 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
     /* 763681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763693 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763695 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763701 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763707 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763717 */     GIR_RootConstrainSelectedInstOperands,
     /* 763718 */     // GIR_Coverage, 6723,
     /* 763718 */     GIR_EraseRootFromParent_Done,
     /* 763719 */   // Label 10144: @763719
     /* 763719 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(763825), // Rule ID 6727 //
     /* 763724 */     // MIs[0] offset
     /* 763724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763727 */     // MIs[0] format
     /* 763727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763730 */     // MIs[0] auxiliary
     /* 763730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763733 */     // MIs[0] Operand 8
     /* 763733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 763736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763743 */     // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 763746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 763750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 763755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 763759 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 763762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 763766 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 763769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 763774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 763784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
     /* 763787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 763792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763799 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763807 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763813 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763823 */     GIR_RootConstrainSelectedInstOperands,
     /* 763824 */     // GIR_Coverage, 6727,
     /* 763824 */     GIR_EraseRootFromParent_Done,
     /* 763825 */   // Label 10145: @763825
     /* 763825 */   GIM_Reject,
     /* 763826 */ // Label 10129: @763826
     /* 763826 */ GIM_Reject,
     /* 763827 */ // Label 10077: @763827
     /* 763827 */ GIM_Reject,
     /* 763828 */ // Label 163: @763828
     /* 763828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 10153*/ GIMT_Encode4(769256),
     /* 763839 */ /*GILLT_s16*//*Label 10146*/ GIMT_Encode4(763879),
     /* 763843 */ /*GILLT_s32*//*Label 10147*/ GIMT_Encode4(764922), GIMT_Encode4(0),
     /* 763851 */ /*GILLT_v2s16*//*Label 10148*/ GIMT_Encode4(765965),
     /* 763855 */ /*GILLT_v2s32*//*Label 10149*/ GIMT_Encode4(766668), GIMT_Encode4(0),
     /* 763863 */ /*GILLT_v3s32*//*Label 10150*/ GIMT_Encode4(767031), GIMT_Encode4(0),
     /* 763871 */ /*GILLT_v4s16*//*Label 10151*/ GIMT_Encode4(767394),
     /* 763875 */ /*GILLT_v4s32*//*Label 10152*/ GIMT_Encode4(768893),
     /* 763879 */ // Label 10146: @763879
     /* 763879 */ GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(764921),
     /* 763884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 763887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 763890 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 763893 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 763896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 763900 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(763981), // Rule ID 6728 //
     /* 763905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 763908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763916 */     // MIs[0] offset
     /* 763916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 763919 */     // MIs[0] format
     /* 763919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 763922 */     // MIs[0] auxiliary
     /* 763922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 763925 */     // MIs[0] Operand 8
     /* 763925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 763936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 763943 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 763943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 763946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 763948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 763950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 763955 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 763957 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 763963 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 763969 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 763975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 763979 */     GIR_RootConstrainSelectedInstOperands,
     /* 763980 */     // GIR_Coverage, 6728,
     /* 763980 */     GIR_EraseRootFromParent_Done,
     /* 763981 */   // Label 10155: @763981
     /* 763981 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(764062), // Rule ID 6748 //
     /* 763986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 763989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 763993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 763997 */     // MIs[0] offset
     /* 763997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764000 */     // MIs[0] format
     /* 764000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764003 */     // MIs[0] auxiliary
     /* 764003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764006 */     // MIs[0] Operand 8
     /* 764006 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764024 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 764027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764036 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764038 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764044 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764060 */     GIR_RootConstrainSelectedInstOperands,
     /* 764061 */     // GIR_Coverage, 6748,
     /* 764061 */     GIR_EraseRootFromParent_Done,
     /* 764062 */   // Label 10156: @764062
     /* 764062 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(764143), // Rule ID 6752 //
     /* 764067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 764070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764078 */     // MIs[0] offset
     /* 764078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764081 */     // MIs[0] format
     /* 764081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764084 */     // MIs[0] auxiliary
     /* 764084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764087 */     // MIs[0] Operand 8
     /* 764087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764105 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 764108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764117 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764119 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764141 */     GIR_RootConstrainSelectedInstOperands,
     /* 764142 */     // GIR_Coverage, 6752,
     /* 764142 */     GIR_EraseRootFromParent_Done,
     /* 764143 */   // Label 10157: @764143
     /* 764143 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(764222), // Rule ID 6730 //
     /* 764148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 764151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764155 */     // MIs[0] offset
     /* 764155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764158 */     // MIs[0] format
     /* 764158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764161 */     // MIs[0] auxiliary
     /* 764161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764164 */     // MIs[0] Operand 8
     /* 764164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764182 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 764185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764187 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764196 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764198 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764220 */     GIR_RootConstrainSelectedInstOperands,
     /* 764221 */     // GIR_Coverage, 6730,
     /* 764221 */     GIR_EraseRootFromParent_Done,
     /* 764222 */   // Label 10158: @764222
     /* 764222 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(764301), // Rule ID 6750 //
     /* 764227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 764230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764234 */     // MIs[0] offset
     /* 764234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764237 */     // MIs[0] format
     /* 764237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764240 */     // MIs[0] auxiliary
     /* 764240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764243 */     // MIs[0] Operand 8
     /* 764243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764261 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 764264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764266 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764275 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764277 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764283 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764289 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764299 */     GIR_RootConstrainSelectedInstOperands,
     /* 764300 */     // GIR_Coverage, 6750,
     /* 764300 */     GIR_EraseRootFromParent_Done,
     /* 764301 */   // Label 10159: @764301
     /* 764301 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(764380), // Rule ID 6754 //
     /* 764306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 764309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764313 */     // MIs[0] offset
     /* 764313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764316 */     // MIs[0] format
     /* 764316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764319 */     // MIs[0] auxiliary
     /* 764319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764322 */     // MIs[0] Operand 8
     /* 764322 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764340 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 764343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764345 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 764347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764354 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764356 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764362 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764378 */     GIR_RootConstrainSelectedInstOperands,
     /* 764379 */     // GIR_Coverage, 6754,
     /* 764379 */     GIR_EraseRootFromParent_Done,
     /* 764380 */   // Label 10160: @764380
     /* 764380 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(764451), // Rule ID 6729 //
     /* 764385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 764388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764392 */     // MIs[0] offset
     /* 764392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764395 */     // MIs[0] format
     /* 764395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764398 */     // MIs[0] auxiliary
     /* 764398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764401 */     // MIs[0] Operand 8
     /* 764401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764411 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 764414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764416 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764425 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764427 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764433 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764439 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764449 */     GIR_RootConstrainSelectedInstOperands,
     /* 764450 */     // GIR_Coverage, 6729,
     /* 764450 */     GIR_EraseRootFromParent_Done,
     /* 764451 */   // Label 10161: @764451
     /* 764451 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(764522), // Rule ID 6749 //
     /* 764456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 764459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764463 */     // MIs[0] offset
     /* 764463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764466 */     // MIs[0] format
     /* 764466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764469 */     // MIs[0] auxiliary
     /* 764469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764472 */     // MIs[0] Operand 8
     /* 764472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764482 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 764485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764487 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764496 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764498 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764504 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764510 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764520 */     GIR_RootConstrainSelectedInstOperands,
     /* 764521 */     // GIR_Coverage, 6749,
     /* 764521 */     GIR_EraseRootFromParent_Done,
     /* 764522 */   // Label 10162: @764522
     /* 764522 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(764593), // Rule ID 6753 //
     /* 764527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 764530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764534 */     // MIs[0] offset
     /* 764534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764537 */     // MIs[0] format
     /* 764537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764540 */     // MIs[0] auxiliary
     /* 764540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764543 */     // MIs[0] Operand 8
     /* 764543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764553 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 764556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764558 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 764560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764567 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764569 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764575 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764581 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764591 */     GIR_RootConstrainSelectedInstOperands,
     /* 764592 */     // GIR_Coverage, 6753,
     /* 764592 */     GIR_EraseRootFromParent_Done,
     /* 764593 */   // Label 10163: @764593
     /* 764593 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(764702), // Rule ID 6731 //
     /* 764598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 764601 */     // MIs[0] offset
     /* 764601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764604 */     // MIs[0] format
     /* 764604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764607 */     // MIs[0] auxiliary
     /* 764607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764610 */     // MIs[0] Operand 8
     /* 764610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764620 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764636 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764643 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 764664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764676 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764678 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764684 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764690 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764700 */     GIR_RootConstrainSelectedInstOperands,
     /* 764701 */     // GIR_Coverage, 6731,
     /* 764701 */     GIR_EraseRootFromParent_Done,
     /* 764702 */   // Label 10164: @764702
     /* 764702 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(764811), // Rule ID 6751 //
     /* 764707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 764710 */     // MIs[0] offset
     /* 764710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764713 */     // MIs[0] format
     /* 764713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764716 */     // MIs[0] auxiliary
     /* 764716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764719 */     // MIs[0] Operand 8
     /* 764719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764729 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764745 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 764773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764785 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764787 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764793 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764799 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764809 */     GIR_RootConstrainSelectedInstOperands,
     /* 764810 */     // GIR_Coverage, 6751,
     /* 764810 */     GIR_EraseRootFromParent_Done,
     /* 764811 */   // Label 10165: @764811
     /* 764811 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(764920), // Rule ID 6755 //
     /* 764816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 764819 */     // MIs[0] offset
     /* 764819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764822 */     // MIs[0] format
     /* 764822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764825 */     // MIs[0] auxiliary
     /* 764825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764828 */     // MIs[0] Operand 8
     /* 764828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 764831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764838 */     // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 764841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 764845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 764850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 764854 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 764857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 764861 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 764864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 764869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 764879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 764882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 764887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764894 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 764896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 764902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 764908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 764914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 764918 */     GIR_RootConstrainSelectedInstOperands,
     /* 764919 */     // GIR_Coverage, 6755,
     /* 764919 */     GIR_EraseRootFromParent_Done,
     /* 764920 */   // Label 10166: @764920
     /* 764920 */   GIM_Reject,
     /* 764921 */ // Label 10154: @764921
     /* 764921 */ GIM_Reject,
     /* 764922 */ // Label 10147: @764922
     /* 764922 */ GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(765964),
     /* 764927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 764930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 764933 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 764936 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 764939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 764943 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(765024), // Rule ID 6732 //
     /* 764948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 764951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 764955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 764959 */     // MIs[0] offset
     /* 764959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 764962 */     // MIs[0] format
     /* 764962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 764965 */     // MIs[0] auxiliary
     /* 764965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 764968 */     // MIs[0] Operand 8
     /* 764968 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 764979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 764986 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 764986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
     /* 764989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 764991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 764993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 764998 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765006 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765022 */     GIR_RootConstrainSelectedInstOperands,
     /* 765023 */     // GIR_Coverage, 6732,
     /* 765023 */     GIR_EraseRootFromParent_Done,
     /* 765024 */   // Label 10168: @765024
     /* 765024 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(765105), // Rule ID 6756 //
     /* 765029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 765032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765040 */     // MIs[0] offset
     /* 765040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765043 */     // MIs[0] format
     /* 765043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765046 */     // MIs[0] auxiliary
     /* 765046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765049 */     // MIs[0] Operand 8
     /* 765049 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765067 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
     /* 765070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765079 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765081 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765103 */     GIR_RootConstrainSelectedInstOperands,
     /* 765104 */     // GIR_Coverage, 6756,
     /* 765104 */     GIR_EraseRootFromParent_Done,
     /* 765105 */   // Label 10169: @765105
     /* 765105 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(765186), // Rule ID 6760 //
     /* 765110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 765113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765121 */     // MIs[0] offset
     /* 765121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765124 */     // MIs[0] format
     /* 765124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765127 */     // MIs[0] auxiliary
     /* 765127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765130 */     // MIs[0] Operand 8
     /* 765130 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765148 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
     /* 765151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765160 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765162 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765168 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765174 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765184 */     GIR_RootConstrainSelectedInstOperands,
     /* 765185 */     // GIR_Coverage, 6760,
     /* 765185 */     GIR_EraseRootFromParent_Done,
     /* 765186 */   // Label 10170: @765186
     /* 765186 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(765265), // Rule ID 6734 //
     /* 765191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 765194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765198 */     // MIs[0] offset
     /* 765198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765201 */     // MIs[0] format
     /* 765201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765204 */     // MIs[0] auxiliary
     /* 765204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765207 */     // MIs[0] Operand 8
     /* 765207 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765225 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
     /* 765228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765230 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765239 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765241 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765263 */     GIR_RootConstrainSelectedInstOperands,
     /* 765264 */     // GIR_Coverage, 6734,
     /* 765264 */     GIR_EraseRootFromParent_Done,
     /* 765265 */   // Label 10171: @765265
     /* 765265 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(765344), // Rule ID 6758 //
     /* 765270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 765273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765277 */     // MIs[0] offset
     /* 765277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765280 */     // MIs[0] format
     /* 765280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765283 */     // MIs[0] auxiliary
     /* 765283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765286 */     // MIs[0] Operand 8
     /* 765286 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765304 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
     /* 765307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765309 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765318 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765342 */     GIR_RootConstrainSelectedInstOperands,
     /* 765343 */     // GIR_Coverage, 6758,
     /* 765343 */     GIR_EraseRootFromParent_Done,
     /* 765344 */   // Label 10172: @765344
     /* 765344 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(765423), // Rule ID 6762 //
     /* 765349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 765352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765356 */     // MIs[0] offset
     /* 765356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765359 */     // MIs[0] format
     /* 765359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765362 */     // MIs[0] auxiliary
     /* 765362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765365 */     // MIs[0] Operand 8
     /* 765365 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 765376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765383 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
     /* 765386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765388 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 765390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765397 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765399 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765405 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765411 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765421 */     GIR_RootConstrainSelectedInstOperands,
     /* 765422 */     // GIR_Coverage, 6762,
     /* 765422 */     GIR_EraseRootFromParent_Done,
     /* 765423 */   // Label 10173: @765423
     /* 765423 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(765494), // Rule ID 6733 //
     /* 765428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 765431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765435 */     // MIs[0] offset
     /* 765435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765438 */     // MIs[0] format
     /* 765438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765441 */     // MIs[0] auxiliary
     /* 765441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765444 */     // MIs[0] Operand 8
     /* 765444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765454 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
     /* 765457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765459 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765468 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765470 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765476 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765482 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765492 */     GIR_RootConstrainSelectedInstOperands,
     /* 765493 */     // GIR_Coverage, 6733,
     /* 765493 */     GIR_EraseRootFromParent_Done,
     /* 765494 */   // Label 10174: @765494
     /* 765494 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(765565), // Rule ID 6757 //
     /* 765499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 765502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765506 */     // MIs[0] offset
     /* 765506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765509 */     // MIs[0] format
     /* 765509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765512 */     // MIs[0] auxiliary
     /* 765512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765515 */     // MIs[0] Operand 8
     /* 765515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765525 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
     /* 765528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765530 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765539 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765541 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765547 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765553 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765563 */     GIR_RootConstrainSelectedInstOperands,
     /* 765564 */     // GIR_Coverage, 6757,
     /* 765564 */     GIR_EraseRootFromParent_Done,
     /* 765565 */   // Label 10175: @765565
     /* 765565 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(765636), // Rule ID 6761 //
     /* 765570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 765573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 765577 */     // MIs[0] offset
     /* 765577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765580 */     // MIs[0] format
     /* 765580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765583 */     // MIs[0] auxiliary
     /* 765583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765586 */     // MIs[0] Operand 8
     /* 765586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765596 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
     /* 765599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765601 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 765603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765610 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765612 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765618 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765624 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765634 */     GIR_RootConstrainSelectedInstOperands,
     /* 765635 */     // GIR_Coverage, 6761,
     /* 765635 */     GIR_EraseRootFromParent_Done,
     /* 765636 */   // Label 10176: @765636
     /* 765636 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(765745), // Rule ID 6735 //
     /* 765641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 765644 */     // MIs[0] offset
     /* 765644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765647 */     // MIs[0] format
     /* 765647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765650 */     // MIs[0] auxiliary
     /* 765650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765653 */     // MIs[0] Operand 8
     /* 765653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765663 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 765666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 765670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 765675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 765679 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 765682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 765686 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 765689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 765694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
     /* 765707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 765712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765719 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765721 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765727 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765743 */     GIR_RootConstrainSelectedInstOperands,
     /* 765744 */     // GIR_Coverage, 6735,
     /* 765744 */     GIR_EraseRootFromParent_Done,
     /* 765745 */   // Label 10177: @765745
     /* 765745 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(765854), // Rule ID 6759 //
     /* 765750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 765753 */     // MIs[0] offset
     /* 765753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765756 */     // MIs[0] format
     /* 765756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765759 */     // MIs[0] auxiliary
     /* 765759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765762 */     // MIs[0] Operand 8
     /* 765762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765772 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 765775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 765779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 765784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 765788 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 765791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 765795 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 765798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 765803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
     /* 765816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 765821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765828 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765830 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765836 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765842 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765852 */     GIR_RootConstrainSelectedInstOperands,
     /* 765853 */     // GIR_Coverage, 6759,
     /* 765853 */     GIR_EraseRootFromParent_Done,
     /* 765854 */   // Label 10178: @765854
     /* 765854 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(765963), // Rule ID 6763 //
     /* 765859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 765862 */     // MIs[0] offset
     /* 765862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 765865 */     // MIs[0] format
     /* 765865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 765868 */     // MIs[0] auxiliary
     /* 765868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 765871 */     // MIs[0] Operand 8
     /* 765871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 765874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 765881 */     // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 765881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 765884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 765888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 765893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 765897 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 765900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 765904 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 765907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 765912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 765922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
     /* 765925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 765927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 765930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 765932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 765937 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 765939 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 765945 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 765951 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 765957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 765961 */     GIR_RootConstrainSelectedInstOperands,
     /* 765962 */     // GIR_Coverage, 6763,
     /* 765962 */     GIR_EraseRootFromParent_Done,
     /* 765963 */   // Label 10179: @765963
     /* 765963 */   GIM_Reject,
     /* 765964 */ // Label 10167: @765964
     /* 765964 */ GIM_Reject,
     /* 765965 */ // Label 10148: @765965
     /* 765965 */ GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(766667),
     /* 765970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 765973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 765976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 765979 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 765982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
     /* 765986 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(766067), // Rule ID 6764 //
     /* 765991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 765994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 765998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766002 */     // MIs[0] offset
     /* 766002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766005 */     // MIs[0] format
     /* 766005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766008 */     // MIs[0] auxiliary
     /* 766008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766011 */     // MIs[0] Operand 8
     /* 766011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766029 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFSET),
     /* 766032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766041 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766043 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766065 */     GIR_RootConstrainSelectedInstOperands,
     /* 766066 */     // GIR_Coverage, 6764,
     /* 766066 */     GIR_EraseRootFromParent_Done,
     /* 766067 */   // Label 10181: @766067
     /* 766067 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(766148), // Rule ID 6768 //
     /* 766072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 766075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766083 */     // MIs[0] offset
     /* 766083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766086 */     // MIs[0] format
     /* 766086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766089 */     // MIs[0] auxiliary
     /* 766089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766092 */     // MIs[0] Operand 8
     /* 766092 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766110 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
     /* 766113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766122 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766124 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766130 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766146 */     GIR_RootConstrainSelectedInstOperands,
     /* 766147 */     // GIR_Coverage, 6768,
     /* 766147 */     GIR_EraseRootFromParent_Done,
     /* 766148 */   // Label 10182: @766148
     /* 766148 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(766227), // Rule ID 6766 //
     /* 766153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 766156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766160 */     // MIs[0] offset
     /* 766160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766163 */     // MIs[0] format
     /* 766163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766166 */     // MIs[0] auxiliary
     /* 766166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766169 */     // MIs[0] Operand 8
     /* 766169 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766187 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFEN),
     /* 766190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766192 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766201 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766203 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766225 */     GIR_RootConstrainSelectedInstOperands,
     /* 766226 */     // GIR_Coverage, 6766,
     /* 766226 */     GIR_EraseRootFromParent_Done,
     /* 766227 */   // Label 10183: @766227
     /* 766227 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(766306), // Rule ID 6770 //
     /* 766232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 766235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766239 */     // MIs[0] offset
     /* 766239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766242 */     // MIs[0] format
     /* 766242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766245 */     // MIs[0] auxiliary
     /* 766245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766248 */     // MIs[0] Operand 8
     /* 766248 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766266 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
     /* 766269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766271 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766280 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766282 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766304 */     GIR_RootConstrainSelectedInstOperands,
     /* 766305 */     // GIR_Coverage, 6770,
     /* 766305 */     GIR_EraseRootFromParent_Done,
     /* 766306 */   // Label 10184: @766306
     /* 766306 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(766377), // Rule ID 6765 //
     /* 766311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 766314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766318 */     // MIs[0] offset
     /* 766318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766321 */     // MIs[0] format
     /* 766321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766324 */     // MIs[0] auxiliary
     /* 766324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766327 */     // MIs[0] Operand 8
     /* 766327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766337 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_IDXEN),
     /* 766340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766342 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 766344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766351 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766353 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766375 */     GIR_RootConstrainSelectedInstOperands,
     /* 766376 */     // GIR_Coverage, 6765,
     /* 766376 */     GIR_EraseRootFromParent_Done,
     /* 766377 */   // Label 10185: @766377
     /* 766377 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(766448), // Rule ID 6769 //
     /* 766382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 766385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766389 */     // MIs[0] offset
     /* 766389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766392 */     // MIs[0] format
     /* 766392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766395 */     // MIs[0] auxiliary
     /* 766395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766398 */     // MIs[0] Operand 8
     /* 766398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766408 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
     /* 766411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766413 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 766415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766422 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766446 */     GIR_RootConstrainSelectedInstOperands,
     /* 766447 */     // GIR_Coverage, 6769,
     /* 766447 */     GIR_EraseRootFromParent_Done,
     /* 766448 */   // Label 10186: @766448
     /* 766448 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(766557), // Rule ID 6767 //
     /* 766453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 766456 */     // MIs[0] offset
     /* 766456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766459 */     // MIs[0] format
     /* 766459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766462 */     // MIs[0] auxiliary
     /* 766462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766465 */     // MIs[0] Operand 8
     /* 766465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766475 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766491 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766498 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
     /* 766519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766531 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766545 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766555 */     GIR_RootConstrainSelectedInstOperands,
     /* 766556 */     // GIR_Coverage, 6767,
     /* 766556 */     GIR_EraseRootFromParent_Done,
     /* 766557 */   // Label 10187: @766557
     /* 766557 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(766666), // Rule ID 6771 //
     /* 766562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 766565 */     // MIs[0] offset
     /* 766565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766568 */     // MIs[0] format
     /* 766568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766571 */     // MIs[0] auxiliary
     /* 766571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766574 */     // MIs[0] Operand 8
     /* 766574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766584 */     // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766600 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766607 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
     /* 766628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766640 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766642 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766648 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766654 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766664 */     GIR_RootConstrainSelectedInstOperands,
     /* 766665 */     // GIR_Coverage, 6771,
     /* 766665 */     GIR_EraseRootFromParent_Done,
     /* 766666 */   // Label 10188: @766666
     /* 766666 */   GIM_Reject,
     /* 766667 */ // Label 10180: @766667
     /* 766667 */ GIM_Reject,
     /* 766668 */ // Label 10149: @766668
     /* 766668 */ GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(767030),
     /* 766673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 766676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 766679 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 766682 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 766685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 766689 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(766770), // Rule ID 6736 //
     /* 766694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 766697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766705 */     // MIs[0] offset
     /* 766705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766708 */     // MIs[0] format
     /* 766708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766711 */     // MIs[0] auxiliary
     /* 766711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766714 */     // MIs[0] Operand 8
     /* 766714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766732 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
     /* 766735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766744 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766746 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766752 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766758 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766768 */     GIR_RootConstrainSelectedInstOperands,
     /* 766769 */     // GIR_Coverage, 6736,
     /* 766769 */     GIR_EraseRootFromParent_Done,
     /* 766770 */   // Label 10190: @766770
     /* 766770 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(766849), // Rule ID 6738 //
     /* 766775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 766778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 766782 */     // MIs[0] offset
     /* 766782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766785 */     // MIs[0] format
     /* 766785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766788 */     // MIs[0] auxiliary
     /* 766788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766791 */     // MIs[0] Operand 8
     /* 766791 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 766802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766809 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
     /* 766812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766814 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 766816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766823 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766825 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766847 */     GIR_RootConstrainSelectedInstOperands,
     /* 766848 */     // GIR_Coverage, 6738,
     /* 766848 */     GIR_EraseRootFromParent_Done,
     /* 766849 */   // Label 10191: @766849
     /* 766849 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(766920), // Rule ID 6737 //
     /* 766854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 766857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 766861 */     // MIs[0] offset
     /* 766861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766864 */     // MIs[0] format
     /* 766864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766867 */     // MIs[0] auxiliary
     /* 766867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766870 */     // MIs[0] Operand 8
     /* 766870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766880 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
     /* 766883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766885 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 766887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 766894 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 766896 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 766902 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 766908 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 766914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 766918 */     GIR_RootConstrainSelectedInstOperands,
     /* 766919 */     // GIR_Coverage, 6737,
     /* 766919 */     GIR_EraseRootFromParent_Done,
     /* 766920 */   // Label 10192: @766920
     /* 766920 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(767029), // Rule ID 6739 //
     /* 766925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 766928 */     // MIs[0] offset
     /* 766928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 766931 */     // MIs[0] format
     /* 766931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 766934 */     // MIs[0] auxiliary
     /* 766934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 766937 */     // MIs[0] Operand 8
     /* 766937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 766940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 766947 */     // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 766947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 766950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 766954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 766959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 766963 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 766966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 766970 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 766973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 766978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 766988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
     /* 766991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 766993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 766996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 766998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767003 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767005 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767011 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767017 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767027 */     GIR_RootConstrainSelectedInstOperands,
     /* 767028 */     // GIR_Coverage, 6739,
     /* 767028 */     GIR_EraseRootFromParent_Done,
     /* 767029 */   // Label 10193: @767029
     /* 767029 */   GIM_Reject,
     /* 767030 */ // Label 10189: @767030
     /* 767030 */ GIM_Reject,
     /* 767031 */ // Label 10150: @767031
     /* 767031 */ GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(767393),
     /* 767036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 767039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 767042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 767045 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 767048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
     /* 767052 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(767133), // Rule ID 6740 //
     /* 767057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 767060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767068 */     // MIs[0] offset
     /* 767068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767071 */     // MIs[0] format
     /* 767071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767074 */     // MIs[0] auxiliary
     /* 767074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767077 */     // MIs[0] Operand 8
     /* 767077 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767095 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
     /* 767098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767107 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767109 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767115 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767131 */     GIR_RootConstrainSelectedInstOperands,
     /* 767132 */     // GIR_Coverage, 6740,
     /* 767132 */     GIR_EraseRootFromParent_Done,
     /* 767133 */   // Label 10195: @767133
     /* 767133 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(767212), // Rule ID 6742 //
     /* 767138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 767141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767145 */     // MIs[0] offset
     /* 767145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767148 */     // MIs[0] format
     /* 767148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767151 */     // MIs[0] auxiliary
     /* 767151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767154 */     // MIs[0] Operand 8
     /* 767154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767172 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
     /* 767175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767177 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 767179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767186 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767188 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767194 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767210 */     GIR_RootConstrainSelectedInstOperands,
     /* 767211 */     // GIR_Coverage, 6742,
     /* 767211 */     GIR_EraseRootFromParent_Done,
     /* 767212 */   // Label 10196: @767212
     /* 767212 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(767283), // Rule ID 6741 //
     /* 767217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 767220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767224 */     // MIs[0] offset
     /* 767224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767227 */     // MIs[0] format
     /* 767227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767230 */     // MIs[0] auxiliary
     /* 767230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767233 */     // MIs[0] Operand 8
     /* 767233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767243 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
     /* 767246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767248 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 767250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767257 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767265 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767271 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767281 */     GIR_RootConstrainSelectedInstOperands,
     /* 767282 */     // GIR_Coverage, 6741,
     /* 767282 */     GIR_EraseRootFromParent_Done,
     /* 767283 */   // Label 10197: @767283
     /* 767283 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(767392), // Rule ID 6743 //
     /* 767288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 767291 */     // MIs[0] offset
     /* 767291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767294 */     // MIs[0] format
     /* 767294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767297 */     // MIs[0] auxiliary
     /* 767297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767300 */     // MIs[0] Operand 8
     /* 767300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 767303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767310 */     // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 767313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 767317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 767322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 767326 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 767329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 767333 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 767336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 767341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 767351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
     /* 767354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 767359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767366 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767368 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767374 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767380 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767390 */     GIR_RootConstrainSelectedInstOperands,
     /* 767391 */     // GIR_Coverage, 6743,
     /* 767391 */     GIR_EraseRootFromParent_Done,
     /* 767392 */   // Label 10198: @767392
     /* 767392 */   GIM_Reject,
     /* 767393 */ // Label 10194: @767393
     /* 767393 */ GIM_Reject,
     /* 767394 */ // Label 10151: @767394
     /* 767394 */ GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(768892),
     /* 767399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 767402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 767405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 767408 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 767411 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(767503), // Rule ID 6772 //
     /* 767416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 767419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 767426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 767430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767438 */     // MIs[0] offset
     /* 767438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767441 */     // MIs[0] format
     /* 767441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767444 */     // MIs[0] auxiliary
     /* 767444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767447 */     // MIs[0] Operand 8
     /* 767447 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767465 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
     /* 767468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767477 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767479 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767485 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767491 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767501 */     GIR_RootConstrainSelectedInstOperands,
     /* 767502 */     // GIR_Coverage, 6772,
     /* 767502 */     GIR_EraseRootFromParent_Done,
     /* 767503 */   // Label 10200: @767503
     /* 767503 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(767595), // Rule ID 6776 //
     /* 767508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 767511 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 767518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 767522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767530 */     // MIs[0] offset
     /* 767530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767533 */     // MIs[0] format
     /* 767533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767536 */     // MIs[0] auxiliary
     /* 767536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767539 */     // MIs[0] Operand 8
     /* 767539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767557 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
     /* 767560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767593 */     GIR_RootConstrainSelectedInstOperands,
     /* 767594 */     // GIR_Coverage, 6776,
     /* 767594 */     GIR_EraseRootFromParent_Done,
     /* 767595 */   // Label 10201: @767595
     /* 767595 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(767680), // Rule ID 6780 //
     /* 767600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 767603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 767607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767615 */     // MIs[0] offset
     /* 767615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767618 */     // MIs[0] format
     /* 767618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767621 */     // MIs[0] auxiliary
     /* 767621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767624 */     // MIs[0] Operand 8
     /* 767624 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767642 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
     /* 767645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767654 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767656 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767662 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767668 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767678 */     GIR_RootConstrainSelectedInstOperands,
     /* 767679 */     // GIR_Coverage, 6780,
     /* 767679 */     GIR_EraseRootFromParent_Done,
     /* 767680 */   // Label 10202: @767680
     /* 767680 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(767765), // Rule ID 6784 //
     /* 767685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 767688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 767692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 767700 */     // MIs[0] offset
     /* 767700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767703 */     // MIs[0] format
     /* 767703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767706 */     // MIs[0] auxiliary
     /* 767706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767709 */     // MIs[0] Operand 8
     /* 767709 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767727 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
     /* 767730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767739 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767741 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767747 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767753 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767763 */     GIR_RootConstrainSelectedInstOperands,
     /* 767764 */     // GIR_Coverage, 6784,
     /* 767764 */     GIR_EraseRootFromParent_Done,
     /* 767765 */   // Label 10203: @767765
     /* 767765 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(767855), // Rule ID 6774 //
     /* 767770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 767773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 767780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 767784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767788 */     // MIs[0] offset
     /* 767788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767791 */     // MIs[0] format
     /* 767791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767794 */     // MIs[0] auxiliary
     /* 767794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767797 */     // MIs[0] Operand 8
     /* 767797 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767815 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
     /* 767818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767820 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 767822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767829 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767831 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767837 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767843 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767853 */     GIR_RootConstrainSelectedInstOperands,
     /* 767854 */     // GIR_Coverage, 6774,
     /* 767854 */     GIR_EraseRootFromParent_Done,
     /* 767855 */   // Label 10204: @767855
     /* 767855 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(767945), // Rule ID 6778 //
     /* 767860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 767863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 767870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 767874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767878 */     // MIs[0] offset
     /* 767878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767881 */     // MIs[0] format
     /* 767881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767884 */     // MIs[0] auxiliary
     /* 767884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767887 */     // MIs[0] Operand 8
     /* 767887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767905 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
     /* 767908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767910 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 767912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 767919 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 767921 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 767927 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 767933 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 767939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 767943 */     GIR_RootConstrainSelectedInstOperands,
     /* 767944 */     // GIR_Coverage, 6778,
     /* 767944 */     GIR_EraseRootFromParent_Done,
     /* 767945 */   // Label 10205: @767945
     /* 767945 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(768028), // Rule ID 6782 //
     /* 767950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 767953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 767957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 767961 */     // MIs[0] offset
     /* 767961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 767964 */     // MIs[0] format
     /* 767964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 767967 */     // MIs[0] auxiliary
     /* 767967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 767970 */     // MIs[0] Operand 8
     /* 767970 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 767981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 767988 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 767988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
     /* 767991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 767993 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 767995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 767997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768002 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768004 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768026 */     GIR_RootConstrainSelectedInstOperands,
     /* 768027 */     // GIR_Coverage, 6782,
     /* 768027 */     GIR_EraseRootFromParent_Done,
     /* 768028 */   // Label 10206: @768028
     /* 768028 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(768111), // Rule ID 6786 //
     /* 768033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 768036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768044 */     // MIs[0] offset
     /* 768044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768047 */     // MIs[0] format
     /* 768047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768050 */     // MIs[0] auxiliary
     /* 768050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768053 */     // MIs[0] Operand 8
     /* 768053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768071 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
     /* 768074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768076 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 768078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768085 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768087 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768093 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768099 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768109 */     GIR_RootConstrainSelectedInstOperands,
     /* 768110 */     // GIR_Coverage, 6786,
     /* 768110 */     GIR_EraseRootFromParent_Done,
     /* 768111 */   // Label 10207: @768111
     /* 768111 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(768193), // Rule ID 6773 //
     /* 768116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 768119 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 768126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768134 */     // MIs[0] offset
     /* 768134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768137 */     // MIs[0] format
     /* 768137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768140 */     // MIs[0] auxiliary
     /* 768140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768143 */     // MIs[0] Operand 8
     /* 768143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768153 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
     /* 768156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768158 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768167 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768169 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768175 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768181 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768191 */     GIR_RootConstrainSelectedInstOperands,
     /* 768192 */     // GIR_Coverage, 6773,
     /* 768192 */     GIR_EraseRootFromParent_Done,
     /* 768193 */   // Label 10208: @768193
     /* 768193 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(768275), // Rule ID 6777 //
     /* 768198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 768201 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 768208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768216 */     // MIs[0] offset
     /* 768216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768219 */     // MIs[0] format
     /* 768219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768222 */     // MIs[0] auxiliary
     /* 768222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768225 */     // MIs[0] Operand 8
     /* 768225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768235 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
     /* 768238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768240 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768249 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768263 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768273 */     GIR_RootConstrainSelectedInstOperands,
     /* 768274 */     // GIR_Coverage, 6777,
     /* 768274 */     GIR_EraseRootFromParent_Done,
     /* 768275 */   // Label 10209: @768275
     /* 768275 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(768350), // Rule ID 6781 //
     /* 768280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 768283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768291 */     // MIs[0] offset
     /* 768291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768294 */     // MIs[0] format
     /* 768294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768297 */     // MIs[0] auxiliary
     /* 768297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768300 */     // MIs[0] Operand 8
     /* 768300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768310 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
     /* 768313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768315 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768324 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768338 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768348 */     GIR_RootConstrainSelectedInstOperands,
     /* 768349 */     // GIR_Coverage, 6781,
     /* 768349 */     GIR_EraseRootFromParent_Done,
     /* 768350 */   // Label 10210: @768350
     /* 768350 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(768425), // Rule ID 6785 //
     /* 768355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 768358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768366 */     // MIs[0] offset
     /* 768366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768369 */     // MIs[0] format
     /* 768369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768372 */     // MIs[0] auxiliary
     /* 768372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768375 */     // MIs[0] Operand 8
     /* 768375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768385 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
     /* 768388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768390 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 768392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768399 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768401 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768407 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768413 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768423 */     GIR_RootConstrainSelectedInstOperands,
     /* 768424 */     // GIR_Coverage, 6785,
     /* 768424 */     GIR_EraseRootFromParent_Done,
     /* 768425 */   // Label 10211: @768425
     /* 768425 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(768545), // Rule ID 6775 //
     /* 768430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 768433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 768440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768444 */     // MIs[0] offset
     /* 768444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768447 */     // MIs[0] format
     /* 768447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768450 */     // MIs[0] auxiliary
     /* 768450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768453 */     // MIs[0] Operand 8
     /* 768453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768463 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768479 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768486 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
     /* 768507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768519 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768543 */     GIR_RootConstrainSelectedInstOperands,
     /* 768544 */     // GIR_Coverage, 6775,
     /* 768544 */     GIR_EraseRootFromParent_Done,
     /* 768545 */   // Label 10212: @768545
     /* 768545 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(768665), // Rule ID 6779 //
     /* 768550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 768553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 768560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768564 */     // MIs[0] offset
     /* 768564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768567 */     // MIs[0] format
     /* 768567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768570 */     // MIs[0] auxiliary
     /* 768570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768573 */     // MIs[0] Operand 8
     /* 768573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768583 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33592>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768599 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768606 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
     /* 768627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768639 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768653 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768663 */     GIR_RootConstrainSelectedInstOperands,
     /* 768664 */     // GIR_Coverage, 6779,
     /* 768664 */     GIR_EraseRootFromParent_Done,
     /* 768665 */   // Label 10213: @768665
     /* 768665 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(768778), // Rule ID 6783 //
     /* 768670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 768673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768677 */     // MIs[0] offset
     /* 768677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768680 */     // MIs[0] format
     /* 768680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768683 */     // MIs[0] auxiliary
     /* 768683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768686 */     // MIs[0] Operand 8
     /* 768686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768696 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768712 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768719 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
     /* 768740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768752 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768754 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768760 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768766 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768776 */     GIR_RootConstrainSelectedInstOperands,
     /* 768777 */     // GIR_Coverage, 6783,
     /* 768777 */     GIR_EraseRootFromParent_Done,
     /* 768778 */   // Label 10214: @768778
     /* 768778 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(768891), // Rule ID 6787 //
     /* 768783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 768786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
     /* 768790 */     // MIs[0] offset
     /* 768790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768793 */     // MIs[0] format
     /* 768793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768796 */     // MIs[0] auxiliary
     /* 768796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768799 */     // MIs[0] Operand 8
     /* 768799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 768802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768809 */     // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 768812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 768816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 768821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 768825 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 768828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 768832 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 768835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 768840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 768850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
     /* 768853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 768858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768865 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768867 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768873 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768879 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768889 */     GIR_RootConstrainSelectedInstOperands,
     /* 768890 */     // GIR_Coverage, 6787,
     /* 768890 */     GIR_EraseRootFromParent_Done,
     /* 768891 */   // Label 10215: @768891
     /* 768891 */   GIM_Reject,
     /* 768892 */ // Label 10199: @768892
     /* 768892 */ GIM_Reject,
     /* 768893 */ // Label 10152: @768893
     /* 768893 */ GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(769255),
     /* 768898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 768901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 768904 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 768907 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 768910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
     /* 768914 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(768995), // Rule ID 6744 //
     /* 768919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 768922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 768926 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 768930 */     // MIs[0] offset
     /* 768930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 768933 */     // MIs[0] format
     /* 768933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 768936 */     // MIs[0] auxiliary
     /* 768936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 768939 */     // MIs[0] Operand 8
     /* 768939 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 768950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 768957 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 768957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
     /* 768960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 768962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 768964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 768969 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 768971 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 768977 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 768983 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 768989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 768993 */     GIR_RootConstrainSelectedInstOperands,
     /* 768994 */     // GIR_Coverage, 6744,
     /* 768994 */     GIR_EraseRootFromParent_Done,
     /* 768995 */   // Label 10217: @768995
     /* 768995 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(769074), // Rule ID 6746 //
     /* 769000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769007 */     // MIs[0] offset
     /* 769007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769010 */     // MIs[0] format
     /* 769010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769013 */     // MIs[0] auxiliary
     /* 769013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769016 */     // MIs[0] Operand 8
     /* 769016 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769034 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
     /* 769037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 769039 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769048 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769050 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769056 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769062 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769072 */     GIR_RootConstrainSelectedInstOperands,
     /* 769073 */     // GIR_Coverage, 6746,
     /* 769073 */     GIR_EraseRootFromParent_Done,
     /* 769074 */   // Label 10218: @769074
     /* 769074 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(769145), // Rule ID 6745 //
     /* 769079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769086 */     // MIs[0] offset
     /* 769086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769089 */     // MIs[0] format
     /* 769089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769092 */     // MIs[0] auxiliary
     /* 769092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769095 */     // MIs[0] Operand 8
     /* 769095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769105 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
     /* 769108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 769110 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 769112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769119 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769121 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769127 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769133 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769143 */     GIR_RootConstrainSelectedInstOperands,
     /* 769144 */     // GIR_Coverage, 6745,
     /* 769144 */     GIR_EraseRootFromParent_Done,
     /* 769145 */   // Label 10219: @769145
     /* 769145 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(769254), // Rule ID 6747 //
     /* 769150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 769153 */     // MIs[0] offset
     /* 769153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769156 */     // MIs[0] format
     /* 769156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769159 */     // MIs[0] auxiliary
     /* 769159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769162 */     // MIs[0] Operand 8
     /* 769162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769172 */     // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 769175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 769179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 769184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 769188 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 769191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 769195 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 769198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 769203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 769213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
     /* 769216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
     /* 769218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 769221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769228 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769252 */     GIR_RootConstrainSelectedInstOperands,
     /* 769253 */     // GIR_Coverage, 6747,
     /* 769253 */     GIR_EraseRootFromParent_Done,
     /* 769254 */   // Label 10220: @769254
     /* 769254 */   GIM_Reject,
     /* 769255 */ // Label 10216: @769255
     /* 769255 */ GIM_Reject,
     /* 769256 */ // Label 10153: @769256
     /* 769256 */ GIM_Reject,
     /* 769257 */ // Label 164: @769257
     /* 769257 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 10225*/ GIMT_Encode4(774724),
     /* 769268 */ /*GILLT_s32*//*Label 10221*/ GIMT_Encode4(769304), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 769280 */ /*GILLT_v2s32*//*Label 10222*/ GIMT_Encode4(770659), GIMT_Encode4(0),
     /* 769288 */ /*GILLT_v3s32*//*Label 10223*/ GIMT_Encode4(772014), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 769300 */ /*GILLT_v4s32*//*Label 10224*/ GIMT_Encode4(773369),
     /* 769304 */ // Label 10221: @769304
     /* 769304 */ GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(770658),
     /* 769309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 769312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 769315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 769318 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 769321 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(769402), // Rule ID 6788 //
     /* 769326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 769329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769337 */     // MIs[0] offset
     /* 769337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769340 */     // MIs[0] format
     /* 769340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769343 */     // MIs[0] auxiliary
     /* 769343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769346 */     // MIs[0] Operand 8
     /* 769346 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769364 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 769367 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769376 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769378 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769384 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769390 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769400 */     GIR_RootConstrainSelectedInstOperands,
     /* 769401 */     // GIR_Coverage, 6788,
     /* 769401 */     GIR_EraseRootFromParent_Done,
     /* 769402 */   // Label 10227: @769402
     /* 769402 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(769480), // Rule ID 6792 //
     /* 769407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769415 */     // MIs[0] offset
     /* 769415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769418 */     // MIs[0] format
     /* 769418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769421 */     // MIs[0] auxiliary
     /* 769421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769424 */     // MIs[0] Operand 8
     /* 769424 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769442 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 769445 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769454 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769456 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769478 */     GIR_RootConstrainSelectedInstOperands,
     /* 769479 */     // GIR_Coverage, 6792,
     /* 769479 */     GIR_EraseRootFromParent_Done,
     /* 769480 */   // Label 10228: @769480
     /* 769480 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(769561), // Rule ID 6820 //
     /* 769485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 769488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769496 */     // MIs[0] offset
     /* 769496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769499 */     // MIs[0] format
     /* 769499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769502 */     // MIs[0] auxiliary
     /* 769502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769505 */     // MIs[0] Operand 8
     /* 769505 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769523 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9744:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
     /* 769526 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769535 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769537 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769543 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769549 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769559 */     GIR_RootConstrainSelectedInstOperands,
     /* 769560 */     // GIR_Coverage, 6820,
     /* 769560 */     GIR_EraseRootFromParent_Done,
     /* 769561 */   // Label 10229: @769561
     /* 769561 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(769639), // Rule ID 6824 //
     /* 769566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769574 */     // MIs[0] offset
     /* 769574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769577 */     // MIs[0] format
     /* 769577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769580 */     // MIs[0] auxiliary
     /* 769580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769583 */     // MIs[0] Operand 8
     /* 769583 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769601 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
     /* 769604 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769613 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769615 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769621 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769627 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769637 */     GIR_RootConstrainSelectedInstOperands,
     /* 769638 */     // GIR_Coverage, 6824,
     /* 769638 */     GIR_EraseRootFromParent_Done,
     /* 769639 */   // Label 10230: @769639
     /* 769639 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(769718), // Rule ID 6790 //
     /* 769644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 769647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769651 */     // MIs[0] offset
     /* 769651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769654 */     // MIs[0] format
     /* 769654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769657 */     // MIs[0] auxiliary
     /* 769657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769660 */     // MIs[0] Operand 8
     /* 769660 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769678 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 769681 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769683 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769692 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769694 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769716 */     GIR_RootConstrainSelectedInstOperands,
     /* 769717 */     // GIR_Coverage, 6790,
     /* 769717 */     GIR_EraseRootFromParent_Done,
     /* 769718 */   // Label 10231: @769718
     /* 769718 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(769794), // Rule ID 6794 //
     /* 769723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769727 */     // MIs[0] offset
     /* 769727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769730 */     // MIs[0] format
     /* 769730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769733 */     // MIs[0] auxiliary
     /* 769733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769736 */     // MIs[0] Operand 8
     /* 769736 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769754 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 769757 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769759 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769768 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769770 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769776 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769782 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769792 */     GIR_RootConstrainSelectedInstOperands,
     /* 769793 */     // GIR_Coverage, 6794,
     /* 769793 */     GIR_EraseRootFromParent_Done,
     /* 769794 */   // Label 10232: @769794
     /* 769794 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(769873), // Rule ID 6822 //
     /* 769799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 769802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769806 */     // MIs[0] offset
     /* 769806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769809 */     // MIs[0] format
     /* 769809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769812 */     // MIs[0] auxiliary
     /* 769812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769815 */     // MIs[0] Operand 8
     /* 769815 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769833 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
     /* 769836 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769838 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769847 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769849 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769855 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769861 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769871 */     GIR_RootConstrainSelectedInstOperands,
     /* 769872 */     // GIR_Coverage, 6822,
     /* 769872 */     GIR_EraseRootFromParent_Done,
     /* 769873 */   // Label 10233: @769873
     /* 769873 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(769949), // Rule ID 6826 //
     /* 769878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 769882 */     // MIs[0] offset
     /* 769882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769885 */     // MIs[0] format
     /* 769885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769888 */     // MIs[0] auxiliary
     /* 769888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769891 */     // MIs[0] Operand 8
     /* 769891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 769902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769909 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
     /* 769912 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769914 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 769916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769923 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 769931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 769937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 769943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 769947 */     GIR_RootConstrainSelectedInstOperands,
     /* 769948 */     // GIR_Coverage, 6826,
     /* 769948 */     GIR_EraseRootFromParent_Done,
     /* 769949 */   // Label 10234: @769949
     /* 769949 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(770020), // Rule ID 6789 //
     /* 769954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 769957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 769961 */     // MIs[0] offset
     /* 769961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 769964 */     // MIs[0] format
     /* 769964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 769967 */     // MIs[0] auxiliary
     /* 769967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 769970 */     // MIs[0] Operand 8
     /* 769970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 769973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 769980 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 769980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 769983 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 769985 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 769987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 769989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 769994 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 769996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770008 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770018 */     GIR_RootConstrainSelectedInstOperands,
     /* 770019 */     // GIR_Coverage, 6789,
     /* 770019 */     GIR_EraseRootFromParent_Done,
     /* 770020 */   // Label 10235: @770020
     /* 770020 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(770088), // Rule ID 6793 //
     /* 770025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770029 */     // MIs[0] offset
     /* 770029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770032 */     // MIs[0] format
     /* 770032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770035 */     // MIs[0] auxiliary
     /* 770035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770038 */     // MIs[0] Operand 8
     /* 770038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770048 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 770051 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770053 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770062 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770064 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770070 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770076 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770086 */     GIR_RootConstrainSelectedInstOperands,
     /* 770087 */     // GIR_Coverage, 6793,
     /* 770087 */     GIR_EraseRootFromParent_Done,
     /* 770088 */   // Label 10236: @770088
     /* 770088 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(770159), // Rule ID 6821 //
     /* 770093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 770096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770100 */     // MIs[0] offset
     /* 770100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770103 */     // MIs[0] format
     /* 770103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770106 */     // MIs[0] auxiliary
     /* 770106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770109 */     // MIs[0] Operand 8
     /* 770109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770119 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
     /* 770122 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770124 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770133 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770147 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770157 */     GIR_RootConstrainSelectedInstOperands,
     /* 770158 */     // GIR_Coverage, 6821,
     /* 770158 */     GIR_EraseRootFromParent_Done,
     /* 770159 */   // Label 10237: @770159
     /* 770159 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(770227), // Rule ID 6825 //
     /* 770164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770168 */     // MIs[0] offset
     /* 770168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770171 */     // MIs[0] format
     /* 770171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770174 */     // MIs[0] auxiliary
     /* 770174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770177 */     // MIs[0] Operand 8
     /* 770177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770187 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
     /* 770190 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770192 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 770194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770201 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770203 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770225 */     GIR_RootConstrainSelectedInstOperands,
     /* 770226 */     // GIR_Coverage, 6825,
     /* 770226 */     GIR_EraseRootFromParent_Done,
     /* 770227 */   // Label 10238: @770227
     /* 770227 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(770336), // Rule ID 6791 //
     /* 770232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 770235 */     // MIs[0] offset
     /* 770235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770238 */     // MIs[0] format
     /* 770238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770241 */     // MIs[0] auxiliary
     /* 770241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770244 */     // MIs[0] Operand 8
     /* 770244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770254 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770270 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770277 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 770298 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770310 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770312 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770318 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770324 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770334 */     GIR_RootConstrainSelectedInstOperands,
     /* 770335 */     // GIR_Coverage, 6791,
     /* 770335 */     GIR_EraseRootFromParent_Done,
     /* 770336 */   // Label 10239: @770336
     /* 770336 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(770442), // Rule ID 6795 //
     /* 770341 */     // MIs[0] offset
     /* 770341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770344 */     // MIs[0] format
     /* 770344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770347 */     // MIs[0] auxiliary
     /* 770347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770350 */     // MIs[0] Operand 8
     /* 770350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770360 */     // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770376 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770383 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 770404 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770416 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770440 */     GIR_RootConstrainSelectedInstOperands,
     /* 770441 */     // GIR_Coverage, 6795,
     /* 770441 */     GIR_EraseRootFromParent_Done,
     /* 770442 */   // Label 10240: @770442
     /* 770442 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(770551), // Rule ID 6823 //
     /* 770447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 770450 */     // MIs[0] offset
     /* 770450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770453 */     // MIs[0] format
     /* 770453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770456 */     // MIs[0] auxiliary
     /* 770456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770459 */     // MIs[0] Operand 8
     /* 770459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770469 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9744:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770485 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770492 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
     /* 770513 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770525 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770549 */     GIR_RootConstrainSelectedInstOperands,
     /* 770550 */     // GIR_Coverage, 6823,
     /* 770550 */     GIR_EraseRootFromParent_Done,
     /* 770551 */   // Label 10241: @770551
     /* 770551 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(770657), // Rule ID 6827 //
     /* 770556 */     // MIs[0] offset
     /* 770556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770559 */     // MIs[0] format
     /* 770559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770562 */     // MIs[0] auxiliary
     /* 770562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770565 */     // MIs[0] Operand 8
     /* 770565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 770568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770575 */     // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 770578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 770582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 770587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 770591 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 770594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 770598 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 770601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 770606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 770616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
     /* 770619 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 770624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770631 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770645 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770655 */     GIR_RootConstrainSelectedInstOperands,
     /* 770656 */     // GIR_Coverage, 6827,
     /* 770656 */     GIR_EraseRootFromParent_Done,
     /* 770657 */   // Label 10242: @770657
     /* 770657 */   GIM_Reject,
     /* 770658 */ // Label 10226: @770658
     /* 770658 */ GIM_Reject,
     /* 770659 */ // Label 10222: @770659
     /* 770659 */ GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(772013),
     /* 770664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 770667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 770670 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 770673 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 770676 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(770757), // Rule ID 6796 //
     /* 770681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 770684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770692 */     // MIs[0] offset
     /* 770692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770695 */     // MIs[0] format
     /* 770695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770698 */     // MIs[0] auxiliary
     /* 770698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770701 */     // MIs[0] Operand 8
     /* 770701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770719 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 770722 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770731 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770733 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770739 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770745 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770755 */     GIR_RootConstrainSelectedInstOperands,
     /* 770756 */     // GIR_Coverage, 6796,
     /* 770756 */     GIR_EraseRootFromParent_Done,
     /* 770757 */   // Label 10244: @770757
     /* 770757 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(770835), // Rule ID 6800 //
     /* 770762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770770 */     // MIs[0] offset
     /* 770770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770773 */     // MIs[0] format
     /* 770773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770776 */     // MIs[0] auxiliary
     /* 770776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770779 */     // MIs[0] Operand 8
     /* 770779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770797 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 770800 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770809 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770811 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770817 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770823 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770833 */     GIR_RootConstrainSelectedInstOperands,
     /* 770834 */     // GIR_Coverage, 6800,
     /* 770834 */     GIR_EraseRootFromParent_Done,
     /* 770835 */   // Label 10245: @770835
     /* 770835 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(770916), // Rule ID 6828 //
     /* 770840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 770843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770851 */     // MIs[0] offset
     /* 770851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770854 */     // MIs[0] format
     /* 770854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770857 */     // MIs[0] auxiliary
     /* 770857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770860 */     // MIs[0] Operand 8
     /* 770860 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770878 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9743:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
     /* 770881 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770890 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770904 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770914 */     GIR_RootConstrainSelectedInstOperands,
     /* 770915 */     // GIR_Coverage, 6828,
     /* 770915 */     GIR_EraseRootFromParent_Done,
     /* 770916 */   // Label 10246: @770916
     /* 770916 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(770994), // Rule ID 6832 //
     /* 770921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 770925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 770929 */     // MIs[0] offset
     /* 770929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 770932 */     // MIs[0] format
     /* 770932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 770935 */     // MIs[0] auxiliary
     /* 770935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 770938 */     // MIs[0] Operand 8
     /* 770938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 770949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 770956 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 770956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
     /* 770959 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 770961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 770963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 770968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 770970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 770976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 770982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 770988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 770992 */     GIR_RootConstrainSelectedInstOperands,
     /* 770993 */     // GIR_Coverage, 6832,
     /* 770993 */     GIR_EraseRootFromParent_Done,
     /* 770994 */   // Label 10247: @770994
     /* 770994 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(771073), // Rule ID 6798 //
     /* 770999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 771002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771006 */     // MIs[0] offset
     /* 771006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771009 */     // MIs[0] format
     /* 771009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771012 */     // MIs[0] auxiliary
     /* 771012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771015 */     // MIs[0] Operand 8
     /* 771015 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771033 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 771036 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771038 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771047 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771049 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771055 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771071 */     GIR_RootConstrainSelectedInstOperands,
     /* 771072 */     // GIR_Coverage, 6798,
     /* 771072 */     GIR_EraseRootFromParent_Done,
     /* 771073 */   // Label 10248: @771073
     /* 771073 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(771149), // Rule ID 6802 //
     /* 771078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771082 */     // MIs[0] offset
     /* 771082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771085 */     // MIs[0] format
     /* 771085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771088 */     // MIs[0] auxiliary
     /* 771088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771091 */     // MIs[0] Operand 8
     /* 771091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771109 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 771112 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771114 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771123 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771125 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771131 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771137 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771147 */     GIR_RootConstrainSelectedInstOperands,
     /* 771148 */     // GIR_Coverage, 6802,
     /* 771148 */     GIR_EraseRootFromParent_Done,
     /* 771149 */   // Label 10249: @771149
     /* 771149 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(771228), // Rule ID 6830 //
     /* 771154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 771157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771161 */     // MIs[0] offset
     /* 771161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771164 */     // MIs[0] format
     /* 771164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771167 */     // MIs[0] auxiliary
     /* 771167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771170 */     // MIs[0] Operand 8
     /* 771170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771188 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
     /* 771191 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771193 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771202 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771204 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771210 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771216 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771226 */     GIR_RootConstrainSelectedInstOperands,
     /* 771227 */     // GIR_Coverage, 6830,
     /* 771227 */     GIR_EraseRootFromParent_Done,
     /* 771228 */   // Label 10250: @771228
     /* 771228 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(771304), // Rule ID 6834 //
     /* 771233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 771237 */     // MIs[0] offset
     /* 771237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771240 */     // MIs[0] format
     /* 771240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771243 */     // MIs[0] auxiliary
     /* 771243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771246 */     // MIs[0] Operand 8
     /* 771246 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 771257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771264 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
     /* 771267 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771269 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 771271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771278 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771286 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771292 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771302 */     GIR_RootConstrainSelectedInstOperands,
     /* 771303 */     // GIR_Coverage, 6834,
     /* 771303 */     GIR_EraseRootFromParent_Done,
     /* 771304 */   // Label 10251: @771304
     /* 771304 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(771375), // Rule ID 6797 //
     /* 771309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 771312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771316 */     // MIs[0] offset
     /* 771316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771319 */     // MIs[0] format
     /* 771319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771322 */     // MIs[0] auxiliary
     /* 771322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771325 */     // MIs[0] Operand 8
     /* 771325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771335 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 771338 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771340 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771349 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771351 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771357 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771363 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771373 */     GIR_RootConstrainSelectedInstOperands,
     /* 771374 */     // GIR_Coverage, 6797,
     /* 771374 */     GIR_EraseRootFromParent_Done,
     /* 771375 */   // Label 10252: @771375
     /* 771375 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(771443), // Rule ID 6801 //
     /* 771380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771384 */     // MIs[0] offset
     /* 771384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771387 */     // MIs[0] format
     /* 771387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771390 */     // MIs[0] auxiliary
     /* 771390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771393 */     // MIs[0] Operand 8
     /* 771393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771403 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 771406 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771408 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771417 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771419 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771425 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771431 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771441 */     GIR_RootConstrainSelectedInstOperands,
     /* 771442 */     // GIR_Coverage, 6801,
     /* 771442 */     GIR_EraseRootFromParent_Done,
     /* 771443 */   // Label 10253: @771443
     /* 771443 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(771514), // Rule ID 6829 //
     /* 771448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 771451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771455 */     // MIs[0] offset
     /* 771455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771458 */     // MIs[0] format
     /* 771458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771461 */     // MIs[0] auxiliary
     /* 771461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771464 */     // MIs[0] Operand 8
     /* 771464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771474 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
     /* 771477 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771479 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771488 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771490 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771496 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771502 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771512 */     GIR_RootConstrainSelectedInstOperands,
     /* 771513 */     // GIR_Coverage, 6829,
     /* 771513 */     GIR_EraseRootFromParent_Done,
     /* 771514 */   // Label 10254: @771514
     /* 771514 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(771582), // Rule ID 6833 //
     /* 771519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 771523 */     // MIs[0] offset
     /* 771523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771526 */     // MIs[0] format
     /* 771526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771529 */     // MIs[0] auxiliary
     /* 771529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771532 */     // MIs[0] Operand 8
     /* 771532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771542 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
     /* 771545 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771547 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 771549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771556 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771558 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771564 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771570 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771580 */     GIR_RootConstrainSelectedInstOperands,
     /* 771581 */     // GIR_Coverage, 6833,
     /* 771581 */     GIR_EraseRootFromParent_Done,
     /* 771582 */   // Label 10255: @771582
     /* 771582 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(771691), // Rule ID 6799 //
     /* 771587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 771590 */     // MIs[0] offset
     /* 771590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771593 */     // MIs[0] format
     /* 771593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771596 */     // MIs[0] auxiliary
     /* 771596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771599 */     // MIs[0] Operand 8
     /* 771599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771609 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771625 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771632 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 771653 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771665 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771667 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771673 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771679 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771689 */     GIR_RootConstrainSelectedInstOperands,
     /* 771690 */     // GIR_Coverage, 6799,
     /* 771690 */     GIR_EraseRootFromParent_Done,
     /* 771691 */   // Label 10256: @771691
     /* 771691 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(771797), // Rule ID 6803 //
     /* 771696 */     // MIs[0] offset
     /* 771696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771699 */     // MIs[0] format
     /* 771699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771702 */     // MIs[0] auxiliary
     /* 771702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771705 */     // MIs[0] Operand 8
     /* 771705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771715 */     // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771731 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771738 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 771759 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771771 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771773 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771779 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771785 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771795 */     GIR_RootConstrainSelectedInstOperands,
     /* 771796 */     // GIR_Coverage, 6803,
     /* 771796 */     GIR_EraseRootFromParent_Done,
     /* 771797 */   // Label 10257: @771797
     /* 771797 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(771906), // Rule ID 6831 //
     /* 771802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 771805 */     // MIs[0] offset
     /* 771805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771808 */     // MIs[0] format
     /* 771808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771811 */     // MIs[0] auxiliary
     /* 771811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771814 */     // MIs[0] Operand 8
     /* 771814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771824 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771840 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771847 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
     /* 771868 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771880 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771882 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771888 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 771894 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 771900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 771904 */     GIR_RootConstrainSelectedInstOperands,
     /* 771905 */     // GIR_Coverage, 6831,
     /* 771905 */     GIR_EraseRootFromParent_Done,
     /* 771906 */   // Label 10258: @771906
     /* 771906 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(772012), // Rule ID 6835 //
     /* 771911 */     // MIs[0] offset
     /* 771911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 771914 */     // MIs[0] format
     /* 771914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 771917 */     // MIs[0] auxiliary
     /* 771917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 771920 */     // MIs[0] Operand 8
     /* 771920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 771923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 771930 */     // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 771930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 771933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 771937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 771942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 771946 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 771949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 771953 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 771956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 771961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 771971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
     /* 771974 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 771976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 771979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 771981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 771986 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 771988 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 771994 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772000 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772010 */     GIR_RootConstrainSelectedInstOperands,
     /* 772011 */     // GIR_Coverage, 6835,
     /* 772011 */     GIR_EraseRootFromParent_Done,
     /* 772012 */   // Label 10259: @772012
     /* 772012 */   GIM_Reject,
     /* 772013 */ // Label 10243: @772013
     /* 772013 */ GIM_Reject,
     /* 772014 */ // Label 10223: @772014
     /* 772014 */ GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(773368),
     /* 772019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 772022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 772025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 772028 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 772031 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(772112), // Rule ID 6804 //
     /* 772036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 772039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772047 */     // MIs[0] offset
     /* 772047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772050 */     // MIs[0] format
     /* 772050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772053 */     // MIs[0] auxiliary
     /* 772053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772056 */     // MIs[0] Operand 8
     /* 772056 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772074 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 772077 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772086 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772110 */     GIR_RootConstrainSelectedInstOperands,
     /* 772111 */     // GIR_Coverage, 6804,
     /* 772111 */     GIR_EraseRootFromParent_Done,
     /* 772112 */   // Label 10261: @772112
     /* 772112 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(772190), // Rule ID 6808 //
     /* 772117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772125 */     // MIs[0] offset
     /* 772125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772128 */     // MIs[0] format
     /* 772128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772131 */     // MIs[0] auxiliary
     /* 772131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772134 */     // MIs[0] Operand 8
     /* 772134 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772152 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 772155 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772164 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772166 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772172 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772178 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772188 */     GIR_RootConstrainSelectedInstOperands,
     /* 772189 */     // GIR_Coverage, 6808,
     /* 772189 */     GIR_EraseRootFromParent_Done,
     /* 772190 */   // Label 10262: @772190
     /* 772190 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(772271), // Rule ID 6836 //
     /* 772195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 772198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772206 */     // MIs[0] offset
     /* 772206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772209 */     // MIs[0] format
     /* 772209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772212 */     // MIs[0] auxiliary
     /* 772212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772215 */     // MIs[0] Operand 8
     /* 772215 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772233 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9742:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
     /* 772236 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772245 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772247 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772253 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772259 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772269 */     GIR_RootConstrainSelectedInstOperands,
     /* 772270 */     // GIR_Coverage, 6836,
     /* 772270 */     GIR_EraseRootFromParent_Done,
     /* 772271 */   // Label 10263: @772271
     /* 772271 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(772349), // Rule ID 6840 //
     /* 772276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772284 */     // MIs[0] offset
     /* 772284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772287 */     // MIs[0] format
     /* 772287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772290 */     // MIs[0] auxiliary
     /* 772290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772293 */     // MIs[0] Operand 8
     /* 772293 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772311 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9742:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
     /* 772314 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772323 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772325 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772331 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772337 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772347 */     GIR_RootConstrainSelectedInstOperands,
     /* 772348 */     // GIR_Coverage, 6840,
     /* 772348 */     GIR_EraseRootFromParent_Done,
     /* 772349 */   // Label 10264: @772349
     /* 772349 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(772428), // Rule ID 6806 //
     /* 772354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 772357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772361 */     // MIs[0] offset
     /* 772361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772364 */     // MIs[0] format
     /* 772364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772367 */     // MIs[0] auxiliary
     /* 772367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772370 */     // MIs[0] Operand 8
     /* 772370 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772388 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 772391 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772393 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772402 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772404 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772410 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772416 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772426 */     GIR_RootConstrainSelectedInstOperands,
     /* 772427 */     // GIR_Coverage, 6806,
     /* 772427 */     GIR_EraseRootFromParent_Done,
     /* 772428 */   // Label 10265: @772428
     /* 772428 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(772504), // Rule ID 6810 //
     /* 772433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772437 */     // MIs[0] offset
     /* 772437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772440 */     // MIs[0] format
     /* 772440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772443 */     // MIs[0] auxiliary
     /* 772443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772446 */     // MIs[0] Operand 8
     /* 772446 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772464 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 772467 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772469 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772478 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772480 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772486 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772492 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772502 */     GIR_RootConstrainSelectedInstOperands,
     /* 772503 */     // GIR_Coverage, 6810,
     /* 772503 */     GIR_EraseRootFromParent_Done,
     /* 772504 */   // Label 10266: @772504
     /* 772504 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(772583), // Rule ID 6838 //
     /* 772509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 772512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772516 */     // MIs[0] offset
     /* 772516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772519 */     // MIs[0] format
     /* 772519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772522 */     // MIs[0] auxiliary
     /* 772522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772525 */     // MIs[0] Operand 8
     /* 772525 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772543 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
     /* 772546 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772548 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772557 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772559 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772565 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772581 */     GIR_RootConstrainSelectedInstOperands,
     /* 772582 */     // GIR_Coverage, 6838,
     /* 772582 */     GIR_EraseRootFromParent_Done,
     /* 772583 */   // Label 10267: @772583
     /* 772583 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(772659), // Rule ID 6842 //
     /* 772588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 772592 */     // MIs[0] offset
     /* 772592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772595 */     // MIs[0] format
     /* 772595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772598 */     // MIs[0] auxiliary
     /* 772598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772601 */     // MIs[0] Operand 8
     /* 772601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 772612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772619 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
     /* 772622 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772624 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 772626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772633 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772635 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772641 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772647 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772657 */     GIR_RootConstrainSelectedInstOperands,
     /* 772658 */     // GIR_Coverage, 6842,
     /* 772658 */     GIR_EraseRootFromParent_Done,
     /* 772659 */   // Label 10268: @772659
     /* 772659 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(772730), // Rule ID 6805 //
     /* 772664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 772667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772671 */     // MIs[0] offset
     /* 772671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772674 */     // MIs[0] format
     /* 772674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772677 */     // MIs[0] auxiliary
     /* 772677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772680 */     // MIs[0] Operand 8
     /* 772680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772690 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 772693 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772695 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772704 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772728 */     GIR_RootConstrainSelectedInstOperands,
     /* 772729 */     // GIR_Coverage, 6805,
     /* 772729 */     GIR_EraseRootFromParent_Done,
     /* 772730 */   // Label 10269: @772730
     /* 772730 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(772798), // Rule ID 6809 //
     /* 772735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772739 */     // MIs[0] offset
     /* 772739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772742 */     // MIs[0] format
     /* 772742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772745 */     // MIs[0] auxiliary
     /* 772745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772748 */     // MIs[0] Operand 8
     /* 772748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772758 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 772761 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772763 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772772 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772796 */     GIR_RootConstrainSelectedInstOperands,
     /* 772797 */     // GIR_Coverage, 6809,
     /* 772797 */     GIR_EraseRootFromParent_Done,
     /* 772798 */   // Label 10270: @772798
     /* 772798 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(772869), // Rule ID 6837 //
     /* 772803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 772806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772810 */     // MIs[0] offset
     /* 772810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772813 */     // MIs[0] format
     /* 772813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772816 */     // MIs[0] auxiliary
     /* 772816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772819 */     // MIs[0] Operand 8
     /* 772819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772829 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
     /* 772832 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772834 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772843 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772845 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772851 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772857 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772867 */     GIR_RootConstrainSelectedInstOperands,
     /* 772868 */     // GIR_Coverage, 6837,
     /* 772868 */     GIR_EraseRootFromParent_Done,
     /* 772869 */   // Label 10271: @772869
     /* 772869 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(772937), // Rule ID 6841 //
     /* 772874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 772878 */     // MIs[0] offset
     /* 772878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772881 */     // MIs[0] format
     /* 772881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772884 */     // MIs[0] auxiliary
     /* 772884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772887 */     // MIs[0] Operand 8
     /* 772887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772897 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
     /* 772900 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 772902 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 772904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 772906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 772911 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 772913 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 772919 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 772925 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 772931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 772935 */     GIR_RootConstrainSelectedInstOperands,
     /* 772936 */     // GIR_Coverage, 6841,
     /* 772936 */     GIR_EraseRootFromParent_Done,
     /* 772937 */   // Label 10272: @772937
     /* 772937 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(773046), // Rule ID 6807 //
     /* 772942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 772945 */     // MIs[0] offset
     /* 772945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 772948 */     // MIs[0] format
     /* 772948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 772951 */     // MIs[0] auxiliary
     /* 772951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 772954 */     // MIs[0] Operand 8
     /* 772954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 772957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 772964 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 772964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 772967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 772971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 772976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 772980 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 772983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 772987 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 772990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 772995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 773008 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773020 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773028 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773034 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773044 */     GIR_RootConstrainSelectedInstOperands,
     /* 773045 */     // GIR_Coverage, 6807,
     /* 773045 */     GIR_EraseRootFromParent_Done,
     /* 773046 */   // Label 10273: @773046
     /* 773046 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(773152), // Rule ID 6811 //
     /* 773051 */     // MIs[0] offset
     /* 773051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773054 */     // MIs[0] format
     /* 773054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773057 */     // MIs[0] auxiliary
     /* 773057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773060 */     // MIs[0] Operand 8
     /* 773060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773070 */     // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773086 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773093 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 773114 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773126 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773128 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773134 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773140 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773150 */     GIR_RootConstrainSelectedInstOperands,
     /* 773151 */     // GIR_Coverage, 6811,
     /* 773151 */     GIR_EraseRootFromParent_Done,
     /* 773152 */   // Label 10274: @773152
     /* 773152 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(773261), // Rule ID 6839 //
     /* 773157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 773160 */     // MIs[0] offset
     /* 773160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773163 */     // MIs[0] format
     /* 773163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773166 */     // MIs[0] auxiliary
     /* 773166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773169 */     // MIs[0] Operand 8
     /* 773169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773179 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773195 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773198 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773202 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
     /* 773223 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773235 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773237 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773243 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773249 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773259 */     GIR_RootConstrainSelectedInstOperands,
     /* 773260 */     // GIR_Coverage, 6839,
     /* 773260 */     GIR_EraseRootFromParent_Done,
     /* 773261 */   // Label 10275: @773261
     /* 773261 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(773367), // Rule ID 6843 //
     /* 773266 */     // MIs[0] offset
     /* 773266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773269 */     // MIs[0] format
     /* 773269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773272 */     // MIs[0] auxiliary
     /* 773272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773275 */     // MIs[0] Operand 8
     /* 773275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 773278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773285 */     // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9742:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 773288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 773292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 773297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 773301 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 773304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 773308 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 773311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 773316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 773326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
     /* 773329 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 773334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773341 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773343 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773349 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773355 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773365 */     GIR_RootConstrainSelectedInstOperands,
     /* 773366 */     // GIR_Coverage, 6843,
     /* 773366 */     GIR_EraseRootFromParent_Done,
     /* 773367 */   // Label 10276: @773367
     /* 773367 */   GIM_Reject,
     /* 773368 */ // Label 10260: @773368
     /* 773368 */ GIM_Reject,
     /* 773369 */ // Label 10224: @773369
     /* 773369 */ GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(774723),
     /* 773374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 773377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 773380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 773383 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 773386 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(773467), // Rule ID 6812 //
     /* 773391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 773394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773402 */     // MIs[0] offset
     /* 773402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773405 */     // MIs[0] format
     /* 773405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773408 */     // MIs[0] auxiliary
     /* 773408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773411 */     // MIs[0] Operand 8
     /* 773411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773429 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 773432 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773441 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773443 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773449 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773455 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773465 */     GIR_RootConstrainSelectedInstOperands,
     /* 773466 */     // GIR_Coverage, 6812,
     /* 773466 */     GIR_EraseRootFromParent_Done,
     /* 773467 */   // Label 10278: @773467
     /* 773467 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(773545), // Rule ID 6816 //
     /* 773472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773480 */     // MIs[0] offset
     /* 773480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773483 */     // MIs[0] format
     /* 773483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773486 */     // MIs[0] auxiliary
     /* 773486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773489 */     // MIs[0] Operand 8
     /* 773489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773507 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 773510 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773519 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773543 */     GIR_RootConstrainSelectedInstOperands,
     /* 773544 */     // GIR_Coverage, 6816,
     /* 773544 */     GIR_EraseRootFromParent_Done,
     /* 773545 */   // Label 10279: @773545
     /* 773545 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(773626), // Rule ID 6844 //
     /* 773550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 773553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773561 */     // MIs[0] offset
     /* 773561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773564 */     // MIs[0] format
     /* 773564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773567 */     // MIs[0] auxiliary
     /* 773567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773570 */     // MIs[0] Operand 8
     /* 773570 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773588 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9741:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
     /* 773591 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773600 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773608 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773614 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773624 */     GIR_RootConstrainSelectedInstOperands,
     /* 773625 */     // GIR_Coverage, 6844,
     /* 773625 */     GIR_EraseRootFromParent_Done,
     /* 773626 */   // Label 10280: @773626
     /* 773626 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(773704), // Rule ID 6848 //
     /* 773631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 773639 */     // MIs[0] offset
     /* 773639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773642 */     // MIs[0] format
     /* 773642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773645 */     // MIs[0] auxiliary
     /* 773645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773648 */     // MIs[0] Operand 8
     /* 773648 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773666 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9741:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
     /* 773669 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773678 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773692 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773702 */     GIR_RootConstrainSelectedInstOperands,
     /* 773703 */     // GIR_Coverage, 6848,
     /* 773703 */     GIR_EraseRootFromParent_Done,
     /* 773704 */   // Label 10281: @773704
     /* 773704 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(773783), // Rule ID 6814 //
     /* 773709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 773712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773716 */     // MIs[0] offset
     /* 773716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773719 */     // MIs[0] format
     /* 773719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773722 */     // MIs[0] auxiliary
     /* 773722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773725 */     // MIs[0] Operand 8
     /* 773725 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773743 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 773746 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773748 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773757 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773759 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773765 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773771 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773781 */     GIR_RootConstrainSelectedInstOperands,
     /* 773782 */     // GIR_Coverage, 6814,
     /* 773782 */     GIR_EraseRootFromParent_Done,
     /* 773783 */   // Label 10282: @773783
     /* 773783 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(773859), // Rule ID 6818 //
     /* 773788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773792 */     // MIs[0] offset
     /* 773792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773795 */     // MIs[0] format
     /* 773795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773798 */     // MIs[0] auxiliary
     /* 773798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773801 */     // MIs[0] Operand 8
     /* 773801 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773819 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 773822 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773824 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773833 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773835 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773841 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773847 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773857 */     GIR_RootConstrainSelectedInstOperands,
     /* 773858 */     // GIR_Coverage, 6818,
     /* 773858 */     GIR_EraseRootFromParent_Done,
     /* 773859 */   // Label 10283: @773859
     /* 773859 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(773938), // Rule ID 6846 //
     /* 773864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 773867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773871 */     // MIs[0] offset
     /* 773871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773874 */     // MIs[0] format
     /* 773874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773877 */     // MIs[0] auxiliary
     /* 773877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773880 */     // MIs[0] Operand 8
     /* 773880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773898 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
     /* 773901 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773903 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773912 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773914 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773920 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 773926 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 773932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 773936 */     GIR_RootConstrainSelectedInstOperands,
     /* 773937 */     // GIR_Coverage, 6846,
     /* 773937 */     GIR_EraseRootFromParent_Done,
     /* 773938 */   // Label 10284: @773938
     /* 773938 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(774014), // Rule ID 6850 //
     /* 773943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 773947 */     // MIs[0] offset
     /* 773947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 773950 */     // MIs[0] format
     /* 773950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 773953 */     // MIs[0] auxiliary
     /* 773953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 773956 */     // MIs[0] Operand 8
     /* 773956 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 773967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 773974 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 773974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
     /* 773977 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 773979 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 773981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 773983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 773988 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 773990 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 773996 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774002 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774012 */     GIR_RootConstrainSelectedInstOperands,
     /* 774013 */     // GIR_Coverage, 6850,
     /* 774013 */     GIR_EraseRootFromParent_Done,
     /* 774014 */   // Label 10285: @774014
     /* 774014 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(774085), // Rule ID 6813 //
     /* 774019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 774022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 774026 */     // MIs[0] offset
     /* 774026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774029 */     // MIs[0] format
     /* 774029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774032 */     // MIs[0] auxiliary
     /* 774032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774035 */     // MIs[0] Operand 8
     /* 774035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774045 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 774048 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774050 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 774052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774059 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774061 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774067 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774073 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774083 */     GIR_RootConstrainSelectedInstOperands,
     /* 774084 */     // GIR_Coverage, 6813,
     /* 774084 */     GIR_EraseRootFromParent_Done,
     /* 774085 */   // Label 10286: @774085
     /* 774085 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(774153), // Rule ID 6817 //
     /* 774090 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 774094 */     // MIs[0] offset
     /* 774094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774097 */     // MIs[0] format
     /* 774097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774100 */     // MIs[0] auxiliary
     /* 774100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774103 */     // MIs[0] Operand 8
     /* 774103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774113 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 774116 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774118 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 774120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774127 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774129 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774135 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774141 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774151 */     GIR_RootConstrainSelectedInstOperands,
     /* 774152 */     // GIR_Coverage, 6817,
     /* 774152 */     GIR_EraseRootFromParent_Done,
     /* 774153 */   // Label 10287: @774153
     /* 774153 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(774224), // Rule ID 6845 //
     /* 774158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 774161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 774165 */     // MIs[0] offset
     /* 774165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774168 */     // MIs[0] format
     /* 774168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774171 */     // MIs[0] auxiliary
     /* 774171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774174 */     // MIs[0] Operand 8
     /* 774174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774184 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
     /* 774187 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774189 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 774191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774198 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774200 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774206 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774212 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774222 */     GIR_RootConstrainSelectedInstOperands,
     /* 774223 */     // GIR_Coverage, 6845,
     /* 774223 */     GIR_EraseRootFromParent_Done,
     /* 774224 */   // Label 10288: @774224
     /* 774224 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(774292), // Rule ID 6849 //
     /* 774229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 774233 */     // MIs[0] offset
     /* 774233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774236 */     // MIs[0] format
     /* 774236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774239 */     // MIs[0] auxiliary
     /* 774239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774242 */     // MIs[0] Operand 8
     /* 774242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774252 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
     /* 774255 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774257 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 774259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774266 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774268 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774274 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774280 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774290 */     GIR_RootConstrainSelectedInstOperands,
     /* 774291 */     // GIR_Coverage, 6849,
     /* 774291 */     GIR_EraseRootFromParent_Done,
     /* 774292 */   // Label 10289: @774292
     /* 774292 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(774401), // Rule ID 6815 //
     /* 774297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 774300 */     // MIs[0] offset
     /* 774300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774303 */     // MIs[0] format
     /* 774303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774306 */     // MIs[0] auxiliary
     /* 774306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774309 */     // MIs[0] Operand 8
     /* 774309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774319 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 774322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 774326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 774331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 774335 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 774338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 774342 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 774345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 774350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 774363 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 774368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774375 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774377 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774383 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774389 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774399 */     GIR_RootConstrainSelectedInstOperands,
     /* 774400 */     // GIR_Coverage, 6815,
     /* 774400 */     GIR_EraseRootFromParent_Done,
     /* 774401 */   // Label 10290: @774401
     /* 774401 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(774507), // Rule ID 6819 //
     /* 774406 */     // MIs[0] offset
     /* 774406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774409 */     // MIs[0] format
     /* 774409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774412 */     // MIs[0] auxiliary
     /* 774412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774415 */     // MIs[0] Operand 8
     /* 774415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774425 */     // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 774428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 774432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 774437 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 774441 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 774444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 774448 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 774451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 774456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 774469 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 774474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774481 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774483 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774489 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774495 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774505 */     GIR_RootConstrainSelectedInstOperands,
     /* 774506 */     // GIR_Coverage, 6819,
     /* 774506 */     GIR_EraseRootFromParent_Done,
     /* 774507 */   // Label 10291: @774507
     /* 774507 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(774616), // Rule ID 6847 //
     /* 774512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
     /* 774515 */     // MIs[0] offset
     /* 774515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774518 */     // MIs[0] format
     /* 774518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774521 */     // MIs[0] auxiliary
     /* 774521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774524 */     // MIs[0] Operand 8
     /* 774524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774534 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 774537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 774541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 774546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 774550 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 774553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 774557 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 774560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 774565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
     /* 774578 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 774583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774590 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774592 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774598 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774604 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774614 */     GIR_RootConstrainSelectedInstOperands,
     /* 774615 */     // GIR_Coverage, 6847,
     /* 774615 */     GIR_EraseRootFromParent_Done,
     /* 774616 */   // Label 10292: @774616
     /* 774616 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(774722), // Rule ID 6851 //
     /* 774621 */     // MIs[0] offset
     /* 774621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774624 */     // MIs[0] format
     /* 774624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774627 */     // MIs[0] auxiliary
     /* 774627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774630 */     // MIs[0] Operand 8
     /* 774630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 774633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774640 */     // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9741:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 774643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 774647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 774652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 774656 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 774659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 774663 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 774666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 774671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 774681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
     /* 774684 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 774689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774696 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774698 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774704 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774710 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774720 */     GIR_RootConstrainSelectedInstOperands,
     /* 774721 */     // GIR_Coverage, 6851,
     /* 774721 */     GIR_EraseRootFromParent_Done,
     /* 774722 */   // Label 10293: @774722
     /* 774722 */   GIM_Reject,
     /* 774723 */ // Label 10277: @774723
     /* 774723 */ GIM_Reject,
     /* 774724 */ // Label 10225: @774724
     /* 774724 */ GIM_Reject,
     /* 774725 */ // Label 165: @774725
     /* 774725 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 10301*/ GIMT_Encode4(780065),
     /* 774736 */ /*GILLT_s16*//*Label 10294*/ GIMT_Encode4(774776),
     /* 774740 */ /*GILLT_s32*//*Label 10295*/ GIMT_Encode4(775815), GIMT_Encode4(0),
     /* 774748 */ /*GILLT_v2s16*//*Label 10296*/ GIMT_Encode4(776854),
     /* 774752 */ /*GILLT_v2s32*//*Label 10297*/ GIMT_Encode4(777553), GIMT_Encode4(0),
     /* 774760 */ /*GILLT_v3s32*//*Label 10298*/ GIMT_Encode4(777912), GIMT_Encode4(0),
     /* 774768 */ /*GILLT_v4s16*//*Label 10299*/ GIMT_Encode4(778271),
     /* 774772 */ /*GILLT_v4s32*//*Label 10300*/ GIMT_Encode4(779706),
     /* 774776 */ // Label 10294: @774776
     /* 774776 */ GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(775814),
     /* 774781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 774784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 774787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 774790 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 774793 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(774874), // Rule ID 6852 //
     /* 774798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 774801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 774805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 774809 */     // MIs[0] offset
     /* 774809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774812 */     // MIs[0] format
     /* 774812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774815 */     // MIs[0] auxiliary
     /* 774815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774818 */     // MIs[0] Operand 8
     /* 774818 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 774829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774836 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9744:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 774839 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774848 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774850 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774856 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774862 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774872 */     GIR_RootConstrainSelectedInstOperands,
     /* 774873 */     // GIR_Coverage, 6852,
     /* 774873 */     GIR_EraseRootFromParent_Done,
     /* 774874 */   // Label 10303: @774874
     /* 774874 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(774955), // Rule ID 6872 //
     /* 774879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 774882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 774886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 774890 */     // MIs[0] offset
     /* 774890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774893 */     // MIs[0] format
     /* 774893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774896 */     // MIs[0] auxiliary
     /* 774896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774899 */     // MIs[0] Operand 8
     /* 774899 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 774910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774917 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9744:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 774920 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 774922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 774924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 774929 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 774931 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 774937 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 774943 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 774949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 774953 */     GIR_RootConstrainSelectedInstOperands,
     /* 774954 */     // GIR_Coverage, 6872,
     /* 774954 */     GIR_EraseRootFromParent_Done,
     /* 774955 */   // Label 10304: @774955
     /* 774955 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(775036), // Rule ID 6876 //
     /* 774960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 774963 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 774967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 774971 */     // MIs[0] offset
     /* 774971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 774974 */     // MIs[0] format
     /* 774974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 774977 */     // MIs[0] auxiliary
     /* 774977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 774980 */     // MIs[0] Operand 8
     /* 774980 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 774991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 774998 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 774998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 775001 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775010 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775012 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775018 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775024 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775034 */     GIR_RootConstrainSelectedInstOperands,
     /* 775035 */     // GIR_Coverage, 6876,
     /* 775035 */     GIR_EraseRootFromParent_Done,
     /* 775036 */   // Label 10305: @775036
     /* 775036 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(775115), // Rule ID 6854 //
     /* 775041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 775044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 775048 */     // MIs[0] offset
     /* 775048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775051 */     // MIs[0] format
     /* 775051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775054 */     // MIs[0] auxiliary
     /* 775054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775057 */     // MIs[0] Operand 8
     /* 775057 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 775068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775075 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 775078 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775080 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 775082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775089 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775091 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775097 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775103 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775113 */     GIR_RootConstrainSelectedInstOperands,
     /* 775114 */     // GIR_Coverage, 6854,
     /* 775114 */     GIR_EraseRootFromParent_Done,
     /* 775115 */   // Label 10306: @775115
     /* 775115 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(775194), // Rule ID 6874 //
     /* 775120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 775123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 775127 */     // MIs[0] offset
     /* 775127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775130 */     // MIs[0] format
     /* 775130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775133 */     // MIs[0] auxiliary
     /* 775133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775136 */     // MIs[0] Operand 8
     /* 775136 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 775147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775154 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 775157 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775159 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 775161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775168 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775170 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775176 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775182 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775192 */     GIR_RootConstrainSelectedInstOperands,
     /* 775193 */     // GIR_Coverage, 6874,
     /* 775193 */     GIR_EraseRootFromParent_Done,
     /* 775194 */   // Label 10307: @775194
     /* 775194 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(775273), // Rule ID 6878 //
     /* 775199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 775202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 775206 */     // MIs[0] offset
     /* 775206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775209 */     // MIs[0] format
     /* 775209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775212 */     // MIs[0] auxiliary
     /* 775212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775215 */     // MIs[0] Operand 8
     /* 775215 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 775226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775233 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 775236 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775238 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 775240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775247 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775249 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775255 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775261 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775271 */     GIR_RootConstrainSelectedInstOperands,
     /* 775272 */     // GIR_Coverage, 6878,
     /* 775272 */     GIR_EraseRootFromParent_Done,
     /* 775273 */   // Label 10308: @775273
     /* 775273 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(775344), // Rule ID 6853 //
     /* 775278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 775281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 775285 */     // MIs[0] offset
     /* 775285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775288 */     // MIs[0] format
     /* 775288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775291 */     // MIs[0] auxiliary
     /* 775291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775294 */     // MIs[0] Operand 8
     /* 775294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 775297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775304 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 775307 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775309 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 775311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775318 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775320 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775326 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775332 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775342 */     GIR_RootConstrainSelectedInstOperands,
     /* 775343 */     // GIR_Coverage, 6853,
     /* 775343 */     GIR_EraseRootFromParent_Done,
     /* 775344 */   // Label 10309: @775344
     /* 775344 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(775415), // Rule ID 6873 //
     /* 775349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 775352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 775356 */     // MIs[0] offset
     /* 775356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775359 */     // MIs[0] format
     /* 775359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775362 */     // MIs[0] auxiliary
     /* 775362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775365 */     // MIs[0] Operand 8
     /* 775365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 775368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775375 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 775378 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775380 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 775382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775389 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775391 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775397 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775403 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775413 */     GIR_RootConstrainSelectedInstOperands,
     /* 775414 */     // GIR_Coverage, 6873,
     /* 775414 */     GIR_EraseRootFromParent_Done,
     /* 775415 */   // Label 10310: @775415
     /* 775415 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(775486), // Rule ID 6877 //
     /* 775420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 775423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 775427 */     // MIs[0] offset
     /* 775427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775430 */     // MIs[0] format
     /* 775430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775433 */     // MIs[0] auxiliary
     /* 775433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775436 */     // MIs[0] Operand 8
     /* 775436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 775439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775446 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 775449 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775451 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 775453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775460 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775484 */     GIR_RootConstrainSelectedInstOperands,
     /* 775485 */     // GIR_Coverage, 6877,
     /* 775485 */     GIR_EraseRootFromParent_Done,
     /* 775486 */   // Label 10311: @775486
     /* 775486 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(775595), // Rule ID 6855 //
     /* 775491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 775494 */     // MIs[0] offset
     /* 775494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775497 */     // MIs[0] format
     /* 775497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775500 */     // MIs[0] auxiliary
     /* 775500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775503 */     // MIs[0] Operand 8
     /* 775503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 775506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775513 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9744:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 775516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 775520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 775525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 775529 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 775532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 775536 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 775539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 775544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 775549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 775554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 775557 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 775562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775593 */     GIR_RootConstrainSelectedInstOperands,
     /* 775594 */     // GIR_Coverage, 6855,
     /* 775594 */     GIR_EraseRootFromParent_Done,
     /* 775595 */   // Label 10312: @775595
     /* 775595 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(775704), // Rule ID 6875 //
     /* 775600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 775603 */     // MIs[0] offset
     /* 775603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775606 */     // MIs[0] format
     /* 775606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775609 */     // MIs[0] auxiliary
     /* 775609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775612 */     // MIs[0] Operand 8
     /* 775612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 775615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775622 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9744:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 775625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 775629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 775634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 775638 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 775641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 775645 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 775648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 775653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 775658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 775663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 775666 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 775671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775678 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775692 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775702 */     GIR_RootConstrainSelectedInstOperands,
     /* 775703 */     // GIR_Coverage, 6875,
     /* 775703 */     GIR_EraseRootFromParent_Done,
     /* 775704 */   // Label 10313: @775704
     /* 775704 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(775813), // Rule ID 6879 //
     /* 775709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 775712 */     // MIs[0] offset
     /* 775712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775715 */     // MIs[0] format
     /* 775715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775718 */     // MIs[0] auxiliary
     /* 775718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775721 */     // MIs[0] Operand 8
     /* 775721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 775724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775731 */     // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 775734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 775738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 775743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 775747 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 775750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 775754 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 775757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 775762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 775767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 775772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 775775 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 775780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775787 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775795 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775801 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775811 */     GIR_RootConstrainSelectedInstOperands,
     /* 775812 */     // GIR_Coverage, 6879,
     /* 775812 */     GIR_EraseRootFromParent_Done,
     /* 775813 */   // Label 10314: @775813
     /* 775813 */   GIM_Reject,
     /* 775814 */ // Label 10302: @775814
     /* 775814 */ GIM_Reject,
     /* 775815 */ // Label 10295: @775815
     /* 775815 */ GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(776853),
     /* 775820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 775823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 775826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 775829 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 775832 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(775913), // Rule ID 6856 //
     /* 775837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 775840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 775844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 775848 */     // MIs[0] offset
     /* 775848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775851 */     // MIs[0] format
     /* 775851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775854 */     // MIs[0] auxiliary
     /* 775854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775857 */     // MIs[0] Operand 8
     /* 775857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 775868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775875 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
     /* 775878 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775887 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775889 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775895 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775901 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775911 */     GIR_RootConstrainSelectedInstOperands,
     /* 775912 */     // GIR_Coverage, 6856,
     /* 775912 */     GIR_EraseRootFromParent_Done,
     /* 775913 */   // Label 10316: @775913
     /* 775913 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(775994), // Rule ID 6880 //
     /* 775918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 775921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 775925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 775929 */     // MIs[0] offset
     /* 775929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 775932 */     // MIs[0] format
     /* 775932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 775935 */     // MIs[0] auxiliary
     /* 775935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 775938 */     // MIs[0] Operand 8
     /* 775938 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 775949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 775956 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 775956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
     /* 775959 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 775961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 775963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 775968 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 775970 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 775976 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 775982 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 775988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 775992 */     GIR_RootConstrainSelectedInstOperands,
     /* 775993 */     // GIR_Coverage, 6880,
     /* 775993 */     GIR_EraseRootFromParent_Done,
     /* 775994 */   // Label 10317: @775994
     /* 775994 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(776075), // Rule ID 6884 //
     /* 775999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 776002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 776006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 776010 */     // MIs[0] offset
     /* 776010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776013 */     // MIs[0] format
     /* 776013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776016 */     // MIs[0] auxiliary
     /* 776016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776019 */     // MIs[0] Operand 8
     /* 776019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 776030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776037 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9744:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
     /* 776040 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776049 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776057 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776063 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776073 */     GIR_RootConstrainSelectedInstOperands,
     /* 776074 */     // GIR_Coverage, 6884,
     /* 776074 */     GIR_EraseRootFromParent_Done,
     /* 776075 */   // Label 10318: @776075
     /* 776075 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(776154), // Rule ID 6858 //
     /* 776080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 776083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 776087 */     // MIs[0] offset
     /* 776087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776090 */     // MIs[0] format
     /* 776090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776093 */     // MIs[0] auxiliary
     /* 776093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776096 */     // MIs[0] Operand 8
     /* 776096 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 776107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776114 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
     /* 776117 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776119 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 776121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776128 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776130 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776152 */     GIR_RootConstrainSelectedInstOperands,
     /* 776153 */     // GIR_Coverage, 6858,
     /* 776153 */     GIR_EraseRootFromParent_Done,
     /* 776154 */   // Label 10319: @776154
     /* 776154 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(776233), // Rule ID 6882 //
     /* 776159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 776162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 776166 */     // MIs[0] offset
     /* 776166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776169 */     // MIs[0] format
     /* 776169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776172 */     // MIs[0] auxiliary
     /* 776172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776175 */     // MIs[0] Operand 8
     /* 776175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 776186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776193 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
     /* 776196 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776198 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 776200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776207 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776209 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776215 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776221 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776231 */     GIR_RootConstrainSelectedInstOperands,
     /* 776232 */     // GIR_Coverage, 6882,
     /* 776232 */     GIR_EraseRootFromParent_Done,
     /* 776233 */   // Label 10320: @776233
     /* 776233 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(776312), // Rule ID 6886 //
     /* 776238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 776241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 776245 */     // MIs[0] offset
     /* 776245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776248 */     // MIs[0] format
     /* 776248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776251 */     // MIs[0] auxiliary
     /* 776251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776254 */     // MIs[0] Operand 8
     /* 776254 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 776265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776272 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
     /* 776275 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776277 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 776279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776286 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776288 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776294 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776300 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776310 */     GIR_RootConstrainSelectedInstOperands,
     /* 776311 */     // GIR_Coverage, 6886,
     /* 776311 */     GIR_EraseRootFromParent_Done,
     /* 776312 */   // Label 10321: @776312
     /* 776312 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(776383), // Rule ID 6857 //
     /* 776317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 776320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 776324 */     // MIs[0] offset
     /* 776324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776327 */     // MIs[0] format
     /* 776327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776330 */     // MIs[0] auxiliary
     /* 776330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776333 */     // MIs[0] Operand 8
     /* 776333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 776336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776343 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
     /* 776346 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776348 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 776350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776357 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776359 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776365 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776371 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776381 */     GIR_RootConstrainSelectedInstOperands,
     /* 776382 */     // GIR_Coverage, 6857,
     /* 776382 */     GIR_EraseRootFromParent_Done,
     /* 776383 */   // Label 10322: @776383
     /* 776383 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(776454), // Rule ID 6881 //
     /* 776388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 776391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 776395 */     // MIs[0] offset
     /* 776395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776398 */     // MIs[0] format
     /* 776398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776401 */     // MIs[0] auxiliary
     /* 776401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776404 */     // MIs[0] Operand 8
     /* 776404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 776407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776414 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
     /* 776417 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776419 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 776421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776428 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776436 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776442 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776452 */     GIR_RootConstrainSelectedInstOperands,
     /* 776453 */     // GIR_Coverage, 6881,
     /* 776453 */     GIR_EraseRootFromParent_Done,
     /* 776454 */   // Label 10323: @776454
     /* 776454 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(776525), // Rule ID 6885 //
     /* 776459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 776462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 776466 */     // MIs[0] offset
     /* 776466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776469 */     // MIs[0] format
     /* 776469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776472 */     // MIs[0] auxiliary
     /* 776472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776475 */     // MIs[0] Operand 8
     /* 776475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 776478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776485 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9744:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
     /* 776488 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776490 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 776492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776499 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776501 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776507 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776513 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776523 */     GIR_RootConstrainSelectedInstOperands,
     /* 776524 */     // GIR_Coverage, 6885,
     /* 776524 */     GIR_EraseRootFromParent_Done,
     /* 776525 */   // Label 10324: @776525
     /* 776525 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(776634), // Rule ID 6859 //
     /* 776530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 776533 */     // MIs[0] offset
     /* 776533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776536 */     // MIs[0] format
     /* 776536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776539 */     // MIs[0] auxiliary
     /* 776539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776542 */     // MIs[0] Operand 8
     /* 776542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 776545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776552 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 776555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 776559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 776564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 776568 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 776571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 776575 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 776578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 776583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 776588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 776593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
     /* 776596 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 776601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776608 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776610 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776616 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776622 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776632 */     GIR_RootConstrainSelectedInstOperands,
     /* 776633 */     // GIR_Coverage, 6859,
     /* 776633 */     GIR_EraseRootFromParent_Done,
     /* 776634 */   // Label 10325: @776634
     /* 776634 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(776743), // Rule ID 6883 //
     /* 776639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 776642 */     // MIs[0] offset
     /* 776642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776645 */     // MIs[0] format
     /* 776645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776648 */     // MIs[0] auxiliary
     /* 776648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776651 */     // MIs[0] Operand 8
     /* 776651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 776654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776661 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 776664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 776668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 776673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 776677 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 776680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 776684 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 776687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 776692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 776697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 776702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
     /* 776705 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 776710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776717 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776719 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776725 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776731 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776741 */     GIR_RootConstrainSelectedInstOperands,
     /* 776742 */     // GIR_Coverage, 6883,
     /* 776742 */     GIR_EraseRootFromParent_Done,
     /* 776743 */   // Label 10326: @776743
     /* 776743 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(776852), // Rule ID 6887 //
     /* 776748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 776751 */     // MIs[0] offset
     /* 776751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776754 */     // MIs[0] format
     /* 776754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776757 */     // MIs[0] auxiliary
     /* 776757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776760 */     // MIs[0] Operand 8
     /* 776760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 776763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776770 */     // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 776773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 776777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 776782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 776786 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 776789 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 776793 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 776796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 776801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 776806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 776811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
     /* 776814 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 776819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776826 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776828 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776834 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776840 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776850 */     GIR_RootConstrainSelectedInstOperands,
     /* 776851 */     // GIR_Coverage, 6887,
     /* 776851 */     GIR_EraseRootFromParent_Done,
     /* 776852 */   // Label 10327: @776852
     /* 776852 */   GIM_Reject,
     /* 776853 */ // Label 10315: @776853
     /* 776853 */ GIM_Reject,
     /* 776854 */ // Label 10296: @776854
     /* 776854 */ GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(777552),
     /* 776859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 776862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 776865 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 776868 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 776871 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(776952), // Rule ID 6888 //
     /* 776876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 776879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 776883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 776887 */     // MIs[0] offset
     /* 776887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776890 */     // MIs[0] format
     /* 776890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776893 */     // MIs[0] auxiliary
     /* 776893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776896 */     // MIs[0] Operand 8
     /* 776896 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 776907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776914 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9744:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
     /* 776917 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 776919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 776921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 776926 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 776928 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 776934 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 776940 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 776946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 776950 */     GIR_RootConstrainSelectedInstOperands,
     /* 776951 */     // GIR_Coverage, 6888,
     /* 776951 */     GIR_EraseRootFromParent_Done,
     /* 776952 */   // Label 10329: @776952
     /* 776952 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(777033), // Rule ID 6892 //
     /* 776957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 776960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 776964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 776968 */     // MIs[0] offset
     /* 776968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 776971 */     // MIs[0] format
     /* 776971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 776974 */     // MIs[0] auxiliary
     /* 776974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 776977 */     // MIs[0] Operand 8
     /* 776977 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 776988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 776995 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9744:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 776995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
     /* 776998 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777007 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777009 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777015 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777021 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777031 */     GIR_RootConstrainSelectedInstOperands,
     /* 777032 */     // GIR_Coverage, 6892,
     /* 777032 */     GIR_EraseRootFromParent_Done,
     /* 777033 */   // Label 10330: @777033
     /* 777033 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(777112), // Rule ID 6890 //
     /* 777038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 777041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 777045 */     // MIs[0] offset
     /* 777045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777048 */     // MIs[0] format
     /* 777048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777051 */     // MIs[0] auxiliary
     /* 777051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777054 */     // MIs[0] Operand 8
     /* 777054 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 777065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777072 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
     /* 777075 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777077 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 777079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777086 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777110 */     GIR_RootConstrainSelectedInstOperands,
     /* 777111 */     // GIR_Coverage, 6890,
     /* 777111 */     GIR_EraseRootFromParent_Done,
     /* 777112 */   // Label 10331: @777112
     /* 777112 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(777191), // Rule ID 6894 //
     /* 777117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 777120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 777124 */     // MIs[0] offset
     /* 777124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777127 */     // MIs[0] format
     /* 777127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777130 */     // MIs[0] auxiliary
     /* 777130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777133 */     // MIs[0] Operand 8
     /* 777133 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 777144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777151 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
     /* 777154 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777156 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 777158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777165 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777167 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777173 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777179 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777189 */     GIR_RootConstrainSelectedInstOperands,
     /* 777190 */     // GIR_Coverage, 6894,
     /* 777190 */     GIR_EraseRootFromParent_Done,
     /* 777191 */   // Label 10332: @777191
     /* 777191 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(777262), // Rule ID 6889 //
     /* 777196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 777199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 777203 */     // MIs[0] offset
     /* 777203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777206 */     // MIs[0] format
     /* 777206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777209 */     // MIs[0] auxiliary
     /* 777209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777212 */     // MIs[0] Operand 8
     /* 777212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 777215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777222 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
     /* 777225 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777227 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 777229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777236 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777238 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777244 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777250 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777260 */     GIR_RootConstrainSelectedInstOperands,
     /* 777261 */     // GIR_Coverage, 6889,
     /* 777261 */     GIR_EraseRootFromParent_Done,
     /* 777262 */   // Label 10333: @777262
     /* 777262 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(777333), // Rule ID 6893 //
     /* 777267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 777270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 777274 */     // MIs[0] offset
     /* 777274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777277 */     // MIs[0] format
     /* 777277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777280 */     // MIs[0] auxiliary
     /* 777280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777283 */     // MIs[0] Operand 8
     /* 777283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 777286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777293 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
     /* 777296 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777298 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 777300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777307 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777309 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777315 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777321 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777331 */     GIR_RootConstrainSelectedInstOperands,
     /* 777332 */     // GIR_Coverage, 6893,
     /* 777332 */     GIR_EraseRootFromParent_Done,
     /* 777333 */   // Label 10334: @777333
     /* 777333 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(777442), // Rule ID 6891 //
     /* 777338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 777341 */     // MIs[0] offset
     /* 777341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777344 */     // MIs[0] format
     /* 777344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777347 */     // MIs[0] auxiliary
     /* 777347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777350 */     // MIs[0] Operand 8
     /* 777350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 777353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777360 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 777363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 777367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 777372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 777376 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 777379 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 777383 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 777386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 777391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 777396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 777401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
     /* 777404 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 777409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777416 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777418 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777424 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777430 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777440 */     GIR_RootConstrainSelectedInstOperands,
     /* 777441 */     // GIR_Coverage, 6891,
     /* 777441 */     GIR_EraseRootFromParent_Done,
     /* 777442 */   // Label 10335: @777442
     /* 777442 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(777551), // Rule ID 6895 //
     /* 777447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 777450 */     // MIs[0] offset
     /* 777450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777453 */     // MIs[0] format
     /* 777453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777456 */     // MIs[0] auxiliary
     /* 777456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777459 */     // MIs[0] Operand 8
     /* 777459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 777462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777469 */     // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9744:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 777472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 777476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 777481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 777485 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 777488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 777492 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 777495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 777500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 777505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 777510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
     /* 777513 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 777518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777525 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777539 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777549 */     GIR_RootConstrainSelectedInstOperands,
     /* 777550 */     // GIR_Coverage, 6895,
     /* 777550 */     GIR_EraseRootFromParent_Done,
     /* 777551 */   // Label 10336: @777551
     /* 777551 */   GIM_Reject,
     /* 777552 */ // Label 10328: @777552
     /* 777552 */ GIM_Reject,
     /* 777553 */ // Label 10297: @777553
     /* 777553 */ GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(777911),
     /* 777558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 777561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 777564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 777567 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 777570 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(777651), // Rule ID 6860 //
     /* 777575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 777578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 777582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 777586 */     // MIs[0] offset
     /* 777586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777589 */     // MIs[0] format
     /* 777589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777592 */     // MIs[0] auxiliary
     /* 777592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777595 */     // MIs[0] Operand 8
     /* 777595 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 777606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777613 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9743:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
     /* 777616 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777625 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777627 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777633 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777639 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777649 */     GIR_RootConstrainSelectedInstOperands,
     /* 777650 */     // GIR_Coverage, 6860,
     /* 777650 */     GIR_EraseRootFromParent_Done,
     /* 777651 */   // Label 10338: @777651
     /* 777651 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(777730), // Rule ID 6862 //
     /* 777656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 777659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 777663 */     // MIs[0] offset
     /* 777663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777666 */     // MIs[0] format
     /* 777666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777669 */     // MIs[0] auxiliary
     /* 777669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777672 */     // MIs[0] Operand 8
     /* 777672 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 777683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777690 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
     /* 777693 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777695 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 777697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777704 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777706 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777712 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777718 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777728 */     GIR_RootConstrainSelectedInstOperands,
     /* 777729 */     // GIR_Coverage, 6862,
     /* 777729 */     GIR_EraseRootFromParent_Done,
     /* 777730 */   // Label 10339: @777730
     /* 777730 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(777801), // Rule ID 6861 //
     /* 777735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 777738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 777742 */     // MIs[0] offset
     /* 777742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777745 */     // MIs[0] format
     /* 777745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777748 */     // MIs[0] auxiliary
     /* 777748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777751 */     // MIs[0] Operand 8
     /* 777751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 777754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777761 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
     /* 777764 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777766 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 777768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777775 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777777 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777783 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777789 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777799 */     GIR_RootConstrainSelectedInstOperands,
     /* 777800 */     // GIR_Coverage, 6861,
     /* 777800 */     GIR_EraseRootFromParent_Done,
     /* 777801 */   // Label 10340: @777801
     /* 777801 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(777910), // Rule ID 6863 //
     /* 777806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 777809 */     // MIs[0] offset
     /* 777809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777812 */     // MIs[0] format
     /* 777812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777815 */     // MIs[0] auxiliary
     /* 777815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777818 */     // MIs[0] Operand 8
     /* 777818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 777821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777828 */     // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9743:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 777831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 777835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 777840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 777844 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 777847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 777851 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 777854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 777859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 777864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 777869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
     /* 777872 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 777877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777884 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777886 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777892 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777898 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 777904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 777908 */     GIR_RootConstrainSelectedInstOperands,
     /* 777909 */     // GIR_Coverage, 6863,
     /* 777909 */     GIR_EraseRootFromParent_Done,
     /* 777910 */   // Label 10341: @777910
     /* 777910 */   GIM_Reject,
     /* 777911 */ // Label 10337: @777911
     /* 777911 */ GIM_Reject,
     /* 777912 */ // Label 10298: @777912
     /* 777912 */ GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(778270),
     /* 777917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 777920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 777923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 777926 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 777929 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(778010), // Rule ID 6864 //
     /* 777934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 777937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 777941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 777945 */     // MIs[0] offset
     /* 777945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 777948 */     // MIs[0] format
     /* 777948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 777951 */     // MIs[0] auxiliary
     /* 777951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 777954 */     // MIs[0] Operand 8
     /* 777954 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 777965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 777972 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9742:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 777972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
     /* 777975 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 777977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 777979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 777984 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 777986 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 777992 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 777998 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778008 */     GIR_RootConstrainSelectedInstOperands,
     /* 778009 */     // GIR_Coverage, 6864,
     /* 778009 */     GIR_EraseRootFromParent_Done,
     /* 778010 */   // Label 10343: @778010
     /* 778010 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(778089), // Rule ID 6866 //
     /* 778015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 778018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778022 */     // MIs[0] offset
     /* 778022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778025 */     // MIs[0] format
     /* 778025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778028 */     // MIs[0] auxiliary
     /* 778028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778031 */     // MIs[0] Operand 8
     /* 778031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778049 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
     /* 778052 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778054 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 778056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778063 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778065 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778071 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778077 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778087 */     GIR_RootConstrainSelectedInstOperands,
     /* 778088 */     // GIR_Coverage, 6866,
     /* 778088 */     GIR_EraseRootFromParent_Done,
     /* 778089 */   // Label 10344: @778089
     /* 778089 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(778160), // Rule ID 6865 //
     /* 778094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 778097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 778101 */     // MIs[0] offset
     /* 778101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778104 */     // MIs[0] format
     /* 778104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778107 */     // MIs[0] auxiliary
     /* 778107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778110 */     // MIs[0] Operand 8
     /* 778110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 778113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778120 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
     /* 778123 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778125 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 778127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778134 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778136 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778142 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778148 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778158 */     GIR_RootConstrainSelectedInstOperands,
     /* 778159 */     // GIR_Coverage, 6865,
     /* 778159 */     GIR_EraseRootFromParent_Done,
     /* 778160 */   // Label 10345: @778160
     /* 778160 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(778269), // Rule ID 6867 //
     /* 778165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 778168 */     // MIs[0] offset
     /* 778168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778171 */     // MIs[0] format
     /* 778171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778174 */     // MIs[0] auxiliary
     /* 778174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778177 */     // MIs[0] Operand 8
     /* 778177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 778180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778187 */     // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9742:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 778190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 778194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 778199 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 778203 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 778206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 778210 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 778213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 778218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 778223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 778228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
     /* 778231 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 778236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778243 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778245 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778251 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778257 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778267 */     GIR_RootConstrainSelectedInstOperands,
     /* 778268 */     // GIR_Coverage, 6867,
     /* 778268 */     GIR_EraseRootFromParent_Done,
     /* 778269 */   // Label 10346: @778269
     /* 778269 */   GIM_Reject,
     /* 778270 */ // Label 10342: @778270
     /* 778270 */ GIM_Reject,
     /* 778271 */ // Label 10299: @778271
     /* 778271 */ GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(779705),
     /* 778276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 778279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 778282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 778285 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 778288 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(778376), // Rule ID 6896 //
     /* 778293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 778296 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 778303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 778311 */     // MIs[0] offset
     /* 778311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778314 */     // MIs[0] format
     /* 778314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778317 */     // MIs[0] auxiliary
     /* 778317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778320 */     // MIs[0] Operand 8
     /* 778320 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778338 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_OFFSET_exact),
     /* 778341 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778350 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778364 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778374 */     GIR_RootConstrainSelectedInstOperands,
     /* 778375 */     // GIR_Coverage, 6896,
     /* 778375 */     GIR_EraseRootFromParent_Done,
     /* 778376 */   // Label 10348: @778376
     /* 778376 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(778464), // Rule ID 6900 //
     /* 778381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 778384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 778391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 778399 */     // MIs[0] offset
     /* 778399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778402 */     // MIs[0] format
     /* 778402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778405 */     // MIs[0] auxiliary
     /* 778405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778408 */     // MIs[0] Operand 8
     /* 778408 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778426 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFSET_exact),
     /* 778429 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778438 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778440 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778446 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778452 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778462 */     GIR_RootConstrainSelectedInstOperands,
     /* 778463 */     // GIR_Coverage, 6900,
     /* 778463 */     GIR_EraseRootFromParent_Done,
     /* 778464 */   // Label 10349: @778464
     /* 778464 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(778545), // Rule ID 6904 //
     /* 778469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 778472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 778480 */     // MIs[0] offset
     /* 778480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778483 */     // MIs[0] format
     /* 778483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778486 */     // MIs[0] auxiliary
     /* 778486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778489 */     // MIs[0] Operand 8
     /* 778489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778507 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
     /* 778510 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778519 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778521 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778527 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778533 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778543 */     GIR_RootConstrainSelectedInstOperands,
     /* 778544 */     // GIR_Coverage, 6904,
     /* 778544 */     GIR_EraseRootFromParent_Done,
     /* 778545 */   // Label 10350: @778545
     /* 778545 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(778626), // Rule ID 6908 //
     /* 778550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 778553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 778561 */     // MIs[0] offset
     /* 778561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778564 */     // MIs[0] format
     /* 778564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778567 */     // MIs[0] auxiliary
     /* 778567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778570 */     // MIs[0] Operand 8
     /* 778570 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778588 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9743:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
     /* 778591 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778600 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778602 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778608 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778614 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778624 */     GIR_RootConstrainSelectedInstOperands,
     /* 778625 */     // GIR_Coverage, 6908,
     /* 778625 */     GIR_EraseRootFromParent_Done,
     /* 778626 */   // Label 10351: @778626
     /* 778626 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(778712), // Rule ID 6898 //
     /* 778631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 778634 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 778641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778645 */     // MIs[0] offset
     /* 778645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778648 */     // MIs[0] format
     /* 778648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778651 */     // MIs[0] auxiliary
     /* 778651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778654 */     // MIs[0] Operand 8
     /* 778654 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778672 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_OFFEN_exact),
     /* 778675 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778677 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 778679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778686 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778688 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778694 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778700 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778710 */     GIR_RootConstrainSelectedInstOperands,
     /* 778711 */     // GIR_Coverage, 6898,
     /* 778711 */     GIR_EraseRootFromParent_Done,
     /* 778712 */   // Label 10352: @778712
     /* 778712 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(778798), // Rule ID 6902 //
     /* 778717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 778720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 778727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778731 */     // MIs[0] offset
     /* 778731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778734 */     // MIs[0] format
     /* 778734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778737 */     // MIs[0] auxiliary
     /* 778737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778740 */     // MIs[0] Operand 8
     /* 778740 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778758 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_OFFEN_exact),
     /* 778761 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778763 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 778765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778772 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778774 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778796 */     GIR_RootConstrainSelectedInstOperands,
     /* 778797 */     // GIR_Coverage, 6902,
     /* 778797 */     GIR_EraseRootFromParent_Done,
     /* 778798 */   // Label 10353: @778798
     /* 778798 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(778877), // Rule ID 6906 //
     /* 778803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 778806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778810 */     // MIs[0] offset
     /* 778810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778813 */     // MIs[0] format
     /* 778813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778816 */     // MIs[0] auxiliary
     /* 778816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778819 */     // MIs[0] Operand 8
     /* 778819 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778837 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
     /* 778840 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778842 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 778844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778851 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778853 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778875 */     GIR_RootConstrainSelectedInstOperands,
     /* 778876 */     // GIR_Coverage, 6906,
     /* 778876 */     GIR_EraseRootFromParent_Done,
     /* 778877 */   // Label 10354: @778877
     /* 778877 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(778956), // Rule ID 6910 //
     /* 778882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 778885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 778889 */     // MIs[0] offset
     /* 778889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778892 */     // MIs[0] format
     /* 778892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778895 */     // MIs[0] auxiliary
     /* 778895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778898 */     // MIs[0] Operand 8
     /* 778898 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 778909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778916 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
     /* 778919 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778921 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 778923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 778925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 778930 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 778932 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 778938 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 778944 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 778950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 778954 */     GIR_RootConstrainSelectedInstOperands,
     /* 778955 */     // GIR_Coverage, 6910,
     /* 778955 */     GIR_EraseRootFromParent_Done,
     /* 778956 */   // Label 10355: @778956
     /* 778956 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(779034), // Rule ID 6897 //
     /* 778961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 778964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 778971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 778975 */     // MIs[0] offset
     /* 778975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 778978 */     // MIs[0] format
     /* 778978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 778981 */     // MIs[0] auxiliary
     /* 778981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 778984 */     // MIs[0] Operand 8
     /* 778984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 778987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 778994 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 778994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_IDXEN_exact),
     /* 778997 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 778999 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 779001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779008 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779010 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779016 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779022 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779032 */     GIR_RootConstrainSelectedInstOperands,
     /* 779033 */     // GIR_Coverage, 6897,
     /* 779033 */     GIR_EraseRootFromParent_Done,
     /* 779034 */   // Label 10356: @779034
     /* 779034 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(779112), // Rule ID 6901 //
     /* 779039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 779042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 779049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 779053 */     // MIs[0] offset
     /* 779053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779056 */     // MIs[0] format
     /* 779056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779059 */     // MIs[0] auxiliary
     /* 779059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779062 */     // MIs[0] Operand 8
     /* 779062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779072 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_IDXEN_exact),
     /* 779075 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779077 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 779079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779086 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779088 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779094 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779100 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779110 */     GIR_RootConstrainSelectedInstOperands,
     /* 779111 */     // GIR_Coverage, 6901,
     /* 779111 */     GIR_EraseRootFromParent_Done,
     /* 779112 */   // Label 10357: @779112
     /* 779112 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(779183), // Rule ID 6905 //
     /* 779117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 779120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 779124 */     // MIs[0] offset
     /* 779124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779127 */     // MIs[0] format
     /* 779127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779130 */     // MIs[0] auxiliary
     /* 779130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779133 */     // MIs[0] Operand 8
     /* 779133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779143 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
     /* 779146 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779148 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 779150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779157 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779159 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779165 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779171 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779181 */     GIR_RootConstrainSelectedInstOperands,
     /* 779182 */     // GIR_Coverage, 6905,
     /* 779182 */     GIR_EraseRootFromParent_Done,
     /* 779183 */   // Label 10358: @779183
     /* 779183 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(779254), // Rule ID 6909 //
     /* 779188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 779191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 779195 */     // MIs[0] offset
     /* 779195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779198 */     // MIs[0] format
     /* 779198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779201 */     // MIs[0] auxiliary
     /* 779201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779204 */     // MIs[0] Operand 8
     /* 779204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779214 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
     /* 779217 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779219 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 779221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779228 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779230 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779236 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779242 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779252 */     GIR_RootConstrainSelectedInstOperands,
     /* 779253 */     // GIR_Coverage, 6909,
     /* 779253 */     GIR_EraseRootFromParent_Done,
     /* 779254 */   // Label 10359: @779254
     /* 779254 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(779370), // Rule ID 6899 //
     /* 779259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 779262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 779269 */     // MIs[0] offset
     /* 779269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779272 */     // MIs[0] format
     /* 779272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779275 */     // MIs[0] auxiliary
     /* 779275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779278 */     // MIs[0] Operand 8
     /* 779278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779288 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 779291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 779295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 779300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 779304 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 779307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 779311 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 779314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 779319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_BOTHEN_exact),
     /* 779332 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 779337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779344 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779346 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779352 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779358 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779368 */     GIR_RootConstrainSelectedInstOperands,
     /* 779369 */     // GIR_Coverage, 6899,
     /* 779369 */     GIR_EraseRootFromParent_Done,
     /* 779370 */   // Label 10360: @779370
     /* 779370 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(779486), // Rule ID 6903 //
     /* 779375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 779378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
     /* 779385 */     // MIs[0] offset
     /* 779385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779388 */     // MIs[0] format
     /* 779388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779391 */     // MIs[0] auxiliary
     /* 779391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779394 */     // MIs[0] Operand 8
     /* 779394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779404 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_33737>>  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 779407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 779411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 779416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 779420 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 779423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 779427 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 779430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 779435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_VBUFFER_BOTHEN_exact),
     /* 779448 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 779453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779460 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779462 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779468 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779474 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779484 */     GIR_RootConstrainSelectedInstOperands,
     /* 779485 */     // GIR_Coverage, 6903,
     /* 779485 */     GIR_EraseRootFromParent_Done,
     /* 779486 */   // Label 10361: @779486
     /* 779486 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(779595), // Rule ID 6907 //
     /* 779491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
     /* 779494 */     // MIs[0] offset
     /* 779494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779497 */     // MIs[0] format
     /* 779497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779500 */     // MIs[0] auxiliary
     /* 779500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779503 */     // MIs[0] Operand 8
     /* 779503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779513 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 779516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 779520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 779525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 779529 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 779532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 779536 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 779539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 779544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
     /* 779557 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 779562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779569 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779571 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779577 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779583 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779593 */     GIR_RootConstrainSelectedInstOperands,
     /* 779594 */     // GIR_Coverage, 6907,
     /* 779594 */     GIR_EraseRootFromParent_Done,
     /* 779595 */   // Label 10362: @779595
     /* 779595 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(779704), // Rule ID 6911 //
     /* 779600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
     /* 779603 */     // MIs[0] offset
     /* 779603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779606 */     // MIs[0] format
     /* 779606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779609 */     // MIs[0] auxiliary
     /* 779609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779612 */     // MIs[0] Operand 8
     /* 779612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779622 */     // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9743:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 779625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 779629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 779634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 779638 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 779641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 779645 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 779648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 779653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 779663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
     /* 779666 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 779671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779678 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779680 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779686 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779692 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779702 */     GIR_RootConstrainSelectedInstOperands,
     /* 779703 */     // GIR_Coverage, 6911,
     /* 779703 */     GIR_EraseRootFromParent_Done,
     /* 779704 */   // Label 10363: @779704
     /* 779704 */   GIM_Reject,
     /* 779705 */ // Label 10347: @779705
     /* 779705 */ GIM_Reject,
     /* 779706 */ // Label 10300: @779706
     /* 779706 */ GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(780064),
     /* 779711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 779714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 779717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 779720 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 779723 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(779804), // Rule ID 6868 //
     /* 779728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 779731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 779735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 779739 */     // MIs[0] offset
     /* 779739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779742 */     // MIs[0] format
     /* 779742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779745 */     // MIs[0] auxiliary
     /* 779745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779748 */     // MIs[0] Operand 8
     /* 779748 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 779759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779766 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9741:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
     /* 779769 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779778 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779780 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779786 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779792 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779802 */     GIR_RootConstrainSelectedInstOperands,
     /* 779803 */     // GIR_Coverage, 6868,
     /* 779803 */     GIR_EraseRootFromParent_Done,
     /* 779804 */   // Label 10365: @779804
     /* 779804 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(779883), // Rule ID 6870 //
     /* 779809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 779812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 779816 */     // MIs[0] offset
     /* 779816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779819 */     // MIs[0] format
     /* 779819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779822 */     // MIs[0] auxiliary
     /* 779822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779825 */     // MIs[0] Operand 8
     /* 779825 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
     /* 779836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779843 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
     /* 779846 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779848 */     GIR_RootToRootCopy, /*OpIdx*/3, // voffset
     /* 779850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779857 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779859 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779865 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779871 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779881 */     GIR_RootConstrainSelectedInstOperands,
     /* 779882 */     // GIR_Coverage, 6870,
     /* 779882 */     GIR_EraseRootFromParent_Done,
     /* 779883 */   // Label 10366: @779883
     /* 779883 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(779954), // Rule ID 6869 //
     /* 779888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 779891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 779895 */     // MIs[0] offset
     /* 779895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779898 */     // MIs[0] format
     /* 779898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779901 */     // MIs[0] auxiliary
     /* 779901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779904 */     // MIs[0] Operand 8
     /* 779904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779914 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
     /* 779917 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 779919 */     GIR_RootToRootCopy, /*OpIdx*/2, // vindex
     /* 779921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 779923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 779928 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 779930 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 779936 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 779942 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 779948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 779952 */     GIR_RootConstrainSelectedInstOperands,
     /* 779953 */     // GIR_Coverage, 6869,
     /* 779953 */     GIR_EraseRootFromParent_Done,
     /* 779954 */   // Label 10367: @779954
     /* 779954 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(780063), // Rule ID 6871 //
     /* 779959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
     /* 779962 */     // MIs[0] offset
     /* 779962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 779965 */     // MIs[0] format
     /* 779965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 779968 */     // MIs[0] auxiliary
     /* 779968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 779971 */     // MIs[0] Operand 8
     /* 779971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 779974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
     /* 779981 */     // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9741:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
     /* 779981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 779984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /* 779988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 779993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
     /* 779997 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /* 780000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
     /* 780004 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
     /* 780007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
     /* 780012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 780017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 780022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
     /* 780025 */     GIR_RootToRootCopy, /*OpIdx*/0, // vdata
     /* 780027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 780030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
     /* 780032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
     /* 780037 */     GIR_RootToRootCopy, /*OpIdx*/5, // offset
     /* 780039 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
     /* 780045 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
     /* 780051 */     GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
     /* 780057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 780061 */     GIR_RootConstrainSelectedInstOperands,
     /* 780062 */     // GIR_Coverage, 6871,
     /* 780062 */     GIR_EraseRootFromParent_Done,
     /* 780063 */   // Label 10368: @780063
     /* 780063 */   GIM_Reject,
     /* 780064 */ // Label 10364: @780064
     /* 780064 */ GIM_Reject,
     /* 780065 */ // Label 10301: @780065
     /* 780065 */ GIM_Reject,
     /* 780066 */ // Label 166: @780066
     /* 780066 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 10371*/ GIMT_Encode4(780371),
     /* 780077 */ /*GILLT_s16*//*Label 10369*/ GIMT_Encode4(780085),
     /* 780081 */ /*GILLT_s32*//*Label 10370*/ GIMT_Encode4(780329),
     /* 780085 */ // Label 10369: @780085
     /* 780085 */ GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(780328),
     /* 780090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 780093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 780096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 780099 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(780175), // Rule ID 1028 //
     /* 780104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
     /* 780107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 780111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780132 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 780132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
     /* 780135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 780137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 780142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 780147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 780152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 780157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 780162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 780167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 780170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 780173 */     GIR_RootConstrainSelectedInstOperands,
     /* 780174 */     // GIR_Coverage, 1028,
     /* 780174 */     GIR_EraseRootFromParent_Done,
     /* 780175 */   // Label 10373: @780175
     /* 780175 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(780251), // Rule ID 1029 //
     /* 780180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
     /* 780183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
     /* 780187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780208 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 780208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
     /* 780211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 780213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 780218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 780223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 780228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 780233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 780238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 780243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 780246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 780249 */     GIR_RootConstrainSelectedInstOperands,
     /* 780250 */     // GIR_Coverage, 1029,
     /* 780250 */     GIR_EraseRootFromParent_Done,
     /* 780251 */   // Label 10374: @780251
     /* 780251 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(780327), // Rule ID 1030 //
     /* 780256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
     /* 780259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 780263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
     /* 780284 */     // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
     /* 780284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
     /* 780287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 780289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
     /* 780294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 780299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
     /* 780304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
     /* 780309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
     /* 780314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
     /* 780319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 780322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 780325 */     GIR_RootConstrainSelectedInstOperands,
     /* 780326 */     // GIR_Coverage, 1030,
     /* 780326 */     GIR_EraseRootFromParent_Done,
     /* 780327 */   // Label 10375: @780327
     /* 780327 */   GIM_Reject,
     /* 780328 */ // Label 10372: @780328
     /* 780328 */ GIM_Reject,
     /* 780329 */ // Label 10370: @780329
     /* 780329 */ GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(780370), // Rule ID 969 //
     /* 780334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 780337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 780340 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 780343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
     /* 780347 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
     /* 780354 */   // (AMDGPUumed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
     /* 780354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
     /* 780357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
     /* 780359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
     /* 780364 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 780366 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 780368 */   GIR_RootConstrainSelectedInstOperands,
     /* 780369 */   // GIR_Coverage, 969,
     /* 780369 */   GIR_EraseRootFromParent_Done,
     /* 780370 */ // Label 10376: @780370
     /* 780370 */ GIM_Reject,
     /* 780371 */ // Label 10371: @780371
     /* 780371 */ GIM_Reject,
     /* 780372 */ // Label 167: @780372
     /* 780372 */ GIM_Reject,
     /* 780373 */ }; // Size: 780373 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
